/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/platform","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ee=function(q){for(var t=[],F=0,T=q.length;F<T;F++)t[F]=Z[q[F]];return t};const Oe=this,Be=typeof global=="object"?global:{};var oe;(function(q){q.global=Oe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=t})(oe||(oe={}));var oe;(function(q){class t{constructor(u,y,N){this.type=u,this.detail=y,this.timestamp=N}}q.LoaderEvent=t;class F{constructor(u){this._events=[new t(1,"",u)]}record(u,y){this._events.push(new t(u,y,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=F;class T{record(u,y){}getEvents(){return[]}}T.INSTANCE=new T,q.NullLoaderEventRecorder=T})(oe||(oe={}));var oe;(function(q){class t{static fileUriToFilePath(T,i){if(i=decodeURI(i).replace(/%23/g,"#"),T){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(T,i){return T.length>=i.length&&T.substr(0,i.length)===i}static endsWith(T,i){return T.length>=i.length&&T.substr(T.length-i.length)===i}static containsQueryString(T){return/^[^\#]*\?/gi.test(T)}static isAbsolutePath(T){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(T)}static forEachProperty(T,i){if(T){let u;for(u in T)T.hasOwnProperty(u)&&i(u,T[u])}}static isEmpty(T){let i=!0;return t.forEachProperty(T,()=>{i=!1}),i}static recursiveClone(T){if(!T||typeof T!="object"||T instanceof RegExp||!Array.isArray(T)&&Object.getPrototypeOf(T)!==Object.prototype)return T;let i=Array.isArray(T)?[]:{};return t.forEachProperty(T,(u,y)=>{y&&typeof y=="object"?i[u]=t.recursiveClone(y):i[u]=y}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(T){return t.startsWith(T,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,q.Utilities=t})(oe||(oe={}));var oe;(function(q){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}q.ensureError=t;class F{static validateConfigurationOptions(u){function y(N){if(N.phase==="loading"){console.error('Loading "'+N.moduleId+'" failed'),console.error(N),console.error("Here are the modules that depend on it:"),console.error(N.neededBy);return}if(N.phase==="factory"){console.error('The factory function of "'+N.moduleId+'" has thrown an exception'),console.error(N),console.error("Here are the modules that depend on it:"),console.error(N.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=y),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(q.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const N=t(new Error("INVALID cached data configuration, 'path' MUST be set"));N.phase="configuration",u.onError(N),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,y=null){let N=q.Utilities.recursiveClone(y||{});return q.Utilities.forEachProperty(u,(a,g)=>{a==="ignoreDuplicateModules"&&typeof N.ignoreDuplicateModules<"u"?N.ignoreDuplicateModules=N.ignoreDuplicateModules.concat(g):a==="paths"&&typeof N.paths<"u"?q.Utilities.forEachProperty(g,(p,R)=>N.paths[p]=R):a==="config"&&typeof N.config<"u"?q.Utilities.forEachProperty(g,(p,R)=>N.config[p]=R):N[a]=q.Utilities.recursiveClone(g)}),F.validateConfigurationOptions(N)}}q.ConfigurationOptionsUtil=F;class T{constructor(u,y){if(this._env=u,this.options=F.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let N=this.options.nodeRequire.main.filename,a=Math.max(N.lastIndexOf("/"),N.lastIndexOf("\\"));this.options.baseUrl=N.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(u,y)=>{Array.isArray(y)?this.sortedPathsRules.push({from:u,to:y}):this.sortedPathsRules.push({from:u,to:[y]})}),this.sortedPathsRules.sort((u,y)=>y.from.length-u.from.length)}cloneAndMerge(u){return new T(this._env,F.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let y;for(let N=0,a=this.sortedPathsRules.length;N<a;N++)if(y=this.sortedPathsRules[N],q.Utilities.startsWith(u,y.from)){let g=[];for(let p=0,R=y.to.length;p<R;p++)g.push(y.to[p]+u.substr(y.from.length));return g}return[u]}_addUrlArgsToUrl(u){return q.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let y=0,N=u.length;y<N;y++)u[y]=this._addUrlArgsToUrl(u[y]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let y=u,N;if(!q.Utilities.endsWith(y,".js")&&!q.Utilities.isAbsolutePath(y)){N=this._applyPaths(y);for(let a=0,g=N.length;a<g;a++)this.isBuild()&&N[a]==="empty:"||(q.Utilities.isAbsolutePath(N[a])||(N[a]=this.options.baseUrl+N[a]),!q.Utilities.endsWith(N[a],".js")&&!q.Utilities.containsQueryString(N[a])&&(N[a]=N[a]+".js"))}else!q.Utilities.endsWith(y,".js")&&!q.Utilities.containsQueryString(y)&&(y=y+".js"),N=[y];return this._addUrlArgsIfNecessaryToUrls(N)}requireToUrl(u){let y=u;return q.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],q.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}q.Configuration=T})(oe||(oe={}));var oe;(function(q){class t{constructor(g){this._env=g,this._scriptLoader=null,this._callbackMap={}}load(g,p,R,w){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=g.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new F;let L={callback:R,errorback:w};if(this._callbackMap.hasOwnProperty(p)){this._callbackMap[p].push(L);return}this._callbackMap[p]=[L],this._scriptLoader.load(g,p,()=>this.triggerCallback(p),e=>this.triggerErrorback(p,e))}triggerCallback(g){let p=this._callbackMap[g];delete this._callbackMap[g];for(let R=0;R<p.length;R++)p[R].callback()}triggerErrorback(g,p){let R=this._callbackMap[g];delete this._callbackMap[g];for(let w=0;w<R.length;w++)R[w].errorback(p)}}class F{attachListeners(g,p,R){let w=()=>{g.removeEventListener("load",L),g.removeEventListener("error",e)},L=E=>{w(),p()},e=E=>{w(),R(E)};g.addEventListener("load",L),g.addEventListener("error",e)}load(g,p,R,w){if(/^node\|/.test(p)){let L=g.getConfig().getOptionsLiteral(),e=y(g.getRecorder(),L.nodeRequire||q.global.nodeRequire),E=p.split("|"),D=null;try{D=e(E[1])}catch(_){w(_);return}g.enqueueDefineAnonymousModule([],()=>D),R()}else{let L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,R,w);const{trustedTypesPolicy:e}=g.getConfig().getOptionsLiteral();e&&(p=e.createScriptURL(p)),L.setAttribute("src",p);const{cspNonce:E}=g.getConfig().getOptionsLiteral();E&&L.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(L)}}}function T(a){const{trustedTypesPolicy:g}=a.getConfig().getOptionsLiteral();try{return(g?self.eval(g.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(g){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=T(g)),this._cachedCanUseEval}load(g,p,R,w){if(/^node\|/.test(p)){const L=g.getConfig().getOptionsLiteral(),e=y(g.getRecorder(),L.nodeRequire||q.global.nodeRequire),E=p.split("|");let D=null;try{D=e(E[1])}catch(_){w(_);return}g.enqueueDefineAnonymousModule([],function(){return D}),R()}else{const{trustedTypesPolicy:L}=g.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(p)&&p.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(g)){fetch(p).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${p}`,(L?self.eval(L.createScript("",E)):new Function(E)).call(self),R()}).then(void 0,w);return}try{L&&(p=L.createScriptURL(p)),importScripts(p),R()}catch(E){w(E)}}}}class u{constructor(g){this._env=g,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(g){this._didInitialize||(this._didInitialize=!0,this._fs=g("fs"),this._vm=g("vm"),this._path=g("path"),this._crypto=g("crypto"))}_initNodeRequire(g,p){const{nodeCachedData:R}=p.getConfig().getOptionsLiteral();if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const w=this,L=g("module");function e(E){const D=E.constructor;let _=function(m){try{return E.require(m)}finally{}};return _.resolve=function(m,l){return D._resolveFilename(m,E,!1,l)},_.resolve.paths=function(m){return D._resolveLookupPaths(m,E)},_.main=process.mainModule,_.extensions=D._extensions,_.cache=D._cache,_}L.prototype._compile=function(E,D){const _=L.wrap(E.replace(/^#!.*/,"")),v=p.getRecorder(),m=w._getCachedDataPath(R,D),l={filename:D};let c;try{const h=w._fs.readFileSync(m);c=h.slice(0,16),l.cachedData=h.slice(16),v.record(60,m)}catch{v.record(61,m)}const r=new w._vm.Script(_,l),s=r.runInThisContext(l),d=w._path.dirname(D),f=e(this),A=[this.exports,f,this,D,d,process,Be,Buffer],b=s.apply(this.exports,A);return w._handleCachedData(r,_,m,!l.cachedData,p),w._verifyCachedData(r,_,m,c,p),b}}load(g,p,R,w){const L=g.getConfig().getOptionsLiteral(),e=y(g.getRecorder(),L.nodeRequire||q.global.nodeRequire),E=L.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,g);let D=g.getRecorder();if(/^node\|/.test(p)){let _=p.split("|"),v=null;try{v=e(_[1])}catch(m){w(m);return}g.enqueueDefineAnonymousModule([],()=>v),R()}else{p=q.Utilities.fileUriToFilePath(this._env.isWindows,p);const _=this._path.normalize(p),v=this._getElectronRendererScriptPathOrUri(_),m=Boolean(L.nodeCachedData),l=m?this._getCachedDataPath(L.nodeCachedData,p):void 0;this._readSourceAndCachedData(_,l,D,(c,r,s,d)=>{if(c){w(c);return}let f;r.charCodeAt(0)===u._BOM?f=u._PREFIX+r.substring(1)+u._SUFFIX:f=u._PREFIX+r+u._SUFFIX,f=E(f,_);const A={filename:v,cachedData:s},b=this._createAndEvalScript(g,f,A,R,w);this._handleCachedData(b,f,l,m&&!s,g),this._verifyCachedData(b,f,l,d,g)})}}_createAndEvalScript(g,p,R,w,L){const e=g.getRecorder();e.record(31,R.filename);const E=new this._vm.Script(p,R),D=E.runInThisContext(R),_=g.getGlobalAMDDefineFunc();let v=!1;const m=function(){return v=!0,_.apply(null,arguments)};return m.amd=_.amd,D.call(q.global,g.getGlobalAMDRequireFunc(),m,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),v?w():L(new Error(`Didn't receive define call in ${R.filename}!`)),E}_getElectronRendererScriptPathOrUri(g){if(!this._env.isElectronRenderer)return g;let p=g.match(/^([a-z])\:(.*)/i);return p?`file:///${(p[1].toUpperCase()+":"+p[2]).replace(/\\/g,"/")}`:`file://${g}`}_getCachedDataPath(g,p){const R=this._crypto.createHash("md5").update(p,"utf8").update(g.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(p).replace(/\.js$/,"");return this._path.join(g.path,`${w}-${R}.code`)}_handleCachedData(g,p,R,w,L){g.cachedDataRejected?this._fs.unlink(R,e=>{L.getRecorder().record(62,R),this._createAndWriteCachedData(g,p,R,L),e&&L.getConfig().onError(e)}):w&&this._createAndWriteCachedData(g,p,R,L)}_createAndWriteCachedData(g,p,R,w){let L=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,D;const _=()=>{setTimeout(()=>{D||(D=this._crypto.createHash("md5").update(p,"utf8").digest());const v=g.createCachedData();if(!(v.length===0||v.length===e||E>=5)){if(v.length<e){_();return}e=v.length,this._fs.writeFile(R,Buffer.concat([D,v]),m=>{m&&w.getConfig().onError(m),w.getRecorder().record(63,R),_()})}},L*Math.pow(4,E++))};_()}_readSourceAndCachedData(g,p,R,w){if(!p)this._fs.readFile(g,{encoding:"utf8"},w);else{let L,e,E,D=2;const _=v=>{v?w(v):--D===0&&w(void 0,L,e,E)};this._fs.readFile(g,{encoding:"utf8"},(v,m)=>{L=m,_(v)}),this._fs.readFile(p,(v,m)=>{!v&&m&&m.length>0?(E=m.slice(0,16),e=m.slice(16),R.record(60,p)):R.record(61,p),_()})}}_verifyCachedData(g,p,R,w,L){!w||g.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(p,"utf8").digest();w.equals(e)||(L.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${R}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(R,E=>{E&&L.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random())))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function y(a,g){if(g.__$__isRecorded)return g;const p=function(w){a.record(33,w);try{return g(w)}finally{a.record(34,w)}};return p.__$__isRecorded=!0,p}q.ensureRecordedNodeRequire=y;function N(a){return new t(a)}q.createScriptLoader=N})(oe||(oe={}));var oe;(function(q){class t{constructor(a){let g=a.lastIndexOf("/");g!==-1?this.fromModulePath=a.substr(0,g+1):this.fromModulePath=""}static _normalizeModuleId(a){let g=a,p;for(p=/\/\.\//;p.test(g);)g=g.replace(p,"/");for(g=g.replace(/^\.\//g,""),p=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;p.test(g);)g=g.replace(p,"/");return g=g.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),g}resolveModule(a){let g=a;return q.Utilities.isAbsolutePath(g)||(q.Utilities.startsWith(g,"./")||q.Utilities.startsWith(g,"../"))&&(g=t._normalizeModuleId(this.fromModulePath+g)),g}}t.ROOT=new t(""),q.ModuleIdResolver=t;class F{constructor(a,g,p,R,w,L){this.id=a,this.strId=g,this.dependencies=p,this._callback=R,this._errorback=w,this.moduleIdResolver=L,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,g){try{return{returnedValue:a.apply(q.global,g),producedError:null}}catch(p){return{returnedValue:null,producedError:p}}}static _invokeFactory(a,g,p,R){return a.shouldInvokeFactory(g)?a.shouldCatchError()?this._safeInvokeFunction(p,R):{returnedValue:p.apply(q.global,R),producedError:null}:{returnedValue:null,producedError:null}}complete(a,g,p,R){this._isComplete=!0;let w=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let L=F._invokeFactory(g,this.strId,this._callback,p);w=L.producedError,a.record(22,this.strId),!w&&typeof L.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=L.returnedValue)}else this.exports=this._callback;if(w){let L=q.ensureError(w);L.phase="factory",L.moduleId=this.strId,L.neededBy=R(this.id),this.error=L,g.onError(L)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}q.Module=F;class T{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let g=this._strModuleIdToIntModuleId.get(a);return typeof g>"u"&&(g=this._nextId++,this._strModuleIdToIntModuleId.set(a,g),this._intModuleIdToStrModuleId[g]=a),g}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),q.RegularDependency=i;class u{constructor(a,g,p){this.id=a,this.pluginId=g,this.pluginParam=p}}q.PluginDependency=u;class y{constructor(a,g,p,R,w=0){this._env=a,this._scriptLoader=g,this._loaderAvailableTimestamp=w,this._defineFunc=p,this._requireFunc=R,this._moduleIdProvider=new T,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new y(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,g){let p=L=>L.replace(/\\/g,"/"),R=p(a),w=g.split(/\n/);for(let L=0;L<w.length;L++){let e=w[L].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],D=e[2],_=e[3],v=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(v),E=p(E),E===R){let m={line:parseInt(D,10),col:parseInt(_,10)};return m.line===1&&(m.col-=53),m}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],g=0;for(let p=0,R=this._modules2.length;p<R;p++){let w=this._modules2[p];if(!w)continue;let L=this._buildInfoPath[w.id]||null,e=this._buildInfoDefineStack[w.id]||null,E=this._buildInfoDependencies[w.id];a[g++]={id:w.strId,path:L,defineLocation:L&&e?y._findRelevantLocationInStack(L,e):null,dependencies:E,shim:null,exports:w.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,g){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let p=null;this._config.isBuild()&&(p=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:p,dependencies:a,callback:g}}defineModule(a,g,p,R,w,L=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let E=new F(e,a,this._normalizeDependencies(g,L),p,R,L);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=w,this._buildInfoDependencies[e]=(E.dependencies||[]).map(D=>this._moduleIdProvider.getStrModuleId(D.id))),this._resolve(E)}_normalizeDependency(a,g){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let p=a.indexOf("!");if(p>=0){let R=g.resolveModule(a.substr(0,p)),w=g.resolveModule(a.substr(p+1)),L=this._moduleIdProvider.getModuleId(R+"!"+w),e=this._moduleIdProvider.getModuleId(R);return new u(L,e,w)}return new i(this._moduleIdProvider.getModuleId(g.resolveModule(a)))}_normalizeDependencies(a,g){let p=[],R=0;for(let w=0,L=a.length;w<L;w++)p[R++]=this._normalizeDependency(a[w],g);return p}_relativeRequire(a,g,p,R){if(typeof g=="string")return this.synchronousRequire(g,a);this.defineModule(q.Utilities.generateAnonymousModule(),g,p,R,null,a)}synchronousRequire(a,g=new t(a)){let p=this._normalizeDependency(a,g),R=this._modules2[p.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports}configure(a,g){let p=this._config.shouldRecordStats();g?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!p&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let g=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),g.dependencies,g.callback,null,g.stack)}}_createLoadError(a,g){let p=this._moduleIdProvider.getStrModuleId(a),R=(this._inverseDependencies2[a]||[]).map(L=>this._moduleIdProvider.getStrModuleId(L));const w=q.ensureError(g);return w.phase="loading",w.moduleId=p,w.neededBy=R,w}_onLoadError(a,g){const p=this._createLoadError(a,g);this._modules2[a]||(this._modules2[a]=new F(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let R=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)R[e]=!1;let w=!1,L=[];for(L.push(a),R[a]=!0;L.length>0;){let e=L.shift(),E=this._modules2[e];E&&(w=E.onDependencyError(p)||w);let D=this._inverseDependencies2[e];if(D)for(let _=0,v=D.length;_<v;_++){let m=D[_];R[m]||(L.push(m),R[m]=!0)}}w||this._config.onError(p)}_hasDependencyPath(a,g){let p=this._modules2[a];if(!p)return!1;let R=[];for(let L=0,e=this._moduleIdProvider.getMaxModuleId();L<e;L++)R[L]=!1;let w=[];for(w.push(p),R[a]=!0;w.length>0;){let e=w.shift().dependencies;if(e)for(let E=0,D=e.length;E<D;E++){let _=e[E];if(_.id===g)return!0;let v=this._modules2[_.id];v&&!R[_.id]&&(R[_.id]=!0,w.push(v))}}return!1}_findCyclePath(a,g,p){if(a===g||p===50)return[a];let R=this._modules2[a];if(!R)return null;let w=R.dependencies;if(w)for(let L=0,e=w.length;L<e;L++){let E=this._findCyclePath(w[L].id,g,p+1);if(E!==null)return E.push(a),E}return null}_createRequire(a){let g=(p,R,w)=>this._relativeRequire(a,p,R,w);return g.toUrl=p=>this._config.requireToUrl(a.resolveModule(p)),g.getStats=()=>this.getLoaderEvents(),g.hasDependencyCycle=()=>this._hasDependencyCycle,g.config=(p,R=!1)=>{this.configure(p,R)},g.__$__nodeRequire=q.global.nodeRequire,g}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let g=this._moduleIdProvider.getStrModuleId(a),p=this._config.moduleIdToPaths(g),R=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(g.indexOf("/")===-1||R.test(g))&&p.push("node|"+g);let w=-1,L=e=>{if(w++,w>=p.length)this._onLoadError(a,e);else{let E=p[w],D=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[a]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}D.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=E),D.record(11,E),this._onLoad(a)},_=>{D.record(12,E),L(_)})}};L(null)}_loadPluginDependency(a,g){if(this._modules2[g.id]||this._knownModules2[g.id])return;this._knownModules2[g.id]=!0;let p=R=>{this.defineModule(this._moduleIdProvider.getStrModuleId(g.id),[],R,null,null)};p.error=R=>{this._config.onError(this._createLoadError(g.id,R))},a.load(g.pluginParam,this._createRequire(t.ROOT),p,this._config.getOptionsLiteral())}_resolve(a){let g=a.dependencies;if(g)for(let p=0,R=g.length;p<R;p++){let w=g[p];if(w===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(w===i.MODULE){a.unresolvedDependenciesCount--;continue}if(w===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let L=this._modules2[w.id];if(L&&L.isComplete()){if(L.error){a.onDependencyError(L.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(w.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(w.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(w.id,a.id,0)||[];e.reverse(),e.push(w.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[w.id]=this._inverseDependencies2[w.id]||[],this._inverseDependencies2[w.id].push(a.id),w instanceof u){let e=this._modules2[w.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,w);continue}let E=this._inversePluginDependencies2.get(w.pluginId);E||(E=[],this._inversePluginDependencies2.set(w.pluginId,E)),E.push(w),this._loadModule(w.pluginId);continue}this._loadModule(w.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let g=this.getRecorder();if(a.isComplete())return;let p=a.dependencies,R=[];if(p)for(let E=0,D=p.length;E<D;E++){let _=p[E];if(_===i.EXPORTS){R[E]=a.exports;continue}if(_===i.MODULE){R[E]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(_===i.REQUIRE){R[E]=this._createRequire(a.moduleIdResolver);continue}let v=this._modules2[_.id];if(v){R[E]=v.exports;continue}R[E]=null}const w=E=>(this._inverseDependencies2[E]||[]).map(D=>this._moduleIdProvider.getStrModuleId(D));a.complete(g,this._config,R,w);let L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(let E=0,D=L.length;E<D;E++){let _=L[E],v=this._modules2[_];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let E=0,D=e.length;E<D;E++)this._loadPluginDependency(a.exports,e[E])}}}q.ModuleManager=y})(oe||(oe={}));var J,oe;(function(q){const t=new q.Environment;let F=null;const T=function(N,a,g){typeof N!="string"&&(g=a,a=N,N=null),(typeof a!="object"||!Array.isArray(a))&&(g=a,a=null),a||(a=["require","exports","module"]),N?F.defineModule(N,a,g,null,null):F.enqueueDefineAnonymousModule(a,g)};T.amd={jQuery:!0};const i=function(N,a=!1){F.configure(N,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return F.getConfig().getOptionsLiteral()},u.reset=function(){F=F.reset()},u.getBuildInfo=function(){return F.getBuildInfo()},u.getStats=function(){return F.getLoaderEvents()},u.define=T;function y(){if(typeof q.global.require<"u"||typeof require<"u"){const N=q.global.require||require;if(typeof N=="function"&&typeof N.resolve=="function"){const a=q.ensureRecordedNodeRequire(F.getRecorder(),N);q.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(q.global.define=T),q.global.require=u)}q.init=y,(typeof q.global.define!="function"||!q.global.define.amd)&&(F=new q.ModuleManager(t,q.createScriptLoader(t),T,u,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&u.config(q.global.require),J=function(){return T.apply(null,arguments)},J.amd=T.amd,typeof doNotInitLoader>"u"&&y())})(oe||(oe={})),J(Z[54],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(N,a,g,p){if(p=p||{},(p["vs/css"]||{}).disabled){g({});return}const w=a.toUrl(N+".css");T(N,w,()=>{g({})},L=>{typeof g.error=="function"&&g.error("Could not find "+w+".")})}t.load=F;function T(N,a,g,p){if(i(N,a)){g();return}u(N,a,g,p)}function i(N,a){const g=document.getElementsByTagName("link");for(let p=0,R=g.length;p<R;p++){const w=g[p].getAttribute("data-name"),L=g[p].getAttribute("href");if(w===N||L===a)return!0}return!1}function u(N,a,g,p){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",N),y(N,R,g,p),R.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function y(N,a,g,p){const R=()=>{a.removeEventListener("load",w),a.removeEventListener("error",L)},w=e=>{R(),g()},L=e=>{R(),p(e)};a.addEventListener("load",w),a.addEventListener("error",L)}}),J("vs/nls",["require","exports"],function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const T="i-default";function i(e,E){let D;return E.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(_,v)=>{const m=v[0],l=E[m];let c=_;return typeof l=="string"?c=l:(typeof l=="number"||typeof l=="boolean"||l===void 0||l===null)&&(c=String(l)),c}),F&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function u(e,E){let D=e[E];return D||(D=e["*"],D)?D:null}function y(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function N(e,E,D){const _=y(e)+y(E)+"vscode/"+y(D),v=await fetch(_);if(v.ok)return await v.json();throw new Error(`${v.status} - ${v.statusText}`)}function a(e){return function(E,D){const _=Array.prototype.slice.call(arguments,2);return i(e[E],_)}}function g(e,E,...D){return i(E,D)}t.localize=g;function p(e){}t.getConfiguredDefaultLocale=p;function R(e){F=e}t.setPseudoTranslation=R;function w(e,E){return{localize:a(E[e]),getConfiguredDefaultLocale:E.getConfiguredDefaultLocale??(D=>{})}}t.create=w;function L(e,E,D,_){const v=_["vs/nls"]??{};if(!e||e.length===0)return D({localize:g,getConfiguredDefaultLocale:()=>v.availableLanguages?.["*"]});const m=v.availableLanguages?u(v.availableLanguages,e):null,l=m===null||m===T;let c=".nls";l||(c=c+"."+m);const r=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>v.availableLanguages?.["*"],D(s)};typeof v.loadBundle=="function"?v.loadBundle(e,m,(s,d)=>{s?E([e+".nls"],r):r(d)}):v.translationServiceUrl&&!l?(async()=>{try{const s=await N(v.translationServiceUrl,m,e);return r(s)}catch(s){if(!m.includes("-"))return console.error(s),E([e+".nls"],r);try{const d=m.split("-")[0],f=await N(v.translationServiceUrl,d,e);return v.availableLanguages??={},v.availableLanguages["*"]=d,r(f)}catch(d){return console.error(d),E([e+".nls"],r)}}})():E([e+c],r,s=>{if(c===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${m}. Falling back to the default language:`,s),E([e+".nls"],r)})}t.load=L}),function(){const q=globalThis.MonacoEnvironment,t=q&&q.baseUrl?q.baseUrl:"../../../",F=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:g=>g,createScript:(g,...p)=>{const R=p.slice(0,-1).join(","),w=p.pop().toString();return`(function anonymous(${R}) { ${w}
})`}}):void 0;function T(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function i(){return new Promise((g,p)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const R=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(R)&&R.substring(0,globalThis.origin.length)!==globalThis.origin)&&T()){fetch(R).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${R}`,(F?globalThis.eval(F.createScript("",L)):new Function(L)).call(globalThis),g()}).then(void 0,p);return}F?importScripts(F.createScriptURL(R)):importScripts(R),g()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function y(g){i().then(()=>{u(),require([g],function(p){setTimeout(function(){const R=p.create((w,L)=>{globalThis.postMessage(w,L)},null);for(globalThis.onmessage=w=>R.onmessage(w.data,w.ports);a.length>0;){const w=a.shift();R.onmessage(w.data,w.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&u();let N=!0;const a=[];globalThis.onmessage=g=>{if(!N){a.push(g);return}N=!1,y(g.data)}}(),J(Z[25],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class F{constructor(i,u,y,N){this.originalStart=i,this.originalLength=u,this.modifiedStart=y,this.modifiedLength=N}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=F}),J(Z[5],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class F{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?l.isErrorNoTelemetry(s)?new l(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(d=>{d(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}t.ErrorHandler=F,t.errorHandler=new F;function T(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=T;function i(r){if(!r||typeof r!="object")return!1;const s=r;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){g(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function y(r){g(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=y;function N(r){if(r instanceof Error){const{name:s,message:d}=r,f=r.stacktrace||r.stack;return{$isError:!0,name:s,message:d,stack:f,noTelemetry:l.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=N;const a="Canceled";function g(r){return r instanceof p?!0:r instanceof Error&&r.name===a&&r.message===a}t.isCancellationError=g;class p extends Error{constructor(){super(a),this.name=this.message}}t.CancellationError=p;function R(){const r=new Error(a);return r.name=r.message,r}t.canceled=R;function w(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=w;function L(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=L;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function E(r){const s=new Error(`${r} has been disposed`);return s.name="DISPOSED",s}t.disposed=E;function D(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=D;class _ extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=_;class v extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=v;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=m;class l extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof l)return s;const d=new l;return d.message=s.message,d.stack=s.stack,d}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=l;class c extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}t.BugIndicatingError=c}),J(Z[26],ee([0,1,5]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function T(k,S=0){return k[k.length-(1+S)]}t.tail=T;function i(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=i;function u(k,S,I=(W,j)=>W===j){if(k===S)return!0;if(!k||!S||k.length!==S.length)return!1;for(let W=0,j=k.length;W<j;W++)if(!I(k[W],S[W]))return!1;return!0}t.equals=u;function y(k,S){const I=k.length-1;S<I&&(k[S]=k[I]),k.pop()}t.removeFastWithoutKeepingOrder=y;function N(k,S,I){return a(k.length,W=>I(k[W],S))}t.binarySearch=N;function a(k,S){let I=0,W=k-1;for(;I<=W;){const j=(I+W)/2|0,ie=S(j);if(ie<0)I=j+1;else if(ie>0)W=j-1;else return j}return-(I+1)}t.binarySearch2=a;function g(k,S){let I=0,W=k.length;if(W===0)return 0;for(;I<W;){const j=Math.floor((I+W)/2);S(k[j])?W=j:I=j+1}return I}t.findFirstInSorted=g;function p(k,S,I){if(k=k|0,k>=S.length)throw new TypeError("invalid index");const W=S[Math.floor(S.length*Math.random())],j=[],ie=[],re=[];for(const le of S){const ae=I(le,W);ae<0?j.push(le):ae>0?ie.push(le):re.push(le)}return k<j.length?p(k,j,I):k<j.length+re.length?re[0]:p(k-(j.length+re.length),ie,I)}t.quickSelect=p;function R(k,S){const I=[];let W;for(const j of k.slice(0).sort(S))!W||S(W[0],j)!==0?(W=[j],I.push(W)):W.push(j);return I}t.groupBy=R;function w(k,S,I){const W=[];function j(le,ae,fe){if(ae===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===le?(he.deleteCount+=ae,he.toInsert.push(...fe)):W.push({start:le,deleteCount:ae,toInsert:fe})}let ie=0,re=0;for(;;){if(ie===k.length){j(ie,0,S.slice(re));break}if(re===S.length){j(ie,k.length-ie,[]);break}const le=k[ie],ae=S[re],fe=I(le,ae);fe===0?(ie+=1,re+=1):fe<0?(j(ie,1,[]),ie+=1):fe>0&&(j(ie,0,[ae]),re+=1)}return W}t.sortedDiff=w;function L(k,S,I){const W=w(k,S,I),j=[],ie=[];for(const re of W)j.push(...k.slice(re.start,re.start+re.deleteCount)),ie.push(...re.toInsert);return{removed:j,added:ie}}t.delta=L;function e(k,S,I){if(I===0)return[];const W=k.slice(0,I).sort(S);return D(k,S,W,I,k.length),W}t.top=e;function E(k,S,I,W,j){return I===0?Promise.resolve([]):new Promise((ie,re)=>{(async()=>{const le=k.length,ae=k.slice(0,I).sort(S);for(let fe=I,he=Math.min(I+W,le);fe<le;fe=he,he=Math.min(he+W,le)){if(fe>I&&await new Promise(ke=>setTimeout(ke)),j&&j.isCancellationRequested)throw new F.CancellationError;D(k,S,ae,fe,he)}return ae})().then(ie,re)})}t.topAsync=E;function D(k,S,I,W,j){for(const ie=I.length;W<j;W++){const re=k[W];if(S(re,I[ie-1])<0){I.pop();const le=g(I,ae=>S(re,ae)<0);I.splice(le,0,re)}}}function _(k){return k.filter(S=>!!S)}t.coalesce=_;function v(k){let S=0;for(let I=0;I<k.length;I++)k[I]&&(k[S]=k[I],S+=1);k.length=S}t.coalesceInPlace=v;function m(k,S,I){k.splice(I,0,k.splice(S,1)[0])}t.move=m;function l(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=l;function c(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=c;function r(k,S=I=>I){const I=new Set;return k.filter(W=>{const j=S(W);return I.has(j)?!1:(I.add(j),!0)})}t.distinct=r;function s(k){const S=new Set;return I=>{const W=k(I);return S.has(W)?!1:(S.add(W),!0)}}t.uniqueFilter=s;function d(k,S){const I=f(k,S);if(I!==-1)return k[I]}t.findLast=d;function f(k,S){for(let I=k.length-1;I>=0;I--){const W=k[I];if(S(W))return I}return-1}t.lastIndex=f;function A(k,S){return k.length>0?k[0]:S}t.firstOrDefault=A;function b(k,S){return k.length>0?k[k.length-1]:S}t.lastOrDefault=b;function h(k,S,I=(W,j)=>W===j){let W=0;for(let j=0,ie=Math.min(k.length,S.length);j<ie&&I(k[j],S[j]);j++)W++;return W}t.commonPrefixLength=h;function o(k){return[].concat(...k)}t.flatten=o;function M(k,S){let I=typeof S=="number"?k:0;typeof S=="number"?I=k:(I=0,S=k);const W=[];if(I<=S)for(let j=I;j<S;j++)W.push(j);else for(let j=I;j>S;j--)W.push(j);return W}t.range=M;function U(k,S,I){return k.reduce((W,j)=>(W[S(j)]=I?I(j):j,W),Object.create(null))}t.index=U;function C(k,S){return k.push(S),()=>B(k,S)}t.insert=C;function B(k,S){const I=k.indexOf(S);if(I>-1)return k.splice(I,1),S}t.remove=B;function V(k,S,I){const W=k.slice(0,S),j=k.slice(S);return W.concat(I,j)}t.arrayInsert=V;function z(k,S){let I;if(typeof S=="number"){let W=S;I=()=>{const j=Math.sin(W++)*179426549;return j-Math.floor(j)}}else I=Math.random;for(let W=k.length-1;W>0;W-=1){const j=Math.floor(I()*(W+1)),ie=k[W];k[W]=k[j],k[j]=ie}}t.shuffle=z;function x(k,S){const I=k.indexOf(S);I>-1&&(k.splice(I,1),k.unshift(S))}t.pushToStart=x;function ne(k,S){const I=k.indexOf(S);I>-1&&(k.splice(I,1),k.push(S))}t.pushToEnd=ne;function Q(k,S){for(const I of S)k.push(I)}t.pushMany=Q;function K(k,S){return Array.isArray(k)?k.map(S):S(k)}t.mapArrayOrNot=K;function n(k){return Array.isArray(k)?k:[k]}t.asArray=n;function we(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=we;function pe(k,S){for(const I of k){const W=S(I);if(W!==void 0)return W}}t.mapFind=pe;function de(k,S,I){const W=ve(k,S),j=k.length,ie=I.length;k.length=j+ie;for(let re=j-1;re>=W;re--)k[re+ie]=k[re];for(let re=0;re<ie;re++)k[re+W]=I[re]}t.insertInto=de;function Ee(k,S,I,W){const j=ve(k,S),ie=k.splice(j,I);return de(k,j,W),ie}t.splice=Ee;function ve(k,S){return S<0?Math.max(S+k.length,0):Math.min(S,k.length)}var Ne;(function(k){function S(j){return j<0}k.isLessThan=S;function I(j){return j>0}k.isGreaterThan=I;function W(j){return j===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(Ne=t.CompareResult||(t.CompareResult={}));function Re(k,S){return(I,W)=>S(k(I),k(W))}t.compareBy=Re;function De(...k){return(S,I)=>{for(const W of k){const j=W(S,I);if(!Ne.isNeitherLessOrGreaterThan(j))return j}return Ne.neitherLessOrGreaterThan}}t.tieBreakComparators=De;const Fe=(k,S)=>k-S;t.numberComparator=Fe;function _e(k,S){if(k.length===0)return;let I=k[0];for(let W=1;W<k.length;W++){const j=k[W];S(j,I)>0&&(I=j)}return I}t.findMaxBy=_e;function Pe(k,S){if(k.length===0)return;let I=k[0];for(let W=1;W<k.length;W++){const j=k[W];S(j,I)>=0&&(I=j)}return I}t.findLastMaxBy=Pe;function te(k,S){return _e(k,(I,W)=>-S(I,W))}t.findMinBy=te;class G{constructor(S){this.f=S,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(S){let I=this.c;for(;I<this.f.length&&S(this.f[I]);)I++;const W=I===this.c?null:this.f.slice(this.c,I);return this.c=I,W}takeFromEndWhile(S){let I=this.d;for(;I>=0&&S(this.f[I]);)I--;const W=I===this.d?null:this.f.slice(I+1,this.d+1);return this.d=I,W}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const S=this.f[this.c];return this.c++,S}removeLast(){const S=this.f[this.d];return this.d--,S}takeCount(S){const I=this.f.slice(this.c,this.c+S);return this.c+=S,I}}t.ArrayQueue=G;class Y{constructor(S){this.iterate=S}forEach(S){this.iterate(I=>(S(I),!0))}toArray(){const S=[];return this.iterate(I=>(S.push(I),!0)),S}filter(S){return new Y(I=>this.iterate(W=>S(W)?I(W):!0))}map(S){return new Y(I=>this.iterate(W=>I(S(W))))}some(S){let I=!1;return this.iterate(W=>(I=S(W),!I)),I}findFirst(S){let I;return this.iterate(W=>S(W)?(I=W,!1):!0),I}findLast(S){let I;return this.iterate(W=>(S(W)&&(I=W),!0)),I}findLastMaxBy(S){let I,W=!0;return this.iterate(j=>((W||Ne.isGreaterThan(S(j,I)))&&(W=!1,I=j),!0)),I}}Y.empty=new Y(k=>{}),t.CallbackIterable=Y}),J(Z[10],ee([0,1,5]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function T(a,g){if(!a)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=T;function i(a,g="Unreachable"){throw new Error(g)}t.assertNever=i;function u(a){if(!a)throw new F.BugIndicatingError("Assertion Failed")}t.assert=u;function y(a){if(!a()){debugger;a(),(0,F.onUnexpectedError)(new F.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function N(a,g){let p=0;for(;p<a.length-1;){const R=a[p],w=a[p+1];if(!g(R,w))return!1;p++}return!0}t.checkAdjacentItems=N}),J(Z[13],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function F(T){const i=this;let u=!1,y;return function(){return u||(u=!0,y=T.apply(i,arguments)),y}}t.once=F}),J(Z[14],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(T){function i(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=i;const u=Object.freeze([]);function y(){return u}T.empty=y;function*N(l){yield l}T.single=N;function a(l){return i(l)?l:N(l)}T.wrap=a;function g(l){return l||u}T.from=g;function p(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=p;function R(l){return l[Symbol.iterator]().next().value}T.first=R;function w(l,c){for(const r of l)if(c(r))return!0;return!1}T.some=w;function L(l,c){for(const r of l)if(c(r))return r}T.find=L;function*e(l,c){for(const r of l)c(r)&&(yield r)}T.filter=e;function*E(l,c){let r=0;for(const s of l)yield c(s,r++)}T.map=E;function*D(...l){for(const c of l)for(const r of c)yield r}T.concat=D;function _(l,c,r){let s=r;for(const d of l)s=c(s,d);return s}T.reduce=_;function*v(l,c,r=l.length){for(c<0&&(c+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);c<r;c++)yield l[c]}T.slice=v;function m(l,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,l];const s=l[Symbol.iterator]();for(let d=0;d<c;d++){const f=s.next();if(f.done)return[r,T.empty()];r.push(f.value)}return[r,{[Symbol.iterator](){return s}}]}T.consume=m})(F=t.Iterable||(t.Iterable={}))}),J(Z[27],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(F=t.KeyCode||(t.KeyCode={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,D){this._keyCodeToStr[E]=D,this._strToKeyCode[D.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const u=new i,y=new i,N=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],g=Object.create(null),p=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>g[e]||0,toString:e=>a[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",E=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],_=[];for(const v of E){const[m,l,c,r,s,d,f,A,b,h]=v;if(_[c]||(_[c]=!0,a[c]=r,g[r]=c,p[r.toLowerCase()]=c,l&&(t.IMMUTABLE_CODE_TO_KEY_CODE[c]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[s]=c))),!D[s]){if(D[s]=!0,!d)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);u.define(s,d),y.define(s,b||d),N.define(s,h||b||d)}f&&(t.EVENT_KEY_CODE_MAP[f]=s),A&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[A]=s)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function E(c){return u.keyCodeToStr(c)}e.toString=E;function D(c){return u.strToKeyCode(c)}e.fromString=D;function _(c){return y.keyCodeToStr(c)}e.toUserSettingsUS=_;function v(c){return N.keyCodeToStr(c)}e.toUserSettingsGeneral=v;function m(c){return y.strToKeyCode(c)||N.strToKeyCode(c)}e.fromUserSettings=m;function l(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(c)}e.toElectronAccelerator=l})(R=t.KeyCodeUtils||(t.KeyCodeUtils={}));var w;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(w=t.KeyMod||(t.KeyMod={}));function L(e,E){const D=(E&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=L}),J(Z[28],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class F{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=F}),J(Z[6],ee([0,1,13,14]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function y(b){u=b}if(t.setDisposableTracker=y,i){const b="__is_disposable_tracked__";y(new class{trackDisposable(h){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[b]||console.log(o)},3e3)}setParent(h,o){if(h&&h!==v.None)try{h[b]=!0}catch{}}markAsDisposed(h){if(h&&h!==v.None)try{h[b]=!0}catch{}}markAsSingleton(h){}})}function N(b){return u?.trackDisposable(b),b}function a(b){u?.markAsDisposed(b)}function g(b,h){u?.setParent(b,h)}function p(b,h){if(!!u)for(const o of b)u.setParent(o,h)}function R(b){return u?.markAsSingleton(b),b}t.markAsSingleton=R;function w(b){return typeof b.dispose=="function"&&b.dispose.length===0}t.isDisposable=w;function L(b){if(T.Iterable.is(b)){const h=[];for(const o of b)if(o)try{o.dispose()}catch(M){h.push(M)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}t.dispose=L;function e(b){for(const h of b)w(h)&&h.dispose();return[]}t.disposeIfDisposable=e;function E(...b){const h=D(()=>L(b));return p(b,h),h}t.combinedDisposable=E;function D(b){const h=N({dispose:(0,F.once)(()=>{a(h),b()})});return h}t.toDisposable=D;class _{constructor(){this.c=new Set,this.f=!1,N(this)}dispose(){this.f||(a(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{L(this.c)}finally{this.c.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return g(h,this),this.f?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(h),h}}_.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=_;class v{constructor(){this.B=new _,N(this),g(this.B,this)}dispose(){a(this),this.B.dispose()}D(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(h)}}v.None=Object.freeze({dispose(){}}),t.Disposable=v;class m{constructor(){this.b=!1,N(this)}get value(){return this.b?void 0:this.a}set value(h){this.b||h===this.a||(this.a?.dispose(),h&&g(h,this),this.a=h)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const h=this.a;return this.a=void 0,h&&g(h,null),h}}t.MutableDisposable=m;class l{constructor(h){this.b=h,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(h){let o=h;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,a(this))},this}}t.SafeDisposable=c;class r{constructor(){this.a=new Map}acquire(h,...o){let M=this.a.get(h);M||(M={counter:0,object:this.b(h,...o)},this.a.set(h,M));const{object:U}=M,C=(0,F.once)(()=>{--M.counter===0&&(this.c(h,M.object),this.a.delete(h))});return M.counter++,{object:U,dispose:C}}}t.ReferenceCollection=r;class s{constructor(h){this.a=h}async acquire(h,...o){const M=this.a.acquire(h,...o);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(U){throw M.dispose(),U}}}t.AsyncReferenceCollection=s;class d{constructor(h){this.object=h}dispose(){}}t.ImmortalReference=d;function f(b){const h=new _;try{b(h)}finally{h.dispose()}}t.disposeOnReturn=f;class A{constructor(){this.a=new Map,this.b=!1,N(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(h){return this.a.has(h)}get(h){return this.a.get(h)}set(h,o,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(h)?.dispose(),this.a.set(h,o)}deleteAndDispose(h){this.a.get(h)?.dispose(),this.a.delete(h)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=A}),J(Z[15],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class F{constructor(u){this.element=u,this.next=F.Undefined,this.prev=F.Undefined}}F.Undefined=new F(void 0);class T{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let u=this.a;for(;u!==F.Undefined;){const y=u.next;u.prev=F.Undefined,u.next=F.Undefined,u=y}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(u){return this.d(u,!1)}push(u){return this.d(u,!0)}d(u,y){const N=new F(u);if(this.a===F.Undefined)this.a=N,this.b=N;else if(y){const g=this.b;this.b=N,N.prev=g,g.next=N}else{const g=this.a;this.a=N,N.next=g,g.prev=N}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(N))}}shift(){if(this.a!==F.Undefined){const u=this.a.element;return this.e(this.a),u}}pop(){if(this.b!==F.Undefined){const u=this.b.element;return this.e(this.b),u}}e(u){if(u.prev!==F.Undefined&&u.next!==F.Undefined){const y=u.prev;y.next=u.next,u.next.prev=y}else u.prev===F.Undefined&&u.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):u.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):u.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let u=this.a;for(;u!==F.Undefined;)yield u.element,u=u.next}}t.LinkedList=T}),J(Z[16],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function F(s){return typeof s=="string"}t.isString=F;function T(s){return Array.isArray(s)&&s.every(d=>F(d))}t.isStringArray=T;function i(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=i;function u(s){const d=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof d}t.isTypedArray=u;function y(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=y;function N(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=N;function a(s){return s===!0||s===!1}t.isBoolean=a;function g(s){return typeof s>"u"}t.isUndefined=g;function p(s){return!R(s)}t.isDefined=p;function R(s){return g(s)||s===null}t.isUndefinedOrNull=R;function w(s,d){if(!s)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}t.assertType=w;function L(s){if(R(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=L;function e(...s){const d=[];for(let f=0;f<s.length;f++){const A=s[f];if(R(A))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);d.push(A)}return d}t.assertAllDefined=e;const E=Object.prototype.hasOwnProperty;function D(s){if(!i(s))return!1;for(const d in s)if(E.call(s,d))return!1;return!0}t.isEmptyObject=D;function _(s){return typeof s=="function"}t.isFunction=_;function v(...s){return s.length>0&&s.every(_)}t.areFunctions=v;function m(s,d){const f=Math.min(s.length,d.length);for(let A=0;A<f;A++)l(s[A],d[A])}t.validateConstraints=m;function l(s,d){if(F(d)){if(typeof s!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(_(d)){try{if(s instanceof d)return}catch{}if(!R(s)&&s.constructor===d||d.length===1&&d.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=l;function c(s){return s===null?void 0:s}t.withNullAsUndefined=c;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),J(Z[29],ee([0,1,16]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const T=Object.create(null);function i(N,a){if((0,F.isString)(a)){const g=T[a];if(g===void 0)throw new Error(`${N} references an unknown codicon: ${a}`);a=g}return T[N]=a,{id:N}}function u(){return T}t.getCodiconFontCharacters=u;function y(){return Object.values(t.Codicon)}t.getAllCodicons=y,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),J(Z[11],ee([0,1,16]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(_){if(!_||typeof _!="object"||_ instanceof RegExp)return _;const v=Array.isArray(_)?[]:{};return Object.entries(_).forEach(([m,l])=>{v[m]=l&&typeof l=="object"?T(l):l}),v}t.deepClone=T;function i(_){if(!_||typeof _!="object")return _;const v=[_];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const l in m)if(u.call(m,l)){const c=m[l];typeof c=="object"&&!Object.isFrozen(c)&&!(0,F.isTypedArray)(c)&&v.push(c)}}return _}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function y(_,v){return N(_,v,new Set)}t.cloneAndChange=y;function N(_,v,m){if((0,F.isUndefinedOrNull)(_))return _;const l=v(_);if(typeof l<"u")return l;if(Array.isArray(_)){const c=[];for(const r of _)c.push(N(r,v,m));return c}if((0,F.isObject)(_)){if(m.has(_))throw new Error("Cannot clone recursive data-structure");m.add(_);const c={};for(const r in _)u.call(_,r)&&(c[r]=N(_[r],v,m));return m.delete(_),c}return _}function a(_,v,m=!0){return(0,F.isObject)(_)?((0,F.isObject)(v)&&Object.keys(v).forEach(l=>{l in _?m&&((0,F.isObject)(_[l])&&(0,F.isObject)(v[l])?a(_[l],v[l],m):_[l]=v[l]):_[l]=v[l]}),_):v}t.mixin=a;function g(_,v){if(_===v)return!0;if(_==null||v===null||v===void 0||typeof _!=typeof v||typeof _!="object"||Array.isArray(_)!==Array.isArray(v))return!1;let m,l;if(Array.isArray(_)){if(_.length!==v.length)return!1;for(m=0;m<_.length;m++)if(!g(_[m],v[m]))return!1}else{const c=[];for(l in _)c.push(l);c.sort();const r=[];for(l in v)r.push(l);if(r.sort(),!g(c,r))return!1;for(m=0;m<c.length;m++)if(!g(_[c[m]],v[c[m]]))return!1}return!0}t.equals=g;function p(_){const v=new Set;return JSON.stringify(_,(m,l)=>{if((0,F.isObject)(l)||Array.isArray(l)){if(v.has(l))return"[Circular]";v.add(l)}return l})}t.safeStringify=p;function R(_,v){const m=Object.create(null);return!_||!v||Object.keys(v).forEach(c=>{const r=_[c],s=v[c];g(r,s)||(m[c]=s)}),m}t.distinct=R;function w(_,v){const m=v.toLowerCase(),l=Object.keys(_).find(c=>c.toLowerCase()===m);return l?_[l]:_[v]}t.getCaseInsensitive=w;function L(_,v){const m=Object.create(null);for(const[l,c]of Object.entries(_))v(l,c)&&(m[l]=c);return m}t.filter=L;function e(_){let v=[],m=Object.getPrototypeOf(_);for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}t.getAllPropertyNames=e;function E(_){const v=[];for(const m of e(_))typeof _[m]=="function"&&v.push(m);return v}t.getAllMethodNames=E;function D(_,v){const m=c=>function(){const r=Array.prototype.slice.call(arguments,0);return v(c,r)},l={};for(const c of _)l[c]=m(c);return l}t.createProxyObject=D}),J(Z[17],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var F;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F=t.Constants||(t.Constants={}));function T(u){return u<0?0:u>255?255:u|0}t.toUint8=T;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),J(Z[18],ee([0,1,17]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class T{constructor(N){const a=(0,F.toUint8)(N);this.c=a,this.a=T.d(a),this.b=new Map}static d(N){const a=new Uint8Array(256);return a.fill(N),a}set(N,a){const g=(0,F.toUint8)(a);N>=0&&N<256?this.a[N]=g:this.b.set(N,g)}get(N){return N>=0&&N<256?this.a[N]:this.b.get(N)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=T;var i;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(i||(i={}));class u{constructor(){this.a=new T(0)}add(N){this.a.set(N,1)}has(N){return this.a.get(N)===1}clear(){return this.a.clear()}}t.CharacterSet=u}),J(Z[3],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class F{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new F(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return F.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return F.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return F.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const y=i.lineNumber|0,N=u.lineNumber|0;if(y===N){const a=i.column|0,g=u.column|0;return a-g}return y-N}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new F(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=F}),J(Z[2],ee([0,1,3]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class T{constructor(u,y,N,a){u>N||u===N&&y>a?(this.startLineNumber=N,this.startColumn=a,this.endLineNumber=u,this.endColumn=y):(this.startLineNumber=u,this.startColumn=y,this.endLineNumber=N,this.endColumn=a)}isEmpty(){return T.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return T.containsPosition(this,u)}static containsPosition(u,y){return!(y.lineNumber<u.startLineNumber||y.lineNumber>u.endLineNumber||y.lineNumber===u.startLineNumber&&y.column<u.startColumn||y.lineNumber===u.endLineNumber&&y.column>u.endColumn)}static strictContainsPosition(u,y){return!(y.lineNumber<u.startLineNumber||y.lineNumber>u.endLineNumber||y.lineNumber===u.startLineNumber&&y.column<=u.startColumn||y.lineNumber===u.endLineNumber&&y.column>=u.endColumn)}containsRange(u){return T.containsRange(this,u)}static containsRange(u,y){return!(y.startLineNumber<u.startLineNumber||y.endLineNumber<u.startLineNumber||y.startLineNumber>u.endLineNumber||y.endLineNumber>u.endLineNumber||y.startLineNumber===u.startLineNumber&&y.startColumn<u.startColumn||y.endLineNumber===u.endLineNumber&&y.endColumn>u.endColumn)}strictContainsRange(u){return T.strictContainsRange(this,u)}static strictContainsRange(u,y){return!(y.startLineNumber<u.startLineNumber||y.endLineNumber<u.startLineNumber||y.startLineNumber>u.endLineNumber||y.endLineNumber>u.endLineNumber||y.startLineNumber===u.startLineNumber&&y.startColumn<=u.startColumn||y.endLineNumber===u.endLineNumber&&y.endColumn>=u.endColumn)}plusRange(u){return T.plusRange(this,u)}static plusRange(u,y){let N,a,g,p;return y.startLineNumber<u.startLineNumber?(N=y.startLineNumber,a=y.startColumn):y.startLineNumber===u.startLineNumber?(N=y.startLineNumber,a=Math.min(y.startColumn,u.startColumn)):(N=u.startLineNumber,a=u.startColumn),y.endLineNumber>u.endLineNumber?(g=y.endLineNumber,p=y.endColumn):y.endLineNumber===u.endLineNumber?(g=y.endLineNumber,p=Math.max(y.endColumn,u.endColumn)):(g=u.endLineNumber,p=u.endColumn),new T(N,a,g,p)}intersectRanges(u){return T.intersectRanges(this,u)}static intersectRanges(u,y){let N=u.startLineNumber,a=u.startColumn,g=u.endLineNumber,p=u.endColumn;const R=y.startLineNumber,w=y.startColumn,L=y.endLineNumber,e=y.endColumn;return N<R?(N=R,a=w):N===R&&(a=Math.max(a,w)),g>L?(g=L,p=e):g===L&&(p=Math.min(p,e)),N>g||N===g&&a>p?null:new T(N,a,g,p)}equalsRange(u){return T.equalsRange(this,u)}static equalsRange(u,y){return!u&&!y?!0:!!u&&!!y&&u.startLineNumber===y.startLineNumber&&u.startColumn===y.startColumn&&u.endLineNumber===y.endLineNumber&&u.endColumn===y.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(u){return new F.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(u){return new F.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,y){return new T(this.startLineNumber,this.startColumn,u,y)}setStartPosition(u,y){return new T(u,y,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(u){return new T(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(u){return new T(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new T(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,y=u){return new T(u.lineNumber,u.column,y.lineNumber,y.column)}static lift(u){return u?new T(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,y){return!(u.endLineNumber<y.startLineNumber||u.endLineNumber===y.startLineNumber&&u.endColumn<y.startColumn||y.endLineNumber<u.startLineNumber||y.endLineNumber===u.startLineNumber&&y.endColumn<u.startColumn)}static areIntersecting(u,y){return!(u.endLineNumber<y.startLineNumber||u.endLineNumber===y.startLineNumber&&u.endColumn<=y.startColumn||y.endLineNumber<u.startLineNumber||y.endLineNumber===u.startLineNumber&&y.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,y){if(u&&y){const g=u.startLineNumber|0,p=y.startLineNumber|0;if(g===p){const R=u.startColumn|0,w=y.startColumn|0;if(R===w){const L=u.endLineNumber|0,e=y.endLineNumber|0;if(L===e){const E=u.endColumn|0,D=y.endColumn|0;return E-D}return L-e}return R-w}return g-p}return(u?1:0)-(y?1:0)}static compareRangesUsingEnds(u,y){return u.endLineNumber===y.endLineNumber?u.endColumn===y.endColumn?u.startLineNumber===y.startLineNumber?u.startColumn-y.startColumn:u.startLineNumber-y.startLineNumber:u.endColumn-y.endColumn:u.endLineNumber-y.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=T}),J(Z[30],ee([0,1,3,2]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(i=t.SelectionDirection||(t.SelectionDirection={}));class u extends T.Range{constructor(N,a,g,p){super(N,a,g,p),this.selectionStartLineNumber=N,this.selectionStartColumn=a,this.positionLineNumber=g,this.positionColumn=p}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(N){return u.selectionsEqual(this,N)}static selectionsEqual(N,a){return N.selectionStartLineNumber===a.selectionStartLineNumber&&N.selectionStartColumn===a.selectionStartColumn&&N.positionLineNumber===a.positionLineNumber&&N.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(N,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,N,a):new u(N,a,this.startLineNumber,this.startColumn)}getPosition(){return new F.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(N,a){return this.getDirection()===0?new u(N,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,N,a)}static fromPositions(N,a=N){return new u(N.lineNumber,N.column,a.lineNumber,a.column)}static fromRange(N,a){return a===0?new u(N.startLineNumber,N.startColumn,N.endLineNumber,N.endColumn):new u(N.endLineNumber,N.endColumn,N.startLineNumber,N.startColumn)}static liftSelection(N){return new u(N.selectionStartLineNumber,N.selectionStartColumn,N.positionLineNumber,N.positionColumn)}static selectionsArrEqual(N,a){if(N&&!a||!N&&a)return!1;if(!N&&!a)return!0;if(N.length!==a.length)return!1;for(let g=0,p=N.length;g<p;g++)if(!this.selectionsEqual(N[g],a[g]))return!1;return!0}static isISelection(N){return N&&typeof N.selectionStartLineNumber=="number"&&typeof N.selectionStartColumn=="number"&&typeof N.positionLineNumber=="number"&&typeof N.positionColumn=="number"}static createWithDirection(N,a,g,p,R){return R===0?new u(N,a,g,p):new u(g,p,N,a)}}t.Selection=u}),J(Z[31],ee([0,1,18]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var T;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(T=t.WordCharacterClass||(t.WordCharacterClass={}));class i extends F.CharacterClassifier{constructor(N){super(0);for(let a=0,g=N.length;a<g;a++)this.set(N.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(y){const N={};return a=>(N.hasOwnProperty(a)||(N[a]=y(a)),N[a])}t.getMapForWordSeparators=u(y=>new i(y))}),J(Z[19],ee([0,1,14,6,15]),function(q,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(R=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const L of t.USUAL_WORD_SEPARATORS)R.indexOf(L)>=0||(w+="\\"+L);return w+="\\s]+)",new RegExp(w,"g")}t.DEFAULT_WORD_REGEXP=u();function y(R){let w=t.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)w=R;else{let L="g";R.ignoreCase&&(L+="i"),R.multiline&&(L+="m"),R.unicode&&(L+="u"),w=new RegExp(R.source,L)}return w.lastIndex=0,w}t.ensureValidWordDefinition=y;const N=new i.LinkedList;N.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(R){const w=N.unshift(R);return(0,T.toDisposable)(w)}t.setDefaultGetWordAtTextConfig=a;function g(R,w,L,e,E){if(E||(E=F.Iterable.first(N)),L.length>E.maxLen){let l=R-E.maxLen/2;return l<0?l=0:e+=l,L=L.substring(l,R+E.maxLen/2),g(R,w,L,e,E)}const D=Date.now(),_=R-1-e;let v=-1,m=null;for(let l=1;!(Date.now()-D>=E.timeBudget);l++){const c=_-E.windowSize*l;w.lastIndex=Math.max(0,c);const r=p(w,L,_,v);if(!r&&m||(m=r,c<=0))break;v=c}if(m){const l={word:m[0],startColumn:e+1+m.index,endColumn:e+1+m.index+m[0].length};return w.lastIndex=0,l}return null}t.getWordAtText=g;function p(R,w,L,e){let E;for(;E=R.exec(w);){const D=E.index||0;if(D<=L&&R.lastIndex>=L)return E;if(e>0&&D>e)return null}return null}}),J(Z[7],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class F{constructor(u,y){this.seq1Range=u,this.seq2Range=y}reverse(){return new F(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}t.SequenceDiff=F;class T{constructor(u,y){this.start=u,this.endExclusive=y}get isEmpty(){return this.start===this.endExclusive}delta(u){return new T(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(u){return new T(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}}t.OffsetRange=T}),J(Z[32],ee([0,1,7]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function T(a,g,p){let R=p;return R=u(a,g,R),R=y(a,g,R),R}t.optimizeSequenceDiffs=T;function i(a,g,p){const R=[];for(const w of p){const L=R[R.length-1];if(!L){R.push(w);continue}w.seq1Range.start-L.seq1Range.endExclusive<=2||w.seq2Range.start-L.seq2Range.endExclusive<=2?R[R.length-1]=new F.SequenceDiff(L.seq1Range.join(w.seq1Range),L.seq2Range.join(w.seq2Range)):R.push(w)}return R}t.smoothenSequenceDiffs=i;function u(a,g,p){const R=[];p.length>0&&R.push(p[0]);for(let w=1;w<p.length;w++){const L=R[R.length-1],e=p[w];if(e.seq1Range.isEmpty){let E=!0;const D=e.seq1Range.start-L.seq1Range.endExclusive;for(let _=1;_<=D;_++)if(g.getElement(e.seq2Range.start-_)!==g.getElement(e.seq2Range.endExclusive-_)){E=!1;break}if(E){R[R.length-1]=new F.SequenceDiff(L.seq1Range,new F.OffsetRange(L.seq2Range.start,e.seq2Range.endExclusive-D));continue}}R.push(e)}return R}t.joinSequenceDiffs=u;function y(a,g,p){if(!a.getBoundaryScore||!g.getBoundaryScore)return p;for(let R=0;R<p.length;R++){const w=p[R];if(w.seq1Range.isEmpty){const L=R>0?p[R-1].seq2Range.endExclusive:-1,e=R+1<p.length?p[R+1].seq2Range.start:g.length;p[R]=N(w,a,g,e,L)}else if(w.seq2Range.isEmpty){const L=R>0?p[R-1].seq1Range.endExclusive:-1,e=R+1<p.length?p[R+1].seq1Range.start:a.length;p[R]=N(w.reverse(),g,a,e,L).reverse()}}return p}t.shiftSequenceDiffs=y;function N(a,g,p,R,w){let e=1;for(;a.seq2Range.start-e>w&&p.getElement(a.seq2Range.start-e)===p.getElement(a.seq2Range.endExclusive-e)&&e<20;)e++;e--;let E=0;for(;a.seq2Range.start+E<R&&p.getElement(a.seq2Range.start+E)===p.getElement(a.seq2Range.endExclusive+E)&&E<20;)E++;if(e===0&&E===0)return a;let D=0,_=-1;for(let v=-e;v<=E;v++){const m=a.seq2Range.start+v,l=a.seq2Range.endExclusive+v,c=a.seq1Range.start+v,r=g.getBoundaryScore(c)+p.getBoundaryScore(m)+p.getBoundaryScore(l);r>_&&(_=r,D=v)}return D!==0?new F.SequenceDiff(a.seq1Range.delta(D),a.seq2Range.delta(D)):a}}),J(Z[33],ee([0,1,7]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class T{compute(a,g){if(a.length===0)return[new F.SequenceDiff(new F.OffsetRange(0,0),new F.OffsetRange(0,g.length))];if(g.length===0)return[new F.SequenceDiff(new F.OffsetRange(0,a.length),new F.OffsetRange(0,0))];function p(m,l){for(;m<a.length&&l<g.length&&a.getElement(m)===g.getElement(l);)m++,l++;return m}let R=0;const w=new u;w.set(0,p(0,0));const L=new y;L.set(0,w.get(0)===0?null:new i(null,0,0,w.get(0)));let e=0;e:for(;;)for(R++,e=-R;e<=R;e+=2){const m=e===R?-1:w.get(e+1),l=e===-R?-1:w.get(e-1)+1,c=Math.min(Math.max(m,l),a.length),r=c-e,s=p(c,r);w.set(e,s);const d=c===m?L.get(e+1):L.get(e-1);if(L.set(e,s!==c?new i(d,c,r,s-c):d),w.get(e)===a.length&&w.get(e)-e===g.length)break e}let E=L.get(e);const D=[];let _=a.length,v=g.length;for(;;){const m=E?E.x+E.length:0,l=E?E.y+E.length:0;if((m!==_||l!==v)&&D.push(new F.SequenceDiff(new F.OffsetRange(m,_),new F.OffsetRange(l,v))),!E)break;_=E.x,v=E.y,E=E.prev}return D.reverse(),D}}t.MyersDiffAlgorithm=T;class i{constructor(a,g,p,R){this.prev=a,this.x=g,this.y=p,this.length=R}}class u{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,g){if(a<0){if(a=-a-1,a>=this.b.length){const p=this.b;this.b=new Int32Array(p.length*2),this.b.set(p)}this.b[a]=g}else{if(a>=this.a.length){const p=this.a;this.a=new Int32Array(p.length*2),this.a.set(p)}this.a[a]=g}}}class y{constructor(){this.a=[],this.b=[]}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,g){a<0?(a=-a-1,this.b[a]=g):this.a[a]=g}}}),J(Z[34],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class F{constructor(i,u){this.width=i,this.height=u,this.a=[],this.a=new Array(i*u)}get(i,u){return this.a[i+u*this.width]}set(i,u,y){this.a[i+u*this.width]=y}}t.Array2D=F}),J(Z[35],ee([0,1,7,34]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class i{compute(y,N,a){const g=new T.Array2D(y.length,N.length),p=new T.Array2D(y.length,N.length),R=new T.Array2D(y.length,N.length);for(let v=0;v<y.length;v++)for(let m=0;m<N.length;m++){const l=v===0?0:g.get(v-1,m),c=m===0?0:g.get(v,m-1);let r;y.getElement(v)===N.getElement(m)?(v===0||m===0?r=0:r=g.get(v-1,m-1),v>0&&m>0&&p.get(v-1,m-1)===3&&(r+=R.get(v-1,m-1)),r+=a?a(v,m):1):r=-1;const s=Math.max(l,c,r);if(s===r){const d=v>0&&m>0?R.get(v-1,m-1):0;R.set(v,m,d+1),p.set(v,m,3)}else s===l?(R.set(v,m,0),p.set(v,m,1)):s===c&&(R.set(v,m,0),p.set(v,m,2));g.set(v,m,s)}const w=[];let L=y.length,e=N.length;function E(v,m){(v+1!==L||m+1!==e)&&w.push(new F.SequenceDiff(new F.OffsetRange(v+1,L),new F.OffsetRange(m+1,e))),L=v,e=m}let D=y.length-1,_=N.length-1;for(;D>=0&&_>=0;)p.get(D,_)===3?(E(D,_),D--,_--):p.get(D,_)===1?D--:_--;return E(-1,-1),w.reverse(),w}}t.DynamicProgrammingDiffing=i}),J(Z[20],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=t.RangeMapping=t.LineRangeMapping=void 0;class F{constructor(y,N,a){this.originalRange=y,this.modifiedRange=N,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.LineRangeMapping=F;class T{constructor(y,N){this.originalRange=y,this.modifiedRange=N}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=T;class i{constructor(y,N){this.startLineNumber=y,this.endLineNumberExclusive=N}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(y){return new i(this.startLineNumber+y,this.endLineNumberExclusive+y)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(y){return new i(Math.min(this.startLineNumber,y.startLineNumber),Math.max(this.endLineNumberExclusive,y.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=i}),J(Z[36],ee([0,1,10,3,2,7,35,32,33,20]),function(q,t,F,T,i,u,y,N,a,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class p{constructor(){this.b=new y.DynamicProgrammingDiffing,this.c=new a.MyersDiffAlgorithm}computeDiff(r,s,d){const f=new Map;function A(ne){let Q=f.get(ne);return Q===void 0&&(Q=f.size,f.set(ne,Q)),Q}const b=r.map(ne=>A(ne.trim())),h=s.map(ne=>A(ne.trim())),o=new L(b,r),M=new L(h,s);let U=(()=>o.length+M.length<1500?this.b.compute(o,M,(ne,Q)=>r[ne]===s[Q]?s[Q].length===0?.1:1+Math.log(1+s[Q].length):.99):this.c.compute(o,M))();U=(0,N.optimizeSequenceDiffs)(o,M,U);const C=[],B=ne=>{for(let Q=0;Q<ne;Q++){const K=V+Q,n=z+Q;if(r[K]!==s[n]){const we=this.f(r,s,new u.SequenceDiff(new u.OffsetRange(K,K+1),new u.OffsetRange(n,n+1)));for(const pe of we)C.push(pe)}}};let V=0,z=0;for(const ne of U){(0,F.assertFn)(()=>ne.seq1Range.start-V===ne.seq2Range.start-z);const Q=ne.seq1Range.start-V;B(Q),V=ne.seq1Range.endExclusive,z=ne.seq2Range.endExclusive;const K=this.f(r,s,ne);for(const n of K)C.push(n)}B(r.length-V);const x=R(C);return{quitEarly:!1,changes:x}}f(r,s,d){const f=new E(r,d.seq1Range),A=new E(s,d.seq2Range),b=f.length+A.length<500?this.b.compute(f,A):this.c.compute(f,A);let h=(0,N.optimizeSequenceDiffs)(f,A,b);return h=(0,N.smoothenSequenceDiffs)(f,A,h),h.map(M=>new g.RangeMapping(f.translateRange(M.seq1Range).delta(d.seq1Range.start),A.translateRange(M.seq2Range).delta(d.seq2Range.start)))}}t.StandardLinesDiffComputer=p;function R(c){const r=[];for(const s of w(c,(d,f)=>f.originalRange.startLineNumber-(d.originalRange.endLineNumber-(d.originalRange.endColumn>1?0:1))<=1||f.modifiedRange.startLineNumber-(d.modifiedRange.endLineNumber-(d.modifiedRange.endColumn>1?0:1))<=1)){const d=s[0],f=s[s.length-1];r.push(new g.LineRangeMapping(new g.LineRange(d.originalRange.startLineNumber,f.originalRange.endLineNumber+(f.originalRange.endColumn>1||f.modifiedRange.endColumn>1?1:0)),new g.LineRange(d.modifiedRange.startLineNumber,f.modifiedRange.endLineNumber+(f.originalRange.endColumn>1||f.modifiedRange.endColumn>1?1:0)),s))}return(0,F.assertFn)(()=>(0,F.checkAdjacentItems)(r,(s,d)=>d.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===d.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<d.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<d.modifiedRange.startLineNumber)),r}t.lineRangeMappingFromRangeMappings=R;function*w(c,r){let s,d;for(const f of c)d!==void 0&&r(d,f)?s.push(f):(s&&(yield s),s=[f]),d=f;s&&(yield s)}class L{constructor(r,s){this.b=r,this.c=s}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=r===0?0:e(this.c[r-1]),d=r===this.c.length?0:e(this.c[r]);return 1e3-(s+d)}}t.LineSequence=L;function e(c){let r=0;for(;r<c.length&&(c.charCodeAt(r)===32||c.charCodeAt(r)===9);)r++;return r}class E{constructor(r,s){this.lines=r,this.lineRange=s;let d=0;this.c=new Int32Array(s.length);for(let A=s.start;A<s.endExclusive;A++)d+=r[A].length,this.c[A-s.start]=d+1,d++;this.b=new Int32Array(d);let f=0;for(let A=s.start;A<s.endExclusive;A++){const b=r[A];for(let h=0;h<b.length;h++)this.b[f+h]=b.charCodeAt(h);f+=b.length,A<r.length-1&&(this.b[f]=`
`.charCodeAt(0),f+=1)}}get text(){return[...this.b].map(r=>String.fromCharCode(r)).join("")}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=m(r>0?this.b[r-1]:-1),d=m(r<this.b.length?this.b[r]:-1);if(s===6&&d===7)return 0;let f=0;return s!==d&&(f+=10,d===1&&(f+=1)),f+=v(s),f+=v(d),f}translateOffset(r){let s=0,d=this.c.length;for(;s<d;){const A=Math.floor((s+d)/2);this.c[A]>r?d=A:s=A+1}const f=s===0?0:this.c[s-1];return new T.Position(s+1,r-f+1)}translateRange(r){return i.Range.fromPositions(this.translateOffset(r.start),this.translateOffset(r.endExclusive))}}var D;(function(c){c[c.WordLower=0]="WordLower",c[c.WordUpper=1]="WordUpper",c[c.WordNumber=2]="WordNumber",c[c.End=3]="End",c[c.Other=4]="Other",c[c.Space=5]="Space",c[c.LineBreakCR=6]="LineBreakCR",c[c.LineBreakLF=7]="LineBreakLF"})(D||(D={}));const _={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function v(c){return _[c]}function m(c){return c===10?7:c===13?6:l(c)?5:c>=97&&c<=122?0:c>=65&&c<=90?1:c>=48&&c<=57?2:c===-1?3:4}function l(c){return c===32||c===9}}),J(Z[37],ee([0,1,18]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var T;(function(L){L[L.Invalid=0]="Invalid",L[L.Start=1]="Start",L[L.H=2]="H",L[L.HT=3]="HT",L[L.HTT=4]="HTT",L[L.HTTP=5]="HTTP",L[L.F=6]="F",L[L.FI=7]="FI",L[L.FIL=8]="FIL",L[L.BeforeColon=9]="BeforeColon",L[L.AfterColon=10]="AfterColon",L[L.AlmostThere=11]="AlmostThere",L[L.End=12]="End",L[L.Accept=13]="Accept",L[L.LastKnownState=14]="LastKnownState"})(T=t.State||(t.State={}));class i{constructor(e,E,D){const _=new Uint8Array(e*E);for(let v=0,m=e*E;v<m;v++)_[v]=D;this.a=_,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,D){this.a[e*this.cols+E]=D}}class u{constructor(e){let E=0,D=0;for(let v=0,m=e.length;v<m;v++){const[l,c,r]=e[v];c>E&&(E=c),l>D&&(D=l),r>D&&(D=r)}E++,D++;const _=new i(D,E,0);for(let v=0,m=e.length;v<m;v++){const[l,c,r]=e[v];_.set(l,c,r)}this.a=_,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.StateMachine=u;let y=null;function N(){return y===null&&(y=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var a;(function(L){L[L.None=0]="None",L[L.ForceTermination=1]="ForceTermination",L[L.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let g=null;function p(){if(g===null){g=new F.CharacterClassifier(0);const L=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<L.length;E++)g.set(L.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)g.set(e.charCodeAt(E),2)}return g}class R{static a(e,E,D,_,v){let m=v-1;do{const l=E.charCodeAt(m);if(e.get(l)!==2)break;m--}while(m>_);if(_>0){const l=E.charCodeAt(_-1),c=E.charCodeAt(m);(l===40&&c===41||l===91&&c===93||l===123&&c===125)&&m--}return{range:{startLineNumber:D,startColumn:_+1,endLineNumber:D,endColumn:m+2},url:E.substring(_,m+1)}}static computeLinks(e,E=N()){const D=p(),_=[];for(let v=1,m=e.getLineCount();v<=m;v++){const l=e.getLineContent(v),c=l.length;let r=0,s=0,d=0,f=1,A=!1,b=!1,h=!1,o=!1;for(;r<c;){let M=!1;const U=l.charCodeAt(r);if(f===13){let C;switch(U){case 40:A=!0,C=0;break;case 41:C=A?0:1;break;case 91:h=!0,b=!0,C=0;break;case 93:h=!1,C=b?0:1;break;case 123:o=!0,C=0;break;case 125:C=o?0:1;break;case 39:case 34:case 96:d===U?C=1:d===39||d===34||d===96?C=0:C=1;break;case 42:C=d===42?1:0;break;case 124:C=d===124?1:0;break;case 32:C=h?0:1;break;default:C=D.get(U)}C===1&&(_.push(R.a(D,l,v,s,r)),M=!0)}else if(f===12){let C;U===91?(b=!0,C=0):C=D.get(U),C===1?M=!0:f=13}else f=E.nextState(f,U),f===0&&(M=!0);M&&(f=1,A=!1,b=!1,o=!1,s=r+1,d=U),r++}f===13&&_.push(R.a(D,l,v,s,c))}return _}}t.LinkComputer=R;function w(L){return!L||typeof L.getLineCount!="function"||typeof L.getLineContent!="function"?[]:R.computeLinks(L)}t.computeLinks=w}),J(Z[38],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,y,N,a){if(i&&u){const g=this.a(u,a);if(g)return{range:i,value:g}}if(y&&N){const g=this.a(N,a);if(g)return{range:y,value:g}}return null}a(i,u){const y=this.b(i,u);return y!==null?y:this.d(i,u)}b(i,u){const y=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let N=Number(i);const a=parseFloat(i);return!isNaN(N)&&!isNaN(a)&&N===a?N===0&&!u?null:(N=Math.floor(N*y),N+=u?y:-y,String(N/y)):null}d(i,u){return this.e(this.c,i,u)}e(i,u,y){let N=null;for(let a=0,g=i.length;N===null&&a<g;a++)N=this.f(i[a],u,y);return N}f(i,u,y){let N=i.indexOf(u);return N>=0?(N+=y?1:-1,N<0?N=i.length-1:N%=i.length,i[N]):null}}F.INSTANCE=new F,t.BasicInplaceReplace=F}),J(Z[39],ee([0,1,11]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T=t.OverviewRulerLane||(t.OverviewRulerLane={}));var i;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(i=t.MinimapPosition||(t.MinimapPosition={}));var u;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(u=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var y;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(y=t.EndOfLinePreference||(t.EndOfLinePreference={}));var N;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(N=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var a;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(a=t.EndOfLineSequence||(t.EndOfLineSequence={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,F.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}t.TextModelResolvedOptions=g;class p{constructor(l,c){this._findMatchBrand=void 0,this.range=l,this.matches=c}}t.FindMatch=p;var R;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));function w(m){return m&&typeof m.read=="function"}t.isITextSnapshot=w;var L;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(L=t.PositionAffinity||(t.PositionAffinity={}));var e;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=t.ModelConstants||(t.ModelConstants={}));class E{constructor(l,c,r,s,d,f){this.identifier=l,this.range=c,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=f}}t.ValidAnnotatedEditOperation=E;class D{constructor(l,c,r){this.regex=l,this.wordSeparators=c,this.simpleSearch=r}}t.SearchData=D;class _{constructor(l,c,r){this.reverseEdits=l,this.changes=c,this.trimAutoWhitespaceLineNumbers=r}}t.ApplyEditsResult=_;function v(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}t.shouldSynchronizeModel=v}),J(Z[40],ee([0,1,26,17]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,g){a=(0,T.toUint32)(a);const p=this.a,R=this.b,w=g.length;return w===0?!1:(this.a=new Uint32Array(p.length+w),this.a.set(p.subarray(0,a),0),this.a.set(p.subarray(a),a+w),this.a.set(g,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}setValue(a,g){return a=(0,T.toUint32)(a),g=(0,T.toUint32)(g),this.a[a]===g?!1:(this.a[a]=g,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,g){a=(0,T.toUint32)(a),g=(0,T.toUint32)(g);const p=this.a,R=this.b;if(a>=p.length)return!1;const w=p.length-a;return g>=w&&(g=w),g===0?!1:(this.a=new Uint32Array(p.length-g),this.a.set(p.subarray(0,a),0),this.a.set(p.subarray(a+g),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,T.toUint32)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),a>=this.a.length&&(a=this.a.length-1);for(let p=g;p<=a;p++)this.b[p]=this.b[p-1]+this.a[p];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let g=0,p=this.a.length-1,R=0,w=0,L=0;for(;g<=p;)if(R=g+(p-g)/2|0,w=this.b[R],L=w-this.a[R],a<L)p=R-1;else if(a>=w)g=R+1;else break;return new y(R,a-L)}}t.PrefixSumComputer=i;class u{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const g=this.e[a],p=g>0?this.d[g-1]:0;return new y(g,a-p)}removeValues(a,g){this.a.splice(a,g),this.f(a)}insertValues(a,g){this.a=(0,F.arrayInsert)(this.a,a,g),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,g=this.a.length;a<g;a++){const p=this.a[a],R=a>0?this.d[a-1]:0;this.d[a]=R+p;for(let w=0;w<p;w++)this.e[R+w]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,g){this.a[a]!==g&&(this.a[a]=g,this.f(a))}}t.ConstantTimePrefixSumComputer=u;class y{constructor(a,g){this.index=a,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=g}}t.PrefixSumIndexOfResult=y}),J(Z[41],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F=t.AccessibilitySupport||(t.AccessibilitySupport={}));var T;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(T=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u=t.CompletionItemKind||(t.CompletionItemKind={}));var y;(function(n){n[n.Deprecated=1]="Deprecated"})(y=t.CompletionItemTag||(t.CompletionItemTag={}));var N;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var g;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(g=t.CursorChangeReason||(t.CursorChangeReason={}));var p;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(p=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var R;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(R=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var L;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.colorDecoratorsLimit=18]="colorDecoratorsLimit",n[n.columnSelection=19]="columnSelection",n[n.comments=20]="comments",n[n.contextmenu=21]="contextmenu",n[n.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",n[n.cursorBlinking=23]="cursorBlinking",n[n.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",n[n.cursorStyle=25]="cursorStyle",n[n.cursorSurroundingLines=26]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",n[n.cursorWidth=28]="cursorWidth",n[n.disableLayerHinting=29]="disableLayerHinting",n[n.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",n[n.domReadOnly=31]="domReadOnly",n[n.dragAndDrop=32]="dragAndDrop",n[n.dropIntoEditor=33]="dropIntoEditor",n[n.emptySelectionClipboard=34]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",n[n.extraEditorClassName=36]="extraEditorClassName",n[n.fastScrollSensitivity=37]="fastScrollSensitivity",n[n.find=38]="find",n[n.fixedOverflowWidgets=39]="fixedOverflowWidgets",n[n.folding=40]="folding",n[n.foldingStrategy=41]="foldingStrategy",n[n.foldingHighlight=42]="foldingHighlight",n[n.foldingImportsByDefault=43]="foldingImportsByDefault",n[n.foldingMaximumRegions=44]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=46]="fontFamily",n[n.fontInfo=47]="fontInfo",n[n.fontLigatures=48]="fontLigatures",n[n.fontSize=49]="fontSize",n[n.fontWeight=50]="fontWeight",n[n.fontVariations=51]="fontVariations",n[n.formatOnPaste=52]="formatOnPaste",n[n.formatOnType=53]="formatOnType",n[n.glyphMargin=54]="glyphMargin",n[n.gotoLocation=55]="gotoLocation",n[n.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",n[n.hover=57]="hover",n[n.inDiffEditor=58]="inDiffEditor",n[n.inlineSuggest=59]="inlineSuggest",n[n.letterSpacing=60]="letterSpacing",n[n.lightbulb=61]="lightbulb",n[n.lineDecorationsWidth=62]="lineDecorationsWidth",n[n.lineHeight=63]="lineHeight",n[n.lineNumbers=64]="lineNumbers",n[n.lineNumbersMinChars=65]="lineNumbersMinChars",n[n.linkedEditing=66]="linkedEditing",n[n.links=67]="links",n[n.matchBrackets=68]="matchBrackets",n[n.minimap=69]="minimap",n[n.mouseStyle=70]="mouseStyle",n[n.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=72]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",n[n.multiCursorModifier=74]="multiCursorModifier",n[n.multiCursorPaste=75]="multiCursorPaste",n[n.multiCursorLimit=76]="multiCursorLimit",n[n.occurrencesHighlight=77]="occurrencesHighlight",n[n.overviewRulerBorder=78]="overviewRulerBorder",n[n.overviewRulerLanes=79]="overviewRulerLanes",n[n.padding=80]="padding",n[n.parameterHints=81]="parameterHints",n[n.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",n[n.quickSuggestions=84]="quickSuggestions",n[n.quickSuggestionsDelay=85]="quickSuggestionsDelay",n[n.readOnly=86]="readOnly",n[n.renameOnType=87]="renameOnType",n[n.renderControlCharacters=88]="renderControlCharacters",n[n.renderFinalNewline=89]="renderFinalNewline",n[n.renderLineHighlight=90]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=92]="renderValidationDecorations",n[n.renderWhitespace=93]="renderWhitespace",n[n.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",n[n.roundedSelection=95]="roundedSelection",n[n.rulers=96]="rulers",n[n.scrollbar=97]="scrollbar",n[n.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=99]="scrollBeyondLastLine",n[n.scrollPredominantAxis=100]="scrollPredominantAxis",n[n.selectionClipboard=101]="selectionClipboard",n[n.selectionHighlight=102]="selectionHighlight",n[n.selectOnLineNumbers=103]="selectOnLineNumbers",n[n.showFoldingControls=104]="showFoldingControls",n[n.showUnused=105]="showUnused",n[n.snippetSuggestions=106]="snippetSuggestions",n[n.smartSelect=107]="smartSelect",n[n.smoothScrolling=108]="smoothScrolling",n[n.stickyScroll=109]="stickyScroll",n[n.stickyTabStops=110]="stickyTabStops",n[n.stopRenderingLineAfter=111]="stopRenderingLineAfter",n[n.suggest=112]="suggest",n[n.suggestFontSize=113]="suggestFontSize",n[n.suggestLineHeight=114]="suggestLineHeight",n[n.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",n[n.suggestSelection=116]="suggestSelection",n[n.tabCompletion=117]="tabCompletion",n[n.tabIndex=118]="tabIndex",n[n.unicodeHighlighting=119]="unicodeHighlighting",n[n.unusualLineTerminators=120]="unusualLineTerminators",n[n.useShadowDOM=121]="useShadowDOM",n[n.useTabStops=122]="useTabStops",n[n.wordBreak=123]="wordBreak",n[n.wordSeparators=124]="wordSeparators",n[n.wordWrap=125]="wordWrap",n[n.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=128]="wordWrapColumn",n[n.wordWrapOverride1=129]="wordWrapOverride1",n[n.wordWrapOverride2=130]="wordWrapOverride2",n[n.wrappingIndent=131]="wrappingIndent",n[n.wrappingStrategy=132]="wrappingStrategy",n[n.showDeprecated=133]="showDeprecated",n[n.inlayHints=134]="inlayHints",n[n.editorClassName=135]="editorClassName",n[n.pixelRatio=136]="pixelRatio",n[n.tabFocusMode=137]="tabFocusMode",n[n.layoutInfo=138]="layoutInfo",n[n.wrappingInfo=139]="wrappingInfo"})(L=t.EditorOption||(t.EditorOption={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e=t.EndOfLinePreference||(t.EndOfLinePreference={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E=t.EndOfLineSequence||(t.EndOfLineSequence={}));var D;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(D=t.IndentAction||(t.IndentAction={}));var _;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(_=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var v;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(v=t.InlayHintKind||(t.InlayHintKind={}));var m;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(m=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var l;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(l=t.KeyCode||(t.KeyCode={}));var c;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(c=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d=t.MouseTargetType||(t.MouseTargetType={}));var f;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(f=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var A;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(A=t.OverviewRulerLane||(t.OverviewRulerLane={}));var b;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(b=t.PositionAffinity||(t.PositionAffinity={}));var h;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(h=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var o;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(o=t.RenderMinimap||(t.RenderMinimap={}));var M;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(M=t.ScrollType||(t.ScrollType={}));var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var C;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));var B;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(B=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var V;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(V=t.SymbolKind||(t.SymbolKind={}));var z;(function(n){n[n.Deprecated=1]="Deprecated"})(z=t.SymbolTag||(t.SymbolTag={}));var x;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(x=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var ne;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(ne=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var Q;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Q=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var K;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(K=t.WrappingIndent||(t.WrappingIndent={}))}),J(Z[42],ee([55,56]),function(q,t){return q.create("vs/base/common/platform",t)}),J(Z[8],ee([0,1,42]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let T=!1,i=!1,u=!1,y=!1,N=!1,a=!1,g=!1,p=!1,R=!1,w=!1,L,e=t.LANGUAGE_DEFAULT,E,D;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?_=t.globals.vscode.process:typeof process<"u"&&(_=process);const v=typeof _?.versions?.electron=="string",m=v&&_?.type==="renderer";if(typeof navigator=="object"&&!m)D=navigator.userAgent,T=D.indexOf("Windows")>=0,i=D.indexOf("Macintosh")>=0,p=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=D.indexOf("Linux")>=0,w=D?.indexOf("Mobi")>=0,a=!0,L=F.getConfiguredDefaultLocale(F.localize(0,null))||t.LANGUAGE_DEFAULT,e=L;else if(typeof _=="object"){T=_.platform==="win32",i=_.platform==="darwin",u=_.platform==="linux",y=u&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,g=v,R=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,L=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const h=_.env.VSCODE_NLS_CONFIG;if(h)try{const o=JSON.parse(h),M=o.availableLanguages["*"];L=o.locale,e=M||t.LANGUAGE_DEFAULT,E=o._translationsConfigFile}catch{}N=!0}else console.error("Unable to resolve platform.");var l;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(l=t.Platform||(t.Platform={}));function c(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=c;let r=0;i?r=1:T?r=3:u&&(r=2),t.isWindows=T,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=y,t.isNative=N,t.isElectron=g,t.isWeb=a,t.isWebWorker=a&&typeof t.globals.importScripts=="function",t.isIOS=p,t.isMobile=w,t.isCI=R,t.platform=r,t.userAgent=D,t.language=e;var s;(function(h){function o(){return t.language}h.value=o;function M(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}h.isDefaultVariant=M;function U(){return t.language==="en"}h.isDefault=U})(s=t.Language||(t.Language={})),t.locale=L,t.translationsConfigFile=E,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const h=[];t.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let U=0,C=h.length;U<C;U++){const B=h[U];if(B.id===M.data.vscodeScheduleAsyncWork){h.splice(U,1),B.callback();return}}});let o=0;return M=>{const U=++o;h.push({id:U,callback:M}),t.globals.postMessage({vscodeScheduleAsyncWork:U},"*")}}return h=>setTimeout(h)})();var d;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(d=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||p?2:T?1:3;let f=!0,A=!1;function b(){if(!A){A=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,f=new Uint16Array(h.buffer)[0]===(2<<8)+1}return f}t.isLittleEndian=b,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),J(Z[43],ee([0,1,8]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let T;if(typeof F.globals.vscode<"u"&&typeof F.globals.vscode.process<"u"){const i=F.globals.vscode.process;T={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return F.isWindows?"win32":F.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.platform=T.platform,t.arch=T.arch}),J(Z[44],ee([0,1,43]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const T=65,i=97,u=90,y=122,N=46,a=47,g=92,p=58,R=63;class w extends Error{constructor(s,d,f){let A;typeof d=="string"&&d.indexOf("not ")===0?(A="must not be",d=d.replace(/^not /,"")):A="must be";const b=s.indexOf(".")!==-1?"property":"argument";let h=`The "${s}" ${b} ${A} of type ${d}`;h+=`. Received type ${typeof f}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function L(r,s){if(r===null||typeof r!="object")throw new w(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new w(s,"string",r)}const E=F.platform==="win32";function D(r){return r===a||r===g}function _(r){return r===a}function v(r){return r>=T&&r<=u||r>=i&&r<=y}function m(r,s,d,f){let A="",b=0,h=-1,o=0,M=0;for(let U=0;U<=r.length;++U){if(U<r.length)M=r.charCodeAt(U);else{if(f(M))break;M=a}if(f(M)){if(!(h===U-1||o===1))if(o===2){if(A.length<2||b!==2||A.charCodeAt(A.length-1)!==N||A.charCodeAt(A.length-2)!==N){if(A.length>2){const C=A.lastIndexOf(d);C===-1?(A="",b=0):(A=A.slice(0,C),b=A.length-1-A.lastIndexOf(d)),h=U,o=0;continue}else if(A.length!==0){A="",b=0,h=U,o=0;continue}}s&&(A+=A.length>0?`${d}..`:"..",b=2)}else A.length>0?A+=`${d}${r.slice(h+1,U)}`:A=r.slice(h+1,U),b=U-h-1;h=U,o=0}else M===N&&o!==-1?++o:o=-1}return A}function l(r,s){L(s,"pathObject");const d=s.dir||s.root,f=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${f}`:`${d}${r}${f}`:f}t.win32={resolve(...r){let s="",d="",f=!1;for(let A=r.length-1;A>=-1;A--){let b;if(A>=0){if(b=r[A],e(b,"path"),b.length===0)continue}else s.length===0?b=F.cwd():(b=F.env[`=${s}`]||F.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==s.toLowerCase()&&b.charCodeAt(2)===g)&&(b=`${s}\\`));const h=b.length;let o=0,M="",U=!1;const C=b.charCodeAt(0);if(h===1)D(C)&&(o=1,U=!0);else if(D(C))if(U=!0,D(b.charCodeAt(1))){let B=2,V=B;for(;B<h&&!D(b.charCodeAt(B));)B++;if(B<h&&B!==V){const z=b.slice(V,B);for(V=B;B<h&&D(b.charCodeAt(B));)B++;if(B<h&&B!==V){for(V=B;B<h&&!D(b.charCodeAt(B));)B++;(B===h||B!==V)&&(M=`\\\\${z}\\${b.slice(V,B)}`,o=B)}}}else o=1;else v(C)&&b.charCodeAt(1)===p&&(M=b.slice(0,2),o=2,h>2&&D(b.charCodeAt(2))&&(U=!0,o=3));if(M.length>0)if(s.length>0){if(M.toLowerCase()!==s.toLowerCase())continue}else s=M;if(f){if(s.length>0)break}else if(d=`${b.slice(o)}\\${d}`,f=U,U&&s.length>0)break}return d=m(d,!f,"\\",D),f?`${s}\\${d}`:`${s}${d}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let d=0,f,A=!1;const b=r.charCodeAt(0);if(s===1)return _(b)?"\\":r;if(D(b))if(A=!0,D(r.charCodeAt(1))){let o=2,M=o;for(;o<s&&!D(r.charCodeAt(o));)o++;if(o<s&&o!==M){const U=r.slice(M,o);for(M=o;o<s&&D(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&!D(r.charCodeAt(o));)o++;if(o===s)return`\\\\${U}\\${r.slice(M)}\\`;o!==M&&(f=`\\\\${U}\\${r.slice(M,o)}`,d=o)}}}else d=1;else v(b)&&r.charCodeAt(1)===p&&(f=r.slice(0,2),d=2,s>2&&D(r.charCodeAt(2))&&(A=!0,d=3));let h=d<s?m(r.slice(d),!A,"\\",D):"";return h.length===0&&!A&&(h="."),h.length>0&&D(r.charCodeAt(s-1))&&(h+="\\"),f===void 0?A?`\\${h}`:h:A?`${f}\\${h}`:`${f}${h}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const d=r.charCodeAt(0);return D(d)||s>2&&v(d)&&r.charCodeAt(1)===p&&D(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,d;for(let b=0;b<r.length;++b){const h=r[b];e(h,"path"),h.length>0&&(s===void 0?s=d=h:s+=`\\${h}`)}if(s===void 0)return".";let f=!0,A=0;if(typeof d=="string"&&D(d.charCodeAt(0))){++A;const b=d.length;b>1&&D(d.charCodeAt(1))&&(++A,b>2&&(D(d.charCodeAt(2))?++A:f=!1))}if(f){for(;A<s.length&&D(s.charCodeAt(A));)A++;A>=2&&(s=`\\${s.slice(A)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const d=t.win32.resolve(r),f=t.win32.resolve(s);if(d===f||(r=d.toLowerCase(),s=f.toLowerCase(),r===s))return"";let A=0;for(;A<r.length&&r.charCodeAt(A)===g;)A++;let b=r.length;for(;b-1>A&&r.charCodeAt(b-1)===g;)b--;const h=b-A;let o=0;for(;o<s.length&&s.charCodeAt(o)===g;)o++;let M=s.length;for(;M-1>o&&s.charCodeAt(M-1)===g;)M--;const U=M-o,C=h<U?h:U;let B=-1,V=0;for(;V<C;V++){const x=r.charCodeAt(A+V);if(x!==s.charCodeAt(o+V))break;x===g&&(B=V)}if(V!==C){if(B===-1)return f}else{if(U>C){if(s.charCodeAt(o+V)===g)return f.slice(o+V+1);if(V===2)return f.slice(o+V)}h>C&&(r.charCodeAt(A+V)===g?B=V:V===2&&(B=3)),B===-1&&(B=0)}let z="";for(V=A+B+1;V<=b;++V)(V===b||r.charCodeAt(V)===g)&&(z+=z.length===0?"..":"\\..");return o+=B,z.length>0?`${z}${f.slice(o,M)}`:(f.charCodeAt(o)===g&&++o,f.slice(o,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const d=s.charCodeAt(2);if(d!==R&&d!==N)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(v(s.charCodeAt(0))&&s.charCodeAt(1)===p&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let d=-1,f=0;const A=r.charCodeAt(0);if(s===1)return D(A)?r:".";if(D(A)){if(d=f=1,D(r.charCodeAt(1))){let o=2,M=o;for(;o<s&&!D(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&D(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&!D(r.charCodeAt(o));)o++;if(o===s)return r;o!==M&&(d=f=o+1)}}}}else v(A)&&r.charCodeAt(1)===p&&(d=s>2&&D(r.charCodeAt(2))?3:2,f=d);let b=-1,h=!0;for(let o=s-1;o>=f;--o)if(D(r.charCodeAt(o))){if(!h){b=o;break}}else h=!1;if(b===-1){if(d===-1)return".";b=d}return r.slice(0,b)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,f=-1,A=!0,b;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===p&&(d=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let h=s.length-1,o=-1;for(b=r.length-1;b>=d;--b){const M=r.charCodeAt(b);if(D(M)){if(!A){d=b+1;break}}else o===-1&&(A=!1,o=b+1),h>=0&&(M===s.charCodeAt(h)?--h===-1&&(f=b):(h=-1,f=o))}return d===f?f=o:f===-1&&(f=r.length),r.slice(d,f)}for(b=r.length-1;b>=d;--b)if(D(r.charCodeAt(b))){if(!A){d=b+1;break}}else f===-1&&(A=!1,f=b+1);return f===-1?"":r.slice(d,f)},extname(r){e(r,"path");let s=0,d=-1,f=0,A=-1,b=!0,h=0;r.length>=2&&r.charCodeAt(1)===p&&v(r.charCodeAt(0))&&(s=f=2);for(let o=r.length-1;o>=s;--o){const M=r.charCodeAt(o);if(D(M)){if(!b){f=o+1;break}continue}A===-1&&(b=!1,A=o+1),M===N?d===-1?d=o:h!==1&&(h=1):d!==-1&&(h=-1)}return d===-1||A===-1||h===0||h===1&&d===A-1&&d===f+1?"":r.slice(d,A)},format:l.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.length;let f=0,A=r.charCodeAt(0);if(d===1)return D(A)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(D(A)){if(f=1,D(r.charCodeAt(1))){let B=2,V=B;for(;B<d&&!D(r.charCodeAt(B));)B++;if(B<d&&B!==V){for(V=B;B<d&&D(r.charCodeAt(B));)B++;if(B<d&&B!==V){for(V=B;B<d&&!D(r.charCodeAt(B));)B++;B===d?f=B:B!==V&&(f=B+1)}}}}else if(v(A)&&r.charCodeAt(1)===p){if(d<=2)return s.root=s.dir=r,s;if(f=2,D(r.charCodeAt(2))){if(d===3)return s.root=s.dir=r,s;f=3}}f>0&&(s.root=r.slice(0,f));let b=-1,h=f,o=-1,M=!0,U=r.length-1,C=0;for(;U>=f;--U){if(A=r.charCodeAt(U),D(A)){if(!M){h=U+1;break}continue}o===-1&&(M=!1,o=U+1),A===N?b===-1?b=U:C!==1&&(C=1):b!==-1&&(C=-1)}return o!==-1&&(b===-1||C===0||C===1&&b===o-1&&b===h+1?s.base=s.name=r.slice(h,o):(s.name=r.slice(h,b),s.base=r.slice(h,o),s.ext=r.slice(b,o))),h>0&&h!==f?s.dir=r.slice(0,h-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const r=/\\/g;return()=>{const s=F.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>F.cwd()})();t.posix={resolve(...r){let s="",d=!1;for(let f=r.length-1;f>=-1&&!d;f--){const A=f>=0?r[f]:c();e(A,"path"),A.length!==0&&(s=`${A}/${s}`,d=A.charCodeAt(0)===a)}return s=m(s,!d,"/",_),d?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a,d=r.charCodeAt(r.length-1)===a;return r=m(r,!s,"/",_),r.length===0?s?"/":d?"./":".":(d&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let s;for(let d=0;d<r.length;++d){const f=r[d];e(f,"path"),f.length>0&&(s===void 0?s=f:s+=`/${f}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const d=1,f=r.length,A=f-d,b=1,h=s.length-b,o=A<h?A:h;let M=-1,U=0;for(;U<o;U++){const B=r.charCodeAt(d+U);if(B!==s.charCodeAt(b+U))break;B===a&&(M=U)}if(U===o)if(h>o){if(s.charCodeAt(b+U)===a)return s.slice(b+U+1);if(U===0)return s.slice(b+U)}else A>o&&(r.charCodeAt(d+U)===a?M=U:U===0&&(M=0));let C="";for(U=d+M+1;U<=f;++U)(U===f||r.charCodeAt(U)===a)&&(C+=C.length===0?"..":"/..");return`${C}${s.slice(b+M)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a;let d=-1,f=!0;for(let A=r.length-1;A>=1;--A)if(r.charCodeAt(A)===a){if(!f){d=A;break}}else f=!1;return d===-1?s?"/":".":s&&d===1?"//":r.slice(0,d)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,f=-1,A=!0,b;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let h=s.length-1,o=-1;for(b=r.length-1;b>=0;--b){const M=r.charCodeAt(b);if(M===a){if(!A){d=b+1;break}}else o===-1&&(A=!1,o=b+1),h>=0&&(M===s.charCodeAt(h)?--h===-1&&(f=b):(h=-1,f=o))}return d===f?f=o:f===-1&&(f=r.length),r.slice(d,f)}for(b=r.length-1;b>=0;--b)if(r.charCodeAt(b)===a){if(!A){d=b+1;break}}else f===-1&&(A=!1,f=b+1);return f===-1?"":r.slice(d,f)},extname(r){e(r,"path");let s=-1,d=0,f=-1,A=!0,b=0;for(let h=r.length-1;h>=0;--h){const o=r.charCodeAt(h);if(o===a){if(!A){d=h+1;break}continue}f===-1&&(A=!1,f=h+1),o===N?s===-1?s=h:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||f===-1||b===0||b===1&&s===f-1&&s===d+1?"":r.slice(s,f)},format:l.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.charCodeAt(0)===a;let f;d?(s.root="/",f=1):f=0;let A=-1,b=0,h=-1,o=!0,M=r.length-1,U=0;for(;M>=f;--M){const C=r.charCodeAt(M);if(C===a){if(!o){b=M+1;break}continue}h===-1&&(o=!1,h=M+1),C===N?A===-1?A=M:U!==1&&(U=1):A!==-1&&(U=-1)}if(h!==-1){const C=b===0&&d?1:b;A===-1||U===0||U===1&&A===h-1&&A===b+1?s.base=s.name=r.slice(C,h):(s.name=r.slice(C,A),s.base=r.slice(C,h),s.ext=r.slice(A,h))}return b>0?s.dir=r.slice(0,b-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E?t.win32.normalize:t.posix.normalize,t.isAbsolute=E?t.win32.isAbsolute:t.posix.isAbsolute,t.join=E?t.win32.join:t.posix.join,t.resolve=E?t.win32.resolve:t.posix.resolve,t.relative=E?t.win32.relative:t.posix.relative,t.dirname=E?t.win32.dirname:t.posix.dirname,t.basename=E?t.win32.basename:t.posix.basename,t.extname=E?t.win32.extname:t.posix.extname,t.format=E?t.win32.format:t.posix.format,t.parse=E?t.win32.parse:t.posix.parse,t.toNamespacedPath=E?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=E?t.win32.sep:t.posix.sep,t.delimiter=E?t.win32.delimiter:t.posix.delimiter}),J(Z[21],ee([0,1,8]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const T=F.globals.performance&&typeof F.globals.performance.now=="function";class i{static create(y=!0){return new i(y)}constructor(y){this.a=T&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?F.globals.performance.now():Date.now()}}t.StopWatch=i}),J(Z[9],ee([0,1,5,13,6,15,21]),function(q,t,F,T,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const N=!1,a=!1;var g;(function(b){b.None=()=>i.Disposable.None;function h(te){if(a){const{onDidAddListener:G}=te,Y=e.create();let k=0;te.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function o(te,G){return Q(te,()=>{},0,void 0,!0,void 0,G)}b.defer=o;function M(te){return(G,Y=null,k)=>{let S=!1,I;return I=te(W=>{if(!S)return I?I.dispose():S=!0,G.call(Y,W)},null,k),S&&I.dispose(),I}}b.once=M;function U(te,G,Y){return ne((k,S=null,I)=>te(W=>k.call(S,G(W)),null,I),Y)}b.map=U;function C(te,G,Y){return ne((k,S=null,I)=>te(W=>{G(W),k.call(S,W)},null,I),Y)}b.forEach=C;function B(te,G,Y){return ne((k,S=null,I)=>te(W=>G(W)&&k.call(S,W),null,I),Y)}b.filter=B;function V(te){return te}b.signal=V;function z(...te){return(G,Y=null,k)=>(0,i.combinedDisposable)(...te.map(S=>S(I=>G.call(Y,I),null,k)))}b.any=z;function x(te,G,Y,k){let S=Y;return U(te,I=>(S=G(S,I),S),k)}b.reduce=x;function ne(te,G){let Y;const k={onWillAddFirstListener(){Y=te(S.fire,S)},onDidRemoveLastListener(){Y?.dispose()}};G||h(k);const S=new D(k);return G?.add(S),S.event}function Q(te,G,Y=100,k=!1,S=!1,I,W){let j,ie,re,le=0,ae;const fe={leakWarningThreshold:I,onWillAddFirstListener(){j=te(ke=>{le++,ie=G(ie,ke),k&&!re&&(he.fire(ie),ie=void 0),ae=()=>{const Se=ie;ie=void 0,re=void 0,(!k||le>1)&&he.fire(Se),le=0},typeof Y=="number"?(clearTimeout(re),re=setTimeout(ae,Y)):re===void 0&&(re=0,queueMicrotask(ae))})},onWillRemoveListener(){S&&le>0&&ae?.()},onDidRemoveLastListener(){ae=void 0,j.dispose()}};W||h(fe);const he=new D(fe);return W?.add(he),he.event}b.debounce=Q;function K(te,G=0,Y){return b.debounce(te,(k,S)=>k?(k.push(S),k):[S],G,void 0,!0,void 0,Y)}b.accumulate=K;function n(te,G=(k,S)=>k===S,Y){let k=!0,S;return B(te,I=>{const W=k||!G(I,S);return k=!1,S=I,W},Y)}b.latch=n;function we(te,G,Y){return[b.filter(te,G,Y),b.filter(te,k=>!G(k),Y)]}b.split=we;function pe(te,G=!1,Y=[]){let k=Y.slice(),S=te(j=>{k?k.push(j):W.fire(j)});const I=()=>{k?.forEach(j=>W.fire(j)),k=null},W=new D({onWillAddFirstListener(){S||(S=te(j=>W.fire(j)))},onDidAddFirstListener(){k&&(G?setTimeout(I):I())},onDidRemoveLastListener(){S&&S.dispose(),S=null}});return W.event}b.buffer=pe;class de{constructor(G){this.event=G,this.c=new i.DisposableStore}map(G){return new de(U(this.event,G,this.c))}forEach(G){return new de(C(this.event,G,this.c))}filter(G){return new de(B(this.event,G,this.c))}reduce(G,Y){return new de(x(this.event,G,Y,this.c))}latch(){return new de(n(this.event,void 0,this.c))}debounce(G,Y=100,k=!1,S=!1,I){return new de(Q(this.event,G,Y,k,S,I,this.c))}on(G,Y,k){return this.event(G,Y,k)}once(G,Y,k){return M(this.event)(G,Y,k)}dispose(){this.c.dispose()}}function Ee(te){return new de(te)}b.chain=Ee;function ve(te,G,Y=k=>k){const k=(...j)=>W.fire(Y(...j)),S=()=>te.on(G,k),I=()=>te.removeListener(G,k),W=new D({onWillAddFirstListener:S,onDidRemoveLastListener:I});return W.event}b.fromNodeEventEmitter=ve;function Ne(te,G,Y=k=>k){const k=(...j)=>W.fire(Y(...j)),S=()=>te.addEventListener(G,k),I=()=>te.removeEventListener(G,k),W=new D({onWillAddFirstListener:S,onDidRemoveLastListener:I});return W.event}b.fromDOMEventEmitter=Ne;function Re(te){return new Promise(G=>M(te)(G))}b.toPromise=Re;function De(te,G){return G(void 0),te(Y=>G(Y))}b.runAndSubscribe=De;function Fe(te,G){let Y=null;function k(I){Y?.dispose(),Y=new i.DisposableStore,G(I,Y)}k(void 0);const S=te(I=>k(I));return(0,i.toDisposable)(()=>{S.dispose(),Y?.dispose()})}b.runAndSubscribeWithStore=Fe;class _e{constructor(G,Y){this.obs=G,this.c=0,this.d=!1;const k={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Y||h(k),this.emitter=new D(k),Y&&Y.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,Y){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Pe(te,G){return new _e(te,G).emitter.event}b.fromObservable=Pe})(g=t.Event||(t.Event={}));class p{constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${p.c++}`,p.all.add(this)}start(h){this.d=new y.StopWatch(!0),this.listenerCount=h}stop(){if(this.d){const h=this.d.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.d=void 0}}}p.all=new Set,p.c=0,t.EventProfiling=p;let R=-1;function w(b){const h=R;return R=b,{dispose(){R=h}}}t.setGlobalLeakWarningThreshold=w;class L{constructor(h,o=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=o,this.d=0}dispose(){this.c?.clear()}check(h,o){const M=this.threshold;if(M<=0||o<M)return;this.c||(this.c=new Map);const U=this.c.get(h.value)||0;if(this.c.set(h.value,U+1),this.d-=1,this.d<=0){this.d=M*.5;let C,B=0;for(const[V,z]of this.c)(!C||B<z)&&(C=V,B=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${B}):`),console.warn(C)}return()=>{const C=this.c.get(h.value)||0;this.c.set(h.value,C-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(h,o,M){this.callback=h,this.callbackThis=o,this.stack=M,this.subscription=new i.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class D{constructor(h){this.j=!1,this.d=h,this.f=R>0||this.d?.leakWarningThreshold?new L(this.d?.leakWarningThreshold??R):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(N){const h=Array.from(this.q);queueMicrotask(()=>{for(const o of h)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(h,o,M)=>{if(this.q||(this.q=new u.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const U=this.q.isEmpty();U&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let C,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=e.create(),C=this.f.check(B,this.q.size+1)),N&&(B=B??e.create());const V=new E(h,o,B),z=this.q.push(V);U&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,h,o);const x=V.subscription.set(()=>{C?.(),this.j||(this.d?.onWillRemoveListener?.(this),z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof i.DisposableStore?M.add(x):Array.isArray(M)&&M.push(x),x}),this.l}fire(h){if(this.q){this.m||(this.m=new v(this.d?.onListenerError));for(const o of this.q)this.m.push(this,o,h);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=D;class _{constructor(h=F.onUnexpectedError){this.d=h,this.c=new u.LinkedList}get size(){return this.c.size}push(h,o,M){this.c.push(new m(h,o,M))}clear(h){const o=new u.LinkedList;for(const M of this.c)M.emitter!==h&&o.push(M);this.c=o}deliver(){for(;this.c.size>0;){const h=this.c.shift();try{h.listener.invoke(h.event)}catch(o){this.d(o)}}}}t.EventDeliveryQueue=_;class v extends _{clear(h){this.c.clear()}}class m{constructor(h,o,M){this.emitter=h,this.listener=o,this.event=M}}class l extends D{async fireAsync(h,o,M){if(!!this.q){this.c||(this.c=new u.LinkedList);for(const U of this.q)this.c.push([U,h]);for(;this.c.size>0&&!o.isCancellationRequested;){const[U,C]=this.c.shift(),B=[],V={...C,token:o,waitUntil:z=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");M&&(z=M(z,U.callback)),B.push(z)}};try{U.invoke(V)}catch(z){(0,F.onUnexpectedError)(z);continue}Object.freeze(B),await Promise.allSettled(B).then(z=>{for(const x of z)x.status==="rejected"&&(0,F.onUnexpectedError)(x.reason)})}}}}t.AsyncEmitter=l;class c extends D{constructor(h){super(h),this.h=0,this.s=new u.LinkedList,this.t=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.t(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.q&&(this.h!==0?this.s.push(h):super.fire(h))}}t.PauseableEmitter=c;class r extends c{constructor(h){super(h),this.c=h.delay??100}fire(h){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(h)}}t.DebounceEmitter=r;class s extends D{constructor(h){super(h),this.c=[],this.h=h?.merge}fire(h){!this.hasListeners()||(this.c.push(h),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(o=>super.fire(o)),this.c=[]}))}}t.MicrotaskEmitter=s;class d{constructor(){this.d=!1,this.f=[],this.c=new D({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(h){const o={event:h,listener:null};this.f.push(o),this.d&&this.j(o);const M=()=>{this.d&&this.k(o);const U=this.f.indexOf(o);this.f.splice(U,1)};return(0,i.toDisposable)((0,T.once)(M))}g(){this.d=!0,this.f.forEach(h=>this.j(h))}h(){this.d=!1,this.f.forEach(h=>this.k(h))}j(h){h.listener=h.event(o=>this.c.fire(o))}k(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=d;class f{constructor(){this.c=[]}wrapEvent(h){return(o,M,U)=>h(C=>{const B=this.c[this.c.length-1];B?B.push(()=>o.call(M,C)):o.call(M,C)},void 0,U)}bufferEvents(h){const o=[];this.c.push(o);const M=h();return this.c.pop(),o.forEach(U=>U()),M}}t.EventBufferer=f;class A{constructor(){this.c=!1,this.d=g.None,this.f=i.Disposable.None,this.g=new D({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(h){this.d=h,this.c&&(this.f.dispose(),this.f=h(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=A}),J(Z[22],ee([0,1,9]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const T=Object.freeze(function(N,a){const g=setTimeout(N.bind(a),0);return{dispose(){clearTimeout(g)}}});var i;(function(N){function a(g){return g===N.None||g===N.Cancelled||g instanceof u?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}N.isCancellationToken=a,N.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),N.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i=t.CancellationToken||(t.CancellationToken={}));class u{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new F.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(a){this.a=void 0,this.b=void 0,this.b=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new u),this.a}cancel(){this.a?this.a instanceof u&&this.a.cancel():this.a=i.Cancelled}dispose(a=!1){a&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof u&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=y}),J(Z[45],ee([0,1,22]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class T{constructor(N){this.b=N,this.a=null}get(){if(this.a)return this.a;const N=new F.CancellationTokenSource,a=this.b(N.token);return this.a={promise:a,dispose:()=>{this.a=null,N.cancel(),N.dispose()}},this.a}}t.Cache=T;class i{constructor(N){this.c=N,this.a=void 0,this.b=void 0}get(N){const a=JSON.stringify(N);return this.b!==a&&(this.b=a,this.a=this.c(N)),this.a}}t.LRUCachedFunction=i;class u{get cachedValues(){return this.a}constructor(N){this.b=N,this.a=new Map}get(N){if(this.a.has(N))return this.a.get(N);const a=this.b(N);return this.a.set(N,a),a}}t.CachedFunction=u}),J(Z[4],ee([0,1,45,28]),function(q,t,F,T){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(P){return!P||typeof P!="string"?!0:P.trim().length===0}t.isFalsyOrWhitespace=u;const y=/{(\d+)}/g;function N(P,...O){return O.length===0?P:P.replace(y,function(H,$){const X=parseInt($,10);return isNaN(X)||X<0||X>=O.length?H:O[X]})}t.format=N;const a=/{([^}]+)}/g;function g(P,O){return P.replace(a,(H,$)=>O[$]??H)}t.format2=g;function p(P){return P.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}t.escape=p;function R(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=R;function w(P,O){let H=0;const $=O.charCodeAt(0);for(let X=P.length-1;X>=0;X--)P.charCodeAt(X)===$&&H++;return H}t.count=w;function L(P,O,H="\u2026"){return P.length<=O?P:`${P.substr(0,O)}${H}`}t.truncate=L;function e(P,O=" "){const H=E(P,O);return D(H,O)}t.trim=e;function E(P,O){if(!P||!O)return P;const H=O.length;if(H===0||P.length===0)return P;let $=0;for(;P.indexOf(O,$)===$;)$=$+H;return P.substring($)}t.ltrim=E;function D(P,O){if(!P||!O)return P;const H=O.length,$=P.length;if(H===0||$===0)return P;let X=$,se=-1;for(;se=P.lastIndexOf(O,X-1),!(se===-1||se+H!==X);){if(se===0)return"";X=se}return P.substring(0,X)}t.rtrim=D;function _(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function v(P){return P.replace(/\*/g,"")}t.stripWildcards=v;function m(P,O,H={}){if(!P)throw new Error("Cannot create regex from empty string");O||(P=R(P)),H.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let $="";return H.global&&($+="g"),H.matchCase||($+="i"),H.multiline&&($+="m"),H.unicode&&($+="u"),new RegExp(P,$)}t.createRegExp=m;function l(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}t.regExpLeadsToEndlessLoop=l;function c(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=c;function r(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}t.regExpFlags=r;function s(P){return P.split(/\r\n|\r|\n/)}t.splitLines=s;function d(P){for(let O=0,H=P.length;O<H;O++){const $=P.charCodeAt(O);if($!==32&&$!==9)return O}return-1}t.firstNonWhitespaceIndex=d;function f(P,O=0,H=P.length){for(let $=O;$<H;$++){const X=P.charCodeAt($);if(X!==32&&X!==9)return P.substring(O,$)}return P.substring(O,H)}t.getLeadingWhitespace=f;function A(P,O=P.length-1){for(let H=O;H>=0;H--){const $=P.charCodeAt(H);if($!==32&&$!==9)return H}return-1}t.lastNonWhitespaceIndex=A;function b(P,O,H){const $=[];let X=0;for(const se of P.matchAll(O)){if($.push(P.slice(X,se.index)),se.index===void 0)throw new Error("match.index should be defined");X=se.index+se[0].length,$.push(H(se[0],...se.slice(1),se.index,P,se.groups))}return $.push(P.slice(X)),Promise.all($).then(se=>se.join(""))}t.replaceAsync=b;function h(P,O){return P<O?-1:P>O?1:0}t.compare=h;function o(P,O,H=0,$=P.length,X=0,se=O.length){for(;H<$&&X<se;H++,X++){const be=P.charCodeAt(H),ue=O.charCodeAt(X);if(be<ue)return-1;if(be>ue)return 1}const ce=$-H,ye=se-X;return ce<ye?-1:ce>ye?1:0}t.compareSubstring=o;function M(P,O){return U(P,O,0,P.length,0,O.length)}t.compareIgnoreCase=M;function U(P,O,H=0,$=P.length,X=0,se=O.length){for(;H<$&&X<se;H++,X++){let be=P.charCodeAt(H),ue=O.charCodeAt(X);if(be===ue)continue;if(be>=128||ue>=128)return o(P.toLowerCase(),O.toLowerCase(),H,$,X,se);B(be)&&(be-=32),B(ue)&&(ue-=32);const ge=be-ue;if(ge!==0)return ge}const ce=$-H,ye=se-X;return ce<ye?-1:ce>ye?1:0}t.compareSubstringIgnoreCase=U;function C(P){return P>=48&&P<=57}t.isAsciiDigit=C;function B(P){return P>=97&&P<=122}t.isLowerAsciiLetter=B;function V(P){return P>=65&&P<=90}t.isUpperAsciiLetter=V;function z(P,O){return P.length===O.length&&U(P,O)===0}t.equalsIgnoreCase=z;function x(P,O){const H=O.length;return O.length>P.length?!1:U(P,O,0,H)===0}t.startsWithIgnoreCase=x;function ne(P,O){const H=Math.min(P.length,O.length);let $;for($=0;$<H;$++)if(P.charCodeAt($)!==O.charCodeAt($))return $;return H}t.commonPrefixLength=ne;function Q(P,O){const H=Math.min(P.length,O.length);let $;const X=P.length-1,se=O.length-1;for($=0;$<H;$++)if(P.charCodeAt(X-$)!==O.charCodeAt(se-$))return $;return H}t.commonSuffixLength=Q;function K(P){return 55296<=P&&P<=56319}t.isHighSurrogate=K;function n(P){return 56320<=P&&P<=57343}t.isLowSurrogate=n;function we(P,O){return(P-55296<<10)+(O-56320)+65536}t.computeCodePoint=we;function pe(P,O,H){const $=P.charCodeAt(H);if(K($)&&H+1<O){const X=P.charCodeAt(H+1);if(n(X))return we($,X)}return $}t.getNextCodePoint=pe;function de(P,O){const H=P.charCodeAt(O-1);if(n(H)&&O>1){const $=P.charCodeAt(O-2);if(K($))return we($,H)}return H}class Ee{get offset(){return this.e}constructor(O,H=0){this.c=O,this.d=O.length,this.e=H}setOffset(O){this.e=O}prevCodePoint(){const O=de(this.c,this.e);return this.e-=O>=65536?2:1,O}nextCodePoint(){const O=pe(this.c,this.d,this.e);return this.e+=O>=65536?2:1,O}eol(){return this.e>=this.d}}t.CodePointIterator=Ee;class ve{get offset(){return this.c.offset}constructor(O,H=0){this.c=new Ee(O,H)}nextGraphemeLength(){const O=Ae.getInstance(),H=this.c,$=H.offset;let X=O.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const se=H.offset,ce=O.getGraphemeBreakType(H.nextCodePoint());if(Ue(X,ce)){H.setOffset(se);break}X=ce}return H.offset-$}prevGraphemeLength(){const O=Ae.getInstance(),H=this.c,$=H.offset;let X=O.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const se=H.offset,ce=O.getGraphemeBreakType(H.prevCodePoint());if(Ue(ce,X)){H.setOffset(se);break}X=ce}return $-H.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ve;function Ne(P,O){return new ve(P,O).nextGraphemeLength()}t.nextCharLength=Ne;function Re(P,O){return new ve(P,O).prevGraphemeLength()}t.prevCharLength=Re;function De(P,O){O>0&&n(P.charCodeAt(O))&&O--;const H=O+Ne(P,O);return[H-Re(P,H),H]}t.getCharContainingOffset=De;function Fe(P){const O=new ve(P);let H=0;for(;!O.eol();)H++,O.nextGraphemeLength();return H}t.charCount=Fe;let _e;function Pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(P){return _e||(_e=Pe()),_e.test(P)}t.containsRTL=te;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(P){return G.test(P)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(P){return t.UNUSUAL_LINE_TERMINATORS.test(P)}t.containsUnusualLineTerminators=k;function S(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}t.isFullWidthCharacter=S;function I(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}t.isEmojiImprecise=I;function W(P,O){if(P.length<O)return P;const H=/\b/g;let $=0;for(;H.test(P)&&!(P.length-H.lastIndex<O);)$=H.lastIndex,H.lastIndex+=1;return P.substring($).replace(/^\s/,"")}t.lcut=W;const j=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ie(P){return P&&(P=P.replace(j,"")),P}t.removeAnsiEscapeCodes=ie,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function re(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}t.startsWithUTF8BOM=re;function le(P){return re(P)?P.substr(1):P}t.stripUTF8BOM=le;function ae(P,O){if(!P||!O||P.length<O.length)return!1;const H=O.length,$=P.toLowerCase();let X=0,se=-1;for(;X<H;){const ce=$.indexOf(O[X],se+1);if(ce<0)return!1;se=ce,X++}return!0}t.fuzzyContains=ae;function fe(P,O=!1){return P?(O&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}t.containsUppercaseCharacter=fe;function he(P){return P.charAt(0).toUpperCase()+P.slice(1)}t.uppercaseFirstLetter=he;function ke(P,O=1){if(O===0)return"";let H=-1;do H=P.indexOf(`
`,H+1),O--;while(O>0&&H>=0);return H===-1?P:(P[H-1]==="\r"&&H--,P.substr(0,H))}t.getNLines=ke;function Se(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}t.singleLetterHash=Se;function qe(P){return Ae.getInstance().getGraphemeBreakType(P)}t.getGraphemeBreakType=qe;function Ue(P,O){return P===0?O!==5&&O!==7:P===2&&O===3?!1:P===4||P===2||P===3||O===4||O===2||O===3?!0:!(P===8&&(O===8||O===9||O===11||O===12)||(P===11||P===9)&&(O===9||O===10)||(P===12||P===10)&&O===10||O===5||O===13||O===7||P===1||P===13&&O===14||P===6&&O===6)}var We;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Ve()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const H=this.d,$=H.length/3;let X=1;for(;X<=$;)if(O<H[3*X])X=2*X;else if(O>H[3*X+1])X=2*X+1;else return H[3*X+2];return 0}}Ae.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(P,O){if(P===0)return 0;const H=je(P,O);if(H!==void 0)return H;const $=new Ee(O,P);return $.prevCodePoint(),$.offset}t.getLeftDeleteOffset=He;function je(P,O){const H=new Ee(O,P);let $=H.prevCodePoint();for(;ze($)||$===65039||$===8419;){if(H.offset===0)return;$=H.prevCodePoint()}if(!I($))return;let X=H.offset;return X>0&&H.prevCodePoint()===8205&&(X=H.offset),X}function ze(P){return 127995<=P&&P<=127999}var Ce;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),t.noBreakWhitespace="\xA0";class me{static getInstance(O){return me.d.get(Array.from(O))}static getLocales(){return me.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=me,me.c=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.d=new F.LRUCachedFunction(P=>{function O(ue){const ge=new Map;for(let Le=0;Le<ue.length;Le+=2)ge.set(ue[Le],ue[Le+1]);return ge}function H(ue,ge){const Le=new Map(ue);for(const[Te,Ie]of ge)Le.set(Te,Ie);return Le}function $(ue,ge){if(!ue)return ge;const Le=new Map;for(const[Te,Ie]of ue)ge.has(Te)&&Le.set(Te,Ie);return Le}const X=i.c.value;let se=P.filter(ue=>!ue.startsWith("_")&&ue in X);se.length===0&&(se=["_default"]);let ce;for(const ue of se){const ge=O(X[ue]);ce=$(ce,ge)}const ye=O(X._common),be=H(ye,ce);return new me(be)}),me.e=new T.Lazy(()=>Object.keys(me.c.value).filter(P=>!P.startsWith("_"))),t.AmbiguousCharacters=me;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(O){return Me.e().has(O)}static get codePoints(){return Me.e()}}Me.d=void 0,t.InvisibleCharacters=Me}),J(Z[46],ee([0,1,4]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function T(_){return i(_,0)}t.hash=T;function i(_,v){switch(typeof _){case"object":return _===null?u(349,v):Array.isArray(_)?a(_,v):g(_,v);case"string":return N(_,v);case"boolean":return y(_,v);case"number":return u(_,v);case"undefined":return u(937,v);default:return u(617,v)}}t.doHash=i;function u(_,v){return(v<<5)-v+_|0}t.numberHash=u;function y(_,v){return u(_?433:863,v)}function N(_,v){v=u(149417,v);for(let m=0,l=_.length;m<l;m++)v=u(_.charCodeAt(m),v);return v}t.stringHash=N;function a(_,v){return v=u(104579,v),_.reduce((m,l)=>i(l,m),v)}function g(_,v){return v=u(181387,v),Object.keys(_).sort().reduce((m,l)=>(m=N(l,m),i(_[l],m)),v)}class p{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=i(v,this.g),this.g}}t.Hasher=p;var R;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function w(_,v,m=32){const l=m-v,c=~((1<<l)-1);return(_<<v|(c&_)>>>l)>>>0}function L(_,v=0,m=_.byteLength,l=0){for(let c=0;c<m;c++)_[v+c]=l}function e(_,v,m="0"){for(;_.length<v;)_=m+_;return _}function E(_,v=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(m=>m.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),v/4)}t.toHexString=E;class D{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const m=v.length;if(m===0)return;const l=this.p;let c=this.r,r=this.u,s,d;for(r!==0?(s=r,d=-1,r=0):(s=v.charCodeAt(0),d=0);;){let f=s;if(F.isHighSurrogate(s))if(d+1<m){const A=v.charCodeAt(d+1);F.isLowSurrogate(A)?(d++,f=F.computeCodePoint(s,A)):f=65533}else{r=s;break}else F.isLowSurrogate(s)&&(f=65533);if(c=this.w(l,c,f),d++,d<m)s=v.charCodeAt(d);else break}this.r=c,this.u=r}w(v,m,l){return l<128?v[m++]=l:l<2048?(v[m++]=192|(l&1984)>>>6,v[m++]=128|(l&63)>>>0):l<65536?(v[m++]=224|(l&61440)>>>12,v[m++]=128|(l&4032)>>>6,v[m++]=128|(l&63)>>>0):(v[m++]=240|(l&1835008)>>>18,v[m++]=128|(l&258048)>>>12,v[m++]=128|(l&4032)>>>6,v[m++]=128|(l&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,L(this.p,this.r),this.r>56&&(this.y(),L(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=D.g,m=this.q;for(let h=0;h<64;h+=4)v.setUint32(h,m.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)v.setUint32(h,w(v.getUint32(h-12,!1)^v.getUint32(h-32,!1)^v.getUint32(h-56,!1)^v.getUint32(h-64,!1),1),!1);let l=this.h,c=this.l,r=this.m,s=this.n,d=this.o,f,A,b;for(let h=0;h<80;h++)h<20?(f=c&r|~c&s,A=1518500249):h<40?(f=c^r^s,A=1859775393):h<60?(f=c&r|c&s|r&s,A=2400959708):(f=c^r^s,A=3395469782),b=w(l,5)+f+d+A+v.getUint32(h*4,!1)&4294967295,d=s,s=r,r=w(c,30),c=l,l=b;this.h=this.h+l&4294967295,this.l=this.l+c&4294967295,this.m=this.m+r&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}D.g=new DataView(new ArrayBuffer(320)),t.StringSHA1=D}),J(Z[23],ee([0,1,25,46]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(w){this.a=w}getElements(){const w=this.a,L=new Int32Array(w.length);for(let e=0,E=w.length;e<E;e++)L[e]=w.charCodeAt(e);return L}}t.StringDiffSequence=i;function u(R,w,L){return new p(new i(R),new i(w)).ComputeDiff(L).changes}t.stringDiff=u;class y{static Assert(w,L){if(!w)throw new Error(L)}}class N{static Copy(w,L,e,E,D){for(let _=0;_<D;_++)e[E+_]=w[L+_]}static Copy2(w,L,e,E,D){for(let _=0;_<D;_++)e[E+_]=w[L+_]}}var a;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(w,L){this.b=Math.min(this.b,w),this.c=Math.min(this.c,L),this.d++}AddModifiedElement(w,L){this.b=Math.min(this.b,w),this.c=Math.min(this.c,L),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class p{constructor(w,L,e=null){this.a=e,this.b=w,this.c=L;const[E,D,_]=p.o(w),[v,m,l]=p.o(L);this.d=_&&l,this.e=E,this.f=D,this.g=v,this.h=m,this.k=[],this.m=[]}static n(w){return w.length>0&&typeof w[0]=="string"}static o(w){const L=w.getElements();if(p.n(L)){const e=new Int32Array(L.length);for(let E=0,D=L.length;E<D;E++)e[E]=(0,T.stringHash)(L[E],0);return[L,e,!0]}return L instanceof Int32Array?[[],L,!1]:[[],new Int32Array(L),!1]}p(w,L){return this.f[w]!==this.h[L]?!1:this.d?this.e[w]===this.g[L]:!0}q(w,L){if(!this.p(w,L))return!1;const e=p.r(this.b,w),E=p.r(this.c,L);return e===E}static r(w,L){return typeof w.getStrictElement=="function"?w.getStrictElement(L):null}s(w,L){return this.f[w]!==this.f[L]?!1:this.d?this.e[w]===this.e[L]:!0}u(w,L){return this.h[w]!==this.h[L]?!1:this.d?this.g[w]===this.g[L]:!0}ComputeDiff(w){return this.v(0,this.f.length-1,0,this.h.length-1,w)}v(w,L,e,E,D){const _=[!1];let v=this.w(w,L,e,E,_);return D&&(v=this.z(v)),{quitEarly:_[0],changes:v}}w(w,L,e,E,D){for(D[0]=!1;w<=L&&e<=E&&this.p(w,e);)w++,e++;for(;L>=w&&E>=e&&this.p(L,E);)L--,E--;if(w>L||e>E){let r;return e<=E?(y.Assert(w===L+1,"originalStart should only be one more than originalEnd"),r=[new F.DiffChange(w,0,e,E-e+1)]):w<=L?(y.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[new F.DiffChange(w,L-w+1,e,0)]):(y.Assert(w===L+1,"originalStart should only be one more than originalEnd"),y.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const _=[0],v=[0],m=this.y(w,L,e,E,_,v,D),l=_[0],c=v[0];if(m!==null)return m;if(!D[0]){const r=this.w(w,l,e,c,D);let s=[];return D[0]?s=[new F.DiffChange(l+1,L-(l+1)+1,c+1,E-(c+1)+1)]:s=this.w(l+1,L,c+1,E,D),this.H(r,s)}return[new F.DiffChange(w,L-w+1,e,E-e+1)]}x(w,L,e,E,D,_,v,m,l,c,r,s,d,f,A,b,h,o){let M=null,U=null,C=new g,B=L,V=e,z=d[0]-b[0]-E,x=-1073741824,ne=this.k.length-1;do{const Q=z+w;Q===B||Q<V&&l[Q-1]<l[Q+1]?(r=l[Q+1],f=r-z-E,r<x&&C.MarkNextChange(),x=r,C.AddModifiedElement(r+1,f),z=Q+1-w):(r=l[Q-1]+1,f=r-z-E,r<x&&C.MarkNextChange(),x=r-1,C.AddOriginalElement(r,f+1),z=Q-1-w),ne>=0&&(l=this.k[ne],w=l[0],B=1,V=l.length-1)}while(--ne>=-1);if(M=C.getReverseChanges(),o[0]){let Q=d[0]+1,K=b[0]+1;if(M!==null&&M.length>0){const n=M[M.length-1];Q=Math.max(Q,n.getOriginalEnd()),K=Math.max(K,n.getModifiedEnd())}U=[new F.DiffChange(Q,s-Q+1,K,A-K+1)]}else{C=new g,B=_,V=v,z=d[0]-b[0]-m,x=1073741824,ne=h?this.m.length-1:this.m.length-2;do{const Q=z+D;Q===B||Q<V&&c[Q-1]>=c[Q+1]?(r=c[Q+1]-1,f=r-z-m,r>x&&C.MarkNextChange(),x=r+1,C.AddOriginalElement(r+1,f+1),z=Q+1-D):(r=c[Q-1],f=r-z-m,r>x&&C.MarkNextChange(),x=r,C.AddModifiedElement(r+1,f+1),z=Q-1-D),ne>=0&&(c=this.m[ne],D=c[0],B=1,V=c.length-1)}while(--ne>=-1);U=C.getChanges()}return this.H(M,U)}y(w,L,e,E,D,_,v){let m=0,l=0,c=0,r=0,s=0,d=0;w--,e--,D[0]=0,_[0]=0,this.k=[],this.m=[];const f=L-w+(E-e),A=f+1,b=new Int32Array(A),h=new Int32Array(A),o=E-e,M=L-w,U=w-e,C=L-E,V=(M-o)%2===0;b[o]=w,h[M]=L,v[0]=!1;for(let z=1;z<=f/2+1;z++){let x=0,ne=0;c=this.J(o-z,z,o,A),r=this.J(o+z,z,o,A);for(let K=c;K<=r;K+=2){K===c||K<r&&b[K-1]<b[K+1]?m=b[K+1]:m=b[K-1]+1,l=m-(K-o)-U;const n=m;for(;m<L&&l<E&&this.p(m+1,l+1);)m++,l++;if(b[K]=m,m+l>x+ne&&(x=m,ne=l),!V&&Math.abs(K-M)<=z-1&&m>=h[K])return D[0]=m,_[0]=l,n<=h[K]&&1447>0&&z<=1447+1?this.x(o,c,r,U,M,s,d,C,b,h,m,L,D,l,E,_,V,v):null}const Q=(x-w+(ne-e)-z)/2;if(this.a!==null&&!this.a(x,Q))return v[0]=!0,D[0]=x,_[0]=ne,Q>0&&1447>0&&z<=1447+1?this.x(o,c,r,U,M,s,d,C,b,h,m,L,D,l,E,_,V,v):(w++,e++,[new F.DiffChange(w,L-w+1,e,E-e+1)]);s=this.J(M-z,z,M,A),d=this.J(M+z,z,M,A);for(let K=s;K<=d;K+=2){K===s||K<d&&h[K-1]>=h[K+1]?m=h[K+1]-1:m=h[K-1],l=m-(K-M)-C;const n=m;for(;m>w&&l>e&&this.p(m,l);)m--,l--;if(h[K]=m,V&&Math.abs(K-o)<=z&&m<=b[K])return D[0]=m,_[0]=l,n>=b[K]&&1447>0&&z<=1447+1?this.x(o,c,r,U,M,s,d,C,b,h,m,L,D,l,E,_,V,v):null}if(z<=1447){let K=new Int32Array(r-c+2);K[0]=o-c+1,N.Copy2(b,c,K,1,r-c+1),this.k.push(K),K=new Int32Array(d-s+2),K[0]=M-s+1,N.Copy2(h,s,K,1,d-s+1),this.m.push(K)}}return this.x(o,c,r,U,M,s,d,C,b,h,m,L,D,l,E,_,V,v)}z(w){for(let L=0;L<w.length;L++){const e=w[L],E=L<w.length-1?w[L+1].originalStart:this.f.length,D=L<w.length-1?w[L+1].modifiedStart:this.h.length,_=e.originalLength>0,v=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<D&&(!_||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!v||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const l=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!l)break;e.originalStart++,e.modifiedStart++}const m=[null];if(L<w.length-1&&this.I(w[L],w[L+1],m)){w[L]=m[0],w.splice(L+1,1),L--;continue}}for(let L=w.length-1;L>=0;L--){const e=w[L];let E=0,D=0;if(L>0){const r=w[L-1];E=r.originalStart+r.originalLength,D=r.modifiedStart+r.modifiedLength}const _=e.originalLength>0,v=e.modifiedLength>0;let m=0,l=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,d=e.modifiedStart-r;if(s<E||d<D||_&&!this.s(s,s+e.originalLength)||v&&!this.u(d,d+e.modifiedLength))break;const A=(s===E&&d===D?5:0)+this.G(s,e.originalLength,d,e.modifiedLength);A>l&&(l=A,m=r)}e.originalStart-=m,e.modifiedStart-=m;const c=[null];if(L>0&&this.I(w[L-1],w[L],c)){w[L-1]=c[0],w.splice(L,1),L++;continue}}if(this.d)for(let L=1,e=w.length;L<e;L++){const E=w[L-1],D=w[L],_=D.originalStart-E.originalStart-E.originalLength,v=E.originalStart,m=D.originalStart+D.originalLength,l=m-v,c=E.modifiedStart,r=D.modifiedStart+D.modifiedLength,s=r-c;if(_<5&&l<20&&s<20){const d=this.A(v,l,c,s,_);if(d){const[f,A]=d;(f!==E.originalStart+E.originalLength||A!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=f-E.originalStart,E.modifiedLength=A-E.modifiedStart,D.originalStart=f+_,D.modifiedStart=A+_,D.originalLength=m-D.originalStart,D.modifiedLength=r-D.modifiedStart)}}}return w}A(w,L,e,E,D){if(L<D||E<D)return null;const _=w+L-D+1,v=e+E-D+1;let m=0,l=0,c=0;for(let r=w;r<_;r++)for(let s=e;s<v;s++){const d=this.B(r,s,D);d>0&&d>m&&(m=d,l=r,c=s)}return m>0?[l,c]:null}B(w,L,e){let E=0;for(let D=0;D<e;D++){if(!this.p(w+D,L+D))return 0;E+=this.e[w+D].length}return E}C(w){return w<=0||w>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[w])}D(w,L){if(this.C(w)||this.C(w-1))return!0;if(L>0){const e=w+L;if(this.C(e-1)||this.C(e))return!0}return!1}E(w){return w<=0||w>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[w])}F(w,L){if(this.E(w)||this.E(w-1))return!0;if(L>0){const e=w+L;if(this.E(e-1)||this.E(e))return!0}return!1}G(w,L,e,E){const D=this.D(w,L)?1:0,_=this.F(e,E)?1:0;return D+_}H(w,L){const e=[];if(w.length===0||L.length===0)return L.length>0?L:w;if(this.I(w[w.length-1],L[0],e)){const E=new Array(w.length+L.length-1);return N.Copy(w,0,E,0,w.length-1),E[w.length-1]=e[0],N.Copy(L,1,E,w.length,L.length-1),E}else{const E=new Array(w.length+L.length);return N.Copy(w,0,E,0,w.length),N.Copy(L,0,E,w.length,L.length),E}}I(w,L,e){if(y.Assert(w.originalStart<=L.originalStart,"Left change is not less than or equal to right change"),y.Assert(w.modifiedStart<=L.modifiedStart,"Left change is not less than or equal to right change"),w.originalStart+w.originalLength>=L.originalStart||w.modifiedStart+w.modifiedLength>=L.modifiedStart){const E=w.originalStart;let D=w.originalLength;const _=w.modifiedStart;let v=w.modifiedLength;return w.originalStart+w.originalLength>=L.originalStart&&(D=L.originalStart+L.originalLength-w.originalStart),w.modifiedStart+w.modifiedLength>=L.modifiedStart&&(v=L.modifiedStart+L.modifiedLength-w.modifiedStart),e[0]=new F.DiffChange(E,D,_,v),!0}else return e[0]=null,!1}J(w,L,e,E){if(w>=0&&w<E)return w;const D=e,_=E-e-1,v=L%2===0;if(w<0){const m=D%2===0;return v===m?0:1}else{const m=_%2===0;return v===m?E-1:E-2}}}t.LcsDiff=p}),J(Z[12],ee([0,1,44,8]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,y=/^\/\//;function N(d,f){if(!d.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!i.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!u.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,f){return!d&&!f?"file":d}function g(d,f){switch(d){case"https":case"http":case"file":f?f[0]!==R&&(f=R+f):f=R;break}return f}const p="",R="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class L{static isUri(f){return f instanceof L?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,A,b,h,o,M=!1){typeof f=="object"?(this.scheme=f.scheme||p,this.authority=f.authority||p,this.path=f.path||p,this.query=f.query||p,this.fragment=f.fragment||p):(this.scheme=a(f,M),this.authority=A||p,this.path=g(this.scheme,b||p),this.query=h||p,this.fragment=o||p,N(this,M))}get fsPath(){return m(this,!1)}with(f){if(!f)return this;let{scheme:A,authority:b,path:h,query:o,fragment:M}=f;return A===void 0?A=this.scheme:A===null&&(A=p),b===void 0?b=this.authority:b===null&&(b=p),h===void 0?h=this.path:h===null&&(h=p),o===void 0?o=this.query:o===null&&(o=p),M===void 0?M=this.fragment:M===null&&(M=p),A===this.scheme&&b===this.authority&&h===this.path&&o===this.query&&M===this.fragment?this:new E(A,b,h,o,M)}static parse(f,A=!1){const b=w.exec(f);return b?new E(b[2]||p,s(b[4]||p),s(b[5]||p),s(b[7]||p),s(b[9]||p),A):new E(p,p,p,p,p)}static file(f){let A=p;if(T.isWindows&&(f=f.replace(/\\/g,R)),f[0]===R&&f[1]===R){const b=f.indexOf(R,2);b===-1?(A=f.substring(2),f=R):(A=f.substring(2,b),f=f.substring(b)||R)}return new E("file",A,f,p,p)}static from(f){const A=new E(f.scheme,f.authority,f.path,f.query,f.fragment);return N(A,!0),A}static joinPath(f,...A){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return T.isWindows&&f.scheme==="file"?b=L.file(F.win32.join(m(f,!0),...A)).path:b=F.posix.join(f.path,...A),f.with({path:b})}toString(f=!1){return l(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof L)return f;{const A=new E(f);return A._formatted=f.external,A._fsPath=f._sep===e?f.fsPath:null,A}}else return f}}t.URI=L;const e=T.isWindows?1:void 0;class E extends L{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(f=!1){return f?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=e),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(d,f,A){let b,h=-1;for(let o=0;o<d.length;o++){const M=d.charCodeAt(o);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||f&&M===47||A&&M===91||A&&M===93||A&&M===58)h!==-1&&(b+=encodeURIComponent(d.substring(h,o)),h=-1),b!==void 0&&(b+=d.charAt(o));else{b===void 0&&(b=d.substr(0,o));const U=D[M];U!==void 0?(h!==-1&&(b+=encodeURIComponent(d.substring(h,o)),h=-1),b+=U):h===-1&&(h=o)}}return h!==-1&&(b+=encodeURIComponent(d.substring(h))),b!==void 0?b:d}function v(d){let f;for(let A=0;A<d.length;A++){const b=d.charCodeAt(A);b===35||b===63?(f===void 0&&(f=d.substr(0,A)),f+=D[b]):f!==void 0&&(f+=d[A])}return f!==void 0?f:d}function m(d,f){let A;return d.authority&&d.path.length>1&&d.scheme==="file"?A=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?f?A=d.path.substr(1):A=d.path[1].toLowerCase()+d.path.substr(2):A=d.path,T.isWindows&&(A=A.replace(/\//g,"\\")),A}t.uriToFsPath=m;function l(d,f){const A=f?v:_;let b="",{scheme:h,authority:o,path:M,query:U,fragment:C}=d;if(h&&(b+=h,b+=":"),(o||h==="file")&&(b+=R,b+=R),o){let B=o.indexOf("@");if(B!==-1){const V=o.substr(0,B);o=o.substr(B+1),B=V.lastIndexOf(":"),B===-1?b+=A(V,!1,!1):(b+=A(V.substr(0,B),!1,!1),b+=":",b+=A(V.substr(B+1),!1,!0)),b+="@"}o=o.toLowerCase(),B=o.lastIndexOf(":"),B===-1?b+=A(o,!1,!0):(b+=A(o.substr(0,B),!1,!0),b+=o.substr(B))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const B=M.charCodeAt(1);B>=65&&B<=90&&(M=`/${String.fromCharCode(B+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const B=M.charCodeAt(0);B>=65&&B<=90&&(M=`${String.fromCharCode(B+32)}:${M.substr(2)}`)}b+=A(M,!0,!1)}return U&&(b+="?",b+=A(U,!1,!1)),C&&(b+="#",b+=f?C:_(C,!1,!1)),b}function c(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+c(d.substr(3)):d}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(r)?d.replace(r,f=>c(f)):d}}),J(Z[57],ee([0,1,5,9,6,11,8,4]),function(q,t,F,T,i,u,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let g=!1;function p(d){!y.isWeb||(g||(g=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}t.logOnceWebWorkerWarning=p;var R;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class w{constructor(f,A,b,h){this.vsWorker=f,this.req=A,this.method=b,this.args=h,this.type=0}}class L{constructor(f,A,b,h){this.vsWorker=f,this.seq=A,this.res=b,this.err=h,this.type=1}}class e{constructor(f,A,b,h){this.vsWorker=f,this.req=A,this.eventName=b,this.arg=h,this.type=2}}class E{constructor(f,A,b){this.vsWorker=f,this.req=A,this.event=b,this.type=3}}class D{constructor(f,A){this.vsWorker=f,this.req=A,this.type=4}}class _{constructor(f){this.a=-1,this.g=f,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(f){this.a=f}sendMessage(f,A){const b=String(++this.b);return new Promise((h,o)=>{this.c[b]={resolve:h,reject:o},this.o(new w(this.a,b,f,A))})}listen(f,A){let b=null;const h=new T.Emitter({onWillAddFirstListener:()=>{b=String(++this.b),this.d.set(b,h),this.o(new e(this.a,b,f,A))},onDidRemoveLastListener:()=>{this.d.delete(b),this.o(new D(this.a,b)),b=null}});return h.event}handleMessage(f){!f||!f.vsWorker||this.a!==-1&&f.vsWorker!==this.a||this.h(f)}h(f){switch(f.type){case 1:return this.j(f);case 0:return this.k(f);case 2:return this.l(f);case 3:return this.m(f);case 4:return this.n(f)}}j(f){if(!this.c[f.seq]){console.warn("Got reply to unknown seq");return}const A=this.c[f.seq];if(delete this.c[f.seq],f.err){let b=f.err;f.err.$isError&&(b=new Error,b.name=f.err.name,b.message=f.err.message,b.stack=f.err.stack),A.reject(b);return}A.resolve(f.res)}k(f){const A=f.req;this.g.handleMessage(f.method,f.args).then(h=>{this.o(new L(this.a,A,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,F.transformErrorForSerialization)(h.detail)),this.o(new L(this.a,A,void 0,(0,F.transformErrorForSerialization)(h)))})}l(f){const A=f.req,b=this.g.handleEvent(f.eventName,f.arg)(h=>{this.o(new E(this.a,A,h))});this.f.set(A,b)}m(f){if(!this.d.has(f.req)){console.warn("Got event for unknown req");return}this.d.get(f.req).fire(f.event)}n(f){if(!this.f.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(f.req).dispose(),this.f.delete(f.req)}o(f){const A=[];if(f.type===0)for(let b=0;b<f.args.length;b++)f.args[b]instanceof ArrayBuffer&&A.push(f.args[b]);else f.type===1&&f.res instanceof ArrayBuffer&&A.push(f.res);this.g.sendMessage(f,A)}}class v extends i.Disposable{constructor(f,A,b){super();let h=null;this.a=this.D(f.create("vs/base/common/worker/simpleWorker",V=>{this.c.handleMessage(V)},V=>{h?.(V)})),this.c=new _({sendMessage:(V,z)=>{this.a.postMessage(V,z)},handleMessage:(V,z)=>{if(typeof b[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(b[V].apply(b,z))}catch(x){return Promise.reject(x)}},handleEvent:(V,z)=>{if(l(V)){const x=b[V].call(b,z);if(typeof x!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return x}if(m(V)){const x=b[V];if(typeof x!="function")throw new Error(`Missing event ${V} on main thread host.`);return x}throw new Error(`Malformed event name ${V}`)}}),this.c.setWorkerId(this.a.getId());let o=null;const M=globalThis.require;typeof M<"u"&&typeof M.getConfig=="function"?o=M.getConfig():typeof globalThis.requirejs<"u"&&(o=globalThis.requirejs.s.contexts._.config);const U=(0,u.getAllMethodNames)(b);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(o)),A,U]);const C=(V,z)=>this.g(V,z),B=(V,z)=>this.c.listen(V,z);this.f=new Promise((V,z)=>{h=z,this.b.then(x=>{V(c(x,C,B))},x=>{z(x),this.h("Worker failed to load "+A,x)})})}getProxyObject(){return this.f}g(f,A){return new Promise((b,h)=>{this.b.then(()=>{this.c.sendMessage(f,A).then(b,h)},h)})}h(f,A){console.error(f),console.info(A)}}t.SimpleWorkerClient=v;function m(d){return d[0]==="o"&&d[1]==="n"&&N.isUpperAsciiLetter(d.charCodeAt(2))}function l(d){return/^onDynamic/.test(d)&&N.isUpperAsciiLetter(d.charCodeAt(9))}function c(d,f,A){const b=M=>function(){const U=Array.prototype.slice.call(arguments,0);return f(M,U)},h=M=>function(U){return A(M,U)},o={};for(const M of d){if(l(M)){o[M]=h(M);continue}if(m(M)){o[M]=A(M,void 0);continue}o[M]=b(M)}return o}class r{constructor(f,A){this.a=A,this.b=null,this.c=new _({sendMessage:(b,h)=>{f(b,h)},handleMessage:(b,h)=>this.d(b,h),handleEvent:(b,h)=>this.f(b,h)})}onmessage(f){this.c.handleMessage(f)}d(f,A){if(f===a)return this.g(A[0],A[1],A[2],A[3]);if(!this.b||typeof this.b[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.b[f].apply(this.b,A))}catch(b){return Promise.reject(b)}}f(f,A){if(!this.b)throw new Error("Missing requestHandler");if(l(f)){const b=this.b[f].call(this.b,A);if(typeof b!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return b}if(m(f)){const b=this.b[f];if(typeof b!="function")throw new Error(`Missing event ${f} on request handler.`);return b}throw new Error(`Malformed event name ${f}`)}g(f,A,b,h){this.c.setWorkerId(f);const U=c(h,(C,B)=>this.c.sendMessage(C,B),(C,B)=>this.c.listen(C,B));return this.a?(this.b=this.a(U),Promise.resolve((0,u.getAllMethodNames)(this.b))):(A&&(typeof A.baseUrl<"u"&&delete A.baseUrl,typeof A.paths<"u"&&typeof A.paths.vs<"u"&&delete A.paths.vs,typeof A.trustedTypesPolicy!==void 0&&delete A.trustedTypesPolicy,A.catchError=!0,globalThis.require.config(A)),new Promise((C,B)=>{(globalThis.require||q)([b],z=>{if(this.b=z.create(U),!this.b){B(new Error("No RequestHandler!"));return}C((0,u.getAllMethodNames)(this.b))},B)}))}}t.SimpleWorkerServer=r;function s(d){return new r(d,null)}t.create=s}),J(Z[24],ee([0,1,23,20,4,2,10]),function(q,t,F,T,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const N=3;class a{computeDiff(l,c,r){const d=new E(l,c,{maxComputationTime:r.maxComputationTimeMs,shouldIgnoreTrimWhitespace:r.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),f=[];let A=null;for(const b of d.changes){let h;b.originalEndLineNumber===0?h=new T.LineRange(b.originalStartLineNumber+1,b.originalStartLineNumber+1):h=new T.LineRange(b.originalStartLineNumber,b.originalEndLineNumber+1);let o;b.modifiedEndLineNumber===0?o=new T.LineRange(b.modifiedStartLineNumber+1,b.modifiedStartLineNumber+1):o=new T.LineRange(b.modifiedStartLineNumber,b.modifiedEndLineNumber+1);let M=new T.LineRangeMapping(h,o,b.charChanges?.map(U=>new T.RangeMapping(new u.Range(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new u.Range(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));A&&(A.modifiedRange.endLineNumberExclusive===M.modifiedRange.startLineNumber||A.originalRange.endLineNumberExclusive===M.originalRange.startLineNumber)&&(M=new T.LineRangeMapping(A.originalRange.join(M.originalRange),A.modifiedRange.join(M.modifiedRange),A.innerChanges&&M.innerChanges?A.innerChanges.concat(M.innerChanges):void 0),f.pop()),f.push(M),A=M}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(f,(b,h)=>h.originalRange.startLineNumber-b.originalRange.endLineNumberExclusive===h.modifiedRange.startLineNumber-b.modifiedRange.endLineNumberExclusive&&b.originalRange.endLineNumberExclusive<h.originalRange.startLineNumber&&b.modifiedRange.endLineNumberExclusive<h.modifiedRange.startLineNumber)),{quitEarly:d.quitEarly,changes:f}}}t.SmartLinesDiffComputer=a;function g(m,l,c,r){return new F.LcsDiff(m,l,c).ComputeDiff(r)}class p{constructor(l){const c=[],r=[];for(let s=0,d=l.length;s<d;s++)c[s]=D(l[s],1),r[s]=_(l[s],1);this.lines=l,this.a=c,this.b=r}getElements(){const l=[];for(let c=0,r=this.lines.length;c<r;c++)l[c]=this.lines[c].substring(this.a[c]-1,this.b[c]-1);return l}getStrictElement(l){return this.lines[l]}getStartLineNumber(l){return l+1}getEndLineNumber(l){return l+1}createCharSequence(l,c,r){const s=[],d=[],f=[];let A=0;for(let b=c;b<=r;b++){const h=this.lines[b],o=l?this.a[b]:1,M=l?this.b[b]:h.length+1;for(let U=o;U<M;U++)s[A]=h.charCodeAt(U-1),d[A]=b+1,f[A]=U,A++;!l&&b<r&&(s[A]=10,d[A]=b+1,f[A]=h.length+1,A++)}return new R(s,d,f)}}class R{constructor(l,c,r){this.a=l,this.b=c,this.d=r}toString(){return"["+this.a.map((l,c)=>(l===10?"\\n":String.fromCharCode(l))+`-(${this.b[c]},${this.d[c]})`).join(", ")+"]"}e(l,c){if(l<0||l>=c.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(l){return l>0&&l===this.b.length?this.getEndLineNumber(l-1):(this.e(l,this.b),this.b[l])}getEndLineNumber(l){return l===-1?this.getStartLineNumber(l+1):(this.e(l,this.b),this.a[l]===10?this.b[l]+1:this.b[l])}getStartColumn(l){return l>0&&l===this.d.length?this.getEndColumn(l-1):(this.e(l,this.d),this.d[l])}getEndColumn(l){return l===-1?this.getStartColumn(l+1):(this.e(l,this.d),this.a[l]===10?1:this.d[l]+1)}}class w{constructor(l,c,r,s,d,f,A,b){this.originalStartLineNumber=l,this.originalStartColumn=c,this.originalEndLineNumber=r,this.originalEndColumn=s,this.modifiedStartLineNumber=d,this.modifiedStartColumn=f,this.modifiedEndLineNumber=A,this.modifiedEndColumn=b}static createFromDiffChange(l,c,r){const s=c.getStartLineNumber(l.originalStart),d=c.getStartColumn(l.originalStart),f=c.getEndLineNumber(l.originalStart+l.originalLength-1),A=c.getEndColumn(l.originalStart+l.originalLength-1),b=r.getStartLineNumber(l.modifiedStart),h=r.getStartColumn(l.modifiedStart),o=r.getEndLineNumber(l.modifiedStart+l.modifiedLength-1),M=r.getEndColumn(l.modifiedStart+l.modifiedLength-1);return new w(s,d,f,A,b,h,o,M)}}function L(m){if(m.length<=1)return m;const l=[m[0]];let c=l[0];for(let r=1,s=m.length;r<s;r++){const d=m[r],f=d.originalStart-(c.originalStart+c.originalLength),A=d.modifiedStart-(c.modifiedStart+c.modifiedLength);Math.min(f,A)<N?(c.originalLength=d.originalStart+d.originalLength-c.originalStart,c.modifiedLength=d.modifiedStart+d.modifiedLength-c.modifiedStart):(l.push(d),c=d)}return l}class e{constructor(l,c,r,s,d){this.originalStartLineNumber=l,this.originalEndLineNumber=c,this.modifiedStartLineNumber=r,this.modifiedEndLineNumber=s,this.charChanges=d}static createFromDiffResult(l,c,r,s,d,f,A){let b,h,o,M,U;if(c.originalLength===0?(b=r.getStartLineNumber(c.originalStart)-1,h=0):(b=r.getStartLineNumber(c.originalStart),h=r.getEndLineNumber(c.originalStart+c.originalLength-1)),c.modifiedLength===0?(o=s.getStartLineNumber(c.modifiedStart)-1,M=0):(o=s.getStartLineNumber(c.modifiedStart),M=s.getEndLineNumber(c.modifiedStart+c.modifiedLength-1)),f&&c.originalLength>0&&c.originalLength<20&&c.modifiedLength>0&&c.modifiedLength<20&&d()){const C=r.createCharSequence(l,c.originalStart,c.originalStart+c.originalLength-1),B=s.createCharSequence(l,c.modifiedStart,c.modifiedStart+c.modifiedLength-1);if(C.getElements().length>0&&B.getElements().length>0){let V=g(C,B,d,!0).changes;A&&(V=L(V)),U=[];for(let z=0,x=V.length;z<x;z++)U.push(w.createFromDiffChange(V[z],C,B))}}return new e(b,h,o,M,U)}}class E{constructor(l,c,r){this.a=r.shouldComputeCharChanges,this.b=r.shouldPostProcessCharChanges,this.d=r.shouldIgnoreTrimWhitespace,this.e=r.shouldMakePrettyDiff,this.f=l,this.g=c,this.h=new p(l),this.j=new p(c),this.k=v(r.maxComputationTime),this.l=v(r.maxComputationTime===0?0:Math.min(r.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const l=g(this.h,this.j,this.k,this.e),c=l.changes,r=l.quitEarly;if(this.d){const A=[];for(let b=0,h=c.length;b<h;b++)A.push(e.createFromDiffResult(this.d,c[b],this.h,this.j,this.l,this.a,this.b));return{quitEarly:r,changes:A}}const s=[];let d=0,f=0;for(let A=-1,b=c.length;A<b;A++){const h=A+1<b?c[A+1]:null,o=h?h.originalStart:this.f.length,M=h?h.modifiedStart:this.g.length;for(;d<o&&f<M;){const U=this.f[d],C=this.g[f];if(U!==C){{let B=D(U,1),V=D(C,1);for(;B>1&&V>1;){const z=U.charCodeAt(B-2),x=C.charCodeAt(V-2);if(z!==x)break;B--,V--}(B>1||V>1)&&this.m(s,d+1,1,B,f+1,1,V)}{let B=_(U,1),V=_(C,1);const z=U.length+1,x=C.length+1;for(;B<z&&V<x;){const ne=U.charCodeAt(B-1),Q=U.charCodeAt(V-1);if(ne!==Q)break;B++,V++}(B<z||V<x)&&this.m(s,d+1,B,z,f+1,V,x)}}d++,f++}h&&(s.push(e.createFromDiffResult(this.d,h,this.h,this.j,this.l,this.a,this.b)),d+=h.originalLength,f+=h.modifiedLength)}return{quitEarly:r,changes:s}}m(l,c,r,s,d,f,A){if(this.n(l,c,r,s,d,f,A))return;let b;this.a&&(b=[new w(c,r,c,s,d,f,d,A)]),l.push(new e(c,c,d,d,b))}n(l,c,r,s,d,f,A){const b=l.length;if(b===0)return!1;const h=l[b-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber===c&&h.modifiedEndLineNumber===d?(this.a&&h.charChanges&&h.charChanges.push(new w(c,r,c,s,d,f,d,A)),!0):h.originalEndLineNumber+1===c&&h.modifiedEndLineNumber+1===d?(h.originalEndLineNumber=c,h.modifiedEndLineNumber=d,this.a&&h.charChanges&&h.charChanges.push(new w(c,r,c,s,d,f,d,A)),!0):!1}}t.DiffComputer=E;function D(m,l){const c=i.firstNonWhitespaceIndex(m);return c===-1?l:c+1}function _(m,l){const c=i.lastNonWhitespaceIndex(m);return c===-1?l:c+2}function v(m){if(m===0)return()=>!0;const l=Date.now();return()=>Date.now()-l<m}}),J(Z[47],ee([0,1,24,36]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new F.SmartLinesDiffComputer,experimental:new T.StandardLinesDiffComputer}}),J(Z[48],ee([0,1,4,3,40]),function(q,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(N,a,g,p){this.c=N,this.d=a,this.f=g,this.g=p,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(N){N.eol&&N.eol!==this.f&&(this.f=N.eol,this.h=null);const a=N.changes;for(const g of a)this.n(g.range),this.o(new T.Position(g.range.startLineNumber,g.range.startColumn),g.text);this.g=N.versionId,this.j=null}k(){if(!this.h){const N=this.f.length,a=this.d.length,g=new Uint32Array(a);for(let p=0;p<a;p++)g[p]=this.d[p].length+N;this.h=new i.PrefixSumComputer(g)}}l(N,a){this.d[N]=a,this.h&&this.h.setValue(N,this.d[N].length+this.f.length)}n(N){if(N.startLineNumber===N.endLineNumber){if(N.startColumn===N.endColumn)return;this.l(N.startLineNumber-1,this.d[N.startLineNumber-1].substring(0,N.startColumn-1)+this.d[N.startLineNumber-1].substring(N.endColumn-1));return}this.l(N.startLineNumber-1,this.d[N.startLineNumber-1].substring(0,N.startColumn-1)+this.d[N.endLineNumber-1].substring(N.endColumn-1)),this.d.splice(N.startLineNumber,N.endLineNumber-N.startLineNumber),this.h&&this.h.removeValues(N.startLineNumber,N.endLineNumber-N.startLineNumber)}o(N,a){if(a.length===0)return;const g=(0,F.splitLines)(a);if(g.length===1){this.l(N.lineNumber-1,this.d[N.lineNumber-1].substring(0,N.column-1)+g[0]+this.d[N.lineNumber-1].substring(N.column-1));return}g[g.length-1]+=this.d[N.lineNumber-1].substring(N.column-1),this.l(N.lineNumber-1,this.d[N.lineNumber-1].substring(0,N.column-1)+g[0]);const p=new Uint32Array(g.length-1);for(let R=1;R<g.length;R++)this.d.splice(N.lineNumber+R-1,0,g[R]),p[R-1]=g[R].length+this.f.length;this.h&&this.h.insertValues(N.lineNumber,p)}}t.MirrorTextModel=u}),J(Z[49],ee([0,1,4,31,3,2,39]),function(q,t,F,T,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const N=999;class a{constructor(v,m,l,c){this.searchString=v,this.isRegex=m,this.matchCase=l,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=g(this.searchString):v=this.searchString.indexOf(`
`)>=0;let m=null;try{m=F.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!m)return null;let l=!this.isRegex&&!v;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new y.SearchData(m,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}t.SearchParams=a;function g(_){if(!_||_.length===0)return!1;for(let v=0,m=_.length;v<m;v++){const l=_.charCodeAt(v);if(l===10)return!0;if(l===92){if(v++,v>=m)break;const c=_.charCodeAt(v);if(c===110||c===114||c===87)return!0}}return!1}t.isMultilineRegexSource=g;function p(_,v,m){if(!m)return new y.FindMatch(_,null);const l=[];for(let c=0,r=v.length;c<r;c++)l[c]=v[c];return new y.FindMatch(_,l)}t.createFindMatch=p;class R{constructor(v){const m=[];let l=0;for(let c=0,r=v.length;c<r;c++)v.charCodeAt(c)===10&&(m[l++]=c);this.a=m}findLineFeedCountBeforeOffset(v){const m=this.a;let l=0,c=m.length-1;if(c===-1||v<=m[0])return 0;for(;l<c;){const r=l+((c-l)/2>>0);m[r]>=v?c=r-1:m[r+1]>=v?(l=r,c=r):l=r+1}return l+1}}class w{static findMatches(v,m,l,c,r){const s=m.parseSearchRequest();return s?s.regex.multiline?this.b(v,l,new D(s.wordSeparators,s.regex),c,r):this.c(v,l,s,c,r):[]}static a(v,m,l,c,r,s){let d,f=0;c?(f=c.findLineFeedCountBeforeOffset(r),d=m+r+f):d=m+r;let A;if(c){const M=c.findLineFeedCountBeforeOffset(r+s.length)-f;A=d+s.length+M}else A=d+s.length;const b=v.getPositionAt(d),h=v.getPositionAt(A);return new u.Range(b.lineNumber,b.column,h.lineNumber,h.column)}static b(v,m,l,c,r){const s=v.getOffsetAt(m.getStartPosition()),d=v.getValueInRange(m,1),f=v.getEOL()===`\r
`?new R(d):null,A=[];let b=0,h;for(l.reset(0);h=l.next(d);)if(A[b++]=p(this.a(v,s,d,f,h.index,h[0]),h,c),b>=r)return A;return A}static c(v,m,l,c,r){const s=[];let d=0;if(m.startLineNumber===m.endLineNumber){const A=v.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return d=this.d(l,A,m.startLineNumber,m.startColumn-1,d,s,c,r),s}const f=v.getLineContent(m.startLineNumber).substring(m.startColumn-1);d=this.d(l,f,m.startLineNumber,m.startColumn-1,d,s,c,r);for(let A=m.startLineNumber+1;A<m.endLineNumber&&d<r;A++)d=this.d(l,v.getLineContent(A),A,0,d,s,c,r);if(d<r){const A=v.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);d=this.d(l,A,m.endLineNumber,0,d,s,c,r)}return s}static d(v,m,l,c,r,s,d,f){const A=v.wordSeparators;if(!d&&v.simpleSearch){const o=v.simpleSearch,M=o.length,U=m.length;let C=-M;for(;(C=m.indexOf(o,C+M))!==-1;)if((!A||E(A,m,U,C,M))&&(s[r++]=new y.FindMatch(new u.Range(l,C+1+c,l,C+1+M+c),null),r>=f))return r;return r}const b=new D(v.wordSeparators,v.regex);let h;b.reset(0);do if(h=b.next(m),h&&(s[r++]=p(new u.Range(l,h.index+1+c,l,h.index+1+h[0].length+c),h,d),r>=f))return r;while(h);return r}static findNextMatch(v,m,l,c){const r=m.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.e(v,l,s,c):this.f(v,l,s,c)}static e(v,m,l,c){const r=new i.Position(m.lineNumber,1),s=v.getOffsetAt(r),d=v.getLineCount(),f=v.getValueInRange(new u.Range(r.lineNumber,r.column,d,v.getLineMaxColumn(d)),1),A=v.getEOL()===`\r
`?new R(f):null;l.reset(m.column-1);const b=l.next(f);return b?p(this.a(v,s,f,A,b.index,b[0]),b,c):m.lineNumber!==1||m.column!==1?this.e(v,new i.Position(1,1),l,c):null}static f(v,m,l,c){const r=v.getLineCount(),s=m.lineNumber,d=v.getLineContent(s),f=this.g(l,d,s,m.column,c);if(f)return f;for(let A=1;A<=r;A++){const b=(s+A-1)%r,h=v.getLineContent(b+1),o=this.g(l,h,b+1,1,c);if(o)return o}return null}static g(v,m,l,c,r){v.reset(c-1);const s=v.next(m);return s?p(new u.Range(l,s.index+1,l,s.index+1+s[0].length),s,r):null}static findPreviousMatch(v,m,l,c){const r=m.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.h(v,l,s,c):this.j(v,l,s,c)}static h(v,m,l,c){const r=this.b(v,new u.Range(1,1,m.lineNumber,m.column),l,c,10*N);if(r.length>0)return r[r.length-1];const s=v.getLineCount();return m.lineNumber!==s||m.column!==v.getLineMaxColumn(s)?this.h(v,new i.Position(s,v.getLineMaxColumn(s)),l,c):null}static j(v,m,l,c){const r=v.getLineCount(),s=m.lineNumber,d=v.getLineContent(s).substring(0,m.column-1),f=this.k(l,d,s,c);if(f)return f;for(let A=1;A<=r;A++){const b=(r+s-A-1)%r,h=v.getLineContent(b+1),o=this.k(l,h,b+1,c);if(o)return o}return null}static k(v,m,l,c){let r=null,s;for(v.reset(0);s=v.next(m);)r=p(new u.Range(l,s.index+1,l,s.index+1+s[0].length),s,c);return r}}t.TextModelSearch=w;function L(_,v,m,l,c){if(l===0)return!0;const r=v.charCodeAt(l-1);if(_.get(r)!==0||r===13||r===10)return!0;if(c>0){const s=v.charCodeAt(l);if(_.get(s)!==0)return!0}return!1}function e(_,v,m,l,c){if(l+c===m)return!0;const r=v.charCodeAt(l+c);if(_.get(r)!==0||r===13||r===10)return!0;if(c>0){const s=v.charCodeAt(l+c-1);if(_.get(s)!==0)return!0}return!1}function E(_,v,m,l,c){return L(_,v,m,l,c)&&e(_,v,m,l,c)}t.isValidMatch=E;class D{constructor(v,m){this._wordSeparators=v,this.a=m,this.b=-1,this.c=0}reset(v){this.a.lastIndex=v,this.b=-1,this.c=0}next(v){const m=v.length;let l;do{if(this.b+this.c===m||(l=this.a.exec(v),!l))return null;const c=l.index,r=l[0].length;if(c===this.b&&r===this.c){if(r===0){F.getNextCodePoint(v,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=r,!this._wordSeparators||E(this._wordSeparators,v,m,c,r))return l}while(l);return null}}t.Searcher=D}),J(Z[50],ee([0,1,2,49,4,10,19]),function(q,t,F,T,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class N{static computeUnicodeHighlights(e,E,D){const _=D?D.startLineNumber:1,v=D?D.endLineNumber:e.getLineCount(),m=new p(E),l=m.getCandidateCodePoints();let c;l==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(l))}`,"g");const r=new T.Searcher(null,c),s=[];let d=!1,f,A=0,b=0,h=0;e:for(let o=_,M=v;o<=M;o++){const U=e.getLineContent(o),C=U.length;r.reset(0);do if(f=r.next(U),f){let B=f.index,V=f.index+f[0].length;if(B>0){const Q=U.charCodeAt(B-1);i.isHighSurrogate(Q)&&B--}if(V+1<C){const Q=U.charCodeAt(V-1);i.isHighSurrogate(Q)&&V++}const z=U.substring(B,V);let x=(0,y.getWordAtText)(B+1,y.DEFAULT_WORD_REGEXP,U,0);x&&x.endColumn<=B+1&&(x=null);const ne=m.shouldHighlightNonBasicASCII(z,x?x.word:null);if(ne!==0){ne===3?A++:ne===2?b++:ne===1?h++:(0,u.assertNever)(ne);const Q=1e3;if(s.length>=Q){d=!0;break e}s.push(new F.Range(o,B+1,o,V+1))}}while(f)}return{ranges:s,hasMore:d,ambiguousCharacterCount:A,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:h}}static computeUnicodeHighlightReason(e,E){const D=new p(E);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=e.codePointAt(0),m=D.ambiguousCharacters.getPrimaryConfusable(v),l=i.AmbiguousCharacters.getLocales().filter(c=>!i.AmbiguousCharacters.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(m),notAmbiguousInLocales:l}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=N;function a(L,e){return`[${i.escapeRegExpCharacters(L.map(D=>String.fromCodePoint(D)).join(""))}]`}var g;(function(L){L[L.Ambiguous=0]="Ambiguous",L[L.Invisible=1]="Invisible",L[L.NonBasicAscii=2]="NonBasicAscii"})(g=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class p{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of i.InvisibleCharacters.codePoints)R(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const D=e.codePointAt(0);if(this.a.has(D))return 0;if(this.b.nonBasicASCII)return 1;let _=!1,v=!1;if(E)for(const m of E){const l=m.codePointAt(0),c=i.isBasicASCII(m);_=_||c,!c&&!this.ambiguousCharacters.isAmbiguous(l)&&!i.InvisibleCharacters.isInvisibleCharacter(l)&&(v=!0)}return!_&&v?0:this.b.invisibleCharacters&&!R(e)&&i.InvisibleCharacters.isInvisibleCharacter(D)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function R(L){return L===" "||L===`
`||L==="	"}var w;(function(L){L[L.None=0]="None",L[L.NonBasicASCII=1]="NonBasicASCII",L[L.Invisible=2]="Invisible",L[L.Ambiguous=3]="Ambiguous"})(w||(w={}))}),J(Z[51],ee([0,1,9,6]),function(q,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new F.Emitter,this.onDidChange=this.c.event,this.d=null}fire(N){this.c.fire({changedLanguages:N,changedColorMap:!1})}register(N,a){return this.a.set(N,a),this.fire([N]),(0,T.toDisposable)(()=>{this.a.get(N)===a&&(this.a.delete(N),this.fire([N]))})}registerFactory(N,a){this.b.get(N)?.dispose();const g=new u(this,N,a);return this.b.set(N,g),(0,T.toDisposable)(()=>{const p=this.b.get(N);!p||p!==g||(this.b.delete(N),p.dispose())})}async getOrCreate(N){const a=this.get(N);if(a)return a;const g=this.b.get(N);return!g||g.isResolved?null:(await g.resolve(),this.get(N))}get(N){return this.a.get(N)||null}isResolved(N){if(this.get(N))return!0;const g=this.b.get(N);return!!(!g||g.isResolved)}setColorMap(N){this.d=N,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.TokenizationRegistry=i;class u extends T.Disposable{get isResolved(){return this.c}constructor(N,a,g){super(),this.f=N,this.g=a,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const N=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,N&&!this.a&&this.D(this.f.register(this.g,N))}}}),J(Z[52],ee([0,1,29,12,2,51]),function(q,t,F,T,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.InlayHintKind=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class y{constructor(M,U,C){this.offset=M,this.type=U,this.language=C,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=y;class N{constructor(M,U){this.tokens=M,this.endState=U,this._tokenizationResultBrand=void 0}}t.TokenizationResult=N;class a{constructor(M,U){this.tokens=M,this.endState=U,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=a;var g;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(g=t.CompletionItemKind||(t.CompletionItemKind={}));var p;(function(o){const M=new Map;M.set(0,F.Codicon.symbolMethod),M.set(1,F.Codicon.symbolFunction),M.set(2,F.Codicon.symbolConstructor),M.set(3,F.Codicon.symbolField),M.set(4,F.Codicon.symbolVariable),M.set(5,F.Codicon.symbolClass),M.set(6,F.Codicon.symbolStruct),M.set(7,F.Codicon.symbolInterface),M.set(8,F.Codicon.symbolModule),M.set(9,F.Codicon.symbolProperty),M.set(10,F.Codicon.symbolEvent),M.set(11,F.Codicon.symbolOperator),M.set(12,F.Codicon.symbolUnit),M.set(13,F.Codicon.symbolValue),M.set(15,F.Codicon.symbolEnum),M.set(14,F.Codicon.symbolConstant),M.set(15,F.Codicon.symbolEnum),M.set(16,F.Codicon.symbolEnumMember),M.set(17,F.Codicon.symbolKeyword),M.set(27,F.Codicon.symbolSnippet),M.set(18,F.Codicon.symbolText),M.set(19,F.Codicon.symbolColor),M.set(20,F.Codicon.symbolFile),M.set(21,F.Codicon.symbolReference),M.set(22,F.Codicon.symbolCustomColor),M.set(23,F.Codicon.symbolFolder),M.set(24,F.Codicon.symbolTypeParameter),M.set(25,F.Codicon.account),M.set(26,F.Codicon.issues);function U(V){let z=M.get(V);return z||(console.info("No codicon found for CompletionItemKind "+V),z=F.Codicon.symbolProperty),z}o.toIcon=U;const C=new Map;C.set("method",0),C.set("function",1),C.set("constructor",2),C.set("field",3),C.set("variable",4),C.set("class",5),C.set("struct",6),C.set("interface",7),C.set("module",8),C.set("property",9),C.set("event",10),C.set("operator",11),C.set("unit",12),C.set("value",13),C.set("constant",14),C.set("enum",15),C.set("enum-member",16),C.set("enumMember",16),C.set("keyword",17),C.set("snippet",27),C.set("text",18),C.set("color",19),C.set("file",20),C.set("reference",21),C.set("customcolor",22),C.set("folder",23),C.set("type-parameter",24),C.set("typeParameter",24),C.set("account",25),C.set("issue",26);function B(V,z){let x=C.get(V);return typeof x>"u"&&!z&&(x=9),x}o.fromString=B})(p=t.CompletionItemKinds||(t.CompletionItemKinds={}));var R;(function(o){o[o.Deprecated=1]="Deprecated"})(R=t.CompletionItemTag||(t.CompletionItemTag={}));var w;(function(o){o[o.None=0]="None",o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(w=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var L;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var e;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(e=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var E;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(E=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var D;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var _;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(_=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function v(o){return o&&T.URI.isUri(o.uri)&&i.Range.isIRange(o.range)&&(i.Range.isIRange(o.originSelectionRange)||i.Range.isIRange(o.targetSelectionRange))}t.isLocationLink=v;var m;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(m=t.SymbolKind||(t.SymbolKind={}));var l;(function(o){o[o.Deprecated=1]="Deprecated"})(l=t.SymbolTag||(t.SymbolTag={}));var c;(function(o){const M=new Map;M.set(0,F.Codicon.symbolFile),M.set(1,F.Codicon.symbolModule),M.set(2,F.Codicon.symbolNamespace),M.set(3,F.Codicon.symbolPackage),M.set(4,F.Codicon.symbolClass),M.set(5,F.Codicon.symbolMethod),M.set(6,F.Codicon.symbolProperty),M.set(7,F.Codicon.symbolField),M.set(8,F.Codicon.symbolConstructor),M.set(9,F.Codicon.symbolEnum),M.set(10,F.Codicon.symbolInterface),M.set(11,F.Codicon.symbolFunction),M.set(12,F.Codicon.symbolVariable),M.set(13,F.Codicon.symbolConstant),M.set(14,F.Codicon.symbolString),M.set(15,F.Codicon.symbolNumber),M.set(16,F.Codicon.symbolBoolean),M.set(17,F.Codicon.symbolArray),M.set(18,F.Codicon.symbolObject),M.set(19,F.Codicon.symbolKey),M.set(20,F.Codicon.symbolNull),M.set(21,F.Codicon.symbolEnumMember),M.set(22,F.Codicon.symbolStruct),M.set(23,F.Codicon.symbolEvent),M.set(24,F.Codicon.symbolOperator),M.set(25,F.Codicon.symbolTypeParameter);function U(C){let B=M.get(C);return B||(console.info("No codicon found for SymbolKind "+C),B=F.Codicon.symbolProperty),B}o.toIcon=U})(c=t.SymbolKinds||(t.SymbolKinds={}));class r{static fromValue(M){switch(M){case"comment":return r.Comment;case"imports":return r.Imports;case"region":return r.Region}return new r(M)}constructor(M){this.value=M}}r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region"),t.FoldingRangeKind=r;var s;(function(o){function M(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}o.is=M})(s=t.Command||(t.Command={}));var d;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(d=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var f;(function(o){o[o.Unresolved=0]="Unresolved",o[o.Resolved=1]="Resolved"})(f=t.CommentThreadState||(t.CommentThreadState={}));var A;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(A=t.CommentMode||(t.CommentMode={}));var b;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(b=t.InlayHintKind||(t.InlayHintKind={})),t.TokenizationRegistry=new u.TokenizationRegistry;var h;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(h=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),J(Z[53],ee([0,1,22,9,27,12,3,2,30,52,41]),function(q,t,F,T,i,u,y,N,a,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class R{static chord(e,E){return(0,i.KeyChord)(e,E)}}R.CtrlCmd=2048,R.Shift=1024,R.Alt=512,R.WinCtrl=256,t.KeyMod=R;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.CancellationTokenSource,Emitter:T.Emitter,KeyCode:p.KeyCode,KeyMod:R,Position:y.Position,Range:N.Range,Selection:a.Selection,SelectionDirection:p.SelectionDirection,MarkerSeverity:p.MarkerSeverity,MarkerTag:p.MarkerTag,Uri:u.URI,Token:g.Token}}t.createMonacoBaseAPI=w}),J(Z[58],ee([0,1,23,12,3,2,48,19,37,38,53,21,50,24,47,11]),function(q,t,F,T,i,u,y,N,a,g,p,R,w,L,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class D extends y.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(l){return this.d[l-1]}getWordAtPosition(l,c){const r=(0,N.getWordAtText)(l.column,(0,N.ensureValidWordDefinition)(c),this.d[l.lineNumber-1],0);return r?new u.Range(l.lineNumber,r.startColumn,l.lineNumber,r.endColumn):null}getWordUntilPosition(l,c){const r=this.getWordAtPosition(l,c);return r?{word:this.d[l.lineNumber-1].substring(r.startColumn-1,l.column-1),startColumn:r.startColumn,endColumn:l.column}:{word:"",startColumn:l.column,endColumn:l.column}}words(l){const c=this.d,r=this.p.bind(this);let s=0,d="",f=0,A=[];return{*[Symbol.iterator](){for(;;)if(f<A.length){const b=d.substring(A[f].start,A[f].end);f+=1,yield b}else if(s<c.length)d=c[s],A=r(d,l),f=0,s+=1;else break}}}getLineWords(l,c){const r=this.d[l-1],s=this.p(r,c),d=[];for(const f of s)d.push({word:r.substring(f.start,f.end),startColumn:f.start+1,endColumn:f.end+1});return d}p(l,c){const r=[];let s;for(c.lastIndex=0;(s=c.exec(l))&&s[0].length!==0;)r.push({start:s.index,end:s.index+s[0].length});return r}getValueInRange(l){if(l=this.q(l),l.startLineNumber===l.endLineNumber)return this.d[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const c=this.f,r=l.startLineNumber-1,s=l.endLineNumber-1,d=[];d.push(this.d[r].substring(l.startColumn-1));for(let f=r+1;f<s;f++)d.push(this.d[f]);return d.push(this.d[s].substring(0,l.endColumn-1)),d.join(c)}offsetAt(l){return l=this.r(l),this.k(),this.h.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this.k();const c=this.h.getIndexOf(l),r=this.d[c.index].length;return{lineNumber:1+c.index,column:1+Math.min(c.remainder,r)}}q(l){const c=this.r({lineNumber:l.startLineNumber,column:l.startColumn}),r=this.r({lineNumber:l.endLineNumber,column:l.endColumn});return c.lineNumber!==l.startLineNumber||c.column!==l.startColumn||r.lineNumber!==l.endLineNumber||r.column!==l.endColumn?{startLineNumber:c.lineNumber,startColumn:c.column,endLineNumber:r.lineNumber,endColumn:r.column}:l}r(l){if(!i.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:c,column:r}=l,s=!1;if(c<1)c=1,r=1,s=!0;else if(c>this.d.length)c=this.d.length,r=this.d[c-1].length+1,s=!0;else{const d=this.d[c-1].length+1;r<1?(r=1,s=!0):r>d&&(r=d,s=!0)}return s?{lineNumber:c,column:r}:l}}class _{constructor(l,c){this.c=l,this.d=Object.create(null),this.f=c,this.g=null}dispose(){this.d=Object.create(null)}h(l){return this.d[l]}j(){const l=[];return Object.keys(this.d).forEach(c=>l.push(this.d[c])),l}acceptNewModel(l){this.d[l.url]=new D(T.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,c){if(!this.d[l])return;this.d[l].onEvents(c)}acceptRemovedModel(l){!this.d[l]||delete this.d[l]}async computeUnicodeHighlights(l,c,r){const s=this.h(l);return s?w.UnicodeTextModelHighlighter.computeUnicodeHighlights(s,c,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(l,c,r,s){const d=this.h(l),f=this.h(c);return!d||!f?null:_.k(d,f,r,s)}static k(l,c,r,s){const d=s==="experimental"?e.linesDiffComputers.experimental:e.linesDiffComputers.smart,f=l.getLinesContent(),A=c.getLinesContent(),b=d.computeDiff(f,A,r);return{identical:b.changes.length>0?!1:this.l(l,c),quitEarly:b.quitEarly,changes:b.changes.map(o=>[o.originalRange.startLineNumber,o.originalRange.endLineNumberExclusive,o.modifiedRange.startLineNumber,o.modifiedRange.endLineNumberExclusive,o.innerChanges?.map(M=>[M.originalRange.startLineNumber,M.originalRange.startColumn,M.originalRange.endLineNumber,M.originalRange.endColumn,M.modifiedRange.startLineNumber,M.modifiedRange.startColumn,M.modifiedRange.endLineNumber,M.modifiedRange.endColumn])])}}static l(l,c){const r=l.getLineCount(),s=c.getLineCount();if(r!==s)return!1;for(let d=1;d<=r;d++){const f=l.getLineContent(d),A=c.getLineContent(d);if(f!==A)return!1}return!0}async computeDirtyDiff(l,c,r){const s=this.h(l),d=this.h(c);if(!s||!d)return null;const f=s.getLinesContent(),A=d.getLinesContent();return new L.DiffComputer(f,A,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:r,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(l,c,r){const s=this.h(l);if(!s)return c;const d=[];let f;c=c.slice(0).sort((A,b)=>{if(A.range&&b.range)return u.Range.compareRangesUsingStarts(A.range,b.range);const h=A.range?0:1,o=b.range?0:1;return h-o});for(let{range:A,text:b,eol:h}of c){if(typeof h=="number"&&(f=h),u.Range.isEmpty(A)&&!b)continue;const o=s.getValueInRange(A);if(b=b.replace(/\r\n|\n|\r/g,s.eol),o===b)continue;if(Math.max(b.length,o.length)>_.n){d.push({range:A,text:b});continue}const M=(0,F.stringDiff)(o,b,r),U=s.offsetAt(u.Range.lift(A).getStartPosition());for(const C of M){const B=s.positionAt(U+C.originalStart),V=s.positionAt(U+C.originalStart+C.originalLength),z={text:b.substr(C.modifiedStart,C.modifiedLength),range:{startLineNumber:B.lineNumber,startColumn:B.column,endLineNumber:V.lineNumber,endColumn:V.column}};s.getValueInRange(z.range)!==z.text&&d.push(z)}}return typeof f=="number"&&d.push({eol:f,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(l){const c=this.h(l);return c?(0,a.computeLinks)(c):null}async textualSuggest(l,c,r,s){const d=new R.StopWatch(!0),f=new RegExp(r,s),A=new Set;e:for(const b of l){const h=this.h(b);if(!!h){for(const o of h.words(f))if(!(o===c||!isNaN(Number(o)))&&(A.add(o),A.size>_.o))break e}}return{words:Array.from(A),duration:d.elapsed()}}async computeWordRanges(l,c,r,s){const d=this.h(l);if(!d)return Object.create(null);const f=new RegExp(r,s),A=Object.create(null);for(let b=c.startLineNumber;b<c.endLineNumber;b++){const h=d.getLineWords(b,f);for(const o of h){if(!isNaN(Number(o.word)))continue;let M=A[o.word];M||(M=[],A[o.word]=M),M.push({startLineNumber:b,startColumn:o.startColumn,endLineNumber:b,endColumn:o.endColumn})}}return A}async navigateValueSet(l,c,r,s,d){const f=this.h(l);if(!f)return null;const A=new RegExp(s,d);c.startColumn===c.endColumn&&(c={startLineNumber:c.startLineNumber,startColumn:c.startColumn,endLineNumber:c.endLineNumber,endColumn:c.endColumn+1});const b=f.getValueInRange(c),h=f.getWordAtPosition({lineNumber:c.startLineNumber,column:c.startColumn},A);if(!h)return null;const o=f.getValueInRange(h);return g.BasicInplaceReplace.INSTANCE.navigateValueSet(c,b,h,o,r)}loadForeignModule(l,c,r){const s=(A,b)=>this.c.fhr(A,b),f={host:(0,E.createProxyObject)(r,s),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(f,c),Promise.resolve((0,E.getAllMethodNames)(this.g))):new Promise((A,b)=>{q([l],h=>{this.g=h.create(f,c),A((0,E.getAllMethodNames)(this.g))},b)})}fmr(l,c){if(!this.g||typeof this.g[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.g[l].apply(this.g,c))}catch(r){return Promise.reject(r)}}}_.n=1e5,_.o=1e4,t.EditorSimpleWorker=_;function v(m){return new _(m,null)}t.create=v,typeof importScripts=="function"&&(globalThis.monaco=(0,p.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/base/worker/workerMain.js.map
