/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","vs/base/common/arrays","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],te=function(x){for(var e=[],P=0,L=x.length;P<L;P++)e[P]=ee[x[P]];return e};define(ee[127],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function P(k,f){const u=Math.pow(10,f);return Math.round(k*u)/u}class L{constructor(f,u,w,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=P(Math.max(Math.min(1,y),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.RGBA=L;class s{constructor(f,u,w,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,u),0),3),this.l=P(Math.max(Math.min(1,w),0),3),this.a=P(Math.max(Math.min(1,y),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,w=f.g/255,y=f.b/255,S=f.a,d=Math.max(u,w,y),I=Math.min(u,w,y);let b=0,r=0;const h=(I+d)/2,g=d-I;if(g>0){switch(r=Math.min(h<=.5?g/(2*h):g/(2-2*h),1),d){case u:b=(w-y)/g+(w<y?6:0);break;case w:b=(y-u)/g+2;break;case y:b=(u-w)/g+4;break}b*=60,b=Math.round(b)}return new s(b,r,h,S)}static i(f,u,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?f+(u-f)*6*w:w<1/2?u:w<2/3?f+(u-f)*(2/3-w)*6:f}static toRGBA(f){const u=f.h/360,{s:w,l:y,a:S}=f;let d,I,b;if(w===0)d=I=b=y;else{const r=y<.5?y*(1+w):y+w-y*w,h=2*y-r;d=s.i(h,r,u+1/3),I=s.i(h,r,u),b=s.i(h,r,u-1/3)}return new L(Math.round(d*255),Math.round(I*255),Math.round(b*255),S)}}e.HSLA=s;class A{constructor(f,u,w,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,u),0),3),this.v=P(Math.max(Math.min(1,w),0),3),this.a=P(Math.max(Math.min(1,y),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,w=f.g/255,y=f.b/255,S=Math.max(u,w,y),d=Math.min(u,w,y),I=S-d,b=S===0?0:I/S;let r;return I===0?r=0:S===u?r=((w-y)/I%6+6)%6:S===w?r=(y-u)/I+2:r=(u-w)/I+4,new A(Math.round(r*60),b,S,f.a)}static toRGBA(f){const{h:u,s:w,v:y,a:S}=f,d=y*w,I=d*(1-Math.abs(u/60%2-1)),b=y-d;let[r,h,g]=[0,0,0];return u<60?(r=d,h=I):u<120?(r=I,h=d):u<180?(h=d,g=I):u<240?(h=I,g=d):u<300?(r=I,g=d):u<=360&&(r=d,g=I),r=Math.round((r+b)*255),h=Math.round((h+b)*255),g=Math.round((g+b)*255),new L(r,h,g,S)}}e.HSVA=A;class R{static fromHex(f){return R.Format.CSS.parseHex(f)||R.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof L)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof A)this.j=f,this.rgba=A.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&L.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&A.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=R.k(this.rgba.r),u=R.k(this.rgba.g),w=R.k(this.rgba.b),y=.2126*f+.7152*u+.0722*w;return P(y,4)}static k(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),w=f.getRelativeLuminance();return u>w?(u+.05)/(w+.05):(w+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),w=f.getRelativeLuminance();return u>w}isDarkerThan(f){const u=this.getRelativeLuminance(),w=f.getRelativeLuminance();return u<w}lighten(f){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:w,b:y,a:S}=this.rgba;return new R(new L(u,w,y,S*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,w=this.rgba.a,y=u.a,S=w+y*(1-w);if(S<1e-6)return R.transparent;const d=this.rgba.r*w/S+u.r*y*(1-w)/S,I=this.rgba.g*w/S+u.g*y*(1-w)/S,b=this.rgba.b*w/S+u.b*y*(1-w)/S;return new R(new L(d,I,b,S))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:w,b:y,a:S}=this.rgba;return new R(new L(f.rgba.r-S*(f.rgba.r-u),f.rgba.g-S*(f.rgba.g-w),f.rgba.b-S*(f.rgba.b-y),1))}flatten(...f){const u=f.reduceRight((w,y)=>R.o(y,w));return R.o(this,u)}static o(f,u){const w=1-f.rgba.a;return new R(new L(w*u.rgba.r+f.rgba.a*f.rgba.r,w*u.rgba.g+f.rgba.a*f.rgba.g,w*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(f,u,w){if(f.isLighterThan(u))return f;w=w||.5;const y=f.getRelativeLuminance(),S=u.getRelativeLuminance();return w=w*(S-y)/S,f.lighten(w)}static getDarkerColor(f,u,w){if(f.isDarkerThan(u))return f;w=w||.5;const y=f.getRelativeLuminance(),S=u.getRelativeLuminance();return w=w*(y-S)/y,f.darken(w)}}R.white=new R(new L(255,255,255,1)),R.black=new R(new L(0,0,0,1)),R.red=new R(new L(255,0,0,1)),R.blue=new R(new L(0,0,255,1)),R.green=new R(new L(0,255,0,1)),R.cyan=new R(new L(0,255,255,1)),R.lightgrey=new R(new L(211,211,211,1)),R.transparent=new R(new L(0,0,0,0)),e.Color=R,function(k){let f;(function(u){let w;(function(y){function S(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}y.formatRGB=S;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=d;function I(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}y.formatHSL=I;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=b;function r(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function h(t){return`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}`}y.formatHex=h;function g(t,c=!1){return c&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}${r(Math.round(t.rgba.a*255))}`}y.formatHexA=g;function E(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}y.format=E;function p(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),n=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),o=16*C(t.charCodeAt(5))+C(t.charCodeAt(6));return new k(new L(i,n,o,1))}if(c===9){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),n=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),o=16*C(t.charCodeAt(5))+C(t.charCodeAt(6)),l=16*C(t.charCodeAt(7))+C(t.charCodeAt(8));return new k(new L(i,n,o,l/255))}if(c===4){const i=C(t.charCodeAt(1)),n=C(t.charCodeAt(2)),o=C(t.charCodeAt(3));return new k(new L(16*i+i,16*n+n,16*o+o))}if(c===5){const i=C(t.charCodeAt(1)),n=C(t.charCodeAt(2)),o=C(t.charCodeAt(3)),l=C(t.charCodeAt(4));return new k(new L(16*i+i,16*n+n,16*o+o,(16*l+l)/255))}return null}y.parseHex=p;function C(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=u.CSS||(u.CSS={}))})(f=k.Format||(k.Format={}))}(R=e.Color||(e.Color={})),e.Color=R}),define(ee[55],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function P(R){return(k,f,u)=>{let w=null,y=null;if(typeof u.value=="function"?(w="value",y=u.value):typeof u.get=="function"&&(w="get",y=u.get),!y)throw new Error("not supported");u[w]=R(y,f)}}function L(R,k,f){let u=null,w=null;if(typeof f.value=="function"?(u="value",w=f.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",w=f.get),!w)throw new Error("not supported");const y=`$memoize$${k}`;f[u]=function(...S){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,S)}),this[y]}}e.memoize=L;function s(R,k,f){return P((u,w)=>{const y=`$debounce$${w}`,S=`$debounce$result$${w}`;return function(...d){this[S]||(this[S]=f?f():void 0),clearTimeout(this[y]),k&&(this[S]=k(this[S],...d),d=[this[S]]),this[y]=setTimeout(()=>{u.apply(this,d),this[S]=f?f():void 0},R)}})}e.debounce=s;function A(R,k,f){return P((u,w)=>{const y=`$throttle$timer$${w}`,S=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,I=`$throttle$pending$${w}`;return function(...b){if(this[S]||(this[S]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),k&&(this[S]=k(this[S],...b)),this[I])return;const r=this[d]+R;r<=Date.now()?(this[d]=Date.now(),u.apply(this,[this[S]]),this[S]=f?f():void 0):(this[I]=!0,this[y]=setTimeout(()=>{this[I]=!1,this[d]=Date.now(),u.apply(this,[this[S]]),this[S]=f?f():void 0},r-Date.now()))}})}e.throttle=A}),define(ee[13],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class P{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?p.isErrorNoTelemetry(c)?new p(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(i=>{i(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=P,e.errorHandler=new P;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function s(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=s;function A(t){u(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function R(t){u(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function k(t){if(t instanceof Error){const{name:c,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:n,noTelemetry:p.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const f="Canceled";function u(t){return t instanceof w?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=u;class w extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=w;function y(){const t=new Error(f);return t.name=t.message,t}e.canceled=y;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function I(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function b(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=b;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class h extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=h;class g extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=g;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=E;class p extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof p)return c;const i=new p;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class C extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}e.BugIndicatingError=C}),define(ee[26],te([0,1,13]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(j,B=0){return j[j.length-(1+B)]}e.tail=L;function s(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=s;function A(j,B,K=(re,he)=>re===he){if(j===B)return!0;if(!j||!B||j.length!==B.length)return!1;for(let re=0,he=j.length;re<he;re++)if(!K(j[re],B[re]))return!1;return!0}e.equals=A;function R(j,B){const K=j.length-1;B<K&&(j[B]=j[K]),j.pop()}e.removeFastWithoutKeepingOrder=R;function k(j,B,K){return f(j.length,re=>K(j[re],B))}e.binarySearch=k;function f(j,B){let K=0,re=j-1;for(;K<=re;){const he=(K+re)/2|0,ve=B(he);if(ve<0)K=he+1;else if(ve>0)re=he-1;else return he}return-(K+1)}e.binarySearch2=f;function u(j,B){let K=0,re=j.length;if(re===0)return 0;for(;K<re;){const he=Math.floor((K+re)/2);B(j[he])?re=he:K=he+1}return K}e.findFirstInSorted=u;function w(j,B,K){if(j=j|0,j>=B.length)throw new TypeError("invalid index");const re=B[Math.floor(B.length*Math.random())],he=[],ve=[],Se=[];for(const Oe of B){const Le=K(Oe,re);Le<0?he.push(Oe):Le>0?ve.push(Oe):Se.push(Oe)}return j<he.length?w(j,he,K):j<he.length+Se.length?Se[0]:w(j-(he.length+Se.length),ve,K)}e.quickSelect=w;function y(j,B){const K=[];let re;for(const he of j.slice(0).sort(B))!re||B(re[0],he)!==0?(re=[he],K.push(re)):re.push(he);return K}e.groupBy=y;function S(j,B,K){const re=[];function he(Oe,Le,Fe){if(Le===0&&Fe.length===0)return;const me=re[re.length-1];me&&me.start+me.deleteCount===Oe?(me.deleteCount+=Le,me.toInsert.push(...Fe)):re.push({start:Oe,deleteCount:Le,toInsert:Fe})}let ve=0,Se=0;for(;;){if(ve===j.length){he(ve,0,B.slice(Se));break}if(Se===B.length){he(ve,j.length-ve,[]);break}const Oe=j[ve],Le=B[Se],Fe=K(Oe,Le);Fe===0?(ve+=1,Se+=1):Fe<0?(he(ve,1,[]),ve+=1):Fe>0&&(he(ve,0,[Le]),Se+=1)}return re}e.sortedDiff=S;function d(j,B,K){const re=S(j,B,K),he=[],ve=[];for(const Se of re)he.push(...j.slice(Se.start,Se.start+Se.deleteCount)),ve.push(...Se.toInsert);return{removed:he,added:ve}}e.delta=d;function I(j,B,K){if(K===0)return[];const re=j.slice(0,K).sort(B);return r(j,B,re,K,j.length),re}e.top=I;function b(j,B,K,re,he){return K===0?Promise.resolve([]):new Promise((ve,Se)=>{(async()=>{const Oe=j.length,Le=j.slice(0,K).sort(B);for(let Fe=K,me=Math.min(K+re,Oe);Fe<Oe;Fe=me,me=Math.min(me+re,Oe)){if(Fe>K&&await new Promise(pe=>setTimeout(pe)),he&&he.isCancellationRequested)throw new P.CancellationError;r(j,B,Le,Fe,me)}return Le})().then(ve,Se)})}e.topAsync=b;function r(j,B,K,re,he){for(const ve=K.length;re<he;re++){const Se=j[re];if(B(Se,K[ve-1])<0){K.pop();const Oe=u(K,Le=>B(Se,Le)<0);K.splice(Oe,0,Se)}}}function h(j){return j.filter(B=>!!B)}e.coalesce=h;function g(j){let B=0;for(let K=0;K<j.length;K++)j[K]&&(j[B]=j[K],B+=1);j.length=B}e.coalesceInPlace=g;function E(j,B,K){j.splice(K,0,j.splice(B,1)[0])}e.move=E;function p(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=p;function C(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=C;function t(j,B=K=>K){const K=new Set;return j.filter(re=>{const he=B(re);return K.has(he)?!1:(K.add(he),!0)})}e.distinct=t;function c(j){const B=new Set;return K=>{const re=j(K);return B.has(re)?!1:(B.add(re),!0)}}e.uniqueFilter=c;function i(j,B){const K=n(j,B);if(K!==-1)return j[K]}e.findLast=i;function n(j,B){for(let K=j.length-1;K>=0;K--){const re=j[K];if(B(re))return K}return-1}e.lastIndex=n;function o(j,B){return j.length>0?j[0]:B}e.firstOrDefault=o;function l(j,B){return j.length>0?j[j.length-1]:B}e.lastOrDefault=l;function a(j,B,K=(re,he)=>re===he){let re=0;for(let he=0,ve=Math.min(j.length,B.length);he<ve&&K(j[he],B[he]);he++)re++;return re}e.commonPrefixLength=a;function m(j){return[].concat(...j)}e.flatten=m;function D(j,B){let K=typeof B=="number"?j:0;typeof B=="number"?K=j:(K=0,B=j);const re=[];if(K<=B)for(let he=K;he<B;he++)re.push(he);else for(let he=K;he>B;he--)re.push(he);return re}e.range=D;function M(j,B,K){return j.reduce((re,he)=>(re[B(he)]=K?K(he):he,re),Object.create(null))}e.index=M;function T(j,B){return j.push(B),()=>$(j,B)}e.insert=T;function $(j,B){const K=j.indexOf(B);if(K>-1)return j.splice(K,1),B}e.remove=$;function z(j,B,K){const re=j.slice(0,B),he=j.slice(B);return re.concat(K,he)}e.arrayInsert=z;function q(j,B){let K;if(typeof B=="number"){let re=B;K=()=>{const he=Math.sin(re++)*179426549;return he-Math.floor(he)}}else K=Math.random;for(let re=j.length-1;re>0;re-=1){const he=Math.floor(K()*(re+1)),ve=j[re];j[re]=j[he],j[he]=ve}}e.shuffle=q;function ie(j,B){const K=j.indexOf(B);K>-1&&(j.splice(K,1),j.unshift(B))}e.pushToStart=ie;function oe(j,B){const K=j.indexOf(B);K>-1&&(j.splice(K,1),j.push(B))}e.pushToEnd=oe;function ae(j,B){for(const K of B)j.push(K)}e.pushMany=ae;function de(j,B){return Array.isArray(j)?j.map(B):B(j)}e.mapArrayOrNot=de;function ce(j){return Array.isArray(j)?j:[j]}e.asArray=ce;function J(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=J;function Y(j,B){for(const K of j){const re=B(K);if(re!==void 0)return re}}e.mapFind=Y;function H(j,B,K){const re=V(j,B),he=j.length,ve=K.length;j.length=he+ve;for(let Se=he-1;Se>=re;Se--)j[Se+ve]=j[Se];for(let Se=0;Se<ve;Se++)j[Se+re]=K[Se]}e.insertInto=H;function F(j,B,K,re){const he=V(j,B),ve=j.splice(he,K);return H(j,he,re),ve}e.splice=F;function V(j,B){return B<0?Math.max(B+j.length,0):Math.min(B,j.length)}var Z;(function(j){function B(he){return he<0}j.isLessThan=B;function K(he){return he>0}j.isGreaterThan=K;function re(he){return he===0}j.isNeitherLessOrGreaterThan=re,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function ne(j,B){return(K,re)=>B(j(K),j(re))}e.compareBy=ne;function se(...j){return(B,K)=>{for(const re of j){const he=re(B,K);if(!Z.isNeitherLessOrGreaterThan(he))return he}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=se;const U=(j,B)=>j-B;e.numberComparator=U;function v(j,B){if(j.length===0)return;let K=j[0];for(let re=1;re<j.length;re++){const he=j[re];B(he,K)>0&&(K=he)}return K}e.findMaxBy=v;function O(j,B){if(j.length===0)return;let K=j[0];for(let re=1;re<j.length;re++){const he=j[re];B(he,K)>=0&&(K=he)}return K}e.findLastMaxBy=O;function W(j,B){return v(j,(K,re)=>-B(K,re))}e.findMinBy=W;class N{constructor(B){this.f=B,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(B){let K=this.c;for(;K<this.f.length&&B(this.f[K]);)K++;const re=K===this.c?null:this.f.slice(this.c,K);return this.c=K,re}takeFromEndWhile(B){let K=this.d;for(;K>=0&&B(this.f[K]);)K--;const re=K===this.d?null:this.f.slice(K+1,this.d+1);return this.d=K,re}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const B=this.f[this.c];return this.c++,B}removeLast(){const B=this.f[this.d];return this.d--,B}takeCount(B){const K=this.f.slice(this.c,this.c+B);return this.c+=B,K}}e.ArrayQueue=N;class G{constructor(B){this.iterate=B}forEach(B){this.iterate(K=>(B(K),!0))}toArray(){const B=[];return this.iterate(K=>(B.push(K),!0)),B}filter(B){return new G(K=>this.iterate(re=>B(re)?K(re):!0))}map(B){return new G(K=>this.iterate(re=>K(B(re))))}some(B){let K=!1;return this.iterate(re=>(K=B(re),!K)),K}findFirst(B){let K;return this.iterate(re=>B(re)?(K=re,!1):!0),K}findLast(B){let K;return this.iterate(re=>(B(re)&&(K=re),!0)),K}findLastMaxBy(B){let K,re=!0;return this.iterate(he=>((re||Z.isGreaterThan(B(he,K)))&&(re=!1,K=he),!0)),K}}G.empty=new G(j=>{}),e.CallbackIterable=G}),define(ee[128],te([0,1,13]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=L;function s(f,u="Unreachable"){throw new Error(u)}e.assertNever=s;function A(f){if(!f)throw new P.BugIndicatingError("Assertion Failed")}e.assert=A;function R(f){if(!f()){debugger;f(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function k(f,u){let w=0;for(;w<f.length-1;){const y=f[w],S=f[w+1];if(!u(y,S))return!1;w++}return!0}e.checkAdjacentItems=k}),define(ee[50],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function P(L){const s=this;let A=!1,R;return function(){return A||(A=!0,R=L.apply(s,arguments)),R}}e.once=P}),define(ee[71],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(L){function s(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=s;const A=Object.freeze([]);function R(){return A}L.empty=R;function*k(p){yield p}L.single=k;function f(p){return s(p)?p:k(p)}L.wrap=f;function u(p){return p||A}L.from=u;function w(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=w;function y(p){return p[Symbol.iterator]().next().value}L.first=y;function S(p,C){for(const t of p)if(C(t))return!0;return!1}L.some=S;function d(p,C){for(const t of p)if(C(t))return t}L.find=d;function*I(p,C){for(const t of p)C(t)&&(yield t)}L.filter=I;function*b(p,C){let t=0;for(const c of p)yield C(c,t++)}L.map=b;function*r(...p){for(const C of p)for(const t of C)yield t}L.concat=r;function h(p,C,t){let c=t;for(const i of p)c=C(c,i);return c}L.reduce=h;function*g(p,C,t=p.length){for(C<0&&(C+=p.length),t<0?t+=p.length:t>p.length&&(t=p.length);C<t;C++)yield p[C]}L.slice=g;function E(p,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,p];const c=p[Symbol.iterator]();for(let i=0;i<C;i++){const n=c.next();if(n.done)return[t,L.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return c}}]}L.consume=E})(P=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(t,c=!1){let i=0;const n=t.length;let o="",l=0,a=16,m=0;function D(oe){let ae=0,de=0;for(;ae<oe;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)de=de*16+ce-48;else if(ce>=65&&ce<=70)de=de*16+ce-65+10;else if(ce>=97&&ce<=102)de=de*16+ce-97+10;else break;i++,ae++}return ae<oe&&(de=-1),de}function M(oe){i=oe,o="",l=0,a=16,m=0}function T(){const oe=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return m=3,t.substring(oe,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ae=i}else m=3;return t.substring(oe,ae)}function $(){let oe="",ae=i;for(;;){if(i>=n){oe+=t.substring(ae,i),m=2;break}const de=t.charCodeAt(i);if(de===34){oe+=t.substring(ae,i),i++;break}if(de===92){if(oe+=t.substring(ae,i),i++,i>=n){m=2;break}switch(t.charCodeAt(i++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const J=D(4);J>=0?oe+=String.fromCharCode(J):m=4;break}default:m=5}ae=i;continue}if(de>=0&&de<=31)if(f(de)){oe+=t.substring(ae,i),m=2;break}else m=6;i++}return oe}function z(){if(o="",m=0,l=i,i>=n)return l=n,a=17;let oe=t.charCodeAt(i);if(k(oe)){do i++,o+=String.fromCharCode(oe),oe=t.charCodeAt(i);while(k(oe));return a=15}if(f(oe))return i++,o+=String.fromCharCode(oe),oe===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(oe){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=$(),a=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!f(t.charCodeAt(i));)i++;return o=t.substring(ae,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const de=n-1;let ce=!1;for(;i<de;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,m=1),o=t.substring(ae,i),a=13}return o+=String.fromCharCode(oe),i++,a=16}case 45:if(o+=String.fromCharCode(oe),i++,i===n||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),a=11;default:for(;i<n&&q(oe);)i++,oe=t.charCodeAt(i);if(l!==i){switch(o=t.substring(l,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(oe),i++,a=16}}function q(oe){if(k(oe)||f(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let oe;do oe=z();while(oe>=12&&oe<=15);return oe}return{setPosition:M,getPosition:()=>i,scan:c?ie:z,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>m}}e.createScanner=R;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function y(t,c){const i=[],n=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function m(D,M,T,$){l.value=D,l.offset=M,l.length=T,l.type=$,l.colonOffset=void 0,o=l}try{E(t,{onObjectBegin:(D,M)=>{if(c<=D)throw n;o=void 0,a=c>D,i.push("")},onObjectProperty:(D,M,T)=>{if(c<M||(m(D,M,T,"property"),i[i.length-1]=D,c<=M+T))throw n},onObjectEnd:(D,M)=>{if(c<=D)throw n;o=void 0,i.pop()},onArrayBegin:(D,M)=>{if(c<=D)throw n;o=void 0,i.push(0)},onArrayEnd:(D,M)=>{if(c<=D)throw n;o=void 0,i.pop()},onLiteralValue:(D,M,T)=>{if(c<M||(m(D,M,T,C(D)),c<=M+T))throw n},onSeparator:(D,M,T)=>{if(c<=M)throw n;if(D===":"&&o&&o.type==="property")o.colonOffset=M,a=!1,o=void 0;else if(D===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(D){if(D!==n)throw D}return{path:i,previousNode:o,isAtPropertyKey:a,matches:D=>{let M=0;for(let T=0;M<D.length&&T<i.length;T++)if(D[M]===i[T]||D[M]==="*")M++;else if(D[M]!=="**")return!1;return M===D.length}}}e.getLocation=y;function S(t,c=[],i=A.DEFAULT){let n=null,o=[];const l=[];function a(D){Array.isArray(o)?o.push(D):n!==null&&(o[n]=D)}return E(t,{onObjectBegin:()=>{const D={};a(D),l.push(o),o=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const D=[];a(D),l.push(o),o=D,n=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:a,onError:(D,M,T)=>{c.push({error:D,offset:M,length:T})}},i),o[0]}e.parse=S;function d(t,c=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function l(D){return n.children.push(D),D}E(t,{onObjectBegin:D=>{n=l({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,M,T)=>{n=l({type:"property",offset:M,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:M,length:T,parent:n})},onObjectEnd:(D,M)=>{n.length=D+M-n.offset,n=n.parent,o(D+M)},onArrayBegin:(D,M)=>{n=l({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,M)=>{n.length=D+M-n.offset,n=n.parent,o(D+M)},onLiteralValue:(D,M,T)=>{l({type:C(D),offset:M,length:T,parent:n,value:D}),o(M+T)},onSeparator:(D,M,T)=>{n.type==="property"&&(D===":"?n.colonOffset=M:D===","&&o(M))},onError:(D,M,T)=>{c.push({error:D,offset:M,length:T})}},i);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=d;function I(t,c){if(!t)return;let i=t;for(const n of c)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===n){i=l.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=I;function b(t){if(!t.parent||!t.parent.children)return[];const c=b(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=b;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const c=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(c[i.children[0].value]=r(n))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function h(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=h;function g(t,c,i=!1){if(h(t,c,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const l=g(n[o],c,i);if(l)return l}return t}}e.findNodeAtOffset=g;function E(t,c,i=A.DEFAULT){const n=R(t,!1);function o(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(ne){return ne?se=>ne(se,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(c.onObjectBegin),m=l(c.onObjectProperty),D=o(c.onObjectEnd),M=o(c.onArrayBegin),T=o(c.onArrayEnd),$=l(c.onLiteralValue),z=l(c.onSeparator),q=o(c.onComment),ie=l(c.onError),oe=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function de(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:oe||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ne){case 12:case 13:oe?ce(10):q();break;case 16:ce(1);break;case 15:case 14:break;default:return ne}}}function ce(ne,se=[],U=[]){if(ie(ne),se.length+U.length>0){let v=n.getToken();for(;v!==17;){if(se.indexOf(v)!==-1){de();break}else if(U.indexOf(v)!==-1)break;v=de()}}}function J(ne){const se=n.getTokenValue();return ne?$(se):m(se),de(),!0}function Y(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(ce(2),ne=0)}catch{ce(2)}$(ne);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return de(),!0}function H(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(J(!1),n.getToken()===6?(z(":"),de(),Z()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function F(){a(),de();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||ce(4,[],[]),z(","),de(),n.getToken()===2&&ae)break}else ne&&ce(6,[],[]);H()||ce(4,[],[2,5]),ne=!0}return D(),n.getToken()!==2?ce(7,[2],[]):de(),!0}function V(){M(),de();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||ce(4,[],[]),z(","),de(),n.getToken()===4&&ae)break}else ne&&ce(6,[],[]);Z()||ce(4,[],[4,5]),ne=!0}return T(),n.getToken()!==4?ce(8,[4],[]):de(),!0}function Z(){switch(n.getToken()){case 3:return V();case 1:return F();case 10:return J(!0);default:return Y()}}return de(),n.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):Z()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=E;function p(t,c){const i=R(t),n=[];let o,l=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:l!==a&&n.push(t.substring(l,a)),c!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,c)),l=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=p;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(ee[129],te([0,1,43]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(u,w,y){let S,d,I,b,r;if(w){for(b=w.offset,r=b+w.length,I=b;I>0&&!f(u,I-1);)I--;let a=r;for(;a<u.length&&!f(u,a);)a++;d=u.substring(I,a),S=R(d,y)}else d=u,S=0,I=0,b=0,r=u.length;const h=k(y,u);let g=!1,E=0,p;y.insertSpaces?p=A(" ",y.tabSize||4):p="	";const C=(0,P.createScanner)(d,!1);let t=!1;function c(){return h+A(p,S+E)}function i(){let a=C.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=C.scan();return t=a===16||C.getTokenError()!==0,a}const n=[];function o(a,m,D){!t&&m<r&&D>b&&u.substring(m,D)!==a&&n.push({offset:m,length:D-m,content:a})}let l=i();if(l!==17){const a=C.getTokenOffset()+I,m=A(p,S);o(m,I,a)}for(;l!==17;){let a=C.getTokenOffset()+C.getTokenLength()+I,m=i(),D="";for(;!g&&(m===12||m===13);){const T=C.getTokenOffset()+I;o(" ",a,T),a=C.getTokenOffset()+C.getTokenLength()+I,D=m===12?c():"",m=i()}if(m===2)l!==1&&(E--,D=c());else if(m===4)l!==3&&(E--,D=c());else{switch(l){case 3:case 1:E++,D=c();break;case 5:case 12:D=c();break;case 13:g?D=c():D=" ";break;case 6:D=" ";break;case 10:if(m===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?D=" ":m!==5&&m!==17&&(t=!0);break;case 16:t=!0;break}g&&(m===12||m===13)&&(D=c())}const M=C.getTokenOffset()+I;o(D,a,M),l=m}return n}e.format=L;function s(u,w){const y=JSON.stringify(u,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?y.replace(/\r\n|\r|\n/g,w.eol):y}e.toFormattedString=s;function A(u,w){let y="";for(let S=0;S<w;S++)y+=u;return y}function R(u,w){let y=0,S=0;const d=w.tabSize||4;for(;y<u.length;){const I=u.charAt(y);if(I===" ")S++;else if(I==="	")S+=d;else break;y++}return Math.floor(S/d)}function k(u,w){for(let y=0;y<w.length;y++){const S=w.charAt(y);if(S==="\r")return y+1<w.length&&w.charAt(y+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return u&&u.eol||`
`}e.getEOL=k;function f(u,w){return`\r
`.indexOf(u.charAt(w))!==-1}e.isEOL=f}),define(ee[130],te([0,1,43,129]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function s(u,w,y){return A(u,w,void 0,y)}e.removeProperty=s;function A(u,w,y,S,d){const I=w.slice(),b=[],r=(0,P.parseTree)(u,b);let h,g;for(;I.length>0&&(g=I.pop(),h=(0,P.findNodeAtLocation)(r,I),h===void 0&&y!==void 0);)typeof g=="string"?y={[g]:y}:y=[y];if(h)if(h.type==="object"&&typeof g=="string"&&Array.isArray(h.children)){const E=(0,P.findNodeAtLocation)(h,[g]);if(E!==void 0)if(y===void 0){if(!E.parent)throw new Error("Malformed AST");const p=h.children.indexOf(E.parent);let C,t=E.parent.offset+E.parent.length;if(p>0){const c=h.children[p-1];C=c.offset+c.length}else C=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return R(u,{offset:C,length:t-C,content:""},S)}else return R(u,{offset:E.offset,length:E.length,content:JSON.stringify(y)},S);else{if(y===void 0)return[];const p=`${JSON.stringify(g)}: ${JSON.stringify(y)}`,C=d?d(h.children.map(c=>c.children[0].value)):h.children.length;let t;if(C>0){const c=h.children[C-1];t={offset:c.offset+c.length,length:0,content:","+p}}else h.children.length===0?t={offset:h.offset+1,length:0,content:p}:t={offset:h.offset+1,length:0,content:p+","};return R(u,t,S)}}else if(h.type==="array"&&typeof g=="number"&&Array.isArray(h.children))if(y!==void 0){const E=`${JSON.stringify(y)}`;let p;if(h.children.length===0||g===0)p={offset:h.offset+1,length:0,content:h.children.length===0?E:E+","};else{const C=g===-1||g>h.children.length?h.children.length:g,t=h.children[C-1];p={offset:t.offset+t.length,length:0,content:","+E}}return R(u,p,S)}else{const E=g,p=h.children[E];let C;if(h.children.length===1)C={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===E){const t=h.children[E-1],c=t.offset+t.length,i=h.offset+h.length;C={offset:c,length:i-2-c,content:""}}else C={offset:p.offset,length:h.children[E+1].offset-p.offset,content:""};return R(u,C,S)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${h.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return R(u,{offset:r?r.offset:0,length:r?r.length:0,content:JSON.stringify(y)},S)}}e.setProperty=A;function R(u,w,y){let S=k(u,w),d=w.offset,I=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;d>0&&!(0,L.isEOL)(S,d-1);)d--;for(;I<S.length&&!(0,L.isEOL)(S,I);)I++}const b=(0,L.format)(S,{offset:d,length:I-d},y);for(let h=b.length-1;h>=0;h--){const g=b[h];S=k(S,g),d=Math.min(d,g.offset),I=Math.max(I,g.offset+g.length),I+=g.content.length-g.length}const r=u.length-(S.length-I)-d;return[{offset:d,length:r,content:S.substring(d,I)}]}e.withFormatting=R;function k(u,w){return u.substring(0,w.offset)+w.content+u.substring(w.offset+w.length)}e.applyEdit=k;function f(u,w){const y=w.slice(0).sort((d,I)=>{const b=d.offset-I.offset;return b===0?d.length-I.length:b});let S=u.length;for(let d=y.length-1;d>=0;d--){const I=y[d];if(I.offset+I.length<=S)u=k(u,I);else throw new Error("Overlapping edit");S=I.offset}return u}e.applyEdits=f}),define(ee[131],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=P}),define(ee[2],te([0,1,50,71]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const s=!1;let A=null;function R(l){A=l}if(e.setDisposableTracker=R,s){const l="__is_disposable_tracked__";R(new class{trackDisposable(a){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(m)},3e3)}setParent(a,m){if(a&&a!==g.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==g.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function k(l){return A?.trackDisposable(l),l}function f(l){A?.markAsDisposed(l)}function u(l,a){A?.setParent(l,a)}function w(l,a){if(!!A)for(const m of l)A.setParent(m,a)}function y(l){return A?.markAsSingleton(l),l}e.markAsSingleton=y;function S(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=S;function d(l){if(L.Iterable.is(l)){const a=[];for(const m of l)if(m)try{m.dispose()}catch(D){a.push(D)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=d;function I(l){for(const a of l)S(a)&&a.dispose();return[]}e.disposeIfDisposable=I;function b(...l){const a=r(()=>d(l));return w(l,a),a}e.combinedDisposable=b;function r(l){const a=k({dispose:(0,P.once)(()=>{f(a),l()})});return a}e.toDisposable=r;class h{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return u(a,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class g{constructor(){this.B=new h,k(this),u(this.B,this)}dispose(){f(this),this.B.dispose()}D(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(a)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class E{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&u(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&u(a,null),a}}e.MutableDisposable=E;class p{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=p;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(a){let m=a;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,f(this))},this}}e.SafeDisposable=C;class t{constructor(){this.a=new Map}acquire(a,...m){let D=this.a.get(a);D||(D={counter:0,object:this.b(a,...m)},this.a.set(a,D));const{object:M}=D,T=(0,P.once)(()=>{--D.counter===0&&(this.c(a,D.object),this.a.delete(a))});return D.counter++,{object:M,dispose:T}}}e.ReferenceCollection=t;class c{constructor(a){this.a=a}async acquire(a,...m){const D=this.a.acquire(a,...m);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(M){throw D.dispose(),M}}}e.AsyncReferenceCollection=c;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function n(l){const a=new h;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=n;class o{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,m,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(a)?.dispose(),this.a.set(a,m)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ee[100],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{constructor(A){this.element=A,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class L{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let A=this.a;for(;A!==P.Undefined;){const R=A.next;A.prev=P.Undefined,A.next=P.Undefined,A=R}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const k=new P(A);if(this.a===P.Undefined)this.a=k,this.b=k;else if(R){const u=this.b;this.b=k,k.prev=u,u.next=k}else{const u=this.a;this.a=k,k.next=u,u.prev=k}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(k))}}shift(){if(this.a!==P.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==P.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==P.Undefined&&A.next!==P.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===P.Undefined&&A.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):A.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):A.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==P.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ee[35],te([0,1]),function(x,e){"use strict";var P,L,s;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(b,r,h){let g=b.get(r);return g===void 0&&(g=h,b.set(r,g)),g}e.getOrSet=A;function R(b){const r=[];return b.forEach((h,g)=>{r.push(`${g} => ${h}`)}),`Map(${b.size}) {${r.join(", ")}}`}e.mapToString=R;function k(b){const r=[];return b.forEach(h=>{r.push(h)}),`Set(${b.size}) {${r.join(", ")}}`}e.setToString=k;class f{constructor(r,h){this.uri=r,this.value=h}}class u{constructor(r,h){this[P]="ResourceMap",r instanceof u?(this.b=new Map(r.b),this.c=h??u.a):(this.b=new Map,this.c=r??u.a)}set(r,h){return this.b.set(this.c(r),new f(r,h)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,h){typeof h<"u"&&(r=r.bind(h));for(const[g,E]of this.b)r(E.value,E.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}u.a=b=>b.toString(),e.ResourceMap=u;class w{constructor(r,h){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new u(r):(this.a=new u(h),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,h){this.a.forEach((g,E)=>r.call(h,E,E,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var y;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class S{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,h=0){const g=this.a.get(r);if(!!g)return h!==0&&this.j(g,h),g.value}set(r,h,g=0){let E=this.a.get(r);if(E)E.value=h,g!==0&&this.j(E,g);else{switch(E={key:r,value:h,next:void 0,previous:void 0},g){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(r,E),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const h=this.a.get(r);if(!!h)return this.a.delete(r),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,h){const g=this.e;let E=this.b;for(;E;){if(h?r.bind(h)(E.value,E.key,this):r(E.value,E.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const r=this,h=this.e;let g=this.b;const E={[Symbol.iterator](){return E},next(){if(r.e!==h)throw new Error("LinkedMap got modified during iteration.");if(g){const p={value:g.key,done:!1};return g=g.next,p}else return{value:void 0,done:!0}}};return E}values(){const r=this,h=this.e;let g=this.b;const E={[Symbol.iterator](){return E},next(){if(r.e!==h)throw new Error("LinkedMap got modified during iteration.");if(g){const p={value:g.value,done:!1};return g=g.next,p}else return{value:void 0,done:!0}}};return E}entries(){const r=this,h=this.e;let g=this.b;const E={[Symbol.iterator](){return E},next(){if(r.e!==h)throw new Error("LinkedMap got modified during iteration.");if(g){const p={value:[g.key,g.value],done:!1};return g=g.next,p}else return{value:void 0,done:!0}}};return E}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let h=this.b,g=this.size;for(;h&&g>r;)this.a.delete(h.key),h=h.next,g--;this.b=h,this.d=g,h&&(h.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const h=r.next,g=r.previous;if(!h||!g)throw new Error("Invalid list");h.previous=g,g.next=h}r.next=void 0,r.previous=void 0,this.e++}j(r,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(r===this.b)return;const g=r.next,E=r.previous;r===this.c?(E.next=void 0,this.c=E):(g.previous=E,E.next=g),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(h===2){if(r===this.c)return;const g=r.next,E=r.previous;r===this.b?(g.previous=void 0,this.b=g):(g.previous=E,E.next=g),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((h,g)=>{r.push([g,h])}),r}fromJSON(r){this.clear();for(const[h,g]of r)this.set(h,g)}}e.LinkedMap=S;class d extends S{constructor(r,h=1){super(),this.k=r,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,h=2){return super.get(r,h)}peek(r){return super.get(r,0)}set(r,h){return super.set(r,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class I{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let h=this.a.get(r)||0;return h===0?!1:(h--,h===0?this.a.delete(r):this.a.set(r,h),!0)}has(r){return this.a.has(r)}}e.CounterSet=I}),define(ee[82],te([0,1,35]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new P.LRUCache(1e4);function s(u){return f(u,"NFC",L)}e.normalizeNFC=s;const A=new P.LRUCache(1e4);function R(u){return f(u,"NFD",A)}e.normalizeNFD=R;const k=/[^\u0000-\u0080]/;function f(u,w,y){if(!u)return u;const S=y.get(u);if(S)return S;let d;return k.test(u)?d=u.normalize(w):d=u,y.set(u,d),d}e.removeAccents=function(){const u=/[\u0300-\u036f]/g;return function(w){return R(w).replace(u,"")}}()}),define(ee[132],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function P(k,f,u){return Math.min(Math.max(k,f),u)}e.clamp=P;function L(k,f){return(f+k%f)%f}e.rot=L;class s{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=s;class A{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const u=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function x(s){const A=[];typeof s=="number"&&A.push("code/timeOrigin",s);function R(f){A.push(f,Date.now())}function k(){const f=[];for(let u=0;u<A.length;u+=2)f.push({name:A[u],startTime:A[u+1]});return f}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(s+R.startTime)});return A}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=P(L))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var L in P)(typeof exports=="object"?exports:x)[L]=P[L]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function P(L){if(e[L])return e[L].exports;var s=e[L]={i:L,l:!1,exports:{}};return x[L].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=x,P.c=e,P.d=function(L,s,A){P.o(L,s)||Object.defineProperty(L,s,{enumerable:!0,get:A})},P.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},P.t=function(L,s){if(1&s&&(L=P(L)),8&s||4&s&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(P.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&s&&typeof L!="string")for(var R in L)P.d(A,R,function(k){return L[k]}.bind(null,R));return A},P.n=function(L){var s=L&&L.__esModule?function(){return L.default}:function(){return L};return P.d(s,"a",s),s},P.o=function(L,s){return Object.prototype.hasOwnProperty.call(L,s)},P.p="",P(P.s=0)}([function(x,e,P){(function(L){var s;e=x.exports=U,s=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],f=e.src=[],u=0,w=u++;f[w]="0|[1-9]\\d*";var y=u++;f[y]="[0-9]+";var S=u++;f[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=u++;f[d]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var I=u++;f[I]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var b=u++;f[b]="(?:"+f[w]+"|"+f[S]+")";var r=u++;f[r]="(?:"+f[y]+"|"+f[S]+")";var h=u++;f[h]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var g=u++;f[g]="(?:-?("+f[r]+"(?:\\."+f[r]+")*))";var E=u++;f[E]="[0-9A-Za-z-]+";var p=u++;f[p]="(?:\\+("+f[E]+"(?:\\."+f[E]+")*))";var C=u++,t="v?"+f[d]+f[h]+"?"+f[p]+"?";f[C]="^"+t+"$";var c="[v=\\s]*"+f[I]+f[g]+"?"+f[p]+"?",i=u++;f[i]="^"+c+"$";var n=u++;f[n]="((?:<|>)?=?)";var o=u++;f[o]=f[y]+"|x|X|\\*";var l=u++;f[l]=f[w]+"|x|X|\\*";var a=u++;f[a]="[v=\\s]*("+f[l]+")(?:\\.("+f[l]+")(?:\\.("+f[l]+")(?:"+f[h]+")?"+f[p]+"?)?)?";var m=u++;f[m]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[g]+")?"+f[p]+"?)?)?";var D=u++;f[D]="^"+f[n]+"\\s*"+f[a]+"$";var M=u++;f[M]="^"+f[n]+"\\s*"+f[m]+"$";var T=u++;f[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=u++;f[$]="(?:~>?)";var z=u++;f[z]="(\\s*)"+f[$]+"\\s+",k[z]=new RegExp(f[z],"g");var q=u++;f[q]="^"+f[$]+f[a]+"$";var ie=u++;f[ie]="^"+f[$]+f[m]+"$";var oe=u++;f[oe]="(?:\\^)";var ae=u++;f[ae]="(\\s*)"+f[oe]+"\\s+",k[ae]=new RegExp(f[ae],"g");var de=u++;f[de]="^"+f[oe]+f[a]+"$";var ce=u++;f[ce]="^"+f[oe]+f[m]+"$";var J=u++;f[J]="^"+f[n]+"\\s*("+c+")$|^$";var Y=u++;f[Y]="^"+f[n]+"\\s*("+t+")$|^$";var H=u++;f[H]="(\\s*)"+f[n]+"\\s*("+c+"|"+f[a]+")",k[H]=new RegExp(f[H],"g");var F=u++;f[F]="^\\s*("+f[a]+")\\s+-\\s+("+f[a]+")\\s*$";var V=u++;f[V]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var Z=u++;f[Z]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)s(ne,f[ne]),k[ne]||(k[ne]=new RegExp(f[ne]));function se(_,le){if(_ instanceof U)return _;if(typeof _!="string"||_.length>A||!(le?k[i]:k[C]).test(_))return null;try{return new U(_,le)}catch{return null}}function U(_,le){if(_ instanceof U){if(_.loose===le)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(_,le);s("SemVer",_,le),this.loose=le;var fe=_.trim().match(le?k[i]:k[C]);if(!fe)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Me=+ke;if(Me>=0&&Me<R)return Me}return ke}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=se,e.valid=function(_,le){var fe=se(_,le);return fe?fe.version:null},e.clean=function(_,le){var fe=se(_.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof U||(_=new U(_,this.loose)),this.compareMain(_)||this.comparePre(_)},U.prototype.compareMain=function(_){return _ instanceof U||(_=new U(_,this.loose)),O(this.major,_.major)||O(this.minor,_.minor)||O(this.patch,_.patch)},U.prototype.comparePre=function(_){if(_ instanceof U||(_=new U(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],ke=_.prerelease[le];if(s("prerelease compare",le,fe,ke),fe===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(fe===void 0)return-1;if(fe!==ke)return O(fe,ke)}while(++le)},U.prototype.inc=function(_,le){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,le,fe,ke){typeof fe=="string"&&(ke=fe,fe=void 0);try{return new U(_,fe).inc(le,ke).version}catch{return null}},e.diff=function(_,le){if(j(_,le))return null;var fe=se(_),ke=se(le);if(fe.prerelease.length||ke.prerelease.length){for(var Me in fe)if((Me==="major"||Me==="minor"||Me==="patch")&&fe[Me]!==ke[Me])return"pre"+Me;return"prerelease"}for(var Me in fe)if((Me==="major"||Me==="minor"||Me==="patch")&&fe[Me]!==ke[Me])return Me},e.compareIdentifiers=O;var v=/^[0-9]+$/;function O(_,le){var fe=v.test(_),ke=v.test(le);return fe&&ke&&(_=+_,le=+le),fe&&!ke?-1:ke&&!fe?1:_<le?-1:_>le?1:0}function W(_,le,fe){return new U(_,fe).compare(new U(le,fe))}function N(_,le,fe){return W(_,le,fe)>0}function G(_,le,fe){return W(_,le,fe)<0}function j(_,le,fe){return W(_,le,fe)===0}function B(_,le,fe){return W(_,le,fe)!==0}function K(_,le,fe){return W(_,le,fe)>=0}function re(_,le,fe){return W(_,le,fe)<=0}function he(_,le,fe,ke){var Me;switch(le){case"===":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),Me=_===fe;break;case"!==":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),Me=_!==fe;break;case"":case"=":case"==":Me=j(_,fe,ke);break;case"!=":Me=B(_,fe,ke);break;case">":Me=N(_,fe,ke);break;case">=":Me=K(_,fe,ke);break;case"<":Me=G(_,fe,ke);break;case"<=":Me=re(_,fe,ke);break;default:throw new TypeError("Invalid operator: "+le)}return Me}function ve(_,le){if(_ instanceof ve){if(_.loose===le)return _;_=_.value}if(!(this instanceof ve))return new ve(_,le);s("comparator",_,le),this.loose=le,this.parse(_),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,le){return O(le,_)},e.major=function(_,le){return new U(_,le).major},e.minor=function(_,le){return new U(_,le).minor},e.patch=function(_,le){return new U(_,le).patch},e.compare=W,e.compareLoose=function(_,le){return W(_,le,!0)},e.rcompare=function(_,le,fe){return W(le,_,fe)},e.sort=function(_,le){return _.sort(function(fe,ke){return e.compare(fe,ke,le)})},e.rsort=function(_,le){return _.sort(function(fe,ke){return e.rcompare(fe,ke,le)})},e.gt=N,e.lt=G,e.eq=j,e.neq=B,e.gte=K,e.lte=re,e.cmp=he,e.Comparator=ve;var Se={};function Oe(_,le){if(_ instanceof Oe)return _.loose===le?_:new Oe(_.raw,le);if(_ instanceof ve)return new Oe(_.value,le);if(!(this instanceof Oe))return new Oe(_,le);if(this.loose=le,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Le(_){return!_||_.toLowerCase()==="x"||_==="*"}function Fe(_,le,fe,ke,Me,Te,We,$e,qe,Ue,He,X,ue){return((le=Le(fe)?"":Le(ke)?">="+fe+".0.0":Le(Me)?">="+fe+"."+ke+".0":">="+le)+" "+($e=Le(qe)?"":Le(Ue)?"<"+(+qe+1)+".0.0":Le(He)?"<"+qe+"."+(+Ue+1)+".0":X?"<="+qe+"."+Ue+"."+He+"-"+X:"<="+$e)).trim()}function me(_,le){for(var fe=0;fe<_.length;fe++)if(!_[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<_.length;fe++)if(s(_[fe].semver),_[fe].semver!==Se&&_[fe].semver.prerelease.length>0){var ke=_[fe].semver;if(ke.major===le.major&&ke.minor===le.minor&&ke.patch===le.patch)return!0}return!1}return!0}function pe(_,le,fe){try{le=new Oe(le,fe)}catch{return!1}return le.test(_)}function Ce(_,le,fe,ke){var Me,Te,We,$e,qe;switch(_=new U(_,ke),le=new Oe(le,ke),fe){case">":Me=N,Te=re,We=G,$e=">",qe=">=";break;case"<":Me=G,Te=K,We=N,$e="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(_,le,ke))return!1;for(var Ue=0;Ue<le.set.length;++Ue){var He=le.set[Ue],X=null,ue=null;if(He.forEach(function(ge){ge.semver===Se&&(ge=new ve(">=0.0.0")),X=X||ge,ue=ue||ge,Me(ge.semver,X.semver,ke)?X=ge:We(ge.semver,ue.semver,ke)&&(ue=ge)}),X.operator===$e||X.operator===qe||(!ue.operator||ue.operator===$e)&&Te(_,ue.semver)||ue.operator===qe&&We(_,ue.semver))return!1}return!0}ve.prototype.parse=function(_){var le=this.loose?k[J]:k[Y],fe=_.match(le);if(!fe)throw new TypeError("Invalid comparator: "+_);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new U(fe[2],this.loose):this.semver=Se},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===Se||(typeof _=="string"&&(_=new U(_,this.loose)),he(_,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(_,le){if(!(_ instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Oe(_.value,le),pe(this.value,fe,le);if(_.operator==="")return fe=new Oe(this.value,le),pe(_.semver,fe,le);var ke=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Te=this.semver.version===_.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),$e=he(this.semver,"<",_.semver,le)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),qe=he(this.semver,">",_.semver,le)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return ke||Me||Te&&We||$e||qe},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(_){var le=this.loose;_=_.trim(),s("range",_,le);var fe=le?k[V]:k[F];_=_.replace(fe,Fe),s("hyphen replace",_),_=_.replace(k[H],"$1$2$3"),s("comparator trim",_,k[H]),_=(_=(_=_.replace(k[z],"$1~")).replace(k[ae],"$1^")).split(/\s+/).join(" ");var ke=le?k[J]:k[Y],Me=_.split(" ").map(function(Te){return function(We,$e){return s("comp",We),We=function(qe,Ue){return qe.trim().split(/\s+/).map(function(He){return function(X,ue){s("caret",X,ue);var ge=ue?k[ce]:k[de];return X.replace(ge,function(be,we,Ae,Ne,Ve){var Ge;return s("caret",X,be,we,Ae,Ne,Ve),Le(we)?Ge="":Le(Ae)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Le(Ne)?Ge=we==="0"?">="+we+"."+Ae+".0 <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+".0 <"+(+we+1)+".0.0":Ve?(s("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=we==="0"?Ae==="0"?">="+we+"."+Ae+"."+Ne+Ve+" <"+we+"."+Ae+"."+(+Ne+1):">="+we+"."+Ae+"."+Ne+Ve+" <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+"."+Ne+Ve+" <"+(+we+1)+".0.0"):(s("no pr"),Ge=we==="0"?Ae==="0"?">="+we+"."+Ae+"."+Ne+" <"+we+"."+Ae+"."+(+Ne+1):">="+we+"."+Ae+"."+Ne+" <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+"."+Ne+" <"+(+we+1)+".0.0"),s("caret return",Ge),Ge})}(He,Ue)}).join(" ")}(We,$e),s("caret",We),We=function(qe,Ue){return qe.trim().split(/\s+/).map(function(He){return function(X,ue){var ge=ue?k[ie]:k[q];return X.replace(ge,function(be,we,Ae,Ne,Ve){var Ge;return s("tilde",X,be,we,Ae,Ne,Ve),Le(we)?Ge="":Le(Ae)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Le(Ne)?Ge=">="+we+"."+Ae+".0 <"+we+"."+(+Ae+1)+".0":Ve?(s("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+we+"."+Ae+"."+Ne+Ve+" <"+we+"."+(+Ae+1)+".0"):Ge=">="+we+"."+Ae+"."+Ne+" <"+we+"."+(+Ae+1)+".0",s("tilde return",Ge),Ge})}(He,Ue)}).join(" ")}(We,$e),s("tildes",We),We=function(qe,Ue){return s("replaceXRanges",qe,Ue),qe.split(/\s+/).map(function(He){return function(X,ue){X=X.trim();var ge=ue?k[M]:k[D];return X.replace(ge,function(be,we,Ae,Ne,Ve,Ge){s("xRange",X,be,we,Ae,Ne,Ve,Ge);var Ke=Le(Ae),Ye=Ke||Le(Ne),Ze=Ye||Le(Ve);return we==="="&&Ze&&(we=""),Ke?be=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(Ne=0),Ze&&(Ve=0),we===">"?(we=">=",Ye?(Ae=+Ae+1,Ne=0,Ve=0):Ze&&(Ne=+Ne+1,Ve=0)):we==="<="&&(we="<",Ye?Ae=+Ae+1:Ne=+Ne+1),be=we+Ae+"."+Ne+"."+Ve):Ye?be=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ze&&(be=">="+Ae+"."+Ne+".0 <"+Ae+"."+(+Ne+1)+".0"),s("xRange return",be),be})}(He,Ue)}).join(" ")}(We,$e),s("xrange",We),We=function(qe,Ue){return s("replaceStars",qe,Ue),qe.trim().replace(k[Z],"")}(We,$e),s("stars",We),We}(Te,le)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Te){return!!Te.match(ke)})),Me=Me.map(function(Te){return new ve(Te,le)})},Oe.prototype.intersects=function(_,le){if(!(_ instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(ke){return _.set.some(function(Me){return Me.every(function(Te){return ke.intersects(Te,le)})})})})},e.toComparators=function(_,le){return new Oe(_,le).set.map(function(fe){return fe.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new U(_,this.loose));for(var le=0;le<this.set.length;le++)if(me(this.set[le],_))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(_,le,fe){var ke=null,Me=null;try{var Te=new Oe(le,fe)}catch{return null}return _.forEach(function(We){Te.test(We)&&(ke&&Me.compare(We)!==-1||(Me=new U(ke=We,fe)))}),ke},e.minSatisfying=function(_,le,fe){var ke=null,Me=null;try{var Te=new Oe(le,fe)}catch{return null}return _.forEach(function(We){Te.test(We)&&(ke&&Me.compare(We)!==1||(Me=new U(ke=We,fe)))}),ke},e.validRange=function(_,le){try{return new Oe(_,le).range||"*"}catch{return null}},e.ltr=function(_,le,fe){return Ce(_,le,"<",fe)},e.gtr=function(_,le,fe){return Ce(_,le,">",fe)},e.outside=Ce,e.prerelease=function(_,le){var fe=se(_,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(_,le,fe){return _=new Oe(_,fe),le=new Oe(le,fe),_.intersects(le)},e.coerce=function(_){if(_ instanceof U)return _;if(typeof _!="string")return null;var le=_.match(k[T]);return le==null?null:se((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(x,e){var P,L,s=x.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function k(r){if(P===setTimeout)return setTimeout(r,0);if((P===A||!P)&&setTimeout)return P=setTimeout,setTimeout(r,0);try{return P(r,0)}catch{try{return P.call(null,r,0)}catch{return P.call(this,r,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:A}catch{P=A}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var f,u=[],w=!1,y=-1;function S(){w&&f&&(w=!1,f.length?u=f.concat(u):y=-1,u.length&&d())}function d(){if(!w){var r=k(S);w=!0;for(var h=u.length;h;){for(f=u,u=[];++y<h;)f&&f[y].run();y=-1,h=u.length}f=null,w=!1,function(g){if(L===clearTimeout)return clearTimeout(g);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(g);try{L(g)}catch{try{return L.call(null,g)}catch{return L.call(this,g)}}}(r)}}function I(r,h){this.fun=r,this.array=h}function b(){}s.nextTick=function(r){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];u.push(new I(r,h)),u.length!==1||w||k(d)},I.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function(r){return[]},s.binding=function(r){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(r){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ee[133],te([0,1]),function(x,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(k,f,u){this.level=k,this.key=f,this.value=u,this.forward=[]}}const s=void 0;class A{constructor(k,f=2**16){this.comparator=k,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new L(this.c,s,s)}get size(){return this.f}clear(){this.e=new L(this.c,s,s)}has(k){return Boolean(A.g(this,k,this.comparator))}get(k){return A.g(this,k,this.comparator)?.value}set(k,f){return A.h(this,k,f,this.comparator)&&(this.f+=1),this}delete(k){const f=A.k(this,k,this.comparator);return f&&(this.f-=1),f}forEach(k,f){let u=this.e.forward[0];for(;u;)k.call(f,u.value,u.key,this),u=u.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",f=this.e.forward[0];for(;f;)k+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return k}static g(k,f,u){let w=k.e;for(let y=k.d-1;y>=0;y--)for(;w.forward[y]&&u(w.forward[y].key,f)<0;)w=w.forward[y];if(w=w.forward[0],w&&u(w.key,f)===0)return w}static h(k,f,u,w){const y=[];let S=k.e;for(let d=k.d-1;d>=0;d--){for(;S.forward[d]&&w(S.forward[d].key,f)<0;)S=S.forward[d];y[d]=S}if(S=S.forward[0],S&&w(S.key,f)===0)return S.value=u,!1;{const d=A.j(k);if(d>k.d){for(let I=k.d;I<d;I++)y[I]=k.e;k.d=d}S=new L(d,f,u);for(let I=0;I<d;I++)S.forward[I]=y[I].forward[I],y[I].forward[I]=S;return!0}}static j(k,f=.5){let u=1;for(;Math.random()<f&&u<k.c;)u+=1;return u}static k(k,f,u){const w=[];let y=k.e;for(let S=k.d-1;S>=0;S--){for(;y.forward[S]&&u(y.forward[S].key,f)<0;)y=y.forward[S];w[S]=y}if(y=y.forward[0],!y||u(y.key,f)!==0)return!1;for(let S=0;S<k.d&&w[S].forward[S]===y;S++)w[S].forward[S]=y.forward[S];for(;k.d>0&&k.e.forward[k.d-1]===s;)k.d-=1;return!0}}e.SkipList=A}),define(ee[60],te([0,1,13,2]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function s(p){const C=p;return C?typeof C.read=="function":!1}e.isReadable=s;function A(p){const C=p;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function R(p){const C=p;return C?A(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=R;function k(p,C){return new f(p,C)}e.newWriteableStream=k;class f{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,P.onUnexpectedError)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let c;switch(C){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(p,C){const t=[];let c;for(;(c=p.read())!==null;)t.push(c);return C(t)}e.consumeReadable=u;function w(p,C,t){const c=[];let i;for(;(i=p.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?C(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return p.read()}}}e.peekReadable=w;function y(p,C){return new Promise((t,c)=>{const i=[];S(p,{onData:n=>{C&&i.push(n)},onError:n=>{C?c(n):t(void 0)},onEnd:()=>{t(C?C(i):void 0)}})})}e.consumeStream=y;function S(p,C){let t=!1;return p.on("error",c=>{t||C.onError(c)}),p.on("end",()=>{t||C.onEnd()}),p.on("data",c=>{t||C.onData(c)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=S;function d(p,C){return new Promise((t,c)=>{const i=new L.DisposableStore,n=[],o=m=>{if(n.push(m),n.length>C)return i.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},l=m=>c(m),a=()=>t({stream:p,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>p.removeListener("error",l))),p.on("error",l),i.add((0,L.toDisposable)(()=>p.removeListener("end",a))),p.on("end",a),i.add((0,L.toDisposable)(()=>p.removeListener("data",o))),p.on("data",o)})}e.peekStream=d;function I(p,C){const t=k(C);return t.end(p),t}e.toStream=I;function b(){const p=k(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=b;function r(p){let C=!1;return{read:()=>C?null:(C=!0,p)}}e.toReadable=r;function h(p,C,t){const c=k(t);return S(p,{onData:i=>c.write(C.data(i)),onError:i=>c.error(C.error?C.error(i):i),onEnd:()=>c.end()}),c}e.transform=h;function g(p,C,t){let c=!1;return{read:()=>{const i=C.read();return c?i:(c=!0,i!==null?t([p,i]):p)}}}e.prefixedReadable=g;function E(p,C,t){let c=!1;const i=k(t);return S(C,{onData:n=>c?i.write(n):(c=!0,i.write(t([p,n]))),onError:n=>i.error(n),onEnd:()=>{c||(c=!0,i.write(p)),i.end()}}),i}e.prefixedStream=E}),define(ee[17],te([0,1,60]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let s,A;class R{static alloc(m){return L?new R(Buffer.allocUnsafe(m)):new R(new Uint8Array(m))}static wrap(m){return L&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new R(m)}static fromString(m,D){return!(D?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(m)):(s||(s=new TextEncoder),new R(s.encode(m)))}static fromByteArray(m){const D=R.alloc(m.length);for(let M=0,T=m.length;M<T;M++)D.buffer[M]=m[M];return D}static concat(m,D){if(typeof D>"u"){D=0;for(let $=0,z=m.length;$<z;$++)D+=m[$].byteLength}const M=R.alloc(D);let T=0;for(let $=0,z=m.length;$<z;$++){const q=m[$];M.set(q,T),T+=q.byteLength}return M}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=R.alloc(this.byteLength);return m.set(this),m}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(m,D){return new R(this.buffer.subarray(m,D))}set(m,D){if(m instanceof R)this.buffer.set(m.buffer,D);else if(m instanceof Uint8Array)this.buffer.set(m,D);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),D);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,D){w(this.buffer,m,D)}readUInt32LE(m){return y(this.buffer,m)}writeUInt32LE(m,D){S(this.buffer,m,D)}readUInt8(m){return d(this.buffer,m)}writeUInt8(m,D){I(this.buffer,m,D)}}e.VSBuffer=R;function k(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0}e.readUInt16LE=k;function f(a,m,D){a[D+0]=m&255,m=m>>>8,a[D+1]=m&255}e.writeUInt16LE=f;function u(a,m){return a[m]*2**24+a[m+1]*2**16+a[m+2]*2**8+a[m+3]}e.readUInt32BE=u;function w(a,m,D){a[D+3]=m,m=m>>>8,a[D+2]=m,m=m>>>8,a[D+1]=m,m=m>>>8,a[D]=m}e.writeUInt32BE=w;function y(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0|a[m+2]<<16>>>0|a[m+3]<<24>>>0}e.readUInt32LE=y;function S(a,m,D){a[D+0]=m&255,m=m>>>8,a[D+1]=m&255,m=m>>>8,a[D+2]=m&255,m=m>>>8,a[D+3]=m&255}e.writeUInt32LE=S;function d(a,m){return a[m]}e.readUInt8=d;function I(a,m,D){a[D]=m}e.writeUInt8=I;function b(a){return P.consumeReadable(a,m=>R.concat(m))}e.readableToBuffer=b;function r(a){return P.toReadable(a)}e.bufferToReadable=r;function h(a){return P.consumeStream(a,m=>R.concat(m))}e.streamToBuffer=h;async function g(a){return a.ended?R.concat(a.buffer):R.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=g;function E(a){return P.toStream(a,m=>R.concat(m))}e.bufferToStream=E;function p(a){return P.transform(a,{data:m=>typeof m=="string"?R.fromString(m):R.wrap(m)},m=>R.concat(m))}e.streamToBufferReadableStream=p;function C(a){return P.newWriteableStream(m=>R.concat(m),a)}e.newWriteableBufferStream=C;function t(a,m){return P.prefixedReadable(a,m,D=>R.concat(D))}e.prefixedBufferReadable=t;function c(a,m){return P.prefixedStream(a,m,D=>R.concat(D))}e.prefixedBufferStream=c;function i(a){let m=0,D=0,M=0;const T=new Uint8Array(Math.floor(a.length/4*3)),$=q=>{switch(D){case 3:T[M++]=m|q,D=0;break;case 2:T[M++]=m|q>>>2,m=q<<6,D=3;break;case 1:T[M++]=m|q>>>4,m=q<<4,D=2;break;default:m=q<<2,D=1}};for(let q=0;q<a.length;q++){const ie=a.charCodeAt(q);if(ie>=65&&ie<=90)$(ie-65);else if(ie>=97&&ie<=122)$(ie-97+26);else if(ie>=48&&ie<=57)$(ie-48+52);else if(ie===43||ie===45)$(62);else if(ie===47||ie===95)$(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[q]}`)}}const z=M;for(;D>0;)$(0);return R.wrap(T).slice(0,z)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},m=!0,D=!1){const M=D?o:n;let T="";const $=a.byteLength%3;let z=0;for(;z<a.byteLength-$;z+=3){const q=a[z+0],ie=a[z+1],oe=a[z+2];T+=M[q>>>2],T+=M[(q<<4|ie>>>4)&63],T+=M[(ie<<2|oe>>>6)&63],T+=M[oe&63]}if($===1){const q=a[z+0];T+=M[q>>>2],T+=M[q<<4&63],m&&(T+="==")}else if($===2){const q=a[z+0],ie=a[z+1];T+=M[q>>>2],T+=M[(q<<4|ie>>>4)&63],T+=M[ie<<2&63],m&&(T+="=")}return T}e.encodeBase64=l}),define(ee[134],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[11],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function P(c){return typeof c=="string"}e.isString=P;function L(c){return Array.isArray(c)&&c.every(i=>P(i))}e.isStringArray=L;function s(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=s;function A(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=A;function R(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=R;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function f(c){return c===!0||c===!1}e.isBoolean=f;function u(c){return typeof c>"u"}e.isUndefined=u;function w(c){return!y(c)}e.isDefined=w;function y(c){return u(c)||c===null}e.isUndefinedOrNull=y;function S(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function d(c){if(y(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=d;function I(...c){const i=[];for(let n=0;n<c.length;n++){const o=c[n];if(y(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=I;const b=Object.prototype.hasOwnProperty;function r(c){if(!s(c))return!1;for(const i in c)if(b.call(c,i))return!1;return!0}e.isEmptyObject=r;function h(c){return typeof c=="function"}e.isFunction=h;function g(...c){return c.length>0&&c.every(h)}e.areFunctions=g;function E(c,i){const n=Math.min(c.length,i.length);for(let o=0;o<n;o++)p(c[o],i[o])}e.validateConstraints=E;function p(c,i){if(P(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(c instanceof i)return}catch{}if(!y(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function C(c){return c===null?void 0:c}e.withNullAsUndefined=C;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(ee[135],te([0,1,11]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function s(k,f){if((0,P.isString)(f)){const u=L[f];if(u===void 0)throw new Error(`${k} references an unknown codicon: ${f}`);f=u}return L[k]=f,{id:k}}function A(){return L}e.getCodiconFontCharacters=A;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ee[37],te([0,1,11]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([E,p])=>{g[E]=p&&typeof p=="object"?L(p):p}),g}e.deepClone=L;function s(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const E=g.shift();Object.freeze(E);for(const p in E)if(A.call(E,p)){const C=E[p];typeof C=="object"&&!Object.isFrozen(C)&&!(0,P.isTypedArray)(C)&&g.push(C)}}return h}e.deepFreeze=s;const A=Object.prototype.hasOwnProperty;function R(h,g){return k(h,g,new Set)}e.cloneAndChange=R;function k(h,g,E){if((0,P.isUndefinedOrNull)(h))return h;const p=g(h);if(typeof p<"u")return p;if(Array.isArray(h)){const C=[];for(const t of h)C.push(k(t,g,E));return C}if((0,P.isObject)(h)){if(E.has(h))throw new Error("Cannot clone recursive data-structure");E.add(h);const C={};for(const t in h)A.call(h,t)&&(C[t]=k(h[t],g,E));return E.delete(h),C}return h}function f(h,g,E=!0){return(0,P.isObject)(h)?((0,P.isObject)(g)&&Object.keys(g).forEach(p=>{p in h?E&&((0,P.isObject)(h[p])&&(0,P.isObject)(g[p])?f(h[p],g[p],E):h[p]=g[p]):h[p]=g[p]}),h):g}e.mixin=f;function u(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let E,p;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(E=0;E<h.length;E++)if(!u(h[E],g[E]))return!1}else{const C=[];for(p in h)C.push(p);C.sort();const t=[];for(p in g)t.push(p);if(t.sort(),!u(C,t))return!1;for(E=0;E<C.length;E++)if(!u(h[C[E]],g[C[E]]))return!1}return!0}e.equals=u;function w(h){const g=new Set;return JSON.stringify(h,(E,p)=>{if((0,P.isObject)(p)||Array.isArray(p)){if(g.has(p))return"[Circular]";g.add(p)}return p})}e.safeStringify=w;function y(h,g){const E=Object.create(null);return!h||!g||Object.keys(g).forEach(C=>{const t=h[C],c=g[C];u(t,c)||(E[C]=c)}),E}e.distinct=y;function S(h,g){const E=g.toLowerCase(),p=Object.keys(h).find(C=>C.toLowerCase()===E);return p?h[p]:h[g]}e.getCaseInsensitive=S;function d(h,g){const E=Object.create(null);for(const[p,C]of Object.entries(h))g(p,C)&&(E[p]=C);return E}e.filter=d;function I(h){let g=[],E=Object.getPrototypeOf(h);for(;Object.prototype!==E;)g=g.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return g}e.getAllPropertyNames=I;function b(h){const g=[];for(const E of I(h))typeof h[E]=="function"&&g.push(E);return g}e.getAllMethodNames=b;function r(h,g){const E=C=>function(){const t=Array.prototype.slice.call(arguments,0);return g(C,t)},p={};for(const C of h)p[C]=E(C);return p}e.createProxyObject=r}),define(ee[136],te([0,1,135]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(R){function k(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=k})(L=e.ThemeColor||(e.ThemeColor={}));function s(R){return{id:R}}e.themeColorFromId=s;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(g){const E=k.exec(g.id);if(!E)return f(P.Codicon.error);const[,p,C]=E,t=["codicon","codicon-"+p];return C&&t.push("codicon-modifier-"+C.substring(1)),t}R.asClassNameArray=f;function u(g){return f(g).join(" ")}R.asClassName=u;function w(g){return"."+f(g).join(".")}R.asCSSSelector=w;function y(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||L.isThemeColor(g.color))}R.isThemeIcon=y;const S=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function d(g){const E=S.exec(g);if(!E)return;const[,p]=E;return{id:p}}R.fromString=d;function I(g){return{id:g}}R.fromId=I;function b(g,E){let p=g.id;const C=p.lastIndexOf("~");return C!==-1&&(p=p.substring(0,C)),E&&(p=`${p}~${E}`),{id:p}}R.modify=b;function r(g){const E=g.id.lastIndexOf("~");if(E!==-1)return g.id.substring(E+1)}R.getModifier=r;function h(g,E){return g.id===E.id&&g.color?.id===E.color?.id}R.isEqual=h})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(s){return P.test(s)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(k){for(let f=0;f<k.length;f++)k[f]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),R=[];for(let k=0;k<256;k++)R.push(k.toString(16).padStart(2,"0"));return function(){s(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,u="";return u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+="-",u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u+=R[A[f++]],u}}()}),define(ee[137],te([0,1,83,41,50]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(R,k){if(await new Promise((w,y)=>{const S=L.createReadStream(R),d=P.createHash("sha1");S.pipe(d);const I=(0,s.once)((b,r)=>{S.removeAllListeners(),d.removeAllListeners(),b?y(b):w(r)});S.once("error",I),S.once("end",I),d.once("error",I),d.once("data",b=>I(void 0,b.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=A}),define(ee[138],te([0,1,27]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(R){const k=R.replace(/\-/g,":").toLowerCase();return!L.has(k)}function A(){const R=(0,P.networkInterfaces)();for(const k in R){const f=R[k];if(f){for(const{mac:u}of f)if(s(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ee[101],te([0,1,84]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(k,f,u,w=1){let y=!1;return new Promise(S=>{const d=setTimeout(()=>{if(!y)return y=!0,S(0)},u);s(k,f,w,I=>{if(!y)return y=!0,clearTimeout(d),S(I)})})}e.findFreePort=L;function s(k,f,u,w){if(f===0)return w(0);const y=new P.Socket;y.once("connect",()=>(R(y),s(k+u,f-1,u,w))),y.once("data",()=>{}),y.once("error",S=>(R(y),S.code!=="ECONNREFUSED"?s(k+u,f-1,u,w):w(k))),y.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,f,u,w="127.0.0.1"){let y=!1,S,d=1;const I=P.createServer({pauseOnConnect:!0});function b(r,h){y||(y=!0,I.removeAllListeners(),I.close(),S&&clearTimeout(S),h(r))}return new Promise(r=>{S=setTimeout(()=>{b(0,r)},u),I.on("listening",()=>{b(k,r)}),I.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&d<f?(k++,d++,I.listen(k,w)):b(0,r)}),I.on("close",()=>{b(0,r)}),I.listen(k,w)})}e.findFreePortFaster=A;function R(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(f){console.error(f)}}}),define(ee[139],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[140],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class P{constructor(s,A){this.a=s,this.onMessage=A}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=P}),define(ee[42],te([0,1,14,13]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class s{constructor(){this.a=new WeakMap}on(R,k){const f=(u,...w)=>{this.b(R,u)&&k(u,...w)};return this.a.set(k,f),P.ipcMain.on(R,f),this}once(R,k){return P.ipcMain.once(R,(f,...u)=>{this.b(R,f)&&k(f,...u)}),this}handle(R,k){return P.ipcMain.handle(R,(f,...u)=>this.b(R,f)?k(f,...u):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return P.ipcMain.removeHandler(R),this}removeListener(R,k){const f=this.a.get(k);return f&&(P.ipcMain.removeListener(R,f),this.a.delete(k)),this}b(R,k){if(!R||!R.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const f=k.senderFrame,u=f.url;if(!u)return!0;let w="unknown";try{w=new URL(u).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${u}'.`),!1}return w!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${w}'.`),!1):f.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new s}),define(ee[141],te([0,1,14,42,11,139]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){L.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(f,u,w,y,S)=>{const d=k(f,y,w);d.popup({window:(0,s.withNullAsUndefined)(P.BrowserWindow.fromWebContents(f.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{d&&f.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,u)}})})}e.registerContextMenuListener=R;function k(f,u,w){const y=new P.Menu;return w.forEach(S=>{let d;S.type==="separator"?d=new P.MenuItem({type:S.type}):Array.isArray(S.submenu)?d=new P.MenuItem({submenu:k(f,u,S.submenu),label:S.label}):d=new P.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(I,b,r)=>f.sender.send(u,S.id,r)}),y.append(d)}),y}}),define(ee[72],te([0,1,14]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=P.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[142],te([12,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(ee[143],te([0,1,142]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,s=L*60,A=s*24,R=A*7,k=A*30,f=A*365;function u(y,S,d,I){typeof y!="number"&&(y=y.getTime());const b=Math.round((new Date().getTime()-y)/1e3);if(b<-30)return(0,P.localize)(0,null,u(new Date().getTime()+b*1e3,!1));if(!I&&b<30)return(0,P.localize)(1,null);let r;return b<L?(r=b,S?r===1?d?(0,P.localize)(2,null,r):(0,P.localize)(3,null,r):d?(0,P.localize)(4,null,r):(0,P.localize)(5,null,r):r===1?d?(0,P.localize)(6,null,r):(0,P.localize)(7,null,r):d?(0,P.localize)(8,null,r):(0,P.localize)(9,null,r)):b<s?(r=Math.floor(b/L),S?r===1?d?(0,P.localize)(10,null,r):(0,P.localize)(11,null,r):d?(0,P.localize)(12,null,r):(0,P.localize)(13,null,r):r===1?d?(0,P.localize)(14,null,r):(0,P.localize)(15,null,r):d?(0,P.localize)(16,null,r):(0,P.localize)(17,null,r)):b<A?(r=Math.floor(b/s),S?r===1?d?(0,P.localize)(18,null,r):(0,P.localize)(19,null,r):d?(0,P.localize)(20,null,r):(0,P.localize)(21,null,r):r===1?d?(0,P.localize)(22,null,r):(0,P.localize)(23,null,r):d?(0,P.localize)(24,null,r):(0,P.localize)(25,null,r)):b<R?(r=Math.floor(b/A),S?r===1?(0,P.localize)(26,null,r):(0,P.localize)(27,null,r):r===1?(0,P.localize)(28,null,r):(0,P.localize)(29,null,r)):b<k?(r=Math.floor(b/R),S?r===1?d?(0,P.localize)(30,null,r):(0,P.localize)(31,null,r):d?(0,P.localize)(32,null,r):(0,P.localize)(33,null,r):r===1?d?(0,P.localize)(34,null,r):(0,P.localize)(35,null,r):d?(0,P.localize)(36,null,r):(0,P.localize)(37,null,r)):b<f?(r=Math.floor(b/k),S?r===1?d?(0,P.localize)(38,null,r):(0,P.localize)(39,null,r):d?(0,P.localize)(40,null,r):(0,P.localize)(41,null,r):r===1?d?(0,P.localize)(42,null,r):(0,P.localize)(43,null,r):d?(0,P.localize)(44,null,r):(0,P.localize)(45,null,r)):(r=Math.floor(b/f),S?r===1?d?(0,P.localize)(46,null,r):(0,P.localize)(47,null,r):d?(0,P.localize)(48,null,r):(0,P.localize)(49,null,r):r===1?d?(0,P.localize)(50,null,r):(0,P.localize)(51,null,r):d?(0,P.localize)(52,null,r):(0,P.localize)(53,null,r))}e.fromNow=u;function w(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(ee[144],te([12,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,26,11,144]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(y,S){return S&&(y.stack||y.stacktrace)?s.localize(0,null,k(y),R(y.stack)||R(y.stacktrace)):k(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?s.localize(1,null,y.message):y.message||s.localize(2,null)}function f(y=null,S=!1){if(!y)return s.localize(3,null);if(Array.isArray(y)){const d=P.coalesce(y),I=f(d[0],S);return d.length>1?s.localize(4,null,I,d.length):I}if(L.isString(y))return y;if(y.detail){const d=y.detail;if(d.error)return A(d.error,S);if(d.exception)return A(d.exception,S)}return y.stack?A(y,S):y.message?y.message:s.localize(5,null)}e.toErrorMessage=f;function u(y){const S=y;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=u;function w(y,S){let d;return typeof y=="string"?d=new Error(y):d=y,d.actions=S,d}e.createErrorWithActions=w}),define(ee[145],te([12,10]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(ee[146],te([0,1,145]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[147],te([12,10]),function(x,e){return x.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,147]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,s=!1,A=!1,R=!1,k=!1,f=!1,u=!1,w=!1,y=!1,S=!1,d,I=e.LANGUAGE_DEFAULT,b,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const g=typeof h?.versions?.electron=="string",E=g&&h?.type==="renderer";if(typeof navigator=="object"&&!E)r=navigator.userAgent,L=r.indexOf("Windows")>=0,s=r.indexOf("Macintosh")>=0,w=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=r.indexOf("Linux")>=0,S=r?.indexOf("Mobi")>=0,f=!0,d=P.getConfiguredDefaultLocale(P.localize(0,null))||e.LANGUAGE_DEFAULT,I=d;else if(typeof h=="object"){L=h.platform==="win32",s=h.platform==="darwin",A=h.platform==="linux",R=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,u=g,y=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,I=e.LANGUAGE_DEFAULT;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const m=JSON.parse(a),D=m.availableLanguages["*"];d=m.locale,I=D||e.LANGUAGE_DEFAULT,b=m._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var p;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function C(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let t=0;s?t=1:L?t=3:A&&(t=2),e.isWindows=L,e.isMacintosh=s,e.isLinux=A,e.isLinuxSnap=R,e.isNative=k,e.isElectron=u,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isMobile=S,e.isCI=y,e.platform=t,e.userAgent=r,e.language=I;var c;(function(a){function m(){return e.language}a.value=m;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=D;function M(){return e.language==="en"}a.isDefault=M})(c=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let M=0,T=a.length;M<T;M++){const $=a[M];if($.id===D.data.vscodeScheduleAsyncWork){a.splice(M,1),$.callback();return}}});let m=0;return D=>{const M=++m;a.push({id:M,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=s||w?2:L?1:3;let n=!0,o=!1;function l(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,n=new Uint16Array(a.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const s=P.globals.vscode.process;L={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,36]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,s=97,A=90,R=122,k=46,f=47,u=92,w=58,y=63;class S extends Error{constructor(c,i,n){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const l=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${l} ${o} of type ${i}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,c){if(t===null||typeof t!="object")throw new S(c,"Object",t)}function I(t,c){if(typeof t!="string")throw new S(c,"string",t)}const b=P.platform==="win32";function r(t){return t===f||t===u}function h(t){return t===f}function g(t){return t>=L&&t<=A||t>=s&&t<=R}function E(t,c,i,n){let o="",l=0,a=-1,m=0,D=0;for(let M=0;M<=t.length;++M){if(M<t.length)D=t.charCodeAt(M);else{if(n(D))break;D=f}if(n(D)){if(!(a===M-1||m===1))if(m===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const T=o.lastIndexOf(i);T===-1?(o="",l=0):(o=o.slice(0,T),l=o.length-1-o.lastIndexOf(i)),a=M,m=0;continue}else if(o.length!==0){o="",l=0,a=M,m=0;continue}}c&&(o+=o.length>0?`${i}..`:"..",l=2)}else o.length>0?o+=`${i}${t.slice(a+1,M)}`:o=t.slice(a+1,M),l=M-a-1;a=M,m=0}else D===k&&m!==-1?++m:m=-1}return o}function p(t,c){d(c,"pathObject");const i=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let c="",i="",n=!1;for(let o=t.length-1;o>=-1;o--){let l;if(o>=0){if(l=t[o],I(l,"path"),l.length===0)continue}else c.length===0?l=P.cwd():(l=P.env[`=${c}`]||P.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===u)&&(l=`${c}\\`));const a=l.length;let m=0,D="",M=!1;const T=l.charCodeAt(0);if(a===1)r(T)&&(m=1,M=!0);else if(r(T))if(M=!0,r(l.charCodeAt(1))){let $=2,z=$;for(;$<a&&!r(l.charCodeAt($));)$++;if($<a&&$!==z){const q=l.slice(z,$);for(z=$;$<a&&r(l.charCodeAt($));)$++;if($<a&&$!==z){for(z=$;$<a&&!r(l.charCodeAt($));)$++;($===a||$!==z)&&(D=`\\\\${q}\\${l.slice(z,$)}`,m=$)}}}else m=1;else g(T)&&l.charCodeAt(1)===w&&(D=l.slice(0,2),m=2,a>2&&r(l.charCodeAt(2))&&(M=!0,m=3));if(D.length>0)if(c.length>0){if(D.toLowerCase()!==c.toLowerCase())continue}else c=D;if(n){if(c.length>0)break}else if(i=`${l.slice(m)}\\${i}`,n=M,M&&c.length>0)break}return i=E(i,!n,"\\",r),n?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){I(t,"path");const c=t.length;if(c===0)return".";let i=0,n,o=!1;const l=t.charCodeAt(0);if(c===1)return h(l)?"\\":t;if(r(l))if(o=!0,r(t.charCodeAt(1))){let m=2,D=m;for(;m<c&&!r(t.charCodeAt(m));)m++;if(m<c&&m!==D){const M=t.slice(D,m);for(D=m;m<c&&r(t.charCodeAt(m));)m++;if(m<c&&m!==D){for(D=m;m<c&&!r(t.charCodeAt(m));)m++;if(m===c)return`\\\\${M}\\${t.slice(D)}\\`;m!==D&&(n=`\\\\${M}\\${t.slice(D,m)}`,i=m)}}}else i=1;else g(l)&&t.charCodeAt(1)===w&&(n=t.slice(0,2),i=2,c>2&&r(t.charCodeAt(2))&&(o=!0,i=3));let a=i<c?E(t.slice(i),!o,"\\",r):"";return a.length===0&&!o&&(a="."),a.length>0&&r(t.charCodeAt(c-1))&&(a+="\\"),n===void 0?o?`\\${a}`:a:o?`${n}\\${a}`:`${n}${a}`},isAbsolute(t){I(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return r(i)||c>2&&g(i)&&t.charCodeAt(1)===w&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let l=0;l<t.length;++l){const a=t[l];I(a,"path"),a.length>0&&(c===void 0?c=i=a:c+=`\\${a}`)}if(c===void 0)return".";let n=!0,o=0;if(typeof i=="string"&&r(i.charCodeAt(0))){++o;const l=i.length;l>1&&r(i.charCodeAt(1))&&(++o,l>2&&(r(i.charCodeAt(2))?++o:n=!1))}if(n){for(;o<c.length&&r(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(t,c){if(I(t,"from"),I(c,"to"),t===c)return"";const i=e.win32.resolve(t),n=e.win32.resolve(c);if(i===n||(t=i.toLowerCase(),c=n.toLowerCase(),t===c))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===u;)o++;let l=t.length;for(;l-1>o&&t.charCodeAt(l-1)===u;)l--;const a=l-o;let m=0;for(;m<c.length&&c.charCodeAt(m)===u;)m++;let D=c.length;for(;D-1>m&&c.charCodeAt(D-1)===u;)D--;const M=D-m,T=a<M?a:M;let $=-1,z=0;for(;z<T;z++){const ie=t.charCodeAt(o+z);if(ie!==c.charCodeAt(m+z))break;ie===u&&($=z)}if(z!==T){if($===-1)return n}else{if(M>T){if(c.charCodeAt(m+z)===u)return n.slice(m+z+1);if(z===2)return n.slice(m+z)}a>T&&(t.charCodeAt(o+z)===u?$=z:z===2&&($=3)),$===-1&&($=0)}let q="";for(z=o+$+1;z<=l;++z)(z===l||t.charCodeAt(z)===u)&&(q+=q.length===0?"..":"\\..");return m+=$,q.length>0?`${q}${n.slice(m,D)}`:(n.charCodeAt(m)===u&&++m,n.slice(m,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===u){if(c.charCodeAt(1)===u){const i=c.charCodeAt(2);if(i!==y&&i!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(g(c.charCodeAt(0))&&c.charCodeAt(1)===w&&c.charCodeAt(2)===u)return`\\\\?\\${c}`;return t},dirname(t){I(t,"path");const c=t.length;if(c===0)return".";let i=-1,n=0;const o=t.charCodeAt(0);if(c===1)return r(o)?t:".";if(r(o)){if(i=n=1,r(t.charCodeAt(1))){let m=2,D=m;for(;m<c&&!r(t.charCodeAt(m));)m++;if(m<c&&m!==D){for(D=m;m<c&&r(t.charCodeAt(m));)m++;if(m<c&&m!==D){for(D=m;m<c&&!r(t.charCodeAt(m));)m++;if(m===c)return t;m!==D&&(i=n=m+1)}}}}else g(o)&&t.charCodeAt(1)===w&&(i=c>2&&r(t.charCodeAt(2))?3:2,n=i);let l=-1,a=!0;for(let m=c-1;m>=n;--m)if(r(t.charCodeAt(m))){if(!a){l=m;break}}else a=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,c){c!==void 0&&I(c,"ext"),I(t,"path");let i=0,n=-1,o=!0,l;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,m=-1;for(l=t.length-1;l>=i;--l){const D=t.charCodeAt(l);if(r(D)){if(!o){i=l+1;break}}else m===-1&&(o=!1,m=l+1),a>=0&&(D===c.charCodeAt(a)?--a===-1&&(n=l):(a=-1,n=m))}return i===n?n=m:n===-1&&(n=t.length),t.slice(i,n)}for(l=t.length-1;l>=i;--l)if(r(t.charCodeAt(l))){if(!o){i=l+1;break}}else n===-1&&(o=!1,n=l+1);return n===-1?"":t.slice(i,n)},extname(t){I(t,"path");let c=0,i=-1,n=0,o=-1,l=!0,a=0;t.length>=2&&t.charCodeAt(1)===w&&g(t.charCodeAt(0))&&(c=n=2);for(let m=t.length-1;m>=c;--m){const D=t.charCodeAt(m);if(r(D)){if(!l){n=m+1;break}continue}o===-1&&(l=!1,o=m+1),D===k?i===-1?i=m:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||o===-1||a===0||a===1&&i===o-1&&i===n+1?"":t.slice(i,o)},format:p.bind(null,"\\"),parse(t){I(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let n=0,o=t.charCodeAt(0);if(i===1)return r(o)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(r(o)){if(n=1,r(t.charCodeAt(1))){let $=2,z=$;for(;$<i&&!r(t.charCodeAt($));)$++;if($<i&&$!==z){for(z=$;$<i&&r(t.charCodeAt($));)$++;if($<i&&$!==z){for(z=$;$<i&&!r(t.charCodeAt($));)$++;$===i?n=$:$!==z&&(n=$+1)}}}}else if(g(o)&&t.charCodeAt(1)===w){if(i<=2)return c.root=c.dir=t,c;if(n=2,r(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;n=3}}n>0&&(c.root=t.slice(0,n));let l=-1,a=n,m=-1,D=!0,M=t.length-1,T=0;for(;M>=n;--M){if(o=t.charCodeAt(M),r(o)){if(!D){a=M+1;break}continue}m===-1&&(D=!1,m=M+1),o===k?l===-1?l=M:T!==1&&(T=1):l!==-1&&(T=-1)}return m!==-1&&(l===-1||T===0||T===1&&l===m-1&&l===a+1?c.base=c.name=t.slice(a,m):(c.name=t.slice(a,l),c.base=t.slice(a,m),c.ext=t.slice(l,m))),a>0&&a!==n?c.dir=t.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(b){const t=/\\/g;return()=>{const c=P.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const o=n>=0?t[n]:C();I(o,"path"),o.length!==0&&(c=`${o}/${c}`,i=o.charCodeAt(0)===f)}return c=E(c,!i,"/",h),i?`/${c}`:c.length>0?c:"."},normalize(t){if(I(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===f,i=t.charCodeAt(t.length-1)===f;return t=E(t,!c,"/",h),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return I(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const n=t[i];I(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(I(t,"from"),I(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,n=t.length,o=n-i,l=1,a=c.length-l,m=o<a?o:a;let D=-1,M=0;for(;M<m;M++){const $=t.charCodeAt(i+M);if($!==c.charCodeAt(l+M))break;$===f&&(D=M)}if(M===m)if(a>m){if(c.charCodeAt(l+M)===f)return c.slice(l+M+1);if(M===0)return c.slice(l+M)}else o>m&&(t.charCodeAt(i+M)===f?D=M:M===0&&(D=0));let T="";for(M=i+D+1;M<=n;++M)(M===n||t.charCodeAt(M)===f)&&(T+=T.length===0?"..":"/..");return`${T}${c.slice(l+D)}`},toNamespacedPath(t){return t},dirname(t){if(I(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===f;let i=-1,n=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===f){if(!n){i=o;break}}else n=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&I(c,"ext"),I(t,"path");let i=0,n=-1,o=!0,l;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,m=-1;for(l=t.length-1;l>=0;--l){const D=t.charCodeAt(l);if(D===f){if(!o){i=l+1;break}}else m===-1&&(o=!1,m=l+1),a>=0&&(D===c.charCodeAt(a)?--a===-1&&(n=l):(a=-1,n=m))}return i===n?n=m:n===-1&&(n=t.length),t.slice(i,n)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===f){if(!o){i=l+1;break}}else n===-1&&(o=!1,n=l+1);return n===-1?"":t.slice(i,n)},extname(t){I(t,"path");let c=-1,i=0,n=-1,o=!0,l=0;for(let a=t.length-1;a>=0;--a){const m=t.charCodeAt(a);if(m===f){if(!o){i=a+1;break}continue}n===-1&&(o=!1,n=a+1),m===k?c===-1?c=a:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||n===-1||l===0||l===1&&c===n-1&&c===i+1?"":t.slice(c,n)},format:p.bind(null,"/"),parse(t){I(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===f;let n;i?(c.root="/",n=1):n=0;let o=-1,l=0,a=-1,m=!0,D=t.length-1,M=0;for(;D>=n;--D){const T=t.charCodeAt(D);if(T===f){if(!m){l=D+1;break}continue}a===-1&&(m=!1,a=D+1),T===k?o===-1?o=D:M!==1&&(M=1):o!==-1&&(M=-1)}if(a!==-1){const T=l===0&&i?1:l;o===-1||M===0||M===1&&o===a-1&&o===l+1?c.base=c.name=t.slice(T,a):(c.name=t.slice(T,o),c.base=t.slice(T,a),c.ext=t.slice(o,a))}return l>0?c.dir=t.slice(0,l-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(ee[73],te([0,1,4]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var s;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(s=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(k,...f){const u=f.reduce((S,d)=>(S[d]=!0,S),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(S=>!u[S]).forEach(S=>{for(let d=0;d<w.length;d++)if(S.search(w[d])!==-1){delete k[S];break}})}e.sanitizeProcessEnvironment=A;function R(k){!k||(delete k.DEBUG,P.isMacintosh&&delete k.DYLD_LIBRARY_PATH,P.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ee[74],te([0,1,4]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=P.globals.performance&&typeof P.globals.performance.now=="function";class s{static create(R=!0){return new s(R)}constructor(R){this.a=L&&R,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?P.globals.performance.now():Date.now()}}e.StopWatch=s}),define(ee[3],te([0,1,13,50,2,100,74]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,f=!1;var u;(function(l){l.None=()=>s.Disposable.None;function a(W){if(f){const{onDidAddListener:N}=W,G=I.create();let j=0;W.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),N?.()}}}function m(W,N){return ae(W,()=>{},0,void 0,!0,void 0,N)}l.defer=m;function D(W){return(N,G=null,j)=>{let B=!1,K;return K=W(re=>{if(!B)return K?K.dispose():B=!0,N.call(G,re)},null,j),B&&K.dispose(),K}}l.once=D;function M(W,N,G){return oe((j,B=null,K)=>W(re=>j.call(B,N(re)),null,K),G)}l.map=M;function T(W,N,G){return oe((j,B=null,K)=>W(re=>{N(re),j.call(B,re)},null,K),G)}l.forEach=T;function $(W,N,G){return oe((j,B=null,K)=>W(re=>N(re)&&j.call(B,re),null,K),G)}l.filter=$;function z(W){return W}l.signal=z;function q(...W){return(N,G=null,j)=>(0,s.combinedDisposable)(...W.map(B=>B(K=>N.call(G,K),null,j)))}l.any=q;function ie(W,N,G,j){let B=G;return M(W,K=>(B=N(B,K),B),j)}l.reduce=ie;function oe(W,N){let G;const j={onWillAddFirstListener(){G=W(B.fire,B)},onDidRemoveLastListener(){G?.dispose()}};N||a(j);const B=new r(j);return N?.add(B),B.event}function ae(W,N,G=100,j=!1,B=!1,K,re){let he,ve,Se,Oe=0,Le;const Fe={leakWarningThreshold:K,onWillAddFirstListener(){he=W(pe=>{Oe++,ve=N(ve,pe),j&&!Se&&(me.fire(ve),ve=void 0),Le=()=>{const Ce=ve;ve=void 0,Se=void 0,(!j||Oe>1)&&me.fire(Ce),Oe=0},typeof G=="number"?(clearTimeout(Se),Se=setTimeout(Le,G)):Se===void 0&&(Se=0,queueMicrotask(Le))})},onWillRemoveListener(){B&&Oe>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,he.dispose()}};re||a(Fe);const me=new r(Fe);return re?.add(me),me.event}l.debounce=ae;function de(W,N=0,G){return l.debounce(W,(j,B)=>j?(j.push(B),j):[B],N,void 0,!0,void 0,G)}l.accumulate=de;function ce(W,N=(j,B)=>j===B,G){let j=!0,B;return $(W,K=>{const re=j||!N(K,B);return j=!1,B=K,re},G)}l.latch=ce;function J(W,N,G){return[l.filter(W,N,G),l.filter(W,j=>!N(j),G)]}l.split=J;function Y(W,N=!1,G=[]){let j=G.slice(),B=W(he=>{j?j.push(he):re.fire(he)});const K=()=>{j?.forEach(he=>re.fire(he)),j=null},re=new r({onWillAddFirstListener(){B||(B=W(he=>re.fire(he)))},onDidAddFirstListener(){j&&(N?setTimeout(K):K())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return re.event}l.buffer=Y;class H{constructor(N){this.event=N,this.c=new s.DisposableStore}map(N){return new H(M(this.event,N,this.c))}forEach(N){return new H(T(this.event,N,this.c))}filter(N){return new H($(this.event,N,this.c))}reduce(N,G){return new H(ie(this.event,N,G,this.c))}latch(){return new H(ce(this.event,void 0,this.c))}debounce(N,G=100,j=!1,B=!1,K){return new H(ae(this.event,N,G,j,B,K,this.c))}on(N,G,j){return this.event(N,G,j)}once(N,G,j){return D(this.event)(N,G,j)}dispose(){this.c.dispose()}}function F(W){return new H(W)}l.chain=F;function V(W,N,G=j=>j){const j=(...he)=>re.fire(G(...he)),B=()=>W.on(N,j),K=()=>W.removeListener(N,j),re=new r({onWillAddFirstListener:B,onDidRemoveLastListener:K});return re.event}l.fromNodeEventEmitter=V;function Z(W,N,G=j=>j){const j=(...he)=>re.fire(G(...he)),B=()=>W.addEventListener(N,j),K=()=>W.removeEventListener(N,j),re=new r({onWillAddFirstListener:B,onDidRemoveLastListener:K});return re.event}l.fromDOMEventEmitter=Z;function ne(W){return new Promise(N=>D(W)(N))}l.toPromise=ne;function se(W,N){return N(void 0),W(G=>N(G))}l.runAndSubscribe=se;function U(W,N){let G=null;function j(K){G?.dispose(),G=new s.DisposableStore,N(K,G)}j(void 0);const B=W(K=>j(K));return(0,s.toDisposable)(()=>{B.dispose(),G?.dispose()})}l.runAndSubscribeWithStore=U;class v{constructor(N,G){this.obs=N,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{N.addObserver(this)},onDidRemoveLastListener:()=>{N.removeObserver(this)}};G||a(j),this.emitter=new r(j),G&&G.add(this.emitter)}beginUpdate(N){this.c++}handleChange(N,G){this.d=!0}endUpdate(N){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function O(W,N){return new v(W,N).emitter.event}l.fromObservable=O})(u=e.Event||(e.Event={}));class w{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${w.c++}`,w.all.add(this)}start(a){this.d=new R.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}w.all=new Set,w.c=0,e.EventProfiling=w;let y=-1;function S(l){const a=y;return y=l,{dispose(){y=a}}}e.setGlobalLeakWarningThreshold=S;class d{constructor(a,m=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=m,this.d=0}dispose(){this.c?.clear()}check(a,m){const D=this.threshold;if(D<=0||m<D)return;this.c||(this.c=new Map);const M=this.c.get(a.value)||0;if(this.c.set(a.value,M+1),this.d-=1,this.d<=0){this.d=D*.5;let T,$=0;for(const[z,q]of this.c)(!T||$<q)&&(T=z,$=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${$}):`),console.warn(T)}return()=>{const T=this.c.get(a.value)||0;this.c.set(a.value,T-1)}}}class I{static create(){return new I(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(a,m,D){this.callback=a,this.callbackThis=m,this.stack=D,this.subscription=new s.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class r{constructor(a){this.j=!1,this.d=a,this.f=y>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new w(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const a=Array.from(this.q);queueMicrotask(()=>{for(const m of a)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,m,D)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.Disposable.None;const M=this.q.isEmpty();M&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,$;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&($=I.create(),T=this.f.check($,this.q.size+1)),k&&($=$??I.create());const z=new b(a,m,$),q=this.q.push(z);M&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,m);const ie=z.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof s.DisposableStore?D.add(ie):Array.isArray(D)&&D.push(ie),ie}),this.l}fire(a){if(this.q){this.m||(this.m=new g(this.d?.onListenerError));for(const m of this.q)this.m.push(this,m,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class h{constructor(a=P.onUnexpectedError){this.d=a,this.c=new A.LinkedList}get size(){return this.c.size}push(a,m,D){this.c.push(new E(a,m,D))}clear(a){const m=new A.LinkedList;for(const D of this.c)D.emitter!==a&&m.push(D);this.c=m}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(m){this.d(m)}}}}e.EventDeliveryQueue=h;class g extends h{clear(a){this.c.clear()}}class E{constructor(a,m,D){this.emitter=a,this.listener=m,this.event=D}}class p extends r{async fireAsync(a,m,D){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const M of this.q)this.c.push([M,a]);for(;this.c.size>0&&!m.isCancellationRequested;){const[M,T]=this.c.shift(),$=[],z={...T,token:m,waitUntil:q=>{if(Object.isFrozen($))throw new Error("waitUntil can NOT be called asynchronous");D&&(q=D(q,M.callback)),$.push(q)}};try{M.invoke(z)}catch(q){(0,P.onUnexpectedError)(q);continue}Object.freeze($),await Promise.allSettled($).then(q=>{for(const ie of q)ie.status==="rejected"&&(0,P.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=p;class C extends r{constructor(a){super(a),this.h=0,this.s=new A.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=C;class t extends C{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=t;class c extends r{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(m=>super.fire(m)),this.c=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const m={event:a,listener:null};this.f.push(m),this.d&&this.j(m);const D=()=>{this.d&&this.k(m);const M=this.f.indexOf(m);this.f.splice(M,1)};return(0,s.toDisposable)((0,L.once)(D))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(m=>this.c.fire(m))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(a){return(m,D,M)=>a(T=>{const $=this.c[this.c.length-1];$?$.push(()=>m.call(D,T)):m.call(D,T)},void 0,M)}bufferEvents(a){const m=[];this.c.push(m);const D=a();return this.c.pop(),m.forEach(M=>M()),D}}e.EventBufferer=n;class o{constructor(){this.c=!1,this.d=u.None,this.f=s.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ee[22],te([0,1,3]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,f){const u=setTimeout(k.bind(f),0);return{dispose(){clearTimeout(u)}}});var s;(function(k){function f(u){return u===k.None||u===k.Cancelled||u instanceof A?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}k.isCancellationToken=f,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(s=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new P.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=s.None}}e.CancellationTokenSource=R}),define(ee[148],te([0,1,22]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new P.CancellationTokenSource,f=this.b(k.token);return this.a={promise:f,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=L;class s{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const f=JSON.stringify(k);return this.b!==f&&(this.b=f,this.a=this.c(k)),this.a}}e.LRUCachedFunction=s;class A{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const f=this.b(k);return this.a.set(k,f),f}}e.CachedFunction=A}),define(ee[25],te([0,1,148,131]),function(x,e,P,L){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=A;const R=/{(\d+)}/g;function k(X,...ue){return ue.length===0?X:X.replace(R,function(ge,be){const we=parseInt(be,10);return isNaN(we)||we<0||we>=ue.length?ge:ue[we]})}e.format=k;const f=/{([^}]+)}/g;function u(X,ue){return X.replace(f,(ge,be)=>ue[be]??ge)}e.format2=u;function w(X){return X.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=w;function y(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function S(X,ue){let ge=0;const be=ue.charCodeAt(0);for(let we=X.length-1;we>=0;we--)X.charCodeAt(we)===be&&ge++;return ge}e.count=S;function d(X,ue,ge="\u2026"){return X.length<=ue?X:`${X.substr(0,ue)}${ge}`}e.truncate=d;function I(X,ue=" "){const ge=b(X,ue);return r(ge,ue)}e.trim=I;function b(X,ue){if(!X||!ue)return X;const ge=ue.length;if(ge===0||X.length===0)return X;let be=0;for(;X.indexOf(ue,be)===be;)be=be+ge;return X.substring(be)}e.ltrim=b;function r(X,ue){if(!X||!ue)return X;const ge=ue.length,be=X.length;if(ge===0||be===0)return X;let we=be,Ae=-1;for(;Ae=X.lastIndexOf(ue,we-1),!(Ae===-1||Ae+ge!==we);){if(Ae===0)return"";we=Ae}return X.substring(0,we)}e.rtrim=r;function h(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(X){return X.replace(/\*/g,"")}e.stripWildcards=g;function E(X,ue,ge={}){if(!X)throw new Error("Cannot create regex from empty string");ue||(X=y(X)),ge.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let be="";return ge.global&&(be+="g"),ge.matchCase||(be+="i"),ge.multiline&&(be+="m"),ge.unicode&&(be+="u"),new RegExp(X,be)}e.createRegExp=E;function p(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function C(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function i(X){for(let ue=0,ge=X.length;ue<ge;ue++){const be=X.charCodeAt(ue);if(be!==32&&be!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function n(X,ue=0,ge=X.length){for(let be=ue;be<ge;be++){const we=X.charCodeAt(be);if(we!==32&&we!==9)return X.substring(ue,be)}return X.substring(ue,ge)}e.getLeadingWhitespace=n;function o(X,ue=X.length-1){for(let ge=ue;ge>=0;ge--){const be=X.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function l(X,ue,ge){const be=[];let we=0;for(const Ae of X.matchAll(ue)){if(be.push(X.slice(we,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");we=Ae.index+Ae[0].length,be.push(ge(Ae[0],...Ae.slice(1),Ae.index,X,Ae.groups))}return be.push(X.slice(we)),Promise.all(be).then(Ae=>Ae.join(""))}e.replaceAsync=l;function a(X,ue){return X<ue?-1:X>ue?1:0}e.compare=a;function m(X,ue,ge=0,be=X.length,we=0,Ae=ue.length){for(;ge<be&&we<Ae;ge++,we++){const Ge=X.charCodeAt(ge),Ke=ue.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const Ne=be-ge,Ve=Ae-we;return Ne<Ve?-1:Ne>Ve?1:0}e.compareSubstring=m;function D(X,ue){return M(X,ue,0,X.length,0,ue.length)}e.compareIgnoreCase=D;function M(X,ue,ge=0,be=X.length,we=0,Ae=ue.length){for(;ge<be&&we<Ae;ge++,we++){let Ge=X.charCodeAt(ge),Ke=ue.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return m(X.toLowerCase(),ue.toLowerCase(),ge,be,we,Ae);$(Ge)&&(Ge-=32),$(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const Ne=be-ge,Ve=Ae-we;return Ne<Ve?-1:Ne>Ve?1:0}e.compareSubstringIgnoreCase=M;function T(X){return X>=48&&X<=57}e.isAsciiDigit=T;function $(X){return X>=97&&X<=122}e.isLowerAsciiLetter=$;function z(X){return X>=65&&X<=90}e.isUpperAsciiLetter=z;function q(X,ue){return X.length===ue.length&&M(X,ue)===0}e.equalsIgnoreCase=q;function ie(X,ue){const ge=ue.length;return ue.length>X.length?!1:M(X,ue,0,ge)===0}e.startsWithIgnoreCase=ie;function oe(X,ue){const ge=Math.min(X.length,ue.length);let be;for(be=0;be<ge;be++)if(X.charCodeAt(be)!==ue.charCodeAt(be))return be;return ge}e.commonPrefixLength=oe;function ae(X,ue){const ge=Math.min(X.length,ue.length);let be;const we=X.length-1,Ae=ue.length-1;for(be=0;be<ge;be++)if(X.charCodeAt(we-be)!==ue.charCodeAt(Ae-be))return be;return ge}e.commonSuffixLength=ae;function de(X){return 55296<=X&&X<=56319}e.isHighSurrogate=de;function ce(X){return 56320<=X&&X<=57343}e.isLowSurrogate=ce;function J(X,ue){return(X-55296<<10)+(ue-56320)+65536}e.computeCodePoint=J;function Y(X,ue,ge){const be=X.charCodeAt(ge);if(de(be)&&ge+1<ue){const we=X.charCodeAt(ge+1);if(ce(we))return J(be,we)}return be}e.getNextCodePoint=Y;function H(X,ue){const ge=X.charCodeAt(ue-1);if(ce(ge)&&ue>1){const be=X.charCodeAt(ue-2);if(de(be))return J(be,ge)}return ge}class F{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=H(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Y(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=F;class V{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new F(ue,ge)}nextGraphemeLength(){const ue=ke.getInstance(),ge=this.c,be=ge.offset;let we=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ae=ge.offset,Ne=ue.getGraphemeBreakType(ge.nextCodePoint());if(le(we,Ne)){ge.setOffset(Ae);break}we=Ne}return ge.offset-be}prevGraphemeLength(){const ue=ke.getInstance(),ge=this.c,be=ge.offset;let we=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ae=ge.offset,Ne=ue.getGraphemeBreakType(ge.prevCodePoint());if(le(Ne,we)){ge.setOffset(Ae);break}we=Ne}return be-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=V;function Z(X,ue){return new V(X,ue).nextGraphemeLength()}e.nextCharLength=Z;function ne(X,ue){return new V(X,ue).prevGraphemeLength()}e.prevCharLength=ne;function se(X,ue){ue>0&&ce(X.charCodeAt(ue))&&ue--;const ge=ue+Z(X,ue);return[ge-ne(X,ge),ge]}e.getCharContainingOffset=se;function U(X){const ue=new V(X);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.charCount=U;let v;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(X){return v||(v=O()),v.test(X)}e.containsRTL=W;const N=/^[\t\n\r\x20-\x7E]*$/;function G(X){return N.test(X)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=j;function B(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=B;function K(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=K;function re(X,ue){if(X.length<ue)return X;const ge=/\b/g;let be=0;for(;ge.test(X)&&!(X.length-ge.lastIndex<ue);)be=ge.lastIndex,ge.lastIndex+=1;return X.substring(be).replace(/^\s/,"")}e.lcut=re;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ve(X){return X&&(X=X.replace(he,"")),X}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Oe(X){return Se(X)?X.substr(1):X}e.stripUTF8BOM=Oe;function Le(X,ue){if(!X||!ue||X.length<ue.length)return!1;const ge=ue.length,be=X.toLowerCase();let we=0,Ae=-1;for(;we<ge;){const Ne=be.indexOf(ue[we],Ae+1);if(Ne<0)return!1;Ae=Ne,we++}return!0}e.fuzzyContains=Le;function Fe(X,ue=!1){return X?(ue&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Fe;function me(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=me;function pe(X,ue=1){if(ue===0)return"";let ge=-1;do ge=X.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?X:(X[ge-1]==="\r"&&ge--,X.substr(0,ge))}e.getNLines=pe;function Ce(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Ce;function _(X){return ke.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=_;function le(X,ue){return X===0?ue!==5&&ue!==7:X===2&&ue===3?!1:X===4||X===2||X===3||ue===4||ue===2||ue===3?!0:!(X===8&&(ue===8||ue===9||ue===11||ue===12)||(X===11||X===9)&&(ue===9||ue===10)||(X===12||X===10)&&ue===10||ue===5||ue===13||ue===7||X===1||X===13&&ue===14||X===6&&ue===6)}var fe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ke{static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Me()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,be=ge.length/3;let we=1;for(;we<=be;)if(ue<ge[3*we])we=2*we;else if(ue>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}ke.c=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(X,ue){if(X===0)return 0;const ge=We(X,ue);if(ge!==void 0)return ge;const be=new F(ue,X);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Te;function We(X,ue){const ge=new F(ue,X);let be=ge.prevCodePoint();for(;$e(be)||be===65039||be===8419;){if(ge.offset===0)return;be=ge.prevCodePoint()}if(!K(be))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function $e(X){return 127995<=X&&X<=127999}var qe;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(ue){return Ue.d.get(Array.from(ue))}static getLocales(){return Ue.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}s=Ue,Ue.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.d=new P.LRUCachedFunction(X=>{function ue(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function ge(Ke,Ye){const Ze=new Map(Ke);for(const[rt,ct]of Ye)Ze.set(rt,ct);return Ze}function be(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[rt,ct]of Ke)Ye.has(rt)&&Ze.set(rt,ct);return Ze}const we=s.c.value;let Ae=X.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Ae.length===0&&(Ae=["_default"]);let Ne;for(const Ke of Ae){const Ye=ue(we[Ke]);Ne=be(Ne,Ye)}const Ve=ue(we._common),Ge=ge(Ve,Ne);return new Ue(Ge)}),Ue.e=new L.Lazy(()=>Object.keys(Ue.c.value).filter(X=>!X.startsWith("_"))),e.AmbiguousCharacters=Ue;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ue){return He.e().has(ue)}static get codePoints(){return He.e()}}He.d=void 0,e.InvisibleCharacters=He}),define(ee[32],te([0,1,9,4,25,11]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(o){return o===47||o===92}e.isPathSeparator=R;function k(o){return o.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=k;function f(o){return o.indexOf("/")===-1&&(o=k(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=f;function u(o,l=P.posix.sep){if(!o)return"";const a=o.length,m=o.charCodeAt(0);if(R(m)){if(R(o.charCodeAt(1))&&!R(o.charCodeAt(2))){let M=3;const T=M;for(;M<a&&!R(o.charCodeAt(M));M++);if(T!==M&&!R(o.charCodeAt(M+1))){for(M+=1;M<a;M++)if(R(o.charCodeAt(M)))return o.slice(0,M+1).replace(/[\\/]/g,l)}}return l}else if(h(m)&&o.charCodeAt(1)===58)return R(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let D=o.indexOf("://");if(D!==-1){for(D+=3;D<a;D++)if(R(o.charCodeAt(D)))return o.slice(0,D+1)}return""}e.getRoot=u;function w(o){if(!L.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let a=2;const m=a;for(;a<o.length&&(l=o.charCodeAt(a),l!==92);a++);return!(m===a||(l=o.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=w;const y=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(o,l=L.isWindows){const a=l?y:S;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||l&&d.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=I;function b(o,l,a){const m=o===l;return!a||m?m:!o||!l?!1:(0,s.equalsIgnoreCase)(o,l)}e.isEqual=b;function r(o,l,a,m=P.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(a){if(!(0,s.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let M=l.length;return l.charAt(l.length-1)===m&&M--,o.charAt(M)===m}return l.charAt(l.length-1)!==m&&(l+=m),o.indexOf(l)===0}e.isEqualOrParent=r;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function g(o,l){return L.isWindows&&o.endsWith(":")&&(o+=P.sep),(0,P.isAbsolute)(o)||(o=(0,P.join)(l,o)),o=(0,P.normalize)(o),L.isWindows?(o=(0,s.rtrim)(o,P.sep),o.endsWith(":")&&(o+=P.sep)):(o=(0,s.rtrim)(o,P.sep),o||(o=P.sep)),o}e.sanitizeFilePath=g;function E(o){const l=(0,P.normalize)(o);return L.isWindows?o.length>3?!1:p(l)&&(o.length===2||l.charCodeAt(2)===92):l===P.posix.sep}e.isRootOrDriveLetter=E;function p(o,l=L.isWindows){return l?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function C(o){return p(o)?o[0]:void 0}e.getDriveLetter=C;function t(o,l,a){return l.length>o.length?-1:o===l?0:(a&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=t;function c(o){const l=o.split(":");let a,m,D;for(const M of l){const T=Number(M);(0,A.isNumber)(T)?m===void 0?m=T:D===void 0&&(D=T):a=a?[a,M].join(":"):M}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:m!==void 0?m:void 0,column:D!==void 0?D:m!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,l,a=8){let m="";for(let M=0;M<a;M++)m+=i.charAt(Math.floor(Math.random()*i.length));let D;return l?D=`${l}-${m}`:D=m,o?(0,P.join)(o,D):D}e.randomPath=n}),define(ee[56],te([0,1,25]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(h){return s(h,0)}e.hash=L;function s(h,g){switch(typeof h){case"object":return h===null?A(349,g):Array.isArray(h)?f(h,g):u(h,g);case"string":return k(h,g);case"boolean":return R(h,g);case"number":return A(h,g);case"undefined":return A(937,g);default:return A(617,g)}}e.doHash=s;function A(h,g){return(g<<5)-g+h|0}e.numberHash=A;function R(h,g){return A(h?433:863,g)}function k(h,g){g=A(149417,g);for(let E=0,p=h.length;E<p;E++)g=A(h.charCodeAt(E),g);return g}e.stringHash=k;function f(h,g){return g=A(104579,g),h.reduce((E,p)=>s(p,E),g)}function u(h,g){return g=A(181387,g),Object.keys(h).sort().reduce((E,p)=>(E=k(p,E),s(h[p],E)),g)}class w{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=s(g,this.g),this.g}}e.Hasher=w;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function S(h,g,E=32){const p=E-g,C=~((1<<p)-1);return(h<<g|(C&h)>>>p)>>>0}function d(h,g=0,E=h.byteLength,p=0){for(let C=0;C<E;C++)h[g+C]=p}function I(h,g,E="0"){for(;h.length<g;)h=E+h;return h}function b(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(E=>E.toString(16).padStart(2,"0")).join(""):I((h>>>0).toString(16),g/4)}e.toHexString=b;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const E=g.length;if(E===0)return;const p=this.p;let C=this.r,t=this.u,c,i;for(t!==0?(c=t,i=-1,t=0):(c=g.charCodeAt(0),i=0);;){let n=c;if(P.isHighSurrogate(c))if(i+1<E){const o=g.charCodeAt(i+1);P.isLowSurrogate(o)?(i++,n=P.computeCodePoint(c,o)):n=65533}else{t=c;break}else P.isLowSurrogate(c)&&(n=65533);if(C=this.w(p,C,n),i++,i<E)c=g.charCodeAt(i);else break}this.r=C,this.u=t}w(g,E,p){return p<128?g[E++]=p:p<2048?(g[E++]=192|(p&1984)>>>6,g[E++]=128|(p&63)>>>0):p<65536?(g[E++]=224|(p&61440)>>>12,g[E++]=128|(p&4032)>>>6,g[E++]=128|(p&63)>>>0):(g[E++]=240|(p&1835008)>>>18,g[E++]=128|(p&258048)>>>12,g[E++]=128|(p&4032)>>>6,g[E++]=128|(p&63)>>>0),E>=64&&(this.y(),E-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=r.g,E=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,E.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,S(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let p=this.h,C=this.l,t=this.m,c=this.n,i=this.o,n,o,l;for(let a=0;a<80;a++)a<20?(n=C&t|~C&c,o=1518500249):a<40?(n=C^t^c,o=1859775393):a<60?(n=C&t|C&c|t&c,o=2400959708):(n=C^t^c,o=3395469782),l=S(p,5)+n+i+o+g.getUint32(a*4,!1)&4294967295,i=c,c=t,t=S(C,30),C=p,p=l;this.h=this.h+p&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+i&4294967295}}r.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=r}),define(ee[75],te([0,1,25]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(L||(L={})),function(s){const A="error",R="warning",k="warn",f="info",u="ignore";function w(S){return S?P.equalsIgnoreCase(A,S)?s.Error:P.equalsIgnoreCase(R,S)||P.equalsIgnoreCase(k,S)?s.Warning:P.equalsIgnoreCase(f,S)?s.Info:s.Ignore:s.Ignore}s.fromValue=w;function y(S){switch(S){case s.Error:return A;case s.Warning:return R;case s.Info:return f;default:return u}}s.toString=y}(L||(L={})),e.default=L}),define(ee[61],te([0,1,26,25]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const I=d.charCodeAt(0),b=this.b.charCodeAt(this.c);return I-b}value(){return this.b[this.c]}}e.StringIterator=s;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,L.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class R{constructor(d=!0,I=!0){this.f=d,this.g=I}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let I=d.length-1;I>=0;I--,this.c--){const b=this.b.charCodeAt(I);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const I=this.b.charCodeAt(this.e);if(I===47||this.f&&I===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,L.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var k;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(d,I){this.f=d,this.g=I,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,L.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(w||(w={}));class y{static forUris(d=()=>!1,I=()=>!1){return new y(new f(d,I))}static forPaths(d=!1){return new y(new R(void 0,!d))}static forStrings(){return new y(new s)}static forConfigKeys(){return new y(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,I){if(I){const b=I.slice(0);(0,P.shuffle)(b);for(const r of b)this.set(r,d)}else{const b=d.slice(0);(0,P.shuffle)(b);for(const r of b)this.set(r[0],r[1])}}set(d,I){const b=this.b.reset(d);let r;this.c||(this.c=new u,this.c.segment=b.value());const h=[];for(r=this.c;;){const E=b.cmp(r.segment);if(E>0)r.left||(r.left=new u,r.left.segment=b.value()),h.push([-1,r]),r=r.left;else if(E<0)r.right||(r.right=new u,r.right.segment=b.value()),h.push([1,r]),r=r.right;else if(b.hasNext())b.next(),r.mid||(r.mid=new u,r.mid.segment=b.value()),h.push([0,r]),r=r.mid;else break}const g=r.value;r.value=I,r.key=d;for(let E=h.length-1;E>=0;E--){const p=h[E][1];p.updateHeight();const C=p.balanceFactor();if(C<-1||C>1){const t=h[E][0],c=h[E+1][0];if(t===1&&c===1)h[E][1]=p.rotateLeft();else if(t===-1&&c===-1)h[E][1]=p.rotateRight();else if(t===1&&c===-1)p.right=h[E+1][1]=h[E+1][1].rotateRight(),h[E][1]=p.rotateLeft();else if(t===-1&&c===1)p.left=h[E+1][1]=h[E+1][1].rotateLeft(),h[E][1]=p.rotateRight();else throw new Error;if(E>0)switch(h[E-1][0]){case-1:h[E-1][1].left=h[E][1];break;case 1:h[E-1][1].right=h[E][1];break;case 0:h[E-1][1].mid=h[E][1];break}else this.c=h[0][1]}}return g}get(d){return this.d(d)?.value}d(d){const I=this.b.reset(d);let b=this.c;for(;b;){const r=I.cmp(b.segment);if(r>0)b=b.left;else if(r<0)b=b.right;else if(I.hasNext())I.next(),b=b.mid;else break}return b}has(d){const I=this.d(d);return!(I?.value===void 0&&I?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,I){const b=this.b.reset(d),r=[];let h=this.c;for(;h;){const g=b.cmp(h.segment);if(g>0)r.push([-1,h]),h=h.left;else if(g<0)r.push([1,h]),h=h.right;else if(b.hasNext())b.next(),r.push([0,h]),h=h.mid;else break}if(!!h){if(I?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:E,value:p,segment:C}=g;this.e(g.key,!1),h.key=E,h.value=p,h.segment=C}}else{const g=h.left??h.right;if(r.length>0){const[E,p]=r[r.length-1];switch(E){case-1:p.left=g;break;case 0:p.mid=g;break;case 1:p.right=g;break}}else this.c=g}for(let g=r.length-1;g>=0;g--){const E=r[g][1];E.updateHeight();const p=E.balanceFactor();if(p>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),r[g][1]=E.rotateLeft()):p<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),r[g][1]=E.rotateRight()),g>0)switch(r[g-1][0]){case-1:r[g-1][1].left=r[g][1];break;case 1:r[g-1][1].right=r[g][1];break;case 0:r[g-1][1].mid=r[g][1];break}else this.c=r[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const I=this.b.reset(d);let b=this.c,r;for(;b;){const h=I.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if(I.hasNext())I.next(),r=b.value||r,b=b.mid;else break}return b&&b.value||r}findSuperstr(d){return this.g(d,!1)}g(d,I){const b=this.b.reset(d);let r=this.c;for(;r;){const h=b.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else return r.mid?this.h(r.mid):I?r.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[I,b]of this)d(b,I)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const I=[];return this.j(d,I),I[Symbol.iterator]()}j(d,I){!d||(d.left&&this.j(d.left,I),d.value&&I.push([d.key,d.value]),d.mid&&this.j(d.mid,I),d.right&&this.j(d.right,I))}_isBalanced(){const d=I=>{if(!I)return!0;const b=I.balanceFactor();return b<-1||b>1?!1:d(I.left)&&d(I.right)};return d(this.c)}}e.TernarySearchTree=y}),define(ee[8],te([0,1,9,4]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function k(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function u(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==y&&(n=y+n):n=y;break}return n}const w="",y="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,l,a,m,D=!1){typeof n=="object"?(this.scheme=n.scheme||w,this.authority=n.authority||w,this.path=n.path||w,this.query=n.query||w,this.fragment=n.fragment||w):(this.scheme=f(n,D),this.authority=o||w,this.path=u(this.scheme,l||w),this.query=a||w,this.fragment=m||w,k(this,D))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:l,path:a,query:m,fragment:D}=n;return o===void 0?o=this.scheme:o===null&&(o=w),l===void 0?l=this.authority:l===null&&(l=w),a===void 0?a=this.path:a===null&&(a=w),m===void 0?m=this.query:m===null&&(m=w),D===void 0?D=this.fragment:D===null&&(D=w),o===this.scheme&&l===this.authority&&a===this.path&&m===this.query&&D===this.fragment?this:new b(o,l,a,m,D)}static parse(n,o=!1){const l=S.exec(n);return l?new b(l[2]||w,c(l[4]||w),c(l[5]||w),c(l[7]||w),c(l[9]||w),o):new b(w,w,w,w,w)}static file(n){let o=w;if(L.isWindows&&(n=n.replace(/\\/g,y)),n[0]===y&&n[1]===y){const l=n.indexOf(y,2);l===-1?(o=n.substring(2),n=y):(o=n.substring(2,l),n=n.substring(l)||y)}return new b("file",o,n,w,w)}static from(n){const o=new b(n.scheme,n.authority,n.path,n.query,n.fragment);return k(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&n.scheme==="file"?l=d.file(P.win32.join(E(n,!0),...o)).path:l=P.posix.join(n.path,...o),n.with({path:l})}toString(n=!1){return p(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const o=new b(n);return o._formatted=n.external,o._fsPath=n._sep===I?n.fsPath:null,o}}else return n}}e.URI=d;const I=L.isWindows?1:void 0;class b extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=I),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let l,a=-1;for(let m=0;m<i.length;m++){const D=i.charCodeAt(m);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||n&&D===47||o&&D===91||o&&D===93||o&&D===58)a!==-1&&(l+=encodeURIComponent(i.substring(a,m)),a=-1),l!==void 0&&(l+=i.charAt(m));else{l===void 0&&(l=i.substr(0,m));const M=r[D];M!==void 0?(a!==-1&&(l+=encodeURIComponent(i.substring(a,m)),a=-1),l+=M):a===-1&&(a=m)}}return a!==-1&&(l+=encodeURIComponent(i.substring(a))),l!==void 0?l:i}function g(i){let n;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);l===35||l===63?(n===void 0&&(n=i.substr(0,o)),n+=r[l]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function E(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=E;function p(i,n){const o=n?g:h;let l="",{scheme:a,authority:m,path:D,query:M,fragment:T}=i;if(a&&(l+=a,l+=":"),(m||a==="file")&&(l+=y,l+=y),m){let $=m.indexOf("@");if($!==-1){const z=m.substr(0,$);m=m.substr($+1),$=z.lastIndexOf(":"),$===-1?l+=o(z,!1,!1):(l+=o(z.substr(0,$),!1,!1),l+=":",l+=o(z.substr($+1),!1,!0)),l+="@"}m=m.toLowerCase(),$=m.lastIndexOf(":"),$===-1?l+=o(m,!1,!0):(l+=o(m.substr(0,$),!1,!0),l+=m.substr($))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const $=D.charCodeAt(1);$>=65&&$<=90&&(D=`/${String.fromCharCode($+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const $=D.charCodeAt(0);$>=65&&$<=90&&(D=`${String.fromCharCode($+32)}:${D.substr(2)}`)}l+=o(D,!0,!1)}return M&&(l+="?",l+=o(M,!1,!1)),T&&(l+="#",l+=n?T:h(T,!1,!1)),l}function C(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+C(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,n=>C(n)):i}}),define(ee[149],te([0,1,8]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(u){const w=u;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=L;function s(u){const w=[];let y;try{const S=JSON.parse(u.arguments),d=S[S.length-1];d&&d.__$stack&&(S.pop(),y=d.__$stack),w.push(...S)}catch{w.push("Unable to log remote console arguments",u.arguments)}return{args:w,stack:y}}e.parse=s;function A(u){if(typeof u!="string")return A(s(u).stack);const w=u;if(w){const y=R(w),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(S&&S.length===4)return{uri:P.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=A;function R(u){if(!u)return u;const w=u.indexOf(`
`);return w===-1?u:u.substring(0,w)}function k(u,w){const{args:y,stack:S}=s(u),d=typeof y[0]=="string"&&y.length===1;let I=R(S);I&&(I=`(${I.trim()})`);let b=[];if(typeof y[0]=="string"?I&&d?b=[`%c[${w}] %c${y[0]} %c${I}`,f("blue"),f(""),f("grey")]:b=[`%c[${w}] %c${y[0]}`,f("blue"),f(""),...y.slice(1)]:b=[`%c[${w}]%`,f("blue"),...y],I&&!d&&b.push(I),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,b)}e.log=k;function f(u){return`color: ${u}`}}),define(ee[85],te([0,1,17,25,8]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(u){return JSON.stringify(u,k)}e.stringify=A;function R(u){let w=JSON.parse(u);return w=f(w),w}e.parse=R;function k(u,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,L.regExpFlags)(w)}:w}function f(u,w=0){if(!u||w>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return s.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof P.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=f(u[y],w+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=f(u[y],w+1))}return u}e.revive=f}),define(ee[15],te([0,1,13,4,8]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${A.vscodeRemoteResource}`}set(w,y,S){this.a[w]=y,this.b[w]=S}setConnectionToken(w,y){this.c[w]=y}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(r){return P.onUnexpectedError(r),w}const y=w.authority;let S=this.a[y];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const d=this.b[y],I=this.c[y];let b=`path=${encodeURIComponent(w.path)}`;return typeof I=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),s.URI.from({scheme:L.isWeb?this.d:A.vscodeRemoteResource,authority:`${S}:${d}`,path:this.f,query:b})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(w){const y=this.b(w,x);return this.uriToBrowserUri(y)}uriToBrowserUri(w){return w.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${k.a}`)?w.with({scheme:A.vscodeFileResource,authority:w.authority||k.a,query:null,fragment:null}):w}asFileUri(w){const y=this.b(w,x);return this.uriToFileUri(y)}uriToFileUri(w){return w.scheme===A.vscodeFileResource?w.with({scheme:A.file,authority:w.authority!==k.a?w.authority:null,query:null,fragment:null}):w}b(w,y){return s.URI.isUri(w)?w:s.URI.parse(y.toUrl(w))}}k.a="vscode-app",e.FileAccess=new k;var f;(function(u){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(w.get("3"));const y="vscode-coi";function S(I){let b;typeof I=="string"?b=new URL(I).searchParams:I instanceof URL?b=I.searchParams:s.URI.isUri(I)&&(b=new URL(I.toString(!0)).searchParams);const r=b?.get(y);if(!!r)return w.get(r)}u.getHeadersFromQuery=S;function d(I,b,r){if(!globalThis.crossOriginIsolated)return;const h=b&&r?"3":r?"2":"1";I instanceof URLSearchParams?I.set(y,h):I[y]=h}u.addSearchParam=d})(f=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,15,9,4,25,8]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(d){return(0,k.uriToFsPath)(d,!0)}e.originalFSPath=f;class u{constructor(I){this.a=I}compare(I,b,r=!1){return I===b?0:(0,R.compare)(this.getComparisonKey(I,r),this.getComparisonKey(b,r))}isEqual(I,b,r=!1){return I===b?!0:!I||!b?!1:this.getComparisonKey(I,r)===this.getComparisonKey(b,r)}getComparisonKey(I,b=!1){return I.with({path:this.a(I)?I.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(I){return this.a(I)}isEqualOrParent(I,b,r=!1){if(I.scheme===b.scheme){if(I.scheme===L.Schemas.file)return P.isEqualOrParent(f(I),f(b),this.a(I))&&I.query===b.query&&(r||I.fragment===b.fragment);if((0,e.isEqualAuthority)(I.authority,b.authority))return P.isEqualOrParent(I.path,b.path,this.a(I),"/")&&I.query===b.query&&(r||I.fragment===b.fragment)}return!1}joinPath(I,...b){return k.URI.joinPath(I,...b)}basenameOrAuthority(I){return(0,e.basename)(I)||I.authority}basename(I){return s.posix.basename(I.path)}extname(I){return s.posix.extname(I.path)}dirname(I){if(I.path.length===0)return I;let b;return I.scheme===L.Schemas.file?b=k.URI.file(s.dirname(f(I))).path:(b=s.posix.dirname(I.path),I.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${I.toString})) resulted in a relative path`),b="/")),I.with({path:b})}normalizePath(I){if(!I.path.length)return I;let b;return I.scheme===L.Schemas.file?b=k.URI.file(s.normalize(f(I))).path:b=s.posix.normalize(I.path),I.with({path:b})}relativePath(I,b){if(I.scheme!==b.scheme||!(0,e.isEqualAuthority)(I.authority,b.authority))return;if(I.scheme===L.Schemas.file){const g=s.relative(f(I),f(b));return A.isWindows?P.toSlashes(g):g}let r=I.path||"/";const h=b.path||"/";if(this.a(I)){let g=0;for(const E=Math.min(r.length,h.length);g<E&&!(r.charCodeAt(g)!==h.charCodeAt(g)&&r.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);r=h.substr(0,g)+r.substr(g)}return s.posix.relative(r,h)}resolvePath(I,b){if(I.scheme===L.Schemas.file){const r=k.URI.file(s.resolve(f(I),b));return I.with({authority:r.authority,path:r.path})}return b=P.toPosixPath(b),I.with({path:s.posix.resolve(I.path,b)})}isAbsolutePath(I){return!!I.path&&I.path[0]==="/"}isEqualAuthority(I,b){return I===b||I!==void 0&&b!==void 0&&(0,R.equalsIgnoreCase)(I,b)}hasTrailingPathSeparator(I,b=s.sep){if(I.scheme===L.Schemas.file){const r=f(I);return r.length>P.getRoot(r).length&&r[r.length-1]===b}else{const r=I.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(I.fsPath)}}removeTrailingPathSeparator(I,b=s.sep){return(0,e.hasTrailingPathSeparator)(I,b)?I.with({path:I.path.substr(0,I.path.length-1)}):I}addTrailingPathSeparator(I,b=s.sep){let r=!1;if(I.scheme===L.Schemas.file){const h=f(I);r=h!==void 0&&h.length===P.getRoot(h).length&&h[h.length-1]===b}else{b="/";const h=I.path;r=h.length===1&&h.charCodeAt(h.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(I,b)?I.with({path:I.path+"/"}):I}}e.ExtUri=u,e.extUri=new u(()=>!1),e.extUriBiasedIgnorePathCase=new u(d=>d.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new u(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(d,I){const b=[];for(let r=0;r<d.length;r++){const h=I(d[r]);d.some((g,E)=>E===r?!1:(0,e.isEqualOrParent)(h,I(g)))||b.push(d[r])}return b}e.distinctParents=w;var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function I(b){const r=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(E=>{const[p,C]=E.split(":");p&&C&&r.set(p,C)});const g=b.path.substring(0,b.path.indexOf(";"));return g&&r.set(d.META_DATA_MIME,g),r}d.parseMetaData=I})(y=e.DataUri||(e.DataUri={}));function S(d,I,b){if(I){let r=d.path;return r&&r[0]!==s.posix.sep&&(r=s.posix.sep+r),d.with({scheme:b,authority:I,path:r})}return d.with({scheme:b})}e.toLocalResource=S}),define(ee[7],te([0,1,22,13,3,2,18,4,134]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u(U){return!!U&&typeof U.then=="function"}e.isThenable=u;function w(U){const v=new P.CancellationTokenSource,O=U(v.token),W=new Promise((N,G)=>{const j=v.token.onCancellationRequested(()=>{j.dispose(),v.dispose(),G(new L.CancellationError)});Promise.resolve(O).then(B=>{j.dispose(),v.dispose(),N(B)},B=>{j.dispose(),v.dispose(),G(B)})});return new class{cancel(){v.cancel()}then(N,G){return W.then(N,G)}catch(N){return this.then(void 0,N)}finally(N){return W.finally(N)}}}e.createCancelablePromise=w;function y(U,v,O){return new Promise((W,N)=>{const G=v.onCancellationRequested(()=>{G.dispose(),W(O)});U.then(W,N).finally(()=>G.dispose())})}e.raceCancellation=y;function S(U,v){return new Promise((O,W)=>{const N=v.onCancellationRequested(()=>{N.dispose(),W(new L.CancellationError)});U.then(O,W).finally(()=>N.dispose())})}e.raceCancellationError=S;async function d(U){let v=-1;const O=U.map((N,G)=>N.then(j=>(v=G,j))),W=await Promise.race(O);return U.forEach((N,G)=>{G!==v&&N.cancel()}),W}e.raceCancellablePromises=d;function I(U,v,O){let W;const N=setTimeout(()=>{W?.(void 0),O?.()},v);return Promise.race([U.finally(()=>clearTimeout(N)),new Promise(G=>W=G)])}e.raceTimeout=I;function b(U){return new Promise((v,O)=>{const W=U();u(W)?W.then(v,O):v(W)})}e.asPromise=b;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(v){if(this.a){if(this.d=v,!this.b){const O=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(O,O).then(W)})}return new Promise((O,W)=>{this.b.then(O,W)})}return this.a=v(),new Promise((O,W)=>{this.a.then(N=>{this.a=null,O(N)},N=>{this.a=null,W(N)})})}}e.Throttler=r;class h{constructor(){this.a=Promise.resolve(null)}queue(v){return this.a=this.a.then(()=>v(),()=>v())}}e.Sequencer=h;class g{constructor(){this.a=new Map}queue(v,O){const N=(this.a.get(v)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(v)===N&&this.a.delete(v)});return this.a.set(v,N),N}}e.SequencerByKey=g;const E=(U,v)=>{let O=!0;const W=setTimeout(()=>{O=!1,v()},U);return{isTriggered:()=>O,dispose:()=>{clearTimeout(W),O=!1}}},p=U=>{let v=!0;return queueMicrotask(()=>{v&&(v=!1,U())}),{isTriggered:()=>v,dispose:()=>{v=!1}}};class C{constructor(v){this.defaultDelay=v,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(v,O=this.defaultDelay){this.g=v,this.h(),this.b||(this.b=new Promise((N,G)=>{this.d=N,this.f=G}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=O===f.MicrotaskDelay?p(W):E(O,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor(v){this.a=new C(v),this.b=new r}trigger(v,O){return this.a.trigger(()=>this.b.queue(v),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((v,O)=>{this.d=v})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class i extends c{constructor(v){super(),this.f=setTimeout(()=>this.open(),v)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(U,v){return v?new Promise((O,W)=>{const N=setTimeout(()=>{G.dispose(),O()},U),G=v.onCancellationRequested(()=>{clearTimeout(N),G.dispose(),W(new L.CancellationError)})}):w(O=>n(U,O))}e.timeout=n;function o(U,v=0){const O=setTimeout(U,v);return(0,A.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=o;function l(U){const v=[];let O=0;const W=U.length;function N(){return O<W?U[O++]():null}function G(j){j!=null&&v.push(j);const B=N();return B?B.then(G):Promise.resolve(v)}return Promise.resolve(null).then(G)}e.sequence=l;function a(U,v=W=>!!W,O=null){let W=0;const N=U.length,G=()=>{if(W>=N)return Promise.resolve(O);const j=U[W++];return Promise.resolve(j()).then(K=>v(K)?Promise.resolve(K):G())};return G()}e.first=a;function m(U,v=W=>!!W,O=null){if(U.length===0)return Promise.resolve(O);let W=U.length;const N=()=>{W=-1;for(const G of U)G.cancel?.()};return new Promise((G,j)=>{for(const B of U)B.then(K=>{--W>=0&&v(K)?(N(),G(K)):W===0&&G(O)}).catch(K=>{--W>=0&&(N(),j(K))})})}e.firstParallel=m;class D{constructor(v){this.a=0,this.d=v,this.f=[],this.b=0,this.g=new s.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(v){return this.a++,new Promise((O,W)=>{this.f.push({factory:v,c:O,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const v=this.f.shift();this.b++;const O=v.factory();O.then(v.c,v.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=D;class M extends D{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const v=new H;return this.b.add(v),v.p}d(){for(const[,v]of this.a)if(v.size>0)return!1;return!0}queueFor(v,O=R.extUri){const W=O.getComparisonKey(v);let N=this.a.get(W);return N||(N=new M,s.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,N)),N}f(){!this.d()||this.g()}g(){for(const v of this.b)v.complete();this.b.clear()}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class ${constructor(v,O){this.a=-1,typeof v=="function"&&typeof O=="number"&&this.setIfNotSet(v,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(v,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,v()},O)}setIfNotSet(v,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,v()},O))}}e.TimeoutTimer=$;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(v,O){this.cancel(),this.a=setInterval(()=>{v()},O)}}e.IntervalTimer=z;class q{constructor(v,O){this.b=-1,this.a=v,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(v=this.d){this.cancel(),this.b=setTimeout(this.f,v)}get delay(){return this.d}set delay(v){this.d=v}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class ie{constructor(v,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=v,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(v=this.b){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(v/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ie;class oe extends q{constructor(v,O){super(v,O),this.j=[]}work(v){this.j.push(v),this.isScheduled()||this.schedule()}h(){const v=this.j;this.j=[],this.a?.(v)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=oe;class ae extends A.Disposable{constructor(v,O){super(),this.g=v,this.h=O,this.a=[],this.b=this.D(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(v){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+v.length>this.g.maxBufferedWork)return!1}else if(this.pending+v.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of v)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,k.setTimeout0)(()=>{if(v)return;const O=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.runWhenIdle=(U,v)=>{const O=requestIdleCallback(U,typeof v=="number"?{timeout:v}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(O))}}}}();class de{constructor(v){this.d=!1,this.a=()=>{try{this.f=v()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=de;async function ce(U,v,O){let W;for(let N=0;N<O;N++)try{return await U()}catch(G){W=G,await n(v)}throw W}e.retry=ce;class J{hasPending(v){return this.a?typeof v=="number"?this.a.taskId===v:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(v,O,W){return this.a={taskId:v,cancel:()=>W?.(),promise:O},O.then(()=>this.d(v),()=>this.d(v)),O}d(v){this.a&&v===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const v=this.b;this.b=void 0,v.run().then(v.promiseResolve,v.promiseReject)}}setNext(v){if(this.b)this.b.run=v;else{let O,W;const N=new Promise((G,j)=>{O=G,W=j});this.b={run:v,promise:N,promiseResolve:O,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=J;class Y{constructor(v,O=()=>Date.now()){this.d=v,this.f=O,this.a=0,this.b=0}increment(){const v=this.f();return v-this.a>this.d&&(this.a=v,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((v,O)=>{this.a=v,this.b=O})}complete(v){return new Promise(O=>{this.a(v),this.f=!0,O()})}error(v){return new Promise(O=>{this.b(v),this.d=!0,O()})}cancel(){new Promise(v=>{this.b(new L.CancellationError),this.d=!0,v()})}}e.DeferredPromise=H;var F;(function(U){async function v(W){let N;const G=await Promise.all(W.map(j=>j.then(B=>B,B=>{N||(N=B)})));if(typeof N<"u")throw N;return G}U.settled=v;function O(W){return new Promise(async(N,G)=>{try{await W(N,G)}catch(j){G(j)}})}U.withAsyncBody=O})(F=e.Promises||(e.Promises={}));var V;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(V||(V={}));class Z{static fromArray(v){return new Z(O=>{O.emitMany(v)})}static fromPromise(v){return new Z(async O=>{O.emitMany(await v)})}static fromPromises(v){return new Z(async O=>{await Promise.all(v.map(async W=>O.emitOne(await W)))})}static merge(v){return new Z(async O=>{await Promise.all(v.map(async W=>{for await(const N of W)O.emitOne(N)}))})}constructor(v){this.a=0,this.b=[],this.d=null,this.f=new s.Emitter,queueMicrotask(async()=>{const O={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(v(O)),this.j()}catch(W){this.k(W)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let v=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(v<this.b.length)return{done:!1,value:this.b[v++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(v,O){return new Z(async W=>{for await(const N of v)W.emitOne(O(N))})}map(v){return Z.map(this,v)}static filter(v,O){return new Z(async W=>{for await(const N of v)O(N)&&W.emitOne(N)})}filter(v){return Z.filter(this,v)}static coalesce(v){return Z.filter(v,O=>!!O)}coalesce(){return Z.coalesce(this)}static async toPromise(v){const O=[];for await(const W of v)O.push(W);return O}toPromise(){return Z.toPromise(this)}g(v){this.a===0&&(this.b.push(v),this.f.fire())}h(v){this.a===0&&(this.b=this.b.concat(v),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(v){this.a===0&&(this.a=2,this.d=v,this.f.fire())}}Z.EMPTY=Z.fromArray([]),e.AsyncIterableObject=Z;class ne extends Z{constructor(v,O){super(O),this.l=v}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function se(U){const v=new P.CancellationTokenSource,O=U(v.token);return new ne(v,async W=>{const N=v.token.onCancellationRequested(()=>{N.dispose(),v.dispose(),W.reject(new L.CancellationError)});try{for await(const G of O){if(v.token.isCancellationRequested)return;W.emitOne(G)}N.dispose(),v.dispose()}catch(G){N.dispose(),v.dispose(),W.reject(G)}})}e.createCancelableAsyncIterable=se}),define(ee[102],te([0,1,26,7,32,35,9,4,25]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function u(){return Object.create(null)}e.getEmptyExpression=u,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",y="[^/\\\\]",S=/\//g;function d(Y,H){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${w}|${y}+${w}${H?`|${w}${y}+`:""})*?`}}function I(Y,H){if(!Y)return[];const F=[];let V=!1,Z=!1,ne="";for(const se of Y){switch(se){case H:if(!V&&!Z){F.push(ne),ne="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}ne+=se}return ne&&F.push(ne),F}e.splitGlobAware=I;function b(Y){if(!Y)return"";let H="";const F=I(Y,e.GLOB_SPLIT);if(F.every(V=>V===e.GLOBSTAR))H=".*";else{let V=!1;F.forEach((Z,ne)=>{if(Z===e.GLOBSTAR){if(V)return;H+=d(2,ne===F.length-1)}else{let se=!1,U="",v=!1,O="";for(const W of Z){if(W!=="}"&&se){U+=W;continue}if(v&&(W!=="]"||!O)){let N;W==="-"?N=W:(W==="^"||W==="!")&&!O?N="^":W===e.GLOB_SPLIT?N="":N=(0,f.escapeRegExpCharacters)(W),O+=N;continue}switch(W){case"{":se=!0;continue;case"[":v=!0;continue;case"}":{H+=`(?:${I(U,",").map(j=>b(j)).join("|")})`,se=!1,U="";break}case"]":{H+="["+O+"]",v=!1,O="";break}case"?":H+=y;continue;case"*":H+=d(1);continue;default:H+=(0,f.escapeRegExpCharacters)(W)}}ne<F.length-1&&(F[ne+1]!==e.GLOBSTAR||ne+2<F.length)&&(H+=w)}V=Z===e.GLOBSTAR})}return H}const r=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),c=function(){return!1},i=function(){return null};function n(Y,H){if(!Y)return i;let F;typeof Y!="string"?F=Y.pattern:F=Y,F=F.trim();const V=`${F}_${!!H.trimForExclusions}`;let Z=t.get(V);if(Z)return o(Z,Y);let ne;return r.test(F)?Z=a(F.substr(4),F):(ne=h.exec(l(F,H)))?Z=m(ne[1],F):(H.trimForExclusions?E:g).test(F)?Z=D(F,H):(ne=p.exec(l(F,H)))?Z=M(ne[1].substr(1),F,!0):(ne=C.exec(l(F,H)))?Z=M(ne[1],F,!1):Z=T(F),t.set(V,Z),o(Z,Y)}function o(Y,H){if(typeof H=="string")return Y;const F=function(V,Z){return(0,s.isEqualOrParent)(V,H.base,!k.isLinux)?Y((0,f.ltrim)(V.substr(H.base.length),R.sep),Z):null};return F.allBasenames=Y.allBasenames,F.allPaths=Y.allPaths,F.basenames=Y.basenames,F.patterns=Y.patterns,F}function l(Y,H){return H.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,H){return function(F,V){return typeof F=="string"&&F.endsWith(Y)?H:null}}function m(Y,H){const F=`/${Y}`,V=`\\${Y}`,Z=function(se,U){return typeof se!="string"?null:U?U===Y?H:null:se===Y||se.endsWith(F)||se.endsWith(V)?H:null},ne=[Y];return Z.basenames=ne,Z.patterns=[H],Z.allBasenames=ne,Z}function D(Y,H){const F=ce(Y.slice(1,-1).split(",").map(U=>n(U,H)).filter(U=>U!==i),Y),V=F.length;if(!V)return i;if(V===1)return F[0];const Z=function(U,v){for(let O=0,W=F.length;O<W;O++)if(F[O](U,v))return Y;return null},ne=F.find(U=>!!U.allBasenames);ne&&(Z.allBasenames=ne.allBasenames);const se=F.reduce((U,v)=>v.allPaths?U.concat(v.allPaths):U,[]);return se.length&&(Z.allPaths=se),Z}function M(Y,H,F){const V=R.sep===R.posix.sep,Z=V?Y:Y.replace(S,R.sep),ne=R.sep+Z,se=R.posix.sep+Y;let U;return F?U=function(v,O){return typeof v=="string"&&(v===Z||v.endsWith(ne)||!V&&(v===Y||v.endsWith(se)))?H:null}:U=function(v,O){return typeof v=="string"&&(v===Z||!V&&v===Y)?H:null},U.allPaths=[(F?"*/":"./")+Y],U}function T(Y){try{const H=new RegExp(`^${b(Y)}$`);return function(F){return H.lastIndex=0,typeof F=="string"&&H.test(F)?Y:null}}catch{return i}}function $(Y,H,F){return!Y||typeof H!="string"?!1:z(Y)(H,void 0,F)}e.match=$;function z(Y,H={}){if(!Y)return c;if(typeof Y=="string"||q(Y)){const F=n(Y,H);if(F===i)return c;const V=function(Z,ne){return!!F(Z,ne)};return F.allBasenames&&(V.allBasenames=F.allBasenames),F.allPaths&&(V.allPaths=F.allPaths),V}return ae(Y,H)}e.parse=z;function q(Y){const H=Y;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=q;function ie(Y){return Y.allBasenames||[]}e.getBasenameTerms=ie;function oe(Y){return Y.allPaths||[]}e.getPathTerms=oe;function ae(Y,H){const F=ce(Object.getOwnPropertyNames(Y).map(U=>de(U,Y[U],H)).filter(U=>U!==i)),V=F.length;if(!V)return i;if(!F.some(U=>!!U.requiresSiblings)){if(V===1)return F[0];const U=function(W,N){let G;for(let j=0,B=F.length;j<B;j++){const K=F[j](W,N);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(G||(G=[]),G.push(K))}return G?(async()=>{for(const j of G){const B=await j;if(typeof B=="string")return B}return null})():null},v=F.find(W=>!!W.allBasenames);v&&(U.allBasenames=v.allBasenames);const O=F.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return O.length&&(U.allPaths=O),U}const Z=function(U,v,O){let W,N;for(let G=0,j=F.length;G<j;G++){const B=F[G];B.requiresSiblings&&O&&(v||(v=(0,R.basename)(U)),W||(W=v.substr(0,v.length-(0,R.extname)(U).length)));const K=B(U,v,W,O);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(N||(N=[]),N.push(K))}return N?(async()=>{for(const G of N){const j=await G;if(typeof j=="string")return j}return null})():null},ne=F.find(U=>!!U.allBasenames);ne&&(Z.allBasenames=ne.allBasenames);const se=F.reduce((U,v)=>v.allPaths?U.concat(v.allPaths):U,[]);return se.length&&(Z.allPaths=se),Z}function de(Y,H,F){if(H===!1)return i;const V=n(Y,F);if(V===i)return i;if(typeof H=="boolean")return V;if(H){const Z=H.when;if(typeof Z=="string"){const ne=(se,U,v,O)=>{if(!O||!V(se,U))return null;const W=Z.replace("$(basename)",()=>v),N=O(W);return(0,L.isThenable)(N)?N.then(G=>G?Y:null):N?Y:null};return ne.requiresSiblings=!0,ne}}return V}function ce(Y,H){const F=Y.filter(U=>!!U.basenames);if(F.length<2)return Y;const V=F.reduce((U,v)=>{const O=v.basenames;return O?U.concat(O):U},[]);let Z;if(H){Z=[];for(let U=0,v=V.length;U<v;U++)Z.push(H)}else Z=F.reduce((U,v)=>{const O=v.patterns;return O?U.concat(O):U},[]);const ne=function(U,v){if(typeof U!="string")return null;if(!v){let W;for(W=U.length;W>0;W--){const N=U.charCodeAt(W-1);if(N===47||N===92)break}v=U.substr(W)}const O=V.indexOf(v);return O!==-1?Z[O]:null};ne.basenames=V,ne.patterns=Z,ne.allBasenames=V;const se=Y.filter(U=>!U.basenames);return se.push(ne),se}function J(Y,H){return(0,P.equals)(Y,H,(F,V)=>typeof F=="string"&&typeof V=="string"?F===V:typeof F!="string"&&typeof V!="string"?F.base===V.base&&F.pattern===V.pattern:!1)}e.patternsEquals=J}),define(ee[45],te([0,1,26,32,9,4,18,25]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,n){const{os:o,tildify:l,relative:a}=n;if(a){const M=u(i,a,o);if(typeof M=="string")return M}let m=i.fsPath;if(o===1&&!A.isWindows?m=m.replace(/\//g,"\\"):o!==1&&A.isWindows&&(m=m.replace(/\\/g,"/")),o!==1&&l?.userHome){const M=l.userHome.fsPath;let T;i.scheme!==l.userHome.scheme&&i.path.startsWith(s.posix.sep)?T=l.userHome.with({path:i.path}).fsPath:T=i.fsPath,m=S(T,M,o)}return(o===1?s.win32:s.posix).normalize(w(m,o===1))}e.getPathLabel=f;function u(i,n,o){const l=o===1?s.win32:s.posix,a=o===3?R.extUri:R.extUriIgnorePathCase,m=n.getWorkspace(),D=(0,P.firstOrDefault)(m.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(s.posix.sep)&&(i=D.uri.with({path:i.path}));const M=n.getWorkspaceFolder(i);if(!M)return;let T;if(a.isEqual(M.uri,i)?T="":T=a.relativePath(M.uri,i)??"",T&&(T=l.normalize(T)),m.folders.length>1&&!n.noPrefix){const $=M.name?M.name:a.basenameOrAuthority(M.uri);T=T?`${$} \u2022 ${T}`:$}return T}function w(i,n=A.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=w;let y=Object.create(null);function S(i,n,o=A.OS){if(o===1||!i||!n)return i;let l=y.original===n?y.normalized:void 0;l||(l=n,A.isWindows&&(l=(0,L.toSlashes)(l)),l=`${(0,k.rtrim)(l,s.posix.sep)}${s.posix.sep}`,y={original:n,normalized:l});let a=i;return A.isWindows&&(a=(0,L.toSlashes)(a)),(o===3?a.startsWith(l):(0,k.startsWithIgnoreCase)(a,l))?`~/${a.substr(l.length)}`:i}e.tildify=S;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=d;const I="\u2026",b="\\\\",r="~";function h(i,n=s.sep){const o=new Array(i.length);let l=!1;for(let a=0;a<i.length;a++){const m=i[a];if(m===""){o[a]=`.${n}`;continue}if(!m){o[a]=m;continue}l=!0;let D="",M=m;M.indexOf(b)===0?(D=M.substr(0,M.indexOf(b)+b.length),M=M.substr(M.indexOf(b)+b.length)):M.indexOf(n)===0?(D=M.substr(0,M.indexOf(n)+n.length),M=M.substr(M.indexOf(n)+n.length)):M.indexOf(r)===0&&(D=M.substr(0,M.indexOf(r)+r.length),M=M.substr(M.indexOf(r)+r.length));const T=M.split(n);for(let $=1;l&&$<=T.length;$++)for(let z=T.length-$;l&&z>=0;z--){l=!1;let q=T.slice(z,z+$).join(n);for(let ie=0;!l&&ie<i.length;ie++)if(ie!==a&&i[ie]&&i[ie].indexOf(q)>-1){const oe=z+$===T.length,ae=z>0&&i[ie].indexOf(n)>-1?n+q:q,de=i[ie].endsWith(ae);l=!oe||de}if(!l){let ie="";(T[0].endsWith(":")||D!=="")&&(z===1&&(z=0,$++,q=T[0]+n+q),z>0&&(ie=T[0]+n),ie=D+ie),z>0&&(ie=ie+I+n),ie=ie+q,z+$<T.length&&(ie=ie+n+I),o[a]=ie}}l&&(o[a]=m)}return o}e.shorten=h;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(i,n=Object.create(null)){const o=[];let l=!1,a="";for(const m of i)if(m==="$"||l&&m==="{")a&&o.push({value:a,type:g.TEXT}),a="",l=!0;else if(m==="}"&&l){const D=n[a];if(typeof D=="string")D.length&&o.push({value:D,type:g.VARIABLE});else if(D){const M=o[o.length-1];(!M||M.type!==g.SEPARATOR)&&o.push({value:D.label,type:g.SEPARATOR})}a="",l=!1}else a+=m;return a&&!l&&o.push({value:a,type:g.TEXT}),o.filter((m,D)=>{if(m.type===g.SEPARATOR){const M=o[D-1],T=o[D+1];return[M,T].every($=>$&&($.type===g.VARIABLE||$.type===g.TEXT)&&$.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=E;function p(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function C(i,n){return A.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const n=i.indexOf("/")!==-1?s.posix:s.win32,o=n.basename(i),l=n.dirname(i);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(ee[150],te([0,1,17,8]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function s(y){return y.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:s(L.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:s(L.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:L.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function R(y,S,d){if(!y||d>200)return null;if(typeof y=="object"){if(y instanceof L.URI)return S.transformOutgoing(y);for(const I in y)if(Object.hasOwnProperty.call(y,I)){const b=R(y[I],S,d+1);b!==null&&(y[I]=b)}}return null}function k(y,S){const d=R(y,S,0);return d===null?y:d}e.transformOutgoingURIs=k;function f(y,S,d,I){if(!y||I>200)return null;if(typeof y=="object"){if(y.$mid===1)return d?L.URI.revive(S.transformIncoming(y)):S.transformIncoming(y);if(y instanceof P.VSBuffer)return null;for(const b in y)if(Object.hasOwnProperty.call(y,b)){const r=f(y[b],S,d,I+1);r!==null&&(y[b]=r)}}return null}function u(y,S){const d=f(y,S,!1,0);return d===null?y:d}e.transformIncomingURIs=u;function w(y,S){const d=f(y,S,!0,0);return d===null?y:d}e.transformAndReviveIncomingURIs=w}),define(ee[86],te([0,1,27,13,61,31,138]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(w){return this.a||(this.a=s.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,y=0;const S=(0,P.networkInterfaces)();for(const d in S){const I=S[d];if(I)for(const{mac:b,internal:r}of I)r||(y+=1,this.c(b.toUpperCase())&&(w+=1))}this.b=y>0?w/y:0}return this.b}};let k;async function f(){return k||(k=(async()=>await u()||A.generateUuid())()),k}e.getMachineId=f;async function u(){try{const w=await new Promise((S,d)=>{x(["crypto"],S,d)}),y=(0,R.getMac)();return w.createHash("sha256").update(y,"utf8").digest("hex")}catch(w){L.onUnexpectedError(w);return}}}),define(ee[23],te([0,1,41,27,151,7,32,82,9,4,18,8]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(ae){ae[ae.UNLINK=0]="UNLINK",ae[ae.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function d(ae,de=S.UNLINK){if((0,R.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");return de===S.UNLINK?b(ae):I(ae)}async function I(ae){try{const de=(0,R.randomPath)((0,L.tmpdir)());try{await P.promises.rename(ae,de)}catch(ce){return ce.code==="ENOENT"?void 0:b(ae)}b(de).catch(ce=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function b(ae){return(0,s.promisify)(P.rm)(ae,{recursive:!0,force:!0,maxRetries:3})}function r(ae){if((0,R.isRootOrDriveLetter)(ae))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ae,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function h(ae,de){return p(await(de?g(ae):(0,s.promisify)(P.readdir)(ae)))}async function g(ae){try{return await(0,s.promisify)(P.readdir)(ae,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const de=[],ce=await h(ae);for(const J of ce){let Y=!1,H=!1,F=!1;try{const V=await e.Promises.lstat((0,f.join)(ae,J));Y=V.isFile(),H=V.isDirectory(),F=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}de.push({name:J,isFile:()=>Y,isDirectory:()=>H,isSymbolicLink:()=>F})}return de}function E(ae){return p(P.readdirSync(ae))}e.readdirSync=E;function p(ae){return ae.map(de=>typeof de=="string"?u.isMacintosh?(0,k.normalizeNFC)(de):de:(de.name=u.isMacintosh?(0,k.normalizeNFC)(de.name):de.name,de))}async function C(ae){const de=await h(ae),ce=[];for(const J of de)await c.existsDirectory((0,f.join)(ae,J))&&ce.push(J);return ce}function t(ae,de=1e3){return new Promise(ce=>{let J=!1;const Y=setInterval(()=>{J||(J=!0,P.access(ae,H=>{J=!1,H&&(clearInterval(Y),ce(void 0))}))},de)})}e.whenDeleted=t;var c;(function(ae){async function de(Y){let H;try{if(H=await e.Promises.lstat(Y),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(u.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw V}throw F}}ae.stat=de;async function ce(Y){try{const{stat:H,symbolicLink:F}=await ae.stat(Y);return H.isFile()&&F?.dangling!==!0}catch{}return!1}ae.existsFile=ce;async function J(Y){try{const{stat:H,symbolicLink:F}=await ae.stat(Y);return H.isDirectory()&&F?.dangling!==!0}catch{}return!1}ae.existsDirectory=J})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function n(ae,de,ce){return i.queueFor(y.URI.file(ae),w.extUriBiasedIgnorePathCase).queue(()=>{const J=D(ce);return new Promise((Y,H)=>a(ae,de,J,F=>F?H(F):Y()))})}let o=!0;function l(ae){o=ae}e.configureFlushOnWrite=l;function a(ae,de,ce,J){if(!o)return P.writeFile(ae,de,{mode:ce.mode,flag:ce.flag},J);P.open(ae,ce.flag,ce.mode,(Y,H)=>{if(Y)return J(Y);P.writeFile(H,de,F=>{if(F)return P.close(H,()=>J(F));P.fdatasync(H,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),l(!1)),P.close(H,Z=>J(Z))))})})}function m(ae,de,ce){const J=D(ce);if(!o)return P.writeFileSync(ae,de,{mode:J.mode,flag:J.flag});const Y=P.openSync(ae,J.flag,J.mode);try{P.writeFileSync(Y,de);try{P.fdatasyncSync(Y)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),l(!1)}}finally{P.closeSync(Y)}}e.writeFileSync=m;function D(ae){return ae?{mode:typeof ae.mode=="number"?ae.mode:438,flag:typeof ae.flag=="string"?ae.flag:"w"}:{mode:438,flag:"w"}}async function M(ae,de){if(ae!==de)try{await e.Promises.rename(ae,de)}catch(ce){if(ae.toLowerCase()!==de.toLowerCase()&&ce.code==="EXDEV"||ae.endsWith("."))await T(ae,de,{preserveSymlinks:!1}),await d(ae,S.MOVE);else throw ce}}async function T(ae,de,ce){return z(ae,de,{root:{source:ae,target:de},options:ce,handledSourcePaths:new Set})}const $=511;async function z(ae,de,ce){if(ce.handledSourcePaths.has(ae))return;ce.handledSourcePaths.add(ae);const{stat:J,symbolicLink:Y}=await c.stat(ae);if(Y){if(ce.options.preserveSymlinks)try{return await oe(ae,de,ce)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(Y.dangling)return}return J.isDirectory()?q(ae,de,J.mode&$,ce):ie(ae,de,J.mode&$)}async function q(ae,de,ce,J){await e.Promises.mkdir(de,{recursive:!0,mode:ce});const Y=await h(ae);for(const H of Y)await z((0,f.join)(ae,H),(0,f.join)(de,H),J)}async function ie(ae,de,ce){await e.Promises.copyFile(ae,de),await e.Promises.chmod(de,ce)}async function oe(ae,de,ce){let J=await e.Promises.readlink(ae);(0,R.isEqualOrParent)(J,ce.root.source,!u.isLinux)&&(J=(0,f.join)(ce.root.target,J.substr(ce.root.source.length+1))),await e.Promises.symlink(J,de)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ae,de,ce,J,Y)=>new Promise((H,F)=>{P.read(ae,de,ce,J,Y,(V,Z,ne)=>V?F(V):H({bytesRead:Z,buffer:ne}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ae,de,ce,J,Y)=>new Promise((H,F)=>{P.write(ae,de,ce,J,Y,(V,Z,ne)=>V?F(V):H({bytesWritten:Z,buffer:ne}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get rename(){return(0,s.promisify)(P.rename)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ae){try{return await e.Promises.access(ae),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return C}get writeFile(){return n}get rm(){return d}get move(){return M}get copy(){return T}}}),define(ee[103],te([0,1,41,9,4,25,23]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(S){if(s.isLinux)return S;const d=(0,L.dirname)(S);if(S===d)return S;const I=((0,L.basename)(S)||S).toLowerCase();try{const r=(0,R.readdirSync)(d).filter(h=>h.toLowerCase()===I);if(r.length===1){const h=k(d);if(h)return(0,L.join)(h,r[0])}else if(r.length>1){const h=r.indexOf(I);if(h>=0){const g=k(d);if(g)return(0,L.join)(g,r[h])}}}catch{}return null}e.realcaseSync=k;async function f(S){if(s.isLinux)return S;const d=(0,L.dirname)(S);if(S===d)return S;const I=((0,L.basename)(S)||S).toLowerCase();try{const r=(await R.Promises.readdir(d)).filter(h=>h.toLowerCase()===I);if(r.length===1){const h=await f(d);if(h)return(0,L.join)(h,r[0])}else if(r.length>1){const h=r.indexOf(I);if(h>=0){const g=await f(d);if(g)return(0,L.join)(g,r[h])}}}catch{}return null}e.realcase=f;async function u(S){try{return await R.Promises.realpath(S)}catch{const I=y(S);return await R.Promises.access(I,P.constants.R_OK),I}}e.realpath=u;function w(S){try{return P.realpathSync(S)}catch{const I=y(S);return P.accessSync(I,P.constants.R_OK),I}}e.realpathSync=w;function y(S){return(0,A.rtrim)((0,L.normalize)(S),L.sep)}}),define(ee[152],te([0,1,27,9,23]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var f;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class y{constructor(C,t,c){this.exePath=C,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function S({useAlternateBitness:p=!1}={}){return p?u===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:C=!1}={}){const t=S({useAlternateBitness:p});if(!t)return null;const c=L.join(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(c))return null;let i=-1,n=null;for(const a of await s.Promises.readdir(c)){let m=-1;if(C){const M=a.indexOf("-");if(M<0)continue;const T=a.substring(0,M);if(!A.test(T)||a.substring(M+1)!=="preview")continue;m=parseInt(T,10)}else{if(!A.test(a))continue;m=parseInt(a,10)}if(m<=i)continue;const D=L.join(c,a,"pwsh.exe");!await s.SymlinkSupport.existsFile(D)||(n=D,i=m)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",l=C?" Preview":"";return new y(n,`PowerShell${l}${o}`,!0)}async function I({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const C=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=p?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await s.Promises.readdir(C))if(t.test(i)){const n=L.join(C,i,"pwsh.exe");return new y(n,c)}return null}function b(){const p=L.join(P.homedir(),".dotnet","tools","pwsh.exe");return new y(p,".NET Core PowerShell Global Tool")}function r(){const p=L.join(process.env.windir,u===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await I(),p&&(yield p),p=b(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await I({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=r(),p&&(yield p)}async function*g(){for await(const p of h())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=g;async function E(){for await(const p of g())return p;return null}e.getFirstAvailablePowerShellInstallation=E}),define(ee[87],te([0,1,9,4,36,73,11,23]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function f(y=s.env){return y.comspec||"cmd.exe"}e.getWindowsShell=f;function u(y){let S=[],d=!1;const I=function(b){if(d){S.push(b);return}(!y.send(b,h=>{if(h&&console.error(h),d=!1,S.length>0){const g=S.slice(0);S=[],g.forEach(E=>I(E))}})||L.isWindows)&&(d=!0)};return{send:I}}e.createQueuedSender=u;var w;(function(y){async function S(d,I,b){if(P.isAbsolute(d))return d;if(I===void 0&&(I=s.cwd()),P.dirname(d)!=="."||(b===void 0&&R.isString(s.env.PATH)&&(b=s.env.PATH.split(P.delimiter)),b===void 0||b.length===0))return P.join(I,d);async function h(g){if(await k.Promises.exists(g)){let E;try{E=await k.Promises.stat(g)}catch(p){p.message.startsWith("EACCES")&&(E=await k.Promises.lstat(g))}return E?!E.isDirectory():!1}return!1}for(const g of b){let E;if(P.isAbsolute(g)?E=P.join(g,d):E=P.join(I,g,d),await h(E))return E;let p=E+".com";if(await h(p)||(p=E+".exe",await h(p)))return p}return P.join(I,d)}y.findExecutable=S})(w=e.win32||(e.win32={}))}),define(ee[104],te([0,1,46,15]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function s(R){return new Promise((k,f)=>{let u;const w=new Map;function y(d,I,b,r,h){const g=w.get(I);if(d===R||g){const E={name:S(b),cmd:b,pid:d,ppid:I,load:r,mem:h};w.set(d,E),d===R&&(u=E),g&&(g.children||(g.children=[]),g.children.push(E),g.children.length>1&&(g.children=g.children.sort((p,C)=>p.pid-C.pid)))}}function S(d){const I=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,g=/conhost\.exe/i,E=/--type=([a-zA-Z-]+)/;if(r.exec(d))return"electron-crash-reporter";if(h.exec(d))return"winpty-process";if(g.exec(d))return"console-window-host (Windows internal process)";let p=E.exec(d);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?I.exec(d)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const C=/[a-zA-Z-]+\.js/g;let t="";do p=C.exec(d),p&&(t+=p+" ");while(p);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=I=>I.indexOf("\\\\?\\")===0||I.indexOf("\\??\\")===0?I.substr(4):I.indexOf('"\\\\?\\')===0||I.indexOf('"\\??\\')===0?'"'+I.substr(5):I;new Promise((I,b)=>{x(["windows-process-tree"],I,b)}).then(I=>{I.getProcessList(R,b=>{if(!b){f(new Error(`Root process ${R} not found`));return}I.getProcessCpuUsage(b,r=>{const h=new Map;r.forEach(g=>{const E=d(g.commandLine||"");h.set(g.pid,{name:S(E),cmd:E,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),u=h.get(R),u?(h.forEach(g=>{const E=h.get(g.ppid);E&&(E.children||(E.children=[]),E.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((E,p)=>E.pid-p.pid))}),k(u)):f(new Error(`Root process ${R} not found`))})},I.ProcessDataFlag.CommandLine|I.ProcessDataFlag.Memory)})}else{let d=function(){let I=[u];const b=[];for(;I.length;){const h=I.shift();h&&(b.push(h.pid),h.children&&(I=I.concat(h.children)))}let r=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+b.join(" "),(0,P.exec)(r,{},(h,g,E)=>{if(h||E)f(h||new Error(E.toString()));else{const p=g.toString().split(`
`);for(let C=0;C<b.length;C++){const t=w.get(b[C]);t.load=parseFloat(p[C])}if(!u){f(new Error(`Root process ${R} not found`));return}k(u)}})};(0,P.exec)("which ps",{},(I,b,r)=>{if(I||r)if(process.platform!=="linux")f(I||new Error(r.toString()));else{const h=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(h,{},(g,E,p)=>{g||p?f(g||new Error(p.toString())):(A(E,y),d())})}else{const h=b.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${h} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,p,C)=>{E||C&&!C.includes("screen size is bogus")?f(E||new Error(C.toString())):(A(p,y),process.platform==="linux"?d():u?k(u):f(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=s;function A(R,k){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=R.toString().split(`
`);for(const w of u){const y=f.exec(w.trim());y&&y.length===6&&k(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ee[153],te([0,1,27,4,152,87]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(y,S){return y===1?L.isWindows?w():A.getWindowsShell(S):f(y,S)}e.getSystemShell=R;let k=null;function f(y,S){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!k){let d;if(L.isWindows)d="/bin/bash";else{if(d=S.SHELL,!d)try{d=(0,P.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}k=d}return k}let u=null;async function w(){return u||(u=(await(0,s.getFirstAvailablePowerShellInstallation)()).exePath),u}});var ye=this&&this.__decorate||function(x,e,P,L){var s=arguments.length,A=s<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,P):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(x,e,P,L);else for(var k=x.length-1;k>=0;k--)(R=x[k])&&(A=(s<3?R(A):s>3?R(e,P,A):R(e,P))||A);return s>3&&A&&Object.defineProperty(e,P,A),A};define(ee[47],te([0,1,26,7,17,22,55,13,3,2,85,25,11]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(d||(d={}));function I(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(b||(b={}));function r(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function g(H){let F=0;for(let V=0;;V+=7){const Z=H.read(1);if(F|=(Z.buffer[0]&127)<<V,!(Z.buffer[0]&128))return F}}const E=i(0);function p(H,F){if(F===0){H.write(E);return}let V=0;for(let ne=F;ne!==0;ne=ne>>>7)V++;const Z=s.VSBuffer.alloc(V);for(let ne=0;F!==0;ne++)Z.buffer[ne]=F&127,F=F>>>7,F>0&&(Z.buffer[ne]|=128);H.write(Z)}class C{constructor(F){this.b=F,this.a=0}read(F){const V=this.b.slice(this.a,this.a+F);return this.a+=V.byteLength,V}}e.BufferReader=C;class t{constructor(){this.a=[]}get buffer(){return s.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=t;var c;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(c||(c={}));function i(H){const F=s.VSBuffer.alloc(1);return F.writeUInt8(H,0),F}const n={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},o=typeof Buffer<"u";function l(H,F){if(typeof F>"u")H.write(n.Undefined);else if(typeof F=="string"){const V=s.VSBuffer.fromString(F);H.write(n.String),p(H,V.byteLength),H.write(V)}else if(o&&Buffer.isBuffer(F)){const V=s.VSBuffer.wrap(F);H.write(n.Buffer),p(H,V.byteLength),H.write(V)}else if(F instanceof s.VSBuffer)H.write(n.VSBuffer),p(H,F.byteLength),H.write(F);else if(Array.isArray(F)){H.write(n.Array),p(H,F.length);for(const V of F)l(H,V)}else if(typeof F=="number"&&(F|0)===F)H.write(n.Uint),p(H,F);else{const V=s.VSBuffer.fromString(JSON.stringify(F));H.write(n.Object),p(H,V.byteLength),H.write(V)}}e.serialize=l;function a(H){switch(H.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return H.read(g(H)).toString();case c.Buffer:return H.read(g(H)).buffer;case c.VSBuffer:return H.read(g(H));case c.Array:{const V=g(H),Z=[];for(let ne=0;ne<V;ne++)Z.push(a(H));return Z}case c.Object:return JSON.parse(H.read(g(H)).toString());case c.Int:return g(H)}}e.deserialize=a;class m{constructor(F,V,Z=null,ne=1e3){this.h=F,this.j=V,this.k=Z,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(F,V){this.b.set(F,V),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const V=this.o([F.type]);this.k?.logOutgoing(V,0,1,r(F.type));return}case 201:case 202:case 204:case 203:{const V=this.o([F.type,F.id],F.data);this.k?.logOutgoing(V,F.id,1,r(F.type),F.data);return}}}o(F,V=void 0){const Z=new t;return l(Z,F),l(Z,V),this.p(Z.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const V=new C(F),Z=a(V),ne=a(V),se=Z[0];switch(se){case 100:return this.k?.logIncoming(F.byteLength,Z[1],1,`${I(se)}: ${Z[2]}.${Z[3]}`,ne),this.s({type:se,id:Z[1],channelName:Z[2],name:Z[3],arg:ne});case 102:return this.k?.logIncoming(F.byteLength,Z[1],1,`${I(se)}: ${Z[2]}.${Z[3]}`,ne),this.t({type:se,id:Z[1],channelName:Z[2],name:Z[3],arg:ne});case 101:return this.k?.logIncoming(F.byteLength,Z[1],1,`${I(se)}`),this.u({type:se,id:Z[1]});case 103:return this.k?.logIncoming(F.byteLength,Z[1],1,`${I(se)}`),this.u({type:se,id:Z[1]})}}s(F){const V=this.b.get(F.channelName);if(!V){this.v(F);return}const Z=new A.CancellationTokenSource;let ne;try{ne=V.call(this.j,F.name,F.arg,Z.token)}catch(v){ne=Promise.reject(v)}const se=F.id;ne.then(v=>{this.m({id:se,data:v,type:201}),this.d.delete(F.id)},v=>{v instanceof Error?this.m({id:se,data:{message:v.message,name:v.name,stack:v.stack?v.stack.split?v.stack.split(`
`):v.stack:void 0},type:202}):this.m({id:se,data:v,type:203}),this.d.delete(F.id)});const U=(0,u.toDisposable)(()=>Z.cancel());this.d.set(F.id,U)}t(F){const V=this.b.get(F.channelName);if(!V){this.v(F);return}const Z=F.id,se=V.listen(this.j,F.name,F.arg)(U=>this.m({id:Z,data:U,type:204}));this.d.set(F.id,se)}u(F){const V=this.d.get(F.id);V&&(V.dispose(),this.d.delete(F.id))}v(F){let V=this.g.get(F.channelName);V||(V=[],this.g.set(F.channelName,V));const Z=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:F,timeoutTimer:Z})}w(F){const V=this.g.get(F);if(V){for(const Z of V)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=m;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(F,V=null){this.l=F,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=V}getChannel(F){const V=this;return{call(Z,ne,se){return V.a?Promise.reject(new k.CancellationError):V.m(F,Z,ne,se)},listen(Z,ne){return V.a?f.Event.None:V.o(F,Z,ne)}}}m(F,V,Z,ne=A.CancellationToken.None){const se=this.g++,v={id:se,type:100,channelName:F,name:V,arg:Z};if(ne.isCancellationRequested)return Promise.reject(new k.CancellationError);let O;return new Promise((N,G)=>{if(ne.isCancellationRequested)return G(new k.CancellationError);const j=()=>{const he=ve=>{switch(ve.type){case 201:this.f.delete(se),N(ve.data);break;case 202:{this.f.delete(se);const Se=new Error(ve.data.message);Se.stack=Array.isArray(ve.data.stack)?ve.data.stack.join(`
`):ve.data.stack,Se.name=ve.data.name,G(Se);break}case 203:this.f.delete(se),G(ve.data);break}};this.f.set(se,he),this.p(v)};let B=null;this.b===h.Idle?j():(B=(0,L.createCancelablePromise)(he=>this.u()),B.then(()=>{B=null,j()}));const K=()=>{B?(B.cancel(),B=null):this.p({id:se,type:101}),G(new k.CancellationError)},re=ne.onCancellationRequested(K);O=(0,u.combinedDisposable)((0,u.toDisposable)(K),re),this.d.add(O)}).finally(()=>{this.d.delete(O)})}o(F,V,Z){const ne=this.g++,U={id:ne,type:102,channelName:F,name:V,arg:Z};let v=null;const O=new f.Emitter({onWillAddFirstListener:()=>{v=(0,L.createCancelablePromise)(N=>this.u()),v.then(()=>{v=null,this.d.add(O),this.p(U)})},onDidRemoveLastListener:()=>{v?(v.cancel(),v=null):(this.d.delete(O),this.p({id:ne,type:103}))}}),W=N=>O.fire(N.data);return this.f.set(ne,W),O.event}p(F){switch(F.type){case 100:case 102:{const V=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(V,F.id,0,`${I(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const V=this.q([F.type,F.id]);this.j?.logOutgoing(V,F.id,0,I(F.type));return}}}q(F,V=void 0){const Z=new t;return l(Z,F),l(Z,V),this.r(Z.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const V=new C(F),Z=a(V),ne=a(V),se=Z[0];switch(se){case 200:return this.j?.logIncoming(F.byteLength,0,0,r(se)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,Z[1],0,r(se),ne),this.t({type:Z[0],id:Z[1],data:ne})}}t(F){if(F.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}ye([R.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const F=[];return this.f.forEach(V=>F.push(V)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:V,onDidClientDisconnect:Z})=>{f.Event.once(V.onMessage)(se=>{const U=new C(se),v=a(U),O=new m(V,v),W=new M(V);this.a.forEach((G,j)=>O.registerChannel(j,G));const N={channelServer:O,channelClient:W,ctx:v};this.f.add(N),this.g.fire(N),Z(()=>{O.dispose(),W.dispose(),this.f.delete(N),this.h.fire(N)})})})}getChannel(F,V){const Z=this;return{call(ne,se,U){let v;if((0,S.isFunction)(V)){const W=(0,P.getRandomElement)(Z.connections.filter(V));v=W?Promise.resolve(W):f.Event.toPromise(f.Event.filter(Z.onDidAddConnection,V))}else v=V.routeCall(Z,ne,se);const O=v.then(W=>W.channelClient.getChannel(F));return z(O).call(ne,se,U)},listen(ne,se){if((0,S.isFunction)(V))return Z.j(F,V,ne,se);const U=V.routeEvent(Z,ne,se).then(v=>v.channelClient.getChannel(F));return z(U).listen(ne,se)}}}j(F,V,Z,ne){const se=this;let U=new u.DisposableStore;const v=new f.Emitter({onWillAddFirstListener:()=>{U=new u.DisposableStore;const O=new f.EventMultiplexer,W=new Map,N=j=>{const K=j.channelClient.getChannel(F).listen(Z,ne),re=O.add(K);W.set(j,re)},G=j=>{const B=W.get(j);!B||(B.dispose(),W.delete(j))};se.connections.filter(V).forEach(N),f.Event.filter(se.onDidAddConnection,V)(N,void 0,U),se.onDidRemoveConnection(G,void 0,U),O.event(v.fire,v,U),U.add(O)},onDidRemoveLastListener:()=>{U.dispose()}});return v.event}registerChannel(F,V){this.a.set(F,V),this.f.forEach(Z=>{Z.channelServer.registerChannel(F,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class ${constructor(F,V,Z=null){const ne=new t;l(ne,V),F.send(ne.buffer),this.a=new M(F,Z),this.d=new m(F,V,Z)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,V){this.d.registerChannel(F,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=$;function z(H){return{call(F,V,Z){return H.then(ne=>ne.call(F,V,Z))},listen(F,V){const Z=new f.Relay;return H.then(ne=>Z.input=ne.listen(F,V)),Z.event}}}e.getDelayedChannel=z;function q(H){let F=!1;return{call(V,Z,ne){return F?H.call(V,Z,ne):(0,L.timeout)(0).then(()=>F=!0).then(()=>H.call(V,Z,ne))},listen(V,Z){if(F)return H.listen(V,Z);const ne=new f.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>ne.input=H.listen(V,Z)),ne.event}}}e.getNextTickChannel=q;class ie{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const V of F.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await f.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=ie;var oe;(function(H){function F(se,U){const v=se,O=U&&U.disableMarshalling,W=new Map;for(const N in v)Z(N)&&W.set(N,f.Event.buffer(v[N],!0));return new class{listen(N,G,j){const B=W.get(G);if(B)return B;if(ne(G)){const K=v[G];if(typeof K=="function")return K.call(v,j)}throw new Error(`Event not found: ${G}`)}call(N,G,j){const B=v[G];if(typeof B=="function"){if(!O&&Array.isArray(j))for(let K=0;K<j.length;K++)j[K]=(0,w.revive)(j[K]);return B.apply(v,j)}throw new Error(`Method not found: ${G}`)}}}H.fromService=F;function V(se,U){const v=U&&U.disableMarshalling;return new Proxy({},{get(O,W){if(typeof W=="string")return U?.properties?.has(W)?U.properties.get(W):ne(W)?function(N){return se.listen(W,N)}:Z(W)?se.listen(W):async function(...N){let G;U&&!(0,S.isUndefinedOrNull)(U.context)?G=[U.context,...N]:G=N;const j=await se.call(W,G);return v?j:(0,w.revive)(j)};throw new Error(`Property not found: ${String(W)}`)}})}H.toService=V;function Z(se){return se[0]==="o"&&se[1]==="n"&&y.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&y.isUpperAsciiLetter(se.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const F=H.toString();if(F!=="[object Object]")return F}return H}function ce(H){return Array.isArray(H)?H.map(de):de(H)}function J(H,F,V,Z,ne,se,U){U=ce(U);const v=ae[ne],O=v[Z%v.length];let W=[`%c[${H}]%c[${String(F).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(se)?(W=W.concat(U),W.push(")")):W.push(U),console.log.apply(console,W)}class Y{constructor(F,V){this.d=F,this.f=V,this.a=0,this.b=0}logOutgoing(F,V,Z,ne,se){this.b+=F,J(this.d,this.b,F,V,Z,ne,se)}logIncoming(F,V,Z,ne,se){this.a+=F,J(this.f,this.a,F,V,Z,ne,se)}}e.IPCLogger=Y}),define(ee[154],te([0,1,17,3,47]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(f){this.a=f,this.onMessage=L.Event.fromDOMEventEmitter(this.a,"message",u=>P.VSBuffer.wrap(u.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class R extends s.IPCClient{constructor(f,u){const w=new A(f);super(w,u),this.b=w}dispose(){this.b.disconnect()}}e.Client=R}),define(ee[105],te([0,1,7,17,3,2,47]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var f;(function(M){M.enableDiagnostics=!1,M.records=[];const T=new WeakMap;let $=0;function z(ie,oe){if(!T.has(ie)){const ae=String(++$);T.set(ie,ae)}return T.get(ie)}function q(ie,oe,ae,de){if(!M.enableDiagnostics)return;const ce=z(ie,oe);if(de instanceof L.VSBuffer||de instanceof Uint8Array||de instanceof ArrayBuffer||ArrayBuffer.isView(de)){const J=L.VSBuffer.alloc(de.byteLength);J.set(de),M.records.push({timestamp:Date.now(),id:ce,label:oe,type:ae,buff:J})}else M.records.push({timestamp:Date.now(),id:ce,label:oe,type:ae,data:de})}M.traceSocketEvent=q})(f=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function y(){return w||(w=L.VSBuffer.alloc(0)),w}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,$){if(T===0)return y();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const oe=this.a[0];return $&&(this.a.shift(),this.b-=T),oe}if(this.a[0].byteLength>T){const oe=this.a[0].slice(0,T);return $&&(this.a[0]=this.a[0].slice(T),this.b-=T),oe}const z=L.VSBuffer.alloc(T);let q=0,ie=0;for(;T>0;){const oe=this.a[ie];if(oe.byteLength>T){const ae=oe.slice(0,T);z.set(ae,q),q+=T,$&&(this.a[ie]=oe.slice(T),this.b-=T),T-=T}else z.set(oe,q),q+=oe.byteLength,$?(this.a.shift(),this.b-=oe.byteLength):ie++,T-=oe.byteLength}return z}}e.ChunkStream=S;var d;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function I(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class r{constructor(T,$,z,q){this.type=T,this.id=$,this.ack=z,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends A.Disposable{constructor(T){super(),this.f=this.D(new s.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new S,this.D(this.a.onData($=>this.acceptChunk($))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const $=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=$.readUInt32BE(9),this.g.messageType=$.readUInt8(0),this.g.id=$.readUInt32BE(1),this.g.ack=$.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:I(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const z=this.g.messageType,q=this.g.id,ie=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",$),this.f.fire(new r(z,q,ie,$)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const $=L.VSBuffer.alloc(13);$.writeUInt8(T.type,0),$.writeUInt32BE(T.id,1),$.writeUInt32BE(T.ack,5),$.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:I(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j($,T.data)}g(T,$){const z=this.f===0;return this.d.push(T,$),this.f+=T.byteLength+$.byteLength,z}h(){const T=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,$){this.g(T,$)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class E extends A.Disposable{constructor(T){super(),this.f=new s.Emitter,this.onMessage=this.f.event,this.g=new s.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.D(new g(this.a)),this.c=this.D(new h(this.a)),this.D(this.c.onMessage($=>{$.type===1&&this.f.fire($.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new r(1,0,0,T))}}e.Protocol=E;class p extends R.IPCClient{static fromSocket(T,$){return new p(new E(T),$)}get onDidDispose(){return this.b.onDidDispose}constructor(T,$,z=null){super(T,$,z),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=p;class C{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new s.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=C;class t{constructor(T){this.data=T,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let T=0,$=this.a;for(;$;)$=$.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let $=0,z=this.a;for(;z;)T[$++]=z.data,z=z.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const $=new t(T);if(!this.a){this.a=$,this.b=$;return}this.b.next=$,this.b=$}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let $=0;$<i.a;$++)this.c[$]=T-1e3*$;setInterval(()=>{for(let $=i.a;$>=1;$--)this.c[$]=this.c[$-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),$=(1+i.a)*1e3;let z=0;for(let q=0;q<i.a;q++)T-this.c[q]<=$&&z++;return 1-z/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function o(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class l{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=l;class a{constructor(T,$){this.roundTripTime=T,this.recentHighRoundTripCount=$}}e.HighRoundTripTimeEvent=a;class m{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new C,this.onControlMessage=this.x.event,this.y=new C,this.onMessage=this.y.event,this.z=new C,this.onDidDispose=this.z.event,this.A=new C,this.onSocketClose=this.A.event,this.B=new C,this.onSocketTimeout=this.B.event,this.C=new C,this.onHighRoundTripTime=this.C.event,this.D=new C,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=T.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new r(5,0,0,y());this.p.write(T),this.p.flush()}sendPause(){const T=new r(7,0,0,y());this.p.write(T)}sendResume(){const T=new r(8,0,0,y());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,$){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.q.acceptChunk($)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new r(3,0,this.h,y());this.p.write(T);const $=this.b.toArray();for(let z=0,q=$.length;z<q;z++)this.p.write($[z]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const $=this.b.peek();if($&&$.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const $=Date.now();$-this.m>1e4&&(this.m=$,this.p.write(new r(6,0,0,y())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const $=this.b.toArray();for(let z=0,q=$.length;z<q;z++)this.p.write($[z]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const $=++this.c;this.h=this.g;const z=new r(1,$,this.h,T);this.b.push(z),this.a||(this.p.write(z),this.G())}sendControl(T){const $=new r(2,0,0,T);this.p.write($)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),$=Date.now()-T.writtenTime,z=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if($>=2e4&&z>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:$,timeSinceLastReceivedSomeData:z});return}const ie=Math.max(2e4-$,2e4-z,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},ie)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new r(3,0,this.h,y());this.p.write(T)}I(){this.h=this.g;const T=new r(9,0,this.h,y());this.p.write(T)}J(T){this.h=this.g;const $=new r(10,0,this.h,T);this.p.write($)}K(T){this.h=this.g;const $=new r(11,0,this.h,T);this.p.write($)}}e.PersistentProtocol=m;class D extends A.Disposable{constructor(){super(),this.a=this.D(new s.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new s.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new s.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new P.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,$=L.VSBuffer.alloc(4);$.writeUInt32BE(T,0),this.a.fire($)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const $=T.readUInt32BE(0);if(this.g<=0||$!==this.h)return;const z=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=z;const ie=this.l,oe=this.j.filter(ae=>ae>=1e3).length;this.l=oe>=3?1:0,z>1e3&&this.b.fire(new a(z,oe)),ie!==this.l&&this.c.fire(this.l)}}}),define(ee[155],te([0,1,42,17,3,2,47,140]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(w,y){const S=s.Event.fromNodeEventEmitter(P.validatedIpcMain,y,(I,b)=>({event:I,message:b})),d=s.Event.filter(S,({event:I})=>I.sender.id===w);return s.Event.map(d,({message:I})=>I&&L.VSBuffer.wrap(I))}class u extends R.IPCServer{static d(){const y=s.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:hello",({sender:S})=>S);return s.Event.map(y,S=>{const d=S.id;u.b.get(d)?.dispose();const b=new s.Emitter;u.b.set(d,(0,A.toDisposable)(()=>b.fire()));const r=f(d,"vscode:message"),h=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),b.event);return{protocol:new k.Protocol(S,r),onDidClientDisconnect:h}})}constructor(){super(u.d())}}u.b=new Map,e.Server=u}),define(ee[106],te([0,1,42,3,31,154]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends A.Client{constructor(u,w){super({addEventListener:(y,S)=>u.addListener(y,S),removeEventListener:(y,S)=>u.removeListener(y,S),postMessage:y=>u.postMessage(y),start:()=>u.start(),close:()=>u.close()},w)}}e.Client=R;async function k(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,s.generateUuid)();f.webContents.send("vscode:createMessageChannel",u);const w=L.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:createMessageChannelResult",(S,d)=>({nonce:d,port:S.ports[0]})),{port:y}=await L.Event.toPromise(L.Event.once(L.Event.filter(w,S=>S.nonce===u)));return y}e.connect=k}),define(ee[156],te([0,1,46,7,17,22,149,13,3,2,37,87,73,47]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class I extends d.ChannelServer{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",g=>s.VSBuffer.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=I;class b{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const E=g&&g.timeout?g.timeout:6e4;this.b=new L.Delayer(E),this.d=null,this.f=null}getChannel(h){const g=this;return{call(E,p,C){return g.k(h,E,p,C)},listen(E,p){return g.l(h,E,p)}}}k(h,g,E,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const C=this.n(h),t=(0,L.createCancelablePromise)(n=>C.call(g,E,n)),c=p.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{c.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,g,E){if(!this.b)return f.Event.None;this.b.cancel();let p;const C=new f.Emitter({onWillAddFirstListener:()=>{p=this.n(h).listen(g,E)(C.fire,C),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(g.env),this.d=(0,P.fork)(this.i,h,g);const E=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,R.isRemoteConsoleLog)(o)){(0,R.log)(o,`IPC Library: ${this.j.serverName}`);return}E.fire(s.VSBuffer.wrap(Buffer.from(o,"base64")))});const C=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&C.send(o.buffer.toString("base64")),c=E.event,i={send:t,onMessage:c};this.f=new d.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,u.dispose)(a)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(ee[88],te([0,1,17,13,3,2,9,4,31,47,105]),function(x,e,P,L,s,A,R,k,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class S{traceSocketEvent(a,m){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,m)}constructor(a,m=""){this.f=!0,this.debugLabel=m,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,L.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const m=D=>{this.traceSocketEvent("read",D),a(P.VSBuffer.wrap(D))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(a){const m=D=>{a({type:0,hadError:D,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(a){const m=()=>{a()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,L.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,L.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=S;var d;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize",l[l.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var I;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(I||(I={}));class b extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,m){this.socket.traceSocketEvent(a,m)}constructor(a,m,D,M){super(),this.f=this.D(new s.Emitter),this.g=this.D(new s.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:D?.byteLength||0,recordInflateBytes:M}),this.a=this.D(new r(this,m,D,M,this.f,(T,$)=>this.k(T,$))),this.D(this.a.onError(T=>{console.error(T),(0,L.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new w.ChunkStream,this.D(this.socket.onData(T=>this.l(T))),this.D(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await s.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let m=0;for(;m<a.byteLength;)this.a.writeMessage(a.slice(m,Math.min(m+262144,a.byteLength))),m+=262144}k(a,m){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let D=2;a.byteLength<126?D+=0:a.byteLength<2**16?D+=2:D+=8;const M=P.VSBuffer.alloc(D);if(m?M.writeUInt8(194,0):M.writeUInt8(130,0),a.byteLength<126)M.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){M.writeUInt8(126,1);let T=1;M.writeUInt8(a.byteLength>>>8&255,++T),M.writeUInt8(a.byteLength>>>0&255,++T)}else{M.writeUInt8(127,1);let T=1;M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(a.byteLength>>>24&255,++T),M.writeUInt8(a.byteLength>>>16&255,++T),M.writeUInt8(a.byteLength>>>8&255,++T),M.writeUInt8(a.byteLength>>>0&255,++T)}this.socket.write(P.VSBuffer.concat([M,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),D=m.readUInt8(0),M=(D&128)>>>7,T=(D&64)>>>6,$=m.readUInt8(1),z=($&128)>>>7,q=$&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(M),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),D=m.readUInt8(1),M=(D&128)>>>7;let T=D&127,$=1;T===126?T=m.readUInt8(++$)*2**8+m.readUInt8(++$):T===127&&(T=m.readUInt8(++$)*0+m.readUInt8(++$)*0+m.readUInt8(++$)*0+m.readUInt8(++$)*0+m.readUInt8(++$)*2**24+m.readUInt8(++$)*2**16+m.readUInt8(++$)*2**8+m.readUInt8(++$));let z=0;M&&(z=m.readUInt8(++$)*2**24+m.readUInt8(++$)*2**16+m.readUInt8(++$)*2**8+m.readUInt8(++$)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),E(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(m,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await s.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class r extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.VSBuffer.alloc(0)}constructor(a,m,D,M,T,$){super(),this.l=a,this.m=T,this.n=$,this.a=this.D(new s.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new s.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new s.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,m?(this.b=this.D(new h(this.l,M,D,{windowBits:15})),this.f=this.D(new g(this.l,{windowBits:15})),this.D(this.b.onError(z=>this.a.fire(z))),this.D(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const m=await this.r(this.f,a);this.n(m,!0)}else this.n(a,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(a,m){return new Promise((D,M)=>{a.write(m),a.flush(T=>D(T))})}acceptFrame(a,m,D){this.h.push({data:a,isCompressed:m,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const m=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.m.fire(m)}else this.m.fire(a.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(a,m,D){return new Promise((M,T)=>{a.write(m),D&&a.write(P.VSBuffer.fromByteArray([0,0,255,255])),a.flush($=>M($))})}}class h extends A.Disposable{get recordedInflateBytes(){return this.j?P.VSBuffer.concat(this.f):P.VSBuffer.alloc(0)}constructor(a,m,D,M){super(),this.h=a,this.j=m,this.a=this.D(new s.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=y().zlib.createInflateRaw(M),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(P.VSBuffer.wrap(T))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=P.VSBuffer.concat(this.g);this.g.length=0,a(m)})}}class g extends A.Disposable{constructor(a,m){super(),this.g=a,this.a=this.D(new s.Emitter),this.onError=this.a.event,this.f=[],this.b=y().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(P.VSBuffer.wrap(D))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=P.VSBuffer.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),a(m)})}}function E(l,a){if(a===0)return;const m=l.byteLength>>>2;for(let q=0;q<m;q++){const ie=l.readUInt32BE(q*4);l.writeUInt32BE(ie^a,q*4)}const D=m*4,M=l.byteLength-D,T=a>>>24&255,$=a>>>16&255,z=a>>>8&255;M>=1&&l.writeUInt8(l.readUInt8(D)^T,D),M>=2&&l.writeUInt8(l.readUInt8(D+1)^$,D+1),M>=3&&l.writeUInt8(l.readUInt8(D+2)^z,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const p={[2]:107,[1]:103};function C(){const l=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;const a=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:y().os.tmpdir(),m=(0,R.join)(a,`vscode-ipc-${l}.sock`);return c(m),m}e.createRandomIPCHandle=C;function t(l,a,m){const D=y().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${m}-${a}-sock`;const M=m.substr(0,4),T=a.substr(0,6),$=D.substr(0,8);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${$}-${M}-${T}.sock`):z=(0,R.join)(l,`${M}-${T}.sock`),c(z),z}e.createStaticIPCHandle=t;function c(l){const a=p[k.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends u.IPCServer{static b(a){const m=s.Event.fromNodeEventEmitter(a,"connection");return s.Event.map(m,D=>({protocol:new w.Protocol(new S(D,"ipc-server-connection")),onDidClientDisconnect:s.Event.once(s.Event.fromNodeEventEmitter(D,"close"))}))}constructor(a){super(i.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(l){return new Promise((a,m)=>{const D=y().net.createServer();D.on("error",m),D.listen(l,()=>{D.removeListener("error",m),a(new i(D))})})}e.serve=n;function o(l,a){return new Promise((m,D)=>{const M=y().net.createConnection(l,()=>{M.removeListener("error",D),m(w.Client.fromSocket(new S(M,`ipc-client${a}`),a))});M.once("error",D)})}e.connect=o}),define(ee[107],te([0,1,7,3,2,11]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R=e.StorageHint||(e.StorageHint={}));function k(y){const S=y;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var f;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class u extends s.Disposable{constructor(S,d=Object.create(null)){super(),this.m=S,this.n=d,this.b=this.D(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new P.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(S=>this.q(S)))}q(S){S.changed?.forEach((d,I)=>this.r(I,d)),S.deleted?.forEach(d=>this.r(d,void 0))}r(S,d){if(this.c===f.Closed)return;let I=!1;(0,A.isUndefinedOrNull)(d)?I=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),I=!0),I&&this.b.fire(S)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(S,d){const I=this.f.get(S);return(0,A.isUndefinedOrNull)(I)?d:I}getBoolean(S,d){const I=this.get(S);return(0,A.isUndefinedOrNull)(I)?d:I==="true"}getNumber(S,d){const I=this.get(S);return(0,A.isUndefinedOrNull)(I)?d:parseInt(I,10)}async set(S,d){if(this.c===f.Closed)return;if((0,A.isUndefinedOrNull)(d))return this.delete(S);const I=String(d);if(this.f.get(S)!==I)return this.f.set(S,I),this.j.set(S,I),this.h.delete(S),this.b.fire(S),this.v()}async delete(S){if(!(this.c===f.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire(S),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=f.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(S).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(S){if(!!this.t)return this.v(S)}async v(S){return this.g.trigger(()=>this.u(),S)}async whenFlushed(){if(!!this.t)return new Promise(S=>this.l.push(S))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}u.a=100,e.Storage=u;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,I)=>this.a.set(I,d)),S.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=w}),define(ee[157],te([0,1,7,3,35,9,23]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return L.Event.None}constructor(w,y=Object.create(null)){this.g=w,this.h=y,this.c=(0,A.basename)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const w=await this.f,y=new Map;return(await this.s(w,"SELECT * FROM ItemTable")).forEach(d=>y.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(w){const y=await this.f;return this.j(y,w)}j(w,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,s.mapToString)(y.insert):"0"}), delete(${y.delete?(0,s.setToString)(y.delete):"0"})`),this.t(w,()=>{const S=y.insert,d=y.delete;if(S&&S.size>0){const I=[];I.push([]);let b=0;S.forEach((r,h)=>{let g=I[b];g.length>k.b&&(b++,g=[],I.push(g)),g.push(h,r)}),I.forEach(r=>{this.u(w,`INSERT INTO ItemTable VALUES ${new Array(r.length/2).fill("(?,?)").join(",")}`,h=>h.run(r),()=>{const h=[];let g=0;return S.forEach((E,p)=>{h.push(p),g+=E.length}),`Keys: ${h.join(", ")} Length: ${g}`})})}if(d&&d.size){const I=[];I.push([]);let b=0;d.forEach(r=>{let h=I[b];h.length>k.b&&(b++,h=[],I.push(h)),h.push(r)}),I.forEach(r=>{this.u(w,`DELETE FROM ItemTable WHERE key IN (${new Array(r.length).fill("?").join(",")})`,h=>h.run(r),()=>{const h=[];return d.forEach(g=>{h.push(g)}),`Keys: ${h.join(", ")}`})})}})}async close(w){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,w)}k(w,y){return new Promise((S,d)=>{w.db.close(I=>(I&&this.o(w,`[storage ${this.c}] close(): ${I}`),this.g===k.IN_MEMORY_PATH?S():!w.isErroneous&&!w.isInMemory?this.l().then(S,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),S())):typeof y=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const r=()=>this.k(b,void 0);return this.j(b,{insert:y()}).then(()=>r(),h=>(r(),Promise.reject(h)))})).then(S,d):d(I||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const w=this.m(this.g);return R.Promises.copy(this.g,w,{preserveSymlinks:!1})}m(w){return`${w}.backup`}async checkIntegrity(w){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${w})`);const y=await this.f,S=await this.r(y,w?"PRAGMA integrity_check":"PRAGMA quick_check"),d=w?S.integrity_check:S.quick_check;return y.isErroneous?`${d} (last error: ${y.lastError})`:y.isInMemory?`${d} (in-memory!)`:d}async n(w,y=!0){this.d.trace(`[storage ${this.c}] open(${w}, retryOnBusy: ${y})`);try{return await this.p(w)}catch(S){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&y)return await(0,P.timeout)(k.a),this.n(w,!1);try{await R.Promises.unlink(w);try{await R.Promises.rename(this.m(w),w)}catch{}return await this.p(w)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(k.IN_MEMORY_PATH)}}}o(w,y){w.isErroneous=!0,w.lastError=y,this.d.error(y)}p(w){return new Promise((y,S)=>{new Promise((d,I)=>{x(["@vscode/sqlite3"],d,I)}).then(d=>{const I={db:new(this.d.isTracing?d.verbose().Database:d.Database)(w,b=>b?I.db&&b.code!=="SQLITE_CANTOPEN"?I.db.close(()=>S(b)):S(b):this.q(I,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(I),r=>I.db.close(()=>S(r)))),isInMemory:w===k.IN_MEMORY_PATH};I.db.on("error",b=>this.o(I,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&I.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},S)})}q(w,y){return new Promise((S,d)=>{w.db.exec(y,I=>I?(this.o(w,`[storage ${this.c}] exec(): ${I}`),d(I)):S())})}r(w,y){return new Promise((S,d)=>{w.db.get(y,(I,b)=>I?(this.o(w,`[storage ${this.c}] get(): ${I}`),d(I)):S(b))})}s(w,y){return new Promise((S,d)=>{w.db.all(y,(I,b)=>I?(this.o(w,`[storage ${this.c}] all(): ${I}`),d(I)):S(b))})}t(w,y){return new Promise((S,d)=>{w.db.serialize(()=>{w.db.run("BEGIN TRANSACTION"),y(),w.db.run("END TRANSACTION",I=>I?(this.o(w,`[storage ${this.c}] transaction(): ${I}`),d(I)):S())})})}u(w,y,S,d){const I=w.db.prepare(y),b=r=>{this.o(w,`[storage ${this.c}] prepare(): ${r} (${y}). Details: ${d()}`)};I.on("error",b),S(I),I.finalize(r=>{r&&b(r),I.removeListener("error",b)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class f{constructor(w){w&&typeof w.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=w.logTrace),w&&typeof w.logError=="function"&&(this.b=w.logError)}get isTracing(){return!!this.a}trace(w){this.a?.(w)}error(w){this.b?.(w)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[158],te([12,10]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(ee[159],te([12,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[160],te([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[161],te([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(ee[162],te([12,10]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[163],te([12,10]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[164],te([12,10]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(ee[165],te([12,10]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(ee[166],te([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[167],te([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[168],te([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[169],te([12,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[170],te([12,10]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[171],te([12,10]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(ee[172],te([12,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(ee[173],te([12,10]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(ee[174],te([12,10]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[175],te([12,10]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[176],te([12,10]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[177],te([12,10]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[178],te([12,10]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[179],te([12,10]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(ee[180],te([12,10]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(ee[181],te([12,10]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[182],te([12,10]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[183],te([12,10]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[184],te([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[185],te([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[186],te([12,10]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(ee[187],te([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[188],te([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[189],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.isFolderBackupInfo=P;function L(s){return s&&s.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[190],te([0,1,8]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function s(R){let k=[];try{Array.isArray(R.workspaces)&&(k=R.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=s;function A(R){let k=[];try{Array.isArray(R.folders)&&(k=R.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=A}),define(ee[191],te([0,1,13,161]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var s;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(s=e.TokenType||(e.TokenType={}));function A(...u){switch(u.length){case 1:return(0,L.localize)(0,null,u[0]);case 2:return(0,L.localize)(1,null,u[0],u[1]);case 3:return(0,L.localize)(2,null,u[0],u[1],u[2]);default:return}}const R=(0,L.localize)(3,null),k=(0,L.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,P.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const y=this.d,S=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:S};this.g.push({offset:y,lexeme:S,additionalInfo:w}),this.f.push(d)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const y=this.c.substring(this.d,this.e),S=f.b.get(y);S?this.k(S):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,y=!1,S=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(k);return}const I=this.c.charCodeAt(w);if(y)y=!1;else if(I===47&&!S){w++;break}else I===91?S=!0:I===92?y=!0:I===93&&(S=!1);w++}for(;w<this.c.length&&f.a.has(this.c.charCodeAt(w));)w++;this.e=w;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}f.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0))),f.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=f}),define(ee[192],te([0,1,3,2]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class s{constructor(){this.a=new P.Emitter,this.b=new P.Emitter,this.c=new P.Emitter,this.d=new P.Emitter}call(k,f,u){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(k,f,u){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}s.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=s;class A extends L.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,f,u){this.b.call("attach",[k,f,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,f){this.b.call("terminate",[k,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,f){return this.b.call("openExtensionDevelopmentHostWindow",[k,f])}}e.ExtensionHostDebugChannelClient=A}),define(ee[193],te([0,1,143,55,15,9,36,18,8]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,A.dirname)(s.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(f.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=R.env.VSCODE_PORTABLE;return d?f.URI.file((0,A.join)(d,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(s.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,A.resolve)(d)):f.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const I=R.env.VSCODE_EXTENSIONS;if(I)return I;const b=R.env.VSCODE_PORTABLE;return b?(0,A.join)(b,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(I=>/^[^:/?#]+?:\/\//.test(I)?f.URI.parse(I):f.URI.file((0,A.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const I of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(I);b&&b[1]&&b[2]&&d.push([b[1],b[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=R.env.VSCODE_PORTABLE;return d?f.URI.file((0,A.join)(d,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,I,b){this.a=d,this.b=I,this.c=b,this.editSessionId=this.args.editSessionId}}ye([L.memoize],u.prototype,"appRoot",null),ye([L.memoize],u.prototype,"userHome",null),ye([L.memoize],u.prototype,"userDataPath",null),ye([L.memoize],u.prototype,"appSettingsHome",null),ye([L.memoize],u.prototype,"tmpDir",null),ye([L.memoize],u.prototype,"cacheHome",null),ye([L.memoize],u.prototype,"stateResource",null),ye([L.memoize],u.prototype,"userRoamingDataHome",null),ye([L.memoize],u.prototype,"userDataSyncHome",null),ye([L.memoize],u.prototype,"sync",null),ye([L.memoize],u.prototype,"machineSettingsResource",null),ye([L.memoize],u.prototype,"workspaceStorageHome",null),ye([L.memoize],u.prototype,"localHistoryHome",null),ye([L.memoize],u.prototype,"keyboardLayoutResource",null),ye([L.memoize],u.prototype,"argvResource",null),ye([L.memoize],u.prototype,"isExtensionDevelopment",null),ye([L.memoize],u.prototype,"untitledWorkspacesHome",null),ye([L.memoize],u.prototype,"installSourcePath",null),ye([L.memoize],u.prototype,"builtinExtensionsPath",null),ye([L.memoize],u.prototype,"extensionsPath",null),ye([L.memoize],u.prototype,"extensionDevelopmentLocationURI",null),ye([L.memoize],u.prototype,"extensionDevelopmentKind",null),ye([L.memoize],u.prototype,"extensionTestsLocationURI",null),ye([L.memoize],u.prototype,"debugExtensionHost",null),ye([L.memoize],u.prototype,"logLevel",null),ye([L.memoize],u.prototype,"extensionLogLevel",null),ye([L.memoize],u.prototype,"serviceMachineIdResource",null),ye([L.memoize],u.prototype,"disableTelemetry",null),ye([L.memoize],u.prototype,"disableWorkspaceTrust",null),ye([L.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function w(S,d){return y(S["inspect-extensions"],S["inspect-brk-extensions"],5870,d,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=w;function y(S,d,I,b,r,h){const E=Number(d||S)||(b?null:I),p=E?Boolean(!!d):!1;let C;if(h)try{C=JSON.parse(h)}catch{}return{port:E,break:p,debugId:r,env:C}}e.parseDebugParams=y}),define(ee[108],te([0,1,291,4,164]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},category:{type:"string",cat:"e",description:(0,s.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,s.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(b,r,h=R){const g=b.find(l=>l.length>0&&l[0]!=="-"),E={},p=["_"],C=[],t={};let c;for(const l in r){const a=r[l];a.type==="subcommand"?l===g&&(c=a):(a.alias&&(E[l]=a.alias),a.type==="string"||a.type==="string[]"?(p.push(l),a.deprecates&&p.push(...a.deprecates)):a.type==="boolean"&&(C.push(l),a.deprecates&&C.push(...a.deprecates)),a.global&&(t[l]=a))}if(c&&g){const l=t;for(const M in c.options)l[M]=c.options[M];const a=b.filter(M=>M!==g),m=h.getSubcommandReporter?h.getSubcommandReporter(g):void 0,D=k(a,l,m);return{[g]:D,_:[]}}const i=P(b,{string:p,boolean:C,alias:E}),n={},o=i;n._=i._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(const l in r){const a=r[l];if(a.type==="subcommand")continue;a.alias&&delete o[a.alias];let m=o[l];if(a.deprecates)for(const D of a.deprecates)o.hasOwnProperty(D)&&(m||(m=o[D],m&&h.onDeprecatedOption(D,a.deprecationMessage||(0,s.localize)(36,null,l))),delete o[D]);if(typeof m<"u"){if(a.type==="string[]"){if(Array.isArray(m)||(m=[m]),!a.allowEmptyValue){const D=m.filter(M=>M.length>0);D.length!==m.length&&(h.onEmptyValue(l),m=D.length>0?D:void 0)}}else a.type==="string"&&(Array.isArray(m)?(m=m.pop(),h.onMultipleValues(l,m)):!m&&!a.allowEmptyValue&&(h.onEmptyValue(l),m=void 0));n[l]=m,a.deprecationMessage&&h.onDeprecatedOption(l,a.deprecationMessage)}delete o[l]}for(const l in o)h.onUnknownOption(l);return n}e.parseArgs=k;function f(b,r){let h="";return r.args&&(Array.isArray(r.args)?h=` <${r.args.join("> <")}>`:h=` <${r.args}>`),r.alias?`-${r.alias} --${b}${h}`:`--${b}${h}`}function u(b,r){const h=[];for(const g in b){const E=b[g],p=f(g,E);h.push([p,E.description])}return w(h,r)}e.formatOptions=u;function w(b,r){const g=b.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(r-g<25)return b.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const E=r-g-1,p=[];for(const C of b){const t=C[0],c=S(C[1],E),i=y(g-t.length-2);p.push("  "+t+i+c[0]);for(let n=1;n<c.length;n++)p.push(y(g)+c[n])}return p}function y(b){return" ".repeat(b)}function S(b,r){const h=[];for(;b.length;){const g=b.length<r?b.length:b.lastIndexOf(" ",r),E=b.slice(0,g).trim();b=b.slice(g),h.push(E)}return h}function d(b,r,h,g,E){const p=process.stdout.isTTY&&process.stdout.columns||80,C=E?.noInputFiles!==!0?`[${(0,s.localize)(37,null)}...]`:"",t=[`${b} ${h}`];t.push(""),t.push(`${(0,s.localize)(38,null)}: ${r} [${(0,s.localize)(39,null)}]${C}`),t.push(""),E?.noPipe!==!0&&(L.isWindows?t.push((0,s.localize)(40,null,r)):t.push((0,s.localize)(41,null,r)),t.push(""));const c={},i=[];for(const n in g){const o=g[n];if(o.type==="subcommand")o.description&&i.push({command:n,description:o.description});else if(o.description&&o.cat){let l=c[o.cat];l||(c[o.cat]=l={}),l[n]=o}}for(const n in c){const o=n,l=c[o];l&&(t.push(A[o]),t.push(...u(l,p)),t.push(""))}return i.length&&(t.push((0,s.localize)(42,null)),t.push(...w(i.map(n=>[n.command,n.description]),p)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function I(b,r){return`${b||(0,s.localize)(43,null)}
${r||(0,s.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=I}),define(ee[194],te([0,1,84,192,108]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,f,u){return f==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(k,f,u)}async g(k,f){const u=(0,s.parseArgs)(k,s.OPTIONS);u.debugRenderer=f;const w=u.extensionDevelopmentPath;if(!w)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(w,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const S=y.win;if(!S)return{success:!0};const d=S.webContents.debugger;let I=d.isAttached()?1/0:0;const b=(0,P.createServer)(r=>{I++===0&&d.attach();let h=!1;const g=C=>{h||r.write(JSON.stringify(C)+"\0")},E=(C,t,c,i)=>g({method:t,params:c,sessionId:i});S.on("close",()=>{d.removeListener("message",E),r.end(),h=!0}),d.addListener("message",E);let p=Buffer.alloc(0);r.on("data",C=>{p=Buffer.concat([p,C]);for(let t=p.indexOf(0);t!==-1;t=p.indexOf(0)){let c;try{const i=p.slice(0,t).toString("utf8");p=p.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}d.sendCommand(c.method,c.params,c.sessionId).then(i=>g({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>g({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),r.on("error",C=>{console.error("error on cdp pipe:",C)}),r.on("close",()=>{h=!0,--I===0&&d.detach()})});return await new Promise(r=>b.listen(0,r)),S.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ee[62],te([0,1,292,165,108]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function R(S,d){const I=(p,C)=>{console.warn((0,L.localize)(0,null,p,C))},b=p=>{console.warn((0,L.localize)(1,null,p))},r=(p,C)=>{console.warn((0,L.localize)(2,null,p,C))},h=p=>({onUnknownOption:C=>{p!=="tunnel"&&console.warn((0,L.localize)(3,null,C,p))},onMultipleValues:I,onEmptyValue:b,onDeprecatedOption:r,getSubcommandReporter:p!=="tunnel"?h:void 0}),g={onUnknownOption:p=>{console.warn((0,L.localize)(4,null,p))},onMultipleValues:I,onEmptyValue:b,onDeprecatedOption:r,getSubcommandReporter:h},E=(0,s.parseArgs)(S,s.OPTIONS,d?g:void 0);return E.goto&&E._.forEach(p=>P(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,L.localize)(5,null))),E["max-memory"]&&P(parseInt(E["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),E}function k(S){const d=S.findIndex(I=>!/^-/.test(I));if(d>-1)return[...S.slice(0,d),...S.slice(d+1)]}function f(S){let[,...d]=S;process.env.VSCODE_DEV&&(d=k(d)||[]);const I=!y(process.env);return R(d,I)}e.parseMainProcessArgv=f;function u(S){let[,,...d]=S;return process.env.VSCODE_DEV&&(d=k(d)||[]),R(d,!0)}e.parseCLIProcessArgv=u;function w(S,...d){const I=S.indexOf("--");return I===-1?S.push(...d):S.splice(I,0,...d),S}e.addArg=w;function y(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function x(e,P,L){function s(R,k){const f=A(R,k),u=[f];return e.isAbsolute(f)||u.unshift(L),e.resolve(...u)}function A(R,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,k);const w=R["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(P.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,k)}return{getUserDataPath:s}}if(typeof define=="function")define(ee[195],te([196,27,36]),function(e,P,L){return x(e,P,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=x(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[109],te([0,1,27,193,195]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(u,w){super(u,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(u,w.nameShort)},w)}}e.NativeEnvironmentService=A;function R(f,u){return(0,L.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.parsePtyHostDebugPort=R;function k(f,u){return(0,L.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(ee[197],te([0,1,41,27,32]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(R){const k=(0,s.randomPath)((0,L.tmpdir)());try{return(0,P.writeFileSync)(k,""),R&&console.log(`Marker file for --wait created: ${k}`),k}catch(f){R&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=A}),define(ee[198],te([0,1,11,167]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function s(R,k,f){try{A(R,k,f)}catch(u){console.error(u?.message??u)}return R}e.localizeManifest=s;function A(R,k,f){const u=(w,y,S)=>{const d=w[y];if((0,P.isString)(d)){const I=d,b=I.length;if(b>1&&I[0]==="%"&&I[b-1]==="%"){const r=I.substr(1,b-2);let h=k[r];h===void 0&&f&&(h=f[r]);const g=typeof h=="string"?h:h?.message,E=f?.[r],p=typeof E=="string"?E:E?.message;if(!g){p||console.warn(`[${R.name}]: ${(0,L.localize)(0,null,r)}`);return}if(S&&(y==="title"||y==="category")&&p&&p!==g){const C={value:g,original:p};w[y]=C}else w[y]=g}}else if((0,P.isObject)(d))for(const I in d)d.hasOwnProperty(I)&&(I==="commands"?u(d,I,!0):u(d,I,S));else if(Array.isArray(d))for(let I=0;I<d.length;I++)u(d,I,S)};for(const w in R)R.hasOwnProperty(w)&&u(R,w)}}),define(ee[199],te([0,1,18,75,169,200]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function f(h){return h=h.trim(),h==="*"||R.test(h)}e.isValidVersionStr=f;function u(h){if(!f(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=u;function w(h){if(!h)return null;const g=h.majorBase,E=h.majorMustEqual,p=h.minorBase;let C=h.minorMustEqual;const t=h.patchBase;let c=h.patchMustEqual;h.hasCaret&&(g===0||(C=!1),c=!1);let i=0;if(h.preRelease){const n=k.exec(h.preRelease);if(n){const[,o,l,a]=n;i=Date.UTC(Number(o),Number(l)-1,Number(a))}}return{majorBase:g,majorMustEqual:E,minorBase:p,minorMustEqual:C,patchBase:t,patchMustEqual:c,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=w;function y(h,g,E){let p;typeof h=="string"?p=w(u(h)):p=h;let C;g instanceof Date?C=g.getTime():typeof g=="string"&&(C=new Date(g).getTime());let t;if(typeof E=="string"?t=w(u(E)):t=E,!p||!t)return!1;const c=p.majorBase,i=p.minorBase,n=p.patchBase;let o=t.majorBase,l=t.minorBase,a=t.patchBase;const m=t.notBefore;let D=t.majorMustEqual,M=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:i>l?!0:i<l||C&&C<m?!1:n>=a:(c===1&&o===0&&(!D||!M||!T)&&(o=1,l=0,a=0,D=!0,M=!1,T=!1),c<o?!1:c>o?!D:i<l?!1:i>l?!M:n<a?!1:n>a?!T:!(C&&C<m))}e.isValidVersion=y;function S(h,g,E,p,C){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([L.default.Error,s.localize(0,null)]),t;if(typeof p.name!="string")return t.push([L.default.Error,s.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([L.default.Error,s.localize(2,null,"version")]),t;if(!p.engines)return t.push([L.default.Error,s.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([L.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!r(p.extensionDependencies))return t.push([L.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!r(p.activationEvents))return t.push([L.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([L.default.Error,s.localize(7,null,"activationEvents","main")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([L.default.Warning,s.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([L.default.Error,s.localize(9,null,"main")]),t;{const n=(0,P.joinPath)(E,p.main);(0,P.isEqualOrParent)(n,E)||t.push([L.default.Warning,s.localize(10,null,n.path,E.path)])}if(typeof p.activationEvents>"u")return t.push([L.default.Error,s.localize(11,null,"activationEvents","main")]),t}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([L.default.Error,s.localize(12,null,"browser")]),t;{const n=(0,P.joinPath)(E,p.browser);(0,P.isEqualOrParent)(n,E)||t.push([L.default.Warning,s.localize(13,null,n.path,E.path)])}if(typeof p.activationEvents>"u")return t.push([L.default.Error,s.localize(14,null,"activationEvents","browser")]),t}if(!A.valid(p.version))return t.push([L.default.Error,s.localize(15,null)]),t;const c=[];if(!d(h,g,p,C,c))for(const n of c)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=S;function d(h,g,E,p,C){return p||typeof E.main>"u"&&typeof E.browser>"u"?!0:b(h,g,E.engines.vscode,C)}e.isValidExtensionVersion=d;function I(h,g,E){return h==="*"||b(g,E,h)}e.isEngineValid=I;function b(h,g,E,p=[]){const C=w(u(E));if(!C)return p.push(s.localize(16,null,E)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return p.push(s.localize(17,null,E)),!1}else if(!C.majorMustEqual)return p.push(s.localize(18,null,E)),!1;return y(h,g,C)?!0:(p.push(s.localize(19,null,h,E)),!1)}function r(h){if(!Array.isArray(h))return!1;for(let g=0,E=h.length;g<E;g++)if(typeof h[g]!="string")return!1;return!0}}),define(ee[201],te([0,1,17,31]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function s(A,R,k){let f=k&&k.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const w=(await R.readFile(A.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(w)?w:null}catch{f=null}if(!f){f=(0,L.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,P.VSBuffer.fromString(f))}catch{}}return k?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=s}),define(ee[76],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(s,A=[],R=!1){this.ctor=s,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=P}),define(ee[202],te([0,1,76]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var s;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(s=e.InstantiationType||(e.InstantiationType={}));function A(k,f,u){f instanceof P.SyncDescriptor||(f=new P.SyncDescriptor(f,[],Boolean(u))),L.push([k,f])}e.registerSingleton=A;function R(){return L}e.getSingletonServiceDescriptors=R}),define(ee[203],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const k=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(R);k.outgoing.set(f.key,f),f.incoming.set(k.key,k)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const k of this.a.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let k=this.a.get(R);return k||(k=new P(R,A),this.a.set(R,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,k]of this.a)A.push(`${R}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const k=new Set([A]),f=this.c(R,k);if(f)return f}}c(A,R){for(const[k,f]of A.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const u=this.c(f,R);if(u)return u;R.delete(k)}}}e.Graph=L}),define(ee[6],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var P;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function k(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=k})(P=e._util||(e._util={})),e.IInstantiationService=s("instantiationService");function L(R,k,f){k[P.DI_TARGET]===k?k[P.DI_DEPENDENCIES].push({id:R,index:f}):(k[P.DI_DEPENDENCIES]=[{id:R,index:f}],k[P.DI_TARGET]=k)}function s(R){if(P.serviceIds.has(R))return P.serviceIds.get(R);const k=function(f,u,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,f,w)};return k.toString=()=>R,P.serviceIds.set(R,k),k}e.createDecorator=s;function A(R){return R}e.refineServiceDecorator=A}),define(ee[63],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,P.createDecorator)("backupMainService")}),define(ee[19],te([0,1,11,8,6]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,s.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=R;var k;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function u(r,h){const g=Object.create(null);for(const E in r)w(g,E,r[E],h);return g}e.toValuesTree=u;function w(r,h,g,E){const p=h.split("."),C=p.pop();let t=r;for(let c=0;c<p.length;c++){const i=p[c];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${p.slice(0,c+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[C]=g}catch{E(`Ignoring ${h} as ${p.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${h} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=w;function y(r,h){const g=h.split(".");S(r,g)}e.removeFromValueTree=y;function S(r,h){const g=h.shift();if(h.length===0){delete r[g];return}if(Object.keys(r).indexOf(g)!==-1){const E=r[g];typeof E=="object"&&!Array.isArray(E)&&(S(E,h),Object.keys(E).length===0&&delete r[g])}}function d(r,h,g){function E(t,c){let i=t;for(const n of c){if(typeof i!="object"||i===null)return;i=i[n]}return i}const p=h.split("."),C=E(r,p);return typeof C>"u"?g:C}e.getConfigurationValue=d;function I(r,h,g){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in r?P.isObject(r[E])&&P.isObject(h[E])?I(r[E],h[E],g):g&&(r[E]=h[E]):r[E]=h[E])})}e.merge=I;function b(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(ee[204],te([0,1,4,25,191,6,160]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",P.isMacintosh),k.set("isLinux",P.isLinux),k.set("isWindows",P.isWindows),k.set("isWeb",P.isWeb),k.set("isMacNative",P.isMacintosh&&!P.isWeb),k.set("isEdge",P.isEdge),k.set("isFirefox",P.isFirefox),k.set("isChrome",P.isChrome),k.set("isSafari",P.isSafari);const f=Object.prototype.hasOwnProperty;var u;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(u=e.ContextKeyExprType||(e.ContextKeyExprType={}));const w={regexParsingWithErrorRecovery:!0};class y extends Error{}const S=(0,R.localize)(0,null),d=(0,R.localize)(1,null),I=(0,R.localize)(2,null),b=(0,R.localize)(3,null),r=(0,R.localize)(4,null),h=(0,R.localize)(5,null),g=(0,R.localize)(6,null),E=(0,R.localize)(7,null);class p{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(v=w){this.h=v,this.c=new s.Scanner,this.d=[],this.f=0,this.g=[]}parse(v){if(v===""){this.g.push({message:S,offset:0,lexeme:"",additionalInfo:d});return}this.d=this.c.reset(v).scan(),this.f=0,this.g=[];try{const O=this.k();if(!this.B()){const W=this.A(),N=W.type===17?h:void 0;throw this.g.push({message:r,offset:W.offset,lexeme:s.Scanner.getLexeme(W),additionalInfo:N}),new y}return O}catch(O){if(!(O instanceof y))throw O;return}}k(){return this.l()}l(){const v=[this.m()];for(;this.v(16);){const O=this.m();v.push(O)}return v.length===1?v[0]:C.or(...v)}m(){const v=[this.o()];for(;this.v(15);){const O=this.o();v.push(O)}return v.length===1?v[0]:C.and(...v)}o(){if(this.v(2)){const v=this.A();switch(v.type){case 11:return this.w(),n.INSTANCE;case 12:return this.w(),o.INSTANCE;case 0:{this.w();const O=this.k();return this.x(1,b),O?.negate()}case 17:return this.w(),T.create(v.lexeme);default:throw this.y("KEY | true | false | '(' expression ')'",v)}}return this.s()}s(){const v=this.A();switch(v.type){case 11:return this.w(),C.true();case 12:return this.w(),C.false();case 0:{this.w();const O=this.k();return this.x(1,b),O}case 17:{const O=v.lexeme;if(this.w(),this.v(9)){const N=this.A();if(!this.h.regexParsingWithErrorRecovery){if(this.w(),N.type!==10)throw this.y("REGEX",N);const G=N.lexeme,j=G.lastIndexOf("/"),B=j===G.length-1?void 0:G.substring(j+1);let K;try{K=new RegExp(G.substring(1,j),B)}catch{throw this.y("REGEX",N)}return ae.create(O,K)}switch(N.type){case 10:case 19:{const G=[N.lexeme];this.w();let j=this.A(),B=0;for(let Se=0;Se<N.lexeme.length;Se++)N.lexeme.charCodeAt(Se)===40?B++:N.lexeme.charCodeAt(Se)===41&&B--;for(;!this.B()&&j.type!==15&&j.type!==16;){switch(j.type){case 0:B++;break;case 1:B--;break;case 10:case 18:for(let Se=0;Se<j.lexeme.length;Se++)j.lexeme.charCodeAt(Se)===40?B++:N.lexeme.charCodeAt(Se)===41&&B--}if(B<0)break;G.push(s.Scanner.getLexeme(j)),this.w(),j=this.A()}const K=G.join(""),re=K.lastIndexOf("/"),he=re===K.length-1?void 0:K.substring(re+1);let ve;try{ve=new RegExp(K.substring(1,re),he)}catch{throw this.y("REGEX",N)}return C.regex(O,ve)}case 18:{const G=N.lexeme;this.w();let j=null;if(!(0,L.isFalsyOrWhitespace)(G)){const B=G.indexOf("/"),K=G.lastIndexOf("/");if(B!==K&&B>=0){const re=G.slice(B+1,K),he=G[K+1]==="i"?"i":"";try{j=new RegExp(re,he)}catch{throw this.y("REGEX",N)}}}if(j===null)throw this.y("REGEX",N);return ae.create(O,j)}default:throw this.y("REGEX",this.A())}}if(this.v(14)){this.x(13,I);const N=this.t();return C.notIn(O,N)}switch(this.A().type){case 3:{this.w();const N=this.t();if(this.u().type===18)return C.equals(O,N);switch(N){case"true":return C.has(O);case"false":return C.not(O);default:return C.equals(O,N)}}case 4:{this.w();const N=this.t();if(this.u().type===18)return C.notEquals(O,N);switch(N){case"true":return C.not(O);case"false":return C.has(O);default:return C.notEquals(O,N)}}case 5:return this.w(),ie.create(O,this.t());case 6:return this.w(),oe.create(O,this.t());case 7:return this.w(),z.create(O,this.t());case 8:return this.w(),q.create(O,this.t());case 13:return this.w(),C.in(O,this.t());default:return C.has(O)}}case 20:throw this.g.push({message:g,offset:v.offset,lexeme:"",additionalInfo:E}),new y;default:throw this.y(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.A())}}t(){const v=this.A();switch(v.type){case 17:case 18:return this.w(),v.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(v){return this.z(v)?(this.w(),!0):!1}w(){return this.B()||this.f++,this.u()}x(v,O){if(this.z(v))return this.w();throw this.y(O,this.A())}y(v,O,W){const N=(0,R.localize)(8,null,v,s.Scanner.getLexeme(O)),G=O.offset,j=s.Scanner.getLexeme(O);return this.g.push({message:N,offset:G,lexeme:j,additionalInfo:W}),new y}z(v){return this.A().type===v}A(){return this.d[this.f]}B(){return this.A().type===20}}e.Parser=p;class C{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(v){return l.create(v)}static equals(v,O){return a.create(v,O)}static notEquals(v,O){return M.create(v,O)}static regex(v,O){return ae.create(v,O)}static in(v,O){return m.create(v,O)}static notIn(v,O){return D.create(v,O)}static not(v){return T.create(v)}static and(...v){return J.create(v,null,!0)}static or(...v){return Y.create(v,null,!0)}static greater(v,O){return z.create(v,O)}static greaterEquals(v,O){return q.create(v,O)}static smaller(v,O){return ie.create(v,O)}static smallerEquals(v,O){return oe.create(v,O)}static deserialize(v){return v==null?void 0:this.c.parse(v)}}C.c=new p({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=C;function t(U){const v=new p({regexParsingWithErrorRecovery:!1});return U.map(O=>(v.parse(O),v.lexingErrors.length>0?v.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,R.localize)(9,null,W.additionalInfo):(0,R.localize)(10,null),offset:W.offset,length:W.lexeme.length})):v.parsingErrors.length>0?v.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.validateWhenClauses=t;function c(U,v){const O=U?U.substituteConstants():void 0,W=v?v.substituteConstants():void 0;return!O&&!W?!0:!O||!W?!1:O.equals(W)}e.expressionsAreEqualWithConstantSubstitution=c;function i(U,v){return U.cmp(v)}class n{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return o.INSTANCE}}n.INSTANCE=new n,e.ContextKeyFalseExpr=n;class o{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return n.INSTANCE}}o.INSTANCE=new o,e.ContextKeyTrueExpr=o;class l{static create(v,O=null){const W=k.get(v);return typeof W=="boolean"?W?o.INSTANCE:n.INSTANCE:new l(v,O)}constructor(v,O){this.key=v,this.c=O,this.type=2}cmp(v){return v.type!==this.type?this.type-v.type:F(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=k.get(this.key);return typeof v=="boolean"?v?o.INSTANCE:n.INSTANCE:this}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=l;class a{static create(v,O,W=null){if(typeof O=="boolean")return O?l.create(v,W):T.create(v,W);const N=k.get(v);return typeof N=="boolean"?O===(N?"true":"false")?o.INSTANCE:n.INSTANCE:new a(v,O,W)}constructor(v,O,W){this.c=v,this.d=O,this.f=W,this.type=4}cmp(v){return v.type!==this.type?this.type-v.type:V(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){const v=k.get(this.c);if(typeof v=="boolean"){const O=v?"true":"false";return this.d===O?o.INSTANCE:n.INSTANCE}return this}evaluate(v){return v.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(v){return v.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=a;class m{static create(v,O){return new m(v,O)}constructor(v,O){this.d=v,this.f=O,this.type=10,this.c=null}cmp(v){return v.type!==this.type?this.type-v.type:V(this.d,this.f,v.d,v.f)}equals(v){return v.type===this.type?this.d===v.d&&this.f===v.f:!1}substituteConstants(){return this}evaluate(v){const O=v.getValue(this.f),W=v.getValue(this.d);return Array.isArray(O)?O.includes(W):typeof W=="string"&&typeof O=="object"&&O!==null?f.call(O,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(v){return v.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class D{static create(v,O){return new D(v,O)}constructor(v,O){this.d=v,this.f=O,this.type=11,this.c=m.create(v,O)}cmp(v){return v.type!==this.type?this.type-v.type:this.c.cmp(v.c)}equals(v){return v.type===this.type?this.c.equals(v.c):!1}substituteConstants(){return this}evaluate(v){return!this.c.evaluate(v)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(v){return v.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=D;class M{static create(v,O,W=null){if(typeof O=="boolean")return O?T.create(v,W):l.create(v,W);const N=k.get(v);return typeof N=="boolean"?O===(N?"true":"false")?n.INSTANCE:o.INSTANCE:new M(v,O,W)}constructor(v,O,W){this.c=v,this.d=O,this.f=W,this.type=5}cmp(v){return v.type!==this.type?this.type-v.type:V(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){const v=k.get(this.c);if(typeof v=="boolean"){const O=v?"true":"false";return this.d===O?n.INSTANCE:o.INSTANCE}return this}evaluate(v){return v.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(v){return v.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=M;class T{static create(v,O=null){const W=k.get(v);return typeof W=="boolean"?W?n.INSTANCE:o.INSTANCE:new T(v,O)}constructor(v,O){this.c=v,this.d=O,this.type=3}cmp(v){return v.type!==this.type?this.type-v.type:F(this.c,v.c)}equals(v){return v.type===this.type?this.c===v.c:!1}substituteConstants(){const v=k.get(this.c);return typeof v=="boolean"?v?n.INSTANCE:o.INSTANCE:this}evaluate(v){return!v.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(v){return v.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.ContextKeyNotExpr=T;function $(U,v){if(typeof U=="string"){const O=parseFloat(U);isNaN(O)||(U=O)}return typeof U=="string"||typeof U=="number"?v(U):n.INSTANCE}class z{static create(v,O,W=null){return $(O,N=>new z(v,N,W))}constructor(v,O,W){this.c=v,this.d=O,this.f=W,this.type=12}cmp(v){return v.type!==this.type?this.type-v.type:V(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(v){return v.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=z;class q{static create(v,O,W=null){return $(O,N=>new q(v,N,W))}constructor(v,O,W){this.c=v,this.d=O,this.f=W,this.type=13}cmp(v){return v.type!==this.type?this.type-v.type:V(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(v){return v.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=q;class ie{static create(v,O,W=null){return $(O,N=>new ie(v,N,W))}constructor(v,O,W){this.c=v,this.d=O,this.f=W,this.type=14}cmp(v){return v.type!==this.type?this.type-v.type:V(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(v){return v.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ie;class oe{static create(v,O,W=null){return $(O,N=>new oe(v,N,W))}constructor(v,O,W){this.c=v,this.d=O,this.f=W,this.type=15}cmp(v){return v.type!==this.type?this.type-v.type:V(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(v){return v.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=oe;class ae{static create(v,O){return new ae(v,O)}constructor(v,O){this.d=v,this.f=O,this.type=7,this.c=null}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.d<v.d)return-1;if(this.d>v.d)return 1;const O=this.f?this.f.source:"",W=v.f?v.f.source:"";return O<W?-1:O>W?1:0}equals(v){if(v.type===this.type){const O=this.f?this.f.source:"",W=v.f?v.f.source:"";return this.d===v.d&&O===W}return!1}substituteConstants(){return this}evaluate(v){const O=v.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const v=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${v}`}keys(){return[this.d]}map(v){return v.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=de.create(this)),this.c}}e.ContextKeyRegexExpr=ae;class de{static create(v){return new de(v)}constructor(v){this.c=v,this.type=8}cmp(v){return v.type!==this.type?this.type-v.type:this.c.cmp(v.c)}equals(v){return v.type===this.type?this.c.equals(v.c):!1}substituteConstants(){return this}evaluate(v){return!this.c.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(v){return new de(this.c.map(v))}negate(){return this.c}}e.ContextKeyNotRegexExpr=de;function ce(U){let v=null;for(let O=0,W=U.length;O<W;O++){const N=U[O].substituteConstants();if(U[O]!==N&&v===null){v=[];for(let G=0;G<O;G++)v[G]=U[G]}v!==null&&(v[O]=N)}return v===null?U:v}class J{static create(v,O,W){return J.d(v,O,W)}constructor(v,O){this.expr=v,this.c=O,this.type=6}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let O=0,W=this.expr.length;O<W;O++){const N=i(this.expr[O],v.expr[O]);if(N!==0)return N}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let O=0,W=this.expr.length;O<W;O++)if(!this.expr[O].equals(v.expr[O]))return!1;return!0}return!1}substituteConstants(){const v=ce(this.expr);return v===this.expr?this:J.create(v,this.c,!1)}evaluate(v){for(let O=0,W=this.expr.length;O<W;O++)if(!this.expr[O].evaluate(v))return!1;return!0}static d(v,O,W){const N=[];let G=!1;for(const j of v)if(!!j){if(j.type===1){G=!0;continue}if(j.type===0)return n.INSTANCE;if(j.type===6){N.push(...j.expr);continue}N.push(j)}if(N.length===0&&G)return o.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let j=1;j<N.length;j++)N[j-1].equals(N[j])&&(N.splice(j,1),j--);if(N.length===1)return N[0];for(;N.length>1;){const j=N[N.length-1];if(j.type!==9)break;N.pop();const B=N.pop(),K=N.length===0,re=Y.create(j.expr.map(he=>J.create([he,B],null,W)),null,K);re&&(N.push(re),N.sort(i))}if(N.length===1)return N[0];if(W){for(let j=0;j<N.length;j++)for(let B=j+1;B<N.length;B++)if(N[j].negate().equals(N[B]))return n.INSTANCE;if(N.length===1)return N[0]}return new J(N,O)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(const O of this.expr)v.push(...O.keys());return v}map(v){return new J(this.expr.map(O=>O.map(v)),null)}negate(){if(!this.c){const v=[];for(const O of this.expr)v.push(O.negate());this.c=Y.create(v,this,!0)}return this.c}}class Y{static create(v,O,W){return Y.d(v,O,W)}constructor(v,O){this.expr=v,this.c=O,this.type=9}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let O=0,W=this.expr.length;O<W;O++){const N=i(this.expr[O],v.expr[O]);if(N!==0)return N}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let O=0,W=this.expr.length;O<W;O++)if(!this.expr[O].equals(v.expr[O]))return!1;return!0}return!1}substituteConstants(){const v=ce(this.expr);return v===this.expr?this:Y.create(v,this.c,!1)}evaluate(v){for(let O=0,W=this.expr.length;O<W;O++)if(this.expr[O].evaluate(v))return!0;return!1}static d(v,O,W){let N=[],G=!1;if(v){for(let j=0,B=v.length;j<B;j++){const K=v[j];if(!!K){if(K.type===0){G=!0;continue}if(K.type===1)return o.INSTANCE;if(K.type===9){N=N.concat(K.expr);continue}N.push(K)}}if(N.length===0&&G)return n.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let j=1;j<N.length;j++)N[j-1].equals(N[j])&&(N.splice(j,1),j--);if(N.length===1)return N[0];if(W){for(let j=0;j<N.length;j++)for(let B=j+1;B<N.length;B++)if(N[j].negate().equals(N[B]))return o.INSTANCE;if(N.length===1)return N[0]}return new Y(N,O)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(const O of this.expr)v.push(...O.keys());return v}map(v){return new Y(this.expr.map(O=>O.map(v)),null)}negate(){if(!this.c){const v=[];for(const O of this.expr)v.push(O.negate());for(;v.length>1;){const O=v.shift(),W=v.shift(),N=[];for(const G of se(O))for(const j of se(W))N.push(J.create([G,j],null,!1));v.unshift(Y.create(N,null,!1))}this.c=Y.create(v,this,!0)}return this.c}}class H extends l{static all(){return H.d.values()}constructor(v,O,W){super(v,null),this.f=O,typeof W=="object"?H.d.push({...W,key:v}):W!==!0&&H.d.push({key:v,description:W,type:O!=null?typeof O:void 0})}bindTo(v){return v.createKey(this.key,this.f)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return a.create(this.key,v)}notEqualsTo(v){return M.create(this.key,v)}}H.d=[],e.RawContextKey=H,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function F(U,v){return U<v?-1:U>v?1:0}function V(U,v,O,W){return U<O?-1:U>O?1:v<W?-1:v>W?1:0}function Z(U,v){if(U.type===0||v.type===1)return!0;if(U.type===9)return v.type===9?ne(U.expr,v.expr):!1;if(v.type===9){for(const O of v.expr)if(Z(U,O))return!0;return!1}if(U.type===6){if(v.type===6)return ne(v.expr,U.expr);for(const O of U.expr)if(Z(O,v))return!0;return!1}return U.equals(v)}e.implies=Z;function ne(U,v){let O=0,W=0;for(;O<U.length&&W<v.length;){const N=U[O].cmp(v[W]);if(N<0)return!1;N===0&&O++,W++}return O===U.length}function se(U){return U.type===9?U.expr:[U]}}),define(ee[77],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,P.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,P.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(A,R){return this.a[A]?.[R]??null}async setPassword(A,R,k){this.a[A]=this.a[A]??{},this.a[A][R]=k}async deletePassword(A,R){return this.a[A]?.[R]?(delete this.a[A][R],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const R=[];for(const k of Object.keys(this.a[A]||{}))R.push({account:k,password:this.a[A][k]});return R}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(ee[89],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,P.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class s{async getPerformanceInfo(R,k){return{}}async getSystemInfo(R,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,k){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=s}),define(ee[90],te([0,1,18,75,162,6,45,4,37]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var u;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(u||(u={}));class w{a(r){return this.d(r,u.Confirmation)}b(r){return this.d(r,u.Prompt)}c(r){return this.d(r,u.Input)}d(r,h){const g=[];switch(h){case u.Confirmation:{const E=r;E.primaryButton?g.push(E.primaryButton):g.push((0,s.localize)(0,null)),E.cancelButton?g.push(E.cancelButton):g.push((0,s.localize)(1,null));break}case u.Prompt:{const E=r;Array.isArray(E.buttons)&&E.buttons.length>0&&g.push(...E.buttons.map(p=>p.label)),E.cancelButton&&(E.cancelButton===!0?g.push((0,s.localize)(2,null)):typeof E.cancelButton=="string"?g.push(E.cancelButton):E.cancelButton.label?g.push(E.cancelButton.label):g.push((0,s.localize)(3,null))),g.length===0&&g.push((0,s.localize)(4,null));break}case u.Input:{const E=r;E.primaryButton?g.push(E.primaryButton):g.push((0,s.localize)(5,null)),E.cancelButton?g.push(E.cancelButton):g.push((0,s.localize)(6,null));break}}return g}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===L.default.Info?"info":r===L.default.Error?"error":r===L.default.Warning?"warning":"none"}async f(r,h,g){const E=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&E.push(r.cancelButton),{result:await E[h]?.run({checkboxChecked:g}),checkboxChecked:g}}}e.AbstractDialogHandler=w,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var y;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(y=e.ConfirmResult||(e.ConfirmResult={}));const S=10;function d(b){const r=[];return r.push(...b.slice(0,S).map(h=>typeof h=="string"?h:(0,P.basename)(h))),b.length>S&&(b.length-S===1?r.push((0,s.localize)(7,null)):r.push((0,s.localize)(8,null,b.length-S))),r.push(""),r.join(`
`)}e.getFileNamesMessage=d;function I(b,r){const h=(0,f.deepClone)(b);let g=(h.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),E=(b.buttons||[]).map((t,c)=>c),p=0,C=h.cancelId??g.length-1;if(g.length>1){const t=typeof C=="number"?g[C]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&g.length>1&&C!==1){g.splice(C,1),g.splice(1,0,t);const c=E[C];E.splice(C,1),E.splice(1,0,c),C=1}k.isLinux&&g.length>1&&(g=g.reverse(),E=E.reverse(),p=g.length-1,typeof t=="string"&&(C=p-1))}else if(k.isWindows&&typeof t=="string"&&g.length>1&&C!==g.length-1){g.splice(C,1),g.push(t);const c=E[C];E.splice(C,1),E.push(c),C=g.length-1}}return h.buttons=g,h.defaultId=p,h.cancelId=C,h.noLink=!0,h.title=h.title||r.nameLong,{options:h,buttonIndeces:E}}e.massageMessageBoxOptions=I}),define(ee[110],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,P.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,55,9,88,34,109,6]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(A.IEnvironmentService);class f extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,s.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ye([P.memoize],f.prototype,"cachedLanguagesPath",null),ye([P.memoize],f.prototype,"backupHome",null),ye([P.memoize],f.prototype,"mainIPCHandle",null),ye([P.memoize],f.prototype,"mainLockfile",null),ye([P.memoize],f.prototype,"disableUpdates",null),ye([P.memoize],f.prototype,"disableKeytar",null),ye([P.memoize],f.prototype,"crossOriginIsolated",null),ye([P.memoize],f.prototype,"codeCachePath",null),ye([P.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[111],te([0,1,166,6]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=s;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function R(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function k(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function f(h,g,E){return k(g,E)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===E?!0:u(E).includes(h)}e.isTargetPlatformCompatible=f;function u(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=w;var y;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var I;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class r extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,P.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ee[205],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,P.createDecorator)("extensionUrlTrustService")}),define(ee[206],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,P.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[112],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,P.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,P.createDecorator)("externalTerminal")}),define(ee[207],te([0,1,46,15,9,4,73,23,87,170,112]),function(x,e,P,L,s,A,R,k,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=u.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends S{openTerminal(p,C){return this.spawnTerminal(P,p,f.getWindowsShell(),C)}spawnTerminal(p,C,t,c){const i=C.windowsExec||d.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const n=s.basename(i,".exe").toLowerCase();if(n==="cmder")return p.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),n==="wt"&&o.push("-d ."),new Promise((l,a)=>{const m=r(process),D=p.spawn(t,o,{cwd:c,env:m});D.on("error",a),D.on("exit",()=>l())})}runInTerminal(p,C,t,c,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows();return new Promise((o,l)=>{const a=`"${C} - ${y}"`,m=`""${t.join('" "')}" & pause"`,D=Object.assign({},r(process),c);Object.keys(D).filter(q=>D[q]===null).forEach(q=>delete D[q]);const M={cwd:C,env:D,windowsVerbatimArguments:!0};let T,$;s.basename(n,".exe")==="wt"?(T=n,$=["-d",".",d.b,"/c",m]):(T=d.b,$=["/c","start",a,"/wait",n,"/c",m]),P.spawn(T,$,M).on("error",q=>{l(h(q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return d.d}}d.b="cmd.exe",e.WindowsExternalTerminalService=d;class I extends S{openTerminal(p,C){return this.spawnTerminal(P,p,C)}runInTerminal(p,C,t,c,i){const n=i.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{if(n===w.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const a=n===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`).fsPath,"-t",p||y,"-w",C];for(const $ of t)D.push("-a"),D.push($);if(c){const $=Object.assign({},r(process),c);for(const z in $){const q=$[z];q===null?(D.push("-u"),D.push(z)):(D.push("-e"),D.push(`${z}=${q}`))}}let M="";const T=P.spawn(I.b,D);T.on("error",$=>{l(h($))}),T.stderr.on("data",$=>{M+=$.toString()}),T.on("exit",$=>{if($===0)o(void 0);else if(M){const z=M.split(`
`,1);l(new Error(z[0]))}else l(new Error(u.localize(1,null,a,$)))})}else l(new Error(u.localize(2,null,n)))})}spawnTerminal(p,C,t){const c=C.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",c];t&&o.push(t);const l=r(process),a=p.spawn("/usr/bin/open",o,{cwd:t,env:l});a.on("error",n),a.on("exit",()=>i())})}}I.b="/usr/bin/osascript",e.MacExternalTerminalService=I;class b extends S{openTerminal(p,C){return this.spawnTerminal(P,p,C)}runInTerminal(p,C,t,c,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{const a=[];n.then(m=>{m.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const D=`${g(t)}; echo; read -p "${b.b}" -n1;`;a.push(`''${D}''`);const M=Object.assign({},r(process),c);Object.keys(M).filter(q=>M[q]===null).forEach(q=>delete M[q]);const T={cwd:C,env:M};let $="";const z=P.spawn(m,a,T);z.on("error",q=>{l(h(q))}),z.stderr.on("data",q=>{$+=q.toString()}),z.on("exit",q=>{if(q===0)o(void 0);else if($){const ie=$.split(`
`,1);l(new Error(ie[0]))}else l(new Error(u.localize(4,null,m,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!A.isLinux)b.d=Promise.resolve("xterm");else{const p=await k.Promises.exists("/etc/debian_version");b.d=new Promise(C=>{p?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return b.d}spawnTerminal(p,C,t){const c=C.linuxExec?Promise.resolve(C.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{c.then(o=>{const l=r(process),a=p.spawn(o,[],{cwd:t,env:l});a.on("error",n),a.on("exit",()=>i())})})}}b.b=u.localize(3,null),e.LinuxExternalTerminalService=b;function r(E){const p={...E.env};return(0,R.sanitizeProcessEnvironment)(p),p}function h(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(u.localize(5,null,E.path)):E}function g(E){let p="";for(const C of E)C.indexOf(" ")>=0?p+='"'+C+'"':p+=C,p+=" ";return p}}),define(ee[16],te([0,1,61,9,25,11,8,172,6,4,15]),function(x,e,P,L,s,A,R,k,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function y(F){return F.create===!0}e.isFileOpenForWriteOptions=y;var S;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var d;(function(F){F[F.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var I;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=b;function r(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=r;function h(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=h;function g(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=E;function p(F){return b(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var C;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(V,Z){const ne=new t(V.toString(),Z);return n(ne,Z),ne}constructor(V,Z){super(V),this.code=Z}}e.FileSystemProviderError=t;function c(F,V){return t.create(F,V)}e.createFileSystemProviderError=c;function i(F){return F||c((0,k.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function n(F,V){return F.name=V?`${V} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=n;function o(F){if(!F)return C.Unknown;if(F instanceof t)return F.code;const V=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!V)return C.Unknown;switch(V[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=o;function l(F){if(F instanceof $)return F.fileOperationResult;switch(o(F)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var a;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class m{constructor(V,Z,ne){this.resource=V,this.operation=Z,this.target=ne}isOperation(V){return this.operation===V}}e.FileOperationEvent=m;var D;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(D=e.FileChangeType||(e.FileChangeType={}));class M{constructor(V,Z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const se of V){const U=ne.get(se.type);switch(U?U.push([se.resource,se]):ne.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,U]of ne)switch(se){case 1:this.a=P.TernarySearchTree.forUris(()=>Z),this.a.fill(U);break;case 0:this.b=P.TernarySearchTree.forUris(()=>Z),this.b.fill(U);break;case 2:this.c=P.TernarySearchTree.forUris(()=>Z),this.c.fill(U);break}}contains(V,...Z){return this.d(V,{includeChildren:!1},...Z)}affects(V,...Z){return this.d(V,{includeChildren:!0},...Z)}d(V,Z,...ne){if(!V)return!1;const se=ne.length>0;return!!((!se||ne.includes(1))&&(this.a?.get(V)||Z.includeChildren&&this.a?.findSuperstr(V))||(!se||ne.includes(0))&&(this.b?.get(V)||Z.includeChildren&&this.b?.findSuperstr(V))||(!se||ne.includes(2))&&(this.c?.findSubstr(V)||Z.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=M;function T(F,V,Z){return!F||!V||F===V||V.length>F.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),Z?(0,s.startsWithIgnoreCase)(F,V):F.indexOf(V)===0)}e.isParent=T;class $ extends Error{constructor(V,Z,ne){super(V),this.fileOperationResult=Z,this.options=ne}}e.FileOperationError=$;class z extends ${constructor(V,Z,ne,se){super(V,Z,se),this.fileOperationResult=Z,this.size=ne}}e.TooLargeFileOperationError=z;class q extends ${constructor(V,Z,ne){super(V,2,ne),this.stat=Z}}e.NotModifiedSinceFileOperationError=q;var ie;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var oe;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=ae;async function de(F,V){if(!V.hasProvider(R.URI.from({scheme:F.scheme})))return new Promise(Z=>{const ne=V.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===F.scheme&&se.added&&(ne.dispose(),Z())})})}e.whenProviderRegistered=de,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<ce.KB?(0,k.localize)(1,null,V.toFixed(0)):V<ce.MB?(0,k.localize)(2,null,(V/ce.KB).toFixed(2)):V<ce.GB?(0,k.localize)(3,null,(V/ce.MB).toFixed(2)):V<ce.TB?(0,k.localize)(4,null,(V/ce.GB).toFixed(2)):(0,k.localize)(5,null,(V/ce.TB).toFixed(2))}}ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB,e.ByteSize=ce;var J;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(J=e.Arch||(e.Arch={}));function Y(F){return{maxFileSize:F===0?300*ce.MB:16*ce.GB,maxHeapSize:F===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=Y;function H(F){const V=typeof F=="string"||F?.scheme===w.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===w.Schemas.file?1024*ce.MB:V?10*ce.MB:u.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=H}),define(ee[208],te([0,1,17,44,13,3,2,60,8,31,16]),function(x,e,P,L,s,A,R,k,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends R.Disposable{constructor(d,I){super(),this.a=d,this.b=I,this.onDidChangeCapabilities=A.Event.None,this.f=this.D(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,u.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,I){const{buffer:b}=await this.a.call("readFile",[d,I]);return b}readFileStream(d,I,b){const r=(0,k.newWriteableStream)(g=>P.VSBuffer.concat(g.map(E=>P.VSBuffer.wrap(E))).buffer),h=this.a.listen("readFileStream",[d,I])(g=>{if(g instanceof P.VSBuffer)r.write(g.buffer);else{if(g==="end")r.end();else{let E;if(g instanceof Error)E=g;else{const p=g;E=(0,w.createFileSystemProviderError)(p.message??(0,L.toErrorMessage)(p),p.code??w.FileSystemProviderErrorCode.Unknown)}r.error(E),r.end()}h.dispose()}});return b.onCancellationRequested(()=>{r.error((0,s.canceled)()),r.end(),h.dispose()}),r}writeFile(d,I,b){return this.a.call("writeFile",[d,P.VSBuffer.wrap(I),b])}open(d,I){return this.a.call("open",[d,I])}close(d){return this.a.call("close",[d])}async read(d,I,b,r,h){const[g,E]=await this.a.call("read",[d,I,h]);return b.set(g.buffer.slice(0,E),r),E}write(d,I,b,r,h){return this.a.call("write",[d,I,P.VSBuffer.wrap(b),r,h])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,I){return this.a.call("delete",[d,I])}rename(d,I,b){return this.a.call("rename",[d,I,b])}copy(d,I,b){return this.a.call("copy",[d,I,b])}cloneFile(d,I){return this.a.call("cloneFile",[d,I])}i(){this.D(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const I=d;this.f.fire(I.map(b=>({resource:f.URI.revive(b.resource),type:b.type})))}else{const I=d;this.g.fire(I)}}))}watch(d,I){const b=(0,u.generateUuid)();return this.a.call("watch",[this.h,b,d,I]),(0,R.toDisposable)(()=>this.a.call("unwatch",[this.h,b]))}}e.DiskFileSystemProviderClient=y}),define(ee[113],te([0,1,17,13,173,16]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(w,y,S,d,I,b){let r;try{await k(w,y,S,d,I,b)}catch(h){r=h}finally{r&&I.errorTransformer&&(r=I.errorTransformer(r)),typeof r<"u"&&S.error(r),S.end()}}e.readFileIntoStream=R;async function k(w,y,S,d,I,b){f(b);const r=await w.open(y,{create:!1});try{f(b);let h=0,g=0,E=I&&typeof I.length=="number"?I.length:void 0,p=P.VSBuffer.alloc(Math.min(I.bufferSize,typeof E=="number"?E:I.bufferSize)),C=I&&typeof I.position=="number"?I.position:0,t=0;do g=await w.read(r,C,p.buffer,t,p.byteLength-t),C+=g,t+=g,h+=g,typeof E=="number"&&(E-=g),t===p.byteLength&&(await S.write(d(p)),p=P.VSBuffer.alloc(Math.min(I.bufferSize,typeof E=="number"?E:I.bufferSize)),t=0);while(g>0&&(typeof E!="number"||E>0)&&f(b)&&u(h,I));if(t>0){let c=t;typeof E=="number"&&(c=Math.min(t,E)),S.write(d(p.slice(0,c)))}}catch(h){throw(0,A.ensureFileSystemProviderError)(h)}finally{await w.close(r)}}function f(w){if(w.isCancellationRequested)throw(0,L.canceled)();return!0}function u(w,y){if(y?.limits){if(typeof y.limits.memory=="number"&&w>y.limits.memory)throw(0,A.createFileSystemProviderError)((0,s.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&w>y.limits.size)throw(0,A.createFileSystemProviderError)((0,s.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[78],te([0,1,102,2,9,4,8,16]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(h){return h.recursive===!0}e.isRecursiveWatchRequest=f;class u extends L.Disposable{constructor(g,E,p,C){super(),this.h=g,this.i=E,this.j=p,this.k=C,this.c=this.D(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new L.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(E=>this.h(E))),g.add(this.b.onDidLogMessage(E=>this.i(E))),g.add(this.b.onDidError(E=>this.n(E)))}n(g){this.k.restartOnError?this.g<u.a&&this.f?(this.q(`restarting watcher after error: ${g}`),this.p(this.f)):this.q(`gave up attempting to restart watcher after error: ${g}`):this.q(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}q(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}r(g){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}u.a=5,e.AbstractWatcherClient=u;class w extends u{constructor(g,E,p){super(g,E,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class y extends u{constructor(g,E,p){super(g,E,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function S(h){return h.map(g=>({type:g.type,resource:R.URI.file(g.path)}))}e.toFileChanges=S;function d(h){const g=new r;for(const E of h)g.processEvent(E);return g.coalesce()}e.coalesceEvents=d;function I(h,g){return typeof g=="string"&&!g.startsWith(P.GLOBSTAR)&&!(0,s.isAbsolute)(g)?{base:h,pattern:g}:g}e.normalizeWatcherPattern=I;function b(h,g){const E=[];for(const p of g)E.push((0,P.parse)(I(h,p)));return E}e.parseWatcherPatterns=b;class r{constructor(){this.a=new Set,this.b=new Map}c(g){return A.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const E=this.b.get(this.c(g));let p=!1;if(E){const C=E.type,t=g.type;E.path!==g.path&&(g.type===2||g.type===1)?p=!0:C===1&&t===2?(this.b.delete(this.c(g)),this.a.delete(E)):C===2&&t===1?E.type=0:C===1&&t===0||(E.type=t)}else p=!0;p&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],E=[];return Array.from(this.a).filter(p=>p.type!==2?(g.push(p),!1):!0).sort((p,C)=>p.path.length-C.path.length).filter(p=>E.some(C=>(0,k.isParent)(p.path,C,!A.isLinux))?!1:(E.push(p.path),!0)).concat(g)}}}),define(ee[209],te([0,1,41,7,22,32,2,82,9,4,103,23,78]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends R.Disposable{constructor(r,h,g,E){super(),this.j=r,this.k=h,this.l=g,this.m=E,this.c=this.D(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.k(p))),this.f=this.D(new L.RunOnceWorker(p=>this.t(p),d.b)),this.g=(0,S.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,S.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new s.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.q(this.j);if(this.i.token.isCancellationRequested)return;const h=await y.Promises.stat(r);this.D(await this.r(r,h.isDirectory()))}catch(r){r.code!=="ENOENT"?this.v(r):this.y(r)}}async q(r){let h=r.path;try{h=await y.Promises.realpath(r.path),r.path===h&&(h=await(0,w.realcase)(r.path)??r.path),r.path!==h&&this.y(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${h})`)}catch{}return h}async r(r,h){if(u.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.v(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const g=new s.CancellationTokenSource(this.i.token),E=new R.DisposableStore;try{const p=(0,f.basename)(r),C=(0,P.watch)(r);E.add((0,R.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.y(`Started watching: '${r}'`);const t=new Set;if(h)try{for(const i of await y.Promises.readdir(r))t.add(i)}catch(i){this.v(i)}const c=new Map;E.add((0,R.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),C.on("error",(i,n)=>{this.v(`Failed to watch ${r} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),C.on("change",(i,n)=>{if(g.token.isCancellationRequested)return;this.y(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),u.isMacintosh&&(o=(0,k.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){c.get(o)?.dispose();const l=setTimeout(async()=>{if(c.delete(o),o===p&&!await y.Promises.exists(r)){this.w("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.u((0,f.join)(r,o));if(g.token.isCancellationRequested)return;let m;a?t.has(o)?m=0:(m=1,t.add(o)):(t.delete(o),m=2),this.s({path:(0,f.join)(this.j.path,o),type:m})},d.a);c.set(o,(0,R.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(o)?l=0:(l=1,t.add(o)),this.s({path:(0,f.join)(this.j.path,o),type:l})}else if(i==="rename"||o!==p){const l=setTimeout(async()=>{const a=await y.Promises.exists(r);g.token.isCancellationRequested||(a?(this.s({path:this.j.path,type:0},!0),E.add(await this.r(r,!1))):(this.s({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);E.clear(),E.add((0,R.toDisposable)(()=>clearTimeout(l)))}else this.s({path:this.j.path,type:0},!0)})}catch(p){await y.Promises.exists(r)&&!g.token.isCancellationRequested&&this.v(`Failed to watch ${r} for changes using fs.watch() (${p.toString()})`)}return(0,R.toDisposable)(()=>{g.dispose(!0),E.dispose()})}s(r,h=!1){this.i.token.isCancellationRequested||(this.m&&this.y(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!h&&this.g.some(g=>g(r.path))?this.m&&this.y(` >> ignored (excluded) ${r.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(g=>g(r.path))?this.m&&this.y(` >> ignored (not included) ${r.path}`):this.f.work(r))}t(r){const h=(0,S.coalesceEvents)(r);if(h.length>0){if(this.m)for(const E of h)this.y(`>> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`);this.c.work(h)?this.c.pending>0&&this.y(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.w(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async u(r){if(u.isLinux)return y.Promises.exists(r);try{const h=(0,f.basename)(r);return(await y.Promises.readdir((0,f.dirname)(r))).some(E=>E===h)}catch(h){return this.y(h),!1}}setVerboseLogging(r){this.m=r}v(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}w(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}y(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.y(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function I(b,r,h,g,E=512){const p=await y.Promises.open(b,"r"),C=Buffer.allocUnsafe(E),t=new s.CancellationTokenSource(g);let c,i=!1;const n={path:b,excludes:[],recursive:!1},o=new d(n,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:m}=await y.Promises.read(p,C,0,E,null);if(!m||t.token.isCancellationRequested)break;r(C.slice(0,m))}}catch(m){c=new Error(m),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,h(),new Promise((l,a)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await y.Promises.close(p)}catch(m){c=new Error(m)}c?a(c):l()})})}e.watchFileContents=I}),define(ee[210],te([0,1,3,102,2,4,209]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends s.Disposable{constructor(){super(...arguments),this.a=this.D(new P.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new P.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(u){const w=this.i(u),y=w.filter(d=>{const I=this.c.get(d.path);return I?!(0,L.patternsEquals)(I.request.excludes,d.excludes)||!(0,L.patternsEquals)(I.request.includes,d.includes):!0}),S=Array.from(this.c.values()).filter(({request:d})=>!w.find(I=>I.path===d.path&&(0,L.patternsEquals)(I.excludes,d.excludes)&&(0,L.patternsEquals)(I.includes,d.includes))).map(({request:d})=>d.path);y.length&&this.j(`Request to start watching: ${y.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),S.length&&this.j(`Request to stop watching: ${S.join(",")}`);for(const d of S)this.h(d);for(const d of y)this.g(d)}g(u){const w=new R.NodeJSFileWatcherLibrary(u,S=>this.a.fire(S),S=>this.b.fire(S),this.f),y={request:u,instance:w};this.c.set(u.path,y)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const w=this.c.get(u);w&&(this.c.delete(u),w.instance.dispose())}i(u){const w=new Map;for(const y of u){const S=A.isLinux?y.path:y.path.toLowerCase();w.set(S,y)}return Array.from(w.values())}async setVerboseLogging(u){this.f=u;for(const[,w]of this.c)w.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,w){return w?`[File Watcher (node.js)] ${u} (path: ${w.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=k}),define(ee[211],te([0,1,78,210]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class s extends P.AbstractNonRecursiveWatcherClient{constructor(R,k,f){super(R,k,f),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=s}),define(ee[212],te([0,1,15,47,156,78]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends A.AbstractUniversalWatcherClient{constructor(f,u,w){super(f,u,w),this.m()}l(f){const u=f.add(new s.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:w,signal:y})=>this.n(`terminated by itself with code ${w}, signal: ${y}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ee[91],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(...s){this.a=new Map;for(const[A,R]of s)this.set(A,R)}set(s,A){const R=this.a.get(s);return this.a.set(s,A),R}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.ServiceCollection=P}),define(ee[213],te([0,1,7,13,2,76,203,6,91,100]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class y extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class S{constructor(r=new f.ServiceCollection,h=!1,g,E=w){this.f=r,this.g=h,this.h=g,this.i=E,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new R.Graph(p=>p):void 0}createChild(r){return new S(r,this.g,this,this.i)}invokeFunction(r,...h){const g=I.traceInvocation(this.i,r);let E=!1;try{return r({get:C=>{if(E)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(C,g);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...h)}finally{E=!0,g.stop()}}createInstance(r,...h){let g,E;return r instanceof A.SyncDescriptor?(g=I.traceCreation(this.i,r.ctor),E=this.j(r.ctor,r.staticArguments.concat(h),g)):(g=I.traceCreation(this.i,r),E=this.j(r,h,g)),g.stop(),E}j(r,h=[],g){const E=k._util.getServiceDependencies(r).sort((t,c)=>t.index-c.index),p=[];for(const t of E){const c=this.m(t.id,g);c||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(c)}const C=E.length>0?E[0].index:h.length;if(h.length!==C){console.trace(`[createInstance] First service dependency of ${r.name} at position ${C+1} conflicts with ${h.length} static arguments`);const t=C-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,C)}return Reflect.construct(r,h.concat(p))}k(r,h){if(this.f.get(r)instanceof A.SyncDescriptor)this.f.set(r,h);else if(this.h)this.h.k(r,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const h=this.f.get(r);return!h&&this.h?this.h.l(r):h}m(r,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const g=this.l(r);return g instanceof A.SyncDescriptor?this.q(r,g,h.branch(r,!0)):(h.branch(r,!1),g)}q(r,h,g){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,h,g)}finally{this.o.delete(r)}}r(r,h,g){const E=new R.Graph(t=>t.id.toString());let p=0;const C=[{id:r,desc:h,_trace:g}];for(;C.length;){const t=C.pop();if(E.lookupOrInsertNode(t),p++>1e3)throw new y(E);for(const c of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(c.id);if(i||this.u(`[createInstance] ${r} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof A.SyncDescriptor){const n={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};E.insertEdge(t,n),C.push(n)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new y(E);break}for(const{data:c}of t){if(this.l(c.id)instanceof A.SyncDescriptor){const n=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,n)}E.removeNode(c)}}return this.l(r)}s(r,h,g=[],E,p){if(this.f.get(r)instanceof A.SyncDescriptor)return this.t(r,h,g,E,p);if(this.h)return this.h.s(r,h,g,E,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(r,h,g=[],E,p){if(E){const C=new S(void 0,this.g,this,this.i);C.c=String(r);const t=new Map,c=new P.IdleValue(()=>{const i=C.j(h,g,p);for(const[n,o]of t){const l=i[n];if(typeof l=="function")for(const a of o)l.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!c.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new u.LinkedList,t.set(n,a)),(D,M,T)=>{const $=a.push([D,M,T]);return(0,s.toDisposable)($)}}if(n in i)return i[n];const o=c.value;let l=o[n];return typeof l!="function"||(l=l.bind(o),i[n]=l),l},set(i,n,o){return c.value[n]=o,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,g,p)}u(r,h){if(h&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=S;var d;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(d||(d={}));class I{static traceInvocation(r,h){return r?new I(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I.c}static traceCreation(r,h){return r?new I(1,h.name):I.c}constructor(r,h){this.type=r,this.name=h,this.g=Date.now(),this.h=[]}branch(r,h){const g=new I(3,r.toString());return this.h.push([r,h,g]),g}stop(){const r=Date.now()-this.g;I.f+=r;let h=!1;function g(p,C){const t=[],c=new Array(p+1).join("	");for(const[i,n,o]of C.h)if(n&&o){h=!0,t.push(`${c}CREATES -> ${i}`);const l=g(p+1,o);l&&t.push(l)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${I.f.toFixed(2)}ms)`];(r>2||h)&&I.all.add(E.join(`
`))}}I.all=new Set,I.c=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}},I.f=0,e.Trace=I}),define(ee[5],te([0,1,44,3,56,2,35,4,18,11,8,204,6]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function d(){return new Date().toISOString()}function I(D){return(0,u.isNumber)(D)}e.isLogLevel=I;var b;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function r(D,M,T){switch(M){case b.Trace:D.trace(T);break;case b.Debug:D.debug(T);break;case b.Info:D.info(T);break;case b.Warning:D.warn(T);break;case b.Error:D.error(T);break;case b.Off:break;default:throw new Error(`Invalid log level ${M}`)}}e.log=r;function h(D,M=!1){let T="";for(let $=0;$<D.length;$++){let z=D[$];if(z instanceof Error&&(z=(0,P.toErrorMessage)(z,M)),typeof z=="object")try{z=JSON.stringify(z)}catch{}T+=($>0?" ":"")+z}return T}class g extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==b.Off&&this.b<=M}}e.AbstractLogger=g;class E extends g{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...T){this.f(b.Trace)&&this.g(b.Trace,h([M,...T],!0))}debug(M,...T){this.f(b.Debug)&&this.g(b.Debug,h([M,...T]))}info(M,...T){this.f(b.Info)&&this.g(b.Info,h([M,...T]))}warn(M,...T){this.f(b.Warning)&&this.g(b.Warning,h([M,...T]))}error(M,...T){if(this.f(b.Error))if(M instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=M.stack,this.g(b.Error,h($))}else this.g(b.Error,h([M,...T]))}flush(){}}e.AbstractMessageLogger=E;class p extends g{constructor(M=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(M),this.g=!k.isWindows}trace(M,...T){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...T):console.log(`[main ${d()}]`,M,...T))}debug(M,...T){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...T):console.log(`[main ${d()}]`,M,...T))}info(M,...T){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...T):console.log(`[main ${d()}]`,M,...T))}warn(M,...T){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,M,...T):console.warn(`[main ${d()}]`,M,...T))}error(M,...T){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,M,...T):console.error(`[main ${d()}]`,M,...T))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class C extends g{constructor(M=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(M)}trace(M,...T){this.f(b.Trace)&&console.log("%cTRACE","color: #888",M,...T)}debug(M,...T){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",M,...T)}info(M,...T){this.f(b.Info)&&console.log("%c INFO","color: #33f",M,...T)}warn(M,...T){this.f(b.Warning)&&console.log("%c WARN","color: #993",M,...T)}error(M,...T){this.f(b.Error)&&console.log("%c  ERR","color: #f33",M,...T)}dispose(){}flush(){}}e.ConsoleLogger=C;class t extends g{constructor(M,T=e.DEFAULT_LOG_LEVEL){super(),this.g=M,this.setLevel(T)}trace(M,...T){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(M),...T])}debug(M,...T){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(M),...T])}info(M,...T){this.f(b.Info)&&this.g.log(b.Info,[this.h(M),...T])}warn(M,...T){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(M),...T])}error(M,...T){this.f(b.Error)&&this.g.log(b.Error,[this.h(M),...T])}h(M){return typeof M=="string"?M:(0,P.toErrorMessage)(M,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class c extends g{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const T of this.g)T.setLevel(M);super.setLevel(M)}trace(M,...T){for(const $ of this.g)$.trace(M,...T)}debug(M,...T){for(const $ of this.g)$.debug(M,...T)}info(M,...T){for(const $ of this.g)$.info(M,...T)}warn(M,...T){for(const $ of this.g)$.warn(M,...T)}error(M,...T){for(const $ of this.g)$.error(M,...T)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose()}}e.MultiplexLogger=c;class i extends A.Disposable{constructor(M,T,$){if(super(),this.h=M,this.j=T,this.b=new R.ResourceMap,this.c=this.D(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new L.Emitter),this.onDidChangeVisibility=this.g.event,$)for(const z of $)this.b.set(z.resource,{logger:void 0,info:z})}k(M){return(0,u.isString)(M)?[...this.b.values()].find(T=>T.info.id===M):this.b.get(M)}getLogger(M){return this.k(M)?.logger}createLogger(M,T){const $=this.l(M),z=(0,u.isString)(M)?M:T?.id??(0,s.hash)($.toString()).toString(16);let q=this.b.get($)?.logger;const ie=T?.logLevel==="always"?b.Trace:T?.logLevel;q||(q=this.m($,ie??this.getLogLevel($)??this.h,{...T,id:z}));const oe={logger:q,info:{resource:$,id:z,logLevel:ie,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(oe.info),this.b.set($,oe),q}l(M){return(0,u.isString)(M)?(0,f.joinPath)(this.j,`${M}.log`):M}setLogLevel(M,T){if(w.URI.isUri(M)){const $=M,z=T,q=this.b.get($);q&&z!==q.info.logLevel&&(q.info.logLevel=z===this.h?void 0:z,q.logger?.setLevel(z),this.b.set(q.info.resource,q),this.f.fire([$,z]))}else{this.h=M;for(const[$,z]of this.b.entries())this.b.get($)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,T){const $=this.k(M);$&&T!==!$.info.hidden&&($.info.hidden=!T,this.b.set($.info.resource,$),this.g.fire([$.info.resource,T]))}getLogLevel(M){let T;return M&&(T=this.b.get(M)?.info.logLevel),T??this.h}registerLogger(M){const T=this.b.get(M.resource);T?T.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const T=this.b.get(M);T&&(T.logger&&T.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(M){}getLevel(){return b.Info}trace(M,...T){}debug(M,...T){}info(M,...T){}warn(M,...T){}error(M,...T){}critical(M,...T){}dispose(){}flush(){}}e.NullLogger=n;class o extends n{}e.NullLogService=o;function l(D){if(D.verbose)return b.Trace;if(typeof D.logLevel=="string"){const M=m(D.logLevel.toLowerCase());if(M!==void 0)return M}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function a(D){switch(D){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=a;function m(D){switch(D){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=m,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",a(b.Info))});var Q=this&&this.__param||function(x,e){return function(P,L){e(P,L,x)}};define(ee[214],te([0,1,77,3,2,5,4,7]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=class ht extends s.Disposable{constructor(w){super(),this.h=w,this.c=this.D(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new k.SequencerByKey}async getPassword(w,y){this.h.trace("Getting password from keytar:",w,y);let S;try{S=await this.i()}catch{return null}return await this.g.queue(w+y,()=>this.k(S,w,y))}async k(w,y,S){const d=await(0,k.retry)(()=>w.getPassword(y,S),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",S),d;let I,b;try{const r=JSON.parse(d);I=r.content,b=r.hasNextChunk}catch{}if(!I||!b)return this.h.trace("Got password from keytar for account:",S),d;try{let r=1;for(;b;){const h=await(0,k.retry)(()=>w.getPassword(y,`${S}-${r}`),50,3),g=JSON.parse(h);I+=g.content,b=g.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,S),I}catch(r){return this.h.error(r),d}}async setPassword(w,y,S){this.h.trace("Setting password using keytar:",w,y);let d;try{d=await this.i()}catch(I){throw this.j?.(I),I}await this.g.queue(w+y,()=>this.l(d,w,y,S)),this.c.fire({service:w,account:y})}async l(w,y,S,d){if(!R.isWindows){await(0,k.retry)(()=>w.setPassword(y,S,d),50,3),this.h.trace("Set password from keytar for account:",S);return}if(await this.m(w,y,S),d.length<=ht.b){await(0,k.retry)(()=>w.setPassword(y,S,d),50,3),this.h.trace("Set password from keytar for account:",S);return}let I=0,b=0,r=!0;const h=[];for(;r;){const g=d.substring(I,I+ht.b);I+=ht.b,r=d.length-I>0;const E={content:g,hasNextChunk:r};h.push((0,k.retry)(()=>w.setPassword(y,b?`${S}-${b}`:S,JSON.stringify(E)),50,3)),b++}await Promise.all(h),this.h.trace(`Set${b?` ${b}-chunked`:""} password from keytar for account:`,S)}async deletePassword(w,y){this.h.trace("Deleting password using keytar:",w,y);let S;try{S=await this.i()}catch(I){throw this.j?.(I),I}const d=await this.g.queue(w+y,()=>this.m(S,w,y));return d&&this.c.fire({service:w,account:y}),d}async m(w,y,S){const d=await w.getPassword(y,S);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",S),!1;let I,b;try{const h=JSON.parse(d);I=h.content,b=h.hasNextChunk}catch{}let r=0;if(I&&b)try{for(r++;b;){const h=`${S}-${r}`,g=await w.getPassword(y,h);await w.deletePassword(y,h),b=JSON.parse(g).hasNextChunk,r++}}catch(h){this.h.error(h)}return await w.deletePassword(y,S)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,S),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,S),!1)}async findPassword(w){let y;try{y=await this.i()}catch{return null}return await y.findPassword(w)}async findCredentials(w){let y;try{y=await this.i()}catch{return[]}return await y.findCredentials(w)}clear(){return this.f instanceof P.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,f=ye([Q(0,A.ILogService)],f),e.BaseCredentialsMainService=f}),define(ee[215],te([0,1,5]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=class{constructor(A,R){this.a=A,this.b=R}c(){return new Promise((A,R)=>x(["vscode-encrypt"],A,R))}async encrypt(A){let R;try{R=await this.c()}catch{return A}try{return R.encrypt(this.a,A)}catch(k){return this.b.error(k),A}}async decrypt(A){let R;try{R=await this.c()}catch{return A}try{return R.decrypt(this.a,A)}catch(k){return this.b.error(k),A}}};L=ye([Q(1,P.ILogService)],L),e.EncryptionMainService=L}),define(ee[216],te([0,1,26,7,13,3,2,9,78,5]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends R.Disposable{constructor(S,d){super(),this.a=S,this.b=d,this.c=this.D(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new L.ThrottledDelayer(0)),this.r=[],this.s=this.D(new L.ThrottledDelayer(0))}watch(S,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(S,d):this.t(S,d)}l(S,d){const I={path:this.z(S),excludes:d.excludes,includes:d.includes,recursive:d.recursive},b=(0,P.insert)(this.j,I);return this.m(),(0,R.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(S=>(0,s.onUnexpectedError)(S))}n(){this.h||(this.h=this.D(this.p(d=>this.c.fire((0,f.toFileChanges)(d)),d=>this.y(d),this.a.getLevel()===u.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const S=this.b?.watcher?.recursive?.usePolling;if(S===!0)for(const d of this.j)(0,f.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const d of this.j)(0,f.isRecursiveWatchRequest)(d)&&S.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(S,d){const I={path:this.z(S),excludes:d.excludes,includes:d.includes,recursive:!1},b=(0,P.insert)(this.r,I);return this.u(),(0,R.toDisposable)(()=>{b(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(S=>(0,s.onUnexpectedError)(S))}v(){return this.q||(this.q=this.D(this.w(S=>this.c.fire((0,f.toFileChanges)(S)),S=>this.y(S),this.a.getLevel()===u.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.q.watch(this.r)}y(S){S.type==="error"&&this.g.fire(S.message),this.a[S.type](S.message)}z(S){return(0,k.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(ee[217],te([0,1,26,7,17,22,3,56,71,2,61,15,64,18,60,171,16,113,5,13]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends u.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.D(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new R.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new R.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new R.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new R.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new L.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${t}`);const i=new u.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(n=>this.R.fire(new r.FileChangesEvent(n,!this.O(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,u.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(i){c.push(i)}}),!this.h.has(t)&&await L.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return f.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new r.FileOperationError((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const i=new E.ErrorNoTelemetry;throw i.message=(0,b.localize)(1,null,t.toString()),i}return c}async k(t){const c=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(c)||(0,r.hasReadWriteCapability)(c)||(0,r.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(c)||(0,r.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(i){throw(0,r.toFileSystemProviderErrorCode)(i)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,b.localize)(2,null,this.nb(t)),1):(0,r.ensureFileSystemProviderError)(i)}}async n(t,c){const i=await this.j(t),n=this.O(i),o=c?.resolveTo,l=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,m=await i.stat(t);let D;return this.p(i,t,m,void 0,!!a,(M,T)=>(D||(D=w.TernarySearchTree.forUris(()=>!n),D.set(t,!0),o&&D.fill(!0,o)),D.get(M.resource)||D.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&l?T===1:!1))}async p(t,c,i,n,o,l){const{providerExtUri:a}=this.N(t),m={resource:c,name:a.basename(c),isFile:(i.type&r.FileType.File)!==0,isDirectory:(i.type&r.FileType.Directory)!==0,isSymbolicLink:(i.type&r.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&r.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,r.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&l(m,n)){try{const D=await t.readdir(c),M=await L.Promises.settled(D.map(async([T,$])=>{try{const z=a.joinPath(c,T),q=o?await t.stat(z):{type:$};return await this.p(t,z,q,D.length,o,l)}catch(z){return this.b.trace(z),null}}));m.children=(0,P.coalesce)(M)}catch(D){this.b.trace(D),m.children=[]}return m}return m}async resolveAll(t){return L.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),i=await c.stat(t);return this.p(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.q(t,c)}catch(i){return i}return!0}async q(t,c){if(!c?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,b.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=s.VSBuffer.fromString(""),i){await this.q(t,i);const n=await this.writeFile(t,c);return this.m.fire(new r.FileOperationEvent(t,0,n)),n}async writeFile(t,c,i){const n=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(n);try{await this.r(n,t,i)||await this.P(n,o.dirname(t));let a;if((0,r.hasReadWriteCapability)(n)&&!(c instanceof s.VSBuffer))if((0,I.isReadableStream)(c)){const m=await(0,I.peekStream)(c,3);m.ended?a=s.VSBuffer.concat(m.buffer):a=m}else a=(0,I.peekReadable)(c,m=>s.VSBuffer.concat(m),3);else a=c;!(0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n)&&a instanceof s.VSBuffer?await this.cb(n,t,i,a):await this.Y(n,t,i,a instanceof s.VSBuffer?(0,s.bufferToReadable)(a):a),this.m.fire(new r.FileOperationEvent(t,4))}catch(l){throw new r.FileOperationError((0,b.localize)(4,null,this.nb(t),(0,r.ensureFileSystemProviderError)(l).toString()),(0,r.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async r(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(c)));let o;try{o=await t.stat(c)}catch{return}if((o.type&r.FileType.Directory)!==0)throw new r.FileOperationError((0,b.localize)(6,null,this.nb(c)),0,i);if(this.mb(c,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==r.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,r.etag)({mtime:i.mtime,size:o.size}))throw new r.FileOperationError((0,b.localize)(7,null),3,i);return o}async readFile(t,c,i){const n=await this.k(t);return c?.atomic?this.s(n,t,c,i):this.t(n,t,c,i)}async s(t,c,i,n){return new Promise((o,l)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.t(t,c,i,n);o(a)}catch(a){l(a)}})})}async t(t,c,i,n){const o=await this.u(t,c,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,s.streamToBuffer)(o.value)}}async readFileStream(t,c,i){const n=await this.k(t);return this.u(n,t,c,i)}async u(t,c,i,n){const o=new A.CancellationTokenSource(n),l=this.F(c,i).then(m=>m,m=>{throw o.cancel(),m});let a;try{return typeof i?.etag=="string"&&i.etag!==r.ETAG_DISABLED&&await l,i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.C(t,c,i):(0,r.hasFileReadStreamCapability)(t)?a=this.w(t,c,o.token,i):a=this.z(t,c,o.token,i),{...await l,value:a}}catch(m){throw a&&await(0,I.consumeStream)(a),this.v(m,c,i)}}v(t,c,i){const n=(0,b.localize)(8,null,this.nb(c),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new r.FileOperationError(n,(0,r.toFileOperationResult)(t),i)}w(t,c,i,n=Object.create(null)){const o=t.readFileStream(c,n,i);return(0,I.transform)(o,{data:l=>l instanceof s.VSBuffer?l:s.VSBuffer.wrap(l),error:l=>this.v(l,c,n)},l=>s.VSBuffer.concat(l))}z(t,c,i,n=Object.create(null)){const o=(0,s.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,c,o,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.v(l,c,n)},i),o}C(t,c,i){const n=(0,I.newWriteableStream)(o=>s.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?o=await t.readFile(c,{atomic:!0}):o=await t.readFile(c),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(c,o.byteLength,i),n.end(s.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async F(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError((0,b.localize)(9,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==r.ETAG_DISABLED&&c.etag===i.etag)throw new r.NotModifiedSinceFileOperationError((0,b.localize)(10,null),i,c);return this.G(t,i.size,c),i}G(t,c,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&c>i.limits.size&&(n=7),typeof n=="number")throw new r.TooLargeFileOperationError((0,b.localize)(11,null,this.nb(t)),n,c,i)}}async canMove(t,c,i){return this.H(t,c,"move",i)}async canCopy(t,c,i){return this.H(t,c,"copy",i)}async H(t,c,i,n){if(t.toString()!==c.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(c),c);await this.M(o,t,l,c,i,n)}catch(o){return o}return!0}async move(t,c,i){const n=this.lb(await this.l(t),t),o=this.lb(await this.l(c),c),l=await this.I(n,t,o,c,"move",!!i),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,l==="move"?2:3,a)),a}async copy(t,c,i){const n=await this.k(t),o=this.lb(await this.l(c),c),l=await this.I(n,t,o,c,"copy",!!i),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,l==="copy"?3:2,a)),a}async I(t,c,i,n,o,l){if(c.toString()===n.toString())return o;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.M(t,c,i,n,o,l);if(a&&!m&&l&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(c,n,{overwrite:l});else{const D=await this.resolve(c);D.isDirectory?await this.L(t,D,i,n):await this.J(t,c,i,n)}return o}else return t===i?(await t.rename(c,n,{overwrite:l}),o):(await this.I(t,c,i,n,"copy",l),await this.del(c,{recursive:!0}),"copy")}async J(t,c,i,n){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.eb(t,c,i,n);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.kb(t,c,i,n);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.ib(t,c,i,n);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.gb(t,c,i,n)}async L(t,c,i,n){await i.mkdir(n),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async o=>{const l=this.N(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,l):this.J(t,o.resource,i,l)}))}async M(t,c,i,n,o,l){let a=!1;if(t===i){const{providerExtUri:D,isPathCaseSensitive:M}=this.N(t);if(M||(a=D.isEqual(c,n)),a&&o==="copy")throw new Error((0,b.localize)(12,null,this.nb(c),this.nb(n)));if(!a&&D.isEqualOrParent(n,c))throw new Error((0,b.localize)(13,null,this.nb(c),this.nb(n)))}const m=await this.exists(n);if(m&&!a){if(!l)throw new r.FileOperationError((0,b.localize)(14,null,this.nb(c),this.nb(n)),4);if(t===i){const{providerExtUri:D}=this.N(t);if(D.isEqualOrParent(c,n))throw new Error((0,b.localize)(15,null,this.nb(c),this.nb(n)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}N(t){const c=this.O(t);return{providerExtUri:c?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async P(t,c){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(c,n.dirname(c));)try{if(((await t.stat(c)).type&r.FileType.Directory)===0)throw new Error((0,b.localize)(16,null,this.nb(c)));break}catch(o){if((0,r.toFileSystemProviderErrorCode)(o)!==r.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(c)),c=n.dirname(c)}for(let o=i.length-1;o>=0;o--){c=n.joinPath(c,i[o]);try{await t.mkdir(c)}catch(l){if((0,r.toFileSystemProviderErrorCode)(l)!==r.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,c){try{await this.Q(t,c)}catch(i){return i}return!0}async Q(t,c){const i=this.lb(await this.j(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,b.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new r.FileOperationError((0,b.localize)(18,null,this.nb(t)),1);if(!!!c?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,b.localize)(19,null,this.nb(t)))}return i}async del(t,c){const i=await this.Q(t,c),n=!!c?.useTrash,o=!!c?.recursive;await i.delete(t,{recursive:o,useTrash:n}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.j(t),n=this.lb(await this.l(c),c);if(i===n&&this.N(i).providerExtUri.isEqual(t,c))return;if(i===n&&(0,r.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.P(n,this.N(n).providerExtUri.dirname(c));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,r.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,c,{overwrite:!0})):o.queue(()=>this.J(i,t,n,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new u.DisposableStore;let n=!1,o=()=>{n=!0};return i.add((0,u.toDisposable)(()=>o())),(async()=>{try{const l=await this.W(t,c);n?(0,u.dispose)(l):o=()=>(0,u.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,c){const i=await this.j(t),n=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),c]);let o=this.U.get(n);return o||(o={count:0,disposable:i.watch(t,c)},this.U.set(n,o)),o.count+=1,(0,u.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,u.dispose)(o.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.dispose)(t.disposable);this.U.clear()}async Y(t,c,i,n){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,I.isReadableStream)(n)||(0,I.isReadableBufferedStream)(n)?await this.Z(t,o,n):await this.ab(t,o,n)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await t.close(o)}})}async Z(t,c,i){let n=0,o;if((0,I.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=s.VSBuffer.concat(i.buffer);await this.bb(t,c,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,a)=>{(0,I.listenStream)(o,{onData:async m=>{o.pause();try{await this.bb(t,c,m,m.byteLength,n,0)}catch(D){return a(D)}n+=m.byteLength,setTimeout(()=>o.resume())},onError:m=>a(m),onEnd:()=>l()})})}async ab(t,c,i){let n=0,o;for(;(o=i.read())!==null;)await this.bb(t,c,o,o.byteLength,n,0),n+=o.byteLength}async bb(t,c,i,n,o,l){let a=0;for(;a<n;)a+=await t.write(c,o+a,i.buffer,l+a,n-a)}async cb(t,c,i,n){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,i,n))}async db(t,c,i,n){let o;n instanceof s.VSBuffer?o=n:(0,I.isReadableStream)(n)?o=await(0,s.streamToBuffer)(n):(0,I.isReadableBufferedStream)(n)?o=await(0,s.bufferedStreamToBuffer)(n):o=(0,s.readableToBuffer)(n),await t.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,c,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,c,i,n))}async fb(t,c,i,n){let o,l;try{o=await t.open(c,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const a=s.VSBuffer.alloc(this.a);let m=0,D=0,M=0;do M=await t.read(o,m,a.buffer,D,a.byteLength-D),await this.bb(i,l,a,M,m,D),m+=M,D+=M,D===a.byteLength&&(D=0);while(M>0)}catch(a){throw(0,r.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,c,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,c,i,n))}async hb(t,c,i,n){return i.writeFile(n,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(t,c,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,c,i,n))}async jb(t,c,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await t.readFile(c);await this.bb(i,o,s.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await i.close(o)}}async kb(t,c,i,n){const o=await(0,s.streamToBuffer)(this.z(t,c,A.CancellationToken.None));await this.cb(i,n,void 0,o)}lb(t,c){if(t.capabilities&2048)throw new r.FileOperationError((0,b.localize)(20,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,b.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};p=ye([Q(0,g.ILogService)],p),e.FileService=p}),define(ee[92],te([0,1,41,293,7,35,17,3,32,2,9,4,18,60,23,175,16,113,216,44,212,211]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(P)}catch(c){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(c)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=k.Event.None,this.H=new A.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:o}=await I.SymlinkSupport.stat(this.z(i));return{type:this.G(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await I.Promises.readdir(this.z(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(i,l.name))).type:a=this.G(l),o.push([l.name,a])}catch(a){this.a.trace(a)}})),o}catch(n){throw this.Y(n)}}G(i,n){let o;return n?.dangling?o=r.FileType.Unknown:i.isFile()?o=r.FileType.File:i.isDirectory()?o=r.FileType.Directory:o=r.FileType.Unknown,n&&(o|=r.FileType.SymbolicLink),o}async I(i){const n=this.z(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const l=new s.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(i)})`),o=await this.I(i));const l=this.z(i);return await I.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{o?.dispose()}}J(i){t.C&&this.a.trace(i)}readFileStream(i,n,o){const l=(0,d.newWriteableStream)(a=>R.VSBuffer.concat(a.map(m=>R.VSBuffer.wrap(m))).buffer);return(0,h.readFileIntoStream)(this,i,l,a=>a.buffer,{...n,bufferSize:256*1024},o),l}async writeFile(i,n,o){let l;try{const a=this.z(i);if(!o.create||!o.overwrite){if(await I.Promises.exists(a)){if(!o.overwrite)throw(0,r.createFileSystemProviderError)((0,b.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,r.createFileSystemProviderError)((0,b.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const o=this.z(i);let l;(0,r.isFileOpenForWriteOptions)(n)&&(l=await this.I(i));let a;try{if((0,r.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:D}=await I.SymlinkSupport.stat(o);D.mode&128||await I.Promises.chmod(o,D.mode|128)}catch(D){this.a.trace(D)}let m;if((0,r.isFileOpenForWriteOptions)(n)){if(y.isWindows)try{await I.Promises.truncate(o,0),m="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}m||(m="w")}else m="r";a=await I.Promises.open(o,m)}catch(m){throw l?.dispose(),(0,r.isFileOpenForWriteOptions)(n)?await this.Z(i,m):this.Y(m)}if(this.L.set(a,0),(0,r.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),l){const m=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,l),m&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),m.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await I.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await I.Promises.close(i)}catch(o){throw this.Y(o)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,l,a){const m=this.P(i,n);let D=null;try{D=(await I.Promises.read(i,o,l,a,m)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(i,m,D)}return D}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,o){const l=this.L.get(i);typeof l=="number"&&(typeof n=="number"||(typeof o=="number"?this.L.set(i,l+o):this.L.delete(i)))}async write(i,n,o,l,a){return(0,s.retry)(()=>this.R(i,n,o,l,a),100,3)}async R(i,n,o,l,a){const m=this.P(i,n);let D=null;try{D=(await I.Promises.write(i,o,l,a,m)).bytesWritten}catch(M){throw await this.Z(this.N.get(i),M)}finally{this.Q(i,m,D)}return D}async mkdir(i){try{await I.Promises.mkdir(this.z(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const o=this.z(i);n.recursive?await I.Promises.rm(o,I.RimRafMode.MOVE):await I.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,n,o){const l=this.z(i),a=this.z(n);if(l!==a)try{await this.S(i,n,"move",o.overwrite),await I.Promises.move(l,a)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(2,null,(0,w.basename)(l),(0,w.basename)((0,w.dirname)(a)),m.toString()))),this.Y(m)}}async copy(i,n,o){const l=this.z(i),a=this.z(n);if(l!==a)try{await this.S(i,n,"copy",o.overwrite),await I.Promises.copy(l,a,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(3,null,(0,w.basename)(l),(0,w.basename)((0,w.dirname)(a)),m.toString()))),this.Y(m)}}async S(i,n,o,l){const a=this.z(i),m=this.z(n);let D=!1;if(!!(this.capabilities&1024)||(D=(0,f.isEqual)(a,m,!0)),D&&o==="copy")throw(0,r.createFileSystemProviderError)((0,b.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(!D&&await I.Promises.exists(m)){if(!l)throw(0,r.createFileSystemProviderError)((0,b.localize)(5,null),r.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,o){const l=this.z(i),a=this.z(n),m=!!(this.capabilities&1024);if((0,f.isEqual)(l,a,!m))return;const D=new u.DisposableStore;try{const[M,T]=await Promise.all([this.I(i),this.I(n)]);D.add(M),D.add(T),o&&await I.Promises.mkdir((0,w.dirname)(a),{recursive:!0}),await I.Promises.copyFile(l,a)}catch(M){if(M.code==="ENOENT"&&!o)return this.U(i,n,!0);throw this.Y(M)}finally{D.dispose()}}p(i,n,o){return new p.UniversalWatcherClient(l=>i(l),l=>n(l),o)}w(i,n,o){return new C.NodeJSWatcherClient(l=>i(l),l=>n(l),o)}Y(i){if(i instanceof r.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=r.FileSystemProviderErrorCode.NoPermissions;break;default:n=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(i,n)}async Z(i,n){let o=this.Y(n);if(i&&o.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await I.SymlinkSupport.stat(this.z(i));l.mode&128||(o=(0,r.createFileSystemProviderError)(n,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return o}}t.C=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ee[218],te([0,1,3,92,2,17,60,22]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends s.Disposable{constructor(y,S){super(),this.a=y,this.b=S,this.v=new Map,this.w=new Map}call(y,S,d){const I=this.c(y);switch(S){case"stat":return this.g(I,d[0]);case"readdir":return this.h(I,d[0]);case"open":return this.l(I,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(I,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(I,d[0],d[1],d[2]);case"rename":return this.s(I,d[0],d[1],d[2]);case"copy":return this.t(I,d[0],d[1],d[2]);case"cloneFile":return this.u(I,d[0],d[1]);case"mkdir":return this.q(I,d[0]);case"delete":return this.r(I,d[0],d[1]);case"watch":return this.z(I,d[0],d[1],d[2],d[3]);case"unwatch":return this.C(d[0],d[1])}throw new Error(`IPC Command ${S} not found`)}listen(y,S,d){const I=this.c(y);switch(S){case"fileChange":return this.y(I,d[0]);case"readFileStream":return this.j(I,d[0],d[1])}throw new Error(`Unknown event ${S}`)}g(y,S){const d=this.f(y,S,!0);return this.a.stat(d)}h(y,S){const d=this.f(y,S);return this.a.readdir(d)}async i(y,S,d){const I=this.f(y,S,!0),b=await this.a.readFile(I,d);return A.VSBuffer.wrap(b)}j(y,S,d){const I=this.f(y,S,!0),b=new k.CancellationTokenSource,r=new P.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),h=this.a.readFileStream(I,d,b.token);return(0,R.listenStream)(h,{onData:g=>r.fire(A.VSBuffer.wrap(g)),onError:g=>r.fire(g),onEnd:()=>{r.fire("end"),r.dispose(),b.dispose()}}),r.event}k(y,S,d,I){const b=this.f(y,S);return this.a.writeFile(b,d.buffer,I)}l(y,S,d){const I=this.f(y,S,!0);return this.a.open(I,d)}m(y){return this.a.close(y)}async n(y,S,d){const I=A.VSBuffer.alloc(d),b=0,r=await this.a.read(y,S,I.buffer,b,d);return[I,r]}p(y,S,d,I,b){return this.a.write(y,S,d.buffer,I,b)}q(y,S){const d=this.f(y,S);return this.a.mkdir(d)}r(y,S,d){const I=this.f(y,S);return this.a.delete(I,d)}s(y,S,d,I){const b=this.f(y,S),r=this.f(y,d);return this.a.rename(b,r,I)}t(y,S,d,I){const b=this.f(y,S),r=this.f(y,d);return this.a.copy(b,r,I)}u(y,S,d){const I=this.f(y,S),b=this.f(y,d);return this.a.cloneFile(I,b)}y(y,S){const d=new P.Emitter({onWillAddFirstListener:()=>{this.v.set(S,this.F(y,d))},onDidRemoveLastListener:()=>{(0,s.dispose)(this.v.get(S)),this.v.delete(S)}});return d.event}async z(y,S,d,I,b){const r=this.v.get(S);if(r){const h=this.f(y,I),g=r.watch(d,h,b);this.w.set(S+d,g)}}async C(y,S){const d=y+S,I=this.w.get(d);I&&((0,s.dispose)(I),this.w.delete(d))}dispose(){super.dispose();for(const[,y]of this.w)y.dispose();this.w.clear();for(const[,y]of this.v)y.dispose();this.v.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class u extends s.Disposable{constructor(y,S,d,I){super(),this.c=y,this.f=d,this.g=I,this.a=new Map,this.b=this.D(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(S)}h(y){const S=this.D(new P.Emitter);this.D(S.event(d=>{y.fire(d.map(I=>({resource:this.c.transformOutgoingURI(I.resource),type:I.type})))})),this.D(this.b.onDidChangeFile(d=>S.fire(d))),this.D(this.b.onDidWatchError(d=>y.fire(d)))}i(y){}j(y){}watch(y,S,d){const I=this.j(this.g);return Array.isArray(I)&&(d.excludes=[...d.excludes,...I]),this.a.set(y,this.b.watch(S,d)),(0,s.toDisposable)(()=>{(0,s.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=u}),define(ee[219],te([0,1,14,174,4,8,16,9,218,150]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class w extends f.AbstractDiskFileSystemProviderChannel{constructor(d,I,b){super(d,I),this.G=b}c(d){return u.DefaultURITransformer}f(d,I){return A.URI.revive(I)}async r(d,I,b){if(!b.useTrash)return super.r(d,I,b);const r=this.f(d,I),h=(0,k.normalize)(r.fsPath);try{await P.shell.trashItem(h)}catch{throw(0,R.createFileSystemProviderError)(s.isWindows?(0,L.localize)(0,null,(0,k.basename)(h)):(0,L.localize)(1,null,(0,k.basename)(h)),R.FileSystemProviderErrorCode.Unknown)}}F(d,I){return new y(d,I,this.b,this.G)}}e.DiskFileSystemProviderChannel=w;class y extends f.AbstractSessionFileWatcher{watch(d,I,b){if(b.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(d,I,b)}}}),define(ee[220],te([0,1,5]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends P.AbstractMessageLogger{constructor(A=P.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(A),this.D(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(A){this.l=A;for(const{level:R,message:k}of this.k)(0,P.log)(A,R,k);this.k=[]}g(A,R){this.l?(0,P.log)(this.l,A,R):this.getLevel()<=A&&this.k.push({level:A,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=L}),define(ee[221],te([0,1,2,5]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class s extends P.Disposable{constructor(R,k=[]){super(),this.a=new L.MultiplexLogger([R,...k]),this.D(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...k){this.a.trace(R,...k)}debug(R,...k){this.a.debug(R,...k)}info(R,...k){this.a.info(R,...k)}warn(R,...k){this.a.warn(R,...k)}error(R,...k){this.a.error(R,...k)}flush(){this.a.flush()}}e.LogService=s}),define(ee[222],te([0,1,35,8,5]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(k){this.b=k,this.a=new P.ResourceMap}listen(k,f,u){switch(f){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(k,f,u){switch(f){case"createLogger":this.c(L.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,s.isLogLevel)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(L.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(L.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:L.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(L.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}c(k,f,u){this.a.set(k,this.b.createLogger(k,f,u))}d(k,f){let u=console.log;switch(k){case s.LogLevel.Error:u=console.error;break;case s.LogLevel.Warning:u=console.warn;break;case s.LogLevel.Info:u=console.info;break}u.call(console,...f)}e(k,f){const u=this.a.get(k);if(!u)throw new Error("Create the logger before logging");for(const[w,y]of f)(0,s.log)(u,w,y)}}e.LoggerChannel=A}),define(ee[223],te([0,1,16,5]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var s;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(s||(s={}));async function A(u,w,y,S,d){try{const I=await new Promise((r,h)=>{x(["spdlog"],r,h)});I.setFlushOn(s.Trace);const b=await I.createAsyncRotatingLogger(u,w,y,S);return d?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(I){console.error(I)}return null}function R(u,w,y){switch(w){case L.LogLevel.Trace:u.trace(y);break;case L.LogLevel.Debug:u.debug(y);break;case L.LogLevel.Info:u.info(y);break;case L.LogLevel.Warning:u.warn(y);break;case L.LogLevel.Error:u.error(y);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function k(u,w){switch(w){case L.LogLevel.Trace:u.setLevel(s.Trace);break;case L.LogLevel.Debug:u.setLevel(s.Debug);break;case L.LogLevel.Info:u.setLevel(s.Info);break;case L.LogLevel.Warning:u.setLevel(s.Warning);break;case L.LogLevel.Error:u.setLevel(s.Error);break;case L.LogLevel.Off:u.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class f extends L.AbstractMessageLogger{constructor(w,y,S,d,I){super(),this.k=[],this.setLevel(I),this.l=this.n(w,y,S,d),this.D(this.onDidChangeLogLevel(b=>{this.m&&k(this.m,b)}))}async n(w,y,S,d){const I=S?6:1,b=30/I*P.ByteSize.MB,r=await A(w,y,b,I,d);if(r){this.m=r,k(this.m,this.getLevel());for(const{level:h,message:g}of this.k)R(this.m,h,g);this.k=[]}}g(w,y){this.m?R(this.m,w,y):this.getLevel()<=w&&this.k.push({level:w,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(ee[224],te([0,1,31,5,223]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(k,f,u){return new s.SpdLogLogger((0,P.generateUuid)(),k.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.LoggerService=A}),define(ee[65],te([0,1,35,3,6,5,224]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,s.refineServiceDecorator)(A.ILoggerService);class k extends R.LoggerService{constructor(){super(...arguments),this.p=new P.ResourceMap}createLogger(u,w,y){y!==void 0&&this.p.set(this.l(u),y);try{return super.createLogger(u,w)}catch(S){throw this.p.delete(this.l(u)),S}}registerLogger(u,w){w!==void 0&&this.p.set(u.resource,w),super.registerLogger(u)}deregisterLogger(u){this.p.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const w=[];for(const y of super.getRegisteredLoggers())u===this.p.get(y.resource)&&w.push(y);return w}getOnDidChangeLogLevelEvent(u){return L.Event.filter(this.onDidChangeLogLevel,w=>(0,A.isLogLevel)(w)||this.q(w[0],u))}getOnDidChangeVisibilityEvent(u){return L.Event.filter(this.onDidChangeVisibility,([w])=>this.q(w,u))}getOnDidChangeLoggersEvent(u){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,w=>({added:[...w.added].filter(S=>this.q(S.resource,u)),removed:[...w.removed].filter(S=>this.q(S.resource,u))})),w=>w.added.length>0||w.removed.length>0)}deregisterLoggers(u){for(const[w,y]of this.p)y===u&&this.deregisterLogger(w)}q(u,w){const y=this.p.get(u);return y===void 0||y===w}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=k}),define(ee[225],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function P(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=P;function L(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function s(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=s;function A(R){return!P(R)&&!L(R)&&!s(R)}e.isMenubarMenuItemAction=A}),define(ee[38],te([0,1,3,71,2,6]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class R extends s.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new P.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const w=Object.keys(this.f).length;return this.f={...u,...this.f},w!==Object.keys(this.f).length&&await this.i(u),L.Iterable.reduce(this.g.entries(),(y,[S,d])=>({...y,[S]:d}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(u,[w,y])=>({...u,[w]:{definition:y,value:this.g.get(w)}}),{})}}e.AbstractPolicyService=R;class k{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[226],te([0,1,7,3,71,11,16,5,38]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(y,S){const d=[];for(const I of new Set(s.Iterable.concat(y.keys(),S.keys())))y.get(I)!==S.get(I)&&d.push(I);return d}let w=class extends f.AbstractPolicyService{constructor(S,d,I){super(),this.j=S,this.k=d,this.l=I,this.c=this.D(new P.ThrottledDelayer(500));const b=L.Event.filter(d.onDidFilesChange,r=>r.affects(S));this.D(d.watch(S)),this.D(b(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const S=new Map;try{const d=await this.k.readFile(this.j),I=JSON.parse(d.value.toString());if(!(0,A.isObject)(I))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(I))this.f[b]&&S.set(b,I[b])}catch(d){d.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",d)}return S}async p(){const S=await this.n(),d=u(this.g,S);this.g=S,d.length>0&&this.h.fire(d)}};w=ye([Q(1,R.IFileService),Q(2,k.ILogService)],w),e.FilePolicyService=w}),define(ee[227],te([0,1,3,2,38]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(f){this.b=f,this.a=new L.DisposableStore}listen(f,u){switch(u){case"onDidChange":return P.Event.map(this.b.onDidChange,w=>w.reduce((y,S)=>({...y,[S]:this.b.getPolicyValue(S)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(f,u,w){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(w)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class R extends s.AbstractPolicyService{constructor(f,u){super(),this.a=u;for(const w in f){const{definition:y,value:S}=f[w];this.f[w]=y,S!==void 0&&this.g.set(w,S)}this.a.listen("onDidChange")(w=>{for(const y in w){const S=w[y];S===null?this.g.delete(y):this.g.set(y,S)}this.h.fire(Object.keys(w))})}async i(f){const u=await this.a.call("updatePolicyDefinitions",f);for(const w in u)this.g.set(w,u[w])}}e.PolicyChannelClient=R}),define(ee[228],te([0,1,38,7,294,2,5]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends P.AbstractPolicyService{constructor(u,w){super(),this.j=u,this.k=w,this.a=new L.Throttler,this.b=this.D(new A.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((w,y)=>{try{this.b.value=(0,s.createWatcher)(this.k,u,S=>{this.m(S),w()})}catch(S){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",S),y(S)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const w in u){const y=u[w];y===void 0?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(u))}};k=ye([Q(0,R.ILogService)],k),e.NativePolicyService=k}),define(ee[66],te([0,1,4,36]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const A=P.globals.vscode.context.configuration();if(A)s=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:A.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ee[21],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[229],te([0,1,83,5,21]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=class{constructor(k,f){this.b=k,this.c=f,this.a=new Map}async isExtensionUrlTrusted(k,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const u=/^(.*)#([^#]+)$/.exec(f);if(!u)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,w,y]=u;let S=this.a.get(k);if(!S){if(S=this.b.trustedExtensionUrlPublicKeys[k],!S||S.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...S])}const d=Buffer.from(decodeURIComponent(y),"base64");if(d.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const I=d.slice(0,6),b=d.readUIntBE(0,6),r=Date.now()-b;if(r<0||r>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const h=d.slice(6),g=P.createVerify("SHA256");g.write(I),g.write(Buffer.from(w)),g.end();for(let E=0;E<S.length;E++){let p=S[E];if(p!==null){if(typeof p=="string")try{p=P.createPublicKey({key:Buffer.from(p,"base64"),format:"der",type:"spki"}),S[E]=p}catch(C){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${E+1} for ${k}:`,C),S[E]=null;continue}if(g.verify(p,h))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};A=ye([Q(0,s.IProductService),Q(1,L.ILogService)],A),e.ExtensionUrlTrustService=A}),define(ee[230],te([0,1,7,5]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let s=class{constructor(R,k,f){this.a=R,this.b=k,this.c=f}async inspect(R){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.timeout)(R);const f=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};s=ye([Q(2,L.ILogService)],s),e.WindowProfiler=s}),define(ee[67],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,P.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,128,11]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class s{constructor(){this.a=new Map}add(R,k){P.ok(L.isString(R)),P.ok(L.isObject(k)),P.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,k)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new s}),define(ee[231],te([0,1,3,51]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function s(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this.b=new P.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,u){this.a[s(f)]=u,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;L.Registry.add(e.Extensions.JSONContribution,R)}),define(ee[68],te([0,1,26,3,11,159,19,231,51]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=f.Registry.as(k.Extensions.JSONContribution);class S{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.n(t,c,i),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.o(t,c),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.o(c,i),this.n(t,!1,i),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const i=[];for(const{overrides:n,source:o}of t)for(const l in n)if(c.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.a.get(l),m=a?.valuesSources??new Map;if(o)for(const $ of Object.keys(n[l]))m.set($,o);const D={...a?.value||{},...n[l]};this.a.set(l,{source:o,value:D,valuesSources:m});const M=(0,R.getLanguageTagSettingPlainKey)(l),T={type:"object",default:D,description:A.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:s.isString(o)?void 0:o,defaultValueSource:o};i.push(...b(l)),this.d[l]=T,this.b.properties[l]=T}else{this.a.set(l,{value:n[l],source:o});const a=this.d[l];a&&(this.w(l,a),this.r(l,a))}this.m(i)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:i,source:n}of t)for(const o in i){const l=this.a.get(o),a=s.isString(n)?n:n?.id,m=s.isString(l?.source)?l?.source:l?.source?.id;if(a===m)if(c.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.w(o,D),this.r(o,D))}}this.u()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,i){t.forEach(n=>{this.p(n,c,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,c){const i=n=>{if(n.properties)for(const o in n.properties){c.add(o);const l=this.d[o];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[o],this.s(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.c.indexOf(n);o!==-1&&this.c.splice(o,1)}}p(t,c=!0,i,n,o=3,l){o=s.isUndefinedOrNull(t.scope)?o:t.scope;const a=t.properties;if(a)for(const D in a){const M=a[D];if(c&&E(D,M)){delete a[D];continue}if(M.source=i,M.defaultDefaultValue=a[D].default,this.w(D,M),e.OVERRIDE_PROPERTY_REGEX.test(D)?M.scope=void 0:(M.scope=s.isUndefinedOrNull(M.scope)?o:M.scope,M.restricted=s.isUndefinedOrNull(M.restricted)?!!n?.includes(D):M.restricted),a[D].hasOwnProperty("included")&&!a[D].included){this.f[D]=a[D],delete a[D];continue}else this.d[D]=a[D],a[D].policy?.name&&this.e.set(a[D].policy.name,D);!a[D].deprecationMessage&&a[D].markdownDeprecationMessage&&(a[D].deprecationMessage=a[D].markdownDeprecationMessage),l.add(D)}const m=t.allOf;if(m)for(const D of m)this.p(D,c,i,n,o,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=i=>{const n=i.properties;if(n)for(const l in n)this.r(l,n[l]);i.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const i=this.a.get(t);let n=i?.value,o=i?.source;s.isUndefined(n)&&(n=c.defaultDefaultValue,o=void 0),s.isUndefined(n)&&(n=h(c.type)),c.default=n,c.defaultValueSource=o}}const d="\\[([^\\]]+)\\]",I=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let c=I.exec(C);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=I.exec(C)}}return(0,P.distinct)(t)}e.overrideIdentifiersFromKey=b;function r(C){return C.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=r;function h(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new S;f.Registry.add(e.Extensions.Configuration,g);function E(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?A.localize(7,null,C):g.getConfigurationProperties()[C]!==void 0?A.localize(8,null,C):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,C,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=E;function p(){const C=[],t=g.getConfigurationProperties();for(const c of Object.keys(t))C.push([c,t[c].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=p}),define(ee[114],te([0,1,26,3,43,2,35,37,11,8,19,68,51]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(c){return Object.isFrozen(c)?c:k.deepFreeze(c)}class I{constructor(i={},n=[],o=[],l){this.b=i,this.c=n,this.d=o,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof I)return n;const o=new b("");return o.parseRaw(n),o.configurationModel});this.f=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,w.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const o=this.rawConfiguration.getValue(i),l=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):o;return{value:o,override:l,merged:a}}getOverrideValue(i,n){const o=this.i(n);return o?i?(0,w.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return P.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return P.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=k.deepClone(this.contents),o=k.deepClone(this.overrides),l=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const m of i)if(a.push(...m.raw?.length?m.raw:[m]),!m.isEmpty()){this.h(n,m.contents);for(const D of m.overrides){const[M]=o.filter(T=>P.equals(T.identifiers,D.identifiers));M?(this.h(M.contents,D.contents),M.keys.push(...D.keys),M.keys=P.distinct(M.keys)):o.push(k.deepClone(D))}for(const D of m.keys)l.indexOf(D)===-1&&l.push(D)}return new I(n,l,o,a.every(m=>m instanceof I)?void 0:a)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const l of P.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[l];const m=n[l];m&&(typeof a=="object"&&typeof m=="object"?(a=k.deepClone(a),this.h(a,m)):a=m),o[l]=a}return new I(o,this.keys,this.overrides)}h(i,n){for(const o of Object.keys(n)){if(o in i&&f.isObject(i[o])&&f.isObject(n[o])){this.h(i[o],n[o]);continue}i[o]=k.deepClone(n[o])}}i(i){let n=null,o=null;const l=a=>{a&&(o?this.h(o,a):o=k.deepClone(a))};for(const a of this.overrides)P.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&l(a.contents);return l(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,w.removeFromValueTree)(this.contents,i),y.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>P.equals(o.identifiers,(0,y.overrideIdentifiersFromKey)(i))),1))}j(i,n,o){(0,w.addToValueTree)(this.contents,i,n,l=>console.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),y.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,w.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=I;class b{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!f.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:l,overrides:a,restricted:m,hasExcludedProperties:D}=this.h(i,n);this.b=new I(o,l,a,D?[i]:void 0),this.c=m||[]}g(i){let n={},o=null,l=[];const a=[],m=[];function D(T){Array.isArray(l)?l.push(T):o!==null&&(l[o]=T)}const M={onObjectBegin:()=>{const T={};D(T),a.push(l),l=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{l=a.pop()},onArrayBegin:()=>{const T=[];D(T),a.push(l),l=T,o=null},onArrayEnd:()=>{l=a.pop()},onLiteralValue:D,onError:(T,$,z)=>{m.push({error:T,offset:$,length:z})}};if(i)try{s.visit(i,M),n=l[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return n}h(i,n){const o=S.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,o,!0,n);i=l.raw;const a=(0,w.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),m=Object.keys(i),D=this.j(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:a,keys:m,overrides:D,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,n,o,l){let a=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const m={},D=[];for(const M in i)if(y.OVERRIDE_PROPERTY_REGEX.test(M)&&o){const T=this.i(i[M],n,!1,l);m[M]=T.raw,a=a||T.hasExcludedProperties,D.push(...T.restricted)}else{const T=n[M],$=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&D.push(M),($===void 0||l.scopes===void 0||l.scopes.includes($))&&!(l.skipRestricted&&T?.restricted)?m[M]=i[M]:a=!0}return{raw:m,restricted:D,hasExcludedProperties:a}}j(i,n){const o=[];for(const l of Object.keys(i))if(y.OVERRIDE_PROPERTY_REGEX.test(l)){const a={};for(const m in i[l])a[m]=i[l][m];o.push({identifiers:(0,y.overrideIdentifiersFromKey)(l),keys:Object.keys(a),contents:(0,w.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=b;class r extends A.Disposable{constructor(i,n,o,l){super(),this.f=i,this.g=n,this.h=l,this.c=this.D(new L.Emitter),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(o.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(L.Event.any(L.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class h{constructor(i,n,o,l,a,m,D,M,T,$,z,q,ie){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=l,this.d=a,this.f=m,this.g=D,this.h=M,this.i=T,this.j=$,this.k=z,this.l=q,this.m=ie}get value(){return d(this.c)}n(i,n,o){const l=i.inspect(n,o);return{get value(){return d(l.value)},get override(){return d(l.override)},get merged(){return d(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(i,n,o,l,a=new I,m=new I,D=new R.ResourceMap,M=new I,T=new R.ResourceMap){this.c=i,this.d=n,this.f=o,this.g=l,this.h=a,this.i=m,this.j=D,this.l=M,this.m=T,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(i,n,o){return this.q(i,n,o).getValue(i)}updateValue(i,n,o={}){let l;o.resource?(l=this.m.get(o.resource),l||(l=new I,this.m.set(o.resource,l))):l=this.l,n===void 0?l.removeValue(i):l.setValue(i,n),o.resource||(this.a=null)}inspect(i,n,o){const l=this.q(i,n,o),a=this.u(n.resource,o),m=n.resource?this.m.get(n.resource)||this.l:this.l,D=new Set;for(const M of l.overrides)for(const T of M.identifiers)l.getOverrideValue(i,T)!==void 0&&D.add(T);return new h(i,n,l.getValue(i),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,a||void 0,m)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:l,updated:a,removed:m}=C(this.c,i);n=[...l,...a,...m]}for(const l of n)for(const a of(0,y.overrideIdentifiersFromKey)(l)){const m=this.c.getKeysForOverrideIdentifier(a),D=i.getKeysForOverrideIdentifier(a),M=[...D.filter(T=>m.indexOf(T)===-1),...m.filter(T=>D.indexOf(T)===-1),...m.filter(T=>!k.equals(this.c.override(a).getValue(T),i.override(a).getValue(T)))];o.push([a,M])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:l}=C(this.d,i),a=[...n,...o,...l];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:l,overrides:a}=C(this.applicationConfiguration,i),m=[...n,...o,...l];return m.length&&this.updateApplicationConfiguration(i),{keys:m,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:a}=C(this.localUserConfiguration,i),m=[...n,...o,...l];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:a}=C(this.remoteUserConfiguration,i),m=[...n,...o,...l];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:l,overrides:a}=C(this.workspaceConfiguration,i),m=[...n,...o,...l];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const o=this.p.get(i),{added:l,updated:a,removed:m,overrides:D}=C(o,n),M=[...l,...a,...m];return(M.length||!o)&&this.updateFolderConfiguration(i,n),{keys:M,overrides:D}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:a,overrides:m}=C(n,void 0);return{keys:[...o,...l,...a],overrides:m}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,o){let l=this.r(n,o);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},n){let o=this.s();if(n&&i){const l=n.getFolder(i);l&&(o=this.t(l.uri)||o);const a=this.m.get(i);a&&(o=o.merge(a))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const o=this.s(),l=this.j.get(i);l?(n=o.merge(l),this.b.set(i,n)):n=o}return n}u(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:o,overrides:l,keys:a}=this.j.get(n);return i.push([n,{contents:o,overrides:l,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i){const n=this.x(i.defaults),o=this.x(i.policy),l=this.x(i.application),a=this.x(i.user),m=this.x(i.workspace),D=i.folders.reduce((M,T)=>(M.set(u.URI.revive(T[0]),this.x(T[1])),M),new R.ResourceMap);return new g(n,o,l,a,new I,m,D,new I,new R.ResourceMap)}static x(i){return new I(i.contents,i.keys,i.overrides)}}e.Configuration=g;function E(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,n=new Map;for(const l of c)l.keys.forEach(a=>i.add(a)),l.overrides.forEach(([a,m])=>{const D=(0,R.getOrSet)(n,a,new Set);m.forEach(M=>D.add(M))});const o=[];return n.forEach((l,a)=>o.push([a,[...l.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=E;class p{constructor(i,n,o,l){this.change=i,this.f=n,this.g=o,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const m of a)this.affectedKeys.add(m);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(i,n){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const a=l+o.length;if(a>=this.d.length)return!1;const m=this.d.charCodeAt(a);if(m!==this.b&&m!==this.c)return!1;if(n){const D=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,M=this.g.getValue(i,n,this.h);return!k.equals(D,M)}return!0}}e.ConfigurationChangeEvent=p;function C(c,i){const{added:n,removed:o,updated:l}=t(i?.rawConfiguration,c?.rawConfiguration),a=[],m=c?.getAllOverrideIdentifiers()||[],D=i?.getAllOverrideIdentifiers()||[];if(i){const M=D.filter(T=>!m.includes(T));for(const T of M)a.push([T,i.getKeysForOverrideIdentifier(T)])}if(c){const M=m.filter(T=>!D.includes(T));for(const T of M)a.push([T,c.getKeysForOverrideIdentifier(T)])}if(i&&c){for(const M of m)if(D.includes(M)){const T=t({contents:c.getOverrideValue(void 0,M)||{},keys:c.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});a.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:o,updated:l,overrides:a}}function t(c,i){const n=c?i?c.keys.filter(a=>i.keys.indexOf(a)===-1):[...c.keys]:[],o=i?c?i.keys.filter(a=>c.keys.indexOf(a)===-1):[...i.keys]:[],l=[];if(c&&i){for(const a of i.keys)if(c.keys.indexOf(a)!==-1){const m=(0,w.getConfigurationValue)(i.contents,a),D=(0,w.getConfigurationValue)(c.contents,a);k.equals(m,D)||l.push(a)}}return{added:n,removed:o,updated:l}}}),define(ee[232],te([0,1,26,3,2,37,11,114,68,5,38,51]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends s.Disposable{constructor(){super(...arguments),this.a=this.D(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(y.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:h})=>this.c(Array.from(r),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,h){this.h(r,y.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new k.ConfigurationModel;const r=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,h){const g=this.f();for(const E of r){const p=g[E],C=h[E];p!==void 0?this.b.addValue(E,p):C?this.b.addValue(E,C.default):this.b.removeValue(E)}}}e.DefaultConfiguration=S;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let I=class extends s.Disposable{get configurationModel(){return this.b}constructor(r,h,g){super(),this.c=r,this.f=h,this.g=g,this.a=this.D(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(r=>this.i(r))),this.D(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const h={},g=[],E=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const p of r){const C=E[p];if(!C){g.push(p);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}g.push(p),h[C.policy.name]={type:C.type}}}return(0,R.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),g}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const h=y.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),g=(0,P.coalesce)(r.map(E=>h.get(E)));this.j(g,!0)}j(r,h){this.g.trace("PolicyConfiguration#update",r);const g=y.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),E=[],p=this.b.isEmpty();for(const C of r){const t=g[C]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(p?c!==void 0:!(0,A.equals)(this.b.getValue(C),c))&&E.push([C,c])}else this.b.getValue(C)!==void 0&&E.push([C,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const C=this.b;this.b=new k.ConfigurationModel;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,c]of E)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);h&&this.a.fire(this.b)}}};I=ye([Q(1,w.IPolicyService),Q(2,u.ILogService)],I),e.PolicyConfiguration=I}),define(ee[233],te([0,1,7,3,2,18,19,114,232,38]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class w extends s.Disposable{constructor(S,d,I,b){super(),this.i=S,this.h=this.D(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new f.DefaultConfiguration),this.c=I instanceof u.NullPolicyService?new f.NullPolicyConfiguration:this.D(new f.PolicyConfiguration(this.b,I,b)),this.f=this.D(new k.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,d)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.D(new P.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:r,properties:h})=>this.k(r,h))),this.D(this.c.onDidChangeConfiguration(r=>this.l(r))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[S,d,I]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(S,d,new k.ConfigurationModel,I)}getConfigurationData(){return this.a.toData()}getValue(S,d){const I=typeof S=="string"?S:void 0,b=(0,R.isConfigurationOverrides)(S)?S:(0,R.isConfigurationOverrides)(d)?d:{};return this.a.getValue(I,b,void 0)}updateValue(S,d,I,b){return Promise.reject(new Error("not supported"))}inspect(S){return this.a.inspect(S,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const S=await this.f.loadConfiguration();this.j(S)}j(S){const d=this.a.toData(),I=this.a.compareAndUpdateLocalUserConfiguration(S);this.m(I,d,2)}k(S,d){const I=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(S,d);this.m(b,I,7)}l(S){const d=this.a.toData(),I=this.a.compareAndUpdatePolicyConfiguration(S);this.m(I,d,7)}m(S,d,I){const b=new k.ConfigurationChangeEvent(S,{data:d},this.a);b.source=I,b.sourceConfig=this.n(I),this.h.fire(b)}n(S){switch(S){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=w}),define(ee[234],te([0,1,13,6]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var s;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(s=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends P.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof A&&f._code===s.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof A&&f._code===s.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof A&&f._code===s.NoResolverFound}static isHandled(f){return f instanceof A&&f.isHandled}constructor(f,u=s.Unknown,w){super(f),this._message=f,this._code=u,this._detail=w,this.isHandled=u===s.NotAvailable&&w===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function R(k){const f=k.indexOf("+");return f===-1?k:k.substring(0,f)}e.getRemoteAuthorityPrefix=R}),define(ee[57],te([0,1,15]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(u){return u.scheme===P.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=L;function s(u){if(!u)return;const w=u.indexOf("+");return w<0?u:u.substr(0,w)}e.getRemoteName=s;function A(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=A;function R(u){const{host:w,port:y}=f(u);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:y}}e.parseAuthorityWithPort=R;function k(u,w){let{host:y,port:S}=f(u);return typeof S>"u"&&(S=w),{host:y,port:S}}e.parseAuthorityWithOptionalPort=k;function f(u){const w=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const S=u.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:u,port:void 0}}}),define(ee[115],te([0,1,25,6,57]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var k;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class f{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,h){if(typeof r>"u"||r===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof r=="string"||typeof h=="string"){const g=typeof r=="string"?r:r.value,E=typeof h=="string"?h:h.value;return P.equalsIgnoreCase(g,E)}return r.c===h.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=f;class u{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const h of r)this.add(h)}add(r){this.c.add(f.toKey(r))}delete(r){return this.c.delete(f.toKey(r))}has(r){return this.c.has(f.toKey(r))}}e.ExtensionIdentifierSet=u;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(f.toKey(r))}get(r){return this.c.get(f.toKey(r))}has(r){return this.c.has(f.toKey(r))}set(r,h){this.c.set(f.toKey(r),h)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=w;function y(b){return S(b)}e.isApplicationScopedExtension=y;function S(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function d(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function I(b,r){if(r){const h=`onResolveRemoteAuthority:${(0,s.getRemoteName)(r)}`;return!!b.activationEvents?.includes(h)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[235],te([0,1,7,17,22,13,3,2,64,74,31,105,234,57]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var b;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function r(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(O){const W=new s.CancellationTokenSource;return setTimeout(()=>W.cancel(),O),W.token}function g(O,W){if(O.isCancellationRequested||W.isCancellationRequested)return s.CancellationToken.Cancelled;const N=new s.CancellationTokenSource;return O.onCancellationRequested(()=>N.cancel()),W.onCancellationRequested(()=>N.cancel()),N.token}class E{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((N,G)=>{this.f=N,this.g=G}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function p(O,W){const N=new E(W);return N.registerDisposable(O.onControlMessage(G=>{const j=JSON.parse(G.toString()),B=V(j);B?N.reject(B):N.resolve(j)})),N.promise}function C(O,W,N,G,j,B,K,re,he){const ve=new E(he),Se=u.StopWatch.create(!1);return O.info(`Creating a socket (${re})...`),f.mark(`code/willCreateSocket/${K}`),W.connect(N,G,j,B,re,(Oe,Le)=>{ve.didTimeout?(f.mark(`code/didCreateSocketError/${K}`),O.info(`Creating a socket (${re}) finished after ${Se.elapsed()} ms, but this is too late and has timed out already.`),Oe&&O.error(Oe),Le?.dispose()):Oe||!Le?(f.mark(`code/didCreateSocketError/${K}`),O.info(`Creating a socket (${re}) returned an error after ${Se.elapsed()} ms.`),ve.reject(Oe)):(f.mark(`code/didCreateSocketOK/${K}`),O.info(`Creating a socket (${re}) was successful after ${Se.elapsed()} ms.`),ve.resolve(Le))}),ve.promise}function t(O,W){const N=new E(W);return O.then(G=>{N.didTimeout||N.resolve(G)},G=>{N.didTimeout||N.reject(G)}),N.promise}async function c(O,W,N,G){const j=U(O,W);O.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await C(O.logService,O.socketFactory,O.host,O.port,(0,d.getRemoteServerRootPath)(O),`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,r(W),`renderer-${r(W)}-${O.reconnectionToken}`,G)}catch(Se){throw O.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),O.logService.error(Se),Se}O.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let K,re;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(B,null),K=O.reconnectionProtocol,re=!1):(K=new y.PersistentProtocol({socket:B,measureRoundTripTime:!0}),re=!0),O.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const he=await t(O.signService.createNewMessage((0,w.generateUuid)()),G),ve={type:"auth",auth:O.connectionToken||"00000000000000000000",data:he.data};K.sendControl(L.VSBuffer.fromString(JSON.stringify(ve)));try{const Se=await p(K,g(G,h(1e4)));if(Se.type!=="sign"||typeof Se.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(O.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(O.signService.validate(he,Se.signedData),G)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const Le=await t(O.signService.sign(Se.data),G),Fe={type:"connectionType",commit:O.commit,signedData:Le,desiredConnectionType:W};return N&&(Fe.args=N),O.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(L.VSBuffer.fromString(JSON.stringify(Fe))),{protocol:K,ownsProtocol:re}}catch(Se){throw Se&&Se.code==="ETIMEDOUT"&&(O.logService.error(`${j} the handshake timed out. Error:`),O.logService.error(Se)),Se&&Se.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${j} received error control message when negotiating connection. Error:`),O.logService.error(Se)),re&&F(K),Se}}async function i(O,W,N,G){const j=Date.now(),B=U(O,W),{protocol:K,ownsProtocol:re}=await c(O,W,N,G),he=new E(G);return he.registerDisposable(K.onControlMessage(ve=>{const Se=JSON.parse(ve.toString()),Oe=V(Se);Oe?(O.logService.error(`${B} received error control message when negotiating connection. Error:`),O.logService.error(Oe),re&&F(K),he.reject(Oe)):(O.reconnectionProtocol?.endAcceptReconnection(),O.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${v(j)}!`),he.resolve({protocol:K,firstMessage:Se}))})),he.promise}async function n(O,W){const{protocol:N}=await i(O,1,void 0,W);return{protocol:N}}async function o(O,W,N){const{protocol:G,firstMessage:j}=await i(O,2,W,N),B=j&&j.debugPort;return{protocol:G,debugPort:B}}async function l(O,W,N){const G=Date.now(),j=U(O,3),{protocol:B}=await c(O,3,W,N);return O.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${v(G)}!`),B}async function a(O,W,N){const{host:G,port:j,connectionToken:B}=await O.addressProvider.getAddress();return{commit:O.commit,quality:O.quality,host:G,port:j,connectionToken:B,reconnectionToken:W,reconnectionProtocol:N,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function m(O,W,N){return M(O,async G=>{const{protocol:j}=await n(G,s.CancellationToken.None);return new Y(O,W,N,G.reconnectionToken,j)})}e.connectRemoteAgentManagement=m;async function D(O,W){return M(O,async N=>{const{protocol:G,debugPort:j}=await o(N,W,s.CancellationToken.None);return new H(O,W,N.reconnectionToken,G,j)})}e.connectRemoteAgentExtensionHost=D;async function M(O,W){for(let G=1;;G++)try{const j=(0,w.generateUuid)(),B=await a(O,j,null);return await W(B)}catch(j){if(G<5)O.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),O.logService.error(j);else throw O.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),O.logService.error(j),J.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(j)),j}}async function T(O,W,N){const G=await a(O,(0,w.generateUuid)(),null);return await l(G,{host:W,port:N},s.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function $(O){return(0,P.createCancelablePromise)(W=>new Promise((N,G)=>{const j=setTimeout(N,O*1e3);W.onCancellationRequested(()=>{clearTimeout(j),N()})}))}var z;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain",O[O.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class q{constructor(W,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=q;class ie{constructor(W,N,G,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.durationSeconds=G,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ie;class oe{constructor(W,N,G){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=oe;class ae{constructor(W,N,G){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=G,this.type=4}}e.ConnectionGainEvent=ae;class de{constructor(W,N){this.reconnectionToken=W,this.connectionHealth=N,this.type=5}}e.ConnectionHealthChangedEvent=de;class ce{constructor(W,N,G,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=G,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class J extends k.Disposable{static triggerPermanentFailure(W,N,G){this._permanentFailure=!0,this.f=W,this.g=N,this.h=G,this.i.forEach(j=>j.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(W=>W.r())}static debugPauseSocketWriting(){this.i.forEach(W=>W.v())}get k(){return this.c||J._permanentFailure}constructor(W,N,G,j,B){super(),this.n=W,this.p=N,this.reconnectionToken=G,this.protocol=j,this.q=B,this.j=this.D(new R.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ae(this.reconnectionToken,0,0)),this.D(j.onSocketClose(K=>{const re=se(this.n,this.reconnectionToken,!0);K?K.type===0?(this.p.logService.info(`${re} received socket close event (hadError: ${K.hadError}).`),K.error&&this.p.logService.error(K.error)):(this.p.logService.info(`${re} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this.p.logService.error(K.event)):this.p.logService.info(`${re} received socket close event.`),this.r()})),this.D(j.onSocketTimeout(K=>{const re=se(this.n,this.reconnectionToken,!0);this.p.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${K.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${K.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${K.timeSinceLastReceivedSomeData}).`),this.r()})),this.D(j.onHighRoundTripTime(K=>{const re=ne(this.n,this.reconnectionToken);this.p.logService.info(`${re} high roundtrip time: ${K.roundTripTime}ms (${K.recentHighRoundTripCount} of ${5} recent samples)`)})),this.D(j.onDidChangeConnectionHealth(K=>{this.j.fire(new de(this.reconnectionToken,K))})),J.i.push(this),this.D((0,k.toDisposable)(()=>{const K=J.i.indexOf(this);K>=0&&J.i.splice(K,1)})),this.k&&this.u(J.f,J.g,J.h)}dispose(){super.dispose(),this.m=!0}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k||this.m)return;const W=se(this.n,this.reconnectionToken,!0);this.p.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const j=G<N.length?N[G]:N[N.length-1];try{if(j>0){const K=$(j);this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,K)),this.p.logService.info(`${W} waiting for ${j} seconds before reconnecting...`);try{await K}catch{}}if(this.k){this.p.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.p.logService.info(`${W} resolving connection...`);const B=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${W} connecting to ${B.host}:${B.port}...`),await this.w(B,h(I)),this.p.logService.info(`${W} reconnected!`),this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.p.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this.p.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.p.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(B);continue}if((0,A.isCancellationError)(B)){this.p.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(B);continue}if(B instanceof S.RemoteAuthorityResolverError){this.p.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,S.RemoteAuthorityResolverError.isHandled(B));break}this.p.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k&&!this.m)}t(W,N,G){this.q?J.triggerPermanentFailure(W,N,G):this.u(W,N,G)}u(W,N,G){this.j.fire(new ce(this.reconnectionToken,W,N,G)),F(this.protocol)}v(){this.protocol.pauseSocketWriting()}}J._permanentFailure=!1,J.f=0,J.g=0,J.h=!1,J.i=[],e.PersistentConnection=J;class Y extends J{constructor(W,N,G,j,B){super(1,W,j,B,!0),this.client=this.D(new y.Client(B,{remoteAuthority:N,clientId:G},W.ipcLogger))}async w(W,N){await n(W,N)}}e.ManagementPersistentConnection=Y;class H extends J{constructor(W,N,G,j,B){super(2,W,G,j,!1),this.y=N,this.debugPort=B}async w(W,N){await o(W,this.y,N)}}e.ExtensionHostPersistentConnection=H;function F(O){try{O.acceptDisconnect();const W=O.getSocket();O.dispose(),W.dispose()}catch(W){(0,A.onUnexpectedError)(W)}}function V(O){if(O&&O.type==="error"){const W=new Error(`Connection error: ${O.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Z(O,W){for(;O.length<W;)O+=" ";return O}function ne(O,W){return`[remote-connection][${Z(r(O),13)}][${W.substr(0,5)}\u2026]`}function se(O,W,N){return`${ne(O,W)}[${N?"reconnect":"initial"}]`}function U(O,W){return`${se(W,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function v(O){return`${Date.now()-O} ms`}}),define(ee[236],te([0,1,84,88]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(s,A,R,k,f,u){const w=S=>u(S,void 0),y=P.createConnection({host:s,port:A},()=>{y.removeListener("error",w);const S=Buffer.alloc(16);for(let r=0;r<16;r++)S[r]=Math.round(Math.random()*256);const d=S.toString("base64"),I=[`GET ws://${/:/.test(s)?`[${s}]`:s}:${A}${R}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];y.write(I.join(`\r
`)+`\r
\r
`);const b=r=>{r.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",b),u(void 0,new L.NodeSocket(y,f)))};y.on("data",b)});y.setNoDelay(!0),y.once("error",w)}}}),define(ee[237],te([0,1,27,46,41,196]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function k(d=!1){return(R===void 0||d)&&(R=f()),R}e.hasWSLFeatureInstalled=k;async function f(){const d=u();if(d===void 0)return!1;if(d>=22e3){const I=y();if(I)return new Promise(b=>{L.execFile(I,["--status"],r=>b(!r))})}else{const I=S();if(I)try{if((await s.promises.stat(I)).isFile())return!0}catch{}}return!1}function u(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(d)return parseInt(d[3])}function w(d){const I=process.env.SystemRoot;if(I){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(I,b?"Sysnative":"System32",d)}}function y(){return w("wsl.exe")}function S(){return w("lxss\\LxssManager.dll")}}),define(ee[52],te([0,1,17,13,2,179,68,6,5,51]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class w{constructor(C){this.b=C}toJSON(){if(!this.a){const C=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?C[t]="*****":C[t]=this.b[t];this.a=C}return this.a}}class y extends s.Disposable{constructor(C,t){super(),this.b=0,this.a=t.createLogger(C?"remotenetwork":"network",{name:C?(0,A.localize)(0,null):(0,A.localize)(1,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async c(C,t,c){const i=`${C} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new w(t.headers??{}));try{const n=await c();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,L.getErrorMessage)(n)),n}}}e.AbstractRequestService=y;function S(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=S;function d(p){return p.res.statusCode===204}async function I(p){return d(p)?null:(await(0,P.streamToBuffer)(p.stream)).toString()}e.asText=I;async function b(p){if(!S(p))throw new Error("Server returned "+p.res.statusCode);return I(p)}e.asTextOrError=b;async function r(p){if(!S(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,P.streamToBuffer)(p.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}e.asJson=r;function h(p){E(p)}e.updateProxyConfigurationsScope=h;let g;function E(p){const C=u.Registry.as(R.Extensions.Configuration),t=g;g={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},C.updateConfigurations({add:[g],remove:t?[t]:[]})}E(2)}),define(ee[238],te([0,1,17,22]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class s{constructor(k){this.a=k}listen(k,f){throw new Error("Invalid listen")}call(k,f,u,w=L.CancellationToken.None){switch(f){case"request":return this.a.request(u[0],w).then(async({res:y,stream:S})=>{const d=await(0,P.streamToBuffer)(S);return[{statusCode:y.statusCode,headers:y.headers},d]});case"resolveProxy":return this.a.resolveProxy(u[0])}throw new Error("Invalid call")}}e.RequestChannel=s;class A{constructor(k){this.a=k}async request(k,f){const[u,w]=await this.a.call("request",[k],f);return{res:u,stream:(0,P.bufferToStream)(w)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=A}),define(ee[239],te([0,1,240,11]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function s(R,k){return R.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:R.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function A(R,k,f={}){const u=(0,P.parse)(R),w=f.proxyUrl||s(u,k);if(!w)return null;const y=(0,P.parse)(w);if(!/^https?:$/.test(y.protocol||""))return null;const S={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((d,I)=>{x(["http-proxy-agent"],d,I)}))(S):new(await new Promise((d,I)=>{x(["https-proxy-agent"],d,I)}))(S)}e.getProxyAgent=A}),define(ee[116],te([0,1,46,9,180,22,44,13,4,31,153,62,7,132]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let I;async function b(h,g,E,p){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(p)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(p)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=S.Promises.withAsyncBody(async(C,t)=>{const c=new A.CancellationTokenSource;let i=1e4;const n=h.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.clamp)(n,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),t(new Error((0,s.localize)(0,null)))},i);try{C(await r(g,c.token))}catch(l){!(0,k.isCancellationError)(l)&&!c.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,R.toErrorMessage)(l)))):C({})}finally{clearTimeout(o),c.dispose()}})),I)}e.getResolvedShellEnv=b;async function r(h,g){const E=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",E);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const C=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",c);const i=await(0,w.getSystemShell)(f.OS,c);return h.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(g.isCancellationRequested)return o(new k.CancellationError);const l=(0,L.basename)(i);let a,m;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${D} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,m=["-Login","-Command"]):(a=`'${process.execPath}' ${D} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,l==="tcsh"||l==="csh"?m=["-ic"]:m=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),a);const M=(0,P.spawn)(i,[...m,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});g.onCancellationRequested(()=>(M.kill(),o(new k.CancellationError))),M.on("error",z=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(z)),o(z)});const T=[];M.stdout.on("data",z=>T.push(z));const $=[];M.stderr.on("data",z=>$.push(z)),M.on("close",(z,q)=>{const ie=Buffer.concat(T).toString("utf8");h.trace("getUnixShellEnvironment#raw",ie);const oe=Buffer.concat($).toString("utf8");if(oe.trim()&&h.trace("getUnixShellEnvironment#stderr",oe),z||q)return o(new Error((0,s.localize)(2,null,z,q)));const ae=t.exec(ie),de=ae?ae[1]:"{}";try{const ce=JSON.parse(de);E?ce.ELECTRON_RUN_AS_NODE=E:delete ce.ELECTRON_RUN_AS_NODE,p?ce.ELECTRON_NO_ATTACH_CONSOLE=p:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){h.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ce)),o(ce)}})})}}),define(ee[93],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[241],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class P{constructor(){this.b=new Map}c(){return new Promise((s,A)=>x(["vsda"],s,A))}async createNewMessage(s){try{const A=await this.c(),R=new A.validator;if(R){const k=String(P.a++);return this.b.set(k,R),{id:k,data:R.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,A){if(!s.id)return!0;const R=this.b.get(s.id);if(!R)return!1;this.b.delete(s.id);try{return R.validate(A)==="ok"}catch{return!1}}async sign(s){try{const A=await this.c(),R=new A.signer;if(R)return R.sign(s)}catch{}return s}}P.a=1,e.SignService=P}),define(ee[33],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,P.createDecorator)("stateReadService"),e.IStateService=(0,P.createDecorator)("stateService")}),define(ee[20],te([0,1,14,42,7,3,2,4,36,11,6,5,33,28]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var I;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(I=e.ShutdownReason||(e.ShutdownReason={}));var b;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(b=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let r=class dt extends R.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(g,E,p){super(),this.u=g,this.v=E,this.w=p,this.c=this.D(new A.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.D(new A.Emitter),this.onWillShutdown=this.f.event,this.g=this.D(new A.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.D(new A.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.q=void 0,this.r=void 0,this.s=new Map,this.t=new Map,this.y(),this.when(2).then(()=>this.z())}y(){this.j=!!this.v.getItem(dt.b),this.j&&this.v.removeItem(dt.b)}z(){const g=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.C(1))};P.app.addListener("before-quit",g);const E=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",p=>{this.L("Lifecycle#app.on(will-quit) - begin"),p.preventDefault(),this.C(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),P.app.removeListener("before-quit",g),P.app.removeListener("window-all-closed",E),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}C(g){if(this.r)return this.r;const E=this.u;this.L("Lifecycle#onWillShutdown.fire()");const p=[];return this.f.fire({reason:g,join(C,t){E.trace(`Lifecycle#onWillShutdown - begin '${C}'`),p.push(t.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${C}'`)}))}}),this.r=(async()=>{try{await s.Promises.settled(p)}catch(C){this.u.error(C)}try{await this.v.close()}catch(C){this.u.error(C)}})(),this.r}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===g)return;this.L(`lifecycle (main): phase changed (value: ${g})`),this.k=g;const E=this.t.get(this.k);E&&(E.open(),this.t.delete(this.k))}async when(g){if(g<=this.k)return;let E=this.t.get(g);E||(E=new s.Barrier,this.t.set(g,E)),await E.wait()}registerWindow(g){const E=new R.DisposableStore;this.n++,E.add(g.onWillLoad(C=>this.g.fire({window:g,workspace:C.workspace,reason:C.reason})));const p=(0,u.assertIsDefined)(g.win);p.on("close",C=>{const t=g.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${g.id}`),C.preventDefault(),this.unload(g,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(g),g.close()})}),p.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.n--,E.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.C(1)})}async reload(g,E){await this.unload(g,3)||g.reload(E)}unload(g,E){const p=this.s.get(g.id);if(p)return p;const C=this.F(g,E).finally(()=>{this.s.delete(g.id)});return this.s.set(g.id,C),C}async F(g,E){if(!g.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${g.id}`);const p=this.i?2:E,C=await this.I(g,p);return C?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.G(C)):(await this.J(g,p),!1)}G(g){return g?(this.H(!0),this.i=!1,!0):!1}H(g){this.q&&(this.q(g),this.q=void 0,this.p=void 0)}I(g,E){return new Promise(p=>{const C=this.m++,t=`vscode:ok${C}`,c=`vscode:cancel${C}`;L.validatedIpcMain.once(t,()=>{p(!1)}),L.validatedIpcMain.once(c,()=>{p(!0)}),g.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:E})})}J(g,E){return new Promise(p=>{const t=`vscode:reply${this.m++}`;L.validatedIpcMain.once(t,()=>p()),g.send("vscode:onWillUnload",{replyChannel:t,reason:E})})}quit(g){return this.L(`Lifecycle#quit() - begin (willRestart: ${g})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(g&&this.v.setItem(dt.b,!0),this.p=new Promise(E=>{this.q=E,this.L("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.p)}L(g){this.w.args["enable-smoke-test-driver"]?this.u.info(g):this.u.trace(g)}async relaunch(g){this.L("Lifecycle#relaunch()");const E=process.argv.slice(1);if(g?.addArgs&&E.push(...g.addArgs),g?.removeArgs)for(const t of g.removeArgs){const c=E.indexOf(t);c>=0&&E.splice(c,1)}const p=()=>{try{if(k.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.u.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E})};P.app.once("quit",p),await this.quit(!0)&&P.app.removeListener("quit",p)}async kill(g){this.L("Lifecycle#kill()"),await this.C(2),await Promise.race([(0,s.timeout)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let p;E.webContents&&!E.webContents.isDestroyed()?p=new Promise(C=>E.once("closed",C)):p=Promise.resolve(),E.destroy(),await p}})()]),P.app.exit(g)}};r.b="lifecycle.quitAndRestart",r=ye([Q(0,y.ILogService),Q(1,S.IStateService),Q(2,d.IEnvironmentMainService)],r),e.LifecycleMainService=r}),define(ee[242],te([0,1,4,3,2,6,20]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let k=class extends s.Disposable{constructor(w){super(),this.a=this.D(new L.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,w.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const w=await new Promise((y,S)=>{x(["native-keymap"],y,S)});this.c=f(w),P.isCI||w.onDidChangeKeyboardLayout(()=>{this.c=f(w),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ye([Q(0,R.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function f(u){const w=u.getKeyMap(),y=u.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:y}}}),define(ee[117],te([0,1,7,17,11,34,16,5]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var f;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(f=e.SaveStrategy||(e.SaveStrategy={}));class u{constructor(d,I,b,r){this.f=d,this.g=b,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=I===0?void 0:new P.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,I){const b=this.a[d];return(0,s.isUndefinedOrNull)(b)?I:b}setItem(d,I){this.setItems([{key:d,data:I}])}setItems(d){let I=!1;for(const{key:b,data:r}of d)this.a[b]!==r&&((0,s.isUndefinedOrNull)(r)?(0,s.isUndefined)(this.a[b])||(this.a[b]=void 0,I=!0):(this.a[b]=r,I=!0));I&&this.j()}removeItem(d){(0,s.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(d)),this.b=d}catch(I){this.g.error(I)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=u;let w=class{constructor(d,I,b,r){this.a=new u(I.stateResource,d,b,r)}async init(){await this.a.init()}getItem(d,I){return this.a.getItem(d,I)}};w=ye([Q(1,A.IEnvironmentService),Q(2,k.ILogService),Q(3,R.IFileService)],w),e.StateReadonlyService=w;class y extends w{setItem(d,I){this.a.setItem(d,I)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=y}),define(ee[94],te([0,1,4,36,8,31]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(u){if(P.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function k(u,w,y,S,d,I,b,r,h,g){const E=Object.create(null);E["common.machineId"]=b,E.sessionID=(0,A.generateUuid)()+Date.now(),E.commitHash=d,E.version=I,E["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,P.PlatformToString)(P.platform),E["common.nodePlatform"]=L.platform,E["common.nodeArch"]=S,E["common.product"]=g||"desktop",r&&(E["common.msftInternal"]=r);let p=0;const C=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-C,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),P.isLinuxSnap&&(E["common.snap"]="true");const t=R(y);t&&(E["common.platformDetail"]=t);try{const c=await u.readFile(s.URI.file(h));E["common.source"]=c.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=k;function f(u){const w=L.env.USERDNSDOMAIN;if(!w)return!1;const y=w.toLowerCase();return u.some(S=>y===S)}e.verifyMicrosoftInternalDomain=f}),define(ee[24],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var s;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(s=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[243],te([0,1,27,7,43,15,9,4,8,86,23,104,89,16,21,24]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function h(t,c){const i=`${t}::${c.join(":")}`,n=r.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,a=new Map,m=2e4;function D(T,$,z,q){const ie=$.substring(T.length+1);return L.Promises.withAsyncBody(async oe=>{let ae;try{ae=await w.Promises.readdir($,{withFileTypes:!0})}catch{oe();return}if(q.count>=m){q.count+=ae.length,q.maxReached=!0,oe();return}let de=ae.length;if(de===0){oe();return}let ce=ae;q.count+ae.length>m&&(q.maxReached=!0,de=m-q.count,ce=ae.slice(0,de)),q.count+=ae.length;for(const J of ce)if(J.isDirectory()){if(z.includes(J.name)||await D(T,(0,R.join)($,J.name),z,q),--de===0){oe();return}}else{const Y=J.name.lastIndexOf(".");if(Y>=0){const H=J.name.substring(Y+1);H&&l.set(H,(l.get(H)??0)+1)}for(const H of o)H.relativePathPattern?.test(ie)!==!1&&H.filePattern.test(J.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--de===0){oe();return}}})}const M=L.Promises.withAsyncBody(async T=>{const $={count:0,maxReached:!1};await D(t,t,c,$);const z=await p(t);T({configFiles:g(a),fileTypes:g(l),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:z})});return r.set(i,M),M}e.collectWorkspaceStats=h;function g(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function E(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.virtualMachineHint.value()*100)}%`},c=P.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=E;async function p(t){try{const c=new Map,i=(0,R.join)(t,".vscode","launch.json"),n=await w.Promises.readFile(i),o=[],l=(0,s.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,s.getNodeType)(l)==="object"&&l.configurations)for(const a of l.configurations){const m=a.type;m&&(c.has(m)?c.set(m,c.get(m)+1):c.set(m,1))}return g(c)}catch{return[]}}e.collectLaunchConfigs=p;let C=class{constructor(c,i){this.c=c,this.d=i}f(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}g(c){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${P.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(u.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,y.listProcesses)(c.mainPID),this.k(c)]).then(async n=>{let[o,l]=n,a=this.m(c,o);return i.forEach(m=>{if((0,S.isRemoteDiagnosticError)(m))a+=`
${m.errorMessage}`,l+=`
${m.errorMessage}`;else if(a+=`

Remote: ${m.hostName}`,m.processes&&(a+=`
${this.m(c,m.processes)}`),m.workspaceMetadata){l+=`
|  Remote: ${m.hostName}`;for(const D of Object.keys(m.workspaceMetadata)){const M=m.workspaceMetadata[D];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),l+=`|    Folder (${D}): ${T}`,l+=this.h(M)}}}),{processInfo:a,workspaceInfo:l}})}async getSystemInfo(c,i){const{memory:n,vmHint:o,os:l,cpus:a}=E(),m={os:l,memory:n,cpus:a,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(m.load=`${P.loadavg().map(D=>Math.round(D)).join(", ")}`),k.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(c,i){const n=[];return(0,y.listProcesses)(c.mainPID).then(async o=>(n.push(""),n.push(this.g(c)),n.push(""),n.push(this.m(c,o)),c.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(c))),i.forEach(l=>{if((0,S.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.f(l.machineInfo)),l.processes&&n.push(this.m(c,l.processes)),l.workspaceMetadata)for(const a of Object.keys(l.workspaceMetadata)){const m=l.workspaceMetadata[a];let D=`${m.fileCount} files`;m.maxFilesReached&&(D=`more than ${D}`),n.push(`Folder (${a}): ${D}`),n.push(this.h(m))}}),n.push(""),n.push(""),n.join(`
`)))}h(c){const i=[];let o=0;const l=(M,T)=>{const $=` ${M}(${T})`;o+$.length>60?(i.push(a),a="|                 ",o=a.length):o+=$.length,a+=$};let a="|      File types:";const m=10,D=c.fileTypes.length>m?m:c.fileTypes.length;for(let M=0;M<D;M++){const T=c.fileTypes[M];l(T.name,T.count)}if(i.push(a),c.configFiles.length>=0&&(a="|      Conf files:",o=0,c.configFiles.forEach(M=>{l(M.name,M.count)}),i.push(a)),c.launchConfigFiles.length>0){let M="|      Launch Configs:";c.launchConfigFiles.forEach(T=>{M+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(M)}return i.join(`
`)}j(c){const i=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${c[n]}`).join(`
                  `)}k(c){const i=[],n=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const a=f.URI.revive(l);if(a.scheme===A.Schemas.file){const m=a.fsPath;n.push(h(m,["node_modules",".git"]).then(D=>{let M=`${D.fileCount} files`;D.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,R.basename)(m)}): ${M}`),i.push(this.h(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${m} (${D.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(c,i){const n=new Map;c.windows.forEach(l=>n.set(l.pid,`window [${l.id}] (${l.title})`)),c.pidToNames.forEach(({pid:l,name:a})=>n.set(l,a));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(c.mainPID,n,o,i,0),o.join(`
`)}n(c,i,n,o,l){const a=l===0;let m;a?m=o.pid===c?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?m=i.get(o.pid):m=`${"  ".repeat(l)} ${o.name}`;const D=process.platform==="win32"?o.mem:P.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(o.children)&&o.children.forEach(M=>this.n(c,i,n,M,l+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:n}of c.folders){const o=f.URI.revive(n);if(o.scheme!==A.Schemas.file)continue;const l=o.fsPath;try{(await h(l,["node_modules",".git"])).fileTypes.forEach(m=>i.add(m.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const n=f.URI.revive(i);if(n.scheme!==A.Schemas.file)continue;const o=n.fsPath;try{const l=await h(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),l.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),l.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),l.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};C=ye([Q(0,b.ITelemetryService),Q(1,I.IProductService)],C),e.DiagnosticsService=C}),define(ee[244],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class P{constructor(A){this.b=A}listen(A,R){throw new Error(`Event not found: ${R}`)}call(A,R,{eventName:k,data:f}){return this.b.forEach(u=>u.log(k,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=P;class L{constructor(A){this.b=A}log(A,R){return this.b.call("log",{eventName:A,data:R}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[48],te([0,1,37,11,3,19,57,94,24]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(o){this.value=o}}e.TelemetryTrustedValue=u;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,l){return Promise.resolve(void 0)}publicLog2(o,l){return this.publicLog(o,l)}publicLogError(o,l){return Promise.resolve(void 0)}publicLogError2(o,l){return this.publicLogError(o,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class y{async publicLog(o,l,a){}async publicLogError(o,l,a){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(n,o){return s.Event.debounce(o.onDidChangeConfiguration,(a,m)=>{const D=a?new Set([...a.affectedKeys,...m.affectedKeys]):m.affectedKeys;return{...m,affectedKeys:D}},1e3,!0)(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=S;function d(n,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!n.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=d;function I(n,o){return!(o.isBuilt||o.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=I;function b(n){const o=n.getValue(f.TELEMETRY_SETTING_ID),l=n.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function r(n){const o={},l={},a={};E(n,a);for(let m in a){m=m.length>150?m.substr(m.length-149):m;const D=a[m];typeof D=="number"?l[m]=D:typeof D=="boolean"?l[m]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${D.length}`),o[m]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(o[m]=D)}return{properties:o,measurements:l}}e.validateTelemetryData=r;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(n){if(!n)return"none";const o=(0,R.getRemoteName)(n);return h.has(o)?o:"other"}e.cleanRemoteAuthority=g;function E(n,o,l=0,a){if(!!n)for(const m of Object.getOwnPropertyNames(n)){const D=n[m],M=a?a+m:m;Array.isArray(D)?o[M]=(0,P.safeStringify)(D):D instanceof Date?o[M]=D.toISOString():(0,L.isObject)(D)?l<2?E(D,o,l+1,M+"."):o[M]=(0,P.safeStringify)(D):o[M]=D}}function p(n,o){const l=n.msftInternalDomains||[],a=o.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(l)||a}e.isInternalTelemetry=p;function C(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=C;function t(n,o){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let l=n;const a=[];for(const T of o)for(;;){const $=T.exec(n);if(!$)break;a.push([$.index,T.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(l="";;){const T=D.exec(n);if(!T)break;const $=a.some(([z,q])=>T.index<q&&z<D.lastIndex);!m.test(T[0])&&!$&&(l+=n.substring(M,T.index)+"<REDACTED: user-file-path>",M=D.lastIndex)}return M<n.length&&(l+=n.substr(M)),l}function c(n){if(!n)return n;const o=n.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of l)if(a.regex.test(o))return`<REDACTED: ${a.label}>`;return n}function i(n,o){return(0,P.cloneAndChange)(n,l=>{if(l instanceof u)return l.value;if(typeof l=="string"){let a=l.replaceAll("%20"," ");a=t(a,o);for(const m of o)a=a.replace(m,"");return a=c(a),a}})}e.cleanData=i}),define(ee[118],te([0,1,25,111,115,4,8,13,36,48]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,P.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=w;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(n){const o=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new S(n.identifier,o,l)}static parse(n){const o=y.exec(n);return o&&o[1]&&o[2]?new S({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,l="undefined"){this.version=o,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof S?w(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=S;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(i){const n=d.exec(i);return n&&n[1]?[r(n[1]),n[2]]:[r(i),void 0]}e.getIdAndVersion=I;function b(i,n){return`${i}.${n}`}e.getExtensionId=b;function r(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function h(i,n){return r(b(i??s.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=h;function g(i,n){const o=[],l=a=>{for(const m of o)if(m.some(D=>w(n(D),n(a))))return m;return null};for(const a of i){const m=l(a);m?m.push(a):o.push([a])}return o}e.groupByExtension=g;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function p(i){return{id:new u.TelemetryTrustedValue(i.identifier.id),name:new u.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new s.ExtensionIdentifier("pprice.better-merge");function C(i,n){const o=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const a=l.shift();if(a&&o.every(m=>!w(m.identifier,{id:a}))){const m=i.filter(D=>w(D.identifier,{id:a}));m.length===1&&(o.push(m[0]),l.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=C;async function t(i,n){if(!A.isLinux)return!1;let o;try{o=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(a))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(i,n){const o=await t(i,n),l=(0,L.getTargetPlatform)(o?"alpine":A.platform,f.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=c}),define(ee[245],te([0,1,201,48]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function s(A,R,k,f,u,w,y){const S={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,L.supportsTelemetry)(R,k)&&(0,L.getTelemetryLevel)(f)===3){const d=await(0,P.getServiceMachineId)(k,u,w),{machineId:I}=await y.getTelemetryInfo();S["X-Market-User-Id"]=d,S["VSCode-SessionId"]=I||d}return S}e.resolveMarketplaceHeaders=s}),define(ee[246],te([0,1,13,37,48]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(u,w,y){const S=await new Promise((h,g)=>{x(["@microsoft/1ds-core-js"],h,g)}),d=await new Promise((h,g)=>{x(["@microsoft/1ds-post-js"],h,g)}),I=new S.AppInsightsCore,b=new d.PostChannel,r={instrumentationKey:u,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(y){r.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:y};r.extensionConfig[b.identifier]=h}return I.initialize(r,[]),I.addTelemetryInitializer(h=>{w&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),I}class f{constructor(w,y,S,d,I){this.e=w,this.f=y,this.g=S,this.h=I,this.c=A,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(w){if(!!this.a){if(typeof this.a!="string"){w(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(y=>{w(y)},y=>{(0,P.onUnexpectedError)(y),console.error(y)})}}log(w,y){if(!this.a)return;y=(0,L.mixin)(y,this.g),y=(0,s.validateTelemetryData)(y);const S=this.f+"/"+w;try{this.i(d=>{d.pluginVersionString=y?.properties.version??"Unknown",d.track({name:S,baseData:{name:S,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(w=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ee[119],te([0,1,2,37,4,25,181,19,68,66,21,51,24,48]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(h,g,E){this.k=g,this.l=E,this.d={},this.i=new P.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(S.TELEMETRY_SETTING_ID)||p.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,d.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const E=g.usage?3:g.error?2:0;h=Math.min(h,E)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,g=h.sessionID,E=h["common.machineId"],p=h["common.firstSessionDate"],C=h["common.msftInternal"];return{sessionId:g,machineId:E,firstSessionDate:p,msftInternal:C}}dispose(){this.i.dispose()}n(h,g,E){return this.g<g?Promise.resolve(void 0):this.c.then(p=>{E=(0,L.mixin)(E,this.d),E=(0,d.cleanData)(E,this.j),E=(0,L.mixin)(E,p),this.b.forEach(C=>C.log(h,E))},p=>{console.error(p)})}publicLog(h,g){return this.n(h,3,g)}publicLog2(h,g){return this.publicLog(h,g)}publicLogError(h,g){return this.h?this.n(h,2,g):Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=ye([Q(1,k.IConfigurationService),Q(2,w.IProductService)],I),e.TelemetryService=I;function b(){const r=(0,R.localize)(0,null,u.default.nameLong),h=u.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=s.isWeb?"":(0,R.localize)(3,null),E=(0,R.localize)(4,null),p=(0,R.localize)(5,null),C=(0,R.localize)(6,null),t=(0,R.localize)(7,null),c=`
|       | ${E} | ${p} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${r} ${h} ${g}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}y.Registry.as(f.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(f.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,R.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,R.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[247],te([0,1,295,246]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class s extends L.AbstractOneDataSystemAppender{constructor(R,k,f,u){const w={sendPOST:(y,S)=>{const d={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const I=P.request(y.urlString,d,b=>{b.on("data",function(r){S(b.statusCode??200,b.headers,r.toString())}),b.on("error",function(r){S(0,{})})});I.write(y.data),I.end()}catch{S(0,{})}}};super(R,k,f,u,w)}}e.OneDataSystemAppender=s}),define(ee[248],te([0,1,4,86,24]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(R){let k=R.getItem(s.machineIdKey);return(typeof k!="string"||P.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,L.getMachineId)()),k}e.resolveMachineId=A}),define(ee[120],te([0,1,24,248]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function s(A){const R=await(0,L.resolveMachineId)(A);return A.setItem(P.machineIdKey,R),R}e.resolveMachineId=s}),define(ee[69],te([0,1,14,3,2,4,19,6,33]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const u="#FFFFFF",w="#1E1E1E",y="#000000",S="#FFFFFF",d="theme",I="themeBackground",b="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let r=class extends s.Disposable{constructor(g,E){super(),this.b=g,this.c=E,this.a=this.D(new L.Emitter),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return g.dark?y:S;let E=this.b.getItem(I,null);if(!E)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":E=u;break;case"hc-black":E=y;break;case"hc-light":E=S;break;default:E=w}return A.isMacintosh&&E.toUpperCase()===w&&(E="#171717"),E}saveWindowSplash(g,E){this.b.setItems([{key:d,data:E.baseTheme},{key:I,data:E.colorInfo.background},{key:b,data:E}]),typeof g=="number"&&this.f(g,E)}f(g,E){for(const p of P.BrowserWindow.getAllWindows())if(p.id===g){p.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};r=ye([Q(0,f.IStateService),Q(1,R.IConfigurationService)],r),e.ThemeMainService=r}),define(ee[121],te([0,1,3,19,6,5]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,s.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,s.createDecorator)("sharedTunnelsService");var R;(function(b){b.Http="http",b.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function u(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=u,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=y;function S(b,r,h,g){if(h===1)return!1;if(h===2&&y(r)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return b<1024}e.isPortPrivileged=S;class d{constructor(r,h,g){this.remoteAddress=r,this.localAddress=h,this.b=g,this.a=new P.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let I=class{constructor(r,h){this.i=r,this.j=h,this.a=new P.Emitter,this.onTunnelOpened=this.a.event,this.b=new P.Emitter,this.onTunnelClosed=this.b.event,this.c=new P.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],h=Array.from(this.d.values());for(const g of h){const E=Array.from(g.values());for(const p of E){const C=await p.value;C&&r.push(C)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:h}of r.values())await h.then(g=>g?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,h,g,E,p){this.o(r,h,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:h,localAddress:g,privacy:E,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,h){(y(r)||w(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const g=this.q(r,h);if(g)return++g.refcount,g.value}openTunnel(r,h,g,E,p,C=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${p}.`),!r)return;if(h||(h="localhost"),E||(E=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(r,h,g,E,p,C,t,c);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(n);return(n.tunnelRemoteHost!==h||n.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const h=this.d.get(r.tunnelRemoteHost);if(h){const g=h.get(r.tunnelRemotePort);g&&(g.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,g))}}}}async n(r,h,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${h}.`);const E=g.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(h),E}}async closeTunnel(r,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${h} `);const g=this.d.get(r);if(g&&g.has(h)){const E=g.get(h);E.refcount=0,await this.n(r,h,E)}}o(r,h,g){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(h,{refcount:1,value:g})}async p(r,h){const g=this.d.get(r);g&&(await g.get(h)||g.delete(h),g.size===0&&this.d.delete(r))}q(r,h){const g=[r];w(r)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):y(r)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(p=>this.d.get(p));for(const p of E){const C=p?.get(h);if(C)return C}}canTunnel(r){return!!u(r)}s(r,h,g,E,p,C,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${E}.`);const c=g;this.h.add(c);const i=E===void 0?g:E,n={elevationRequired:p?this.isPortPrivileged(i):!1},o={remoteAddress:{host:h,port:g},localAddressPort:E,privacy:C,public:C?C!==k.Private:void 0,protocol:t},l=r.forwardPort(o,n);return l?(this.o(h,g,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),l}};I=ye([Q(0,A.ILogService),Q(1,L.IConfigurationService)],I),e.AbstractTunnelService=I}),define(ee[249],te([0,1,84,27,101,236,7,2,19,5,21,235,121,93,4]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function b(p,C,t,c,i){let n;for(let o=3;o&&(n?.dispose(),n=await new r(p,C,t,c,i).waitForReady(),!(i&&s.BROWSER_RESTRICTED_PORTS[i]||!s.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));o--);return n}class r extends k.Disposable{constructor(C,t,c,i,n){super(),this.j=t,this.k=n,this.privacy=S.TunnelPrivacyId.Private,this.i=new Map,this.a=C,this.b=P.createServer(),this.c=new R.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const C=this.k??this.tunnelRemotePort,t=(0,S.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,s.findFreePortFaster)(C,2,1e3,t),i=null;return this.b.listen(c,this.j),await this.c.wait(),i=this.b.address(),i||(c=0,this.b.listen(c,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(C){C.pause();const t=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,y.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=c.getSocket().socket,n=c.readEntireBuffer();c.dispose(),n.byteLength>0&&C.write(n.buffer),C.on("end",()=>{C.localAddress&&this.i.delete(C.localAddress),i.end()}),C.on("close",()=>i.end()),C.on("error",()=>{C.localAddress&&this.i.delete(C.localAddress),i.destroy()}),i.on("end",()=>C.end()),i.on("close",()=>C.end()),i.on("error",()=>{C.destroy()}),C.pipe(i),i.pipe(C),C.localAddress&&this.i.set(C.localAddress,()=>{C.end(),i.end()})}}let h=class extends S.AbstractTunnelService{constructor(C,t,c,i,n){super(t,n),this.t=C,this.u=c,this.v=i}isPortPrivileged(C){return(0,S.isPortPrivileged)(C,this.k,I.OS,L.release())}r(C,t,c,i,n,o,l,a){const m=this.q(t,c);if(m)return++m.refcount,m.value;if(this.e)return this.s(this.e,t,c,n,o,l,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${n}.`);const D={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:C,signService:this.u,logService:this.i,ipcLogger:null},M=b(D,i,t,c,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,M),M}}};h=ye([Q(1,u.ILogService),Q(2,d.ISignService),Q(3,w.IProductService),Q(4,f.IConfigurationService)],h),e.BaseTunnelService=h;let g=class extends h{constructor(C,t,c,i){super(A.nodeSocketFactory,C,t,c,i)}};g=ye([Q(0,u.ILogService),Q(1,d.ISignService),Q(2,w.IProductService),Q(3,f.IConfigurationService)],g),e.TunnelService=g;let E=class extends k.Disposable{constructor(C,t,c,i){super(),this.b=C,this.c=t,this.f=c,this.g=i,this.a=new Map}async openTunnel(C,t,c,i,n,o,l,a,m){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this.a.has(C)){const D=new g(this.b,this.f,this.c,this.g);this.D(D),this.a.set(C,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(C))})}return this.a.get(C).openTunnel(t,c,i,n,o,l,a,m)}};E=ye([Q(0,u.ILogService),Q(1,w.IProductService),Q(2,d.ISignService),Q(3,f.IConfigurationService)],E),e.SharedTunnelsService=E}),define(ee[49],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(L=e.StateType||(e.StateType={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(s=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,R)=>({type:"idle",updateType:A,error:R}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,P.createDecorator)("updateService")}),define(ee[250],te([0,1,4,182,68,51]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(s.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:P.isWindows&&!P.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[251],te([0,1,3,49]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class s{constructor(k){this.a=k}listen(k,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(k,f,u){switch(f){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=s;class A{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new P.Emitter,this.onStateChange=this.a.event,this.b=L.State.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=A}),define(ee[95],te([0,1,7,22,3,19,28,20,5,21,52,49]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(I,b,r){return`${r.updateUrl}/api/update/${I}/${b}/${r.commit}`}e.createUpdateURL=S;let d=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,r,h,g,E,p){this.f=b,this.g=r,this.h=h,this.i=g,this.j=E,this.k=p,this.b=y.State.Uninitialized,this.c=new s.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),r=this.l(b);if(!r){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(r),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(y.State.Idle(this.p())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,h=>this.j.error(h))}l(b){return b==="none"?void 0:this.k.quality}m(b=60*60*1e3){return(0,P.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},L.CancellationToken.None)).res.statusCode===204}catch(r){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(r);return}}async _applySpecificUpdate(b){}p(){return 1}q(){}};d=ye([Q(0,k.ILifecycleMainService),Q(1,A.IConfigurationService),Q(2,R.IEnvironmentMainService),Q(3,w.IRequestService),Q(4,f.ILogService),Q(5,u.IProductService)],d),e.AbstractUpdateService=d}),define(ee[252],te([0,1,14,55,3,2,19,28,20,5,21,52,24,49,95]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends I.AbstractUpdateService{get u(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(h,g)=>g)}get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(h,g,E)=>({url:g,version:E,productVersion:E}))}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(h,g,E,p)=>({releaseNotes:g,version:E,productVersion:E,date:p}))}constructor(h,g,E,p,C,t,c){super(h,g,p,C,t,c),this.y=E,this.t=new A.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(h){this.j.error("UpdateService error:",h);const E=(this.state.type==="checking for updates"?this.state.explicit:!0)?h:void 0;this.d(d.State.Idle(1,E))}r(h){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,I.createUpdateURL)(g,h,this.k);try{P.autoUpdater.setFeedURL({url:E})}catch(p){this.j.error("Failed to set update feed URL",p);return}return E}s(h){this.d(d.State.CheckingForUpdates(h)),P.autoUpdater.checkForUpdates()}C(h){this.state.type==="checking for updates"&&this.d(d.State.Downloading(h))}D(h){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:h.version}),this.d(d.State.Ready(h)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ye([L.memoize],b.prototype,"u",null),ye([L.memoize],b.prototype,"v",null),ye([L.memoize],b.prototype,"w",null),ye([L.memoize],b.prototype,"x",null),b=ye([Q(0,f.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,S.ITelemetryService),Q(3,k.IEnvironmentMainService),Q(4,y.IRequestService),Q(5,u.ILogService),Q(6,w.IProductService)],b),e.DarwinUpdateService=b}),define(ee[253],te([0,1,46,41,7,3,9,28,20,5,24,49]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,r,h){if(this.f=b,this.g=h,this.a=y.State.Uninitialized,this.b=new A.Emitter,this.onStateChange=this.b.event,r.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.State.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(b=60*60*1e3){return(0,s.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};S=ye([Q(0,f.ILifecycleMainService),Q(1,k.IEnvironmentMainService),Q(2,u.ILogService)],S);let d=class extends S{constructor(b,r,h,g,E,p){super(h,g,E),this.o=b,this.p=r,this.q=p;const C=(0,L.watch)(R.dirname(this.o)),t=A.Event.fromNodeEventEmitter(C,"change",(o,l)=>l),c=A.Event.filter(t,o=>o==="current"),n=A.Event.debounce(c,(o,l)=>l,2e3)(()=>this.checkForUpdates(!1));h.onWillShutdown(()=>{n.dispose(),C.close()})}m(){this.d(y.State.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(y.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((h,g)=>(0,L.realpath)(`${R.dirname(this.o)}/current`,(E,p)=>E?g(E):h(p))),r=R.basename(b);return this.p!==r}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=ye([Q(2,f.ILifecycleMainService),Q(3,k.IEnvironmentMainService),Q(4,u.ILogService),Q(5,w.ITelemetryService)],d),e.SnapUpdateService=d}),define(ee[39],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(ee[254],te([0,1,39,202,16,18,133,3,2]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(S){this.uri=S,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let w=class{constructor(S){this.g=S,this.c=new f.DisposableStore,this.f=2**16;const d=new Map,I=b=>{let r=d.get(b.scheme);return r===void 0&&(r=S.hasProvider(b)&&!this.g.hasCapability(b,1024),d.set(b.scheme,r)),r};this.c.add(k.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(b=>{d.delete(b.scheme)})),this.extUri=new A.ExtUri(I),this.d=new R.SkipList((b,r)=>this.extUri.compare(b,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(S){this.g.hasProvider(S)&&(S=(0,A.normalizePath)(S));const d=this.d.get(S);return d?d.touch().uri.with({fragment:S.fragment}):(this.d.set(S,new u(S)),this.h(),S)}h(){if(this.d.size<this.f)return;const S=[...this.d.entries()].sort((I,b)=>I[1].time<b[1].time?1:I[1].time>b[1].time?-1:0);u._clock=0,this.d.clear();const d=this.f*.5;for(let I=0;I<d;I++)this.d.set(S[I][0],S[I][1].touch())}};w=ye([Q(0,s.IFileService)],w),e.UriIdentityService=w,(0,L.registerSingleton)(P.IUriIdentityService,w,1)}),define(ee[122],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,P.createDecorator)("urlService")}),define(ee[255],te([0,1,8]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(k){this.a=k}listen(k,f){throw new Error(`Event not found: ${f}`)}call(k,f,u){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class s{constructor(k){this.a=k}handleURL(k,f){return this.a.call("handleURL",[k.toJSON(),f])}}e.URLHandlerChannelClient=s;class A{constructor(k,f){this.a=k,this.b=f}async routeCall(k,f,u,w){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const y=P.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const S=/\bwindowId=(\d+)/.exec(y.query);if(S){const d=S[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,y.toString(!0));const I=new RegExp(`window:${d}`),b=k.connections.find(r=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",r.ctx),I.test(r.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,f,u,w)}routeEvent(k,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=A}),define(ee[256],te([0,1,7,2,8,21]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends L.Disposable{constructor(){super(...arguments),this.a=new Set}open(u,w){const y=[...this.a.values()];return(0,P.first)(y.map(S=>()=>S.handleURL(u,w)),void 0,!1).then(S=>S||!1)}registerHandler(u){return this.a.add(u),(0,L.toDisposable)(()=>this.a.delete(u))}}e.AbstractURLService=R;let k=class extends R{constructor(u){super(),this.b=u}create(u){let{authority:w,path:y,query:S,fragment:d}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return w&&y&&y.indexOf("/")!==0&&(y=`/${y}`),s.URI.from({scheme:this.b.urlProtocol,authority:w,path:y,query:S,fragment:d})}};k=ye([Q(0,A.IProductService)],k),e.NativeURLService=k}),define(ee[257],te([0,1,14,7,3,2,4,8]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(w,y,S,d,I,b){if(this.f=y,this.g=b,this.a=[],this.b=0,this.c=A.Disposable.None,this.d=new A.DisposableStore,w&&(b.trace("ElectronURLListener initialUrisToHandle:",w.map(g=>g.originalUrl)),this.a=w),R.isWindows){const g=d.isBuilt?[]:[`"${d.appRoot}"`];g.push("--open-url","--"),P.app.setAsDefaultProtocolClient(I.urlProtocol,process.execPath,g)}const r=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(g,E)=>({event:g,url:E})),({event:g,url:E})=>(g.preventDefault(),E));this.d.add(r(g=>{const E=this.h(g);!E||this.f.open(E,{originalUrl:g})})),S.getWindows().filter(g=>g.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(S.onDidSignalReadyWindow)(this.i,this,this.d))}h(w){try{return k.URI.parse(w)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const w=[];for(const y of this.a)await this.f.open(y.uri,{originalUrl:y.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),w.push(y));w.length!==0&&(this.a=w,this.c=(0,L.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=f}),define(ee[258],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[259],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,P.createDecorator)("webviewManagerService")}),define(ee[260],te([0,1,14,2,15,8]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends L.Disposable{constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,u){try{const w=A.URI.parse(f.url),y=R.a.get(w.path);if(typeof y=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${y}`,d=s.FileAccess.asFileUri(S);return u({path:decodeURIComponent(d.fsPath),headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}R.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=R}),define(ee[79],te([0,1,4]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function s(w){return!!w.folderUri}e.isFolderToOpen=s;function A(w){return!!w.fileUri}e.isFileToOpen=A;function R(w){const y=k(w),S=w.getValue("window.menuBarVisibility");return S==="default"||y==="native"&&S==="compact"||P.isMacintosh&&P.isNative?"classic":S}e.getMenuBarVisibility=R;function k(w){if(P.isWeb)return"custom";const y=w.getValue("window");if(y){if(P.isMacintosh&&y.nativeTabs===!0||P.isMacintosh&&y.nativeFullScreen===!1)return"native";const I=y.titleBarStyle;if(I==="native"||I==="custom")return I}return P.isLinux?"native":"custom"}e.getTitleBarStyle=k;function f(w){if(!P.isWindows||P.isWeb||k(w)==="native")return!1;const y=w.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!0}e.useWindowControlsOverlay=f;function u(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=u}),define(ee[123],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var P;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(P=e.LoadReason||(e.LoadReason={}));var L;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(L=e.UnloadReason||(e.UnloadReason={}));const s=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=s;var A;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(A=e.WindowMode||(e.WindowMode={}));var R;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(R=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(x,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,P.createDecorator)("windowsMainService");var L;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}))}),define(ee[261],te([0,1,14,22,3,56,2,31,77,110,5,21,30]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let I=class extends R.Disposable{constructor(r,h,g,E,p){super(),this.g=r,this.h=h,this.i=g,this.j=E,this.k=p,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=d.Initial,this.f=void 0,this.l()}l(){const r=s.Event.fromNodeEventEmitter(P.app,"login",(h,g,E,p,C)=>({event:h,webContents:g,req:E,authInfo:p,callback:C}));this.D(r(this.m,this))}async m({event:r,authInfo:h,req:g,callback:E}){if(!h.isProxy)return;if(!this.b&&this.c===d.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}r.preventDefault();let p;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),p=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(h);try{p=await this.b}finally{this.b=void 0}}E(p?.username,p?.password)}async n(r){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const h=await this.p(r);if(h)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),h;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(r){this.g.trace("auth#doResolveProxyCredentials - enter",r);const h=String((0,A.hash)({scheme:r.scheme,host:r.host,port:r.port}));let g,E;try{const c=await this.i.getPassword(this.a,h);if(c){const i=JSON.parse(await this.j.decrypt(c));g=i.username,E=i.password}}catch(c){this.g.error(c)}if(this.c!==d.StoredCredentialsUsed&&typeof g=="string"&&typeof E=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=d.StoredCredentialsUsed,{username:g,password:E};const p=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!p){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${p.id} to handle proxy login`);const C={authInfo:r,username:this.f?.username??g,password:this.f?.password??E,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};p.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,C),this.c=d.LoginDialogShown;const t=await new Promise(c=>{const i=async(n,o,l)=>{if(o===C.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${p.id}`),p.win?.webContents.off("ipc-message",i),l){const a={username:l.username,password:l.password};try{if(l.remember){const m=await this.j.encrypt(JSON.stringify(a));await this.i.setPassword(this.a,h,m)}else await this.i.deletePassword(this.a,h)}catch(m){this.g.error(m)}c({username:a.username,password:a.password})}else c(void 0)};p.win?.webContents.on("ipc-message",i)});return this.f=t,t}};I=ye([Q(0,w.ILogService),Q(1,S.IWindowsMainService),Q(2,f.ICredentialsMainService),Q(3,u.IEncryptionMainService),Q(4,y.IProductService)],I),e.ProxyAuthHandler=I}),define(ee[262],te([0,1,77,5,34,21,30,214]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends k.BaseCredentialsMainService{constructor(w,y,S,d){super(w),this.n=y,this.p=S,this.q=d,this.j=I=>{this.q.sendToFocused("vscode:showCredentialsError",I.message??I)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new P.InMemoryCredentialsProvider,this.f;const w=await new Promise((y,S)=>{x(["keytar"],y,S)});return await w.findCredentials("test-keytar-loads"),this.f=w,this.f}};f=ye([Q(0,L.ILogService),Q(1,s.INativeEnvironmentService),Q(2,A.IProductService),Q(3,R.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(ee[263],te([0,1,14,26,4,8,23,19,62,6,5,122,30]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,u.createDecorator)(e.ID);let d=class{constructor(b,r,h,g){this.a=b,this.b=r,this.c=h,this.d=g}async start(b,r){this.a.trace("Received data from other instance: ",b,r),s.isMacintosh&&P.app.focus({steal:!0});const h=this.e(b);if(h.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const E=(0,L.firstOrDefault)(await this.b.openEmptyWindow({context:4}));E&&(g=E.ready())}g.then(()=>{for(const{uri:E,originalUrl:p}of h)this.c.open(E,{originalUrl:p})})}else return this.f(b,r)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,L.coalesce)(b._urls.map(r=>{try{return{uri:A.URI.parse(r),originalUrl:r}}catch{return null}})):[]}async f(b,r){const h=(0,f.isLaunchedFromCli)(r)?0:4;let g=[];const E=b.wait&&b.waitMarkerFilePath?A.URI.file(b.waitMarkerFilePath):void 0,p=b.remote||void 0,C={context:h,cli:b,userEnv:r,waitMarkerFileURI:E,remoteAuthority:p,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,C);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||C.forceProfile||C.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.isMacintosh}if(t)g=await this.b.open({...C,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,C),g=[c]):g=await this.b.open({...C,forceEmpty:!0})}}else g=await this.b.open({...C,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(E&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,R.whenDeleted)(E.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};d=ye([Q(0,w.ILogService),Q(1,S.IWindowsMainService),Q(2,y.IURLService),Q(3,k.IConfigurationService)],d),e.LaunchMainService=d}),define(ee[70],te([0,1,14,2,3,5,264,7,15,72,30,75,24,20,73,37]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function r(E){return typeof E.responseWindowId=="number"}let h=class ut extends L.Disposable{static getAll(){return Array.from(ut.b.values())}constructor(p,C,t){super(),this.n=p,this.p=C,this.q=t,this.c=String(++ut.a),this.f=this.D(new s.Emitter),this.onStdout=this.f.event,this.g=this.D(new s.Emitter),this.onStderr=this.g.event,this.h=this.D(new s.Emitter),this.onMessage=this.h.event,this.i=this.D(new s.Emitter),this.onExit=this.i.event,this.j=this.D(new s.Emitter),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}r(p,C){let t;switch(this.m?.correlationId?t=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${p}`:t=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${p}`,C){case y.default.Error:this.n.error(t);break;case y.default.Warning:this.n.warn(t);break;case y.default.Info:this.n.info(t);break}}s(){if(!u.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");return this.k?(this.r("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(p){const C=this.t(p,!1);return C&&p.payload&&this.postMessage(p.payload),C}t(p,C){if(!this.s())return!1;this.m=p;const t=`${this.m.type}-${this.c}`,c=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.m.args??[],n=this.m.execArgv??[],o=this.m.allowLoadingUnsignedLibraries,l="pipe",a=this.u(p,C);return this.r("creating new...",y.default.Info),this.k=u.UtilityProcess.fork(c,i,{serviceName:t,env:a,execArgv:n,allowLoadingUnsignedLibraries:o,stdio:l}),this.v(this.k,this.m,t,C),!0}u(p,C){const t=p.env?{...p.env}:{...(0,b.deepClone)(process.env)};t.VSCODE_AMD_ENTRYPOINT=p.entryPoint,typeof p.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(p.parentLifecycleBound)),C&&(t.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=p.type,(0,I.removeDangerousEnvVariables)(t);for(const c of Object.keys(t))t[c]=String(t[c]);return t}v(p,C,t,c){if(p.stdout){const i=new R.StringDecoder("utf-8");this.D(s.Event.fromNodeEventEmitter(p.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(p.stderr){const i=new R.StringDecoder("utf-8");this.D(s.Event.fromNodeEventEmitter(p.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.D(s.Event.fromNodeEventEmitter(p,"message")(i=>this.h.fire(i))),this.D(s.Event.fromNodeEventEmitter(p,"spawn")(()=>{this.l=p.pid,typeof p.pid=="number"&&ut.b.set(p.pid,{pid:p.pid,name:r(C)?`${C.type} [${C.responseWindowId}]`:C.type}),this.r("successfully created",y.default.Info)})),this.D(s.Event.fromNodeEventEmitter(p,"exit")(i=>{this.r(`received exit event with code ${i}`,y.default.Info),this.i.fire({pid:this.l,code:i,signal:"unknown"}),this.w()})),this.D(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===t&&(this.r(`crashed with code ${i.exitCode} and reason '${i.reason}'`,y.default.Error),this.p.publicLog2("utilityprocesscrash",{type:C.type,reason:i.reason,code:i.exitCode,sandboxed:c?"1":"0"}),this.j.fire({pid:this.l,code:i.exitCode,reason:i.reason}),this.w())}))}once(p,C){const t=this.D(this.h.event(c=>{c===p&&(t.dispose(),C())}))}postMessage(p,C){!this.k||this.k.postMessage(p,C)}connect(p){const{port1:C,port2:t}=new P.MessageChannelMain;return this.postMessage(p,[t]),C}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.r("enabling inspect port",y.default.Info);const p=process;return typeof p._debugProcess=="function"?(p._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.r("attempting to kill the process...",y.default.Info),this.k.kill()?(this.r("successfully killed the process",y.default.Info),this.w()):this.r("unable to kill the process",y.default.Warning)}w(){typeof this.l=="number"&&ut.b.delete(this.l),this.k=void 0}async waitForExit(p){!this.k||(this.r("waiting to exit...",y.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,k.timeout)(p)]),this.k&&(this.r(`did not exit within ${p}ms, will kill it now...`,y.default.Info),this.kill()))}};h.a=0,h.b=new Map,h=ye([Q(0,A.ILogService),Q(1,S.ITelemetryService),Q(2,d.ILifecycleMainService)],h),e.UtilityProcess=h;let g=class extends h{constructor(p,C,t,c){super(p,t,c),this.y=C}start(p){const C=this.y.getWindowById(p.responseWindowId);if(!C?.win||C.win.isDestroyed()||C.win.webContents.isDestroyed())return this.r("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.t(p,C.isSandboxed))return!1;this.z(C.win,p);const c=this.connect(p.payload);return C.win.webContents.postMessage(p.responseChannel,p.responseNonce,[c]),!0}z(p,C){C.windowLifecycleBound&&(this.D(s.Event.filter(this.q.onWillLoadWindow,t=>t.window.win===p)(()=>this.kill())),this.D(s.Event.fromNodeEventEmitter(p,"closed")(()=>this.kill())))}};g=ye([Q(0,A.ILogService),Q(1,w.IWindowsMainService),Q(2,S.ITelemetryService),Q(3,d.ILifecycleMainService)],g),e.WindowUtilityProcess=g}),define(ee[265],te([0,1,13,2,3,5,20,74,46,264,7,15,37,4,36,72,70,30,24]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let E=class Pt{constructor(t,c,i,n){this.d=t,this.f=c,this.g=i,this.h=n,this.c=!1,this.b=new Map,this.f.onWillShutdown(o=>{this.c=!0,o.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(t){const c=this.b.get(t);if(!c)throw new Error("Unknown extension host!");return c}onDynamicStdout(t){return this.i(t).onStdout}onDynamicStderr(t){return this.i(t).onStderr}onDynamicMessage(t){return this.i(t).onMessage}onDynamicError(t){const c=this.i(t);return c instanceof r.WindowUtilityProcess?s.Event.None:c.onError}onDynamicExit(t){return this.i(t).onExit}async canUseUtilityProcess(){return b.canUseUtilityProcess}async createExtensionHost(t){if(this.c)throw(0,P.canceled)();const c=String(++Pt.a);let i;if(t){if(!b.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new r.WindowUtilityProcess(this.d,this.g,this.h,this.f)}else i=new p(c,this.d);return this.b.set(c,i),i.onExit(({pid:n,code:o,signal:l})=>{this.d.info(`Extension host with pid ${n} exited with code: ${o}, signal: ${l}.`),setTimeout(()=>{i.dispose(),this.b.delete(c)})}),{id:c}}async start(t,c){if(this.c)throw(0,P.canceled)();this.i(t).start({...c,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:c.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this.c)throw(0,P.canceled)();const c=this.b.get(t);return c?c.enableInspectPort():!1}async kill(t){if(this.c)throw(0,P.canceled)();const c=this.b.get(t);!c||c.kill()}async _killAllNow(){for(const[,t]of this.b)t.kill()}async _waitForAllExit(t){const c=[];for(const[,i]of this.b)c.push(i.waitForExit(t));return w.Promises.settled(c).then(()=>{})}};E.a=0,E=ye([Q(0,A.ILogService),Q(1,R.ILifecycleMainService),Q(2,h.IWindowsMainService),Q(3,g.ITelemetryService)],E),e.ExtensionHostStarter=E;let p=class extends L.Disposable{constructor(t,c){super(),this.id=t,this.c=c,this._onStdout=this.D(new s.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.D(new s.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.D(new s.Emitter),this.onMessage=this._onMessage.event,this._onError=this.D(new s.Emitter),this.onError=this._onError.event,this._onExit=this.D(new s.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(t){d.isCI&&this.c.info("Calling fork to start extension host...");const c=k.StopWatch.create(!1);this.a=(0,f.fork)(y.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,I.cwd)()},t));const i=c.elapsed(),n=this.a.pid;this.c.info(`Starting extension host with pid ${n} (fork() took ${i} ms).`);const o=new u.StringDecoder("utf-8");this.a.stdout?.on("data",a=>{const m=typeof a=="string"?a:o.write(a);this._onStdout.fire(m)});const l=new u.StringDecoder("utf-8");this.a.stderr?.on("data",a=>{const m=typeof a=="string"?a:l.write(a);this._onStderr.fire(m)}),this.a.on("message",a=>{this._onMessage.fire(a)}),this.a.on("error",a=>{this._onError.fire({error:(0,P.transformErrorForSerialization)(a)})}),this.a.on("exit",(a,m)=>{this.b=!0,this._onExit.fire({pid:n,code:a,signal:m})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):d.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(t){if(!this.a)return;const c=this.a.pid;this.c.info(`Waiting for extension host with pid ${c} to exit.`),await Promise.race([s.Event.toPromise(this.onExit),(0,w.timeout)(t)]),this.b||(this.c.info(`Extension host with pid ${c} did not exit within ${t}ms.`),this.a.kill())}};p=ye([Q(1,A.ILogService)],p)}),define(ee[266],te([0,1,2,6,5,30,70,24,56,3,7,20]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let S=class extends P.Disposable{constructor(b,r,h,g){super(),this.b=b,this.c=r,this.f=h,this.g=g,this.a=new Map}async createWorker(b){const r=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${r})`);const h=this.h(b);this.a.has(h)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${r})`),this.disposeWorker(b));const g=new d(this.b,this.c,this.f,this.g,b);if(!g.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(h,g);const E=new w.DeferredPromise;return u.Event.once(g.onDidTerminate)(p=>{p.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${p.code}, signal: ${p.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${p.code}, signal: ${p.signal}`),this.a.delete(h),E.complete({reason:p})}),E.p}h(b){return(0,f.hash)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const r=this.h(b),h=this.a.get(r);!h||(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),h.kill(),this.a.delete(r))}};S=ye([Q(0,s.ILogService),Q(1,A.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,y.ILifecycleMainService)],S),e.UtilityProcessWorkerMainService=S;let d=class extends P.Disposable{constructor(b,r,h,g,E){super(),this.c=b,this.f=r,this.g=h,this.h=g,this.i=E,this.a=this.D(new u.Emitter),this.onDidTerminate=this.a.event,this.b=new R.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.D(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.D(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const r=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:r,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};d=ye([Q(0,s.ILogService),Q(1,A.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,y.ILifecycleMainService)],d)}),define(ee[267],te([0,1,14,3,2,260,30]),function(x,e,P,L,s,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends s.Disposable{constructor(u){super(),this.b=u,this.a=this.D(new L.Emitter),this.onFoundInFrame=this.a.event,this.D(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(u,w){let y;if(typeof u.windowId=="number"){const{windowId:S}=u,d=this.b.getWindowById(S);if(!d?.win)throw new Error(`Invalid windowId: ${S}`);y=d.win.webContents}else{const{webContentsId:S}=u;if(y=P.webContents.fromId(S),!y)throw new Error(`Invalid webContentsId: ${S}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(w)}async findInFrame(u,w,y,S){const I=this.c(u,w);if(typeof I.findInFrame=="function"){I.findInFrame(y,{findNext:S.findNext,forward:S.forward});const b=(r,h)=>{h.finalUpdate&&(this.a.fire(h),I.removeListener("found-in-frame",b))};I.on("found-in-frame",b)}}async stopFindInFrame(u,w,y){const d=this.c(u,w);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(u,w){const y=this.b.getWindowById(u.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${u}`);const S=y.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===w);if(!S)throw new Error(`Unknown frame: ${w}`);return S}};k=ye([Q(0,R.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[268],te([0,1,7,3,2]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends s.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:f,getActiveWindowId:u}){super(),this.a=this.D(new s.DisposableStore),L.Event.latch(L.Event.any(k,f))(this.f,this,this.a),this.b=(0,P.createCancelablePromise)(()=>u()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(ee[29],te([0,1,186,9,61,18,8,6,15]),function(x,e,P,L,s,A,R,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function u(n){const o=n;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=u;function w(n){return typeof n?.id=="string"&&!u(n)&&!S(n)}e.isEmptyWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=n;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=y;function S(n){const o=n;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=S;function d(n){const o=n;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const l=n;if(l?.configPath)return{id:l.id,configPath:R.URI.revive(l.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=d;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function b(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=b;function r(n){const o=n;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=r;class h{constructor(o,l,a,m,D){this.h=o,this.j=a,this.k=m,this.l=D,this.c=s.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=s.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(o,l){this.raw=l,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function E(n){return new g({uri:n,index:0,name:(0,A.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(n,o){return A.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function C(n){let o;return R.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function c(n,o){return!p(n,o)&&!C(n)}e.isSavedWorkspace=c;function i(n){return(typeof n=="string"?(0,L.extname)(n):(0,A.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ee[58],te([0,1,14,7,56,45,2,82,4,11,23,163,90,6,5,21,29]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,d.createDecorator)("dialogMainService");let h=class{constructor(E,p){this.d=E,this.e=p,this.a=new Map,this.b=new Map,this.c=new L.Queue}pickFileFolder(E,p){return this.f({...E,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},p)}pickFolder(E,p){return this.f({...E,pickFolders:!0,title:(0,y.localize)(1,null)},p)}pickFile(E,p){return this.f({...E,pickFiles:!0,title:(0,y.localize)(2,null)},p)}pickWorkspace(E,p){const C=(0,y.localize)(3,null),t=(0,A.mnemonicButtonLabel)((0,y.localize)(4,null)),c=r.WORKSPACE_FILTER;return this.f({...E,pickFiles:!0,title:C,filters:c,buttonLabel:t},p)}async f(E,p){const C={title:E.title,buttonLabel:E.buttonLabel,filters:E.filters,defaultPath:E.defaultPath};(typeof E.pickFiles=="boolean"||typeof E.pickFolders=="boolean")&&(C.properties=void 0,E.pickFiles&&E.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",E.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&C.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(C,(0,u.withNullAsUndefined)(p||P.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(E){if(E){let p=this.b.get(E.id);return p||(p=new L.Queue,this.b.set(E.id,p)),p}else return this.c}showMessageBox(E,p){return this.g(p).queue(async()=>{const{options:C,buttonIndeces:t}=(0,S.massageMessageBoxOptions)(E,this.e);let c;return p?c=await P.dialog.showMessageBox(p,C):c=await P.dialog.showMessageBox(C),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(E,p){const C=this.j(E,p);if(!C)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(p).queue(async()=>{let t;return p?t=await P.dialog.showSaveDialog(p,E):t=await P.dialog.showSaveDialog(E),t.filePath=this.h(t.filePath),t})}finally{(0,R.dispose)(C)}}h(E){return E&&f.isMacintosh&&(E=(0,k.normalizeNFC)(E)),E}i(E){return E.map(p=>this.h(p))}async showOpenDialog(E,p){E.defaultPath&&(await w.Promises.exists(E.defaultPath)||(E.defaultPath=void 0));const C=this.j(E,p);if(!C)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(p).queue(async()=>{let t;return p?t=await P.dialog.showOpenDialog(p,E):t=await P.dialog.showOpenDialog(E),t.filePaths=this.i(t.filePaths),t})}finally{(0,R.dispose)(C)}}j(E,p){if(!p)return R.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",E);let C=this.a.get(p.id);C||(C=new Set,this.a.set(p.id,C));const t=(0,s.hash)(E);if(!C.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",E),C.add(t),(0,R.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",E),C?.delete(t),C?.size===0&&this.a.delete(p.id)})}};h=ye([Q(0,I.ILogService),Q(1,b.IProductService)],h),e.DialogMainService=h}),define(ee[269],te([0,1,3,2,85,29]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends L.Disposable{constructor(f,u){super(),this.f=f,this.g=u,this.b=this.D(new P.Emitter),this.c=new Map,this.h(u.applicationStorage,this.b)}h(f,u){this.D(P.Event.debounce(f.onDidChangeStorage,(w,y)=>(w?w.push(y):w=[y],w),R.a)(w=>{w.length&&u.fire(this.i(w,f))}))}i(f,u){const w=new Map,y=new Set;return f.forEach(S=>{const d=u.get(S.key);typeof d=="string"?w.set(S.key,d):y.add(S.key)}),{changed:Array.from(w.entries()),deleted:Array.from(y.values())}}listen(f,u,w){switch(u){case"onDidChangeStorage":{const y=w.profile?(0,s.revive)(w.profile):void 0;if(!y)return this.b.event;let S=this.c.get(y.id);return S||(S=this.D(new P.Emitter),this.h(this.g.profileStorage(y),S),this.c.set(y.id,S)),S.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,w){const y=w.profile?(0,s.revive)(w.profile):void 0,S=(0,A.reviveIdentifier)(w.workspace),d=await this.j(y,S);switch(u){case"getItems":return Array.from(d.items.entries());case"updateItems":{const I=w;if(I.insert)for(const[b,r]of I.insert)d.set(b,r);I.delete?.forEach(b=>d.delete(b));break}case"isUsed":{const I=w.payload;if(typeof I=="string")return this.g.isUsed(I)}default:throw new Error(`Call not found: ${u}`)}}async j(f,u){let w;u?w=this.g.workspaceStorage(u):f?w=this.g.profileStorage(f):w=this.g.applicationStorage;try{await w.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${y}`)}return w}}R.a=100,e.StorageDatabaseChannel=R}),define(ee[40],te([0,1,56,3,2,18,8,183,34,16,6,5,29,35,39,7,31,25,11]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&R.URI.isUri(n.location)&&R.URI.isUri(n.globalStorageHome)&&R.URI.isUri(n.settingsResource)&&R.URI.isUri(n.keybindingsResource)&&R.URI.isUri(n.tasksResource)&&R.URI.isUri(n.snippetsHome)&&R.URI.isUri(n.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function p(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:n}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:R.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=p;function C(i,n,o,l){return{id:i,name:n,location:o,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:(0,A.joinPath)(o,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=C;let t=class extends s.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(n,o,l,a){super(),this.m=n,this.n=o,this.q=l,this.r=a,this.f=!0,this.g=this.D(new L.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new L.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new L.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new L.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(n){this.f!==n&&(this.s=void 0,this.f=n)}isEnabled(){return this.f}get t(){if(!this.s){const n=[];if(this.f)try{for(const m of this.I()){if(!m.name||!(0,g.isString)(m.name)||!m.location){this.r.warn("Skipping the invalid stored profile",m.location||m.name);continue}n.push(C((0,A.basename)(m.location),m.name,m.location,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}))}}catch(m){this.r.error(m)}const o=new d.ResourceMap,l=new Map,a=this.u();if(n.unshift({...a,extensionsResource:this.N()??a.extensionsResource,isDefault:!0}),n.length)try{const m=this.L();if(m.workspaces)for(const[D,M]of Object.entries(m.workspaces)){const T=R.URI.parse(D),$=n.find(z=>z.id===M);$&&o.set(T,$)}if(m.emptyWindows)for(const[D,M]of Object.entries(m.emptyWindows)){const T=n.find($=>$.id===M);T&&l.set(D,T)}}catch(m){this.r.error(m)}this.s={profiles:n,workspaces:o,emptyWindows:l}}return this.s}u(){return C("__default__profile__",(0,k.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,h.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const D of this.profiles){const M=l.exec(D.name),T=M?parseInt(M[1]):0;a=T>a?T:a}const m=`${o} ${a+1}`;return this.createProfile((0,P.hash)((0,r.generateUuid)()).toString(16),m,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,P.hash)((0,r.generateUuid)()).toString(16),n,o,l)}async createProfile(n,o,l,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.v(n,o,l);return a&&await this.setProfileForWorkspace(a,m),m}async v(n,o,l){if(!(0,g.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const m=this.profiles.find(T=>T.name===o||T.id===n);if(m)return m;const D=C(n,o,(0,A.joinPath)(this.profilesHome,n),l);await this.n.createFolder(D.location);const M=[];return this.h.fire({profile:D,join(T){M.push(T)}}),await b.Promises.settled(M),this.z([D],[],[]),D}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(a=>a.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=C(l.id,o.name??l.name,l.location,{shortName:o.shortName??l.shortName,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags}),this.z([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.i.fire({profile:o,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.r.error(a)}for(const a of[...this.t.emptyWindows.keys()])o.id===this.t.emptyWindows.get(a)?.id&&this.t.emptyWindows.delete(a);for(const a of[...this.t.workspaces.keys()])o.id===this.t.workspaces.get(a)?.id&&this.t.workspaces.delete(a);this.G(),this.z([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.r.error(a)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(a=>a.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.F(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.q.extUri.isEqual(l.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(o=>!this.y(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.w(n);return R.URI.isUri(o)?this.l.workspaces.get(o)??this.t.workspaces.get(o):this.l.emptyWindows.get(o)??this.t.emptyWindows.get(o)}w(n){return(0,S.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,S.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(o=>this.q.extUri.isEqual(o.location,n.location))||[...this.l.workspaces.values()].some(o=>this.q.extUri.isEqual(o.location,n.location))||[...this.t.emptyWindows.values()].some(o=>this.q.extUri.isEqual(o.location,n.location))||[...this.t.workspaces.values()].some(o=>this.q.extUri.isEqual(o.location,n.location)))}z(n,o,l){const a=[...this.profiles,...n],m=[];this.l.profiles=[];for(let D of a)D.isDefault||o.some(M=>D.id===M.id)||(D=l.find(M=>D.id===M.id)??D,D.isTransient?this.l.profiles.push(D):m.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.J(m),this.s=void 0,this.C(n,o,l)}C(n,o,l){this.g.fire({added:n,removed:o,updated:l,all:this.profiles})}F(n,o,l){l=o?.isTransient?!0:l,l||this.F(n,void 0,!0);const a=this.w(n),m=l?this.l:this.t;R.URI.isUri(a)?(m.workspaces.delete(a),o&&m.workspaces.set(a,o)):(m.emptyWindows.delete(a),o&&m.emptyWindows.set(a,o)),l||this.G()}G(){const n={};for(const[l,a]of this.t.workspaces.entries())n[l.toString()]=a.id;const o={};for(const[l,a]of this.t.emptyWindows.entries())o[l.toString()]=a.id;this.M({workspaces:n,emptyWindows:o}),this.s=void 0}H(n){const o={},l=this.u();if(n.workspaces)for(const[m,D]of Object.entries(n.workspaces)){const M=R.URI.parse(D);o[m]=this.q.extUri.isEqual(M,l.location)?l.id:this.q.extUri.basename(M)}const a={};if(n.emptyWindows)for(const[m,D]of Object.entries(n.emptyWindows)){const M=R.URI.parse(D);a[m]=this.q.extUri.isEqual(M,l.location)?l.id:this.q.extUri.basename(M)}return{workspaces:o,emptyWindows:a}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([Q(0,f.IEnvironmentService),Q(1,u.IFileService),Q(2,I.IUriIdentityService),Q(3,y.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=c}),define(ee[80],te([0,1,7,17,2,3,35,8,111,118,16,6,5,40,39,11,13,24]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class E extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let p=class extends s.Disposable{constructor(i,n,o,l,a,m){super(),this.i=i,this.j=n,this.k=o,this.l=l,this.m=a,this.n=m,this.b=this.D(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new R.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const o=[],l=[];try{return await this.p(n,a=>{const m=[];for(const D of a)i.some(([M])=>(0,u.areSameExtensions)(M.identifier,D.identifier)&&M.manifest.version!==D.version)?o.push(D):m.push(D);for(const[D,M]of i)if(!m.some(T=>(0,u.areSameExtensions)(T.identifier,D.identifier)&&T.version===D.manifest.version)){const T={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:M};l.push(T),m.push(T)}return l.length&&this.b.fire({extensions:l,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),m}),l.length&&this.c.fire({extensions:l,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),l}catch(a){throw l.length&&this.c.fire({extensions:l,error:a,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:a,profileLocation:n}),a}}async updateMetadata(i,n){const o=[];return await this.p(n,l=>{const a=[];for(const m of l){const D=i.find(([M])=>(0,u.areSameExtensions)(M.identifier,m.identifier)&&M.manifest.version===m.version);D&&(m.metadata={...m.metadata,...D[1]},o.push(m)),a.push(m)}return a}),o}async removeExtensionFromProfile(i,n){const o=[];this.f.fire({extensions:o,profileLocation:n});try{await this.p(n,l=>{const a=[];for(const m of l)(0,u.areSameExtensions)(m.identifier,i.identifier)?o.push(m):a.push(m);return o.length&&this.f.fire({extensions:o,profileLocation:n}),a}),o.length&&this.g.fire({extensions:o,profileLocation:n})}catch(l){throw o.length&&this.g.fire({extensions:o,error:l,profileLocation:n}),l}}async p(i,n,o){return this.v(i).queue(async()=>{let l=[],a;try{const m=await this.j.readFile(i);a=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,w.toFileOperationResult)(m)!==1)throw m;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&o?.bailOutWhenFileNotFound)throw new E((0,r.getErrorMessage)(m),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.q(i);let m=!1;for(const D of a){C(D)||this.q(i);let M;if((0,b.isString)(D.relativeLocation)&&D.relativeLocation)M=this.s(D.relativeLocation);else if((0,b.isString)(D.location))M=this.s(D.location),m=!0,D.relativeLocation=D.location,D.location=M.toJSON();else{M=k.URI.revive(D.location);const T=this.r(M);T&&(m=!0,D.relativeLocation=T)}l.push({identifier:D.identifier,location:M,version:D.version,metadata:D.metadata})}m&&await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(a)))}if(n){l=n(l);const m=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.r(D.location),metadata:D.metadata}));await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(m)))}return l})}q(i){const n=new E(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}s(i){return this.l.extUri.joinPath(this.i,i)}async u(){return this.t||(this.t=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(i)).value.toString()}catch(a){if((0,w.toFileOperationResult)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",i.toString());let l;try{const a=JSON.parse(o);Array.isArray(a)&&a.every(m=>C(m))?l=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,w.toFileOperationResult)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(i)}catch(a){(0,w.toFileOperationResult)(a)!==1&&this.n.error(a)}try{await this.j.del(n)}catch(a){(0,w.toFileOperationResult)(a)!==1&&this.n.error(a)}return l})()),this.t}v(i){let n=this.h.get(i);return n||(n=new P.Queue,this.h.set(i,n)),n}};p=ye([Q(1,w.IFileService),Q(2,d.IUserDataProfilesService),Q(3,I.IUriIdentityService),Q(4,h.ITelemetryService),Q(5,S.ILogService)],p),e.AbstractExtensionsProfileScannerService=p;function C(c){return(0,b.isObject)(c)&&(0,f.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,b.isString)(c.location)&&c.location)&&((0,b.isUndefined)(c.relativeLocation)||(0,b.isString)(c.relativeLocation))&&c.version&&(0,b.isString)(c.version)}function t(c){return c?(0,b.isString)(c.path)&&(0,b.isString)(c.scheme):!1}}),define(ee[124],te([0,1,26,7,37,17,13,43,146,2,15,9,4,18,200,75,11,8,168,34,118,115,199,16,6,5,21,3,85,80,40,39,198]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i,n,o,l,a,m,D,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(ce){function J(Y,H){if(Y===H)return!0;const F=Object.keys(Y),V=new Set;for(const Z of Object.keys(H))V.add(Z);if(F.length!==V.size)return!1;for(const Z of F){if(Y[Z]!==H[Z])return!1;V.delete(Z)}return V.size===0}ce.equals=J})($=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let z=class extends u.Disposable{constructor(J,Y,H,F,V,Z,ne,se,U,v,O,W){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=Y,this.l=H,this.m=F,this.n=V,this.p=Z,this.q=ne,this.r=se,this.s=U,this.t=v,this.u=O,this.v=W,this.g=this.D(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(oe,(0,d.joinPath)(this.m,C.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(oe,(0,d.joinPath)(this.m,C.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(ie,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,p.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions(J,Y,H){const[F,V]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(Y)]),Z=H?await this.scanExtensionsUnderDevelopment(J,[...F,...V]):[];return this.F(F,V,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const Y=[];Y.push(this.G(!!J.useCache,J.language)),Y.push(this.H(J.language,!!J.checkControlFile));const[H,F]=await Promise.all(Y);return this.C([...H,...F],0,J,!1)}async scanUserExtensions(J){const Y=J.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",Y);const H=this.u.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.J(Y,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,H),V=J.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k;let Z;try{Z=await V.scanExtensions(F)}catch(ne){if(ne instanceof m.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),Z=await V.scanExtensions(F);else throw ne}return Z=await this.C(Z,1,J,!0),this.r.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(J,Y){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const H=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter(F=>F.scheme===w.Schemas.file).map(async F=>{const V=await this.J(F,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(V)).map(ne=>(ne.type=Y.find(se=>(0,p.areSameExtensions)(se.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,V)))}))).flat();return this.C(H,"development",J,!0)}return[]}async scanExistingExtension(J,Y,H){const F=await this.J(J,!1,Y,!0,H.language,!0,void 0),V=await this.k.scanExtension(F);return!V||!H.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(J,Y,H){const F=await this.J(J,!1,Y,!0,H.language,!0,void 0),V=await this.k.scanOneOrMultipleExtensions(F);return this.C(V,Y,H,!0)}async scanMetadata(J){const Y=(0,d.joinPath)(J,"package.json"),H=(await this.q.readFile(Y)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(J,Y){const H=(0,d.joinPath)(J,"package.json"),F=(await this.q.readFile(H)).value.toString(),V=JSON.parse(F);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,V.__metadata={...V.__metadata,...Y},await this.q.writeFile((0,d.joinPath)(J,"package.json"),A.VSBuffer.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof m.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw J}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.p.addExtensionsToProfile(J.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,c.toFileOperationResult)(Y)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(Y))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.r.error(J)}finally{this.y=void 0}})()),this.y}async C(J,Y,H,F){return H.includeAllVersions||(J=this.F(Y===0?J:void 0,Y===1?J:void 0,Y==="development"?J:void 0,await this.getTargetPlatform(),F)),H.includeInvalid||(J=J.filter(V=>V.isValid)),J.sort((V,Z)=>{const ne=y.basename(V.location.fsPath),se=y.basename(Z.location.fsPath);return ne<se?-1:ne>se?1:0})}F(J,Y,H,F,V){const Z=(se,U,v)=>{if(se.isValid&&!U.isValid)return!1;if(se.isValid===U.isValid){if(V&&I.gt(se.manifest.version,U.manifest.version))return this.r.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(I.eq(se.manifest.version,U.manifest.version)){if(se.type===0)return this.r.debug(`Skipping extension ${U.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===F)return this.r.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return v?this.r.warn(`Overwriting user extension ${se.location.path} with ${U.location.path}.`):this.r.debug(`Overwriting user extension ${se.location.path} with ${U.location.path}.`),!0},ne=new C.ExtensionIdentifierMap;return J?.forEach(se=>{const U=ne.get(se.identifier.id);(!U||Z(U,se,!1))&&ne.set(se.identifier.id,se)}),Y?.forEach(se=>{const U=ne.get(se.identifier.id);if(!U&&J&&se.type===0){this.r.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!U||Z(U,se,!1))&&ne.set(se.identifier.id,se)}),H?.forEach(se=>{const U=ne.get(se.identifier.id);(!U||Z(U,se,!0))&&ne.set(se.identifier.id,se),ne.set(se.identifier.id,se)}),[...ne.values()]}async G(J,Y){this.r.trace("Started scanning system extensions");const H=await this.J(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),V=await(J&&!H.devMode?this.i:this.k).scanExtensions(H);return this.r.trace("Scanned system extensions:",V.length),V}async H(J,Y){const H=this.s.isBuilt?[]:this.t.builtInExtensions;if(!H?.length)return[];this.r.trace("Started scanning dev system extensions");const F=Y?await this.I():{},V=[],Z=h.URI.file(y.normalize(y.join(w.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of H){const U=F[se.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":V.push((0,d.joinPath)(Z,se.name));break;default:V.push(h.URI.file(U));break}}const ne=await Promise.all(V.map(async se=>this.k.scanExtension(await this.J(se,!1,0,!0,J,!0,void 0))));return this.r.trace("Scanned dev system extensions:",ne.length),(0,P.coalesce)(ne)}async I(){try{const J=await this.q.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async J(J,Y,H,F,V,Z,ne){const se=await this.f(V??S.language),U=await this.L(J),v=Y&&!this.u.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,O=v?await this.L(v):void 0;return new q(J,U,v,O,Y,ne,H,F,Z,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,V,se)}async L(J){try{const Y=await this.q.stat(J);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};z=ye([Q(4,D.IUserDataProfilesService),Q(5,m.IExtensionsProfileScannerService),Q(6,c.IFileService),Q(7,n.ILogService),Q(8,E.IEnvironmentService),Q(9,o.IProductService),Q(10,M.IUriIdentityService),Q(11,i.IInstantiationService)],z),e.AbstractExtensionsScannerService=z;class q{constructor(J,Y,H,F,V,Z,ne,se,U,v,O,W,N,G,j){this.location=J,this.mtime=Y,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=F,this.profile=V,this.profileScanOptions=Z,this.type=ne,this.excludeObsolete=se,this.validate=U,this.productVersion=v,this.productDate=O,this.productCommit=W,this.devMode=N,this.language=G,this.translations=j}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,Y){return(0,d.isEqual)(J.location,Y.location)&&J.mtime===Y.mtime&&(0,d.isEqual)(J.applicationExtensionslocation,Y.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&J.profile===Y.profile&&s.equals(J.profileScanOptions,Y.profileScanOptions)&&J.type===Y.type&&J.excludeObsolete===Y.excludeObsolete&&J.validate===Y.validate&&J.productVersion===Y.productVersion&&J.productDate===Y.productDate&&J.productCommit===Y.productCommit&&J.devMode===Y.devMode&&J.language===Y.language&&$.equals(J.translations,Y.translations)}}e.ExtensionScannerInput=q;let ie=class extends u.Disposable{constructor(J,Y,H,F,V){super(),this.f=J,this.g=Y,this.h=H,this.i=F,this.j=V}async scanExtensions(J){const Y=J.profile?await this.l(J):await this.k(J);let H={};if(J.excludeObsolete&&J.type===1)try{const F=(await this.i.readFile(this.f)).value.toString();H=JSON.parse(F)}catch{}return(0,r.isEmptyObject)(H)?Y:Y.filter(F=>!H[p.ExtensionKey.create(F).toString()])}async k(J){const Y=await this.i.resolve(J.location);if(!Y.children?.length)return[];const H=await Promise.all(Y.children.map(async F=>{if(!F.isDirectory||J.type===1&&(0,d.basename)(F.resource).indexOf(".")===0)return null;const V=new q(F.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(V)}));return(0,P.coalesce)(H).sort((F,V)=>F.location.path<V.location.path?-1:1)}async l(J){let Y=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){Y=Y.filter(F=>!F.metadata?.isApplicationScoped);const H=await this.m(J.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,J);Y.push(...H)}return Y}async m(J,Y,H){const F=await this.g.scanProfileExtensions(J,H.profileScanOptions);if(!F.length)return[];const V=await Promise.all(F.map(async Z=>{if(Y(Z)){const ne=new q(Z.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne,Z.metadata)}return null}));return(0,P.coalesce)(V)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,d.joinPath)(J.location,"package.json"))){const Y=await this.scanExtension(J);return Y?[Y]:[]}else return await this.scanExtensions(J)}catch(Y){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,R.getErrorMessage)(Y)),[]}}async scanExtension(J,Y){try{let H=await this.scanExtensionManifest(J.location);if(H){H.publisher||(H.publisher=C.UNDEFINED_PUBLISHER),Y=Y??H.__metadata,delete H.__metadata;const F=(0,p.getGalleryExtensionId)(H.publisher,H.name),V=Y?.id?{id:F,uuid:Y.id}:{id:F},Z=Y?.isSystem?0:J.type,ne=Z===0||!!Y?.isBuiltin;H=await this.n(J.location,H,q.createNlsConfiguration(J));const se={type:Z,identifier:V,manifest:H,location:J.location,isBuiltin:ne,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return J.validate?this.validate(se,J):se}}catch(H){J.type!==0&&this.j.error(H)}return null}validate(J,Y){let H=!0;const F=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,J.manifest,J.isBuiltin);for(const[V,Z]of F)V===b.default.Error&&(H=!1,this.j.error(this.s(Y.location,Z)));return J.isValid=H,J.validations=F,J}async scanExtensionManifest(J){const Y=(0,d.joinPath)(J,"package.json");let H;try{H=(await this.i.readFile(Y)).value.toString()}catch(V){return(0,c.toFileOperationResult)(V)!==1&&this.j.error(this.s(J,(0,g.localize)(0,null,Y.path,V.message))),null}let F;try{F=JSON.parse(H)}catch{const Z=[];(0,k.parse)(H,Z);for(const ne of Z)this.j.error(this.s(J,(0,g.localize)(1,null,Y.path,ne.offset,ne.length,(0,f.getParseErrorMessage)(ne.error))));return null}return(0,k.getNodeType)(F)!=="object"?(this.j.error(this.s(J,(0,g.localize)(2,null,Y.path))),null):F}async n(J,Y,H){const F=await this.p(J,Y,H);if(F)try{const V=[],Z=await this.q(F.default,V);if(V.length>0)return V.forEach(se=>{this.j.error(this.s(J,(0,g.localize)(3,null,F.default?.path,(0,f.getParseErrorMessage)(se.error))))}),Y;if((0,k.getNodeType)(F)!=="object")return this.j.error(this.s(J,(0,g.localize)(4,null,F.default?.path))),Y;const ne=F.values||Object.create(null);return(0,T.localizeManifest)(Y,ne,Z)}catch{}return Y}async p(J,Y,H){const F=(0,d.joinPath)(J,"package.nls.json"),V=(U,v)=>{v.forEach(O=>{this.j.error(this.s(J,(0,g.localize)(5,null,U?.path,(0,f.getParseErrorMessage)(O.error))))})},Z=U=>{this.j.error(this.s(J,(0,g.localize)(6,null,U?.path)))},ne=`${Y.publisher}.${Y.name}`,se=H.translations[ne];if(se)try{const U=h.URI.file(se),v=(await this.i.readFile(U)).value.toString(),O=[],W=(0,k.parse)(v,O);return O.length>0?(V(U,O),{values:void 0,default:F}):(0,k.getNodeType)(W)!=="object"?(Z(U),{values:void 0,default:F}):{values:W.contents?W.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.i.exists(F))return;let v;try{v=await this.r(J,H)}catch{return}if(!v.localized)return{values:void 0,default:v.original};try{const O=(await this.i.readFile(v.localized)).value.toString(),W=[],N=(0,k.parse)(O,W);return W.length>0?(V(v.localized,W),{values:void 0,default:v.original}):(0,k.getNodeType)(N)!=="object"?(Z(v.localized),{values:void 0,default:v.original}):{values:N,default:v.original}}catch{return{values:void 0,default:v.original}}}}async q(J,Y){if(J)try{const H=(await this.i.readFile(J)).value.toString();return(0,k.parse)(H,Y)}catch{}}r(J,Y){return new Promise((H,F)=>{const V=Z=>{const ne=(0,d.joinPath)(J,`package.nls.${Z}.json`);this.i.exists(ne).then(se=>{se&&H({localized:ne,original:(0,d.joinPath)(J,"package.nls.json")});const U=Z.lastIndexOf("-");U===-1?H({localized:(0,d.joinPath)(J,"package.nls.json"),original:null}):(Z=Z.substring(0,U),V(Z))})};if(Y.devMode||Y.pseudo||!Y.language)return H({localized:(0,d.joinPath)(J,"package.nls.json"),original:null});V(Y.language)})}s(J,Y){return`[${J.path}]: ${Y}`}};ie=ye([Q(1,m.IExtensionsProfileScannerService),Q(2,M.IUriIdentityService),Q(3,c.IFileService),Q(4,n.ILogService)],ie);let oe=class extends ie{constructor(J,Y,H,F,V,Z){super(Y,H,F,V,Z),this.w=J,this.u=this.D(new L.ThrottledDelayer(3e3)),this.v=this.D(new l.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions(J){const Y=await this.y();if(this.t=J,Y&&Y.input&&q.equals(Y.input,this.t))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.u.trigger(()=>this.C()),Y.result.map(F=>(F.location=h.URI.revive(F.location),F));const H=await super.scanExtensions(J);return await this.z({input:J,result:H}),H}async y(){try{const J=await this.i.readFile(this.w),Y=JSON.parse(J.value.toString());return{result:Y.result,input:(0,a.revive)(Y.input)}}catch(J){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,R.getErrorMessage)(J))}return null}async z(J){try{await this.i.writeFile(this.w,A.VSBuffer.fromString(JSON.stringify(J)))}catch(Y){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,R.getErrorMessage)(Y))}}async C(){if(!this.t)return;const J=await this.y();if(!J)return;const Y=J.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!s.equals(H,Y))try{this.j.info("Invalidating Cache",Y,H),await this.i.del(this.w),this.v.fire()}catch(F){this.j.error(F)}}};oe=ye([Q(2,m.IExtensionsProfileScannerService),Q(3,M.IUriIdentityService),Q(4,c.IFileService),Q(5,n.ILogService)],oe);function ae(ce,J){const Y=(0,p.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:Y,identifier:new C.ExtensionIdentifier(Y),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:J,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=ae;class de extends z{constructor(J,Y,H,F,V,Z,ne,se,U,v,O,W){super(J,Y,(0,d.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(F,C.MANIFEST_CACHE_FOLDER),V,Z,ne,se,U,v,O,W),this.M=(async()=>{if(S.translationsConfigFile)try{const N=await this.q.readFile(h.URI.file(S.translationsConfigFile));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(J){return this.M}}e.NativeExtensionsScannerService=de}),define(ee[270],te([0,1,5,40,39,24,80,16,34,8]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let w=class extends R.AbstractExtensionsProfileScannerService{constructor(S,d,I,b,r,h){super(u.URI.file(S.extensionsPath),d,I,b,r,h)}};w=ye([Q(0,f.INativeEnvironmentService),Q(1,k.IFileService),Q(2,L.IUserDataProfilesService),Q(3,s.IUriIdentityService),Q(4,A.ITelemetryService),Q(5,P.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(ee[271],te([0,1,8,34,80,124,16,6,5,21,39,40]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends A.NativeExtensionsScannerService{constructor(I,b,r,h,g,E,p,C){super(P.URI.file(g.builtinExtensionsPath),P.URI.file(g.extensionsPath),g.userHome,P.URI.file(g.userDataPath),I,b,r,h,g,E,p,C)}};S=ye([Q(0,y.IUserDataProfilesService),Q(1,s.IExtensionsProfileScannerService),Q(2,R.IFileService),Q(3,f.ILogService),Q(4,L.INativeEnvironmentService),Q(5,u.IProductService),Q(6,w.IUriIdentityService),Q(7,k.IInstantiationService)],S),e.ExtensionsScannerService=S}),define(ee[272],te([0,1,14,2,15,9,4,61,8,31,42,34,5,40]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends L.Disposable{constructor(r,h,g){super(),this.c=r,this.f=g,this.a=k.TernarySearchTree.forPaths(!R.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(r.appRoot),this.addValidFileRoot(r.extensionsPath),this.addValidFileRoot(h.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(r.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:r}=P.session;r.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(h,g)=>this.i(h,g)),r.protocol.interceptFileProtocol(s.Schemas.file,(h,g)=>this.h(h,g)),this.D((0,L.toDisposable)(()=>{r.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),r.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(r){const h=(0,A.normalize)(r);return this.a.get(h)?L.Disposable.None:(this.a.set(h,!0),(0,L.toDisposable)(()=>this.a.delete(h)))}h(r,h){const g=f.URI.parse(r.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${s.Schemas.file}: protocol (original URL: ${r.url})`),h({error:-3})}i(r,h){const g=this.j(r);let E;return this.c.crossOriginIsolated&&((0,A.basename)(g)==="workbench.html"||(0,A.basename)(g)==="workbench-dev.html"?E=s.COI.CoopAndCoep:E=s.COI.getHeadersFromQuery(r.url)),this.a.findSubstr(g)?h({path:g,headers:E}):this.b.has((0,A.extname)(g).toLowerCase())?h({path:g}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${r.url})`),h({error:-3}))}j(r){const h=f.URI.parse(r.url),g=s.FileAccess.uriToFileUri(h);return(0,A.normalize)(g.fsPath)}createIPCObjectUrl(){let r;const h=f.URI.from({scheme:"vscode",path:(0,u.generateUuid)()}),g=h.toString(),E=async()=>r;return w.validatedIpcMain.handle(g,E),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:h,update:p=>r=p,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),w.validatedIpcMain.removeHandler(g)}}}};I=ye([Q(0,y.INativeEnvironmentService),Q(1,d.IUserDataProfilesService),Q(2,S.ILogService)],I),e.ProtocolMainService=I}),define(ee[273],te([0,1,14,42,7,3,2,15,11,106,28,20,5,66,67,69,44,40,38,65,70,19,48,72,109]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let n=class extends R.Disposable{constructor(l,a,m,D,M,T,$,z,q,ie,oe){super(),this.i=l,this.j=a,this.k=m,this.l=D,this.m=M,this.n=T,this.q=$,this.r=z,this.s=q,this.t=ie,this.u=oe,this.a=this.D(new A.Emitter),this.onDidError=A.Event.buffer(this.a.event),this.b=new s.Barrier,this.c=void 0,this.f=void 0,this.g=void 0,this.h=(()=>{let ae=!1;if(c.canUseUtilityProcess){const de=this.u.getValue("window.experimental.sharedProcessUseUtilityProcess");typeof de=="boolean"?ae=de:ae=typeof d.default.quality=="string"&&d.default.quality!=="stable"}return ae})(),this.F=void 0,this.G=void 0,this.v(),this.h&&this.n.info("[SharedProcess] using utility process")}v(){L.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,a)=>this.w(l,a)),L.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,a)=>this.y(l,a)),this.D(this.m.onWillShutdown(()=>this.z()))}async w(l,a){this.n.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.b.isOpen()||this.b.open(),await this.whenReady();const m=await this.connect();if(l.sender.isDestroyed())return m.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[m])}y(l,a){this.n.trace("[SharedProcess] onWorkerConnection",a);const m=new R.DisposableStore,D=T=>{!this.O()||(this.n.trace(`[SharedProcess] disposing worker (reason: '${T}')`,a),m.dispose(),this.C("vscode:electron-main->shared-process=disposeWorker",a))},M=P.BrowserWindow.fromId(a.reply.windowId);if(!M||M.isDestroyed()||M.webContents.isDestroyed()||!a.reply.channel){D("unavailable");return}m.add(A.Event.filter(this.m.onWillLoadWindow,T=>T.window.win===M)(()=>D("load"))),m.add(A.Event.fromNodeEventEmitter(M,"closed")(()=>D("closed"))),M.webContents.postMessage(a.reply.channel,a.reply.nonce,l.ports)}z(){if(this.n.trace("[SharedProcess] onWillShutdown"),this.g)this.g.postMessage("vscode:electron-main->shared-process=exit"),this.g=void 0;else{const l=this.c;if(!l)return;this.C("vscode:electron-main->shared-process=exit"),this.f&&(l.removeListener("close",this.f),this.f=void 0),setTimeout(()=>{try{this.n.trace("[SharedProcess] onWillShutdown window.close()"),l.close()}catch(a){this.n.trace(`[SharedProcess] onWillShutdown window.close() error: ${a}`)}this.c=void 0},0)}}C(l,...a){if(!this.O()){this.n.warn(`Sending IPC message to channel '${l}' for shared process that is destroyed`);return}try{this.c?.webContents.send(l,...a)}catch(m){this.n.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,r.toErrorMessage)(m)}`)}}whenReady(){return this.F||(this.F=(async()=>{await this.H;const l=new s.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=init-done",()=>l.complete()):L.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>l.complete()),await l.p,this.n.trace("[SharedProcess] Overall ready")})()),this.F}get H(){return this.G||(this.G=(async()=>{await this.b.wait(),this.I();const l=new s.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=ipc-ready",()=>l.complete()):L.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>l.complete()),await l.p,this.n.trace("[SharedProcess] IPC ready")})()),this.G}I(){this.h?this.J():this.L(),this.N()}J(){this.g=this.D(new p.UtilityProcess(this.n,t.NullTelemetryService,this.m));const l=(0,i.parseSharedProcessDebugPort)(this.k.args,this.k.isBuilt);let a;l.port&&(a=["--nolazy"],l.break?a.push(`--inspect-brk=${l.port}`):a.push(`--inspect=${l.port}`)),this.g.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.M(),execArgv:a})}L(){const l=this.D(this.t.createIPCObjectUrl());this.c=new P.BrowserWindow({show:!1,backgroundColor:this.s.getBackgroundColor(),title:"shared-process",webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`],v8CacheOptions:this.k.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update(this.M()),this.c.loadURL(k.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.k.isBuilt?"":"-dev"}.html`).toString(!0))}M(){return{machineId:this.i,windowId:this.c?.id??-1,appRoot:this.k.appRoot,codeCachePath:this.k.codeCachePath,profiles:{home:this.l.profilesHome,all:this.l.profiles},userEnv:this.j,args:this.k.args,logLevel:this.q.getLogLevel(),loggers:this.q.getRegisteredLoggers(),product:d.default,policiesData:this.r.serialize()}}N(){this.c?(this.f=l=>{this.n.trace("SharedProcess#close prevented"),l.preventDefault(),this.c?.isVisible()&&this.c.hide()},this.c.on("close",this.f),this.c.webContents.on("render-process-gone",(l,a)=>this.a.fire({type:2,details:a})),this.c.on("unresponsive",()=>this.a.fire({type:1})),this.c.webContents.on("did-fail-load",(l,a,m)=>this.a.fire({type:3,details:{reason:m,exitCode:a}}))):this.g&&this.D(this.g.onCrash(l=>this.a.fire({type:2,details:{reason:l.reason,exitCode:l.code}})))}async connect(){return await this.H,this.g?this.g.connect():(0,u.connect)((0,f.assertIsDefined)(this.c))}async toggle(){await this.H,this.c&&(this.c.isVisible()?(this.c.webContents.closeDevTools(),this.c.hide()):(this.c.show(),this.c.webContents.openDevTools()))}isVisible(){return this.c?.isVisible()??!1}usingUtilityProcess(){return!!this.g}O(){const l=this.c;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};n=ye([Q(2,w.IEnvironmentMainService),Q(3,h.IUserDataProfilesService),Q(4,y.ILifecycleMainService),Q(5,S.ILogService),Q(6,E.ILoggerMainService),Q(7,g.IPolicyService),Q(8,b.IThemeMainService),Q(9,I.IProtocolMainService),Q(10,C.IConfigurationService)],n),e.SharedProcess=n}),define(ee[96],te([0,1,7,3,2,64,11,107,6,40]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var S;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function d(g){const E=g.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=d;class I extends s.Disposable{constructor(E={flushInterval:I.a}){super(),this.j=E,this.b=this.D(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new P.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new s.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,P.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,s.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(E,p){if(p===e.TARGET_KEY){switch(E){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:p,target:this.F(E)[p]})}q(E){this.f.fire({reason:E})}get(E,p,C){return this.L(p)?.get(E,C)}getBoolean(E,p,C){return this.L(p)?.getBoolean(E,C)}getNumber(E,p,C){return this.L(p)?.getNumber(E,C)}store(E,p,C,t){if((0,R.isUndefinedOrNull)(p)){this.remove(E,C);return}this.r(()=>{this.t(E,C,t),this.L(C)?.set(E,p)})}remove(E,p){this.r(()=>{this.t(E,p,void 0),this.L(p)?.delete(E)})}r(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,p){const C=[],t=this.F(E);for(const c of Object.keys(t))t[c]===p&&C.push(c);return C}t(E,p,C){const t=this.F(p);typeof C=="number"?t[E]!==C&&(t[E]=C,this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[E]=="number"&&(delete t[E],this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(E){switch(E){case-1:return this.C;case 0:return this.y;default:return this.v}}G(E){const p=this.L(E);return p?d(p):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=w.NONE){this.f.fire({reason:E});const p=this.L(-1),C=this.L(0),t=this.L(1);switch(E){case w.NONE:await P.Promises.settled([p?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await P.Promises.settled([p?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,C=this.L(1)?.items??new Map;return h(E,p,C,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(E,p){return this.q(w.NONE),(0,u.isUserDataProfile)(E)?this.N(E,p):this.O(E,p)}H(E,p){return!(E.id===p.id||b(p)&&b(E))}I(E,p,C,t){this.r(()=>{if(t)for(const[c,i]of E)p.set(c,i);else{const c=new Set;for(const[i,n]of E)c.add(i),p.get(i)!==n&&this.n(C,i);for(const[i]of p.items)c.has(i)||this.n(C,i)}})}}I.a=60*1e3,e.AbstractStorageService=I;function b(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class r extends I{constructor(){super(),this.p=this.D(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(E=>this.n(1,E))),this.D(this.P.onDidChangeStorage(E=>this.n(0,E))),this.D(this.p.onDidChangeStorage(E=>this.n(-1,E)))}L(E){switch(E){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(E){return!1}}e.InMemoryStorageService=r;async function h(g,E,p,C,t,c){const i=$=>{try{return JSON.parse($)}catch{return $}},n=new Map,o=new Map;g.forEach(($,z)=>{n.set(z,$),o.set(z,i($))});const l=new Map,a=new Map;E.forEach(($,z)=>{l.set(z,$),a.set(z,i($))});const m=new Map,D=new Map;p.forEach(($,z)=>{m.set(z,$),D.set(z,i($))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const M=[];if(n.forEach(($,z)=>{M.push({key:z,value:$})}),console.table(M),console.groupEnd(),console.log(o),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const $=[];l.forEach((z,q)=>{$.push({key:q,value:z})}),console.table($),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const T=[];m.forEach(($,z)=>{T.push({key:z,value:$})}),console.table(T),console.groupEnd(),console.log(D)}e.logStorage=h}),define(ee[274],te([0,1,26,7,3,2,9,74,8,23,107,157,5,96,24,29]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class r extends A.Disposable{get storage(){return this.f}constructor(c,i){super(),this.j=c,this.k=i,this.b=this.D(new s.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.D(new s.Emitter),this.onDidCloseStorage=this.c.event,this.f=new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new L.DeferredPromise,this.whenInit=this.h.p,this.i=w.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===w.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.D(c.onDidChangeStorage(n=>this.b.fire({key:n}))),await this.m(c);const i=c.getBoolean(d.IS_NEW_KEY);i===void 0?c.set(d.IS_NEW_KEY,!0):i&&c.set(d.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=w.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===S.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,i){return this.f.get(c,i)}set(c,i){return this.f.set(c,i)}delete(c){return this.f.delete(c)}async close(){const c=new k.StopWatch(!1);await this.r(),c.stop(),c.elapsed()>r.a&&await this.q(c),this.c.fire()}async q(c){if(!!this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([o,l])=>({key:o,length:l.length})),(o,l)=>l.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async r(){this.g&&await this.g,this.i=w.StorageState.Closed,await this.f.close()}}r.a=2e3;class h extends r{get path(){if(!this.u.useInMemoryStorage)return(0,R.join)(this.t.globalStorageHome.fsPath,h.s)}constructor(c,i,n,o){super(n,o),this.t=c,this.u=i}async n(){return new w.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:w.StorageHint.STORAGE_IN_MEMORY})}}h.s="state.vscdb";class g extends h{constructor(c,i,n,o){super(c,i,n,o)}}e.ProfileStorageMain=g;class E extends h{constructor(c,i,n,o){super(i.defaultProfile,c,n,o)}async m(c){await super.m(c),this.y(c)}y(c){c.get(I.firstSessionDateStorageKey,void 0)===void 0&&c.set(I.firstSessionDateStorageKey,new Date().toUTCString());const n=c.get(I.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();c.set(I.lastSessionDateStorageKey,typeof n>"u"?null:n),c.set(I.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=E;class p extends r{get path(){if(!this.v.useInMemoryStorage)return(0,R.join)(this.w.workspaceStorageHome.fsPath,this.u.id,p.s)}constructor(c,i,n,o,l){super(n,l),this.u=c,this.v=i,this.w=o}async n(){const{storageFilePath:c,wasCreated:i}=await this.z();return new w.Storage(new y.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.v.useInMemoryStorage?w.StorageHint.STORAGE_IN_MEMORY:i?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async z(){if(this.v.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,R.join)(this.w.workspaceStorageHome.fsPath,this.u.id),i=(0,R.join)(c,p.s);return await u.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await u.Promises.mkdir(c,{recursive:!0}),this.C(c),{storageFilePath:i,wasCreated:!0})}async C(c){let i;if((0,b.isSingleFolderWorkspaceIdentifier)(this.u)?i={folder:this.u.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.u)&&(i={workspace:this.u.configPath.toString()}),i)try{const n=(0,R.join)(c,p.t);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}p.s="state.vscdb",p.t="workspace.json",e.WorkspaceStorageMain=p;class C extends r{get path(){}async n(){return new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=C}),define(ee[275],te([0,1,3,2,96]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(k,f,u){super(),this.b=k,this.c=f,this.f=u;const w=this.D(new L.MutableDisposable);this.a=this.D(new P.Emitter({onWillAddFirstListener:()=>w.value=this.g(),onDidRemoveLastListener:()=>w.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new L.DisposableStore;return k.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.h(f))),k.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let w=f.get(u.profile.id);return w||f.set(u.profile.id,w={profile:u.profile,keys:[],storage:u.storage}),w.keys.push(u.key),f},100)(f=>this.i(f))),k}h(k){const f=k.includes(s.TARGET_KEY)?[this.c.defaultProfile]:[],u=[];if(k=k.filter(w=>w!==s.TARGET_KEY),k.length){const w=(0,s.loadKeyTargets)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:k.map(y=>({key:y,scope:0,target:w[y]}))})}this.j(f,u)}i(k){const f=[],u=new Map;for(const[w,y]of k.entries()){y.keys.includes(s.TARGET_KEY)&&f.push(y.profile);const S=y.keys.filter(d=>d!==s.TARGET_KEY);if(S.length){const d=(0,s.loadKeyTargets)(y.storage.storage);u.set(w,{profile:y.profile,changes:S.map(I=>({key:I,scope:0,target:d[I]}))})}}this.j(f,[...u.values()])}j(k,f){(k.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:k})}listen(k,f,u){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(k,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ee[276],te([0,1,8,34,16,5,33,39,40,11,117]),function(x,e,P,L,s,A,R,k,f,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=class ft extends f.UserDataProfilesService{constructor(b,r,h,g,E){super(h,g,r,E),this.O=b,this.P=h}I(){return this.O.getItem(ft.b,[]).map(r=>({...r,location:(0,u.isString)(r.location)?this.q.extUri.joinPath(this.profilesHome,r.location):P.URI.revive(r.location)}))}L(){const b=this.O.getItem(ft.c,{});return this.O.getItem(ft.a,!1)?b:this.H(b)}N(){return this.q.extUri.joinPath(P.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y.a="profileAssociationsMigration",y=ye([Q(0,R.IStateReadService),Q(1,k.IUriIdentityService),Q(2,L.INativeEnvironmentService),Q(3,s.IFileService),Q(4,A.ILogService)],y),e.UserDataProfilesReadonlyService=y;let S=class st extends y{constructor(b,r,h,g,E){super(b,r,h,g,E),this.U=b}J(b){b.length?this.U.setItem(st.b,b.map(r=>({...r,location:this.q.extUri.basename(r.location)}))):this.U.removeItem(st.b)}I(){const b=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(b),this.U.setItem("userDataProfilesMigration",!0)),b}M(b){b.emptyWindows||b.workspaces?this.U.setItem(st.c,b):this.U.removeItem(st.c)}L(){const b="workspaceAndProfileInfo",r=this.U.getItem(b,void 0);if(r){this.U.removeItem(b);const g=r.reduce((E,{workspace:p,profile:C})=>(E[P.URI.revive(p).toString()]=P.URI.revive(C).toString(),E),{});this.U.setItem(st.c,{workspaces:g})}const h=super.L();return this.U.getItem(st.a,!1)||(this.M(h),this.U.setItem(st.a,!0)),h}};S=ye([Q(0,R.IStateService),Q(1,k.IUriIdentityService),Q(2,L.INativeEnvironmentService),Q(3,s.IFileService),Q(4,A.ILogService)],S),e.UserDataProfilesService=S;let d=class extends S{constructor(b,r,h,g){super(new w.StateService(0,r,g,h),b,r,h,g)}async init(){return await this.U.init(),super.init()}};d=ye([Q(0,k.IUriIdentityService),Q(1,L.INativeEnvironmentService),Q(2,s.IFileService),Q(3,A.ILogService)],d),e.ServerUserDataProfilesService=d}),define(ee[53],te([0,1,34,16,6,5,39,40,276,33]),function(x,e,P,L,s,A,R,k,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,s.refineServiceDecorator)(k.IUserDataProfilesService);let w=class extends f.UserDataProfilesService{constructor(S,d,I,b,r){super(S,d,I,b,r)}getAssociatedEmptyWindows(){const S=[];for(const d of this.t.emptyWindows.keys())S.push({id:d});return S}};w=ye([Q(0,u.IStateService),Q(1,R.IUriIdentityService),Q(2,P.INativeEnvironmentService),Q(3,L.IFileService),Q(4,A.ILogService)],w),e.UserDataProfilesMainService=w}),define(ee[97],te([0,1,8,50,3,2,34,16,6,20,5,96,274,40,53,39]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let r=class extends A.Disposable{constructor(E,p,C,t,c,i){super(),this.c=E,this.f=p,this.g=C,this.h=t,this.i=c,this.j=i,this.a=void 0,this.b=this.D(new s.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.q=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.D(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.D(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,p]of this.n)E.join("profileStorage",p.close());for(const[,p]of this.q)E.join("workspaceStorage",p.close())})),this.D(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.i.exists(E.profile.globalStorageHome)||await this.i.createFolder(E.profile.globalStorageHome)})())})),this.D(this.g.onWillRemoveProfile(E=>{const p=this.n.get(E.profile.id);p&&E.join(p.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const E=new S.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,L.once)(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),E}profileStorage(E){if((0,y.isProfileUsingDefaultStorage)(E))return this.applicationStorage;let p=this.n.get(E.id);if(!p){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),p=this.p(E),this.n.set(E.id,p);const C=this.D(p.onDidChangeStorage(t=>this.b.fire({...t,storage:p,profile:E})));(0,L.once)(p.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.n.delete(E.id),C.dispose()})}return p}p(E){return this.a===2?new S.InMemoryStorageMain(this.c,this.i):new S.ProfileStorageMain(E,this.k(),this.c,this.i)}workspaceStorage(E){let p=this.q.get(E.id);return p||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),p=this.r(E),this.q.set(E.id,p),(0,L.once)(p.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.q.delete(E.id)})),p}r(E){return this.a===2?new S.InMemoryStorageMain(this.c,this.i):new S.WorkspaceStorageMain(E,this.k(),this.c,this.f,this.i)}isUsed(E){const p=P.URI.file(E);for(const C of[this.applicationStorage,...this.n.values(),...this.q.values()])if(!!C.path&&this.j.extUri.isEqualOrParent(P.URI.file(C.path),p))return!0;return!1}};r=ye([Q(0,w.ILogService),Q(1,R.IEnvironmentService),Q(2,I.IUserDataProfilesMainService),Q(3,u.ILifecycleMainService),Q(4,k.IFileService),Q(5,b.IUriIdentityService)],r),e.StorageMainService=r,e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let h=class extends y.AbstractStorageService{constructor(E,p){super(),this.p=E,this.s=p,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(E){if(E===-1)return this.s.applicationStorage.storage}M(E){if(E===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};h=ye([Q(0,d.IUserDataProfilesService),Q(1,e.IStorageMainService)],h),e.ApplicationStorageMainService=h}),define(ee[277],te([0,1,2,20,53,29,7,30]),function(x,e,P,L,s,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends P.Disposable{constructor(w,y,S){super(),this.a=y,this.b=S,this.D(w.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.D(w.onBeforeCloseWindow(d=>this.c(d))),this.D(new R.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(w){const y=this.f(w),S=this.a.getProfileForWorkspace(y);S?.isTransient&&(this.a.unsetWorkspace(y,S.isTransient),S.isTransient&&await this.a.cleanUpTransientProfiles())}f(w){return w.openedWorkspace??(0,A.toWorkspaceIdentifier)(w.backupPath,w.isExtensionDevelopmentHost)}g(){const w=this.a.getAssociatedEmptyWindows();if(w.length===0)return;const y=this.b.getWindows().map(S=>this.f(S));for(const S of w)y.some(d=>d.id===S.id)||this.a.unsetWorkspace(S,!1)}};f=ye([Q(0,L.ILifecycleMainService),Q(1,s.IUserDataProfilesMainService),Q(2,k.IWindowsMainService)],f),e.UserDataProfilesHandler=f}),define(ee[125],te([0,1,18,8,29]),function(x,e,P,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(f,u,w){for(const S of f){const d=S.openedWorkspace;if((0,s.isWorkspaceIdentifier)(d)){const I=await w(d);if(I){if(I.folders.some(b=>P.extUriBiasedIgnorePathCase.isEqualOrParent(u,b.uri)))return S}else if(P.extUriBiasedIgnorePathCase.isEqualOrParent(u,d.configPath))return S}}const y=f.filter(S=>(0,s.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqualOrParent(u,S.openedWorkspace.uri));if(y.length)return y.sort((S,d)=>-(S.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function R(f,u){for(const w of f)if((0,s.isWorkspaceIdentifier)(w.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.configPath,u)||(0,s.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.uri,u))return w}e.findWindowOnWorkspaceOrFolder=R;function k(f,u){const w=y=>u.some(S=>P.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(y)));for(const y of f)if(y.config?.extensionDevelopmentPath?.some(S=>w(S)))return y}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[278],te([0,1,14,2,4,18,8,19,20,5,33,30,123,29]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let I=class yt extends L.Disposable{get state(){return this.b}constructor(p,C,t,c,i){super(),this.g=p,this.h=C,this.i=t,this.j=c,this.k=i,this.b=b(this.h.getItem(yt.a)),this.c=void 0,this.f=!1,this.l()}l(){P.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(p=>this.p(p)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(p=>{p.newCount-p.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(p=>this.p(p))}m(){this.f=!0,this.n()}n(){const p=new Set,C={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!C.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(C.lastActiveWindow=this.q(i),C.lastActiveWindow.uiState.mode===3&&p.add(C.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(C.lastPluginDevelopmentHostWindow=this.q(t),C.lastPluginDevelopmentHostWindow.uiState.mode===3&&(p.has(C.lastPluginDevelopmentHostWindow.uiState.display)?s.isMacintosh&&!t.win?.isSimpleFullScreen()&&(C.lastPluginDevelopmentHostWindow.uiState.mode=1):p.add(C.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(C.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.q(i);return n.uiState.mode===3&&(p.has(n.uiState.display)?s.isMacintosh&&n.windowId!==C.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):p.add(n.uiState.display)),n}));const c=h(C);this.h.setItem(yt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(p){if(this.i.quitRequested)return;const C=this.q(p);p.isExtensionDevelopmentHost&&!p.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=C:!p.isExtensionDevelopmentHost&&p.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,d.isWorkspaceIdentifier)(p.openedWorkspace)&&t.workspace?.id===p.openedWorkspace.id,i=(0,d.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&t.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(t.folderUri,p.openedWorkspace.uri);(c||i)&&(t.uiState=C.uiState)}),this.g.getWindowCount()===1&&(this.c=C)}q(p){return{windowId:p.id,workspace:(0,d.isWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace.uri:void 0,backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.serializeWindowState()}}getNewWindowState(p){const C=this.r(p),t=this.k.getValue("window");if(C.mode===3){let c;C.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(C.mode=1)}return C}r(p){const C=this.g.getLastActiveWindow();if(!p.extensionTestsPath){if(!!p.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=p.workspace;if((0,d.isWorkspaceIdentifier)(l)){const m=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(m.length)return m[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(l)){const m=this.state.openedWindows.filter(D=>D.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(m.length)return m[0]}else if(p.backupPath){const m=this.state.openedWindows.filter(D=>D.backupPath===p.backupPath).map(D=>D.uiState);if(m.length)return m[0]}const a=this.c||this.state.lastActiveWindow;if(!C&&a)return a.uiState}let t;const c=P.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(s.isMacintosh){const l=P.screen.getCursorScreenPoint();t=P.screen.getDisplayNearestPoint(l)}!t&&C&&(t=P.screen.getDisplayMatching(C.getBounds())),t||(t=P.screen.getPrimaryDisplay()||c[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.k.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&C){const l=C.serializeWindowState();l.mode===3?i.mode=3:i=l,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.s(i)),i.hasDefaultState=!0,i}s(p){if(this.g.getWindows().length===0)return p;p.x=typeof p.x=="number"?p.x:0,p.y=typeof p.y=="number"?p.y:0;const C=this.g.getWindows().map(t=>t.getBounds());for(;C.some(t=>t.x===p.x||t.y===p.y);)p.x+=30,p.y+=30;return p}};I.a="windowsState",I=ye([Q(0,y.IWindowsMainService),Q(1,w.IStateService),Q(2,f.ILifecycleMainService),Q(3,u.ILogService),Q(4,k.IConfigurationService)],I),e.WindowsStateHandler=I;function b(E){const p={openedWindows:[]},C=E||{openedWindows:[]};return C.lastActiveWindow&&(p.lastActiveWindow=r(C.lastActiveWindow)),C.lastPluginDevelopmentHostWindow&&(p.lastPluginDevelopmentHostWindow=r(C.lastPluginDevelopmentHostWindow)),Array.isArray(C.openedWindows)&&(p.openedWindows=C.openedWindows.map(t=>r(t))),p}e.restoreWindowsState=b;function r(E){const p={uiState:E.uiState};return E.backupPath&&(p.backupPath=E.backupPath),E.remoteAuthority&&(p.remoteAuthority=E.remoteAuthority),E.folder&&(p.folderUri=R.URI.parse(E.folder)),E.workspaceIdentifier&&(p.workspace={id:E.workspaceIdentifier.id,configPath:R.URI.parse(E.workspaceIdentifier.configURIPath)}),p}function h(E){return{lastActiveWindow:E.lastActiveWindow&&g(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&g(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(p=>g(p))}}e.getWindowsStateStoreData=h;function g(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ee[98],te([0,1,32,43,130,45,15,9,4,18,8,6,57,29]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function I(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function b(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=b;function r(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=r;function h(D){return g(D)||E(D)}e.isStoredWorkspaceFolder=h;function g(D){const M=D;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function E(D){const M=D;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function p(D,M,T,$,z){if(D.scheme!==$.scheme)return{name:T,uri:D.toString(!0)};let q=M?void 0:z.relativePath($,D);if(q!==void 0)q.length===0?q=".":f.isWindows&&(q=C(q));else if(D.scheme===R.Schemas.file)q=D.fsPath,f.isWindows&&(q=C(q));else if(z.isEqualAuthority(D.authority,$.authority))q=D.path;else return{name:T,uri:D.toString(!0)};return{name:T,path:q}}e.getStoredWorkspaceFolder=p;function C(D){return D=(0,A.normalizeDriveLetter)(D),(0,P.isUNC)(D)||(D=(0,P.toSlashes)(D)),D}function t(D,M,T){const $=[],z=new Set,q=T.dirname(M);for(const ie of D){let oe;if(g(ie))ie.path&&(oe=T.resolvePath(q,ie.path));else if(E(ie))try{oe=w.URI.parse(ie.uri),oe.path[0]!==k.posix.sep&&(oe=oe.with({path:k.posix.sep+oe.path}))}catch(ae){console.warn(ae)}if(oe){const ae=T.getComparisonKey(oe);if(!z.has(ae)){z.add(ae);const de=ie.name||T.basenameOrAuthority(oe);$.push(new d.WorkspaceFolder({uri:oe,name:de,index:$.length},ie))}}}return $}e.toWorkspaceFolders=t;function c(D,M,T,$,z){const q=i(M,D),ie=z.dirname(M),oe=z.dirname($),ae=[];for(const Y of q.folders){const H=g(Y)?z.resolvePath(ie,Y.path):w.URI.parse(Y.uri);let F;T?F=!1:F=!g(Y)||(0,k.isAbsolute)(Y.path),ae.push(p(H,F,Y.name,oe,z))}const de={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ce=s.setProperty(D,["folders"],ae,de);let J=s.applyEdits(D,ce);return(0,u.isEqualAuthority)(q.remoteAuthority,(0,S.getRemoteAuthority)($))&&(J=s.applyEdits(J,s.removeProperty(J,["remoteAuthority"],de))),J}e.rewriteWorkspaceFileForNewLocation=c;function i(D,M){const T=L.parse(M);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter($=>h($));else throw new Error(`${D} looks like an invalid workspace file.`);return T}function n(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function o(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function a(D,M){const T={workspaces:[],files:[]};if(D){const $=function(q,ie){for(let oe=0;oe<q.length;oe++)try{ie(q[oe],oe)}catch(ae){M.warn(`Error restoring recent entry ${JSON.stringify(q[oe])}: ${ae.toString()}. Skip entry.`)}},z=D;Array.isArray(z.entries)&&$(z.entries,q=>{const ie=q.label,oe=q.remoteAuthority;n(q)?T.workspaces.push({label:ie,remoteAuthority:oe,workspace:{id:q.workspace.id,configPath:w.URI.parse(q.workspace.configPath)}}):o(q)?T.workspaces.push({label:ie,remoteAuthority:oe,folderUri:w.URI.parse(q.folderUri)}):l(q)&&T.files.push({label:ie,remoteAuthority:oe,fileUri:w.URI.parse(q.fileUri)})})}return T}e.restoreRecentlyOpened=a;function m(D){const M={entries:[]};for(const T of D.workspaces)b(T)?M.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):M.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of D.files)M.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return M}e.toStoreData=m}),define(ee[99],te([0,1,83,15,4,18]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(u){function w(){let y=u.scheme===L.Schemas.file?(0,A.originalFSPath)(u):u.toString();return s.isLinux||(y=y.toLowerCase()),(0,P.createHash)("md5").update(y).digest("hex")}return{id:w(),configPath:u}}e.getWorkspaceIdentifier=R;function k(u,w){function y(){if(u.scheme!==L.Schemas.file)return(0,P.createHash)("md5").update(u.toString()).digest("hex");if(!w)return;let d;return s.isLinux?d=w.ino:s.isMacintosh?d=w.birthtime.getTime():s.isWindows&&(typeof w.birthtimeMs=="number"?d=Math.floor(w.birthtimeMs):d=w.birthtime.getTime()),(0,P.createHash)("md5").update(u.fsPath).update(d?String(d):"").digest("hex")}const S=y();if(typeof S=="string")return{id:S,uri:u}}e.getSingleFolderWorkspaceIdentifier=k;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(ee[279],te([0,1,83,32,15,9,4,18,23,190,19,28,33,16,5,189,29,99]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let g=class bt{constructor(p,C,t,c){this.j=p,this.k=C,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,n)=>(0,L.isEqual)(i,n,!R.isLinux)}}async initialize(){const p=this.m.getItem(bt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(p.emptyWindows),this.d=await this.u((0,u.deserializeWorkspaceInfos)(p)),this.e=await this.v((0,u.deserializeFolderInfos)(p)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.HotExitConfiguration.OFF}q(){return this.s()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(p,C){this.d.some(c=>p.workspace.id===c.workspace.id)||(this.d.push(p),this.C());const t=(0,A.join)(this.c,p.workspace.id);return C?this.t(t,C).then(()=>t):t}async t(p,C){if(await f.Promises.exists(p)&&await this.z(p),await f.Promises.exists(C))try{await f.Promises.rename(C,p)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(p){return this.e.some(C=>this.h.isEqual(p.folderUri,C.folderUri))||(this.e.push(p),this.C()),(0,A.join)(this.c,this.D(p))}registerEmptyWindowBackup(p){return this.g.some(C=>!!C.backupFolder&&this.i.isEqual(C.backupFolder,p.backupFolder))||(this.g.push(p),this.C()),(0,A.join)(this.c,p.backupFolder)}async u(p){if(!Array.isArray(p))return[];const C=new Set,t=[];for(const c of p){const i=c.workspace;if(!(0,r.isWorkspaceIdentifier)(i))return[];if(!C.has(i.id)){C.add(i.id);const n=(0,A.join)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?t.push(c):await this.z(n):await this.x(n)}}return t}async v(p){if(!Array.isArray(p))return[];const C=[],t=new Set;for(const c of p){const i=c.folderUri,n=this.h.getComparisonKey(i);if(!t.has(n)){t.add(n);const o=(0,A.join)(this.c,this.D(c));await this.B(o)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?C.push(c):await this.z(o):await this.x(o)}}return C}async w(p){if(!Array.isArray(p))return[];const C=[],t=new Set;for(const c of p){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,A.join)(this.c,i);await this.B(n)?C.push(c):await this.x(n)}}return C}async x(p){try{await f.Promises.rm(p,f.RimRafMode.MOVE)}catch(C){this.l.error(`Backup: Could not delete stale backup: ${C.toString()}`)}}y(){let p=(0,h.createEmptyWorkspaceIdentifier)();for(;this.g.some(C=>!!C.backupFolder&&this.i.isEqual(C.backupFolder,p.id));)p=(0,h.createEmptyWorkspaceIdentifier)();return{backupFolder:p.id}}async z(p){const C=this.y(),t=(0,A.join)(this.c,C.backupFolder);try{await f.Promises.rename(p,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(C),!0}async getDirtyWorkspaces(){const p=[];for(const C of this.d)await this.A(C)&&p.push(C);for(const C of this.e)await this.A(C)&&p.push(C);return p}A(p){let C;return(0,u.isEmptyWindowBackupInfo)(p)?C=(0,A.join)(this.c,p.backupFolder):(0,b.isFolderBackupInfo)(p)?C=(0,A.join)(this.c,this.D(p)):C=(0,A.join)(this.c,p.workspace.id),this.B(C)}async B(p){try{const C=await f.Promises.readdir(p);for(const t of C)try{if((await f.Promises.readdir((0,A.join)(p,t))).length>0)return!0}catch{}}catch{}return!1}C(){const p={workspaces:this.d.map(({workspace:C,remoteAuthority:t})=>{const c={id:C.id,configURIPath:C.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:C,remoteAuthority:t})=>{const c={folderUri:C.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:C,remoteAuthority:t})=>{const c={backupFolder:C};return t&&(c.remoteAuthority=t),c})};this.m.setItem(bt.a,p)}D(p){const C=p.folderUri;let t;return C.scheme===s.Schemas.file?t=R.isLinux?C.fsPath:C.fsPath.toLowerCase():t=C.toString().toLowerCase(),(0,P.createHash)("md5").update(t).digest("hex")}};g.a="backupWorkspaces",g=ye([Q(0,y.IEnvironmentMainService),Q(1,w.IConfigurationService),Q(2,I.ILogService),Q(3,S.IStateService)],g),e.BackupMainService=g}),define(ee[54],te([0,1,14,3,43,2,15,9,18,11,23,188,63,58,28,6,5,53,125,29,98,99]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let t=class extends A.Disposable{constructor(i,n,o,l,a){super(),this.g=i,this.h=n,this.i=o,this.j=l,this.k=a,this.a=this.D(new L.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.D(new L.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await w.Promises.readdir(this.c.fsPath)).map(n=>(0,f.joinPath)(this.c,n,E.UNTITLED_WORKSPACE_NAME));for(const n of i){const o=(0,C.getWorkspaceIdentifier)(n),l=await this.resolveLocalWorkspace(n);l?this.f.push({workspace:o,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,n=>w.Promises.readFile(n,"utf8"))}l(i,n){if(!!this.m(i)&&i.scheme===R.Schemas.file)try{const o=n(i.fsPath);return o instanceof Promise?o.then(l=>this.n(i,l),l=>{}):this.n(i,o)}catch{return}}m(i){return(0,E.isUntitledWorkspace)(i,this.g)||(0,E.hasWorkspaceFileExtension)(i)}n(i,n){try{const o=this.p(i,n),l=(0,C.getWorkspaceIdentifier)(i);return{id:l.id,configPath:l.configPath,folders:(0,p.toWorkspaceFolders)(o.folders,l.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(i,n){const o=(0,s.parse)(n);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(l=>(0,p.isStoredWorkspaceFolder)(l));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,n){const{workspace:o,storedWorkspace:l}=this.q(i,n),a=o.configPath.fsPath;return await w.Promises.mkdir((0,k.dirname)(a),{recursive:!0}),await w.Promises.writeFile(a,JSON.stringify(l,null,"	")),this.f.push({workspace:o,remoteAuthority:n}),o}q(i=[],n){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,f.joinPath)(this.c,o),a=(0,f.joinPath)(l,E.UNTITLED_WORKSPACE_NAME),m=[];for(const D of i)m.push((0,p.getStoredWorkspaceFolder)(D.uri,!0,D.name,l,f.extUriBiasedIgnorePathCase));return{workspace:(0,C.getWorkspaceIdentifier)(a),storedWorkspace:{folders:m,remoteAuthority:n}}}async getWorkspaceIdentifier(i){return(0,C.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,E.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.r(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async r(i){const n=(0,f.originalFSPath)(i.configPath);try{await w.Promises.rm((0,k.dirname)(n));const o=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await w.Promises.exists(o)&&await w.Promises.writeFile((0,k.join)(o,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==i.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${n} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,n,o){if(!i||!i.win||!i.isReady||!await this.s(i,n,o))return;const a=await this.t(i,(0,C.getWorkspaceIdentifier)(o));if(!!a)return this.b.fire({window:i,workspace:a.workspace}),a}async s(i,n,o){return o?(0,E.isWorkspaceIdentifier)(i.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,g.findWindowOnWorkspaceOrFolder)(n,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,f.basename)(o)),detail:(0,y.localize)(2,null)},(0,u.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),!1):!0:!0}async t(i,n){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority})),(0,E.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=n,i.config.backupPath=o,{workspace:n,backupPath:o}}};t=ye([Q(0,I.IEnvironmentMainService),Q(1,r.ILogService),Q(2,h.IUserDataProfilesMainService),Q(3,S.IBackupMainService),Q(4,d.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(ee[126],te([0,1,14,42,22,6,30,29,54,11,5,70]),function(x,e,P,L,s,A,R,k,f,u,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let S=class{constructor(I,b,r){this.a=I,this.b=b,this.c=r}async getRemoteDiagnostics(I){const b=this.a.getWindows();return(await Promise.all(b.map(async h=>{const g=h.remoteAuthority;if(!g)return;const E=`vscode:getDiagnosticInfoResponse${h.id}`,p={includeProcesses:I.includeProcesses,folders:I.includeWorkspaceMetadata?await this.f(h):void 0};return new Promise(C=>{h.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:E,args:p}),L.validatedIpcMain.once(E,(t,c)=>{c||C({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),C(c)}),setTimeout(()=>{C({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(h=>!!h)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const I=[];for(const r of P.BrowserWindow.getAllWindows()){const h=this.a.getWindowById(r.id);h?I.push(await this.d(h)):I.push(this.e(r))}const b=[];for(const{pid:r,name:h}of y.UtilityProcess.getAll())b.push({pid:r,name:h});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:I,pidToNames:b,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(I){const b=await this.f(I),r=(0,u.assertIsDefined)(I.win);return this.e(r,b,I.remoteAuthority)}e(I,b=[],r){return{id:I.id,pid:I.webContents.getOSProcessId(),title:I.getTitle(),folderURIs:b,remoteAuthority:r}}async f(I){const b=[],r=I.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(r))b.push(r.uri);else if((0,k.isWorkspaceIdentifier)(r)){const h=await this.b.resolveLocalWorkspace(r.configPath);h&&h.folders.forEach(E=>{b.push(E.uri)})}return b}};S=ye([Q(0,R.IWindowsMainService),Q(1,f.IWorkspacesManagementMainService),Q(2,w.ILogService)],S),e.DiagnosticsMainService=S}),define(ee[59],te([0,1,46,14,27,151,55,3,2,15,9,4,8,103,86,23,101,178,58,28,6,20,5,21,69,30,29,54,17,237,230,33]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i,n,o,l,a,m,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,p.createDecorator)("nativeHostMainService");let T=class extends f.Disposable{constructor(z,q,ie,oe,ae,de,ce,J,Y,H){super(),this.a=z,this.b=q,this.c=ie,this.f=oe,this.g=ae,this.h=de,this.i=ce,this.j=J,this.k=Y,this.l=H,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,F=>F.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:F,x:V,y:Z})=>({windowId:F.id,x:V,y:Z})),({windowId:F})=>!!this.b.getWindowById(F)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(F,V)=>V.id),F=>!!this.b.getWindowById(F)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(F,V)=>V.id),F=>!!this.b.getWindowById(F)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(F,V)=>V.id),F=>!!this.b.getWindowById(F)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),F=>!!F),F=>F.id),k.Event.filter(k.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(F,V)=>V.id),F=>!!this.b.getWindowById(F))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.D(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(F,V,Z)=>Z),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),k.Event.fromNodeEventEmitter(L.screen,"display-added"),k.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(q=>({id:q.id,workspace:q.openedWorkspace??(0,o.toWorkspaceIdentifier)(q.backupPath,q.isExtensionDevelopmentHost),title:q.win?.getTitle()??"",filename:q.getRepresentedFilename(),dirty:q.isDocumentEdited()}))}async getWindowCount(z){return this.b.getWindowCount()}async getActiveWindowId(z){const q=L.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(q)return q.id}openWindow(z,q,ie){return Array.isArray(q)?this.n(z,q,ie):this.p(z,q)}async n(z,q,ie=Object.create(null)){q.length>0&&await this.b.open({context:5,contextWindowId:z,urisToOpen:q,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p(z,q){await this.b.openEmptyWindow({context:5,contextWindowId:z},q)}async toggleFullScreen(z){this.v(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.v(z)?.handleTitleDoubleClick()}async isMaximized(z){const q=this.v(z);return q?.win?q.win.isMaximized():!1}async maximizeWindow(z){const q=this.v(z);q?.win&&q.win.maximize()}async unmaximizeWindow(z){const q=this.v(z);q?.win&&q.win.unmaximize()}async minimizeWindow(z){const q=this.v(z);q?.win&&q.win.minimize()}async updateWindowControls(z,q){const ie=this.v(z);ie&&ie.updateWindowControls(q)}async focusWindow(z,q){q&&typeof q.windowId=="number"&&(z=q.windowId),this.v(z)?.focus({force:q?.force??!1})}async setMinimumSize(z,q,ie){const oe=this.v(z);if(oe?.win){const[ae,de]=oe.win.getSize(),[ce,J]=oe.win.getMinimumSize(),[Y,H]=[q??ce,ie??J],[F,V]=[Math.max(ae,Y),Math.max(de,H)];(ce!==Y||J!==H)&&oe.win.setMinimumSize(Y,H),(ae!==F||de!==V)&&oe.win.setSize(F,V)}}async saveWindowSplash(z,q){this.j.saveWindowSplash(z,q)}async installShellCommand(z){const{source:q,target:ie}=await this.q();try{const{symbolicLink:oe}=await b.SymlinkSupport.stat(q);if(oe&&!oe.dangling){const ae=await(0,d.realpath)(q);if(ie===ae)return}await b.Promises.unlink(q)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await b.Promises.symlink(ie,q)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:ae}=await this.showMessageBox(z,{type:"info",message:(0,h.localize)(0,null,this.i.nameShort),buttons:[(0,h.localize)(1,null),(0,h.localize)(2,null)]});if(ae===0)try{const de=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${q}'\\" with administrator privileges"`;await(0,A.promisify)(P.exec)(de)}catch{throw new Error((0,h.localize)(3,null,q))}}}async uninstallShellCommand(z){const{source:q}=await this.q();try{await b.Promises.unlink(q)}catch(ie){switch(ie.code){case"EACCES":{const{response:oe}=await this.showMessageBox(z,{type:"info",message:(0,h.localize)(4,null,this.i.nameShort),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]});if(oe===0)try{const ae=`osascript -e "do shell script \\"rm '${q}'\\" with administrator privileges"`;await(0,A.promisify)(P.exec)(ae)}catch{throw new Error((0,h.localize)(7,null,q))}break}case"ENOENT":break;default:throw ie}}}async q(){const z=(0,w.resolve)(this.g.appRoot,"bin","code"),q=`/usr/local/bin/${this.i.applicationName}`;if(!await b.Promises.exists(z))throw new Error((0,h.localize)(8,null,z));return{source:q,target:z}}async showMessageBox(z,q){return this.c.showMessageBox(q,this.r(z))}async showSaveDialog(z,q){return this.c.showSaveDialog(q,this.r(z))}async showOpenDialog(z,q){return this.c.showOpenDialog(q,this.r(z))}r(z){const q=this.v(z);if(q?.win)return q.win}async pickFileFolderAndOpen(z,q){const ie=await this.c.pickFileFolder(q);ie&&await this.s(await Promise.all(ie.map(async oe=>await b.SymlinkSupport.existsDirectory(oe)?{folderUri:S.URI.file(oe)}:{fileUri:S.URI.file(oe)})),q,z)}async pickFolderAndOpen(z,q){const ie=await this.c.pickFolder(q);ie&&await this.s(ie.map(oe=>({folderUri:S.URI.file(oe)})),q,z)}async pickFileAndOpen(z,q){const ie=await this.c.pickFile(q);ie&&await this.s(ie.map(oe=>({fileUri:S.URI.file(oe)})),q,z)}async pickWorkspaceAndOpen(z,q){const ie=await this.c.pickWorkspace(q);ie&&await this.s(ie.map(oe=>({workspaceUri:S.URI.file(oe)})),q,z)}async s(z,q,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:z,forceNewWindow:q.forceNewWindow})}async showItemInFolder(z,q){L.shell.showItemInFolder(q)}async setRepresentedFilename(z,q){this.v(z)?.setRepresentedFilename(q)}async setDocumentEdited(z,q){this.v(z)?.setDocumentEdited(q)}async openExternal(z,q){return y.isLinuxSnap?this.t(q):L.shell.openExternal(q),!0}t(z){const q=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=q,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(z,q){return L.shell.trashItem(q)}async isAdmin(){let z;return y.isWindows?z=(await new Promise((q,ie)=>{x(["native-is-elevated"],q,ie)}))():z=process.getuid()===0,z}async writeElevated(z,q,ie,oe){const ae=await new Promise((de,ce)=>{x(["@vscode/sudo-prompt"],de,ce)});return new Promise((de,ce)=>{const J=[`"${this.u}"`];oe?.unlock&&J.push("--file-chmod"),J.push("--file-write",`"${q.fsPath}"`,`"${ie.fsPath}"`);const Y={name:this.i.nameLong.replace("-",""),icns:y.isMacintosh&&this.g.isBuilt?(0,w.join)((0,w.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(J.join(" "),Y,(H,F,V)=>{F&&this.h.trace(`[sudo-prompt] received stdout: ${F}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),H?ce(H):de(void 0)})})}get u(){return y.isWindows?this.g.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,w.join)(this.g.appRoot,"scripts","code-cli.bat"):y.isLinux?this.g.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,w.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,w.join)(this.g.appRoot,"bin","code"):(0,w.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return I.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,m.hasWSLFeatureInstalled)()}async killProcess(z,q,ie){process.kill(q,ie)}async readClipboardText(z,q){return L.clipboard.readText(q)}async writeClipboardText(z,q,ie){return L.clipboard.writeText(q,ie)}async readClipboardFindText(z){return L.clipboard.readFindText()}async writeClipboardFindText(z,q){return L.clipboard.writeFindText(q)}async writeClipboardBuffer(z,q,ie,oe){return L.clipboard.writeBuffer(q,Buffer.from(ie.buffer),oe)}async readClipboardBuffer(z,q){return a.VSBuffer.wrap(L.clipboard.readBuffer(q))}async hasClipboard(z,q,ie){return L.clipboard.has(q,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,q){this.v(z)?.updateTouchBar(q)}async notifyReady(z){this.v(z)?.setReady()}async relaunch(z,q){return this.f.relaunch(q)}async reload(z,q){const ie=this.v(z);if(ie){if((0,o.isWorkspaceIdentifier)(ie.openedWorkspace)){const oe=ie.openedWorkspace.configPath;if(oe.scheme===u.Schemas.file&&(await this.l.resolveLocalWorkspace(oe))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,q?.disableExtensions!==void 0?{_:[],"disable-extensions":q.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,q){const ie=this.v(q);if(ie?.win)return ie.win.close()}async quit(z){const q=this.b.getLastActiveWindow();q?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&q.win?q.win.close():this.f.quit()}async exit(z,q){await this.f.kill(q)}async resolveProxy(z,q){return this.v(z)?.win?.webContents?.session?.resolveProxy(q)}findFreePort(z,q,ie,oe,ae=1){return(0,r.findFreePort)(q,ie,oe,ae)}async openDevTools(z,q){const ie=this.v(z);ie?.win&&ie.win.webContents.openDevTools(q)}async toggleDevTools(z){const q=this.v(z);q?.win&&q.win.webContents.toggleDevTools()}async sendInputEvent(z,q){const ie=this.v(z);ie?.win&&(q.type==="mouseDown"||q.type==="mouseUp")&&ie.win.webContents.sendInputEvent(q)}async enableSandbox(z,q){q?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(z,q,ie){const oe=this.v(z);if(!oe||!oe.win)throw new Error;return await new D.WindowProfiler(oe.win,q,this.h).inspect(ie)}async windowsGetStringRegKey(z,q,ie,oe){if(!y.isWindows)return;const ae=await new Promise((de,ce)=>{x(["@vscode/windows-registry"],de,ce)});try{return ae.GetStringRegKey(q,ie,oe)}catch{return}}v(z){if(typeof z=="number")return this.b.getWindowById(z)}};ye([R.memoize],T.prototype,"u",null),T=ye([Q(1,n.IWindowsMainService),Q(2,g.IDialogMainService),Q(3,C.ILifecycleMainService),Q(4,E.IEnvironmentMainService),Q(5,t.ILogService),Q(6,c.IProductService),Q(7,i.IThemeMainService),Q(8,M.IStateService),Q(9,l.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(ee[280],te([0,1,14,42,27,2,15,4,104,176,89,126,58,28,6,5,59,66,21,67,79,32,11,33,70]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,I.createDecorator)("issueMainService");const n="issue.processExplorerWindowState";let o=class kt{constructor(m,D,M,T,$,z,q,ie,oe,ae){this.g=m,this.h=D,this.i=M,this.j=T,this.k=$,this.l=z,this.m=q,this.n=ie,this.o=oe,this.p=ae,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){L.validatedIpcMain.on("vscode:issueSystemInfoRequest",async m=>{const[D,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.j.getSystemInfo(D,M);this.r(m,"vscode:issueSystemInfoResponse",T)}),L.validatedIpcMain.on("vscode:listProcesses",async m=>{const D=[];try{D.push({name:(0,u.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,w.isRemoteDiagnosticError)(T)?D.push({name:T.hostName,rootProcess:T}):T.processes&&D.push({name:T.hostName,rootProcess:T.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.r(m,"vscode:listProcessesResponse",D)}),L.validatedIpcMain.on("vscode:issueReporterClipboard",async m=>{if(this.b){const{response:D}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(1,null),buttons:[(0,u.localize)(2,null),(0,u.localize)(3,null)]},this.b);this.r(m,"vscode:issueReporterClipboardResponse",D===0)}}),L.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async m=>{const D=await this.v();this.r(m,"vscode:issuePerformanceInfoResponse",D)}),L.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:m}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(4,null),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]},this.b);m===0&&this.b&&(this.b.destroy(),this.b=null)}}),L.validatedIpcMain.on("vscode:workbenchCommand",(m,D)=>{const{id:M,from:T,args:$}=D;let z;switch(T){case"issueReporter":z=this.c;break;case"processExplorer":z=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}z?.webContents.send("vscode:runAction",{id:M,from:T,args:$})}),L.validatedIpcMain.on("vscode:openExternal",(m,D)=>{this.m.openExternal(void 0,D)}),L.validatedIpcMain.on("vscode:closeIssueReporter",m=>{this.b?.close()}),L.validatedIpcMain.on("vscode:closeProcessExplorer",m=>{this.d?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async m=>{const D=await this.k.getMainDiagnostics(),M=[];for(const T of D.windows)M.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:$}of i.UtilityProcess.getAll())M.push([T,$]);this.r(m,"vscode:pidToNameResponse",M)})}r(m,D,...M){m.sender.isDestroyed()||m.sender.send(D,...M)}async openReporter(m){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const D=new A.DisposableStore,M=D.add(this.n.createIPCObjectUrl()),T=this.u(this.c,700,800);this.b=this.t(T,M,{backgroundColor:m.styles.backgroundColor,title:(0,u.localize)(7,null),zoomLevel:m.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:m,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:h.default}),this.b.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,D.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,D.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(m){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const D=new A.DisposableStore,M=D.add(this.n.createIPCObjectUrl()),T=this.p.getItem(n,void 0),$=l(T)?T:this.u(this.f,800,500);this.d=this.t($,M,{backgroundColor:m.styles.backgroundColor,title:(0,u.localize)(8,null),zoomLevel:m.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:m,product:h.default}),this.d.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,D.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,D.dispose())});const z=()=>{if(!this.d)return;const q=this.d.getSize(),ie=this.d.getPosition();if(!q||!ie)return;const oe={width:q[0],height:q[1],x:ie[0],y:ie[1]};this.p.setItem(n,oe)};this.d.on("moved",z),this.d.on("resized",z)}this.d&&this.s(this.d)}s(m){m.isMinimized()&&m.restore(),m.focus()}t(m,D,M,T){const $=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:m.width,height:m.height,minWidth:300,minHeight:200,x:m.x,y:m.y,title:M.title,backgroundColor:M.backgroundColor||kt.a,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${D.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,p.zoomLevelToZoomFactor)(M.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return $.setMenuBarVisibility(!1),$}async getSystemStatus(){const[m,D]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(m,D)}u(m,D,M){let T;const $=P.screen.getAllDisplays();if($.length===1)T=$[0];else{if(k.isMacintosh){const ie=P.screen.getCursorScreenPoint();T=P.screen.getDisplayNearestPoint(ie)}!T&&m&&(T=P.screen.getDisplayMatching(m.getBounds())),T||(T=P.screen.getPrimaryDisplay()||$[0])}const z=T.bounds,q={width:D,height:M,x:z.x+z.width/2-D/2,y:z.y+z.height/2-M/2};return z.width>0&&z.height>0&&(q.x<z.x&&(q.x=z.x),q.y<z.y&&(q.y=z.y),q.x>z.x+z.width&&(q.x=z.x),q.y>z.y+z.height&&(q.y=z.y),q.width>z.width&&(q.width=z.width),q.height>z.height&&(q.height=z.height)),q}async v(){try{const[m,D]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(m,D)}catch(m){throw this.i.warn("issueService#getPerformanceInfo ",m.message),m}}async stopTracing(){if(!this.h.args.trace)return;const m=await P.contentTracing.stopRecording(`${(0,C.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(9,null),detail:(0,u.localize)(10,null,m),buttons:[(0,u.localize)(11,null)]},(0,t.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,m)}};o.a="#1E1E1E",o=ye([Q(1,d.IEnvironmentMainService),Q(2,b.ILogService),Q(3,w.IDiagnosticsService),Q(4,y.IDiagnosticsMainService),Q(5,S.IDialogMainService),Q(6,r.INativeHostMainService),Q(7,E.IProtocolMainService),Q(8,g.IProductService),Q(9,c.IStateService)],o),e.IssueMainService=o;function l(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(ee[281],te([0,1,22,19,28,20,5,59,21,52,24,49,95]),function(x,e,P,L,s,A,R,k,f,u,w,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends S.AbstractUpdateService{constructor(b,r,h,g,E,p,C,t){super(b,r,g,E,p,t),this.e=h,this.t=C}r(b){return(0,S.createUpdateURL)(`linux-${process.arch}`,b,this.k)}s(b){!this.a||(this.d(y.State.CheckingForUpdates(b)),this.i.request({url:this.a},P.CancellationToken.None).then(u.asJson).then(r=>{!r||!r.url||!r.version||!r.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(y.State.Idle(1))):this.d(y.State.AvailableForDownload(r))}).then(void 0,r=>{this.j.error(r),this.e.publicLog2("update:notAvailable",{explicit:!!b});const h=b?r.message||r:void 0;this.d(y.State.Idle(1,h))}))}async n(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.t.openExternal(void 0,b.update.url),this.d(y.State.Idle(1))}};d=ye([Q(0,A.ILifecycleMainService),Q(1,L.IConfigurationService),Q(2,w.ITelemetryService),Q(3,s.IEnvironmentMainService),Q(4,u.IRequestService),Q(5,R.ILogService),Q(6,k.INativeHostMainService),Q(7,f.IProductService)],d),e.LinuxUpdateService=d}),define(ee[282],te([0,1,46,41,27,7,22,55,9,8,137,23,19,28,16,20,5,59,21,52,24,49,95]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(l,a=1e3){for(;!l();)await(0,A.timeout)(a)}let i;function n(){return typeof i>"u"&&(i=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends t.AbstractUpdateService{get cachePath(){const a=f.join((0,s.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return y.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,m,D,M,T,$,z,q,ie){super(a,m,M,T,$,ie),this.t=D,this.u=z,this.v=q}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(a){let m="win32";return process.arch!=="ia32"&&(m+=`-${process.arch}`),n()===1?m+="-archive":this.k.target==="user"&&(m+="-user"),(0,t.createUpdateURL)(m,a,this.k)}s(a){!this.a||(this.d(C.State.CheckingForUpdates(a)),this.i.request({url:this.a},R.CancellationToken.None).then(E.asJson).then(m=>{const D=n();return!m||!m.url||!m.version||!m.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!a}),this.d(C.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(C.State.AvailableForDownload(m)),Promise.resolve(null)):(this.d(C.State.Downloading(m)),this.A(m.version).then(()=>this.z(m.version).then(M=>y.Promises.exists(M).then(T=>{if(T)return Promise.resolve(M);const $=m.url,z=m.hash,q=`${M}.tmp`;return this.i.request({url:$},R.CancellationToken.None).then(ie=>this.u.writeFile(u.URI.file(q),ie.stream)).then(z?()=>(0,w.checksum)(q,m.hash):()=>{}).then(()=>y.Promises.rename(q,M)).then(()=>M)})).then(M=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:M},T&&m.supportsFastUpdate?this.k.target==="user"?this.o():this.d(C.State.Downloaded(m)):this.d(C.State.Ready(m))})))}).then(void 0,m=>{this.j.error(m),this.t.publicLog2("update:notAvailable",{explicit:!!a});const D=a?m.message||m:void 0;this.d(C.State.Idle(n(),D))}))}async n(a){a.update.url&&this.v.openExternal(void 0,a.update.url),this.d(C.State.Idle(n()))}async z(a){const m=await this.cachePath;return f.join(m,`CodeSetup-${this.k.quality}-${a}.exe`)}async A(a=null){const m=a?$=>!new RegExp(`${this.k.quality}-${a}\\.exe$`).test($):()=>!0,D=await this.cachePath,T=(await y.Promises.readdir(D)).filter(m).map(async $=>{try{await y.Promises.unlink(f.join(D,$))}catch{}});await Promise.all(T)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const a=this.state.update;this.d(C.State.Updating(a));const m=await this.cachePath;this.e.updateFilePath=f.join(m,`CodeSetup-${this.k.quality}-${a.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(C.State.Idle(n()))});const M=`${this.k.win32MutexName}-ready`,T=await new Promise(($,z)=>{x(["windows-mutex"],$,z)});c(()=>T.isActive(M)).then(()=>this.d(C.State.Ready(a)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?L.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return n()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const m=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!m};this.d(C.State.Downloading(D)),this.e={packagePath:a},m?this.k.target==="user"?this.o():this.d(C.State.Downloaded(D)):this.d(C.State.Ready(D))}};ye([k.memoize],o.prototype,"cachePath",null),o=ye([Q(0,b.ILifecycleMainService),Q(1,S.IConfigurationService),Q(2,p.ITelemetryService),Q(3,d.IEnvironmentMainService),Q(4,E.IRequestService),Q(5,r.ILogService),Q(6,I.IFileService),Q(7,h.INativeHostMainService),Q(8,g.IProductService)],o),e.Win32UpdateService=o}),define(ee[283],te([0,1,14,7,22,44,3,2,15,9,64,4,8,184,63,19,58,28,62,16,20,5,21,67,245,97,24,136,69,79,30,29,54,123,127,38,33,53,59,247,119,48,94,27,120,65]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i,n,o,l,a,m,D,M,T,$,z,q,ie,oe,ae,de,ce,J,Y,H,F,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Z;(function(se){se[se.NONE=0]="NONE",se[se.NAVIGATING=1]="NAVIGATING",se[se.READY=2]="READY"})(Z||(Z={}));let ne=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.q?.backupPath}get openedWorkspace(){return this.q?.workspace}get profile(){if(!this.config)return;const U=this.Q.profiles.find(v=>v.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.Q.getProfileForWorkspace(this.config.workspace??(0,M.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.q?.remoteAuthority}get config(){return this.q}get isExtensionDevelopmentHost(){return!!this.q?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.q?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.q?.debugId}constructor(U,v,O,W,N,G,j,B,K,re,he,ve,Se,Oe,Le,Fe,me,pe,Ce,_,le){super(),this.M=v,this.N=O,this.O=W,this.P=N,this.Q=G,this.R=j,this.S=B,this.U=K,this.W=re,this.X=he,this.Y=ve,this.Z=Se,this.ab=Oe,this.bb=Le,this.db=Fe,this.eb=me,this.fb=pe,this.gb=Ce,this.hb=_,this.ib=le,this.c=this.D(new R.Emitter),this.onWillLoad=this.c.event,this.f=this.D(new R.Emitter),this.onDidSignalReady=this.f.event,this.g=this.D(new R.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.D(new R.Emitter),this.onDidClose=this.h.event,this.j=this.D(new R.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.D(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let fe=!1;{const[ke,Me]=this.ub(U.state);this.r=ke,this.M.trace("window#ctor: using window state",ke);const Te=this.r.mode===0||this.r.mode===3;typeof ot.b>"u"&&(ot.b=this.hb.getItem("window.experimental.useSandbox",!1));const We=this.W.getValue("window");typeof We?.experimental?.useSandbox=="boolean"?fe=We.experimental.useSandbox:this.eb.quality==="stable"&&ot.b?fe=!0:fe=typeof this.eb.quality=="string"&&this.eb.quality!=="stable",this.n=fe;const $e={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.X.getBackgroundColor(),minWidth:m.WindowMinimumSize.WIDTH,minHeight:m.WindowMinimumSize.HEIGHT,show:!Te,title:this.eb.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.zoomLevelToZoomFactor)(We?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...fe?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?$e.icon=(0,u.join)(this.O.appRoot,"resources/linux/code.png"):y.isWindows&&!this.O.isBuilt&&($e.icon=(0,u.join)(this.O.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.Bb()&&($e.fullscreenable=!1),y.isMacintosh&&($e.acceptFirstMouse=!0,We?.clickThroughInactive===!1&&($e.acceptFirstMouse=!1));const qe=y.isMacintosh&&We?.nativeTabs===!0;qe&&($e.tabbingIdentifier=this.eb.nameShort);const Ue=(0,m.getTitleBarStyle)(this.W)==="custom";if(Ue&&($e.titleBarStyle="hidden",y.isMacintosh||($e.frame=!1),(0,m.useWindowControlsOverlay)(this.W))){const He=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),X=z.Color.fromHex(He).isDarker()?"#FFFFFF":"#000000";$e.titleBarOverlay={height:29,color:He,symbolColor:X},this.z=!0}if((0,w.mark)("code/willCreateCodeBrowserWindow"),this.l=new P.BrowserWindow($e),(0,w.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,y.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(y.isWindows&&(0,m.useWindowControlsOverlay)(this.W)||y.isMacintosh)){const He=this.hb.getItem(ot.a);He&&this.updateWindowControls({height:He})}y.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[X,ue]=this.l.getPosition(),ge=P.screen.getCursorScreenPoint(),be=ge.x-X,we=ge.y-ue;return(()=>!(be>30&&we>=0&&we<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:be,y:we})),0}),(y.isMacintosh||y.isWindows)&&Me&&(!qe||P.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(He=>typeof He=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Te&&((0,w.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.xb(!0),this.l.show(),(0,w.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(fe)}setRepresentedFilename(U){y.isMacintosh?this.l.setRepresentedFilename(U):this.v=U}getRepresentedFilename(){return y.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(U){y.isMacintosh&&this.l.setDocumentEdited(U),this.w=U}isDocumentEdited(){return y.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(U){y.isMacintosh&&U?.force&&P.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.C.push(U)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(U=>{function v(){O.dispose(),W.dispose(),U()}const O=this.onDidClose(()=>v()),W=this.onWillLoad(()=>v())})}kb(U){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:U})),this.l.webContents.on("render-process-gone",(O,W)=>this.nb(2,{...W,sandboxed:U})),this.l.webContents.on("did-fail-load",(O,W,N)=>this.nb(3,{reason:N,exitCode:W,sandboxed:U})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.q=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.q&&(this.q.maximized=!0),P.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.q&&(this.q.maximized=!1),P.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.D(this.W.onDidChangeConfiguration(O=>this.rb(O))),this.D(this.Y.onDidDeleteUntitledWorkspace(O=>this.qb(O)));const v=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:v},async(O,W)=>{const N=await this.mb();W({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,N)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(U,v){switch(U){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${v?.reason||"<unknown>"}, code: ${v?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${v?.reason||"<unknown>"}, code: ${v?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:U,reason:v?.reason,code:v?.exitCode,sandboxed:v?.sandboxed?"1":"0"}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:O,checkboxChecked:W}=await this.bb.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this.q?.workspace?(0,d.localize)(5,null):void 0},this.l);if(O!==2){const N=O===0;await this.pb(N,W)}}else if(U===2)if(y.isWindows&&v?.reason==="launch-failed"&&v.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(v);else{let O;v?O=(0,d.localize)(7,null,v.reason,v.exitCode??"<unknown>"):O=(0,d.localize)(6,null);const{response:W,checkboxChecked:N}=await this.bb.showMessageBox({type:"warning",buttons:[this.q?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:O,detail:this.q?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this.q?.workspace?(0,d.localize)(13,null):void 0},this.l),G=W===0;await this.pb(G,N)}break}}async ob(U){const v=[],O=(0,J.isInternalTelemetry)(this.eb,this.W);if((0,J.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&v.push(new de.OneDataSystemAppender(O,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const{installSourcePath:N}=this.O,G=await(0,F.resolveMachineId)(this.hb),j={appenders:v,sendErrorTelemetry:!1,commonProperties:(0,Y.resolveCommonProperties)(this.R,(0,H.release)(),(0,H.hostname)(),process.arch,this.eb.commit,this.eb.version,G,O,N),piiPaths:(0,J.getPiiPathsFromEnvironment)(this.O)};await new ce.TelemetryService(j,this.W,this.eb).publicLog2("windowadminerror",{reason:U.reason,code:U.exitCode})}const{response:W}=await this.bb.showMessageBox({type:"error",buttons:[(0,d.localize)(14,null),(0,d.localize)(15,null)],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.eb.nameLong)},this.l);W===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(v.map(N=>N.flush())),await this.pb(!1,!1)}async pb(U,v){const O=this.q?.workspace;if(v&&O)try{const W=this.U.workspaceStorage(O);await W.init(),W.delete("memento/workbench.parts.editor"),await W.close()}catch(W){this.M.error(W)}if(this.j.fire(),this.l?.destroy(),U&&this.q){let W,N;(0,M.isSingleFolderWorkspaceIdentifier)(O)?W={folderUri:O.uri}:(0,M.isWorkspaceIdentifier)(O)?W={workspaceUri:O.configPath}:N=!0;const[G]=await this.gb.open({context:5,userEnv:this.q.userEnv,cli:{...this.O.args,_:[]},urisToOpen:W?[W]:void 0,forceEmpty:N,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});G.focus()}}qb(U){this.q?.workspace?.id===U.id&&(this.q.workspace=void 0)}rb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const v=this.Cb();v!==this.s&&(this.s=v,this.Db(v))}if(!U||U.affectsConfiguration("http.proxy")){let v=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;v?.endsWith("/")&&(v=v.substr(0,v.length-1));const O=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((v||"").indexOf("@")===-1&&(v!==this.G||O!==this.H)){this.G=v,this.H=O;const W=v||"",N=O?`${O},<local>`:"<local>";this.M.trace(`Setting proxy to '${W}', bypassing '${N}'`),this.l.webContents.session.setProxy({proxyRules:W,proxyBypassRules:N,pacScript:""})}}}addTabbedWindow(U){y.isMacintosh&&U.win&&this.l.addTabbedWindow(U.win)}load(U,v=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!v.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),v.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(U,v),this.jb===0?this.q=U:this.J=U,this.jb=1,this.l.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const O=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.D(new L.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:U.workspace,reason:v.isReload?3:O?2:1})}sb(U,v){const O=(this.q??this.J)?.userEnv;if(O){const W=(0,g.isLaunchedFromCli)(O)&&!(0,g.isLaunchedFromCli)(U.userEnv),N=this.isExtensionDevelopmentHost;(W||N)&&(U.userEnv={...O,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),v.disableExtensions!==void 0&&(U["disable-extensions"]=v.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.l.isMaximized(),U.partsSplash=this.X.getWindowSplash(),(0,w.mark)("code/willOpenNewWindow"),U.perfMarks=(0,w.getMarks)(),this.I.update(U)}async reload(U){const v=Object.assign({},this.q);v.workspace=await this.tb(v),delete v.filesToOpenOrCreate,delete v.filesToDiff,delete v.filesToMerge,delete v.filesToWait,this.isExtensionDevelopmentHost&&U&&(v.verbose=U.verbose,v.debugId=U.debugId,v.extensionEnvironment=U.extensionEnvironment,v["inspect-extensions"]=U["inspect-extensions"],v["inspect-brk-extensions"]=U["inspect-brk-extensions"],v["extensions-dir"]=U["extensions-dir"]),v.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),v.isInitialStartup=!1,v.policiesData=this.P.serialize(),v.continueOn=this.O.continueOn,v.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},v.logLevel=this.N.getLogLevel(),v.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(v,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async tb(U){if((0,M.isWorkspaceIdentifier)(U.workspace)){const v=U.workspace.configPath;if(v.scheme===f.Schemas.file&&!await this.R.exists(v))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(U.workspace)){const v=U.workspace.uri;if(v.scheme===f.Schemas.file&&!await this.R.exists(v))return}return U.workspace}serializeWindowState(){if(!this.l)return(0,$.defaultWindowState)();if(this.isFullScreen){let O;try{O=P.screen.getDisplayMatching(this.getBounds())}catch{}const W=(0,$.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.r.width||W.width,height:this.r.height||W.height,x:this.r.x||0,y:this.r.y||0}}const U=Object.create(null);let v;if(!y.isMacintosh&&this.l.isMaximized()?v=0:v=1,v===0?U.mode=0:U.mode=1,v===1||v===0){let O;v===1?O=this.getBounds():O=this.l.getNormalBounds(),U.x=O.x,U.y=O.y,U.width=O.width,U.height=O.height}return U}updateWindowControls(U){if(U.height&&this.hb.setItem(ot.a,U.height),y.isWindows&&this.z)this.l.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(y.isMacintosh&&U.height!==void 0){const v=(U.height-15)/2;this.l.setTrafficLightPosition({x:v,y:v})}}ub(U){(0,w.mark)("code/willRestoreCodeWindowState");let v=!1;if(U)try{const O=P.screen.getAllDisplays();v=O.length>1,U=this.vb(U,O)}catch(O){this.M.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,w.mark)("code/didRestoreCodeWindowState"),[U||(0,$.defaultWindowState)(),v]}vb(U,v){if(this.M.trace(`window#validateWindowState: validating window state on ${v.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(v.length===1){const N=this.wb(v[0]);if(N){let G=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!N||(U.x<N.x&&(U.x=N.x),U.y<N.y&&(U.y=N.y))};this.M.trace("window#validateWindowState: 1 monitor working area",N),G(),U.width>N.width&&(U.width=N.width),U.height>N.height&&(U.height=N.height),U.x>N.x+N.width-128&&(U.x=N.x+N.width-U.width),U.y>N.y+N.height-128&&(U.y=N.y+N.height-U.height),G()}return U}if(U.display&&U.mode===3){const N=v.find(G=>G.id===U.display);if(N&&typeof N.bounds?.x=="number"&&typeof N.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const G=(0,$.defaultWindowState)(3);return G.x=N.bounds.x,G.y=N.bounds.y,G}}let O,W;try{O=P.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),W=this.wb(O)}catch{}if(O&&W&&U.x+U.width>W.x&&U.y+U.height>W.y&&U.x<W.x+W.width&&U.y<W.y+W.height)return this.M.trace("window#validateWindowState: multi-monitor working area",W),U}wb(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,v]=this.l.getPosition(),[O,W]=this.l.getSize();return{x:U,y:v,width:O,height:W}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(U){this.Bb()?this.yb(U):this.Ab(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.s&&this.Db(this.s,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(U){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(U)}zb(U){y.isMacintosh&&(this.t=U,this.u=new L.DeferredPromise,Promise.race([this.u.p,(0,L.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(U)}Ab(U){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(U),this.l.webContents.focus()}Bb(){const U=this.W.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let U=(0,m.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}Db(U,v=!0){y.isMacintosh||(U==="toggle"&&v&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),U==="hidden"?setTimeout(()=>{this.Eb(U)}):this.Eb(U))}Eb(U){const v=this.isFullScreen;switch(U){case"classic":this.l.setMenuBarVisibility(!v),this.l.autoHideMenuBar=v;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(U,v,...O){this.isReady?this.send(U,...O):this.ready().then(()=>{v.isCancellationRequested||this.send(U,...O)})}send(U,...v){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.l.webContents.send(U,...v)}catch(O){this.M.warn(`Error sending IPC message to channel '${U}' of window ${this.k}: ${(0,A.toErrorMessage)(O)}`)}}}updateTouchBar(U){!y.isMacintosh||this.F.forEach((v,O)=>{const W=U[O];v.segments=this.Hb(W)})}Fb(){if(!!y.isMacintosh){for(let U=0;U<10;U++){const v=this.Gb();this.F.push(v)}this.l.setTouchBar(new P.TouchBar({items:this.F}))}}Gb(U=[]){const v=this.Hb(U),O=new P.TouchBar.TouchBarSegmentedControl({segments:v,mode:"buttons",segmentStyle:"automatic",change:W=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:O.segments[W].id,from:"touchbar"})}});return O}Hb(U=[]){return U.map(O=>{let W;O.icon&&!l.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===f.Schemas.file&&(W=P.nativeImage.createFromPath(S.URI.revive(O.icon.dark).fsPath),W.isEmpty()&&(W=void 0));let N;return typeof O.title=="string"?N=O.title:N=O.title.value,{id:O.id,label:W?void 0:N,icon:W}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};ne.a="windowControlHeight",ne.b=void 0,ne=ye([Q(1,C.ILogService),Q(2,V.ILoggerMainService),Q(3,h.IEnvironmentMainService),Q(4,q.IPolicyService),Q(5,oe.IUserDataProfilesMainService),Q(6,E.IFileService),Q(7,n.IApplicationStorageMainService),Q(8,n.IStorageMainService),Q(9,b.IConfigurationService),Q(10,a.IThemeMainService),Q(11,T.IWorkspacesManagementMainService),Q(12,I.IBackupMainService),Q(13,o.ITelemetryService),Q(14,r.IDialogMainService),Q(15,p.ILifecycleMainService),Q(16,t.IProductService),Q(17,c.IProtocolMainService),Q(18,D.IWindowsMainService),Q(19,ie.IStateService),Q(20,ae.INativeHostMainService)],ne),e.CodeWindow=ne}),define(ee[81],te([0,1,14,26,7,3,45,2,15,4,18,8,23,187,6,20,5,97,98,29,54,35]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,I.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,n,o,l){super(),this.f=i,this.g=n,this.h=o,this.j=l,this.c=this.D(new A.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.y=this.D(new s.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.z()),this.D(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const a of i)if((0,g.isRecentWorkspace)(a))!this.g.isUntitledWorkspace(a.workspace)&&!this.q(n,a.workspace)&&n.push(a);else if((0,g.isRecentFolder)(a))this.r(n,a.folderUri)||n.push(a);else{const m=this.s(o,a.fileUri),D=a.fileUri.scheme===f.Schemas.file&&tt.w.indexOf((0,w.basename)(a.fileUri))>=0;!m&&!D&&(o.push(a),u.isWindows&&a.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(a.fileUri.fsPath))}const l=await this.l({workspaces:n,files:o});n=l.workspaces,o=l.files,n.length>tt.a&&(n.length=tt.a),o.length>tt.a&&(o.length=tt.a),await this.n({workspaces:n,files:o}),this.c.fire(),u.isMacintosh&&this.y.trigger(()=>this.H())}async removeRecentlyOpened(i){const n=m=>{const D=this.p(m);for(const M of i)if(w.extUriBiasedIgnorePathCase.isEqual(M,D))return!1;return!0},o=await this.getRecentlyOpened(),l=o.workspaces.filter(n),a=o.files.filter(n);(l.length!==o.workspaces.length||a.length!==o.files.length)&&(await this.n({files:a,workspaces:l}),this.c.fire(),u.isMacintosh&&this.y.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const n=new C.ResourceMap(a=>w.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.workspaces)for(const a of i.workspaces)n.set(this.p(a),a);const o=new C.ResourceMap(a=>w.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.files)for(const a of i.files)o.set(this.p(a),a);const l=await this.m();for(const a of l.workspaces){const m=n.get(this.p(a));m?m.label=m.label??a.label:n.set(this.p(a),a)}for(const a of l.files){const m=o.get(this.p(a));m?m.label=m.label??a.label:o.set(this.p(a),a)}return{workspaces:[...n.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const n=this.j.get(tt.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,g.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,g.toStoreData)(i)),-1,1)}p(i){return(0,g.isRecentFolder)(i)?i.folderUri:(0,g.isRecentFile)(i)?i.fileUri:i.workspace.configPath}q(i,n){return!!i.find(o=>(0,g.isRecentWorkspace)(o)&&o.workspace.id===n.id)}r(i,n){return!!i.find(o=>(0,g.isRecentFolder)(o)&&w.extUriBiasedIgnorePathCase.isEqual(o.folderUri,n))}s(i,n){return!!i.find(o=>w.extUriBiasedIgnorePathCase.isEqual(o.fileUri,n))}async z(){!u.isWindows||(await this.C(),this.D(this.onDidChangeRecentlyOpened(()=>this.C())))}async C(){if(!u.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const a of P.app.getJumpListSettings().removedItems){const m=a.args;if(m){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(m);D&&n.push(y.URI.parse(D[2]))}}await this.removeRecentlyOpened(n);let o=!1;const l=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.v).map(a=>{const m=(0,g.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:D,description:M}=this.F(m,a.label);let T;return y.URI.isUri(m)?T=`--folder-uri "${m.toString()}"`:(o=!0,T=`--file-uri "${m.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:o?(0,d.localize)(2,null):(0,d.localize)(3,null),items:l})}i.push({type:"recent"});try{const n=P.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(i,n){if(n)return{title:(0,R.splitName)(n).name,description:n};if(y.URI.isUri(i))return{title:(0,w.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let o=(0,w.basename)(i.configPath);return o.endsWith(E.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-E.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,R.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!u.isMacintosh)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let a=0;a<i.workspaces.length&&o<tt.t;a++){const m=this.p(i.workspaces[a]);if(m.scheme===f.Schemas.file){const D=(0,w.originalFSPath)(m);await S.Promises.exists(D)&&(n.push(D),o++)}}const l=[];for(let a=0;a<i.files.length&&o<tt.u;a++){const m=this.p(i.files[a]);if(m.scheme===f.Schemas.file){const D=(0,w.originalFSPath)(m);if(tt.w.includes((0,w.basename)(m))||n.includes(D))continue;await S.Promises.exists(D)&&(l.push(D),o++)}}l.reverse().forEach(a=>P.app.addRecentDocument(a)),n.reverse().forEach(a=>P.app.addRecentDocument(a))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.t=7,t.u=10,t.v=7,t.w=["COMMIT_EDITMSG","MERGE_MSG"],t=ye([Q(0,r.ILogService),Q(1,p.IWorkspacesManagementMainService),Q(2,b.ILifecycleMainService),Q(3,h.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[284],te([0,1,14,7,22,45,4,8,177,19,28,20,5,225,59,21,33,24,49,79,30,81]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class vt{constructor(o,l,a,m,D,M,T,$,z,q,ie){this.n=o,this.o=l,this.p=a,this.q=m,this.r=D,this.s=M,this.t=T,this.u=$,this.v=z,this.w=q,this.x=ie,this.m=Object.create(null),this.g=new L.RunOnceScheduler(()=>this.E(),0),this.h=new L.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.isMacintosh||(0,E.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(vt.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(M,T,$)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(M,T,$)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(M,T,$)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P($),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(M,T,$)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P($),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(M,T,$)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P($),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const a=this.x.reportIssueUrl;a&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(a,"openReportIssues"));const m=this.x.licenseUrl;m&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.language){const M=m.indexOf("?")>0?"&":"?";this.Z(`${m}${M}lang=${R.language}`,"openLicenseUrl")}else this.Z(m,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&m&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(D,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!R.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,l){this.k=o.menus,this.l=o.keybindings,this.t.setItem(vt.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){!R.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){!R.isMacintosh||(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=P.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(R.isMacintosh?new P.Menu:null);return}const l=new P.Menu;let a;if(R.isMacintosh){const D=new P.Menu;a=new P.MenuItem({label:this.x.nameShort,submenu:D}),this.I(D),l.append(a)}if(R.isMacintosh&&!this.c){this.c=!0;const D=new P.Menu;D.append(new P.MenuItem({label:this.bb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(D)}if(this.K("File")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(1,null)),submenu:D});this.M(D,"File"),l.append(M)}if(this.K("Edit")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(2,null)),submenu:D});this.M(D,"Edit"),l.append(M)}if(this.K("Selection")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(3,null)),submenu:D});this.M(D,"Selection"),l.append(M)}if(this.K("View")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(4,null)),submenu:D});this.M(D,"View"),l.append(M)}if(this.K("Go")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(5,null)),submenu:D});this.M(D,"Go"),l.append(M)}if(this.K("Run")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(6,null)),submenu:D});this.M(D,"Run"),l.append(M)}if(this.K("Terminal")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(7,null)),submenu:D});this.M(D,"Terminal"),l.append(M)}let m;if(this.K("Window")){const D=new P.Menu;m=new P.MenuItem({label:this.bb(f.localize(8,null)),submenu:D,role:"window"}),this.S(D)}if(m&&l.append(m),this.K("Help")){const D=new P.Menu,M=new P.MenuItem({label:this.bb(f.localize(9,null)),submenu:D,role:"help"});this.M(D,"Help"),l.append(M)}l.items&&l.items.length>0?P.Menu.setApplicationMenu(l):P.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const l=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),a=this.T();let m;if(this.K("Preferences")){const oe=new P.Menu;this.M(oe,"Preferences"),m=new P.MenuItem({label:this.bb(f.localize(11,null)),submenu:oe})}const D=new P.Menu,M=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:D}),T=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),$=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),q=new P.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(oe,ae,de)=>{const ce=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!P.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.J(de)&&this.w.quit(void 0)}})),ie=[l];ie.push(...a),m&&ie.push(i(),m),ie.push(i(),M,i(),T,$,z,i(),q),ie.forEach(oe=>o.append(oe))}async J(o){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(o)){const{response:a}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return a===0}return!0}K(o){if(!R.isMacintosh&&(0,E.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,l){l.forEach(a=>{if((0,d.isMenubarMenuItemSeparator)(a))o.append(i());else if((0,d.isMenubarMenuItemSubmenu)(a)){const m=new P.Menu,D=new P.MenuItem({label:this.bb(a.label),submenu:m});this.L(m,a.submenu.items),o.append(D)}else(0,d.isMenubarMenuItemRecentAction)(a)?o.append(this.O(a)):(0,d.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.N(o),R.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[a.id]?o.append(new P.MenuItem(this.Y(a.id,{label:this.bb(a.label),click:this.m[a.id]}))):o.append(this.U(a.label,a.id,!1,a.checked)):o.append(this.U(a.label,a.id,a.enabled!==!1,!!a.checked)):o.append(this.U(a.label,a.id,a.enabled!==!1,!!a.checked)))})}M(o,l){this.k&&this.k[l]&&this.L(o,this.k[l].items)}N(o){const l=this.T();l.length&&(l.forEach(a=>o.append(a)),o.append(i()))}O(o){const l=k.URI.revive(o.uri),a=o.id,m=a==="openRecentFile"?{fileUri:l}:a==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new P.MenuItem(this.Y(a,{label:o.label,click:async(D,M,T)=>{const $=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[m],forceNewWindow:$,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(o){return!!(o&&(!R.isMacintosh&&(o.ctrlKey||o.shiftKey)||R.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,l,a){const m={label:this.bb(o),role:a,enabled:!0};return new P.MenuItem(this.X(l,m))}S(o){const l=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),a=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),m=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.U(f.localize(23,null),"workbench.action.switchWindow"),M=[];this.C&&(M.push(i()),M.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),M.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,a,i(),D,...M,i(),m].forEach(T=>o.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new P.MenuItem({label:this.bb(f.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.bb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.bb(f.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.bb(f.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,l,a,m){const D=this.bb(o),M=typeof l=="function"?l:(ie,oe,ae)=>{const de=ie?ie.userSettingsLabel:null;let ce=l;Array.isArray(l)&&(ce=this.P(ae)?l[1]:l[0]),de&&ae.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:de}):this.W({type:"commandId",commandId:ce})},T=typeof a=="boolean"?a:this.p.getWindowCount()>0,$=typeof m=="boolean"?m:!1,z={label:D,click:M,enabled:T};$&&(z.type="checkbox",z.checked=$);let q;return typeof l=="string"?q=l:Array.isArray(l)&&(q=l[0]),R.isMacintosh&&(q==="editor.action.clipboardCutAction"?z.role="cut":q==="editor.action.clipboardCopyAction"?z.role="copy":q==="editor.action.clipboardPasteAction"&&(z.role="paste"),q==="undo"?z.click=this.V(M,{inDevTools:ie=>ie.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?z.click=this.V(M,{inDevTools:ie=>ie.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(z.click=this.V(M,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(q,z))}V(o,l){return(a,m,D)=>{const M=P.BrowserWindow.getFocusedWindow();if(!M)return l.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return l.inDevTools(M.webContents.devToolsWebContents);o(a,m||M,D)}}W(o){let l=P.BrowserWindow.getFocusedWindow();if(!l){const m=this.p.getLastActiveWindow();m?.isMinimized()&&(l=m.win)}const a=l?this.p.getWindowById(l.id):void 0;if(a){if(this.v.trace("menubar#runActionInRenderer",o),R.isMacintosh&&!this.q.isBuilt&&!a.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const m={id:o.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",s.CancellationToken.None,m)}else{const m={userSettingsLabel:o.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,m)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,l){const a=typeof o=="string"?this.l[o]:void 0;if(a?.label){if(a.isNative!==!1)l.accelerator=a.label,l.userSettingsLabel=a.userSettingsLabel;else if(typeof l.label=="string"){const m=l.label.indexOf("[");m>=0?l.label=`${l.label.substr(0,m)} [${a.label}]`:l.label=`${l.label} [${a.label}]`}}else l.accelerator=void 0;return l}Y(o,l,a=!l.accelerator){a&&(l=this.X(o,l));const m=l.click;return l.click=(D,M,T)=>{this.ab(o),m?.(D,M,T)},l}Z(o,l){this.w.openExternal(void 0,o),this.ab(l)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,A.mnemonicMenuLabel)(o,!this.B)}};c.a="lastKnownMenubarData",c=ye([Q(0,g.IUpdateService),Q(1,u.IConfigurationService),Q(2,p.IWindowsMainService),Q(3,w.IEnvironmentMainService),Q(4,h.ITelemetryService),Q(5,C.IWorkspacesHistoryMainService),Q(6,r.IStateService),Q(7,y.ILifecycleMainService),Q(8,S.ILogService),Q(9,I.INativeHostMainService),Q(10,b.IProductService)],c),e.Menubar=c;function i(){return new P.MenuItem({type:"separator"})}}),define(ee[285],te([0,1,6,20,5,284]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,P.createDecorator)("menubarMainService");let R=class{constructor(f,u,w){this.b=f,this.c=u,this.d=w,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(A.Menubar)}async updateMenubar(f,u){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(u,f)}};R=ye([Q(0,P.IInstantiationService),Q(1,L.ILifecycleMainService),Q(2,s.ILogService)],R),e.MenubarMainService=R}),define(ee[286],te([0,1,14,23,27,26,22,3,32,50,45,2,15,9,64,4,36,18,11,8,185,63,19,58,28,16,6,20,5,66,67,57,33,79,283,125,278,29,99,81,54,69,38,53,65,72]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i,n,o,l,a,m,D,M,T,$,z,q,ie,oe,ae,de,ce,J,Y,H,F,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Z(U){return(0,oe.isWorkspaceIdentifier)(U?.workspace)}function ne(U){return(0,oe.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let se=class at extends y.Disposable{constructor(v,O,W,N,G,j,B,K,re,he,ve,Se,Oe,Le,Fe,me,pe,Ce){super(),this.k=v,this.l=O,this.m=W,this.n=N,this.q=G,this.r=j,this.s=B,this.t=K,this.u=re,this.v=he,this.w=ve,this.z=Se,this.C=Oe,this.F=Le,this.G=Fe,this.H=me,this.I=pe,this.J=Ce,this.b=this.D(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.D(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.D(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.D(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.D(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.D(new ie.WindowsStateHandler(this,this.q,this.u,this.m,this.w)),this.L()}L(){this.D(this.C.onDidEnterWorkspace(v=>this.c.fire(v.window))),this.D(this.onDidSignalReadyWindow(v=>{if(v.config?.extensionDevelopmentPath||v.config?.extensionTestsPath){const O=new y.DisposableStore;if(O.add(k.Event.any(v.onDidClose,v.onDidDestroy)(()=>O.dispose())),v.config.extensionDevelopmentPath)for(const W of v.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(W));v.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(v.config.extensionTestsPath))}}))}openEmptyWindow(v,O){const W=this.s.args,N=O?.remoteAuthority||void 0,G=!0,j=O?.forceReuseWindow,B=!j;return this.open({...v,cli:W,forceEmpty:G,forceNewWindow:B,forceReuseWindow:j,remoteAuthority:N})}openExistingWindow(v,O){v.focus(),this.M(O,[v])}async open(v){this.m.trace("windowsManager#open"),v.addMode&&(v.initialStartup||!this.getLastActiveWindow())&&(v.addMode=!1);const O=[],W=[],N=[],G=[],j=[];let B,K=0;const re=await this.S(v);this.m.trace("windowsManager#open pathsToOpen",re);for(const Le of re)ne(Le)?v.addMode?O.push(Le):W.push(Le):Z(Le)?N.push(Le):Le.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Le.remoteAuthority}),B.filesToOpenOrCreate.push(Le)):Le.backupPath?j.push({backupFolder:(0,d.basename)(Le.backupPath),remoteAuthority:Le.remoteAuthority}):K++;v.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),v.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&v.waitMarkerFileURI&&(B.filesToWait={paths:(0,A.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:v.waitMarkerFileURI}),v.initialStartup?(G.push(...this.C.getUntitledWorkspaces()),N.push(...G),j.push(...this.v.getEmptyWindowBackups())):j.length=0;const{windows:he,filesOpenedInWindow:ve}=await this.N(v,N,W,j,K,B,O);if(this.m.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${W.length}, emptyToRestore: ${j.length}, emptyToOpen: ${K})`),he.length>1)if(ve)ve.focus();else{const Le=this.j.state.lastActiveWindow&&!v.forceEmpty&&!v.cli._.length&&!v.cli["file-uri"]&&!v.cli["folder-uri"]&&!(v.urisToOpen&&v.urisToOpen.length);let Fe=!0,me=!0;if(Le){const pe=he.filter(Ce=>this.j.state.lastActiveWindow&&Ce.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Fe=!1,me=!1)}if(Fe)for(let pe=he.length-1;pe>=0;pe--){const Ce=he[pe];if(!(Ce.openedWorkspace&&G.some(_=>Ce.openedWorkspace&&_.workspace.id===Ce.openedWorkspace.id)||Ce.backupPath&&j.some(_=>Ce.backupPath&&_.backupFolder===(0,d.basename)(Ce.backupPath)))){Ce.focus(),me=!1;break}}me&&he[he.length-1].focus()}const Se=B&&B.filesToDiff.length>0,Oe=B&&B.filesToMerge.length>0;if(!he.some(Le=>Le.isExtensionDevelopmentHost)&&!Se&&!Oe&&!v.noRecentEntry){const Le=[];for(const Fe of re)Z(Fe)&&!Fe.transient?Le.push({label:Fe.label,workspace:Fe.workspace,remoteAuthority:Fe.remoteAuthority}):ne(Fe)?Le.push({label:Fe.label,folderUri:Fe.workspace.uri,remoteAuthority:Fe.remoteAuthority}):Fe.fileUri&&Le.push({label:Fe.label,fileUri:Fe.fileUri,remoteAuthority:Fe.remoteAuthority});this.z.addRecentlyOpened(Le)}return this.M(v,he),he}M(v,O){const W=v.waitMarkerFileURI;v.context===0&&W&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.H.del(W)}catch{}})()}async N(v,O,W,N,G,j,B){const K=[];let re;function he(pe,Ce){K.push(pe),Ce&&(re=pe,j=void 0)}let{openFolderInNewWindow:ve,openFilesInNewWindow:Se}=this.fb(v);if(!v.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,Ce=this.kb(pe);Ce&&he(this.P(Ce,B.map(_=>_.workspace.uri)))}const Oe=W.length+O.length+N.length;if(j&&Oe===0){const pe=j.filesToOpenOrCreate[0]||j.filesToDiff[0]||j.filesToMerge[3],Ce=this.getWindows().filter(le=>j&&(0,h.isEqualAuthority)(le.remoteAuthority,j.remoteAuthority));let _;pe?.fileUri&&!Se&&((v.context===4||v.context===0||v.context===1)&&(_=await(0,q.findWindowOnFile)(Ce,pe.fileUri,async le=>le.configPath.scheme===S.Schemas.file?this.C.resolveLocalWorkspace(le.configPath):void 0)),_||(_=this.lb(Ce))),_?(0,oe.isWorkspaceIdentifier)(_.openedWorkspace)?O.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(_.openedWorkspace)?W.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):he(this.O(v,_,j),!0):he(await this.gb({userEnv:v.userEnv,cli:v.cli,initialStartup:v.initialStartup,filesToOpen:j,forceNewWindow:!0,remoteAuthority:j.remoteAuthority,forceNewTabbedWindow:v.forceNewTabbedWindow,forceProfile:v.forceProfile,forceTempProfile:v.forceTempProfile}),!0)}const Le=(0,A.distinct)(O,pe=>pe.workspace.id);if(Le.length>0){const pe=(0,A.coalesce)(Le.map(Ce=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ce.workspace.configPath)));if(pe.length>0){const Ce=pe[0],_=(0,h.isEqualAuthority)(j?.remoteAuthority,Ce.remoteAuthority)?j:void 0;he(this.O(v,Ce,_),!!_),ve=!0}for(const Ce of Le){if(pe.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Ce.workspace.id))continue;const _=Ce.remoteAuthority,le=(0,h.isEqualAuthority)(j?.remoteAuthority,_)?j:void 0;he(await this.R(v,Ce,ve,le),!!le),ve=!0}}const Fe=(0,A.distinct)(W,pe=>h.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Fe.length>0){const pe=(0,A.coalesce)(Fe.map(Ce=>(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Ce.workspace.uri)));if(pe.length>0){const Ce=pe[0],_=(0,h.isEqualAuthority)(j?.remoteAuthority,Ce.remoteAuthority)?j:void 0;he(this.O(v,Ce,_),!!_),ve=!0}for(const Ce of Fe){if(pe.some(fe=>(0,oe.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Ce.workspace.uri)))continue;const _=Ce.remoteAuthority,le=(0,h.isEqualAuthority)(j?.remoteAuthority,_)?j:void 0;he(await this.R(v,Ce,ve,le),!!le),ve=!0}}const me=(0,A.distinct)(N,pe=>pe.backupFolder);if(me.length>0)for(const pe of me){const Ce=pe.remoteAuthority,_=(0,h.isEqualAuthority)(j?.remoteAuthority,Ce)?j:void 0;he(await this.Q(v,!0,Ce,_,pe),!!_),ve=!0}if(K.length===0||j){j&&!G&&G++;const pe=j?j.remoteAuthority:v.remoteAuthority;for(let Ce=0;Ce<G;Ce++)he(await this.Q(v,ve,pe,j),!!j),ve=!0}return{windows:(0,A.distinct)(K),filesOpenedInWindow:re}}O(v,O,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),O.focus();const N={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:v?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",R.CancellationToken.None,N),O}P(v,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),v.focus();const W={foldersToAdd:O};return v.sendWhenReady("vscode:addFolders",R.CancellationToken.None,W),v}Q(v,O,W,N,G){this.m.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:W,filesToOpen:N,forceNewWindow:O});let j;return!O&&typeof v.contextWindowId=="number"&&(j=this.getWindowById(v.contextWindowId)),this.gb({userEnv:v.userEnv,cli:v.cli,initialStartup:v.initialStartup,remoteAuthority:W,forceNewWindow:O,forceNewTabbedWindow:v.forceNewTabbedWindow,filesToOpen:N,windowToUse:j,emptyWindowBackupInfo:G,forceProfile:v.forceProfile,forceTempProfile:v.forceTempProfile})}R(v,O,W,N,G){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:N}),!W&&!G&&typeof v.contextWindowId=="number"&&(G=this.getWindowById(v.contextWindowId)),this.gb({workspace:O.workspace,userEnv:v.userEnv,cli:v.cli,initialStartup:v.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:v.forceNewTabbedWindow,filesToOpen:N,windowToUse:G,forceProfile:v.forceProfile,forceTempProfile:v.forceTempProfile})}async S(v){let O,W=!1,N=!1;if(v.urisToOpen&&v.urisToOpen.length>0?(O=await this.U(v),W=!0):v.forceEmpty?O=[Object.create(null)]:v.cli._.length||v.cli["folder-uri"]||v.cli["file-uri"]?(O=await this.W(v.cli),O.length===0&&O.push(Object.create(null)),W=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),N=!0),!v.addMode&&W){const G=O.filter(j=>ne(j));if(G.length>1){const j=G[0].remoteAuthority;if(G.every(B=>(0,h.isEqualAuthority)(B.remoteAuthority,j))){const B=await this.C.createUntitledWorkspace(G.map(K=>({uri:K.workspace.uri})));O.push({workspace:B,remoteAuthority:j}),O=O.filter(K=>!ne(K))}}}if(v.initialStartup&&!N&&this.w.getValue("window")?.restoreWindows==="preserve"){const G=await this.Y();O.unshift(...G.filter(j=>Z(j)||ne(j)||j.backupPath))}return O}async U(v){const O={gotoLineMode:v.gotoLineMode,remoteAuthority:v.remoteAuthority},W=await Promise.all((0,A.coalesce)(v.urisToOpen||[]).map(async N=>{const G=await this.ab(N,O);if(G)return G.label=N.label,G;const j=this.cb(N);this.G.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:j.scheme===S.Schemas.file?(0,p.localize)(1,null):(0,p.localize)(2,null),detail:j.scheme===S.Schemas.file?(0,p.localize)(3,null,(0,w.getPathLabel)(j,{os:b.OS,tildify:this.s})):(0,p.localize)(4,null,j.toString(!0))},(0,g.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow()))}));return(0,A.coalesce)(W)}async W(v){const O=[],W={ignoreFileNotFound:!0,gotoLineMode:v.goto,remoteAuthority:v.remote||void 0,forceOpenWorkspaceAsFile:v.diff&&v._.length===2||v.merge&&v._.length===4},N=v["folder-uri"];if(N){const B=await Promise.all(N.map(K=>{const re=this.X(K);if(!!re)return this.ab({folderUri:re},W)}));O.push(...(0,A.coalesce)(B))}const G=v["file-uri"];if(G){const B=await Promise.all(G.map(K=>{const re=this.X(K);if(!!re)return this.ab((0,oe.hasWorkspaceFileExtension)(K)?{workspaceUri:re}:{fileUri:re},W)}));O.push(...(0,A.coalesce)(B))}const j=await Promise.all(v._.map(B=>W.remoteAuthority?this.eb(B,W):this.db(B,W)));return O.push(...(0,A.coalesce)(j)),O}X(v){try{const O=E.URI.parse(v);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${v}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${v}, ${O.message}`)}}async Y(){const v=this.Z();switch(v){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];v!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const W=await Promise.all(O.map(async N=>{if(N.workspace){const G=await this.ab({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});if(Z(G))return G}else if(N.folderUri){const G=await this.ab({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});if(ne(G))return G}else if(v!=="folders"&&N.backupPath)return{backupPath:N.backupPath,remoteAuthority:N.remoteAuthority}}));return(0,A.coalesce)(W)}}}Z(){let v;return this.u.wasRestarted?v="all":(v=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(v)||(v="all")),v}async ab(v,O=Object.create(null)){const W=this.cb(v);return W.scheme===S.Schemas.file?((0,$.isFileToOpen)(v)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,O)):this.bb(v,O)}bb(v,O){let W=this.cb(v);const N=(0,M.getRemoteAuthority)(W)||O.remoteAuthority;if(W=(0,h.removeTrailingPathSeparator)((0,h.normalizePath)(W)),(0,$.isFileToOpen)(v)){if(O.gotoLineMode){const{path:G,line:j,column:B}=(0,f.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:G}),options:{selection:j?{startLineNumber:j,startColumn:B||1}:void 0},remoteAuthority:N}}return{fileUri:W,remoteAuthority:N}}else if((0,$.isWorkspaceToOpen)(v))return{workspace:(0,ae.getWorkspaceIdentifier)(W),remoteAuthority:N};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:N}}cb(v){return(0,$.isWorkspaceToOpen)(v)?v.workspaceUri:(0,$.isFolderToOpen)(v)?v.folderUri:v.fileUri}async db(v,O){let W,N;O.gotoLineMode&&({path:v,line:W,column:N}=(0,f.parseLineAndColumnAware)(v)),v=(0,f.sanitizeFilePath)((0,d.normalize)(v),(0,r.cwd)());try{const G=await L.Promises.stat(v);if(G.isFile()){if(!O.forceOpenWorkspaceAsFile){const j=await this.C.resolveLocalWorkspace(E.URI.file(v));if(j)return j.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:j.id,configPath:j.configPath},type:n.FileType.File,exists:!0,remoteAuthority:j.remoteAuthority,transient:j.transient}}return{fileUri:E.URI.file(v),type:n.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:N||1}:void 0}}}else{if(G.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(E.URI.file(v),G),type:n.FileType.Directory,exists:!0};if(!b.isWindows&&v==="/dev/null")return{fileUri:E.URI.file(v),type:n.FileType.File,exists:!0}}}catch{const j=E.URI.file(v);if(this.z.removeRecentlyOpened([j]),O.ignoreFileNotFound)return{fileUri:j,type:n.FileType.File,exists:!1}}}eb(v,O){const W=v.charCodeAt(0),N=O.remoteAuthority;let G,j;O.gotoLineMode&&({path:v,line:G,column:j}=(0,f.parseLineAndColumnAware)(v)),W!==47&&((0,f.isWindowsDriveLetter)(W)&&v.charCodeAt(v.charCodeAt(1))===58&&(v=(0,f.toSlashes)(v)),v=`/${v}`);const B=E.URI.from({scheme:S.Schemas.vscodeRemote,authority:N,path:v});if(v.charCodeAt(v.length-1)!==47){if((0,oe.hasWorkspaceFileExtension)(v))return O.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:G?{startLineNumber:G,startColumn:j||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(B),remoteAuthority:N};if(O.gotoLineMode||d.posix.basename(v).indexOf(".")!==-1)return{fileUri:B,options:{selection:G?{startLineNumber:G,startColumn:j||1}:void 0},remoteAuthority:N}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:N}}fb(v){const O=this.w.getValue("window"),W=O?.openFoldersInNewWindow||"default",N=O?.openFilesInNewWindow||"off";let G=(v.preferNewWindow||v.forceNewWindow)&&!v.forceReuseWindow;!v.forceNewWindow&&!v.forceReuseWindow&&(W==="on"||W==="off")&&(G=W==="on");let j=!1;return v.forceNewWindow||v.forceReuseWindow?j=!!v.forceNewWindow&&!v.forceReuseWindow:(b.isMacintosh?v.context===1&&(j=!0):v.context!==3&&v.context!==2&&!(v.userEnv&&v.userEnv.TERM_PROGRAM==="vscode")&&(j=!0),!v.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(j=N==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:j}}async openExtensionDevelopmentHostWindow(v,O){const W=(0,q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),v);if(W)return this.u.reload(W,O.cli),W.focus(),[W];let N=O.cli["folder-uri"]||[],G=O.cli["file-uri"]||[],j=O.cli._;if(!j.length&&!N.length&&!G.length&&!O.cli.extensionTestsPath){const re=this.j.state.lastPluginDevelopmentHostWindow,he=re?.workspace??re?.folderUri;he&&(E.URI.isUri(he)?he.scheme===S.Schemas.file?j=[he.fsPath]:N=[he.toString()]:he.configPath.scheme===S.Schemas.file?j=[(0,h.originalFSPath)(he.configPath)]:G=[he.configPath.toString()])}let B=O.remoteAuthority;for(const re of v)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=E.URI.parse(re),ve=(0,M.getRemoteAuthority)(he);ve&&(B?(0,h.isEqualAuthority)(ve,B)||this.m.error("more than one extension development path authority"):B=ve)}j=j.filter(re=>{const he=E.URI.file(re);return(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:(0,h.isEqualAuthority)((0,M.getRemoteAuthority)(he),B)}),N=N.filter(re=>{const he=this.X(re);return he&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,h.isEqualAuthority)((0,M.getRemoteAuthority)(he),B):!1}),G=G.filter(re=>{const he=this.X(re);return he&&!!(0,q.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,h.isEqualAuthority)((0,M.getRemoteAuthority)(he),B):!1}),O.cli._=j,O.cli["folder-uri"]=N,O.cli["file-uri"]=G;const K={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!j.length&&!N.length&&!G.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(K)}async gb(v){const O=this.w.getValue("window"),W=this.getLastActiveWindow(),N=W?.profile??this.t.defaultProfile;let G;!v.forceNewWindow&&!v.forceNewTabbedWindow&&(G=v.windowToUse||W,G&&G.focus());let j=!1;V.canUseUtilityProcess&&(typeof O?.experimental?.sharedProcessUseUtilityProcess=="boolean"?j=O.experimental.sharedProcessUseUtilityProcess:j=typeof m.default.quality=="string"&&m.default.quality!=="stable");const B={...this.s.args,...v.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:v.emptyWindowBackupInfo?(0,d.join)(this.s.backupHome,v.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.t.profilesHome,all:this.t.profiles,profile:N},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:v.remoteAuthority,workspace:v.workspace,userEnv:{...this.l,...v.userEnv},filesToOpenOrCreate:v.filesToOpen?.filesToOpenOrCreate,filesToDiff:v.filesToOpen?.filesToDiff,filesToMerge:v.filesToOpen?.filesToMerge,filesToWait:v.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.s.logsHome.fsPath,product:m.default,isInitialStartup:v.initialStartup,perfMarks:(0,I.getMarks)(),os:{release:(0,s.release)(),hostname:(0,s.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn,preferUtilityProcess:j};if(G){const K=G.config;!B.extensionDevelopmentPath&&K?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=K.extensionDevelopmentPath,B.extensionDevelopmentKind=K.extensionDevelopmentKind,B["enable-proposed-api"]=K["enable-proposed-api"],B.verbose=K.verbose,B["inspect-extensions"]=K["inspect-extensions"],B["inspect-brk-extensions"]=K["inspect-brk-extensions"],B.debugId=K.debugId,B.extensionEnvironment=K.extensionEnvironment,B["extensions-dir"]=K["extensions-dir"],B["disable-extensions"]=K["disable-extensions"]),B.loggers=K?.loggers??B.loggers}else{const K=this.j.getNewWindowState(B);(0,I.mark)("code/willCreateCodeWindow");const re=G=this.F.createInstance(z.CodeWindow,{state:K,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,I.mark)("code/didCreateCodeWindow"),v.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),at.a.push(re),this.b.fire(re),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,u.once)(re.onDidSignalReady)(()=>this.c.fire(re)),(0,u.once)(re.onDidClose)(()=>this.jb(re)),(0,u.once)(re.onDidDestroy)(()=>this.f.fire(re)),re.onDidTriggerSystemContextMenu(({x:ve,y:Se})=>this.h.fire({window:re,x:ve,y:Se}));const he=(0,g.assertIsDefined)(re.win?.webContents);he.removeAllListeners("devtools-reload-page"),he.on("devtools-reload-page",()=>this.u.reload(re)),this.u.registerWindow(re)}return B.windowId=G.id,G.isReady?this.u.unload(G,4).then(async K=>{K||await this.hb(G,B,v,N)}):await this.hb(G,B,v,N),G}async hb(v,O,W,N){if(O.extensionDevelopmentPath||((0,oe.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),this.t.isEnabled()){const G=O.workspace??(0,oe.toWorkspaceIdentifier)(O.backupPath,!1),j=this.ib(W,G,N),B=j instanceof Promise?await j:j;O.profiles.profile=B,O.extensionDevelopmentPath||await this.t.setProfileForWorkspace(G,B)}v.load(O)}ib(v,O,W){return v.forceProfile?this.t.profiles.find(N=>N.name===v.forceProfile)??this.t.createNamedProfile(v.forceProfile):v.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(O)??W}jb(v){const O=at.a.indexOf(v);at.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const v=P.BrowserWindow.getFocusedWindow();if(v)return this.getWindowById(v.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(v){return this.lb(this.getWindows().filter(O=>(0,h.isEqualAuthority)(O.remoteAuthority,v)))}lb(v){const O=Math.max.apply(Math,v.map(W=>W.lastFocusTime));return v.find(W=>W.lastFocusTime===O)}sendToFocused(v,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(v,R.CancellationToken.None,...O)}sendToAll(v,O,W){for(const N of this.getWindows())W&&W.indexOf(N.id)>=0||N.sendWhenReady(v,R.CancellationToken.None,O)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(v){const O=this.getWindows().filter(W=>W.id===v);return(0,A.firstOrDefault)(O)}getWindowByWebContents(v){const O=P.BrowserWindow.fromWebContents(v);if(!!O)return this.getWindowById(O.id)}};se.a=[],se=ye([Q(2,a.ILogService),Q(3,F.ILoggerMainService),Q(4,T.IStateService),Q(5,Y.IPolicyService),Q(6,i.IEnvironmentMainService),Q(7,H.IUserDataProfilesMainService),Q(8,l.ILifecycleMainService),Q(9,C.IBackupMainService),Q(10,t.IConfigurationService),Q(11,de.IWorkspacesHistoryMainService),Q(12,ce.IWorkspacesManagementMainService),Q(13,o.IInstantiationService),Q(14,c.IDialogMainService),Q(15,n.IFileService),Q(16,D.IProtocolMainService),Q(17,J.IThemeMainService)],se),e.WindowsMainService=se}),define(ee[287],te([0,1,63,30,81,54]),function(x,e,P,L,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=class{constructor(f,u,w,y){this.a=f,this.b=u,this.c=w,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const w=this.b.getWindowById(f);if(w)return this.a.enterWorkspace(w,this.b.getWindows(),u)}createUntitledWorkspace(f,u,w){return this.a.createUntitledWorkspace(u,w)}deleteUntitledWorkspace(f,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};R=ye([Q(0,A.IWorkspacesManagementMainService),Q(1,L.IWindowsMainService),Q(2,s.IWorkspacesHistoryMainService),Q(3,P.IBackupMainService)],R),e.WorkspacesMainService=R}),define(ee[288],te([0,1,14,42,27,17,44,13,32,50,43,45,2,15,9,4,11,8,31,141,47,155,106,261,158,63,279,19,77,194,89,126,58,110,215,28,62,116,205,229,206,265,112,207,208,16,219,92,76,6,91,280,242,263,20,5,285,59,21,57,273,93,33,269,97,94,24,244,119,48,49,251,252,281,253,282,122,255,256,257,259,267,30,286,268,29,98,81,287,54,262,38,227,53,238,52,80,124,271,277,275,7,120,270,222,65,90,266,258]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i,n,o,l,a,m,D,M,T,$,z,q,ie,oe,ae,de,ce,J,Y,H,F,V,Z,ne,se,U,v,O,W,N,G,j,B,K,re,he,ve,Se,Oe,Le,Fe,me,pe,Ce,_,le,fe,ke,Me,Te,We,$e,qe,Ue,He,X,ue,ge,be,we,Ae,Ne,Ve,Ge,Ke,Ye,Ze,rt,ct,gt,Dt,Ct,Rt,Mt,At,Lt,Ot,mt,Tt,Ft,Wt,Ut,Nt,pt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let wt=class extends S.Disposable{constructor(De,Pe,Ee,Ie,Re,ze,Xe,Qe,Be,je,xe){super(),this.c=De,this.f=Pe,this.g=Ee,this.h=Ie,this.i=Re,this.j=ze,this.k=Xe,this.l=Qe,this.m=Be,this.n=je,this.p=xe,this.q(),this.r()}q(){const De=Be=>Be?.startsWith(`${d.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Be,je,xe,Je)=>De(Je.requestingUrl)?xe(Pe.has(je)):xe(!1)),P.session.defaultSession.setPermissionCheckHandler((Be,je,xe,Je)=>De(Je.requestingUrl)?Pe.has(je):!1);const Ee=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ie=Be=>{for(let je=Be;je;je=je.parent)if(je.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Re=Be=>Be.resourceType==="xhr"||Ie(Be.frame),ze=Be=>{const je=Be.frame;if(!je||!this.a)return!1;const xe=P.BrowserWindow.getAllWindows();for(const Je of xe)if(je.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(Be,je)=>{if(Be.path!=="/index.html")return!0;const xe=je.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Be,je)=>{const xe=h.URI.parse(Be.url);return xe.scheme===d.Schemas.vscodeWebview&&!Xe(xe,Be)?(this.h.error("Blocked vscode-webview request",Be.url),je({cancel:!0})):xe.scheme===d.Schemas.vscodeFileResource&&!ze(Be)?(this.h.error("Blocked vscode-file request",Be.url),je({cancel:!0})):xe.path.endsWith(".svg")&&!Ee.has(xe.scheme)?je({cancel:!Re(Be)}):je({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Be,je)=>{const xe=Be.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=h.URI.parse(Be.url);if(_e.path.endsWith(".svg")&&Ee.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],je({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return je({cancel:!Re(Be)})}return je({cancel:!1})});const Qe=P.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,I.join)(this.i.codeCachePath,"chrome"))}r(){(0,k.setUnexpectedErrorHandler)(Ee=>this.t(Ee)),process.on("uncaughtException",Ee=>(0,k.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,k.onUnexpectedError)(Ee)),this.j.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),P.app.on("accessibility-support-changed",(Ee,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),P.app.on("activate",async(Ee,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Ee,Ie)=>{Ie.on("will-navigate",Re=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),Ie.setWindowOpenHandler(({url:Re})=>(this.b?.openExternal(void 0,Re),{action:"deny"}))});let De=[],Pe;P.app.on("open-file",(Ee,Ie)=>{this.h.trace("app#open-file: ",Ie),Ee.preventDefault(),De.push((0,Ne.hasWorkspaceFileExtension)(Ie)?{workspaceUri:h.URI.file(Ie)}:{fileUri:h.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),L.validatedIpcMain.handle("vscode:fetchShellEnv",Ee=>{const Ie=this.a?.getWindowByWebContents(Ee.sender);let Re,ze;return Ie?.config?(Re=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Re=this.i.args,ze=process.env),this.M(Re,ze,!1)}),L.validatedIpcMain.handle("vscode:writeNlsFile",(Ee,Ie,Re)=>{const ze=this.s([Ie]);if(!ze||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,A.VSBuffer.fromString(Re))}),L.validatedIpcMain.handle("vscode:readNlsFile",async(Ee,...Ie)=>{const Re=this.s(Ie);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Re)).value.toString()}),L.validatedIpcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),L.validatedIpcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),L.validatedIpcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}s(De){let Pe;for(const Ee of De)typeof Ee=="string"&&(typeof Pe!="string"?Pe=Ee:Pe=(0,I.join)(Pe,Ee));if(!(typeof Pe!="string"||!(0,I.isAbsolute)(Pe)||!(0,f.isEqualOrParent)(Pe,this.i.cachedLanguagesPath,!b.isLinux)))return h.URI.file(Pe)}t(De){if(De){const Pe={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${De}`),De.stack&&this.h.error(De.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const De=this.n.win32AppUserModelId;b.isWindows&&De&&P.app.setAppUserModelId(De);try{b.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(je){this.h.error(je)}const Pe=new C.Server;this.j.onWillShutdown(je=>{je.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const Ee=await(0,Tt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:Ie,sharedProcessReady:Re,sharedProcessClient:ze}=this.C(Ee),Xe=await this.F(Ee,Ie,Re);this.D(Xe.createInstance(c.ProxyAuthHandler)),this.D(Xe.createInstance(Lt.UserDataProfilesHandler)),Xe.invokeFunction(je=>this.G(je,Pe,ze));const Qe=Xe.invokeFunction(je=>this.u(je,Pe));this.j.phase=2,await Xe.invokeFunction(je=>this.H(je,Qe)),this.j.phase=3,Xe.invokeFunction(je=>this.I(je,Ie)),this.D(new mt.RunOnceScheduler(()=>{this.D((0,mt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}u(De,Pe){const Ee=this.a=De.get(be.IWindowsMainService),Ie=De.get(qe.IURLService),Re=this.b=De.get(K.INativeHostMainService),ze=this;Ie.registerHandler({async handleURL(Je,_e){return ze.z(Ee,Ie,Je,_e)}});const Xe=this.D(new Ae.ActiveWindowManager({onDidOpenWindow:Re.onDidOpenWindow,onDidFocusWindow:Re.onDidFocusWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Qe=new p.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),Be=new Ue.URLHandlerRouter(Qe,this.h),je=Pe.getChannel("urlHandler",Be);Ie.registerHandler(new Ue.URLHandlerChannelClient(je));const xe=this.v();return this.D(new X.ElectronURLListener(xe?.urls,Ie,Ee,this.i,this.n,this.h)),xe}v(){const De=this.i.args["open-url"]?this.i.args._urls||[]:[];De.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),De.length+Pe.length===0)return;const Ee=[];return{urls:[...De,...Pe].map(Re=>{try{return{uri:h.URI.parse(Re),originalUrl:Re}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Re);return}}).filter(Re=>{if(!Re)return!1;if(this.w(Re.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Re.uri.toString(!0)),!1;const ze=this.y(Re.uri);return ze?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Re.uri.toString(!0),ze),Ee.push(ze),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Re.uri.toString(!0)),!0)}),openables:Ee}}w(De){if(De.authority===d.Schemas.file&&b.isWindows){const{options:Pe,buttonIndeces:Ee}=(0,Nt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,y.getPathLabel)(De,{os:b.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(Ee[P.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}y(De){if(!!De.path){if(De.authority===d.Schemas.file){const Pe=h.URI.file(De.fsPath);return(0,Ne.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(De.authority===d.Schemas.vscodeRemote){const Pe=De.path.indexOf(I.posix.sep,1);if(Pe!==-1){const Ee=De.path.substring(1,Pe),Ie=De.path.substring(Pe),Re=h.URI.from({scheme:d.Schemas.vscodeRemote,authority:Ee,path:Ie,query:De.query,fragment:De.fragment});return(0,Ne.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Re}:/:[\d]+$/.test(Ie)?{fileUri:Re}:{folderUri:Re}}}}}async z(De,Pe,Ee,Ie){if(this.h.trace("app#handleProtocolUrl():",Ee.toString(!0),Ie),Ee.scheme===this.n.urlProtocol&&Ee.path==="workspace"&&(Ee=Ee.with({authority:"file",path:h.URI.parse(Ee.query).path,query:""})),this.w(Ee))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",Ee.toString(!0)),!0;let Re=!1;const ze=new URLSearchParams(Ee.query);ze.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),ze.delete("windowId"),Ee=Ee.with({query:ze.toString()}),Re=!0):b.isMacintosh&&De.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),Re=!0);const Xe=ze.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ee.toString(!0)),ze.delete("continueOn"),Ee=Ee.with({query:ze.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.y(Ee);if(Qe){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,Ee.toString(!0));const[Be]=await De.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:Re,gotoLineMode:!0});return Be.focus(),!0}if(Re){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ee.toString(!0));const[Be]=await De.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,he.getRemoteAuthority)(Ee)});return await Be.ready(),Pe.open(Ee,Ie)}return this.h.trace("app#handleProtocolUrl(): not handled",Ee.toString(!0),Ie),!1}C(De){const Pe=this.D(this.g.createInstance(ve.SharedProcess,De,this.f)),Ee=(async()=>{this.h.trace("Main->SharedProcess#connect");const Re=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(Re,"main")})(),Ie=(async()=>(await Pe.whenReady(),Ee))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:Ee}}async F(De,Pe,Ee){const Ie=new v.ServiceCollection;switch(process.platform){case"win32":Ie.set(fe.IUpdateService,new se.SyncDescriptor($e.Win32UpdateService));break;case"linux":b.isLinuxSnap?Ie.set(fe.IUpdateService,new se.SyncDescriptor(We.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(fe.IUpdateService,new se.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(fe.IUpdateService,new se.SyncDescriptor(Me.DarwinUpdateService));break}Ie.set(be.IWindowsMainService,new se.SyncDescriptor(we.WindowsMainService,[De,this.f],!1));const Re=new T.DialogMainService(this.h,this.n);Ie.set(T.IDialogMainService,Re),Ie.set(N.ILaunchMainService,new se.SyncDescriptor(N.LaunchMainService,void 0,!1)),Ie.set(M.IDiagnosticsMainService,new se.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),Ie.set(D.IDiagnosticsService,p.ProxyChannel.toService((0,p.getDelayedChannel)(Ee.then(Qe=>Qe.getChannel("diagnostics"))))),Ie.set(O.IIssueMainService,new se.SyncDescriptor(O.IssueMainService,[this.f])),Ie.set($.IEncryptionMainService,new se.SyncDescriptor(z.EncryptionMainService,[De])),Ie.set(W.IKeyboardLayoutMainService,new se.SyncDescriptor(W.KeyboardLayoutMainService)),Ie.set(K.INativeHostMainService,new se.SyncDescriptor(K.NativeHostMainService,[Pe],!1)),Ie.set(a.ICredentialsMainService,new se.SyncDescriptor(Ze.CredentialsNativeMainService)),Ie.set(ue.IWebviewManagerService,new se.SyncDescriptor(ge.WebviewMainService)),Ie.set(B.IMenubarMainService,new se.SyncDescriptor(B.MenubarMainService)),Ie.set(ae.IExtensionUrlTrustService,new se.SyncDescriptor(de.ExtensionUrlTrustService)),Ie.set(ce.IExtensionHostStarter,new se.SyncDescriptor(J.ExtensionHostStarter)),Ie.set(Fe.IStorageMainService,new se.SyncDescriptor(Fe.StorageMainService)),Ie.set(Fe.IApplicationStorageMainService,new se.SyncDescriptor(Fe.ApplicationStorageMainService)),b.isWindows?Ie.set(Y.IExternalTerminalMainService,new se.SyncDescriptor(H.WindowsExternalTerminalService)):b.isMacintosh?Ie.set(Y.IExternalTerminalMainService,new se.SyncDescriptor(H.MacExternalTerminalService)):b.isLinux&&Ie.set(Y.IExternalTerminalMainService,new se.SyncDescriptor(H.LinuxExternalTerminalService));const ze=new o.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(n.IBackupMainService,ze);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Re);if(Ie.set(Ye.IWorkspacesManagementMainService,Xe),Ie.set(Ve.IWorkspacesService,new se.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Ie.set(Ge.IWorkspacesHistoryMainService,new se.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Ie.set(qe.IURLService,new se.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,le.supportsTelemetry)(this.n,this.i)){const Qe=(0,le.isInternalTelemetry)(this.n,this.k),Be=(0,p.getDelayedChannel)(Ee.then(nt=>nt.getChannel("telemetryAppender"))),je=new Ce.TelemetryAppenderClient(Be),xe=(0,me.resolveCommonProperties)(this.m,(0,s.release)(),(0,s.hostname)(),process.arch,this.n.commit,this.n.version,De,Qe,this.i.installSourcePath),Je=(0,le.getPiiPathsFromEnvironment)(this.i),_e={appenders:[je],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Ie.set(pe.ITelemetryService,new se.SyncDescriptor(_.TelemetryService,[_e],!1))}else Ie.set(pe.ITelemetryService,le.NullTelemetryService);return Ie.set(Rt.IExtensionsProfileScannerService,new se.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Ie.set(Mt.IExtensionsScannerService,new se.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Ie.set(pt.IUtilityProcessWorkerMainService,new se.SyncDescriptor(pt.UtilityProcessWorkerMainService,void 0,!0)),await mt.Promises.settled([ze.initialize(),Xe.initialize()]),this.g.createChild(Ie)}G(De,Pe,Ee){const Ie=p.ProxyChannel.fromService(De.get(N.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Re=p.ProxyChannel.fromService(De.get(M.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Re);const ze=new ct.PolicyChannel(De.get(rt.IPolicyService));Pe.registerChannel("policy",ze),Ee.then(et=>et.registerChannel("policy",ze));const Xe=this.m.getProvider(d.Schemas.file);(0,r.assertType)(Xe instanceof ne.DiskFileSystemProvider);const Qe=new Z.DiskFileSystemProviderChannel(Xe,this.h,this.i);Pe.registerChannel(F.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),Ee.then(et=>et.registerChannel(F.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const Be=p.ProxyChannel.fromService(De.get(gt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",Be),Ee.then(et=>et.registerChannel("userDataProfiles",Be));const je=new Dt.RequestChannel(De.get(Ct.IRequestService));Ee.then(et=>et.registerChannel("request",je));const xe=new ke.UpdateChannel(De.get(fe.IUpdateService));Pe.registerChannel("update",xe);const Je=p.ProxyChannel.fromService(De.get(O.IIssueMainService));Pe.registerChannel("issue",Je);const _e=p.ProxyChannel.fromService(De.get($.IEncryptionMainService));Pe.registerChannel("encryption",_e);const nt=p.ProxyChannel.fromService(De.get(a.ICredentialsMainService));Pe.registerChannel("credentials",nt);const it=p.ProxyChannel.fromService(De.get(Se.ISignService));Pe.registerChannel("sign",it);const lt=p.ProxyChannel.fromService(De.get(W.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",lt),this.b=De.get(K.INativeHostMainService);const St=p.ProxyChannel.fromService(this.b);Pe.registerChannel("nativeHost",St),Ee.then(et=>et.registerChannel("nativeHost",St));const $t=p.ProxyChannel.fromService(De.get(Ve.IWorkspacesService));Pe.registerChannel("workspaces",$t);const zt=p.ProxyChannel.fromService(De.get(B.IMenubarMainService));Pe.registerChannel("menubar",zt);const qt=p.ProxyChannel.fromService(De.get(qe.IURLService));Pe.registerChannel("url",qt);const Bt=p.ProxyChannel.fromService(De.get(ae.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Bt);const Ht=p.ProxyChannel.fromService(De.get(ue.IWebviewManagerService));Pe.registerChannel("webview",Ht);const Et=this.D(new Le.StorageDatabaseChannel(this.h,De.get(Fe.IStorageMainService)));Pe.registerChannel("storage",Et),Ee.then(et=>et.registerChannel("storage",Et));const Vt=this.D(new Ot.ProfileStorageChangesListenerChannel(De.get(Fe.IStorageMainService),De.get(gt.IUserDataProfilesMainService),this.h));Ee.then(et=>et.registerChannel("profileStorageListener",Vt));const xt=p.ProxyChannel.fromService(De.get(Y.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",xt);const It=new Wt.LoggerChannel(De.get(Ut.ILoggerMainService));Pe.registerChannel("logger",It),Ee.then(et=>et.registerChannel("logger",It));const Gt=new m.ElectronExtensionHostDebugBroadcastChannel(De.get(be.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",Gt);const Kt=p.ProxyChannel.fromService(De.get(ce.IExtensionHostStarter));Pe.registerChannel(ce.ipcExtensionHostStarterChannelName,Kt);const Xt=p.ProxyChannel.fromService(De.get(pt.IUtilityProcessWorkerMainService));Pe.registerChannel(jt.ipcUtilityProcessWorkerChannelName,Xt)}async H(De,Pe){const Ee=this.a=De.get(be.IWindowsMainService),Ie=(0,ie.isLaunchedFromCli)(process.env)?0:4,Re=this.i.args;if(Pe){if(Pe.openables.length>0)return Ee.open({context:Ie,cli:Re,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const it of Pe.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),Ee.open({context:Ie,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Xe=Re._.length,Qe=!!Re["folder-uri"],Be=!!Re["file-uri"],je=Re["skip-add-to-recently-opened"]===!0,xe=Re.wait&&Re.waitMarkerFilePath?h.URI.file(Re.waitMarkerFilePath):void 0,Je=Re.remote||void 0,_e=Re.profile,nt=Re["profile-temp"];if(!Xe&&!Qe&&!Be){if(Re["new-window"]||_e||nt)return Ee.open({context:Ie,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:je,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(ze.length)return Ee.open({context:1,cli:Re,urisToOpen:ze.map(it=>(0,Ne.hasWorkspaceFileExtension)(it)?{workspaceUri:h.URI.file(it)}:{fileUri:h.URI.file(it)}),noRecentEntry:je,waitMarkerFileURI:xe,initialStartup:!0})}return Ee.open({context:Ie,cli:Re,forceNewWindow:Re["new-window"]||!Xe&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:je,waitMarkerFileURI:xe,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(De,Pe){const Ee=De.get(pe.ITelemetryService),Ie=De.get(fe.IUpdateService);this.L(Ee,Pe),this.J(),P.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Re,ze)=>{ze({url:Re.url.replace(/^vscode-remote-resource:/,"http:"),method:Re.method})}),(Ie instanceof $e.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof Me.DarwinUpdateService)&&Ie.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const De=this.n.win32MutexName;if(b.isWindows&&De)try{const Pe=await new Promise((Ie,Re)=>{x(["windows-mutex"],Ie,Re)}),Ee=new Pe.Mutex(De);(0,u.once)(this.j.onWillShutdown)(()=>Ee.release())}catch(Pe){this.h.error(Pe)}}L(De,Pe){let Ee=!1;(0,u.once)(this.j.onWillShutdown)(()=>Ee=!0),this.D(Pe.onDidError(({type:Ie,details:Re})=>{switch(Ie){case 2:this.h.error(`[SharedProcess] renderer process gone (reason: ${Re?.reason||"<unknown>"}, code: ${Re?.exitCode||"<unknown>"})`);break;case 1:this.h.error("[SharedProcess]  detected unresponsive");break;case 3:this.h.error(`[SharedProcess]  failed to load (reason: ${Re?.reason||"<unknown>"}, code: ${Re?.exitCode||"<unknown>"})`);break}De.publicLog2("sharedprocesserror",{type:Ie,reason:Re?.reason,code:Re?.exitCode,visible:Pe.isVisible(),utilityprocess:Pe.usingUtilityProcess()?"1":"0",shuttingdown:Ee})}))}async M(De,Pe,Ee){try{return await(0,oe.getResolvedShellEnv)(this.k,this.h,De,Pe)}catch(Ie){const Re=(0,R.toErrorMessage)(Ie);Ee?this.a?.sendToFocused("vscode:showResolveShellEnvError",Re):this.h.error(Re)}return{}}async N(){try{const Pe=(await this.m.readFile(this.i.argvResource)).value.toString(),Ee=JSON.parse((0,w.stripComments)(Pe)),Re=(0,le.getTelemetryLevel)(this.k)>=1;if(Ee["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],Xe=Pe.substring(0,Pe.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(Xe))}else{const ze=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);ze!==Pe&&await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(ze))}}catch(De){this.h.error(De)}}};wt=ye([Q(2,U.IInstantiationService),Q(3,j.ILogService),Q(4,q.IEnvironmentMainService),Q(5,G.ILifecycleMainService),Q(6,l.IConfigurationService),Q(7,Oe.IStateService),Q(8,V.IFileService),Q(9,re.IProductService),Q(10,gt.IUserDataProfilesMainService)],wt),e.CodeApplication=wt}),define(ee[289],te([0,1,240,7,17,13,11,19,34,116,5,52,239,296]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let I=class extends y.AbstractRequestService{constructor(r,h,g,E){super(!!h.isRemoteServer,E),this.j=r,this.k=h,this.l=g,this.m(),this.D(r.onDidChangeConfiguration(p=>{p.affectsConfiguration("http")&&this.m()}))}m(){const r=this.j.getValue("http");this.f=r?.proxy,this.g=!!r?.proxyStrictSSL,this.h=r?.proxyAuthorization}async request(r,h){const{f:g,g:E}=this;let p;try{p=await(0,u.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(c){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(c)))}const C={...process.env,...p},t=r.agent?r.agent:await(0,S.getProxyAgent)(r.url||"",C,{proxyUrl:g,strictSSL:E});return r.agent=t,r.strictSSL=E,this.h&&(r.headers={...r.headers||{},"Proxy-Authorization":this.h}),this.p(r,h)}async n(r){return((0,P.parse)(r.url).protocol==="https:"?await new Promise((E,p)=>{x(["https"],E,p)}):await new Promise((E,p)=>{x(["http"],E,p)})).request}p(r,h){return this.c(r.isChromiumNetwork?"electron":"node",r,()=>L.Promises.withAsyncBody(async(g,E)=>{const p=(0,P.parse)(r.url),C=r.getRawRequest?r.getRawRequest(r):await this.n(r),t={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:r.type||"GET",headers:r.headers,agent:r.agent,rejectUnauthorized:(0,R.isBoolean)(r.strictSSL)?r.strictSSL:!0};r.user&&r.password&&(t.auth=r.user+":"+r.password);const c=C(t,i=>{const n=(0,R.isNumber)(r.followRedirects)?r.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.p({...r,url:i.headers.location,followRedirects:n-1},h).then(g,E);else{let o=i;!r.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,d.createGunzip)())),g({res:i,stream:(0,s.streamToBufferReadableStream)(o)})}});c.on("error",E),r.timeout&&c.setTimeout(r.timeout),r.isChromiumNetwork&&c.removeHeader("Content-Length"),r.data&&typeof r.data=="string"&&c.write(r.data),c.end(),h.onCancellationRequested(()=>{c.abort(),E(new A.CancellationError)})}))}async resolveProxy(r){}};I=ye([Q(0,k.IConfigurationService),Q(1,f.INativeEnvironmentService),Q(2,w.ILogService),Q(3,w.ILoggerService)],I),e.RequestService=I}),define(ee[290],te([0,1,14,289]),function(x,e,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function s(R){return P.net.request}class A extends L.RequestService{request(k,f){return super.request({...k||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.RequestMainService=A}),define(ee[297],te([0,1,14,41,8,26,7,44,13,32,50,45,15,9,64,4,36,25,23,47,88,288,10,19,233,243,28,62,197,16,217,92,76,213,91,20,220,5,66,21,67,272,121,249,52,290,93,241,33,48,69,53,38,228,226,2,39,254,65,221,90,117,250]),function(x,e,P,L,s,A,R,k,f,u,w,y,S,d,I,b,r,h,g,E,p,C,t,c,i,n,o,l,a,m,D,M,T,$,z,q,ie,oe,ae,de,ce,J,Y,H,F,V,Z,ne,se,U,v,O,W,N,G,j,B,K,re,he,ve,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(me){console.error(me.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,pe,Ce,_,le,fe,ke,Me]=this.b();try{try{await this.d(Ce,Me,_,le,ke)}catch(Te){throw this.f(Ce,ke,Te),Te}await me.invokeFunction(async Te=>{const We=Te.get(oe.ILogService),$e=Te.get(q.ILifecycleMainService),qe=Te.get(m.IFileService),Ue=Te.get(oe.ILoggerService),He=await this.e(We,Ce,$e,me,ke,!0);return g.Promises.writeFile(Ce.mainLockfile,String(process.pid)).catch(X=>{We.warn(`app#startup(): Error writing main lockfile: ${X.stack}`)}),fe.logger=Ue.createLogger("main",{name:(0,t.localize)(0,null)}),(0,w.once)($e.onWillShutdown)(X=>{qe.dispose(),_.dispose(),X.join("instanceLockfile",g.Promises.unlink(Ce.mainLockfile).catch(()=>{}))}),me.createInstance(C.CodeApplication,He,pe).startup()})}catch(Te){me.invokeFunction(this.i,Te)}}b(){const me=new z.ServiceCollection,pe=new j.DisposableStore;process.once("exit",()=>pe.dispose());const Ce={_serviceBrand:void 0,...ae.default};me.set(de.IProductService,Ce);const _=new o.EnvironmentMainService(this.j(),Ce),le=this.c(_);me.set(o.IEnvironmentMainService,_);const fe=new re.LoggerMainService((0,oe.getLogLevel)(_),_.logsHome);me.set(re.ILoggerMainService,fe);const ke=new ie.BufferLogger(fe.getLogLevel()),Me=pe.add(new he.LogService(ke,[new oe.ConsoleMainLogger(fe.getLogLevel())]));me.set(oe.ILogService,Me);const Te=new D.FileService(Me);me.set(m.IFileService,Te);const We=new M.DiskFileSystemProvider(Me);Te.registerProvider(S.Schemas.file,We);const $e=new K.UriIdentityService(Te);me.set(B.IUriIdentityService,$e);const qe=new Se.StateService(1,_,Me,Te);me.set(se.IStateReadService,qe),me.set(se.IStateService,qe);const Ue=new O.UserDataProfilesMainService(qe,$e,_,Te,Me);me.set(O.IUserDataProfilesMainService,Ue);const He=b.isWindows&&Ce.win32RegValueName?pe.add(new N.NativePolicyService(Me,Ce.win32RegValueName)):_.policyFile?pe.add(new G.FilePolicyService(_.policyFile,Te,Me)):new W.NullPolicyService;me.set(W.IPolicyService,He);const X=new i.ConfigurationService(Ue.defaultProfile.settingsResource,Te,He,Me);return me.set(c.IConfigurationService,X),me.set(q.ILifecycleMainService,new T.SyncDescriptor(q.LifecycleMainService,void 0,!1)),me.set(F.IRequestService,new T.SyncDescriptor(V.RequestMainService,void 0,!0)),me.set(v.IThemeMainService,new T.SyncDescriptor(v.ThemeMainService)),me.set(Z.ISignService,new T.SyncDescriptor(ne.SignService,void 0,!1)),me.set(Y.ITunnelService,new T.SyncDescriptor(H.TunnelService)),me.set(ce.IProtocolMainService,new J.ProtocolMainService(_,Ue,Me)),[new $.InstantiationService(me,!0),le,_,X,qe,ke,Ce,Ue]}c(me){const pe={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ce=>{const _=process.env[Ce];typeof _=="string"&&(pe[Ce]=_)}),Object.assign(process.env,pe),pe}async d(me,pe,Ce,_,le){await R.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.fsPath,pe.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(fe=>fe?g.Promises.mkdir(fe,{recursive:!0}):void 0)),_.init(),Ce.initialize()]),pe.init()}async e(me,pe,Ce,_,le,fe){let ke;try{(0,I.mark)("code/willStartMainServer"),ke=await(0,p.serve)(pe.mainIPCHandle),(0,I.mark)("code/didStartMainServer"),(0,w.once)(Ce.onWillShutdown)(()=>ke.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.f(pe,le,Me),Me;let Te;try{Te=await(0,p.connect)(pe.mainIPCHandle,"main")}catch(Ue){if(!fe||b.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,t.localize)(1,null,le.nameShort),(0,t.localize)(2,null),le),Ue;try{(0,L.unlinkSync)(pe.mainIPCHandle)}catch(He){throw me.warn("Could not delete obsolete instance handle",He),He}return this.e(me,pe,Ce,_,le,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${le.nameShort} is running.`;throw me.error(Ue),Te.dispose(),new Error(Ue)}let We;!pe.args.wait&&!pe.args.status&&(We=setTimeout(()=>{this.g((0,t.localize)(3,null,le.nameShort),(0,t.localize)(4,null),le)},1e4));const $e=E.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),qe=E.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return _.invokeFunction(async()=>{const Ue=new n.DiagnosticsService(U.NullTelemetryService,le),He=await qe.getMainDiagnostics(),X=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ue=await Ue.getDiagnostics(He,X);throw console.log(ue),new f.ExpectedError});throw b.isWindows&&await this.h($e,me),me.trace("Sending env to running instance..."),await $e.start(pe.args,process.env),Te.dispose(),We&&clearTimeout(We),new f.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw me.warn(`Warning: The --status argument can only be used if ${le.nameShort} is already running. Please run it again after {0} has started.`),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ke}f(me,pe,Ce){if(Ce.code==="EACCES"||Ce.code==="EPERM"){const _=(0,A.coalesce)([me.userDataPath,me.extensionsPath,p.XDG_RUNTIME_DIR]).map(le=>(0,y.getPathLabel)(s.URI.file(le),{os:b.OS,tildify:me}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Ce),_.join(`
`)),pe)}}g(me,pe,Ce){P.dialog.showMessageBoxSync((0,ve.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:me,detail:pe},Ce).options)}async h(me,pe){if(b.isWindows){const Ce=await me.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Ce);try{(await new Promise((_,le)=>{x(["windows-foreground-love"],_,le)})).allowSetForegroundWindow(Ce)}catch(_){pe.error(_)}}}i(me,pe){const Ce=me.get(oe.ILogService),_=me.get(q.ILifecycleMainService);let le=0;pe&&(pe.isExpected?pe.message&&Ce.trace(pe.message):(le=1,pe.stack?Ce.error(pe.stack):Ce.error(`Startup error: ${pe.toString()}`))),_.kill(le)}j(){const me=this.k((0,l.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const pe=(0,a.createWaitMarkerFileSync)(me.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),me.waitMarkerFilePath=pe)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const pe=this.l(me._,me.goto);me._=pe}return me}l(me,pe){const Ce=(0,r.cwd)(),_=me.map(ke=>{let Me=String(ke),Te;pe&&(Te=(0,u.parseLineAndColumnAware)(Me),Me=Te.path),Me&&(Me=this.m(Ce,Me));const We=(0,u.sanitizeFilePath)(Me,Ce),$e=(0,d.basename)(We);return $e&&!(0,u.isValidBasename)($e)?null:pe&&Te?(Te.path=We,this.n(Te)):We}),le=b.isWindows||b.isMacintosh,fe=(0,A.distinct)(_,ke=>ke&&le?ke.toLowerCase():ke||"");return(0,A.coalesce)(fe)}m(me,pe){return b.isWindows&&(pe=(0,h.rtrim)(pe,'"')),pe=(0,h.trim)((0,h.trim)(pe," "),"	"),b.isWindows&&(pe=(0,d.resolve)(me,pe),pe=(0,h.rtrim)(pe,".")),pe}n(me){const pe=[me.path];return typeof me.line=="number"&&pe.push(String(me.line)),typeof me.column=="number"&&pe.push(String(me.column)),pe.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/code/electron-main/main.js.map
