/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/common/objects","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(J){for(var t=[],E=0,R=J.length;E<R;E++)t[E]=ge[J[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(J){if(Array.isArray(J)){for(var t=0,E=Array(J.length);t<J.length;t++)E[t]=J[t];return E}else return Array.from(J)}var xt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,qt=Object.isFrozen,jt=Object.getPrototypeOf,Vt=Object.getOwnPropertyDescriptor,it=Object.freeze,at=Object.seal,Kt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,At=It.construct;vt||(vt=function(t,E,R){return t.apply(E,R)}),it||(it=function(t){return t}),at||(at=function(t){return t}),At||(At=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat(_t(E))))});var Gt=st(Array.prototype.forEach),Mt=st(Array.prototype.pop),gt=st(Array.prototype.push),ct=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Yt=st(String.prototype.indexOf),Xt=st(String.prototype.trim),lt=st(RegExp.prototype.test),Rt=Zt(TypeError);function st(J){return function(t){for(var E=arguments.length,R=Array(E>1?E-1:0),i=1;i<E;i++)R[i-1]=arguments[i];return vt(J,t,R)}}function Zt(J){return function(){for(var t=arguments.length,E=Array(t),R=0;R<t;R++)E[R]=arguments[R];return At(J,E)}}function He(J,t){Nt&&Nt(J,null);for(var E=t.length;E--;){var R=t[E];if(typeof R=="string"){var i=ct(R);i!==R&&(qt(t)||(t[E]=i),R=i)}J[R]=!0}return J}function dt(J){var t=Kt(null),E=void 0;for(E in J)vt(xt,J,[E])&&(t[E]=J[E]);return t}function Dt(J,t){for(;J!==null;){var E=Vt(J,t);if(E){if(E.get)return st(E.get);if(typeof E.value=="function")return st(E.value)}J=jt(J)}function R(i){return console.warn("fallback value for",i),null}return R}var Ot=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Qt=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ft=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Jt=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=it(["#text"]),Ht=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),kt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),zt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),wt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=at(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=at(/<%[\s\S]*|[\s\S]*%>/gm),ii=at(/^data-[\-\w.\u00B7-\uFFFF]/),ni=at(/^aria-[\-\w]+$/),si=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=at(/^(?:\w+script|data):/i),oi=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(J){return typeof J}:function(J){return J&&typeof Symbol=="function"&&J.constructor===Symbol&&J!==Symbol.prototype?"symbol":typeof J};function ot(J){if(Array.isArray(J)){for(var t=0,E=Array(J.length);t<J.length;t++)E[t]=J[t];return E}else return Array.from(J)}var ai=function(){return typeof window>"u"?null:window},li=function(t,E){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var R=null,i="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(i)&&(R=E.currentScript.getAttribute(i));var W="dompurify"+(R?"#"+R:"");try{return t.createPolicy(W,{createHTML:function(D){return D}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ut(){var J=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(ce){return Ut(ce)};if(t.version="2.3.1",t.removed=[],!J||!J.document||J.document.nodeType!==9)return t.isSupported=!1,t;var E=J.document,R=J.document,i=J.DocumentFragment,W=J.HTMLTemplateElement,v=J.Node,D=J.Element,g=J.NodeFilter,l=J.NamedNodeMap,c=l===void 0?J.NamedNodeMap||J.MozNamedAttrMap:l,P=J.Text,r=J.Comment,u=J.DOMParser,e=J.trustedTypes,a=D.prototype,n=Dt(a,"cloneNode"),s=Dt(a,"nextSibling"),o=Dt(a,"childNodes"),y=Dt(a,"parentNode");if(typeof W=="function"){var A=R.createElement("template");A.content&&A.content.ownerDocument&&(R=A.content.ownerDocument)}var S=li(e,E),d=S&&Y?S.createHTML(""):"",p=R,L=p.implementation,I=p.createNodeIterator,h=p.createDocumentFragment,b=p.getElementsByTagName,m=E.importNode,w={};try{w=dt(R).documentMode?R.documentMode:{}}catch{}var O={};t.isSupported=typeof y=="function"&&L&&typeof L.createHTMLDocument<"u"&&w!==9;var V=ei,ie=ti,se=ii,ae=ni,de=ri,ue=oi,Z=si,Q=null,ve=He({},[].concat(ot(Ot),ot(St),ot(Ct),ot(Ft),ot(Bt))),pe=null,Me=He({},[].concat(ot(Ht),ot(kt),ot(zt),ot(wt))),Re=null,le=null,_=!0,ne=!0,ee=!1,te=!1,T=!1,x=!1,M=!1,f=!1,C=!1,$=!0,Y=!1,F=!0,N=!0,B=!1,k={},z=null,H=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),U=null,q=He({},["audio","video","img","source","image","track"]),G=null,re=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),he="http://www.w3.org/1998/Math/MathML",we="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",Le=ye,Ce=!1,De=null,Pe=R.createElement("form"),Ie=function(ce){De&&De===ce||((!ce||(typeof ce>"u"?"undefined":mt(ce))!=="object")&&(ce={}),ce=dt(ce),Q="ALLOWED_TAGS"in ce?He({},ce.ALLOWED_TAGS):ve,pe="ALLOWED_ATTR"in ce?He({},ce.ALLOWED_ATTR):Me,G="ADD_URI_SAFE_ATTR"in ce?He(dt(re),ce.ADD_URI_SAFE_ATTR):re,U="ADD_DATA_URI_TAGS"in ce?He(dt(q),ce.ADD_DATA_URI_TAGS):q,z="FORBID_CONTENTS"in ce?He({},ce.FORBID_CONTENTS):H,Re="FORBID_TAGS"in ce?He({},ce.FORBID_TAGS):{},le="FORBID_ATTR"in ce?He({},ce.FORBID_ATTR):{},k="USE_PROFILES"in ce?ce.USE_PROFILES:!1,_=ce.ALLOW_ARIA_ATTR!==!1,ne=ce.ALLOW_DATA_ATTR!==!1,ee=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,te=ce.SAFE_FOR_TEMPLATES||!1,T=ce.WHOLE_DOCUMENT||!1,f=ce.RETURN_DOM||!1,C=ce.RETURN_DOM_FRAGMENT||!1,$=ce.RETURN_DOM_IMPORT!==!1,Y=ce.RETURN_TRUSTED_TYPE||!1,M=ce.FORCE_BODY||!1,F=ce.SANITIZE_DOM!==!1,N=ce.KEEP_CONTENT!==!1,B=ce.IN_PLACE||!1,Z=ce.ALLOWED_URI_REGEXP||Z,Le=ce.NAMESPACE||ye,te&&(ne=!1),C&&(f=!0),k&&(Q=He({},[].concat(ot(Bt))),pe=[],k.html===!0&&(He(Q,Ot),He(pe,Ht)),k.svg===!0&&(He(Q,St),He(pe,kt),He(pe,wt)),k.svgFilters===!0&&(He(Q,Ct),He(pe,kt),He(pe,wt)),k.mathMl===!0&&(He(Q,Ft),He(pe,zt),He(pe,wt))),ce.ADD_TAGS&&(Q===ve&&(Q=dt(Q)),He(Q,ce.ADD_TAGS)),ce.ADD_ATTR&&(pe===Me&&(pe=dt(pe)),He(pe,ce.ADD_ATTR)),ce.ADD_URI_SAFE_ATTR&&He(G,ce.ADD_URI_SAFE_ATTR),ce.FORBID_CONTENTS&&(z===H&&(z=dt(z)),He(z,ce.FORBID_CONTENTS)),N&&(Q["#text"]=!0),T&&He(Q,["html","head","body"]),Q.table&&(He(Q,["tbody"]),delete Re.tbody),it&&it(ce),De=ce)},je=He({},["mi","mo","mn","ms","mtext"]),ze=He({},["foreignobject","desc","title","annotation-xml"]),Ue=He({},St);He(Ue,Ct),He(Ue,Qt);var Ze=He({},Ft);He(Ze,Jt);var Ge=function(ce){var Ae=y(ce);(!Ae||!Ae.tagName)&&(Ae={namespaceURI:ye,tagName:"template"});var Ne=ct(ce.tagName),_e=ct(Ae.tagName);if(ce.namespaceURI===we)return Ae.namespaceURI===ye?Ne==="svg":Ae.namespaceURI===he?Ne==="svg"&&(_e==="annotation-xml"||je[_e]):Boolean(Ue[Ne]);if(ce.namespaceURI===he)return Ae.namespaceURI===ye?Ne==="math":Ae.namespaceURI===we?Ne==="math"&&ze[_e]:Boolean(Ze[Ne]);if(ce.namespaceURI===ye){if(Ae.namespaceURI===we&&!ze[_e]||Ae.namespaceURI===he&&!je[_e])return!1;var Qe=He({},["title","style","font","a","script"]);return!Ze[Ne]&&(Qe[Ne]||!Ue[Ne])}return!1},Be=function(ce){gt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{try{ce.outerHTML=d}catch{ce.remove()}}},j=function(ce,Ae){try{gt(t.removed,{attribute:Ae.getAttributeNode(ce),from:Ae})}catch{gt(t.removed,{attribute:null,from:Ae})}if(Ae.removeAttribute(ce),ce==="is"&&!pe[ce])if(f||C)try{Be(Ae)}catch{}else try{Ae.setAttribute(ce,"")}catch{}},oe=function(ce){var Ae=void 0,Ne=void 0;if(M)ce="<remove></remove>"+ce;else{var _e=Pt(ce,/^[\r\n\t ]+/);Ne=_e&&_e[0]}var Qe=S?S.createHTML(ce):ce;if(Le===ye)try{Ae=new u().parseFromString(Qe,"text/html")}catch{}if(!Ae||!Ae.documentElement){Ae=L.createDocument(Le,"template",null);try{Ae.documentElement.innerHTML=Ce?"":Qe}catch{}}var Je=Ae.body||Ae.documentElement;return ce&&Ne&&Je.insertBefore(R.createTextNode(Ne),Je.childNodes[0]||null),Le===ye?b.call(Ae,T?"html":"body")[0]:T?Ae.documentElement:Je},be=function(ce){return I.call(ce.ownerDocument||ce,ce,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},Ee=function(ce){return ce instanceof P||ce instanceof r?!1:typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof c)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"},Se=function(ce){return(typeof v>"u"?"undefined":mt(v))==="object"?ce instanceof v:ce&&(typeof ce>"u"?"undefined":mt(ce))==="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},Oe=function(ce,Ae,Ne){!O[ce]||Gt(O[ce],function(_e){_e.call(t,Ae,Ne,De)})},$e=function(ce){var Ae=void 0;if(Oe("beforeSanitizeElements",ce,null),Ee(ce)||Pt(ce.nodeName,/[\u0080-\uFFFF]/))return Be(ce),!0;var Ne=ct(ce.nodeName);if(Oe("uponSanitizeElement",ce,{tagName:Ne,allowedTags:Q}),!Se(ce.firstElementChild)&&(!Se(ce.content)||!Se(ce.content.firstElementChild))&&lt(/<[/\w]/g,ce.innerHTML)&&lt(/<[/\w]/g,ce.textContent)||Ne==="select"&&lt(/<template/i,ce.innerHTML))return Be(ce),!0;if(!Q[Ne]||Re[Ne]){if(N&&!z[Ne]){var _e=y(ce)||ce.parentNode,Qe=o(ce)||ce.childNodes;if(Qe&&_e)for(var Je=Qe.length,et=Je-1;et>=0;--et)_e.insertBefore(n(Qe[et],!0),s(ce))}return Be(ce),!0}return ce instanceof D&&!Ge(ce)||(Ne==="noscript"||Ne==="noembed")&&lt(/<\/no(script|embed)/i,ce.innerHTML)?(Be(ce),!0):(te&&ce.nodeType===3&&(Ae=ce.textContent,Ae=ut(Ae,V," "),Ae=ut(Ae,ie," "),ce.textContent!==Ae&&(gt(t.removed,{element:ce.cloneNode()}),ce.textContent=Ae)),Oe("afterSanitizeElements",ce,null),!1)},tt=function(ce,Ae,Ne){if(F&&(Ae==="id"||Ae==="name")&&(Ne in R||Ne in Pe))return!1;if(!(ne&&!le[Ae]&&lt(se,Ae))){if(!(_&&lt(ae,Ae))){if(!pe[Ae]||le[Ae])return!1;if(!G[Ae]){if(!lt(Z,ut(Ne,ue,""))){if(!((Ae==="src"||Ae==="xlink:href"||Ae==="href")&&ce!=="script"&&Yt(Ne,"data:")===0&&U[ce])){if(!(ee&&!lt(de,ut(Ne,ue,"")))){if(Ne)return!1}}}}}}return!0},Ke=function(ce){var Ae=void 0,Ne=void 0,_e=void 0,Qe=void 0;Oe("beforeSanitizeAttributes",ce,null);var Je=ce.attributes;if(!!Je){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:pe};for(Qe=Je.length;Qe--;){Ae=Je[Qe];var rt=Ae,ht=rt.name,yt=rt.namespaceURI;if(Ne=Xt(Ae.value),_e=ct(ht),et.attrName=_e,et.attrValue=Ne,et.keepAttr=!0,et.forceKeepAttr=void 0,Oe("uponSanitizeAttribute",ce,et),Ne=et.attrValue,!et.forceKeepAttr&&(j(ht,ce),!!et.keepAttr)){if(lt(/\/>/i,Ne)){j(ht,ce);continue}te&&(Ne=ut(Ne,V," "),Ne=ut(Ne,ie," "));var Tt=ce.nodeName.toLowerCase();if(!!tt(Tt,_e,Ne))try{yt?ce.setAttributeNS(yt,ht,Ne):ce.setAttribute(ht,Ne),Mt(t.removed)}catch{}}}Oe("afterSanitizeAttributes",ce,null)}},xe=function Te(ce){var Ae=void 0,Ne=be(ce);for(Oe("beforeSanitizeShadowDOM",ce,null);Ae=Ne.nextNode();)Oe("uponSanitizeShadowNode",Ae,null),!$e(Ae)&&(Ae.content instanceof i&&Te(Ae.content),Ke(Ae));Oe("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Te,ce){var Ae=void 0,Ne=void 0,_e=void 0,Qe=void 0,Je=void 0;if(Ce=!Te,Ce&&(Te="<!-->"),typeof Te!="string"&&!Se(Te)){if(typeof Te.toString!="function")throw Rt("toString is not a function");if(Te=Te.toString(),typeof Te!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(J.toStaticHTML)==="object"||typeof J.toStaticHTML=="function"){if(typeof Te=="string")return J.toStaticHTML(Te);if(Se(Te))return J.toStaticHTML(Te.outerHTML)}return Te}if(x||Ie(ce),t.removed=[],typeof Te=="string"&&(B=!1),!B)if(Te instanceof v)Ae=oe("<!---->"),Ne=Ae.ownerDocument.importNode(Te,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Ae=Ne:Ae.appendChild(Ne);else{if(!f&&!te&&!T&&Te.indexOf("<")===-1)return S&&Y?S.createHTML(Te):Te;if(Ae=oe(Te),!Ae)return f?null:d}Ae&&M&&Be(Ae.firstChild);for(var et=be(B?Te:Ae);_e=et.nextNode();)_e.nodeType===3&&_e===Qe||$e(_e)||(_e.content instanceof i&&xe(_e.content),Ke(_e),Qe=_e);if(Qe=null,B)return Te;if(f){if(C)for(Je=h.call(Ae.ownerDocument);Ae.firstChild;)Je.appendChild(Ae.firstChild);else Je=Ae;return $&&(Je=m.call(E,Je,!0)),Je}var rt=T?Ae.outerHTML:Ae.innerHTML;return te&&(rt=ut(rt,V," "),rt=ut(rt,ie," ")),S&&Y?S.createHTML(rt):rt},t.setConfig=function(Te){Ie(Te),x=!0},t.clearConfig=function(){De=null,x=!1},t.isValidAttribute=function(Te,ce,Ae){De||Ie({});var Ne=ct(Te),_e=ct(ce);return tt(Ne,_e,Ae)},t.addHook=function(Te,ce){typeof ce=="function"&&(O[Te]=O[Te]||[],gt(O[Te],ce))},t.removeHook=function(Te){O[Te]&&Mt(O[Te])},t.removeHooks=function(Te){O[Te]&&(O[Te]=[])},t.removeAllHooks=function(){O={}},t}var ui=Ut();define("vs/base/browser/dompurify/dompurify",function(){return ui}),define(ge[38],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(v){this.domNode=v,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(v){const D=R(v);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(v){const D=R(v);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(v){const D=R(v);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(v){const D=R(v);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(v){const D=R(v);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(v){const D=R(v);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(v){const D=R(v);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(v){const D=R(v);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(v){const D=R(v);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(v){const D=R(v);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(v){const D=R(v);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(v){this.l!==v&&(this.l=v,this.domNode.style.fontFamily=this.l)}setFontWeight(v){this.m!==v&&(this.m=v,this.domNode.style.fontWeight=this.m)}setFontSize(v){const D=R(v);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(v){this.o!==v&&(this.o=v,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(v){this.p!==v&&(this.p=v,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(v){this.q!==v&&(this.q=v,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(v){this.r!==v&&(this.r=v,this.domNode.style.textDecoration=this.r)}setLineHeight(v){const D=R(v);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(v){const D=R(v);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(v){this.u!==v&&(this.u=v,this.domNode.className=this.u)}toggleClassName(v,D){this.domNode.classList.toggle(v,D),this.u=this.domNode.className}setDisplay(v){this.v!==v&&(this.v=v,this.domNode.style.display=this.v)}setPosition(v){this.w!==v&&(this.w=v,this.domNode.style.position=this.w)}setVisibility(v){this.x!==v&&(this.x=v,this.domNode.style.visibility=this.x)}setColor(v){this.y!==v&&(this.y=v,this.domNode.style.color=this.y)}setBackgroundColor(v){this.z!==v&&(this.z=v,this.domNode.style.backgroundColor=this.z)}setLayerHinting(v){this.A!==v&&(this.A=v,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(v){this.C!==v&&(this.C=v,this.domNode.style.boxShadow=v)}setContain(v){this.B!==v&&(this.B=v,this.domNode.style.contain=this.B)}setAttribute(v,D){this.domNode.setAttribute(v,D)}removeAttribute(v){this.domNode.removeAttribute(v)}appendChild(v){this.domNode.appendChild(v.domNode)}removeChild(v){this.domNode.removeChild(v.domNode)}}t.FastDomNode=E;function R(W){return typeof W=="number"?`${W}px`:W}function i(W){return new E(W)}t.createFastDomNode=i}),define(ge[65],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,R=null;function i(v){if(!v.parent||v.parent===v)return null;try{const D=v.location,g=v.parent.location;if(D.origin!=="null"&&g.origin!=="null"&&D.origin!==g.origin)return E=!0,null}catch{return E=!0,null}return v.parent}class W{static getSameOriginWindowChain(){if(!R){R=[];let D=window,g;do g=i(D),g?R.push({window:D,iframeElement:D.frameElement||null}):R.push({window:D,iframeElement:null}),D=g;while(D)}return R.slice(0)}static hasDifferentOriginAncestor(){return R||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(D,g){if(!g||D===g)return{top:0,left:0};let l=0,c=0;const P=this.getSameOriginWindowChain();for(const r of P){if(l+=r.window.scrollY,c+=r.window.scrollX,r.window===g||!r.iframeElement)break;const u=r.iframeElement.getBoundingClientRect();l+=u.top,c+=u.left}return{top:l,left:c}}}t.IframeUtils=W}),define(ge[66],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(E=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class R extends Error{constructor(v,D){super(`ListError [${v}] ${D}`)}}t.ListError=R;class i{constructor(){this.c=new WeakMap}getHeight(v){return this.c.get(v)??this.d(v)}setDynamicHeight(v,D){D>0&&this.c.set(v,D)}}t.CachedListVirtualDelegate=i}),define(ge[67],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(i){this.a=i}splice(i,W,v){this.a.forEach(D=>D.splice(i,W,v))}}t.CombinedSpliceable=E}),define(ge[39],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class R{constructor(W,v,D,g,l,c){this.a=Math.round(v),this.b=Math.round(D),this.c=Math.round(W),this.d=g,this.e=l,this.f=c,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new R(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const v=Math.round(W);return this.d!==v?(this.d=v,this.m(),!0):!1}setScrollSize(W){const v=Math.round(W);return this.e!==v?(this.e=v,this.m(),!0):!1}setScrollPosition(W){const v=Math.round(W);return this.f!==v?(this.f=v,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,v,D,g,l){const c=Math.max(0,D-W),P=Math.max(0,c-2*v),r=g>0&&g>D;if(!r)return{computedAvailableSize:Math.round(c),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const u=Math.round(Math.max(E,Math.floor(D*P/g))),e=(P-u)/(g-D),a=l*e;return{computedAvailableSize:Math.round(c),computedIsNeeded:r,computedSliderSize:Math.round(u),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const W=R.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const v=W-this.c-this.i/2;return Math.round(v/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const v=W-this.c;let D=this.f;return v<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const v=this.k+W;return Math.round(v/this.j)}}t.ScrollbarState=R}),define(ge[24],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var E;(function(D){D[D.Hidden=0]="Hidden",D[D.Visible=1]="Visible",D[D.Recurse=2]="Recurse"})(E=t.TreeVisibility||(t.TreeVisibility={}));var R;(function(D){D[D.Unknown=0]="Unknown",D[D.Twistie=1]="Twistie",D[D.Element=2]="Element",D[D.Filter=3]="Filter"})(R=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var i;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(i=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(D=!1){return{accept:!0,bubble:0,autoExpand:D}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(D=!1){return{accept:!0,bubble:0,effect:0,autoExpand:D}}};class W extends Error{constructor(g,l){super(`TreeError [${g}] ${l}`)}}t.TreeError=W;class v{constructor(g){this.a=g,this.b=new WeakMap}map(g){let l=this.b.get(g);return l||(l=this.a(g),this.b.set(g,l)),l}}t.WeakMapper=v}),define(ge[68],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(v,D){const g=Object.create(null);for(const l of v){const c=D(l);let P=g[c];P||(P=g[c]=[]),P.push(l)}return g}t.groupBy=E;function R(v,D){const g=[],l=[];for(const c of v)D.has(c)||g.push(c);for(const c of D)v.has(c)||l.push(c);return{removed:g,added:l}}t.diffSets=R;function i(v,D){const g=[],l=[];for(const[c,P]of v)D.has(c)||g.push(P);for(const[c,P]of D)v.has(c)||l.push(P);return{removed:g,added:l}}t.diffMaps=i;class W{constructor(){this.a=new Map}add(D,g){let l=this.a.get(D);l||(l=new Set,this.a.set(D,l)),l.add(g)}delete(D,g){const l=this.a.get(D);!l||(l.delete(g),l.size===0&&this.a.delete(D))}forEach(D,g){const l=this.a.get(D);!l||l.forEach(g)}}t.SetMap=W}),define(ge[69],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(D,g){const l=Math.pow(10,g);return Math.round(D*l)/l}class R{constructor(g,l,c,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=E(Math.max(Math.min(1,P),0),3)}static equals(g,l){return g.r===l.r&&g.g===l.g&&g.b===l.b&&g.a===l.a}}t.RGBA=R;class i{constructor(g,l,c,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,c),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(g,l){return g.h===l.h&&g.s===l.s&&g.l===l.l&&g.a===l.a}static fromRGBA(g){const l=g.r/255,c=g.g/255,P=g.b/255,r=g.a,u=Math.max(l,c,P),e=Math.min(l,c,P);let a=0,n=0;const s=(e+u)/2,o=u-e;if(o>0){switch(n=Math.min(s<=.5?o/(2*s):o/(2-2*s),1),u){case l:a=(c-P)/o+(c<P?6:0);break;case c:a=(P-l)/o+2;break;case P:a=(l-c)/o+4;break}a*=60,a=Math.round(a)}return new i(a,n,s,r)}static i(g,l,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?g+(l-g)*6*c:c<1/2?l:c<2/3?g+(l-g)*(2/3-c)*6:g}static toRGBA(g){const l=g.h/360,{s:c,l:P,a:r}=g;let u,e,a;if(c===0)u=e=a=P;else{const n=P<.5?P*(1+c):P+c-P*c,s=2*P-n;u=i.i(s,n,l+1/3),e=i.i(s,n,l),a=i.i(s,n,l-1/3)}return new R(Math.round(u*255),Math.round(e*255),Math.round(a*255),r)}}t.HSLA=i;class W{constructor(g,l,c,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,c),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(g,l){return g.h===l.h&&g.s===l.s&&g.v===l.v&&g.a===l.a}static fromRGBA(g){const l=g.r/255,c=g.g/255,P=g.b/255,r=Math.max(l,c,P),u=Math.min(l,c,P),e=r-u,a=r===0?0:e/r;let n;return e===0?n=0:r===l?n=((c-P)/e%6+6)%6:r===c?n=(P-l)/e+2:n=(l-c)/e+4,new W(Math.round(n*60),a,r,g.a)}static toRGBA(g){const{h:l,s:c,v:P,a:r}=g,u=P*c,e=u*(1-Math.abs(l/60%2-1)),a=P-u;let[n,s,o]=[0,0,0];return l<60?(n=u,s=e):l<120?(n=e,s=u):l<180?(s=u,o=e):l<240?(s=e,o=u):l<300?(n=e,o=u):l<=360&&(n=u,o=e),n=Math.round((n+a)*255),s=Math.round((s+a)*255),o=Math.round((o+a)*255),new R(n,s,o,r)}}t.HSVA=W;class v{static fromHex(g){return v.Format.CSS.parseHex(g)||v.red}static equals(g,l){return!g&&!l?!0:!g||!l?!1:g.equals(l)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof R)this.rgba=g;else if(g instanceof i)this.i=g,this.rgba=i.toRGBA(g);else if(g instanceof W)this.j=g,this.rgba=W.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&R.equals(this.rgba,g.rgba)&&i.equals(this.hsla,g.hsla)&&W.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=v.k(this.rgba.r),l=v.k(this.rgba.g),c=v.k(this.rgba.b),P=.2126*g+.7152*l+.0722*c;return E(P,4)}static k(g){const l=g/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(g){const l=this.getRelativeLuminance(),c=g.getRelativeLuminance();return l>c?(l+.05)/(c+.05):(c+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const l=this.getRelativeLuminance(),c=g.getRelativeLuminance();return l>c}isDarkerThan(g){const l=this.getRelativeLuminance(),c=g.getRelativeLuminance();return l<c}lighten(g){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:l,g:c,b:P,a:r}=this.rgba;return new v(new R(l,c,P,r*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const l=g.rgba,c=this.rgba.a,P=l.a,r=c+P*(1-c);if(r<1e-6)return v.transparent;const u=this.rgba.r*c/r+l.r*P*(1-c)/r,e=this.rgba.g*c/r+l.g*P*(1-c)/r,a=this.rgba.b*c/r+l.b*P*(1-c)/r;return new v(new R(u,e,a,r))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:l,g:c,b:P,a:r}=this.rgba;return new v(new R(g.rgba.r-r*(g.rgba.r-l),g.rgba.g-r*(g.rgba.g-c),g.rgba.b-r*(g.rgba.b-P),1))}flatten(...g){const l=g.reduceRight((c,P)=>v.o(P,c));return v.o(this,l)}static o(g,l){const c=1-g.rgba.a;return new v(new R(c*l.rgba.r+g.rgba.a*g.rgba.r,c*l.rgba.g+g.rgba.a*g.rgba.g,c*l.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(g,l,c){if(g.isLighterThan(l))return g;c=c||.5;const P=g.getRelativeLuminance(),r=l.getRelativeLuminance();return c=c*(r-P)/r,g.lighten(c)}static getDarkerColor(g,l,c){if(g.isDarkerThan(l))return g;c=c||.5;const P=g.getRelativeLuminance(),r=l.getRelativeLuminance();return c=c*(P-r)/P,g.darken(c)}}v.white=new v(new R(255,255,255,1)),v.black=new v(new R(0,0,0,1)),v.red=new v(new R(255,0,0,1)),v.blue=new v(new R(0,0,255,1)),v.green=new v(new R(0,255,0,1)),v.cyan=new v(new R(0,255,255,1)),v.lightgrey=new v(new R(211,211,211,1)),v.transparent=new v(new R(0,0,0,0)),t.Color=v,function(D){let g;(function(l){let c;(function(P){function r(d){return d.rgba.a===1?`rgb(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b})`:D.Format.CSS.formatRGBA(d)}P.formatRGB=r;function u(d){return`rgba(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b}, ${+d.rgba.a.toFixed(2)})`}P.formatRGBA=u;function e(d){return d.hsla.a===1?`hsl(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(d)}P.formatHSL=e;function a(d){return`hsla(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%, ${d.hsla.a.toFixed(2)})`}P.formatHSLA=a;function n(d){const p=d.toString(16);return p.length!==2?"0"+p:p}function s(d){return`#${n(d.rgba.r)}${n(d.rgba.g)}${n(d.rgba.b)}`}P.formatHex=s;function o(d,p=!1){return p&&d.rgba.a===1?D.Format.CSS.formatHex(d):`#${n(d.rgba.r)}${n(d.rgba.g)}${n(d.rgba.b)}${n(Math.round(d.rgba.a*255))}`}P.formatHexA=o;function y(d){return d.isOpaque()?D.Format.CSS.formatHex(d):D.Format.CSS.formatRGBA(d)}P.format=y;function A(d){const p=d.length;if(p===0||d.charCodeAt(0)!==35)return null;if(p===7){const L=16*S(d.charCodeAt(1))+S(d.charCodeAt(2)),I=16*S(d.charCodeAt(3))+S(d.charCodeAt(4)),h=16*S(d.charCodeAt(5))+S(d.charCodeAt(6));return new D(new R(L,I,h,1))}if(p===9){const L=16*S(d.charCodeAt(1))+S(d.charCodeAt(2)),I=16*S(d.charCodeAt(3))+S(d.charCodeAt(4)),h=16*S(d.charCodeAt(5))+S(d.charCodeAt(6)),b=16*S(d.charCodeAt(7))+S(d.charCodeAt(8));return new D(new R(L,I,h,b/255))}if(p===4){const L=S(d.charCodeAt(1)),I=S(d.charCodeAt(2)),h=S(d.charCodeAt(3));return new D(new R(16*L+L,16*I+I,16*h+h))}if(p===5){const L=S(d.charCodeAt(1)),I=S(d.charCodeAt(2)),h=S(d.charCodeAt(3)),b=S(d.charCodeAt(4));return new D(new R(16*L+L,16*I+I,16*h+h,(16*b+b)/255))}return null}P.parseHex=A;function S(d){switch(d){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=l.CSS||(l.CSS={}))})(g=D.Format||(D.Format={}))}(v=t.Color||(t.Color={})),t.Color=v}),define(ge[25],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(v){return(D,g,l)=>{let c=null,P=null;if(typeof l.value=="function"?(c="value",P=l.value):typeof l.get=="function"&&(c="get",P=l.get),!P)throw new Error("not supported");l[c]=v(P,g)}}function R(v,D,g){let l=null,c=null;if(typeof g.value=="function"?(l="value",c=g.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",c=g.get),!c)throw new Error("not supported");const P=`$memoize$${D}`;g[l]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,r)}),this[P]}}t.memoize=R;function i(v,D,g){return E((l,c)=>{const P=`$debounce$${c}`,r=`$debounce$result$${c}`;return function(...u){this[r]||(this[r]=g?g():void 0),clearTimeout(this[P]),D&&(this[r]=D(this[r],...u),u=[this[r]]),this[P]=setTimeout(()=>{l.apply(this,u),this[r]=g?g():void 0},v)}})}t.debounce=i;function W(v,D,g){return E((l,c)=>{const P=`$throttle$timer$${c}`,r=`$throttle$result$${c}`,u=`$throttle$lastRun$${c}`,e=`$throttle$pending$${c}`;return function(...a){if(this[r]||(this[r]=g?g():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),D&&(this[r]=D(this[r],...a)),this[e])return;const n=this[u]+v;n<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[r]]),this[r]=g?g():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[u]=Date.now(),l.apply(this,[this[r]]),this[r]=g?g():void 0},n-Date.now()))}})}t.throttle=W}),define(ge[70],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(i,W,v,D){this.originalStart=i,this.originalLength=W,this.modifiedStart=v,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(p){setTimeout(()=>{throw p.stack?A.isErrorNoTelemetry(p)?new A(p.message+`

`+p.stack):new Error(p.message+`

`+p.stack):p},0)}}addListener(p){return this.b.push(p),()=>{this.d(p)}}c(p){this.b.forEach(L=>{L(p)})}d(p){this.b.splice(this.b.indexOf(p),1)}setUnexpectedErrorHandler(p){this.a=p}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(p){this.a(p),this.c(p)}onUnexpectedExternalError(p){this.a(p)}}t.ErrorHandler=E,t.errorHandler=new E;function R(d){t.errorHandler.setUnexpectedErrorHandler(d)}t.setUnexpectedErrorHandler=R;function i(d){if(!d||typeof d!="object")return!1;const p=d;return p.code==="EPIPE"&&p.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function W(d){l(d)||t.errorHandler.onUnexpectedError(d)}t.onUnexpectedError=W;function v(d){l(d)||t.errorHandler.onUnexpectedExternalError(d)}t.onUnexpectedExternalError=v;function D(d){if(d instanceof Error){const{name:p,message:L}=d,I=d.stacktrace||d.stack;return{$isError:!0,name:p,message:L,stack:I,noTelemetry:A.isErrorNoTelemetry(d)}}return d}t.transformErrorForSerialization=D;const g="Canceled";function l(d){return d instanceof c?!0:d instanceof Error&&d.name===g&&d.message===g}t.isCancellationError=l;class c extends Error{constructor(){super(g),this.name=this.message}}t.CancellationError=c;function P(){const d=new Error(g);return d.name=d.message,d}t.canceled=P;function r(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}t.illegalArgument=r;function u(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}t.illegalState=u;function e(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function a(d){const p=new Error(`${d} has been disposed`);return p.name="DISPOSED",p}t.disposed=a;function n(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}t.getErrorMessage=n;class s extends Error{constructor(p){super("NotImplemented"),p&&(this.message=p)}}t.NotImplementedError=s;class o extends Error{constructor(p){super("NotSupported"),p&&(this.message=p)}}t.NotSupportedError=o;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=y;class A extends Error{constructor(p){super(p),this.name="CodeExpectedError"}static fromError(p){if(p instanceof A)return p;const L=new A;return L.message=p.message,L.stack=p.stack,L}static isErrorNoTelemetry(p){return p.name==="CodeExpectedError"}}t.ErrorNoTelemetry=A;class S extends Error{constructor(p){super(p||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}t.BugIndicatingError=S}),define(ge[13],me([1,0,7]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function R(F,N=0){return F[F.length-(1+N)]}t.tail=R;function i(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}t.tail2=i;function W(F,N,B=(k,z)=>k===z){if(F===N)return!0;if(!F||!N||F.length!==N.length)return!1;for(let k=0,z=F.length;k<z;k++)if(!B(F[k],N[k]))return!1;return!0}t.equals=W;function v(F,N){const B=F.length-1;N<B&&(F[N]=F[B]),F.pop()}t.removeFastWithoutKeepingOrder=v;function D(F,N,B){return g(F.length,k=>B(F[k],N))}t.binarySearch=D;function g(F,N){let B=0,k=F-1;for(;B<=k;){const z=(B+k)/2|0,H=N(z);if(H<0)B=z+1;else if(H>0)k=z-1;else return z}return-(B+1)}t.binarySearch2=g;function l(F,N){let B=0,k=F.length;if(k===0)return 0;for(;B<k;){const z=Math.floor((B+k)/2);N(F[z])?k=z:B=z+1}return B}t.findFirstInSorted=l;function c(F,N,B){if(F=F|0,F>=N.length)throw new TypeError("invalid index");const k=N[Math.floor(N.length*Math.random())],z=[],H=[],U=[];for(const q of N){const G=B(q,k);G<0?z.push(q):G>0?H.push(q):U.push(q)}return F<z.length?c(F,z,B):F<z.length+U.length?U[0]:c(F-(z.length+U.length),H,B)}t.quickSelect=c;function P(F,N){const B=[];let k;for(const z of F.slice(0).sort(N))!k||N(k[0],z)!==0?(k=[z],B.push(k)):k.push(z);return B}t.groupBy=P;function r(F,N,B){const k=[];function z(q,G,re){if(G===0&&re.length===0)return;const he=k[k.length-1];he&&he.start+he.deleteCount===q?(he.deleteCount+=G,he.toInsert.push(...re)):k.push({start:q,deleteCount:G,toInsert:re})}let H=0,U=0;for(;;){if(H===F.length){z(H,0,N.slice(U));break}if(U===N.length){z(H,F.length-H,[]);break}const q=F[H],G=N[U],re=B(q,G);re===0?(H+=1,U+=1):re<0?(z(H,1,[]),H+=1):re>0&&(z(H,0,[G]),U+=1)}return k}t.sortedDiff=r;function u(F,N,B){const k=r(F,N,B),z=[],H=[];for(const U of k)z.push(...F.slice(U.start,U.start+U.deleteCount)),H.push(...U.toInsert);return{removed:z,added:H}}t.delta=u;function e(F,N,B){if(B===0)return[];const k=F.slice(0,B).sort(N);return n(F,N,k,B,F.length),k}t.top=e;function a(F,N,B,k,z){return B===0?Promise.resolve([]):new Promise((H,U)=>{(async()=>{const q=F.length,G=F.slice(0,B).sort(N);for(let re=B,he=Math.min(B+k,q);re<q;re=he,he=Math.min(he+k,q)){if(re>B&&await new Promise(we=>setTimeout(we)),z&&z.isCancellationRequested)throw new E.CancellationError;n(F,N,G,re,he)}return G})().then(H,U)})}t.topAsync=a;function n(F,N,B,k,z){for(const H=B.length;k<z;k++){const U=F[k];if(N(U,B[H-1])<0){B.pop();const q=l(B,G=>N(U,G)<0);B.splice(q,0,U)}}}function s(F){return F.filter(N=>!!N)}t.coalesce=s;function o(F){let N=0;for(let B=0;B<F.length;B++)F[B]&&(F[N]=F[B],N+=1);F.length=N}t.coalesceInPlace=o;function y(F,N,B){F.splice(B,0,F.splice(N,1)[0])}t.move=y;function A(F){return!Array.isArray(F)||F.length===0}t.isFalsyOrEmpty=A;function S(F){return Array.isArray(F)&&F.length>0}t.isNonEmptyArray=S;function d(F,N=B=>B){const B=new Set;return F.filter(k=>{const z=N(k);return B.has(z)?!1:(B.add(z),!0)})}t.distinct=d;function p(F){const N=new Set;return B=>{const k=F(B);return N.has(k)?!1:(N.add(k),!0)}}t.uniqueFilter=p;function L(F,N){const B=I(F,N);if(B!==-1)return F[B]}t.findLast=L;function I(F,N){for(let B=F.length-1;B>=0;B--){const k=F[B];if(N(k))return B}return-1}t.lastIndex=I;function h(F,N){return F.length>0?F[0]:N}t.firstOrDefault=h;function b(F,N){return F.length>0?F[F.length-1]:N}t.lastOrDefault=b;function m(F,N,B=(k,z)=>k===z){let k=0;for(let z=0,H=Math.min(F.length,N.length);z<H&&B(F[z],N[z]);z++)k++;return k}t.commonPrefixLength=m;function w(F){return[].concat(...F)}t.flatten=w;function O(F,N){let B=typeof N=="number"?F:0;typeof N=="number"?B=F:(B=0,N=F);const k=[];if(B<=N)for(let z=B;z<N;z++)k.push(z);else for(let z=B;z>N;z--)k.push(z);return k}t.range=O;function V(F,N,B){return F.reduce((k,z)=>(k[N(z)]=B?B(z):z,k),Object.create(null))}t.index=V;function ie(F,N){return F.push(N),()=>se(F,N)}t.insert=ie;function se(F,N){const B=F.indexOf(N);if(B>-1)return F.splice(B,1),N}t.remove=se;function ae(F,N,B){const k=F.slice(0,N),z=F.slice(N);return k.concat(B,z)}t.arrayInsert=ae;function de(F,N){let B;if(typeof N=="number"){let k=N;B=()=>{const z=Math.sin(k++)*179426549;return z-Math.floor(z)}}else B=Math.random;for(let k=F.length-1;k>0;k-=1){const z=Math.floor(B()*(k+1)),H=F[k];F[k]=F[z],F[z]=H}}t.shuffle=de;function ue(F,N){const B=F.indexOf(N);B>-1&&(F.splice(B,1),F.unshift(N))}t.pushToStart=ue;function Z(F,N){const B=F.indexOf(N);B>-1&&(F.splice(B,1),F.push(N))}t.pushToEnd=Z;function Q(F,N){for(const B of N)F.push(B)}t.pushMany=Q;function ve(F,N){return Array.isArray(F)?F.map(N):N(F)}t.mapArrayOrNot=ve;function pe(F){return Array.isArray(F)?F:[F]}t.asArray=pe;function Me(F){return F[Math.floor(Math.random()*F.length)]}t.getRandomElement=Me;function Re(F,N){for(const B of F){const k=N(B);if(k!==void 0)return k}}t.mapFind=Re;function le(F,N,B){const k=ne(F,N),z=F.length,H=B.length;F.length=z+H;for(let U=z-1;U>=k;U--)F[U+H]=F[U];for(let U=0;U<H;U++)F[U+k]=B[U]}t.insertInto=le;function _(F,N,B,k){const z=ne(F,N),H=F.splice(z,B);return le(F,z,k),H}t.splice=_;function ne(F,N){return N<0?Math.max(N+F.length,0):Math.min(N,F.length)}var ee;(function(F){function N(z){return z<0}F.isLessThan=N;function B(z){return z>0}F.isGreaterThan=B;function k(z){return z===0}F.isNeitherLessOrGreaterThan=k,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ee=t.CompareResult||(t.CompareResult={}));function te(F,N){return(B,k)=>N(F(B),F(k))}t.compareBy=te;function T(...F){return(N,B)=>{for(const k of F){const z=k(N,B);if(!ee.isNeitherLessOrGreaterThan(z))return z}return ee.neitherLessOrGreaterThan}}t.tieBreakComparators=T;const x=(F,N)=>F-N;t.numberComparator=x;function M(F,N){if(F.length===0)return;let B=F[0];for(let k=1;k<F.length;k++){const z=F[k];N(z,B)>0&&(B=z)}return B}t.findMaxBy=M;function f(F,N){if(F.length===0)return;let B=F[0];for(let k=1;k<F.length;k++){const z=F[k];N(z,B)>=0&&(B=z)}return B}t.findLastMaxBy=f;function C(F,N){return M(F,(B,k)=>-N(B,k))}t.findMinBy=C;class ${constructor(N){this.f=N,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(N){let B=this.c;for(;B<this.f.length&&N(this.f[B]);)B++;const k=B===this.c?null:this.f.slice(this.c,B);return this.c=B,k}takeFromEndWhile(N){let B=this.d;for(;B>=0&&N(this.f[B]);)B--;const k=B===this.d?null:this.f.slice(B+1,this.d+1);return this.d=B,k}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const N=this.f[this.c];return this.c++,N}removeLast(){const N=this.f[this.d];return this.d--,N}takeCount(N){const B=this.f.slice(this.c,this.c+N);return this.c+=N,B}}t.ArrayQueue=$;class Y{constructor(N){this.iterate=N}forEach(N){this.iterate(B=>(N(B),!0))}toArray(){const N=[];return this.iterate(B=>(N.push(B),!0)),N}filter(N){return new Y(B=>this.iterate(k=>N(k)?B(k):!0))}map(N){return new Y(B=>this.iterate(k=>B(N(k))))}some(N){let B=!1;return this.iterate(k=>(B=N(k),!B)),B}findFirst(N){let B;return this.iterate(k=>N(k)?(B=k,!1):!0),B}findLast(N){let B;return this.iterate(k=>(N(k)&&(B=k),!0)),B}findLastMaxBy(N){let B,k=!0;return this.iterate(z=>((k||ee.isGreaterThan(N(z,B)))&&(k=!1,B=z),!0)),B}}Y.empty=new Y(F=>{}),t.CallbackIterable=Y}),define(ge[71],me([1,0,7]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function R(g,l){if(!g)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=R;function i(g,l="Unreachable"){throw new Error(l)}t.assertNever=i;function W(g){if(!g)throw new E.BugIndicatingError("Assertion Failed")}t.assert=W;function v(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=v;function D(g,l){let c=0;for(;c<g.length-1;){const P=g[c],r=g[c+1];if(!l(P,r))return!1;c++}return!0}t.checkAdjacentItems=D}),define(ge[40],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(R){const i=this;let W=!1,v;return function(){return W||(W=!0,v=R.apply(i,arguments)),v}}t.once=E}),define(ge[72],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(R){function i(A){return A&&typeof A=="object"&&typeof A[Symbol.iterator]=="function"}R.is=i;const W=Object.freeze([]);function v(){return W}R.empty=v;function*D(A){yield A}R.single=D;function g(A){return i(A)?A:D(A)}R.wrap=g;function l(A){return A||W}R.from=l;function c(A){return!A||A[Symbol.iterator]().next().done===!0}R.isEmpty=c;function P(A){return A[Symbol.iterator]().next().value}R.first=P;function r(A,S){for(const d of A)if(S(d))return!0;return!1}R.some=r;function u(A,S){for(const d of A)if(S(d))return d}R.find=u;function*e(A,S){for(const d of A)S(d)&&(yield d)}R.filter=e;function*a(A,S){let d=0;for(const p of A)yield S(p,d++)}R.map=a;function*n(...A){for(const S of A)for(const d of S)yield d}R.concat=n;function s(A,S,d){let p=d;for(const L of A)p=S(p,L);return p}R.reduce=s;function*o(A,S,d=A.length){for(S<0&&(S+=A.length),d<0?d+=A.length:d>A.length&&(d=A.length);S<d;S++)yield A[S]}R.slice=o;function y(A,S=Number.POSITIVE_INFINITY){const d=[];if(S===0)return[d,A];const p=A[Symbol.iterator]();for(let L=0;L<S;L++){const I=p.next();if(I.done)return[d,R.empty()];d.push(I.value)}return[d,{[Symbol.iterator](){return p}}]}R.consume=y})(E=t.Iterable||(t.Iterable={}))}),define(ge[41],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=t.KeyCode||(t.KeyCode={}));var R;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(R=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,n){this._keyCodeToStr[a]=n,this._strToKeyCode[n.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const W=new i,v=new i,D=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],l=Object.create(null),c=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>l[e]||0,toString:e=>g[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",a=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],s=[];for(const o of a){const[y,A,S,d,p,L,I,h,b,m]=o;if(s[S]||(s[S]=!0,g[S]=d,l[d]=S,c[d.toLowerCase()]=S,A&&(t.IMMUTABLE_CODE_TO_KEY_CODE[S]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[p]=S))),!n[p]){if(n[p]=!0,!L)throw new Error(`String representation missing for key code ${p} around scan code ${d}`);W.define(p,L),v.define(p,b||L),D.define(p,m||b||L)}I&&(t.EVENT_KEY_CODE_MAP[I]=p),h&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=p)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function a(S){return W.keyCodeToStr(S)}e.toString=a;function n(S){return W.strToKeyCode(S)}e.fromString=n;function s(S){return v.keyCodeToStr(S)}e.toUserSettingsUS=s;function o(S){return D.keyCodeToStr(S)}e.toUserSettingsGeneral=o;function y(S){return v.strToKeyCode(S)||D.strToKeyCode(S)}e.fromUserSettings=y;function A(S){if(S>=93&&S<=108)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(S)}e.toElectronAccelerator=A})(P=t.KeyCodeUtils||(t.KeyCodeUtils={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r=t.KeyMod||(t.KeyMod={}));function u(e,a){const n=(a&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=u}),define(ge[73],me([1,0,7]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var R;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(R||(R={}));function i(P,r){if(P===0)return null;const u=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new g([W(u,r),W(e,r)]):new g([W(u,r)])}t.decodeKeybinding=i;function W(P,r){const u=!!(P&2048),e=!!(P&256),a=r===2?e:u,n=!!(P&1024),s=!!(P&512),o=r===2?u:e,y=P&255;return new v(a,n,s,o,y)}t.createSimpleKeybinding=W;class v{constructor(r,u,e,a,n){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=a,this.keyCode=n}equals(r){return r instanceof v&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${r}${u}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=v;class D{constructor(r,u,e,a,n){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=a,this.scanCode=n}equals(r){return r instanceof D&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${r}${u}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=D;class g{constructor(r){if(r.length===0)throw(0,E.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let u=0,e=this.chords.length;u<e;u++)u!==0&&(r+=";"),r+=this.chords[u].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let u=0;u<this.chords.length;u++)if(!this.chords[u].equals(r.chords[u]))return!1;return!0}}t.Keybinding=g;class l{constructor(r,u,e,a,n,s){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=a,this.keyLabel=n,this.keyAriaLabel=s}}t.ResolvedChord=l;class c{}t.ResolvedKeybinding=c}),define(ge[42],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=E}),define(ge[2],me([1,0,40,26]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let W=null;function v(b){W=b}if(t.setDisposableTracker=v,i){const b="__is_disposable_tracked__";v(new class{trackDisposable(m){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[b]||console.log(w)},3e3)}setParent(m,w){if(m&&m!==o.None)try{m[b]=!0}catch{}}markAsDisposed(m){if(m&&m!==o.None)try{m[b]=!0}catch{}}markAsSingleton(m){}})}function D(b){return W?.trackDisposable(b),b}function g(b){W?.markAsDisposed(b)}function l(b,m){W?.setParent(b,m)}function c(b,m){if(!!W)for(const w of b)W.setParent(w,m)}function P(b){return W?.markAsSingleton(b),b}t.markAsSingleton=P;function r(b){return typeof b.dispose=="function"&&b.dispose.length===0}t.isDisposable=r;function u(b){if(R.Iterable.is(b)){const m=[];for(const w of b)if(w)try{w.dispose()}catch(O){m.push(O)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}t.dispose=u;function e(b){for(const m of b)r(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function a(...b){const m=n(()=>u(b));return c(b,m),m}t.combinedDisposable=a;function n(b){const m=D({dispose:(0,E.once)(()=>{g(m),b()})});return m}t.toDisposable=n;class s{constructor(){this.c=new Set,this.f=!1,D(this)}dispose(){this.f||(g(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{u(this.c)}finally{this.c.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return l(m,this),this.f?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(m),m}}s.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=s;class o{constructor(){this.B=new s,D(this),l(this.B,this)}dispose(){g(this),this.B.dispose()}D(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(m)}}o.None=Object.freeze({dispose(){}}),t.Disposable=o;class y{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&l(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&l(m,null),m}}t.MutableDisposable=y;class A{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=A;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(m){let w=m;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,g(this))},this}}t.SafeDisposable=S;class d{constructor(){this.a=new Map}acquire(m,...w){let O=this.a.get(m);O||(O={counter:0,object:this.b(m,...w)},this.a.set(m,O));const{object:V}=O,ie=(0,E.once)(()=>{--O.counter===0&&(this.c(m,O.object),this.a.delete(m))});return O.counter++,{object:V,dispose:ie}}}t.ReferenceCollection=d;class p{constructor(m){this.a=m}async acquire(m,...w){const O=this.a.acquire(m,...w);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(V){throw O.dispose(),V}}}t.AsyncReferenceCollection=p;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function I(b){const m=new s;try{b(m)}finally{m.dispose()}}t.disposeOnReturn=I;class h{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,w,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(m)?.dispose(),this.a.set(m,w)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=h}),define(ge[43],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(W){this.element=W,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class R{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let W=this.a;for(;W!==E.Undefined;){const v=W.next;W.prev=E.Undefined,W.next=E.Undefined,W=v}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,v){const D=new E(W);if(this.a===E.Undefined)this.a=D,this.b=D;else if(v){const l=this.b;this.b=D,D.prev=l,l.next=D}else{const l=this.a;this.a=D,D.next=l,l.prev=D}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(D))}}shift(){if(this.a!==E.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==E.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==E.Undefined&&W.next!==E.Undefined){const v=W.prev;v.next=W.next,W.next.prev=v}else W.prev===E.Undefined&&W.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):W.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):W.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==E.Undefined;)yield W.element,W=W.next}}t.LinkedList=R}),define(ge[74],me([1,0]),function(J,t){"use strict";var E,R,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function W(a,n,s){let o=a.get(n);return o===void 0&&(o=s,a.set(n,o)),o}t.getOrSet=W;function v(a){const n=[];return a.forEach((s,o)=>{n.push(`${o} => ${s}`)}),`Map(${a.size}) {${n.join(", ")}}`}t.mapToString=v;function D(a){const n=[];return a.forEach(s=>{n.push(s)}),`Set(${a.size}) {${n.join(", ")}}`}t.setToString=D;class g{constructor(n,s){this.uri=n,this.value=s}}class l{constructor(n,s){this[E]="ResourceMap",n instanceof l?(this.b=new Map(n.b),this.c=s??l.a):(this.b=new Map,this.c=n??l.a)}set(n,s){return this.b.set(this.c(n),new g(n,s)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[o,y]of this.b)n(y.value,y.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}l.a=a=>a.toString(),t.ResourceMap=l;class c{constructor(n,s){this[R]="ResourceSet",!n||typeof n=="function"?this.a=new l(n):(this.a=new l(s),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,s){this.a.forEach((o,y)=>n.call(s,y,y,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=c;var P;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(P=t.Touch||(t.Touch={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,s=0){const o=this.a.get(n);if(!!o)return s!==0&&this.j(o,s),o.value}set(n,s,o=0){let y=this.a.get(n);if(y)y.value=s,o!==0&&this.j(y,o);else{switch(y={key:n,value:s,next:void 0,previous:void 0},o){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(n,y),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.a.get(n);if(!!s)return this.a.delete(n),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,s){const o=this.e;let y=this.b;for(;y;){if(s?n.bind(s)(y.value,y.key,this):n(y.value,y.key,this),this.e!==o)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const n=this,s=this.e;let o=this.b;const y={[Symbol.iterator](){return y},next(){if(n.e!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const A={value:o.key,done:!1};return o=o.next,A}else return{value:void 0,done:!0}}};return y}values(){const n=this,s=this.e;let o=this.b;const y={[Symbol.iterator](){return y},next(){if(n.e!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const A={value:o.value,done:!1};return o=o.next,A}else return{value:void 0,done:!0}}};return y}entries(){const n=this,s=this.e;let o=this.b;const y={[Symbol.iterator](){return y},next(){if(n.e!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const A={value:[o.key,o.value],done:!1};return o=o.next,A}else return{value:void 0,done:!0}}};return y}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.b,o=this.size;for(;s&&o>n;)this.a.delete(s.key),s=s.next,o--;this.b=s,this.d=o,s&&(s.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const s=n.next,o=n.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}n.next=void 0,n.previous=void 0,this.e++}j(n,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this.b)return;const o=n.next,y=n.previous;n===this.c?(y.next=void 0,this.c=y):(o.previous=y,y.next=o),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(s===2){if(n===this.c)return;const o=n.next,y=n.previous;n===this.b?(o.previous=void 0,this.b=o):(o.previous=y,y.next=o),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((s,o)=>{n.push([o,s])}),n}fromJSON(n){this.clear();for(const[s,o]of n)this.set(s,o)}}t.LinkedMap=r;class u extends r{constructor(n,s=1){super(),this.k=n,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=u;class e{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let s=this.a.get(n)||0;return s===0?!1:(s--,s===0?this.a.delete(n):this.a.set(n,s),!0)}has(n){return this.a.has(n)}}t.CounterSet=e}),function(J,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(ge[75],me([0]),t):(J=typeof globalThis<"u"?globalThis:J||self,t(J.marked={}))}(this,function(J){"use strict";function t(F,N){for(var B=0;B<N.length;B++){var k=N[B];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(F,k.key,k)}}function E(F,N,B){return N&&t(F.prototype,N),B&&t(F,B),Object.defineProperty(F,"prototype",{writable:!1}),F}function R(F,N){if(!!F){if(typeof F=="string")return i(F,N);var B=Object.prototype.toString.call(F).slice(8,-1);if(B==="Object"&&F.constructor&&(B=F.constructor.name),B==="Map"||B==="Set")return Array.from(F);if(B==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(B))return i(F,N)}}function i(F,N){(N==null||N>F.length)&&(N=F.length);for(var B=0,k=new Array(N);B<N;B++)k[B]=F[B];return k}function W(F,N){var B=typeof Symbol<"u"&&F[Symbol.iterator]||F["@@iterator"];if(B)return(B=B.call(F)).next.bind(B);if(Array.isArray(F)||(B=R(F))||N&&F&&typeof F.length=="number"){B&&(F=B);var k=0;return function(){return k>=F.length?{done:!0}:{done:!1,value:F[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function v(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=v();function D(F){J.defaults=F}var g=/[&<>"']/,l=/[&<>"']/g,c=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(N){return r[N]};function e(F,N){if(N){if(g.test(F))return F.replace(l,u)}else if(c.test(F))return F.replace(P,u);return F}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(F){return F.replace(a,function(N,B){return B=B.toLowerCase(),B==="colon"?":":B.charAt(0)==="#"?B.charAt(1)==="x"?String.fromCharCode(parseInt(B.substring(2),16)):String.fromCharCode(+B.substring(1)):""})}var s=/(^|[^\[])\^/g;function o(F,N){F=typeof F=="string"?F:F.source,N=N||"";var B={replace:function(z,H){return H=H.source||H,H=H.replace(s,"$1"),F=F.replace(z,H),B},getRegex:function(){return new RegExp(F,N)}};return B}var y=/[^\w:]/g,A=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(F,N,B){if(F){var k;try{k=decodeURIComponent(n(B)).replace(y,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}N&&!A.test(B)&&(B=h(N,B));try{B=encodeURI(B).replace(/%25/g,"%")}catch{return null}return B}var d={},p=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(F,N){d[" "+F]||(p.test(F)?d[" "+F]=F+"/":d[" "+F]=O(F,"/",!0)),F=d[" "+F];var B=F.indexOf(":")===-1;return N.substring(0,2)==="//"?B?N:F.replace(L,"$1")+N:N.charAt(0)==="/"?B?N:F.replace(I,"$1")+N:F+N}var b={exec:function(){}};function m(F){for(var N=1,B,k;N<arguments.length;N++){B=arguments[N];for(k in B)Object.prototype.hasOwnProperty.call(B,k)&&(F[k]=B[k])}return F}function w(F,N){var B=F.replace(/\|/g,function(H,U,q){for(var G=!1,re=U;--re>=0&&q[re]==="\\";)G=!G;return G?"|":" |"}),k=B.split(/ \|/),z=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>N)k.splice(N);else for(;k.length<N;)k.push("");for(;z<k.length;z++)k[z]=k[z].trim().replace(/\\\|/g,"|");return k}function O(F,N,B){var k=F.length;if(k===0)return"";for(var z=0;z<k;){var H=F.charAt(k-z-1);if(H===N&&!B)z++;else if(H!==N&&B)z++;else break}return F.slice(0,k-z)}function V(F,N){if(F.indexOf(N[1])===-1)return-1;for(var B=F.length,k=0,z=0;z<B;z++)if(F[z]==="\\")z++;else if(F[z]===N[0])k++;else if(F[z]===N[1]&&(k--,k<0))return z;return-1}function ie(F){F&&F.sanitize&&!F.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function se(F,N){if(N<1)return"";for(var B="";N>1;)N&1&&(B+=F),N>>=1,F+=F;return B+F}function ae(F,N,B,k){var z=N.href,H=N.title?e(N.title):null,U=F[1].replace(/\\([\[\]])/g,"$1");if(F[0].charAt(0)!=="!"){k.state.inLink=!0;var q={type:"link",raw:B,href:z,title:H,text:U,tokens:k.inlineTokens(U)};return k.state.inLink=!1,q}return{type:"image",raw:B,href:z,title:H,text:e(U)}}function de(F,N){var B=F.match(/^(\s+)(?:```)/);if(B===null)return N;var k=B[1];return N.split(`
`).map(function(z){var H=z.match(/^\s+/);if(H===null)return z;var U=H[0];return U.length>=k.length?z.slice(k.length):z}).join(`
`)}var ue=function(){function F(B){this.options=B||J.defaults}var N=F.prototype;return N.space=function(k){var z=this.rules.block.newline.exec(k);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},N.code=function(k){var z=this.rules.block.code.exec(k);if(z){var H=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?H:O(H,`
`)}}},N.fences=function(k){var z=this.rules.block.fences.exec(k);if(z){var H=z[0],U=de(H,z[3]||"");return{type:"code",raw:H,lang:z[2]?z[2].trim():z[2],text:U}}},N.heading=function(k){var z=this.rules.block.heading.exec(k);if(z){var H=z[2].trim();if(/#$/.test(H)){var U=O(H,"#");(this.options.pedantic||!U||/ $/.test(U))&&(H=U.trim())}return{type:"heading",raw:z[0],depth:z[1].length,text:H,tokens:this.lexer.inline(H)}}},N.hr=function(k){var z=this.rules.block.hr.exec(k);if(z)return{type:"hr",raw:z[0]}},N.blockquote=function(k){var z=this.rules.block.blockquote.exec(k);if(z){var H=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},N.list=function(k){var z=this.rules.block.list.exec(k);if(z){var H,U,q,G,re,he,we,ye,Le,Ce,De,Pe,Ie=z[1].trim(),je=Ie.length>1,ze={type:"list",raw:"",ordered:je,start:je?+Ie.slice(0,-1):"",loose:!1,items:[]};Ie=je?"\\d{1,9}\\"+Ie.slice(-1):"\\"+Ie,this.options.pedantic&&(Ie=je?Ie:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Ie+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Pe=!1,!(!(z=Ue.exec(k))||this.rules.block.hr.test(k)));){if(H=z[0],k=k.substring(H.length),ye=z[2].split(`
`,1)[0],Le=k.split(`
`,1)[0],this.options.pedantic?(G=2,De=ye.trimLeft()):(G=z[2].search(/[^ ]/),G=G>4?1:G,De=ye.slice(G),G+=z[1].length),he=!1,!ye&&/^ *$/.test(Le)&&(H+=Le+`
`,k=k.substring(Le.length+1),Pe=!0),!Pe)for(var Ze=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ge=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),j=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");k&&(Ce=k.split(`
`,1)[0],ye=Ce,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(ye)||j.test(ye)||Ze.test(ye)||Ge.test(k)));){if(ye.search(/[^ ]/)>=G||!ye.trim())De+=`
`+ye.slice(G);else if(!he)De+=`
`+ye;else break;!he&&!ye.trim()&&(he=!0),H+=Ce+`
`,k=k.substring(Ce.length+1)}ze.loose||(we?ze.loose=!0:/\n *\n *$/.test(H)&&(we=!0)),this.options.gfm&&(U=/^\[[ xX]\] /.exec(De),U&&(q=U[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:H,task:!!U,checked:q,loose:!1,text:De}),ze.raw+=H}ze.items[ze.items.length-1].raw=H.trimRight(),ze.items[ze.items.length-1].text=De.trimRight(),ze.raw=ze.raw.trimRight();var oe=ze.items.length;for(re=0;re<oe;re++){this.lexer.state.top=!1,ze.items[re].tokens=this.lexer.blockTokens(ze.items[re].text,[]);var be=ze.items[re].tokens.filter(function(Se){return Se.type==="space"}),Ee=be.every(function(Se){for(var Oe=Se.raw.split(""),$e=0,tt=W(Oe),Ke;!(Ke=tt()).done;){var xe=Ke.value;if(xe===`
`&&($e+=1),$e>1)return!0}return!1});!ze.loose&&be.length&&Ee&&(ze.loose=!0,ze.items[re].loose=!0)}return ze}},N.html=function(k){var z=this.rules.block.html.exec(k);if(z){var H={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};if(this.options.sanitize){var U=this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]);H.type="paragraph",H.text=U,H.tokens=this.lexer.inline(U)}return H}},N.def=function(k){var z=this.rules.block.def.exec(k);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var H=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:z[0],href:z[2],title:z[3]}}},N.table=function(k){var z=this.rules.block.table.exec(k);if(z){var H={type:"table",header:w(z[1]).map(function(we){return{text:we}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=z[0];var U=H.align.length,q,G,re,he;for(q=0;q<U;q++)/^ *-+: *$/.test(H.align[q])?H.align[q]="right":/^ *:-+: *$/.test(H.align[q])?H.align[q]="center":/^ *:-+ *$/.test(H.align[q])?H.align[q]="left":H.align[q]=null;for(U=H.rows.length,q=0;q<U;q++)H.rows[q]=w(H.rows[q],H.header.length).map(function(we){return{text:we}});for(U=H.header.length,G=0;G<U;G++)H.header[G].tokens=this.lexer.inline(H.header[G].text);for(U=H.rows.length,G=0;G<U;G++)for(he=H.rows[G],re=0;re<he.length;re++)he[re].tokens=this.lexer.inline(he[re].text);return H}}},N.lheading=function(k){var z=this.rules.block.lheading.exec(k);if(z)return{type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:this.lexer.inline(z[1])}},N.paragraph=function(k){var z=this.rules.block.paragraph.exec(k);if(z){var H=z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1];return{type:"paragraph",raw:z[0],text:H,tokens:this.lexer.inline(H)}}},N.text=function(k){var z=this.rules.block.text.exec(k);if(z)return{type:"text",raw:z[0],text:z[0],tokens:this.lexer.inline(z[0])}},N.escape=function(k){var z=this.rules.inline.escape.exec(k);if(z)return{type:"escape",raw:z[0],text:e(z[1])}},N.tag=function(k){var z=this.rules.inline.tag.exec(k);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]}},N.link=function(k){var z=this.rules.inline.link.exec(k);if(z){var H=z[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var U=O(H.slice(0,-1),"\\");if((H.length-U.length)%2===0)return}else{var q=V(z[2],"()");if(q>-1){var G=z[0].indexOf("!")===0?5:4,re=G+z[1].length+q;z[2]=z[2].substring(0,q),z[0]=z[0].substring(0,re).trim(),z[3]=""}}var he=z[2],we="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);ye&&(he=ye[1],we=ye[3])}else we=z[3]?z[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(H)?he=he.slice(1):he=he.slice(1,-1)),ae(z,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},N.reflink=function(k,z){var H;if((H=this.rules.inline.reflink.exec(k))||(H=this.rules.inline.nolink.exec(k))){var U=(H[2]||H[1]).replace(/\s+/g," ");if(U=z[U.toLowerCase()],!U||!U.href){var q=H[0].charAt(0);return{type:"text",raw:q,text:q}}return ae(H,U,H[0],this.lexer)}},N.emStrong=function(k,z,H){H===void 0&&(H="");var U=this.rules.inline.emStrong.lDelim.exec(k);if(!!U&&!(U[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=U[1]||U[2]||"";if(!q||q&&(H===""||this.rules.inline.punctuation.exec(H))){var G=U[0].length-1,re,he,we=G,ye=0,Le=U[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Le.lastIndex=0,z=z.slice(-1*k.length+G);(U=Le.exec(z))!=null;)if(re=U[1]||U[2]||U[3]||U[4]||U[5]||U[6],!!re){if(he=re.length,U[3]||U[4]){we+=he;continue}else if((U[5]||U[6])&&G%3&&!((G+he)%3)){ye+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+ye),Math.min(G,he)%2){var Ce=k.slice(1,G+U.index+he);return{type:"em",raw:k.slice(0,G+U.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var De=k.slice(2,G+U.index+he-1);return{type:"strong",raw:k.slice(0,G+U.index+he+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},N.codespan=function(k){var z=this.rules.inline.code.exec(k);if(z){var H=z[2].replace(/\n/g," "),U=/[^ ]/.test(H),q=/^ /.test(H)&&/ $/.test(H);return U&&q&&(H=H.substring(1,H.length-1)),H=e(H,!0),{type:"codespan",raw:z[0],text:H}}},N.br=function(k){var z=this.rules.inline.br.exec(k);if(z)return{type:"br",raw:z[0]}},N.del=function(k){var z=this.rules.inline.del.exec(k);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2])}},N.autolink=function(k,z){var H=this.rules.inline.autolink.exec(k);if(H){var U,q;return H[2]==="@"?(U=e(this.options.mangle?z(H[1]):H[1]),q="mailto:"+U):(U=e(H[1]),q=U),{type:"link",raw:H[0],text:U,href:q,tokens:[{type:"text",raw:U,text:U}]}}},N.url=function(k,z){var H;if(H=this.rules.inline.url.exec(k)){var U,q;if(H[2]==="@")U=e(this.options.mangle?z(H[0]):H[0]),q="mailto:"+U;else{var G;do G=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(G!==H[0]);U=e(H[0]),H[1]==="www."?q="http://"+U:q=U}return{type:"link",raw:H[0],text:U,href:q,tokens:[{type:"text",raw:U,text:U}]}}},N.inlineText=function(k,z){var H=this.rules.inline.text.exec(k);if(H){var U;return this.lexer.state.inRawBlock?U=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]):H[0]:U=e(this.options.smartypants?z(H[0]):H[0]),{type:"text",raw:H[0],text:U}}},F}(),Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=o(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.listItemStart=o(/^( *)(bull) */).replace("bull",Z.bullet).getRegex(),Z.list=o(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=o(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=o(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=o(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=m({},Z),Z.gfm=m({},Z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.table=o(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.gfm.paragraph=o(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=m({},Z.normal,{html:o(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:o(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=o(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=o(Z._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=o(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=o(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=o(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=o(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=o(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=o(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=o(Q.reflink).replace("label",Q._label).replace("ref",Z._label).getRegex(),Q.nolink=o(Q.nolink).replace("ref",Z._label).getRegex(),Q.reflinkSearch=o(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=m({},Q),Q.pedantic=m({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:o(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:o(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=m({},Q.normal,{escape:o(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=o(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=m({},Q.gfm,{br:o(Q.br).replace("{2,}","*").getRegex(),text:o(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ve(F){return F.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function pe(F){var N="",B,k,z=F.length;for(B=0;B<z;B++)k=F.charCodeAt(B),Math.random()>.5&&(k="x"+k.toString(16)),N+="&#"+k+";";return N}var Me=function(){function F(B){this.tokens=[],this.tokens.links=Object.create(null),this.options=B||J.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:Z.normal,inline:Q.normal};this.options.pedantic?(k.block=Z.pedantic,k.inline=Q.pedantic):this.options.gfm&&(k.block=Z.gfm,this.options.breaks?k.inline=Q.breaks:k.inline=Q.gfm),this.tokenizer.rules=k}F.lex=function(k,z){var H=new F(z);return H.lex(k)},F.lexInline=function(k,z){var H=new F(z);return H.inlineTokens(k)};var N=F.prototype;return N.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},N.blockTokens=function(k,z){var H=this;z===void 0&&(z=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(we,ye,Le){return ye+"    ".repeat(Le.length)});for(var U,q,G,re;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(U=we.call({lexer:H},k,z))?(k=k.substring(U.raw.length),z.push(U),!0):!1}))){if(U=this.tokenizer.space(k)){k=k.substring(U.raw.length),U.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(U);continue}if(U=this.tokenizer.code(k)){k=k.substring(U.raw.length),q=z[z.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+U.raw,q.text+=`
`+U.text,this.inlineQueue[this.inlineQueue.length-1].src=q.text):z.push(U);continue}if(U=this.tokenizer.fences(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.heading(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.hr(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.blockquote(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.list(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.html(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.def(k)){k=k.substring(U.raw.length),q=z[z.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+U.raw,q.text+=`
`+U.raw,this.inlineQueue[this.inlineQueue.length-1].src=q.text):this.tokens.links[U.tag]||(this.tokens.links[U.tag]={href:U.href,title:U.title});continue}if(U=this.tokenizer.table(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.lheading(k)){k=k.substring(U.raw.length),z.push(U);continue}if(G=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,ye=k.slice(1),Le=void 0;H.options.extensions.startBlock.forEach(function(Ce){Le=Ce.call({lexer:this},ye),typeof Le=="number"&&Le>=0&&(we=Math.min(we,Le))}),we<1/0&&we>=0&&(G=k.substring(0,we+1))}(),this.state.top&&(U=this.tokenizer.paragraph(G))){q=z[z.length-1],re&&q.type==="paragraph"?(q.raw+=`
`+U.raw,q.text+=`
`+U.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):z.push(U),re=G.length!==k.length,k=k.substring(U.raw.length);continue}if(U=this.tokenizer.text(k)){k=k.substring(U.raw.length),q=z[z.length-1],q&&q.type==="text"?(q.raw+=`
`+U.raw,q.text+=`
`+U.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):z.push(U);continue}if(k){var he="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,z},N.inline=function(k,z){return z===void 0&&(z=[]),this.inlineQueue.push({src:k,tokens:z}),z},N.inlineTokens=function(k,z){var H=this;z===void 0&&(z=[]);var U,q,G,re=k,he,we,ye;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(re))!=null;)Le.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(re=re.slice(0,he.index)+"["+se("a",he[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(re))!=null;)re=re.slice(0,he.index)+"["+se("a",he[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(re))!=null;)re=re.slice(0,he.index)+"++"+re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(we||(ye=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(U=De.call({lexer:H},k,z))?(k=k.substring(U.raw.length),z.push(U),!0):!1}))){if(U=this.tokenizer.escape(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.tag(k)){k=k.substring(U.raw.length),q=z[z.length-1],q&&U.type==="text"&&q.type==="text"?(q.raw+=U.raw,q.text+=U.text):z.push(U);continue}if(U=this.tokenizer.link(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(U.raw.length),q=z[z.length-1],q&&U.type==="text"&&q.type==="text"?(q.raw+=U.raw,q.text+=U.text):z.push(U);continue}if(U=this.tokenizer.emStrong(k,re,ye)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.codespan(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.br(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.del(k)){k=k.substring(U.raw.length),z.push(U);continue}if(U=this.tokenizer.autolink(k,pe)){k=k.substring(U.raw.length),z.push(U);continue}if(!this.state.inLink&&(U=this.tokenizer.url(k,pe))){k=k.substring(U.raw.length),z.push(U);continue}if(G=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Pe=k.slice(1),Ie=void 0;H.options.extensions.startInline.forEach(function(je){Ie=je.call({lexer:this},Pe),typeof Ie=="number"&&Ie>=0&&(De=Math.min(De,Ie))}),De<1/0&&De>=0&&(G=k.substring(0,De+1))}(),U=this.tokenizer.inlineText(G,ve)){k=k.substring(U.raw.length),U.raw.slice(-1)!=="_"&&(ye=U.raw.slice(-1)),we=!0,q=z[z.length-1],q&&q.type==="text"?(q.raw+=U.raw,q.text+=U.text):z.push(U);continue}if(k){var Ce="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return z},E(F,null,[{key:"rules",get:function(){return{block:Z,inline:Q}}}]),F}(),Re=function(){function F(B){this.options=B||J.defaults}var N=F.prototype;return N.code=function(k,z,H){var U=(z||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(k,U);q!=null&&q!==k&&(H=!0,k=q)}return k=k.replace(/\n$/,"")+`
`,U?'<pre><code class="'+this.options.langPrefix+e(U,!0)+'">'+(H?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(H?k:e(k,!0))+`</code></pre>
`},N.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},N.html=function(k){return k},N.heading=function(k,z,H,U){if(this.options.headerIds){var q=this.options.headerPrefix+U.slug(H);return"<h"+z+' id="'+q+'">'+k+"</h"+z+`>
`}return"<h"+z+">"+k+"</h"+z+`>
`},N.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},N.list=function(k,z,H){var U=z?"ol":"ul",q=z&&H!==1?' start="'+H+'"':"";return"<"+U+q+`>
`+k+"</"+U+`>
`},N.listitem=function(k){return"<li>"+k+`</li>
`},N.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},N.paragraph=function(k){return"<p>"+k+`</p>
`},N.table=function(k,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+z+`</table>
`},N.tablerow=function(k){return`<tr>
`+k+`</tr>
`},N.tablecell=function(k,z){var H=z.header?"th":"td",U=z.align?"<"+H+' align="'+z.align+'">':"<"+H+">";return U+k+("</"+H+`>
`)},N.strong=function(k){return"<strong>"+k+"</strong>"},N.em=function(k){return"<em>"+k+"</em>"},N.codespan=function(k){return"<code>"+k+"</code>"},N.br=function(){return this.options.xhtml?"<br/>":"<br>"},N.del=function(k){return"<del>"+k+"</del>"},N.link=function(k,z,H){if(k=S(this.options.sanitize,this.options.baseUrl,k),k===null)return H;var U='<a href="'+e(k)+'"';return z&&(U+=' title="'+z+'"'),U+=">"+H+"</a>",U},N.image=function(k,z,H){if(k=S(this.options.sanitize,this.options.baseUrl,k),k===null)return H;var U='<img src="'+k+'" alt="'+H+'"';return z&&(U+=' title="'+z+'"'),U+=this.options.xhtml?"/>":">",U},N.text=function(k){return k},F}(),le=function(){function F(){}var N=F.prototype;return N.strong=function(k){return k},N.em=function(k){return k},N.codespan=function(k){return k},N.del=function(k){return k},N.html=function(k){return k},N.text=function(k){return k},N.link=function(k,z,H){return""+H},N.image=function(k,z,H){return""+H},N.br=function(){return""},F}(),_=function(){function F(){this.seen={}}var N=F.prototype;return N.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},N.getNextSafeSlug=function(k,z){var H=k,U=0;if(this.seen.hasOwnProperty(H)){U=this.seen[k];do U++,H=k+"-"+U;while(this.seen.hasOwnProperty(H))}return z||(this.seen[k]=U,this.seen[H]=0),H},N.slug=function(k,z){z===void 0&&(z={});var H=this.serialize(k);return this.getNextSafeSlug(H,z.dryrun)},F}(),ne=function(){function F(B){this.options=B||J.defaults,this.options.renderer=this.options.renderer||new Re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}F.parse=function(k,z){var H=new F(z);return H.parse(k)},F.parseInline=function(k,z){var H=new F(z);return H.parseInline(k)};var N=F.prototype;return N.parse=function(k,z){z===void 0&&(z=!0);var H="",U,q,G,re,he,we,ye,Le,Ce,De,Pe,Ie,je,ze,Ue,Ze,Ge,Be,j,oe=k.length;for(U=0;U<oe;U++){if(De=k[U],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(j=this.options.extensions.renderers[De.type].call({parser:this},De),j!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){H+=j||"";continue}switch(De.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(De.tokens),De.depth,n(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Le="",ye="",re=De.header.length,q=0;q<re;q++)ye+=this.renderer.tablecell(this.parseInline(De.header[q].tokens),{header:!0,align:De.align[q]});for(Le+=this.renderer.tablerow(ye),Ce="",re=De.rows.length,q=0;q<re;q++){for(we=De.rows[q],ye="",he=we.length,G=0;G<he;G++)ye+=this.renderer.tablecell(this.parseInline(we[G].tokens),{header:!1,align:De.align[G]});Ce+=this.renderer.tablerow(ye)}H+=this.renderer.table(Le,Ce);continue}case"blockquote":{Ce=this.parse(De.tokens),H+=this.renderer.blockquote(Ce);continue}case"list":{for(Pe=De.ordered,Ie=De.start,je=De.loose,re=De.items.length,Ce="",q=0;q<re;q++)Ue=De.items[q],Ze=Ue.checked,Ge=Ue.task,ze="",Ue.task&&(Be=this.renderer.checkbox(Ze),je?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Be+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Be+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Be}):ze+=Be),ze+=this.parse(Ue.tokens,je),Ce+=this.renderer.listitem(ze,Ge,Ze);H+=this.renderer.list(Ce,Pe,Ie);continue}case"html":{H+=this.renderer.html(De.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ce=De.tokens?this.parseInline(De.tokens):De.text;U+1<oe&&k[U+1].type==="text";)De=k[++U],Ce+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);H+=z?this.renderer.paragraph(Ce):Ce;continue}default:{var be='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return H},N.parseInline=function(k,z){z=z||this.renderer;var H="",U,q,G,re=k.length;for(U=0;U<re;U++){if(q=k[U],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(G=this.options.extensions.renderers[q.type].call({parser:this},q),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(q.type))){H+=G||"";continue}switch(q.type){case"escape":{H+=z.text(q.text);break}case"html":{H+=z.html(q.text);break}case"link":{H+=z.link(q.href,q.title,this.parseInline(q.tokens,z));break}case"image":{H+=z.image(q.href,q.title,q.text);break}case"strong":{H+=z.strong(this.parseInline(q.tokens,z));break}case"em":{H+=z.em(this.parseInline(q.tokens,z));break}case"codespan":{H+=z.codespan(q.text);break}case"br":{H+=z.br();break}case"del":{H+=z.del(this.parseInline(q.tokens,z));break}case"text":{H+=z.text(q.text);break}default:{var he='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return H},F}();function ee(F,N,B){if(typeof F>"u"||F===null)throw new Error("marked(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");if(typeof N=="function"&&(B=N,N=null),N=m({},ee.defaults,N||{}),ie(N),B){var k=N.highlight,z;try{z=Me.lex(F,N)}catch(re){return B(re)}var H=function(he){var we;if(!he)try{N.walkTokens&&ee.walkTokens(z,N.walkTokens),we=ne.parse(z,N)}catch(ye){he=ye}return N.highlight=k,he?B(he):B(null,we)};if(!k||k.length<3||(delete N.highlight,!z.length))return H();var U=0;ee.walkTokens(z,function(re){re.type==="code"&&(U++,setTimeout(function(){k(re.text,re.lang,function(he,we){if(he)return H(he);we!=null&&we!==re.text&&(re.text=we,re.escaped=!0),U--,U===0&&H()})},0))}),U===0&&H();return}function q(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,N.silent)return"<p>An error occurred:</p><pre>"+e(re.message+"",!0)+"</pre>";throw re}try{var G=Me.lex(F,N);if(N.walkTokens){if(N.async)return Promise.all(ee.walkTokens(G,N.walkTokens)).then(function(){return ne.parse(G,N)}).catch(q);ee.walkTokens(G,N.walkTokens)}return ne.parse(G,N)}catch(re){q(re)}}ee.options=ee.setOptions=function(F){return m(ee.defaults,F),D(ee.defaults),ee},ee.getDefaults=v,ee.defaults=J.defaults,ee.use=function(){for(var F=arguments.length,N=new Array(F),B=0;B<F;B++)N[B]=arguments[B];var k=m.apply(void 0,[{}].concat(N)),z=ee.defaults.extensions||{renderers:{},childTokens:{}},H;N.forEach(function(U){if(U.extensions&&(H=!0,U.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var re=z.renderers?z.renderers[G.name]:null;re?z.renderers[G.name]=function(){for(var he=arguments.length,we=new Array(he),ye=0;ye<he;ye++)we[ye]=arguments[ye];var Le=G.renderer.apply(this,we);return Le===!1&&(Le=re.apply(this,we)),Le}:z.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[G.level]?z[G.level].unshift(G.tokenizer):z[G.level]=[G.tokenizer],G.start&&(G.level==="block"?z.startBlock?z.startBlock.push(G.start):z.startBlock=[G.start]:G.level==="inline"&&(z.startInline?z.startInline.push(G.start):z.startInline=[G.start]))}G.childTokens&&(z.childTokens[G.name]=G.childTokens)})),U.renderer&&function(){var G=ee.defaults.renderer||new Re,re=function(ye){var Le=G[ye];G[ye]=function(){for(var Ce=arguments.length,De=new Array(Ce),Pe=0;Pe<Ce;Pe++)De[Pe]=arguments[Pe];var Ie=U.renderer[ye].apply(G,De);return Ie===!1&&(Ie=Le.apply(G,De)),Ie}};for(var he in U.renderer)re(he);k.renderer=G}(),U.tokenizer&&function(){var G=ee.defaults.tokenizer||new ue,re=function(ye){var Le=G[ye];G[ye]=function(){for(var Ce=arguments.length,De=new Array(Ce),Pe=0;Pe<Ce;Pe++)De[Pe]=arguments[Pe];var Ie=U.tokenizer[ye].apply(G,De);return Ie===!1&&(Ie=Le.apply(G,De)),Ie}};for(var he in U.tokenizer)re(he);k.tokenizer=G}(),U.walkTokens){var q=ee.defaults.walkTokens;k.walkTokens=function(G){var re=[];return re.push(U.walkTokens.call(this,G)),q&&(re=re.concat(q.call(this,G))),re}}H&&(k.extensions=z),ee.setOptions(k)})},ee.walkTokens=function(F,N){for(var B=[],k=function(){var q=H.value;switch(B=B.concat(N.call(ee,q)),q.type){case"table":{for(var G=W(q.header),re;!(re=G()).done;){var he=re.value;B=B.concat(ee.walkTokens(he.tokens,N))}for(var we=W(q.rows),ye;!(ye=we()).done;)for(var Le=ye.value,Ce=W(Le),De;!(De=Ce()).done;){var Pe=De.value;B=B.concat(ee.walkTokens(Pe.tokens,N))}break}case"list":{B=B.concat(ee.walkTokens(q.items,N));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[q.type]?ee.defaults.extensions.childTokens[q.type].forEach(function(Ie){B=B.concat(ee.walkTokens(q[Ie],N))}):q.tokens&&(B=B.concat(ee.walkTokens(q.tokens,N)))}},z=W(F),H;!(H=z()).done;)k();return B},ee.parseInline=function(F,N){if(typeof F>"u"||F===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");N=m({},ee.defaults,N||{}),ie(N);try{var B=Me.lexInline(F,N);return N.walkTokens&&ee.walkTokens(B,N.walkTokens),ne.parseInline(B,N)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,N.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},ee.Parser=ne,ee.parser=ne.parse,ee.Renderer=Re,ee.TextRenderer=le,ee.Lexer=Me,ee.lexer=Me.lex,ee.Tokenizer=ue,ee.Slugger=_,ee.parse=ee;var te=ee.options,T=ee.setOptions,x=ee.use,M=ee.walkTokens,f=ee.parseInline,C=ee,$=ne.parse,Y=Me.lex;J.Lexer=Me,J.Parser=ne,J.Renderer=Re,J.Slugger=_,J.TextRenderer=le,J.Tokenizer=ue,J.getDefaults=v,J.lexer=Y,J.marked=ee,J.options=te,J.parse=C,J.parseInline=f,J.parser=$,J.setOptions=T,J.use=x,J.walkTokens=M,Object.defineProperty(J,"__esModule",{value:!0})}),define(ge[76],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(i,W=0,v=i.length,D=W-1){this.a=i,this.b=W,this.c=v,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=E}),define(ge[77],me([1,0,76]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class R{constructor(v=[],D=10){this.h(v),this.b=D,this.d()}getHistory(){return this.j}add(v){this.a.delete(v),this.a.add(v),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()===this.j.length-1}isNowhere(){return this.c.current()===null}has(v){return this.a.has(v)}clear(){this.h([]),this.d()}d(){this.f();const v=this.j;this.c=new E.ArrayNavigator(v,0,v.length,v.length)}f(){const v=this.j;v.length>this.b&&this.h(v.slice(v.length-this.b))}g(){const v=this.c.current();return v?this.j.indexOf(v):-1}h(v){this.a=new Set;for(const D of v)this.a.add(D)}get j(){const v=[];return this.a.forEach(D=>v.push(D)),v}}t.HistoryNavigator=R;class i{constructor(v,D=10){if(this.f=D,v.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:v[0],previous:void 0,next:void 0};for(let g=1;g<v.length;g++)this.add(v[g])}add(v){const D={value:v,previous:this.b,next:void 0};for(this.b.next=D,this.b=D,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(v){const D=this.b.value;return this.b.value=v,D}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(v){let D=this.a;for(;D;){if(D.value===v)return!0;D=D.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let v=this.a;for(;v;)yield v.value,v=v.next}}t.HistoryNavigator2=i}),define(ge[44],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(D,g,l){return Math.min(Math.max(D,g),l)}t.clamp=E;function R(D,g){return(g+D%g)%g}t.rot=R;class i{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=i;class W{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=W;class v{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const l=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=v}),define(ge[45],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(R){function i(g,l){if(g.start>=l.end||l.start>=g.end)return{start:0,end:0};const c=Math.max(g.start,l.start),P=Math.min(g.end,l.end);return P-c<=0?{start:0,end:0}:{start:c,end:P}}R.intersect=i;function W(g){return g.end-g.start<=0}R.isEmpty=W;function v(g,l){return!W(i(g,l))}R.intersects=v;function D(g,l){const c=[],P={start:g.start,end:Math.min(l.start,g.end)},r={start:Math.max(l.end,g.start),end:g.end};return W(P)||c.push(P),W(r)||c.push(r),c}R.relativeComplement=D})(E=t.Range||(t.Range={}))}),define(ge[78],me([1,0,45]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function R(g,l){const c=[];for(const P of l){if(g.start>=P.range.end)continue;if(g.end<P.range.start)break;const r=E.Range.intersect(g,P.range);E.Range.isEmpty(r)||c.push({range:r,size:P.size})}return c}t.groupIntersect=R;function i({start:g,end:l},c){return{start:g+c,end:l+c}}t.shift=i;function W(g){const l=[];let c=null;for(const P of g){const r=P.range.start,u=P.range.end,e=P.size;if(c&&e===c.size){c.range.end=u;continue}c={range:{start:r,end:u},size:e},l.push(c)}return l}t.consolidate=W;function v(...g){return W(g.reduce((l,c)=>l.concat(c),[]))}class D{constructor(){this.a=[],this.b=0}splice(l,c,P=[]){const r=P.length-c,u=R({start:0,end:l},this.a),e=R({start:l+c,end:Number.POSITIVE_INFINITY},this.a).map(n=>({range:i(n.range,r),size:n.size})),a=P.map((n,s)=>({range:{start:l+s,end:l+s+1},size:n.size}));this.a=v(u,a,e),this.b=this.a.reduce((n,s)=>n+s.size*(s.range.end-s.range.start),0)}get count(){const l=this.a.length;return l?this.a[l-1].range.end:0}get size(){return this.b}indexAt(l){if(l<0)return-1;let c=0,P=0;for(const r of this.a){const u=r.range.end-r.range.start,e=P+u*r.size;if(l<e)return c+Math.floor((l-P)/r.size);c+=u,P=e}return c}indexAfter(l){return Math.min(this.indexAt(l)+1,this.count)}positionAt(l){if(l<0)return-1;let c=0,P=0;for(const r of this.a){const u=r.range.end-r.range.start,e=P+u;if(l<e)return c+(l-P)*r.size;c+=u*r.size,P=e}return-1}}t.RangeMap=D}),define(ge[79],me([1,0,7,2]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(A){const S=A;return S?typeof S.read=="function":!1}t.isReadable=i;function W(A){const S=A;return S?[S.on,S.pause,S.resume,S.destroy].every(d=>typeof d=="function"):!1}t.isReadableStream=W;function v(A){const S=A;return S?W(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}t.isReadableBufferedStream=v;function D(A,S){return new g(A,S)}t.newWriteableStream=D;class g{constructor(S,d){this.e=S,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(d=>d(S))}h(S){this.c.error.length===0?(0,E.onUnexpectedError)(S):this.c.error.slice(0).forEach(d=>d(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,d){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(S,d){if(this.a.destroyed)return;let p;switch(S){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const L=p.indexOf(d);L>=0&&p.splice(L,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(A,S){const d=[];let p;for(;(p=A.read())!==null;)d.push(p);return S(d)}t.consumeReadable=l;function c(A,S,d){const p=[];let L;for(;(L=A.read())!==null&&p.length<d;)p.push(L);return L===null&&p.length>0?S(p):{read:()=>{if(p.length>0)return p.shift();if(typeof L<"u"){const I=L;return L=void 0,I}return A.read()}}}t.peekReadable=c;function P(A,S){return new Promise((d,p)=>{const L=[];r(A,{onData:I=>{S&&L.push(I)},onError:I=>{S?p(I):d(void 0)},onEnd:()=>{d(S?S(L):void 0)}})})}t.consumeStream=P;function r(A,S){let d=!1;return A.on("error",p=>{d||S.onError(p)}),A.on("end",()=>{d||S.onEnd()}),A.on("data",p=>{d||S.onData(p)}),(0,R.toDisposable)(()=>d=!0)}t.listenStream=r;function u(A,S){return new Promise((d,p)=>{const L=new R.DisposableStore,I=[],h=w=>{if(I.push(w),I.length>S)return L.dispose(),A.pause(),d({stream:A,buffer:I,ended:!1})},b=w=>p(w),m=()=>d({stream:A,buffer:I,ended:!0});L.add((0,R.toDisposable)(()=>A.removeListener("error",b))),A.on("error",b),L.add((0,R.toDisposable)(()=>A.removeListener("end",m))),A.on("end",m),L.add((0,R.toDisposable)(()=>A.removeListener("data",h))),A.on("data",h)})}t.peekStream=u;function e(A,S){const d=D(S);return d.end(A),d}t.toStream=e;function a(){const A=D(()=>{throw new Error("not supported")});return A.end(),A}t.emptyStream=a;function n(A){let S=!1;return{read:()=>S?null:(S=!0,A)}}t.toReadable=n;function s(A,S,d){const p=D(d);return r(A,{onData:L=>p.write(S.data(L)),onError:L=>p.error(S.error?S.error(L):L),onEnd:()=>p.end()}),p}t.transform=s;function o(A,S,d){let p=!1;return{read:()=>{const L=S.read();return p?L:(p=!0,L!==null?d([A,L]):A)}}}t.prefixedReadable=o;function y(A,S,d){let p=!1;const L=D(d);return r(S,{onData:I=>p?L.write(I):(p=!0,L.write(d([A,I]))),onError:I=>L.error(I),onEnd:()=>{p||(p=!0,L.write(A)),L.end()}}),L}t.prefixedStream=y}),define(ge[30],me([1,0,79]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const R=typeof Buffer<"u";let i,W;class v{static alloc(w){return R?new v(Buffer.allocUnsafe(w)):new v(new Uint8Array(w))}static wrap(w){return R&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new v(w)}static fromString(w,O){return!(O?.dontUseNodeBuffer||!1)&&R?new v(Buffer.from(w)):(i||(i=new TextEncoder),new v(i.encode(w)))}static fromByteArray(w){const O=v.alloc(w.length);for(let V=0,ie=w.length;V<ie;V++)O.buffer[V]=w[V];return O}static concat(w,O){if(typeof O>"u"){O=0;for(let se=0,ae=w.length;se<ae;se++)O+=w[se].byteLength}const V=v.alloc(O);let ie=0;for(let se=0,ae=w.length;se<ae;se++){const de=w[se];V.set(de,ie),ie+=de.byteLength}return V}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=v.alloc(this.byteLength);return w.set(this),w}toString(){return R?this.buffer.toString():(W||(W=new TextDecoder),W.decode(this.buffer))}slice(w,O){return new v(this.buffer.subarray(w,O))}set(w,O){if(w instanceof v)this.buffer.set(w.buffer,O);else if(w instanceof Uint8Array)this.buffer.set(w,O);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),O);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return l(this.buffer,w)}writeUInt32BE(w,O){c(this.buffer,w,O)}readUInt32LE(w){return P(this.buffer,w)}writeUInt32LE(w,O){r(this.buffer,w,O)}readUInt8(w){return u(this.buffer,w)}writeUInt8(w,O){e(this.buffer,w,O)}}t.VSBuffer=v;function D(m,w){return m[w+0]<<0>>>0|m[w+1]<<8>>>0}t.readUInt16LE=D;function g(m,w,O){m[O+0]=w&255,w=w>>>8,m[O+1]=w&255}t.writeUInt16LE=g;function l(m,w){return m[w]*2**24+m[w+1]*2**16+m[w+2]*2**8+m[w+3]}t.readUInt32BE=l;function c(m,w,O){m[O+3]=w,w=w>>>8,m[O+2]=w,w=w>>>8,m[O+1]=w,w=w>>>8,m[O]=w}t.writeUInt32BE=c;function P(m,w){return m[w+0]<<0>>>0|m[w+1]<<8>>>0|m[w+2]<<16>>>0|m[w+3]<<24>>>0}t.readUInt32LE=P;function r(m,w,O){m[O+0]=w&255,w=w>>>8,m[O+1]=w&255,w=w>>>8,m[O+2]=w&255,w=w>>>8,m[O+3]=w&255}t.writeUInt32LE=r;function u(m,w){return m[w]}t.readUInt8=u;function e(m,w,O){m[O]=w}t.writeUInt8=e;function a(m){return E.consumeReadable(m,w=>v.concat(w))}t.readableToBuffer=a;function n(m){return E.toReadable(m)}t.bufferToReadable=n;function s(m){return E.consumeStream(m,w=>v.concat(w))}t.streamToBuffer=s;async function o(m){return m.ended?v.concat(m.buffer):v.concat([...m.buffer,await s(m.stream)])}t.bufferedStreamToBuffer=o;function y(m){return E.toStream(m,w=>v.concat(w))}t.bufferToStream=y;function A(m){return E.transform(m,{data:w=>typeof w=="string"?v.fromString(w):v.wrap(w)},w=>v.concat(w))}t.streamToBufferReadableStream=A;function S(m){return E.newWriteableStream(w=>v.concat(w),m)}t.newWriteableBufferStream=S;function d(m,w){return E.prefixedReadable(m,w,O=>v.concat(O))}t.prefixedBufferReadable=d;function p(m,w){return E.prefixedStream(m,w,O=>v.concat(O))}t.prefixedBufferStream=p;function L(m){let w=0,O=0,V=0;const ie=new Uint8Array(Math.floor(m.length/4*3)),se=de=>{switch(O){case 3:ie[V++]=w|de,O=0;break;case 2:ie[V++]=w|de>>>2,w=de<<6,O=3;break;case 1:ie[V++]=w|de>>>4,w=de<<4,O=2;break;default:w=de<<2,O=1}};for(let de=0;de<m.length;de++){const ue=m.charCodeAt(de);if(ue>=65&&ue<=90)se(ue-65);else if(ue>=97&&ue<=122)se(ue-97+26);else if(ue>=48&&ue<=57)se(ue-48+52);else if(ue===43||ue===45)se(62);else if(ue===47||ue===95)se(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${m[de]}`)}}const ae=V;for(;O>0;)se(0);return v.wrap(ie).slice(0,ae)}t.decodeBase64=L;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:m},w=!0,O=!1){const V=O?h:I;let ie="";const se=m.byteLength%3;let ae=0;for(;ae<m.byteLength-se;ae+=3){const de=m[ae+0],ue=m[ae+1],Z=m[ae+2];ie+=V[de>>>2],ie+=V[(de<<4|ue>>>4)&63],ie+=V[(ue<<2|Z>>>6)&63],ie+=V[Z&63]}if(se===1){const de=m[ae+0];ie+=V[de>>>2],ie+=V[de<<4&63],w&&(ie+="==")}else if(se===2){const de=m[ae+0],ue=m[ae+1];ie+=V[de>>>2],ie+=V[(de<<4|ue>>>4)&63],ie+=V[ue<<2&63],w&&(ie+="=")}return ie}t.encodeBase64=b}),define(ge[46],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[6],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(p){return typeof p=="string"}t.isString=E;function R(p){return Array.isArray(p)&&p.every(L=>E(L))}t.isStringArray=R;function i(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}t.isObject=i;function W(p){const L=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof L}t.isTypedArray=W;function v(p){return typeof p=="number"&&!isNaN(p)}t.isNumber=v;function D(p){return!!p&&typeof p[Symbol.iterator]=="function"}t.isIterable=D;function g(p){return p===!0||p===!1}t.isBoolean=g;function l(p){return typeof p>"u"}t.isUndefined=l;function c(p){return!P(p)}t.isDefined=c;function P(p){return l(p)||p===null}t.isUndefinedOrNull=P;function r(p,L){if(!p)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=r;function u(p){if(P(p))throw new Error("Assertion Failed: argument is undefined or null");return p}t.assertIsDefined=u;function e(...p){const L=[];for(let I=0;I<p.length;I++){const h=p[I];if(P(h))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);L.push(h)}return L}t.assertAllDefined=e;const a=Object.prototype.hasOwnProperty;function n(p){if(!i(p))return!1;for(const L in p)if(a.call(p,L))return!1;return!0}t.isEmptyObject=n;function s(p){return typeof p=="function"}t.isFunction=s;function o(...p){return p.length>0&&p.every(s)}t.areFunctions=o;function y(p,L){const I=Math.min(p.length,L.length);for(let h=0;h<I;h++)A(p[h],L[h])}t.validateConstraints=y;function A(p,L){if(E(L)){if(typeof p!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(s(L)){try{if(p instanceof L)return}catch{}if(!P(p)&&p.constructor===L||L.length===1&&L.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=A;function S(p){return p===null?void 0:p}t.withNullAsUndefined=S;function d(p){return typeof p>"u"?null:p}t.withUndefinedAsNull=d}),define(ge[16],me([1,0,6]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const R=Object.create(null);function i(D,g){if((0,E.isString)(g)){const l=R[g];if(l===void 0)throw new Error(`${D} references an unknown codicon: ${g}`);g=l}return R[D]=g,{id:D}}function W(){return R}t.getCodiconFontCharacters=W;function v(){return Object.values(t.Codicon)}t.getAllCodicons=v,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[80],me([1,0,6]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function R(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const o=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([y,A])=>{o[y]=A&&typeof A=="object"?R(A):A}),o}t.deepClone=R;function i(s){if(!s||typeof s!="object")return s;const o=[s];for(;o.length>0;){const y=o.shift();Object.freeze(y);for(const A in y)if(W.call(y,A)){const S=y[A];typeof S=="object"&&!Object.isFrozen(S)&&!(0,E.isTypedArray)(S)&&o.push(S)}}return s}t.deepFreeze=i;const W=Object.prototype.hasOwnProperty;function v(s,o){return D(s,o,new Set)}t.cloneAndChange=v;function D(s,o,y){if((0,E.isUndefinedOrNull)(s))return s;const A=o(s);if(typeof A<"u")return A;if(Array.isArray(s)){const S=[];for(const d of s)S.push(D(d,o,y));return S}if((0,E.isObject)(s)){if(y.has(s))throw new Error("Cannot clone recursive data-structure");y.add(s);const S={};for(const d in s)W.call(s,d)&&(S[d]=D(s[d],o,y));return y.delete(s),S}return s}function g(s,o,y=!0){return(0,E.isObject)(s)?((0,E.isObject)(o)&&Object.keys(o).forEach(A=>{A in s?y&&((0,E.isObject)(s[A])&&(0,E.isObject)(o[A])?g(s[A],o[A],y):s[A]=o[A]):s[A]=o[A]}),s):o}t.mixin=g;function l(s,o){if(s===o)return!0;if(s==null||o===null||o===void 0||typeof s!=typeof o||typeof s!="object"||Array.isArray(s)!==Array.isArray(o))return!1;let y,A;if(Array.isArray(s)){if(s.length!==o.length)return!1;for(y=0;y<s.length;y++)if(!l(s[y],o[y]))return!1}else{const S=[];for(A in s)S.push(A);S.sort();const d=[];for(A in o)d.push(A);if(d.sort(),!l(S,d))return!1;for(y=0;y<S.length;y++)if(!l(s[S[y]],o[S[y]]))return!1}return!0}t.equals=l;function c(s){const o=new Set;return JSON.stringify(s,(y,A)=>{if((0,E.isObject)(A)||Array.isArray(A)){if(o.has(A))return"[Circular]";o.add(A)}return A})}t.safeStringify=c;function P(s,o){const y=Object.create(null);return!s||!o||Object.keys(o).forEach(S=>{const d=s[S],p=o[S];l(d,p)||(y[S]=p)}),y}t.distinct=P;function r(s,o){const y=o.toLowerCase(),A=Object.keys(s).find(S=>S.toLowerCase()===y);return A?s[A]:s[o]}t.getCaseInsensitive=r;function u(s,o){const y=Object.create(null);for(const[A,S]of Object.entries(s))o(A,S)&&(y[A]=S);return y}t.filter=u;function e(s){let o=[],y=Object.getPrototypeOf(s);for(;Object.prototype!==y;)o=o.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return o}t.getAllPropertyNames=e;function a(s){const o=[];for(const y of e(s))typeof s[y]=="function"&&o.push(y);return o}t.getAllMethodNames=a;function n(s,o){const y=S=>function(){const d=Array.prototype.slice.call(arguments,0);return o(S,d)},A={};for(const S of s)A[S]=y(S);return A}t.createProxyObject=n}),define(ge[17],me([1,0,16]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var R;(function(v){function D(g){return g&&typeof g=="object"&&typeof g.id=="string"}v.isThemeColor=D})(R=t.ThemeColor||(t.ThemeColor={}));function i(v){return{id:v}}t.themeColorFromId=i;var W;(function(v){v.iconNameSegment="[A-Za-z0-9]+",v.iconNameExpression="[A-Za-z0-9-]+",v.iconModifierExpression="~[A-Za-z]+",v.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${v.iconNameExpression})(${v.iconModifierExpression})?$`);function g(o){const y=D.exec(o.id);if(!y)return g(E.Codicon.error);const[,A,S]=y,d=["codicon","codicon-"+A];return S&&d.push("codicon-modifier-"+S.substring(1)),d}v.asClassNameArray=g;function l(o){return g(o).join(" ")}v.asClassName=l;function c(o){return"."+g(o).join(".")}v.asCSSSelector=c;function P(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||R.isThemeColor(o.color))}v.isThemeIcon=P;const r=new RegExp(`^\\$\\((${v.iconNameExpression}(?:${v.iconModifierExpression})?)\\)$`);function u(o){const y=r.exec(o);if(!y)return;const[,A]=y;return{id:A}}v.fromString=u;function e(o){return{id:o}}v.fromId=e;function a(o,y){let A=o.id;const S=A.lastIndexOf("~");return S!==-1&&(A=A.substring(0,S)),y&&(A=`${A}~${y}`),{id:A}}v.modify=a;function n(o){const y=o.id.lastIndexOf("~");if(y!==-1)return o.id.substring(y+1)}v.getModifier=n;function s(o,y){return o.id===y.id&&o.color?.id===y.color?.id}v.isEqual=s})(W=t.ThemeIcon||(t.ThemeIcon={}))}),define(ge[81],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(i,W){this.a=i,this.onMessage=W}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[47],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(J,t){return J.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(J,t){return J.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let R=!1,i=!1,W=!1,v=!1,D=!1,g=!1,l=!1,c=!1,P=!1,r=!1,u,e=t.LANGUAGE_DEFAULT,a,n;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const o=typeof s?.versions?.electron=="string",y=o&&s?.type==="renderer";if(typeof navigator=="object"&&!y)n=navigator.userAgent,R=n.indexOf("Windows")>=0,i=n.indexOf("Macintosh")>=0,c=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=n.indexOf("Linux")>=0,r=n?.indexOf("Mobi")>=0,g=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=u;else if(typeof s=="object"){R=s.platform==="win32",i=s.platform==="darwin",W=s.platform==="linux",v=W&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,l=o,P=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const m=s.env.VSCODE_NLS_CONFIG;if(m)try{const w=JSON.parse(m),O=w.availableLanguages["*"];u=w.locale,e=O||t.LANGUAGE_DEFAULT,a=w._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var A;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(A=t.Platform||(t.Platform={}));function S(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=S;let d=0;i?d=1:R?d=3:W&&(d=2),t.isWindows=R,t.isMacintosh=i,t.isLinux=W,t.isLinuxSnap=v,t.isNative=D,t.isElectron=l,t.isWeb=g,t.isWebWorker=g&&typeof t.globals.importScripts=="function",t.isIOS=c,t.isMobile=r,t.isCI=P,t.platform=d,t.userAgent=n,t.language=e;var p;(function(m){function w(){return t.language}m.value=w;function O(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}m.isDefaultVariant=O;function V(){return t.language==="en"}m.isDefault=V})(p=t.Language||(t.Language={})),t.locale=u,t.translationsConfigFile=a,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const m=[];t.globals.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let V=0,ie=m.length;V<ie;V++){const se=m[V];if(se.id===O.data.vscodeScheduleAsyncWork){m.splice(V,1),se.callback();return}}});let w=0;return O=>{const V=++w;m.push({id:V,callback:O}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return m=>setTimeout(m)})();var L;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(L=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||c?2:R?1:3;let I=!0,h=!1;function b(){if(!h){h=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,I=new Uint16Array(m.buffer)[0]===(2<<8)+1}return I}t.isLittleEndian=b,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let R;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;R={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=R.cwd,t.env=R.env,t.platform=R.platform,t.arch=R.arch}),define(ge[22],me([1,0,105]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const R=65,i=97,W=90,v=122,D=46,g=47,l=92,c=58,P=63;class r extends Error{constructor(p,L,I){let h;typeof L=="string"&&L.indexOf("not ")===0?(h="must not be",L=L.replace(/^not /,"")):h="must be";const b=p.indexOf(".")!==-1?"property":"argument";let m=`The "${p}" ${b} ${h} of type ${L}`;m+=`. Received type ${typeof I}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function u(d,p){if(d===null||typeof d!="object")throw new r(p,"Object",d)}function e(d,p){if(typeof d!="string")throw new r(p,"string",d)}const a=E.platform==="win32";function n(d){return d===g||d===l}function s(d){return d===g}function o(d){return d>=R&&d<=W||d>=i&&d<=v}function y(d,p,L,I){let h="",b=0,m=-1,w=0,O=0;for(let V=0;V<=d.length;++V){if(V<d.length)O=d.charCodeAt(V);else{if(I(O))break;O=g}if(I(O)){if(!(m===V-1||w===1))if(w===2){if(h.length<2||b!==2||h.charCodeAt(h.length-1)!==D||h.charCodeAt(h.length-2)!==D){if(h.length>2){const ie=h.lastIndexOf(L);ie===-1?(h="",b=0):(h=h.slice(0,ie),b=h.length-1-h.lastIndexOf(L)),m=V,w=0;continue}else if(h.length!==0){h="",b=0,m=V,w=0;continue}}p&&(h+=h.length>0?`${L}..`:"..",b=2)}else h.length>0?h+=`${L}${d.slice(m+1,V)}`:h=d.slice(m+1,V),b=V-m-1;m=V,w=0}else O===D&&w!==-1?++w:w=-1}return h}function A(d,p){u(p,"pathObject");const L=p.dir||p.root,I=p.base||`${p.name||""}${p.ext||""}`;return L?L===p.root?`${L}${I}`:`${L}${d}${I}`:I}t.win32={resolve(...d){let p="",L="",I=!1;for(let h=d.length-1;h>=-1;h--){let b;if(h>=0){if(b=d[h],e(b,"path"),b.length===0)continue}else p.length===0?b=E.cwd():(b=E.env[`=${p}`]||E.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==p.toLowerCase()&&b.charCodeAt(2)===l)&&(b=`${p}\\`));const m=b.length;let w=0,O="",V=!1;const ie=b.charCodeAt(0);if(m===1)n(ie)&&(w=1,V=!0);else if(n(ie))if(V=!0,n(b.charCodeAt(1))){let se=2,ae=se;for(;se<m&&!n(b.charCodeAt(se));)se++;if(se<m&&se!==ae){const de=b.slice(ae,se);for(ae=se;se<m&&n(b.charCodeAt(se));)se++;if(se<m&&se!==ae){for(ae=se;se<m&&!n(b.charCodeAt(se));)se++;(se===m||se!==ae)&&(O=`\\\\${de}\\${b.slice(ae,se)}`,w=se)}}}else w=1;else o(ie)&&b.charCodeAt(1)===c&&(O=b.slice(0,2),w=2,m>2&&n(b.charCodeAt(2))&&(V=!0,w=3));if(O.length>0)if(p.length>0){if(O.toLowerCase()!==p.toLowerCase())continue}else p=O;if(I){if(p.length>0)break}else if(L=`${b.slice(w)}\\${L}`,I=V,V&&p.length>0)break}return L=y(L,!I,"\\",n),I?`${p}\\${L}`:`${p}${L}`||"."},normalize(d){e(d,"path");const p=d.length;if(p===0)return".";let L=0,I,h=!1;const b=d.charCodeAt(0);if(p===1)return s(b)?"\\":d;if(n(b))if(h=!0,n(d.charCodeAt(1))){let w=2,O=w;for(;w<p&&!n(d.charCodeAt(w));)w++;if(w<p&&w!==O){const V=d.slice(O,w);for(O=w;w<p&&n(d.charCodeAt(w));)w++;if(w<p&&w!==O){for(O=w;w<p&&!n(d.charCodeAt(w));)w++;if(w===p)return`\\\\${V}\\${d.slice(O)}\\`;w!==O&&(I=`\\\\${V}\\${d.slice(O,w)}`,L=w)}}}else L=1;else o(b)&&d.charCodeAt(1)===c&&(I=d.slice(0,2),L=2,p>2&&n(d.charCodeAt(2))&&(h=!0,L=3));let m=L<p?y(d.slice(L),!h,"\\",n):"";return m.length===0&&!h&&(m="."),m.length>0&&n(d.charCodeAt(p-1))&&(m+="\\"),I===void 0?h?`\\${m}`:m:h?`${I}\\${m}`:`${I}${m}`},isAbsolute(d){e(d,"path");const p=d.length;if(p===0)return!1;const L=d.charCodeAt(0);return n(L)||p>2&&o(L)&&d.charCodeAt(1)===c&&n(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let p,L;for(let b=0;b<d.length;++b){const m=d[b];e(m,"path"),m.length>0&&(p===void 0?p=L=m:p+=`\\${m}`)}if(p===void 0)return".";let I=!0,h=0;if(typeof L=="string"&&n(L.charCodeAt(0))){++h;const b=L.length;b>1&&n(L.charCodeAt(1))&&(++h,b>2&&(n(L.charCodeAt(2))?++h:I=!1))}if(I){for(;h<p.length&&n(p.charCodeAt(h));)h++;h>=2&&(p=`\\${p.slice(h)}`)}return t.win32.normalize(p)},relative(d,p){if(e(d,"from"),e(p,"to"),d===p)return"";const L=t.win32.resolve(d),I=t.win32.resolve(p);if(L===I||(d=L.toLowerCase(),p=I.toLowerCase(),d===p))return"";let h=0;for(;h<d.length&&d.charCodeAt(h)===l;)h++;let b=d.length;for(;b-1>h&&d.charCodeAt(b-1)===l;)b--;const m=b-h;let w=0;for(;w<p.length&&p.charCodeAt(w)===l;)w++;let O=p.length;for(;O-1>w&&p.charCodeAt(O-1)===l;)O--;const V=O-w,ie=m<V?m:V;let se=-1,ae=0;for(;ae<ie;ae++){const ue=d.charCodeAt(h+ae);if(ue!==p.charCodeAt(w+ae))break;ue===l&&(se=ae)}if(ae!==ie){if(se===-1)return I}else{if(V>ie){if(p.charCodeAt(w+ae)===l)return I.slice(w+ae+1);if(ae===2)return I.slice(w+ae)}m>ie&&(d.charCodeAt(h+ae)===l?se=ae:ae===2&&(se=3)),se===-1&&(se=0)}let de="";for(ae=h+se+1;ae<=b;++ae)(ae===b||d.charCodeAt(ae)===l)&&(de+=de.length===0?"..":"\\..");return w+=se,de.length>0?`${de}${I.slice(w,O)}`:(I.charCodeAt(w)===l&&++w,I.slice(w,O))},toNamespacedPath(d){if(typeof d!="string"||d.length===0)return d;const p=t.win32.resolve(d);if(p.length<=2)return d;if(p.charCodeAt(0)===l){if(p.charCodeAt(1)===l){const L=p.charCodeAt(2);if(L!==P&&L!==D)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(o(p.charCodeAt(0))&&p.charCodeAt(1)===c&&p.charCodeAt(2)===l)return`\\\\?\\${p}`;return d},dirname(d){e(d,"path");const p=d.length;if(p===0)return".";let L=-1,I=0;const h=d.charCodeAt(0);if(p===1)return n(h)?d:".";if(n(h)){if(L=I=1,n(d.charCodeAt(1))){let w=2,O=w;for(;w<p&&!n(d.charCodeAt(w));)w++;if(w<p&&w!==O){for(O=w;w<p&&n(d.charCodeAt(w));)w++;if(w<p&&w!==O){for(O=w;w<p&&!n(d.charCodeAt(w));)w++;if(w===p)return d;w!==O&&(L=I=w+1)}}}}else o(h)&&d.charCodeAt(1)===c&&(L=p>2&&n(d.charCodeAt(2))?3:2,I=L);let b=-1,m=!0;for(let w=p-1;w>=I;--w)if(n(d.charCodeAt(w))){if(!m){b=w;break}}else m=!1;if(b===-1){if(L===-1)return".";b=L}return d.slice(0,b)},basename(d,p){p!==void 0&&e(p,"ext"),e(d,"path");let L=0,I=-1,h=!0,b;if(d.length>=2&&o(d.charCodeAt(0))&&d.charCodeAt(1)===c&&(L=2),p!==void 0&&p.length>0&&p.length<=d.length){if(p===d)return"";let m=p.length-1,w=-1;for(b=d.length-1;b>=L;--b){const O=d.charCodeAt(b);if(n(O)){if(!h){L=b+1;break}}else w===-1&&(h=!1,w=b+1),m>=0&&(O===p.charCodeAt(m)?--m===-1&&(I=b):(m=-1,I=w))}return L===I?I=w:I===-1&&(I=d.length),d.slice(L,I)}for(b=d.length-1;b>=L;--b)if(n(d.charCodeAt(b))){if(!h){L=b+1;break}}else I===-1&&(h=!1,I=b+1);return I===-1?"":d.slice(L,I)},extname(d){e(d,"path");let p=0,L=-1,I=0,h=-1,b=!0,m=0;d.length>=2&&d.charCodeAt(1)===c&&o(d.charCodeAt(0))&&(p=I=2);for(let w=d.length-1;w>=p;--w){const O=d.charCodeAt(w);if(n(O)){if(!b){I=w+1;break}continue}h===-1&&(b=!1,h=w+1),O===D?L===-1?L=w:m!==1&&(m=1):L!==-1&&(m=-1)}return L===-1||h===-1||m===0||m===1&&L===h-1&&L===I+1?"":d.slice(L,h)},format:A.bind(null,"\\"),parse(d){e(d,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return p;const L=d.length;let I=0,h=d.charCodeAt(0);if(L===1)return n(h)?(p.root=p.dir=d,p):(p.base=p.name=d,p);if(n(h)){if(I=1,n(d.charCodeAt(1))){let se=2,ae=se;for(;se<L&&!n(d.charCodeAt(se));)se++;if(se<L&&se!==ae){for(ae=se;se<L&&n(d.charCodeAt(se));)se++;if(se<L&&se!==ae){for(ae=se;se<L&&!n(d.charCodeAt(se));)se++;se===L?I=se:se!==ae&&(I=se+1)}}}}else if(o(h)&&d.charCodeAt(1)===c){if(L<=2)return p.root=p.dir=d,p;if(I=2,n(d.charCodeAt(2))){if(L===3)return p.root=p.dir=d,p;I=3}}I>0&&(p.root=d.slice(0,I));let b=-1,m=I,w=-1,O=!0,V=d.length-1,ie=0;for(;V>=I;--V){if(h=d.charCodeAt(V),n(h)){if(!O){m=V+1;break}continue}w===-1&&(O=!1,w=V+1),h===D?b===-1?b=V:ie!==1&&(ie=1):b!==-1&&(ie=-1)}return w!==-1&&(b===-1||ie===0||ie===1&&b===w-1&&b===m+1?p.base=p.name=d.slice(m,w):(p.name=d.slice(m,b),p.base=d.slice(m,w),p.ext=d.slice(b,w))),m>0&&m!==I?p.dir=d.slice(0,m-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(a){const d=/\\/g;return()=>{const p=E.cwd().replace(d,"/");return p.slice(p.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...d){let p="",L=!1;for(let I=d.length-1;I>=-1&&!L;I--){const h=I>=0?d[I]:S();e(h,"path"),h.length!==0&&(p=`${h}/${p}`,L=h.charCodeAt(0)===g)}return p=y(p,!L,"/",s),L?`/${p}`:p.length>0?p:"."},normalize(d){if(e(d,"path"),d.length===0)return".";const p=d.charCodeAt(0)===g,L=d.charCodeAt(d.length-1)===g;return d=y(d,!p,"/",s),d.length===0?p?"/":L?"./":".":(L&&(d+="/"),p?`/${d}`:d)},isAbsolute(d){return e(d,"path"),d.length>0&&d.charCodeAt(0)===g},join(...d){if(d.length===0)return".";let p;for(let L=0;L<d.length;++L){const I=d[L];e(I,"path"),I.length>0&&(p===void 0?p=I:p+=`/${I}`)}return p===void 0?".":t.posix.normalize(p)},relative(d,p){if(e(d,"from"),e(p,"to"),d===p||(d=t.posix.resolve(d),p=t.posix.resolve(p),d===p))return"";const L=1,I=d.length,h=I-L,b=1,m=p.length-b,w=h<m?h:m;let O=-1,V=0;for(;V<w;V++){const se=d.charCodeAt(L+V);if(se!==p.charCodeAt(b+V))break;se===g&&(O=V)}if(V===w)if(m>w){if(p.charCodeAt(b+V)===g)return p.slice(b+V+1);if(V===0)return p.slice(b+V)}else h>w&&(d.charCodeAt(L+V)===g?O=V:V===0&&(O=0));let ie="";for(V=L+O+1;V<=I;++V)(V===I||d.charCodeAt(V)===g)&&(ie+=ie.length===0?"..":"/..");return`${ie}${p.slice(b+O)}`},toNamespacedPath(d){return d},dirname(d){if(e(d,"path"),d.length===0)return".";const p=d.charCodeAt(0)===g;let L=-1,I=!0;for(let h=d.length-1;h>=1;--h)if(d.charCodeAt(h)===g){if(!I){L=h;break}}else I=!1;return L===-1?p?"/":".":p&&L===1?"//":d.slice(0,L)},basename(d,p){p!==void 0&&e(p,"ext"),e(d,"path");let L=0,I=-1,h=!0,b;if(p!==void 0&&p.length>0&&p.length<=d.length){if(p===d)return"";let m=p.length-1,w=-1;for(b=d.length-1;b>=0;--b){const O=d.charCodeAt(b);if(O===g){if(!h){L=b+1;break}}else w===-1&&(h=!1,w=b+1),m>=0&&(O===p.charCodeAt(m)?--m===-1&&(I=b):(m=-1,I=w))}return L===I?I=w:I===-1&&(I=d.length),d.slice(L,I)}for(b=d.length-1;b>=0;--b)if(d.charCodeAt(b)===g){if(!h){L=b+1;break}}else I===-1&&(h=!1,I=b+1);return I===-1?"":d.slice(L,I)},extname(d){e(d,"path");let p=-1,L=0,I=-1,h=!0,b=0;for(let m=d.length-1;m>=0;--m){const w=d.charCodeAt(m);if(w===g){if(!h){L=m+1;break}continue}I===-1&&(h=!1,I=m+1),w===D?p===-1?p=m:b!==1&&(b=1):p!==-1&&(b=-1)}return p===-1||I===-1||b===0||b===1&&p===I-1&&p===L+1?"":d.slice(p,I)},format:A.bind(null,"/"),parse(d){e(d,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return p;const L=d.charCodeAt(0)===g;let I;L?(p.root="/",I=1):I=0;let h=-1,b=0,m=-1,w=!0,O=d.length-1,V=0;for(;O>=I;--O){const ie=d.charCodeAt(O);if(ie===g){if(!w){b=O+1;break}continue}m===-1&&(w=!1,m=O+1),ie===D?h===-1?h=O:V!==1&&(V=1):h!==-1&&(V=-1)}if(m!==-1){const ie=b===0&&L?1:b;h===-1||V===0||V===1&&h===m-1&&h===b+1?p.base=p.name=d.slice(ie,m):(p.name=d.slice(ie,h),p.base=d.slice(ie,m),p.ext=d.slice(h,m))}return b>0?p.dir=d.slice(0,b-1):L&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=a?t.win32.normalize:t.posix.normalize,t.isAbsolute=a?t.win32.isAbsolute:t.posix.isAbsolute,t.join=a?t.win32.join:t.posix.join,t.resolve=a?t.win32.resolve:t.posix.resolve,t.relative=a?t.win32.relative:t.posix.relative,t.dirname=a?t.win32.dirname:t.posix.dirname,t.basename=a?t.win32.basename:t.posix.basename,t.extname=a?t.win32.extname:t.posix.extname,t.format=a?t.win32.format:t.posix.format,t.parse=a?t.win32.parse:t.posix.parse,t.toNamespacedPath=a?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=a?t.win32.sep:t.posix.sep,t.delimiter=a?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,22]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(c){const P=(0,E.extname)(c),r=R[P.toLowerCase()];return r!==void 0?r:v(c)}t.getMediaOrTextMime=W;function v(c){const P=(0,E.extname)(c);return i[P.toLowerCase()]}t.getMediaMime=v;function D(c){for(const P in i)if(i[P]===c)return P}t.getExtensionForMimeType=D;const g=/^(.+)\/(.+?)(;.+)?$/;function l(c,P){const r=g.exec(c);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:c}t.normalizeMimeType=l}),define(ge[107],me([1,0,5]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const R=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(v=!0){return new i(v)}constructor(v){this.a=R&&v,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}t.StopWatch=i}),define(ge[3],me([1,0,7,40,2,43,107]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const D=!1,g=!1;var l;(function(b){b.None=()=>i.Disposable.None;function m(C){if(g){const{onDidAddListener:$}=C,Y=e.create();let F=0;C.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function w(C,$){return Q(C,()=>{},0,void 0,!0,void 0,$)}b.defer=w;function O(C){return($,Y=null,F)=>{let N=!1,B;return B=C(k=>{if(!N)return B?B.dispose():N=!0,$.call(Y,k)},null,F),N&&B.dispose(),B}}b.once=O;function V(C,$,Y){return Z((F,N=null,B)=>C(k=>F.call(N,$(k)),null,B),Y)}b.map=V;function ie(C,$,Y){return Z((F,N=null,B)=>C(k=>{$(k),F.call(N,k)},null,B),Y)}b.forEach=ie;function se(C,$,Y){return Z((F,N=null,B)=>C(k=>$(k)&&F.call(N,k),null,B),Y)}b.filter=se;function ae(C){return C}b.signal=ae;function de(...C){return($,Y=null,F)=>(0,i.combinedDisposable)(...C.map(N=>N(B=>$.call(Y,B),null,F)))}b.any=de;function ue(C,$,Y,F){let N=Y;return V(C,B=>(N=$(N,B),N),F)}b.reduce=ue;function Z(C,$){let Y;const F={onWillAddFirstListener(){Y=C(N.fire,N)},onDidRemoveLastListener(){Y?.dispose()}};$||m(F);const N=new n(F);return $?.add(N),N.event}function Q(C,$,Y=100,F=!1,N=!1,B,k){let z,H,U,q=0,G;const re={leakWarningThreshold:B,onWillAddFirstListener(){z=C(we=>{q++,H=$(H,we),F&&!U&&(he.fire(H),H=void 0),G=()=>{const ye=H;H=void 0,U=void 0,(!F||q>1)&&he.fire(ye),q=0},typeof Y=="number"?(clearTimeout(U),U=setTimeout(G,Y)):U===void 0&&(U=0,queueMicrotask(G))})},onWillRemoveListener(){N&&q>0&&G?.()},onDidRemoveLastListener(){G=void 0,z.dispose()}};k||m(re);const he=new n(re);return k?.add(he),he.event}b.debounce=Q;function ve(C,$=0,Y){return b.debounce(C,(F,N)=>F?(F.push(N),F):[N],$,void 0,!0,void 0,Y)}b.accumulate=ve;function pe(C,$=(F,N)=>F===N,Y){let F=!0,N;return se(C,B=>{const k=F||!$(B,N);return F=!1,N=B,k},Y)}b.latch=pe;function Me(C,$,Y){return[b.filter(C,$,Y),b.filter(C,F=>!$(F),Y)]}b.split=Me;function Re(C,$=!1,Y=[]){let F=Y.slice(),N=C(z=>{F?F.push(z):k.fire(z)});const B=()=>{F?.forEach(z=>k.fire(z)),F=null},k=new n({onWillAddFirstListener(){N||(N=C(z=>k.fire(z)))},onDidAddFirstListener(){F&&($?setTimeout(B):B())},onDidRemoveLastListener(){N&&N.dispose(),N=null}});return k.event}b.buffer=Re;class le{constructor($){this.event=$,this.c=new i.DisposableStore}map($){return new le(V(this.event,$,this.c))}forEach($){return new le(ie(this.event,$,this.c))}filter($){return new le(se(this.event,$,this.c))}reduce($,Y){return new le(ue(this.event,$,Y,this.c))}latch(){return new le(pe(this.event,void 0,this.c))}debounce($,Y=100,F=!1,N=!1,B){return new le(Q(this.event,$,Y,F,N,B,this.c))}on($,Y,F){return this.event($,Y,F)}once($,Y,F){return O(this.event)($,Y,F)}dispose(){this.c.dispose()}}function _(C){return new le(C)}b.chain=_;function ne(C,$,Y=F=>F){const F=(...z)=>k.fire(Y(...z)),N=()=>C.on($,F),B=()=>C.removeListener($,F),k=new n({onWillAddFirstListener:N,onDidRemoveLastListener:B});return k.event}b.fromNodeEventEmitter=ne;function ee(C,$,Y=F=>F){const F=(...z)=>k.fire(Y(...z)),N=()=>C.addEventListener($,F),B=()=>C.removeEventListener($,F),k=new n({onWillAddFirstListener:N,onDidRemoveLastListener:B});return k.event}b.fromDOMEventEmitter=ee;function te(C){return new Promise($=>O(C)($))}b.toPromise=te;function T(C,$){return $(void 0),C(Y=>$(Y))}b.runAndSubscribe=T;function x(C,$){let Y=null;function F(B){Y?.dispose(),Y=new i.DisposableStore,$(B,Y)}F(void 0);const N=C(B=>F(B));return(0,i.toDisposable)(()=>{N.dispose(),Y?.dispose()})}b.runAndSubscribeWithStore=x;class M{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const F={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||m(F),this.emitter=new n(F),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function f(C,$){return new M(C,$).emitter.event}b.fromObservable=f})(l=t.Event||(t.Event={}));class c{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${c.c++}`,c.all.add(this)}start(m){this.d=new v.StopWatch(!0),this.listenerCount=m}stop(){if(this.d){const m=this.d.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.d=void 0}}}c.all=new Set,c.c=0,t.EventProfiling=c;let P=-1;function r(b){const m=P;return P=b,{dispose(){P=m}}}t.setGlobalLeakWarningThreshold=r;class u{constructor(m,w=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=w,this.d=0}dispose(){this.c?.clear()}check(m,w){const O=this.threshold;if(O<=0||w<O)return;this.c||(this.c=new Map);const V=this.c.get(m.value)||0;if(this.c.set(m.value,V+1),this.d-=1,this.d<=0){this.d=O*.5;let ie,se=0;for(const[ae,de]of this.c)(!ie||se<de)&&(ie=ae,se=de);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${se}):`),console.warn(ie)}return()=>{const ie=this.c.get(m.value)||0;this.c.set(m.value,ie-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class a{constructor(m,w,O){this.callback=m,this.callbackThis=w,this.stack=O,this.subscription=new i.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class n{constructor(m){this.j=!1,this.d=m,this.f=P>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new c(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(D){const m=Array.from(this.q);queueMicrotask(()=>{for(const w of m)w.subscription.isset()&&(w.subscription.unset(),w.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(m,w,O)=>{if(this.q||(this.q=new W.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let ie,se;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(se=e.create(),ie=this.f.check(se,this.q.size+1)),D&&(se=se??e.create());const ae=new a(m,w,se),de=this.q.push(ae);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,m,w);const ue=ae.subscription.set(()=>{ie?.(),this.j||(this.d?.onWillRemoveListener?.(this),de(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return O instanceof i.DisposableStore?O.add(ue):Array.isArray(O)&&O.push(ue),ue}),this.l}fire(m){if(this.q){this.m||(this.m=new o(this.d?.onListenerError));for(const w of this.q)this.m.push(this,w,m);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=n;class s{constructor(m=E.onUnexpectedError){this.d=m,this.c=new W.LinkedList}get size(){return this.c.size}push(m,w,O){this.c.push(new y(m,w,O))}clear(m){const w=new W.LinkedList;for(const O of this.c)O.emitter!==m&&w.push(O);this.c=w}deliver(){for(;this.c.size>0;){const m=this.c.shift();try{m.listener.invoke(m.event)}catch(w){this.d(w)}}}}t.EventDeliveryQueue=s;class o extends s{clear(m){this.c.clear()}}class y{constructor(m,w,O){this.emitter=m,this.listener=w,this.event=O}}class A extends n{async fireAsync(m,w,O){if(!!this.q){this.c||(this.c=new W.LinkedList);for(const V of this.q)this.c.push([V,m]);for(;this.c.size>0&&!w.isCancellationRequested;){const[V,ie]=this.c.shift(),se=[],ae={...ie,token:w,waitUntil:de=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");O&&(de=O(de,V.callback)),se.push(de)}};try{V.invoke(ae)}catch(de){(0,E.onUnexpectedError)(de);continue}Object.freeze(se),await Promise.allSettled(se).then(de=>{for(const ue of de)ue.status==="rejected"&&(0,E.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=A;class S extends n{constructor(m){super(m),this.h=0,this.s=new W.LinkedList,this.t=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.t(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.q&&(this.h!==0?this.s.push(m):super.fire(m))}}t.PauseableEmitter=S;class d extends S{constructor(m){super(m),this.c=m.delay??100}fire(m){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(m)}}t.DebounceEmitter=d;class p extends n{constructor(m){super(m),this.c=[],this.h=m?.merge}fire(m){!this.hasListeners()||(this.c.push(m),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(w=>super.fire(w)),this.c=[]}))}}t.MicrotaskEmitter=p;class L{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(m){const w={event:m,listener:null};this.f.push(w),this.d&&this.j(w);const O=()=>{this.d&&this.k(w);const V=this.f.indexOf(w);this.f.splice(V,1)};return(0,i.toDisposable)((0,R.once)(O))}g(){this.d=!0,this.f.forEach(m=>this.j(m))}h(){this.d=!1,this.f.forEach(m=>this.k(m))}j(m){m.listener=m.event(w=>this.c.fire(w))}k(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=L;class I{constructor(){this.c=[]}wrapEvent(m){return(w,O,V)=>m(ie=>{const se=this.c[this.c.length-1];se?se.push(()=>w.call(O,ie)):w.call(O,ie)},void 0,V)}bufferEvents(m){const w=[];this.c.push(w);const O=m();return this.c.pop(),w.forEach(V=>V()),O}}t.EventBufferer=I;class h{constructor(){this.c=!1,this.d=l.None,this.f=i.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(m){this.d=m,this.c&&(this.f.dispose(),this.f=m(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=h}),define(ge[18],me([1,0,3,2]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new E.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(A,S){this.a!==A&&(this.a=A)}getZoomFactor(){return this.b}setZoomFactor(A){this.b=A}setFullscreen(A){this.c!==A&&(this.c=A,this.d.fire())}isFullscreen(){return this.c}}i.INSTANCE=new i;class W extends R.Disposable{constructor(){super(),this.a=this.D(new E.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(A){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),A&&this.a.fire()}}class v extends R.Disposable{get value(){return this.b}constructor(){super(),this.a=this.D(new E.Emitter),this.onDidChange=this.a.event,this.b=this.c();const A=this.D(new W);this.D(A.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const A=document.createElement("canvas").getContext("2d"),S=window.devicePixelRatio||1,d=A.webkitBackingStorePixelRatio||A.mozBackingStorePixelRatio||A.msBackingStorePixelRatio||A.oBackingStorePixelRatio||A.backingStorePixelRatio||1;return S/d}}class D{constructor(){this.a=null}b(){return this.a||(this.a=(0,R.markAsSingleton)(new v)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function g(y,A){typeof y=="string"&&(y=window.matchMedia(y)),y.addEventListener("change",A)}t.addMatchMediaChangeListener=g,t.PixelRatio=new D;function l(y,A){i.INSTANCE.setZoomLevel(y,A)}t.setZoomLevel=l;function c(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=c;function P(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=P;function r(y){i.INSTANCE.setZoomFactor(y)}t.setZoomFactor=r;function u(y){i.INSTANCE.setFullscreen(y)}t.setFullscreen=u;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.isFirefox=a.indexOf("Firefox")>=0,t.isWebKit=a.indexOf("AppleWebKit")>=0,t.isChrome=a.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&a.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=a.indexOf("Electron/")>=0,t.isAndroid=a.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const y=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),A=window.matchMedia("(display-mode: fullscreen)");n=y.matches,g(y,({matches:S})=>{n&&A.matches||(n=S)})}function s(){return n}t.isStandalone=s;function o(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=o}),define(ge[108],me([1,0,18,5]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(i=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:R.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:R.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>R.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[20],me([1,0,3]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class R{get event(){return this.a.event}constructor(W,v,D){const g=l=>this.a.fire(l);this.a=new E.Emitter({onWillAddFirstListener:()=>W.addEventListener(v,g,D),onDidRemoveLastListener:()=>W.removeEventListener(v,g,D)})}dispose(){this.a.dispose()}}t.DomEmitter=R}),define(ge[14],me([1,0,18,41,73,5]),function(J,t,E,R,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function v(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return R.KeyCodeUtils.fromString(n)}const a=e.keyCode;if(a===3)return 7;if(E.isFirefox){if(a===59)return 80;if(a===107)return 81;if(a===109)return 83;if(W.isMacintosh&&a===224)return 57}else if(E.isWebKit){if(a===91)return 57;if(W.isMacintosh&&a===93)return 57;if(!W.isMacintosh&&a===92)return 57}return R.EVENT_KEY_CODE_MAP[a]||0}const D=W.isMacintosh?256:2048,g=512,l=1024,c=W.isMacintosh?2048:256;function P(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=P;function r(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${R.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class u{constructor(a){this._standardKeyboardEventBrand=!0;const n=a;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=v(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let n=0;return this.ctrlKey&&(n|=D),this.altKey&&(n|=g),this.shiftKey&&(n|=l),this.metaKey&&(n|=c),n|=a,n}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.StandardKeyboardEvent=u}),define(ge[21],me([1,0,18,65,5]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class W{constructor(l){this.timestamp=Date.now(),this.browserEvent=l,this.leftButton=l.button===0,this.middleButton=l.button===1,this.rightButton=l.button===2,this.buttons=l.buttons,this.target=l.target,this.detail=l.detail||1,l.type==="dblclick"&&(this.detail=2),this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,typeof l.pageX=="number"?(this.posx=l.pageX,this.posy=l.pageY):(this.posx=l.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=l.clientY+document.body.scrollTop+document.documentElement.scrollTop);const c=R.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,l.view);this.posx-=c.left,this.posy-=c.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=W;class v extends W{constructor(l){super(l),this.dataTransfer=l.dataTransfer}}t.DragMouseEvent=v;class D{constructor(l,c=0,P=0){if(this.browserEvent=l||null,this.target=l?l.target||l.targetNode||l.srcElement:null,this.deltaY=P,this.deltaX=c,l){const r=l,u=l;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof u.VERTICAL_AXIS<"u"&&u.axis===u.VERTICAL_AXIS)this.deltaY=-u.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaY=-l.deltaY/3:this.deltaY=-l.deltaY:this.deltaY=-l.deltaY/40}if(typeof r.wheelDeltaX<"u")E.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof u.HORIZONTAL_AXIS<"u"&&u.axis===u.HORIZONTAL_AXIS)this.deltaX=-l.detail/3;else if(l.type==="wheel"){const e=l;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!i.isMacintosh?this.deltaX=-l.deltaX/3:this.deltaX=-l.deltaX:this.deltaX=-l.deltaX/40}this.deltaY===0&&this.deltaX===0&&l.wheelDelta&&(this.deltaY=l.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=D}),define(ge[31],me([1,0,3,2,103]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class W extends R.Disposable{constructor(r,u="",e="",a=!0,n){super(),this.j=this.D(new E.Emitter),this.onDidChange=this.j.event,this.w=!0,this.m=r,this.n=u,this.u=e,this.w=a,this.C=n}get id(){return this.m}get label(){return this.n}set label(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.j.fire({label:r}))}get tooltip(){return this.q||""}set tooltip(r){this.G(r)}G(r){this.q!==r&&(this.q=r,this.j.fire({tooltip:r}))}get class(){return this.u}set class(r){this.H(r)}H(r){this.u!==r&&(this.u=r,this.j.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.I(r)}I(r){this.w!==r&&(this.w=r,this.j.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.J(r)}J(r){this.z!==r&&(this.z=r,this.j.fire({checked:r}))}async run(r,u){this.C&&await this.C(r)}}t.Action=W;class v extends R.Disposable{constructor(){super(...arguments),this.f=this.D(new E.Emitter),this.onWillRun=this.f.event,this.h=this.D(new E.Emitter),this.onDidRun=this.h.event}async run(r,u){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.k(r,u)}catch(a){e=a}this.h.fire({action:r,error:e})}async k(r,u){await r.run(u)}}t.ActionRunner=v;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let u=[];for(const e of r)e.length&&(u.length?u=[...u,new D,...e]:u=e);return u}async run(){}}D.ID="vs.actions.separator",t.Separator=D;class g{get actions(){return this.a}constructor(r,u,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=u,this.class=a,this.a=e}async run(){}}t.SubmenuAction=g;class l extends W{constructor(){super(l.ID,i.localize(0,null),void 0,!1)}}l.ID="vs.actions.empty",t.EmptySubmenuAction=l;function c(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.toAction=c}),define(ge[27],me([1,0,3]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const R=Object.freeze(function(D,g){const l=setTimeout(D.bind(g),0);return{dispose(){clearTimeout(l)}}});var i;(function(D){function g(l){return l===D.None||l===D.Cancelled||l instanceof W?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}D.isCancellationToken=g,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(i=t.CancellationToken||(t.CancellationToken={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(g){this.a=void 0,this.b=void 0,this.b=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new W),this.a}cancel(){this.a?this.a instanceof W&&this.a.cancel():this.a=i.Cancelled}dispose(g=!1){g&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof W&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=v}),define(ge[109],me([1,0,27]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class R{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new E.CancellationTokenSource,g=this.b(D.token);return this.a={promise:g,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.Cache=R;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const g=JSON.stringify(D);return this.b!==g&&(this.b=g,this.a=this.c(D)),this.a}}t.LRUCachedFunction=i;class W{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const g=this.b(D);return this.a.set(D,g),g}}t.CachedFunction=W}),define(ge[48],me([1,0,3,2]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(u){u[u.Auto=1]="Auto",u[u.Hidden=2]="Hidden",u[u.Visible=3]="Visible"})(i=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class W{constructor(e,a,n,s,o,y,A){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,n=n|0,s=s|0,o=o|0,y=y|0,A=A|0),this.rawScrollLeft=s,this.rawScrollTop=A,a<0&&(a=0),s+a>n&&(s=n-a),s<0&&(s=0),o<0&&(o=0),A+o>y&&(A=y-o),A<0&&(A=0),this.width=a,this.scrollWidth=n,this.scrollLeft=s,this.height=o,this.scrollHeight=y,this.scrollTop=A}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const n=this.width!==e.width,s=this.scrollWidth!==e.scrollWidth,o=this.scrollLeft!==e.scrollLeft,y=this.height!==e.height,A=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:s,scrollLeftChanged:o,heightChanged:y,scrollHeightChanged:A,scrollTopChanged:S}}}t.ScrollState=W;class v extends R.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.D(new E.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const n=this.g.withScrollDimensions(e,a);this.k(n,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const n=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===n.scrollLeft&&this.h.to.scrollTop===n.scrollTop)return;let s;a?s=new c(this.h.from,n,this.h.startTime,this.h.duration):s=this.h.combine(this.g,n,this.c),this.h.dispose(),this.h=s}else{const n=this.g.withScrollPosition(e);this.h=c.start(this.g,n,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.k(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,a){const n=this.g;n.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(n,a)))}}t.Scrollable=v;class D{constructor(e,a,n){this.scrollLeft=e,this.scrollTop=a,this.isDone=n}}t.SmoothScrollingUpdate=D;function g(u,e){const a=e-u;return function(n){return u+a*r(n)}}function l(u,e,a){return function(n){return n<a?u(n/a):e((n-a)/(1-a))}}class c{constructor(e,a,n,s){this.from=e,this.to=a,this.duration=s,this.startTime=n,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,n){if(Math.abs(e-a)>2.5*n){let o,y;return e<a?(o=e+.75*n,y=a-.75*n):(o=e-.75*n,y=a+.75*n),l(g(e,o),g(y,a),.33)}return g(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const n=this.c(a),s=this.d(a);return new D(n,s,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,n){return c.start(e,a,n)}static start(e,a,n){n=n+10;const s=Date.now()-10;return new c(e,a,s,n)}}t.SmoothScrollingOperation=c;function P(u){return Math.pow(u,3)}function r(u){return 1-P(1-u)}}),define(ge[11],me([1,0,109,42]),function(J,t,E,R){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function W(j){return!j||typeof j!="string"?!0:j.trim().length===0}t.isFalsyOrWhitespace=W;const v=/{(\d+)}/g;function D(j,...oe){return oe.length===0?j:j.replace(v,function(be,Ee){const Se=parseInt(Ee,10);return isNaN(Se)||Se<0||Se>=oe.length?be:oe[Se]})}t.format=D;const g=/{([^}]+)}/g;function l(j,oe){return j.replace(g,(be,Ee)=>oe[Ee]??be)}t.format2=l;function c(j){return j.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=c;function P(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function r(j,oe){let be=0;const Ee=oe.charCodeAt(0);for(let Se=j.length-1;Se>=0;Se--)j.charCodeAt(Se)===Ee&&be++;return be}t.count=r;function u(j,oe,be="\u2026"){return j.length<=oe?j:`${j.substr(0,oe)}${be}`}t.truncate=u;function e(j,oe=" "){const be=a(j,oe);return n(be,oe)}t.trim=e;function a(j,oe){if(!j||!oe)return j;const be=oe.length;if(be===0||j.length===0)return j;let Ee=0;for(;j.indexOf(oe,Ee)===Ee;)Ee=Ee+be;return j.substring(Ee)}t.ltrim=a;function n(j,oe){if(!j||!oe)return j;const be=oe.length,Ee=j.length;if(be===0||Ee===0)return j;let Se=Ee,Oe=-1;for(;Oe=j.lastIndexOf(oe,Se-1),!(Oe===-1||Oe+be!==Se);){if(Oe===0)return"";Se=Oe}return j.substring(0,Se)}t.rtrim=n;function s(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=s;function o(j){return j.replace(/\*/g,"")}t.stripWildcards=o;function y(j,oe,be={}){if(!j)throw new Error("Cannot create regex from empty string");oe||(j=P(j)),be.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let Ee="";return be.global&&(Ee+="g"),be.matchCase||(Ee+="i"),be.multiline&&(Ee+="m"),be.unicode&&(Ee+="u"),new RegExp(j,Ee)}t.createRegExp=y;function A(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}t.regExpLeadsToEndlessLoop=A;function S(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function d(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}t.regExpFlags=d;function p(j){return j.split(/\r\n|\r|\n/)}t.splitLines=p;function L(j){for(let oe=0,be=j.length;oe<be;oe++){const Ee=j.charCodeAt(oe);if(Ee!==32&&Ee!==9)return oe}return-1}t.firstNonWhitespaceIndex=L;function I(j,oe=0,be=j.length){for(let Ee=oe;Ee<be;Ee++){const Se=j.charCodeAt(Ee);if(Se!==32&&Se!==9)return j.substring(oe,Ee)}return j.substring(oe,be)}t.getLeadingWhitespace=I;function h(j,oe=j.length-1){for(let be=oe;be>=0;be--){const Ee=j.charCodeAt(be);if(Ee!==32&&Ee!==9)return be}return-1}t.lastNonWhitespaceIndex=h;function b(j,oe,be){const Ee=[];let Se=0;for(const Oe of j.matchAll(oe)){if(Ee.push(j.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,Ee.push(be(Oe[0],...Oe.slice(1),Oe.index,j,Oe.groups))}return Ee.push(j.slice(Se)),Promise.all(Ee).then(Oe=>Oe.join(""))}t.replaceAsync=b;function m(j,oe){return j<oe?-1:j>oe?1:0}t.compare=m;function w(j,oe,be=0,Ee=j.length,Se=0,Oe=oe.length){for(;be<Ee&&Se<Oe;be++,Se++){const Ke=j.charCodeAt(be),xe=oe.charCodeAt(Se);if(Ke<xe)return-1;if(Ke>xe)return 1}const $e=Ee-be,tt=Oe-Se;return $e<tt?-1:$e>tt?1:0}t.compareSubstring=w;function O(j,oe){return V(j,oe,0,j.length,0,oe.length)}t.compareIgnoreCase=O;function V(j,oe,be=0,Ee=j.length,Se=0,Oe=oe.length){for(;be<Ee&&Se<Oe;be++,Se++){let Ke=j.charCodeAt(be),xe=oe.charCodeAt(Se);if(Ke===xe)continue;if(Ke>=128||xe>=128)return w(j.toLowerCase(),oe.toLowerCase(),be,Ee,Se,Oe);se(Ke)&&(Ke-=32),se(xe)&&(xe-=32);const Te=Ke-xe;if(Te!==0)return Te}const $e=Ee-be,tt=Oe-Se;return $e<tt?-1:$e>tt?1:0}t.compareSubstringIgnoreCase=V;function ie(j){return j>=48&&j<=57}t.isAsciiDigit=ie;function se(j){return j>=97&&j<=122}t.isLowerAsciiLetter=se;function ae(j){return j>=65&&j<=90}t.isUpperAsciiLetter=ae;function de(j,oe){return j.length===oe.length&&V(j,oe)===0}t.equalsIgnoreCase=de;function ue(j,oe){const be=oe.length;return oe.length>j.length?!1:V(j,oe,0,be)===0}t.startsWithIgnoreCase=ue;function Z(j,oe){const be=Math.min(j.length,oe.length);let Ee;for(Ee=0;Ee<be;Ee++)if(j.charCodeAt(Ee)!==oe.charCodeAt(Ee))return Ee;return be}t.commonPrefixLength=Z;function Q(j,oe){const be=Math.min(j.length,oe.length);let Ee;const Se=j.length-1,Oe=oe.length-1;for(Ee=0;Ee<be;Ee++)if(j.charCodeAt(Se-Ee)!==oe.charCodeAt(Oe-Ee))return Ee;return be}t.commonSuffixLength=Q;function ve(j){return 55296<=j&&j<=56319}t.isHighSurrogate=ve;function pe(j){return 56320<=j&&j<=57343}t.isLowSurrogate=pe;function Me(j,oe){return(j-55296<<10)+(oe-56320)+65536}t.computeCodePoint=Me;function Re(j,oe,be){const Ee=j.charCodeAt(be);if(ve(Ee)&&be+1<oe){const Se=j.charCodeAt(be+1);if(pe(Se))return Me(Ee,Se)}return Ee}t.getNextCodePoint=Re;function le(j,oe){const be=j.charCodeAt(oe-1);if(pe(be)&&oe>1){const Ee=j.charCodeAt(oe-2);if(ve(Ee))return Me(Ee,be)}return be}class _{get offset(){return this.e}constructor(oe,be=0){this.c=oe,this.d=oe.length,this.e=be}setOffset(oe){this.e=oe}prevCodePoint(){const oe=le(this.c,this.e);return this.e-=oe>=65536?2:1,oe}nextCodePoint(){const oe=Re(this.c,this.d,this.e);return this.e+=oe>=65536?2:1,oe}eol(){return this.e>=this.d}}t.CodePointIterator=_;class ne{get offset(){return this.c.offset}constructor(oe,be=0){this.c=new _(oe,be)}nextGraphemeLength(){const oe=Pe.getInstance(),be=this.c,Ee=be.offset;let Se=oe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Oe=be.offset,$e=oe.getGraphemeBreakType(be.nextCodePoint());if(Ce(Se,$e)){be.setOffset(Oe);break}Se=$e}return be.offset-Ee}prevGraphemeLength(){const oe=Pe.getInstance(),be=this.c,Ee=be.offset;let Se=oe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Oe=be.offset,$e=oe.getGraphemeBreakType(be.prevCodePoint());if(Ce($e,Se)){be.setOffset(Oe);break}Se=$e}return Ee-be.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ne;function ee(j,oe){return new ne(j,oe).nextGraphemeLength()}t.nextCharLength=ee;function te(j,oe){return new ne(j,oe).prevGraphemeLength()}t.prevCharLength=te;function T(j,oe){oe>0&&pe(j.charCodeAt(oe))&&oe--;const be=oe+ee(j,oe);return[be-te(j,be),be]}t.getCharContainingOffset=T;function x(j){const oe=new ne(j);let be=0;for(;!oe.eol();)be++,oe.nextGraphemeLength();return be}t.charCount=x;let M;function f(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(j){return M||(M=f()),M.test(j)}t.containsRTL=C;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(j){return $.test(j)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(j){return t.UNUSUAL_LINE_TERMINATORS.test(j)}t.containsUnusualLineTerminators=F;function N(j){return j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}t.isFullWidthCharacter=N;function B(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129008||j>=129280&&j<=129535||j>=129648&&j<=129782}t.isEmojiImprecise=B;function k(j,oe){if(j.length<oe)return j;const be=/\b/g;let Ee=0;for(;be.test(j)&&!(j.length-be.lastIndex<oe);)Ee=be.lastIndex,be.lastIndex+=1;return j.substring(Ee).replace(/^\s/,"")}t.lcut=k;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function H(j){return j&&(j=j.replace(z,"")),j}t.removeAnsiEscapeCodes=H,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function U(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}t.startsWithUTF8BOM=U;function q(j){return U(j)?j.substr(1):j}t.stripUTF8BOM=q;function G(j,oe){if(!j||!oe||j.length<oe.length)return!1;const be=oe.length,Ee=j.toLowerCase();let Se=0,Oe=-1;for(;Se<be;){const $e=Ee.indexOf(oe[Se],Oe+1);if($e<0)return!1;Oe=$e,Se++}return!0}t.fuzzyContains=G;function re(j,oe=!1){return j?(oe&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}t.containsUppercaseCharacter=re;function he(j){return j.charAt(0).toUpperCase()+j.slice(1)}t.uppercaseFirstLetter=he;function we(j,oe=1){if(oe===0)return"";let be=-1;do be=j.indexOf(`
`,be+1),oe--;while(oe>0&&be>=0);return be===-1?j:(j[be-1]==="\r"&&be--,j.substr(0,be))}t.getNLines=we;function ye(j){return j=j%(2*26),j<26?String.fromCharCode(97+j):String.fromCharCode(65+j-26)}t.singleLetterHash=ye;function Le(j){return Pe.getInstance().getGraphemeBreakType(j)}t.getGraphemeBreakType=Le;function Ce(j,oe){return j===0?oe!==5&&oe!==7:j===2&&oe===3?!1:j===4||j===2||j===3||oe===4||oe===2||oe===3?!0:!(j===8&&(oe===8||oe===9||oe===11||oe===12)||(j===11||j===9)&&(oe===9||oe===10)||(j===12||j===10)&&oe===10||oe===5||oe===13||oe===7||j===1||j===13&&oe===14||j===6&&oe===6)}var De;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(De=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Ie()}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const be=this.d,Ee=be.length/3;let Se=1;for(;Se<=Ee;)if(oe<be[3*Se])Se=2*Se;else if(oe>be[3*Se+1])Se=2*Se+1;else return be[3*Se+2];return 0}}Pe.c=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(j,oe){if(j===0)return 0;const be=ze(j,oe);if(be!==void 0)return be;const Ee=new _(oe,j);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=je;function ze(j,oe){const be=new _(oe,j);let Ee=be.prevCodePoint();for(;Ue(Ee)||Ee===65039||Ee===8419;){if(be.offset===0)return;Ee=be.prevCodePoint()}if(!B(Ee))return;let Se=be.offset;return Se>0&&be.prevCodePoint()===8205&&(Se=be.offset),Se}function Ue(j){return 127995<=j&&j<=127999}var Ze;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),t.noBreakWhitespace="\xA0";class Ge{static getInstance(oe){return Ge.d.get(Array.from(oe))}static getLocales(){return Ge.e.value}constructor(oe){this.f=oe}isAmbiguous(oe){return this.f.has(oe)}getPrimaryConfusable(oe){return this.f.get(oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=Ge,Ge.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.d=new E.LRUCachedFunction(j=>{function oe(xe){const Te=new Map;for(let ce=0;ce<xe.length;ce+=2)Te.set(xe[ce],xe[ce+1]);return Te}function be(xe,Te){const ce=new Map(xe);for(const[Ae,Ne]of Te)ce.set(Ae,Ne);return ce}function Ee(xe,Te){if(!xe)return Te;const ce=new Map;for(const[Ae,Ne]of xe)Te.has(Ae)&&ce.set(Ae,Ne);return ce}const Se=i.c.value;let Oe=j.filter(xe=>!xe.startsWith("_")&&xe in Se);Oe.length===0&&(Oe=["_default"]);let $e;for(const xe of Oe){const Te=oe(Se[xe]);$e=Ee($e,Te)}const tt=oe(Se._common),Ke=be(tt,$e);return new Ge(Ke)}),Ge.e=new R.Lazy(()=>Object.keys(Ge.c.value).filter(j=>!j.startsWith("_"))),t.AmbiguousCharacters=Ge;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(oe){return Be.e().has(oe)}static get codePoints(){return Be.e()}}Be.d=void 0,t.InvisibleCharacters=Be}),define(ge[110],me([1,0,22,5,11,6]),function(J,t,E,R,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function v(h){return h===47||h===92}t.isPathSeparator=v;function D(h){return h.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=D;function g(h){return h.indexOf("/")===-1&&(h=D(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}t.toPosixPath=g;function l(h,b=E.posix.sep){if(!h)return"";const m=h.length,w=h.charCodeAt(0);if(v(w)){if(v(h.charCodeAt(1))&&!v(h.charCodeAt(2))){let V=3;const ie=V;for(;V<m&&!v(h.charCodeAt(V));V++);if(ie!==V&&!v(h.charCodeAt(V+1))){for(V+=1;V<m;V++)if(v(h.charCodeAt(V)))return h.slice(0,V+1).replace(/[\\/]/g,b)}}return b}else if(s(w)&&h.charCodeAt(1)===58)return v(h.charCodeAt(2))?h.slice(0,2)+b:h.slice(0,2);let O=h.indexOf("://");if(O!==-1){for(O+=3;O<m;O++)if(v(h.charCodeAt(O)))return h.slice(0,O+1)}return""}t.getRoot=l;function c(h){if(!R.isWindows||!h||h.length<5)return!1;let b=h.charCodeAt(0);if(b!==92||(b=h.charCodeAt(1),b!==92))return!1;let m=2;const w=m;for(;m<h.length&&(b=h.charCodeAt(m),b!==92);m++);return!(w===m||(b=h.charCodeAt(m+1),isNaN(b)||b===92))}t.isUNC=c;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(h,b=R.isWindows){const m=b?P:r;return!(!h||h.length===0||/^\s+$/.test(h)||(m.lastIndex=0,m.test(h))||b&&u.test(h)||h==="."||h===".."||b&&h[h.length-1]==="."||b&&h.length!==h.trim().length||h.length>255)}t.isValidBasename=e;function a(h,b,m){const w=h===b;return!m||w?w:!h||!b?!1:(0,i.equalsIgnoreCase)(h,b)}t.isEqual=a;function n(h,b,m,w=E.sep){if(h===b)return!0;if(!h||!b||b.length>h.length)return!1;if(m){if(!(0,i.startsWithIgnoreCase)(h,b))return!1;if(b.length===h.length)return!0;let V=b.length;return b.charAt(b.length-1)===w&&V--,h.charAt(V)===w}return b.charAt(b.length-1)!==w&&(b+=w),h.indexOf(b)===0}t.isEqualOrParent=n;function s(h){return h>=65&&h<=90||h>=97&&h<=122}t.isWindowsDriveLetter=s;function o(h,b){return R.isWindows&&h.endsWith(":")&&(h+=E.sep),(0,E.isAbsolute)(h)||(h=(0,E.join)(b,h)),h=(0,E.normalize)(h),R.isWindows?(h=(0,i.rtrim)(h,E.sep),h.endsWith(":")&&(h+=E.sep)):(h=(0,i.rtrim)(h,E.sep),h||(h=E.sep)),h}t.sanitizeFilePath=o;function y(h){const b=(0,E.normalize)(h);return R.isWindows?h.length>3?!1:A(b)&&(h.length===2||b.charCodeAt(2)===92):b===E.posix.sep}t.isRootOrDriveLetter=y;function A(h,b=R.isWindows){return b?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}t.hasDriveLetter=A;function S(h){return A(h)?h[0]:void 0}t.getDriveLetter=S;function d(h,b,m){return b.length>h.length?-1:h===b?0:(m&&(h=h.toLowerCase(),b=b.toLowerCase()),h.indexOf(b))}t.indexOfPath=d;function p(h){const b=h.split(":");let m,w,O;for(const V of b){const ie=Number(V);(0,W.isNumber)(ie)?w===void 0?w=ie:O===void 0&&(O=ie):m=m?[m,V].join(":"):V}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:w!==void 0?w:void 0,column:O!==void 0?O:w!==void 0?1:void 0}}t.parseLineAndColumnAware=p;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function I(h,b,m=8){let w="";for(let V=0;V<m;V++)w+=L.charAt(Math.floor(Math.random()*L.length));let O;return b?O=`${b}-${w}`:O=w,h?(0,E.join)(h,O):O}t.randomPath=I}),define(ge[32],me([1,0,74,11]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...H){return function(U,q){for(let G=0,re=H.length;G<re;G++){const he=H[G](U,q);if(he)return he}return null}}t.or=i,t.matchesStrictPrefix=W.bind(void 0,!1),t.matchesPrefix=W.bind(void 0,!0);function W(H,U,q){if(!q||q.length<U.length)return null;let G;return H?G=R.startsWithIgnoreCase(q,U):G=q.indexOf(U)===0,G?U.length>0?[{start:0,end:U.length}]:[]:null}function v(H,U){const q=U.toLowerCase().indexOf(H.toLowerCase());return q===-1?null:[{start:q,end:q+H.length}]}t.matchesContiguousSubString=v;function D(H,U){return g(H.toLowerCase(),U.toLowerCase(),0,0)}t.matchesSubString=D;function g(H,U,q,G){if(q===H.length)return[];if(G===U.length)return null;if(H[q]===U[G]){let re=null;return(re=g(H,U,q+1,G+1))?s({start:G,end:G+1},re):null}return g(H,U,q,G+1)}function l(H){return 97<=H&&H<=122}function c(H){return 65<=H&&H<=90}t.isUpper=c;function P(H){return 48<=H&&H<=57}function r(H){return H===32||H===9||H===10||H===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>u.add(H.charCodeAt(0)));function e(H){return r(H)||u.has(H)}function a(H,U){return H===U||e(H)&&e(U)}function n(H){return l(H)||c(H)||P(H)}function s(H,U){return U.length===0?U=[H]:H.end===U[0].start?U[0].start=H.start:U.unshift(H),U}function o(H,U){for(let q=U;q<H.length;q++){const G=H.charCodeAt(q);if(c(G)||P(G)||q>0&&!n(H.charCodeAt(q-1)))return q}return H.length}function y(H,U,q,G){if(q===H.length)return[];if(G===U.length)return null;if(H[q]!==U[G].toLowerCase())return null;{let re=null,he=G+1;for(re=y(H,U,q+1,G+1);!re&&(he=o(U,he))<U.length;)re=y(H,U,q+1,he),he++;return re===null?null:s({start:G,end:G+1},re)}}function A(H){let U=0,q=0,G=0,re=0,he=0;for(let De=0;De<H.length;De++)he=H.charCodeAt(De),c(he)&&U++,l(he)&&q++,n(he)&&G++,P(he)&&re++;const we=U/H.length,ye=q/H.length,Le=G/H.length,Ce=re/H.length;return{upperPercent:we,lowerPercent:ye,alphaPercent:Le,numericPercent:Ce}}function S(H){const{upperPercent:U,lowerPercent:q}=H;return q===0&&U>.6}function d(H){const{upperPercent:U,lowerPercent:q,alphaPercent:G,numericPercent:re}=H;return q>.2&&U<.8&&G>.6&&re<.2}function p(H){let U=0,q=0,G=0,re=0;for(let he=0;he<H.length;he++)G=H.charCodeAt(he),c(G)&&U++,l(G)&&q++,r(G)&&re++;return(U===0||q===0)&&re===0?H.length<=30:U<=5}function L(H,U){if(!U||(U=U.trim(),U.length===0)||!p(H)||U.length>60)return null;const q=A(U);if(!d(q)){if(!S(q))return null;U=U.toLowerCase()}let G=null,re=0;for(H=H.toLowerCase();re<U.length&&(G=y(H,U,0,re))===null;)re=o(U,re+1);return G}t.matchesCamelCase=L;function I(H,U,q=!1){if(!U||U.length===0)return null;let G=null,re=0;for(H=H.toLowerCase(),U=U.toLowerCase();re<U.length&&(G=h(H,U,0,re,q))===null;)re=b(U,re+1);return G}t.matchesWords=I;function h(H,U,q,G,re){if(q===H.length)return[];if(G===U.length)return null;if(a(H.charCodeAt(q),U.charCodeAt(G))){let he=null,we=G+1;if(he=h(H,U,q+1,G+1,re),!re)for(;!he&&(we=b(U,we))<U.length;)he=h(H,U,q+1,we,re),we++;return he?H.charCodeAt(q)!==U.charCodeAt(G)?he:s({start:G,end:G+1},he):null}else return null}function b(H,U){for(let q=U;q<H.length;q++)if(e(H.charCodeAt(q))||q>0&&e(H.charCodeAt(q-1)))return q;return H.length}const m=i(t.matchesPrefix,L,v),w=i(t.matchesPrefix,L,D),O=new E.LRUCache(1e4);function V(H,U,q=!1){if(typeof H!="string"||typeof U!="string")return null;let G=O.get(H);G||(G=new RegExp(R.convertSimple2RegExpPattern(H),"i"),O.set(H,G));const re=G.exec(U);return re?[{start:re.index,end:re.index+re[0].length}]:q?w(H,U):m(H,U)}t.matchesFuzzy=V;function ie(H,U){const q=$(H,H.toLowerCase(),0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?ae(q):null}t.matchesFuzzy2=ie;function se(H,U,q,G,re,he){const we=Math.min(13,H.length);for(;q<we;q++){const ye=$(H,U,q,G,re,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,he]}t.anyScore=se;function ae(H){if(typeof H>"u")return[];const U=[],q=H[1];for(let G=H.length-1;G>1;G--){const re=H[G]+q,he=U[U.length-1];he&&he.end===re?he.end=re+1:U.push({start:re,end:re+1})}return U}t.createMatches=ae;const de=128;function ue(){const H=[],U=[];for(let q=0;q<=de;q++)U[q]=0;for(let q=0;q<=de;q++)H.push(U.slice(0));return H}function Z(H){const U=[];for(let q=0;q<=H;q++)U[q]=0;return U}const Q=Z(2*de),ve=Z(2*de),pe=ue(),Me=ue(),Re=ue(),le=!1;function _(H,U,q,G,re){function he(ye,Le,Ce=" "){for(;ye.length<Le;)ye=Ce+ye;return ye}let we=` |   |${G.split("").map(ye=>he(ye,3)).join("|")}
`;for(let ye=0;ye<=q;ye++)ye===0?we+=" |":we+=`${U[ye-1]}|`,we+=H[ye].slice(0,re+1).map(Le=>he(Le.toString(),3)).join("|")+`
`;return we}function ne(H,U,q,G){H=H.substr(U),q=q.substr(G),console.log(_(Me,H,H.length,q,q.length)),console.log(_(Re,H,H.length,q,q.length)),console.log(_(pe,H,H.length,q,q.length))}function ee(H,U){if(U<0||U>=H.length)return!1;const q=H.codePointAt(U);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(q)}}function te(H,U){if(U<0||U>=H.length)return!1;switch(H.charCodeAt(U)){case 32:case 9:return!0;default:return!1}}function T(H,U,q){return U[H]!==q[H]}function x(H,U,q,G,re,he,we=!1){for(;U<q&&re<he;)H[U]===G[re]&&(we&&(Q[U]=re),U+=1),re+=1;return U===q}t.isPatternInWord=x;var M;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(M||(M={}));var f;(function(H){H.Default=[-100,0];function U(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}H.isDefault=U})(f=t.FuzzyScore||(t.FuzzyScore={}));class C{constructor(U,q){this.firstMatchCanBeWeak=U,this.boostFullMatch=q}}C.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},t.FuzzyScoreOptions=C;function $(H,U,q,G,re,he,we=C.default){const ye=H.length>de?de:H.length,Le=G.length>de?de:G.length;if(q>=ye||he>=Le||ye-q>Le-he||!x(U,q,ye,re,he,Le,!0))return;Y(ye,Le,q,he,U,re);let Ce=1,De=1,Pe=q,Ie=he;const je=[!1];for(Ce=1,Pe=q;Pe<ye;Ce++,Pe++){const Be=Q[Pe],j=ve[Pe],oe=Pe+1<ye?ve[Pe+1]:Le;for(De=Be-he+1,Ie=Be;Ie<oe;De++,Ie++){let be=Number.MIN_SAFE_INTEGER,Ee=!1;Ie<=j&&(be=F(H,U,Pe,q,G,re,Ie,Le,he,pe[Ce-1][De-1]===0,je));let Se=0;be!==Number.MAX_SAFE_INTEGER&&(Ee=!0,Se=be+Me[Ce-1][De-1]);const Oe=Ie>Be,$e=Oe?Me[Ce][De-1]+(pe[Ce][De-1]>0?-5:0):0,tt=Ie>Be+1&&pe[Ce][De-1]>0,Ke=tt?Me[Ce][De-2]+(pe[Ce][De-2]>0?-5:0):0;if(tt&&(!Oe||Ke>=$e)&&(!Ee||Ke>=Se))Me[Ce][De]=Ke,Re[Ce][De]=3,pe[Ce][De]=0;else if(Oe&&(!Ee||$e>=Se))Me[Ce][De]=$e,Re[Ce][De]=2,pe[Ce][De]=0;else if(Ee)Me[Ce][De]=Se,Re[Ce][De]=1,pe[Ce][De]=pe[Ce-1][De-1]+1;else throw new Error("not possible")}}if(le&&ne(H,q,G,he),!je[0]&&!we.firstMatchCanBeWeak)return;Ce--,De--;const ze=[Me[Ce][De],he];let Ue=0,Ze=0;for(;Ce>=1;){let Be=De;do{const j=Re[Ce][Be];if(j===3)Be=Be-2;else if(j===2)Be=Be-1;else break}while(Be>=1);Ue>1&&U[q+Ce-1]===re[he+De-1]&&!T(Be+he-1,G,re)&&Ue+1>pe[Ce][Be]&&(Be=De),Be===De?Ue++:Ue=1,Ze||(Ze=Be),Ce--,De=Be-1,ze.push(De)}Le===ye&&we.boostFullMatch&&(ze[0]+=2);const Ge=Ze-ye;return ze[0]-=Ge,ze}t.fuzzyScore=$;function Y(H,U,q,G,re,he){let we=H-1,ye=U-1;for(;we>=q&&ye>=G;)re[we]===he[ye]&&(ve[we]=ye,we--),ye--}function F(H,U,q,G,re,he,we,ye,Le,Ce,De){if(U[q]!==he[we])return Number.MIN_SAFE_INTEGER;let Pe=1,Ie=!1;return we===q-G?Pe=H[q]===re[we]?7:5:T(we,re,he)&&(we===0||!T(we-1,re,he))?(Pe=H[q]===re[we]?7:5,Ie=!0):ee(he,we)&&(we===0||!ee(he,we-1))?Pe=5:(ee(he,we-1)||te(he,we-1))&&(Pe=5,Ie=!0),Pe>1&&q===G&&(De[0]=!0),Ie||(Ie=T(we,re,he)||ee(he,we-1)||te(he,we-1)),q===G?we>Le&&(Pe-=Ie?3:5):Ce?Pe+=Ie?2:0:Pe+=Ie?0:1,we+1===ye&&(Pe-=Ie?3:5),Pe}function N(H,U,q,G,re,he,we){return k(H,U,q,G,re,he,!0,we)}t.fuzzyScoreGracefulAggressive=N;function B(H,U,q,G,re,he,we){return k(H,U,q,G,re,he,!1,we)}t.fuzzyScoreGraceful=B;function k(H,U,q,G,re,he,we,ye){let Le=$(H,U,q,G,re,he,ye);if(Le&&!we)return Le;if(H.length>=3){const Ce=Math.min(7,H.length-1);for(let De=q+1;De<Ce;De++){const Pe=z(H,De);if(Pe){const Ie=$(Pe,Pe.toLowerCase(),q,G,re,he,ye);Ie&&(Ie[0]-=3,(!Le||Ie[0]>Le[0])&&(Le=Ie))}}}return Le}function z(H,U){if(U+1>=H.length)return;const q=H[U],G=H[U+1];if(q!==G)return H.slice(0,U)+G+q+H.slice(U+2)}}),define(ge[111],me([1,0,11]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function R(s){return i(s,0)}t.hash=R;function i(s,o){switch(typeof s){case"object":return s===null?W(349,o):Array.isArray(s)?g(s,o):l(s,o);case"string":return D(s,o);case"boolean":return v(s,o);case"number":return W(s,o);case"undefined":return W(937,o);default:return W(617,o)}}t.doHash=i;function W(s,o){return(o<<5)-o+s|0}t.numberHash=W;function v(s,o){return W(s?433:863,o)}function D(s,o){o=W(149417,o);for(let y=0,A=s.length;y<A;y++)o=W(s.charCodeAt(y),o);return o}t.stringHash=D;function g(s,o){return o=W(104579,o),s.reduce((y,A)=>i(A,y),o)}function l(s,o){return o=W(181387,o),Object.keys(s).sort().reduce((y,A)=>(y=D(A,y),i(s[A],y)),o)}class c{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=i(o,this.g),this.g}}t.Hasher=c;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(s,o,y=32){const A=y-o,S=~((1<<A)-1);return(s<<o|(S&s)>>>A)>>>0}function u(s,o=0,y=s.byteLength,A=0){for(let S=0;S<y;S++)s[o+S]=A}function e(s,o,y="0"){for(;s.length<o;)s=y+s;return s}function a(s,o=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(y=>y.toString(16).padStart(2,"0")).join(""):e((s>>>0).toString(16),o/4)}t.toHexString=a;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const y=o.length;if(y===0)return;const A=this.p;let S=this.r,d=this.u,p,L;for(d!==0?(p=d,L=-1,d=0):(p=o.charCodeAt(0),L=0);;){let I=p;if(E.isHighSurrogate(p))if(L+1<y){const h=o.charCodeAt(L+1);E.isLowSurrogate(h)?(L++,I=E.computeCodePoint(p,h)):I=65533}else{d=p;break}else E.isLowSurrogate(p)&&(I=65533);if(S=this.w(A,S,I),L++,L<y)p=o.charCodeAt(L);else break}this.r=S,this.u=d}w(o,y,A){return A<128?o[y++]=A:A<2048?(o[y++]=192|(A&1984)>>>6,o[y++]=128|(A&63)>>>0):A<65536?(o[y++]=224|(A&61440)>>>12,o[y++]=128|(A&4032)>>>6,o[y++]=128|(A&63)>>>0):(o[y++]=240|(A&1835008)>>>18,o[y++]=128|(A&258048)>>>12,o[y++]=128|(A&4032)>>>6,o[y++]=128|(A&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=n.g,y=this.q;for(let m=0;m<64;m+=4)o.setUint32(m,y.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)o.setUint32(m,r(o.getUint32(m-12,!1)^o.getUint32(m-32,!1)^o.getUint32(m-56,!1)^o.getUint32(m-64,!1),1),!1);let A=this.h,S=this.l,d=this.m,p=this.n,L=this.o,I,h,b;for(let m=0;m<80;m++)m<20?(I=S&d|~S&p,h=1518500249):m<40?(I=S^d^p,h=1859775393):m<60?(I=S&d|S&p|d&p,h=2400959708):(I=S^d^p,h=3395469782),b=r(A,5)+I+L+h+o.getUint32(m*4,!1)&4294967295,L=p,p=d,d=r(S,30),S=A,A=b;this.h=this.h+A&4294967295,this.l=this.l+S&4294967295,this.m=this.m+d&4294967295,this.n=this.n+p&4294967295,this.o=this.o+L&4294967295}}n.g=new DataView(new ArrayBuffer(320)),t.StringSHA1=n}),define(ge[112],me([1,0,70,111]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,u=new Int32Array(r.length);for(let e=0,a=r.length;e<a;e++)u[e]=r.charCodeAt(e);return u}}t.StringDiffSequence=i;function W(P,r,u){return new c(new i(P),new i(r)).ComputeDiff(u).changes}t.stringDiff=W;class v{static Assert(r,u){if(!r)throw new Error(u)}}class D{static Copy(r,u,e,a,n){for(let s=0;s<n;s++)e[a+s]=r[u+s]}static Copy2(r,u,e,a,n){for(let s=0;s<n;s++)e[a+s]=r[u+s]}}var g;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(g||(g={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,u){this.b=Math.min(this.b,r),this.c=Math.min(this.c,u),this.d++}AddModifiedElement(r,u){this.b=Math.min(this.b,r),this.c=Math.min(this.c,u),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(r,u,e=null){this.a=e,this.b=r,this.c=u;const[a,n,s]=c.o(r),[o,y,A]=c.o(u);this.d=s&&A,this.e=a,this.f=n,this.g=o,this.h=y,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const u=r.getElements();if(c.n(u)){const e=new Int32Array(u.length);for(let a=0,n=u.length;a<n;a++)e[a]=(0,R.stringHash)(u[a],0);return[u,e,!0]}return u instanceof Int32Array?[[],u,!1]:[[],new Int32Array(u),!1]}p(r,u){return this.f[r]!==this.h[u]?!1:this.d?this.e[r]===this.g[u]:!0}q(r,u){if(!this.p(r,u))return!1;const e=c.r(this.b,r),a=c.r(this.c,u);return e===a}static r(r,u){return typeof r.getStrictElement=="function"?r.getStrictElement(u):null}s(r,u){return this.f[r]!==this.f[u]?!1:this.d?this.e[r]===this.e[u]:!0}u(r,u){return this.h[r]!==this.h[u]?!1:this.d?this.g[r]===this.g[u]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,u,e,a,n){const s=[!1];let o=this.w(r,u,e,a,s);return n&&(o=this.z(o)),{quitEarly:s[0],changes:o}}w(r,u,e,a,n){for(n[0]=!1;r<=u&&e<=a&&this.p(r,e);)r++,e++;for(;u>=r&&a>=e&&this.p(u,a);)u--,a--;if(r>u||e>a){let d;return e<=a?(v.Assert(r===u+1,"originalStart should only be one more than originalEnd"),d=[new E.DiffChange(r,0,e,a-e+1)]):r<=u?(v.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),d=[new E.DiffChange(r,u-r+1,e,0)]):(v.Assert(r===u+1,"originalStart should only be one more than originalEnd"),v.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const s=[0],o=[0],y=this.y(r,u,e,a,s,o,n),A=s[0],S=o[0];if(y!==null)return y;if(!n[0]){const d=this.w(r,A,e,S,n);let p=[];return n[0]?p=[new E.DiffChange(A+1,u-(A+1)+1,S+1,a-(S+1)+1)]:p=this.w(A+1,u,S+1,a,n),this.H(d,p)}return[new E.DiffChange(r,u-r+1,e,a-e+1)]}x(r,u,e,a,n,s,o,y,A,S,d,p,L,I,h,b,m,w){let O=null,V=null,ie=new l,se=u,ae=e,de=L[0]-b[0]-a,ue=-1073741824,Z=this.k.length-1;do{const Q=de+r;Q===se||Q<ae&&A[Q-1]<A[Q+1]?(d=A[Q+1],I=d-de-a,d<ue&&ie.MarkNextChange(),ue=d,ie.AddModifiedElement(d+1,I),de=Q+1-r):(d=A[Q-1]+1,I=d-de-a,d<ue&&ie.MarkNextChange(),ue=d-1,ie.AddOriginalElement(d,I+1),de=Q-1-r),Z>=0&&(A=this.k[Z],r=A[0],se=1,ae=A.length-1)}while(--Z>=-1);if(O=ie.getReverseChanges(),w[0]){let Q=L[0]+1,ve=b[0]+1;if(O!==null&&O.length>0){const pe=O[O.length-1];Q=Math.max(Q,pe.getOriginalEnd()),ve=Math.max(ve,pe.getModifiedEnd())}V=[new E.DiffChange(Q,p-Q+1,ve,h-ve+1)]}else{ie=new l,se=s,ae=o,de=L[0]-b[0]-y,ue=1073741824,Z=m?this.m.length-1:this.m.length-2;do{const Q=de+n;Q===se||Q<ae&&S[Q-1]>=S[Q+1]?(d=S[Q+1]-1,I=d-de-y,d>ue&&ie.MarkNextChange(),ue=d+1,ie.AddOriginalElement(d+1,I+1),de=Q+1-n):(d=S[Q-1],I=d-de-y,d>ue&&ie.MarkNextChange(),ue=d,ie.AddModifiedElement(d+1,I+1),de=Q-1-n),Z>=0&&(S=this.m[Z],n=S[0],se=1,ae=S.length-1)}while(--Z>=-1);V=ie.getChanges()}return this.H(O,V)}y(r,u,e,a,n,s,o){let y=0,A=0,S=0,d=0,p=0,L=0;r--,e--,n[0]=0,s[0]=0,this.k=[],this.m=[];const I=u-r+(a-e),h=I+1,b=new Int32Array(h),m=new Int32Array(h),w=a-e,O=u-r,V=r-e,ie=u-a,ae=(O-w)%2===0;b[w]=r,m[O]=u,o[0]=!1;for(let de=1;de<=I/2+1;de++){let ue=0,Z=0;S=this.J(w-de,de,w,h),d=this.J(w+de,de,w,h);for(let ve=S;ve<=d;ve+=2){ve===S||ve<d&&b[ve-1]<b[ve+1]?y=b[ve+1]:y=b[ve-1]+1,A=y-(ve-w)-V;const pe=y;for(;y<u&&A<a&&this.p(y+1,A+1);)y++,A++;if(b[ve]=y,y+A>ue+Z&&(ue=y,Z=A),!ae&&Math.abs(ve-O)<=de-1&&y>=m[ve])return n[0]=y,s[0]=A,pe<=m[ve]&&1447>0&&de<=1447+1?this.x(w,S,d,V,O,p,L,ie,b,m,y,u,n,A,a,s,ae,o):null}const Q=(ue-r+(Z-e)-de)/2;if(this.a!==null&&!this.a(ue,Q))return o[0]=!0,n[0]=ue,s[0]=Z,Q>0&&1447>0&&de<=1447+1?this.x(w,S,d,V,O,p,L,ie,b,m,y,u,n,A,a,s,ae,o):(r++,e++,[new E.DiffChange(r,u-r+1,e,a-e+1)]);p=this.J(O-de,de,O,h),L=this.J(O+de,de,O,h);for(let ve=p;ve<=L;ve+=2){ve===p||ve<L&&m[ve-1]>=m[ve+1]?y=m[ve+1]-1:y=m[ve-1],A=y-(ve-O)-ie;const pe=y;for(;y>r&&A>e&&this.p(y,A);)y--,A--;if(m[ve]=y,ae&&Math.abs(ve-w)<=de&&y<=b[ve])return n[0]=y,s[0]=A,pe>=b[ve]&&1447>0&&de<=1447+1?this.x(w,S,d,V,O,p,L,ie,b,m,y,u,n,A,a,s,ae,o):null}if(de<=1447){let ve=new Int32Array(d-S+2);ve[0]=w-S+1,D.Copy2(b,S,ve,1,d-S+1),this.k.push(ve),ve=new Int32Array(L-p+2),ve[0]=O-p+1,D.Copy2(m,p,ve,1,L-p+1),this.m.push(ve)}}return this.x(w,S,d,V,O,p,L,ie,b,m,y,u,n,A,a,s,ae,o)}z(r){for(let u=0;u<r.length;u++){const e=r[u],a=u<r.length-1?r[u+1].originalStart:this.f.length,n=u<r.length-1?r[u+1].modifiedStart:this.h.length,s=e.originalLength>0,o=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<n&&(!s||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!o||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const A=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!A)break;e.originalStart++,e.modifiedStart++}const y=[null];if(u<r.length-1&&this.I(r[u],r[u+1],y)){r[u]=y[0],r.splice(u+1,1),u--;continue}}for(let u=r.length-1;u>=0;u--){const e=r[u];let a=0,n=0;if(u>0){const d=r[u-1];a=d.originalStart+d.originalLength,n=d.modifiedStart+d.modifiedLength}const s=e.originalLength>0,o=e.modifiedLength>0;let y=0,A=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let d=1;;d++){const p=e.originalStart-d,L=e.modifiedStart-d;if(p<a||L<n||s&&!this.s(p,p+e.originalLength)||o&&!this.u(L,L+e.modifiedLength))break;const h=(p===a&&L===n?5:0)+this.G(p,e.originalLength,L,e.modifiedLength);h>A&&(A=h,y=d)}e.originalStart-=y,e.modifiedStart-=y;const S=[null];if(u>0&&this.I(r[u-1],r[u],S)){r[u-1]=S[0],r.splice(u,1),u++;continue}}if(this.d)for(let u=1,e=r.length;u<e;u++){const a=r[u-1],n=r[u],s=n.originalStart-a.originalStart-a.originalLength,o=a.originalStart,y=n.originalStart+n.originalLength,A=y-o,S=a.modifiedStart,d=n.modifiedStart+n.modifiedLength,p=d-S;if(s<5&&A<20&&p<20){const L=this.A(o,A,S,p,s);if(L){const[I,h]=L;(I!==a.originalStart+a.originalLength||h!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=I-a.originalStart,a.modifiedLength=h-a.modifiedStart,n.originalStart=I+s,n.modifiedStart=h+s,n.originalLength=y-n.originalStart,n.modifiedLength=d-n.modifiedStart)}}}return r}A(r,u,e,a,n){if(u<n||a<n)return null;const s=r+u-n+1,o=e+a-n+1;let y=0,A=0,S=0;for(let d=r;d<s;d++)for(let p=e;p<o;p++){const L=this.B(d,p,n);L>0&&L>y&&(y=L,A=d,S=p)}return y>0?[A,S]:null}B(r,u,e){let a=0;for(let n=0;n<e;n++){if(!this.p(r+n,u+n))return 0;a+=this.e[r+n].length}return a}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,u){if(this.C(r)||this.C(r-1))return!0;if(u>0){const e=r+u;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,u){if(this.E(r)||this.E(r-1))return!0;if(u>0){const e=r+u;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,u,e,a){const n=this.D(r,u)?1:0,s=this.F(e,a)?1:0;return n+s}H(r,u){const e=[];if(r.length===0||u.length===0)return u.length>0?u:r;if(this.I(r[r.length-1],u[0],e)){const a=new Array(r.length+u.length-1);return D.Copy(r,0,a,0,r.length-1),a[r.length-1]=e[0],D.Copy(u,1,a,r.length,u.length-1),a}else{const a=new Array(r.length+u.length);return D.Copy(r,0,a,0,r.length),D.Copy(u,0,a,r.length,u.length),a}}I(r,u,e){if(v.Assert(r.originalStart<=u.originalStart,"Left change is not less than or equal to right change"),v.Assert(r.modifiedStart<=u.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=u.originalStart||r.modifiedStart+r.modifiedLength>=u.modifiedStart){const a=r.originalStart;let n=r.originalLength;const s=r.modifiedStart;let o=r.modifiedLength;return r.originalStart+r.originalLength>=u.originalStart&&(n=u.originalStart+u.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=u.modifiedStart&&(o=u.modifiedStart+u.modifiedLength-r.modifiedStart),e[0]=new E.DiffChange(a,n,s,o),!0}else return e[0]=null,!1}J(r,u,e,a){if(r>=0&&r<a)return r;const n=e,s=a-e-1,o=u%2===0;if(r<0){const y=n%2===0;return o===y?0:1}else{const y=s%2===0;return o===y?a-1:a-2}}}t.LcsDiff=c}),define(ge[33],me([1,0,32,11,17]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const W="$(",v=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${v.source}`,"g");function g(s){return s.replace(D,(o,y)=>y?o:`\\${o}`)}t.escapeIcons=g;const l=new RegExp(`\\\\${v.source}`,"g");function c(s){return s.replace(l,o=>`\\${o}`)}t.markdownEscapeEscapedIcons=c;const P=new RegExp(`(\\s)?(\\\\)?${v.source}(\\s)?`,"g");function r(s){return s.indexOf(W)===-1?s:s.replace(P,(o,y,A,S)=>A?o:y||S||"")}t.stripIcons=r;function u(s){return s?s.replace(/\$\((.*?)\)/g,(o,y)=>` ${y} `).trim():""}t.getCodiconAriaLabel=u;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(s){e.lastIndex=0;let o="";const y=[];let A=0;for(;;){const S=e.lastIndex,d=e.exec(s),p=s.substring(S,d?.index);if(p.length>0){o+=p;for(let L=0;L<p.length;L++)y.push(A)}if(!d)break;A+=d[0].length}return{text:o,iconOffsets:y}}t.parseLabelWithIcons=a;function n(s,o,y=!1){const{text:A,iconOffsets:S}=o;if(!S||S.length===0)return(0,E.matchesFuzzy)(s,A,y);const d=(0,R.ltrim)(A," "),p=A.length-d.length,L=(0,E.matchesFuzzy)(s,d,y);if(L)for(const I of L){const h=S[I.start+p]+p;I.start+=h,I.end+=h}return L}t.matchesFuzzyIconAware=n}),define(ge[113],me([1,0,13,11]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const e=u.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.StringIterator=i;class W{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,R.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=W;class v{constructor(u=!0,e=!0){this.f=u,this.g=e}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let e=u.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,R.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=v;var D;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(D||(D={}));class g{constructor(u,e){this.f=u,this.g=e,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new v(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,R.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=g;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(c||(c={}));class P{static forUris(u=()=>!1,e=()=>!1){return new P(new g(u,e))}static forPaths(u=!1){return new P(new v(void 0,!u))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new W)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,e){if(e){const a=e.slice(0);(0,E.shuffle)(a);for(const n of a)this.set(n,u)}else{const a=u.slice(0);(0,E.shuffle)(a);for(const n of a)this.set(n[0],n[1])}}set(u,e){const a=this.b.reset(u);let n;this.c||(this.c=new l,this.c.segment=a.value());const s=[];for(n=this.c;;){const y=a.cmp(n.segment);if(y>0)n.left||(n.left=new l,n.left.segment=a.value()),s.push([-1,n]),n=n.left;else if(y<0)n.right||(n.right=new l,n.right.segment=a.value()),s.push([1,n]),n=n.right;else if(a.hasNext())a.next(),n.mid||(n.mid=new l,n.mid.segment=a.value()),s.push([0,n]),n=n.mid;else break}const o=n.value;n.value=e,n.key=u;for(let y=s.length-1;y>=0;y--){const A=s[y][1];A.updateHeight();const S=A.balanceFactor();if(S<-1||S>1){const d=s[y][0],p=s[y+1][0];if(d===1&&p===1)s[y][1]=A.rotateLeft();else if(d===-1&&p===-1)s[y][1]=A.rotateRight();else if(d===1&&p===-1)A.right=s[y+1][1]=s[y+1][1].rotateRight(),s[y][1]=A.rotateLeft();else if(d===-1&&p===1)A.left=s[y+1][1]=s[y+1][1].rotateLeft(),s[y][1]=A.rotateRight();else throw new Error;if(y>0)switch(s[y-1][0]){case-1:s[y-1][1].left=s[y][1];break;case 1:s[y-1][1].right=s[y][1];break;case 0:s[y-1][1].mid=s[y][1];break}else this.c=s[0][1]}}return o}get(u){return this.d(u)?.value}d(u){const e=this.b.reset(u);let a=this.c;for(;a;){const n=e.cmp(a.segment);if(n>0)a=a.left;else if(n<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(u){const e=this.d(u);return!(e?.value===void 0&&e?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,e){const a=this.b.reset(u),n=[];let s=this.c;for(;s;){const o=a.cmp(s.segment);if(o>0)n.push([-1,s]),s=s.left;else if(o<0)n.push([1,s]),s=s.right;else if(a.hasNext())a.next(),n.push([0,s]),s=s.mid;else break}if(!!s){if(e?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const o=this.f(s.right);if(o.key){const{key:y,value:A,segment:S}=o;this.e(o.key,!1),s.key=y,s.value=A,s.segment=S}}else{const o=s.left??s.right;if(n.length>0){const[y,A]=n[n.length-1];switch(y){case-1:A.left=o;break;case 0:A.mid=o;break;case 1:A.right=o;break}}else this.c=o}for(let o=n.length-1;o>=0;o--){const y=n[o][1];y.updateHeight();const A=y.balanceFactor();if(A>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),n[o][1]=y.rotateLeft()):A<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),n[o][1]=y.rotateRight()),o>0)switch(n[o-1][0]){case-1:n[o-1][1].left=n[o][1];break;case 1:n[o-1][1].right=n[o][1];break;case 0:n[o-1][1].mid=n[o][1];break}else this.c=n[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const e=this.b.reset(u);let a=this.c,n;for(;a;){const s=e.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(e.hasNext())e.next(),n=a.value||n,a=a.mid;else break}return a&&a.value||n}findSuperstr(u){return this.g(u,!1)}g(u,e){const a=this.b.reset(u);let n=this.c;for(;n;){const s=a.cmp(n.segment);if(s>0)n=n.left;else if(s<0)n=n.right;else if(a.hasNext())a.next(),n=n.mid;else return n.mid?this.h(n.mid):e?n.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[e,a]of this)u(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const e=[];return this.j(u,e),e[Symbol.iterator]()}j(u,e){!u||(u.left&&this.j(u.left,e),u.value&&e.push([u.key,u.value]),u.mid&&this.j(u.mid,e),u.right&&this.j(u.right,e))}_isBalanced(){const u=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:u(e.left)&&u(e.right)};return u(this.c)}}t.TernarySearchTree=P}),define(ge[15],me([1,0,22,5]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,W=/^\//,v=/^\/\//;function D(L,I){if(!L.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!W.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(L,I){return!L&&!I?"file":L}function l(L,I){switch(L){case"https":case"http":case"file":I?I[0]!==P&&(I=P+I):I=P;break}return I}const c="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(I){return I instanceof u?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,h,b,m,w,O=!1){typeof I=="object"?(this.scheme=I.scheme||c,this.authority=I.authority||c,this.path=I.path||c,this.query=I.query||c,this.fragment=I.fragment||c):(this.scheme=g(I,O),this.authority=h||c,this.path=l(this.scheme,b||c),this.query=m||c,this.fragment=w||c,D(this,O))}get fsPath(){return y(this,!1)}with(I){if(!I)return this;let{scheme:h,authority:b,path:m,query:w,fragment:O}=I;return h===void 0?h=this.scheme:h===null&&(h=c),b===void 0?b=this.authority:b===null&&(b=c),m===void 0?m=this.path:m===null&&(m=c),w===void 0?w=this.query:w===null&&(w=c),O===void 0?O=this.fragment:O===null&&(O=c),h===this.scheme&&b===this.authority&&m===this.path&&w===this.query&&O===this.fragment?this:new a(h,b,m,w,O)}static parse(I,h=!1){const b=r.exec(I);return b?new a(b[2]||c,p(b[4]||c),p(b[5]||c),p(b[7]||c),p(b[9]||c),h):new a(c,c,c,c,c)}static file(I){let h=c;if(R.isWindows&&(I=I.replace(/\\/g,P)),I[0]===P&&I[1]===P){const b=I.indexOf(P,2);b===-1?(h=I.substring(2),I=P):(h=I.substring(2,b),I=I.substring(b)||P)}return new a("file",h,I,c,c)}static from(I){const h=new a(I.scheme,I.authority,I.path,I.query,I.fragment);return D(h,!0),h}static joinPath(I,...h){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return R.isWindows&&I.scheme==="file"?b=u.file(E.win32.join(y(I,!0),...h)).path:b=E.posix.join(I.path,...h),I.with({path:b})}toString(I=!1){return A(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof u)return I;{const h=new a(I);return h._formatted=I.external,h._fsPath=I._sep===e?I.fsPath:null,h}}else return I}}t.URI=u;const e=R.isWindows?1:void 0;class a extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(I=!1){return I?A(this,!0):(this._formatted||(this._formatted=A(this,!1)),this._formatted)}toJSON(){const I={$mid:1};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=e),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(L,I,h){let b,m=-1;for(let w=0;w<L.length;w++){const O=L.charCodeAt(w);if(O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57||O===45||O===46||O===95||O===126||I&&O===47||h&&O===91||h&&O===93||h&&O===58)m!==-1&&(b+=encodeURIComponent(L.substring(m,w)),m=-1),b!==void 0&&(b+=L.charAt(w));else{b===void 0&&(b=L.substr(0,w));const V=n[O];V!==void 0?(m!==-1&&(b+=encodeURIComponent(L.substring(m,w)),m=-1),b+=V):m===-1&&(m=w)}}return m!==-1&&(b+=encodeURIComponent(L.substring(m))),b!==void 0?b:L}function o(L){let I;for(let h=0;h<L.length;h++){const b=L.charCodeAt(h);b===35||b===63?(I===void 0&&(I=L.substr(0,h)),I+=n[b]):I!==void 0&&(I+=L[h])}return I!==void 0?I:L}function y(L,I){let h;return L.authority&&L.path.length>1&&L.scheme==="file"?h=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?I?h=L.path.substr(1):h=L.path[1].toLowerCase()+L.path.substr(2):h=L.path,R.isWindows&&(h=h.replace(/\//g,"\\")),h}t.uriToFsPath=y;function A(L,I){const h=I?o:s;let b="",{scheme:m,authority:w,path:O,query:V,fragment:ie}=L;if(m&&(b+=m,b+=":"),(w||m==="file")&&(b+=P,b+=P),w){let se=w.indexOf("@");if(se!==-1){const ae=w.substr(0,se);w=w.substr(se+1),se=ae.lastIndexOf(":"),se===-1?b+=h(ae,!1,!1):(b+=h(ae.substr(0,se),!1,!1),b+=":",b+=h(ae.substr(se+1),!1,!0)),b+="@"}w=w.toLowerCase(),se=w.lastIndexOf(":"),se===-1?b+=h(w,!1,!0):(b+=h(w.substr(0,se),!1,!0),b+=w.substr(se))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const se=O.charCodeAt(1);se>=65&&se<=90&&(O=`/${String.fromCharCode(se+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const se=O.charCodeAt(0);se>=65&&se<=90&&(O=`${String.fromCharCode(se+32)}:${O.substr(2)}`)}b+=h(O,!0,!1)}return V&&(b+="?",b+=h(V,!1,!1)),ie&&(b+="#",b+=I?ie:s(ie,!1,!1)),b}function S(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+S(L.substr(3)):L}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function p(L){return L.match(d)?L.replace(d,I=>S(I)):L}}),define(ge[49],me([1,0,30,11,15]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function W(l){return JSON.stringify(l,D)}t.stringify=W;function v(l){let c=JSON.parse(l);return c=g(c),c}t.parse=v;function D(l,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:(0,R.regExpFlags)(c)}:c}function g(l,c=0){if(!l||c>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return i.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let P=0;P<l.length;++P)l[P]=g(l[P],c+1);else for(const P in l)Object.hasOwnProperty.call(l,P)&&(l[P]=g(l[P],c+1))}return l}t.revive=g}),define(ge[28],me([1,0,7,5,15]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(W=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${W.vscodeRemoteResource}`}set(c,P,r){this.a[c]=P,this.b[c]=r}setConnectionToken(c,P){this.c[c]=P}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(n){return E.onUnexpectedError(n),c}const P=c.authority;let r=this.a[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const u=this.b[P],e=this.c[P];let a=`path=${encodeURIComponent(c.path)}`;return typeof e=="string"&&(a+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:R.isWeb?this.d:W.vscodeRemoteResource,authority:`${r}:${u}`,path:this.f,query:a})}}t.RemoteAuthorities=new v,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(c){const P=this.b(c,J);return this.uriToBrowserUri(P)}uriToBrowserUri(c){return c.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(c):c.scheme===W.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${W.vscodeFileResource}://${D.a}`)?c.with({scheme:W.vscodeFileResource,authority:c.authority||D.a,query:null,fragment:null}):c}asFileUri(c){const P=this.b(c,J);return this.uriToFileUri(P)}uriToFileUri(c){return c.scheme===W.vscodeFileResource?c.with({scheme:W.file,authority:c.authority!==D.a?c.authority:null,query:null,fragment:null}):c}b(c,P){return i.URI.isUri(c)?c:i.URI.parse(P.toUrl(c))}}D.a="vscode-app",t.FileAccess=new D;var g;(function(l){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(c.get("3"));const P="vscode-coi";function r(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const n=a?.get(P);if(!!n)return c.get(n)}l.getHeadersFromQuery=r;function u(e,a,n){if(!globalThis.crossOriginIsolated)return;const s=a&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(P,s):e[P]=s}l.addSearchParam=u})(g=t.COI||(t.COI={}))}),define(ge[34],me([1,0,110,28,22,5,11,15]),function(J,t,E,R,i,W,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function g(u){return(0,D.uriToFsPath)(u,!0)}t.originalFSPath=g;class l{constructor(e){this.a=e}compare(e,a,n=!1){return e===a?0:(0,v.compare)(this.getComparisonKey(e,n),this.getComparisonKey(a,n))}isEqual(e,a,n=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,n)===this.getComparisonKey(a,n)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,n=!1){if(e.scheme===a.scheme){if(e.scheme===R.Schemas.file)return E.isEqualOrParent(g(e),g(a),this.a(e))&&e.query===a.query&&(n||e.fragment===a.fragment);if((0,t.isEqualAuthority)(e.authority,a.authority))return E.isEqualOrParent(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(n||e.fragment===a.fragment)}return!1}joinPath(e,...a){return D.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===R.Schemas.file?a=D.URI.file(i.dirname(g(e))).path:(a=i.posix.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===R.Schemas.file?a=D.URI.file(i.normalize(g(e))).path:a=i.posix.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.isEqualAuthority)(e.authority,a.authority))return;if(e.scheme===R.Schemas.file){const o=i.relative(g(e),g(a));return W.isWindows?E.toSlashes(o):o}let n=e.path||"/";const s=a.path||"/";if(this.a(e)){let o=0;for(const y=Math.min(n.length,s.length);o<y&&!(n.charCodeAt(o)!==s.charCodeAt(o)&&n.charAt(o).toLowerCase()!==s.charAt(o).toLowerCase());o++);n=s.substr(0,o)+n.substr(o)}return i.posix.relative(n,s)}resolvePath(e,a){if(e.scheme===R.Schemas.file){const n=D.URI.file(i.resolve(g(e),a));return e.with({authority:n.authority,path:n.path})}return a=E.toPosixPath(a),e.with({path:i.posix.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,v.equalsIgnoreCase)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===R.Schemas.file){const n=g(e);return n.length>E.getRoot(n).length&&n[n.length-1]===a}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.hasTrailingPathSeparator)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let n=!1;if(e.scheme===R.Schemas.file){const s=g(e);n=s!==void 0&&s.length===E.getRoot(s).length&&s[s.length-1]===a}else{a="/";const s=e.path;n=s.length===1&&s.charCodeAt(s.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,a)?e.with({path:e.path+"/"}):e}}t.ExtUri=l,t.extUri=new l(()=>!1),t.extUriBiasedIgnorePathCase=new l(u=>u.scheme===R.Schemas.file?!W.isLinux:!0),t.extUriIgnorePathCase=new l(u=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function c(u,e){const a=[];for(let n=0;n<u.length;n++){const s=e(u[n]);u.some((o,y)=>y===n?!1:(0,t.isEqualOrParent)(s,e(o)))||a.push(u[n])}return a}t.distinctParents=c;var P;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function e(a){const n=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(y=>{const[A,S]=y.split(":");A&&S&&n.set(A,S)});const o=a.path.substring(0,a.path.indexOf(";"));return o&&n.set(u.META_DATA_MIME,o),n}u.parseMetaData=e})(P=t.DataUri||(t.DataUri={}));function r(u,e,a){if(e){let n=u.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),u.with({scheme:a,authority:e,path:n})}return u.with({scheme:a})}t.toLocalResource=r}),define(ge[9],me([1,0,27,7,3,2,34,5,46]),function(J,t,E,R,i,W,v,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function l(x){return!!x&&typeof x.then=="function"}t.isThenable=l;function c(x){const M=new E.CancellationTokenSource,f=x(M.token),C=new Promise(($,Y)=>{const F=M.token.onCancellationRequested(()=>{F.dispose(),M.dispose(),Y(new R.CancellationError)});Promise.resolve(f).then(N=>{F.dispose(),M.dispose(),$(N)},N=>{F.dispose(),M.dispose(),Y(N)})});return new class{cancel(){M.cancel()}then($,Y){return C.then($,Y)}catch($){return this.then(void 0,$)}finally($){return C.finally($)}}}t.createCancelablePromise=c;function P(x,M,f){return new Promise((C,$)=>{const Y=M.onCancellationRequested(()=>{Y.dispose(),C(f)});x.then(C,$).finally(()=>Y.dispose())})}t.raceCancellation=P;function r(x,M){return new Promise((f,C)=>{const $=M.onCancellationRequested(()=>{$.dispose(),C(new R.CancellationError)});x.then(f,C).finally(()=>$.dispose())})}t.raceCancellationError=r;async function u(x){let M=-1;const f=x.map(($,Y)=>$.then(F=>(M=Y,F))),C=await Promise.race(f);return x.forEach(($,Y)=>{Y!==M&&$.cancel()}),C}t.raceCancellablePromises=u;function e(x,M,f){let C;const $=setTimeout(()=>{C?.(void 0),f?.()},M);return Promise.race([x.finally(()=>clearTimeout($)),new Promise(Y=>C=Y)])}t.raceTimeout=e;function a(x){return new Promise((M,f)=>{const C=x();l(C)?C.then(M,f):M(C)})}t.asPromise=a;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(M){if(this.a){if(this.d=M,!this.b){const f=()=>{this.b=null;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(f,f).then(C)})}return new Promise((f,C)=>{this.b.then(f,C)})}return this.a=M(),new Promise((f,C)=>{this.a.then($=>{this.a=null,f($)},$=>{this.a=null,C($)})})}}t.Throttler=n;class s{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}t.Sequencer=s;class o{constructor(){this.a=new Map}queue(M,f){const $=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(f).finally(()=>{this.a.get(M)===$&&this.a.delete(M)});return this.a.set(M,$),$}}t.SequencerByKey=o;const y=(x,M)=>{let f=!0;const C=setTimeout(()=>{f=!1,M()},x);return{isTriggered:()=>f,dispose:()=>{clearTimeout(C),f=!1}}},A=x=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,x())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class S{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,f=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise(($,Y)=>{this.d=$,this.f=Y}).then(()=>{if(this.b=null,this.d=null,this.g){const $=this.g;return this.g=null,$()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=f===g.MicrotaskDelay?A(C):y(f,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=S;class d{constructor(M){this.a=new S(M),this.b=new n}trigger(M,f){return this.a.trigger(()=>this.b.queue(M),f)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=d;class p{constructor(){this.a=!1,this.b=new Promise((M,f)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=p;class L extends p{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=L;function I(x,M){return M?new Promise((f,C)=>{const $=setTimeout(()=>{Y.dispose(),f()},x),Y=M.onCancellationRequested(()=>{clearTimeout($),Y.dispose(),C(new R.CancellationError)})}):c(f=>I(x,f))}t.timeout=I;function h(x,M=0){const f=setTimeout(x,M);return(0,W.toDisposable)(()=>clearTimeout(f))}t.disposableTimeout=h;function b(x){const M=[];let f=0;const C=x.length;function $(){return f<C?x[f++]():null}function Y(F){F!=null&&M.push(F);const N=$();return N?N.then(Y):Promise.resolve(M)}return Promise.resolve(null).then(Y)}t.sequence=b;function m(x,M=C=>!!C,f=null){let C=0;const $=x.length,Y=()=>{if(C>=$)return Promise.resolve(f);const F=x[C++];return Promise.resolve(F()).then(B=>M(B)?Promise.resolve(B):Y())};return Y()}t.first=m;function w(x,M=C=>!!C,f=null){if(x.length===0)return Promise.resolve(f);let C=x.length;const $=()=>{C=-1;for(const Y of x)Y.cancel?.()};return new Promise((Y,F)=>{for(const N of x)N.then(B=>{--C>=0&&M(B)?($(),Y(B)):C===0&&Y(f)}).catch(B=>{--C>=0&&($(),F(B))})})}t.firstParallel=w;class O{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new i.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((f,C)=>{this.f.push({factory:M,c:f,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const f=M.factory();f.then(M.c,M.e),f.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=O;class V extends O{constructor(){super(1)}}t.Queue=V;class ie{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const M=new le;return this.b.add(M),M.p}d(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,f=v.extUri){const C=f.getComparisonKey(M);let $=this.a.get(C);return $||($=new V,i.Event.once($.onDrained)(()=>{$?.dispose(),this.a.delete(C),this.f()}),this.a.set(C,$)),$}f(){!this.d()||this.g()}g(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.g()}}t.ResourceQueue=ie;class se{constructor(M,f){this.a=-1,typeof M=="function"&&typeof f=="number"&&this.setIfNotSet(M,f)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,f){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},f)}setIfNotSet(M,f){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},f))}}t.TimeoutTimer=se;class ae{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,f){this.cancel(),this.a=setInterval(()=>{M()},f)}}t.IntervalTimer=ae;class de{constructor(M,f){this.b=-1,this.a=M,this.d=f,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=de;class ue{constructor(M,f){f%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${f}ms is not a multiple of 1000ms.`),this.a=M,this.b=f,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=ue;class Z extends de{constructor(M,f){super(M,f),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=Z;class Q extends W.Disposable{constructor(M,f){super(),this.g=M,this.h=f,this.a=[],this.b=this.D(new W.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const f of M)this.a.push(f);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=x=>{(0,D.setTimeout0)(()=>{if(M)return;const f=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,f-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:t.runWhenIdle=(x,M)=>{const f=requestIdleCallback(x,typeof M=="number"?{timeout:M}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(f))}}}}();class ve{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(f){this.g=f}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=ve;async function pe(x,M,f){let C;for(let $=0;$<f;$++)try{return await x()}catch(Y){C=Y,await I(M)}throw C}t.retry=pe;class Me{hasPending(M){return this.a?typeof M=="number"?this.a.taskId===M:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(M,f,C){return this.a={taskId:M,cancel:()=>C?.(),promise:f},f.then(()=>this.d(M),()=>this.d(M)),f}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this.b)this.b.run=M;else{let f,C;const $=new Promise((Y,F)=>{f=Y,C=F});this.b={run:M,promise:$,promiseResolve:f,promiseReject:C}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=Me;class Re{constructor(M,f=()=>Date.now()){this.d=M,this.f=f,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}t.IntervalCounter=Re;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((M,f)=>{this.a=M,this.b=f})}complete(M){return new Promise(f=>{this.a(M),this.f=!0,f()})}error(M){return new Promise(f=>{this.b(M),this.d=!0,f()})}cancel(){new Promise(M=>{this.b(new R.CancellationError),this.d=!0,M()})}}t.DeferredPromise=le;var _;(function(x){async function M(C){let $;const Y=await Promise.all(C.map(F=>F.then(N=>N,N=>{$||($=N)})));if(typeof $<"u")throw $;return Y}x.settled=M;function f(C){return new Promise(async($,Y)=>{try{await C($,Y)}catch(F){Y(F)}})}x.withAsyncBody=f})(_=t.Promises||(t.Promises={}));var ne;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(ne||(ne={}));class ee{static fromArray(M){return new ee(f=>{f.emitMany(M)})}static fromPromise(M){return new ee(async f=>{f.emitMany(await M)})}static fromPromises(M){return new ee(async f=>{await Promise.all(M.map(async C=>f.emitOne(await C)))})}static merge(M){return new ee(async f=>{await Promise.all(M.map(async C=>{for await(const $ of C)f.emitOne($)}))})}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new i.Emitter,queueMicrotask(async()=>{const f={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(M(f)),this.j()}catch(C){this.k(C)}finally{f.emitOne=void 0,f.emitMany=void 0,f.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(M,f){return new ee(async C=>{for await(const $ of M)C.emitOne(f($))})}map(M){return ee.map(this,M)}static filter(M,f){return new ee(async C=>{for await(const $ of M)f($)&&C.emitOne($)})}filter(M){return ee.filter(this,M)}static coalesce(M){return ee.filter(M,f=>!!f)}coalesce(){return ee.coalesce(this)}static async toPromise(M){const f=[];for await(const C of M)f.push(C);return f}toPromise(){return ee.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}ee.EMPTY=ee.fromArray([]),t.AsyncIterableObject=ee;class te extends ee{constructor(M,f){super(f),this.l=M}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=te;function T(x){const M=new E.CancellationTokenSource,f=x(M.token);return new te(M,async C=>{const $=M.token.onCancellationRequested(()=>{$.dispose(),M.dispose(),C.reject(new R.CancellationError)});try{for await(const Y of f){if(M.token.isCancellationRequested)return;C.emitOne(Y)}$.dispose(),M.dispose()}catch(Y){$.dispose(),M.dispose(),C.reject(Y)}})}t.createCancelableAsyncIterable=T}),define(ge[4],me([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function a(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=a;function n(X){return X?.isConnected??!1}t.isInDOM=n;class s{constructor(K,fe,Fe,ke){this.f=K,this.g=fe,this.d=Fe,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function o(X,K,fe,Fe){return new s(X,K,fe,Fe)}t.addDisposableListener=o;function y(X){return function(K){return X(new W.StandardMouseEvent(K))}}function A(X){return function(K){return X(new i.StandardKeyboardEvent(K))}}const S=function(K,fe,Fe,ke){let qe=Fe;return fe==="click"||fe==="mousedown"?qe=y(Fe):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(qe=A(Fe)),o(K,fe,qe,ke)};t.addStandardDisposableListener=S;const d=function(K,fe,Fe){const ke=y(fe);return L(K,ke,Fe)};t.addStandardDisposableGenericMouseDownListener=d;const p=function(K,fe,Fe){const ke=y(fe);return h(K,ke,Fe)};t.addStandardDisposableGenericMouseUpListener=p;function L(X,K,fe){return o(X,r.isIOS&&R.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,K,fe)}t.addDisposableGenericMouseDownListener=L;function I(X,K,fe){return o(X,r.isIOS&&R.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,K,fe)}t.addDisposableGenericMouseMoveListener=I;function h(X,K,fe){return o(X,r.isIOS&&R.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,K,fe)}t.addDisposableGenericMouseUpListener=h;class b{constructor(K,fe=0){this.d=K,this.priority=fe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,D.onUnexpectedError)(K)}}static sort(K,fe){return fe.priority-K.priority}}(function(){let X=[],K=null,fe=!1,Fe=!1;const ke=()=>{for(fe=!1,K=X,X=[],Fe=!0;K.length>0;)K.sort(b.sort),K.shift().execute();Fe=!1};t.scheduleAtNextAnimationFrame=(qe,We=0)=>{const Xe=new b(qe,We);return X.push(Xe),fe||(fe=!0,requestAnimationFrame(ke)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(qe,We)=>{if(Fe){const Xe=new b(qe,We);return K.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(qe,We)}})();function m(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=m;function w(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=w;const O=8,V=function(X,K){return K};class ie extends c.Disposable{constructor(K,fe,Fe,ke=V,qe=O){super();let We=null,Xe=0;const nt=this.D(new v.TimeoutTimer),Ye=()=>{Xe=new Date().getTime(),Fe(We),We=null};this.D(o(K,fe,pt=>{We=ke(We,pt);const Et=new Date().getTime()-Xe;Et>=qe?(nt.cancel(),Ye()):nt.setIfNotSet(Ye,qe-Et)}))}}function se(X,K,fe,Fe,ke){return new ie(X,K,fe,Fe,ke)}t.addDisposableThrottledListener=se;function ae(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=ae;function de(X){if(X!==document.body)return new Z(X.clientWidth,X.clientHeight);if(r.isIOS&&window.visualViewport)return new Z(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new Z(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new Z(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new Z(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=de;class ue{static d(K,fe){return parseFloat(fe)||0}static f(K,fe,Fe){const ke=ae(K),qe=ke?ke.getPropertyValue(fe):"0";return ue.d(K,qe)}static getBorderLeftWidth(K){return ue.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return ue.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return ue.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return ue.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return ue.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return ue.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return ue.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return ue.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return ue.f(K,"margin-left","marginLeft")}static getMarginTop(K){return ue.f(K,"margin-top","marginTop")}static getMarginRight(K){return ue.f(K,"margin-right","marginRight")}static getMarginBottom(K){return ue.f(K,"margin-bottom","marginBottom")}}class Z{constructor(K,fe){this.width=K,this.height=fe}with(K=this.width,fe=this.height){return K!==this.width||fe!==this.height?new Z(K,fe):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof Z?K:new Z(K.width,K.height)}static equals(K,fe){return K===fe?!0:!K||!fe?!1:K.width===fe.width&&K.height===fe.height}}Z.None=new Z(0,0),t.Dimension=Z;function Q(X){let K=X.offsetParent,fe=X.offsetTop,Fe=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){fe-=X.scrollTop;const ke=B(X)?null:ae(X);ke&&(Fe-=ke.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===K&&(Fe+=ue.getBorderLeftWidth(X),fe+=ue.getBorderTopWidth(X),fe+=X.offsetTop,Fe+=X.offsetLeft,K=X.offsetParent)}return{left:Fe,top:fe}}t.getTopLeftOffset=Q;function ve(X,K,fe){typeof K=="number"&&(X.style.width=`${K}px`),typeof fe=="number"&&(X.style.height=`${fe}px`)}t.size=ve;function pe(X,K,fe,Fe,ke,qe="absolute"){typeof K=="number"&&(X.style.top=`${K}px`),typeof fe=="number"&&(X.style.right=`${fe}px`),typeof Fe=="number"&&(X.style.bottom=`${Fe}px`),typeof ke=="number"&&(X.style.left=`${ke}px`),X.style.position=qe}t.position=pe;function Me(X){const K=X.getBoundingClientRect();return{left:K.left+window.scrollX,top:K.top+window.scrollY,width:K.width,height:K.height}}t.getDomNodePagePosition=Me;function Re(X){let K=X,fe=1;do{const Fe=ae(K).zoom;Fe!=null&&Fe!=="1"&&(fe*=Fe),K=K.parentElement}while(K!==null&&K!==document.documentElement);return fe}t.getDomNodeZoomLevel=Re;function le(X){const K=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.offsetWidth+K}t.getTotalWidth=le;function _(X){const K=ue.getBorderLeftWidth(X)+ue.getBorderRightWidth(X),fe=ue.getPaddingLeft(X)+ue.getPaddingRight(X);return X.offsetWidth-K-fe}t.getContentWidth=_;function ne(X){const K=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.scrollWidth+K}t.getTotalScrollWidth=ne;function ee(X){const K=ue.getBorderTopWidth(X)+ue.getBorderBottomWidth(X),fe=ue.getPaddingTop(X)+ue.getPaddingBottom(X);return X.offsetHeight-K-fe}t.getContentHeight=ee;function te(X){const K=ue.getMarginTop(X)+ue.getMarginBottom(X);return X.offsetHeight+K}t.getTotalHeight=te;function T(X,K){if(X===null)return 0;const fe=Q(X),Fe=Q(K);return fe.left-Fe.left}function x(X,K){const fe=K.map(ke=>Math.max(ne(ke),le(ke))+T(ke,X)||0);return Math.max(...fe)}t.getLargestChildWidth=x;function M(X,K){for(;X;){if(X===K)return!0;X=X.parentNode}return!1}t.isAncestor=M;const f="parentFlowToElementId";function C(X,K){X.dataset[f]=K.id}t.setParentFlowTo=C;function $(X){const K=X.dataset[f];return typeof K=="string"?document.getElementById(K):null}function Y(X,K){let fe=X;for(;fe;){if(fe===K)return!0;if(fe instanceof HTMLElement){const Fe=$(fe);if(Fe){fe=Fe;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function F(X,K,fe){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(K))return X;if(fe){if(typeof fe=="string"){if(X.classList.contains(fe))return null}else if(X===fe)return null}X=X.parentNode}return null}t.findParentWithClass=F;function N(X,K,fe){return!!F(X,K,fe)}t.hasParentWithClass=N;function B(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=B;function k(X){return!!z(X)}t.isInShadowDOM=k;function z(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return B(X)?X:null}t.getShadowRoot=z;function H(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=H;function U(X=document.getElementsByTagName("head")[0]){const K=document.createElement("style");return K.type="text/css",K.media="screen",X.appendChild(K),K}t.createStyleSheet=U;function q(X=document.getElementsByTagName("head")[0]){const K=document.createElement("meta");return X.appendChild(K),K}t.createMetaElement=q;let G=null;function re(){return G||(G=U()),G}function he(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function we(X,K,fe=re()){!fe||!K||fe.sheet.insertRule(X+"{"+K+"}",0)}t.createCSSRule=we;function ye(X,K=re()){if(!K)return;const fe=he(K),Fe=[];for(let ke=0;ke<fe.length;ke++)fe[ke].selectorText.indexOf(X)!==-1&&Fe.push(ke);for(let ke=Fe.length-1;ke>=0;ke--)K.sheet.deleteRule(Fe[ke])}t.removeCSSRulesContainingSelector=ye;function Le(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Le,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ce(X){const K=X;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.isEventLike=Ce,t.EventHelper={stop:(X,K)=>(X.preventDefault(),K&&X.stopPropagation(),X)};function De(X){const K=[];for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)K[fe]=X.scrollTop,X=X.parentNode;return K}t.saveParentsScrollTop=De;function Pe(X,K){for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)X.scrollTop!==K[fe]&&(X.scrollTop=K[fe]),X=X.parentNode}t.restoreParentsScrollTop=Pe;class Ie extends c.Disposable{static l(K){const fe=z(K),Fe=fe?fe.activeElement:document.activeElement;return M(Fe,K)}constructor(K){super(),this.f=this.D(new g.Emitter),this.onDidFocus=this.f.event,this.g=this.D(new g.Emitter),this.onDidBlur=this.g.event;let fe=Ie.l(K),Fe=!1;const ke=()=>{Fe=!1,fe||(fe=!0,this.f.fire())},qe=()=>{fe&&(Fe=!0,window.setTimeout(()=>{Fe&&(Fe=!1,fe=!1,this.g.fire())},0))};this.j=()=>{Ie.l(K)!==fe&&(fe?qe():ke())},this.D(o(K,t.EventType.FOCUS,ke,!0)),this.D(o(K,t.EventType.BLUR,qe,!0)),this.D(o(K,t.EventType.FOCUS_IN,()=>this.j())),this.D(o(K,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function je(X){return new Ie(X)}t.trackFocus=je;function ze(X,K){return X.after(K),K}t.after=ze;function Ue(X,...K){if(X.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}t.append=Ue;function Ze(X,K){return X.insertBefore(K,X.firstChild),K}t.prepend=Ze;function Ge(X,...K){X.innerText="",Ue(X,...K)}t.reset=Ge;const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var j;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(j=t.Namespace||(t.Namespace={}));function oe(X,K,fe,...Fe){const ke=Be.exec(K);if(!ke)throw new Error("Bad use of emmet");const qe=ke[1]||"div";let We;return X!==j.HTML?We=document.createElementNS(X,qe):We=document.createElement(qe),ke[3]&&(We.id=ke[3]),ke[4]&&(We.className=ke[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Xe,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Xe)?We[Xe]=nt:Xe==="selected"?nt&&We.setAttribute(Xe,"true"):We.setAttribute(Xe,nt))}),We.append(...Fe),We}function be(X,K,...fe){return oe(j.HTML,X,K,...fe)}t.$=be,be.SVG=function(X,K,...fe){return oe(j.SVG,X,K,...fe)};function Ee(X,K){const fe=[];return X.forEach((Fe,ke)=>{ke>0&&(K instanceof Node?fe.push(K.cloneNode()):fe.push(document.createTextNode(K))),fe.push(Fe)}),fe}t.join=Ee;function Se(...X){for(const K of X)K.style.display="",K.removeAttribute("aria-hidden")}t.show=Se;function Oe(...X){for(const K of X)K.style.display="none",K.setAttribute("aria-hidden","true")}t.hide=Oe;function $e(X,K){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(K))return X;X=X.parentNode}return null}function tt(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&$e(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=tt;function Ke(X){return K=>{K.preventDefault(),K.stopPropagation(),X(K)}}t.finalHandler=Ke;function xe(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=xe;function Te(X){const K=window.devicePixelRatio*X;return Math.max(1,Math.floor(K))/window.devicePixelRatio}t.computeScreenAwareSize=Te;function ce(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=ce;const Ae=780,Ne=640;function _e(X){const K=Math.floor(window.screenLeft+window.innerWidth/2-Ae/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Ne/2);window.open(X,"_blank",`width=${Ae},height=${Ne},top=${fe},left=${K}`)}t.windowOpenPopup=_e;function Qe(X,K=!0){const fe=window.open();return fe?(K&&(fe.opener=null),fe.location.href=X,!0):!1}t.windowOpenWithSuccess=Qe;function Je(X){const K=()=>{X(),fe=(0,t.scheduleAtNextAnimationFrame)(K)};let fe=(0,t.scheduleAtNextAnimationFrame)(K);return(0,c.toDisposable)(()=>fe.dispose())}t.animate=Je,P.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function et(X){return X?`url('${P.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=et;function rt(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=rt;function ht(X,K){if(X!==void 0){const fe=X.match(/^\s*var\((.+)\)$/);if(fe){const Fe=fe[1].split(",",2);return Fe.length===2&&(K=ht(Fe[1].trim(),K)),`var(${Fe[0]}, ${K})`}return X}return K}t.asCssValueWithDefault=ht;function yt(X,K){let fe;if(e.URI.isUri(X))fe=X.toString(!0);else{const ke=new Blob([X]);fe=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(fe))}const Fe=document.createElement("a");document.body.appendChild(Fe),Fe.download=K,Fe.href=fe,Fe.click(),setTimeout(()=>document.body.removeChild(Fe))}t.triggerDownload=yt;function Tt(){return new Promise(X=>{const K=document.createElement("input");document.body.appendChild(K),K.type="file",K.multiple=!0,g.Event.once(g.Event.fromDOMEventEmitter(K,"input"))(()=>{X((0,u.withNullAsUndefined)(K.files))}),K.click(),setTimeout(()=>document.body.removeChild(K))})}t.triggerUpload=Tt;var bt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(bt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function ci(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:bt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:bt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:bt.BROWSER,guess:!0}:null}t.detectFullscreen=ci;function Wt(X,K=!1){const fe=document.createElement("a");return l.addHook("afterSanitizeAttributes",Fe=>{for(const ke of["href","src"])if(Fe.hasAttribute(ke)){const qe=Fe.getAttribute(ke);if(ke==="href"&&qe.startsWith("#"))continue;if(fe.href=qe,!X.includes(fe.protocol.replace(/:$/,""))){if(K&&ke==="src"&&fe.href.startsWith("data:"))continue;Fe.removeAttribute(ke)}}}),(0,c.toDisposable)(()=>{l.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const di=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const fi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function gi(X,K){const fe=Wt(di);try{const Fe=l.sanitize(K,fi);X.innerHTML=Fe}finally{fe.dispose()}}t.safeInnerHtml=gi;function mi(X){const K=new Uint16Array(X.length);for(let ke=0;ke<K.length;ke++)K[ke]=X.charCodeAt(ke);let fe="";const Fe=new Uint8Array(K.buffer);for(let ke=0;ke<Fe.length;ke++)fe+=String.fromCharCode(Fe[ke]);return fe}function bi(X){return btoa(mi(X))}t.multibyteAwareBtoa=bi;class ft extends g.Emitter{constructor(){super(),this.s=new c.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(o(window,"keydown",K=>{if(K.defaultPrevented)return;const fe=new i.StandardKeyboardEvent(K);if(!(fe.keyCode===6&&K.repeat)){if(K.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(K.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(K.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(K.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(fe.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=K.altKey,this.t.ctrlKey=K.ctrlKey,this.t.metaKey=K.metaKey,this.t.shiftKey=K.shiftKey,this.t.lastKeyPressed&&(this.t.event=K,this.fire(this.t))}},!0)),this.s.add(o(window,"keyup",K=>{K.defaultPrevented||(!K.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!K.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!K.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!K.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=K.altKey,this.t.ctrlKey=K.ctrlKey,this.t.metaKey=K.metaKey,this.t.shiftKey=K.shiftKey,this.t.lastKeyReleased&&(this.t.event=K,this.fire(this.t)))},!0)),this.s.add(o(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(o(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(o(document.body,"mousemove",K=>{K.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(o(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function pi(X){const K=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}t.getCookieValue=pi;class vi extends c.Disposable{constructor(K,fe){super(),this.j=K,this.l=fe,this.f=0,this.g=0,this.m()}m(){this.D(o(this.j,t.EventType.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.l.onDragEnter(K)})),this.D(o(this.j,t.EventType.DRAG_OVER,K=>{K.preventDefault(),this.l.onDragOver?.(K,K.timeStamp-this.g)})),this.D(o(this.j,t.EventType.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(K))})),this.D(o(this.j,t.EventType.DRAG_END,K=>{this.f=0,this.g=0,this.l.onDragEnd(K)})),this.D(o(this.j,t.EventType.DROP,K=>{this.f=0,this.g=0,this.l.onDrop(K)}))}}t.DragAndDropObserver=vi;const Di=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function wi(X,...K){let fe,Fe;Array.isArray(K[0])?(fe={},Fe=K[0]):(fe=K[0]||{},Fe=K[1]);const ke=Di.exec(X);if(!ke||!ke.groups)throw new Error("Bad use of h");const qe=ke.groups.tag||"div",We=document.createElement(qe);ke.groups.id&&(We.id=ke.groups.id);const Xe=[];if(ke.groups.class)for(const Ye of ke.groups.class.split("."))Ye!==""&&Xe.push(Ye);if(fe.className!==void 0)for(const Ye of fe.className.split("."))Ye!==""&&Xe.push(Ye);Xe.length>0&&(We.className=Xe.join(" "));const nt={};if(ke.groups.name&&(nt[ke.groups.name]=We),Fe)for(const Ye of Fe)Ye instanceof HTMLElement?We.appendChild(Ye):typeof Ye=="string"?We.append(Ye):(Object.assign(nt,Ye),We.appendChild(Ye.root));for(const[Ye,pt]of Object.entries(fe))if(Ye!=="className")if(Ye==="style")for(const[Et,Lt]of Object.entries(pt))We.style.setProperty($t(Et),typeof Lt=="number"?Lt+"px":""+Lt);else Ye==="tabIndex"?We.tabIndex=pt:We.setAttribute($t(Ye),pt.toString());return nt.root=We,nt}t.h=wi;function $t(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[50],me([1,0,4,2,106]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class W extends R.Disposable{constructor(g,l){super(),this.D((0,E.addDisposableListener)(g,"dragover",c=>{c.preventDefault(),this.a||(this.a=setTimeout(()=>{l(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(c=>{this.D((0,E.addDisposableListener)(g,c,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=W,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text};function v(D,g,l,c,P){const r=document.createElement("div");r.className=l,r.textContent=g,P&&(r.style.color=P),c&&(r.style.background=c),D.dataTransfer&&(document.body.appendChild(r),D.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=v}),define(ge[51],me([1,0,4]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function R(r,u={}){const e=W(u);return e.textContent=r,e}t.renderText=R;function i(r,u={}){const e=W(u);return g(e,l(r,!!u.renderCodeSegments),u.actionHandler,u.renderCodeSegments),e}t.renderFormattedText=i;function W(r){const u=r.inline?"span":"div",e=document.createElement(u);return r.className&&(e.className=r.className),e}t.createElement=W;class v{constructor(u){this.b=u,this.c=0}eos(){return this.c>=this.b.length}next(){const u=this.peek();return this.advance(),u}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(D||(D={}));function g(r,u,e,a){let n;if(u.type===2)n=document.createTextNode(u.content||"");else if(u.type===3)n=document.createElement("b");else if(u.type===4)n=document.createElement("i");else if(u.type===7&&a)n=document.createElement("code");else if(u.type===5&&e){const s=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(s,"click",o=>{e.callback(String(u.index),o)})),n=s}else u.type===8?n=document.createElement("br"):u.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(u.children)&&u.children.forEach(s=>{g(n,s,e,a)})}function l(r,u){const e={type:1,children:[]};let a=0,n=e;const s=[],o=new v(r);for(;!o.eos();){let y=o.next();const A=y==="\\"&&P(o.peek(),u)!==0;if(A&&(y=o.next()),!A&&c(y,u)&&y===o.peek()){o.advance(),n.type===2&&(n=s.pop());const S=P(y,u);if(n.type===S||n.type===5&&S===6)n=s.pop();else{const d={type:S,children:[]};S===5&&(d.index=a,a++),n.children.push(d),s.push(n),n=d}}else if(y===`
`)n.type===2&&(n=s.pop()),n.children.push({type:8});else if(n.type!==2){const S={type:2,content:y};n.children.push(S),s.push(n),n=S}else n.content+=y}return n.type===2&&(n=s.pop()),s.length,e}function c(r,u){return P(r,u)!==0}function P(r,u){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return u?7:0;default:return 0}}}),define(ge[52],me([1,0,4,2]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this.a=new R.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(v,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const g=this.c;this.c=null,v&&g&&g(D)}isMonitoring(){return!!this.b}startMonitoring(v,D,g,l,c){this.isMonitoring()&&this.stopMonitoring(!1),this.b=l,this.c=c;let P=v;try{v.setPointerCapture(D),this.a.add((0,R.toDisposable)(()=>{try{v.releasePointerCapture(D)}catch{}}))}catch{P=window}this.a.add(E.addDisposableListener(P,E.EventType.POINTER_MOVE,r=>{if(r.buttons!==g){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(E.addDisposableListener(P,E.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var Ve=this&&this.__decorate||function(J,t,E,R){var i=arguments.length,W=i<3?t:R===null?R=Object.getOwnPropertyDescriptor(t,E):R,v;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(J,t,E,R);else for(var D=J.length-1;D>=0;D--)(v=J[D])&&(W=(i<3?v(W):i>3?v(t,E,W):v(t,E))||W);return i>3&&W&&Object.defineProperty(t,E,W),W};define(ge[23],me([1,0,4,13,25,2,43]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var D;(function(l){l.Tap="-monaco-gesturetap",l.Change="-monaco-gesturechange",l.Start="-monaco-gesturestart",l.End="-monaco-gesturesend",l.Contextmenu="-monaco-gesturecontextmenu"})(D=t.EventType||(t.EventType={}));class g extends W.Disposable{constructor(){super(),this.f=!1,this.g=new v.LinkedList,this.h=new v.LinkedList,this.k={},this.j=null,this.l=0,this.D(E.addDisposableListener(document,"touchstart",c=>this.n(c),{passive:!1})),this.D(E.addDisposableListener(document,"touchend",c=>this.p(c))),this.D(E.addDisposableListener(document,"touchmove",c=>this.u(c),{passive:!1}))}static addTarget(c){if(!g.isTouchDevice())return W.Disposable.None;g.b||(g.b=new g);const P=g.b.g.push(c);return(0,W.toDisposable)(P)}static ignoreTarget(c){if(!g.isTouchDevice())return W.Disposable.None;g.b||(g.b=new g);const P=g.b.h.push(c);return(0,W.toDisposable)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(c){const P=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,u=c.targetTouches.length;r<u;r++){const e=c.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const a=this.q(D.Start,e.target);a.pageX=e.pageX,a.pageY=e.pageY,this.r(a)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}p(c){const P=Date.now(),r=Object.keys(this.k).length;for(let u=0,e=c.changedTouches.length;u<e;u++){const a=c.changedTouches.item(u);if(!this.k.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const n=this.k[a.identifier],s=Date.now()-n.initialTimeStamp;if(s<g.c&&Math.abs(n.initialPageX-R.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-R.tail(n.rollingPageY))<30){const o=this.q(D.Tap,n.initialTarget);o.pageX=R.tail(n.rollingPageX),o.pageY=R.tail(n.rollingPageY),this.r(o)}else if(s>=g.c&&Math.abs(n.initialPageX-R.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-R.tail(n.rollingPageY))<30){const o=this.q(D.Contextmenu,n.initialTarget);o.pageX=R.tail(n.rollingPageX),o.pageY=R.tail(n.rollingPageY),this.r(o)}else if(r===1){const o=R.tail(n.rollingPageX),y=R.tail(n.rollingPageY),A=R.tail(n.rollingTimestamps)-n.rollingTimestamps[0],S=o-n.rollingPageX[0],d=y-n.rollingPageY[0],p=[...this.g].filter(L=>n.initialTarget instanceof Node&&L.contains(n.initialTarget));this.s(p,P,Math.abs(S)/A,S>0?1:-1,o,Math.abs(d)/A,d>0?1:-1,y)}this.r(this.q(D.End,n.initialTarget)),delete this.k[a.identifier]}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}q(c,P){const r=document.createEvent("CustomEvent");return r.initEvent(c,!1,!0),r.initialTarget=P,r.tapCount=0,r}r(c){if(c.type===D.Tap){const P=new Date().getTime();let r=0;P-this.l>g.m?r=1:r=2,this.l=P,c.tapCount=r}else(c.type===D.Change||c.type===D.Contextmenu)&&(this.l=0);if(c.initialTarget instanceof Node){for(const P of this.h)if(P.contains(c.initialTarget))return;for(const P of this.g)P.contains(c.initialTarget)&&(P.dispatchEvent(c),this.f=!0)}}s(c,P,r,u,e,a,n,s){this.j=E.scheduleAtNextAnimationFrame(()=>{const o=Date.now(),y=o-P;let A=0,S=0,d=!0;r+=g.a*y,a+=g.a*y,r>0&&(d=!1,A=u*r*y),a>0&&(d=!1,S=n*a*y);const p=this.q(D.Change);p.translationX=A,p.translationY=S,c.forEach(L=>L.dispatchEvent(p)),d||this.s(c,o,r,u,e+A,a,n,s+S)})}u(c){const P=Date.now();for(let r=0,u=c.changedTouches.length;r<u;r++){const e=c.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const a=this.k[e.identifier],n=this.q(D.Change,a.initialTarget);n.translationX=e.pageX-R.tail(a.rollingPageX),n.translationY=e.pageY-R.tail(a.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.r(n),a.rollingPageX.length>3&&(a.rollingPageX.shift(),a.rollingPageY.shift(),a.rollingTimestamps.shift()),a.rollingPageX.push(e.pageX),a.rollingPageY.push(e.pageY),a.rollingTimestamps.push(P)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}g.a=-.005,g.c=700,g.m=400,Ve([i.memoize],g,"isTouchDevice",null),t.Gesture=g}),define(ge[53],me([1,0,4,5,83]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let W,v,D,g,l;function c(e){W=document.createElement("div"),W.className="monaco-aria-container";const a=()=>{const s=document.createElement("div");return s.className="monaco-alert",s.setAttribute("role","alert"),s.setAttribute("aria-atomic","true"),W.appendChild(s),s};v=a(),D=a();const n=()=>{const s=document.createElement("div");return s.className="monaco-status",s.setAttribute("role","complementary"),s.setAttribute("aria-live","polite"),s.setAttribute("aria-atomic","true"),W.appendChild(s),s};g=n(),l=n(),e.appendChild(W)}t.setARIAContainer=c;function P(e){!W||(v.textContent!==e?(E.clearNode(D),u(v,e)):(E.clearNode(v),u(D,e)))}t.alert=P;function r(e){!W||(R.isMacintosh?P(e):g.textContent!==e?(E.clearNode(l),u(g,e)):(E.clearNode(g),u(l,e)))}t.status=r;function u(e,a){E.clearNode(e),a.length>i&&(a=a.substr(0,i)),e.textContent=a,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,17]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(D){const g=new Array;let l,c=0,P=0;for(;(l=i.exec(D))!==null;){P=l.index||0,c<P&&g.push(D.substring(c,P)),c=(l.index||0)+l[0].length;const[,r,u]=l;g.push(r?`$(${u})`:v({id:u}))}return c<D.length&&g.push(D.substring(c)),g}t.renderLabelWithIcons=W;function v(D){const g=E.$("span");return g.classList.add(...R.ThemeIcon.asClassNameArray(D)),g}t.renderIcon=v}),define(ge[116],me([1,0,4]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function R(W){try{W.parentElement?.removeChild(W)}catch{}}class i{constructor(v){this.d=v,this.a=new Map,this.b=new Set,this.c=!1}alloc(v){let D=this.h(v).pop(),g=!1;if(D)g=this.b.has(D.domNode),g&&this.b.delete(D.domNode);else{const l=(0,E.$)(".monaco-list-row"),P=this.i(v).renderTemplate(l);D={domNode:l,templateId:v,templateData:P}}return{row:D,isReusingConnectedDomNode:g}}release(v){!v||this.f(v)}transact(v){if(this.c)throw new Error("Already in transaction");this.c=!0;try{v()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(v){const{domNode:D,templateId:g}=v;D&&(this.c?this.b.add(D):this.g(D)),this.h(g).push(v)}g(v){v.classList.remove("scrolling"),R(v)}h(v){let D=this.a.get(v);return D||(D=[],this.a.set(v,D)),D}dispose(){this.a.forEach((v,D)=>{for(const g of v)this.i(D).disposeTemplate(g.templateData),g.templateData=null}),this.a.clear(),this.b.clear()}i(v){const D=this.d.get(v);if(!D)throw new Error(`No renderer found for ${v}`);return D}}t.RowCache=i}),define(ge[117],me([1,0,9,2]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends R.Disposable{constructor(v,D,g){super(),this.a=v,this.b=D,this.c=g,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.D(new E.TimeoutTimer)}setVisibility(v){this.a!==v&&(this.a=v,this.m())}setShouldBeVisible(v){this.g=v,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const v=this.l();this.h!==v&&(this.h=v,this.ensureVisibility())}setIsNeeded(v){this.i!==v&&(this.i=v,this.ensureVisibility())}setDomNode(v){this.f=v,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(v){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(v?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(J,t,E,R,i,W,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class g extends v.Disposable{constructor(c,P,r,u){super(),this.f=0,this.b=u||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.D(new W.Emitter),this.h=r,this.i(),this.setOptions(c,P)}i(){this.D(R.Gesture.addTarget(this.a)),[R.EventType.Tap].forEach(c=>{this.D(E.addDisposableListener(this.a,c,P=>{this.a.focus()}))}),this.D(E.addStandardDisposableListener(this.a,"click",c=>{E.EventHelper.stop(c,!0)})),this.D(E.addStandardDisposableListener(this.a,"change",c=>{this.a.title=c.target.value,this.g.fire({index:c.target.selectedIndex,selected:c.target.value})})),this.D(E.addStandardDisposableListener(this.a,"keydown",c=>{let P=!1;D.isMacintosh?(c.keyCode===18||c.keyCode===16||c.keyCode===10)&&(P=!0):(c.keyCode===18&&c.altKey||c.keyCode===10||c.keyCode===3)&&(P=!0),P&&c.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(c,P){(!this.c||!i.equals(this.c,c))&&(this.c=c,this.a.options.length=0,this.c.forEach((r,u)=>{this.a.add(this.j(r.text,u,r.isDisabled))})),P!==void 0&&this.select(P)}select(c){this.c.length===0?this.f=0:c>=0&&c<this.c.length?this.f=c:c>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(c){this.b.ariaLabel=c,this.a.setAttribute("aria-label",c)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(c){this.a.tabIndex=c?0:-1}render(c){c.classList.add("select-container"),c.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(c){this.h=c,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}j(c,P,r){const u=document.createElement("option");return u.value=c,u.text=c,u.disabled=!!r,u}}t.SelectBoxNative=g}),define(ge[54],me([1,0,24,13,9,46,112,3,26]),function(J,t,E,R,i,W,v,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function l(u){return typeof u=="object"&&"visibility"in u&&"data"in u}t.isFilterResult=l;function c(u){switch(u){case!0:return 1;case!1:return 0;default:return u}}t.getVisibleState=c;function P(u){return typeof u.collapsible=="boolean"}class r{constructor(e,a,n,s={}){this.o=e,this.p=a,this.rootRef=[],this.d=new D.EventBufferer,this.f=new D.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.Emitter,this.onDidSplice=this.l.event,this.m=new i.Delayer(W.MicrotaskDelay),this.h=typeof s.collapseByDefault>"u"?!1:s.collapseByDefault,this.j=s.filter,this.k=typeof s.autoExpandSingleChildren>"u"?!1:s.autoExpandSingleChildren,this.c={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,n=g.Iterable.empty(),s={}){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");s.diffIdentityProvider?this.q(s.diffIdentityProvider,e,a,n,s):this.s(e,a,n,s)}q(e,a,n,s=g.Iterable.empty(),o,y=o.diffDepth??0){const{parentNode:A}=this.G(a);if(!A.lastDiffIds)return this.s(a,n,s,o);const S=[...s],d=a[a.length-1],p=new v.LcsDiff({getElements:()=>A.lastDiffIds},{getElements:()=>[...A.children.slice(0,d),...S,...A.children.slice(d+n)].map(m=>e.getId(m.element).toString())}).ComputeDiff(!1);if(p.quitEarly)return A.lastDiffIds=void 0,this.s(a,n,S,o);const L=a.slice(0,-1),I=(m,w,O)=>{if(y>0)for(let V=0;V<O;V++)m--,w--,this.q(e,[...L,m,0],Number.MAX_SAFE_INTEGER,S[w].children,o,y-1)};let h=Math.min(A.children.length,d+n),b=S.length;for(const m of p.changes.sort((w,O)=>O.originalStart-w.originalStart))I(h,b,h-(m.originalStart+m.originalLength)),h=m.originalStart,b=m.modifiedStart-d,this.s([...L,h],m.originalLength,g.Iterable.slice(S,b,b+m.modifiedLength),o);I(h,b,h)}s(e,a,n=g.Iterable.empty(),{onDidCreateNode:s,onDidDeleteNode:o,diffIdentityProvider:y}){const{parentNode:A,listIndex:S,revealed:d,visible:p}=this.G(e),L=[],I=g.Iterable.map(n,ue=>this.w(ue,A,A.visible?1:0,d,L,s)),h=e[e.length-1],b=A.children.length>0;let m=0;for(let ue=h;ue>=0&&ue<A.children.length;ue--){const Z=A.children[ue];if(Z.visible){m=Z.visibleChildIndex;break}}const w=[];let O=0,V=0;for(const ue of I)w.push(ue),V+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=m+O++);const ie=(0,R.splice)(A.children,h,a,w);y?A.lastDiffIds?(0,R.splice)(A.lastDiffIds,h,a,w.map(ue=>y.getId(ue.element).toString())):A.lastDiffIds=A.children.map(ue=>y.getId(ue.element).toString()):A.lastDiffIds=void 0;let se=0;for(const ue of ie)ue.visible&&se++;if(se!==0)for(let ue=h+w.length;ue<A.children.length;ue++){const Z=A.children[ue];Z.visible&&(Z.visibleChildIndex-=se)}if(A.visibleChildrenCount+=O-se,d&&p){const ue=ie.reduce((Z,Q)=>Z+(Q.visible?Q.renderNodeCount:0),0);this.B(A,V-ue),this.p.splice(S,ue,L)}if(ie.length>0&&o){const ue=Z=>{o(Z),Z.children.forEach(ue)};ie.forEach(ue)}this.l.fire({insertedNodes:w,deletedNodes:ie});const ae=A.children.length>0;b!==ae&&this.setCollapsible(e.slice(0,-1),ae);let de=A;for(;de;){if(de.visibility===2){this.m.trigger(()=>this.refilter());break}de=de.parent}}rerender(e){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{node:a,listIndex:n,revealed:s}=this.F(e);a.visible&&s&&this.p.splice(n,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{listIndex:n}=this.F(e);this.p.updateElementHeight(n,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:n,revealed:s}=this.F(e);return n&&s?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const n=this.E(e);typeof a>"u"&&(a=!n.collapsible);const s={collapsible:a};return this.d.bufferEvents(()=>this.t(e,s))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,n){const s=this.E(e);typeof a>"u"&&(a=!s.collapsed);const o={collapsed:a,recursive:n||!1};return this.d.bufferEvents(()=>this.t(e,o))}t(e,a){const{node:n,listIndex:s,revealed:o}=this.F(e),y=this.u(n,s,o,a);if(n!==this.c&&this.k&&y&&!P(a)&&n.collapsible&&!n.collapsed&&!a.recursive){let A=-1;for(let S=0;S<n.children.length;S++)if(n.children[S].visible)if(A>-1){A=-1;break}else A=S;A>-1&&this.t([...e,A],a)}return y}u(e,a,n,s){const o=this.v(e,s,!1);if(!n||!e.visible||!o)return o;const y=e.renderNodeCount,A=this.x(e),S=y-(a===-1?0:1);return this.p.splice(a+1,S,A.slice(1)),o}v(e,a,n){let s;if(e===this.c?s=!1:(P(a)?(s=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(s=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):s=!1,s&&this.f.fire({node:e,deep:n})),!P(a)&&a.recursive)for(const o of e.children)s=this.v(o,a,!0)||s;return s}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,n,s,o,y){const A={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},S=this.C(A,n);A.visibility=S,s&&o.push(A);const d=e.children||g.Iterable.empty(),p=s&&S!==0&&!A.collapsed;let L=0,I=1;for(const h of d){const b=this.w(h,A,S,p,o,y);A.children.push(b),I+=b.renderNodeCount,b.visible&&(b.visibleChildIndex=L++)}return A.collapsible=A.collapsible||A.children.length>0,A.visibleChildrenCount=L,A.visible=S===2?L>0:S===1,A.visible?A.collapsed||(A.renderNodeCount=I):(A.renderNodeCount=0,s&&o.pop()),y?.(A),A}x(e){const a=e.renderNodeCount,n=[];return this.y(e,n),this.B(e.parent,n.length-a),n}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this.y(n,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,n=[];return this.A(e,e.visible?1:0,n),this.B(e.parent,n.length-a),n}A(e,a,n,s=!0){let o;if(e!==this.c){if(o=this.C(e,a),o===0)return e.visible=!1,e.renderNodeCount=0,!1;s&&n.push(e)}const y=n.length;e.renderNodeCount=e===this.c?0:1;let A=!1;if(!e.collapsed||o!==0){let S=0;for(const d of e.children)A=this.A(d,o,n,s&&!e.collapsed)||A,d.visible&&(d.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=o===2?A:o===1,e.visibility=o),e.visible?e.collapsed||(e.renderNodeCount+=n.length-y):(e.renderNodeCount=0,s&&n.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const n=this.j?this.j.filter(e.element,a):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):l(n)?(e.filterData=n.data,c(n.visibility)):(e.filterData=void 0,c(n))}D(e,a=this.c){if(!e||e.length===0)return!0;const[n,...s]=e;return n<0||n>a.children.length?!1:this.D(s,a.children[n])}E(e,a=this.c){if(!e||e.length===0)return a;const[n,...s]=e;if(n<0||n>a.children.length)throw new E.TreeError(this.o,"Invalid tree location");return this.E(s,a.children[n])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:n,revealed:s,visible:o}=this.G(e),y=e[e.length-1];if(y<0||y>a.children.length)throw new E.TreeError(this.o,"Invalid tree location");const A=a.children[y];return{node:A,listIndex:n,revealed:s,visible:o&&A.visible}}G(e,a=this.c,n=0,s=!0,o=!0){const[y,...A]=e;if(y<0||y>a.children.length)throw new E.TreeError(this.o,"Invalid tree location");for(let S=0;S<y;S++)n+=a.children[S].renderNodeCount;return s=s&&!a.collapsed,o=o&&a.visible,A.length===0?{parentNode:a,listIndex:n,revealed:s,visible:o}:this.G(A,a.children[y],n+1,s,o)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let n=e;for(;n.parent;)a.push(n.parent.children.indexOf(n)),n=n.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,R.tail2)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(ge[119],me([1,0,54,24,26]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class W{get size(){return this.d.size}constructor(D,g,l={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new E.IndexTreeModel(D,g,null,l),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,l.sorter&&(this.j={compare(c,P){return l.sorter.compare(c.element,P.element)}}),this.h=l.identityProvider}setChildren(D,g=i.Iterable.empty(),l={}){const c=this.o(D);this.l(c,this.m(g),l)}l(D,g=i.Iterable.empty(),l){const c=new Set,P=new Set,r=e=>{if(e.element===null)return;const a=e;if(c.add(a.element),this.d.set(a.element,a),this.h){const n=this.h.getId(a.element).toString();P.add(n),this.f.set(n,a)}l.onDidCreateNode?.(a)},u=e=>{if(e.element===null)return;const a=e;if(c.has(a.element)||this.d.delete(a.element),this.h){const n=this.h.getId(a.element).toString();P.has(n)||this.f.delete(n)}l.onDidDeleteNode?.(a)};this.c.splice([...D,0],Number.MAX_VALUE,g,{...l,onDidCreateNode:r,onDidDeleteNode:u})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,g=>{let l=this.d.get(g.element);if(!l&&this.h){const r=this.h.getId(g.element).toString();l=this.f.get(r)}if(!l)return{...g,children:this.m(g.children)};const c=typeof g.collapsible=="boolean"?g.collapsible:l.collapsible,P=typeof g.collapsed<"u"?g.collapsed:l.collapsed;return{...g,collapsible:c,collapsed:P,children:this.m(g.children)}})}rerender(D){const g=this.o(D);this.c.rerender(g)}updateElementHeight(D,g){const l=this.o(D);this.c.updateElementHeight(l,g)}resort(D=null,g=!0){if(!this.j)return;const l=this.o(D),c=this.c.getNode(l);this.l(l,this.n(c,g),{})}n(D,g,l=!0){let c=[...D.children];return(g||l)&&(c=c.sort(this.j.compare.bind(this.j))),i.Iterable.map(c,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,g,!1)}))}getFirstElementChild(D=null){const g=this.o(D);return this.c.getFirstElementChild(g)}getLastElementAncestor(D=null){const g=this.o(D);return this.c.getLastElementAncestor(g)}has(D){return this.d.has(D)}getListIndex(D){const g=this.o(D);return this.c.getListIndex(g)}getListRenderCount(D){const g=this.o(D);return this.c.getListRenderCount(g)}isCollapsible(D){const g=this.o(D);return this.c.isCollapsible(g)}setCollapsible(D,g){const l=this.o(D);return this.c.setCollapsible(l,g)}isCollapsed(D){const g=this.o(D);return this.c.isCollapsed(g)}setCollapsed(D,g,l){const c=this.o(D);return this.c.setCollapsed(c,g,l)}expandTo(D){const g=this.o(D);this.c.expandTo(g)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const g=this.d.get(D);if(!g)throw new R.TreeError(this.k,`Tree element not found: ${D}`);return g}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new R.TreeError(this.k,"Invalid getParentNodeLocation call");const g=this.d.get(D);if(!g)throw new R.TreeError(this.k,`Tree element not found: ${D}`);const l=this.c.getNodeLocation(g),c=this.c.getParentNodeLocation(l);return this.c.getNode(c).element}o(D){if(D===null)return[];const g=this.d.get(D);if(!g)throw new R.TreeError(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(g)}}t.ObjectTreeModel=W}),define(ge[19],me([1,0,4,14,21,23,2]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class D extends v.Disposable{f(l,c){this.D(E.addDisposableListener(l,E.EventType.CLICK,P=>c(new i.StandardMouseEvent(P))))}j(l,c){this.D(E.addDisposableListener(l,E.EventType.MOUSE_DOWN,P=>c(new i.StandardMouseEvent(P))))}k(l,c){this.D(E.addDisposableListener(l,E.EventType.MOUSE_OVER,P=>c(new i.StandardMouseEvent(P))))}m(l,c){this.D(E.addDisposableListener(l,E.EventType.MOUSE_LEAVE,P=>c(new i.StandardMouseEvent(P))))}p(l,c){this.D(E.addDisposableListener(l,E.EventType.KEY_DOWN,P=>c(new R.StandardKeyboardEvent(P))))}q(l,c){this.D(E.addDisposableListener(l,E.EventType.KEY_UP,P=>c(new R.StandardKeyboardEvent(P))))}u(l,c){this.D(E.addDisposableListener(l,E.EventType.INPUT,c))}z(l,c){this.D(E.addDisposableListener(l,E.EventType.BLUR,c))}C(l,c){this.D(E.addDisposableListener(l,E.EventType.FOCUS,c))}F(l,c){this.D(E.addDisposableListener(l,E.EventType.CHANGE,c))}G(l){return W.Gesture.ignoreTarget(l)}}t.Widget=D}),define(ge[35],me([1,0,52,19,9,17,4]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class D extends R.Widget{constructor(l){super(),this.a=l.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=l.bgWidth+"px",this.bgDomNode.style.height=l.bgHeight+"px",typeof l.top<"u"&&(this.bgDomNode.style.top="0px"),typeof l.left<"u"&&(this.bgDomNode.style.left="0px"),typeof l.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof l.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=l.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(l.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof l.top<"u"&&(this.domNode.style.top=l.top+"px"),typeof l.left<"u"&&(this.domNode.style.left=l.left+"px"),typeof l.bottom<"u"&&(this.domNode.style.bottom=l.bottom+"px"),typeof l.right<"u"&&(this.domNode.style.right=l.right+"px"),this.g=this.D(new E.GlobalPointerMoveMonitor),this.D(v.addStandardDisposableListener(this.bgDomNode,v.EventType.POINTER_DOWN,c=>this.h(c))),this.D(v.addStandardDisposableListener(this.domNode,v.EventType.POINTER_DOWN,c=>this.h(c))),this.b=this.D(new i.IntervalTimer),this.c=this.D(new i.TimeoutTimer)}h(l){if(!l.target||!(l.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(l.target,l.pointerId,l.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),l.preventDefault()}}t.ScrollbarArrow=D}),define(ge[55],me([1,0,4,38,52,35,117,19,5]),function(J,t,E,R,i,W,v,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const l=140;class c extends D.Widget{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.D(new v.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.D(new i.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,R.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.D(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,u=>this.y(u)))}r(r){const u=this.D(new W.ScrollbarArrow(r));this.domNode.domNode.appendChild(u.bgDomNode),this.domNode.domNode.appendChild(u.domNode)}s(r,u,e,a){this.slider=(0,R.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(u),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.D(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this.I(n))})),this.f(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.H(r)}delegatePointerDown(r){const u=this.domNode.domNode.getClientRects()[0].top,e=u+this.h.getSliderPosition(),a=u+this.h.getSliderPosition()+this.h.getSliderSize(),n=this.O(r);e<=n&&n<=a?r.button===0&&(r.preventDefault(),this.I(r)):this.H(r)}H(r){let u,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")u=r.offsetX,e=r.offsetY;else{const n=E.getDomNodePagePosition(this.domNode.domNode);u=r.pageX-n.left,e=r.pageY-n.top}const a=this.N(u,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),r.button===0&&(r.preventDefault(),this.I(r))}I(r){if(!r.target||!(r.target instanceof Element))return;const u=this.O(r),e=this.P(r),a=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const s=this.P(n),o=Math.abs(s-e);if(g.isWindows&&o>l){this.J(a.getScrollPosition());return}const A=this.O(n)-u;this.J(a.getDesiredScrollPositionFromDelta(A))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(r){const u={};this.writeScrollPosition(u,r),this.b.setScrollPositionNow(u)}updateScrollbarSize(r){this.Q(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=c}),define(ge[120],me([1,0,21,55,35,39,16]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class D extends R.AbstractScrollbar{constructor(l,c,P){const r=l.getScrollDimensions(),u=l.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:P,scrollbarState:new W.ScrollbarState(c.horizontalHasArrows?c.arrowSize:0,c.horizontal===2?0:c.horizontalScrollbarSize,c.vertical===2?0:c.verticalScrollbarSize,r.width,r.scrollWidth,u.scrollLeft),visibility:c.horizontal,extraScrollbarClassName:"horizontal",scrollable:l,scrollByPage:c.scrollByPage}),c.horizontalHasArrows){const e=(c.arrowSize-i.ARROW_IMG_SIZE)/2,a=(c.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:v.Codicon.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:v.Codicon.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((c.horizontalScrollbarSize-c.horizontalSliderSize)/2),0,void 0,c.horizontalSliderSize)}M(l,c){this.slider.setWidth(l),this.slider.setLeft(c)}L(l,c){this.domNode.setWidth(l),this.domNode.setHeight(c),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(l){return this.n=this.v(l.scrollWidth)||this.n,this.n=this.w(l.scrollLeft)||this.n,this.n=this.t(l.width)||this.n,this.n}N(l,c){return l}O(l){return l.pageX}P(l){return l.pageY}Q(l){this.slider.setHeight(l)}writeScrollPosition(l,c){l.scrollLeft=c}updateOptions(l){this.updateScrollbarSize(l.horizontal===2?0:l.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this.i.setVisibility(l.horizontal),this.c=l.scrollByPage}}t.HorizontalScrollbar=D}),define(ge[121],me([1,0,21,55,35,39,16]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class D extends R.AbstractScrollbar{constructor(l,c,P){const r=l.getScrollDimensions(),u=l.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:P,scrollbarState:new W.ScrollbarState(c.verticalHasArrows?c.arrowSize:0,c.vertical===2?0:c.verticalScrollbarSize,0,r.height,r.scrollHeight,u.scrollTop),visibility:c.vertical,extraScrollbarClassName:"vertical",scrollable:l,scrollByPage:c.scrollByPage}),c.verticalHasArrows){const e=(c.arrowSize-i.ARROW_IMG_SIZE)/2,a=(c.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:v.Codicon.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:v.Codicon.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((c.verticalScrollbarSize-c.verticalSliderSize)/2),c.verticalSliderSize,void 0)}M(l,c){this.slider.setHeight(l),this.slider.setTop(c)}L(l,c){this.domNode.setWidth(c),this.domNode.setHeight(l),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(l){return this.n=this.v(l.scrollHeight)||this.n,this.n=this.w(l.scrollTop)||this.n,this.n=this.t(l.height)||this.n,this.n}N(l,c){return c}O(l){return l.pageY}P(l){return l.pageX}Q(l){this.slider.setWidth(l)}writeScrollPosition(l,c){l.scrollTop=c}updateOptions(l){this.updateScrollbarSize(l.vertical===2?0:l.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(l.vertical),this.c=l.scrollByPage}}t.VerticalScrollbar=D}),define(ge[56],me([1,0,18,4,38,21,120,121,19,9,3,2,5,48,90]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,a=50,n=!0;class s{constructor(I,h,b){this.timestamp=I,this.deltaX=h,this.deltaY=b,this.score=0}}class o{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let I=1,h=0,b=1,m=this.d;do{const w=m===this.c?I:Math.pow(2,-b);if(I-=w,h+=this.b[m].score*w,m===this.c)break;m=(this.a+m-1)%this.a,b++}while(!0);return h<=.5}acceptStandardWheelEvent(I){const h=window.devicePixelRatio/(0,E.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),I.deltaX/h,I.deltaY/h):this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,h,b){const m=new s(I,h,b);m.score=this.f(m),this.c===-1&&this.d===-1?(this.b[0]=m,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=m)}f(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let h=.5;const b=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(I.deltaX)||!this.g(I.deltaY))&&(h+=.25),Math.min(Math.max(h,0),1)}g(I){return Math.abs(Math.round(I)-I)<.01}}o.INSTANCE=new o,t.MouseWheelClassifier=o;class y extends g.Widget{get options(){return this.a}constructor(I,h,b){super(),this.I=this.D(new c.Emitter),this.onScroll=this.I.event,this.J=this.D(new c.Emitter),this.onWillScroll=this.J.event,I.style.overflow="hidden",this.a=p(h),this.b=b,this.D(this.b.onScroll(w=>{this.J.fire(w),this.N(w),this.I.fire(w)}));const m={onMouseWheel:w=>this.M(w),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.D(new D.VerticalScrollbar(this.b,this.a,m)),this.g=this.D(new v.HorizontalScrollbar(this.b,this.a,m)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(I),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,i.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,i.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,i.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,w=>this.S(w)),this.m(this.r,w=>this.R(w)),this.w=this.D(new l.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,P.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this.c.delegatePointerDown(I)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(I){this.b.setScrollDimensions(I,!1)}updateClassName(I){this.a.className=I,r.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this.a.handleMouseWheel=I.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this.a.horizontal=I.horizontal),typeof I.vertical<"u"&&(this.a.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this.a.scrollByPage=I.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(I){this.H=I}delegateScrollFromMouseWheelEvent(I){this.M(new W.StandardWheelEvent(I))}L(I){if(this.s.length>0!==I&&(this.s=(0,P.dispose)(this.s),I)){const b=m=>{this.M(new W.StandardWheelEvent(m))};this.s.push(R.addDisposableListener(this.r,R.EventType.MOUSE_WHEEL,b,{passive:!1}))}}M(I){const h=o.INSTANCE;n&&h.acceptStandardWheelEvent(I);let b=!1;if(I.deltaY||I.deltaX){let w=I.deltaY*this.a.mouseWheelScrollSensitivity,O=I.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(w)>=Math.abs(O)?O=0:w=0),this.a.flipAxes&&([w,O]=[O,w]);const V=!r.isMacintosh&&I.browserEvent&&I.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!O&&(O=w,w=0),I.browserEvent&&I.browserEvent.altKey&&(O=O*this.a.fastScrollSensitivity,w=w*this.a.fastScrollSensitivity);const ie=this.b.getFutureScrollPosition();let se={};if(w){const ae=a*w,de=ie.scrollTop-(ae<0?Math.floor(ae):Math.ceil(ae));this.c.writeScrollPosition(se,de)}if(O){const ae=a*O,de=ie.scrollLeft-(ae<0?Math.floor(ae):Math.ceil(ae));this.g.writeScrollPosition(se,de)}se=this.b.validateScrollPosition(se),(ie.scrollLeft!==se.scrollLeft||ie.scrollTop!==se.scrollTop)&&(n&&this.a.mouseWheelSmoothScroll&&h.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(se):this.b.setScrollPositionNow(se),b=!0)}let m=b;!m&&this.a.alwaysConsumeMouseWheel&&(m=!0),!m&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(m=!0),m&&(I.preventDefault(),I.stopPropagation())}N(I){this.y=this.g.onDidScroll(I)||this.y,this.y=this.c.onDidScroll(I)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const I=this.b.getCurrentScrollPosition(),h=I.scrollTop>0,b=I.scrollLeft>0,m=b?" left":"",w=h?" top":"",O=b||h?" top-left-corner":"";this.i.setClassName(`shadow${m}`),this.l.setClassName(`shadow${w}`),this.n.setClassName(`shadow${O}${w}${m}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(I){this.v=!1,this.W()}S(I){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=y;class A extends y{constructor(I,h){h=h||{},h.mouseWheelSmoothScroll=!1;const b=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>R.scheduleAtNextAnimationFrame(m)});super(I,h,b),this.D(b)}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=A;class S extends y{constructor(I,h,b){super(I,h,b)}setScrollPosition(I){I.reuseAnimation?this.b.setScrollPositionSmooth(I,I.reuseAnimation):this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class d extends y{constructor(I,h){h=h||{},h.mouseWheelSmoothScroll=!1;const b=new u.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>R.scheduleAtNextAnimationFrame(m)});super(I,h,b),this.D(b),this.Y=I,this.onScroll(m=>{m.scrollTopChanged&&(this.Y.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this.Y.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=d;function p(L){const I={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return I.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:I.verticalScrollbarSize,r.isMacintosh&&(I.className+=" mac"),I}}),define(ge[57],me([1,0,50,4,20,23,56,13,9,25,3,2,45,48,78,116,7]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u,e,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const s={CurrentDragAndDropData:void 0},o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(I){return[I]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class y{get context(){return this.d}set context(h){this.d=h}constructor(h){this.elements=h}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=y;class A{constructor(h){this.elements=h}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=A;class S{constructor(){this.types=[],this.files=[]}update(h){if(h.types&&this.types.splice(0,this.types.length,...h.types),h.files){this.files.splice(0,this.files.length);for(let b=0;b<h.files.length;b++){const m=h.files.item(b);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function d(I,h){return Array.isArray(I)&&Array.isArray(h)?(0,D.equals)(I,h):I===h}class p{constructor(h){h?.getSetSize?this.getSetSize=h.getSetSize.bind(h):this.getSetSize=(b,m,w)=>w,h?.getPosInSet?this.getPosInSet=h.getPosInSet.bind(h):this.getPosInSet=(b,m)=>m+1,h?.getRole?this.getRole=h.getRole.bind(h):this.getRole=b=>"listitem",h?.isChecked?this.isChecked=h.isChecked.bind(h):this.isChecked=b=>{}}}class L{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(h){if(h!==this.N){if(h&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=h,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const b of this.d)this.X(b);this.U(),this.q.setScrollDimensions({width:(0,R.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(h,b,m,w=o){if(this.P=b,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new g.Delayer(50),this.v=!1,this.x=P.Disposable.None,this.y=0,this.G=!1,this.J=P.Disposable.None,this.K=P.Disposable.None,this.L=new P.DisposableStore,this.M=new c.Emitter,this.onDidChangeContentHeight=c.Event.latch(this.M.event,void 0,this.L),this.N=!1,w.horizontalScrolling&&w.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of m)this.j.set(V.templateId,V);this.h=this.L.add(new a.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof w.mouseSupport=="boolean"?w.mouseSupport:!0),this.N=w.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof w.additionalScrollHeight>"u"?0:w.additionalScrollHeight,this.D=new p(w.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(w.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(W.Gesture.addTarget(this.o)),this.p=new u.Scrollable({forceIntegerValues:!0,smoothScrollDuration:w.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,R.scheduleAtNextAnimationFrame)(V)}),this.q=this.L.add(new v.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:w.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:w.verticalScrollMode??o.verticalScrollMode,useShadows:w.useShadows??o.useShadows,mouseWheelScrollSensitivity:w.mouseWheelScrollSensitivity,fastScrollSensitivity:w.fastScrollSensitivity,scrollByPage:w.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),h.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,R.addDisposableListener)(this.o,W.EventType.Change,V=>this.gb(V))),this.L.add((0,R.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.L.add((0,R.addDisposableListener)(this.domNode,"dragover",V=>this.ib(this.eb(V)))),this.L.add((0,R.addDisposableListener)(this.domNode,"drop",V=>this.kb(this.eb(V)))),this.L.add((0,R.addDisposableListener)(this.domNode,"dragleave",V=>this.jb(this.eb(V)))),this.L.add((0,R.addDisposableListener)(this.domNode,"dragend",V=>this.lb(V))),this.z=w.setRowLineHeight??o.setRowLineHeight,this.A=w.setRowHeight??o.setRowHeight,this.B=w.supportDynamicHeights??o.supportDynamicHeights,this.F=w.dnd??o.dnd,this.layout(w.initialSize?.height,w.initialSize?.width)}updateOptions(h){h.additionalScrollHeight!==void 0&&(this.C=h.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),h.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(h.smoothScrolling?125:0),h.horizontalScrolling!==void 0&&(this.O=h.horizontalScrolling);let b;h.scrollByPage!==void 0&&(b={...b??{},scrollByPage:h.scrollByPage}),h.mouseWheelScrollSensitivity!==void 0&&(b={...b??{},mouseWheelScrollSensitivity:h.mouseWheelScrollSensitivity}),h.fastScrollSensitivity!==void 0&&(b={...b??{},fastScrollSensitivity:h.fastScrollSensitivity}),b&&this.q.updateOptions(b)}delegateScrollFromMouseWheelEvent(h){this.q.delegateScrollFromMouseWheelEvent(h)}delegateVerticalScrollbarPointerDown(h){this.q.delegateVerticalScrollbarPointerDown(h)}updateElementHeight(h,b,m){if(h<0||h>=this.d.length)return;const w=this.d[h].size;if(typeof b>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[h].lastDynamicHeightWidth=void 0,b=w+this.tb(h)}if(w===b)return;const O=this.rb(this.k,this.m);let V=0;h<O.start||m!==null&&m>h&&m<=O.end?V=b-w:V=0,this.g.splice(h,1,[{size:b}]),this.d[h].size=b,this.V(O,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(h,b,m=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(h,b,m)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(h,b,m=[]){const w=this.rb(this.k,this.m),O={start:h,end:h+b},V=r.Range.intersect(w,O),ie=new Map;for(let te=V.end-1;te>=V.start;te--){const T=this.d[te];if(T.dragStartDisposable.dispose(),T.checkedDisposable.dispose(),T.row){let x=ie.get(T.templateId);x||(x=[],ie.set(T.templateId,x));const M=this.j.get(T.templateId);M&&M.disposeElement&&M.disposeElement(T.element,te,T.row.templateData,T.size),x.push(T.row)}T.row=null}const se={start:h+b,end:this.d.length},ae=r.Range.intersect(se,w),de=r.Range.relativeComplement(se,w),ue=m.map(te=>({id:String(this.f++),element:te,templateId:this.P.getTemplateId(te),size:this.P.getHeight(te),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(te),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.Disposable.None,checkedDisposable:P.Disposable.None}));let Z;h===0&&b>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,ue),Z=this.d,this.d=ue):(this.g.splice(h,b,ue),Z=this.d.splice(h,b,...ue));const Q=m.length-b,ve=this.rb(this.k,this.m),pe=(0,e.shift)(ae,Q),Me=r.Range.intersect(ve,pe);for(let te=Me.start;te<Me.end;te++)this.Y(this.d[te],te);const Re=r.Range.relativeComplement(pe,ve);for(const te of Re)for(let T=te.start;T<te.end;T++)this.Z(T);const le=de.map(te=>(0,e.shift)(te,Q)),ne=[{start:h,end:h+m.length},...le].map(te=>r.Range.intersect(ve,te)),ee=this.ub(ne);for(const te of ne)for(let T=te.start;T<te.end;T++){const x=this.d[T],f=ie.get(x.templateId)?.pop();this.W(T,ee,f)}for(const te of ie.values())for(const T of te)this.h.release(T);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),Z.map(te=>te.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,R.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let h=0;for(const b of this.d)typeof b.width<"u"&&(h=Math.max(h,b.width));this.E=h,this.q.setScrollDimensions({scrollWidth:h===0?0:h+10})}updateWidth(h){if(!this.O||typeof this.E>"u")return;const b=this.d[h];this.X(b),typeof b.width<"u"&&b.width>this.E&&(this.E=b.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const h of this.d)h.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const h=this.rb(this.k,this.m),b=this.g.positionAt(h.start),m=this.g.positionAt(h.start+1);return m!==-1&&(m-b)/2+b<this.scrollTop?h.start+1:h.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(h){return this.d[h].element}indexOf(h){return this.d.findIndex(b=>b.element===h)}domElement(h){const b=this.d[h].row;return b&&b.domNode}elementHeight(h){return this.d[h].size}elementTop(h){return this.g.positionAt(h)}indexAt(h){return this.g.indexAt(h)}indexAfter(h){return this.g.indexAfter(h)}layout(h,b){const m={height:typeof h=="number"?h:(0,R.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,m.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(m),typeof b<"u"&&(this.n=b,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof b=="number"?b:(0,R.getContentWidth)(this.domNode)})}V(h,b,m,w,O,V=!1){const ie=this.rb(b,m),se=r.Range.relativeComplement(ie,h),ae=r.Range.relativeComplement(h,ie),de=this.ub(se);if(V){const ue=r.Range.intersect(h,ie);for(let Z=ue.start;Z<ue.end;Z++)this.Y(this.d[Z],Z)}this.h.transact(()=>{for(const ue of ae)for(let Z=ue.start;Z<ue.end;Z++)this.Z(Z);for(const ue of se)for(let Z=ue.start;Z<ue.end;Z++)this.W(Z,de)}),w!==void 0&&(this.o.style.left=`-${w}px`),this.o.style.top=`-${b}px`,this.O&&O!==void 0&&(this.o.style.width=`${Math.max(O,this.n)}px`),this.k=b,this.m=m}W(h,b,m){const w=this.d[h];let O=!1;if(!w.row)if(m)w.row=m;else{const de=this.h.alloc(w.templateId);w.row=de.row,O=de.isReusingConnectedDomNode}const V=this.D.getRole(w.element)||"listitem";w.row.domNode.setAttribute("role",V);const ie=this.D.isChecked(w.element);if(typeof ie=="boolean")w.row.domNode.setAttribute("aria-checked",String(!!ie));else if(ie){const de=ue=>w.row.domNode.setAttribute("aria-checked",String(!!ue));de(ie.value),w.checkedDisposable=ie.onDidChange(de)}(O||!w.row.domNode.parentElement)&&(b?this.o.insertBefore(w.row.domNode,b):this.o.appendChild(w.row.domNode)),this.Y(w,h);const se=this.j.get(w.templateId);if(!se)throw new Error(`No renderer found for template id ${w.templateId}`);se?.renderElement(w.element,h,w.row.templateData,w.size);const ae=this.F.getDragURI(w.element);w.dragStartDisposable.dispose(),w.row.domNode.draggable=!!ae,ae&&(w.dragStartDisposable=(0,R.addDisposableListener)(w.row.domNode,"dragstart",de=>this.hb(w.element,ae,de))),this.O&&(this.X(w),this.S())}X(h){if(!h.row||!h.row.domNode)return;h.row.domNode.style.width="fit-content",h.width=(0,R.getContentWidth)(h.row.domNode);const b=window.getComputedStyle(h.row.domNode);b.paddingLeft&&(h.width+=parseFloat(b.paddingLeft)),b.paddingRight&&(h.width+=parseFloat(b.paddingRight)),h.row.domNode.style.width=""}Y(h,b){h.row.domNode.style.top=`${this.elementTop(b)}px`,this.A&&(h.row.domNode.style.height=`${h.size}px`),this.z&&(h.row.domNode.style.lineHeight=`${h.size}px`),h.row.domNode.setAttribute("data-index",`${b}`),h.row.domNode.setAttribute("data-last-element",b===this.length-1?"true":"false"),h.row.domNode.setAttribute("data-parity",b%2===0?"even":"odd"),h.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(h.element,b,this.length))),h.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(h.element,b))),h.row.domNode.setAttribute("id",this.getElementDomId(b)),h.row.domNode.classList.toggle("drop-target",h.dropTarget)}Z(h){const b=this.d[h];if(b.dragStartDisposable.dispose(),b.checkedDisposable.dispose(),b.row){const m=this.j.get(b.templateId);m&&m.disposeElement&&m.disposeElement(b.element,h,b.row.templateData,b.size),this.h.release(b.row),b.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(h,b){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:h,reuseAnimation:b})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(h){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:h})}get scrollTop(){return this.getScrollTop()}set scrollTop(h){this.setScrollTop(h)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"click")).event,h=>this.ab(h),this.L)}get onMouseDblClick(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"dblclick")).event,h=>this.ab(h),this.L)}get onMouseMiddleClick(){return c.Event.filter(c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"auxclick")).event,h=>this.ab(h),this.L),h=>h.browserEvent.button===1,this.L)}get onMouseUp(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseup")).event,h=>this.ab(h),this.L)}get onMouseDown(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousedown")).event,h=>this.ab(h),this.L)}get onMouseOver(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseover")).event,h=>this.ab(h),this.L)}get onMouseMove(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousemove")).event,h=>this.ab(h),this.L)}get onMouseOut(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseout")).event,h=>this.ab(h),this.L)}get onContextMenu(){return c.Event.any(c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"contextmenu")).event,h=>this.ab(h),this.L),c.Event.map(this.L.add(new i.DomEmitter(this.domNode,W.EventType.Contextmenu)).event,h=>this.db(h),this.L))}get onTouchStart(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"touchstart")).event,h=>this.bb(h),this.L)}get onTap(){return c.Event.map(this.L.add(new i.DomEmitter(this.o,W.EventType.Tap)).event,h=>this.db(h),this.L)}ab(h){const b=this.qb(h.target||null),m=typeof b>"u"?void 0:this.d[b],w=m&&m.element;return{browserEvent:h,index:b,element:w}}bb(h){const b=this.qb(h.target||null),m=typeof b>"u"?void 0:this.d[b],w=m&&m.element;return{browserEvent:h,index:b,element:w}}db(h){const b=this.qb(h.initialTarget||null),m=typeof b>"u"?void 0:this.d[b],w=m&&m.element;return{browserEvent:h,index:b,element:w}}eb(h){const b=this.qb(h.target||null),m=typeof b>"u"?void 0:this.d[b],w=m&&m.element;return{browserEvent:h,index:b,element:w}}fb(h){try{const b=this.rb(this.k,this.m);this.V(b,h.scrollTop,h.height,h.scrollLeft,h.scrollWidth),this.B&&this.sb(h.scrollTop,h.height,h.inSmoothScrolling)}catch(b){throw console.error("Got bad scroll event:",h),b}}gb(h){h.preventDefault(),h.stopPropagation(),this.scrollTop-=h.translationY}hb(h,b,m){if(!m.dataTransfer)return;const w=this.F.getDragElements(h);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(E.DataTransfers.TEXT,b),m.dataTransfer.setDragImage){let O;this.F.getDragLabel&&(O=this.F.getDragLabel(w,m)),typeof O>"u"&&(O=String(w.length));const V=(0,R.$)(".monaco-drag-image");V.textContent=O;const se=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||document.body})(this.domNode);se.appendChild(V),m.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>se.removeChild(V),0)}this.domNode.classList.add("dragging"),this.H=new y(w),s.CurrentDragAndDropData=new A(w),this.F.onDragStart?.(this.H,m)}ib(h){if(h.browserEvent.preventDefault(),this.K.dispose(),s.CurrentDragAndDropData&&s.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(h.browserEvent),!h.browserEvent.dataTransfer))return!1;if(!this.H)if(s.CurrentDragAndDropData)this.H=s.CurrentDragAndDropData;else{if(!h.browserEvent.dataTransfer.types)return!1;this.H=new S}const b=this.F.onDragOver(this.H,h.element,h.index,h.browserEvent);if(this.G=typeof b=="boolean"?b:b.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;h.browserEvent.dataTransfer.dropEffect=typeof b!="boolean"&&b.effect===0?"copy":"move";let m;if(typeof b!="boolean"&&b.feedback?m=b.feedback:typeof h.index>"u"?m=[-1]:m=[h.index],m=(0,D.distinct)(m).filter(w=>w>=-1&&w<this.length).sort((w,O)=>w-O),m=m[0]===-1?[-1]:m,d(this.I,m))return!0;if(this.I=m,this.J.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,P.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const w of m){const O=this.d[w];O.dropTarget=!0,O.row?.domNode.classList.add("drop-target")}this.J=(0,P.toDisposable)(()=>{for(const w of m){const O=this.d[w];O.dropTarget=!1,O.row?.domNode.classList.remove("drop-target")}})}return!0}jb(h){this.K.dispose(),this.K=(0,g.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,h.element,h.index,h.browserEvent)}kb(h){if(!this.G)return;const b=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,s.CurrentDragAndDropData=void 0,!(!b||!h.browserEvent.dataTransfer)&&(h.browserEvent.preventDefault(),b.update(h.browserEvent.dataTransfer),this.F.drop(b,h.element,h.index,h.browserEvent))}lb(h){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,s.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(h)}mb(){this.I=void 0,this.J.dispose(),this.J=P.Disposable.None}nb(h){if(!this.w){const b=(0,R.getTopLeftOffset)(this.domNode).top;this.w=(0,R.animate)(this.ob.bind(this,b))}this.x.dispose(),this.x=(0,g.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=h.pageY}ob(h){if(this.y===void 0)return;const b=this.y-h,m=this.renderHeight-35;b<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(b-35))):b>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(b-m))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(h){const b=this.q.getDomNode();let m=h;for(;m instanceof HTMLElement&&m!==this.o&&b.contains(m);){const w=m.getAttribute("data-index");if(w){const O=Number(w);if(!isNaN(O))return O}m=m.parentElement}}rb(h,b){return{start:this.g.indexAt(h),end:this.g.indexAfter(h+b-1)}}sb(h,b,m){const w=this.rb(h,b);let O,V;h===this.elementTop(w.start)?(O=w.start,V=0):w.end-w.start>1&&(O=w.start+1,V=this.elementTop(O)-h);let ie=0;for(;;){const se=this.rb(h,b);let ae=!1;for(let de=se.start;de<se.end;de++){const ue=this.tb(de);ue!==0&&this.g.splice(de,1,[this.d[de]]),ie+=ue,ae=ae||ue!==0}if(!ae){ie!==0&&this.R();const de=r.Range.relativeComplement(w,se);for(const Z of de)for(let Q=Z.start;Q<Z.end;Q++)this.d[Q].row&&this.Z(Q);const ue=r.Range.relativeComplement(se,w);for(const Z of ue)for(let Q=Z.start;Q<Z.end;Q++){const ve=Q+1,pe=ve<this.d.length?this.d[ve].row:null,Me=pe?pe.domNode:null;this.W(Q,Me)}for(let Z=se.start;Z<se.end;Z++)this.d[Z].row&&this.Y(this.d[Z],Z);if(typeof O=="number"){const Z=this.p.getFutureScrollPosition().scrollTop-h,Q=this.elementTop(O)-V+Z;this.setScrollTop(Q,m)}this.M.fire(this.contentHeight);return}}}tb(h){const b=this.d[h];if(this.P.getDynamicHeight){const V=this.P.getDynamicHeight(b.element);if(V!==null){const ie=b.size;return b.size=V,b.lastDynamicHeightWidth=this.n,V-ie}}if(!b.hasDynamicHeight||b.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(b.element))return 0;const m=b.size;if(b.row)return b.row.domNode.style.height="",b.size=b.row.domNode.offsetHeight,b.lastDynamicHeightWidth=this.n,b.size-m;const{row:w}=this.h.alloc(b.templateId);w.domNode.style.height="",this.o.appendChild(w.domNode);const O=this.j.get(b.templateId);if(!O)throw new n.BugIndicatingError("Missing renderer for templateId: "+b.templateId);return O.renderElement(b.element,h,w.templateData,void 0),b.size=w.domNode.offsetHeight,O.disposeElement?.(b.element,h,w.templateData,void 0),this.P.setDynamicHeight?.(b.element,b.size),b.lastDynamicHeightWidth=this.n,this.o.removeChild(w.domNode),this.h.release(w),b.size-m}ub(h){const b=h[h.length-1];if(!b)return null;const m=this.d[b.end];return!m||!m.row?null:m.row.domNode}getElementDomId(h){return`${this.domId}_${h}`}dispose(){if(this.d){for(const h of this.d)if(h.row){const b=this.j.get(h.row.templateId);b&&(b.disposeElement?.(h.element,-1,h.row.templateData,void 0),b.disposeTemplate(h.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.dispose)(this.L)}}L.c=0,Ve([l.memoize],L.prototype,"onMouseClick",null),Ve([l.memoize],L.prototype,"onMouseDblClick",null),Ve([l.memoize],L.prototype,"onMouseMiddleClick",null),Ve([l.memoize],L.prototype,"onMouseUp",null),Ve([l.memoize],L.prototype,"onMouseDown",null),Ve([l.memoize],L.prototype,"onMouseOver",null),Ve([l.memoize],L.prototype,"onMouseMove",null),Ve([l.memoize],L.prototype,"onMouseOut",null),Ve([l.memoize],L.prototype,"onContextMenu",null),Ve([l.memoize],L.prototype,"onTouchStart",null),Ve([l.memoize],L.prototype,"onTap",null),t.ListView=L}),define(ge[36],me([1,0,4,20,14,23,53,67,13,9,69,25,3,32,2,44,5,6,66,57,89]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u,e,a,n,s,o,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class A{constructor(T){this.d=T,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(T){return T}renderElement(T,x,M){const f=this.c.findIndex(C=>C.templateData===M);if(f>=0){const C=this.c[f];this.d.unrender(M),C.index=x}else{const C={index:x,templateData:M};this.c.push(C)}this.d.renderIndex(x,M)}splice(T,x,M){const f=[];for(const C of this.c)C.index<T?f.push(C):C.index>=T+x&&f.push({index:C.index+M-x,templateData:C.templateData});this.c=f}renderIndexes(T){for(const{index:x,templateData:M}of this.c)T.indexOf(x)>-1&&this.d.renderIndex(x,M)}disposeTemplate(T){const x=this.c.findIndex(M=>M.templateData===T);x<0||this.c.splice(x,1)}}class S{get name(){return this.h}get renderer(){return new A(this)}constructor(T){this.h=T,this.c=0,this.d=[],this.f=[],this.g=new r.Emitter,this.onChange=this.g.event}splice(T,x,M){x=Math.max(0,Math.min(x,this.c-T));const f=M.length-x,C=T+x,$=[...this.f.filter(F=>F<T),...M.map((F,N)=>F?N+T:-1).filter(F=>F!==-1),...this.f.filter(F=>F>=C).map(F=>F+f)],Y=this.c+f;if(this.f.length>0&&$.length===0&&Y>0){const F=this.f.find(N=>N>=T)??Y-1;$.push(Math.min(F,Y-1))}this.renderer.splice(T,x,M.length),this.k($,$),this.c=Y}renderIndex(T,x){x.classList.toggle(this.h,this.contains(T))}unrender(T){T.classList.remove(this.h)}set(T,x){return this.k(T,[...T].sort(Re),x)}k(T,x,M){const f=this.d,C=this.f;this.d=T,this.f=x;const $=pe(C,T);return this.renderer.renderIndexes($),this.g.fire({indexes:T,browserEvent:M}),f}get(){return this.d}contains(T){return(0,g.binarySearch)(this.f,T,Re)>=0}dispose(){(0,e.dispose)(this.g)}}Ve([P.memoize],S.prototype,"renderer",null);class d extends S{constructor(T){super("selected"),this.l=T}renderIndex(T,x){super.renderIndex(T,x),this.l&&(this.contains(T)?x.setAttribute("aria-selected","true"):x.setAttribute("aria-selected","false"))}}class p{constructor(T,x,M){this.c=T,this.d=x,this.f=M}splice(T,x,M){if(!this.f)return this.c.splice(T,x,M.map(()=>!1));const f=this.c.get().map($=>this.f.getId(this.d.element($)).toString()),C=M.map($=>f.indexOf(this.f.getId($).toString())>-1);this.c.splice(T,x,C)}}function L(te){return te.tagName==="INPUT"||te.tagName==="TEXTAREA"}t.isInputElement=L;function I(te){return te.classList.contains("monaco-editor")?!0:te.classList.contains("monaco-list")||!te.parentElement?!1:I(te.parentElement)}t.isMonacoEditor=I;function h(te){return te.tagName==="A"&&te.classList.contains("monaco-button")||te.tagName==="DIV"&&te.classList.contains("monaco-button-dropdown")?!0:te.classList.contains("monaco-list")||!te.parentElement?!1:h(te.parentElement)}t.isButton=h;class b{get f(){return this.c.add(r.Event.chain(this.c.add(new R.DomEmitter(this.h.domNode,"keydown")).event).filter(T=>!L(T.target)).map(T=>new i.StandardKeyboardEvent(T)))}constructor(T,x,M){this.g=T,this.h=x,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter(f=>f.keyCode===3).on(this.k,this,this.c),this.f.filter(f=>f.keyCode===16).on(this.l,this,this.c),this.f.filter(f=>f.keyCode===18).on(this.o,this,this.c),this.f.filter(f=>f.keyCode===11).on(this.p,this,this.c),this.f.filter(f=>f.keyCode===12).on(this.q,this,this.c),this.f.filter(f=>f.keyCode===9).on(this.t,this,this.c),M.multipleSelectionSupport!==!1&&this.f.filter(f=>(n.isMacintosh?f.metaKey:f.ctrlKey)&&f.keyCode===31).on(this.s,this,this.d)}updateOptions(T){T.multipleSelectionSupport!==void 0&&(this.d.clear(),T.multipleSelectionSupport&&this.f.filter(x=>(n.isMacintosh?x.metaKey:x.ctrlKey)&&x.keyCode===31).on(this.s,this,this.d))}k(T){T.preventDefault(),T.stopPropagation(),this.g.setSelection(this.g.getFocus(),T.browserEvent)}l(T){T.preventDefault(),T.stopPropagation(),this.g.focusPrevious(1,!1,T.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}o(T){T.preventDefault(),T.stopPropagation(),this.g.focusNext(1,!1,T.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}p(T){T.preventDefault(),T.stopPropagation(),this.g.focusPreviousPage(T.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}q(T){T.preventDefault(),T.stopPropagation(),this.g.focusNextPage(T.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}s(T){T.preventDefault(),T.stopPropagation(),this.g.setSelection((0,g.range)(this.g.length),T.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(T){this.g.getSelection().length&&(T.preventDefault(),T.stopPropagation(),this.g.setSelection([],T.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ve([P.memoize],b.prototype,"f",null);var m;(function(te){te[te.Automatic=0]="Automatic",te[te.Trigger=1]="Trigger"})(m=t.TypeNavigationMode||(t.TypeNavigationMode={}));var w;(function(te){te[te.Idle=0]="Idle",te[te.Typing=1]="Typing"})(w||(w={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(te){return te.ctrlKey||te.metaKey||te.altKey?!1:te.keyCode>=31&&te.keyCode<=56||te.keyCode>=21&&te.keyCode<=30||te.keyCode>=93&&te.keyCode<=102||te.keyCode>=80&&te.keyCode<=90}};class O{constructor(T,x,M,f,C){this.o=T,this.p=x,this.q=M,this.s=f,this.t=C,this.c=!1,this.d=w.Idle,this.f=m.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(T.options)}updateOptions(T){T.typeNavigationEnabled??!0?this.u():this.v(),this.f=T.typeNavigationMode??m.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let T=!1;const x=this.k.add(r.Event.chain(this.k.add(new R.DomEmitter(this.p.domNode,"keydown")).event)).filter(C=>!L(C.target)).filter(()=>this.f===m.Automatic||this.g).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>T||this.s(C)).filter(C=>this.t.mightProducePrintableCharacter(C)).forEach(C=>E.EventHelper.stop(C,!0)).map(C=>C.browserEvent.key).event,M=r.Event.debounce(x,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(x,M),(C,$)=>$===null?null:(C||"")+$,void 0,this.k)(this.z,this,this.k),M(this.w,this,this.k),x(()=>T=!0,void 0,this.k),M(()=>T=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const T=this.o.getFocus();if(T.length>0&&T[0]===this.h){const x=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(T[0]));x&&(0,v.alert)(x)}this.h=-1}z(T){if(!T){this.d=w.Idle,this.g=!1;return}const x=this.o.getFocus(),M=x.length>0?x[0]:0,f=this.d===w.Idle?1:0;this.d=w.Typing;for(let C=0;C<this.o.length;C++){const $=(M+C+f)%this.o.length,Y=this.q.getKeyboardNavigationLabel(this.p.element($)),F=Y&&Y.toString();if(typeof F>"u"||(0,u.matchesPrefix)(T,F)){this.h=M,this.o.setFocus([$]),this.o.reveal($);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class V{constructor(T,x){this.d=T,this.f=x,this.c=new e.DisposableStore,this.c.add(r.Event.chain(this.c.add(new R.DomEmitter(x.domNode,"keydown")).event)).filter(f=>!L(f.target)).map(f=>new i.StandardKeyboardEvent(f)).filter(f=>f.keyCode===2&&!f.ctrlKey&&!f.metaKey&&!f.shiftKey&&!f.altKey).on(this.g,this,this.c)}g(T){if(T.target!==this.f.domNode)return;const x=this.d.getFocus();if(x.length===0)return;const M=this.f.domElement(x[0]);if(!M)return;const f=M.querySelector("[tabIndex]");if(!f||!(f instanceof HTMLElement)||f.tabIndex===-1)return;const C=window.getComputedStyle(f);C.visibility==="hidden"||C.display==="none"||(T.preventDefault(),T.stopPropagation(),f.focus())}dispose(){this.c.dispose()}}function ie(te){return n.isMacintosh?te.browserEvent.metaKey:te.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=ie;function se(te){return te.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=se;function ae(te){return te instanceof MouseEvent&&te.button===2}const de={isSelectionSingleChangeEvent:ie,isSelectionRangeChangeEvent:se};class ue{constructor(T){this.k=T,this.f=new e.DisposableStore,this.g=new r.Emitter,this.onPointer=this.g.event,T.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||de),this.d=typeof T.options.mouseSupport>"u"||!!T.options.mouseSupport,this.d&&(T.onMouseDown(this.s,this,this.f),T.onContextMenu(this.t,this,this.f),T.onMouseDblClick(this.v,this,this.f),T.onTouchStart(this.s,this,this.f),this.f.add(W.Gesture.addTarget(T.getHTMLElement()))),r.Event.any(T.onMouseClick,T.onMouseMiddleClick,T.onTap)(this.u,this,this.f)}updateOptions(T){T.multipleSelectionSupport!==void 0&&(this.c=void 0,T.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||de))}o(T){return this.c?this.c.isSelectionSingleChangeEvent(T):!1}p(T){return this.c?this.c.isSelectionRangeChangeEvent(T):!1}q(T){return this.o(T)||this.p(T)}s(T){I(T.browserEvent.target)||document.activeElement!==T.browserEvent.target&&this.k.domFocus()}t(T){if(L(T.browserEvent.target)||I(T.browserEvent.target))return;const x=typeof T.index>"u"?[]:[T.index];this.k.setFocus(x,T.browserEvent)}u(T){if(!this.d||L(T.browserEvent.target)||I(T.browserEvent.target))return;const x=T.index;if(typeof x>"u"){this.k.setFocus([],T.browserEvent),this.k.setSelection([],T.browserEvent),this.k.setAnchor(void 0);return}if(this.p(T))return this.w(T);if(this.q(T))return this.w(T);this.k.setFocus([x],T.browserEvent),this.k.setAnchor(x),ae(T.browserEvent)||this.k.setSelection([x],T.browserEvent),this.g.fire(T)}v(T){if(L(T.browserEvent.target)||I(T.browserEvent.target)||this.q(T))return;const x=this.k.getFocus();this.k.setSelection(x,T.browserEvent)}w(T){const x=T.index;let M=this.k.getAnchor();if(this.p(T)){typeof M>"u"&&(M=this.k.getFocus()[0]??x,this.k.setAnchor(M));const f=Math.min(M,x),C=Math.max(M,x),$=(0,g.range)(f,C+1),Y=this.k.getSelection(),F=ve(pe(Y,[M]),M);if(F.length===0)return;const N=pe($,Me(Y,F));this.k.setSelection(N,T.browserEvent),this.k.setFocus([x],T.browserEvent)}else if(this.o(T)){const f=this.k.getSelection(),C=f.filter($=>$!==x);this.k.setFocus([x]),this.k.setAnchor(x),f.length===C.length?this.k.setSelection([...C,x],T.browserEvent):this.k.setSelection(C,T.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ue;class Z{constructor(T,x){this.c=T,this.d=x}style(T){const x=this.d&&`.${this.d}`,M=[];T.listBackground&&M.push(`.monaco-list${x} .monaco-list-rows { background: ${T.listBackground}; }`),T.listFocusBackground&&(M.push(`.monaco-list${x}:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),M.push(`.monaco-list${x}:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&M.push(`.monaco-list${x}:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(M.push(`.monaco-list${x}:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),M.push(`.monaco-list${x}:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&M.push(`.monaco-list${x}:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listActiveSelectionIconForeground&&M.push(`.monaco-list${x}:focus .monaco-list-row.selected .codicon { color: ${T.listActiveSelectionIconForeground}; }`),T.listFocusAndSelectionBackground&&M.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { background-color: ${T.listFocusAndSelectionBackground}; }
			`),T.listFocusAndSelectionForeground&&M.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { color: ${T.listFocusAndSelectionForeground}; }
			`),T.listInactiveFocusForeground&&(M.push(`.monaco-list${x} .monaco-list-row.focused { color:  ${T.listInactiveFocusForeground}; }`),M.push(`.monaco-list${x} .monaco-list-row.focused:hover { color:  ${T.listInactiveFocusForeground}; }`)),T.listInactiveSelectionIconForeground&&M.push(`.monaco-list${x} .monaco-list-row.focused .codicon { color:  ${T.listInactiveSelectionIconForeground}; }`),T.listInactiveFocusBackground&&(M.push(`.monaco-list${x} .monaco-list-row.focused { background-color:  ${T.listInactiveFocusBackground}; }`),M.push(`.monaco-list${x} .monaco-list-row.focused:hover { background-color:  ${T.listInactiveFocusBackground}; }`)),T.listInactiveSelectionBackground&&(M.push(`.monaco-list${x} .monaco-list-row.selected { background-color:  ${T.listInactiveSelectionBackground}; }`),M.push(`.monaco-list${x} .monaco-list-row.selected:hover { background-color:  ${T.listInactiveSelectionBackground}; }`)),T.listInactiveSelectionForeground&&M.push(`.monaco-list${x} .monaco-list-row.selected { color: ${T.listInactiveSelectionForeground}; }`),T.listHoverBackground&&M.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&M.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${T.listHoverForeground}; }`);const f=(0,E.asCssValueWithDefault)(T.listFocusAndSelectionOutline,(0,E.asCssValueWithDefault)(T.listSelectionOutline,T.listFocusOutline??""));f&&M.push(`.monaco-list${x}:focus .monaco-list-row.focused.selected { outline: 1px solid ${f}; outline-offset: -1px;}`),T.listFocusOutline&&M.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${x}.last-focused .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }
			`);const C=(0,E.asCssValueWithDefault)(T.listSelectionOutline,T.listInactiveFocusOutline??"");C&&M.push(`.monaco-list${x} .monaco-list-row.focused.selected { outline: 1px dotted ${C}; outline-offset: -1px; }`),T.listSelectionOutline&&M.push(`.monaco-list${x} .monaco-list-row.selected { outline: 1px dotted ${T.listSelectionOutline}; outline-offset: -1px; }`),T.listInactiveFocusOutline&&M.push(`.monaco-list${x} .monaco-list-row.focused { outline: 1px dotted ${T.listInactiveFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&M.push(`.monaco-list${x} .monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.listDropBackground&&M.push(`
				.monaco-list${x}.drop-target,
				.monaco-list${x} .monaco-list-rows.drop-target,
				.monaco-list${x} .monaco-list-row.drop-target { background-color: ${T.listDropBackground} !important; color: inherit !important; }
			`),T.tableColumnsBorder&&M.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${T.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),T.tableOddRowsBackgroundColor&&M.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${T.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=M.join(`
`)}}t.DefaultStyleController=Z,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:c.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:c.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:c.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const Q={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ve(te,T){const x=te.indexOf(T);if(x===-1)return[];const M=[];let f=x-1;for(;f>=0&&te[f]===T-(x-f);)M.push(te[f--]);for(M.reverse(),f=x;f<te.length&&te[f]===T+(f-x);)M.push(te[f++]);return M}function pe(te,T){const x=[];let M=0,f=0;for(;M<te.length||f<T.length;)if(M>=te.length)x.push(T[f++]);else if(f>=T.length)x.push(te[M++]);else if(te[M]===T[f]){x.push(te[M]),M++,f++;continue}else te[M]<T[f]?x.push(te[M++]):x.push(T[f++]);return x}function Me(te,T){const x=[];let M=0,f=0;for(;M<te.length||f<T.length;)if(M>=te.length)x.push(T[f++]);else if(f>=T.length)x.push(te[M++]);else if(te[M]===T[f]){M++,f++;continue}else te[M]<T[f]?x.push(te[M++]):f++;return x}const Re=(te,T)=>te-T;class le{constructor(T,x){this.c=T,this.d=x}get templateId(){return this.c}renderTemplate(T){return this.d.map(x=>x.renderTemplate(T))}renderElement(T,x,M,f){let C=0;for(const $ of this.d)$.renderElement(T,x,M[C++],f)}disposeElement(T,x,M,f){let C=0;for(const $ of this.d)$.disposeElement?.(T,x,M[C],f),C+=1}disposeTemplate(T){let x=0;for(const M of this.d)M.disposeTemplate(T[x++])}}class _{constructor(T){this.c=T,this.templateId="a18n"}renderTemplate(T){return T}renderElement(T,x,M){const f=this.c.getAriaLabel(T);f?M.setAttribute("aria-label",f):M.removeAttribute("aria-label");const C=this.c.getAriaLevel&&this.c.getAriaLevel(T);typeof C=="number"?M.setAttribute("aria-level",`${C}`):M.removeAttribute("aria-level")}disposeTemplate(T){}}class ne{constructor(T,x){this.c=T,this.d=x}getDragElements(T){const x=this.c.getSelectedElements();return x.indexOf(T)>-1?x:[T]}getDragURI(T){return this.d.getDragURI(T)}getDragLabel(T,x){if(this.d.getDragLabel)return this.d.getDragLabel(T,x)}onDragStart(T,x){this.d.onDragStart?.(T,x)}onDragOver(T,x,M,f){return this.d.onDragOver(T,x,M,f)}onDragLeave(T,x,M,f){this.d.onDragLeave?.(T,x,M,f)}onDragEnd(T){this.d.onDragEnd?.(T)}drop(T,x,M,f){this.d.drop(T,x,M,f)}}class ee{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),T=>this.I(T),this.A)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),T=>this.I(T),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let T=!1;const x=this.A.add(r.Event.chain(this.A.add(new R.DomEmitter(this.k.domNode,"keydown")).event)).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>T=C.keyCode===58||C.shiftKey&&C.keyCode===68).map(C=>E.EventHelper.stop(C,!0)).filter(()=>!1).event,M=this.A.add(r.Event.chain(this.A.add(new R.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>T=!1).map(C=>new i.StandardKeyboardEvent(C)).filter(C=>C.keyCode===58||C.shiftKey&&C.keyCode===68).map(C=>E.EventHelper.stop(C,!0)).map(({browserEvent:C})=>{const $=this.getFocus(),Y=$.length?$[0]:void 0,F=typeof Y<"u"?this.k.element(Y):void 0,N=typeof Y<"u"?this.k.domElement(Y):this.k.domNode;return{index:Y,element:F,anchor:N,browserEvent:C}}).event,f=this.A.add(r.Event.chain(this.k.onContextMenu)).filter(C=>!T).map(({element:C,index:$,browserEvent:Y})=>({element:C,index:$,anchor:{x:Y.pageX+1,y:Y.pageY},browserEvent:Y})).event;return r.Event.any(x,M,f)}get onKeyDown(){return this.A.add(new R.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new R.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new R.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.A.add(new R.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.A.add(new R.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(T,x,M,f,C=Q){this.C=T,this.D=C,this.c=new S("focused"),this.f=new S("anchor"),this.g=new r.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new r.Emitter,this.onDidDispose=this.B.event;const $=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new d($!=="listbox");const Y=[this.c.renderer,this.d.renderer];this.u=C.accessibilityProvider,this.u&&(Y.push(new _(this.u)),this.u.onDidChangeActiveDescendant?.(this.K,this,this.A)),f=f.map(N=>new le(N.templateId,[...Y,N]));const F={...C,dnd:C.dnd&&new ne(this,C.dnd)};if(this.k=this.E(x,M,f,F),this.k.domNode.setAttribute("role",$),C.styleController)this.q=C.styleController(this.k.domId);else{const N=(0,E.createStyleSheet)(this.k.domNode);this.q=new Z(N,this.k.domId)}if(this.o=new D.CombinedSpliceable([new p(this.c,this.k,C.identityProvider),new p(this.d,this.k,C.identityProvider),new p(this.f,this.k,C.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new V(this,this.k)),(typeof C.keyboardSupport!="boolean"||C.keyboardSupport)&&(this.v=new b(this,this.k,C),this.A.add(this.v)),C.keyboardNavigationLabelProvider){const N=C.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new O(this,this.k,C.keyboardNavigationLabelProvider,C.keyboardNavigationEventFilter??(()=>!0),N),this.A.add(this.t)}this.w=this.F(C),this.A.add(this.w),this.onDidChangeFocus(this.J,this,this.A),this.onDidChangeSelection(this.L,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(T,x,M,f){return new y.ListView(T,x,M,f)}F(T){return new ue(this)}updateOptions(T={}){this.D={...this.D,...T},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(T),this.v?.updateOptions(T),this.k.updateOptions(T)}get options(){return this.D}splice(T,x,M=[]){if(T<0||T>this.k.length)throw new o.ListError(this.C,`Invalid start index: ${T}`);if(x<0)throw new o.ListError(this.C,`Invalid delete count: ${x}`);x===0&&M.length===0||this.g.bufferEvents(()=>this.o.splice(T,x,M))}updateWidth(T){this.k.updateWidth(T)}updateElementHeight(T,x){this.k.updateElementHeight(T,x,null)}rerender(){this.k.rerender()}element(T){return this.k.element(T)}indexOf(T){return this.k.indexOf(T)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(T){this.k.setScrollTop(T)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(T){this.k.setScrollLeft(T)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(T){this.z=T,this.k.domNode.setAttribute("aria-label",T)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(T,x){this.k.layout(T,x)}triggerTypeNavigation(){this.t?.trigger()}setSelection(T,x){for(const M of T)if(M<0||M>=this.length)throw new o.ListError(this.C,`Invalid index ${M}`);this.d.set(T,x)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(T=>this.k.element(T))}setAnchor(T){if(typeof T>"u"){this.f.set([]);return}if(T<0||T>=this.length)throw new o.ListError(this.C,`Invalid index ${T}`);this.f.set([T])}getAnchor(){return(0,g.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const T=this.getAnchor();return typeof T>"u"?void 0:this.element(T)}setFocus(T,x){for(const M of T)if(M<0||M>=this.length)throw new o.ListError(this.C,`Invalid index ${M}`);this.c.set(T,x)}focusNext(T=1,x=!1,M,f){if(this.length===0)return;const C=this.c.get(),$=this.G(C.length>0?C[0]+T:0,x,f);$>-1&&this.setFocus([$],M)}focusPrevious(T=1,x=!1,M,f){if(this.length===0)return;const C=this.c.get(),$=this.H(C.length>0?C[0]-T:0,x,f);$>-1&&this.setFocus([$],M)}async focusNextPage(T,x){let M=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);M=M===0?0:M-1;const f=this.getFocus()[0];if(f!==M&&(f===void 0||M>f)){const C=this.H(M,!1,x);C>-1&&f!==C?this.setFocus([C],T):this.setFocus([M],T)}else{const C=this.k.getScrollTop();let $=C+this.k.renderHeight;M>f&&($-=this.k.elementHeight(M)),this.k.setScrollTop($),this.k.getScrollTop()!==C&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusNextPage(T,x))}}async focusPreviousPage(T,x){let M;const f=this.k.getScrollTop();f===0?M=this.k.indexAt(f):M=this.k.indexAfter(f-1);const C=this.getFocus()[0];if(C!==M&&(C===void 0||C>=M)){const $=this.G(M,!1,x);$>-1&&C!==$?this.setFocus([$],T):this.setFocus([M],T)}else{const $=f;this.k.setScrollTop(f-this.k.renderHeight),this.k.getScrollTop()!==$&&(this.setFocus([]),await(0,l.timeout)(0),await this.focusPreviousPage(T,x))}}focusLast(T,x){if(this.length===0)return;const M=this.H(this.length-1,!1,x);M>-1&&this.setFocus([M],T)}focusFirst(T,x){this.focusNth(0,T,x)}focusNth(T,x,M){if(this.length===0)return;const f=this.G(T,!1,M);f>-1&&this.setFocus([f],x)}G(T,x=!1,M){for(let f=0;f<this.length;f++){if(T>=this.length&&!x)return-1;if(T=T%this.length,!M||M(this.element(T)))return T;T++}return-1}H(T,x=!1,M){for(let f=0;f<this.length;f++){if(T<0&&!x)return-1;if(T=(this.length+T%this.length)%this.length,!M||M(this.element(T)))return T;T--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(T=>this.k.element(T))}reveal(T,x){if(T<0||T>=this.length)throw new o.ListError(this.C,`Invalid index ${T}`);const M=this.k.getScrollTop(),f=this.k.elementTop(T),C=this.k.elementHeight(T);if((0,s.isNumber)(x)){const $=C-this.k.renderHeight;this.k.setScrollTop($*(0,a.clamp)(x,0,1)+f)}else{const $=f+C,Y=M+this.k.renderHeight;f<M&&$>=Y||(f<M||$>=Y&&C>=this.k.renderHeight?this.k.setScrollTop(f):$>=Y&&this.k.setScrollTop($-this.k.renderHeight))}}getRelativeTop(T){if(T<0||T>=this.length)throw new o.ListError(this.C,`Invalid index ${T}`);const x=this.k.getScrollTop(),M=this.k.elementTop(T),f=this.k.elementHeight(T);if(M<x||M+f>x+this.k.renderHeight)return null;const C=f-this.k.renderHeight;return Math.abs((x-M)/C)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(T){return this.k.getElementDomId(T)}style(T){this.q.style(T)}I({indexes:T,browserEvent:x}){return{indexes:T,elements:T.map(M=>this.k.element(M)),browserEvent:x}}J(){const T=this.c.get();this.k.domNode.classList.toggle("element-focused",T.length>0),this.K()}K(){const T=this.c.get();if(T.length>0){let x;this.u?.getActiveDescendantId&&(x=this.u.getActiveDescendantId(this.k.element(T[0]))),this.k.domNode.setAttribute("aria-activedescendant",x||this.k.getElementDomId(T[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}L(){const T=this.d.get();this.k.domNode.classList.toggle("selection-none",T.length===0),this.k.domNode.classList.toggle("selection-single",T.length===1),this.k.domNode.classList.toggle("selection-multiple",T.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}Ve([P.memoize],ee.prototype,"onDidChangeFocus",null),Ve([P.memoize],ee.prototype,"onDidChangeSelection",null),Ve([P.memoize],ee.prototype,"onContextMenu",null),Ve([P.memoize],ee.prototype,"onKeyDown",null),Ve([P.memoize],ee.prototype,"onKeyUp",null),Ve([P.memoize],ee.prototype,"onKeyPress",null),Ve([P.memoize],ee.prototype,"onDidFocus",null),Ve([P.memoize],ee.prototype,"onDidBlur",null),t.List=ee}),define(ge[58],me([1,0,7,33,34,11,15]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(D=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class g{constructor(s="",o=!1){if(this.value=s,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(s,o=0){return this.value+=r(this.supportThemeIcons?(0,R.escapeIcons)(s):s).replace(/([ \t]+)/g,(y,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,o){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}appendLink(s,o,y){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(s),")"),y&&(this.value+=` "${this.c(this.c(y,'"'),")")}"`),this.value+=")",this}c(s,o){const y=new RegExp((0,W.escapeRegExpCharacters)(o),"g");return s.replace(y,(A,S)=>s.charAt(S-1)!=="\\"?`\\${A}`:A)}}t.MarkdownString=g;function l(n){return c(n)?!n.value:Array.isArray(n)?n.every(l):!0}t.isEmptyMarkdownString=l;function c(n){return n instanceof g?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=c;function P(n,s){return n===s?!0:!n||!s?!1:n.value===s.value&&n.isTrusted===s.isTrusted&&n.supportThemeIcons===s.supportThemeIcons&&n.supportHtml===s.supportHtml&&(n.baseUri===s.baseUri||!!n.baseUri&&!!s.baseUri&&(0,i.isEqual)(v.URI.from(n.baseUri),v.URI.from(s.baseUri)))}t.markdownStringEqual=P;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function u(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=u;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function a(n){const s=[],o=n.split("|").map(A=>A.trim());n=o[0];const y=o[1];if(y){const A=/height=(\d+)/.exec(y),S=/width=(\d+)/.exec(y),d=A?A[1]:"",p=S?S[1]:"",L=isFinite(parseInt(p)),I=isFinite(parseInt(d));L&&s.push(`width="${p}"`),I&&s.push(`height="${d}"`)}return{href:n,dimensions:s}}t.parseHrefAndDimensions=a}),define(ge[122],me([1,0,4,114,20,51,14,21,115,7,3,58,33,72,42,2,75,49,28,80,34,11,15]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u,e,a,n,s,o,y,A,S,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const p=Object.freeze({image:(Z,Q,ve)=>{let pe=[],Me=[];return Z&&({href:Z,dimensions:pe}=(0,P.parseHrefAndDimensions)(Z),Me.push(`src="${(0,P.escapeDoubleQuotes)(Z)}"`)),ve&&Me.push(`alt="${(0,P.escapeDoubleQuotes)(ve)}"`),Q&&Me.push(`title="${(0,P.escapeDoubleQuotes)(Q)}"`),pe.length&&(Me=Me.concat(pe)),"<img "+Me.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,Q,ve)=>typeof Z!="string"?"":(Z===ve&&(ve=(0,P.removeMarkdownEscapes)(ve)),Q=typeof Q=="string"?(0,P.escapeDoubleQuotes)((0,P.removeMarkdownEscapes)(Q)):"",Z=(0,P.removeMarkdownEscapes)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${Q||Z}">${ve}</a>`)});function L(Z,Q={},ve={}){const pe=new a.DisposableStore;let Me=!1;const Re=(0,W.createElement)(Q),le=function(C){let $;try{$=(0,s.parse)(decodeURIComponent(C))}catch{}return $?($=(0,y.cloneAndChange)($,Y=>{if(Z.uris&&Z.uris[Y])return d.URI.revive(Z.uris[Y])}),encodeURIComponent(JSON.stringify($))):C},_=function(C,$){const Y=Z.uris&&Z.uris[C];let F=d.URI.revive(Y);return $?C.startsWith(o.Schemas.data+":")?C:(F||(F=d.URI.parse(C)),o.FileAccess.uriToBrowserUri(F).toString(!0)):!F||d.URI.parse(C).toString()===F.toString()?C:(F.query&&(F=F.with({query:le(F.query)})),F.toString())},ne=new n.marked.Renderer;ne.image=p.image,ne.link=p.link,ne.paragraph=p.paragraph;const ee=[],te=[];if(Q.codeBlockRendererSync?ne.code=(C,$)=>{const Y=u.defaultGenerator.nextId(),F=Q.codeBlockRendererSync(I($),C);return te.push([Y,F]),`<div class="code" data-code="${Y}">${(0,S.escape)(C)}</div>`}:Q.codeBlockRenderer&&(ne.code=(C,$)=>{const Y=u.defaultGenerator.nextId(),F=Q.codeBlockRenderer(I($),C);return ee.push(F.then(N=>[Y,N])),`<div class="code" data-code="${Y}">${(0,S.escape)(C)}</div>`}),Q.actionHandler){const C=function(F){let N=F.target;if(!(N.tagName!=="A"&&(N=N.parentElement,!N||N.tagName!=="A")))try{let B=N.dataset.href;B&&(Z.baseUri&&(B=h(d.URI.from(Z.baseUri),B)),Q.actionHandler.callback(B,F))}catch(B){(0,l.onUnexpectedError)(B)}finally{F.preventDefault()}},$=Q.actionHandler.disposables.add(new i.DomEmitter(Re,"click")),Y=Q.actionHandler.disposables.add(new i.DomEmitter(Re,"auxclick"));Q.actionHandler.disposables.add(c.Event.any($.event,Y.event)(F=>{const N=new D.StandardMouseEvent(F);!N.leftButton&&!N.middleButton||C(N)})),Q.actionHandler.disposables.add(E.addDisposableListener(Re,"keydown",F=>{const N=new v.StandardKeyboardEvent(F);!N.equals(10)&&!N.equals(3)||C(N)}))}Z.supportHtml||(ve.sanitizer=C=>(Z.isTrusted?C.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?C:"",ve.sanitize=!0,ve.silent=!0),ve.renderer=ne;let T=Z.value??"";T.length>1e5&&(T=`${T.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(T=(0,r.markdownEscapeEscapedIcons)(T));let x;if(Q.fillInIncompleteTokens){const C={...n.marked.defaults,...ve},$=n.marked.lexer(T,C),Y=ae($);x=n.marked.parser(Y,C)}else x=n.marked.parse(T,ve);Z.supportThemeIcons&&(x=(0,g.renderLabelWithIcons)(x).map($=>typeof $=="string"?$:$.outerHTML).join(""));const f=new DOMParser().parseFromString(b(Z,x),"text/html");if(f.body.querySelectorAll("img").forEach(C=>{const $=C.getAttribute("src");if($){let Y=$;try{Z.baseUri&&(Y=h(d.URI.from(Z.baseUri),Y))}catch{}C.src=_(Y,!0)}}),f.body.querySelectorAll("a").forEach(C=>{const $=C.getAttribute("href");if(C.setAttribute("href",""),!$||/^data:|javascript:/i.test($)||/^command:/i.test($)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test($))C.replaceWith(...C.childNodes);else{let Y=_($,!1);Z.baseUri&&(Y=h(d.URI.from(Z.baseUri),$)),C.dataset.href=Y}}),Re.innerHTML=b(Z,f.body.innerHTML),ee.length>0)Promise.all(ee).then(C=>{if(Me)return;const $=new Map(C),Y=Re.querySelectorAll("div[data-code]");for(const F of Y){const N=$.get(F.dataset.code??"");N&&E.reset(F,N)}Q.asyncRenderCallback?.()});else if(te.length>0){const C=new Map(te),$=Re.querySelectorAll("div[data-code]");for(const Y of $){const F=C.get(Y.dataset.code??"");F&&E.reset(Y,F)}}if(Q.asyncRenderCallback)for(const C of Re.getElementsByTagName("img")){const $=pe.add(E.addDisposableListener(C,"load",()=>{$.dispose(),Q.asyncRenderCallback()}))}return{element:Re,dispose:()=>{Me=!0,pe.dispose()}}}t.renderMarkdown=L;function I(Z){if(!Z)return"";const Q=Z.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:Z}function h(Z,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:Z.path.endsWith("/")?(0,A.resolvePath)(Z,Q).toString():(0,A.resolvePath)((0,A.dirname)(Z),Q).toString()}function b(Z,Q){const{config:ve,allowedSchemes:pe}=m(Z);R.addHook("uponSanitizeAttribute",(Re,le)=>{if(le.attrName==="style"||le.attrName==="class"){if(Re.tagName==="SPAN"){if(le.attrName==="style"){le.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(le.attrValue);return}else if(le.attrName==="class"){le.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(le.attrValue);return}}le.keepAttr=!1;return}});const Me=E.hookDomPurifyHrefAndSrcSanitizer(pe);try{return R.sanitize(Q,{...ve,RETURN_TRUSTED_TYPE:!0})}finally{R.removeHook("uponSanitizeAttribute"),Me.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function m(Z){const Q=[o.Schemas.http,o.Schemas.https,o.Schemas.mailto,o.Schemas.data,o.Schemas.file,o.Schemas.vscodeFileResource,o.Schemas.vscodeRemote,o.Schemas.vscodeRemoteResource];return Z.isTrusted&&Q.push(o.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function w(Z){return typeof Z=="string"?Z:O(Z)}t.renderStringAsPlaintext=w;function O(Z){let Q=Z.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const ve=n.marked.parse(Q,{renderer:ie.value}).replace(/&(#\d+|[a-zA-Z]+);/g,pe=>V.get(pe)??pe);return b({isTrusted:!1},ve).toString()}t.renderMarkdownAsPlaintext=O;const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),ie=new e.Lazy(()=>{const Z=new n.marked.Renderer;return Z.code=Q=>Q,Z.blockquote=Q=>Q,Z.html=Q=>"",Z.heading=(Q,ve,pe)=>Q+`
`,Z.hr=()=>"",Z.list=(Q,ve)=>Q,Z.listitem=Q=>Q+`
`,Z.paragraph=Q=>Q+`
`,Z.table=(Q,ve)=>Q+ve+`
`,Z.tablerow=Q=>Q,Z.tablecell=(Q,ve)=>Q+" ",Z.strong=Q=>Q,Z.em=Q=>Q,Z.codespan=Q=>Q,Z.br=()=>`
`,Z.del=Q=>Q,Z.image=(Q,ve,pe)=>"",Z.text=Q=>Q,Z.link=(Q,ve,pe)=>pe,Z});function se(Z){let Q="";return Z.forEach(ve=>{Q+=ve.raw}),Q}function ae(Z){let Q,ve;for(Q=0;Q<Z.length;Q++){const pe=Z[Q];if(pe.type==="paragraph"&&pe.raw.match(/(\n|^)```/)){ve=de(Z.slice(Q));break}if(pe.type==="paragraph"&&pe.raw.match(/(\n|^)\|/)){ve=ue(Z.slice(Q));break}}if(ve){const pe=[...Z.slice(0,Q),...ve];return pe.links=Z.links,pe}return Z}t.fillInIncompleteTokens=ae;function de(Z){const Q=se(Z);return n.marked.lexer(Q+"\n```")}function ue(Z){const Q=se(Z),ve=Q.split(`
`);let pe,Me=!1;for(let Re=0;Re<ve.length;Re++){const le=ve[Re].trim();if(typeof pe>"u"&&le.match(/^\s*\|/)){const _=le.match(/(\|[^\|]+)(?=\||$)/g);_&&(pe=_.length)}else if(typeof pe=="number")if(le.match(/^\s*\|/)){if(Re!==ve.length-1)return Z;Me=!0}else return Z}if(typeof pe=="number"&&pe>0){const Re=Me?ve.slice(0,-1).join(`
`):Q,le=!!Re.match(/\|\s*$/),_=Re+(le?"":"|")+`
|${" --- |".repeat(pe)}`;return n.marked.lexer(_)}return Z}}),define(ge[123],me([1,0,4,9,27,58,33,2,6,99]),function(J,t,E,R,i,W,v,D,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function c(u,e){(0,g.isString)(e)?u.title=(0,v.stripIcons)(e):e?.markdownNotSupportedFallback?u.title=e.markdownNotSupportedFallback:u.removeAttribute("title")}t.setupNativeHover=c;class P{constructor(e,a,n){this.c=e,this.d=a,this.f=n}async update(e,a,n){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let s;if(e===void 0||(0,g.isString)(e)||e instanceof HTMLElement)s=e;else if(!(0,g.isFunction)(e.markdown))s=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,l.localize)(0,null),a),this.b=new i.CancellationTokenSource;const o=this.b.token;if(s=await e.markdown(o),s===void 0&&(s=e.markdownNotSupportedFallback),this.isDisposed||o.isCancellationRequested)return}this.g(s,a,n)}g(e,a,n){const s=this.a;if(this.h(e)){const o={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!s,...n};this.a=this.c.showHover(o,a)}s?.dispose()}h(e){return e?(0,W.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(u,e,a,n){let s,o;const y=(L,I)=>{const h=o!==void 0;L&&(o?.dispose(),o=void 0),I&&(s?.dispose(),s=void 0),h&&u.onDidHideHover?.()},A=(L,I,h)=>new R.TimeoutTimer(async()=>{(!o||o.isDisposed)&&(o=new P(u,h||e,L>0),await o.update(a,I,n))},L),S=()=>{if(s)return;const L=new D.DisposableStore,I=m=>y(!1,m.fromElement===e);L.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,I,!0));const h=()=>y(!0,!0);L.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,h,!0));const b={targetElements:[e],dispose:()=>{}};if(u.placement===void 0||u.placement==="mouse"){const m=w=>{b.x=w.x+10,w.target instanceof HTMLElement&&w.target.classList.contains("action-label")&&y(!0,!0)};L.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,m,!0))}L.add(A(u.delay,!1,b)),s=L},d=E.addDisposableListener(e,E.EventType.MOUSE_OVER,S,!0);return{show:L=>{y(!1,!0),A(0,L)},hide:()=>{y(!0,!0)},update:async(L,I)=>{a=L,await o?.update(a,void 0,I)},dispose:()=>{d.dispose(),y(!0,!0)}}}t.setupCustomHover=r}),define(ge[124],me([1,0,4,20,14,122,36,13,3,41,2,5,101,92]),function(J,t,E,R,i,W,v,D,g,l,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const u=E.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(o){const y=Object.create(null);return y.root=o,y.text=E.append(o,u(".option-text")),y.detail=E.append(o,u(".option-detail")),y.decoratorRight=E.append(o,u(".option-decorator-right")),y}renderElement(o,y,A){const S=A,d=o.text,p=o.detail,L=o.decoratorRight,I=o.isDisabled;S.text.textContent=d,S.detail.textContent=p||"",S.decoratorRight.innerText=L||"",I?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(o){}}class n extends c.Disposable{constructor(o,y,A,S,d){super(),this.k=[],this.w=0,this.z=!1,this.F=!1,this.H=!1,this.f=!1,this.n=S,this.g=d||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=n.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new g.Emitter,this.D(this.m),this.J(),this.I(A),this.l=y||0,o&&this.setOptions(o,y),this.M()}getHeight(){return 22}getTemplateId(){return e}I(o){this.q=o,this.r=E.$(".monaco-select-box-dropdown-container"),this.r.classList.add("monaco-select-box-dropdown-padding"),this.C=E.append(this.r,u(".select-box-details-pane"));const y=E.append(this.r,u(".select-box-dropdown-container-width-control")),A=E.append(y,u(".width-control-div"));this.v=document.createElement("span"),this.v.className="option-text-width-control",E.append(A,this.v),this.y=0,this.s=E.createStyleSheet(this.r),this.r.setAttribute("draggable","true"),this.D(E.addDisposableListener(this.r,E.EventType.DRAG_START,S=>{E.EventHelper.stop(S,!0)}))}J(){this.D(E.addStandardDisposableListener(this.h,"change",y=>{this.l=y.target.selectedIndex,this.m.fire({index:y.target.selectedIndex,selected:y.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.D(E.addDisposableListener(this.h,E.EventType.CLICK,y=>{E.EventHelper.stop(y),this.f?this.R(!0):this.Q()})),this.D(E.addDisposableListener(this.h,E.EventType.MOUSE_DOWN,y=>{E.EventHelper.stop(y)}));let o;this.D(E.addDisposableListener(this.h,"touchstart",y=>{o=this.f})),this.D(E.addDisposableListener(this.h,"touchend",y=>{E.EventHelper.stop(y),o?this.R(!0):this.Q()})),this.D(E.addDisposableListener(this.h,E.EventType.KEY_DOWN,y=>{const A=new i.StandardKeyboardEvent(y);let S=!1;P.isMacintosh?(A.keyCode===18||A.keyCode===16||A.keyCode===10||A.keyCode===3)&&(S=!0):(A.keyCode===18&&A.altKey||A.keyCode===16&&A.altKey||A.keyCode===10||A.keyCode===3)&&(S=!0),S&&(this.Q(),E.EventHelper.stop(y,!0))}))}get onDidSelect(){return this.m.event}setOptions(o,y){D.equals(this.k,o)||(this.k=o,this.h.options.length=0,this.z=!1,this.G=void 0,this.k.forEach((A,S)=>{this.h.add(this.P(A.text,S,A.isDisabled)),typeof A.description=="string"&&(this.z=!0)})),y!==void 0&&(this.select(y),this.w=this.l)}L(){this.t?.splice(0,this.t.length,this.k)}select(o){o>=0&&o<this.k.length?this.l=o:o>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.N()}M(){const o=[];this.n.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&this.n.selectBorder!==this.n.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.s.textContent=o.join(`
`)}N(){const o=this.n.selectBackground??"",y=this.n.selectForeground??"",A=this.n.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=y,this.h.style.borderColor=A}O(){const o=this.n.selectBackground??"",y=E.asCssValueWithDefault(this.n.selectListBackground,o);this.u.style.backgroundColor=y,this.C.style.backgroundColor=y;const A=this.n.focusBorder??"";this.r.style.outlineColor=A,this.r.style.outlineOffset="-1px",this.t.style(this.n)}P(o,y,A){const S=document.createElement("option");return S.value=o,S.text=o,S.disabled=!!A,S}Q(){this.C.innerText="",!(!this.q||this.f)&&(this.Y(this.r),this.L(),this.q.showContextView({getAnchor:()=>this.h,render:o=>this.S(o,!0),layout:()=>{this.W()},onHide:()=>{this.r.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.y},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.R(!1),this.q.showContextView({getAnchor:()=>this.h,render:o=>this.S(o),layout:()=>this.W(),onHide:()=>{this.r.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.y},this.g.optionsAsChildren?this.j:void 0),this.w=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}R(o){!this.q||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.q.hideContextView())}S(o,y){return o.appendChild(this.r),this.W(y),{dispose:()=>{try{o.removeChild(this.r)}catch{}}}}U(){let o=0;return this.k.forEach((y,A)=>{this.db(A),this.C.offsetHeight>o&&(o=this.C.offsetHeight)}),o}W(o){if(this.F)return!1;if(this.t){this.r.classList.add("visible");const y=E.getDomNodePagePosition(this.h),A=getComputedStyle(this.h),S=parseFloat(A.getPropertyValue("--dropdown-padding-top"))+parseFloat(A.getPropertyValue("--dropdown-padding-bottom")),d=window.innerHeight-y.top-y.height-(this.g.minBottomMargin||0),p=y.top-n.b,L=this.h.offsetWidth,I=this.X(this.v),h=Math.max(I,Math.round(L)).toString()+"px";this.r.style.width=h,this.t.getHTMLElement().style.height="",this.t.layout();let b=this.t.contentHeight;this.z&&this.G===void 0&&(this.G=this.U());const m=this.z?this.G:0,w=b+S+m,O=Math.floor((d-S-m)/this.getHeight()),V=Math.floor((p-S-m)/this.getHeight());if(o)return y.top+y.height>window.innerHeight-22||y.top<n.b||O<1&&V<1?!1:(O<n.c&&V>O&&this.k.length>O?(this.y=1,this.r.removeChild(this.u),this.r.removeChild(this.C),this.r.appendChild(this.C),this.r.appendChild(this.u),this.C.classList.remove("border-top"),this.C.classList.add("border-bottom")):(this.y=0,this.r.removeChild(this.u),this.r.removeChild(this.C),this.r.appendChild(this.u),this.r.appendChild(this.C),this.C.classList.remove("border-bottom"),this.C.classList.add("border-top")),!0);if(y.top+y.height>window.innerHeight-22||y.top<n.b||this.y===0&&O<1||this.y===1&&V<1)return this.R(!0),!1;if(this.y===0){if(this.f&&O+V<1)return this.R(!0),!1;w>d&&(b=O*this.getHeight())}else w>p&&(b=V*this.getHeight());return this.t.layout(b),this.t.domFocus(),this.t.length>0&&(this.t.setFocus([this.l||0]),this.t.reveal(this.t.getFocus()[0]||0)),this.z?(this.t.getHTMLElement().style.height=b+S+"px",this.r.style.height=""):this.r.style.height=b+S+"px",this.db(this.l),this.r.style.width=h,this.u.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.r.classList.add("synthetic-focus"),!0}else return!1}X(o){let y=0;if(o){let A=0,S=0;this.k.forEach((d,p)=>{const L=d.detail?d.detail.length:0,I=d.decoratorRight?d.decoratorRight.length:0,h=d.text.length+L+I;h>S&&(A=p,S=h)}),o.textContent=this.k[A].text+(this.k[A].decoratorRight?this.k[A].decoratorRight+" ":""),y=E.getTotalWidth(o)}return y}Y(o){if(this.t)return;this.u=E.append(o,u(".select-box-dropdown-list-container")),this.p=new a,this.t=new v.List("SelectBoxCustom",this.u,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let d=S.text;return S.detail&&(d+=`. ${S.detail}`),S.decoratorRight&&(d+=`. ${S.decoratorRight}`),S.description&&(d+=`. ${S.description}`),d},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.t.ariaLabel=this.g.ariaLabel);const y=this.D(new R.DomEmitter(this.u,"keydown")),A=g.Event.chain(y.event).filter(()=>this.t.length>0).map(S=>new i.StandardKeyboardEvent(S));this.D(A.filter(S=>S.keyCode===3).on(S=>this.fb(S),this)),this.D(A.filter(S=>S.keyCode===2).on(S=>this.fb(S),this)),this.D(A.filter(S=>S.keyCode===9).on(S=>this.eb(S),this)),this.D(A.filter(S=>S.keyCode===16).on(S=>this.hb(S),this)),this.D(A.filter(S=>S.keyCode===18).on(S=>this.gb(S),this)),this.D(A.filter(S=>S.keyCode===12).on(this.jb,this)),this.D(A.filter(S=>S.keyCode===11).on(this.ib,this)),this.D(A.filter(S=>S.keyCode===14).on(this.kb,this)),this.D(A.filter(S=>S.keyCode===13).on(this.lb,this)),this.D(A.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=80&&S.keyCode<=108).on(this.mb,this)),this.D(E.addDisposableListener(this.t.getHTMLElement(),E.EventType.POINTER_UP,S=>this.Z(S))),this.D(this.t.onMouseOver(S=>typeof S.index<"u"&&this.t.setFocus([S.index]))),this.D(this.t.onDidChangeFocus(S=>this.cb(S))),this.D(E.addDisposableListener(this.r,E.EventType.FOCUS_OUT,S=>{!this.f||E.isAncestor(S.relatedTarget,this.r)||this.ab()})),this.t.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.t.getHTMLElement().setAttribute("aria-expanded","true"),this.O()}Z(o){if(!this.t.length)return;E.EventHelper.stop(o);const y=o.target;if(!y||y.classList.contains("slider"))return;const A=y.closest(".monaco-list-row");if(!A)return;const S=Number(A.getAttribute("data-index")),d=A.classList.contains("option-disabled");S>=0&&S<this.k.length&&!d&&(this.l=S,this.select(this.l),this.t.setFocus([this.l]),this.t.reveal(this.t.getFocus()[0]),this.l!==this.w&&(this.w=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0))}ab(){this.H||(this.l!==this.w&&this.select(this.w),this.R(!1))}bb(o,y){const A=d=>{for(let p=0;p<d.childNodes.length;p++){const L=d.childNodes.item(p);(L.tagName&&L.tagName.toLowerCase())==="img"?d.removeChild(L):A(L)}},S=(0,W.renderMarkdown)({value:o,supportThemeIcons:!0},{actionHandler:y});return S.element.classList.add("select-box-description-markdown"),A(S.element),S.element}cb(o){!this.f||!this.z||this.db(o.indexes[0])}db(o){this.C.innerText="";const y=this.k[o],A=y?.description??"",S=y?.descriptionIsMarkdown??!1;if(A){if(S){const d=y.descriptionMarkdownActionHandler;this.C.appendChild(this.bb(A,d))}else this.C.innerText=A;this.C.style.display="block"}else this.C.style.display="none";this.F=!0,this.q.layout(),this.F=!1}eb(o){E.EventHelper.stop(o),this.select(this.w),this.R(!0)}fb(o){E.EventHelper.stop(o),this.l!==this.w&&(this.w=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0)}gb(o){if(this.l<this.k.length-1){E.EventHelper.stop(o,!0);const y=this.k[this.l+1].isDisabled;if(y&&this.k.length>this.l+2)this.l+=2;else{if(y)return;this.l++}this.select(this.l),this.t.setFocus([this.l]),this.t.reveal(this.t.getFocus()[0])}}hb(o){this.l>0&&(E.EventHelper.stop(o,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.t.setFocus([this.l]),this.t.reveal(this.t.getFocus()[0]))}ib(o){E.EventHelper.stop(o),this.t.focusPreviousPage(),setTimeout(()=>{this.l=this.t.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.t.setFocus([this.l])),this.t.reveal(this.l),this.select(this.l)},1)}jb(o){E.EventHelper.stop(o),this.t.focusNextPage(),setTimeout(()=>{this.l=this.t.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.t.setFocus([this.l])),this.t.reveal(this.l),this.select(this.l)},1)}kb(o){E.EventHelper.stop(o),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.t.setFocus([this.l]),this.t.reveal(this.l),this.select(this.l))}lb(o){E.EventHelper.stop(o),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.t.setFocus([this.l]),this.t.reveal(this.l),this.select(this.l))}mb(o){const y=l.KeyCodeUtils.toString(o.keyCode);let A=-1;for(let S=0;S<this.k.length-1;S++)if(A=(S+this.l+1)%this.k.length,this.k[A].text.charAt(0).toUpperCase()===y&&!this.k[A].isDisabled){this.select(A),this.t.setFocus([A]),this.t.reveal(this.t.getFocus()[0]),E.EventHelper.stop(o);break}}dispose(){this.R(!1),super.dispose()}}n.a=32,n.b=2,n.c=3,t.SelectBoxList=n}),define(ge[125],me([1,0,36,124,118,19,5,91]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...E.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends W.Widget{constructor(l,c,P,r,u){super(),v.isMacintosh&&!u?.useCustomDrawn?this.a=new i.SelectBoxNative(l,c,r,u):this.a=new R.SelectBoxList(l,c,P,r,u),this.D(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(l,c){this.a.setOptions(l,c)}select(l){this.a.select(l)}setAriaLabel(l){this.a.setAriaLabel(l)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(l){this.a.setFocusable(l)}render(l){this.a.render(l)}}t.SelectBox=D}),define(ge[59],me([1,0,18,50,4,23,123,125,31,2,5,6,96,47]),function(J,t,E,R,i,W,v,D,g,l,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class u extends l.Disposable{get action(){return this._action}constructor(s,o,y={}){super(),this.m=y,this._context=s||this,this._action=o,o instanceof g.Action&&this.D(o.onDidChange(A=>{!this.element||this.q(A)}))}q(s){s.enabled!==void 0&&this.t(),s.checked!==void 0&&this.G(),s.class!==void 0&&this.F(),s.label!==void 0&&(this.u(),this.z()),s.tooltip!==void 0&&this.z()}get actionRunner(){return this.j||(this.j=this.D(new g.ActionRunner)),this.j}set actionRunner(s){this.j=s}isEnabled(){return this._action.enabled}setActionContext(s){this._context=s}render(s){const o=this.element=s;this.D(W.Gesture.addTarget(s));const y=this.m&&this.m.draggable;y&&(s.draggable=!0,E.isFirefox&&this.D((0,i.addDisposableListener)(s,i.EventType.DRAG_START,A=>A.dataTransfer?.setData(R.DataTransfers.TEXT,this._action.label)))),this.D((0,i.addDisposableListener)(o,W.EventType.Tap,A=>this.onClick(A,!0))),this.D((0,i.addDisposableListener)(o,i.EventType.MOUSE_DOWN,A=>{y||i.EventHelper.stop(A,!0),this._action.enabled&&A.button===0&&o.classList.add("active")})),c.isMacintosh&&this.D((0,i.addDisposableListener)(o,i.EventType.CONTEXT_MENU,A=>{A.button===0&&A.ctrlKey===!0&&this.onClick(A)})),this.D((0,i.addDisposableListener)(o,i.EventType.CLICK,A=>{i.EventHelper.stop(A,!0),this.m&&this.m.isMenu||this.onClick(A)})),this.D((0,i.addDisposableListener)(o,i.EventType.DBLCLICK,A=>{i.EventHelper.stop(A,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(A=>{this.D((0,i.addDisposableListener)(o,A,S=>{i.EventHelper.stop(S),o.classList.remove("active")}))})}onClick(s,o=!1){i.EventHelper.stop(s,!0);const y=P.isUndefinedOrNull(this._context)?this.m?.useEventAsContext?s:{preserveFocus:o}:this._context;this.actionRunner.run(this._action,y)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(s){this.element&&(this.element.tabIndex=s?0:-1)}get trapsArrowNavigation(){return!1}t(){}u(){}w(){return this.action.tooltip}z(){if(!this.element)return;const s=this.w()??"";this.C(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(s):(this.f=(0,v.setupCustomHover)(this.m.hoverDelegate,this.element,s),this.B.add(this.f))):this.element.title=s}C(){if(this.element){const s=this.w()??"";this.element.setAttribute("aria-label",s)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=u;class e extends u{constructor(s,o,y){super(s,o,y),this.m=y,this.m.icon=y.icon!==void 0?y.icon:!1,this.m.label=y.label!==void 0?y.label:!0,this.I=""}render(s){super.render(s),this.element&&(this.p=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.p&&(this._action.id===g.Separator.ID?this.p.setAttribute("role","presentation"):this.m.isMenu?this.p.setAttribute("role","menuitem"):this.p.setAttribute("role","button")),this.m.label&&this.m.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.u(),this.z(),this.t(),this.G()}focus(){this.p&&(this.p.tabIndex=0,this.p.focus())}isFocused(){return!!this.p&&this.p?.tabIndex===0}blur(){this.p&&(this.p.tabIndex=-1)}setFocusable(s){this.p&&(this.p.tabIndex=s?0:-1)}u(){this.m.label&&this.p&&(this.p.textContent=this.action.label)}w(){let s=null;return this.action.tooltip?s=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(s=this.action.label,this.m.keybinding&&(s=r.localize(0,null,s,this.m.keybinding))),s??void 0}F(){this.I&&this.p&&this.p.classList.remove(...this.I.split(" ")),this.m.icon?(this.I=this.action.class,this.p&&(this.p.classList.add("codicon"),this.I&&this.p.classList.add(...this.I.split(" "))),this.t()):this.p?.classList.remove("codicon")}t(){this.action.enabled?(this.p&&(this.p.removeAttribute("aria-disabled"),this.p.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.p&&(this.p.setAttribute("aria-disabled","true"),this.p.classList.add("disabled")),this.element?.classList.add("disabled"))}C(){if(this.p){const s=this.w()??"";this.p.setAttribute("aria-label",s)}}G(){this.p&&(this.action.checked?this.p.classList.add("checked"):this.p.classList.remove("checked"))}}t.ActionViewItem=e;class a extends u{constructor(s,o,y,A,S,d,p){super(s,o),this.b=new D.SelectBox(y,A,S,d,p),this.b.setFocusable(!1),this.D(this.b),this.g()}setOptions(s,o){this.b.setOptions(s,o)}select(s){this.b.select(s)}g(){this.D(this.b.onDidSelect(s=>this.k(s.selected,s.index)))}k(s,o){this.actionRunner.run(this._action,this.n(s,o))}n(s,o){return s}setFocusable(s){this.b.setFocusable(s)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(s){this.b.render(s)}}t.SelectActionViewItem=a}),define(ge[60],me([1,0,4,14,59,31,3,2,6,47]),function(J,t,E,R,i,W,v,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var l;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(l=t.ActionsOrientation||(t.ActionsOrientation={}));class c extends D.Disposable{constructor(u,e={}){super(),this.g=this.D(new D.DisposableStore),this.n=this.D(new D.DisposableMap),this.s=!1,this.t=!0,this.v=this.D(new v.Emitter),this.onDidBlur=this.v.event,this.w=this.D(new v.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.z=this.D(new v.Emitter),this.onDidRun=this.z.event,this.C=this.D(new v.Emitter),this.onWillRun=this.C.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new W.ActionRunner,this.g.add(this.f)),this.g.add(this.f.onDidRun(s=>this.z.fire(s))),this.g.add(this.f.onWillRun(s=>this.C.fire(s))),this.viewItems=[],this.q=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,n;switch(this.l){case 0:a=[15],n=[17];break;case 1:a=[16],n=[18],this.domNode.className+=" vertical";break}this.D(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,s=>{const o=new R.StandardKeyboardEvent(s);let y=!0;const A=typeof this.q=="number"?this.viewItems[this.q]:void 0;a&&(o.equals(a[0])||o.equals(a[1]))?y=this.M():n&&(o.equals(n[0])||o.equals(n[1]))?y=this.L():o.equals(9)&&this.y?this.w.fire():o.equals(14)?y=this.I():o.equals(13)?y=this.J():o.equals(2)&&A instanceof i.BaseActionViewItem&&A.trapsArrowNavigation?y=this.L():this.G(o)?this.m.keyDown?this.O(o):this.s=!0:y=!1,y&&(o.preventDefault(),o.stopPropagation())})),this.D(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,s=>{const o=new R.StandardKeyboardEvent(s);this.G(o)?(!this.m.keyDown&&this.s&&(this.s=!1,this.O(o)),o.preventDefault(),o.stopPropagation()):(o.equals(2)||o.equals(1026))&&this.H()})),this.r=this.D(E.trackFocus(this.domNode)),this.D(this.r.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this.v.fire(),this.q=void 0,this.p=void 0,this.s=!1)})),this.D(this.r.onDidFocus(()=>this.H())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),u.appendChild(this.domNode)}F(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(u){u?this.u.setAttribute("aria-label",u):this.u.removeAttribute("aria-label")}setFocusable(u){if(this.t=u,this.t){const e=this.viewItems.find(a=>a instanceof i.BaseActionViewItem&&a.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}G(u){let e=!1;return this.m.keys.forEach(a=>{e=e||u.equals(a)}),e}H(){for(let u=0;u<this.u.children.length;u++){const e=this.u.children[u];if(E.isAncestor(E.getActiveElement(),e)){this.q=u;break}}}get context(){return this.j}set context(u){this.j=u,this.viewItems.forEach(e=>e.setActionContext(u))}get actionRunner(){return this.f}set actionRunner(u){this.f=u,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.z.fire(e))),this.g.add(this.f.onWillRun(e=>this.C.fire(e))),this.viewItems.forEach(e=>e.actionRunner=u)}getContainer(){return this.domNode}hasAction(u){return this.viewItems.findIndex(e=>e.action.id===u.id)!==-1}getAction(u){if(typeof u=="number")return this.viewItems[u]?.action;if(u instanceof HTMLElement){for(;u.parentElement!==this.u;){if(!u.parentElement)return;u=u.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===u)return this.viewItems[e].action}}push(u,e={}){const a=Array.isArray(u)?u:[u];let n=g.isNumber(e.index)?e.index:null;a.forEach(s=>{const o=document.createElement("li");o.className="action-item",o.setAttribute("role","presentation");let y;const A={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(y=this.b.actionViewItemProvider(s,A)),y||(y=new i.ActionViewItem(this.context,s,A)),this.b.allowContextMenu||this.n.set(y,E.addDisposableListener(o,E.EventType.CONTEXT_MENU,S=>{E.EventHelper.stop(S,!0)})),y.actionRunner=this.f,y.setActionContext(this.context),y.render(o),this.t&&y instanceof i.BaseActionViewItem&&this.viewItems.length===0&&y.setFocusable(!0),n===null||n<0||n>=this.u.children.length?(this.u.appendChild(o),this.viewItems.push(y)):(this.u.insertBefore(o,this.u.children[n]),this.viewItems.splice(n,0,y),n++)}),typeof this.q=="number"&&this.focus(this.q),this.F()}getWidth(u){if(u>=0&&u<this.u.children.length){const e=this.u.children.item(u);if(e)return e.clientWidth}return 0}getHeight(u){if(u>=0&&u<this.u.children.length){const e=this.u.children.item(u);if(e)return e.clientHeight}return 0}pull(u){u>=0&&u<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[u]),this.n.deleteAndDispose(this.viewItems[u]),(0,D.dispose)(this.viewItems.splice(u,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,D.dispose)(this.viewItems),this.n.clearAndDisposeAll(),E.clearNode(this.u),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(u){let e=!1,a;if(u===void 0?e=!0:typeof u=="number"?a=u:typeof u=="boolean"&&(e=u),e&&typeof this.q>"u"){const n=this.viewItems.findIndex(s=>s.isEnabled());this.q=n===-1?void 0:n,this.N(void 0,void 0,!0)}else a!==void 0&&(this.q=a),this.N(void 0,void 0,!0)}I(){return this.q=this.length()-1,this.L(!0)}J(){return this.q=0,this.M(!0)}L(u){if(typeof this.q>"u")this.q=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.q;let a;do{if(!u&&this.b.preventLoopNavigation&&this.q+1>=this.viewItems.length)return this.q=e,!1;this.q=(this.q+1)%this.viewItems.length,a=this.viewItems[this.q]}while(this.q!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===W.Separator.ID));return this.N(),!0}M(u){if(typeof this.q>"u")this.q=0;else if(this.viewItems.length<=1)return!1;const e=this.q;let a;do{if(this.q=this.q-1,this.q<0){if(!u&&this.b.preventLoopNavigation)return this.q=e,!1;this.q=this.viewItems.length-1}a=this.viewItems[this.q]}while(this.q!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===W.Separator.ID));return this.N(!0),!0}N(u,e,a=!1){typeof this.q>"u"&&this.u.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.q&&this.viewItems[this.p]?.blur();const n=this.q!==void 0&&this.viewItems[this.q];if(n){let s=!0;g.isFunction(n.focus)||(s=!1),this.b.focusOnlyEnabledItems&&g.isFunction(n.isEnabled)&&!n.isEnabled()&&(s=!1),n.action.id===W.Separator.ID&&(s=!1),s?(a||this.p!==this.q)&&(n.focus(u),this.p=this.q):(this.u.focus({preventScroll:e}),this.p=void 0)}}O(u){if(typeof this.q>"u")return;const e=this.viewItems[this.q];if(e instanceof i.BaseActionViewItem){const a=e._context===null||e._context===void 0?u:e._context;this.run(e._action,a)}}async run(u,e){await this.f.run(u,e)}dispose(){this.j=void 0,this.viewItems=(0,D.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=c;function P(r){if(!r.length)return r;let u=-1;for(let a=0;a<r.length;a++)if(r[a].id!==W.Separator.ID){u=a;break}if(u===-1)return[];r=r.slice(u);for(let a=r.length-1;a>=0&&r[a].id===W.Separator.ID;a--)r.splice(a,1);let e=!1;for(let a=r.length-1;a>=0;a--){const n=r[a].id===W.Separator.ID;n&&!e?r.splice(a,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=P}),define(ge[61],me([1,0,4,20,51,60,53,56,19,3,77,100,88]),function(J,t,E,R,i,W,v,D,g,l,c,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const r=E.$;var u;(function(n){n[n.INFO=1]="INFO",n[n.WARNING=2]="WARNING",n[n.ERROR=3]="ERROR"})(u=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends g.Widget{constructor(s,o,y){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.D(new l.Emitter),this.onDidChange=this.I.event,this.J=this.D(new l.Emitter),this.onDidHeightChange=this.J.event,this.a=o,this.g=y,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=E.append(s,r(".monaco-inputbox.idle"));const A=this.g.flexibleHeight?"textarea":"input",S=E.append(this.element,r(".ibwrapper"));if(this.b=E.append(S,r(A+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.C(this.b,()=>this.element.classList.add("synthetic-focus")),this.z(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=E.append(S,r("div.mirror")),this.t.innerText="\xA0",this.H=new D.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),E.append(s,this.H.getDomNode()),this.D(this.H),this.D(this.H.onScroll(L=>this.b.scrollTop=L.scrollTop));const d=this.D(new R.DomEmitter(document,"selectionchange")),p=l.Event.filter(d.event,()=>document.getSelection()?.anchorNode===S);this.D(p(this.N,this)),this.D(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.u(this.b,()=>this.R()),this.z(this.b,()=>this.L()),this.C(this.b,()=>this.M()),this.D(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.D(new W.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(s){this.i=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.l=s,this.b.title=s}setAriaLabel(s){this.n=s,s?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.R())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.v=="number"?this.v:E.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(s){s?this.enable():this.disable()}get width(){return E.getTotalWidth(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let o=0;if(this.t){const y=parseFloat(this.t.style.paddingLeft||"")||0,A=parseFloat(this.t.style.paddingRight||"")||0;o=y+A}this.b.style.width=s-o+"px"}else this.b.style.width=s+"px";this.t&&(this.t.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.t&&(this.t.style.paddingRight=s+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const s=this.w,o=this.v,y=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:s,height:o}),this.H.setScrollPosition({scrollTop:y})}showMessage(s,o){this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(s.type));const y=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(y.border,"transparent")}`,this.h.content&&(this.hasFocus()||o)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let s=null;return this.r&&(s=this.r(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const o=this.g.inputBoxStyles;switch(s){case 1:return{border:o.inputValidationInfoBorder,background:o.inputValidationInfoBackground,foreground:o.inputValidationInfoForeground};case 2:return{border:o.inputValidationWarningBorder,background:o.inputValidationWarningBackground,foreground:o.inputValidationWarningForeground};default:return{border:o.inputValidationErrorBorder,background:o.inputValidationErrorBackground,foreground:o.inputValidationErrorForeground}}}O(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let s;const o=()=>s.style.width=E.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:A=>{if(!this.h)return null;s=E.append(A,r(".monaco-inputbox-container")),o();const S={inline:!0,className:"monaco-inputbox-message"},d=this.h.formatContent?(0,i.renderFormattedText)(this.h.content,S):(0,i.renderText)(this.h.content,S);d.classList.add(this.O(this.h.type));const p=this.stylesForType(this.h.type);return d.style.backgroundColor=p.background??"",d.style.color=p.foreground??"",d.style.border=p.border?`1px solid ${p.border}`:"",E.append(s,d),null},onHide:()=>{this.s="closed"},layout:o});let y;this.h.type===3?y=P.localize(0,null,this.h.content):this.h.type===2?y=P.localize(1,null,this.h.content):y=P.localize(2,null,this.h.content),v.alert(y),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const s=this.value,y=s.charCodeAt(s.length-1)===10?" ":"";(s+y).replace(/\u000c/g,"")?this.t.textContent=s+y:this.t.innerText="\xA0",this.layout()}U(){const s=this.g.inputBoxStyles,o=s.inputBackground??"",y=s.inputForeground??"",A=s.inputBorder??"";this.element.style.backgroundColor=o,this.element.style.color=y,this.b.style.backgroundColor="inherit",this.b.style.color=y,this.element.style.border=`1px solid ${E.asCssValueWithDefault(A,"transparent")}`}layout(){if(!this.t)return;const s=this.w;this.w=E.getTotalHeight(this.t),s!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(s){const o=this.inputElement,y=o.selectionStart,A=o.selectionEnd,S=o.value;y!==null&&A!==null&&(this.value=S.substr(0,y)+s+S.substr(A),o.setSelectionRange(y+1,y+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class a extends e{constructor(s,o,y){const A=P.localize(3,null),S=` or \u21C5 ${A}`,d=` (\u21C5 ${A})`;super(s,o,y),this.Y=this.D(new l.Emitter),this.onDidFocus=this.Y.event,this.Z=this.D(new l.Emitter),this.onDidBlur=this.Z.event,this.W=new c.HistoryNavigator(y.history,100);const p=()=>{if(y.showHistoryHint&&y.showHistoryHint()&&!this.i.endsWith(S)&&!this.i.endsWith(d)&&this.W.getHistory().length){const L=this.i.endsWith(")")?S:d,I=this.i+L;y.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=I:this.setPlaceHolder(I)}};this.X=new MutationObserver((L,I)=>{L.forEach(h=>{h.target.textContent||p()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.C(this.b,()=>p()),this.z(this.b,()=>{const L=I=>{if(this.i.endsWith(I)){const h=this.i.slice(0,this.i.length-I.length);return y.showPlaceholderOnFocus?this.i=h:this.setPlaceHolder(h),!0}else return!1};L(d)||L(S)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(s){this.value&&(s||this.value!==this.cb())&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let s=this.eb();s&&(s=s===this.value?this.eb():s),s&&(this.value=s,v.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let s=this.db();s&&(s=s===this.value?this.db():s),s&&(this.value=s,v.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let s=this.W.current();return s||(s=this.W.last(),this.W.next()),s}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=a}),define(ge[62],me([1,0,59,19,16,17,3,93]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class D extends E.BaseActionViewItem{constructor(P,r,u){super(P,r,u),this.a=this.D(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:u.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:u.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:u.toggleStyles?.inputActiveOptionForeground})),this.D(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(P){this.element=P,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(P){this.a.domNode.tabIndex=P?0:-1}}t.ToggleActionViewItem=D;class g extends R.Widget{constructor(P){super(),this.a=this.D(new v.Emitter),this.onChange=this.a.event,this.b=this.D(new v.Emitter),this.onKeyDown=this.b.event,this.c=P,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,u=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),u.preventDefault())}),this.D(this.G(this.domNode)),this.p(this.domNode,u=>{if(u.keyCode===10||u.keyCode===3){this.checked=!this.s,this.a.fire(!0),u.preventDefault(),u.stopPropagation();return}this.b.fire(u)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(P){this.s=P,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(P){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=P,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.Toggle=g;class l extends R.Widget{constructor(P,r,u){super(),this.c=P,this.g=r,this.a=new g({title:this.c,isChecked:this.g,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=u,this.h(),this.D(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(P){this.a.checked=P,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=l}),define(ge[126],me([1,0,62,16,98]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const W=i.localize(0,null),v=i.localize(1,null),D=i.localize(2,null);class g extends E.Toggle{constructor(r){super({icon:R.Codicon.caseSensitive,title:W+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=g;class l extends E.Toggle{constructor(r){super({icon:R.Codicon.wholeWord,title:v+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=l;class c extends E.Toggle{constructor(r){super({icon:R.Codicon.regex,title:D+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=c}),define(ge[127],me([1,0,4,126,61,19,3,97,2,87]),function(J,t,E,R,i,W,v,D,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const l=D.localize(0,null);class c extends W.Widget{constructor(r,u,e){super(),this.i=!0,this.l=!1,this.n=new g.DisposableStore,this.H=[],this.I=this.D(new v.Emitter),this.onDidOptionChange=this.I.event,this.J=this.D(new v.Emitter),this.onKeyDown=this.J.event,this.L=this.D(new v.Emitter),this.onMouseDown=this.L.event,this.M=this.D(new v.Emitter),this.onInput=this.M.event,this.N=this.D(new v.Emitter),this.onKeyUp=this.N.event,this.O=this.D(new v.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.D(new v.Emitter),this.onRegexKeyDown=this.P.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||l,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",s=e.appendRegexLabel||"",o=e.history||[],y=!!e.flexibleHeight,A=!!e.flexibleWidth,S=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.D(new i.HistoryInputBox(this.domNode,u,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:o,showHistoryHint:e.showHistoryHint,flexibleHeight:y,flexibleWidth:A,flexibleMaxHeight:S,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.D(new R.RegexToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.D(this.v.onChange(p=>{this.I.fire(p),!p&&this.i&&this.inputBox.focus(),this.validate()})),this.D(this.v.onKeyDown(p=>{this.P.fire(p)})),this.w=this.D(new R.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this.D(this.w.onChange(p=>{this.I.fire(p),!p&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.D(new R.CaseSensitiveToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.D(this.y.onChange(p=>{this.I.fire(p),!p&&this.i&&this.inputBox.focus(),this.validate()})),this.D(this.y.onKeyDown(p=>{this.O.fire(p)}));const d=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,p=>{if(p.equals(15)||p.equals(17)||p.equals(9)){const L=d.indexOf(document.activeElement);if(L>=0){let I=-1;p.equals(17)?I=(L+1)%d.length:p.equals(15)&&(L===0?I=d.length-1:I=L-1),p.equals(9)?(d[L].blur(),this.inputBox.focus()):I>=0&&d[I].focus(),E.EventHelper.stop(p,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),r?.appendChild(this.domNode),this.D(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",d=>{this.l=!0})),this.D(E.addDisposableListener(this.inputBox.inputElement,"compositionend",d=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,d=>this.J.fire(d)),this.q(this.inputBox.inputElement,d=>this.N.fire(d)),this.u(this.inputBox.inputElement,d=>this.M.fire()),this.j(this.inputBox.inputElement,d=>this.L.fire(d))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.Q(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const r of this.H)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const r of this.H)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const u of this.H)u.domNode.remove();this.H=[],this.n.dispose(),this.n=new g.DisposableStore;for(const u of r??[])this.n.add(u),this.s.appendChild(u.domNode),this.n.add(u.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(u);this.H.length>0&&(this.s.style.display=""),this.Q()}Q(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((u,e)=>u+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(r){this.y&&(this.y.checked=r)}getWholeWords(){return this.w?.checked??!1}setWholeWords(r){this.w&&(this.w.checked=r)}getRegex(){return this.v?.checked??!1}setRegex(r){this.v&&(this.v.checked=r,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}c.OPTION_CHANGE="optionChange",t.FindInput=c}),define(ge[128],me([1,0,4,20,14,60,127,61,57,36,62,54,24,31,13,9,16,17,68,3,32,2,44,6,102,94]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u,e,a,n,s,o,y,A,S,d,p,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class I extends g.ElementsDragAndDropData{set context(f){this.c.context=f}get context(){return this.c.context}constructor(f){super(f.elements.map(C=>C.element)),this.c=f}}function h(M){return M instanceof g.ElementsDragAndDropData?new I(M):M}class b{constructor(f,C){this.c=f,this.d=C,this.b=S.Disposable.None}getDragURI(f){return this.d.getDragURI(f.element)}getDragLabel(f,C){if(this.d.getDragLabel)return this.d.getDragLabel(f.map($=>$.element),C)}onDragStart(f,C){this.d.onDragStart?.(h(f),C)}onDragOver(f,C,$,Y,F=!0){const N=this.d.onDragOver(h(f),C&&C.element,$,Y),B=this.a!==C;if(B&&(this.b.dispose(),this.a=C),typeof C>"u")return N;if(B&&typeof N!="boolean"&&N.autoExpand&&(this.b=(0,a.disposableTimeout)(()=>{const q=this.c(),G=q.getNodeLocation(C);q.isCollapsed(G)&&q.setCollapsed(G,!1),this.a=void 0},500)),typeof N=="boolean"||!N.accept||typeof N.bubble>"u"||N.feedback){if(!F){const q=typeof N=="boolean"?N:N.accept,G=typeof N=="boolean"?void 0:N.effect;return{accept:q,effect:G,feedback:[$]}}return N}if(N.bubble===1){const q=this.c(),G=q.getNodeLocation(C),re=q.getParentNodeLocation(G),he=q.getNode(re),we=re&&q.getListIndex(re);return this.onDragOver(f,he,we,Y,!1)}const k=this.c(),z=k.getNodeLocation(C),H=k.getListIndex(z),U=k.getListRenderCount(z);return{...N,feedback:(0,e.range)(H,H+U)}}drop(f,C,$,Y){this.b.dispose(),this.a=void 0,this.d.drop(h(f),C&&C.element,$,Y)}onDragEnd(f){this.d.onDragEnd?.(f)}}function m(M,f){return f&&{...f,identityProvider:f.identityProvider&&{getId(C){return f.identityProvider.getId(C.element)}},dnd:f.dnd&&new b(M,f.dnd),multipleSelectionController:f.multipleSelectionController&&{isSelectionSingleChangeEvent(C){return f.multipleSelectionController.isSelectionSingleChangeEvent({...C,element:C.element})},isSelectionRangeChangeEvent(C){return f.multipleSelectionController.isSelectionRangeChangeEvent({...C,element:C.element})}},accessibilityProvider:f.accessibilityProvider&&{...f.accessibilityProvider,getSetSize(C){const $=M(),Y=$.getNodeLocation(C),F=$.getParentNodeLocation(Y);return $.getNode(F).visibleChildrenCount},getPosInSet(C){return C.visibleChildIndex+1},isChecked:f.accessibilityProvider&&f.accessibilityProvider.isChecked?C=>f.accessibilityProvider.isChecked(C.element):void 0,getRole:f.accessibilityProvider&&f.accessibilityProvider.getRole?C=>f.accessibilityProvider.getRole(C.element):()=>"treeitem",getAriaLabel(C){return f.accessibilityProvider.getAriaLabel(C.element)},getWidgetAriaLabel(){return f.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:f.accessibilityProvider&&f.accessibilityProvider.getWidgetRole?()=>f.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:f.accessibilityProvider&&f.accessibilityProvider.getAriaLevel?C=>f.accessibilityProvider.getAriaLevel(C.element):C=>C.depth,getActiveDescendantId:f.accessibilityProvider.getActiveDescendantId&&(C=>f.accessibilityProvider.getActiveDescendantId(C.element))},keyboardNavigationLabelProvider:f.keyboardNavigationLabelProvider&&{...f.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(C){return f.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(C.element)}}}}class w{constructor(f){this.a=f}getHeight(f){return this.a.getHeight(f.element)}getTemplateId(f){return this.a.getTemplateId(f.element)}hasDynamicHeight(f){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(f.element)}setDynamicHeight(f,C){this.a.setDynamicHeight?.(f.element,C)}}t.ComposedTreeDelegate=w;class O{static lift(f){return f instanceof O?f:new O(f)}static empty(f=0){return new O({focus:[],selection:[],expanded:Object.create(null),scrollTop:f})}constructor(f){if(this.focus=new Set(f.focus),this.selection=new Set(f.selection),f.expanded instanceof Array){this.expanded=Object.create(null);for(const C of f.expanded)this.expanded[C]=1}else this.expanded=f.expanded;this.expanded=f.expanded,this.scrollTop=f.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=O;var V;(function(M){M.None="none",M.OnHover="onHover",M.Always="always"})(V=t.RenderIndentGuides||(t.RenderIndentGuides={}));class ie{get elements(){return this.b}constructor(f,C=[]){this.b=C,this.a=new S.DisposableStore,this.onDidChange=y.Event.forEach(f,$=>this.b=$,this.a)}dispose(){this.a.dispose()}}class se{constructor(f,C,$,Y,F,N={}){this.o=f,this.p=C,this.q=Y,this.s=F,this.b=new Map,this.c=new Map,this.d=se.a,this.f=!1,this.g=!1,this.j=new Set,this.k=S.Disposable.None,this.m=new S.DisposableStore,this.templateId=f.templateId,this.updateOptions(N),y.Event.map($,B=>B.node)(this.u,this,this.m),f.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(f={}){if(typeof f.indent<"u"){const C=(0,d.clamp)(f.indent,0,40);if(C!==this.d){this.d=C;for(const[$,Y]of this.c)this.v($,Y)}}if(typeof f.renderIndentGuides<"u"){const C=f.renderIndentGuides!==V.None;if(C!==this.g){this.g=C;for(const[$,Y]of this.c)this.w($,Y);if(this.k.dispose(),C){const $=new S.DisposableStore;this.q.onDidChange(this.x,this,$),this.k=$,this.x(this.q.elements)}}}typeof f.hideTwistiesOfChildlessElements<"u"&&(this.f=f.hideTwistiesOfChildlessElements)}renderTemplate(f){const C=(0,E.append)(f,(0,E.$)(".monaco-tl-row")),$=(0,E.append)(C,(0,E.$)(".monaco-tl-indent")),Y=(0,E.append)(C,(0,E.$)(".monaco-tl-twistie")),F=(0,E.append)(C,(0,E.$)(".monaco-tl-contents")),N=this.o.renderTemplate(F);return{container:f,indent:$,twistie:Y,indentGuidesDisposable:S.Disposable.None,templateData:N}}renderElement(f,C,$,Y){this.c.set(f,$),this.b.set(f.element,f),this.v(f,$),this.o.renderElement(f,C,$.templateData,Y)}disposeElement(f,C,$,Y){$.indentGuidesDisposable.dispose(),this.o.disposeElement?.(f,C,$.templateData,Y),typeof Y=="number"&&(this.c.delete(f),this.b.delete(f.element))}disposeTemplate(f){this.o.disposeTemplate(f.templateData)}t(f){const C=this.b.get(f);!C||this.u(C)}u(f){const C=this.c.get(f);!C||(this.x(this.q.elements),this.v(f,C))}v(f,C){const $=se.a+(f.depth-1)*this.d;C.twistie.style.paddingLeft=`${$}px`,C.indent.style.width=`${$+this.d-16}px`,f.collapsible?C.container.setAttribute("aria-expanded",String(!f.collapsed)):C.container.removeAttribute("aria-expanded"),C.twistie.classList.remove(...s.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let Y=!1;this.o.renderTwistie&&(Y=this.o.renderTwistie(f.element,C.twistie)),f.collapsible&&(!this.f||f.visibleChildrenCount>0)?(Y||C.twistie.classList.add(...s.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),C.twistie.classList.add("collapsible"),C.twistie.classList.toggle("collapsed",f.collapsed)):C.twistie.classList.remove("collapsible","collapsed"),this.w(f,C)}w(f,C){if((0,E.clearNode)(C.indent),C.indentGuidesDisposable.dispose(),!this.g)return;const $=new S.DisposableStore,Y=this.p();for(;;){const F=Y.getNodeLocation(f),N=Y.getParentNodeLocation(F);if(!N)break;const B=Y.getNode(N),k=(0,E.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(B)&&k.classList.add("active"),C.indent.childElementCount===0?C.indent.appendChild(k):C.indent.insertBefore(k,C.indent.firstElementChild),this.s.add(B,k),$.add((0,S.toDisposable)(()=>this.s.delete(B,k))),f=B}C.indentGuidesDisposable=$}x(f){if(!this.g)return;const C=new Set,$=this.p();f.forEach(Y=>{const F=$.getNodeLocation(Y);try{const N=$.getParentNodeLocation(F);Y.collapsible&&Y.children.length>0&&!Y.collapsed?C.add(Y):N&&C.add($.getNode(N))}catch{}}),this.j.forEach(Y=>{C.has(Y)||this.s.forEach(Y,F=>F.classList.remove("active"))}),C.forEach(Y=>{this.j.has(Y)||this.s.forEach(Y,F=>F.classList.add("active"))}),this.j=C}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,S.dispose)(this.m)}}se.a=8;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(f){this.c=f,this.d=f.toLowerCase()}constructor(f,C,$){this.g=f,this.j=C,this.k=$,this.a=0,this.b=0,this.c="",this.d="",this.f=new S.DisposableStore,f.onWillRefilter(this.m,this,this.f)}filter(f,C){let $=1;if(this.k){const N=this.k.filter(f,C);if(typeof N=="boolean"?$=N?1:0:(0,P.isFilterResult)(N)?$=(0,P.getVisibleState)(N.visibility):$=N,$===0)return!1}if(this.a++,!this.c)return this.b++,{data:A.FuzzyScore.Default,visibility:$};const Y=this.j.getKeyboardNavigationLabel(f),F=Array.isArray(Y)?Y:[Y];for(const N of F){const B=N&&N.toString();if(typeof B>"u")return{data:A.FuzzyScore.Default,visibility:$};let k;if(this.g.findMatchType===ve.Contiguous){const z=B.toLowerCase().indexOf(this.d);if(z>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let H=this.d.length;H>0;H--)k.push(z+H-1)}}else k=(0,A.fuzzyScore)(this.c,this.d,0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,F.length===1?{data:k,visibility:$}:{data:{label:B,score:k},visibility:$}}return this.g.findMode===Q.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(f):2:{data:A.FuzzyScore.Default,visibility:$}}m(){this.a=0,this.b=0}dispose(){(0,S.dispose)(this.f)}}class de extends c.Toggle{constructor(f){super({icon:n.Codicon.listFilter,title:(0,L.localize)(0,null),isChecked:f.isChecked??!1,inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.ModeToggle=de;class ue extends c.Toggle{constructor(f){super({icon:n.Codicon.searchFuzzy,title:(0,L.localize)(1,null),isChecked:f.isChecked??!1,inputActiveOptionBorder:f.inputActiveOptionBorder,inputActiveOptionForeground:f.inputActiveOptionForeground,inputActiveOptionBackground:f.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const Z={inputBoxStyles:D.unthemedInboxStyles,toggleStyles:c.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Q;(function(M){M[M.Highlight=0]="Highlight",M[M.Filter=1]="Filter"})(Q=t.TreeFindMode||(t.TreeFindMode={}));var ve;(function(M){M[M.Fuzzy=0]="Fuzzy",M[M.Contiguous=1]="Contiguous"})(ve=t.TreeFindMatchType||(t.TreeFindMatchType={}));class pe extends S.Disposable{set mode(f){this.b.checked=f===Q.Filter,this.f.inputBox.setPlaceHolder(f===Q.Filter?(0,L.localize)(2,null):(0,L.localize)(3,null))}set matchType(f){this.c.checked=f===ve.Fuzzy}get value(){return this.f.inputBox.value}set value(f){this.f.inputBox.value=f}constructor(f,C,$,Y,F,N){super(),this.p=C,this.a=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new y.Emitter,this.onDidDisable=this._onDidDisable.event,f.appendChild(this.a.root),this.D((0,S.toDisposable)(()=>f.removeChild(this.a.root)));const B=N?.styles??Z;B.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=B.listFilterWidgetBackground),B.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${B.listFilterWidgetShadow}`),this.b=this.D(new de({...B.toggleStyles,isChecked:Y===Q.Filter})),this.c=this.D(new ue({...B.toggleStyles,isChecked:F===ve.Fuzzy})),this.onDidChangeMode=y.Event.map(this.b.onChange,()=>this.b.checked?Q.Filter:Q.Highlight,this.B),this.onDidChangeMatchType=y.Event.map(this.c.onChange,()=>this.c.checked?ve.Fuzzy:ve.Contiguous,this.B),this.f=this.D(new v.FindInput(this.a.findInput,$,{label:(0,L.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:B.inputBoxStyles,toggleStyles:B.toggleStyles,history:N?.history})),this.g=this.D(new W.ActionBar(this.a.actionbar)),this.mode=Y;const k=this.D(new R.DomEmitter(this.f.inputBox.inputElement,"keydown")),z=this.D(y.Event.chain(k.event)).map(G=>new i.StandardKeyboardEvent(G)).event;this.D(z(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const H=this.D(new u.Action("close",(0,L.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(H,{icon:!0,label:!1});const U=this.D(new R.DomEmitter(this.a.grab,"mousedown"));this.D(U.event(G=>{const re=new S.DisposableStore,he=re.add(new R.DomEmitter(window,"mousemove")),we=re.add(new R.DomEmitter(window,"mouseup")),ye=this.k,Le=G.pageX,Ce=this.m,De=G.pageY;this.a.grab.classList.add("grabbing");const Pe=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=je=>{const ze=je.pageX-Le;this.k=ye-ze;const Ue=je.pageY-De;this.m=Ce+Ue,this.layout()};re.add(he.event(Ie)),re.add(we.event(je=>{Ie(je),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Pe,re.dispose()}))}));const q=this.D(y.Event.chain(this.D(new R.DomEmitter(this.a.grab,"keydown")).event)).map(G=>new i.StandardKeyboardEvent(G)).event;this.D(q(G=>{let re,he;if(G.keyCode===15?re=Number.POSITIVE_INFINITY:G.keyCode===17?re=0:G.keyCode===10&&(re=this.k===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?he=0:G.keyCode===18&&(he=Number.POSITIVE_INFINITY),re!==void 0&&(G.preventDefault(),G.stopPropagation(),this.k=re,this.layout()),he!==void 0){G.preventDefault(),G.stopPropagation(),this.m=he;const we=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=we},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(f=this.j){this.j=f,this.k=(0,d.clamp)(this.k,0,Math.max(0,f-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,d.clamp)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(f){this.f.showMessage(f)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.timeout)(300),super.dispose()}}class Me{get pattern(){return this.b}get mode(){return this.d}set mode(f){f!==this.d&&(this.d=f,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(f))}get matchType(){return this.f}set matchType(f){f!==this.f&&(this.f=f,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(f))}constructor(f,C,$,Y,F,N={}){this.t=f,this.u=$,this.v=Y,this.w=F,this.x=N,this.b="",this.c="",this.j=0,this.k=new y.Emitter,this.onDidChangeMode=this.k.event,this.m=new y.Emitter,this.onDidChangeMatchType=this.m.event,this.o=new y.Emitter,this.onDidChangePattern=this.o.event,this.p=new y.Emitter,this.onDidChangeOpenState=this.p.event,this.q=new S.DisposableStore,this.s=new S.DisposableStore,this.d=f.options.defaultFindMode??Q.Highlight,this.f=f.options.defaultFindMatchType??ve.Fuzzy,C.onDidSplice(this.z,this,this.s)}updateOptions(f={}){f.defaultFindMode!==void 0&&(this.mode=f.defaultFindMode),f.defaultFindMatchType!==void 0&&(this.matchType=f.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new pe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(f=>this.mode=f,void 0,this.q),this.g.onDidChangeMatchType(f=>this.matchType=f,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){!this.g||(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new S.DisposableStore,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(f){this.b=f,this.o.fire(f),this.v.pattern=f,this.t.refilter(),f&&this.t.focusNext(0,!0,void 0,$=>!A.FuzzyScore.isDefault($.filterData));const C=this.t.getFocus();if(C.length>0){const $=C[0];this.t.getRelativeTop($)===null&&this.t.reveal($,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const f=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&f?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,L.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(f){return!this.g||!this.pattern||this.d===Q.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!A.FuzzyScore.isDefault(f.filterData)}layout(f){this.j=f,this.g?.layout(f)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Re(M){let f=r.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(M.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?f=r.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(M.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?f=r.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(M.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(f=r.TreeMouseEventTarget.Filter),{browserEvent:M.browserEvent,element:M.element?M.element.element:null,target:f}}function le(M){return{element:M.element?M.element.element:null,browserEvent:M.browserEvent,anchor:M.anchor}}function _(M,f){f(M),M.children.forEach(C=>_(C,f))}class ne{get f(){return this.d||(this.d=this.m()),this.d}constructor(f,C){this.g=f,this.j=C,this.a=[],this.c=new y.Emitter,this.onDidChange=this.c.event}set(f,C){!C?.__forceEvent&&(0,e.equals)(this.a,f)||this.k(f,!1,C)}k(f,C,$){if(this.a=[...f],this.b=void 0,this.d=void 0,!C){const Y=this;this.c.fire({get elements(){return Y.get()},browserEvent:$})}}get(){return this.b||(this.b=this.a.map(f=>f.element)),[...this.b]}getNodes(){return this.a}has(f){return this.f.has(f)}onDidModelSplice({insertedNodes:f,deletedNodes:C}){if(!this.j){const k=this.m(),z=H=>k.delete(H);C.forEach(H=>_(H,z)),this.set([...k.values()]);return}const $=new Set,Y=k=>$.add(this.j.getId(k.element).toString());C.forEach(k=>_(k,Y));const F=new Map,N=k=>F.set(this.j.getId(k.element).toString(),k);f.forEach(k=>_(k,N));const B=[];for(const k of this.a){const z=this.j.getId(k.element).toString();if(!$.has(z))B.push(k);else{const U=F.get(z);U&&B.push(U)}}if(this.a.length>0&&B.length===0){const k=this.g();k&&B.push(k)}this.k(B,!0)}m(){const f=new Set;for(const C of this.a)f.add(C);return f}}class ee extends l.MouseController{constructor(f,C){super(f),this.z=C}u(f){if((0,l.isButton)(f.browserEvent.target)||(0,l.isInputElement)(f.browserEvent.target)||(0,l.isMonacoEditor)(f.browserEvent.target))return;const C=f.element;if(!C)return super.u(f);if(this.p(f)||this.o(f))return super.u(f);const $=f.browserEvent.target,Y=$.classList.contains("monaco-tl-twistie")||$.classList.contains("monaco-icon-label")&&$.classList.contains("folder-icon")&&f.browserEvent.offsetX<16;let F=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?F=this.z.expandOnlyOnTwistieClick(C.element):F=!!this.z.expandOnlyOnTwistieClick,F&&!Y&&f.browserEvent.detail!==2)return super.u(f);if(!this.z.expandOnDoubleClick&&f.browserEvent.detail===2)return super.u(f);if(C.collapsible){const N=this.z.getNodeLocation(C),B=f.browserEvent.altKey;if(this.z.setFocus([N]),this.z.toggleCollapsed(N,B),F&&Y)return}super.u(f)}v(f){f.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(f)}}class te extends l.List{constructor(f,C,$,Y,F,N,B,k){super(f,C,$,Y,k),this.p=F,this.s=N,this.M=B}F(f){return new ee(this,f.tree)}splice(f,C,$=[]){if(super.splice(f,C,$),$.length===0)return;const Y=[],F=[];let N;$.forEach((B,k)=>{this.p.has(B)&&Y.push(f+k),this.s.has(B)&&F.push(f+k),this.M.has(B)&&(N=f+k)}),Y.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Y])),F.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...F])),typeof N=="number"&&super.setAnchor(N)}setFocus(f,C,$=!1){super.setFocus(f,C),$||this.p.set(f.map(Y=>this.element(Y)),C)}setSelection(f,C,$=!1){super.setSelection(f,C),$||this.s.set(f.map(Y=>this.element(Y)),C)}setAnchor(f,C=!1){super.setAnchor(f),C||(typeof f>"u"?this.M.set([]):this.M.set([this.element(f)]))}}class T{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return y.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return y.Event.filter(y.Event.map(this.j.onMouseDblClick,Re),f=>f.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return y.Event.map(this.j.onContextMenu,le)}get onTap(){return y.Event.map(this.j.onTap,Re)}get onPointer(){return y.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return y.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??Q.Highlight}set findMode(f){this.x&&(this.x.mode=f)}get findMatchType(){return this.x?.matchType??ve.Fuzzy}set findMatchType(f){this.x&&(this.x.matchType=f)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:y.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(f,C,$,Y,F={}){this.D=f,this.E=F,this.w=new y.EventBufferer,this.onDidChangeFindOpenState=y.Event.None,this.A=new S.DisposableStore,this.B=new y.Emitter,this.onWillRefilter=this.B.event,this.C=new y.Emitter,this.onDidUpdateOptions=this.C.event;const N=new w($),B=new y.Relay,k=new y.Relay,z=this.A.add(new ie(k.event)),H=new o.SetMap;this.k=Y.map(G=>new se(G,()=>this.o,B.event,z,H,F));for(const G of this.k)this.A.add(G);let U;F.keyboardNavigationLabelProvider&&(U=new ae(this,F.keyboardNavigationLabelProvider,F.filter),F={...F,filter:U},this.A.add(U)),this.p=new ne(()=>this.j.getFocusedElements()[0],F.identityProvider),this.q=new ne(()=>this.j.getSelectedElements()[0],F.identityProvider),this.u=new ne(()=>this.j.getAnchorElement(),F.identityProvider),this.j=new te(f,C,N,this.k,this.p,this.q,this.u,{...m(()=>this.o,F),tree:this}),this.o=this.I(f,this.j,F),B.input=this.o.onDidChangeCollapseState;const q=y.Event.forEach(this.o.onDidSplice,G=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(G),this.q.onDidModelSplice(G)})},this.A);if(q(()=>null,null,this.A),k.input=y.Event.chain(y.Event.any(q,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const G=new Set;for(const re of this.p.getNodes())G.add(re);for(const re of this.q.getNodes())G.add(re);return[...G.values()]}).event,F.keyboardSupport!==!1){const G=y.Event.chain(this.j.onKeyDown).filter(re=>!(0,l.isInputElement)(re.target)).map(re=>new i.StandardKeyboardEvent(re));G.filter(re=>re.keyCode===15).on(this.F,this,this.A),G.filter(re=>re.keyCode===17).on(this.G,this,this.A),G.filter(re=>re.keyCode===10).on(this.H,this,this.A)}if((F.findWidgetEnabled??!0)&&F.keyboardNavigationLabelProvider&&F.contextViewProvider){const G=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Me(this,this.o,this.j,U,F.contextViewProvider,G),this.y=re=>this.x.shouldAllowFocus(re),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=y.Event.None,this.onDidChangeFindMatchType=y.Event.None;this.z=(0,E.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===V.Always)}updateOptions(f={}){this.E={...this.E,...f};for(const C of this.k)C.updateOptions(f);this.j.updateOptions(this.E),this.x?.updateOptions(f),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===V.Always)}get options(){return this.E}updateWidth(f){const C=this.o.getListIndex(f);C!==-1&&this.j.updateWidth(C)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(f){this.j.scrollTop=f}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(f){this.j.scrollLeft=f}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const f=this.j.firstVisibleIndex;return f<0||f>=this.j.length?void 0:this.j.element(f).element}get lastVisibleElement(){const f=this.j.lastVisibleIndex;return this.j.element(f).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(f){this.j.ariaLabel=f}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(f,C){this.j.layout(f,C),(0,p.isNumber)(C)&&this.x?.layout(C)}style(f){const C=`.${this.j.domId}`,$=[];f.treeIndentGuidesStroke&&($.push(`.monaco-list${C}:hover .monaco-tl-indent > .indent-guide, .monaco-list${C}.always .monaco-tl-indent > .indent-guide  { border-color: ${f.treeInactiveIndentGuidesStroke}; }`),$.push(`.monaco-list${C} .monaco-tl-indent > .indent-guide.active { border-color: ${f.treeIndentGuidesStroke}; }`)),this.z.textContent=$.join(`
`),this.j.style(f)}getParentElement(f){const C=this.o.getParentNodeLocation(f);return this.o.getNode(C).element}getFirstElementChild(f){return this.o.getFirstElementChild(f)}getNode(f){return this.o.getNode(f)}getNodeLocation(f){return this.o.getNodeLocation(f)}collapse(f,C=!1){return this.o.setCollapsed(f,!0,C)}expand(f,C=!1){return this.o.setCollapsed(f,!1,C)}toggleCollapsed(f,C=!1){return this.o.setCollapsed(f,void 0,C)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(f){return this.o.isCollapsible(f)}setCollapsible(f,C){return this.o.setCollapsible(f,C)}isCollapsed(f){return this.o.isCollapsed(f)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(f){if(typeof f>"u")return this.j.setAnchor(void 0);const C=this.o.getNode(f);this.u.set([C]);const $=this.o.getListIndex(f);$>-1&&this.j.setAnchor($,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(f,C){const $=f.map(F=>this.o.getNode(F));this.q.set($,C);const Y=f.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setSelection(Y,C,!0)}getSelection(){return this.q.get()}setFocus(f,C){const $=f.map(F=>this.o.getNode(F));this.p.set($,C);const Y=f.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setFocus(Y,C,!0)}focusNext(f=1,C=!1,$,Y=this.y){this.j.focusNext(f,C,$,Y)}focusPrevious(f=1,C=!1,$,Y=this.y){this.j.focusPrevious(f,C,$,Y)}focusNextPage(f,C=this.y){return this.j.focusNextPage(f,C)}focusPreviousPage(f,C=this.y){return this.j.focusPreviousPage(f,C)}focusLast(f,C=this.y){this.j.focusLast(f,C)}focusFirst(f,C=this.y){this.j.focusFirst(f,C)}getFocus(){return this.p.get()}reveal(f,C){this.o.expandTo(f);const $=this.o.getListIndex(f);$!==-1&&this.j.reveal($,C)}getRelativeTop(f){const C=this.o.getListIndex(f);return C===-1?null:this.j.getRelativeTop(C)}getViewState(f=this.options.identityProvider){if(!f)throw new r.TreeError(this.D,"Can't get tree view state without an identity provider");const C=N=>f.getId(N).toString(),$=O.empty(this.scrollTop);for(const N of this.getFocus())$.focus.add(C(N));for(const N of this.getSelection())$.selection.add(C(N));const Y=this.o.getNode(),F=[Y];for(;F.length>0;){const N=F.shift();N!==Y&&N.collapsible&&($.expanded[C(N.element)]=N.collapsed?0:1),F.push(...N.children)}return $}F(f){f.preventDefault(),f.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const $=C[0],Y=this.o.getNodeLocation($);if(!this.o.setCollapsed(Y,!0)){const N=this.o.getParentNodeLocation(Y);if(!N)return;const B=this.o.getListIndex(N);this.j.reveal(B),this.j.setFocus([B])}}G(f){f.preventDefault(),f.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const $=C[0],Y=this.o.getNodeLocation($);if(!this.o.setCollapsed(Y,!1)){if(!$.children.some(k=>k.visible))return;const[N]=this.j.getFocus(),B=N+1;this.j.reveal(B),this.j.setFocus([B])}}H(f){f.preventDefault(),f.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const $=C[0],Y=this.o.getNodeLocation($),F=f.browserEvent.altKey;this.o.setCollapsed(Y,void 0,F)}navigate(f){return new x(this.j,this.o,f)}dispose(){(0,S.dispose)(this.A),this.j.dispose()}}t.AbstractTree=T;class x{constructor(f,C,$){this.b=f,this.c=C,$?this.a=this.c.getListIndex($):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(J,t,E,R,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class v extends E.AbstractTree{constructor(g,l,c,P,r,u={}){super(g,l,c,P,u),this.f=g,this.g=r,this.d=new Map,this.c=u.identityProvider}getInput(){return this.b}setInput(g,l){if(l&&!this.c)throw new i.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=g,!g){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!l){this.m(g);return}const c=[],P=[],r=e=>{const a=this.c.getId(e).toString();return!l.expanded[a]},u=e=>{const a=this.c.getId(e.element).toString();l.focus.has(a)&&c.push(e.element),l.selection.has(a)&&P.push(e.element)};this.m(g,r,u),this.setFocus(c),this.setSelection(P),l&&typeof l.scrollTop=="number"&&(this.scrollTop=l.scrollTop)}updateChildren(g=this.b){if(typeof this.b>"u")throw new i.TreeError(this.f,"Tree input not set");let l;this.c&&(l=c=>{const P=this.c.getId(c).toString(),r=this.d.get(P);if(!!r)return r.collapsed}),this.m(g,l)}resort(g=this.b,l=!0){this.o.resort(g===this.b?null:g,l)}refresh(g){if(g===void 0){this.j.rerender();return}this.o.rerender(g)}m(g,l,c){let P;if(this.c){const r=new Set,u=c;c=e=>{const a=this.c.getId(e.element).toString();r.add(a),this.d.set(a,e),u?.(e)},P=e=>{const a=this.c.getId(e.element).toString();r.has(a)||this.d.delete(a)}}this.o.setChildren(g===this.b?null:g,this.s(g,l).elements,{onDidCreateNode:c,onDidDeleteNode:P})}s(g,l){const c=[...this.g.getChildren(g)];return{elements:W.Iterable.map(c,r=>{const{elements:u,size:e}=this.s(r,l),a=this.g.hasChildren?this.g.hasChildren(r):void 0,n=e===0?void 0:l&&l(r);return{element:r,children:u,collapsible:a,collapsed:n}}),size:c.length}}I(g,l,c){return new R.ObjectTreeModel(g,l,c)}}t.DataTree=v}),define(ge[63],me([1,0,13,9,30,27,25,7,3,2,49,11,6]),function(J,t,E,R,i,W,v,D,g,l,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var u;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(u||(u={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(a||(a={}));function n(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(s||(s={}));function o(le){let _=0;for(let ne=0;;ne+=7){const ee=le.read(1);if(_|=(ee.buffer[0]&127)<<ne,!(ee.buffer[0]&128))return _}}const y=L(0);function A(le,_){if(_===0){le.write(y);return}let ne=0;for(let te=_;te!==0;te=te>>>7)ne++;const ee=i.VSBuffer.alloc(ne);for(let te=0;_!==0;te++)ee.buffer[te]=_&127,_=_>>>7,_>0&&(ee.buffer[te]|=128);le.write(ee)}class S{constructor(_){this.b=_,this.a=0}read(_){const ne=this.b.slice(this.a,this.a+_);return this.a+=ne.byteLength,ne}}t.BufferReader=S;class d{constructor(){this.a=[]}get buffer(){return i.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}t.BufferWriter=d;var p;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(p||(p={}));function L(le){const _=i.VSBuffer.alloc(1);return _.writeUInt8(le,0),_}const I={Undefined:L(p.Undefined),String:L(p.String),Buffer:L(p.Buffer),VSBuffer:L(p.VSBuffer),Array:L(p.Array),Object:L(p.Object),Uint:L(p.Int)},h=typeof Buffer<"u";function b(le,_){if(typeof _>"u")le.write(I.Undefined);else if(typeof _=="string"){const ne=i.VSBuffer.fromString(_);le.write(I.String),A(le,ne.byteLength),le.write(ne)}else if(h&&Buffer.isBuffer(_)){const ne=i.VSBuffer.wrap(_);le.write(I.Buffer),A(le,ne.byteLength),le.write(ne)}else if(_ instanceof i.VSBuffer)le.write(I.VSBuffer),A(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(I.Array),A(le,_.length);for(const ne of _)b(le,ne)}else if(typeof _=="number"&&(_|0)===_)le.write(I.Uint),A(le,_);else{const ne=i.VSBuffer.fromString(JSON.stringify(_));le.write(I.Object),A(le,ne.byteLength),le.write(ne)}}t.serialize=b;function m(le){switch(le.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return le.read(o(le)).toString();case p.Buffer:return le.read(o(le)).buffer;case p.VSBuffer:return le.read(o(le));case p.Array:{const ne=o(le),ee=[];for(let te=0;te<ne;te++)ee.push(m(le));return ee}case p.Object:return JSON.parse(le.read(o(le)).toString());case p.Int:return o(le)}}t.deserialize=m;class w{constructor(_,ne,ee=null,te=1e3){this.h=_,this.j=ne,this.k=ee,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(T=>this.q(T)),this.m({type:200})}registerChannel(_,ne){this.b.set(_,ne),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ne=this.o([_.type]);this.k?.logOutgoing(ne,0,1,n(_.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ne,_.id,1,n(_.type),_.data);return}}}o(_,ne=void 0){const ee=new d;return b(ee,_),b(ee,ne),this.p(ee.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ne=new S(_),ee=m(ne),te=m(ne),T=ee[0];switch(T){case 100:return this.k?.logIncoming(_.byteLength,ee[1],1,`${e(T)}: ${ee[2]}.${ee[3]}`,te),this.s({type:T,id:ee[1],channelName:ee[2],name:ee[3],arg:te});case 102:return this.k?.logIncoming(_.byteLength,ee[1],1,`${e(T)}: ${ee[2]}.${ee[3]}`,te),this.t({type:T,id:ee[1],channelName:ee[2],name:ee[3],arg:te});case 101:return this.k?.logIncoming(_.byteLength,ee[1],1,`${e(T)}`),this.u({type:T,id:ee[1]});case 103:return this.k?.logIncoming(_.byteLength,ee[1],1,`${e(T)}`),this.u({type:T,id:ee[1]})}}s(_){const ne=this.b.get(_.channelName);if(!ne){this.v(_);return}const ee=new W.CancellationTokenSource;let te;try{te=ne.call(this.j,_.name,_.arg,ee.token)}catch(M){te=Promise.reject(M)}const T=_.id;te.then(M=>{this.m({id:T,data:M,type:201}),this.d.delete(_.id)},M=>{M instanceof Error?this.m({id:T,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:T,data:M,type:203}),this.d.delete(_.id)});const x=(0,l.toDisposable)(()=>ee.cancel());this.d.set(_.id,x)}t(_){const ne=this.b.get(_.channelName);if(!ne){this.v(_);return}const ee=_.id,T=ne.listen(this.j,_.name,_.arg)(x=>this.m({id:ee,data:x,type:204}));this.d.set(_.id,T)}u(_){const ne=this.d.get(_.id);ne&&(ne.dispose(),this.d.delete(_.id))}v(_){let ne=this.g.get(_.channelName);ne||(ne=[],this.g.set(_.channelName,ne));const ee=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:_,timeoutTimer:ee})}w(_){const ne=this.g.get(_);if(ne){for(const ee of ne)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=w;var O;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(O=t.RequestInitiator||(t.RequestInitiator={}));class V{constructor(_,ne=null){this.l=_,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=ne}getChannel(_){const ne=this;return{call(ee,te,T){return ne.a?Promise.reject(new D.CancellationError):ne.m(_,ee,te,T)},listen(ee,te){return ne.a?g.Event.None:ne.o(_,ee,te)}}}m(_,ne,ee,te=W.CancellationToken.None){const T=this.g++,M={id:T,type:100,channelName:_,name:ne,arg:ee};if(te.isCancellationRequested)return Promise.reject(new D.CancellationError);let f;return new Promise(($,Y)=>{if(te.isCancellationRequested)return Y(new D.CancellationError);const F=()=>{const z=H=>{switch(H.type){case 201:this.f.delete(T),$(H.data);break;case 202:{this.f.delete(T);const U=new Error(H.data.message);U.stack=Array.isArray(H.data.stack)?H.data.stack.join(`
`):H.data.stack,U.name=H.data.name,Y(U);break}case 203:this.f.delete(T),Y(H.data);break}};this.f.set(T,z),this.p(M)};let N=null;this.b===s.Idle?F():(N=(0,R.createCancelablePromise)(z=>this.u()),N.then(()=>{N=null,F()}));const B=()=>{N?(N.cancel(),N=null):this.p({id:T,type:101}),Y(new D.CancellationError)},k=te.onCancellationRequested(B);f=(0,l.combinedDisposable)((0,l.toDisposable)(B),k),this.d.add(f)}).finally(()=>{this.d.delete(f)})}o(_,ne,ee){const te=this.g++,x={id:te,type:102,channelName:_,name:ne,arg:ee};let M=null;const f=new g.Emitter({onWillAddFirstListener:()=>{M=(0,R.createCancelablePromise)($=>this.u()),M.then(()=>{M=null,this.d.add(f),this.p(x)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(f),this.p({id:te,type:103}))}}),C=$=>f.fire($.data);return this.f.set(te,C),f.event}p(_){switch(_.type){case 100:case 102:{const ne=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ne,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ne=this.q([_.type,_.id]);this.j?.logOutgoing(ne,_.id,0,e(_.type));return}}}q(_,ne=void 0){const ee=new d;return b(ee,_),b(ee,ne),this.r(ee.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ne=new S(_),ee=m(ne),te=m(ne),T=ee[0];switch(T){case 200:return this.j?.logIncoming(_.byteLength,0,0,n(T)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,ee[1],0,n(T),te),this.t({type:ee[0],id:ee[1],data:te})}}t(_){if(_.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}Ve([v.memoize],V.prototype,"onDidInitializePromise",null),t.ChannelClient=V;class ie{get connections(){const _=[];return this.f.forEach(ne=>_.push(ne)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:ne,onDidClientDisconnect:ee})=>{g.Event.once(ne.onMessage)(T=>{const x=new S(T),M=m(x),f=new w(ne,M),C=new V(ne);this.a.forEach((Y,F)=>f.registerChannel(F,Y));const $={channelServer:f,channelClient:C,ctx:M};this.f.add($),this.g.fire($),ee(()=>{f.dispose(),C.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(_,ne){const ee=this;return{call(te,T,x){let M;if((0,r.isFunction)(ne)){const C=(0,E.getRandomElement)(ee.connections.filter(ne));M=C?Promise.resolve(C):g.Event.toPromise(g.Event.filter(ee.onDidAddConnection,ne))}else M=ne.routeCall(ee,te,T);const f=M.then(C=>C.channelClient.getChannel(_));return ae(f).call(te,T,x)},listen(te,T){if((0,r.isFunction)(ne))return ee.j(_,ne,te,T);const x=ne.routeEvent(ee,te,T).then(M=>M.channelClient.getChannel(_));return ae(x).listen(te,T)}}}j(_,ne,ee,te){const T=this;let x=new l.DisposableStore;const M=new g.Emitter({onWillAddFirstListener:()=>{x=new l.DisposableStore;const f=new g.EventMultiplexer,C=new Map,$=F=>{const B=F.channelClient.getChannel(_).listen(ee,te),k=f.add(B);C.set(F,k)},Y=F=>{const N=C.get(F);!N||(N.dispose(),C.delete(F))};T.connections.filter(ne).forEach($),g.Event.filter(T.onDidAddConnection,ne)($,void 0,x),T.onDidRemoveConnection(Y,void 0,x),f.event(M.fire,M,x),x.add(f)},onDidRemoveLastListener:()=>{x.dispose()}});return M.event}registerChannel(_,ne){this.a.set(_,ne),this.f.forEach(ee=>{ee.channelServer.registerChannel(_,ne)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=ie;class se{constructor(_,ne,ee=null){const te=new d;b(te,ne),_.send(te.buffer),this.a=new V(_,ee),this.d=new w(_,ne,ee)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ne){this.d.registerChannel(_,ne)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=se;function ae(le){return{call(_,ne,ee){return le.then(te=>te.call(_,ne,ee))},listen(_,ne){const ee=new g.Relay;return le.then(te=>ee.input=te.listen(_,ne)),ee.event}}}t.getDelayedChannel=ae;function de(le){let _=!1;return{call(ne,ee,te){return _?le.call(ne,ee,te):(0,R.timeout)(0).then(()=>_=!0).then(()=>le.call(ne,ee,te))},listen(ne,ee){if(_)return le.listen(ne,ee);const te=new g.Relay;return(0,R.timeout)(0).then(()=>_=!0).then(()=>te.input=le.listen(ne,ee)),te.event}}}t.getNextTickChannel=de;class ue{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ne of _.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await g.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.StaticRouter=ue;var Z;(function(le){function _(T,x){const M=T,f=x&&x.disableMarshalling,C=new Map;for(const $ in M)ee($)&&C.set($,g.Event.buffer(M[$],!0));return new class{listen($,Y,F){const N=C.get(Y);if(N)return N;if(te(Y)){const B=M[Y];if(typeof B=="function")return B.call(M,F)}throw new Error(`Event not found: ${Y}`)}call($,Y,F){const N=M[Y];if(typeof N=="function"){if(!f&&Array.isArray(F))for(let B=0;B<F.length;B++)F[B]=(0,c.revive)(F[B]);return N.apply(M,F)}throw new Error(`Method not found: ${Y}`)}}}le.fromService=_;function ne(T,x){const M=x&&x.disableMarshalling;return new Proxy({},{get(f,C){if(typeof C=="string")return x?.properties?.has(C)?x.properties.get(C):te(C)?function($){return T.listen(C,$)}:ee(C)?T.listen(C):async function(...$){let Y;x&&!(0,r.isUndefinedOrNull)(x.context)?Y=[x.context,...$]:Y=$;const F=await T.call(C,Y);return M?F:(0,c.revive)(F)};throw new Error(`Property not found: ${String(C)}`)}})}le.toService=ne;function ee(T){return T[0]==="o"&&T[1]==="n"&&P.isUpperAsciiLetter(T.charCodeAt(2))}function te(T){return/^onDynamic/.test(T)&&P.isUpperAsciiLetter(T.charCodeAt(9))}})(Z=t.ProxyChannel||(t.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ve(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function pe(le){return Array.isArray(le)?le.map(ve):ve(le)}function Me(le,_,ne,ee,te,T,x){x=pe(x);const M=Q[te],f=M[ee%M.length];let C=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(T)?(C=C.concat(x),C.push(")")):C.push(x),console.log.apply(console,C)}class Re{constructor(_,ne){this.d=_,this.f=ne,this.a=0,this.b=0}logOutgoing(_,ne,ee,te,T){this.b+=_,Me(this.d,this.b,_,ne,ee,te,T)}logIncoming(_,ne,ee,te,T){this.a+=_,Me(this.f,this.a,_,ne,ee,te,T)}}t.IPCLogger=Re}),define(ge[29],me([1,0,5]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,81,29]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function W(D,g,l){const c=[],P=i++,r=`vscode:onContextMenu${P}`,u=(e,a,n)=>{c[a].click?.(n)};R.ipcRenderer.once(r,u),R.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,a)=>{a===P&&(R.ipcRenderer.removeListener(r,u),l?.())}),R.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,P,D.map(e=>v(e,c)),r,g)}t.popup=W;function v(D,g){const l={id:g.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return g.push(D),Array.isArray(D.submenu)&&(l.submenu=D.submenu.map(c=>v(c,g))),l}}),define(ge[131],me([1,0,30,3,63,82,29]),function(J,t,E,R,i,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class D extends i.IPCClient{static f(){const l=R.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:message",(c,P)=>E.VSBuffer.wrap(P));return v.ipcRenderer.send("vscode:hello"),new W.Protocol(v.ipcRenderer,l)}constructor(l){const c=D.f();super(c,l),this.b=c}dispose(){this.b.disconnect()}}t.Client=D}),define(ge[132],me([12,10]),function(J,t){return J.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(J,t){return J.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[37],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(v){v.serviceIds=new Map,v.DI_TARGET="$di$target",v.DI_DEPENDENCIES="$di$dependencies";function D(g){return g[v.DI_DEPENDENCIES]||[]}v.getServiceDependencies=D})(E=t._util||(t._util={})),t.IInstantiationService=i("instantiationService");function R(v,D,g){D[E.DI_TARGET]===D?D[E.DI_DEPENDENCIES].push({id:v,index:g}):(D[E.DI_DEPENDENCIES]=[{id:v,index:g}],D[E.DI_TARGET]=D)}function i(v){if(E.serviceIds.has(v))return E.serviceIds.get(v);const D=function(g,l,c){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,g,c)};return D.toString=()=>v,E.serviceIds.set(v,D),D}t.createDecorator=i;function W(v){return v}t.refineServiceDecorator=W}),define(ge[134],me([1,0,37]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function R(W){return!!W.hostName&&!!W.errorMessage}t.isRemoteDiagnosticError=R;class i{async getPerformanceInfo(v,D){return{}}async getSystemInfo(v,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(v,D){return""}async getWorkspaceFileExtensions(v){return{extensions:[]}}async reportWorkspaceStats(v){}}t.NullDiagnosticsService=i}),define(ge[135],me([1,0,113,22,11,6,15,132,37,5,28]),function(J,t,E,R,i,W,v,D,g,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.getPlatformFileLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,g.createDecorator)("fileService");function P(_){return _.create===!0}t.isFileOpenForWriteOptions=P;var r;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(r=t.FileType||(t.FileType={}));var u;(function(_){_[_.Readonly=1]="Readonly"})(u=t.FilePermission||(t.FilePermission={}));var e;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(e=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function a(_){return!!(_.capabilities&2)}t.hasReadWriteCapability=a;function n(_){return!!(_.capabilities&8)}t.hasFileFolderCopyCapability=n;function s(_){return!!(_.capabilities&32768)}t.hasFileCloneCapability=s;function o(_){return!!(_.capabilities&4)}t.hasOpenReadWriteCloseCapability=o;function y(_){return!!(_.capabilities&16)}t.hasFileReadStreamCapability=y;function A(_){return a(_)?!!(_.capabilities&16384):!1}t.hasFileAtomicReadCapability=A;var S;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(S=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class d extends Error{static create(ne,ee){const te=new d(ne.toString(),ee);return I(te,ee),te}constructor(ne,ee){super(ne),this.code=ee}}t.FileSystemProviderError=d;function p(_,ne){return d.create(_,ne)}t.createFileSystemProviderError=p;function L(_){return _||p((0,D.localize)(0,null),S.Unknown)}t.ensureFileSystemProviderError=L;function I(_,ne){return _.name=ne?`${ne} (FileSystemError)`:"FileSystemError",_}t.markAsFileSystemProviderError=I;function h(_){if(!_)return S.Unknown;if(_ instanceof d)return _.code;const ne=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ne)return S.Unknown;switch(ne[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}t.toFileSystemProviderErrorCode=h;function b(_){if(_ instanceof se)return _.fileOperationResult;switch(h(_)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=b;var m;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(m=t.FileOperation||(t.FileOperation={}));class w{constructor(ne,ee,te){this.resource=ne,this.operation=ee,this.target=te}isOperation(ne){return this.operation===ne}}t.FileOperationEvent=w;var O;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(O=t.FileChangeType||(t.FileChangeType={}));class V{constructor(ne,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const T of ne){const x=te.get(T.type);switch(x?x.push([T.resource,T]):te.set(T.type,[[T.resource,T]]),T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}}for(const[T,x]of te)switch(T){case 1:this.a=E.TernarySearchTree.forUris(()=>ee),this.a.fill(x);break;case 0:this.b=E.TernarySearchTree.forUris(()=>ee),this.b.fill(x);break;case 2:this.c=E.TernarySearchTree.forUris(()=>ee),this.c.fill(x);break}}contains(ne,...ee){return this.d(ne,{includeChildren:!1},...ee)}affects(ne,...ee){return this.d(ne,{includeChildren:!0},...ee)}d(ne,ee,...te){if(!ne)return!1;const T=te.length>0;return!!((!T||te.includes(1))&&(this.a?.get(ne)||ee.includeChildren&&this.a?.findSuperstr(ne))||(!T||te.includes(0))&&(this.b?.get(ne)||ee.includeChildren&&this.b?.findSuperstr(ne))||(!T||te.includes(2))&&(this.c?.findSubstr(ne)||ee.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=V;function ie(_,ne,ee){return!_||!ne||_===ne||ne.length>_.length?!1:(ne.charAt(ne.length-1)!==R.sep&&(ne+=R.sep),ee?(0,i.startsWithIgnoreCase)(_,ne):_.indexOf(ne)===0)}t.isParent=ie;class se extends Error{constructor(ne,ee,te){super(ne),this.fileOperationResult=ee,this.options=te}}t.FileOperationError=se;class ae extends se{constructor(ne,ee,te,T){super(ne,ee,T),this.fileOperationResult=ee,this.size=te}}t.TooLargeFileOperationError=ae;class de extends se{constructor(ne,ee,te){super(ne,2,te),this.stat=ee}}t.NotModifiedSinceFileOperationError=de;var ue;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ue=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var Z;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function Q(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}t.etag=Q;async function ve(_,ne){if(!ne.hasProvider(v.URI.from({scheme:_.scheme})))return new Promise(ee=>{const te=ne.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===_.scheme&&T.added&&(te.dispose(),ee())})})}t.whenProviderRegistered=ve,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class pe{static formatSize(ne){return(0,W.isNumber)(ne)||(ne=0),ne<pe.KB?(0,D.localize)(1,null,ne.toFixed(0)):ne<pe.MB?(0,D.localize)(2,null,(ne/pe.KB).toFixed(2)):ne<pe.GB?(0,D.localize)(3,null,(ne/pe.MB).toFixed(2)):ne<pe.TB?(0,D.localize)(4,null,(ne/pe.GB).toFixed(2)):(0,D.localize)(5,null,(ne/pe.TB).toFixed(2))}}pe.KB=1024,pe.MB=pe.KB*pe.KB,pe.GB=pe.MB*pe.KB,pe.TB=pe.GB*pe.KB,t.ByteSize=pe;var Me;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(Me=t.Arch||(t.Arch={}));function Re(_){return{maxFileSize:_===0?300*pe.MB:16*pe.GB,maxHeapSize:_===0?700*pe.MB:2*700*pe.MB}}t.getPlatformFileLimits=Re;function le(_){const ne=typeof _=="string"||_?.scheme===c.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===c.Schemas.file?1024*pe.MB:ne?10*pe.MB:l.isWeb?50*pe.MB:1024*pe.MB}t.getLargeFileConfirmationLimit=le}),define(ge[136],me([1,0,37]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,E.createDecorator)("mainProcessService");class R{constructor(W,v){this.a=W,this.b=v}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,v){this.a.registerChannel(W,v)}}t.MainProcessService=R}),define(ge[137],me([1,0,2,131]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends E.Disposable{constructor(v){super(),this.a=this.D(new R.Client(`window:${v}`))}getChannel(v){return this.a.getChannel(v)}registerChannel(v,D){this.a.registerChannel(v,D)}}t.ElectronIPCMainProcessService=i});var hi=this&&this.__param||function(J,t){return function(E,R){t(E,R,J)}};define(ge[138],me([1,0,63,136]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=class{constructor(v,D){return this.windowId=v,E.ProxyChannel.toService(D.getChannel("nativeHost"),{context:v,properties:(()=>{const g=new Map;return g.set("windowId",v),g})()})}};i=Ve([hi(1,R.IMainProcessService)],i),t.NativeHostService=i}),define(ge[64],me([1,0,71,6]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.a=new Map}add(v,D){E.ok(R.isString(v)),E.ok(R.isObject(D)),E.ok(!this.a.has(v),"There is already an extension with this id"),this.a.set(v,D)}knows(v){return this.a.has(v)}as(v){return this.a.get(v)||null}}t.Registry=new i}),define(ge[139],me([1,0,3,64]),function(J,t,E,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class W{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[i(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const v=new W;R.Registry.add(t.Extensions.JSONContribution,v)}),define(ge[140],me([1,0,9,16,17,3,6,15,133,139,64]),function(J,t,E,R,i,W,v,D,g,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var P;(function(A){function S(d,p){let L=d.defaults;for(;i.ThemeIcon.isThemeIcon(L);){const I=e.getIcon(L.id);if(!I)return;L=I.defaults}return L}A.getDefinition=S})(P=t.IconContribution||(t.IconContribution={}));var r;(function(A){function S(p){return{weight:p.weight,style:p.style,src:p.src.map(L=>({format:L.format,location:L.location.toString()}))}}A.toJSONObject=S;function d(p){const L=I=>(0,v.isString)(I)?I:void 0;if(p&&Array.isArray(p.src)&&p.src.every(I=>(0,v.isString)(I.format)&&(0,v.isString)(I.location)))return{weight:L(p.weight),style:L(p.style),src:p.src.map(I=>({format:I.format,location:D.URI.parse(I.location)}))}}A.fromJSONObject=d})(r=t.IconFontDefinition||(t.IconFontDefinition={}));class u{constructor(){this.a=new W.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(S,d,p,L){const I=this.b[S];if(I){if(p&&!I.description){I.description=p,this.d.properties[S].markdownDescription=`${p} $(${S})`;const m=this.e.enum.indexOf(S);m!==-1&&(this.e.enumDescriptions[m]=p),this.a.fire()}return I}const h={id:S,description:p,defaults:d,deprecationMessage:L};this.b[S]=h;const b={$ref:"#/definitions/icons"};return L&&(b.deprecationMessage=L),p&&(b.markdownDescription=`${p}: $(${S})`),this.d.properties[S]=b,this.e.enum.push(S),this.e.enumDescriptions.push(p||""),this.a.fire(),{id:S}}deregisterIcon(S){delete this.b[S],delete this.d.properties[S];const d=this.e.enum.indexOf(S);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(S=>this.b[S])}getIcon(S){return this.b[S]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(S,d){const p=this.f[S];return p||(this.f[S]=d,this.a.fire(),d)}deregisterIconFont(S){delete this.f[S]}getIconFont(S){return this.f[S]}toString(){const S=(I,h)=>I.id.localeCompare(h.id),d=I=>{for(;i.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(I=>this.b[I]);for(const I of L.filter(h=>!!h.description).sort(S))p.push(`|<i class="${d(I)}"></i>|${I.id}|${i.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const I of L.filter(h=>!i.ThemeIcon.isThemeIcon(h.defaults)).sort(S))p.push(`|<i class="${d(I)}"></i>|${I.id}|`);return p.join(`
`)}}const e=new u;c.Registry.add(t.Extensions.IconContribution,e);function a(A,S,d,p){return e.registerIcon(A,S,d,p)}t.registerIcon=a;function n(){return e}t.getIconRegistry=n;function s(){const A=(0,R.getCodiconFontCharacters)();for(const S in A){const d="\\"+A[S].toString(16);e.registerIcon(S,{fontCharacter:d})}}s(),t.iconsSchemaId="vscode://schemas/icons";const o=c.Registry.as(l.Extensions.JSONContribution);o.registerSchema(t.iconsSchemaId,e.getIconSchema());const y=new E.RunOnceScheduler(()=>o.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{y.isScheduled()||y.schedule()}),t.widgetClose=a("widget-close",R.Codicon.close,(0,g.localize)(2,null)),t.gotoPreviousLocation=a("goto-previous-location",R.Codicon.arrowUp,(0,g.localize)(3,null)),t.gotoNextLocation=a("goto-next-location",R.Codicon.arrowDown,(0,g.localize)(4,null)),t.syncing=i.ThemeIcon.modify(R.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(ge[141],me([1,0,4,3,17,140]),function(J,t,E,R,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function v(g){const l=new R.Emitter,c=(0,W.getIconRegistry)();return c.onDidChange(()=>l.fire()),g?.onDidProductIconThemeChange(()=>l.fire()),{onDidChange:l.event,getCSS(){const P=g?g.getProductIconTheme():new D,r={},u=a=>{const n=P.getIcon(a);if(!n)return;const s=n.font;return s?(r[s.id]=s.definition,`.codicon-${a.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(s.id)}; }`):`.codicon-${a.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const a of c.getIcons()){const n=u(a);n&&e.push(n)}for(const a in r){const n=r[a],s=n.weight?`font-weight: ${n.weight};`:"",o=n.style?`font-style: ${n.style};`:"",y=n.src.map(A=>`${(0,E.asCSSUrl)(A.location)} format('${A.format}')`).join(", ");e.push(`@font-face { src: ${y}; font-family: ${(0,E.asCSSPropertyValue)(a)};${s}${o} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=v;class D{getIcon(l){const c=(0,W.getIconRegistry)();let P=l.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=c.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.UnthemedProductIconTheme=D}),define(ge[142],me([1,0,5]),function(J,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(c){return!!c.workspaceUri}t.isWorkspaceToOpen=R;function i(c){return!!c.folderUri}t.isFolderToOpen=i;function W(c){return!!c.fileUri}t.isFileToOpen=W;function v(c){const P=D(c),r=c.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||E.isMacintosh&&E.isNative?"classic":r}t.getMenuBarVisibility=v;function D(c){if(E.isWeb)return"custom";const P=c.getValue("window");if(P){if(E.isMacintosh&&P.nativeTabs===!0||E.isMacintosh&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=D;function g(c){if(!E.isWindows||E.isWeb||D(c)==="native")return!1;const P=c.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}t.useWindowControlsOverlay=g;function l(c=0){return Math.pow(1.2,c)}t.zoomLevelToZoomFactor=l}),define(ge[143],me([1,0,18,29,142]),function(J,t,E,R,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function W(g){R.webFrame.setZoomLevel(g),(0,E.setZoomFactor)((0,i.zoomLevelToZoomFactor)(g)),(0,E.setZoomLevel)(g,!1)}t.applyZoom=W;function v(){W((0,E.getZoomLevel)()+1)}t.zoomIn=v;function D(){W((0,E.getZoomLevel)()-1)}t.zoomOut=D}),define(ge[144],me([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(J,t,E,R,i,W,v,D,g,l,c,P,r,u,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class s{getHeight(O){return 22}getTemplateId(O){return I(O)?"process":p(O)?"machine":(0,g.isRemoteDiagnosticError)(O)?"error":L(O)?"header":""}}class o{hasChildren(O){return(0,g.isRemoteDiagnosticError)(O)?!1:I(O)?!!O.children?.length:!0}getChildren(O){return I(O)?O.children?O.children:[]:(0,g.isRemoteDiagnosticError)(O)?[]:L(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:p(O)?[O.rootProcess]:[O.processes]}}class y{constructor(){this.templateId="header"}renderTemplate(O){const V=(0,R.append)(O,(0,R.$)(".row")),ie=(0,R.append)(V,(0,R.$)(".nameLabel")),se=(0,R.append)(V,(0,R.$)(".cpu")),ae=(0,R.append)(V,(0,R.$)(".memory")),de=(0,R.append)(V,(0,R.$)(".pid"));return{name:ie,CPU:se,memory:ae,PID:de}}renderElement(O,V,ie,se){ie.name.textContent=(0,E.localize)(0,null),ie.CPU.textContent=(0,E.localize)(1,null),ie.PID.textContent=(0,E.localize)(2,null),ie.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(O){}}class A{constructor(){this.templateId="machine"}renderTemplate(O){const V=Object.create(null),ie=(0,R.append)(O,(0,R.$)(".row"));return V.name=(0,R.append)(ie,(0,R.$)(".nameLabel")),V}renderElement(O,V,ie,se){ie.name.textContent=O.element.name}disposeTemplate(O){}}class S{constructor(){this.templateId="error"}renderTemplate(O){const V=Object.create(null),ie=(0,R.append)(O,(0,R.$)(".row"));return V.name=(0,R.append)(ie,(0,R.$)(".nameLabel")),V}renderElement(O,V,ie,se){ie.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class d{constructor(O,V,ie){this.a=O,this.b=V,this.c=ie,this.templateId="process"}renderTemplate(O){const V=(0,R.append)(O,(0,R.$)(".row")),ie=(0,R.append)(V,(0,R.$)(".nameLabel")),se=(0,R.append)(V,(0,R.$)(".cpu")),ae=(0,R.append)(V,(0,R.$)(".memory")),de=(0,R.append)(V,(0,R.$)(".pid"));return{name:ie,CPU:se,PID:de,memory:ae}}renderElement(O,V,ie,se){const{element:ae}=O,de=ae.pid.toFixed(0);let ue=ae.name;this.c.has(ae.pid)&&(ue=this.c.get(ae.pid)),ie.name.textContent=ue,ie.name.title=ae.cmd,ie.CPU.textContent=ae.load.toFixed(0),ie.PID.textContent=de,ie.PID.parentElement.id=`pid-${de}`;const Z=this.a==="win32"?ae.mem:this.b*(ae.mem/100);ie.memory.textContent=(Z/l.ByteSize.MB).toFixed(0)}disposeTemplate(O){}}function p(w){return!!w.name&&!!w.rootProcess}function L(w){return!!w.processRoots}function I(w){return!!w.pid}class h{constructor(O,V){this.f=V,this.b=new Map;const ie=new c.ElectronIPCMainProcessService(O);this.c=new P.NativeHostService(O,ie),this.k(V.styles),this.g(V),D.ipcRenderer.on("vscode:pidToNameResponse",(se,ae)=>{this.b=new Map;for(const[de,ue]of ae)this.b.set(de,ue)}),D.ipcRenderer.on("vscode:listProcessesResponse",async(se,ae)=>{ae.forEach((de,ue)=>{I(de.rootProcess)&&(de.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ae}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ae),this.m(0)}),this.a=Date.now(),D.ipcRenderer.send("vscode:pidToNameRequest"),D.ipcRenderer.send("vscode:listProcesses")}g(O){document.onkeydown=V=>{const ie=O.platform==="darwin"?V.metaKey:V.ctrlKey;ie&&V.keyCode===87&&(V.stopPropagation(),V.preventDefault(),D.ipcRenderer.send("vscode:closeProcessExplorer")),ie&&V.keyCode===187&&(0,u.zoomIn)(),ie&&V.keyCode===189&&(0,u.zoomOut)()}}async h(O){const V=document.getElementById("process-list");if(!V)return;const{totalmem:ie}=await this.c.getOSStatistics(),se=[new d(this.f.platform,ie,this.b),new y,new A,new S];this.d=new i.DataTree("processExplorer",V,new s,se,new o,{identityProvider:{getId:ae=>I(ae)?ae.pid.toString():(0,g.isRemoteDiagnosticError)(ae)?ae.hostName:L(ae)?"processes":p(ae)?ae.name:"header"}}),this.d.setInput({processes:{processRoots:O}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ae=>{const de=new e.StandardKeyboardEvent(ae);if(de.keyCode===35&&de.altKey){const ue=this.n();Promise.all(ue.map(Z=>this.c.killProcess(Z,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ae=>{I(ae.element)&&this.l(ae.element,!0)}),V.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{V.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(O){const V=a.exec(O);return V&&V.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}j(O){const V={type:"node",request:"attach",name:`process ${O.pid}`};let ie=a.exec(O.cmd);ie?V.port=Number(ie.groups.port):V.processId=String(O.pid),ie=n.exec(O.cmd),ie&&(V.port=Number(ie.groups.port)),D.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[V]})}k(O){const V=(0,R.createStyleSheet)(),ie=[];O.listFocusBackground&&(ie.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),ie.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&ie.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(ie.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),ie.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&ie.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&ie.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&ie.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&ie.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&ie.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&ie.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&ie.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&ie.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&ie.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),V.textContent=ie.join(`
`),O.color&&(document.body.style.color=O.color)}l(O,V){const ie=[],se=Number(O.pid);V&&(ie.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.c.killProcess(se,"SIGTERM")}}),ie.push({label:(0,E.localize)(5,null),click:()=>{this.c.killProcess(se,"SIGKILL")}}),ie.push({type:"separator"})),ie.push({label:(0,E.localize)(6,null),click:()=>{const ae=this.n();ae?.includes(se)||(ae.length=0,ae.push(se));const de=ae?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(de){const ue=de.map(Z=>Z.innerText).filter(Z=>!!Z);this.c.writeClipboardText(ue.join(`
`))}}}),ie.push({label:(0,E.localize)(7,null),click:()=>{const ae=document.getElementById("process-list");ae&&this.c.writeClipboardText(ae.innerText)}}),O&&V&&this.i(O.cmd)&&(ie.push({type:"separator"}),ie.push({label:(0,E.localize)(8,null),click:()=>{this.j(O)}})),(0,v.popup)(ie)}m(O){setTimeout(()=>{const V=Date.now(),ie=O+V-this.a;this.a=V,ie>1e3?(D.ipcRenderer.send("vscode:pidToNameRequest"),D.ipcRenderer.send("vscode:listProcesses")):this.m(ie)},200)}n(){return this.d?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function b(){const w=(0,R.createStyleSheet)();w.id="codiconStyles";const O=(0,r.getIconsStyleSheet)(void 0);function V(){w.textContent=O.getCSS()}const ie=new W.RunOnceScheduler(V,0);O.onDidChange(()=>ie.schedule()),ie.schedule()}function m(w){const O=w.data.platform==="win32"?"windows":w.data.platform==="linux"?"linux":"mac";document.body.classList.add(O),b(),(0,u.applyZoom)(w.data.zoomLevel),new h(w.windowId,w.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
