/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ie=function(B){for(var e=[],L=0,T=B.length;L<T;L++)e[L]=te[B[L]];return e};define(te[50],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(N){return(I,d,c)=>{let P=null,E=null;if(typeof c.value=="function"?(P="value",E=c.value):typeof c.get=="function"&&(P="get",E=c.get),!E)throw new Error("not supported");c[P]=N(E,d)}}function T(N,I,d){let c=null,P=null;if(typeof d.value=="function"?(c="value",P=d.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",P=d.get),!P)throw new Error("not supported");const E=`$memoize$${I}`;d[c]=function(...y){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,y)}),this[E]}}e.memoize=T;function k(N,I,d){return L((c,P)=>{const E=`$debounce$${P}`,y=`$debounce$result$${P}`;return function(...v){this[y]||(this[y]=d?d():void 0),clearTimeout(this[E]),I&&(this[y]=I(this[y],...v),v=[this[y]]),this[E]=setTimeout(()=>{c.apply(this,v),this[y]=d?d():void 0},N)}})}e.debounce=k;function A(N,I,d){return L((c,P)=>{const E=`$throttle$timer$${P}`,y=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,O=`$throttle$pending$${P}`;return function(...R){if(this[y]||(this[y]=d?d():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[y]=I(this[y],...R)),this[O])return;const u=this[v]+N;u<=Date.now()?(this[v]=Date.now(),c.apply(this,[this[y]]),this[y]=d?d():void 0):(this[O]=!0,this[E]=setTimeout(()=>{this[O]=!1,this[v]=Date.now(),c.apply(this,[this[y]]),this[y]=d?d():void 0},u-Date.now()))}})}e.throttle=A}),define(te[70],ie([0,1,9]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function T(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=T;function k(d,c="Unreachable"){throw new Error(c)}e.assertNever=k;function A(d){if(!d)throw new L.BugIndicatingError("Assertion Failed")}e.assert=A;function N(d){if(!d()){debugger;d(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function I(d,c){let P=0;for(;P<d.length-1;){const E=d[P],y=d[P+1];if(!c(E,y))return!1;P++}return!0}e.checkAdjacentItems=I}),define(te[51],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function N(t,a=!1){let n=0;const i=t.length;let r="",o=0,l=16,g=0;function S(re){let ce=0,fe=0;for(;ce<re;){const ae=t.charCodeAt(n);if(ae>=48&&ae<=57)fe=fe*16+ae-48;else if(ae>=65&&ae<=70)fe=fe*16+ae-65+10;else if(ae>=97&&ae<=102)fe=fe*16+ae-97+10;else break;n++,ce++}return ce<re&&(fe=-1),fe}function D(re){n=re,r="",o=0,l=16,g=0}function F(){const re=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return g=3,t.substring(re,n);let ce=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;ce=n}else g=3;return t.substring(re,ce)}function K(){let re="",ce=n;for(;;){if(n>=i){re+=t.substring(ce,n),g=2;break}const fe=t.charCodeAt(n);if(fe===34){re+=t.substring(ce,n),n++;break}if(fe===92){if(re+=t.substring(ce,n),n++,n>=i){g=2;break}switch(t.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const x=S(4);x>=0?re+=String.fromCharCode(x):g=4;break}default:g=5}ce=n;continue}if(fe>=0&&fe<=31)if(d(fe)){re+=t.substring(ce,n),g=2;break}else g=6;n++}return re}function Z(){if(r="",g=0,o=n,n>=i)return o=i,l=17;let re=t.charCodeAt(n);if(I(re)){do n++,r+=String.fromCharCode(re),re=t.charCodeAt(n);while(I(re));return l=15}if(d(re))return n++,r+=String.fromCharCode(re),re===13&&t.charCodeAt(n)===10&&(n++,r+=`
`),l=14;switch(re){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,r=K(),l=10;case 47:{const ce=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!d(t.charCodeAt(n));)n++;return r=t.substring(ce,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const fe=i-1;let ae=!1;for(;n<fe;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,ae=!0;break}n++}return ae||(n++,g=1),r=t.substring(ce,n),l=13}return r+=String.fromCharCode(re),n++,l=16}case 45:if(r+=String.fromCharCode(re),n++,n===i||!c(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),l=11;default:for(;n<i&&_(re);)n++,re=t.charCodeAt(n);if(o!==n){switch(r=t.substring(o,n),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(re),n++,l=16}}function _(re){if(I(re)||d(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let re;do re=Z();while(re>=12&&re<=15);return re}return{setPosition:D,getPosition:()=>n,scan:a?se:Z,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>g}}e.createScanner=N;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function E(t,a){const n=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(S,D,F,K){o.value=S,o.offset=D,o.length=F,o.type=K,o.colonOffset=void 0,r=o}try{w(t,{onObjectBegin:(S,D)=>{if(a<=S)throw i;r=void 0,l=a>S,n.push("")},onObjectProperty:(S,D,F)=>{if(a<D||(g(S,D,F,"property"),n[n.length-1]=S,a<=D+F))throw i},onObjectEnd:(S,D)=>{if(a<=S)throw i;r=void 0,n.pop()},onArrayBegin:(S,D)=>{if(a<=S)throw i;r=void 0,n.push(0)},onArrayEnd:(S,D)=>{if(a<=S)throw i;r=void 0,n.pop()},onLiteralValue:(S,D,F)=>{if(a<D||(g(S,D,F,b(S)),a<=D+F))throw i},onSeparator:(S,D,F)=>{if(a<=D)throw i;if(S===":"&&r&&r.type==="property")r.colonOffset=D,l=!1,r=void 0;else if(S===","){const K=n[n.length-1];typeof K=="number"?n[n.length-1]=K+1:(l=!0,n[n.length-1]=""),r=void 0}}})}catch(S){if(S!==i)throw S}return{path:n,previousNode:r,isAtPropertyKey:l,matches:S=>{let D=0;for(let F=0;D<S.length&&F<n.length;F++)if(S[D]===n[F]||S[D]==="*")D++;else if(S[D]!=="**")return!1;return D===S.length}}}e.getLocation=E;function y(t,a=[],n=A.DEFAULT){let i=null,r=[];const o=[];function l(S){Array.isArray(r)?r.push(S):i!==null&&(r[i]=S)}return w(t,{onObjectBegin:()=>{const S={};l(S),o.push(r),r=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const S=[];l(S),o.push(r),r=S,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:l,onError:(S,D,F)=>{a.push({error:S,offset:D,length:F})}},n),r[0]}e.parse=y;function v(t,a=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function o(S){return i.children.push(S),S}w(t,{onObjectBegin:S=>{i=o({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,D,F)=>{i=o({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:D,length:F,parent:i})},onObjectEnd:(S,D)=>{i.length=S+D-i.offset,i=i.parent,r(S+D)},onArrayBegin:(S,D)=>{i=o({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,D)=>{i.length=S+D-i.offset,i=i.parent,r(S+D)},onLiteralValue:(S,D,F)=>{o({type:b(S),offset:D,length:F,parent:i,value:S}),r(D+F)},onSeparator:(S,D,F)=>{i.type==="property"&&(S===":"?i.colonOffset=D:S===","&&r(D))},onError:(S,D,F)=>{a.push({error:S,offset:D,length:F})}},n);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=v;function O(t,a){if(!t)return;let n=t;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===i){n=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=O;function R(t){if(!t.parent||!t.parent.children)return[];const a=R(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;a.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&a.push(n)}return a}e.getNodePath=R;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const a=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(a[n.children[0].value]=u(i))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function f(t,a,n=!1){return a>=t.offset&&a<t.offset+t.length||n&&a===t.offset+t.length}e.contains=f;function p(t,a,n=!1){if(f(t,a,n)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=a;r++){const o=p(i[r],a,n);if(o)return o}return t}}e.findNodeAtOffset=p;function w(t,a,n=A.DEFAULT){const i=N(t,!1);function r(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(X){return X?Y=>X(Y,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(a.onObjectBegin),g=o(a.onObjectProperty),S=r(a.onObjectEnd),D=r(a.onArrayBegin),F=r(a.onArrayEnd),K=o(a.onLiteralValue),Z=o(a.onSeparator),_=r(a.onComment),se=o(a.onError),re=n&&n.disallowComments,ce=n&&n.allowTrailingComma;function fe(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(X){case 12:case 13:re?ae(10):_();break;case 16:ae(1);break;case 15:case 14:break;default:return X}}}function ae(X,Y=[],C=[]){if(se(X),Y.length+C.length>0){let s=i.getToken();for(;s!==17;){if(Y.indexOf(s)!==-1){fe();break}else if(C.indexOf(s)!==-1)break;s=fe()}}}function x(X){const Y=i.getTokenValue();return X?K(Y):g(Y),fe(),!0}function W(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(ae(2),X=0)}catch{ae(2)}K(X);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return fe(),!0}function z(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(Z(":"),fe(),H()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function U(){l(),fe();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||ae(4,[],[]),Z(","),fe(),i.getToken()===2&&ce)break}else X&&ae(6,[],[]);z()||ae(4,[],[2,5]),X=!0}return S(),i.getToken()!==2?ae(7,[2],[]):fe(),!0}function $(){D(),fe();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||ae(4,[],[]),Z(","),fe(),i.getToken()===4&&ce)break}else X&&ae(6,[],[]);H()||ae(4,[],[4,5]),X=!0}return F(),i.getToken()!==4?ae(8,[4],[]):fe(),!0}function H(){switch(i.getToken()){case 3:return $();case 1:return U();case 10:return x(!0);default:return W()}}return fe(),i.getToken()===17?n.allowEmptyContent?!0:(ae(4,[],[]),!1):H()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=w;function m(t,a){const n=N(t),i=[];let r,o=0,l;do switch(l=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:o!==l&&i.push(t.substring(o,l)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=m;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(te[71],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(I,d,c){return Math.min(Math.max(I,d),c)}e.clamp=L;function T(I,d){return(d+I%d)%d}e.rot=T;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class A{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class N{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const c=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function B(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function N(d){A.push(d,Date.now())}function I(){const d=[];for(let c=0;c<A.length;c+=2)d.push({name:A[c],startTime:A[c+1]});return d}return{mark:N,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(k+N.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function L(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=L(T))}(),function(B,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var T in L)(typeof exports=="object"?exports:B)[T]=L[T]}}(typeof self<"u"?self:this,function(){return function(B){var e={};function L(T){if(e[T])return e[T].exports;var k=e[T]={i:T,l:!1,exports:{}};return B[T].call(k.exports,k,k.exports,L),k.l=!0,k.exports}return L.m=B,L.c=e,L.d=function(T,k,A){L.o(T,k)||Object.defineProperty(T,k,{enumerable:!0,get:A})},L.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},L.t=function(T,k){if(1&k&&(T=L(T)),8&k||4&k&&typeof T=="object"&&T&&T.__esModule)return T;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:T}),2&k&&typeof T!="string")for(var N in T)L.d(A,N,function(I){return T[I]}.bind(null,N));return A},L.n=function(T){var k=T&&T.__esModule?function(){return T.default}:function(){return T};return L.d(k,"a",k),k},L.o=function(T,k){return Object.prototype.hasOwnProperty.call(T,k)},L.p="",L(L.s=0)}([function(B,e,L){(function(T){var k;e=B.exports=C,k=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],d=e.src=[],c=0,P=c++;d[P]="0|[1-9]\\d*";var E=c++;d[E]="[0-9]+";var y=c++;d[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=c++;d[v]="("+d[P]+")\\.("+d[P]+")\\.("+d[P]+")";var O=c++;d[O]="("+d[E]+")\\.("+d[E]+")\\.("+d[E]+")";var R=c++;d[R]="(?:"+d[P]+"|"+d[y]+")";var u=c++;d[u]="(?:"+d[E]+"|"+d[y]+")";var f=c++;d[f]="(?:-("+d[R]+"(?:\\."+d[R]+")*))";var p=c++;d[p]="(?:-?("+d[u]+"(?:\\."+d[u]+")*))";var w=c++;d[w]="[0-9A-Za-z-]+";var m=c++;d[m]="(?:\\+("+d[w]+"(?:\\."+d[w]+")*))";var b=c++,t="v?"+d[v]+d[f]+"?"+d[m]+"?";d[b]="^"+t+"$";var a="[v=\\s]*"+d[O]+d[p]+"?"+d[m]+"?",n=c++;d[n]="^"+a+"$";var i=c++;d[i]="((?:<|>)?=?)";var r=c++;d[r]=d[E]+"|x|X|\\*";var o=c++;d[o]=d[P]+"|x|X|\\*";var l=c++;d[l]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[f]+")?"+d[m]+"?)?)?";var g=c++;d[g]="[v=\\s]*("+d[r]+")(?:\\.("+d[r]+")(?:\\.("+d[r]+")(?:"+d[p]+")?"+d[m]+"?)?)?";var S=c++;d[S]="^"+d[i]+"\\s*"+d[l]+"$";var D=c++;d[D]="^"+d[i]+"\\s*"+d[g]+"$";var F=c++;d[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=c++;d[K]="(?:~>?)";var Z=c++;d[Z]="(\\s*)"+d[K]+"\\s+",I[Z]=new RegExp(d[Z],"g");var _=c++;d[_]="^"+d[K]+d[l]+"$";var se=c++;d[se]="^"+d[K]+d[g]+"$";var re=c++;d[re]="(?:\\^)";var ce=c++;d[ce]="(\\s*)"+d[re]+"\\s+",I[ce]=new RegExp(d[ce],"g");var fe=c++;d[fe]="^"+d[re]+d[l]+"$";var ae=c++;d[ae]="^"+d[re]+d[g]+"$";var x=c++;d[x]="^"+d[i]+"\\s*("+a+")$|^$";var W=c++;d[W]="^"+d[i]+"\\s*("+t+")$|^$";var z=c++;d[z]="(\\s*)"+d[i]+"\\s*("+a+"|"+d[l]+")",I[z]=new RegExp(d[z],"g");var U=c++;d[U]="^\\s*("+d[l]+")\\s+-\\s+("+d[l]+")\\s*$";var $=c++;d[$]="^\\s*("+d[g]+")\\s+-\\s+("+d[g]+")\\s*$";var H=c++;d[H]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)k(X,d[X]),I[X]||(I[X]=new RegExp(d[X]));function Y(V,J){if(V instanceof C)return V;if(typeof V!="string"||V.length>A||!(J?I[n]:I[b]).test(V))return null;try{return new C(V,J)}catch{return null}}function C(V,J){if(V instanceof C){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof C))return new C(V,J);k("SemVer",V,J),this.loose=J;var Q=V.trim().match(J?I[n]:I[b]);if(!Q)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var Ee=+de;if(Ee>=0&&Ee<N)return Ee}return de}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=Y,e.valid=function(V,J){var Q=Y(V,J);return Q?Q.version:null},e.clean=function(V,J){var Q=Y(V.trim().replace(/^[=v]+/,""),J);return Q?Q.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(V){return k("SemVer.compare",this.version,this.loose,V),V instanceof C||(V=new C(V,this.loose)),this.compareMain(V)||this.comparePre(V)},C.prototype.compareMain=function(V){return V instanceof C||(V=new C(V,this.loose)),h(this.major,V.major)||h(this.minor,V.minor)||h(this.patch,V.patch)},C.prototype.comparePre=function(V){if(V instanceof C||(V=new C(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var Q=this.prerelease[J],de=V.prerelease[J];if(k("prerelease compare",J,Q,de),Q===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Q===void 0)return-1;if(Q!==de)return h(Q,de)}while(++J)},C.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,Q,de){typeof Q=="string"&&(de=Q,Q=void 0);try{return new C(V,Q).inc(J,de).version}catch{return null}},e.diff=function(V,J){if(q(V,J))return null;var Q=Y(V),de=Y(J);if(Q.prerelease.length||de.prerelease.length){for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==de[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==de[Ee])return Ee},e.compareIdentifiers=h;var s=/^[0-9]+$/;function h(V,J){var Q=s.test(V),de=s.test(J);return Q&&de&&(V=+V,J=+J),Q&&!de?-1:de&&!Q?1:V<J?-1:V>J?1:0}function M(V,J,Q){return new C(V,Q).compare(new C(J,Q))}function j(V,J,Q){return M(V,J,Q)>0}function G(V,J,Q){return M(V,J,Q)<0}function q(V,J,Q){return M(V,J,Q)===0}function ne(V,J,Q){return M(V,J,Q)!==0}function oe(V,J,Q){return M(V,J,Q)>=0}function pe(V,J,Q){return M(V,J,Q)<=0}function me(V,J,Q,de){var Ee;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),Ee=V===Q;break;case"!==":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),Ee=V!==Q;break;case"":case"=":case"==":Ee=q(V,Q,de);break;case"!=":Ee=ne(V,Q,de);break;case">":Ee=j(V,Q,de);break;case">=":Ee=oe(V,Q,de);break;case"<":Ee=G(V,Q,de);break;case"<=":Ee=pe(V,Q,de);break;default:throw new TypeError("Invalid operator: "+J)}return Ee}function ue(V,J){if(V instanceof ue){if(V.loose===J)return V;V=V.value}if(!(this instanceof ue))return new ue(V,J);k("comparator",V,J),this.loose=J,this.parse(V),this.semver===he?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(V,J){return h(J,V)},e.major=function(V,J){return new C(V,J).major},e.minor=function(V,J){return new C(V,J).minor},e.patch=function(V,J){return new C(V,J).patch},e.compare=M,e.compareLoose=function(V,J){return M(V,J,!0)},e.rcompare=function(V,J,Q){return M(J,V,Q)},e.sort=function(V,J){return V.sort(function(Q,de){return e.compare(Q,de,J)})},e.rsort=function(V,J){return V.sort(function(Q,de){return e.rcompare(Q,de,J)})},e.gt=j,e.lt=G,e.eq=q,e.neq=ne,e.gte=oe,e.lte=pe,e.cmp=me,e.Comparator=ue;var he={};function ye(V,J){if(V instanceof ye)return V.loose===J?V:new ye(V.raw,J);if(V instanceof ue)return new ye(V.value,J);if(!(this instanceof ye))return new ye(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function le(V){return!V||V.toLowerCase()==="x"||V==="*"}function ve(V,J,Q,de,Ee,Oe,Ie,Ae,Re,Ne,Fe,De,Te){return((J=le(Q)?"":le(de)?">="+Q+".0.0":le(Ee)?">="+Q+"."+de+".0":">="+J)+" "+(Ae=le(Re)?"":le(Ne)?"<"+(+Re+1)+".0.0":le(Fe)?"<"+Re+"."+(+Ne+1)+".0":De?"<="+Re+"."+Ne+"."+Fe+"-"+De:"<="+Ae)).trim()}function Se(V,J){for(var Q=0;Q<V.length;Q++)if(!V[Q].test(J))return!1;if(J.prerelease.length){for(Q=0;Q<V.length;Q++)if(k(V[Q].semver),V[Q].semver!==he&&V[Q].semver.prerelease.length>0){var de=V[Q].semver;if(de.major===J.major&&de.minor===J.minor&&de.patch===J.patch)return!0}return!1}return!0}function Le(V,J,Q){try{J=new ye(J,Q)}catch{return!1}return J.test(V)}function Ue(V,J,Q,de){var Ee,Oe,Ie,Ae,Re;switch(V=new C(V,de),J=new ye(J,de),Q){case">":Ee=j,Oe=pe,Ie=G,Ae=">",Re=">=";break;case"<":Ee=G,Oe=oe,Ie=j,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(V,J,de))return!1;for(var Ne=0;Ne<J.set.length;++Ne){var Fe=J.set[Ne],De=null,Te=null;if(Fe.forEach(function(Ce){Ce.semver===he&&(Ce=new ue(">=0.0.0")),De=De||Ce,Te=Te||Ce,Ee(Ce.semver,De.semver,de)?De=Ce:Ie(Ce.semver,Te.semver,de)&&(Te=Ce)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Oe(V,Te.semver)||Te.operator===Re&&Ie(V,Te.semver))return!1}return!0}ue.prototype.parse=function(V){var J=this.loose?I[x]:I[W],Q=V.match(J);if(!Q)throw new TypeError("Invalid comparator: "+V);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new C(Q[2],this.loose):this.semver=he},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(V){return k("Comparator.test",V,this.loose),this.semver===he||(typeof V=="string"&&(V=new C(V,this.loose)),me(V,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(V,J){if(!(V instanceof ue))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new ye(V.value,J),Le(this.value,Q,J);if(V.operator==="")return Q=new ye(this.value,J),Le(V.semver,Q,J);var de=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Oe=this.semver.version===V.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ae=me(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Re=me(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return de||Ee||Oe&&Ie||Ae||Re},e.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),k("range",V,J);var Q=J?I[$]:I[U];V=V.replace(Q,ve),k("hyphen replace",V),V=V.replace(I[z],"$1$2$3"),k("comparator trim",V,I[z]),V=(V=(V=V.replace(I[Z],"$1~")).replace(I[ce],"$1^")).split(/\s+/).join(" ");var de=J?I[x]:I[W],Ee=V.split(" ").map(function(Oe){return function(Ie,Ae){return k("comp",Ie),Ie=function(Re,Ne){return Re.trim().split(/\s+/).map(function(Fe){return function(De,Te){k("caret",De,Te);var Ce=Te?I[ae]:I[fe];return De.replace(Ce,function(je,we,be,Pe,ke){var Me;return k("caret",De,je,we,be,Pe,ke),le(we)?Me="":le(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":le(Pe)?Me=we==="0"?">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":">="+we+"."+be+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+ke+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+" <"+(+we+1)+".0.0"),k("caret return",Me),Me})}(Fe,Ne)}).join(" ")}(Ie,Ae),k("caret",Ie),Ie=function(Re,Ne){return Re.trim().split(/\s+/).map(function(Fe){return function(De,Te){var Ce=Te?I[se]:I[_];return De.replace(Ce,function(je,we,be,Pe,ke){var Me;return k("tilde",De,je,we,be,Pe,ke),le(we)?Me="":le(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":le(Pe)?Me=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0"):Me=">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0",k("tilde return",Me),Me})}(Fe,Ne)}).join(" ")}(Ie,Ae),k("tildes",Ie),Ie=function(Re,Ne){return k("replaceXRanges",Re,Ne),Re.split(/\s+/).map(function(Fe){return function(De,Te){De=De.trim();var Ce=Te?I[D]:I[S];return De.replace(Ce,function(je,we,be,Pe,ke,Me){k("xRange",De,je,we,be,Pe,ke,Me);var We=le(be),Ve=We||le(Pe),xe=Ve||le(ke);return we==="="&&xe&&(we=""),We?je=we===">"||we==="<"?"<0.0.0":"*":we&&xe?(Ve&&(Pe=0),xe&&(ke=0),we===">"?(we=">=",Ve?(be=+be+1,Pe=0,ke=0):xe&&(Pe=+Pe+1,ke=0)):we==="<="&&(we="<",Ve?be=+be+1:Pe=+Pe+1),je=we+be+"."+Pe+"."+ke):Ve?je=">="+be+".0.0 <"+(+be+1)+".0.0":xe&&(je=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0"),k("xRange return",je),je})}(Fe,Ne)}).join(" ")}(Ie,Ae),k("xrange",Ie),Ie=function(Re,Ne){return k("replaceStars",Re,Ne),Re.trim().replace(I[H],"")}(Ie,Ae),k("stars",Ie),Ie}(Oe,J)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Oe){return!!Oe.match(de)})),Ee=Ee.map(function(Oe){return new ue(Oe,J)})},ye.prototype.intersects=function(V,J){if(!(V instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(de){return V.set.some(function(Ee){return Ee.every(function(Oe){return de.intersects(Oe,J)})})})})},e.toComparators=function(V,J){return new ye(V,J).set.map(function(Q){return Q.map(function(de){return de.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new C(V,this.loose));for(var J=0;J<this.set.length;J++)if(Se(this.set[J],V))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(V,J,Q){var de=null,Ee=null;try{var Oe=new ye(J,Q)}catch{return null}return V.forEach(function(Ie){Oe.test(Ie)&&(de&&Ee.compare(Ie)!==-1||(Ee=new C(de=Ie,Q)))}),de},e.minSatisfying=function(V,J,Q){var de=null,Ee=null;try{var Oe=new ye(J,Q)}catch{return null}return V.forEach(function(Ie){Oe.test(Ie)&&(de&&Ee.compare(Ie)!==1||(Ee=new C(de=Ie,Q)))}),de},e.validRange=function(V,J){try{return new ye(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,Q){return Ue(V,J,"<",Q)},e.gtr=function(V,J,Q){return Ue(V,J,">",Q)},e.outside=Ue,e.prerelease=function(V,J){var Q=Y(V,J);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(V,J,Q){return V=new ye(V,Q),J=new ye(J,Q),V.intersects(J)},e.coerce=function(V){if(V instanceof C)return V;if(typeof V!="string")return null;var J=V.match(I[F]);return J==null?null:Y((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,L(1))},function(B,e){var L,T,k=B.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function I(u){if(L===setTimeout)return setTimeout(u,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(u,0);try{return L(u,0)}catch{try{return L.call(null,u,0)}catch{return L.call(this,u,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{T=typeof clearTimeout=="function"?clearTimeout:N}catch{T=N}})();var d,c=[],P=!1,E=-1;function y(){P&&d&&(P=!1,d.length?c=d.concat(c):E=-1,c.length&&v())}function v(){if(!P){var u=I(y);P=!0;for(var f=c.length;f;){for(d=c,c=[];++E<f;)d&&d[E].run();E=-1,f=c.length}d=null,P=!1,function(p){if(T===clearTimeout)return clearTimeout(p);if((T===N||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(p);try{T(p)}catch{try{return T.call(null,p)}catch{return T.call(this,p)}}}(u)}}function O(u,f){this.fun=u,this.array=f}function R(){}k.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];c.push(new O(u,f)),c.length!==1||P||I(v)},O.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=R,k.addListener=R,k.once=R,k.off=R,k.removeListener=R,k.removeAllListeners=R,k.emit=R,k.prependListener=R,k.prependOnceListener=R,k.listeners=function(u){return[]},k.binding=function(u){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(u){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[72],ie([0,1]),function(B,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(I,d,c){this.level=I,this.key=d,this.value=c,this.forward=[]}}const k=void 0;class A{constructor(I,d=2**16){this.comparator=I,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new T(this.c,k,k)}get size(){return this.f}clear(){this.e=new T(this.c,k,k)}has(I){return Boolean(A.g(this,I,this.comparator))}get(I){return A.g(this,I,this.comparator)?.value}set(I,d){return A.h(this,I,d,this.comparator)&&(this.f+=1),this}delete(I){const d=A.k(this,I,this.comparator);return d&&(this.f-=1),d}forEach(I,d){let c=this.e.forward[0];for(;c;)I.call(d,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",d=this.e.forward[0];for(;d;)I+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return I}static g(I,d,c){let P=I.e;for(let E=I.d-1;E>=0;E--)for(;P.forward[E]&&c(P.forward[E].key,d)<0;)P=P.forward[E];if(P=P.forward[0],P&&c(P.key,d)===0)return P}static h(I,d,c,P){const E=[];let y=I.e;for(let v=I.d-1;v>=0;v--){for(;y.forward[v]&&P(y.forward[v].key,d)<0;)y=y.forward[v];E[v]=y}if(y=y.forward[0],y&&P(y.key,d)===0)return y.value=c,!1;{const v=A.j(I);if(v>I.d){for(let O=I.d;O<v;O++)E[O]=I.e;I.d=v}y=new T(v,d,c);for(let O=0;O<v;O++)y.forward[O]=E[O].forward[O],E[O].forward[O]=y;return!0}}static j(I,d=.5){let c=1;for(;Math.random()<d&&c<I.c;)c+=1;return c}static k(I,d,c){const P=[];let E=I.e;for(let y=I.d-1;y>=0;y--){for(;E.forward[y]&&c(E.forward[y].key,d)<0;)E=E.forward[y];P[y]=E}if(E=E.forward[0],!E||c(E.key,d)!==0)return!1;for(let y=0;y<I.d&&P[y].forward[y]===E;y++)P[y].forward[y]=E.forward[y];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.SkipList=A}),define(te[44],ie([0,1,9,2]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(m){const b=m;return b?typeof b.read=="function":!1}e.isReadable=k;function A(m){const b=m;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function N(m){const b=m;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=N;function I(m,b){return new d(m,b)}e.newWriteableStream=I;class d{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,L.onUnexpectedError)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(t);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(m,b){const t=[];let a;for(;(a=m.read())!==null;)t.push(a);return b(t)}e.consumeReadable=c;function P(m,b,t){const a=[];let n;for(;(n=m.read())!==null&&a.length<t;)a.push(n);return n===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.peekReadable=P;function E(m,b){return new Promise((t,a)=>{const n=[];y(m,{onData:i=>{b&&n.push(i)},onError:i=>{b?a(i):t(void 0)},onEnd:()=>{t(b?b(n):void 0)}})})}e.consumeStream=E;function y(m,b){let t=!1;return m.on("error",a=>{t||b.onError(a)}),m.on("end",()=>{t||b.onEnd()}),m.on("data",a=>{t||b.onData(a)}),(0,T.toDisposable)(()=>t=!0)}e.listenStream=y;function v(m,b){return new Promise((t,a)=>{const n=new T.DisposableStore,i=[],r=g=>{if(i.push(g),i.length>b)return n.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},o=g=>a(g),l=()=>t({stream:m,buffer:i,ended:!0});n.add((0,T.toDisposable)(()=>m.removeListener("error",o))),m.on("error",o),n.add((0,T.toDisposable)(()=>m.removeListener("end",l))),m.on("end",l),n.add((0,T.toDisposable)(()=>m.removeListener("data",r))),m.on("data",r)})}e.peekStream=v;function O(m,b){const t=I(b);return t.end(m),t}e.toStream=O;function R(){const m=I(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=R;function u(m){let b=!1;return{read:()=>b?null:(b=!0,m)}}e.toReadable=u;function f(m,b,t){const a=I(t);return y(m,{onData:n=>a.write(b.data(n)),onError:n=>a.error(b.error?b.error(n):n),onEnd:()=>a.end()}),a}e.transform=f;function p(m,b,t){let a=!1;return{read:()=>{const n=b.read();return a?n:(a=!0,n!==null?t([m,n]):m)}}}e.prefixedReadable=p;function w(m,b,t){let a=!1;const n=I(t);return y(b,{onData:i=>a?n.write(i):(a=!0,n.write(t([m,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(m)),n.end()}}),n}e.prefixedStream=w}),define(te[14],ie([0,1,44]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let k,A;class N{static alloc(g){return T?new N(Buffer.allocUnsafe(g)):new N(new Uint8Array(g))}static wrap(g){return T&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new N(g)}static fromString(g,S){return!(S?.dontUseNodeBuffer||!1)&&T?new N(Buffer.from(g)):(k||(k=new TextEncoder),new N(k.encode(g)))}static fromByteArray(g){const S=N.alloc(g.length);for(let D=0,F=g.length;D<F;D++)S.buffer[D]=g[D];return S}static concat(g,S){if(typeof S>"u"){S=0;for(let K=0,Z=g.length;K<Z;K++)S+=g[K].byteLength}const D=N.alloc(S);let F=0;for(let K=0,Z=g.length;K<Z;K++){const _=g[K];D.set(_,F),F+=_.byteLength}return D}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=N.alloc(this.byteLength);return g.set(this),g}toString(){return T?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(g,S){return new N(this.buffer.subarray(g,S))}set(g,S){if(g instanceof N)this.buffer.set(g.buffer,S);else if(g instanceof Uint8Array)this.buffer.set(g,S);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),S);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return c(this.buffer,g)}writeUInt32BE(g,S){P(this.buffer,g,S)}readUInt32LE(g){return E(this.buffer,g)}writeUInt32LE(g,S){y(this.buffer,g,S)}readUInt8(g){return v(this.buffer,g)}writeUInt8(g,S){O(this.buffer,g,S)}}e.VSBuffer=N;function I(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0}e.readUInt16LE=I;function d(l,g,S){l[S+0]=g&255,g=g>>>8,l[S+1]=g&255}e.writeUInt16LE=d;function c(l,g){return l[g]*2**24+l[g+1]*2**16+l[g+2]*2**8+l[g+3]}e.readUInt32BE=c;function P(l,g,S){l[S+3]=g,g=g>>>8,l[S+2]=g,g=g>>>8,l[S+1]=g,g=g>>>8,l[S]=g}e.writeUInt32BE=P;function E(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0|l[g+2]<<16>>>0|l[g+3]<<24>>>0}e.readUInt32LE=E;function y(l,g,S){l[S+0]=g&255,g=g>>>8,l[S+1]=g&255,g=g>>>8,l[S+2]=g&255,g=g>>>8,l[S+3]=g&255}e.writeUInt32LE=y;function v(l,g){return l[g]}e.readUInt8=v;function O(l,g,S){l[S]=g}e.writeUInt8=O;function R(l){return L.consumeReadable(l,g=>N.concat(g))}e.readableToBuffer=R;function u(l){return L.toReadable(l)}e.bufferToReadable=u;function f(l){return L.consumeStream(l,g=>N.concat(g))}e.streamToBuffer=f;async function p(l){return l.ended?N.concat(l.buffer):N.concat([...l.buffer,await f(l.stream)])}e.bufferedStreamToBuffer=p;function w(l){return L.toStream(l,g=>N.concat(g))}e.bufferToStream=w;function m(l){return L.transform(l,{data:g=>typeof g=="string"?N.fromString(g):N.wrap(g)},g=>N.concat(g))}e.streamToBufferReadableStream=m;function b(l){return L.newWriteableStream(g=>N.concat(g),l)}e.newWriteableBufferStream=b;function t(l,g){return L.prefixedReadable(l,g,S=>N.concat(S))}e.prefixedBufferReadable=t;function a(l,g){return L.prefixedStream(l,g,S=>N.concat(S))}e.prefixedBufferStream=a;function n(l){let g=0,S=0,D=0;const F=new Uint8Array(Math.floor(l.length/4*3)),K=_=>{switch(S){case 3:F[D++]=g|_,S=0;break;case 2:F[D++]=g|_>>>2,g=_<<6,S=3;break;case 1:F[D++]=g|_>>>4,g=_<<4,S=2;break;default:g=_<<2,S=1}};for(let _=0;_<l.length;_++){const se=l.charCodeAt(_);if(se>=65&&se<=90)K(se-65);else if(se>=97&&se<=122)K(se-97+26);else if(se>=48&&se<=57)K(se-48+52);else if(se===43||se===45)K(62);else if(se===47||se===95)K(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${l[_]}`)}}const Z=D;for(;S>0;)K(0);return N.wrap(F).slice(0,Z)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},g=!0,S=!1){const D=S?r:i;let F="";const K=l.byteLength%3;let Z=0;for(;Z<l.byteLength-K;Z+=3){const _=l[Z+0],se=l[Z+1],re=l[Z+2];F+=D[_>>>2],F+=D[(_<<4|se>>>4)&63],F+=D[(se<<2|re>>>6)&63],F+=D[re&63]}if(K===1){const _=l[Z+0];F+=D[_>>>2],F+=D[_<<4&63],g&&(F+="==")}else if(K===2){const _=l[Z+0],se=l[Z+1];F+=D[_>>>2],F+=D[(_<<4|se>>>4)&63],F+=D[se<<2&63],g&&(F+="=")}return F}e.encodeBase64=o}),define(te[30],ie([0,1,3]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([w,m])=>{p[w]=m&&typeof m=="object"?T(m):m}),p}e.deepClone=T;function k(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const w=p.shift();Object.freeze(w);for(const m in w)if(A.call(w,m)){const b=w[m];typeof b=="object"&&!Object.isFrozen(b)&&!(0,L.isTypedArray)(b)&&p.push(b)}}return f}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function N(f,p){return I(f,p,new Set)}e.cloneAndChange=N;function I(f,p,w){if((0,L.isUndefinedOrNull)(f))return f;const m=p(f);if(typeof m<"u")return m;if(Array.isArray(f)){const b=[];for(const t of f)b.push(I(t,p,w));return b}if((0,L.isObject)(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const b={};for(const t in f)A.call(f,t)&&(b[t]=I(f[t],p,w));return w.delete(f),b}return f}function d(f,p,w=!0){return(0,L.isObject)(f)?((0,L.isObject)(p)&&Object.keys(p).forEach(m=>{m in f?w&&((0,L.isObject)(f[m])&&(0,L.isObject)(p[m])?d(f[m],p[m],w):f[m]=p[m]):f[m]=p[m]}),f):p}e.mixin=d;function c(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let w,m;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(w=0;w<f.length;w++)if(!c(f[w],p[w]))return!1}else{const b=[];for(m in f)b.push(m);b.sort();const t=[];for(m in p)t.push(m);if(t.sort(),!c(b,t))return!1;for(w=0;w<b.length;w++)if(!c(f[b[w]],p[b[w]]))return!1}return!0}e.equals=c;function P(f){const p=new Set;return JSON.stringify(f,(w,m)=>{if((0,L.isObject)(m)||Array.isArray(m)){if(p.has(m))return"[Circular]";p.add(m)}return m})}e.safeStringify=P;function E(f,p){const w=Object.create(null);return!f||!p||Object.keys(p).forEach(b=>{const t=f[b],a=p[b];c(t,a)||(w[b]=a)}),w}e.distinct=E;function y(f,p){const w=p.toLowerCase(),m=Object.keys(f).find(b=>b.toLowerCase()===w);return m?f[m]:f[p]}e.getCaseInsensitive=y;function v(f,p){const w=Object.create(null);for(const[m,b]of Object.entries(f))p(m,b)&&(w[m]=b);return w}e.filter=v;function O(f){let p=[],w=Object.getPrototypeOf(f);for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}e.getAllPropertyNames=O;function R(f){const p=[];for(const w of O(f))typeof f[w]=="function"&&p.push(w);return p}e.getAllMethodNames=R;function u(f,p){const w=b=>function(){const t=Array.prototype.slice.call(arguments,0);return p(b,t)},m={};for(const b of f)m[b]=w(b);return m}e.createProxyObject=u}),define(te[28],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(k){return L.test(k)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let d=0;d<I.length;d++)I[d]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),N=[];for(let I=0;I<256;I++)N.push(I.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let d=0,c="";return c+=N[A[d++]],c+=N[A[d++]],c+=N[A[d++]],c+=N[A[d++]],c+="-",c+=N[A[d++]],c+=N[A[d++]],c+="-",c+=N[A[d++]],c+=N[A[d++]],c+="-",c+=N[A[d++]],c+=N[A[d++]],c+="-",c+=N[A[d++]],c+=N[A[d++]],c+=N[A[d++]],c+=N[A[d++]],c+=N[A[d++]],c+=N[A[d++]],c}}()}),define(te[73],ie([0,1,33]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const I=N.replace(/\-/g,":").toLowerCase();return!T.has(I)}function A(){const N=(0,L.networkInterfaces)();for(const I in N){const d=N[I];if(d){for(const{mac:c}of d)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(te[74],ie([7,4]),function(B,e){return B.create("vs/base/common/date",e)}),define(te[75],ie([0,1,74]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,k=T*60,A=k*24,N=A*7,I=A*30,d=A*365;function c(E,y,v,O){typeof E!="number"&&(E=E.getTime());const R=Math.round((new Date().getTime()-E)/1e3);if(R<-30)return(0,L.localize)(0,null,c(new Date().getTime()+R*1e3,!1));if(!O&&R<30)return(0,L.localize)(1,null);let u;return R<T?(u=R,y?u===1?v?(0,L.localize)(2,null,u):(0,L.localize)(3,null,u):v?(0,L.localize)(4,null,u):(0,L.localize)(5,null,u):u===1?v?(0,L.localize)(6,null,u):(0,L.localize)(7,null,u):v?(0,L.localize)(8,null,u):(0,L.localize)(9,null,u)):R<k?(u=Math.floor(R/T),y?u===1?v?(0,L.localize)(10,null,u):(0,L.localize)(11,null,u):v?(0,L.localize)(12,null,u):(0,L.localize)(13,null,u):u===1?v?(0,L.localize)(14,null,u):(0,L.localize)(15,null,u):v?(0,L.localize)(16,null,u):(0,L.localize)(17,null,u)):R<A?(u=Math.floor(R/k),y?u===1?v?(0,L.localize)(18,null,u):(0,L.localize)(19,null,u):v?(0,L.localize)(20,null,u):(0,L.localize)(21,null,u):u===1?v?(0,L.localize)(22,null,u):(0,L.localize)(23,null,u):v?(0,L.localize)(24,null,u):(0,L.localize)(25,null,u)):R<N?(u=Math.floor(R/A),y?u===1?(0,L.localize)(26,null,u):(0,L.localize)(27,null,u):u===1?(0,L.localize)(28,null,u):(0,L.localize)(29,null,u)):R<I?(u=Math.floor(R/N),y?u===1?v?(0,L.localize)(30,null,u):(0,L.localize)(31,null,u):v?(0,L.localize)(32,null,u):(0,L.localize)(33,null,u):u===1?v?(0,L.localize)(34,null,u):(0,L.localize)(35,null,u):v?(0,L.localize)(36,null,u):(0,L.localize)(37,null,u)):R<d?(u=Math.floor(R/I),y?u===1?v?(0,L.localize)(38,null,u):(0,L.localize)(39,null,u):v?(0,L.localize)(40,null,u):(0,L.localize)(41,null,u):u===1?v?(0,L.localize)(42,null,u):(0,L.localize)(43,null,u):v?(0,L.localize)(44,null,u):(0,L.localize)(45,null,u)):(u=Math.floor(R/d),y?u===1?v?(0,L.localize)(46,null,u):(0,L.localize)(47,null,u):v?(0,L.localize)(48,null,u):(0,L.localize)(49,null,u):u===1?v?(0,L.localize)(50,null,u):(0,L.localize)(51,null,u):v?(0,L.localize)(52,null,u):(0,L.localize)(53,null,u))}e.fromNow=c;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[76],ie([7,4]),function(B,e){return B.create("vs/base/common/errorMessage",e)}),define(te[34],ie([0,1,19,3,76]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(E,y){return y&&(E.stack||E.stacktrace)?k.localize(0,null,I(E),N(E.stack)||N(E.stacktrace)):I(E)}function N(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function d(E=null,y=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const v=L.coalesce(E),O=d(v[0],y);return v.length>1?k.localize(4,null,O,v.length):O}if(T.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return A(v.error,y);if(v.exception)return A(v.exception,y)}return E.stack?A(E,y):E.message?E.message:k.localize(5,null)}e.toErrorMessage=d;function c(E){const y=E;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=c;function P(E,y){let v;return typeof E=="string"?v=new Error(E):v=E,v.actions=y,v}e.createErrorWithActions=P}),define(te[77],ie([7,4]),function(B,e){return B.create("vs/base/common/jsonErrorMessages",e)}),define(te[78],ie([0,1,77]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function T(k){switch(k){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=T}),define(te[52],ie([0,1,12]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(T=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(I,...d){const c=d.reduce((y,v)=>(y[v]=!0,y),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(y=>!c[y]).forEach(y=>{for(let v=0;v<P.length;v++)if(y.search(P[v])!==-1){delete I[y];break}})}e.sanitizeProcessEnvironment=A;function N(I){!I||(delete I.DEBUG,L.isMacintosh&&delete I.DYLD_LIBRARY_PATH,L.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(te[45],ie([0,1,29]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(f){return k(f,0)}e.hash=T;function k(f,p){switch(typeof f){case"object":return f===null?A(349,p):Array.isArray(f)?d(f,p):c(f,p);case"string":return I(f,p);case"boolean":return N(f,p);case"number":return A(f,p);case"undefined":return A(937,p);default:return A(617,p)}}e.doHash=k;function A(f,p){return(p<<5)-p+f|0}e.numberHash=A;function N(f,p){return A(f?433:863,p)}function I(f,p){p=A(149417,p);for(let w=0,m=f.length;w<m;w++)p=A(f.charCodeAt(w),p);return p}e.stringHash=I;function d(f,p){return p=A(104579,p),f.reduce((w,m)=>k(m,w),p)}function c(f,p){return p=A(181387,p),Object.keys(f).sort().reduce((w,m)=>(w=I(m,w),k(f[m],w)),p)}class P{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=k(p,this.g),this.g}}e.Hasher=P;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function y(f,p,w=32){const m=w-p,b=~((1<<m)-1);return(f<<p|(b&f)>>>m)>>>0}function v(f,p=0,w=f.byteLength,m=0){for(let b=0;b<w;b++)f[p+b]=m}function O(f,p,w="0"){for(;f.length<p;)f=w+f;return f}function R(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(w=>w.toString(16).padStart(2,"0")).join(""):O((f>>>0).toString(16),p/4)}e.toHexString=R;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const w=p.length;if(w===0)return;const m=this.p;let b=this.r,t=this.u,a,n;for(t!==0?(a=t,n=-1,t=0):(a=p.charCodeAt(0),n=0);;){let i=a;if(L.isHighSurrogate(a))if(n+1<w){const r=p.charCodeAt(n+1);L.isLowSurrogate(r)?(n++,i=L.computeCodePoint(a,r)):i=65533}else{t=a;break}else L.isLowSurrogate(a)&&(i=65533);if(b=this.w(m,b,i),n++,n<w)a=p.charCodeAt(n);else break}this.r=b,this.u=t}w(p,w,m){return m<128?p[w++]=m:m<2048?(p[w++]=192|(m&1984)>>>6,p[w++]=128|(m&63)>>>0):m<65536?(p[w++]=224|(m&61440)>>>12,p[w++]=128|(m&4032)>>>6,p[w++]=128|(m&63)>>>0):(p[w++]=240|(m&1835008)>>>18,p[w++]=128|(m&258048)>>>12,p[w++]=128|(m&4032)>>>6,p[w++]=128|(m&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=u.g,w=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,w.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,y(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let m=this.h,b=this.l,t=this.m,a=this.n,n=this.o,i,r,o;for(let l=0;l<80;l++)l<20?(i=b&t|~b&a,r=1518500249):l<40?(i=b^t^a,r=1859775393):l<60?(i=b&t|b&a|t&a,r=2400959708):(i=b^t^a,r=3395469782),o=y(m,5)+i+n+r+p.getUint32(l*4,!1)&4294967295,n=a,a=t,t=y(b,30),b=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(te[53],ie([0,1,29]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(T||(T={})),function(k){const A="error",N="warning",I="warn",d="info",c="ignore";function P(y){return y?L.equalsIgnoreCase(A,y)?k.Error:L.equalsIgnoreCase(N,y)||L.equalsIgnoreCase(I,y)?k.Warning:L.equalsIgnoreCase(d,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=P;function E(y){switch(y){case k.Error:return A;case k.Warning:return N;case k.Info:return d;default:return c}}k.toString=E}(T||(T={})),e.default=T}),define(te[79],ie([0,1,11]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=T;function k(c){const P=[];let E;try{const y=JSON.parse(c.arguments),v=y[y.length-1];v&&v.__$stack&&(y.pop(),E=v.__$stack),P.push(...y)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:E}}e.parse=k;function A(c){if(typeof c!="string")return A(k(c).stack);const P=c;if(P){const E=N(P),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(y&&y.length===4)return{uri:L.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=A;function N(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function I(c,P){const{args:E,stack:y}=k(c),v=typeof E[0]=="string"&&E.length===1;let O=N(y);O&&(O=`(${O.trim()})`);let R=[];if(typeof E[0]=="string"?O&&v?R=[`%c[${P}] %c${E[0]} %c${O}`,d("blue"),d(""),d("grey")]:R=[`%c[${P}] %c${E[0]}`,d("blue"),d(""),...E.slice(1)]:R=[`%c[${P}]%`,d("blue"),...E],O&&!v&&R.push(O),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,R)}e.log=I;function d(c){return`color: ${c}`}}),define(te[54],ie([0,1,14,29,11]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(c){return JSON.stringify(c,I)}e.stringify=A;function N(c){let P=JSON.parse(c);return P=d(P),P}e.parse=N;function I(c,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,T.regExpFlags)(P)}:P}function d(c,P=0){if(!c||P>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return k.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof L.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let E=0;E<c.length;++E)c[E]=d(c[E],P+1);else for(const E in c)Object.hasOwnProperty.call(c,E)&&(c[E]=d(c[E],P+1))}return c}e.revive=d}),define(te[80],ie([0,1,33,9,55,28,73]),function(B,e,L,T,k,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(P){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(P)}value(){if(this.b===void 0){let P=0,E=0;const y=(0,L.networkInterfaces)();for(const v in y){const O=y[v];if(O)for(const{mac:R,internal:u}of O)u||(E+=1,this.c(R.toUpperCase())&&(P+=1))}this.b=E>0?P/E:0}return this.b}};let I;async function d(){return I||(I=(async()=>await c()||A.generateUuid())()),I}e.getMachineId=d;async function c(){try{const P=await new Promise((y,v)=>{B(["crypto"],y,v)}),E=(0,N.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){T.onUnexpectedError(P);return}}}),define(te[81],ie([0,1,33,15,20]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(b,t,a){this.exePath=b,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:m=!1}={}){return m?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:m=!1,findPreview:b=!1}={}){const t=y({useAlternateBitness:m});if(!t)return null;const a=T.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,i=null;for(const l of await k.Promises.readdir(a)){let g=-1;if(b){const D=l.indexOf("-");if(D<0)continue;const F=l.substring(0,D);if(!A.test(F)||l.substring(D+1)!=="preview")continue;g=parseInt(F,10)}else{if(!A.test(l))continue;g=parseInt(l,10)}if(g<=n)continue;const S=T.join(a,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(S)||(i=S,n=g)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",o=b?" Preview":"";return new E(i,`PowerShell${o}${r}`,!0)}async function O({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const b=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(b))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=m?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(b))if(t.test(n)){const i=T.join(b,n,"pwsh.exe");return new E(i,a)}return null}function R(){const m=T.join(L.homedir(),".dotnet","tools","pwsh.exe");return new E(m,".NET Core PowerShell Global Tool")}function u(){const m=T.join(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(m,"Windows PowerShell",!0)}async function*f(){let m=await v();m&&(yield m),m=await v({useAlternateBitness:!0}),m&&(yield m),m=await O(),m&&(yield m),m=R(),m&&(yield m),m=await v({findPreview:!0}),m&&(yield m),m=await O({findPreview:!0}),m&&(yield m),m=await v({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=u(),m&&(yield m)}async function*p(){for await(const m of f())await m.exists()&&(yield m)}e.enumeratePowerShellInstallations=p;async function w(){for await(const m of p())return m;return null}e.getFirstAvailablePowerShellInstallation=w}),define(te[56],ie([0,1,15,12,35,52,3,20]),function(B,e,L,T,k,A,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function d(E=k.env){return E.comspec||"cmd.exe"}e.getWindowsShell=d;function c(E){let y=[],v=!1;const O=function(R){if(v){y.push(R);return}(!E.send(R,f=>{if(f&&console.error(f),v=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(w=>O(w))}})||T.isWindows)&&(v=!0)};return{send:O}}e.createQueuedSender=c;var P;(function(E){async function y(v,O,R){if(L.isAbsolute(v))return v;if(O===void 0&&(O=k.cwd()),L.dirname(v)!=="."||(R===void 0&&N.isString(k.env.PATH)&&(R=k.env.PATH.split(L.delimiter)),R===void 0||R.length===0))return L.join(O,v);async function f(p){if(await I.Promises.exists(p)){let w;try{w=await I.Promises.stat(p)}catch(m){m.message.startsWith("EACCES")&&(w=await I.Promises.lstat(p))}return w?!w.isDirectory():!1}return!1}for(const p of R){let w;if(L.isAbsolute(p)?w=L.join(p,v):w=L.join(O,p,v),await f(w))return w;let m=w+".com";if(await f(m)||(m=w+".exe",await f(m)))return m}return L.join(O,v)}E.findExecutable=y})(P=e.win32||(e.win32={}))}),define(te[82],ie([0,1,33,12,81,56]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(E,y){return E===1?T.isWindows?P():A.getWindowsShell(y):d(E,y)}e.getSystemShell=N;let I=null;function d(E,y){if(T.isLinux&&E===2||T.isMacintosh&&E===3)return"/bin/bash";if(!I){let v;if(T.isWindows)v="/bin/bash";else{if(v=y.SHELL,!v)try{v=(0,L.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}I=v}return I}let c=null;async function P(){return c||(c=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),c}});var ge=this&&this.__decorate||function(B,e,L,T){var k=arguments.length,A=k<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,L):T,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(B,e,L,T);else for(var I=B.length-1;I>=0;I--)(N=B[I])&&(A=(k<3?N(A):k>3?N(e,L,A):N(e,L))||A);return k>3&&A&&Object.defineProperty(e,L,A),A};define(te[57],ie([0,1,19,8,14,23,50,9,5,2,54,29,3]),function(B,e,L,T,k,A,N,I,d,c,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var v;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(v||(v={}));function O(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(R||(R={}));function u(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function p(z){let U=0;for(let $=0;;$+=7){const H=z.read(1);if(U|=(H.buffer[0]&127)<<$,!(H.buffer[0]&128))return U}}const w=n(0);function m(z,U){if(U===0){z.write(w);return}let $=0;for(let X=U;X!==0;X=X>>>7)$++;const H=k.VSBuffer.alloc($);for(let X=0;U!==0;X++)H.buffer[X]=U&127,U=U>>>7,U>0&&(H.buffer[X]|=128);z.write(H)}class b{constructor(U){this.b=U,this.a=0}read(U){const $=this.b.slice(this.a,this.a+U);return this.a+=$.byteLength,$}}e.BufferReader=b;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var a;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(a||(a={}));function n(z){const U=k.VSBuffer.alloc(1);return U.writeUInt8(z,0),U}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},r=typeof Buffer<"u";function o(z,U){if(typeof U>"u")z.write(i.Undefined);else if(typeof U=="string"){const $=k.VSBuffer.fromString(U);z.write(i.String),m(z,$.byteLength),z.write($)}else if(r&&Buffer.isBuffer(U)){const $=k.VSBuffer.wrap(U);z.write(i.Buffer),m(z,$.byteLength),z.write($)}else if(U instanceof k.VSBuffer)z.write(i.VSBuffer),m(z,U.byteLength),z.write(U);else if(Array.isArray(U)){z.write(i.Array),m(z,U.length);for(const $ of U)o(z,$)}else if(typeof U=="number"&&(U|0)===U)z.write(i.Uint),m(z,U);else{const $=k.VSBuffer.fromString(JSON.stringify(U));z.write(i.Object),m(z,$.byteLength),z.write($)}}e.serialize=o;function l(z){switch(z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return z.read(p(z)).toString();case a.Buffer:return z.read(p(z)).buffer;case a.VSBuffer:return z.read(p(z));case a.Array:{const $=p(z),H=[];for(let X=0;X<$;X++)H.push(l(z));return H}case a.Object:return JSON.parse(z.read(p(z)).toString());case a.Int:return p(z)}}e.deserialize=l;class g{constructor(U,$,H=null,X=1e3){this.h=U,this.j=$,this.k=H,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(U,$){this.b.set(U,$),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const $=this.o([U.type]);this.k?.logOutgoing($,0,1,u(U.type));return}case 201:case 202:case 204:case 203:{const $=this.o([U.type,U.id],U.data);this.k?.logOutgoing($,U.id,1,u(U.type),U.data);return}}}o(U,$=void 0){const H=new t;return o(H,U),o(H,$),this.p(H.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const $=new b(U),H=l($),X=l($),Y=H[0];switch(Y){case 100:return this.k?.logIncoming(U.byteLength,H[1],1,`${O(Y)}: ${H[2]}.${H[3]}`,X),this.s({type:Y,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.k?.logIncoming(U.byteLength,H[1],1,`${O(Y)}: ${H[2]}.${H[3]}`,X),this.t({type:Y,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.k?.logIncoming(U.byteLength,H[1],1,`${O(Y)}`),this.u({type:Y,id:H[1]});case 103:return this.k?.logIncoming(U.byteLength,H[1],1,`${O(Y)}`),this.u({type:Y,id:H[1]})}}s(U){const $=this.b.get(U.channelName);if(!$){this.v(U);return}const H=new A.CancellationTokenSource;let X;try{X=$.call(this.j,U.name,U.arg,H.token)}catch(s){X=Promise.reject(s)}const Y=U.id;X.then(s=>{this.m({id:Y,data:s,type:201}),this.d.delete(U.id)},s=>{s instanceof Error?this.m({id:Y,data:{message:s.message,name:s.name,stack:s.stack?s.stack.split?s.stack.split(`
`):s.stack:void 0},type:202}):this.m({id:Y,data:s,type:203}),this.d.delete(U.id)});const C=(0,c.toDisposable)(()=>H.cancel());this.d.set(U.id,C)}t(U){const $=this.b.get(U.channelName);if(!$){this.v(U);return}const H=U.id,Y=$.listen(this.j,U.name,U.arg)(C=>this.m({id:H,data:C,type:204}));this.d.set(U.id,Y)}u(U){const $=this.d.get(U.id);$&&($.dispose(),this.d.delete(U.id))}v(U){let $=this.g.get(U.channelName);$||($=[],this.g.set(U.channelName,$));const H=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);$.push({request:U,timeoutTimer:H})}w(U){const $=this.g.get(U);if($){for(const H of $)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=g;var S;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(U,$=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=$}getChannel(U){const $=this;return{call(H,X,Y){return $.a?Promise.reject(new I.CancellationError):$.m(U,H,X,Y)},listen(H,X){return $.a?d.Event.None:$.o(U,H,X)}}}m(U,$,H,X=A.CancellationToken.None){const Y=this.g++,s={id:Y,type:100,channelName:U,name:$,arg:H};if(X.isCancellationRequested)return Promise.reject(new I.CancellationError);let h;return new Promise((j,G)=>{if(X.isCancellationRequested)return G(new I.CancellationError);const q=()=>{const me=ue=>{switch(ue.type){case 201:this.f.delete(Y),j(ue.data);break;case 202:{this.f.delete(Y);const he=new Error(ue.data.message);he.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,he.name=ue.data.name,G(he);break}case 203:this.f.delete(Y),G(ue.data);break}};this.f.set(Y,me),this.p(s)};let ne=null;this.b===f.Idle?q():(ne=(0,T.createCancelablePromise)(me=>this.u()),ne.then(()=>{ne=null,q()}));const oe=()=>{ne?(ne.cancel(),ne=null):this.p({id:Y,type:101}),G(new I.CancellationError)},pe=X.onCancellationRequested(oe);h=(0,c.combinedDisposable)((0,c.toDisposable)(oe),pe),this.d.add(h)}).finally(()=>{this.d.delete(h)})}o(U,$,H){const X=this.g++,C={id:X,type:102,channelName:U,name:$,arg:H};let s=null;const h=new d.Emitter({onWillAddFirstListener:()=>{s=(0,T.createCancelablePromise)(j=>this.u()),s.then(()=>{s=null,this.d.add(h),this.p(C)})},onDidRemoveLastListener:()=>{s?(s.cancel(),s=null):(this.d.delete(h),this.p({id:X,type:103}))}}),M=j=>h.fire(j.data);return this.f.set(X,M),h.event}p(U){switch(U.type){case 100:case 102:{const $=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing($,U.id,0,`${O(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const $=this.q([U.type,U.id]);this.j?.logOutgoing($,U.id,0,O(U.type));return}}}q(U,$=void 0){const H=new t;return o(H,U),o(H,$),this.r(H.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const $=new b(U),H=l($),X=l($),Y=H[0];switch(Y){case 200:return this.j?.logIncoming(U.byteLength,0,0,u(Y)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,H[1],0,u(Y),X),this.t({type:H[0],id:H[1],data:X})}}t(U){if(U.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}ge([N.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class F{get connections(){const U=[];return this.f.forEach($=>U.push($)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:$,onDidClientDisconnect:H})=>{d.Event.once($.onMessage)(Y=>{const C=new b(Y),s=l(C),h=new g($,s),M=new D($);this.a.forEach((G,q)=>h.registerChannel(q,G));const j={channelServer:h,channelClient:M,ctx:s};this.f.add(j),this.g.fire(j),H(()=>{h.dispose(),M.dispose(),this.f.delete(j),this.h.fire(j)})})})}getChannel(U,$){const H=this;return{call(X,Y,C){let s;if((0,y.isFunction)($)){const M=(0,L.getRandomElement)(H.connections.filter($));s=M?Promise.resolve(M):d.Event.toPromise(d.Event.filter(H.onDidAddConnection,$))}else s=$.routeCall(H,X,Y);const h=s.then(M=>M.channelClient.getChannel(U));return Z(h).call(X,Y,C)},listen(X,Y){if((0,y.isFunction)($))return H.j(U,$,X,Y);const C=$.routeEvent(H,X,Y).then(s=>s.channelClient.getChannel(U));return Z(C).listen(X,Y)}}}j(U,$,H,X){const Y=this;let C=new c.DisposableStore;const s=new d.Emitter({onWillAddFirstListener:()=>{C=new c.DisposableStore;const h=new d.EventMultiplexer,M=new Map,j=q=>{const oe=q.channelClient.getChannel(U).listen(H,X),pe=h.add(oe);M.set(q,pe)},G=q=>{const ne=M.get(q);!ne||(ne.dispose(),M.delete(q))};Y.connections.filter($).forEach(j),d.Event.filter(Y.onDidAddConnection,$)(j,void 0,C),Y.onDidRemoveConnection(G,void 0,C),h.event(s.fire,s,C),C.add(h)},onDidRemoveLastListener:()=>{C.dispose()}});return s.event}registerChannel(U,$){this.a.set(U,$),this.f.forEach(H=>{H.channelServer.registerChannel(U,$)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class K{constructor(U,$,H=null){const X=new t;o(X,$),U.send(X.buffer),this.a=new D(U,H),this.d=new g(U,$,H)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,$){this.d.registerChannel(U,$)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=K;function Z(z){return{call(U,$,H){return z.then(X=>X.call(U,$,H))},listen(U,$){const H=new d.Relay;return z.then(X=>H.input=X.listen(U,$)),H.event}}}e.getDelayedChannel=Z;function _(z){let U=!1;return{call($,H,X){return U?z.call($,H,X):(0,T.timeout)(0).then(()=>U=!0).then(()=>z.call($,H,X))},listen($,H){if(U)return z.listen($,H);const X=new d.Relay;return(0,T.timeout)(0).then(()=>U=!0).then(()=>X.input=z.listen($,H)),X.event}}}e.getNextTickChannel=_;class se{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const $ of U.connections)if(await Promise.resolve(this.a($.ctx)))return Promise.resolve($);return await d.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=se;var re;(function(z){function U(Y,C){const s=Y,h=C&&C.disableMarshalling,M=new Map;for(const j in s)H(j)&&M.set(j,d.Event.buffer(s[j],!0));return new class{listen(j,G,q){const ne=M.get(G);if(ne)return ne;if(X(G)){const oe=s[G];if(typeof oe=="function")return oe.call(s,q)}throw new Error(`Event not found: ${G}`)}call(j,G,q){const ne=s[G];if(typeof ne=="function"){if(!h&&Array.isArray(q))for(let oe=0;oe<q.length;oe++)q[oe]=(0,P.revive)(q[oe]);return ne.apply(s,q)}throw new Error(`Method not found: ${G}`)}}}z.fromService=U;function $(Y,C){const s=C&&C.disableMarshalling;return new Proxy({},{get(h,M){if(typeof M=="string")return C?.properties?.has(M)?C.properties.get(M):X(M)?function(j){return Y.listen(M,j)}:H(M)?Y.listen(M):async function(...j){let G;C&&!(0,y.isUndefinedOrNull)(C.context)?G=[C.context,...j]:G=j;const q=await Y.call(M,G);return s?q:(0,P.revive)(q)};throw new Error(`Property not found: ${String(M)}`)}})}z.toService=$;function H(Y){return Y[0]==="o"&&Y[1]==="n"&&E.isUpperAsciiLetter(Y.charCodeAt(2))}function X(Y){return/^onDynamic/.test(Y)&&E.isUpperAsciiLetter(Y.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const U=z.toString();if(U!=="[object Object]")return U}return z}function ae(z){return Array.isArray(z)?z.map(fe):fe(z)}function x(z,U,$,H,X,Y,C){C=ae(C);const s=ce[X],h=s[H%s.length];let M=[`%c[${z}]%c[${String(U).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(Y)?(M=M.concat(C),M.push(")")):M.push(C),console.log.apply(console,M)}class W{constructor(U,$){this.d=U,this.f=$,this.a=0,this.b=0}logOutgoing(U,$,H,X,Y){this.b+=U,x(this.d,this.b,U,$,H,X,Y)}logIncoming(U,$,H,X,Y){this.a+=U,x(this.f,this.a,U,$,H,X,Y)}}e.IPCLogger=W}),define(te[83],ie([0,1,58,8,14,23,79,9,5,2,30,56,52,57]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class O extends v.ChannelServer{constructor(f){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",p=>k.VSBuffer.wrap(Buffer.from(p,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=O;class R{constructor(f,p){this.i=f,this.j=p,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const w=p&&p.timeout?p.timeout:6e4;this.b=new T.Delayer(w),this.d=null,this.f=null}getChannel(f){const p=this;return{call(w,m,b){return p.k(f,w,m,b)},listen(w,m){return p.l(f,w,m)}}}k(f,p,w,m=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const b=this.n(f),t=(0,T.createCancelablePromise)(i=>b.call(p,w,i)),a=m.onCancellationRequested(()=>t.cancel()),n=(0,c.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,p,w){if(!this.b)return d.Event.None;this.b.cancel();let m;const b=new d.Emitter({onWillAddFirstListener:()=>{m=this.n(f).listen(p,w)(b.fire,b),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return b.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(p.env),this.d=(0,L.fork)(this.i,f,p);const w=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.isRemoteConsoleLog)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const b=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&b.send(r.buffer.toString("base64")),a=w.event,n={send:t,onMessage:a};this.f=new v.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.dispose)(l)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(f){let p=this.g.get(f);return p||(p=this.m.getChannel(f),this.g.set(f,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=R}),define(te[84],ie([0,1,8,5,2,3]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function I(E){const y=E;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class c extends k.Disposable{constructor(y,v=Object.create(null)){super(),this.m=y,this.n=v,this.b=this.D(new T.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new L.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(y=>this.q(y)))}q(y){y.changed?.forEach((v,O)=>this.r(O,v)),y.deleted?.forEach(v=>this.r(v,void 0))}r(y,v){if(this.c===d.Closed)return;let O=!1;(0,A.isUndefinedOrNull)(v)?O=this.f.delete(y):this.f.get(y)!==v&&(this.f.set(y,v),O=!0),O&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,v){const O=this.f.get(y);return(0,A.isUndefinedOrNull)(O)?v:O}getBoolean(y,v){const O=this.get(y);return(0,A.isUndefinedOrNull)(O)?v:O==="true"}getNumber(y,v){const O=this.get(y);return(0,A.isUndefinedOrNull)(O)?v:parseInt(O,10)}async set(y,v){if(this.c===d.Closed)return;if((0,A.isUndefinedOrNull)(v))return this.delete(y);const O=String(v);if(this.f.get(y)!==O)return this.f.set(y,O),this.j.set(y,O),this.h.delete(y),this.b.fire(y),this.v()}async delete(y){if(!(this.c===d.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=d.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.t)return this.v(y)}async v(y){return this.g.trigger(()=>this.u(),y)}async whenFlushed(){if(!!this.t)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class P{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((v,O)=>this.a.set(O,v)),y.delete?.forEach(v=>this.a.delete(v))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[85],ie([7,4]),function(B,e){return B.create("vs/base/node/zip",e)}),define(te[86],ie([7,4]),function(B,e){return B.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[87],ie([7,4]),function(B,e){return B.create("vs/platform/contextkey/common/contextkey",e)}),define(te[88],ie([7,4]),function(B,e){return B.create("vs/platform/contextkey/common/scanner",e)}),define(te[89],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[90],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[91],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[92],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[93],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[94],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[95],ie([7,4]),function(B,e){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[96],ie([7,4]),function(B,e){return B.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[97],ie([7,4]),function(B,e){return B.create("vs/platform/files/common/fileService",e)}),define(te[98],ie([7,4]),function(B,e){return B.create("vs/platform/files/common/io",e)}),define(te[99],ie([7,4]),function(B,e){return B.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[100],ie([7,4]),function(B,e){return B.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[101],ie([7,4]),function(B,e){return B.create("vs/platform/request/common/request",e)}),define(te[102],ie([7,4]),function(B,e){return B.create("vs/platform/shell/node/shellEnv",e)}),define(te[103],ie([7,4]),function(B,e){return B.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[104],ie([7,4]),function(B,e){return B.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[105],ie([7,4]),function(B,e){return B.create("vs/platform/workspace/common/workspace",e)}),define(te[106],ie([0,1,9,88]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(k=e.TokenType||(e.TokenType={}));function A(...c){switch(c.length){case 1:return(0,T.localize)(0,null,c[0]);case 2:return(0,T.localize)(1,null,c[0],c[1]);case 3:return(0,T.localize)(2,null,c[0],c[1],c[2]);default:return}}const N=(0,T.localize)(3,null),I=(0,T.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,y=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:y};this.g.push({offset:E,lexeme:y,additionalInfo:P}),this.f.push(v)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),y=d.b.get(E);y?this.k(y):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,y=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(I);return}const O=this.c.charCodeAt(P);if(E)E=!1;else if(O===47&&!y){P++;break}else O===91?y=!0:O===92?E=!0:O===93&&(y=!1);P++}for(;P<this.c.length&&d.a.has(this.c.charCodeAt(P));)P++;this.e=P;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}d.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),d.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=d}),define(te[107],ie([0,1,75,50,16,15,35,17,11]),function(B,e,L,T,k,A,N,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const v=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",v)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=N.env.VSCODE_PORTABLE;return v?d.URI.file((0,A.join)(v,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,A.resolve)(v):(0,A.normalize)((0,A.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?d.URI.file((0,A.resolve)(v)):d.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,A.resolve)(v);const O=N.env.VSCODE_EXTENSIONS;if(O)return O;const R=N.env.VSCODE_PORTABLE;return R?(0,A.join)(R,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(O=>/^[^:/?#]+?:\/\//.test(O)?d.URI.parse(O):d.URI.file((0,A.normalize)(O)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?d.URI.parse(v):d.URI.file((0,A.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const O of this.args.log||[]){const R=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(O);R&&R[1]&&R[2]&&v.push([R[1],R[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=N.env.VSCODE_PORTABLE;return v?d.URI.file((0,A.join)(v,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,O,R){this.a=v,this.b=O,this.c=R,this.editSessionId=this.args.editSessionId}}ge([T.memoize],c.prototype,"appRoot",null),ge([T.memoize],c.prototype,"userHome",null),ge([T.memoize],c.prototype,"userDataPath",null),ge([T.memoize],c.prototype,"appSettingsHome",null),ge([T.memoize],c.prototype,"tmpDir",null),ge([T.memoize],c.prototype,"cacheHome",null),ge([T.memoize],c.prototype,"stateResource",null),ge([T.memoize],c.prototype,"userRoamingDataHome",null),ge([T.memoize],c.prototype,"userDataSyncHome",null),ge([T.memoize],c.prototype,"sync",null),ge([T.memoize],c.prototype,"machineSettingsResource",null),ge([T.memoize],c.prototype,"workspaceStorageHome",null),ge([T.memoize],c.prototype,"localHistoryHome",null),ge([T.memoize],c.prototype,"keyboardLayoutResource",null),ge([T.memoize],c.prototype,"argvResource",null),ge([T.memoize],c.prototype,"isExtensionDevelopment",null),ge([T.memoize],c.prototype,"untitledWorkspacesHome",null),ge([T.memoize],c.prototype,"installSourcePath",null),ge([T.memoize],c.prototype,"builtinExtensionsPath",null),ge([T.memoize],c.prototype,"extensionsPath",null),ge([T.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ge([T.memoize],c.prototype,"extensionDevelopmentKind",null),ge([T.memoize],c.prototype,"extensionTestsLocationURI",null),ge([T.memoize],c.prototype,"debugExtensionHost",null),ge([T.memoize],c.prototype,"logLevel",null),ge([T.memoize],c.prototype,"extensionLogLevel",null),ge([T.memoize],c.prototype,"serviceMachineIdResource",null),ge([T.memoize],c.prototype,"disableTelemetry",null),ge([T.memoize],c.prototype,"disableWorkspaceTrust",null),ge([T.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function P(y,v){return E(y["inspect-extensions"],y["inspect-brk-extensions"],5870,v,y.debugId,y.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function E(y,v,O,R,u,f){const w=Number(v||y)||(R?null:O),m=w?Boolean(!!v):!1;let b;if(f)try{b=JSON.parse(f)}catch{}return{port:w,break:m,debugId:u,env:b}}e.parseDebugParams=E}),function(){"use strict";function B(e,L,T){function k(N,I){const d=A(N,I),c=[d];return e.isAbsolute(d)||c.unshift(T),e.resolve(...c)}function A(N,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const P=N["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(E,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:k}}if(typeof define=="function")define(te[108],ie([161,33,35]),function(e,L,T){return B(e,L,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=B(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[109],ie([0,1,33,107,108]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends T.AbstractNativeEnvironmentService{constructor(c,P){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,k.getUserDataPath)(c,P.nameShort)},P)}}e.NativeEnvironmentService=A;function N(d,c){return(0,T.parseDebugParams)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,c,d.extensionEnvironment)}e.parsePtyHostDebugPort=N;function I(d,c){return(0,T.parseDebugParams)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,c,d.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(te[110],ie([0,1,3,92]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,I,d){try{A(N,I,d)}catch(c){console.error(c?.message??c)}return N}e.localizeManifest=k;function A(N,I,d){const c=(P,E,y)=>{const v=P[E];if((0,L.isString)(v)){const O=v,R=O.length;if(R>1&&O[0]==="%"&&O[R-1]==="%"){const u=O.substr(1,R-2);let f=I[u];f===void 0&&d&&(f=d[u]);const p=typeof f=="string"?f:f?.message,w=d?.[u],m=typeof w=="string"?w:w?.message;if(!p){m||console.warn(`[${N.name}]: ${(0,T.localize)(0,null,u)}`);return}if(y&&(E==="title"||E==="category")&&m&&m!==p){const b={value:p,original:m};P[E]=b}else P[E]=p}}else if((0,L.isObject)(v))for(const O in v)v.hasOwnProperty(O)&&(O==="commands"?c(v,O,!0):c(v,O,y));else if(Array.isArray(v))for(let O=0;O<v.length;O++)c(v,O,y)};for(const P in N)N.hasOwnProperty(P)&&c(N,P)}}),define(te[46],ie([0,1,17,53,96,41]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function d(f){return f=f.trim(),f==="*"||N.test(f)}e.isValidVersionStr=d;function c(f){if(!d(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(N);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=c;function P(f){if(!f)return null;const p=f.majorBase,w=f.majorMustEqual,m=f.minorBase;let b=f.minorMustEqual;const t=f.patchBase;let a=f.patchMustEqual;f.hasCaret&&(p===0||(b=!1),a=!1);let n=0;if(f.preRelease){const i=I.exec(f.preRelease);if(i){const[,r,o,l]=i;n=Date.UTC(Number(r),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:w,minorBase:m,minorMustEqual:b,patchBase:t,patchMustEqual:a,isMinimum:f.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function E(f,p,w){let m;typeof f=="string"?m=P(c(f)):m=f;let b;p instanceof Date?b=p.getTime():typeof p=="string"&&(b=new Date(p).getTime());let t;if(typeof w=="string"?t=P(c(w)):t=w,!m||!t)return!1;const a=m.majorBase,n=m.minorBase,i=m.patchBase;let r=t.majorBase,o=t.minorBase,l=t.patchBase;const g=t.notBefore;let S=t.majorMustEqual,D=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:n>o?!0:n<o||b&&b<g?!1:i>=l:(a===1&&r===0&&(!S||!D||!F)&&(r=1,o=0,l=0,S=!0,D=!1,F=!1),a<r?!1:a>r?!S:n<o?!1:n>o?!D:i<l?!1:i>l?!F:!(b&&b<g))}e.isValidVersion=E;function y(f,p,w,m,b){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([T.default.Error,k.localize(0,null)]),t;if(typeof m.name!="string")return t.push([T.default.Error,k.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([T.default.Error,k.localize(2,null,"version")]),t;if(!m.engines)return t.push([T.default.Error,k.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([T.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!u(m.extensionDependencies))return t.push([T.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!u(m.activationEvents))return t.push([T.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([T.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([T.default.Warning,k.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([T.default.Error,k.localize(9,null,"main")]),t;{const i=(0,L.joinPath)(w,m.main);(0,L.isEqualOrParent)(i,w)||t.push([T.default.Warning,k.localize(10,null,i.path,w.path)])}if(typeof m.activationEvents>"u")return t.push([T.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([T.default.Error,k.localize(12,null,"browser")]),t;{const i=(0,L.joinPath)(w,m.browser);(0,L.isEqualOrParent)(i,w)||t.push([T.default.Warning,k.localize(13,null,i.path,w.path)])}if(typeof m.activationEvents>"u")return t.push([T.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!A.valid(m.version))return t.push([T.default.Error,k.localize(15,null)]),t;const a=[];if(!v(f,p,m,b,a))for(const i of a)t.push([T.default.Error,i]);return t}e.validateExtensionManifest=y;function v(f,p,w,m,b){return m||typeof w.main>"u"&&typeof w.browser>"u"?!0:R(f,p,w.engines.vscode,b)}e.isValidExtensionVersion=v;function O(f,p,w){return f==="*"||R(p,w,f)}e.isEngineValid=O;function R(f,p,w,m=[]){const b=P(c(w));if(!b)return m.push(k.localize(16,null,w)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return m.push(k.localize(17,null,w)),!1}else if(!b.majorMustEqual)return m.push(k.localize(18,null,w)),!1;return E(f,p,b)?!0:(m.push(k.localize(19,null,f,w)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let p=0,w=f.length;p<w;p++)if(typeof f[p]!="string")return!1;return!0}}),define(te[111],ie([0,1,14,28]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(A,N,I){let d=I&&I.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const P=(await N.readFile(A.serviceMachineIdResource)).value.toString();d=(0,T.isUUID)(P)?P:null}catch{d=null}if(!d){d=(0,T.generateUuid)();try{await N.writeFile(A.serviceMachineIdResource,L.VSBuffer.fromString(d))}catch{}}return I?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=k}),define(te[47],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(k,A=[],N=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=L}),define(te[112],ie([0,1,47]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function A(I,d,c){d instanceof L.SyncDescriptor||(d=new L.SyncDescriptor(d,[],Boolean(c))),T.push([I,d])}e.registerSingleton=A;function N(){return T}e.getSingletonServiceDescriptors=N}),define(te[113],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class T{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const I=this.lookupOrInsertNode(A),d=this.lookupOrInsertNode(N);I.outgoing.set(d.key,d),d.incoming.set(I.key,I)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const I of this.a.values())I.outgoing.delete(N),I.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let I=this.a.get(N);return I||(I=new L(N,A),this.a.set(N,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,I]of this.a)A.push(`${N}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const I=new Set([A]),d=this.c(N,I);if(d)return d}}c(A,N){for(const[I,d]of A.outgoing){if(N.has(I))return[...N,I].join(" -> ");N.add(I);const c=this.c(d,N);if(c)return c;N.delete(I)}}}e.Graph=T}),define(te[24],ie([0,1,3,11,10]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationOverrides=A;function N(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=N;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function c(u,f){const p=Object.create(null);for(const w in u)P(p,w,u[w],f);return p}e.toValuesTree=c;function P(u,f,p,w){const m=f.split("."),b=m.pop();let t=u;for(let a=0;a<m.length;a++){const n=m[a];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${f} as ${m.slice(0,a+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[b]=p}catch{w(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=P;function E(u,f){const p=f.split(".");y(u,p)}e.removeFromValueTree=E;function y(u,f){const p=f.shift();if(f.length===0){delete u[p];return}if(Object.keys(u).indexOf(p)!==-1){const w=u[p];typeof w=="object"&&!Array.isArray(w)&&(y(w,f),Object.keys(w).length===0&&delete u[p])}}function v(u,f,p){function w(t,a){let n=t;for(const i of a){if(typeof n!="object"||n===null)return;n=n[i]}return n}const m=f.split("."),b=w(u,m);return typeof b>"u"?p:b}e.getConfigurationValue=v;function O(u,f,p){Object.keys(f).forEach(w=>{w!=="__proto__"&&(w in u?L.isObject(u[w])&&L.isObject(f[w])?O(u[w],f[w],p):p&&(u[w]=f[w]):u[w]=f[w])})}e.merge=O;function R(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=R}),define(te[114],ie([0,1,12,29,106,10,87]),function(B,e,L,T,k,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",L.isMacintosh),I.set("isLinux",L.isLinux),I.set("isWindows",L.isWindows),I.set("isWeb",L.isWeb),I.set("isMacNative",L.isMacintosh&&!L.isWeb),I.set("isEdge",L.isEdge),I.set("isFirefox",L.isFirefox),I.set("isChrome",L.isChrome),I.set("isSafari",L.isSafari);const d=Object.prototype.hasOwnProperty;var c;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(c=e.ContextKeyExprType||(e.ContextKeyExprType={}));const P={regexParsingWithErrorRecovery:!0};class E extends Error{}const y=(0,N.localize)(0,null),v=(0,N.localize)(1,null),O=(0,N.localize)(2,null),R=(0,N.localize)(3,null),u=(0,N.localize)(4,null),f=(0,N.localize)(5,null),p=(0,N.localize)(6,null),w=(0,N.localize)(7,null);class m{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(s=P){this.h=s,this.c=new k.Scanner,this.d=[],this.f=0,this.g=[]}parse(s){if(s===""){this.g.push({message:y,offset:0,lexeme:"",additionalInfo:v});return}this.d=this.c.reset(s).scan(),this.f=0,this.g=[];try{const h=this.k();if(!this.B()){const M=this.A(),j=M.type===17?f:void 0;throw this.g.push({message:u,offset:M.offset,lexeme:k.Scanner.getLexeme(M),additionalInfo:j}),new E}return h}catch(h){if(!(h instanceof E))throw h;return}}k(){return this.l()}l(){const s=[this.m()];for(;this.v(16);){const h=this.m();s.push(h)}return s.length===1?s[0]:b.or(...s)}m(){const s=[this.o()];for(;this.v(15);){const h=this.o();s.push(h)}return s.length===1?s[0]:b.and(...s)}o(){if(this.v(2)){const s=this.A();switch(s.type){case 11:return this.w(),i.INSTANCE;case 12:return this.w(),r.INSTANCE;case 0:{this.w();const h=this.k();return this.x(1,R),h?.negate()}case 17:return this.w(),F.create(s.lexeme);default:throw this.y("KEY | true | false | '(' expression ')'",s)}}return this.s()}s(){const s=this.A();switch(s.type){case 11:return this.w(),b.true();case 12:return this.w(),b.false();case 0:{this.w();const h=this.k();return this.x(1,R),h}case 17:{const h=s.lexeme;if(this.w(),this.v(9)){const j=this.A();if(!this.h.regexParsingWithErrorRecovery){if(this.w(),j.type!==10)throw this.y("REGEX",j);const G=j.lexeme,q=G.lastIndexOf("/"),ne=q===G.length-1?void 0:G.substring(q+1);let oe;try{oe=new RegExp(G.substring(1,q),ne)}catch{throw this.y("REGEX",j)}return ce.create(h,oe)}switch(j.type){case 10:case 19:{const G=[j.lexeme];this.w();let q=this.A(),ne=0;for(let he=0;he<j.lexeme.length;he++)j.lexeme.charCodeAt(he)===40?ne++:j.lexeme.charCodeAt(he)===41&&ne--;for(;!this.B()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let he=0;he<q.lexeme.length;he++)q.lexeme.charCodeAt(he)===40?ne++:j.lexeme.charCodeAt(he)===41&&ne--}if(ne<0)break;G.push(k.Scanner.getLexeme(q)),this.w(),q=this.A()}const oe=G.join(""),pe=oe.lastIndexOf("/"),me=pe===oe.length-1?void 0:oe.substring(pe+1);let ue;try{ue=new RegExp(oe.substring(1,pe),me)}catch{throw this.y("REGEX",j)}return b.regex(h,ue)}case 18:{const G=j.lexeme;this.w();let q=null;if(!(0,T.isFalsyOrWhitespace)(G)){const ne=G.indexOf("/"),oe=G.lastIndexOf("/");if(ne!==oe&&ne>=0){const pe=G.slice(ne+1,oe),me=G[oe+1]==="i"?"i":"";try{q=new RegExp(pe,me)}catch{throw this.y("REGEX",j)}}}if(q===null)throw this.y("REGEX",j);return ce.create(h,q)}default:throw this.y("REGEX",this.A())}}if(this.v(14)){this.x(13,O);const j=this.t();return b.notIn(h,j)}switch(this.A().type){case 3:{this.w();const j=this.t();if(this.u().type===18)return b.equals(h,j);switch(j){case"true":return b.has(h);case"false":return b.not(h);default:return b.equals(h,j)}}case 4:{this.w();const j=this.t();if(this.u().type===18)return b.notEquals(h,j);switch(j){case"true":return b.not(h);case"false":return b.has(h);default:return b.notEquals(h,j)}}case 5:return this.w(),se.create(h,this.t());case 6:return this.w(),re.create(h,this.t());case 7:return this.w(),Z.create(h,this.t());case 8:return this.w(),_.create(h,this.t());case 13:return this.w(),b.in(h,this.t());default:return b.has(h)}}case 20:throw this.g.push({message:p,offset:s.offset,lexeme:"",additionalInfo:w}),new E;default:throw this.y(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.A())}}t(){const s=this.A();switch(s.type){case 17:case 18:return this.w(),s.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(s){return this.z(s)?(this.w(),!0):!1}w(){return this.B()||this.f++,this.u()}x(s,h){if(this.z(s))return this.w();throw this.y(h,this.A())}y(s,h,M){const j=(0,N.localize)(8,null,s,k.Scanner.getLexeme(h)),G=h.offset,q=k.Scanner.getLexeme(h);return this.g.push({message:j,offset:G,lexeme:q,additionalInfo:M}),new E}z(s){return this.A().type===s}A(){return this.d[this.f]}B(){return this.A().type===20}}e.Parser=m;class b{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(s){return o.create(s)}static equals(s,h){return l.create(s,h)}static notEquals(s,h){return D.create(s,h)}static regex(s,h){return ce.create(s,h)}static in(s,h){return g.create(s,h)}static notIn(s,h){return S.create(s,h)}static not(s){return F.create(s)}static and(...s){return x.create(s,null,!0)}static or(...s){return W.create(s,null,!0)}static greater(s,h){return Z.create(s,h)}static greaterEquals(s,h){return _.create(s,h)}static smaller(s,h){return se.create(s,h)}static smallerEquals(s,h){return re.create(s,h)}static deserialize(s){return s==null?void 0:this.c.parse(s)}}b.c=new m({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=b;function t(C){const s=new m({regexParsingWithErrorRecovery:!1});return C.map(h=>(s.parse(h),s.lexingErrors.length>0?s.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,N.localize)(9,null,M.additionalInfo):(0,N.localize)(10,null),offset:M.offset,length:M.lexeme.length})):s.parsingErrors.length>0?s.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.validateWhenClauses=t;function a(C,s){const h=C?C.substituteConstants():void 0,M=s?s.substituteConstants():void 0;return!h&&!M?!0:!h||!M?!1:h.equals(M)}e.expressionsAreEqualWithConstantSubstitution=a;function n(C,s){return C.cmp(s)}class i{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return r.INSTANCE}}i.INSTANCE=new i,e.ContextKeyFalseExpr=i;class r{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}substituteConstants(){return this}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return i.INSTANCE}}r.INSTANCE=new r,e.ContextKeyTrueExpr=r;class o{static create(s,h=null){const M=I.get(s);return typeof M=="boolean"?M?r.INSTANCE:i.INSTANCE:new o(s,h)}constructor(s,h){this.key=s,this.c=h,this.type=2}cmp(s){return s.type!==this.type?this.type-s.type:U(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}substituteConstants(){const s=I.get(this.key);return typeof s=="boolean"?s?r.INSTANCE:i.INSTANCE:this}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=o;class l{static create(s,h,M=null){if(typeof h=="boolean")return h?o.create(s,M):F.create(s,M);const j=I.get(s);return typeof j=="boolean"?h===(j?"true":"false")?r.INSTANCE:i.INSTANCE:new l(s,h,M)}constructor(s,h,M){this.c=s,this.d=h,this.f=M,this.type=4}cmp(s){return s.type!==this.type?this.type-s.type:$(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=I.get(this.c);if(typeof s=="boolean"){const h=s?"true":"false";return this.d===h?r.INSTANCE:i.INSTANCE}return this}evaluate(s){return s.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(s){return s.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=l;class g{static create(s,h){return new g(s,h)}constructor(s,h){this.d=s,this.f=h,this.type=10,this.c=null}cmp(s){return s.type!==this.type?this.type-s.type:$(this.d,this.f,s.d,s.f)}equals(s){return s.type===this.type?this.d===s.d&&this.f===s.f:!1}substituteConstants(){return this}evaluate(s){const h=s.getValue(this.f),M=s.getValue(this.d);return Array.isArray(h)?h.includes(M):typeof M=="string"&&typeof h=="object"&&h!==null?d.call(h,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(s){return s.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class S{static create(s,h){return new S(s,h)}constructor(s,h){this.d=s,this.f=h,this.type=11,this.c=g.create(s,h)}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(s){return s.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=S;class D{static create(s,h,M=null){if(typeof h=="boolean")return h?F.create(s,M):o.create(s,M);const j=I.get(s);return typeof j=="boolean"?h===(j?"true":"false")?i.INSTANCE:r.INSTANCE:new D(s,h,M)}constructor(s,h,M){this.c=s,this.d=h,this.f=M,this.type=5}cmp(s){return s.type!==this.type?this.type-s.type:$(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){const s=I.get(this.c);if(typeof s=="boolean"){const h=s?"true":"false";return this.d===h?i.INSTANCE:r.INSTANCE}return this}evaluate(s){return s.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(s){return s.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=D;class F{static create(s,h=null){const M=I.get(s);return typeof M=="boolean"?M?i.INSTANCE:r.INSTANCE:new F(s,h)}constructor(s,h){this.c=s,this.d=h,this.type=3}cmp(s){return s.type!==this.type?this.type-s.type:U(this.c,s.c)}equals(s){return s.type===this.type?this.c===s.c:!1}substituteConstants(){const s=I.get(this.c);return typeof s=="boolean"?s?i.INSTANCE:r.INSTANCE:this}evaluate(s){return!s.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(s){return s.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.ContextKeyNotExpr=F;function K(C,s){if(typeof C=="string"){const h=parseFloat(C);isNaN(h)||(C=h)}return typeof C=="string"||typeof C=="number"?s(C):i.INSTANCE}class Z{static create(s,h,M=null){return K(h,j=>new Z(s,j,M))}constructor(s,h,M){this.c=s,this.d=h,this.f=M,this.type=12}cmp(s){return s.type!==this.type?this.type-s.type:$(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=Z;class _{static create(s,h,M=null){return K(h,j=>new _(s,j,M))}constructor(s,h,M){this.c=s,this.d=h,this.f=M,this.type=13}cmp(s){return s.type!==this.type?this.type-s.type:$(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(s){return s.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=_;class se{static create(s,h,M=null){return K(h,j=>new se(s,j,M))}constructor(s,h,M){this.c=s,this.d=h,this.f=M,this.type=14}cmp(s){return s.type!==this.type?this.type-s.type:$(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=se;class re{static create(s,h,M=null){return K(h,j=>new re(s,j,M))}constructor(s,h,M){this.c=s,this.d=h,this.f=M,this.type=15}cmp(s){return s.type!==this.type?this.type-s.type:$(this.c,this.d,s.c,s.d)}equals(s){return s.type===this.type?this.c===s.c&&this.d===s.d:!1}substituteConstants(){return this}evaluate(s){return typeof this.d=="string"?!1:parseFloat(s.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(s){return s.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=re;class ce{static create(s,h){return new ce(s,h)}constructor(s,h){this.d=s,this.f=h,this.type=7,this.c=null}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.d<s.d)return-1;if(this.d>s.d)return 1;const h=this.f?this.f.source:"",M=s.f?s.f.source:"";return h<M?-1:h>M?1:0}equals(s){if(s.type===this.type){const h=this.f?this.f.source:"",M=s.f?s.f.source:"";return this.d===s.d&&h===M}return!1}substituteConstants(){return this}evaluate(s){const h=s.getValue(this.d);return this.f?this.f.test(h):!1}serialize(){const s=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${s}`}keys(){return[this.d]}map(s){return s.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=fe.create(this)),this.c}}e.ContextKeyRegexExpr=ce;class fe{static create(s){return new fe(s)}constructor(s){this.c=s,this.type=8}cmp(s){return s.type!==this.type?this.type-s.type:this.c.cmp(s.c)}equals(s){return s.type===this.type?this.c.equals(s.c):!1}substituteConstants(){return this}evaluate(s){return!this.c.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(s){return new fe(this.c.map(s))}negate(){return this.c}}e.ContextKeyNotRegexExpr=fe;function ae(C){let s=null;for(let h=0,M=C.length;h<M;h++){const j=C[h].substituteConstants();if(C[h]!==j&&s===null){s=[];for(let G=0;G<h;G++)s[G]=C[G]}s!==null&&(s[h]=j)}return s===null?C:s}class x{static create(s,h,M){return x.d(s,h,M)}constructor(s,h){this.expr=s,this.c=h,this.type=6}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let h=0,M=this.expr.length;h<M;h++){const j=n(this.expr[h],s.expr[h]);if(j!==0)return j}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let h=0,M=this.expr.length;h<M;h++)if(!this.expr[h].equals(s.expr[h]))return!1;return!0}return!1}substituteConstants(){const s=ae(this.expr);return s===this.expr?this:x.create(s,this.c,!1)}evaluate(s){for(let h=0,M=this.expr.length;h<M;h++)if(!this.expr[h].evaluate(s))return!1;return!0}static d(s,h,M){const j=[];let G=!1;for(const q of s)if(!!q){if(q.type===1){G=!0;continue}if(q.type===0)return i.INSTANCE;if(q.type===6){j.push(...q.expr);continue}j.push(q)}if(j.length===0&&G)return r.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(n);for(let q=1;q<j.length;q++)j[q-1].equals(j[q])&&(j.splice(q,1),q--);if(j.length===1)return j[0];for(;j.length>1;){const q=j[j.length-1];if(q.type!==9)break;j.pop();const ne=j.pop(),oe=j.length===0,pe=W.create(q.expr.map(me=>x.create([me,ne],null,M)),null,oe);pe&&(j.push(pe),j.sort(n))}if(j.length===1)return j[0];if(M){for(let q=0;q<j.length;q++)for(let ne=q+1;ne<j.length;ne++)if(j[q].negate().equals(j[ne]))return i.INSTANCE;if(j.length===1)return j[0]}return new x(j,h)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(const h of this.expr)s.push(...h.keys());return s}map(s){return new x(this.expr.map(h=>h.map(s)),null)}negate(){if(!this.c){const s=[];for(const h of this.expr)s.push(h.negate());this.c=W.create(s,this,!0)}return this.c}}class W{static create(s,h,M){return W.d(s,h,M)}constructor(s,h){this.expr=s,this.c=h,this.type=9}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let h=0,M=this.expr.length;h<M;h++){const j=n(this.expr[h],s.expr[h]);if(j!==0)return j}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let h=0,M=this.expr.length;h<M;h++)if(!this.expr[h].equals(s.expr[h]))return!1;return!0}return!1}substituteConstants(){const s=ae(this.expr);return s===this.expr?this:W.create(s,this.c,!1)}evaluate(s){for(let h=0,M=this.expr.length;h<M;h++)if(this.expr[h].evaluate(s))return!0;return!1}static d(s,h,M){let j=[],G=!1;if(s){for(let q=0,ne=s.length;q<ne;q++){const oe=s[q];if(!!oe){if(oe.type===0){G=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){j=j.concat(oe.expr);continue}j.push(oe)}}if(j.length===0&&G)return i.INSTANCE;j.sort(n)}if(j.length!==0){if(j.length===1)return j[0];for(let q=1;q<j.length;q++)j[q-1].equals(j[q])&&(j.splice(q,1),q--);if(j.length===1)return j[0];if(M){for(let q=0;q<j.length;q++)for(let ne=q+1;ne<j.length;ne++)if(j[q].negate().equals(j[ne]))return r.INSTANCE;if(j.length===1)return j[0]}return new W(j,h)}}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(const h of this.expr)s.push(...h.keys());return s}map(s){return new W(this.expr.map(h=>h.map(s)),null)}negate(){if(!this.c){const s=[];for(const h of this.expr)s.push(h.negate());for(;s.length>1;){const h=s.shift(),M=s.shift(),j=[];for(const G of Y(h))for(const q of Y(M))j.push(x.create([G,q],null,!1));s.unshift(W.create(j,null,!1))}this.c=W.create(s,this,!0)}return this.c}}class z extends o{static all(){return z.d.values()}constructor(s,h,M){super(s,null),this.f=h,typeof M=="object"?z.d.push({...M,key:s}):M!==!0&&z.d.push({key:s,description:M,type:h!=null?typeof h:void 0})}bindTo(s){return s.createKey(this.key,this.f)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(s){return l.create(this.key,s)}notEqualsTo(s){return D.create(this.key,s)}}z.d=[],e.RawContextKey=z,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function U(C,s){return C<s?-1:C>s?1:0}function $(C,s,h,M){return C<h?-1:C>h?1:s<M?-1:s>M?1:0}function H(C,s){if(C.type===0||s.type===1)return!0;if(C.type===9)return s.type===9?X(C.expr,s.expr):!1;if(s.type===9){for(const h of s.expr)if(H(C,h))return!0;return!1}if(C.type===6){if(s.type===6)return X(s.expr,C.expr);for(const h of C.expr)if(H(h,s))return!0;return!1}return C.equals(s)}e.implies=H;function X(C,s){let h=0,M=0;for(;h<C.length&&M<s.length;){const j=C[h].cmp(s[M]);if(j<0)return!1;j===0&&h++,M++}return h===C.length}function Y(C){return C.type===9?C.expr:[C]}}),define(te[59],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(te[18],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(te[21],ie([0,1,90,10]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function k(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function N(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function I(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function d(f,p,w){return I(p,w)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===w?!0:c(w).includes(f)}e.isTargetPlatformCompatible=d;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function P(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=P;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var y;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var v;(function(f){f.Install="install",f.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var O;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(O=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var R;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(R=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(p,w){super(p),this.code=w,this.name=w}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class T{b(){return this.a||(this.a=new Promise((A,N)=>B(["node-vsce-sign"],async I=>A(I),N))),this.a}async verify(A,N,I){let d;try{d=await this.b()}catch{return!1}return d.verify(A,N,I)}}e.ExtensionSignatureVerificationService=T}),define(te[61],ie([0,1,14,9,98,13]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(P,E,y,v,O,R){let u;try{await I(P,E,y,v,O,R)}catch(f){u=f}finally{u&&O.errorTransformer&&(u=O.errorTransformer(u)),typeof u<"u"&&y.error(u),y.end()}}e.readFileIntoStream=N;async function I(P,E,y,v,O,R){d(R);const u=await P.open(E,{create:!1});try{d(R);let f=0,p=0,w=O&&typeof O.length=="number"?O.length:void 0,m=L.VSBuffer.alloc(Math.min(O.bufferSize,typeof w=="number"?w:O.bufferSize)),b=O&&typeof O.position=="number"?O.position:0,t=0;do p=await P.read(u,b,m.buffer,t,m.byteLength-t),b+=p,t+=p,f+=p,typeof w=="number"&&(w-=p),t===m.byteLength&&(await y.write(v(m)),m=L.VSBuffer.alloc(Math.min(O.bufferSize,typeof w=="number"?w:O.bufferSize)),t=0);while(p>0&&(typeof w!="number"||w>0)&&d(R)&&c(f,O));if(t>0){let a=t;typeof w=="number"&&(a=Math.min(t,w)),y.write(v(m.slice(0,a)))}}catch(f){throw(0,A.ensureFileSystemProviderError)(f)}finally{await P.close(u)}}function d(P){if(P.isCancellationRequested)throw(0,T.canceled)();return!0}function c(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,A.createFileSystemProviderError)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,A.createFileSystemProviderError)((0,k.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[115],ie([0,1,5,162,2,12,163]),function(B,e,L,T,k,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.D(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.i(c),E=P.filter(v=>{const O=this.c.get(v.path);return O?!(0,T.patternsEquals)(O.request.excludes,v.excludes)||!(0,T.patternsEquals)(O.request.includes,v.includes):!0}),y=Array.from(this.c.values()).filter(({request:v})=>!P.find(O=>O.path===v.path&&(0,T.patternsEquals)(O.excludes,v.excludes)&&(0,T.patternsEquals)(O.includes,v.includes))).map(({request:v})=>v.path);E.length&&this.j(`Request to start watching: ${E.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const v of y)this.h(v);for(const v of E)this.g(v)}g(c){const P=new N.NodeJSFileWatcherLibrary(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),E={request:c,instance:P};this.c.set(c.path,E)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}i(c){const P=new Map;for(const E of c){const y=A.isLinux?E.path:E.path.toLowerCase();P.set(y,E)}return Array.from(P.values())}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=I}),define(te[116],ie([0,1,62,115]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends L.AbstractNonRecursiveWatcherClient{constructor(N,I,d){super(N,I,d),this.m()}l(){return new T.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[117],ie([0,1,16,57,83,62]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends A.AbstractUniversalWatcherClient{constructor(d,c,P){super(d,c,P),this.m()}l(d){const c=d.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:P,signal:E})=>this.n(`terminated by itself with code ${P}, signal: ${E}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(te[63],ie([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...k){this.a=new Map;for(const[A,N]of k)this.set(A,N)}set(k,A){const N=this.a.get(k);return this.a.set(k,A),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=L}),define(te[118],ie([0,1,8,9,2,47,113,10,63,164]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class E extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class y{constructor(u=new d.ServiceCollection,f=!1,p,w=P){this.f=u,this.g=f,this.h=p,this.i=w,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=w?p?._globalGraph??new N.Graph(m=>m):void 0}createChild(u){return new y(u,this.g,this,this.i)}invokeFunction(u,...f){const p=O.traceInvocation(this.i,u);let w=!1;try{return u({get:b=>{if(w)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(b,p);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...f)}finally{w=!0,p.stop()}}createInstance(u,...f){let p,w;return u instanceof A.SyncDescriptor?(p=O.traceCreation(this.i,u.ctor),w=this.j(u.ctor,u.staticArguments.concat(f),p)):(p=O.traceCreation(this.i,u),w=this.j(u,f,p)),p.stop(),w}j(u,f=[],p){const w=I._util.getServiceDependencies(u).sort((t,a)=>t.index-a.index),m=[];for(const t of w){const a=this.m(t.id,p);a||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(a)}const b=w.length>0?w[0].index:f.length;if(f.length!==b){console.trace(`[createInstance] First service dependency of ${u.name} at position ${b+1} conflicts with ${f.length} static arguments`);const t=b-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,b)}return Reflect.construct(u,f.concat(m))}k(u,f){if(this.f.get(u)instanceof A.SyncDescriptor)this.f.set(u,f);else if(this.h)this.h.k(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const f=this.f.get(u);return!f&&this.h?this.h.l(u):f}m(u,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const p=this.l(u);return p instanceof A.SyncDescriptor?this.q(u,p,f.branch(u,!0)):(f.branch(u,!1),p)}q(u,f,p){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,f,p)}finally{this.o.delete(u)}}r(u,f,p){const w=new N.Graph(t=>t.id.toString());let m=0;const b=[{id:u,desc:f,_trace:p}];for(;b.length;){const t=b.pop();if(w.lookupOrInsertNode(t),m++>1e3)throw new E(w);for(const a of I._util.getServiceDependencies(t.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),n instanceof A.SyncDescriptor){const i={id:a.id,desc:n,_trace:t._trace.branch(a.id,!0)};w.insertEdge(t,i),b.push(i)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.SyncDescriptor){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}w.removeNode(a)}}return this.l(u)}s(u,f,p=[],w,m){if(this.f.get(u)instanceof A.SyncDescriptor)return this.t(u,f,p,w,m);if(this.h)return this.h.s(u,f,p,w,m);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(u,f,p=[],w,m){if(w){const b=new y(void 0,this.g,this,this.i);b.c=String(u);const t=new Map,a=new L.IdleValue(()=>{const n=b.j(f,p,m);for(const[i,r]of t){const o=n[i];if(typeof o=="function")for(const l of r)o.apply(n,l)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=t.get(i);return l||(l=new c.LinkedList,t.set(i,l)),(S,D,F)=>{const K=l.push([S,D,F]);return(0,k.toDisposable)(K)}}if(i in n)return n[i];const r=a.value;let o=r[i];return typeof o!="function"||(o=o.bind(r),n[i]=o),o},set(n,i,r){return a.value[i]=r,!0},getPrototypeOf(n){return f.prototype}})}else return this.j(f,p,m)}u(u,f){if(f&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=y;var v;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(v||(v={}));class O{static traceInvocation(u,f){return u?new O(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):O.c}static traceCreation(u,f){return u?new O(1,f.name):O.c}constructor(u,f){this.type=u,this.name=f,this.g=Date.now(),this.h=[]}branch(u,f){const p=new O(3,u.toString());return this.h.push([u,f,p]),p}stop(){const u=Date.now()-this.g;O.f+=u;let f=!1;function p(m,b){const t=[],a=new Array(m+1).join("	");for(const[n,i,r]of b.h)if(i&&r){f=!0,t.push(`${a}CREATES -> ${n}`);const o=p(m+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${n}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${O.f.toFixed(2)}ms)`];(u>2||f)&&O.all.add(w.join(`
`))}}O.all=new Set,O.c=new class extends O{constructor(){super(0,null)}stop(){}branch(){return this}},O.f=0,e.Trace=O});var ee=this&&this.__param||function(B,e){return function(L,T){e(L,T,B)}};define(te[64],ie([0,1,23,2,12,100,21,10]),function(B,e,L,T,k,A,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function d(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=d,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let c=class extends T.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new L.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const O=y.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(u=>u.startsWith("lp-"))).map(R=>{const u=R.properties.localizedLanguages?.[0],f=d(R);return{...this.f(f,u,R),extensionId:R.identifier.id,galleryExtension:R}});return O.push(this.f("en","English")),O}f(E,y,v){const O=y??E;let R;if(O!==E&&(R=`(${E})`),E.toLowerCase()===k.language.toLowerCase()&&(R??="",R+=(0,A.localize)(0,null)),v?.installCount){R??="";const u=v.installCount;let f;u>1e6?f=`${Math.floor(u/1e5)/10}M`:u>1e3?f=`${Math.floor(u/1e3)}K`:f=String(u),R+=` $(cloud-download) ${f}`}return{id:E,label:O,description:R}}};c=ge([ee(0,N.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(te[6],ie([0,1,34,5,45,2,36,12,17,3,11,114,10]),function(B,e,L,T,k,A,N,I,d,c,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function v(){return new Date().toISOString()}function O(S){return(0,c.isNumber)(S)}e.isLogLevel=O;var R;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function u(S,D,F){switch(D){case R.Trace:S.trace(F);break;case R.Debug:S.debug(F);break;case R.Info:S.info(F);break;case R.Warning:S.warn(F);break;case R.Error:S.error(F);break;case R.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=u;function f(S,D=!1){let F="";for(let K=0;K<S.length;K++){let Z=S[K];if(Z instanceof Error&&(Z=(0,L.toErrorMessage)(Z,D)),typeof Z=="object")try{Z=JSON.stringify(Z)}catch{}F+=(K>0?" ":"")+Z}return F}class p extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==R.Off&&this.b<=D}}e.AbstractLogger=p;class w extends p{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...F){this.f(R.Trace)&&this.g(R.Trace,f([D,...F],!0))}debug(D,...F){this.f(R.Debug)&&this.g(R.Debug,f([D,...F]))}info(D,...F){this.f(R.Info)&&this.g(R.Info,f([D,...F]))}warn(D,...F){this.f(R.Warning)&&this.g(R.Warning,f([D,...F]))}error(D,...F){if(this.f(R.Error))if(D instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=D.stack,this.g(R.Error,f(K))}else this.g(R.Error,f([D,...F]))}flush(){}}e.AbstractMessageLogger=w;class m extends p{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D),this.g=!I.isWindows}trace(D,...F){this.f(R.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...F):console.log(`[main ${v()}]`,D,...F))}debug(D,...F){this.f(R.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...F):console.log(`[main ${v()}]`,D,...F))}info(D,...F){this.f(R.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...F):console.log(`[main ${v()}]`,D,...F))}warn(D,...F){this.f(R.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,D,...F):console.warn(`[main ${v()}]`,D,...F))}error(D,...F){this.f(R.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,D,...F):console.error(`[main ${v()}]`,D,...F))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class b extends p{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D)}trace(D,...F){this.f(R.Trace)&&console.log("%cTRACE","color: #888",D,...F)}debug(D,...F){this.f(R.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",D,...F)}info(D,...F){this.f(R.Info)&&console.log("%c INFO","color: #33f",D,...F)}warn(D,...F){this.f(R.Warning)&&console.log("%c WARN","color: #993",D,...F)}error(D,...F){this.f(R.Error)&&console.log("%c  ERR","color: #f33",D,...F)}dispose(){}flush(){}}e.ConsoleLogger=b;class t extends p{constructor(D,F=e.DEFAULT_LOG_LEVEL){super(),this.g=D,this.setLevel(F)}trace(D,...F){this.f(R.Trace)&&this.g.log(R.Trace,[this.h(D),...F])}debug(D,...F){this.f(R.Debug)&&this.g.log(R.Debug,[this.h(D),...F])}info(D,...F){this.f(R.Info)&&this.g.log(R.Info,[this.h(D),...F])}warn(D,...F){this.f(R.Warning)&&this.g.log(R.Warning,[this.h(D),...F])}error(D,...F){this.f(R.Error)&&this.g.log(R.Error,[this.h(D),...F])}h(D){return typeof D=="string"?D:(0,L.toErrorMessage)(D,this.f(R.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends p{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const F of this.g)F.setLevel(D);super.setLevel(D)}trace(D,...F){for(const K of this.g)K.trace(D,...F)}debug(D,...F){for(const K of this.g)K.debug(D,...F)}info(D,...F){for(const K of this.g)K.info(D,...F)}warn(D,...F){for(const K of this.g)K.warn(D,...F)}error(D,...F){for(const K of this.g)K.error(D,...F)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose()}}e.MultiplexLogger=a;class n extends A.Disposable{constructor(D,F,K){if(super(),this.h=D,this.j=F,this.b=new N.ResourceMap,this.c=this.D(new T.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new T.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new T.Emitter),this.onDidChangeVisibility=this.g.event,K)for(const Z of K)this.b.set(Z.resource,{logger:void 0,info:Z})}k(D){return(0,c.isString)(D)?[...this.b.values()].find(F=>F.info.id===D):this.b.get(D)}getLogger(D){return this.k(D)?.logger}createLogger(D,F){const K=this.l(D),Z=(0,c.isString)(D)?D:F?.id??(0,k.hash)(K.toString()).toString(16);let _=this.b.get(K)?.logger;const se=F?.logLevel==="always"?R.Trace:F?.logLevel;_||(_=this.m(K,se??this.getLogLevel(K)??this.h,{...F,id:Z}));const re={logger:_,info:{resource:K,id:Z,logLevel:se,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(re.info),this.b.set(K,re),_}l(D){return(0,c.isString)(D)?(0,d.joinPath)(this.j,`${D}.log`):D}setLogLevel(D,F){if(P.URI.isUri(D)){const K=D,Z=F,_=this.b.get(K);_&&Z!==_.info.logLevel&&(_.info.logLevel=Z===this.h?void 0:Z,_.logger?.setLevel(Z),this.b.set(_.info.resource,_),this.f.fire([K,Z]))}else{this.h=D;for(const[K,Z]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&Z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,F){const K=this.k(D);K&&F!==!K.info.hidden&&(K.info.hidden=!F,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,F]))}getLogLevel(D){let F;return D&&(F=this.b.get(D)?.info.logLevel),F??this.h}registerLogger(D){const F=this.b.get(D.resource);F?F.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const F=this.b.get(D);F&&(F.logger&&F.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(D){}getLevel(){return R.Info}trace(D,...F){}debug(D,...F){}info(D,...F){}warn(D,...F){}error(D,...F){}critical(D,...F){}dispose(){}flush(){}}e.NullLogger=i;class r extends i{}e.NullLogService=r;function o(S){if(S.verbose)return R.Trace;if(typeof S.logLevel=="string"){const D=g(S.logLevel.toLowerCase());if(D!==void 0)return D}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(S){switch(S){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=l;function g(S){switch(S){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=g,e.CONTEXT_LOG_LEVEL=new E.RawContextKey("logLevel",l(R.Info))}),define(te[119],ie([0,1,19,8,9,5,2,15,62,6]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends N.Disposable{constructor(y,v){super(),this.a=y,this.b=v,this.c=this.D(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new T.ThrottledDelayer(0)),this.r=[],this.s=this.D(new T.ThrottledDelayer(0))}watch(y,v){return v.recursive||this.b?.watcher?.forceUniversal?this.l(y,v):this.t(y,v)}l(y,v){const O={path:this.z(y),excludes:v.excludes,includes:v.includes,recursive:v.recursive},R=(0,L.insert)(this.j,O);return this.m(),(0,N.toDisposable)(()=>{R(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,k.onUnexpectedError)(y))}n(){this.h||(this.h=this.D(this.p(v=>this.c.fire((0,d.toFileChanges)(v)),v=>this.y(v),this.a.getLevel()===c.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const v of this.j)(0,d.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const v of this.j)(0,d.isRecursiveWatchRequest)(v)&&y.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(y,v){const O={path:this.z(y),excludes:v.excludes,includes:v.includes,recursive:!1},R=(0,L.insert)(this.r,O);return this.u(),(0,N.toDisposable)(()=>{R(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(y=>(0,k.onUnexpectedError)(y))}v(){return this.q||(this.q=this.D(this.w(y=>this.c.fire((0,d.toFileChanges)(y)),y=>this.y(y),this.a.getLevel()===c.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.q.watch(this.r)}y(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}z(y){return(0,I.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[120],ie([0,1,19,8,14,23,5,45,65,2,55,16,121,17,44,97,13,61,6,9]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.D(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new T.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const n=new c.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),n.add(a.onDidChangeFile(i=>this.R.fire(new u.FileChangesEvent(i,!this.O(a))))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(n){a.push(n)}}),!this.h.has(t)&&await T.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return d.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,v.isAbsolutePath)(t))throw new u.FileOperationError((0,R.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const n=new w.ErrorNoTelemetry;throw n.message=(0,R.localize)(1,null,t.toString()),n}return a}async k(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a)||(0,u.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,R.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async n(t,a){const n=await this.j(t),i=this.O(n),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,g=await n.stat(t);let S;return this.p(n,t,g,void 0,!!l,(D,F)=>(S||(S=P.TernarySearchTree.forUris(()=>!i),S.set(t,!0),r&&S.fill(!0,r)),S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?F===1:!1))}async p(t,a,n,i,r,o){const{providerExtUri:l}=this.N(t),g={resource:a,name:l.basename(a),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(g.isDirectory&&o(g,i)){try{const S=await t.readdir(a),D=await T.Promises.settled(S.map(async([F,K])=>{try{const Z=l.joinPath(a,F),_=r?await t.stat(Z):{type:K};return await this.p(t,Z,_,S.length,r,o)}catch(Z){return this.b.trace(Z),null}}));g.children=(0,L.coalesce)(D)}catch(S){this.b.trace(S),g.children=[]}return g}return g}async resolveAll(t){return T.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),n=await a.stat(t);return this.p(a,t,n,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.q(t,a)}catch(n){return n}return!0}async q(t,a){if(!a?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,R.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=k.VSBuffer.fromString(""),n){await this.q(t,n);const i=await this.writeFile(t,a);return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,a,n){const i=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(i);try{await this.r(i,t,n)||await this.P(i,r.dirname(t));let l;if((0,u.hasReadWriteCapability)(i)&&!(a instanceof k.VSBuffer))if((0,O.isReadableStream)(a)){const g=await(0,O.peekStream)(a,3);g.ended?l=k.VSBuffer.concat(g.buffer):l=g}else l=(0,O.peekReadable)(a,g=>k.VSBuffer.concat(g),3);else l=a;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&l instanceof k.VSBuffer?await this.cb(i,t,n,l):await this.Y(i,t,n,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this.m.fire(new u.FileOperationEvent(t,4))}catch(o){throw new u.FileOperationError((0,R.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(o).toString()),(0,u.toFileOperationResult)(o),n)}return this.resolve(t,{resolveMetadata:!0})}async r(t,a,n){if(!!n?.unlock&&!(t.capabilities&8192))throw new Error((0,R.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,R.localize)(6,null,this.nb(a)),0,n);if(this.mb(a,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:r.size}))throw new u.FileOperationError((0,R.localize)(7,null),3,n);return r}async readFile(t,a,n){const i=await this.k(t);return a?.atomic?this.s(i,t,a,n):this.t(i,t,a,n)}async s(t,a,n,i){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.t(t,a,n,i);r(l)}catch(l){o(l)}})})}async t(t,a,n,i){const r=await this.u(t,a,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(t,a,n){const i=await this.k(t);return this.u(i,t,a,n)}async u(t,a,n,i){const r=new A.CancellationTokenSource(i),o=this.F(a,n).then(g=>g,g=>{throw r.cancel(),g});let l;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await o,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?l=this.C(t,a,n):(0,u.hasFileReadStreamCapability)(t)?l=this.w(t,a,r.token,n):l=this.z(t,a,r.token,n),{...await o,value:l}}catch(g){throw l&&await(0,O.consumeStream)(l),this.v(g,a,n)}}v(t,a,n){const i=(0,R.localize)(8,null,this.nb(a),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}w(t,a,n,i=Object.create(null)){const r=t.readFileStream(a,i,n);return(0,O.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>this.v(o,a,i)},o=>k.VSBuffer.concat(o))}z(t,a,n,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,a,r,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.v(o,a,i)},n),r}C(t,a,n){const i=(0,O.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(a,r.byteLength,n),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async F(t,a){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,R.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==u.ETAG_DISABLED&&a.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,R.localize)(10,null),n,a);return this.G(t,n.size,a),n}G(t,a,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&a>n.limits.size&&(i=7),typeof i=="number")throw new u.TooLargeFileOperationError((0,R.localize)(11,null,this.nb(t)),i,a,n)}}async canMove(t,a,n){return this.H(t,a,"move",n)}async canCopy(t,a,n){return this.H(t,a,"copy",n)}async H(t,a,n,i){if(t.toString()!==a.toString())try{const r=n==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(r,t,o,a,n,i)}catch(r){return r}return!0}async move(t,a,n){const i=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),o=await this.I(i,t,r,a,"move",!!n),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="move"?2:3,l)),l}async copy(t,a,n){const i=await this.k(t),r=this.lb(await this.l(a),a),o=await this.I(i,t,r,a,"copy",!!n),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,o==="copy"?3:2,l)),l}async I(t,a,n,i,r,o){if(a.toString()===i.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:g}=await this.M(t,a,n,i,r,o);if(l&&!g&&o&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),r==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(a,i,{overwrite:o});else{const S=await this.resolve(a);S.isDirectory?await this.L(t,S,n,i):await this.J(t,a,n,i)}return r}else return t===n?(await t.rename(a,i,{overwrite:o}),r):(await this.I(t,a,n,i,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.eb(t,a,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.kb(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.ib(t,a,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.gb(t,a,n,i)}async L(t,a,n,i){await n.mkdir(i),Array.isArray(a.children)&&await T.Promises.settled(a.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),n,o):this.J(t,r.resource,n,o)}))}async M(t,a,n,i,r,o){let l=!1;if(t===n){const{providerExtUri:S,isPathCaseSensitive:D}=this.N(t);if(D||(l=S.isEqual(a,i)),l&&r==="copy")throw new Error((0,R.localize)(12,null,this.nb(a),this.nb(i)));if(!l&&S.isEqualOrParent(i,a))throw new Error((0,R.localize)(13,null,this.nb(a),this.nb(i)))}const g=await this.exists(i);if(g&&!l){if(!o)throw new u.FileOperationError((0,R.localize)(14,null,this.nb(a),this.nb(i)),4);if(t===n){const{providerExtUri:S}=this.N(t);if(S.isEqualOrParent(a,i))throw new Error((0,R.localize)(15,null,this.nb(a),this.nb(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:l}}N(t){const a=this.O(t);return{providerExtUri:a?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async P(t,a){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(a,i.dirname(a));)try{if(((await t.stat(a)).type&u.FileType.Directory)===0)throw new Error((0,R.localize)(16,null,this.nb(a)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(a)),a=i.dirname(a)}for(let r=n.length-1;r>=0;r--){a=i.joinPath(a,n[r]);try{await t.mkdir(a)}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(n){return n}return!0}async Q(t,a){const n=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,R.localize)(17,null,this.nb(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.mb(t,r);else throw new u.FileOperationError((0,R.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const l=await this.resolve(t);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,R.localize)(19,null,this.nb(t)))}return n}async del(t,a){const n=await this.Q(t,a),i=!!a?.useTrash,r=!!a?.recursive;await n.delete(t,{recursive:r,useTrash:i}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,a){const n=await this.j(t),i=this.lb(await this.l(a),a);if(n===i&&this.N(n).providerExtUri.isEqual(t,a))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,a);await this.P(i,this.N(i).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(n,t,i,a))}watch(t,a={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);i?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(t,a){const n=await this.j(t),i=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(i);return r||(r={count:0,disposable:n.watch(t,a)},this.U.set(i,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,O.isReadableStream)(i)||(0,O.isReadableBufferedStream)(i)?await this.Z(t,r,i):await this.ab(t,r,i)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,a,n){let i=0,r;if((0,O.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.bb(t,a,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,l)=>{(0,O.listenStream)(r,{onData:async g=>{r.pause();try{await this.bb(t,a,g,g.byteLength,i,0)}catch(S){return l(S)}i+=g.byteLength,setTimeout(()=>r.resume())},onError:g=>l(g),onEnd:()=>o()})})}async ab(t,a,n){let i=0,r;for(;(r=n.read())!==null;)await this.bb(t,a,r,r.byteLength,i,0),i+=r.byteLength}async bb(t,a,n,i,r,o){let l=0;for(;l<i;)l+=await t.write(a,r+l,n.buffer,o+l,i-l)}async cb(t,a,n,i){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,n,i))}async db(t,a,n,i){let r;i instanceof k.VSBuffer?r=i:(0,O.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,O.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.fb(t,a,n,i))}async fb(t,a,n,i){let r,o;try{r=await t.open(a,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.a);let g=0,S=0,D=0;do D=await t.read(r,g,l.buffer,S,l.byteLength-S),await this.bb(n,o,l,D,g,S),g+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await T.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async gb(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.hb(t,a,n,i))}async hb(t,a,n,i){return n.writeFile(i,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.jb(t,a,n,i))}async jb(t,a,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async kb(t,a,n,i){const r=await(0,k.streamToBuffer)(this.z(t,a,A.CancellationToken.None));await this.cb(n,i,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new u.FileOperationError((0,R.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,R.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};m=ge([ee(0,p.ILogService)],m),e.FileService=m}),define(te[122],ie([0,1,123,165,8,36,14,5,166,2,15,12,17,44,20,99,13,61,119,34,117,116]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(a)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.H=new A.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:r}=await O.SymlinkSupport.stat(this.z(n));return{type:this.G(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(n){try{const i=await O.Promises.readdir(this.z(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,y.joinPath)(n,o.name))).type:l=this.G(o),r.push([o.name,l])}catch(l){this.a.trace(l)}})),r}catch(i){throw this.Y(i)}}G(n,i){let r;return i?.dangling?r=u.FileType.Unknown:n.isFile()?r=u.FileType.File:n.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,i&&(r|=u.FileType.SymbolicLink),r}async I(n){const i=this.z(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new k.Barrier;return this.H.set(n,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(n)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(n)})`),r=await this.I(n));const o=this.z(n);return await O.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(n){t.C&&this.a.trace(n)}readFileStream(n,i,r){const o=(0,v.newWriteableStream)(l=>N.VSBuffer.concat(l.map(g=>N.VSBuffer.wrap(g))).buffer);return(0,f.readFileIntoStream)(this,n,o,l=>l.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(n,i,r){let o;try{const l=this.z(n);if(!r.create||!r.overwrite){if(await O.Promises.exists(l)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,R.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,R.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.Z(n,l)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(n){t.O=n}async open(n,i){const r=this.z(n);let o;(0,u.isFileOpenForWriteOptions)(i)&&(o=await this.I(n));let l;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await O.SymlinkSupport.stat(r);S.mode&128||await O.Promises.chmod(r,S.mode|128)}catch(S){this.a.trace(S)}let g;if((0,u.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await O.Promises.truncate(r,0),g="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}g||(g="w")}else g="r";l=await O.Promises.open(r,g)}catch(g){throw o?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.Z(n,g):this.Y(g)}if(this.L.set(l,0),(0,u.isFileOpenForWriteOptions)(i)&&this.N.set(l,n),o){const g=this.M.get(l);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${r})`),this.M.set(l,o),g&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${r})`),g.dispose())}return l}async close(n){const i=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&t.O)try{await O.Promises.fdatasync(n)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await O.Promises.close(n)}catch(r){throw this.Y(r)}finally{i&&(this.M.get(n)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,o,l){const g=this.P(n,i);let S=null;try{S=(await O.Promises.read(n,r,o,l,g)).bytesRead}catch(D){throw this.Y(D)}finally{this.Q(n,g,S)}return S}P(n,i){return i===this.L.get(n)?null:i}Q(n,i,r){const o=this.L.get(n);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.L.set(n,o+r):this.L.delete(n)))}async write(n,i,r,o,l){return(0,k.retry)(()=>this.R(n,i,r,o,l),100,3)}async R(n,i,r,o,l){const g=this.P(n,i);let S=null;try{S=(await O.Promises.write(n,r,o,l,g)).bytesWritten}catch(D){throw await this.Z(this.N.get(n),D)}finally{this.Q(n,g,S)}return S}async mkdir(n){try{await O.Promises.mkdir(this.z(n))}catch(i){throw this.Y(i)}}async delete(n,i){try{const r=this.z(n);i.recursive?await O.Promises.rm(r,O.RimRafMode.MOVE):await O.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(n,i,r){const o=this.z(n),l=this.z(i);if(o!==l)try{await this.S(n,i,"move",r.overwrite),await O.Promises.move(o,l)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,R.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),g.toString()))),this.Y(g)}}async copy(n,i,r){const o=this.z(n),l=this.z(i);if(o!==l)try{await this.S(n,i,"copy",r.overwrite),await O.Promises.copy(o,l,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,R.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),g.toString()))),this.Y(g)}}async S(n,i,r,o){const l=this.z(n),g=this.z(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,d.isEqual)(l,g,!0)),S&&r==="copy")throw(0,u.createFileSystemProviderError)((0,R.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!S&&await O.Promises.exists(g)){if(!o)throw(0,u.createFileSystemProviderError)((0,R.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.U(n,i,!1)}async U(n,i,r){const o=this.z(n),l=this.z(i),g=!!(this.capabilities&1024);if((0,d.isEqual)(o,l,!g))return;const S=new c.DisposableStore;try{const[D,F]=await Promise.all([this.I(n),this.I(i)]);S.add(D),S.add(F),r&&await O.Promises.mkdir((0,P.dirname)(l),{recursive:!0}),await O.Promises.copyFile(o,l)}catch(D){if(D.code==="ENOENT"&&!r)return this.U(n,i,!0);throw this.Y(D)}finally{S.dispose()}}p(n,i,r){return new m.UniversalWatcherClient(o=>n(o),o=>i(o),r)}w(n,i,r){return new b.NodeJSWatcherClient(o=>n(o),o=>i(o),r)}Y(n){if(n instanceof u.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=u.FileSystemProviderErrorCode.NoPermissions;break;default:i=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,i)}async Z(n,i){let r=this.Y(i);if(n&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await O.SymlinkSupport.stat(this.z(n));o.mode&128||(r=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.C=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(te[124],ie([0,1,2,6]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends L.Disposable{constructor(N,I=[]){super(),this.a=new T.MultiplexLogger([N,...I]),this.D(N.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...I){this.a.trace(N,...I)}debug(N,...I){this.a.debug(N,...I)}info(N,...I){this.a.info(N,...I)}warn(N,...I){this.a.warn(N,...I)}error(N,...I){this.a.error(N,...I)}flush(){this.a.flush()}}e.LogService=k}),define(te[125],ie([0,1,13,6]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function A(c,P,E,y,v){try{const O=await new Promise((u,f)=>{B(["spdlog"],u,f)});O.setFlushOn(k.Trace);const R=await O.createAsyncRotatingLogger(c,P,E,y);return v?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(O){console.error(O)}return null}function N(c,P,E){switch(P){case T.LogLevel.Trace:c.trace(E);break;case T.LogLevel.Debug:c.debug(E);break;case T.LogLevel.Info:c.info(E);break;case T.LogLevel.Warning:c.warn(E);break;case T.LogLevel.Error:c.error(E);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function I(c,P){switch(P){case T.LogLevel.Trace:c.setLevel(k.Trace);break;case T.LogLevel.Debug:c.setLevel(k.Debug);break;case T.LogLevel.Info:c.setLevel(k.Info);break;case T.LogLevel.Warning:c.setLevel(k.Warning);break;case T.LogLevel.Error:c.setLevel(k.Error);break;case T.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class d extends T.AbstractMessageLogger{constructor(P,E,y,v,O){super(),this.k=[],this.setLevel(O),this.l=this.n(P,E,y,v),this.D(this.onDidChangeLogLevel(R=>{this.m&&I(this.m,R)}))}async n(P,E,y,v){const O=y?6:1,R=30/O*L.ByteSize.MB,u=await A(P,E,R,O,v);if(u){this.m=u,I(this.m,this.getLevel());for(const{level:f,message:p}of this.k)N(this.m,f,p);this.k=[]}}g(P,E){this.m?N(this.m,P,E):this.getLevel()<=P&&this.k.push({level:P,message:E})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(te[126],ie([0,1,28,6,125]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends T.AbstractLoggerService{m(I,d,c){return new k.SpdLogLogger((0,L.generateUuid)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,d)}}e.LoggerService=A}),define(te[38],ie([0,1,5,65,2,10]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.i(c),T.Iterable.reduce(this.g.entries(),(E,[y,v])=>({...E,[y]:v}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return T.Iterable.reduce(Object.entries(this.f),(c,[P,E])=>({...c,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=N;class I{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(te[127],ie([0,1,8,5,65,3,13,6,38]),function(B,e,L,T,k,A,N,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(E,y){const v=[];for(const O of new Set(k.Iterable.concat(E.keys(),y.keys())))E.get(O)!==y.get(O)&&v.push(O);return v}let P=class extends d.AbstractPolicyService{constructor(y,v,O){super(),this.j=y,this.k=v,this.l=O,this.c=this.D(new L.ThrottledDelayer(500));const R=T.Event.filter(v.onDidFilesChange,u=>u.affects(y));this.D(v.watch(y)),this.D(R(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const v=await this.k.readFile(this.j),O=JSON.parse(v.value.toString());if(!(0,A.isObject)(O))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(O))this.f[R]&&y.set(R,O[R])}catch(v){v.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",v)}return y}async p(){const y=await this.n(),v=c(this.g,y);this.g=y,v.length>0&&this.h.fire(v)}};P=ge([ee(1,N.IFileService),ee(2,I.ILogService)],P),e.FilePolicyService=P}),define(te[128],ie([0,1,38,8,167,2,6]),function(B,e,L,T,k,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends L.AbstractPolicyService{constructor(c,P){super(),this.j=c,this.k=P,this.a=new T.Throttler,this.b=this.D(new A.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((P,E)=>{try{this.b.value=(0,k.createWatcher)(this.k,c,y=>{this.m(y),P()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),E(y)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const P in c){const E=c[P];E===void 0?this.g.delete(P):this.g.set(P,E)}this.h.fire(Object.keys(c))}};I=ge([ee(0,N.ILogService)],I),e.NativePolicyService=I}),define(te[31],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[37],ie([0,1,70,3]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,I){L.ok(T.isString(N)),L.ok(T.isObject(I)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,I)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(te[129],ie([0,1,5,37]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[k(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;T.Registry.add(e.Extensions.JSONContribution,N)}),define(te[42],ie([0,1,19,5,3,86,24,129,37]),function(B,e,L,T,k,A,N,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=d.Registry.as(I.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const n=new Set;this.n(t,a,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const a=new Set;this.o(t,a),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const n=new Set;this.o(a,n),this.n(t,!1,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const n=[];for(const{overrides:i,source:r}of t)for(const o in i)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const l=this.a.get(o),g=l?.valuesSources??new Map;if(r)for(const K of Object.keys(i[o]))g.set(K,r);const S={...l?.value||{},...i[o]};this.a.set(o,{source:r,value:S,valuesSources:g});const D=(0,N.getLanguageTagSettingPlainKey)(o),F={type:"object",default:S,description:A.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:k.isString(r)?void 0:r,defaultValueSource:r};n.push(...R(o)),this.d[o]=F,this.b.properties[o]=F}else{this.a.set(o,{value:i[o],source:r});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(n)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:n,source:i}of t)for(const r in n){const o=this.a.get(r),l=k.isString(i)?i:i?.id,g=k.isString(o?.source)?o?.source:o?.source?.id;if(l===g)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const S=this.d[r];S&&(this.w(r,S),this.r(r,S))}}this.u()}deltaConfiguration(t){let a=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,n){t.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,a){const n=i=>{if(i.properties)for(const r in i.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of t){n(i);const r=this.c.indexOf(i);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,n,i,r=3,o){r=k.isUndefinedOrNull(t.scope)?r:t.scope;const l=t.properties;if(l)for(const S in l){const D=l[S];if(a&&w(S,D)){delete l[S];continue}if(D.source=n,D.defaultDefaultValue=l[S].default,this.w(S,D),e.OVERRIDE_PROPERTY_REGEX.test(S)?D.scope=void 0:(D.scope=k.isUndefinedOrNull(D.scope)?r:D.scope,D.restricted=k.isUndefinedOrNull(D.restricted)?!!i?.includes(S):D.restricted),l[S].hasOwnProperty("included")&&!l[S].included){this.f[S]=l[S],delete l[S];continue}else this.d[S]=l[S],l[S].policy?.name&&this.e.set(l[S].policy.name,S);!l[S].deprecationMessage&&l[S].markdownDeprecationMessage&&(l[S].deprecationMessage=l[S].markdownDeprecationMessage),o.add(S)}const g=t.allOf;if(g)for(const S of g)this.p(S,a,n,i,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=n=>{const i=n.properties;if(i)for(const o in i)this.r(o,i[o]);n.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const n=this.a.get(t);let i=n?.value,r=n?.source;k.isUndefined(i)&&(i=a.defaultDefaultValue,r=void 0),k.isUndefined(i)&&(i=f(a.type)),a.default=i,a.defaultValueSource=r}}const v="\\[([^\\]]+)\\]",O=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function R(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let a=O.exec(b);for(;a?.length;){const n=a[1].trim();n&&t.push(n),a=O.exec(b)}}return(0,L.distinct)(t)}e.overrideIdentifiersFromKey=R;function u(b){return b.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=u;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new y;d.Registry.add(e.Extensions.Configuration,p);function w(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):p.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,b,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=w;function m(){const b=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))b.push([a,t[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=m}),define(te[66],ie([0,1,19,5,51,2,36,30,3,11,24,42,37]),function(B,e,L,T,k,A,N,I,d,c,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(a){return Object.isFrozen(a)?a:I.deepFreeze(a)}class O{constructor(n={},i=[],r=[],o){this.b=n,this.c=i,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof O)return i;const r=new R("");return r.parseRaw(i),r.configurationModel});this.f=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,l=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:l}}getOverrideValue(n,i){const r=this.i(i);return r?n?(0,P.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return L.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),r=I.deepClone(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const g of n)if(l.push(...g.raw?.length?g.raw:[g]),!g.isEmpty()){this.h(i,g.contents);for(const S of g.overrides){const[D]=r.filter(F=>L.equals(F.identifiers,S.identifiers));D?(this.h(D.contents,S.contents),D.keys.push(...S.keys),D.keys=L.distinct(D.keys)):r.push(I.deepClone(S))}for(const S of g.keys)o.indexOf(S)===-1&&o.push(S)}return new O(i,o,r,l.every(g=>g instanceof O)?void 0:l)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o];const g=i[o];g&&(typeof l=="object"&&typeof g=="object"?(l=I.deepClone(l),this.h(l,g)):l=g),r[o]=l}return new O(r,this.keys,this.overrides)}h(n,i){for(const r of Object.keys(i)){if(r in n&&d.isObject(n[r])&&d.isObject(i[r])){this.h(n[r],i[r]);continue}n[r]=I.deepClone(i[r])}}i(n){let i=null,r=null;const o=l=>{l&&(r?this.h(r,l):r=I.deepClone(l))};for(const l of this.overrides)L.equals(l.identifiers,[n])?i=l.contents:l.identifiers.includes(n)&&o(l.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.removeFromValueTree)(this.contents,n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(r=>L.equals(r.identifiers,(0,E.overrideIdentifiersFromKey)(n))),1))}j(n,i,r){(0,P.addToValueTree)(this.contents,n,i,o=>console.error(o)),r=r||this.keys.indexOf(n)===-1,r&&this.keys.push(n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],o=>console.error(o))})}}e.ConfigurationModel=O;class R{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new O}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!d.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:o,overrides:l,restricted:g,hasExcludedProperties:S}=this.h(n,i);this.b=new O(r,o,l,S?[n]:void 0),this.c=g||[]}g(n){let i={},r=null,o=[];const l=[],g=[];function S(F){Array.isArray(o)?o.push(F):r!==null&&(o[r]=F)}const D={onObjectBegin:()=>{const F={};S(F),l.push(o),o=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const F=[];S(F),l.push(o),o=F,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:S,onError:(F,K,Z)=>{g.push({error:F,offset:K,length:Z})}};if(n)try{k.visit(n,D),i=o[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return i}h(n,i){const r=y.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.i(n,r,!0,i);n=o.raw;const l=(0,P.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),g=Object.keys(n),S=this.j(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:l,keys:g,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(n,i,r,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const g={},S=[];for(const D in n)if(E.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const F=this.i(n[D],i,!1,o);g[D]=F.raw,l=l||F.hasExcludedProperties,S.push(...F.restricted)}else{const F=i[D],K=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&S.push(D),(K===void 0||o.scopes===void 0||o.scopes.includes(K))&&!(o.skipRestricted&&F?.restricted)?g[D]=n[D]:l=!0}return{raw:g,restricted:S,hasExcludedProperties:l}}j(n,i){const r=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const g in n[o])l[g]=n[o][g];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,P.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=R;class u extends A.Disposable{constructor(n,i,r,o){super(),this.f=n,this.g=i,this.h=o,this.c=this.D(new T.Emitter),this.onDidChange=this.c.event,this.a=new R(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(r.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(T.Event.any(T.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new O}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class f{constructor(n,i,r,o,l,g,S,D,F,K,Z,_,se){this.a=n,this.b=i,this.c=r,this.overrideIdentifiers=o,this.d=l,this.f=g,this.g=S,this.h=D,this.i=F,this.j=K,this.k=Z,this.l=_,this.m=se}get value(){return v(this.c)}n(n,i,r){const o=n.inspect(i,r);return{get value(){return v(o.value)},get override(){return v(o.override)},get merged(){return v(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(n,i,r,o,l=new O,g=new O,S=new N.ResourceMap,D=new O,F=new N.ResourceMap){this.c=n,this.d=i,this.f=r,this.g=o,this.h=l,this.i=g,this.j=S,this.l=D,this.m=F,this.a=null,this.b=new N.ResourceMap,this.n=null}getValue(n,i,r){return this.q(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new O,this.m.set(r.resource,o))):o=this.l,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const o=this.q(n,i,r),l=this.u(i.resource,r),g=i.resource?this.m.get(i.resource)||this.l:this.l,S=new Set;for(const D of o.overrides)for(const F of D.identifiers)o.getOverrideValue(n,F)!==void 0&&S.add(F);return new f(n,i,o.getValue(n),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,l||void 0,g)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:l,removed:g}=b(this.c,n);i=[...o,...l,...g]}for(const o of i)for(const l of(0,E.overrideIdentifiersFromKey)(o)){const g=this.c.getKeysForOverrideIdentifier(l),S=n.getKeysForOverrideIdentifier(l),D=[...S.filter(F=>g.indexOf(F)===-1),...g.filter(F=>S.indexOf(F)===-1),...g.filter(F=>!I.equals(this.c.override(l).getValue(F),n.override(l).getValue(F)))];r.push([l,D])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=b(this.d,n),l=[...i,...r,...o];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=b(this.applicationConfiguration,n),g=[...i,...r,...o];return g.length&&this.updateApplicationConfiguration(n),{keys:g,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=b(this.localUserConfiguration,n),g=[...i,...r,...o];return g.length&&this.updateLocalUserConfiguration(n),{keys:g,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=b(this.remoteUserConfiguration,n),g=[...i,...r,...o];return g.length&&this.updateRemoteUserConfiguration(n),{keys:g,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:l}=b(this.workspaceConfiguration,n),g=[...i,...r,...o];return g.length&&this.updateWorkspaceConfiguration(n),{keys:g,overrides:l}}compareAndUpdateFolderConfiguration(n,i){const r=this.p.get(n),{added:o,updated:l,removed:g,overrides:S}=b(r,i),D=[...o,...l,...g];return(D.length||!r)&&this.updateFolderConfiguration(n,i),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:l,overrides:g}=b(i,void 0);return{keys:[...r,...o,...l],overrides:g}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,r){let o=this.r(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}r({resource:n},i){let r=this.s();if(i&&n){const o=i.getFolder(n);o&&(r=this.t(o.uri)||r);const l=this.m.get(n);l&&(r=r.merge(l))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const r=this.s(),o=this.j.get(n);o?(i=r.merge(o),this.b.set(n,i)):i=r}return i}u(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:l}=this.j.get(i);return n.push([i,{contents:r,overrides:o,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(r=>n.add(r))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.i.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.x(n.defaults),r=this.x(n.policy),o=this.x(n.application),l=this.x(n.user),g=this.x(n.workspace),S=n.folders.reduce((D,F)=>(D.set(c.URI.revive(F[0]),this.x(F[1])),D),new N.ResourceMap);return new p(i,r,o,l,new O,g,S,new O,new N.ResourceMap)}static x(n){return new O(n.contents,n.keys,n.overrides)}}e.Configuration=p;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const o of a)o.keys.forEach(l=>n.add(l)),o.overrides.forEach(([l,g])=>{const S=(0,N.getOrSet)(i,l,new Set);g.forEach(D=>S.add(D))});const r=[];return i.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=w;class m{constructor(n,i,r,o){this.change=n,this.f=i,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const g of l)this.affectedKeys.add(g);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(n,i){const r=this.a+n,o=this.d.indexOf(r);if(o<0)return!1;const l=o+r.length;if(l>=this.d.length)return!1;const g=this.d.charCodeAt(l);if(g!==this.b&&g!==this.c)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,D=this.g.getValue(n,i,this.h);return!I.equals(S,D)}return!0}}e.ConfigurationChangeEvent=m;function b(a,n){const{added:i,removed:r,updated:o}=t(n?.rawConfiguration,a?.rawConfiguration),l=[],g=a?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const D=S.filter(F=>!g.includes(F));for(const F of D)l.push([F,n.getKeysForOverrideIdentifier(F)])}if(a){const D=g.filter(F=>!S.includes(F));for(const F of D)l.push([F,a.getKeysForOverrideIdentifier(F)])}if(n&&a){for(const D of g)if(S.includes(D)){const F=t({contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)},{contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)});l.push([D,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:r,updated:o,overrides:l}}function t(a,n){const i=a?n?a.keys.filter(l=>n.keys.indexOf(l)===-1):[...a.keys]:[],r=n?a?n.keys.filter(l=>a.keys.indexOf(l)===-1):[...n.keys]:[],o=[];if(a&&n){for(const l of n.keys)if(a.keys.indexOf(l)!==-1){const g=(0,P.getConfigurationValue)(n.contents,l),S=(0,P.getConfigurationValue)(a.contents,l);I.equals(g,S)||o.push(l)}}return{added:i,removed:r,updated:o}}}),define(te[130],ie([0,1,19,5,2,30,3,66,42,6,38,37]),function(B,e,L,T,k,A,N,I,d,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments),this.a=this.D(new T.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(E.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:f})=>this.c(Array.from(u),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,f){this.h(u,E.Registry.as(d.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new I.ConfigurationModel;const u=E.Registry.as(d.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,f){const p=this.f();for(const w of u){const m=p[w],b=f[w];m!==void 0?this.b.addValue(w,m):b?this.b.addValue(w,b.default):this.b.removeValue(w)}}}e.DefaultConfiguration=y;class v{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let O=class extends k.Disposable{get configurationModel(){return this.b}constructor(u,f,p){super(),this.c=u,this.f=f,this.g=p,this.a=this.D(new T.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(u=>this.i(u))),this.D(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const f={},p=[],w=E.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const m of u){const b=w[m];if(!b){p.push(m);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.g.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}p.push(m),f[b.policy.name]={type:b.type}}}return(0,N.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),p}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const f=E.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),p=(0,L.coalesce)(u.map(w=>f.get(w)));this.j(p,!0)}j(u,f){this.g.trace("PolicyConfiguration#update",u);const p=E.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),w=[],m=this.b.isEmpty();for(const b of u){const t=p[b]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(m?a!==void 0:!(0,A.equals)(this.b.getValue(b),a))&&w.push([b,a])}else this.b.getValue(b)!==void 0&&w.push([b,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const b=this.b;this.b=new I.ConfigurationModel;for(const t of b.keys)this.b.setValue(t,b.getValue(t));for(const[t,a]of w)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);f&&this.a.fire(this.b)}}};O=ge([ee(1,P.IPolicyService),ee(2,c.ILogService)],O),e.PolicyConfiguration=O}),define(te[131],ie([0,1,8,5,2,17,24,66,130,38]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends k.Disposable{constructor(y,v,O,R){super(),this.i=y,this.h=this.D(new T.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new d.DefaultConfiguration),this.c=O instanceof c.NullPolicyService?new d.NullPolicyConfiguration:this.D(new d.PolicyConfiguration(this.b,O,R)),this.f=this.D(new I.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,v)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.D(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:u,properties:f})=>this.k(u,f))),this.D(this.c.onDidChangeConfiguration(u=>this.l(u))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,v,O]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(y,v,new I.ConfigurationModel,O)}getConfigurationData(){return this.a.toData()}getValue(y,v){const O=typeof y=="string"?y:void 0,R=(0,N.isConfigurationOverrides)(y)?y:(0,N.isConfigurationOverrides)(v)?v:{};return this.a.getValue(O,R,void 0)}updateValue(y,v,O,R){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const v=this.a.toData(),O=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(O,v,2)}k(y,v){const O=this.a.toData(),R=this.a.compareAndUpdateDefaultConfiguration(y,v);this.m(R,O,7)}l(y){const v=this.a.toData(),O=this.a.compareAndUpdatePolicyConfiguration(y);this.m(O,v,7)}m(y,v,O){const R=new I.ConfigurationChangeEvent(y,{data:v},this.a);R.source=O,R.sourceConfig=this.n(O),this.h.fire(R)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[67],ie([0,1,16]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=T;function k(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.getRemoteName=k;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=A;function N(c){const{host:P,port:E}=d(c);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.parseAuthorityWithPort=N;function I(c,P){let{host:E,port:y}=d(c);return typeof y>"u"&&(y=P),{host:E,port:y}}e.parseAuthorityWithOptionalPort=I;function d(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=c.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(te[32],ie([0,1,29,10,67]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(N=e.ExtensionType||(e.ExtensionType={}));var I;(function(R){R.WIN32_X64="win32-x64",R.WIN32_IA32="win32-ia32",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class d{constructor(u){this.value=u,this.c=u.toLowerCase()}static equals(u,f){if(typeof u>"u"||u===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof u=="string"||typeof f=="string"){const p=typeof u=="string"?u:u.value,w=typeof f=="string"?f:f.value;return L.equalsIgnoreCase(p,w)}return u.c===f.c}static toKey(u){return typeof u=="string"?u.toLowerCase():u.c}}e.ExtensionIdentifier=d;class c{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const f of u)this.add(f)}add(u){this.c.add(d.toKey(u))}delete(u){return this.c.delete(d.toKey(u))}has(u){return this.c.has(d.toKey(u))}}e.ExtensionIdentifierSet=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(d.toKey(u))}get(u){return this.c.get(d.toKey(u))}has(u){return this.c.has(d.toKey(u))}set(u,f){this.c.set(d.toKey(u),f)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function E(R){return y(R)}e.isApplicationScopedExtension=E;function y(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function v(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function O(R,u){if(u){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(u)}`;return!!R.activationEvents?.includes(f)}return!1}e.isResolverExtension=O,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[132],ie([0,1,2,15,20,32]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends L.Disposable{constructor(d,c){super(),this.b=d,this.a=(0,T.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.D(c.onDidInstallExtensions(P=>this.c(P))),this.D(c.onDidUninstallExtension(P=>this.f(P)))}c(d){d.some(c=>!!c.local)&&this.invalidate()}f(d){d.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(te[43],ie([0,1,14,9,2,101,42,10,6,37]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class P{constructor(b){this.b=b}toJSON(){if(!this.a){const b=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.b[t];this.a=b}return this.a}}class E extends k.Disposable{constructor(b,t){super(),this.b=0,this.a=t.createLogger(b?"remotenetwork":"network",{name:b?(0,A.localize)(0,null):(0,A.localize)(1,null),when:d.CONTEXT_LOG_LEVEL.isEqualTo((0,d.LogLevelToString)(d.LogLevel.Trace)).serialize()})}async c(b,t,a){const n=`${b} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new P(t.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,t.type,(0,T.getErrorMessage)(i)),i}}}e.AbstractRequestService=E;function y(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=y;function v(m){return m.res.statusCode===204}async function O(m){return v(m)?null:(await(0,L.streamToBuffer)(m.stream)).toString()}e.asText=O;async function R(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);return O(m)}e.asTextOrError=R;async function u(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);if(v(m))return null;const t=(await(0,L.streamToBuffer)(m.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=u;function f(m){w(m)}e.updateProxyConfigurationsScope=f;let p;function w(m){const b=c.Registry.as(N.Extensions.Configuration),t=p;p={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},b.updateConfigurations({add:[p],remove:t?[t]:[]})}w(2)}),define(te[133],ie([0,1,23,16,13,43]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(d,c){this.a=d,this.b=c}async download(d,c,P=L.CancellationToken.None){if(d.scheme===T.Schemas.file||d.scheme===T.Schemas.vscodeRemote){await this.b.copy(d,c);return}const E={type:"GET",url:d.toString(!0)},y=await this.a.request(E,P);if(y.res.statusCode===200)await this.b.writeFile(c,y.stream);else{const v=await(0,A.asTextOrError)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${v}`)}}};N=ge([ee(0,A.IRequestService),ee(1,k.IFileService)],N),e.DownloadService=N}),define(te[134],ie([0,1,135,3]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,I){return N.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:N.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(N,I,d={}){const c=(0,L.parse)(N),P=d.proxyUrl||k(c,I);if(!P)return null;const E=(0,L.parse)(P);if(!/^https?:$/.test(E.protocol||""))return null;const y={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,T.isBoolean)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((v,O)=>{B(["http-proxy-agent"],v,O)}))(y):new(await new Promise((v,O)=>{B(["https-proxy-agent"],v,O)}))(y)}e.getProxyAgent=A}),define(te[136],ie([0,1,58,15,102,23,34,9,12,28,82,168,8,71]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let O;async function R(f,p,w,m){return w["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(m)&&!w["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(m)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),O||(O=y.Promises.withAsyncBody(async(b,t)=>{const a=new A.CancellationTokenSource;let n=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,v.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,k.localize)(0,null)))},n);try{b(await u(p,a.token))}catch(o){!(0,I.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(o)))):b({})}finally{clearTimeout(r),a.dispose()}})),O)}e.getResolvedShellEnv=R;async function u(f,p){const w=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",w);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",m);const b=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(b+"({.*})"+b),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",a);const n=await(0,P.getSystemShell)(d.OS,a);return f.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(p.isCancellationRequested)return r(new I.CancellationError);const o=(0,T.basename)(n);let l,g;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${S} -p '''${b}'' + JSON.stringify(process.env) + ''${b}'''`,g=["-Login","-Command"]):(l=`'${process.execPath}' ${S} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,o==="tcsh"||o==="csh"?g=["-ic"]:g=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),l);const D=(0,L.spawn)(n,[...g,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(D.kill(),r(new I.CancellationError))),D.on("error",Z=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(Z)),r(Z)});const F=[];D.stdout.on("data",Z=>F.push(Z));const K=[];D.stderr.on("data",Z=>K.push(Z)),D.on("close",(Z,_)=>{const se=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",se);const re=Buffer.concat(K).toString("utf8");if(re.trim()&&f.trace("getUnixShellEnvironment#stderr",re),Z||_)return r(new Error((0,k.localize)(2,null,Z,_)));const ce=t.exec(se),fe=ce?ce[1]:"{}";try{const ae=JSON.parse(fe);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,m?ae.ELECTRON_NO_ATTACH_CONSOLE=m:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){f.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(ae)),r(ae)}})})}}),define(te[137],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,L.createDecorator)("stateReadService"),e.IStateService=(0,L.createDecorator)("stateService")}),define(te[68],ie([0,1,8,14,3,18,13,6]),function(B,e,L,T,k,A,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var d;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(d=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(v,O,R,u){this.f=v,this.g=R,this.h=u,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=O===0?void 0:new L.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,O){const R=this.a[v];return(0,k.isUndefinedOrNull)(R)?O:R}setItem(v,O){this.setItems([{key:v,data:O}])}setItems(v){let O=!1;for(const{key:R,data:u}of v)this.a[R]!==u&&((0,k.isUndefinedOrNull)(u)?(0,k.isUndefined)(this.a[R])||(this.a[R]=void 0,O=!0):(this.a[R]=u,O=!0));O&&this.j()}removeItem(v){(0,k.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,T.VSBuffer.fromString(v)),this.b=v}catch(O){this.g.error(O)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let P=class{constructor(v,O,R,u){this.a=new c(O.stateResource,v,R,u)}async init(){await this.a.init()}getItem(v,O){return this.a.getItem(v,O)}};P=ge([ee(1,A.IEnvironmentService),ee(2,I.ILogService),ee(3,N.IFileService)],P),e.StateReadonlyService=P;class E extends P{setItem(v,O){this.a.setItem(v,O)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.StateService=E}),define(te[69],ie([0,1,12,35,11,28]),function(B,e,L,T,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(c){if(L.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function I(c,P,E,y,v,O,R,u,f,p){const w=Object.create(null);w["common.machineId"]=R,w.sessionID=(0,A.generateUuid)()+Date.now(),w.commitHash=v,w.version=O,w["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,L.PlatformToString)(L.platform),w["common.nodePlatform"]=T.platform,w["common.nodeArch"]=y,w["common.product"]=p||"desktop",u&&(w["common.msftInternal"]=u);let m=0;const b=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),L.isLinuxSnap&&(w["common.snap"]="true");const t=N(E);t&&(w["common.platformDetail"]=t);try{const a=await c.readFile(k.URI.file(f));w["common.source"]=a.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=I;function d(c){const P=T.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return c.some(y=>E===y)}e.verifyMicrosoftInternalDomain=d}),define(te[25],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[39],ie([0,1,30,3,5,24,67,69,25]),function(B,e,L,T,k,A,N,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(r){this.value=r}}e.TelemetryTrustedValue=c;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class E{async publicLog(r,o,l){}async publicLogError(r,o,l){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return k.Event.debounce(r.onDidChangeConfiguration,(l,g)=>{const S=l?new Set([...l.affectedKeys,...g.affectedKeys]):g.affectedKeys;return{...g,affectedKeys:S}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=y;function v(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=v;function O(i,r){return!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=O;function R(i){const r=i.getValue(d.TELEMETRY_SETTING_ID),o=i.getValue(d.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(d.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=R;function u(i){const r={},o={},l={};w(i,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const S=l[g];typeof S=="number"?o[g]=S:typeof S=="boolean"?o[g]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${S.length}`),r[g]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(r[g]=S)}return{properties:r,measurements:o}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const r=(0,N.getRemoteName)(i);return f.has(r)?r:"other"}e.cleanRemoteAuthority=p;function w(i,r,o=0,l){if(!!i)for(const g of Object.getOwnPropertyNames(i)){const S=i[g],D=l?l+g:g;Array.isArray(S)?r[D]=(0,L.safeStringify)(S):S instanceof Date?r[D]=S.toISOString():(0,T.isObject)(S)?o<2?w(S,r,o+1,D+"."):r[D]=(0,L.safeStringify)(S):r[D]=S}}function m(i,r){const o=i.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(o)||l}e.isInternalTelemetry=m;function b(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=b;function t(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const l=[];for(const F of r)for(;;){const K=F.exec(i);if(!K)break;l.push([K.index,F.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(o="";;){const F=S.exec(i);if(!F)break;const K=l.some(([Z,_])=>F.index<_&&Z<S.lastIndex);!g.test(F[0])&&!K&&(o+=i.substring(D,F.index)+"<REDACTED: user-file-path>",D=S.lastIndex)}return D<i.length&&(o+=i.substr(D)),o}function a(i){if(!i)return i;const r=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of o)if(l.regex.test(r))return`<REDACTED: ${l.label}>`;return i}function n(i,r){return(0,L.cloneAndChange)(i,o=>{if(o instanceof c)return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=t(l,r);for(const g of r)l=l.replace(g,"");return l=a(l),l}})}e.cleanData=n}),define(te[26],ie([0,1,29,21,32,12,11,9,35,39]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,L.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,r,o)}static parse(i){const r=E.exec(i);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=y;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function O(n){const i=v.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=O;function R(n,i){return`${n}.${i}`}e.getExtensionId=R;function u(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function f(n,i){return u(R(n??k.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=f;function p(n,i){const r=[],o=l=>{for(const g of r)if(g.some(S=>P(i(S),i(l))))return g;return null};for(const l of n){const g=o(l);g?g.push(l):r.push([l])}return r}e.groupByExtension=p;function w(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function m(n){return{id:new c.TelemetryTrustedValue(n.identifier.id),name:new c.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function b(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&r.every(g=>!P(g.identifier,{id:l}))){const g=n.filter(S=>P(S.identifier,{id:l}));g.length===1&&(r.push(g[0]),o.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=b;async function t(n,i){if(!A.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const r=await t(n,i),o=(0,T.getTargetPlatform)(r?"alpine":A.platform,d.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(te[138],ie([0,1,23,9,16,17,41,11,91,21,26,32]),function(B,e,L,T,k,A,N,I,d,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const y=u=>(0,d.localize)(0,null,u),v=(0,d.localize)(1,null,"ms-dotnettools.csharp");function O(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let R=class{constructor(f,p){this.a=f,this.b=p}get d(){}async listExtensions(f,p,w,m=console){let b=await this.a.getInstalled(1,w);const t=E.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(p&&p!==""){if(t.indexOf(p.toLowerCase())<0){m.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}b=b.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){m.log("Possible Categories: "),t.forEach(n=>{m.log(n)});return}this.d&&m.log((0,d.localize)(2,null,this.d)),b=b.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let a;for(const n of b)a!==n.identifier.id&&(a=n.identifier.id,m.log(O(n.manifest,f)))}async installExtensions(f,p,w,m,b=console){const t=[],a=[];f.length&&b.log(this.d?(0,d.localize)(3,null,this.d):(0,d.localize)(4,null));const n=await this.a.getInstalled(1,w.profileLocation),i=(g,S)=>{const D=n.find(F=>(0,P.areSameExtensions)(F.identifier,{id:g}));if(D){if(!m&&(!S||S==="prerelease"&&D.preRelease))return b.log((0,d.localize)(5,null,g,D.manifest.version,g)),!1;if(S&&D.manifest.version===S)return b.log((0,d.localize)(6,null,`${g}@${S}`)),!1}return!0},r=(g,S,D)=>{l.push({id:g,version:S!=="prerelease"?S:void 0,installOptions:{...w,isBuiltin:D,installPreReleaseVersion:S==="prerelease"||w.installPreReleaseVersion}})},o=[],l=[];for(const g of f)if(g instanceof I.URI)o.push({vsix:g,installOptions:w});else{const[S,D]=(0,P.getIdAndVersion)(g);i(S,D)&&r(S,D,!1)}for(const g of p)if(g instanceof I.URI)o.push({vsix:g,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!1}});else{const[S,D]=(0,P.getIdAndVersion)(g);i(S,D)&&r(S,D,!0)}if(o.length&&await Promise.all(o.map(async({vsix:g,installOptions:S})=>{try{const D=await this.f(g,S,m,b);D&&a.push(D)}catch(D){b.error(D.message||D.stack||D),t.push(g.toString())}})),l.length){const g=await this.g(l);await Promise.all(l.map(async S=>{const D=g.get(S.id.toLowerCase());if(D)try{const F=await this.h(S,D,n,m,b);F&&a.push(F)}catch(F){b.error(F.message||F.stack||F),t.push(S.id)}else b.error(`${y(S.version?`${S.id}@${S.version}`:S.id)}
${v}`),t.push(S.id)}))}if(t.length)throw new Error((0,d.localize)(7,null,t.join(", ")))}async f(f,p,w,m){const b=await this.a.getManifest(f);if(!b)throw new Error("Invalid vsix");if(await this.k(b,w,p.profileLocation,m))try{return await this.a.install(f,p),m.log((0,d.localize)(8,null,(0,A.basename)(f))),b}catch(a){if((0,T.isCancellationError)(a))return m.log((0,d.localize)(9,null,(0,A.basename)(f))),null;throw a}return null}async g(f){const p=new Map,w=f.some(t=>t.installOptions.installPreReleaseVersion),m=await this.a.getTargetPlatform(),b=await this.b.getExtensions(f.map(t=>({...t,preRelease:w})),{targetPlatform:m},L.CancellationToken.None);for(const t of b)p.set(t.identifier.id.toLowerCase(),t);return p}async h({id:f,version:p,installOptions:w},m,b,t,a){const n=await this.b.getManifest(m,L.CancellationToken.None);if(n&&!this.j(n,a))return null;const i=b.find(r=>(0,P.areSameExtensions)(r.identifier,m.identifier));if(i){if(m.version===i.manifest.version)return a.log((0,d.localize)(10,null,p?`${f}@${p}`:f)),null;a.log((0,d.localize)(11,null,f,m.version))}try{w.isBuiltin?a.log(p?(0,d.localize)(12,null,f,p):(0,d.localize)(13,null,f)):a.log(p?(0,d.localize)(14,null,f,p):(0,d.localize)(15,null,f));const r=await this.a.installFromGallery(m,{...w,installGivenVersion:!!p});return a.log((0,d.localize)(16,null,f,r.manifest.version)),n}catch(r){if((0,T.isCancellationError)(r))return a.log((0,d.localize)(17,null,f)),null;throw r}}j(f,p){return!0}async k(f,p,w,m){const b={id:(0,P.getGalleryExtensionId)(f.publisher,f.name)},a=(await this.a.getInstalled(1,w)).find(n=>(0,P.areSameExtensions)(b,n.identifier)&&(0,N.gt)(n.manifest.version,f.version));return a&&!p?(m.log((0,d.localize)(18,null,a.identifier.id,a.manifest.version,f.version)),!1):this.j(f,m)}async uninstallExtensions(f,p,w,m=console){const b=async a=>{if(a instanceof I.URI){const n=await this.a.getManifest(a);return O(n)}return a},t=[];for(const a of f){const n=await b(a),r=(await this.a.getInstalled(void 0,w)).filter(o=>(0,P.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.l(n)}
${v}`);if(r.some(o=>o.type===0)){m.log((0,d.localize)(19,null,n));return}if(!p&&r.some(o=>o.isBuiltin)){m.log((0,d.localize)(20,null,n));return}m.log((0,d.localize)(21,null,n));for(const o of r)await this.a.uninstall(o,{profileLocation:w}),t.push(o);this.d?m.log((0,d.localize)(22,null,n,this.d)):m.log((0,d.localize)(23,null,n))}}async locateExtension(f,p=console){const w=await this.a.getInstalled();f.forEach(m=>{w.forEach(b=>{if(b.identifier.id===m&&b.location.scheme===k.Schemas.file){p.log(b.location.fsPath);return}})})}l(f){return this.d?(0,d.localize)(24,null,f,this.d):(0,d.localize)(25,null,f)}};R=ge([ee(0,c.IExtensionManagementService),ee(1,c.IExtensionGalleryService)],R),e.ExtensionManagementCLI=R}),define(te[139],ie([0,1,5,2,36,26,32]),function(B,e,L,T,k,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends T.Disposable{constructor(c,P,E,y,v,O,R){super(),this.f=c,this.g=P,this.h=E,this.i=y,this.j=v,this.k=O,this.l=R,this.a=this.D(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.D(new T.DisposableMap),this.m().then(null,u=>R.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.z()}n(){this.D(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.D(this.i.onAddExtensions(c=>this.q(c))),this.D(this.i.onDidAddExtensions(c=>this.r(c))),this.D(this.i.onRemoveExtensions(c=>this.s(c))),this.D(this.i.onDidRemoveExtensions(c=>this.t(c))),this.D(this.k.onDidFilesChange(c=>this.u(c)))}async p(c,P){try{await Promise.all(P.map(E=>(this.c.deleteAndDispose(E.id),this.y(E.extensionsResource)))),c.length&&await Promise.all(c.map(E=>(this.c.set(E.id,(0,T.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.w(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async q(c){for(const P of c.extensions)this.C(this.G(P.identifier,P.version),c.profileLocation)}async r(c){for(const P of c.extensions){const E=this.G(P.identifier,P.version);c.error?this.F(E,c.profileLocation):this.C(E,c.profileLocation)}}async s(c){for(const P of c.extensions)this.F(this.G(P.identifier,P.version),c.profileLocation)}async t(c){const P=[],E=[];for(const y of c.extensions){const v=this.G(y.identifier,y.version);c.error?this.C(v,c.profileLocation):(this.F(v,c.profileLocation),this.b.has(v)||(this.l.debug("Extension is removed from all profiles",y.identifier.id,y.version),E.push(this.f.scanInstalledExtensionAtLocation(y.location).then(O=>{O?P.push(O):this.l.info("Extension not found at the location",y.location.toString())},O=>this.l.error(O)))))}try{await Promise.all(E),P.length&&await this.z(P)}catch(y){this.l.error(y)}}u(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.v(P.extensionsResource)}async v(c){const P=[],E=[],y=await this.i.scanProfileExtensions(c),v=new Set,O=new Set;for(const[R,u]of this.b)u.has(c)&&O.add(R);for(const R of y){const u=this.G(R.identifier,R.version);v.add(u),O.has(u)||(P.push(R.identifier),this.C(u,c))}for(const R of O)if(!v.has(R)){const u=this.H(R);u&&(E.push(u.identifier),this.F(R,c))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:E.length?{extensions:E,profileLocation:c}:void 0})}async w(c){const P=await this.i.scanProfileExtensions(c);for(const E of P)this.C(this.G(E.identifier,E.version),c)}async y(c){for(const P of[...this.b.keys()])this.F(P,c);await this.z()}async z(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.G(E.identifier,E.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}C(c,P){let E=this.b.get(c);E||this.b.set(c,E=new k.ResourceSet(y=>this.j.extUri.getComparisonKey(y))),E.add(P)}F(c,P){const E=this.b.get(c);E&&E.delete(P),E?.size||this.b.delete(c)}G(c,P){return`${N.ExtensionIdentifier.toKey(c.id)}@${P}`}H(c){const[P,E]=(0,A.getIdAndVersion)(c);return E?{identifier:{id:P},version:E}:void 0}}e.ExtensionsWatcher=I}),define(te[140],ie([0,1,111,39]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(A,N,I,d,c,P,E){const y={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,T.supportsTelemetry)(N,I)&&(0,T.getTelemetryLevel)(d)===3){const v=await(0,L.getServiceMachineId)(I,c,P),{machineId:O}=await E.getTelemetryInfo();y["X-Market-User-Id"]=v,y["VSCode-SessionId"]=O||v}return y}e.resolveMarketplaceHeaders=k}),define(te[141],ie([0,1,169,19,8,2,16,15,20,18,21,26,6,64,11]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let R=class extends v.LanguagePackBaseService{constructor(w,m,b,t){super(b),this.h=w,this.i=t,this.g=this.D(new u(m,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(w,m){const t=(await this.g.getLanguagePacks())[m];if(!t){this.i.warn(`No language pack found for ${m}`);return}const a=t.translations[w];return a?O.URI.file(a):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),m=Object.keys(w).map(b=>{const t=w[b];return{...this.f(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((b,t)=>b.label.localeCompare(t.label)),m}async j(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",w.identifier.id),await this.update())}async k(w){const m=await this.g.getLanguagePacks();Object.keys(m).some(b=>m[b]&&m[b].extensions.some(t=>(0,E.areSameExtensions)(t.extensionIdentifier,w.identifier)))&&(this.i.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),b=await this.g.update(m);return!(0,T.equals)(Object.keys(w),Object.keys(b))}};R=ge([ee(0,P.IExtensionManagementService),ee(1,c.INativeEnvironmentService),ee(2,P.IExtensionGalleryService),ee(3,y.ILogService)],R),e.NativeLanguagePackService=R;let u=class extends A.Disposable{constructor(w,m){super(),this.i=m,this.c={},this.f=(0,I.join)(w.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.m(m=>{Object.keys(m).forEach(b=>delete m[b]),this.j(m,...w)}).then(()=>this.c)}j(w,...m){for(const b of m)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.k(w,b);Object.keys(w).forEach(b=>this.l(w[b]))}k(w,m){const b=m.identifier,t=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of t)if(m.location.scheme===N.Schemas.file&&f(a)){let n=w[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},w[a.languageId]=n);const i=n.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,b))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:b,version:m.manifest.version});for(const r of a.translations)n.translations[r.id]=(0,I.join)(m.location.fsPath,r.path)}}l(w){if(w){const m=(0,L.createHash)("md5");for(const b of w.extensions)m.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);w.hash=m.digest("hex")}}m(w=()=>null){return this.g.queue(()=>{let m=null;return d.Promises.readFile(this.f,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(m=w(b),b)).then(b=>{for(const a of Object.keys(b))b[a]||delete b[a];this.c=b,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),d.Promises.writeFile(this.f,t)}).then(()=>m,b=>this.i.error(b))})}};u=ge([ee(0,c.INativeEnvironmentService),ee(1,y.ILogService)],u);function f(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const w of p.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(te[142],ie([0,1,9,30,39]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function I(c,P,E){const y=await new Promise((f,p)=>{B(["@microsoft/1ds-core-js"],f,p)}),v=await new Promise((f,p)=>{B(["@microsoft/1ds-post-js"],f,p)}),O=new y.AppInsightsCore,R=new v.PostChannel,u={instrumentationKey:c,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[R]]};if(E){u.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:E};u.extensionConfig[R.identifier]=f}return O.initialize(u,[]),O.addTelemetryInitializer(f=>{P&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),O}class d{constructor(P,E,y,v,O){this.e=P,this.f=E,this.g=y,this.h=O,this.c=A,this.d=N,this.g||(this.g={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=I(this.a,this.e,this.h)),this.b.then(E=>{P(E)},E=>{(0,L.onUnexpectedError)(E),console.error(E)})}}log(P,E){if(!this.a)return;E=(0,T.mixin)(E,this.g),E=(0,k.validateTelemetryData)(E);const y=this.f+"/"+P;try{this.i(v=>{v.pluginVersionString=E?.properties.version??"Unknown",v.track({name:y,baseData:{name:y,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(te[143],ie([0,1,2,30,12,29,103,24,42,144,31,37,25,39]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let O=class{constructor(f,p,w){this.k=p,this.l=w,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(y.TELEMETRY_SETTING_ID)||m.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||m.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,p){this.d[f]=p}m(){let f=(0,v.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const w=p.usage?3:p.error?2:0;f=Math.min(f,w)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,p=f.sessionID,w=f["common.machineId"],m=f["common.firstSessionDate"],b=f["common.msftInternal"];return{sessionId:p,machineId:w,firstSessionDate:m,msftInternal:b}}dispose(){this.i.dispose()}n(f,p,w){return this.g<p?Promise.resolve(void 0):this.c.then(m=>{w=(0,T.mixin)(w,this.d),w=(0,v.cleanData)(w,this.j),w=(0,T.mixin)(w,m),this.b.forEach(b=>b.log(f,w))},m=>{console.error(m)})}publicLog(f,p){return this.n(f,3,p)}publicLog2(f,p){return this.publicLog(f,p)}publicLogError(f,p){return this.h?this.n(f,2,p):Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}};O.IDLE_START_EVENT_NAME="UserIdleStart",O.IDLE_STOP_EVENT_NAME="UserIdleStop",O=ge([ee(1,I.IConfigurationService),ee(2,P.IProductService)],O),e.TelemetryService=O;function R(){const u=(0,N.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=k.isWeb?"":(0,N.localize)(3,null),w=(0,N.localize)(4,null),m=(0,N.localize)(5,null),b=(0,N.localize)(6,null),t=(0,N.localize)(7,null),a=`
|       | ${w} | ${m} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,N.localize)(8,null);return`
${u} ${f} ${p}

&nbsp;

${t}
${a}

&nbsp;

${n}
`}E.Registry.as(d.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(d.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[145],ie([0,1,170,142]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends T.AbstractOneDataSystemAppender{constructor(N,I,d,c){const P={sendPOST:(E,y)=>{const v={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const O=L.request(E.urlString,v,R=>{R.on("data",function(u){y(R.statusCode??200,R.headers,u.toString())}),R.on("error",function(u){y(0,{})})});O.write(E.data),O.end()}catch{y(0,{})}}};super(N,I,d,c,P)}}e.OneDataSystemAppender=k}),define(te[146],ie([0,1,15,20]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(A,N){const I=Object.create(null),d=(P,E)=>{const y=JSON.parse(P);I[E]=y};if(N){const P=[],E=await T.Promises.readdir(N);for(const v of E)try{(await T.Promises.stat((0,L.join)(N,v))).isDirectory()&&P.push(v)}catch{}const y=[];for(const v of P)(await T.Promises.readdir((0,L.join)(N,v))).filter(R=>R==="telemetry.json").length===1&&y.push(v);for(const v of y){const O=(await T.Promises.readFile((0,L.join)(N,v,"telemetry.json"))).toString();d(O,v)}}let c=(await T.Promises.readFile((0,L.join)(A,"telemetry-core.json"))).toString();return d(c,"vscode-core"),c=(await T.Promises.readFile((0,L.join)(A,"telemetry-extensions.json"))).toString(),d(c,"vscode-extensions"),JSON.stringify(I,null,4)}e.buildTelemetryMessage=k}),define(te[147],ie([0,1,12,80,25]),function(B,e,L,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(N){let I=N.getItem(k.machineIdKey);return(typeof I!="string"||L.isMacintosh&&I==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(I=await(0,T.getMachineId)()),I}e.resolveMachineId=A}),define(te[27],ie([0,1,10]),function(B,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(te[148],ie([0,1,27,112,13,17,72,5,2]),function(B,e,L,T,k,A,N,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let P=class{constructor(y){this.g=y,this.c=new d.DisposableStore,this.f=2**16;const v=new Map,O=R=>{let u=v.get(R.scheme);return u===void 0&&(u=y.hasProvider(R)&&!this.g.hasCapability(R,1024),v.set(R.scheme,u)),u};this.c.add(I.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(R=>{v.delete(R.scheme)})),this.extUri=new A.ExtUri(O),this.d=new N.SkipList((R,u)=>this.extUri.compare(R,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,A.normalizePath)(y));const v=this.d.get(y);return v?v.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((O,R)=>O[1].time<R[1].time?1:O[1].time>R[1].time?-1:0);c._clock=0,this.d.clear();const v=this.f*.5;for(let O=0;O<v;O++)this.d.set(y[O][0],y[O][1].touch())}};P=ge([ee(0,k.IFileService)],P),e.UriIdentityService=P,(0,T.registerSingleton)(L.IUriIdentityService,P,1)}),define(te[149],ie([0,1,105,15,55,17,11,10,16]),function(B,e,L,T,k,A,N,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function c(i){const r=i;return typeof r?.id=="string"&&N.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=E;function y(i){const r=i;return typeof r?.id=="string"&&N.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=y;function v(i){const r=i;if(r?.uri)return{id:r.id,uri:N.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:N.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=v;var O;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(O=e.WorkbenchState||(e.WorkbenchState={}));function R(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=R;function u(i){const r=i;return!!(r&&typeof r=="object"&&N.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=u;class f{constructor(r,o,l,g,S){this.h=r,this.j=l,this.k=g,this.l=S,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function w(i){return new p({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(i,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function b(i){let r;return N.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=b,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(i,r){return!m(i,r)&&!b(i)}e.isSavedWorkspace=a;function n(i){return(typeof i=="string"?(0,T.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(te[22],ie([0,1,45,5,2,17,11,104,18,13,10,6,149,36,27,8,28,29,3]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&N.URI.isUri(i.location)&&N.URI.isUri(i.globalStorageHome)&&N.URI.isUri(i.settingsResource)&&N.URI.isUri(i.keybindingsResource)&&N.URI.isUri(i.tasksResource)&&N.URI.isUri(i.snippetsHome)&&N.URI.isUri(i.extensionsResource))}e.isUserDataProfile=w,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function m(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:N.URI.revive(n.location).with({scheme:i}),globalStorageHome:N.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:N.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:N.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:N.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:N.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:N.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=m;function b(n,i,r,o){return{id:n,name:i,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:(0,A.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=b;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(i,r,o,l){super(),this.m=i,this.n=r,this.q=o,this.r=l,this.f=!0,this.g=this.D(new T.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new T.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new T.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new T.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new v.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(i){this.f!==i&&(this.s=void 0,this.f=i)}isEnabled(){return this.f}get t(){if(!this.s){const i=[];if(this.f)try{for(const g of this.I()){if(!g.name||!(0,p.isString)(g.name)||!g.location){this.r.warn("Skipping the invalid stored profile",g.location||g.name);continue}i.push(b((0,A.basename)(g.location),g.name,g.location,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}))}}catch(g){this.r.error(g)}const r=new v.ResourceMap,o=new Map,l=this.u();if(i.unshift({...l,extensionsResource:this.N()??l.extensionsResource,isDefault:!0}),i.length)try{const g=this.L();if(g.workspaces)for(const[S,D]of Object.entries(g.workspaces)){const F=N.URI.parse(S),K=i.find(Z=>Z.id===D);K&&r.set(F,K)}if(g.emptyWindows)for(const[S,D]of Object.entries(g.emptyWindows)){const F=i.find(K=>K.id===D);F&&o.set(S,F)}}catch(g){this.r.error(g)}this.s={profiles:i,workspaces:r,emptyWindows:o}}return this.s}u(){return b("__default__profile__",(0,I.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(i){const r="Temp",o=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let l=0;for(const S of this.profiles){const D=o.exec(S.name),F=D?parseInt(D[1]):0;l=F>l?F:l}const g=`${r} ${l+1}`;return this.createProfile((0,L.hash)((0,u.generateUuid)()).toString(16),g,{transient:!0},i)}async createNamedProfile(i,r,o){return this.createProfile((0,L.hash)((0,u.generateUuid)()).toString(16),i,r,o)}async createProfile(i,r,o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.v(i,r,o);return l&&await this.setProfileForWorkspace(l,g),g}async v(i,r,o){if(!(0,p.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let l=this.k.get(r);return l||(l=(async()=>{try{const g=this.profiles.find(F=>F.name===r||F.id===i);if(g)return g;const S=b(i,r,(0,A.joinPath)(this.profilesHome,i),o);await this.n.createFolder(S.location);const D=[];return this.h.fire({profile:S,join(F){D.push(F)}}),await R.Promises.settled(D),this.z([S],[],[]),S}finally{this.k.delete(r)}})(),this.k.set(r,l)),l}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(l=>l.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=b(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.z([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(l=>l.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.i.fire({profile:r,join(l){o.push(l)}});try{await Promise.allSettled(o)}catch(l){this.r.error(l)}for(const l of[...this.t.emptyWindows.keys()])r.id===this.t.emptyWindows.get(l)?.id&&this.t.emptyWindows.delete(l);for(const l of[...this.t.workspaces.keys()])r.id===this.t.workspaces.get(l)?.id&&this.t.workspaces.delete(l);this.G(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(l){this.r.error(l)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(l=>l.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(i,o)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(i,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.q.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.w(i);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.t.workspaces.get(r):this.l.emptyWindows.get(r)??this.t.emptyWindows.get(r)}w(i){return(0,y.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,y.isWorkspaceIdentifier)(i)?i.configPath:i.id}y(i){return!!([...this.l.emptyWindows.values()].some(r=>this.q.extUri.isEqual(r.location,i.location))||[...this.l.workspaces.values()].some(r=>this.q.extUri.isEqual(r.location,i.location))||[...this.t.emptyWindows.values()].some(r=>this.q.extUri.isEqual(r.location,i.location))||[...this.t.workspaces.values()].some(r=>this.q.extUri.isEqual(r.location,i.location)))}z(i,r,o){const l=[...this.profiles,...i],g=[];this.l.profiles=[];for(let S of l)S.isDefault||r.some(D=>S.id===D.id)||(S=o.find(D=>S.id===D.id)??S,S.isTransient?this.l.profiles.push(S):g.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.J(g),this.s=void 0,this.C(i,r,o)}C(i,r,o){this.g.fire({added:i,removed:r,updated:o,all:this.profiles})}F(i,r,o){o=r?.isTransient?!0:o,o||this.F(i,void 0,!0);const l=this.w(i),g=o?this.l:this.t;N.URI.isUri(l)?(g.workspaces.delete(l),r&&g.workspaces.set(l,r)):(g.emptyWindows.delete(l),r&&g.emptyWindows.set(l,r)),o||this.G()}G(){const i={};for(const[o,l]of this.t.workspaces.entries())i[o.toString()]=l.id;const r={};for(const[o,l]of this.t.emptyWindows.entries())r[o.toString()]=l.id;this.M({workspaces:i,emptyWindows:r}),this.s=void 0}H(i){const r={},o=this.u();if(i.workspaces)for(const[g,S]of Object.entries(i.workspaces)){const D=N.URI.parse(S);r[g]=this.q.extUri.isEqual(D,o.location)?o.id:this.q.extUri.basename(D)}const l={};if(i.emptyWindows)for(const[g,S]of Object.entries(i.emptyWindows)){const D=N.URI.parse(S);l[g]=this.q.extUri.isEqual(D,o.location)?o.id:this.q.extUri.basename(D)}return{workspaces:r,emptyWindows:l}}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ge([ee(0,d.IEnvironmentService),ee(1,c.IFileService),ee(2,O.IUriIdentityService),ee(3,E.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=a}),define(te[150],ie([0,1,19,8,23,9,5,2,12,11,89,21,26,32,6,31,25,22]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var p;(function(n){n.Verified="Verified",n.Unverified="Unverified",n.UnknownError="UnknownError"})(p=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let w=class extends I.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,o,l,g){super(),this.s=i,this.t=r,this.u=o,this.v=l,this.w=g,this.h=0,this.j=new Map,this.k=new Map,this.l=this.D(new N.Emitter),this.m=this.D(new N.Emitter),this.n=this.D(new N.Emitter),this.p=this.D(new N.Emitter),this.q=[],this.D((0,I.toDisposable)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.k.forEach(S=>S.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.s.isEnabled())throw new E.ExtensionManagementError(P.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.y(o.manifest,o.extension,r)}catch(o){throw t(this.t,"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(i),error:o}),this.u.error("Failed to install extension.",i.identifier.id),this.u.error(o),b(o)}}async uninstall(i,r={}){return this.u.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.q.push(i)}async y(i,r,o){const l={...o,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,v.isApplicationScopedExtension)(i)?this.w.defaultProfile.extensionsResource:o.profileLocation??this.P()},g=_=>`${y.ExtensionKey.create(_).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const _=this.j.get(g(r));if(_)return this.u.info("Extensions is already requested to install",r.identifier.id),_.task.waitUntilTaskIsFinished()}const S=[],D=[],F=[],K=this.Q(i,r,l);c.URI.isUri(r)||this.j.set(g(r),{task:K,waitingTasks:[]}),this.l.fire({identifier:K.identifier,source:r,profileLocation:l.profileLocation}),this.u.info("Installing extension:",K.identifier.id),S.push({task:K,manifest:i});let Z=!1;try{if(l.donotIncludePackAndDependencies)this.u.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const se=await this.F(K.identifier,i,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),re=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:ce,manifest:fe}of(0,L.distinct)(se,({gallery:ae})=>ae.identifier.id)){Z=Z||!!fe.extensionDependencies?.some(W=>(0,y.areSameExtensions)({id:W},K.identifier));const ae=g(ce),x=this.j.get(ae);if(x){if(this.z(K,x.task)){const W=x.task.identifier;this.u.info("Waiting for already requested installing extension",W.id,K.identifier.id),x.waitingTasks.push(K),D.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,z=>z.some(U=>(0,y.areSameExtensions)(U.identifier,W)))).then(z=>{if(this.u.info("Finished waiting for already requested installing extension",W.id,K.identifier.id),!z.find($=>(0,y.areSameExtensions)($.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!re.some(({identifier:W})=>(0,y.areSameExtensions)(W,ce.identifier))){const W=this.Q(fe,ce,{...l,donotIncludePackAndDependencies:!0});this.j.set(ae,{task:W,waitingTasks:[K]}),this.l.fire({identifier:W.identifier,source:ce,profileLocation:l.profileLocation}),this.u.info("Installing extension:",W.identifier.id,K.identifier.id),S.push({task:W,manifest:fe})}}}catch(se){if(c.URI.isUri(K.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.u.warn("Cannot install dependencies of extension:",K.identifier.id,se.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.u.warn("Cannot install packed extensions of extension:",K.identifier.id,se.message);else throw this.u.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),se}const _=S.reduce((se,{task:re,manifest:ce})=>(se.set(re.identifier.id.toLowerCase(),{task:re,manifest:ce}),se),new Map);for(;_.size;){let se;const re=[..._.values()].filter(({manifest:ce})=>!ce.extensionDependencies?.some(fe=>_.has(fe.toLowerCase())));re.length?se=_.size===1?re:re.filter(({task:ce})=>!(ce===K&&!Z)):(this.u.info("Found extensions with circular dependencies",re.map(({task:ce})=>ce.identifier.id)),se=[..._.values()]),await this.C(se.map(async({task:ce})=>{const fe=new Date().getTime();try{const ae=await ce.run();if(await this.C(this.q.map(x=>x.postInstall(ae,ce.source,l,k.CancellationToken.None))),!c.URI.isUri(ce.source)){const x=ce.operation===3,W=x?void 0:(new Date().getTime()-ce.source.lastUpdated)/1e3;if(t(this.t,x?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(ce.source),verificationStatus:ce.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:W}),d.isWeb&&ce.operation!==3)try{await this.s.reportStatistic(ae.manifest.publisher,ae.manifest.name,ae.manifest.version,"install")}catch{}}F.push({local:ae,identifier:ce.identifier,operation:ce.operation,source:ce.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:ae.isApplicationScoped})}catch(ae){throw c.URI.isUri(ce.source)||t(this.t,ce.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(ce.source),verificationStatus:ce.verificationStatus,duration:new Date().getTime()-fe,error:ae}),this.u.error("Error while installing the extension:",ce.identifier.id),ae}finally{_.delete(ce.identifier.id.toLowerCase())}}))}return D.length&&await this.C(D),F.forEach(({identifier:se})=>this.u.info("Extension installed successfully:",se.id)),this.m.fire(F),F.filter(({identifier:se})=>(0,y.areSameExtensions)(se,K.identifier))[0].local}catch(_){if(S.forEach(({task:se})=>se.cancel()),F.length)try{const se=await Promise.allSettled(F.map(({local:re})=>this.R(re,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let re=0;re<se.length;re++){const ce=se[re],{identifier:fe}=F[re];ce.status==="fulfilled"?this.u.info("Rollback: Uninstalled extension",fe.id):this.u.warn("Rollback: Error while uninstalling extension",fe.id,(0,A.getErrorMessage)(ce.reason))}}catch(se){this.u.warn("Error while rolling back extensions",(0,A.getErrorMessage)(se),F.map(({identifier:re})=>re.id))}throw this.m.fire(S.map(({task:se})=>({identifier:se.identifier,operation:2,source:se.source,context:l.context,profileLocation:l.profileLocation}))),_}finally{for(const{task:_}of S)_.source&&!c.URI.isUri(_.source)&&this.j.delete(g(_.source))}}z(i,r){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(r)||l.some(g=>this.z(g,r)))||o===r&&l[0]&&!this.z(i,l[0]))return!1;return!0}async C(i){const r=[],o=[],l=await Promise.allSettled(i);for(const g of l)g.status==="fulfilled"?r.push(g.value):o.push(g.reason);if(o.length)throw m(o);return r}async F(i,r,o,l,g){if(!this.s.isEnabled())return[];const S=await this.getInstalled(void 0,g),D=[],F=[],K=async(Z,_)=>{D.push(Z);const se=_.extensionDependencies||[],re=[...se];if(_.extensionPack){const ce=o?S.find(fe=>(0,y.areSameExtensions)(fe.identifier,Z)):void 0;for(const fe of _.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(ae=>(0,y.areSameExtensions)({id:ae},{id:fe}))||re.every(ae=>!(0,y.areSameExtensions)({id:ae},{id:fe}))&&re.push(fe)}if(re.length){const ce=re.filter(fe=>D.every(ae=>!(0,y.areSameExtensions)(ae,{id:fe})));if(ce.length){const fe=await this.s.getExtensions(ce.map(ae=>({id:ae,preRelease:l})),k.CancellationToken.None);for(const ae of fe){if(D.find(z=>(0,y.areSameExtensions)(z,ae.identifier)))continue;const x=se.some(z=>(0,y.areSameExtensions)({id:z},ae.identifier));let W;try{W=await this.G(ae,!1,l)}catch(z){if(z instanceof E.ExtensionManagementError&&z.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!x){this.u.info("Skipping the packed extension as it cannot be installed",ae.identifier.id);continue}else throw z}F.push({gallery:W.extension,manifest:W.manifest}),await K(W.extension.identifier,W.manifest)}}}};return await K(i,r),F}async G(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,y.areSameExtensions)(i.identifier,D)))throw new E.ExtensionManagementError(P.localize(1,null,i.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new E.ExtensionManagementError(P.localize(2,null,i.identifier.id,this.v.nameLong,(0,E.TargetPlatformToString)(D)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const g=await this.H(i,r,o);if(g){if(o&&!r&&i.hasPreReleaseVersion&&!g.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(P.localize(3,null,i.identifier.id,this.v.nameLong,this.v.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.s.getExtensions([i.identifier],k.CancellationToken.None))[0]?new E.ExtensionManagementError(P.localize(4,null,i.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(P.localize(5,null,i.identifier.id,this.v.nameLong,this.v.version),E.ExtensionManagementErrorCode.Incompatible);this.u.info("Getting Manifest...",g.identifier.id);const S=await this.s.getManifest(g,k.CancellationToken.None);if(S===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(S.version!==g.version)throw new E.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:g,manifest:S}}async H(i,r,o){const l=await this.getTargetPlatform();let g=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(g=(await this.s.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!g&&await this.s.isExtensionCompatible(i,o,l)&&(g=i),g||(r?g=(await this.s.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:g=await this.s.getCompatibleExtension(i,o,l)),g}async I(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.w.defaultProfile.extensionsResource:r.profileLocation??this.P()},l=Z=>`${Z.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,g=this.k.get(l(i.identifier));if(g)return this.u.info("Extensions is already requested to uninstall",i.identifier.id),g.waitUntilTaskIsFinished();const S=Z=>{const _=this.R(Z,o);return this.k.set(l(_.extension.identifier),_),o.profileLocation?this.u.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,o.profileLocation.toString()):this.u.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this.n.fire({identifier:Z.identifier,profileLocation:o.profileLocation,applicationScoped:Z.isApplicationScoped}),_},D=(Z,_)=>{_?o.profileLocation?this.u.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,o.profileLocation.toString(),_.message):this.u.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,_.message):o.profileLocation?this.u.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,o.profileLocation.toString()):this.u.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),t(this.t,"extensionGallery:uninstall",{extensionData:(0,y.getLocalExtensionTelemetryData)(Z),error:_}),this.p.fire({identifier:Z.identifier,error:_?.code,profileLocation:o.profileLocation,applicationScoped:Z.isApplicationScoped})},F=[],K=[];try{F.push(S(i));const Z=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.u.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const _=this.M(i,Z);for(const se of _)this.k.has(l(se.identifier))?this.u.info("Extensions is already requested to uninstall",se.identifier.id):F.push(S(se))}o.donotCheckDependents?this.u.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(F.map(_=>_.extension),Z,i),await this.C(F.map(async _=>{try{if(await _.run(),await this.C(this.q.map(se=>se.postUninstall(_.extension,o,k.CancellationToken.None))),_.extension.identifier.uuid)try{await this.s.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}D(_.extension)}catch(se){const re=se instanceof E.ExtensionManagementError?se:new E.ExtensionManagementError((0,A.getErrorMessage)(se),E.ExtensionManagementErrorCode.Internal);throw D(_.extension,re),re}finally{K.push(_)}}))}catch(Z){const _=Z instanceof E.ExtensionManagementError?Z:new E.ExtensionManagementError((0,A.getErrorMessage)(Z),E.ExtensionManagementErrorCode.Internal);for(const se of F){try{se.cancel()}catch{}K.includes(se)||D(se.extension,_)}throw _}finally{for(const Z of F)this.k.delete(l(Z.extension.identifier))||this.u.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}J(i,r,o){for(const l of i){const g=this.N(l,r);if(g.length){const S=g.filter(D=>!i.some(F=>(0,y.areSameExtensions)(F.identifier,D.identifier)));if(S.length)throw new Error(this.L(l,S,o))}}}L(i,r,o){return o===i?r.length===1?P.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const g=r.filter(D=>!D.isBuiltin&&l.some(F=>(0,y.areSameExtensions)({id:F},D.identifier))),S=[];for(const D of g)S.push(...this.M(D,r,o));return[...g,...S]}return[]}N(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,y.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.u.trace("ExtensionManagementService.refreshReportedCache");const i=await this.s.getExtensionsControlManifest();return this.u.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.u.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};w=ge([ee(0,E.IExtensionGalleryService),ee(1,u.ITelemetryService),ee(2,O.ILogService),ee(3,R.IProductService),ee(4,f.IUserDataProfilesService)],w),e.AbstractExtensionManagementService=w;function m(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=m;function b(n){if(n instanceof E.ExtensionManagementError)return n;const i=new E.ExtensionManagementError(n.message,E.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:r,verificationStatus:o,duration:l,error:g,durationSinceUpdate:S}){let D,F;g&&(g instanceof E.ExtensionManagementError?(D=g.code,g.code===E.ExtensionManagementErrorCode.Signature&&(F=g.message)):D=E.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:o,success:!g,duration:l,errorcode:D,errorcodeDetail:F,durationSinceUpdate:S})}class a{constructor(){this.d=new T.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,T.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,T.createCancelablePromise)(i=>new Promise((r,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(te[40],ie([0,1,8,14,2,5,36,11,21,26,13,10,6,22,27,3,9,25]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class w extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=w,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let m=class extends k.Disposable{constructor(n,i,r,o,l,g){super(),this.i=n,this.j=i,this.k=r,this.l=o,this.m=l,this.n=g,this.b=this.D(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new N.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const r=[],o=[];try{return await this.p(i,l=>{const g=[];for(const S of l)n.some(([D])=>(0,c.areSameExtensions)(D.identifier,S.identifier)&&D.manifest.version!==S.version)?r.push(S):g.push(S);for(const[S,D]of n)if(!g.some(F=>(0,c.areSameExtensions)(F.identifier,S.identifier)&&F.version===S.manifest.version)){const F={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:D};o.push(F),g.push(F)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),r.length&&this.f.fire({extensions:r,profileLocation:i}),g}),o.length&&this.c.fire({extensions:o,profileLocation:i}),r.length&&this.g.fire({extensions:r,profileLocation:i}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:i}),r.length&&this.g.fire({extensions:r,error:l,profileLocation:i}),l}}async updateMetadata(n,i){const r=[];return await this.p(i,o=>{const l=[];for(const g of o){const S=n.find(([D])=>(0,c.areSameExtensions)(D.identifier,g.identifier)&&D.manifest.version===g.version);S&&(g.metadata={...g.metadata,...S[1]},r.push(g)),l.push(g)}return l}),r}async removeExtensionFromProfile(n,i){const r=[];this.f.fire({extensions:r,profileLocation:i});try{await this.p(i,o=>{const l=[];for(const g of o)(0,c.areSameExtensions)(g.identifier,n.identifier)?r.push(g):l.push(g);return r.length&&this.f.fire({extensions:r,profileLocation:i}),l}),r.length&&this.g.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:i}),o}}async p(n,i,r){return this.v(n).queue(async()=>{let o=[],l;try{const g=await this.j.readFile(n);l=JSON.parse(g.value.toString().trim()||"[]")}catch(g){if((0,P.toFileOperationResult)(g)!==1)throw g;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(l=await this.u()),!l&&r?.bailOutWhenFileNotFound)throw new w((0,u.getErrorMessage)(g),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.q(n);let g=!1;for(const S of l){b(S)||this.q(n);let D;if((0,R.isString)(S.relativeLocation)&&S.relativeLocation)D=this.s(S.relativeLocation);else if((0,R.isString)(S.location))D=this.s(S.location),g=!0,S.relativeLocation=S.location,S.location=D.toJSON();else{D=I.URI.revive(S.location);const F=this.r(D);F&&(g=!0,S.relativeLocation=F)}o.push({identifier:S.identifier,location:D,version:S.version,metadata:S.metadata})}g&&await this.j.writeFile(n,T.VSBuffer.fromString(JSON.stringify(l)))}if(i){o=i(o);const g=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.r(S.location),metadata:S.metadata}));await this.j.writeFile(n,T.VSBuffer.fromString(JSON.stringify(g)))}return o})}q(n){const i=new w(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}r(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}s(n){return this.l.extUri.joinPath(this.i,n)}async u(){return this.t||(this.t=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(n)).value.toString()}catch(l){if((0,P.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",n.toString());let o;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(g=>b(g))?o=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(n)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(i)}catch(l){(0,P.toFileOperationResult)(l)!==1&&this.n.error(l)}return o})()),this.t}v(n){let i=this.h.get(n);return i||(i=new L.Queue,this.h.set(n,i)),i}};m=ge([ee(1,P.IFileService),ee(2,v.IUserDataProfilesService),ee(3,O.IUriIdentityService),ee(4,f.ITelemetryService),ee(5,y.ILogService)],m),e.AbstractExtensionsProfileScannerService=m;function b(a){return(0,R.isObject)(a)&&(0,d.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,R.isString)(a.location)&&a.location)&&((0,R.isUndefined)(a.relativeLocation)||(0,R.isString)(a.relativeLocation))&&a.version&&(0,R.isString)(a.version)}function t(a){return a?(0,R.isString)(a.path)&&(0,R.isString)(a.scheme):!1}}),define(te[48],ie([0,1,19,8,30,14,9,51,78,2,16,15,12,17,41,53,3,11,93,18,26,32,46,13,10,6,31,5,54,40,22,27,110]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w,m,b,t,a,n,i,r,o,l,g,S,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ae){function x(W,z){if(W===z)return!0;const U=Object.keys(W),$=new Set;for(const H of Object.keys(z))$.add(H);if(U.length!==$.size)return!1;for(const H of U){if(W[H]!==z[H])return!1;$.delete(H)}return $.size===0}ae.equals=x})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let Z=class extends c.Disposable{constructor(x,W,z,U,$,H,X,Y,C,s,h,M){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=W,this.l=z,this.m=U,this.n=$,this.p=H,this.q=X,this.r=Y,this.s=C,this.t=s,this.u=h,this.v=M,this.g=this.D(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(re,(0,v.joinPath)(this.m,b.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(re,(0,v.joinPath)(this.m,b.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(se,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,m.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions(x,W,z){const[U,$]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(W)]),H=z?await this.scanExtensionsUnderDevelopment(x,[...U,...$]):[];return this.F(U,$,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const W=[];W.push(this.G(!!x.useCache,x.language)),W.push(this.H(x.language,!!x.checkControlFile));const[z,U]=await Promise.all(W);return this.C([...z,...U],0,x,!1)}async scanUserExtensions(x){const W=x.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",W);const z=this.u.extUri.isEqual(x.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.J(W,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,z),$=x.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let H;try{H=await $.scanExtensions(U)}catch(X){if(X instanceof g.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),H=await $.scanExtensions(U);else throw X}return H=await this.C(H,1,x,!0),this.r.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(x,W){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const z=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter(U=>U.scheme===P.Schemas.file).map(async U=>{const $=await this.J(U,!1,1,!0,x.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions($)).map(X=>(X.type=W.find(Y=>(0,m.areSameExtensions)(Y.identifier,X.identifier))?.type??X.type,this.k.validate(X,$)))}))).flat();return this.C(z,"development",x,!0)}return[]}async scanExistingExtension(x,W,z){const U=await this.J(x,!1,W,!0,z.language,!0,void 0),$=await this.k.scanExtension(U);return!$||!z.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(x,W,z){const U=await this.J(x,!1,W,!0,z.language,!0,void 0),$=await this.k.scanOneOrMultipleExtensions(U);return this.C($,W,z,!0)}async scanMetadata(x){const W=(0,v.joinPath)(x,"package.json"),z=(await this.q.readFile(W)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(x,W){const z=(0,v.joinPath)(x,"package.json"),U=(await this.q.readFile(z)).value.toString(),$=JSON.parse(U);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,$.__metadata={...$.__metadata,...W},await this.q.writeFile((0,v.joinPath)(x,"package.json"),A.VSBuffer.fromString(JSON.stringify($,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof g.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw x}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.p.addExtensionsToProfile(x.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(W){(0,a.toFileOperationResult)(W)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(W))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.r.error(x)}finally{this.y=void 0}})()),this.y}async C(x,W,z,U){return z.includeAllVersions||(x=this.F(W===0?x:void 0,W===1?x:void 0,W==="development"?x:void 0,await this.getTargetPlatform(),U)),z.includeInvalid||(x=x.filter($=>$.isValid)),x.sort(($,H)=>{const X=E.basename($.location.fsPath),Y=E.basename(H.location.fsPath);return X<Y?-1:X>Y?1:0})}F(x,W,z,U,$){const H=(Y,C,s)=>{if(Y.isValid&&!C.isValid)return!1;if(Y.isValid===C.isValid){if($&&O.gt(Y.manifest.version,C.manifest.version))return this.r.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(O.eq(Y.manifest.version,C.manifest.version)){if(Y.type===0)return this.r.debug(`Skipping extension ${C.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===U)return this.r.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return s?this.r.warn(`Overwriting user extension ${Y.location.path} with ${C.location.path}.`):this.r.debug(`Overwriting user extension ${Y.location.path} with ${C.location.path}.`),!0},X=new b.ExtensionIdentifierMap;return x?.forEach(Y=>{const C=X.get(Y.identifier.id);(!C||H(C,Y,!1))&&X.set(Y.identifier.id,Y)}),W?.forEach(Y=>{const C=X.get(Y.identifier.id);if(!C&&x&&Y.type===0){this.r.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!C||H(C,Y,!1))&&X.set(Y.identifier.id,Y)}),z?.forEach(Y=>{const C=X.get(Y.identifier.id);(!C||H(C,Y,!0))&&X.set(Y.identifier.id,Y),X.set(Y.identifier.id,Y)}),[...X.values()]}async G(x,W){this.r.trace("Started scanning system extensions");const z=await this.J(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),$=await(x&&!z.devMode?this.i:this.k).scanExtensions(z);return this.r.trace("Scanned system extensions:",$.length),$}async H(x,W){const z=this.s.isBuilt?[]:this.t.builtInExtensions;if(!z?.length)return[];this.r.trace("Started scanning dev system extensions");const U=W?await this.I():{},$=[],H=f.URI.file(E.normalize(E.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of z){const C=U[Y.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(H,Y.name));break;default:$.push(f.URI.file(C));break}}const X=await Promise.all($.map(async Y=>this.k.scanExtension(await this.J(Y,!1,0,!0,x,!0,void 0))));return this.r.trace("Scanned dev system extensions:",X.length),(0,L.coalesce)(X)}async I(){try{const x=await this.q.readFile(this.l);return JSON.parse(x.value.toString())}catch{return{}}}async J(x,W,z,U,$,H,X){const Y=await this.f($??y.language),C=await this.L(x),s=W&&!this.u.extUri.isEqual(x,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,h=s?await this.L(s):void 0;return new _(x,C,s,h,W,X,z,U,H,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,$,Y)}async L(x){try{const W=await this.q.stat(x);if(typeof W.mtime=="number")return W.mtime}catch{}}};Z=ge([ee(4,S.IUserDataProfilesService),ee(5,g.IExtensionsProfileScannerService),ee(6,a.IFileService),ee(7,i.ILogService),ee(8,w.IEnvironmentService),ee(9,r.IProductService),ee(10,D.IUriIdentityService),ee(11,n.IInstantiationService)],Z),e.AbstractExtensionsScannerService=Z;class _{constructor(x,W,z,U,$,H,X,Y,C,s,h,M,j,G,q){this.location=x,this.mtime=W,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=U,this.profile=$,this.profileScanOptions=H,this.type=X,this.excludeObsolete=Y,this.validate=C,this.productVersion=s,this.productDate=h,this.productCommit=M,this.devMode=j,this.language=G,this.translations=q}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,W){return(0,v.isEqual)(x.location,W.location)&&x.mtime===W.mtime&&(0,v.isEqual)(x.applicationExtensionslocation,W.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&x.profile===W.profile&&k.equals(x.profileScanOptions,W.profileScanOptions)&&x.type===W.type&&x.excludeObsolete===W.excludeObsolete&&x.validate===W.validate&&x.productVersion===W.productVersion&&x.productDate===W.productDate&&x.productCommit===W.productCommit&&x.devMode===W.devMode&&x.language===W.language&&K.equals(x.translations,W.translations)}}e.ExtensionScannerInput=_;let se=class extends c.Disposable{constructor(x,W,z,U,$){super(),this.f=x,this.g=W,this.h=z,this.i=U,this.j=$}async scanExtensions(x){const W=x.profile?await this.l(x):await this.k(x);let z={};if(x.excludeObsolete&&x.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();z=JSON.parse(U)}catch{}return(0,u.isEmptyObject)(z)?W:W.filter(U=>!z[m.ExtensionKey.create(U).toString()])}async k(x){const W=await this.i.resolve(x.location);if(!W.children?.length)return[];const z=await Promise.all(W.children.map(async U=>{if(!U.isDirectory||x.type===1&&(0,v.basename)(U.resource).indexOf(".")===0)return null;const $=new _(U.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension($)}));return(0,L.coalesce)(z).sort((U,$)=>U.location.path<$.location.path?-1:1)}async l(x){let W=await this.m(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){W=W.filter(U=>!U.metadata?.isApplicationScoped);const z=await this.m(x.applicationExtensionslocation,U=>!!U.metadata?.isApplicationScoped,x);W.push(...z)}return W}async m(x,W,z){const U=await this.g.scanProfileExtensions(x,z.profileScanOptions);if(!U.length)return[];const $=await Promise.all(U.map(async H=>{if(W(H)){const X=new _(H.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(X,H.metadata)}return null}));return(0,L.coalesce)($)}async scanOneOrMultipleExtensions(x){try{if(await this.i.exists((0,v.joinPath)(x.location,"package.json"))){const W=await this.scanExtension(x);return W?[W]:[]}else return await this.scanExtensions(x)}catch(W){return this.j.error(`Error scanning extensions at ${x.location.path}:`,(0,N.getErrorMessage)(W)),[]}}async scanExtension(x,W){try{let z=await this.scanExtensionManifest(x.location);if(z){z.publisher||(z.publisher=b.UNDEFINED_PUBLISHER),W=W??z.__metadata,delete z.__metadata;const U=(0,m.getGalleryExtensionId)(z.publisher,z.name),$=W?.id?{id:U,uuid:W.id}:{id:U},H=W?.isSystem?0:x.type,X=H===0||!!W?.isBuiltin;z=await this.n(x.location,z,_.createNlsConfiguration(x));const Y={type:H,identifier:$,manifest:z,location:x.location,isBuiltin:X,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return x.validate?this.validate(Y,x):Y}}catch(z){x.type!==0&&this.j.error(z)}return null}validate(x,W){let z=!0;const U=(0,t.validateExtensionManifest)(W.productVersion,W.productDate,W.location,x.manifest,x.isBuiltin);for(const[$,H]of U)$===R.default.Error&&(z=!1,this.j.error(this.s(W.location,H)));return x.isValid=z,x.validations=U,x}async scanExtensionManifest(x){const W=(0,v.joinPath)(x,"package.json");let z;try{z=(await this.i.readFile(W)).value.toString()}catch($){return(0,a.toFileOperationResult)($)!==1&&this.j.error(this.s(x,(0,p.localize)(0,null,W.path,$.message))),null}let U;try{U=JSON.parse(z)}catch{const H=[];(0,I.parse)(z,H);for(const X of H)this.j.error(this.s(x,(0,p.localize)(1,null,W.path,X.offset,X.length,(0,d.getParseErrorMessage)(X.error))));return null}return(0,I.getNodeType)(U)!=="object"?(this.j.error(this.s(x,(0,p.localize)(2,null,W.path))),null):U}async n(x,W,z){const U=await this.p(x,W,z);if(U)try{const $=[],H=await this.q(U.default,$);if($.length>0)return $.forEach(Y=>{this.j.error(this.s(x,(0,p.localize)(3,null,U.default?.path,(0,d.getParseErrorMessage)(Y.error))))}),W;if((0,I.getNodeType)(U)!=="object")return this.j.error(this.s(x,(0,p.localize)(4,null,U.default?.path))),W;const X=U.values||Object.create(null);return(0,F.localizeManifest)(W,X,H)}catch{}return W}async p(x,W,z){const U=(0,v.joinPath)(x,"package.nls.json"),$=(C,s)=>{s.forEach(h=>{this.j.error(this.s(x,(0,p.localize)(5,null,C?.path,(0,d.getParseErrorMessage)(h.error))))})},H=C=>{this.j.error(this.s(x,(0,p.localize)(6,null,C?.path)))},X=`${W.publisher}.${W.name}`,Y=z.translations[X];if(Y)try{const C=f.URI.file(Y),s=(await this.i.readFile(C)).value.toString(),h=[],M=(0,I.parse)(s,h);return h.length>0?($(C,h),{values:void 0,default:U}):(0,I.getNodeType)(M)!=="object"?(H(C),{values:void 0,default:U}):{values:M.contents?M.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let s;try{s=await this.r(x,z)}catch{return}if(!s.localized)return{values:void 0,default:s.original};try{const h=(await this.i.readFile(s.localized)).value.toString(),M=[],j=(0,I.parse)(h,M);return M.length>0?($(s.localized,M),{values:void 0,default:s.original}):(0,I.getNodeType)(j)!=="object"?(H(s.localized),{values:void 0,default:s.original}):{values:j,default:s.original}}catch{return{values:void 0,default:s.original}}}}async q(x,W){if(x)try{const z=(await this.i.readFile(x)).value.toString();return(0,I.parse)(z,W)}catch{}}r(x,W){return new Promise((z,U)=>{const $=H=>{const X=(0,v.joinPath)(x,`package.nls.${H}.json`);this.i.exists(X).then(Y=>{Y&&z({localized:X,original:(0,v.joinPath)(x,"package.nls.json")});const C=H.lastIndexOf("-");C===-1?z({localized:(0,v.joinPath)(x,"package.nls.json"),original:null}):(H=H.substring(0,C),$(H))})};if(W.devMode||W.pseudo||!W.language)return z({localized:(0,v.joinPath)(x,"package.nls.json"),original:null});$(W.language)})}s(x,W){return`[${x.path}]: ${W}`}};se=ge([ee(1,g.IExtensionsProfileScannerService),ee(2,D.IUriIdentityService),ee(3,a.IFileService),ee(4,i.ILogService)],se);let re=class extends se{constructor(x,W,z,U,$,H){super(W,z,U,$,H),this.w=x,this.u=this.D(new T.ThrottledDelayer(3e3)),this.v=this.D(new o.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions(x){const W=await this.y();if(this.t=x,W&&W.input&&_.equals(W.input,this.t))return this.j.debug("Using cached extensions scan result",x.location.toString()),this.u.trigger(()=>this.C()),W.result.map(U=>(U.location=f.URI.revive(U.location),U));const z=await super.scanExtensions(x);return await this.z({input:x,result:z}),z}async y(){try{const x=await this.i.readFile(this.w),W=JSON.parse(x.value.toString());return{result:W.result,input:(0,l.revive)(W.input)}}catch(x){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,N.getErrorMessage)(x))}return null}async z(x){try{await this.i.writeFile(this.w,A.VSBuffer.fromString(JSON.stringify(x)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,N.getErrorMessage)(W))}}async C(){if(!this.t)return;const x=await this.y();if(!x)return;const W=x.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!k.equals(z,W))try{this.j.info("Invalidating Cache",W,z),await this.i.del(this.w),this.v.fire()}catch(U){this.j.error(U)}}};re=ge([ee(2,g.IExtensionsProfileScannerService),ee(3,D.IUriIdentityService),ee(4,a.IFileService),ee(5,i.ILogService)],re);function ce(ae,x){const W=(0,m.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:W,identifier:new b.ExtensionIdentifier(W),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:x,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.toExtensionDescription=ce;class fe extends Z{constructor(x,W,z,U,$,H,X,Y,C,s,h,M){super(x,W,(0,v.joinPath)(z,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(U,b.MANIFEST_CACHE_FOLDER),$,H,X,Y,C,s,h,M),this.M=(async()=>{if(y.translationsConfigFile)try{const j=await this.q.readFile(f.URI.file(y.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(x){return this.M}}e.NativeExtensionsScannerService=fe}),define(te[151],ie([0,1,58,8,34,5,2,16,15,20,6,22]),function(B,e,L,T,k,A,N,I,d,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends N.Disposable{constructor(O,R){super(),this.b=O,this.f=R,this.a=new T.Limiter(5)}async postUninstall(O){const R=this.g(O,"uninstall");R&&(this.f.info(O.identifier.id,O.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,O),this.f.info("Finished running post uninstall script",O.identifier.id,O.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",O.identifier.id,O.manifest.version),this.f.error(u)}}));try{await c.Promises.rm(this.j(O))}catch(u){this.f.error("Error while removing extension storage path",O.identifier.id),this.f.error(u)}}g(O,R){const u=`vscode:${R}`;if(O.location.scheme===I.Schemas.file&&O.manifest&&O.manifest.scripts&&typeof O.manifest.scripts[u]=="string"){const f=O.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(O.identifier.id,O.manifest.version,`${u} should be a node script`),null):{script:(0,d.join)(O.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(O,R,u,f,p){return new Promise((w,m)=>{const b=this.i(O,R,u,p);let t;const a=n=>{t&&(clearTimeout(t),t=null),n?m(n):w(void 0)};b.on("error",n=>{a((0,k.toErrorMessage)(n)||"Unknown")}),b.on("exit",(n,i)=>{a(n?`post-${R} process exited with code ${n}`:void 0)}),f&&(t=setTimeout(()=>{t=null,b.kill(),m("timed out")},5e3))})}i(O,R,u,f){const p={silent:!0,execArgv:void 0},w=(0,L.fork)(O,[`--type=extension-post-${R}`,...u],p);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const m=A.Event.fromNodeEventEmitter(w.stdout,"data"),b=A.Event.fromNodeEventEmitter(w.stderr,"data");m(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${R}`,n)),b(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${R}`,n));const t=A.Event.any(A.Event.map(m,n=>({data:`%c${n}`,format:[""]})),A.Event.map(b,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),w}j(O){return(0,d.join)(this.b.defaultProfile.globalStorageHome.fsPath,O.identifier.id.toLowerCase())}};y=ge([ee(0,E.IUserDataProfilesService),ee(1,P.ILogService)],y),e.ExtensionsLifecycle=y}),define(te[152],ie([0,1,6,22,27,25,40,13,18,11]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends N.AbstractExtensionsProfileScannerService{constructor(y,v,O,R,u,f){super(c.URI.file(y.extensionsPath),v,O,R,u,f)}};P=ge([ee(0,d.INativeEnvironmentService),ee(1,I.IFileService),ee(2,T.IUserDataProfilesService),ee(3,k.IUriIdentityService),ee(4,A.ITelemetryService),ee(5,L.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(te[153],ie([0,1,11,18,40,48,13,10,6,31,27,22]),function(B,e,L,T,k,A,N,I,d,c,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends A.NativeExtensionsScannerService{constructor(O,R,u,f,p,w,m,b){super(L.URI.file(p.builtinExtensionsPath),L.URI.file(p.extensionsPath),p.userHome,L.URI.file(p.userDataPath),O,R,u,f,p,w,m,b)}};y=ge([ee(0,E.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,N.IFileService),ee(3,d.ILogService),ee(4,T.INativeEnvironmentService),ee(5,c.IProductService),ee(6,P.IUriIdentityService),ee(7,I.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(te[154],ie([0,1,8,5,2,121,3,84,10,22]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var y;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function v(p){const w=p.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=v;class O extends k.Disposable{constructor(w={flushInterval:O.a}){super(),this.j=w,this.b=this.D(new T.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new T.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new T.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new k.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,m){if(m===e.TARGET_KEY){switch(w){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:m,target:this.F(w)[m]})}q(w){this.f.fire({reason:w})}get(w,m,b){return this.L(m)?.get(w,b)}getBoolean(w,m,b){return this.L(m)?.getBoolean(w,b)}getNumber(w,m,b){return this.L(m)?.getNumber(w,b)}store(w,m,b,t){if((0,N.isUndefinedOrNull)(m)){this.remove(w,b);return}this.r(()=>{this.t(w,b,t),this.L(b)?.set(w,m)})}remove(w,m){this.r(()=>{this.t(w,m,void 0),this.L(m)?.delete(w)})}r(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,m){const b=[],t=this.F(w);for(const a of Object.keys(t))t[a]===m&&b.push(a);return b}t(w,m,b){const t=this.F(m);typeof b=="number"?t[w]!==b&&(t[w]=b,this.L(m)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[w]=="number"&&(delete t[w],this.L(m)?.set(e.TARGET_KEY,JSON.stringify(t)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(w){switch(w){case-1:return this.C;case 0:return this.y;default:return this.v}}G(w){const m=this.L(w);return m?v(m):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=P.NONE){this.f.fire({reason:w});const m=this.L(-1),b=this.L(0),t=this.L(1);switch(w){case P.NONE:await L.Promises.settled([m?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([m?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,m=this.L(0)?.items??new Map,b=this.L(1)?.items??new Map;return f(w,m,b,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,m){return this.q(P.NONE),(0,c.isUserDataProfile)(w)?this.N(w,m):this.O(w,m)}H(w,m){return!(w.id===m.id||R(m)&&R(w))}I(w,m,b,t){this.r(()=>{if(t)for(const[a,n]of w)m.set(a,n);else{const a=new Set;for(const[n,i]of w)a.add(n),m.get(n)!==i&&this.n(b,n);for(const[n]of m.items)a.has(n)||this.n(b,n)}})}}O.a=60*1e3,e.AbstractStorageService=O;function R(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=R;class u extends O{constructor(){super(),this.p=this.D(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.D(this.P.onDidChangeStorage(w=>this.n(0,w))),this.D(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.InMemoryStorageService=u;async function f(p,w,m,b,t,a){const n=K=>{try{return JSON.parse(K)}catch{return K}},i=new Map,r=new Map;p.forEach((K,Z)=>{i.set(Z,K),r.set(Z,n(K))});const o=new Map,l=new Map;w.forEach((K,Z)=>{o.set(Z,K),l.set(Z,n(K))});const g=new Map,S=new Map;m.forEach((K,Z)=>{g.set(Z,K),S.set(Z,n(K))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const D=[];if(i.forEach((K,Z)=>{D.push({key:Z,value:K})}),console.table(D),console.groupEnd(),console.log(r),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const K=[];o.forEach((Z,_)=>{K.push({key:_,value:Z})}),console.table(K),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const F=[];g.forEach((K,Z)=>{F.push({key:Z,value:K})}),console.table(F),console.groupEnd(),console.log(S)}e.logStorage=f}),define(te[155],ie([0,1,19,23,9,12,35,3,11,24,18,21,26,46,13,6,31,43,140,154,25]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const b=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,N.arch),t="X-Market-Search-Activity-Id";var a;(function(s){s[s.None=0]="None",s[s.IncludeVersions=1]="IncludeVersions",s[s.IncludeFiles=2]="IncludeFiles",s[s.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",s[s.IncludeSharedAccounts=8]="IncludeSharedAccounts",s[s.IncludeVersionProperties=16]="IncludeVersionProperties",s[s.ExcludeNonValidated=32]="ExcludeNonValidated",s[s.IncludeInstallationTargets=64]="IncludeInstallationTargets",s[s.IncludeAssetUri=128]="IncludeAssetUri",s[s.IncludeStatistics=256]="IncludeStatistics",s[s.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",s[s.Unpublished=4096]="Unpublished",s[s.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function n(...s){return String(s.reduce((h,M)=>h|M,0))}var i;(function(s){s[s.Tag=1]="Tag",s[s.ExtensionId=4]="ExtensionId",s[s.Category=5]="Category",s[s.ExtensionName=7]="ExtensionName",s[s.Target=8]="Target",s[s.Featured=9]="Featured",s[s.SearchText=10]="SearchText",s[s.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class S{constructor(h=g){this.d=h}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(h,M=this.d.pageSize){return new S({...this.d,pageNumber:h,pageSize:M})}withFilter(h,...M){const j=[...this.d.criteria,...M.length?M.map(G=>({filterType:h,value:G})):[{filterType:h}]];return new S({...this.d,criteria:j})}withSortBy(h){return new S({...this.d,sortBy:h})}withSortOrder(h){return new S({...this.d,sortOrder:h})}withFlags(...h){return new S({...this.d,flags:h.reduce((M,j)=>M|j,0)})}withAssetTypes(...h){return new S({...this.d,assetTypes:h})}withSource(h){return new S({...this.d,source:h})}get raw(){const{criteria:h,pageNumber:M,pageSize:j,sortBy:G,sortOrder:q,flags:ne,assetTypes:oe}=this.d;return{filters:[{criteria:h,pageNumber:M,pageSize:j,sortBy:G,sortOrder:q}],assetTypes:oe,flags:ne}}get searchText(){const h=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return h&&h.value?h.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(h=>String(h.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(s,h){const M=(s||[]).filter(j=>j.statisticName===h)[0];return M?M.value:0}function F(s){const h="Microsoft.VisualStudio.Code.Translation.";return s.files.filter(j=>j.assetType.indexOf(h)===0).reduce((j,G)=>{const q=_(s,G.assetType);return q&&j.push([G.assetType.substring(h.length),q]),j},[])}function K(s){if(s.properties){const h=s.properties.filter(G=>G.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=h.filter(G=>M.test(G.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return _(s,r.Repository)}function Z(s){return{uri:`${s.fallbackAssetUri}/${r.VSIX}?redirect=true${s.targetPlatform?`&targetPlatform=${s.targetPlatform}`:""}`,fallbackUri:`${s.fallbackAssetUri}/${r.VSIX}${s.targetPlatform?`?targetPlatform=${s.targetPlatform}`:""}`}}function _(s,h){return s.files.filter(j=>j.assetType===h)[0]?{uri:`${s.assetUri}/${h}${s.targetPlatform?`?targetPlatform=${s.targetPlatform}`:""}`,fallbackUri:`${s.fallbackAssetUri}/${h}${s.targetPlatform?`?targetPlatform=${s.targetPlatform}`:""}`}:null}function se(s,h){const M=s.properties?s.properties.filter(G=>G.key===h):[],j=M.length>0&&M[0].value;return j?j.split(",").map(G=>(0,y.adoptToGalleryExtensionId)(G)):[]}function re(s){const h=s.properties?s.properties.filter(M=>M.key===o.Engine):[];return h.length>0&&h[0].value||""}function ce(s){const h=s.properties?s.properties.filter(M=>M.key===o.PreRelease):[];return h.length>0&&h[0].value==="true"}function fe(s){const h=s.properties?s.properties.filter(j=>j.key===o.LocalizedLanguages):[],M=h.length>0&&h[0].value||"";return M?M.split(","):[]}function ae(s){return s.properties?.find(h=>h.key===o.SponsorLink)?.value}function x(s){return s.indexOf("preview")!==-1}function W(s){return s.targetPlatform?(0,E.toTargetPlatform)(s.targetPlatform):"undefined"}function z(s){const h=(0,L.distinct)(s.versions.map(W)),M=!!s.tags?.includes(E.WEB_EXTENSION_TAG),j=h.indexOf("web");return M?j===-1&&h.push("web"):j!==-1&&h.splice(j,1),h}function U(s,h){const M=(0,E.getFallbackTargetPlarforms)(h);for(let j=0;j<s.length;j++){const G=s[j];if(G.version===s[j-1]?.version){let q=j;const ne=W(G);if(ne===h)for(;q>0&&s[q-1].version===G.version;)q--;else if(M.includes(ne))for(;q>0&&s[q-1].version===G.version&&W(s[q-1])!==h;)q--;q!==j&&(s.splice(j,1),s.splice(q,0,G))}}return s}e.sortExtensionVersions=U;function $(s,h,M){s.telemetryData={index:h,querySource:M,queryActivityId:s.queryContext?.[t]}}function H(s,h,M,j){const G=s.versions[0],q={manifest:_(h,r.Manifest),readme:_(h,r.Details),changelog:_(h,r.Changelog),license:_(h,r.License),repository:K(h),download:Z(h),icon:_(h,r.Icon),signature:_(h,r.Signature),coreTranslations:F(h)};return{identifier:{id:(0,y.getGalleryExtensionId)(s.publisher.publisherName,s.extensionName),uuid:s.extensionId},name:s.extensionName,version:h.version,displayName:s.displayName,publisherId:s.publisher.publisherId,publisher:s.publisher.publisherName,publisherDisplayName:s.publisher.displayName,publisherDomain:s.publisher.domain?{link:s.publisher.domain,verified:!!s.publisher.isDomainVerified}:void 0,publisherSponsorLink:ae(G),description:s.shortDescription||"",installCount:D(s.statistics,"install"),rating:D(s.statistics,"averagerating"),ratingCount:D(s.statistics,"ratingcount"),categories:s.categories||[],tags:s.tags||[],releaseDate:Date.parse(s.releaseDate),lastUpdated:Date.parse(s.lastUpdated),allTargetPlatforms:M,assets:q,properties:{dependencies:se(h,o.Dependency),extensionPack:se(h,o.ExtensionPack),engine:re(h),localizedLanguages:fe(h),targetPlatform:W(h),isPreReleaseVersion:ce(h)},hasPreReleaseVersion:ce(G),hasReleaseVersion:!0,preview:x(s.flags),isSigned:!!q.signature,queryContext:j}}let X=class{constructor(h,M,j,G,q,ne,oe,pe){this.k=M,this.l=j,this.n=G,this.o=q,this.q=ne,this.u=oe,this.w=pe;const me=oe.extensionsGallery,ue=me?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ue?me.servicePPEUrl:me?.serviceUrl,this.g=ue?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,p.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,h,this.o)}x(h=""){return`${this.d}${h}`}isEnabled(){return!!this.d}async getExtensions(h,M,j){const G=T.CancellationToken.isCancellationToken(M)?{}:M,q=T.CancellationToken.isCancellationToken(M)?M:j,ne=[],oe=[],pe=[],me=[];let ue=!0;for(const le of h){le.uuid?oe.push(le.uuid):ne.push(le.id);const ve=!!(le.version||le.preRelease);pe.push({id:le.id,uuid:le.uuid,includePreRelease:ve}),le.version&&me.push({id:le.id,uuid:le.uuid,version:le.version}),ue=ue&&!!le.hasPreRelease&&!ve}if(!oe.length&&!ne.length)return[];let he=new S().withPage(1,h.length);oe.length&&(he=he.withFilter(i.ExtensionId,...oe)),ne.length&&(he=he.withFilter(i.ExtensionName,...ne)),(G.queryAllVersions||ue)&&(he=he.withFlags(he.flags,a.IncludeVersions)),G.source&&(he=he.withSource(G.source));const{extensions:ye}=await this.z(he,{targetPlatform:G.targetPlatform??b,includePreRelease:pe,versions:me,compatible:!!G.compatible},q);return G.source&&ye.forEach((le,ve)=>$(le,ve,G.source)),ye}async getCompatibleExtension(h,M,j){if((0,E.isNotWebExtensionInWebTargetPlatform)(h.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(h,M,j))return h;const G=new S().withFlags(a.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,h.identifier.uuid),{extensions:q}=await this.z(G,{targetPlatform:j,compatible:!0,includePreRelease:M},T.CancellationToken.None);return q[0]||null}async isExtensionCompatible(h,M,j){if(!(0,E.isTargetPlatformCompatible)(h.properties.targetPlatform,h.allTargetPlatforms,j)||!M&&h.properties.isPreReleaseVersion)return!1;let G=h.properties.engine;if(!G){const q=await this.getManifest(h,T.CancellationToken.None);if(!q)throw new Error("Manifest was not found");G=q.engines.vscode}return(0,v.isEngineValid)(G,this.u.version,this.u.date)}async y(h,M,j,G,q){if(!(0,E.isTargetPlatformCompatible)(W(h),G,q)||M!=="any"&&ce(h)!==(M==="prerelease"))return!1;if(j)try{const ne=await this.E(h);if(!(0,v.isEngineValid)(ne,this.u.version,this.u.date))return!1}catch(ne){return this.l.error(`Error while getting the engine for the version ${h.version}.`,(0,k.getErrorMessage)(ne)),!1}return!0}async query(h,M){let j=h.text||"";const G=h.pageSize??50;let q=new S().withPage(1,G);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,he,ye)=>(q=q.withFilter(i.Category,ye||he),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,he,ye)=>(q=q.withFilter(i.Tag,ye||he),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(i.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),q=q.withFilter(i.SearchText,j)),q=q.withSortBy(0)):h.ids?q=q.withFilter(i.ExtensionId,...h.ids):h.names?q=q.withFilter(i.ExtensionName,...h.names):q=q.withSortBy(4),typeof h.sortBy=="number"&&(q=q.withSortBy(h.sortBy)),typeof h.sortOrder=="number"&&(q=q.withSortOrder(h.sortOrder)),h.source&&(q=q.withSource(h.source));const ne=async(ue,he)=>{const{extensions:ye,total:le}=await this.z(ue,{targetPlatform:b,compatible:!1,includePreRelease:!!h.includePreRelease},he);return ye.forEach((ve,Se)=>$(ve,(ue.pageNumber-1)*ue.pageSize+Se,h.source)),{extensions:ye,total:le}},{extensions:oe,total:pe}=await ne(q,M),me=async(ue,he)=>{if(he.isCancellationRequested)throw new k.CancellationError;const{extensions:ye}=await ne(q.withPage(ue+1),he);return ye};return{firstPage:oe,total:pe,pageSize:q.pageSize,getPage:me}}async z(h,M,j){const G=h.flags;!!(h.flags&a.IncludeLatestVersionOnly)&&!!(h.flags&a.IncludeVersions)&&(h=h.withFlags(h.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(h.flags&a.IncludeLatestVersionOnly)&&!(h.flags&a.IncludeVersions)&&(h=h.withFlags(h.flags,a.IncludeLatestVersionOnly)),M.versions?.length&&(h=h.withFlags(h.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),h=h.withFlags(h.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:q,total:ne,context:oe}=await this.B(h,j);if(!(h.flags&a.IncludeLatestVersionOnly)){const he=[];for(const ye of q){const le=await this.A(ye,M,oe);le&&he.push(le)}return{extensions:he,total:ne}}const me=[],ue=new Map;for(let he=0;he<q.length;he++){const ye=q[he],le={id:(0,y.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},ve=(0,I.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Le=>(0,y.areSameExtensions)(Le,le))?.includePreRelease;if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(z(ye),M.targetPlatform))continue;const Se=await this.A(ye,M,oe);!Se||Se.properties.isPreReleaseVersion&&(!ve||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==M.targetPlatform&&Se.hasPreReleaseVersion?ue.set(ye.extensionId,he):me.push([he,Se])}if(ue.size){const he=new Date().getTime(),ye=new S().withFlags(G&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,ue.size).withFilter(i.ExtensionId,...ue.keys()),{extensions:le}=await this.z(ye,M,j);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const ve of le){const Se=ue.get(ve.identifier.uuid);me.push([Se,ve])}}return{extensions:me.sort((he,ye)=>he[0]-ye[0]).map(([,he])=>he),total:ne}}async A(h,M,j){const G={id:(0,y.getGalleryExtensionId)(h.publisher.publisherName,h.extensionName),uuid:h.extensionId},q=M.versions?.find(me=>(0,y.areSameExtensions)(me,G))?.version,ne=(0,I.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(me=>(0,y.areSameExtensions)(me,G))?.includePreRelease,oe=z(h),pe=U(h.versions,M.targetPlatform);if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(oe,M.targetPlatform))return null;for(let me=0;me<pe.length;me++){const ue=pe[me];if(!(q&&ue.version!==q)){if(await this.y(ue,ne?"any":"release",M.compatible,oe,M.targetPlatform))return H(h,ue,oe,j);if(q&&ue.version===q)return null}}return q||M.compatible?null:H(h,h.versions[0],oe)}async B(h,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");h=h.withFlags(h.flags,a.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(a.Unpublished));const j=await this.j,G=JSON.stringify(h.raw),q={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ne=new Date().getTime();let oe,pe,me=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&h.criteria.some(he=>he.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:q},M),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:me};const ue=await(0,f.asJson)(oe);if(ue){const he=ue.results[0],ye=he.extensions,le=he.resultMetadata&&he.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return me=le&&le.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:me,context:{[t]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ue){throw pe=ue,ue}finally{this.o.publicLog2("galleryService:query",{...h.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-ne,success:!!oe&&(0,f.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:pe?(0,k.isCancellationError)(pe)?"canceled":(0,k.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(h,M,j,G){if(!this.isEnabled())return;const q=A.isWeb?this.x(`/itemName/${h}.${M}/version/${j}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${h}/extensions/${M}/${j}/stats?statType=${G}`),ne=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ne};try{await this.k.request({type:"POST",url:q,headers:pe},T.CancellationToken.None)}catch{}}async download(h,M,j){this.l.trace("ExtensionGalleryService#download",h.identifier.id);const G=(0,y.getGalleryExtensionTelemetryData)(h),q=new Date().getTime(),ne=he=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:he}),oe=j===2?"install":j===3?"update":"",pe=oe?{uri:`${h.assets.download.uri}${d.URI.parse(h.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${h.assets.download.fallbackUri}${d.URI.parse(h.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:h.assets.download,me=h.queryContext?.[t]?{[t]:h.queryContext[t]}:void 0,ue=await this.D(pe,me?{headers:me}:void 0);await this.q.writeFile(M,ue.stream),ne(new Date().getTime()-q)}async downloadSignatureArchive(h,M){if(!h.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",h.identifier.id);const j=await this.D(h.assets.signature);await this.q.writeFile(M,j.stream)}async getReadme(h,M){if(h.assets.readme){const j=await this.D(h.assets.readme,{},M);return await(0,f.asTextOrError)(j)||""}return""}async getManifest(h,M){if(h.assets.manifest){const j=await this.D(h.assets.manifest,{},M),G=await(0,f.asTextOrError)(j);return G?JSON.parse(G):null}return null}async C(h,M){const j=_(h,r.Manifest);if(!j)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},q=await this.D(j,{headers:G});return await(0,f.asJson)(q)}async getCoreTranslation(h,M){const j=h.assets.coreTranslations.filter(G=>G[0]===M.toUpperCase())[0];if(j){const G=await this.D(j[1]),q=await(0,f.asTextOrError)(G);return q?JSON.parse(q):null}return null}async getChangelog(h,M){if(h.assets.changelog){const j=await this.D(h.assets.changelog,{},M);return await(0,f.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(h,M,j){let G=new S().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);h.identifier.uuid?G=G.withFilter(i.ExtensionId,h.identifier.uuid):G=G.withFilter(i.ExtensionName,h.identifier.id);const{galleryExtensions:q}=await this.B(G,T.CancellationToken.None);if(!q.length)return[];const ne=z(q[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(ne,j))return[];const oe=[];await Promise.all(q[0].versions.map(async ue=>{try{await this.y(ue,M?"any":"release",!0,ne,j)&&oe.push(ue)}catch{}}));const pe=[],me=new Set;for(const ue of U(oe,j))me.has(ue.version)||(me.add(ue.version),pe.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:ce(ue)}));return pe}async D(h,M={},j=T.CancellationToken.None){const G=await this.j,q={type:"GET"},ne={...G,...M.headers||{}};M={...M,...q,headers:ne};const oe=h.uri,pe=h.fallbackUri,me={...M,url:oe};try{const ue=await this.k.request(me,j);if(ue.res.statusCode===200)return ue;const he=await(0,f.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${he}`)}catch(ue){if((0,k.isCancellationError)(ue))throw ue;const he=(0,k.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:he});const ye={...M,url:pe};return this.k.request(ye,j)}}async E(h){let M=re(h);if(!M){const j=await this.C(h,T.CancellationToken.None);if(!j)throw new Error("Manifest was not found");M=j.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const h=await this.k.request({type:"GET",url:this.h},T.CancellationToken.None);if(h.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,f.asJson)(h),j=[],G={};if(M){for(const q of M.malicious)j.push({id:q});if(M.migrateToPreRelease)for(const[q,ne]of Object.entries(M.migrateToPreRelease))(!ne.engine||(0,v.isEngineValid)(ne.engine,this.u.version,this.u.date))&&(G[q.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[q,ne]of Object.entries(M.deprecated))ne&&(G[q.toLowerCase()]=(0,I.isBoolean)(ne)?{}:ne)}return{malicious:j,deprecated:G}}};X=ge([ee(1,f.IRequestService),ee(2,R.ILogService),ee(3,P.IEnvironmentService),ee(4,m.ITelemetryService),ee(5,O.IFileService),ee(6,u.IProductService),ee(7,c.IConfigurationService)],X);let Y=class extends X{constructor(h,M,j,G,q,ne,oe,pe){super(h,M,j,G,q,ne,oe,pe)}};Y=ge([ee(0,w.IStorageService),ee(1,f.IRequestService),ee(2,R.ILogService),ee(3,P.IEnvironmentService),ee(4,m.ITelemetryService),ee(5,O.IFileService),ee(6,u.IProductService),ee(7,c.IConfigurationService)],Y),e.ExtensionGalleryService=Y;let C=class extends X{constructor(h,M,j,G,q,ne,oe){super(void 0,h,M,j,G,q,ne,oe)}};C=ge([ee(0,f.IRequestService),ee(1,R.ILogService),ee(2,P.IEnvironmentService),ee(3,m.ITelemetryService),ee(4,O.IFileService),ee(5,u.IProductService),ee(6,c.IConfigurationService)],C),e.ExtensionGalleryServiceWithNoStorageService=C}),define(te[156],ie([0,1,11,18,13,6,137,27,22,3,68]),function(B,e,L,T,k,A,N,I,d,c,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let E=class $e extends d.UserDataProfilesService{constructor(R,u,f,p,w){super(f,p,u,w),this.O=R,this.P=f}I(){return this.O.getItem($e.b,[]).map(u=>({...u,location:(0,c.isString)(u.location)?this.q.extUri.joinPath(this.profilesHome,u.location):L.URI.revive(u.location)}))}L(){const R=this.O.getItem($e.c,{});return this.O.getItem($e.a,!1)?R:this.H(R)}N(){return this.q.extUri.joinPath(L.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};E.a="profileAssociationsMigration",E=ge([ee(0,N.IStateReadService),ee(1,I.IUriIdentityService),ee(2,T.INativeEnvironmentService),ee(3,k.IFileService),ee(4,A.ILogService)],E),e.UserDataProfilesReadonlyService=E;let y=class ze extends E{constructor(R,u,f,p,w){super(R,u,f,p,w),this.U=R}J(R){R.length?this.U.setItem(ze.b,R.map(u=>({...u,location:this.q.extUri.basename(u.location)}))):this.U.removeItem(ze.b)}I(){const R=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(R),this.U.setItem("userDataProfilesMigration",!0)),R}M(R){R.emptyWindows||R.workspaces?this.U.setItem(ze.c,R):this.U.removeItem(ze.c)}L(){const R="workspaceAndProfileInfo",u=this.U.getItem(R,void 0);if(u){this.U.removeItem(R);const p=u.reduce((w,{workspace:m,profile:b})=>(w[L.URI.revive(m).toString()]=L.URI.revive(b).toString(),w),{});this.U.setItem(ze.c,{workspaces:p})}const f=super.L();return this.U.getItem(ze.a,!1)||(this.M(f),this.U.setItem(ze.a,!0)),f}};y=ge([ee(0,N.IStateService),ee(1,I.IUriIdentityService),ee(2,T.INativeEnvironmentService),ee(3,k.IFileService),ee(4,A.ILogService)],y),e.UserDataProfilesService=y;let v=class extends y{constructor(R,u,f,p){super(new P.StateService(0,u,p,f),R,u,f,p)}async init(){return await this.U.init(),super.init()}};v=ge([ee(0,I.IUriIdentityService),ee(1,T.INativeEnvironmentService),ee(2,k.IFileService),ee(3,A.ILogService)],v),e.ServerUserDataProfilesService=v}),define(te[49],ie([0,1,123,8,15,3,20,85,171,172]),function(B,e,L,T,k,A,N,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.ExtractError=E;function y(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function v(t){if(t instanceof E)return t;let a;return P.test(t.message)&&(a="CorruptZip"),new E(a,t)}function O(t,a,n,i,r,o){const l=k.dirname(a),g=k.join(i,l);if(!g.startsWith(i))return Promise.reject(new Error(I.localize(0,null,a)));const S=k.join(i,a);let D;return o.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(N.Promises.mkdir(g,{recursive:!0})).then(()=>new Promise((F,K)=>{if(!o.isCancellationRequested)try{D=(0,L.createWriteStream)(S,{mode:n}),D.once("close",()=>F()),D.once("error",K),t.once("error",K),t.pipe(D)}catch(Z){K(Z)}}))}function R(t,a,n,i){let r=(0,T.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((l,g)=>{const S=new T.Sequencer,D=F=>{F.isCancellationRequested||(o++,t.readEntry())};t.once("error",g),t.once("close",()=>r.then(()=>{i.isCancellationRequested||t.entryCount===o?l():g(new E("Incomplete",new Error(I.localize(1,null,o,t.entryCount))))},g)),t.readEntry(),t.on("entry",F=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(F.fileName)){D(i);return}const K=F.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(K)){const se=k.join(a,K);r=(0,T.createCancelablePromise)(re=>N.Promises.mkdir(se,{recursive:!0}).then(()=>D(re)).then(void 0,g));return}const Z=f(t,F),_=y(F);r=(0,T.createCancelablePromise)(se=>S.queue(()=>Z.then(re=>O(re,K,_,a,n,se).then(()=>D(se)))).then(null,g))})})}function u(t,a=!1){return new Promise((n,i)=>{(0,d.open)(t,a?{lazyEntries:!0}:void 0,(r,o)=>{r?i(v(r)):n((0,A.assertIsDefined)(o))})})}function f(t,a){return new Promise((n,i)=>{t.openReadStream(a,(r,o)=>{r?i(v(r)):n((0,A.assertIsDefined)(o))})})}function p(t,a){return new Promise((n,i)=>{const r=new c.ZipFile;a.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const o=(0,L.createWriteStream)(t);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(t))})}e.zip=p;function w(t,a,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=u(t,!0);return n.overwrite&&(o=o.then(l=>N.Promises.rm(a).then(()=>l))),o.then(l=>R(l,a,{sourcePathRegex:r},i))}e.extract=w;function m(t,a){return u(t).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===a&&f(n,o).then(l=>i(l),l=>r(l))}),n.once("close",()=>r(new Error(I.localize(2,null,a))))}))}function b(t,a){return m(t,a).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",l=>o.push(l)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=b}),define(te[157],ie([0,1,8,9,2,16,12,17,41,3,28,20,49,24,18,21,26,60,13,6]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let m=class qe extends k.Disposable{constructor(t,a,n,i,r,o){super(),this.h=a,this.i=n,this.j=i,this.k=r,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,a){await this.g;const n=(0,I.joinPath)(this.extensionsDownloadDir,this.u(t));try{await this.q(t,n,r=>this.i.download(t,r,a))}catch(r){throw new R.ExtensionManagementError(r.message,R.ExtensionManagementErrorCode.Download)}let i="Unverified";if(this.m(t)){const r=await this.n(t);try{await this.k.verify(n.fsPath,r.fsPath,this.l.getLevel()===w.LogLevel.Trace)&&(i="Verified"),this.l.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${i}.`)}catch(o){const l=o,g=l.code;if(l.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${l.output}`),g==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${i}.`);else{if(g==="PackageIsInvalidZip"||g==="SignatureArchiveIsInvalidZip")throw new R.ExtensionManagementError(y.CorruptZipMessage,R.ExtensionManagementErrorCode.CorruptZip);if(!l.didExecute)this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${i} (${g})`);else throw await this.delete(n),new R.ExtensionManagementError(g,R.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(r)}catch(o){this.l.error(o)}}}return{location:n,verificationStatus:i}}m(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(a)?a:!0}async n(t){await this.g;const a=(0,I.joinPath)(this.extensionsDownloadDir,`${this.u(t)}${qe.c}`);return await this.q(t,a,n=>this.i.downloadSignatureArchive(t,n)),a}async q(t,a,n){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await n(a);return}const i=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await n(i);try{await this.r(i,a,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(i)}catch{}if(r.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.l.info(`Rename failed because of ${(0,T.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(t){await this.g,await this.h.del(t)}async r(t,a,n){try{await E.Promises.rename(t.fsPath,a.fsPath)}catch(i){if(N.isWindows&&i&&i.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.r(t,a,n);throw i}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],n=[],i=[];for(const l of t.children)if(l.name.endsWith(qe.c))i.push(l.resource);else{const g=u.ExtensionKey.parse(l.name);g&&n.push([g,l])}const r=(0,u.groupByExtension)(n,([l])=>l),o=[];for(const l of r)l.sort((g,S)=>d.rcompare(g[0].version,S[0].version)),a.push(...l.slice(1).map(g=>g[1].resource)),o.push(l[0][1]);o.sort((l,g)=>l.mtime-g.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),a.push(...i),await L.Promises.settled(a.map(l=>(this.l.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.l.error(t)}}u(t){return this.f?u.ExtensionKey.create(t).toString().toLowerCase():(0,P.generateUuid)()}};m.c=".sigzip",m=ge([ee(0,O.INativeEnvironmentService),ee(1,p.IFileService),ee(2,R.IExtensionGalleryService),ee(3,v.IConfigurationService),ee(4,f.IExtensionSignatureVerificationService),ee(5,w.ILogService)],m),e.ExtensionsDownloader=m}),define(te[158],ie([0,1,49,95]),function(B,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(A){return(0,L.buffer)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.getManifest=k}),define(te[159],ie([0,1,8,14,23,34,9,5,2,36,16,15,12,17,41,3,11,28,20,49,94,59,18,150,21,26,40,48,157,151,158,132,139,32,46,13,10,6,31,25,27,22]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w,m,b,t,a,n,i,r,o,l,g,S,D,F,K,Z,_,se,re,ce,fe,ae,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,se.refineServiceDecorator)(n.IExtensionManagementService);let W=class extends a.AbstractExtensionManagementService{constructor(C,s,h,M,j,G,q,ne,oe,pe,me,ue){super(C,s,h,pe,ue),this.Z=j,this.ab=G,this.bb=q,this.cb=oe,this.db=me,this.X=this.D(new I.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new c.ResourceSet;const he=this.D(ne.createInstance(g.ExtensionsLifecycle));this.S=this.D(ne.createInstance(z,le=>he.postUninstall(le))),this.U=this.D(new D.ExtensionsManifestCache(M,this)),this.W=this.D(ne.createInstance(l.ExtensionsDownloader));const ye=this.D(new F.ExtensionsWatcher(this,this.Z,ue,G,me,oe,h));this.D(ye.onDidChangeExtensionsByAnotherSource(le=>this.kb(le))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.u)),this.eb}async zip(C){this.u.trace("ExtensionManagementService#zip",C.identifier.id);const s=await this.jb(C),h=await(0,w.zip)((0,v.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,s);return u.URI.file(h)}async unzip(C){return this.u.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:s,cleanup:h}=await this.fb(C),M=E.resolve(s.fsPath);try{return await(0,S.getManifest)(M)}finally{await h()}}getInstalled(C,s=this.w.defaultProfile.extensionsResource){return this.S.scanExtensions(C??null,s)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.S.scanUserExtensionAtLocation(C)}async install(C,s={}){this.u.trace("ExtensionManagementService#install",C.toString());const{location:h,cleanup:M}=await this.fb(C);try{const j=await(0,S.getManifest)(E.resolve(h.fsPath));if(j.engines&&j.engines.vscode&&!(0,Z.isEngineValid)(j.engines.vscode,this.v.version,this.v.date))throw new Error(m.localize(0,null,(0,i.getGalleryExtensionId)(j.publisher,j.name),this.v.version));return await this.y(j,h,s)}finally{await M()}}async installFromLocation(C,s){this.u.trace("ExtensionManagementService#installFromLocation",C.toString());const h=await this.S.scanUserExtensionAtLocation(C);if(!h)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ob([[h,void 0]],s),this.u.info("Successfully installed extension",h.identifier.id,s.toString()),h}async installExtensionsFromProfile(C,s,h){this.u.trace("ExtensionManagementService#installExtensionsFromProfile",C,s.toString(),h.toString());const M=(await this.S.scanExtensions(1,s)).filter(j=>C.some(G=>(0,i.areSameExtensions)(G,j.identifier)));if(M.length){const j=await Promise.all(M.map(G=>this.S.scanMetadata(G,s)));await this.ob(M.map((G,q)=>[G,j[q]]),h),this.u.info("Successfully installed extensions",M.map(G=>G.identifier.id),h.toString())}return M}async updateMetadata(C,s,h=this.w.defaultProfile.extensionsResource){return this.u.trace("ExtensionManagementService#updateMetadata",C.identifier.id),s.isPreReleaseVersion&&(s.preRelease=!0),s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.pinned=s.pinned||void 0,C=await this.S.updateMetadata(C,s,h),this.U.invalidate(),this.X.fire(C),C}async reinstallFromGallery(C){if(this.u.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.s.isEnabled())throw new Error(m.localize(1,null));const s=await this.getTargetPlatform(),[h]=await this.s.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:s,compatible:!0},k.CancellationToken.None);if(!h)throw new Error(m.localize(2,null));await this.S.setUninstalled(C);try{await this.S.removeUninstalledExtension(C)}catch(M){throw new Error(m.localize(3,null,(0,A.toErrorMessage)(M)))}return this.installFromGallery(h)}copyExtensions(C,s){return this.S.copyExtensions(C,s)}markAsUninstalled(...C){return this.S.setUninstalled(...C)}async cleanUp(){this.u.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(C){this.u.error(C)}}async download(C,s){const{location:h}=await this.W.download(C,s);return h}async fb(C){if(C.scheme===P.Schemas.file)return{location:C,async cleanup(){}};this.u.trace("Downloading extension from",C.toString());const s=(0,v.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(C,s),this.u.info("Downloaded extension to",s.toString()),{location:s,cleanup:async()=>{try{await this.cb.del(s)}catch(M){this.u.error(M)}}}}P(){return this.w.defaultProfile.extensionsResource}Q(C,s,h){if(u.URI.isUri(s))return new H(C,s,h,this.s,this.S,this.db,this.w,this.Z,this.ab,this.u);const M=i.ExtensionKey.create(s).toString();let j=this.Y.get(M);return j||(this.Y.set(M,j=new $(C,s,h,this.W,this.S,this.db,this.w,this.Z,this.ab,this.u)),j.waitUntilTaskIsFinished().then(()=>this.Y.delete(M))),j}R(C,s){return new X(C,s.profileLocation,this.ab)}async jb(C){const s=async M=>{let j=await p.Promises.readdir(M);j=j.map(ne=>E.join(M,ne));const G=await Promise.all(j.map(ne=>p.Promises.stat(ne)));let q=Promise.resolve([]);return G.forEach((ne,oe)=>{const pe=j[oe];ne.isFile()&&(q=q.then(me=>[...me,pe])),ne.isDirectory()&&(q=q.then(me=>s(pe).then(ue=>[...me,...ue])))}),q};return(await s(C.location.fsPath)).map(M=>({path:`extension/${E.relative(C.location.fsPath,M)}`,localPath:M}))}async kb({added:C,removed:s}){if(s)for(const h of s.extensions)this.u.info("Extensions removed from another source",h.id,s.profileLocation.toString()),this.p.fire({identifier:h,profileLocation:s.profileLocation});if(C){const M=(await this.S.scanExtensions(1,C.profileLocation)).filter(j=>C.extensions.some(G=>(0,i.areSameExtensions)(G,j.identifier)));this.m.fire(M.map(j=>(this.u.info("Extensions added from another source",j.identifier.id,C.profileLocation.toString()),{identifier:j.identifier,local:j,profileLocation:C.profileLocation,operation:1})))}}async mb(){this.D(this.S.onExtract(s=>this.lb.add(s)));const C=await this.cb.resolve(this.Z.userExtensionsLocation);for(const s of C.children??[])s.isDirectory&&this.lb.add(s.resource);this.D(this.cb.watch(this.Z.userExtensionsLocation)),this.D(this.cb.onDidFilesChange(s=>this.nb(s)))}async nb(C){if(!C.affects(this.Z.userExtensionsLocation,1))return;const s=[];for(const h of C.rawAdded){if(this.lb.has(h)||!this.db.extUri.isEqual(this.db.extUri.dirname(h),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(h,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(h).startsWith(".")||!(await this.cb.stat(h)).isDirectory)continue;const M=await this.S.scanUserExtensionAtLocation(h);M&&M.installedTimestamp===void 0&&(this.lb.add(h),s.push(M))}s.length&&(await this.ob(s.map(h=>[h,void 0]),this.w.defaultProfile.extensionsResource),this.u.info("Added extensions to default profile from external source",s.map(h=>h.identifier.id)))}async ob(C,s){const h=C.map(M=>M[0]);await this.pb(h),await this.ab.addExtensionsToProfile(C,s),this.m.fire(h.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:s})))}async pb(C){const s=await this.S.getUninstalledExtensions();for(const h of C){const M=i.ExtensionKey.create(h);!s[M.toString()]||(this.u.trace("Removing the extension from uninstalled list:",M.id),await this.S.setInstalled(M),this.u.info("Removed the extension from uninstalled list:",M.id))}}};W=ge([ee(0,n.IExtensionGalleryService),ee(1,fe.ITelemetryService),ee(2,re.ILogService),ee(3,t.INativeEnvironmentService),ee(4,o.IExtensionsScannerService),ee(5,r.IExtensionsProfileScannerService),ee(6,b.IDownloadService),ee(7,se.IInstantiationService),ee(8,_.IFileService),ee(9,ce.IProductService),ee(10,ae.IUriIdentityService),ee(11,x.IUserDataProfilesService)],W),e.ExtensionManagementService=W;let z=class extends d.Disposable{constructor(C,s,h,M,j,G){super(),this.k=C,this.l=s,this.m=h,this.n=M,this.p=j,this.q=G,this.h=this.D(new I.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,v.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new L.Queue}async cleanUp(){await this.y(),this.j=this.j.then(()=>this.z()),await this.j}async scanExtensions(C,s){const h={includeInvalid:!0,profileLocation:s};let M=[];return C===null||C===0?M.push(...await this.m.scanAllExtensions({includeInvalid:!0},h,!1)):C===1&&M.push(...await this.m.scanUserExtensions(h)),M=C!==null?M.filter(j=>j.type===C):M,Promise.all(M.map(j=>this.w(j)))}async scanAllUserExtensions(C){const s=await this.m.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(s.map(h=>this.w(h)))}async scanUserExtensionAtLocation(C){try{const s=await this.m.scanExistingExtension(C,1,{includeInvalid:!0});if(s)return await this.w(s)}catch(s){this.q.error(s)}return null}async extractUserExtension(C,s,h,M){await this.j.catch(()=>{});const j=C.toString(),G=E.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),q=E.join(this.m.userExtensionsLocation.fsPath,j);try{await p.Promises.rm(q)}catch{throw new n.ExtensionManagementError(m.localize(4,null,q,C.id),n.ExtensionManagementErrorCode.Delete)}await this.t(C,s,G,M),await this.m.updateMetadata(u.URI.file(G),h);try{this.h.fire(u.URI.file(q)),await this.u(C,G,q,Date.now()+2*60*1e3),this.q.info("Renamed to",q)}catch(ne){try{await p.Promises.rm(G)}catch{}if(ne.code==="ENOTEMPTY")this.q.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.q.info(`Rename failed because of ${(0,N.getErrorMessage)(ne)}. Deleted from extracted location`,G),ne}return this.v(u.URI.file(q),1)}async scanMetadata(C,s){return s?(await this.n.scanProfileExtensions(s)).find(M=>(0,i.areSameExtensions)(M.identifier,C.identifier))?.metadata:this.m.scanMetadata(C.location)}async updateMetadata(C,s,h){return h?await this.n.updateMetadata([[C,s]],h):await this.m.updateMetadata(C.location,s),this.v(C.location,C.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...C){const s=C.map(h=>i.ExtensionKey.create(h));await this.s(h=>s.forEach(M=>{h[M.toString()]=!0,this.q.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(C){await this.s(s=>delete s[C.toString()])}async removeExtension(C,s){this.q.trace(`Deleting ${s} extension from disk`,C.identifier.id,C.location.fsPath);const h=this.p.extUri.joinPath(this.p.extUri.dirname(C.location),`.${(0,f.generateUuid)()}`);await this.u(C.identifier,C.location.fsPath,h.fsPath,Date.now()+2*60*1e3),await this.l.del(h,{recursive:!0}),this.q.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.s(s=>delete s[i.ExtensionKey.create(C).toString()])}async copyExtensions(C,s){const h=await this.scanExtensions(1,C),M=await Promise.all(h.filter(j=>!j.isApplicationScoped).map(async j=>[j,await this.scanMetadata(j,C)]));await this.n.addExtensionsToProfile(M,s)}async s(C){return this.g.queue(async()=>{let s;try{s=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,_.toFileOperationResult)(M)!==1)throw M}let h={};if(s)try{h=JSON.parse(s)}catch{}return C&&(C(h),Object.keys(h).length?await this.l.writeFile(this.c,T.VSBuffer.fromString(JSON.stringify(h))):await this.l.del(this.c)),h})}async t(C,s,h,M){this.q.trace(`Started extracting the extension from ${s} to ${h}`);try{await p.Promises.rm(h)}catch(j){throw new n.ExtensionManagementError(this.C(j).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(s,h,{sourcePath:"extension",overwrite:!0},M),this.q.info(`Extracted extension to ${h}:`,C.id)}catch(j){try{await p.Promises.rm(h)}catch{}let G=n.ExtensionManagementErrorCode.Extract;throw j instanceof w.ExtractError&&(j.type==="CorruptZip"?G=n.ExtensionManagementErrorCode.CorruptZip:j.type==="Incomplete"&&(G=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(j.message,G)}}async u(C,s,h,M){try{await p.Promises.rename(s,h)}catch(j){if(y.isWindows&&j&&j.code==="EPERM"&&Date.now()<M)return this.q.info(`Failed renaming ${s} to ${h} with 'EPERM' error. Trying again...`,C.id),this.u(C,s,h,M);throw new n.ExtensionManagementError(j.message||m.localize(5,null,s,h),j.code||n.ExtensionManagementErrorCode.Rename)}}async v(C,s){const h=await this.m.scanExistingExtension(C,s,{includeInvalid:!0});if(h)return this.w(h);throw new Error(m.localize(6,null,C.path))}async w(C){const s=await this.l.resolve(C.location);let h,M;return s.children&&(h=s.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,M=s.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:h,changelogUrl:M,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async y(){const C=await this.getUninstalledExtensions();this.q.debug("Removing uninstalled extensions:",Object.keys(C));const s=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),h=new Set;for(const j of s)C[i.ExtensionKey.create(j).toString()]||h.add(j.identifier.id.toLowerCase());try{const j=(0,i.groupByExtension)(s,G=>G.identifier);await L.Promises.settled(j.map(async G=>{const q=G.sort((ne,oe)=>O.rcompare(ne.manifest.version,oe.manifest.version))[0];h.has(q.identifier.id.toLowerCase())||await this.k(await this.w(q))}))}catch(j){this.q.error(j)}const M=s.filter(j=>j.metadata&&C[i.ExtensionKey.create(j).toString()]);await Promise.allSettled(M.map(j=>this.removeUninstalledExtension(j)))}async z(){this.q.trace("ExtensionManagementService#removeGeneratedFolders");const C=[];let s;try{s=await this.l.resolve(this.m.userExtensionsLocation)}catch(h){(0,_.toFileOperationResult)(h)!==1&&this.q.error(h)}for(const h of s?.children??[])h.isDirectory&&h.name.startsWith(".")&&(0,f.isUUID)(h.name.substring(1))&&C.push((async()=>{this.q.trace("Deleting the generated extension folder",h.resource.toString());try{await this.l.del(h.resource,{recursive:!0}),this.q.info("Deleted the generated extension folder",h.resource.toString())}catch(M){this.q.error(M)}})());await Promise.allSettled(C)}C(C){const s=Array.isArray(C)?C:[C];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((h,M)=>new Error(`${h.message}${h.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};z=ge([ee(1,_.IFileService),ee(2,o.IExtensionsScannerService),ee(3,r.IExtensionsProfileScannerService),ee(4,ae.IUriIdentityService),ee(5,re.ILogService)],z),e.ExtensionsScanner=z;class U extends a.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,R.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(C,s,h,M,j,G,q,ne,oe){super(),this.identifier=C,this.source=s,this.l=h,this.m=M,this.n=j,this.o=G,this.p=q,this.q=ne,this.s=oe,this.j="Unverified",this.k=2}async h(C){const[s,h]=await this.x(C);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[s,h]],this.l.profileLocation),s}async u({zipPath:C,key:s,metadata:h},M){let j=await this.v(s);return j||(this.s.trace("Extracting extension...",s.id),j=await this.m.extractUserExtension(s,C,h,M),this.s.info("Extracting extension completed.",s.id)),j}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(M=>i.ExtensionKey.create(M).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class $ extends U{constructor(C,s,h,M,j,G,q,ne,oe,pe){super(s.identifier,s,h,j,G,q,ne,oe,pe),this.y=C,this.z=s,this.A=M}async x(C){const h=(await this.m.scanExtensions(null,this.l.profileLocation)).find(q=>(0,i.areSameExtensions)(q.identifier,this.z.identifier));h&&(this.k=3);const M={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,K.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||h?.isMachineScoped,isBuiltin:this.l.isBuiltin||h?.isBuiltin,isSystem:h?.type===0?!0:void 0,updated:!!h,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,R.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:h?.preRelease)};if(h?.manifest.version===this.z.version)return[await this.m.updateMetadata(h,M),M];const{location:j,verificationStatus:G}=await this.A.download(this.z,this.k);try{return this.j=G,this.C(j.fsPath),[await this.u({zipPath:j.fsPath,key:i.ExtensionKey.create(this.z),metadata:M},C),M]}catch(q){try{await this.A.delete(j)}catch(ne){this.s.warn("Error while deleting the downloaded file",j.toString(),(0,N.getErrorMessage)(ne))}throw q}}async C(C){try{await(0,S.getManifest)(C)}catch(s){throw new n.ExtensionManagementError((0,a.joinErrors)(s).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=$;class H extends U{constructor(C,s,h,M,j,G,q,ne,oe,pe){super({id:(0,i.getGalleryExtensionId)(C.publisher,C.name)},s,h,j,G,q,ne,oe,pe),this.y=C,this.z=s,this.A=M}async h(C){const s=await super.h(C);return this.D(s,C),s}async x(C){const s=new i.ExtensionKey(this.identifier,this.y.version),M=(await this.m.scanExtensions(1,this.l.profileLocation)).find(q=>(0,i.areSameExtensions)(this.identifier,q.identifier)),j={isApplicationScoped:(0,K.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||M?.isMachineScoped,isBuiltin:this.l.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0};if(M)if(this.k=3,s.equals(new i.ExtensionKey(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&O.gt(M.manifest.version,this.y.version)&&await this.m.setUninstalled(M);else{const q=await this.v(s);if(q)try{await this.m.removeExtension(q,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:E.resolve(this.z.fsPath),key:s,metadata:j},C),j]}async D(C,s){try{let[h]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],s);if(h||([h]=await this.A.getExtensions([{id:C.identifier.id}],s)),h){const M={id:h.identifier.uuid,publisherDisplayName:h.publisherDisplayName,publisherId:h.publisherId,isPreReleaseVersion:h.properties.isPreReleaseVersion,preRelease:h.properties.isPreReleaseVersion||this.l.installPreReleaseVersion};await this.m.updateMetadata(C,M,this.l.profileLocation)}}catch{}}}class X extends a.AbstractExtensionTask{constructor(C,s,h){super(),this.extension=C,this.j=s,this.k=h}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[160],ie([0,1,135,8,14,9,3,24,18,136,6,43,134,173]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let O=class extends E.AbstractRequestService{constructor(u,f,p,w){super(!!f.isRemoteServer,w),this.j=u,this.k=f,this.l=p,this.m(),this.D(u.onDidChangeConfiguration(m=>{m.affectsConfiguration("http")&&this.m()}))}m(){const u=this.j.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,f){const{f:p,g:w}=this;let m;try{m=await(0,c.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(a){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(a)))}const b={...process.env,...m},t=u.agent?u.agent:await(0,y.getProxyAgent)(u.url||"",b,{proxyUrl:p,strictSSL:w});return u.agent=t,u.strictSSL=w,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.p(u,f)}async n(u){return((0,L.parse)(u.url).protocol==="https:"?await new Promise((w,m)=>{B(["https"],w,m)}):await new Promise((w,m)=>{B(["http"],w,m)})).request}p(u,f){return this.c(u.isChromiumNetwork?"electron":"node",u,()=>T.Promises.withAsyncBody(async(p,w)=>{const m=(0,L.parse)(u.url),b=u.getRawRequest?u.getRawRequest(u):await this.n(u),t={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,N.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const a=b(t,n=>{const i=(0,N.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this.p({...u,url:n.headers.location,followRedirects:i-1},f).then(p,w);else{let r=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,v.createGunzip)())),p({res:n,stream:(0,k.streamToBufferReadableStream)(r)})}});a.on("error",w),u.timeout&&a.setTimeout(u.timeout),u.isChromiumNetwork&&a.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&a.write(u.data),a.end(),f.onCancellationRequested(()=>{a.abort(),w(new A.CancellationError)})}))}async resolveProxy(u){}};O=ge([ee(0,I.IConfigurationService),ee(1,d.INativeEnvironmentService),ee(2,P.ILogService),ee(3,P.ILoggerService)],O),e.RequestService=O}),define(te[174],ie([0,1,33,8,14,34,9,2,16,15,12,35,11,20,24,131,59,133,18,109,155,21,60,138,40,48,159,153,13,120,122,47,118,63,64,141,6,127,38,128,144,31,43,160,68,69,25,143,39,145,146,27,148,22,156,147,152,124,126,4]),function(B,e,L,T,k,A,N,I,d,c,P,E,y,v,O,R,u,f,p,w,m,b,t,a,n,i,r,o,l,g,S,D,F,K,Z,_,se,re,ce,fe,ae,x,W,z,U,$,H,X,Y,C,s,h,M,j,G,q,ne,oe,pe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends I.Disposable{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,ve]=await this.f();return le.invokeFunction(async Se=>{const Le=Se.get(se.ILogService),Ue=Se.get(l.IFileService),V=Se.get(p.INativeEnvironmentService),J=Se.get(j.IUserDataProfilesService);Le.info("CLI main",this.b),this.g(Le),await this.h(V,Ue,J,le),await Promise.all(ve.map(Q=>{(0,T.raceTimeout)(Q.flush(),1e3)}))})}async f(){const le=new K.ServiceCollection,ve={_serviceBrand:void 0,...ae.default};le.set(x.IProductService,ve);const Se=new w.NativeEnvironmentService(this.b,ve);le.set(p.INativeEnvironmentService,Se),await Promise.all([Se.appSettingsHome.fsPath,Se.extensionsPath].map(De=>De?v.Promises.mkdir(De,{recursive:!0}):void 0));const Le=new pe.LoggerService((0,se.getLogLevel)(Se),Se.logsHome);le.set(se.ILoggerService,Le);const Ue=this.D(Le.createLogger("cli",{name:(0,me.localize)(0,null)})),V=[];Le.getLogLevel()===se.LogLevel.Trace&&V.push(new se.ConsoleLogger(Le.getLogLevel()));const J=this.D(new oe.LogService(Ue,V));le.set(se.ILogService,J);const Q=this.D(new g.FileService(J));le.set(l.IFileService,Q);const de=this.D(new S.DiskFileSystemProvider(J));Q.registerProvider(d.Schemas.file,de);const Ee=new M.UriIdentityService(Q);le.set(h.IUriIdentityService,Ee);const Oe=new U.StateReadonlyService(1,Se,J,Q),Ie=new G.UserDataProfilesReadonlyService(Oe,Ee,Se,Q,J);le.set(j.IUserDataProfilesService,Ie);const Ae=P.isWindows&&ve.win32RegValueName?this.D(new fe.NativePolicyService(J,ve.win32RegValueName)):Se.policyFile?this.D(new re.FilePolicyService(Se.policyFile,Q,J)):new ce.NullPolicyService;le.set(ce.IPolicyService,Ae);const Re=this.D(new R.ConfigurationService(Ie.defaultProfile.settingsResource,Q,Ae,J));le.set(O.IConfigurationService,Re),await Promise.all([Oe.init(),Re.initialize()]),Ie.init(),le.set(h.IUriIdentityService,new M.UriIdentityService(Q)),le.set(W.IRequestService,new D.SyncDescriptor(z.RequestService,void 0,!0)),le.set(u.IDownloadService,new D.SyncDescriptor(f.DownloadService,void 0,!0)),le.set(n.IExtensionsProfileScannerService,new D.SyncDescriptor(ne.ExtensionsProfileScannerService,void 0,!0)),le.set(i.IExtensionsScannerService,new D.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),le.set(t.IExtensionSignatureVerificationService,new D.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),le.set(r.INativeServerExtensionManagementService,new D.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),le.set(b.IExtensionGalleryService,new D.SyncDescriptor(m.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),le.set(Z.ILanguagePackService,new D.SyncDescriptor(_.NativeLanguagePackService,void 0,!1));const Ne=[],Fe=(0,Y.isInternalTelemetry)(ve,Re);if((0,Y.supportsTelemetry)(ve,Se)){ve.aiConfig&&ve.aiConfig.ariaKey&&Ne.push(new C.OneDataSystemAppender(Fe,"monacoworkbench",null,ve.aiConfig.ariaKey));const{installSourcePath:De}=Se,Te={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ce;try{Ce=await(0,q.resolveMachineId)(Oe)}catch(je){je.code!=="ENOENT"&&J.error(je)}return(0,$.resolveCommonProperties)(Q,(0,L.release)(),(0,L.hostname)(),process.arch,ve.commit,ve.version,Ce,Fe,De)})(),piiPaths:(0,Y.getPiiPathsFromEnvironment)(Se)};le.set(H.ITelemetryService,new D.SyncDescriptor(X.TelemetryService,[Te],!1))}else le.set(H.ITelemetryService,Y.NullTelemetryService);return[new F.InstantiationService(le),Ne]}g(le){(0,N.setUnexpectedErrorHandler)(ve=>{const Se=(0,A.toErrorMessage)(ve,!0);!Se||le.error(`[uncaught exception in CLI]: ${Se}`)}),process.on("uncaughtException",ve=>{(0,N.isSigPipeError)(ve)||(0,N.onUnexpectedError)(ve)}),process.on("unhandledRejection",ve=>(0,N.onUnexpectedError)(ve))}async h(le,ve,Se,Le){let Ue;if(le.args.profile&&(Ue=Se.profiles.find(J=>J.name===le.args.profile),!Ue))throw new Error(`Profile '${le.args.profile}' not found.`);const V=(Ue??Se.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(le,ve,this.b["install-source"]);if(this.b["list-extensions"])return Le.createInstance(a.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const J={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Le.createInstance(a.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),J,!!this.b.force)}else{if(this.b["uninstall-extension"])return Le.createInstance(a.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Le.createInstance(a.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,s.buildTelemetryMessage)(le.appRoot,le.extensionsPath))}}i(le){return le.map(ve=>/\.vsix$/i.test(ve)?y.URI.file((0,c.isAbsolute)(ve)?ve:(0,c.join)((0,E.cwd)(),ve)):ve)}async j(le,ve,Se){await ve.writeFile(y.URI.file(le.installSourcePath),k.VSBuffer.fromString(Se.slice(0,30)))}}async function he(ye){const le=new ue(ye);try{await le.run()}finally{le.dispose()}}e.main=he})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/code/node/cliProcessMain.js.map
