/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","path","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],L=0,U=te.length;L<U;L++)e[L]=re[te[L]];return e};define(re[62],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(N){return(R,I,w)=>{let P=null,S=null;if(typeof w.value=="function"?(P="value",S=w.value):typeof w.get=="function"&&(P="get",S=w.get),!S)throw new Error("not supported");w[P]=N(S,I)}}function U(N,R,I){let w=null,P=null;if(typeof I.value=="function"?(w="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(w="get",P=I.get),!P)throw new Error("not supported");const S=`$memoize$${R}`;I[w]=function(...p){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[S]}}e.memoize=U;function l(N,R,I){return L((w,P)=>{const S=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...d){this[p]||(this[p]=I?I():void 0),clearTimeout(this[S]),R&&(this[p]=R(this[p],...d),d=[this[p]]),this[S]=setTimeout(()=>{w.apply(this,d),this[p]=I?I():void 0},N)}})}e.debounce=l;function O(N,R,I){return L((w,P)=>{const S=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,d=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...E){if(this[p]||(this[p]=I?I():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),R&&(this[p]=R(this[p],...E)),this[m])return;const c=this[d]+N;c<=Date.now()?(this[d]=Date.now(),w.apply(this,[this[p]]),this[p]=I?I():void 0):(this[m]=!0,this[S]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),w.apply(this,[this[p]]),this[p]=I?I():void 0},c-Date.now()))}})}e.throttle=O}),define(re[10],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?v.isErrorNoTelemetry(o)?new v(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(i=>{i(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=L,e.errorHandler=new L;function U(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=U;function l(n){if(!n||typeof n!="object")return!1;const o=n;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function O(n){w(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=O;function N(n){w(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=N;function R(n){if(n instanceof Error){const{name:o,message:i}=n,t=n.stacktrace||n.stack;return{$isError:!0,name:o,message:i,stack:t,noTelemetry:v.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=R;const I="Canceled";function w(n){return n instanceof P?!0:n instanceof Error&&n.name===I&&n.message===I}e.isCancellationError=w;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function S(){const n=new Error(I);return n.name=n.message,n}e.canceled=S;function p(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=p;function d(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=d;function m(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function E(n){const o=new Error(`${n} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function c(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=c;class u extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=u;class h extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class v extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof v)return o;const i=new v;return i.message=o.message,i.stack=o.stack,i}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class D extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(re[21],oe([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function U(W,Q=0){return W[W.length-(1+Q)]}e.tail=U;function l(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=l;function O(W,Q,ee=(le,he)=>le===he){if(W===Q)return!0;if(!W||!Q||W.length!==Q.length)return!1;for(let le=0,he=W.length;le<he;le++)if(!ee(W[le],Q[le]))return!1;return!0}e.equals=O;function N(W,Q){const ee=W.length-1;Q<ee&&(W[Q]=W[ee]),W.pop()}e.removeFastWithoutKeepingOrder=N;function R(W,Q,ee){return I(W.length,le=>ee(W[le],Q))}e.binarySearch=R;function I(W,Q){let ee=0,le=W-1;for(;ee<=le;){const he=(ee+le)/2|0,pe=Q(he);if(pe<0)ee=he+1;else if(pe>0)le=he-1;else return he}return-(ee+1)}e.binarySearch2=I;function w(W,Q){let ee=0,le=W.length;if(le===0)return 0;for(;ee<le;){const he=Math.floor((ee+le)/2);Q(W[he])?le=he:ee=he+1}return ee}e.findFirstInSorted=w;function P(W,Q,ee){if(W=W|0,W>=Q.length)throw new TypeError("invalid index");const le=Q[Math.floor(Q.length*Math.random())],he=[],pe=[],de=[];for(const be of Q){const Ce=ee(be,le);Ce<0?he.push(be):Ce>0?pe.push(be):de.push(be)}return W<he.length?P(W,he,ee):W<he.length+de.length?de[0]:P(W-(he.length+de.length),pe,ee)}e.quickSelect=P;function S(W,Q){const ee=[];let le;for(const he of W.slice(0).sort(Q))!le||Q(le[0],he)!==0?(le=[he],ee.push(le)):le.push(he);return ee}e.groupBy=S;function p(W,Q,ee){const le=[];function he(be,Ce,Re){if(Ce===0&&Re.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Ce,ke.toInsert.push(...Re)):le.push({start:be,deleteCount:Ce,toInsert:Re})}let pe=0,de=0;for(;;){if(pe===W.length){he(pe,0,Q.slice(de));break}if(de===Q.length){he(pe,W.length-pe,[]);break}const be=W[pe],Ce=Q[de],Re=ee(be,Ce);Re===0?(pe+=1,de+=1):Re<0?(he(pe,1,[]),pe+=1):Re>0&&(he(pe,0,[Ce]),de+=1)}return le}e.sortedDiff=p;function d(W,Q,ee){const le=p(W,Q,ee),he=[],pe=[];for(const de of le)he.push(...W.slice(de.start,de.start+de.deleteCount)),pe.push(...de.toInsert);return{removed:he,added:pe}}e.delta=d;function m(W,Q,ee){if(ee===0)return[];const le=W.slice(0,ee).sort(Q);return c(W,Q,le,ee,W.length),le}e.top=m;function E(W,Q,ee,le,he){return ee===0?Promise.resolve([]):new Promise((pe,de)=>{(async()=>{const be=W.length,Ce=W.slice(0,ee).sort(Q);for(let Re=ee,ke=Math.min(ee+le,be);Re<be;Re=ke,ke=Math.min(ke+le,be)){if(Re>ee&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new L.CancellationError;c(W,Q,Ce,Re,ke)}return Ce})().then(pe,de)})}e.topAsync=E;function c(W,Q,ee,le,he){for(const pe=ee.length;le<he;le++){const de=W[le];if(Q(de,ee[pe-1])<0){ee.pop();const be=w(ee,Ce=>Q(de,Ce)<0);ee.splice(be,0,de)}}}function u(W){return W.filter(Q=>!!Q)}e.coalesce=u;function h(W){let Q=0;for(let ee=0;ee<W.length;ee++)W[ee]&&(W[Q]=W[ee],Q+=1);W.length=Q}e.coalesceInPlace=h;function g(W,Q,ee){W.splice(ee,0,W.splice(Q,1)[0])}e.move=g;function v(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=v;function D(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=D;function n(W,Q=ee=>ee){const ee=new Set;return W.filter(le=>{const he=Q(le);return ee.has(he)?!1:(ee.add(he),!0)})}e.distinct=n;function o(W){const Q=new Set;return ee=>{const le=W(ee);return Q.has(le)?!1:(Q.add(le),!0)}}e.uniqueFilter=o;function i(W,Q){const ee=t(W,Q);if(ee!==-1)return W[ee]}e.findLast=i;function t(W,Q){for(let ee=W.length-1;ee>=0;ee--){const le=W[ee];if(Q(le))return ee}return-1}e.lastIndex=t;function s(W,Q){return W.length>0?W[0]:Q}e.firstOrDefault=s;function a(W,Q){return W.length>0?W[W.length-1]:Q}e.lastOrDefault=a;function r(W,Q,ee=(le,he)=>le===he){let le=0;for(let he=0,pe=Math.min(W.length,Q.length);he<pe&&ee(W[he],Q[he]);he++)le++;return le}e.commonPrefixLength=r;function f(W){return[].concat(...W)}e.flatten=f;function b(W,Q){let ee=typeof Q=="number"?W:0;typeof Q=="number"?ee=W:(ee=0,Q=W);const le=[];if(ee<=Q)for(let he=ee;he<Q;he++)le.push(he);else for(let he=ee;he>Q;he--)le.push(he);return le}e.range=b;function y(W,Q,ee){return W.reduce((le,he)=>(le[Q(he)]=ee?ee(he):he,le),Object.create(null))}e.index=y;function k(W,Q){return W.push(Q),()=>T(W,Q)}e.insert=k;function T(W,Q){const ee=W.indexOf(Q);if(ee>-1)return W.splice(ee,1),Q}e.remove=T;function F(W,Q,ee){const le=W.slice(0,Q),he=W.slice(Q);return le.concat(ee,he)}e.arrayInsert=F;function j(W,Q){let ee;if(typeof Q=="number"){let le=Q;ee=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else ee=Math.random;for(let le=W.length-1;le>0;le-=1){const he=Math.floor(ee()*(le+1)),pe=W[le];W[le]=W[he],W[he]=pe}}e.shuffle=j;function x(W,Q){const ee=W.indexOf(Q);ee>-1&&(W.splice(ee,1),W.unshift(Q))}e.pushToStart=x;function V(W,Q){const ee=W.indexOf(Q);ee>-1&&(W.splice(ee,1),W.push(Q))}e.pushToEnd=V;function B(W,Q){for(const ee of Q)W.push(ee)}e.pushMany=B;function X(W,Q){return Array.isArray(W)?W.map(Q):Q(W)}e.mapArrayOrNot=X;function J(W){return Array.isArray(W)?W:[W]}e.asArray=J;function G(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=G;function Y(W,Q){for(const ee of W){const le=Q(ee);if(le!==void 0)return le}}e.mapFind=Y;function H(W,Q,ee){const le=Z(W,Q),he=W.length,pe=ee.length;W.length=he+pe;for(let de=he-1;de>=le;de--)W[de+pe]=W[de];for(let de=0;de<pe;de++)W[de+le]=ee[de]}e.insertInto=H;function $(W,Q,ee,le){const he=Z(W,Q),pe=W.splice(he,ee);return H(W,he,le),pe}e.splice=$;function Z(W,Q){return Q<0?Math.max(Q+W.length,0):Math.min(Q,W.length)}var ie;(function(W){function Q(he){return he<0}W.isLessThan=Q;function ee(he){return he>0}W.isGreaterThan=ee;function le(he){return he===0}W.isNeitherLessOrGreaterThan=le,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function se(W,Q){return(ee,le)=>Q(W(ee),W(le))}e.compareBy=se;function ae(...W){return(Q,ee)=>{for(const le of W){const he=le(Q,ee);if(!ie.isNeitherLessOrGreaterThan(he))return he}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const q=(W,Q)=>W-Q;e.numberComparator=q;function C(W,Q){if(W.length===0)return;let ee=W[0];for(let le=1;le<W.length;le++){const he=W[le];Q(he,ee)>0&&(ee=he)}return ee}e.findMaxBy=C;function A(W,Q){if(W.length===0)return;let ee=W[0];for(let le=1;le<W.length;le++){const he=W[le];Q(he,ee)>=0&&(ee=he)}return ee}e.findLastMaxBy=A;function M(W,Q){return C(W,(ee,le)=>-Q(ee,le))}e.findMinBy=M;class z{constructor(Q){this.f=Q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let ee=this.c;for(;ee<this.f.length&&Q(this.f[ee]);)ee++;const le=ee===this.c?null:this.f.slice(this.c,ee);return this.c=ee,le}takeFromEndWhile(Q){let ee=this.d;for(;ee>=0&&Q(this.f[ee]);)ee--;const le=ee===this.d?null:this.f.slice(ee+1,this.d+1);return this.d=ee,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Q=this.f[this.c];return this.c++,Q}removeLast(){const Q=this.f[this.d];return this.d--,Q}takeCount(Q){const ee=this.f.slice(this.c,this.c+Q);return this.c+=Q,ee}}e.ArrayQueue=z;class _{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(ee=>(Q(ee),!0))}toArray(){const Q=[];return this.iterate(ee=>(Q.push(ee),!0)),Q}filter(Q){return new _(ee=>this.iterate(le=>Q(le)?ee(le):!0))}map(Q){return new _(ee=>this.iterate(le=>ee(Q(le))))}some(Q){let ee=!1;return this.iterate(le=>(ee=Q(le),!ee)),ee}findFirst(Q){let ee;return this.iterate(le=>Q(le)?(ee=le,!1):!0),ee}findLast(Q){let ee;return this.iterate(le=>(Q(le)&&(ee=le),!0)),ee}findLastMaxBy(Q){let ee,le=!0;return this.iterate(he=>((le||ie.isGreaterThan(Q(he,ee)))&&(le=!1,ee=he),!0)),ee}}_.empty=new _(W=>{}),e.CallbackIterable=_}),define(re[129],oe([0,1,10]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function U(I,w){if(!I)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=U;function l(I,w="Unreachable"){throw new Error(w)}e.assertNever=l;function O(I){if(!I)throw new L.BugIndicatingError("Assertion Failed")}e.assert=O;function N(I){if(!I()){debugger;I(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function R(I,w){let P=0;for(;P<I.length-1;){const S=I[P],p=I[P+1];if(!w(S,p))return!1;P++}return!0}e.checkAdjacentItems=R}),define(re[82],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(U){const l=this;let O=!1,N;return function(){return O||(O=!0,N=U.apply(l,arguments)),N}}e.once=L}),define(re[63],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(U){function l(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}U.is=l;const O=Object.freeze([]);function N(){return O}U.empty=N;function*R(v){yield v}U.single=R;function I(v){return l(v)?v:R(v)}U.wrap=I;function w(v){return v||O}U.from=w;function P(v){return!v||v[Symbol.iterator]().next().done===!0}U.isEmpty=P;function S(v){return v[Symbol.iterator]().next().value}U.first=S;function p(v,D){for(const n of v)if(D(n))return!0;return!1}U.some=p;function d(v,D){for(const n of v)if(D(n))return n}U.find=d;function*m(v,D){for(const n of v)D(n)&&(yield n)}U.filter=m;function*E(v,D){let n=0;for(const o of v)yield D(o,n++)}U.map=E;function*c(...v){for(const D of v)for(const n of D)yield n}U.concat=c;function u(v,D,n){let o=n;for(const i of v)o=D(o,i);return o}U.reduce=u;function*h(v,D,n=v.length){for(D<0&&(D+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);D<n;D++)yield v[D]}U.slice=h;function g(v,D=Number.POSITIVE_INFINITY){const n=[];if(D===0)return[n,v];const o=v[Symbol.iterator]();for(let i=0;i<D;i++){const t=o.next();if(t.done)return[n,U.empty()];n.push(t.value)}return[n,{[Symbol.iterator](){return o}}]}U.consume=g})(L=e.Iterable||(e.Iterable={}))}),define(re[35],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var U;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(U=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var O;(function(n){n.DEFAULT={allowTrailingComma:!0}})(O=e.ParseOptions||(e.ParseOptions={}));function N(n,o=!1){let i=0;const t=n.length;let s="",a=0,r=16,f=0;function b(V){let B=0,X=0;for(;B<V;){const J=n.charCodeAt(i);if(J>=48&&J<=57)X=X*16+J-48;else if(J>=65&&J<=70)X=X*16+J-65+10;else if(J>=97&&J<=102)X=X*16+J-97+10;else break;i++,B++}return B<V&&(X=-1),X}function y(V){i=V,s="",a=0,r=16,f=0}function k(){const V=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&w(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&w(n.charCodeAt(i)))for(i++;i<n.length&&w(n.charCodeAt(i));)i++;else return f=3,n.substring(V,i);let B=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&w(n.charCodeAt(i))){for(i++;i<n.length&&w(n.charCodeAt(i));)i++;B=i}else f=3;return n.substring(V,B)}function T(){let V="",B=i;for(;;){if(i>=t){V+=n.substring(B,i),f=2;break}const X=n.charCodeAt(i);if(X===34){V+=n.substring(B,i),i++;break}if(X===92){if(V+=n.substring(B,i),i++,i>=t){f=2;break}switch(n.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const G=b(4);G>=0?V+=String.fromCharCode(G):f=4;break}default:f=5}B=i;continue}if(X>=0&&X<=31)if(I(X)){V+=n.substring(B,i),f=2;break}else f=6;i++}return V}function F(){if(s="",f=0,a=i,i>=t)return a=t,r=17;let V=n.charCodeAt(i);if(R(V)){do i++,s+=String.fromCharCode(V),V=n.charCodeAt(i);while(R(V));return r=15}if(I(V))return i++,s+=String.fromCharCode(V),V===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),r=14;switch(V){case 123:return i++,r=1;case 125:return i++,r=2;case 91:return i++,r=3;case 93:return i++,r=4;case 58:return i++,r=6;case 44:return i++,r=5;case 34:return i++,s=T(),r=10;case 47:{const B=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<t&&!I(n.charCodeAt(i));)i++;return s=n.substring(B,i),r=12}if(n.charCodeAt(i+1)===42){i+=2;const X=t-1;let J=!1;for(;i<X;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,J=!0;break}i++}return J||(i++,f=1),s=n.substring(B,i),r=13}return s+=String.fromCharCode(V),i++,r=16}case 45:if(s+=String.fromCharCode(V),i++,i===t||!w(n.charCodeAt(i)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=k(),r=11;default:for(;i<t&&j(V);)i++,V=n.charCodeAt(i);if(a!==i){switch(s=n.substring(a,i),s){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return s+=String.fromCharCode(V),i++,r=16}}function j(V){if(R(V)||I(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let V;do V=F();while(V>=12&&V<=15);return V}return{setPosition:y,getPosition:()=>i,scan:o?x:F,getToken:()=>r,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>f}}e.createScanner=N;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function S(n,o){const i=[],t=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function f(b,y,k,T){a.value=b,a.offset=y,a.length=k,a.type=T,a.colonOffset=void 0,s=a}try{g(n,{onObjectBegin:(b,y)=>{if(o<=b)throw t;s=void 0,r=o>b,i.push("")},onObjectProperty:(b,y,k)=>{if(o<y||(f(b,y,k,"property"),i[i.length-1]=b,o<=y+k))throw t},onObjectEnd:(b,y)=>{if(o<=b)throw t;s=void 0,i.pop()},onArrayBegin:(b,y)=>{if(o<=b)throw t;s=void 0,i.push(0)},onArrayEnd:(b,y)=>{if(o<=b)throw t;s=void 0,i.pop()},onLiteralValue:(b,y,k)=>{if(o<y||(f(b,y,k,D(b)),o<=y+k))throw t},onSeparator:(b,y,k)=>{if(o<=y)throw t;if(b===":"&&s&&s.type==="property")s.colonOffset=y,r=!1,s=void 0;else if(b===","){const T=i[i.length-1];typeof T=="number"?i[i.length-1]=T+1:(r=!0,i[i.length-1]=""),s=void 0}}})}catch(b){if(b!==t)throw b}return{path:i,previousNode:s,isAtPropertyKey:r,matches:b=>{let y=0;for(let k=0;y<b.length&&k<i.length;k++)if(b[y]===i[k]||b[y]==="*")y++;else if(b[y]!=="**")return!1;return y===b.length}}}e.getLocation=S;function p(n,o=[],i=O.DEFAULT){let t=null,s=[];const a=[];function r(b){Array.isArray(s)?s.push(b):t!==null&&(s[t]=b)}return g(n,{onObjectBegin:()=>{const b={};r(b),a.push(s),s=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const b=[];r(b),a.push(s),s=b,t=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:r,onError:(b,y,k)=>{o.push({error:b,offset:y,length:k})}},i),s[0]}e.parse=p;function d(n,o=[],i=O.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(b){t.type==="property"&&(t.length=b-t.offset,t=t.parent)}function a(b){return t.children.push(b),b}g(n,{onObjectBegin:b=>{t=a({type:"object",offset:b,length:-1,parent:t,children:[]})},onObjectProperty:(b,y,k)=>{t=a({type:"property",offset:y,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:b,offset:y,length:k,parent:t})},onObjectEnd:(b,y)=>{t.length=b+y-t.offset,t=t.parent,s(b+y)},onArrayBegin:(b,y)=>{t=a({type:"array",offset:b,length:-1,parent:t,children:[]})},onArrayEnd:(b,y)=>{t.length=b+y-t.offset,t=t.parent,s(b+y)},onLiteralValue:(b,y,k)=>{a({type:D(b),offset:y,length:k,parent:t,value:b}),s(y+k)},onSeparator:(b,y,k)=>{t.type==="property"&&(b===":"?t.colonOffset=y:b===","&&s(y))},onError:(b,y,k)=>{o.push({error:b,offset:y,length:k})}},i);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=d;function m(n,o){if(!n)return;let i=n;for(const t of o)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===t){i=a.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=m;function E(n){if(!n.parent||!n.parent.children)return[];const o=E(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;o.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&o.push(i)}return o}e.getNodePath=E;function c(n){switch(n.type){case"array":return n.children.map(c);case"object":{const o=Object.create(null);for(const i of n.children){const t=i.children[1];t&&(o[i.children[0].value]=c(t))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=c;function u(n,o,i=!1){return o>=n.offset&&o<n.offset+n.length||i&&o===n.offset+n.length}e.contains=u;function h(n,o,i=!1){if(u(n,o,i)){const t=n.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=o;s++){const a=h(t[s],o,i);if(a)return a}return n}}e.findNodeAtOffset=h;function g(n,o,i=O.DEFAULT){const t=N(n,!1);function s(se){return se?()=>se(t.getTokenOffset(),t.getTokenLength()):()=>!0}function a(se){return se?ae=>se(ae,t.getTokenOffset(),t.getTokenLength()):()=>!0}const r=s(o.onObjectBegin),f=a(o.onObjectProperty),b=s(o.onObjectEnd),y=s(o.onArrayBegin),k=s(o.onArrayEnd),T=a(o.onLiteralValue),F=a(o.onSeparator),j=s(o.onComment),x=a(o.onError),V=i&&i.disallowComments,B=i&&i.allowTrailingComma;function X(){for(;;){const se=t.scan();switch(t.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:V||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(se){case 12:case 13:V?J(10):j();break;case 16:J(1);break;case 15:case 14:break;default:return se}}}function J(se,ae=[],q=[]){if(x(se),ae.length+q.length>0){let C=t.getToken();for(;C!==17;){if(ae.indexOf(C)!==-1){X();break}else if(q.indexOf(C)!==-1)break;C=X()}}}function G(se){const ae=t.getTokenValue();return se?T(ae):f(ae),X(),!0}function Y(){switch(t.getToken()){case 11:{let se=0;try{se=JSON.parse(t.getTokenValue()),typeof se!="number"&&(J(2),se=0)}catch{J(2)}T(se);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return X(),!0}function H(){return t.getToken()!==10?(J(3,[],[2,5]),!1):(G(!1),t.getToken()===6?(F(":"),X(),ie()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function $(){r(),X();let se=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(se||J(4,[],[]),F(","),X(),t.getToken()===2&&B)break}else se&&J(6,[],[]);H()||J(4,[],[2,5]),se=!0}return b(),t.getToken()!==2?J(7,[2],[]):X(),!0}function Z(){y(),X();let se=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(se||J(4,[],[]),F(","),X(),t.getToken()===4&&B)break}else se&&J(6,[],[]);ie()||J(4,[],[4,5]),se=!0}return k(),t.getToken()!==4?J(8,[4],[]):X(),!0}function ie(){switch(t.getToken()){case 3:return Z();case 1:return $();case 10:return G(!0);default:return Y()}}return X(),t.getToken()===17?i.allowEmptyContent?!0:(J(4,[],[]),!1):ie()?(t.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=g;function v(n,o){const i=N(n),t=[];let s,a=0,r;do switch(r=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==r&&t.push(n.substring(a,r)),o!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,o)),a=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=v;function D(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(re[42],oe([0,1,35]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function U(w,P,S){let p,d,m,E,c;if(P){for(E=P.offset,c=E+P.length,m=E;m>0&&!I(w,m-1);)m--;let r=c;for(;r<w.length&&!I(w,r);)r++;d=w.substring(m,r),p=N(d,S)}else d=w,p=0,m=0,E=0,c=w.length;const u=R(S,w);let h=!1,g=0,v;S.insertSpaces?v=O(" ",S.tabSize||4):v="	";const D=(0,L.createScanner)(d,!1);let n=!1;function o(){return u+O(v,p+g)}function i(){let r=D.scan();for(h=!1;r===15||r===14;)h=h||r===14,r=D.scan();return n=r===16||D.getTokenError()!==0,r}const t=[];function s(r,f,b){!n&&f<c&&b>E&&w.substring(f,b)!==r&&t.push({offset:f,length:b-f,content:r})}let a=i();if(a!==17){const r=D.getTokenOffset()+m,f=O(v,p);s(f,m,r)}for(;a!==17;){let r=D.getTokenOffset()+D.getTokenLength()+m,f=i(),b="";for(;!h&&(f===12||f===13);){const k=D.getTokenOffset()+m;s(" ",r,k),r=D.getTokenOffset()+D.getTokenLength()+m,b=f===12?o():"",f=i()}if(f===2)a!==1&&(g--,b=o());else if(f===4)a!==3&&(g--,b=o());else{switch(a){case 3:case 1:g++,b=o();break;case 5:case 12:b=o();break;case 13:h?b=o():b=" ";break;case 6:b=" ";break;case 10:if(f===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?b=" ":f!==5&&f!==17&&(n=!0);break;case 16:n=!0;break}h&&(f===12||f===13)&&(b=o())}const y=D.getTokenOffset()+m;s(b,r,y),a=f}return t}e.format=U;function l(w,P){const S=JSON.stringify(w,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?S.replace(/\r\n|\r|\n/g,P.eol):S}e.toFormattedString=l;function O(w,P){let S="";for(let p=0;p<P;p++)S+=w;return S}function N(w,P){let S=0,p=0;const d=P.tabSize||4;for(;S<w.length;){const m=w.charAt(S);if(m===" ")p++;else if(m==="	")p+=d;else break;S++}return Math.floor(p/d)}function R(w,P){for(let S=0;S<P.length;S++){const p=P.charAt(S);if(p==="\r")return S+1<P.length&&P.charAt(S+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=R;function I(w,P){return`\r
`.indexOf(w.charAt(P))!==-1}e.isEOL=I}),define(re[83],oe([0,1,35,42]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(w,P,S){return O(w,P,void 0,S)}e.removeProperty=l;function O(w,P,S,p,d){const m=P.slice(),E=[],c=(0,L.parseTree)(w,E);let u,h;for(;m.length>0&&(h=m.pop(),u=(0,L.findNodeAtLocation)(c,m),u===void 0&&S!==void 0);)typeof h=="string"?S={[h]:S}:S=[S];if(u)if(u.type==="object"&&typeof h=="string"&&Array.isArray(u.children)){const g=(0,L.findNodeAtLocation)(u,[h]);if(g!==void 0)if(S===void 0){if(!g.parent)throw new Error("Malformed AST");const v=u.children.indexOf(g.parent);let D,n=g.parent.offset+g.parent.length;if(v>0){const o=u.children[v-1];D=o.offset+o.length}else D=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return N(w,{offset:D,length:n-D,content:""},p)}else return N(w,{offset:g.offset,length:g.length,content:JSON.stringify(S)},p);else{if(S===void 0)return[];const v=`${JSON.stringify(h)}: ${JSON.stringify(S)}`,D=d?d(u.children.map(o=>o.children[0].value)):u.children.length;let n;if(D>0){const o=u.children[D-1];n={offset:o.offset+o.length,length:0,content:","+v}}else u.children.length===0?n={offset:u.offset+1,length:0,content:v}:n={offset:u.offset+1,length:0,content:v+","};return N(w,n,p)}}else if(u.type==="array"&&typeof h=="number"&&Array.isArray(u.children))if(S!==void 0){const g=`${JSON.stringify(S)}`;let v;if(u.children.length===0||h===0)v={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const D=h===-1||h>u.children.length?u.children.length:h,n=u.children[D-1];v={offset:n.offset+n.length,length:0,content:","+g}}return N(w,v,p)}else{const g=h,v=u.children[g];let D;if(u.children.length===1)D={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const n=u.children[g-1],o=n.offset+n.length,i=u.offset+u.length;D={offset:o,length:i-2-o,content:""}}else D={offset:v.offset,length:u.children[g+1].offset-v.offset,content:""};return N(w,D,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${u.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return N(w,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(S)},p)}}e.setProperty=O;function N(w,P,S){let p=R(w,P),d=P.offset,m=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;d>0&&!(0,U.isEOL)(p,d-1);)d--;for(;m<p.length&&!(0,U.isEOL)(p,m);)m++}const E=(0,U.format)(p,{offset:d,length:m-d},S);for(let u=E.length-1;u>=0;u--){const h=E[u];p=R(p,h),d=Math.min(d,h.offset),m=Math.max(m,h.offset+h.length),m+=h.content.length-h.length}const c=w.length-(p.length-m)-d;return[{offset:d,length:c,content:p.substring(d,m)}]}e.withFormatting=N;function R(w,P){return w.substring(0,P.offset)+P.content+w.substring(P.offset+P.length)}e.applyEdit=R;function I(w,P){const S=P.slice(0).sort((d,m)=>{const E=d.offset-m.offset;return E===0?d.length-m.length:E});let p=w.length;for(let d=S.length-1;d>=0;d--){const m=S[d];if(m.offset+m.length<=p)w=R(w,m);else throw new Error("Overlapping edit");p=m.offset}return w}e.applyEdits=I}),define(re[130],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=L}),define(re[2],oe([0,1,82,63]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let O=null;function N(a){O=a}if(e.setDisposableTracker=N,l){const a="__is_disposable_tracked__";N(new class{trackDisposable(r){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(f)},3e3)}setParent(r,f){if(r&&r!==h.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==h.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function R(a){return O?.trackDisposable(a),a}function I(a){O?.markAsDisposed(a)}function w(a,r){O?.setParent(a,r)}function P(a,r){if(!!O)for(const f of a)O.setParent(f,r)}function S(a){return O?.markAsSingleton(a),a}e.markAsSingleton=S;function p(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=p;function d(a){if(U.Iterable.is(a)){const r=[];for(const f of a)if(f)try{f.dispose()}catch(b){r.push(b)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function m(a){for(const r of a)p(r)&&r.dispose();return[]}e.disposeIfDisposable=m;function E(...a){const r=c(()=>d(a));return P(a,r),r}e.combinedDisposable=E;function c(a){const r=R({dispose:(0,L.once)(()=>{I(r),a()})});return r}e.toDisposable=c;class u{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return w(r,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class h{constructor(){this.B=new u,R(this),w(this.B,this)}dispose(){I(this),this.B.dispose()}D(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(r)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class g{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&w(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&w(r,null),r}}e.MutableDisposable=g;class v{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(r){let f=r;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,I(this))},this}}e.SafeDisposable=D;class n{constructor(){this.a=new Map}acquire(r,...f){let b=this.a.get(r);b||(b={counter:0,object:this.b(r,...f)},this.a.set(r,b));const{object:y}=b,k=(0,L.once)(()=>{--b.counter===0&&(this.c(r,b.object),this.a.delete(r))});return b.counter++,{object:y,dispose:k}}}e.ReferenceCollection=n;class o{constructor(r){this.a=r}async acquire(r,...f){const b=this.a.acquire(r,...f);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(y){throw b.dispose(),y}}}e.AsyncReferenceCollection=o;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function t(a){const r=new u;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=t;class s{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,f,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(r)?.dispose(),this.a.set(r,f)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[84],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(O){this.element=O,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class U{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let O=this.a;for(;O!==L.Undefined;){const N=O.next;O.prev=L.Undefined,O.next=L.Undefined,O=N}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,N){const R=new L(O);if(this.a===L.Undefined)this.a=R,this.b=R;else if(N){const w=this.b;this.b=R,R.prev=w,w.next=R}else{const w=this.a;this.a=R,R.next=w,w.prev=R}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(R))}}shift(){if(this.a!==L.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==L.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==L.Undefined&&O.next!==L.Undefined){const N=O.prev;N.next=O.next,O.next.prev=N}else O.prev===L.Undefined&&O.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):O.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):O.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==L.Undefined;)yield O.element,O=O.next}}e.LinkedList=U}),define(re[37],oe([0,1]),function(te,e){"use strict";var L,U,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(E,c,u){let h=E.get(c);return h===void 0&&(h=u,E.set(c,h)),h}e.getOrSet=O;function N(E){const c=[];return E.forEach((u,h)=>{c.push(`${h} => ${u}`)}),`Map(${E.size}) {${c.join(", ")}}`}e.mapToString=N;function R(E){const c=[];return E.forEach(u=>{c.push(u)}),`Set(${E.size}) {${c.join(", ")}}`}e.setToString=R;class I{constructor(c,u){this.uri=c,this.value=u}}class w{constructor(c,u){this[L]="ResourceMap",c instanceof w?(this.b=new Map(c.b),this.c=u??w.a):(this.b=new Map,this.c=c??w.a)}set(c,u){return this.b.set(this.c(c),new I(c,u)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,u){typeof u<"u"&&(c=c.bind(u));for(const[h,g]of this.b)c(g.value,g.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}w.a=E=>E.toString(),e.ResourceMap=w;class P{constructor(c,u){this[U]="ResourceSet",!c||typeof c=="function"?this.a=new w(c):(this.a=new w(u),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,u){this.a.forEach((h,g)=>c.call(u,g,g,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var S;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class p{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,u=0){const h=this.a.get(c);if(!!h)return u!==0&&this.j(h,u),h.value}set(c,u,h=0){let g=this.a.get(c);if(g)g.value=u,h!==0&&this.j(g,h);else{switch(g={key:c,value:u,next:void 0,previous:void 0},h){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(c,g),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const u=this.a.get(c);if(!!u)return this.a.delete(c),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,u){const h=this.e;let g=this.b;for(;g;){if(u?c.bind(u)(g.value,g.key,this):c(g.value,g.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.key,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return g}values(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:h.value,done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return g}entries(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const v={value:[h.key,h.value],done:!1};return h=h.next,v}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>c;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const u=c.next,h=c.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}c.next=void 0,c.previous=void 0,this.e++}j(c,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(c===this.b)return;const h=c.next,g=c.previous;c===this.c?(g.next=void 0,this.c=g):(h.previous=g,g.next=h),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(u===2){if(c===this.c)return;const h=c.next,g=c.previous;c===this.b?(h.previous=void 0,this.b=h):(h.previous=g,g.next=h),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((u,h)=>{c.push([h,u])}),c}fromJSON(c){this.clear();for(const[u,h]of c)this.set(u,h)}}e.LinkedMap=p;class d extends p{constructor(c,u=1){super(),this.k=c,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,u=2){return super.get(c,u)}peek(c){return super.get(c,0)}set(c,u){return super.set(c,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class m{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let u=this.a.get(c)||0;return u===0?!1:(u--,u===0?this.a.delete(c):this.a.set(c,u),!0)}has(c){return this.a.has(c)}}e.CounterSet=m}),define(re[85],oe([0,1,37]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const U=new L.LRUCache(1e4);function l(w){return I(w,"NFC",U)}e.normalizeNFC=l;const O=new L.LRUCache(1e4);function N(w){return I(w,"NFD",O)}e.normalizeNFD=N;const R=/[^\u0000-\u0080]/;function I(w,P,S){if(!w)return w;const p=S.get(w);if(p)return p;let d;return R.test(w)?d=w.normalize(P):d=w,S.set(w,d),d}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(P){return N(P).replace(w,"")}}()}),define(re[131],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(R,I,w){return Math.min(Math.max(R,I),w)}e.clamp=L;function U(R,I){return(I+R%I)%I}e.rot=U;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class O{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=O;class N{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const w=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function te(l){const O=[];typeof l=="number"&&O.push("code/timeOrigin",l);function N(I){O.push(I,Date.now())}function R(){const I=[];for(let w=0;w<O.length;w+=2)I.push({name:O[w],startTime:O[w+1]});return I}return{mark:N,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const N of performance.getEntriesByType("mark"))O.push({name:N.name,startTime:Math.round(l+N.startTime)});return O}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function L(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=L(U))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var U in L)(typeof exports=="object"?exports:te)[U]=L[U]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function L(U){if(e[U])return e[U].exports;var l=e[U]={i:U,l:!1,exports:{}};return te[U].call(l.exports,l,l.exports,L),l.l=!0,l.exports}return L.m=te,L.c=e,L.d=function(U,l,O){L.o(U,l)||Object.defineProperty(U,l,{enumerable:!0,get:O})},L.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},L.t=function(U,l){if(1&l&&(U=L(U)),8&l||4&l&&typeof U=="object"&&U&&U.__esModule)return U;var O=Object.create(null);if(L.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:U}),2&l&&typeof U!="string")for(var N in U)L.d(O,N,function(R){return U[R]}.bind(null,N));return O},L.n=function(U){var l=U&&U.__esModule?function(){return U.default}:function(){return U};return L.d(l,"a",l),l},L.o=function(U,l){return Object.prototype.hasOwnProperty.call(U,l)},L.p="",L(L.s=0)}([function(te,e,L){(function(U){var l;e=te.exports=q,l=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],w=0,P=w++;I[P]="0|[1-9]\\d*";var S=w++;I[S]="[0-9]+";var p=w++;I[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=w++;I[d]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var m=w++;I[m]="("+I[S]+")\\.("+I[S]+")\\.("+I[S]+")";var E=w++;I[E]="(?:"+I[P]+"|"+I[p]+")";var c=w++;I[c]="(?:"+I[S]+"|"+I[p]+")";var u=w++;I[u]="(?:-("+I[E]+"(?:\\."+I[E]+")*))";var h=w++;I[h]="(?:-?("+I[c]+"(?:\\."+I[c]+")*))";var g=w++;I[g]="[0-9A-Za-z-]+";var v=w++;I[v]="(?:\\+("+I[g]+"(?:\\."+I[g]+")*))";var D=w++,n="v?"+I[d]+I[u]+"?"+I[v]+"?";I[D]="^"+n+"$";var o="[v=\\s]*"+I[m]+I[h]+"?"+I[v]+"?",i=w++;I[i]="^"+o+"$";var t=w++;I[t]="((?:<|>)?=?)";var s=w++;I[s]=I[S]+"|x|X|\\*";var a=w++;I[a]=I[P]+"|x|X|\\*";var r=w++;I[r]="[v=\\s]*("+I[a]+")(?:\\.("+I[a]+")(?:\\.("+I[a]+")(?:"+I[u]+")?"+I[v]+"?)?)?";var f=w++;I[f]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[h]+")?"+I[v]+"?)?)?";var b=w++;I[b]="^"+I[t]+"\\s*"+I[r]+"$";var y=w++;I[y]="^"+I[t]+"\\s*"+I[f]+"$";var k=w++;I[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=w++;I[T]="(?:~>?)";var F=w++;I[F]="(\\s*)"+I[T]+"\\s+",R[F]=new RegExp(I[F],"g");var j=w++;I[j]="^"+I[T]+I[r]+"$";var x=w++;I[x]="^"+I[T]+I[f]+"$";var V=w++;I[V]="(?:\\^)";var B=w++;I[B]="(\\s*)"+I[V]+"\\s+",R[B]=new RegExp(I[B],"g");var X=w++;I[X]="^"+I[V]+I[r]+"$";var J=w++;I[J]="^"+I[V]+I[f]+"$";var G=w++;I[G]="^"+I[t]+"\\s*("+o+")$|^$";var Y=w++;I[Y]="^"+I[t]+"\\s*("+n+")$|^$";var H=w++;I[H]="(\\s*)"+I[t]+"\\s*("+o+"|"+I[r]+")",R[H]=new RegExp(I[H],"g");var $=w++;I[$]="^\\s*("+I[r]+")\\s+-\\s+("+I[r]+")\\s*$";var Z=w++;I[Z]="^\\s*("+I[f]+")\\s+-\\s+("+I[f]+")\\s*$";var ie=w++;I[ie]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)l(se,I[se]),R[se]||(R[se]=new RegExp(I[se]));function ae(ce,fe){if(ce instanceof q)return ce;if(typeof ce!="string"||ce.length>O||!(fe?R[i]:R[D]).test(ce))return null;try{return new q(ce,fe)}catch{return null}}function q(ce,fe){if(ce instanceof q){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof q))return new q(ce,fe);l("SemVer",ce,fe),this.loose=fe;var ge=ce.trim().match(fe?R[i]:R[D]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<N)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var ge=ae(ce,fe);return ge?ge.version:null},e.clean=function(ce,fe){var ge=ae(ce.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(ce){return l("SemVer.compare",this.version,this.loose,ce),ce instanceof q||(ce=new q(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},q.prototype.compareMain=function(ce){return ce instanceof q||(ce=new q(ce,this.loose)),A(this.major,ce.major)||A(this.minor,ce.minor)||A(this.patch,ce.patch)},q.prototype.comparePre=function(ce){if(ce instanceof q||(ce=new q(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=ce.prerelease[fe];if(l("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return A(ge,Ie)}while(++fe)},q.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new q(ce,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(ce,fe){if(W(ce,fe))return null;var ge=ae(ce),Ie=ae(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=A;var C=/^[0-9]+$/;function A(ce,fe){var ge=C.test(ce),Ie=C.test(fe);return ge&&Ie&&(ce=+ce,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:ce<fe?-1:ce>fe?1:0}function M(ce,fe,ge){return new q(ce,ge).compare(new q(fe,ge))}function z(ce,fe,ge){return M(ce,fe,ge)>0}function _(ce,fe,ge){return M(ce,fe,ge)<0}function W(ce,fe,ge){return M(ce,fe,ge)===0}function Q(ce,fe,ge){return M(ce,fe,ge)!==0}function ee(ce,fe,ge){return M(ce,fe,ge)>=0}function le(ce,fe,ge){return M(ce,fe,ge)<=0}function he(ce,fe,ge,Ie){var Pe;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=W(ce,ge,Ie);break;case"!=":Pe=Q(ce,ge,Ie);break;case">":Pe=z(ce,ge,Ie);break;case">=":Pe=ee(ce,ge,Ie);break;case"<":Pe=_(ce,ge,Ie);break;case"<=":Pe=le(ce,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function pe(ce,fe){if(ce instanceof pe){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,fe);l("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===de?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ce,fe){return A(fe,ce)},e.major=function(ce,fe){return new q(ce,fe).major},e.minor=function(ce,fe){return new q(ce,fe).minor},e.patch=function(ce,fe){return new q(ce,fe).patch},e.compare=M,e.compareLoose=function(ce,fe){return M(ce,fe,!0)},e.rcompare=function(ce,fe,ge){return M(fe,ce,ge)},e.sort=function(ce,fe){return ce.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(ce,fe){return ce.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=z,e.lt=_,e.eq=W,e.neq=Q,e.gte=ee,e.lte=le,e.cmp=he,e.Comparator=pe;var de={};function be(ce,fe){if(ce instanceof be)return ce.loose===fe?ce:new be(ce.raw,fe);if(ce instanceof pe)return new be(ce.value,fe);if(!(this instanceof be))return new be(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Re(ce,fe,ge,Ie,Pe,Fe,Le,qe,Me,Ne,je,ne,ue){return((fe=Ce(ge)?"":Ce(Ie)?">="+ge+".0.0":Ce(Pe)?">="+ge+"."+Ie+".0":">="+fe)+" "+(qe=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(je)?"<"+Me+"."+(+Ne+1)+".0":ne?"<="+Me+"."+Ne+"."+je+"-"+ne:"<="+qe)).trim()}function ke(ce,fe){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ce.length;ge++)if(l(ce[ge].semver),ce[ge].semver!==de&&ce[ge].semver.prerelease.length>0){var Ie=ce[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function We(ce,fe,ge){try{fe=new be(fe,ge)}catch{return!1}return fe.test(ce)}function Ye(ce,fe,ge,Ie){var Pe,Fe,Le,qe,Me;switch(ce=new q(ce,Ie),fe=new be(fe,Ie),ge){case">":Pe=z,Fe=le,Le=_,qe=">",Me=">=";break;case"<":Pe=_,Fe=ee,Le=z,qe="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(ce,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var je=fe.set[Ne],ne=null,ue=null;if(je.forEach(function(me){me.semver===de&&(me=new pe(">=0.0.0")),ne=ne||me,ue=ue||me,Pe(me.semver,ne.semver,Ie)?ne=me:Le(me.semver,ue.semver,Ie)&&(ue=me)}),ne.operator===qe||ne.operator===Me||(!ue.operator||ue.operator===qe)&&Fe(ce,ue.semver)||ue.operator===Me&&Le(ce,ue.semver))return!1}return!0}pe.prototype.parse=function(ce){var fe=this.loose?R[G]:R[Y],ge=ce.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new q(ge[2],this.loose):this.semver=de},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return l("Comparator.test",ce,this.loose),this.semver===de||(typeof ce=="string"&&(ce=new q(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,fe){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,fe),We(this.value,ge,fe);if(ce.operator==="")return ge=new be(this.value,fe),We(ce.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Fe=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),qe=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ie||Pe||Fe&&Le||qe||Me},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),l("range",ce,fe);var ge=fe?R[Z]:R[$];ce=ce.replace(ge,Re),l("hyphen replace",ce),ce=ce.replace(R[H],"$1$2$3"),l("comparator trim",ce,R[H]),ce=(ce=(ce=ce.replace(R[F],"$1~")).replace(R[B],"$1^")).split(/\s+/).join(" ");var Ie=fe?R[G]:R[Y],Pe=ce.split(" ").map(function(Fe){return function(Le,qe){return l("comp",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){l("caret",ne,ue);var me=ue?R[J]:R[X];return ne.replace(me,function(we,ve,Ee,De,Ae){var Te;return l("caret",ne,we,ve,Ee,De,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(De)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Ae?(l("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+Ee+"."+(+De+1):">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+De+Ae+" <"+(+ve+1)+".0.0"):(l("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+De+" <"+ve+"."+Ee+"."+(+De+1):">="+ve+"."+Ee+"."+De+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+De+" <"+(+ve+1)+".0.0"),l("caret return",Te),Te})}(je,Ne)}).join(" ")}(Le,qe),l("caret",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){var me=ue?R[x]:R[j];return ne.replace(me,function(we,ve,Ee,De,Ae){var Te;return l("tilde",ne,we,ve,Ee,De,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(De)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Ae?(l("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+ve+"."+Ee+"."+De+Ae+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+De+" <"+ve+"."+(+Ee+1)+".0",l("tilde return",Te),Te})}(je,Ne)}).join(" ")}(Le,qe),l("tildes",Le),Le=function(Me,Ne){return l("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(je){return function(ne,ue){ne=ne.trim();var me=ue?R[y]:R[b];return ne.replace(me,function(we,ve,Ee,De,Ae,Te){l("xRange",ne,we,ve,Ee,De,Ae,Te);var Ue=Ce(Ee),$e=Ue||Ce(De),ze=$e||Ce(Ae);return ve==="="&&ze&&(ve=""),Ue?we=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?($e&&(De=0),ze&&(Ae=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,De=0,Ae=0):ze&&(De=+De+1,Ae=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:De=+De+1),we=ve+Ee+"."+De+"."+Ae):$e?we=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(we=">="+Ee+"."+De+".0 <"+Ee+"."+(+De+1)+".0"),l("xRange return",we),we})}(je,Ne)}).join(" ")}(Le,qe),l("xrange",Le),Le=function(Me,Ne){return l("replaceStars",Me,Ne),Me.trim().replace(R[ie],"")}(Le,qe),l("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new pe(Fe,fe)})},be.prototype.intersects=function(ce,fe){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return ce.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ce,fe){return new be(ce,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new q(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ce))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(ce,fe,ge){var Ie=null,Pe=null;try{var Fe=new be(fe,ge)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new q(Ie=Le,ge)))}),Ie},e.minSatisfying=function(ce,fe,ge){var Ie=null,Pe=null;try{var Fe=new be(fe,ge)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new q(Ie=Le,ge)))}),Ie},e.validRange=function(ce,fe){try{return new be(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,ge){return Ye(ce,fe,"<",ge)},e.gtr=function(ce,fe,ge){return Ye(ce,fe,">",ge)},e.outside=Ye,e.prerelease=function(ce,fe){var ge=ae(ce,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,fe,ge){return ce=new be(ce,ge),fe=new be(fe,ge),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof q)return ce;if(typeof ce!="string")return null;var fe=ce.match(R[k]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,L(1))},function(te,e){var L,U,l=te.exports={};function O(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function R(c){if(L===setTimeout)return setTimeout(c,0);if((L===O||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:O}catch{L=O}try{U=typeof clearTimeout=="function"?clearTimeout:N}catch{U=N}})();var I,w=[],P=!1,S=-1;function p(){P&&I&&(P=!1,I.length?w=I.concat(w):S=-1,w.length&&d())}function d(){if(!P){var c=R(p);P=!0;for(var u=w.length;u;){for(I=w,w=[];++S<u;)I&&I[S].run();S=-1,u=w.length}I=null,P=!1,function(h){if(U===clearTimeout)return clearTimeout(h);if((U===N||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(h);try{U(h)}catch{try{return U.call(null,h)}catch{return U.call(this,h)}}}(c)}}function m(c,u){this.fun=c,this.array=u}function E(){}l.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];w.push(new m(c,u)),w.length!==1||P||R(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(c){return[]},l.binding=function(c){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(c){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(re[132],oe([0,1]),function(te,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(R,I,w){this.level=R,this.key=I,this.value=w,this.forward=[]}}const l=void 0;class O{constructor(R,I=2**16){this.comparator=R,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new U(this.c,l,l)}get size(){return this.f}clear(){this.e=new U(this.c,l,l)}has(R){return Boolean(O.g(this,R,this.comparator))}get(R){return O.g(this,R,this.comparator)?.value}set(R,I){return O.h(this,R,I,this.comparator)&&(this.f+=1),this}delete(R){const I=O.k(this,R,this.comparator);return I&&(this.f-=1),I}forEach(R,I){let w=this.e.forward[0];for(;w;)R.call(I,w.value,w.key,this),w=w.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this.e.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static g(R,I,w){let P=R.e;for(let S=R.d-1;S>=0;S--)for(;P.forward[S]&&w(P.forward[S].key,I)<0;)P=P.forward[S];if(P=P.forward[0],P&&w(P.key,I)===0)return P}static h(R,I,w,P){const S=[];let p=R.e;for(let d=R.d-1;d>=0;d--){for(;p.forward[d]&&P(p.forward[d].key,I)<0;)p=p.forward[d];S[d]=p}if(p=p.forward[0],p&&P(p.key,I)===0)return p.value=w,!1;{const d=O.j(R);if(d>R.d){for(let m=R.d;m<d;m++)S[m]=R.e;R.d=d}p=new U(d,I,w);for(let m=0;m<d;m++)p.forward[m]=S[m].forward[m],S[m].forward[m]=p;return!0}}static j(R,I=.5){let w=1;for(;Math.random()<I&&w<R.c;)w+=1;return w}static k(R,I,w){const P=[];let S=R.e;for(let p=R.d-1;p>=0;p--){for(;S.forward[p]&&w(S.forward[p].key,I)<0;)S=S.forward[p];P[p]=S}if(S=S.forward[0],!S||w(S.key,I)!==0)return!1;for(let p=0;p<R.d&&P[p].forward[p]===S;p++)P[p].forward[p]=S.forward[p];for(;R.d>0&&R.e.forward[R.d-1]===l;)R.d-=1;return!0}}e.SkipList=O}),define(re[43],oe([0,1,10,2]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(v){const D=v;return D?typeof D.read=="function":!1}e.isReadable=l;function O(v){const D=v;return D?[D.on,D.pause,D.resume,D.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=O;function N(v){const D=v;return D?O(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=N;function R(v,D){return new I(v,D)}e.newWriteableStream=R;class I{constructor(D,n){this.e=D,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(n=>n(D))}h(D){this.c.error.length===0?(0,L.onUnexpectedError)(D):this.c.error.slice(0).forEach(n=>n(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,n){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(D,n){if(this.a.destroyed)return;let o;switch(D){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const i=o.indexOf(n);i>=0&&o.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(v,D){const n=[];let o;for(;(o=v.read())!==null;)n.push(o);return D(n)}e.consumeReadable=w;function P(v,D,n){const o=[];let i;for(;(i=v.read())!==null&&o.length<n;)o.push(i);return i===null&&o.length>0?D(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const t=i;return i=void 0,t}return v.read()}}}e.peekReadable=P;function S(v,D){return new Promise((n,o)=>{const i=[];p(v,{onData:t=>{D&&i.push(t)},onError:t=>{D?o(t):n(void 0)},onEnd:()=>{n(D?D(i):void 0)}})})}e.consumeStream=S;function p(v,D){let n=!1;return v.on("error",o=>{n||D.onError(o)}),v.on("end",()=>{n||D.onEnd()}),v.on("data",o=>{n||D.onData(o)}),(0,U.toDisposable)(()=>n=!0)}e.listenStream=p;function d(v,D){return new Promise((n,o)=>{const i=new U.DisposableStore,t=[],s=f=>{if(t.push(f),t.length>D)return i.dispose(),v.pause(),n({stream:v,buffer:t,ended:!1})},a=f=>o(f),r=()=>n({stream:v,buffer:t,ended:!0});i.add((0,U.toDisposable)(()=>v.removeListener("error",a))),v.on("error",a),i.add((0,U.toDisposable)(()=>v.removeListener("end",r))),v.on("end",r),i.add((0,U.toDisposable)(()=>v.removeListener("data",s))),v.on("data",s)})}e.peekStream=d;function m(v,D){const n=R(D);return n.end(v),n}e.toStream=m;function E(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=E;function c(v){let D=!1;return{read:()=>D?null:(D=!0,v)}}e.toReadable=c;function u(v,D,n){const o=R(n);return p(v,{onData:i=>o.write(D.data(i)),onError:i=>o.error(D.error?D.error(i):i),onEnd:()=>o.end()}),o}e.transform=u;function h(v,D,n){let o=!1;return{read:()=>{const i=D.read();return o?i:(o=!0,i!==null?n([v,i]):v)}}}e.prefixedReadable=h;function g(v,D,n){let o=!1;const i=R(n);return p(D,{onData:t=>o?i.write(t):(o=!0,i.write(n([v,t]))),onError:t=>i.error(t),onEnd:()=>{o||(o=!0,i.write(v)),i.end()}}),i}e.prefixedStream=g}),define(re[16],oe([0,1,43]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const U=typeof Buffer<"u";let l,O;class N{static alloc(f){return U?new N(Buffer.allocUnsafe(f)):new N(new Uint8Array(f))}static wrap(f){return U&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new N(f)}static fromString(f,b){return!(b?.dontUseNodeBuffer||!1)&&U?new N(Buffer.from(f)):(l||(l=new TextEncoder),new N(l.encode(f)))}static fromByteArray(f){const b=N.alloc(f.length);for(let y=0,k=f.length;y<k;y++)b.buffer[y]=f[y];return b}static concat(f,b){if(typeof b>"u"){b=0;for(let T=0,F=f.length;T<F;T++)b+=f[T].byteLength}const y=N.alloc(b);let k=0;for(let T=0,F=f.length;T<F;T++){const j=f[T];y.set(j,k),k+=j.byteLength}return y}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=N.alloc(this.byteLength);return f.set(this),f}toString(){return U?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(f,b){return new N(this.buffer.subarray(f,b))}set(f,b){if(f instanceof N)this.buffer.set(f.buffer,b);else if(f instanceof Uint8Array)this.buffer.set(f,b);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),b);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return w(this.buffer,f)}writeUInt32BE(f,b){P(this.buffer,f,b)}readUInt32LE(f){return S(this.buffer,f)}writeUInt32LE(f,b){p(this.buffer,f,b)}readUInt8(f){return d(this.buffer,f)}writeUInt8(f,b){m(this.buffer,f,b)}}e.VSBuffer=N;function R(r,f){return r[f+0]<<0>>>0|r[f+1]<<8>>>0}e.readUInt16LE=R;function I(r,f,b){r[b+0]=f&255,f=f>>>8,r[b+1]=f&255}e.writeUInt16LE=I;function w(r,f){return r[f]*2**24+r[f+1]*2**16+r[f+2]*2**8+r[f+3]}e.readUInt32BE=w;function P(r,f,b){r[b+3]=f,f=f>>>8,r[b+2]=f,f=f>>>8,r[b+1]=f,f=f>>>8,r[b]=f}e.writeUInt32BE=P;function S(r,f){return r[f+0]<<0>>>0|r[f+1]<<8>>>0|r[f+2]<<16>>>0|r[f+3]<<24>>>0}e.readUInt32LE=S;function p(r,f,b){r[b+0]=f&255,f=f>>>8,r[b+1]=f&255,f=f>>>8,r[b+2]=f&255,f=f>>>8,r[b+3]=f&255}e.writeUInt32LE=p;function d(r,f){return r[f]}e.readUInt8=d;function m(r,f,b){r[b]=f}e.writeUInt8=m;function E(r){return L.consumeReadable(r,f=>N.concat(f))}e.readableToBuffer=E;function c(r){return L.toReadable(r)}e.bufferToReadable=c;function u(r){return L.consumeStream(r,f=>N.concat(f))}e.streamToBuffer=u;async function h(r){return r.ended?N.concat(r.buffer):N.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=h;function g(r){return L.toStream(r,f=>N.concat(f))}e.bufferToStream=g;function v(r){return L.transform(r,{data:f=>typeof f=="string"?N.fromString(f):N.wrap(f)},f=>N.concat(f))}e.streamToBufferReadableStream=v;function D(r){return L.newWriteableStream(f=>N.concat(f),r)}e.newWriteableBufferStream=D;function n(r,f){return L.prefixedReadable(r,f,b=>N.concat(b))}e.prefixedBufferReadable=n;function o(r,f){return L.prefixedStream(r,f,b=>N.concat(b))}e.prefixedBufferStream=o;function i(r){let f=0,b=0,y=0;const k=new Uint8Array(Math.floor(r.length/4*3)),T=j=>{switch(b){case 3:k[y++]=f|j,b=0;break;case 2:k[y++]=f|j>>>2,f=j<<6,b=3;break;case 1:k[y++]=f|j>>>4,f=j<<4,b=2;break;default:f=j<<2,b=1}};for(let j=0;j<r.length;j++){const x=r.charCodeAt(j);if(x>=65&&x<=90)T(x-65);else if(x>=97&&x<=122)T(x-97+26);else if(x>=48&&x<=57)T(x-48+52);else if(x===43||x===45)T(62);else if(x===47||x===95)T(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${r[j]}`)}}const F=y;for(;b>0;)T(0);return N.wrap(k).slice(0,F)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:r},f=!0,b=!1){const y=b?s:t;let k="";const T=r.byteLength%3;let F=0;for(;F<r.byteLength-T;F+=3){const j=r[F+0],x=r[F+1],V=r[F+2];k+=y[j>>>2],k+=y[(j<<4|x>>>4)&63],k+=y[(x<<2|V>>>6)&63],k+=y[V&63]}if(T===1){const j=r[F+0];k+=y[j>>>2],k+=y[j<<4&63],f&&(k+="==")}else if(T===2){const j=r[F+0],x=r[F+1];k+=y[j>>>2],k+=y[(j<<4|x>>>4)&63],k+=y[x<<2&63],f&&(k+="=")}return k}e.encodeBase64=a}),define(re[133],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(re[12],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(o){return typeof o=="string"}e.isString=L;function U(o){return Array.isArray(o)&&o.every(i=>L(i))}e.isStringArray=U;function l(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=l;function O(o){const i=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof i}e.isTypedArray=O;function N(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=N;function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=R;function I(o){return o===!0||o===!1}e.isBoolean=I;function w(o){return typeof o>"u"}e.isUndefined=w;function P(o){return!S(o)}e.isDefined=P;function S(o){return w(o)||o===null}e.isUndefinedOrNull=S;function p(o,i){if(!o)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=p;function d(o){if(S(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=d;function m(...o){const i=[];for(let t=0;t<o.length;t++){const s=o[t];if(S(s))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);i.push(s)}return i}e.assertAllDefined=m;const E=Object.prototype.hasOwnProperty;function c(o){if(!l(o))return!1;for(const i in o)if(E.call(o,i))return!1;return!0}e.isEmptyObject=c;function u(o){return typeof o=="function"}e.isFunction=u;function h(...o){return o.length>0&&o.every(u)}e.areFunctions=h;function g(o,i){const t=Math.min(o.length,i.length);for(let s=0;s<t;s++)v(o[s],i[s])}e.validateConstraints=g;function v(o,i){if(L(i)){if(typeof o!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(o instanceof i)return}catch{}if(!S(o)&&o.constructor===i||i.length===1&&i.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function D(o){return o===null?void 0:o}e.withNullAsUndefined=D;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(re[52],oe([0,1,12]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const U=Object.create(null);function l(R,I){if((0,L.isString)(I)){const w=U[I];if(w===void 0)throw new Error(`${R} references an unknown codicon: ${I}`);I=w}return U[R]=I,{id:R}}function O(){return U}e.getCodiconFontCharacters=O;function N(){return Object.values(e.Codicon)}e.getAllCodicons=N,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(re[32],oe([0,1,12]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,v])=>{h[g]=v&&typeof v=="object"?U(v):v}),h}e.deepClone=U;function l(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const v in g)if(O.call(g,v)){const D=g[v];typeof D=="object"&&!Object.isFrozen(D)&&!(0,L.isTypedArray)(D)&&h.push(D)}}return u}e.deepFreeze=l;const O=Object.prototype.hasOwnProperty;function N(u,h){return R(u,h,new Set)}e.cloneAndChange=N;function R(u,h,g){if((0,L.isUndefinedOrNull)(u))return u;const v=h(u);if(typeof v<"u")return v;if(Array.isArray(u)){const D=[];for(const n of u)D.push(R(n,h,g));return D}if((0,L.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const D={};for(const n in u)O.call(u,n)&&(D[n]=R(u[n],h,g));return g.delete(u),D}return u}function I(u,h,g=!0){return(0,L.isObject)(u)?((0,L.isObject)(h)&&Object.keys(h).forEach(v=>{v in u?g&&((0,L.isObject)(u[v])&&(0,L.isObject)(h[v])?I(u[v],h[v],g):u[v]=h[v]):u[v]=h[v]}),u):h}e.mixin=I;function w(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let g,v;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(g=0;g<u.length;g++)if(!w(u[g],h[g]))return!1}else{const D=[];for(v in u)D.push(v);D.sort();const n=[];for(v in h)n.push(v);if(n.sort(),!w(D,n))return!1;for(g=0;g<D.length;g++)if(!w(u[D[g]],h[D[g]]))return!1}return!0}e.equals=w;function P(u){const h=new Set;return JSON.stringify(u,(g,v)=>{if((0,L.isObject)(v)||Array.isArray(v)){if(h.has(v))return"[Circular]";h.add(v)}return v})}e.safeStringify=P;function S(u,h){const g=Object.create(null);return!u||!h||Object.keys(h).forEach(D=>{const n=u[D],o=h[D];w(n,o)||(g[D]=o)}),g}e.distinct=S;function p(u,h){const g=h.toLowerCase(),v=Object.keys(u).find(D=>D.toLowerCase()===g);return v?u[v]:u[h]}e.getCaseInsensitive=p;function d(u,h){const g=Object.create(null);for(const[v,D]of Object.entries(u))h(v,D)&&(g[v]=D);return g}e.filter=d;function m(u){let h=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.getAllPropertyNames=m;function E(u){const h=[];for(const g of m(u))typeof u[g]=="function"&&h.push(g);return h}e.getAllMethodNames=E;function c(u,h){const g=D=>function(){const n=Array.prototype.slice.call(arguments,0);return h(D,n)},v={};for(const D of u)v[D]=g(D);return v}e.createProxyObject=c}),define(re[134],oe([0,1,52]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var U;(function(N){function R(I){return I&&typeof I=="object"&&typeof I.id=="string"}N.isThemeColor=R})(U=e.ThemeColor||(e.ThemeColor={}));function l(N){return{id:N}}e.themeColorFromId=l;var O;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function I(h){const g=R.exec(h.id);if(!g)return I(L.Codicon.error);const[,v,D]=g,n=["codicon","codicon-"+v];return D&&n.push("codicon-modifier-"+D.substring(1)),n}N.asClassNameArray=I;function w(h){return I(h).join(" ")}N.asClassName=w;function P(h){return"."+I(h).join(".")}N.asCSSSelector=P;function S(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||U.isThemeColor(h.color))}N.isThemeIcon=S;const p=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function d(h){const g=p.exec(h);if(!g)return;const[,v]=g;return{id:v}}N.fromString=d;function m(h){return{id:h}}N.fromId=m;function E(h,g){let v=h.id;const D=v.lastIndexOf("~");return D!==-1&&(v=v.substring(0,D)),g&&(v=`${v}~${g}`),{id:v}}N.modify=E;function c(h){const g=h.id.lastIndexOf("~");if(g!==-1)return h.id.substring(g+1)}N.getModifier=c;function u(h,g){return h.id===g.id&&h.color?.id===g.color?.id}N.isEqual=u})(O=e.ThemeIcon||(e.ThemeIcon={}))}),define(re[31],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(l){return L.test(l)}e.isUUID=U,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),N=[];for(let R=0;R<256;R++)N.push(R.toString(16).padStart(2,"0"));return function(){l(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let I=0,w="";return w+=N[O[I++]],w+=N[O[I++]],w+=N[O[I++]],w+=N[O[I++]],w+="-",w+=N[O[I++]],w+=N[O[I++]],w+="-",w+=N[O[I++]],w+=N[O[I++]],w+="-",w+=N[O[I++]],w+=N[O[I++]],w+="-",w+=N[O[I++]],w+=N[O[I++]],w+=N[O[I++]],w+=N[O[I++]],w+=N[O[I++]],w+=N[O[I++]],w}}()}),define(re[135],oe([0,1,34]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(N){const R=N.replace(/\-/g,":").toLowerCase();return!U.has(R)}function O(){const N=(0,L.networkInterfaces)();for(const R in N){const I=N[R];if(I){for(const{mac:w}of I)if(l(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(re[136],oe([0,1,86]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function U(R,I,w,P=1){let S=!1;return new Promise(p=>{const d=setTimeout(()=>{if(!S)return S=!0,p(0)},w);l(R,I,P,m=>{if(!S)return S=!0,clearTimeout(d),p(m)})})}e.findFreePort=U;function l(R,I,w,P){if(I===0)return P(0);const S=new L.Socket;S.once("connect",()=>(N(S),l(R+w,I-1,w,P))),S.once("data",()=>{}),S.once("error",p=>(N(S),p.code!=="ECONNREFUSED"?l(R+w,I-1,w,P):P(R))),S.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(R,I,w,P="127.0.0.1"){let S=!1,p,d=1;const m=L.createServer({pauseOnConnect:!0});function E(c,u){S||(S=!0,m.removeAllListeners(),m.close(),p&&clearTimeout(p),u(c))}return new Promise(c=>{p=setTimeout(()=>{E(0,c)},w),m.on("listening",()=>{E(R,c)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&d<I?(R++,d++,m.listen(R,P)):E(0,c)}),m.on("close",()=>{E(0,c)}),m.listen(R,P)})}e.findFreePortFaster=O;function N(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(re[87],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(U){return!!U.parentPort}e.isUtilityProcess=L}),define(re[137],oe([8,7]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[64],oe([0,1,137]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,l=U*60,O=l*24,N=O*7,R=O*30,I=O*365;function w(S,p,d,m){typeof S!="number"&&(S=S.getTime());const E=Math.round((new Date().getTime()-S)/1e3);if(E<-30)return(0,L.localize)(0,null,w(new Date().getTime()+E*1e3,!1));if(!m&&E<30)return(0,L.localize)(1,null);let c;return E<U?(c=E,p?c===1?d?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):d?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?d?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):d?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):E<l?(c=Math.floor(E/U),p?c===1?d?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):d?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?d?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):d?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):E<O?(c=Math.floor(E/l),p?c===1?d?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):d?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?d?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):d?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):E<N?(c=Math.floor(E/O),p?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):E<R?(c=Math.floor(E/N),p?c===1?d?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):d?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?d?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):d?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):E<I?(c=Math.floor(E/R),p?c===1?d?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):d?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?d?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):d?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(E/I),p?c===1?d?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):d?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?d?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):d?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=w;function P(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(re[138],oe([8,7]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,21,12,138]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(S,p){return p&&(S.stack||S.stacktrace)?l.localize(0,null,R(S),N(S.stack)||N(S.stacktrace)):R(S)}function N(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?l.localize(1,null,S.message):S.message||l.localize(2,null)}function I(S=null,p=!1){if(!S)return l.localize(3,null);if(Array.isArray(S)){const d=L.coalesce(S),m=I(d[0],p);return d.length>1?l.localize(4,null,m,d.length):m}if(U.isString(S))return S;if(S.detail){const d=S.detail;if(d.error)return O(d.error,p);if(d.exception)return O(d.exception,p)}return S.stack?O(S,p):S.message?S.message:l.localize(5,null)}e.toErrorMessage=I;function w(S){const p=S;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=w;function P(S,p){let d;return typeof S=="string"?d=new Error(S):d=S,d.actions=p,d}e.createErrorWithActions=P}),define(re[139],oe([8,7]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[140],oe([0,1,139]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function U(l){switch(l){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=U}),define(re[141],oe([8,7]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,141]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let U=!1,l=!1,O=!1,N=!1,R=!1,I=!1,w=!1,P=!1,S=!1,p=!1,d,m=e.LANGUAGE_DEFAULT,E,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const h=typeof u?.versions?.electron=="string",g=h&&u?.type==="renderer";if(typeof navigator=="object"&&!g)c=navigator.userAgent,U=c.indexOf("Windows")>=0,l=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,I=!0,d=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,m=d;else if(typeof u=="object"){U=u.platform==="win32",l=u.platform==="darwin",O=u.platform==="linux",N=O&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=h,S=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const f=JSON.parse(r),b=f.availableLanguages["*"];d=f.locale,m=b||e.LANGUAGE_DEFAULT,E=f._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function D(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let n=0;l?n=1:U?n=3:O&&(n=2),e.isWindows=U,e.isMacintosh=l,e.isLinux=O,e.isLinuxSnap=N,e.isNative=R,e.isElectron=w,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=p,e.isCI=S,e.platform=n,e.userAgent=c,e.language=m;var o;(function(r){function f(){return e.language}r.value=f;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=b;function y(){return e.language==="en"}r.isDefault=y})(o=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let y=0,k=r.length;y<k;y++){const T=r[y];if(T.id===b.data.vscodeScheduleAsyncWork){r.splice(y,1),T.callback();return}}});let f=0;return b=>{const y=++f;r.push({id:y,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return r=>setTimeout(r)})();var i;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||P?2:U?1:3;let t=!0,s=!1;function a(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const l=L.globals.vscode.process;U={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(re[13],oe([0,1,36]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,l=97,O=90,N=122,R=46,I=47,w=92,P=58,S=63;class p extends Error{constructor(o,i,t){let s;typeof i=="string"&&i.indexOf("not ")===0?(s="must not be",i=i.replace(/^not /,"")):s="must be";const a=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${a} ${s} of type ${i}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function d(n,o){if(n===null||typeof n!="object")throw new p(o,"Object",n)}function m(n,o){if(typeof n!="string")throw new p(o,"string",n)}const E=L.platform==="win32";function c(n){return n===I||n===w}function u(n){return n===I}function h(n){return n>=U&&n<=O||n>=l&&n<=N}function g(n,o,i,t){let s="",a=0,r=-1,f=0,b=0;for(let y=0;y<=n.length;++y){if(y<n.length)b=n.charCodeAt(y);else{if(t(b))break;b=I}if(t(b)){if(!(r===y-1||f===1))if(f===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==R||s.charCodeAt(s.length-2)!==R){if(s.length>2){const k=s.lastIndexOf(i);k===-1?(s="",a=0):(s=s.slice(0,k),a=s.length-1-s.lastIndexOf(i)),r=y,f=0;continue}else if(s.length!==0){s="",a=0,r=y,f=0;continue}}o&&(s+=s.length>0?`${i}..`:"..",a=2)}else s.length>0?s+=`${i}${n.slice(r+1,y)}`:s=n.slice(r+1,y),a=y-r-1;r=y,f=0}else b===R&&f!==-1?++f:f=-1}return s}function v(n,o){d(o,"pathObject");const i=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return i?i===o.root?`${i}${t}`:`${i}${n}${t}`:t}e.win32={resolve(...n){let o="",i="",t=!1;for(let s=n.length-1;s>=-1;s--){let a;if(s>=0){if(a=n[s],m(a,"path"),a.length===0)continue}else o.length===0?a=L.cwd():(a=L.env[`=${o}`]||L.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===w)&&(a=`${o}\\`));const r=a.length;let f=0,b="",y=!1;const k=a.charCodeAt(0);if(r===1)c(k)&&(f=1,y=!0);else if(c(k))if(y=!0,c(a.charCodeAt(1))){let T=2,F=T;for(;T<r&&!c(a.charCodeAt(T));)T++;if(T<r&&T!==F){const j=a.slice(F,T);for(F=T;T<r&&c(a.charCodeAt(T));)T++;if(T<r&&T!==F){for(F=T;T<r&&!c(a.charCodeAt(T));)T++;(T===r||T!==F)&&(b=`\\\\${j}\\${a.slice(F,T)}`,f=T)}}}else f=1;else h(k)&&a.charCodeAt(1)===P&&(b=a.slice(0,2),f=2,r>2&&c(a.charCodeAt(2))&&(y=!0,f=3));if(b.length>0)if(o.length>0){if(b.toLowerCase()!==o.toLowerCase())continue}else o=b;if(t){if(o.length>0)break}else if(i=`${a.slice(f)}\\${i}`,t=y,y&&o.length>0)break}return i=g(i,!t,"\\",c),t?`${o}\\${i}`:`${o}${i}`||"."},normalize(n){m(n,"path");const o=n.length;if(o===0)return".";let i=0,t,s=!1;const a=n.charCodeAt(0);if(o===1)return u(a)?"\\":n;if(c(a))if(s=!0,c(n.charCodeAt(1))){let f=2,b=f;for(;f<o&&!c(n.charCodeAt(f));)f++;if(f<o&&f!==b){const y=n.slice(b,f);for(b=f;f<o&&c(n.charCodeAt(f));)f++;if(f<o&&f!==b){for(b=f;f<o&&!c(n.charCodeAt(f));)f++;if(f===o)return`\\\\${y}\\${n.slice(b)}\\`;f!==b&&(t=`\\\\${y}\\${n.slice(b,f)}`,i=f)}}}else i=1;else h(a)&&n.charCodeAt(1)===P&&(t=n.slice(0,2),i=2,o>2&&c(n.charCodeAt(2))&&(s=!0,i=3));let r=i<o?g(n.slice(i),!s,"\\",c):"";return r.length===0&&!s&&(r="."),r.length>0&&c(n.charCodeAt(o-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(n){m(n,"path");const o=n.length;if(o===0)return!1;const i=n.charCodeAt(0);return c(i)||o>2&&h(i)&&n.charCodeAt(1)===P&&c(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let o,i;for(let a=0;a<n.length;++a){const r=n[a];m(r,"path"),r.length>0&&(o===void 0?o=i=r:o+=`\\${r}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof i=="string"&&c(i.charCodeAt(0))){++s;const a=i.length;a>1&&c(i.charCodeAt(1))&&(++s,a>2&&(c(i.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&c(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(n,o){if(m(n,"from"),m(o,"to"),n===o)return"";const i=e.win32.resolve(n),t=e.win32.resolve(o);if(i===t||(n=i.toLowerCase(),o=t.toLowerCase(),n===o))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===w;)s++;let a=n.length;for(;a-1>s&&n.charCodeAt(a-1)===w;)a--;const r=a-s;let f=0;for(;f<o.length&&o.charCodeAt(f)===w;)f++;let b=o.length;for(;b-1>f&&o.charCodeAt(b-1)===w;)b--;const y=b-f,k=r<y?r:y;let T=-1,F=0;for(;F<k;F++){const x=n.charCodeAt(s+F);if(x!==o.charCodeAt(f+F))break;x===w&&(T=F)}if(F!==k){if(T===-1)return t}else{if(y>k){if(o.charCodeAt(f+F)===w)return t.slice(f+F+1);if(F===2)return t.slice(f+F)}r>k&&(n.charCodeAt(s+F)===w?T=F:F===2&&(T=3)),T===-1&&(T=0)}let j="";for(F=s+T+1;F<=a;++F)(F===a||n.charCodeAt(F)===w)&&(j+=j.length===0?"..":"\\..");return f+=T,j.length>0?`${j}${t.slice(f,b)}`:(t.charCodeAt(f)===w&&++f,t.slice(f,b))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const o=e.win32.resolve(n);if(o.length<=2)return n;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const i=o.charCodeAt(2);if(i!==S&&i!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return n},dirname(n){m(n,"path");const o=n.length;if(o===0)return".";let i=-1,t=0;const s=n.charCodeAt(0);if(o===1)return c(s)?n:".";if(c(s)){if(i=t=1,c(n.charCodeAt(1))){let f=2,b=f;for(;f<o&&!c(n.charCodeAt(f));)f++;if(f<o&&f!==b){for(b=f;f<o&&c(n.charCodeAt(f));)f++;if(f<o&&f!==b){for(b=f;f<o&&!c(n.charCodeAt(f));)f++;if(f===o)return n;f!==b&&(i=t=f+1)}}}}else h(s)&&n.charCodeAt(1)===P&&(i=o>2&&c(n.charCodeAt(2))?3:2,t=i);let a=-1,r=!0;for(let f=o-1;f>=t;--f)if(c(n.charCodeAt(f))){if(!r){a=f;break}}else r=!1;if(a===-1){if(i===-1)return".";a=i}return n.slice(0,a)},basename(n,o){o!==void 0&&m(o,"ext"),m(n,"path");let i=0,t=-1,s=!0,a;if(n.length>=2&&h(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(i=2),o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let r=o.length-1,f=-1;for(a=n.length-1;a>=i;--a){const b=n.charCodeAt(a);if(c(b)){if(!s){i=a+1;break}}else f===-1&&(s=!1,f=a+1),r>=0&&(b===o.charCodeAt(r)?--r===-1&&(t=a):(r=-1,t=f))}return i===t?t=f:t===-1&&(t=n.length),n.slice(i,t)}for(a=n.length-1;a>=i;--a)if(c(n.charCodeAt(a))){if(!s){i=a+1;break}}else t===-1&&(s=!1,t=a+1);return t===-1?"":n.slice(i,t)},extname(n){m(n,"path");let o=0,i=-1,t=0,s=-1,a=!0,r=0;n.length>=2&&n.charCodeAt(1)===P&&h(n.charCodeAt(0))&&(o=t=2);for(let f=n.length-1;f>=o;--f){const b=n.charCodeAt(f);if(c(b)){if(!a){t=f+1;break}continue}s===-1&&(a=!1,s=f+1),b===R?i===-1?i=f:r!==1&&(r=1):i!==-1&&(r=-1)}return i===-1||s===-1||r===0||r===1&&i===s-1&&i===t+1?"":n.slice(i,s)},format:v.bind(null,"\\"),parse(n){m(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const i=n.length;let t=0,s=n.charCodeAt(0);if(i===1)return c(s)?(o.root=o.dir=n,o):(o.base=o.name=n,o);if(c(s)){if(t=1,c(n.charCodeAt(1))){let T=2,F=T;for(;T<i&&!c(n.charCodeAt(T));)T++;if(T<i&&T!==F){for(F=T;T<i&&c(n.charCodeAt(T));)T++;if(T<i&&T!==F){for(F=T;T<i&&!c(n.charCodeAt(T));)T++;T===i?t=T:T!==F&&(t=T+1)}}}}else if(h(s)&&n.charCodeAt(1)===P){if(i<=2)return o.root=o.dir=n,o;if(t=2,c(n.charCodeAt(2))){if(i===3)return o.root=o.dir=n,o;t=3}}t>0&&(o.root=n.slice(0,t));let a=-1,r=t,f=-1,b=!0,y=n.length-1,k=0;for(;y>=t;--y){if(s=n.charCodeAt(y),c(s)){if(!b){r=y+1;break}continue}f===-1&&(b=!1,f=y+1),s===R?a===-1?a=y:k!==1&&(k=1):a!==-1&&(k=-1)}return f!==-1&&(a===-1||k===0||k===1&&a===f-1&&a===r+1?o.base=o.name=n.slice(r,f):(o.name=n.slice(r,a),o.base=n.slice(r,f),o.ext=n.slice(a,f))),r>0&&r!==t?o.dir=n.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(E){const n=/\\/g;return()=>{const o=L.cwd().replace(n,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...n){let o="",i=!1;for(let t=n.length-1;t>=-1&&!i;t--){const s=t>=0?n[t]:D();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,i=s.charCodeAt(0)===I)}return o=g(o,!i,"/",u),i?`/${o}`:o.length>0?o:"."},normalize(n){if(m(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===I,i=n.charCodeAt(n.length-1)===I;return n=g(n,!o,"/",u),n.length===0?o?"/":i?"./":".":(i&&(n+="/"),o?`/${n}`:n)},isAbsolute(n){return m(n,"path"),n.length>0&&n.charCodeAt(0)===I},join(...n){if(n.length===0)return".";let o;for(let i=0;i<n.length;++i){const t=n[i];m(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(n,o){if(m(n,"from"),m(o,"to"),n===o||(n=e.posix.resolve(n),o=e.posix.resolve(o),n===o))return"";const i=1,t=n.length,s=t-i,a=1,r=o.length-a,f=s<r?s:r;let b=-1,y=0;for(;y<f;y++){const T=n.charCodeAt(i+y);if(T!==o.charCodeAt(a+y))break;T===I&&(b=y)}if(y===f)if(r>f){if(o.charCodeAt(a+y)===I)return o.slice(a+y+1);if(y===0)return o.slice(a+y)}else s>f&&(n.charCodeAt(i+y)===I?b=y:y===0&&(b=0));let k="";for(y=i+b+1;y<=t;++y)(y===t||n.charCodeAt(y)===I)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(a+b)}`},toNamespacedPath(n){return n},dirname(n){if(m(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===I;let i=-1,t=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===I){if(!t){i=s;break}}else t=!1;return i===-1?o?"/":".":o&&i===1?"//":n.slice(0,i)},basename(n,o){o!==void 0&&m(o,"ext"),m(n,"path");let i=0,t=-1,s=!0,a;if(o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let r=o.length-1,f=-1;for(a=n.length-1;a>=0;--a){const b=n.charCodeAt(a);if(b===I){if(!s){i=a+1;break}}else f===-1&&(s=!1,f=a+1),r>=0&&(b===o.charCodeAt(r)?--r===-1&&(t=a):(r=-1,t=f))}return i===t?t=f:t===-1&&(t=n.length),n.slice(i,t)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===I){if(!s){i=a+1;break}}else t===-1&&(s=!1,t=a+1);return t===-1?"":n.slice(i,t)},extname(n){m(n,"path");let o=-1,i=0,t=-1,s=!0,a=0;for(let r=n.length-1;r>=0;--r){const f=n.charCodeAt(r);if(f===I){if(!s){i=r+1;break}continue}t===-1&&(s=!1,t=r+1),f===R?o===-1?o=r:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||t===-1||a===0||a===1&&o===t-1&&o===i+1?"":n.slice(o,t)},format:v.bind(null,"/"),parse(n){m(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const i=n.charCodeAt(0)===I;let t;i?(o.root="/",t=1):t=0;let s=-1,a=0,r=-1,f=!0,b=n.length-1,y=0;for(;b>=t;--b){const k=n.charCodeAt(b);if(k===I){if(!f){a=b+1;break}continue}r===-1&&(f=!1,r=b+1),k===R?s===-1?s=b:y!==1&&(y=1):s!==-1&&(y=-1)}if(r!==-1){const k=a===0&&i?1:a;s===-1||y===0||y===1&&s===r-1&&s===a+1?o.base=o.name=n.slice(k,r):(o.name=n.slice(k,s),o.base=n.slice(k,r),o.ext=n.slice(s,r))}return a>0?o.dir=n.slice(0,a-1):i&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(re[142],oe([0,1,13]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(P){const S=(0,L.extname)(P),p=U[S.toLowerCase()];return p!==void 0?p:N(P)}e.getMediaOrTextMime=O;function N(P){const S=(0,L.extname)(P);return l[S.toLowerCase()]}e.getMediaMime=N;function R(P){for(const S in l)if(l[S]===P)return S}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function w(P,S){const p=I.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:S?void 0:P}e.normalizeMimeType=w}),define(re[88],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var U;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(U=e.Source||(e.Source={}));var l;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function O(R,...I){const w=I.reduce((p,d)=>(p[d]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(p=>!w[p]).forEach(p=>{for(let d=0;d<P.length;d++)if(p.search(P[d])!==-1){delete R[p];break}})}e.sanitizeProcessEnvironment=O;function N(R){!R||(delete R.DEBUG,L.isMacintosh&&delete R.DYLD_LIBRARY_PATH,L.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(re[89],oe([0,1,4]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const U=L.globals.performance&&typeof L.globals.performance.now=="function";class l{static create(N=!0){return new l(N)}constructor(N){this.a=U&&N,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?L.globals.performance.now():Date.now()}}e.StopWatch=l}),define(re[3],oe([0,1,10,82,2,84,89]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var w;(function(a){a.None=()=>l.Disposable.None;function r(M){if(I){const{onDidAddListener:z}=M,_=m.create();let W=0;M.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),z?.()}}}function f(M,z){return B(M,()=>{},0,void 0,!0,void 0,z)}a.defer=f;function b(M){return(z,_=null,W)=>{let Q=!1,ee;return ee=M(le=>{if(!Q)return ee?ee.dispose():Q=!0,z.call(_,le)},null,W),Q&&ee.dispose(),ee}}a.once=b;function y(M,z,_){return V((W,Q=null,ee)=>M(le=>W.call(Q,z(le)),null,ee),_)}a.map=y;function k(M,z,_){return V((W,Q=null,ee)=>M(le=>{z(le),W.call(Q,le)},null,ee),_)}a.forEach=k;function T(M,z,_){return V((W,Q=null,ee)=>M(le=>z(le)&&W.call(Q,le),null,ee),_)}a.filter=T;function F(M){return M}a.signal=F;function j(...M){return(z,_=null,W)=>(0,l.combinedDisposable)(...M.map(Q=>Q(ee=>z.call(_,ee),null,W)))}a.any=j;function x(M,z,_,W){let Q=_;return y(M,ee=>(Q=z(Q,ee),Q),W)}a.reduce=x;function V(M,z){let _;const W={onWillAddFirstListener(){_=M(Q.fire,Q)},onDidRemoveLastListener(){_?.dispose()}};z||r(W);const Q=new c(W);return z?.add(Q),Q.event}function B(M,z,_=100,W=!1,Q=!1,ee,le){let he,pe,de,be=0,Ce;const Re={leakWarningThreshold:ee,onWillAddFirstListener(){he=M(We=>{be++,pe=z(pe,We),W&&!de&&(ke.fire(pe),pe=void 0),Ce=()=>{const Ye=pe;pe=void 0,de=void 0,(!W||be>1)&&ke.fire(Ye),be=0},typeof _=="number"?(clearTimeout(de),de=setTimeout(Ce,_)):de===void 0&&(de=0,queueMicrotask(Ce))})},onWillRemoveListener(){Q&&be>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};le||r(Re);const ke=new c(Re);return le?.add(ke),ke.event}a.debounce=B;function X(M,z=0,_){return a.debounce(M,(W,Q)=>W?(W.push(Q),W):[Q],z,void 0,!0,void 0,_)}a.accumulate=X;function J(M,z=(W,Q)=>W===Q,_){let W=!0,Q;return T(M,ee=>{const le=W||!z(ee,Q);return W=!1,Q=ee,le},_)}a.latch=J;function G(M,z,_){return[a.filter(M,z,_),a.filter(M,W=>!z(W),_)]}a.split=G;function Y(M,z=!1,_=[]){let W=_.slice(),Q=M(he=>{W?W.push(he):le.fire(he)});const ee=()=>{W?.forEach(he=>le.fire(he)),W=null},le=new c({onWillAddFirstListener(){Q||(Q=M(he=>le.fire(he)))},onDidAddFirstListener(){W&&(z?setTimeout(ee):ee())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return le.event}a.buffer=Y;class H{constructor(z){this.event=z,this.c=new l.DisposableStore}map(z){return new H(y(this.event,z,this.c))}forEach(z){return new H(k(this.event,z,this.c))}filter(z){return new H(T(this.event,z,this.c))}reduce(z,_){return new H(x(this.event,z,_,this.c))}latch(){return new H(J(this.event,void 0,this.c))}debounce(z,_=100,W=!1,Q=!1,ee){return new H(B(this.event,z,_,W,Q,ee,this.c))}on(z,_,W){return this.event(z,_,W)}once(z,_,W){return b(this.event)(z,_,W)}dispose(){this.c.dispose()}}function $(M){return new H(M)}a.chain=$;function Z(M,z,_=W=>W){const W=(...he)=>le.fire(_(...he)),Q=()=>M.on(z,W),ee=()=>M.removeListener(z,W),le=new c({onWillAddFirstListener:Q,onDidRemoveLastListener:ee});return le.event}a.fromNodeEventEmitter=Z;function ie(M,z,_=W=>W){const W=(...he)=>le.fire(_(...he)),Q=()=>M.addEventListener(z,W),ee=()=>M.removeEventListener(z,W),le=new c({onWillAddFirstListener:Q,onDidRemoveLastListener:ee});return le.event}a.fromDOMEventEmitter=ie;function se(M){return new Promise(z=>b(M)(z))}a.toPromise=se;function ae(M,z){return z(void 0),M(_=>z(_))}a.runAndSubscribe=ae;function q(M,z){let _=null;function W(ee){_?.dispose(),_=new l.DisposableStore,z(ee,_)}W(void 0);const Q=M(ee=>W(ee));return(0,l.toDisposable)(()=>{Q.dispose(),_?.dispose()})}a.runAndSubscribeWithStore=q;class C{constructor(z,_){this.obs=z,this.c=0,this.d=!1;const W={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};_||r(W),this.emitter=new c(W),_&&_.add(this.emitter)}beginUpdate(z){this.c++}handleChange(z,_){this.d=!0}endUpdate(z){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function A(M,z){return new C(M,z).emitter.event}a.fromObservable=A})(w=e.Event||(e.Event={}));class P{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${P.c++}`,P.all.add(this)}start(r){this.d=new N.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}P.all=new Set,P.c=0,e.EventProfiling=P;let S=-1;function p(a){const r=S;return S=a,{dispose(){S=r}}}e.setGlobalLeakWarningThreshold=p;class d{constructor(r,f=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=f,this.d=0}dispose(){this.c?.clear()}check(r,f){const b=this.threshold;if(b<=0||f<b)return;this.c||(this.c=new Map);const y=this.c.get(r.value)||0;if(this.c.set(r.value,y+1),this.d-=1,this.d<=0){this.d=b*.5;let k,T=0;for(const[F,j]of this.c)(!k||T<j)&&(k=F,T=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${T}):`),console.warn(k)}return()=>{const k=this.c.get(r.value)||0;this.c.set(r.value,k-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(r,f,b){this.callback=r,this.callbackThis=f,this.stack=b,this.subscription=new l.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class c{constructor(r){this.j=!1,this.d=r,this.f=S>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const r=Array.from(this.q);queueMicrotask(()=>{for(const f of r)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,f,b)=>{if(this.q||(this.q=new O.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const y=this.q.isEmpty();y&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let k,T;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(T=m.create(),k=this.f.check(T,this.q.size+1)),R&&(T=T??m.create());const F=new E(r,f,T),j=this.q.push(F);y&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,f);const x=F.subscription.set(()=>{k?.(),this.j||(this.d?.onWillRemoveListener?.(this),j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof l.DisposableStore?b.add(x):Array.isArray(b)&&b.push(x),x}),this.l}fire(r){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const f of this.q)this.m.push(this,f,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=c;class u{constructor(r=L.onUnexpectedError){this.d=r,this.c=new O.LinkedList}get size(){return this.c.size}push(r,f,b){this.c.push(new g(r,f,b))}clear(r){const f=new O.LinkedList;for(const b of this.c)b.emitter!==r&&f.push(b);this.c=f}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(f){this.d(f)}}}}e.EventDeliveryQueue=u;class h extends u{clear(r){this.c.clear()}}class g{constructor(r,f,b){this.emitter=r,this.listener=f,this.event=b}}class v extends c{async fireAsync(r,f,b){if(!!this.q){this.c||(this.c=new O.LinkedList);for(const y of this.q)this.c.push([y,r]);for(;this.c.size>0&&!f.isCancellationRequested;){const[y,k]=this.c.shift(),T=[],F={...k,token:f,waitUntil:j=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");b&&(j=b(j,y.callback)),T.push(j)}};try{y.invoke(F)}catch(j){(0,L.onUnexpectedError)(j);continue}Object.freeze(T),await Promise.allSettled(T).then(j=>{for(const x of j)x.status==="rejected"&&(0,L.onUnexpectedError)(x.reason)})}}}}e.AsyncEmitter=v;class D extends c{constructor(r){super(r),this.h=0,this.s=new O.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=D;class n extends D{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=n;class o extends c{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(f=>super.fire(f)),this.c=[]}))}}e.MicrotaskEmitter=o;class i{constructor(){this.d=!1,this.f=[],this.c=new c({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const f={event:r,listener:null};this.f.push(f),this.d&&this.j(f);const b=()=>{this.d&&this.k(f);const y=this.f.indexOf(f);this.f.splice(y,1)};return(0,l.toDisposable)((0,U.once)(b))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(f=>this.c.fire(f))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class t{constructor(){this.c=[]}wrapEvent(r){return(f,b,y)=>r(k=>{const T=this.c[this.c.length-1];T?T.push(()=>f.call(b,k)):f.call(b,k)},void 0,y)}bufferEvents(r){const f=[];this.c.push(f);const b=r();return this.c.pop(),f.forEach(y=>y()),b}}e.EventBufferer=t;class s{constructor(){this.c=!1,this.d=w.None,this.f=l.Disposable.None,this.g=new c({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[25],oe([0,1,3]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(R,I){const w=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(w)}}});var l;(function(R){function I(w){return w===R.None||w===R.Cancelled||w instanceof O?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(l=e.CancellationToken||(e.CancellationToken={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?U:(this.b||(this.b=new L.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=l.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=N}),define(re[143],oe([0,1,25]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new L.CancellationTokenSource,I=this.b(R.token);return this.a={promise:I,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=U;class l{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const I=JSON.stringify(R);return this.b!==I&&(this.b=I,this.a=this.c(R)),this.a}}e.LRUCachedFunction=l;class O{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const I=this.b(R);return this.a.set(R,I),I}}e.CachedFunction=O}),define(re[27],oe([0,1,143,130]),function(te,e,L,U){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function O(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=O;const N=/{(\d+)}/g;function R(ne,...ue){return ue.length===0?ne:ne.replace(N,function(me,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=ue.length?me:ue[ve]})}e.format=R;const I=/{([^}]+)}/g;function w(ne,ue){return ne.replace(I,(me,we)=>ue[we]??me)}e.format2=w;function P(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function S(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function p(ne,ue){let me=0;const we=ue.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===we&&me++;return me}e.count=p;function d(ne,ue,me="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${me}`}e.truncate=d;function m(ne,ue=" "){const me=E(ne,ue);return c(me,ue)}e.trim=m;function E(ne,ue){if(!ne||!ue)return ne;const me=ue.length;if(me===0||ne.length===0)return ne;let we=0;for(;ne.indexOf(ue,we)===we;)we=we+me;return ne.substring(we)}e.ltrim=E;function c(ne,ue){if(!ne||!ue)return ne;const me=ue.length,we=ne.length;if(me===0||we===0)return ne;let ve=we,Ee=-1;for(;Ee=ne.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+me!==ve);){if(Ee===0)return"";ve=Ee}return ne.substring(0,ve)}e.rtrim=c;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function h(ne){return ne.replace(/\*/g,"")}e.stripWildcards=h;function g(ne,ue,me={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=S(ne)),me.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let we="";return me.global&&(we+="g"),me.matchCase||(we+="i"),me.multiline&&(we+="m"),me.unicode&&(we+="u"),new RegExp(ne,we)}e.createRegExp=g;function v(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function D(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function n(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=n;function o(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=o;function i(ne){for(let ue=0,me=ne.length;ue<me;ue++){const we=ne.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function t(ne,ue=0,me=ne.length){for(let we=ue;we<me;we++){const ve=ne.charCodeAt(we);if(ve!==32&&ve!==9)return ne.substring(ue,we)}return ne.substring(ue,me)}e.getLeadingWhitespace=t;function s(ne,ue=ne.length-1){for(let me=ue;me>=0;me--){const we=ne.charCodeAt(me);if(we!==32&&we!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function a(ne,ue,me){const we=[];let ve=0;for(const Ee of ne.matchAll(ue)){if(we.push(ne.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,we.push(me(Ee[0],...Ee.slice(1),Ee.index,ne,Ee.groups))}return we.push(ne.slice(ve)),Promise.all(we).then(Ee=>Ee.join(""))}e.replaceAsync=a;function r(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=r;function f(ne,ue,me=0,we=ne.length,ve=0,Ee=ue.length){for(;me<we&&ve<Ee;me++,ve++){const Te=ne.charCodeAt(me),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const De=we-me,Ae=Ee-ve;return De<Ae?-1:De>Ae?1:0}e.compareSubstring=f;function b(ne,ue){return y(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=b;function y(ne,ue,me=0,we=ne.length,ve=0,Ee=ue.length){for(;me<we&&ve<Ee;me++,ve++){let Te=ne.charCodeAt(me),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return f(ne.toLowerCase(),ue.toLowerCase(),me,we,ve,Ee);T(Te)&&(Te-=32),T(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const De=we-me,Ae=Ee-ve;return De<Ae?-1:De>Ae?1:0}e.compareSubstringIgnoreCase=y;function k(ne){return ne>=48&&ne<=57}e.isAsciiDigit=k;function T(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=T;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function j(ne,ue){return ne.length===ue.length&&y(ne,ue)===0}e.equalsIgnoreCase=j;function x(ne,ue){const me=ue.length;return ue.length>ne.length?!1:y(ne,ue,0,me)===0}e.startsWithIgnoreCase=x;function V(ne,ue){const me=Math.min(ne.length,ue.length);let we;for(we=0;we<me;we++)if(ne.charCodeAt(we)!==ue.charCodeAt(we))return we;return me}e.commonPrefixLength=V;function B(ne,ue){const me=Math.min(ne.length,ue.length);let we;const ve=ne.length-1,Ee=ue.length-1;for(we=0;we<me;we++)if(ne.charCodeAt(ve-we)!==ue.charCodeAt(Ee-we))return we;return me}e.commonSuffixLength=B;function X(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=X;function J(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=J;function G(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=G;function Y(ne,ue,me){const we=ne.charCodeAt(me);if(X(we)&&me+1<ue){const ve=ne.charCodeAt(me+1);if(J(ve))return G(we,ve)}return we}e.getNextCodePoint=Y;function H(ne,ue){const me=ne.charCodeAt(ue-1);if(J(me)&&ue>1){const we=ne.charCodeAt(ue-2);if(X(we))return G(we,me)}return me}class ${get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=H(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Y(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=$;class Z{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new $(ue,me)}nextGraphemeLength(){const ue=Ie.getInstance(),me=this.c,we=me.offset;let ve=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ee=me.offset,De=ue.getGraphemeBreakType(me.nextCodePoint());if(fe(ve,De)){me.setOffset(Ee);break}ve=De}return me.offset-we}prevGraphemeLength(){const ue=Ie.getInstance(),me=this.c,we=me.offset;let ve=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ee=me.offset,De=ue.getGraphemeBreakType(me.prevCodePoint());if(fe(De,ve)){me.setOffset(Ee);break}ve=De}return we-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function ie(ne,ue){return new Z(ne,ue).nextGraphemeLength()}e.nextCharLength=ie;function se(ne,ue){return new Z(ne,ue).prevGraphemeLength()}e.prevCharLength=se;function ae(ne,ue){ue>0&&J(ne.charCodeAt(ue))&&ue--;const me=ue+ie(ne,ue);return[me-se(ne,me),me]}e.getCharContainingOffset=ae;function q(ne){const ue=new Z(ne);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.charCount=q;let C;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(ne){return C||(C=A()),C.test(ne)}e.containsRTL=M;const z=/^[\t\n\r\x20-\x7E]*$/;function _(ne){return z.test(ne)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=W;function Q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Q;function ee(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ee;function le(ne,ue){if(ne.length<ue)return ne;const me=/\b/g;let we=0;for(;me.test(ne)&&!(ne.length-me.lastIndex<ue);)we=me.lastIndex,me.lastIndex+=1;return ne.substring(we).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function pe(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function be(ne){return de(ne)?ne.substr(1):ne}e.stripUTF8BOM=be;function Ce(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const me=ue.length,we=ne.toLowerCase();let ve=0,Ee=-1;for(;ve<me;){const De=we.indexOf(ue[ve],Ee+1);if(De<0)return!1;Ee=De,ve++}return!0}e.fuzzyContains=Ce;function Re(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Re;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ke;function We(ne,ue=1){if(ue===0)return"";let me=-1;do me=ne.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?ne:(ne[me-1]==="\r"&&me--,ne.substr(0,me))}e.getNLines=We;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function ce(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ce;function fe(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var ge;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,we=me.length/3;let ve=1;for(;ve<=we;)if(ue<me[3*ve])ve=2*ve;else if(ue>me[3*ve+1])ve=2*ve+1;else return me[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ne,ue){if(ne===0)return 0;const me=Le(ne,ue);if(me!==void 0)return me;const we=new $(ue,ne);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Fe;function Le(ne,ue){const me=new $(ue,ne);let we=me.prevCodePoint();for(;qe(we)||we===65039||we===8419;){if(me.offset===0)return;we=me.prevCodePoint()}if(!ee(we))return;let ve=me.offset;return ve>0&&me.prevCodePoint()===8205&&(ve=me.offset),ve}function qe(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ne,Ne.c=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new L.LRUCachedFunction(ne=>{function ue(Ue){const $e=new Map;for(let ze=0;ze<Ue.length;ze+=2)$e.set(Ue[ze],Ue[ze+1]);return $e}function me(Ue,$e){const ze=new Map(Ue);for(const[et,nt]of $e)ze.set(et,nt);return ze}function we(Ue,$e){if(!Ue)return $e;const ze=new Map;for(const[et,nt]of Ue)$e.has(et)&&ze.set(et,nt);return ze}const ve=l.c.value;let Ee=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let De;for(const Ue of Ee){const $e=ue(ve[Ue]);De=we(De,$e)}const Ae=ue(ve._common),Te=me(Ae,De);return new Ne(Te)}),Ne.e=new U.Lazy(()=>Object.keys(Ne.c.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Ne;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ue){return je.e().has(ue)}static get codePoints(){return je.e()}}je.d=void 0,e.InvisibleCharacters=je}),define(re[48],oe([0,1,13,4,27,12]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function N(s){return s===47||s===92}e.isPathSeparator=N;function R(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function I(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function w(s,a=L.posix.sep){if(!s)return"";const r=s.length,f=s.charCodeAt(0);if(N(f)){if(N(s.charCodeAt(1))&&!N(s.charCodeAt(2))){let y=3;const k=y;for(;y<r&&!N(s.charCodeAt(y));y++);if(k!==y&&!N(s.charCodeAt(y+1))){for(y+=1;y<r;y++)if(N(s.charCodeAt(y)))return s.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(u(f)&&s.charCodeAt(1)===58)return N(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<r;b++)if(N(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=w;function P(s){if(!U.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let r=2;const f=r;for(;r<s.length&&(a=s.charCodeAt(r),a!==92);r++);return!(f===r||(a=s.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=P;const S=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(s,a=U.isWindows){const r=a?S:p;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||a&&d.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=m;function E(s,a,r){const f=s===a;return!r||f?f:!s||!a?!1:(0,l.equalsIgnoreCase)(s,a)}e.isEqual=E;function c(s,a,r,f=L.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(r){if(!(0,l.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let y=a.length;return a.charAt(a.length-1)===f&&y--,s.charAt(y)===f}return a.charAt(a.length-1)!==f&&(a+=f),s.indexOf(a)===0}e.isEqualOrParent=c;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function h(s,a){return U.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(a,s)),s=(0,L.normalize)(s),U.isWindows?(s=(0,l.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,l.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=h;function g(s){const a=(0,L.normalize)(s);return U.isWindows?s.length>3?!1:v(a)&&(s.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=g;function v(s,a=U.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function D(s){return v(s)?s[0]:void 0}e.getDriveLetter=D;function n(s,a,r){return a.length>s.length?-1:s===a?0:(r&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=n;function o(s){const a=s.split(":");let r,f,b;for(const y of a){const k=Number(y);(0,O.isNumber)(k)?f===void 0?f=k:b===void 0&&(b=k):r=r?[r,y].join(":"):y}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:f!==void 0?f:void 0,column:b!==void 0?b:f!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,a,r=8){let f="";for(let y=0;y<r;y++)f+=i.charAt(Math.floor(Math.random()*i.length));let b;return a?b=`${a}-${f}`:b=f,s?(0,L.join)(s,b):b}e.randomPath=t}),define(re[53],oe([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function U(u){return l(u,0)}e.hash=U;function l(u,h){switch(typeof u){case"object":return u===null?O(349,h):Array.isArray(u)?I(u,h):w(u,h);case"string":return R(u,h);case"boolean":return N(u,h);case"number":return O(u,h);case"undefined":return O(937,h);default:return O(617,h)}}e.doHash=l;function O(u,h){return(h<<5)-h+u|0}e.numberHash=O;function N(u,h){return O(u?433:863,h)}function R(u,h){h=O(149417,h);for(let g=0,v=u.length;g<v;g++)h=O(u.charCodeAt(g),h);return h}e.stringHash=R;function I(u,h){return h=O(104579,h),u.reduce((g,v)=>l(v,g),h)}function w(u,h){return h=O(181387,h),Object.keys(u).sort().reduce((g,v)=>(g=R(v,g),l(u[v],g)),h)}class P{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=l(h,this.g),this.g}}e.Hasher=P;var S;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function p(u,h,g=32){const v=g-h,D=~((1<<v)-1);return(u<<h|(D&u)>>>v)>>>0}function d(u,h=0,g=u.byteLength,v=0){for(let D=0;D<g;D++)u[h+D]=v}function m(u,h,g="0"){for(;u.length<h;)u=g+u;return u}function E(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),h/4)}e.toHexString=E;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const g=h.length;if(g===0)return;const v=this.p;let D=this.r,n=this.u,o,i;for(n!==0?(o=n,i=-1,n=0):(o=h.charCodeAt(0),i=0);;){let t=o;if(L.isHighSurrogate(o))if(i+1<g){const s=h.charCodeAt(i+1);L.isLowSurrogate(s)?(i++,t=L.computeCodePoint(o,s)):t=65533}else{n=o;break}else L.isLowSurrogate(o)&&(t=65533);if(D=this.w(v,D,t),i++,i<g)o=h.charCodeAt(i);else break}this.r=D,this.u=n}w(h,g,v){return v<128?h[g++]=v:v<2048?(h[g++]=192|(v&1984)>>>6,h[g++]=128|(v&63)>>>0):v<65536?(h[g++]=224|(v&61440)>>>12,h[g++]=128|(v&4032)>>>6,h[g++]=128|(v&63)>>>0):(h[g++]=240|(v&1835008)>>>18,h[g++]=128|(v&258048)>>>12,h[g++]=128|(v&4032)>>>6,h[g++]=128|(v&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=c.g,g=this.q;for(let r=0;r<64;r+=4)h.setUint32(r,g.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)h.setUint32(r,p(h.getUint32(r-12,!1)^h.getUint32(r-32,!1)^h.getUint32(r-56,!1)^h.getUint32(r-64,!1),1),!1);let v=this.h,D=this.l,n=this.m,o=this.n,i=this.o,t,s,a;for(let r=0;r<80;r++)r<20?(t=D&n|~D&o,s=1518500249):r<40?(t=D^n^o,s=1859775393):r<60?(t=D&n|D&o|n&o,s=2400959708):(t=D^n^o,s=3395469782),a=p(v,5)+t+i+s+h.getUint32(r*4,!1)&4294967295,i=o,o=n,n=p(D,30),D=v,v=a;this.h=this.h+v&4294967295,this.l=this.l+D&4294967295,this.m=this.m+n&4294967295,this.n=this.n+o&4294967295,this.o=this.o+i&4294967295}}c.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(re[90],oe([0,1,27]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(U||(U={})),function(l){const O="error",N="warning",R="warn",I="info",w="ignore";function P(p){return p?L.equalsIgnoreCase(O,p)?l.Error:L.equalsIgnoreCase(N,p)||L.equalsIgnoreCase(R,p)?l.Warning:L.equalsIgnoreCase(I,p)?l.Info:l.Ignore:l.Ignore}l.fromValue=P;function S(p){switch(p){case l.Error:return O;case l.Warning:return N;case l.Info:return I;default:return w}}l.toString=S}(U||(U={})),e.default=U}),define(re[49],oe([0,1,21,27]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const m=d.charCodeAt(0),E=this.b.charCodeAt(this.c);return m-E}value(){return this.b[this.c]}}e.StringIterator=l;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,U.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,U.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=O;class N{constructor(d=!0,m=!0){this.f=d,this.g=m}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let m=d.length-1;m>=0;m--,this.c--){const E=this.b.charCodeAt(m);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,U.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,U.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=N;var R;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(d,m){this.f=d,this.g=m,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,U.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,U.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,U.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,U.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class S{static forUris(d=()=>!1,m=()=>!1){return new S(new I(d,m))}static forPaths(d=!1){return new S(new N(void 0,!d))}static forStrings(){return new S(new l)}static forConfigKeys(){return new S(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,m){if(m){const E=m.slice(0);(0,L.shuffle)(E);for(const c of E)this.set(c,d)}else{const E=d.slice(0);(0,L.shuffle)(E);for(const c of E)this.set(c[0],c[1])}}set(d,m){const E=this.b.reset(d);let c;this.c||(this.c=new w,this.c.segment=E.value());const u=[];for(c=this.c;;){const g=E.cmp(c.segment);if(g>0)c.left||(c.left=new w,c.left.segment=E.value()),u.push([-1,c]),c=c.left;else if(g<0)c.right||(c.right=new w,c.right.segment=E.value()),u.push([1,c]),c=c.right;else if(E.hasNext())E.next(),c.mid||(c.mid=new w,c.mid.segment=E.value()),u.push([0,c]),c=c.mid;else break}const h=c.value;c.value=m,c.key=d;for(let g=u.length-1;g>=0;g--){const v=u[g][1];v.updateHeight();const D=v.balanceFactor();if(D<-1||D>1){const n=u[g][0],o=u[g+1][0];if(n===1&&o===1)u[g][1]=v.rotateLeft();else if(n===-1&&o===-1)u[g][1]=v.rotateRight();else if(n===1&&o===-1)v.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=v.rotateLeft();else if(n===-1&&o===1)v.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=v.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return h}get(d){return this.d(d)?.value}d(d){const m=this.b.reset(d);let E=this.c;for(;E;){const c=m.cmp(E.segment);if(c>0)E=E.left;else if(c<0)E=E.right;else if(m.hasNext())m.next(),E=E.mid;else break}return E}has(d){const m=this.d(d);return!(m?.value===void 0&&m?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,m){const E=this.b.reset(d),c=[];let u=this.c;for(;u;){const h=E.cmp(u.segment);if(h>0)c.push([-1,u]),u=u.left;else if(h<0)c.push([1,u]),u=u.right;else if(E.hasNext())E.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this.f(u.right);if(h.key){const{key:g,value:v,segment:D}=h;this.e(h.key,!1),u.key=g,u.value=v,u.segment=D}}else{const h=u.left??u.right;if(c.length>0){const[g,v]=c[c.length-1];switch(g){case-1:v.left=h;break;case 0:v.mid=h;break;case 1:v.right=h;break}}else this.c=h}for(let h=c.length-1;h>=0;h--){const g=c[h][1];g.updateHeight();const v=g.balanceFactor();if(v>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),c[h][1]=g.rotateLeft()):v<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),c[h][1]=g.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const m=this.b.reset(d);let E=this.c,c;for(;E;){const u=m.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(m.hasNext())m.next(),c=E.value||c,E=E.mid;else break}return E&&E.value||c}findSuperstr(d){return this.g(d,!1)}g(d,m){const E=this.b.reset(d);let c=this.c;for(;c;){const u=E.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(E.hasNext())E.next(),c=c.mid;else return c.mid?this.h(c.mid):m?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[m,E]of this)d(E,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const m=[];return this.j(d,m),m[Symbol.iterator]()}j(d,m){!d||(d.left&&this.j(d.left,m),d.value&&m.push([d.key,d.value]),d.mid&&this.j(d.mid,m),d.right&&this.j(d.right,m))}_isBalanced(){const d=m=>{if(!m)return!0;const E=m.balanceFactor();return E<-1||E>1?!1:d(m.left)&&d(m.right)};return d(this.c)}}e.TernarySearchTree=S}),define(re[11],oe([0,1,13,4]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,O=/^\//,N=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!l.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,t){return!i&&!t?"file":i}function w(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const P="",S="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(t){return t instanceof d?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,s,a,r,f,b=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=I(t,b),this.authority=s||P,this.path=w(this.scheme,a||P),this.query=r||P,this.fragment=f||P,R(this,b))}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:a,path:r,query:f,fragment:b}=t;return s===void 0?s=this.scheme:s===null&&(s=P),a===void 0?a=this.authority:a===null&&(a=P),r===void 0?r=this.path:r===null&&(r=P),f===void 0?f=this.query:f===null&&(f=P),b===void 0?b=this.fragment:b===null&&(b=P),s===this.scheme&&a===this.authority&&r===this.path&&f===this.query&&b===this.fragment?this:new E(s,a,r,f,b)}static parse(t,s=!1){const a=p.exec(t);return a?new E(a[2]||P,o(a[4]||P),o(a[5]||P),o(a[7]||P),o(a[9]||P),s):new E(P,P,P,P,P)}static file(t){let s=P;if(U.isWindows&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(s=t.substring(2),t=S):(s=t.substring(2,a),t=t.substring(a)||S)}return new E("file",s,t,P,P)}static from(t){const s=new E(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return U.isWindows&&t.scheme==="file"?a=d.file(L.win32.join(g(t,!0),...s)).path:a=L.posix.join(t.path,...s),t.with({path:a})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof d)return t;{const s=new E(t);return s._formatted=t.external,s._fsPath=t._sep===m?t.fsPath:null,s}}else return t}}e.URI=d;const m=U.isWindows?1:void 0;class E extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=m),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,s){let a,r=-1;for(let f=0;f<i.length;f++){const b=i.charCodeAt(f);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||t&&b===47||s&&b===91||s&&b===93||s&&b===58)r!==-1&&(a+=encodeURIComponent(i.substring(r,f)),r=-1),a!==void 0&&(a+=i.charAt(f));else{a===void 0&&(a=i.substr(0,f));const y=c[b];y!==void 0?(r!==-1&&(a+=encodeURIComponent(i.substring(r,f)),r=-1),a+=y):r===-1&&(r=f)}}return r!==-1&&(a+=encodeURIComponent(i.substring(r))),a!==void 0?a:i}function h(i){let t;for(let s=0;s<i.length;s++){const a=i.charCodeAt(s);a===35||a===63?(t===void 0&&(t=i.substr(0,s)),t+=c[a]):t!==void 0&&(t+=i[s])}return t!==void 0?t:i}function g(i,t){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,U.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function v(i,t){const s=t?h:u;let a="",{scheme:r,authority:f,path:b,query:y,fragment:k}=i;if(r&&(a+=r,a+=":"),(f||r==="file")&&(a+=S,a+=S),f){let T=f.indexOf("@");if(T!==-1){const F=f.substr(0,T);f=f.substr(T+1),T=F.lastIndexOf(":"),T===-1?a+=s(F,!1,!1):(a+=s(F.substr(0,T),!1,!1),a+=":",a+=s(F.substr(T+1),!1,!0)),a+="@"}f=f.toLowerCase(),T=f.lastIndexOf(":"),T===-1?a+=s(f,!1,!0):(a+=s(f.substr(0,T),!1,!0),a+=f.substr(T))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const T=b.charCodeAt(1);T>=65&&T<=90&&(b=`/${String.fromCharCode(T+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const T=b.charCodeAt(0);T>=65&&T<=90&&(b=`${String.fromCharCode(T+32)}:${b.substr(2)}`)}a+=s(b,!0,!1)}return y&&(a+="?",a+=s(y,!1,!1)),k&&(a+="#",a+=t?k:u(k,!1,!1)),a}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,t=>D(t)):i}}),define(re[144],oe([0,1,11]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(w){const P=w;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=U;function l(w){const P=[];let S;try{const p=JSON.parse(w.arguments),d=p[p.length-1];d&&d.__$stack&&(p.pop(),S=d.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",w.arguments)}return{args:P,stack:S}}e.parse=l;function O(w){if(typeof w!="string")return O(l(w).stack);const P=w;if(P){const S=N(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(p&&p.length===4)return{uri:L.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=O;function N(w){if(!w)return w;const P=w.indexOf(`
`);return P===-1?w:w.substring(0,P)}function R(w,P){const{args:S,stack:p}=l(w),d=typeof S[0]=="string"&&S.length===1;let m=N(p);m&&(m=`(${m.trim()})`);let E=[];if(typeof S[0]=="string"?m&&d?E=[`%c[${P}] %c${S[0]} %c${m}`,I("blue"),I(""),I("grey")]:E=[`%c[${P}] %c${S[0]}`,I("blue"),I(""),...S.slice(1)]:E=[`%c[${P}]%`,I("blue"),...S],m&&!d&&E.push(m),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,E)}e.log=R;function I(w){return`color: ${w}`}}),define(re[91],oe([0,1,16,27,11]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function O(w){return JSON.stringify(w,R)}e.stringify=O;function N(w){let P=JSON.parse(w);return P=I(P),P}e.parse=N;function R(w,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,U.regExpFlags)(P)}:P}function I(w,P=0){if(!w||P>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return l.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof L.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let S=0;S<w.length;++S)w[S]=I(w[S],P+1);else for(const S in w)Object.hasOwnProperty.call(w,S)&&(w[S]=I(w[S],P+1))}return w}e.revive=I}),define(re[22],oe([0,1,10,4,11]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(O=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${O.vscodeRemoteResource}`}set(P,S,p){this.a[P]=S,this.b[P]=p}setConnectionToken(P,S){this.c[P]=S}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(c){return L.onUnexpectedError(c),P}const S=P.authority;let p=this.a[S];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const d=this.b[S],m=this.c[S];let E=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),l.URI.from({scheme:U.isWeb?this.d:O.vscodeRemoteResource,authority:`${p}:${d}`,path:this.f,query:E})}}e.RemoteAuthorities=new N,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(P){const S=this.b(P,te);return this.uriToBrowserUri(S)}uriToBrowserUri(P){return P.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===O.file&&(U.isNative||U.isWebWorker&&U.globals.origin===`${O.vscodeFileResource}://${R.a}`)?P.with({scheme:O.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const S=this.b(P,te);return this.uriToFileUri(S)}uriToFileUri(P){return P.scheme===O.vscodeFileResource?P.with({scheme:O.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,S){return l.URI.isUri(P)?P:l.URI.parse(S.toUrl(P))}}R.a="vscode-app",e.FileAccess=new R;var I;(function(w){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(P.get("3"));const S="vscode-coi";function p(m){let E;typeof m=="string"?E=new URL(m).searchParams:m instanceof URL?E=m.searchParams:l.URI.isUri(m)&&(E=new URL(m.toString(!0)).searchParams);const c=E?.get(S);if(!!c)return P.get(c)}w.getHeadersFromQuery=p;function d(m,E,c){if(!globalThis.crossOriginIsolated)return;const u=E&&c?"3":c?"2":"1";m instanceof URLSearchParams?m.set(S,u):m[S]=u}w.addSearchParam=d})(I=e.COI||(e.COI={}))}),define(re[23],oe([0,1,48,22,13,4,27,11]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(d){return(0,R.uriToFsPath)(d,!0)}e.originalFSPath=I;class w{constructor(m){this.a=m}compare(m,E,c=!1){return m===E?0:(0,N.compare)(this.getComparisonKey(m,c),this.getComparisonKey(E,c))}isEqual(m,E,c=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,c)===this.getComparisonKey(E,c)}getComparisonKey(m,E=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,E,c=!1){if(m.scheme===E.scheme){if(m.scheme===U.Schemas.file)return L.isEqualOrParent(I(m),I(E),this.a(m))&&m.query===E.query&&(c||m.fragment===E.fragment);if((0,e.isEqualAuthority)(m.authority,E.authority))return L.isEqualOrParent(m.path,E.path,this.a(m),"/")&&m.query===E.query&&(c||m.fragment===E.fragment)}return!1}joinPath(m,...E){return R.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return l.posix.basename(m.path)}extname(m){return l.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===U.Schemas.file?E=R.URI.file(l.dirname(I(m))).path:(E=l.posix.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===U.Schemas.file?E=R.URI.file(l.normalize(I(m))).path:E=l.posix.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.isEqualAuthority)(m.authority,E.authority))return;if(m.scheme===U.Schemas.file){const h=l.relative(I(m),I(E));return O.isWindows?L.toSlashes(h):h}let c=m.path||"/";const u=E.path||"/";if(this.a(m)){let h=0;for(const g=Math.min(c.length,u.length);h<g&&!(c.charCodeAt(h)!==u.charCodeAt(h)&&c.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);c=u.substr(0,h)+c.substr(h)}return l.posix.relative(c,u)}resolvePath(m,E){if(m.scheme===U.Schemas.file){const c=R.URI.file(l.resolve(I(m),E));return m.with({authority:c.authority,path:c.path})}return E=L.toPosixPath(E),m.with({path:l.posix.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,N.equalsIgnoreCase)(m,E)}hasTrailingPathSeparator(m,E=l.sep){if(m.scheme===U.Schemas.file){const c=I(m);return c.length>L.getRoot(c).length&&c[c.length-1]===E}else{const c=m.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=l.sep){return(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=l.sep){let c=!1;if(m.scheme===U.Schemas.file){const u=I(m);c=u!==void 0&&u.length===L.getRoot(u).length&&u[u.length-1]===E}else{E="/";const u=m.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path+"/"}):m}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(d=>d.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new w(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(d,m){const E=[];for(let c=0;c<d.length;c++){const u=m(d[c]);d.some((h,g)=>g===c?!1:(0,e.isEqualOrParent)(u,m(h)))||E.push(d[c])}return E}e.distinctParents=P;var S;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(E){const c=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(g=>{const[v,D]=g.split(":");v&&D&&c.set(v,D)});const h=E.path.substring(0,E.path.indexOf(";"));return h&&c.set(d.META_DATA_MIME,h),c}d.parseMetaData=m})(S=e.DataUri||(e.DataUri={}));function p(d,m,E){if(m){let c=d.path;return c&&c[0]!==l.posix.sep&&(c=l.posix.sep+c),d.with({scheme:E,authority:m,path:c})}return d.with({scheme:E})}e.toLocalResource=p}),define(re[6],oe([0,1,25,10,3,2,23,4,133]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(q){return!!q&&typeof q.then=="function"}e.isThenable=w;function P(q){const C=new L.CancellationTokenSource,A=q(C.token),M=new Promise((z,_)=>{const W=C.token.onCancellationRequested(()=>{W.dispose(),C.dispose(),_(new U.CancellationError)});Promise.resolve(A).then(Q=>{W.dispose(),C.dispose(),z(Q)},Q=>{W.dispose(),C.dispose(),_(Q)})});return new class{cancel(){C.cancel()}then(z,_){return M.then(z,_)}catch(z){return this.then(void 0,z)}finally(z){return M.finally(z)}}}e.createCancelablePromise=P;function S(q,C,A){return new Promise((M,z)=>{const _=C.onCancellationRequested(()=>{_.dispose(),M(A)});q.then(M,z).finally(()=>_.dispose())})}e.raceCancellation=S;function p(q,C){return new Promise((A,M)=>{const z=C.onCancellationRequested(()=>{z.dispose(),M(new U.CancellationError)});q.then(A,M).finally(()=>z.dispose())})}e.raceCancellationError=p;async function d(q){let C=-1;const A=q.map((z,_)=>z.then(W=>(C=_,W))),M=await Promise.race(A);return q.forEach((z,_)=>{_!==C&&z.cancel()}),M}e.raceCancellablePromises=d;function m(q,C,A){let M;const z=setTimeout(()=>{M?.(void 0),A?.()},C);return Promise.race([q.finally(()=>clearTimeout(z)),new Promise(_=>M=_)])}e.raceTimeout=m;function E(q){return new Promise((C,A)=>{const M=q();w(M)?M.then(C,A):C(M)})}e.asPromise=E;class c{constructor(){this.a=null,this.b=null,this.d=null}queue(C){if(this.a){if(this.d=C,!this.b){const A=()=>{this.b=null;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(A,A).then(M)})}return new Promise((A,M)=>{this.b.then(A,M)})}return this.a=C(),new Promise((A,M)=>{this.a.then(z=>{this.a=null,A(z)},z=>{this.a=null,M(z)})})}}e.Throttler=c;class u{constructor(){this.a=Promise.resolve(null)}queue(C){return this.a=this.a.then(()=>C(),()=>C())}}e.Sequencer=u;class h{constructor(){this.a=new Map}queue(C,A){const z=(this.a.get(C)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(C)===z&&this.a.delete(C)});return this.a.set(C,z),z}}e.SequencerByKey=h;const g=(q,C)=>{let A=!0;const M=setTimeout(()=>{A=!1,C()},q);return{isTriggered:()=>A,dispose:()=>{clearTimeout(M),A=!1}}},v=q=>{let C=!0;return queueMicrotask(()=>{C&&(C=!1,q())}),{isTriggered:()=>C,dispose:()=>{C=!1}}};class D{constructor(C){this.defaultDelay=C,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(C,A=this.defaultDelay){this.g=C,this.h(),this.b||(this.b=new Promise((z,_)=>{this.d=z,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=A===I.MicrotaskDelay?v(M):g(A,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new U.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class n{constructor(C){this.a=new D(C),this.b=new c}trigger(C,A){return this.a.trigger(()=>this.b.queue(C),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class o{constructor(){this.a=!1,this.b=new Promise((C,A)=>{this.d=C})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class i extends o{constructor(C){super(),this.f=setTimeout(()=>this.open(),C)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function t(q,C){return C?new Promise((A,M)=>{const z=setTimeout(()=>{_.dispose(),A()},q),_=C.onCancellationRequested(()=>{clearTimeout(z),_.dispose(),M(new U.CancellationError)})}):P(A=>t(q,A))}e.timeout=t;function s(q,C=0){const A=setTimeout(q,C);return(0,O.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=s;function a(q){const C=[];let A=0;const M=q.length;function z(){return A<M?q[A++]():null}function _(W){W!=null&&C.push(W);const Q=z();return Q?Q.then(_):Promise.resolve(C)}return Promise.resolve(null).then(_)}e.sequence=a;function r(q,C=M=>!!M,A=null){let M=0;const z=q.length,_=()=>{if(M>=z)return Promise.resolve(A);const W=q[M++];return Promise.resolve(W()).then(ee=>C(ee)?Promise.resolve(ee):_())};return _()}e.first=r;function f(q,C=M=>!!M,A=null){if(q.length===0)return Promise.resolve(A);let M=q.length;const z=()=>{M=-1;for(const _ of q)_.cancel?.()};return new Promise((_,W)=>{for(const Q of q)Q.then(ee=>{--M>=0&&C(ee)?(z(),_(ee)):M===0&&_(A)}).catch(ee=>{--M>=0&&(z(),W(ee))})})}e.firstParallel=f;class b{constructor(C){this.a=0,this.d=C,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(C){return this.a++,new Promise((A,M)=>{this.f.push({factory:C,c:A,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const C=this.f.shift();this.b++;const A=C.factory();A.then(C.c,C.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=b;class y extends b{constructor(){super(1)}}e.Queue=y;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const C=new H;return this.b.add(C),C.p}d(){for(const[,C]of this.a)if(C.size>0)return!1;return!0}queueFor(C,A=N.extUri){const M=A.getComparisonKey(C);let z=this.a.get(M);return z||(z=new y,l.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(M),this.f()}),this.a.set(M,z)),z}f(){!this.d()||this.g()}g(){for(const C of this.b)C.complete();this.b.clear()}dispose(){for(const[,C]of this.a)C.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class T{constructor(C,A){this.a=-1,typeof C=="function"&&typeof A=="number"&&this.setIfNotSet(C,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(C,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,C()},A)}setIfNotSet(C,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,C()},A))}}e.TimeoutTimer=T;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(C,A){this.cancel(),this.a=setInterval(()=>{C()},A)}}e.IntervalTimer=F;class j{constructor(C,A){this.b=-1,this.a=C,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(C=this.d){this.cancel(),this.b=setTimeout(this.f,C)}get delay(){return this.d}set delay(C){this.d=C}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class x{constructor(C,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=C,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(C=this.b){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(C/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class V extends j{constructor(C,A){super(C,A),this.j=[]}work(C){this.j.push(C),this.isScheduled()||this.schedule()}h(){const C=this.j;this.j=[],this.a?.(C)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=V;class B extends O.Disposable{constructor(C,A){super(),this.g=C,this.h=A,this.a=[],this.b=this.D(new O.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(C){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+C.length>this.g.maxBufferedWork)return!1}else if(this.pending+C.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of C)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,R.setTimeout0)(()=>{if(C)return;const A=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:e.runWhenIdle=(q,C)=>{const A=requestIdleCallback(q,typeof C=="number"?{timeout:C}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(A))}}}}();class X{constructor(C){this.d=!1,this.a=()=>{try{this.f=C()}catch(A){this.g=A}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=X;async function J(q,C,A){let M;for(let z=0;z<A;z++)try{return await q()}catch(_){M=_,await t(C)}throw M}e.retry=J;class G{hasPending(C){return this.a?typeof C=="number"?this.a.taskId===C:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(C,A,M){return this.a={taskId:C,cancel:()=>M?.(),promise:A},A.then(()=>this.d(C),()=>this.d(C)),A}d(C){this.a&&C===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const C=this.b;this.b=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}setNext(C){if(this.b)this.b.run=C;else{let A,M;const z=new Promise((_,W)=>{A=_,M=W});this.b={run:C,promise:z,promiseResolve:A,promiseReject:M}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=G;class Y{constructor(C,A=()=>Date.now()){this.d=C,this.f=A,this.a=0,this.b=0}increment(){const C=this.f();return C-this.a>this.d&&(this.a=C,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((C,A)=>{this.a=C,this.b=A})}complete(C){return new Promise(A=>{this.a(C),this.f=!0,A()})}error(C){return new Promise(A=>{this.b(C),this.d=!0,A()})}cancel(){new Promise(C=>{this.b(new U.CancellationError),this.d=!0,C()})}}e.DeferredPromise=H;var $;(function(q){async function C(M){let z;const _=await Promise.all(M.map(W=>W.then(Q=>Q,Q=>{z||(z=Q)})));if(typeof z<"u")throw z;return _}q.settled=C;function A(M){return new Promise(async(z,_)=>{try{await M(z,_)}catch(W){_(W)}})}q.withAsyncBody=A})($=e.Promises||(e.Promises={}));var Z;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(Z||(Z={}));class ie{static fromArray(C){return new ie(A=>{A.emitMany(C)})}static fromPromise(C){return new ie(async A=>{A.emitMany(await C)})}static fromPromises(C){return new ie(async A=>{await Promise.all(C.map(async M=>A.emitOne(await M)))})}static merge(C){return new ie(async A=>{await Promise.all(C.map(async M=>{for await(const z of M)A.emitOne(z)}))})}constructor(C){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const A={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(C(A)),this.j()}catch(M){this.k(M)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let C=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(C<this.b.length)return{done:!1,value:this.b[C++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(C,A){return new ie(async M=>{for await(const z of C)M.emitOne(A(z))})}map(C){return ie.map(this,C)}static filter(C,A){return new ie(async M=>{for await(const z of C)A(z)&&M.emitOne(z)})}filter(C){return ie.filter(this,C)}static coalesce(C){return ie.filter(C,A=>!!A)}coalesce(){return ie.coalesce(this)}static async toPromise(C){const A=[];for await(const M of C)A.push(M);return A}toPromise(){return ie.toPromise(this)}g(C){this.a===0&&(this.b.push(C),this.f.fire())}h(C){this.a===0&&(this.b=this.b.concat(C),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(C){this.a===0&&(this.a=2,this.d=C,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class se extends ie{constructor(C,A){super(A),this.l=C}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function ae(q){const C=new L.CancellationTokenSource,A=q(C.token);return new se(C,async M=>{const z=C.token.onCancellationRequested(()=>{z.dispose(),C.dispose(),M.reject(new U.CancellationError)});try{for await(const _ of A){if(C.token.isCancellationRequested)return;M.emitOne(_)}z.dispose(),C.dispose()}catch(_){z.dispose(),C.dispose(),M.reject(_)}})}e.createCancelableAsyncIterable=ae}),define(re[92],oe([0,1,21,6,48,37,13,4,27]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",S="[^/\\\\]",p=/\//g;function d(Y,H){switch(Y){case 0:return"";case 1:return`${S}*?`;default:return`(?:${P}|${S}+${P}${H?`|${P}${S}+`:""})*?`}}function m(Y,H){if(!Y)return[];const $=[];let Z=!1,ie=!1,se="";for(const ae of Y){switch(ae){case H:if(!Z&&!ie){$.push(se),se="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}se+=ae}return se&&$.push(se),$}e.splitGlobAware=m;function E(Y){if(!Y)return"";let H="";const $=m(Y,e.GLOB_SPLIT);if($.every(Z=>Z===e.GLOBSTAR))H=".*";else{let Z=!1;$.forEach((ie,se)=>{if(ie===e.GLOBSTAR){if(Z)return;H+=d(2,se===$.length-1)}else{let ae=!1,q="",C=!1,A="";for(const M of ie){if(M!=="}"&&ae){q+=M;continue}if(C&&(M!=="]"||!A)){let z;M==="-"?z=M:(M==="^"||M==="!")&&!A?z="^":M===e.GLOB_SPLIT?z="":z=(0,I.escapeRegExpCharacters)(M),A+=z;continue}switch(M){case"{":ae=!0;continue;case"[":C=!0;continue;case"}":{H+=`(?:${m(q,",").map(W=>E(W)).join("|")})`,ae=!1,q="";break}case"]":{H+="["+A+"]",C=!1,A="";break}case"?":H+=S;continue;case"*":H+=d(1);continue;default:H+=(0,I.escapeRegExpCharacters)(M)}}se<$.length-1&&($[se+1]!==e.GLOBSTAR||se+2<$.length)&&(H+=P)}Z=ie===e.GLOBSTAR})}return H}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new O.LRUCache(1e4),o=function(){return!1},i=function(){return null};function t(Y,H){if(!Y)return i;let $;typeof Y!="string"?$=Y.pattern:$=Y,$=$.trim();const Z=`${$}_${!!H.trimForExclusions}`;let ie=n.get(Z);if(ie)return s(ie,Y);let se;return c.test($)?ie=r($.substr(4),$):(se=u.exec(a($,H)))?ie=f(se[1],$):(H.trimForExclusions?g:h).test($)?ie=b($,H):(se=v.exec(a($,H)))?ie=y(se[1].substr(1),$,!0):(se=D.exec(a($,H)))?ie=y(se[1],$,!1):ie=k($),n.set(Z,ie),s(ie,Y)}function s(Y,H){if(typeof H=="string")return Y;const $=function(Z,ie){return(0,l.isEqualOrParent)(Z,H.base,!R.isLinux)?Y((0,I.ltrim)(Z.substr(H.base.length),N.sep),ie):null};return $.allBasenames=Y.allBasenames,$.allPaths=Y.allPaths,$.basenames=Y.basenames,$.patterns=Y.patterns,$}function a(Y,H){return H.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function r(Y,H){return function($,Z){return typeof $=="string"&&$.endsWith(Y)?H:null}}function f(Y,H){const $=`/${Y}`,Z=`\\${Y}`,ie=function(ae,q){return typeof ae!="string"?null:q?q===Y?H:null:ae===Y||ae.endsWith($)||ae.endsWith(Z)?H:null},se=[Y];return ie.basenames=se,ie.patterns=[H],ie.allBasenames=se,ie}function b(Y,H){const $=J(Y.slice(1,-1).split(",").map(q=>t(q,H)).filter(q=>q!==i),Y),Z=$.length;if(!Z)return i;if(Z===1)return $[0];const ie=function(q,C){for(let A=0,M=$.length;A<M;A++)if($[A](q,C))return Y;return null},se=$.find(q=>!!q.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ae=$.reduce((q,C)=>C.allPaths?q.concat(C.allPaths):q,[]);return ae.length&&(ie.allPaths=ae),ie}function y(Y,H,$){const Z=N.sep===N.posix.sep,ie=Z?Y:Y.replace(p,N.sep),se=N.sep+ie,ae=N.posix.sep+Y;let q;return $?q=function(C,A){return typeof C=="string"&&(C===ie||C.endsWith(se)||!Z&&(C===Y||C.endsWith(ae)))?H:null}:q=function(C,A){return typeof C=="string"&&(C===ie||!Z&&C===Y)?H:null},q.allPaths=[($?"*/":"./")+Y],q}function k(Y){try{const H=new RegExp(`^${E(Y)}$`);return function($){return H.lastIndex=0,typeof $=="string"&&H.test($)?Y:null}}catch{return i}}function T(Y,H,$){return!Y||typeof H!="string"?!1:F(Y)(H,void 0,$)}e.match=T;function F(Y,H={}){if(!Y)return o;if(typeof Y=="string"||j(Y)){const $=t(Y,H);if($===i)return o;const Z=function(ie,se){return!!$(ie,se)};return $.allBasenames&&(Z.allBasenames=$.allBasenames),$.allPaths&&(Z.allPaths=$.allPaths),Z}return B(Y,H)}e.parse=F;function j(Y){const H=Y;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=j;function x(Y){return Y.allBasenames||[]}e.getBasenameTerms=x;function V(Y){return Y.allPaths||[]}e.getPathTerms=V;function B(Y,H){const $=J(Object.getOwnPropertyNames(Y).map(q=>X(q,Y[q],H)).filter(q=>q!==i)),Z=$.length;if(!Z)return i;if(!$.some(q=>!!q.requiresSiblings)){if(Z===1)return $[0];const q=function(M,z){let _;for(let W=0,Q=$.length;W<Q;W++){const ee=$[W](M,z);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(_||(_=[]),_.push(ee))}return _?(async()=>{for(const W of _){const Q=await W;if(typeof Q=="string")return Q}return null})():null},C=$.find(M=>!!M.allBasenames);C&&(q.allBasenames=C.allBasenames);const A=$.reduce((M,z)=>z.allPaths?M.concat(z.allPaths):M,[]);return A.length&&(q.allPaths=A),q}const ie=function(q,C,A){let M,z;for(let _=0,W=$.length;_<W;_++){const Q=$[_];Q.requiresSiblings&&A&&(C||(C=(0,N.basename)(q)),M||(M=C.substr(0,C.length-(0,N.extname)(q).length)));const ee=Q(q,C,M,A);if(typeof ee=="string")return ee;(0,U.isThenable)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const _ of z){const W=await _;if(typeof W=="string")return W}return null})():null},se=$.find(q=>!!q.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ae=$.reduce((q,C)=>C.allPaths?q.concat(C.allPaths):q,[]);return ae.length&&(ie.allPaths=ae),ie}function X(Y,H,$){if(H===!1)return i;const Z=t(Y,$);if(Z===i)return i;if(typeof H=="boolean")return Z;if(H){const ie=H.when;if(typeof ie=="string"){const se=(ae,q,C,A)=>{if(!A||!Z(ae,q))return null;const M=ie.replace("$(basename)",()=>C),z=A(M);return(0,U.isThenable)(z)?z.then(_=>_?Y:null):z?Y:null};return se.requiresSiblings=!0,se}}return Z}function J(Y,H){const $=Y.filter(q=>!!q.basenames);if($.length<2)return Y;const Z=$.reduce((q,C)=>{const A=C.basenames;return A?q.concat(A):q},[]);let ie;if(H){ie=[];for(let q=0,C=Z.length;q<C;q++)ie.push(H)}else ie=$.reduce((q,C)=>{const A=C.patterns;return A?q.concat(A):q},[]);const se=function(q,C){if(typeof q!="string")return null;if(!C){let M;for(M=q.length;M>0;M--){const z=q.charCodeAt(M-1);if(z===47||z===92)break}C=q.substr(M)}const A=Z.indexOf(C);return A!==-1?ie[A]:null};se.basenames=Z,se.patterns=ie,se.allBasenames=Z;const ae=Y.filter(q=>!q.basenames);return ae.push(se),ae}function G(Y,H){return(0,L.equals)(Y,H,($,Z)=>typeof $=="string"&&typeof Z=="string"?$===Z:typeof $!="string"&&typeof Z!="string"?$.base===Z.base&&$.pattern===Z.pattern:!1)}e.patternsEquals=G}),define(re[93],oe([0,1,16,11]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(S){return S.toJSON()}class O{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:l(U.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:l(U.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:U.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function N(S,p,d){if(!S||d>200)return null;if(typeof S=="object"){if(S instanceof U.URI)return p.transformOutgoing(S);for(const m in S)if(Object.hasOwnProperty.call(S,m)){const E=N(S[m],p,d+1);E!==null&&(S[m]=E)}}return null}function R(S,p){const d=N(S,p,0);return d===null?S:d}e.transformOutgoingURIs=R;function I(S,p,d,m){if(!S||m>200)return null;if(typeof S=="object"){if(S.$mid===1)return d?U.URI.revive(p.transformIncoming(S)):p.transformIncoming(S);if(S instanceof L.VSBuffer)return null;for(const E in S)if(Object.hasOwnProperty.call(S,E)){const c=I(S[E],p,d,m+1);c!==null&&(S[E]=c)}}return null}function w(S,p){const d=I(S,p,!1,0);return d===null?S:d}e.transformIncomingURIs=w;function P(S,p){const d=I(S,p,!0,0);return d===null?S:d}e.transformAndReviveIncomingURIs=P}),define(re[145],oe([0,1,34,10,49,31,135]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(P){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(P)}value(){if(this.b===void 0){let P=0,S=0;const p=(0,L.networkInterfaces)();for(const d in p){const m=p[d];if(m)for(const{mac:E,internal:c}of m)c||(S+=1,this.c(E.toUpperCase())&&(P+=1))}this.b=S>0?P/S:0}return this.b}};let R;async function I(){return R||(R=(async()=>await w()||O.generateUuid())()),R}e.getMachineId=I;async function w(){try{const P=await new Promise((p,d)=>{te(["crypto"],p,d)}),S=(0,N.getMac)();return P.createHash("sha256").update(S,"utf8").digest("hex")}catch(P){U.onUnexpectedError(P);return}}}),define(re[28],oe([0,1,54,34,292,6,48,85,13,4,23,11]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function d(B,X=p.UNLINK){if((0,N.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return X===p.UNLINK?E(B):m(B)}async function m(B){try{const X=(0,N.randomPath)((0,U.tmpdir)());try{await L.promises.rename(B,X)}catch(J){return J.code==="ENOENT"?void 0:E(B)}E(X).catch(J=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function E(B){return(0,l.promisify)(L.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function c(B){if((0,N.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(B,X){return v(await(X?h(B):(0,l.promisify)(L.readdir)(B)))}async function h(B){try{return await(0,l.promisify)(L.readdir)(B,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const X=[],J=await u(B);for(const G of J){let Y=!1,H=!1,$=!1;try{const Z=await e.Promises.lstat((0,I.join)(B,G));Y=Z.isFile(),H=Z.isDirectory(),$=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}X.push({name:G,isFile:()=>Y,isDirectory:()=>H,isSymbolicLink:()=>$})}return X}function g(B){return v(L.readdirSync(B))}e.readdirSync=g;function v(B){return B.map(X=>typeof X=="string"?w.isMacintosh?(0,R.normalizeNFC)(X):X:(X.name=w.isMacintosh?(0,R.normalizeNFC)(X.name):X.name,X))}async function D(B){const X=await u(B),J=[];for(const G of X)await o.existsDirectory((0,I.join)(B,G))&&J.push(G);return J}function n(B,X=1e3){return new Promise(J=>{let G=!1;const Y=setInterval(()=>{G||(G=!0,L.access(B,H=>{G=!1,H&&(clearInterval(Y),J(void 0))}))},X)})}e.whenDeleted=n;var o;(function(B){async function X(Y){let H;try{if(H=await e.Promises.lstat(Y),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(w.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw Z}throw $}}B.stat=X;async function J(Y){try{const{stat:H,symbolicLink:$}=await B.stat(Y);return H.isFile()&&$?.dangling!==!0}catch{}return!1}B.existsFile=J;async function G(Y){try{const{stat:H,symbolicLink:$}=await B.stat(Y);return H.isDirectory()&&$?.dangling!==!0}catch{}return!1}B.existsDirectory=G})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new O.ResourceQueue;function t(B,X,J){return i.queueFor(S.URI.file(B),P.extUriBiasedIgnorePathCase).queue(()=>{const G=b(J);return new Promise((Y,H)=>r(B,X,G,$=>$?H($):Y()))})}let s=!0;function a(B){s=B}e.configureFlushOnWrite=a;function r(B,X,J,G){if(!s)return L.writeFile(B,X,{mode:J.mode,flag:J.flag},G);L.open(B,J.flag,J.mode,(Y,H)=>{if(Y)return G(Y);L.writeFile(H,X,$=>{if($)return L.close(H,()=>G($));L.fdatasync(H,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),a(!1)),L.close(H,ie=>G(ie))))})})}function f(B,X,J){const G=b(J);if(!s)return L.writeFileSync(B,X,{mode:G.mode,flag:G.flag});const Y=L.openSync(B,G.flag,G.mode);try{L.writeFileSync(Y,X);try{L.fdatasyncSync(Y)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),a(!1)}}finally{L.closeSync(Y)}}e.writeFileSync=f;function b(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function y(B,X){if(B!==X)try{await e.Promises.rename(B,X)}catch(J){if(B.toLowerCase()!==X.toLowerCase()&&J.code==="EXDEV"||B.endsWith("."))await k(B,X,{preserveSymlinks:!1}),await d(B,p.MOVE);else throw J}}async function k(B,X,J){return F(B,X,{root:{source:B,target:X},options:J,handledSourcePaths:new Set})}const T=511;async function F(B,X,J){if(J.handledSourcePaths.has(B))return;J.handledSourcePaths.add(B);const{stat:G,symbolicLink:Y}=await o.stat(B);if(Y){if(J.options.preserveSymlinks)try{return await V(B,X,J)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(Y.dangling)return}return G.isDirectory()?j(B,X,G.mode&T,J):x(B,X,G.mode&T)}async function j(B,X,J,G){await e.Promises.mkdir(X,{recursive:!0,mode:J});const Y=await u(B);for(const H of Y)await F((0,I.join)(B,H),(0,I.join)(X,H),G)}async function x(B,X,J){await e.Promises.copyFile(B,X),await e.Promises.chmod(X,J)}async function V(B,X,J){let G=await e.Promises.readlink(B);(0,N.isEqualOrParent)(G,J.root.source,!w.isLinux)&&(G=(0,I.join)(J.root.target,G.substr(J.root.source.length+1))),await e.Promises.symlink(G,X)}e.Promises=new class{get access(){return(0,l.promisify)(L.access)}get stat(){return(0,l.promisify)(L.stat)}get lstat(){return(0,l.promisify)(L.lstat)}get utimes(){return(0,l.promisify)(L.utimes)}get read(){return(B,X,J,G,Y)=>new Promise((H,$)=>{L.read(B,X,J,G,Y,(Z,ie,se)=>Z?$(Z):H({bytesRead:ie,buffer:se}))})}get readFile(){return(0,l.promisify)(L.readFile)}get write(){return(B,X,J,G,Y)=>new Promise((H,$)=>{L.write(B,X,J,G,Y,(Z,ie,se)=>Z?$(Z):H({bytesWritten:ie,buffer:se}))})}get appendFile(){return(0,l.promisify)(L.appendFile)}get fdatasync(){return(0,l.promisify)(L.fdatasync)}get truncate(){return(0,l.promisify)(L.truncate)}get rename(){return(0,l.promisify)(L.rename)}get copyFile(){return(0,l.promisify)(L.copyFile)}get open(){return(0,l.promisify)(L.open)}get close(){return(0,l.promisify)(L.close)}get symlink(){return(0,l.promisify)(L.symlink)}get readlink(){return(0,l.promisify)(L.readlink)}get chmod(){return(0,l.promisify)(L.chmod)}get mkdir(){return(0,l.promisify)(L.mkdir)}get unlink(){return(0,l.promisify)(L.unlink)}get rmdir(){return(0,l.promisify)(L.rmdir)}get realpath(){return(0,l.promisify)(L.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return D}get writeFile(){return t}get rm(){return d}get move(){return y}get copy(){return k}}}),define(re[146],oe([0,1,54,13,4,27,28]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(p){if(l.isLinux)return p;const d=(0,U.dirname)(p);if(p===d)return p;const m=((0,U.basename)(p)||p).toLowerCase();try{const c=(0,N.readdirSync)(d).filter(u=>u.toLowerCase()===m);if(c.length===1){const u=R(d);if(u)return(0,U.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(m);if(u>=0){const h=R(d);if(h)return(0,U.join)(h,c[u])}}}catch{}return null}e.realcaseSync=R;async function I(p){if(l.isLinux)return p;const d=(0,U.dirname)(p);if(p===d)return p;const m=((0,U.basename)(p)||p).toLowerCase();try{const c=(await N.Promises.readdir(d)).filter(u=>u.toLowerCase()===m);if(c.length===1){const u=await I(d);if(u)return(0,U.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(m);if(u>=0){const h=await I(d);if(h)return(0,U.join)(h,c[u])}}}catch{}return null}e.realcase=I;async function w(p){try{return await N.Promises.realpath(p)}catch{const m=S(p);return await N.Promises.access(m,L.constants.R_OK),m}}e.realpath=w;function P(p){try{return L.realpathSync(p)}catch{const m=S(p);return L.accessSync(m,L.constants.R_OK),m}}e.realpathSync=P;function S(p){return(0,O.rtrim)((0,U.normalize)(p),U.sep)}}),define(re[94],oe([0,1,34,13,28]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,N=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var I;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(I||(I={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class S{constructor(D,n,o){this.exePath=D,this.displayName=n,this.a=o}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:v=!1}={}){return v?w===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:v=!1,findPreview:D=!1}={}){const n=p({useAlternateBitness:v});if(!n)return null;const o=U.join(n,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(o))return null;let i=-1,t=null;for(const r of await l.Promises.readdir(o)){let f=-1;if(D){const y=r.indexOf("-");if(y<0)continue;const k=r.substring(0,y);if(!O.test(k)||r.substring(y+1)!=="preview")continue;f=parseInt(k,10)}else{if(!O.test(r))continue;f=parseInt(r,10)}if(f<=i)continue;const b=U.join(o,r,"pwsh.exe");!await l.SymlinkSupport.existsFile(b)||(t=b,i=f)}if(!t)return null;const s=n.includes("x86")?" (x86)":"",a=D?" Preview":"";return new S(t,`PowerShell${a}${s}`,!0)}async function m({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const D=U.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await l.Promises.readdir(D))if(n.test(i)){const t=U.join(D,i,"pwsh.exe");return new S(t,o)}return null}function E(){const v=U.join(L.homedir(),".dotnet","tools","pwsh.exe");return new S(v,".NET Core PowerShell Global Tool")}function c(){const v=U.join(process.env.windir,w===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(v,"Windows PowerShell",!0)}async function*u(){let v=await d();v&&(yield v),v=await d({useAlternateBitness:!0}),v&&(yield v),v=await m(),v&&(yield v),v=E(),v&&(yield v),v=await d({findPreview:!0}),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await d({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=c(),v&&(yield v)}async function*h(){for await(const v of u())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=h;async function g(){for await(const v of h())return v;return null}e.getFirstAvailablePowerShellInstallation=g}),define(re[95],oe([0,1,13,4,36,88,12,28]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function I(S=l.env){return S.comspec||"cmd.exe"}e.getWindowsShell=I;function w(S){let p=[],d=!1;const m=function(E){if(d){p.push(E);return}(!S.send(E,u=>{if(u&&console.error(u),d=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(g=>m(g))}})||U.isWindows)&&(d=!0)};return{send:m}}e.createQueuedSender=w;var P;(function(S){async function p(d,m,E){if(L.isAbsolute(d))return d;if(m===void 0&&(m=l.cwd()),L.dirname(d)!=="."||(E===void 0&&N.isString(l.env.PATH)&&(E=l.env.PATH.split(L.delimiter)),E===void 0||E.length===0))return L.join(m,d);async function u(h){if(await R.Promises.exists(h)){let g;try{g=await R.Promises.stat(h)}catch(v){v.message.startsWith("EACCES")&&(g=await R.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(const h of E){let g;if(L.isAbsolute(h)?g=L.join(h,d):g=L.join(m,h,d),await u(g))return g;let v=g+".com";if(await u(v)||(v=g+".exe",await u(v)))return v}return L.join(m,d)}S.findExecutable=p})(P=e.win32||(e.win32={}))}),define(re[147],oe([0,1,50,22]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(N){return new Promise((R,I)=>{let w;const P=new Map;function S(d,m,E,c,u){const h=P.get(m);if(d===N||h){const g={name:p(E),cmd:E,pid:d,ppid:m,load:c,mem:u};P.set(d,g),d===N&&(w=g),h&&(h.children||(h.children=[]),h.children.push(g),h.children.length>1&&(h.children=h.children.sort((v,D)=>v.pid-D.pid)))}}function p(d){const m=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,h=/conhost\.exe/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(d))return"electron-crash-reporter";if(u.exec(d))return"winpty-process";if(h.exec(d))return"console-window-host (Windows internal process)";let v=g.exec(d);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?m.exec(d)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const D=/[a-zA-Z-]+\.js/g;let n="";do v=D.exec(d),v&&(n+=v+" ");while(v);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${n})`:E.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,E)=>{te(["windows-process-tree"],m,E)}).then(m=>{m.getProcessList(N,E=>{if(!E){I(new Error(`Root process ${N} not found`));return}m.getProcessCpuUsage(E,c=>{const u=new Map;c.forEach(h=>{const g=d(h.commandLine||"");u.set(h.pid,{name:p(g),cmd:g,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),w=u.get(N),w?(u.forEach(h=>{const g=u.get(h.ppid);g&&(g.children||(g.children=[]),g.children.push(h))}),u.forEach(h=>{h.children&&(h.children=h.children.sort((g,v)=>g.pid-v.pid))}),R(w)):I(new Error(`Root process ${N} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[w];const E=[];for(;m.length;){const u=m.shift();u&&(E.push(u.pid),u.children&&(m=m.concat(u.children)))}let c=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+E.join(" "),(0,L.exec)(c,{},(u,h,g)=>{if(u||g)I(u||new Error(g.toString()));else{const v=h.toString().split(`
`);for(let D=0;D<E.length;D++){const n=P.get(E[D]);n.load=parseFloat(v[D])}if(!w){I(new Error(`Root process ${N} not found`));return}R(w)}})};(0,L.exec)("which ps",{},(m,E,c)=>{if(m||c)if(process.platform!=="linux")I(m||new Error(c.toString()));else{const u=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(u,{},(h,g,v)=>{h||v?I(h||new Error(v.toString())):(O(g,S),d())})}else{const u=E.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${u} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,D)=>{g||D&&!D.includes("screen size is bogus")?I(g||new Error(D.toString())):(O(v,S),process.platform==="linux"?d():w?R(w):I(new Error(`Root process ${N} not found`)))})}})}})}e.listProcesses=l;function O(N,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=N.toString().split(`
`);for(const P of w){const S=I.exec(P.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(re[148],oe([0,1,34,4,94,95]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(S,p){return S===1?U.isWindows?P():O.getWindowsShell(p):I(S,p)}e.getSystemShell=N;let R=null;function I(S,p){if(U.isLinux&&S===2||U.isMacintosh&&S===3)return"/bin/bash";if(!R){let d;if(U.isWindows)d="/bin/bash";else{if(d=p.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}R=d}return R}let w=null;async function P(){return w||(w=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),w}});var ye=this&&this.__decorate||function(te,e,L,U){var l=arguments.length,O=l<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,L):U,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(te,e,L,U);else for(var R=te.length-1;R>=0;R--)(N=te[R])&&(O=(l<3?N(O):l>3?N(e,L,O):N(e,L))||O);return l>3&&O&&Object.defineProperty(e,L,O),O};define(re[39],oe([0,1,21,6,16,25,62,10,3,2,91,27,12]),function(te,e,L,U,l,O,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(d||(d={}));function m(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(E||(E={}));function c(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(u||(u={}));function h(H){let $=0;for(let Z=0;;Z+=7){const ie=H.read(1);if($|=(ie.buffer[0]&127)<<Z,!(ie.buffer[0]&128))return $}}const g=i(0);function v(H,$){if($===0){H.write(g);return}let Z=0;for(let se=$;se!==0;se=se>>>7)Z++;const ie=l.VSBuffer.alloc(Z);for(let se=0;$!==0;se++)ie.buffer[se]=$&127,$=$>>>7,$>0&&(ie.buffer[se]|=128);H.write(ie)}class D{constructor($){this.b=$,this.a=0}read($){const Z=this.b.slice(this.a,this.a+$);return this.a+=Z.byteLength,Z}}e.BufferReader=D;class n{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write($){this.a.push($)}}e.BufferWriter=n;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function i(H){const $=l.VSBuffer.alloc(1);return $.writeUInt8(H,0),$}const t={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object),Uint:i(o.Int)},s=typeof Buffer<"u";function a(H,$){if(typeof $>"u")H.write(t.Undefined);else if(typeof $=="string"){const Z=l.VSBuffer.fromString($);H.write(t.String),v(H,Z.byteLength),H.write(Z)}else if(s&&Buffer.isBuffer($)){const Z=l.VSBuffer.wrap($);H.write(t.Buffer),v(H,Z.byteLength),H.write(Z)}else if($ instanceof l.VSBuffer)H.write(t.VSBuffer),v(H,$.byteLength),H.write($);else if(Array.isArray($)){H.write(t.Array),v(H,$.length);for(const Z of $)a(H,Z)}else if(typeof $=="number"&&($|0)===$)H.write(t.Uint),v(H,$);else{const Z=l.VSBuffer.fromString(JSON.stringify($));H.write(t.Object),v(H,Z.byteLength),H.write(Z)}}e.serialize=a;function r(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(h(H)).toString();case o.Buffer:return H.read(h(H)).buffer;case o.VSBuffer:return H.read(h(H));case o.Array:{const Z=h(H),ie=[];for(let se=0;se<Z;se++)ie.push(r(H));return ie}case o.Object:return JSON.parse(H.read(h(H)).toString());case o.Int:return h(H)}}e.deserialize=r;class f{constructor($,Z,ie=null,se=1e3){this.h=$,this.j=Z,this.k=ie,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel($,Z){this.b.set($,Z),setTimeout(()=>this.w($),0)}m($){switch($.type){case 200:{const Z=this.o([$.type]);this.k?.logOutgoing(Z,0,1,c($.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([$.type,$.id],$.data);this.k?.logOutgoing(Z,$.id,1,c($.type),$.data);return}}}o($,Z=void 0){const ie=new n;return a(ie,$),a(ie,Z),this.p(ie.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const Z=new D($),ie=r(Z),se=r(Z),ae=ie[0];switch(ae){case 100:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}: ${ie[2]}.${ie[3]}`,se),this.s({type:ae,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 102:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}: ${ie[2]}.${ie[3]}`,se),this.t({type:ae,id:ie[1],channelName:ie[2],name:ie[3],arg:se});case 101:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}`),this.u({type:ae,id:ie[1]});case 103:return this.k?.logIncoming($.byteLength,ie[1],1,`${m(ae)}`),this.u({type:ae,id:ie[1]})}}s($){const Z=this.b.get($.channelName);if(!Z){this.v($);return}const ie=new O.CancellationTokenSource;let se;try{se=Z.call(this.j,$.name,$.arg,ie.token)}catch(C){se=Promise.reject(C)}const ae=$.id;se.then(C=>{this.m({id:ae,data:C,type:201}),this.d.delete($.id)},C=>{C instanceof Error?this.m({id:ae,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:ae,data:C,type:203}),this.d.delete($.id)});const q=(0,w.toDisposable)(()=>ie.cancel());this.d.set($.id,q)}t($){const Z=this.b.get($.channelName);if(!Z){this.v($);return}const ie=$.id,ae=Z.listen(this.j,$.name,$.arg)(q=>this.m({id:ie,data:q,type:204}));this.d.set($.id,ae)}u($){const Z=this.d.get($.id);Z&&(Z.dispose(),this.d.delete($.id))}v($){let Z=this.g.get($.channelName);Z||(Z=[],this.g.set($.channelName,Z));const ie=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:$,timeoutTimer:ie})}w($){const Z=this.g.get($);if(Z){for(const ie of Z)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var b;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor($,Z=null){this.l=$,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Z}getChannel($){const Z=this;return{call(ie,se,ae){return Z.a?Promise.reject(new R.CancellationError):Z.m($,ie,se,ae)},listen(ie,se){return Z.a?I.Event.None:Z.o($,ie,se)}}}m($,Z,ie,se=O.CancellationToken.None){const ae=this.g++,C={id:ae,type:100,channelName:$,name:Z,arg:ie};if(se.isCancellationRequested)return Promise.reject(new R.CancellationError);let A;return new Promise((z,_)=>{if(se.isCancellationRequested)return _(new R.CancellationError);const W=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(ae),z(pe.data);break;case 202:{this.f.delete(ae);const de=new Error(pe.data.message);de.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,de.name=pe.data.name,_(de);break}case 203:this.f.delete(ae),_(pe.data);break}};this.f.set(ae,he),this.p(C)};let Q=null;this.b===u.Idle?W():(Q=(0,U.createCancelablePromise)(he=>this.u()),Q.then(()=>{Q=null,W()}));const ee=()=>{Q?(Q.cancel(),Q=null):this.p({id:ae,type:101}),_(new R.CancellationError)},le=se.onCancellationRequested(ee);A=(0,w.combinedDisposable)((0,w.toDisposable)(ee),le),this.d.add(A)}).finally(()=>{this.d.delete(A)})}o($,Z,ie){const se=this.g++,q={id:se,type:102,channelName:$,name:Z,arg:ie};let C=null;const A=new I.Emitter({onWillAddFirstListener:()=>{C=(0,U.createCancelablePromise)(z=>this.u()),C.then(()=>{C=null,this.d.add(A),this.p(q)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(A),this.p({id:se,type:103}))}}),M=z=>A.fire(z.data);return this.f.set(se,M),A.event}p($){switch($.type){case 100:case 102:{const Z=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(Z,$.id,0,`${m($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Z=this.q([$.type,$.id]);this.j?.logOutgoing(Z,$.id,0,m($.type));return}}}q($,Z=void 0){const ie=new n;return a(ie,$),a(ie,Z),this.r(ie.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const Z=new D($),ie=r(Z),se=r(Z),ae=ie[0];switch(ae){case 200:return this.j?.logIncoming($.byteLength,0,0,c(ae)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming($.byteLength,ie[1],0,c(ae),se),this.t({type:ie[0],id:ie[1],data:se})}}t($){if($.type===200){this.b=u.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.dispose)(this.d.values()),this.d.clear()}}ye([N.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class k{get connections(){const $=[];return this.f.forEach(Z=>$.push(Z)),$}constructor($){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,$(({protocol:Z,onDidClientDisconnect:ie})=>{I.Event.once(Z.onMessage)(ae=>{const q=new D(ae),C=r(q),A=new f(Z,C),M=new y(Z);this.a.forEach((_,W)=>A.registerChannel(W,_));const z={channelServer:A,channelClient:M,ctx:C};this.f.add(z),this.g.fire(z),ie(()=>{A.dispose(),M.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel($,Z){const ie=this;return{call(se,ae,q){let C;if((0,p.isFunction)(Z)){const M=(0,L.getRandomElement)(ie.connections.filter(Z));C=M?Promise.resolve(M):I.Event.toPromise(I.Event.filter(ie.onDidAddConnection,Z))}else C=Z.routeCall(ie,se,ae);const A=C.then(M=>M.channelClient.getChannel($));return F(A).call(se,ae,q)},listen(se,ae){if((0,p.isFunction)(Z))return ie.j($,Z,se,ae);const q=Z.routeEvent(ie,se,ae).then(C=>C.channelClient.getChannel($));return F(q).listen(se,ae)}}}j($,Z,ie,se){const ae=this;let q=new w.DisposableStore;const C=new I.Emitter({onWillAddFirstListener:()=>{q=new w.DisposableStore;const A=new I.EventMultiplexer,M=new Map,z=W=>{const ee=W.channelClient.getChannel($).listen(ie,se),le=A.add(ee);M.set(W,le)},_=W=>{const Q=M.get(W);!Q||(Q.dispose(),M.delete(W))};ae.connections.filter(Z).forEach(z),I.Event.filter(ae.onDidAddConnection,Z)(z,void 0,q),ae.onDidRemoveConnection(_,void 0,q),A.event(C.fire,C,q),q.add(A)},onDidRemoveLastListener:()=>{q.dispose()}});return C.event}registerChannel($,Z){this.a.set($,Z),this.f.forEach(ie=>{ie.channelServer.registerChannel($,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class T{constructor($,Z,ie=null){const se=new n;a(se,Z),$.send(se.buffer),this.a=new y($,ie),this.d=new f($,Z,ie)}getChannel($){return this.a.getChannel($)}registerChannel($,Z){this.d.registerChannel($,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=T;function F(H){return{call($,Z,ie){return H.then(se=>se.call($,Z,ie))},listen($,Z){const ie=new I.Relay;return H.then(se=>ie.input=se.listen($,Z)),ie.event}}}e.getDelayedChannel=F;function j(H){let $=!1;return{call(Z,ie,se){return $?H.call(Z,ie,se):(0,U.timeout)(0).then(()=>$=!0).then(()=>H.call(Z,ie,se))},listen(Z,ie){if($)return H.listen(Z,ie);const se=new I.Relay;return(0,U.timeout)(0).then(()=>$=!0).then(()=>se.input=H.listen(Z,ie)),se.event}}}e.getNextTickChannel=j;class x{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const Z of $.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await I.Event.toPromise($.onDidAddConnection),await this.b($)}}e.StaticRouter=x;var V;(function(H){function $(ae,q){const C=ae,A=q&&q.disableMarshalling,M=new Map;for(const z in C)ie(z)&&M.set(z,I.Event.buffer(C[z],!0));return new class{listen(z,_,W){const Q=M.get(_);if(Q)return Q;if(se(_)){const ee=C[_];if(typeof ee=="function")return ee.call(C,W)}throw new Error(`Event not found: ${_}`)}call(z,_,W){const Q=C[_];if(typeof Q=="function"){if(!A&&Array.isArray(W))for(let ee=0;ee<W.length;ee++)W[ee]=(0,P.revive)(W[ee]);return Q.apply(C,W)}throw new Error(`Method not found: ${_}`)}}}H.fromService=$;function Z(ae,q){const C=q&&q.disableMarshalling;return new Proxy({},{get(A,M){if(typeof M=="string")return q?.properties?.has(M)?q.properties.get(M):se(M)?function(z){return ae.listen(M,z)}:ie(M)?ae.listen(M):async function(...z){let _;q&&!(0,p.isUndefinedOrNull)(q.context)?_=[q.context,...z]:_=z;const W=await ae.call(M,_);return C?W:(0,P.revive)(W)};throw new Error(`Property not found: ${String(M)}`)}})}H.toService=Z;function ie(ae){return ae[0]==="o"&&ae[1]==="n"&&S.isUpperAsciiLetter(ae.charCodeAt(2))}function se(ae){return/^onDynamic/.test(ae)&&S.isUpperAsciiLetter(ae.charCodeAt(9))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const $=H.toString();if($!=="[object Object]")return $}return H}function J(H){return Array.isArray(H)?H.map(X):X(H)}function G(H,$,Z,ie,se,ae,q){q=J(q);const C=B[se],A=C[ie%C.length];let M=[`%c[${H}]%c[${String($).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ae)?(M=M.concat(q),M.push(")")):M.push(q),console.log.apply(console,M)}class Y{constructor($,Z){this.d=$,this.f=Z,this.a=0,this.b=0}logOutgoing($,Z,ie,se,ae){this.b+=$,G(this.d,this.b,$,Z,ie,se,ae)}logIncoming($,Z,ie,se,ae){this.a+=$,G(this.f,this.a,$,Z,ie,se,ae)}}e.IPCLogger=Y}),define(re[149],oe([0,1,16,3,39]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(I){this.a=I,this.onMessage=U.Event.fromDOMEventEmitter(this.a,"message",w=>L.VSBuffer.wrap(w.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=O;class N extends l.IPCClient{constructor(I,w){const P=new O(I);super(P,w),this.b=P}dispose(){this.b.disconnect()}}e.Client=N}),define(re[96],oe([0,1,6,16,3,2,39]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(y){y.Created="created",y.Read="read",y.Write="write",y.Open="open",y.Error="error",y.Close="close",y.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",y.NodeEndReceived="nodeEndReceived",y.NodeEndSent="nodeEndSent",y.NodeDrainBegin="nodeDrainBegin",y.NodeDrainEnd="nodeDrainEnd",y.zlibInflateError="zlibInflateError",y.zlibInflateData="zlibInflateData",y.zlibInflateInitialWrite="zlibInflateInitialWrite",y.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",y.zlibInflateWrite="zlibInflateWrite",y.zlibInflateFlushFired="zlibInflateFlushFired",y.zlibDeflateError="zlibDeflateError",y.zlibDeflateData="zlibDeflateData",y.zlibDeflateWrite="zlibDeflateWrite",y.zlibDeflateFlushFired="zlibDeflateFlushFired",y.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",y.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",y.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",y.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",y.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",y.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",y.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",y.ProtocolHeaderRead="protocolHeaderRead",y.ProtocolMessageRead="protocolMessageRead",y.ProtocolHeaderWrite="protocolHeaderWrite",y.ProtocolMessageWrite="protocolMessageWrite",y.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(y){y.enableDiagnostics=!1,y.records=[];const k=new WeakMap;let T=0;function F(x,V){if(!k.has(x)){const B=String(++T);k.set(x,B)}return k.get(x)}function j(x,V,B,X){if(!y.enableDiagnostics)return;const J=F(x,V);if(X instanceof U.VSBuffer||X instanceof Uint8Array||X instanceof ArrayBuffer||ArrayBuffer.isView(X)){const G=U.VSBuffer.alloc(X.byteLength);G.set(X),y.records.push({timestamp:Date.now(),id:J,label:V,type:B,buff:G})}else y.records.push({timestamp:Date.now(),id:J,label:V,type:B,data:X})}y.traceSocketEvent=j})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(y){y[y.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",y[y.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function S(){return P||(P=U.VSBuffer.alloc(0)),P}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(k){this.a.push(k),this.b+=k.byteLength}read(k){return this.c(k,!0)}peek(k){return this.c(k,!1)}c(k,T){if(k===0)return S();if(k>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===k){const V=this.a[0];return T&&(this.a.shift(),this.b-=k),V}if(this.a[0].byteLength>k){const V=this.a[0].slice(0,k);return T&&(this.a[0]=this.a[0].slice(k),this.b-=k),V}const F=U.VSBuffer.alloc(k);let j=0,x=0;for(;k>0;){const V=this.a[x];if(V.byteLength>k){const B=V.slice(0,k);F.set(B,j),j+=k,T&&(this.a[x]=V.slice(k),this.b-=k),k-=k}else F.set(V,j),j+=V.byteLength,T?(this.a.shift(),this.b-=V.byteLength):x++,k-=V.byteLength}return F}}e.ChunkStream=p;var d;(function(y){y[y.None=0]="None",y[y.Regular=1]="Regular",y[y.Control=2]="Control",y[y.Ack=3]="Ack",y[y.Disconnect=5]="Disconnect",y[y.ReplayRequest=6]="ReplayRequest",y[y.Pause=7]="Pause",y[y.Resume=8]="Resume",y[y.KeepAlive=9]="KeepAlive",y[y.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",y[y.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function m(y){switch(y){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(y){y[y.HeaderLength=13]="HeaderLength",y[y.AcknowledgeTime=2e3]="AcknowledgeTime",y[y.TimeoutTime=2e4]="TimeoutTime",y[y.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",y[y.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",y[y.KeepAliveSendTime=5e3]="KeepAliveSendTime",y[y.LatencySampleTime=6e4]="LatencySampleTime",y[y.LatencySampleCount=5]="LatencySampleCount",y[y.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",y[y.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(k,T,F,j){this.type=k,this.id=T,this.ack=F,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends O.Disposable{constructor(k){super(),this.f=this.D(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=k,this.b=!1,this.c=new p,this.D(this.a.onData(T=>this.acceptChunk(T))),this.lastReadTime=Date.now()}acceptChunk(k){if(!(!k||k.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(k);this.c.byteLength>=this.g.readLen;){const T=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=T.readUInt32BE(9),this.g.messageType=T.readUInt8(0),this.g.id=T.readUInt32BE(1),this.g.ack=T.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,j=this.g.id,x=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",T),this.f.fire(new c(F,j,x,T)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(k){this.k=null,this.a=!1,this.b=!1,this.c=k,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(k){if(this.a)return;k.writtenTime=Date.now(),this.lastWriteTime=Date.now();const T=U.VSBuffer.alloc(13);T.writeUInt8(k.type,0),T.writeUInt32BE(k.id,1),T.writeUInt32BE(k.ack,5),T.writeUInt32BE(k.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(k.type),id:k.id,ack:k.ack,messageSize:k.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",k.data),this.j(T,k.data)}g(k,T){const F=this.f===0;return this.d.push(k,T),this.f+=k.byteLength+T.byteLength,F}h(){const k=U.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,k}j(k,T){this.g(k,T)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const k=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:k.byteLength}),this.c.write(k)}}class g extends O.Disposable{constructor(k){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=k,this.b=this.D(new h(this.a)),this.c=this.D(new u(this.a)),this.D(this.c.onMessage(T=>{T.type===1&&this.f.fire(T.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(k){this.b.write(new c(1,0,0,k))}}e.Protocol=g;class v extends N.IPCClient{static fromSocket(k,T){return new v(new g(k),T)}get onDidDispose(){return this.b.onDidDispose}constructor(k,T,F=null){super(k,T,F),this.b=k}dispose(){super.dispose();const k=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),k.end()}}e.Client=v;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(k){this.b?this.d.length>0?this.d.push(k):this.a.fire(k):this.d.push(k)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class n{constructor(k){this.data=k,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let k=0,T=this.a;for(;T;)T=T.next,k++;return k}peek(){return this.a?this.a.data:null}toArray(){const k=[];let T=0,F=this.a;for(;F;)k[T++]=F.data,F=F.next;return k}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(k){const T=new n(k);if(!this.a){this.a=T,this.b=T;return}this.b.next=T,this.b=T}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const k=Date.now();for(let T=0;T<i.a;T++)this.c[T]=k-1e3*T;setInterval(()=>{for(let T=i.a;T>=1;T--)this.c[T]=this.c[T-1];this.c[0]=Date.now()},1e3)}d(){const k=Date.now(),T=(1+i.a)*1e3;let F=0;for(let j=0;j<i.a;j++)k-this.c[j]<=T&&F++;return 1-F/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var t;(function(y){y[y.Good=0]="Good",y[y.Poor=1]="Poor"})(t=e.ConnectionHealth||(e.ConnectionHealth={}));function s(y){switch(y){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(k){this.connectionHealth=k}}e.ConnectionHealthChangedEvent=a;class r{constructor(k,T){this.roundTripTime=k,this.recentHighRoundTripCount=T}}e.HighRoundTripTimeEvent=r;class f{get unacknowledgedCount(){return this.c-this.d}constructor(k){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=k.loadEstimator??i.getInstance(),this.v=k.measureRoundTripTime??!1,this.w=k.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new O.DisposableStore,this.o=k.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(T=>this.E(T))),this.t.add(this.o.onClose(T=>this.A.fire(T))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(T=>this.J(T))),this.t.add(this.r.onHighRoundTripTime(T=>this.C.fire(T))),this.t.add(this.r.onDidChangeConnectionHealth(T=>this.D.fire(T))),this.v&&this.r.start(),k.initialChunk&&this.q.acceptChunk(k.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const k=new c(5,0,0,S());this.p.write(k),this.p.flush()}sendPause(){const k=new c(7,0,0,S());this.p.write(k)}sendResume(){const k=new c(8,0,0,S());this.p.write(k)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(k,T){this.a=!0,this.t.dispose(),this.t=new O.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=k,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new b),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(T)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const k=new c(3,0,this.h,S());this.p.write(k);const T=this.b.toArray();for(let F=0,j=T.length;F<j;F++)this.p.write(T[F]);this.G()}acceptDisconnect(){this.z.fire()}E(k){if(k.ack>this.d){this.d=k.ack;do{const T=this.b.peek();if(T&&T.id<=k.ack)this.b.pop();else break}while(!0)}switch(k.type){case 0:break;case 1:{if(k.id>this.g)if(k.id!==this.g+1){const T=Date.now();T-this.m>1e4&&(this.m=T,this.p.write(new c(6,0,0,S())))}else this.g=k.id,this.j=Date.now(),this.F(),this.y.fire(k.data);break}case 2:{this.x.fire(k.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const T=this.b.toArray();for(let F=0,j=T.length;F<j;F++)this.p.write(T[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(k.data);break}case 11:{this.r.handleResponse(k.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(k){const T=++this.c;this.h=this.g;const F=new c(1,T,this.h,k);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(k){const T=new c(2,0,0,k);this.p.write(T)}F(){if(this.g<=this.h||this.k)return;const k=Date.now()-this.j;if(k>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-k+5)}G(){if(this.c<=this.d||this.f||this.a)return;const k=this.b.peek(),T=Date.now()-k.writtenTime,F=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(T>=2e4&&F>=2e4&&j>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:T,timeSinceLastReceivedSomeData:F});return}const x=Math.max(2e4-T,2e4-F,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.G()},x)}H(){if(this.g<=this.h)return;this.h=this.g;const k=new c(3,0,this.h,S());this.p.write(k)}I(){this.h=this.g;const k=new c(9,0,this.h,S());this.p.write(k)}J(k){this.h=this.g;const T=new c(10,0,this.h,k);this.p.write(T)}K(k){this.h=this.g;const T=new c(11,0,this.h,k);this.p.write(T)}}e.PersistentProtocol=f;class b extends O.Disposable{constructor(){super(),this.a=this.D(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new L.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},k=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const k=++this.h,T=U.VSBuffer.alloc(4);T.writeUInt32BE(k,0),this.a.fire(T)},6e4)}handleResponse(k){if(k.byteLength!==4)return;const T=k.readUInt32BE(0);if(this.g<=0||T!==this.h)return;const F=Date.now()-this.g,j=this.k++;this.j[j%this.j.length]=F;const x=this.l,V=this.j.filter(B=>B>=1e3).length;this.l=V>=3?1:0,F>1e3&&this.b.fire(new r(F,V)),x!==this.l&&this.c.fire(this.l)}}}),define(re[150],oe([0,1,151,3,39,149]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class N extends l.IPCServer{static b(){const I=U.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(w,P)=>P);return U.Event.map(I,w=>{const{port1:P,port2:S}=new MessageChannel,d={protocol:new O.Protocol(P),onDidClientDisconnect:U.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[S]),d})}constructor(){super(N.b())}}e.Server=N}),define(re[65],oe([0,1,50,6,16,25,144,10,3,2,32,95,88,39]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends d.ChannelServer{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",h=>l.VSBuffer.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class E{constructor(u,h){this.i=u,this.j=h,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const g=h&&h.timeout?h.timeout:6e4;this.b=new U.Delayer(g),this.d=null,this.f=null}getChannel(u){const h=this;return{call(g,v,D){return h.k(u,g,v,D)},listen(g,v){return h.l(u,g,v)}}}k(u,h,g,v=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const D=this.n(u),n=(0,U.createCancelablePromise)(t=>D.call(h,g,t)),o=v.onCancellationRequested(()=>n.cancel()),i=(0,w.toDisposable)(()=>n.cancel());return this.c.add(i),n.finally(()=>{o.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,h,g){if(!this.b)return I.Event.None;this.b.cancel();let v;const D=new I.Emitter({onWillAddFirstListener:()=>{v=this.n(u).listen(h,g)(D.fire,D),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,p.removeDangerousEnvVariables)(h.env),this.d=(0,L.fork)(this.i,u,h);const g=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,N.isRemoteConsoleLog)(s)){(0,N.log)(s,`IPC Library: ${this.j.serverName}`);return}g.fire(l.VSBuffer.wrap(Buffer.from(s,"base64")))});const D=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&D.send(s.buffer.toString("base64")),o=g.event,i={send:n,onMessage:o};this.f=new d.ChannelClient(i);const t=()=>this.o();process.once("exit",t),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",t),this.c.forEach(r=>(0,w.dispose)(r)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(u){let h=this.g.get(u);return h||(h=this.m.getChannel(u),this.g.set(u,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=E}),define(re[152],oe([0,1,87,16,39,3,12,21]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(p){this.a=p,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",d=>U.VSBuffer.wrap(d.data)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}class w extends l.IPCServer{static b(){(0,N.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const p=new O.Emitter;return process.parentPort.on("message",d=>{const m=(0,R.firstOrDefault)(d.ports);m&&p.fire(m)}),O.Event.map(p.event,d=>({protocol:new I(d),onDidClientDisconnect:O.Event.fromNodeEventEmitter(d,"close")}))}constructor(){super(w.b())}}e.Server=w;function P(S,p,d){const m=E=>{E.data===p&&(S.removeListener("message",m),d())};S.on("message",m)}e.once=P}),define(re[153],oe([0,1,16,10,3,2,13,4,31,39,96]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class p{traceSocketEvent(r,f){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,f)}constructor(r,f=""){this.f=!0,this.debugLabel=f,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=b=>{if(this.traceSocketEvent("error",{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,U.onUnexpectedError)(b)}},this.socket.on("error",this.a),this.b=b=>{this.traceSocketEvent("close",{hadError:b}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const f=b=>{this.traceSocketEvent("read",b),r(L.VSBuffer.wrap(b))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(r){const f=b=>{r({type:0,hadError:b,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(r){const f=()=>{r()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,U.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,U.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=p;var d;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize",a[a.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var m;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(m||(m={}));class E extends O.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,f){this.socket.traceSocketEvent(r,f)}constructor(r,f,b,y){super(),this.f=this.D(new l.Emitter),this.g=this.D(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:b?.byteLength||0,recordInflateBytes:y}),this.a=this.D(new c(this,f,b,y,this.f,(k,T)=>this.k(k,T))),this.D(this.a.onError(k=>{console.error(k),(0,U.onUnexpectedError)(k),this.g.fire({type:0,hadError:!0,error:k})})),this.b=new P.ChunkStream,this.D(this.socket.onData(k=>this.l(k))),this.D(this.socket.onClose(async k=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(k)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){let f=0;for(;f<r.byteLength;)this.a.writeMessage(r.slice(f,Math.min(f+262144,r.byteLength))),f+=262144}k(r,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let b=2;r.byteLength<126?b+=0:r.byteLength<2**16?b+=2:b+=8;const y=L.VSBuffer.alloc(b);if(f?y.writeUInt8(194,0):y.writeUInt8(130,0),r.byteLength<126)y.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){y.writeUInt8(126,1);let k=1;y.writeUInt8(r.byteLength>>>8&255,++k),y.writeUInt8(r.byteLength>>>0&255,++k)}else{y.writeUInt8(127,1);let k=1;y.writeUInt8(0,++k),y.writeUInt8(0,++k),y.writeUInt8(0,++k),y.writeUInt8(0,++k),y.writeUInt8(r.byteLength>>>24&255,++k),y.writeUInt8(r.byteLength>>>16&255,++k),y.writeUInt8(r.byteLength>>>8&255,++k),y.writeUInt8(r.byteLength>>>0&255,++k)}this.socket.write(L.VSBuffer.concat([y,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),b=f.readUInt8(0),y=(b&128)>>>7,k=(b&64)>>>6,T=f.readUInt8(1),F=(T&128)>>>7,j=T&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=y,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(k)),this.j.firstFrameOfMessage=Boolean(y),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),b=f.readUInt8(1),y=(b&128)>>>7;let k=b&127,T=1;k===126?k=f.readUInt8(++T)*2**8+f.readUInt8(++T):k===127&&(k=f.readUInt8(++T)*0+f.readUInt8(++T)*0+f.readUInt8(++T)*0+f.readUInt8(++T)*0+f.readUInt8(++T)*2**24+f.readUInt8(++T)*2**16+f.readUInt8(++T)*2**8+f.readUInt8(++T));let F=0;y&&(F=f.readUInt8(++T)*2**24+f.readUInt8(++T)*2**16+f.readUInt8(++T)*2**8+f.readUInt8(++T)),this.j.state=3,this.j.readLen=k,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),g(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class c extends O.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(r,f,b,y,k,T){super(),this.l=r,this.m=k,this.n=T,this.a=this.D(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,f?(this.b=this.D(new u(this.l,y,b,{windowBits:15})),this.f=this.D(new h(this.l,{windowBits:15})),this.D(this.b.onError(F=>this.a.fire(F))),this.D(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const f=await this.r(this.f,r);this.n(f,!0)}else this.n(r,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(r,f){return new Promise((b,y)=>{r.write(f),r.flush(k=>b(k))})}acceptFrame(r,f,b){this.h.push({data:r,isCompressed:f,isLastFrameOfMessage:b}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const f=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.m.fire(f)}else this.m.fire(r.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(r,f,b){return new Promise((y,k)=>{r.write(f),b&&r.write(L.VSBuffer.fromByteArray([0,0,255,255])),r.flush(T=>y(T))})}}class u extends O.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(r,f,b,y){super(),this.h=r,this.j=f,this.a=this.D(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(y),this.b.on("error",k=>{this.h.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.h.traceSocketEvent("zlibInflateData",k),this.g.push(L.VSBuffer.wrap(k))}),b&&(this.h.traceSocketEvent("zlibInflateInitialWrite",b.buffer),this.b.write(b.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=L.VSBuffer.concat(this.g);this.g.length=0,r(f)})}}class h extends O.Disposable{constructor(r,f){super(),this.g=r,this.a=this.D(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",b=>{this.g.traceSocketEvent("zlibDeflateError",{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.g.traceSocketEvent("zlibDeflateData",b),this.f.push(L.VSBuffer.wrap(b))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=L.VSBuffer.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),r(f)})}}function g(a,r){if(r===0)return;const f=a.byteLength>>>2;for(let j=0;j<f;j++){const x=a.readUInt32BE(j*4);a.writeUInt32BE(x^r,j*4)}const b=f*4,y=a.byteLength-b,k=r>>>24&255,T=r>>>16&255,F=r>>>8&255;y>=1&&a.writeUInt8(a.readUInt8(b)^k,b),y>=2&&a.writeUInt8(a.readUInt8(b+1)^T,b+1),y>=3&&a.writeUInt8(a.readUInt8(b+2)^F,b+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function D(){const a=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;const r=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:S().os.tmpdir(),f=(0,N.join)(r,`vscode-ipc-${a}.sock`);return o(f),f}e.createRandomIPCHandle=D;function n(a,r,f){const b=S().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${f}-${r}-sock`;const y=f.substr(0,4),k=r.substr(0,6),T=b.substr(0,8);let F;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,N.join)(e.XDG_RUNTIME_DIR,`vscode-${T}-${y}-${k}.sock`):F=(0,N.join)(a,`${y}-${k}.sock`),o(F),F}e.createStaticIPCHandle=n;function o(a){const r=v[R.platform];typeof r=="number"&&a.length>=r&&console.warn(`WARNING: IPC handle "${a}" is longer than ${r} chars, try a shorter --user-data-dir`)}class i extends w.IPCServer{static b(r){const f=l.Event.fromNodeEventEmitter(r,"connection");return l.Event.map(f,b=>({protocol:new P.Protocol(new p(b,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(b,"close"))}))}constructor(r){super(i.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function t(a){return new Promise((r,f)=>{const b=S().net.createServer();b.on("error",f),b.listen(a,()=>{b.removeListener("error",f),r(new i(b))})})}e.serve=t;function s(a,r){return new Promise((f,b)=>{const y=S().net.createConnection(a,()=>{y.removeListener("error",b),f(P.Client.fromSocket(new p(y,`ipc-client${r}`),r))});y.once("error",b)})}e.connect=s}),define(re[66],oe([0,1,6,3,2,12]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function R(S){const p=S;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var I;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class w extends l.Disposable{constructor(p,d=Object.create(null)){super(),this.m=p,this.n=d,this.b=this.D(new U.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new L.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.D(this.m.onDidChangeItemsExternal(p=>this.q(p)))}q(p){p.changed?.forEach((d,m)=>this.r(m,d)),p.deleted?.forEach(d=>this.r(d,void 0))}r(p,d){if(this.c===I.Closed)return;let m=!1;(0,O.isUndefinedOrNull)(d)?m=this.f.delete(p):this.f.get(p)!==d&&(this.f.set(p,d),m=!0),m&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,d){const m=this.f.get(p);return(0,O.isUndefinedOrNull)(m)?d:m}getBoolean(p,d){const m=this.get(p);return(0,O.isUndefinedOrNull)(m)?d:m==="true"}getNumber(p,d){const m=this.get(p);return(0,O.isUndefinedOrNull)(m)?d:parseInt(m,10)}async set(p,d){if(this.c===I.Closed)return;if((0,O.isUndefinedOrNull)(d))return this.delete(p);const m=String(d);if(this.f.get(p)!==m)return this.f.set(p,m),this.j.set(p,m),this.h.delete(p),this.b.fire(p),this.v()}async delete(p){if(!(this.c===I.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.v()}async close(){return this.k||(this.k=this.s()),this.k}async s(){this.c=I.Closed;try{await this.v(0)}catch{}await this.m.close(()=>this.f)}get t(){return this.j.size>0||this.h.size>0}async u(){if(!this.t)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.t)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.t)return this.v(p)}async v(p){return this.g.trigger(()=>this.u(),p)}async whenFlushed(){if(!!this.t)return new Promise(p=>this.l.push(p))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}w.a=100,e.Storage=w;class P{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((d,m)=>this.a.set(m,d)),p.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=P}),define(re[154],oe([8,7]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[155],oe([8,7]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[156],oe([8,7]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(re[157],oe([8,7]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(re[158],oe([8,7]),function(te,e){return te.create("vs/platform/environment/node/argv",e)}),define(re[159],oe([8,7]),function(te,e){return te.create("vs/platform/environment/node/argvHelper",e)}),define(re[160],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[161],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[162],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[163],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(re[164],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[165],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[166],oe([8,7]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[167],oe([8,7]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[168],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[169],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[170],oe([8,7]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[171],oe([8,7]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[172],oe([8,7]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[173],oe([8,7]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[174],oe([8,7]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[175],oe([8,7]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[176],oe([8,7]),function(te,e){return te.create("vs/platform/shell/node/shellEnv",e)}),define(re[177],oe([8,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[178],oe([8,7]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[179],oe([8,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[180],oe([8,7]),function(te,e){return te.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[181],oe([8,7]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[182],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[183],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[184],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[185],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[186],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[187],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[188],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[189],oe([8,7]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[190],oe([8,7]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[191],oe([0,1,10,157]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(l=e.TokenType||(e.TokenType={}));function O(...w){switch(w.length){case 1:return(0,U.localize)(0,null,w[0]);case 2:return(0,U.localize)(1,null,w[0],w[1]);case 3:return(0,U.localize)(2,null,w[0],w[1],w[2]);default:return}}const N=(0,U.localize)(3,null),R=(0,U.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const S=this.d,p=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:p};this.g.push({offset:S,lexeme:p,additionalInfo:P}),this.f.push(d)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const S=this.c.substring(this.d,this.e),p=I.b.get(S);p?this.k(p):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,S=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const m=this.c.charCodeAt(P);if(S)S=!1;else if(m===47&&!p){P++;break}else m===91?p=!0:m===92?S=!0:m===93&&(p=!1);P++}for(;P<this.c.length&&I.a.has(this.c.charCodeAt(P));)P++;this.e=P;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}I.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=I}),define(re[192],oe([0,1,64,62,22,13,36,23,11]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,O.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",d)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=N.env.VSCODE_PORTABLE;return d?I.URI.file((0,O.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,O.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,O.resolve)(d):(0,O.normalize)((0,O.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?I.URI.file((0,O.resolve)(d)):I.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,O.resolve)(d);const m=N.env.VSCODE_EXTENSIONS;if(m)return m;const E=N.env.VSCODE_PORTABLE;return E?(0,O.join)(E,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?I.URI.parse(m):I.URI.file((0,O.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?I.URI.parse(d):I.URI.file((0,O.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const m of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);E&&E[1]&&E[2]&&d.push([E[1],E[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=N.env.VSCODE_PORTABLE;return d?I.URI.file((0,O.join)(d,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,m,E){this.a=d,this.b=m,this.c=E,this.editSessionId=this.args.editSessionId}}ye([U.memoize],w.prototype,"appRoot",null),ye([U.memoize],w.prototype,"userHome",null),ye([U.memoize],w.prototype,"userDataPath",null),ye([U.memoize],w.prototype,"appSettingsHome",null),ye([U.memoize],w.prototype,"tmpDir",null),ye([U.memoize],w.prototype,"cacheHome",null),ye([U.memoize],w.prototype,"stateResource",null),ye([U.memoize],w.prototype,"userRoamingDataHome",null),ye([U.memoize],w.prototype,"userDataSyncHome",null),ye([U.memoize],w.prototype,"sync",null),ye([U.memoize],w.prototype,"machineSettingsResource",null),ye([U.memoize],w.prototype,"workspaceStorageHome",null),ye([U.memoize],w.prototype,"localHistoryHome",null),ye([U.memoize],w.prototype,"keyboardLayoutResource",null),ye([U.memoize],w.prototype,"argvResource",null),ye([U.memoize],w.prototype,"isExtensionDevelopment",null),ye([U.memoize],w.prototype,"untitledWorkspacesHome",null),ye([U.memoize],w.prototype,"installSourcePath",null),ye([U.memoize],w.prototype,"builtinExtensionsPath",null),ye([U.memoize],w.prototype,"extensionsPath",null),ye([U.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ye([U.memoize],w.prototype,"extensionDevelopmentKind",null),ye([U.memoize],w.prototype,"extensionTestsLocationURI",null),ye([U.memoize],w.prototype,"debugExtensionHost",null),ye([U.memoize],w.prototype,"logLevel",null),ye([U.memoize],w.prototype,"extensionLogLevel",null),ye([U.memoize],w.prototype,"serviceMachineIdResource",null),ye([U.memoize],w.prototype,"disableTelemetry",null),ye([U.memoize],w.prototype,"disableWorkspaceTrust",null),ye([U.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function P(p,d){return S(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId,p.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function S(p,d,m,E,c,u){const g=Number(d||p)||(E?null:m),v=g?Boolean(!!d):!1;let D;if(u)try{D=JSON.parse(u)}catch{}return{port:g,break:v,debugId:c,env:D}}e.parseDebugParams=S}),define(re[193],oe([0,1,293,4,158]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const O={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const N={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(E,c,u=N){const h=E.find(a=>a.length>0&&a[0]!=="-"),g={},v=["_"],D=[],n={};let o;for(const a in c){const r=c[a];r.type==="subcommand"?a===h&&(o=r):(r.alias&&(g[a]=r.alias),r.type==="string"||r.type==="string[]"?(v.push(a),r.deprecates&&v.push(...r.deprecates)):r.type==="boolean"&&(D.push(a),r.deprecates&&D.push(...r.deprecates)),r.global&&(n[a]=r))}if(o&&h){const a=n;for(const y in o.options)a[y]=o.options[y];const r=E.filter(y=>y!==h),f=u.getSubcommandReporter?u.getSubcommandReporter(h):void 0,b=R(r,a,f);return{[h]:b,_:[]}}const i=L(E,{string:v,boolean:D,alias:g}),t={},s=i;t._=i._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in c){const r=c[a];if(r.type==="subcommand")continue;r.alias&&delete s[r.alias];let f=s[a];if(r.deprecates)for(const b of r.deprecates)s.hasOwnProperty(b)&&(f||(f=s[b],f&&u.onDeprecatedOption(b,r.deprecationMessage||(0,l.localize)(36,null,a))),delete s[b]);if(typeof f<"u"){if(r.type==="string[]"){if(Array.isArray(f)||(f=[f]),!r.allowEmptyValue){const b=f.filter(y=>y.length>0);b.length!==f.length&&(u.onEmptyValue(a),f=b.length>0?b:void 0)}}else r.type==="string"&&(Array.isArray(f)?(f=f.pop(),u.onMultipleValues(a,f)):!f&&!r.allowEmptyValue&&(u.onEmptyValue(a),f=void 0));t[a]=f,r.deprecationMessage&&u.onDeprecatedOption(a,r.deprecationMessage)}delete s[a]}for(const a in s)u.onUnknownOption(a);return t}e.parseArgs=R;function I(E,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${E}${u}`:`--${E}${u}`}function w(E,c){const u=[];for(const h in E){const g=E[h],v=I(h,g);u.push([v,g.description])}return P(u,c)}e.formatOptions=w;function P(E,c){const h=E.reduce((D,n)=>Math.max(D,n[0].length),12)+2+1;if(c-h<25)return E.reduce((D,n)=>D.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=c-h-1,v=[];for(const D of E){const n=D[0],o=p(D[1],g),i=S(h-n.length-2);v.push("  "+n+i+o[0]);for(let t=1;t<o.length;t++)v.push(S(h)+o[t])}return v}function S(E){return" ".repeat(E)}function p(E,c){const u=[];for(;E.length;){const h=E.length<c?E.length:E.lastIndexOf(" ",c),g=E.slice(0,h).trim();E=E.slice(h),u.push(g)}return u}function d(E,c,u,h,g){const v=process.stdout.isTTY&&process.stdout.columns||80,D=g?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",n=[`${E} ${u}`];n.push(""),n.push(`${(0,l.localize)(38,null)}: ${c} [${(0,l.localize)(39,null)}]${D}`),n.push(""),g?.noPipe!==!0&&(U.isWindows?n.push((0,l.localize)(40,null,c)):n.push((0,l.localize)(41,null,c)),n.push(""));const o={},i=[];for(const t in h){const s=h[t];if(s.type==="subcommand")s.description&&i.push({command:t,description:s.description});else if(s.description&&s.cat){let a=o[s.cat];a||(o[s.cat]=a={}),a[t]=s}}for(const t in o){const s=t,a=o[s];a&&(n.push(O[s]),n.push(...w(a,v)),n.push(""))}return i.length&&(n.push((0,l.localize)(42,null)),n.push(...P(i.map(t=>[t.command,t.description]),v)),n.push("")),n.join(`
`)}e.buildHelpMessage=d;function m(E,c){return`${E||(0,l.localize)(43,null)}
${c||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(re[194],oe([0,1,294,159,193]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const O=2048;function N(p,d){const m=(v,D)=>{console.warn((0,U.localize)(0,null,v,D))},E=v=>{console.warn((0,U.localize)(1,null,v))},c=(v,D)=>{console.warn((0,U.localize)(2,null,v,D))},u=v=>({onUnknownOption:D=>{v!=="tunnel"&&console.warn((0,U.localize)(3,null,D,v))},onMultipleValues:m,onEmptyValue:E,onDeprecatedOption:c,getSubcommandReporter:v!=="tunnel"?u:void 0}),h={onUnknownOption:v=>{console.warn((0,U.localize)(4,null,v))},onMultipleValues:m,onEmptyValue:E,onDeprecatedOption:c,getSubcommandReporter:u},g=(0,l.parseArgs)(p,l.OPTIONS,d?h:void 0);return g.goto&&g._.forEach(v=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,U.localize)(5,null))),g["max-memory"]&&L(parseInt(g["max-memory"])>=O,`The max-memory argument cannot be specified lower than ${O} MB.`),g}function R(p){const d=p.findIndex(m=>!/^-/.test(m));if(d>-1)return[...p.slice(0,d),...p.slice(d+1)]}function I(p){let[,...d]=p;process.env.VSCODE_DEV&&(d=R(d)||[]);const m=!S(process.env);return N(d,m)}e.parseMainProcessArgv=I;function w(p){let[,,...d]=p;return process.env.VSCODE_DEV&&(d=R(d)||[]),N(d,!0)}e.parseCLIProcessArgv=w;function P(p,...d){const m=p.indexOf("--");return m===-1?p.push(...d):p.splice(m,0,...d),p}e.addArg=P;function S(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function te(e,L,U){function l(N,R){const I=O(N,R),w=[I];return e.isAbsolute(I)||w.unshift(U),e.resolve(...w)}function O(N,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,R);const P=N["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(S,"AppData","Roaming")}break;case"darwin":w=e.join(L.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,R)}return{getUserDataPath:l}}if(typeof define=="function")define(re[195],oe([196,34,36]),function(e,L,U){return te(e,L,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=te(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[97],oe([0,1,34,192,195]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends U.AbstractNativeEnvironmentService{constructor(w,P){super(w,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,l.getUserDataPath)(w,P.nameShort)},P)}}e.NativeEnvironmentService=O;function N(I,w){return(0,U.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,w,I.extensionEnvironment)}e.parsePtyHostDebugPort=N;function R(I,w){return(0,U.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,w,I.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(re[197],oe([0,1,11]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const U=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,O=/^([^@]+@)?([^:]+)(:\d+)?$/,N=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(c){const u=c.match(N);return u?u[1]:null}function P(c){if(c.indexOf("://")===-1){const u=c.match(U);return u?w(u[2]):null}try{const u=L.URI.parse(c);if(u.authority)return w(u.authority)}catch{}return null}function S(c,u){const h=new Set;let g;for(;g=R.exec(c);){const D=P(g[1]);D&&h.add(D)}const v=new Set(u);return Array.from(h).map(D=>v.has(D)?D:D.replace(I,"a"))}e.getDomainsOfRemotes=S;function p(c){const u=c.match(O);return u?u[2]:null}function d(c,u,h){return c&&u?(h&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${c}${u}`:`${c}/${u}`):null}function m(c,u){if(c.indexOf("://")===-1){const h=c.match(l);if(h)return d(h[2],h[3],u)}try{const h=L.URI.parse(c);if(h.authority)return d(p(h.authority),h.path,u)}catch{}return null}function E(c,u=!1){const h=[];let g;for(;g=R.exec(c);){const v=m(g[1],u);v&&h.push(v)}return h}e.getRemotes=E}),define(re[198],oe([0,1,12,162]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(N,R,I){try{O(N,R,I)}catch(w){console.error(w?.message??w)}return N}e.localizeManifest=l;function O(N,R,I){const w=(P,S,p)=>{const d=P[S];if((0,L.isString)(d)){const m=d,E=m.length;if(E>1&&m[0]==="%"&&m[E-1]==="%"){const c=m.substr(1,E-2);let u=R[c];u===void 0&&I&&(u=I[c]);const h=typeof u=="string"?u:u?.message,g=I?.[c],v=typeof g=="string"?g:g?.message;if(!h){v||console.warn(`[${N.name}]: ${(0,U.localize)(0,null,c)}`);return}if(p&&(S==="title"||S==="category")&&v&&v!==h){const D={value:h,original:v};P[S]=D}else P[S]=h}}else if((0,L.isObject)(d))for(const m in d)d.hasOwnProperty(m)&&(m==="commands"?w(d,m,!0):w(d,m,p));else if(Array.isArray(d))for(let m=0;m<d.length;m++)w(d,m,p)};for(const P in N)N.hasOwnProperty(P)&&w(N,P)}}),define(re[199],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O,N,R,I){return this.a.call("promptImportantExtensionsInstallNotification",[O,N,R,I])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class U{constructor(O){this.a=O}listen(O,N){throw new Error(`Event not found: ${N}`)}call(O,N,R){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${N}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(re[67],oe([0,1,23,90,167,55]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||N.test(u)}e.isValidVersionStr=I;function w(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(N);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=w;function P(u){if(!u)return null;const h=u.majorBase,g=u.majorMustEqual,v=u.minorBase;let D=u.minorMustEqual;const n=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(h===0||(D=!1),o=!1);let i=0;if(u.preRelease){const t=R.exec(u.preRelease);if(t){const[,s,a,r]=t;i=Date.UTC(Number(s),Number(a)-1,Number(r))}}return{majorBase:h,majorMustEqual:g,minorBase:v,minorMustEqual:D,patchBase:n,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function S(u,h,g){let v;typeof u=="string"?v=P(w(u)):v=u;let D;h instanceof Date?D=h.getTime():typeof h=="string"&&(D=new Date(h).getTime());let n;if(typeof g=="string"?n=P(w(g)):n=g,!v||!n)return!1;const o=v.majorBase,i=v.minorBase,t=v.patchBase;let s=n.majorBase,a=n.minorBase,r=n.patchBase;const f=n.notBefore;let b=n.majorMustEqual,y=n.minorMustEqual,k=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:i>a?!0:i<a||D&&D<f?!1:t>=r:(o===1&&s===0&&(!b||!y||!k)&&(s=1,a=0,r=0,b=!0,y=!1,k=!1),o<s?!1:o>s?!b:i<a?!1:i>a?!y:t<r?!1:t>r?!k:!(D&&D<f))}e.isValidVersion=S;function p(u,h,g,v,D){const n=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return n.push([U.default.Error,l.localize(0,null)]),n;if(typeof v.name!="string")return n.push([U.default.Error,l.localize(1,null,"name")]),n;if(typeof v.version!="string")return n.push([U.default.Error,l.localize(2,null,"version")]),n;if(!v.engines)return n.push([U.default.Error,l.localize(3,null,"engines")]),n;if(typeof v.engines.vscode!="string")return n.push([U.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof v.extensionDependencies<"u"&&!c(v.extensionDependencies))return n.push([U.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof v.activationEvents<"u"){if(!c(v.activationEvents))return n.push([U.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof v.main>"u"&&typeof v.browser>"u")return n.push([U.default.Error,l.localize(7,null,"activationEvents","main")]),n}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&n.push([U.default.Warning,l.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return n.push([U.default.Error,l.localize(9,null,"main")]),n;{const t=(0,L.joinPath)(g,v.main);(0,L.isEqualOrParent)(t,g)||n.push([U.default.Warning,l.localize(10,null,t.path,g.path)])}if(typeof v.activationEvents>"u")return n.push([U.default.Error,l.localize(11,null,"activationEvents","main")]),n}if(typeof v.browser<"u"){if(typeof v.browser!="string")return n.push([U.default.Error,l.localize(12,null,"browser")]),n;{const t=(0,L.joinPath)(g,v.browser);(0,L.isEqualOrParent)(t,g)||n.push([U.default.Warning,l.localize(13,null,t.path,g.path)])}if(typeof v.activationEvents>"u")return n.push([U.default.Error,l.localize(14,null,"activationEvents","browser")]),n}if(!O.valid(v.version))return n.push([U.default.Error,l.localize(15,null)]),n;const o=[];if(!d(u,h,v,D,o))for(const t of o)n.push([U.default.Error,t]);return n}e.validateExtensionManifest=p;function d(u,h,g,v,D){return v||typeof g.main>"u"&&typeof g.browser>"u"?!0:E(u,h,g.engines.vscode,D)}e.isValidExtensionVersion=d;function m(u,h,g){return u==="*"||E(h,g,u)}e.isEngineValid=m;function E(u,h,g,v=[]){const D=P(w(g));if(!D)return v.push(l.localize(16,null,g)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return v.push(l.localize(17,null,g)),!1}else if(!D.majorMustEqual)return v.push(l.localize(18,null,g)),!1;return S(u,h,D)?!0:(v.push(l.localize(19,null,u,g)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let h=0,g=u.length;h<g;h++)if(typeof u[h]!="string")return!1;return!0}}),define(re[44],oe([0,1,16,31]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(O,N,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await N.readFile(O.serviceMachineIdResource)).value.toString();I=(0,U.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,U.generateUuid)();try{await N.writeFile(O.serviceMachineIdResource,L.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=l}),define(re[68],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(l,O=[],N=!1){this.ctor=l,this.staticArguments=O,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=L}),define(re[200],oe([0,1,68]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const U=[];var l;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function O(R,I,w){I instanceof L.SyncDescriptor||(I=new L.SyncDescriptor(I,[],Boolean(w))),U.push([R,I])}e.registerSingleton=O;function N(){return U}e.getSingletonServiceDescriptors=N}),define(re[201],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(O,N){this.key=O,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class U{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const N of this.a.values())N.outgoing.size===0&&O.push(N);return O}insertEdge(O,N){const R=this.lookupOrInsertNode(O),I=this.lookupOrInsertNode(N);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(O){const N=this.b(O);this.a.delete(N);for(const R of this.a.values())R.outgoing.delete(N),R.incoming.delete(N)}lookupOrInsertNode(O){const N=this.b(O);let R=this.a.get(N);return R||(R=new L(N,O),this.a.set(N,R)),R}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[N,R]of this.a)O.push(`${N}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,N]of this.a){const R=new Set([O]),I=this.c(N,R);if(I)return I}}c(O,N){for(const[R,I]of O.outgoing){if(N.has(R))return[...N,R].join(" -> ");N.add(R);const w=this.c(I,N);if(w)return w;N.delete(R)}}}e.Graph=U}),define(re[5],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function U(N,R,I){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:N,index:I}):(R[L.DI_DEPENDENCIES]=[{id:N,index:I}],R[L.DI_TARGET]=R)}function l(N){if(L.serviceIds.has(N))return L.serviceIds.get(N);const R=function(I,w,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(R,I,P)};return R.toString=()=>N,L.serviceIds.set(N,R),R}e.createDecorator=l;function O(N){return N}e.refineServiceDecorator=O}),define(re[202],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(re[17],oe([0,1,12,11,5]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof U.URI)}e.isConfigurationOverrides=O;function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof U.URI)}e.isConfigurationUpdateOverrides=N;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function w(c,u){const h=Object.create(null);for(const g in c)P(h,g,c[g],u);return h}e.toValuesTree=w;function P(c,u,h,g){const v=u.split("."),D=v.pop();let n=c;for(let o=0;o<v.length;o++){const i=v[o];let t=n[i];switch(typeof t){case"undefined":t=n[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${u} as ${v.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}n=t}if(typeof n=="object"&&n!==null)try{n[D]=h}catch{g(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function S(c,u){const h=u.split(".");p(c,h)}e.removeFromValueTree=S;function p(c,u){const h=u.shift();if(u.length===0){delete c[h];return}if(Object.keys(c).indexOf(h)!==-1){const g=c[h];typeof g=="object"&&!Array.isArray(g)&&(p(g,u),Object.keys(g).length===0&&delete c[h])}}function d(c,u,h){function g(n,o){let i=n;for(const t of o){if(typeof i!="object"||i===null)return;i=i[t]}return i}const v=u.split("."),D=g(c,v);return typeof D>"u"?h:D}e.getConfigurationValue=d;function m(c,u,h){Object.keys(u).forEach(g=>{g!=="__proto__"&&(g in c?L.isObject(c[g])&&L.isObject(u[g])?m(c[g],u[g],h):h&&(c[g]=u[g]):c[g]=u[g])})}e.merge=m;function E(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(re[69],oe([0,1,4,27,191,5,156]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",L.isMacintosh),R.set("isLinux",L.isLinux),R.set("isWindows",L.isWindows),R.set("isWeb",L.isWeb),R.set("isMacNative",L.isMacintosh&&!L.isWeb),R.set("isEdge",L.isEdge),R.set("isFirefox",L.isFirefox),R.set("isChrome",L.isChrome),R.set("isSafari",L.isSafari);const I=Object.prototype.hasOwnProperty;var w;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));const P={regexParsingWithErrorRecovery:!0};class S extends Error{}const p=(0,N.localize)(0,null),d=(0,N.localize)(1,null),m=(0,N.localize)(2,null),E=(0,N.localize)(3,null),c=(0,N.localize)(4,null),u=(0,N.localize)(5,null),h=(0,N.localize)(6,null),g=(0,N.localize)(7,null);class v{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(C=P){this.h=C,this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}parse(C){if(C===""){this.g.push({message:p,offset:0,lexeme:"",additionalInfo:d});return}this.d=this.c.reset(C).scan(),this.f=0,this.g=[];try{const A=this.k();if(!this.B()){const M=this.A(),z=M.type===17?u:void 0;throw this.g.push({message:c,offset:M.offset,lexeme:l.Scanner.getLexeme(M),additionalInfo:z}),new S}return A}catch(A){if(!(A instanceof S))throw A;return}}k(){return this.l()}l(){const C=[this.m()];for(;this.v(16);){const A=this.m();C.push(A)}return C.length===1?C[0]:D.or(...C)}m(){const C=[this.o()];for(;this.v(15);){const A=this.o();C.push(A)}return C.length===1?C[0]:D.and(...C)}o(){if(this.v(2)){const C=this.A();switch(C.type){case 11:return this.w(),t.INSTANCE;case 12:return this.w(),s.INSTANCE;case 0:{this.w();const A=this.k();return this.x(1,E),A?.negate()}case 17:return this.w(),k.create(C.lexeme);default:throw this.y("KEY | true | false | '(' expression ')'",C)}}return this.s()}s(){const C=this.A();switch(C.type){case 11:return this.w(),D.true();case 12:return this.w(),D.false();case 0:{this.w();const A=this.k();return this.x(1,E),A}case 17:{const A=C.lexeme;if(this.w(),this.v(9)){const z=this.A();if(!this.h.regexParsingWithErrorRecovery){if(this.w(),z.type!==10)throw this.y("REGEX",z);const _=z.lexeme,W=_.lastIndexOf("/"),Q=W===_.length-1?void 0:_.substring(W+1);let ee;try{ee=new RegExp(_.substring(1,W),Q)}catch{throw this.y("REGEX",z)}return B.create(A,ee)}switch(z.type){case 10:case 19:{const _=[z.lexeme];this.w();let W=this.A(),Q=0;for(let de=0;de<z.lexeme.length;de++)z.lexeme.charCodeAt(de)===40?Q++:z.lexeme.charCodeAt(de)===41&&Q--;for(;!this.B()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:Q++;break;case 1:Q--;break;case 10:case 18:for(let de=0;de<W.lexeme.length;de++)W.lexeme.charCodeAt(de)===40?Q++:z.lexeme.charCodeAt(de)===41&&Q--}if(Q<0)break;_.push(l.Scanner.getLexeme(W)),this.w(),W=this.A()}const ee=_.join(""),le=ee.lastIndexOf("/"),he=le===ee.length-1?void 0:ee.substring(le+1);let pe;try{pe=new RegExp(ee.substring(1,le),he)}catch{throw this.y("REGEX",z)}return D.regex(A,pe)}case 18:{const _=z.lexeme;this.w();let W=null;if(!(0,U.isFalsyOrWhitespace)(_)){const Q=_.indexOf("/"),ee=_.lastIndexOf("/");if(Q!==ee&&Q>=0){const le=_.slice(Q+1,ee),he=_[ee+1]==="i"?"i":"";try{W=new RegExp(le,he)}catch{throw this.y("REGEX",z)}}}if(W===null)throw this.y("REGEX",z);return B.create(A,W)}default:throw this.y("REGEX",this.A())}}if(this.v(14)){this.x(13,m);const z=this.t();return D.notIn(A,z)}switch(this.A().type){case 3:{this.w();const z=this.t();if(this.u().type===18)return D.equals(A,z);switch(z){case"true":return D.has(A);case"false":return D.not(A);default:return D.equals(A,z)}}case 4:{this.w();const z=this.t();if(this.u().type===18)return D.notEquals(A,z);switch(z){case"true":return D.not(A);case"false":return D.has(A);default:return D.notEquals(A,z)}}case 5:return this.w(),x.create(A,this.t());case 6:return this.w(),V.create(A,this.t());case 7:return this.w(),F.create(A,this.t());case 8:return this.w(),j.create(A,this.t());case 13:return this.w(),D.in(A,this.t());default:return D.has(A)}}case 20:throw this.g.push({message:h,offset:C.offset,lexeme:"",additionalInfo:g}),new S;default:throw this.y(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.A())}}t(){const C=this.A();switch(C.type){case 17:case 18:return this.w(),C.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(C){return this.z(C)?(this.w(),!0):!1}w(){return this.B()||this.f++,this.u()}x(C,A){if(this.z(C))return this.w();throw this.y(A,this.A())}y(C,A,M){const z=(0,N.localize)(8,null,C,l.Scanner.getLexeme(A)),_=A.offset,W=l.Scanner.getLexeme(A);return this.g.push({message:z,offset:_,lexeme:W,additionalInfo:M}),new S}z(C){return this.A().type===C}A(){return this.d[this.f]}B(){return this.A().type===20}}e.Parser=v;class D{static false(){return t.INSTANCE}static true(){return s.INSTANCE}static has(C){return a.create(C)}static equals(C,A){return r.create(C,A)}static notEquals(C,A){return y.create(C,A)}static regex(C,A){return B.create(C,A)}static in(C,A){return f.create(C,A)}static notIn(C,A){return b.create(C,A)}static not(C){return k.create(C)}static and(...C){return G.create(C,null,!0)}static or(...C){return Y.create(C,null,!0)}static greater(C,A){return F.create(C,A)}static greaterEquals(C,A){return j.create(C,A)}static smaller(C,A){return x.create(C,A)}static smallerEquals(C,A){return V.create(C,A)}static deserialize(C){return C==null?void 0:this.c.parse(C)}}D.c=new v({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=D;function n(q){const C=new v({regexParsingWithErrorRecovery:!1});return q.map(A=>(C.parse(A),C.lexingErrors.length>0?C.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,N.localize)(9,null,M.additionalInfo):(0,N.localize)(10,null),offset:M.offset,length:M.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.validateWhenClauses=n;function o(q,C){const A=q?q.substituteConstants():void 0,M=C?C.substituteConstants():void 0;return!A&&!M?!0:!A||!M?!1:A.equals(M)}e.expressionsAreEqualWithConstantSubstitution=o;function i(q,C){return q.cmp(C)}class t{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return s.INSTANCE}}t.INSTANCE=new t,e.ContextKeyFalseExpr=t;class s{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return t.INSTANCE}}s.INSTANCE=new s,e.ContextKeyTrueExpr=s;class a{static create(C,A=null){const M=R.get(C);return typeof M=="boolean"?M?s.INSTANCE:t.INSTANCE:new a(C,A)}constructor(C,A){this.key=C,this.c=A,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:$(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=R.get(this.key);return typeof C=="boolean"?C?s.INSTANCE:t.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=k.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=a;class r{static create(C,A,M=null){if(typeof A=="boolean")return A?a.create(C,M):k.create(C,M);const z=R.get(C);return typeof z=="boolean"?A===(z?"true":"false")?s.INSTANCE:t.INSTANCE:new r(C,A,M)}constructor(C,A,M){this.c=C,this.d=A,this.f=M,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=R.get(this.c);if(typeof C=="boolean"){const A=C?"true":"false";return this.d===A?s.INSTANCE:t.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=r;class f{static create(C,A){return new f(C,A)}constructor(C,A){this.d=C,this.f=A,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const A=C.getValue(this.f),M=C.getValue(this.d);return Array.isArray(A)?A.includes(M):typeof M=="string"&&typeof A=="object"&&A!==null?I.call(A,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class b{static create(C,A){return new b(C,A)}constructor(C,A){this.d=C,this.f=A,this.type=11,this.c=f.create(C,A)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class y{static create(C,A,M=null){if(typeof A=="boolean")return A?k.create(C,M):a.create(C,M);const z=R.get(C);return typeof z=="boolean"?A===(z?"true":"false")?t.INSTANCE:s.INSTANCE:new y(C,A,M)}constructor(C,A,M){this.c=C,this.d=A,this.f=M,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=R.get(this.c);if(typeof C=="boolean"){const A=C?"true":"false";return this.d===A?t.INSTANCE:s.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=y;class k{static create(C,A=null){const M=R.get(C);return typeof M=="boolean"?M?t.INSTANCE:s.INSTANCE:new k(C,A)}constructor(C,A){this.c=C,this.d=A,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:$(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=R.get(this.c);return typeof C=="boolean"?C?t.INSTANCE:s.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.ContextKeyNotExpr=k;function T(q,C){if(typeof q=="string"){const A=parseFloat(q);isNaN(A)||(q=A)}return typeof q=="string"||typeof q=="number"?C(q):t.INSTANCE}class F{static create(C,A,M=null){return T(A,z=>new F(C,z,M))}constructor(C,A,M){this.c=C,this.d=A,this.f=M,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=F;class j{static create(C,A,M=null){return T(A,z=>new j(C,z,M))}constructor(C,A,M){this.c=C,this.d=A,this.f=M,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=j;class x{static create(C,A,M=null){return T(A,z=>new x(C,z,M))}constructor(C,A,M){this.c=C,this.d=A,this.f=M,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=x;class V{static create(C,A,M=null){return T(A,z=>new V(C,z,M))}constructor(C,A,M){this.c=C,this.d=A,this.f=M,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:Z(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=V;class B{static create(C,A){return new B(C,A)}constructor(C,A){this.d=C,this.f=A,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const A=this.f?this.f.source:"",M=C.f?C.f.source:"";return A<M?-1:A>M?1:0}equals(C){if(C.type===this.type){const A=this.f?this.f.source:"",M=C.f?C.f.source:"";return this.d===C.d&&A===M}return!1}substituteConstants(){return this}evaluate(C){const A=C.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.ContextKeyRegexExpr=B;class X{static create(C){return new X(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(C){return new X(this.c.map(C))}negate(){return this.c}}e.ContextKeyNotRegexExpr=X;function J(q){let C=null;for(let A=0,M=q.length;A<M;A++){const z=q[A].substituteConstants();if(q[A]!==z&&C===null){C=[];for(let _=0;_<A;_++)C[_]=q[_]}C!==null&&(C[A]=z)}return C===null?q:C}class G{static create(C,A,M){return G.d(C,A,M)}constructor(C,A){this.expr=C,this.c=A,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let A=0,M=this.expr.length;A<M;A++){const z=i(this.expr[A],C.expr[A]);if(z!==0)return z}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let A=0,M=this.expr.length;A<M;A++)if(!this.expr[A].equals(C.expr[A]))return!1;return!0}return!1}substituteConstants(){const C=J(this.expr);return C===this.expr?this:G.create(C,this.c,!1)}evaluate(C){for(let A=0,M=this.expr.length;A<M;A++)if(!this.expr[A].evaluate(C))return!1;return!0}static d(C,A,M){const z=[];let _=!1;for(const W of C)if(!!W){if(W.type===1){_=!0;continue}if(W.type===0)return t.INSTANCE;if(W.type===6){z.push(...W.expr);continue}z.push(W)}if(z.length===0&&_)return s.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];for(;z.length>1;){const W=z[z.length-1];if(W.type!==9)break;z.pop();const Q=z.pop(),ee=z.length===0,le=Y.create(W.expr.map(he=>G.create([he,Q],null,M)),null,ee);le&&(z.push(le),z.sort(i))}if(z.length===1)return z[0];if(M){for(let W=0;W<z.length;W++)for(let Q=W+1;Q<z.length;Q++)if(z[W].negate().equals(z[Q]))return t.INSTANCE;if(z.length===1)return z[0]}return new G(z,A)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const A of this.expr)C.push(...A.keys());return C}map(C){return new G(this.expr.map(A=>A.map(C)),null)}negate(){if(!this.c){const C=[];for(const A of this.expr)C.push(A.negate());this.c=Y.create(C,this,!0)}return this.c}}class Y{static create(C,A,M){return Y.d(C,A,M)}constructor(C,A){this.expr=C,this.c=A,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let A=0,M=this.expr.length;A<M;A++){const z=i(this.expr[A],C.expr[A]);if(z!==0)return z}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let A=0,M=this.expr.length;A<M;A++)if(!this.expr[A].equals(C.expr[A]))return!1;return!0}return!1}substituteConstants(){const C=J(this.expr);return C===this.expr?this:Y.create(C,this.c,!1)}evaluate(C){for(let A=0,M=this.expr.length;A<M;A++)if(this.expr[A].evaluate(C))return!0;return!1}static d(C,A,M){let z=[],_=!1;if(C){for(let W=0,Q=C.length;W<Q;W++){const ee=C[W];if(!!ee){if(ee.type===0){_=!0;continue}if(ee.type===1)return s.INSTANCE;if(ee.type===9){z=z.concat(ee.expr);continue}z.push(ee)}}if(z.length===0&&_)return t.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];if(M){for(let W=0;W<z.length;W++)for(let Q=W+1;Q<z.length;Q++)if(z[W].negate().equals(z[Q]))return s.INSTANCE;if(z.length===1)return z[0]}return new Y(z,A)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const A of this.expr)C.push(...A.keys());return C}map(C){return new Y(this.expr.map(A=>A.map(C)),null)}negate(){if(!this.c){const C=[];for(const A of this.expr)C.push(A.negate());for(;C.length>1;){const A=C.shift(),M=C.shift(),z=[];for(const _ of ae(A))for(const W of ae(M))z.push(G.create([_,W],null,!1));C.unshift(Y.create(z,null,!1))}this.c=Y.create(C,this,!0)}return this.c}}class H extends a{static all(){return H.d.values()}constructor(C,A,M){super(C,null),this.f=A,typeof M=="object"?H.d.push({...M,key:C}):M!==!0&&H.d.push({key:C,description:M,type:A!=null?typeof A:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return r.create(this.key,C)}notEqualsTo(C){return y.create(this.key,C)}}H.d=[],e.RawContextKey=H,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function $(q,C){return q<C?-1:q>C?1:0}function Z(q,C,A,M){return q<A?-1:q>A?1:C<M?-1:C>M?1:0}function ie(q,C){if(q.type===0||C.type===1)return!0;if(q.type===9)return C.type===9?se(q.expr,C.expr):!1;if(C.type===9){for(const A of C.expr)if(ie(q,A))return!0;return!1}if(q.type===6){if(C.type===6)return se(C.expr,q.expr);for(const A of q.expr)if(ie(A,C))return!0;return!1}return q.equals(C)}e.implies=ie;function se(q,C){let A=0,M=0;for(;A<q.length&&M<C.length;){const z=q[A].cmp(C[M]);if(z<0)return!1;z===0&&A++,M++}return A===q.length}function ae(q){return q.type===9?q.expr:[q]}}),define(re[98],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function U(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=U;class l{async getPerformanceInfo(N,R){return{}}async getSystemInfo(N,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,R){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.NullDiagnosticsService=l}),define(re[99],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(re[15],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],oe([0,1,161,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function O(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function N(u,h){switch(u){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function R(u,h){return h==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(u,h,g){return R(h,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:w(g).includes(u)}e.isTargetPlatformCompatible=I;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(re[203],oe([0,1,3,2,32,11,93,29]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(c,u){return c?O.URI.revive(u?u.transformIncoming(c):c):void 0}function w(c,u){return u?u.transformOutgoingURI(c):c}function P(c,u){u=u||N.DefaultURITransformer;const h=c.manifest;return{...(0,N.transformAndReviveIncomingURIs)({...c,manifest:void 0},u),manifest:h}}function S(c,u){return c?.profileLocation?(0,N.transformAndReviveIncomingURIs)(c,u??N.DefaultURITransformer):c}function p(c,u){return u?(0,l.cloneAndChange)(c,h=>h instanceof O.URI?u.transformOutgoingURI(h):void 0):c}class d{constructor(u,h){this.a=u,this.b=h,this.onInstallExtension=L.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,h){const g=this.b(u);switch(h){case"onInstallExtension":return L.Event.map(this.onInstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,g):v.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,v=>v.map(D=>({...D,local:D.local?p(D.local,g):D.local,profileLocation:D.profileLocation?w(D.profileLocation,g):D.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,g):v.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,v=>({...v,profileLocation:v.profileLocation?w(v.profileLocation,g):v.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,v=>p(v,g))}throw new Error("Invalid listen")}async call(u,h,g){const v=this.b(u);switch(h){case"zip":{const D=P(g[0],v),n=await this.a.zip(D);return w(n,v)}case"unzip":return this.a.unzip(I(g[0],v));case"install":return this.a.install(I(g[0],v),S(g[1],v));case"installFromLocation":return this.a.installFromLocation(I(g[0],v),I(g[1],v));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],I(g[1],v),I(g[2],v));case"getManifest":return this.a.getManifest(I(g[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],S(g[1],v));case"uninstall":return this.a.uninstall(P(g[0],v),S(g[1],v));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(g[0],v));case"getInstalled":return(await this.a.getInstalled(g[0],I(g[1],v))).map(n=>p(n,v));case"copyExtensions":return this.a.copyExtensions(I(g[0],v),I(g[1],v));case"updateMetadata":{const D=await this.a.updateMetadata(P(g[0],v),g[1],I(g[2],v));return p(D,v)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class m extends U.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.D(new L.Emitter),this.f=this.D(new L.Emitter),this.g=this.D(new L.Emitter),this.h=this.D(new L.Emitter),this.j=this.D(new L.Emitter),this.D(this.k.listen("onInstallExtension")(h=>this.l(this.c,{...h,source:this.m(h.source)?O.URI.revive(h.source):h.source,profileLocation:O.URI.revive(h.profileLocation)}))),this.D(this.k.listen("onDidInstallExtensions")(h=>this.l(this.f,h.map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.m(g.source)?O.URI.revive(g.source):g.source,profileLocation:O.URI.revive(g.profileLocation)}))))),this.D(this.k.listen("onUninstallExtension")(h=>this.l(this.g,{...h,profileLocation:O.URI.revive(h.profileLocation)}))),this.D(this.k.listen("onDidUninstallExtension")(h=>this.l(this.h,{...h,profileLocation:O.URI.revive(h.profileLocation)}))),this.D(this.k.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(P(h,null))))}l(u,h){u.fire(h)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const h=await this.getTargetPlatform();return u.allTargetPlatforms.some(g=>(0,R.isTargetPlatformCompatible)(g,u.allTargetPlatforms,h))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(h=>O.URI.revive(h)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,h){return Promise.resolve(this.k.call("install",[u,h])).then(g=>P(g,null))}installFromLocation(u,h){return Promise.resolve(this.k.call("installFromLocation",[u,h])).then(g=>P(g,null))}async installExtensionsFromProfile(u,h,g){return(await this.k.call("installExtensionsFromProfile",[u,h,g])).map(D=>P(D,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,h){return Promise.resolve(this.k.call("installFromGallery",[u,h])).then(g=>P(g,null))}uninstall(u,h){return Promise.resolve(this.k.call("uninstall",[u,h]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(h=>P(h,null))}getInstalled(u=null,h){return Promise.resolve(this.k.call("getInstalled",[u,h])).then(g=>g.map(v=>P(v,null)))}updateMetadata(u,h,g){return Promise.resolve(this.k.call("updateMetadata",[u,h,g])).then(v=>P(v,null))}copyExtensions(u,h){return this.k.call("copyExtensions",[u,h])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,h){const g=await this.k.call("download",[u,h]);return O.URI.revive(g)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class E{constructor(u){this.a=u}listen(u,h){throw new Error("Invalid listen")}call(u,h,g){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(re[100],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class U{b(){return this.a||(this.a=new Promise((O,N)=>te(["node-vsce-sign"],async R=>O(R),N))),this.a}async verify(O,N,R){let I;try{I=await this.b()}catch{return!1}return I.verify(O,N,R)}}e.ExtensionSignatureVerificationService=U}),define(re[101],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(U=e.RecommendationSource||(e.RecommendationSource={}));function l(N){switch(N){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var O;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(O=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],oe([0,1,49,13,27,12,11,169,5,4,22]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S($){return $.create===!0}e.isFileOpenForWriteOptions=S;var p;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(p=e.FileType||(e.FileType={}));var d;(function($){$[$.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var m;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E($){return!!($.capabilities&2)}e.hasReadWriteCapability=E;function c($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=c;function u($){return!!($.capabilities&32768)}e.hasFileCloneCapability=u;function h($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function g($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=g;function v($){return E($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var D;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(Z,ie){const se=new n(Z.toString(),ie);return t(se,ie),se}constructor(Z,ie){super(Z),this.code=ie}}e.FileSystemProviderError=n;function o($,Z){return n.create($,Z)}e.createFileSystemProviderError=o;function i($){return $||o((0,R.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function t($,Z){return $.name=Z?`${Z} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=t;function s($){if(!$)return D.Unknown;if($ instanceof n)return $.code;const Z=/^(.+) \(FileSystemError\)$/.exec($.name);if(!Z)return D.Unknown;switch(Z[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=s;function a($){if($ instanceof T)return $.fileOperationResult;switch(s($)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class f{constructor(Z,ie,se){this.resource=Z,this.operation=ie,this.target=se}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=f;var b;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(b=e.FileChangeType||(e.FileChangeType={}));class y{constructor(Z,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const ae of Z){const q=se.get(ae.type);switch(q?q.push([ae.resource,ae]):se.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,q]of se)switch(ae){case 1:this.a=L.TernarySearchTree.forUris(()=>ie),this.a.fill(q);break;case 0:this.b=L.TernarySearchTree.forUris(()=>ie),this.b.fill(q);break;case 2:this.c=L.TernarySearchTree.forUris(()=>ie),this.c.fill(q);break}}contains(Z,...ie){return this.d(Z,{includeChildren:!1},...ie)}affects(Z,...ie){return this.d(Z,{includeChildren:!0},...ie)}d(Z,ie,...se){if(!Z)return!1;const ae=se.length>0;return!!((!ae||se.includes(1))&&(this.a?.get(Z)||ie.includeChildren&&this.a?.findSuperstr(Z))||(!ae||se.includes(0))&&(this.b?.get(Z)||ie.includeChildren&&this.b?.findSuperstr(Z))||(!ae||se.includes(2))&&(this.c?.findSubstr(Z)||ie.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function k($,Z,ie){return!$||!Z||$===Z||Z.length>$.length?!1:(Z.charAt(Z.length-1)!==U.sep&&(Z+=U.sep),ie?(0,l.startsWithIgnoreCase)($,Z):$.indexOf(Z)===0)}e.isParent=k;class T extends Error{constructor(Z,ie,se){super(Z),this.fileOperationResult=ie,this.options=se}}e.FileOperationError=T;class F extends T{constructor(Z,ie,se,ae){super(Z,ie,ae),this.fileOperationResult=ie,this.size=se}}e.TooLargeFileOperationError=F;class j extends T{constructor(Z,ie,se){super(Z,2,se),this.stat=ie}}e.NotModifiedSinceFileOperationError=j;var x;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=B;async function X($,Z){if(!Z.hasProvider(N.URI.from({scheme:$.scheme})))return new Promise(ie=>{const se=Z.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===$.scheme&&ae.added&&(se.dispose(),ie())})})}e.whenProviderRegistered=X,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(Z){return(0,O.isNumber)(Z)||(Z=0),Z<J.KB?(0,R.localize)(1,null,Z.toFixed(0)):Z<J.MB?(0,R.localize)(2,null,(Z/J.KB).toFixed(2)):Z<J.GB?(0,R.localize)(3,null,(Z/J.MB).toFixed(2)):Z<J.TB?(0,R.localize)(4,null,(Z/J.GB).toFixed(2)):(0,R.localize)(5,null,(Z/J.TB).toFixed(2))}}J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB,e.ByteSize=J;var G;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function Y($){return{maxFileSize:$===0?300*J.MB:16*J.GB,maxHeapSize:$===0?700*J.MB:2*700*J.MB}}e.getPlatformFileLimits=Y;function H($){const Z=typeof $=="string"||$?.scheme===P.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===P.Schemas.file?1024*J.MB:Z?10*J.MB:w.isWeb?50*J.MB:1024*J.MB}e.getLargeFileConfirmationLimit=H});var K=this&&this.__param||function(te,e){return function(L,U){e(L,U,te)}};define(re[204],oe([0,1,102,43,14]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let O=class{constructor(R){this.a=R}async checksum(R){const I=(await this.a.readFileStream(R)).value;return new Promise((w,P)=>{const S=(0,L.createHash)("md5");(0,U.listenStream)(I,{onData:p=>S.update(p.buffer),onError:p=>P(p),onEnd:()=>w(S.digest("base64").replace(/=+$/,""))})})}};O=ye([K(0,l.IFileService)],O),e.ChecksumService=O}),define(re[205],oe([0,1,16,38,10,3,2,43,11,31,14]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends N.Disposable{constructor(d,m){super(),this.a=d,this.b=m,this.onDidChangeCapabilities=O.Event.None,this.f=this.D(new O.Emitter),this.onDidChangeFile=this.f.event,this.g=this.D(new O.Emitter),this.onDidWatchError=this.g.event,this.h=(0,w.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,m){const{buffer:E}=await this.a.call("readFile",[d,m]);return E}readFileStream(d,m,E){const c=(0,R.newWriteableStream)(h=>L.VSBuffer.concat(h.map(g=>L.VSBuffer.wrap(g))).buffer),u=this.a.listen("readFileStream",[d,m])(h=>{if(h instanceof L.VSBuffer)c.write(h.buffer);else{if(h==="end")c.end();else{let g;if(h instanceof Error)g=h;else{const v=h;g=(0,P.createFileSystemProviderError)(v.message??(0,U.toErrorMessage)(v),v.code??P.FileSystemProviderErrorCode.Unknown)}c.error(g),c.end()}u.dispose()}});return E.onCancellationRequested(()=>{c.error((0,l.canceled)()),c.end(),u.dispose()}),c}writeFile(d,m,E){return this.a.call("writeFile",[d,L.VSBuffer.wrap(m),E])}open(d,m){return this.a.call("open",[d,m])}close(d){return this.a.call("close",[d])}async read(d,m,E,c,u){const[h,g]=await this.a.call("read",[d,m,u]);return E.set(h.buffer.slice(0,g),c),g}write(d,m,E,c,u){return this.a.call("write",[d,m,L.VSBuffer.wrap(E),c,u])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,m){return this.a.call("delete",[d,m])}rename(d,m,E){return this.a.call("rename",[d,m,E])}copy(d,m,E){return this.a.call("copy",[d,m,E])}cloneFile(d,m){return this.a.call("cloneFile",[d,m])}i(){this.D(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const m=d;this.f.fire(m.map(E=>({resource:I.URI.revive(E.resource),type:E.type})))}else{const m=d;this.g.fire(m)}}))}watch(d,m){const E=(0,w.generateUuid)();return this.a.call("watch",[this.h,E,d,m]),(0,N.toDisposable)(()=>this.a.call("unwatch",[this.h,E]))}}e.DiskFileSystemProviderClient=S}),define(re[103],oe([0,1,16,10,170,14]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(P,S,p,d,m,E){let c;try{await R(P,S,p,d,m,E)}catch(u){c=u}finally{c&&m.errorTransformer&&(c=m.errorTransformer(c)),typeof c<"u"&&p.error(c),p.end()}}e.readFileIntoStream=N;async function R(P,S,p,d,m,E){I(E);const c=await P.open(S,{create:!1});try{I(E);let u=0,h=0,g=m&&typeof m.length=="number"?m.length:void 0,v=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),D=m&&typeof m.position=="number"?m.position:0,n=0;do h=await P.read(c,D,v.buffer,n,v.byteLength-n),D+=h,n+=h,u+=h,typeof g=="number"&&(g-=h),n===v.byteLength&&(await p.write(d(v)),v=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof g=="number"?g:m.bufferSize)),n=0);while(h>0&&(typeof g!="number"||g>0)&&I(E)&&w(u,m));if(n>0){let o=n;typeof g=="number"&&(o=Math.min(n,g)),p.write(d(v.slice(0,o)))}}catch(u){throw(0,O.ensureFileSystemProviderError)(u)}finally{await P.close(c)}}function I(P){if(P.isCancellationRequested)throw(0,U.canceled)();return!0}function w(P,S){if(S?.limits){if(typeof S.limits.memory=="number"&&P>S.limits.memory)throw(0,O.createFileSystemProviderError)((0,l.localize)(0,null),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&P>S.limits.size)throw(0,O.createFileSystemProviderError)((0,l.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],oe([0,1,92,2,13,4,11,14]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class w extends U.Disposable{constructor(h,g,v,D){super(),this.h=h,this.i=g,this.j=v,this.k=D,this.c=this.D(new U.MutableDisposable),this.f=void 0,this.g=0}m(){const h=new U.DisposableStore;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(g=>this.h(g))),h.add(this.b.onDidLogMessage(g=>this.i(g))),h.add(this.b.onDidError(g=>this.n(g)))}n(h){this.k.restartOnError?this.g<w.a&&this.f?(this.q(`restarting watcher after error: ${h}`),this.p(this.f)):this.q(`gave up attempting to restart watcher after error: ${h}`):this.q(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}q(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}r(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}w.a=5,e.AbstractWatcherClient=w;class P extends w{constructor(h,g,v){super(h,g,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class S extends w{constructor(h,g,v){super(h,g,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function p(u){return u.map(h=>({type:h.type,resource:N.URI.file(h.path)}))}e.toFileChanges=p;function d(u){const h=new c;for(const g of u)h.processEvent(g);return h.coalesce()}e.coalesceEvents=d;function m(u,h){return typeof h=="string"&&!h.startsWith(L.GLOBSTAR)&&!(0,l.isAbsolute)(h)?{base:u,pattern:h}:h}e.normalizeWatcherPattern=m;function E(u,h){const g=[];for(const v of h)g.push((0,L.parse)(m(u,v)));return g}e.parseWatcherPatterns=E;class c{constructor(){this.a=new Set,this.b=new Map}c(h){return O.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const g=this.b.get(this.c(h));let v=!1;if(g){const D=g.type,n=h.type;g.path!==h.path&&(h.type===2||h.type===1)?v=!0:D===1&&n===2?(this.b.delete(this.c(h)),this.a.delete(g)):D===2&&n===1?g.type=0:D===1&&n===0||(g.type=n)}else v=!0;v&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],g=[];return Array.from(this.a).filter(v=>v.type!==2?(h.push(v),!1):!0).sort((v,D)=>v.path.length-D.path.length).filter(v=>g.some(D=>(0,R.isParent)(v.path,D,!O.isLinux))?!1:(g.push(v.path),!0)).concat(h)}}}),define(re[206],oe([0,1,54,6,25,48,2,85,13,4,146,28,56]),function(te,e,L,U,l,O,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends N.Disposable{constructor(c,u,h,g){super(),this.j=c,this.k=u,this.l=h,this.m=g,this.c=this.D(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.D(new U.RunOnceWorker(v=>this.t(v),d.b)),this.g=(0,p.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const c=await this.q(this.j);if(this.i.token.isCancellationRequested)return;const u=await S.Promises.stat(c);this.D(await this.r(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.v(c):this.y(c)}}async q(c){let u=c.path;try{u=await S.Promises.realpath(c.path),c.path===u&&(u=await(0,P.realcase)(c.path)??c.path),c.path!==u&&this.y(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async r(c,u){if(w.isMacintosh&&(0,O.isEqualOrParent)(c,"/Volumes/",!0))return this.v(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),N.Disposable.None;const h=new l.CancellationTokenSource(this.i.token),g=new N.DisposableStore;try{const v=(0,I.basename)(c),D=(0,L.watch)(c);g.add((0,N.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.y(`Started watching: '${c}'`);const n=new Set;if(u)try{for(const i of await S.Promises.readdir(c))n.add(i)}catch(i){this.v(i)}const o=new Map;g.add((0,N.toDisposable)(()=>{for(const[,i]of o)i.dispose();o.clear()})),D.on("error",(i,t)=>{this.v(`Failed to watch ${c} for changes using fs.watch() (${i}, ${t})`),this.dispose()}),D.on("change",(i,t)=>{if(h.token.isCancellationRequested)return;this.y(`[raw] ["${i}"] ${t}`);let s="";if(t&&(s=t.toString(),w.isMacintosh&&(s=(0,R.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===v&&!await S.Promises.exists(c)){this.w("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.u((0,I.join)(c,s));if(h.token.isCancellationRequested)return;let f;r?n.has(s)?f=0:(f=1,n.add(s)):(n.delete(s),f=2),this.s({path:(0,I.join)(this.j.path,s),type:f})},d.a);o.set(s,(0,N.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(s)?a=0:(a=1,n.add(s)),this.s({path:(0,I.join)(this.j.path,s),type:a})}else if(i==="rename"||s!==v){const a=setTimeout(async()=>{const r=await S.Promises.exists(c);h.token.isCancellationRequested||(r?(this.s({path:this.j.path,type:0},!0),g.add(await this.r(c,!1))):(this.s({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);g.clear(),g.add((0,N.toDisposable)(()=>clearTimeout(a)))}else this.s({path:this.j.path,type:0},!0)})}catch(v){await S.Promises.exists(c)&&!h.token.isCancellationRequested&&this.v(`Failed to watch ${c} for changes using fs.watch() (${v.toString()})`)}return(0,N.toDisposable)(()=>{h.dispose(!0),g.dispose()})}s(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.y(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(h=>h(c.path))?this.m&&this.y(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(h=>h(c.path))?this.m&&this.y(` >> ignored (not included) ${c.path}`):this.f.work(c))}t(c){const u=(0,p.coalesceEvents)(c);if(u.length>0){if(this.m)for(const g of u)this.y(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(u)?this.c.pending>0&&this.y(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.w(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async u(c){if(w.isLinux)return S.Promises.exists(c);try{const u=(0,I.basename)(c);return(await S.Promises.readdir((0,I.dirname)(c))).some(g=>g===u)}catch(u){return this.y(u),!1}}setVerboseLogging(c){this.m=c}v(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}w(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}y(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.y(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function m(E,c,u,h,g=512){const v=await S.Promises.open(E,"r"),D=Buffer.allocUnsafe(g),n=new l.CancellationTokenSource(h);let o,i=!1;const t={path:E,excludes:[],recursive:!1},s=new d(t,a=>{(async()=>{for(const{type:r}of a)if(r===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await S.Promises.read(v,D,0,g,null);if(!f||n.token.isCancellationRequested)break;c(D.slice(0,f))}}catch(f){o=new Error(f),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,u(),new Promise((a,r)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await S.Promises.close(v)}catch(f){o=new Error(f)}o?r(o):a()})})}e.watchFileContents=m}),define(re[207],oe([0,1,3,92,2,4,206]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends l.Disposable{constructor(){super(...arguments),this.a=this.D(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.D(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(w){const P=this.i(w),S=P.filter(d=>{const m=this.c.get(d.path);return m?!(0,U.patternsEquals)(m.request.excludes,d.excludes)||!(0,U.patternsEquals)(m.request.includes,d.includes):!0}),p=Array.from(this.c.values()).filter(({request:d})=>!P.find(m=>m.path===d.path&&(0,U.patternsEquals)(m.excludes,d.excludes)&&(0,U.patternsEquals)(m.includes,d.includes))).map(({request:d})=>d.path);S.length&&this.j(`Request to start watching: ${S.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const d of p)this.h(d);for(const d of S)this.g(d)}g(w){const P=new N.NodeJSFileWatcherLibrary(w,p=>this.a.fire(p),p=>this.b.fire(p),this.f),S={request:w,instance:P};this.c.set(w.path,S)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const P=this.c.get(w);P&&(this.c.delete(w),P.instance.dispose())}i(w){const P=new Map;for(const S of w){const p=O.isLinux?S.path:S.path.toLowerCase();P.set(p,S)}return Array.from(P.values())}async setVerboseLogging(w){this.f=w;for(const[,P]of this.c)P.instance.setVerboseLogging(w)}j(w){this.f&&this.b.fire({type:"trace",message:this.k(w)})}k(w,P){return P?`[File Watcher (node.js)] ${w} (path: ${P.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=R}),define(re[208],oe([0,1,56,207]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends L.AbstractNonRecursiveWatcherClient{constructor(N,R,I){super(N,R,I),this.m()}l(){return new U.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(re[209],oe([0,1,22,39,65,56]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends O.AbstractUniversalWatcherClient{constructor(I,w,P){super(I,w,P),this.m()}l(I){const w=I.add(new l.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(w.onDidProcessExit(({code:P,signal:S})=>this.n(`terminated by itself with code ${P}, signal: ${S}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(re[70],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...l){this.a=new Map;for(const[O,N]of l)this.set(O,N)}set(l,O){const N=this.a.get(l);return this.a.set(l,O),N}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=L}),define(re[210],oe([0,1,6,10,2,68,201,5,70,84]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class S extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class p{constructor(c=new I.ServiceCollection,u=!1,h,g=P){this.f=c,this.g=u,this.h=h,this.i=g,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=g?h?._globalGraph??new N.Graph(v=>v):void 0}createChild(c){return new p(c,this.g,this,this.i)}invokeFunction(c,...u){const h=m.traceInvocation(this.i,c);let g=!1;try{return c({get:D=>{if(g)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(D,h);if(!n)throw new Error(`[invokeFunction] unknown service '${D}'`);return n}},...u)}finally{g=!0,h.stop()}}createInstance(c,...u){let h,g;return c instanceof O.SyncDescriptor?(h=m.traceCreation(this.i,c.ctor),g=this.j(c.ctor,c.staticArguments.concat(u),h)):(h=m.traceCreation(this.i,c),g=this.j(c,u,h)),h.stop(),g}j(c,u=[],h){const g=R._util.getServiceDependencies(c).sort((n,o)=>n.index-o.index),v=[];for(const n of g){const o=this.m(n.id,h);o||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${n.id}.`,!1),v.push(o)}const D=g.length>0?g[0].index:u.length;if(u.length!==D){console.trace(`[createInstance] First service dependency of ${c.name} at position ${D+1} conflicts with ${u.length} static arguments`);const n=D-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,D)}return Reflect.construct(c,u.concat(v))}k(c,u){if(this.f.get(c)instanceof O.SyncDescriptor)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const h=this.l(c);return h instanceof O.SyncDescriptor?this.q(c,h,u.branch(c,!0)):(u.branch(c,!1),h)}q(c,u,h){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,h)}finally{this.o.delete(c)}}r(c,u,h){const g=new N.Graph(n=>n.id.toString());let v=0;const D=[{id:c,desc:u,_trace:h}];for(;D.length;){const n=D.pop();if(g.lookupOrInsertNode(n),v++>1e3)throw new S(g);for(const o of R._util.getServiceDependencies(n.desc.ctor)){const i=this.l(o.id);if(i||this.u(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),i instanceof O.SyncDescriptor){const t={id:o.id,desc:i,_trace:n._trace.branch(o.id,!0)};g.insertEdge(n,t),D.push(t)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new S(g);break}for(const{data:o}of n){if(this.l(o.id)instanceof O.SyncDescriptor){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}g.removeNode(o)}}return this.l(c)}s(c,u,h=[],g,v){if(this.f.get(c)instanceof O.SyncDescriptor)return this.t(c,u,h,g,v);if(this.h)return this.h.s(c,u,h,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,h=[],g,v){if(g){const D=new p(void 0,this.g,this,this.i);D.c=String(c);const n=new Map,o=new L.IdleValue(()=>{const i=D.j(u,h,v);for(const[t,s]of n){const a=i[t];if(typeof a=="function")for(const r of s)a.apply(i,r)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let r=n.get(t);return r||(r=new w.LinkedList,n.set(t,r)),(b,y,k)=>{const T=r.push([b,y,k]);return(0,l.toDisposable)(T)}}if(t in i)return i[t];const s=o.value;let a=s[t];return typeof a!="function"||(a=a.bind(s),i[t]=a),a},set(i,t,s){return o.value[t]=s,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,h,v)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=p;var d;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(d||(d={}));class m{static traceInvocation(c,u){return c?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(c,u){return c?new m(1,u.name):m.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const h=new m(3,c.toString());return this.h.push([c,u,h]),h}stop(){const c=Date.now()-this.g;m.f+=c;let u=!1;function h(v,D){const n=[],o=new Array(v+1).join("	");for(const[i,t,s]of D.h)if(t&&s){u=!0,n.push(`${o}CREATES -> ${i}`);const a=h(v+1,s);a&&n.push(a)}else n.push(`${o}uses -> ${i}`);return n.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(c>2||u)&&m.all.add(g.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(re[71],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class U{constructor(O,N){this.a=O,this.b=N}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,N){this.a.registerChannel(O,N)}}e.MainProcessService=U}),define(re[72],oe([0,1,25,2,4,172,29,5]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let w=class extends U.Disposable{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new L.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const m=p.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(c=>c.startsWith("lp-"))).map(E=>{const c=E.properties.localizedLanguages?.[0],u=I(E);return{...this.f(u,c,E),extensionId:E.identifier.id,galleryExtension:E}});return m.push(this.f("en","English")),m}f(S,p,d){const m=p??S;let E;if(m!==S&&(E=`(${S})`),S.toLowerCase()===l.language.toLowerCase()&&(E??="",E+=(0,O.localize)(0,null)),d?.installCount){E??="";const c=d.installCount;let u;c>1e6?u=`${Math.floor(c/1e5)/10}M`:c>1e3?u=`${Math.floor(c/1e3)}K`:u=String(c),E+=` $(cloud-download) ${u}`}return{id:S,label:m,description:E}}};w=ye([K(0,N.IExtensionGalleryService)],w),e.LanguagePackBaseService=w}),define(re[211],oe([0,1,2,72]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends L.Disposable{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};l=ye([K(0,U.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(re[9],oe([0,1,38,3,53,2,37,4,23,12,11,69,5]),function(te,e,L,U,l,O,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function d(){return new Date().toISOString()}function m(b){return(0,w.isNumber)(b)}e.isLogLevel=m;var E;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function c(b,y,k){switch(y){case E.Trace:b.trace(k);break;case E.Debug:b.debug(k);break;case E.Info:b.info(k);break;case E.Warning:b.warn(k);break;case E.Error:b.error(k);break;case E.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=c;function u(b,y=!1){let k="";for(let T=0;T<b.length;T++){let F=b[T];if(F instanceof Error&&(F=(0,L.toErrorMessage)(F,y)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(T>0?" ":"")+F}return k}class h extends O.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new U.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==E.Off&&this.b<=y}}e.AbstractLogger=h;class g extends h{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...k){this.f(E.Trace)&&this.g(E.Trace,u([y,...k],!0))}debug(y,...k){this.f(E.Debug)&&this.g(E.Debug,u([y,...k]))}info(y,...k){this.f(E.Info)&&this.g(E.Info,u([y,...k]))}warn(y,...k){this.f(E.Warning)&&this.g(E.Warning,u([y,...k]))}error(y,...k){if(this.f(E.Error))if(y instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=y.stack,this.g(E.Error,u(T))}else this.g(E.Error,u([y,...k]))}flush(){}}e.AbstractMessageLogger=g;class v extends h{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y),this.g=!R.isWindows}trace(y,...k){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,y,...k):console.log(`[main ${d()}]`,y,...k))}debug(y,...k){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,y,...k):console.log(`[main ${d()}]`,y,...k))}info(y,...k){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,y,...k):console.log(`[main ${d()}]`,y,...k))}warn(y,...k){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,y,...k):console.warn(`[main ${d()}]`,y,...k))}error(y,...k){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,y,...k):console.error(`[main ${d()}]`,y,...k))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class D extends h{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y)}trace(y,...k){this.f(E.Trace)&&console.log("%cTRACE","color: #888",y,...k)}debug(y,...k){this.f(E.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",y,...k)}info(y,...k){this.f(E.Info)&&console.log("%c INFO","color: #33f",y,...k)}warn(y,...k){this.f(E.Warning)&&console.log("%c WARN","color: #993",y,...k)}error(y,...k){this.f(E.Error)&&console.log("%c  ERR","color: #f33",y,...k)}dispose(){}flush(){}}e.ConsoleLogger=D;class n extends h{constructor(y,k=e.DEFAULT_LOG_LEVEL){super(),this.g=y,this.setLevel(k)}trace(y,...k){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(y),...k])}debug(y,...k){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(y),...k])}info(y,...k){this.f(E.Info)&&this.g.log(E.Info,[this.h(y),...k])}warn(y,...k){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(y),...k])}error(y,...k){this.f(E.Error)&&this.g.log(E.Error,[this.h(y),...k])}h(y){return typeof y=="string"?y:(0,L.toErrorMessage)(y,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class o extends h{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const k of this.g)k.setLevel(y);super.setLevel(y)}trace(y,...k){for(const T of this.g)T.trace(y,...k)}debug(y,...k){for(const T of this.g)T.debug(y,...k)}info(y,...k){for(const T of this.g)T.info(y,...k)}warn(y,...k){for(const T of this.g)T.warn(y,...k)}error(y,...k){for(const T of this.g)T.error(y,...k)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.MultiplexLogger=o;class i extends O.Disposable{constructor(y,k,T){if(super(),this.h=y,this.j=k,this.b=new N.ResourceMap,this.c=this.D(new U.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new U.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new U.Emitter),this.onDidChangeVisibility=this.g.event,T)for(const F of T)this.b.set(F.resource,{logger:void 0,info:F})}k(y){return(0,w.isString)(y)?[...this.b.values()].find(k=>k.info.id===y):this.b.get(y)}getLogger(y){return this.k(y)?.logger}createLogger(y,k){const T=this.l(y),F=(0,w.isString)(y)?y:k?.id??(0,l.hash)(T.toString()).toString(16);let j=this.b.get(T)?.logger;const x=k?.logLevel==="always"?E.Trace:k?.logLevel;j||(j=this.m(T,x??this.getLogLevel(T)??this.h,{...k,id:F}));const V={logger:j,info:{resource:T,id:F,logLevel:x,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(V.info),this.b.set(T,V),j}l(y){return(0,w.isString)(y)?(0,I.joinPath)(this.j,`${y}.log`):y}setLogLevel(y,k){if(P.URI.isUri(y)){const T=y,F=k,j=this.b.get(T);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([T,F]))}else{this.h=y;for(const[T,F]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,k){const T=this.k(y);T&&k!==!T.info.hidden&&(T.info.hidden=!k,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,k]))}getLogLevel(y){let k;return y&&(k=this.b.get(y)?.info.logLevel),k??this.h}registerLogger(y){const k=this.b.get(y.resource);k?k.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const k=this.b.get(y);k&&(k.logger&&k.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=i;class t{constructor(){this.onDidChangeLogLevel=new U.Emitter().event}setLevel(y){}getLevel(){return E.Info}trace(y,...k){}debug(y,...k){}info(y,...k){}warn(y,...k){}error(y,...k){}critical(y,...k){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;function a(b){if(b.verbose)return E.Trace;if(typeof b.logLevel=="string"){const y=f(b.logLevel.toLowerCase());if(y!==void 0)return y}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function r(b){switch(b){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=r;function f(b){switch(b){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=f,e.CONTEXT_LOG_LEVEL=new S.RawContextKey("logLevel",r(E.Info))}),define(re[212],oe([0,1,6,10,2,23,28,15,9]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends l.Disposable{constructor(S,p){super(),this.a=S,this.b=p,this.D(new L.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const S=(0,O.basename)(this.a.logsHome),p=(0,O.dirname)(this.a.logsHome),E=(await N.Promises.readdir(p.fsPath)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==S),c=E.slice(0,Math.max(0,E.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(u=>N.Promises.rm((0,O.joinPath)(p,u).fsPath))))}catch(S){(0,U.onUnexpectedError)(S)}}};w=ye([K(0,R.IEnvironmentService),K(1,I.ILogService)],w),e.LogsDataCleaner=w}),define(re[213],oe([0,1,21,6,10,3,2,13,56,9]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends N.Disposable{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.D(new O.Emitter),this.onDidChangeFile=this.c.event,this.g=this.D(new O.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.D(new U.ThrottledDelayer(0)),this.r=[],this.s=this.D(new U.ThrottledDelayer(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(p,d):this.t(p,d)}l(p,d){const m={path:this.z(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive},E=(0,L.insert)(this.j,m);return this.m(),(0,N.toDisposable)(()=>{E(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,l.onUnexpectedError)(p))}n(){this.h||(this.h=this.D(this.p(d=>this.c.fire((0,I.toFileChanges)(d)),d=>this.y(d),this.a.getLevel()===w.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,I.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,I.isRecursiveWatchRequest)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}t(p,d){const m={path:this.z(p),excludes:d.excludes,includes:d.includes,recursive:!1},E=(0,L.insert)(this.r,m);return this.u(),(0,N.toDisposable)(()=>{E(),this.u()})}u(){this.s.trigger(()=>this.v()).catch(p=>(0,l.onUnexpectedError)(p))}v(){return this.q||(this.q=this.D(this.w(p=>this.c.fire((0,I.toFileChanges)(p)),p=>this.y(p),this.a.getLevel()===w.LogLevel.Trace)),this.D(this.a.onDidChangeLogLevel(()=>{this.q?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.q.watch(this.r)}y(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}z(p){return(0,R.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(re[214],oe([0,1,21,6,16,25,3,53,63,2,49,22,104,23,43,168,14,103,9,10]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends w.Disposable{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.D(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.D(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.D(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.D(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.D(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.D(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.D(new U.ResourceQueue)}registerProvider(n,o){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${n}`);const i=new w.DisposableStore;return this.h.set(n,o),this.c.fire({added:!0,scheme:n,provider:o}),i.add(o.onDidChangeFile(t=>this.R.fire(new c.FileChangesEvent(t,!this.O(o))))),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(t=>this.S.fire(new Error(t)))),i.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:n}))),(0,w.toDisposable)(()=>{this.c.fire({added:!1,scheme:n,provider:o}),this.h.delete(n),(0,w.dispose)(i)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const o=[];this.f.fire({scheme:n,join(i){o.push(i)}}),!this.h.has(n)&&await U.Promises.settled(o)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,o){const i=this.h.get(n.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return I.Iterable.map(this.h,([n,o])=>({scheme:n,capabilities:o.capabilities}))}async j(n){if(!(0,d.isAbsolutePath)(n))throw new c.FileOperationError((0,E.localize)(0,null,this.nb(n)),8);await this.activateProvider(n.scheme);const o=this.h.get(n.scheme);if(!o){const i=new g.ErrorNoTelemetry;throw i.message=(0,E.localize)(1,null,n.toString()),i}return o}async k(n){const o=await this.j(n);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)||(0,c.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const o=await this.j(n);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,o){try{return await this.n(n,o)}catch(i){throw(0,c.toFileSystemProviderErrorCode)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,E.localize)(2,null,this.nb(n)),1):(0,c.ensureFileSystemProviderError)(i)}}async n(n,o){const i=await this.j(n),t=this.O(i),s=o?.resolveTo,a=o?.resolveSingleChildDescendants,r=o?.resolveMetadata,f=await i.stat(n);let b;return this.p(i,n,f,void 0,!!r,(y,k)=>(b||(b=P.TernarySearchTree.forUris(()=>!t),b.set(n,!0),s&&b.fill(!0,s)),b.get(y.resource)||b.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?k===1:!1))}async p(n,o,i,t,s,a){const{providerExtUri:r}=this.N(n),f={resource:o,name:r.basename(o),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&c.FilePermission.Readonly)||Boolean(n.capabilities&2048),etag:(0,c.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(f.isDirectory&&a(f,t)){try{const b=await n.readdir(o),y=await U.Promises.settled(b.map(async([k,T])=>{try{const F=r.joinPath(o,k),j=s?await n.stat(F):{type:T};return await this.p(n,F,j,b.length,s,a)}catch(F){return this.b.trace(F),null}}));f.children=(0,L.coalesce)(y)}catch(b){this.b.trace(b),f.children=[]}return f}return f}async resolveAll(n){return U.Promises.settled(n.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const o=await this.j(n),i=await o.stat(n);return this.p(o,n,i,void 0,!0,()=>!1)}async exists(n){const o=await this.j(n);try{return!!await o.stat(n)}catch{return!1}}async canCreateFile(n,o){try{await this.q(n,o)}catch(i){return i}return!0}async q(n,o){if(!o?.overwrite&&await this.exists(n))throw new c.FileOperationError((0,E.localize)(3,null,this.nb(n)),3,o)}async createFile(n,o=l.VSBuffer.fromString(""),i){await this.q(n,i);const t=await this.writeFile(n,o);return this.m.fire(new c.FileOperationEvent(n,0,t)),t}async writeFile(n,o,i){const t=this.lb(await this.l(n),n),{providerExtUri:s}=this.N(t);try{await this.r(t,n,i)||await this.P(t,s.dirname(n));let r;if((0,c.hasReadWriteCapability)(t)&&!(o instanceof l.VSBuffer))if((0,m.isReadableStream)(o)){const f=await(0,m.peekStream)(o,3);f.ended?r=l.VSBuffer.concat(f.buffer):r=f}else r=(0,m.peekReadable)(o,f=>l.VSBuffer.concat(f),3);else r=o;!(0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasReadWriteCapability)(t)&&r instanceof l.VSBuffer?await this.cb(t,n,i,r):await this.Y(t,n,i,r instanceof l.VSBuffer?(0,l.bufferToReadable)(r):r),this.m.fire(new c.FileOperationEvent(n,4))}catch(a){throw new c.FileOperationError((0,E.localize)(4,null,this.nb(n),(0,c.ensureFileSystemProviderError)(a).toString()),(0,c.toFileOperationResult)(a),i)}return this.resolve(n,{resolveMetadata:!0})}async r(n,o,i){if(!!i?.unlock&&!(n.capabilities&8192))throw new Error((0,E.localize)(5,null,this.nb(o)));let s;try{s=await n.stat(o)}catch{return}if((s.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,E.localize)(6,null,this.nb(o)),0,i);if(this.mb(o,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,c.etag)({mtime:i.mtime,size:s.size}))throw new c.FileOperationError((0,E.localize)(7,null),3,i);return s}async readFile(n,o,i){const t=await this.k(n);return o?.atomic?this.s(t,n,o,i):this.t(t,n,o,i)}async s(n,o,i,t){return new Promise((s,a)=>{this.X.queueFor(o,this.N(n).providerExtUri).queue(async()=>{try{const r=await this.t(n,o,i,t);s(r)}catch(r){a(r)}})})}async t(n,o,i,t){const s=await this.u(n,o,{...i,preferUnbuffered:!0},t);return{...s,value:await(0,l.streamToBuffer)(s.value)}}async readFileStream(n,o,i){const t=await this.k(n);return this.u(t,n,o,i)}async u(n,o,i,t){const s=new O.CancellationTokenSource(t),a=this.F(o,i).then(f=>f,f=>{throw s.cancel(),f});let r;try{return typeof i?.etag=="string"&&i.etag!==c.ETAG_DISABLED&&await a,i?.atomic&&(0,c.hasFileAtomicReadCapability)(n)||!((0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasFileReadStreamCapability)(n))||(0,c.hasReadWriteCapability)(n)&&i?.preferUnbuffered?r=this.C(n,o,i):(0,c.hasFileReadStreamCapability)(n)?r=this.w(n,o,s.token,i):r=this.z(n,o,s.token,i),{...await a,value:r}}catch(f){throw r&&await(0,m.consumeStream)(r),this.v(f,o,i)}}v(n,o,i){const t=(0,E.localize)(8,null,this.nb(o),(0,c.ensureFileSystemProviderError)(n).toString());return n instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(t,n.stat,i):n instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(t,n.fileOperationResult,n.size,n.options):new c.FileOperationError(t,(0,c.toFileOperationResult)(n),i)}w(n,o,i,t=Object.create(null)){const s=n.readFileStream(o,t,i);return(0,m.transform)(s,{data:a=>a instanceof l.VSBuffer?a:l.VSBuffer.wrap(a),error:a=>this.v(a,o,t)},a=>l.VSBuffer.concat(a))}z(n,o,i,t=Object.create(null)){const s=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(n,o,s,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.v(a,o,t)},i),s}C(n,o,i){const t=(0,m.newWriteableStream)(s=>l.VSBuffer.concat(s));return(async()=>{try{let s;i?.atomic&&(0,c.hasFileAtomicReadCapability)(n)?s=await n.readFile(o,{atomic:!0}):s=await n.readFile(o),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.G(o,s.byteLength,i),t.end(l.VSBuffer.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async F(n,o){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new c.FileOperationError((0,E.localize)(9,null,this.nb(n)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.ETAG_DISABLED&&o.etag===i.etag)throw new c.NotModifiedSinceFileOperationError((0,E.localize)(10,null),i,o);return this.G(n,i.size,o),i}G(n,o,i){if(i?.limits){let t;if(typeof i.limits.memory=="number"&&o>i.limits.memory&&(t=9),typeof i.limits.size=="number"&&o>i.limits.size&&(t=7),typeof t=="number")throw new c.TooLargeFileOperationError((0,E.localize)(11,null,this.nb(n)),t,o,i)}}async canMove(n,o,i){return this.H(n,o,"move",i)}async canCopy(n,o,i){return this.H(n,o,"copy",i)}async H(n,o,i,t){if(n.toString()!==o.toString())try{const s=i==="move"?this.lb(await this.l(n),n):await this.k(n),a=this.lb(await this.l(o),o);await this.M(s,n,a,o,i,t)}catch(s){return s}return!0}async move(n,o,i){const t=this.lb(await this.l(n),n),s=this.lb(await this.l(o),o),a=await this.I(t,n,s,o,"move",!!i),r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(n,a==="move"?2:3,r)),r}async copy(n,o,i){const t=await this.k(n),s=this.lb(await this.l(o),o),a=await this.I(t,n,s,o,"copy",!!i),r=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(n,a==="copy"?3:2,r)),r}async I(n,o,i,t,s,a){if(o.toString()===t.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:f}=await this.M(n,o,i,t,s,a);if(r&&!f&&a&&await this.del(t,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(t)),s==="copy"){if(n===i&&(0,c.hasFileFolderCopyCapability)(n))await n.copy(o,t,{overwrite:a});else{const b=await this.resolve(o);b.isDirectory?await this.L(n,b,i,t):await this.J(n,o,i,t)}return s}else return n===i?(await n.rename(o,t,{overwrite:a}),s):(await this.I(n,o,i,t,"copy",a),await this.del(o,{recursive:!0}),"copy")}async J(n,o,i,t){if((0,c.hasOpenReadWriteCloseCapability)(n)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.eb(n,o,i,t);if((0,c.hasOpenReadWriteCloseCapability)(n)&&(0,c.hasReadWriteCapability)(i))return this.kb(n,o,i,t);if((0,c.hasReadWriteCapability)(n)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.ib(n,o,i,t);if((0,c.hasReadWriteCapability)(n)&&(0,c.hasReadWriteCapability)(i))return this.gb(n,o,i,t)}async L(n,o,i,t){await i.mkdir(t),Array.isArray(o.children)&&await U.Promises.settled(o.children.map(async s=>{const a=this.N(i).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.L(n,await this.resolve(s.resource),i,a):this.J(n,s.resource,i,a)}))}async M(n,o,i,t,s,a){let r=!1;if(n===i){const{providerExtUri:b,isPathCaseSensitive:y}=this.N(n);if(y||(r=b.isEqual(o,t)),r&&s==="copy")throw new Error((0,E.localize)(12,null,this.nb(o),this.nb(t)));if(!r&&b.isEqualOrParent(t,o))throw new Error((0,E.localize)(13,null,this.nb(o),this.nb(t)))}const f=await this.exists(t);if(f&&!r){if(!a)throw new c.FileOperationError((0,E.localize)(14,null,this.nb(o),this.nb(t)),4);if(n===i){const{providerExtUri:b}=this.N(n);if(b.isEqualOrParent(o,t))throw new Error((0,E.localize)(15,null,this.nb(o),this.nb(t)))}}return{exists:f,isSameResourceWithDifferentPathCase:r}}N(n){const o=this.O(n);return{providerExtUri:o?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:o}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const o=this.lb(await this.j(n),n);await this.P(o,n);const i=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(n,0,i)),i}async P(n,o){const i=[],{providerExtUri:t}=this.N(n);for(;!t.isEqual(o,t.dirname(o));)try{if(((await n.stat(o)).type&c.FileType.Directory)===0)throw new Error((0,E.localize)(16,null,this.nb(o)));break}catch(s){if((0,c.toFileSystemProviderErrorCode)(s)!==c.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(t.basename(o)),o=t.dirname(o)}for(let s=i.length-1;s>=0;s--){o=t.joinPath(o,i[s]);try{await n.mkdir(o)}catch(a){if((0,c.toFileSystemProviderErrorCode)(a)!==c.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(n,o){try{await this.Q(n,o)}catch(i){return i}return!0}async Q(n,o){const i=this.lb(await this.j(n),n);if(!!o?.useTrash&&!(i.capabilities&4096))throw new Error((0,E.localize)(17,null,this.nb(n)));let s;try{s=await i.stat(n)}catch{}if(s)this.mb(n,s);else throw new c.FileOperationError((0,E.localize)(18,null,this.nb(n)),1);if(!!!o?.recursive){const r=await this.resolve(n);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,E.localize)(19,null,this.nb(n)))}return i}async del(n,o){const i=await this.Q(n,o),t=!!o?.useTrash,s=!!o?.recursive;await i.delete(n,{recursive:s,useTrash:t}),this.m.fire(new c.FileOperationEvent(n,1))}async cloneFile(n,o){const i=await this.j(n),t=this.lb(await this.l(o),o);if(i===t&&this.N(i).providerExtUri.isEqual(n,o))return;if(i===t&&(0,c.hasFileCloneCapability)(i))return i.cloneFile(n,o);await this.P(t,this.N(t).providerExtUri.dirname(o));const s=this.X.queueFor(n,this.N(i).providerExtUri);return i===t&&(0,c.hasFileFolderCopyCapability)(i)?s.queue(()=>i.copy(n,o,{overwrite:!0})):s.queue(()=>this.J(i,n,t,o))}watch(n,o={recursive:!1,excludes:[]}){const i=new w.DisposableStore;let t=!1,s=()=>{t=!0};return i.add((0,w.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(n,o);t?(0,w.dispose)(a):s=()=>(0,w.dispose)(a)}catch(a){this.b.error(a)}})(),i}async W(n,o){const i=await this.j(n),t=(0,R.hash)([this.N(i).providerExtUri.getComparisonKey(n),o]);let s=this.U.get(t);return s||(s={count:0,disposable:i.watch(n,o)},this.U.set(t,s)),s.count+=1,(0,w.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,w.dispose)(s.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,w.dispose)(n.disposable);this.U.clear()}async Y(n,o,i,t){return this.X.queueFor(o,this.N(n).providerExtUri).queue(async()=>{const s=await n.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(t)||(0,m.isReadableBufferedStream)(t)?await this.Z(n,s,t):await this.ab(n,s,t)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await n.close(s)}})}async Z(n,o,i){let t=0,s;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=l.VSBuffer.concat(i.buffer);await this.bb(n,o,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((a,r)=>{(0,m.listenStream)(s,{onData:async f=>{s.pause();try{await this.bb(n,o,f,f.byteLength,t,0)}catch(b){return r(b)}t+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>r(f),onEnd:()=>a()})})}async ab(n,o,i){let t=0,s;for(;(s=i.read())!==null;)await this.bb(n,o,s,s.byteLength,t,0),t+=s.byteLength}async bb(n,o,i,t,s,a){let r=0;for(;r<t;)r+=await n.write(o,s+r,i.buffer,a+r,t-r)}async cb(n,o,i,t){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.db(n,o,i,t))}async db(n,o,i,t){let s;t instanceof l.VSBuffer?s=t:(0,m.isReadableStream)(t)?s=await(0,l.streamToBuffer)(t):(0,m.isReadableBufferedStream)(t)?s=await(0,l.bufferedStreamToBuffer)(t):s=(0,l.readableToBuffer)(t),await n.writeFile(o,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(n,o,i,t){return this.X.queueFor(t,this.N(i).providerExtUri).queue(()=>this.fb(n,o,i,t))}async fb(n,o,i,t){let s,a;try{s=await n.open(o,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const r=l.VSBuffer.alloc(this.a);let f=0,b=0,y=0;do y=await n.read(s,f,r.buffer,b,r.byteLength-b),await this.bb(i,a,r,y,f,b),f+=y,b+=y,b===r.byteLength&&(b=0);while(y>0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await U.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async gb(n,o,i,t){return this.X.queueFor(t,this.N(i).providerExtUri).queue(()=>this.hb(n,o,i,t))}async hb(n,o,i,t){return i.writeFile(t,await n.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async ib(n,o,i,t){return this.X.queueFor(t,this.N(i).providerExtUri).queue(()=>this.jb(n,o,i,t))}async jb(n,o,i,t){const s=await i.open(t,{create:!0,unlock:!1});try{const a=await n.readFile(o);await this.bb(i,s,l.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await i.close(s)}}async kb(n,o,i,t){const s=await(0,l.streamToBuffer)(this.z(n,o,O.CancellationToken.None));await this.cb(i,t,void 0,s)}lb(n,o){if(n.capabilities&2048)throw new c.FileOperationError((0,E.localize)(20,null,this.nb(o)),6);return n}mb(n,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,E.localize)(21,null,this.nb(n)),6)}nb(n){return n.scheme===S.Schemas.file?n.fsPath:n.toString(!0)}};v=ye([K(0,h.ILogService)],v),e.FileService=v}),define(re[215],oe([0,1,54,295,6,37,16,3,48,2,13,4,23,43,28,171,14,103,213,38,209,208]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(o)}`)}})();class n extends h.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t),this.onDidChangeCapabilities=R.Event.None,this.H=new O.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:t,symbolicLink:s}=await m.SymlinkSupport.stat(this.z(i));return{type:this.G(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.Y(t)}}async readdir(i){try{const t=await m.Promises.readdir(this.z(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async a=>{try{let r;a.isSymbolicLink()?r=(await this.stat((0,p.joinPath)(i,a.name))).type:r=this.G(a),s.push([a.name,r])}catch(r){this.a.trace(r)}})),s}catch(t){throw this.Y(t)}}G(i,t){let s;return t?.dangling?s=c.FileType.Unknown:i.isFile()?s=c.FileType.File:i.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,t&&(s|=c.FileType.SymbolicLink),s}async I(i){const t=this.z(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const a=new l.Barrier;return this.H.set(i,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,w.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.H.get(i)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),a.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.z(i)})`),s=await this.I(i));const a=this.z(i);return await m.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(i){n.C&&this.a.trace(i)}readFileStream(i,t,s){const a=(0,d.newWriteableStream)(r=>N.VSBuffer.concat(r.map(f=>N.VSBuffer.wrap(f))).buffer);return(0,u.readFileIntoStream)(this,i,a,r=>r.buffer,{...t,bufferSize:256*1024},s),a}async writeFile(i,t,s){let a;try{const r=this.z(i);if(!s.create||!s.overwrite){if(await m.Promises.exists(r)){if(!s.overwrite)throw(0,c.createFileSystemProviderError)((0,E.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.createFileSystemProviderError)((0,E.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(a,0,t,0,t.byteLength)}catch(r){throw await this.Z(i,r)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){n.O=i}async open(i,t){const s=this.z(i);let a;(0,c.isFileOpenForWriteOptions)(t)&&(a=await this.I(i));let r;try{if((0,c.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:b}=await m.SymlinkSupport.stat(s);b.mode&128||await m.Promises.chmod(s,b.mode|128)}catch(b){this.a.trace(b)}let f;if((0,c.isFileOpenForWriteOptions)(t)){if(S.isWindows)try{await m.Promises.truncate(s,0),f="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}f||(f="w")}else f="r";r=await m.Promises.open(s,f)}catch(f){throw a?.dispose(),(0,c.isFileOpenForWriteOptions)(t)?await this.Z(i,f):this.Y(f)}if(this.L.set(r,0),(0,c.isFileOpenForWriteOptions)(t)&&this.N.set(r,i),a){const f=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${s})`),this.M.set(r,a),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${s})`),f.dispose())}return r}async close(i){const t=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&n.O)try{await m.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(i)}catch(s){throw this.Y(s)}finally{t&&(this.M.get(i)===t&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,a,r){const f=this.P(i,t);let b=null;try{b=(await m.Promises.read(i,s,a,r,f)).bytesRead}catch(y){throw this.Y(y)}finally{this.Q(i,f,b)}return b}P(i,t){return t===this.L.get(i)?null:t}Q(i,t,s){const a=this.L.get(i);typeof a=="number"&&(typeof t=="number"||(typeof s=="number"?this.L.set(i,a+s):this.L.delete(i)))}async write(i,t,s,a,r){return(0,l.retry)(()=>this.R(i,t,s,a,r),100,3)}async R(i,t,s,a,r){const f=this.P(i,t);let b=null;try{b=(await m.Promises.write(i,s,a,r,f)).bytesWritten}catch(y){throw await this.Z(this.N.get(i),y)}finally{this.Q(i,f,b)}return b}async mkdir(i){try{await m.Promises.mkdir(this.z(i))}catch(t){throw this.Y(t)}}async delete(i,t){try{const s=this.z(i);t.recursive?await m.Promises.rm(s,m.RimRafMode.MOVE):await m.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(i,t,s){const a=this.z(i),r=this.z(t);if(a!==r)try{await this.S(i,t,"move",s.overwrite),await m.Promises.move(a,r)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,E.localize)(2,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(r)),f.toString()))),this.Y(f)}}async copy(i,t,s){const a=this.z(i),r=this.z(t);if(a!==r)try{await this.S(i,t,"copy",s.overwrite),await m.Promises.copy(a,r,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,E.localize)(3,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(r)),f.toString()))),this.Y(f)}}async S(i,t,s,a){const r=this.z(i),f=this.z(t);let b=!1;if(!!(this.capabilities&1024)||(b=(0,I.isEqual)(r,f,!0)),b&&s==="copy")throw(0,c.createFileSystemProviderError)((0,E.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!b&&await m.Promises.exists(f)){if(!a)throw(0,c.createFileSystemProviderError)((0,E.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}async cloneFile(i,t){return this.U(i,t,!1)}async U(i,t,s){const a=this.z(i),r=this.z(t),f=!!(this.capabilities&1024);if((0,I.isEqual)(a,r,!f))return;const b=new w.DisposableStore;try{const[y,k]=await Promise.all([this.I(i),this.I(t)]);b.add(y),b.add(k),s&&await m.Promises.mkdir((0,P.dirname)(r),{recursive:!0}),await m.Promises.copyFile(a,r)}catch(y){if(y.code==="ENOENT"&&!s)return this.U(i,t,!0);throw this.Y(y)}finally{b.dispose()}}p(i,t,s){return new v.UniversalWatcherClient(a=>i(a),a=>t(a),s)}w(i,t,s){return new D.NodeJSWatcherClient(a=>i(a),a=>t(a),s)}Y(i){if(i instanceof c.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=c.FileSystemProviderErrorCode.NoPermissions;break;default:t=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,t)}async Z(i,t){let s=this.Y(t);if(i&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await m.SymlinkSupport.stat(this.z(i));a.mode&128||(s=(0,c.createFileSystemProviderError)(t,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}n.C=!1,n.O=!0,e.DiskFileSystemProvider=n}),define(re[105],oe([0,1,3,2,5,9]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let N=class extends U.Disposable{constructor(I){super(),this.b=I,this.a=this.D(new L.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};N=ye([K(0,O.ILogService)],N),e.SharedProcessLifecycleService=N}),define(re[106],oe([0,1,11,3,9,2]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class N extends l.AbstractLoggerService{constructor(S,p,d,m,E){super(p,d,m),this.n=S,this.p=E,this.D(E.listen("onDidChangeLogLevel",S)(c=>{(0,l.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(L.URI.revive(c[0]),c[1])})),this.D(E.listen("onDidChangeVisibility",S)(([c,u])=>super.setVisibility(L.URI.revive(c),u))),this.D(E.listen("onDidChangeLoggers",S)(({added:c,removed:u})=>{for(const h of c)super.registerLogger({...h,resource:L.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(S,p)=>{this.p.call("consoleLog",[S,p])}})}registerLogger(S){super.registerLogger(S),this.p.call("registerLogger",[S,this.n])}deregisterLogger(S){super.deregisterLogger(S),this.p.call("deregisterLogger",[S,this.n])}setLogLevel(S,p){super.setLogLevel(S,p),this.p.call("setLogLevel",[S,p])}setVisibility(S,p){super.setVisibility(S,p),this.p.call("setVisibility",[S,p])}m(S,p,d){return new R(this.p,S,p,d,this.n)}static setLogLevel(S,p,d){return S.call("setLogLevel",[p,d])}}e.LoggerChannelClient=N;class R extends l.AbstractMessageLogger{constructor(S,p,d,m,E){super(m?.logLevel==="always"),this.m=S,this.n=p,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[p,m,E]).then(()=>{this.q(this.l),this.k=!0})}g(S,p){const d=[[S,p]];this.k?this.q(d):this.l.push(...d)}q(S){this.m.call("log",[this.n,S])}}class I{constructor(S,p){this.a=S,this.b=p}listen(S,p){const d=this.b(S);switch(p){case"onDidChangeLoggers":return U.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(E=>this.c(E,d)),removed:[...m.removed].map(E=>this.c(E,d))}));case"onDidChangeVisibility":return U.Event.map(this.a.onDidChangeVisibility,m=>[d.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return U.Event.map(this.a.onDidChangeLogLevel,m=>(0,l.isLogLevel)(m)?m:[d.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${p}`)}async call(S,p,d){const m=this.b(S);switch(p){case"setLogLevel":return(0,l.isLogLevel)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(L.URI.revive(m.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(E=>this.c(E,m)))}throw new Error(`Call not found: ${p}`)}c(S,p){return{...S,resource:p.transformOutgoingURI(S.resource)}}}e.LoggerChannel=I;class w extends O.Disposable{constructor(S,p){super(),p.call("setLogLevel",[S.getLogLevel()]),this.D(S.onDidChangeLogLevel(d=>p.call("setLogLevel",[d]))),p.call("getRegisteredLoggers").then(d=>{for(const m of d)S.registerLogger({...m,resource:L.URI.revive(m.resource)})}),this.D(p.listen("onDidChangeVisibility")(([d,m])=>S.setVisibility(L.URI.revive(d),m))),this.D(p.listen("onDidChangeLoggers")(({added:d,removed:m})=>{for(const E of d)S.registerLogger({...E,resource:L.URI.revive(E.resource)});for(const E of m)S.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=w}),define(re[216],oe([0,1,2,9]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends L.Disposable{constructor(N,R=[]){super(),this.a=new U.MultiplexLogger([N,...R]),this.D(N.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...R){this.a.trace(N,...R)}debug(N,...R){this.a.debug(N,...R)}info(N,...R){this.a.info(N,...R)}warn(N,...R){this.a.warn(N,...R)}error(N,...R){this.a.error(N,...R)}flush(){this.a.flush()}}e.LogService=l}),define(re[57],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(re[58],oe([0,1,3,63,2,5]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class N extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.D(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const P=Object.keys(this.f).length;return this.f={...w,...this.f},P!==Object.keys(this.f).length&&await this.i(w),U.Iterable.reduce(this.g.entries(),(S,[p,d])=>({...S,[p]:d}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return U.Iterable.reduce(Object.entries(this.f),(w,[P,S])=>({...w,[P]:{definition:S,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=N;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(re[217],oe([0,1,3,2,58]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(I){this.b=I,this.a=new U.DisposableStore}listen(I,w){switch(w){case"onDidChange":return L.Event.map(this.b.onDidChange,P=>P.reduce((S,p)=>({...S,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(I,w,P){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.PolicyChannel=O;class N extends l.AbstractPolicyService{constructor(I,w){super(),this.a=w;for(const P in I){const{definition:S,value:p}=I[P];this.f[P]=S,p!==void 0&&this.g.set(P,p)}this.a.listen("onDidChange")(P=>{for(const S in P){const p=P[S];p===null?this.g.delete(S):this.g.set(S,p)}this.h.fire(Object.keys(P))})}async i(I){const w=await this.a.call("updatePolicyDefinitions",I);for(const P in w)this.g.set(P,w[P])}}e.PolicyChannelClient=N}),define(re[107],oe([0,1,4,36]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const O=L.globals.vscode.context.configuration();if(O)l=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,U.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:O.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(re[26],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[218],oe([0,1,6,10,2,13,28,9,26]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends l.Disposable{constructor(S,p,d){super(),this.b=p,this.c=d,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.D(new L.RunOnceScheduler(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),d=(0,O.dirname)(S),m=(0,O.basename)(S),E=await N.Promises.readdir(d);await Promise.all(E.map(async c=>{if(c===m)return;const u=(0,O.join)(d,c),h=await N.Promises.stat(u);if(h.isDirectory()&&p-h.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),N.Promises.rm(u)}))}catch(p){(0,U.onUnexpectedError)(p)}}};w=ye([K(1,I.IProductService),K(2,R.ILogService)],w),e.CodeCacheCleaner=w}),define(re[219],oe([0,1,6,10,2,13,28,15,9,26]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends l.Disposable{constructor(p,d,m){super(),this.b=p,this.c=d,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.D(new L.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),d=JSON.parse(await N.Promises.readFile((0,O.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(d)){const g=d[h];p[`${g.hash}.${h}`]=!0}const m=(0,O.join)(this.b.userDataPath,"clp");if(!await N.Promises.exists(m))return;const c=await N.Promises.readdir(m);for(const h of c){if(p[h]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await N.Promises.rm((0,O.join)(m,h))}const u=Date.now();for(const h of Object.keys(p)){const g=(0,O.join)(m,h),v=await N.Promises.readdir(g);for(const D of v){if(D==="tcf.json")continue;const n=(0,O.join)(g,D),o=await N.Promises.stat(n);o.isDirectory()&&u-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.join)(h,D)}`),await N.Promises.rm(n))}}}catch(p){(0,U.onUnexpectedError)(p)}}};P=ye([K(0,R.INativeEnvironmentService),K(1,I.ILogService),K(2,w.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(re[220],oe([0,1,13,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var l;(function(O){function N(I){return Boolean(I.samples&&I.timeDeltas)}O.isValidProfile=N;function R(I,w="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,L.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.join)(w,(0,L.basename)(P.callFrame.url)));return I}O.rewriteAbsolutePaths=R})(l=e.Utils||(e.Utils={}))}),define(re[221],oe([0,1,31]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this.a=new Map}async startProfiling(O){const R=await(await new Promise((w,P)=>{te(["v8-inspect-profiler"],w,P)})).startProfiling({port:O.port,checkForPaused:!0}),I=(0,L.generateUuid)();return this.a.set(I,R),I}async stopProfiling(O){const N=this.a.get(O);if(!N)throw new Error(`UNKNOWN session '${O}'`);const R=await N.stop();return this.a.delete(O),R.profile}}e.InspectProfilingService=U}),define(re[40],oe([0,1,129,12]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(N,R){L.ok(U.isString(N)),L.ok(U.isObject(R)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,R)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new l}),define(re[108],oe([0,1,3,40]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class O{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,w){this.a[l(I)]=w,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const N=new O;U.Registry.add(e.Extensions.JSONContribution,N)}),define(re[45],oe([0,1,21,3,12,155,17,108,40]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=I.Registry.as(R.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new U.Emitter,this.onDidSchemaChange=this.i.event,this.j=new U.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const i=new Set;this.n(n,o,i),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const o=new Set;this.o(n,o),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:n,remove:o}){const i=new Set;this.o(o,i),this.n(n,!1,i),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(n){const o=new Set;this.k(n,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(n,o){const i=[];for(const{overrides:t,source:s}of n)for(const a in t)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const r=this.a.get(a),f=r?.valuesSources??new Map;if(s)for(const T of Object.keys(t[a]))f.set(T,s);const b={...r?.value||{},...t[a]};this.a.set(a,{source:s,value:b,valuesSources:f});const y=(0,N.getLanguageTagSettingPlainKey)(a),k={type:"object",default:b,description:O.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:l.isString(s)?void 0:s,defaultValueSource:s};i.push(...E(a)),this.d[a]=k,this.b.properties[a]=k}else{this.a.set(a,{value:t[a],source:s});const r=this.d[a];r&&(this.w(a,r),this.r(a,r))}this.m(i)}deregisterDefaultConfigurations(n){const o=new Set;this.l(n,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(n,o){for(const{overrides:i,source:t}of n)for(const s in i){const a=this.a.get(s),r=l.isString(t)?t:t?.id,f=l.isString(a?.source)?a?.source:a?.source?.id;if(r===f)if(o.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const b=this.d[s];b&&(this.w(s,b),this.r(s,b))}}this.u()}deltaConfiguration(n){let o=!1;const i=new Set;n.removedDefaults&&(this.l(n.removedDefaults,i),o=!0),n.addedDefaults&&(this.k(n.addedDefaults,i),o=!0),n.removedConfigurations&&this.o(n.removedConfigurations,i),n.addedConfigurations&&this.n(n.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const o of n)this.h.add(o);this.u()}n(n,o,i){n.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,i),this.c.push(t),this.q(t)})}o(n,o){const i=t=>{if(t.properties)for(const s in t.properties){o.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,t.properties[s])}t.allOf?.forEach(s=>i(s))};for(const t of n){i(t);const s=this.c.indexOf(t);s!==-1&&this.c.splice(s,1)}}p(n,o=!0,i,t,s=3,a){s=l.isUndefinedOrNull(n.scope)?s:n.scope;const r=n.properties;if(r)for(const b in r){const y=r[b];if(o&&g(b,y)){delete r[b];continue}if(y.source=i,y.defaultDefaultValue=r[b].default,this.w(b,y),e.OVERRIDE_PROPERTY_REGEX.test(b)?y.scope=void 0:(y.scope=l.isUndefinedOrNull(y.scope)?s:y.scope,y.restricted=l.isUndefinedOrNull(y.restricted)?!!t?.includes(b):y.restricted),r[b].hasOwnProperty("included")&&!r[b].included){this.f[b]=r[b],delete r[b];continue}else this.d[b]=r[b],r[b].policy?.name&&this.e.set(r[b].policy.name,b);!r[b].deprecationMessage&&r[b].markdownDeprecationMessage&&(r[b].deprecationMessage=r[b].markdownDeprecationMessage),a.add(b)}const f=n.allOf;if(f)for(const b of f)this.p(b,o,i,t,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const o=i=>{const t=i.properties;if(t)for(const a in t)this.r(a,t[a]);i.allOf?.forEach(o)};o(n)}r(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.g.properties[n]=o;break}}s(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const o=`[${n}]`,i={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}}v(){const n={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,o){const i=this.a.get(n);let t=i?.value,s=i?.source;l.isUndefined(t)&&(t=o.defaultDefaultValue,s=void 0),l.isUndefined(t)&&(t=u(o.type)),o.default=t,o.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(D){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let o=m.exec(D);for(;o?.length;){const i=o[1].trim();i&&n.push(i),o=m.exec(D)}}return(0,L.distinct)(n)}e.overrideIdentifiersFromKey=E;function c(D){return D.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=c;function u(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const h=new p;I.Registry.add(e.Extensions.Configuration,h);function g(D,n){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?O.localize(7,null,D):h.getConfigurationProperties()[D]!==void 0?O.localize(8,null,D):n.policy?.name&&h.getPolicyConfigurations().get(n.policy?.name)!==void 0?O.localize(9,null,D,n.policy?.name,h.getPolicyConfigurations().get(n.policy?.name)):null:O.localize(6,null)}e.validateProperty=g;function v(){const D=[],n=h.getConfigurationProperties();for(const o of Object.keys(n))D.push([o,n[o].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=v}),define(re[73],oe([0,1,21,3,35,2,37,32,12,11,17,45,40]),function(te,e,L,U,l,O,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class m{constructor(i={},t=[],s=[],a){this.b=i,this.c=t,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(t=>{if(t instanceof m)return t;const s=new E("");return s.parseRaw(t),s.configurationModel});this.f=i.reduce((t,s)=>s===t?s:t.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,t){const s=this.rawConfiguration.getValue(i),a=t?this.rawConfiguration.getOverrideValue(i,t):void 0,r=t?this.rawConfiguration.override(t).getValue(i):s;return{value:s,override:a,merged:r}}getOverrideValue(i,t){const s=this.i(t);return s?i?(0,P.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return L.distinct(i)}override(i){let t=this.a.get(i);return t||(t=this.g(i),this.a.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),a=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const f of i)if(r.push(...f.raw?.length?f.raw:[f]),!f.isEmpty()){this.h(t,f.contents);for(const b of f.overrides){const[y]=s.filter(k=>L.equals(k.identifiers,b.identifiers));y?(this.h(y.contents,b.contents),y.keys.push(...b.keys),y.keys=L.distinct(y.keys)):s.push(R.deepClone(b))}for(const b of f.keys)a.indexOf(b)===-1&&a.push(b)}return new m(t,a,s,r.every(f=>f instanceof m)?void 0:r)}g(i){const t=this.i(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let r=this.contents[a];const f=t[a];f&&(typeof r=="object"&&typeof f=="object"?(r=R.deepClone(r),this.h(r,f)):r=f),s[a]=r}return new m(s,this.keys,this.overrides)}h(i,t){for(const s of Object.keys(t)){if(s in i&&I.isObject(i[s])&&I.isObject(t[s])){this.h(i[s],t[s]);continue}i[s]=R.deepClone(t[s])}}i(i){let t=null,s=null;const a=r=>{r&&(s?this.h(s,r):s=R.deepClone(r))};for(const r of this.overrides)L.equals(r.identifiers,[i])?t=r.contents:r.identifiers.includes(i)&&a(r.contents);return a(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,t){this.j(i,t,!0)}setValue(i,t){this.j(i,t,!1)}removeValue(i){const t=this.keys.indexOf(i);t!==-1&&(this.keys.splice(t,1),(0,P.removeFromValueTree)(this.contents,i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>L.equals(s.identifiers,(0,S.overrideIdentifiersFromKey)(i))),1))}j(i,t,s){(0,P.addToValueTree)(this.contents,i,t,a=>console.error(a)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],a=>console.error(a))})}}e.ConfigurationModel=m;class E{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,t){if(!I.isUndefinedOrNull(i)){const s=this.g(i);this.parseRaw(s,t)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,t){this.a=i;const{contents:s,keys:a,overrides:r,restricted:f,hasExcludedProperties:b}=this.h(i,t);this.b=new m(s,a,r,b?[i]:void 0),this.c=f||[]}g(i){let t={},s=null,a=[];const r=[],f=[];function b(k){Array.isArray(a)?a.push(k):s!==null&&(a[s]=k)}const y={onObjectBegin:()=>{const k={};b(k),r.push(a),a=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const k=[];b(k),r.push(a),a=k,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:b,onError:(k,T,F)=>{f.push({error:k,offset:T,length:F})}};if(i)try{l.visit(i,y),t=a[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return t}h(i,t){const s=p.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),a=this.i(i,s,!0,t);i=a.raw;const r=(0,P.toValuesTree)(i,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),f=Object.keys(i),b=this.j(i,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:r,keys:f,overrides:b,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(i,t,s,a){let r=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:r};const f={},b=[];for(const y in i)if(S.OVERRIDE_PROPERTY_REGEX.test(y)&&s){const k=this.i(i[y],t,!1,a);f[y]=k.raw,r=r||k.hasExcludedProperties,b.push(...k.restricted)}else{const k=t[y],T=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&b.push(y),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&k?.restricted)?f[y]=i[y]:r=!0}return{raw:f,restricted:b,hasExcludedProperties:r}}j(i,t){const s=[];for(const a of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(a)){const r={};for(const f in i[a])r[f]=i[a][f];s.push({identifiers:(0,S.overrideIdentifiersFromKey)(a),keys:Object.keys(r),contents:(0,P.toValuesTree)(r,t)})}return s}}e.ConfigurationModelParser=E;class c extends O.Disposable{constructor(i,t,s,a){super(),this.f=i,this.g=t,this.h=a,this.c=this.D(new U.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(s.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(U.Event.any(U.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),U.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class u{constructor(i,t,s,a,r,f,b,y,k,T,F,j,x){this.a=i,this.b=t,this.c=s,this.overrideIdentifiers=a,this.d=r,this.f=f,this.g=b,this.h=y,this.i=k,this.j=T,this.k=F,this.l=j,this.m=x}get value(){return d(this.c)}n(i,t,s){const a=i.inspect(t,s);return{get value(){return d(a.value)},get override(){return d(a.override)},get merged(){return d(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(i,t,s,a,r=new m,f=new m,b=new N.ResourceMap,y=new m,k=new N.ResourceMap){this.c=i,this.d=t,this.f=s,this.g=a,this.h=r,this.i=f,this.j=b,this.l=y,this.m=k,this.a=null,this.b=new N.ResourceMap,this.n=null}getValue(i,t,s){return this.q(i,t,s).getValue(i)}updateValue(i,t,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new m,this.m.set(s.resource,a))):a=this.l,t===void 0?a.removeValue(i):a.setValue(i,t),s.resource||(this.a=null)}inspect(i,t,s){const a=this.q(i,t,s),r=this.u(t.resource,s),f=t.resource?this.m.get(t.resource)||this.l:this.l,b=new Set;for(const y of a.overrides)for(const k of y.identifiers)a.getOverrideValue(i,k)!==void 0&&b.add(k);return new u(i,t,a.getValue(i),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,r||void 0,f)}keys(i){const t=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,t){this.j.set(i,t),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:a,updated:r,removed:f}=D(this.c,i);t=[...a,...r,...f]}for(const a of t)for(const r of(0,S.overrideIdentifiersFromKey)(a)){const f=this.c.getKeysForOverrideIdentifier(r),b=i.getKeysForOverrideIdentifier(r),y=[...b.filter(k=>f.indexOf(k)===-1),...f.filter(k=>b.indexOf(k)===-1),...f.filter(k=>!R.equals(this.c.override(r).getValue(k),i.override(r).getValue(k)))];s.push([r,y])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:t,updated:s,removed:a}=D(this.d,i),r=[...t,...s,...a];return r.length&&this.updatePolicyConfiguration(i),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:t,updated:s,removed:a,overrides:r}=D(this.applicationConfiguration,i),f=[...t,...s,...a];return f.length&&this.updateApplicationConfiguration(i),{keys:f,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:a,overrides:r}=D(this.localUserConfiguration,i),f=[...t,...s,...a];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:r}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:a,overrides:r}=D(this.remoteUserConfiguration,i),f=[...t,...s,...a];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:r}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:a,overrides:r}=D(this.workspaceConfiguration,i),f=[...t,...s,...a];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:r}}compareAndUpdateFolderConfiguration(i,t){const s=this.p.get(i),{added:a,updated:r,removed:f,overrides:b}=D(s,t),y=[...a,...r,...f];return(y.length||!s)&&this.updateFolderConfiguration(i,t),{keys:y,overrides:b}}compareAndDeleteFolderConfiguration(i){const t=this.p.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:a,removed:r,overrides:f}=D(t,void 0);return{keys:[...s,...a,...r],overrides:f}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,t,s){let a=this.r(t,s);return t.overrideIdentifier&&(a=a.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(a=a.merge(this.d)),a}r({resource:i},t){let s=this.s();if(t&&i){const a=t.getFolder(i);a&&(s=this.t(a.uri)||s);const r=this.m.get(i);r&&(s=s.merge(r))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let t=this.b.get(i);if(!t){const s=this.s(),a=this.j.get(i);a?(t=s.merge(a),this.b.set(i,t)):t=s}return t}u(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,t)=>{const{contents:s,overrides:a,keys:r}=this.j.get(t);return i.push([t,{contents:s,overrides:a,keys:r}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(t=>i.add(t)),this.userConfiguration.keys.forEach(t=>i.add(t)),this.i.keys.forEach(t=>i.add(t)),this.j.forEach(t=>t.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const t=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(a=>t.add(a))),[...t.values()]}static parse(i){const t=this.x(i.defaults),s=this.x(i.policy),a=this.x(i.application),r=this.x(i.user),f=this.x(i.workspace),b=i.folders.reduce((y,k)=>(y.set(w.URI.revive(k[0]),this.x(k[1])),y),new N.ResourceMap);return new h(t,s,a,r,new m,f,b,new m,new N.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=h;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,t=new Map;for(const a of o)a.keys.forEach(r=>i.add(r)),a.overrides.forEach(([r,f])=>{const b=(0,N.getOrSet)(t,r,new Set);f.forEach(y=>b.add(y))});const s=[];return t.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=g;class v{constructor(i,t,s,a){this.change=i,this.f=t,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of i.keys)this.affectedKeys.add(r);for(const[,r]of i.overrides)for(const f of r)this.affectedKeys.add(f);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(i,t){const s=this.a+i,a=this.d.indexOf(s);if(a<0)return!1;const r=a+s.length;if(r>=this.d.length)return!1;const f=this.d.charCodeAt(r);if(f!==this.b&&f!==this.c)return!1;if(t){const b=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.f?.workspace):void 0,y=this.g.getValue(i,t,this.h);return!R.equals(b,y)}return!0}}e.ConfigurationChangeEvent=v;function D(o,i){const{added:t,removed:s,updated:a}=n(i?.rawConfiguration,o?.rawConfiguration),r=[],f=o?.getAllOverrideIdentifiers()||[],b=i?.getAllOverrideIdentifiers()||[];if(i){const y=b.filter(k=>!f.includes(k));for(const k of y)r.push([k,i.getKeysForOverrideIdentifier(k)])}if(o){const y=f.filter(k=>!b.includes(k));for(const k of y)r.push([k,o.getKeysForOverrideIdentifier(k)])}if(i&&o){for(const y of f)if(b.includes(y)){const k=n({contents:o.getOverrideValue(void 0,y)||{},keys:o.getKeysForOverrideIdentifier(y)},{contents:i.getOverrideValue(void 0,y)||{},keys:i.getKeysForOverrideIdentifier(y)});r.push([y,[...k.added,...k.removed,...k.updated]])}}return{added:t,removed:s,updated:a,overrides:r}}function n(o,i){const t=o?i?o.keys.filter(r=>i.keys.indexOf(r)===-1):[...o.keys]:[],s=i?o?i.keys.filter(r=>o.keys.indexOf(r)===-1):[...i.keys]:[],a=[];if(o&&i){for(const r of i.keys)if(o.keys.indexOf(r)!==-1){const f=(0,P.getConfigurationValue)(i.contents,r),b=(0,P.getConfigurationValue)(o.contents,r);R.equals(f,b)||a.push(r)}}return{added:t,removed:s,updated:a}}}),define(re[222],oe([0,1,21,3,2,32,12,73,45,9,58,40]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class p extends l.Disposable{constructor(){super(...arguments),this.a=this.D(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.D(S.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,S.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new R.ConfigurationModel;const c=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const h=this.f();for(const g of c){const v=h[g],D=u[g];v!==void 0?this.b.addValue(g,v):D?this.b.addValue(g,D.default):this.b.removeValue(g)}}}e.DefaultConfiguration=p;class d{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let m=class extends l.Disposable{get configurationModel(){return this.b}constructor(c,u,h){super(),this.c=c,this.f=u,this.g=h,this.a=this.D(new U.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.D(this.f.onDidChange(c=>this.i(c))),this.D(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},h=[],g=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const v of c){const D=g[v];if(!D){h.push(v);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}h.push(v),u[D.policy.name]={type:D.type}}}return(0,N.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),h}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=S.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),h=(0,L.coalesce)(c.map(g=>u.get(g)));this.j(h,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const h=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),g=[],v=this.b.isEmpty();for(const D of c){const n=h[D]?.policy?.name;if(n){const o=this.f.getPolicyValue(n);(v?o!==void 0:!(0,O.equals)(this.b.getValue(D),o))&&g.push([D,o])}else this.b.getValue(D)!==void 0&&g.push([D,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const D=this.b;this.b=new R.ConfigurationModel;for(const n of D.keys)this.b.setValue(n,D.getValue(n));for(const[n,o]of g)o===void 0?this.b.removeValue(n):this.b.setValue(n,o);u&&this.a.fire(this.b)}}};m=ye([K(1,P.IPolicyService),K(2,w.ILogService)],m),e.PolicyConfiguration=m}),define(re[223],oe([0,1,6,3,2,23,17,73,222,58]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends l.Disposable{constructor(p,d,m,E){super(),this.i=p,this.h=this.D(new U.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.D(new I.DefaultConfiguration),this.c=m instanceof w.NullPolicyService?new I.NullPolicyConfiguration:this.D(new I.PolicyConfiguration(this.b,m,E)),this.f=this.D(new R.UserSettings(this.i,void 0,O.extUriBiasedIgnorePathCase,d)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.D(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.D(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.D(this.c.onDidChangeConfiguration(c=>this.l(c))),this.D(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,d,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(p,d,new R.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(p,d){const m=typeof p=="string"?p:void 0,E=(0,N.isConfigurationOverrides)(p)?p:(0,N.isConfigurationOverrides)(d)?d:{};return this.a.getValue(m,E,void 0)}updateValue(p,d,m,E){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const d=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(m,d,2)}k(p,d){const m=this.a.toData(),E=this.a.compareAndUpdateDefaultConfiguration(p,d);this.m(E,m,7)}l(p){const d=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(p);this.m(m,d,7)}m(p,d,m){const E=new R.ConfigurationChangeEvent(p,{data:d},this.a);E.source=m,E.sourceConfig=this.n(m),this.h.fire(E)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(re[224],oe([0,1,10,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class O extends L.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof O&&I._code===l.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof O&&I._code===l.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof O&&I._code===l.NoResolverFound}static isHandled(I){return I instanceof O&&I.isHandled}constructor(I,w=l.Unknown,P){super(I),this._message=I,this._code=w,this._detail=P,this.isHandled=w===l.NotAvailable&&P===!0,Object.setPrototypeOf(this,O.prototype)}}e.RemoteAuthorityResolverError=O;function N(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.getRemoteAuthorityPrefix=N}),define(re[74],oe([0,1,22]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function U(w){return w.scheme===L.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=U;function l(w){if(!w)return;const P=w.indexOf("+");return P<0?w:w.substr(0,P)}e.getRemoteName=l;function O(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=O;function N(w){const{host:P,port:S}=I(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:S}}e.parseAuthorityWithPort=N;function R(w,P){let{host:S,port:p}=I(w);return typeof p>"u"&&(p=P),{host:S,port:p}}e.parseAuthorityWithOptionalPort=R;function I(w){const P=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const p=w.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:w,port:void 0}}}),define(re[46],oe([0,1,27,5,74]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(N=e.ExtensionType||(e.ExtensionType={}));var R;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(c){this.value=c,this.c=c.toLowerCase()}static equals(c,u){if(typeof c>"u"||c===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof c=="string"||typeof u=="string"){const h=typeof c=="string"?c:c.value,g=typeof u=="string"?u:u.value;return L.equalsIgnoreCase(h,g)}return c.c===u.c}static toKey(c){return typeof c=="string"?c.toLowerCase():c.c}}e.ExtensionIdentifier=I;class w{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const u of c)this.add(u)}add(c){this.c.add(I.toKey(c))}delete(c){return this.c.delete(I.toKey(c))}has(c){return this.c.has(I.toKey(c))}}e.ExtensionIdentifierSet=w;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(I.toKey(c))}get(c){return this.c.get(I.toKey(c))}has(c){return this.c.has(I.toKey(c))}set(c,u){this.c.set(I.toKey(c),u)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function S(E){return p(E)}e.isApplicationScopedExtension=S;function p(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function d(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function m(E,c){if(c){const u=`onResolveRemoteAuthority:${(0,l.getRemoteName)(c)}`;return!!E.activationEvents?.includes(u)}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[225],oe([0,1,2,13,28,46]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends L.Disposable{constructor(I,w){super(),this.b=I,this.a=(0,U.join)(this.b.userDataPath,O.MANIFEST_CACHE_FOLDER,O.USER_MANIFEST_CACHE_FILE),this.D(w.onDidInstallExtensions(P=>this.c(P))),this.D(w.onDidUninstallExtension(P=>this.f(P)))}c(I){I.some(w=>!!w.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(re[226],oe([0,1,6,16,25,10,3,2,104,89,31,96,224,74]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var E;(function(A){A[A.Management=1]="Management",A[A.ExtensionHost=2]="ExtensionHost",A[A.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function c(A){switch(A){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(A){const M=new l.CancellationTokenSource;return setTimeout(()=>M.cancel(),A),M.token}function h(A,M){if(A.isCancellationRequested||M.isCancellationRequested)return l.CancellationToken.Cancelled;const z=new l.CancellationTokenSource;return A.onCancellationRequested(()=>z.cancel()),M.onCancellationRequested(()=>z.cancel()),z.token}class g{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((z,_)=>{this.f=z,this.g=_}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function v(A,M){const z=new g(M);return z.registerDisposable(A.onControlMessage(_=>{const W=JSON.parse(_.toString()),Q=Z(W);Q?z.reject(Q):z.resolve(W)})),z.promise}function D(A,M,z,_,W,Q,ee,le,he){const pe=new g(he),de=w.StopWatch.create(!1);return A.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${ee}`),M.connect(z,_,W,Q,le,(be,Ce)=>{pe.didTimeout?(I.mark(`code/didCreateSocketError/${ee}`),A.info(`Creating a socket (${le}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),be&&A.error(be),Ce?.dispose()):be||!Ce?(I.mark(`code/didCreateSocketError/${ee}`),A.info(`Creating a socket (${le}) returned an error after ${de.elapsed()} ms.`),pe.reject(be)):(I.mark(`code/didCreateSocketOK/${ee}`),A.info(`Creating a socket (${le}) was successful after ${de.elapsed()} ms.`),pe.resolve(Ce))}),pe.promise}function n(A,M){const z=new g(M);return A.then(_=>{z.didTimeout||z.resolve(_)},_=>{z.didTimeout||z.reject(_)}),z.promise}async function o(A,M,z,_){const W=q(A,M);A.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await D(A.logService,A.socketFactory,A.host,A.port,(0,d.getRemoteServerRootPath)(A),`reconnectionToken=${A.reconnectionToken}&reconnection=${A.reconnectionProtocol?"true":"false"}`,c(M),`renderer-${c(M)}-${A.reconnectionToken}`,_)}catch(de){throw A.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),A.logService.error(de),de}A.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let ee,le;A.reconnectionProtocol?(A.reconnectionProtocol.beginAcceptReconnection(Q,null),ee=A.reconnectionProtocol,le=!1):(ee=new S.PersistentProtocol({socket:Q,measureRoundTripTime:!0}),le=!0),A.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const he=await n(A.signService.createNewMessage((0,P.generateUuid)()),_),pe={type:"auth",auth:A.connectionToken||"00000000000000000000",data:he.data};ee.sendControl(U.VSBuffer.fromString(JSON.stringify(pe)));try{const de=await v(ee,h(_,u(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(A.logService.trace(`${W} 4/6. received SignRequest control message.`),!await n(A.signService.validate(he,de.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await n(A.signService.sign(de.data),_),Re={type:"connectionType",commit:A.commit,signedData:Ce,desiredConnectionType:M};return z&&(Re.args=z),A.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(U.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ee,ownsProtocol:le}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(A.logService.error(`${W} the handshake timed out. Error:`),A.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(A.logService.error(`${W} received error control message when negotiating connection. Error:`),A.logService.error(de)),le&&$(ee),de}}async function i(A,M,z,_){const W=Date.now(),Q=q(A,M),{protocol:ee,ownsProtocol:le}=await o(A,M,z,_),he=new g(_);return he.registerDisposable(ee.onControlMessage(pe=>{const de=JSON.parse(pe.toString()),be=Z(de);be?(A.logService.error(`${Q} received error control message when negotiating connection. Error:`),A.logService.error(be),le&&$(ee),he.reject(be)):(A.reconnectionProtocol?.endAcceptReconnection(),A.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${C(W)}!`),he.resolve({protocol:ee,firstMessage:de}))})),he.promise}async function t(A,M){const{protocol:z}=await i(A,1,void 0,M);return{protocol:z}}async function s(A,M,z){const{protocol:_,firstMessage:W}=await i(A,2,M,z),Q=W&&W.debugPort;return{protocol:_,debugPort:Q}}async function a(A,M,z){const _=Date.now(),W=q(A,3),{protocol:Q}=await o(A,3,M,z);return A.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${C(_)}!`),Q}async function r(A,M,z){const{host:_,port:W,connectionToken:Q}=await A.addressProvider.getAddress();return{commit:A.commit,quality:A.quality,host:_,port:W,connectionToken:Q,reconnectionToken:M,reconnectionProtocol:z,socketFactory:A.socketFactory,signService:A.signService,logService:A.logService}}async function f(A,M,z){return y(A,async _=>{const{protocol:W}=await t(_,l.CancellationToken.None);return new Y(A,M,z,_.reconnectionToken,W)})}e.connectRemoteAgentManagement=f;async function b(A,M){return y(A,async z=>{const{protocol:_,debugPort:W}=await s(z,M,l.CancellationToken.None);return new H(A,M,z.reconnectionToken,_,W)})}e.connectRemoteAgentExtensionHost=b;async function y(A,M){for(let _=1;;_++)try{const W=(0,P.generateUuid)(),Q=await r(A,W,null);return await M(Q)}catch(W){if(_<5)A.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),A.logService.error(W);else throw A.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),A.logService.error(W),G.triggerPermanentFailure(0,0,p.RemoteAuthorityResolverError.isHandled(W)),W}}async function k(A,M,z){const _=await r(A,(0,P.generateUuid)(),null);return await a(_,{host:M,port:z},l.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function T(A){return(0,L.createCancelablePromise)(M=>new Promise((z,_)=>{const W=setTimeout(z,A*1e3);M.onCancellationRequested(()=>{clearTimeout(W),z()})}))}var F;(function(A){A[A.ConnectionLost=0]="ConnectionLost",A[A.ReconnectionWait=1]="ReconnectionWait",A[A.ReconnectionRunning=2]="ReconnectionRunning",A[A.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",A[A.ConnectionGain=4]="ConnectionGain",A[A.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class j{constructor(M,z){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=j;class x{constructor(M,z,_,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.durationSeconds=_,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=x;class V{constructor(M,z,_){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=V;class B{constructor(M,z,_){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.attempt=_,this.type=4}}e.ConnectionGainEvent=B;class X{constructor(M,z){this.reconnectionToken=M,this.connectionHealth=z,this.type=5}}e.ConnectionHealthChangedEvent=X;class J{constructor(M,z,_,W){this.reconnectionToken=M,this.millisSinceLastIncomingData=z,this.attempt=_,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=J;class G extends R.Disposable{static triggerPermanentFailure(M,z,_){this._permanentFailure=!0,this.f=M,this.g=z,this.h=_,this.i.forEach(W=>W.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(M=>M.r())}static debugPauseSocketWriting(){this.i.forEach(M=>M.v())}get k(){return this.c||G._permanentFailure}constructor(M,z,_,W,Q){super(),this.n=M,this.p=z,this.reconnectionToken=_,this.protocol=W,this.q=Q,this.j=this.D(new N.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new B(this.reconnectionToken,0,0)),this.D(W.onSocketClose(ee=>{const le=ae(this.n,this.reconnectionToken,!0);ee?ee.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.p.logService.error(ee.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.p.logService.error(ee.event)):this.p.logService.info(`${le} received socket close event.`),this.r()})),this.D(W.onSocketTimeout(ee=>{const le=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.r()})),this.D(W.onHighRoundTripTime(ee=>{const le=se(this.n,this.reconnectionToken);this.p.logService.info(`${le} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of ${5} recent samples)`)})),this.D(W.onDidChangeConnectionHealth(ee=>{this.j.fire(new X(this.reconnectionToken,ee))})),G.i.push(this),this.D((0,R.toDisposable)(()=>{const ee=G.i.indexOf(this);ee>=0&&G.i.splice(ee,1)})),this.k&&this.u(G.f,G.g,G.h)}dispose(){super.dispose(),this.m=!0}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k||this.m)return;const M=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const W=_<z.length?z[_]:z[z.length-1];try{if(W>0){const ee=T(W);this.j.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,ee)),this.p.logService.info(`${M} waiting for ${W} seconds before reconnecting...`);try{await ee}catch{}}if(this.k){this.p.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.p.logService.info(`${M} resolving connection...`);const Q=await r(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${M} connecting to ${Q.host}:${Q.port}...`),await this.w(Q,u(m)),this.p.logService.info(`${M} reconnected!`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.p.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(p.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Q)){this.p.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.p.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if((0,O.isCancellationError)(Q)){this.p.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if(Q instanceof p.RemoteAuthorityResolverError){this.p.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,p.RemoteAuthorityResolverError.isHandled(Q));break}this.p.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.k&&!this.m)}t(M,z,_){this.q?G.triggerPermanentFailure(M,z,_):this.u(M,z,_)}u(M,z,_){this.j.fire(new J(this.reconnectionToken,M,z,_)),$(this.protocol)}v(){this.protocol.pauseSocketWriting()}}G._permanentFailure=!1,G.f=0,G.g=0,G.h=!1,G.i=[],e.PersistentConnection=G;class Y extends G{constructor(M,z,_,W,Q){super(1,M,W,Q,!0),this.client=this.D(new S.Client(Q,{remoteAuthority:z,clientId:_},M.ipcLogger))}async w(M,z){await t(M,z)}}e.ManagementPersistentConnection=Y;class H extends G{constructor(M,z,_,W,Q){super(2,M,_,W,!1),this.y=z,this.debugPort=Q}async w(M,z){await s(M,this.y,z)}}e.ExtensionHostPersistentConnection=H;function $(A){try{A.acceptDisconnect();const M=A.getSocket();A.dispose(),M.dispose()}catch(M){(0,O.onUnexpectedError)(M)}}function Z(A){if(A&&A.type==="error"){const M=new Error(`Connection error: ${A.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function ie(A,M){for(;A.length<M;)A+=" ";return A}function se(A,M){return`[remote-connection][${ie(c(A),13)}][${M.substr(0,5)}\u2026]`}function ae(A,M,z){return`${se(A,M)}[${z?"reconnect":"initial"}]`}function q(A,M){return`${ae(M,A.reconnectionToken,!!A.reconnectionProtocol)}[${A.host}:${A.port}]`}function C(A){return`${Date.now()-A} ms`}}),define(re[227],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[228],oe([0,1,86,153]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,O,N,R,I,w){const P=p=>w(p,void 0),S=L.createConnection({host:l,port:O},()=>{S.removeListener("error",P);const p=Buffer.alloc(16);for(let c=0;c<16;c++)p[c]=Math.round(Math.random()*256);const d=p.toString("base64"),m=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${O}${N}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];S.write(m.join(`\r
`)+`\r
\r
`);const E=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",E),w(void 0,new U.NodeSocket(S,I)))};S.on("data",E)});S.setNoDelay(!0),S.once("error",P)}}}),define(re[109],oe([0,1,5,173]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var l;(function(O){O.disconnected={type:"disconnected"},O.uninitialized={type:"uninitialized"},O.connected=N=>({type:"connected",info:N}),O.connecting=N=>({type:"connecting",progress:N})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(re[59],oe([0,1,16,10,2,175,45,5,9,40]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class P{constructor(D){this.b=D}toJSON(){if(!this.a){const D=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?D[n]="*****":D[n]=this.b[n];this.a=D}return this.a}}class S extends l.Disposable{constructor(D,n){super(),this.b=0,this.a=n.createLogger(D?"remotenetwork":"network",{name:D?(0,O.localize)(0,null):(0,O.localize)(1,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async c(D,n,o){const i=`${D} #${++this.b}: ${n.url}`;this.a.trace(`${i} - begin`,n.type,new P(n.headers??{}));try{const t=await o();return this.a.trace(`${i} - end`,n.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${i} - error`,n.type,(0,U.getErrorMessage)(t)),t}}}e.AbstractRequestService=S;function p(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=p;function d(v){return v.res.statusCode===204}async function m(v){return d(v)?null:(await(0,L.streamToBuffer)(v.stream)).toString()}e.asText=m;async function E(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}e.asTextOrError=E;async function c(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);if(d(v))return null;const n=(await(0,L.streamToBuffer)(v.stream)).toString();try{return JSON.parse(n)}catch(o){throw o.message+=`:
`+n,o}}e.asJson=c;function u(v){g(v)}e.updateProxyConfigurationsScope=u;let h;function g(v){const D=w.Registry.as(N.Extensions.Configuration),n=h;h={id:"http",order:15,title:(0,O.localize)(2,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0}}},D.updateConfigurations({add:[h],remove:n?[n]:[]})}g(2)}),define(re[229],oe([0,1,25,22,14,59]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(I,w){this.a=I,this.b=w}async download(I,w,P=L.CancellationToken.None){if(I.scheme===U.Schemas.file||I.scheme===U.Schemas.vscodeRemote){await this.b.copy(I,w);return}const S={type:"GET",url:I.toString(!0)},p=await this.a.request(S,P);if(p.res.statusCode===200)await this.b.writeFile(w,p.stream);else{const d=await(0,O.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${d}`)}}};N=ye([K(0,O.IRequestService),K(1,l.IFileService)],N),e.DownloadService=N}),define(re[230],oe([0,1,16,25]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(R){this.a=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,w,P=U.CancellationToken.None){switch(I){case"request":return this.a.request(w[0],P).then(async({res:S,stream:p})=>{const d=await(0,L.streamToBuffer)(p);return[{statusCode:S.statusCode,headers:S.headers},d]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class O{constructor(R){this.a=R}async request(R,I){const[w,P]=await this.a.call("request",[R],I);return{res:w,stream:(0,L.bufferToStream)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=O}),define(re[110],oe([0,1,53,5]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(O){return(0,L.hash)({moduleId:O.process.moduleId,windowId:O.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,U.createDecorator)("sharedProcessWorkerService")}),define(re[231],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(U){U.Spawn="vscode:shared-process->shared-process-worker=spawn",U.Terminate="vscode:shared-process->shared-process-worker=terminate",U.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",U.Ready="vscode:shared-process-worker->shared-process=ready",U.Ack="vscode:shared-process-worker->shared-process=ack",U.Trace="vscode:shared-process-worker->shared-process=trace",U.Info="vscode:shared-process-worker->shared-process=info",U.Warn="vscode:shared-process-worker->shared-process=warn",U.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[232],oe([0,1,151,6,25,3,2,22,31,9,110,231]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(E){this.d=E,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(E){const c=`window: ${E.reply.windowId}, moduleId: ${E.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${c})`);const u=(0,P.hash)(E);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.f(E));const h=new l.CancellationTokenSource;let g,v,D;this.b.set(u,t=>{h.dispose(!0),g?.terminate(E,l.CancellationToken.None),v?.close(),D?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:t}))}),g=await this.e(E);const n=new Promise(t=>{this.c.set(u,t)});if(h.token.isCancellationRequested)return n;const{port1:o,port2:i}=new MessageChannel;return v=o,D=i,await g.spawn(E,D,h.token),h.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${c})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",E,[v])),n}e(E){let c=this.a.get(E.process.moduleId);if(!c){this.d.trace(`SharedProcess: creating new web worker (${E.process.moduleId})`);const u=new d(E.process.type,this.d);c=u.init(),u.onDidProcessSelfTerminate(({configuration:h,reason:g})=>{this.f(h,g)}),this.a.set(E.process.moduleId,c)}return c}async disposeWorker(E){return this.f(E)}f(E,c){const u=this.b.get((0,P.hash)(E));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${E.reply.windowId}, moduleId: ${E.process.moduleId})`),u(c))}};p=ye([K(0,w.ILogService)],p),e.SharedProcessWorkerService=p;class d extends N.Disposable{constructor(E,c){super(),this.f=E,this.g=c,this.a=this.D(new O.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const E=new U.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return c.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},c.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},c.onmessage=u=>{const{id:h,message:g,configuration:v,nonce:D}=u.data;switch(h){case S.SharedProcessWorkerMessages.Ready:E.complete(c);break;case S.SharedProcessWorkerMessages.Ack:if(D){const n=this.c.get(D);n&&(this.c.delete(D),n())}break;case S.SharedProcessWorkerMessages.SelfTerminated:v&&g&&this.a.fire({configuration:v,reason:JSON.parse(g)});break;case S.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,g);break;case S.SharedProcessWorkerMessages.Info:g&&this.g.info(g);break;case S.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,g);break;case S.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,g);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),E.p}async i(E,c,u){const h=await this.b;if(!c.isCancellationRequested)return new Promise(g=>{const v=(0,I.generateUuid)();this.c.set(v,g);const D={...E,nonce:v};u?h.postMessage(D,[u]):h.postMessage(D),c.onCancellationRequested(()=>{this.c.delete(v)&&g()})})}spawn(E,c,u){const h={id:S.SharedProcessWorkerMessages.Spawn,configuration:E,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(h,u,c)}terminate(E,c){const u={id:S.SharedProcessWorkerMessages.Terminate,configuration:E};return this.i(u,c)}}}),define(re[233],oe([0,1,62,22,97]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class O extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:U.Schemas.vscodeUserData})}}ye([L.memoize],O.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=O}),define(re[234],oe([0,1,50,13,176,25,38,10,4,31,148,194,6,131]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function E(u,h,g,v){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(v)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(v)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=p.Promises.withAsyncBody(async(D,n)=>{const o=new O.CancellationTokenSource;let i=1e4;const t=u.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(i=(0,d.clamp)(t,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),n(new Error((0,l.localize)(0,null)))},i);try{D(await c(h,o.token))}catch(a){!(0,R.isCancellationError)(a)&&!o.token.isCancellationRequested?n(new Error((0,l.localize)(1,null,(0,N.toErrorMessage)(a)))):D({})}finally{clearTimeout(s),o.dispose()}})),m)}e.getResolvedShellEnv=E;async function c(u,h){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",v);const D=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(D+"({.*})"+D),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const i=await(0,P.getSystemShell)(I.OS,o);return u.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(h.isCancellationRequested)return s(new R.CancellationError);const a=(0,U.basename)(i);let r,f;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(r=`& '${process.execPath}' ${b} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,f=["-Login","-Command"]):(r=`'${process.execPath}' ${b} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,a==="tcsh"||a==="csh"?f=["-ic"]:f=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),r);const y=(0,L.spawn)(i,[...f,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(y.kill(),s(new R.CancellationError))),y.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(F)),s(F)});const k=[];y.stdout.on("data",F=>k.push(F));const T=[];y.stderr.on("data",F=>T.push(F)),y.on("close",(F,j)=>{const x=Buffer.concat(k).toString("utf8");u.trace("getUnixShellEnvironment#raw",x);const V=Buffer.concat(T).toString("utf8");if(V.trim()&&u.trace("getUnixShellEnvironment#stderr",V),F||j)return s(new Error((0,l.localize)(2,null,F,j)));const B=n.exec(x),X=B?B[1]:"{}";try{const J=JSON.parse(X);g?J.ELECTRON_RUN_AS_NODE=g:delete J.ELECTRON_RUN_AS_NODE,v?J.ELECTRON_NO_ATTACH_CONSOLE=v:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",J),t(J)}catch(J){u.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(J)),s(J)}})})}}),define(re[111],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[235],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.b=new Map}c(){return new Promise((l,O)=>te(["vsda"],l,O))}async createNewMessage(l){try{const O=await this.c(),N=new O.validator;if(N){const R=String(L.a++);return this.b.set(R,N),{id:R,data:N.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,O){if(!l.id)return!0;const N=this.b.get(l.id);if(!N)return!1;this.b.delete(l.id);try{return N.validate(O)==="ok"}catch{return!1}}async sign(l){try{const O=await this.c(),N=new O.signer;if(N)return N.sign(l)}catch{}return l}}L.a=1,e.SignService=L}),define(re[75],oe([0,1,3,2]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends U.Disposable{constructor(S,p,d){super(),this.a=S,this.b=p,this.c=d}async getItems(){const S={profile:this.b,workspace:this.c},p=await this.a.call("getItems",S);return new Map(p)}updateItems(S){const p={profile:this.b,workspace:this.c};return S.insert&&(p.insert=Array.from(S.insert.entries())),S.delete&&(p.delete=Array.from(S.delete.values())),this.a.call("updateItems",p)}}class O extends l{constructor(S,p){super(S,p,void 0),this.f=this.D(new L.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.D(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class N extends O{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=N;class R extends O{constructor(S,p){super(S,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends l{constructor(S,p){super(S,void 0,p),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class w{constructor(S){this.a=S}isUsed(S){const p={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",p)}}e.StorageClient=w}),define(re[112],oe([0,1,4,36,11,31]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(w){if(L.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function R(w,P,S,p,d,m,E,c,u,h){const g=Object.create(null);g["common.machineId"]=E,g.sessionID=(0,O.generateUuid)()+Date.now(),g.commitHash=d,g.version=m,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,L.PlatformToString)(L.platform),g["common.nodePlatform"]=U.platform,g["common.nodeArch"]=p,g["common.product"]=h||"desktop",c&&(g["common.msftInternal"]=c);let v=0;const D=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),L.isLinuxSnap&&(g["common.snap"]="true");const n=N(S);n&&(g["common.platformDetail"]=n);try{const o=await w.readFile(l.URI.file(u));g["common.source"]=o.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function I(w){const P=U.env.USERDNSDOMAIN;if(!P)return!1;const S=P.toLowerCase();return w.some(p=>S===p)}e.verifyMicrosoftInternalDomain=I}),define(re[19],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(U=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[236],oe([0,1,34,6,35,22,13,4,11,145,28,147,98,14,26,19]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function u(n,o){const i=`${n}::${o.join(":")}`,t=c.get(i);if(t)return t;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,r=new Map,f=2e4;function b(k,T,F,j){const x=T.substring(k.length+1);return U.Promises.withAsyncBody(async V=>{let B;try{B=await P.Promises.readdir(T,{withFileTypes:!0})}catch{V();return}if(j.count>=f){j.count+=B.length,j.maxReached=!0,V();return}let X=B.length;if(X===0){V();return}let J=B;j.count+B.length>f&&(j.maxReached=!0,X=f-j.count,J=B.slice(0,X)),j.count+=B.length;for(const G of J)if(G.isDirectory()){if(F.includes(G.name)||await b(k,(0,N.join)(T,G.name),F,j),--X===0){V();return}}else{const Y=G.name.lastIndexOf(".");if(Y>=0){const H=G.name.substring(Y+1);H&&a.set(H,(a.get(H)??0)+1)}for(const H of s)H.relativePathPattern?.test(x)!==!1&&H.filePattern.test(G.name)&&r.set(H.tag,(r.get(H.tag)??0)+1);if(--X===0){V();return}}})}const y=U.Promises.withAsyncBody(async k=>{const T={count:0,maxReached:!1};await b(n,n,o,T);const F=await v(n);k({configFiles:h(r),fileTypes:h(a),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:F})});return c.set(i,y),y}e.collectWorkspaceStats=u;function h(n){return Array.from(n.entries(),([o,i])=>({name:o,count:i})).sort((o,i)=>i.count-o.count)}function g(){const n={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=g;async function v(n){try{const o=new Map,i=(0,N.join)(n,".vscode","launch.json"),t=await P.Promises.readFile(i),s=[],a=(0,l.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,l.getNodeType)(a)==="object"&&a.configurations)for(const r of a.configurations){const f=r.type;f&&(o.has(f)?o.set(f,o.get(f)+1):o.set(f,1))}return h(o)}catch{return[]}}e.collectLaunchConfigs=v;let D=class{constructor(o,i){this.c=o,this.d=i}f(o){const i=[];return i.push(`OS Version:       ${o.os}`),i.push(`CPUs:             ${o.cpus}`),i.push(`Memory (System):  ${o.memory}`),i.push(`VM:               ${o.vmHint}`),i.join(`
`)}g(o){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||i.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${o.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(o,i){return Promise.all([(0,S.listProcesses)(o.mainPID),this.k(o)]).then(async t=>{let[s,a]=t,r=this.m(o,s);return i.forEach(f=>{if((0,p.isRemoteDiagnosticError)(f))r+=`
${f.errorMessage}`,a+=`
${f.errorMessage}`;else if(r+=`

Remote: ${f.hostName}`,f.processes&&(r+=`
${this.m(o,f.processes)}`),f.workspaceMetadata){a+=`
|  Remote: ${f.hostName}`;for(const b of Object.keys(f.workspaceMetadata)){const y=f.workspaceMetadata[b];let k=`${y.fileCount} files`;y.maxFilesReached&&(k=`more than ${k}`),a+=`|    Folder (${b}): ${k}`,a+=this.h(y)}}}),{processInfo:r,workspaceInfo:a}})}async getSystemInfo(o,i){const{memory:t,vmHint:s,os:a,cpus:r}=g(),f={os:a,memory:t,cpus:r,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:i};return R.isWindows||(f.load=`${L.loadavg().map(b=>Math.round(b)).join(", ")}`),R.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(o,i){const t=[];return(0,S.listProcesses)(o.mainPID).then(async s=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,s)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),i.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))t.push(`
${a.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${a.hostName}`),t.push(this.f(a.machineInfo)),a.processes&&t.push(this.m(o,a.processes)),a.workspaceMetadata)for(const r of Object.keys(a.workspaceMetadata)){const f=a.workspaceMetadata[r];let b=`${f.fileCount} files`;f.maxFilesReached&&(b=`more than ${b}`),t.push(`Folder (${r}): ${b}`),t.push(this.h(f))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const i=[];let s=0;const a=(y,k)=>{const T=` ${y}(${k})`;s+T.length>60?(i.push(r),r="|                 ",s=r.length):s+=T.length,r+=T};let r="|      File types:";const f=10,b=o.fileTypes.length>f?f:o.fileTypes.length;for(let y=0;y<b;y++){const k=o.fileTypes[y];a(k.name,k.count)}if(i.push(r),o.configFiles.length>=0&&(r="|      Conf files:",s=0,o.configFiles.forEach(y=>{a(y.name,y.count)}),i.push(r)),o.launchConfigFiles.length>0){let y="|      Launch Configs:";o.launchConfigFiles.forEach(k=>{y+=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`}),i.push(y)}return i.join(`
`)}j(o){const i=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const i=[],t=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const r=I.URI.revive(a);if(r.scheme===O.Schemas.file){const f=r.fsPath;t.push(u(f,["node_modules",".git"]).then(b=>{let y=`${b.fileCount} files`;b.maxFilesReached&&(y=`more than ${y}`),i.push(`|    Folder (${(0,N.basename)(f)}): ${y}`),i.push(this.h(b))}).catch(b=>{i.push(`|      Error: Unable to collect workspace stats for folder ${f} (${b.toString()})`)}))}else i.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,i){const t=new Map;o.windows.forEach(a=>t.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:r})=>t.set(a,r));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.n(o.mainPID,t,s,i,0),s.join(`
`)}n(o,i,t,s,a){const r=a===0;let f;r?f=s.pid===o?`${this.d.applicationName} main`:"remote agent":i.has(s.pid)?f=i.get(s.pid):f=`${"  ".repeat(a)} ${s.name}`;const b=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(b/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(y=>this.n(o,i,t,y,a+1))}async getWorkspaceFileExtensions(o){const i=new Set;for(const{uri:t}of o.folders){const s=I.URI.revive(t);if(s.scheme!==O.Schemas.file)continue;const a=s.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(f=>i.add(f.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(o){for(const{uri:i}of o.folders){const t=I.URI.revive(i);if(t.scheme!==O.Schemas.file)continue;const s=t.fsPath;try{const a=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})}),a.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})}),a.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};D=ye([K(0,E.ITelemetryService),K(1,m.IProductService)],D),e.DiagnosticsService=D}),define(re[237],oe([0,1,109,3,19,15,2,9,13,50,26,4,6,105,17,174,34]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const u=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let h=class extends N.Disposable{constructor(v,D,n,o,i,t){super(),this.q=v,this.r=D,this.s=n,this.t=t,this.b=new U.Emitter,this.onDidTokenFailed=this.b.event,this.f=new U.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new U.Emitter,this.onDidChangeAccount=this.g.event,this.k=L.TunnelStates.disconnected,this.h=this.D(o.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this.n=new p.Delayer(100),this.D(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,R.LogLevelToString)(s)))),this.D(i.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.D(t.onDidChangeConfiguration(s=>{u.some(a=>s.affectsConfiguration(a))&&this.n.trigger(()=>this.v())}))}async getAccount(){return this.i}async updateAccount(v){if(v&&this.i?v.token!==this.i.token||v.providerId!==this.i.providerId:v!==this.i){this.i=v,this.g.fire(v),v?this.h.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.h.info("Account reset"),this.q.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.n.trigger(()=>this.v())}catch(D){this.h.error(D)}}return this.k}u(){if(!this.p){let v;S.isMacintosh?v=this.s.appRoot:v=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.p=(0,I.join)(v,"bin",`${this.r.tunnelApplicationName}${S.isWindows?".exe":""}`)}return this.p}async v(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.w(L.TunnelStates.disconnected);return}const{token:v,providerId:D,accountLabel:n}=this.i;this.w(L.TunnelStates.connecting((0,E.localize)(0,null,n,D)));const o=(r,f)=>{r=r.replaceAll(v,"*".repeat(4)),f?this.h.error(r):this.h.info(r),!this.s.isBuilt&&r.startsWith("   Compiling")&&this.w(L.TunnelStates.connecting((0,E.localize)(1,null)))},i=this.y("login",["user","login","--provider",D,"--access-token",v,"--log",(0,R.LogLevelToString)(this.h.getLevel())],o);this.j=i;try{if(await i,this.j!==i)return}catch(r){this.h.error(r),this.j=void 0,this.b.fire(!0),this.w(L.TunnelStates.disconnected);return}const t=this.C();t?this.w(L.TunnelStates.connecting((0,E.localize)(2,null,t))):this.w(L.TunnelStates.connecting((0,E.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.h.getLevel())];t?s.push("--name",t):s.push("--random-name"),this.z()&&s.push("--no-sleep");const a=this.y("tunnel",s,(r,f)=>{f?this.h.error(r):this.h.info(r);const b=r.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const y={link:b[1],domain:b[2],hostName:b[4]};this.w(L.TunnelStates.connected(y))}else r.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.w(L.TunnelStates.disconnected))});this.j=a,a.finally(()=>{a===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.w(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}w(v){this.k=v,this.f.fire(v)}y(v,D,n=()=>{}){return(0,p.createCancelablePromise)(o=>new Promise((i,t)=>{o.isCancellationRequested&&i();let s;if(o.onCancellationRequested(()=>{s&&(this.h.info(`${v} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${v} Spawning: cargo run -- tunnel ${D.join(" ")}`,!1),s=(0,w.spawn)("cargo",["run","--","tunnel",...D],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const a=this.u();n(`${v} Spawning: ${a} tunnel ${D.join(" ")}`,!1),s=(0,w.spawn)(a,["tunnel",...D],{cwd:(0,c.homedir)()})}s.stdout.on("data",a=>{if(s){const r=a.toString();n(r,!1)}}),s.stderr.on("data",a=>{if(s){const r=a.toString();n(r,!0)}}),s.on("exit",a=>{s&&(n(`${v} exit(${s.pid}): + ${a} `,!1),s=void 0,a===0?i():t())}),s.on("error",a=>{s&&(n(`${v} error(${s.pid}): + ${a} `,!0),s=void 0,t())})}))}async getHostName(){return this.C()}z(){return!!this.t.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}C(){let v=this.t.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,c.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};h=ye([K(0,l.ITelemetryService),K(1,P.IProductService),K(2,O.INativeEnvironmentService),K(3,R.ILoggerService),K(4,d.ISharedProcessLifecycleService),K(5,m.IConfigurationService)],h),e.RemoteTunnelService=h}),define(re[113],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(O){this.b=O}listen(O,N){throw new Error(`Event not found: ${N}`)}call(O,N,{eventName:R,data:I}){return this.b.forEach(w=>w.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class U{constructor(O){this.b=O}log(O,N){return this.b.call("log",{eventName:O,data:N}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(re[47],oe([0,1,32,12,3,17,74,112,19]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(s){this.value=s}}e.TelemetryTrustedValue=w;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,a){return Promise.resolve(void 0)}publicLog2(s,a){return this.publicLog(s,a)}publicLogError(s,a){return Promise.resolve(void 0)}publicLogError2(s,a){return this.publicLogError(s,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class S{async publicLog(s,a,r){}async publicLogError(s,a,r){}}e.NullEndpointTelemetryService=S,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(t,s){return l.Event.debounce(s.onDidChangeConfiguration,(r,f)=>{const b=r?new Set([...r.affectedKeys,...f.affectedKeys]):f.affectedKeys;return{...f,affectedKeys:b}},1e3,!0)(r=>{r.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(r.source),configurationKeys:Array.from(r.affectedKeys)})})}e.configurationTelemetry=p;function d(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=d;function m(t,s){return!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=m;function E(t){const s=t.getValue(I.TELEMETRY_SETTING_ID),a=t.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function c(t){const s={},a={},r={};g(t,r);for(let f in r){f=f.length>150?f.substr(f.length-149):f;const b=r[f];typeof b=="number"?a[f]=b:typeof b=="boolean"?a[f]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${b.length}`),s[f]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(s[f]=b)}return{properties:s,measurements:a}}e.validateTelemetryData=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const s=(0,N.getRemoteName)(t);return u.has(s)?s:"other"}e.cleanRemoteAuthority=h;function g(t,s,a=0,r){if(!!t)for(const f of Object.getOwnPropertyNames(t)){const b=t[f],y=r?r+f:f;Array.isArray(b)?s[y]=(0,L.safeStringify)(b):b instanceof Date?s[y]=b.toISOString():(0,U.isObject)(b)?a<2?g(b,s,a+1,y+"."):s[y]=(0,L.safeStringify)(b):s[y]=b}}function v(t,s){const a=t.msftInternalDomains||[],r=s.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(a)||r}e.isInternalTelemetry=v;function D(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=D;function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const r=[];for(const k of s)for(;;){const T=k.exec(t);if(!T)break;r.push([T.index,k.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(a="";;){const k=b.exec(t);if(!k)break;const T=r.some(([F,j])=>k.index<j&&F<b.lastIndex);!f.test(k[0])&&!T&&(a+=t.substring(y,k.index)+"<REDACTED: user-file-path>",y=b.lastIndex)}return y<t.length&&(a+=t.substr(y)),a}function o(t){if(!t)return t;const s=t.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of a)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return t}function i(t,s){return(0,L.cloneAndChange)(t,a=>{if(a instanceof w)return a.value;if(typeof a=="string"){let r=a.replaceAll("%20"," ");r=n(r,s);for(const f of s)r=r.replace(f,"");return r=o(r),r}})}e.cleanData=i}),define(re[33],oe([0,1,27,29,46,4,11,10,36,47]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,L.compareIgnoreCase)(i.id,t.id)===0}e.areSameExtensions=P;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(t){const s=t.manifest?t.manifest.version:t.version,a=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new p(t.identifier,s,a)}static parse(t){const s=S.exec(t);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof p?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=p;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const t=d.exec(i);return t&&t[1]?[c(t[1]),t[2]]:[c(i),void 0]}e.getIdAndVersion=m;function E(i,t){return`${i}.${t}`}e.getExtensionId=E;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function u(i,t){return c(E(i??l.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=u;function h(i,t){const s=[],a=r=>{for(const f of s)if(f.some(b=>P(t(b),t(r))))return f;return null};for(const r of i){const f=a(r);f?f.push(r):s.push([r])}return s}e.groupByExtension=h;function g(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function v(i){return{id:new w.TelemetryTrustedValue(i.identifier.id),name:new w.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function D(i,t){const s=[],a=t.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const r=a.shift();if(r&&s.every(f=>!P(f.identifier,{id:r}))){const f=i.filter(b=>P(b.identifier,{id:r}));f.length===1&&(s.push(f[0]),a.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=D;async function n(i,t){if(!O.isLinux)return!1;let s;try{s=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){t.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(r))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(i,t){const s=await n(i,t),a=(0,U.getTargetPlatform)(s?"alpine":O.platform,I.arch);return t.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(re[238],oe([0,1,21,2,23,11,197,14,26,6,3,13,4,36,163,33]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let c=class extends U.Disposable{constructor(D,n){super(),this.b=D,this.c=n,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,o])=>this.a.set(o.configPath,o))}getConfigBasedTips(D){return this.f(D)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(D){const n=[];for(const[o,i]of this.a)if(!(i.configScheme&&i.configScheme!==D.scheme))try{const t=await this.b.readFile((0,l.joinPath)(D,o)),s=new Map;Object.entries(i.recommendations).forEach(([r,f])=>{if((0,L.isNonEmptyArray)(f.remotes))for(const b of f.remotes)s.set(b,{extensionId:r,extensionName:f.name,configName:i.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled});else n.push({extensionId:r,extensionName:f.name,configName:i.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled})});const a=(0,N.getDomainsOfRemotes)(t.value.toString(),[...s.keys()]);for(const r of a){const f=s.get(r);f&&n.push(f)}}catch{}return n}};c=ye([K(0,R.IFileService),K(1,I.IProductService)],c),e.ExtensionTipsService=c;const u="extensionTips/promptedExecutableTips",h="extensionTips/lastPromptedMediumImpExeTime";class g extends c{constructor(D,n,o,i,t,s,a,r){super(a,r),this.m=D,this.n=n,this.p=o,this.q=i,this.r=t,this.s=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,r.exeBasedExtensionTips&&Object.entries(r.exeBasedExtensionTips).forEach(([f,b])=>{const y=[],k=[],T=[];Object.entries(b.recommendations).forEach(([F,j])=>{j.important?b.important?y.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):k.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):T.push({extensionId:F,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),y.length&&this.g.set(f,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:y}),k.length&&this.h.set(f,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:k}),T.length&&this.j.set(f,{exeFriendlyName:b.friendlyName,windowsPath:b.windowsPath,recommendations:T})}),(0,w.timeout)(3e3).then(async()=>{await this.t(),this.v(),this.w()})}async getImportantExecutableBasedTips(){const D=await this.J(this.g),n=await this.J(this.h);return[...D,...n]}getOtherExecutableBasedTips(){return this.J(this.j)}async t(){const D=await this.J(this.g),n=await this.J(this.h),o=await this.q.getInstalled();this.k=this.u(D,o),this.l=this.u(n,o)}u(D,n){const o=new Map;D.forEach(r=>o.set(r.extensionId.toLowerCase(),r));const{installed:i,uninstalled:t}=this.I([...o.keys()],n);for(const r of i){const f=o.get(r);f&&this.p.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:r,exeName:f.exeName})}for(const r of t){const f=o.get(r);f&&this.p.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:r,exeName:f.exeName})}const s=this.G(),a=new Map;for(const r of t){const f=o.get(r);if(f&&(!s[f.exeName]||!s[f.exeName].includes(f.extensionId))){let b=a.get(f.exeName);b||(b=[],a.set(f.exeName,b)),b.push(f)}}return a}v(){if(this.k.size===0)return;const[D,n]=[...this.k.entries()][0];this.z(n).then(o=>{switch(o){case"reacted":this.H(n[0].exeName,n);break;case"ignored":this.k.delete(D);break;case"incompatibleWindow":{const i=P.Event.once(P.Event.latch(P.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.D(i(()=>this.v()));break}case"toomany":{const i=this.D((0,w.disposableTimeout)(()=>{i.dispose(),this.v()},36e5));break}}})}w(){if(this.l.size===0)return;const D=this.C(),n=Date.now()-D,o=7*24*60*60*1e3;if(n<o){const s=this.D((0,w.disposableTimeout)(()=>{s.dispose(),this.w()},o-n));return}const[i,t]=[...this.l.entries()][0];this.z(t).then(s=>{switch(s){case"reacted":{this.F(Date.now()),this.l.delete(i),this.H(t[0].exeName,t);const a=this.D((0,w.disposableTimeout)(()=>{a.dispose(),this.w()},o));break}case"ignored":this.l.delete(i),this.w();break;case"incompatibleWindow":{const a=P.Event.once(P.Event.latch(P.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.D(a(()=>this.w()));break}case"toomany":{const a=this.D((0,w.disposableTimeout)(()=>{a.dispose(),this.w()},36e5));break}}})}async z(D){const n=await this.q.getInstalled(1),o=D.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>n.every(a=>!(0,E.areSameExtensions)(a.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase()),i=(0,m.localize)(0,null,D[0].exeFriendlyName);return this.s.promptImportantExtensionsInstallNotification(o,i,`@exe:"${D[0].exeName}"`,3)}C(){let D=this.r.getNumber(h,-1);return D||(D=Date.now(),this.F(D)),D}F(D){this.r.store(h,D,-1,1)}G(){return JSON.parse(this.r.get(u,-1,"{}"))}H(D,n){const o=this.G();o[D]=n.map(({extensionId:i})=>i.toLowerCase()),this.r.store(u,JSON.stringify(o),-1,0)}I(D,n){const o=[],i=[],t=n.reduce((s,a)=>(s.add(a.identifier.id.toLowerCase()),s),new Set);return D.forEach(s=>{t.has(s.toLowerCase())?o.push(s):i.push(s)}),{installed:o,uninstalled:i}}async J(D){const n=[],o=new Map;for(const i of D.keys()){const t=D.get(i);if(!t||!(0,L.isNonEmptyArray)(t.recommendations))continue;const s=[];p.isWindows?t.windowsPath&&s.push(t.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(s.push((0,S.join)("/usr/local/bin",i)),s.push((0,S.join)("/usr/bin",i)),s.push((0,S.join)(this.m.fsPath,i)));for(const a of s){let r=o.get(a);if(r===void 0&&(r=await this.b.exists(O.URI.file(a)),o.set(a,r)),r)for(const{extensionId:f,extensionName:b,isExtensionPack:y,whenNotInstalled:k}of t.recommendations)n.push({extensionId:f,extensionName:b,isExtensionPack:y,exeName:i,exeFriendlyName:t.exeFriendlyName,windowsPath:t.windowsPath,whenNotInstalled:k})}}return n}}e.AbstractNativeExtensionTipsService=g}),define(re[239],oe([0,1,25,33]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(O,N,R,I,w){try{const P=await O.getExtensionsControlManifest();if(!P.deprecated)return;const S=await O.getInstalled(1);for(const[p,d]of Object.entries(P.deprecated)){if(!d?.extension)continue;const{id:m,autoMigrate:E,preRelease:c}=d.extension;if(!E)continue;const u=S.find(g=>(0,U.areSameExtensions)(g.identifier,{id:p}));if(!u)continue;const h=(await N.getExtensions([{id:m,preRelease:c}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!h){w.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${m}' extension is not found`);continue}try{w.info(`Migrating '${u.identifier.id}' extension to '${m}' extension...`);const g=!I.getDisabledExtensions().some(D=>(0,U.areSameExtensions)(D,u.identifier));await O.uninstall(u),w.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let v=S.find(D=>(0,U.areSameExtensions)(D.identifier,{id:m}));(!v||!v.isPreReleaseVersion&&g)&&(v=await O.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${v.identifier.id}'`),g||(await I.disableExtension(v.identifier),w.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),E.storage&&(R.addToMigrationList((0,U.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,U.getExtensionId)(v.manifest.publisher,v.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${u.identifier.id}' extension to '${m}' extension.`)}catch(g){w.error(g)}}}catch(P){w.error(P)}}e.migrateUnsupportedExtensions=l}),define(re[240],oe([0,1,3,2,37,33,46]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends U.Disposable{constructor(w,P,S,p,d,m,E){super(),this.f=w,this.g=P,this.h=S,this.i=p,this.j=d,this.k=m,this.l=E,this.a=this.D(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.D(new U.DisposableMap),this.m().then(null,c=>E.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.z()}n(){this.D(this.h.onDidChangeProfiles(w=>this.p(w.added,w.removed))),this.D(this.i.onAddExtensions(w=>this.q(w))),this.D(this.i.onDidAddExtensions(w=>this.r(w))),this.D(this.i.onRemoveExtensions(w=>this.s(w))),this.D(this.i.onDidRemoveExtensions(w=>this.t(w))),this.D(this.k.onDidFilesChange(w=>this.u(w)))}async p(w,P){try{await Promise.all(P.map(S=>(this.c.deleteAndDispose(S.id),this.y(S.extensionsResource)))),w.length&&await Promise.all(w.map(S=>(this.c.set(S.id,(0,U.combinedDisposable)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.w(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async q(w){for(const P of w.extensions)this.C(this.G(P.identifier,P.version),w.profileLocation)}async r(w){for(const P of w.extensions){const S=this.G(P.identifier,P.version);w.error?this.F(S,w.profileLocation):this.C(S,w.profileLocation)}}async s(w){for(const P of w.extensions)this.F(this.G(P.identifier,P.version),w.profileLocation)}async t(w){const P=[],S=[];for(const p of w.extensions){const d=this.G(p.identifier,p.version);w.error?this.C(d,w.profileLocation):(this.F(d,w.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",p.identifier.id,p.version),S.push(this.f.scanInstalledExtensionAtLocation(p.location).then(m=>{m?P.push(m):this.l.info("Extension not found at the location",p.location.toString())},m=>this.l.error(m)))))}try{await Promise.all(S),P.length&&await this.z(P)}catch(p){this.l.error(p)}}u(w){for(const P of this.h.profiles)w.contains(P.extensionsResource,0,1)&&this.v(P.extensionsResource)}async v(w){const P=[],S=[],p=await this.i.scanProfileExtensions(w),d=new Set,m=new Set;for(const[E,c]of this.b)c.has(w)&&m.add(E);for(const E of p){const c=this.G(E.identifier,E.version);d.add(c),m.has(c)||(P.push(E.identifier),this.C(c,w))}for(const E of m)if(!d.has(E)){const c=this.H(E);c&&(S.push(c.identifier),this.F(E,w))}(P.length||S.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:w}:void 0,removed:S.length?{extensions:S,profileLocation:w}:void 0})}async w(w){const P=await this.i.scanProfileExtensions(w);for(const S of P)this.C(this.G(S.identifier,S.version),w)}async y(w){for(const P of[...this.b.keys()])this.F(P,w);await this.z()}async z(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.G(S.identifier,S.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}C(w,P){let S=this.b.get(w);S||this.b.set(w,S=new l.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),S.add(P)}F(w,P){const S=this.b.get(w);S&&S.delete(P),S?.size||this.b.delete(w)}G(w,P){return`${N.ExtensionIdentifier.toKey(w.id)}@${P}`}H(w){const[P,S]=(0,O.getIdAndVersion)(w);return S?{identifier:{id:P},version:S}:void 0}}e.ExtensionsWatcher=R}),define(re[241],oe([0,1,44,47]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(O,N,R,I,w,P,S){const p={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${N.nameShort})`};if((0,U.supportsTelemetry)(N,R)&&(0,U.getTelemetryLevel)(I)===3){const d=await(0,L.getServiceMachineId)(R,w,P),{machineId:m}=await S.getTelemetryInfo();p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=m||d}return p}e.resolveMarketplaceHeaders=l}),define(re[242],oe([0,1,102,21,6,2,22,13,28,15,29,33,9,72,11]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends d.LanguagePackBaseService{constructor(g,v,D,n){super(D),this.h=g,this.i=n,this.g=this.D(new c(v,n)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(g,v){const n=(await this.g.getLanguagePacks())[v];if(!n){this.i.warn(`No language pack found for ${v}`);return}const o=n.translations[g];return o?m.URI.file(o):void 0}async getInstalledLanguages(){const g=await this.g.getLanguagePacks(),v=Object.keys(g).map(D=>{const n=g[D];return{...this.f(D,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return v.push(this.f("en","English")),v.sort((D,n)=>D.label.localeCompare(n.label)),v}async j(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",g.identifier.id),await this.update())}async k(g){const v=await this.g.getLanguagePacks();Object.keys(v).some(D=>v[D]&&v[D].extensions.some(n=>(0,S.areSameExtensions)(n.extensionIdentifier,g.identifier)))&&(this.i.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,v]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),D=await this.g.update(v);return!(0,U.equals)(Object.keys(g),Object.keys(D))}};E=ye([K(0,P.IExtensionManagementService),K(1,w.INativeEnvironmentService),K(2,P.IExtensionGalleryService),K(3,p.ILogService)],E),e.NativeLanguagePackService=E;let c=class extends O.Disposable{constructor(g,v){super(),this.i=v,this.c={},this.f=(0,R.join)(g.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(g){return this.m(v=>{Object.keys(v).forEach(D=>delete v[D]),this.j(v,...g)}).then(()=>this.c)}j(g,...v){for(const D of v)D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&this.k(g,D);Object.keys(g).forEach(D=>this.l(g[D]))}k(g,v){const D=v.identifier,n=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of n)if(v.location.scheme===N.Schemas.file&&u(o)){let i=g[o.languageId];i||(i={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},g[o.languageId]=i);const t=i.extensions.filter(s=>(0,S.areSameExtensions)(s.extensionIdentifier,D))[0];t?t.version=v.manifest.version:i.extensions.push({extensionIdentifier:D,version:v.manifest.version});for(const s of o.translations)i.translations[s.id]=(0,R.join)(v.location.fsPath,s.path)}}l(g){if(g){const v=(0,L.createHash)("md5");for(const D of g.extensions)v.update(D.extensionIdentifier.uuid||D.extensionIdentifier.id).update(D.version);g.hash=v.digest("hex")}}m(g=()=>null){return this.g.queue(()=>{let v=null;return I.Promises.readFile(this.f,"utf8").then(void 0,D=>D.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(D)).then(D=>{try{return JSON.parse(D)}catch{return{}}}).then(D=>(v=g(D),D)).then(D=>{for(const o of Object.keys(D))D[o]||delete D[o];this.c=D,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),I.Promises.writeFile(this.f,n)}).then(()=>v,D=>this.i.error(D))})}};c=ye([K(0,w.INativeEnvironmentService),K(1,p.ILogService)],c);function u(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const g of h.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(re[243],oe([0,1,10,32,47]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function R(w,P,S){const p=await new Promise((u,h)=>{te(["@microsoft/1ds-core-js"],u,h)}),d=await new Promise((u,h)=>{te(["@microsoft/1ds-post-js"],u,h)}),m=new p.AppInsightsCore,E=new d.PostChannel,c={instrumentationKey:w,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(S){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:S};c.extensionConfig[E.identifier]=u}return m.initialize(c,[]),m.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class I{constructor(P,S,p,d,m){this.e=P,this.f=S,this.g=p,this.h=m,this.c=O,this.d=N,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(S=>{P(S)},S=>{(0,L.onUnexpectedError)(S),console.error(S)})}}log(P,S){if(!this.a)return;S=(0,U.mixin)(S,this.g),S=(0,l.validateTelemetryData)(S);const p=this.f+"/"+P;try{this.i(d=>{d.pluginVersionString=S?.properties.version??"Unknown",d.track({name:p,baseData:{name:p,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[114],oe([0,1,2,177,15,9,26,47]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends L.Disposable{constructor(P,S,p,d,m=""){super(),this.b=m;const E=S.getLogger(R.telemetryLogId);if(E)this.a=this.D(E);else{const u=(0,R.isLoggingOnly)(d,p)?" (Not Sent)":"",h=()=>(0,R.supportsTelemetry)(d,p)&&P.getLevel()===O.LogLevel.Trace;this.a=this.D(S.createLogger(R.telemetryLogId,{name:(0,U.localize)(0,null,u),hidden:!h()})),this.D(P.onDidChangeLogLevel(()=>S.setVisibility(R.telemetryLogId,h()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,R.validateTelemetryData)(S))}};I=ye([K(0,O.ILogService),K(1,O.ILoggerService),K(2,l.IEnvironmentService),K(3,N.IProductService)],I),e.TelemetryLogAppender=I}),define(re[115],oe([0,1,2,32,4,27,178,17,45,107,26,40,19,47]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(u,h,g){this.k=h,this.l=g,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,O.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(p.TELEMETRY_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(p.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,h){this.d[u]=h}m(){let u=(0,d.getTelemetryLevel)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,h=u.sessionID,g=u["common.machineId"],v=u["common.firstSessionDate"],D=u["common.msftInternal"];return{sessionId:h,machineId:g,firstSessionDate:v,msftInternal:D}}dispose(){this.i.dispose()}n(u,h,g){return this.g<h?Promise.resolve(void 0):this.c.then(v=>{g=(0,U.mixin)(g,this.d),g=(0,d.cleanData)(g,this.j),g=(0,U.mixin)(g,v),this.b.forEach(D=>D.log(u,g))},v=>{console.error(v)})}publicLog(u,h){return this.n(u,3,h)}publicLog2(u,h){return this.publicLog(u,h)}publicLogError(u,h){return this.h?this.n(u,2,h):Promise.resolve(void 0)}publicLogError2(u,h){return this.publicLogError(u,h)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ye([K(1,R.IConfigurationService),K(2,P.IProductService)],m),e.TelemetryService=m;function E(){const c=(0,N.localize)(0,null,w.default.nameLong),u=w.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=l.isWeb?"":(0,N.localize)(3,null),g=(0,N.localize)(4,null),v=(0,N.localize)(5,null),D=(0,N.localize)(6,null),n=(0,N.localize)(7,null),o=`
|       | ${g} | ${v} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${c} ${u} ${h}

&nbsp;

${n}
${o}

&nbsp;

${i}
`}S.Registry.as(I.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(I.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,N.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,N.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[244],oe([0,1,296,243]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends U.AbstractOneDataSystemAppender{constructor(N,R,I,w){const P={sendPOST:(S,p)=>{const d={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const m=L.request(S.urlString,d,E=>{E.on("data",function(c){p(E.statusCode??200,E.headers,c.toString())}),E.on("error",function(c){p(0,{})})});m.write(S.data),m.end()}catch{p(0,{})}}};super(N,R,I,w,P)}}e.OneDataSystemAppender=l}),define(re[245],oe([0,1,22,65,17,15,9,26,19,113,114,115]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(m,E,c,u,h,g){this.b=m,this.c=E,this.d=c,this.e=u,this.f=h,this.g=g,this.a=new Map}async h(m){if(!this.a.has(m.id)){const{machineId:E,sessionId:c}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=E,u["common.vscodesessionid"]=c;const h=[m.id,JSON.stringify(u),m.aiKey],v=new U.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),D=[new w.TelemetryAppenderClient(v),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${m.id}] `)];this.a.set(m.id,new S.TelemetryService({appenders:D,sendErrorTelemetry:m.sendErrorTelemetry},this.b,this.g))}return this.a.get(m.id)}async publicLog(m,E,c){await(await this.h(m)).publicLog(E,c)}async publicLogError(m,E,c){await(await this.h(m)).publicLogError(E,c)}};p=ye([K(0,l.IConfigurationService),K(1,I.ITelemetryService),K(2,N.ILogService),K(3,N.ILoggerService),K(4,O.IEnvironmentService),K(5,R.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(re[116],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(re[246],oe([0,1,4,116]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(I){this.collections=I,this.map=new Map,I.forEach((w,P)=>{const S=w.map.entries();let p=S.next();for(;!p.done;){const d=p.value[0];let m=this.map.get(d);if(m||(m=[],this.map.set(d,m)),m.length>0&&m[0].type===U.EnvironmentVariableMutatorType.Replace){p=S.next();continue}const E=p.value[1];m.unshift({extensionIdentifier:P,value:E.value,type:E.type}),p=S.next()}})}async applyToProcessEnvironment(I,w){let P;L.isWindows&&(P={},Object.keys(I).forEach(S=>P[S.toLowerCase()]=S));for(const[S,p]of this.map){const d=L.isWindows&&P[S.toLowerCase()]||S;for(const m of p){const E=w?await w(m.value):m.value;switch(m.type){case U.EnvironmentVariableMutatorType.Append:I[d]=(I[d]||"")+E;break;case U.EnvironmentVariableMutatorType.Prepend:I[d]=E+(I[d]||"");break;case U.EnvironmentVariableMutatorType.Replace:I[d]=E;break}}}}diff(I){const w=new Map,P=new Map,S=new Map;if(I.map.forEach((p,d)=>{const m=this.map.get(d),E=O(p,m);E&&w.set(d,E)}),this.map.forEach((p,d)=>{const m=I.map.get(d),E=O(p,m);E&&S.set(d,E)}),this.map.forEach((p,d)=>{const m=I.map.get(d),E=N(p,m);E&&P.set(d,E)}),!(w.size===0&&P.size===0&&S.size===0))return{added:w,changed:P,removed:S}}}e.MergedEnvironmentVariableCollection=l;function O(R,I){if(!I)return R;const w=new Set;I.forEach(S=>w.add(S.extensionIdentifier));const P=[];return R.forEach(S=>{w.has(S.extensionIdentifier)||P.push(S)}),P.length===0?void 0:P}function N(R,I){if(!I)return;const w=new Map;I.forEach(S=>w.set(S.extensionIdentifier,S));const P=[];return R.forEach(S=>{const p=w.get(S.extensionIdentifier);p&&(S.type!==p.type||S.value!==p.value)&&P.push(p)}),P.length===0?void 0:P}}),define(re[247],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(N){return[...N.entries()]}e.serializeEnvironmentVariableCollection=L;function U(N){return new Map(N)}e.deserializeEnvironmentVariableCollection=U;function l(N){return Array.from(N.entries()).map(R=>[R[0],L(R[1].map)])}e.serializeEnvironmentVariableCollections=l;function O(N){return new Map(N.map(R=>[R[0],{map:U(R[1])}]))}e.deserializeEnvironmentVariableCollections=O}),define(re[248],oe([0,1,6,25,3,2,9]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends O.Disposable{constructor(w,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.D(new l.Emitter),this.onCreateRequest=this.g.event,this.b=w===void 0?15e3:w}createRequest(w){return new Promise((P,S)=>{const p=++this.a;this.c.set(p,P),this.g.fire({requestId:p,...w});const d=new U.CancellationTokenSource;(0,L.timeout)(this.b,d.token).then(()=>S(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,O.toDisposable)(()=>d.cancel())])})}acceptReply(w,P){const S=this.c.get(w);S?(this.c.delete(w),(0,O.dispose)(this.f.get(w)||[]),this.f.delete(w),S(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};R=ye([K(1,N.ILogService)],R),e.RequestStore=R}),define(re[117],oe([0,1,5,69]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new U.RawContextKey("terminalTabFocusMode",!1,!0);var l;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(l=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var O;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.SmoothScrolling="terminal.integrated.smoothScrolling"})(O=e.TerminalSettingId||(e.TerminalSettingId={}));var N;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(N=e.PosixShellType||(e.PosixShellType={}));var R;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Logger="logger",g.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var P;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var d;(function(g){g.TerminalView="view",g.Editor="editor"})(d=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var E;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(E=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}));var u;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var h;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(h=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[249],oe([0,1,52,11,180,134]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function N(p,d){const m=[{name:null,description:(0,l.localize)(0,null)}];return m.push(...p.map(E=>({name:E.profileName,description:R(E)}))),d&&m.push(...d.map(E=>({name:E.title,description:I(E)}))),{values:m.map(E=>E.name),markdownDescriptions:m.map(E=>E.description)}}e.createProfileSchemaEnums=N;function R(p){let d=`$(${O.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:L.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?d+=`
- args: "${p.args}"`:d+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(d+=`
- overrideName: ${p.overrideName}`),p.color&&(d+=`
- color: ${p.color}`),p.env&&(d+=`
- env: ${JSON.stringify(p.env)}`),d}function I(p){return`$(${O.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:L.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function w(p,d){if(!p&&!d)return!0;if(typeof p=="string"&&typeof d=="string")return p===d;if(Array.isArray(p)&&Array.isArray(d)){if(p.length!==d.length)return!1;for(let m=0;m<p.length;m++)if(p[m]!==d[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function P(p,d){if(!p&&!d)return!0;if(!p||!d)return!1;if(O.ThemeIcon.isThemeIcon(p)&&O.ThemeIcon.isThemeIcon(d))return p.id===d.id&&p.color===d.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof d=="object"&&"light"in d&&"dark"in d){const m=p,E=d;if((U.URI.isUri(m.light)||S(m.light))&&(U.URI.isUri(m.dark)||S(m.dark))&&(U.URI.isUri(E.light)||S(E.light))&&(U.URI.isUri(E.dark)||S(E.dark)))return m.light.path===E.light.path&&m.dark.path===E.dark.path}if(U.URI.isUri(p)&&U.URI.isUri(d)||S(p)||S(d)){const m=p,E=d;return m.path===E.path&&m.scheme===E.scheme}return!1}e.terminalIconsEqual=P;function S(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=S}),define(re[250],oe([0,1,52,179,45,40,249]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),v=>v.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),v=>`$(${v.id})`)};const R={args:{description:(0,U.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,U.localize)(1,null),type:"boolean"},icon:{description:(0,U.localize)(2,null),...e.terminalIconSchema},color:{description:(0,U.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,U.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,U.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},w={type:"object",required:["path"],properties:{path:{description:(0,U.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,U.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,U.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,U.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,U.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,U.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),E=(0,U.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,U.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,U.localize)(26,null)}},{type:"string",markdownDescription:(0,U.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,U.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(30,null),type:"string"},id:{description:(0,U.localize)(31,null),type:"string"},title:{description:(0,U.localize)(32,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(34,null),type:"string"},id:{description:(0,U.localize)(35,null),type:"string"},title:{description:(0,U.localize)(36,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,U.localize)(38,null),type:"string"},id:{description:(0,U.localize)(39,null),type:"string"},title:{description:(0,U.localize)(40,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,U.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,U.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,U.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,U.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,U.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){O.Registry.as(l.Extensions.Configuration).registerConfiguration(c),g()}e.registerTerminalPlatformConfiguration=u;let h;function g(v,D){const n=O.Registry.as(l.Extensions.Configuration);let o;v&&(o=(0,N.createProfileSchemaEnums)(v?.profiles,D));const i=h;h={id:"terminal",order:100,title:(0,U.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,U.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?o?.values:void 0,markdownEnumDescriptions:v?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,U.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?o?.values:void 0,markdownEnumDescriptions:v?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,U.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?o?.values:void 0,markdownEnumDescriptions:v?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[h],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(re[251],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(re[252],oe([0,1,34,22,32,13,4,36,27,12,28,116,247,246]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function m(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let s=0;return t&&t.length===4&&(s=parseInt(t[3])),s}e.getWindowsBuildNumber=m;async function E(t,s,a,r=R.env,f=P.Promises.exists){if(O.isAbsolute(t))return await f(t)?t:void 0;if(s===void 0&&(s=R.cwd()),O.dirname(t)!=="."){const T=O.join(s,t);return await f(T)?T:void 0}const y=(0,l.getCaseInsensitive)(r,"PATH");if(a===void 0&&(0,w.isString)(y)&&(a=y.split(O.delimiter)),a===void 0||a.length===0){const T=O.join(s,t);return await f(T)?T:void 0}for(const T of a){let F;if(O.isAbsolute(T)?F=O.join(T,t):F=O.join(s,T,t),await f(F))return F;if(N.isWindows){let j=F+".com";if(await f(j)||(j=F+".exe",await f(j)))return j}}const k=O.join(s,t);return await f(k)?k:void 0}e.findExecutable=E;function c(t,s,a,r,f){const b=N.isWindows&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||b)return;const y=t.args,k=R.platform==="win32"?O.basename(t.executable).toLowerCase():O.basename(t.executable),T=O.dirname(U.FileAccess.asFileUri("").fsPath);let F;const j={VSCODE_INJECTION:"1"};if(N.isWindows){if(k==="pwsh.exe"||k==="powershell.exe")return!y||o(y)?F=g.get(h.WindowsPwsh):n(y)&&(F=g.get(h.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T,""),s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:j}):void 0;r.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(k){case"bash":return!y||y.length===0?F=g.get(h.Bash):i(y)&&(j.VSCODE_SHELL_LOGIN="1",u(s,j),F=g.get(h.Bash)),F?(F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T),{newArgs:F,envMixin:j}):void 0;case"fish":{const x=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=O.join(T,"out/vs/workbench/contrib/xdg_data");return j.XDG_DATA_DIRS=`${x}:${V}`,u(s,j),{newArgs:void 0,envMixin:j}}case"pwsh":return!y||o(y)?F=g.get(h.Pwsh):n(y)&&(F=g.get(h.PwshLogin)),F?(s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T,""),{newArgs:F,envMixin:j}):void 0;case"zsh":{if(!y||y.length===0?F=g.get(h.Zsh):i(y)?(F=g.get(h.ZshLogin),u(s,j)):(y===g.get(h.Zsh)||y===g.get(h.ZshLogin))&&(F=y),!F)return;F=[...F],F[F.length-1]=(0,I.format)(F[F.length-1],T);let x;try{x=L.userInfo().username}catch{x="unknown"}const V=O.join(L.tmpdir(),`${x}-${f.applicationName}-zsh`);j.ZDOTDIR=V;const B=a?.ZDOTDIR??L.homedir()??"~";j.USER_ZDOTDIR=B;const X=[];return X.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(V,".zshrc")}),X.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(V,".zprofile")}),X.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(V,".zshenv")}),X.push({source:O.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(V,".zlogin")}),{newArgs:F,envMixin:j,filesToCopy:X}}}r.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.getShellIntegrationInjection=c;function u(t,s){if(N.isMacintosh&&t.environmentVariableCollections){const a=(0,p.deserializeEnvironmentVariableCollections)(t.environmentVariableCollections),f=new d.MergedEnvironmentVariableCollection(a).map.get("PATH"),b=[];if(f)for(const y of f)y.type===S.EnvironmentVariableMutatorType.Prepend&&b.push(y.value);b.length>0&&(s.VSCODE_PATH_PREFIX=b.join(""))}}var h;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(h||(h={}));const g=new Map;g.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(h.Zsh,["-i"]),g.set(h.ZshLogin,["-il"]),g.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],D=["-nol","-nologo"];function n(t){return typeof t=="string"?v.includes(t.toLowerCase()):t.length===1&&v.includes(t[0].toLowerCase())||t.length===2&&(v.includes(t[0].toLowerCase())||v.includes(t[1].toLowerCase()))&&(D.includes(t[0].toLowerCase())||D.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?D.includes(t.toLowerCase()):t.length===0||t?.length===1&&D.includes(t[0].toLowerCase())}function i(t){return t==="string"&&v.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&v.includes(t[0].toLowerCase())}}),define(re[253],oe([0,1,50,52,13,4,12,28,94,252,196]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let S,p=!0;function d(t,s,a,r,f=process.env,b,y,k,T){return b=b||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},O.isWindows?m(a,b,f,y,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),T,k):n(b,y,a,t&&typeof t=="object"?{...t}:r.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,k,f)}e.detectAvailableProfiles=d;async function m(t,s,a,r,f,b,y,k,T){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),j=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let x=!1;(0,w.getWindowsBuildNumber)()>=16299&&(x=!0),await u(k);const V=new Map;if(t){V.set("PowerShell",{source:"PowerShell",icon:U.Codicon.terminalPowershell,isAutoDetected:!0}),V.set("Windows PowerShell",{path:`${j}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:U.Codicon.terminalPowershell,isAutoDetected:!0}),V.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),V.set("Command Prompt",{path:`${j}\\cmd.exe`,icon:U.Codicon.terminalCmd,isAutoDetected:!0}),V.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),V.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:U.Codicon.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;V.set("Cmder",{path:`${j}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}o(b,V);const B=await E(V.entries(),y,s,a,r,T);if(t||f)try{const X=await v(`${j}\\${x?"wsl":"bash"}.exe`,y);for(const J of X)(!b||!(J.profileName in b))&&B.push(J)}catch{p&&(r?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return B}async function E(t,s,a,r=process.env,f,b){const y=[];for(const[k,T]of t){if(T===null)continue;let F,j,x;if("source"in T){const J=S?.get(T.source);if(!J)continue;F=J.paths,j=T.args||J.args,T.icon?x=c(T.icon):J.icon&&(x=J.icon)}else F=Array.isArray(T.path)?T.path:[T.path],j=O.isWindows||Array.isArray(T.args)?T.args:void 0,x=c(T.icon);let V;if(b){const J=F.map(Y=>typeof Y=="string"?Y:Y.path),G=await b(J);V=new Array(F.length);for(let Y=0;Y<F.length;Y++)typeof F[Y]=="string"?V[Y]=G[Y]:V[Y]={path:G[Y],isUnsafe:!0}}else V=F.slice();let B;if(T.requiresPath){let J;if((0,N.isString)(T.requiresPath)?J=T.requiresPath:(J=T.requiresPath.path,T.requiresPath.isUnsafe&&(B=J)),!await a.existsFile(J))continue}const X=await i(k,s,V,a,r,j,T.env,T.overrideName,T.isAutoDetected,B);X?(X.isAutoDetected=T.isAutoDetected,X.icon=x,X.color=T.color,y.push(X)):f?.debug("Terminal profile not validated",k,F)}return f?.debug("Validated terminal profiles",y),y}function c(t){return typeof t=="string"?{id:t}:t}async function u(t){if(S&&!t)return;const[s,a]=await Promise.all([h(),t||g()]);S=new Map,S.set("Git Bash",{profileName:"Git Bash",paths:s,args:["--login","-i"]}),S.set("PowerShell",{profileName:"PowerShell",paths:a,icon:U.Codicon.terminalPowershell})}async function h(){const t=new Set,s=await(0,w.findExecutable)("git.exe");if(s){const f=(0,P.dirname)(s);t.add((0,P.resolve)(f,"../..")),console.log("gitDirs",t)}function a(f,b){b&&f.add(b)}a(t,process.env.ProgramW6432),a(t,process.env.ProgramFiles),a(t,process.env["ProgramFiles(X86)"]),a(t,`${process.env.LocalAppData}\\Program`);const r=[];for(const f of t)r.push(`${f}\\Git\\bin\\bash.exe`,`${f}\\Git\\usr\\bin\\bash.exe`);return r.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),r}async function g(){const t=[];for await(const s of(0,I.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function v(t,s){const a=[],r=await new Promise((y,k)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,F)=>{if(T)return k("Problem occurred when getting wsl distros");y(F)})});if(!r)return[];const f=new RegExp(/[\r?\n]/),b=r.split(f).filter(y=>y.trim().length>0&&y!=="");for(const y of b){if(y===""||y.startsWith("docker-desktop"))continue;const k=`${y} (WSL)`,T={profileName:k,path:t,args:["-d",`${y}`],isDefault:k===s,icon:D(y),isAutoDetected:!1};a.push(T)}return a}function D(t){return t.includes("Ubuntu")?U.Codicon.terminalUbuntu:t.includes("Debian")?U.Codicon.terminalDebian:U.Codicon.terminalLinux}async function n(t,s,a,r,f,b,y,k){const T=new Map;if(a){const F=(await t.readFile("/etc/shells")).toString(),j=b||F.split(`
`).filter(V=>V.trim().includes("#")&&V.trim().length>0),x=new Map;for(const V of j){let B=(0,l.basename)(V),X=x.get(B)||0;X++,X>1&&(B=`${B} (${X})`),x.set(B,X),T.set(B,{path:V,isAutoDetected:!0})}}return o(r,T),await E(T.entries(),f,t,k,s,y)}function o(t,s){if(!!t)for(const[a,r]of Object.entries(t))r===null||typeof r!="object"||!("path"in r)&&!("source"in r)?s.delete(a):(r.icon=r.icon||s.get(a)?.icon,s.set(a,r))}async function i(t,s,a,r,f,b,y,k,T,F){if(a.length===0)return Promise.resolve(void 0);const j=a.shift();if(j==="")return i(t,s,a,r,f,b,y,k,T);const x=typeof j!="string"&&j.isUnsafe,V=typeof j=="string"?j:j.path,B={profileName:t,path:V,args:b,env:y,overrideName:k,isAutoDetected:T,isDefault:t===s,isUnsafePath:x,requiresUnsafePath:F};if((0,l.basename)(V)===V){const J=f.PATH?f.PATH.split(l.delimiter):void 0,G=await(0,w.findExecutable)(V,void 0,J,void 0,r.existsFile);return G?(B.path=G,B.isFromPath=!0,B):i(t,s,a,r,f,b)}return await r.existsFile((0,l.normalize)(V))?B:i(t,s,a,r,f,b,y,k,T)}}),define(re[254],oe([0,1,3,2,22,4,39,65,17,15,97,234,9,248,117,250,253,106]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(D){D[D.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let g=0,v=class extends U.Disposable{constructor(n,o,i,t,s,a){super(),this.z=n,this.C=o,this.F=i,this.G=t,this.H=s,this.I=a,this.g=0,this.h=!0,this.i=!1,this.l=this.D(new L.Emitter),this.onPtyHostExit=this.l.event,this.m=this.D(new L.Emitter),this.onPtyHostStart=this.m.event,this.n=this.D(new L.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.D(new L.Emitter),this.onPtyHostResponsive=this.p.event,this.q=this.D(new L.Emitter),this.onPtyHostRequestResolveVariables=this.q.event,this.r=this.D(new L.Emitter),this.onProcessData=this.r.event,this.s=this.D(new L.Emitter),this.onProcessReady=this.s.event,this.t=this.D(new L.Emitter),this.onProcessReplay=this.t.event,this.u=this.D(new L.Emitter),this.onProcessOrphanQuestion=this.u.event,this.v=this.D(new L.Emitter),this.onDidRequestDetach=this.v.event,this.w=this.D(new L.Emitter),this.onDidChangeProperty=this.w.event,this.y=this.D(new L.Emitter),this.onProcessExit=this.y.event,(0,E.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.D((0,U.toDisposable)(()=>this.O())),this.f=this.D(new d.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.q.fire,this.q),[this.a,this.b]=this.N(),this.D(this.F.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(O.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(n){return this.H.error("ptyHost was unable to resolve shell environment",n),{}}}N(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_PTY_REMOTE:this.C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.z.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.z.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.z.scrollback}},o=(0,P.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const i=new R.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),N.ProxyChannel.toService(i.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.D(i.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=h.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this.D(new u.RemoteLoggerChannelClient(this.I,i.getChannel(m.TerminalIpcChannels.Logger)));const s=N.ProxyChannel.toService(i.getChannel(m.TerminalIpcChannels.PtyHost));return this.D(s.onProcessData(a=>this.r.fire(a))),this.D(s.onProcessReady(a=>this.s.fire(a))),this.D(s.onProcessExit(a=>this.y.fire(a))),this.D(s.onDidChangeProperty(a=>this.w.fire(a))),this.D(s.onProcessReplay(a=>this.t.fire(a))),this.D(s.onProcessOrphanQuestion(a=>this.u.fire(a))),this.D(s.onDidRequestDetach(a=>this.v.fire(a))),[i,s]}dispose(){this.i=!0,super.dispose()}async createProcess(n,o,i,t,s,a,r,f,b,y,k){const T=setTimeout(()=>this.S(),m.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(n,o,i,t,s,a,r,f,b,y,k);return clearTimeout(T),g=Math.max(g,F),F}updateTitle(n,o,i){return this.b.updateTitle(n,o,i)}updateIcon(n,o,i,t){return this.b.updateIcon(n,o,i,t)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,o){return this.b.detachFromProcess(n,o)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,o){return this.b.shutdown(n,o)}input(n,o){return this.b.input(n,o)}processBinary(n,o){return this.b.processBinary(n,o)}resize(n,o,i){return this.b.resize(n,o,i)}acknowledgeDataEvent(n,o){return this.b.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this.b.setUnicodeVersion(n,o)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,o){return this.b.installAutoReply(n,o)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,o,i,t=!1){const s=await this.c;return(0,c.detectAvailableProfiles)(o,i,t,this.F,s,void 0,this.H,this.W.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n,o){return this.b.getWslPath(n,o)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this.b.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this.b.acceptDetachInstanceReply(n,o)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this.b.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this.b.refreshProperty(n,o)}async updateProperty(n,o,i){return this.b.updateProperty(n,o,i)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(n,o){return this.f.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this.f.acceptReply(n,o)}};v=ye([K(2,I.IConfigurationService),K(3,w.IEnvironmentService),K(4,p.ILogService),K(5,p.ILoggerService)],v),e.PtyHostService=v}),define(re[76],oe([0,1,3,17,5,9]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var N;(function(E){E.Http="http",E.Https="https"})(N=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=S;function p(E,c,u,h){if(u===1)return!1;if(u===2&&S(c)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(g?.length===4&&parseInt(g[1])>=18)return!1}return E<1024}e.isPortPrivileged=p;class d{constructor(c,u,h){this.remoteAddress=c,this.localAddress=u,this.b=h,this.a=new L.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let m=class{constructor(c,u){this.i=c,this.j=u,this.a=new L.Emitter,this.onTunnelOpened=this.a.event,this.b=new L.Emitter,this.onTunnelClosed=this.b.event,this.c=new L.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],u=Array.from(this.d.values());for(const h of u){const g=Array.from(h.values());for(const v of g){const D=await v.value;D&&c.push(D)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:u}of c.values())await u.then(h=>h?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,u,h,g,v){this.o(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:h,privacy:g,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(S(c)||P(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const h=this.q(c,u);if(h)return++h.refcount,h.value}openTunnel(c,u,h,g,v,D=!1,n,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${v}.`),!c)return;if(u||(u="localhost"),g||(g=this.k),this.e&&this.h.has(h)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(c,u,h,g,v,D,n,o);return i?i.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,h);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==h)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.d.get(c.tunnelRemoteHost);if(u){const h=u.get(c.tunnelRemotePort);h&&(h.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,h))}}}}async n(c,u,h){if(h.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const g=h.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(u),g}}async closeTunnel(c,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const h=this.d.get(c);if(h&&h.has(u)){const g=h.get(u);g.refcount=0,await this.n(c,u,g)}}o(c,u,h){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(u,{refcount:1,value:h})}async p(c,u){const h=this.d.get(c);h&&(await h.get(u)||h.delete(u),h.size===0&&this.d.delete(c))}q(c,u){const h=[c];P(c)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):S(c)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const g=h.map(v=>this.d.get(v));for(const v of g){const D=v?.get(u);if(D)return D}}canTunnel(c){return!!w(c)}s(c,u,h,g,v,D,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${g}.`);const o=h;this.h.add(o);const i=g===void 0?h:g,t={elevationRequired:v?this.isPortPrivileged(i):!1},s={remoteAddress:{host:u,port:h},localAddressPort:g,privacy:D,public:D?D!==R.Private:void 0,protocol:n},a=c.forwardPort(s,t);return a?(this.o(u,h,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),a}};m=ye([K(0,O.ILogService),K(1,U.IConfigurationService)],m),e.AbstractTunnelService=m}),define(re[255],oe([0,1,9,76,2,10,6]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.D(P)}}let I=class Dt extends l.Disposable{constructor(P,S){super(),this.f=P,this.g=S,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(P,S,p,d,m,E,c){const u=new R,h=await Promise.resolve(this.f.openTunnel(P,u,p,d,m,E,c));if(!h)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${d} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(S))throw this.c.delete(S),u.dispose(),await h.dispose(),(0,O.canceled)();return u.setTunnel(h),this.b.set(S,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${h.localAddress} (local) to ${p}:${d} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(P,S){const p=this.b.get(P);!p||p.setAddress(S)}async destroyTunnel(P){const S=this.b.get(P);if(S){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await S.dispose();return}this.c.add(P)}};I.a=0,I=ye([K(0,U.ISharedTunnelsService),K(1,L.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[256],oe([0,1,86,34,136,228,6,2,17,9,26,226,76,111,4]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(v,D,n,o,i){let t;for(let s=3;s&&(t?.dispose(),t=await new c(v,D,n,o,i).waitForReady(),!(i&&l.BROWSER_RESTRICTED_PORTS[i]||!l.BROWSER_RESTRICTED_PORTS[t.tunnelLocalPort]));s--);return t}class c extends R.Disposable{constructor(D,n,o,i,t){super(),this.j=n,this.k=t,this.privacy=p.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=L.createServer(),this.c=new N.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let o=await(0,l.findFreePortFaster)(D,2,1e3,n),i=null;return this.b.listen(o,this.j),await this.c.wait(),i=this.b.address(),i||(o=0,this.b.listen(o,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,S.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),i=o.getSocket().socket,t=o.readEntireBuffer();o.dispose(),t.byteLength>0&&D.write(t.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let u=class extends p.AbstractTunnelService{constructor(D,n,o,i,t){super(n,t),this.t=D,this.u=o,this.v=i}isPortPrivileged(D){return(0,p.isPortPrivileged)(D,this.k,m.OS,U.release())}r(D,n,o,i,t,s,a,r){const f=this.q(n,o);if(f)return++f.refcount,f.value;if(this.e)return this.s(this.e,n,o,t,s,a,r);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${o} on local port ${t}.`);const b={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},y=E(b,i,n,o,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,o,y),y}}};u=ye([K(1,w.ILogService),K(2,d.ISignService),K(3,P.IProductService),K(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let h=class extends u{constructor(D,n,o,i){super(O.nodeSocketFactory,D,n,o,i)}};h=ye([K(0,w.ILogService),K(1,d.ISignService),K(2,P.IProductService),K(3,I.IConfigurationService)],h),e.TunnelService=h;let g=class extends R.Disposable{constructor(D,n,o,i){super(),this.b=D,this.c=n,this.f=o,this.g=i,this.a=new Map}async openTunnel(D,n,o,i,t,s,a,r,f){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${i} on local port ${s}.`),!this.a.has(D)){const b=new h(this.b,this.f,this.c,this.g);this.D(b),this.a.set(D,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(n,o,i,t,s,a,r,f)}};g=ye([K(0,w.ILogService),K(1,P.IProductService),K(2,d.ISignService),K(3,I.IConfigurationService)],g),e.SharedTunnelsService=g}),define(re[30],oe([0,1,5]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(re[257],oe([0,1,30,200,14,23,132,3,2]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(p){this.uri=p,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let P=class{constructor(p){this.g=p,this.c=new I.DisposableStore,this.f=2**16;const d=new Map,m=E=>{let c=d.get(E.scheme);return c===void 0&&(c=p.hasProvider(E)&&!this.g.hasCapability(E,1024),d.set(E.scheme,c)),c};this.c.add(R.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(E=>{d.delete(E.scheme)})),this.extUri=new O.ExtUri(m),this.d=new N.SkipList((E,c)=>this.extUri.compare(E,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,O.normalizePath)(p));const d=this.d.get(p);return d?d.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new w(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((m,E)=>m[1].time<E[1].time?1:m[1].time>E[1].time?-1:0);w._clock=0,this.d.clear();const d=this.f*.5;for(let m=0;m<d;m++)this.d.set(p[m][0],p[m][1].touch())}};P=ye([K(0,l.IFileService)],P),e.UriIdentityService=P,(0,U.registerSingleton)(L.IUriIdentityService,P,1)}),define(re[258],oe([0,1,3,2,14,43,49,16]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends U.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,S,p,d){super(),this.c=P,this.f=S,this.g=p,this.h=d,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.D(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=N.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.D(this.f.onDidChangeFile(m=>this.i(m)))}watch(P,S){this.b.set(P,P);const p=this.f.watch(this.j(P),S);return(0,U.toDisposable)(()=>{this.b.delete(P),p.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,S,p){return this.f.rename(this.j(P),this.j(S),p)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,S,p){const d=(0,O.newWriteableStream)(m=>R.VSBuffer.concat(m.map(E=>R.VSBuffer.wrap(E))).buffer);return(async()=>{try{const m=await this.readFile(P);d.end(m)}catch(m){d.error(m),d.end()}})(),d}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,S,p){return this.f.writeFile(this.j(P),S,p)}delete(P,S){return this.f.delete(this.j(P),S)}copy(P,S,p){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(S),p);throw new Error("copy not supported")}i(P){const S=[];for(const p of P){if(p.resource.scheme!==this.c)continue;const d=this.k(p.resource);this.b.findSubstr(d)&&S.push({resource:d,type:p.type})}S.length&&(this.h.debug("User data changed"),this.a.fire(S))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(re[60],oe([0,1,83]),function(te,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(N,R,I,w){const P=(0,L.setProperty)(N,R,I,w)[0];return P&&(N=N.substring(0,P.offset)+P.content+N.substring(P.offset+P.length)),N}e.edit=U;function l(N,R,I){let w=I;for(;w>=0;){if(N.charAt(w)===R.charAt(R.length-1)&&R.length===1)return w+1;if(w--,R.length===2&&w>=0&&N.charAt(w)===R.charAt(0))return w+2}return 0}e.getLineStartOffset=l;function O(N,R,I){let w=I;for(;w>=0;)if(N.charAt(w)===R.charAt(R.length-1)&&R.length===1||(w++,R.length===2&&w>=0&&N.charAt(w)===R.charAt(1)))return w;return N.length-1}e.getLineEndOffset=O}),define(re[259],oe([0,1,32,55,12]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(d,m,E,c,u,h){const g=[],v=[],D=[];if(!m){const V=d.filter(({identifier:B})=>u.every(X=>X.toLowerCase()!==B.id.toLowerCase()));return{local:{added:g,removed:v,updated:D},remote:V.length>0?{added:V,updated:[],removed:[],all:V}:null}}d=d.map(S),m=m.map(S),E=E?E.map(S):null;const n=new Map,o=V=>{V.uuid&&n.set(V.id.toLowerCase(),V.uuid)};d.forEach(({identifier:V})=>o(V)),m.forEach(({identifier:V})=>o(V)),E?.forEach(({identifier:V})=>o(V));const i=V=>{const B=V.identifier.uuid||n.get(V.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${V.identifier.id.toLowerCase()}`},t=(V,B)=>(V.set(i(B),B),V),s=d.reduce(t,new Map),a=m.reduce(t,new Map),r=m.reduce((V,B)=>t(V,(0,L.deepClone)(B)),new Map),f=E?E.reduce(t,new Map):null,b=c.reduce(t,new Map),y=u.reduce((V,B)=>{const X=n.get(B.toLowerCase());return V.add(X?`uuid:${X}`:`id:${B.toLowerCase()}`)},new Set),k=h?h.reduce((V,{id:B,uuid:X})=>(X=X??n.get(B.toLowerCase()),V.add(X?`uuid:${X}`:`id:${B.toLowerCase()}`)),new Set):null,T=N(s,a,y,!1);if(T.added.size>0||T.removed.size>0||T.updated.size>0){const V=N(f,s,y,!1),B=N(f,a,y,!0),X=(J,G,Y,H)=>{let $,Z,ie;return G.installed?($=H.pinned,ie=H.preRelease,$&&(Z=H.version)):($=Y.pinned,ie=Y.preRelease,$&&(Z=Y.version)),$===void 0&&($=G.pinned,$&&(Z=G.version)),ie===void 0&&(ie=G.preRelease),{...H,installed:G.installed||Y.installed,pinned:$,preRelease:ie,version:Z??(Y.version&&(!G.installed||U.gt(Y.version,G.version))?Y.version:G.version),state:I(G,Y,f?.get(J))}};for(const J of B.removed.values()){const G=s.get(J);if(!G)continue;const Y=(0,l.assertIsDefined)(f?.get(J)),H=k&&!k.has(J)&&Y.installed;G.installed&&H?v.push(G.identifier):r.set(J,G)}for(const J of B.added.values()){const G=(0,l.assertIsDefined)(a.get(J)),Y=s.get(J);if(Y){if(T.updated.has(J)){const H=X(J,Y,G,G);R(Y,G,!1,!1)||D.push(p(H,J)),r.set(J,H)}}else G.installed&&g.push(p(G,J))}for(const J of B.updated.values()){const G=(0,l.assertIsDefined)(a.get(J)),Y=(0,l.assertIsDefined)(f?.get(J)),H=s.get(J);if(H)if(k&&!k.has(J)&&Y.installed&&H.installed&&!G.installed)v.push(H.identifier);else{const Z=X(J,H,G,G);D.push(p(Z,J)),r.set(J,Z)}else G.installed&&g.push(p(G,J))}for(const J of V.added.values())B.added.has(J)||r.set(J,(0,l.assertIsDefined)(s.get(J)));for(const J of V.updated.values()){if(B.removed.has(J)||B.updated.has(J))continue;const G=(0,l.assertIsDefined)(s.get(J)),Y=(0,l.assertIsDefined)(a.get(J));r.set(J,X(J,G,Y,G))}for(const J of V.removed.values())B.updated.has(J)||B.removed.has(J)||b.has(J)||!(0,l.assertIsDefined)(a.get(J)).installed||!k||k.has(J)||!(0,l.assertIsDefined)(f?.get(J)).installed||r.delete(J)}const F=[],j=N(a,r,new Set,!0),x=j.added.size>0||j.updated.size>0||j.removed.size>0;return x&&r.forEach((V,B)=>F.push(p(V,B))),{local:{added:g,removed:v,updated:D},remote:x?{added:[...j.added].map(V=>r.get(V)),updated:[...j.updated].map(V=>r.get(V)),removed:[...j.removed].map(V=>a.get(V)),all:F}:null}}e.merge=O;function N(d,m,E,c){const u=d?[...d.keys()].filter(n=>!E.has(n)):[],h=[...m.keys()].filter(n=>!E.has(n)),g=h.filter(n=>u.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),v=u.filter(n=>h.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),D=new Set;for(const n of u){if(v.has(n))continue;const o=d.get(n),i=m.get(n);(!i||!R(o,i,c,!0))&&D.add(n)}return{added:g,removed:v,updated:D}}function R(d,m,E,c){return!(d.disabled!==m.disabled||c&&d.installed!==m.installed||d.installed&&m.installed&&(d.preRelease!==m.preRelease||d.pinned!==m.pinned||m.pinned&&d.version!==m.version)||!P(d.state,m.state)||E&&d.version!==m.version)}function I(d,m,E){const c=d.state,u=m.state,h=E?.state;if(!m.version||c&&U.gt(d.version,m.version))return c;if(u&&U.gt(m.version,d.version)||!c)return u;if(!u)return c;const g=(0,L.deepClone)(c),v=h?w(h,u):{added:Object.keys(u).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},D=h?w(h,c):{added:Object.keys(c).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...v.added.values(),...v.updated.values()])g[n]=u[n];for(const n of v.removed.values())D.updated.has(n)||delete g[n];return g}function w(d,m){const E=Object.keys(d),c=Object.keys(m),u=c.filter(v=>E.indexOf(v)===-1).reduce((v,D)=>(v.add(D),v),new Set),h=E.filter(v=>c.indexOf(v)===-1).reduce((v,D)=>(v.add(D),v),new Set),g=new Set;for(const v of E){if(h.has(v))continue;const D=d[v],n=m[v];(0,L.equals)(D,n)||g.add(v)}return{added:u,removed:h,updated:g}}function P(d={},m={}){const{added:E,removed:c,updated:u}=w(d,m);return E.size===0&&c.size===0&&u.size===0}function S(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function p(d,m){const E={identifier:{id:d.identifier.id,uuid:m.startsWith("uuid:")?m.substring(5):void 0},version:d.version,preRelease:!!d.preRelease,pinned:!!d.pinned};return d.disabled&&(E.disabled=!0),d.installed&&(E.installed=!0),d.state&&(E.state=d.state),E}}),define(re[118],oe([0,1,21,17,5]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let O=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==R&&P!==`-${R}`),I&&w.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(R,I){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==R&&P!==`-${R}`),I&&w.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(R){const I=R.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),w=this.b().map(p=>p.toLowerCase()),P=[],S=[];if(Array.isArray(w))for(const p of w)p.startsWith("-")?S.push(p.substring(1)):P.push(p);return(0,L.distinct)([...I,...P].filter(p=>S.indexOf(p)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};O=ye([K(0,U.IConfigurationService)],O),e.IgnoredExtensionsManagementService=O}),define(re[260],oe([0,1,21,35,32,69,60]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(v){return(0,U.parse)(v)||[]}async function I(v,D,n,o,i){const t=R(v),s=R(D),a=n?R(n):null,r=[...t,...s,...a||[]].map(X=>X.key),f=await i.resolveUserBindings(r),b=P(t,s,a,f);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:D,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const y=p(t),k=p(s),T=a?p(a):null,F=m(y,k,f),j=T?m(T,y,f):{added:[...y.keys()].reduce((X,J)=>(X.add(J),X),new Set),removed:new Set,updated:new Set},x=T?m(T,k,f):{added:[...k.keys()].reduce((X,J)=>(X.add(J),X),new Set),removed:new Set,updated:new Set},V=w(F,j,x);let B=v;for(const X of V.removed.values())V.conflicts.has(X)||(B=h(B,X,o));for(const X of V.added.values()){if(V.conflicts.has(X))continue;const J=k.get(X);if(J.some(G=>G.command!==`-${X}`&&b.conflicts.has(f[G.key]))){V.conflicts.add(X);continue}B=u(B,J,o)}for(const X of V.updated.values()){if(V.conflicts.has(X))continue;const J=k.get(X);if(J.some(G=>G.command!==`-${X}`&&b.conflicts.has(f[G.key]))){V.conflicts.add(X);continue}B=g(B,X,J,o)}return{mergeContent:B,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=I;function w(v,D,n){const o=new Set,i=new Set,t=new Set,s=new Set;for(const a of D.removed.values())n.updated.has(a)&&s.add(a);for(const a of n.removed.values())s.has(a)||(D.updated.has(a)?s.add(a):i.add(a));for(const a of D.added.values())s.has(a)||n.added.has(a)&&v.updated.has(a)&&s.add(a);for(const a of n.added.values())s.has(a)||(D.added.has(a)?v.updated.has(a)&&s.add(a):o.add(a));for(const a of D.updated.values())s.has(a)||n.updated.has(a)&&v.updated.has(a)&&s.add(a);for(const a of n.updated.values())s.has(a)||(D.updated.has(a)?v.updated.has(a)&&s.add(a):t.add(a));return{added:o,removed:i,updated:t,conflicts:s}}function P(v,D,n,o){const i=new Set,t=S(v,o),s=S(D,o),a=n?S(n,o):null,r=d(t,s);if(r.added.size===0&&r.removed.size===0&&r.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const f=a?d(a,t):{added:[...t.keys()].reduce((j,x)=>(j.add(x),j),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const b=a?d(a,s):{added:[...s.keys()].reduce((j,x)=>(j.add(x),j),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:y,removed:k,updated:T,conflicts:F}=w(r,f,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:y,removed:k,updated:T,conflicts:F}}function S(v,D){const n=new Map;for(const o of v){const i=D[o.key];let t=n.get(i);t||(t=[],n.set(i,t)),t.push(o)}return n}function p(v){const D=new Map;for(const n of v){const o=n.command[0]==="-"?n.command.substring(1):n.command;let i=D.get(o);i||(i=[],D.set(o,i)),i.push(n)}return D}function d(v,D){const n=[...v.keys()],o=[...D.keys()],i=o.filter(a=>n.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),t=n.filter(a=>o.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),s=new Set;for(const a of n){if(t.has(a))continue;const r=v.get(a).map(b=>({...b,key:a})),f=D.get(a).map(b=>({...b,key:a}));(0,L.equals)(r,f,(b,y)=>c(b,y))||s.add(a)}return{added:i,removed:t,updated:s}}function m(v,D,n){const o=[...v.keys()],i=[...D.keys()],t=i.filter(r=>o.indexOf(r)===-1).reduce((r,f)=>(r.add(f),r),new Set),s=o.filter(r=>i.indexOf(r)===-1).reduce((r,f)=>(r.add(f),r),new Set),a=new Set;for(const r of o){if(s.has(r))continue;const f=v.get(r).map(y=>({...y,key:n[y.key]})),b=D.get(r).map(y=>({...y,key:n[y.key]}));E(f,b)||a.add(r)}return{added:t,removed:s,updated:a}}function E(v,D){return!(!(0,L.equals)(v.filter(({command:n})=>n[0]!=="-"),D.filter(({command:n})=>n[0]!=="-"),(n,o)=>c(n,o))||!(0,L.equals)(v.filter(({command:n})=>n[0]==="-"),D.filter(({command:n})=>n[0]==="-"),(n,o)=>c(n,o)))}function c(v,D){if(v.command!==D.command||v.key!==D.key)return!1;const n=O.ContextKeyExpr.deserialize(v.when),o=O.ContextKeyExpr.deserialize(D.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!l.equals(v.args,D.args))}function u(v,D,n){for(const o of D)v=N.edit(v,[-1],o,n);return v}function h(v,D,n){const o=R(v);for(let i=o.length-1;i>=0;i--)(o[i].command===D||o[i].command===`-${D}`)&&(v=N.edit(v,[i],void 0,n));return v}function g(v,D,n,o){const i=R(v),t=i.findIndex(s=>s.command===D||s.command===`-${D}`);for(let s=i.length-1;s>=0;s--)(i[s].command===D||i[s].command===`-${D}`)&&(v=N.edit(v,[s],void 0,o));for(let s=n.length-1;s>=0;s--)v=N.edit(v,[t],n[s],o);return v}}),define(re[261],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(O,N,R){const I={},w={},P=new Set;if(!N)return{local:{added:I,updated:w,removed:[...P.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const S=U(O,N);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:I,updated:w,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=U(R,O),d=U(R,N),m={},E={},c=new Set,u=new Set;for(const h of p.removed.values())d.updated.has(h)?I[h]=N[h]:c.add(h);for(const h of d.removed.values())u.has(h)||(p.updated.has(h)?u.add(h):P.add(h));for(const h of p.updated.values())u.has(h)||(d.updated.has(h)?S.updated.has(h)&&u.add(h):E[h]=O[h]);for(const h of d.updated.values())u.has(h)||(p.updated.has(h)?S.updated.has(h)&&u.add(h):O[h]!==void 0&&(w[h]=N[h]));for(const h of p.added.values())u.has(h)||(d.added.has(h)?S.updated.has(h)&&u.add(h):m[h]=O[h]);for(const h of d.added.values())u.has(h)||(p.added.has(h)?S.updated.has(h)&&u.add(h):I[h]=N[h]);return{local:{added:I,removed:[...P.values()],updated:w},remote:{added:m,removed:[...c.values()],updated:E},conflicts:[...u.values()]}}e.merge=L;function U(O,N){const R=O?Object.keys(O):[],I=N?Object.keys(N):[],w=I.filter(p=>R.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),P=R.filter(p=>I.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),S=new Set;for(const p of R){if(P.has(p))continue;const d=O[p],m=N[p];d!==m&&S.add(p)}return{added:w,removed:P,updated:S}}function l(O,N){const{added:R,removed:I,updated:w}=U(O,N);return R.size===0&&I.size===0&&w.size===0}e.areSame=l}),define(re[262],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(l,O,N,R){const I={added:[],removed:[],updated:[]};let w={added:[],removed:[],updated:[]};if(!O){const S=l.filter(({id:p})=>!R.includes(p));return S.length?w.added=S:w=null,{local:I,remote:w}}const P=U(l,O,R);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const S=U(N,l,R),p=U(N,O,R);for(const d of p.removed){const m=l.find(E=>E.id===d);m&&I.removed.push(m)}for(const d of p.added){const m=O.find(E=>E.id===d);S.added.includes(d)?P.updated.includes(d)&&I.updated.push(m):I.added.push(m)}for(const d of p.updated)I.updated.push(O.find(m=>m.id===d));for(const d of S.added)p.added.includes(d)||w.added.push(l.find(m=>m.id===d));for(const d of S.updated)p.removed.includes(d)||p.updated.includes(d)||w.updated.push(l.find(m=>m.id===d));for(const d of S.removed){const m=O.find(E=>E.id===d);m&&w.removed.push(m)}}return w.added.length===0&&w.removed.length===0&&w.updated.length===0&&(w=null),{local:I,remote:w}}e.merge=L;function U(l,O,N){l=l?l.filter(({id:p})=>!N.includes(p)):[],O=O.filter(({id:p})=>!N.includes(p));const R=l.map(({id:p})=>p),I=O.map(({id:p})=>p),w=I.filter(p=>R.indexOf(p)===-1),P=R.filter(p=>I.indexOf(p)===-1),S=[];for(const{id:p,name:d,shortName:m}of l){if(P.includes(p))continue;const E=O.find(c=>c.id===p);(!E||E.name!==d||E.shortName!==m)&&S.push(p)}return{added:w,removed:P,updated:S}}}),define(re[24],oe([0,1,21,12,186,45,29,5,108,40]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const s=w.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function S(){const s=w.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(b=>!!s[b].ignoreSync),r=Object.keys(s).filter(b=>s[b].scope===2||s[b].scope===6),f=P();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...r,...f])}e.getDefaultIgnoredSettings=S,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function p(){const s="vscode://schemas/ignoredSettings",a=w.Registry.as(O.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const r=w.Registry.as(I.Extensions.JSONContribution),f=()=>{const b=P(),y=S().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),k=Object.keys(O.allSettings.properties).filter(j=>y.indexOf(j)===-1),T=y.filter(j=>b.indexOf(j)===-1),F={items:{type:"string",enum:[...k,...T.map(j=>`-${j}`)]}};r.registerSchema(s,F)};return a.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=p;function d(s){return s&&(0,U.isObject)(s)&&(0,U.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=d;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(s,...a){return s?[s,...a]:a}e.getPathSegments=E;function c(s,a,r,f){return f.joinPath(r.userDataSyncHome,...E(s,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=c,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=u;var h;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(h=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(a,r,f,b){super(a),this.code=r,this.resource=f,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class v extends g{constructor(a,r,f,b,y){super(a,f,void 0,y),this.url=r,this.serverCode=b}}e.UserDataSyncStoreError=v;class D extends g{constructor(a,r){super(a,r)}}e.UserDataAutoSyncError=D,function(s){function a(r){if(r instanceof s)return r;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(r.name);if(f&&f[1]){const b=f[2]==="unknown"?void 0:f[2],y=f[3]==="unknown"?void 0:f[3];return new s(r.message,f[1],b,y)}return new s(r.message,"Unknown")}s.toUserDataSyncError=a}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[263],oe([0,1,32,24]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(N,R,I,w,P){if(!R)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const S=O(N,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=I?O(I,R):{added:Object.keys(R).reduce((h,g)=>(h.add(g),h),new Set),removed:new Set,updated:new Set},d=I?O(I,N):{added:Object.keys(N).reduce((h,g)=>(h.add(g),h),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},E=L.deepClone(R),c=!I;for(const h of d.added.values())h!==U.SYNC_SERVICE_URL_TYPE&&c&&p.added.has(h)||(E[h]=N[h]);for(const h of d.updated.values())E[h]=N[h];for(const h of d.removed.values())w.unregistered.includes(h)||delete E[h];for(const h of p.added.values()){const g=R[h];if(w.machine.includes(h)){P.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(h))continue;const v=N[h];v&&v.value===g.value||h===U.SYNC_SERVICE_URL_TYPE&&c&&d.added.has(h)||(v?m.updated[h]=g:m.added[h]=g)}for(const h of p.updated.values()){const g=R[h];if(w.machine.includes(h)){P.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(h)||d.removed.has(h))continue;const v=N[h];v&&v.value===g.value||(m.updated[h]=g)}for(const h of p.removed.values()){if(w.machine.includes(h)){P.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}d.updated.has(h)||d.removed.has(h)||m.removed.push(h)}const u=O(R,E);return{local:m,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:E}}}e.merge=l;function O(N,R){const I=Object.keys(N),w=Object.keys(R),P=w.filter(d=>I.indexOf(d)===-1).reduce((d,m)=>(d.add(m),d),new Set),S=I.filter(d=>w.indexOf(d)===-1).reduce((d,m)=>(d.add(m),d),new Set),p=new Set;for(const d of I){if(S.has(d))continue;const m=N[d],E=R[d];L.equals(m,E)||p.add(d)}return{added:P,removed:S,updated:p}}}),define(re[264],oe([0,1,21,35,83,42,32,60,24]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(r,f,b){let y=[];b?y=S(b):y=P(f);const k=[],T=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(y))for(const F of y)F.startsWith("-")?T.push(F.substring(1)):k.push(F);return(0,L.distinct)([...r,...k].filter(F=>T.indexOf(F)===-1))}e.getIgnoredSettings=w;function P(r){let f=r.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=r.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:r.getValue("settingsSync.ignoredSettings")||[]}function S(r){const f=(0,U.parse)(r);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function p(r,f){const b=(0,U.parse)(r)||{};let y="{}";for(const k of Object.keys(b)){const T=(0,l.setProperty)(y,[k],b[k],f);y=(0,l.applyEdits)(y,T)}return y}e.removeComments=p;function d(r,f,b,y){if(b.length){const k=a(f),T=(0,U.parse)(f)||{},F=(0,U.parse)(r);if(!F)return r;const j=[];for(const x of b){const V=T[x],B=F[x];V===void 0?r=R.edit(r,[x],void 0,y):B!==void 0?r=R.edit(r,[x],V,y):j.push(n(x,k))}j.sort((x,V)=>x.startOffset-V.startOffset),j.forEach(x=>r=h(x.setting.key,f,r,y))}return r}e.updateIgnoredSettings=d;function m(r,f,b,y,k,T){const F=d(r,f,y,T),j=b!==F,x=b!==f;if(!j&&!x)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!x)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(x&&!j)return{conflictsSettings:[],localContent:d(f,r,y,T),remoteContent:null,hasConflicts:!1};if(b===null&&c(r)){const M=E(r,f,y)?null:d(f,r,y,T);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let V=r,B=f;const X=(0,U.parse)(r),J=(0,U.parse)(f),G=b?(0,U.parse)(b):null,Y=y.reduce((M,z)=>(M.add(z),M),new Set),H=u(X,J,Y),$=u(G,X,Y),Z=u(G,J,Y),ie=new Map,se=new Set,ae=M=>{se.add(M);const z=k.filter(({key:_})=>_===M)[0];z?(V=R.edit(V,[M],z.value,T),B=R.edit(B,[M],z.value,T)):ie.set(M,{key:M,localValue:X[M],remoteValue:J[M]})};for(const M of $.removed.values())Z.updated.has(M)?ae(M):B=R.edit(B,[M],void 0,T);for(const M of Z.removed.values())se.has(M)||($.updated.has(M)?ae(M):V=R.edit(V,[M],void 0,T));for(const M of $.updated.values())se.has(M)||(Z.updated.has(M)?H.updated.has(M)&&ae(M):B=R.edit(B,[M],X[M],T));for(const M of Z.updated.values())se.has(M)||($.updated.has(M)?H.updated.has(M)&&ae(M):V=R.edit(V,[M],J[M],T));for(const M of $.added.values())se.has(M)||(Z.added.has(M)?H.updated.has(M)&&ae(M):B=h(M,V,B,T));for(const M of Z.added.values())se.has(M)||($.added.has(M)?H.updated.has(M)&&ae(M):V=h(M,B,V,T));const q=ie.size>0||!E(V,B,y),C=q||!E(V,r,[]),A=q||!E(B,f,[]);return{localContent:C?V:null,remoteContent:A?B:null,conflictsSettings:[...ie.values()],hasConflicts:q}}e.merge=m;function E(r,f,b){if(r===f)return!0;const y=(0,U.parse)(r),k=(0,U.parse)(f),T=b.reduce((x,V)=>(x.add(V),x),new Set),F=a(r).filter(x=>!(x.setting&&T.has(x.setting.key))),j=a(f).filter(x=>!(x.setting&&T.has(x.setting.key)));if(F.length!==j.length)return!1;for(let x=0;x<F.length;x++){const V=F[x],B=j[x];if(V.setting&&B.setting){if(V.setting.key!==B.setting.key||!N.equals(y[V.setting.key],k[V.setting.key]))return!1}else if(!V.setting&&!B.setting){if(V.value!==B.value)return!1}else return!1}return!0}function c(r){return r?a(r).length===0:!0}e.isEmpty=c;function u(r,f,b){const y=r?Object.keys(r).filter(x=>!b.has(x)):[],k=Object.keys(f).filter(x=>!b.has(x)),T=k.filter(x=>y.indexOf(x)===-1).reduce((x,V)=>(x.add(V),x),new Set),F=y.filter(x=>k.indexOf(x)===-1).reduce((x,V)=>(x.add(V),x),new Set),j=new Set;if(r)for(const x of y){if(F.has(x))continue;const V=r[x],B=f[x];N.equals(V,B)||j.add(x)}return{added:T,removed:F,updated:j}}function h(r,f,b,y){const k=(0,U.parse)(f),T=a(f),F=a(b),j=g(r,T,F);return v(b,r,k[r],j,F,y)}e.addSetting=h;function g(r,f,b){const y=f.findIndex(T=>T.setting?.key===r),k=f[y-1];if(k){if(k.setting){const F=n(k.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!0}}else{const F=o(y,f);if(F){const j=n(F.setting.key,b);if(j){const x=i(b.indexOf(j),b),V=t(f,F,f[y]);if(x){const B=t(b,j,x),X=s(V,B);return X?{index:b.indexOf(X),insertAfter:!0}:{index:b.indexOf(x),insertAfter:!1}}else{const B=t(b,j,b[b.length-1]),X=s(V,B);return X?{index:b.indexOf(X),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const T=f[y+1];if(T)if(T.setting){const F=n(T.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!1}}else{const F=i(y,f);if(F){const j=n(F.setting.key,b);if(j){const x=o(b.indexOf(j),b),V=t(f,f[y],F);if(x){const B=t(b,x,j),X=s(V.reverse(),B.reverse());return X?{index:b.indexOf(X),insertAfter:!1}:{index:b.indexOf(x),insertAfter:!0}}else{const B=t(b,b[0],j),X=s(V.reverse(),B.reverse());return X?{index:b.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function v(r,f,b,y,k,T){let F;return y.index===-1?F=(0,l.setProperty)(r,[f],b,T):F=D(r,f,b,y,k,T).map(j=>(0,l.withFormatting)(r,j,T)[0]),(0,l.applyEdits)(r,F)}function D(r,f,b,y,k,T){const F=`${JSON.stringify(f)}: ${JSON.stringify(b)}`,j=(0,O.getEOL)(T,r),x=k[y.index];if(y.insertAfter){const V=[];if(x.setting)V.push({offset:x.endOffset,length:0,content:","+F});else{const B=i(y.index,k),X=o(y.index,k),J=X?.setting?.commaOffset;X&&J===void 0&&V.push({offset:X.endOffset,length:0,content:","});const G=J!==void 0&&J>x.endOffset;V.push({offset:G?J+1:x.endOffset,length:0,content:B?j+F+",":j+F})}return V}else{if(x.setting)return[{offset:x.startOffset,length:0,content:F+","}];const V=(k[y.index-1]&&!k[y.index-1].setting?j:"")+F+(i(y.index,k)?",":"")+j;return[{offset:x.startOffset,length:0,content:V}]}}function n(r,f){return f.filter(b=>b.setting?.key===r)[0]}function o(r,f){for(let b=r-1;b>=0;b--)if(f[b].setting)return f[b]}function i(r,f){for(let b=r+1;b<f.length;b++)if(f[b].setting)return f[b]}function t(r,f,b){const y=r.indexOf(f),k=r.indexOf(b);return r.filter((T,F)=>y<F&&F<k)}function s(r,f){if(r.length&&f.length){let b=0;for(;b<f.length&&b<r.length;b++)if(r[b].value!==f[b].value)return f[b-1];return f[b-1]}}function a(r){const f=[];let b=-1,y,k;const T={onObjectBegin:F=>{b++},onObjectProperty:(F,j,x)=>{b===0&&(y=j,k=F)},onObjectEnd:(F,j)=>{b--,b===0&&f.push({startOffset:y,endOffset:F+j,value:r.substring(y,F+j),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(F,j)=>{b++},onArrayEnd:(F,j)=>{b--,b===0&&f.push({startOffset:y,endOffset:F+j,value:r.substring(y,F+j),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(F,j,x)=>{b===0&&f.push({startOffset:y,endOffset:j+x,value:r.substring(y,j+x),setting:{key:k,commaOffset:void 0}})},onSeparator:(F,j,x)=>{if(b===0&&F===","){let V=f.length-1;for(;V>=0&&!f[V].setting;V--);const B=f[V];B&&f.splice(V,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:j}})}},onComment:(F,j)=>{b===0&&f.push({startOffset:F,endOffset:F+j,value:r.substring(F,F+j)})}};return(0,U.visit)(r,T),f}}),define(re[77],oe([0,1,3,2,5,24]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let N=class extends U.Disposable{get account(){return this.a}constructor(I,w){super(),this.g=I,this.h=w,this.b=this.D(new L.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.D(new L.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.D(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.D(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};N=ye([K(0,O.IUserDataSyncStoreService),K(1,O.IUserDataSyncLogService)],N),e.UserDataSyncAccountService=N}),define(re[265],oe([0,1,2,11]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(p){this.a=p}listen(p,d){switch(d){case"onError":return this.a.onError}throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"triggerSync":return this.a.triggerSync(m[0],m[1],m[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(m[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class O{constructor(p){this.a=p}listen(p,d){throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(m[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(U.URI.revive(m[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=O;class N{constructor(p){this.a=p}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.a.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.a.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=N;class R{constructor(p){this.a=p}listen(p,d){switch(d){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${d}`)}async call(p,d,m){switch(d){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(m[0],m[1]);case"setEnablements":return this.a.setEnablements(m)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(p){this.a=p}listen(p,d){switch(d){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(m)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class w{constructor(p){this.a=p}listen(p,d){switch(d){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(p,d,m){switch(d){case"switch":return this.a.switch(m[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class P extends L.Disposable{constructor(p){super(),this.a=p,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.a.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.a.call("getPreviousUserDataSyncStore");return this.b(p)}b(p){return{url:U.URI.revive(p.url),type:p.type,defaultUrl:U.URI.revive(p.defaultUrl),insidersUrl:U.URI.revive(p.insidersUrl),stableUrl:U.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(re[266],oe([0,1,187,9,24]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=class extends U.AbstractLogger{constructor(R){super(),this.g=this.D(R.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(R,...I){this.g.trace(R,...I)}debug(R,...I){this.g.debug(R,...I)}info(R,...I){this.g.info(R,...I)}warn(R,...I){this.g.warn(R,...I)}error(R,...I){this.g.error(R,...I)}flush(){this.g.flush()}};O=ye([K(0,U.ILoggerService)],O),e.UserDataSyncLogService=O}),define(re[267],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(re[268],oe([0,1,6,3,2]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends l.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:I,getActiveWindowId:w}){super(),this.a=this.D(new l.DisposableStore),U.Event.latch(U.Event.any(R,I))(this.f,this,this.a),this.b=(0,L.createCancelablePromise)(()=>w()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=O}),define(re[119],oe([0,1,190,13,49,23,11,5,22]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function w(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=w;function P(t){return typeof t?.id=="string"&&!w(t)&&!p(t)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,U.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=t;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=S;function p(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=p;function d(t){const s=t;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const a=t;if(a?.configPath)return{id:a.id,configPath:N.URI.revive(a.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=d;var m;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function E(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function c(t){const s=t;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=c;class u{constructor(s,a,r,f,b){this.h=s,this.j=r,this.k=f,this.l=b,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class h{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function g(t){return new h({uri:t,index:0,name:(0,O.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(t,s){return O.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function D(t){let s;return N.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=D,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function o(t,s){return!v(t,s)&&!D(t)}e.isSavedWorkspace=o;function i(t){return(typeof t=="string"?(0,U.extname)(t):(0,O.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(re[18],oe([0,1,53,3,2,23,11,181,15,14,5,9,119,37,30,6,31,27,12]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function g(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&N.URI.isUri(t.location)&&N.URI.isUri(t.globalStorageHome)&&N.URI.isUri(t.settingsResource)&&N.URI.isUri(t.keybindingsResource)&&N.URI.isUri(t.tasksResource)&&N.URI.isUri(t.snippetsHome)&&N.URI.isUri(t.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function v(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:t}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=v;function D(i,t,s,a){return{id:i,name:t,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,O.joinPath)(s,"globalStorage"),settingsResource:(0,O.joinPath)(s,"settings.json"),keybindingsResource:(0,O.joinPath)(s,"keybindings.json"),tasksResource:(0,O.joinPath)(s,"tasks.json"),snippetsHome:(0,O.joinPath)(s,"snippets"),extensionsResource:(0,O.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=D;let n=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.t.profiles,...this.l.profiles]}constructor(t,s,a,r){super(),this.m=t,this.n=s,this.q=a,this.r=r,this.f=!0,this.g=this.D(new U.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.D(new U.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.D(new U.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.D(new U.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.s=void 0}setEnablement(t){this.f!==t&&(this.s=void 0,this.f=t)}isEnabled(){return this.f}get t(){if(!this.s){const t=[];if(this.f)try{for(const f of this.I()){if(!f.name||!(0,h.isString)(f.name)||!f.location){this.r.warn("Skipping the invalid stored profile",f.location||f.name);continue}t.push(D((0,O.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}}catch(f){this.r.error(f)}const s=new d.ResourceMap,a=new Map,r=this.u();if(t.unshift({...r,extensionsResource:this.N()??r.extensionsResource,isDefault:!0}),t.length)try{const f=this.L();if(f.workspaces)for(const[b,y]of Object.entries(f.workspaces)){const k=N.URI.parse(b),T=t.find(F=>F.id===y);T&&s.set(k,T)}if(f.emptyWindows)for(const[b,y]of Object.entries(f.emptyWindows)){const k=t.find(T=>T.id===y);k&&a.set(b,k)}}catch(f){this.r.error(f)}this.s={profiles:t,workspaces:s,emptyWindows:a}}return this.s}u(){return D("__default__profile__",(0,R.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(t){const s="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let r=0;for(const b of this.profiles){const y=a.exec(b.name),k=y?parseInt(y[1]):0;r=k>r?k:r}const f=`${s} ${r+1}`;return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),f,{transient:!0},t)}async createNamedProfile(t,s,a){return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),t,s,a)}async createProfile(t,s,a,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=await this.v(t,s,a);return r&&await this.setProfileForWorkspace(r,f),f}async v(t,s,a){if(!(0,h.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(s);return r||(r=(async()=>{try{const f=this.profiles.find(k=>k.name===s||k.id===t);if(f)return f;const b=D(t,s,(0,O.joinPath)(this.profilesHome,t),a);await this.n.createFolder(b.location);const y=[];return this.h.fire({profile:b,join(k){y.push(k)}}),await E.Promises.settled(y),this.z([b],[],[]),b}finally{this.k.delete(s)}})(),this.k.set(s,r)),r}async updateProfile(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(r=>r.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=D(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(r=>r.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.i.fire({profile:s,join(r){a.push(r)}});try{await Promise.allSettled(a)}catch(r){this.r.error(r)}for(const r of[...this.t.emptyWindows.keys()])s.id===this.t.emptyWindows.get(r)?.id&&this.t.emptyWindows.delete(r);for(const r of[...this.t.workspaces.keys()])s.id===this.t.workspaces.get(r)?.id&&this.t.workspaces.delete(r);this.G(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(r){this.r.error(r)}}async setProfileForWorkspace(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(r=>r.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.F(t,a)}unsetWorkspace(t,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(t,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.t.workspaces.clear(),this.t.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.q.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(t.map(s=>this.removeProfile(s)))}getProfileForWorkspace(t){const s=this.w(t);return N.URI.isUri(s)?this.l.workspaces.get(s)??this.t.workspaces.get(s):this.l.emptyWindows.get(s)??this.t.emptyWindows.get(s)}w(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:t.id}y(t){return!!([...this.l.emptyWindows.values()].some(s=>this.q.extUri.isEqual(s.location,t.location))||[...this.l.workspaces.values()].some(s=>this.q.extUri.isEqual(s.location,t.location))||[...this.t.emptyWindows.values()].some(s=>this.q.extUri.isEqual(s.location,t.location))||[...this.t.workspaces.values()].some(s=>this.q.extUri.isEqual(s.location,t.location)))}z(t,s,a){const r=[...this.profiles,...t],f=[];this.l.profiles=[];for(let b of r)b.isDefault||s.some(y=>b.id===y.id)||(b=a.find(y=>b.id===y.id)??b,b.isTransient?this.l.profiles.push(b):f.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.J(f),this.s=void 0,this.C(t,s,a)}C(t,s,a){this.g.fire({added:t,removed:s,updated:a,all:this.profiles})}F(t,s,a){a=s?.isTransient?!0:a,a||this.F(t,void 0,!0);const r=this.w(t),f=a?this.l:this.t;N.URI.isUri(r)?(f.workspaces.delete(r),s&&f.workspaces.set(r,s)):(f.emptyWindows.delete(r),s&&f.emptyWindows.set(r,s)),a||this.G()}G(){const t={};for(const[a,r]of this.t.workspaces.entries())t[a.toString()]=r.id;const s={};for(const[a,r]of this.t.emptyWindows.entries())s[a.toString()]=r.id;this.M({workspaces:t,emptyWindows:s}),this.s=void 0}H(t){const s={},a=this.u();if(t.workspaces)for(const[f,b]of Object.entries(t.workspaces)){const y=N.URI.parse(b);s[f]=this.q.extUri.isEqual(y,a.location)?a.id:this.q.extUri.basename(y)}const r={};if(t.emptyWindows)for(const[f,b]of Object.entries(t.emptyWindows)){const y=N.URI.parse(b);r[f]=this.q.extUri.isEqual(y,a.location)?a.id:this.q.extUri.basename(y)}return{workspaces:s,emptyWindows:r}}I(){return[]}J(t){throw new Error("not implemented")}L(){return{}}M(t){throw new Error("not implemented")}N(){}};n.b="userDataProfiles",n.c="profileAssociations",n=ye([K(0,I.IEnvironmentService),K(1,w.IFileService),K(2,m.IUriIdentityService),K(3,S.ILogService)],n),e.UserDataProfilesService=n;class o extends n{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(t){this.a=t}L(){return this.Q}M(t){this.Q=t}}e.InMemoryUserDataProfilesService=o}),define(re[269],oe([0,1,6,2,18]),function(te,e,L,U,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let O=class extends U.Disposable{constructor(R){super(),this.D(new L.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};O=ye([K(0,l.IUserDataProfilesService)],O),e.UserDataProfilesCleaner=O}),define(re[270],oe([0,1,21,6,25,10,3,2,4,11,160,29,33,46,9,26,19,18]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var h;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(h=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let g=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,s,a,r,f){super(),this.s=t,this.t=s,this.u=a,this.v=r,this.w=f,this.h=0,this.j=new Map,this.k=new Map,this.l=this.D(new N.Emitter),this.m=this.D(new N.Emitter),this.n=this.D(new N.Emitter),this.p=this.D(new N.Emitter),this.q=[],this.D((0,R.toDisposable)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.k.forEach(b=>b.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,S.isTargetPlatformCompatible)(a,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{if(!this.s.isEnabled())throw new S.ExtensionManagementError(P.localize(0,null),S.ExtensionManagementErrorCode.Internal);const a=await this.G(t,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.y(a.manifest,a.extension,s)}catch(a){throw n(this.t,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:a}),this.u.error("Failed to install extension.",t.identifier.id),this.u.error(a),D(a)}}async uninstall(t,s={}){return this.u.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.q.push(t)}async y(t,s,a){const r={...a,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,d.isApplicationScopedExtension)(t)?this.w.defaultProfile.extensionsResource:a.profileLocation??this.P()},f=j=>`${p.ExtensionKey.create(j).toString()}${r.profileLocation?`-${r.profileLocation.toString()}`:""}`;if(!w.URI.isUri(s)){const j=this.j.get(f(s));if(j)return this.u.info("Extensions is already requested to install",s.identifier.id),j.task.waitUntilTaskIsFinished()}const b=[],y=[],k=[],T=this.Q(t,s,r);w.URI.isUri(s)||this.j.set(f(s),{task:T,waitingTasks:[]}),this.l.fire({identifier:T.identifier,source:s,profileLocation:r.profileLocation}),this.u.info("Installing extension:",T.identifier.id),b.push({task:T,manifest:t});let F=!1;try{if(r.donotIncludePackAndDependencies)this.u.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const x=await this.F(T.identifier,t,!!r.installOnlyNewlyAddedFromExtensionPack,!!r.installPreReleaseVersion,r.profileLocation),V=await this.getInstalled(void 0,r.profileLocation);for(const{gallery:B,manifest:X}of(0,L.distinct)(x,({gallery:J})=>J.identifier.id)){F=F||!!X.extensionDependencies?.some(Y=>(0,p.areSameExtensions)({id:Y},T.identifier));const J=f(B),G=this.j.get(J);if(G){if(this.z(T,G.task)){const Y=G.task.identifier;this.u.info("Waiting for already requested installing extension",Y.id,T.identifier.id),G.waitingTasks.push(T),y.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,H=>H.some($=>(0,p.areSameExtensions)($.identifier,Y)))).then(H=>{if(this.u.info("Finished waiting for already requested installing extension",Y.id,T.identifier.id),!H.find(Z=>(0,p.areSameExtensions)(Z.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else if(!V.some(({identifier:Y})=>(0,p.areSameExtensions)(Y,B.identifier))){const Y=this.Q(X,B,{...r,donotIncludePackAndDependencies:!0});this.j.set(J,{task:Y,waitingTasks:[T]}),this.l.fire({identifier:Y.identifier,source:B,profileLocation:r.profileLocation}),this.u.info("Installing extension:",Y.identifier.id,T.identifier.id),b.push({task:Y,manifest:X})}}}catch(x){if(w.URI.isUri(T.source))(0,L.isNonEmptyArray)(t.extensionDependencies)&&this.u.warn("Cannot install dependencies of extension:",T.identifier.id,x.message),(0,L.isNonEmptyArray)(t.extensionPack)&&this.u.warn("Cannot install packed extensions of extension:",T.identifier.id,x.message);else throw this.u.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),x}const j=b.reduce((x,{task:V,manifest:B})=>(x.set(V.identifier.id.toLowerCase(),{task:V,manifest:B}),x),new Map);for(;j.size;){let x;const V=[...j.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(X=>j.has(X.toLowerCase())));V.length?x=j.size===1?V:V.filter(({task:B})=>!(B===T&&!F)):(this.u.info("Found extensions with circular dependencies",V.map(({task:B})=>B.identifier.id)),x=[...j.values()]),await this.C(x.map(async({task:B})=>{const X=new Date().getTime();try{const J=await B.run();if(await this.C(this.q.map(G=>G.postInstall(J,B.source,r,l.CancellationToken.None))),!w.URI.isUri(B.source)){const G=B.operation===3,Y=G?void 0:(new Date().getTime()-B.source.lastUpdated)/1e3;if(n(this.t,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:Y}),I.isWeb&&B.operation!==3)try{await this.s.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}k.push({local:J,identifier:B.identifier,operation:B.operation,source:B.source,context:r.context,profileLocation:r.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw w.URI.isUri(B.source)||n(this.t,B.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-X,error:J}),this.u.error("Error while installing the extension:",B.identifier.id),J}finally{j.delete(B.identifier.id.toLowerCase())}}))}return y.length&&await this.C(y),k.forEach(({identifier:x})=>this.u.info("Extension installed successfully:",x.id)),this.m.fire(k),k.filter(({identifier:x})=>(0,p.areSameExtensions)(x,T.identifier))[0].local}catch(j){if(b.forEach(({task:x})=>x.cancel()),k.length)try{const x=await Promise.allSettled(k.map(({local:V})=>this.R(V,{versionOnly:!0,profileLocation:r.profileLocation}).run()));for(let V=0;V<x.length;V++){const B=x[V],{identifier:X}=k[V];B.status==="fulfilled"?this.u.info("Rollback: Uninstalled extension",X.id):this.u.warn("Rollback: Error while uninstalling extension",X.id,(0,O.getErrorMessage)(B.reason))}}catch(x){this.u.warn("Error while rolling back extensions",(0,O.getErrorMessage)(x),k.map(({identifier:V})=>V.id))}throw this.m.fire(b.map(({task:x})=>({identifier:x.identifier,operation:2,source:x.source,context:r.context,profileLocation:r.profileLocation}))),j}finally{for(const{task:j}of b)j.source&&!w.URI.isUri(j.source)&&this.j.delete(f(j.source))}}z(t,s){for(const[,{task:a,waitingTasks:r}]of this.j.entries())if(a===t&&(r.includes(s)||r.some(f=>this.z(f,s)))||a===s&&r[0]&&!this.z(t,r[0]))return!1;return!0}async C(t){const s=[],a=[],r=await Promise.allSettled(t);for(const f of r)f.status==="fulfilled"?s.push(f.value):a.push(f.reason);if(a.length)throw v(a);return s}async F(t,s,a,r,f){if(!this.s.isEnabled())return[];const b=await this.getInstalled(void 0,f),y=[],k=[],T=async(F,j)=>{y.push(F);const x=j.extensionDependencies||[],V=[...x];if(j.extensionPack){const B=a?b.find(X=>(0,p.areSameExtensions)(X.identifier,F)):void 0;for(const X of j.extensionPack)B&&B.manifest.extensionPack&&B.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:X}))||V.every(J=>!(0,p.areSameExtensions)({id:J},{id:X}))&&V.push(X)}if(V.length){const B=V.filter(X=>y.every(J=>!(0,p.areSameExtensions)(J,{id:X})));if(B.length){const X=await this.s.getExtensions(B.map(J=>({id:J,preRelease:r})),l.CancellationToken.None);for(const J of X){if(y.find(H=>(0,p.areSameExtensions)(H,J.identifier)))continue;const G=x.some(H=>(0,p.areSameExtensions)({id:H},J.identifier));let Y;try{Y=await this.G(J,!1,r)}catch(H){if(H instanceof S.ExtensionManagementError&&H.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!G){this.u.info("Skipping the packed extension as it cannot be installed",J.identifier.id);continue}else throw H}k.push({gallery:Y.extension,manifest:Y.manifest}),await T(Y.extension.identifier,Y.manifest)}}}};return await T(t,s),k}async G(t,s,a){if((await this.getExtensionsControlManifest()).malicious.some(y=>(0,p.areSameExtensions)(t.identifier,y)))throw new S.ExtensionManagementError(P.localize(1,null,t.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const y=await this.getTargetPlatform();throw new S.ExtensionManagementError(P.localize(2,null,t.identifier.id,this.v.nameLong,(0,S.TargetPlatformToString)(y)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const f=await this.H(t,s,a);if(f){if(a&&!s&&t.hasPreReleaseVersion&&!f.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(P.localize(3,null,t.identifier.id,this.v.nameLong,this.v.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&t.properties.isPreReleaseVersion&&(await this.s.getExtensions([t.identifier],l.CancellationToken.None))[0]?new S.ExtensionManagementError(P.localize(4,null,t.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(P.localize(5,null,t.identifier.id,this.v.nameLong,this.v.version),S.ExtensionManagementErrorCode.Incompatible);this.u.info("Getting Manifest...",f.identifier.id);const b=await this.s.getManifest(f,l.CancellationToken.None);if(b===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(b.version!==f.version)throw new S.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:f,manifest:b}}async H(t,s,a){const r=await this.getTargetPlatform();let f=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(f=(await this.s.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:r,compatible:!0},l.CancellationToken.None))[0]||null),!f&&await this.s.isExtensionCompatible(t,a,r)&&(f=t),f||(s?f=(await this.s.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:r,compatible:!0},l.CancellationToken.None))[0]||null:f=await this.s.getCompatibleExtension(t,a,r)),f}async I(t,s){const a={...s,profileLocation:t.isApplicationScoped?this.w.defaultProfile.extensionsResource:s.profileLocation??this.P()},r=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,f=this.k.get(r(t.identifier));if(f)return this.u.info("Extensions is already requested to uninstall",t.identifier.id),f.waitUntilTaskIsFinished();const b=F=>{const j=this.R(F,a);return this.k.set(r(j.extension.identifier),j),a.profileLocation?this.u.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.u.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),j},y=(F,j)=>{j?a.profileLocation?this.u.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),j.message):this.u.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,j.message):a.profileLocation?this.u.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.u.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),n(this.t,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(F),error:j}),this.p.fire({identifier:F.identifier,error:j?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},k=[],T=[];try{k.push(b(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.u.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const j=this.M(t,F);for(const x of j)this.k.has(r(x.identifier))?this.u.info("Extensions is already requested to uninstall",x.identifier.id):k.push(b(x))}a.donotCheckDependents?this.u.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(k.map(j=>j.extension),F,t),await this.C(k.map(async j=>{try{if(await j.run(),await this.C(this.q.map(x=>x.postUninstall(j.extension,a,l.CancellationToken.None))),j.extension.identifier.uuid)try{await this.s.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}y(j.extension)}catch(x){const V=x instanceof S.ExtensionManagementError?x:new S.ExtensionManagementError((0,O.getErrorMessage)(x),S.ExtensionManagementErrorCode.Internal);throw y(j.extension,V),V}finally{T.push(j)}}))}catch(F){const j=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,O.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);for(const x of k){try{x.cancel()}catch{}T.includes(x)||y(x.extension,j)}throw j}finally{for(const F of k)this.k.delete(r(F.extension.identifier))||this.u.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(t,s,a){for(const r of t){const f=this.N(r,s);if(f.length){const b=f.filter(y=>!t.some(k=>(0,p.areSameExtensions)(k.identifier,y.identifier)));if(b.length)throw new Error(this.L(r,b,a))}}}L(t,s,a){return a===t?s.length===1?P.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?P.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):P.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?P.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?P.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):P.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(t,s,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const r=t.manifest.extensionPack?t.manifest.extensionPack:[];if(r.length){const f=s.filter(y=>!y.isBuiltin&&r.some(k=>(0,p.areSameExtensions)({id:k},y.identifier))),b=[];for(const y of f)b.push(...this.M(y,s,a));return[...f,...b]}return[]}N(t,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(r=>(0,p.areSameExtensions)({id:r},t.identifier)))}async O(){try{this.u.trace("ExtensionManagementService.refreshReportedCache");const t=await this.s.getExtensionsControlManifest();return this.u.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.u.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=ye([K(0,S.IExtensionGalleryService),K(1,c.ITelemetryService),K(2,m.ILogService),K(3,E.IProductService),K(4,u.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function v(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=v;function D(i){if(i instanceof S.ExtensionManagementError)return i;const t=new S.ExtensionManagementError(i.message,S.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}function n(i,t,{extensionData:s,verificationStatus:a,duration:r,error:f,durationSinceUpdate:b}){let y,k;f&&(f instanceof S.ExtensionManagementError?(y=f.code,f.code===S.ExtensionManagementErrorCode.Signature&&(k=f.message)):y=S.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...s,verificationStatus:a,success:!f,duration:r,errorcode:y,errorcodeDetail:k,durationSinceUpdate:b})}class o{constructor(){this.d=new U.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,U.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,U.createCancelablePromise)(t=>new Promise((s,a)=>{const r=t.onCancellationRequested(()=>{r.dispose(),a(new O.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=o}),define(re[51],oe([0,1,6,16,2,3,37,11,29,33,14,5,9,18,30,12,10,19]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class g extends Error{constructor(i,t){super(i),this.code=t}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let v=class extends l.Disposable{constructor(i,t,s,a,r,f){super(),this.i=i,this.j=t,this.k=s,this.l=a,this.m=r,this.n=f,this.b=this.D(new O.Emitter),this.onAddExtensions=this.b.event,this.c=this.D(new O.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.D(new O.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.D(new O.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new N.ResourceMap}scanProfileExtensions(i,t){return this.p(i,void 0,t)}async addExtensionsToProfile(i,t){const s=[],a=[];try{return await this.p(t,r=>{const f=[];for(const b of r)i.some(([y])=>(0,w.areSameExtensions)(y.identifier,b.identifier)&&y.manifest.version!==b.version)?s.push(b):f.push(b);for(const[b,y]of i)if(!f.some(k=>(0,w.areSameExtensions)(k.identifier,b.identifier)&&k.version===b.manifest.version)){const k={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:y};a.push(k),f.push(k)}return a.length&&this.b.fire({extensions:a,profileLocation:t}),s.length&&this.f.fire({extensions:s,profileLocation:t}),f}),a.length&&this.c.fire({extensions:a,profileLocation:t}),s.length&&this.g.fire({extensions:s,profileLocation:t}),a}catch(r){throw a.length&&this.c.fire({extensions:a,error:r,profileLocation:t}),s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async updateMetadata(i,t){const s=[];return await this.p(t,a=>{const r=[];for(const f of a){const b=i.find(([y])=>(0,w.areSameExtensions)(y.identifier,f.identifier)&&y.manifest.version===f.version);b&&(f.metadata={...f.metadata,...b[1]},s.push(f)),r.push(f)}return r}),s}async removeExtensionFromProfile(i,t){const s=[];this.f.fire({extensions:s,profileLocation:t});try{await this.p(t,a=>{const r=[];for(const f of a)(0,w.areSameExtensions)(f.identifier,i.identifier)?s.push(f):r.push(f);return s.length&&this.f.fire({extensions:s,profileLocation:t}),r}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(a){throw s.length&&this.g.fire({extensions:s,error:a,profileLocation:t}),a}}async p(i,t,s){return this.v(i).queue(async()=>{let a=[],r;try{const f=await this.j.readFile(i);r=JSON.parse(f.value.toString().trim()||"[]")}catch(f){if((0,P.toFileOperationResult)(f)!==1)throw f;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(r=await this.u()),!r&&s?.bailOutWhenFileNotFound)throw new g((0,c.getErrorMessage)(f),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.q(i);let f=!1;for(const b of r){D(b)||this.q(i);let y;if((0,E.isString)(b.relativeLocation)&&b.relativeLocation)y=this.s(b.relativeLocation);else if((0,E.isString)(b.location))y=this.s(b.location),f=!0,b.relativeLocation=b.location,b.location=y.toJSON();else{y=R.URI.revive(b.location);const k=this.r(y);k&&(f=!0,b.relativeLocation=k)}a.push({identifier:b.identifier,location:y,version:b.version,metadata:b.metadata})}f&&await this.j.writeFile(i,U.VSBuffer.fromString(JSON.stringify(r)))}if(t){a=t(a);const f=a.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.r(b.location),metadata:b.metadata}));await this.j.writeFile(i,U.VSBuffer.fromString(JSON.stringify(f)))}return a})}q(i){const t=new g(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}r(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}s(i){return this.l.extUri.joinPath(this.i,i)}async u(){return this.t||(this.t=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),t=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(i)).value.toString()}catch(r){if((0,P.toFileOperationResult)(r)===1)return;throw r}this.n.info("Migrating extensions from old default profile location",i.toString());let a;try{const r=JSON.parse(s);Array.isArray(r)&&r.every(f=>D(f))?a=r:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",r)}catch(r){this.n.error(r)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(r){if((0,P.toFileOperationResult)(r)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw r}try{await this.j.del(i)}catch(r){(0,P.toFileOperationResult)(r)!==1&&this.n.error(r)}try{await this.j.del(t)}catch(r){(0,P.toFileOperationResult)(r)!==1&&this.n.error(r)}return a})()),this.t}v(i){let t=this.h.get(i);return t||(t=new L.Queue,this.h.set(i,t)),t}};v=ye([K(1,P.IFileService),K(2,d.IUserDataProfilesService),K(3,m.IUriIdentityService),K(4,u.ITelemetryService),K(5,p.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function D(o){return(0,E.isObject)(o)&&(0,I.isIExtensionIdentifier)(o.identifier)&&(n(o.location)||(0,E.isString)(o.location)&&o.location)&&((0,E.isUndefined)(o.relativeLocation)||(0,E.isString)(o.relativeLocation))&&o.version&&(0,E.isString)(o.version)}function n(o){return o?(0,E.isString)(o.path)&&(0,E.isString)(o.scheme):!1}}),define(re[78],oe([0,1,21,6,32,16,10,35,140,2,22,13,4,23,55,90,12,11,164,15,33,46,67,14,5,9,26,3,91,51,18,30,198]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D,n,o,i,t,s,a,r,f,b,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(J){function G(Y,H){if(Y===H)return!0;const $=Object.keys(Y),Z=new Set;for(const ie of Object.keys(H))Z.add(ie);if($.length!==Z.size)return!1;for(const ie of $){if(Y[ie]!==H[ie])return!1;Z.delete(ie)}return Z.size===0}J.equals=G})(T=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let F=class extends w.Disposable{constructor(G,Y,H,$,Z,ie,se,ae,q,C,A,M){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Y,this.l=H,this.m=$,this.n=Z,this.p=ie,this.q=se,this.r=ae,this.s=q,this.t=C,this.u=A,this.v=M,this.g=this.D(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.D(this.v.createInstance(V,(0,d.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.D(this.v.createInstance(V,(0,d.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.D(this.v.createInstance(x,this.h)),this.y=void 0,this.D(this.i.onDidChangeCache(()=>this.g.fire(0))),this.D(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.w||(this.w=(0,v.computeTargetPlatform)(this.q,this.r)),this.w}async scanAllExtensions(G,Y,H){const[$,Z]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Y)]),ie=H?await this.scanExtensionsUnderDevelopment(G,[...$,...Z]):[];return this.F($,Z,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Y=[];Y.push(this.G(!!G.useCache,G.language)),Y.push(this.H(G.language,!!G.checkControlFile));const[H,$]=await Promise.all(Y);return this.C([...H,...$],0,G,!1)}async scanUserExtensions(G){const Y=G.profileLocation??this.userExtensionsLocation;this.r.trace("Started scanning user extensions",Y);const H=this.u.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(Y,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,H),Z=G.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let ie;try{ie=await Z.scanExtensions($)}catch(se){if(se instanceof f.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.z(),ie=await Z.scanExtensions($);else throw se}return ie=await this.C(ie,1,G,!0),this.r.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(G,Y){if(this.s.isExtensionDevelopment&&this.s.extensionDevelopmentLocationURI){const H=(await Promise.all(this.s.extensionDevelopmentLocationURI.filter($=>$.scheme===P.Schemas.file).map(async $=>{const Z=await this.J($,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Z)).map(se=>(se.type=Y.find(ae=>(0,v.areSameExtensions)(ae.identifier,se.identifier))?.type??se.type,this.k.validate(se,Z)))}))).flat();return this.C(H,"development",G,!0)}return[]}async scanExistingExtension(G,Y,H){const $=await this.J(G,!1,Y,!0,H.language,!0,void 0),Z=await this.k.scanExtension($);return!Z||!H.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(G,Y,H){const $=await this.J(G,!1,Y,!0,H.language,!0,void 0),Z=await this.k.scanOneOrMultipleExtensions($);return this.C(Z,Y,H,!0)}async scanMetadata(G){const Y=(0,d.joinPath)(G,"package.json"),H=(await this.q.readFile(Y)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(G,Y){const H=(0,d.joinPath)(G,"package.json"),$=(await this.q.readFile(H)).value.toString(),Z=JSON.parse($);Y.isMachineScoped=Y.isMachineScoped||void 0,Y.isBuiltin=Y.isBuiltin||void 0,Z.__metadata={...Z.__metadata,...Y},await this.q.writeFile((0,d.joinPath)(G,"package.json"),O.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof f.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.z();else throw G}}async z(){return this.y||(this.y=(async()=>{try{this.r.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.p.addExtensionsToProfile(G.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.q.createFile(this.n.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.r.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(Y))}this.r.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.r.error(G)}finally{this.y=void 0}})()),this.y}async C(G,Y,H,$){return H.includeAllVersions||(G=this.F(Y===0?G:void 0,Y===1?G:void 0,Y==="development"?G:void 0,await this.getTargetPlatform(),$)),H.includeInvalid||(G=G.filter(Z=>Z.isValid)),G.sort((Z,ie)=>{const se=S.basename(Z.location.fsPath),ae=S.basename(ie.location.fsPath);return se<ae?-1:se>ae?1:0})}F(G,Y,H,$,Z){const ie=(ae,q,C)=>{if(ae.isValid&&!q.isValid)return!1;if(ae.isValid===q.isValid){if(Z&&m.gt(ae.manifest.version,q.manifest.version))return this.r.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(m.eq(ae.manifest.version,q.manifest.version)){if(ae.type===0)return this.r.debug(`Skipping extension ${q.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===$)return this.r.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return C?this.r.warn(`Overwriting user extension ${ae.location.path} with ${q.location.path}.`):this.r.debug(`Overwriting user extension ${ae.location.path} with ${q.location.path}.`),!0},se=new D.ExtensionIdentifierMap;return G?.forEach(ae=>{const q=se.get(ae.identifier.id);(!q||ie(q,ae,!1))&&se.set(ae.identifier.id,ae)}),Y?.forEach(ae=>{const q=se.get(ae.identifier.id);if(!q&&G&&ae.type===0){this.r.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!q||ie(q,ae,!1))&&se.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const q=se.get(ae.identifier.id);(!q||ie(q,ae,!0))&&se.set(ae.identifier.id,ae),se.set(ae.identifier.id,ae)}),[...se.values()]}async G(G,Y){this.r.trace("Started scanning system extensions");const H=await this.J(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),Z=await(G&&!H.devMode?this.i:this.k).scanExtensions(H);return this.r.trace("Scanned system extensions:",Z.length),Z}async H(G,Y){const H=this.s.isBuilt?[]:this.t.builtInExtensions;if(!H?.length)return[];this.r.trace("Started scanning dev system extensions");const $=Y?await this.I():{},Z=[],ie=u.URI.file(S.normalize(S.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const q=$[ae.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":Z.push((0,d.joinPath)(ie,ae.name));break;default:Z.push(u.URI.file(q));break}}const se=await Promise.all(Z.map(async ae=>this.k.scanExtension(await this.J(ae,!1,0,!0,G,!0,void 0))));return this.r.trace("Scanned dev system extensions:",se.length),(0,L.coalesce)(se)}async I(){try{const G=await this.q.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async J(G,Y,H,$,Z,ie,se){const ae=await this.f(Z??p.language),q=await this.L(G),C=Y&&!this.u.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,A=C?await this.L(C):void 0;return new j(G,q,C,A,Y,se,H,$,ie,this.t.version,this.t.date,this.t.commit,!this.s.isBuilt,Z,ae)}async L(G){try{const Y=await this.q.stat(G);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};F=ye([K(4,b.IUserDataProfilesService),K(5,f.IExtensionsProfileScannerService),K(6,o.IFileService),K(7,t.ILogService),K(8,g.IEnvironmentService),K(9,s.IProductService),K(10,y.IUriIdentityService),K(11,i.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class j{constructor(G,Y,H,$,Z,ie,se,ae,q,C,A,M,z,_,W){this.location=G,this.mtime=Y,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=$,this.profile=Z,this.profileScanOptions=ie,this.type=se,this.excludeObsolete=ae,this.validate=q,this.productVersion=C,this.productDate=A,this.productCommit=M,this.devMode=z,this.language=_,this.translations=W}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Y){return(0,d.isEqual)(G.location,Y.location)&&G.mtime===Y.mtime&&(0,d.isEqual)(G.applicationExtensionslocation,Y.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&G.profile===Y.profile&&l.equals(G.profileScanOptions,Y.profileScanOptions)&&G.type===Y.type&&G.excludeObsolete===Y.excludeObsolete&&G.validate===Y.validate&&G.productVersion===Y.productVersion&&G.productDate===Y.productDate&&G.productCommit===Y.productCommit&&G.devMode===Y.devMode&&G.language===Y.language&&T.equals(G.translations,Y.translations)}}e.ExtensionScannerInput=j;let x=class extends w.Disposable{constructor(G,Y,H,$,Z){super(),this.f=G,this.g=Y,this.h=H,this.i=$,this.j=Z}async scanExtensions(G){const Y=G.profile?await this.l(G):await this.k(G);let H={};if(G.excludeObsolete&&G.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();H=JSON.parse($)}catch{}return(0,c.isEmptyObject)(H)?Y:Y.filter($=>!H[v.ExtensionKey.create($).toString()])}async k(G){const Y=await this.i.resolve(G.location);if(!Y.children?.length)return[];const H=await Promise.all(Y.children.map(async $=>{if(!$.isDirectory||G.type===1&&(0,d.basename)($.resource).indexOf(".")===0)return null;const Z=new j($.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(Z)}));return(0,L.coalesce)(H).sort(($,Z)=>$.location.path<Z.location.path?-1:1)}async l(G){let Y=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){Y=Y.filter($=>!$.metadata?.isApplicationScoped);const H=await this.m(G.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,G);Y.push(...H)}return Y}async m(G,Y,H){const $=await this.g.scanProfileExtensions(G,H.profileScanOptions);if(!$.length)return[];const Z=await Promise.all($.map(async ie=>{if(Y(ie)){const se=new j(ie.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(se,ie.metadata)}return null}));return(0,L.coalesce)(Z)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,d.joinPath)(G.location,"package.json"))){const Y=await this.scanExtension(G);return Y?[Y]:[]}else return await this.scanExtensions(G)}catch(Y){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,N.getErrorMessage)(Y)),[]}}async scanExtension(G,Y){try{let H=await this.scanExtensionManifest(G.location);if(H){H.publisher||(H.publisher=D.UNDEFINED_PUBLISHER),Y=Y??H.__metadata,delete H.__metadata;const $=(0,v.getGalleryExtensionId)(H.publisher,H.name),Z=Y?.id?{id:$,uuid:Y.id}:{id:$},ie=Y?.isSystem?0:G.type,se=ie===0||!!Y?.isBuiltin;H=await this.n(G.location,H,j.createNlsConfiguration(G));const ae={type:ie,identifier:Z,manifest:H,location:G.location,isBuiltin:se,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return G.validate?this.validate(ae,G):ae}}catch(H){G.type!==0&&this.j.error(H)}return null}validate(G,Y){let H=!0;const $=(0,n.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,G.manifest,G.isBuiltin);for(const[Z,ie]of $)Z===E.default.Error&&(H=!1,this.j.error(this.s(Y.location,ie)));return G.isValid=H,G.validations=$,G}async scanExtensionManifest(G){const Y=(0,d.joinPath)(G,"package.json");let H;try{H=(await this.i.readFile(Y)).value.toString()}catch(Z){return(0,o.toFileOperationResult)(Z)!==1&&this.j.error(this.s(G,(0,h.localize)(0,null,Y.path,Z.message))),null}let $;try{$=JSON.parse(H)}catch{const ie=[];(0,R.parse)(H,ie);for(const se of ie)this.j.error(this.s(G,(0,h.localize)(1,null,Y.path,se.offset,se.length,(0,I.getParseErrorMessage)(se.error))));return null}return(0,R.getNodeType)($)!=="object"?(this.j.error(this.s(G,(0,h.localize)(2,null,Y.path))),null):$}async n(G,Y,H){const $=await this.p(G,Y,H);if($)try{const Z=[],ie=await this.q($.default,Z);if(Z.length>0)return Z.forEach(ae=>{this.j.error(this.s(G,(0,h.localize)(3,null,$.default?.path,(0,I.getParseErrorMessage)(ae.error))))}),Y;if((0,R.getNodeType)($)!=="object")return this.j.error(this.s(G,(0,h.localize)(4,null,$.default?.path))),Y;const se=$.values||Object.create(null);return(0,k.localizeManifest)(Y,se,ie)}catch{}return Y}async p(G,Y,H){const $=(0,d.joinPath)(G,"package.nls.json"),Z=(q,C)=>{C.forEach(A=>{this.j.error(this.s(G,(0,h.localize)(5,null,q?.path,(0,I.getParseErrorMessage)(A.error))))})},ie=q=>{this.j.error(this.s(G,(0,h.localize)(6,null,q?.path)))},se=`${Y.publisher}.${Y.name}`,ae=H.translations[se];if(ae)try{const q=u.URI.file(ae),C=(await this.i.readFile(q)).value.toString(),A=[],M=(0,R.parse)(C,A);return A.length>0?(Z(q,A),{values:void 0,default:$}):(0,R.getNodeType)(M)!=="object"?(ie(q),{values:void 0,default:$}):{values:M.contents?M.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let C;try{C=await this.r(G,H)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const A=(await this.i.readFile(C.localized)).value.toString(),M=[],z=(0,R.parse)(A,M);return M.length>0?(Z(C.localized,M),{values:void 0,default:C.original}):(0,R.getNodeType)(z)!=="object"?(ie(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async q(G,Y){if(G)try{const H=(await this.i.readFile(G)).value.toString();return(0,R.parse)(H,Y)}catch{}}r(G,Y){return new Promise((H,$)=>{const Z=ie=>{const se=(0,d.joinPath)(G,`package.nls.${ie}.json`);this.i.exists(se).then(ae=>{ae&&H({localized:se,original:(0,d.joinPath)(G,"package.nls.json")});const q=ie.lastIndexOf("-");q===-1?H({localized:(0,d.joinPath)(G,"package.nls.json"),original:null}):(ie=ie.substring(0,q),Z(ie))})};if(Y.devMode||Y.pseudo||!Y.language)return H({localized:(0,d.joinPath)(G,"package.nls.json"),original:null});Z(Y.language)})}s(G,Y){return`[${G.path}]: ${Y}`}};x=ye([K(1,f.IExtensionsProfileScannerService),K(2,y.IUriIdentityService),K(3,o.IFileService),K(4,t.ILogService)],x);let V=class extends x{constructor(G,Y,H,$,Z,ie){super(Y,H,$,Z,ie),this.w=G,this.u=this.D(new U.ThrottledDelayer(3e3)),this.v=this.D(new a.Emitter),this.onDidChangeCache=this.v.event}async scanExtensions(G){const Y=await this.y();if(this.t=G,Y&&Y.input&&j.equals(Y.input,this.t))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.u.trigger(()=>this.C()),Y.result.map($=>($.location=u.URI.revive($.location),$));const H=await super.scanExtensions(G);return await this.z({input:G,result:H}),H}async y(){try{const G=await this.i.readFile(this.w),Y=JSON.parse(G.value.toString());return{result:Y.result,input:(0,r.revive)(Y.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",this.w.path,(0,N.getErrorMessage)(G))}return null}async z(G){try{await this.i.writeFile(this.w,O.VSBuffer.fromString(JSON.stringify(G)))}catch(Y){this.j.debug("Error while writing the extension cache file:",this.w.path,(0,N.getErrorMessage)(Y))}}async C(){if(!this.t)return;const G=await this.y();if(!G)return;const Y=G.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.t)));if(!l.equals(H,Y))try{this.j.info("Invalidating Cache",Y,H),await this.i.del(this.w),this.v.fire()}catch($){this.j.error($)}}};V=ye([K(2,f.IExtensionsProfileScannerService),K(3,y.IUriIdentityService),K(4,o.IFileService),K(5,t.ILogService)],V);function B(J,G){const Y=(0,v.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:Y,identifier:new D.ExtensionIdentifier(Y),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:G,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=B;class X extends F{constructor(G,Y,H,$,Z,ie,se,ae,q,C,A,M){super(G,Y,(0,d.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)($,D.MANIFEST_CACHE_FOLDER),Z,ie,se,ae,q,C,A,M),this.M=(async()=>{if(p.translationsConfigFile)try{const z=await this.q.readFile(u.URI.file(p.translationsConfigFile));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(G){return this.M}}e.NativeExtensionsScannerService=X}),define(re[271],oe([0,1,50,6,38,3,2,22,13,28,9,18]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends N.Disposable{constructor(m,E){super(),this.b=m,this.f=E,this.a=new U.Limiter(5)}async postUninstall(m){const E=this.g(m,"uninstall");E&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(E.script,"uninstall",E.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(c)}}));try{await w.Promises.rm(this.j(m))}catch(c){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(c)}}g(m,E){const c=`vscode:${E}`;if(m.location.scheme===R.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[c]=="string"){const u=m.manifest.scripts[c].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${c} should be a node script`),null):{script:(0,I.join)(m.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(m,E,c,u,h){return new Promise((g,v)=>{const D=this.i(m,E,c,h);let n;const o=i=>{n&&(clearTimeout(n),n=null),i?v(i):g(void 0)};D.on("error",i=>{o((0,l.toErrorMessage)(i)||"Unknown")}),D.on("exit",(i,t)=>{o(i?`post-${E} process exited with code ${i}`:void 0)}),u&&(n=setTimeout(()=>{n=null,D.kill(),v("timed out")},5e3))})}i(m,E,c,u){const h={silent:!0,execArgv:void 0},g=(0,L.fork)(m,[`--type=extension-post-${E}`,...c],h);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const v=O.Event.fromNodeEventEmitter(g.stdout,"data"),D=O.Event.fromNodeEventEmitter(g.stderr,"data");v(i=>this.f.info(u.identifier.id,u.manifest.version,`post-${E}`,i)),D(i=>this.f.error(u.identifier.id,u.manifest.version,`post-${E}`,i));const n=O.Event.any(O.Event.map(v,i=>({data:`%c${i}`,format:[""]})),O.Event.map(D,i=>({data:`%c${i}`,format:["color: red"]})));return O.Event.debounce(n,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}j(m){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};p=ye([K(0,S.IUserDataProfilesService),K(1,P.ILogService)],p),e.ExtensionsLifecycle=p}),define(re[272],oe([0,1,9,18,30,19,51,14,15,11]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends N.AbstractExtensionsProfileScannerService{constructor(p,d,m,E,c,u){super(w.URI.file(p.extensionsPath),d,m,E,c,u)}};P=ye([K(0,I.INativeEnvironmentService),K(1,R.IFileService),K(2,U.IUserDataProfilesService),K(3,l.IUriIdentityService),K(4,O.ITelemetryService),K(5,L.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(re[273],oe([0,1,11,15,51,78,14,5,9,26,30,18]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends O.NativeExtensionsScannerService{constructor(m,E,c,u,h,g,v,D){super(L.URI.file(h.builtinExtensionsPath),L.URI.file(h.extensionsPath),h.userHome,L.URI.file(h.userDataPath),m,E,c,u,h,g,v,D)}};p=ye([K(0,S.IUserDataProfilesService),K(1,l.IExtensionsProfileScannerService),K(2,N.IFileService),K(3,I.ILogService),K(4,U.INativeEnvironmentService),K(5,w.IProductService),K(6,P.IUriIdentityService),K(7,R.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(re[20],oe([0,1,6,3,2,104,12,66,5,18]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function d(h){const g=h.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=d;class m extends l.Disposable{constructor(g={flushInterval:m.a}){super(),this.j=g,this.b=this.D(new U.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.D(new U.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.D(new U.Emitter),this.onWillSaveState=this.f.event,this.h=this.D(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.D(new l.MutableDisposable),this.u=void 0,this.w=void 0,this.z=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,v){if(v===e.TARGET_KEY){switch(g){case-1:this.z=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:v,target:this.F(g)[v]})}q(g){this.f.fire({reason:g})}get(g,v,D){return this.L(v)?.get(g,D)}getBoolean(g,v,D){return this.L(v)?.getBoolean(g,D)}getNumber(g,v,D){return this.L(v)?.getNumber(g,D)}store(g,v,D,n){if((0,N.isUndefinedOrNull)(v)){this.remove(g,D);return}this.r(()=>{this.t(g,D,n),this.L(D)?.set(g,v)})}remove(g,v){this.r(()=>{this.t(g,v,void 0),this.L(v)?.delete(g)})}r(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,v){const D=[],n=this.F(g);for(const o of Object.keys(n))n[o]===v&&D.push(o);return D}t(g,v,D){const n=this.F(v);typeof D=="number"?n[g]!==D&&(n[g]=D,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get C(){return this.z||(this.z=this.G(-1)),this.z}F(g){switch(g){case-1:return this.C;case 0:return this.y;default:return this.v}}G(g){const v=this.L(g);return v?d(v):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this.f.fire({reason:g});const v=this.L(-1),D=this.L(0),n=this.L(1);switch(g){case P.NONE:await L.Promises.settled([v?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([v?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return u(g,v,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,v){return this.q(P.NONE),(0,w.isUserDataProfile)(g)?this.N(g,v):this.O(g,v)}H(g,v){return!(g.id===v.id||E(v)&&E(g))}I(g,v,D,n){this.r(()=>{if(n)for(const[o,i]of g)v.set(o,i);else{const o=new Set;for(const[i,t]of g)o.add(i),v.get(i)!==t&&this.n(D,i);for(const[i]of v.items)o.has(i)||this.n(D,i)}})}}m.a=60*1e3,e.AbstractStorageService=m;function E(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class c extends m{constructor(){super(),this.p=this.D(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.D(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.D(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.D(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.D(this.P.onDidChangeStorage(g=>this.n(0,g))),this.D(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=c;async function u(h,g,v,D,n,o){const i=T=>{try{return JSON.parse(T)}catch{return T}},t=new Map,s=new Map;h.forEach((T,F)=>{t.set(F,T),s.set(F,i(T))});const a=new Map,r=new Map;g.forEach((T,F)=>{a.set(F,T),r.set(F,i(T))});const f=new Map,b=new Map;v.forEach((T,F)=>{f.set(F,T),b.set(F,i(T))}),console.group(D!==n?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const y=[];if(t.forEach((T,F)=>{y.push({key:F,value:T})}),console.table(y),console.groupEnd(),console.log(s),D!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const T=[];a.forEach((F,j)=>{T.push({key:j,value:F})}),console.table(T),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${o})`);const k=[];f.forEach((T,F)=>{k.push({key:F,value:T})}),console.table(k),console.groupEnd(),console.log(b)}e.logStorage=u}),define(re[120],oe([0,1,3,2,12,29,33,20]),function(te,e,L,U,l,O,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends U.Disposable{constructor(S,p){super(),this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.D(new w(S)),this.D(this.b.onDidChange(d=>this.a.fire({extensions:d,source:"storage"}))),this.D(p.onDidInstallExtensions(d=>d.forEach(({local:m,operation:E})=>{m&&E===4&&this.f(m.identifier)})))}async enableExtension(S,p){return this.f(S)?(this.a.fire({extensions:[S],source:p}),!0):!1}async disableExtension(S,p){return this.c(S)?(this.a.fire({extensions:[S],source:p}),!0):!1}getDisabledExtensions(){return this.h(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const p=this.getDisabledExtensions();return p.every(d=>!(0,N.areSameExtensions)(d,S))?(p.push(S),this.g(p),!0):!1}f(S){const p=this.getDisabledExtensions();for(let d=0;d<p.length;d++){const m=p[d];if((0,N.areSameExtensions)(m,S))return p.splice(d,1),this.g(p),!0}return!1}g(S){this.i(O.DISABLED_EXTENSIONS_STORAGE_PATH,S)}h(S){return this.b.get(S,0)}i(S,p){this.b.set(S,p,0)}};I=ye([K(0,R.IStorageService),K(1,O.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class w extends U.Disposable{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.D(new L.Emitter),this.onDidChange=this.b.event,this.D(S.onDidChangeValue(p=>this.f(p)))}get(S,p){let d;return p===0?((0,l.isUndefinedOrNull)(this.a[S])&&(this.a[S]=this.g(S,p)),d=this.a[S]):d=this.g(S,p),JSON.parse(d)}set(S,p,d){const m=JSON.stringify(p.map(({id:c,uuid:u})=>({id:c,uuid:u})));this.g(S,d)!==m&&(d===0&&(p.length?this.a[S]=m:delete this.a[S]),this.h(S,p.length?m:void 0,d))}f(S){if(S.scope===0&&!(0,l.isUndefinedOrNull)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const d=this.get(S.key,S.scope);delete this.a[S.key];const m=this.get(S.key,S.scope),E=d.filter(u=>!m.some(h=>(0,N.areSameExtensions)(u,h))),c=m.filter(u=>!d.some(h=>(0,N.areSameExtensions)(h,u)));(E.length||c.length)&&this.b.fire([...E,...c])}}g(S,p){return this.c.get(S,p,"[]")}h(S,p,d){p?this.c.store(S,p,d,1):this.c.remove(S,d)}}e.StorageManager=w}),define(re[274],oe([0,1,21,25,10,4,36,12,11,17,15,29,33,67,14,9,26,59,241,20,19]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const D=O.isWeb?"web":(0,S.getTargetPlatform)(O.platform,N.arch),n="X-Market-Search-Activity-Id";var o;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished",C[C.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function i(...C){return String(C.reduce((A,M)=>A|M,0))}var t;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class b{constructor(A=f){this.d=A}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(A,M=this.d.pageSize){return new b({...this.d,pageNumber:A,pageSize:M})}withFilter(A,...M){const z=[...this.d.criteria,...M.length?M.map(_=>({filterType:A,value:_})):[{filterType:A}]];return new b({...this.d,criteria:z})}withSortBy(A){return new b({...this.d,sortBy:A})}withSortOrder(A){return new b({...this.d,sortOrder:A})}withFlags(...A){return new b({...this.d,flags:A.reduce((M,z)=>M|z,0)})}withAssetTypes(...A){return new b({...this.d,assetTypes:A})}withSource(A){return new b({...this.d,source:A})}get raw(){const{criteria:A,pageNumber:M,pageSize:z,sortBy:_,sortOrder:W,flags:Q,assetTypes:ee}=this.d;return{filters:[{criteria:A,pageNumber:M,pageSize:z,sortBy:_,sortOrder:W}],assetTypes:ee,flags:Q}}get searchText(){const A=this.d.criteria.filter(M=>M.filterType===t.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(A=>String(A.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(C,A){const M=(C||[]).filter(z=>z.statisticName===A)[0];return M?M.value:0}function k(C){const A="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(z=>z.assetType.indexOf(A)===0).reduce((z,_)=>{const W=j(C,_.assetType);return W&&z.push([_.assetType.substring(A.length),W]),z},[])}function T(C){if(C.properties){const A=C.properties.filter(_=>_.key===s.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=A.filter(_=>M.test(_.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return j(C,s.Repository)}function F(C){return{uri:`${C.fallbackAssetUri}/${s.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${s.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function j(C,A){return C.files.filter(z=>z.assetType===A)[0]?{uri:`${C.assetUri}/${A}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${A}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}:null}function x(C,A){const M=C.properties?C.properties.filter(_=>_.key===A):[],z=M.length>0&&M[0].value;return z?z.split(",").map(_=>(0,p.adoptToGalleryExtensionId)(_)):[]}function V(C){const A=C.properties?C.properties.filter(M=>M.key===a.Engine):[];return A.length>0&&A[0].value||""}function B(C){const A=C.properties?C.properties.filter(M=>M.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function X(C){const A=C.properties?C.properties.filter(z=>z.key===a.LocalizedLanguages):[],M=A.length>0&&A[0].value||"";return M?M.split(","):[]}function J(C){return C.properties?.find(A=>A.key===a.SponsorLink)?.value}function G(C){return C.indexOf("preview")!==-1}function Y(C){return C.targetPlatform?(0,S.toTargetPlatform)(C.targetPlatform):"undefined"}function H(C){const A=(0,L.distinct)(C.versions.map(Y)),M=!!C.tags?.includes(S.WEB_EXTENSION_TAG),z=A.indexOf("web");return M?z===-1&&A.push("web"):z!==-1&&A.splice(z,1),A}function $(C,A){const M=(0,S.getFallbackTargetPlarforms)(A);for(let z=0;z<C.length;z++){const _=C[z];if(_.version===C[z-1]?.version){let W=z;const Q=Y(_);if(Q===A)for(;W>0&&C[W-1].version===_.version;)W--;else if(M.includes(Q))for(;W>0&&C[W-1].version===_.version&&Y(C[W-1])!==A;)W--;W!==z&&(C.splice(z,1),C.splice(W,0,_))}}return C}e.sortExtensionVersions=$;function Z(C,A,M){C.telemetryData={index:A,querySource:M,queryActivityId:C.queryContext?.[n]}}function ie(C,A,M,z){const _=C.versions[0],W={manifest:j(A,s.Manifest),readme:j(A,s.Details),changelog:j(A,s.Changelog),license:j(A,s.License),repository:T(A),download:F(A),icon:j(A,s.Icon),signature:j(A,s.Signature),coreTranslations:k(A)};return{identifier:{id:(0,p.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:A.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(_),description:C.shortDescription||"",installCount:y(C.statistics,"install"),rating:y(C.statistics,"averagerating"),ratingCount:y(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:M,assets:W,properties:{dependencies:x(A,a.Dependency),extensionPack:x(A,a.ExtensionPack),engine:V(A),localizedLanguages:X(A),targetPlatform:Y(A),isPreReleaseVersion:B(A)},hasPreReleaseVersion:B(_),hasReleaseVersion:!0,preview:G(C.flags),isSigned:!!W.signature,queryContext:z}}let se=class{constructor(A,M,z,_,W,Q,ee,le){this.k=M,this.l=z,this.n=_,this.o=W,this.q=Q,this.u=ee,this.w=le;const he=ee.extensionsGallery,pe=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=pe?he.servicePPEUrl:he?.serviceUrl,this.g=pe?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,h.resolveMarketplaceHeaders)(ee.version,ee,this.n,this.w,this.q,A,this.o)}x(A=""){return`${this.d}${A}`}isEnabled(){return!!this.d}async getExtensions(A,M,z){const _=U.CancellationToken.isCancellationToken(M)?{}:M,W=U.CancellationToken.isCancellationToken(M)?M:z,Q=[],ee=[],le=[],he=[];let pe=!0;for(const Ce of A){Ce.uuid?ee.push(Ce.uuid):Q.push(Ce.id);const Re=!!(Ce.version||Ce.preRelease);le.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Re}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),pe=pe&&!!Ce.hasPreRelease&&!Re}if(!ee.length&&!Q.length)return[];let de=new b().withPage(1,A.length);ee.length&&(de=de.withFilter(t.ExtensionId,...ee)),Q.length&&(de=de.withFilter(t.ExtensionName,...Q)),(_.queryAllVersions||pe)&&(de=de.withFlags(de.flags,o.IncludeVersions)),_.source&&(de=de.withSource(_.source));const{extensions:be}=await this.z(de,{targetPlatform:_.targetPlatform??D,includePreRelease:le,versions:he,compatible:!!_.compatible},W);return _.source&&be.forEach((Ce,Re)=>Z(Ce,Re,_.source)),be}async getCompatibleExtension(A,M,z){if((0,S.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(A,M,z))return A;const _=new b().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,A.identifier.uuid),{extensions:W}=await this.z(_,{targetPlatform:z,compatible:!0,includePreRelease:M},U.CancellationToken.None);return W[0]||null}async isExtensionCompatible(A,M,z){if(!(0,S.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,z)||!M&&A.properties.isPreReleaseVersion)return!1;let _=A.properties.engine;if(!_){const W=await this.getManifest(A,U.CancellationToken.None);if(!W)throw new Error("Manifest was not found");_=W.engines.vscode}return(0,d.isEngineValid)(_,this.u.version,this.u.date)}async y(A,M,z,_,W){if(!(0,S.isTargetPlatformCompatible)(Y(A),_,W)||M!=="any"&&B(A)!==(M==="prerelease"))return!1;if(z)try{const Q=await this.E(A);if(!(0,d.isEngineValid)(Q,this.u.version,this.u.date))return!1}catch(Q){return this.l.error(`Error while getting the engine for the version ${A.version}.`,(0,l.getErrorMessage)(Q)),!1}return!0}async query(A,M){let z=A.text||"";const _=A.pageSize??50;let W=new b().withPage(1,_);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,de,be)=>(W=W.withFilter(t.Category,be||de),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,de,be)=>(W=W.withFilter(t.Tag,be||de),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(t.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),W=W.withFilter(t.SearchText,z)),W=W.withSortBy(0)):A.ids?W=W.withFilter(t.ExtensionId,...A.ids):A.names?W=W.withFilter(t.ExtensionName,...A.names):W=W.withSortBy(4),typeof A.sortBy=="number"&&(W=W.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(W=W.withSortOrder(A.sortOrder)),A.source&&(W=W.withSource(A.source));const Q=async(pe,de)=>{const{extensions:be,total:Ce}=await this.z(pe,{targetPlatform:D,compatible:!1,includePreRelease:!!A.includePreRelease},de);return be.forEach((Re,ke)=>Z(Re,(pe.pageNumber-1)*pe.pageSize+ke,A.source)),{extensions:be,total:Ce}},{extensions:ee,total:le}=await Q(W,M),he=async(pe,de)=>{if(de.isCancellationRequested)throw new l.CancellationError;const{extensions:be}=await Q(W.withPage(pe+1),de);return be};return{firstPage:ee,total:le,pageSize:W.pageSize,getPage:he}}async z(A,M,z){const _=A.flags;!!(A.flags&o.IncludeLatestVersionOnly)&&!!(A.flags&o.IncludeVersions)&&(A=A.withFlags(A.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(A.flags&o.IncludeLatestVersionOnly)&&!(A.flags&o.IncludeVersions)&&(A=A.withFlags(A.flags,o.IncludeLatestVersionOnly)),M.versions?.length&&(A=A.withFlags(A.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),A=A.withFlags(A.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:W,total:Q,context:ee}=await this.B(A,z);if(!(A.flags&o.IncludeLatestVersionOnly)){const de=[];for(const be of W){const Ce=await this.A(be,M,ee);Ce&&de.push(Ce)}return{extensions:de,total:Q}}const he=[],pe=new Map;for(let de=0;de<W.length;de++){const be=W[de],Ce={id:(0,p.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Re=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(We=>(0,p.areSameExtensions)(We,Ce))?.includePreRelease;if(M.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(H(be),M.targetPlatform))continue;const ke=await this.A(be,M,ee);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?pe.set(be.extensionId,de):he.push([de,ke])}if(pe.size){const de=new Date().getTime(),be=new b().withFlags(_&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,pe.size).withFilter(t.ExtensionId,...pe.keys()),{extensions:Ce}=await this.z(be,M,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:pe.size});for(const Re of Ce){const ke=pe.get(Re.identifier.uuid);he.push([ke,Re])}}return{extensions:he.sort((de,be)=>de[0]-be[0]).map(([,de])=>de),total:Q}}async A(A,M,z){const _={id:(0,p.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},W=M.versions?.find(he=>(0,p.areSameExtensions)(he,_))?.version,Q=(0,R.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(he=>(0,p.areSameExtensions)(he,_))?.includePreRelease,ee=H(A),le=$(A.versions,M.targetPlatform);if(M.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(ee,M.targetPlatform))return null;for(let he=0;he<le.length;he++){const pe=le[he];if(!(W&&pe.version!==W)){if(await this.y(pe,Q?"any":"release",M.compatible,ee,M.targetPlatform))return ie(A,pe,ee,z);if(W&&pe.version===W)return null}}return W||M.compatible?null:ie(A,A.versions[0],ee)}async B(A,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(o.Unpublished));const z=await this.j,_=JSON.stringify(A.raw),W={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},Q=new Date().getTime();let ee,le,he=0;try{if(ee=await this.k.request({type:"POST",url:this.g&&A.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:W},M),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:he};const pe=await(0,u.asJson)(ee);if(pe){const de=pe.results[0],be=de.extensions,Ce=de.resultMetadata&&de.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:he,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(pe){throw le=pe,pe}finally{this.o.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(_.length),duration:new Date().getTime()-Q,success:!!ee&&(0,u.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:le?(0,l.isCancellationError)(le)?"canceled":(0,l.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(A,M,z,_){if(!this.isEnabled())return;const W=O.isWeb?this.x(`/itemName/${A}.${M}/version/${z}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${A}/extensions/${M}/${z}/stats?statType=${_}`),Q=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:W,headers:le},U.CancellationToken.None)}catch{}}async download(A,M,z){this.l.trace("ExtensionGalleryService#download",A.identifier.id);const _=(0,p.getGalleryExtensionTelemetryData)(A),W=new Date().getTime(),Q=de=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:de}),ee=z===2?"install":z===3?"update":"",le=ee?{uri:`${A.assets.download.uri}${I.URI.parse(A.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${A.assets.download.fallbackUri}${I.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:A.assets.download,he=A.queryContext?.[n]?{[n]:A.queryContext[n]}:void 0,pe=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile(M,pe.stream),Q(new Date().getTime()-W)}async downloadSignatureArchive(A,M){if(!A.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const z=await this.D(A.assets.signature);await this.q.writeFile(M,z.stream)}async getReadme(A,M){if(A.assets.readme){const z=await this.D(A.assets.readme,{},M);return await(0,u.asTextOrError)(z)||""}return""}async getManifest(A,M){if(A.assets.manifest){const z=await this.D(A.assets.manifest,{},M),_=await(0,u.asTextOrError)(z);return _?JSON.parse(_):null}return null}async C(A,M){const z=j(A,s.Manifest);if(!z)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},W=await this.D(z,{headers:_});return await(0,u.asJson)(W)}async getCoreTranslation(A,M){const z=A.assets.coreTranslations.filter(_=>_[0]===M.toUpperCase())[0];if(z){const _=await this.D(z[1]),W=await(0,u.asTextOrError)(_);return W?JSON.parse(W):null}return null}async getChangelog(A,M){if(A.assets.changelog){const z=await this.D(A.assets.changelog,{},M);return await(0,u.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(A,M,z){let _=new b().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?_=_.withFilter(t.ExtensionId,A.identifier.uuid):_=_.withFilter(t.ExtensionName,A.identifier.id);const{galleryExtensions:W}=await this.B(_,U.CancellationToken.None);if(!W.length)return[];const Q=H(W[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(Q,z))return[];const ee=[];await Promise.all(W[0].versions.map(async pe=>{try{await this.y(pe,M?"any":"release",!0,Q,z)&&ee.push(pe)}catch{}}));const le=[],he=new Set;for(const pe of $(ee,z))he.has(pe.version)||(he.add(pe.version),le.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:B(pe)}));return le}async D(A,M={},z=U.CancellationToken.None){const _=await this.j,W={type:"GET"},Q={..._,...M.headers||{}};M={...M,...W,headers:Q};const ee=A.uri,le=A.fallbackUri,he={...M,url:ee};try{const pe=await this.k.request(he,z);if(pe.res.statusCode===200)return pe;const de=await(0,u.asTextOrError)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${de}`)}catch(pe){if((0,l.isCancellationError)(pe))throw pe;const de=(0,l.getErrorMessage)(pe);this.o.publicLog2("galleryService:cdnFallback",{url:ee,message:de});const be={...M,url:le};return this.k.request(be,z)}}async E(A){let M=V(A);if(!M){const z=await this.C(A,U.CancellationToken.None);if(!z)throw new Error("Manifest was not found");M=z.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const A=await this.k.request({type:"GET",url:this.h},U.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,u.asJson)(A),z=[],_={};if(M){for(const W of M.malicious)z.push({id:W});if(M.migrateToPreRelease)for(const[W,Q]of Object.entries(M.migrateToPreRelease))(!Q.engine||(0,d.isEngineValid)(Q.engine,this.u.version,this.u.date))&&(_[W.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[W,Q]of Object.entries(M.deprecated))Q&&(_[W.toLowerCase()]=(0,R.isBoolean)(Q)?{}:Q)}return{malicious:z,deprecated:_}}};se=ye([K(1,u.IRequestService),K(2,E.ILogService),K(3,P.IEnvironmentService),K(4,v.ITelemetryService),K(5,m.IFileService),K(6,c.IProductService),K(7,w.IConfigurationService)],se);let ae=class extends se{constructor(A,M,z,_,W,Q,ee,le){super(A,M,z,_,W,Q,ee,le)}};ae=ye([K(0,g.IStorageService),K(1,u.IRequestService),K(2,E.ILogService),K(3,P.IEnvironmentService),K(4,v.ITelemetryService),K(5,m.IFileService),K(6,c.IProductService),K(7,w.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let q=class extends se{constructor(A,M,z,_,W,Q,ee){super(void 0,A,M,z,_,W,Q,ee)}};q=ye([K(0,u.IRequestService),K(1,E.ILogService),K(2,P.IEnvironmentService),K(3,v.ITelemetryService),K(4,m.IFileService),K(5,c.IProductService),K(6,w.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q}),define(re[79],oe([0,1,5,3,2,20,33,26,21,9,12]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Xe extends l.Disposable{static b(m){return`extensionKeys/${(0,N.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static c(m){const E=S.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(m,E){const c=await m.getInstalled(),u=[];for(const[h,g]of Xe.f(E)){const v=c.find(D=>(0,N.areSameExtensions)(D.identifier,{id:h}))?.manifest.version;for(const D of g)v!==D&&u.push(Xe.b({id:h,version:D}))}for(const h of u)E.remove(h,0)}static f(m){const E=new Map,c=m.keys(0,1);for(const u of c){const h=Xe.c(u);if(h){let g=E.get(h.id.toLowerCase());g||E.set(h.id.toLowerCase(),g=[]),g.push(h.version)}}return E}constructor(m,E,c){super(),this.i=m,this.j=E,this.k=c,this.g=this.D(new U.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(m),this.D(this.i.onDidChangeValue(u=>this.l(u)))}l(m){if(m.scope!==0)return;if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const E=Xe.c(m.key);if(E){if(this.i.get(m.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let c=this.h.get(E.id.toLowerCase());c||this.h.set(E.id.toLowerCase(),c=[]),c.push(E.version),this.g.fire()}return}}m(m){if((0,P.isString)(m))return m;const E=m.manifest?m.manifest.publisher:m.publisher,c=m.manifest?m.manifest.name:m.name;return(0,N.getExtensionId)(E,c)}getExtensionState(m,E){const c=this.m(m),u=this.getExtensionStateRaw(m,E);if(u)try{return JSON.parse(u)}catch(h){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${E}): ${h}`)}}getExtensionStateRaw(m,E){const c=this.m(m),u=this.i.get(c,E?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${E}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(m,E,c){const u=this.m(m);E===void 0?this.i.remove(u,c?0:1):this.i.store(u,JSON.stringify(E),c?0:1,1)}setKeysForSync(m,E){this.i.store(Xe.b(m),JSON.stringify(E),0,1)}getKeysForSync(m){const E=this.j.extensionSyncedKeys?.[m.id.toLowerCase()],c=this.i.get(Xe.b(m),0),u=c?JSON.parse(c):void 0;return u&&E?(0,I.distinct)([...u,...E]):u||E}addToMigrationList(m,E){if(m!==E){const c=this.n.filter(u=>!u.includes(m)&&!u.includes(E));c.push([m,E]),this.n=c}}getSourceExtensionToMigrate(m){const E=this.n.find(([,c])=>m===c);return E?E[0]:void 0}get n(){const m=this.i.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(m);if(Array.isArray(E))return E}catch{}return[]}set n(m){m.length?this.i.store("extensionStorage.migrationList",JSON.stringify(m),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};p.a=512*1024,p=ye([K(0,O.IStorageService),K(1,R.IProductService),K(2,w.ILogService)],p),e.ExtensionStorageService=p}),define(re[275],oe([0,1,29,14,26,15,101,57,20,19,238]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let S=class extends P.AbstractNativeExtensionTipsService{constructor(d,m,E,c,u,h,g,v){super(d.userHome,u,m,E,c,h,g,v)}};S=ye([K(0,O.INativeEnvironmentService),K(1,w.ITelemetryService),K(2,L.IExtensionManagementService),K(3,I.IStorageService),K(4,R.INativeHostService),K(5,N.IExtensionRecommendationNotificationService),K(6,U.IFileService),K(7,l.IProductService)],S),e.ExtensionTipsService=S}),define(re[276],oe([0,1,6,2,23,66,20,75,18]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class w extends N.AbstractStorageService{constructor(S,p,d,m){super(),this.X=S,this.Y=p,this.Z=d,this.ab=m,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.D(new U.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.D(new U.DisposableStore),this.W=this.db(this.X)}bb(){const S=this.D(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),p=this.D(new O.Storage(S));return this.D(p.onDidChangeStorage(d=>this.n(-1,d))),p}cb(S){this.Q.clear(),this.P=S;let p;if((0,N.isProfileUsingDefaultStorage)(S))p=this.s;else{const d=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),S));p=this.Q.add(new O.Storage(d))}return this.Q.add(p.onDidChangeStorage(d=>this.n(0,d))),p}db(S){this.U.clear(),this.S=S?.id;let p;if(S){const d=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),S));p=this.U.add(new O.Storage(d)),this.U.add(p.onDidChangeStorage(m=>this.n(1,m)))}return p}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(S){switch(S){case-1:return this.s;case 0:return this.R;default:return this.W}}M(S){switch(S){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.q(N.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(S,p){if(!this.H(this.P,S))return;const d=this.R,m=d.items;d!==this.s&&await d.close(),this.R=this.cb(S),await this.R.init(),this.I(m,this.R,0,p)}async O(S,p){const d=this.W,m=d?.items??new Map;await d?.close(),this.W=this.db(S),await this.W.init(),this.I(m,this.W,1,p)}hasScope(S){return(0,I.isUserDataProfile)(S)?this.P.id===S.id:this.S===S.id}}e.RemoteStorageService=w}),define(re[277],oe([0,1,3,2,18,93]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class N{constructor(w,P){this.a=w,this.b=P}listen(w,P){const S=this.b(w);switch(P){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(d=>(0,O.transformOutgoingURIs)({...d},S)),added:p.added.map(d=>(0,O.transformOutgoingURIs)({...d},S)),removed:p.removed.map(d=>(0,O.transformOutgoingURIs)({...d},S)),updated:p.updated.map(d=>(0,O.transformOutgoingURIs)({...d},S))}))}throw new Error(`Invalid listen ${P}`)}async call(w,P,S){const p=this.b(w);switch(P){case"createProfile":{const d=await this.a.createProfile(S[0],S[1],S[2]);return(0,O.transformOutgoingURIs)({...d},p)}case"updateProfile":{let d=(0,l.reviveProfile)((0,O.transformIncomingURIs)(S[0],p),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,S[1]),(0,O.transformOutgoingURIs)({...d},p)}case"removeProfile":{const d=(0,l.reviveProfile)((0,O.transformIncomingURIs)(S[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=N;class R extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,P,S){super(),this.profilesHome=P,this.f=S,this.a=[],this.b=this.D(new L.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(p=>(0,l.reviveProfile)(p,this.profilesHome.scheme)),this.D(this.f.listen("onDidChangeProfiles")(p=>{const d=p.added.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),m=p.removed.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),E=p.updated.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme));this.a=p.all.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),this.b.fire({added:d,removed:m,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,P,S){const p=await this.f.call("createNamedProfile",[w,P,S]);return(0,l.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(w,P,S,p){const d=await this.f.call("createProfile",[w,P,S,p]);return(0,l.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(w){const P=await this.f.call("createTransientProfile",[w]);return(0,l.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(w,P){await this.f.call("setProfileForWorkspace",[w,P])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,P){const S=await this.f.call("updateProfile",[w,P]);return(0,l.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(re[61],oe([0,1,2,66,5,20,3,75,18]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let w=class extends L.Disposable{constructor(d){super(),this.a=d}async readStorageData(d){return this.withProfileScopedStorageService(d,async m=>this.b(m))}async updateStorageData(d,m,E){return this.withProfileScopedStorageService(d,async c=>this.c(c,m,E))}async withProfileScopedStorageService(d,m){if(this.a.hasScope(d))return m(this.a);const E=await this.g(d),c=new S(E);try{await c.initialize();const u=await m(c);return await c.flush(),u}finally{c.dispose(),await this.f(E)}}b(d){const m=new Map,E=c=>{for(const u of d.keys(0,c))m.set(u,{value:d.get(u,0),target:c})};return E(0),E(1),m}c(d,m,E){for(const[c,u]of m)d.store(c,u,0,E)}async f(d){try{await d.close()}finally{(0,L.isDisposable)(d)&&d.dispose()}}};w=ye([K(0,O.IStorageService)],w),e.AbstractUserDataProfileStorageService=w;class P extends w{constructor(d,m,E,c){super(E),this.i=d;const u=d.getChannel("profileStorageListener"),h=this.D(new L.MutableDisposable);this.h=this.D(new N.Emitter({onWillAddFirstListener:()=>{h.value=u.listen("onDidChange")(g=>{c.trace("profile storage changes",g),this.h.fire({targetChanges:g.targetChanges.map(v=>(0,I.reviveProfile)(v,m.profilesHome.scheme)),valueChanges:g.valueChanges.map(v=>({...v,profile:(0,I.reviveProfile)(v.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this.h.event}async g(d){const m=this.i.getChannel("storage");return(0,O.isProfileUsingDefaultStorage)(d)?new R.ApplicationStorageDatabaseClient(m):new R.ProfileStorageDatabaseClient(m,d)}}e.RemoteUserDataProfileStorageService=P;class S extends O.AbstractStorageService{constructor(d){super({flushInterval:100}),this.p=this.D(new U.Storage(d))}J(){return this.p.init()}L(d){return d===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[278],oe([0,1,20,9,18,71,61]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends N.RemoteUserDataProfileStorageService{constructor(w,P,S,p){super(w,P,S,p)}};R=ye([K(0,O.IMainProcessService),K(1,l.IUserDataProfilesService),K(2,L.IStorageService),K(3,U.ILogService)],R),e.NativeUserDataProfileStorageService=R}),define(re[41],oe([0,1,21,6,16,25,3,35,2,27,12,182,17,15,14,9,44,20,19,30,24,18]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(f){return!!(f&&f.ref!==void 0&&typeof f.ref=="string"&&f.ref!==""&&f.syncData!==void 0&&(f.syncData===null||o(f.syncData)))}e.isRemoteUserData=n;function o(f){return!!(f&&f.version!==void 0&&typeof f.version=="number"&&f.content!==void 0&&typeof f.content=="string"&&(Object.keys(f).length===2||Object.keys(f).length===3&&f.machineId!==void 0&&typeof f.machineId=="string"))}e.isSyncData=o;function i(f,b){return`${(0,w.uppercaseFirstLetter)(f)}${b.isDefault?"":` (${b.name})`}`}e.getSyncResourceLogLabel=i;let t=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(b,y,k,T,F,j,x,V,B,X,J,G){super(),this.syncResource=b,this.collection=y,this.z=k,this.C=T,this.F=F,this.G=j,this.H=x,this.I=V,this.J=B,this.L=X,this.M=J,this.c=null,this.k="idle",this.l=this.D(new N.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.D(new N.Emitter),this.onDidChangeConflicts=this.n.event,this.q=new U.ThrottledDelayer(50),this.s=this.D(new N.Emitter),this.onDidChangeLocal=this.s.event,this.u=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.v=!1,this.y={},this.resource=this.syncResource.syncResource,this.w=i(b.syncResource,b.profile),this.h=G.extUri,this.f=this.h.joinPath(T.userDataSyncHome,...(0,v.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.t=(0,v.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,T,this.h),this.j=(0,c.getServiceMachineId)(T,k,F)}N(){this.q.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.w}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const y=await this.U(b.remoteUserData,b.lastSyncUserData,!0,this.mb());this.P(y)}else{this.L.trace(`${this.w}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.sb(b):!0)&&this.s.fire()}}P(b){this.k!==b&&(this.k=b,this.l.fire(b))}async sync(b,y={}){await this.Q(b,!0,this.mb(),y)}async preview(b,y,k={}){return this.Q(b,!1,y,k)}async apply(b,y={}){try{this.y={...y};const k=await this.Y(b);return this.P(k),this.c}finally{this.y={}}}async Q(b,y,k,T){try{if(this.y={...T},this.status==="hasConflicts")return this.L.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.w}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let F="idle";try{const j=await this.getLastSyncUserData(),x=await this.S(b,j);return F=await this.U(x,j,y,k),F==="hasConflicts"?this.L.info(`${this.w}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.w}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(F)}}finally{this.y={}}}async replace(b){const y=this.ib(b);if(!y)return!1;await this.stop();try{this.L.trace(`${this.w}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const k=await this.getLastSyncUserData(),T=await this.S(null,k),F=await this.R(T),j=await this.ob({ref:T.ref,syncData:y},k,F,this.mb(),O.CancellationToken.None),x=[];for(const V of j){const B=await this.qb(V,V.remoteResource,void 0,O.CancellationToken.None),{remoteChange:X}=await this.qb(V,V.previewResource,V.remoteContent,O.CancellationToken.None);x.push([V,{...B,remoteChange:X!==0?X:2}])}await this.rb(T,k,x,!1),this.L.info(`${this.w}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(b){const y=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===y}async S(b,y){if(y){const k=b?b[this.resource]:void 0;if(y.ref===k||k===void 0&&y.syncData===null)return y}return this.getRemoteUserData(y)}async U(b,y,k,T){if(b.syncData&&b.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,S.localize)(0,null,this.resource,this.nb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(b,y,k,T)}catch(F){if(F instanceof v.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.w}: Failed to synchronize ${this.w} as there is a new local version available. Synchronizing again...`),this.U(b,y,k,T);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.w}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),y=await this.getLastSyncUserData(),this.U(b,y,k,T)}throw F}}async W(b,y,k,T){try{const F=await this.R(b),j=!F&&y===null&&this.eb()!==void 0,x=k&&!j;this.c||(this.c=(0,U.createCancelablePromise)(B=>this.cb(b,y,F,x,T,B)));let V=await this.c;if(k&&j){this.L.info(`${this.w}: Accepting remote because it was synced before and the last sync data is not available.`);for(const B of V.resourcePreviews)V=await this.accept(B.remoteResource)||V}return this.ab(V.resourcePreviews),V.resourcePreviews.some(({mergeState:B})=>B==="conflict")?"hasConflicts":k?await this.Y(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(b){return await this.X(b,async y=>{const k=await this.pb(y,O.CancellationToken.None);await this.z.writeFile(y.previewResource,l.VSBuffer.fromString(k?.content||""));const T=k&&!k.hasConflicts?await this.qb(y,y.previewResource,void 0,O.CancellationToken.None):void 0;return y.acceptResult=T,y.mergeState=k.hasConflicts?"conflict":T?"accepted":"preview",y.localChange=T?T.localChange:k.localChange,y.remoteChange=T?T.remoteChange:k.remoteChange,y}),this.c}async accept(b,y){return await this.X(b,async k=>{const T=await this.qb(k,b,y,O.CancellationToken.None);return k.acceptResult=T,k.mergeState="accepted",k.localChange=T.localChange,k.remoteChange=T.remoteChange,k}),this.c}async discard(b){return await this.X(b,async y=>{const k=await this.pb(y,O.CancellationToken.None);return await this.z.writeFile(y.previewResource,l.VSBuffer.fromString(k.content||"")),y.acceptResult=void 0,y.mergeState="preview",y.localChange=k.localChange,y.remoteChange=k.remoteChange,y}),this.c}async X(b,y){if(!this.c)return;let k=await this.c;const T=k.resourcePreviews.findIndex(({localResource:F,remoteResource:j,previewResource:x})=>this.h.isEqual(F,b)||this.h.isEqual(j,b)||this.h.isEqual(x,b));T!==-1&&(this.c=(0,U.createCancelablePromise)(async F=>{const j=[...k.resourcePreviews];return j[T]=await y(j[T]),{...k,resourcePreviews:j}}),k=await this.c,this.ab(k.resourcePreviews),k.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(b){if(!this.c)return"idle";const y=await this.c;return y.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":y.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.rb(y.remoteUserData,y.lastSyncUserData,y.resourcePreviews.map(k=>[k,k.acceptResult]),b),this.c=null,await this.Z(),"idle")}async Z(){try{await this.z.del(this.g,{recursive:!0})}catch{}}ab(b){const y=b.filter(({mergeState:k})=>k==="conflict");(0,L.equals)(this.m,y,(k,T)=>this.h.isEqual(k.previewResource,T.previewResource))||(this.m=y,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async bb(b){const y=this.c?await this.c:null;if(y)for(const k of y.resourcePreviews){if(this.h.isEqual(k.acceptedResource,b))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,b))return k.remoteContent;if(this.h.isEqual(k.localResource,b))return k.localContent;if(this.h.isEqual(k.baseResource,b))return k.baseContent}return null}async resetLocal(){this.F.remove(this.u,-1);try{await this.z.del(this.t)}catch(b){(0,m.toFileOperationResult)(b)!==1&&this.L.error(b)}}async cb(b,y,k,T,F,j){const x=await this.ob(b,y,k,F,j),V=[];for(const B of x){const X=B.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)V.push({...B,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=T?await this.pb(B,j):void 0;if(j.isCancellationRequested)break;await this.z.writeFile(B.previewResource,l.VSBuffer.fromString(J?.content||""));const G=J&&!J.hasConflicts?await this.qb(B,B.previewResource,void 0,j):void 0;V.push({...B,acceptResult:G,mergeState:J?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:J?J.localChange:B.localChange,remoteChange:G?G.remoteChange:J?J.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:y,resourcePreviews:V,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let b=this.eb();if(b||(b=await this.hb()),!b)return this.L.info(`${this.w}: Last sync data state does not exist.`),null;const y=JSON.parse(b),k=this.I.getResourceSyncStateVersion(this.resource);if(this.v=!!y.version&&!!k&&y.version!==k,this.v)return this.L.info(`${this.w}: Reset last sync state because last sync state version ${y.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let T,F=1;for(;T===void 0&&F++<6;)try{const j=await this.fb();j&&(j.ref===y.ref?T=j.syncData:this.L.info(`${this.w}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof m.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.w}: Last sync resource does not exist locally.`);break}else{if(j instanceof v.UserDataSyncError)throw j;this.L.error(j,F)}}if(T===void 0)try{const j=await this.G.resolveResourceContent(this.resource,y.ref,this.collection,this.y);T=j===null?null:this.ib(j),await this.gb({ref:y.ref,syncData:T})}catch(j){if(j instanceof v.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.w}: Last sync resource does not exist remotely.`);else throw j}return T===void 0?null:{...y,syncData:T}}async db(b,y={}){if(y.ref||y.version)throw new Error("Cannot have core properties as additional");const k=this.I.getResourceSyncStateVersion(this.resource),T={ref:b.ref,version:k,...y};this.F.store(this.u,JSON.stringify(T),-1,1),await this.gb(b)}eb(){return this.F.get(this.u,-1)}async fb(){const b=(await this.z.readFile(this.t)).value.toString();try{const y=b?JSON.parse(b):void 0;if(n(y))return y}catch(y){this.L.error(y)}}async gb(b){await this.z.writeFile(this.t,l.VSBuffer.fromString(JSON.stringify(b)))}async hb(){try{const b=await this.z.readFile(this.t),y=JSON.parse(b.value.toString());await this.z.del(this.t),y.ref&&y.content!==void 0?(this.F.store(this.u,JSON.stringify({...y,content:void 0}),-1,1),await this.gb({ref:y.ref,syncData:y.content===null?null:JSON.parse(y.content)})):this.L.info(`${this.w}: Migrating last sync user data. Invalid data.`,y)}catch(b){b instanceof m.FileOperationError&&b.fileOperationResult===1?this.L.info(`${this.w}: Migrating last sync user data. Resource does not exist.`):this.L.error(b)}return this.F.get(this.u,-1)}async getRemoteUserData(b){const{ref:y,content:k}=await this.jb(b);let T=null;return k!==null&&(T=this.ib(k)),{ref:y,syncData:T}}ib(b){try{const y=JSON.parse(b);if(o(y))return y}catch(y){this.L.error(y)}throw new v.UserDataSyncError((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(b){const y=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.G.readResource(this.resource,y,this.collection,this.y)}async kb(b,y){const k=await this.j,T={version:this.nb,machineId:k,content:b};try{return y=await this.G.writeResource(this.resource,JSON.stringify(T),y,this.collection,this.y),{ref:y,syncData:T}}catch(F){throw F instanceof v.UserDataSyncError&&F.code==="TooLarge"&&(F=new v.UserDataSyncError(F.message,F.code,this.resource)),F}}async lb(b){const y={version:this.nb,content:b};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(y))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.w}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.w}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ye([K(2,m.IFileService),K(3,d.IEnvironmentService),K(4,u.IStorageService),K(5,v.IUserDataSyncStoreService),K(6,v.IUserDataSyncBackupStoreService),K(7,v.IUserDataSyncEnablementService),K(8,h.ITelemetryService),K(9,v.IUserDataSyncLogService),K(10,p.IConfigurationService),K(11,g.IUriIdentityService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(b,y,k,T,F,j,x,V,B,X,J,G,Y){super(y,k,T,F,j,x,V,B,X,J,G,Y),this.i=b,this.D(this.z.watch(this.h.dirname(b))),this.D(this.z.onDidFilesChange(H=>this.ub(H)))}async p(){try{return await this.z.readFile(this.i)}catch{return null}}async r(b,y,k){try{y?await this.z.writeFile(this.i,l.VSBuffer.fromString(b),k?void 0:y):await this.z.createFile(this.i,l.VSBuffer.fromString(b),{overwrite:k})}catch(T){throw T instanceof m.FileOperationError&&T.fileOperationResult===1||T instanceof m.FileOperationError&&T.fileOperationResult===3?new v.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async tb(){try{await this.z.del(this.i)}catch(b){if(!(b instanceof m.FileOperationError&&b.fileOperationResult===1))throw b}}ub(b){!b.contains(this.i)||this.N()}};s=ye([K(3,m.IFileService),K(4,d.IEnvironmentService),K(5,u.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncEnablementService),K(9,h.ITelemetryService),K(10,v.IUserDataSyncLogService),K(11,p.IConfigurationService),K(12,g.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(b,y,k,T,F,j,x,V,B,X,J,G,Y,H){super(b,y,k,T,F,j,x,V,B,X,J,Y,H),this.vb=G,this.xb=void 0}wb(b,y){const k=[],T=(0,R.parse)(b,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,P.isUndefined)(T)&&y!==Array.isArray(T)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};a=ye([K(3,m.IFileService),K(4,d.IEnvironmentService),K(5,u.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncEnablementService),K(9,h.ITelemetryService),K(10,v.IUserDataSyncLogService),K(11,v.IUserDataSyncUtilService),K(12,p.IConfigurationService),K(13,g.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let r=class{constructor(b,y,k,T,F,j,x){this.resource=b,this.g=y,this.h=k,this.j=T,this.k=F,this.l=j,this.d=x.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,k,this.d)}async initialize({ref:b,content:y}){if(!y){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(y);if(!!k)try{await this.o({ref:b,syncData:k})}catch(T){this.j.error(T)}}m(b){try{const y=JSON.parse(b);if(o(y))return y}catch(y){this.j.error(y)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,y={}){if(y.ref||y.version)throw new Error("Cannot have core properties as additional");const k={ref:b.ref,version:void 0,...y};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,l.VSBuffer.fromString(JSON.stringify(b)))}};r=ye([K(1,D.IUserDataProfilesService),K(2,d.IEnvironmentService),K(3,E.ILogService),K(4,m.IFileService),K(5,u.IStorageService),K(6,g.IUriIdentityService)],r),e.AbstractInitializer=r}),define(re[121],oe([0,1,6,25,10,3,42,2,27,17,15,120,29,33,79,14,5,70,9,20,19,30,18,41,259,118,24,61]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D,n,o,i,t,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(F,j){const x=JSON.parse(F.content);if(F.version===1||F.version===2){const V=(await j.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of x)F.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),F.version===2&&V.every(X=>!(0,d.areSameExtensions)(X.identifier,B.identifier))&&(B.installed=!0)}return x}function f(F){return JSON.parse(F.content)}e.parseExtensions=f;function b(F,j){return F.sort((x,V)=>!x.identifier.uuid&&V.identifier.uuid?-1:x.identifier.uuid&&!V.identifier.uuid?1:(0,I.compare)(x.identifier.id,V.identifier.id)),j?(0,N.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=b;let y=class extends o.AbstractSynchroniser{constructor(j,x,V,B,X,J,G,Y,H,$,Z,ie,se,ae,q,C,A){super({syncResource:"extensions",profile:j},x,B,V,X,J,G,ie,se,$,Z,q),this.zb=Y,this.Ab=H,this.Bb=A,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(k),this.D(O.Event.any(O.Event.filter(this.zb.onDidInstallExtensions,M=>M.some(({local:z})=>!!z)),O.Event.filter(this.zb.onDidUninstallExtension,M=>!M.error),O.Event.filter(C.onDidChange,M=>M.valueChanges.some(({profile:z,changes:_})=>this.syncResource.profile.id===z.id&&_.some(W=>W.key===p.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(j,x){const V=j.syncData?await r(j.syncData,this.zb):null,B=x?.skippedExtensions??[],X=x?.builtinExtensions??null,J=x?.syncData?await r(x.syncData,this.zb):null,{localExtensions:G,ignoredExtensions:Y}=await this.yb.getLocalExtensions(this.syncResource.profile);V?this.L.trace(`${this.w}: Merging remote extensions with local extensions...`):this.L.trace(`${this.w}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:$}=(0,i.merge)(G,V,J,B,Y,X),Z={local:H,remote:$,content:this.Eb(G,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:$!==null?2:0},ie=this.Lb(G,!1);return[{skippedExtensions:B,builtinExtensions:X,baseResource:this.ub,baseContent:J?this.Lb(J,!1):ie,localResource:this.vb,localContent:ie,localExtensions:G,remoteResource:this.wb,remoteExtensions:V,remoteContent:V?this.Lb(V,!1):null,previewResource:this.tb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.xb}]}async sb(j){const x=j.syncData?await r(j.syncData,this.zb):null,{localExtensions:V,ignoredExtensions:B}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,i.merge)(V,x,x,j.skippedExtensions||[],B,j.builtinExtensions||[]);return X!==null}Eb(j,x,V,B){const X=[...x,...V],J=new Set,G=Y=>{J.add(Y.id.toLowerCase()),Y.uuid&&J.add(Y.uuid)};X.forEach(({identifier:Y})=>G(Y)),B.forEach(G);for(const Y of j)J.has(Y.identifier.id.toLowerCase())||Y.identifier.uuid&&J.has(Y.identifier.uuid)||X.push(Y);return this.Lb(X,!1)}async pb(j,x){return{...j.previewResult,hasConflicts:!1}}async qb(j,x,V,B){if(this.h.isEqual(x,this.vb))return this.Hb(j);if(this.h.isEqual(x,this.wb))return this.Ib(j);if(this.h.isEqual(x,this.tb))return j.previewResult;throw new Error(`Invalid Resource: ${x.toString()}`)}async Hb(j){const x=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.Ab.getIgnoredExtensions(x),B=(0,i.merge)(j.localExtensions,null,null,j.skippedExtensions,V,j.builtinExtensions),{local:X,remote:J}=B;return{content:j.localContent,local:X,remote:J,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:J!==null?2:0}}async Ib(j){const x=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),V=this.Ab.getIgnoredExtensions(x),B=j.remoteContent?JSON.parse(j.remoteContent):null;if(B!==null){const X=(0,i.merge)(j.localExtensions,B,j.localExtensions,[],V,j.builtinExtensions),{local:J,remote:G}=X;return{content:j.remoteContent,local:J,remote:G,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:G!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(j,x,V,B){let{skippedExtensions:X,builtinExtensions:J,localExtensions:G}=V[0][0];const{local:Y,remote:H,localChange:$,remoteChange:Z}=V[0][1];if($===0&&Z===0&&this.L.info(`${this.w}: No changes found during synchronizing extensions.`),$!==0&&(await this.lb(JSON.stringify(G)),X=await this.yb.updateLocalExtensions(Y.added,Y.removed,Y.updated,X,this.syncResource.profile)),H){this.L.trace(`${this.w}: Updating remote extensions...`);const ie=JSON.stringify(H.all);j=await this.kb(ie,B?null:j.ref),this.L.info(`${this.w}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(se=>se.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(se=>se.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(se=>se.identifier.id))}.`:""}`)}x?.ref!==j.ref&&(this.L.trace(`${this.w}: Updating last synchronized extensions...`),J=this.Kb(G,J),await this.db(j,{skippedExtensions:X,builtinExtensions:J}),this.L.info(`${this.w}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ie=>ie.identifier.id))}.`:""}`))}Kb(j,x){const V=new Set,B=[];for(const X of j)V.add(X.identifier.id.toLowerCase()),X.installed||B.push(X.identifier);if(x)for(const X of x)V.has(X.id.toLowerCase())||B.push(X);return B}async resolveContent(j){if(this.h.isEqual(this.wb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.vb,j)||this.h.isEqual(this.xb,j)){const x=await this.bb(j);return x&&this.Lb(JSON.parse(x),!0)}return null}Lb(j,x){return b(j,x)}async hasLocalData(){try{const{localExtensions:j}=await this.yb.getLocalExtensions(this.syncResource.profile);if(j.some(x=>x.installed||x.disabled))return!0}catch{}return!1}};y=ye([K(2,P.IEnvironmentService),K(3,E.IFileService),K(4,g.IStorageService),K(5,s.IUserDataSyncStoreService),K(6,s.IUserDataSyncBackupStoreService),K(7,p.IExtensionManagementService),K(8,t.IIgnoredExtensionsManagementService),K(9,s.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,s.IUserDataSyncEnablementService),K(12,v.ITelemetryService),K(13,m.IExtensionStorageService),K(14,D.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,c.IInstantiationService)],y),e.ExtensionsSynchroniser=y;let k=class{constructor(j,x,V,B,X,J){this.a=j,this.b=x,this.c=V,this.d=B,this.f=X,this.g=J}async getLocalExtensions(j){const x=await this.a.getInstalled(void 0,j.extensionsResource),V=this.d.getIgnoredExtensions(x);return{localExtensions:await this.j(j,async(X,J)=>{const G=X.getDisabledExtensions();return x.map(Y=>{const{identifier:H,isBuiltin:$,manifest:Z,preRelease:ie,pinned:se}=Y,ae={identifier:H,preRelease:ie,version:Z.version,pinned:!!se};G.some(q=>(0,d.areSameExtensions)(q,H))&&(ae.disabled=!0),$||(ae.installed=!0);try{const q=J.getKeysForSync({id:H.id,version:Z.version});if(q){const C=J.getExtensionState(Y,!0)||{};ae.state=Object.keys(C).reduce((A,M)=>(q.includes(M)&&(A[M]=C[M]),A),{})}}catch(q){this.g.info(`${(0,o.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,l.getErrorMessage)(q))}return ae})}),ignoredExtensions:V}}async updateLocalExtensions(j,x,V,B,X){const J=(0,o.getSyncResourceLogLabel)("extensions",X),G=[],Y=[],H=[],$=await this.a.getInstalled(void 0,X.extensionsResource);if((j.length||V.length)&&await this.j(X,async(ie,se)=>{await L.Promises.settled([...j,...V].map(async ae=>{const q=$.find(M=>(0,d.areSameExtensions)(M.identifier,ae.identifier));if(q&&q.isBuiltin){ae.state&&q.manifest.version===ae.version&&this.h(ae.state,q,q.manifest.version,se),ie.getDisabledExtensions().some(z=>(0,d.areSameExtensions)(z,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${J}: Disabling extension...`,ae.identifier.id),await ie.disableExtension(ae.identifier),this.g.info(`${J}: Disabled extension`,ae.identifier.id)):(this.g.trace(`${J}: Enabling extension...`,ae.identifier.id),await ie.enableExtension(ae.identifier),this.g.info(`${J}: Enabled extension`,ae.identifier.id))),Y.push(ae.identifier);return}const C=ae.pinned?ae.version:void 0,A=(await this.c.getExtensions([{...ae.identifier,version:C,preRelease:C?void 0:ae.preRelease}],U.CancellationToken.None))[0];if(ae.state&&(q?q.manifest.version===ae.version:!!A)&&this.h(ae.state,q||A,q?.manifest.version,se),A)try{ie.getDisabledExtensions().some(z=>(0,d.areSameExtensions)(z,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${J}: Disabling extension...`,ae.identifier.id,A.version),await ie.disableExtension(A.identifier),this.g.info(`${J}: Disabled extension`,ae.identifier.id,A.version)):(this.g.trace(`${J}: Enabling extension...`,ae.identifier.id,A.version),await ie.enableExtension(A.identifier),this.g.info(`${J}: Enabled extension`,ae.identifier.id,A.version))),(!q||q.preRelease!==ae.preRelease||q.pinned!==ae.pinned||C&&q.manifest.version!==C)&&(await this.a.canInstall(A)?G.push([ae,A]):(this.g.info(`${J}: Skipped synchronizing extension because it cannot be installed.`,A.displayName||A.identifier.id),H.push(ae)))}catch(M){H.push(ae),this.g.error(M),this.g.info(`${J}: Skipped synchronizing extension`,A.displayName||A.identifier.id)}else H.push(ae),this.g.info(`${J}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),x.length){const ie=$.filter(({identifier:se,isBuiltin:ae})=>!ae&&x.some(q=>(0,d.areSameExtensions)(se,q)));await L.Promises.settled(ie.map(async se=>{this.g.trace(`${J}: Uninstalling local extension...`,se.identifier.id),await this.a.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${J}: Uninstalled local extension.`,se.identifier.id),Y.push(se.identifier)}))}for(const[ie,se]of G)try{this.g.trace(`${J}: Installing extension...`,se.identifier.id,se.version),await this.a.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ie.pinned&&!!ie.version,installPreReleaseVersion:ie.preRelease,profileLocation:X.extensionsResource,context:{[p.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[p.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${J}: Installed extension.`,se.identifier.id,se.version),Y.push(se.identifier)}catch(ae){H.push(ie),ae instanceof p.ExtensionManagementError&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatiblePreRelease,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.g.info(`${J}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.g.error(ae),this.g.info(`${J}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const Z=[];for(const ie of B)Y.some(se=>(0,d.areSameExtensions)(se,ie.identifier))||Z.push(ie);for(const ie of H)Z.some(se=>(0,d.areSameExtensions)(se.identifier,ie.identifier))||Z.push(ie);return Z}h(j,x,V,B){const X=B.getExtensionState(x,!0)||{},J=V?B.getKeysForSync({id:x.identifier.id,version:V}):void 0;J?J.forEach(G=>{X[G]=j[G]}):Object.keys(j).forEach(G=>X[G]=j[G]),B.setExtensionState(x,X,!0)}async j(j,x){return this.b.withProfileScopedStorageService(j,async V=>{const B=new R.DisposableStore,X=this.f.createChild(new u.ServiceCollection([g.IStorageService,V])),J=B.add(X.createInstance(S.GlobalExtensionEnablementService)),G=B.add(X.createInstance(m.ExtensionStorageService));try{return await x(J,G)}finally{B.dispose()}})}};k=ye([K(0,p.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,p.IExtensionGalleryService),K(3,t.IIgnoredExtensionsManagementService),K(4,c.IInstantiationService),K(5,s.IUserDataSyncLogService)],k),e.LocalExtensionsProvider=k;let T=class extends o.AbstractInitializer{constructor(j,x,V,B,X,J,G,Y){super("extensions",B,X,J,V,G,Y),this.p=j,this.q=x}async t(j){return j.syncData?await r(j.syncData,this.p):null}u(j,x){const V=[],B=[],X=[];for(const J of j){if(this.q.hasToNeverSyncExtension(J.identifier.id))continue;const G=x.find(Y=>(0,d.areSameExtensions)(Y.identifier,J.identifier));G?(V.push(G),J.disabled&&X.push(J.identifier)):J.installed&&(B.push({...J.identifier,preRelease:!!J.preRelease}),J.disabled&&X.push(J.identifier))}return{installedExtensions:V,newExtensions:B,disabledExtensions:X,remoteExtensions:j}}};T=ye([K(0,p.IExtensionManagementService),K(1,t.IIgnoredExtensionsManagementService),K(2,E.IFileService),K(3,n.IUserDataProfilesService),K(4,P.IEnvironmentService),K(5,h.ILogService),K(6,g.IStorageService),K(7,D.IUriIdentityService)],T),e.AbstractExtensionsInitializer=T}),define(re[122],oe([0,1,16,10,3,35,42,4,31,17,15,14,9,44,20,19,30,41,60,263,24,18,61,5]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const i="globalState.argv.",t=["locale"];function s(k,T){const F=k.storage?Object.keys(k.storage).sort():[],j={};return F.forEach(x=>j[x]=k.storage[x]),k.storage=j,T?(0,N.toFormattedString)(k,{}):JSON.stringify(k)}e.stringify=s;const a=1;let r=class extends u.AbstractSynchroniser{constructor(T,F,j,x,V,B,X,J,G,Y,H,$,Z,ie){super({syncResource:"globalState",profile:T},F,x,J,$,V,B,G,Y,X,H,Z),this.xb=j,this.nb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=ie.createInstance(f),this.D(x.watch(this.h.dirname(this.C.argvResource))),this.D(l.Event.any(l.Event.filter(x.onDidFilesChange,se=>se.contains(this.C.argvResource)),l.Event.filter(j.onDidChange,se=>!!(se.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||se.valueChanges.some(({profile:ae,changes:q})=>this.syncResource.profile.id===ae.id&&q.some(C=>C.target===0)))))(()=>this.N()))}async ob(T,F,j){const x=T.syncData?JSON.parse(T.syncData.content):null;F=F===null&&j?T:F;const V=F&&F.syncData?JSON.parse(F.syncData.content):null,B=await this.wb.getLocalGlobalState(this.syncResource.profile);x?this.L.trace(`${this.w}: Merging remote ui state with local ui state...`):this.L.trace(`${this.w}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Fb(V),{local:J,remote:G}=(0,g.merge)(B.storage,x?x.storage:null,V?V.storage:null,X,this.L),Y={content:null,local:J,remote:G,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:G.all!==null?2:0},H=s(B,!1);return[{baseResource:this.r,baseContent:V?s(V,!1):H,localResource:this.tb,localContent:H,localUserData:B,remoteResource:this.ub,remoteContent:x?s(x,!1):null,previewResource:this.p,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.vb,storageKeys:X}]}async sb(T){const F=T.syncData?JSON.parse(T.syncData.content):null;if(F===null)return!0;const j=await this.wb.getLocalGlobalState(this.syncResource.profile),x=await this.Fb(F),{remote:V}=(0,g.merge)(j.storage,F.storage,F.storage,x,this.L);return V.all!==null}async pb(T,F){return{...T.previewResult,hasConflicts:!1}}async qb(T,F,j,x){if(this.h.isEqual(F,this.tb))return this.Cb(T);if(this.h.isEqual(F,this.ub))return this.Db(T);if(this.h.isEqual(F,this.p))return T.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Cb(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(T.localUserData.storage),removed:[],updated:[],all:T.localUserData.storage},localChange:0,remoteChange:2}}async Db(T){if(T.remoteContent!==null){const F=JSON.parse(T.remoteContent),{local:j,remote:x}=(0,g.merge)(T.localUserData.storage,F.storage,null,T.storageKeys,this.L);return{content:T.remoteContent,local:j,remote:x,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(T,F,j,x){const{localUserData:V}=j[0][0],{local:B,remote:X,localChange:J,remoteChange:G}=j[0][1];if(J===0&&G===0&&this.L.info(`${this.w}: No changes found during synchronizing ui state.`),J!==0&&(this.L.trace(`${this.w}: Updating local ui state...`),await this.lb(JSON.stringify(V)),await this.wb.writeLocalGlobalState(B,this.syncResource.profile),this.L.info(`${this.w}: Updated local ui state`)),G!==0){this.L.trace(`${this.w}: Updating remote ui state...`);const Y=JSON.stringify({storage:X.all});T=await this.kb(Y,x?null:T.ref),this.L.info(`${this.w}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}F?.ref!==T.ref&&(this.L.trace(`${this.w}: Updating last synchronized ui state...`),await this.db(T),this.L.info(`${this.w}: Updated last synchronized ui state`))}async resolveContent(T){if(this.h.isEqual(this.ub,T)||this.h.isEqual(this.r,T)||this.h.isEqual(this.tb,T)||this.h.isEqual(this.vb,T)){const F=await this.bb(T);return F&&s(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:T}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(T).length>1||T[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(T){const F=await this.xb.readStorageData(this.syncResource.profile),j=[],x=[];for(const[X,J]of F)J.target===0?j.push(X):J.target===1&&x.push(X);const V=[...j,...x],B=T?.storage?Object.keys(T.storage).filter(X=>!X.startsWith(i)&&!V.includes(X)&&F.get(X)!==void 0):[];if(!R.isWeb){const X=[...v.ALL_SYNC_RESOURCES.map(J=>(0,v.getEnablementKey)(J)),v.SYNC_SERVICE_URL_TYPE];B.push(...X),x.push(...X)}return{user:j,machine:x,unregistered:B}}};r=ye([K(2,n.IUserDataProfileStorageService),K(3,S.IFileService),K(4,v.IUserDataSyncStoreService),K(5,v.IUserDataSyncBackupStoreService),K(6,v.IUserDataSyncLogService),K(7,P.IEnvironmentService),K(8,v.IUserDataSyncEnablementService),K(9,E.ITelemetryService),K(10,w.IConfigurationService),K(11,m.IStorageService),K(12,c.IUriIdentityService),K(13,o.IInstantiationService)],r),e.GlobalStateSynchroniser=r;let f=class{constructor(T,F,j,x){this.a=T,this.b=F,this.c=j,this.d=x}async getLocalGlobalState(T){const F={};if(T.isDefault){const x=await this.f(),V=(0,O.parse)(x);for(const B of t)V[B]!==void 0&&(F[`${i}${B}`]={version:1,value:V[B]})}const j=await this.c.readStorageData(T);for(const[x,V]of j)V.value&&V.target===0&&(F[x]={version:1,value:V.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const T=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),T.value.toString()}catch(T){this.d.debug((0,U.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:F,updated:j},x){const V=(0,u.getSyncResourceLogLabel)("globalState",x),B={},X=new Map,J=await this.c.readStorageData(x),G=(Y,H)=>{for(const $ of Y){if($.startsWith(i)){B[$.substring(i.length)]=H?H[$].value:void 0;continue}if(H){const Z=H[$];Z.value!==J.get($)?.value&&X.set($,Z.value)}else J.get($)!==void 0&&X.set($,void 0)}};if(G(Object.keys(T),T),G(Object.keys(j),j),G(F),Object.keys(B).length){this.d.trace(`${V}: Updating locale...`);const Y=await this.f();let H=Y;for(const $ of Object.keys(B))H=(0,h.edit)(H,[$],B[$],{});Y!==H&&(this.d.trace(`${V}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.VSBuffer.fromString(H)),this.d.info(`${V}: Updated locale.`)),this.d.info(`${V}: Updated locale`)}X.size&&(this.d.trace(`${V}: Updating global state...`),await this.c.updateStorageData(x,X,0),this.d.info(`${V}: Updated global state`,[...X.keys()]))}};f=ye([K(0,S.IFileService),K(1,P.IEnvironmentService),K(2,n.IUserDataProfileStorageService),K(3,v.IUserDataSyncLogService)],f),e.LocalGlobalStateProvider=f;let b=class extends u.AbstractInitializer{constructor(T,F,j,x,V,B){super("globalState",j,x,V,F,T,B)}async o(T){const F=T.syncData?JSON.parse(T.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},x={};for(const V of Object.keys(F.storage))V.startsWith(i)?j[V.substring(i.length)]=F.storage[V].value:this.l.get(V,0)===void 0&&(x[V]=F.storage[V].value);if(Object.keys(j).length){let V="{}";try{V=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const B of Object.keys(j))V=(0,h.edit)(V,[B],j[B],{});await this.k.writeFile(this.h.argvResource,L.VSBuffer.fromString(V))}if(Object.keys(x).length)for(const V of Object.keys(x))this.l.store(V,x[V],0,0)}};b=ye([K(0,m.IStorageService),K(1,S.IFileService),K(2,D.IUserDataProfilesService),K(3,P.IEnvironmentService),K(4,v.IUserDataSyncLogService),K(5,c.IUriIdentityService)],b),e.GlobalStateInitializer=b;let y=class{constructor(T,F,j,x,V){this.a=T,this.b=F,this.c=j,this.d=x,this.f=V}getSyncStoreType(T){return this.h(T)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const F=(0,v.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(T,F)}catch(j){if(j instanceof v.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(T,F)}throw j}}async g(T,F){const j=await this.a.readResource("globalState",null,void 0,F),x=this.h(j)||{storage:{}};x.storage[v.SYNC_SERVICE_URL_TYPE]={value:T,version:a};const V=await(0,d.getServiceMachineId)(this.c,this.d,this.b),B={version:a,machineId:V,content:s(x,!1)};await this.a.writeResource("globalState",JSON.stringify(B),j.ref,void 0,F)}h({content:T}){if(!T)return null;const F=JSON.parse(T);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};y=ye([K(1,m.IStorageService),K(2,P.IEnvironmentService),K(3,S.IFileService),K(4,p.ILogService)],y),e.UserDataSyncStoreTypeSynchronizer=y}),define(re[123],oe([0,1,21,16,3,35,4,12,183,17,15,14,20,19,30,18,41,260,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(n,o,i){try{const t=JSON.parse(n);if(!o)return(0,R.isUndefined)(t.all)?null:t.all;switch(N.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}catch(t){return i.error(t),null}}e.getKeybindingsContentFromSyncContent=g;let v=class extends c.AbstractJsonFileSynchroniser{constructor(o,i,t,s,a,r,f,b,y,k,T,F,j){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},i,b,y,k,t,s,f,F,a,T,r,j),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.D(l.Event.filter(r.onDidChangeConfiguration,x=>x.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(o,i,t,s){const a=o.syncData?g(o.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;i=i===null&&t?o:i;const r=i?this.Kb(i):null,f=await this.p(),b=await this.yb();let y=null,k=!1,T=!1,F=!1;if(a){let V=f?f.value.toString():"[]";if(V=V||"[]",this.wb(V,!0))throw new h.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!r||r!==V||r!==a){this.L.trace(`${this.w}: Merging remote keybindings with local keybindings...`);const B=await(0,u.merge)(V,a,r,b,this.vb);B.hasChanges&&(y=B.mergeContent,F=B.hasConflicts,k=F||B.mergeContent!==V,T=F||B.mergeContent!==a)}}else f&&(this.L.trace(`${this.w}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=f.value.toString(),T=!0);const j={content:F?r:y,localChange:k?f?2:1:0,remoteChange:T?2:0,hasConflicts:F},x=f?f.value.toString():null;return[{fileContent:f,baseResource:this.Bb,baseContent:r,localResource:this.Cb,localContent:x,localChange:j.localChange,remoteResource:this.Db,remoteContent:a,remoteChange:j.remoteChange,previewResource:this.Ab,previewResult:j,acceptedResource:this.Eb}]}async sb(o){const i=this.Kb(o);if(i===null)return!0;const t=await this.p(),s=t?t.value.toString():"",a=await this.yb(),r=await(0,u.merge)(s||"[]",i,i,a,this.vb);return r.hasConflicts||r.mergeContent!==i}async pb(o,i){return o.previewResult}async qb(o,i,t,s){if(this.h.isEqual(i,this.Cb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(i,this.Db))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(i,this.Ab))return t===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async rb(o,i,t,s){const{fileContent:a}=t[0][0];let{content:r,localChange:f,remoteChange:b}=t[0][1];if(f===0&&b===0&&this.L.info(`${this.w}: No changes found during synchronizing keybindings.`),r!==null&&(r=r.trim(),r=r||"[]",this.wb(r,!0)))throw new h.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(f!==0&&(this.L.trace(`${this.w}: Updating local keybindings...`),a&&await this.lb(this.Lb(a.value.toString())),await this.r(r||"[]",a,s),this.L.info(`${this.w}: Updated local keybindings`)),b!==0){this.L.trace(`${this.w}: Updating remote keybindings...`);const y=this.Lb(r||"[]",o.syncData?.content);o=await this.kb(y,s?null:o.ref),this.L.info(`${this.w}: Updated remote keybindings`)}try{await this.z.del(this.Ab)}catch{}i?.ref!==o.ref&&(this.L.trace(`${this.w}: Updating last synchronized keybindings...`),await this.db(o,{platformSpecific:this.Mb()}),this.L.info(`${this.w}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const i=(0,O.parse)(o.value.toString());if((0,L.isNonEmptyArray)(i))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Db,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Eb,o)?this.bb(o):null}Kb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Mb()?null:g(o.syncData.content,this.Mb(),this.L)}Lb(o,i){let t={};try{t=JSON.parse(i||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete t.all:t.all=o,N.OS){case 2:t.mac=o;break;case 3:t.linux=o;break;case 1:t.windows=o;break}return JSON.stringify(t)}Mb(){return!!this.M.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=ye([K(2,h.IUserDataSyncStoreService),K(3,h.IUserDataSyncBackupStoreService),K(4,h.IUserDataSyncLogService),K(5,w.IConfigurationService),K(6,h.IUserDataSyncEnablementService),K(7,S.IFileService),K(8,P.IEnvironmentService),K(9,p.IStorageService),K(10,h.IUserDataSyncUtilService),K(11,d.ITelemetryService),K(12,m.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let D=class extends c.AbstractInitializer{constructor(o,i,t,s,a,r){super("keybindings",i,t,s,o,a,r)}async o(o){const i=o.syncData?this.p(o.syncData.content):null;if(!i){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,U.VSBuffer.fromString(i)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),i=(0,O.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(i)}catch(o){return o.fileOperationResult===1}}p(o){try{return g(o,!0,this.j)}catch(i){return this.j.error(i),null}}};D=ye([K(0,S.IFileService),K(1,E.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,p.IStorageService),K(5,m.IUriIdentityService)],D),e.KeybindingsInitializer=D}),define(re[124],oe([0,1,16,3,184,17,73,15,29,14,20,19,30,18,41,60,264,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function g(n){const o=JSON.parse(n);return h(o)?o:{settings:n}}e.parseSettingsSyncContent=g;let v=class extends m.AbstractJsonFileSynchroniser{constructor(o,i,t,s,a,r,f,b,y,k,T,F,j,x){super(o.settingsResource,{syncResource:"settings",profile:o},i,t,s,a,r,f,T,F,b,y,k,x),this.Ab=j,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(o){const i=await this.getLastSyncUserData(),t=await this.S(o,i),s=this.Hb(t),a=new N.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&a.parse(s.settings),a.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(o,i,t){const s=await this.p(),a=await this.yb(),r=this.Hb(o);i=i===null&&t?o:i;const f=i?this.Hb(i):null,b=await this.Lb();let y=null,k=!1,T=!1,F=!1;if(r){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Mb(B),this.L.trace(`${this.w}: Merging remote settings with local settings...`);const X=(0,c.merge)(B,r.settings,f?f.settings:null,b,[],a);y=X.localContent||X.remoteContent,k=X.localContent!==null,T=X.remoteContent!==null,F=X.hasConflicts}else s&&(this.L.trace(`${this.w}: Remote settings does not exist. Synchronizing settings for the first time.`),y=s.value.toString().trim()||"{}",this.Mb(y),T=!0);const j=s?s.value.toString():null,x=f?.settings??null,V={content:F?x:y,localChange:k?2:0,remoteChange:T?2:0,hasConflicts:F};return[{fileContent:s,baseResource:this.baseResource,baseContent:x,localResource:this.localResource,localContent:j,localChange:V.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:V.remoteChange,previewResource:this.previewResource,previewResult:V,acceptedResource:this.acceptedResource}]}async sb(o){const i=this.Hb(o);if(i===null)return!0;const t=await this.p(),s=t?t.value.toString().trim():"",a=await this.Lb(),r=await this.yb();return(0,c.merge)(s||"{}",i.settings,i.settings,a,[],r).remoteContent!==null}async pb(o,i){const t=await this.yb(),s=await this.Lb();return{...o.previewResult,content:o.previewResult.content?(0,c.updateIgnoredSettings)(o.previewResult.content,"{}",s,t):null}}async qb(o,i,t,s){const a=await this.yb(),r=await this.Lb();if(this.h.isEqual(i,this.localResource))return{content:o.fileContent?(0,c.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",r,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(i,this.remoteResource))return{content:o.remoteContent!==null?(0,c.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(i,this.previewResource))return t===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:t!==null?(0,c.updateIgnoredSettings)(t,o.fileContent?o.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async rb(o,i,t,s){const{fileContent:a}=t[0][0];let{content:r,localChange:f,remoteChange:b}=t[0][1];if(f===0&&b===0&&this.L.info(`${this.w}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Mb(r),f!==0&&(this.L.trace(`${this.w}: Updating local settings...`),a&&await this.lb(JSON.stringify(this.Jb(a.value.toString()))),await this.r(r,a,s),await this.M.reloadConfiguration(3),this.L.info(`${this.w}: Updated local settings`)),b!==0){const y=await this.yb(),k=this.Hb(o),T=await this.Lb(r);r=(0,c.updateIgnoredSettings)(r,k?k.settings:"{}",T,y),this.L.trace(`${this.w}: Updating remote settings...`),o=await this.kb(JSON.stringify(this.Jb(r)),s?null:o.ref),this.L.info(`${this.w}: Updated remote settings`)}try{await this.z.del(this.previewResource)}catch{}i?.ref!==o.ref&&(this.L.trace(`${this.w}: Updating last synchronized settings...`),await this.db(o),this.L.info(`${this.w}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.p();if(o){const i=await this.yb(),t=(0,E.edit)(o.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,c.isEmpty)(t)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)||this.h.isEqual(this.baseResource,o)?this.bb(o):null}async bb(o){let i=await super.bb(o);if(i){const t=await this.yb(),s=await this.Lb();i=(0,c.updateIgnoredSettings)(i,"{}",s,t)}return i}Hb(o){return o.syncData?this.Ib(o.syncData.content):null}Ib(o){try{return g(o)}catch(i){this.L.error(i)}return null}Jb(o){return{settings:o}}async Lb(o){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const t=U.Event.any(U.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:a})=>!!a)),U.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{t.dispose(),this.Kb=void 0})}const i=await this.Kb;return(0,c.getIgnoredSettings)(i,this.M,o)}Mb(o){if(this.wb(o,!1))throw new u.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};v=ye([K(2,w.IFileService),K(3,R.IEnvironmentService),K(4,P.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncLogService),K(8,u.IUserDataSyncUtilService),K(9,O.IConfigurationService),K(10,u.IUserDataSyncEnablementService),K(11,S.ITelemetryService),K(12,I.IExtensionManagementService),K(13,p.IUriIdentityService)],v),e.SettingsSynchroniser=v;let D=class extends m.AbstractInitializer{constructor(o,i,t,s,a,r){super("settings",i,t,s,o,a,r)}async o(o){const i=o.syncData?this.p(o.syncData.content):null;if(!i){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.VSBuffer.fromString(i.settings)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,c.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}p(o){try{return g(o)}catch(i){this.j.error(i)}return null}};D=ye([K(0,w.IFileService),K(1,d.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,P.IStorageService),K(5,p.IUriIdentityService)],D),e.SettingsInitializer=D}),define(re[125],oe([0,1,16,3,32,17,15,14,20,19,30,18,41,261,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(h){return JSON.parse(h.content)}e.parseSnippets=E;let c=class extends p.AbstractSynchroniser{constructor(g,v,D,n,o,i,t,s,a,r,f,b){super({syncResource:"snippets",profile:g},v,n,D,o,i,t,r,f,s,a,b),this.nb=1,this.p=g.snippetsHome,this.D(this.z.watch(D.userRoamingDataHome)),this.D(this.z.watch(this.p)),this.D(U.Event.filter(this.z.onDidFilesChange,y=>y.affects(this.p))(()=>this.N()))}async ob(g,v,D){const n=await this.Db(),o=this.Cb(n),i=g.syncData?this.Bb(g.syncData):null;v=v===null&&D?g:v;const t=v&&v.syncData?this.Bb(v.syncData):null;i?this.L.trace(`${this.w}: Merging remote snippets with local snippets...`):this.L.trace(`${this.w}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,d.merge)(o,i,t);return this.xb(s,n,i||{},t||{})}async sb(g){const v=g.syncData?this.Bb(g.syncData):null;if(v===null)return!0;const D=await this.Db(),n=this.Cb(D),o=(0,d.merge)(n,v,v);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async pb(g,v){return g.previewResult}async qb(g,v,D,n){if(this.h.isEqualOrParent(v,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return D===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:D,localChange:D===null?g.fileContent!==null?3:0:2,remoteChange:D===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async rb(g,v,D,n){const o=D.map(([i,t])=>({...i,acceptResult:t}));o.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.L.info(`${this.w}: No changes found during synchronizing snippets.`),o.some(({localChange:i})=>i!==0)&&(await this.yb(o),await this.zb(o,n)),o.some(({remoteChange:i})=>i!==0)&&(g=await this.Ab(o,g,n)),v?.ref!==g.ref&&(this.L.trace(`${this.w}: Updating last synchronized snippets...`),await this.db(g),this.L.info(`${this.w}: Updated last synchronized snippets`));for(const{previewResource:i}of o)try{await this.z.del(i)}catch{}}xb(g,v,D,n){const o=new Map;for(const i of Object.keys(g.local.added)){const t={content:g.local.added[i],hasConflicts:!1,localChange:1,remoteChange:0};o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(g.local.updated)){const t={content:g.local.updated[i],hasConflicts:!1,localChange:2,remoteChange:0},s=v[i]?v[i].value.toString():null;o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=v[i]?v[i].value.toString():null;o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(g.remote.added)){const t={content:g.remote.added[i],hasConflicts:!1,localChange:0,remoteChange:1},s=v[i]?v[i].value.toString():null;o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(g.remote.updated)){const t={content:g.remote.updated[i],hasConflicts:!1,localChange:0,remoteChange:2},s=v[i]?v[i].value.toString():null;o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[i],localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[i],previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of g.conflicts){const t={content:n[i]??null,hasConflicts:!0,localChange:v[i]?2:1,remoteChange:D[i]?2:1},s=v[i]?v[i].value.toString():null;o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[i]||null,localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[i]||null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const i of Object.keys(v))if(!o.has(i)){const t={content:v[i]?v[i].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=v[i]?v[i].value.toString():null;o.set(i,{baseResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[i]??null,localResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[i]||null,localContent:s,remoteResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[i]||null,previewResource:this.h.joinPath(this.g,i),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,i).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(g){return this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(g,this.g.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(g):null}async hasLocalData(){try{const g=await this.Db();if(Object.keys(g).length)return!0}catch{}return!1}async yb(g){const v={};for(const D of g)D.fileContent&&(v[this.h.basename(D.localResource)]=D.fileContent);await this.lb(JSON.stringify(this.Cb(v)))}async zb(g,v){for(const{fileContent:D,acceptResult:n,localResource:o,remoteResource:i,localChange:t}of g)if(t!==0){const s=i?this.h.basename(i):this.h.basename(o),a=this.h.joinPath(this.p,s);t===3?(this.L.trace(`${this.w}: Deleting snippet...`,this.h.basename(a)),await this.z.del(a),this.L.info(`${this.w}: Deleted snippet`,this.h.basename(a))):t===1?(this.L.trace(`${this.w}: Creating snippet...`,this.h.basename(a)),await this.z.createFile(a,L.VSBuffer.fromString(n.content),{overwrite:v}),this.L.info(`${this.w}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.w}: Updating snippet...`,this.h.basename(a)),await this.z.writeFile(a,L.VSBuffer.fromString(n.content),v?void 0:D),this.L.info(`${this.w}: Updated snippet`,this.h.basename(a)))}}async Ab(g,v,D){const n=v.syncData?this.Bb(v.syncData):{},o=(0,l.deepClone)(n);for(const{acceptResult:i,localResource:t,remoteResource:s,remoteChange:a}of g)if(a!==0){const r=t?this.h.basename(t):this.h.basename(s);a===3?delete o[r]:o[r]=i.content}return(0,d.areSame)(n,o)||(this.L.trace(`${this.w}: Updating remote snippets...`),v=await this.kb(JSON.stringify(o),D?null:v.ref),this.L.info(`${this.w}: Updated remote snippets`)),v}Bb(g){return E(g)}Cb(g){const v={};for(const D of Object.keys(g))v[D]=g[D].value.toString();return v}async Db(){const g={};let v;try{v=await this.z.resolve(this.p)}catch(D){if(D instanceof R.FileOperationError&&D.fileOperationResult===1)return g;throw D}for(const D of v.children||[]){const n=D.resource,o=this.h.extname(n);if(o===".json"||o===".code-snippets"){const i=this.h.relativePath(this.p,n),t=await this.z.readFile(n);g[i]=t}}return g}};c=ye([K(2,N.IEnvironmentService),K(3,R.IFileService),K(4,I.IStorageService),K(5,m.IUserDataSyncStoreService),K(6,m.IUserDataSyncBackupStoreService),K(7,m.IUserDataSyncLogService),K(8,O.IConfigurationService),K(9,m.IUserDataSyncEnablementService),K(10,w.ITelemetryService),K(11,P.IUriIdentityService)],c),e.SnippetsSynchroniser=c;let u=class extends p.AbstractInitializer{constructor(g,v,D,n,o,i){super("snippets",v,D,n,g,o,i)}async o(g){const v=g.syncData?JSON.parse(g.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(v)){const o=v[n];if(o){const i=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(i,L.VSBuffer.fromString(o)),this.j.info("Created snippet",this.d.basename(i))}}await this.n(g)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};u=ye([K(0,R.IFileService),K(1,S.IUserDataProfilesService),K(2,N.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,I.IStorageService),K(5,P.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[126],oe([0,1,16,17,15,14,20,19,30,18,41,24]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(c,u){try{return JSON.parse(c).tasks??null}catch(h){return u.error(h),null}}e.getTasksContentFromSyncContent=p;let d=class extends P.AbstractFileSynchroniser{constructor(u,h,g,v,D,n,o,i,t,s,a,r){super(u.tasksResource,{syncResource:"tasks",profile:u},h,i,t,s,g,v,o,a,D,n,r),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(u,h,g,v){const D=u.syncData?p(u.syncData.content,this.L):null;h=h===null&&g?u:h;const n=h?.syncData?p(h.syncData.content,this.L):null,o=await this.p();let i=null,t=!1,s=!1,a=!1;if(u.syncData){const b=o?o.value.toString():null;if(!n||n!==b||n!==D){this.L.trace(`${this.w}: Merging remote tasks with local tasks...`);const y=E(b,D,n);i=y.content,a=y.hasConflicts,t=y.hasLocalChanged,s=y.hasRemoteChanged}}else o&&(this.L.trace(`${this.w}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=o.value.toString(),s=!0);const r={content:a?n:i,localChange:t?o?2:1:0,remoteChange:s?2:0,hasConflicts:a},f=o?o.value.toString():null;return[{fileContent:o,baseResource:this.xb,baseContent:n,localResource:this.yb,localContent:f,localChange:r.localChange,remoteResource:this.zb,remoteContent:D,remoteChange:r.remoteChange,previewResource:this.wb,previewResult:r,acceptedResource:this.Ab}]}async sb(u){const h=u?.syncData?p(u.syncData.content,this.L):null;if(h===null)return!0;const g=await this.p(),v=g?g.value.toString():null,D=E(v,h,h);return D.hasLocalChanged||D.hasRemoteChanged}async pb(u,h){return u.previewResult}async qb(u,h,g,v){if(this.h.isEqual(h,this.yb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(h,this.zb))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(h,this.wb))return g===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async rb(u,h,g,v){const{fileContent:D}=g[0][0],{content:n,localChange:o,remoteChange:i}=g[0][1];if(o===0&&i===0&&this.L.info(`${this.w}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.w}: Updating local tasks...`),D&&await this.lb(JSON.stringify(this.Gb(D.value.toString()))),n?await this.r(n,D,v):await this.tb(),this.L.info(`${this.w}: Updated local tasks`)),i!==0){this.L.trace(`${this.w}: Updating remote tasks...`);const t=JSON.stringify(this.Gb(n));u=await this.kb(t,v?null:u.ref),this.L.info(`${this.w}: Updated remote tasks`)}try{await this.z.del(this.wb)}catch{}h?.ref!==u.ref&&(this.L.trace(`${this.w}: Updating last synchronized tasks...`),await this.db(u),this.L.info(`${this.w}: Updated last synchronized tasks`))}async hasLocalData(){return this.z.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.zb,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.yb,u)||this.h.isEqual(this.Ab,u)?this.bb(u):null}Gb(u){return u?{tasks:u}:{}}};d=ye([K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncBackupStoreService),K(4,S.IUserDataSyncLogService),K(5,U.IConfigurationService),K(6,S.IUserDataSyncEnablementService),K(7,O.IFileService),K(8,l.IEnvironmentService),K(9,N.IStorageService),K(10,R.ITelemetryService),K(11,I.IUriIdentityService)],d),e.TasksSynchroniser=d;let m=class extends P.AbstractInitializer{constructor(u,h,g,v,D,n){super("tasks",h,g,v,u,D,n),this.c=this.g.defaultProfile.tasksResource}async o(u){const h=u.syncData?p(u.syncData.content,this.j):null;if(!h){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.VSBuffer.fromString(h)),await this.n(u)}async p(){return this.k.exists(this.c)}};m=ye([K(0,O.IFileService),K(1,w.IUserDataProfilesService),K(2,l.IEnvironmentService),K(3,S.IUserDataSyncLogService),K(4,N.IStorageService),K(5,I.IUriIdentityService)],m),e.TasksInitializer=m;function E(c,u,h){if(c===null&&u===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=h!==c,v=h!==u;return!g&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!v?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!g?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[127],oe([0,1,42,17,15,14,20,19,30,18,41,262,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let d=class extends P.AbstractSynchroniser{constructor(u,h,g,v,D,n,o,i,t,s,a,r,f){super({syncResource:"profiles",profile:u},h,v,D,n,o,i,a,r,t,s,f),this.r=g,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?E(u.syncData):null}async getRemoteSyncedProfiles(u){const h=await this.getLastSyncUserData(),g=await this.S(u,h);return g?.syncData?E(g.syncData):null}async ob(u,h,g){if(!this.r.isEnabled())throw new p.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=u.syncData?E(u.syncData):null,D=h?.syncData?E(h.syncData):null,n=this.Ab(),{local:o,remote:i}=(0,S.merge)(n,v,D,[]),t={local:o,remote:i,content:D?this.Bb(D):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:i!==null?2:0},s=m(n,!1);return[{baseResource:this.baseResource,baseContent:D?this.Bb(D):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:v?this.Bb(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async sb(u){const h=u?.syncData?E(u.syncData):null,g=this.Ab(),{remote:v}=(0,S.merge)(g,h,h,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async pb(u,h){return{...u.previewResult,hasConflicts:!1}}async qb(u,h,g,v){if(this.h.isEqual(h,this.localResource))return this.xb(u);if(this.h.isEqual(h,this.remoteResource))return this.yb(u);if(this.h.isEqual(h,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async xb(u){const h=this.Ab(),g=(0,S.merge)(h,null,null,[]),{local:v,remote:D}=g;return{content:u.localContent,local:v,remote:D,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:D!==null?2:0}}async yb(u){const h=u.remoteContent?JSON.parse(u.remoteContent):null,g=[],v=[];for(const D of this.Ab()){const n=h?.find(o=>o.id===D.id);n&&(g.push({id:D.id,name:D.name,collection:n.collection}),v.push(D))}if(h!==null){const D=(0,S.merge)(v,h,g,[]),{local:n,remote:o}=D;return{content:u.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(u,h,g,v){const{local:D,remote:n,localChange:o,remoteChange:i}=g[0][1];o===0&&i===0&&this.L.info(`${this.w}: No changes found during synchronizing profiles.`);const t=g[0][0].remoteProfiles||[];if(t.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new p.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.lb(m(this.Ab(),!1));const s=[];for(const a of D.added)s.push((async()=>{this.L.trace(`${this.w}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.w}: Created profile '${a.name}'.`)})());for(const a of D.removed)s.push((async()=>{this.L.trace(`${this.w}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.w}: Removed profile '${a.name}'.`)})());for(const a of D.updated){const r=this.r.profiles.find(f=>f.id===a.id);r?s.push((async()=>{this.L.trace(`${this.w}: Updating '${a.name}' profile...`),await this.r.updateProfile(r,{name:a.name,shortName:a.shortName}),this.L.info(`${this.w}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.w}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(s)}if(i!==0){this.L.trace(`${this.w}: Updating remote profiles...`);const s=[],a=t.length+(n?.added.length??0)<=20;if(a)for(const r of n?.added||[]){const f=await this.G.createCollection(this.y);s.push(f),t.push({id:r.id,name:r.name,collection:f,shortName:r.shortName})}else this.L.info(`${this.w}: Could not create remote profiles as there are too many profiles.`);for(const r of n?.removed||[])t.splice(t.findIndex(({id:f})=>r.id===f),1);for(const r of n?.updated||[]){const f=t.find(({id:b})=>r.id===b);f&&t.splice(t.indexOf(f),1,{id:r.id,name:r.name,collection:f.collection,shortName:r.shortName})}try{u=await this.updateRemoteProfiles(t,v?null:u.ref),this.L.info(`${this.w}: Updated remote profiles.${a&&n?.added.length?` Added: ${JSON.stringify(n.added.map(r=>r.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(r=>r.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(r=>r.name))}.`:""}`)}catch(r){if(s.length){this.L.info(`${this.w}: Failed to update remote profiles. Cleaning up added collections...`);for(const f of s)await this.G.deleteCollection(f,this.y)}throw r}for(const r of n?.removed||[])await this.G.deleteCollection(r.collection,this.y)}h?.ref!==u.ref&&(this.L.trace(`${this.w}: Updating last synchronized profiles...`),await this.db(u),this.L.info(`${this.w}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,h){return this.kb(this.Bb(u),h)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const h=await this.bb(u);return h&&(0,L.toFormattedString)(JSON.parse(h),{})}return null}Ab(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((h,g)=>h.name.localeCompare(g.name)))}};d=ye([K(2,w.IUserDataProfilesService),K(3,O.IFileService),K(4,l.IEnvironmentService),K(5,N.IStorageService),K(6,p.IUserDataSyncStoreService),K(7,p.IUserDataSyncBackupStoreService),K(8,p.IUserDataSyncLogService),K(9,U.IConfigurationService),K(10,p.IUserDataSyncEnablementService),K(11,R.ITelemetryService),K(12,I.IUriIdentityService)],d),e.UserDataProfilesManifestSynchroniser=d;function m(c,u){const h=[...c].sort((g,v)=>g.name.localeCompare(v.name)).map(g=>({id:g.id,name:g.name}));return u?(0,L.toFormattedString)(h,{}):JSON.stringify(h)}e.stringifyLocalProfiles=m;function E(c){return JSON.parse(c.content)}e.parseUserDataProfilesManifest=E}),define(re[279],oe([0,1,6,16,64,2,23,17,15,14,18,24]),function(te,e,L,U,l,O,N,R,I,w,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends O.Disposable{constructor(m,E,c,u,h){super(),this.a=m,this.b=E,this.c=c,this.f=u,this.g=h,this.h()}async h(){for(const E of this.g.profiles)for(const c of S.ALL_SYNC_RESOURCES)try{await this.j(this.i(E,c))}catch(u){this.f.error(u)}let m;try{m=await this.b.resolve(this.a.userDataSyncHome)}catch(E){(0,w.toFileOperationResult)(E)!==1&&this.f.error(E);return}if(m.children){for(const E of m.children)if(E.isDirectory&&!this.g.profiles.some(c=>c.id===E.name))try{this.f.info("Deleting non existing profile from backup",E.resource.path),await this.b.del(E.resource,{recursive:!0})}catch(c){this.f.error(c)}}}async getAllRefs(m,E){const c=this.i(m,E);try{const u=await this.b.resolve(c);if(u.children)return u.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.k(g)}))}catch(u){if((0,w.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(m,E,c){const u=this.i(m,E),h=(0,N.joinPath)(u,c);try{return(await this.b.readFile(h)).value.toString()}catch(g){return this.f.error(g),null}}async backup(m,E,c){const u=this.i(m,E),h=(0,N.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(h,U.VSBuffer.fromString(c))}catch(g){this.f.error(g)}try{this.j(u)}catch{}}i(m,E){return(0,N.joinPath)(this.a.userDataSyncHome,...m.isDefault?[E]:[m.id,E])}async j(m){try{try{if(!await this.b.exists(m))return}catch{return}const E=await this.b.resolve(m);if(E.children){const c=E.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let h=c.filter(v=>Date.now()-this.k(v)>u);const g=c.length-h.length;g<10&&(h=h.slice(10-g)),await L.Promises.settled(h.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(E){this.f.error(E)}}k(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};p=ye([K(0,I.IEnvironmentService),K(1,w.IFileService),K(2,R.IConfigurationService),K(3,S.IUserDataSyncLogService),K(4,P.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(re[280],oe([0,1,3,2,4,15,20,19,24]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let P=class extends U.Disposable{constructor(p,d,m,E){super(),this.c=p,this.f=d,this.g=m,this.h=E,this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new L.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.D(p.onDidChangeValue(c=>this.j(c)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:p}),this.c.store(w,p,-1,1))}isResourceEnabled(p){return this.c.getBoolean((0,I.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,d){if(this.isResourceEnabled(p)!==d){const m=(0,I.getEnablementKey)(p);this.i(m,d)}}getResourceSyncStateVersion(p){}i(p,d){this.c.store(p,d,-1,l.isWeb?0:1)}j(p){if(p.scope!==-1)return;if(w===p.key){this.a.fire(this.isEnabled());return}const d=I.ALL_SYNC_RESOURCES.filter(m=>(0,I.getEnablementKey)(m)===p.key)[0];if(d){this.b.fire([d,this.isResourceEnabled(d)]);return}}};P=ye([K(0,N.IStorageService),K(1,R.ITelemetryService),K(2,O.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(re[80],oe([0,1,3,2,4,27,188,15,14,5,26,44,20,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const m="sync.currentMachineName",E="Safari",c="Chrome",u="Edge",h="Firefox",g="Android";function v(o){switch(o){case E:case c:case u:case h:case g:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function D(){return l.isSafari?E:l.isChrome?c:l.isEdge?u:l.isFirefox?h:l.isAndroid?g:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let n=class it extends U.Disposable{constructor(i,t,s,a,r,f){super(),this.h=s,this.i=a,this.j=r,this.k=f,this.c=this.D(new L.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.getServiceMachineId)(i,t,s)}async getMachines(i){const t=await this.f;return(await this.m(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,s=await this.m(i);s.machines.some(({id:a})=>a===t)||(s.machines.push({id:t,name:this.l(s.machines),platform:D()}),await this.n(s))}async removeCurrentMachine(i){const t=await this.f,s=await this.m(i),a=s.machines.filter(({id:r})=>r!==t);a.length!==s.machines.length&&(s.machines=a,await this.n(s))}async renameMachine(i,t,s){const a=await this.m(s),r=a.machines.find(({id:f})=>f===i);if(r){r.name=t,await this.n(a);const f=await this.f;i===f&&this.h.store(m,t,-1,1)}}async setEnablements(i){const t=await this.m();for(const[s,a]of i){const r=t.machines.find(f=>f.id===s);r&&(r.disabled=a?void 0:!0)}await this.n(t)}l(i){const t=this.h.get(m,-1);if(t)return t;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${D()} (${this.k.nameShort})`,a=new RegExp(`${(0,O.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let r=0;for(const f of i){const b=a.exec(f.name),y=b?parseInt(b[1]):0;r=y>r?y:r}return`${s} #${r+1}`}async m(i){this.g=await this.p(i);const t=this.q(this.g);if(t.version!==it.a)throw new Error((0,N.localize)(0,null,this.k.nameLong));return t}async n(i){const t=JSON.stringify(i),s=await this.i.writeResource(it.b,t,this.g?.ref||null);this.g={ref:s,content:t},this.c.fire()}async p(i){if(this.g){const t=i&&i.latest?i.latest[it.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}q(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.j.error(t)}return{version:it.a,machines:[]}}};n.a=1,n.b="machines",n=ye([K(0,R.IEnvironmentService),K(1,I.IFileService),K(2,p.IStorageService),K(3,d.IUserDataSyncStoreService),K(4,d.IUserDataSyncLogService),K(5,P.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[281],oe([0,1,6,64,38,10,3,2,4,23,11,185,26,20,19,24,77,80]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const h="sync.disableMachineEventually",g="sync.sessionId",v="sync.storeUrl",D="sync.productQuality";let n=class extends R.Disposable{get j(){const t=this.y.get(v,-1);return t?P.URI.parse(t):void 0}set j(t){t?this.y.store(v,t.toString(),-1,1):this.y.remove(v,-1)}get l(){return this.y.get(D,-1)}set l(t){t?this.y.store(D,t,-1,1):this.y.remove(D,-1)}constructor(t,s,a,r,f,b,y,k,T,F){super(),this.n=s,this.p=a,this.q=r,this.r=f,this.s=b,this.u=y,this.v=k,this.w=T,this.y=F,this.a=this.D(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.D(new N.Emitter),this.onError=this.h.event,this.N=[],this.f=this.D(new L.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=t.quality,this.j&&(this.s.info("Using settings sync service",this.j.toString()),this.D(s.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.s.info("Using settings sync service",this.j.toString()))})),this.q.isEnabled()?this.s.info("Auto Sync is enabled."):this.s.info("Auto Sync is disabled."),this.z(),this.L()&&this.J(),this.D(y.onDidChangeAccount(()=>this.z())),this.D(a.onDidChangeDonotMakeRequestsUntil(()=>this.z())),this.D(f.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.D(N.Event.filter(this.q.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.D(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}z(){const{enabled:t,message:s}=this.F();t?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.r,this.w,this.s,this.y),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.C()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.s.info(s),this.a.clear()):s&&this.q.isEnabled()&&this.s.info(s))}C(){return!0}F(){return this.q.isEnabled()?this.u.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(t,s,a){try{this.u.account&&!a&&await this.w.removeCurrentMachine(),this.G(!1),this.y.remove(g,-1),t?(this.v.publicLog2("sync/turnOffEveryWhere"),await this.r.reset()):await this.r.resetLocal()}catch(r){if(this.s.error(r),s)this.G(!1);else throw r}}G(t){this.q.isEnabled()!==t&&(this.q.setEnablement(t),this.z())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(t){if(!t){this.b=0;return}const s=E.UserDataSyncError.toUserDataSyncError(t);s instanceof E.UserDataAutoSyncError&&this.v.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.s.info("Auto Sync: Suspended sync because of making too many requests to server"),this.z()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.s.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.s.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.s.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.s.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.s.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.s.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.s.error(s),this.b++),this.h.fire(s)}async J(){this.y.store(h,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.L()&&(this.M(),!this.q.isEnabled()&&this.u.account&&await this.w.removeCurrentMachine())}L(){return this.y.getBoolean(h,-1,!1)}M(){this.y.remove(h,-1)}async triggerSync(t,s,a){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.s.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...t),this.f.trigger(async()=>{this.s.trace("activity sources",...this.N);const r=this.u.account?.authenticationProviderId||"";this.v.publicLog2("sync/triggered",{sources:this.N,providerId:r}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=ye([K(0,p.IProductService),K(1,E.IUserDataSyncStoreManagementService),K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncEnablementService),K(4,E.IUserDataSyncService),K(5,E.IUserDataSyncLogService),K(6,c.IUserDataSyncAccountService),K(7,m.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,d.IStorageService)],n),e.UserDataAutoSyncService=n;class o extends R.Disposable{constructor(t,s,a,r,f,b,y,k){super(),this.j=t,this.k=s,this.l=a,this.m=r,this.n=f,this.p=b,this.q=y,this.r=k,this.b=this.D(new R.MutableDisposable),this.c=this.D(new N.Emitter),this.onDidStartSync=this.c.event,this.f=this.D(new N.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.D(this.onDidFinishSync(()=>this.s())),this.D((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.q.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.q.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}s(){this.b.value=(0,L.disposableTimeout)(()=>this.sync(o.a,!1),this.k)}sync(t,s){const a=(0,L.createCancelablePromise)(async r=>{if(this.i)try{this.q.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(f){if((0,O.isCancellationError)(f))return}return this.w(t,s,r)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}u(){return this.j!==void 0&&!(0,w.isEqual)(this.j,this.l.userDataSyncStore?.url)}async v(){const t=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!t&&(!(0,w.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,w.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,w.isEqual)(s.stableUrl,t.stableUrl))}async w(t,s,a){this.q.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let r;try{await this.y(s,a)}catch(f){if(this.q.error(f),r=f,E.UserDataSyncError.toUserDataSyncError(f).code==="MethodNotFound")try{this.q.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.q.info("Auto Sync: Retrying sync..."),await this.y(s,a),r=void 0}catch(b){this.q.error(b),r=b}}this.f.fire(r)}async y(t,s){if(this.h=await this.n.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.u()?await this.v()?new E.UserDataAutoSyncError((0,S.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(2,null),"TurnedOff");const a=this.r.get(g,-1);if(a&&this.g&&a!==this.g.session)throw this.u()?await this.v()?new E.UserDataAutoSyncError((0,S.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,S.localize)(5,null),"SessionExpired");const r=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const f=r.find(b=>b.isCurrent);if(f?.disabled)throw new E.UserDataAutoSyncError((0,S.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(b){throw new E.UserDataAutoSyncError((0,l.toErrorMessage)(b),b instanceof E.UserDataSyncError?b.code:"Unknown")}this.g&&this.g.session!==a&&this.r.store(g,this.g.session,-1,1),!s.isCancellationRequested&&(f||await this.p.addCurrentMachine(this.g||void 0))}register(t){return super.D(t)}}o.a="Interval"}),define(re[282],oe([0,1,11,189,15,14,44,20,30,24,18,41,125,124,123,17,126,121,122,5,127,42]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class He{constructor(i,t,s,a,r,f,b,y,k,T){this.e=i,this.f=t,this.g=s,this.h=r,this.i=f,this.j=b,this.k=y,this.l=k,this.m=T,this.d=a.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const t=this.K(i.content,"profiles");return(0,v.parseUserDataProfilesManifest)(t)}return[]}async getRemoteSyncResourceHandles(i,t){return(await this.e.getAllResourceRefs(i,t?.collection)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!0,syncResource:i,profile:t?.id??this.k.defaultProfile.id,collection:t?.collection,ref:r,node:void 0})}))}async getLocalSyncResourceHandles(i,t){return(await this.f.getAllRefs(t,i)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!1,syncResource:i,profile:t.id,collection:void 0,ref:r,node:void 0})}))}resolveUserDataSyncResource({uri:i}){const t=this.J(i),s=t?this.k.profiles.find(a=>a.id===t.profile):void 0;return t&&s?{profile:s,syncResource:t?.syncResource}:void 0}async getAssociatedResources({uri:i}){const t=this.J(i);if(!t)return[];const s=this.k.profiles.find(a=>a.id===t.profile);switch(t.syncResource){case"settings":return this.r(i,s);case"keybindings":return this.t(i,s);case"tasks":return this.v(i,s);case"snippets":return this.x(i,s);case"globalState":return this.C(i,s);case"extensions":return this.z(i,s);case"profiles":return this.F(i,s)}}async getMachineId({uri:i}){const t=this.J(i);if(!!t){if(t.remote){if(t.ref){const{content:s}=await this.L(t.syncResource,t.ref,t.collection);if(s)return this.K(s,t.syncResource)?.machineId}return}return(0,N.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(i){const t=this.J(i);if(!t||t.node===He.a)return null;if(t.ref){const s=await this.n(t.remote,t.syncResource,t.profile,t.collection,t.ref);return t.node&&s?this.o(t.syncResource,s,t.node):s}return!t.remote&&!t.node?this.q(t.syncResource,t.profile):null}async n(i,t,s,a,r){if(i){const{content:b}=await this.L(t,r,a);return b}const f=this.k.profiles.find(b=>b.id===s);return f?this.f.resolveContent(f,t,r):null}o(i,t,s){const a=this.K(t,i);switch(i){case"settings":return this.s(a,s);case"keybindings":return this.u(a,s);case"tasks":return this.w(a,s);case"snippets":return this.y(a,s);case"globalState":return this.D(a,s);case"extensions":return this.A(a,s);case"profiles":return this.G(a,s)}}async q(i,t){const s=this.k.profiles.find(a=>a.id===t);if(!s)return null;switch(i){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(i,t){const s=this.d.joinPath(i,"settings.json"),a=t?t.settingsResource:this.d.joinPath(i,He.a);return[{resource:s,comparableResource:a}]}s(i,t){switch(t){case"settings.json":return(0,d.parseSettingsSyncContent)(i.content).settings}return null}t(i,t){const s=this.d.joinPath(i,"keybindings.json"),a=t?t.keybindingsResource:this.d.joinPath(i,He.a);return[{resource:s,comparableResource:a}]}u(i,t){switch(t){case"keybindings.json":return(0,m.getKeybindingsContentFromSyncContent)(i.content,!!this.l.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(i,t){const s=this.d.joinPath(i,"tasks.json"),a=t?t.tasksResource:this.d.joinPath(i,He.a);return[{resource:s,comparableResource:a}]}w(i,t){switch(t){case"tasks.json":return(0,c.getTasksContentFromSyncContent)(i.content,this.g)}return null}async x(i,t){const s=await this.resolveContent(i);if(s){const a=this.K(s,"snippets");if(a){const r=(0,p.parseSnippets)(a),f=[];for(const b of Object.keys(r)){const y=this.d.joinPath(i,b),k=t?this.d.joinPath(t.snippetsHome,b):this.d.joinPath(i,He.a);f.push({resource:y,comparableResource:k})}return f}}return[]}y(i,t){return(0,p.parseSnippets)(i)[t]||null}z(i,t){const s=this.d.joinPath(i,"extensions.json"),a=t?this.I({remote:!1,syncResource:"extensions",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,He.a);return[{resource:s,comparableResource:a}]}A(i,t){switch(t){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(i),!0)}return null}async B(i){const{localExtensions:t}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(i);return(0,u.stringify)(t,!0)}C(i,t){const s=this.d.joinPath(i,"globalState.json"),a=t?this.I({remote:!1,syncResource:"globalState",profile:t.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,He.a);return[{resource:s,comparableResource:a}]}D(i,t){switch(t){case"globalState.json":return(0,h.stringify)(JSON.parse(i.content),!0)}return null}async E(i){const t=await this.m.createInstance(h.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,h.stringify)(t,!0)}F(i,t){const s=this.d.joinPath(i,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:a}]}G(i,t){switch(t){case"profiles.json":return(0,D.toFormattedString)(JSON.parse(i.content),{})}return null}async H(i){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(t=>!t.isDefault&&!t.isTransient),!0)}I(i){const t=i.remote?He.b:He.c,s=[i.syncResource,i.profile];return i.collection&&s.push(`collection:${i.collection}`),i.ref&&s.push(`ref:${i.ref}`),i.node&&s.push(i.node),this.d.joinPath(L.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:t,path:"/"}),...s)}J(i){if(i.scheme!==w.USER_DATA_SYNC_SCHEME||i.authority!==He.c&&i.authority!==He.b)return;const t=[];for(;i.path!=="/";)t.unshift(this.d.basename(i)),i=this.d.dirname(i);if(t.length<2)return;const s=i.authority===He.b,a=t.shift(),r=t.shift();let f,b,y;for(;t.length;){const k=t.shift();k.startsWith("collection:")?f=k.substring(11):k.startsWith("ref:")?b=k.substring(4):y=k}return{remote:s,syncResource:a,profile:r,collection:f,ref:b,node:y}}K(i,t){try{const s=JSON.parse(i);if((0,S.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new w.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",t)}async L(i,t,s){const a=await this.e.resolveResourceContent(i,t,s);return{ref:t,content:a}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=ye([K(0,w.IUserDataSyncStoreService),K(1,w.IUserDataSyncBackupStoreService),K(2,w.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,l.IEnvironmentService),K(5,R.IStorageService),K(6,O.IFileService),K(7,P.IUserDataProfilesService),K(8,E.IConfigurationService),K(9,g.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[283],oe([0,1,21,6,25,38,3,2,23,12,31,17,29,5,20,19,18,121,122,123,124,125,126,127,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let s=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(y,k,T,F,j,x,V,B,X){super(),this.u=y,this.v=k,this.w=T,this.y=F,this.z=j,this.C=x,this.F=V,this.G=B,this.H=X,this.f="uninitialized",this.g=this.D(new N.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.D(new N.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.D(new N.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.D(new N.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.D(new N.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.q=this.D(new N.Emitter),this.onDidResetLocal=this.q.event,this.r=this.D(new N.Emitter),this.onDidResetRemote=this.r.event,this.t=new Map,this.f=k.userDataSyncStore?"idle":"uninitialized",this.m=this.C.getNumber(t,-1,void 0),this.D((0,R.toDisposable)(()=>this.W()))}async createSyncTask(y,k){this.X(),this.y.info("Sync started.");const T=new Date().getTime(),F=(0,P.generateUuid)();try{const B=(0,i.createSyncHeaders)(F);k&&(B["Cache-Control"]="no-cache"),y=await this.u.manifest(y,B)}catch(B){const X=i.UserDataSyncError.toUserDataSyncError(B);throw f(X,F,this.v,this.z),X}const j=!1,x=this;let V;return{manifest:y,async run(){if(j)throw new Error("Can run a task only once");V=(0,U.createCancelablePromise)(B=>x.I(y,!1,F,B)),await V.finally(()=>V=void 0),x.y.info(`Sync done. Took ${new Date().getTime()-T}ms`),x.S()},stop(){return V?.cancel(),x.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.y.info("Sync started.");const y=new Date().getTime(),k=(0,P.generateUuid)(),T=(0,i.createSyncHeaders)(k);let F;try{F=await this.u.manifest(null,T)}catch(V){const B=i.UserDataSyncError.toUserDataSyncError(V);throw f(B,k,this.v,this.z),B}await this.resetLocal();const j=this,x=new l.CancellationTokenSource;return{id:k,async merge(){return j.I(F,!0,k,x.token)},async apply(){try{try{await j.L(F,k,x.token)}catch(V){if(i.UserDataSyncError.toUserDataSyncError(V).code==="MethodNotFound")j.y.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.y.info("Applying manual sync again..."),await j.L(F,k,x.token);else throw V}}catch(V){throw j.y.error(V),V}j.y.info(`Sync done. Took ${new Date().getTime()-y}ms`),j.S()},async stop(){x.cancel(),await j.N(),await j.resetLocal()}}}async I(y,k,T,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(j,y,k,T,F));const x=j.enabled.find(V=>V.resource==="profiles");if(x){const V=await x.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J(V,y,k,T,F)}}finally{this.l.fire(this.k)}}async J(y,k,T,F,j){for(const x of y){if(j.isCancellationRequested)return;const V=this.G.profiles.find(X=>X.id===x.id);if(!V){this.y.error(`Profile with id:${x.id} and name: ${x.name} does not exist locally to sync.`);continue}this.y.info("Syncing profile.",x.name);const B=this.getOrCreateActiveProfileSynchronizer(V,x);this.k.push(...await this.M(B,k,T,F,j))}for(const[x,V]of this.t.entries())this.G.profiles.some(B=>B.id===V[0].profile.id)||(V[1].dispose(),this.t.delete(x))}async L(y,k,T){const F=this.U();for(const X of F){if(T.isCancellationRequested)return;await X.apply(k,T)}const j=F.find(X=>X.profile.isDefault);if(!j)return;const x=j.enabled.find(X=>X.resource==="profiles");if(!x)return;const B=(await x.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(X=>F.every(J=>J.profile.id!==X.id));B.length&&await this.J(B,y,!1,k,T)}async M(y,k,T,F,j){return(await y.sync(k,T,F,j)).map(([V,B])=>({profile:y.profile,syncResource:V,error:B}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(y=>y.stop()))}async resolveContent(y){const k=await this.H.resolveContent(y);if(k)return k;for(const T of this.U())for(const F of T.enabled){const j=await F.resolveContent(y);if(j)return j}return null}async replace(y){this.X();const k=this.H.resolveUserDataSyncResource(y);if(!k)return;const T=await this.resolveContent(y.uri);!T||await this.O(k.profile,async F=>{if(k.syncResource===F.resource)return await F.replace(T),!0})}async accept(y,k,T,F){this.X(),await this.O(y.profile,async j=>{if(y.syncResource===j.resource)return await j.accept(k,T),F&&await j.apply((0,w.isBoolean)(F)?!1:F.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(y,k){return this.H.getRemoteSyncResourceHandles(y,k)}async getLocalSyncResourceHandles(y,k){return this.H.getLocalSyncResourceHandles(y,k??this.G.defaultProfile)}async getAssociatedResources(y){return this.H.getAssociatedResources(y)}async getMachineId(y){return this.H.getMachineId(y)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.u.clear(),this.y.info("Cleared data on server")}catch(y){this.y.error(y)}this.r.fire()}async resetLocal(){this.X(),this.m=void 0,this.C.remove(t,-1);for(const[y]of this.t.values())try{await y.resetLocal()}catch(k){this.y.error(k)}this.W(),this.q.fire(),this.y.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.H.getRemoteSyncedProfiles(),k=y.map(x=>x.collection),T=await this.u.getAllCollections(),F=T.filter(x=>!k.includes(x));F.length&&(this.y.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(x=>this.u.deleteCollection(x))),this.y.info("Deleted redundant collections on server"));const j=y.filter(x=>T.includes(x.collection));if(j.length!==y.length){this.y.info("Updating remote profiles with invalid collections on server");const x=this.w.createInstance(o.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await x.updateRemoteProfiles(j,null),this.y.info("Updated remote profiles on server")}finally{x.dispose()}}}async O(y,k){const T=new R.DisposableStore;try{const F=this.t.get(y.id);if(F){const X=await this.P(F[0],k,T);return(0,w.isUndefined)(X)?null:X}if(y.isDefault){const X=T.add(this.w.createInstance(a,y,void 0)),J=await this.P(X,k,T);return(0,w.isUndefined)(J)?null:J}if(this.G.isEnabled())return null;const j=T.add(this.w.createInstance(o.UserDataProfilesManifestSynchroniser,y,void 0)),x=await this.u.manifest(null),B=(await j.getRemoteSyncedProfiles(x?.latest??null)||[]).find(X=>X.id===y.id);if(B){const X=T.add(this.w.createInstance(a,y,B.collection)),J=await this.P(X,k,T);return(0,w.isUndefined)(J)?null:J}return null}finally{T.dispose()}}async P(y,k,T){const F=[...y.enabled,...y.disabled.map(j=>T.add(y.createSynchronizer(j)))];for(const j of F){const x=await k(j);if(!(0,w.isUndefined)(x))return x}}Q(y){const k=this.f;this.f!==y&&(this.f=y,this.g.fire(y),k==="hasConflicts"&&this.S())}R(){const y=this.U().map(k=>k.conflicts).flat();(0,L.equals)(this.i,y,(k,T)=>k.profile.id===T.profile.id&&k.syncResource===T.syncResource&&(0,L.equals)(k.conflicts,T.conflicts,(F,j)=>(0,I.isEqual)(F.previewResource,j.previewResource)))||(this.i=y,this.j.fire(y))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.C.store(t,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(y,k){let T=this.t.get(y.id);if(T&&T[0].collection!==k?.collection&&(this.y.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.t.delete(y.id)),!T){const F=new R.DisposableStore,j=F.add(this.w.createInstance(a,y,k?.collection));F.add(j.onDidChangeStatus(x=>this.Q(x))),F.add(j.onDidChangeConflicts(x=>this.R())),F.add(j.onDidChangeLocal(x=>this.h.fire(x))),this.t.set(y.id,T=[j,F])}return T[0]}U(){const y=[];for(const[k]of this.t.values())y.push(k);return y}W(){this.t.forEach(([,y])=>y.dispose()),this.t.clear()}X(){if(!this.v.userDataSyncStore)throw new Error("Not enabled")}};s=ye([K(0,i.IUserDataSyncStoreService),K(1,i.IUserDataSyncStoreManagementService),K(2,d.IInstantiationService),K(3,i.IUserDataSyncLogService),K(4,E.ITelemetryService),K(5,m.IStorageService),K(6,i.IUserDataSyncEnablementService),K(7,c.IUserDataProfilesService),K(8,i.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let a=class extends R.Disposable{get enabled(){return this.f.sort((y,k)=>y[1]-k[1]).map(([y])=>y)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(y=>!this.l.isResourceEnabled(y))}get status(){return this.g}get conflicts(){return this.j}constructor(y,k,T,F,j,x,V,B,X,J){super(),this.profile=y,this.collection=k,this.l=T,this.m=F,this.n=j,this.q=x,this.r=V,this.t=B,this.u=X,this.v=J,this.f=[],this.g="idle",this.h=this.D(new N.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.D(new N.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.D(new N.Emitter),this.onDidChangeConflicts=this.k.event,this.D(T.onDidChangeResourceEnablement(([G,Y])=>this.w(G,Y))),this.D((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,G])=>G.dispose())));for(const G of i.ALL_SYNC_RESOURCES)T.isResourceEnabled(G)&&this.y(G)}w(y,k){k?this.y(y):this.z(y)}y(y){if(this.f.some(([j])=>j.resource===y))return;if(y==="extensions"&&!this.n.isEnabled()){this.t.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.u.isEnabled()))return;const k=new R.DisposableStore,T=k.add(this.createSynchronizer(y));k.add(T.onDidChangeStatus(()=>this.G())),k.add(T.onDidChangeConflicts(()=>this.H())),k.add(T.onDidChangeLocal(()=>this.i.fire(y)));const F=this.I(y);this.f.push([T,F,k])}z(y){const k=this.f.findIndex(([T])=>T.resource===y);if(k!==-1){const[[T,,F]]=this.f.splice(k,1);F.dispose(),this.G(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,j=>this.t.error(j))}}createSynchronizer(y){switch(y){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(D.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(o.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(y,k,T,F){if(F.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const x=[],V=(0,i.createSyncHeaders)(T),B=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,X=k?await this.C(B):{};for(const J of j){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(J.resource))return[];try{if(k){const G=await J.preview(B,X,V);if(G)for(const Y of G.resourcePreviews)(Y.localChange!==0||Y.remoteChange!==0)&&Y.mergeState==="preview"&&await J.merge(Y.previewResource)}else await J.sync(B,V)}catch(G){const Y=i.UserDataSyncError.toUserDataSyncError(G);if(f(Y,T,this.q,this.r),r(G))throw Y;this.t.error(G),this.t.error(`${J.resource}: ${(0,O.toErrorMessage)(G)}`),x.push([J.resource,Y])}}return x}finally{this.G()}}async apply(y,k){const T=(0,i.createSyncHeaders)(y);for(const F of this.enabled){if(k.isCancellationRequested)return;try{await F.apply(!1,T)}catch(j){const x=i.UserDataSyncError.toUserDataSyncError(j);if(f(x,y,this.q,this.r),r(j))throw x;this.t.error(j),this.t.error(`${F.resource}: ${(0,O.toErrorMessage)(j)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(k){this.t.error(k)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(k){this.t.error(`${y.resource}: ${(0,O.toErrorMessage)(k)}`),this.t.error(k)}}async C(y){if(!this.profile.isDefault)return{};const k=this.v.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),T=this.enabled.find(F=>F instanceof v.SettingsSynchroniser);if(T){const F=await T.getRemoteUserDataSyncConfiguration(y);return{...k,...F}}return k}F(y){this.g!==y&&(this.g=y,this.h.fire(y))}G(){return this.H(),this.enabled.some(y=>y.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const y=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,L.equals)(this.j,y,(k,T)=>k.syncResource===T.syncResource&&(0,L.equals)(k.conflicts,T.conflicts,(F,j)=>(0,I.isEqual)(F.previewResource,j.previewResource)))||(this.j=y,this.k.fire(y))}I(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([K(2,i.IUserDataSyncEnablementService),K(3,d.IInstantiationService),K(4,p.IExtensionGalleryService),K(5,i.IUserDataSyncStoreManagementService),K(6,E.ITelemetryService),K(7,i.IUserDataSyncLogService),K(8,c.IUserDataProfilesService),K(9,S.IConfigurationService)],a);function r(b){if(b instanceof i.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function f(b,y,k,T){T.publicLog2("sync/error",{code:b.code,serverCode:b instanceof i.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof i.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:y,service:k.userDataSyncStore.url.toString()})}}),define(re[284],oe([0,1,3,2,11,18,24]),function(te,e,L,U,l,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(p,d){return{...p,profile:(0,O.reviveProfile)(p.profile,d.profilesHome.scheme)}}function I(p){return{created:p.created,uri:l.URI.revive(p.uri)}}class w{constructor(d,m,E){this.c=d,this.d=m,this.f=E,this.a=new Map,this.b=new L.Emitter}listen(d,m){switch(m){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${m}`)}async call(d,m,E){try{return await this.g(d,m,E)}catch(c){throw this.f.error(c),c}}async g(d,m,E){switch(m){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(E[0]));case"accept":return this.c.accept(R(E[0],this.d),l.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(E[0],E[1]?(0,O.reviveProfile)(E[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.c.replace(I(E[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(E[0]));case"getMachineId":return this.c.getMachineId(I(E[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(m.startsWith("manualSync/")){const c=m.substring(11),u=E[0],h=this.h(u);switch(E=E.slice(1),c){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.a.delete(this.j(h.id)));case"stop":return h.stop().finally(()=>this.a.delete(this.j(h.id)))}}throw new Error("Invalid call")}h(d){const m=this.a.get(this.j(d));if(!m)throw new Error(`Manual sync taks not found: ${d}`);return m}async i(){const d=await this.c.createManualSyncTask();return this.a.set(this.j(d.id),d),d.id}j(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=w;let P=class extends U.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(d,m){super(),this.k=m,this.b="uninitialized",this.c=this.D(new L.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.D(new L.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.D(new L.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.D(new L.Emitter),this.onSyncErrors=this.j.event,this.a={call(E,c,u){return d.call(E,c,u).then(null,h=>{throw N.UserDataSyncError.toUserDataSyncError(h)})},listen(E,c){return d.listen(E,c)}},this.a.call("_getInitialData").then(([E,c,u])=>{this.l(E),this.m(c),u&&this.n(u),this.D(this.a.listen("onDidChangeStatus")(h=>this.l(h))),this.D(this.a.listen("onDidChangeLastSyncTime")(h=>this.n(h)))}),this.D(this.a.listen("onDidChangeConflicts")(E=>this.m(E))),this.D(this.a.listen("onSyncErrors")(E=>this.j.fire(E.map(c=>({...c,error:N.UserDataSyncError.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const d=await this.a.call("createManualSyncTask"),m=this;return new S(d,{async call(c,u,h){return m.a.call(`manualSync/${c}`,[d,...Array.isArray(u)?u:[u]],h)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(d,m,E,c){return this.a.call("accept",[d,m,E,c])}resolveContent(d){return this.a.call("resolveContent",[d])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(d,m){return(await this.a.call("getLocalSyncResourceHandles",[d,m])).map(({created:c,uri:u})=>({created:c,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(d,m){return(await this.a.call("getRemoteSyncResourceHandles",[d,m])).map(({created:c,uri:u})=>({created:c,uri:l.URI.revive(u)}))}async getAssociatedResources(d){return(await this.a.call("getAssociatedResources",[d])).map(({resource:E,comparableResource:c})=>({resource:l.URI.revive(E),comparableResource:l.URI.revive(c)}))}getMachineId(d){return this.a.call("getMachineId",[d])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(d){return this.a.call("replace",[d])}async l(d){this.b=d,this.c.fire(d)}async m(d){this.f=d.map(m=>({syncResource:m.syncResource,profile:(0,O.reviveProfile)(m.profile,this.k.profilesHome.scheme),conflicts:m.conflicts.map(E=>({...E,baseResource:l.URI.revive(E.baseResource),localResource:l.URI.revive(E.localResource),remoteResource:l.URI.revive(E.remoteResource),previewResource:l.URI.revive(E.previewResource)}))})),this.g.fire(this.f)}n(d){this.h!==d&&(this.h=d,this.i.fire(d))}};P=ye([K(1,O.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class S extends U.Disposable{constructor(d,m){super(),this.id=d,this.a=m}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[285],oe([0,1,6,25,10,3,2,142,4,23,12,11,31,17,15,14,26,59,44,20,24]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const D="sync.previous.store",n="sync.donot-make-requests-until",o="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let a=class extends N.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(T){this.h.store(v.SYNC_SERVICE_URL_TYPE,T,-1,I.isWeb?0:1)}constructor(T,F,j){super(),this.f=T,this.g=F,this.h=j,this.a=this.D(new O.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.D(O.Event.filter(j.onDidChangeValue,x=>x.key===v.SYNC_SERVICE_URL_TYPE&&x.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(T,F){T=I.isWeb&&T?.web?{...T,...T.web}:T;const j={...T||{},...F||{}};if(j&&(0,P.isString)(j.url)&&(0,P.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(x=>Array.isArray(j.authenticationProviders[x].scopes))){const x=j,V=!!x.canSwitch&&!F?.url,B=x.url===x.insidersUrl?"insiders":"stable",X=(V?this.c:void 0)||B,J=F?.url||(X==="insiders"?x.insidersUrl:X==="stable"?x.stableUrl:x.url);return{url:S.URI.parse(J),type:X,defaultType:B,defaultUrl:S.URI.parse(x.url),stableUrl:S.URI.parse(x.stableUrl),insidersUrl:S.URI.parse(x.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(x.authenticationProviders).reduce((G,Y)=>(G.push({id:Y,scopes:x.authenticationProviders[Y].scopes}),G),[])}}}};a=ye([K(0,c.IProductService),K(1,d.IConfigurationService),K(2,g.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let r=class extends a{constructor(T,F,j){super(T,F,j);const x=this.h.get(D,-1);x&&(this.k=JSON.parse(x));const V=this.f[v.CONFIGURATION_SYNC_STORE_KEY];V?this.h.store(D,JSON.stringify(V),-1,1):this.h.remove(D,-1)}async switch(T){T!==this.c&&(this.c=T,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};r=ye([K(0,c.IProductService),K(1,d.IConfigurationService),K(2,g.IStorageService)],r),e.UserDataSyncStoreManagementService=r;let f=class extends N.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(T,F,j,x,V,B,X){super(),this.k=j,this.l=x,this.n=X,this.g=this.D(new O.Emitter),this.onTokenFailed=this.g.event,this.h=this.D(new O.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.D(new O.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.p(T),this.c=(0,h.getServiceMachineId)(V,B,X).then(J=>{const G={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(G["X-Client-Commit"]=F.commit),G}),this.f=new y(t,s,this.k,this.l),this.q(),this.D((0,N.toDisposable)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(T,F){this.b={token:T,type:F}}p(T){this.a=T?(0,w.joinPath)(T,"v1"):void 0}q(){const T=this.n.getNumber(n,-1);T&&Date.now()<T&&this.s(new Date(T))}s(T){this.i?.getTime()!==T?.getTime()&&(this.i=T,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.r=(0,L.createCancelablePromise)(F=>(0,L.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.s(void 0))),this.r.then(null,F=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const j=await this.v(F,{type:"GET",headers:T},[],U.CancellationToken.None);return(await(0,u.asJson)(j))?.map(({id:x})=>x)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.Mimes.text;const j=await this.v(F,{type:"POST",headers:T},[],U.CancellationToken.None),x=await(0,u.asTextOrError)(j);if(!x)throw new v.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",j.res.statusCode,j.res.headers[v.HEADER_OPERATION_ID]);return x}async deleteCollection(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=T?(0,w.joinPath)(this.a,"collection",T).toString():(0,w.joinPath)(this.a,"collection").toString();F={...F},await this.v(j,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async getAllResourceRefs(T,F){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.t(this.a,F,T),x={},V=await this.v(j.toString(),{type:"GET",headers:x},[],U.CancellationToken.None);return(await(0,u.asJson)(V)||[]).map(({url:X,created:J})=>({ref:(0,w.relativePath)(j,j.with({path:X})),created:J*1e3}))}async resolveResourceContent(T,F,j,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,w.joinPath)(this.t(this.a,j,T),F).toString();x={...x},x["Cache-Control"]="no-cache";const B=await this.v(V,{type:"GET",headers:x},[],U.CancellationToken.None);return await(0,u.asTextOrError)(B)}async deleteResource(T,F,j){if(!this.a)throw new Error("No settings sync store url configured.");const x=F!==null?(0,w.joinPath)(this.t(this.a,j,T),F).toString():this.t(this.a,j,T).toString(),V={};await this.v(x,{type:"DELETE",headers:V},[],U.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,w.joinPath)(this.a,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.v(T,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async readResource(T,F,j,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=(0,w.joinPath)(this.t(this.a,j,T),"latest").toString();x={...x},x["Cache-Control"]="no-cache",F&&(x["If-None-Match"]=F.ref);const B=await this.v(V,{type:"GET",headers:x},[304],U.CancellationToken.None);let X=null;if(B.res.statusCode===304&&(X=F),X===null){const J=B.res.headers.etag;if(!J)throw new v.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",B.res.statusCode,B.res.headers[v.HEADER_OPERATION_ID]);const G=await(0,u.asTextOrError)(B);if(!G&&B.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",V,"EmptyResponse",B.res.statusCode,B.res.headers[v.HEADER_OPERATION_ID]);X={ref:J,content:G}}return X}async writeResource(T,F,j,x,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=this.t(this.a,x,T).toString();V={...V},V["Content-Type"]=R.Mimes.text,j&&(V["If-Match"]=j);const X=await this.v(B,{type:"POST",data:F,headers:V},[],U.CancellationToken.None),J=X.res.headers.etag;if(!J)throw new v.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",X.res.statusCode,X.res.headers[v.HEADER_OPERATION_ID]);return J}async manifest(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,w.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const x=await this.v(j,{type:"GET",headers:F},[304],U.CancellationToken.None);let V=null;if(x.res.statusCode===304&&(V=T),!V){const X=x.res.headers.etag;if(!X)throw new v.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",x.res.statusCode,x.res.headers[v.HEADER_OPERATION_ID]);const J=await(0,u.asTextOrError)(x);if(!J&&x.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",j,"EmptyResponse",x.res.statusCode,x.res.headers[v.HEADER_OPERATION_ID]);J&&(V={...JSON.parse(J),ref:X})}const B=this.n.get(o,-1);return B&&V&&B!==V.session&&this.u(),V===null&&B&&this.u(),V&&this.n.store(o,V.session,-1,1),V}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(T,F,j){return F?(0,w.joinPath)(T,"collection",F,"resource",j):(0,w.joinPath)(T,"resource",j)}u(){this.n.remove(o,-1),this.n.remove(i,-1)}async v(T,F,j,x){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const V=await this.c;F.headers={...F.headers||{},...V,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(F.headers),this.l.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let B;try{B=await this.f.request(T,F,x)}catch(H){if(!(H instanceof v.UserDataSyncStoreError)){let $="RequestFailed";const Z=(0,l.getErrorMessage)(H).toLowerCase();Z.includes("xhr timeout")?$="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?$="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":Z.includes("headers must be an object")?$="RequestHeadersNotObject":(0,l.isCancellationError)(H)&&($="RequestCanceled"),H=new v.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,$,void 0,void 0)}throw this.l.info("Request failed",T),H}const X=B.res.headers[v.HEADER_OPERATION_ID],J={url:T,status:B.res.statusCode,"execution-id":F.headers[v.HEADER_EXECUTION_ID],"operation-id":X},G=(0,u.isSuccess)(B)||B.res.statusCode&&j.indexOf(B.res.statusCode)!==-1;let Y="";if(G?this.l.trace("Request succeeded",J):(this.l.info("Request failed",J),Y=await(0,u.asText)(B)||""),B.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",B.res.statusCode,X);if(this.h.fire(),B.res.statusCode===404)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",B.res.statusCode,X);if(B.res.statusCode===405)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested endpoint is not found (405). ${Y}`,T,"MethodNotFound",B.res.statusCode,X);if(B.res.statusCode===409)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",B.res.statusCode,X);if(B.res.statusCode===410)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",B.res.statusCode,X);if(B.res.statusCode===412)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",B.res.statusCode,X);if(B.res.statusCode===413)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",B.res.statusCode,X);if(B.res.statusCode===426)throw new v.UserDataSyncStoreError(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",B.res.statusCode,X);if(B.res.statusCode===429){const H=B.res.headers["retry-after"];throw H?(this.s(new Date(Date.now()+parseInt(H)*1e3)),new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",B.res.statusCode,X)):new v.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",B.res.statusCode,X)}if(!G)throw new v.UserDataSyncStoreError("Server returned "+B.res.statusCode,T,"Unknown",B.res.statusCode,X);return B}w(T){let F=this.n.get(i,-1);F===void 0&&(F=(0,p.generateUuid)(),this.n.store(i,F,-1,1)),T["X-Machine-Session-Id"]=F;const j=this.n.get(o,-1);j!==void 0&&(T["X-User-Session-Id"]=j)}};f=ye([K(1,c.IProductService),K(2,u.IRequestService),K(3,v.IUserDataSyncLogService),K(4,m.IEnvironmentService),K(5,E.IFileService),K(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let b=class extends f{constructor(T,F,j,x,V,B,X){super(T.userDataSyncStore?.url,F,j,x,V,B,X),this.D(T.onDidChangeUserDataSyncStore(()=>this.p(T.userDataSyncStore?.url)))}};b=ye([K(0,v.IUserDataSyncStoreManagementService),K(1,c.IProductService),K(2,u.IRequestService),K(3,v.IUserDataSyncLogService),K(4,m.IEnvironmentService),K(5,E.IFileService),K(6,g.IStorageService)],b),e.UserDataSyncStoreService=b;class y{constructor(T,F,j,x){this.c=T,this.d=F,this.f=j,this.g=x,this.a=[],this.b=void 0}request(T,F,j){if(this.h()&&this.i(),F.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(F,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=y}),define(re[286],oe([0,1,3,57,26,20,19,281,24,77,80]),function(te,e,L,U,l,O,N,R,I,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends R.UserDataAutoSyncService{constructor(d,m,E,c,u,h,g,v,D,n,o){super(d,m,E,c,u,g,v,D,n,o),this.D(L.Event.debounce(L.Event.any(L.Event.map(h.onDidFocusWindow,()=>"windowFocus"),L.Event.map(h.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};S=ye([K(0,l.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,U.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,w.IUserDataSyncAccountService),K(8,N.ITelemetryService),K(9,P.IUserDataSyncMachinesService),K(10,O.IStorageService)],S),e.UserDataAutoSyncService=S}),define(re[287],oe([0,1,102,22,4,23]),function(te,e,L,U,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function N(w){function P(){let S=w.scheme===U.Schemas.file?(0,O.originalFSPath)(w):w.toString();return l.isLinux||(S=S.toLowerCase()),(0,L.createHash)("md5").update(S).digest("hex")}return{id:P(),configPath:w}}e.getWorkspaceIdentifier=N;function R(w,P){function S(){if(w.scheme!==U.Schemas.file)return(0,L.createHash)("md5").update(w.toString()).digest("hex");if(!P)return;let d;return l.isLinux?d=P.ino:l.isMacintosh?d=P.birthtime.getTime():l.isWindows&&(typeof P.birthtimeMs=="number"?d=Math.floor(P.birthtimeMs):d=P.birthtime.getTime()),(0,L.createHash)("md5").update(w.fsPath).update(d?String(d):"").digest("hex")}const p=S();if(typeof p=="string")return{id:p,uri:w}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[288],oe([0,1,6,10,2,13,28,15,9,75,119,287,57,71]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let m=class extends l.Disposable{constructor(c,u,h,g){super(),this.a=c,this.b=u,this.c=h,this.f=g,this.D(new L.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await N.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new w.StorageClient(this.f.getChannel("storage"));await Promise.all(c.map(async h=>{const g=(0,O.join)(this.a.workspaceStorageHome.fsPath,h);h.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||h===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===h)||await u.isUsed(g)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${h} as it seems to be an unused empty workspace.`),await N.Promises.rm(g))}))}catch(c){(0,U.onUnexpectedError)(c)}}};m=ye([K(0,R.INativeEnvironmentService),K(1,I.ILogService),K(2,p.INativeHostService),K(3,d.IMainProcessService)],m),e.UnusedWorkspaceStorageDataCleaner=m}),define(re[81],oe([0,1,54,6,13,12,28,154,297,298]),function(te,e,L,U,l,O,N,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class S extends Error{constructor(o,i){let t=i.message;switch(o){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=o,this.cause=i}}e.ExtractError=S;function p(n){const o=n.externalFileAttributes>>16||33188;return[448,56,7].map(i=>o&i).reduce((i,t)=>i+t,o&61440)}function d(n){if(n instanceof S)return n;let o;return P.test(n.message)&&(o="CorruptZip"),new S(o,n)}function m(n,o,i,t,s,a){const r=l.dirname(o),f=l.join(t,r);if(!f.startsWith(t))return Promise.reject(new Error(R.localize(0,null,o)));const b=l.join(t,o);let y;return a.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(N.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((k,T)=>{if(!a.isCancellationRequested)try{y=(0,L.createWriteStream)(b,{mode:i}),y.once("close",()=>k()),y.once("error",T),n.once("error",T),n.pipe(y)}catch(F){T(F)}}))}function E(n,o,i,t){let s=(0,U.createCancelablePromise)(()=>Promise.resolve()),a=0;return t.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((r,f)=>{const b=new U.Sequencer,y=k=>{k.isCancellationRequested||(a++,n.readEntry())};n.once("error",f),n.once("close",()=>s.then(()=>{t.isCancellationRequested||n.entryCount===a?r():f(new S("Incomplete",new Error(R.localize(1,null,a,n.entryCount))))},f)),n.readEntry(),n.on("entry",k=>{if(t.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){y(t);return}const T=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(T)){const x=l.join(o,T);s=(0,U.createCancelablePromise)(V=>N.Promises.mkdir(x,{recursive:!0}).then(()=>y(V)).then(void 0,f));return}const F=u(n,k),j=p(k);s=(0,U.createCancelablePromise)(x=>b.queue(()=>F.then(V=>m(V,T,j,o,i,x).then(()=>y(x)))).then(null,f))})})}function c(n,o=!1){return new Promise((i,t)=>{(0,I.open)(n,o?{lazyEntries:!0}:void 0,(s,a)=>{s?t(d(s)):i((0,O.assertIsDefined)(a))})})}function u(n,o){return new Promise((i,t)=>{n.openReadStream(o,(s,a)=>{s?t(d(s)):i((0,O.assertIsDefined)(a))})})}function h(n,o){return new Promise((i,t)=>{const s=new w.ZipFile;o.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const a=(0,L.createWriteStream)(n);s.outputStream.pipe(a),s.outputStream.once("error",t),a.once("error",t),a.once("finish",()=>i(n))})}e.zip=h;function g(n,o,i={},t){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=c(n,!0);return i.overwrite&&(a=a.then(r=>N.Promises.rm(o).then(()=>r))),a.then(r=>E(r,o,{sourcePathRegex:s},t))}e.extract=g;function v(n,o){return c(n).then(i=>new Promise((t,s)=>{i.on("entry",a=>{a.fileName===o&&u(i,a).then(r=>t(r),r=>s(r))}),i.once("close",()=>s(new Error(R.localize(2,null,o))))}))}function D(n,o){return v(n,o).then(i=>new Promise((t,s)=>{const a=[];i.once("error",s),i.on("data",r=>a.push(r)),i.on("end",()=>t(Buffer.concat(a)))}))}e.buffer=D}),define(re[289],oe([0,1,6,10,2,22,4,23,55,12,31,28,81,17,15,29,33,100,14,9]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends l.Disposable{constructor(n,o,i,t,s,a){super(),this.h=o,this.i=i,this.j=t,this.k=s,this.l=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(n,o){await this.g;const i=(0,R.joinPath)(this.extensionsDownloadDir,this.u(n));try{await this.q(n,i,s=>this.i.download(n,s,o))}catch(s){throw new E.ExtensionManagementError(s.message,E.ExtensionManagementErrorCode.Download)}let t="Unverified";if(this.m(n)){const s=await this.n(n);try{await this.k.verify(i.fsPath,s.fsPath,this.l.getLevel()===g.LogLevel.Trace)&&(t="Verified"),this.l.info(`Extension signature verification: ${n.identifier.id}. Verification status: ${t}.`)}catch(a){const r=a,f=r.code;if(r.output&&this.l.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${r.output}`),f==="UnknownError")t="UnknownError",this.l.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${t}.`);else{if(f==="PackageIsInvalidZip"||f==="SignatureArchiveIsInvalidZip")throw new E.ExtensionManagementError(p.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip);if(!r.didExecute)this.l.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${t} (${f})`);else throw await this.delete(i),new E.ExtensionManagementError(f,E.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(s)}catch(a){this.l.error(a)}}}return{location:i,verificationStatus:t}}m(n){if(!n.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,w.isBoolean)(o)?o:!0}async n(n){await this.g;const o=(0,R.joinPath)(this.extensionsDownloadDir,`${this.u(n)}${yt.c}`);return await this.q(n,o,i=>this.i.downloadSignatureArchive(n,i)),o}async q(n,o,i){if(await this.h.exists(o))return;if(o.scheme!==O.Schemas.file){await i(o);return}const t=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(t)||await i(t);try{await this.r(t,o,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(t)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,U.getErrorMessage)(s)}. Deleted the file from downloaded location`,t.path),s}}async delete(n){await this.g,await this.h.del(n)}async r(n,o,i){try{await S.Promises.rename(n.fsPath,o.fsPath)}catch(t){if(N.isWindows&&t&&t.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${n} to ${o} with 'EPERM' error. Trying again...`),this.r(n,o,i);throw t}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const o=[],i=[],t=[];for(const r of n.children)if(r.name.endsWith(yt.c))t.push(r.resource);else{const f=c.ExtensionKey.parse(r.name);f&&i.push([f,r])}const s=(0,c.groupByExtension)(i,([r])=>r),a=[];for(const r of s)r.sort((f,b)=>I.rcompare(f[0].version,b[0].version)),o.push(...r.slice(1).map(f=>f[1].resource)),a.push(r[0][1]);a.sort((r,f)=>r.mtime-f.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(r=>r.resource)),o.push(...t),await L.Promises.settled(o.map(r=>(this.l.trace("Deleting from cache",r.path),this.h.del(r))))}}catch(n){this.l.error(n)}}u(n){return this.f?c.ExtensionKey.create(n).toString().toLowerCase():(0,P.generateUuid)()}};v.c=".sigzip",v=ye([K(0,m.INativeEnvironmentService),K(1,h.IFileService),K(2,E.IExtensionGalleryService),K(3,d.IConfigurationService),K(4,u.IExtensionSignatureVerificationService),K(5,g.ILogService)],v),e.ExtensionsDownloader=v}),define(re[290],oe([0,1,81,166]),function(te,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(O){return(0,L.buffer)(O,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}e.getManifest=l}),define(re[128],oe([0,1,6,16,25,38,10,3,2,37,22,13,4,23,55,12,11,31,28,81,165,99,15,270,29,33,51,78,289,271,290,225,240,46,67,14,5,9,26,19,30,18]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D,n,o,i,t,s,a,r,f,b,y,k,T,F,j,x,V,B,X,J,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,x.refineServiceDecorator)(i.IExtensionManagementService);let Y=class extends o.AbstractExtensionManagementService{constructor(q,C,A,M,z,_,W,Q,ee,le,he,pe){super(q,C,A,le,pe),this.Z=z,this.ab=_,this.bb=W,this.cb=ee,this.db=he,this.X=this.D(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new w.ResourceSet;const de=this.D(Q.createInstance(f.ExtensionsLifecycle));this.S=this.D(Q.createInstance(H,Ce=>de.postUninstall(Ce))),this.U=this.D(new y.ExtensionsManifestCache(M,this)),this.W=this.D(Q.createInstance(r.ExtensionsDownloader));const be=this.D(new k.ExtensionsWatcher(this,this.Z,pe,_,he,ee,A));this.D(be.onDidChangeExtensionsByAnotherSource(Ce=>this.kb(Ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,t.computeTargetPlatform)(this.cb,this.u)),this.eb}async zip(q){this.u.trace("ExtensionManagementService#zip",q.identifier.id);const C=await this.jb(q),A=await(0,g.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,C);return c.URI.file(A)}async unzip(q){return this.u.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:C,cleanup:A}=await this.fb(q),M=S.resolve(C.fsPath);try{return await(0,b.getManifest)(M)}finally{await A()}}getInstalled(q,C=this.w.defaultProfile.extensionsResource){return this.S.scanExtensions(q??null,C)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.S.scanUserExtensionAtLocation(q)}async install(q,C={}){this.u.trace("ExtensionManagementService#install",q.toString());const{location:A,cleanup:M}=await this.fb(q);try{const z=await(0,b.getManifest)(S.resolve(A.fsPath));if(z.engines&&z.engines.vscode&&!(0,F.isEngineValid)(z.engines.vscode,this.v.version,this.v.date))throw new Error(v.localize(0,null,(0,t.getGalleryExtensionId)(z.publisher,z.name),this.v.version));return await this.y(z,A,C)}finally{await M()}}async installFromLocation(q,C){this.u.trace("ExtensionManagementService#installFromLocation",q.toString());const A=await this.S.scanUserExtensionAtLocation(q);if(!A)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.ob([[A,void 0]],C),this.u.info("Successfully installed extension",A.identifier.id,C.toString()),A}async installExtensionsFromProfile(q,C,A){this.u.trace("ExtensionManagementService#installExtensionsFromProfile",q,C.toString(),A.toString());const M=(await this.S.scanExtensions(1,C)).filter(z=>q.some(_=>(0,t.areSameExtensions)(_,z.identifier)));if(M.length){const z=await Promise.all(M.map(_=>this.S.scanMetadata(_,C)));await this.ob(M.map((_,W)=>[_,z[W]]),A),this.u.info("Successfully installed extensions",M.map(_=>_.identifier.id),A.toString())}return M}async updateMetadata(q,C,A=this.w.defaultProfile.extensionsResource){return this.u.trace("ExtensionManagementService#updateMetadata",q.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.pinned=C.pinned||void 0,q=await this.S.updateMetadata(q,C,A),this.U.invalidate(),this.X.fire(q),q}async reinstallFromGallery(q){if(this.u.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.s.isEnabled())throw new Error(v.localize(1,null));const C=await this.getTargetPlatform(),[A]=await this.s.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:C,compatible:!0},l.CancellationToken.None);if(!A)throw new Error(v.localize(2,null));await this.S.setUninstalled(q);try{await this.S.removeUninstalledExtension(q)}catch(M){throw new Error(v.localize(3,null,(0,O.toErrorMessage)(M)))}return this.installFromGallery(A)}copyExtensions(q,C){return this.S.copyExtensions(q,C)}markAsUninstalled(...q){return this.S.setUninstalled(...q)}async cleanUp(){this.u.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(q){this.u.error(q)}}async download(q,C){const{location:A}=await this.W.download(q,C);return A}async fb(q){if(q.scheme===P.Schemas.file)return{location:q,async cleanup(){}};this.u.trace("Downloading extension from",q.toString());const C=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(q,C),this.u.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.cb.del(C)}catch(M){this.u.error(M)}}}}P(){return this.w.defaultProfile.extensionsResource}Q(q,C,A){if(c.URI.isUri(C))return new ie(q,C,A,this.s,this.S,this.db,this.w,this.Z,this.ab,this.u);const M=t.ExtensionKey.create(C).toString();let z=this.Y.get(M);return z||(this.Y.set(M,z=new Z(q,C,A,this.W,this.S,this.db,this.w,this.Z,this.ab,this.u)),z.waitUntilTaskIsFinished().then(()=>this.Y.delete(M))),z}R(q,C){return new se(q,C.profileLocation,this.ab)}async jb(q){const C=async M=>{let z=await h.Promises.readdir(M);z=z.map(Q=>S.join(M,Q));const _=await Promise.all(z.map(Q=>h.Promises.stat(Q)));let W=Promise.resolve([]);return _.forEach((Q,ee)=>{const le=z[ee];Q.isFile()&&(W=W.then(he=>[...he,le])),Q.isDirectory()&&(W=W.then(he=>C(le).then(pe=>[...he,...pe])))}),W};return(await C(q.location.fsPath)).map(M=>({path:`extension/${S.relative(q.location.fsPath,M)}`,localPath:M}))}async kb({added:q,removed:C}){if(C)for(const A of C.extensions)this.u.info("Extensions removed from another source",A.id,C.profileLocation.toString()),this.p.fire({identifier:A,profileLocation:C.profileLocation});if(q){const M=(await this.S.scanExtensions(1,q.profileLocation)).filter(z=>q.extensions.some(_=>(0,t.areSameExtensions)(_,z.identifier)));this.m.fire(M.map(z=>(this.u.info("Extensions added from another source",z.identifier.id,q.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:q.profileLocation,operation:1})))}}async mb(){this.D(this.S.onExtract(C=>this.lb.add(C)));const q=await this.cb.resolve(this.Z.userExtensionsLocation);for(const C of q.children??[])C.isDirectory&&this.lb.add(C.resource);this.D(this.cb.watch(this.Z.userExtensionsLocation)),this.D(this.cb.onDidFilesChange(C=>this.nb(C)))}async nb(q){if(!q.affects(this.Z.userExtensionsLocation,1))return;const C=[];for(const A of q.rawAdded){if(this.lb.has(A)||!this.db.extUri.isEqual(this.db.extUri.dirname(A),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(A,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(A).startsWith(".")||!(await this.cb.stat(A)).isDirectory)continue;const M=await this.S.scanUserExtensionAtLocation(A);M&&M.installedTimestamp===void 0&&(this.lb.add(A),C.push(M))}C.length&&(await this.ob(C.map(A=>[A,void 0]),this.w.defaultProfile.extensionsResource),this.u.info("Added extensions to default profile from external source",C.map(A=>A.identifier.id)))}async ob(q,C){const A=q.map(M=>M[0]);await this.pb(A),await this.ab.addExtensionsToProfile(q,C),this.m.fire(A.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:C})))}async pb(q){const C=await this.S.getUninstalledExtensions();for(const A of q){const M=t.ExtensionKey.create(A);!C[M.toString()]||(this.u.trace("Removing the extension from uninstalled list:",M.id),await this.S.setInstalled(M),this.u.info("Removed the extension from uninstalled list:",M.id))}}};Y=ye([K(0,i.IExtensionGalleryService),K(1,X.ITelemetryService),K(2,V.ILogService),K(3,n.INativeEnvironmentService),K(4,a.IExtensionsScannerService),K(5,s.IExtensionsProfileScannerService),K(6,D.IDownloadService),K(7,x.IInstantiationService),K(8,j.IFileService),K(9,B.IProductService),K(10,J.IUriIdentityService),K(11,G.IUserDataProfilesService)],Y),e.ExtensionManagementService=Y;let H=class extends I.Disposable{constructor(q,C,A,M,z,_){super(),this.k=q,this.l=C,this.m=A,this.n=M,this.p=z,this.q=_,this.h=this.D(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,d.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new L.Queue}async cleanUp(){await this.y(),this.j=this.j.then(()=>this.z()),await this.j}async scanExtensions(q,C){const A={includeInvalid:!0,profileLocation:C};let M=[];return q===null||q===0?M.push(...await this.m.scanAllExtensions({includeInvalid:!0},A,!1)):q===1&&M.push(...await this.m.scanUserExtensions(A)),M=q!==null?M.filter(z=>z.type===q):M,Promise.all(M.map(z=>this.w(z)))}async scanAllUserExtensions(q){const C=await this.m.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return Promise.all(C.map(A=>this.w(A)))}async scanUserExtensionAtLocation(q){try{const C=await this.m.scanExistingExtension(q,1,{includeInvalid:!0});if(C)return await this.w(C)}catch(C){this.q.error(C)}return null}async extractUserExtension(q,C,A,M){await this.j.catch(()=>{});const z=q.toString(),_=S.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),W=S.join(this.m.userExtensionsLocation.fsPath,z);try{await h.Promises.rm(W)}catch{throw new i.ExtensionManagementError(v.localize(4,null,W,q.id),i.ExtensionManagementErrorCode.Delete)}await this.t(q,C,_,M),await this.m.updateMetadata(c.URI.file(_),A);try{this.h.fire(c.URI.file(W)),await this.u(q,_,W,Date.now()+2*60*1e3),this.q.info("Renamed to",W)}catch(Q){try{await h.Promises.rm(_)}catch{}if(Q.code==="ENOTEMPTY")this.q.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.q.info(`Rename failed because of ${(0,N.getErrorMessage)(Q)}. Deleted from extracted location`,_),Q}return this.v(c.URI.file(W),1)}async scanMetadata(q,C){return C?(await this.n.scanProfileExtensions(C)).find(M=>(0,t.areSameExtensions)(M.identifier,q.identifier))?.metadata:this.m.scanMetadata(q.location)}async updateMetadata(q,C,A){return A?await this.n.updateMetadata([[q,C]],A):await this.m.updateMetadata(q.location,C),this.v(q.location,q.type)}getUninstalledExtensions(){return this.s()}async setUninstalled(...q){const C=q.map(A=>t.ExtensionKey.create(A));await this.s(A=>C.forEach(M=>{A[M.toString()]=!0,this.q.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(q){await this.s(C=>delete C[q.toString()])}async removeExtension(q,C){this.q.trace(`Deleting ${C} extension from disk`,q.identifier.id,q.location.fsPath);const A=this.p.extUri.joinPath(this.p.extUri.dirname(q.location),`.${(0,u.generateUuid)()}`);await this.u(q.identifier,q.location.fsPath,A.fsPath,Date.now()+2*60*1e3),await this.l.del(A,{recursive:!0}),this.q.info("Deleted from disk",q.identifier.id,q.location.fsPath)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.s(C=>delete C[t.ExtensionKey.create(q).toString()])}async copyExtensions(q,C){const A=await this.scanExtensions(1,q),M=await Promise.all(A.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,q)]));await this.n.addExtensionsToProfile(M,C)}async s(q){return this.g.queue(async()=>{let C;try{C=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,j.toFileOperationResult)(M)!==1)throw M}let A={};if(C)try{A=JSON.parse(C)}catch{}return q&&(q(A),Object.keys(A).length?await this.l.writeFile(this.c,U.VSBuffer.fromString(JSON.stringify(A))):await this.l.del(this.c)),A})}async t(q,C,A,M){this.q.trace(`Started extracting the extension from ${C} to ${A}`);try{await h.Promises.rm(A)}catch(z){throw new i.ExtensionManagementError(this.C(z).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(C,A,{sourcePath:"extension",overwrite:!0},M),this.q.info(`Extracted extension to ${A}:`,q.id)}catch(z){try{await h.Promises.rm(A)}catch{}let _=i.ExtensionManagementErrorCode.Extract;throw z instanceof g.ExtractError&&(z.type==="CorruptZip"?_=i.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(_=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(z.message,_)}}async u(q,C,A,M){try{await h.Promises.rename(C,A)}catch(z){if(p.isWindows&&z&&z.code==="EPERM"&&Date.now()<M)return this.q.info(`Failed renaming ${C} to ${A} with 'EPERM' error. Trying again...`,q.id),this.u(q,C,A,M);throw new i.ExtensionManagementError(z.message||v.localize(5,null,C,A),z.code||i.ExtensionManagementErrorCode.Rename)}}async v(q,C){const A=await this.m.scanExistingExtension(q,C,{includeInvalid:!0});if(A)return this.w(A);throw new Error(v.localize(6,null,q.path))}async w(q){const C=await this.l.resolve(q.location);let A,M;return C.children&&(A=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,M=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:A,changelogUrl:M,publisherDisplayName:q.metadata?.publisherDisplayName||null,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned}}async y(){const q=await this.getUninstalledExtensions();this.q.debug("Removing uninstalled extensions:",Object.keys(q));const C=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),A=new Set;for(const z of C)q[t.ExtensionKey.create(z).toString()]||A.add(z.identifier.id.toLowerCase());try{const z=(0,t.groupByExtension)(C,_=>_.identifier);await L.Promises.settled(z.map(async _=>{const W=_.sort((Q,ee)=>m.rcompare(Q.manifest.version,ee.manifest.version))[0];A.has(W.identifier.id.toLowerCase())||await this.k(await this.w(W))}))}catch(z){this.q.error(z)}const M=C.filter(z=>z.metadata&&q[t.ExtensionKey.create(z).toString()]);await Promise.allSettled(M.map(z=>this.removeUninstalledExtension(z)))}async z(){this.q.trace("ExtensionManagementService#removeGeneratedFolders");const q=[];let C;try{C=await this.l.resolve(this.m.userExtensionsLocation)}catch(A){(0,j.toFileOperationResult)(A)!==1&&this.q.error(A)}for(const A of C?.children??[])A.isDirectory&&A.name.startsWith(".")&&(0,u.isUUID)(A.name.substring(1))&&q.push((async()=>{this.q.trace("Deleting the generated extension folder",A.resource.toString());try{await this.l.del(A.resource,{recursive:!0}),this.q.info("Deleted the generated extension folder",A.resource.toString())}catch(M){this.q.error(M)}})());await Promise.allSettled(q)}C(q){const C=Array.isArray(q)?q:[q];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((A,M)=>new Error(`${A.message}${A.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};H=ye([K(1,j.IFileService),K(2,a.IExtensionsScannerService),K(3,s.IExtensionsProfileScannerService),K(4,J.IUriIdentityService),K(5,V.ILogService)],H),e.ExtensionsScanner=H;class $ extends o.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,E.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(q,C,A,M,z,_,W,Q,ee){super(),this.identifier=q,this.source=C,this.l=A,this.m=M,this.n=z,this.o=_,this.p=W,this.q=Q,this.s=ee,this.j="Unverified",this.k=2}async h(q){const[C,A]=await this.x(q);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,A]],this.l.profileLocation),C}async u({zipPath:q,key:C,metadata:A},M){let z=await this.v(C);return z||(this.s.trace("Extracting extension...",C.id),z=await this.m.extractUserExtension(C,q,A,M),this.s.info("Extracting extension completed.",C.id)),z}async v(q){return await this.w(q)?(this.s.trace("Removing the extension from uninstalled list:",q.id),await this.m.setInstalled(q),this.s.info("Removed the extension from uninstalled list:",q.id),(await this.m.scanAllUserExtensions(!0)).find(M=>t.ExtensionKey.create(M).equals(q))):void 0}async w(q){return!!(await this.m.getUninstalledExtensions())[q.toString()]}}class Z extends ${constructor(q,C,A,M,z,_,W,Q,ee,le){super(C.identifier,C,A,z,_,W,Q,ee,le),this.y=q,this.z=C,this.A=M}async x(q){const A=(await this.m.scanExtensions(null,this.l.profileLocation)).find(W=>(0,t.areSameExtensions)(W.identifier,this.z.identifier));A&&(this.k=3);const M={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,T.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||A?.isMachineScoped,isBuiltin:this.l.isBuiltin||A?.isBuiltin,isSystem:A?.type===0?!0:void 0,updated:!!A,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,E.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:A?.preRelease)};if(A?.manifest.version===this.z.version)return[await this.m.updateMetadata(A,M),M];const{location:z,verificationStatus:_}=await this.A.download(this.z,this.k);try{return this.j=_,this.C(z.fsPath),[await this.u({zipPath:z.fsPath,key:t.ExtensionKey.create(this.z),metadata:M},q),M]}catch(W){try{await this.A.delete(z)}catch(Q){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,N.getErrorMessage)(Q))}throw W}}async C(q){try{await(0,b.getManifest)(q)}catch(C){throw new i.ExtensionManagementError((0,o.joinErrors)(C).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=Z;class ie extends ${constructor(q,C,A,M,z,_,W,Q,ee,le){super({id:(0,t.getGalleryExtensionId)(q.publisher,q.name)},C,A,z,_,W,Q,ee,le),this.y=q,this.z=C,this.A=M}async h(q){const C=await super.h(q);return this.D(C,q),C}async x(q){const C=new t.ExtensionKey(this.identifier,this.y.version),M=(await this.m.scanExtensions(1,this.l.profileLocation)).find(W=>(0,t.areSameExtensions)(this.identifier,W.identifier)),z={isApplicationScoped:(0,T.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||M?.isMachineScoped,isBuiltin:this.l.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0};if(M)if(this.k=3,C.equals(new t.ExtensionKey(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(v.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&m.gt(M.manifest.version,this.y.version)&&await this.m.setUninstalled(M);else{const W=await this.v(C);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(v.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:S.resolve(this.z.fsPath),key:C,metadata:z},q),z]}async D(q,C){try{let[A]=await this.A.getExtensions([{id:q.identifier.id,version:q.manifest.version}],C);if(A||([A]=await this.A.getExtensions([{id:q.identifier.id}],C)),A){const M={id:A.identifier.uuid,publisherDisplayName:A.publisherDisplayName,publisherId:A.publisherId,isPreReleaseVersion:A.properties.isPreReleaseVersion,preRelease:A.properties.isPreReleaseVersion||this.l.installPreReleaseVersion};await this.m.updateMetadata(q,M,this.l.profileLocation)}}catch{}}}class se extends o.AbstractExtensionTask{constructor(q,C,A){super(),this.extension=q,this.j=C,this.k=A}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[291],oe([0,1,2,29,79,239,128,9,20]),function(te,e,L,U,l,O,N,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let w=class extends L.Disposable{constructor(S,p,d,m,E,c){super(),S.cleanUp(),(0,O.migrateUnsupportedExtensions)(S,p,d,m,c),l.ExtensionStorageService.removeOutdatedExtensionVersions(S,E)}};w=ye([K(0,N.INativeServerExtensionManagementService),K(1,U.IExtensionGalleryService),K(2,l.IExtensionStorageService),K(3,U.IGlobalExtensionEnablementService),K(4,I.IStorageService),K(5,R.ILogService)],w),e.ExtensionsContributions=w}),define(re[299],oe([0,1,150,232,251,34,38,10,2,22,11,39,152,218,219,211,212,288,202,204,17,223,98,236,99,229,15,233,120,274,29,100,203,128,101,14,214,215,68,5,210,70,72,242,9,106,107,26,59,20,112,19,113,114,115,47,245,117,254,79,118,24,77,279,265,266,80,280,283,284,285,61,278,268,111,235,76,256,227,255,110,30,257,4,258,205,221,220,78,273,18,51,217,58,277,244,269,109,282,291,7,216,267,87,105,237,272,230,199,57,286,275,71,276]),function(te,e,L,U,l,O,N,R,I,w,P,S,p,d,m,E,c,u,h,g,v,D,n,o,i,t,s,a,r,f,b,y,k,T,F,j,x,V,B,X,J,G,Y,H,$,Z,ie,se,ae,q,C,A,M,z,_,W,Q,ee,le,he,pe,de,be,Ce,Re,ke,We,Ye,ce,fe,ge,Ie,Pe,Fe,Le,qe,Me,Ne,je,ne,ue,me,we,ve,Ee,De,Ae,Te,Ue,$e,ze,et,nt,vt,Rt,kt,Lt,wt,At,Ot,Tt,Nt,Ut,Ze,St,Mt,Ft,jt,$t,zt,qt,Wt,bt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class xt extends I.Disposable{constructor(Se,Oe){super(),this.f=Se,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.D(new p.Server):this.a=this.D(new L.Server),this.h()}h(){let Se=!1;const Oe=()=>{Se||(Se=!0,this.c?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Oe),(0,Ze.isUtilityProcess)(process)?(0,p.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe):this.g.once("vscode:electron-main->shared-process=exit",Oe),!(0,Ze.isUtilityProcess)(process)){const xe="vscode:electron-main->shared-process=disposeWorker",Be=(st,Ve)=>{this.i(Ve)};this.g.on(xe,Be),this.D((0,I.toDisposable)(()=>this.g.removeListener(xe,Be)))}}i(Se){this.b?.disposeWorker(Se)}async init(){const Se=await this.j();(0,de.registerConfiguration)(),Se.invokeFunction(Oe=>{const xe=Oe.get($.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(xe)}),this.D((0,I.combinedDisposable)(Se.createInstance(d.CodeCacheCleaner,this.f.codeCachePath),Se.createInstance(m.LanguagePackCachedDataCleaner),Se.createInstance(u.UnusedWorkspaceStorageDataCleaner),Se.createInstance(c.LogsDataCleaner),Se.createInstance(E.LocalizationsUpdater),Se.createInstance(Ot.ExtensionsContributions),Se.createInstance(Lt.UserDataProfilesCleaner)))}async j(){const Se=new G.ServiceCollection,Oe={_serviceBrand:void 0,...ie.default};Se.set(se.IProductService,Oe);const xe=new S.StaticRouter(Ke=>Ke==="main"),Be=new bt.MainProcessService(this.a,xe);Se.set(bt.IMainProcessService,Be);const st=this.f.policiesData?new nt.PolicyChannelClient(this.f.policiesData,Be.getChannel("policy")):new vt.NullPolicyService;Se.set(vt.IPolicyService,st);const Ve=new a.SharedProcessEnvironmentService(this.f.args,Oe);Se.set(s.INativeEnvironmentService,Ve);const _e=new Z.LoggerChannelClient(void 0,this.f.logLevel,Ve.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:P.URI.revive(Ke.resource)})),Be.getChannel("logger"));Se.set($.ILoggerService,_e);const ct=this.D(_e.createLogger("sharedprocess",{name:(0,Tt.localize)(0,null)})),ht=this.D(new $.ConsoleLogger(ct.getLevel())),Ge=this.D(new Nt.LogService(ct,[ht]));Se.set($.ILogService,Ge),this.c=this.D(new St.SharedProcessLifecycleService(Ge)),Se.set(St.ISharedProcessLifecycleService,this.c),this.b=new U.SharedProcessWorkerService(Ge),Se.set(ue.ISharedProcessWorkerService,this.b);const Qe=this.D(new x.FileService(Ge));Se.set(j.IFileService,Qe);const ft=this.D(new V.DiskFileSystemProvider(Ge));Qe.registerProvider(w.Schemas.file,ft);const dt=this.D(new Ee.FileUserDataProvider(w.Schemas.file,this.D(new De.DiskFileSystemProviderClient(Be.getChannel(De.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ve.isLinux})),w.Schemas.vscodeUserData,Ge));Qe.registerProvider(w.Schemas.vscodeUserData,dt);const tt=this.D(new Rt.UserDataProfilesService(this.f.profiles.all,P.URI.revive(this.f.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),Be.getChannel("userDataProfiles")));Se.set(ze.IUserDataProfilesService,tt);const Je=this.D(new D.ConfigurationService(tt.defaultProfile.settingsResource,Qe,st,Ge));Se.set(v.IConfigurationService,Je);const rt=new Bt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Be,Ve);Se.set(q.IStorageService,rt),this.D((0,I.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const gt=new we.UriIdentityService(Qe);Se.set(me.IUriIdentityService,gt),Se.set(ae.IRequestService,new jt.RequestChannelClient(Be.getChannel("request"))),Se.set(h.IChecksumService,new B.SyncDescriptor(g.ChecksumService,void 0,!1)),Se.set(Te.IV8InspectProfilingService,new B.SyncDescriptor(Ae.InspectProfilingService,void 0,!1));const lt=S.ProxyChannel.toService(Be.getChannel("nativeHost"),{context:this.f.windowId});Se.set(zt.INativeHostService,lt),Se.set(i.IDownloadService,new B.SyncDescriptor(t.DownloadService,void 0,!0));const mt=this.D(new Fe.ActiveWindowManager(lt)),Vt=new S.StaticRouter(Ke=>mt.getActiveClientId().then(pt=>Ke===pt));Se.set(F.IExtensionRecommendationNotificationService,new $t.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Vt)));let ut;const ot=[],Ct=(0,W.isInternalTelemetry)(Oe,Je);if((0,W.supportsTelemetry)(Oe,Ve)){const Ke=new z.TelemetryLogAppender(Ge,_e,Ve,Oe);ot.push(Ke);const{installSourcePath:pt}=Ve;if(Oe.aiConfig?.ariaKey){const Pt=new kt.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.D((0,I.toDisposable)(()=>Pt.flush())),ot.push(Pt)}ut=new _.TelemetryService({appenders:ot,commonProperties:(0,C.resolveCommonProperties)(Qe,(0,O.release)(),(0,O.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,Ct,pt),sendErrorTelemetry:!0,piiPaths:(0,W.getPiiPathsFromEnvironment)(Ve)},Je,Oe)}else{ut=W.NullTelemetryService;const Ke=W.NullAppender;ot.push(Ke)}this.a.registerChannel("telemetryAppender",new M.TelemetryAppenderChannel(ot)),Se.set(A.ITelemetryService,ut);const Ht=new Q.CustomEndpointTelemetryService(Je,ut,Ge,_e,Ve,Oe);Se.set(A.ICustomEndpointTelemetryService,Ht),Se.set(et.IExtensionsProfileScannerService,new B.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Se.set(Ue.IExtensionsScannerService,new B.SyncDescriptor($e.ExtensionsScannerService,void 0,!0)),Se.set(y.IExtensionSignatureVerificationService,new B.SyncDescriptor(y.ExtensionSignatureVerificationService,void 0,!0)),Se.set(T.INativeServerExtensionManagementService,new B.SyncDescriptor(T.ExtensionManagementService,void 0,!0)),Se.set(b.IExtensionGalleryService,new B.SyncDescriptor(f.ExtensionGalleryService,void 0,!0)),Se.set(b.IExtensionTipsService,new B.SyncDescriptor(Wt.ExtensionTipsService,void 0,!1)),Se.set(Y.ILanguagePackService,new B.SyncDescriptor(H.NativeLanguagePackService,void 0,!1)),Se.set(n.IDiagnosticsService,new B.SyncDescriptor(o.DiagnosticsService,void 0,!1)),Se.set(be.IUserDataSyncAccountService,new B.SyncDescriptor(be.UserDataSyncAccountService,void 0,!0)),Se.set(de.IUserDataSyncLogService,new B.SyncDescriptor(ke.UserDataSyncLogService,void 0,!0)),Se.set(de.IUserDataSyncUtilService,new Re.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),Se.set(b.IGlobalExtensionEnablementService,new B.SyncDescriptor(r.GlobalExtensionEnablementService,void 0,!1)),Se.set(pe.IIgnoredExtensionsManagementService,new B.SyncDescriptor(pe.IgnoredExtensionsManagementService,void 0,!0)),Se.set(he.IExtensionStorageService,new B.SyncDescriptor(he.ExtensionStorageService)),Se.set(de.IUserDataSyncStoreManagementService,new B.SyncDescriptor(ge.UserDataSyncStoreManagementService,void 0,!0)),Se.set(de.IUserDataSyncStoreService,new B.SyncDescriptor(ge.UserDataSyncStoreService,void 0,!0)),Se.set(We.IUserDataSyncMachinesService,new B.SyncDescriptor(We.UserDataSyncMachinesService,void 0,!0)),Se.set(de.IUserDataSyncBackupStoreService,new B.SyncDescriptor(Ce.UserDataSyncBackupStoreService,void 0,!1)),Se.set(de.IUserDataSyncEnablementService,new B.SyncDescriptor(Ye.UserDataSyncEnablementService,void 0,!0)),Se.set(de.IUserDataSyncService,new B.SyncDescriptor(ce.UserDataSyncService,void 0,!1)),Se.set(Ie.IUserDataProfileStorageService,new B.SyncDescriptor(Pe.NativeUserDataProfileStorageService,void 0,!0)),Se.set(de.IUserDataSyncResourceProviderService,new B.SyncDescriptor(At.UserDataSyncResourceProviderService,void 0,!0));const It=new le.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Je,Ve,Ge,_e);return It.initialize(),Se.set(l.ILocalPtyService,this.D(It)),Se.set(Le.ISignService,new B.SyncDescriptor(qe.SignService,void 0,!1)),Se.set(Me.ISharedTunnelsService,new B.SyncDescriptor(Ne.SharedTunnelsService)),Se.set(je.ISharedProcessTunnelService,new B.SyncDescriptor(ne.SharedProcessTunnelService)),Se.set(wt.IRemoteTunnelService,new B.SyncDescriptor(Mt.RemoteTunnelService)),new J.InstantiationService(Se)}k(Se){const Oe=new k.ExtensionManagementChannel(Se.get(b.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const xe=S.ProxyChannel.fromService(Se.get(Y.ILanguagePackService));this.a.registerChannel("languagePacks",xe);const Be=S.ProxyChannel.fromService(Se.get(n.IDiagnosticsService));this.a.registerChannel("diagnostics",Be);const st=new k.ExtensionTipsChannel(Se.get(b.IExtensionTipsService));this.a.registerChannel("extensionTipsService",st);const Ve=S.ProxyChannel.fromService(Se.get(h.IChecksumService));this.a.registerChannel("checksum",Ve);const _e=S.ProxyChannel.fromService(Se.get(Te.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",_e);const ct=new Re.UserDataSyncMachinesServiceChannel(Se.get(We.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=S.ProxyChannel.fromService(Se.get(A.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ge=new Re.UserDataSyncAccountServiceChannel(Se.get(be.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const Qe=new Re.UserDataSyncStoreManagementServiceChannel(Se.get(de.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new fe.UserDataSyncChannel(Se.get(de.IUserDataSyncService),Se.get(ze.IUserDataProfilesService),Se.get($.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.D(Se.get(X.IInstantiationService).createInstance(qt.UserDataAutoSyncService)),tt=new Re.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",tt);const Je=Se.get(l.ILocalPtyService),rt=S.ProxyChannel.fromService(Je);this.a.registerChannel(ee.TerminalIpcChannels.LocalPty,rt);const gt=S.ProxyChannel.fromService(Se.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,gt);const lt=S.ProxyChannel.fromService(Se.get(ue.ISharedProcessWorkerService));this.a.registerChannel(Ut.ipcUtilityProcessWorkerChannelName,lt);const mt=S.ProxyChannel.fromService(Se.get(wt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(Se){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,R.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,R.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,R.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Oe=>{const xe=(0,N.toErrorMessage)(Oe,!0);!xe||Se.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Et(at){let Se;(0,Ze.isUtilityProcess)(process)||(Se=(await new Promise((xe,Be)=>{te(["electron"],xe,Be)})).ipcRenderer);const Oe=new xt(at,Se);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):Se.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):Se.send("vscode:shared-process->electron-main=init-done")}e.main=Et,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Et(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
