/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","os","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],c=0,A=re.length;c<A;c++)e[c]=De[re[c]];return e};define(De[61],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(P,T){const D=Object.create(null);for(const g of P){const L=T(g);let k=D[L];k||(k=D[L]=[]),k.push(g)}return D}e.groupBy=c;function A(P,T){const D=[],g=[];for(const L of P)T.has(L)||D.push(L);for(const L of T)P.has(L)||g.push(L);return{removed:D,added:g}}e.diffSets=A;function u(P,T){const D=[],g=[];for(const[L,k]of P)T.has(L)||D.push(k);for(const[L,k]of T)P.has(L)||g.push(k);return{removed:D,added:g}}e.diffMaps=u;class R{constructor(){this.a=new Map}add(T,D){let g=this.a.get(T);g||(g=new Set,this.a.set(T,g)),g.add(D)}delete(T,D){const g=this.a.get(T);!g||(g.delete(D),g.size===0&&this.a.delete(T))}forEach(T,D){const g=this.a.get(T);!g||g.forEach(D)}}e.SetMap=R}),define(De[62],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(P){return(T,D,g)=>{let L=null,k=null;if(typeof g.value=="function"?(L="value",k=g.value):typeof g.get=="function"&&(L="get",k=g.get),!k)throw new Error("not supported");g[L]=P(k,D)}}function A(P,T,D){let g=null,L=null;if(typeof D.value=="function"?(g="value",L=D.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",L=D.get),!L)throw new Error("not supported");const k=`$memoize$${T}`;D[g]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[k]}}e.memoize=A;function u(P,T,D){return c((g,L)=>{const k=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...I){this[S]||(this[S]=D?D():void 0),clearTimeout(this[k]),T&&(this[S]=T(this[S],...I),I=[this[S]]),this[k]=setTimeout(()=>{g.apply(this,I),this[S]=D?D():void 0},P)}})}e.debounce=u;function R(P,T,D){return c((g,L)=>{const k=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...E){if(this[S]||(this[S]=D?D():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),T&&(this[S]=T(this[S],...E)),this[C])return;const r=this[I]+P;r<=Date.now()?(this[I]=Date.now(),g.apply(this,[this[S]]),this[S]=D?D():void 0):(this[C]=!0,this[k]=setTimeout(()=>{this[C]=!1,this[I]=Date.now(),g.apply(this,[this[S]]),this[S]=D?D():void 0},r-Date.now()))}})}e.throttle=R}),define(De[9],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?y.isErrorNoTelemetry(o)?new y(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=c,e.errorHandler=new c;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function u(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function R(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function P(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=P;function T(t){if(t instanceof Error){const{name:o,message:s}=t,a=t.stacktrace||t.stack;return{$isError:!0,name:o,message:s,stack:a,noTelemetry:y.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=T;const D="Canceled";function g(t){return t instanceof L?!0:t instanceof Error&&t.name===D&&t.message===D}e.isCancellationError=g;class L extends Error{constructor(){super(D),this.name=this.message}}e.CancellationError=L;function k(){const t=new Error(D);return t.name=t.message,t}e.canceled=k;function S(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=S;function I(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=I;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function E(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.disposed=E;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class f extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=f;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class y extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof y)return o;const s=new y;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class m extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype);debugger}}e.BugIndicatingError=m}),define(De[17],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(Z,ce=0){return Z[Z.length-(1+ce)]}e.tail=A;function u(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=u;function R(Z,ce,de=(te,ae)=>te===ae){if(Z===ce)return!0;if(!Z||!ce||Z.length!==ce.length)return!1;for(let te=0,ae=Z.length;te<ae;te++)if(!de(Z[te],ce[te]))return!1;return!0}e.equals=R;function P(Z,ce){const de=Z.length-1;ce<de&&(Z[ce]=Z[de]),Z.pop()}e.removeFastWithoutKeepingOrder=P;function T(Z,ce,de){return D(Z.length,te=>de(Z[te],ce))}e.binarySearch=T;function D(Z,ce){let de=0,te=Z-1;for(;de<=te;){const ae=(de+te)/2|0,oe=ce(ae);if(oe<0)de=ae+1;else if(oe>0)te=ae-1;else return ae}return-(de+1)}e.binarySearch2=D;function g(Z,ce){let de=0,te=Z.length;if(te===0)return 0;for(;de<te;){const ae=Math.floor((de+te)/2);ce(Z[ae])?te=ae:de=ae+1}return de}e.findFirstInSorted=g;function L(Z,ce,de){if(Z=Z|0,Z>=ce.length)throw new TypeError("invalid index");const te=ce[Math.floor(ce.length*Math.random())],ae=[],oe=[],F=[];for(const z of ce){const G=de(z,te);G<0?ae.push(z):G>0?oe.push(z):F.push(z)}return Z<ae.length?L(Z,ae,de):Z<ae.length+F.length?F[0]:L(Z-(ae.length+F.length),oe,de)}e.quickSelect=L;function k(Z,ce){const de=[];let te;for(const ae of Z.slice(0).sort(ce))!te||ce(te[0],ae)!==0?(te=[ae],de.push(te)):te.push(ae);return de}e.groupBy=k;function S(Z,ce,de){const te=[];function ae(z,G,_){if(G===0&&_.length===0)return;const fe=te[te.length-1];fe&&fe.start+fe.deleteCount===z?(fe.deleteCount+=G,fe.toInsert.push(..._)):te.push({start:z,deleteCount:G,toInsert:_})}let oe=0,F=0;for(;;){if(oe===Z.length){ae(oe,0,ce.slice(F));break}if(F===ce.length){ae(oe,Z.length-oe,[]);break}const z=Z[oe],G=ce[F],_=de(z,G);_===0?(oe+=1,F+=1):_<0?(ae(oe,1,[]),oe+=1):_>0&&(ae(oe,0,[G]),F+=1)}return te}e.sortedDiff=S;function I(Z,ce,de){const te=S(Z,ce,de),ae=[],oe=[];for(const F of te)ae.push(...Z.slice(F.start,F.start+F.deleteCount)),oe.push(...F.toInsert);return{removed:ae,added:oe}}e.delta=I;function C(Z,ce,de){if(de===0)return[];const te=Z.slice(0,de).sort(ce);return r(Z,ce,te,de,Z.length),te}e.top=C;function E(Z,ce,de,te,ae){return de===0?Promise.resolve([]):new Promise((oe,F)=>{(async()=>{const z=Z.length,G=Z.slice(0,de).sort(ce);for(let _=de,fe=Math.min(de+te,z);_<z;_=fe,fe=Math.min(fe+te,z)){if(_>de&&await new Promise(Ee=>setTimeout(Ee)),ae&&ae.isCancellationRequested)throw new c.CancellationError;r(Z,ce,G,_,fe)}return G})().then(oe,F)})}e.topAsync=E;function r(Z,ce,de,te,ae){for(const oe=de.length;te<ae;te++){const F=Z[te];if(ce(F,de[oe-1])<0){de.pop();const z=g(de,G=>ce(F,G)<0);de.splice(z,0,F)}}}function d(Z){return Z.filter(ce=>!!ce)}e.coalesce=d;function f(Z){let ce=0;for(let de=0;de<Z.length;de++)Z[de]&&(Z[ce]=Z[de],ce+=1);Z.length=ce}e.coalesceInPlace=f;function w(Z,ce,de){Z.splice(de,0,Z.splice(ce,1)[0])}e.move=w;function y(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=y;function m(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=m;function t(Z,ce=de=>de){const de=new Set;return Z.filter(te=>{const ae=ce(te);return de.has(ae)?!1:(de.add(ae),!0)})}e.distinct=t;function o(Z){const ce=new Set;return de=>{const te=Z(de);return ce.has(te)?!1:(ce.add(te),!0)}}e.uniqueFilter=o;function s(Z,ce){const de=a(Z,ce);if(de!==-1)return Z[de]}e.findLast=s;function a(Z,ce){for(let de=Z.length-1;de>=0;de--){const te=Z[de];if(ce(te))return de}return-1}e.lastIndex=a;function l(Z,ce){return Z.length>0?Z[0]:ce}e.firstOrDefault=l;function v(Z,ce){return Z.length>0?Z[Z.length-1]:ce}e.lastOrDefault=v;function i(Z,ce,de=(te,ae)=>te===ae){let te=0;for(let ae=0,oe=Math.min(Z.length,ce.length);ae<oe&&de(Z[ae],ce[ae]);ae++)te++;return te}e.commonPrefixLength=i;function n(Z){return[].concat(...Z)}e.flatten=n;function h(Z,ce){let de=typeof ce=="number"?Z:0;typeof ce=="number"?de=Z:(de=0,ce=Z);const te=[];if(de<=ce)for(let ae=de;ae<ce;ae++)te.push(ae);else for(let ae=de;ae>ce;ae--)te.push(ae);return te}e.range=h;function b(Z,ce,de){return Z.reduce((te,ae)=>(te[ce(ae)]=de?de(ae):ae,te),Object.create(null))}e.index=b;function p(Z,ce){return Z.push(ce),()=>O(Z,ce)}e.insert=p;function O(Z,ce){const de=Z.indexOf(ce);if(de>-1)return Z.splice(de,1),ce}e.remove=O;function W(Z,ce,de){const te=Z.slice(0,ce),ae=Z.slice(ce);return te.concat(de,ae)}e.arrayInsert=W;function q(Z,ce){let de;if(typeof ce=="number"){let te=ce;de=()=>{const ae=Math.sin(te++)*179426549;return ae-Math.floor(ae)}}else de=Math.random;for(let te=Z.length-1;te>0;te-=1){const ae=Math.floor(de()*(te+1)),oe=Z[te];Z[te]=Z[ae],Z[ae]=oe}}e.shuffle=q;function Y(Z,ce){const de=Z.indexOf(ce);de>-1&&(Z.splice(de,1),Z.unshift(ce))}e.pushToStart=Y;function x(Z,ce){const de=Z.indexOf(ce);de>-1&&(Z.splice(de,1),Z.push(ce))}e.pushToEnd=x;function M(Z,ce){for(const de of ce)Z.push(de)}e.pushMany=M;function B(Z,ce){return Array.isArray(Z)?Z.map(ce):ce(Z)}e.mapArrayOrNot=B;function U(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=U;function j(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=j;function he(Z,ce){for(const de of Z){const te=ce(de);if(te!==void 0)return te}}e.mapFind=he;function ie(Z,ce,de){const te=J(Z,ce),ae=Z.length,oe=de.length;Z.length=ae+oe;for(let F=ae-1;F>=te;F--)Z[F+oe]=Z[F];for(let F=0;F<oe;F++)Z[F+te]=de[F]}e.insertInto=ie;function V(Z,ce,de,te){const ae=J(Z,ce),oe=Z.splice(ae,de);return ie(Z,ae,te),oe}e.splice=V;function J(Z,ce){return ce<0?Math.max(ce+Z.length,0):Math.min(ce,Z.length)}var ne;(function(Z){function ce(ae){return ae<0}Z.isLessThan=ce;function de(ae){return ae>0}Z.isGreaterThan=de;function te(ae){return ae===0}Z.isNeitherLessOrGreaterThan=te,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function ve(Z,ce){return(de,te)=>ce(Z(de),Z(te))}e.compareBy=ve;function ue(...Z){return(ce,de)=>{for(const te of Z){const ae=te(ce,de);if(!ne.isNeitherLessOrGreaterThan(ae))return ae}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=ue;const ee=(Z,ce)=>Z-ce;e.numberComparator=ee;function N(Z,ce){if(Z.length===0)return;let de=Z[0];for(let te=1;te<Z.length;te++){const ae=Z[te];ce(ae,de)>0&&(de=ae)}return de}e.findMaxBy=N;function K(Z,ce){if(Z.length===0)return;let de=Z[0];for(let te=1;te<Z.length;te++){const ae=Z[te];ce(ae,de)>=0&&(de=ae)}return de}e.findLastMaxBy=K;function le(Z,ce){return N(Z,(de,te)=>-ce(de,te))}e.findMinBy=le;class me{constructor(ce){this.f=ce,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let de=this.c;for(;de<this.f.length&&ce(this.f[de]);)de++;const te=de===this.c?null:this.f.slice(this.c,de);return this.c=de,te}takeFromEndWhile(ce){let de=this.d;for(;de>=0&&ce(this.f[de]);)de--;const te=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,te}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ce=this.f[this.c];return this.c++,ce}removeLast(){const ce=this.f[this.d];return this.d--,ce}takeCount(ce){const de=this.f.slice(this.c,this.c+ce);return this.c+=ce,de}}e.ArrayQueue=me;class ke{constructor(ce){this.iterate=ce}forEach(ce){this.iterate(de=>(ce(de),!0))}toArray(){const ce=[];return this.iterate(de=>(ce.push(de),!0)),ce}filter(ce){return new ke(de=>this.iterate(te=>ce(te)?de(te):!0))}map(ce){return new ke(de=>this.iterate(te=>de(ce(te))))}some(ce){let de=!1;return this.iterate(te=>(de=ce(te),!de)),de}findFirst(ce){let de;return this.iterate(te=>ce(te)?(de=te,!1):!0),de}findLast(ce){let de;return this.iterate(te=>(ce(te)&&(de=te),!0)),de}findLastMaxBy(ce){let de,te=!0;return this.iterate(ae=>((te||ne.isGreaterThan(ce(ae,de)))&&(te=!1,de=ae),!0)),de}}ke.empty=new ke(Z=>{}),e.CallbackIterable=ke}),define(De[51],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(D,g){if(!D)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=A;function u(D,g="Unreachable"){throw new Error(g)}e.assertNever=u;function R(D){if(!D)throw new c.BugIndicatingError("Assertion Failed")}e.assert=R;function P(D){if(!D()){debugger;D(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=P;function T(D,g){let L=0;for(;L<D.length-1;){const k=D[L],S=D[L+1];if(!g(k,S))return!1;L++}return!0}e.checkAdjacentItems=T}),define(De[63],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(A){const u=this;let R=!1,P;return function(){return R||(R=!0,P=A.apply(u,arguments)),P}}e.once=c}),define(De[102],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(u){this.a=u,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(De[64],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(A){function u(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}A.is=u;const R=Object.freeze([]);function P(){return R}A.empty=P;function*T(y){yield y}A.single=T;function D(y){return u(y)?y:T(y)}A.wrap=D;function g(y){return y||R}A.from=g;function L(y){return!y||y[Symbol.iterator]().next().done===!0}A.isEmpty=L;function k(y){return y[Symbol.iterator]().next().value}A.first=k;function S(y,m){for(const t of y)if(m(t))return!0;return!1}A.some=S;function I(y,m){for(const t of y)if(m(t))return t}A.find=I;function*C(y,m){for(const t of y)m(t)&&(yield t)}A.filter=C;function*E(y,m){let t=0;for(const o of y)yield m(o,t++)}A.map=E;function*r(...y){for(const m of y)for(const t of m)yield t}A.concat=r;function d(y,m,t){let o=t;for(const s of y)o=m(o,s);return o}A.reduce=d;function*f(y,m,t=y.length){for(m<0&&(m+=y.length),t<0?t+=y.length:t>y.length&&(t=y.length);m<t;m++)yield y[m]}A.slice=f;function w(y,m=Number.POSITIVE_INFINITY){const t=[];if(m===0)return[t,y];const o=y[Symbol.iterator]();for(let s=0;s<m;s++){const a=o.next();if(a.done)return[t,A.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return o}}]}A.consume=w})(c=e.Iterable||(e.Iterable={}))}),define(De[147],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var u;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(u=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function P(t,o=!1){let s=0;const a=t.length;let l="",v=0,i=16,n=0;function h(x){let M=0,B=0;for(;M<x;){const U=t.charCodeAt(s);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;s++,M++}return M<x&&(B=-1),B}function b(x){s=x,l="",v=0,i=16,n=0}function p(){const x=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&g(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&g(t.charCodeAt(s)))for(s++;s<t.length&&g(t.charCodeAt(s));)s++;else return n=3,t.substring(x,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&g(t.charCodeAt(s))){for(s++;s<t.length&&g(t.charCodeAt(s));)s++;M=s}else n=3;return t.substring(x,M)}function O(){let x="",M=s;for(;;){if(s>=a){x+=t.substring(M,s),n=2;break}const B=t.charCodeAt(s);if(B===34){x+=t.substring(M,s),s++;break}if(B===92){if(x+=t.substring(M,s),s++,s>=a){n=2;break}switch(t.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const j=h(4);j>=0?x+=String.fromCharCode(j):n=4;break}default:n=5}M=s;continue}if(B>=0&&B<=31)if(D(B)){x+=t.substring(M,s),n=2;break}else n=6;s++}return x}function W(){if(l="",n=0,v=s,s>=a)return v=a,i=17;let x=t.charCodeAt(s);if(T(x)){do s++,l+=String.fromCharCode(x),x=t.charCodeAt(s);while(T(x));return i=15}if(D(x))return s++,l+=String.fromCharCode(x),x===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),i=14;switch(x){case 123:return s++,i=1;case 125:return s++,i=2;case 91:return s++,i=3;case 93:return s++,i=4;case 58:return s++,i=6;case 44:return s++,i=5;case 34:return s++,l=O(),i=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!D(t.charCodeAt(s));)s++;return l=t.substring(M,s),i=12}if(t.charCodeAt(s+1)===42){s+=2;const B=a-1;let U=!1;for(;s<B;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,n=1),l=t.substring(M,s),i=13}return l+=String.fromCharCode(x),s++,i=16}case 45:if(l+=String.fromCharCode(x),s++,s===a||!g(t.charCodeAt(s)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=p(),i=11;default:for(;s<a&&q(x);)s++,x=t.charCodeAt(s);if(v!==s){switch(l=t.substring(v,s),l){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return l+=String.fromCharCode(x),s++,i=16}}function q(x){if(T(x)||D(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let x;do x=W();while(x>=12&&x<=15);return x}return{setPosition:b,getPosition:()=>s,scan:o?Y:W,getToken:()=>i,getTokenValue:()=>l,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>n}}e.createScanner=P;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function k(t,o){const s=[],a=new Object;let l;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function n(h,b,p,O){v.value=h,v.offset=b,v.length=p,v.type=O,v.colonOffset=void 0,l=v}try{w(t,{onObjectBegin:(h,b)=>{if(o<=h)throw a;l=void 0,i=o>h,s.push("")},onObjectProperty:(h,b,p)=>{if(o<b||(n(h,b,p,"property"),s[s.length-1]=h,o<=b+p))throw a},onObjectEnd:(h,b)=>{if(o<=h)throw a;l=void 0,s.pop()},onArrayBegin:(h,b)=>{if(o<=h)throw a;l=void 0,s.push(0)},onArrayEnd:(h,b)=>{if(o<=h)throw a;l=void 0,s.pop()},onLiteralValue:(h,b,p)=>{if(o<b||(n(h,b,p,m(h)),o<=b+p))throw a},onSeparator:(h,b,p)=>{if(o<=b)throw a;if(h===":"&&l&&l.type==="property")l.colonOffset=b,i=!1,l=void 0;else if(h===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(i=!0,s[s.length-1]=""),l=void 0}}})}catch(h){if(h!==a)throw h}return{path:s,previousNode:l,isAtPropertyKey:i,matches:h=>{let b=0;for(let p=0;b<h.length&&p<s.length;p++)if(h[b]===s[p]||h[b]==="*")b++;else if(h[b]!=="**")return!1;return b===h.length}}}e.getLocation=k;function S(t,o=[],s=R.DEFAULT){let a=null,l=[];const v=[];function i(h){Array.isArray(l)?l.push(h):a!==null&&(l[a]=h)}return w(t,{onObjectBegin:()=>{const h={};i(h),v.push(l),l=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{l=v.pop()},onArrayBegin:()=>{const h=[];i(h),v.push(l),l=h,a=null},onArrayEnd:()=>{l=v.pop()},onLiteralValue:i,onError:(h,b,p)=>{o.push({error:h,offset:b,length:p})}},s),l[0]}e.parse=S;function I(t,o=[],s=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function v(h){return a.children.push(h),h}w(t,{onObjectBegin:h=>{a=v({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,b,p)=>{a=v({type:"property",offset:b,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:b,length:p,parent:a})},onObjectEnd:(h,b)=>{a.length=h+b-a.offset,a=a.parent,l(h+b)},onArrayBegin:(h,b)=>{a=v({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,b)=>{a.length=h+b-a.offset,a=a.parent,l(h+b)},onLiteralValue:(h,b,p)=>{v({type:m(h),offset:b,length:p,parent:a,value:h}),l(b+p)},onSeparator:(h,b,p)=>{a.type==="property"&&(h===":"?a.colonOffset=b:h===","&&l(b))},onError:(h,b,p)=>{o.push({error:h,offset:b,length:p})}},s);const n=a.children[0];return n&&delete n.parent,n}e.parseTree=I;function C(t,o){if(!t)return;let s=t;for(const a of o)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===a){s=v.children[1],l=!0;break}if(!l)return}else{const l=a;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=C;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.getNodePath=E;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const o=Object.create(null);for(const s of t.children){const a=s.children[1];a&&(o[s.children[0].value]=r(a))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function d(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.contains=d;function f(t,o,s=!1){if(d(t,o,s)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=o;l++){const v=f(a[l],o,s);if(v)return v}return t}}e.findNodeAtOffset=f;function w(t,o,s=R.DEFAULT){const a=P(t,!1);function l(ve){return ve?()=>ve(a.getTokenOffset(),a.getTokenLength()):()=>!0}function v(ve){return ve?ue=>ve(ue,a.getTokenOffset(),a.getTokenLength()):()=>!0}const i=l(o.onObjectBegin),n=v(o.onObjectProperty),h=l(o.onObjectEnd),b=l(o.onArrayBegin),p=l(o.onArrayEnd),O=v(o.onLiteralValue),W=v(o.onSeparator),q=l(o.onComment),Y=v(o.onError),x=s&&s.disallowComments,M=s&&s.allowTrailingComma;function B(){for(;;){const ve=a.scan();switch(a.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ve){case 12:case 13:x?U(10):q();break;case 16:U(1);break;case 15:case 14:break;default:return ve}}}function U(ve,ue=[],ee=[]){if(Y(ve),ue.length+ee.length>0){let N=a.getToken();for(;N!==17;){if(ue.indexOf(N)!==-1){B();break}else if(ee.indexOf(N)!==-1)break;N=B()}}}function j(ve){const ue=a.getTokenValue();return ve?O(ue):n(ue),B(),!0}function he(){switch(a.getToken()){case 11:{let ve=0;try{ve=JSON.parse(a.getTokenValue()),typeof ve!="number"&&(U(2),ve=0)}catch{U(2)}O(ve);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return B(),!0}function ie(){return a.getToken()!==10?(U(3,[],[2,5]),!1):(j(!1),a.getToken()===6?(W(":"),B(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){i(),B();let ve=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ve||U(4,[],[]),W(","),B(),a.getToken()===2&&M)break}else ve&&U(6,[],[]);ie()||U(4,[],[2,5]),ve=!0}return h(),a.getToken()!==2?U(7,[2],[]):B(),!0}function J(){b(),B();let ve=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ve||U(4,[],[]),W(","),B(),a.getToken()===4&&M)break}else ve&&U(6,[],[]);ne()||U(4,[],[4,5]),ve=!0}return p(),a.getToken()!==4?U(8,[4],[]):B(),!0}function ne(){switch(a.getToken()){case 3:return J();case 1:return V();case 10:return j(!0);default:return he()}}return B(),a.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(a.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=w;function y(t,o){const s=P(t),a=[];let l,v=0,i;do switch(i=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:v!==i&&a.push(t.substring(v,i)),o!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,o)),v=s.getPosition();break}while(l!==17);return a.join("")}e.stripComments=y;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(De[65],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(u){this.d=u,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(u){this.c=u}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=c}),define(De[6],Ce([1,0,63,64]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let R=null;function P(v){R=v}if(e.setDisposableTracker=P,u){const v="__is_disposable_tracked__";P(new class{trackDisposable(i){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[v]||console.log(n)},3e3)}setParent(i,n){if(i&&i!==f.None)try{i[v]=!0}catch{}}markAsDisposed(i){if(i&&i!==f.None)try{i[v]=!0}catch{}}markAsSingleton(i){}})}function T(v){return R?.trackDisposable(v),v}function D(v){R?.markAsDisposed(v)}function g(v,i){R?.setParent(v,i)}function L(v,i){if(!!R)for(const n of v)R.setParent(n,i)}function k(v){return R?.markAsSingleton(v),v}e.markAsSingleton=k;function S(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=S;function I(v){if(A.Iterable.is(v)){const i=[];for(const n of v)if(n)try{n.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}e.dispose=I;function C(v){for(const i of v)S(i)&&i.dispose();return[]}e.disposeIfDisposable=C;function E(...v){const i=r(()=>I(v));return L(v,i),i}e.combinedDisposable=E;function r(v){const i=T({dispose:(0,c.once)(()=>{D(i),v()})});return i}e.toDisposable=r;class d{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(D(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{I(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return g(i,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class f{constructor(){this.B=new d,T(this),g(this.B,this)}dispose(){D(this),this.B.dispose()}D(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.B.add(i)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class w{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&g(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,D(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&g(i,null),i}}e.MutableDisposable=w;class y{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(i){let n=i;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,D(this))},this}}e.SafeDisposable=m;class t{constructor(){this.a=new Map}acquire(i,...n){let h=this.a.get(i);h||(h={counter:0,object:this.b(i,...n)},this.a.set(i,h));const{object:b}=h,p=(0,c.once)(()=>{--h.counter===0&&(this.c(i,h.object),this.a.delete(i))});return h.counter++,{object:b,dispose:p}}}e.ReferenceCollection=t;class o{constructor(i){this.a=i}async acquire(i,...n){const h=this.a.acquire(i,...n);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(b){throw h.dispose(),b}}}e.AsyncReferenceCollection=o;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function a(v){const i=new d;try{v(i)}finally{i.dispose()}}e.disposeOnReturn=a;class l{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){D(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{I(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,n,h=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this.a.get(i)?.dispose(),this.a.set(i,n)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(De[66],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(R){this.element=R,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class A{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let R=this.a;for(;R!==c.Undefined;){const P=R.next;R.prev=c.Undefined,R.next=c.Undefined,R=P}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,P){const T=new c(R);if(this.a===c.Undefined)this.a=T,this.b=T;else if(P){const g=this.b;this.b=T,T.prev=g,g.next=T}else{const g=this.a;this.a=T,T.next=g,g.prev=T}this.c+=1;let D=!1;return()=>{D||(D=!0,this.e(T))}}shift(){if(this.a!==c.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==c.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==c.Undefined&&R.next!==c.Undefined){const P=R.prev;P.next=R.next,R.next.prev=P}else R.prev===c.Undefined&&R.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):R.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):R.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==c.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(De[28],Ce([1,0]),function(re,e){"use strict";var c,A,u;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(E,r,d){let f=E.get(r);return f===void 0&&(f=d,E.set(r,f)),f}e.getOrSet=R;function P(E){const r=[];return E.forEach((d,f)=>{r.push(`${f} => ${d}`)}),`Map(${E.size}) {${r.join(", ")}}`}e.mapToString=P;function T(E){const r=[];return E.forEach(d=>{r.push(d)}),`Set(${E.size}) {${r.join(", ")}}`}e.setToString=T;class D{constructor(r,d){this.uri=r,this.value=d}}class g{constructor(r,d){this[c]="ResourceMap",r instanceof g?(this.b=new Map(r.b),this.c=d??g.a):(this.b=new Map,this.c=r??g.a)}set(r,d){return this.b.set(this.c(r),new D(r,d)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,d){typeof d<"u"&&(r=r.bind(d));for(const[f,w]of this.b)r(w.value,w.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}g.a=E=>E.toString(),e.ResourceMap=g;class L{constructor(r,d){this[A]="ResourceSet",!r||typeof r=="function"?this.a=new g(r):(this.a=new g(d),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,d){this.a.forEach((f,w)=>r.call(d,w,w,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var k;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class S{constructor(){this[u]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,d=0){const f=this.a.get(r);if(!!f)return d!==0&&this.j(f,d),f.value}set(r,d,f=0){let w=this.a.get(r);if(w)w.value=d,f!==0&&this.j(w,f);else{switch(w={key:r,value:d,next:void 0,previous:void 0},f){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(r,w),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const d=this.a.get(r);if(!!d)return this.a.delete(r),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,d){const f=this.e;let w=this.b;for(;w;){if(d?r.bind(d)(w.value,w.key,this):r(w.value,w.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const r=this,d=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(r.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const y={value:f.key,done:!1};return f=f.next,y}else return{value:void 0,done:!0}}};return w}values(){const r=this,d=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(r.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const y={value:f.value,done:!1};return f=f.next,y}else return{value:void 0,done:!0}}};return w}entries(){const r=this,d=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(r.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const y={value:[f.key,f.value],done:!1};return f=f.next,y}else return{value:void 0,done:!0}}};return w}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>r;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const d=r.next,f=r.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}r.next=void 0,r.previous=void 0,this.e++}j(r,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(r===this.b)return;const f=r.next,w=r.previous;r===this.c?(w.next=void 0,this.c=w):(f.previous=w,w.next=f),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(d===2){if(r===this.c)return;const f=r.next,w=r.previous;r===this.b?(f.previous=void 0,this.b=f):(f.previous=w,w.next=f),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((d,f)=>{r.push([f,d])}),r}fromJSON(r){this.clear();for(const[d,f]of r)this.set(d,f)}}e.LinkedMap=S;class I extends S{constructor(r,d=1){super(),this.k=r,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,d=2){return super.get(r,d)}peek(r){return super.get(r,0)}set(r,d){return super.set(r,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=I;class C{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let d=this.a.get(r)||0;return d===0?!1:(d--,d===0?this.a.delete(r):this.a.set(r,d),!0)}has(r){return this.a.has(r)}}e.CounterSet=C}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[148],Ce([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(Z,ce){for(var de=0;de<ce.length;de++){var te=ce[de];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Z,te.key,te)}}function c(Z,ce,de){return ce&&e(Z.prototype,ce),de&&e(Z,de),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function A(Z,ce){if(!!Z){if(typeof Z=="string")return u(Z,ce);var de=Object.prototype.toString.call(Z).slice(8,-1);if(de==="Object"&&Z.constructor&&(de=Z.constructor.name),de==="Map"||de==="Set")return Array.from(Z);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return u(Z,ce)}}function u(Z,ce){(ce==null||ce>Z.length)&&(ce=Z.length);for(var de=0,te=new Array(ce);de<ce;de++)te[de]=Z[de];return te}function R(Z,ce){var de=typeof Symbol<"u"&&Z[Symbol.iterator]||Z["@@iterator"];if(de)return(de=de.call(Z)).next.bind(de);if(Array.isArray(Z)||(de=A(Z))||ce&&Z&&typeof Z.length=="number"){de&&(Z=de);var te=0;return function(){return te>=Z.length?{done:!0}:{done:!1,value:Z[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=P();function T(Z){re.defaults=Z}var D=/[&<>"']/,g=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(ce){return S[ce]};function C(Z,ce){if(ce){if(D.test(Z))return Z.replace(g,I)}else if(L.test(Z))return Z.replace(k,I);return Z}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(Z){return Z.replace(E,function(ce,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function f(Z,ce){Z=typeof Z=="string"?Z:Z.source,ce=ce||"";var de={replace:function(ae,oe){return oe=oe.source||oe,oe=oe.replace(d,"$1"),Z=Z.replace(ae,oe),de},getRegex:function(){return new RegExp(Z,ce)}};return de}var w=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Z,ce,de){if(Z){var te;try{te=decodeURIComponent(r(de)).replace(w,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}ce&&!y.test(de)&&(de=l(ce,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Z,ce){t[" "+Z]||(o.test(Z)?t[" "+Z]=Z+"/":t[" "+Z]=h(Z,"/",!0)),Z=t[" "+Z];var de=Z.indexOf(":")===-1;return ce.substring(0,2)==="//"?de?ce:Z.replace(s,"$1")+ce:ce.charAt(0)==="/"?de?ce:Z.replace(a,"$1")+ce:Z+ce}var v={exec:function(){}};function i(Z){for(var ce=1,de,te;ce<arguments.length;ce++){de=arguments[ce];for(te in de)Object.prototype.hasOwnProperty.call(de,te)&&(Z[te]=de[te])}return Z}function n(Z,ce){var de=Z.replace(/\|/g,function(oe,F,z){for(var G=!1,_=F;--_>=0&&z[_]==="\\";)G=!G;return G?"|":" |"}),te=de.split(/ \|/),ae=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>ce)te.splice(ce);else for(;te.length<ce;)te.push("");for(;ae<te.length;ae++)te[ae]=te[ae].trim().replace(/\\\|/g,"|");return te}function h(Z,ce,de){var te=Z.length;if(te===0)return"";for(var ae=0;ae<te;){var oe=Z.charAt(te-ae-1);if(oe===ce&&!de)ae++;else if(oe!==ce&&de)ae++;else break}return Z.slice(0,te-ae)}function b(Z,ce){if(Z.indexOf(ce[1])===-1)return-1;for(var de=Z.length,te=0,ae=0;ae<de;ae++)if(Z[ae]==="\\")ae++;else if(Z[ae]===ce[0])te++;else if(Z[ae]===ce[1]&&(te--,te<0))return ae;return-1}function p(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(Z,ce){if(ce<1)return"";for(var de="";ce>1;)ce&1&&(de+=Z),ce>>=1,Z+=Z;return de+Z}function W(Z,ce,de,te){var ae=ce.href,oe=ce.title?C(ce.title):null,F=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){te.state.inLink=!0;var z={type:"link",raw:de,href:ae,title:oe,text:F,tokens:te.inlineTokens(F)};return te.state.inLink=!1,z}return{type:"image",raw:de,href:ae,title:oe,text:C(F)}}function q(Z,ce){var de=Z.match(/^(\s+)(?:```)/);if(de===null)return ce;var te=de[1];return ce.split(`
`).map(function(ae){var oe=ae.match(/^\s+/);if(oe===null)return ae;var F=oe[0];return F.length>=te.length?ae.slice(te.length):ae}).join(`
`)}var Y=function(){function Z(de){this.options=de||re.defaults}var ce=Z.prototype;return ce.space=function(te){var ae=this.rules.block.newline.exec(te);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ce.code=function(te){var ae=this.rules.block.code.exec(te);if(ae){var oe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:h(oe,`
`)}}},ce.fences=function(te){var ae=this.rules.block.fences.exec(te);if(ae){var oe=ae[0],F=q(oe,ae[3]||"");return{type:"code",raw:oe,lang:ae[2]?ae[2].trim():ae[2],text:F}}},ce.heading=function(te){var ae=this.rules.block.heading.exec(te);if(ae){var oe=ae[2].trim();if(/#$/.test(oe)){var F=h(oe,"#");(this.options.pedantic||!F||/ $/.test(F))&&(oe=F.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:oe,tokens:this.lexer.inline(oe)}}},ce.hr=function(te){var ae=this.rules.block.hr.exec(te);if(ae)return{type:"hr",raw:ae[0]}},ce.blockquote=function(te){var ae=this.rules.block.blockquote.exec(te);if(ae){var oe=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},ce.list=function(te){var ae=this.rules.block.list.exec(te);if(ae){var oe,F,z,G,_,fe,Ee,Ae,we,Pe,Ie,ze,qe=ae[1].trim(),tt=qe.length>1,Qe={type:"list",raw:"",ordered:tt,start:tt?+qe.slice(0,-1):"",loose:!1,items:[]};qe=tt?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=tt?qe:"[*+-]");for(var it=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(ze=!1,!(!(ae=it.exec(te))||this.rules.block.hr.test(te)));){if(oe=ae[0],te=te.substring(oe.length),Ae=ae[2].split(`
`,1)[0],we=te.split(`
`,1)[0],this.options.pedantic?(G=2,Ie=Ae.trimLeft()):(G=ae[2].search(/[^ ]/),G=G>4?1:G,Ie=Ae.slice(G),G+=ae[1].length),fe=!1,!Ae&&/^ *$/.test(we)&&(oe+=we+`
`,te=te.substring(we.length+1),ze=!0),!ze)for(var rt=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),$=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");te&&(Pe=te.split(`
`,1)[0],Ae=Pe,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Ae)||$.test(Ae)||rt.test(Ae)||Be.test(te)));){if(Ae.search(/[^ ]/)>=G||!Ae.trim())Ie+=`
`+Ae.slice(G);else if(!fe)Ie+=`
`+Ae;else break;!fe&&!Ae.trim()&&(fe=!0),oe+=Pe+`
`,te=te.substring(Pe.length+1)}Qe.loose||(Ee?Qe.loose=!0:/\n *\n *$/.test(oe)&&(Ee=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(Ie),F&&(z=F[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:oe,task:!!F,checked:z,loose:!1,text:Ie}),Qe.raw+=oe}Qe.items[Qe.items.length-1].raw=oe.trimRight(),Qe.items[Qe.items.length-1].text=Ie.trimRight(),Qe.raw=Qe.raw.trimRight();var Q=Qe.items.length;for(_=0;_<Q;_++){this.lexer.state.top=!1,Qe.items[_].tokens=this.lexer.blockTokens(Qe.items[_].text,[]);var ge=Qe.items[_].tokens.filter(function(Ne){return Ne.type==="space"}),Le=ge.every(function(Ne){for(var je=Ne.raw.split(""),Ye=0,Xe=R(je),nt;!(nt=Xe()).done;){var ot=nt.value;if(ot===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Qe.loose&&ge.length&&Le&&(Qe.loose=!0,Qe.items[_].loose=!0)}return Qe}},ce.html=function(te){var ae=this.rules.block.html.exec(te);if(ae){var oe={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(ae[0]):C(ae[0]);oe.type="paragraph",oe.text=F,oe.tokens=this.lexer.inline(F)}return oe}},ce.def=function(te){var ae=this.rules.block.def.exec(te);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var oe=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:ae[0],href:ae[2],title:ae[3]}}},ce.table=function(te){var ae=this.rules.block.table.exec(te);if(ae){var oe={type:"table",header:n(ae[1]).map(function(Ee){return{text:Ee}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ae[0];var F=oe.align.length,z,G,_,fe;for(z=0;z<F;z++)/^ *-+: *$/.test(oe.align[z])?oe.align[z]="right":/^ *:-+: *$/.test(oe.align[z])?oe.align[z]="center":/^ *:-+ *$/.test(oe.align[z])?oe.align[z]="left":oe.align[z]=null;for(F=oe.rows.length,z=0;z<F;z++)oe.rows[z]=n(oe.rows[z],oe.header.length).map(function(Ee){return{text:Ee}});for(F=oe.header.length,G=0;G<F;G++)oe.header[G].tokens=this.lexer.inline(oe.header[G].text);for(F=oe.rows.length,G=0;G<F;G++)for(fe=oe.rows[G],_=0;_<fe.length;_++)fe[_].tokens=this.lexer.inline(fe[_].text);return oe}}},ce.lheading=function(te){var ae=this.rules.block.lheading.exec(te);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ce.paragraph=function(te){var ae=this.rules.block.paragraph.exec(te);if(ae){var oe=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:oe,tokens:this.lexer.inline(oe)}}},ce.text=function(te){var ae=this.rules.block.text.exec(te);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ce.escape=function(te){var ae=this.rules.inline.escape.exec(te);if(ae)return{type:"escape",raw:ae[0],text:C(ae[1])}},ce.tag=function(te){var ae=this.rules.inline.tag.exec(te);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):C(ae[0]):ae[0]}},ce.link=function(te){var ae=this.rules.inline.link.exec(te);if(ae){var oe=ae[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var F=h(oe.slice(0,-1),"\\");if((oe.length-F.length)%2===0)return}else{var z=b(ae[2],"()");if(z>-1){var G=ae[0].indexOf("!")===0?5:4,_=G+ae[1].length+z;ae[2]=ae[2].substring(0,z),ae[0]=ae[0].substring(0,_).trim(),ae[3]=""}}var fe=ae[2],Ee="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(fe);Ae&&(fe=Ae[1],Ee=Ae[3])}else Ee=ae[3]?ae[3].slice(1,-1):"";return fe=fe.trim(),/^</.test(fe)&&(this.options.pedantic&&!/>$/.test(oe)?fe=fe.slice(1):fe=fe.slice(1,-1)),W(ae,{href:fe&&fe.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ce.reflink=function(te,ae){var oe;if((oe=this.rules.inline.reflink.exec(te))||(oe=this.rules.inline.nolink.exec(te))){var F=(oe[2]||oe[1]).replace(/\s+/g," ");if(F=ae[F.toLowerCase()],!F||!F.href){var z=oe[0].charAt(0);return{type:"text",raw:z,text:z}}return W(oe,F,oe[0],this.lexer)}},ce.emStrong=function(te,ae,oe){oe===void 0&&(oe="");var F=this.rules.inline.emStrong.lDelim.exec(te);if(!!F&&!(F[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=F[1]||F[2]||"";if(!z||z&&(oe===""||this.rules.inline.punctuation.exec(oe))){var G=F[0].length-1,_,fe,Ee=G,Ae=0,we=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(we.lastIndex=0,ae=ae.slice(-1*te.length+G);(F=we.exec(ae))!=null;)if(_=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!_){if(fe=_.length,F[3]||F[4]){Ee+=fe;continue}else if((F[5]||F[6])&&G%3&&!((G+fe)%3)){Ae+=fe;continue}if(Ee-=fe,!(Ee>0)){if(fe=Math.min(fe,fe+Ee+Ae),Math.min(G,fe)%2){var Pe=te.slice(1,G+F.index+fe);return{type:"em",raw:te.slice(0,G+F.index+fe+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var Ie=te.slice(2,G+F.index+fe-1);return{type:"strong",raw:te.slice(0,G+F.index+fe+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},ce.codespan=function(te){var ae=this.rules.inline.code.exec(te);if(ae){var oe=ae[2].replace(/\n/g," "),F=/[^ ]/.test(oe),z=/^ /.test(oe)&&/ $/.test(oe);return F&&z&&(oe=oe.substring(1,oe.length-1)),oe=C(oe,!0),{type:"codespan",raw:ae[0],text:oe}}},ce.br=function(te){var ae=this.rules.inline.br.exec(te);if(ae)return{type:"br",raw:ae[0]}},ce.del=function(te){var ae=this.rules.inline.del.exec(te);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ce.autolink=function(te,ae){var oe=this.rules.inline.autolink.exec(te);if(oe){var F,z;return oe[2]==="@"?(F=C(this.options.mangle?ae(oe[1]):oe[1]),z="mailto:"+F):(F=C(oe[1]),z=F),{type:"link",raw:oe[0],text:F,href:z,tokens:[{type:"text",raw:F,text:F}]}}},ce.url=function(te,ae){var oe;if(oe=this.rules.inline.url.exec(te)){var F,z;if(oe[2]==="@")F=C(this.options.mangle?ae(oe[0]):oe[0]),z="mailto:"+F;else{var G;do G=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(G!==oe[0]);F=C(oe[0]),oe[1]==="www."?z="http://"+F:z=F}return{type:"link",raw:oe[0],text:F,href:z,tokens:[{type:"text",raw:F,text:F}]}}},ce.inlineText=function(te,ae){var oe=this.rules.inline.text.exec(te);if(oe){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):C(oe[0]):oe[0]:F=C(this.options.smartypants?ae(oe[0]):oe[0]),{type:"text",raw:oe[0],text:F}}},Z}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=f(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=f(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=f(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=f(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=f(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=f(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=i({},x),x.gfm=i({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=f(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=f(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=i({},x.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:f(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=f(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=f(x._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=f(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=f(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=f(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=f(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=f(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=f(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=f(M.reflink).replace("label",M._label).replace("ref",x._label).getRegex(),M.nolink=f(M.nolink).replace("ref",x._label).getRegex(),M.reflinkSearch=f(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=i({},M),M.pedantic=i({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=i({},M.normal,{escape:f(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=f(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=i({},M.gfm,{br:f(M.br).replace("{2,}","*").getRegex(),text:f(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(Z){var ce="",de,te,ae=Z.length;for(de=0;de<ae;de++)te=Z.charCodeAt(de),Math.random()>.5&&(te="x"+te.toString(16)),ce+="&#"+te+";";return ce}var j=function(){function Z(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||re.defaults,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:x.normal,inline:M.normal};this.options.pedantic?(te.block=x.pedantic,te.inline=M.pedantic):this.options.gfm&&(te.block=x.gfm,this.options.breaks?te.inline=M.breaks:te.inline=M.gfm),this.tokenizer.rules=te}Z.lex=function(te,ae){var oe=new Z(ae);return oe.lex(te)},Z.lexInline=function(te,ae){var oe=new Z(ae);return oe.inlineTokens(te)};var ce=Z.prototype;return ce.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ce.blockTokens=function(te,ae){var oe=this;ae===void 0&&(ae=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(Ee,Ae,we){return Ae+"    ".repeat(we.length)});for(var F,z,G,_;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(F=Ee.call({lexer:oe},te,ae))?(te=te.substring(F.raw.length),ae.push(F),!0):!1}))){if(F=this.tokenizer.space(te)){te=te.substring(F.raw.length),F.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(F);continue}if(F=this.tokenizer.code(te)){te=te.substring(F.raw.length),z=ae[ae.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):ae.push(F);continue}if(F=this.tokenizer.fences(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.heading(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.hr(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.blockquote(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.list(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.html(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.def(te)){te=te.substring(F.raw.length),z=ae[ae.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+F.raw,z.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.lheading(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(G=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,Ae=te.slice(1),we=void 0;oe.options.extensions.startBlock.forEach(function(Pe){we=Pe.call({lexer:this},Ae),typeof we=="number"&&we>=0&&(Ee=Math.min(Ee,we))}),Ee<1/0&&Ee>=0&&(G=te.substring(0,Ee+1))}(),this.state.top&&(F=this.tokenizer.paragraph(G))){z=ae[ae.length-1],_&&z.type==="paragraph"?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ae.push(F),_=G.length!==te.length,te=te.substring(F.raw.length);continue}if(F=this.tokenizer.text(te)){te=te.substring(F.raw.length),z=ae[ae.length-1],z&&z.type==="text"?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ae.push(F);continue}if(te){var fe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return this.state.top=!0,ae},ce.inline=function(te,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:te,tokens:ae}),ae},ce.inlineTokens=function(te,ae){var oe=this;ae===void 0&&(ae=[]);var F,z,G,_=te,fe,Ee,Ae;if(this.tokens.links){var we=Object.keys(this.tokens.links);if(we.length>0)for(;(fe=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)we.includes(fe[0].slice(fe[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,fe.index)+"["+O("a",fe[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(fe=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,fe.index)+"["+O("a",fe[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(fe=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,fe.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(Ee||(Ae=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(F=Ie.call({lexer:oe},te,ae))?(te=te.substring(F.raw.length),ae.push(F),!0):!1}))){if(F=this.tokenizer.escape(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.tag(te)){te=te.substring(F.raw.length),z=ae[ae.length-1],z&&F.type==="text"&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):ae.push(F);continue}if(F=this.tokenizer.link(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(F.raw.length),z=ae[ae.length-1],z&&F.type==="text"&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):ae.push(F);continue}if(F=this.tokenizer.emStrong(te,_,Ae)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.codespan(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.br(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.del(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.autolink(te,U)){te=te.substring(F.raw.length),ae.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(te,U))){te=te.substring(F.raw.length),ae.push(F);continue}if(G=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,ze=te.slice(1),qe=void 0;oe.options.extensions.startInline.forEach(function(tt){qe=tt.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(Ie=Math.min(Ie,qe))}),Ie<1/0&&Ie>=0&&(G=te.substring(0,Ie+1))}(),F=this.tokenizer.inlineText(G,B)){te=te.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(Ae=F.raw.slice(-1)),Ee=!0,z=ae[ae.length-1],z&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):ae.push(F);continue}if(te){var Pe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return ae},c(Z,null,[{key:"rules",get:function(){return{block:x,inline:M}}}]),Z}(),he=function(){function Z(de){this.options=de||re.defaults}var ce=Z.prototype;return ce.code=function(te,ae,oe){var F=(ae||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(te,F);z!=null&&z!==te&&(oe=!0,te=z)}return te=te.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+C(F,!0)+'">'+(oe?te:C(te,!0))+`</code></pre>
`:"<pre><code>"+(oe?te:C(te,!0))+`</code></pre>
`},ce.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},ce.html=function(te){return te},ce.heading=function(te,ae,oe,F){if(this.options.headerIds){var z=this.options.headerPrefix+F.slug(oe);return"<h"+ae+' id="'+z+'">'+te+"</h"+ae+`>
`}return"<h"+ae+">"+te+"</h"+ae+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(te,ae,oe){var F=ae?"ol":"ul",z=ae&&oe!==1?' start="'+oe+'"':"";return"<"+F+z+`>
`+te+"</"+F+`>
`},ce.listitem=function(te){return"<li>"+te+`</li>
`},ce.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(te){return"<p>"+te+`</p>
`},ce.table=function(te,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ae+`</table>
`},ce.tablerow=function(te){return`<tr>
`+te+`</tr>
`},ce.tablecell=function(te,ae){var oe=ae.header?"th":"td",F=ae.align?"<"+oe+' align="'+ae.align+'">':"<"+oe+">";return F+te+("</"+oe+`>
`)},ce.strong=function(te){return"<strong>"+te+"</strong>"},ce.em=function(te){return"<em>"+te+"</em>"},ce.codespan=function(te){return"<code>"+te+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(te){return"<del>"+te+"</del>"},ce.link=function(te,ae,oe){if(te=m(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var F='<a href="'+C(te)+'"';return ae&&(F+=' title="'+ae+'"'),F+=">"+oe+"</a>",F},ce.image=function(te,ae,oe){if(te=m(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var F='<img src="'+te+'" alt="'+oe+'"';return ae&&(F+=' title="'+ae+'"'),F+=this.options.xhtml?"/>":">",F},ce.text=function(te){return te},Z}(),ie=function(){function Z(){}var ce=Z.prototype;return ce.strong=function(te){return te},ce.em=function(te){return te},ce.codespan=function(te){return te},ce.del=function(te){return te},ce.html=function(te){return te},ce.text=function(te){return te},ce.link=function(te,ae,oe){return""+oe},ce.image=function(te,ae,oe){return""+oe},ce.br=function(){return""},Z}(),V=function(){function Z(){this.seen={}}var ce=Z.prototype;return ce.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(te,ae){var oe=te,F=0;if(this.seen.hasOwnProperty(oe)){F=this.seen[te];do F++,oe=te+"-"+F;while(this.seen.hasOwnProperty(oe))}return ae||(this.seen[te]=F,this.seen[oe]=0),oe},ce.slug=function(te,ae){ae===void 0&&(ae={});var oe=this.serialize(te);return this.getNextSafeSlug(oe,ae.dryrun)},Z}(),J=function(){function Z(de){this.options=de||re.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new V}Z.parse=function(te,ae){var oe=new Z(ae);return oe.parse(te)},Z.parseInline=function(te,ae){var oe=new Z(ae);return oe.parseInline(te)};var ce=Z.prototype;return ce.parse=function(te,ae){ae===void 0&&(ae=!0);var oe="",F,z,G,_,fe,Ee,Ae,we,Pe,Ie,ze,qe,tt,Qe,it,rt,Be,et,$,Q=te.length;for(F=0;F<Q;F++){if(Ie=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&($=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),$!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){oe+=$||"";continue}switch(Ie.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,r(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(we="",Ae="",_=Ie.header.length,z=0;z<_;z++)Ae+=this.renderer.tablecell(this.parseInline(Ie.header[z].tokens),{header:!0,align:Ie.align[z]});for(we+=this.renderer.tablerow(Ae),Pe="",_=Ie.rows.length,z=0;z<_;z++){for(Ee=Ie.rows[z],Ae="",fe=Ee.length,G=0;G<fe;G++)Ae+=this.renderer.tablecell(this.parseInline(Ee[G].tokens),{header:!1,align:Ie.align[G]});Pe+=this.renderer.tablerow(Ae)}oe+=this.renderer.table(we,Pe);continue}case"blockquote":{Pe=this.parse(Ie.tokens),oe+=this.renderer.blockquote(Pe);continue}case"list":{for(ze=Ie.ordered,qe=Ie.start,tt=Ie.loose,_=Ie.items.length,Pe="",z=0;z<_;z++)it=Ie.items[z],rt=it.checked,Be=it.task,Qe="",it.task&&(et=this.renderer.checkbox(rt),tt?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=et+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=et+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:et}):Qe+=et),Qe+=this.parse(it.tokens,tt),Pe+=this.renderer.listitem(Qe,Be,rt);oe+=this.renderer.list(Pe,ze,qe);continue}case"html":{oe+=this.renderer.html(Ie.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(Pe=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;F+1<Q&&te[F+1].type==="text";)Ie=te[++F],Pe+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);oe+=ae?this.renderer.paragraph(Pe):Pe;continue}default:{var ge='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(ge);return}else throw new Error(ge)}}}return oe},ce.parseInline=function(te,ae){ae=ae||this.renderer;var oe="",F,z,G,_=te.length;for(F=0;F<_;F++){if(z=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(G=this.options.extensions.renderers[z.type].call({parser:this},z),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){oe+=G||"";continue}switch(z.type){case"escape":{oe+=ae.text(z.text);break}case"html":{oe+=ae.html(z.text);break}case"link":{oe+=ae.link(z.href,z.title,this.parseInline(z.tokens,ae));break}case"image":{oe+=ae.image(z.href,z.title,z.text);break}case"strong":{oe+=ae.strong(this.parseInline(z.tokens,ae));break}case"em":{oe+=ae.em(this.parseInline(z.tokens,ae));break}case"codespan":{oe+=ae.codespan(z.text);break}case"br":{oe+=ae.br();break}case"del":{oe+=ae.del(this.parseInline(z.tokens,ae));break}case"text":{oe+=ae.text(z.text);break}default:{var fe='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return oe},Z}();function ne(Z,ce,de){if(typeof Z>"u"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof ce=="function"&&(de=ce,ce=null),ce=i({},ne.defaults,ce||{}),p(ce),de){var te=ce.highlight,ae;try{ae=j.lex(Z,ce)}catch(_){return de(_)}var oe=function(fe){var Ee;if(!fe)try{ce.walkTokens&&ne.walkTokens(ae,ce.walkTokens),Ee=J.parse(ae,ce)}catch(Ae){fe=Ae}return ce.highlight=te,fe?de(fe):de(null,Ee)};if(!te||te.length<3||(delete ce.highlight,!ae.length))return oe();var F=0;ne.walkTokens(ae,function(_){_.type==="code"&&(F++,setTimeout(function(){te(_.text,_.lang,function(fe,Ee){if(fe)return oe(fe);Ee!=null&&Ee!==_.text&&(_.text=Ee,_.escaped=!0),F--,F===0&&oe()})},0))}),F===0&&oe();return}function z(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+C(_.message+"",!0)+"</pre>";throw _}try{var G=j.lex(Z,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ne.walkTokens(G,ce.walkTokens)).then(function(){return J.parse(G,ce)}).catch(z);ne.walkTokens(G,ce.walkTokens)}return J.parse(G,ce)}catch(_){z(_)}}ne.options=ne.setOptions=function(Z){return i(ne.defaults,Z),T(ne.defaults),ne},ne.getDefaults=P,ne.defaults=re.defaults,ne.use=function(){for(var Z=arguments.length,ce=new Array(Z),de=0;de<Z;de++)ce[de]=arguments[de];var te=i.apply(void 0,[{}].concat(ce)),ae=ne.defaults.extensions||{renderers:{},childTokens:{}},oe;ce.forEach(function(F){if(F.extensions&&(oe=!0,F.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var _=ae.renderers?ae.renderers[G.name]:null;_?ae.renderers[G.name]=function(){for(var fe=arguments.length,Ee=new Array(fe),Ae=0;Ae<fe;Ae++)Ee[Ae]=arguments[Ae];var we=G.renderer.apply(this,Ee);return we===!1&&(we=_.apply(this,Ee)),we}:ae.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[G.level]?ae[G.level].unshift(G.tokenizer):ae[G.level]=[G.tokenizer],G.start&&(G.level==="block"?ae.startBlock?ae.startBlock.push(G.start):ae.startBlock=[G.start]:G.level==="inline"&&(ae.startInline?ae.startInline.push(G.start):ae.startInline=[G.start]))}G.childTokens&&(ae.childTokens[G.name]=G.childTokens)})),F.renderer&&function(){var G=ne.defaults.renderer||new he,_=function(Ae){var we=G[Ae];G[Ae]=function(){for(var Pe=arguments.length,Ie=new Array(Pe),ze=0;ze<Pe;ze++)Ie[ze]=arguments[ze];var qe=F.renderer[Ae].apply(G,Ie);return qe===!1&&(qe=we.apply(G,Ie)),qe}};for(var fe in F.renderer)_(fe);te.renderer=G}(),F.tokenizer&&function(){var G=ne.defaults.tokenizer||new Y,_=function(Ae){var we=G[Ae];G[Ae]=function(){for(var Pe=arguments.length,Ie=new Array(Pe),ze=0;ze<Pe;ze++)Ie[ze]=arguments[ze];var qe=F.tokenizer[Ae].apply(G,Ie);return qe===!1&&(qe=we.apply(G,Ie)),qe}};for(var fe in F.tokenizer)_(fe);te.tokenizer=G}(),F.walkTokens){var z=ne.defaults.walkTokens;te.walkTokens=function(G){var _=[];return _.push(F.walkTokens.call(this,G)),z&&(_=_.concat(z.call(this,G))),_}}oe&&(te.extensions=ae),ne.setOptions(te)})},ne.walkTokens=function(Z,ce){for(var de=[],te=function(){var z=oe.value;switch(de=de.concat(ce.call(ne,z)),z.type){case"table":{for(var G=R(z.header),_;!(_=G()).done;){var fe=_.value;de=de.concat(ne.walkTokens(fe.tokens,ce))}for(var Ee=R(z.rows),Ae;!(Ae=Ee()).done;)for(var we=Ae.value,Pe=R(we),Ie;!(Ie=Pe()).done;){var ze=Ie.value;de=de.concat(ne.walkTokens(ze.tokens,ce))}break}case"list":{de=de.concat(ne.walkTokens(z.items,ce));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[z.type]?ne.defaults.extensions.childTokens[z.type].forEach(function(qe){de=de.concat(ne.walkTokens(z[qe],ce))}):z.tokens&&(de=de.concat(ne.walkTokens(z.tokens,ce)))}},ae=R(Z),oe;!(oe=ae()).done;)te();return de},ne.parseInline=function(Z,ce){if(typeof Z>"u"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");ce=i({},ne.defaults,ce||{}),p(ce);try{var de=j.lexInline(Z,ce);return ce.walkTokens&&ne.walkTokens(de,ce.walkTokens),J.parseInline(de,ce)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+C(te.message+"",!0)+"</pre>";throw te}},ne.Parser=J,ne.parser=J.parse,ne.Renderer=he,ne.TextRenderer=ie,ne.Lexer=j,ne.lexer=j.lex,ne.Tokenizer=Y,ne.Slugger=V,ne.parse=ne;var ve=ne.options,ue=ne.setOptions,ee=ne.use,N=ne.walkTokens,K=ne.parseInline,le=ne,me=J.parse,ke=j.lex;re.Lexer=j,re.Parser=J,re.Renderer=he,re.Slugger=V,re.TextRenderer=ie,re.Tokenizer=Y,re.getDefaults=P,re.lexer=ke,re.marked=ne,re.options=ve,re.parse=le,re.parseInline=K,re.parser=me,re.setOptions=ue,re.use=ee,re.walkTokens=N,Object.defineProperty(re,"__esModule",{value:!0})}),define(De[87],Ce([1,0,28]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new c.LRUCache(1e4);function u(g){return D(g,"NFC",A)}e.normalizeNFC=u;const R=new c.LRUCache(1e4);function P(g){return D(g,"NFD",R)}e.normalizeNFD=P;const T=/[^\u0000-\u0080]/;function D(g,L,k){if(!g)return g;const S=k.get(g);if(S)return S;let I;return T.test(g)?I=g.normalize(L):I=g,k.set(g,I),I}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(L){return P(L).replace(g,"")}}()}),define(De[103],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,D,g){return Math.min(Math.max(T,D),g)}e.clamp=c;function A(T,D){return(D+T%D)%D}e.rot=A;class u{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=u;class R{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class P{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=P}),function(){function re(u){const R=[];typeof u=="number"&&R.push("code/timeOrigin",u);function P(D){R.push(D,Date.now())}function T(){const D=[];for(let g=0;g<R.length;g+=2)D.push({name:R[g],startTime:R[g+1]});return D}return{mark:P,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const P of performance.getEntriesByType("mark"))R.push({name:P.name,startTime:Math.round(u+P.startTime)});return R}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=c(A))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var A in c)(typeof exports=="object"?exports:re)[A]=c[A]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function c(A){if(e[A])return e[A].exports;var u=e[A]={i:A,l:!1,exports:{}};return re[A].call(u.exports,u,u.exports,c),u.l=!0,u.exports}return c.m=re,c.c=e,c.d=function(A,u,R){c.o(A,u)||Object.defineProperty(A,u,{enumerable:!0,get:R})},c.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},c.t=function(A,u){if(1&u&&(A=c(A)),8&u||4&u&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(c.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&u&&typeof A!="string")for(var P in A)c.d(R,P,function(T){return A[T]}.bind(null,P));return R},c.n=function(A){var u=A&&A.__esModule?function(){return A.default}:function(){return A};return c.d(u,"a",u),u},c.o=function(A,u){return Object.prototype.hasOwnProperty.call(A,u)},c.p="",c(c.s=0)}([function(re,e,c){(function(A){var u;e=re.exports=ee,u=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var we=Array.prototype.slice.call(arguments,0);we.unshift("SEMVER"),console.log.apply(console,we)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],D=e.src=[],g=0,L=g++;D[L]="0|[1-9]\\d*";var k=g++;D[k]="[0-9]+";var S=g++;D[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=g++;D[I]="("+D[L]+")\\.("+D[L]+")\\.("+D[L]+")";var C=g++;D[C]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var E=g++;D[E]="(?:"+D[L]+"|"+D[S]+")";var r=g++;D[r]="(?:"+D[k]+"|"+D[S]+")";var d=g++;D[d]="(?:-("+D[E]+"(?:\\."+D[E]+")*))";var f=g++;D[f]="(?:-?("+D[r]+"(?:\\."+D[r]+")*))";var w=g++;D[w]="[0-9A-Za-z-]+";var y=g++;D[y]="(?:\\+("+D[w]+"(?:\\."+D[w]+")*))";var m=g++,t="v?"+D[I]+D[d]+"?"+D[y]+"?";D[m]="^"+t+"$";var o="[v=\\s]*"+D[C]+D[f]+"?"+D[y]+"?",s=g++;D[s]="^"+o+"$";var a=g++;D[a]="((?:<|>)?=?)";var l=g++;D[l]=D[k]+"|x|X|\\*";var v=g++;D[v]=D[L]+"|x|X|\\*";var i=g++;D[i]="[v=\\s]*("+D[v]+")(?:\\.("+D[v]+")(?:\\.("+D[v]+")(?:"+D[d]+")?"+D[y]+"?)?)?";var n=g++;D[n]="[v=\\s]*("+D[l]+")(?:\\.("+D[l]+")(?:\\.("+D[l]+")(?:"+D[f]+")?"+D[y]+"?)?)?";var h=g++;D[h]="^"+D[a]+"\\s*"+D[i]+"$";var b=g++;D[b]="^"+D[a]+"\\s*"+D[n]+"$";var p=g++;D[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=g++;D[O]="(?:~>?)";var W=g++;D[W]="(\\s*)"+D[O]+"\\s+",T[W]=new RegExp(D[W],"g");var q=g++;D[q]="^"+D[O]+D[i]+"$";var Y=g++;D[Y]="^"+D[O]+D[n]+"$";var x=g++;D[x]="(?:\\^)";var M=g++;D[M]="(\\s*)"+D[x]+"\\s+",T[M]=new RegExp(D[M],"g");var B=g++;D[B]="^"+D[x]+D[i]+"$";var U=g++;D[U]="^"+D[x]+D[n]+"$";var j=g++;D[j]="^"+D[a]+"\\s*("+o+")$|^$";var he=g++;D[he]="^"+D[a]+"\\s*("+t+")$|^$";var ie=g++;D[ie]="(\\s*)"+D[a]+"\\s*("+o+"|"+D[i]+")",T[ie]=new RegExp(D[ie],"g");var V=g++;D[V]="^\\s*("+D[i]+")\\s+-\\s+("+D[i]+")\\s*$";var J=g++;D[J]="^\\s*("+D[n]+")\\s+-\\s+("+D[n]+")\\s*$";var ne=g++;D[ne]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)u(ve,D[ve]),T[ve]||(T[ve]=new RegExp(D[ve]));function ue(we,Pe){if(we instanceof ee)return we;if(typeof we!="string"||we.length>R||!(Pe?T[s]:T[m]).test(we))return null;try{return new ee(we,Pe)}catch{return null}}function ee(we,Pe){if(we instanceof ee){if(we.loose===Pe)return we;we=we.version}else if(typeof we!="string")throw new TypeError("Invalid Version: "+we);if(we.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ee))return new ee(we,Pe);u("SemVer",we,Pe),this.loose=Pe;var Ie=we.trim().match(Pe?T[s]:T[m]);if(!Ie)throw new TypeError("Invalid Version: "+we);if(this.raw=we,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var qe=+ze;if(qe>=0&&qe<P)return qe}return ze}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=ue,e.valid=function(we,Pe){var Ie=ue(we,Pe);return Ie?Ie.version:null},e.clean=function(we,Pe){var Ie=ue(we.trim().replace(/^[=v]+/,""),Pe);return Ie?Ie.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(we){return u("SemVer.compare",this.version,this.loose,we),we instanceof ee||(we=new ee(we,this.loose)),this.compareMain(we)||this.comparePre(we)},ee.prototype.compareMain=function(we){return we instanceof ee||(we=new ee(we,this.loose)),K(this.major,we.major)||K(this.minor,we.minor)||K(this.patch,we.patch)},ee.prototype.comparePre=function(we){if(we instanceof ee||(we=new ee(we,this.loose)),this.prerelease.length&&!we.prerelease.length)return-1;if(!this.prerelease.length&&we.prerelease.length)return 1;if(!this.prerelease.length&&!we.prerelease.length)return 0;var Pe=0;do{var Ie=this.prerelease[Pe],ze=we.prerelease[Pe];if(u("prerelease compare",Pe,Ie,ze),Ie===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==ze)return K(Ie,ze)}while(++Pe)},ee.prototype.inc=function(we,Pe){switch(we){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+we)}return this.format(),this.raw=this.version,this},e.inc=function(we,Pe,Ie,ze){typeof Ie=="string"&&(ze=Ie,Ie=void 0);try{return new ee(we,Ie).inc(Pe,ze).version}catch{return null}},e.diff=function(we,Pe){if(Z(we,Pe))return null;var Ie=ue(we),ze=ue(Pe);if(Ie.prerelease.length||ze.prerelease.length){for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==ze[qe])return"pre"+qe;return"prerelease"}for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==ze[qe])return qe},e.compareIdentifiers=K;var N=/^[0-9]+$/;function K(we,Pe){var Ie=N.test(we),ze=N.test(Pe);return Ie&&ze&&(we=+we,Pe=+Pe),Ie&&!ze?-1:ze&&!Ie?1:we<Pe?-1:we>Pe?1:0}function le(we,Pe,Ie){return new ee(we,Ie).compare(new ee(Pe,Ie))}function me(we,Pe,Ie){return le(we,Pe,Ie)>0}function ke(we,Pe,Ie){return le(we,Pe,Ie)<0}function Z(we,Pe,Ie){return le(we,Pe,Ie)===0}function ce(we,Pe,Ie){return le(we,Pe,Ie)!==0}function de(we,Pe,Ie){return le(we,Pe,Ie)>=0}function te(we,Pe,Ie){return le(we,Pe,Ie)<=0}function ae(we,Pe,Ie,ze){var qe;switch(Pe){case"===":typeof we=="object"&&(we=we.version),typeof Ie=="object"&&(Ie=Ie.version),qe=we===Ie;break;case"!==":typeof we=="object"&&(we=we.version),typeof Ie=="object"&&(Ie=Ie.version),qe=we!==Ie;break;case"":case"=":case"==":qe=Z(we,Ie,ze);break;case"!=":qe=ce(we,Ie,ze);break;case">":qe=me(we,Ie,ze);break;case">=":qe=de(we,Ie,ze);break;case"<":qe=ke(we,Ie,ze);break;case"<=":qe=te(we,Ie,ze);break;default:throw new TypeError("Invalid operator: "+Pe)}return qe}function oe(we,Pe){if(we instanceof oe){if(we.loose===Pe)return we;we=we.value}if(!(this instanceof oe))return new oe(we,Pe);u("comparator",we,Pe),this.loose=Pe,this.parse(we),this.semver===F?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(we,Pe){return K(Pe,we)},e.major=function(we,Pe){return new ee(we,Pe).major},e.minor=function(we,Pe){return new ee(we,Pe).minor},e.patch=function(we,Pe){return new ee(we,Pe).patch},e.compare=le,e.compareLoose=function(we,Pe){return le(we,Pe,!0)},e.rcompare=function(we,Pe,Ie){return le(Pe,we,Ie)},e.sort=function(we,Pe){return we.sort(function(Ie,ze){return e.compare(Ie,ze,Pe)})},e.rsort=function(we,Pe){return we.sort(function(Ie,ze){return e.rcompare(Ie,ze,Pe)})},e.gt=me,e.lt=ke,e.eq=Z,e.neq=ce,e.gte=de,e.lte=te,e.cmp=ae,e.Comparator=oe;var F={};function z(we,Pe){if(we instanceof z)return we.loose===Pe?we:new z(we.raw,Pe);if(we instanceof oe)return new z(we.value,Pe);if(!(this instanceof z))return new z(we,Pe);if(this.loose=Pe,this.raw=we,this.set=we.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+we);this.format()}function G(we){return!we||we.toLowerCase()==="x"||we==="*"}function _(we,Pe,Ie,ze,qe,tt,Qe,it,rt,Be,et,$,Q){return((Pe=G(Ie)?"":G(ze)?">="+Ie+".0.0":G(qe)?">="+Ie+"."+ze+".0":">="+Pe)+" "+(it=G(rt)?"":G(Be)?"<"+(+rt+1)+".0.0":G(et)?"<"+rt+"."+(+Be+1)+".0":$?"<="+rt+"."+Be+"."+et+"-"+$:"<="+it)).trim()}function fe(we,Pe){for(var Ie=0;Ie<we.length;Ie++)if(!we[Ie].test(Pe))return!1;if(Pe.prerelease.length){for(Ie=0;Ie<we.length;Ie++)if(u(we[Ie].semver),we[Ie].semver!==F&&we[Ie].semver.prerelease.length>0){var ze=we[Ie].semver;if(ze.major===Pe.major&&ze.minor===Pe.minor&&ze.patch===Pe.patch)return!0}return!1}return!0}function Ee(we,Pe,Ie){try{Pe=new z(Pe,Ie)}catch{return!1}return Pe.test(we)}function Ae(we,Pe,Ie,ze){var qe,tt,Qe,it,rt;switch(we=new ee(we,ze),Pe=new z(Pe,ze),Ie){case">":qe=me,tt=te,Qe=ke,it=">",rt=">=";break;case"<":qe=ke,tt=de,Qe=me,it="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(we,Pe,ze))return!1;for(var Be=0;Be<Pe.set.length;++Be){var et=Pe.set[Be],$=null,Q=null;if(et.forEach(function(ge){ge.semver===F&&(ge=new oe(">=0.0.0")),$=$||ge,Q=Q||ge,qe(ge.semver,$.semver,ze)?$=ge:Qe(ge.semver,Q.semver,ze)&&(Q=ge)}),$.operator===it||$.operator===rt||(!Q.operator||Q.operator===it)&&tt(we,Q.semver)||Q.operator===rt&&Qe(we,Q.semver))return!1}return!0}oe.prototype.parse=function(we){var Pe=this.loose?T[j]:T[he],Ie=we.match(Pe);if(!Ie)throw new TypeError("Invalid comparator: "+we);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new ee(Ie[2],this.loose):this.semver=F},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(we){return u("Comparator.test",we,this.loose),this.semver===F||(typeof we=="string"&&(we=new ee(we,this.loose)),ae(we,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(we,Pe){if(!(we instanceof oe))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new z(we.value,Pe),Ee(this.value,Ie,Pe);if(we.operator==="")return Ie=new z(this.value,Pe),Ee(we.semver,Ie,Pe);var ze=!(this.operator!==">="&&this.operator!==">"||we.operator!==">="&&we.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||we.operator!=="<="&&we.operator!=="<"),tt=this.semver.version===we.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||we.operator!==">="&&we.operator!=="<="),it=ae(this.semver,"<",we.semver,Pe)&&(this.operator===">="||this.operator===">")&&(we.operator==="<="||we.operator==="<"),rt=ae(this.semver,">",we.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(we.operator===">="||we.operator===">");return ze||qe||tt&&Qe||it||rt},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(we){return we.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(we){var Pe=this.loose;we=we.trim(),u("range",we,Pe);var Ie=Pe?T[J]:T[V];we=we.replace(Ie,_),u("hyphen replace",we),we=we.replace(T[ie],"$1$2$3"),u("comparator trim",we,T[ie]),we=(we=(we=we.replace(T[W],"$1~")).replace(T[M],"$1^")).split(/\s+/).join(" ");var ze=Pe?T[j]:T[he],qe=we.split(" ").map(function(tt){return function(Qe,it){return u("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(et){return function($,Q){u("caret",$,Q);var ge=Q?T[U]:T[B];return $.replace(ge,function(Le,Ne,je,Ye,Xe){var nt;return u("caret",$,Le,Ne,je,Ye,Xe),G(Ne)?nt="":G(je)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":G(Ye)?nt=Ne==="0"?">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+".0 <"+(+Ne+1)+".0.0":Xe?(u("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),nt=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+je+"."+(+Ye+1):">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+Ye+Xe+" <"+(+Ne+1)+".0.0"):(u("no pr"),nt=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+je+"."+(+Ye+1):">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+Ye+" <"+(+Ne+1)+".0.0"),u("caret return",nt),nt})}(et,Be)}).join(" ")}(Qe,it),u("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(et){return function($,Q){var ge=Q?T[Y]:T[q];return $.replace(ge,function(Le,Ne,je,Ye,Xe){var nt;return u("tilde",$,Le,Ne,je,Ye,Xe),G(Ne)?nt="":G(je)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":G(Ye)?nt=">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":Xe?(u("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),nt=">="+Ne+"."+je+"."+Ye+Xe+" <"+Ne+"."+(+je+1)+".0"):nt=">="+Ne+"."+je+"."+Ye+" <"+Ne+"."+(+je+1)+".0",u("tilde return",nt),nt})}(et,Be)}).join(" ")}(Qe,it),u("tildes",Qe),Qe=function(rt,Be){return u("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(et){return function($,Q){$=$.trim();var ge=Q?T[b]:T[h];return $.replace(ge,function(Le,Ne,je,Ye,Xe,nt){u("xRange",$,Le,Ne,je,Ye,Xe,nt);var ot=G(je),pt=ot||G(Ye),bt=pt||G(Xe);return Ne==="="&&bt&&(Ne=""),ot?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&bt?(pt&&(Ye=0),bt&&(Xe=0),Ne===">"?(Ne=">=",pt?(je=+je+1,Ye=0,Xe=0):bt&&(Ye=+Ye+1,Xe=0)):Ne==="<="&&(Ne="<",pt?je=+je+1:Ye=+Ye+1),Le=Ne+je+"."+Ye+"."+Xe):pt?Le=">="+je+".0.0 <"+(+je+1)+".0.0":bt&&(Le=">="+je+"."+Ye+".0 <"+je+"."+(+Ye+1)+".0"),u("xRange return",Le),Le})}(et,Be)}).join(" ")}(Qe,it),u("xrange",Qe),Qe=function(rt,Be){return u("replaceStars",rt,Be),rt.trim().replace(T[ne],"")}(Qe,it),u("stars",Qe),Qe}(tt,Pe)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(tt){return!!tt.match(ze)})),qe=qe.map(function(tt){return new oe(tt,Pe)})},z.prototype.intersects=function(we,Pe){if(!(we instanceof z))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(ze){return we.set.some(function(qe){return qe.every(function(tt){return ze.intersects(tt,Pe)})})})})},e.toComparators=function(we,Pe){return new z(we,Pe).set.map(function(Ie){return Ie.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},z.prototype.test=function(we){if(!we)return!1;typeof we=="string"&&(we=new ee(we,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if(fe(this.set[Pe],we))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(we,Pe,Ie){var ze=null,qe=null;try{var tt=new z(Pe,Ie)}catch{return null}return we.forEach(function(Qe){tt.test(Qe)&&(ze&&qe.compare(Qe)!==-1||(qe=new ee(ze=Qe,Ie)))}),ze},e.minSatisfying=function(we,Pe,Ie){var ze=null,qe=null;try{var tt=new z(Pe,Ie)}catch{return null}return we.forEach(function(Qe){tt.test(Qe)&&(ze&&qe.compare(Qe)!==1||(qe=new ee(ze=Qe,Ie)))}),ze},e.validRange=function(we,Pe){try{return new z(we,Pe).range||"*"}catch{return null}},e.ltr=function(we,Pe,Ie){return Ae(we,Pe,"<",Ie)},e.gtr=function(we,Pe,Ie){return Ae(we,Pe,">",Ie)},e.outside=Ae,e.prerelease=function(we,Pe){var Ie=ue(we,Pe);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(we,Pe,Ie){return we=new z(we,Ie),Pe=new z(Pe,Ie),we.intersects(Pe)},e.coerce=function(we){if(we instanceof ee)return we;if(typeof we!="string")return null;var Pe=we.match(T[p]);return Pe==null?null:ue((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,c(1))},function(re,e){var c,A,u=re.exports={};function R(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function T(r){if(c===setTimeout)return setTimeout(r,0);if((c===R||!c)&&setTimeout)return c=setTimeout,setTimeout(r,0);try{return c(r,0)}catch{try{return c.call(null,r,0)}catch{return c.call(this,r,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:R}catch{c=R}try{A=typeof clearTimeout=="function"?clearTimeout:P}catch{A=P}})();var D,g=[],L=!1,k=-1;function S(){L&&D&&(L=!1,D.length?g=D.concat(g):k=-1,g.length&&I())}function I(){if(!L){var r=T(S);L=!0;for(var d=g.length;d;){for(D=g,g=[];++k<d;)D&&D[k].run();k=-1,d=g.length}D=null,L=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===P||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(r)}}function C(r,d){this.fun=r,this.array=d}function E(){}u.nextTick=function(r){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];g.push(new C(r,d)),g.length!==1||L||T(I)},C.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=E,u.addListener=E,u.once=E,u.off=E,u.removeListener=E,u.removeAllListeners=E,u.emit=E,u.prependListener=E,u.prependOnceListener=E,u.listeners=function(r){return[]},u.binding=function(r){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(r){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(De[104],Ce([1,0,9,6]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(y){const m=y;return m?typeof m.read=="function":!1}e.isReadable=u;function R(y){const m=y;return m?[m.on,m.pause,m.resume,m.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function P(y){const m=y;return m?R(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=P;function T(y,m){return new D(y,m)}e.newWriteableStream=T;class D{constructor(m,t){this.e=m,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(t=>t(m))}h(m){this.c.error.length===0?(0,c.onUnexpectedError)(m):this.c.error.slice(0).forEach(t=>t(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,t){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(m,t){if(this.a.destroyed)return;let o;switch(m){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(y,m){const t=[];let o;for(;(o=y.read())!==null;)t.push(o);return m(t)}e.consumeReadable=g;function L(y,m,t){const o=[];let s;for(;(s=y.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?m(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const a=s;return s=void 0,a}return y.read()}}}e.peekReadable=L;function k(y,m){return new Promise((t,o)=>{const s=[];S(y,{onData:a=>{m&&s.push(a)},onError:a=>{m?o(a):t(void 0)},onEnd:()=>{t(m?m(s):void 0)}})})}e.consumeStream=k;function S(y,m){let t=!1;return y.on("error",o=>{t||m.onError(o)}),y.on("end",()=>{t||m.onEnd()}),y.on("data",o=>{t||m.onData(o)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=S;function I(y,m){return new Promise((t,o)=>{const s=new A.DisposableStore,a=[],l=n=>{if(a.push(n),a.length>m)return s.dispose(),y.pause(),t({stream:y,buffer:a,ended:!1})},v=n=>o(n),i=()=>t({stream:y,buffer:a,ended:!0});s.add((0,A.toDisposable)(()=>y.removeListener("error",v))),y.on("error",v),s.add((0,A.toDisposable)(()=>y.removeListener("end",i))),y.on("end",i),s.add((0,A.toDisposable)(()=>y.removeListener("data",l))),y.on("data",l)})}e.peekStream=I;function C(y,m){const t=T(m);return t.end(y),t}e.toStream=C;function E(){const y=T(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=E;function r(y){let m=!1;return{read:()=>m?null:(m=!0,y)}}e.toReadable=r;function d(y,m,t){const o=T(t);return S(y,{onData:s=>o.write(m.data(s)),onError:s=>o.error(m.error?m.error(s):s),onEnd:()=>o.end()}),o}e.transform=d;function f(y,m,t){let o=!1;return{read:()=>{const s=m.read();return o?s:(o=!0,s!==null?t([y,s]):y)}}}e.prefixedReadable=f;function w(y,m,t){let o=!1;const s=T(t);return S(m,{onData:a=>o?s.write(a):(o=!0,s.write(t([y,a]))),onError:a=>s.error(a),onEnd:()=>{o||(o=!0,s.write(y)),s.end()}}),s}e.prefixedStream=w}),define(De[22],Ce([1,0,104]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let u,R;class P{static alloc(n){return A?new P(Buffer.allocUnsafe(n)):new P(new Uint8Array(n))}static wrap(n){return A&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new P(n)}static fromString(n,h){return!(h?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(n)):(u||(u=new TextEncoder),new P(u.encode(n)))}static fromByteArray(n){const h=P.alloc(n.length);for(let b=0,p=n.length;b<p;b++)h.buffer[b]=n[b];return h}static concat(n,h){if(typeof h>"u"){h=0;for(let O=0,W=n.length;O<W;O++)h+=n[O].byteLength}const b=P.alloc(h);let p=0;for(let O=0,W=n.length;O<W;O++){const q=n[O];b.set(q,p),p+=q.byteLength}return b}constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}clone(){const n=P.alloc(this.byteLength);return n.set(this),n}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,h){return new P(this.buffer.subarray(n,h))}set(n,h){if(n instanceof P)this.buffer.set(n.buffer,h);else if(n instanceof Uint8Array)this.buffer.set(n,h);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),h);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,h){L(this.buffer,n,h)}readUInt32LE(n){return k(this.buffer,n)}writeUInt32LE(n,h){S(this.buffer,n,h)}readUInt8(n){return I(this.buffer,n)}writeUInt8(n,h){C(this.buffer,n,h)}}e.VSBuffer=P;function T(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}e.readUInt16LE=T;function D(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255}e.writeUInt16LE=D;function g(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}e.readUInt32BE=g;function L(i,n,h){i[h+3]=n,n=n>>>8,i[h+2]=n,n=n>>>8,i[h+1]=n,n=n>>>8,i[h]=n}e.writeUInt32BE=L;function k(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}e.readUInt32LE=k;function S(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255,n=n>>>8,i[h+2]=n&255,n=n>>>8,i[h+3]=n&255}e.writeUInt32LE=S;function I(i,n){return i[n]}e.readUInt8=I;function C(i,n,h){i[h]=n}e.writeUInt8=C;function E(i){return c.consumeReadable(i,n=>P.concat(n))}e.readableToBuffer=E;function r(i){return c.toReadable(i)}e.bufferToReadable=r;function d(i){return c.consumeStream(i,n=>P.concat(n))}e.streamToBuffer=d;async function f(i){return i.ended?P.concat(i.buffer):P.concat([...i.buffer,await d(i.stream)])}e.bufferedStreamToBuffer=f;function w(i){return c.toStream(i,n=>P.concat(n))}e.bufferToStream=w;function y(i){return c.transform(i,{data:n=>typeof n=="string"?P.fromString(n):P.wrap(n)},n=>P.concat(n))}e.streamToBufferReadableStream=y;function m(i){return c.newWriteableStream(n=>P.concat(n),i)}e.newWriteableBufferStream=m;function t(i,n){return c.prefixedReadable(i,n,h=>P.concat(h))}e.prefixedBufferReadable=t;function o(i,n){return c.prefixedStream(i,n,h=>P.concat(h))}e.prefixedBufferStream=o;function s(i){let n=0,h=0,b=0;const p=new Uint8Array(Math.floor(i.length/4*3)),O=q=>{switch(h){case 3:p[b++]=n|q,h=0;break;case 2:p[b++]=n|q>>>2,n=q<<6,h=3;break;case 1:p[b++]=n|q>>>4,n=q<<4,h=2;break;default:n=q<<2,h=1}};for(let q=0;q<i.length;q++){const Y=i.charCodeAt(q);if(Y>=65&&Y<=90)O(Y-65);else if(Y>=97&&Y<=122)O(Y-97+26);else if(Y>=48&&Y<=57)O(Y-48+52);else if(Y===43||Y===45)O(62);else if(Y===47||Y===95)O(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${i[q]}`)}}const W=b;for(;h>0;)O(0);return P.wrap(p).slice(0,W)}e.decodeBase64=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:i},n=!0,h=!1){const b=h?l:a;let p="";const O=i.byteLength%3;let W=0;for(;W<i.byteLength-O;W+=3){const q=i[W+0],Y=i[W+1],x=i[W+2];p+=b[q>>>2],p+=b[(q<<4|Y>>>4)&63],p+=b[(Y<<2|x>>>6)&63],p+=b[x&63]}if(O===1){const q=i[W+0];p+=b[q>>>2],p+=b[q<<4&63],n&&(p+="==")}else if(O===2){const q=i[W+0],Y=i[W+1];p+=b[q>>>2],p+=b[(q<<4|Y>>>4)&63],p+=b[Y<<2&63],n&&(p+="=")}return p}e.encodeBase64=v}),define(De[149],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[10],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(o){return typeof o=="string"}e.isString=c;function A(o){return Array.isArray(o)&&o.every(s=>c(s))}e.isStringArray=A;function u(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=u;function R(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=R;function P(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=P;function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=T;function D(o){return o===!0||o===!1}e.isBoolean=D;function g(o){return typeof o>"u"}e.isUndefined=g;function L(o){return!k(o)}e.isDefined=L;function k(o){return g(o)||o===null}e.isUndefinedOrNull=k;function S(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=S;function I(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=I;function C(...o){const s=[];for(let a=0;a<o.length;a++){const l=o[a];if(k(l))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(l)}return s}e.assertAllDefined=C;const E=Object.prototype.hasOwnProperty;function r(o){if(!u(o))return!1;for(const s in o)if(E.call(o,s))return!1;return!0}e.isEmptyObject=r;function d(o){return typeof o=="function"}e.isFunction=d;function f(...o){return o.length>0&&o.every(d)}e.areFunctions=f;function w(o,s){const a=Math.min(o.length,s.length);for(let l=0;l<a;l++)y(o[l],s[l])}e.validateConstraints=w;function y(o,s){if(c(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(d(s)){try{if(o instanceof s)return}catch{}if(!k(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function m(o){return o===null?void 0:o}e.withNullAsUndefined=m;function t(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=t}),define(De[67],Ce([1,0,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function u(T,D){if((0,c.isString)(D)){const g=A[D];if(g===void 0)throw new Error(`${T} references an unknown codicon: ${D}`);D=g}return A[T]=D,{id:T}}function R(){return A}e.getCodiconFontCharacters=R;function P(){return Object.values(e.Codicon)}e.getAllCodicons=P,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([w,y])=>{f[w]=y&&typeof y=="object"?A(y):y}),f}e.deepClone=A;function u(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const w=f.shift();Object.freeze(w);for(const y in w)if(R.call(w,y)){const m=w[y];typeof m=="object"&&!Object.isFrozen(m)&&!(0,c.isTypedArray)(m)&&f.push(m)}}return d}e.deepFreeze=u;const R=Object.prototype.hasOwnProperty;function P(d,f){return T(d,f,new Set)}e.cloneAndChange=P;function T(d,f,w){if((0,c.isUndefinedOrNull)(d))return d;const y=f(d);if(typeof y<"u")return y;if(Array.isArray(d)){const m=[];for(const t of d)m.push(T(t,f,w));return m}if((0,c.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const m={};for(const t in d)R.call(d,t)&&(m[t]=T(d[t],f,w));return w.delete(d),m}return d}function D(d,f,w=!0){return(0,c.isObject)(d)?((0,c.isObject)(f)&&Object.keys(f).forEach(y=>{y in d?w&&((0,c.isObject)(d[y])&&(0,c.isObject)(f[y])?D(d[y],f[y],w):d[y]=f[y]):d[y]=f[y]}),d):f}e.mixin=D;function g(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let w,y;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(w=0;w<d.length;w++)if(!g(d[w],f[w]))return!1}else{const m=[];for(y in d)m.push(y);m.sort();const t=[];for(y in f)t.push(y);if(t.sort(),!g(m,t))return!1;for(w=0;w<m.length;w++)if(!g(d[m[w]],f[m[w]]))return!1}return!0}e.equals=g;function L(d){const f=new Set;return JSON.stringify(d,(w,y)=>{if((0,c.isObject)(y)||Array.isArray(y)){if(f.has(y))return"[Circular]";f.add(y)}return y})}e.safeStringify=L;function k(d,f){const w=Object.create(null);return!d||!f||Object.keys(f).forEach(m=>{const t=d[m],o=f[m];g(t,o)||(w[m]=o)}),w}e.distinct=k;function S(d,f){const w=f.toLowerCase(),y=Object.keys(d).find(m=>m.toLowerCase()===w);return y?d[y]:d[f]}e.getCaseInsensitive=S;function I(d,f){const w=Object.create(null);for(const[y,m]of Object.entries(d))f(y,m)&&(w[y]=m);return w}e.filter=I;function C(d){let f=[],w=Object.getPrototypeOf(d);for(;Object.prototype!==w;)f=f.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return f}e.getAllPropertyNames=C;function E(d){const f=[];for(const w of C(d))typeof d[w]=="function"&&f.push(w);return f}e.getAllMethodNames=E;function r(d,f){const w=m=>function(){const t=Array.prototype.slice.call(arguments,0);return f(m,t)},y={};for(const m of d)y[m]=w(m);return y}e.createProxyObject=r}),define(De[52],Ce([1,0,67]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(P){function T(D){return D&&typeof D=="object"&&typeof D.id=="string"}P.isThemeColor=T})(A=e.ThemeColor||(e.ThemeColor={}));function u(P){return{id:P}}e.themeColorFromId=u;var R;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function D(f){const w=T.exec(f.id);if(!w)return D(c.Codicon.error);const[,y,m]=w,t=["codicon","codicon-"+y];return m&&t.push("codicon-modifier-"+m.substring(1)),t}P.asClassNameArray=D;function g(f){return D(f).join(" ")}P.asClassName=g;function L(f){return"."+D(f).join(".")}P.asCSSSelector=L;function k(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||A.isThemeColor(f.color))}P.isThemeIcon=k;const S=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function I(f){const w=S.exec(f);if(!w)return;const[,y]=w;return{id:y}}P.fromString=I;function C(f){return{id:f}}P.fromId=C;function E(f,w){let y=f.id;const m=y.lastIndexOf("~");return m!==-1&&(y=y.substring(0,m)),w&&(y=`${y}~${w}`),{id:y}}P.modify=E;function r(f){const w=f.id.lastIndexOf("~");if(w!==-1)return f.id.substring(w+1)}P.getModifier=r;function d(f,w){return f.id===w.id&&f.color?.id===w.color?.id}P.isEqual=d})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(De[105],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function u(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=u}),define(De[30],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(u){return c.test(u)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(T){for(let D=0;D<T.length;D++)T[D]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),P=[];for(let T=0;T<256;T++)P.push(T.toString(16).padStart(2,"0"));return function(){u(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let D=0,g="";return g+=P[R[D++]],g+=P[R[D++]],g+=P[R[D++]],g+=P[R[D++]],g+="-",g+=P[R[D++]],g+=P[R[D++]],g+="-",g+=P[R[D++]],g+=P[R[D++]],g+="-",g+=P[R[D++]],g+=P[R[D++]],g+="-",g+=P[R[D++]],g+=P[R[D++]],g+=P[R[D++]],g+=P[R[D++]],g+=P[R[D++]],g+=P[R[D++]],g}}()}),define(De[150],Ce([1,0,17,30]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function u(T){return{id:(0,A.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=u;function R(T,D,g){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:D,data:g}),value:void 0}}e.createFileDataTransferItem=R;class P{constructor(){this.a=new Map}get size(){return this.a.size}has(D){return this.a.has(this.b(D))}get(D){return this.a.get(this.b(D))?.[0]}append(D,g){const L=this.a.get(D);L?L.push(g):this.a.set(this.b(D),[g])}replace(D,g){this.a.set(this.b(D),[g])}delete(D){this.a.delete(this.b(D))}*entries(){for(const[D,g]of this.a.entries())for(const L of g)yield[D,L]}values(){return Array.from(this.a.values()).flat()}forEach(D){for(const[g,L]of this.entries())D(L,g)}b(D){return D.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:T=>(0,c.distinct)(T.map(D=>D.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(D=>!D.startsWith("#"))})}),define(De[106],Ce([1,0,105]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(T){const D=(0,c.toUint8)(T);this.c=D,this.a=A.d(D),this.b=new Map}static d(T){const D=new Uint8Array(256);return D.fill(T),D}set(T,D){const g=(0,c.toUint8)(D);T>=0&&T<256?this.a[T]=g:this.b.set(T,g)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var u;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(u||(u={}));class R{constructor(){this.a=new A(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(De[53],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(u,R){this.lineNumber=u,this.column=R}with(u=this.lineNumber,R=this.column){return u===this.lineNumber&&R===this.column?this:new c(u,R)}delta(u=0,R=0){return this.with(this.lineNumber+u,this.column+R)}equals(u){return c.equals(this,u)}static equals(u,R){return!u&&!R?!0:!!u&&!!R&&u.lineNumber===R.lineNumber&&u.column===R.column}isBefore(u){return c.isBefore(this,u)}static isBefore(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<R.column}isBeforeOrEqual(u){return c.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<=R.column}static compare(u,R){const P=u.lineNumber|0,T=R.lineNumber|0;if(P===T){const D=u.column|0,g=R.column|0;return D-g}return P-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new c(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=c}),define(De[32],Ce([1,0,53]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,P,T,D){R>T||R===T&&P>D?(this.startLineNumber=T,this.startColumn=D,this.endLineNumber=R,this.endColumn=P):(this.startLineNumber=R,this.startColumn=P,this.endLineNumber=T,this.endColumn=D)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<R.startColumn||P.lineNumber===R.endLineNumber&&P.column>R.endColumn)}static strictContainsPosition(R,P){return!(P.lineNumber<R.startLineNumber||P.lineNumber>R.endLineNumber||P.lineNumber===R.startLineNumber&&P.column<=R.startColumn||P.lineNumber===R.endLineNumber&&P.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,P){return!(P.startLineNumber<R.startLineNumber||P.endLineNumber<R.startLineNumber||P.startLineNumber>R.endLineNumber||P.endLineNumber>R.endLineNumber||P.startLineNumber===R.startLineNumber&&P.startColumn<=R.startColumn||P.endLineNumber===R.endLineNumber&&P.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,P){let T,D,g,L;return P.startLineNumber<R.startLineNumber?(T=P.startLineNumber,D=P.startColumn):P.startLineNumber===R.startLineNumber?(T=P.startLineNumber,D=Math.min(P.startColumn,R.startColumn)):(T=R.startLineNumber,D=R.startColumn),P.endLineNumber>R.endLineNumber?(g=P.endLineNumber,L=P.endColumn):P.endLineNumber===R.endLineNumber?(g=P.endLineNumber,L=Math.max(P.endColumn,R.endColumn)):(g=R.endLineNumber,L=R.endColumn),new A(T,D,g,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,P){let T=R.startLineNumber,D=R.startColumn,g=R.endLineNumber,L=R.endColumn;const k=P.startLineNumber,S=P.startColumn,I=P.endLineNumber,C=P.endColumn;return T<k?(T=k,D=S):T===k&&(D=Math.max(D,S)),g>I?(g=I,L=C):g===I&&(L=Math.min(L,C)),T>g||T===g&&D>L?null:new A(T,D,g,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,P){return!R&&!P?!0:!!R&&!!P&&R.startLineNumber===P.startLineNumber&&R.startColumn===P.startColumn&&R.endLineNumber===P.endLineNumber&&R.endColumn===P.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new c.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new c.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,P){return new A(this.startLineNumber,this.startColumn,R,P)}setStartPosition(R,P){return new A(R,P,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,P=R){return new A(R.lineNumber,R.column,P.lineNumber,P.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<R.startColumn)}static areIntersecting(R,P){return!(R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<=P.startColumn||P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,P){if(R&&P){const g=R.startLineNumber|0,L=P.startLineNumber|0;if(g===L){const k=R.startColumn|0,S=P.startColumn|0;if(k===S){const I=R.endLineNumber|0,C=P.endLineNumber|0;if(I===C){const E=R.endColumn|0,r=P.endColumn|0;return E-r}return I-C}return k-S}return g-L}return(R?1:0)-(P?1:0)}static compareRangesUsingEnds(R,P){return R.endLineNumber===P.endLineNumber?R.endColumn===P.endColumn?R.startLineNumber===P.startLineNumber?R.startColumn-P.startColumn:R.startLineNumber-P.startLineNumber:R.endColumn-P.endColumn:R.endLineNumber-P.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(De[151],Ce([1,0,53,32]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(u=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(T,D,g,L){super(T,D,g,L),this.selectionStartLineNumber=T,this.selectionStartColumn=D,this.positionLineNumber=g,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,D){return T.selectionStartLineNumber===D.selectionStartLineNumber&&T.selectionStartColumn===D.selectionStartColumn&&T.positionLineNumber===D.positionLineNumber&&T.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,D){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,T,D):new R(T,D,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,D){return this.getDirection()===0?new R(T,D,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,D)}static fromPositions(T,D=T){return new R(T.lineNumber,T.column,D.lineNumber,D.column)}static fromRange(T,D){return D===0?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,D){if(T&&!D||!T&&D)return!1;if(!T&&!D)return!0;if(T.length!==D.length)return!1;for(let g=0,L=T.length;g<L;g++)if(!this.selectionsEqual(T[g],D[g]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,D,g,L,k){return k===0?new R(T,D,g,L):new R(g,L,T,D)}}e.Selection=R}),define(De[152],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[153],Ce([1,0,106]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class u extends c.CharacterClassifier{constructor(T){super(0);for(let D=0,g=T.length;D<g;D++)this.set(T.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function R(P){const T={};return D=>(T.hasOwnProperty(D)||(T[D]=P(D)),T[D])}e.getMapForWordSeparators=R(P=>new u(P))}),define(De[107],Ce([1,0,64,6,66]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)k.indexOf(I)>=0||(S+="\\"+I);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=R();function P(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let I="g";k.ignoreCase&&(I+="i"),k.multiline&&(I+="m"),k.unicode&&(I+="u"),S=new RegExp(k.source,I)}return S.lastIndex=0,S}e.ensureValidWordDefinition=P;const T=new u.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function D(k){const S=T.unshift(k);return(0,A.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=D;function g(k,S,I,C,E){if(E||(E=c.Iterable.first(T)),I.length>E.maxLen){let y=k-E.maxLen/2;return y<0?y=0:C+=y,I=I.substring(y,k+E.maxLen/2),g(k,S,I,C,E)}const r=Date.now(),d=k-1-C;let f=-1,w=null;for(let y=1;!(Date.now()-r>=E.timeBudget);y++){const m=d-E.windowSize*y;S.lastIndex=Math.max(0,m);const t=L(S,I,d,f);if(!t&&w||(w=t,m<=0))break;f=m}if(w){const y={word:w[0],startColumn:C+1+w.index,endColumn:C+1+w.index+w[0].length};return S.lastIndex=0,y}return null}e.getWordAtText=g;function L(k,S,I,C){let E;for(;E=k.exec(S);){const r=E.index||0;if(r<=I&&k.lastIndex>=I)return E;if(C>0&&r>C)return null}return null}}),define(De[154],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class A{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let D=0,g=T.notIn.length;D<g;D++)switch(T.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,D){if(T.getTokenCount()===0)return!0;const g=T.findTokenIndexAtOffset(D-2),L=T.getStandardTokenType(g);return this.isOK(L)}g(T,D){for(let g=T;g<=D;g++){const L=String.fromCharCode(g);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class u{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of T)R(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),R(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),R(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),R(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&R(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=u;function R(P,T,D){P.has(T)?P.get(T).push(D):P.set(T,[D])}}),define(De[155],Ce([1,0,106]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class u{constructor(C,E,r){const d=new Uint8Array(C*E);for(let f=0,w=C*E;f<w;f++)d[f]=r;this.a=d,this.rows=C,this.cols=E}get(C,E){return this.a[C*this.cols+E]}set(C,E,r){this.a[C*this.cols+E]=r}}class R{constructor(C){let E=0,r=0;for(let f=0,w=C.length;f<w;f++){const[y,m,t]=C[f];m>E&&(E=m),y>r&&(r=y),t>r&&(r=t)}E++,r++;const d=new u(r,E,0);for(let f=0,w=C.length;f<w;f++){const[y,m,t]=C[f];d.set(y,m,t)}this.a=d,this.b=E}nextState(C,E){return E<0||E>=this.b?0:this.a.get(C,E)}}e.StateMachine=R;let P=null;function T(){return P===null&&(P=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var D;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let g=null;function L(){if(g===null){g=new c.CharacterClassifier(0);const I=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<I.length;E++)g.set(I.charCodeAt(E),1);const C=".,;:";for(let E=0;E<C.length;E++)g.set(C.charCodeAt(E),2)}return g}class k{static a(C,E,r,d,f){let w=f-1;do{const y=E.charCodeAt(w);if(C.get(y)!==2)break;w--}while(w>d);if(d>0){const y=E.charCodeAt(d-1),m=E.charCodeAt(w);(y===40&&m===41||y===91&&m===93||y===123&&m===125)&&w--}return{range:{startLineNumber:r,startColumn:d+1,endLineNumber:r,endColumn:w+2},url:E.substring(d,w+1)}}static computeLinks(C,E=T()){const r=L(),d=[];for(let f=1,w=C.getLineCount();f<=w;f++){const y=C.getLineContent(f),m=y.length;let t=0,o=0,s=0,a=1,l=!1,v=!1,i=!1,n=!1;for(;t<m;){let h=!1;const b=y.charCodeAt(t);if(a===13){let p;switch(b){case 40:l=!0,p=0;break;case 41:p=l?0:1;break;case 91:i=!0,v=!0,p=0;break;case 93:i=!1,p=v?0:1;break;case 123:n=!0,p=0;break;case 125:p=n?0:1;break;case 39:case 34:case 96:s===b?p=1:s===39||s===34||s===96?p=0:p=1;break;case 42:p=s===42?1:0;break;case 124:p=s===124?1:0;break;case 32:p=i?0:1;break;default:p=r.get(b)}p===1&&(d.push(k.a(r,y,f,o,t)),h=!0)}else if(a===12){let p;b===91?(v=!0,p=0):p=r.get(b),p===1?h=!0:a=13}else a=E.nextState(a,b),a===0&&(h=!0);h&&(a=1,l=!1,v=!1,n=!1,o=t+1,s=b),t++}a===13&&d.push(k.a(r,y,f,o,m))}return d}}e.LinkComputer=k;function S(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:k.computeLinks(I)}e.computeLinks=S}),define(De[108],Ce([1,0,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var u;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(u=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var P;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),y.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,y.indentSize|0),this.a=!1),this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.a===y.a&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=g;class L{constructor(y,m){this._findMatchBrand=void 0,this.range=y,this.matches=m}}e.FindMatch=L;var k;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(w){return w&&typeof w.read=="function"}e.isITextSnapshot=S;var I;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(I=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class E{constructor(y,m,t,o,s,a){this.identifier=y,this.range=m,this.text=t,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=a}}e.ValidAnnotatedEditOperation=E;class r{constructor(y,m,t){this.regex=y,this.wordSeparators=m,this.simpleSearch=t}}e.SearchData=r;class d{constructor(y,m,t){this.reverseEdits=y,this.changes=m,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=d;function f(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=f}),define(De[156],Ce([1,0,17,105]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(D){this.a=D,this.b=new Uint32Array(D.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(D,g){D=(0,A.toUint32)(D);const L=this.a,k=this.b,S=g.length;return S===0?!1:(this.a=new Uint32Array(L.length+S),this.a.set(L.subarray(0,D),0),this.a.set(L.subarray(D),D+S),this.a.set(g,D),D-1<this.c[0]&&(this.c[0]=D-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}setValue(D,g){return D=(0,A.toUint32)(D),g=(0,A.toUint32)(g),this.a[D]===g?!1:(this.a[D]=g,D-1<this.c[0]&&(this.c[0]=D-1),!0)}removeValues(D,g){D=(0,A.toUint32)(D),g=(0,A.toUint32)(g);const L=this.a,k=this.b;if(D>=L.length)return!1;const S=L.length-D;return g>=S&&(g=S),g===0?!1:(this.a=new Uint32Array(L.length-g),this.a.set(L.subarray(0,D),0),this.a.set(L.subarray(D+g),D),this.b=new Uint32Array(this.a.length),D-1<this.c[0]&&(this.c[0]=D-1),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(D){return D<0?0:(D=(0,A.toUint32)(D),this.d(D))}d(D){if(D<=this.c[0])return this.b[D];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),D>=this.a.length&&(D=this.a.length-1);for(let L=g;L<=D;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],D),this.b[D]}getIndexOf(D){D=Math.floor(D),this.getTotalSum();let g=0,L=this.a.length-1,k=0,S=0,I=0;for(;g<=L;)if(k=g+(L-g)/2|0,S=this.b[k],I=S-this.a[k],D<I)L=k-1;else if(D>=S)g=k+1;else break;return new P(k,D-I)}}e.PrefixSumComputer=u;class R{constructor(D){this.a=D,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(D){return this.g(),D===0?0:this.d[D-1]}getIndexOf(D){this.g();const g=this.e[D],L=g>0?this.d[g-1]:0;return new P(g,D-L)}removeValues(D,g){this.a.splice(D,g),this.f(D)}insertValues(D,g){this.a=(0,c.arrayInsert)(this.a,D,g),this.f(D)}f(D){this.b=!1,this.c=Math.min(this.c,D-1)}g(){if(!this.b){for(let D=this.c+1,g=this.a.length;D<g;D++){const L=this.a[D],k=D>0?this.d[D-1]:0;this.d[D]=k+L;for(let S=0;S<L;S++)this.e[k+S]=D}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(D,g){this.a[D]!==g&&(this.a[D]=g,this.f(D))}}e.ConstantTimePrefixSumComputer=R;class P{constructor(D,g){this.index=D,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=D,this.remainder=g}}e.PrefixSumIndexOfResult=P}),define(De[157],Ce([14,15]),function(re,e){return re.create("vs/base/common/actions",e)}),define(De[158],Ce([14,15]),function(re,e){return re.create("vs/base/common/date",e)}),define(De[159],Ce([1,0,158]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,u=A*60,R=u*24,P=R*7,T=R*30,D=R*365;function g(k,S,I,C){typeof k!="number"&&(k=k.getTime());const E=Math.round((new Date().getTime()-k)/1e3);if(E<-30)return(0,c.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(!C&&E<30)return(0,c.localize)(1,null);let r;return E<A?(r=E,S?r===1?I?(0,c.localize)(2,null,r):(0,c.localize)(3,null,r):I?(0,c.localize)(4,null,r):(0,c.localize)(5,null,r):r===1?I?(0,c.localize)(6,null,r):(0,c.localize)(7,null,r):I?(0,c.localize)(8,null,r):(0,c.localize)(9,null,r)):E<u?(r=Math.floor(E/A),S?r===1?I?(0,c.localize)(10,null,r):(0,c.localize)(11,null,r):I?(0,c.localize)(12,null,r):(0,c.localize)(13,null,r):r===1?I?(0,c.localize)(14,null,r):(0,c.localize)(15,null,r):I?(0,c.localize)(16,null,r):(0,c.localize)(17,null,r)):E<R?(r=Math.floor(E/u),S?r===1?I?(0,c.localize)(18,null,r):(0,c.localize)(19,null,r):I?(0,c.localize)(20,null,r):(0,c.localize)(21,null,r):r===1?I?(0,c.localize)(22,null,r):(0,c.localize)(23,null,r):I?(0,c.localize)(24,null,r):(0,c.localize)(25,null,r)):E<P?(r=Math.floor(E/R),S?r===1?(0,c.localize)(26,null,r):(0,c.localize)(27,null,r):r===1?(0,c.localize)(28,null,r):(0,c.localize)(29,null,r)):E<T?(r=Math.floor(E/P),S?r===1?I?(0,c.localize)(30,null,r):(0,c.localize)(31,null,r):I?(0,c.localize)(32,null,r):(0,c.localize)(33,null,r):r===1?I?(0,c.localize)(34,null,r):(0,c.localize)(35,null,r):I?(0,c.localize)(36,null,r):(0,c.localize)(37,null,r)):E<D?(r=Math.floor(E/T),S?r===1?I?(0,c.localize)(38,null,r):(0,c.localize)(39,null,r):I?(0,c.localize)(40,null,r):(0,c.localize)(41,null,r):r===1?I?(0,c.localize)(42,null,r):(0,c.localize)(43,null,r):I?(0,c.localize)(44,null,r):(0,c.localize)(45,null,r)):(r=Math.floor(E/D),S?r===1?I?(0,c.localize)(46,null,r):(0,c.localize)(47,null,r):I?(0,c.localize)(48,null,r):(0,c.localize)(49,null,r):r===1?I?(0,c.localize)(50,null,r):(0,c.localize)(51,null,r):I?(0,c.localize)(52,null,r):(0,c.localize)(53,null,r))}e.fromNow=g;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[160],Ce([14,15]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,17,10,160]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,S){return S&&(k.stack||k.stacktrace)?u.localize(0,null,T(k),P(k.stack)||P(k.stacktrace)):T(k)}function P(k){return Array.isArray(k)?k.join(`
`):k}function T(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?u.localize(1,null,k.message):k.message||u.localize(2,null)}function D(k=null,S=!1){if(!k)return u.localize(3,null);if(Array.isArray(k)){const I=c.coalesce(k),C=D(I[0],S);return I.length>1?u.localize(4,null,C,I.length):C}if(A.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return R(I.error,S);if(I.exception)return R(I.exception,S)}return k.stack?R(k,S):k.message?k.message:u.localize(5,null)}e.toErrorMessage=D;function g(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=g;function L(k,S){let I;return typeof k=="string"?I=new Error(k):I=k,I.actions=S,I}e.createErrorWithActions=L}),define(De[161],Ce([14,15]),function(re,e){return re.create("vs/base/common/platform",e)}),define(De[11],Ce([1,0,161]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,u=!1,R=!1,P=!1,T=!1,D=!1,g=!1,L=!1,k=!1,S=!1,I,C=e.LANGUAGE_DEFAULT,E,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const f=typeof d?.versions?.electron=="string",w=f&&d?.type==="renderer";if(typeof navigator=="object"&&!w)r=navigator.userAgent,A=r.indexOf("Windows")>=0,u=r.indexOf("Macintosh")>=0,L=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=r.indexOf("Linux")>=0,S=r?.indexOf("Mobi")>=0,D=!0,I=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,C=I;else if(typeof d=="object"){A=d.platform==="win32",u=d.platform==="darwin",R=d.platform==="linux",P=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=f,k=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const n=JSON.parse(i),h=n.availableLanguages["*"];I=n.locale,C=h||e.LANGUAGE_DEFAULT,E=n._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var y;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function m(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let t=0;u?t=1:A?t=3:R&&(t=2),e.isWindows=A,e.isMacintosh=u,e.isLinux=R,e.isLinuxSnap=P,e.isNative=T,e.isElectron=g,e.isWeb=D,e.isWebWorker=D&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=S,e.isCI=k,e.platform=t,e.userAgent=r,e.language=C;var o;(function(i){function n(){return e.language}i.value=n;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function b(){return e.language==="en"}i.isDefault=b})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let b=0,p=i.length;b<p;b++){const O=i[b];if(O.id===h.data.vscodeScheduleAsyncWork){i.splice(b,1),O.callback();return}}});let n=0;return h=>{const b=++n;i.push({id:b,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return i=>setTimeout(i)})();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=u||L?2:A?1:3;let a=!0,l=!1;function v(){if(!l){l=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=v,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const u=c.globals.vscode.process;A={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(De[12],Ce([1,0,36]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,u=97,R=90,P=122,T=46,D=47,g=92,L=58,k=63;class S extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const v=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${v} ${l} of type ${s}`;i+=`. Received type ${typeof a}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function I(t,o){if(t===null||typeof t!="object")throw new S(o,"Object",t)}function C(t,o){if(typeof t!="string")throw new S(o,"string",t)}const E=c.platform==="win32";function r(t){return t===D||t===g}function d(t){return t===D}function f(t){return t>=A&&t<=R||t>=u&&t<=P}function w(t,o,s,a){let l="",v=0,i=-1,n=0,h=0;for(let b=0;b<=t.length;++b){if(b<t.length)h=t.charCodeAt(b);else{if(a(h))break;h=D}if(a(h)){if(!(i===b-1||n===1))if(n===2){if(l.length<2||v!==2||l.charCodeAt(l.length-1)!==T||l.charCodeAt(l.length-2)!==T){if(l.length>2){const p=l.lastIndexOf(s);p===-1?(l="",v=0):(l=l.slice(0,p),v=l.length-1-l.lastIndexOf(s)),i=b,n=0;continue}else if(l.length!==0){l="",v=0,i=b,n=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",v=2)}else l.length>0?l+=`${s}${t.slice(i+1,b)}`:l=t.slice(i+1,b),v=b-i-1;i=b,n=0}else h===T&&n!==-1?++n:n=-1}return l}function y(t,o){I(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${a}`:`${s}${t}${a}`:a}e.win32={resolve(...t){let o="",s="",a=!1;for(let l=t.length-1;l>=-1;l--){let v;if(l>=0){if(v=t[l],C(v,"path"),v.length===0)continue}else o.length===0?v=c.cwd():(v=c.env[`=${o}`]||c.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==o.toLowerCase()&&v.charCodeAt(2)===g)&&(v=`${o}\\`));const i=v.length;let n=0,h="",b=!1;const p=v.charCodeAt(0);if(i===1)r(p)&&(n=1,b=!0);else if(r(p))if(b=!0,r(v.charCodeAt(1))){let O=2,W=O;for(;O<i&&!r(v.charCodeAt(O));)O++;if(O<i&&O!==W){const q=v.slice(W,O);for(W=O;O<i&&r(v.charCodeAt(O));)O++;if(O<i&&O!==W){for(W=O;O<i&&!r(v.charCodeAt(O));)O++;(O===i||O!==W)&&(h=`\\\\${q}\\${v.slice(W,O)}`,n=O)}}}else n=1;else f(p)&&v.charCodeAt(1)===L&&(h=v.slice(0,2),n=2,i>2&&r(v.charCodeAt(2))&&(b=!0,n=3));if(h.length>0)if(o.length>0){if(h.toLowerCase()!==o.toLowerCase())continue}else o=h;if(a){if(o.length>0)break}else if(s=`${v.slice(n)}\\${s}`,a=b,b&&o.length>0)break}return s=w(s,!a,"\\",r),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){C(t,"path");const o=t.length;if(o===0)return".";let s=0,a,l=!1;const v=t.charCodeAt(0);if(o===1)return d(v)?"\\":t;if(r(v))if(l=!0,r(t.charCodeAt(1))){let n=2,h=n;for(;n<o&&!r(t.charCodeAt(n));)n++;if(n<o&&n!==h){const b=t.slice(h,n);for(h=n;n<o&&r(t.charCodeAt(n));)n++;if(n<o&&n!==h){for(h=n;n<o&&!r(t.charCodeAt(n));)n++;if(n===o)return`\\\\${b}\\${t.slice(h)}\\`;n!==h&&(a=`\\\\${b}\\${t.slice(h,n)}`,s=n)}}}else s=1;else f(v)&&t.charCodeAt(1)===L&&(a=t.slice(0,2),s=2,o>2&&r(t.charCodeAt(2))&&(l=!0,s=3));let i=s<o?w(t.slice(s),!l,"\\",r):"";return i.length===0&&!l&&(i="."),i.length>0&&r(t.charCodeAt(o-1))&&(i+="\\"),a===void 0?l?`\\${i}`:i:l?`${a}\\${i}`:`${a}${i}`},isAbsolute(t){C(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return r(s)||o>2&&f(s)&&t.charCodeAt(1)===L&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let v=0;v<t.length;++v){const i=t[v];C(i,"path"),i.length>0&&(o===void 0?o=s=i:o+=`\\${i}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&r(s.charCodeAt(0))){++l;const v=s.length;v>1&&r(s.charCodeAt(1))&&(++l,v>2&&(r(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&r(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o)return"";const s=e.win32.resolve(t),a=e.win32.resolve(o);if(s===a||(t=s.toLowerCase(),o=a.toLowerCase(),t===o))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let v=t.length;for(;v-1>l&&t.charCodeAt(v-1)===g;)v--;const i=v-l;let n=0;for(;n<o.length&&o.charCodeAt(n)===g;)n++;let h=o.length;for(;h-1>n&&o.charCodeAt(h-1)===g;)h--;const b=h-n,p=i<b?i:b;let O=-1,W=0;for(;W<p;W++){const Y=t.charCodeAt(l+W);if(Y!==o.charCodeAt(n+W))break;Y===g&&(O=W)}if(W!==p){if(O===-1)return a}else{if(b>p){if(o.charCodeAt(n+W)===g)return a.slice(n+W+1);if(W===2)return a.slice(n+W)}i>p&&(t.charCodeAt(l+W)===g?O=W:W===2&&(O=3)),O===-1&&(O=0)}let q="";for(W=l+O+1;W<=v;++W)(W===v||t.charCodeAt(W)===g)&&(q+=q.length===0?"..":"\\..");return n+=O,q.length>0?`${q}${a.slice(n,h)}`:(a.charCodeAt(n)===g&&++n,a.slice(n,h))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const s=o.charCodeAt(2);if(s!==k&&s!==T)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return t},dirname(t){C(t,"path");const o=t.length;if(o===0)return".";let s=-1,a=0;const l=t.charCodeAt(0);if(o===1)return r(l)?t:".";if(r(l)){if(s=a=1,r(t.charCodeAt(1))){let n=2,h=n;for(;n<o&&!r(t.charCodeAt(n));)n++;if(n<o&&n!==h){for(h=n;n<o&&r(t.charCodeAt(n));)n++;if(n<o&&n!==h){for(h=n;n<o&&!r(t.charCodeAt(n));)n++;if(n===o)return t;n!==h&&(s=a=n+1)}}}}else f(l)&&t.charCodeAt(1)===L&&(s=o>2&&r(t.charCodeAt(2))?3:2,a=s);let v=-1,i=!0;for(let n=o-1;n>=a;--n)if(r(t.charCodeAt(n))){if(!i){v=n;break}}else i=!1;if(v===-1){if(s===-1)return".";v=s}return t.slice(0,v)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let s=0,a=-1,l=!0,v;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,n=-1;for(v=t.length-1;v>=s;--v){const h=t.charCodeAt(v);if(r(h)){if(!l){s=v+1;break}}else n===-1&&(l=!1,n=v+1),i>=0&&(h===o.charCodeAt(i)?--i===-1&&(a=v):(i=-1,a=n))}return s===a?a=n:a===-1&&(a=t.length),t.slice(s,a)}for(v=t.length-1;v>=s;--v)if(r(t.charCodeAt(v))){if(!l){s=v+1;break}}else a===-1&&(l=!1,a=v+1);return a===-1?"":t.slice(s,a)},extname(t){C(t,"path");let o=0,s=-1,a=0,l=-1,v=!0,i=0;t.length>=2&&t.charCodeAt(1)===L&&f(t.charCodeAt(0))&&(o=a=2);for(let n=t.length-1;n>=o;--n){const h=t.charCodeAt(n);if(r(h)){if(!v){a=n+1;break}continue}l===-1&&(v=!1,l=n+1),h===T?s===-1?s=n:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||l===-1||i===0||i===1&&s===l-1&&s===a+1?"":t.slice(s,l)},format:y.bind(null,"\\"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let a=0,l=t.charCodeAt(0);if(s===1)return r(l)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(r(l)){if(a=1,r(t.charCodeAt(1))){let O=2,W=O;for(;O<s&&!r(t.charCodeAt(O));)O++;if(O<s&&O!==W){for(W=O;O<s&&r(t.charCodeAt(O));)O++;if(O<s&&O!==W){for(W=O;O<s&&!r(t.charCodeAt(O));)O++;O===s?a=O:O!==W&&(a=O+1)}}}}else if(f(l)&&t.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=t,o;if(a=2,r(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;a=3}}a>0&&(o.root=t.slice(0,a));let v=-1,i=a,n=-1,h=!0,b=t.length-1,p=0;for(;b>=a;--b){if(l=t.charCodeAt(b),r(l)){if(!h){i=b+1;break}continue}n===-1&&(h=!1,n=b+1),l===T?v===-1?v=b:p!==1&&(p=1):v!==-1&&(p=-1)}return n!==-1&&(v===-1||p===0||p===1&&v===n-1&&v===i+1?o.base=o.name=t.slice(i,n):(o.name=t.slice(i,v),o.base=t.slice(i,n),o.ext=t.slice(v,n))),i>0&&i!==a?o.dir=t.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(E){const t=/\\/g;return()=>{const o=c.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let a=t.length-1;a>=-1&&!s;a--){const l=a>=0?t[a]:m();C(l,"path"),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===D)}return o=w(o,!s,"/",d),s?`/${o}`:o.length>0?o:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===D,s=t.charCodeAt(t.length-1)===D;return t=w(t,!o,"/",d),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===D},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const a=t[s];C(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(C(t,"from"),C(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,a=t.length,l=a-s,v=1,i=o.length-v,n=l<i?l:i;let h=-1,b=0;for(;b<n;b++){const O=t.charCodeAt(s+b);if(O!==o.charCodeAt(v+b))break;O===D&&(h=b)}if(b===n)if(i>n){if(o.charCodeAt(v+b)===D)return o.slice(v+b+1);if(b===0)return o.slice(v+b)}else l>n&&(t.charCodeAt(s+b)===D?h=b:b===0&&(h=0));let p="";for(b=s+h+1;b<=a;++b)(b===a||t.charCodeAt(b)===D)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(v+h)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===D;let s=-1,a=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===D){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&C(o,"ext"),C(t,"path");let s=0,a=-1,l=!0,v;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let i=o.length-1,n=-1;for(v=t.length-1;v>=0;--v){const h=t.charCodeAt(v);if(h===D){if(!l){s=v+1;break}}else n===-1&&(l=!1,n=v+1),i>=0&&(h===o.charCodeAt(i)?--i===-1&&(a=v):(i=-1,a=n))}return s===a?a=n:a===-1&&(a=t.length),t.slice(s,a)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===D){if(!l){s=v+1;break}}else a===-1&&(l=!1,a=v+1);return a===-1?"":t.slice(s,a)},extname(t){C(t,"path");let o=-1,s=0,a=-1,l=!0,v=0;for(let i=t.length-1;i>=0;--i){const n=t.charCodeAt(i);if(n===D){if(!l){s=i+1;break}continue}a===-1&&(l=!1,a=i+1),n===T?o===-1?o=i:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||a===-1||v===0||v===1&&o===a-1&&o===s+1?"":t.slice(o,a)},format:y.bind(null,"/"),parse(t){C(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===D;let a;s?(o.root="/",a=1):a=0;let l=-1,v=0,i=-1,n=!0,h=t.length-1,b=0;for(;h>=a;--h){const p=t.charCodeAt(h);if(p===D){if(!n){v=h+1;break}continue}i===-1&&(n=!1,i=h+1),p===T?l===-1?l=h:b!==1&&(b=1):l!==-1&&(b=-1)}if(i!==-1){const p=v===0&&s?1:v;l===-1||b===0||b===1&&l===i-1&&l===v+1?o.base=o.name=t.slice(p,i):(o.name=t.slice(p,l),o.base=t.slice(p,i),o.ext=t.slice(l,i))}return v>0?o.dir=t.slice(0,v-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(De[109],Ce([1,0,65,12]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new c.Lazy(()=>{const n=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:n,collatorIsNumeric:n.resolvedOptions().numeric}}),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(n,h,b=!1){const p=n||"",O=h||"",W=u.value.collator.compare(p,O);return u.value.collatorIsNumeric&&W===0&&p!==O?p<O?-1:1:W}e.compareFileNames=T;function D(n,h){const b=R.value.collator;return n=n||"",h=h||"",y(b,n,h)}e.compareFileNamesDefault=D;function g(n,h){const b=R.value.collator;return n=n||"",h=h||"",s(n,h)||y(b,n,h)}e.compareFileNamesUpper=g;function L(n,h){const b=R.value.collator;return n=n||"",h=h||"",o(n,h)||y(b,n,h)}e.compareFileNamesLower=L;function k(n,h){return n=n||"",h=h||"",n===h?0:n<h?-1:1}e.compareFileNamesUnicode=k;function S(n,h){const[b,p]=f(n),[O,W]=f(h);let q=u.value.collator.compare(p,W);if(q===0){if(u.value.collatorIsNumeric&&p!==W)return p<W?-1:1;if(q=u.value.collator.compare(b,O),u.value.collatorIsNumeric&&q===0&&b!==O)return b<O?-1:1}return q}e.compareFileExtensions=S;function I(n,h){n=n||"",h=h||"";const b=w(n),p=w(h),O=R.value.collator,W=P.value.collator;return y(W,b,p)||y(O,n,h)}e.compareFileExtensionsDefault=I;function C(n,h){n=n||"",h=h||"";const b=w(n),p=w(h),O=R.value.collator,W=P.value.collator;return y(W,b,p)||s(n,h)||y(O,n,h)}e.compareFileExtensionsUpper=C;function E(n,h){n=n||"",h=h||"";const b=w(n),p=w(h),O=R.value.collator,W=P.value.collator;return y(W,b,p)||o(n,h)||y(O,n,h)}e.compareFileExtensionsLower=E;function r(n,h){n=n||"",h=h||"";const b=w(n).toLowerCase(),p=w(h).toLowerCase();return b!==p?b<p?-1:1:n!==h?n<h?-1:1:0}e.compareFileExtensionsUnicode=r;const d=/^(.*?)(\.([^.]*))?$/;function f(n,h=!1){const b=n?d.exec(n):[];let p=[b&&b[1]||"",b&&b[3]||""];return h&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function w(n){const h=n?d.exec(n):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function y(n,h,b){const p=n.compare(h,b);return p!==0?p:h.length!==b.length?h.length<b.length?-1:1:0}function m(n){const h=n.charAt(0);return h.toLocaleUpperCase()!==h}function t(n){const h=n.charAt(0);return h.toLocaleLowerCase()!==h}function o(n,h){return m(n)&&t(h)?-1:t(n)&&m(h)?1:0}function s(n,h){return t(n)&&m(h)?-1:m(n)&&t(h)?1:0}function a(n,h,b=!1){return b||(n=n&&n.toLowerCase(),h=h&&h.toLowerCase()),n===h?0:n<h?-1:1}function l(n,h,b=!1){const p=n.split(A.sep),O=h.split(A.sep),W=p.length-1,q=O.length-1;let Y,x;for(let M=0;;M++){if(Y=W===M,x=q===M,Y&&x)return T(p[M],O[M],b);if(Y)return-1;if(x)return 1;const B=a(p[M],O[M],b);if(B!==0)return B}}e.comparePaths=l;function v(n,h,b){const p=n.toLowerCase(),O=h.toLowerCase(),W=i(n,h,b);if(W)return W;const q=p.endsWith(b),Y=O.endsWith(b);if(q!==Y)return q?-1:1;const x=T(p,O);return x!==0?x:p.localeCompare(O)}e.compareAnything=v;function i(n,h,b){const p=n.toLowerCase(),O=h.toLowerCase(),W=p.startsWith(b),q=O.startsWith(b);if(W!==q)return W?-1:1;if(W&&q){if(p.length<O.length)return-1;if(p.length>O.length)return 1}return 0}e.compareByPrefix=i}),define(De[88],Ce([1,0,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const k=(0,c.extname)(L),S=A[k.toLowerCase()];return S!==void 0?S:P(L)}e.getMediaOrTextMime=R;function P(L){const k=(0,c.extname)(L);return u[k.toLowerCase()]}e.getMediaMime=P;function T(L){for(const k in u)if(u[k]===L)return k}e.getExtensionForMimeType=T;const D=/^(.+)\/(.+?)(;.+)?$/;function g(L,k){const S=D.exec(L);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:L}e.normalizeMimeType=g}),define(De[110],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var u;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(u=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...D){const g=D.reduce((S,I)=>(S[I]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(S=>!g[S]).forEach(S=>{for(let I=0;I<L.length;I++)if(S.search(L[I])!==-1){delete T[S];break}})}e.sanitizeProcessEnvironment=R;function P(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=P}),define(De[43],Ce([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=c.globals.performance&&typeof c.globals.performance.now=="function";class u{static create(P=!0){return new u(P)}constructor(P){this.a=A&&P,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=u}),define(De[3],Ce([1,0,9,63,6,66,43]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,D=!1;var g;(function(v){v.None=()=>u.Disposable.None;function i(le){if(D){const{onDidAddListener:me}=le,ke=C.create();let Z=0;le.onDidAddListener=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),me?.()}}}function n(le,me){return M(le,()=>{},0,void 0,!0,void 0,me)}v.defer=n;function h(le){return(me,ke=null,Z)=>{let ce=!1,de;return de=le(te=>{if(!ce)return de?de.dispose():ce=!0,me.call(ke,te)},null,Z),ce&&de.dispose(),de}}v.once=h;function b(le,me,ke){return x((Z,ce=null,de)=>le(te=>Z.call(ce,me(te)),null,de),ke)}v.map=b;function p(le,me,ke){return x((Z,ce=null,de)=>le(te=>{me(te),Z.call(ce,te)},null,de),ke)}v.forEach=p;function O(le,me,ke){return x((Z,ce=null,de)=>le(te=>me(te)&&Z.call(ce,te),null,de),ke)}v.filter=O;function W(le){return le}v.signal=W;function q(...le){return(me,ke=null,Z)=>(0,u.combinedDisposable)(...le.map(ce=>ce(de=>me.call(ke,de),null,Z)))}v.any=q;function Y(le,me,ke,Z){let ce=ke;return b(le,de=>(ce=me(ce,de),ce),Z)}v.reduce=Y;function x(le,me){let ke;const Z={onWillAddFirstListener(){ke=le(ce.fire,ce)},onDidRemoveLastListener(){ke?.dispose()}};me||i(Z);const ce=new r(Z);return me?.add(ce),ce.event}function M(le,me,ke=100,Z=!1,ce=!1,de,te){let ae,oe,F,z=0,G;const _={leakWarningThreshold:de,onWillAddFirstListener(){ae=le(Ee=>{z++,oe=me(oe,Ee),Z&&!F&&(fe.fire(oe),oe=void 0),G=()=>{const Ae=oe;oe=void 0,F=void 0,(!Z||z>1)&&fe.fire(Ae),z=0},typeof ke=="number"?(clearTimeout(F),F=setTimeout(G,ke)):F===void 0&&(F=0,queueMicrotask(G))})},onWillRemoveListener(){ce&&z>0&&G?.()},onDidRemoveLastListener(){G=void 0,ae.dispose()}};te||i(_);const fe=new r(_);return te?.add(fe),fe.event}v.debounce=M;function B(le,me=0,ke){return v.debounce(le,(Z,ce)=>Z?(Z.push(ce),Z):[ce],me,void 0,!0,void 0,ke)}v.accumulate=B;function U(le,me=(Z,ce)=>Z===ce,ke){let Z=!0,ce;return O(le,de=>{const te=Z||!me(de,ce);return Z=!1,ce=de,te},ke)}v.latch=U;function j(le,me,ke){return[v.filter(le,me,ke),v.filter(le,Z=>!me(Z),ke)]}v.split=j;function he(le,me=!1,ke=[]){let Z=ke.slice(),ce=le(ae=>{Z?Z.push(ae):te.fire(ae)});const de=()=>{Z?.forEach(ae=>te.fire(ae)),Z=null},te=new r({onWillAddFirstListener(){ce||(ce=le(ae=>te.fire(ae)))},onDidAddFirstListener(){Z&&(me?setTimeout(de):de())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return te.event}v.buffer=he;class ie{constructor(me){this.event=me,this.c=new u.DisposableStore}map(me){return new ie(b(this.event,me,this.c))}forEach(me){return new ie(p(this.event,me,this.c))}filter(me){return new ie(O(this.event,me,this.c))}reduce(me,ke){return new ie(Y(this.event,me,ke,this.c))}latch(){return new ie(U(this.event,void 0,this.c))}debounce(me,ke=100,Z=!1,ce=!1,de){return new ie(M(this.event,me,ke,Z,ce,de,this.c))}on(me,ke,Z){return this.event(me,ke,Z)}once(me,ke,Z){return h(this.event)(me,ke,Z)}dispose(){this.c.dispose()}}function V(le){return new ie(le)}v.chain=V;function J(le,me,ke=Z=>Z){const Z=(...ae)=>te.fire(ke(...ae)),ce=()=>le.on(me,Z),de=()=>le.removeListener(me,Z),te=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:de});return te.event}v.fromNodeEventEmitter=J;function ne(le,me,ke=Z=>Z){const Z=(...ae)=>te.fire(ke(...ae)),ce=()=>le.addEventListener(me,Z),de=()=>le.removeEventListener(me,Z),te=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:de});return te.event}v.fromDOMEventEmitter=ne;function ve(le){return new Promise(me=>h(le)(me))}v.toPromise=ve;function ue(le,me){return me(void 0),le(ke=>me(ke))}v.runAndSubscribe=ue;function ee(le,me){let ke=null;function Z(de){ke?.dispose(),ke=new u.DisposableStore,me(de,ke)}Z(void 0);const ce=le(de=>Z(de));return(0,u.toDisposable)(()=>{ce.dispose(),ke?.dispose()})}v.runAndSubscribeWithStore=ee;class N{constructor(me,ke){this.obs=me,this.c=0,this.d=!1;const Z={onWillAddFirstListener:()=>{me.addObserver(this)},onDidRemoveLastListener:()=>{me.removeObserver(this)}};ke||i(Z),this.emitter=new r(Z),ke&&ke.add(this.emitter)}beginUpdate(me){this.c++}handleChange(me,ke){this.d=!0}endUpdate(me){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function K(le,me){return new N(le,me).emitter.event}v.fromObservable=K})(g=e.Event||(e.Event={}));class L{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${L.c++}`,L.all.add(this)}start(i){this.d=new P.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let k=-1;function S(v){const i=k;return k=v,{dispose(){k=i}}}e.setGlobalLeakWarningThreshold=S;class I{constructor(i,n=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=n,this.d=0}dispose(){this.c?.clear()}check(i,n){const h=this.threshold;if(h<=0||n<h)return;this.c||(this.c=new Map);const b=this.c.get(i.value)||0;if(this.c.set(i.value,b+1),this.d-=1,this.d<=0){this.d=h*.5;let p,O=0;for(const[W,q]of this.c)(!p||O<q)&&(p=W,O=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${O}):`),console.warn(p)}return()=>{const p=this.c.get(i.value)||0;this.c.set(i.value,p-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(i,n,h){this.callback=i,this.callbackThis=n,this.stack=h,this.subscription=new u.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class r{constructor(i){this.j=!1,this.d=i,this.f=k>0||this.d?.leakWarningThreshold?new I(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const i=Array.from(this.q);queueMicrotask(()=>{for(const n of i)n.subscription.isset()&&(n.subscription.unset(),n.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,n,h)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const b=this.q.isEmpty();b&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let p,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=C.create(),p=this.f.check(O,this.q.size+1)),T&&(O=O??C.create());const W=new E(i,n,O),q=this.q.push(W);b&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,n);const Y=W.subscription.set(()=>{p?.(),this.j||(this.d?.onWillRemoveListener?.(this),q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return h instanceof u.DisposableStore?h.add(Y):Array.isArray(h)&&h.push(Y),Y}),this.l}fire(i){if(this.q){this.m||(this.m=new f(this.d?.onListenerError));for(const n of this.q)this.m.push(this,n,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class d{constructor(i=c.onUnexpectedError){this.d=i,this.c=new R.LinkedList}get size(){return this.c.size}push(i,n,h){this.c.push(new w(i,n,h))}clear(i){const n=new R.LinkedList;for(const h of this.c)h.emitter!==i&&n.push(h);this.c=n}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(n){this.d(n)}}}}e.EventDeliveryQueue=d;class f extends d{clear(i){this.c.clear()}}class w{constructor(i,n,h){this.emitter=i,this.listener=n,this.event=h}}class y extends r{async fireAsync(i,n,h){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const b of this.q)this.c.push([b,i]);for(;this.c.size>0&&!n.isCancellationRequested;){const[b,p]=this.c.shift(),O=[],W={...p,token:n,waitUntil:q=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");h&&(q=h(q,b.callback)),O.push(q)}};try{b.invoke(W)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(O),await Promise.allSettled(O).then(q=>{for(const Y of q)Y.status==="rejected"&&(0,c.onUnexpectedError)(Y.reason)})}}}}e.AsyncEmitter=y;class m extends r{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=m;class t extends m{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=t;class o extends r{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(n=>super.fire(n)),this.c=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const n={event:i,listener:null};this.f.push(n),this.d&&this.j(n);const h=()=>{this.d&&this.k(n);const b=this.f.indexOf(n);this.f.splice(b,1)};return(0,u.toDisposable)((0,A.once)(h))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(n=>this.c.fire(n))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class a{constructor(){this.c=[]}wrapEvent(i){return(n,h,b)=>i(p=>{const O=this.c[this.c.length-1];O?O.push(()=>n.call(h,p)):n.call(h,p)},void 0,b)}bufferEvents(i){const n=[];this.c.push(n);const h=i();return this.c.pop(),n.forEach(b=>b()),h}}e.EventBufferer=a;class l{constructor(){this.c=!1,this.d=g.None,this.f=u.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(De[162],Ce([1,0,3,6,157]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(S,I="",C="",E=!0,r){super(),this.j=this.D(new c.Emitter),this.onDidChange=this.j.event,this.w=!0,this.m=S,this.n=I,this.u=C,this.w=E,this.C=r}get id(){return this.m}get label(){return this.n}set label(S){this.F(S)}F(S){this.n!==S&&(this.n=S,this.j.fire({label:S}))}get tooltip(){return this.q||""}set tooltip(S){this.G(S)}G(S){this.q!==S&&(this.q=S,this.j.fire({tooltip:S}))}get class(){return this.u}set class(S){this.H(S)}H(S){this.u!==S&&(this.u=S,this.j.fire({class:S}))}get enabled(){return this.w}set enabled(S){this.I(S)}I(S){this.w!==S&&(this.w=S,this.j.fire({enabled:S}))}get checked(){return this.z}set checked(S){this.J(S)}J(S){this.z!==S&&(this.z=S,this.j.fire({checked:S}))}async run(S,I){this.C&&await this.C(S)}}e.Action=R;class P extends A.Disposable{constructor(){super(...arguments),this.f=this.D(new c.Emitter),this.onWillRun=this.f.event,this.h=this.D(new c.Emitter),this.onDidRun=this.h.event}async run(S,I){if(!S.enabled)return;this.f.fire({action:S});let C;try{await this.k(S,I)}catch(E){C=E}this.h.fire({action:S,error:C})}async k(S,I){await S.run(I)}}e.ActionRunner=P;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...S){let I=[];for(const C of S)C.length&&(I.length?I=[...I,new T,...C]:I=C);return I}async run(){}}T.ID="vs.actions.separator",e.Separator=T;class D{get actions(){return this.a}constructor(S,I,C,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=S,this.label=I,this.class=E,this.a=C}async run(){}}e.SubmenuAction=D;class g extends R{constructor(){super(g.ID,u.localize(0,null),void 0,!1)}}g.ID="vs.actions.empty",e.EmptySubmenuAction=g;function L(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=L}),define(De[21],Ce([1,0,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(T,D){const g=setTimeout(T.bind(D),0);return{dispose(){clearTimeout(g)}}});var u;(function(T){function D(g){return g===T.None||g===T.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}T.isCancellationToken=D,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(u=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(D){this.a=void 0,this.b=void 0,this.b=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=u.Cancelled}dispose(D=!1){D&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=u.None}}e.CancellationTokenSource=P}),define(De[163],Ce([1,0,21]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new c.CancellationTokenSource,D=this.b(T.token);return this.a={promise:D,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=A;class u{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const D=JSON.stringify(T);return this.b!==D&&(this.b=D,this.a=this.c(T)),this.a}}e.LRUCachedFunction=u;class R{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const D=this.b(T);return this.a.set(T,D),D}}e.CachedFunction=R}),define(De[8],Ce([1,0,163,65]),function(re,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const P=/{(\d+)}/g;function T($,...Q){return Q.length===0?$:$.replace(P,function(ge,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=Q.length?ge:Q[Ne]})}e.format=T;const D=/{([^}]+)}/g;function g($,Q){return $.replace(D,(ge,Le)=>Q[Le]??ge)}e.format2=g;function L($){return $.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=L;function k($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S($,Q){let ge=0;const Le=Q.charCodeAt(0);for(let Ne=$.length-1;Ne>=0;Ne--)$.charCodeAt(Ne)===Le&&ge++;return ge}e.count=S;function I($,Q,ge="\u2026"){return $.length<=Q?$:`${$.substr(0,Q)}${ge}`}e.truncate=I;function C($,Q=" "){const ge=E($,Q);return r(ge,Q)}e.trim=C;function E($,Q){if(!$||!Q)return $;const ge=Q.length;if(ge===0||$.length===0)return $;let Le=0;for(;$.indexOf(Q,Le)===Le;)Le=Le+ge;return $.substring(Le)}e.ltrim=E;function r($,Q){if(!$||!Q)return $;const ge=Q.length,Le=$.length;if(ge===0||Le===0)return $;let Ne=Le,je=-1;for(;je=$.lastIndexOf(Q,Ne-1),!(je===-1||je+ge!==Ne);){if(je===0)return"";Ne=je}return $.substring(0,Ne)}e.rtrim=r;function d($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f($){return $.replace(/\*/g,"")}e.stripWildcards=f;function w($,Q,ge={}){if(!$)throw new Error("Cannot create regex from empty string");Q||($=k($)),ge.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return ge.global&&(Le+="g"),ge.matchCase||(Le+="i"),ge.multiline&&(Le+="m"),ge.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=w;function y($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function m($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function t($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=t;function o($){return $.split(/\r\n|\r|\n/)}e.splitLines=o;function s($){for(let Q=0,ge=$.length;Q<ge;Q++){const Le=$.charCodeAt(Q);if(Le!==32&&Le!==9)return Q}return-1}e.firstNonWhitespaceIndex=s;function a($,Q=0,ge=$.length){for(let Le=Q;Le<ge;Le++){const Ne=$.charCodeAt(Le);if(Ne!==32&&Ne!==9)return $.substring(Q,Le)}return $.substring(Q,ge)}e.getLeadingWhitespace=a;function l($,Q=$.length-1){for(let ge=Q;ge>=0;ge--){const Le=$.charCodeAt(ge);if(Le!==32&&Le!==9)return ge}return-1}e.lastNonWhitespaceIndex=l;function v($,Q,ge){const Le=[];let Ne=0;for(const je of $.matchAll(Q)){if(Le.push($.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Le.push(ge(je[0],...je.slice(1),je.index,$,je.groups))}return Le.push($.slice(Ne)),Promise.all(Le).then(je=>je.join(""))}e.replaceAsync=v;function i($,Q){return $<Q?-1:$>Q?1:0}e.compare=i;function n($,Q,ge=0,Le=$.length,Ne=0,je=Q.length){for(;ge<Le&&Ne<je;ge++,Ne++){const nt=$.charCodeAt(ge),ot=Q.charCodeAt(Ne);if(nt<ot)return-1;if(nt>ot)return 1}const Ye=Le-ge,Xe=je-Ne;return Ye<Xe?-1:Ye>Xe?1:0}e.compareSubstring=n;function h($,Q){return b($,Q,0,$.length,0,Q.length)}e.compareIgnoreCase=h;function b($,Q,ge=0,Le=$.length,Ne=0,je=Q.length){for(;ge<Le&&Ne<je;ge++,Ne++){let nt=$.charCodeAt(ge),ot=Q.charCodeAt(Ne);if(nt===ot)continue;if(nt>=128||ot>=128)return n($.toLowerCase(),Q.toLowerCase(),ge,Le,Ne,je);O(nt)&&(nt-=32),O(ot)&&(ot-=32);const pt=nt-ot;if(pt!==0)return pt}const Ye=Le-ge,Xe=je-Ne;return Ye<Xe?-1:Ye>Xe?1:0}e.compareSubstringIgnoreCase=b;function p($){return $>=48&&$<=57}e.isAsciiDigit=p;function O($){return $>=97&&$<=122}e.isLowerAsciiLetter=O;function W($){return $>=65&&$<=90}e.isUpperAsciiLetter=W;function q($,Q){return $.length===Q.length&&b($,Q)===0}e.equalsIgnoreCase=q;function Y($,Q){const ge=Q.length;return Q.length>$.length?!1:b($,Q,0,ge)===0}e.startsWithIgnoreCase=Y;function x($,Q){const ge=Math.min($.length,Q.length);let Le;for(Le=0;Le<ge;Le++)if($.charCodeAt(Le)!==Q.charCodeAt(Le))return Le;return ge}e.commonPrefixLength=x;function M($,Q){const ge=Math.min($.length,Q.length);let Le;const Ne=$.length-1,je=Q.length-1;for(Le=0;Le<ge;Le++)if($.charCodeAt(Ne-Le)!==Q.charCodeAt(je-Le))return Le;return ge}e.commonSuffixLength=M;function B($){return 55296<=$&&$<=56319}e.isHighSurrogate=B;function U($){return 56320<=$&&$<=57343}e.isLowSurrogate=U;function j($,Q){return($-55296<<10)+(Q-56320)+65536}e.computeCodePoint=j;function he($,Q,ge){const Le=$.charCodeAt(ge);if(B(Le)&&ge+1<Q){const Ne=$.charCodeAt(ge+1);if(U(Ne))return j(Le,Ne)}return Le}e.getNextCodePoint=he;function ie($,Q){const ge=$.charCodeAt(Q-1);if(U(ge)&&Q>1){const Le=$.charCodeAt(Q-2);if(B(Le))return j(Le,ge)}return ge}class V{get offset(){return this.e}constructor(Q,ge=0){this.c=Q,this.d=Q.length,this.e=ge}setOffset(Q){this.e=Q}prevCodePoint(){const Q=ie(this.c,this.e);return this.e-=Q>=65536?2:1,Q}nextCodePoint(){const Q=he(this.c,this.d,this.e);return this.e+=Q>=65536?2:1,Q}eol(){return this.e>=this.d}}e.CodePointIterator=V;class J{get offset(){return this.c.offset}constructor(Q,ge=0){this.c=new V(Q,ge)}nextGraphemeLength(){const Q=ze.getInstance(),ge=this.c,Le=ge.offset;let Ne=Q.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const je=ge.offset,Ye=Q.getGraphemeBreakType(ge.nextCodePoint());if(Pe(Ne,Ye)){ge.setOffset(je);break}Ne=Ye}return ge.offset-Le}prevGraphemeLength(){const Q=ze.getInstance(),ge=this.c,Le=ge.offset;let Ne=Q.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const je=ge.offset,Ye=Q.getGraphemeBreakType(ge.prevCodePoint());if(Pe(Ye,Ne)){ge.setOffset(je);break}Ne=Ye}return Le-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ne($,Q){return new J($,Q).nextGraphemeLength()}e.nextCharLength=ne;function ve($,Q){return new J($,Q).prevGraphemeLength()}e.prevCharLength=ve;function ue($,Q){Q>0&&U($.charCodeAt(Q))&&Q--;const ge=Q+ne($,Q);return[ge-ve($,ge),ge]}e.getCharContainingOffset=ue;function ee($){const Q=new J($);let ge=0;for(;!Q.eol();)ge++,Q.nextGraphemeLength();return ge}e.charCount=ee;let N;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le($){return N||(N=K()),N.test($)}e.containsRTL=le;const me=/^[\t\n\r\x20-\x7E]*$/;function ke($){return me.test($)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=Z;function ce($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ce;function de($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=de;function te($,Q){if($.length<Q)return $;const ge=/\b/g;let Le=0;for(;ge.test($)&&!($.length-ge.lastIndex<Q);)Le=ge.lastIndex,ge.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=te;const ae=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function oe($){return $&&($=$.replace(ae,"")),$}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function z($){return F($)?$.substr(1):$}e.stripUTF8BOM=z;function G($,Q){if(!$||!Q||$.length<Q.length)return!1;const ge=Q.length,Le=$.toLowerCase();let Ne=0,je=-1;for(;Ne<ge;){const Ye=Le.indexOf(Q[Ne],je+1);if(Ye<0)return!1;je=Ye,Ne++}return!0}e.fuzzyContains=G;function _($,Q=!1){return $?(Q&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=_;function fe($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=fe;function Ee($,Q=1){if(Q===0)return"";let ge=-1;do ge=$.indexOf(`
`,ge+1),Q--;while(Q>0&&ge>=0);return ge===-1?$:($[ge-1]==="\r"&&ge--,$.substr(0,ge))}e.getNLines=Ee;function Ae($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Ae;function we($){return ze.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=we;function Pe($,Q){return $===0?Q!==5&&Q!==7:$===2&&Q===3?!1:$===4||$===2||$===3||Q===4||Q===2||Q===3?!0:!($===8&&(Q===8||Q===9||Q===11||Q===12)||($===11||$===9)&&(Q===9||Q===10)||($===12||$===10)&&Q===10||Q===5||Q===13||Q===7||$===1||$===13&&Q===14||$===6&&Q===6)}var Ie;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{static getInstance(){return ze.c||(ze.c=new ze),ze.c}constructor(){this.d=qe()}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const ge=this.d,Le=ge.length/3;let Ne=1;for(;Ne<=Le;)if(Q<ge[3*Ne])Ne=2*Ne;else if(Q>ge[3*Ne+1])Ne=2*Ne+1;else return ge[3*Ne+2];return 0}}ze.c=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt($,Q){if($===0)return 0;const ge=Qe($,Q);if(ge!==void 0)return ge;const Le=new V(Q,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=tt;function Qe($,Q){const ge=new V(Q,$);let Le=ge.prevCodePoint();for(;it(Le)||Le===65039||Le===8419;){if(ge.offset===0)return;Le=ge.prevCodePoint()}if(!de(Le))return;let Ne=ge.offset;return Ne>0&&ge.prevCodePoint()===8205&&(Ne=ge.offset),Ne}function it($){return 127995<=$&&$<=127999}var rt;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(Q){return Be.d.get(Array.from(Q))}static getLocales(){return Be.e.value}constructor(Q){this.f=Q}isAmbiguous(Q){return this.f.has(Q)}getPrimaryConfusable(Q){return this.f.get(Q)}getConfusableCodePoints(){return new Set(this.f.keys())}}u=Be,Be.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new c.LRUCachedFunction($=>{function Q(ot){const pt=new Map;for(let bt=0;bt<ot.length;bt+=2)pt.set(ot[bt],ot[bt+1]);return pt}function ge(ot,pt){const bt=new Map(ot);for(const[St,Pt]of pt)bt.set(St,Pt);return bt}function Le(ot,pt){if(!ot)return pt;const bt=new Map;for(const[St,Pt]of ot)pt.has(St)&&bt.set(St,Pt);return bt}const Ne=u.c.value;let je=$.filter(ot=>!ot.startsWith("_")&&ot in Ne);je.length===0&&(je=["_default"]);let Ye;for(const ot of je){const pt=Q(Ne[ot]);Ye=Le(Ye,pt)}const Xe=Q(Ne._common),nt=ge(Xe,Ye);return new Be(nt)}),Be.e=new A.Lazy(()=>Object.keys(Be.c.value).filter($=>!$.startsWith("_"))),e.AmbiguousCharacters=Be;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Q){return et.e().has(Q)}static get codePoints(){return et.e()}}et.d=void 0,e.InvisibleCharacters=et}),define(De[33],Ce([1,0,12,11,8,10]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(l){return l===47||l===92}e.isPathSeparator=P;function T(l){return l.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function D(l){return l.indexOf("/")===-1&&(l=T(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=D;function g(l,v=c.posix.sep){if(!l)return"";const i=l.length,n=l.charCodeAt(0);if(P(n)){if(P(l.charCodeAt(1))&&!P(l.charCodeAt(2))){let b=3;const p=b;for(;b<i&&!P(l.charCodeAt(b));b++);if(p!==b&&!P(l.charCodeAt(b+1))){for(b+=1;b<i;b++)if(P(l.charCodeAt(b)))return l.slice(0,b+1).replace(/[\\/]/g,v)}}return v}else if(d(n)&&l.charCodeAt(1)===58)return P(l.charCodeAt(2))?l.slice(0,2)+v:l.slice(0,2);let h=l.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(P(l.charCodeAt(h)))return l.slice(0,h+1)}return""}e.getRoot=g;function L(l){if(!A.isWindows||!l||l.length<5)return!1;let v=l.charCodeAt(0);if(v!==92||(v=l.charCodeAt(1),v!==92))return!1;let i=2;const n=i;for(;i<l.length&&(v=l.charCodeAt(i),v!==92);i++);return!(n===i||(v=l.charCodeAt(i+1),isNaN(v)||v===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(l,v=A.isWindows){const i=v?k:S;return!(!l||l.length===0||/^\s+$/.test(l)||(i.lastIndex=0,i.test(l))||v&&I.test(l)||l==="."||l===".."||v&&l[l.length-1]==="."||v&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=C;function E(l,v,i){const n=l===v;return!i||n?n:!l||!v?!1:(0,u.equalsIgnoreCase)(l,v)}e.isEqual=E;function r(l,v,i,n=c.sep){if(l===v)return!0;if(!l||!v||v.length>l.length)return!1;if(i){if(!(0,u.startsWithIgnoreCase)(l,v))return!1;if(v.length===l.length)return!0;let b=v.length;return v.charAt(v.length-1)===n&&b--,l.charAt(b)===n}return v.charAt(v.length-1)!==n&&(v+=n),l.indexOf(v)===0}e.isEqualOrParent=r;function d(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=d;function f(l,v){return A.isWindows&&l.endsWith(":")&&(l+=c.sep),(0,c.isAbsolute)(l)||(l=(0,c.join)(v,l)),l=(0,c.normalize)(l),A.isWindows?(l=(0,u.rtrim)(l,c.sep),l.endsWith(":")&&(l+=c.sep)):(l=(0,u.rtrim)(l,c.sep),l||(l=c.sep)),l}e.sanitizeFilePath=f;function w(l){const v=(0,c.normalize)(l);return A.isWindows?l.length>3?!1:y(v)&&(l.length===2||v.charCodeAt(2)===92):v===c.posix.sep}e.isRootOrDriveLetter=w;function y(l,v=A.isWindows){return v?d(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function m(l){return y(l)?l[0]:void 0}e.getDriveLetter=m;function t(l,v,i){return v.length>l.length?-1:l===v?0:(i&&(l=l.toLowerCase(),v=v.toLowerCase()),l.indexOf(v))}e.indexOfPath=t;function o(l){const v=l.split(":");let i,n,h;for(const b of v){const p=Number(b);(0,R.isNumber)(p)?n===void 0?n=p:h===void 0&&(h=p):i=i?[i,b].join(":"):b}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:n!==void 0?n:void 0,column:h!==void 0?h:n!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(l,v,i=8){let n="";for(let b=0;b<i;b++)n+=s.charAt(Math.floor(Math.random()*s.length));let h;return v?h=`${v}-${n}`:h=n,l?(0,c.join)(l,h):h}e.randomPath=a}),define(De[111],Ce([1,0,28,8]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...oe){return function(F,z){for(let G=0,_=oe.length;G<_;G++){const fe=oe[G](F,z);if(fe)return fe}return null}}e.or=u,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(oe,F,z){if(!z||z.length<F.length)return null;let G;return oe?G=A.startsWithIgnoreCase(z,F):G=z.indexOf(F)===0,G?F.length>0?[{start:0,end:F.length}]:[]:null}function P(oe,F){const z=F.toLowerCase().indexOf(oe.toLowerCase());return z===-1?null:[{start:z,end:z+oe.length}]}e.matchesContiguousSubString=P;function T(oe,F){return D(oe.toLowerCase(),F.toLowerCase(),0,0)}e.matchesSubString=T;function D(oe,F,z,G){if(z===oe.length)return[];if(G===F.length)return null;if(oe[z]===F[G]){let _=null;return(_=D(oe,F,z+1,G+1))?d({start:G,end:G+1},_):null}return D(oe,F,z,G+1)}function g(oe){return 97<=oe&&oe<=122}function L(oe){return 65<=oe&&oe<=90}e.isUpper=L;function k(oe){return 48<=oe&&oe<=57}function S(oe){return oe===32||oe===9||oe===10||oe===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>I.add(oe.charCodeAt(0)));function C(oe){return S(oe)||I.has(oe)}function E(oe,F){return oe===F||C(oe)&&C(F)}function r(oe){return g(oe)||L(oe)||k(oe)}function d(oe,F){return F.length===0?F=[oe]:oe.end===F[0].start?F[0].start=oe.start:F.unshift(oe),F}function f(oe,F){for(let z=F;z<oe.length;z++){const G=oe.charCodeAt(z);if(L(G)||k(G)||z>0&&!r(oe.charCodeAt(z-1)))return z}return oe.length}function w(oe,F,z,G){if(z===oe.length)return[];if(G===F.length)return null;if(oe[z]!==F[G].toLowerCase())return null;{let _=null,fe=G+1;for(_=w(oe,F,z+1,G+1);!_&&(fe=f(F,fe))<F.length;)_=w(oe,F,z+1,fe),fe++;return _===null?null:d({start:G,end:G+1},_)}}function y(oe){let F=0,z=0,G=0,_=0,fe=0;for(let Ie=0;Ie<oe.length;Ie++)fe=oe.charCodeAt(Ie),L(fe)&&F++,g(fe)&&z++,r(fe)&&G++,k(fe)&&_++;const Ee=F/oe.length,Ae=z/oe.length,we=G/oe.length,Pe=_/oe.length;return{upperPercent:Ee,lowerPercent:Ae,alphaPercent:we,numericPercent:Pe}}function m(oe){const{upperPercent:F,lowerPercent:z}=oe;return z===0&&F>.6}function t(oe){const{upperPercent:F,lowerPercent:z,alphaPercent:G,numericPercent:_}=oe;return z>.2&&F<.8&&G>.6&&_<.2}function o(oe){let F=0,z=0,G=0,_=0;for(let fe=0;fe<oe.length;fe++)G=oe.charCodeAt(fe),L(G)&&F++,g(G)&&z++,S(G)&&_++;return(F===0||z===0)&&_===0?oe.length<=30:F<=5}function s(oe,F){if(!F||(F=F.trim(),F.length===0)||!o(oe)||F.length>60)return null;const z=y(F);if(!t(z)){if(!m(z))return null;F=F.toLowerCase()}let G=null,_=0;for(oe=oe.toLowerCase();_<F.length&&(G=w(oe,F,0,_))===null;)_=f(F,_+1);return G}e.matchesCamelCase=s;function a(oe,F,z=!1){if(!F||F.length===0)return null;let G=null,_=0;for(oe=oe.toLowerCase(),F=F.toLowerCase();_<F.length&&(G=l(oe,F,0,_,z))===null;)_=v(F,_+1);return G}e.matchesWords=a;function l(oe,F,z,G,_){if(z===oe.length)return[];if(G===F.length)return null;if(E(oe.charCodeAt(z),F.charCodeAt(G))){let fe=null,Ee=G+1;if(fe=l(oe,F,z+1,G+1,_),!_)for(;!fe&&(Ee=v(F,Ee))<F.length;)fe=l(oe,F,z+1,Ee,_),Ee++;return fe?oe.charCodeAt(z)!==F.charCodeAt(G)?fe:d({start:G,end:G+1},fe):null}else return null}function v(oe,F){for(let z=F;z<oe.length;z++)if(C(oe.charCodeAt(z))||z>0&&C(oe.charCodeAt(z-1)))return z;return oe.length}const i=u(e.matchesPrefix,s,P),n=u(e.matchesPrefix,s,T),h=new c.LRUCache(1e4);function b(oe,F,z=!1){if(typeof oe!="string"||typeof F!="string")return null;let G=h.get(oe);G||(G=new RegExp(A.convertSimple2RegExpPattern(oe),"i"),h.set(oe,G));const _=G.exec(F);return _?[{start:_.index,end:_.index+_[0].length}]:z?n(oe,F):i(oe,F)}e.matchesFuzzy=b;function p(oe,F){const z=me(oe,oe.toLowerCase(),0,F,F.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?W(z):null}e.matchesFuzzy2=p;function O(oe,F,z,G,_,fe){const Ee=Math.min(13,oe.length);for(;z<Ee;z++){const Ae=me(oe,F,z,G,_,fe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,fe]}e.anyScore=O;function W(oe){if(typeof oe>"u")return[];const F=[],z=oe[1];for(let G=oe.length-1;G>1;G--){const _=oe[G]+z,fe=F[F.length-1];fe&&fe.end===_?fe.end=_+1:F.push({start:_,end:_+1})}return F}e.createMatches=W;const q=128;function Y(){const oe=[],F=[];for(let z=0;z<=q;z++)F[z]=0;for(let z=0;z<=q;z++)oe.push(F.slice(0));return oe}function x(oe){const F=[];for(let z=0;z<=oe;z++)F[z]=0;return F}const M=x(2*q),B=x(2*q),U=Y(),j=Y(),he=Y(),ie=!1;function V(oe,F,z,G,_){function fe(Ae,we,Pe=" "){for(;Ae.length<we;)Ae=Pe+Ae;return Ae}let Ee=` |   |${G.split("").map(Ae=>fe(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=z;Ae++)Ae===0?Ee+=" |":Ee+=`${F[Ae-1]}|`,Ee+=oe[Ae].slice(0,_+1).map(we=>fe(we.toString(),3)).join("|")+`
`;return Ee}function J(oe,F,z,G){oe=oe.substr(F),z=z.substr(G),console.log(V(j,oe,oe.length,z,z.length)),console.log(V(he,oe,oe.length,z,z.length)),console.log(V(U,oe,oe.length,z,z.length))}function ne(oe,F){if(F<0||F>=oe.length)return!1;const z=oe.codePointAt(F);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(z)}}function ve(oe,F){if(F<0||F>=oe.length)return!1;switch(oe.charCodeAt(F)){case 32:case 9:return!0;default:return!1}}function ue(oe,F,z){return F[oe]!==z[oe]}function ee(oe,F,z,G,_,fe,Ee=!1){for(;F<z&&_<fe;)oe[F]===G[_]&&(Ee&&(M[F]=_),F+=1),_+=1;return F===z}e.isPatternInWord=ee;var N;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(N||(N={}));var K;(function(oe){oe.Default=[-100,0];function F(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}oe.isDefault=F})(K=e.FuzzyScore||(e.FuzzyScore={}));class le{constructor(F,z){this.firstMatchCanBeWeak=F,this.boostFullMatch=z}}le.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=le;function me(oe,F,z,G,_,fe,Ee=le.default){const Ae=oe.length>q?q:oe.length,we=G.length>q?q:G.length;if(z>=Ae||fe>=we||Ae-z>we-fe||!ee(F,z,Ae,_,fe,we,!0))return;ke(Ae,we,z,fe,F,_);let Pe=1,Ie=1,ze=z,qe=fe;const tt=[!1];for(Pe=1,ze=z;ze<Ae;Pe++,ze++){const et=M[ze],$=B[ze],Q=ze+1<Ae?B[ze+1]:we;for(Ie=et-fe+1,qe=et;qe<Q;Ie++,qe++){let ge=Number.MIN_SAFE_INTEGER,Le=!1;qe<=$&&(ge=Z(oe,F,ze,z,G,_,qe,we,fe,U[Pe-1][Ie-1]===0,tt));let Ne=0;ge!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=ge+j[Pe-1][Ie-1]);const je=qe>et,Ye=je?j[Pe][Ie-1]+(U[Pe][Ie-1]>0?-5:0):0,Xe=qe>et+1&&U[Pe][Ie-1]>0,nt=Xe?j[Pe][Ie-2]+(U[Pe][Ie-2]>0?-5:0):0;if(Xe&&(!je||nt>=Ye)&&(!Le||nt>=Ne))j[Pe][Ie]=nt,he[Pe][Ie]=3,U[Pe][Ie]=0;else if(je&&(!Le||Ye>=Ne))j[Pe][Ie]=Ye,he[Pe][Ie]=2,U[Pe][Ie]=0;else if(Le)j[Pe][Ie]=Ne,he[Pe][Ie]=1,U[Pe][Ie]=U[Pe-1][Ie-1]+1;else throw new Error("not possible")}}if(ie&&J(oe,z,G,fe),!tt[0]&&!Ee.firstMatchCanBeWeak)return;Pe--,Ie--;const Qe=[j[Pe][Ie],fe];let it=0,rt=0;for(;Pe>=1;){let et=Ie;do{const $=he[Pe][et];if($===3)et=et-2;else if($===2)et=et-1;else break}while(et>=1);it>1&&F[z+Pe-1]===_[fe+Ie-1]&&!ue(et+fe-1,G,_)&&it+1>U[Pe][et]&&(et=Ie),et===Ie?it++:it=1,rt||(rt=et),Pe--,Ie=et-1,Qe.push(Ie)}we===Ae&&Ee.boostFullMatch&&(Qe[0]+=2);const Be=rt-Ae;return Qe[0]-=Be,Qe}e.fuzzyScore=me;function ke(oe,F,z,G,_,fe){let Ee=oe-1,Ae=F-1;for(;Ee>=z&&Ae>=G;)_[Ee]===fe[Ae]&&(B[Ee]=Ae,Ee--),Ae--}function Z(oe,F,z,G,_,fe,Ee,Ae,we,Pe,Ie){if(F[z]!==fe[Ee])return Number.MIN_SAFE_INTEGER;let ze=1,qe=!1;return Ee===z-G?ze=oe[z]===_[Ee]?7:5:ue(Ee,_,fe)&&(Ee===0||!ue(Ee-1,_,fe))?(ze=oe[z]===_[Ee]?7:5,qe=!0):ne(fe,Ee)&&(Ee===0||!ne(fe,Ee-1))?ze=5:(ne(fe,Ee-1)||ve(fe,Ee-1))&&(ze=5,qe=!0),ze>1&&z===G&&(Ie[0]=!0),qe||(qe=ue(Ee,_,fe)||ne(fe,Ee-1)||ve(fe,Ee-1)),z===G?Ee>we&&(ze-=qe?3:5):Pe?ze+=qe?2:0:ze+=qe?0:1,Ee+1===Ae&&(ze-=qe?3:5),ze}function ce(oe,F,z,G,_,fe,Ee){return te(oe,F,z,G,_,fe,!0,Ee)}e.fuzzyScoreGracefulAggressive=ce;function de(oe,F,z,G,_,fe,Ee){return te(oe,F,z,G,_,fe,!1,Ee)}e.fuzzyScoreGraceful=de;function te(oe,F,z,G,_,fe,Ee,Ae){let we=me(oe,F,z,G,_,fe,Ae);if(we&&!Ee)return we;if(oe.length>=3){const Pe=Math.min(7,oe.length-1);for(let Ie=z+1;Ie<Pe;Ie++){const ze=ae(oe,Ie);if(ze){const qe=me(ze,ze.toLowerCase(),z,G,_,fe,Ae);qe&&(qe[0]-=3,(!we||qe[0]>we[0])&&(we=qe))}}}return we}function ae(oe,F){if(F+1>=oe.length)return;const z=oe[F],G=oe[F+1];if(z!==G)return oe.slice(0,F)+G+z+oe.slice(F+2)}}),define(De[68],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(d){return u(d,0)}e.hash=A;function u(d,f){switch(typeof d){case"object":return d===null?R(349,f):Array.isArray(d)?D(d,f):g(d,f);case"string":return T(d,f);case"boolean":return P(d,f);case"number":return R(d,f);case"undefined":return R(937,f);default:return R(617,f)}}e.doHash=u;function R(d,f){return(f<<5)-f+d|0}e.numberHash=R;function P(d,f){return R(d?433:863,f)}function T(d,f){f=R(149417,f);for(let w=0,y=d.length;w<y;w++)f=R(d.charCodeAt(w),f);return f}e.stringHash=T;function D(d,f){return f=R(104579,f),d.reduce((w,y)=>u(y,w),f)}function g(d,f){return f=R(181387,f),Object.keys(d).sort().reduce((w,y)=>(w=T(y,w),u(d[y],w)),f)}class L{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=u(f,this.g),this.g}}e.Hasher=L;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(d,f,w=32){const y=w-f,m=~((1<<y)-1);return(d<<f|(m&d)>>>y)>>>0}function I(d,f=0,w=d.byteLength,y=0){for(let m=0;m<w;m++)d[f+m]=y}function C(d,f,w="0"){for(;d.length<f;)d=w+d;return d}function E(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(w=>w.toString(16).padStart(2,"0")).join(""):C((d>>>0).toString(16),f/4)}e.toHexString=E;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const w=f.length;if(w===0)return;const y=this.p;let m=this.r,t=this.u,o,s;for(t!==0?(o=t,s=-1,t=0):(o=f.charCodeAt(0),s=0);;){let a=o;if(c.isHighSurrogate(o))if(s+1<w){const l=f.charCodeAt(s+1);c.isLowSurrogate(l)?(s++,a=c.computeCodePoint(o,l)):a=65533}else{t=o;break}else c.isLowSurrogate(o)&&(a=65533);if(m=this.w(y,m,a),s++,s<w)o=f.charCodeAt(s);else break}this.r=m,this.u=t}w(f,w,y){return y<128?f[w++]=y:y<2048?(f[w++]=192|(y&1984)>>>6,f[w++]=128|(y&63)>>>0):y<65536?(f[w++]=224|(y&61440)>>>12,f[w++]=128|(y&4032)>>>6,f[w++]=128|(y&63)>>>0):(f[w++]=240|(y&1835008)>>>18,f[w++]=128|(y&258048)>>>12,f[w++]=128|(y&4032)>>>6,f[w++]=128|(y&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=r.g,w=this.q;for(let i=0;i<64;i+=4)f.setUint32(i,w.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)f.setUint32(i,S(f.getUint32(i-12,!1)^f.getUint32(i-32,!1)^f.getUint32(i-56,!1)^f.getUint32(i-64,!1),1),!1);let y=this.h,m=this.l,t=this.m,o=this.n,s=this.o,a,l,v;for(let i=0;i<80;i++)i<20?(a=m&t|~m&o,l=1518500249):i<40?(a=m^t^o,l=1859775393):i<60?(a=m&t|m&o|t&o,l=2400959708):(a=m^t^o,l=3395469782),v=S(y,5)+a+s+l+f.getUint32(i*4,!1)&4294967295,s=o,o=t,t=S(m,30),m=y,y=v;this.h=this.h+y&4294967295,this.l=this.l+m&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}r.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=r}),define(De[112],Ce([1,0,109,111,68,12,11,8]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,g=[D,[]];function L(U,j,he,ie){if(!U||!j)return g;const V=U.length,J=j.length;if(V<J)return g;const ne=U.toLowerCase();return k(j,he,J,U,ne,V,ie)}e.scoreFuzzy=L;function k(U,j,he,ie,V,J,ne){const ve=[],ue=[];for(let le=0;le<he;le++){const me=le*J,ke=me-J,Z=le>0,ce=U[le],de=j[le];for(let te=0;te<J;te++){const ae=te>0,oe=me+te,F=oe-1,z=ke+te-1,G=ae?ve[F]:0,_=Z&&ae?ve[z]:0,fe=Z&&ae?ue[z]:0;let Ee;!_&&Z?Ee=0:Ee=S(ce,de,ie,V,te,fe),Ee&&_+Ee>=G&&(ne||Z||V.startsWith(j,te))?(ue[oe]=fe+1,ve[oe]=_+Ee):(ue[oe]=D,ve[oe]=G)}}const ee=[];let N=he-1,K=J-1;for(;N>=0&&K>=0;){const le=N*J+K;ue[le]===D||(ee.push(K),N--),K--}return[ve[he*J-1],ee.reverse()]}function S(U,j,he,ie,V,J){let ne=0;if(!I(j,ie[V]))return ne;if(ne+=1,J>0&&(ne+=J*5),U===he[V]&&(ne+=1),V===0)ne+=8;else{const ve=C(he.charCodeAt(V-1));ve?ne+=ve:(0,A.isUpper)(he.charCodeAt(V))&&J===0&&(ne+=2)}return ne}function I(U,j){return U===j?!0:U==="/"||U==="\\"?j==="/"||j==="\\":!1}function C(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function r(U,j,he=0,ie=0){const V=j;return V.values&&V.values.length>1?d(U,V.values,he,ie):f(U,j,he,ie)}e.scoreFuzzy2=r;function d(U,j,he,ie){let V=0;const J=[];for(const ne of j){const[ve,ue]=f(U,ne,he,ie);if(typeof ve!="number")return E;V+=ve,J.push(...ue)}return[V,n(J)]}function f(U,j,he,ie){const V=(0,A.fuzzyScore)(j.original,j.originalLowercase,he,U,U.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,A.createMatches)(V)]:E}const w=Object.freeze({score:0}),y=1<<18,m=1<<17,t=1<<16;function o(U,j,he,ie){const V=ie.values?ie.values:[ie];return(0,u.hash)({[ie.normalized]:{values:V.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:j,allowNonContiguousMatches:he}})}function s(U,j,he,ie,V){if(!U||!j.normalized)return w;const J=ie.getItemLabel(U);if(!J)return w;const ne=ie.getItemDescription(U),ve=o(J,ne,he,j),ue=V[ve];if(ue)return ue;const ee=a(J,ne,ie.getItemPath(U),j,he);return V[ve]=ee,ee}e.scoreItemFuzzy=s;function a(U,j,he,ie,V){const J=!he||!ie.containsPathSeparator;return he&&(P.isLinux?ie.pathNormalized===he:(0,T.equalsIgnoreCase)(ie.pathNormalized,he))?{score:y,labelMatch:[{start:0,end:U.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:ie.values&&ie.values.length>1?l(U,j,he,ie.values,J,V):v(U,j,he,ie,J,V)}function l(U,j,he,ie,V,J){let ne=0;const ve=[],ue=[];for(const ee of ie){const{score:N,labelMatch:K,descriptionMatch:le}=v(U,j,he,ee,V,J);if(N===D)return w;ne+=N,K&&ve.push(...K),le&&ue.push(...le)}return{score:ne,labelMatch:n(ve),descriptionMatch:n(ue)}}function v(U,j,he,ie,V,J){if(V||!j){const[ne,ve]=L(U,ie.normalized,ie.normalizedLowercase,J&&!ie.expectContiguousMatch);if(ne){const ue=(0,A.matchesPrefix)(ie.normalized,U);let ee;return ue?(ee=m,ee+=Math.round(ie.normalized.length/U.length*100)):ee=t,{score:ee+ne,labelMatch:ue||i(ve)}}}if(j){let ne=j;he&&(ne=`${j}${R.sep}`);const ve=ne.length,ue=`${ne}${U}`,[ee,N]=L(ue,ie.normalized,ie.normalizedLowercase,J&&!ie.expectContiguousMatch);if(ee){const K=i(N),le=[],me=[];return K.forEach(ke=>{ke.start<ve&&ke.end>ve?(le.push({start:0,end:ke.end-ve}),me.push({start:ke.start,end:ve})):ke.start>=ve?le.push({start:ke.start-ve,end:ke.end-ve}):me.push(ke)}),{score:ee,labelMatch:le,descriptionMatch:me}}}return w}function i(U){const j=[];if(!U)return j;let he;for(const ie of U)he&&he.end===ie?he.end+=1:(he={start:ie,end:ie+1},j.push(he));return j}function n(U){const j=U.sort((V,J)=>V.start-J.start),he=[];let ie;for(const V of j)!ie||!h(ie,V)?(ie=V,he.push(V)):(ie.start=Math.min(ie.start,V.start),ie.end=Math.max(ie.end,V.end));return he}function h(U,j){return!(U.end<j.start||j.end<U.start)}function b(U,j,he,ie,V,J){const ne=s(U,he,ie,V,J),ve=s(j,he,ie,V,J),ue=ne.score,ee=ve.score;if((ue===y||ee===y)&&ue!==ee)return ue===y?-1:1;if(ue>t||ee>t){if(ue!==ee)return ue>ee?-1:1;if(ue<m&&ee<m){const ce=O(ne.labelMatch,ve.labelMatch);if(ce!==0)return ce}const ke=V.getItemLabel(U)||"",Z=V.getItemLabel(j)||"";if(ke.length!==Z.length)return ke.length-Z.length}if(ue!==ee)return ue>ee?-1:1;const N=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,K=Array.isArray(ve.labelMatch)&&ve.labelMatch.length>0;if(N&&!K)return-1;if(K&&!N)return 1;const le=p(U,ne,V),me=p(j,ve,V);return le&&me&&le!==me?me>le?-1:1:W(U,j,he,V)}e.compareItemsByFuzzyScore=b;function p(U,j,he){let ie=-1,V=-1;if(j.descriptionMatch&&j.descriptionMatch.length?ie=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(ie=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(V=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=he.getItemDescription(U);J&&(V+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(V=j.descriptionMatch[j.descriptionMatch.length-1].end);return V-ie}function O(U,j){if(!U&&!j||(!U||!U.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!U||!U.length)return 1;const he=U[0].start,V=U[U.length-1].end-he,J=j[0].start,ve=j[j.length-1].end-J;return V===ve?0:ve<V?1:-1}function W(U,j,he,ie){const V=ie.getItemLabel(U)||"",J=ie.getItemLabel(j)||"",ne=ie.getItemDescription(U),ve=ie.getItemDescription(j),ue=V.length+(ne?ne.length:0),ee=J.length+(ve?ve.length:0);if(ue!==ee)return ue-ee;const N=ie.getItemPath(U),K=ie.getItemPath(j);return N&&K&&N.length!==K.length?N.length-K.length:V!==J?(0,c.compareAnything)(V,J,he.normalized):ne&&ve&&ne!==ve?(0,c.compareAnything)(ne,ve,he.normalized):N&&K&&N!==K?(0,c.compareAnything)(N,K,he.normalized):0}function q(U){return U.startsWith('"')&&U.endsWith('"')}const Y=" ";function x(U){typeof U!="string"&&(U="");const j=U.toLowerCase(),{pathNormalized:he,normalized:ie,normalizedLowercase:V}=M(U),J=he.indexOf(R.sep)>=0,ne=q(U);let ve;const ue=U.split(Y);if(ue.length>1)for(const ee of ue){const N=q(ee),{pathNormalized:K,normalized:le,normalizedLowercase:me}=M(ee);le&&(ve||(ve=[]),ve.push({original:ee,originalLowercase:ee.toLowerCase(),pathNormalized:K,normalized:le,normalizedLowercase:me,expectContiguousMatch:N}))}return{original:U,originalLowercase:j,pathNormalized:he,normalized:ie,normalizedLowercase:V,values:ve,containsPathSeparator:J,expectContiguousMatch:ne}}e.prepareQuery=x;function M(U){let j;P.isWindows?j=U.replace(/\//g,R.sep):j=U.replace(/\\/g,R.sep);const he=(0,T.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:he,normalizedLowercase:he.toLowerCase()}}function B(U){return Array.isArray(U)?x(U.map(j=>j.original).join(Y)):x(U.original)}e.pieceToQuery=B}),define(De[164],Ce([1,0,111,8,52]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",P=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${P.source}`,"g");function D(d){return d.replace(T,(f,w)=>w?f:`\\${f}`)}e.escapeIcons=D;const g=new RegExp(`\\\\${P.source}`,"g");function L(d){return d.replace(g,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(d){return d.indexOf(R)===-1?d:d.replace(k,(f,w,y,m)=>y?f:w||m||"")}e.stripIcons=S;function I(d){return d?d.replace(/\$\((.*?)\)/g,(f,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=I;const C=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(d){C.lastIndex=0;let f="";const w=[];let y=0;for(;;){const m=C.lastIndex,t=C.exec(d),o=d.substring(m,t?.index);if(o.length>0){f+=o;for(let s=0;s<o.length;s++)w.push(y)}if(!t)break;y+=t[0].length}return{text:f,iconOffsets:w}}e.parseLabelWithIcons=E;function r(d,f,w=!1){const{text:y,iconOffsets:m}=f;if(!m||m.length===0)return(0,c.matchesFuzzy)(d,y,w);const t=(0,A.ltrim)(y," "),o=y.length-t.length,s=(0,c.matchesFuzzy)(d,t,w);if(s)for(const a of s){const l=m[a.start+o]+o;a.start+=l,a.end+=l}return s}e.matchesFuzzyIconAware=r}),define(De[37],Ce([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(A||(A={})),function(u){const R="error",P="warning",T="warn",D="info",g="ignore";function L(S){return S?c.equalsIgnoreCase(R,S)?u.Error:c.equalsIgnoreCase(P,S)||c.equalsIgnoreCase(T,S)?u.Warning:c.equalsIgnoreCase(D,S)?u.Info:u.Ignore:u.Ignore}u.fromValue=L;function k(S){switch(S){case u.Error:return R;case u.Warning:return P;case u.Info:return D;default:return g}}u.toString=k}(A||(A={})),e.default=A}),define(De[69],Ce([1,0,17,8]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this.b="",this.c=0}reset(I){return this.b=I,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(I){const C=I.charCodeAt(0),E=this.b.charCodeAt(this.c);return C-E}value(){return this.b[this.c]}}e.StringIterator=u;class R{constructor(I=!0){this.e=I}reset(I){return this.b=I,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let I=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(I)this.c++;else break;else I=!1;return this}cmp(I){return this.e?(0,A.compareSubstring)(I,this.b,0,I.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class P{constructor(I=!0,C=!0){this.f=I,this.g=C}reset(I){this.d=0,this.e=0,this.b=I,this.c=I.length;for(let C=I.length-1;C>=0;C--,this.c--){const E=this.b.charCodeAt(C);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let I=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(I)this.d++;else break;else I=!1}return this}cmp(I){return this.g?(0,A.compareSubstring)(I,this.b,0,I.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=P;var T;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(T||(T={}));class D{constructor(I,C){this.f=I,this.g=C,this.d=[],this.e=0}reset(I){return this.c=I,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(I)),this.b.reset(I.path),this.b.value()&&this.d.push(3)),this.g(I)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(I){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(I,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(I,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(I);if(this.d[this.e]===4)return(0,A.compare)(I,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(I,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const I=this.right;return this.right=I.left,I.left=this,this.updateHeight(),I.updateHeight(),I}rotateRight(){const I=this.left;return this.left=I.right,I.right=this,this.updateHeight(),I.updateHeight(),I}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(L||(L={}));class k{static forUris(I=()=>!1,C=()=>!1){return new k(new D(I,C))}static forPaths(I=!1){return new k(new P(void 0,!I))}static forStrings(){return new k(new u)}static forConfigKeys(){return new k(new R)}constructor(I){this.b=I}clear(){this.c=void 0}fill(I,C){if(C){const E=C.slice(0);(0,c.shuffle)(E);for(const r of E)this.set(r,I)}else{const E=I.slice(0);(0,c.shuffle)(E);for(const r of E)this.set(r[0],r[1])}}set(I,C){const E=this.b.reset(I);let r;this.c||(this.c=new g,this.c.segment=E.value());const d=[];for(r=this.c;;){const w=E.cmp(r.segment);if(w>0)r.left||(r.left=new g,r.left.segment=E.value()),d.push([-1,r]),r=r.left;else if(w<0)r.right||(r.right=new g,r.right.segment=E.value()),d.push([1,r]),r=r.right;else if(E.hasNext())E.next(),r.mid||(r.mid=new g,r.mid.segment=E.value()),d.push([0,r]),r=r.mid;else break}const f=r.value;r.value=C,r.key=I;for(let w=d.length-1;w>=0;w--){const y=d[w][1];y.updateHeight();const m=y.balanceFactor();if(m<-1||m>1){const t=d[w][0],o=d[w+1][0];if(t===1&&o===1)d[w][1]=y.rotateLeft();else if(t===-1&&o===-1)d[w][1]=y.rotateRight();else if(t===1&&o===-1)y.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=y.rotateLeft();else if(t===-1&&o===1)y.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=y.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this.c=d[0][1]}}return f}get(I){return this.d(I)?.value}d(I){const C=this.b.reset(I);let E=this.c;for(;E;){const r=C.cmp(E.segment);if(r>0)E=E.left;else if(r<0)E=E.right;else if(C.hasNext())C.next(),E=E.mid;else break}return E}has(I){const C=this.d(I);return!(C?.value===void 0&&C?.mid===void 0)}delete(I){return this.e(I,!1)}deleteSuperstr(I){return this.e(I,!0)}e(I,C){const E=this.b.reset(I),r=[];let d=this.c;for(;d;){const f=E.cmp(d.segment);if(f>0)r.push([-1,d]),d=d.left;else if(f<0)r.push([1,d]),d=d.right;else if(E.hasNext())E.next(),r.push([0,d]),d=d.mid;else break}if(!!d){if(C?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this.f(d.right);if(f.key){const{key:w,value:y,segment:m}=f;this.e(f.key,!1),d.key=w,d.value=y,d.segment=m}}else{const f=d.left??d.right;if(r.length>0){const[w,y]=r[r.length-1];switch(w){case-1:y.left=f;break;case 0:y.mid=f;break;case 1:y.right=f;break}}else this.c=f}for(let f=r.length-1;f>=0;f--){const w=r[f][1];w.updateHeight();const y=w.balanceFactor();if(y>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),r[f][1]=w.rotateLeft()):y<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),r[f][1]=w.rotateRight()),f>0)switch(r[f-1][0]){case-1:r[f-1][1].left=r[f][1];break;case 1:r[f-1][1].right=r[f][1];break;case 0:r[f-1][1].mid=r[f][1];break}else this.c=r[0][1]}}}f(I){for(;I.left;)I=I.left;return I}findSubstr(I){const C=this.b.reset(I);let E=this.c,r;for(;E;){const d=C.cmp(E.segment);if(d>0)E=E.left;else if(d<0)E=E.right;else if(C.hasNext())C.next(),r=E.value||r,E=E.mid;else break}return E&&E.value||r}findSuperstr(I){return this.g(I,!1)}g(I,C){const E=this.b.reset(I);let r=this.c;for(;r;){const d=E.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(E.hasNext())E.next(),r=r.mid;else return r.mid?this.h(r.mid):C?r.value:void 0}}hasElementOrSubtree(I){return this.g(I,!0)!==void 0}forEach(I){for(const[C,E]of this)I(E,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(I){const C=[];return this.j(I,C),C[Symbol.iterator]()}j(I,C){!I||(I.left&&this.j(I.left,C),I.value&&C.push([I.key,I.value]),I.mid&&this.j(I.mid,C),I.right&&this.j(I.right,C))}_isBalanced(){const I=C=>{if(!C)return!0;const E=C.balanceFactor();return E<-1||E>1?!1:I(C.left)&&I(C.right)};return I(this.c)}}e.TernarySearchTree=k}),define(De[2],Ce([1,0,12,11]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,R=/^\//,P=/^\/\//;function T(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!u.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,a){return!s&&!a?"file":s}function g(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const L="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(a){return a instanceof I?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,v,i,n,h=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=D(a,h),this.authority=l||L,this.path=g(this.scheme,v||L),this.query=i||L,this.fragment=n||L,T(this,h))}get fsPath(){return w(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:v,path:i,query:n,fragment:h}=a;return l===void 0?l=this.scheme:l===null&&(l=L),v===void 0?v=this.authority:v===null&&(v=L),i===void 0?i=this.path:i===null&&(i=L),n===void 0?n=this.query:n===null&&(n=L),h===void 0?h=this.fragment:h===null&&(h=L),l===this.scheme&&v===this.authority&&i===this.path&&n===this.query&&h===this.fragment?this:new E(l,v,i,n,h)}static parse(a,l=!1){const v=S.exec(a);return v?new E(v[2]||L,o(v[4]||L),o(v[5]||L),o(v[7]||L),o(v[9]||L),l):new E(L,L,L,L,L)}static file(a){let l=L;if(A.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const v=a.indexOf(k,2);v===-1?(l=a.substring(2),a=k):(l=a.substring(2,v),a=a.substring(v)||k)}return new E("file",l,a,L,L)}static from(a){const l=new E(a.scheme,a.authority,a.path,a.query,a.fragment);return T(l,!0),l}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return A.isWindows&&a.scheme==="file"?v=I.file(c.win32.join(w(a,!0),...l)).path:v=c.posix.join(a.path,...l),a.with({path:v})}toString(a=!1){return y(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof I)return a;{const l=new E(a);return l._formatted=a.external,l._fsPath=a._sep===C?a.fsPath:null,l}}else return a}}e.URI=I;const C=A.isWindows?1:void 0;class E extends I{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(a=!1){return a?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=C),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,a,l){let v,i=-1;for(let n=0;n<s.length;n++){const h=s.charCodeAt(n);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47||l&&h===91||l&&h===93||l&&h===58)i!==-1&&(v+=encodeURIComponent(s.substring(i,n)),i=-1),v!==void 0&&(v+=s.charAt(n));else{v===void 0&&(v=s.substr(0,n));const b=r[h];b!==void 0?(i!==-1&&(v+=encodeURIComponent(s.substring(i,n)),i=-1),v+=b):i===-1&&(i=n)}}return i!==-1&&(v+=encodeURIComponent(s.substring(i))),v!==void 0?v:s}function f(s){let a;for(let l=0;l<s.length;l++){const v=s.charCodeAt(l);v===35||v===63?(a===void 0&&(a=s.substr(0,l)),a+=r[v]):a!==void 0&&(a+=s[l])}return a!==void 0?a:s}function w(s,a){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,A.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=w;function y(s,a){const l=a?f:d;let v="",{scheme:i,authority:n,path:h,query:b,fragment:p}=s;if(i&&(v+=i,v+=":"),(n||i==="file")&&(v+=k,v+=k),n){let O=n.indexOf("@");if(O!==-1){const W=n.substr(0,O);n=n.substr(O+1),O=W.lastIndexOf(":"),O===-1?v+=l(W,!1,!1):(v+=l(W.substr(0,O),!1,!1),v+=":",v+=l(W.substr(O+1),!1,!0)),v+="@"}n=n.toLowerCase(),O=n.lastIndexOf(":"),O===-1?v+=l(n,!1,!0):(v+=l(n.substr(0,O),!1,!0),v+=n.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}v+=l(h,!0,!1)}return b&&(v+="?",v+=l(b,!1,!1)),p&&(v+="#",v+=a?p:d(p,!1,!1)),v}function m(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(t)?s.replace(t,a=>m(a)):s}}),define(De[70],Ce([1,0,22,8,2]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(g){return JSON.stringify(g,T)}e.stringify=R;function P(g){let L=JSON.parse(g);return L=D(L),L}e.parse=P;function T(g,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function D(g,L=0){if(!g||L>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return u.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof c.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let k=0;k<g.length;++k)g[k]=D(g[k],L+1);else for(const k in g)Object.hasOwnProperty.call(g,k)&&(g[k]=D(g[k],L+1))}return g}e.revive=D}),define(De[18],Ce([1,0,9,11,2]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,k,S){this.a[L]=k,this.b[L]=S}setConnectionToken(L,k){this.c[L]=k}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(r){return c.onUnexpectedError(r),L}const k=L.authority;let S=this.a[k];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const I=this.b[k],C=this.c[k];let E=`path=${encodeURIComponent(L.path)}`;return typeof C=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),u.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${S}:${I}`,path:this.f,query:E})}}e.RemoteAuthorities=new P,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(L){const k=this.b(L,re);return this.uriToBrowserUri(k)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${T.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||T.a,query:null,fragment:null}):L}asFileUri(L){const k=this.b(L,re);return this.uriToFileUri(k)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==T.a?L.authority:null,query:null,fragment:null}):L}b(L,k){return u.URI.isUri(L)?L:u.URI.parse(k.toUrl(L))}}T.a="vscode-app",e.FileAccess=new T;var D;(function(g){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(L.get("3"));const k="vscode-coi";function S(C){let E;typeof C=="string"?E=new URL(C).searchParams:C instanceof URL?E=C.searchParams:u.URI.isUri(C)&&(E=new URL(C.toString(!0)).searchParams);const r=E?.get(k);if(!!r)return L.get(r)}g.getHeadersFromQuery=S;function I(C,E,r){if(!globalThis.crossOriginIsolated)return;const d=E&&r?"3":r?"2":"1";C instanceof URLSearchParams?C.set(k,d):C[k]=d}g.addSearchParam=I})(D=e.COI||(e.COI={}))}),define(De[24],Ce([1,0,33,18,12,11,8,2]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(I){return(0,T.uriToFsPath)(I,!0)}e.originalFSPath=D;class g{constructor(C){this.a=C}compare(C,E,r=!1){return C===E?0:(0,P.compare)(this.getComparisonKey(C,r),this.getComparisonKey(E,r))}isEqual(C,E,r=!1){return C===E?!0:!C||!E?!1:this.getComparisonKey(C,r)===this.getComparisonKey(E,r)}getComparisonKey(C,E=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,E,r=!1){if(C.scheme===E.scheme){if(C.scheme===A.Schemas.file)return c.isEqualOrParent(D(C),D(E),this.a(C))&&C.query===E.query&&(r||C.fragment===E.fragment);if((0,e.isEqualAuthority)(C.authority,E.authority))return c.isEqualOrParent(C.path,E.path,this.a(C),"/")&&C.query===E.query&&(r||C.fragment===E.fragment)}return!1}joinPath(C,...E){return T.URI.joinPath(C,...E)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return u.posix.basename(C.path)}extname(C){return u.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let E;return C.scheme===A.Schemas.file?E=T.URI.file(u.dirname(D(C))).path:(E=u.posix.dirname(C.path),C.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),E="/")),C.with({path:E})}normalizePath(C){if(!C.path.length)return C;let E;return C.scheme===A.Schemas.file?E=T.URI.file(u.normalize(D(C))).path:E=u.posix.normalize(C.path),C.with({path:E})}relativePath(C,E){if(C.scheme!==E.scheme||!(0,e.isEqualAuthority)(C.authority,E.authority))return;if(C.scheme===A.Schemas.file){const f=u.relative(D(C),D(E));return R.isWindows?c.toSlashes(f):f}let r=C.path||"/";const d=E.path||"/";if(this.a(C)){let f=0;for(const w=Math.min(r.length,d.length);f<w&&!(r.charCodeAt(f)!==d.charCodeAt(f)&&r.charAt(f).toLowerCase()!==d.charAt(f).toLowerCase());f++);r=d.substr(0,f)+r.substr(f)}return u.posix.relative(r,d)}resolvePath(C,E){if(C.scheme===A.Schemas.file){const r=T.URI.file(u.resolve(D(C),E));return C.with({authority:r.authority,path:r.path})}return E=c.toPosixPath(E),C.with({path:u.posix.resolve(C.path,E)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,E){return C===E||C!==void 0&&E!==void 0&&(0,P.equalsIgnoreCase)(C,E)}hasTrailingPathSeparator(C,E=u.sep){if(C.scheme===A.Schemas.file){const r=D(C);return r.length>c.getRoot(r).length&&r[r.length-1]===E}else{const r=C.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,E=u.sep){return(0,e.hasTrailingPathSeparator)(C,E)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,E=u.sep){let r=!1;if(C.scheme===A.Schemas.file){const d=D(C);r=d!==void 0&&d.length===c.getRoot(d).length&&d[d.length-1]===E}else{E="/";const d=C.path;r=d.length===1&&d.charCodeAt(d.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(C,E)?C.with({path:C.path+"/"}):C}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(I=>I.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new g(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,C){const E=[];for(let r=0;r<I.length;r++){const d=C(I[r]);I.some((f,w)=>w===r?!1:(0,e.isEqualOrParent)(d,C(f)))||E.push(I[r])}return E}e.distinctParents=L;var k;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function C(E){const r=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(w=>{const[y,m]=w.split(":");y&&m&&r.set(y,m)});const f=E.path.substring(0,E.path.indexOf(";"));return f&&r.set(I.META_DATA_MIME,f),r}I.parseMetaData=C})(k=e.DataUri||(e.DataUri={}));function S(I,C,E){if(C){let r=I.path;return r&&r[0]!==u.posix.sep&&(r=u.posix.sep+r),I.with({scheme:E,authority:C,path:r})}return I.with({scheme:E})}e.toLocalResource=S}),define(De[19],Ce([1,0,21,9,3,6,24,11,149]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(ee){return!!ee&&typeof ee.then=="function"}e.isThenable=g;function L(ee){const N=new c.CancellationTokenSource,K=ee(N.token),le=new Promise((me,ke)=>{const Z=N.token.onCancellationRequested(()=>{Z.dispose(),N.dispose(),ke(new A.CancellationError)});Promise.resolve(K).then(ce=>{Z.dispose(),N.dispose(),me(ce)},ce=>{Z.dispose(),N.dispose(),ke(ce)})});return new class{cancel(){N.cancel()}then(me,ke){return le.then(me,ke)}catch(me){return this.then(void 0,me)}finally(me){return le.finally(me)}}}e.createCancelablePromise=L;function k(ee,N,K){return new Promise((le,me)=>{const ke=N.onCancellationRequested(()=>{ke.dispose(),le(K)});ee.then(le,me).finally(()=>ke.dispose())})}e.raceCancellation=k;function S(ee,N){return new Promise((K,le)=>{const me=N.onCancellationRequested(()=>{me.dispose(),le(new A.CancellationError)});ee.then(K,le).finally(()=>me.dispose())})}e.raceCancellationError=S;async function I(ee){let N=-1;const K=ee.map((me,ke)=>me.then(Z=>(N=ke,Z))),le=await Promise.race(K);return ee.forEach((me,ke)=>{ke!==N&&me.cancel()}),le}e.raceCancellablePromises=I;function C(ee,N,K){let le;const me=setTimeout(()=>{le?.(void 0),K?.()},N);return Promise.race([ee.finally(()=>clearTimeout(me)),new Promise(ke=>le=ke)])}e.raceTimeout=C;function E(ee){return new Promise((N,K)=>{const le=ee();g(le)?le.then(N,K):N(le)})}e.asPromise=E;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const K=()=>{this.b=null;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(K,K).then(le)})}return new Promise((K,le)=>{this.b.then(K,le)})}return this.a=N(),new Promise((K,le)=>{this.a.then(me=>{this.a=null,K(me)},me=>{this.a=null,le(me)})})}}e.Throttler=r;class d{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=d;class f{constructor(){this.a=new Map}queue(N,K){const me=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.a.get(N)===me&&this.a.delete(N)});return this.a.set(N,me),me}}e.SequencerByKey=f;const w=(ee,N)=>{let K=!0;const le=setTimeout(()=>{K=!1,N()},ee);return{isTriggered:()=>K,dispose:()=>{clearTimeout(le),K=!1}}},y=ee=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,ee())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class m{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,K=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((me,ke)=>{this.d=me,this.f=ke}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=K===D.MicrotaskDelay?y(le):w(K,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=m;class t{constructor(N){this.a=new m(N),this.b=new r}trigger(N,K){return this.a.trigger(()=>this.b.queue(N),K)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class o{constructor(){this.a=!1,this.b=new Promise((N,K)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class s extends o{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function a(ee,N){return N?new Promise((K,le)=>{const me=setTimeout(()=>{ke.dispose(),K()},ee),ke=N.onCancellationRequested(()=>{clearTimeout(me),ke.dispose(),le(new A.CancellationError)})}):L(K=>a(ee,K))}e.timeout=a;function l(ee,N=0){const K=setTimeout(ee,N);return(0,R.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=l;function v(ee){const N=[];let K=0;const le=ee.length;function me(){return K<le?ee[K++]():null}function ke(Z){Z!=null&&N.push(Z);const ce=me();return ce?ce.then(ke):Promise.resolve(N)}return Promise.resolve(null).then(ke)}e.sequence=v;function i(ee,N=le=>!!le,K=null){let le=0;const me=ee.length,ke=()=>{if(le>=me)return Promise.resolve(K);const Z=ee[le++];return Promise.resolve(Z()).then(de=>N(de)?Promise.resolve(de):ke())};return ke()}e.first=i;function n(ee,N=le=>!!le,K=null){if(ee.length===0)return Promise.resolve(K);let le=ee.length;const me=()=>{le=-1;for(const ke of ee)ke.cancel?.()};return new Promise((ke,Z)=>{for(const ce of ee)ce.then(de=>{--le>=0&&N(de)?(me(),ke(de)):le===0&&ke(K)}).catch(de=>{--le>=0&&(me(),Z(de))})})}e.firstParallel=n;class h{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new u.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((K,le)=>{this.f.push({factory:N,c:K,e:le}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const K=N.factory();K.then(N.c,N.e),K.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class b extends h{constructor(){super(1)}}e.Queue=b;class p{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new ie;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,K=P.extUri){const le=K.getComparisonKey(N);let me=this.a.get(le);return me||(me=new b,u.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(le),this.f()}),this.a.set(le,me)),me}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=p;class O{constructor(N,K){this.a=-1,typeof N=="function"&&typeof K=="number"&&this.setIfNotSet(N,K)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,K){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},K)}setIfNotSet(N,K){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},K))}}e.TimeoutTimer=O;class W{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,K){this.cancel(),this.a=setInterval(()=>{N()},K)}}e.IntervalTimer=W;class q{constructor(N,K){this.b=-1,this.a=N,this.d=K,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class Y{constructor(N,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.a=N,this.b=K,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Y;class x extends q{constructor(N,K){super(N,K),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=x;class M extends R.Disposable{constructor(N,K){super(),this.g=N,this.h=K,this.a=[],this.b=this.D(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const K of N)this.a.push(K);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ee=>{(0,T.setTimeout0)(()=>{if(N)return;const K=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,K-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(ee,N)=>{const K=requestIdleCallback(ee,typeof N=="number"?{timeout:N}:void 0);let le=!1;return{dispose(){le||(le=!0,cancelIdleCallback(K))}}}}();class B{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(K){this.g=K}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=B;async function U(ee,N,K){let le;for(let me=0;me<K;me++)try{return await ee()}catch(ke){le=ke,await a(N)}throw le}e.retry=U;class j{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,K,le){return this.a={taskId:N,cancel:()=>le?.(),promise:K},K.then(()=>this.d(N),()=>this.d(N)),K}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let K,le;const me=new Promise((ke,Z)=>{K=ke,le=Z});this.b={run:N,promise:me,promiseResolve:K,promiseReject:le}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class he{constructor(N,K=()=>Date.now()){this.d=N,this.f=K,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=he;class ie{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,K)=>{this.a=N,this.b=K})}complete(N){return new Promise(K=>{this.a(N),this.f=!0,K()})}error(N){return new Promise(K=>{this.b(N),this.d=!0,K()})}cancel(){new Promise(N=>{this.b(new A.CancellationError),this.d=!0,N()})}}e.DeferredPromise=ie;var V;(function(ee){async function N(le){let me;const ke=await Promise.all(le.map(Z=>Z.then(ce=>ce,ce=>{me||(me=ce)})));if(typeof me<"u")throw me;return ke}ee.settled=N;function K(le){return new Promise(async(me,ke)=>{try{await le(me,ke)}catch(Z){ke(Z)}})}ee.withAsyncBody=K})(V=e.Promises||(e.Promises={}));var J;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(J||(J={}));class ne{static fromArray(N){return new ne(K=>{K.emitMany(N)})}static fromPromise(N){return new ne(async K=>{K.emitMany(await N)})}static fromPromises(N){return new ne(async K=>{await Promise.all(N.map(async le=>K.emitOne(await le)))})}static merge(N){return new ne(async K=>{await Promise.all(N.map(async le=>{for await(const me of le)K.emitOne(me)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new u.Emitter,queueMicrotask(async()=>{const K={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(N(K)),this.j()}catch(le){this.k(le)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await u.Event.toPromise(this.f.event)}while(!0)}}}static map(N,K){return new ne(async le=>{for await(const me of N)le.emitOne(K(me))})}map(N){return ne.map(this,N)}static filter(N,K){return new ne(async le=>{for await(const me of N)K(me)&&le.emitOne(me)})}filter(N){return ne.filter(this,N)}static coalesce(N){return ne.filter(N,K=>!!K)}coalesce(){return ne.coalesce(this)}static async toPromise(N){const K=[];for await(const le of N)K.push(le);return K}toPromise(){return ne.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}ne.EMPTY=ne.fromArray([]),e.AsyncIterableObject=ne;class ve extends ne{constructor(N,K){super(K),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ve;function ue(ee){const N=new c.CancellationTokenSource,K=ee(N.token);return new ve(N,async le=>{const me=N.token.onCancellationRequested(()=>{me.dispose(),N.dispose(),le.reject(new A.CancellationError)});try{for await(const ke of K){if(N.token.isCancellationRequested)return;le.emitOne(ke)}me.dispose(),N.dispose()}catch(ke){me.dispose(),N.dispose(),le.reject(ke)}})}e.createCancelableAsyncIterable=ue}),define(De[38],Ce([1,0,17,19,33,28,12,11,8]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",S=/\//g;function I(he,ie){switch(he){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${ie?`|${L}${k}+`:""})*?`}}function C(he,ie){if(!he)return[];const V=[];let J=!1,ne=!1,ve="";for(const ue of he){switch(ue){case ie:if(!J&&!ne){V.push(ve),ve="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ve+=ue}return ve&&V.push(ve),V}e.splitGlobAware=C;function E(he){if(!he)return"";let ie="";const V=C(he,e.GLOB_SPLIT);if(V.every(J=>J===e.GLOBSTAR))ie=".*";else{let J=!1;V.forEach((ne,ve)=>{if(ne===e.GLOBSTAR){if(J)return;ie+=I(2,ve===V.length-1)}else{let ue=!1,ee="",N=!1,K="";for(const le of ne){if(le!=="}"&&ue){ee+=le;continue}if(N&&(le!=="]"||!K)){let me;le==="-"?me=le:(le==="^"||le==="!")&&!K?me="^":le===e.GLOB_SPLIT?me="":me=(0,D.escapeRegExpCharacters)(le),K+=me;continue}switch(le){case"{":ue=!0;continue;case"[":N=!0;continue;case"}":{ie+=`(?:${C(ee,",").map(Z=>E(Z)).join("|")})`,ue=!1,ee="";break}case"]":{ie+="["+K+"]",N=!1,K="";break}case"?":ie+=k;continue;case"*":ie+=I(1);continue;default:ie+=(0,D.escapeRegExpCharacters)(le)}}ve<V.length-1&&(V[ve+1]!==e.GLOBSTAR||ve+2<V.length)&&(ie+=L)}J=ne===e.GLOBSTAR})}return ie}const r=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),o=function(){return!1},s=function(){return null};function a(he,ie){if(!he)return s;let V;typeof he!="string"?V=he.pattern:V=he,V=V.trim();const J=`${V}_${!!ie.trimForExclusions}`;let ne=t.get(J);if(ne)return l(ne,he);let ve;return r.test(V)?ne=i(V.substr(4),V):(ve=d.exec(v(V,ie)))?ne=n(ve[1],V):(ie.trimForExclusions?w:f).test(V)?ne=h(V,ie):(ve=y.exec(v(V,ie)))?ne=b(ve[1].substr(1),V,!0):(ve=m.exec(v(V,ie)))?ne=b(ve[1],V,!1):ne=p(V),t.set(J,ne),l(ne,he)}function l(he,ie){if(typeof ie=="string")return he;const V=function(J,ne){return(0,u.isEqualOrParent)(J,ie.base,!T.isLinux)?he((0,D.ltrim)(J.substr(ie.base.length),P.sep),ne):null};return V.allBasenames=he.allBasenames,V.allPaths=he.allPaths,V.basenames=he.basenames,V.patterns=he.patterns,V}function v(he,ie){return ie.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function i(he,ie){return function(V,J){return typeof V=="string"&&V.endsWith(he)?ie:null}}function n(he,ie){const V=`/${he}`,J=`\\${he}`,ne=function(ue,ee){return typeof ue!="string"?null:ee?ee===he?ie:null:ue===he||ue.endsWith(V)||ue.endsWith(J)?ie:null},ve=[he];return ne.basenames=ve,ne.patterns=[ie],ne.allBasenames=ve,ne}function h(he,ie){const V=U(he.slice(1,-1).split(",").map(ee=>a(ee,ie)).filter(ee=>ee!==s),he),J=V.length;if(!J)return s;if(J===1)return V[0];const ne=function(ee,N){for(let K=0,le=V.length;K<le;K++)if(V[K](ee,N))return he;return null},ve=V.find(ee=>!!ee.allBasenames);ve&&(ne.allBasenames=ve.allBasenames);const ue=V.reduce((ee,N)=>N.allPaths?ee.concat(N.allPaths):ee,[]);return ue.length&&(ne.allPaths=ue),ne}function b(he,ie,V){const J=P.sep===P.posix.sep,ne=J?he:he.replace(S,P.sep),ve=P.sep+ne,ue=P.posix.sep+he;let ee;return V?ee=function(N,K){return typeof N=="string"&&(N===ne||N.endsWith(ve)||!J&&(N===he||N.endsWith(ue)))?ie:null}:ee=function(N,K){return typeof N=="string"&&(N===ne||!J&&N===he)?ie:null},ee.allPaths=[(V?"*/":"./")+he],ee}function p(he){try{const ie=new RegExp(`^${E(he)}$`);return function(V){return ie.lastIndex=0,typeof V=="string"&&ie.test(V)?he:null}}catch{return s}}function O(he,ie,V){return!he||typeof ie!="string"?!1:W(he)(ie,void 0,V)}e.match=O;function W(he,ie={}){if(!he)return o;if(typeof he=="string"||q(he)){const V=a(he,ie);if(V===s)return o;const J=function(ne,ve){return!!V(ne,ve)};return V.allBasenames&&(J.allBasenames=V.allBasenames),V.allPaths&&(J.allPaths=V.allPaths),J}return M(he,ie)}e.parse=W;function q(he){const ie=he;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=q;function Y(he){return he.allBasenames||[]}e.getBasenameTerms=Y;function x(he){return he.allPaths||[]}e.getPathTerms=x;function M(he,ie){const V=U(Object.getOwnPropertyNames(he).map(ee=>B(ee,he[ee],ie)).filter(ee=>ee!==s)),J=V.length;if(!J)return s;if(!V.some(ee=>!!ee.requiresSiblings)){if(J===1)return V[0];const ee=function(le,me){let ke;for(let Z=0,ce=V.length;Z<ce;Z++){const de=V[Z](le,me);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(ke||(ke=[]),ke.push(de))}return ke?(async()=>{for(const Z of ke){const ce=await Z;if(typeof ce=="string")return ce}return null})():null},N=V.find(le=>!!le.allBasenames);N&&(ee.allBasenames=N.allBasenames);const K=V.reduce((le,me)=>me.allPaths?le.concat(me.allPaths):le,[]);return K.length&&(ee.allPaths=K),ee}const ne=function(ee,N,K){let le,me;for(let ke=0,Z=V.length;ke<Z;ke++){const ce=V[ke];ce.requiresSiblings&&K&&(N||(N=(0,P.basename)(ee)),le||(le=N.substr(0,N.length-(0,P.extname)(ee).length)));const de=ce(ee,N,le,K);if(typeof de=="string")return de;(0,A.isThenable)(de)&&(me||(me=[]),me.push(de))}return me?(async()=>{for(const ke of me){const Z=await ke;if(typeof Z=="string")return Z}return null})():null},ve=V.find(ee=>!!ee.allBasenames);ve&&(ne.allBasenames=ve.allBasenames);const ue=V.reduce((ee,N)=>N.allPaths?ee.concat(N.allPaths):ee,[]);return ue.length&&(ne.allPaths=ue),ne}function B(he,ie,V){if(ie===!1)return s;const J=a(he,V);if(J===s)return s;if(typeof ie=="boolean")return J;if(ie){const ne=ie.when;if(typeof ne=="string"){const ve=(ue,ee,N,K)=>{if(!K||!J(ue,ee))return null;const le=ne.replace("$(basename)",()=>N),me=K(le);return(0,A.isThenable)(me)?me.then(ke=>ke?he:null):me?he:null};return ve.requiresSiblings=!0,ve}}return J}function U(he,ie){const V=he.filter(ee=>!!ee.basenames);if(V.length<2)return he;const J=V.reduce((ee,N)=>{const K=N.basenames;return K?ee.concat(K):ee},[]);let ne;if(ie){ne=[];for(let ee=0,N=J.length;ee<N;ee++)ne.push(ie)}else ne=V.reduce((ee,N)=>{const K=N.patterns;return K?ee.concat(K):ee},[]);const ve=function(ee,N){if(typeof ee!="string")return null;if(!N){let le;for(le=ee.length;le>0;le--){const me=ee.charCodeAt(le-1);if(me===47||me===92)break}N=ee.substr(le)}const K=J.indexOf(N);return K!==-1?ne[K]:null};ve.basenames=J,ve.patterns=ne,ve.allBasenames=J;const ue=he.filter(ee=>!ee.basenames);return ue.push(ve),ue}function j(he,ie){return(0,c.equals)(he,ie,(V,J)=>typeof V=="string"&&typeof J=="string"?V===J:typeof V!="string"&&typeof J!="string"?V.base===J.base&&V.pattern===J.pattern:!1)}e.patternsEquals=j}),define(De[113],Ce([1,0,9,164,24,8,2]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",f=!1){if(this.value=d,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(d,f=0){return this.value+=S(this.supportThemeIcons?(0,A.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,f){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}appendLink(d,f,w){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(d),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(d,f){const w=new RegExp((0,R.escapeRegExpCharacters)(f),"g");return d.replace(w,(y,m)=>d.charAt(m-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=D;function g(r){return L(r)?!r.value:Array.isArray(r)?r.every(g):!0}e.isEmptyMarkdownString=g;function L(r){return r instanceof D?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(r,d){return r===d?!0:!r||!d?!1:r.value===d.value&&r.isTrusted===d.isTrusted&&r.supportThemeIcons===d.supportThemeIcons&&r.supportHtml===d.supportHtml&&(r.baseUri===d.baseUri||!!r.baseUri&&!!d.baseUri&&(0,u.isEqual)(P.URI.from(r.baseUri),P.URI.from(d.baseUri)))}e.markdownStringEqual=k;function S(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function I(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function C(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function E(r){const d=[],f=r.split("|").map(y=>y.trim());r=f[0];const w=f[1];if(w){const y=/height=(\d+)/.exec(w),m=/width=(\d+)/.exec(w),t=y?y[1]:"",o=m?m[1]:"",s=isFinite(parseInt(o)),a=isFinite(parseInt(t));s&&d.push(`width="${o}"`),a&&d.push(`height="${t}"`)}return{href:r,dimensions:d}}e.parseHrefAndDimensions=E}),define(De[114],Ce([1,0,17,33,12,11,24,8]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function D(s,a){const{os:l,tildify:v,relative:i}=a;if(i){const b=g(s,i,l);if(typeof b=="string")return b}let n=s.fsPath;if(l===1&&!R.isWindows?n=n.replace(/\//g,"\\"):l!==1&&R.isWindows&&(n=n.replace(/\\/g,"/")),l!==1&&v?.userHome){const b=v.userHome.fsPath;let p;s.scheme!==v.userHome.scheme&&s.path.startsWith(u.posix.sep)?p=v.userHome.with({path:s.path}).fsPath:p=s.fsPath,n=S(p,b,l)}return(l===1?u.win32:u.posix).normalize(L(n,l===1))}e.getPathLabel=D;function g(s,a,l){const v=l===1?u.win32:u.posix,i=l===3?P.extUri:P.extUriIgnorePathCase,n=a.getWorkspace(),h=(0,c.firstOrDefault)(n.folders);if(!h)return;s.scheme!==h.uri.scheme&&s.path.startsWith(u.posix.sep)&&(s=h.uri.with({path:s.path}));const b=a.getWorkspaceFolder(s);if(!b)return;let p;if(i.isEqual(b.uri,s)?p="":p=i.relativePath(b.uri,s)??"",p&&(p=v.normalize(p)),n.folders.length>1&&!a.noPrefix){const O=b.name?b.name:i.basenameOrAuthority(b.uri);p=p?`${O} \u2022 ${p}`:O}return p}function L(s,a=R.isWindows){return(0,A.hasDriveLetter)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let k=Object.create(null);function S(s,a,l=R.OS){if(l===1||!s||!a)return s;let v=k.original===a?k.normalized:void 0;v||(v=a,R.isWindows&&(v=(0,A.toSlashes)(v)),v=`${(0,T.rtrim)(v,u.posix.sep)}${u.posix.sep}`,k={original:a,normalized:v});let i=s;return R.isWindows&&(i=(0,A.toSlashes)(i)),(l===3?i.startsWith(v):(0,T.startsWithIgnoreCase)(i,v))?`~/${i.substr(v.length)}`:s}e.tildify=S;function I(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=I;const C="\u2026",E="\\\\",r="~";function d(s,a=u.sep){const l=new Array(s.length);let v=!1;for(let i=0;i<s.length;i++){const n=s[i];if(n===""){l[i]=`.${a}`;continue}if(!n){l[i]=n;continue}v=!0;let h="",b=n;b.indexOf(E)===0?(h=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(a)===0?(h=b.substr(0,b.indexOf(a)+a.length),b=b.substr(b.indexOf(a)+a.length)):b.indexOf(r)===0&&(h=b.substr(0,b.indexOf(r)+r.length),b=b.substr(b.indexOf(r)+r.length));const p=b.split(a);for(let O=1;v&&O<=p.length;O++)for(let W=p.length-O;v&&W>=0;W--){v=!1;let q=p.slice(W,W+O).join(a);for(let Y=0;!v&&Y<s.length;Y++)if(Y!==i&&s[Y]&&s[Y].indexOf(q)>-1){const x=W+O===p.length,M=W>0&&s[Y].indexOf(a)>-1?a+q:q,B=s[Y].endsWith(M);v=!x||B}if(!v){let Y="";(p[0].endsWith(":")||h!=="")&&(W===1&&(W=0,O++,q=p[0]+a+q),W>0&&(Y=p[0]+a),Y=h+Y),W>0&&(Y=Y+C+a),Y=Y+q,W+O<p.length&&(Y=Y+a+C),l[i]=Y}}v&&(l[i]=n)}return l}e.shorten=d;var f;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function w(s,a=Object.create(null)){const l=[];let v=!1,i="";for(const n of s)if(n==="$"||v&&n==="{")i&&l.push({value:i,type:f.TEXT}),i="",v=!0;else if(n==="}"&&v){const h=a[i];if(typeof h=="string")h.length&&l.push({value:h,type:f.VARIABLE});else if(h){const b=l[l.length-1];(!b||b.type!==f.SEPARATOR)&&l.push({value:h.label,type:f.SEPARATOR})}i="",v=!1}else i+=n;return i&&!v&&l.push({value:i,type:f.TEXT}),l.filter((n,h)=>{if(n.type===f.SEPARATOR){const b=l[h-1],p=l[h+1];return[b,p].every(O=>O&&(O.type===f.VARIABLE||O.type===f.TEXT)&&O.value.length>0)}return!0}).map(n=>n.value).join("")}e.template=w;function y(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function m(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function t(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(s){const a=s.indexOf("/")!==-1?u.posix:u.win32,l=a.basename(s),v=a.dirname(s);return l.length?{name:l,parentPath:v}:{name:v,parentPath:""}}e.splitName=o}),define(De[115],Ce([1,0,22,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(k){return k.toJSON()}class R{constructor(S){this.a=S}transformIncoming(S){const I=this.a.transformIncoming(S);return I===S?S:u(A.URI.from(I))}transformOutgoing(S){const I=this.a.transformOutgoing(S);return I===S?S:u(A.URI.from(I))}transformOutgoingURI(S){const I=this.a.transformOutgoing(S);return I===S?S:A.URI.from(I)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function P(k,S,I){if(!k||I>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return S.transformOutgoing(k);for(const C in k)if(Object.hasOwnProperty.call(k,C)){const E=P(k[C],S,I+1);E!==null&&(k[C]=E)}}return null}function T(k,S){const I=P(k,S,0);return I===null?k:I}e.transformOutgoingURIs=T;function D(k,S,I,C){if(!k||C>200)return null;if(typeof k=="object"){if(k.$mid===1)return I?A.URI.revive(S.transformIncoming(k)):S.transformIncoming(k);if(k instanceof c.VSBuffer)return null;for(const E in k)if(Object.hasOwnProperty.call(k,E)){const r=D(k[E],S,I,C+1);r!==null&&(k[E]=r)}}return null}function g(k,S){const I=D(k,S,!1,0);return I===null?k:I}e.transformIncomingURIs=g;function L(k,S){const I=D(k,S,!0,0);return I===null?k:I}e.transformAndReviveIncomingURIs=L}),define(De[29],Ce([1,0,71,89,324,19,33,87,12,11,24,2]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function I(M,B=S.UNLINK){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===S.UNLINK?E(M):C(M)}async function C(M){try{const B=(0,P.randomPath)((0,A.tmpdir)());try{await c.promises.rename(M,B)}catch(U){return U.code==="ENOENT"?void 0:E(M)}E(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(M){return(0,u.promisify)(c.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function r(M){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function d(M,B){return y(await(B?f(M):(0,u.promisify)(c.readdir)(M)))}async function f(M){try{return await(0,u.promisify)(c.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const B=[],U=await d(M);for(const j of U){let he=!1,ie=!1,V=!1;try{const J=await e.Promises.lstat((0,D.join)(M,j));he=J.isFile(),ie=J.isDirectory(),V=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}B.push({name:j,isFile:()=>he,isDirectory:()=>ie,isSymbolicLink:()=>V})}return B}function w(M){return y(c.readdirSync(M))}e.readdirSync=w;function y(M){return M.map(B=>typeof B=="string"?g.isMacintosh?(0,T.normalizeNFC)(B):B:(B.name=g.isMacintosh?(0,T.normalizeNFC)(B.name):B.name,B))}async function m(M){const B=await d(M),U=[];for(const j of B)await o.existsDirectory((0,D.join)(M,j))&&U.push(j);return U}function t(M,B=1e3){return new Promise(U=>{let j=!1;const he=setInterval(()=>{j||(j=!0,c.access(M,ie=>{j=!1,ie&&(clearInterval(he),U(void 0))}))},B)})}e.whenDeleted=t;var o;(function(M){async function B(he){let ie;try{if(ie=await e.Promises.lstat(he),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(he),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(g.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(he)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw J}throw V}}M.stat=B;async function U(he){try{const{stat:ie,symbolicLink:V}=await M.stat(he);return ie.isFile()&&V?.dangling!==!0}catch{}return!1}M.existsFile=U;async function j(he){try{const{stat:ie,symbolicLink:V}=await M.stat(he);return ie.isDirectory()&&V?.dangling!==!0}catch{}return!1}M.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function a(M,B,U){return s.queueFor(k.URI.file(M),L.extUriBiasedIgnorePathCase).queue(()=>{const j=h(U);return new Promise((he,ie)=>i(M,B,j,V=>V?ie(V):he()))})}let l=!0;function v(M){l=M}e.configureFlushOnWrite=v;function i(M,B,U,j){if(!l)return c.writeFile(M,B,{mode:U.mode,flag:U.flag},j);c.open(M,U.flag,U.mode,(he,ie)=>{if(he)return j(he);c.writeFile(ie,B,V=>{if(V)return c.close(ie,()=>j(V));c.fdatasync(ie,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),v(!1)),c.close(ie,ne=>j(ne))))})})}function n(M,B,U){const j=h(U);if(!l)return c.writeFileSync(M,B,{mode:j.mode,flag:j.flag});const he=c.openSync(M,j.flag,j.mode);try{c.writeFileSync(he,B);try{c.fdatasyncSync(he)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),v(!1)}}finally{c.closeSync(he)}}e.writeFileSync=n;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function b(M,B){if(M!==B)try{await e.Promises.rename(M,B)}catch(U){if(M.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await p(M,B,{preserveSymlinks:!1}),await I(M,S.MOVE);else throw U}}async function p(M,B,U){return W(M,B,{root:{source:M,target:B},options:U,handledSourcePaths:new Set})}const O=511;async function W(M,B,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:j,symbolicLink:he}=await o.stat(M);if(he){if(U.options.preserveSymlinks)try{return await x(M,B,U)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(he.dangling)return}return j.isDirectory()?q(M,B,j.mode&O,U):Y(M,B,j.mode&O)}async function q(M,B,U,j){await e.Promises.mkdir(B,{recursive:!0,mode:U});const he=await d(M);for(const ie of he)await W((0,D.join)(M,ie),(0,D.join)(B,ie),j)}async function Y(M,B,U){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,U)}async function x(M,B,U){let j=await e.Promises.readlink(M);(0,P.isEqualOrParent)(j,U.root.source,!g.isLinux)&&(j=(0,D.join)(U.root.target,j.substr(U.root.source.length+1))),await e.Promises.symlink(j,B)}e.Promises=new class{get access(){return(0,u.promisify)(c.access)}get stat(){return(0,u.promisify)(c.stat)}get lstat(){return(0,u.promisify)(c.lstat)}get utimes(){return(0,u.promisify)(c.utimes)}get read(){return(M,B,U,j,he)=>new Promise((ie,V)=>{c.read(M,B,U,j,he,(J,ne,ve)=>J?V(J):ie({bytesRead:ne,buffer:ve}))})}get readFile(){return(0,u.promisify)(c.readFile)}get write(){return(M,B,U,j,he)=>new Promise((ie,V)=>{c.write(M,B,U,j,he,(J,ne,ve)=>J?V(J):ie({bytesWritten:ne,buffer:ve}))})}get appendFile(){return(0,u.promisify)(c.appendFile)}get fdatasync(){return(0,u.promisify)(c.fdatasync)}get truncate(){return(0,u.promisify)(c.truncate)}get rename(){return(0,u.promisify)(c.rename)}get copyFile(){return(0,u.promisify)(c.copyFile)}get open(){return(0,u.promisify)(c.open)}get close(){return(0,u.promisify)(c.close)}get symlink(){return(0,u.promisify)(c.symlink)}get readlink(){return(0,u.promisify)(c.readlink)}get chmod(){return(0,u.promisify)(c.chmod)}get mkdir(){return(0,u.promisify)(c.mkdir)}get unlink(){return(0,u.promisify)(c.unlink)}get rmdir(){return(0,u.promisify)(c.rmdir)}get realpath(){return(0,u.promisify)(c.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return m}get writeFile(){return a}get rm(){return I}get move(){return b}get copy(){return p}}}),define(De[116],Ce([1,0,71,12,11,8,29]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(S){if(u.isLinux)return S;const I=(0,A.dirname)(S);if(S===I)return S;const C=((0,A.basename)(S)||S).toLowerCase();try{const r=(0,P.readdirSync)(I).filter(d=>d.toLowerCase()===C);if(r.length===1){const d=T(I);if(d)return(0,A.join)(d,r[0])}else if(r.length>1){const d=r.indexOf(C);if(d>=0){const f=T(I);if(f)return(0,A.join)(f,r[d])}}}catch{}return null}e.realcaseSync=T;async function D(S){if(u.isLinux)return S;const I=(0,A.dirname)(S);if(S===I)return S;const C=((0,A.basename)(S)||S).toLowerCase();try{const r=(await P.Promises.readdir(I)).filter(d=>d.toLowerCase()===C);if(r.length===1){const d=await D(I);if(d)return(0,A.join)(d,r[0])}else if(r.length>1){const d=r.indexOf(C);if(d>=0){const f=await D(I);if(f)return(0,A.join)(f,r[d])}}}catch{}return null}e.realcase=D;async function g(S){try{return await P.Promises.realpath(S)}catch{const C=k(S);return await P.Promises.access(C,c.constants.R_OK),C}}e.realpath=g;function L(S){try{return c.realpathSync(S)}catch{const C=k(S);return c.accessSync(C,c.constants.R_OK),C}}e.realpathSync=L;function k(S){return(0,R.rtrim)((0,A.normalize)(S),A.sep)}}),define(De[117],Ce([1,0,12,11,36,110,10,29]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function D(k=u.env){return k.comspec||"cmd.exe"}e.getWindowsShell=D;function g(k){let S=[],I=!1;const C=function(E){if(I){S.push(E);return}(!k.send(E,d=>{if(d&&console.error(d),I=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(w=>C(w))}})||A.isWindows)&&(I=!0)};return{send:C}}e.createQueuedSender=g;var L;(function(k){async function S(I,C,E){if(c.isAbsolute(I))return I;if(C===void 0&&(C=u.cwd()),c.dirname(I)!=="."||(E===void 0&&P.isString(u.env.PATH)&&(E=u.env.PATH.split(c.delimiter)),E===void 0||E.length===0))return c.join(C,I);async function d(f){if(await T.Promises.exists(f)){let w;try{w=await T.Promises.stat(f)}catch(y){y.message.startsWith("EACCES")&&(w=await T.Promises.lstat(f))}return w?!w.isDirectory():!1}return!1}for(const f of E){let w;if(c.isAbsolute(f)?w=c.join(f,I):w=c.join(C,f,I),await d(w))return w;let y=w+".com";if(await d(y)||(y=w+".exe",await d(y)))return y}return c.join(C,I)}k.findExecutable=S})(L=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(re,e,c,A){var u=arguments.length,R=u<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,c):A,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,c,A);else for(var T=re.length-1;T>=0;T--)(P=re[T])&&(R=(u<3?P(R):u>3?P(e,c,R):P(e,c))||R);return u>3&&R&&Object.defineProperty(e,c,R),R};define(De[118],Ce([1,0,17,19,22,21,62,9,3,6,70,8,10]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(I||(I={}));function C(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(E||(E={}));function r(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(d||(d={}));function f(ie){let V=0;for(let J=0;;J+=7){const ne=ie.read(1);if(V|=(ne.buffer[0]&127)<<J,!(ne.buffer[0]&128))return V}}const w=s(0);function y(ie,V){if(V===0){ie.write(w);return}let J=0;for(let ve=V;ve!==0;ve=ve>>>7)J++;const ne=u.VSBuffer.alloc(J);for(let ve=0;V!==0;ve++)ne.buffer[ve]=V&127,V=V>>>7,V>0&&(ne.buffer[ve]|=128);ie.write(ne)}class m{constructor(V){this.b=V,this.a=0}read(V){const J=this.b.slice(this.a,this.a+V);return this.a+=J.byteLength,J}}e.BufferReader=m;class t{constructor(){this.a=[]}get buffer(){return u.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=t;var o;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(o||(o={}));function s(ie){const V=u.VSBuffer.alloc(1);return V.writeUInt8(ie,0),V}const a={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},l=typeof Buffer<"u";function v(ie,V){if(typeof V>"u")ie.write(a.Undefined);else if(typeof V=="string"){const J=u.VSBuffer.fromString(V);ie.write(a.String),y(ie,J.byteLength),ie.write(J)}else if(l&&Buffer.isBuffer(V)){const J=u.VSBuffer.wrap(V);ie.write(a.Buffer),y(ie,J.byteLength),ie.write(J)}else if(V instanceof u.VSBuffer)ie.write(a.VSBuffer),y(ie,V.byteLength),ie.write(V);else if(Array.isArray(V)){ie.write(a.Array),y(ie,V.length);for(const J of V)v(ie,J)}else if(typeof V=="number"&&(V|0)===V)ie.write(a.Uint),y(ie,V);else{const J=u.VSBuffer.fromString(JSON.stringify(V));ie.write(a.Object),y(ie,J.byteLength),ie.write(J)}}e.serialize=v;function i(ie){switch(ie.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return ie.read(f(ie)).toString();case o.Buffer:return ie.read(f(ie)).buffer;case o.VSBuffer:return ie.read(f(ie));case o.Array:{const J=f(ie),ne=[];for(let ve=0;ve<J;ve++)ne.push(i(ie));return ne}case o.Object:return JSON.parse(ie.read(f(ie)).toString());case o.Int:return f(ie)}}e.deserialize=i;class n{constructor(V,J,ne=null,ve=1e3){this.h=V,this.j=J,this.k=ne,this.l=ve,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(V,J){this.b.set(V,J),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const J=this.o([V.type]);this.k?.logOutgoing(J,0,1,r(V.type));return}case 201:case 202:case 204:case 203:{const J=this.o([V.type,V.id],V.data);this.k?.logOutgoing(J,V.id,1,r(V.type),V.data);return}}}o(V,J=void 0){const ne=new t;return v(ne,V),v(ne,J),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const J=new m(V),ne=i(J),ve=i(J),ue=ne[0];switch(ue){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}: ${ne[2]}.${ne[3]}`,ve),this.s({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ve});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}: ${ne[2]}.${ne[3]}`,ve),this.t({type:ue,id:ne[1],channelName:ne[2],name:ne[3],arg:ve});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}`),this.u({type:ue,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${C(ue)}`),this.u({type:ue,id:ne[1]})}}s(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const ne=new R.CancellationTokenSource;let ve;try{ve=J.call(this.j,V.name,V.arg,ne.token)}catch(N){ve=Promise.reject(N)}const ue=V.id;ve.then(N=>{this.m({id:ue,data:N,type:201}),this.d.delete(V.id)},N=>{N instanceof Error?this.m({id:ue,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:ue,data:N,type:203}),this.d.delete(V.id)});const ee=(0,g.toDisposable)(()=>ne.cancel());this.d.set(V.id,ee)}t(V){const J=this.b.get(V.channelName);if(!J){this.v(V);return}const ne=V.id,ue=J.listen(this.j,V.name,V.arg)(ee=>this.m({id:ne,data:ee,type:204}));this.d.set(V.id,ue)}u(V){const J=this.d.get(V.id);J&&(J.dispose(),this.d.delete(V.id))}v(V){let J=this.g.get(V.channelName);J||(J=[],this.g.set(V.channelName,J));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:V,timeoutTimer:ne})}w(V){const J=this.g.get(V);if(J){for(const ne of J)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var h;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(V,J=null){this.l=V,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new D.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=J}getChannel(V){const J=this;return{call(ne,ve,ue){return J.a?Promise.reject(new T.CancellationError):J.m(V,ne,ve,ue)},listen(ne,ve){return J.a?D.Event.None:J.o(V,ne,ve)}}}m(V,J,ne,ve=R.CancellationToken.None){const ue=this.g++,N={id:ue,type:100,channelName:V,name:J,arg:ne};if(ve.isCancellationRequested)return Promise.reject(new T.CancellationError);let K;return new Promise((me,ke)=>{if(ve.isCancellationRequested)return ke(new T.CancellationError);const Z=()=>{const ae=oe=>{switch(oe.type){case 201:this.f.delete(ue),me(oe.data);break;case 202:{this.f.delete(ue);const F=new Error(oe.data.message);F.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,F.name=oe.data.name,ke(F);break}case 203:this.f.delete(ue),ke(oe.data);break}};this.f.set(ue,ae),this.p(N)};let ce=null;this.b===d.Idle?Z():(ce=(0,A.createCancelablePromise)(ae=>this.u()),ce.then(()=>{ce=null,Z()}));const de=()=>{ce?(ce.cancel(),ce=null):this.p({id:ue,type:101}),ke(new T.CancellationError)},te=ve.onCancellationRequested(de);K=(0,g.combinedDisposable)((0,g.toDisposable)(de),te),this.d.add(K)}).finally(()=>{this.d.delete(K)})}o(V,J,ne){const ve=this.g++,ee={id:ve,type:102,channelName:V,name:J,arg:ne};let N=null;const K=new D.Emitter({onWillAddFirstListener:()=>{N=(0,A.createCancelablePromise)(me=>this.u()),N.then(()=>{N=null,this.d.add(K),this.p(ee)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(K),this.p({id:ve,type:103}))}}),le=me=>K.fire(me.data);return this.f.set(ve,le),K.event}p(V){switch(V.type){case 100:case 102:{const J=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(J,V.id,0,`${C(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const J=this.q([V.type,V.id]);this.j?.logOutgoing(J,V.id,0,C(V.type));return}}}q(V,J=void 0){const ne=new t;return v(ne,V),v(ne,J),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const J=new m(V),ne=i(J),ve=i(J),ue=ne[0];switch(ue){case 200:return this.j?.logIncoming(V.byteLength,0,0,r(ue)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,r(ue),ve),this.t({type:ne[0],id:ne[1],data:ve})}}t(V){if(V.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}Ve([P.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class p{get connections(){const V=[];return this.f.forEach(J=>V.push(J)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new D.Emitter,this.onDidAddConnection=this.g.event,this.h=new D.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:J,onDidClientDisconnect:ne})=>{D.Event.once(J.onMessage)(ue=>{const ee=new m(ue),N=i(ee),K=new n(J,N),le=new b(J);this.a.forEach((ke,Z)=>K.registerChannel(Z,ke));const me={channelServer:K,channelClient:le,ctx:N};this.f.add(me),this.g.fire(me),ne(()=>{K.dispose(),le.dispose(),this.f.delete(me),this.h.fire(me)})})})}getChannel(V,J){const ne=this;return{call(ve,ue,ee){let N;if((0,S.isFunction)(J)){const le=(0,c.getRandomElement)(ne.connections.filter(J));N=le?Promise.resolve(le):D.Event.toPromise(D.Event.filter(ne.onDidAddConnection,J))}else N=J.routeCall(ne,ve,ue);const K=N.then(le=>le.channelClient.getChannel(V));return W(K).call(ve,ue,ee)},listen(ve,ue){if((0,S.isFunction)(J))return ne.j(V,J,ve,ue);const ee=J.routeEvent(ne,ve,ue).then(N=>N.channelClient.getChannel(V));return W(ee).listen(ve,ue)}}}j(V,J,ne,ve){const ue=this;let ee=new g.DisposableStore;const N=new D.Emitter({onWillAddFirstListener:()=>{ee=new g.DisposableStore;const K=new D.EventMultiplexer,le=new Map,me=Z=>{const de=Z.channelClient.getChannel(V).listen(ne,ve),te=K.add(de);le.set(Z,te)},ke=Z=>{const ce=le.get(Z);!ce||(ce.dispose(),le.delete(Z))};ue.connections.filter(J).forEach(me),D.Event.filter(ue.onDidAddConnection,J)(me,void 0,ee),ue.onDidRemoveConnection(ke,void 0,ee),K.event(N.fire,N,ee),ee.add(K)},onDidRemoveLastListener:()=>{ee.dispose()}});return N.event}registerChannel(V,J){this.a.set(V,J),this.f.forEach(ne=>{ne.channelServer.registerChannel(V,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=p;class O{constructor(V,J,ne=null){const ve=new t;v(ve,J),V.send(ve.buffer),this.a=new b(V,ne),this.d=new n(V,J,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,J){this.d.registerChannel(V,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function W(ie){return{call(V,J,ne){return ie.then(ve=>ve.call(V,J,ne))},listen(V,J){const ne=new D.Relay;return ie.then(ve=>ne.input=ve.listen(V,J)),ne.event}}}e.getDelayedChannel=W;function q(ie){let V=!1;return{call(J,ne,ve){return V?ie.call(J,ne,ve):(0,A.timeout)(0).then(()=>V=!0).then(()=>ie.call(J,ne,ve))},listen(J,ne){if(V)return ie.listen(J,ne);const ve=new D.Relay;return(0,A.timeout)(0).then(()=>V=!0).then(()=>ve.input=ie.listen(J,ne)),ve.event}}}e.getNextTickChannel=q;class Y{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const J of V.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await D.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=Y;var x;(function(ie){function V(ue,ee){const N=ue,K=ee&&ee.disableMarshalling,le=new Map;for(const me in N)ne(me)&&le.set(me,D.Event.buffer(N[me],!0));return new class{listen(me,ke,Z){const ce=le.get(ke);if(ce)return ce;if(ve(ke)){const de=N[ke];if(typeof de=="function")return de.call(N,Z)}throw new Error(`Event not found: ${ke}`)}call(me,ke,Z){const ce=N[ke];if(typeof ce=="function"){if(!K&&Array.isArray(Z))for(let de=0;de<Z.length;de++)Z[de]=(0,L.revive)(Z[de]);return ce.apply(N,Z)}throw new Error(`Method not found: ${ke}`)}}}ie.fromService=V;function J(ue,ee){const N=ee&&ee.disableMarshalling;return new Proxy({},{get(K,le){if(typeof le=="string")return ee?.properties?.has(le)?ee.properties.get(le):ve(le)?function(me){return ue.listen(le,me)}:ne(le)?ue.listen(le):async function(...me){let ke;ee&&!(0,S.isUndefinedOrNull)(ee.context)?ke=[ee.context,...me]:ke=me;const Z=await ue.call(le,ke);return N?Z:(0,L.revive)(Z)};throw new Error(`Property not found: ${String(le)}`)}})}ie.toService=J;function ne(ue){return ue[0]==="o"&&ue[1]==="n"&&k.isUpperAsciiLetter(ue.charCodeAt(2))}function ve(ue){return/^onDynamic/.test(ue)&&k.isUpperAsciiLetter(ue.charCodeAt(9))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const V=ie.toString();if(V!=="[object Object]")return V}return ie}function U(ie){return Array.isArray(ie)?ie.map(B):B(ie)}function j(ie,V,J,ne,ve,ue,ee){ee=U(ee);const N=M[ve],K=N[ne%N.length];let le=[`%c[${ie}]%c[${String(V).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(ue)?(le=le.concat(ee),le.push(")")):le.push(ee),console.log.apply(console,le)}class he{constructor(V,J){this.d=V,this.f=J,this.a=0,this.b=0}logOutgoing(V,J,ne,ve,ue){this.b+=V,j(this.d,this.b,V,J,ne,ve,ue)}logIncoming(V,J,ne,ve,ue){this.a+=V,j(this.f,this.a,V,J,ne,ve,ue)}}e.IPCLogger=he}),define(De[119],Ce([1,0,19,22,3,6,118]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(b){b.Created="created",b.Read="read",b.Write="write",b.Open="open",b.Error="error",b.Close="close",b.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",b.NodeEndReceived="nodeEndReceived",b.NodeEndSent="nodeEndSent",b.NodeDrainBegin="nodeDrainBegin",b.NodeDrainEnd="nodeDrainEnd",b.zlibInflateError="zlibInflateError",b.zlibInflateData="zlibInflateData",b.zlibInflateInitialWrite="zlibInflateInitialWrite",b.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",b.zlibInflateWrite="zlibInflateWrite",b.zlibInflateFlushFired="zlibInflateFlushFired",b.zlibDeflateError="zlibDeflateError",b.zlibDeflateData="zlibDeflateData",b.zlibDeflateWrite="zlibDeflateWrite",b.zlibDeflateFlushFired="zlibDeflateFlushFired",b.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",b.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",b.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",b.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",b.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",b.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",b.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",b.ProtocolHeaderRead="protocolHeaderRead",b.ProtocolMessageRead="protocolMessageRead",b.ProtocolHeaderWrite="protocolHeaderWrite",b.ProtocolMessageWrite="protocolMessageWrite",b.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(b){b.enableDiagnostics=!1,b.records=[];const p=new WeakMap;let O=0;function W(Y,x){if(!p.has(Y)){const M=String(++O);p.set(Y,M)}return p.get(Y)}function q(Y,x,M,B){if(!b.enableDiagnostics)return;const U=W(Y,x);if(B instanceof A.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const j=A.VSBuffer.alloc(B.byteLength);j.set(B),b.records.push({timestamp:Date.now(),id:U,label:x,type:M,buff:j})}else b.records.push({timestamp:Date.now(),id:U,label:x,type:M,data:B})}b.traceSocketEvent=q})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(b){b[b.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",b[b.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function k(){return L||(L=A.VSBuffer.alloc(0)),L}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(p){this.a.push(p),this.b+=p.byteLength}read(p){return this.c(p,!0)}peek(p){return this.c(p,!1)}c(p,O){if(p===0)return k();if(p>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===p){const x=this.a[0];return O&&(this.a.shift(),this.b-=p),x}if(this.a[0].byteLength>p){const x=this.a[0].slice(0,p);return O&&(this.a[0]=this.a[0].slice(p),this.b-=p),x}const W=A.VSBuffer.alloc(p);let q=0,Y=0;for(;p>0;){const x=this.a[Y];if(x.byteLength>p){const M=x.slice(0,p);W.set(M,q),q+=p,O&&(this.a[Y]=x.slice(p),this.b-=p),p-=p}else W.set(x,q),q+=x.byteLength,O?(this.a.shift(),this.b-=x.byteLength):Y++,p-=x.byteLength}return W}}e.ChunkStream=S;var I;(function(b){b[b.None=0]="None",b[b.Regular=1]="Regular",b[b.Control=2]="Control",b[b.Ack=3]="Ack",b[b.Disconnect=5]="Disconnect",b[b.ReplayRequest=6]="ReplayRequest",b[b.Pause=7]="Pause",b[b.Resume=8]="Resume",b[b.KeepAlive=9]="KeepAlive",b[b.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",b[b.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(I||(I={}));function C(b){switch(b){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(b){b[b.HeaderLength=13]="HeaderLength",b[b.AcknowledgeTime=2e3]="AcknowledgeTime",b[b.TimeoutTime=2e4]="TimeoutTime",b[b.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",b[b.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",b[b.KeepAliveSendTime=5e3]="KeepAliveSendTime",b[b.LatencySampleTime=6e4]="LatencySampleTime",b[b.LatencySampleCount=5]="LatencySampleCount",b[b.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",b[b.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class r{constructor(p,O,W,q){this.type=p,this.id=O,this.ack=W,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends R.Disposable{constructor(p){super(),this.f=this.D(new u.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=p,this.b=!1,this.c=new S,this.D(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(p){if(!(!p||p.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(p);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const W=this.g.messageType,q=this.g.id,Y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new r(W,q,Y,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(p){this.k=null,this.a=!1,this.b=!1,this.c=p,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(p){if(this.a)return;p.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=A.VSBuffer.alloc(13);O.writeUInt8(p.type,0),O.writeUInt32BE(p.id,1),O.writeUInt32BE(p.ack,5),O.writeUInt32BE(p.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(p.type),id:p.id,ack:p.ack,messageSize:p.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",p.data),this.j(O,p.data)}g(p,O){const W=this.f===0;return this.d.push(p,O),this.f+=p.byteLength+O.byteLength,W}h(){const p=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,p}j(p,O){this.g(p,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const p=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:p.byteLength}),this.c.write(p)}}class w extends R.Disposable{constructor(p){super(),this.f=new u.Emitter,this.onMessage=this.f.event,this.g=new u.Emitter,this.onDidDispose=this.g.event,this.a=p,this.b=this.D(new f(this.a)),this.c=this.D(new d(this.a)),this.D(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.D(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(p){this.b.write(new r(1,0,0,p))}}e.Protocol=w;class y extends P.IPCClient{static fromSocket(p,O){return new y(new w(p),O)}get onDidDispose(){return this.b.onDidDispose}constructor(p,O,W=null){super(p,O,W),this.b=p}dispose(){super.dispose();const p=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),p.end()}}e.Client=y;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(p){this.b?this.d.length>0?this.d.push(p):this.a.fire(p):this.d.push(p)}flushBuffer(){this.d=[]}}e.BufferedEmitter=m;class t{constructor(p){this.data=p,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let p=0,O=this.a;for(;O;)O=O.next,p++;return p}peek(){return this.a?this.a.data:null}toArray(){const p=[];let O=0,W=this.a;for(;W;)p[O++]=W.data,W=W.next;return p}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(p){const O=new t(p);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const p=Date.now();for(let O=0;O<s.a;O++)this.c[O]=p-1e3*O;setInterval(()=>{for(let O=s.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const p=Date.now(),O=(1+s.a)*1e3;let W=0;for(let q=0;q<s.a;q++)p-this.c[q]<=O&&W++;return 1-W/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var a;(function(b){b[b.Good=0]="Good",b[b.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function l(b){switch(b){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class v{constructor(p){this.connectionHealth=p}}e.ConnectionHealthChangedEvent=v;class i{constructor(p,O){this.roundTripTime=p,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=i;class n{get unacknowledgedCount(){return this.c-this.d}constructor(p){this.x=new m,this.onControlMessage=this.x.event,this.y=new m,this.onMessage=this.y.event,this.z=new m,this.onDidDispose=this.z.event,this.A=new m,this.onSocketClose=this.A.event,this.B=new m,this.onSocketTimeout=this.B.event,this.C=new m,this.onHighRoundTripTime=this.C.event,this.D=new m,this.onDidChangeConnectionHealth=this.D.event,this.u=p.loadEstimator??s.getInstance(),this.v=p.measureRoundTripTime??!1,this.w=p.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=p.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),p.initialChunk&&this.q.acceptChunk(p.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const p=new r(5,0,0,k());this.p.write(p),this.p.flush()}sendPause(){const p=new r(7,0,0,k());this.p.write(p)}sendResume(){const p=new r(8,0,0,k());this.p.write(p)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(p,O){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=p,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(W=>this.E(W))),this.t.add(this.o.onClose(W=>this.A.fire(W))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(W=>this.J(W))),this.t.add(this.r.onHighRoundTripTime(W=>this.C.fire(W))),this.t.add(this.r.onDidChangeConnectionHealth(W=>this.D.fire(W))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const p=new r(3,0,this.h,k());this.p.write(p);const O=this.b.toArray();for(let W=0,q=O.length;W<q;W++)this.p.write(O[W]);this.G()}acceptDisconnect(){this.z.fire()}E(p){if(p.ack>this.d){this.d=p.ack;do{const O=this.b.peek();if(O&&O.id<=p.ack)this.b.pop();else break}while(!0)}switch(p.type){case 0:break;case 1:{if(p.id>this.g)if(p.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new r(6,0,0,k())))}else this.g=p.id,this.j=Date.now(),this.F(),this.y.fire(p.data);break}case 2:{this.x.fire(p.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let W=0,q=O.length;W<q;W++)this.p.write(O[W]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(p.data);break}case 11:{this.r.handleResponse(p.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(p){const O=++this.c;this.h=this.g;const W=new r(1,O,this.h,p);this.b.push(W),this.a||(this.p.write(W),this.G())}sendControl(p){const O=new r(2,0,0,p);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const p=Date.now()-this.j;if(p>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-p+5)}G(){if(this.c<=this.d||this.f||this.a)return;const p=this.b.peek(),O=Date.now()-p.writtenTime,W=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(O>=2e4&&W>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:W});return}const Y=Math.max(2e4-O,2e4-W,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},Y)}H(){if(this.g<=this.h)return;this.h=this.g;const p=new r(3,0,this.h,k());this.p.write(p)}I(){this.h=this.g;const p=new r(9,0,this.h,k());this.p.write(p)}J(p){this.h=this.g;const O=new r(10,0,this.h,p);this.p.write(O)}K(p){this.h=this.g;const O=new r(11,0,this.h,p);this.p.write(O)}}e.PersistentProtocol=n;class h extends R.Disposable{constructor(){super(),this.a=this.D(new u.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.D(new u.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.D(new u.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.D(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},p=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const p=++this.h,O=A.VSBuffer.alloc(4);O.writeUInt32BE(p,0),this.a.fire(O)},6e4)}handleResponse(p){if(p.byteLength!==4)return;const O=p.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const W=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=W;const Y=this.l,x=this.j.filter(M=>M>=1e3).length;this.l=x>=3?1:0,W>1e3&&this.b.fire(new i(W,x)),Y!==this.l&&this.c.fire(this.l)}}}),define(De[120],Ce([1,0,22,9,3,6,12,11,30,118,119]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class S{traceSocketEvent(i,n){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,n)}constructor(i,n=""){this.f=!0,this.debugLabel=n,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,A.onUnexpectedError)(h)}},this.socket.on("error",this.a),this.b=h=>{this.traceSocketEvent("close",{hadError:h}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const n=h=>{this.traceSocketEvent("read",h),i(c.VSBuffer.wrap(h))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(i){const n=h=>{i({type:0,hadError:h,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(i){const n=()=>{i()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,A.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,A.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=S;var I;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(I||(I={}));var C;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(C||(C={}));class E extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,n){this.socket.traceSocketEvent(i,n)}constructor(i,n,h,b){super(),this.f=this.D(new u.Emitter),this.g=this.D(new u.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:h?.byteLength||0,recordInflateBytes:b}),this.a=this.D(new r(this,n,h,b,this.f,(p,O)=>this.k(p,O))),this.D(this.a.onError(p=>{console.error(p),(0,A.onUnexpectedError)(p),this.g.fire({type:0,hadError:!0,error:p})})),this.b=new L.ChunkStream,this.D(this.socket.onData(p=>this.l(p))),this.D(this.socket.onClose(async p=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(p)}))}dispose(){this.a.isProcessingWriteQueue()?this.D(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let n=0;for(;n<i.byteLength;)this.a.writeMessage(i.slice(n,Math.min(n+262144,i.byteLength))),n+=262144}k(i,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let h=2;i.byteLength<126?h+=0:i.byteLength<2**16?h+=2:h+=8;const b=c.VSBuffer.alloc(h);if(n?b.writeUInt8(194,0):b.writeUInt8(130,0),i.byteLength<126)b.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){b.writeUInt8(126,1);let p=1;b.writeUInt8(i.byteLength>>>8&255,++p),b.writeUInt8(i.byteLength>>>0&255,++p)}else{b.writeUInt8(127,1);let p=1;b.writeUInt8(0,++p),b.writeUInt8(0,++p),b.writeUInt8(0,++p),b.writeUInt8(0,++p),b.writeUInt8(i.byteLength>>>24&255,++p),b.writeUInt8(i.byteLength>>>16&255,++p),b.writeUInt8(i.byteLength>>>8&255,++p),b.writeUInt8(i.byteLength>>>0&255,++p)}this.socket.write(c.VSBuffer.concat([b,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),h=n.readUInt8(0),b=(h&128)>>>7,p=(h&64)>>>6,O=n.readUInt8(1),W=(O&128)>>>7,q=O&127;this.j.state=2,this.j.readLen=2+(W?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=b,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(p)),this.j.firstFrameOfMessage=Boolean(b),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),h=n.readUInt8(1),b=(h&128)>>>7;let p=h&127,O=1;p===126?p=n.readUInt8(++O)*2**8+n.readUInt8(++O):p===127&&(p=n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*2**24+n.readUInt8(++O)*2**16+n.readUInt8(++O)*2**8+n.readUInt8(++O));let W=0;b&&(W=n.readUInt8(++O)*2**24+n.readUInt8(++O)*2**16+n.readUInt8(++O)*2**8+n.readUInt8(++O)),this.j.state=3,this.j.readLen=p,this.j.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),w(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class r extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(i,n,h,b,p,O){super(),this.l=i,this.m=p,this.n=O,this.a=this.D(new u.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.D(new u.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.D(new u.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.s=!1,n?(this.b=this.D(new d(this.l,b,h,{windowBits:15})),this.f=this.D(new f(this.l,{windowBits:15})),this.D(this.b.onError(W=>this.a.fire(W))),this.D(this.f.onError(W=>this.a.fire(W)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.q()}async q(){if(!this.p){for(this.p=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const n=await this.r(this.f,i);this.n(n,!0)}else this.n(i,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}r(i,n){return new Promise((h,b)=>{i.write(n),i.flush(p=>h(p))})}acceptFrame(i,n,h){this.h.push({data:i,isCompressed:n,isLastFrameOfMessage:h}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const n=await this.u(this.b,i.data,i.isLastFrameOfMessage);this.m.fire(n)}else this.m.fire(i.data)}this.s=!1,this.j.fire()}}isProcessingReadQueue(){return this.s}u(i,n,h){return new Promise((b,p)=>{i.write(n),h&&i.write(c.VSBuffer.fromByteArray([0,0,255,255])),i.flush(O=>b(O))})}}class d extends R.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(i,n,h,b){super(),this.h=i,this.j=n,this.a=this.D(new u.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(b),this.b.on("error",p=>{this.h.traceSocketEvent("zlibInflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.h.traceSocketEvent("zlibInflateData",p),this.g.push(c.VSBuffer.wrap(p))}),h&&(this.h.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this.b.write(h.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=c.VSBuffer.concat(this.g);this.g.length=0,i(n)})}}class f extends R.Disposable{constructor(i,n){super(),this.g=i,this.a=this.D(new u.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",h=>{this.g.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this.a.fire(h)}),this.b.on("data",h=>{this.g.traceSocketEvent("zlibDeflateData",h),this.f.push(c.VSBuffer.wrap(h))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=c.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),i(n)})}}function w(v,i){if(i===0)return;const n=v.byteLength>>>2;for(let q=0;q<n;q++){const Y=v.readUInt32BE(q*4);v.writeUInt32BE(Y^i,q*4)}const h=n*4,b=v.byteLength-h,p=i>>>24&255,O=i>>>16&255,W=i>>>8&255;b>=1&&v.writeUInt8(v.readUInt8(h)^p,h),b>=2&&v.writeUInt8(v.readUInt8(h+1)^O,h+1),b>=3&&v.writeUInt8(v.readUInt8(h+2)^W,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const y={[2]:107,[1]:103};function m(){const v=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const i=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:k().os.tmpdir(),n=(0,P.join)(i,`vscode-ipc-${v}.sock`);return o(n),n}e.createRandomIPCHandle=m;function t(v,i,n){const h=k().crypto.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${n}-${i}-sock`;const b=n.substr(0,4),p=i.substr(0,6),O=h.substr(0,8);let W;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${O}-${b}-${p}.sock`):W=(0,P.join)(v,`${b}-${p}.sock`),o(W),W}e.createStaticIPCHandle=t;function o(v){const i=y[T.platform];typeof i=="number"&&v.length>=i&&console.warn(`WARNING: IPC handle "${v}" is longer than ${i} chars, try a shorter --user-data-dir`)}class s extends g.IPCServer{static b(i){const n=u.Event.fromNodeEventEmitter(i,"connection");return u.Event.map(n,h=>({protocol:new L.Protocol(new S(h,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(h,"close"))}))}constructor(i){super(s.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=s;function a(v){return new Promise((i,n)=>{const h=k().net.createServer();h.on("error",n),h.listen(v,()=>{h.removeListener("error",n),i(new s(h))})})}e.serve=a;function l(v,i){return new Promise((n,h)=>{const b=k().net.createConnection(v,()=>{b.removeListener("error",h),n(L.Client.fromSocket(new S(b,`ipc-client${i}`),i))});b.once("error",h)})}e.connect=l}),define(De[165],Ce([1,0,38,12]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(R,P,T,D,g,L){if(Array.isArray(R)){let k=0;for(const S of R){const I=u(S,P,T,D,g,L);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof R=="string")return D?R==="*"?5:R===T?10:0:0;if(R){const{language:k,pattern:S,scheme:I,hasAccessToAllModels:C,notebookType:E}=R;if(!D&&!C)return 0;E&&g&&(P=g);let r=0;if(I)if(I===P.scheme)r=10;else if(I==="*")r=5;else return 0;if(k)if(k===T)r=10;else if(k==="*")r=Math.max(r,5);else return 0;if(E)if(E===L)r=10;else if(E==="*"&&L!==void 0)r=Math.max(r,5);else return 0;if(S){let d;if(typeof S=="string"?d=S:d={...S,base:(0,A.normalize)(S.base)},d===P.fsPath||(0,c.match)(d,P.fsPath))r=10;else return 0}return r}else return 0}}e.score=u}),define(De[166],Ce([1,0,8,53,156]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(T,D,g,L){this.c=T,this.d=D,this.f=g,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const D=T.changes;for(const g of D)this.n(g.range),this.o(new A.Position(g.range.startLineNumber,g.range.startColumn),g.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,D=this.d.length,g=new Uint32Array(D);for(let L=0;L<D;L++)g[L]=this.d[L].length+T;this.h=new u.PrefixSumComputer(g)}}l(T,D){this.d[T]=D,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,D){if(D.length===0)return;const g=(0,c.splitLines)(D);if(g.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+g[0]+this.d[T.lineNumber-1].substring(T.column-1));return}g[g.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+g[0]);const L=new Uint32Array(g.length-1);for(let k=1;k<g.length;k++)this.d.splice(T.lineNumber+k-1,0,g[k]),L[k-1]=g[k].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,L)}}e.MirrorTextModel=R}),define(De[167],Ce([1,0,8,153,53,32,108]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class D{constructor(f,w,y,m){this.searchString=f,this.isRegex=w,this.matchCase=y,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=g(this.searchString):f=this.searchString.indexOf(`
`)>=0;let w=null;try{w=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!w)return null;let y=!this.isRegex&&!f;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new P.SearchData(w,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=D;function g(d){if(!d||d.length===0)return!1;for(let f=0,w=d.length;f<w;f++){const y=d.charCodeAt(f);if(y===10)return!0;if(y===92){if(f++,f>=w)break;const m=d.charCodeAt(f);if(m===110||m===114||m===87)return!0}}return!1}e.isMultilineRegexSource=g;function L(d,f,w){if(!w)return new P.FindMatch(d,null);const y=[];for(let m=0,t=f.length;m<t;m++)y[m]=f[m];return new P.FindMatch(d,y)}e.createFindMatch=L;class k{constructor(f){const w=[];let y=0;for(let m=0,t=f.length;m<t;m++)f.charCodeAt(m)===10&&(w[y++]=m);this.a=w}findLineFeedCountBeforeOffset(f){const w=this.a;let y=0,m=w.length-1;if(m===-1||f<=w[0])return 0;for(;y<m;){const t=y+((m-y)/2>>0);w[t]>=f?m=t-1:w[t+1]>=f?(y=t,m=t):y=t+1}return y+1}}class S{static findMatches(f,w,y,m,t){const o=w.parseSearchRequest();return o?o.regex.multiline?this.b(f,y,new r(o.wordSeparators,o.regex),m,t):this.c(f,y,o,m,t):[]}static a(f,w,y,m,t,o){let s,a=0;m?(a=m.findLineFeedCountBeforeOffset(t),s=w+t+a):s=w+t;let l;if(m){const h=m.findLineFeedCountBeforeOffset(t+o.length)-a;l=s+o.length+h}else l=s+o.length;const v=f.getPositionAt(s),i=f.getPositionAt(l);return new R.Range(v.lineNumber,v.column,i.lineNumber,i.column)}static b(f,w,y,m,t){const o=f.getOffsetAt(w.getStartPosition()),s=f.getValueInRange(w,1),a=f.getEOL()===`\r
`?new k(s):null,l=[];let v=0,i;for(y.reset(0);i=y.next(s);)if(l[v++]=L(this.a(f,o,s,a,i.index,i[0]),i,m),v>=t)return l;return l}static c(f,w,y,m,t){const o=[];let s=0;if(w.startLineNumber===w.endLineNumber){const l=f.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return s=this.d(y,l,w.startLineNumber,w.startColumn-1,s,o,m,t),o}const a=f.getLineContent(w.startLineNumber).substring(w.startColumn-1);s=this.d(y,a,w.startLineNumber,w.startColumn-1,s,o,m,t);for(let l=w.startLineNumber+1;l<w.endLineNumber&&s<t;l++)s=this.d(y,f.getLineContent(l),l,0,s,o,m,t);if(s<t){const l=f.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);s=this.d(y,l,w.endLineNumber,0,s,o,m,t)}return o}static d(f,w,y,m,t,o,s,a){const l=f.wordSeparators;if(!s&&f.simpleSearch){const n=f.simpleSearch,h=n.length,b=w.length;let p=-h;for(;(p=w.indexOf(n,p+h))!==-1;)if((!l||E(l,w,b,p,h))&&(o[t++]=new P.FindMatch(new R.Range(y,p+1+m,y,p+1+h+m),null),t>=a))return t;return t}const v=new r(f.wordSeparators,f.regex);let i;v.reset(0);do if(i=v.next(w),i&&(o[t++]=L(new R.Range(y,i.index+1+m,y,i.index+1+i[0].length+m),i,s),t>=a))return t;while(i);return t}static findNextMatch(f,w,y,m){const t=w.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.e(f,y,o,m):this.f(f,y,o,m)}static e(f,w,y,m){const t=new u.Position(w.lineNumber,1),o=f.getOffsetAt(t),s=f.getLineCount(),a=f.getValueInRange(new R.Range(t.lineNumber,t.column,s,f.getLineMaxColumn(s)),1),l=f.getEOL()===`\r
`?new k(a):null;y.reset(w.column-1);const v=y.next(a);return v?L(this.a(f,o,a,l,v.index,v[0]),v,m):w.lineNumber!==1||w.column!==1?this.e(f,new u.Position(1,1),y,m):null}static f(f,w,y,m){const t=f.getLineCount(),o=w.lineNumber,s=f.getLineContent(o),a=this.g(y,s,o,w.column,m);if(a)return a;for(let l=1;l<=t;l++){const v=(o+l-1)%t,i=f.getLineContent(v+1),n=this.g(y,i,v+1,1,m);if(n)return n}return null}static g(f,w,y,m,t){f.reset(m-1);const o=f.next(w);return o?L(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,t):null}static findPreviousMatch(f,w,y,m){const t=w.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.h(f,y,o,m):this.j(f,y,o,m)}static h(f,w,y,m){const t=this.b(f,new R.Range(1,1,w.lineNumber,w.column),y,m,10*T);if(t.length>0)return t[t.length-1];const o=f.getLineCount();return w.lineNumber!==o||w.column!==f.getLineMaxColumn(o)?this.h(f,new u.Position(o,f.getLineMaxColumn(o)),y,m):null}static j(f,w,y,m){const t=f.getLineCount(),o=w.lineNumber,s=f.getLineContent(o).substring(0,w.column-1),a=this.k(y,s,o,m);if(a)return a;for(let l=1;l<=t;l++){const v=(t+o-l-1)%t,i=f.getLineContent(v+1),n=this.k(y,i,v+1,m);if(n)return n}return null}static k(f,w,y,m){let t=null,o;for(f.reset(0);o=f.next(w);)t=L(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,m);return t}}e.TextModelSearch=S;function I(d,f,w,y,m){if(y===0)return!0;const t=f.charCodeAt(y-1);if(d.get(t)!==0||t===13||t===10)return!0;if(m>0){const o=f.charCodeAt(y);if(d.get(o)!==0)return!0}return!1}function C(d,f,w,y,m){if(y+m===w)return!0;const t=f.charCodeAt(y+m);if(d.get(t)!==0||t===13||t===10)return!0;if(m>0){const o=f.charCodeAt(y+m-1);if(d.get(o)!==0)return!0}return!1}function E(d,f,w,y,m){return I(d,f,w,y,m)&&C(d,f,w,y,m)}e.isValidMatch=E;class r{constructor(f,w){this._wordSeparators=f,this.a=w,this.b=-1,this.c=0}reset(f){this.a.lastIndex=f,this.b=-1,this.c=0}next(f){const w=f.length;let y;do{if(this.b+this.c===w||(y=this.a.exec(f),!y))return null;const m=y.index,t=y[0].length;if(m===this.b&&t===this.c){if(t===0){c.getNextCodePoint(f,w,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=m,this.c=t,!this._wordSeparators||E(this._wordSeparators,f,w,m,t))return y}while(y);return null}}e.Searcher=r}),define(De[121],Ce([1,0,22,11]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(u||(u={}));function R(k){for(let S=0,I=k.length;S<I;S+=4){const C=k[S+0],E=k[S+1],r=k[S+2],d=k[S+3];k[S+0]=d,k[S+1]=r,k[S+2]=E,k[S+3]=C}}function P(k){const S=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return A.isLittleEndian()||R(S),c.VSBuffer.wrap(S)}function T(k){const S=k.buffer;if(A.isLittleEndian()||R(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const I=new Uint8Array(S.byteLength);return I.set(S),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function D(k){const S=new Uint32Array(g(k));let I=0;if(S[I++]=k.id,k.type==="full")S[I++]=1,S[I++]=k.data.length,S.set(k.data,I),I+=k.data.length;else{S[I++]=2,S[I++]=k.deltas.length;for(const C of k.deltas)S[I++]=C.start,S[I++]=C.deleteCount,C.data?(S[I++]=C.data.length,S.set(C.data,I),I+=C.data.length):S[I++]=0}return P(S)}e.encodeSemanticTokensDto=D;function g(k){let S=0;if(S+=1+1,k.type==="full")S+=1+k.data.length;else{S+=1,S+=(1+1+1)*k.deltas.length;for(const I of k.deltas)I.data&&(S+=I.data.length)}return S}function L(k){const S=T(k);let I=0;const C=S[I++];if(S[I++]===1){const f=S[I++],w=S.subarray(I,I+f);return I+=f,{id:C,type:"full",data:w}}const r=S[I++],d=[];for(let f=0;f<r;f++){const w=S[I++],y=S[I++],m=S[I++];let t;m>0&&(t=S.subarray(I,I+m),I+=m),d[f]={start:w,deleteCount:y,data:t}}return{id:C,type:"delta",deltas:d}}e.decodeSemanticTokensDto=L}),define(De[168],Ce([1,0,3,6]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,D){return this.a.set(T,D),this.fire([T]),(0,A.toDisposable)(()=>{this.a.get(T)===D&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,D){this.b.get(T)?.dispose();const g=new R(this,T,D);return this.b.set(T,g),(0,A.toDisposable)(()=>{const L=this.b.get(T);!L||L!==g||(this.b.delete(T),L.dispose())})}async getOrCreate(T){const D=this.get(T);if(D)return D;const g=this.b.get(T);return!g||g.isResolved?null:(await g.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const g=this.b.get(T);return!!(!g||g.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=u;class R extends A.Disposable{get isResolved(){return this.c}constructor(T,D,g){super(),this.f=T,this.g=D,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.D(this.f.register(this.g,T))}}}),define(De[72],Ce([1,0,67,2,32,168]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class P{constructor(h,b,p){this.offset=h,this.type=b,this.language=p,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=P;class T{constructor(h,b){this.tokens=h,this.endState=b,this._tokenizationResultBrand=void 0}}e.TokenizationResult=T;class D{constructor(h,b){this.tokens=h,this.endState=b,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=D;var g;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(n){const h=new Map;h.set(0,c.Codicon.symbolMethod),h.set(1,c.Codicon.symbolFunction),h.set(2,c.Codicon.symbolConstructor),h.set(3,c.Codicon.symbolField),h.set(4,c.Codicon.symbolVariable),h.set(5,c.Codicon.symbolClass),h.set(6,c.Codicon.symbolStruct),h.set(7,c.Codicon.symbolInterface),h.set(8,c.Codicon.symbolModule),h.set(9,c.Codicon.symbolProperty),h.set(10,c.Codicon.symbolEvent),h.set(11,c.Codicon.symbolOperator),h.set(12,c.Codicon.symbolUnit),h.set(13,c.Codicon.symbolValue),h.set(15,c.Codicon.symbolEnum),h.set(14,c.Codicon.symbolConstant),h.set(15,c.Codicon.symbolEnum),h.set(16,c.Codicon.symbolEnumMember),h.set(17,c.Codicon.symbolKeyword),h.set(27,c.Codicon.symbolSnippet),h.set(18,c.Codicon.symbolText),h.set(19,c.Codicon.symbolColor),h.set(20,c.Codicon.symbolFile),h.set(21,c.Codicon.symbolReference),h.set(22,c.Codicon.symbolCustomColor),h.set(23,c.Codicon.symbolFolder),h.set(24,c.Codicon.symbolTypeParameter),h.set(25,c.Codicon.account),h.set(26,c.Codicon.issues);function b(W){let q=h.get(W);return q||(console.info("No codicon found for CompletionItemKind "+W),q=c.Codicon.symbolProperty),q}n.toIcon=b;const p=new Map;p.set("method",0),p.set("function",1),p.set("constructor",2),p.set("field",3),p.set("variable",4),p.set("class",5),p.set("struct",6),p.set("interface",7),p.set("module",8),p.set("property",9),p.set("event",10),p.set("operator",11),p.set("unit",12),p.set("value",13),p.set("constant",14),p.set("enum",15),p.set("enum-member",16),p.set("enumMember",16),p.set("keyword",17),p.set("snippet",27),p.set("text",18),p.set("color",19),p.set("file",20),p.set("reference",21),p.set("customcolor",22),p.set("folder",23),p.set("type-parameter",24),p.set("typeParameter",24),p.set("account",25),p.set("issue",26);function O(W,q){let Y=p.get(W);return typeof Y>"u"&&!q&&(Y=9),Y}n.fromString=O})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var E;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var r;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(r=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(n){return n&&A.URI.isUri(n.uri)&&u.Range.isIRange(n.range)&&(u.Range.isIRange(n.originSelectionRange)||u.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=f;var w;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(w=e.SymbolKind||(e.SymbolKind={}));var y;(function(n){n[n.Deprecated=1]="Deprecated"})(y=e.SymbolTag||(e.SymbolTag={}));var m;(function(n){const h=new Map;h.set(0,c.Codicon.symbolFile),h.set(1,c.Codicon.symbolModule),h.set(2,c.Codicon.symbolNamespace),h.set(3,c.Codicon.symbolPackage),h.set(4,c.Codicon.symbolClass),h.set(5,c.Codicon.symbolMethod),h.set(6,c.Codicon.symbolProperty),h.set(7,c.Codicon.symbolField),h.set(8,c.Codicon.symbolConstructor),h.set(9,c.Codicon.symbolEnum),h.set(10,c.Codicon.symbolInterface),h.set(11,c.Codicon.symbolFunction),h.set(12,c.Codicon.symbolVariable),h.set(13,c.Codicon.symbolConstant),h.set(14,c.Codicon.symbolString),h.set(15,c.Codicon.symbolNumber),h.set(16,c.Codicon.symbolBoolean),h.set(17,c.Codicon.symbolArray),h.set(18,c.Codicon.symbolObject),h.set(19,c.Codicon.symbolKey),h.set(20,c.Codicon.symbolNull),h.set(21,c.Codicon.symbolEnumMember),h.set(22,c.Codicon.symbolStruct),h.set(23,c.Codicon.symbolEvent),h.set(24,c.Codicon.symbolOperator),h.set(25,c.Codicon.symbolTypeParameter);function b(p){let O=h.get(p);return O||(console.info("No codicon found for SymbolKind "+p),O=c.Codicon.symbolProperty),O}n.toIcon=b})(m=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(h){switch(h){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(h)}constructor(h){this.value=h}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var o;(function(n){function h(b){return!b||typeof b!="object"?!1:typeof b.id=="string"&&typeof b.title=="string"}n.is=h})(o=e.Command||(e.Command={}));var s;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var v;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(v=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var i;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[169],Ce([14,15]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(De[122],Ce([1,0,169,11,107,17,23,152]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function($){$[$.None=0]="None",$[$.Keep=1]="Keep",$[$.Brackets=2]="Brackets",$[$.Advanced=3]="Advanced",$[$.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=g;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor(Q,ge,Le,Ne){this.id=Q,this.name=ge,this.defaultValue=Le,this.schema=Ne}applyUpdate(Q,ge){return I(Q,ge)}compute(Q,ge,Le){return Le}}class S{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=S;function I($,Q){if(typeof $!="object"||typeof Q!="object"||!$||!Q)return new S(Q,$!==Q);if(Array.isArray($)||Array.isArray(Q)){const Le=Array.isArray($)&&Array.isArray(Q)&&R.equals($,Q);return new S(Q,!Le)}let ge=!1;for(const Le in Q)if(Q.hasOwnProperty(Le)){const Ne=I($[Le],Q[Le]);Ne.didChange&&($[Le]=Ne.newValue,ge=!0)}return new S($,ge)}class C{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return I(Q,ge)}validate(Q){return this.defaultValue}}class E{constructor(Q,ge,Le,Ne){this.id=Q,this.name=ge,this.defaultValue=Le,this.schema=Ne}applyUpdate(Q,ge){return I(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Le){return Le}}function r($,Q){return typeof $>"u"?Q:$==="false"?!1:Boolean($)}e.boolean=r;class d extends E{constructor(Q,ge,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(Q,ge,Le,Ne)}validate(Q){return r(Q,this.defaultValue)}}function f($,Q,ge,Le){if(typeof $>"u")return Q;let Ne=parseInt($,10);return isNaN(Ne)?Q:(Ne=Math.max(ge,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=f;class w extends E{static clampedInt(Q,ge,Le,Ne){return f(Q,ge,Le,Ne)}constructor(Q,ge,Le,Ne,je,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Le,Ye.minimum=Ne,Ye.maximum=je),super(Q,ge,Le,Ye),this.minimum=Ne,this.maximum=je}validate(Q){return w.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class y extends E{static clamp(Q,ge,Le){return Q<ge?ge:Q>Le?Le:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Le=parseFloat(Q);return isNaN(Le)?ge:Le}constructor(Q,ge,Le,Ne,je){typeof je<"u"&&(je.type="number",je.default=Le),super(Q,ge,Le,je),this.validationFn=Ne}validate(Q){return this.validationFn(y.float(Q,this.defaultValue))}}class m extends E{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(Q,ge,Le,Ne)}validate(Q){return m.string(Q,this.defaultValue)}}function t($,Q,ge){return typeof $!="string"||ge.indexOf($)===-1?Q:$}e.stringSet=t;class o extends E{constructor(Q,ge,Le,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Ne,je.default=Le),super(Q,ge,Le,je),this.c=Ne}validate(Q){return t(Q,this.defaultValue,this.c)}}class s extends k{constructor(Q,ge,Le,Ne,je,Ye,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=Ne),super(Q,ge,Le,Xe),this.c=je,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function a($){switch($){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Le){return Le===0?Q.accessibilitySupport:Le}}class v extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:c.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:r(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function($){$[$.Hidden=0]="Hidden",$[$.Blink=1]="Blink",$[$.Smooth=2]="Smooth",$[$.Phase=3]="Phase",$[$.Expand=4]="Expand",$[$.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n($){switch($){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function($){$[$.Line=1]="Line",$[$.Block=2]="Block",$[$.Underline=3]="Underline",$[$.LineThin=4]="LineThin",$[$.BlockOutline=5]="BlockOutline",$[$.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b($){switch($){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function p($){switch($){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class O extends C{constructor(){super(135)}compute(Q,ge,Le){const Ne=["monaco-editor"];return ge.get(36)&&Ne.push(ge.get(36)),Q.extraEditorClassName&&Ne.push(Q.extraEditorClassName),ge.get(70)==="default"?Ne.push("mouse-default"):ge.get(70)==="copy"&&Ne.push("mouse-copy"),ge.get(105)&&Ne.push("showUnused"),ge.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class W extends d{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(Q,ge,Le){return Le&&Q.emptySelectionClipboard}}class q extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:c.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:c.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:r(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(ge.loop,this.defaultValue.loop)}}}class Y extends k{constructor(){super(48,"fontLigatures",Y.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?Y.OFF:Q==="true"?Y.ON:Q:Boolean(Q)?Y.ON:Y.OFF}}Y.OFF='"liga" off, "calt" off',Y.ON='"liga" on, "calt" on',e.EditorFontLigatures=Y;class x extends k{constructor(){super(51,"fontVariations",x.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?x.OFF:Q==="true"?x.TRANSLATE:Q:Boolean(Q)?x.TRANSLATE:x.OFF}compute(Q,ge,Le){return Q.fontInfo.fontVariationSettings}}x.OFF="normal",x.TRANSLATE="translate",e.EditorFontVariations=x;class M extends C{constructor(){super(47)}compute(Q,ge,Le){return Q.fontInfo}}class B extends E{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(Q){const ge=y.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(ge,6,100)}compute(Q,ge,Le){return Q.fontInfo.fontSize}}class U extends k{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(w.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class j extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:c.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:t(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??t(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??t(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??t(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??t(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??t(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends k{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:c.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),delay:w.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:r(ge.sticky,this.defaultValue.sticky),above:r(ge.above,this.defaultValue.above)}}}var ie;(function($){$[$.None=0]="None",$[$.Text=1]="Text",$[$.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class V extends C{constructor(){super(138)}compute(Q,ge,Le){return V.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Le=Math.floor(Q.paddingTop/Q.lineHeight);let Ne=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Ne=Math.max(Ne,ge-1));const je=(Le+Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:Ye}}static c(Q,ge){const Le=Q.outerWidth,Ne=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Ye=ge.stableMinimapLayoutInput,Xe=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,nt=Q.lineHeight,ot=Q.typicalHalfwidthCharacterWidth,pt=Q.scrollBeyondLastLine,bt=Q.minimap.renderCharacters;let St=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Pt=Q.minimap.maxColumn,$t=Q.minimap.size,Xt=Q.minimap.side,ft=Q.verticalScrollbarWidth,vt=Q.viewLineCount,Ot=Q.remainingWidth,Ut=Q.isViewportWrapping,Nt=bt?2:3;let wt=Math.floor(je*Ne);const kt=wt/je;let At=!1,Bt=!1,Ke=Nt*St,Wt=St/je,Re=1;if($t==="fill"||$t==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:mt,desiredRatio:gt,minimapLineCount:dt}=V.computeContainedMinimapLineCount({viewLineCount:vt,scrollBeyondLastLine:pt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Ne,lineHeight:nt,pixelRatio:je});if(vt/dt>1)At=!0,Bt=!0,St=1,Ke=1,Wt=St/je;else{let yt=!1,Tt=St+1;if($t==="fit"){const Ht=Math.ceil((ct+vt+mt)*Ke);Ut&&Xe&&Ot<=ge.stableFitRemainingWidth?(yt=!0,Tt=ge.stableFitMaxMinimapScale):yt=Ht>wt}if($t==="fill"||yt){At=!0;const Ht=St;Ke=Math.min(nt*je,Math.max(1,Math.floor(1/gt))),Ut&&Xe&&Ot<=ge.stableFitRemainingWidth&&(Tt=ge.stableFitMaxMinimapScale),St=Math.min(Tt,Math.max(1,Math.floor(Ke/Nt))),St>Ht&&(Re=Math.min(2,St/Ht)),Wt=St/je/Re,wt=Math.ceil(Math.max(Ge,ct+vt+mt)*Ke),Ut?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=Ot,ge.stableFitMaxMinimapScale=St):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Fe=Math.floor(Pt*Wt),Se=Math.min(Fe,Math.max(0,Math.floor((Ot-ft-2)*Wt/(ot+Wt)))+e.MINIMAP_GUTTER_WIDTH);let se=Math.floor(je*Se);const Oe=se/je;se=Math.floor(se*Re);const He=bt?1:2,Ze=Xt==="left"?0:Le-Se-ft;return{renderMinimap:He,minimapLeft:Ze,minimapWidth:Se,minimapHeightIsEditorHeight:At,minimapIsSampling:Bt,minimapScale:St,minimapLineHeight:Ke,minimapCanvasInnerWidth:se,minimapCanvasInnerHeight:wt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:kt}}static computeLayout(Q,ge){const Le=ge.outerWidth|0,Ne=ge.outerHeight|0,je=ge.lineHeight|0,Ye=ge.lineNumbersDigitCount|0,Xe=ge.typicalHalfwidthCharacterWidth,nt=ge.maxDigitWidth,ot=ge.pixelRatio,pt=ge.viewLineCount,bt=Q.get(130),St=bt==="inherit"?Q.get(129):bt,Pt=St==="inherit"?Q.get(125):St,$t=Q.get(128),Xt=ge.isDominatedByLongLines,ft=Q.get(54),vt=Q.get(64).renderType!==0,Ot=Q.get(65),Ut=Q.get(99),Nt=Q.get(80),wt=Q.get(69),kt=Q.get(97),At=kt.verticalScrollbarSize,Bt=kt.verticalHasArrows,Ke=kt.arrowSize,Wt=kt.horizontalScrollbarSize,Re=Q.get(40),Fe=Q.get(104)!=="never";let Se=Q.get(62);Re&&Fe&&(Se+=16);let se=0;if(vt){const ai=Math.max(Ye,Ot);se=Math.round(ai*nt)}let Oe=0;ft&&(Oe=je);let He=0,Ze=He+Oe,Ge=Ze+se,ct=Ge+Se;const mt=Le-Oe-se-Se;let gt=!1,dt=!1,lt=-1;St==="inherit"&&Xt?(gt=!0,dt=!0):Pt==="on"||Pt==="bounded"?dt=!0:Pt==="wordWrapColumn"&&(lt=$t);const yt=V.c({outerWidth:Le,outerHeight:Ne,lineHeight:je,typicalHalfwidthCharacterWidth:Xe,pixelRatio:ot,scrollBeyondLastLine:Ut,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:wt,verticalScrollbarWidth:At,viewLineCount:pt,remainingWidth:mt,isViewportWrapping:dt},ge.memory||new L);yt.renderMinimap!==0&&yt.minimapLeft===0&&(He+=yt.minimapWidth,Ze+=yt.minimapWidth,Ge+=yt.minimapWidth,ct+=yt.minimapWidth);const Tt=mt-yt.minimapWidth,Ht=Math.max(1,Math.floor((Tt-At-2)/Xe)),Ft=Bt?Ke:0;return dt&&(lt=Math.max(1,Ht),Pt==="bounded"&&(lt=Math.min(lt,$t))),{width:Le,height:Ne,glyphMarginLeft:He,glyphMarginWidth:Oe,lineNumbersLeft:Ze,lineNumbersWidth:se,decorationsLeft:Ge,decorationsWidth:Se,contentLeft:ct,contentWidth:Tt,minimap:yt,viewportColumn:Ht,isWordWrapMinified:gt,isViewportWrapping:dt,wrappingColumn:lt,verticalScrollbarWidth:At,horizontalScrollbarHeight:Wt,overviewRuler:{top:Ft,width:At,height:Ne-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=V;class J extends k{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate(Q){return t(Q,"simple",["simple","advanced"])}compute(Q,ge,Le){return ge.get(2)===2?"advanced":Le}}class ne extends k{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:c.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:r(Q.enabled,this.defaultValue.enabled)}}}class ve extends k{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ue extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:c.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:t(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(ge.fontFamily,this.defaultValue.fontFamily),padding:r(ge.padding,this.defaultValue.padding)}}}class ee extends k{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):w.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Le){return Le<0?w.clampedInt(-Le*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class N extends y{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>y.clamp(Q,0,150),{markdownDescription:c.localize(60,null)})}compute(Q,ge,Le){return Q.fontInfo.lineHeight}}class K extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:Q.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:c.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),autohide:r(ge.autohide,this.defaultValue.autohide),size:t(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ge.side,this.defaultValue.side,["right","left"]),showSlider:t(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(ge.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ge.scale,1,1,3),maxColumn:w.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le($){return $==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends k{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:w.clampedInt(ge.top,0,0,1e3),bottom:w.clampedInt(ge.bottom,0,0,1e3)}}}class ke extends k{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:c.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),cycle:r(ge.cycle,this.defaultValue.cycle)}}}class Z extends C{constructor(){super(136)}compute(Q,ge,Le){return Q.pixelRatio}}class ce extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:c.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:c.localize(80,null)},other:{anyOf:ge,default:Q.other,description:c.localize(81,null)}},default:Q,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ot=Q?"on":"off";return{comments:ot,strings:ot,other:ot}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Le,strings:Ne}=Q,je=["on","inline","off"];let Ye,Xe,nt;return typeof ge=="boolean"?Ye=ge?"on":"off":Ye=t(ge,this.defaultValue.other,je),typeof Le=="boolean"?Xe=Le?"on":"off":Xe=t(Le,this.defaultValue.comments,je),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=t(Ne,this.defaultValue.strings,je),{other:Ye,comments:Xe,strings:nt}}}var de;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative",$[$.Interval=3]="Interval",$[$.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class te extends k{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Le=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Le}}}function ae($){const Q=$.get(92);return Q==="editable"?$.get(86):Q!=="on"}e.filterValidationDecorations=ae;class oe extends k{constructor(){const Q=[],ge={type:"number",description:c.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:Q,description:c.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Le of Q)if(typeof Le=="number")ge.push({column:w.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;ge.push({column:w.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ge.sort((Le,Ne)=>Le.column-Ne.column),ge}return this.defaultValue}}function F($,Q){if(typeof $!="string")return Q;switch($){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:c.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Le=w.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=w.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:F(ge.vertical,this.defaultValue.vertical),horizontal:F(ge.horizontal,this.defaultValue.horizontal),useShadows:r(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:w.clampedInt(ge.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:w.clampedInt(ge.verticalSliderSize,Ne,0,1e3),scrollByPage:r(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:c.localize(108,null)}})}applyUpdate(Q,ge){let Le=!1;ge.allowedCharacters&&Q&&(P.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Le=!0)),ge.allowedLocales&&Q&&(P.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Le=!0));const Ne=super.applyUpdate(Q,ge);return Le?new S(Ne.newValue,!0):Ne}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:Ae(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Le={};for(const[Ne,je]of Object.entries(Q))je===!0&&(Le[Ne]=!0);return Le}}class _ extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:c.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(110,null),c.localize(111,null)],description:c.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),mode:t(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class fe extends k{constructor(){const Q={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:c.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:c.localize(114,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:r(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ee extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(115,null),c.localize(116,null),c.localize(117,null)],default:Q.bracketPairs,description:c.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:Q.bracketPairsHorizontal,description:c.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:c.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:c.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(125,null),c.localize(126,null),c.localize(127,null)],default:Q.highlightActiveIndentation,description:c.localize(128,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:Ae(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae($,Q,ge){const Le=ge.indexOf($);return Le===-1?Q:ge[Le]}class we extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(129,null),c.localize(130,null)],default:Q.insertMode,description:c.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:c.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:c.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:c.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(135,null),c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:Q.selectionMode,markdownDescription:c.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:c.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:c.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:c.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:c.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:c.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:t(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(ge.showIcons,this.defaultValue.showIcons),showStatusBar:r(ge.showStatusBar,this.defaultValue.showStatusBar),preview:r(ge.preview,this.defaultValue.preview),previewMode:t(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(ge.showMethods,this.defaultValue.showMethods),showFunctions:r(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:r(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(ge.showFields,this.defaultValue.showFields),showVariables:r(ge.showVariables,this.defaultValue.showVariables),showClasses:r(ge.showClasses,this.defaultValue.showClasses),showStructs:r(ge.showStructs,this.defaultValue.showStructs),showInterfaces:r(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:r(ge.showModules,this.defaultValue.showModules),showProperties:r(ge.showProperties,this.defaultValue.showProperties),showEvents:r(ge.showEvents,this.defaultValue.showEvents),showOperators:r(ge.showOperators,this.defaultValue.showOperators),showUnits:r(ge.showUnits,this.defaultValue.showUnits),showValues:r(ge.showValues,this.defaultValue.showValues),showConstants:r(ge.showConstants,this.defaultValue.showConstants),showEnums:r(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:r(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(ge.showKeywords,this.defaultValue.showKeywords),showWords:r(ge.showWords,this.defaultValue.showWords),showColors:r(ge.showColors,this.defaultValue.showColors),showFiles:r(ge.showFiles,this.defaultValue.showFiles),showReferences:r(ge.showReferences,this.defaultValue.showReferences),showFolders:r(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:r(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(ge.showSnippets,this.defaultValue.showSnippets),showUsers:r(ge.showUsers,this.defaultValue.showUsers),showIssues:r(ge.showIssues,this.defaultValue.showIssues)}}}class Pe extends k{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(177,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ie;(function($){$[$.None=0]="None",$[$.Same=1]="Same",$[$.Indent=2]="Indent",$[$.DeepIndent=3]="DeepIndent"})(Ie=e.WrappingIndent||(e.WrappingIndent={}));class ze extends k{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(178,null),c.localize(179,null),c.localize(180,null),c.localize(181,null)],description:c.localize(182,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Le){return ge.get(2)===2?0:Le}}class qe extends C{constructor(){super(139)}compute(Q,ge,Le){const Ne=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class tt extends k{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:c.localize(183,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:r(Q.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?it:A.isLinux?rt:Qe,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be($){return e.editorOptionsRegistry[$.id]=$,$}var et;(function($){$[$.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",$[$.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",$[$.accessibilitySupport=2]="accessibilitySupport",$[$.accessibilityPageSize=3]="accessibilityPageSize",$[$.ariaLabel=4]="ariaLabel",$[$.autoClosingBrackets=5]="autoClosingBrackets",$[$.autoClosingDelete=6]="autoClosingDelete",$[$.autoClosingOvertype=7]="autoClosingOvertype",$[$.autoClosingQuotes=8]="autoClosingQuotes",$[$.autoIndent=9]="autoIndent",$[$.automaticLayout=10]="automaticLayout",$[$.autoSurround=11]="autoSurround",$[$.bracketPairColorization=12]="bracketPairColorization",$[$.guides=13]="guides",$[$.codeLens=14]="codeLens",$[$.codeLensFontFamily=15]="codeLensFontFamily",$[$.codeLensFontSize=16]="codeLensFontSize",$[$.colorDecorators=17]="colorDecorators",$[$.colorDecoratorsLimit=18]="colorDecoratorsLimit",$[$.columnSelection=19]="columnSelection",$[$.comments=20]="comments",$[$.contextmenu=21]="contextmenu",$[$.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",$[$.cursorBlinking=23]="cursorBlinking",$[$.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",$[$.cursorStyle=25]="cursorStyle",$[$.cursorSurroundingLines=26]="cursorSurroundingLines",$[$.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",$[$.cursorWidth=28]="cursorWidth",$[$.disableLayerHinting=29]="disableLayerHinting",$[$.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",$[$.domReadOnly=31]="domReadOnly",$[$.dragAndDrop=32]="dragAndDrop",$[$.dropIntoEditor=33]="dropIntoEditor",$[$.emptySelectionClipboard=34]="emptySelectionClipboard",$[$.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",$[$.extraEditorClassName=36]="extraEditorClassName",$[$.fastScrollSensitivity=37]="fastScrollSensitivity",$[$.find=38]="find",$[$.fixedOverflowWidgets=39]="fixedOverflowWidgets",$[$.folding=40]="folding",$[$.foldingStrategy=41]="foldingStrategy",$[$.foldingHighlight=42]="foldingHighlight",$[$.foldingImportsByDefault=43]="foldingImportsByDefault",$[$.foldingMaximumRegions=44]="foldingMaximumRegions",$[$.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",$[$.fontFamily=46]="fontFamily",$[$.fontInfo=47]="fontInfo",$[$.fontLigatures=48]="fontLigatures",$[$.fontSize=49]="fontSize",$[$.fontWeight=50]="fontWeight",$[$.fontVariations=51]="fontVariations",$[$.formatOnPaste=52]="formatOnPaste",$[$.formatOnType=53]="formatOnType",$[$.glyphMargin=54]="glyphMargin",$[$.gotoLocation=55]="gotoLocation",$[$.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",$[$.hover=57]="hover",$[$.inDiffEditor=58]="inDiffEditor",$[$.inlineSuggest=59]="inlineSuggest",$[$.letterSpacing=60]="letterSpacing",$[$.lightbulb=61]="lightbulb",$[$.lineDecorationsWidth=62]="lineDecorationsWidth",$[$.lineHeight=63]="lineHeight",$[$.lineNumbers=64]="lineNumbers",$[$.lineNumbersMinChars=65]="lineNumbersMinChars",$[$.linkedEditing=66]="linkedEditing",$[$.links=67]="links",$[$.matchBrackets=68]="matchBrackets",$[$.minimap=69]="minimap",$[$.mouseStyle=70]="mouseStyle",$[$.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",$[$.mouseWheelZoom=72]="mouseWheelZoom",$[$.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",$[$.multiCursorModifier=74]="multiCursorModifier",$[$.multiCursorPaste=75]="multiCursorPaste",$[$.multiCursorLimit=76]="multiCursorLimit",$[$.occurrencesHighlight=77]="occurrencesHighlight",$[$.overviewRulerBorder=78]="overviewRulerBorder",$[$.overviewRulerLanes=79]="overviewRulerLanes",$[$.padding=80]="padding",$[$.parameterHints=81]="parameterHints",$[$.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",$[$.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",$[$.quickSuggestions=84]="quickSuggestions",$[$.quickSuggestionsDelay=85]="quickSuggestionsDelay",$[$.readOnly=86]="readOnly",$[$.renameOnType=87]="renameOnType",$[$.renderControlCharacters=88]="renderControlCharacters",$[$.renderFinalNewline=89]="renderFinalNewline",$[$.renderLineHighlight=90]="renderLineHighlight",$[$.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",$[$.renderValidationDecorations=92]="renderValidationDecorations",$[$.renderWhitespace=93]="renderWhitespace",$[$.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",$[$.roundedSelection=95]="roundedSelection",$[$.rulers=96]="rulers",$[$.scrollbar=97]="scrollbar",$[$.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",$[$.scrollBeyondLastLine=99]="scrollBeyondLastLine",$[$.scrollPredominantAxis=100]="scrollPredominantAxis",$[$.selectionClipboard=101]="selectionClipboard",$[$.selectionHighlight=102]="selectionHighlight",$[$.selectOnLineNumbers=103]="selectOnLineNumbers",$[$.showFoldingControls=104]="showFoldingControls",$[$.showUnused=105]="showUnused",$[$.snippetSuggestions=106]="snippetSuggestions",$[$.smartSelect=107]="smartSelect",$[$.smoothScrolling=108]="smoothScrolling",$[$.stickyScroll=109]="stickyScroll",$[$.stickyTabStops=110]="stickyTabStops",$[$.stopRenderingLineAfter=111]="stopRenderingLineAfter",$[$.suggest=112]="suggest",$[$.suggestFontSize=113]="suggestFontSize",$[$.suggestLineHeight=114]="suggestLineHeight",$[$.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",$[$.suggestSelection=116]="suggestSelection",$[$.tabCompletion=117]="tabCompletion",$[$.tabIndex=118]="tabIndex",$[$.unicodeHighlighting=119]="unicodeHighlighting",$[$.unusualLineTerminators=120]="unusualLineTerminators",$[$.useShadowDOM=121]="useShadowDOM",$[$.useTabStops=122]="useTabStops",$[$.wordBreak=123]="wordBreak",$[$.wordSeparators=124]="wordSeparators",$[$.wordWrap=125]="wordWrap",$[$.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",$[$.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",$[$.wordWrapColumn=128]="wordWrapColumn",$[$.wordWrapOverride1=129]="wordWrapOverride1",$[$.wordWrapOverride2=130]="wordWrapOverride2",$[$.wrappingIndent=131]="wrappingIndent",$[$.wrappingStrategy=132]="wrappingStrategy",$[$.showDeprecated=133]="showDeprecated",$[$.inlayHints=134]="inlayHints",$[$.editorClassName=135]="editorClassName",$[$.pixelRatio=136]="pixelRatio",$[$.tabFocusMode=137]="tabFocusMode",$[$.layoutInfo=138]="layoutInfo",$[$.wrappingInfo=139]="wrappingInfo"})(et=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(184,null)})),acceptSuggestionOnEnter:Be(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(185,null),""],markdownDescription:c.localize(186,null)})),accessibilitySupport:Be(new l),accessibilityPageSize:Be(new w(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new m(4,"ariaLabel",c.localize(188,null))),autoClosingBrackets:Be(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(189,null),c.localize(190,null),""],description:c.localize(191,null)})),autoClosingDelete:Be(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(192,null),""],description:c.localize(193,null)})),autoClosingOvertype:Be(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(194,null),""],description:c.localize(195,null)})),autoClosingQuotes:Be(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(196,null),c.localize(197,null),""],description:c.localize(198,null)})),autoIndent:Be(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[c.localize(199,null),c.localize(200,null),c.localize(201,null),c.localize(202,null),c.localize(203,null)],description:c.localize(204,null)})),automaticLayout:Be(new d(10,"automaticLayout",!1)),autoSurround:Be(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(205,null),c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),bracketPairColorization:Be(new fe),bracketPairGuides:Be(new Ee),stickyTabStops:Be(new d(110,"stickyTabStops",!1,{description:c.localize(209,null)})),codeLens:Be(new d(14,"codeLens",!0,{description:c.localize(210,null)})),codeLensFontFamily:Be(new m(15,"codeLensFontFamily","",{description:c.localize(211,null)})),codeLensFontSize:Be(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(212,null)})),colorDecorators:Be(new d(17,"colorDecorators",!0,{description:c.localize(213,null)})),colorDecoratorsLimit:Be(new w(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(214,null)})),columnSelection:Be(new d(19,"columnSelection",!1,{description:c.localize(215,null)})),comments:Be(new v),contextmenu:Be(new d(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new d(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(216,null)})),cursorBlinking:Be(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:c.localize(217,null)})),cursorSmoothCaretAnimation:Be(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(218,null),c.localize(219,null),c.localize(220,null)],description:c.localize(221,null)})),cursorStyle:Be(new s(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:c.localize(222,null)})),cursorSurroundingLines:Be(new w(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(223,null)})),cursorSurroundingLinesStyle:Be(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(224,null),c.localize(225,null)],description:c.localize(226,null)})),cursorWidth:Be(new w(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(227,null)})),disableLayerHinting:Be(new d(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new d(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new d(31,"domReadOnly",!1)),dragAndDrop:Be(new d(32,"dragAndDrop",!0,{description:c.localize(228,null)})),emptySelectionClipboard:Be(new W),dropIntoEditor:Be(new tt),stickyScroll:Be(new ve),experimentalWhitespaceRendering:Be(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(229,null),c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),extraEditorClassName:Be(new m(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new y(37,"fastScrollSensitivity",5,$=>$<=0?5:$,{markdownDescription:c.localize(233,null)})),find:Be(new q),fixedOverflowWidgets:Be(new d(39,"fixedOverflowWidgets",!1)),folding:Be(new d(40,"folding",!0,{description:c.localize(234,null)})),foldingStrategy:Be(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(235,null),c.localize(236,null)],description:c.localize(237,null)})),foldingHighlight:Be(new d(42,"foldingHighlight",!0,{description:c.localize(238,null)})),foldingImportsByDefault:Be(new d(43,"foldingImportsByDefault",!1,{description:c.localize(239,null)})),foldingMaximumRegions:Be(new w(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new d(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(241,null)})),fontFamily:Be(new m(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(242,null)})),fontInfo:Be(new M),fontLigatures2:Be(new Y),fontSize:Be(new B),fontWeight:Be(new U),fontVariations:Be(new x),formatOnPaste:Be(new d(52,"formatOnPaste",!1,{description:c.localize(243,null)})),formatOnType:Be(new d(53,"formatOnType",!1,{description:c.localize(244,null)})),glyphMargin:Be(new d(54,"glyphMargin",!0,{description:c.localize(245,null)})),gotoLocation:Be(new j),hideCursorInOverviewRuler:Be(new d(56,"hideCursorInOverviewRuler",!1,{description:c.localize(246,null)})),hover:Be(new he),inDiffEditor:Be(new d(58,"inDiffEditor",!1)),letterSpacing:Be(new y(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,$=>y.clamp($,-5,20),{description:c.localize(247,null)})),lightbulb:Be(new ne),lineDecorationsWidth:Be(new ee),lineHeight:Be(new N),lineNumbers:Be(new te),lineNumbersMinChars:Be(new w(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new d(66,"linkedEditing",!1,{description:c.localize(248,null)})),links:Be(new d(67,"links",!0,{description:c.localize(249,null)})),matchBrackets:Be(new o(68,"matchBrackets","always",["always","near","never"],{description:c.localize(250,null)})),minimap:Be(new K),mouseStyle:Be(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new y(71,"mouseWheelScrollSensitivity",1,$=>$===0?1:$,{markdownDescription:c.localize(251,null)})),mouseWheelZoom:Be(new d(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(252,null)})),multiCursorMergeOverlapping:Be(new d(73,"multiCursorMergeOverlapping",!0,{description:c.localize(253,null)})),multiCursorModifier:Be(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[c.localize(254,null),c.localize(255,null)],markdownDescription:c.localize(256,null)})),multiCursorPaste:Be(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(257,null),c.localize(258,null)],markdownDescription:c.localize(259,null)})),multiCursorLimit:Be(new w(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(260,null)})),occurrencesHighlight:Be(new d(77,"occurrencesHighlight",!0,{description:c.localize(261,null)})),overviewRulerBorder:Be(new d(78,"overviewRulerBorder",!0,{description:c.localize(262,null)})),overviewRulerLanes:Be(new w(79,"overviewRulerLanes",3,0,3)),padding:Be(new me),parameterHints:Be(new ke),peekWidgetDefaultFocus:Be(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],description:c.localize(265,null)})),definitionLinkOpensInPeek:Be(new d(83,"definitionLinkOpensInPeek",!1,{description:c.localize(266,null)})),quickSuggestions:Be(new ce),quickSuggestionsDelay:Be(new w(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(267,null)})),readOnly:Be(new d(86,"readOnly",!1)),renameOnType:Be(new d(87,"renameOnType",!1,{description:c.localize(268,null),markdownDeprecationMessage:c.localize(269,null)})),renderControlCharacters:Be(new d(88,"renderControlCharacters",!0,{description:c.localize(270,null),restricted:!0})),renderFinalNewline:Be(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(271,null)})),renderLineHighlight:Be(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(272,null)],description:c.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new d(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(274,null)})),renderValidationDecorations:Be(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(275,null),c.localize(276,null),c.localize(277,null),""],description:c.localize(278,null)})),revealHorizontalRightPadding:Be(new w(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new d(95,"roundedSelection",!0,{description:c.localize(279,null)})),rulers:Be(new oe),scrollbar:Be(new z),scrollBeyondLastColumn:Be(new w(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(280,null)})),scrollBeyondLastLine:Be(new d(99,"scrollBeyondLastLine",!0,{description:c.localize(281,null)})),scrollPredominantAxis:Be(new d(100,"scrollPredominantAxis",!0,{description:c.localize(282,null)})),selectionClipboard:Be(new d(101,"selectionClipboard",!0,{description:c.localize(283,null),included:A.isLinux})),selectionHighlight:Be(new d(102,"selectionHighlight",!0,{description:c.localize(284,null)})),selectOnLineNumbers:Be(new d(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(285,null),c.localize(286,null),c.localize(287,null)],description:c.localize(288,null)})),showUnused:Be(new d(105,"showUnused",!0,{description:c.localize(289,null)})),showDeprecated:Be(new d(133,"showDeprecated",!0,{description:c.localize(290,null)})),inlayHints:Be(new ue),snippetSuggestions:Be(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(291,null),c.localize(292,null),c.localize(293,null),c.localize(294,null)],description:c.localize(295,null)})),smartSelect:Be(new Pe),smoothScrolling:Be(new d(108,"smoothScrolling",!1,{description:c.localize(296,null)})),stopRenderingLineAfter:Be(new w(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new we),inlineSuggest:Be(new _),suggestFontSize:Be(new w(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new w(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new d(115,"suggestOnTriggerCharacters",!0,{description:c.localize(299,null)})),suggestSelection:Be(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(300,null),c.localize(301,null),c.localize(302,null)],description:c.localize(303,null)})),tabCompletion:Be(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(304,null),c.localize(305,null),c.localize(306,null)],description:c.localize(307,null)})),tabIndex:Be(new w(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new G),unusualLineTerminators:Be(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(308,null),c.localize(309,null),c.localize(310,null)],description:c.localize(311,null)})),useShadowDOM:Be(new d(121,"useShadowDOM",!0)),useTabStops:Be(new d(122,"useTabStops",!0,{description:c.localize(312,null)})),wordBreak:Be(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(313,null),c.localize(314,null)],description:c.localize(315,null)})),wordSeparators:Be(new m(124,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:c.localize(316,null)})),wordWrap:Be(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(317,null),c.localize(318,null),c.localize(319,null),c.localize(320,null)],description:c.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new m(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new m(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new w(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(322,null)})),wordWrapOverride1:Be(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new O),pixelRatio:Be(new Z),tabFocusMode:Be(new d(137,"tabFocusMode",!1,{markdownDescription:c.localize(323,null)})),layoutInfo:Be(new V),wrappingInfo:Be(new qe),wrappingIndent:Be(new ze),wrappingStrategy:Be(new J)}}),define(De[170],Ce([14,15]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[171],Ce([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(De[172],Ce([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(De[173],Ce([14,15]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[174],Ce([14,15]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[175],Ce([14,15]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[176],Ce([14,15]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(De[177],Ce([14,15]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(De[178],Ce([14,15]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(De[179],Ce([14,15]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(De[180],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[181],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[182],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(De[183],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(De[184],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[185],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[186],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[187],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[188],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[189],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[190],Ce([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[191],Ce([14,15]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(De[192],Ce([14,15]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(De[193],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[194],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[195],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[196],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[197],Ce([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[198],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[199],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[200],Ce([14,15]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[201],Ce([1,0,9,172]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var u;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(u=e.TokenType||(e.TokenType={}));function R(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const P=(0,A.localize)(3,null),T=(0,A.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,c.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const k=this.d,S=this.c.substring(this.d,this.e),I={type:19,offset:this.d,lexeme:S};this.g.push({offset:k,lexeme:S,additionalInfo:L}),this.f.push(I)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const k=this.c.substring(this.d,this.e),S=D.b.get(k);S?this.k(S):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,k=!1,S=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(T);return}const C=this.c.charCodeAt(L);if(k)k=!1;else if(C===47&&!S){L++;break}else C===91?S=!0:C===92?k=!0:C===93&&(S=!1);L++}for(;L<this.c.length&&D.a.has(this.c.charCodeAt(L));)L++;this.e=L;const I=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:I,offset:this.d})}r(){return this.e>=this.c.length}}D.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),D.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=D}),define(De[202],Ce([1,0,24,37,174,325]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function D(d){return d=d.trim(),d==="*"||P.test(d)}e.isValidVersionStr=D;function g(d){if(!D(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(P);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=g;function L(d){if(!d)return null;const f=d.majorBase,w=d.majorMustEqual,y=d.minorBase;let m=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(f===0||(m=!1),o=!1);let s=0;if(d.preRelease){const a=T.exec(d.preRelease);if(a){const[,l,v,i]=a;s=Date.UTC(Number(l),Number(v)-1,Number(i))}}return{majorBase:f,majorMustEqual:w,minorBase:y,minorMustEqual:m,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function k(d,f,w){let y;typeof d=="string"?y=L(g(d)):y=d;let m;f instanceof Date?m=f.getTime():typeof f=="string"&&(m=new Date(f).getTime());let t;if(typeof w=="string"?t=L(g(w)):t=w,!y||!t)return!1;const o=y.majorBase,s=y.minorBase,a=y.patchBase;let l=t.majorBase,v=t.minorBase,i=t.patchBase;const n=t.notBefore;let h=t.majorMustEqual,b=t.minorMustEqual,p=t.patchMustEqual;return t.isMinimum?o>l?!0:o<l?!1:s>v?!0:s<v||m&&m<n?!1:a>=i:(o===1&&l===0&&(!h||!b||!p)&&(l=1,v=0,i=0,h=!0,b=!1,p=!1),o<l?!1:o>l?!h:s<v?!1:s>v?!b:a<i?!1:a>i?!p:!(m&&m<n))}e.isValidVersion=k;function S(d,f,w,y,m){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([A.default.Error,u.localize(0,null)]),t;if(typeof y.name!="string")return t.push([A.default.Error,u.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([A.default.Error,u.localize(2,null,"version")]),t;if(!y.engines)return t.push([A.default.Error,u.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([A.default.Error,u.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!r(y.extensionDependencies))return t.push([A.default.Error,u.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!r(y.activationEvents))return t.push([A.default.Error,u.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([A.default.Error,u.localize(7,null,"activationEvents","main")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([A.default.Warning,u.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([A.default.Error,u.localize(9,null,"main")]),t;{const a=(0,c.joinPath)(w,y.main);(0,c.isEqualOrParent)(a,w)||t.push([A.default.Warning,u.localize(10,null,a.path,w.path)])}if(typeof y.activationEvents>"u")return t.push([A.default.Error,u.localize(11,null,"activationEvents","main")]),t}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([A.default.Error,u.localize(12,null,"browser")]),t;{const a=(0,c.joinPath)(w,y.browser);(0,c.isEqualOrParent)(a,w)||t.push([A.default.Warning,u.localize(13,null,a.path,w.path)])}if(typeof y.activationEvents>"u")return t.push([A.default.Error,u.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(y.version))return t.push([A.default.Error,u.localize(15,null)]),t;const o=[];if(!I(d,f,y,m,o))for(const a of o)t.push([A.default.Error,a]);return t}e.validateExtensionManifest=S;function I(d,f,w,y,m){return y||typeof w.main>"u"&&typeof w.browser>"u"?!0:E(d,f,w.engines.vscode,m)}e.isValidExtensionVersion=I;function C(d,f,w){return d==="*"||E(f,w,d)}e.isEngineValid=C;function E(d,f,w,y=[]){const m=L(g(w));if(!m)return y.push(u.localize(16,null,w)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return y.push(u.localize(17,null,w)),!1}else if(!m.majorMustEqual)return y.push(u.localize(18,null,w)),!1;return k(d,f,m)?!0:(y.push(u.localize(19,null,d,w)),!1)}function r(d){if(!Array.isArray(d))return!1;for(let f=0,w=d.length;f<w;f++)if(typeof d[f]!="string")return!1;return!0}}),define(De[90],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(u,R=[],P=!1){this.ctor=u,this.staticArguments=R,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=c}),define(De[91],Ce([1,0,90]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var u;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(u=e.InstantiationType||(e.InstantiationType={}));function R(T,D,g){D instanceof c.SyncDescriptor||(D=new c.SyncDescriptor(D,[],Boolean(g))),A.push([T,D])}e.registerSingleton=R;function P(){return A}e.getSingletonServiceDescriptors=P}),define(De[203],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R,P){this.key=R,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const P of this.a.values())P.outgoing.size===0&&R.push(P);return R}insertEdge(R,P){const T=this.lookupOrInsertNode(R),D=this.lookupOrInsertNode(P);T.outgoing.set(D.key,D),D.incoming.set(T.key,T)}removeNode(R){const P=this.b(R);this.a.delete(P);for(const T of this.a.values())T.outgoing.delete(P),T.incoming.delete(P)}lookupOrInsertNode(R){const P=this.b(R);let T=this.a.get(P);return T||(T=new c(P,R),this.a.set(P,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[P,T]of this.a)R.push(`${P}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,P]of this.a){const T=new Set([R]),D=this.c(P,T);if(D)return D}}c(R,P){for(const[T,D]of R.outgoing){if(P.has(T))return[...P,T].join(" -> ");P.add(T);const g=this.c(D,P);if(g)return g;P.delete(T)}}}e.Graph=A}),define(De[4],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function T(D){return D[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=u("instantiationService");function A(P,T,D){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:P,index:D}):(T[c.DI_DEPENDENCIES]=[{id:P,index:D}],T[c.DI_TARGET]=T)}function u(P){if(c.serviceIds.has(P))return c.serviceIds.get(P);const T=function(D,g,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(T,D,L)};return T.toString=()=>P,c.serviceIds.set(P,T),T}e.createDecorator=u;function R(P){return P}e.refineServiceDecorator=R}),define(De[54],Ce([1,0,10,2,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=R;function P(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=P;var T;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=D;function g(r,d){const f=Object.create(null);for(const w in r)L(f,w,r[w],d);return f}e.toValuesTree=g;function L(r,d,f,w){const y=d.split("."),m=y.pop();let t=r;for(let o=0;o<y.length;o++){const s=y[o];let a=t[s];switch(typeof a){case"undefined":a=t[s]=Object.create(null);break;case"object":break;default:w(`Ignoring ${d} as ${y.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[m]=f}catch{w(`Ignoring ${d} as ${y.join(".")} is ${JSON.stringify(t)}`)}else w(`Ignoring ${d} as ${y.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=L;function k(r,d){const f=d.split(".");S(r,f)}e.removeFromValueTree=k;function S(r,d){const f=d.shift();if(d.length===0){delete r[f];return}if(Object.keys(r).indexOf(f)!==-1){const w=r[f];typeof w=="object"&&!Array.isArray(w)&&(S(w,d),Object.keys(w).length===0&&delete r[f])}}function I(r,d,f){function w(t,o){let s=t;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const y=d.split("."),m=w(r,y);return typeof m>"u"?f:m}e.getConfigurationValue=I;function C(r,d,f){Object.keys(d).forEach(w=>{w!=="__proto__"&&(w in r?c.isObject(r[w])&&c.isObject(d[w])?C(r[w],d[w],f):f&&(r[w]=d[w]):r[w]=d[w])})}e.merge=C;function E(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(De[44],Ce([1,0,11,8,201,4,171]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",c.isMacintosh),T.set("isLinux",c.isLinux),T.set("isWindows",c.isWindows),T.set("isWeb",c.isWeb),T.set("isMacNative",c.isMacintosh&&!c.isWeb),T.set("isEdge",c.isEdge),T.set("isFirefox",c.isFirefox),T.set("isChrome",c.isChrome),T.set("isSafari",c.isSafari);const D=Object.prototype.hasOwnProperty;var g;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));const L={regexParsingWithErrorRecovery:!0};class k extends Error{}const S=(0,P.localize)(0,null),I=(0,P.localize)(1,null),C=(0,P.localize)(2,null),E=(0,P.localize)(3,null),r=(0,P.localize)(4,null),d=(0,P.localize)(5,null),f=(0,P.localize)(6,null),w=(0,P.localize)(7,null);class y{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(N=L){this.h=N,this.c=new u.Scanner,this.d=[],this.f=0,this.g=[]}parse(N){if(N===""){this.g.push({message:S,offset:0,lexeme:"",additionalInfo:I});return}this.d=this.c.reset(N).scan(),this.f=0,this.g=[];try{const K=this.k();if(!this.B()){const le=this.A(),me=le.type===17?d:void 0;throw this.g.push({message:r,offset:le.offset,lexeme:u.Scanner.getLexeme(le),additionalInfo:me}),new k}return K}catch(K){if(!(K instanceof k))throw K;return}}k(){return this.l()}l(){const N=[this.m()];for(;this.v(16);){const K=this.m();N.push(K)}return N.length===1?N[0]:m.or(...N)}m(){const N=[this.o()];for(;this.v(15);){const K=this.o();N.push(K)}return N.length===1?N[0]:m.and(...N)}o(){if(this.v(2)){const N=this.A();switch(N.type){case 11:return this.w(),a.INSTANCE;case 12:return this.w(),l.INSTANCE;case 0:{this.w();const K=this.k();return this.x(1,E),K?.negate()}case 17:return this.w(),p.create(N.lexeme);default:throw this.y("KEY | true | false | '(' expression ')'",N)}}return this.s()}s(){const N=this.A();switch(N.type){case 11:return this.w(),m.true();case 12:return this.w(),m.false();case 0:{this.w();const K=this.k();return this.x(1,E),K}case 17:{const K=N.lexeme;if(this.w(),this.v(9)){const me=this.A();if(!this.h.regexParsingWithErrorRecovery){if(this.w(),me.type!==10)throw this.y("REGEX",me);const ke=me.lexeme,Z=ke.lastIndexOf("/"),ce=Z===ke.length-1?void 0:ke.substring(Z+1);let de;try{de=new RegExp(ke.substring(1,Z),ce)}catch{throw this.y("REGEX",me)}return M.create(K,de)}switch(me.type){case 10:case 19:{const ke=[me.lexeme];this.w();let Z=this.A(),ce=0;for(let F=0;F<me.lexeme.length;F++)me.lexeme.charCodeAt(F)===40?ce++:me.lexeme.charCodeAt(F)===41&&ce--;for(;!this.B()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let F=0;F<Z.lexeme.length;F++)Z.lexeme.charCodeAt(F)===40?ce++:me.lexeme.charCodeAt(F)===41&&ce--}if(ce<0)break;ke.push(u.Scanner.getLexeme(Z)),this.w(),Z=this.A()}const de=ke.join(""),te=de.lastIndexOf("/"),ae=te===de.length-1?void 0:de.substring(te+1);let oe;try{oe=new RegExp(de.substring(1,te),ae)}catch{throw this.y("REGEX",me)}return m.regex(K,oe)}case 18:{const ke=me.lexeme;this.w();let Z=null;if(!(0,A.isFalsyOrWhitespace)(ke)){const ce=ke.indexOf("/"),de=ke.lastIndexOf("/");if(ce!==de&&ce>=0){const te=ke.slice(ce+1,de),ae=ke[de+1]==="i"?"i":"";try{Z=new RegExp(te,ae)}catch{throw this.y("REGEX",me)}}}if(Z===null)throw this.y("REGEX",me);return M.create(K,Z)}default:throw this.y("REGEX",this.A())}}if(this.v(14)){this.x(13,C);const me=this.t();return m.notIn(K,me)}switch(this.A().type){case 3:{this.w();const me=this.t();if(this.u().type===18)return m.equals(K,me);switch(me){case"true":return m.has(K);case"false":return m.not(K);default:return m.equals(K,me)}}case 4:{this.w();const me=this.t();if(this.u().type===18)return m.notEquals(K,me);switch(me){case"true":return m.not(K);case"false":return m.has(K);default:return m.notEquals(K,me)}}case 5:return this.w(),Y.create(K,this.t());case 6:return this.w(),x.create(K,this.t());case 7:return this.w(),W.create(K,this.t());case 8:return this.w(),q.create(K,this.t());case 13:return this.w(),m.in(K,this.t());default:return m.has(K)}}case 20:throw this.g.push({message:f,offset:N.offset,lexeme:"",additionalInfo:w}),new k;default:throw this.y(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.A())}}t(){const N=this.A();switch(N.type){case 17:case 18:return this.w(),N.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(N){return this.z(N)?(this.w(),!0):!1}w(){return this.B()||this.f++,this.u()}x(N,K){if(this.z(N))return this.w();throw this.y(K,this.A())}y(N,K,le){const me=(0,P.localize)(8,null,N,u.Scanner.getLexeme(K)),ke=K.offset,Z=u.Scanner.getLexeme(K);return this.g.push({message:me,offset:ke,lexeme:Z,additionalInfo:le}),new k}z(N){return this.A().type===N}A(){return this.d[this.f]}B(){return this.A().type===20}}e.Parser=y;class m{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(N){return v.create(N)}static equals(N,K){return i.create(N,K)}static notEquals(N,K){return b.create(N,K)}static regex(N,K){return M.create(N,K)}static in(N,K){return n.create(N,K)}static notIn(N,K){return h.create(N,K)}static not(N){return p.create(N)}static and(...N){return j.create(N,null,!0)}static or(...N){return he.create(N,null,!0)}static greater(N,K){return W.create(N,K)}static greaterEquals(N,K){return q.create(N,K)}static smaller(N,K){return Y.create(N,K)}static smallerEquals(N,K){return x.create(N,K)}static deserialize(N){return N==null?void 0:this.c.parse(N)}}m.c=new y({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=m;function t(ee){const N=new y({regexParsingWithErrorRecovery:!1});return ee.map(K=>(N.parse(K),N.lexingErrors.length>0?N.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,P.localize)(9,null,le.additionalInfo):(0,P.localize)(10,null),offset:le.offset,length:le.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.validateWhenClauses=t;function o(ee,N){const K=ee?ee.substituteConstants():void 0,le=N?N.substituteConstants():void 0;return!K&&!le?!0:!K||!le?!1:K.equals(le)}e.expressionsAreEqualWithConstantSubstitution=o;function s(ee,N){return ee.cmp(N)}class a{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return l.INSTANCE}}a.INSTANCE=new a,e.ContextKeyFalseExpr=a;class l{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return a.INSTANCE}}l.INSTANCE=new l,e.ContextKeyTrueExpr=l;class v{static create(N,K=null){const le=T.get(N);return typeof le=="boolean"?le?l.INSTANCE:a.INSTANCE:new v(N,K)}constructor(N,K){this.key=N,this.c=K,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:V(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=T.get(this.key);return typeof N=="boolean"?N?l.INSTANCE:a.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class i{static create(N,K,le=null){if(typeof K=="boolean")return K?v.create(N,le):p.create(N,le);const me=T.get(N);return typeof me=="boolean"?K===(me?"true":"false")?l.INSTANCE:a.INSTANCE:new i(N,K,le)}constructor(N,K,le){this.c=N,this.d=K,this.f=le,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=T.get(this.c);if(typeof N=="boolean"){const K=N?"true":"false";return this.d===K?l.INSTANCE:a.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=i;class n{static create(N,K){return new n(N,K)}constructor(N,K){this.d=N,this.f=K,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:J(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const K=N.getValue(this.f),le=N.getValue(this.d);return Array.isArray(K)?K.includes(le):typeof le=="string"&&typeof K=="object"&&K!==null?D.call(K,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=n;class h{static create(N,K){return new h(N,K)}constructor(N,K){this.d=N,this.f=K,this.type=11,this.c=n.create(N,K)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=h;class b{static create(N,K,le=null){if(typeof K=="boolean")return K?p.create(N,le):v.create(N,le);const me=T.get(N);return typeof me=="boolean"?K===(me?"true":"false")?a.INSTANCE:l.INSTANCE:new b(N,K,le)}constructor(N,K,le){this.c=N,this.d=K,this.f=le,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=T.get(this.c);if(typeof N=="boolean"){const K=N?"true":"false";return this.d===K?a.INSTANCE:l.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=b;class p{static create(N,K=null){const le=T.get(N);return typeof le=="boolean"?le?a.INSTANCE:l.INSTANCE:new p(N,K)}constructor(N,K){this.c=N,this.d=K,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:V(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=T.get(this.c);return typeof N=="boolean"?N?a.INSTANCE:l.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function O(ee,N){if(typeof ee=="string"){const K=parseFloat(ee);isNaN(K)||(ee=K)}return typeof ee=="string"||typeof ee=="number"?N(ee):a.INSTANCE}class W{static create(N,K,le=null){return O(K,me=>new W(N,me,le))}constructor(N,K,le){this.c=N,this.d=K,this.f=le,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=W;class q{static create(N,K,le=null){return O(K,me=>new q(N,me,le))}constructor(N,K,le){this.c=N,this.d=K,this.f=le,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=q;class Y{static create(N,K,le=null){return O(K,me=>new Y(N,me,le))}constructor(N,K,le){this.c=N,this.d=K,this.f=le,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=Y;class x{static create(N,K,le=null){return O(K,me=>new x(N,me,le))}constructor(N,K,le){this.c=N,this.d=K,this.f=le,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:J(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=x;class M{static create(N,K){return new M(N,K)}constructor(N,K){this.d=N,this.f=K,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const K=this.f?this.f.source:"",le=N.f?N.f.source:"";return K<le?-1:K>le?1:0}equals(N){if(N.type===this.type){const K=this.f?this.f.source:"",le=N.f?N.f.source:"";return this.d===N.d&&K===le}return!1}substituteConstants(){return this}evaluate(N){const K=N.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.ContextKeyRegexExpr=M;class B{static create(N){return new B(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new B(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=B;function U(ee){let N=null;for(let K=0,le=ee.length;K<le;K++){const me=ee[K].substituteConstants();if(ee[K]!==me&&N===null){N=[];for(let ke=0;ke<K;ke++)N[ke]=ee[ke]}N!==null&&(N[K]=me)}return N===null?ee:N}class j{static create(N,K,le){return j.d(N,K,le)}constructor(N,K){this.expr=N,this.c=K,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let K=0,le=this.expr.length;K<le;K++){const me=s(this.expr[K],N.expr[K]);if(me!==0)return me}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let K=0,le=this.expr.length;K<le;K++)if(!this.expr[K].equals(N.expr[K]))return!1;return!0}return!1}substituteConstants(){const N=U(this.expr);return N===this.expr?this:j.create(N,this.c,!1)}evaluate(N){for(let K=0,le=this.expr.length;K<le;K++)if(!this.expr[K].evaluate(N))return!1;return!0}static d(N,K,le){const me=[];let ke=!1;for(const Z of N)if(!!Z){if(Z.type===1){ke=!0;continue}if(Z.type===0)return a.INSTANCE;if(Z.type===6){me.push(...Z.expr);continue}me.push(Z)}if(me.length===0&&ke)return l.INSTANCE;if(me.length!==0){if(me.length===1)return me[0];me.sort(s);for(let Z=1;Z<me.length;Z++)me[Z-1].equals(me[Z])&&(me.splice(Z,1),Z--);if(me.length===1)return me[0];for(;me.length>1;){const Z=me[me.length-1];if(Z.type!==9)break;me.pop();const ce=me.pop(),de=me.length===0,te=he.create(Z.expr.map(ae=>j.create([ae,ce],null,le)),null,de);te&&(me.push(te),me.sort(s))}if(me.length===1)return me[0];if(le){for(let Z=0;Z<me.length;Z++)for(let ce=Z+1;ce<me.length;ce++)if(me[Z].negate().equals(me[ce]))return a.INSTANCE;if(me.length===1)return me[0]}return new j(me,K)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const K of this.expr)N.push(...K.keys());return N}map(N){return new j(this.expr.map(K=>K.map(N)),null)}negate(){if(!this.c){const N=[];for(const K of this.expr)N.push(K.negate());this.c=he.create(N,this,!0)}return this.c}}class he{static create(N,K,le){return he.d(N,K,le)}constructor(N,K){this.expr=N,this.c=K,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let K=0,le=this.expr.length;K<le;K++){const me=s(this.expr[K],N.expr[K]);if(me!==0)return me}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let K=0,le=this.expr.length;K<le;K++)if(!this.expr[K].equals(N.expr[K]))return!1;return!0}return!1}substituteConstants(){const N=U(this.expr);return N===this.expr?this:he.create(N,this.c,!1)}evaluate(N){for(let K=0,le=this.expr.length;K<le;K++)if(this.expr[K].evaluate(N))return!0;return!1}static d(N,K,le){let me=[],ke=!1;if(N){for(let Z=0,ce=N.length;Z<ce;Z++){const de=N[Z];if(!!de){if(de.type===0){ke=!0;continue}if(de.type===1)return l.INSTANCE;if(de.type===9){me=me.concat(de.expr);continue}me.push(de)}}if(me.length===0&&ke)return a.INSTANCE;me.sort(s)}if(me.length!==0){if(me.length===1)return me[0];for(let Z=1;Z<me.length;Z++)me[Z-1].equals(me[Z])&&(me.splice(Z,1),Z--);if(me.length===1)return me[0];if(le){for(let Z=0;Z<me.length;Z++)for(let ce=Z+1;ce<me.length;ce++)if(me[Z].negate().equals(me[ce]))return l.INSTANCE;if(me.length===1)return me[0]}return new he(me,K)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const K of this.expr)N.push(...K.keys());return N}map(N){return new he(this.expr.map(K=>K.map(N)),null)}negate(){if(!this.c){const N=[];for(const K of this.expr)N.push(K.negate());for(;N.length>1;){const K=N.shift(),le=N.shift(),me=[];for(const ke of ue(K))for(const Z of ue(le))me.push(j.create([ke,Z],null,!1));N.unshift(he.create(me,null,!1))}this.c=he.create(N,this,!0)}return this.c}}class ie extends v{static all(){return ie.d.values()}constructor(N,K,le){super(N,null),this.f=K,typeof le=="object"?ie.d.push({...le,key:N}):le!==!0&&ie.d.push({key:N,description:le,type:K!=null?typeof K:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return i.create(this.key,N)}notEqualsTo(N){return b.create(this.key,N)}}ie.d=[],e.RawContextKey=ie,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function V(ee,N){return ee<N?-1:ee>N?1:0}function J(ee,N,K,le){return ee<K?-1:ee>K?1:N<le?-1:N>le?1:0}function ne(ee,N){if(ee.type===0||N.type===1)return!0;if(ee.type===9)return N.type===9?ve(ee.expr,N.expr):!1;if(N.type===9){for(const K of N.expr)if(ne(ee,K))return!0;return!1}if(ee.type===6){if(N.type===6)return ve(N.expr,ee.expr);for(const K of ee.expr)if(ne(K,N))return!0;return!1}return ee.equals(N)}e.implies=ne;function ve(ee,N){let K=0,le=0;for(;K<ee.length&&le<N.length;){const me=ee[K].cmp(N[le]);if(me<0)return!1;me===0&&K++,le++}return K===ee.length}function ue(ee){return ee.type===9?ee.expr:[ee]}}),define(De[204],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(De[123],Ce([1,0,173,4]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function u(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function R(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function P(d,f){switch(d){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P;function T(d,f){return f==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function D(d,f,w){return T(f,w)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===w?!0:g(w).includes(d)}e.isTargetPlatformCompatible=D;function g(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var I;(function(d){d.Install="install",d.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var C;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var E;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class r extends Error{constructor(f,w){super(f),this.code=w,this.name=w}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,c.localize)(1,null),original:"Preferences"}}),define(De[205],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(De[206],Ce([1,0,47,18,12,11,110,29,117,175,205]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=g.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends S{openTerminal(y,m){return this.spawnTerminal(c,y,D.getWindowsShell(),m)}spawnTerminal(y,m,t,o){const s=m.windowsExec||I.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=u.basename(s,".exe").toLowerCase();if(a==="cmder")return y.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),a==="wt"&&l.push("-d ."),new Promise((v,i)=>{const n=r(process),h=y.spawn(t,l,{cwd:o,env:n});h.on("error",i),h.on("exit",()=>v())})}runInTerminal(y,m,t,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:I.getDefaultTerminalWindows();return new Promise((l,v)=>{const i=`"${m} - ${k}"`,n=`""${t.join('" "')}" & pause"`,h=Object.assign({},r(process),o);Object.keys(h).filter(q=>h[q]===null).forEach(q=>delete h[q]);const b={cwd:m,env:h,windowsVerbatimArguments:!0};let p,O;u.basename(a,".exe")==="wt"?(p=a,O=["-d",".",I.b,"/c",n]):(p=I.b,O=["/c","start",i,"/wait",a,"/c",n]),c.spawn(p,O,b).on("error",q=>{v(d(q))}),l(void 0)})}static getDefaultTerminalWindows(){if(!I.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return I.d}}I.b="cmd.exe",e.WindowsExternalTerminalService=I;class C extends S{openTerminal(y,m){return this.spawnTerminal(c,y,m)}runInTerminal(y,m,t,o,s){const a=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((l,v)=>{if(a===L.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const i=a===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",y||k,"-w",m];for(const O of t)h.push("-a"),h.push(O);if(o){const O=Object.assign({},r(process),o);for(const W in O){const q=O[W];q===null?(h.push("-u"),h.push(W)):(h.push("-e"),h.push(`${W}=${q}`))}}let b="";const p=c.spawn(C.b,h);p.on("error",O=>{v(d(O))}),p.stderr.on("data",O=>{b+=O.toString()}),p.on("exit",O=>{if(O===0)l(void 0);else if(b){const W=b.split(`
`,1);v(new Error(W[0]))}else v(new Error(g.localize(1,null,i,O)))})}else v(new Error(g.localize(2,null,a)))})}spawnTerminal(y,m,t){const o=m.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const l=["-a",o];t&&l.push(t);const v=r(process),i=y.spawn("/usr/bin/open",l,{cwd:t,env:v});i.on("error",a),i.on("exit",()=>s())})}}C.b="/usr/bin/osascript",e.MacExternalTerminalService=C;class E extends S{openTerminal(y,m){return this.spawnTerminal(c,y,m)}runInTerminal(y,m,t,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((l,v)=>{const i=[];a.then(n=>{n.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const h=`${f(t)}; echo; read -p "${E.b}" -n1;`;i.push(`''${h}''`);const b=Object.assign({},r(process),o);Object.keys(b).filter(q=>b[q]===null).forEach(q=>delete b[q]);const p={cwd:m,env:b};let O="";const W=c.spawn(n,i,p);W.on("error",q=>{v(d(q))}),W.stderr.on("data",q=>{O+=q.toString()}),W.on("exit",q=>{if(q===0)l(void 0);else if(O){const Y=O.split(`
`,1);v(new Error(Y[0]))}else v(new Error(g.localize(4,null,n,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!E.d)if(!R.isLinux)E.d=Promise.resolve("xterm");else{const y=await T.Promises.exists("/etc/debian_version");E.d=new Promise(m=>{y?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return E.d}spawnTerminal(y,m,t){const o=m.linuxExec?Promise.resolve(m.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const v=r(process),i=y.spawn(l,[],{cwd:t,env:v});i.on("error",a),i.on("exit",()=>s())})})}}E.b=g.localize(3,null),e.LinuxExternalTerminalService=E;function r(w){const y={...w.env};return(0,P.sanitizeProcessEnvironment)(y),y}function d(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(g.localize(5,null,w.path)):w}function f(w){let y="";for(const m of w)m.indexOf(" ")>=0?y+='"'+m+'"':y+=m,y+=" ";return y}}),define(De[45],Ce([1,0,69,12,8,10,2,176,4,11,18]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var S;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var I;(function(V){V[V.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function r(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=r;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function f(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function w(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=w;function y(V){return E(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var m;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(J,ne){const ve=new t(J.toString(),ne);return a(ve,ne),ve}constructor(J,ne){super(J),this.code=ne}}e.FileSystemProviderError=t;function o(V,J){return t.create(V,J)}e.createFileSystemProviderError=o;function s(V){return V||o((0,T.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=s;function a(V,J){return V.name=J?`${J} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=a;function l(V){if(!V)return m.Unknown;if(V instanceof t)return V.code;const J=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!J)return m.Unknown;switch(J[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=l;function v(V){if(V instanceof O)return V.fileOperationResult;switch(l(V)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var i;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(J,ne,ve){this.resource=J,this.operation=ne,this.target=ve}isOperation(J){return this.operation===J}}e.FileOperationEvent=n;var h;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class b{constructor(J,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ve=new Map;for(const ue of J){const ee=ve.get(ue.type);switch(ee?ee.push([ue.resource,ue]):ve.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,ee]of ve)switch(ue){case 1:this.a=c.TernarySearchTree.forUris(()=>ne),this.a.fill(ee);break;case 0:this.b=c.TernarySearchTree.forUris(()=>ne),this.b.fill(ee);break;case 2:this.c=c.TernarySearchTree.forUris(()=>ne),this.c.fill(ee);break}}contains(J,...ne){return this.d(J,{includeChildren:!1},...ne)}affects(J,...ne){return this.d(J,{includeChildren:!0},...ne)}d(J,ne,...ve){if(!J)return!1;const ue=ve.length>0;return!!((!ue||ve.includes(1))&&(this.a?.get(J)||ne.includeChildren&&this.a?.findSuperstr(J))||(!ue||ve.includes(0))&&(this.b?.get(J)||ne.includeChildren&&this.b?.findSuperstr(J))||(!ue||ve.includes(2))&&(this.c?.findSubstr(J)||ne.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=b;function p(V,J,ne){return!V||!J||V===J||J.length>V.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),ne?(0,u.startsWithIgnoreCase)(V,J):V.indexOf(J)===0)}e.isParent=p;class O extends Error{constructor(J,ne,ve){super(J),this.fileOperationResult=ne,this.options=ve}}e.FileOperationError=O;class W extends O{constructor(J,ne,ve,ue){super(J,ne,ue),this.fileOperationResult=ne,this.size=ve}}e.TooLargeFileOperationError=W;class q extends O{constructor(J,ne,ve){super(J,2,ve),this.stat=ne}}e.NotModifiedSinceFileOperationError=q;var Y;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=M;async function B(V,J){if(!J.hasProvider(P.URI.from({scheme:V.scheme})))return new Promise(ne=>{const ve=J.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===V.scheme&&ue.added&&(ve.dispose(),ne())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<U.KB?(0,T.localize)(1,null,J.toFixed(0)):J<U.MB?(0,T.localize)(2,null,(J/U.KB).toFixed(2)):J<U.GB?(0,T.localize)(3,null,(J/U.MB).toFixed(2)):J<U.TB?(0,T.localize)(4,null,(J/U.GB).toFixed(2)):(0,T.localize)(5,null,(J/U.TB).toFixed(2))}}U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB,e.ByteSize=U;var j;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=he;function ie(V){const J=typeof V=="string"||V?.scheme===L.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===L.Schemas.file?1024*U.MB:J?10*U.MB:g.isWeb?50*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=ie}),define(De[92],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...u){this.a=new Map;for(const[R,P]of u)this.set(R,P)}set(u,R){const P=this.a.get(u);return this.a.set(u,R),P}has(u){return this.a.has(u)}get(u){return this.a.get(u)}}e.ServiceCollection=c}),define(De[207],Ce([1,0,19,9,6,90,203,4,92,66]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class k extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class S{constructor(r=new D.ServiceCollection,d=!1,f,w=L){this.f=r,this.g=d,this.h=f,this.i=w,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=w?f?._globalGraph??new P.Graph(y=>y):void 0}createChild(r){return new S(r,this.g,this,this.i)}invokeFunction(r,...d){const f=C.traceInvocation(this.i,r);let w=!1;try{return r({get:m=>{if(w)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(m,f);if(!t)throw new Error(`[invokeFunction] unknown service '${m}'`);return t}},...d)}finally{w=!0,f.stop()}}createInstance(r,...d){let f,w;return r instanceof R.SyncDescriptor?(f=C.traceCreation(this.i,r.ctor),w=this.j(r.ctor,r.staticArguments.concat(d),f)):(f=C.traceCreation(this.i,r),w=this.j(r,d,f)),f.stop(),w}j(r,d=[],f){const w=T._util.getServiceDependencies(r).sort((t,o)=>t.index-o.index),y=[];for(const t of w){const o=this.m(t.id,f);o||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(o)}const m=w.length>0?w[0].index:d.length;if(d.length!==m){console.trace(`[createInstance] First service dependency of ${r.name} at position ${m+1} conflicts with ${d.length} static arguments`);const t=m-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,m)}return Reflect.construct(r,d.concat(y))}k(r,d){if(this.f.get(r)instanceof R.SyncDescriptor)this.f.set(r,d);else if(this.h)this.h.k(r,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const d=this.f.get(r);return!d&&this.h?this.h.l(r):d}m(r,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const f=this.l(r);return f instanceof R.SyncDescriptor?this.q(r,f,d.branch(r,!0)):(d.branch(r,!1),f)}q(r,d,f){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,d,f)}finally{this.o.delete(r)}}r(r,d,f){const w=new P.Graph(t=>t.id.toString());let y=0;const m=[{id:r,desc:d,_trace:f}];for(;m.length;){const t=m.pop();if(w.lookupOrInsertNode(t),y++>1e3)throw new k(w);for(const o of T._util.getServiceDependencies(t.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof R.SyncDescriptor){const a={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};w.insertEdge(t,a),m.push(a)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:o}of t){if(this.l(o.id)instanceof R.SyncDescriptor){const a=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,a)}w.removeNode(o)}}return this.l(r)}s(r,d,f=[],w,y){if(this.f.get(r)instanceof R.SyncDescriptor)return this.t(r,d,f,w,y);if(this.h)return this.h.s(r,d,f,w,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(r,d,f=[],w,y){if(w){const m=new S(void 0,this.g,this,this.i);m.c=String(r);const t=new Map,o=new c.IdleValue(()=>{const s=m.j(d,f,y);for(const[a,l]of t){const v=s[a];if(typeof v=="function")for(const i of l)v.apply(s,i)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let i=t.get(a);return i||(i=new g.LinkedList,t.set(a,i)),(h,b,p)=>{const O=i.push([h,b,p]);return(0,u.toDisposable)(O)}}if(a in s)return s[a];const l=o.value;let v=l[a];return typeof v!="function"||(v=v.bind(l),s[a]=v),v},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return d.prototype}})}else return this.j(d,f,y)}u(r,d){if(d&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=S;var I;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(I||(I={}));class C{static traceInvocation(r,d){return r?new C(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(r,d){return r?new C(1,d.name):C.c}constructor(r,d){this.type=r,this.name=d,this.g=Date.now(),this.h=[]}branch(r,d){const f=new C(3,r.toString());return this.h.push([r,d,f]),f}stop(){const r=Date.now()-this.g;C.f+=r;let d=!1;function f(y,m){const t=[],o=new Array(y+1).join("	");for(const[s,a,l]of m.h)if(a&&l){d=!0,t.push(`${o}CREATES -> ${s}`);const v=f(y+1,l);v&&t.push(v)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(r>2||d)&&C.all.add(w.join(`
`))}}C.all=new Set,C.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C.f=0,e.Trace=C}),define(De[16],Ce([1,0,46,3,68,6,28,11,24,10,2,44,4]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function I(){return new Date().toISOString()}function C(h){return(0,g.isNumber)(h)}e.isLogLevel=C;var E;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function r(h,b,p){switch(b){case E.Trace:h.trace(p);break;case E.Debug:h.debug(p);break;case E.Info:h.info(p);break;case E.Warning:h.warn(p);break;case E.Error:h.error(p);break;case E.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=r;function d(h,b=!1){let p="";for(let O=0;O<h.length;O++){let W=h[O];if(W instanceof Error&&(W=(0,c.toErrorMessage)(W,b)),typeof W=="object")try{W=JSON.stringify(W)}catch{}p+=(O>0?" ":"")+W}return p}class f extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==E.Off&&this.b<=b}}e.AbstractLogger=f;class w extends f{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...p){this.f(E.Trace)&&this.g(E.Trace,d([b,...p],!0))}debug(b,...p){this.f(E.Debug)&&this.g(E.Debug,d([b,...p]))}info(b,...p){this.f(E.Info)&&this.g(E.Info,d([b,...p]))}warn(b,...p){this.f(E.Warning)&&this.g(E.Warning,d([b,...p]))}error(b,...p){if(this.f(E.Error))if(b instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=b.stack,this.g(E.Error,d(O))}else this.g(E.Error,d([b,...p]))}flush(){}}e.AbstractMessageLogger=w;class y extends f{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.g=!T.isWindows}trace(b,...p){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,b,...p):console.log(`[main ${I()}]`,b,...p))}debug(b,...p){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,b,...p):console.log(`[main ${I()}]`,b,...p))}info(b,...p){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,b,...p):console.log(`[main ${I()}]`,b,...p))}warn(b,...p){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,b,...p):console.warn(`[main ${I()}]`,b,...p))}error(b,...p){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,b,...p):console.error(`[main ${I()}]`,b,...p))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class m extends f{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b)}trace(b,...p){this.f(E.Trace)&&console.log("%cTRACE","color: #888",b,...p)}debug(b,...p){this.f(E.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",b,...p)}info(b,...p){this.f(E.Info)&&console.log("%c INFO","color: #33f",b,...p)}warn(b,...p){this.f(E.Warning)&&console.log("%c WARN","color: #993",b,...p)}error(b,...p){this.f(E.Error)&&console.log("%c  ERR","color: #f33",b,...p)}dispose(){}flush(){}}e.ConsoleLogger=m;class t extends f{constructor(b,p=e.DEFAULT_LOG_LEVEL){super(),this.g=b,this.setLevel(p)}trace(b,...p){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(b),...p])}debug(b,...p){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(b),...p])}info(b,...p){this.f(E.Info)&&this.g.log(E.Info,[this.h(b),...p])}warn(b,...p){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(b),...p])}error(b,...p){this.f(E.Error)&&this.g.log(E.Error,[this.h(b),...p])}h(b){return typeof b=="string"?b:(0,c.toErrorMessage)(b,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class o extends f{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const p of this.g)p.setLevel(b);super.setLevel(b)}trace(b,...p){for(const O of this.g)O.trace(b,...p)}debug(b,...p){for(const O of this.g)O.debug(b,...p)}info(b,...p){for(const O of this.g)O.info(b,...p)}warn(b,...p){for(const O of this.g)O.warn(b,...p)}error(b,...p){for(const O of this.g)O.error(b,...p)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.MultiplexLogger=o;class s extends R.Disposable{constructor(b,p,O){if(super(),this.h=b,this.j=p,this.b=new P.ResourceMap,this.c=this.D(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new A.Emitter),this.onDidChangeVisibility=this.g.event,O)for(const W of O)this.b.set(W.resource,{logger:void 0,info:W})}k(b){return(0,g.isString)(b)?[...this.b.values()].find(p=>p.info.id===b):this.b.get(b)}getLogger(b){return this.k(b)?.logger}createLogger(b,p){const O=this.l(b),W=(0,g.isString)(b)?b:p?.id??(0,u.hash)(O.toString()).toString(16);let q=this.b.get(O)?.logger;const Y=p?.logLevel==="always"?E.Trace:p?.logLevel;q||(q=this.m(O,Y??this.getLogLevel(O)??this.h,{...p,id:W}));const x={logger:q,info:{resource:O,id:W,logLevel:Y,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(x.info),this.b.set(O,x),q}l(b){return(0,g.isString)(b)?(0,D.joinPath)(this.j,`${b}.log`):b}setLogLevel(b,p){if(L.URI.isUri(b)){const O=b,W=p,q=this.b.get(O);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([O,W]))}else{this.h=b;for(const[O,W]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,p){const O=this.k(b);O&&p!==!O.info.hidden&&(O.info.hidden=!p,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,p]))}getLogLevel(b){let p;return b&&(p=this.b.get(b)?.info.logLevel),p??this.h}registerLogger(b){const p=this.b.get(b.resource);p?p.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const p=this.b.get(b);p&&(p.logger&&p.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class a{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(b){}getLevel(){return E.Info}trace(b,...p){}debug(b,...p){}info(b,...p){}warn(b,...p){}error(b,...p){}critical(b,...p){}dispose(){}flush(){}}e.NullLogger=a;class l extends a{}e.NullLogService=l;function v(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const b=n(h.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function i(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=i;function n(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=n,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",i(E.Info))}),define(De[208],Ce([1,0,6,16]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends c.Disposable{constructor(P,T=[]){super(),this.a=new A.MultiplexLogger([P,...T]),this.D(P.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...T){this.a.trace(P,...T)}debug(P,...T){this.a.debug(P,...T)}info(P,...T){this.a.info(P,...T)}warn(P,...T){this.a.warn(P,...T)}error(P,...T){this.a.error(P,...T)}flush(){this.a.flush()}}e.LogService=u}),define(De[209],Ce([1,0,45,16]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(u||(u={}));async function R(g,L,k,S,I){try{const C=await new Promise((r,d)=>{re(["spdlog"],r,d)});C.setFlushOn(u.Trace);const E=await C.createAsyncRotatingLogger(g,L,k,S);return I?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(C){console.error(C)}return null}function P(g,L,k){switch(L){case A.LogLevel.Trace:g.trace(k);break;case A.LogLevel.Debug:g.debug(k);break;case A.LogLevel.Info:g.info(k);break;case A.LogLevel.Warning:g.warn(k);break;case A.LogLevel.Error:g.error(k);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function T(g,L){switch(L){case A.LogLevel.Trace:g.setLevel(u.Trace);break;case A.LogLevel.Debug:g.setLevel(u.Debug);break;case A.LogLevel.Info:g.setLevel(u.Info);break;case A.LogLevel.Warning:g.setLevel(u.Warning);break;case A.LogLevel.Error:g.setLevel(u.Error);break;case A.LogLevel.Off:g.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class D extends A.AbstractMessageLogger{constructor(L,k,S,I,C){super(),this.k=[],this.setLevel(C),this.l=this.n(L,k,S,I),this.D(this.onDidChangeLogLevel(E=>{this.m&&T(this.m,E)}))}async n(L,k,S,I){const C=S?6:1,E=30/C*c.ByteSize.MB,r=await R(L,k,E,C,I);if(r){this.m=r,T(this.m,this.getLevel());for(const{level:d,message:f}of this.k)P(this.m,d,f);this.k=[]}}g(L,k){this.m?P(this.m,L,k):this.getLevel()<=L&&this.k.push({level:L,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.q():this.l.then(()=>this.q())}q(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=D}),define(De[124],Ce([1,0,37,177,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var P;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function g(C,E){return E-C}D.compare=g;const L=Object.create(null);L[D.Error]=(0,A.localize)(0,null),L[D.Warning]=(0,A.localize)(1,null),L[D.Info]=(0,A.localize)(2,null);function k(C){return L[C]||""}D.toString=k;function S(C){switch(C){case c.default.Error:return D.Error;case c.default.Warning:return D.Warning;case c.default.Info:return D.Info;case c.default.Ignore:return D.Hint}}D.fromSeverity=S;function I(C){switch(C){case D.Error:return c.default.Error;case D.Warning:return c.default.Warning;case D.Info:return c.default.Info;case D.Hint:return c.default.Ignore}}D.toSeverity=I}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(D){const g="";function L(S){return k(S,!0)}D.makeKey=L;function k(S,I){const C=[g];return S.source?C.push(S.source.replace("\xA6","\\\xA6")):C.push(g),S.code?typeof S.code=="string"?C.push(S.code.replace("\xA6","\\\xA6")):C.push(S.code.value.replace("\xA6","\\\xA6")):C.push(g),S.severity!==void 0&&S.severity!==null?C.push(P.toString(S.severity)):C.push(g),S.message&&I?C.push(S.message.replace("\xA6","\\\xA6")):C.push(g),S.startLineNumber!==void 0&&S.startLineNumber!==null?C.push(S.startLineNumber.toString()):C.push(g),S.startColumn!==void 0&&S.startColumn!==null?C.push(S.startColumn.toString()):C.push(g),S.endLineNumber!==void 0&&S.endLineNumber!==null?C.push(S.endLineNumber.toString()):C.push(g),S.endColumn!==void 0&&S.endColumn!==null?C.push(S.endColumn.toString()):C.push(g),C.push(g),C.join("\xA6")}D.makeKeyOptionalMessage=k})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(De[210],Ce([1,0,3,37,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,u.createDecorator)("notificationService");var R;(function(g){g[g.WORKSPACE=0]="WORKSPACE",g[g.PROFILE=1]="PROFILE",g[g.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(g){g[g.OFF=0]="OFF",g[g.SILENT=1]="SILENT",g[g.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new D,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=T;class D{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=D}),define(De[125],Ce([1,0,8,2,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function R(g,L){return A.URI.isUri(g)?(0,c.equalsIgnoreCase)(g.scheme,L):(0,c.startsWithIgnoreCase)(g,L+":")}e.matchesScheme=R;function P(g,...L){return L.some(k=>R(g,k))}e.matchesSomeScheme=P;function T(g,L){return g.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=T;function D(g){let L;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(L={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:L,uri:g}}e.extractSelection=D}),define(De[211],Ce([1,0,11,36]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const R=c.globals.vscode.context.configuration();if(R)u=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:R.version})}}else u={},Object.keys(u).length===0&&Object.assign(u,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(De[212],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(re,e){return function(c,A){e(c,A,re)}};define(De[126],Ce([1,0,19,21,6,4]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(k){this.b=k}report(k){this.a=k,this.b(this.a)}}T.None=Object.freeze({report(){}}),e.Progress=T;let D=class extends u.Disposable{constructor(k,S){super(),this.a=new c.DeferredPromise,S.withProgress(k,I=>(this.b=I,this.c&&I.report(this.c),this.a.p)),this.D((0,u.toDisposable)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};D=Ve([We(1,e.IProgressService)],D),e.UnmanagedProgress=D;class g extends u.Disposable{constructor(k){super(),this.g=k,this.a=0,this.b=this.D(new u.DisposableStore)}start(k){this.stop();const S=++this.a,I=new A.CancellationTokenSource;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,u.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,u.toDisposable)(()=>I.cancel())),this.b.add((0,u.toDisposable)(()=>this.c?this.c.done():void 0)),{id:S,token:I.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.LongRunningOperation=g,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(De[39],Ce([1,0,51,10]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.a=new Map}add(P,T){c.ok(A.isString(P)),c.ok(A.isObject(T)),c.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,T)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.Registry=new u}),define(De[93],Ce([1,0,3,39]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[u(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const P=new R;A.Registry.add(e.Extensions.JSONContribution,P)}),define(De[127],Ce([1,0,17,3,10,170,54,93,39]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=D.Registry.as(T.Extensions.JSONContribution);class S{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.n(t,o,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.o(t,o),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.o(o,s),this.n(t,!1,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const s=[];for(const{overrides:a,source:l}of t)for(const v in a)if(o.add(v),e.OVERRIDE_PROPERTY_REGEX.test(v)){const i=this.a.get(v),n=i?.valuesSources??new Map;if(l)for(const O of Object.keys(a[v]))n.set(O,l);const h={...i?.value||{},...a[v]};this.a.set(v,{source:l,value:h,valuesSources:n});const b=(0,P.getLanguageTagSettingPlainKey)(v),p={type:"object",default:h,description:R.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:u.isString(l)?void 0:l,defaultValueSource:l};s.push(...E(v)),this.d[v]=p,this.b.properties[v]=p}else{this.a.set(v,{value:a[v],source:l});const i=this.d[v];i&&(this.w(v,i),this.r(v,i))}this.m(s)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:s,source:a}of t)for(const l in s){const v=this.a.get(l),i=u.isString(a)?a:a?.id,n=u.isString(v?.source)?v?.source:v?.source?.id;if(i===n)if(o.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const h=this.d[l];h&&(this.w(l,h),this.r(l,h))}}this.u()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,s){t.forEach(a=>{this.p(a,o,a.extensionInfo,a.restrictedProperties,void 0,s),this.c.push(a),this.q(a)})}o(t,o){const s=a=>{if(a.properties)for(const l in a.properties){o.add(l);const v=this.d[l];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[l],this.s(l,a.properties[l])}a.allOf?.forEach(l=>s(l))};for(const a of t){s(a);const l=this.c.indexOf(a);l!==-1&&this.c.splice(l,1)}}p(t,o=!0,s,a,l=3,v){l=u.isUndefinedOrNull(t.scope)?l:t.scope;const i=t.properties;if(i)for(const h in i){const b=i[h];if(o&&w(h,b)){delete i[h];continue}if(b.source=s,b.defaultDefaultValue=i[h].default,this.w(h,b),e.OVERRIDE_PROPERTY_REGEX.test(h)?b.scope=void 0:(b.scope=u.isUndefinedOrNull(b.scope)?l:b.scope,b.restricted=u.isUndefinedOrNull(b.restricted)?!!a?.includes(h):b.restricted),i[h].hasOwnProperty("included")&&!i[h].included){this.f[h]=i[h],delete i[h];continue}else this.d[h]=i[h],i[h].policy?.name&&this.e.set(i[h].policy.name,h);!i[h].deprecationMessage&&i[h].markdownDeprecationMessage&&(i[h].deprecationMessage=i[h].markdownDeprecationMessage),v.add(h)}const n=t.allOf;if(n)for(const h of n)this.p(h,o,s,a,l,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=s=>{const a=s.properties;if(a)for(const v in a)this.r(v,a[v]);s.allOf?.forEach(o)};o(t)}r(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,o){const s=this.a.get(t);let a=s?.value,l=s?.source;u.isUndefined(a)&&(a=o.defaultDefaultValue,l=void 0),u.isUndefined(a)&&(a=d(o.type)),o.default=a,o.defaultValueSource=l}}const I="\\[([^\\]]+)\\]",C=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(m){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let o=C.exec(m);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=C.exec(m)}}return(0,c.distinct)(t)}e.overrideIdentifiersFromKey=E;function r(m){return m.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=r;function d(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new S;D.Registry.add(e.Extensions.Configuration,f);function w(m,t){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?R.localize(7,null,m):f.getConfigurationProperties()[m]!==void 0?R.localize(8,null,m):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,m,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=w;function y(){const m=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))m.push([o,t[o].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=y}),define(De[213],Ce([1,0,17,3,147,6,28,23,10,2,54,127,39]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(o){return Object.isFrozen(o)?o:T.deepFreeze(o)}class C{constructor(s={},a=[],l=[],v){this.b=s,this.c=a,this.d=l,this.raw=v,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof C)return a;const l=new E("");return l.parseRaw(a),l.configurationModel});this.f=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const l=this.rawConfiguration.getValue(s),v=a?this.rawConfiguration.getOverrideValue(s,a):void 0,i=a?this.rawConfiguration.override(a).getValue(s):l;return{value:l,override:v,merged:i}}getOverrideValue(s,a){const l=this.i(a);return l?s?(0,L.getConfigurationValue)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return c.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return c.distinct(s)}override(s){let a=this.a.get(s);return a||(a=this.g(s),this.a.set(s,a)),a}merge(...s){const a=T.deepClone(this.contents),l=T.deepClone(this.overrides),v=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const n of s)if(i.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.h(a,n.contents);for(const h of n.overrides){const[b]=l.filter(p=>c.equals(p.identifiers,h.identifiers));b?(this.h(b.contents,h.contents),b.keys.push(...h.keys),b.keys=c.distinct(b.keys)):l.push(T.deepClone(h))}for(const h of n.keys)v.indexOf(h)===-1&&v.push(h)}return new C(a,v,l,i.every(n=>n instanceof C)?void 0:i)}g(s){const a=this.i(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const v of c.distinct([...Object.keys(this.contents),...Object.keys(a)])){let i=this.contents[v];const n=a[v];n&&(typeof i=="object"&&typeof n=="object"?(i=T.deepClone(i),this.h(i,n)):i=n),l[v]=i}return new C(l,this.keys,this.overrides)}h(s,a){for(const l of Object.keys(a)){if(l in s&&D.isObject(s[l])&&D.isObject(a[l])){this.h(s[l],a[l]);continue}s[l]=T.deepClone(a[l])}}i(s){let a=null,l=null;const v=i=>{i&&(l?this.h(l,i):l=T.deepClone(i))};for(const i of this.overrides)c.equals(i.identifiers,[s])?a=i.contents:i.identifiers.includes(s)&&v(i.contents);return v(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.j(s,a,!0)}setValue(s,a){this.j(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,L.removeFromValueTree)(this.contents,s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>c.equals(l.identifiers,(0,k.overrideIdentifiersFromKey)(s))),1))}j(s,a,l){(0,L.addToValueTree)(this.contents,s,a,v=>console.error(v)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],v=>console.error(v))})}}e.ConfigurationModel=C;class E{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!D.isUndefinedOrNull(s)){const l=this.g(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:v,overrides:i,restricted:n,hasExcludedProperties:h}=this.h(s,a);this.b=new C(l,v,i,h?[s]:void 0),this.c=n||[]}g(s){let a={},l=null,v=[];const i=[],n=[];function h(p){Array.isArray(v)?v.push(p):l!==null&&(v[l]=p)}const b={onObjectBegin:()=>{const p={};h(p),i.push(v),v=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{v=i.pop()},onArrayBegin:()=>{const p=[];h(p),i.push(v),v=p,l=null},onArrayEnd:()=>{v=i.pop()},onLiteralValue:h,onError:(p,O,W)=>{n.push({error:p,offset:O,length:W})}};if(s)try{u.visit(s,b),a=v[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return a}h(s,a){const l=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),v=this.i(s,l,!0,a);s=v.raw;const i=(0,L.toValuesTree)(s,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),n=Object.keys(s),h=this.j(s,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:i,keys:n,overrides:h,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}i(s,a,l,v){let i=!1;if(!v?.scopes&&!v?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:i};const n={},h=[];for(const b in s)if(k.OVERRIDE_PROPERTY_REGEX.test(b)&&l){const p=this.i(s[b],a,!1,v);n[b]=p.raw,i=i||p.hasExcludedProperties,h.push(...p.restricted)}else{const p=a[b],O=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&h.push(b),(O===void 0||v.scopes===void 0||v.scopes.includes(O))&&!(v.skipRestricted&&p?.restricted)?n[b]=s[b]:i=!0}return{raw:n,restricted:h,hasExcludedProperties:i}}j(s,a){const l=[];for(const v of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(v)){const i={};for(const n in s[v])i[n]=s[v][n];l.push({identifiers:(0,k.overrideIdentifiersFromKey)(v),keys:Object.keys(i),contents:(0,L.toValuesTree)(i,a)})}return l}}e.ConfigurationModelParser=E;class r extends R.Disposable{constructor(s,a,l,v){super(),this.f=s,this.g=a,this.h=v,this.c=this.D(new A.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(l.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(A.Event.any(A.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&l.isEqual(i.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class d{constructor(s,a,l,v,i,n,h,b,p,O,W,q,Y){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=v,this.d=i,this.f=n,this.g=h,this.h=b,this.i=p,this.j=O,this.k=W,this.l=q,this.m=Y}get value(){return I(this.c)}n(s,a,l){const v=s.inspect(a,l);return{get value(){return I(v.value)},get override(){return I(v.override)},get merged(){return I(v.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(s,a,l,v,i=new C,n=new C,h=new P.ResourceMap,b=new C,p=new P.ResourceMap){this.c=s,this.d=a,this.f=l,this.g=v,this.h=i,this.i=n,this.j=h,this.l=b,this.m=p,this.a=null,this.b=new P.ResourceMap,this.n=null}getValue(s,a,l){return this.q(s,a,l).getValue(s)}updateValue(s,a,l={}){let v;l.resource?(v=this.m.get(l.resource),v||(v=new C,this.m.set(l.resource,v))):v=this.l,a===void 0?v.removeValue(s):v.setValue(s,a),l.resource||(this.a=null)}inspect(s,a,l){const v=this.q(s,a,l),i=this.u(a.resource,l),n=a.resource?this.m.get(a.resource)||this.l:this.l,h=new Set;for(const b of v.overrides)for(const p of b.identifiers)v.getOverrideValue(s,p)!==void 0&&h.add(p);return new d(s,a,v.getValue(s),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,i||void 0,n)}keys(s){const a=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.j.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:v,updated:i,removed:n}=m(this.c,s);a=[...v,...i,...n]}for(const v of a)for(const i of(0,k.overrideIdentifiersFromKey)(v)){const n=this.c.getKeysForOverrideIdentifier(i),h=s.getKeysForOverrideIdentifier(i),b=[...h.filter(p=>n.indexOf(p)===-1),...n.filter(p=>h.indexOf(p)===-1),...n.filter(p=>!T.equals(this.c.override(i).getValue(p),s.override(i).getValue(p)))];l.push([i,b])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:v}=m(this.d,s),i=[...a,...l,...v];return i.length&&this.updatePolicyConfiguration(s),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:v,overrides:i}=m(this.applicationConfiguration,s),n=[...a,...l,...v];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:v,overrides:i}=m(this.localUserConfiguration,s),n=[...a,...l,...v];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:i}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:v,overrides:i}=m(this.remoteUserConfiguration,s),n=[...a,...l,...v];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:i}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:v,overrides:i}=m(this.workspaceConfiguration,s),n=[...a,...l,...v];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:i}}compareAndUpdateFolderConfiguration(s,a){const l=this.p.get(s),{added:v,updated:i,removed:n,overrides:h}=m(l,a),b=[...v,...i,...n];return(b.length||!l)&&this.updateFolderConfiguration(s,a),{keys:b,overrides:h}}compareAndDeleteFolderConfiguration(s){const a=this.p.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:v,removed:i,overrides:n}=m(a,void 0);return{keys:[...l,...v,...i],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,a,l){let v=this.r(a,l);return a.overrideIdentifier&&(v=v.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(v=v.merge(this.d)),v}r({resource:s},a){let l=this.s();if(a&&s){const v=a.getFolder(s);v&&(l=this.t(v.uri)||l);const i=this.m.get(s);i&&(l=l.merge(i))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let a=this.b.get(s);if(!a){const l=this.s(),v=this.j.get(s);v?(a=l.merge(v),this.b.set(s,a)):a=l}return a}u(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,a)=>{const{contents:l,overrides:v,keys:i}=this.j.get(a);return s.push([a,{contents:l,overrides:v,keys:i}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.i.keys.forEach(a=>s.add(a)),this.j.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}w(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.i.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(v=>a.add(v))),[...a.values()]}static parse(s){const a=this.x(s.defaults),l=this.x(s.policy),v=this.x(s.application),i=this.x(s.user),n=this.x(s.workspace),h=s.folders.reduce((b,p)=>(b.set(g.URI.revive(p[0]),this.x(p[1])),b),new P.ResourceMap);return new f(a,l,v,i,new C,n,h,new C,new P.ResourceMap)}static x(s){return new C(s.contents,s.keys,s.overrides)}}e.Configuration=f;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const v of o)v.keys.forEach(i=>s.add(i)),v.overrides.forEach(([i,n])=>{const h=(0,P.getOrSet)(a,i,new Set);n.forEach(b=>h.add(b))});const l=[];return a.forEach((v,i)=>l.push([i,[...v.values()]])),{keys:[...s.values()],overrides:l}}e.mergeChanges=w;class y{constructor(s,a,l,v){this.change=s,this.f=a,this.g=l,this.h=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of s.keys)this.affectedKeys.add(i);for(const[,i]of s.overrides)for(const n of i)this.affectedKeys.add(n);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,a){const l=this.a+s,v=this.d.indexOf(l);if(v<0)return!1;const i=v+l.length;if(i>=this.d.length)return!1;const n=this.d.charCodeAt(i);if(n!==this.b&&n!==this.c)return!1;if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,b=this.g.getValue(s,a,this.h);return!T.equals(h,b)}return!0}}e.ConfigurationChangeEvent=y;function m(o,s){const{added:a,removed:l,updated:v}=t(s?.rawConfiguration,o?.rawConfiguration),i=[],n=o?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const b=h.filter(p=>!n.includes(p));for(const p of b)i.push([p,s.getKeysForOverrideIdentifier(p)])}if(o){const b=n.filter(p=>!h.includes(p));for(const p of b)i.push([p,o.getKeysForOverrideIdentifier(p)])}if(s&&o){for(const b of n)if(h.includes(b)){const p=t({contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)},{contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)});i.push([b,[...p.added,...p.removed,...p.updated]])}}return{added:a,removed:l,updated:v,overrides:i}}function t(o,s){const a=o?s?o.keys.filter(i=>s.keys.indexOf(i)===-1):[...o.keys]:[],l=s?o?s.keys.filter(i=>o.keys.indexOf(i)===-1):[...s.keys]:[],v=[];if(o&&s){for(const i of s.keys)if(o.keys.indexOf(i)!==-1){const n=(0,L.getConfigurationValue)(s.contents,i),h=(0,L.getConfigurationValue)(o.contents,i);T.equals(n,h)||v.push(i)}}return{added:a,removed:l,updated:v}}}),define(De[128],Ce([1,0,9,4]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var u;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(u=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends c.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof R&&D._code===u.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof R&&D._code===u.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof R&&D._code===u.NoResolverFound}static isHandled(D){return D instanceof R&&D.isHandled}constructor(D,g=u.Unknown,L){super(D),this._message=D,this._code=g,this._detail=L,this.isHandled=g===u.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function P(T){const D=T.indexOf("+");return D===-1?T:T.substring(0,D)}e.getRemoteAuthorityPrefix=P}),define(De[73],Ce([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(g){return g.scheme===c.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=A;function u(g){if(!g)return;const L=g.indexOf("+");return L<0?g:g.substr(0,L)}e.getRemoteName=u;function R(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=R;function P(g){const{host:L,port:k}=D(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:k}}e.parseAuthorityWithPort=P;function T(g,L){let{host:k,port:S}=D(g);return typeof S>"u"&&(S=L),{host:k,port:S}}e.parseAuthorityWithOptionalPort=T;function D(g){const L=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=g.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:g,port:void 0}}}),define(De[25],Ce([1,0,8,4,73]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var T;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,d){if(typeof r>"u"||r===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof r=="string"||typeof d=="string"){const f=typeof r=="string"?r:r.value,w=typeof d=="string"?d:d.value;return c.equalsIgnoreCase(f,w)}return r.c===d.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=D;class g{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const d of r)this.add(d)}add(r){this.c.add(D.toKey(r))}delete(r){return this.c.delete(D.toKey(r))}has(r){return this.c.has(D.toKey(r))}}e.ExtensionIdentifierSet=g;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(D.toKey(r))}get(r){return this.c.get(D.toKey(r))}has(r){return this.c.has(D.toKey(r))}set(r,d){this.c.set(D.toKey(r),d)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function k(E){return S(E)}e.isApplicationScopedExtension=k;function S(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function I(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(E,r){if(r){const d=`onResolveRemoteAuthority:${(0,u.getRemoteName)(r)}`;return!!E.activationEvents?.includes(d)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[129],Ce([1,0,9,25]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class u{constructor(){this.a=new Map,this.b=new WeakMap}register(P,T){this.a.set(P,T)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const T=Object.create(null);for(const D of P){const g=this.readActivationEvents(D);g.length>0&&(T[A.ExtensionIdentifier.toKey(D.identifier)]=g)}return T}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const T=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return T;for(const D in P.contributes){const g=this.a.get(D);if(!g)continue;const L=P.contributes[D],k=Array.isArray(L)?L:[L];try{g(k,T)}catch(S){(0,c.onUnexpectedError)(S)}}return T}}e.ImplicitActivationEventsImpl=u,e.ImplicitActivationEvents=new u}),define(De[214],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((u,R)=>re(["vsda"],u,R))}async createNewMessage(u){try{const R=await this.c(),P=new R.validator;if(P){const T=String(c.a++);return this.b.set(T,P),{id:T,data:P.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,R){if(!u.id)return!0;const P=this.b.get(u.id);if(!P)return!1;this.b.delete(u.id);try{return P.validate(R)==="ok"}catch{return!1}}async sign(u){try{const R=await this.c(),P=new R.signer;if(P)return P.sign(u)}catch{}return u}}c.a=1,e.SignService=c}),define(De[215],Ce([1,0,11,36,2,30]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(g){if(c.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function T(g,L,k,S,I,C,E,r,d,f){const w=Object.create(null);w["common.machineId"]=E,w.sessionID=(0,R.generateUuid)()+Date.now(),w.commitHash=I,w.version=C,w["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,c.PlatformToString)(c.platform),w["common.nodePlatform"]=A.platform,w["common.nodeArch"]=S,w["common.product"]=f||"desktop",r&&(w["common.msftInternal"]=r);let y=0;const m=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),c.isLinuxSnap&&(w["common.snap"]="true");const t=P(k);t&&(w["common.platformDetail"]=t);try{const o=await g.readFile(u.URI.file(d));w["common.source"]=o.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=T;function D(g){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const k=L.toLowerCase();return g.some(S=>k===S)}e.verifyMicrosoftInternalDomain=D}),define(De[216],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var u;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(u=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[74],Ce([1,0,23,10,3,54,73,215,216]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(l){this.value=l}}e.TelemetryTrustedValue=g;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,v){return Promise.resolve(void 0)}publicLog2(l,v){return this.publicLog(l,v)}publicLogError(l,v){return Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class k{async publicLog(l,v,i){}async publicLogError(l,v,i){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(a,l){return u.Event.debounce(l.onDidChangeConfiguration,(i,n)=>{const h=i?new Set([...i.affectedKeys,...n.affectedKeys]):n.affectedKeys;return{...n,affectedKeys:h}},1e3,!0)(i=>{i.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=S;function I(a,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!a.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=I;function C(a,l){return!(l.isBuilt||l.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=C;function E(a){const l=a.getValue(D.TELEMETRY_SETTING_ID),v=a.getValue(D.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function r(a){const l={},v={},i={};w(a,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const h=i[n];typeof h=="number"?v[n]=h:typeof h=="boolean"?v[n]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${h.length}`),l[n]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(l[n]=h)}return{properties:l,measurements:v}}e.validateTelemetryData=r;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(a){if(!a)return"none";const l=(0,P.getRemoteName)(a);return d.has(l)?l:"other"}e.cleanRemoteAuthority=f;function w(a,l,v=0,i){if(!!a)for(const n of Object.getOwnPropertyNames(a)){const h=a[n],b=i?i+n:n;Array.isArray(h)?l[b]=(0,c.safeStringify)(h):h instanceof Date?l[b]=h.toISOString():(0,A.isObject)(h)?v<2?w(h,l,v+1,b+"."):l[b]=(0,c.safeStringify)(h):l[b]=h}}function y(a,l){const v=a.msftInternalDomains||[],i=l.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(v)||i}e.isInternalTelemetry=y;function m(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=m;function t(a,l){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let v=a;const i=[];for(const p of l)for(;;){const O=p.exec(a);if(!O)break;i.push([O.index,p.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(v="";;){const p=h.exec(a);if(!p)break;const O=i.some(([W,q])=>p.index<q&&W<h.lastIndex);!n.test(p[0])&&!O&&(v+=a.substring(b,p.index)+"<REDACTED: user-file-path>",b=h.lastIndex)}return b<a.length&&(v+=a.substr(b)),v}function o(a){if(!a)return a;const l=a.toLowerCase(),v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of v)if(i.regex.test(l))return`<REDACTED: ${i.label}>`;return a}function s(a,l){return(0,c.cloneAndChange)(a,v=>{if(v instanceof g)return v.value;if(typeof v=="string"){let i=v.replaceAll("%20"," ");i=t(i,l);for(const n of l)i=i.replace(n,"");return i=o(i),i}})}e.cleanData=s}),define(De[217],Ce([1,0,8,123,25,11,2,9,36,74]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,a){return s.uuid&&a.uuid?s.uuid===a.uuid:s.id===a.id?!0:(0,c.compareIgnoreCase)(s.id,a.id)===0}e.areSameExtensions=L;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(a){const l=a.manifest?a.manifest.version:a.version,v=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new S(a.identifier,l,v)}static parse(a){const l=k.exec(a);return l&&l[1]&&l[2]?new S({id:l[1]},l[2],l[4]||void 0):null}constructor(a,l,v="undefined"){this.version=l,this.targetPlatform=v,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof S?L(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=S;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(s){const a=I.exec(s);return a&&a[1]?[r(a[1]),a[2]]:[r(s),void 0]}e.getIdAndVersion=C;function E(s,a){return`${s}.${a}`}e.getExtensionId=E;function r(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function d(s,a){return r(E(s??u.UNDEFINED_PUBLISHER,a))}e.getGalleryExtensionId=d;function f(s,a){const l=[],v=i=>{for(const n of l)if(n.some(h=>L(a(h),a(i))))return n;return null};for(const i of s){const n=v(i);n?n.push(i):l.push([i])}return l}e.groupByExtension=f;function w(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function y(s){return{id:new g.TelemetryTrustedValue(s.identifier.id),name:new g.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function m(s,a){const l=[],v=a.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const i=v.shift();if(i&&l.every(n=>!L(n.identifier,{id:i}))){const n=s.filter(h=>L(h.identifier,{id:i}));n.length===1&&(l.push(n[0]),v.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=m;async function t(s,a){if(!R.isLinux)return!1;let l;try{l=(await s.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){a.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(i))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,a){const l=await t(s,a),v=(0,A.getTargetPlatform)(l?"alpine":R.platform,D.arch);return a.debug("ComputeTargetPlatform:",v),v}e.computeTargetPlatform=o}),define(De[218],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=c;function A(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=A;function u(P){return Array.from(P.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=u;function R(P){return new Map(P.map(T=>[T[0],{map:A(T[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(De[219],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(u){this.b=u,this.a=new Map}dispose(){for(const u of this.a.values())u.dispose()}startBuffering(u,R,P=5){const T=R(D=>{const g=typeof D=="string"?D:D.data;let L=this.a.get(u);if(L){L.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(u),P);L={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(u),T.dispose()}},this.a.set(u,L)});return T}stopBuffering(u){this.a.get(u)?.dispose()}flushBuffer(u){const R=this.a.get(u);R&&(this.a.delete(u),this.b(u,R.data.join("")))}}e.TerminalDataBufferer=c}),define(De[220],Ce([1,0,19,67,52,3,10,2,178,93,39]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(y){function m(t,o){let s=t.defaults;for(;u.ThemeIcon.isThemeIcon(s);){const a=C.getIcon(s.id);if(!a)return;s=a.defaults}return s}y.getDefinition=m})(k=e.IconContribution||(e.IconContribution={}));var S;(function(y){function m(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}y.toJSONObject=m;function t(o){const s=a=>(0,P.isString)(a)?a:void 0;if(o&&Array.isArray(o.src)&&o.src.every(a=>(0,P.isString)(a.format)&&(0,P.isString)(a.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(a=>({format:a.format,location:T.URI.parse(a.location)}))}}y.fromJSONObject=t})(S=e.IconFontDefinition||(e.IconFontDefinition={}));class I{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(m,t,o,s){const a=this.b[m];if(a){if(o&&!a.description){a.description=o,this.d.properties[m].markdownDescription=`${o} $(${m})`;const i=this.e.enum.indexOf(m);i!==-1&&(this.e.enumDescriptions[i]=o),this.a.fire()}return a}const l={id:m,description:o,defaults:t,deprecationMessage:s};this.b[m]=l;const v={$ref:"#/definitions/icons"};return s&&(v.deprecationMessage=s),o&&(v.markdownDescription=`${o}: $(${m})`),this.d.properties[m]=v,this.e.enum.push(m),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:m}}deregisterIcon(m){delete this.b[m],delete this.d.properties[m];const t=this.e.enum.indexOf(m);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(m=>this.b[m])}getIcon(m){return this.b[m]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(m,t){const o=this.f[m];return o||(this.f[m]=t,this.a.fire(),t)}deregisterIconFont(m){delete this.f[m]}getIconFont(m){return this.f[m]}toString(){const m=(a,l)=>a.id.localeCompare(l.id),t=a=>{for(;u.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(a=>this.b[a]);for(const a of s.filter(l=>!!l.description).sort(m))o.push(`|<i class="${t(a)}"></i>|${a.id}|${u.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const a of s.filter(l=>!u.ThemeIcon.isThemeIcon(l.defaults)).sort(m))o.push(`|<i class="${t(a)}"></i>|${a.id}|`);return o.join(`
`)}}const C=new I;L.Registry.add(e.Extensions.IconContribution,C);function E(y,m,t,o){return C.registerIcon(y,m,t,o)}e.registerIcon=E;function r(){return C}e.getIconRegistry=r;function d(){const y=(0,A.getCodiconFontCharacters)();for(const m in y){const t="\\"+y[m].toString(16);C.registerIcon(m,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const f=L.Registry.as(g.Extensions.JSONContribution);f.registerSchema(e.iconsSchemaId,C.getIconSchema());const w=new c.RunOnceScheduler(()=>f.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=E("widget-close",A.Codicon.close,(0,D.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",A.Codicon.arrowUp,(0,D.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",A.Codicon.arrowDown,(0,D.localize)(4,null)),e.syncing=u.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(De[130],Ce([1,0,3,54,4,16]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var P;(function(E){E.Http="http",E.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=k;function S(E,r,d,f){if(d===1)return!1;if(d===2&&k(r)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(w?.length===4&&parseInt(w[1])>=18)return!1}return E<1024}e.isPortPrivileged=S;class I{constructor(r,d,f){this.remoteAddress=r,this.localAddress=d,this.b=f,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=I;let C=class{constructor(r,d){this.i=r,this.j=d,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],d=Array.from(this.d.values());for(const f of d){const w=Array.from(f.values());for(const y of w){const m=await y.value;m&&r.push(m)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:d}of r.values())await d.then(f=>f?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,d,f,w,y){this.o(r,d,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:d,localAddress:f,privacy:w,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,d){(k(r)||L(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const f=this.q(r,d);if(f)return++f.refcount,f.value}openTunnel(r,d,f,w,y,m=!1,t,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${y}.`),!r)return;if(d||(d="localhost"),w||(w=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(r,d,f,w,y,m,t,o);return s?s.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const d=this.d.get(r.tunnelRemoteHost);if(d){const f=d.get(r.tunnelRemotePort);f&&(f.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,f))}}}}async n(r,d,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${d}.`);const w=f.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(d),w}}async closeTunnel(r,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${d} `);const f=this.d.get(r);if(f&&f.has(d)){const w=f.get(d);w.refcount=0,await this.n(r,d,w)}}o(r,d,f){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(d,{refcount:1,value:f})}async p(r,d){const f=this.d.get(r);f&&(await f.get(d)||f.delete(d),f.size===0&&this.d.delete(r))}q(r,d){const f=[r];L(r)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):k(r)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const w=f.map(y=>this.d.get(y));for(const y of w){const m=y?.get(d);if(m)return m}}canTunnel(r){return!!g(r)}s(r,d,f,w,y,m,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${w}.`);const o=f;this.h.add(o);const s=w===void 0?f:w,a={elevationRequired:y?this.isPortPrivileged(s):!1},l={remoteAddress:{host:d,port:f},localAddressPort:w,privacy:m,public:m?m!==T.Private:void 0,protocol:t},v=r.forwardPort(l,a);return v?(this.o(d,f,v),v.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),v}};C=Ve([We(0,R.ILogService),We(1,A.IConfigurationService)],C),e.AbstractTunnelService=C}),define(De[221],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var A;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[222],Ce([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(D){return D.scheme!==c.Schemas.file&&D.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function u(D){if(D.folders.length)return D.folders.every(g=>A(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=u;function R(D){return u(D)?.scheme}e.getVirtualWorkspaceScheme=R;function P(D){return u(D)?.authority}e.getVirtualWorkspaceAuthority=P;function T(D){return u(D)!==void 0}e.isVirtualWorkspace=T}),define(De[48],Ce([1,0,179,12,69,24,2,4,18]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function g(a){const l=a;return typeof l?.id=="string"&&P.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=g;function L(a){return typeof a?.id=="string"&&!g(a)&&!S(a)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(a,l){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,A.basename)(a)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const v=a;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}e.toWorkspaceIdentifier=k;function S(a){const l=a;return typeof l?.id=="string"&&P.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=S;function I(a){const l=a;if(l?.uri)return{id:l.id,uri:P.URI.revive(l.uri)};const v=a;if(v?.configPath)return{id:v.id,configPath:P.URI.revive(v.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=I;var C;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function E(a){const l=a;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=E;function r(a){const l=a;return!!(l&&typeof l=="object"&&P.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=r;class d{constructor(l,v,i,n,h){this.h=l,this.j=i,this.k=n,this.l=h,this.c=u.TernarySearchTree.forUris(this.l,()=>!0),this.folders=v}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=u.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class f{constructor(l,v){this.raw=v,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function w(a){return new f({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(a,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,l.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function m(a){let l;return P.URI.isUri(a)?l=a:l=a.configuration,l?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=m,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(a,l){return!y(a,l)&&!m(a)}e.isSavedWorkspace=o;function s(a){return(typeof a=="string"?(0,A.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[75],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(u){this.d=u,this.b=new Map,this.c=1}add(u){const R=this.c++;return this.b.set(R,u),this.e(),R}get(u,R){return this.b.has(u)?this.b.get(u)[R]:void 0}delete(u){this.b.delete(u),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}c.a=!1,e.Cache=c}),define(De[49],Ce([1,0,18,24,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(T=>{const D=this.b.get(T.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(T,D){D===null?this.b.delete(T.scheme):this.b.set(T.scheme,D)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(De[223],Ce([1,0,182,16,208,26]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(D,g,L){const k=L.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",S=L.remote.isRemote?(0,c.localize)(0,null):D?(0,c.localize)(1,null):(0,c.localize)(2,null);super(g.createLogger(k,{name:S}))}};P=Ve([We(1,A.ILoggerService),We(2,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(De[224],Ce([1,0,19]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(P,T,D){this.h=new Map,this.a=P,this.b=T,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new c.RunOnceScheduler(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of g.values())L.complete()}catch(L){for(const k of g.values())k.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,T){let D=this.f[P];return typeof D>"u"&&(D=T),D}update(P,T){this.f[P]=T;const D=this.h.get(P);if(D!==void 0)return D.p;const g=new c.DeferredPromise;return this.h.set(P,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class u extends A{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,T){super(P.identifier.value,!0,T),this.j=P}}e.ExtensionGlobalMemento=u}),define(De[225],Ce([1,0,3,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(P){this.c=P,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,T,D,g){const k=this.c.getNotebookDocument(A.URI.revive(P)).acceptModelChanged(T.value,D,g);this.b.fire(k)}$acceptDirtyStateChanged(P,T){this.c.getNotebookDocument(A.URI.revive(P)).acceptDirty(T)}$acceptModelSaved(P){const T=this.c.getNotebookDocument(A.URI.revive(P));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(De[20],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[226],Ce([1,0,25,3]),function(re,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(T,D){u.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(T.identifier),_e(this,u,D,"f"),Me(this,u,"f").onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(T){return Me(this,u,"f").get(this.a,T)}store(T,D){return Me(this,u,"f").store(this.a,T,D)}delete(T){return Me(this,u,"f").delete(this.a,T)}}e.ExtensionSecrets=R,u=new WeakMap}),define(De[55],Ce([1,0,4,130,3,20]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var P;(function(D){function g(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:k.protocol}}D.fromApiTunnel=g;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==A.TunnelPrivacyId.ConstantPrivate&&k.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}D.fromServiceTunnel=L})(P=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(g){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(g){return g}async openTunnel(g,L){}async getTunnels(){return[]}async setTunnelFactory(g){return{dispose:()=>{}}}registerPortsAttributesProvider(g,L){return{dispose:()=>{}}}async $providePortAttributes(g,L,k,S,I){return[]}async $forwardPort(g,L){}async $closeTunnel(g){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([We(0,R.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(De[56],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=A}),define(De[227],Ce([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function u(T,D){if(D.serializeBuffersForPostMessage){const g=new A,L=(I,C)=>{if(C instanceof ArrayBuffer){const E=g.add(C);return{$$vscode_array_buffer_reference$$:!0,index:E}}else if(ArrayBuffer.isView(C)){const E=R(C);if(E){const r=g.add(C.buffer);return{$$vscode_array_buffer_reference$$:!0,index:r,view:{type:E,byteLength:C.byteLength,byteOffset:C.byteOffset}}}}return C},k=JSON.stringify(T,L),S=g.buffers.map(I=>{const C=new Uint8Array(I);return c.VSBuffer.wrap(C)});return{message:k,buffers:S}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=u;function R(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(T,D){const g=D.map(S=>{const I=new ArrayBuffer(S.byteLength);return new Uint8Array(I).set(S.buffer),I}),L=D.length?(S,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const C=I,{index:E}=C,r=g[E];if(C.view)switch(C.view.type){case 1:return new Int8Array(r,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return I}:void 0;return{message:JSON.parse(T,L),arrayBuffers:g}}e.deserializeWebviewMessage=P}),define(De[228],Ce([1,0,115]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:R,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function u(R){return new c.URITransformer(A(R))}e.createURITransformer=u}),define(De[131],Ce([1,0,191,10,2,6,4,39,45,18,46,162,37]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(ue){const ee=ue;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=E;function r(ue,ee,N){for(const K of N.visibleEditorPanes)if(K.group.id===ee&&ue.matches(K.input))return K.getViewState()}e.findViewStateForEditor=r;function d(ue){if(n(ue))return!1;const ee=ue;return u.URI.isUri(ee?.resource)}e.isResourceEditorInput=d;function f(ue){if(n(ue))return!1;const ee=ue;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=f;function w(ue){if(n(ue)||f(ue))return!1;const ee=ue;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function y(ue){if(n(ue))return!1;const ee=ue;return ee?ee.resource===void 0||ee.resource.scheme===g.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;const m=/Untitled-\d+/;function t(ue){return ue.scheme===g.Schemas.untitled&&ue.path.length>1&&!m.test(ue.path)}e.isUntitledWithAssociatedResource=t;function o(ue){if(n(ue))return!1;const ee=ue;return u.URI.isUri(ee?.base?.resource)&&u.URI.isUri(ee?.input1?.resource)&&u.URI.isUri(ee?.input2?.resource)&&u.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var a;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(ee,N){let K=this.a.get(ee);return K||(K={source:ee,label:N},this.a.set(ee,K)),K.source}getSourceLabel(ee){return this.a.get(ee)?.label??ee}}e.SaveSourceRegistry=new l;var v;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors"})(v=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function n(ue){return ue instanceof i}e.isEditorInput=n;function h(ue){const ee=ue;return u.URI.isUri(ee?.preferredResource)}function b(ue){const ee=ue;return n(ee?.primary)&&n(ee?.secondary)}e.isSideBySideEditorInput=b;function p(ue){const ee=ue;return n(ee?.modified)&&n(ee?.original)}e.isDiffEditorInput=p;function O(ue,ee,N,K,le){return ve(K,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const me={...N,limits:{size:Number.MAX_VALUE}};ue.openEditor(ee,me)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:S.default.Warning})}e.createTooLargeFileError=O;function W(ue){return n(ue?.editor)}e.isEditorInputWithOptions=W;function q(ue){const ee=ue;return W(ue)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function Y(ue){const ee=ue;return typeof ee?.groupId=="number"&&n(ee.editor)}e.isEditorIdentifier=Y;var x;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(x=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class U{getOriginalUri(ee,N){if(!ee)return;if(o(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,N);if(N?.supportSideBySide){const{primary:le,secondary:me}=this.a(ee);if(le&&me){if(N?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===B.ANY)return this.getOriginalUri(le,{filterByScheme:N.filterByScheme})??this.getOriginalUri(me,{filterByScheme:N.filterByScheme});ee=N.supportSideBySide===B.PRIMARY?le:me}}if(f(ee)||w(ee)||o(ee))return;const K=h(ee)?ee.preferredResource:ee.resource;return!K||!N||!N.filterByScheme?K:this.b(K,N.filterByScheme)}a(ee){return b(ee)||w(ee)?{primary:ee.primary,secondary:ee.secondary}:p(ee)||f(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,N){if(!ee)return;if(o(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,N);if(N?.supportSideBySide){const{primary:le,secondary:me}=this.a(ee);if(le&&me){if(N?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===B.ANY)return this.getCanonicalUri(le,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:N.filterByScheme});ee=N.supportSideBySide===B.PRIMARY?le:me}}if(f(ee)||w(ee)||o(ee))return;const K=ee.resource;return!K||!N||!N.filterByScheme?K:this.b(K,N.filterByScheme)}b(ee,N){if(Array.isArray(N)){if(N.some(K=>ee.scheme===K))return ee}else if(N===ee.scheme)return ee}}e.EditorResourceAccessor=new U;var j;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class he{constructor(){this.c=new Map,this.d=new Map}start(ee){const N=this.a=ee.get(P.IInstantiationService);for(const[K,le]of this.c)this.e(K,le,N);this.c.clear()}e(ee,N,K){const le=K.createInstance(N);this.d.set(ee,le)}registerFileEditorFactory(ee){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ee}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(ee,N){if(this.c.has(ee)||this.d.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.a?this.e(ee,N,this.a):this.c.set(ee,N),(0,R.toDisposable)(()=>{this.c.delete(ee),this.d.delete(ee)})}getEditorSerializer(ee){return this.d.get(typeof ee=="string"?ee:ee.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new he);async function ie(ue,ee,N){return!ue||!ue.length?[]:await Promise.all(ue.map(async K=>{const le=u.URI.revive(K.fileUri);if(!le){N.info("Cannot resolve the path because it is not valid.",K);return}if(!await ee.canHandleResource(le)){N.info("Cannot resolve the path because it cannot be handled",K);return}let ke=K.exists,Z=K.type;if(typeof ke!="boolean"||typeof Z!="number")try{Z=(await ee.stat(le)).isDirectory?D.FileType.Directory:D.FileType.Unknown,ke=!0}catch(de){N.error(de),ke=!1}if(!ke&&K.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",K);return}if(Z===D.FileType.Directory){N.info("Cannot resolve the path because it is a directory",K);return}const ce={...K.options,pinned:!0};return ke?{resource:le,options:ce}:{resource:le,options:ce,forceUntitled:!0}}))}e.pathsToEditors=ie;var V;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function J(ue){const ee=ue;if(!ee)return!1;const N=ee;if(N.modified)return J(N.modified);const K=ee;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=J;function ne(ue){return(0,L.isErrorWithActions)(ue)}e.isEditorOpenError=ne;function ve(ue,ee,N){const K=(0,L.createErrorWithActions)(ue,ee);return K.forceMessage=N?.forceMessage,K.forceSeverity=N?.forceSeverity,K.allowDialog=N?.allowDialog,K}e.createEditorOpenError=ve}),define(De[229],Ce([1,0,3,192,4,6,28,39,17,61,23,67,220]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,S.registerIcon)("default-view-icon",k.Codicon.window,(0,A.localize)(0,null));var I;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(I=e.Extensions||(e.Extensions={}));var C;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(C=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function E(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class r extends R.Disposable{constructor(){super(...arguments),this.c=this.D(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.D(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.flatten)([...this.g.values()])}registerViewContainer(a,l,v){const i=this.get(a.id);if(i)return i;const n=a;return n.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,P.getOrSet)(this.g,l,[]).push(n),v?.isDefault&&this.h.push(n),this.c.fire({viewContainer:n,viewContainerLocation:l}),n}deregisterViewContainer(a){for(const l of this.g.keys()){const v=this.g.get(l),i=v?.indexOf(a);if(i!==-1){v?.splice(i,1),v.length===0&&this.g.delete(l),this.f.fire({viewContainer:a,viewContainerLocation:l});return}}}get(a){return this.all.filter(l=>l.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(v=>v?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(l=>this.getViewContainerLocation(l)===a)}}T.Registry.add(I.ViewContainersRegistry,new r);var d;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function f(s,a){const l=s.group??d.More,v=a.group??d.More;return l!==v?l.localeCompare(v):(s.order??5)-(a.order??5)}class w extends R.Disposable{constructor(){super(...arguments),this.c=this.D(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.D(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.D(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.D(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new g.SetMap}registerViews(a,l){this.registerViews2([{views:a,viewContainer:l}])}registerViews2(a){a.forEach(({views:l,viewContainer:v})=>this.l(l,v)),this.c.fire(a)}deregisterViews(a,l){const v=this.m(a,l);v.length&&this.f.fire({views:v,viewContainer:l})}moveViews(a,l){for(const v of this.j.keys())if(v!==l){const i=this.m(a,v);i.length&&(this.l(i,l),this.g.fire({views:i,from:v,to:l}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const l of this.i){const v=(this.j.get(l)||[]).filter(i=>i.id===a)[0];if(v)return v}return null}getViewContainer(a){for(const l of this.i)if((this.j.get(l)||[]).filter(i=>i.id===a)[0])return l;return null}registerViewWelcomeContent(a,l){return this.k.add(a,l),this.h.fire(a),(0,R.toDisposable)(()=>{this.k.delete(a,l),this.h.fire(a)})}registerViewWelcomeContent2(a,l){const v=new Map;for(const[i,n]of l)this.k.add(a,n),v.set(i,(0,R.toDisposable)(()=>{this.k.delete(a,n),this.h.fire(a)}));return this.h.fire(a),v}getViewWelcomeContent(a){const l=[];return this.k.forEach(a,v=>l.push(v)),l.sort(f)}l(a,l){let v=this.j.get(l);v||(v=[],this.j.set(l,v),this.i.push(l));for(const i of a){if(this.getView(i.id)!==null)throw new Error((0,A.localize)(1,null,i.id));v.push(i)}}m(a,l){const v=this.j.get(l);if(!v)return[];const i=[],n=[];for(const h of v)a.includes(h)?i.push(h):n.push(h);return i.length&&(n.length?this.j.set(l,n):(this.j.delete(l),this.i.splice(this.i.indexOf(l),1))),i}}T.Registry.add(I.ViewsRegistry,new w),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var y;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(y=e.ViewVisibilityState||(e.ViewVisibilityState={}));var m;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(m=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(a,l){this.c=!1,this.d=!1,(0,L.mixin)(this,a),this.d=!!l,this.resolve=async v=>{if(l&&!this.c){const i=await l(v);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class o extends Error{constructor(a){super((0,A.localize)(2,null,a))}}e.NoTreeViewError=o}),define(De[132],Ce([1,0,3,19,193]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,D,g,L){const k={command:T};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const I=this.f.get(k.seq);if(I){this.f.delete(k.seq);const C={type:"response",seq:0,request_seq:k.seq,success:!1,command:T,message:(0,u.localize)(0,null,L,T)};I(C)}},L)}return g&&this.f.set(k.seq,g),k.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,D){return T.type!=="event"||D.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,A.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const D=T,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s(T,D){D.type=T,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((D,g)=>T.set(g,D)),await(0,A.timeout)(500),T.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(De[230],Ce([1,0,194,44,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const R=S=>c.localize(51,null,S);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var P;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(P=e.State||(e.State={}));function T(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var D;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(D=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var g;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(g=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,u.createDecorator)("debugService");var k;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[231],Ce([1,0,8,2,12,23,18,32,21,17]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function k(i,n,h){return i.replace(L,function(b,p){return n&&p.length>0&&p[0]!=="_"?b:h&&h.hasOwnProperty(p)?h[p]:b})}e.formatPII=k;function S(i){const n={};for(const h of Object.keys(i))h.startsWith("!")||(n[h]=i[h]);return n}e.filterExceptionsFromTelemetry=S;function I(i){return i.configuration.request==="attach"&&!C(i)&&(!i.parentSession||I(i.parentSession))}e.isSessionAttach=I;function C(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(n,"extensionhost")||(0,c.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function E(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=E;function r(i,n,h){let b,p=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=O.exec(i);){const q=W.index+1,Y=q+W[0].length;if(q<=n&&Y>=h){b=W[0],p=q;break}}if(b){const q=/\w+/g;let Y=null;for(;(Y=q.exec(b))&&!(Y.index+1+p+Y[0].length>=h););Y&&(b=b.substring(0,q.lastIndex))}return b?{start:p,end:p+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=r;async function d(i,n,h,b){if(i.evaluatableExpressionProvider.has(n)){const p=i.evaluatableExpressionProvider.ordered(n),O=(0,g.coalesce)(await Promise.all(p.map(async W=>{try{return await W.provideEvaluatableExpression(n,h,b??D.CancellationToken.None)}catch{return}})));if(O.length>0){let W=O[0].expression;const q=O[0].range;return W||(W=n.getLineContent(h.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:W}}}else{const p=n.getLineContent(h.lineNumber),{start:O,end:W}=r(p,h.column,h.column),q=p.substring(O-1,W);return{matchingExpression:q,range:new T.Range(h.lineNumber,O,h.lineNumber,O+q.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(i){return!!(i&&i.match(f))}e.isUri=w;function y(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(w(i.path))return A.URI.parse(i.path);if((0,u.isAbsolute)(i.path))return A.URI.file(i.path)}return i.path}function m(i){if(typeof i.path=="object"){const n=A.URI.revive(i.path);if(n)return n.scheme===P.Schemas.file?n.fsPath:n.toString()}return i.path}function t(i,n){const h=n?y:m,b=(0,R.deepClone)(i);return s(b,(p,O)=>{p&&O&&(O.path=h(O))}),b}e.convertToDAPaths=t;function o(i,n){const h=n?y:m,b=(0,R.deepClone)(i);return s(b,(p,O)=>{!p&&O&&(O.path=h(O))}),b}e.convertToVSCPaths=o;function s(i,n){switch(i.type){case"event":{const h=i;switch(h.event){case"output":n(!1,h.body.source);break;case"loadedSource":n(!1,h.body.source);break;case"breakpoint":n(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=i;switch(h.command){case"setBreakpoints":n(!0,h.arguments.source);break;case"breakpointLocations":n(!0,h.arguments.source);break;case"source":n(!0,h.arguments.source);break;case"gotoTargets":n(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(b=>n(!1,b));break;default:break}break}case"response":{const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(b=>n(!1,b.source));break;case"loadedSources":h.body.sources.forEach(b=>n(!1,b));break;case"scopes":h.body.scopes.forEach(b=>n(!1,b.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(b=>n(!1,b.source));break;case"setBreakpoints":h.body.breakpoints.forEach(b=>n(!1,b.source));break;case"disassemble":h.body?.instructions.forEach(p=>n(!1,p.location));break;default:break}break}}}function a(i){return i.filter(n=>!n.presentation?.hidden).sort((n,h)=>n.presentation?h.presentation?n.presentation.group?h.presentation.group?n.presentation.group!==h.presentation.group?n.presentation.group.localeCompare(h.presentation.group):l(n.presentation.order,h.presentation.order):-1:h.presentation.group?1:l(n.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=a;function l(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function v(i,n){const h=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(h!=="none"&&(await n.saveAll(),h==="allEditorsInActiveGroup")){const b=n.activeEditorPane;b&&b.input.resource?.scheme===P.Schemas.untitled&&await n.save({editor:b.input,groupId:b.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(De[232],Ce([1,0,47,233,23,12,11,8,29,195,132]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,f){this.p=f,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",w=>this.w(w))}sendMessage(d){if(this.p){const f=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${k.a}${f}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const f=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(w){this.m.fire(new Error((w.message||w)+`
`+f))}continue}}else{const f=this.r.indexOf(k.a);if(f!==-1){const y=this.r.toString("utf8",0,f).split(k.b);for(const m of y){const t=m.split(k.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(f+k.a.length);continue}}break}}}k.a=`\r
\r
`,k.b=/\r?\n/,k.l=/: */,e.StreamDebugAdapter=k;class S extends k{startSession(){return new Promise((d,f)=>{let w=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),w=!0}),this.x.on("close",()=>{w?this.m.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",y=>{w?this.m.fire(y):f(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=S;class I extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=I;class C extends S{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=C;class E extends k{constructor(d,f){super(),this.y=d,this.z=f}async startSession(){const d=this.y.command,f=this.y.args,w=this.y.options||{};try{if(d)if(R.isAbsolute(d)){if(!await D.Promises.exists(d))throw new Error(g.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let y=process.env;if(w.env&&Object.keys(w.env).length>0&&(y=u.mixin(u.deepClone(process.env),w.env)),d==="node")if(Array.isArray(f)&&f.length>0){const m=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:y,execArgv:m?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};w.cwd&&(t.cwd=w.cwd);const o=c.fork(f[0],f.slice(1),t);if(!o.pid)throw new Error(g.localize(2,null,f[0]));this.x=o}else throw new Error(g.localize(3,null));else{const m={env:y};w.cwd&&(m.cwd=w.cwd),this.x=c.spawn(d,f,m)}this.x.on("error",m=>{this.m.fire(m)}),this.x.on("exit",(m,t)=>{this.n.fire(m)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",m=>{this.m.fire(m)}),this.x.stdin.on("error",m=>{this.m.fire(m)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),P.isWindows?new Promise((d,f)=>{const w=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,m,t){if(y)return f(y)});w.on("exit",d),w.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,f){if(!d)return;const w=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?w.runtime=R.join(f,d.runtime):w.runtime=d.runtime),d.runtimeArgs&&(w.runtimeArgs=d.runtimeArgs),d.program&&(R.isAbsolute(d.program)?w.program=d.program:w.program=R.join(f,d.program)),d.args&&(w.args=d.args);const y=d;return y.win&&(w.win=E.A(y.win,f)),y.winx86&&(w.winx86=E.A(y.winx86,f)),y.windows&&(w.windows=E.A(y.windows,f)),y.osx&&(w.osx=E.A(y.osx,f)),y.linux&&(w.linux=E.A(y.linux,f)),w}static platformAdapterExecutable(d,f){let w=Object.create(null);f=f.toLowerCase();for(const a of d)if(a.contributes){const l=a.contributes.debuggers;l&&l.length>0&&l.filter(v=>typeof v.type=="string"&&T.equalsIgnoreCase(v.type,f)).forEach(v=>{const i=E.A(v,a.extensionLocation.fsPath);w=u.mixin(w,i,a.isBuiltin)})}let y;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=w.winx86||w.win||w.windows:P.isWindows?y=w.win||w.windows:P.isMacintosh?y=w.osx:P.isLinux&&(y=w.linux),y=y||w;const m=y.program||w.program,t=y.args||w.args,o=y.runtime||w.runtime,s=y.runtimeArgs||w.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof m=="string"?[m]:[]).concat(t||[])};if(m)return{type:"executable",command:m,args:t||[]}}}e.ExecutableDebugAdapter=E}),define(De[234],Ce([1,0,47,33,11]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(g,L){return new Promise((k,S)=>{let I="";const C=c.spawn(g,L);C.pid&&C.stdout.on("data",E=>{I+=E.toString()}),C.on("error",E=>{S(E)}),C.on("close",E=>{k(I)})})}async function P(g){if(g)if(u.isWindows){const L=await new Promise((k,S)=>{re(["windows-process-tree"],k,S)});return new Promise(k=>{L.getProcessTree(g,S=>{k(!!S&&S.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(g)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var T;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(T||(T={}));function D(g,L,k,S,I){g=g.trim().toLowerCase();let C;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?C=1:g.indexOf("cmd.exe")>=0?C=0:g.indexOf("bash")>=0?C=2:u.isWindows?C=0:C=2;let E,r=" ";switch(C){case 1:if(E=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),S){const d=(0,A.getDriveLetter)(S);d&&(r+=`${d}:; `),r+=`cd ${E(S)}; `}if(I)for(const d in I){const f=I[d];f===null?r+=`Remove-Item env:${d}; `:r+=`\${env:${d}}='${f}'; `}if(L.length>0){const d=L.shift(),f=k?d:E(d);r+=f[0]==="'"?`& ${f} `:`${f} `;for(const w of L)r+=w==="<"||w===">"||k?w:E(w),r+=" "}break;case 0:if(E=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>d.includes(f))||d.length===0?`"${d}"`:d),S){const d=(0,A.getDriveLetter)(S);d&&(r+=`${d}: && `),r+=`cd ${E(S)} && `}if(I){r+='cmd /C "';for(const d in I){let f=I[d];f===null?r+=`set "${d}=" && `:(f=f.replace(/[&^|<>]/g,w=>`^${w}`),r+=`set "${d}=${f}" && `)}}for(const d of L)r+=d==="<"||d===">"||k?d:E(d),r+=" ";I&&(r+='"');break;case 2:{E=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),f.length===0?'""':f);const d=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(S&&(r+=`cd ${E(S)} ; `),I){r+="/usr/bin/env";for(const f in I){const w=I[f];w===null?r+=` -u ${d(f)}`:r+=` ${d(`${f}=${w}`)}`}r+=" "}for(const f of L)r+=f==="<"||f===">"||k?f:E(f),r+=" ";break}}return r}e.prepareCommand=D}),define(De[94],Ce([1,0,22,38,64,88,18,12,11,44]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(C=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var E;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(E=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var r;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(r=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var f;(function(B){B.scheme=P.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${U.join("")}]+`),he=7;function ie(ee,N){const K=N.toString(he),me=`${K.length<U.length?U[K.length-1]:"z"}${K}s${(0,c.encodeBase64)(c.VSBuffer.fromString(ee.scheme),!0,!0)}`;return ee.with({scheme:B.scheme,fragment:me})}B.generate=ie;function V(ee){if(ee.scheme!==B.scheme)return;const N=ee.fragment.indexOf("s");if(N<0)return;const K=parseInt(ee.fragment.substring(0,N).replace(j,""),he),le=(0,c.decodeBase64)(ee.fragment.substring(N+1)).toString();if(!isNaN(K))return{handle:K,notebook:ee.with({scheme:le,fragment:null})}}B.parse=V;function J(ee,N){return ee.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${ee.scheme!==P.Schemas.file?ee.scheme:""}`})}B.generateCellOutputUri=J;function ne(ee){if(ee.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!N)return;const K=N[1]&&N[1]!==""?N[1]:void 0,le=N[2];return{outputId:K,notebook:ee.with({scheme:le||P.Schemas.file,fragment:null})}}B.parseCellOutputUri=ne;function ve(ee,N,K){return B.generate(ee,N).with({scheme:K})}B.generateCellPropertyUri=ve;function ue(ee,N){if(ee.scheme===N)return B.parse(ee.with({scheme:B.scheme}))}B.parseCellPropertyUri=ue})(f=e.CellUri||(e.CellUri={}));const w=B=>D.isWindows?B.replace(/\//g,"\\"):B;class y{constructor(U=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(U)].map(he=>({pattern:he,matches:A.parse(w(he))}))}sort(U){const j=new Map(u.Iterable.map(U,ie=>[ie,w(ie)]));let he=[];for(const{matches:ie}of this.d)for(const[V,J]of j)if(ie(J)){he.push(V),j.delete(V);break}return j.size&&(he=he.concat([...j.keys()].sort((ie,V)=>this.e.indexOf(ie)-this.e.indexOf(V)))),he}prioritize(U,j){const he=this.f(U);if(he===-1){this.d.unshift({pattern:U,matches:A.parse(w(U))});return}const ie=new Set(j.map(J=>this.f(J,he)));ie.delete(-1);const V=Array.from(ie).sort();this.d.splice(he+1,0,...V.map(J=>this.d[J]));for(let J=V.length-1;J>=0;J--)this.d.splice(V[J],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,j=this.d.length){const he=w(U);for(let ie=0;ie<j;ie++)if(this.d[ie].matches(he))return ie;return-1}}e.MimeTypeDisplayOrder=y;function m(B,U,j,he=(ie,V)=>ie===V){const ie=[];function V(ve,ue,ee){if(ue===0&&ee.length===0)return;const N=ie[ie.length-1];N&&N.start+N.deleteCount===ve?(N.deleteCount+=ue,N.toInsert.push(...ee)):ie.push({start:ve,deleteCount:ue,toInsert:ee})}let J=0,ne=0;for(;;){if(J===B.length){V(J,0,U.slice(ne));break}if(ne===U.length){V(J,B.length-J,[]);break}const ve=B[J],ue=U[ne];if(he(ve,ue)){J+=1,ne+=1;continue}j(ue)?(V(J,1,[]),J+=1):(V(J,0,[ue]),ne+=1)}return ie}e.diff=m,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(B){B.default="default",B.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(B){const U=B;return!!((typeof U.include=="string"||A.isRelativePattern(U.include))&&(typeof U.exclude=="string"||A.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=o;function s(B,U,j){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const he=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(A.match(he,(0,T.basename)(j.fsPath).toLowerCase()))return!(ie&&A.match(ie,(0,T.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",textOutputLineLimit:"notebook.output.textLineLimit",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var a;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(U){return`${l.d}${U}`}static parse(U){if(U.startsWith(l.d))return U.substring(l.d.length)}}l.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=l;function v(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=v;const i=new TextDecoder;function n(B){const U=[];let j=!1;for(const he of B)(U.length===0||j)&&(U.push(he),j=!0);return O(U),M(c.VSBuffer.concat(U.map(he=>c.VSBuffer.wrap(he))))}e.compressOutputItemStreams=n;const h=`${String.fromCharCode(27)}[A`,b=h.split("").map(B=>B.charCodeAt(0)),p=10;function O(B){B.forEach((U,j)=>{if(j===0||U.length<h.length)return;const he=B[j-1],ie=U.subarray(0,h.length);if(ie[0]===b[0]&&ie[1]===b[1]&&ie[2]===b[2]){const V=he.lastIndexOf(p);if(V===-1)return;B[j-1]=he.subarray(0,V),B[j]=U.subarray(h.length)}})}function W(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function q(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let j=B.match(/\r+(.*)$/m)[1];j=j+U.slice(j.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return B}const Y="\b".charCodeAt(0),x="\r".charCodeAt(0);function M(B){return!B.buffer.includes(Y)&&!B.buffer.includes(x)?B:c.VSBuffer.fromString(q(W(i.decode(B.buffer))))}}),define(De[235],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(De[57],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class u{static fromExtHostTestItem(P,T,D=P.parent){if(P._isRoot)return new u([T]);const g=[P.id];for(let L=D;L&&L.id!==T;L=L.parent)g.push(L.id);return g.push(T),new u(g.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const T=P.indexOf("\0");return T===-1?P:P.slice(0,T)}static fromString(P){return new u(P.split("\0"))}static join(P,T){return new u([...P.path,T])}static joinToString(P,T){return P.toString()+"\0"+T}static parentId(P){const T=P.lastIndexOf("\0");return T===-1?void 0:P.slice(0,T)}static localId(P){const T=P.lastIndexOf("\0");return T===-1?P:P.slice(T+1)}static compare(P,T){return P===T?0:T.startsWith(P+"\0")?2:P.startsWith(T+"\0")?3:1}constructor(P,T=P.length){if(this.path=P,this.d=T,P.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new u(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new u(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new u(this.path,P)}compare(P){if(typeof P=="string")return u.compare(this.toString(),P);for(let T=0;T<P.d&&T<this.d;T++)if(P.path[T]!==this.path[T])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.TestId=u}),define(De[76],Ce([1,0,2,32,57]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var P;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const T=i=>"runId"in i;e.isStartControllerTests=T;var D;(function(i){i.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),i.deserialize=n=>({range:A.Range.lift(n.range),uri:c.URI.revive(n.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var g;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(g=e.TestMessageType||(e.TestMessageType={}));var L;(function(i){i.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&D.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&D.deserialize(n.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(i,n)=>`${n?"s":"e"}${i}`;e.getMarkId=k;var S;(function(i){i.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&D.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&D.deserialize(n.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var I;(function(i){i.serialize=n=>n.type===0?L.serialize(n):S.serialize(n),i.deserialize=n=>n.type===0?L.deserialize(n):S.deserialize(n)})(I=e.ITestMessage||(e.ITestMessage={}));var C;(function(i){i.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),i.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(I.serialize)}),i.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(I.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",r=(i,n)=>i+E+n;e.namespaceTestTag=r;const d=i=>{const n=i.indexOf(E);return{ctrlId:i.slice(0,n),tagId:i.slice(n+1)}};e.denamespaceTestTag=d;var f;(function(i){i.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),i.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?c.URI.revive(n.uri):void 0,range:n.range?A.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(f=e.ITestItem||(e.ITestItem={}));var w;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(i){i.serialize=n=>({expand:n.expand,item:f.serialize(n.item)}),i.deserialize=n=>({controllerId:u.TestId.root(n.item.extId),expand:n.expand,item:f.deserialize(n.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var m;(function(i){i.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},i.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?A.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(m=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,n)=>{n.expand!==void 0&&(i.expand=n.expand),n.item!==void 0&&(i.item=i.item?Object.assign(i.item,n.item):n.item)};e.applyTestItemUpdate=t;var o;(function(i){i.serializeWithoutMessages=n=>({...y.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serializeWithoutMessages),retired:n.retired}),i.serialize=n=>({...y.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serialize),retired:n.retired}),i.deserialize=n=>({...y.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(i){i.deserialize=n=>n.op===0?{op:n.op,item:y.deserialize(n.item)}:n.op===1?{op:n.op,item:m.deserialize(n.item)}:n.op===2?{op:n.op,uri:c.URI.revive(n.uri),docv:n.docv}:n,i.serialize=n=>n.op===0?{op:n.op,item:y.serialize(n.item)}:n.op===1?{op:n.op,item:m.serialize(n.item)}:n})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class v{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const b of n)switch(b.op){case 0:this.j(y.deserialize(b.item),h);break;case 1:this.k(m.deserialize(b.item),h);break;case 3:this.l(b.itemId,h);break;case 5:this.m(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this.c.set(b.tag.id,b.tag);break;case 7:this.c.delete(b.id);break}h.complete?.()}j(n,h){const b=u.TestId.parentId(n.item.extId)?.toString();let p;if(!b)p=this.p(n),this.f.add(p),this.d.set(n.item.extId,p);else if(this.d.has(b)){const O=this.d.get(b);O.children.add(n.item.extId),p=this.p(n,O),this.d.set(n.item.extId,p)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(p),n.expand===2&&this.g++,p}k(n,h){const b=this.d.get(n.extId);if(!!b)return n.expand!==void 0&&(b.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(b,n),h.update?.(b),b}l(n,h){const b=this.d.get(n);if(!b)return;const p=u.TestId.parentId(b.item.extId)?.toString();p?this.d.get(p).children.delete(b.item.extId):this.f.delete(b);const O=[[n]];for(;O.length;)for(const W of O.pop()){const q=this.d.get(W);q&&(O.push(q.children),this.d.delete(W),h.remove?.(q,q!==b),q.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=v}),define(De[95],Ce([1,0,19,3,6,51,76,57]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var D;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(D=e.TestItemEventOp||(e.TestItemEventOp={}));const g=(f,w)=>f===w,k=Object.entries({range:(f,w)=>f===w?!0:!f||!w?!1:f.equalsRange(w),busy:g,label:g,description:g,error:g,sortText:g,tags:(f,w)=>!(f.length!==w.length||f.some(y=>!w.includes(y)))}),S=(f,w)=>{let y;for(const[m,t]of k)t(f[m],w[m])||(y?y[m]=w[m]:y={[m]:w[m]});return y};class I extends u.Disposable{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.D(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.D(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.s(this.root,void 0)}set resolveHandler(w){this.h=w;for(const y of this.tree.values())this.G(y)}get resolveHandler(){return this.h}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===w.uri){y.docv=w.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===w.item.extId){(0,P.applyTestItemUpdate)(y.item,w.item);return}if(y.op===0&&y.item.item.extId===w.item.extId){(0,P.applyTestItemUpdate)(y.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,y){const m=this.tree.get(w);if(!!m){if((m.expandLevels===void 0||y>m.expandLevels)&&(m.expandLevels=y),m.expand===1){const t=this.I(m);return t.isOpen()?this.H(m,y-1):t.wait().then(()=>this.H(m,y-1))}else if(m.expand===3)return m.resolveBarrier?.isOpen()===!1?m.resolveBarrier.wait().then(()=>this.H(m,y-1)):this.H(m,y-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,y){switch(y.op){case 3:this.L(T.TestId.joinToString(w.fullId,y.id));break;case 0:this.s(y.item,w);break;case 5:for(const m of y.ops)this.p(w,m);break;case 1:this.u(y.new,y.old,w.fullId.toString());break;case 2:this.G(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:y.update}});break;case 6:this.q(w.actual.uri);break;default:(0,R.assertNever)(y)}}q(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}s(w,y){const m=T.TestId.fromExtHostTestItem(w,this.root.id,y?.actual),t=this.m.getApiFor(w);t.parent&&t.parent!==y?.actual&&this.m.getChildren(t.parent).delete(w.id);let o=this.tree.get(m.toString());if(!o){o={fullId:m,actual:w,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},w.tags.forEach(this.w,this),this.tree.set(o.fullId.toString(),o),this.z(w,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(w)}}),this.F(w,o,y);return}if(o.actual===w){this.C(w,o,y);return}if(o.actual.uri?.toString()!==w.uri?.toString())return this.L(m.toString()),this.s(w,y);const s=this.m.getChildren(o.actual),a=o.actual,l=S(this.m.toITestItem(a),this.m.toITestItem(w));this.m.getApiFor(a).listener=void 0,o.actual=w,o.expand=0,l&&(l.hasOwnProperty("tags")&&(this.u(w.tags,a.tags,m.toString()),delete l.tags),this.p(o,{op:4,update:l})),this.F(w,o,y);for(const[v,i]of s)this.m.getChildren(w).get(i.id)||this.L(T.TestId.joinToString(m,i.id));this.q(o.actual.uri)}u(w,y,m){const t=new Set(y.map(o=>o.id));for(const o of w)t.delete(o.id)||this.w(o);this.pushDiff({op:1,item:{extId:m,item:{tags:w.map(o=>(0,P.namespaceTestTag)(this.m.controllerId,o.id))}}}),t.forEach(this.y,this)}w(w){const y=this.j.get(w.id);y?y.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.namespaceTestTag)(this.m.controllerId,w.id)}}))}y(w){const y=this.j.get(w);y&&!--y.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,P.namespaceTestTag)(this.m.controllerId,w)}))}z(w,y){this.m.getApiFor(w).parent=y&&y.actual!==this.root?y.actual:void 0}C(w,y,m){this.z(w,m);const t=this.m.getApiFor(w);t.parent=m?.actual,t.listener=o=>this.p(y,o),this.G(y)}F(w,y,m){this.C(w,y,m);for(const[t,o]of this.m.getChildren(w))this.s(o,y)}G(w){let y;this.h?w.resolveBarrier?y=w.resolveBarrier.isOpen()?3:2:y=w.actual.canResolveChildren?1:0:y=0,y!==w.expand&&(w.expand=y,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:y}}),y===1&&w.expandLevels!==void 0&&this.I(w))}H(w,y){if(y<0)return;const m=[];for(const[t,o]of this.m.getChildren(w.actual)){const s=this.expand(T.TestId.joinToString(w.fullId,o.id),y);(0,c.isThenable)(s)&&m.push(s)}if(m.length)return Promise.all(m).then(()=>{})}I(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const o=new c.Barrier;return o.open(),o}w.expand=2,this.J(w);const y=w.resolveBarrier=new c.Barrier,m=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let t;try{t=this.h(w.actual===this.root?void 0:w.actual)}catch(o){m(o)}return(0,c.isThenable)(t)?t.catch(m).then(()=>{y.open(),this.G(w)}):(y.open(),this.G(w)),w.resolveBarrier}J(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}L(w){const y=this.tree.get(w);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const m=[y];for(;m.length;){const t=m.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.y(o.id);this.tree.delete(t.fullId.toString());for(const[o,s]of this.m.getChildren(t.actual))m.push(this.tree.get(T.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.TestItemCollection=I;class C extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=C;class E extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class r extends Error{constructor(w,y,m){super(`TestItem with ID "${w}" is from controller "${y}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=r;const d=(f,w,y)=>{let m=new Map;return{get size(){return m.size},forEach(t,o){for(const s of m.values())t.call(o,s,this)},[Symbol.iterator](){return m.entries()},replace(t){const o=new Map,s=new Set(m.keys()),a={op:5,ops:[]};for(const l of t){if(!(l instanceof y))throw new E(l.id);const v=w(l).controllerId;if(v!==f.controllerId)throw new r(l.id,v,f.controllerId);if(o.has(l.id))throw new C(l.id);o.set(l.id,l),s.delete(l.id),a.ops.push({op:0,item:l})}for(const l of s.keys())a.ops.push({op:3,id:l});f.listener?.(a),m=o},add(t){if(!(t instanceof y))throw new E(t.id);m.set(t.id,t),f.listener?.({op:0,item:t})},delete(t){m.delete(t)&&f.listener?.({op:3,id:t})},get(t){return m.get(t)},toJSON(){return Array.from(m.values())}}};e.createTestItemChildren=d}),define(De[133],Ce([1,0,95]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,u=(P,T)=>{const D={controllerId:T};return A.set(P,D),D};e.createPrivateApiFor=u;const R=P=>{const T=A.get(P);if(!T)throw new c.InvalidTestItemError(P?.id||"<unknown>");return T};e.getPrivateApiFor=R}),define(De[96],Ce([1,0,18,2]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(T,D){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(D&&D.authority&&D.isRemote&&T.scheme===c.Schemas.file&&(T=A.URI.from({scheme:c.Schemas.vscodeRemote,authority:D.authority,path:T.path})),A.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${R(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=u;function R(T){return T.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function P(T){return T.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.decodeAuthority=P}),define(De[236],Ce([1,0,3,6,96]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(T,D,g){this.d=T,this.e=D,this.f=g,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const L=D.getVisibleTextEditors();for(const k of this.c.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,D,g,L,k){let S;for(const w of this.e.getVisibleTextEditors(!0))if(w.value===T){S=w;break}if(!S)throw new Error("not a visible editor");const I=this,C=this.a++,E=new c.Emitter,r=new c.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(w){return(0,u.asWebviewUri)(w,I.f)}get cspSource(){return u.webviewGenericCspSource}set options(w){this.b=w,I.d.$setOptions(C,w)}get options(){return this.b}set html(w){this.a=w,I.d.$setHtml(C,w)}get html(){return this.a}get onDidReceiveMessage(){return E.event}postMessage(w){return I.d.$postMessage(C,w)}},f=new class{constructor(){this.editor=T,this.line=D,this.height=g,this.webview=d,this.onDidDispose=r.event}dispose(){I.c.has(C)&&(I.c.delete(C),I.d.$disposeEditorInset(C),r.fire(),r.dispose(),E.dispose())}};return this.d.$createEditorInset(C,S.id,S.value.document.uri,D+1,g,L||{},k.identifier,k.extensionLocation),this.c.set(C,{editor:T,inset:f,onDidReceiveMessage:E}),f}$onDidDispose(T){const D=this.c.get(T);D&&D.inset.dispose()}$onDidReceiveMessage(T,D){this.c.get(T)?.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=R}),define(De[237],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class u extends Error{constructor(P,T){super(T),this.variable=P}}e.VariableError=u}),define(De[238],Ce([1,0,12,36,10,23,11,114,198,237,8]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,C,E,r){this.g=new Map,this.a=I,this.b=C,this.d=E,r&&(this.c=r.then(d=>this.h(d)))}h(I){if(P.isWindows){const C=Object.create(null);return Object.keys(I).forEach(E=>{C[E.toLowerCase()]=I[E]}),C}return I}resolveWithEnvironment(I,C,E){return this.j({env:this.h(I),userHome:void 0},C?C.uri:void 0,E)}async resolveAsync(I,C){const E={env:await this.c,userHome:await this.d};return this.j(E,I?I.uri:void 0,C)}async i(I,C,E,r){const d=R.deepClone(C);P.isWindows&&d.windows?Object.keys(d.windows).forEach(w=>d[w]=d.windows[w]):P.isMacintosh&&d.osx?Object.keys(d.osx).forEach(w=>d[w]=d.osx[w]):P.isLinux&&d.linux&&Object.keys(d.linux).forEach(w=>d[w]=d.linux[w]),delete d.windows,delete d.osx,delete d.linux;const f={env:await this.c,userHome:await this.d};return this.j(f,I?I.uri:void 0,d,E,r)}async resolveAnyAsync(I,C,E){return this.i(I,C,E)}async resolveAnyMap(I,C,E){const r=new Map;return{newConfig:await this.i(I,C,E,r),resolvedVariables:r}}resolveWithInteractionReplace(I,C,E,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,C,E,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,C){if(this.g.has(I))throw new Error("Variable "+I+" is contributed twice.");this.g.set(I,C)}async j(I,C,E,r,d){if(u.isString(E))return this.l(I,C,E,r,d);if(Array.isArray(E))return Promise.all(E.map(f=>this.j(I,C,f,r,d)));if(u.isObject(E)){const f=Object.create(null),w=await Promise.all(Object.keys(E).map(async y=>[await this.l(I,C,y,r,d),await this.j(I,C,E[y],r,d)]));for(const[y,m]of w)f[y]=m;return f}return E}l(I,C,E,r,d){return(0,L.replaceAsync)(E,k.VARIABLE_REGEXP,async(f,w)=>{if(w.includes(k.VARIABLE_LHS))return f;let y=await this.n(I,f,w,C,r);return d?.set(w,y),y!==f&&u.isString(y)&&y.match(k.VARIABLE_REGEXP)&&(y=await this.l(I,C,y,r,d)),y})}m(I){return this.b?this.b.getUriLabel(I,{noPrefix:!0}):I.fsPath}async n(I,C,E,r,d){let f;const w=E.split(":");w.length>1&&(E=w[0],f=w[1]);const y=o=>{const s=this.a.getFilePath();if(s)return(0,T.normalizeDriveLetter)(s);throw new g.VariableError(o,(0,D.localize)(0,null,C))},m=o=>{const s=y(o);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,T.normalizeDriveLetter)(a)}throw new g.VariableError(o,(0,D.localize)(1,null,C,c.basename(s)))},t=o=>{if(f){const s=this.a.getFolderUri(f);if(s)return s;throw new g.VariableError(o,(0,D.localize)(2,null,C,f))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new g.VariableError(o,(0,D.localize)(3,null,C)):new g.VariableError(o,(0,D.localize)(4,null,C))};switch(E){case"env":if(f){if(I.env){const o=I.env[P.isWindows?f.toLowerCase():f];if(u.isString(o))return o}return""}throw new g.VariableError(g.VariableKind.Env,(0,D.localize)(5,null,C));case"config":if(f){const o=this.a.getConfigurationValue(r,f);if(u.isUndefinedOrNull(o))throw new g.VariableError(g.VariableKind.Config,(0,D.localize)(6,null,C,f));if(u.isObject(o))throw new g.VariableError(g.VariableKind.Config,(0,D.localize)(7,null,C,f));return o}throw new g.VariableError(g.VariableKind.Config,(0,D.localize)(8,null,C));case"command":return this.o(g.VariableKind.Command,C,f,d,"command");case"input":return this.o(g.VariableKind.Input,C,f,d,"input");case"extensionInstallFolder":if(f){const o=await this.a.getExtension(f);if(!o)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,C,f));return this.m(o.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,C));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(t(g.VariableKind.WorkspaceFolder)));case"cwd":return r||f?(0,T.normalizeDriveLetter)(this.m(t(g.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(c.basename(this.m(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(I.userHome)return I.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,D.localize)(11,null,C))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new g.VariableError(g.VariableKind.LineNumber,(0,D.localize)(12,null,C))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new g.VariableError(g.VariableKind.SelectedText,(0,D.localize)(13,null,C))}case"file":return y(g.VariableKind.File);case"fileWorkspaceFolder":return m(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||f?c.relative(this.m(t(g.VariableKind.RelativeFile)),y(g.VariableKind.RelativeFile)):y(g.VariableKind.RelativeFile);case"relativeFileDirname":{const o=c.dirname(y(g.VariableKind.RelativeFileDirname));if(r||f){const s=c.relative(this.m(t(g.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return c.dirname(y(g.VariableKind.FileDirname));case"fileExtname":return c.extname(y(g.VariableKind.FileExtname));case"fileBasename":return c.basename(y(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=c.basename(y(g.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-c.extname(o).length)}case"fileDirnameBasename":return c.basename(c.dirname(y(g.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||C}case"execInstallFolder":{const o=this.a.getAppRoot();return o||C}case"pathSeparator":return c.sep;default:try{const o=f?`${E}:${f}`:E;return this.o(g.VariableKind.Unknown,C,o,d,void 0)}catch{return C}}}}o(I,C,E,r,d){if(E&&r){const f=d===void 0?r[E]:r[d+":"+E];if(typeof f=="string")return f;throw new g.VariableError(I,(0,D.localize)(14,null,C))}return C}}k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=k}),define(De[134],Ce([1,0,4,131]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var u;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(u=e.GroupDirection||(e.GroupDirection={}));var R;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var T;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function g(C){const E=C;return(0,A.isEditorInput)(E?.editor)&&(0,A.isEditorInput)(E?.replacement)}e.isEditorReplacement=g;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(C){const E=C;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=S;function I(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(De[239],Ce([1,0,4,134]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(R){const P=R;return typeof R=="number"||(0,A.isEditorGroup)(P)}e.isPreferredGroup=u}),define(De[240],Ce([1,0,4,204]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(A.IEnvironmentService)}),define(De[135],Ce([1,0,25,3,12,6]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=P;class T{static isHostExtension(r,d,f){if(d.getExtensionDescription(r))return!1;const w=f.getExtensionDescription(r);return w?!!((w.main||w.browser)&&w.api==="none"):!1}constructor(r,d){this.h=r,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=d,this.j()}j(){this.d.sort(I),this.e=new c.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const d=this.h.readActivationEvents(r);if(Array.isArray(d))for(let f of d)f==="onUri"&&(f=`onUri:${c.ExtensionIdentifier.toKey(r.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,d){this.d=C(this.d,d),this.d=this.d.concat(r);const f=T.k(this.d);return this.d=C(this.d,f.map(w=>w.identifier)),this.j(),this.c.fire(void 0),new P(f)}static k(r){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this.c.has(t)?this.c.get(t).push(o):this.c.set(t,[o])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,o){const s=d.getArcs(t);for(let a=0;a<s.length;a++)if(!o.has(s[a]))return!1;return!0}getNodes(){return this.e}},f=new c.ExtensionIdentifierMap;for(const t of r)if(f.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)d.addArc(c.ExtensionIdentifier.toKey(t.identifier),c.ExtensionIdentifier.toKey(o));const w=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>w.add(t));const y=d.getNodes().filter(t=>!w.has(t));let m;do{m=!1;for(let t=0;t<y.length;t++){const o=y[t];d.hasOnlyGoodArcs(o,w)&&(y.splice(t,1),t--,w.add(o),m=!0)}}while(m);return y.map(t=>f.get(t))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const d=this.g.get(r);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const d=this.e.get(r);return d||void 0}getExtensionDescriptionByUUID(r){for(const d of this.f)if(d.uuid===r)return d}getExtensionDescriptionByIdOrUUID(r,d){return this.getExtensionDescription(r)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=T,e.basicActivationEventsReader={readActivationEvents:E=>E.activationEvents};class D{constructor(r){this.d=new k,this.c=new T(r,[])}async acquireLock(r){const d=await this.d.acquire(r);return new g(this,d)}deltaExtensions(r,d,f){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,f)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,d){return this.c.getExtensionDescriptionByIdOrUUID(r,d)}}e.LockableExtensionDescriptionRegistry=D;class g extends R.Disposable{constructor(r,d){super(),this.f=r,this.c=!1,this.D(d)}isAcquiredFor(r){return!this.c&&this.f===r}}e.ExtensionDescriptionRegistryLock=g;class L{constructor(r){this.name=r,this.promise=new Promise((d,f)=>{this.c=d})}resolve(r){this.c(r)}}class k{constructor(){this.c=[],this.d=!1}async acquire(r){const d=new L(r);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let d=!0;const f=setTimeout(()=>{d&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),w=()=>{!d||(clearTimeout(f),d=!1,this.d=!1,this.e())};r.resolve((0,R.toDisposable)(w))}}var S;(function(E){E[E.Builtin=0]="Builtin",E[E.User=1]="User",E[E.Dev=2]="Dev"})(S||(S={}));function I(E,r){const d=E.isBuiltin?0:E.isUnderDevelopment?2:1,f=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(d!==f)return d-f;const w=u.posix.basename(E.extensionLocation.path),y=u.posix.basename(r.extensionLocation.path);return w<y?-1:w>y?1:0}function C(E,r){const d=new c.ExtensionIdentifierSet(r);return E.filter(f=>!d.has(f.identifier))}}),define(De[241],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class u{constructor(){this.type=2}serialize(k){k[u.ENV_KEY]="1"}}u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=u;class R{constructor(){this.type=3}serialize(k){k[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function P(L){delete L[A.ENV_KEY],delete L[u.ENV_KEY],delete L[R.ENV_KEY]}function T(L,k){P(k),L.serialize(k)}e.writeExtHostConnection=T;function D(L){if(L[A.ENV_KEY])return g(L,new A(L[A.ENV_KEY]));if(L[u.ENV_KEY])return g(L,new u);if(L[R.ENV_KEY])return g(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=D;function g(L,k){return P(L),k}}),define(De[97],Ce([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var u;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(u=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function P(g){const L=c.VSBuffer.alloc(1);switch(g){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=P;function T(g,L){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=T;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[77],Ce([1,0,4,3,16,26,97,73,74,23,2,6,185]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class extends k.Disposable{constructor(d,f){super(),this.m=d,this.n=f,this.a=this.D(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.D(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=f.createLogger(this.j,{id:D.extensionTelemetryLogChannelId,name:(0,S.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.D(f.onDidChangeLogLevel(w=>{(0,u.isLogLevel)(w)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,f,w){const y=this.getTelemetryDetails(),m=new C(f,w,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled});return this.l.set(d.identifier.value,m),m.apiTelemetryLogger}$initializeTelemetryLevel(d,f,w){this.f=d,this.g=f,this.c=w??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const f={};switch(f["common.extname"]=`${d.publisher}.${d.name}`,f["common.extversion"]=d.version,f["common.vscodemachineid"]=this.m.telemetryInfo.machineId,f["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,f["common.vscodeversion"]=this.m.version,f["common.isnewappinstall"]=E(this.m.telemetryInfo.firstSessionDate),f["common.product"]=this.m.environment.appHost,this.m.uiKind){case P.UIKind.Web:f["common.uikind"]="web";break;case P.UIKind.Desktop:f["common.uikind"]="desktop";break;default:f["common.uikind"]="unknown"}return f["common.remotename"]=(0,T.getRemoteName)((0,D.cleanRemoteAuthority)(this.m.remote.authority)),f}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const f=this.getTelemetryDetails();this.l.forEach((w,y)=>{w.isDisposed&&this.l.delete(y)}),this.l.forEach(w=>{w.updateTelemetryEnablements(f.isUsageEnabled,f.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,f){const w=this.l.get(d.value);return w&&w.isDisposed?(this.l.delete(d.value),!1):!w||w.ignoreUnhandledExtHostErrors?!1:(w.logError(f),!0)}};I=Ve([We(0,R.IExtHostInitDataService),We(1,u.ILoggerService)],I),e.ExtHostTelemetry=I;class C{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,f,w,y,m,t,o){this.g=w,this.h=y,this.i=m,this.j=t,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=f?.ignoreUnhandledErrors??!1,this.b=f?.ignoreBuiltInCommonProperties??!1,this.c=f?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,f){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:f},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let f=d.properties??d;return f=(0,D.cleanData)(f,[]),this.c&&(f=(0,g.mixin)(f,this.c)),this.b||(f=(0,g.mixin)(f,this.j)),d.properties?d.properties=f:d=f,d}k(d,f){!this.f||(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,f=this.mixInCommonPropsAndCleanData(f||{}),this.i||this.f?.sendEventData(d,f),this.h.trace(d,f))}logUsage(d,f){!this.d.isUsageEnabled||this.k(d,f)}logError(d,f){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,f):this.f.sendErrorData(d,f))}get apiTelemetryLogger(){if(!this.e){const d=this,f={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(f)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=C;function E(r){const d=Date.now()-new Date(r).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(De[27],Ce([1,0,3,2,217,129,25,4]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class D{constructor(m){this.dependency=m}}e.MissingExtensionDependency=D;var g;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(g=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class L{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(m,t){const o=[],s=[],a=[],l=[],v=k(this.c),i=k(m),n=(W,q)=>W.extensionLocation.toString()===q.extensionLocation.toString()||W.isBuiltin===q.isBuiltin||W.isUserBuiltin===q.isUserBuiltin||W.isUnderDevelopment===q.isUnderDevelopment;for(const W of this.c){const q=i.get(W.identifier);if(!q){o.push(W.identifier),v.delete(W.identifier);continue}if(!n(W,q)){o.push(W.identifier),v.delete(W.identifier);continue}}for(const W of m){const q=v.get(W.identifier);if(!q){s.push(W);continue}if(!n(q,W)){o.push(q.identifier),v.delete(q.identifier);continue}}const h=new P.ExtensionIdentifierSet(this.d),b=new P.ExtensionIdentifierSet(t);for(const W of this.d)b.has(W)||a.push(W);for(const W of t)h.has(W)||l.push(W);const p=R.ImplicitActivationEvents.createActivationEventsMap(s),O={toRemove:o,toAdd:s,addActivationEvents:p,myToRemove:a,myToAdd:l};return this.delta(O),O}delta(m){const{toRemove:t,toAdd:o,myToRemove:s,myToAdd:a}=m,l=new P.ExtensionIdentifierSet(t),v=new P.ExtensionIdentifierSet(s);for(let i=0;i<this.c.length;i++)l.has(this.c[i].identifier)&&(this.c.splice(i,1),i--);for(let i=0;i<this.d.length;i++)v.has(this.d[i])&&(this.d.splice(i,1),i--);for(const i of o)this.c.push(i);for(const i of a)this.d.push(i)}containsExtension(m){for(const t of this.d)if(P.ExtensionIdentifier.equals(t,m))return!0;return!1}}e.ExtensionHostExtensions=L;function k(y){const m=new P.ExtensionIdentifierMap;for(const t of y)m.set(t.identifier,t);return m}function S(y,m){return y.enabledApiProposals?y.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=S;function I(y,m){if(!S(y,m))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.checkProposedApiEnabled=I;class C{constructor(m,t,o,s){this.codeLoadingTime=m,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=s}}e.ActivationTimes=C;class E{constructor(m,t){this.description=m,this.value=t}}e.ExtensionPointContribution=E;var r;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function d(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,u.getGalleryExtensionId)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function f(y,m){return{identifier:new P.ExtensionIdentifier((0,u.getExtensionId)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!m,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform,browserNlsBundleUris:y.browserNlsBundleUris}}e.toExtensionDescription=f;class w{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(m,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=w}),define(De[242],Ce([1,0,9,135,25,27,16,19]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(d,f,w,y){this.startup=d,this.codeLoadingTime=f,this.activateCallTime=w,this.activateResolvedTime=y}}D.NONE=new D(!1,-1,-1,-1),e.ExtensionActivationTimes=D;class g{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,f){return d===-1||f===-1?-1:f-d}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=g;class L{constructor(d,f,w,y,m,t){this.activationFailed=d,this.activationFailedError=f,this.activationTimes=w,this.module=y,this.exports=m,this.subscriptions=t}}e.ActivatedExtension=L;class k extends L{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class S extends L{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class I extends L{constructor(d){super(!0,d,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(d,f,w,y){this.g=y,this.a=d,this.b=f,this.c=w,this.d=new u.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[d,f]of this.d)f.dispose()}isActivated(d){const f=this.d.get(d);return Boolean(f&&f.value)}getActivatedExtension(d){const f=this.d.get(d);if(!f||!f.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return f.value}async activateByEvent(d,f){if(this.f[d])return;const w=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(w.map(y=>({id:y.identifier,reason:{startup:f,extensionId:y.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,f){const w=this.a.getExtensionDescription(d);if(!w)throw new Error(`Extension '${d}' is not known`);return this.h([{id:w.identifier,reason:f}])}async h(d){const f=d.filter(w=>!this.isActivated(w.id)).map(w=>this.j(w));await Promise.all(f.map(w=>w.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const f=this.a.getExtensionDescription(d.id);if(!f){const m=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new I(m));return this.c.onExtensionActivationError(d.id,m,new R.MissingExtensionDependency(d.id.value)),t}const w=[],y=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const m of y){if(this.m(m))continue;const t=this.d.get(m);if(t){w.push(t);continue}if(this.l(m)){w.push(this.j({id:this.b.getExtensionDescription(m).identifier,reason:d.reason}));continue}const o=this.a.getExtensionDescription(m);if(o){if(!o.main&&!o.browser)continue;w.push(this.j({id:o.identifier,reason:d.reason}));continue}const s=f.displayName||f.identifier.value,a=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${m}'`),l=this.k(d,f.displayName,[],new I(a));return this.c.onExtensionActivationError(f.identifier,a,new R.MissingExtensionDependency(m)),l}return this.k(d,f.displayName,w,null)}k(d,f,w,y){const m=new E(d.id,f,d.reason,w,y,this.c,this.g);return this.d.set(d.id,m),m}l(d){return A.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const f=this.b.getExtensionDescription(d);return f?!f.main&&!f.browser:!1}};C=Ve([We(3,P.ILogService)],C),e.ExtensionsActivator=C;let E=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,f,w,y,m,t,o){this.c=d,this.d=f,this.f=w,this.g=y,this.h=m,this.j=t,this.k=o,this.a=new T.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const f=this.g[d];if(f.value&&!f.value.activationFailed){this.g.splice(d,1),d--;continue}if(f.value&&f.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);w.detail=f.value.activationFailedError,this.h=new I(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const f=new Error;if(d&&d.name&&(f.name=d.name),d&&d.message?f.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:f.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(f.stack=d.stack),this.h=new I(f),this.b&&c.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,f,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};E=Ve([We(6,P.ILogService)],E)});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[7],Ce([1,0,17,9,113,28,88,8,10,2,30,45,128,94,27]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C){"use strict";var E,r,d,f,w,y,m,t,o,s,a,l,v,i,n,h,b,p,O,W,q,Y,x,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(X){return Object.assign(X,{apply:function(){const pe=arguments.length===1?[]:arguments[1];return Reflect.construct(X,pe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(X,[]);{const[pe,...Te]=arguments;return Reflect.construct(X,Te,pe.constructor)}}})}var j;(function(X){X[X.Top=0]="Top",X[X.Bottom=1]="Bottom"})(j=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var he;(function(X){X[X.Command=0]="Command",X[X.Opener=1]="Opener"})(he=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let ie=t=class{static from(...H){let pe=H;return new t(function(){if(pe){for(const Te of pe)Te&&typeof Te.dispose=="function"&&Te.dispose();pe=void 0}})}constructor(H){E.set(this,void 0),_e(this,E,H,"f")}dispose(){typeof Me(this,E,"f")=="function"&&(Me(this,E,"f").call(this),_e(this,E,void 0,"f"))}};E=new WeakMap,ie=t=Ve([U],ie),e.Disposable=ie;let V=o=class{static Min(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let Te=1;Te<H.length;Te++){const xe=H[Te];xe.isBefore(pe)&&(pe=xe)}return pe}static Max(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let Te=1;Te<H.length;Te++){const xe=H[Te];xe.isAfter(pe)&&(pe=xe)}return pe}static isPosition(H){if(!H)return!1;if(H instanceof o)return!0;const{line:pe,character:Te}=H;return typeof pe=="number"&&typeof Te=="number"}static of(H){if(H instanceof o)return H;if(this.isPosition(H))return new o(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,pe){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(pe<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=H,this.e=pe}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,pe=0){if(H===null||pe===null)throw(0,A.illegalArgument)();let Te;return typeof H>"u"?Te=0:typeof H=="number"?Te=H:(Te=typeof H.lineDelta=="number"?H.lineDelta:0,pe=typeof H.characterDelta=="number"?H.characterDelta:0),Te===0&&pe===0?this:new o(this.line+Te,this.character+pe)}with(H,pe=this.character){if(H===null||pe===null)throw(0,A.illegalArgument)();let Te;return typeof H>"u"?Te=this.line:typeof H=="number"?Te=H:(Te=typeof H.line=="number"?H.line:this.line,pe=typeof H.character=="number"?H.character:this.character),Te===this.line&&pe===this.character?this:new o(Te,pe)}toJSON(){return{line:this.line,character:this.character}}};V=o=Ve([U],V),e.Position=V;let J=s=class{static isRange(H){return H instanceof s?!0:H?V.isPosition(H.start)&&V.isPosition(H.end):!1}static of(H){if(H instanceof s)return H;if(this.isRange(H))return new s(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,pe,Te,xe){let Je,at;if(typeof H=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof xe=="number"?(Je=new V(H,pe),at=new V(Te,xe)):V.isPosition(H)&&V.isPosition(pe)&&(Je=V.of(H),at=V.of(pe)),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this.c=Je,this.e=at):(this.c=at,this.e=Je)}contains(H){return s.isRange(H)?this.contains(H.start)&&this.contains(H.end):V.isPosition(H)?!(V.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const pe=V.Max(H.start,this.c),Te=V.Min(H.end,this.e);if(!pe.isAfter(Te))return new s(pe,Te)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const pe=V.Min(H.start,this.c),Te=V.Max(H.end,this.end);return new s(pe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,pe=this.end){if(H===null||pe===null)throw(0,A.illegalArgument)();let Te;return H?V.isPosition(H)?Te=H:(Te=H.start||this.start,pe=H.end||this.end):Te=this.start,Te.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Te,pe)}toJSON(){return[this.start,this.end]}};J=s=Ve([U],J),e.Range=J;let ne=a=class extends J{static isSelection(H){return H instanceof a?!0:H?J.isRange(H)&&V.isPosition(H.anchor)&&V.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,pe,Te,xe){let Je,at;if(typeof H=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof xe=="number"?(Je=new V(H,pe),at=new V(Te,xe)):V.isPosition(H)&&V.isPosition(pe)&&(Je=V.of(H),at=V.of(pe)),!Je||!at)throw new Error("Invalid arguments");super(Je,at),this.f=Je,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ne=a=Ve([U],ne),e.Selection=ne;class ve{constructor(H,pe,Te){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,A.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(pe),this.connectionToken=Te}}e.ResolvedAuthority=ve;class ue extends Error{static NotAvailable(H,pe){return new ue(H,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(H){return new ue(H,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Te){super(H),this._message=H,this._code=pe,this._detail=Te,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var ee;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var N;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=l=class{static isTextEdit(H){return H instanceof l?!0:H?J.isRange(H)&&typeof H.newText=="string":!1}static replace(H,pe){return new l(H,pe)}static insert(H,pe){return l.replace(new J(H,H),pe)}static delete(H){return l.replace(H,"")}static setEndOfLine(H){const pe=new l(new J(new V(0,0),new V(0,0)),"");return pe.newEol=H,pe}get range(){return this.c}set range(H){if(H&&!J.isRange(H))throw(0,A.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this.f=H}constructor(H,pe){this.c=H,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};K=l=Ve([U],K),e.TextEdit=K;let le=v=class{static isNotebookCellEdit(H){return H instanceof v?!0:H?Gt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,pe){return new v(H,pe)}static insertCells(H,pe){return new v(new Gt(H,H),pe)}static deleteCells(H){return new v(H,[])}static updateCellMetadata(H,pe){const Te=new v(new Gt(H,H),[]);return Te.newCellMetadata=pe,Te}static updateNotebookMetadata(H){const pe=new v(new Gt(0,0),[]);return pe.newNotebookMetadata=H,pe}constructor(H,pe){this.range=H,this.newCells=pe}};le=v=Ve([U],le),e.NotebookEdit=le;class me{static isSnippetTextEdit(H){return H instanceof me?!0:H?J.isRange(H.range)&&ce.isSnippetString(H.snippet):!1}static replace(H,pe){return new me(H,pe)}static insert(H,pe){return me.replace(new J(H,H),pe)}constructor(H,pe){this.range=H,this.snippet=pe}}e.SnippetTextEdit=me;var ke;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace",X[X.Snippet=6]="Snippet"})(ke=e.FileEditType||(e.FileEditType={}));let Z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,pe,Te,xe){this.c.push({_type:1,from:H,to:pe,options:Te,metadata:xe})}createFile(H,pe,Te){this.c.push({_type:1,from:void 0,to:H,options:pe,metadata:Te})}deleteFile(H,pe,Te){this.c.push({_type:1,from:H,to:void 0,options:pe,metadata:Te})}e(H,pe,Te){this.c.push({_type:3,metadata:Te,uri:H,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(H,pe,Te,xe){const Je=pe.start,at=pe.end;(Je!==at||Te.length>0)&&this.c.push({_type:5,uri:H,index:Je,count:at-Je,cells:Te,metadata:xe})}g(H,pe,Te,xe){this.c.push({_type:3,metadata:xe,uri:H,edit:{editType:8,index:pe,metadata:Te}})}replace(H,pe,Te,xe){this.c.push({_type:2,uri:H,edit:new K(pe,Te),metadata:xe})}insert(H,pe,Te,xe){this.replace(H,new J(pe,pe),Te,xe)}delete(H,pe,Te){this.replace(H,pe,"",Te)}has(H){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===H.toString())}set(H,pe){if(pe)for(const Te of pe){if(!Te)continue;let xe,Je;Array.isArray(Te)?(xe=Te[0],Je=Te[1]):xe=Te,le.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(H,xe.range.start,xe.newCellMetadata,Je):xe.newNotebookMetadata?this.e(H,xe.newNotebookMetadata,Je):this.f(H,xe.range,xe.newCells,Je):me.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:H,range:xe.range,edit:xe.snippet,metadata:Je}):this.c.push({_type:2,uri:H,edit:xe,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const xe=this.c[Te];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===H.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(H){const pe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===H.toString()&&pe.push(Te.edit);return pe}entries(){const H=new R.ResourceMap;for(const pe of this.c)if(pe._type===2){let Te=H.get(pe.uri);Te||(Te=[pe.uri,[]],H.set(pe.uri,Te)),Te[1].push(pe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Z=Ve([U],Z),e.WorkspaceEdit=Z;let ce=i=class{static isSnippetString(H){return H instanceof i?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=i.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,pe=this.e++){if(typeof H=="function"){const Te=new i;Te.e=this.e,H(Te),this.e=Te.e,H=Te.value}else H=i.c(H);return this.value+="${",this.value+=pe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,pe=this.e++){const Te=H.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(H,pe){if(typeof pe=="function"){const Te=new i;Te.e=this.e,pe(Te),this.e=Te.e,pe=Te.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};ce=i=Ve([U],ce),e.SnippetString=ce;var de;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(de=e.DiagnosticTag||(e.DiagnosticTag={}));var te;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(te=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=n=class{static isLocation(H){return H instanceof n?!0:H?J.isRange(H.range)&&g.URI.isUri(H.uri):!1}constructor(H,pe){if(this.uri=H,pe)if(J.isRange(pe))this.range=J.of(pe);else if(V.isPosition(pe))this.range=new J(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ae=n=Ve([U],ae),e.Location=ae;let oe=class{static is(H){return H?typeof H.message=="string"&&H.location&&J.isRange(H.location.range)&&g.URI.isUri(H.location.uri):!1}constructor(H,pe){this.location=H,this.message=pe}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.location.range.isEqual(pe.location.range)&&H.location.uri.toString()===pe.location.uri.toString()}};oe=Ve([U],oe),e.DiagnosticRelatedInformation=oe;let F=class{constructor(H,pe,Te=te.Error){if(!J.isRange(H))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=H,this.message=pe,this.severity=Te}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.severity===pe.severity&&H.code===pe.code&&H.severity===pe.severity&&H.source===pe.source&&H.range.isEqual(pe.range)&&(0,c.equals)(H.tags,pe.tags)&&(0,c.equals)(H.relatedInformation,pe.relatedInformation,oe.isEqual)}};F=Ve([U],F),e.Diagnostic=F;let z=class{constructor(H,pe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=pe}};z=Ve([U],z),e.Hover=z;var G;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(G=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let _=class{constructor(H,pe=G.Text){this.range=H,this.kind=pe}toJSON(){return{range:this.range,kind:G[this.kind]}}};_=Ve([U],_),e.DocumentHighlight=_;var fe;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(fe=e.SymbolKind||(e.SymbolKind={}));var Ee;(function(X){X[X.Deprecated=1]="Deprecated"})(Ee=e.SymbolTag||(e.SymbolTag={}));let Ae=h=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,pe,Te,xe,Je){this.name=H,this.kind=pe,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),xe instanceof ae?this.location=xe:Te instanceof J&&(this.location=new ae(xe,Te)),h.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};Ae=h=Ve([U],Ae),e.SymbolInformation=Ae;let we=b=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(b.validate)}constructor(H,pe,Te,xe,Je){this.name=H,this.detail=pe,this.kind=Te,this.range=xe,this.selectionRange=Je,this.children=[],b.validate(this)}};we=b=Ve([U],we),e.DocumentSymbol=we;var Pe;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Ie=class{constructor(H,pe){this.title=H,this.kind=pe}};Ie=Ve([U],Ie),e.CodeAction=Ie;let ze=p=class{constructor(H){this.value=H}append(H){return new p(this.value?this.value+p.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+p.c)}};ze.c=".",ze=p=Ve([U],ze),e.CodeActionKind=ze,ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll");let qe=class{constructor(H,pe){if(this.range=H,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};qe=Ve([U],qe),e.SelectionRange=qe;class tt{constructor(H,pe,Te,xe,Je,at){this.kind=H,this.name=pe,this.detail=Te,this.uri=xe,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=tt;class Qe{constructor(H,pe){this.fromRanges=pe,this.from=H}}e.CallHierarchyIncomingCall=Qe;class it{constructor(H,pe){this.fromRanges=pe,this.to=H}}e.CallHierarchyOutgoingCall=it;var rt;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(rt=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Be=class{constructor(H,pe){this.range=H,this.command=pe}get isResolved(){return!!this.command}};Be=Ve([U],Be),e.CodeLens=Be;let et=O=class{static isMarkdownString(H){return H instanceof O?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,pe=!1){r.set(this,void 0),_e(this,r,new u.MarkdownString(H,{supportThemeIcons:pe}),"f")}get value(){return Me(this,r,"f").value}set value(H){Me(this,r,"f").value=H}get isTrusted(){return Me(this,r,"f").isTrusted}set isTrusted(H){Me(this,r,"f").isTrusted=H}get supportThemeIcons(){return Me(this,r,"f").supportThemeIcons}set supportThemeIcons(H){Me(this,r,"f").supportThemeIcons=H}get supportHtml(){return Me(this,r,"f").supportHtml}set supportHtml(H){Me(this,r,"f").supportHtml=H}get baseUri(){return Me(this,r,"f").baseUri}set baseUri(H){Me(this,r,"f").baseUri=H}appendText(H){return Me(this,r,"f").appendText(H),this}appendMarkdown(H){return Me(this,r,"f").appendMarkdown(H),this}appendCodeblock(H,pe){return Me(this,r,"f").appendCodeblock(pe??"",H),this}};r=new WeakMap,et=O=Ve([U],et),e.MarkdownString=et;let $=class{constructor(H,pe){this.label=H,this.documentation=pe}};$=Ve([U],$),e.ParameterInformation=$;let Q=class{constructor(H,pe){this.label=H,this.documentation=pe,this.parameters=[]}};Q=Ve([U],Q),e.SignatureInformation=Q;let ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ge=Ve([U],ge),e.SignatureHelp=ge;var Le;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let je=class{constructor(H){this.value=H}};je=Ve([U],je),e.InlayHintLabelPart=je;let Ye=class{constructor(H,pe,Te){this.position=H,this.label=pe,this.kind=Te}};Ye=Ve([U],Ye),e.InlayHint=Ye;var Xe;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var nt;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(nt=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(X){X[X.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let pt=class{constructor(H,pe){this.label=H,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&nt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pt=Ve([U],pt),e.CompletionItem=pt;let bt=class{constructor(H=[],pe=!1){this.items=H,this.isIncomplete=pe}};bt=Ve([U],bt),e.CompletionList=bt;let St=class{constructor(H,pe,Te){this.insertText=H,this.range=pe,this.command=Te}};St=Ve([U],St),e.InlineSuggestion=St;let Pt=class{constructor(H){this.commands=void 0,this.items=H}};Pt=Ve([U],Pt),e.InlineSuggestionList=Pt;var $t;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})($t=e.ViewColumn||(e.ViewColumn={}));var Xt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var vt;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(vt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var wt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(wt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function H(pe){switch(pe){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=H}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let kt=class{constructor(H,pe){if(pe&&!g.URI.isUri(pe))throw(0,A.illegalArgument)("target");if(!J.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=pe}};kt=Ve([U],kt),e.DocumentLink=kt;let At=class{constructor(H,pe,Te,xe){this.red=H,this.green=pe,this.blue=Te,this.alpha=xe}};At=Ve([U],At),e.Color=At;let Bt=class{constructor(H,pe){if(pe&&!(pe instanceof At))throw(0,A.illegalArgument)("color");if(!J.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=pe}};Bt=Ve([U],Bt),e.ColorInformation=Bt;let Ke=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};Ke=Ve([U],Ke),e.ColorPresentation=Ke;var Wt;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var Re;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Re=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Fe;(function(X){X[X.Unknown=0]="Unknown",X[X.Shutdown=1]="Shutdown",X[X.Process=2]="Process",X[X.User=3]="User",X[X.Extension=4]="Extension"})(Fe=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(H,pe,Te){if(this.startIndex=H,this.length=pe,this.tooltip=Te,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,A.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Se;class se{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=se;class Oe{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=Oe;var He;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(He=e.TerminalLocation||(e.TerminalLocation={}));class Ze{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Ze;var Ge;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(Ge=e.TaskRevealKind||(e.TaskRevealKind={}));var ct;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(ct=e.TaskPanelKind||(e.TaskPanelKind={}));let mt=W=class{static from(H){switch(H){case"clean":return W.Clean;case"build":return W.Build;case"rebuild":return W.Rebuild;case"test":return W.Test;default:return}}constructor(H,pe){if(this.label=pe,typeof H!="string"||typeof pe!="string")throw(0,A.illegalArgument)("name");this.c=H}get id(){return this.c}};mt.Clean=new W("clean","Clean"),mt.Build=new W("build","Build"),mt.Rebuild=new W("rebuild","Rebuild"),mt.Test=new W("test","Test"),mt=W=Ve([U],mt),e.TaskGroup=mt;function gt(X){let H="";for(let pe=0;pe<X.length;pe++)H+=X[pe].replace(/,/g,",,")+",";return H}let dt=class{constructor(H,pe,Te){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=H,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Te):this.f=pe)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)H.push(pe);return gt(H)}};dt=Ve([U],dt),e.ProcessExecution=dt;let lt=class{constructor(H,pe,Te){if(this.f=[],Array.isArray(pe)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H,this.f=pe,this.g=Te}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H,this.g=pe}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)H.push(typeof pe=="string"?pe:pe.value);return gt(H)}};lt=Ve([U],lt),e.ShellExecution=lt;var yt;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var Tt;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(Tt=e.TaskScope||(e.TaskScope={}));class Ht{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=Ht;let Ft=q=class{constructor(H,pe,Te,xe,Je,at){this.j=!1,this.k=this.definition=H;let ut;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Te,this.execution=xe,ut=Je,this.j=!0):pe===Tt.Global||pe===Tt.Workspace?(this.target=pe,this.m=this.name=Te,this.t=this.source=xe,this.execution=Je,ut=at):(this.target=pe,this.m=this.name=Te,this.t=this.source=xe,this.execution=Je,ut=at),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof dt?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof lt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof Ht?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const pe=this.k.type;(q.g===pe||q.e===pe||q.f===pe||q.c===pe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};Ft.c="customExecution",Ft.e="process",Ft.f="shell",Ft.g="$empty",Ft=q=Ve([U],Ft),e.Task=Ft;var ai;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(ai=e.ProgressLocation||(e.ProgressLocation={}));var Rt;(function(X){function H(pe){const Te=pe;return(0,D.isNumber)(Te.value)?Te.tooltip&&!(0,D.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}X.isViewBadge=H})(Rt=e.ViewBadge||(e.ViewBadge={}));let yi=Y=class{static isTreeItem(H,pe){const Te=H;if(Te.checkboxState!==void 0){(0,C.checkProposedApiEnabled)(pe,"treeItemCheckbox");const xe=(0,D.isNumber)(Te.checkboxState)?Te.checkboxState:(0,D.isObject)(Te.checkboxState)&&(0,D.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,D.isNumber)(Te.checkboxState)&&(0,D.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(xe===void 0||xe!==It.Checked&&xe!==It.Unchecked||Je!==void 0&&!(0,D.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(H instanceof Y)return!0;if(Te.label!==void 0&&!(0,D.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,D.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,D.isString)(Te.iconPath)&&!g.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,D.isString)(Te.iconPath.id))){const xe=Te.iconPath;if(!xe||!(0,D.isString)(xe.light)&&!g.URI.isUri(xe.light)&&!(0,D.isString)(xe.dark)&&!g.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,D.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!g.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,D.isString)(Te.tooltip)&&!(Te.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<ci.None&&Te.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,D.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(H,pe=ci.None){this.collapsibleState=pe,g.URI.isUri(H)?this.resourceUri=H:this.label=H}};yi=Y=Ve([U],yi),e.TreeItem=yi;var ci;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var It;(function(X){X[X.Unchecked=0]="Unchecked",X[X.Checked=1]="Checked"})(It=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let li=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,pe){this.value=H,this.id=pe??(0,L.generateUuid)()}};li=Ve([U],li),e.DataTransferItem=li;let ui=class{constructor(H){d.add(this),f.set(this,new Map);for(const[pe,Te]of H??[]){const xe=Me(this,f,"f").get(Me(this,d,"m",w).call(this,pe));xe?xe.push(Te):Me(this,f,"f").set(Me(this,d,"m",w).call(this,pe),[Te])}}get(H){return Me(this,f,"f").get(Me(this,d,"m",w).call(this,H))?.[0]}set(H,pe){Me(this,f,"f").set(Me(this,d,"m",w).call(this,H),[pe])}forEach(H,pe){for(const[Te,xe]of Me(this,f,"f"))for(const Je of xe)H.call(pe,Je,Te,this)}*[(f=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[H,pe]of Me(this,f,"f"))for(const Te of pe)yield[H,Te]}};w=function(H){return H.toLowerCase()},ui=Ve([U],ui),e.DataTransfer=ui;let Zt=class{constructor(H){this.insertText=H}};Zt=Ve([U],Zt),e.DocumentDropEdit=Zt;let Di=class{constructor(H){this.insertText=H}};Di=Ve([U],Di),e.DocumentPasteEdit=Di;let Dt=class{constructor(H,pe){this.id=H,this.color=pe}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};Dt=Ve([U],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let di=class{constructor(H){this.id=H}};di=Ve([U],di),e.ThemeColor=di;var zi;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(zi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(H){this.c=H,this.e=g.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,pe){if(typeof H!="string"&&(!H||!g.URI.isUri(H)&&!g.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof pe!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=g.URI.file(H):g.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=Ve([U],ei),e.RelativePattern=ei;const ii=new WeakMap;function ht(X,H){ii.set(X,H)}e.setBreakpointId=ht;let ti=class{constructor(H,pe,Te,xe){this.enabled=typeof H=="boolean"?H:!0,typeof pe=="string"&&(this.condition=pe),typeof Te=="string"&&(this.hitCondition=Te),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ii.get(this)??(0,L.generateUuid)()),this.c}};ti=Ve([U],ti),e.Breakpoint=ti;let Vt=class extends ti{constructor(H,pe,Te,xe,Je){if(super(pe,Te,xe,Je),H===null)throw(0,A.illegalArgument)("location");this.location=H}};Vt=Ve([U],Vt),e.SourceBreakpoint=Vt;let Qt=class extends ti{constructor(H,pe,Te,xe,Je){super(pe,Te,xe,Je),this.functionName=H}};Qt=Ve([U],Qt),e.FunctionBreakpoint=Qt;let hi=class extends ti{constructor(H,pe,Te,xe,Je,at,ut){if(super(xe,Je,at,ut),!pe)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=pe,this.canPersist=Te}};hi=Ve([U],hi),e.DataBreakpoint=hi;let Ci=class{constructor(H,pe,Te){this.command=H,this.args=pe||[],this.options=Te}};Ci=Ve([U],Ci),e.DebugAdapterExecutable=Ci;let Ii=class{constructor(H,pe){this.port=H,this.host=pe}};Ii=Ve([U],Ii),e.DebugAdapterServer=Ii;let fi=class{constructor(H){this.path=H}};fi=Ve([U],fi),e.DebugAdapterNamedPipeServer=fi;let ki=class{constructor(H){this.implementation=H}};ki=Ve([U],ki),e.DebugAdapterInlineImplementation=ki;let mi=class{constructor(H,pe){this.range=H,this.expression=pe}};mi=Ve([U],mi),e.EvaluatableExpression=mi;var gi;(function(X){X[X.Invoke=0]="Invoke",X[X.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ti=class{constructor(H,pe){this.range=H,this.text=pe}};Ti=Ve([U],Ti),e.InlineValueText=Ti;let ni=class{constructor(H,pe,Te=!0){this.range=H,this.variableName=pe,this.caseSensitiveLookup=Te}};ni=Ve([U],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(H,pe){this.range=H,this.expression=pe}};ri=Ve([U],ri),e.InlineValueEvaluatableExpression=ri;let Pi=class{constructor(H,pe){this.frameId=H,this.stoppedLocation=pe}};Pi=Ve([U],Pi),e.InlineValueContext=Pi;var $i;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let Yt=x=class extends Error{static FileExists(H){return new x(H,k.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(H){return new x(H,k.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(H){return new x(H,k.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(H){return new x(H,k.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(H){return new x(H,k.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(H){return new x(H,k.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(H,pe=k.FileSystemProviderErrorCode.Unknown,Te){super(g.URI.isUri(H)?H.toString(!0):H),this.code=Te?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Yt=x=Ve([U],Yt),e.FileSystemError=Yt;let Ai=class{constructor(H,pe,Te){this.start=H,this.end=pe,this.kind=Te}};Ai=Ve([U],Ai),e.FoldingRange=Ai;var Wi;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ni;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Ni=e.CommentMode||(e.CommentMode={}));var ji;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(ji=e.CommentThreadState||(e.CommentThreadState={}));class Vi{constructor(H,pe=[]){this.tokenTypes=H,this.tokenModifiers=pe}}e.SemanticTokensLegend=Vi;function qi(X){return typeof X>"u"||(0,D.isStringArray)(X)}class si{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let pe=0,Te=H.tokenTypes.length;pe<Te;pe++)this.j.set(H.tokenTypes[pe],pe);for(let pe=0,Te=H.tokenModifiers.length;pe<Te;pe++)this.k.set(H.tokenModifiers[pe],pe)}}push(H,pe,Te,xe,Je){if(typeof H=="number"&&typeof pe=="number"&&typeof Te=="number"&&typeof xe=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(H,pe,Te,xe,Je);if(J.isRange(H)&&typeof pe=="string"&&qi(Te))return this.m(H,pe,Te);throw(0,A.illegalArgument)()}m(H,pe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const xe=H.start.line,Je=H.start.character,at=H.end.character-H.start.character,ut=this.j.get(pe);let Mt=0;if(Te)for(const jt of Te){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(jt);Mt|=1<<qt>>>0}this.n(xe,Je,at,ut,Mt)}n(H,pe,Te,xe,Je){if(this.f&&(H<this.c||H===this.c&&pe<this.e)){this.f=!1;const Mt=this.g.length/5|0;let jt=0,qt=0;for(let Kt=0;Kt<Mt;Kt++){let Jt=this.g[5*Kt],Li=this.g[5*Kt+1];Jt===0?(Jt=jt,Li+=qt):Jt+=jt,this.g[5*Kt]=Jt,this.g[5*Kt+1]=Li,jt=Jt,qt=Li}}let at=H,ut=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(ut-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ut,this.g[this.h++]=Te,this.g[this.h++]=xe,this.g[this.h++]=Je,this.c=H,this.e=pe}static o(H){const pe=[],Te=H.length/5|0;for(let ut=0;ut<Te;ut++)pe[ut]=ut;pe.sort((ut,Mt)=>{const jt=H[5*ut],qt=H[5*Mt];if(jt===qt){const Kt=H[5*ut+1],Jt=H[5*Mt+1];return Kt-Jt}return jt-qt});const xe=new Uint32Array(H.length);let Je=0,at=0;for(let ut=0;ut<Te;ut++){const Mt=5*pe[ut],jt=H[Mt+0],qt=H[Mt+1],Kt=H[Mt+2],Jt=H[Mt+3],Li=H[Mt+4],ln=jt-Je,On=ln===0?qt-at:qt,Oi=5*ut;xe[Oi+0]=ln,xe[Oi+1]=On,xe[Oi+2]=Kt,xe[Oi+3]=Jt,xe[Oi+4]=Li,Je=jt,at=qt}return xe}build(H){return this.f?new pi(new Uint32Array(this.g),H):new pi(si.o(this.g),H)}}e.SemanticTokensBuilder=si;class pi{constructor(H,pe){this.resultId=pe,this.data=H}}e.SemanticTokens=pi;class Fi{constructor(H,pe,Te){this.start=H,this.deleteCount=pe,this.data=Te}}e.SemanticTokensEdit=Fi;class $e{constructor(H,pe){this.resultId=pe,this.edits=H}}e.SemanticTokensEdits=$e;var xt;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let oi=class{constructor(){}};oi.Back={iconPath:new Dt("arrow-left")},oi=Ve([U],oi),e.QuickInputButtons=oi;var Et;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Et=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xi;(function(X){X[X.Info=1]="Info",X[X.Warning=2]="Warning",X[X.Error=3]="Error"})(xi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Gi;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(Gi=e.ExtensionKind||(e.ExtensionKind={}));class Mi{static validate(H){if(typeof H.badge=="string"){let pe=(0,T.nextCharLength)(H.badge,0);if(pe<H.badge.length&&(pe+=(0,T.nextCharLength)(H.badge,pe)),H.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Dt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,pe,Te){this.badge=H,this.tooltip=pe,this.color=Te}}e.FileDecoration=Mi;let Ri=class{constructor(H){this.kind=H}};Ri=Ve([U],Ri),e.ColorTheme=Ri;var bi;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast",X[X.HighContrastLight=4]="HighContrastLight"})(bi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(H){return H instanceof Gt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,pe){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(pe<0)throw(0,A.illegalArgument)("end must be positive");H<=pe?(this.c=H,this.e=pe):(this.c=pe,this.e=H)}with(H){let pe=this.c,Te=this.e;return H.start!==void 0&&(pe=H.start),H.end!==void 0&&(Te=H.end),pe===this.c&&Te===this.e?this:new Gt(pe,Te)}}e.NotebookRange=Gt;class vi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(pe=>vi.isNotebookCellData(pe))}static isNotebookCellData(H){return!0}constructor(H,pe,Te,xe,Je,at,ut){this.kind=H,this.value=pe,this.languageId=Te,this.mime=xe,this.outputs=Je??[],this.metadata=at,this.executionSummary=ut,vi.validate(this)}}e.NotebookCellData=vi;class Ki{constructor(H){this.cells=H}}e.NotebookData=Ki;class zt{static isNotebookCellOutputItem(H){return H instanceof zt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const pe={name:H.name,message:H.message,stack:H.stack};return zt.json(pe,"application/vnd.code.notebook.error")}static stdout(H){return zt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return zt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,pe="application/octet-stream"){return new zt(H,pe)}static text(H,pe=P.Mimes.text){const Te=Me(zt,y,"f",m).encode(String(H));return new zt(Te,pe)}static json(H,pe="text/x-json"){const Te=JSON.stringify(H,void 0,"	");return zt.text(Te,pe)}constructor(H,pe){this.data=H,this.mime=pe;const Te=(0,P.normalizeMimeType)(pe,!0);if(!Te)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}y=zt,m={value:new TextEncoder},e.NotebookCellOutputItem=zt;class wi{static isNotebookCellOutput(H){return H instanceof wi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,pe=!1){const Te=new Set,xe=new Set;for(let Je=0;Je<H.length;Je++){const at=H[Je],ut=(0,P.normalizeMimeType)(at.mime);if(!Te.has(ut)||(0,I.isTextStreamMime)(ut)){Te.add(ut);continue}xe.add(Je),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return xe.size===0?H:H.filter((Je,at)=>!xe.has(at))}constructor(H,pe,Te){this.items=wi.ensureUniqueMimeTypes(H,!0),typeof pe=="string"?(this.id=pe,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=pe??Te)}}e.NotebookCellOutput=wi;var Xi;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ji;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ji=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class _i{constructor(H,pe){this.text=H,this.alignment=pe}}e.NotebookCellStatusBarItem=_i;var Zi;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(Zi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var be;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred",X[X.Hidden=-1]="Hidden"})(be=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ye{constructor(H,pe=[]){this.uri=H,this.provides=(0,c.asArray)(pe)}}e.NotebookRendererScript=ye;class Ue{constructor(H){this.label=H}}e.NotebookKernelSourceAction=Ue;let st=class{constructor(H,pe){this.label=H,this.timestamp=pe}};st=Ve([U],st),e.TimelineItem=st;var Ct;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(Ct=e.ExtensionMode||(e.ExtensionMode={}));var Lt;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(Lt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(H,pe){this.ranges=H,this.wordPattern=pe}}e.LinkedEditingRanges=gn;class pn{constructor(H,pe){this.c=H,this.e=pe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=pn;var bn;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(bn=e.TestResultState||(e.TestResultState={}));var vn;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(vn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(H=void 0,pe=void 0,Te=void 0){this.include=H,this.exclude=pe,this.profile=Te}};Ui=Ve([U],Ui),e.TestRunRequest=Ui;let en=class extends Ui{constructor(H=void 0,pe=void 0,Te=void 0,xe=!1){super(H,pe,Te),this.continuous=xe}};en=Ve([U],en),e.TestRunRequest2=en;let tn=M=class{static diff(H,pe,Te){const xe=new M(H);return xe.expectedOutput=pe,xe.actualOutput=Te,xe}constructor(H){this.message=H}};tn=M=Ve([U],tn),e.TestMessage=tn;let nn=class{constructor(H){this.id=H}};nn=Ve([U],nn),e.TestTag=nn;let Ei=class{constructor(H,pe){this.covered=H,this.total=pe}};Ei=Ve([U],Ei),e.CoveredCount=Ei;let rn=B=class{static fromDetails(H,pe){const Te=new Ei(0,0),xe=new Ei(0,0),Je=new Ei(0,0);for(const ut of pe)if("branches"in ut){Te.total+=1,Te.covered+=ut.executionCount>0?1:0;for(const Mt of ut.branches)xe.total+=1,xe.covered+=Mt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ut.executionCount>0?1:0;const at=new B(H,Te,xe.total>0?xe:void 0,Je.total>0?Je:void 0);return at.detailedCoverage=pe,at}constructor(H,pe,Te,xe){this.uri=H,this.statementCoverage=pe,this.branchCoverage=Te,this.functionCoverage=xe}};rn=B=Ve([U],rn),e.FileCoverage=rn;let sn=class{constructor(H,pe,Te=[]){this.executionCount=H,this.location=pe,this.branches=Te}};sn=Ve([U],sn),e.StatementCoverage=sn;let on=class{constructor(H,pe){this.executionCount=H,this.location=pe}};on=Ve([U],on),e.BranchCoverage=on;let an=class{constructor(H,pe){this.executionCount=H,this.location=pe}};an=Ve([U],an),e.FunctionCoverage=an;var wn;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var En;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(En=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(H,pe,Te,xe,Je,at){this.kind=H,this.name=pe,this.detail=Te,this.uri=xe,this.range=Je,this.selectionRange=at}}e.TypeHierarchyItem=yn;class Dn{constructor(H){this.uri=H}}e.TextTabInput=Dn;class Cn{constructor(H,pe){this.original=H,this.modified=pe}}e.TextDiffTabInput=Cn;class In{constructor(H,pe,Te,xe){this.base=H,this.input1=pe,this.input2=Te,this.result=xe}}e.TextMergeTabInput=In;class kn{constructor(H,pe){this.uri=H,this.viewType=pe}}e.CustomEditorTabInput=kn;class Tn{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=Tn;class Pn{constructor(H,pe){this.uri=H,this.notebookType=pe}}e.NotebookEditorTabInput=Pn;class An{constructor(H,pe,Te){this.original=H,this.modified=pe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class Ln{constructor(H,pe){this.uri=H,this.inputBoxUri=pe}}e.InteractiveWindowInput=Ln}),define(De[136],Ce([1,0,51,18,8,166,107,7,17]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const g=new Map;function L(C,E){E?g.set(C,E):g.delete(C)}e.setWordDefinitionFor=L;function k(C){return g.get(C)}class S extends R.MirrorTextModel{constructor(E,r,d,f,w,y,m,t){super(r,d,f,w),this.m=E,this.p=y,this.q=m,this.notebook=t,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(E){return(0,D.equals)(this.d,E)}get document(){if(!this.a){const E=this;this.a={get uri(){return E.c},get fileName(){return E.c.fsPath},get isUntitled(){return E.c.scheme===A.Schemas.untitled},get languageId(){return E.p},get version(){return E.g},get isClosed(){return E.b},get isDirty(){return E.q},save(){return E.r()},getText(r){return r?E.s(r):E.getText()},get eol(){return E.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return E.d.length},lineAt(r){return E.t(r)},offsetAt(r){return E.u(r)},positionAt(r){return E.v(r)},validateRange(r){return E.w(r)},validatePosition(r){return E.x(r)},getWordRangeAtPosition(r,d){return E.y(r,d)}}}return Object.freeze(this.a)}_acceptLanguageId(E){(0,c.ok)(!this.b),this.p=E}_acceptIsDirty(E){(0,c.ok)(!this.b),this.q=E}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(E){const r=this.w(E);if(r.isEmpty)return"";if(r.isSingleLine)return this.d[r.start.line].substring(r.start.character,r.end.character);const d=this.f,f=r.start.line,w=r.end.line,y=[];y.push(this.d[f].substring(r.start.character));for(let m=f+1;m<w;m++)y.push(this.d[m]);return y.push(this.d[w].substring(0,r.end.character)),y.join(d)}t(E){let r;if(E instanceof T.Position?r=E.line:typeof E=="number"&&(r=E),typeof r!="number"||r<0||r>=this.d.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new I(r,this.d[r],r===this.d.length-1)}u(E){return E=this.x(E),this.k(),this.h.getPrefixSum(E.line-1)+E.character}v(E){E=Math.floor(E),E=Math.max(0,E),this.k();const r=this.h.getIndexOf(E),d=this.d[r.index].length;return new T.Position(r.index,Math.min(r.remainder,d))}w(E){if(!(E instanceof T.Range))throw new Error("Invalid argument");const r=this.x(E.start),d=this.x(E.end);return r===E.start&&d===E.end?E:new T.Range(r.line,r.character,d.line,d.character)}x(E){if(!(E instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return E.with(0,0);let{line:r,character:d}=E,f=!1;if(r<0)r=0,d=0,f=!0;else if(r>=this.d.length)r=this.d.length-1,d=this.d[r].length,f=!0;else{const w=this.d[r].length;d<0?(d=0,f=!0):d>w&&(d=w,f=!0)}return f?new T.Position(r,d):E}y(E,r){const d=this.x(E);if(!r)r=k(this.p);else if((0,u.regExpLeadsToEndlessLoop)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const f=(0,P.getWordAtText)(d.character+1,(0,P.ensureValidWordDefinition)(r),this.d[d.line],0);if(f)return new T.Range(d.line,f.startColumn-1,d.line,f.endColumn-1)}}e.ExtHostDocumentData=S;class I{constructor(E,r,d){this.a=E,this.b=r,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=I}),define(De[243],Ce([1,0,7,20,3]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(T){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new u.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let D;switch(T){case"light":D=c.ColorThemeKind.Light;break;case"hcDark":D=c.ColorThemeKind.HighContrast;break;case"hcLight":D=c.ColorThemeKind.HighContrastLight;break;default:D=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(De[13],Ce([1,0,17,22,150,63,113,28,148,70,88,23,10,2,32,72,124,133,131,94,57,76,239,7]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Fe(se){const{selectionStartLineNumber:Oe,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:Ge}=se,ct=new o.Position(Oe-1,He-1),mt=new o.Position(Ze-1,Ge-1);return new o.Selection(ct,mt)}Re.to=Fe;function Se(se){const{anchor:Oe,active:He}=se;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(s=e.Selection||(e.Selection={}));var a;(function(Re){function Fe(se){if(!se)return;const{start:Oe,end:He}=se;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Fe;function Se(se){if(!se)return;const{startLineNumber:Oe,startColumn:He,endLineNumber:Ze,endColumn:Ge}=se;return new o.Range(Oe-1,He-1,Ze-1,Ge-1)}Re.to=Se})(a=e.Range||(e.Range={}));var l;(function(Re){function Fe(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Fe})(l=e.TokenType||(e.TokenType={}));var v;(function(Re){function Fe(se){return new o.Position(se.lineNumber-1,se.column-1)}Re.to=Fe;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Re.from=Se})(v=e.Position||(e.Position={}));var i;(function(Re){function Fe(Oe,He){return(0,c.coalesce)((0,c.asArray)(Oe).map(Ze=>Se(Ze,He)))}Re.from=Fe;function Se(Oe,He){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:se(Oe.scheme,He),pattern:ge.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function se(Oe,He){return He&&typeof Oe=="string"?He.transformOutgoingScheme(Oe):Oe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Re){function Fe(se){switch(se){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function Se(se){switch(se){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Re){function Fe(se){let Oe;return se.code&&((0,S.isString)(se.code)||(0,S.isNumber)(se.code)?Oe=String(se.code):Oe={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Oe,severity:p.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(b.from),tags:Array.isArray(se.tags)?(0,c.coalesce)(se.tags.map(n.from)):void 0}}Re.from=Fe;function Se(se){const Oe=new o.Diagnostic(a.to(se),se.message,p.to(se.severity));return Oe.source=se.source,Oe.code=(0,S.isString)(se.code)?se.code:se.code?.value,Oe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(b.to),Oe.tags=se.tags&&(0,c.coalesce)(se.tags.map(n.to)),Oe}Re.to=Se})(h=e.Diagnostic||(e.Diagnostic={}));var b;(function(Re){function Fe(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Re.from=Fe;function Se(se){return new o.DiagnosticRelatedInformation(new o.Location(se.resource,a.to(se)),se.message)}Re.to=Se})(b=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Re){function Fe(se){switch(se){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Re.from=Fe;function Se(se){switch(se){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=Se})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Re){function Fe(se){return typeof se=="number"&&se>=o.ViewColumn.One?se-1:se===o.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Re.from=Fe;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(O=e.ViewColumn||(e.ViewColumn={}));function W(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!W(Re[0])}e.isDecorationOptionsArr=q;var Y;(function(Re){function Fe(Ge){return Ge.map(Re.from)}Re.fromMany=Fe;function Se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function se(Ge){let ct;if(Se(Ge)){const{language:lt,value:yt}=Ge;ct={value:"```"+lt+`
`+yt+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const mt=Object.create(null);ct.uris=mt;const gt=lt=>{try{let yt=I.URI.parse(lt,!0);yt=yt.with({query:Oe(yt.query,mt)}),mt[lt]=yt}catch{}return""},dt=new D.marked.Renderer;return dt.link=gt,dt.image=lt=>typeof lt=="string"?gt(P.parseHrefAndDimensions(lt).href):"",(0,D.marked)(ct.value,{renderer:dt}),ct}Re.from=se;function Oe(Ge,ct){if(!Ge)return Ge;let mt;try{mt=(0,g.parse)(Ge)}catch{}if(!mt)return Ge;let gt=!1;return mt=(0,k.cloneAndChange)(mt,dt=>{if(I.URI.isUri(dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[lt]=dt,gt=!0,lt}else return}),gt?JSON.stringify(mt):Ge}function He(Ge){const ct=new o.MarkdownString(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?I.URI.from(Ge.baseUri):void 0,ct}Re.to=He;function Ze(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Re.from(Ge)}Re.fromStrict=Ze})(Y=e.MarkdownString||(e.MarkdownString={}));function x(Re){return q(Re)?Re.map(Fe=>({range:a.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?Y.fromMany(Fe.hoverMessage):Fe.hoverMessage?Y.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:a.from(Fe)}))}e.fromRangeOrRangeWithMessage=x;function M(Re){return typeof Re>"u"?Re:typeof Re=="string"?I.URI.file(Re):Re}e.pathOrURIToURI=M;var B;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?M(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Fe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?M(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Fe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var he;(function(Re){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?U.from(Se.light):void 0,dark:Se.dark?U.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?M(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Fe})(he=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(Re){function Fe(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Re.from=Fe;function Se(se){const Oe=new o.TextEdit(a.to(se.range),se.text);return Oe.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Oe}Re.to=Se})(ie=e.TextEdit||(e.TextEdit={}));var V;(function(Re){function Fe(se,Oe){const He={edits:[]};if(se instanceof o.WorkspaceEdit){const Ze=new T.ResourceSet;for(const Ge of se._allEntries())Ge._type===1&&I.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of se._allEntries())Ge._type===1?He.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?He.edits.push({resource:Ge.uri,textEdit:ie.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?He.edits.push({resource:Ge.uri,textEdit:{range:a.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Oe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?He.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&He.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ot.from)}})}return He}Re.from=Fe;function Se(se){const Oe=new o.WorkspaceEdit;for(const He of se.edits)He.textEdit?Oe.replace(I.URI.revive(He.resource),a.to(He.textEdit.range),He.textEdit.text):Oe.renameFile(I.URI.revive(He.oldResource),I.URI.revive(He.newResource),He.options);return Oe}Re.to=Se})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function Se(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Re.from=Se;function se(Oe){for(const He in Fe)if(Fe[He]===Oe)return Number(He);return o.SymbolKind.Property}Re.to=se})(J=e.SymbolKind||(e.SymbolKind={}));var ne;(function(Re){function Fe(se){switch(se){case o.SymbolTag.Deprecated:return 1}}Re.from=Fe;function Se(se){switch(se){case 1:return o.SymbolTag.Deprecated}}Re.to=Se})(ne=e.SymbolTag||(e.SymbolTag={}));var ve;(function(Re){function Fe(se){return{name:se.name,kind:J.from(se.kind),tags:se.tags&&se.tags.map(ne.from),containerName:se.containerName,location:le.from(se.location)}}Re.from=Fe;function Se(se){const Oe=new o.SymbolInformation(se.name,J.to(se.kind),se.containerName,le.to(se.location));return Oe.tags=se.tags&&se.tags.map(ne.to),Oe}Re.to=Se})(ve=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(Re){function Fe(se){const Oe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:J.from(se.kind),tags:se.tags?.map(ne.from)??[]};return se.children&&(Oe.children=se.children.map(Fe)),Oe}Re.from=Fe;function Se(se){const Oe=new o.DocumentSymbol(se.name,se.detail,J.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,c.isNonEmptyArray)(se.tags)&&(Oe.tags=se.tags.map(ne.to)),se.children&&(Oe.children=se.children.map(Se)),Oe}Re.to=Se})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Re){function Fe(se){const Oe=new o.CallHierarchyItem(J.to(se.kind),se.name,se.detail||"",I.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Re.to=Fe;function Se(se,Oe,He){if(Oe=Oe??se._sessionId,He=He??se._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,name:se.name,detail:se.detail,kind:J.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ne.from)}}Re.from=Se})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Re){function Fe(Se){return new o.CallHierarchyIncomingCall(ee.to(Se.from),Se.fromRanges.map(se=>a.to(se)))}Re.to=Fe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var K;(function(Re){function Fe(Se){return new o.CallHierarchyOutgoingCall(ee.to(Se.to),Se.fromRanges.map(se=>a.to(se)))}Re.to=Fe})(K=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(Re){function Fe(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Re.from=Fe;function Se(se){return new o.Location(I.URI.revive(se.uri),a.to(se.range))}Re.to=Se})(le=e.location||(e.location={}));var me;(function(Re){function Fe(se){const Oe=se,He=se;return{originSelectionRange:Oe.originSelectionRange?a.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:He.uri,range:a.from(Oe.targetRange?Oe.targetRange:He.range),targetSelectionRange:Oe.targetSelectionRange?a.from(Oe.targetSelectionRange):void 0}}Re.from=Fe;function Se(se){return{targetUri:I.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Re.to=Se})(me=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Re){function Fe(se){return{range:a.from(se.range),contents:Y.fromMany(se.contents)}}Re.from=Fe;function Se(se){return new o.Hover(se.contents.map(Y.to),a.to(se.range))}Re.to=Se})(ke=e.Hover||(e.Hover={}));var Z;(function(Re){function Fe(se){return{range:a.from(se.range),expression:se.expression}}Re.from=Fe;function Se(se){return new o.EvaluatableExpression(a.to(se.range),se.expression)}Re.to=Se})(Z=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ce;(function(Re){function Fe(se){if(se instanceof o.InlineValueText)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof o.InlineValueVariableLookup)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function Se(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Re.to=Se})(ce=e.InlineValue||(e.InlineValue={}));var de;(function(Re){function Fe(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Re.from=Fe;function Se(se){return new o.InlineValueContext(se.frameId,a.to(se.stoppedLocation))}Re.to=Se})(de=e.InlineValueContext||(e.InlineValueContext={}));var te;(function(Re){function Fe(se){return{range:a.from(se.range),kind:se.kind}}Re.from=Fe;function Se(se){return new o.DocumentHighlight(a.to(se.range),se.kind)}Re.to=Se})(te=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Re){function Fe(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Fe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Re){function Fe(Se){return{triggerKind:ae.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Fe})(oe=e.CompletionContext||(e.CompletionContext={}));var F;(function(Re){function Fe(se){switch(se){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function Se(se){switch(se){case 1:return o.CompletionItemTag.Deprecated}}Re.to=Se})(F=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Re){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Fe.get(He)??9}Re.from=Se;const se=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Oe(He){return se.get(He)??o.CompletionItemKind.Property}Re.to=Oe})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Re){function Fe(Se,se){const Oe=new o.CompletionItem(Se.label);return Oe.insertText=Se.insertText,Oe.kind=z.to(Se.kind),Oe.tags=Se.tags?.map(F.to),Oe.detail=Se.detail,Oe.documentation=P.isMarkdownString(Se.documentation)?Y.to(Se.documentation):Se.documentation,Oe.sortText=Se.sortText,Oe.filterText=Se.filterText,Oe.preselect=Se.preselect,Oe.commitCharacters=Se.commitCharacters,C.Range.isIRange(Se.range)?Oe.range=a.to(Se.range):typeof Se.range=="object"&&(Oe.range={inserting:a.to(Se.range.insert),replacing:a.to(Se.range.replace)}),Oe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Oe.insertText=new o.SnippetString(Se.insertText):(Oe.insertText=Se.insertText,Oe.textEdit=Oe.range instanceof o.Range?new o.TextEdit(Oe.range,Oe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Se.additionalTextEdits.map(He=>ie.to(He))),Oe.command=se&&Se.command?se.fromInternal(Se.command):void 0,Oe}Re.to=Fe})(G=e.CompletionItem||(e.CompletionItem={}));var _;(function(Re){function Fe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:Y.fromStrict(se.documentation)}}Re.from=Fe;function Se(se){return{label:se.label,documentation:P.isMarkdownString(se.documentation)?Y.to(se.documentation):se.documentation}}Re.to=Se})(_=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(Re){function Fe(se){return{label:se.label,documentation:Y.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(_.from):[],activeParameter:se.activeParameter}}Re.from=Fe;function Se(se){return{label:se.label,documentation:P.isMarkdownString(se.documentation)?Y.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(_.to):[],activeParameter:se.activeParameter}}Re.to=Se})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(Re){function Fe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(fe.from):[]}}Re.from=Fe;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(fe.to):[]}}Re.to=Se})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Fe(Se,se){const Oe=new o.InlayHint(v.to(se.position),typeof se.label=="string"?se.label:se.label.map(we.to.bind(void 0,Se)),se.kind&&Pe.to(se.kind));return Oe.textEdits=se.textEdits&&se.textEdits.map(ie.to),Oe.tooltip=P.isMarkdownString(se.tooltip)?Y.to(se.tooltip):se.tooltip,Oe.paddingLeft=se.paddingLeft,Oe.paddingRight=se.paddingRight,Oe}Re.to=Fe})(Ae=e.InlayHint||(e.InlayHint={}));var we;(function(Re){function Fe(Se,se){const Oe=new o.InlayHintLabelPart(se.label);return Oe.tooltip=P.isMarkdownString(se.tooltip)?Y.to(se.tooltip):se.tooltip,E.Command.is(se.command)&&(Oe.command=Se.fromInternal(se.command)),se.location&&(Oe.location=le.to(se.location)),Oe}Re.to=Fe})(we=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Pe;(function(Re){function Fe(se){return se}Re.from=Fe;function Se(se){return se}Re.to=Se})(Pe=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(Re){function Fe(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Re.from=Fe;function Se(se){let Oe;if(se.url)try{Oe=typeof se.url=="string"?I.URI.parse(se.url,!0):I.URI.revive(se.url)}catch{}return new o.DocumentLink(a.to(se.range),Oe)}Re.to=Se})(Ie=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Re){function Fe(se){const Oe=new o.ColorPresentation(se.label);return se.textEdit&&(Oe.textEdit=ie.to(se.textEdit)),se.additionalTextEdits&&(Oe.additionalTextEdits=se.additionalTextEdits.map(He=>ie.to(He))),Oe}Re.to=Fe;function Se(se){return{label:se.label,textEdit:se.textEdit?ie.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Oe=>ie.from(Oe)):void 0}}Re.from=Se})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Re){function Fe(se){return new o.Color(se[0],se[1],se[2],se[3])}Re.to=Fe;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Re.from=Se})(qe=e.Color||(e.Color={}));var tt;(function(Re){function Fe(se){return{range:a.from(se.range)}}Re.from=Fe;function Se(se){return new o.SelectionRange(a.to(se.range))}Re.to=Se})(tt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Fe(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(Re){function Fe(se){switch(se){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function Se(se){switch(se){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=Se})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Re){function Fe(se){if(se===o.EndOfLine.CRLF)return 1;if(se===o.EndOfLine.LF)return 0}Re.from=Fe;function Se(se){if(se===1)return o.EndOfLine.CRLF;if(se===0)return o.EndOfLine.LF}Re.to=Se})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Re){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var et;(function(Re){function Fe(se){const Oe={start:se.start+1,end:se.end+1};return se.kind&&(Oe.kind=$.from(se.kind)),Oe}Re.from=Fe;function Se(se){const Oe={start:se.start-1,end:se.end-1};return se.kind&&(Oe.kind=$.to(se.kind)),Oe}Re.to=Se})(et=e.FoldingRange||(e.FoldingRange={}));var $;(function(Re){function Fe(se){if(se)switch(se){case o.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Re.from=Fe;function Se(se){if(se)switch(se.value){case E.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Re.to=Se})($=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(Re){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?a.from(Se.selection):void 0,override:typeof Se.override=="boolean"?f.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Fe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ge;(function(Re){function Fe(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||se(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Fe;function Se(He){const Ze=He;return Ze?I.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function se(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(He){return typeof He=="string"?He:new o.RelativePattern(I.URI.revive(He.baseUri),He.pattern)}Re.to=Oe})(ge=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Re){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:ge.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Re.from=Fe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Re){function Fe(se){return{start:se.start,end:se.end}}Re.from=Fe;function Se(se){return new o.NotebookRange(se.start,se.end)}Re.to=Se})(Ne=e.NotebookRange||(e.NotebookRange={}));var je;(function(Re){function Fe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Re.to=Fe;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Re.from=Se})(je=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(Re){function Fe(Se){if(Se===w.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===w.NotebookCellExecutionState.Pending)return;if(Se===w.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Fe})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Fe(se){switch(se){case o.NotebookCellKind.Markup:return w.CellKind.Markup;case o.NotebookCellKind.Code:default:return w.CellKind.Code}}Re.from=Fe;function Se(se){switch(se){case w.CellKind.Markup:return o.NotebookCellKind.Markup;case w.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=Se})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Re){function Fe(se){const Oe={metadata:se.metadata??Object.create(null),cells:[]};for(const He of se.cells)o.NotebookCellData.validate(He),Oe.cells.push(ot.from(He));return Oe}Re.from=Fe;function Se(se){const Oe=new o.NotebookData(se.cells.map(ot.to));return(0,S.isEmptyObject)(se.metadata)||(Oe.metadata=se.metadata),Oe}Re.to=Se})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(Re){function Fe(se){return{cellKind:Xe.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:je.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(bt.from):[]}}Re.from=Fe;function Se(se){return new o.NotebookCellData(Xe.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(bt.to):void 0,se.metadata,se.internalMetadata?je.to(se.internalMetadata):void 0)}Re.to=Se})(ot=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(Re){function Fe(se){return{mime:se.mime,valueBytes:A.VSBuffer.wrap(se.data)}}Re.from=Fe;function Se(se){return new o.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Re.to=Se})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var bt;(function(Re){function Fe(se){return{outputId:se.id,items:se.items.map(pt.from),metadata:se.metadata}}Re.from=Fe;function Se(se){const Oe=se.items.map(pt.to);return new o.NotebookCellOutput(Oe,se.outputId,se.metadata)}Re.to=Se})(bt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var St;(function(Re){function Fe(Oe){return se(Oe)?{include:(0,S.withNullAsUndefined)(ge.from(Oe.include)),exclude:(0,S.withNullAsUndefined)(ge.from(Oe.exclude))}:(0,S.withNullAsUndefined)(ge.from(Oe))}Re.from=Fe;function Se(Oe){return se(Oe)?{include:ge.to(Oe.include),exclude:ge.to(Oe.exclude)}:ge.to(Oe)}Re.to=Se;function se(Oe){const He=Oe;return He?!(0,S.isUndefinedOrNull)(He.include)&&!(0,S.isUndefinedOrNull)(He.exclude):!1}})(St=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pt;(function(Re){function Fe(Se,se,Oe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(He,Oe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Fe})(Pt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var $t;(function(Re){function Fe(Se,se,Oe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(He,Oe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Fe})($t=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Xt;(function(Re){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Fe})(Xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ft;(function(Re){function Fe(se){return{uri:se.uri,provides:se.provides}}Re.from=Fe;function Se(se){return new o.NotebookRendererScript(I.URI.revive(se.uri),se.provides)}Re.to=Se})(ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var vt;(function(Re){function Fe(se){return{message:Y.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Re.from=Fe;function Se(se){const Oe=new o.TestMessage(typeof se.message=="string"?se.message:Y.to(se.message));return Oe.actualOutput=se.actual,Oe.expectedOutput=se.expected,Oe.location=se.location?le.to(se.location):void 0,Oe}Re.to=Se})(vt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Re){Re.namespace=m.namespaceTestTag,Re.denamespace=m.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Ut;(function(Re){function Fe(se){const Oe=(0,d.getPrivateApiFor)(se).controllerId;return{extId:y.TestId.fromExtHostTestItem(se,Oe).toString(),label:se.label,uri:I.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(He=>Ot.namespace(Oe,He.id)),range:C.Range.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&Y.fromStrict(se.error)||null}}Re.from=Fe;function Se(se){return{parent:void 0,error:void 0,id:y.TestId.fromString(se.extId).localId,label:se.label,uri:I.URI.revive(se.uri),tags:(se.tags||[]).map(Oe=>{const{tagId:He}=Ot.denamespace(Oe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Re.toPlain=Se})(Ut=e.TestItem||(e.TestItem={})),function(Re){function Fe(se){return{id:se.id}}Re.from=Fe;function Se(se){return new o.TestTag(se.id)}Re.to=Se}(Ot=e.TestTag||(e.TestTag={}));var Nt;(function(Re){const Fe=(se,Oe)=>{const He=[];for(const[Ge,ct]of Oe)y.TestId.compare(ct.item.extId,Ge)===2&&(Oe.delete(Ge),He.push(ct));const Ze={...Ut.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===0).map(vt.to)})),children:He.map(Ge=>Fe(Ge,Oe))};for(const Ge of Ze.children)Ge.parent=Ze;return Ze};function Se(se){const Oe=[],He=new Map;for(const Ze of se.items){He.set(Ze.item.extId,Ze);const Ge=y.TestId.root(Ze.item.extId);se.request.targets.some(ct=>ct.controllerId===Ge&&ct.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:se.completedAt,results:Oe.map(Ze=>Fe(Ze,He))}}Re.to=Se})(Nt=e.TestResults||(e.TestResults={}));var wt;(function(Re){function Fe(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?v.from(He):a.from(He)}function se(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&Se(Ze.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=se;function Oe(He){return{uri:He.uri,statement:Fe(He.statementCoverage),branch:He.branchCoverage&&Fe(He.branchCoverage),function:He.functionCoverage&&Fe(He.functionCoverage),details:He.detailedCoverage?.map(se)}}Re.fromFile=Oe})(wt=e.TestCoverage||(e.TestCoverage={}));var kt;(function(Re){function Fe(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Fe})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(Re){function Fe(se){const Oe=new o.TypeHierarchyItem(J.to(se.kind),se.name,se.detail||"",I.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Re.to=Fe;function Se(se,Oe,He){if(Oe=Oe??se._sessionId,He=He??se._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,kind:J.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ne.from)}}Re.from=Se})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Fe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Fe})(Bt=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Re){function Fe(He,Ze,Ge){const ct=Ze.fileData;return ct?new class extends o.DataTransferItem{asFile(){return{name:ct.name,uri:I.URI.revive(ct.uri),data:(0,R.once)(()=>Ge())}}}("",Ze.id):He===L.Mimes.uriList&&Ze.uriListData?new o.DataTransferItem(Oe(Ze.uriListData)):new o.DataTransferItem(Ze.asString)}Re.to=Fe;async function Se(He,Ze){const Ge=await Ze.asString();if(He===L.Mimes.uriList)return{id:Ze.id,asString:Ge,fileData:void 0,uriListData:se(Ge)};const ct=Ze.asFile();return{id:Ze.id,asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}}Re.from=Se;function se(He){return u.UriList.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return I.URI.parse(Ze)}catch{}return Ze})}function Oe(He){return u.UriList.create(He.map(Ze=>typeof Ze=="string"?Ze:I.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Wt;(function(Re){function Fe(se,Oe){const He=se.items.map(([Ze,Ge])=>[Ze,Ke.to(Ze,Ge,()=>Oe(Ge.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Fe;async function Se(se){const Oe={items:[]},He=[];return se.forEach((Ze,Ge)=>{He.push((async()=>{Oe.items.push([Ge,await Ke.from(Ge,Ze)])})())}),await Promise.all(He),Oe}Re.toDataTransferDTO=Se})(Wt=e.DataTransfer||(e.DataTransfer={}))}),define(De[244],Ce([1,0,2,9,7,13,66]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(g,L,k,S={timeout:1500,errors:3}){this.c=g,this.d=L,this.f=k,this.g=S,this.a=new P.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(L,k,S)=>{const C={dispose:this.a.push([L,k,g])};return Array.isArray(S)&&S.push(C),C}}async $participateInSave(g,L){const k=c.URI.revive(g);let S=!1;const I=setTimeout(()=>S=!0,this.g.timeout),C=[];try{for(const E of[...this.a]){if(S)break;const r=this.d.getDocument(k),d=await this.h(E,{document:r,reason:R.TextDocumentSaveReason.to(L)});C.push(d)}}finally{clearTimeout(I)}return C}h([g,L,k],S){const I=this.b.get(g);return typeof I=="number"&&I>this.g.errors?Promise.resolve(!1):this.i(k,g,L,S).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const E=this.b.get(g);this.b.set(g,E?E+1:1),typeof E=="number"&&E>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,L,k,S){const I=[],C=Date.now(),{document:E,reason:r}=S,{version:d}=E,f=Object.freeze({document:E,reason:r,waitUntil(w){if(Object.isFrozen(I))throw(0,A.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(w))}});try{L.apply(k,[f])}catch(w){return Promise.reject(w)}return Object.freeze(I),new Promise((w,y)=>{const m=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(I).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(m),w(t)}).catch(t=>{clearTimeout(m),y(t)})}).then(w=>{const y={edits:[]};for(const m of w)if(Array.isArray(m)&&m.every(t=>t instanceof u.TextEdit))for(const{newText:t,newEol:o,range:s}of m)y.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:t,eol:o&&R.EndOfLine.from(o)}});if(y.edits.length!==0)return d===E.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(De[245],Ce([1,0,18,2,13,7,94]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(k,S,I,C){this.start=k,this.deletedCount=S,this.deletedItems=I,this.items=C}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,S,I){this.notebook=k,this.h=S,this.j=I,this.handle=I.handle,this.uri=A.URI.revive(I.uri),this.cellKind=I.cellKind,this.a=I.outputs.map(u.NotebookCellOutput.to),this.e=I.internalMetadata??{},this.b=Object.freeze(I.metadata??{}),this.d=Object.freeze(u.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,S=this.h.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:u.NotebookCellKind.to(this.j.cellKind),document:S.document,get mime(){return k.g},set mime(C){k.g=C},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(I)}return this.f}setOutputs(k){this.a=k.map(u.NotebookCellOutput.to)}setOutputItems(k,S,I){const C=I.map(u.NotebookCellOutputItem.to),E=this.a.find(r=>r.id===k);if(E&&(S||(E.items.length=0),E.items.push(...C),E.items.length>1&&E.items.every(r=>P.isTextStreamMime(r.mime)))){const r=new Map,d=[];E.items.forEach(f=>{let w;r.has(f.mime)?w=r.get(f.mime):(w=[],r.set(f.mime,w),d.push(f.mime)),w.push(f.data)}),E.items.length=0,d.forEach(f=>{const w=P.compressOutputItemStreams(r.get(f));E.items.push({mime:f,data:w.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(u.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=D;class g{constructor(k,S,I,C,E){this.k=k,this.l=S,this.m=I,this.uri=C,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=E.viewType,this.f=Object.freeze(E.metadata??Object.create(null)),this.r([[0,0,E.cells]],!0,void 0),this.g=E.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const k=this,S={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===c.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(I){return I=k.n(I),k.b[I].apiCell},getCells(I){return(I?k.p(I):k.b).map(E=>E.apiCell)},save(){return k.q()}};this.e=Object.freeze(S)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,S,I){this.g=k.versionId,this.h=S,this.acceptDocumentPropertiesChanged({metadata:I});const C={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},E=[];for(const d of k.rawEvents)d.kind===P.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,C.contentChanges):d.kind===P.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,C.contentChanges):d.kind===P.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),E.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),E.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),E.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===P.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),E.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),E.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const r=new Map;for(let d=0;d<E.length;d++){const f=E[d],w=r.get(f.cell);if(w===void 0){const y=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});r.set(f.cell,y-1)}else C.cellChanges[w]={...C.cellChanges[w],...f}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let S=k.start|0,I=k.end|0;return S<0&&(S=0),I>this.b.length&&(I=this.b.length),k.with({start:S,end:I})}p(k){k=this.o(k);const S=[];for(let I=k.start;I<k.end;I++)S.push(this.b[I]);return S}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,S,I){if(this.j)return;const C=[],E=[],r=[];if(k.reverse().forEach(d=>{const w=d[2].map(t=>{const o=new D(this,this.l,t);return S||E.push(D.asModelAddData(this.apiNotebook,t)),o}),y=new T(d[0],d[1],[],w),m=this.b.splice(d[0],d[1],...w);for(const t of m)r.push(t.uri),y.deletedItems.push(t.apiCell);C.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:r}),I)for(const d of C)I.push(d.asApiEvent())}s(k,S,I,C){const E=this.b.splice(k,S);this.b.splice(I,0,...E);const r=[new T(k,S,E.map(d=>d.apiCell),[]),new T(I,0,[],E)];for(const d of r)C.push(d.asApiEvent())}t(k,S){this.b[k].setOutputs(S)}u(k,S,I,C){this.b[k].setOutputItems(S,I,C)}v(k,S){const I=this.b[k];I.apiCell.document.languageId!==S&&this.m.$acceptModelLanguageChanged(I.uri,S)}w(k,S){const I=this.b[k];I.apiCell.mime=S}x(k,S){this.b[k].setMetadata(S)}y(k,S){this.b[k].setInternalMetadata(S)}getCellFromApiCell(k){return this.b.find(S=>S.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(S=>S.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}g.a=0,e.ExtHostNotebookDocument=g}),define(De[137],Ce([1,0,9,13,7]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(T,D,g,L,k,S){this.id=T,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=L,this.c=S}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(D){this.selections=[D]},get selections(){return T.a},set selections(D){if(!Array.isArray(D)||!D.every(u.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T.a=D,T.g(D)},get visibleRanges(){return T.b},revealRange(D,g){T.f.$tryRevealRange(T.id,A.NotebookRange.from(D),g??u.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(A.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(De[246],Ce([1,0,9,3,16,13]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(D,g){this.c=D,this.d=g,this.a=new A.Emitter({onListenerError:c.onUnexpectedExternalError}),this.b=new A.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const L=this.d.getEditorById(D);g.visibleRanges&&L._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&L._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(D[g]))}};P=Ve([We(0,u.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[247],Ce([1,0,13,126,183,21,62,9]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,I,C){const E=this.b++,{title:r,location:d,cancellable:f}=I,w={label:(0,u.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this.a.$startProgress(E,{location:c.ProgressLocation.from(d),title:r,source:w,cancellable:f},S.isUnderDevelopment?void 0:S.identifier.value).catch(T.onUnexpectedExternalError),this.d(E,C,!!f)}d(S,I,C){let E;C&&(E=new R.CancellationTokenSource,this.c.set(S,E));const r=f=>{this.a.$progressEnd(f),this.c.delete(f),E?.dispose()};let d;try{d=I(new L(this.a,S),C&&E?E.token:R.CancellationToken.None)}catch(f){throw r(S),f}return d.then(f=>r(S),f=>r(S)),d}$acceptProgressCanceled(S){const I=this.c.get(S);I&&(I.cancel(),this.c.delete(S))}}e.ExtHostProgress=D;function g(k,S){return k.message=S.message,typeof S.increment=="number"&&(typeof k.increment=="number"?k.increment+=S.increment:k.increment=S.increment),k}class L extends A.Progress{constructor(S,I){super(C=>this.throttledReport(C)),this.c=S,this.d=I}throttledReport(S){this.c.$progressReport(this.d,S)}}Ve([(0,P.throttle)(100,(k,S)=>g(k,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[138],Ce([1,0,32,133,57,95,76,13,2]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(w,y,m,t)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!m(o,s)){const a=o;o=s,w.listener?.(t(s,a))}}}},L=(w,y)=>w===y,k={range:(w,y)=>w===y?!0:!w||!y?!1:w.isEqual(y),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(w,y)=>!(w.length!==y.length||w.some(m=>!y.find(t=>m.id===t.id)))},S=w=>y=>({op:4,update:w(y)}),I=(w,y)=>({range:(()=>{let m;const t=S(o=>({range:c.Range.lift(T.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return m},set(o){w.listener?.({op:6}),k.range(m,o)||(m=o,w.listener?.(t(o)))}}})(),label:g(w,y,k.label,S(m=>({label:m}))),description:g(w,void 0,k.description,S(m=>({description:m}))),sortText:g(w,void 0,k.sortText,S(m=>({sortText:m}))),canResolveChildren:g(w,!1,k.canResolveChildren,m=>({op:2,state:m})),busy:g(w,!1,k.busy,S(m=>({busy:m}))),error:g(w,void 0,k.error,S(m=>({error:T.MarkdownString.fromStrict(m)||null}))),tags:g(w,[],k.tags,(m,t)=>({op:1,new:m.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),C=w=>{const y=u.TestId.fromString(w.extId),m=new r(y.controllerId,y.localId,w.label,D.URI.revive(w.uri)||void 0);return m.range=T.Range.to(w.range||void 0),m.description=w.description||void 0,m.sortText=w.sortText||void 0,m.tags=w.tags.map(t=>T.TestTag.to({id:(0,P.denamespaceTestTag)(t).tagId})),m},E=w=>{let y;for(const m of w.tests){const t=C(m.item);(0,A.getPrivateApiFor)(t).parent=y,y=t}return y};e.toItemFromContext=E;class r{constructor(y,m,t,o){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const s=(0,A.createPrivateApiFor)(this,y);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof d?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,A.getPrivateApiFor,r),enumerable:!0,writable:!1},...I(s,t)})}}e.TestItemImpl=r;class d extends r{constructor(y,m){super(y,y,m,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class f extends R.TestItemCollection{constructor(y,m,t){super({controllerId:y,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new d(y,m),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=f}),define(De[139],Ce([1,0,51,9,102,13,7]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(S,I,C){const E=T.c.nextId();S.$registerTextEditorDecorationType(I.identifier,E,R.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:E,dispose(){S.$removeTextEditorDecorationType(E)}})}}T.c=new u.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=T;class D{constructor(S,I){this.g=[],this.h=void 0,this.j=!1,this.c=S,this.d=S.version,this.e=I.undoStopBefore,this.f=I.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(S,I){this.k();let C=null;if(S instanceof P.Position)C=new P.Range(S,S);else if(S instanceof P.Range)C=S;else throw new Error("Unrecognized location");this.l(C,I,!1)}insert(S,I){this.k(),this.l(new P.Range(S,S),I,!0)}delete(S){this.k();let I=null;if(S instanceof P.Range)I=S;else throw new Error("Unrecognized location");this.l(I,null,!0)}l(S,I,C){const E=this.c.validateRange(S);this.g.push({range:E,text:I,forceMoveMarkers:C})}setEndOfLine(S){if(this.k(),S!==P.EndOfLine.LF&&S!==P.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=S}}class g{constructor(S,I,C,E){this.c=S,this.d=I,this._accept(C),this.e=E;const r=this;this.value={get tabSize(){return r.f},set tabSize(d){r.m(d)},get indentSize(){return r.g},set indentSize(d){r.o(d)},get insertSpaces(){return r.h},set insertSpaces(d){r.q(d)},get cursorStyle(){return r.j},set cursorStyle(d){r.s(d)},get lineNumbers(){return r.k},set lineNumbers(d){r.t(d)}}}_accept(S){this.f=S.tabSize,this.g=S.indentSize,this.h=S.insertSpaces,this.j=S.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(S.lineNumbers)}l(S){if(S==="auto")return"auto";if(typeof S=="number"){const I=Math.floor(S);return I>0?I:null}if(typeof S=="string"){const I=parseInt(S,10);return isNaN(I)?null:I>0?I:null}return null}m(S){const I=this.l(S);if(I!==null){if(typeof I=="number"){if(this.f===I)return;this.f=I}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:I}))}}n(S){if(S==="tabSize")return"tabSize";if(typeof S=="number"){const I=Math.floor(S);return I>0?I:null}if(typeof S=="string"){const I=parseInt(S,10);return isNaN(I)?null:I>0?I:null}return null}o(S){const I=this.n(S);if(I!==null){if(typeof I=="number"){if(this.g===I)return;this.g=I}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:I}))}}p(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}q(S){const I=this.p(S);if(typeof I=="boolean"){if(this.h===I)return;this.h=I}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:I}))}s(S){this.j!==S&&(this.j=S,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:S})))}t(S){this.k!==S&&(this.k=S,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(S)})))}assign(S){const I={};let C=!1;if(typeof S.tabSize<"u"){const E=this.l(S.tabSize);E==="auto"?(C=!0,I.tabSize=E):typeof E=="number"&&this.f!==E&&(this.f=E,C=!0,I.tabSize=E)}if(typeof S.indentSize<"u"){const E=this.n(S.indentSize);E==="tabSize"?(C=!0,I.indentSize=E):typeof E=="number"&&this.g!==E&&(this.g=E,C=!0,I.indentSize=E)}if(typeof S.insertSpaces<"u"){const E=this.p(S.insertSpaces);E==="auto"?(C=!0,I.insertSpaces=E):this.h!==E&&(this.h=E,C=!0,I.insertSpaces=E)}typeof S.cursorStyle<"u"&&this.j!==S.cursorStyle&&(this.j=S.cursorStyle,C=!0,I.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this.k!==S.lineNumbers&&(this.k=S.lineNumbers,C=!0,I.lineNumbers=R.TextEditorLineNumbersStyle.from(S.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,I))}u(S,I){I.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this.e.warn(C)})}}e.ExtHostTextEditorOptions=g;class L{constructor(S,I,C,E,r,d,f,w){this.id=S,this.j=I,this.k=C,this.g=!1,this.h=new Set,this.c=r,this.d=new g(this.j,this.id,d,C),this.e=f,this.f=w;const y=this;this.value=Object.freeze({get document(){return E.value},set document(m){throw(0,A.readonly)("document")},get selection(){return y.c&&y.c[0]},set selection(m){if(!(m instanceof P.Selection))throw(0,A.illegalArgument)("selection");y.c=[m],y.l()},get selections(){return y.c},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof P.Selection)))throw(0,A.illegalArgument)("selections");y.c=m,y.l()},get visibleRanges(){return y.e},set visibleRanges(m){throw(0,A.readonly)("visibleRanges")},get options(){return y.d.value},set options(m){y.g||y.d.assign(m)},get viewColumn(){return y.f},set viewColumn(m){throw(0,A.readonly)("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new D(E.value,t);return m(o),y.m(o)},insertSnippet(m,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=y.c.map(a=>R.Range.from(a));else if(t instanceof P.Position){const{lineNumber:a,column:l}=R.Position.from(t);s=[{startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l}]}else if(t instanceof P.Range)s=[R.Range.from(t)];else{s=[];for(const a of t)if(a instanceof P.Range)s.push(R.Range.from(a));else{const{lineNumber:l,column:v}=R.Position.from(a);s.push({startLineNumber:l,startColumn:v,endLineNumber:l,endColumn:v})}}return I.$tryInsertSnippet(S,E.value.version,m.value,s,o)},setDecorations(m,t){const o=t.length===0;o&&!y.h.has(m.key)||(o?y.h.delete(m.key):y.h.add(m.key),y.n(()=>{if(R.isDecorationOptionsArr(t))return I.$trySetDecorations(S,m.key,R.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let a=0,l=t.length;a<l;a++){const v=t[a];s[4*a]=v.start.line+1,s[4*a+1]=v.start.character+1,s[4*a+2]=v.end.line+1,s[4*a+3]=v.end.character+1}return I.$trySetDecorationsFast(S,m.key,s)}}))},revealRange(m,t){y.n(()=>I.$tryRevealRange(S,R.Range.from(m),t||P.TextEditorRevealType.Default))},show(m){I.$tryShowEditor(S,R.ViewColumn.from(m))},hide(){I.$tryHideEditor(S)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(S){(0,c.ok)(!this.g),this.d._accept(S)}_acceptVisibleRanges(S){(0,c.ok)(!this.g),this.e=S}_acceptViewColumn(S){(0,c.ok)(!this.g),this.f=S}_acceptSelections(S){(0,c.ok)(!this.g),this.c=S}async l(){const S=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,S)),this.value}m(S){const I=S.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const C=I.edits.map(r=>r.range);C.sort((r,d)=>r.end.line===d.end.line?r.end.character===d.end.character?r.start.line===d.start.line?r.start.character-d.start.character:r.start.line-d.start.line:r.end.character-d.end.character:r.end.line-d.end.line);for(let r=0,d=C.length-1;r<d;r++){const f=C[r].end;if(C[r+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=I.edits.map(r=>({range:R.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,I.documentVersionId,E,{setEndOfLine:typeof I.setEndOfLine=="number"?R.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}n(S){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this.k.warn(I),null))}}e.ExtHostTextEditor=L}),define(De[248],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[249],Ce([1,0,199,9,37,123,93,39,25,248,212,129]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=T.Registry.as(P.Extensions.JSONContribution);class I{constructor(m,t,o){this.a=m,this.b=t,this.c=o}d(m,t){this.a({type:m,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(m){this.d(u.default.Error,m)}warn(m){this.d(u.default.Warning,m)}info(m){this.d(u.default.Info,m)}}e.ExtensionMessageCollector=I;class C{static a(m){const t=new D.ExtensionIdentifierSet;for(let o=0,s=m.length;o<s;o++)t.add(m[o].description.identifier);return t}static compute(m,t){if(!m||!m.length)return new C(t,[]);if(!t||!t.length)return new C([],m);const o=this.a(m),s=this.a(t),a=t.filter(v=>!o.has(v.description.identifier)),l=m.filter(v=>!s.has(v.description.identifier));return new C(a,l)}constructor(m,t){this.added=m,this.removed=t}}e.ExtensionPointUserDelta=C;class E{constructor(m,t){this.name=m,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(m){if(this.a!==null)throw new Error("Handler already set!");this.a=m,this.d()}acceptUsers(m){this.c=C.compute(this.b,m),this.b=m,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(m){(0,A.onUnexpectedError)(m)}}}e.ExtensionPoint=E;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class f{constructor(){this.a=new Map}registerExtensionPoint(m){if(this.a.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const t=new E(m.extensionPoint,m.defaultExtensionKind);return this.a.set(m.extensionPoint,t),m.activationEventsGenerator&&k.ImplicitActivationEvents.register(m.extensionPoint,m.activationEventsGenerator),e.schema.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,S.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=f;const w={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(w.ExtensionsRegistry,new f),e.ExtensionsRegistry=T.Registry.as(w.ExtensionsRegistry),S.registerSchema(d,e.schema),S.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(De[250],Ce([1,0,196,10,23,249,44,3]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var g;(function(S){function I(C,E,r){if(!C)return;const d=A.isString(C.type)?C.type:void 0;if(!d||d.length===0){r.error(c.localize(3,null));return}const f=[];if(Array.isArray(C.required))for(const w of C.required)A.isString(w)&&f.push(w);return{extensionId:E.value,taskType:d,required:f,properties:C.properties?u.deepClone(C.properties):{},when:C.when?P.ContextKeyExpr.deserialize(C.when):void 0}}S.from=I})(g||(g={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((I,C)=>{L.setHandler((E,r)=>{this.c=void 0;try{for(const d of r.removed){const f=d.value;for(const w of f)this.a&&w.type&&this.a[w.type]&&delete this.a[w.type]}for(const d of r.added){const f=d.value;for(const w of f){const y=g.from(w,d.description.identifier,d.collector);y&&(this.a[y.taskType]=y)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}I(void 0)})})}onReady(){return this.b}get(I){return this.a[I]}all(){return Object.keys(this.a).map(I=>this.a[I])}getJsonSchema(){if(this.c===void 0){const I=[];for(const C of this.all()){const E={type:"object",additionalProperties:!1};C.required.length>0&&(E.required=C.required.slice(0)),C.properties!==void 0?E.properties=u.deepClone(C.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[C.taskType]},I.push(E)}this.c={oneOf:I}}return this.c}}e.TaskDefinitionRegistry=new k}),define(De[251],Ce([1,0,197,10,24,23,44,250]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new P.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var D;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(D=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(M){function B(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=B}(D=e.ShellQuoting||(e.ShellQuoting={}));var g;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(g=e.CommandOptions||(e.CommandOptions={}));var L;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(M){function B(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=B}(L=e.RevealKind||(e.RevealKind={}));var k;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(M){function B(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=B}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(M){function B(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=B}(S=e.PanelKind||(e.PanelKind={}));var I;(function(M){M.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var C;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(C=e.RuntimeType||(e.RuntimeType={})),function(M){function B(j){switch(j.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=B;function U(j){switch(j){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(C=e.RuntimeType||(e.RuntimeType={}));var E;(function(M){function B(U){return A.isString(U)?U:U.value}M.value=B})(E=e.CommandString||(e.CommandString={}));var r;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function B(j){return j===M.Clean._id||j===M.Build._id||j===M.Rebuild._id||j===M.Test._id}M.is=B;function U(j){if(j!==void 0)return A.isString(j)?B(j)?{_id:j,isDefault:!1}:void 0:j}M.from=U})(r=e.TaskGroup||(e.TaskGroup={}));var d;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var f;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function B(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=B})(f=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(M){M.parallel="parallel",M.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var y;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(y=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class t{constructor(B,U,j,he,ie,V){this._label="",this._id=B,U&&(this._label=U),j&&(this.type=j),this.runOptions=he,this.configurationProperties=ie,this._source=V}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,U=!1){if(B===void 0)return!1;if(A.isString(B))return B===this._label||B===this.configurationProperties.identifier||U&&B===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class o extends t{constructor(B,U,j,he,ie,V,J,ne){super(B,j,void 0,J,ne,U),this.command={},this._source=U,this.hasDefinedMatchers=V,ie&&(this.command=ie)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case C.Shell:U="shell";break;case C.Process:U="process";break;case C.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(B){return B instanceof o}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new o(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=o;class s extends t{constructor(B,U,j,he,ie,V,J){super(B,j,he,V,J,U),this._source=U,this.configures=ie}static is(B){return B instanceof s}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(j)}}e.ConfiguringTask=s;class a extends t{constructor(B,U,j,he,ie,V,J,ne,ve){super(B,j,he,ne,ve,U),this.defines=ie,this.hasDefinedMatchers=J,this.command=V,this.icon=ve.icon,this.hide=ve.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof a}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new a(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=a;class l extends t{constructor(B,U,j,he,ie,V){super(B,j,he,ie,V,U),this._source=U}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new l(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=l;var v;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(v=e.ExecutionEngine||(e.ExecutionEngine={})),function(M){M._default=M.Terminal}(v=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class n{constructor(B){this.c=new Map;for(let U=0;U<B.length;U++)this.c.set(B[U].uri.toString(),U)}compare(B,U){const j=B.getWorkspaceFolder(),he=U.getWorkspaceFolder();if(j&&he){let ie=this.c.get(j.uri.toString());ie=ie===void 0?0:ie+1;let V=this.c.get(he.uri.toString());return V=V===void 0?0:V+1,ie===V?B._label.localeCompare(U._label):ie-V}else return!j&&he?-1:j&&!he?1:0}}e.TaskSorter=n;var h;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var b;(function(M){M.SingleRun="singleRun",M.Background="background"})(b=e.TaskRunType||(e.TaskRunType={}));var p;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(p=e.TaskRunSource||(e.TaskRunSource={}));var O;(function(M){function B(U,j,he,ie){if(j){const V={kind:U,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:j};return U==="start"?V.resolvedVariables=ie:U==="processStarted"?V.processId=ie:U==="processEnded"&&(V.exitCode=ie),Object.freeze(V)}else return Object.freeze({kind:"changed"})}M.create=B})(O=e.TaskEvent||(e.TaskEvent={}));var W;(function(M){function B(j){const he=Object.keys(j).sort();let ie="";for(const V of he){let J=j[V];J instanceof Object?J=B(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ie+=V+","+J+","}return ie}function U(j){const ie={_key:B(j),type:j.taskType};return Object.assign(ie,j),ie}M.create=U})(W=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var Y;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(Y=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var x;(function(M){function B(U,j){const he=T.TaskDefinitionRegistry.get(U.type);if(he===void 0){const ne=R.deepClone(U);return delete ne._key,W.create(ne)}const ie=Object.create(null);ie.type=he.taskType;const V=new Set;he.required.forEach(ne=>V.add(ne));const J=he.properties;for(const ne of Object.keys(J)){const ve=U[ne];if(ve!=null)ie[ne]=ve;else if(V.has(ne)){const ue=J[ne];if(ue.default!==void 0)ie[ne]=R.deepClone(ue.default);else switch(ue.type){case"boolean":ie[ne]=!1;break;case"number":case"integer":ie[ne]=0;break;case"string":ie[ne]="";break;default:j.error(c.localize(2,null,JSON.stringify(U,void 0,0),ne));return}}}return W.create(ie)}M.createTaskIdentifier=B})(x=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[252],Ce([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,T)=>{this.b=P,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,c.onUnexpectedError)(P))}then(P,T){return this.j().then(P,T)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.LazyPromise=A;class u extends A{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=u}),define(De[58],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++c.count}}c.count=0,e.ProxyIdentifier=c;const A=[];function u(T){const D=new c(T);return A[D.nid]=D,D}e.createProxyIdentifier=u;function R(T){return A[T].sid}e.getStringIdentifierForProxy=R;class P{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=P}),define(De[5],Ce([1,0,58]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var u;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(u=e.TabInputKind||(e.TabInputKind={}));var R;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var g;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(g=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(r){return r._id=k.a++,r}}k.a=0,e.IdObject=k;var S;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var C;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,c.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,c.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,c.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,c.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(De[78],Ce([1,0,4,16,5,20]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(u.MainContext.MainThreadTelemetry)}report(D,g,L){const k=this.d(D,g);this.a.has(k)||(this.a.add(k),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};P=Ve([We(0,R.IExtHostRpcService),We(1,A.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(T,D,g){}})}),define(De[253],Ce([1,0,3,5,7,25]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(D){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=D.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(D){return this.c=D,Promise.resolve()}async getSession(D,g,L,k={}){const S=R.ExtensionIdentifier.toKey(D.identifier),I=this.f.get(S)||[],C=[...L].sort().join(" ");let E=I.find(r=>r.providerId===g&&r.scopes===C);if(E)return E.result;{const r=this.g(D,S,g,L,k);E={providerId:g,scopes:C,result:r},I.push(E),this.f.set(S,I);try{await r}finally{const d=I.findIndex(f=>f.providerId===g&&f.scopes===C);d>-1&&(I.splice(d),this.f.set(S,I))}return r}}async g(D,g,L,k,S={}){await this.a.$ensureProvider(L);const I=D.displayName||D.name;return this.a.$getSession(L,k,g,I,S)}async removeSession(D,g){const L=this.b.get(D);return L?L.provider.removeSession(g):this.a.$removeSession(D,g)}registerAuthenticationProvider(D,g,L,k){if(this.b.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this.b.set(D,{label:g,provider:L,options:k??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===D)||this.c.push({id:D,label:g});const S=L.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(D,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(D,g,k?.supportsMultipleAccounts??!1),new u.Disposable(()=>{S.dispose(),this.b.delete(D);const I=this.c.findIndex(C=>C.id===D);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(D)})}$createSession(D,g){const L=this.b.get(D);if(L)return Promise.resolve(L.provider.createSession(g));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,g){const L=this.b.get(D);if(L)return Promise.resolve(L.provider.removeSession(g));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,g){const L=this.b.get(D);if(L)return Promise.resolve(L.provider.getSessions(g));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,g){return this.d.fire({provider:{id:D,label:g}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(De[254],Ce([1,0,5,20,13]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(T,D){this.a=T.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,D,g){const L=u.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,g?.isRefactoring??!1)}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(De[255],Ce([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const P=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(T){return P.$writeText(T)}})}}e.ExtHostClipboard=A});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[40],Ce([1,0,10,7,13,23,5,17,16,70,32,53,2,6,4,20,138,22,58,46,43,74,77]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t){"use strict";var o,s,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(p,O,W){o.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),a.set(this,void 0),_e(this,o,p.getProxy(P.MainContext.MainThreadCommands),"f"),this.d=O,_e(this,a,W,"f"),_e(this,s,p.getProxy(P.MainContext.MainThreadTelemetry),"f"),this.converter=new v(this,q=>{const Y=this.c.get(q);return Y?.result===n.Void?Y:void 0},O),this.f=[{processArgument(q){return(0,g.revive)(q)}},{processArgument(q){return(0,R.cloneAndChange)(q,function(Y){if(L.Range.isIRange(Y))return u.Range.to(Y);if(k.Position.isIPosition(Y))return u.Position.to(Y);if(L.Range.isIRange(Y.range)&&S.URI.isUri(Y.uri))return u.location.to(Y);if(Y instanceof d.VSBuffer)return Y.buffer.buffer;if(!Array.isArray(Y))return Y})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const O=this.registerCommand(!1,p.id,async(...W)=>{const q=p.args.map((x,M)=>{if(!x.validate(W[M]))throw new Error(`Invalid argument '${x.name}' when running '${p.id}', received: ${W[M]}`);return x.convert(W[M])}),Y=await this.executeCommand(p.internalId,...q);return p.result.convert(Y,W,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new A.Disposable(()=>{O.dispose(),this.c.delete(p.id)})}registerCommand(p,O,W,q,Y,x){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:W,thisArg:q,description:Y,extension:x}),p&&Me(this,o,"f").$registerCommand(O),new A.Disposable(()=>{this.b.delete(O)&&p&&Me(this,o,"f").$unregisterCommand(O)})}executeCommand(p,...O){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,O,!0)}async g(p,O,W){if(this.b.has(p))return Me(this,o,"f").$fireCommandActivationEvent(p),this.h(p,O,!1);{let q=!1;const Y=(0,R.cloneAndChange)(O,function(x){if(x instanceof A.Position)return u.Position.from(x);if(x instanceof A.Range)return u.Range.from(x);if(x instanceof A.Location)return u.location.from(x);if(A.NotebookRange.isNotebookRange(x))return u.NotebookRange.from(x);if(x instanceof ArrayBuffer)return q=!0,d.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return q=!0,d.VSBuffer.wrap(x);if(x instanceof d.VSBuffer)return q=!0,x;if(!Array.isArray(x))return x});try{const x=await Me(this,o,"f").$executeCommand(p,q?new f.SerializableObjectWithBuffers(Y):Y,W);return(0,g.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(p,O,!1);throw x}}}async h(p,O,W){const q=this.b.get(p);if(!q)throw new Error("Unknown command");const{callback:Y,thisArg:x,description:M}=q;if(M)for(let U=0;U<M.args.length;U++)try{(0,c.validateConstraint)(O[U],M.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${M.args[U].name}' - ${M.args[U].description}`)}const B=y.StopWatch.create();try{return await Y.apply(x,O)}catch(U){if(p===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...O);j&&(p=j.command)}if(this.d.error(U,p,q.extension?.identifier),!W)throw U;if(q.extension?.identifier){const j=Me(this,a,"f").onExtensionError(q.extension.identifier,U);this.d.trace("forwarded error to extension?",j,q.extension?.identifier)}throw new class extends Error{constructor(){super((0,w.toErrorMessage)(U)),this.id=p,this.source=q.extension?.displayName??q.extension?.name}}}finally{this.j(q,p,B.elapsed())}}j(p,O,W){!p.extension||Me(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new m.TelemetryTrustedValue(O),duration:W})}$executeContributedCommand(p,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const W=this.b.get(p);return W?(O=O.map(q=>this.f.reduce((Y,x)=>x.processArgument(Y,W.extension?.identifier),q)),this.h(p,O,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),Me(this,o,"f").$getCommands().then(O=>(p&&(O=O.filter(W=>W[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(const[O,W]of this.b){const{description:q}=W;q&&(p[O]=q)}return Promise.resolve(p)}};o=new WeakMap,s=new WeakMap,a=new WeakMap,l=Ve([We(0,E.IExtHostRpcService),We(1,D.ILogService),We(2,t.IExtHostTelemetry)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class v{constructor(p,O,W){this.d=p,this.f=O,this.g=W,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,O){if(!p)return;const W={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return W;const q=this.f(p.command);if(q)W.id=q.internalId,W.arguments=q.args.map((Y,x)=>Y.convert(p.arguments&&p.arguments[x]));else if((0,T.isNonEmptyArray)(p.arguments)){const Y=`${p.command}/${++this.c}`;this.b.set(Y,p),O.add((0,I.toDisposable)(()=>{this.b.delete(Y),this.g.trace("CommandsConverter#DISPOSE",Y)})),W.$ident=Y,W.id=this.delegatingCommandId,W.arguments=[Y],this.g.trace("CommandsConverter#CREATE",p.command,Y)}return W}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const O=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.CommandsConverter=v;class i{constructor(p,O,W,q){this.name=p,this.description=O,this.validate=W,this.convert=q}optional(){return new i(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,O){return new i(p??this.name,O??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",b=>S.URI.isUri(b),b=>b),i.Position=new i("position","A position in a text document",b=>A.Position.isPosition(b),u.Position.from),i.Range=new i("range","A range in a text document",b=>A.Range.isRange(b),u.Range.from),i.Selection=new i("selection","A selection in a text document",b=>A.Selection.isSelection(b),u.Selection.from),i.Number=new i("number","",b=>typeof b=="number",b=>b),i.String=new i("string","",b=>typeof b=="string",b=>b),i.CallHierarchyItem=new i("item","A call hierarchy item",b=>b instanceof A.CallHierarchyItem,u.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",b=>b instanceof A.TypeHierarchyItem,u.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",b=>b instanceof r.TestItemImpl,u.TestItem.from),e.ApiCommandArgument=i;class n{constructor(p,O){this.description=p,this.convert=O}}n.Void=new n("no result",b=>b),e.ApiCommandResult=n;class h{constructor(p,O,W,q,Y){this.id=p,this.internalId=O,this.description=W,this.args=q,this.result=Y}}e.ApiCommand=h}),define(De[256],Ce([1,0,17,18,2,72,121,44,125,40,13,7]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new g.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(L.DocumentHighlight.to))),new g.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,d)=>{if((0,c.isFalsyOrEmpty)(r))return;class f extends k.SymbolInformation{static to(y){const m=new f(y.name,L.SymbolKind.to(y.kind),y.containerName||"",new k.Location(d[0],L.Range.to(y.range)));return m.detail=y.detail,m.range=m.location.range,m.selectionRange=L.Range.to(y.selectionRange),m.children=y.children?y.children.map(f.to):[],m}}return r.map(f.to)})),new g.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range,new g.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,new g.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new g.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(L.TextEdit.to))),new g.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new g.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(L.location.to))),new g.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(L.Hover.to))),new g.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(d=>k.Position.isPosition(d)),r=>r.map(L.Position.from))],new g.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(d=>{let f;for(const w of d.reverse())f=new k.SelectionRange(L.Range.to(w),f);return f}))),new g.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.ApiCommandArgument.String.with("query","Search string")],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(L.WorkspaceSymbol.to))),new g.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(L.CallHierarchyItem.to))),new g.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(L.CallHierarchyIncomingCall.to))),new g.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(L.CallHierarchyOutgoingCall.to))),new g.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(!!r)return{range:L.Range.to(r.range),placeholder:r.text}})),new g.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("newName","The new symbol name")],new g.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return L.WorkspaceEdit.to(r)}})),new g.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(L.DocumentLink.to))),new g.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new k.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,P.decodeSemanticTokensDto)(r);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range.optional()],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new k.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,P.decodeSemanticTokensDto)(r);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new g.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,d,f)=>{if(!r)return new k.CompletionList([]);const w=r.suggestions.map(y=>L.CompletionItem.to(y,f));return new k.CompletionList(w,r.incomplete)})),new g.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return L.SignatureHelp.to(r)})),new g.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,d,f)=>C(w=>new k.CodeLens(L.Range.to(w.range),w.command&&f.fromInternal(w.command)))(r))),new g.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>k.Range.isRange(r),r=>k.Selection.isSelection(r)?L.Selection.from(r):L.Range.from(r)),g.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,d,f)=>C(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(w.command)}else{const y=new k.CodeAction(w.title,w.kind?new k.CodeActionKind(w.kind):void 0);return w.edit&&(y.edit=L.WorkspaceEdit.to(w.edit)),w.command&&(y.command=f.fromInternal(w.command)),y.isPreferred=w.isPreferred,y}})(r))),new g.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(d=>new k.ColorInformation(L.Range.to(d.range),L.Color.to(d.color))):[])),new g.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.ApiCommandArgument("color","The color to show and insert",r=>r instanceof k.Color,L.Color.from),new g.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:L.Range.from(r.range)}))],new g.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(L.ColorPresentation.to):[])),new g.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,d,f)=>r.map(L.InlayHint.to.bind(void 0,f)))),new g.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,d)=>{if(r)return r.map(L.FoldingRange.to)})),new g.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(d=>L.NotebookExclusiveDocumentPattern.to(d))})))),new g.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(L.InlineValue.to))),new g.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>u.URI.isUri(r)||typeof r=="string"&&(0,D.matchesSomeScheme)(r,A.Schemas.http,A.Schemas.https),r=>r),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[L.ViewColumn.from(r),void 0]:[L.ViewColumn.from(r.viewColumn),L.TextEditorOpenOptions.from(r)])).optional(),g.ApiCommandArgument.String.with("label","").optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.ApiCommandArgument.Uri.with("resource","Resource to open"),g.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[L.ViewColumn.from(r),void 0]:[L.ViewColumn.from(r.viewColumn),L.TextEditorOpenOptions.from(r)])).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),g.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),g.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[L.ViewColumn.from(r.viewColumn),L.TextEditorOpenOptions.from(r)]).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(L.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(L.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(L.TypeHierarchyItem.to))),new g.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.ApiCommandArgument.TestItem],g.ApiCommandResult.Void),new g.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.ApiCommandResult.Void),new g.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.ApiCommandArgument.String.with("name","The context key name"),new g.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],g.ApiCommandResult.Void)];class I{static register(d){S.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",T.validateWhenClauses)}}e.ExtHostApiCommands=I;function C(r){return d=>{if(Array.isArray(d))return d.map(r)}}function E(r){if(!Array.isArray(r))return;const d=[];for(const f of r)R.isLocationLink(f)?d.push(L.DefinitionLink.to(f)):d.push(L.location.to(f));return d}}),define(De[257],Ce([1,0,19,62,3,6,2,72,25,13,7,5]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(I,C,E){const r=I.getProxy(k.MainContext.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new D.ExtensionIdentifierMap,C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const v=this.b.get(l.handle);return v?v.value:l}else if(l&&l.$mid===7){const v=this.b.get(l.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.commentThreadHandle);return i?i.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.thread.commentThreadHandle);return i?l.$mid===8?i.value:{thread:i.value,text:l.text}:l}else if(l&&l.$mid===10){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const n=l.commentUniqueId,h=i.getCommentByUniqueId(n);return h||l}else if(l&&l.$mid===11){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const i=v.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const n=l.text,h=l.commentUniqueId,b=i.getCommentByUniqueId(h);return b?(typeof b.body=="string"?b.body=n:b.body=new L.MarkdownString(n),b):l}return l}})}createCommentController(l,v,i){const n=d.a++,h=new w(l,n,v,i);this.b.set(h.handle,h);const b=this.c.get(l.identifier)||[];return b.push(h),this.c.set(l.identifier,b),h.value}$createCommentThreadTemplate(l,v,i){const n=this.b.get(l);!n||n.$createCommentThreadTemplate(v,i)}async $updateCommentThreadTemplate(l,v,i){const n=this.b.get(l);!n||n.$updateCommentThreadTemplate(v,i)}$deleteCommentThread(l,v){this.b.get(l)?.$deleteCommentThread(v)}$provideCommentingRanges(l,v,i){const n=this.b.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const h=E.getDocument(P.URI.revive(v));return(0,c.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(h,i)).then(b=>b?b.map(p=>g.Range.from(p)):void 0)}$toggleReaction(l,v,i,n,h){const b=this.b.get(l);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const p=b.getCommentThread(v);if(p){const O=p.getCommentByUniqueId(n.uniqueIdInThread);if(b!==void 0&&O&&b.reactionHandler)return b.reactionHandler(O,t(h))}return Promise.resolve(void 0)})}dispose(){}}d.a=0;class f{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,v,i,n,h,b,p,O){this.m=v,this.n=i,this.o=n,this.p=h,this.q=b,this.extensionDescription=p,this.r=O,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new u.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),r.$createCommentThread(v,this.handle,this.n,this.o,g.Range.from(this.p),p.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{r.$deleteCommentThread(v,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(q){W.range=q},get comments(){return W.comments},set comments(q){W.comments=q},get collapsibleState(){return W.collapsibleState},set collapsibleState(q){W.collapsibleState=q},get canReply(){return W.canReply},set canReply(q){W.canReply=q},get contextValue(){return W.contextValue},set contextValue(q){W.contextValue=q},get label(){return W.label},set label(q){W.label=q},get state(){return W.state},set state(q){W.state=q},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const l=i=>Object.prototype.hasOwnProperty.call(this.b,i),v={};l("range")&&(v.range=g.Range.from(this.p)),l("label")&&(v.label=this.label),l("contextValue")&&(v.contextValue=this.contextValue??null),l("comments")&&(v.comments=this.q.map(i=>y(this,i,this.k))),l("collapsibleState")&&(v.collapseState=o(this.g)),l("canReply")&&(v.canReply=this.canReply),l("state")&&(v.state=s(this.h)),l("isTemplate")&&(v.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(l){for(const v of this.k){const i=v[0],n=v[1];if(l===n)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}f.a=0,Ve([(0,A.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class w{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,v,i,n){this.f=l,this.g=v,this.h=i,this.i=n,this.a=new Map,r.$registerCommentController(this.handle,i,n);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(b){h.options=b},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(b){h.commentingRangeProvider=b},get reactionHandler(){return h.reactionHandler},set reactionHandler(b){h.reactionHandler=b},createCommentThread(b,p,O){return h.createCommentThread(b,p,O).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(l,v,i,n){if(typeof l=="string"){const h=new f(this.id,this.handle,l,v,i,n,this.f,!1);return this.a.set(h.handle,h),h}else{const h=new f(this.id,this.handle,void 0,l,v,i,this.f,!1);return this.a.set(h.handle,h),h}}$createCommentThreadTemplate(l,v){const i=new f(this.id,this.handle,void 0,P.URI.revive(l),g.Range.to(v),[],this.f,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(l,v){const i=this.a.get(l);i&&(i.range=g.Range.to(v))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function y(a,l,v){let i=v.get(l);i||(i=++a.commentHandle,v.set(l,i));const n=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:typeof l.body=="string"?l.body:g.MarkdownString.from(l.body),userName:l.author.name,userIconPath:n,label:l.label,commentReactions:l.reactions?l.reactions.map(h=>m(h)):void 0,timestamp:l.timestamp?.toJSON()}}function m(a){return{label:a.label,iconPath:a.iconPath?g.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function t(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?P.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case L.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function s(a){if(a!==void 0)switch(a){case L.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new d}e.createExtHostComments=S}),define(De[258],Ce([1,0,23,5,26,20]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let P=class{constructor(L,k){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,k){const S=this,I=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){S.e(L,k,I,arguments)}})}e(L,k,S,I){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(I,this.b)}),this.c&&this.f(L,S,I)}};P=Ve([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],P),e.AbstractExtHostConsoleForwarder=P;const T=1e5;function D(g,L){const k=[];if(g.length)for(let S=0;S<g.length;S++){let I=g[S];if(typeof I>"u")I="undefined";else if(I instanceof Error){const C=I;C.stack?I=C.stack:I=C.toString()}k.push(I)}if(L){const S=new Error().stack;S&&k.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,c.safeStringify)(k);return S.length>T?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[140],Ce([1,0,2,5,7,4,20,16,17,8,12,27]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class Bi{constructor(C,E){this.h=E,this.f=new Map,this.g=C.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,E){const r=Bi.c++;this.f.set(r,{provider:C,extensionDescription:E}),this.g.$registerDecorationProvider(r,E.identifier.value);const d=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(f=>{if(!f){this.g.$onDidChange(r,null);return}const w=(0,D.asArray)(f);if(w.length<=Bi.d){this.g.$onDidChange(r,w);return}this.h.warn("[Decorations] CAPPING events from decorations provider",E.identifier.value,w.length);const y=w.map(o=>({uri:o,rank:(0,g.count)(o.path,"/")})),m=(0,D.groupBy)(y,(o,s)=>o.rank-s.rank||(0,g.compare)(o.uri.path,s.uri.path)),t=[];e:for(const o of m){let s;for(const a of o){const l=(0,L.dirname)(a.uri.path);if(s!==l&&(s=l,t.push(a.uri)>=Bi.d))break e}}this.g.$onDidChange(r,t)});return new u.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(C,E,r){if(!this.f.has(C))return Object.create(null);const d=Object.create(null),{provider:f,extensionDescription:w}=this.f.get(C);return await Promise.all(E.map(async y=>{try{const{uri:m,id:t}=y,o=await Promise.resolve(f.provideFileDecoration(c.URI.revive(m),r));if(!o)return;try{u.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,k.checkProposedApiEnabled)(w,"codiconDecoration"),d[t]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${w}': ${s}`)}}catch(m){this.h.error(m)}})),d}};S.c=0,S.d=250,S=Ve([We(0,P.IExtHostRpcService),We(1,T.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[259],Ce([1,0,180,124,2,5,7,13,3,16,28,49]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";var S,I,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{constructor(f,w,y,m,t,o,s){this.d=f,this.e=w,this.f=y,this.g=m,S.set(this,void 0),I.set(this,void 0),C.set(this,void 0),this.c=!1,_e(this,C,new L.ResourceMap(a=>t.getComparisonKey(a)),"f"),_e(this,S,o,"f"),_e(this,I,s,"f")}dispose(){this.c||(Me(this,I,"f").fire([...Me(this,C,"f").keys()]),Me(this,S,"f")?.$clear(this.e),Me(this,C,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(f,w){if(!f){this.clear();return}this.h();let y=[];if(u.URI.isUri(f)){if(!w){this.delete(f);return}Me(this,C,"f").set(f,w.slice()),y=[f]}else if(Array.isArray(f)){y=[];let t;f=[...f].sort(E.j);for(const o of f){const[s,a]=o;if((!t||s.toString()!==t.toString())&&(t&&Me(this,C,"f").get(t).length===0&&Me(this,C,"f").delete(t),t=s,y.push(s),Me(this,C,"f").set(s,[])),a)Me(this,C,"f").get(s)?.push(...a);else{const l=Me(this,C,"f").get(s);l&&(l.length=0)}}}if(Me(this,I,"f").fire(y),!Me(this,S,"f"))return;const m=[];for(const t of y){let o=[];const s=Me(this,C,"f").get(t);if(s)if(s.length>this.f){o=[];const a=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const v of s)if(v.severity===a[l]&&o.push({...T.Diagnostic.from(v),modelVersionId:this.g(t)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(a=>({...T.Diagnostic.from(a),modelVersionId:this.g(t)}));m.push([t,o])}Me(this,S,"f").$changeMany(this.e,m)}delete(f){this.h(),Me(this,I,"f").fire([f]),Me(this,C,"f").delete(f),Me(this,S,"f")?.$changeMany(this.e,[[f,void 0]])}clear(){this.h(),Me(this,I,"f").fire([...Me(this,C,"f").keys()]),Me(this,C,"f").clear(),Me(this,S,"f")?.$clear(this.e)}forEach(f,w){this.h();for(const[y,m]of this)f.call(w,y,m,this)}*[(S=new WeakMap,I=new WeakMap,C=new WeakMap,Symbol.iterator)](){this.h();for(const f of Me(this,C,"f").keys())yield[f,this.get(f)]}get(f){this.h();const w=Me(this,C,"f").get(f);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(f){return this.h(),Array.isArray(Me(this,C,"f").get(f))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(f,w){return f[0].toString()<w[0].toString()?-1:f[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=E;let r=class Si{static _mapper(f){const w=new L.ResourceMap;for(const y of f)w.set(y,y);return{uris:Object.freeze(Array.from(w.values()))}}constructor(f,w,y,m){this.h=w,this.j=y,this.k=m,this.f=new Map,this.g=new D.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.g.event,Si._mapper),this.e=f.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,w){const{f:y,e:m,g:t,h:o,j:s,k:a}=this,l=new class{$changeMany(n,h){m.$changeMany(n,h),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,n,h.length===0?"CLEARING":h)}$clear(n){m.$clear(n),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,n)}dispose(){m.dispose()}};let v;if(!w)w="_generated_diagnostic_collection_name_#"+Si.c++,v=w;else if(!y.has(w))v=w;else{this.h.warn(`DiagnosticCollection with name '${w}' does already exist.`);do v=w+Si.c++;while(y.has(v))}return new class extends E{constructor(){super(w,v,Si.d,n=>a.getDocument(n)?.version,s.extUri,l,t),y.set(v,this)}dispose(){super.dispose(),y.delete(v)}}}getDiagnostics(f){if(f)return this.l(f);{const w=new Map,y=[];for(const m of this.f.values())m.forEach((t,o)=>{let s=w.get(t.toString());typeof s>"u"&&(s=y.length,w.set(t.toString(),s),y.push([t,[]])),y[s][1]=y[s][1].concat(...o)});return y}}l(f){let w=[];for(const y of this.f.values())y.has(f)&&(w=w.concat(y.get(f)));return w}$acceptMarkersChange(f){if(!this.m){const w="_generated_mirror",y=new E(w,w,Si.d,m=>{},this.j.extUri,void 0,this.g);this.f.set(w,y),this.m=y}for(const[w,y]of f)this.m.set(u.URI.revive(w),y.map(T.Diagnostic.to))}};r.c=0,r.d=1e3,r=Ve([We(1,g.ILogService),We(2,k.IExtHostFileSystemInfo)],r),e.ExtHostDiagnostics=r}),define(De[260],Ce([1,0,2,5,27]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(T){this.a=T.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(T,D){return D?.allowUIResources&&(0,u.checkProposedApiEnabled)(T,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(L=>c.URI.revive(L)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(D=>D?c.URI.revive(D):void 0)}}e.ExtHostDialogs=R}),define(De[261],Ce([1,0,9,2,7,5,18,21,8]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class g{constructor(k,S,I){this.d=S,this.e=I,this.b=new Map,this.c=k.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,S){if(Object.keys(P.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const I=g.a++;this.b.set(I,S),this.c.$registerTextContentProvider(I,k);let C;return typeof S.onDidChange=="function"&&(C=S.onDidChange(E=>{if(E.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this.d.getDocument(E)&&this.$provideTextDocumentContent(I,E).then(r=>{if(!r&&typeof r!="string")return;const d=this.d.getDocument(E);if(!d)return;const f=(0,D.splitLines)(r);if(!d.equalLines(f))return this.c.$onVirtualDocumentChange(E,r)},c.onUnexpectedError)})),new u.Disposable(()=>{this.b.delete(I)&&this.c.$unregisterTextContentProvider(I),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(k,S){const I=this.b.get(k);return I?Promise.resolve(I.provideTextDocumentContent(A.URI.revive(S),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}g.a=0,e.ExtHostDocumentContentProvider=g}),define(De[262],Ce([1,0,3,6,2,5,136,13,10,23,7]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(I,C){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=I.getProxy(R.MainContext.MainThreadDocuments),this.g=C,this.g.onDidRemoveDocuments(E=>{for(const r of E)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(E=>{for(const r of E)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(I){if(!I)return;const C=this.g.getDocument(I);if(C)return C}getDocument(I){const C=this.getDocumentData(I);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return C.document}ensureDocumentData(I){const C=this.g.getDocument(I);if(C)return Promise.resolve(C);let E=this.h.get(I.toString());return E||(E=this.f.$tryOpenDocument(I).then(r=>{this.h.delete(I.toString());const d=u.URI.revive(r);return(0,D.assertIsDefined)(this.g.getDocument(d))},r=>(this.h.delete(I.toString()),Promise.reject(r))),this.h.set(I.toString(),E)),E}createDocumentData(I){return this.f.$tryCreateDocument(I).then(C=>u.URI.revive(C))}$acceptModelLanguageChanged(I,C){const E=u.URI.revive(I),r=this.g.getDocument(E);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(C),this.a.fire(r.document)}$acceptModelSaved(I){const C=u.URI.revive(I),E=this.g.getDocument(C);if(!E)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this.d.fire(E.document)}$acceptDirtyStateChanged(I,C){const E=u.URI.revive(I),r=this.g.getDocument(E);if(!r)throw new Error("unknown document");r._acceptIsDirty(C),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,C,E){const r=u.URI.revive(I),d=this.g.getDocument(r);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),d.onEvents(C);let f;C.isUndoing?f=L.TextDocumentChangeReason.Undo:C.isRedoing&&(f=L.TextDocumentChangeReason.Redo),this.c.fire((0,g.deepFreeze)({document:d.document,contentChanges:C.changes.map(w=>({range:T.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:f}))}setWordDefinitionFor(I,C){(0,P.setWordDefinitionFor)(I,C)}}e.ExtHostDocuments=k}),define(De[59],Ce([1,0,51,3,6,2,4,5,136,20,139,13,16,28,18,64,65]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(y,m){this.h=y,this.i=m,this.a=null,this.b=new Map,this.c=new I.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const m=[],t=[],o=[];if(y.removedDocuments)for(const s of y.removedDocuments){const a=R.URI.revive(s),l=this.c.get(a);l?.unref()&&(this.c.delete(a),m.push(l.value))}if(y.addedDocuments)for(const s of y.addedDocuments){const a=R.URI.revive(s.uri);let l=this.c.get(a);if(l&&a.scheme!==C.Schemas.vscodeNotebookCell&&a.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);l||(l=new d(new D.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),a,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(a,l),t.push(l.value)),l.ref()}if(y.removedEditors)for(const s of y.removedEditors){const a=this.b.get(s);this.b.delete(s),a&&o.push(a)}if(y.addedEditors)for(const s of y.addedEditors){const a=R.URI.revive(s.documentUri);c.ok(this.c.has(a),`document '${a}' does not exist`),c.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const l=this.c.get(a).value,v=new L.ExtHostTextEditor(s.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new r.Lazy(()=>l.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(i=>k.Range.to(i)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,v)}y.newActiveEditor!==void 0&&(c.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,u.dispose)(m),(0,u.dispose)(o),y.removedDocuments&&this.e.fire(m),y.addedDocuments&&this.d.fire(t),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return E.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const m=this.b.get(this.a);return y?m:m?.value}allEditors(){return[...this.b.values()]}};f=Ve([We(0,g.IExtHostRpcService),We(1,S.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[60],Ce([1,0,13,5,2,3,4,7,20,10,61]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");class k{constructor(r,d,f){this.e=f,this.d=d,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,d={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(u.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(u.URI.revive(this.b.input.base),u.URI.revive(this.b.input.input1),u.URI.revive(this.b.input.input2),u.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(u.URI.revive(this.b.input.uri),u.URI.revive(this.b.input.inputBoxUri));default:return}}}class S{constructor(r,d){this.c=[],this.d="",this.b=r,this.e=d;for(const f of r.tabs)f.isActive&&(this.d=f.id),this.c.push(new k(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,d={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return c.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(f=>f.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(f=>f.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const f=new k(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,f),r.tabDto.isActive&&(this.d=f.tabId),f}else if(r.kind===1){const f=this.c.splice(r.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(r.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,f),f}const d=this.c.find(f=>f.tabId===r.tabDto.id);if(!d)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(r.tabDto),d}activeTabId(){return this.d}}let I=class{constructor(r){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=r.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,d={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(f=>f.apiObject))},get activeTabGroup(){const f=r.d;return(0,g.assertIsDefined)(r.e.find(y=>y.groupId===f)?.apiObject)},close:async(f,w)=>{const y=Array.isArray(f)?f:[f];return y.length?C(y[0])?this.j(y,w):this.i(y,w):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(r){const d=new Set(this.e.map(s=>s.groupId)),f=new Set(r.map(s=>s.groupId)),w=(0,L.diffSets)(d,f),y=this.e.filter(s=>w.removed.includes(s.groupId)).map(s=>s.apiObject),m=[],t=[];this.e=r.map(s=>{const a=new S(s,()=>this.d);return w.added.includes(a.groupId)?m.push(a.apiObject):t.push(a.apiObject),a});const o=(0,g.assertIsDefined)(r.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:m,closed:y,changed:t}))}$acceptTabGroupUpdate(r){const d=this.e.find(f=>f.groupId===r.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const d=this.e.find(w=>w.groupId===r.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const f=d.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(r){for(const d of this.e)for(const f of d.tabs)if(f.apiObject===r)return f}h(r){return this.e.find(d=>d.apiObject===r)}async i(r,d){const f=[];for(const w of r){const y=this.g(w);if(!y)throw new Error("Tab close: Invalid tab not found!");f.push(y.tabId)}return this.a.$closeTab(f,d)}async j(r,d){const f=[];for(const w of r){const y=this.h(w);if(!y)throw new Error("Group close: Invalid group not found!");f.push(y.groupId)}return this.a.$closeGroup(f,d)}};I=Ve([We(0,D.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function C(E){return E.tabs!==void 0}}),define(De[263],Ce([1,0,2,5,6,7,13,155,8,22,27]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this.a=[]}add(C){this.b=void 0,this.a.push(C)}delete(C){const E=this.a.indexOf(C);E>=0&&(this.a.splice(E,1),this.b=void 0)}c(){if(!this.b){const C=this.a.sort(),E=[];let r,d,f=14,w=14;for(const y of C){let m=r?(0,D.commonPrefixLength)(r,y):0;for(m===0?d=1:d=w;m<y.length;m++)m+1===y.length?(f=w,w=9):w+=1,E.push([d,y.toUpperCase().charCodeAt(m),w]),E.push([d,y.toLowerCase().charCodeAt(m),w]),d=w;r=y,w=f}E.push([9,58,10]),E.push([10,47,12]),this.b=new T.StateMachine(E)}}provideDocumentLinks(C){this.c();const E=[],r=T.LinkComputer.computeLinks({getLineContent(d){return C.lineAt(d-1).text},getLineCount(){return C.lineCount}},this.b);for(const d of r){const f=P.DocumentLink.to(d);f.target&&E.push(f)}return E}}class S{constructor(C,E){this.i=E,this.b=new k,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=C.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(C,E,r,d={}){if(S.j(r),this.d.has(E))throw new Error(`a provider for the scheme '${E}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(C,"*",this.b));const f=this.h++;this.b.add(E),this.d.add(E),this.c.set(f,r);let w=2;d.isCaseSensitive&&(w+=1024),d.isReadonly&&(w+=2048),typeof r.copy=="function"&&(w+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,L.checkProposedApiEnabled)(C,"fsChunks"),w+=4),this.a.$registerFileSystemProvider(f,E,w).catch(m=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${E}`),console.error(m)});const y=r.onDidChangeFile(m=>{const t=[];for(const o of m){const{uri:s,type:a}=o;if(s.scheme!==E)continue;let l;switch(a){case R.FileChangeType.Changed:l=0;break;case R.FileChangeType.Created:l=1;break;case R.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:l})}this.a.$onFileSystemChange(f,t)});return(0,u.toDisposable)(()=>{y.dispose(),this.b.delete(E),this.d.delete(E),this.c.delete(f),this.a.$unregisterProvider(f)})}static j(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static k(C){const{type:E,ctime:r,mtime:d,size:f,permissions:w}=C;return{type:E,ctime:r,mtime:d,size:f,permissions:w}}$stat(C,E){return Promise.resolve(this.l(C).stat(c.URI.revive(E))).then(r=>S.k(r))}$readdir(C,E){return Promise.resolve(this.l(C).readDirectory(c.URI.revive(E)))}$readFile(C,E){return Promise.resolve(this.l(C).readFile(c.URI.revive(E))).then(r=>g.VSBuffer.wrap(r))}$writeFile(C,E,r,d){return Promise.resolve(this.l(C).writeFile(c.URI.revive(E),r.buffer,d))}$delete(C,E,r){return Promise.resolve(this.l(C).delete(c.URI.revive(E),r))}$rename(C,E,r,d){return Promise.resolve(this.l(C).rename(c.URI.revive(E),c.URI.revive(r),d))}$copy(C,E,r,d){const f=this.l(C);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(c.URI.revive(E),c.URI.revive(r),d))}$mkdir(C,E){return Promise.resolve(this.l(C).createDirectory(c.URI.revive(E)))}$watch(C,E,r,d){const f=this.l(C).watch(c.URI.revive(r),d);this.f.set(E,f)}$unwatch(C,E){const r=this.f.get(E);r&&(r.dispose(),this.f.delete(E))}$open(C,E,r){const d=this.l(C);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(c.URI.revive(E),r))}$close(C,E){const r=this.l(C);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(E))}$read(C,E,r,d){const f=this.l(C);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const w=g.VSBuffer.alloc(d);return Promise.resolve(f.read(E,r,w.buffer,0,d)).then(y=>w.slice(0,y))}$write(C,E,r,d){const f=this.l(C);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(E,r,d.buffer,0,d.byteLength))}l(C){const E=this.c.get(C);if(!E){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return E}}e.ExtHostFileSystem=S}),define(De[79],Ce([1,0,5,45,7,22,4,20,49,6]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class _t{constructor(S,I){this.b=new Map,this.a=S.getProxy(c.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(E){try{const r=C.b.get(E.scheme);if(!r)return await C.a.$stat(E);await C.a.$ensureActivation(E.scheme);const d=await r.stat(E);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(r){_t.c(r)}},async readDirectory(E){try{const r=C.b.get(E.scheme);return r?(await C.a.$ensureActivation(E.scheme),(await r.readDirectory(E)).slice()):await C.a.$readdir(E)}catch(r){return _t.c(r)}},async createDirectory(E){try{return await C.a.$mkdir(E)}catch(r){return _t.c(r)}},async readFile(E){try{const r=C.b.get(E.scheme);return r?(await C.a.$ensureActivation(E.scheme),(await r.readFile(E)).slice()):(await C.a.$readFile(E)).buffer}catch(r){return _t.c(r)}},async writeFile(E,r){try{return await C.a.$writeFile(E,R.VSBuffer.wrap(r))}catch(d){return _t.c(d)}},async delete(E,r){try{const d=C.b.get(E.scheme);return d?(await C.a.$ensureActivation(E.scheme),await d.delete(E,{recursive:!1,...r})):await C.a.$delete(E,{recursive:!1,useTrash:!1,...r})}catch(d){return _t.c(d)}},async rename(E,r,d){try{return await C.a.$rename(E,r,{overwrite:!1,...d})}catch(f){return _t.c(f)}},async copy(E,r,d){try{return await C.a.$copy(E,r,{overwrite:!1,...d})}catch(f){return _t.c(f)}},isWritableFileSystem(E){const r=I.getCapabilities(E);if(typeof r=="number")return!(r&2048)}})}static c(S){if(S instanceof u.FileSystemError)throw S;if(!(S instanceof Error))throw new u.FileSystemError(String(S));if(S.name==="ENOPRO"||S.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(S.message);switch(S.name){case A.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(S.message);case A.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(S.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(S.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(S.message);case A.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(S.message);case A.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(S.message);default:throw new u.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,I){return this.b.set(S,I),(0,g.toDisposable)(()=>this.b.delete(S))}};L=Ve([We(0,T.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(De[264],Ce([1,0,3,38,2,5,13,7]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(k,S,I,C,E,r,d,f){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const w=this.h(k,I,E);this.g=0,r&&(this.g+=1),d&&(this.g+=2),f&&(this.g+=4);const y=(0,A.parse)(E),m=typeof E=="string",t=C(o=>{if(!r)for(const s of o.created){const a=u.URI.revive(s);y(a.fsPath)&&(!m||S.getWorkspaceFolder(a))&&this.a.fire(a)}if(!d)for(const s of o.changed){const a=u.URI.revive(s);y(a.fsPath)&&(!m||S.getWorkspaceFolder(a))&&this.b.fire(a)}if(!f)for(const s of o.deleted){const a=u.URI.revive(s);y(a.fsPath)&&(!m||S.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=T.Disposable.from(w,this.a,this.b,this.c,t)}h(k,S,I){const C=T.Disposable.from();if(typeof I=="string")return C;const E=k.getProxy(R.MainContext.MainThreadFileSystem);let r=!1;(I.pattern.includes(A.GLOBSTAR)||I.pattern.includes(A.GLOB_SPLIT))&&(r=!0);const d=Math.random();return E.$watch(S.identifier.value,d,I.baseUri,{recursive:r,excludes:[]}),T.Disposable.from({dispose:()=>E.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(k,S,I){this.j=k,this.k=S,this.l=I,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,S,I,C,E,r){return new D(this.j,k,S,this.a.event,P.GlobPattern.from(I),C,E,r)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,S){switch(k){case 2:this.b.fire(Object.freeze({files:S.map(I=>({oldUri:u.URI.revive(I.source),newUri:u.URI.revive(I.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(I=>u.URI.revive(I.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(I=>u.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,S){return(I,C,E)=>{const r=function(f){I.call(C,f)};return r.extension=k,S.event(r,void 0,E)}}async $onWillRunFileOperation(k,S,I,C){switch(k){case 2:return await this.n(this.g,{files:S.map(E=>({oldUri:u.URI.revive(E.source),newUri:u.URI.revive(E.target)}))},I,C);case 1:return await this.n(this.i,{files:S.map(E=>u.URI.revive(E.target))},I,C);case 0:case 3:return await this.n(this.h,{files:S.map(E=>u.URI.revive(E.target))},I,C)}}async n(k,S,I,C){const E=new Set,r=[];if(await k.fireAsync(S,C,async(f,w)=>{const y=Date.now(),m=await Promise.resolve(f);m instanceof T.WorkspaceEdit&&(r.push([w.extension,m]),E.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-y>I&&this.k.warn("SLOW file-participant",w.extension.identifier)}),C.isCancellationRequested||r.length===0)return;const d={edits:[]};for(const[,f]of r){const{edits:w}=P.WorkspaceEdit.from(f,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(w)}return{edit:d,extensionNames:Array.from(E)}}}e.ExtHostFileSystemEventService=g}),define(De[265],Ce([1,0,2,40]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(P,T,D,g,L){this.a=T,this.b=D,this.c=g;const k=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new A.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new A.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new A.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new A.ApiCommandResult("Notebook and input URI",S=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const I=this.a.getEditorById(S.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:c.URI.revive(S.notebookUri),inputUri:c.URI.revive(S.inputUri),notebookEditor:I.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:c.URI.revive(S.notebookUri),inputUri:c.URI.revive(S.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(P,T,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:D,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=u}),define(De[266],Ce([1,0,6,2,5,13]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(g,L){this.extension=g,this.provider=L,this.handle=P.a++}}P.a=0;class T{constructor(g,L,k){this.e=L,this.f=k,this.b=new Map,this.c=new Map,this.d=g.getProxy(u.MainContext.MainThreadInteractiveEditor)}registerProvider(g,L){const k=new P(g,L);return this.b.set(k.handle,k),this.d.$registerInteractiveEditorProvider(k.handle,g.identifier.value),(0,c.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(k.handle),this.b.delete(k.handle)})}async $prepareInteractiveSession(g,L,k,S){const I=this.b.get(g);if(!I){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const C=this.e.getDocument(A.URI.revive(L)),E=await I.provider.prepareInteractiveEditorSession({document:C,selection:R.Selection.to(k)},S);if(!E)return;const r=T.a++;return this.c.set(r,E),{id:r,placeholder:E.placeholder}}async $provideResponse(g,L,k,S){const I=this.b.get(g);if(!I)return;const C=this.c.get(L.id);if(!C)return;const E=await I.provider.provideInteractiveEditorResponse({session:C,prompt:k.prompt,selection:R.Selection.to(k.selection),wholeRange:R.Range.to(k.wholeRange)},S);if(!!E)return{edits:E.edits.map(R.TextEdit.from),placeholder:E.placeholder}}$releaseSession(g,L){const k=this.c.get(L),S=this.b.get(g);k&&S&&S.provider.releaseInteractiveEditorSession?.(k),this.c.delete(L)}}T.a=0,e.ExtHostInteractiveEditor=T}),define(De[267],Ce([1,0,6,10,5]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class R{constructor(D,g){this.extension=D,this.provider=g,this.handle=R.a++}}R.a=0;class P{constructor(D,g){this.b=new Map,this.c=new Map,this.d=D.getProxy(u.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(D,g,L){const k=new R(D,L);return this.b.set(k.handle,k),this.d.$registerInteractiveSessionProvider(k.handle,g),(0,c.toDisposable)(()=>{this.d.$unregisterInteractiveSessionProvider(k.handle),this.b.delete(k.handle)})}addInteractiveSessionRequest(D){this.d.$addInteractiveSessionRequest(D)}async $prepareInteractiveSession(D,g,L){const k=this.b.get(D);if(!k)return;const S=await k.provider.prepareSession(g,L);if(!S)return;const I=P.a++;return this.c.set(I,S),{id:I}}async $resolveInteractiveRequest(D,g,L,k){const S=this.b.get(D);if(!S)return;const I=this.c.get(g);if(!I||!S.provider.resolveRequest)return;const C=await S.provider.resolveRequest(I,L,k);if(C)return{message:C.message}}async $provideInitialSuggestions(D,g){const L=this.b.get(D);if(!!L&&!!L.provider.provideInitialSuggestions)return(0,A.withNullAsUndefined)(await L.provider.provideInitialSuggestions(g))}async $provideInteractiveReply(D,g,L,k){const S=this.b.get(D);if(!S)return;const I=this.c.get(g);if(!I)return;const C={session:I,message:L.message};if(S.provider.provideResponse){const E=await S.provider.provideResponse(C,k);if(I.saveState){const r=I.saveState();this.d.$acceptInteractiveSessionState(g,r)}return E?(this.d.$acceptInteractiveResponseProgress(D,g,{responsePart:E.content}),{followups:E.followups}):void 0}else if(S.provider.provideResponseWithProgress){const E={report:d=>this.d.$acceptInteractiveResponseProgress(D,g,{responsePart:d.content})},r=await S.provider.provideResponseWithProgress(C,E,k);if(I.saveState){const d=I.saveState();this.d.$acceptInteractiveSessionState(g,d)}return r?{followups:r.followups}:void 0}throw new Error("provider must implement either provideResponse or provideResponseWithProgress")}$releaseSession(D){this.c.delete(D)}}P.a=0,e.ExtHostInteractiveSession=P}),define(De[268],Ce([1,0,6,5]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(P){this.b=0,this.a=P.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,P),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=u}),define(De[269],Ce([1,0,2,23,13,7,72,5,8,32,17,10,151,21,6,121,102,75,43,9,19,27]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(F,z){this.d=F,this.e=z}async provideDocumentSymbols(F,z){const G=this.d.getDocument(F),_=await this.e.provideDocumentSymbols(G,z);if(!(0,L.isFalsyOrEmpty)(_))return _[0]instanceof R.DocumentSymbol?_.map(u.DocumentSymbol.from):t.f(_)}static f(F){F=F.slice(0).sort((_,fe)=>{let Ee=_.location.range.start.compareTo(fe.location.range.start);return Ee===0&&(Ee=fe.location.range.end.compareTo(_.location.range.end)),Ee});const z=[],G=[];for(const _ of F){const fe={name:_.name||"!!MISSING: name!!",kind:u.SymbolKind.from(_.kind),tags:_.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:u.Range.from(_.location.range),selectionRange:u.Range.from(_.location.range),children:[]};for(;;){if(G.length===0){G.push(fe),z.push(fe);break}const Ee=G[G.length-1];if(g.Range.containsRange(Ee.range,fe.range)&&!g.Range.equalsRange(Ee.range,fe.range)){Ee.children?.push(fe),G.push(fe);break}G.pop()}}return z}}class o{constructor(F,z,G){this.g=F,this.h=z,this.j=G,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(F,z){const G=this.g.getDocument(F),_=await this.j.provideCodeLenses(G,z);if(!_||z.isCancellationRequested)return;const fe=this.e.add(_),Ee=new C.DisposableStore;this.f.set(fe,Ee);const Ae={cacheId:fe,lenses:[]};for(let we=0;we<_.length;we++)Ae.lenses.push({cacheId:[fe,we],range:u.Range.from(_[we].range),command:this.h.toInternal(_[we].command,Ee)});return Ae}async resolveCodeLens(F,z){const G=F.cacheId&&this.e.get(...F.cacheId);if(!G)return;let _;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?_=G:_=await this.j.resolveCodeLens(G,z),_||(_=G),z.isCancellationRequested)return;const fe=F.cacheId&&this.f.get(F.cacheId[0]);if(!!fe)return F.command=this.h.toInternal(_.command??o.d,fe),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(oe){return Array.isArray(oe)?oe.map(u.DefinitionLink.from):oe?[u.DefinitionLink.from(oe)]:[]}class a{constructor(F,z){this.d=F,this.e=z}async provideDefinition(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideDefinition(_,fe,G);return s(Ee)}}class l{constructor(F,z){this.d=F,this.e=z}async provideDeclaration(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideDeclaration(_,fe,G);return s(Ee)}}class v{constructor(F,z){this.d=F,this.e=z}async provideImplementation(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideImplementation(_,fe,G);return s(Ee)}}class i{constructor(F,z){this.d=F,this.e=z}async provideTypeDefinition(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideTypeDefinition(_,fe,G);return s(Ee)}}class n{constructor(F,z){this.d=F,this.e=z}async provideHover(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideHover(_,fe,G);if(!(!Ee||(0,L.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=_.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new R.Range(fe,fe)),u.Hover.from(Ee)}}class h{constructor(F,z){this.d=F,this.e=z}async provideEvaluatableExpression(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideEvaluatableExpression(_,fe,G);if(Ee)return u.EvaluatableExpression.from(Ee)}}class b{constructor(F,z){this.d=F,this.e=z}async provideInlineValues(F,z,G,_){const fe=this.d.getDocument(F),Ee=await this.e.provideInlineValues(fe,u.Range.to(z),u.InlineValueContext.to(G),_);if(Array.isArray(Ee))return Ee.map(Ae=>u.InlineValue.from(Ae))}}class p{constructor(F,z){this.d=F,this.e=z}async provideDocumentHighlights(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideDocumentHighlights(_,fe,G);if(Array.isArray(Ee))return Ee.map(u.DocumentHighlight.from)}}class O{constructor(F,z){this.d=F,this.e=z}async provideLinkedEditingRanges(F,z,G){const _=this.d.getDocument(F),fe=u.Position.to(z),Ee=await this.e.provideLinkedEditingRanges(_,fe,G);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,L.coalesce)(Ee.ranges.map(u.Range.from)),wordPattern:Ee.wordPattern}}}class W{constructor(F,z){this.d=F,this.e=z}async provideReferences(F,z,G,_){const fe=this.d.getDocument(F),Ee=u.Position.to(z),Ae=await this.e.provideReferences(fe,Ee,G,_);if(Array.isArray(Ae))return Ae.map(u.location.from)}}class q{constructor(F,z,G,_,fe,Ee,Ae){this.g=F,this.h=z,this.j=G,this.k=_,this.l=fe,this.m=Ee,this.n=Ae,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(F,z,G,_){const fe=this.g.getDocument(F),Ee=S.Selection.isISelection(z)?u.Selection.to(z):u.Range.to(z),Ae=[];for(const tt of this.j.getDiagnostics(F))if(Ee.intersection(tt.range)&&Ae.push(tt)>q.d)break;const we={diagnostics:Ae,only:G.only?new R.CodeActionKind(G.only):void 0,triggerKind:u.CodeActionTriggerKind.to(G.trigger)},Pe=await this.k.provideCodeActions(fe,Ee,we,_);if(!(0,L.isNonEmptyArray)(Pe)||_.isCancellationRequested)return;const Ie=this.e.add(Pe),ze=new C.DisposableStore;this.f.set(Ie,ze);const qe=[];for(let tt=0;tt<Pe.length;tt++){const Qe=Pe[tt];!Qe||(q.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,ze)})):(we.only&&(Qe.kind?we.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Ie,tt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,ze),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(u.Diagnostic.from),edit:Qe.edit&&u.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Ie,actions:qe}}async resolveCodeAction(F,z){const[G,_]=F,fe=this.e.get(G,_);if(!fe||q.o(fe)||!this.k.resolveCodeAction)return;const Ee=await this.k.resolveCodeAction(fe,z)??fe;return Ee?.edit?u.WorkspaceEdit.from(Ee.edit,void 0):void 0}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}q.d=1e3;class Y{constructor(F,z,G,_){this.d=F,this.e=z,this.f=G,this.g=_}async prepareDocumentPaste(F,z,G,_){if(!this.f.prepareDocumentPaste)return;const fe=this.e.getDocument(F),Ee=z.map(we=>u.Range.to(we)),Ae=u.DataTransfer.toDataTransfer(G,()=>{throw new w.NotImplementedError});return await this.f.prepareDocumentPaste(fe,Ee,Ae,_),u.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(F,z,G,_,fe){const Ee=this.e.getDocument(z),Ae=G.map(Ie=>u.Range.to(Ie)),we=u.DataTransfer.toDataTransfer(_,async Ie=>(await this.d.$resolvePasteFileData(this.g,F,Ie)).buffer),Pe=await this.f.provideDocumentPasteEdits(Ee,Ae,we,fe);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?u.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class x{constructor(F,z){this.d=F,this.e=z}async provideDocumentFormattingEdits(F,z,G){const _=this.d.getDocument(F),fe=await this.e.provideDocumentFormattingEdits(_,z,G);if(Array.isArray(fe))return fe.map(u.TextEdit.from)}}class M{constructor(F,z){this.d=F,this.e=z}async provideDocumentRangeFormattingEdits(F,z,G,_){const fe=this.d.getDocument(F),Ee=u.Range.to(z),Ae=await this.e.provideDocumentRangeFormattingEdits(fe,Ee,G,_);if(Array.isArray(Ae))return Ae.map(u.TextEdit.from)}}class B{constructor(F,z){this.d=F,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,z,G,_,fe){const Ee=this.d.getDocument(F),Ae=u.Position.to(z),we=await this.e.provideOnTypeFormattingEdits(Ee,Ae,G,_,fe);if(Array.isArray(we))return we.map(u.TextEdit.from)}}class U{constructor(F,z){this.e=F,this.f=z,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,z){const G=await this.e.provideWorkspaceSymbols(F,z);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const _=this.d.add(G),fe={cacheId:_,symbols:[]};for(let Ee=0;Ee<G.length;Ee++){const Ae=G[Ee];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}fe.symbols.push({...u.WorkspaceSymbol.from(Ae),cacheId:[_,Ee]})}return fe}async resolveWorkspaceSymbol(F,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this.d.get(...F.cacheId);if(G){const _=await this.e.resolveWorkspaceSymbol(G,z);return _&&(0,A.mixin)(F,u.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class j{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,z,G){this.d=F,this.e=z,this.f=G}async provideRenameEdits(F,z,G,_){const fe=this.d.getDocument(F),Ee=u.Position.to(z);try{const Ae=await this.e.provideRenameEdits(fe,Ee,G,_);return Ae?u.WorkspaceEdit.from(Ae):void 0}catch(Ae){const we=j.g(Ae);return we?{rejectReason:we,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(F,z,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(F),fe=u.Position.to(z);try{const Ee=await this.e.prepareRename(_,fe,G);let Ae,we;if(R.Range.isRange(Ee)?(Ae=Ee,we=_.getText(Ee)):(0,k.isObject)(Ee)&&(Ae=Ee.range,we=Ee.placeholder),!Ae||!we)return;if(Ae.start.line>fe.line||Ae.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(Ae),text:we}}catch(Ee){const Ae=j.g(Ee);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(Ee)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class he{constructor(F,z){this.resultId=F,this.tokens=z}}class ie{constructor(F,z){this.f=F,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,z,G){const _=this.f.getDocument(F),fe=z!==0?this.d.get(z):null;let Ee=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,fe.resultId,G):await this.g.provideDocumentSemanticTokens(_,G);return fe&&this.d.delete(z),Ee?(Ee=ie.h(Ee),this.o(ie.n(fe,Ee),Ee)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ie.j(F)?ie.k(F)?F:new R.SemanticTokens(new Uint32Array(F.data),F.resultId):ie.l(F)?ie.m(F)?F:new R.SemanticTokensEdits(F.edits.map(z=>new R.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const z of F.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(F,z){if(!ie.j(z)||!F||!F.tokens)return z;const G=F.tokens,_=G.length,fe=z.data,Ee=fe.length;let Ae=0;const we=Math.min(_,Ee);for(;Ae<we&&G[Ae]===fe[Ae];)Ae++;if(Ae===_&&Ae===Ee)return new R.SemanticTokensEdits([],z.resultId);let Pe=0;const Ie=we-Ae;for(;Pe<Ie&&G[_-Pe-1]===fe[Ee-Pe-1];)Pe++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:_-Ae-Pe,data:fe.subarray(Ae,Ee-Pe)}],z.resultId)}o(F,z){if(ie.j(F)){const G=this.e++;return this.d.set(G,new he(F.resultId,F.data)),(0,E.encodeSemanticTokensDto)({id:G,type:"full",data:F.data})}if(ie.l(F)){const G=this.e++;return ie.j(z)?this.d.set(G,new he(z.resultId,z.data)):this.d.set(G,new he(F.resultId)),(0,E.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(F.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class V{constructor(F,z){this.d=F,this.e=z}async provideDocumentRangeSemanticTokens(F,z,G){const _=this.d.getDocument(F),fe=await this.e.provideDocumentRangeSemanticTokens(_,u.Range.to(z),G);return fe?this.f(fe):null}f(F){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}class J{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,z,G,_,fe){this.f=F,this.g=z,this.h=G,this.j=_,this.k=fe,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(F,z,G,_){const fe=this.f.getDocument(F),Ee=u.Position.to(z),Ae=fe.getWordRangeAtPosition(Ee)||new R.Range(Ee,Ee),we=Ae.with({end:Ee}),Pe=new f.StopWatch(!0),Ie=await this.h.provideCompletionItems(fe,Ee,_,u.CompletionContext.to(G));if(!Ie||_.isCancellationRequested)return;const ze=Array.isArray(Ie)?new R.CompletionList(Ie):Ie,qe=J.supportsResolving(this.h)?this.d.add(ze.items):this.d.add([]),tt=new C.DisposableStore;this.e.set(qe,tt);const Qe=[],it={x:qe,b:Qe,a:{replace:u.Range.from(Ae),insert:u.Range.from(we)},c:ze.isIncomplete||void 0,d:Pe.elapsed()};for(let rt=0;rt<ze.items.length;rt++){const Be=ze.items[rt],et=this.l(Be,[qe,rt],we,Ae);Qe.push(et)}return it}async resolveCompletionItem(F,z){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...F);if(!G)return;const _=await this.h.resolveCompletionItem(G,z);if(!!_)return this.l(_,F)}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,z,G,_){const fe=this.e.get(z[0]);if(!fe)throw Error("DisposableStore is missing...");const Ee=this.g.toInternal(F.command,fe),Ae={x:z,a:F.label,b:F.kind!==void 0?u.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(u.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:u.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(u.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=F.textEdit.newText):typeof F.insertText=="string"?Ae.h=F.insertText:F.insertText instanceof R.SnippetString&&(Ae.h=F.insertText.value,Ae.i|=4);let we;return F.textEdit?we=F.textEdit.range:F.range&&(we=F.range),R.Range.isRange(we)?Ae.j=u.Range.from(we):we&&(!G?.isEqual(we.inserting)||!_?.isEqual(we.replacing))&&(Ae.j={insert:u.Range.from(we.inserting),replace:u.Range.from(we.replacing)}),Ae}}class ne{async provideInlineCompletions(F,z,G,_){}disposeCompletions(F){}handleDidShowCompletionItem(F,z){}handlePartialAccept(F,z,G){}}class ve extends ne{constructor(F,z,G,_){super(),this.f=F,this.g=z,this.h=G,this.j=_,this.d=new ue,this.e=(0,m.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,m.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,z,G,_){const fe=this.g.getDocument(F),Ee=u.Position.to(z),Ae=await this.h.provideInlineCompletionItems(fe,Ee,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:u.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},_);if(!Ae||_.isCancellationRequested)return;const we=Array.isArray(Ae)?Ae:Ae.items,Pe=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Ie;return{pid:this.d.createReferenceId({dispose(){Ie?.dispose()},items:we}),items:we.map((qe,tt)=>{let Qe;qe.command&&(Ie||(Ie=new C.DisposableStore),Qe=this.j.toInternal(qe.command,Ie));const it=qe.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:qe.filterText,range:qe.range?u.Range.from(qe.range):void 0,command:Qe,idx:tt,completeBracketPairs:this.e?qe.completeBracketPairs:!1}}),commands:Pe.map(qe=>(Ie||(Ie=new C.DisposableStore),this.j.toInternal(qe,Ie)))}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,z){const G=this.d.get(F)?.items[z];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G)}handlePartialAccept(F,z,G){const _=this.d.get(F)?.items[z];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(_,G)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const z=this.e++;return this.d.set(z,F),z}disposeReferenceId(F){const z=this.d.get(F);return this.d.delete(F),z}get(F){return this.d.get(F)}}class ee{constructor(F,z){this.e=F,this.f=z,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(F,z,G,_){const fe=this.e.getDocument(F),Ee=u.Position.to(z),Ae=this.g(G),we=await this.f.provideSignatureHelp(fe,Ee,_,Ae);if(we){const Pe=this.d.add([we]);return{...u.SignatureHelp.from(we),id:Pe}}}g(F){let z;if(F.activeSignatureHelp){const G=u.SignatureHelp.to(F.activeSignatureHelp),_=this.d.get(F.activeSignatureHelp.id,0);_?(z=_,z.activeSignature=G.activeSignature,z.activeParameter=G.activeParameter):z=G}return{...F,activeSignatureHelp:z}}releaseSignatureHelp(F){this.d.delete(F)}}class N{constructor(F,z,G,_,fe){this.f=F,this.g=z,this.h=G,this.j=_,this.k=fe,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(F,z,G){const _=this.f.getDocument(F),fe=u.Range.to(z),Ee=await this.h.provideInlayHints(_,fe,G);if(!Array.isArray(Ee)||Ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(G.isCancellationRequested)return;const Ae=this.d.add(Ee);this.e.set(Ae,new C.DisposableStore);const we={hints:[],cacheId:Ae};for(let Pe=0;Pe<Ee.length;Pe++)this.l(Ee[Pe],fe)&&we.hints.push(this.m(Ee[Pe],[Ae,Pe]));return this.j.trace(`[InlayHints] ${we.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),we}async resolveInlayHint(F,z){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...F);if(!G)return;const _=await this.h.resolveInlayHint(G,z);if(!!_&&!!this.l(_))return this.m(_,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,z){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(z&&!z.contains(F.position))}m(F,z){const G=this.e.get(z[0]);if(!G)throw Error("DisposableStore is missing...");const _={label:"",cacheId:z,tooltip:u.MarkdownString.fromStrict(F.tooltip),position:u.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(u.TextEdit.from),kind:F.kind&&u.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?_.label=F.label:_.label=F.label.map(fe=>{const Ee={label:fe.value};return Ee.tooltip=u.MarkdownString.fromStrict(fe.tooltip),R.Location.isLocation(fe.location)&&(Ee.location=u.location.from(fe.location)),fe.command&&(Ee.command=this.g.toInternal(fe.command,G)),Ee}),_}}class K{constructor(F,z){this.e=F,this.f=z,this.d=new d.Cache("DocumentLink")}async provideLinks(F,z){const G=this.e.getDocument(F),_=await this.f.provideDocumentLinks(G,z);if(!(!Array.isArray(_)||_.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(K.g).map(u.DocumentLink.from)};{const fe=this.d.add(_),Ee={links:[],cacheId:fe};for(let Ae=0;Ae<_.length;Ae++){if(!K.g(_[Ae]))continue;const we=u.DocumentLink.from(_[Ae]);we.cacheId=[fe,Ae],Ee.links.push(we)}return Ee}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,z){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...F);if(!G)return;const _=await this.f.resolveDocumentLink(G,z);if(!(!_||!K.g(_)))return u.DocumentLink.from(_)}releaseLinks(F){this.d.delete(F)}}class le{constructor(F,z){this.d=F,this.e=z}async provideColors(F,z){const G=this.d.getDocument(F),_=await this.e.provideDocumentColors(G,z);return Array.isArray(_)?_.map(Ee=>({color:u.Color.from(Ee.color),range:u.Range.from(Ee.range)})):[]}async provideColorPresentations(F,z,G){const _=this.d.getDocument(F),fe=u.Range.to(z.range),Ee=u.Color.to(z.color),Ae=await this.e.provideColorPresentations(Ee,{document:_,range:fe},G);if(!!Array.isArray(Ae))return Ae.map(u.ColorPresentation.from)}}class me{constructor(F,z){this.d=F,this.e=z}async provideFoldingRanges(F,z,G){const _=this.d.getDocument(F),fe=await this.e.provideFoldingRanges(_,z,G);if(!!Array.isArray(fe))return fe.map(u.FoldingRange.from)}}class ke{constructor(F,z,G){this.d=F,this.e=z,this.f=G}async provideSelectionRanges(F,z,G){const _=this.d.getDocument(F),fe=z.map(u.Position.to),Ee=await this.e.provideSelectionRanges(_,fe,G);if(!(0,L.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let we=0;we<fe.length;we++){const Pe=[];Ae.push(Pe);let Ie=fe[we],ze=Ee[we];for(;;){if(!ze.range.contains(Ie))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(u.SelectionRange.from(ze)),!ze.parent)break;Ie=ze.range,ze=ze.parent}}return Ae}}class Z{constructor(F,z){this.f=F,this.g=z,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(F,z,G){const _=this.f.getDocument(F),fe=u.Position.to(z),Ee=await this.g.prepareCallHierarchy(_,fe,G);if(!Ee)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(Ee)?Ee.map(we=>this.h(Ae,we)):[this.h(Ae,Ee)]}async provideCallsTo(F,z,G){const _=this.j(F,z);if(!_)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(_,G);if(!!fe)return fe.map(Ee=>({from:this.h(F,Ee.from),fromRanges:Ee.fromRanges.map(Ae=>u.Range.from(Ae))}))}async provideCallsFrom(F,z,G){const _=this.j(F,z);if(!_)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(_,G);if(!!fe)return fe.map(Ee=>({to:this.h(F,Ee.to),fromRanges:Ee.fromRanges.map(Ae=>u.Range.from(Ae))}))}releaseSession(F){this.e.delete(F)}h(F,z){const G=this.e.get(F),_=u.CallHierarchyItem.from(z,F,G.size.toString(36));return G.set(_._itemId,z),_}j(F,z){return this.e.get(F)?.get(z)}}class ce{constructor(F,z){this.f=F,this.g=z,this.d=new r.IdGenerator(""),this.e=new Map}async prepareSession(F,z,G){const _=this.f.getDocument(F),fe=u.Position.to(z),Ee=await this.g.prepareTypeHierarchy(_,fe,G);if(!Ee)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(Ee)?Ee.map(we=>this.h(Ae,we)):[this.h(Ae,Ee)]}async provideSupertypes(F,z,G){const _=this.j(F,z);if(!_)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(_,G);if(!!fe)return fe.map(Ee=>this.h(F,Ee))}async provideSubtypes(F,z,G){const _=this.j(F,z);if(!_)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(_,G);if(!!fe)return fe.map(Ee=>this.h(F,Ee))}releaseSession(F){this.e.delete(F)}h(F,z){const G=this.e.get(F),_=u.TypeHierarchyItem.from(z,F,G.size.toString(36));return G.set(_._itemId,z),_}j(F,z){return this.e.get(F)?.get(z)}}class de{constructor(F,z,G,_){this.d=F,this.e=z,this.f=G,this.g=_}async provideDocumentOnDropEdits(F,z,G,_,fe){const Ee=this.e.getDocument(z),Ae=u.Position.to(G),we=u.DataTransfer.toDataTransfer(_,async Ie=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ie)).buffer),Pe=await this.f.provideDocumentDropEdits(Ee,Ae,we,fe);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?u.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class te{constructor(F,z){this.adapter=F,this.extension=z}}class ae{constructor(F,z,G,_,fe,Ee,Ae,we){this.g=z,this.h=G,this.j=_,this.k=fe,this.l=Ee,this.m=Ae,this.n=we,this.f=new Map,this.e=F.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(F){return u.DocumentSelector.from(F,this.g)}p(F){return new R.Disposable(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ae.d++}async s(F,z,G,_,fe,Ee=!1){const Ae=this.f.get(F);if(!Ae||!(Ae.adapter instanceof z))return _;const we=Date.now();Ee||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Pe=G(Ae.adapter,Ae.extension);return Promise.resolve(Pe).catch(Ie=>{(0,w.isCancellationError)(Ie)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Ie),this.n.onExtensionError(Ae.extension.identifier,Ie))}).finally(()=>{Ee||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-we}ms`)}),I.CancellationToken.isCancellationToken(fe)?(0,y.raceCancellationError)(Pe,fe):Pe}t(F,z){const G=this.q();return this.f.set(G,new te(F,z)),G}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,z,G,_){const fe=this.t(new t(this.h,G),F),Ee=_&&_.label||ae.u(F);return this.e.$registerDocumentSymbolProvider(fe,this.o(z),Ee),this.p(fe)}$provideDocumentSymbols(F,z,G){return this.s(F,t,_=>_.provideDocumentSymbols(c.URI.revive(z),G),void 0,G)}registerCodeLensProvider(F,z,G){const _=this.q(),fe=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new te(new o(this.h,this.j.converter,G),F)),this.e.$registerCodeLensSupport(_,this.o(z),fe);let Ee=this.p(_);if(fe!==void 0){const Ae=G.onDidChangeCodeLenses(we=>this.e.$emitCodeLensEvent(fe));Ee=R.Disposable.from(Ee,Ae)}return Ee}$provideCodeLenses(F,z,G){return this.s(F,o,_=>_.provideCodeLenses(c.URI.revive(z),G),void 0,G)}$resolveCodeLens(F,z,G){return this.s(F,o,_=>_.resolveCodeLens(z,G),void 0,void 0)}$releaseCodeLenses(F,z){this.s(F,o,G=>Promise.resolve(G.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(F,z,G){const _=this.t(new a(this.h,G),F);return this.e.$registerDefinitionSupport(_,this.o(z)),this.p(_)}$provideDefinition(F,z,G,_){return this.s(F,a,fe=>fe.provideDefinition(c.URI.revive(z),G,_),[],_)}registerDeclarationProvider(F,z,G){const _=this.t(new l(this.h,G),F);return this.e.$registerDeclarationSupport(_,this.o(z)),this.p(_)}$provideDeclaration(F,z,G,_){return this.s(F,l,fe=>fe.provideDeclaration(c.URI.revive(z),G,_),[],_)}registerImplementationProvider(F,z,G){const _=this.t(new v(this.h,G),F);return this.e.$registerImplementationSupport(_,this.o(z)),this.p(_)}$provideImplementation(F,z,G,_){return this.s(F,v,fe=>fe.provideImplementation(c.URI.revive(z),G,_),[],_)}registerTypeDefinitionProvider(F,z,G){const _=this.t(new i(this.h,G),F);return this.e.$registerTypeDefinitionSupport(_,this.o(z)),this.p(_)}$provideTypeDefinition(F,z,G,_){return this.s(F,i,fe=>fe.provideTypeDefinition(c.URI.revive(z),G,_),[],_)}registerHoverProvider(F,z,G,_){const fe=this.t(new n(this.h,G),F);return this.e.$registerHoverProvider(fe,this.o(z)),this.p(fe)}$provideHover(F,z,G,_){return this.s(F,n,fe=>fe.provideHover(c.URI.revive(z),G,_),void 0,_)}registerEvaluatableExpressionProvider(F,z,G,_){const fe=this.t(new h(this.h,G),F);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(z)),this.p(fe)}$provideEvaluatableExpression(F,z,G,_){return this.s(F,h,fe=>fe.provideEvaluatableExpression(c.URI.revive(z),G,_),void 0,_)}registerInlineValuesProvider(F,z,G,_){const fe=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,Ee=this.t(new b(this.h,G),F);this.e.$registerInlineValuesProvider(Ee,this.o(z),fe);let Ae=this.p(Ee);if(fe!==void 0){const we=G.onDidChangeInlineValues(Pe=>this.e.$emitInlineValuesEvent(fe));Ae=R.Disposable.from(Ae,we)}return Ae}$provideInlineValues(F,z,G,_,fe){return this.s(F,b,Ee=>Ee.provideInlineValues(c.URI.revive(z),G,_,fe),void 0,fe)}registerDocumentHighlightProvider(F,z,G){const _=this.t(new p(this.h,G),F);return this.e.$registerDocumentHighlightProvider(_,this.o(z)),this.p(_)}$provideDocumentHighlights(F,z,G,_){return this.s(F,p,fe=>fe.provideDocumentHighlights(c.URI.revive(z),G,_),void 0,_)}registerLinkedEditingRangeProvider(F,z,G){const _=this.t(new O(this.h,G),F);return this.e.$registerLinkedEditingRangeProvider(_,this.o(z)),this.p(_)}$provideLinkedEditingRanges(F,z,G,_){return this.s(F,O,async fe=>{const Ee=await fe.provideLinkedEditingRanges(c.URI.revive(z),G,_);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?ae.w(Ee.wordPattern):void 0}},void 0,_)}registerReferenceProvider(F,z,G){const _=this.t(new W(this.h,G),F);return this.e.$registerReferenceSupport(_,this.o(z)),this.p(_)}$provideReferences(F,z,G,_,fe){return this.s(F,W,Ee=>Ee.provideReferences(c.URI.revive(z),G,_,fe),void 0,fe)}registerCodeActionProvider(F,z,G,_){const fe=new C.DisposableStore,Ee=this.t(new q(this.h,this.j.converter,this.k,G,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(Ee,this.o(z),{providedKinds:_?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:_?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,fe)}))},ae.u(F),Boolean(G.resolveCodeAction)),fe.add(this.p(Ee)),fe}$provideCodeActions(F,z,G,_,fe){return this.s(F,q,Ee=>Ee.provideCodeActions(c.URI.revive(z),G,_,fe),void 0,fe)}$resolveCodeAction(F,z,G){return this.s(F,q,_=>_.resolveCodeAction(z,G),void 0,void 0)}$releaseCodeActions(F,z){this.s(F,q,G=>Promise.resolve(G.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(F,z,G){const _=this.t(new x(this.h,G),F);return this.e.$registerDocumentFormattingSupport(_,this.o(z),F.identifier,F.displayName||F.name),this.p(_)}$provideDocumentFormattingEdits(F,z,G,_){return this.s(F,x,fe=>fe.provideDocumentFormattingEdits(c.URI.revive(z),G,_),void 0,_)}registerDocumentRangeFormattingEditProvider(F,z,G){const _=this.t(new M(this.h,G),F);return this.e.$registerRangeFormattingSupport(_,this.o(z),F.identifier,F.displayName||F.name),this.p(_)}$provideDocumentRangeFormattingEdits(F,z,G,_,fe){return this.s(F,M,Ee=>Ee.provideDocumentRangeFormattingEdits(c.URI.revive(z),G,_,fe),void 0,fe)}registerOnTypeFormattingEditProvider(F,z,G,_){const fe=this.t(new B(this.h,G),F);return this.e.$registerOnTypeFormattingSupport(fe,this.o(z),_,F.identifier),this.p(fe)}$provideOnTypeFormattingEdits(F,z,G,_,fe,Ee){return this.s(F,B,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(z),G,_,fe,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(F,z){const G=this.t(new U(z,this.l),F);return this.e.$registerNavigateTypeSupport(G,typeof z.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(F,z,G){return this.s(F,U,_=>_.provideWorkspaceSymbols(z,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,z,G){return this.s(F,U,_=>_.resolveWorkspaceSymbol(z,G),void 0,void 0)}$releaseWorkspaceSymbols(F,z){this.s(F,U,G=>G.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(F,z,G){const _=this.t(new j(this.h,G,this.l),F);return this.e.$registerRenameSupport(_,this.o(z),j.supportsResolving(G)),this.p(_)}$provideRenameEdits(F,z,G,_,fe){return this.s(F,j,Ee=>Ee.provideRenameEdits(c.URI.revive(z),G,_,fe),void 0,fe)}$resolveRenameLocation(F,z,G,_){return this.s(F,j,fe=>fe.resolveRenameLocation(c.URI.revive(z),G,_),void 0,_)}registerDocumentSemanticTokensProvider(F,z,G,_){const fe=this.t(new ie(this.h,G),F),Ee=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(z),_,Ee);let Ae=this.p(fe);if(Ee){const we=G.onDidChangeSemanticTokens(Pe=>this.e.$emitDocumentSemanticTokensEvent(Ee));Ae=R.Disposable.from(Ae,we)}return Ae}$provideDocumentSemanticTokens(F,z,G,_){return this.s(F,ie,fe=>fe.provideDocumentSemanticTokens(c.URI.revive(z),G,_),null,_)}$releaseDocumentSemanticTokens(F,z){this.s(F,ie,G=>G.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,z,G,_){const fe=this.t(new V(this.h,G),F);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(z),_),this.p(fe)}$provideDocumentRangeSemanticTokens(F,z,G,_){return this.s(F,V,fe=>fe.provideDocumentRangeSemanticTokens(c.URI.revive(z),G,_),null,_)}registerCompletionItemProvider(F,z,G,_){const fe=this.t(new J(this.h,this.j.converter,G,this.m,F),F);return this.e.$registerCompletionsProvider(fe,this.o(z),_,J.supportsResolving(G),`${F.identifier.value}(${_.join("")})`),this.p(fe)}$provideCompletionItems(F,z,G,_,fe){return this.s(F,J,Ee=>Ee.provideCompletionItems(c.URI.revive(z),G,_,fe),void 0,fe)}$resolveCompletionItem(F,z,G){return this.s(F,J,_=>_.resolveCompletionItem(z,G),void 0,G)}$releaseCompletionItems(F,z){this.s(F,J,G=>G.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(F,z,G){const _=new ve(F,this.h,G,this.j.converter),fe=this.t(_,F);return this.e.$registerInlineCompletionsSupport(fe,this.o(z),_.supportsHandleEvents),this.p(fe)}$provideInlineCompletions(F,z,G,_,fe){return this.s(F,ne,Ee=>Ee.provideInlineCompletions(c.URI.revive(z),G,_,fe),void 0,fe)}$handleInlineCompletionDidShow(F,z,G){this.s(F,ne,async _=>{_.handleDidShowCompletionItem(z,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,z,G,_){this.s(F,ne,async fe=>{fe.handlePartialAccept(z,G,_)},void 0,void 0)}$freeInlineCompletionsList(F,z){this.s(F,ne,async G=>{G.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(F,z,G,_){const fe=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,Ee=this.t(new ee(this.h,G),F);return this.e.$registerSignatureHelpProvider(Ee,this.o(z),fe),this.p(Ee)}$provideSignatureHelp(F,z,G,_,fe){return this.s(F,ee,Ee=>Ee.provideSignatureHelp(c.URI.revive(z),G,_,fe),void 0,fe)}$releaseSignatureHelp(F,z){this.s(F,ee,G=>G.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(F,z,G){const _=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new N(this.h,this.j.converter,G,this.l,F),F);this.e.$registerInlayHintsProvider(fe,this.o(z),typeof G.resolveInlayHint=="function",_,ae.u(F));let Ee=this.p(fe);if(_!==void 0){const Ae=G.onDidChangeInlayHints(we=>this.e.$emitInlayHintsEvent(_));Ee=R.Disposable.from(Ee,Ae)}return Ee}$provideInlayHints(F,z,G,_){return this.s(F,N,fe=>fe.provideInlayHints(c.URI.revive(z),G,_),void 0,_)}$resolveInlayHint(F,z,G){return this.s(F,N,_=>_.resolveInlayHint(z,G),void 0,G)}$releaseInlayHints(F,z){this.s(F,N,G=>G.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(F,z,G){const _=this.t(new K(this.h,G),F);return this.e.$registerDocumentLinkProvider(_,this.o(z),typeof G.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(F,z,G){return this.s(F,K,_=>_.provideLinks(c.URI.revive(z),G),void 0,G,z.scheme==="output")}$resolveDocumentLink(F,z,G){return this.s(F,K,_=>_.resolveLink(z,G),void 0,void 0,!0)}$releaseDocumentLinks(F,z){this.s(F,K,G=>G.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(F,z,G){const _=this.t(new le(this.h,G),F);return this.e.$registerDocumentColorProvider(_,this.o(z)),this.p(_)}$provideDocumentColors(F,z,G){return this.s(F,le,_=>_.provideColors(c.URI.revive(z),G),[],G)}$provideColorPresentations(F,z,G,_){return this.s(F,le,fe=>fe.provideColorPresentations(c.URI.revive(z),G,_),void 0,_)}registerFoldingRangeProvider(F,z,G){const _=this.q(),fe=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new te(new me(this.h,G),F)),this.e.$registerFoldingRangeProvider(_,this.o(z),F.identifier,fe);let Ee=this.p(_);if(fe!==void 0){const Ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));Ee=R.Disposable.from(Ee,Ae)}return Ee}$provideFoldingRanges(F,z,G,_){return this.s(F,me,fe=>fe.provideFoldingRanges(c.URI.revive(z),G,_),void 0,_)}registerSelectionRangeProvider(F,z,G){const _=this.t(new ke(this.h,G,this.l),F);return this.e.$registerSelectionRangeProvider(_,this.o(z)),this.p(_)}$provideSelectionRanges(F,z,G,_){return this.s(F,ke,fe=>fe.provideSelectionRanges(c.URI.revive(z),G,_),[],_)}registerCallHierarchyProvider(F,z,G){const _=this.t(new Z(this.h,G),F);return this.e.$registerCallHierarchyProvider(_,this.o(z)),this.p(_)}$prepareCallHierarchy(F,z,G,_){return this.s(F,Z,fe=>Promise.resolve(fe.prepareSession(c.URI.revive(z),G,_)),void 0,_)}$provideCallHierarchyIncomingCalls(F,z,G,_){return this.s(F,Z,fe=>fe.provideCallsTo(z,G,_),void 0,_)}$provideCallHierarchyOutgoingCalls(F,z,G,_){return this.s(F,Z,fe=>fe.provideCallsFrom(z,G,_),void 0,_)}$releaseCallHierarchy(F,z){this.s(F,Z,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(F,z,G){const _=this.t(new ce(this.h,G),F);return this.e.$registerTypeHierarchyProvider(_,this.o(z)),this.p(_)}$prepareTypeHierarchy(F,z,G,_){return this.s(F,ce,fe=>Promise.resolve(fe.prepareSession(c.URI.revive(z),G,_)),void 0,_)}$provideTypeHierarchySupertypes(F,z,G,_){return this.s(F,ce,fe=>fe.provideSupertypes(z,G,_),void 0,_)}$provideTypeHierarchySubtypes(F,z,G,_){return this.s(F,ce,fe=>fe.provideSubtypes(z,G,_),void 0,_)}$releaseTypeHierarchy(F,z){this.s(F,ce,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(F,z,G){const _=this.q();return this.f.set(_,new te(new de(this.e,this.h,G,_),F)),this.e.$registerDocumentOnDropEditProvider(_,this.o(z)),this.p(_)}$provideDocumentOnDropEdits(F,z,G,_,fe,Ee){return this.s(F,de,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(z,c.URI.revive(G),_,fe,Ee)),void 0,void 0)}registerDocumentPasteEditProvider(F,z,G,_){const fe=this.q();return this.f.set(fe,new te(new Y(this.e,this.h,G,fe),F)),this.e.$registerPasteEditProvider(fe,this.o(z),!!G.prepareDocumentPaste,_.pasteMimeTypes),this.p(fe)}$prepareDocumentPaste(F,z,G,_,fe){return this.s(F,Y,Ee=>Ee.prepareDocumentPaste(c.URI.revive(z),G,_,fe),void 0,fe)}$providePasteEdits(F,z,G,_,fe,Ee){return this.s(F,Y,Ae=>Ae.providePasteEdits(z,c.URI.revive(G),_,fe,Ee),void 0,Ee)}static w(F){return{pattern:F.source,flags:(0,D.regExpFlags)(F)}}static y(F){return{decreaseIndentPattern:ae.w(F.decreaseIndentPattern),increaseIndentPattern:ae.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ae.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ae.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ae.w(F.beforeText),afterText:F.afterText?ae.w(F.afterText):void 0,previousLineText:F.previousLineText?ae.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ae.z)}setLanguageConfiguration(F,z,G){const{wordPattern:_}=G;if(_&&(0,D.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(z,_):this.h.setWordDefinitionFor(z,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const fe=this.q(),Ee={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this.e.$setLanguageConfiguration(fe,z,Ee),this.p(fe)}$setWordDefinitions(F){for(const z of F)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}ae.d=0,e.ExtHostLanguageFeatures=ae}),define(De[270],Ce([1,0,5,13,7,37,19,6]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(L,k,S,I){this.c=k,this.d=S,this.e=I,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,k){await this.a.$changeLanguage(L,k);const S=this.c.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,k){const S=L.version,I=A.Position.from(k),C=await this.a.$tokensAtPosition(L.uri,I),E={type:u.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new u.Range(k.line,k.character,k.line,k.character)};if(!C)return E;const r={range:A.Range.to(C.range),type:A.TokenType.to(C.type)};return!r.range.contains(k)||S!==L.version?E:r}createLanguageStatusItem(L,k,S){const I=this.f++,C=this.a,E=this.g,r=`${L.identifier.value}/${k}`;if(E.has(r))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);E.add(r);const d={selector:S,id:k,name:L.displayName??L.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let f;const w=new T.DisposableStore,y=()=>{f?.dispose(),f=(0,P.disposableTimeout)(()=>{w.clear(),this.a.$setLanguageStatus(I,{id:r,name:d.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===u.LanguageStatusSeverity.Error?R.default.Error:d.severity===u.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:d.command&&this.d.toInternal(d.command,w),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},m={dispose(){w.dispose(),f?.dispose(),C.$removeLanguageStatus(I),E.delete(r)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,y()},get selector(){return d.selector},set selector(t){d.selector=t,y()},get text(){return d.text},set text(t){d.text=t,y()},get detail(){return d.detail},set detail(t){d.detail=t,y()},get severity(){return d.severity},set severity(t){d.severity=t,y()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,y()},get command(){return d.command},set command(t){d.command=t,y()},get busy(){return d.busy},set busy(t){d.busy=t,y()}};return y(),m}}e.ExtHostLanguages=D}),define(De[98],Ce([1,0,11,8,2,4,16,5,26,20]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(S,I,C){this.f=C,this.d=new Map,this.a=I.getProxy(T.MainContext.MainThreadLocalization),this.b=S.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(S,I){const{message:C,args:E,comment:r}=I;if(this.c)return(0,A.format2)(C,E??{});let d=C;r&&r.length>0&&(d+=`/${Array.isArray(r)?r.join(""):r}`);const f=this.d.get(S)?.contents[d];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,A.format2)(f??C,E??{})}getBundle(S){return this.d.get(S)?.contents}getBundleUri(S){return this.d.get(S)?.uri}async initializeLocalizedMessages(S){if(this.c||!S.l10n&&!S.isBuiltin||this.d.has(S.identifier.value))return;let I;const C=await this.g(S);if(!C){this.f.error(`No bundle location found for extension ${S.identifier.value}`);return}try{const E=await this.a.$fetchBundleContents(C),r=JSON.parse(E);I=S.isBuiltin?r.contents?.bundle:r}catch(E){this.f.error(`Failed to load translations for ${S.identifier.value} from ${C}: ${E.message}`);return}I&&this.d.set(S.identifier.value,{contents:I,uri:C})}async g(S){if(S.isBuiltin){const I=await this.a.$fetchBuiltInBundleUri(S.identifier.value,this.b);return u.URI.revive(I)}return S.l10n?u.URI.joinPath(S.extensionLocation,S.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=Ve([We(0,D.IExtHostInitDataService),We(1,g.IExtHostRpcService),We(2,P.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(De[141],Ce([1,0,16,5,26,20,2,70]),function(re,e,c,A,u,R,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends c.AbstractLoggerService{constructor(k,S){super(S.logLevel,S.logsLocation,S.loggers.map(I=>(0,T.revive)(I))),this.n=k.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(k,S){S?this.setLogLevel(P.URI.revive(S),k):this.setLogLevel(k)}setVisibility(k,S){super.setVisibility(k,S),this.n.$setVisibility(k,S)}m(k,S,I){return new g(this.n,k,S,I)}};D=Ve([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class g extends c.AbstractMessageLogger{constructor(k,S,I,C){super(C?.logLevel==="always"),this.m=k,this.n=S,this.k=!1,this.l=[],this.setLevel(I),this.m.$createLogger(S,C).then(()=>{this.q(this.l),this.k=!0})}g(k,S){const I=[[k,S]];this.k?this.q(I):this.l.push(...I)}q(k){this.m.$log(this.n,k)}}}),define(De[271],Ce([1,0,5,16,27]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(T){return T&&T.title}let P=class{constructor(D,g){this.b=g,this.a=D.getProxy(c.MainContext.MainThreadMessageService)}showMessage(D,g,L,k,S){const I={source:{identifier:D.identifier,label:D.displayName||D.name}};let C;typeof k=="string"||R(k)?C=[k,...S]:(I.modal=k?.modal,I.useCustom=k?.useCustom,I.detail=k?.detail,C=S),I.useCustom&&(0,u.checkProposedApiEnabled)(D,"resolvers");const E=[];for(let r=0;r<C.length;r++){const d=C[r];if(typeof d=="string")E.push({title:d,handle:r,isCloseAffordance:!1});else if(typeof d=="object"){const{title:f,isCloseAffordance:w}=d;E.push({title:f,isCloseAffordance:!!w,handle:r})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(g,L,I,E).then(r=>{if(typeof r=="number")return C[r]})}};P=Ve([We(1,A.ILogService)],P),e.ExtHostMessageService=P}),define(De[272],Ce([1,0,22,3,6,28,8,10,2,75,5,40,13,7,58,245,137,9]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(y=>y.apiEditor)}constructor(y,m,t,o){this.q=t,this.r=o,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new g.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=y.getProxy(L.MainContext.MainThreadNotebook),this.c=y.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=y.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=m.converter,m.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const a=s.notebookEditor?.notebookUri,l=s.cell.handle,i=this.g.get(a)?.getCell(l);if(i)return i.apiCell}if(s&&s.$mid===14){const a=s.uri,l=this.g.get(a);if(l)return l.apiNotebook}return s}}),f.x(m)}getEditorById(y){const m=this.h.get(y);if(!m)throw new Error(`unknown text editor: ${y}. known editors: ${[...this.h.keys()]} `);return m}getIdByEditor(y){for(const[m,t]of this.h)if(t.apiEditor===y)return m}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(y,m){const t=this.g.get(y);if(!t&&!m)throw new Error(`NO notebook document for '${y}'`);return t}static s(y,m){if(!m)return;const t=m.filenamePattern.map(o=>S.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(m.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:y.identifier,providerDisplayName:y.displayName||y.name,displayName:m.displayName,filenamePattern:t,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(y,m,t){const o=f.a++,s=typeof t.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(o,t),this.b.$registerNotebookCellStatusBarItemProvider(o,s,m);let a;return s!==void 0&&(a=t.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(s))),new I.Disposable(()=>{this.f.delete(o),this.b.$unregisterNotebookCellStatusBarItemProvider(o,s),a?.dispose()})}async createNotebookDocument(y){const m=await this.c.$tryCreateNotebook({viewType:y.viewType,content:y.content&&S.NotebookData.from(y.content)});return D.URI.revive(m)}async openNotebookDocument(y){const m=this.g.get(y);if(m)return m.apiNotebook;const t=await this.c.$tryOpenNotebook(y),o=this.g.get(D.URI.revive(t));return(0,T.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(y,m){D.URI.isUri(y)&&(y=await this.openNotebookDocument(y));let t;typeof m=="object"?t={position:S.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(S.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:t={preserveFocus:!1};const o=await this.d.$tryShowNotebookDocument(y.uri,y.notebookType,t),s=o&&this.h.get(o)?.apiEditor;if(s)return s;throw o?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(y,m,t,o){const s=this.f.get(y),a=D.URI.revive(m),l=this.g.get(a);if(!l||!s)return;const v=l.getCellFromIndex(t);if(!v)return;const i=await s.provideCellStatusBarItems(v.apiCell,o);if(!i)return;const n=new u.DisposableStore,h=this.p.add([n]),p=(Array.isArray(i)?i:[i]).map(O=>S.NotebookStatusBarItem.from(O,this.i,n));return{cacheId:h,items:p}}$releaseNotebookCellStatusBarItems(y){this.p.delete(y)}registerNotebookSerializer(y,m,t,o,s){if((0,P.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,t),this.b.$registerNotebookSerializer(a,{id:y.identifier,location:y.extensionLocation},m,S.NotebookDocumentContentOptions.from(o),f.s(y,s)),(0,u.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(y,m,t){const o=this.u.get(y);if(!o)throw new Error("NO serializer found");const s=await o.deserializeNotebook(m.buffer,t);return new C.SerializableObjectWithBuffers(S.NotebookData.from(s))}async $notebookToData(y,m,t){const o=this.u.get(y);if(!o)throw new Error("NO serializer found");const s=await o.serializeNotebook(S.NotebookData.to(m.value),t);return c.VSBuffer.wrap(s)}w(y,m,t){if(this.h.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const o=new r.ExtHostNotebookEditor(m,this.d,y,t.visibleRanges.map(S.NotebookRange.to),t.selections.map(S.NotebookRange.to),typeof t.viewColumn=="number"?S.ViewColumn.to(t.viewColumn):void 0);this.h.set(m,o)}$acceptDocumentAndEditorsDelta(y){if(y.value.removedDocuments)for(const t of y.value.removedDocuments){const o=D.URI.revive(t),s=this.g.get(o);s&&(s.dispose(),this.g.delete(o),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(s.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===o.toString()&&this.h.delete(a.id)}if(y.value.addedDocuments){const t=[];for(const o of y.value.addedDocuments){const s=D.URI.revive(o.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new E.ExtHostNotebookDocument(this.c,this.q,this.r,s,o);t.push(...o.cells.map(l=>E.ExtHostCell.asModelAddData(a.apiNotebook,l))),this.g.get(s)?.dispose(),this.g.set(s,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this.m.fire(a.apiNotebook)}}if(y.value.addedEditors)for(const t of y.value.addedEditors){if(this.h.has(t.id))return;const o=D.URI.revive(t.documentUri),s=this.g.get(o);s&&this.w(s,t.id,t)}const m=[];if(y.value.removedEditors)for(const t of y.value.removedEditors){const o=this.h.get(t);o&&(this.h.delete(t),this.k?.id===o.id&&(this.k=void 0),m.push(o))}if(y.value.visibleEditors){this.l=y.value.visibleEditors.map(o=>this.h.get(o)).filter(o=>!!o);const t=new Set;this.l.forEach(o=>t.add(o.id));for(const o of this.h.values()){const s=t.has(o.id);o._acceptVisibility(s)}this.l=[...this.h.values()].map(o=>o).filter(o=>o.visible),this.o.fire(this.visibleNotebookEditors)}y.value.newActiveEditor===null?this.k=void 0:y.value.newActiveEditor&&(this.h.get(y.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${y.value.newActiveEditor}`),this.k=this.h.get(y.value.newActiveEditor)),y.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(y){const m=k.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new k.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>c.VSBuffer.wrap(s))],new k.ApiCommandResult("Notebook Data",s=>S.NotebookData.to(s.value))),o=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new C.SerializableObjectWithBuffers(S.NotebookData.from(s)))],new k.ApiCommandResult("Bytes",s=>s.buffer));y.registerApiCommand(t),y.registerApiCommand(o)}}f.a=0,e.ExtHostNotebookController=f}),define(De[273],Ce([1,0,17,19,21,3,6,28,2,25,16,75,5,40,13,7,96,235,27,58]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(l,v,i,n,h){this.k=v,this.l=i,this.m=n,this.n=h,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new k.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=l.getProxy(S.MainContext.MainThreadNotebookKernels);const b=new I.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new I.ApiCommandArgument("options","Select kernel options",p=>!0,p=>{if(p&&"notebookEditor"in p&&"id"in p){const O=this.l.getIdByEditor(p.notebookEditor);return{id:p.id,extension:p.extension,notebookEditorId:O}}else if(p&&"notebookEditor"in p){const O=this.l.getIdByEditor(p.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${p.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return p})],I.ApiCommandResult.Void);this.m.registerApiCommand(b)}createNotebookController(l,v,i,n,h,b){for(const ne of this.h.values())if(ne.controller.id===v&&g.ExtensionIdentifier.equals(l.identifier,ne.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const p=this.i++,O=this;this.n.trace(`NotebookController[${p}], CREATED by ${l.identifier.value}, ${v}`);const W=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${l.identifier}'`);let q=!1;const Y=new P.DisposableStore,x=new R.Emitter,M=new R.Emitter,B={id:s(l.identifier,v),notebookType:i,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:n||l.identifier.value,preloads:b?b.map(C.NotebookRendererScript.from):[]};let U=h??W,j;this.a.$addKernel(p,B).catch(ne=>{console.log(ne),q=!0});let he=0;const ie=()=>{if(q)return;const ne=++he;Promise.resolve().then(()=>{ne===he&&this.a.$updateKernel(p,B)})},V=new T.ResourceMap,J={get id(){return v},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return B.label},set label(ne){B.label=ne??l.displayName??l.name,ie()},get detail(){return B.detail??""},set detail(ne){B.detail=ne,ie()},get description(){return B.description??""},set description(ne){B.description=ne,ie()},get kind(){return(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind??""},set kind(ne){(0,f.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind=ne,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ne){B.supportedLanguages=ne,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){B.supportsExecutionOrder=ne,ie()},get rendererScripts(){return B.preloads?B.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(ne){U=ne??W},get interruptHandler(){return j},set interruptHandler(ne){j=ne,B.supportsInterrupt=Boolean(ne),ie()},createNotebookCellExecution(ne){if(q)throw new Error("notebook controller is DISPOSED");if(!V.has(ne.notebook.uri))throw O.n.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return O._createNotebookCellExecution(ne,s(l.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${p}], DISPOSED`),q=!0,this.h.delete(p),Y.dispose(),x.dispose(),M.dispose(),this.a.$removeKernel(p))},updateNotebookAffinity(ne,ve){ve===E.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(p,ne.uri,ve)},onDidReceiveMessage:M.event,postMessage(ne,ve){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),O.a.$postMessage(p,ve&&O.l.getIdByEditor(ve),ne)},asWebviewUri(ne){return(0,f.checkProposedApiEnabled)(l,"notebookMessaging"),(0,r.asWebviewUri)(ne,O.k.remote)}};return this.h.set(p,{extensionId:l.identifier,controller:J,onDidReceiveMessage:M,onDidChangeSelection:x,associatedNotebooks:V}),J}getIdByController(l){for(const[v,i]of this.h)if(i.controller===l)return s(i.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,v){const i=this.d++,n=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(i,v);const h={dispose:()=>{this.c.delete(i),n.a.$removeKernelDetectionTask(i)}};return this.c.set(i,h),h}registerKernelSourceActionProvider(l,v,i){const n=this.f++,h=typeof i.onDidChangeNotebookKernelSourceActions=="function"?n:void 0,b=this;this.e.set(n,i),this.n.trace(`NotebookKernelSourceActionProvider[${n}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(n,n,v);let p;return h!==void 0&&(p=i.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this.e.delete(n),b.a.$removeKernelSourceActionProvider(n,n),p?.dispose()}}}async $provideKernelSourceActions(l,v){const i=this.e.get(l);if(i){const n=new P.DisposableStore;return this.g.add([n]),(await i.provideNotebookKernelSourceActions(v)??[]).map(b=>C.NotebookKernelSourceAction.from(b,this.m.converter,n))}return[]}$acceptNotebookAssociation(l,v,i){const n=this.h.get(l);if(n){const h=this.l.getNotebookDocument(D.URI.revive(v));i?n.associatedNotebooks.set(h.uri,!0):n.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${l}] ASSOCIATE notebook`,h.uri.toString(),i),n.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(l,v,i){const n=this.h.get(l);if(!n)return;const h=this.l.getNotebookDocument(D.URI.revive(v)),b=[];for(const p of i){const O=h.getCell(p);O&&b.push(O.apiCell)}try{this.n.trace(`NotebookController[${l}] EXECUTE cells`,h.uri.toString(),b.length),await n.controller.executeHandler.call(n.controller,b,h.apiNotebook,n.controller)}catch(p){this.n.error(`NotebookController[${l}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(l,v,i){const n=this.h.get(l);if(!n)return;const h=this.l.getNotebookDocument(D.URI.revive(v));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,h.apiNotebook);else for(const b of i){const p=h.getCell(b);p&&this.b.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,v,i){const n=this.h.get(l);if(!n)return;const h=this.l.getEditorById(v);n.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}$cellExecutionChanged(l,v,i){const h=this.l.getNotebookDocument(D.URI.revive(l)).getCell(v);if(h){const b=i?C.NotebookCellExecutionState.to(i):E.NotebookCellExecutionState.Idle;b!==void 0&&this.j.fire({cell:h.apiCell,state:b})}}_createNotebookCellExecution(l,v){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this.l.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!n)throw new Error("invalid cell");if(this.b.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const h=new t(v,n,this.a);this.b.set(n.uri,h);const b=h.onDidChangeState(()=>{h.state===m.Resolved&&(h.dispose(),b.dispose(),this.b.delete(n.uri))});return h.asApiObject()}};y=Ve([We(4,L.ILogService)],y),e.ExtHostNotebookKernels=y;var m;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(m||(m={}));class t extends P.Disposable{get state(){return this.f}constructor(l,v,i){super(),this.j=v,this.k=i,this.b=t.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.D(new u.CancellationTokenSource),this.h=new o(10,n=>this.m(n)),this.i=v.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const v=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new w.SerializableObjectWithBuffers(v))}n(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}q(l){let v=this.j;if(l&&(v=this.j.notebook.getCellFromApiCell(l)),!v)throw new Error("INVALID cell");return v.handle}r(l){return l.map(v=>{const i=E.NotebookCellOutput.ensureUniqueMimeTypes(v.items,!0);return i===v.items?C.NotebookCellOutput.from(v):C.NotebookCellOutput.from({items:i,id:v.id,metadata:v.metadata})})}async s(l,v,i){const n=this.q(v),h=this.r((0,c.asArray)(l));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:n,append:i,outputs:h})}async t(l,v,i){return l=E.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(C.NotebookCellOutputItem.from),outputId:v.id,append:i})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(i){l.i=i,l.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(i){if(l.f===m.Resolved||l.f===m.Started)throw new Error("Cannot call start again");l.f=m.Started,l.c.fire(),l.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,n){if(l.f===m.Resolved)throw new Error("Cannot call resolve twice");l.f=m.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new w.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:i}))},clearOutput(i){return l.n(),l.s([],i,!1)},appendOutput(i,n){return l.n(),l.s(i,n,!0)},replaceOutput(i,n){return l.n(),l.s(i,n,!1)},appendOutputItems(i,n){return l.n(),l.t(i,n,!0)},replaceOutputItems(i,n){return l.n(),l.t(i,n,!1)}})}}t.a=0;class o{constructor(l,v){this.d=l,this.e=v,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const v=this.a;return this.a=[],this.e(v).finally(()=>l.complete())}}function s(a,l){return`${a.value}/${l}`}e.createKernelId=s}),define(De[274],Ce([1,0,3,5,137]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(T,D){this.c=D,this.a=new Map,this.b=T.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,D,g){const L=this.c.getEditorById(T);this.a.get(D)?.fire({editor:L.apiEditor,message:g})}createRendererMessaging(T,D){if(!T.contributes?.notebookRenderer?.some(L=>L.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(L,k,S)=>this.d(D).event(L,k,S),postMessage:(L,k)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const S=k&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.b.$postMessage(S?.id,D,L)}}}d(T){let D=this.a.get(T);return D||(D=new c.Emitter({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(T)}}),this.a.set(T,D),D)}}e.ExtHostNotebookRenderers=R}),define(De[275],Ce([1,0,6,10,2,27,5]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class T{constructor(g){this.b=new Map,this.a=g.getProxy(P.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,L,k){if((0,R.checkProposedApiEnabled)(g,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,k),this.a.$registerProfileContentHandler(L,k.name,k.description,g.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(g,L,k,S){const I=this.b.get(g);if(!I)throw new Error(`Unknown handler with id: ${g}`);return I.saveProfile(L,k,S)}async $readProfile(g,L,k){const S=this.b.get(g);if(!S)throw new Error(`Unknown handler with id: ${g}`);return S.readProfile((0,A.isString)(L)?L:u.URI.revive(L),k)}}e.ExtHostProfileContentHandlers=T}),define(De[276],Ce([1,0,2,5,19,13]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class P{constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(D,g,L){const k=c.URI.revive(g),S=this.c.get(D);return S?(0,u.asPromise)(()=>S.provideOriginalResource(k,L)).then(I=>I||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,L,k){const S=P.a++;return this.c.set(S,g),this.b.$registerQuickDiffProvider(S,R.DocumentSelector.from(D,this.d),L,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(S),this.c.delete(S)}}}}P.a=0,e.ExtHostQuickDiff=P}),define(De[277],Ce([1,0,21,3,6,5,2,7,9,17,37,52,27,13]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(E,r,d){const f=E.getProxy(R.MainContext.MainThreadQuickOpen);class w{constructor(i,n){this.e=new Map,this.f=0,this.a=i,this.b=n}showQuickPick(i,n,h,b=c.CancellationToken.None){this.c=void 0;const p=Promise.resolve(n),O=++this.f,W=f.$show(O,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},b),q={},Y=W.then(()=>q);return Promise.race([Y,p]).then(x=>{if(x===q)return;const M=(0,S.isProposedApiEnabled)(i,"quickPickItemTooltip");return p.then(B=>{const U=[];for(let j=0;j<B.length;j++){const he=B[j];typeof he=="string"?U.push({label:he,handle:j}):he.kind===T.QuickPickItemKind.Separator?U.push({type:"separator",label:he.label}):(he.tooltip&&!M&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),U.push({label:he.label,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:M?I.MarkdownString.fromStrict(he.tooltip):void 0,handle:j}))}return h&&typeof h.onDidSelectItem=="function"&&(this.c=j=>{h.onDidSelectItem(B[j])}),f.$setItems(O,U),W.then(j=>{if(typeof j=="number")return B[j];if(Array.isArray(j))return j.map(he=>B[he])})})}).then(void 0,x=>{if(!(0,D.isCancellationError)(x))return f.$setError(O,x),Promise.reject(x)})}$onItemSelected(i){this.c?.(i)}showInput(i,n=c.CancellationToken.None){return this.d=i?.validateInput,f.$input(i,typeof this.d=="function",n).then(void 0,h=>{if(!(0,D.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(i){if(!this.d)return;const n=await this.d(i);if(!n||typeof n=="string")return n;let h;switch(n.severity){case T.InputBoxValidationSeverity.Info:h=L.default.Info;break;case T.InputBoxValidationSeverity.Warning:h=L.default.Warning;break;case T.InputBoxValidationSeverity.Error:h=L.default.Error;break;default:h=n.message?L.default.Error:L.default.Ignore;break}return{content:n.message,severity:h}}async showWorkspaceFolderPick(i,n=c.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const b=await this.a.getWorkspaceFolders2();if(!!b)return b.find(p=>p.uri.toString()===h.uri.toString())}createQuickPick(i){const n=new a(i,()=>this.e.delete(n._id));return this.e.set(n._id,n),n}createInputBox(i){const n=new l(i,()=>this.e.delete(n._id));return this.e.set(n._id,n),n}$onDidChangeValue(i,n){this.e.get(i)?._fireDidChangeValue(n)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,n){const h=this.e.get(i);h instanceof a&&h._fireDidChangeActive(n)}$onDidChangeSelection(i,n){const h=this.e.get(i);h instanceof a&&h._fireDidChangeSelection(n)}$onDidTriggerButton(i,n){this.e.get(i)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(i,n,h){const b=this.e.get(i);b instanceof a&&b._fireDidTriggerItemButton(n,h)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class y{constructor(i,n){this.x=i,this.y=n,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((n,h)=>{const b=n===T.QuickInputButtons.Back?-1:h;this.o.set(b,n)}),this.z({buttons:i.map((n,h)=>({...s(n),tooltip:n.tooltip,handle:n===T.QuickInputButtons.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const n=this.o.get(i);n&&this.r.fire(n)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,u.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(i){if(!this.v){for(const n of Object.keys(i)){const h=i[n];this.u[n]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}y.a=1;function m(v){if(v instanceof T.ThemeIcon)return{id:v.id};const i=o(v),n=t(v);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof n=="string"?P.URI.file(n):n}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function o(v){return typeof v=="object"&&"dark"in v?v.dark:v}function s(v){const i=m(v.iconPath);let n,h;return"id"in i?h=k.ThemeIcon.asClassName(i):n=i,{iconPath:n,iconClass:h}}class a extends y{constructor(i,n){super(i.identifier,n),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((b,p)=>{this.C.set(p,b),this.D.set(b,p)});const n=(0,S.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),h=[];for(let b=0;b<i.length;b++){const p=i[b];p.kind===T.QuickPickItemKind.Separator?h.push({type:"separator",label:p.label}):(p.tooltip&&!n&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),h.push({handle:b,label:p.label,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:n?I.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((O,W)=>({...s(O),tooltip:O.tooltip,handle:W}))}))}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(n=>this.D.has(n)),this.z({activeItems:this.J.map(n=>this.D.get(n))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(n=>this.D.has(n)),this.z({selectedItems:this.L.map(n=>this.D.get(n))})}_fireDidChangeActive(i){const n=(0,g.coalesce)(i.map(h=>this.C.get(h)));this.J=n,this.K.fire(n)}_fireDidChangeSelection(i){const n=(0,g.coalesce)(i.map(h=>this.C.get(h)));this.L=n,this.M.fire(n)}_fireDidTriggerItemButton(i,n){const h=this.C.get(i);if(!h||!h.buttons||!h.buttons.length)return;const b=h.buttons[n];b&&this.N.fire({button:b,item:h})}}class l extends y{constructor(i,n){super(i.identifier,n),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:L.default.Error}):this.z({validationMessage:i.message,severity:i.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new w(r,d)}e.createExtHostQuickOpen=C});var Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(De[278],Ce([1,0,2,3,62,6,19,5,17,109,16,25,52,13,27]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C){"use strict";var E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(n){if(n)return typeof n.iconPath=="string"?c.URI.file(n.iconPath):c.URI.isUri(n.iconPath)||S.ThemeIcon.isThemeIcon(n.iconPath)?n.iconPath:void 0}function f(n,h){if(!n.iconPath&&!h.iconPath)return 0;if(n.iconPath){if(!h.iconPath)return 1}else return-1;const b=typeof n.iconPath=="string"?n.iconPath:c.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id,p=typeof h.iconPath=="string"?h.iconPath:c.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,g.comparePaths)(b,p)}function w(n,h){let b=0;if(n.strikeThrough!==h.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==h.faded)return n.faded?1:-1;if(n.tooltip!==h.tooltip)return(n.tooltip||"").localeCompare(h.tooltip||"");if(b=f(n,h),b!==0)return b;if(n.light&&h.light)b=f(n.light,h.light);else{if(n.light)return 1;if(h.light)return-1}if(b!==0)return b;if(n.dark&&h.dark)b=f(n.dark,h.dark);else{if(n.dark)return 1;if(h.dark)return-1}return b}function y(n,h){if(n.command!==h.command)return n.command<h.command?-1:1;if(n.title!==h.title)return n.title<h.title?-1:1;if(n.tooltip!==h.tooltip){if(n.tooltip!==void 0&&h.tooltip!==void 0)return n.tooltip<h.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(n.arguments===h.arguments)return 0;if(n.arguments)if(h.arguments){if(n.arguments.length!==h.arguments.length)return n.arguments.length-h.arguments.length}else return 1;else return-1;for(let b=0;b<n.arguments.length;b++){const p=n.arguments[b],O=h.arguments[b];if(p!==O)return p<O?-1:1}return 0}function m(n,h){let b=(0,g.comparePaths)(n.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(b!==0)return b;if(n.command&&h.command)b=y(n.command,h.command);else{if(n.command)return 1;if(h.command)return-1}if(b!==0)return b;if(n.decorations&&h.decorations)b=w(n.decorations,h.decorations);else{if(n.decorations)return 1;if(h.decorations)return-1}return b}function t(n,h){for(let b=0;b<n.length;b++)if(n[b]!==h[b])return!1;return!0}function o(n,h){return n.command===h.command&&n.title===h.title&&n.tooltip===h.tooltip&&(n.arguments&&h.arguments?t(n.arguments,h.arguments):n.arguments===h.arguments)}function s(n,h){return(0,D.equals)(n,h,o)}class a{get value(){return this.d}set value(h){h=h??"",Me(this,E,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Me(this,E,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,C.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Me(this,E,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Me(this,E,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Me(this,E,"f").$setInputBoxVisibility(this.l,h))}constructor(h,b,p){this.k=h,this.l=p,E.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,E,b,"f")}showValidationMessage(h,b){(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),Me(this,E,"f").$showValidationMessage(this.l,h,b)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=a,E=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,b,p,O,W){this.q=h,this.s=b,this.t=p,this.u=O,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,b){const p=this.h.get(h);return p?(0,P.asPromise)(()=>this.s.executeCommand(p.command,...p.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(m),p=(0,D.sortedDiff)(this.o,h,m).map(q=>{const Y=q.toInsert.map(x=>{const M=this.e++;this.g.set(M,x);const B=x.resourceUri;let U;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const N=new R.DisposableStore;U=this.s.converter.toInternal(x.command,N),this.j.set(M,N)}else this.h.set(M,x.command);const j=d(x.decorations),he=x.decorations&&d(x.decorations.light)||j,ie=x.decorations&&d(x.decorations.dark)||j,V=[he,ie],J=x.decorations&&x.decorations.tooltip||"",ne=x.decorations&&!!x.decorations.strikeThrough,ve=x.decorations&&!!x.decorations.faded,ue=x.contextValue||"";return{rawResource:[M,B,V,J,ne,ve,ue,U],handle:M}});return{start:q.start,deleteCount:q.deleteCount,toInsert:Y}}),O=p.map(({start:q,deleteCount:Y,toInsert:x})=>[q,Y,x.map(M=>M.rawResource)]),W=p.reverse();for(const{start:q,deleteCount:Y,toInsert:x}of W){const M=x.map(U=>U.handle),B=this.n.splice(q,Y,...M);for(const U of B)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=h,O}dispose(){this.l=!0,this.m.fire()}}l.d=0;class v{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Me(this,r,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h,h?.label&&(0,C.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Me(this,r,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h,quickDiffLabel:h?.label})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Me(this,r,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new R.DisposableStore,this.l=h;const b=this.v.converter.toInternal(h,this.k.value);Me(this,r,"f").$updateSourceControl(this.t,{acceptInputCommand:b})}get actionButton(){return(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=h;const b=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(p=>p.map(O=>this.v.converter.toInternal(O,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Me(this,r,"f").$updateSourceControl(this.t,{actionButton:b??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&s(this.p,h))return;this.o.value=new R.DisposableStore,this.p=h;const b=(h||[]).map(p=>this.v.converter.toInternal(p,this.o.value));Me(this,r,"f").$updateSourceControl(this.t,{statusBarCommands:b})}get selected(){return this.q}constructor(h,b,p,O,W,q){this.u=h,this.v=p,this.w=O,this.x=W,this.y=q,r.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=v.d++,this.z=new Map,this.A=new Set,_e(this,r,b,"f"),this.f=new a(h,Me(this,r,"f"),this.t),Me(this,r,"f").$registerSourceControl(this.t,O,W,q)}createResourceGroup(h,b){const p=new l(Me(this,r,"f"),this.v,this.t,h,b),O=A.Event.once(p.onDidDispose)(()=>this.z.delete(p));return this.z.set(p,O),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const h=[],b=[];for(const[p,O]of this.z){O.dispose();const W=p.onDidUpdateResourceStates(()=>{this.A.add(p),this.eventuallyUpdateResourceStates()});A.Event.once(p.onDidDispose)(()=>{this.A.delete(p),W.dispose(),this.e.delete(p.handle),Me(this,r,"f").$unregisterGroup(this.t,p.handle)}),h.push([p.handle,p.id,p.label,p.features]);const q=p._takeResourceStateSnapshot();q.length>0&&b.push([p.handle,q]),this.e.set(p.handle,p)}Me(this,r,"f").$registerGroups(this.t,h,b),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(b=>{const p=b._takeResourceStateSnapshot();p.length!==0&&h.push([b.handle,p])}),h.length>0&&Me(this,r,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Me(this,r,"f").$unregisterSourceControl(this.t)}}r=new WeakMap,v.d=0,Ve([(0,u.debounce)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ve([(0,u.debounce)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let i=class un{get onDidChangeActiveProvider(){return this.j.event}constructor(h,b,p){this.l=b,this.m=p,this.g=new Map,this.h=new k.ExtensionIdentifierMap,this.j=new A.Emitter,this.e=h.getProxy(T.MainContext.MainThreadSCM),this.f=h.getProxy(T.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const W=this.g.get(O.sourceControlHandle);if(!W)return O;const q=W.getResourceGroup(O.groupHandle);return q?q.getResourceState(O.handle):O}else if(O&&O.$mid===4){const W=this.g.get(O.sourceControlHandle);return W?W.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const W=this.g.get(O.handle);return W||O}return O}})}createSourceControl(h,b,p,O){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,b,p,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const W=un.d++,q=new v(h,this.e,this.l,b,p,O);this.g.set(W,q);const Y=this.h.get(h.identifier)||[];return Y.push(q),this.h.set(h.identifier,Y),q}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const b=this.h.get(h.identifier),p=b&&b[b.length-1];return p&&p.inputBox}$provideOriginalResource(h,b,p){const O=c.URI.revive(b);this.m.trace("ExtHostSCM#$provideOriginalResource",h,O.toString());const W=this.g.get(h);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>W.quickDiffProvider.provideOriginalResource(O,p)).then(q=>q||null)}$onInputBoxValueChange(h,b){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const p=this.g.get(h);return p&&p.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(h,b,p,O){this.m.trace("ExtHostSCM#$executeResourceCommand",h,b,p);const W=this.g.get(h);if(!W)return Promise.resolve(void 0);const q=W.getResourceGroup(b);return q?q.$executeResourceCommand(p,O):Promise.resolve(void 0)}$validateInput(h,b,p){this.m.trace("ExtHostSCM#$validateInput",h);const O=this.g.get(h);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>O.inputBox.validateInput(b,p)).then(W=>{if(!W)return Promise.resolve(void 0);const q=I.MarkdownString.fromStrict(W.message);return q?Promise.resolve([q,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};i.d=0,i=Ve([We(2,L.ILogService)],i),e.ExtHostSCM=i}),define(De[99],Ce([1,0,5,3,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(T){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,D){return this.a.$getPassword(T,D)}store(T,D,g){return this.a.$setPassword(T,D,g)}delete(T,D){return this.a.$deletePassword(T,D)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[279],Ce([1,0,7,5,184,6,13,10]),function(re,e,c,A,u,R,P,T){"use strict";var D,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(C,E,r,d,f=c.StatusBarAlignment.Left,w){D.set(this,void 0),g.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,D,C,"f"),_e(this,g,E,"f"),this.c=L.a++,this.e=r,this.f=d,this.g=f,this.h=this.u(w)}u(C){if(!!(0,T.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(C){this.k=C,this.v()}set name(C){this.m=C,this.v()}set tooltip(C){this.l=C,this.v()}set color(C){this.n=C,this.v()}set backgroundColor(C){C&&!L.b.has(C.id)&&(C=void 0),this.o=C,this.v()}set command(C){this.r?.fromApi!==C&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof C=="string"?this.r={fromApi:C,internal:Me(this,g,"f").toInternal({title:"",command:C},this.p)}:C?this.r={fromApi:C,internal:Me(this,g,"f").toInternal(C,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(C){this.t=C,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Me(this,D,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let C;this.e?this.f?C=`${this.e.identifier.value}.${this.f}`:C=this.e.identifier.value:C=this.f;let E;this.m?E=this.m:E=(0,u.localize)(0,null,this.e.displayName||this.e.name);let r=this.n;this.o&&(r=L.b.get(this.o.id));const d=P.MarkdownString.fromStrict(this.l);Me(this,D,"f").$setEntry(this.c,C,E,this.k,d,this.r?.internal,r,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}D=new WeakMap,g=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class k{constructor(C){this.b=[],this.a=C.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,u.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(C){const E={message:C};return this.b.unshift(E),this.c(),new c.Disposable(()=>{const r=this.b.indexOf(E);r>=0&&(this.b.splice(r,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class S{constructor(C,E){this.a=C.getProxy(A.MainContext.MainThreadStatusBar),this.b=E,this.c=new k(this)}createStatusBarEntry(C,E,r,d){return new L(this.a,this.b,C,E,r,d)}setStatusBarMessage(C,E){const r=this.c.setMessage(C);let d;return typeof E=="number"?d=setTimeout(()=>r.dispose(),E):typeof E<"u"&&E.then(()=>r.dispose(),()=>r.dispose()),new c.Disposable(()=>{r.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=S}),define(De[100],Ce([1,0,5,3,4]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(T,D){this.c=D,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,D){this.a.$registerExtensionStorageKeysToSync(T,D)}async initializeExtensionStorage(T,D,g){const L=await this.a.$initializeExtensionStorage(T,D);let k;return L&&(k=this.d(T,D,L)),k||g}setValue(T,D,g){return this.a.$setValue(T,D,g)}$acceptValue(T,D,g){const L=this.d(T,D,g);L&&this.b.fire({shared:T,key:D,value:L})}d(T,D,g){try{return JSON.parse(g)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${T}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(De[80],Ce([1,0,4,26,16,79,2]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(g,L,k){this.d=L,this.f=k,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(S=>this.c=S)}async g(g){return P.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,L=await this.g(g);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this.c)return P.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return P.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([We(0,A.IExtHostInitDataService),We(1,u.ILogService),We(2,R.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(De[41],Ce([1,0,3,5,4,2,20,6,7,186,9,218,21,30,219,52,10,19,13]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class w{constructor(i,n,h,b){this.k=i,this._id=n,this.l=h,this.m=b,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(O=>this.f=O);const p=this;this.value={get name(){return p.m||""},get processId(){return p.b},get creationOptions(){return p.l},get exitStatus(){return p.h},get state(){return p.j},sendText(O,W=!0){p.o(),p.k.$sendText(p._id,O,W)},show(O){p.o(),p.k.$show(p._id,O)},hide(){p.o(),p.k.$hide(p._id)},dispose(){p.a||(p.a=!0,p.k.$dispose(p._id))},get dimensions(){if(!(p.d===void 0||p.g===void 0))return{columns:p.d,rows:p.g}}}}async create(i,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,r.withNullAsUndefined)(i.shellPath),shellArgs:(0,r.withNullAsUndefined)(i.shellArgs),cwd:(0,r.withNullAsUndefined)(i.cwd),env:(0,r.withNullAsUndefined)(i.env),icon:(0,r.withNullAsUndefined)(a(i.iconPath)),color:E.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,r.withNullAsUndefined)(i.message),strictEnv:(0,r.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,r.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,r.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this.n(i.location,n?.resolvedExtHostIdentifier),isTransient:(0,r.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,n,h,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:E.ThemeColor.isThemeColor(b)?b.id:void 0,location:this.n(i,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,n){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in i?{viewColumn:f.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,n){this.h=Object.freeze({code:i,reason:n})}setDimensions(i,n){return i===this.d&&n===this.g||i===0||n===0?!1:(this.d=i,this.g=n,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(n=>{n!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=w;class y{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${n}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,n){this.g.setDimensions?.({columns:i,rows:n})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(n=>this.a.fire(n)),this.g.onDidClose?.((n=void 0)=>{this.f.fire(n===void 0?void 0:n)}),this.g.onDidOverrideDimensions?.(n=>{n&&this.d.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this.g.onDidChangeName?.(n=>{this.d.fire({type:"title",value:n})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let m=1,t=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,n){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new c.Emitter,this.onDidCloseTerminal=this.z.event,this.C=new c.Emitter,this.onDidOpenTerminal=this.C.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=n.getProxy(A.MainContext.MainThreadTerminalService),this.q=new C.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.D({dispose:()=>{for(const[h,b]of this.g)b.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,n){const h=new w(this.a,(0,I.generateUuid)(),i,i.name),b=new y(i.pty);return h.createExtensionTerminal(i.location,this.L(i,n).resolvedExtHostIdentifier,a(i.iconPath),l(i.color)).then(p=>{const O=this.M(p,b);this.h[p]=O}),this.f.push(h),h.value}L(i,n){if(n=n||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const h=i.location.parentTerminal;if(h){const b=this.f.find(p=>p.value===h);b&&(n.resolvedExtHostIdentifier=b._id)}}else i.location&&typeof i.location!="object"?n.location=i.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(i,n){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const b=new y(n),p=this.M(i,b);this.h[i]=p}async $acceptActiveTerminalChanged(i){const n=this.b;if(i===null){this.b=void 0,n!==this.b&&this.F.fire(this.b);return}const h=this.O(i);h&&(this.b=h,n!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,n){const h=this.O(i);h&&this.I.fire({terminal:h.value,data:n})}async $acceptTerminalDimensions(i,n,h){const b=this.O(i);b&&b.setDimensions(n,h)&&this.G.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(i,n,h){this.g.get(i)?.resize(n,h)}async $acceptTerminalTitleChange(i,n){const h=this.O(i);h&&(h.name=n)}async $acceptTerminalClosed(i,n,h){const b=this.Q(this.f,i);if(b!==null){const p=this.f.splice(b,1)[0];p.setExitStatus(n,h),this.z.fire(p.value)}}$acceptTerminalOpened(i,n,h,b){if(n){const W=this.Q(this.f,n);if(W!==null){this.f[W]._id=i,this.C.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const p={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:R.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},O=new w(this.a,i,p,h);this.f.push(O),this.C.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(i,n){this.O(i)?._setProcessId(n)}async $startExtensionTerminal(i,n){const h=this.O(i);if(!h)return{message:(0,g.localize)(0,null,i)};h.isOpen||await new Promise(p=>{const O=this.onDidOpenTerminal(async W=>{W===h.value&&(O.dispose(),p())})});const b=this.g.get(i);b?b.startSendingEvents(n):this.j[i]={initialDimensions:n}}M(i,n){const h=new T.DisposableStore;h.add(n.onProcessReady(p=>this.a.$sendProcessReady(i,p.pid,p.cwd))),h.add(n.onDidChangeProperty(p=>this.a.$sendProcessProperty(i,p))),this.q.startBuffering(i,n.onProcessData),h.add(n.onProcessExit(p=>this.N(i,p))),this.g.set(i,n);const b=this.j[i];return b&&n instanceof y&&(n.startSendingEvents(b.initialDimensions),delete this.j[i]),h}$acceptProcessAckDataEvent(i,n){this.g.get(i)?.acknowledgeDataEvent(n)}$acceptProcessInput(i,n){this.g.get(i)?.input(n)}$acceptTerminalInteraction(i){const n=this.O(i);n?.setInteractedWith()&&this.H.fire(n.value)}$acceptProcessResize(i,n,h){try{this.g.get(i)?.resize(n,h)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(i,n){this.g.get(i)?.shutdown(n)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(n=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(n=>this.a.$sendProcessProperty(i,{type:"cwd",value:n}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.s.add(i),this.s.size===1&&this.a.$startLinkProvider(),new D.Disposable(()=>{this.s.delete(i),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,n,h){if(this.u.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this.u.set(n,h),this.a.$registerProfileProvider(n,i.identifier.value),new D.Disposable(()=>{this.u.delete(n),this.a.$unregisterProfileProvider(n)})}registerTerminalQuickFixProvider(i,n,h){if(this.v.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.v.set(i,h),this.a.$registerQuickFixProvider(i,n),new D.Disposable(()=>{this.v.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,n){const h=new S.CancellationTokenSource().token;if(h.isCancellationRequested)return;const b=this.v.get(i);if(!b)return;const p=await b.provideTerminalQuickFixes(n,h);if(p!==null)return p}async $createContributedProfileTerminal(i,n){const h=new S.CancellationTokenSource().token;let b=await this.u.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(b&&!("options"in b)&&(b={options:b}),!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,n);return}this.createTerminalFromOptions(b.options,n)}}async $provideLinks(i,n){const h=this.O(i);if(!h)return[];this.w.delete(i),this.y.get(i)?.dispose(!0);const p=new S.CancellationTokenSource;this.y.set(i,p);const O=[],W={terminal:h.value,line:n},q=[];for(const M of this.s)q.push(d.Promises.withAsyncBody(async B=>{p.token.onCancellationRequested(()=>B({provider:M,links:[]}));const U=await M.provideTerminalLinks(W,p.token)||[];p.token.isCancellationRequested||B({provider:M,links:U})}));const Y=await Promise.all(q);if(p.token.isCancellationRequested)return[];const x=new Map;for(const M of Y)M&&M.links.length>0&&O.push(...M.links.map(B=>{const U={id:m++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return x.set(U.id,{provider:M.provider,link:B}),U}));return this.w.set(i,x),O}$activateLink(i,n){const h=this.w.get(i)?.get(n);!h||h.provider.handleTerminalLink(h.link)}N(i,n){this.q.stopBuffering(i),this.g.delete(i),delete this.j[i];const h=this.h[i];h&&(h.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,n)}O(i){return this.P(this.f,i)}P(i,n){const h=this.Q(i,n);return h!==null?i[h]:null}Q(i,n){let h=null;return i.some((b,p)=>b._id===n?(h=p,!0):!1),h}getEnvironmentVariableCollection(i){let n=this.l.get(i.identifier.value);return n||(n=new o,this.S(i.identifier.value,n)),n}R(i,n){const h=(0,k.serializeEnvironmentVariableCollection)(n.map);this.a.$setEnvironmentVariableCollection(i,n.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(n=>{const h=n[0],b=new o(n[1]);this.S(h,b)})}$acceptDefaultProfile(i,n){const h=this.m;this.m=i,this.n=n,h?.path!==i.path&&this.J.fire(i.path)}S(i,n){this.l.set(i,n),n.onDidChangeCollection(()=>{this.R(i,n)})}};t=Ve([We(1,P.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class o{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,n){this.d(i,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(i,n){this.d(i,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(i,n){this.d(i,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}d(i,n){const h=this.map.get(i);(!h||h.value!==n.value||h.type!==n.type)&&(this.map.set(i,n),this.b.fire())}get(i){return this.map.get(i)}forEach(i,n){this.map.forEach((h,b)=>i.call(n,b,h,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends t{constructor(i){super(!1,i)}createTerminal(i,n,h){throw new L.NotSupportedError}createTerminalFromOptions(i,n){throw new L.NotSupportedError}};s=Ve([We(0,P.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function a(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function l(v){return E.ThemeColor.isThemeColor(v)?v:void 0}});var Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(De[280],Ce([1,0,17,19,22,21,3,63,68,6,23,10,30,5,20,138,13,7,57,95,76,27]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(M,B,U){this.j=U,this.c=new P.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(I.MainContext.MainThreadTesting),this.h=new W(this.f),this.g=new i(this.f),B.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const he=j,ie=he.tests[he.tests.length-1].item.extId;return this.d.get(f.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,E.toItemFromContext)(j)}})}createTestController(M,B,U,j){if(this.d.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const he=new g.DisposableStore,ie=he.add(new E.ExtHostTestItemCollection(B,U,this.j));ie.root.label=U;const V=new Map,J=this.f,ne={items:ie.root.children,get label(){return U},set label(ue){U=ue,ie.root.label=ue,J.$updateController(B,{label:U})},get refreshHandler(){return j},set refreshHandler(ue){j=ue,J.$updateController(B,{canRefresh:!!ue})},get id(){return B},createRunProfile:(ue,ee,N,K,le,me)=>{let ke=(0,D.hash)(ue);for(;V.has(ke);)ke++;return me!==void 0&&(0,m.checkProposedApiEnabled)(M,"testContinuousRun"),new q(this.f,V,B,ke,ue,ee,N,K,le,me)},createTestItem(ue,ee,N){return new E.TestItemImpl(B,ue,ee,N)},createTestRun:(ue,ee,N=!0)=>this.g.createTestRun(B,ie,ue,ee,N),set resolveHandler(ue){ie.resolveHandler=ue},get resolveHandler(){return ie.resolveHandler},dispose:()=>{he.dispose()}};J.$registerTestController(B,U,!!j),he.add((0,g.toDisposable)(()=>J.$unregisterTestController(B)));const ve={controller:ne,collection:ie,profiles:V};return this.d.set(B,ve),he.add((0,g.toDisposable)(()=>this.d.delete(B))),he.add(ie.onDidGenerateDiff(ue=>J.$publishDiff(B,ue.map(y.TestsDiffOp.serialize)))),ne}createTestObserver(){return this.h.checkout()}async runTests(M,B=R.CancellationToken.None){const U=n(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(U.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(he=>f.TestId.fromExtHostTestItem(he,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:Y[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(he=>he.id)},B)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,B,U){return(0,c.mapFind)(this.g.trackers,he=>he.id===M?he.getCoverage(B):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,B,U,j){return(0,c.mapFind)(this.g.trackers,ie=>ie.id===M?ie.getCoverage(B):void 0)?.resolveFileCoverage(U,j)??Promise.resolve([])}$configureRunProfile(M,B){this.d.get(M)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(M,B){await this.d.get(M)?.controller.refreshHandler?.(B)}$publishTestResults(M){this.results=Object.freeze(M.map(B=>(0,L.deepFreeze)(r.TestResults.to(B))).concat(this.results).sort((B,U)=>U.completedAt-B.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,B){const U=this.d.get(f.TestId.fromString(M).controllerId)?.collection;U&&(await U.expand(M,B<0?1/0:B),U.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(y.TestsDiffOp.deserialize))}async $runControllerTests(M,B){return Promise.all(M.map(U=>this.k(U,!1,B)))}async $startContinuousRun(M,B){const U=new R.CancellationTokenSource(B),j=await Promise.all(M.map(he=>this.k(he,!0,U.token)));return!B.isCancellationRequested&&!j.some(he=>he.error)&&await new Promise(he=>B.onCancellationRequested(he)),U.dispose(!0),j}async k(M,B,U){const j=this.d.get(M.controllerId);if(!j)return{};const{collection:he,profiles:ie}=j,V=ie.get(M.profileId);if(!V)return{};const J=M.testIds.map(ee=>he.tree.get(ee)).filter(k.isDefined),ne=M.excludeExtIds.map(ee=>j.collection.tree.get(ee)).filter(k.isDefined).filter(ee=>J.some(N=>N.fullId.compare(ee.fullId)===2));if(!J.length)return{};const ve=new d.TestRunRequest2(J.some(ee=>ee.actual instanceof E.TestItemRootImpl)?void 0:J.map(ee=>ee.actual),ne.map(ee=>ee.actual),V,B),ue=(0,y.isStartControllerTests)(M)&&this.g.prepareForMainThreadTestRun(ve,h.fromInternal(M,j.collection),U);try{return await V.runHandler(ve,U),{}}catch(ee){return{error:String(ee)}}finally{ue&&(ue.hasRunningTasks&&!U.isCancellationRequested&&await P.Event.toPromise(ue.onEnd),ue.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};s=Ve([We(0,C.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var l;(function(x){x[x.Running=0]="Running",x[x.Cancelling=1]="Cancelling",x[x.Ended=2]="Ended"})(l||(l={}));class v extends g.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,B,U){super(),this.k=M,this.l=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.D(new P.Emitter),this.onEnd=this.j.event,this.h=this.D(new R.CancellationTokenSource(U));const j=this.D(new A.RunOnceScheduler(()=>this.m(),a));this.D(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const B=this.k.id,U=this.k.controllerId,j=(0,S.generateUuid)(),he=new b(this.l,B,j),ie=ve=>(ue,...ee)=>{if(J){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ue)||(this.q(ue),ve(ue,...ee))},V=(ve,ue)=>{const ee=ue instanceof Array?ue.map(r.TestMessage.from):[r.TestMessage.from(ue)];if(ve.uri&&ve.range){const N={range:r.Range.from(ve.range),uri:ve.uri};for(const K of ee)K.location=K.location||N}this.l.$appendTestMessagesInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),ee)};let J=!1;const ne={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return he.coverageProvider},set coverageProvider(ve){he.coverageProvider=ve},enqueued:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),1)}),skipped:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),5)}),started:ie(ve=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),2)}),errored:ie((ve,ue,ee)=>{V(ve,ue),this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),6,ee)}),failed:ie((ve,ue,ee)=>{V(ve,ue),this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,U).toString(),4,ee)}),passed:ie((ve,ue)=>{this.l.$updateTestStateInRun(B,j,f.TestId.fromExtHostTestItem(ve,this.k.controllerId).toString(),3,ue)}),appendOutput:(ve,ue,ee)=>{J||(ee&&(this.k.isIncluded(ee)?this.q(ee):ee=void 0),this.l.$appendOutputToRun(B,j,u.VSBuffer.fromString(ve),ue&&r.location.from(ue),ee&&f.TestId.fromExtHostTestItem(ee,U).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(B,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ne,coverage:he}),this.l.$startedTestRunTask(B,{id:j,name:M,running:!0}),ne}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}q(M){if(!(M instanceof E.TestItemImpl))throw new w.InvalidTestItemError(M.id);if(this.g.has(f.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const B=[],U=this.k.colllection.root;for(;;){const j=r.TestItem.from(M);if(B.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),M===U))break;M=M.parent||U}this.l.$addTestsToRun(this.k.controllerId,this.k.id,B)}}class i{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,B,U){return this.f(M,B,U)}cancelRunById(M){for(const B of this.c.values())if(B.id===M){B.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,B,U,j,he){const ie=this.c.get(U);if(ie)return ie.createRun(j);const V=h.fromPublic(M,B,U,he),J=n(U);this.d.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:J&&{group:Y[J.kind],id:J.profileId},exclude:U.exclude?.map(ve=>f.TestId.fromExtHostTestItem(ve,B.root.id).toString())??[],id:V.id,include:U.include?.map(ve=>f.TestId.fromExtHostTestItem(ve,B.root.id).toString())??[B.root.id],persist:he});const ne=this.f(U,V);return ne.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),ne.dispose()}),ne.createRun(j)}f(M,B,U){const j=new v(B,this.d,U);return this.c.set(M,j),j.onEnd(()=>this.c.delete(M)),j}}e.TestRunCoordinator=i;const n=x=>{if(!!x.profile){if(!(x.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return x.profile}};class h{static fromPublic(M,B,U,j){return new h(M,(0,S.generateUuid)(),U.include?.map(he=>f.TestId.fromExtHostTestItem(he,M).toString())??[M],U.exclude?.map(he=>f.TestId.fromExtHostTestItem(he,M).toString())??[],j,B)}static fromInternal(M,B){return new h(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,B)}constructor(M,B,U,j,he,ie){this.controllerId=M,this.id=B,this.isPersisted=he,this.colllection=ie,this.c=U.map(V=>V+"\0"),this.d=j.map(V=>V+"\0")}isIncluded(M){const B=f.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.d)if(B===U||B.startsWith(U))return!1;for(const U of this.c)if(B===U||B.startsWith(U))return!0;return!1}}e.TestRunDto=h;class b{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,B,U){this.f=M,this.g=B,this.h=U}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(r.TestCoverage.fromFile)??[]}catch(B){throw this.d=void 0,B}}async resolveFileCoverage(M,B){const U=await this.d;let j=U?.[M];return!this.c||!U||!j?[]:(j.detailedCoverage||(j=U[M]=await this.c.resolveFileCoverage?.(j,B)??j),j.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class p{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,r.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const B=f.TestId.parentId(M.item.extId);if(B&&this.g.has(B.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:B,f:U}=this;return{get added(){return[...M].map(j=>j.revived)},get updated(){return[...B].map(j=>j.revived)},get removed(){return[...U].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class O extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new P.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,B){return{...M,revived:r.TestItem.toPlain(M.item),depth:B?B.depth+1:0,children:new Set}}o(){return new p(this.q)}}class W{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(B=>B.revived)},dispose:(0,T.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new O;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class q{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?r.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Me(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,B,U,j,he,ie,V,J=!1,ne=void 0,ve=!1){this.controllerId=U,this.profileId=j,this.d=he,this.kind=ie,this.runHandler=V,this.f=J,this._tag=ne,this.g=ve,t.set(this,void 0),o.set(this,void 0),_e(this,t,M,"f"),_e(this,o,B,"f"),B.set(j,this);const ue=Y[ie];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Me(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:U,tag:ne?r.TestTag.namespace(this.controllerId,ne.id):null,label:he,group:ue,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ve})}dispose(){Me(this,o,"f")?.delete(this.profileId)&&(_e(this,o,void 0,"f"),Me(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,t=new WeakMap,o=new WeakMap;const Y={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(De[281],Ce([1,0,17,9,3,5,139,13,7]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class g{constructor(k,S){this.i=S,this.a=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.b=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.c=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.d=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.f=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.g=new u.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(R.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(I=>this.g.fire(I)),this.i.onDidChangeActiveTextEditor(I=>this.f.fire(I))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const S=this.i.allEditors();return k?S:S.map(I=>I.value)}async showTextDocument(k,S,I){let C;typeof S=="number"?C={position:T.ViewColumn.from(S),preserveFocus:I}:typeof S=="object"?C={position:T.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?T.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:C={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(k.uri,C),r=E&&this.i.getEditor(E);if(r)return r.value;throw E?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,S){return new P.TextEditorDecorationType(this.h,k,S).value}$acceptEditorPropertiesChanged(k,S){const I=this.i.getEditor(k);if(!I)throw new Error("unknown text editor");if(S.options&&I._acceptOptions(S.options),S.selections){const C=S.selections.selections.map(T.Selection.to);I._acceptSelections(C)}if(S.visibleRanges){const C=c.coalesce(S.visibleRanges.map(T.Range.to));I._acceptVisibleRanges(C)}if(S.options&&this.b.fire({textEditor:I.value,options:{...S.options,lineNumbers:T.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const C=D.TextEditorSelectionChangeKind.fromValue(S.selections.source),E=S.selections.selections.map(T.Selection.to);this.a.fire({textEditor:I.value,selections:E,kind:C})}if(S.visibleRanges){const C=c.coalesce(S.visibleRanges.map(T.Range.to));this.c.fire({textEditor:I.value,visibleRanges:C})}}$acceptEditorPositionData(k){for(const S in k){const I=this.i.getEditor(S);if(!I)throw new Error("Unknown text editor");const C=T.ViewColumn.to(k[S]);I.value.viewColumn!==C&&(I._acceptViewColumn(C),this.d.fire({textEditor:I.value,viewColumn:C}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.ExtHostEditors=g}),define(De[282],Ce([1,0,2,4,5,6,7,13,25,10]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(I,C){this.b=new Map,this.c=new Map,this.a=I.getProxy(u.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(E,r)=>{if(E&&E.$mid===12)if(this.b.get(E.source)&&D.ExtensionIdentifier.equals(r,this.b.get(E.source)?.extension)){const d=E.uri===void 0?void 0:c.URI.revive(E.uri);return this.c.get(E.source)?.get(k(d))?.get(E.handle)}else return;return E}})}async $getTimeline(I,C,E,r){return this.b.get(I)?.provider.provideTimeline(c.URI.revive(C),E,r)}registerTimelineProvider(I,C,E,r){const d=new R.DisposableStore,f=this.d(C.id,r,d).bind(this);let w;C.onDidChange&&(w=C.onDidChange(m=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...m,id:C.id}),this));const y=this.c;return this.f({...C,scheme:I,onDidChange:void 0,async provideTimeline(m,t,o){t?.resetCache&&(d.clear(),y.get(C.id)?.clear());const s=await C.provideTimeline(m,t,o);if(s==null)return;const a=f(m,t);return{...s,source:C.id,items:s.items.map(a)}},dispose(){for(const m of y.values())m.get(C.id)?.clear();w?.dispose(),d.dispose()}},E)}d(I,C,E){return(r,d)=>{let f;if(d?.cacheResults){let w=this.c.get(I);w===void 0&&(w=new Map,this.c.set(I,w));const y=k(r);f=w.get(y),f===void 0&&(f=new Map,w.set(y,f))}return w=>{const{iconPath:y,...m}=w,t=`${I}|${w.id??w.timestamp}`;f?.set(t,w);let o,s,a;w.iconPath&&(y instanceof P.ThemeIcon?a={id:y.id,color:y.color}:c.URI.isUri(y)?(o=y,s=y):{light:o,dark:s}=y);let l;return P.MarkdownString.isMarkdownString(m.tooltip)?l=T.MarkdownString.from(m.tooltip):(0,g.isString)(m.tooltip)?l=m.tooltip:P.MarkdownString.isMarkdownString(m.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=T.MarkdownString.from(m.detail)):(0,g.isString)(m.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=m.detail),{...m,id:m.id??void 0,handle:t,source:I,command:w.command?C.toInternal(w.command,E):void 0,icon:o,iconDark:s,themeIcon:a,tooltip:l,accessibilityInformation:w.accessibilityInformation}}}}f(I,C){if(this.b.get(I.id))throw new Error(`Timeline Provider ${I.id} already exists.`);return this.a.$registerTimelineProvider({id:I.id,label:I.label,scheme:I.scheme}),this.b.set(I.id,{provider:I,extension:C}),(0,R.toDisposable)(()=>{for(const r of this.c.values())r.get(I.id)?.clear();this.b.delete(I.id),this.a.$unregisterTimelineProvider(I.id),I.dispose()})}}e.ExtHostTimeline=L;function k(S){return S?.toString()}}),define(De[283],Ce([1,0,6,18,2,5]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(D){this.c=new Map,this.b=D.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,g,L,k){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const S=k.schemes.find(I=>!P.a.has(I));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this.c.set(g,L),this.b.$registerUriOpener(g,k.schemes,D,k.label),(0,c.toDisposable)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,L){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const S=u.URI.revive(g);return k.canOpenExternalUri(S,L)}async $openUri(D,g,L){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(u.URI.revive(g.resolvedUri),{sourceUri:u.URI.revive(g.sourceUri)},L)}}P.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=P}),define(De[284],Ce([1,0,5,2,6,9,25]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(g){this.c=new P.ExtensionIdentifierSet,this.d=new Map,this.b=g.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(g,L){if(this.c.has(g))throw new Error(`Protocol handler already registered for extension ${g}`);const k=T.a++;return this.c.add(g),this.d.set(k,L),this.b.$registerUriHandler(k,g),(0,u.toDisposable)(()=>{this.c.delete(g),this.d.delete(k),this.b.$unregisterUriHandler(k)})}$handleExternalUri(g,L){const k=this.d.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(A.URI.revive(L))}catch(S){(0,R.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(g){return A.URI.revive(await this.b.$createAppUri(g))}}T.a=0,e.ExtHostUrls=T});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[81],Ce([1,0,3,18,23,2,202,227,96,5]),function(re,e,c,A,u,R,P,T,D,g){"use strict";var L,k,S,I,C,E,r,d,f,w,y,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(p,O,W,q,Y,x,M){L.set(this,void 0),k.set(this,void 0),S.set(this,void 0),I.set(this,void 0),C.set(this,void 0),E.set(this,void 0),r.set(this,""),d.set(this,void 0),f.set(this,!1),w.set(this,!1),y.set(this,void 0),m.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new c.Emitter),this._onDidDispose=Me(this,t,"f").event,_e(this,L,p,"f"),_e(this,k,O,"f"),_e(this,d,W,"f"),_e(this,I,q,"f"),_e(this,C,Y,"f"),_e(this,E,x,"f"),_e(this,y,s(x),"f"),_e(this,m,a(x),"f"),_e(this,S,M,"f")}dispose(){_e(this,f,!0,"f"),Me(this,t,"f").fire(),Me(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return _e(this,w,!0,"f"),(0,D.asWebviewUri)(p,Me(this,I,"f"))}get cspSource(){const p=Me(this,E,"f").extensionLocation;if(p.scheme===A.Schemas.https||p.scheme===A.Schemas.http){let O=p.toString();return O.endsWith("/")||(O+="/"),O+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.a(),Me(this,r,"f")}set html(p){this.a(),Me(this,r,"f")!==p&&(_e(this,r,p,"f"),Me(this,m,"f")&&!Me(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(_e(this,w,!0,"f"),Me(this,S,"f").report("Webview vscode-resource: uris",Me(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,k,"f").$setHtml(Me(this,L,"f"),this.b(p)))}get options(){return this.a(),Me(this,d,"f")}set options(p){this.a(),u.equals(Me(this,d,"f"),p)||Me(this,k,"f").$setOptions(Me(this,L,"f"),i(Me(this,E,"f"),Me(this,C,"f"),p)),_e(this,d,p,"f")}async postMessage(p){if(Me(this,f,"f"))return!1;const O=(0,T.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Me(this,y,"f")});return Me(this,k,"f").$postMessage(Me(this,L,"f"),O.message,...O.buffers)}a(){if(Me(this,f,"f"))throw new Error("Webview is disposed")}b(p){if(!Me(this,m,"f"))return p;const O=Me(this,E,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,W=Me(this,E,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Me(this,E,"f").extensionLocation.authority:void 0;return p.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,Y,x,M,B,U)=>{const j=R.URI.from({scheme:M||"file",path:decodeURIComponent(B)}),he=(0,D.asWebviewUri)(j,{isRemote:O,authority:W}).toString();return`${Y}${he}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,Y,x,M,B,U)=>{const j=R.URI.from({scheme:M||"file",path:decodeURIComponent(B)}),he=(0,D.asWebviewUri)(j,{isRemote:O,authority:W}).toString();return`${Y}${he}${U}`})}}e.ExtHostWebview=o,L=new WeakMap,k=new WeakMap,S=new WeakMap,I=new WeakMap,C=new WeakMap,E=new WeakMap,r=new WeakMap,d=new WeakMap,f=new WeakMap,w=new WeakMap,y=new WeakMap,m=new WeakMap,t=new WeakMap;function s(b){try{const p=(0,P.normalizeVersion)((0,P.parseVersion)(b.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function a(b){try{const p=(0,P.normalizeVersion)((0,P.parseVersion)(b.engines.vscode));return p?p.majorBase<1||p.majorBase===1&&p.minorBase<60:!1}catch{return!1}}class l{constructor(p,O,W,q,Y){this.c=O,this.d=W,this.e=q,this.f=Y,this.b=new Map,this.a=p.getProxy(g.MainContext.MainThreadWebviews)}$onMessage(p,O,W){const q=this.g(p);if(q){const{message:Y}=(0,T.deserializeWebviewMessage)(O,W.value);q._onMessageEmitter.fire(Y)}}$onMissingCsp(p,O){this.e.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,O,W){const q=new o(p,this.a,n(O),this.c,this.d,W,this.f);return this.b.set(p,q),q._onDidDispose(()=>{this.b.delete(p)}),q}deleteWebview(p){this.b.delete(p)}g(p){return this.b.get(p)}}e.ExtHostWebviews=l;function v(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=v;function i(b,p,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||h(b,p)}}e.serializeWebviewOptions=i;function n(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(p=>R.URI.from(p))}}function h(b,p){return[...(p?.getWorkspaceFolders()||[]).map(O=>O.uri),b.extensionLocation]}}),define(De[285],Ce([1,0,21,68,6,18,24,2,13,81,75,5,7]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=m(this.document.uri)+this.a++;return(0,P.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class C{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,a){const l=this.b(o,s.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const v=new I(s,a);return this.a.set(l,v),v}delete(o,s){const a=this.b(o,s.uri);this.a.delete(a)}b(o,s){return`${o}@@@${s}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class r{constructor(){this.a=new Map}addTextProvider(o,s,a){return this.b(0,o,s,a)}addCustomProvider(o,s,a){return this.b(1,o,s,a)}get(o){return this.a.get(o)}b(o,s,a,l){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:a,provider:l}),new S.Disposable(()=>this.a.delete(s))}}class d{constructor(o,s,a,l,v){this.d=s,this.f=a,this.g=l,this.h=v,this.b=new r,this.c=new C,this.a=o.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,a,l){const v=new u.DisposableStore;return w(a)?(v.add(this.b.addTextProvider(s,o,a)),this.a.$registerTextEditorProvider((0,g.toExtensionData)(o),s,l.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,g.shouldSerializeBuffersForPostMessage)(o))):(v.add(this.b.addCustomProvider(s,o,a)),f(a)&&v.add(a.onDidChangeCustomDocument(i=>{const n=this.i(s,i.document.uri);if(y(i)){const h=n.addEdit(i);this.a.$onDidEdit(i.document.uri,s,h,i.label)}else this.a.$onContentChange(i.document.uri,s)})),this.a.$registerCustomEditorProvider((0,g.toExtensionData)(o),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,g.shouldSerializeBuffersForPostMessage)(o))),S.Disposable.from(v,new S.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,a,l,v){const i=this.b.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${s}'`);const n=T.URI.revive(o),h=await i.provider.openCustomDocument(n,{backupId:a,untitledDocumentData:l?.buffer},v);let b;return f(i.provider)&&this.f&&(b=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(s,h,b),{editable:f(i.provider)}}async $disposeCustomDocument(o,s){const a=this.b.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=T.URI.revive(o),{document:v}=this.i(s,l);this.c.delete(s,v),v.dispose()}async $resolveCustomEditor(o,s,a,l,v,i){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);const h=D.ViewColumn.to(v),b=this.g.createNewWebview(s,l.contentOptions,n.extension),p=this.h.createNewWebviewPanel(s,a,l.title,h,l.options,b,!0),O=T.URI.revive(o);switch(n.type){case 1:{const{document:W}=this.i(a,O);return n.provider.resolveCustomEditor(W,p,i)}case 0:{const W=this.d.getDocument(O);return n.provider.resolveCustomTextEditor(W,p,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,a){this.i(s,o).disposeEdits(a)}async $onMoveCustomEditor(o,s,a){const l=this.b.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const v=this.h.getWebviewPanel(o);if(!v)throw new Error("No webview found");const i=T.URI.revive(s),n=this.d.getDocument(i);await l.provider.moveCustomTextEditor(n,v,c.CancellationToken.None)}async $undo(o,s,a,l){return this.i(s,o).undo(a,l)}async $redo(o,s,a,l){return this.i(s,o).redo(a,l)}async $revert(o,s,a){const l=this.i(s,o);await this.j(s).revertCustomDocument(l.document,a),l.disposeBackup()}async $onSave(o,s,a){const l=this.i(s,o);await this.j(s).saveCustomDocument(l.document,a),l.disposeBackup()}async $onSaveAs(o,s,a,l){const v=this.i(s,o);return this.j(s).saveCustomDocumentAs(v.document,T.URI.revive(a),l)}async $backup(o,s,a){const l=this.i(s,o),i=await this.j(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},a);return l.updateBackup(i),i.id}i(o,s){const a=this.c.get(o,T.URI.revive(s));if(!a)throw new Error("No custom document found");return a}j(o){const a=this.b.get(o)?.provider;if(!a||!f(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=d;function f(t){return!!t.onDidChangeCustomDocument}function w(t){return typeof t.resolveCustomTextEditor=="function"}function y(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function m(t){const o=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,A.hash)(o)+""}});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[286],Ce([1,0,3,6,2,30,13,81,5,7]),function(re,e,c,A,u,R,P,T,D,g){"use strict";var L,k,S,I,C,E,r,d,f,w,y,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(v,i,n,h){super(),L.set(this,void 0),k.set(this,void 0),S.set(this,void 0),I.set(this,void 0),C.set(this,void 0),E.set(this,void 0),r.set(this,void 0),d.set(this,void 0),f.set(this,!0),w.set(this,void 0),y.set(this,!1),m.set(this,this.D(new c.Emitter)),this.onDidDispose=Me(this,m,"f").event,t.set(this,this.D(new c.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,_e(this,L,v,"f"),_e(this,k,i,"f"),_e(this,I,n,"f"),_e(this,S,h.viewType,"f"),_e(this,C,h.panelOptions,"f"),_e(this,d,h.viewColumn,"f"),_e(this,E,h.title,"f"),_e(this,w,h.active,"f")}dispose(){Me(this,y,"f")||(_e(this,y,!0,"f"),Me(this,m,"f").fire(),Me(this,k,"f").$disposeWebview(Me(this,L,"f")),Me(this,I,"f").dispose(),super.dispose())}get webview(){return this.c(),Me(this,I,"f")}get viewType(){return this.c(),Me(this,S,"f")}get title(){return this.c(),Me(this,E,"f")}set title(v){this.c(),Me(this,E,"f")!==v&&(_e(this,E,v,"f"),Me(this,k,"f").$setTitle(Me(this,L,"f"),v))}get iconPath(){return this.c(),Me(this,r,"f")}set iconPath(v){this.c(),Me(this,r,"f")!==v&&(_e(this,r,v,"f"),Me(this,k,"f").$setIconPath(Me(this,L,"f"),u.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Me(this,C,"f")}get viewColumn(){if(this.c(),!(typeof Me(this,d,"f")=="number"&&Me(this,d,"f")<0))return Me(this,d,"f")}get active(){return this.c(),Me(this,w,"f")}get visible(){return this.c(),Me(this,f,"f")}_updateViewState(v){Me(this,y,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(_e(this,w,v.active,"f"),_e(this,f,v.visible,"f"),_e(this,d,v.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(v,i){this.c(),Me(this,k,"f").$reveal(Me(this,L,"f"),{viewColumn:typeof v>"u"?void 0:P.ViewColumn.from(v),preserveFocus:!!i})}c(){if(Me(this,y,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,S=new WeakMap,I=new WeakMap,C=new WeakMap,E=new WeakMap,r=new WeakMap,d=new WeakMap,f=new WeakMap,w=new WeakMap,y=new WeakMap,m=new WeakMap,t=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(v,i,n){this.g=i,this.h=n,this.e=new Map,this.f=new Map,this.d=v.getProxy(D.MainContext.MainThreadWebviewPanels)}createWebviewPanel(v,i,n,h,b={}){const p=typeof h=="object"?h.viewColumn:h,O={viewColumn:P.ViewColumn.from(p),preserveFocus:typeof h=="object"&&!!h.preserveFocus},W=(0,T.shouldSerializeBuffersForPostMessage)(v),q=s.c();this.d.$createWebviewPanel((0,T.toExtensionData)(v),q,i,{title:n,panelOptions:a(b),webviewOptions:(0,T.serializeWebviewOptions)(v,this.h,b),serializeBuffersForPostMessage:W},O);const Y=this.g.createNewWebview(q,b,v);return this.createNewWebviewPanel(q,i,n,p,b,Y,!0)}$onDidChangeWebviewPanelViewStates(v){const i=Object.keys(v);i.sort((n,h)=>{const b=v[n],p=v[h];return b.active?1:p.active?-1:+b.visible-+p.visible});for(const n of i){const h=this.getWebviewPanel(n);if(!h)continue;const b=v[n];h._updateViewState({active:b.active,visible:b.visible,viewColumn:P.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.e.delete(v),this.g.deleteWebview(v)}registerWebviewPanelSerializer(v,i,n){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:n,extension:v}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(v)}),new g.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(v,i,n,h){const b=this.f.get(i);if(!b)throw new Error(`No serializer found for '${i}'`);const{serializer:p,extension:O}=b,W=this.g.createNewWebview(v,n.webviewOptions,O),q=this.createNewWebviewPanel(v,i,n.title,h,n.panelOptions,W,n.active);await p.deserializeWebviewPanel(q,n.state)}createNewWebviewPanel(v,i,n,h,b,p,O){const W=new o(v,this.d,p,{viewType:i,title:n,viewColumn:h,panelOptions:b,active:O});return this.e.set(v,W),W}getWebviewPanel(v){return this.e.get(v)}}e.ExtHostWebviewPanels=s;function a(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[287],Ce([1,0,3,6,81,13,5,7]),function(re,e,c,A,u,R,P,T){"use strict";var D,g,L,k,S,I,C,E,r,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends A.Disposable{constructor(t,o,s,a,l,v){super(),D.set(this,void 0),g.set(this,void 0),L.set(this,void 0),k.set(this,void 0),S.set(this,!1),I.set(this,void 0),C.set(this,void 0),E.set(this,void 0),r.set(this,void 0),d.set(this,this.D(new c.Emitter)),this.onDidChangeVisibility=Me(this,d,"f").event,f.set(this,this.D(new c.Emitter)),this.onDidDispose=Me(this,f,"f").event,_e(this,L,s,"f"),_e(this,C,a,"f"),_e(this,D,t,"f"),_e(this,g,o,"f"),_e(this,k,l,"f"),_e(this,I,v,"f")}dispose(){Me(this,S,"f")||(_e(this,S,!0,"f"),Me(this,f,"f").fire(),Me(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Me(this,C,"f")}set title(t){this.a(),Me(this,C,"f")!==t&&(_e(this,C,t,"f"),Me(this,g,"f").$setWebviewViewTitle(Me(this,D,"f"),t))}get description(){return this.a(),Me(this,E,"f")}set description(t){this.a(),Me(this,E,"f")!==t&&(_e(this,E,t,"f"),Me(this,g,"f").$setWebviewViewDescription(Me(this,D,"f"),t))}get visible(){return Me(this,I,"f")}get webview(){return Me(this,k,"f")}get viewType(){return Me(this,L,"f")}_setVisible(t){t===Me(this,I,"f")||Me(this,S,"f")||(_e(this,I,t,"f"),Me(this,d,"f").fire())}get badge(){return this.a(),Me(this,r,"f")}set badge(t){this.a(),!(t?.value===Me(this,r,"f")?.value&&t?.tooltip===Me(this,r,"f")?.tooltip)&&(_e(this,r,R.ViewBadge.from(t),"f"),Me(this,g,"f").$setWebviewViewBadge(Me(this,D,"f"),t))}show(t){this.a(),Me(this,g,"f").$show(Me(this,D,"f"),!!t)}a(){if(Me(this,S,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,g=new WeakMap,L=new WeakMap,k=new WeakMap,S=new WeakMap,I=new WeakMap,C=new WeakMap,E=new WeakMap,r=new WeakMap,d=new WeakMap,f=new WeakMap;class y{constructor(t,o){this.d=o,this.b=new Map,this.c=new Map,this.a=t.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,o,s,a){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:t}),this.a.$registerWebviewViewProvider((0,u.toExtensionData)(t),o,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(t,o,s,a,l){const v=this.b.get(o);if(!v)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:n}=v,h=this.d.createNewWebview(t,{},n),b=new w(t,this.a,o,s,h,!0);this.c.set(t,b),await i.resolveWebviewView(b,{state:a},l)}async $onDidChangeWebviewViewVisibility(t,o){this.e(t)._setVisible(o)}async $disposeWebviewView(t){const o=this.e(t);this.c.delete(t),o.dispose(),this.d.deleteWebview(t)}e(t){const o=this.c.get(t);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=y}),define(De[142],Ce([1,0,3,5,2,18,8,4,20]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let g=class dn{get state(){return this.d}constructor(k){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=dn.a,this.b=k.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}$onDidChangeWindowFocus(k){k!==this.d.focused&&(this.d={...this.d,focused:k},this.c.fire(this.d))}openUri(k,S){let I;if(typeof k=="string"){I=k;try{k=u.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,P.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,I,S)}async asExternalUri(k,S){if((0,P.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this.b.$asExternalUri(k,S);return u.URI.from(I)}};g.a={focused:!0},g=Ve([We(0,D.IExtHostRpcService)],g),e.ExtHostWindow=g,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(De[288],Ce([1,0,120,289,71,40,2,16,48]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(S,I,C){this.b=S,this.c=I,this.f=C,this.a=A.createServer((E,r)=>this.h(E,r)),this.g().catch(E=>(I.error(E),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",S=>this.c.error(S))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(S,I){const C=(r,d)=>{I.writeHead(r,{"content-type":"application/json"}),I.end(JSON.stringify(d||null),f=>f&&this.c.error(f))},E=[];S.setEncoding("utf8"),S.on("data",r=>E.push(r)),S.on("end",async()=>{try{const r=JSON.parse(E.join(""));let d;switch(r.type){case"open":d=await this.i(r);break;case"openExternal":d=await this.j(r);break;case"status":d=await this.l(r);break;case"extensionManagement":d=await this.k(r);break;default:C(404,`Unknown message type: ${r.type}`);break}C(200,d)}catch(r){const d=r instanceof Error?r.message:JSON.stringify(r);C(500,d),this.c.error("Error while processing pipe request",r)}})}async i(S){const{fileURIs:I,folderURIs:C,forceNewWindow:E,diffMode:r,mergeMode:d,addMode:f,forceReuseWindow:w,gotoLineMode:y,waitMarkerFilePath:m,remoteAuthority:t}=S,o=[];if(Array.isArray(C))for(const v of C)try{o.push({folderUri:P.URI.parse(v)})}catch{}if(Array.isArray(I))for(const v of I)try{(0,D.hasWorkspaceFileExtension)(v)?o.push({workspaceUri:P.URI.parse(v)}):o.push({fileUri:P.URI.parse(v)})}catch{}const s=m?P.URI.file(m):void 0,l={forceNewWindow:E,diffMode:r,mergeMode:d,addMode:f,gotoLineMode:y,forceReuseWindow:w,preferNewWindow:!w&&!s&&!f,waitMarkerFileURI:s,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",o,l),""}async j(S){for(const I of S.uris){const C=P.URI.parse(I),E=C.scheme==="file"?C:I;await this.b.executeCommand("_remoteCLI.openExternal",E)}}async k(S){const I=E=>E?.map(r=>/\.vsix$/i.test(r)?P.URI.parse(r):r),C={list:S.list,install:I(S.install),uninstall:I(S.uninstall),force:S.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(S){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&u.existsSync(this.f)&&u.unlinkSync(this.f)}}e.CLIServerBase=g;let L=class extends g{constructor(S,I){super(S,I,(0,c.createRandomIPCHandle)())}};L=Ve([We(0,R.IExtHostCommands),We(1,T.ILogService)],L),e.CLIServer=L}),define(De[290],Ce([1,0,258,26,20]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let P=class extends c.AbstractExtHostConsoleForwarder{constructor(D,g){super(D,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(D,g,L){const k=D==="error"||D==="warn"?process.stderr:process.stdout;this.g=!0,k.write(`
START_NATIVE_LOG
`),g.apply(console,L),k.write(`
END_NATIVE_LOG
`),this.g=!1}j(D,g){const L=process[D],k=L.write;let S="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(I,C,E)=>{if(!this.g){S+=I.toString(C);const r=S.length>R?S.length:S.lastIndexOf(`
`);r!==-1&&(console[g](S.slice(0,r)),S=S.slice(r+1))}k.call(L,I,C,E)}})}};P=Ve([We(0,u.IExtHostRpcService),We(1,A.IExtHostInitDataService)],P),e.ExtHostConsoleForwarder=P}),define(De[291],Ce([1,0,12,89,30,40,6,5,2,20]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(S,I){super();const C=S.getProxy(T.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async E=>{const r=D.URI.file((0,c.join)((0,A.tmpdir)(),(0,u.generateUuid)()));return await C.$download(E,r),r})}};L=Ve([We(0,g.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(De[292],Ce([1,0,141,18,209,30]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends c.ExtHostLoggerService{m(D,g,L){return D.scheme===A.Schemas.file?new u.SpdLogLogger(L?.name||(0,R.generateUuid)(),D.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,g):super.m(D,g,L)}registerLogger(D){super.registerLogger(D),this.n.$registerLogger(D)}deregisterLogger(D){super.deregisterLogger(D),this.n.$deregisterLogger(D)}}e.ExtHostLoggerService=P}),define(De[293],Ce([1,0,71,12,2,80,6,18,19,29]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const o=await super.g(t);if(o.scheme!==T.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let a=0;do{let l;a===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${a}`:`${s}-${a}`,await k(l);const v=A.join(l,"vscode.lock"),i=await E(this.d,v,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),u.URI.file(l);a++}while(a<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(m){try{await g.Promises.stat(m);return}catch{}try{await g.Promises.mkdir(m,{recursive:!0})}catch{}}const S=1e3,I=10*60*1e3;class C extends P.Disposable{constructor(t,o){super(),this.b=t,this.c=o,this.a=this.D(new D.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await r(t,o);(!s||s.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(o,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${o}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function E(m,t,o){try{const a={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){m.error(a)}const s=await r(m,t);return!s||s.pid!==process.pid?o?(m.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),w(m,t)):(m.info(`Lock '${t}': Lock acquired.`),new C(m,t))}async function r(m,t){let o;try{o=await g.Promises.readFile(t)}catch(s){return m.error(s),null}try{return JSON.parse(String(o))}catch(s){return m.error(s),null}}async function d(m,t){let o;try{o=await g.Promises.stat(t)}catch(s){return m.error(s),0}return o.mtime.getTime()}function f(m){try{return process.kill(m,0),!0}catch{return!1}}async function w(m,t){const o=await r(m,t);if(!o)return m.info(`Lock '${t}': Could not read pid of lock holder.`),y(m,t);if(o.willReleaseAt){let i=o.willReleaseAt-Date.now();if(i<5e3){for(i>0?m.info(`Lock '${t}': The lockfile is scheduled to be released in ${i} ms.`):m.info(`Lock '${t}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,D.timeout)(Math.min(100,i)),await d(m,t)===0)return y(m,t);i=o.willReleaseAt-Date.now()}return y(m,t)}}if(!f(o.pid))return m.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),y(m,t);const s=await d(m,t),a=Date.now()-s;if(a<=I)return m.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;m.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const l=await d(m,t),v=Date.now()-l;return v<=I?(m.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(m.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),y(m,t))}async function y(m,t){m.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return E(m,t,!0)}}),define(De[294],Ce([1,0,30,20,41]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends u.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,D,g){return this.createTerminalFromOptions({name:T,shellPath:D,shellArgs:g})}createTerminalFromOptions(T,D){const g=new u.ExtHostTerminal(this.a,(0,c.generateUuid)(),T,T.name);return this.f.push(g),g.create(T,this.L(T,D)),g.value}};R=Ve([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(De[295],Ce([1,0,5,20,190,6,26,2,47,24,29,7,11,55,3,130,103,16]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class f extends E.DisposableTunnel{}function w(i){const n=i.trim().split(`
`),h=[];return n.forEach(p=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(p);O&&O.length>=3&&h.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),h.reduce((p,O)=>(p[O.socket]=O,p),{})}e.getSockets=w;function y(...i){const n=[].concat(...i.map(t));return[...new Map(n.filter(h=>h.st==="0A").map(h=>{const b=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(b[0]),port:parseInt(b[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=y;function m(i){let n="";if(i.length===8)for(let h=i.length-2;h>=0;h-=2)n+=parseInt(i.substr(h,2),16),h!==0&&(n+=".");else for(let h=i.length-4;h>=0;h-=4)n+=parseInt(i.substr(h,4),16).toString(16),h!==0&&(n+=":");return n}function t(i){const n=i.trim().split(`
`),h=n.shift().trim().split(/\s+/).filter(p=>p!=="rx_queue"&&p!=="tm->when");return n.map(p=>p.trim().split(/\s+/).reduce((O,W,q)=>(O[h[q]||q]=W,O),{}))}e.loadConnectionTable=t;function o(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function s(i){const n=i.trim().split(`
`),h=[];return n.forEach(b=>{const p=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);p&&p.length>=4&&h.push({pid:parseInt(p[1],10),ppid:parseInt(p[2]),cmd:p[3]})}),h}e.getRootProcesses=s;async function a(i,n,h){const b=h.reduce((O,W)=>(O[W.pid]=W,O),{}),p=[];return i.forEach(({socket:O,ip:W,port:q})=>{const Y=n[O]?n[O].pid:void 0,x=Y?b[Y]?.cmd:void 0;Y&&x&&!o(x)&&p.push({host:W,port:q,detail:x,pid:Y})}),p}e.findPorts=a;function l(i,n,h){const b=new Map,p=s(n);for(const O of i){const W=h.get(O.port);if(W){b.set(O.port,W);continue}const q=p.find(Y=>Y.cmd.includes(`${O.port}`));if(q){let Y=q,x;do x=p.find(M=>M.ppid===Y.pid),x&&(Y=x);while(x);b.set(O.port,{host:O.ip,port:O.port,pid:Y.pid,detail:Y.cmd,ppid:Y.ppid})}else b.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=l;let v=class extends R.Disposable{constructor(n,h,b){super(),this.n=b,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new C.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=n.getProxy(c.MainContext.MainThreadTunnelService),S.isLinux&&h.remote.isRemote&&h.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(n,h){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const b=await this.a.$openTunnel(h,n.displayName);if(b){const p=new f(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.D(p),p}}async getTunnels(){return this.a.$getTunnels()}p(n){return Math.max(n*20,2e3)}q(){return this.k++}registerPortsAttributesProvider(n,h){const b=this.q();return this.l.set(b,{selector:n,provider:h}),this.a.$registerPortsAttributesProvider(n,b),new k.Disposable(()=>{this.l.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(n,h,b,p,O){const W=[];for(const Y of n){const x=this.l.get(Y);if(!x)return[];W.push(...await Promise.all(h.map(async M=>x.provider.providePortAttributes(M,b,p,O))))}const q=W.filter(Y=>!!Y);return q.length>0?q.map(Y=>({autoForwardAction:Y.autoForwardAction,port:Y.port})):[]}async $registerCandidateFinder(n){if(n&&this.h)return;this.h=n;const h=new r.MovingAverage;let b;for(;this.h;){const p=new Date().getTime(),O=(await this.findCandidatePorts()).filter(q=>(0,E.isLocalhost)(q.host)||(0,E.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(q=>q.port).join(", ")}`);const W=new Date().getTime()-p;h.update(W),(!b||JSON.stringify(b)!==JSON.stringify(O))&&(b=O,await this.a.$onFoundNewCandidates(b)),await new Promise(q=>setTimeout(()=>q(),this.p(h.value)))}}async setTunnelFactory(n){if(n){if(n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.c=n.showCandidatePort,this.a.$setCandidateFilter()),n.tunnelFactory){this.b=n.tunnelFactory;let h=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const b=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:h}:void 0;this.a.$setTunnelProvider(b)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(n,h){if(this.f.has(n.host)){const b=this.f.get(n.host);b.has(n.port)&&(h&&b.get(n.port).disposeListener.dispose(),await b.get(n.port).tunnel.dispose(),b.delete(n.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(n,h){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(n,h);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const p=await b;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(n.remoteAddress.host)||this.f.set(n.remoteAddress.host,new Map);const O=this.D(p.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(p.remoteAddress))));return this.f.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:p,disposeListener:O}),I.TunnelDtoConverter.fromApiTunnel(p)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(n){const h=await Promise.all(n.map(p=>this.c(p.host,p.port,p.detail??""))),b=n.filter((p,O)=>h[O]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(p=>p.port).join(", ")} to ${b.map(p=>p.port).join(", ")}`),b}async findCandidatePorts(){let n="",h="";try{n=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const b=y(n,h),p=await new Promise(U=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,he,ie)=>{U(he)})}),O=w(p),W=await L.Promises.readdir("/proc"),q=[];for(const U of W)try{const j=Number(U),he=g.joinPath(T.URI.file("/proc"),U);if((await L.Promises.stat(he.fsPath)).isDirectory()&&!isNaN(j)){const V=await L.Promises.readlink(g.joinPath(he,"cwd").fsPath),J=await L.Promises.readFile(g.joinPath(he,"cmdline").fsPath,"utf8");q.push({pid:j,cwd:V,cmd:J})}}catch{}const Y=[],x=b.filter(U=>{const j=O[U.socket];return j||Y.push(U),j}),M=a(x,O,q);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Y.length}`),Y.length>0){const U=await new Promise(j=>{(0,D.exec)("ps -F -A -l | grep root",(he,ie,V)=>{j(ie)})});this.j=l(Y,U,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(j=>j.port).join(", ")}`)}return M.then(U=>B?U.concat(B):U)}};v=Ve([We(0,A.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,d.ILogService)],v),e.ExtHostTunnelService=v}),define(De[296],Ce([1,0,19,22,21,9,3,6,115,252,58]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(b,p){try{return JSON.stringify(b,p)}catch{return"null"}}const I="$$ref$$",C={[I]:-1};class E{constructor(p,O){this.jsonString=p,this.referencedBuffers=O}}function r(b,p=null,O=!1){const W=[];return{jsonString:(O?S:JSON.stringify)(b,(Y,x)=>{if(typeof x>"u")return C;if(typeof x=="object"){if(x instanceof A.VSBuffer){const M=W.push(x)-1;return{[I]:M}}if(p)return p(Y,x)}return x}),referencedBuffers:W}}e.stringifyJsonWithBufferRefs=r;function d(b,p,O){return JSON.parse(b,(W,q)=>{if(q){const Y=q[I];if(typeof Y=="number")return p[Y];if(O&&q.$mid===1)return O.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=d;function f(b,p){return JSON.stringify(b,p)}function w(b){return b?(p,O)=>O&&O.$mid===1?b.transformOutgoing(O):O:null}var y;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class a extends T.Disposable{constructor(p,O=null,W=null){super(),this[k]=!0,this.b=this.D(new P.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=p,this.f=O,this.g=W,this.h=w(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,Y=L.ProxyIdentifier.count;q<Y;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.q={},this.s=0,this.t=0,this.u=0,this.v=this.D(new c.RunOnceScheduler(()=>this.z(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.q).forEach(p=>{this.q[p].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}w(p){this.t===0&&(this.u=Date.now()+a.a),this.t++,this.v.isScheduled()||this.v.schedule()}y(p){this.u=Date.now()+a.a,this.t--,this.t===0&&this.v.cancel(),this.C(0)}z(){this.t!==0&&(Date.now()>this.u?this.C(1):this.v.schedule())}C(p){this.s!==p&&(this.s=p,this.b.fire(this.s))}get responsiveState(){return this.s}transformIncomingURIs(p){return this.g?(0,D.transformIncomingURIs)(p,this.g):p}getProxy(p){const{nid:O,sid:W}=p;return this.l[O]||(this.l[O]=this.F(O,W)),this.l[O]}F(p,O){const W={get:(q,Y)=>(typeof Y=="string"&&!q[Y]&&Y.charCodeAt(0)===36&&(q[Y]=(...x)=>this.O(p,Y,x)),Y===s?O:q[Y])};return new Proxy(Object.create(null),W)}set(p,O){return this.k[p.nid]=O,O}assertRegistered(p){for(let O=0,W=p.length;O<W;O++){const q=p[O];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(p){if(this.j)return;const O=p.byteLength,W=l.read(p,0),q=W.readUInt8(),Y=W.readUInt32();switch(q){case 1:case 2:{let{rpcId:x,method:M,args:B}=i.deserializeRequestJSONArgs(W);this.g&&(B=(0,D.transformIncomingURIs)(B,this.g)),this.H(O,Y,x,M,B,q===2);break}case 3:case 4:{let{rpcId:x,method:M,args:B}=i.deserializeRequestMixedArgs(W);this.g&&(B=(0,D.transformIncomingURIs)(B,this.g)),this.H(O,Y,x,M,B,q===4);break}case 5:{this.f?.logIncoming(O,Y,0,"ack"),this.y(Y);break}case 6:{this.I(O,Y);break}case 7:{this.J(O,Y,void 0);break}case 9:{let x=i.deserializeReplyOKJSON(W);this.g&&(x=(0,D.transformIncomingURIs)(x,this.g)),this.J(O,Y,x);break}case 10:{const x=i.deserializeReplyOKJSONWithBuffers(W,this.g);this.J(O,Y,x);break}case 8:{const x=i.deserializeReplyOKVSBuffer(W);this.J(O,Y,x);break}case 11:{let x=i.deserializeReplyErrError(W);this.g&&(x=(0,D.transformIncomingURIs)(x,this.g)),this.L(O,Y,x);break}case 12:{this.L(O,Y,void 0);break}default:console.error("received unexpected message"),console.error(p)}}H(p,O,W,q,Y,x){this.f?.logIncoming(p,O,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(W)}.${q}(`,Y);const M=String(O);let B,U;if(x){const he=new u.CancellationTokenSource;Y.push(he.token),B=this.M(W,q,Y),U=()=>he.cancel()}else B=this.M(W,q,Y),U=t;this.p[M]=U;const j=i.serializeAcknowledged(O);this.f?.logOutgoing(j.byteLength,O,1,"ack"),this.c.send(j),B.then(he=>{delete this.p[M];const ie=i.serializeReplyOK(O,he,this.h);this.f?.logOutgoing(ie.byteLength,O,1,"reply:",he),this.c.send(ie)},he=>{delete this.p[M];const ie=i.serializeReplyErr(O,he);this.f?.logOutgoing(ie.byteLength,O,1,"replyErr:",he),this.c.send(ie)})}I(p,O){this.f?.logIncoming(p,O,1,"receiveCancel");const W=String(O);this.p[W]?.()}J(p,O,W){this.f?.logIncoming(p,O,0,"receiveReply:",W);const q=String(O);if(!this.q.hasOwnProperty(q))return;const Y=this.q[q];delete this.q[q],Y.resolveOk(W)}L(p,O,W){this.f?.logIncoming(p,O,0,"receiveReplyErr:",W);const q=String(O);if(!this.q.hasOwnProperty(q))return;const Y=this.q[q];delete this.q[q];let x;W&&(W.$isError?(x=new Error,x.name=W.name,x.message=W.message,x.stack=W.stack):x=W),Y.resolveErr(x)}M(p,O,W){try{return Promise.resolve(this.N(p,O,W))}catch(q){return Promise.reject(q)}}N(p,O,W){const q=this.k[p];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(p));const Y=q[O];if(typeof Y!="function")throw new Error("Unknown method "+O+" on actor "+(0,L.getStringIdentifierForProxy)(p));return Y.apply(q,W)}O(p,O,W){if(this.j)return new g.CanceledLazyPromise;let q=null;if(W.length>0&&u.CancellationToken.isCancellationToken(W[W.length-1])&&(q=W.pop()),q&&q.isCancellationRequested)return Promise.reject(R.canceled());const Y=i.serializeRequestArguments(W,this.h),x=++this.m,M=String(x),B=new g.LazyPromise;q&&q.onCancellationRequested(()=>{const j=i.serializeCancel(x);this.f?.logOutgoing(j.byteLength,x,0,"cancel"),this.c.send(i.serializeCancel(x))}),this.q[M]=B,this.w(x);const U=i.serializeRequest(x,p,O,Y,!!q);return this.f?.logOutgoing(U.byteLength,x,0,`request: ${(0,L.getStringIdentifierForProxy)(p)}.${O}(`,W),this.c.send(U),B}}k=o,a.a=3*1e3,e.RPCProtocol=a;class l{static alloc(p,O,W){const q=new l(A.VSBuffer.alloc(W+1+4),0);return q.writeUInt8(p),q.writeUInt32(O),q}static read(p,O){return new l(p,O)}get buffer(){return this.a}constructor(p,O){this.a=p,this.b=O}static sizeUInt8(){return 1}writeUInt8(p){this.a.writeUInt8(p,this.b),this.b+=1}readUInt8(){const p=this.a.readUInt8(this.b);return this.b+=1,p}writeUInt32(p){this.a.writeUInt32BE(p,this.b),this.b+=4}readUInt32(){const p=this.a.readUInt32BE(this.b);return this.b+=4,p}static sizeShortString(p){return 1+p.byteLength}writeShortString(p){this.a.writeUInt8(p.byteLength,this.b),this.b+=1,this.a.set(p,this.b),this.b+=p.byteLength}readShortString(){const p=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+p).toString();return this.b+=p,W}static sizeLongString(p){return 4+p.byteLength}writeLongString(p){this.a.writeUInt32BE(p.byteLength,this.b),this.b+=4,this.a.set(p,this.b),this.b+=p.byteLength}readLongString(){const p=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+p).toString();return this.b+=p,W}writeBuffer(p){this.a.writeUInt32BE(p.byteLength,this.b),this.b+=4,this.a.set(p,this.b),this.b+=p.byteLength}static sizeVSBuffer(p){return 4+p.byteLength}writeVSBuffer(p){this.a.writeUInt32BE(p.byteLength,this.b),this.b+=4,this.a.set(p,this.b),this.b+=p.byteLength}readVSBuffer(){const p=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+p);return this.b+=p,O}static sizeMixedArray(p){let O=0;O+=1;for(let W=0,q=p.length;W<q;W++){const Y=p[W];switch(O+=1,Y.type){case 1:O+=this.sizeLongString(Y.value);break;case 2:O+=this.sizeVSBuffer(Y.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(Y.value);for(let x=0;x<Y.buffers.length;++x)O+=this.sizeVSBuffer(Y.buffers[x]);break;case 4:break}}return O}writeMixedArray(p){this.a.writeUInt8(p.length,this.b),this.b+=1;for(let O=0,W=p.length;O<W;O++){const q=p[O];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let Y=0;Y<q.buffers.length;++Y)this.writeBuffer(q.buffers[Y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const p=this.a.readUInt8(this.b);this.b+=1;const O=new Array(p);for(let W=0;W<p;W++)switch(this.readUInt8()){case 1:O[W]=this.readLongString();break;case 2:O[W]=this.readVSBuffer();break;case 3:{const Y=this.readUInt32(),x=this.readLongString(),M=[];for(let B=0;B<Y;++B)M.push(this.readVSBuffer());O[W]=new L.SerializableObjectWithBuffers(d(x,M,null));break}case 4:O[W]=void 0;break}return O}}l.sizeUInt32=4;var v;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(v||(v={}));class i{static a(p){for(let O=0,W=p.length;O<W;O++)if(p[O]instanceof A.VSBuffer||p[O]instanceof L.SerializableObjectWithBuffers||typeof p[O]>"u")return!0;return!1}static serializeRequestArguments(p,O){if(this.a(p)){const W=[];for(let q=0,Y=p.length;q<Y;q++){const x=p[q];if(x instanceof A.VSBuffer)W[q]={type:2,value:x};else if(typeof x>"u")W[q]={type:4};else if(x instanceof L.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=r(x.value,O);W[q]={type:3,value:A.VSBuffer.fromString(M),buffers:B}}else W[q]={type:1,value:A.VSBuffer.fromString(f(x,O))}}return{type:1,args:W}}return{type:0,args:f(p,O)}}static serializeRequest(p,O,W,q,Y){switch(q.type){case 0:return this.b(p,O,W,q.args,Y);case 1:return this.c(p,O,W,q.args,Y)}}static b(p,O,W,q,Y){const x=A.VSBuffer.fromString(W),M=A.VSBuffer.fromString(q);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(x),B+=l.sizeLongString(M);const U=l.alloc(Y?2:1,p,B);return U.writeUInt8(O),U.writeShortString(x),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(p){const O=p.readUInt8(),W=p.readShortString(),q=p.readLongString();return{rpcId:O,method:W,args:JSON.parse(q)}}static c(p,O,W,q,Y){const x=A.VSBuffer.fromString(W);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString(x),M+=l.sizeMixedArray(q);const B=l.alloc(Y?4:3,p,M);return B.writeUInt8(O),B.writeShortString(x),B.writeMixedArray(q),B.buffer}static deserializeRequestMixedArgs(p){const O=p.readUInt8(),W=p.readShortString(),q=p.readMixedArray(),Y=new Array(q.length);for(let x=0,M=q.length;x<M;x++){const B=q[x];typeof B=="string"?Y[x]=JSON.parse(B):Y[x]=B}return{rpcId:O,method:W,args:Y}}static serializeAcknowledged(p){return l.alloc(5,p,0).buffer}static serializeCancel(p){return l.alloc(6,p,0).buffer}static serializeReplyOK(p,O,W){if(typeof O>"u")return this.d(p);if(O instanceof A.VSBuffer)return this.e(p,O);if(O instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:Y}=r(O.value,W,!0);return this.g(p,q,Y)}else return this.f(p,S(O,W))}static d(p){return l.alloc(7,p,0).buffer}static e(p,O){let W=0;W+=l.sizeVSBuffer(O);const q=l.alloc(8,p,W);return q.writeVSBuffer(O),q.buffer}static deserializeReplyOKVSBuffer(p){return p.readVSBuffer()}static f(p,O){const W=A.VSBuffer.fromString(O);let q=0;q+=l.sizeLongString(W);const Y=l.alloc(9,p,q);return Y.writeLongString(W),Y.buffer}static g(p,O,W){const q=A.VSBuffer.fromString(O);let Y=0;Y+=l.sizeUInt32,Y+=l.sizeLongString(q);for(const M of W)Y+=l.sizeVSBuffer(M);const x=l.alloc(10,p,Y);x.writeUInt32(W.length),x.writeLongString(q);for(const M of W)x.writeBuffer(M);return x.buffer}static deserializeReplyOKJSON(p){const O=p.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(p,O){const W=p.readUInt32(),q=p.readLongString(),Y=[];for(let x=0;x<W;++x)Y.push(p.readVSBuffer());return new L.SerializableObjectWithBuffers(d(q,Y,O))}static serializeReplyErr(p,O){const W=O?S(R.transformErrorForSerialization(O),null):void 0;if(typeof W!="string")return this.h(p);const q=A.VSBuffer.fromString(W);let Y=0;Y+=l.sizeLongString(q);const x=l.alloc(11,p,Y);return x.writeLongString(q),x.buffer}static deserializeReplyErrError(p){const O=p.readLongString();return JSON.parse(O)}static h(p){return l.alloc(12,p,0).buffer}}var n;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(n||(n={}));var h;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(h||(h={}))}),define(De[297],Ce([1,0,3,39,44,4]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var P;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(L=>g.push(L)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}A.Registry.add(e.Extensions.OutputChannels,new T),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(De[143],Ce([1,0,5,4,20,25,16,297,79,26,49,159,22,10,45,3,6]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends P.AbstractMessageLogger{get disposed(){return this.l}constructor(m,t,o,s,a){super(),this.id=m,this.name=t,this.m=o,this.n=s,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.D(o.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(m){this.append(m+`
`)}append(m){this.info(m)}clear(){const m=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,m)}replace(m){const t=this.k;this.info(m),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(m,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof m=="boolean"?m:t))}hide(){this.n.$close(this.id)}g(m,t){this.k+=S.VSBuffer.fromString(t).byteLength,(0,P.log)(this.m,m,t),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class f extends d{appendLine(m){this.append(m)}}let w=class{constructor(m,t,o,s,a,l){this.i=t,this.j=o,this.k=s,this.l=a,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=m.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.h=m;for(const[t,o]of this.g)o.visible=t===this.h}createOutputChannel(m,t,o){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,a=(0,I.isString)(t)?t:void 0;if((0,I.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const v=this.i.environment.extensionLogLevel?.find(([n])=>R.ExtensionIdentifier.equals(o.identifier,n))?.[1];v&&(l=(0,P.parseLogLevel)(v));const i=s?this.o(m,l,o):this.n(m,a,o);return i.then(n=>{this.g.set(n.id,n),n.visible=n.id===this.h}),s?this.r(m,l??this.m.getLevel(),i):this.q(m,i)}async n(m,t,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,a=this.k.extUri.joinPath(s,`${this.f++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(m,a,t,o.identifier.value);return new d(v,m,l,this.a,o)}async o(m,t,o){const s=await this.p(o),a=m.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(s,`${a}.log`),v=`${o.identifier.value}.${a}`,i=this.l.createLogger(l,{id:v,name:m,logLevel:t,extensionId:o.identifier.value});return new f(v,m,i,this.a,o)}p(m){let t=this.d.get(m.identifier.value);if(!t){const o=this.k.extUri.joinPath(this.i.logsLocation,m.identifier.value);this.d.set(m.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return t}q(m,t){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return m},append(a){s(),t.then(l=>l.append(a))},appendLine(a){s(),t.then(l=>l.appendLine(a))},clear(){s(),t.then(a=>a.clear())},replace(a){s(),t.then(l=>l.replace(a))},show(a,l){s(),t.then(v=>v.show(a,l))},hide(){s(),t.then(a=>a.hide())},dispose(){o=!0,t.then(a=>a.dispose())}}}r(m,t,o){const s=new r.DisposableStore,a=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new E.Emitter);function v(i){t=i,l.fire(i)}return o.then(i=>{s.add(i),i.logLevel!==t&&v(i.logLevel),s.add(i.onDidChangeLogLevel(n=>v(n)))}),{...this.q(m,o),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(i,...n){a(),o.then(h=>h.trace(i,...n))},debug(i,...n){a(),o.then(h=>h.debug(i,...n))},info(i,...n){a(),o.then(h=>h.info(i,...n))},warn(i,...n){a(),o.then(h=>h.warn(i,...n))},error(i,...n){a(),o.then(h=>h.error(i,...n))},dispose(){s.dispose()}}}};w=Ve([We(0,u.IExtHostRpcService),We(1,g.IExtHostInitDataService),We(2,D.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,P.ILoggerService),We(5,P.ILogService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(De[298],Ce([1,0,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(De[299],Ce([1,0,33,18,12,11,24,2,4,222,48,240,298]),function(re,e,c,A,u,R,P,T,D,g,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let I=class hn{constructor(E,r,d,f){this.d=E,this.e=r,this.f=d,this.g=f,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const w=await this.e.getEnvironment();return this.c=w?.userHome??E})()}hasValidBasename(E,r,d){return typeof r=="string"||typeof r>"u"?this.a.then(f=>this.h(E,f,r)):this.h(E,r,d)}h(E,r,d){return E.scheme===A.Schemas.file||E.scheme===A.Schemas.vscodeRemote?(0,c.isValidBasename)(d??(0,P.basename)(E),r===1):!0}get defaultUriScheme(){return hn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(E,r){if(E.remoteAuthority)return A.Schemas.vscodeRemote;const d=(0,g.getVirtualWorkspaceScheme)(r.getWorkspace());if(d)return d;const f=r.getWorkspace().folders[0];if(f)return f.uri.scheme;const w=r.getWorkspace().configuration;return w?w.scheme:A.Schemas.file}userHome(E){return E?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(E=>E===1?u.win32:u.posix)}async fileURI(E){let r="";if(await this.a===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const f=E.indexOf("/",2);f===-1?(r=E.substring(2),E="/"):(r=E.substring(2,f),E=E.substring(f)||"/")}return T.URI.from({scheme:A.Schemas.file,authority:r,path:E,query:"",fragment:""})}};I=Ve([We(1,S.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(De[82],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(P,T){this.line=P,this.character=T}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,T){return new c(0,0)}with(P){return new c(0,0)}}e.Position=c;class A{constructor(P,T,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(P,T),this.end=new c(D,g)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new A(0,0,0,0)}with(P){return new A(0,0,0,0)}}e.Range=A;var u;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(u=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[31],Ce([1,0,17,38,23,33,8,4,12,9,82,19]),function(re,e,c,A,u,R,P,T,D,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",I=" characters skipped \u27EB",C=(S.length+I.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var E;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(E=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function d(J){return!!J.preview}e.resultIsMatch=d;function f(J){return!!J.resource}e.isFileMatch=f;function w(J){return!!J.message}e.isProgressMessage=w;var y;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(y=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=m;class t{constructor(ne,ve,ue){this.ranges=ve;const ee=Array.isArray(ve)?ve:[ve];if(ue&&ue.matchLines===1&&o(ee)){ne=(0,P.getNLines)(ne,ue.matchLines);let N="",K=0,le=0;const me=Math.floor(ue.charsPerLine/5),ke=[];for(const Z of ee){const ce=Math.max(Z.startColumn-me,0),de=Z.startColumn+ue.charsPerLine;if(ce>le+me+C){const te=S+(ce-le)+I;N+=te+ne.slice(ce,de),K+=ce-(le+te.length)}else N+=ne.slice(le,de);ke.push(new a(0,Z.startColumn-K,Z.endColumn-K)),le=de}this.preview={text:N,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const N=Array.isArray(ve)?ve[0].startLineNumber:ve.startLineNumber;this.preview={text:ne,matches:(0,c.mapArrayOrNot)(ve,K=>new s(K.startLineNumber-N,K.startColumn,K.endLineNumber-N,K.endColumn))}}}}e.TextSearchMatch=t;function o(J){const ne=J[0].startLineNumber;for(const ve of J)if(ve.startLineNumber!==ne||ve.endLineNumber!==ne)return!1;return!0}class s{constructor(ne,ve,ue,ee){this.startLineNumber=ne,this.startColumn=ve,this.endLineNumber=ue,this.endColumn=ee}}e.SearchRange=s;class a extends s{constructor(ne,ve,ue){super(ne,ve,ne,ue)}}e.OneLineRange=a;var l;(function(J){J.List="list",J.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var v;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function i(J,ne=!0){const ve=J&&J.files&&J.files.exclude,ue=ne&&J&&J.search&&J.search.exclude;if(!ve&&!ue)return;if(!ve||!ue)return ve||ue;let ee=Object.create(null);return ee=u.mixin(ee,u.deepClone(ve)),ee=u.mixin(ee,u.deepClone(ue),!0),ee}e.getExcludes=i;function n(J,ne){return J.excludePattern&&A.match(J.excludePattern,ne)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,ne)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ve=>{const ue=ve.folder.fsPath;if(R.isEqualOrParent(ne,ue)){const ee=D.relative(ue,ne);return!ve.includePattern||!!A.match(ve.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var h;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(ne,ve){super(ne),this.code=ve}}e.SearchError=b;function p(J){const ne=J.message;if((0,g.isCancellationError)(J))return new b(ne,h.canceled);try{const ve=JSON.parse(ne);return new b(ve.message,ve.code)}catch{return new b(ne,h.other)}}e.deserializeSearchError=p;function O(J){const ne={message:J.message,code:J.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=O;function W(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=W;function q(J){return J.type==="success"}e.isSerializedSearchSuccess=q;function Y(J){return!!J.path}e.isSerializedFileMatch=Y;function x(J,ne){const ve=J.searchPath?J.searchPath:J.relativePath;return(0,P.fuzzyContains)(ve,ne)}e.isFilePatternMatch=x;class M{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function B(J,ne){const ve={...J||{},...ne||{}};return Object.keys(ve).filter(ue=>{const ee=ve[ue];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=B;class U{constructor(ne,ve){this.c=null,this.a={...ne.excludePattern||{},...ve.excludePattern||{}},this.b=A.parse(this.a);let ue=ne.includePattern;ve.includePattern&&(ue?ue={...ue,...ve.includePattern}:ue=ve.includePattern),ue&&(this.c=A.parse(ue))}matchesExcludesSync(ne,ve,ue){return!!(this.b&&this.b(ne,ve,ue))}includedInQuerySync(ne,ve,ue){return!(this.b&&this.b(ne,ve,ue)||this.c&&!this.c(ne,ve,ue))}includedInQuery(ne,ve,ue){const ee=this.b(ne,ve,ue),N=()=>this.c?!!this.c(ne,ve,ue):!0;return(0,k.isThenable)(ee)?ee.then(K=>K?!1:N()):N()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=U;function j(J){for(const ne in J)if(typeof J[ne]!="boolean")return!0;return!1}function he(J){if(!J)return;let ne;return ve=>(ne||(ne=(J()||Promise.resolve([])).then(ue=>ue?V(ue):{})),ne.then(ue=>!!ue[ve]))}e.hasSiblingPromiseFn=he;function ie(J){if(!J)return;let ne;return ve=>{if(!ne){const ue=J();ne=ue?V(ue):{}}return!!ne[ve]}}e.hasSiblingFn=ie;function V(J){const ne={};for(const ve of J)ne[ve]=!0;return ne}}),define(De[34],Ce([1,0,17,19,21,3,6,69,18,103,24,8,10,2,188,4,16,210,48,49,26,20,13,7,56,31,5]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t,o,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function v(q,Y,x){return new L.ExtUri(M=>b(M,x)).isEqual(q,Y)}function i(q,Y,x){return v(q.uri,Y.uri,x)?0:(0,k.compare)(q.uri.toString(),Y.uri.toString())}function n(q,Y,x){return q.index!==Y.index?q.index<Y.index?-1:1:v(q.uri,Y.uri,x)?(0,k.compare)(q.name,Y.name):(0,k.compare)(q.uri.toString(),Y.uri.toString())}function h(q,Y,x,M){const B=q.slice(0).sort((j,he)=>x(j,he,M)),U=Y.slice(0).sort((j,he)=>x(j,he,M));return(0,c.delta)(B,U,(j,he)=>x(j,he,M))}function b(q,Y){const x=Y.getCapabilities(q.scheme);return!(x&&x&1024)}class p extends f.Workspace{static toExtHostWorkspace(Y,x,M,B){if(!Y)return{workspace:null,added:[],removed:[]};const{id:U,name:j,folders:he,configuration:ie,transient:V,isUntitled:J}=Y,ne=[],ve=x;x?he.forEach((K,le)=>{const me=I.URI.revive(K.uri),ke=p.o(M||x,me,B);ke?(ke.name=K.name,ke.index=K.index,ne.push(ke)):ne.push({uri:me,name:K.name,index:le})}):ne.push(...he.map(({uri:K,name:le,index:me})=>({uri:I.URI.revive(K),name:le,index:me}))),ne.sort((K,le)=>K.index<le.index?-1:1);const ue=new p(U,j,ne,!!V,ie?I.URI.revive(ie):null,!!J,K=>b(K,B)),{added:ee,removed:N}=h(ve?ve.workspaceFolders:[],ue.workspaceFolders,i,B);return{workspace:ue,added:ee,removed:N}}static o(Y,x,M){for(let B=0;B<Y.folders.length;B++){const U=Y.workspaceFolders[B];if(v(U.uri,x,M))return U}}constructor(Y,x,M,B,U,j,he){super(Y,M.map(ie=>new f.WorkspaceFolder(ie)),B,U,he),this.t=x,this.u=j,this.q=[],this.s=T.TernarySearchTree.forUris(he),M.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(Y,x){return x&&this.s.get(Y)&&(Y=(0,L.dirname)(Y)),this.s.findSubstr(Y)}resolveWorkspaceFolder(Y){return this.s.get(Y)}}let O=class{constructor(Y,x,M,B,U){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=B,this.s=M,this.t=U,this.j=new g.Counter,this.k=new A.Barrier,this.o=Y.getProxy(l.MainContext.MainThreadWorkspace),this.q=Y.getProxy(l.MainContext.MainThreadMessageService);const j=x.workspace;this.l=j?new p(j.id,j.name,[],!!j.transient,j.configuration?I.URI.revive(j.configuration):null,!!j.isUntitled,he=>b(he,M)):void 0}$initializeWorkspace(Y,x){this.v=x,this.$acceptWorkspaceData(Y),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?I.URI.from({scheme:D.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(Y,x,M,...B){const U=[];if(Array.isArray(B)&&B.forEach(J=>{I.URI.isUri(J.uri)&&!U.some(ne=>v(ne.uri,J.uri,this.s))&&U.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.n||[x,M].some(J=>typeof J!="number"||J<0)||M===0&&U.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(x+M>j.length)return!1;const he=j.slice(0);he.splice(x,M,...U.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<he.length;J++){const ne=he[J];if(he.some((ve,ue)=>ue!==J&&v(ne.uri,ve.uri,this.s)))return!1}he.forEach((J,ne)=>J.index=ne);const{added:ie,removed:V}=h(j,he,n,this.s);if(ie.length===0&&V.length===0)return!1;if(this.o){const J=Y.displayName||Y.name;this.o.$updateWorkspaceFolders(J,x,M,U).then(void 0,ne=>{this.n=void 0;const ve={source:{identifier:Y.identifier,label:Y.displayName||Y.name}};this.q.$showMessage(d.Severity.Error,(0,C.localize)(0,null,J,ne.toString()),ve,[])})}return this.y(he),!0}getWorkspaceFolder(Y,x){if(!!this.x)return this.x.getWorkspaceFolder(Y,x)}async getWorkspaceFolder2(Y,x){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(Y,x)}async resolveWorkspaceFolder(Y){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(Y)}getPath(){if(!this.x)return;const{folders:Y}=this.x;if(Y.length!==0)return Y[0].uri.fsPath}getRelativePath(Y,x){let M,B="";if(typeof Y=="string"?(M=I.URI.file(Y),B=Y):typeof Y<"u"&&(M=Y,B=Y.fsPath),!M)return B;const U=this.getWorkspaceFolder(M,!0);if(!U)return B;typeof x>"u"&&this.x&&(x=this.x.folders.length>1);let j=(0,L.relativePath)(U.uri,M);return x&&U.name&&(j=`${U.name}/${j}`),j}y(Y){this.x&&(this.n=p.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:Y,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(Y){const{workspace:x,added:M,removed:B}=p.toExtHostWorkspace(Y,this.l,this.n,this.s);this.l=x||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:B}))}findFiles(Y,x,M,B,U=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let j;if(x===null?j=!1:x&&(typeof x=="string"?j=x:j=x.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:ie}=W(t.GlobPattern.from(Y));return this.o.$startFileSearch((0,S.withUndefinedAsNull)(he),(0,S.withUndefinedAsNull)(ie),(0,S.withUndefinedAsNull)(j),(0,S.withUndefinedAsNull)(M),U).then(V=>Array.isArray(V)?V.map(J=>I.URI.revive(J)):[])}async findTextInFiles(Y,x,M,B,U=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),he=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:ie,folder:V}=W(t.GlobPattern.from(x.include)),J=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,ne={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:he,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:ie,excludePattern:J},ve=!1;if(this.u[j]=ue=>{if(ve)return;const ee=I.URI.revive(ue.resource);ue.results.forEach(N=>{(0,a.resultIsMatch)(N)?M({uri:ee,preview:{text:N.preview.text,matches:(0,c.mapArrayOrNot)(N.preview.matches,K=>new o.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))},ranges:(0,c.mapArrayOrNot)(N.ranges,K=>new o.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))}):M({uri:ee,text:N.text,lineNumber:N.lineNumber})})},U.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(Y,(0,S.withUndefinedAsNull)(V),ne,j,U);return delete this.u[j],ue||{}}catch(ue){throw delete this.u[j],ue}}$handleTextSearchResult(Y,x){this.u[x]?.(Y)}saveAll(Y){return this.o.$saveAll(Y)}resolveProxy(Y){return this.o.$resolveProxy(Y)}get trusted(){return this.v}requestWorkspaceTrust(Y){return this.o.$requestWorkspaceTrust(Y)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(Y,x){if(this.w.has(Y))throw new Error(`A provider has already been registered for scheme ${Y}`);this.w.set(Y,x);const M=this.t.transformOutgoingScheme(Y),B=this.z++;return this.o.$registerEditSessionIdentityProvider(B,M),(0,P.toDisposable)(()=>{this.w.delete(Y),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(Y,x){this.h.info("Getting edit session identifier for workspaceFolder",Y);const M=await this.resolveWorkspaceFolder(I.URI.revive(Y));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const B=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!B),!B)return;const U=await B.provideEditSessionIdentity(M,x);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(Y,x,M,B){this.h.info("Getting edit session identifier for workspaceFolder",Y);const U=await this.resolveWorkspaceFolder(I.URI.revive(Y));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const j=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!j),!j)return;const he=await j.provideEditSessionIdentityMatch?.(x,M,B);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(Y){return(x,M,B)=>{const U=function(he){x.call(M,he)};return U.extension=Y,this.A.event(U,void 0,B)}}async $onWillCreateEditSessionIdentity(Y,x,M){const B=await this.resolveWorkspaceFolder(I.URI.revive(Y));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:B},x,async(U,j)=>{const he=Date.now();await Promise.resolve(U),Date.now()-he>M&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),x.isCancellationRequested}};O=Ve([We(0,m.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,w.IExtHostFileSystemInfo),We(3,r.ILogService),We(4,s.IURITransformerService)],O),e.ExtHostWorkspace=O,e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function W(q){let Y,x;return q&&(typeof q=="string"?Y=q:(Y=q.pattern,x=I.URI.revive(q.baseUri))),{includePattern:Y,folder:x}}}),define(De[35],Ce([1,0,23,3,34,5,7,213,127,10,19,4,20,16,2]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function E(o,s){if(s){const a=s.split(".");let l=o;for(let v=0;l&&v<a.length;v++)l=l[a[v]];return l}}function r(o){return o instanceof C.URI}function d(o){return o&&o.uri instanceof C.URI&&o.languageId&&typeof o.languageId=="string"}function f(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function w(o){return o&&o.uri instanceof C.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function y(o){if(r(o))return{resource:o};if(d(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(f(o))return{overrideIdentifier:o.languageId};if(w(o))return{resource:o.uri};if(o===null)return{resource:null}}let m=class{constructor(s,a,l){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=a,this.b=l,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,a){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,a))}};m=Ve([We(0,S.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,I.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(s,a,l,v){this.a=new A.Emitter,this.b=s,this.f=v,this.c=a,this.e=T.Configuration.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,a){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(a,l))}getConfiguration(s,a,l){const v=y(a)||{},i=this.g(s?E(this.e.getValue(void 0,v,this.c.workspace),s):this.e.getValue(void 0,v,this.c.workspace));s&&this.h(s,v,l?.identifier);function n(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(b){return typeof E(i,b)<"u"},get:(b,p)=>{this.h(s?`${s}.${b}`:b,v,l?.identifier);let O=E(i,b);if(typeof O>"u")O=p;else{let W;const q=(Y,x)=>{let M;const B=()=>{W=W||(0,c.deepClone)(i),M=M||E(W,x)};return(0,g.isObject)(Y)?new Proxy(Y,{get:(U,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return B(),()=>M;if(W)return M=M||E(W,x),M[j];const he=U[j];return typeof j=="string"?q(he,`${x}.${j}`):he},set:(U,j,he)=>(B(),M&&(M[j]=he),!0),deleteProperty:(U,j)=>(B(),M&&delete M[j],!0),defineProperty:(U,j,he)=>(B(),M&&Object.defineProperty(M,j,he),!0)}):Y};O=q(O,b)}return O},update:(b,p,O,W)=>{b=s?`${s}.${b}`:b;const q=n(O);return p!==void 0?this.b.$updateConfigurationOption(q,b,p,v,W):this.b.$removeConfigurationOption(q,b,v,W)},inspect:b=>{b=s?`${s}.${b}`:b;const p=this.e.inspect(b,v,this.c.workspace);if(p)return{key:b,defaultValue:(0,c.deepClone)(p.policy?.value??p.default?.value),globalValue:(0,c.deepClone)(p.user?.value??p.application?.value),workspaceValue:(0,c.deepClone)(p.workspace?.value),workspaceFolderValue:(0,c.deepClone)(p.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(p.default?.override),globalLanguageValue:(0,c.deepClone)(p.user?.override??p.application?.override),workspaceLanguageValue:(0,c.deepClone)(p.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(p.workspaceFolder?.override),languageIds:(0,c.deepClone)(p.overrideIdentifiers)}}};return typeof i=="object"&&(0,c.mixin)(h,i,!1),Object.freeze(h)}g(s){const a=l=>(0,g.isObject)(l)?new Proxy(l,{get:(v,i)=>a(v[i]),set:(v,i,n)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(v,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(v,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return a(s)}h(s,a,l){const v=D.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),i=l?`[${l.value}] `:"";if(v===4){typeof a?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){a?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,a){const l=new T.ConfigurationChangeEvent(s,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(v,i)=>l.affectsConfiguration(v,y(i))})}k(s){return s.reduce((a,l)=>(a.set(l[0],l[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[83],Ce([1,0,2,19,3,5,7,34,59,35,21,41,20,26,4,18,11,16,78,251,9]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(Y){function x(B){if(B!=null)return B}Y.from=x;function M(B){if(B!=null)return B}Y.to=M})(t||(t={}));var o;(function(Y){function x(B){if(B!=null)return B}Y.from=x;function M(B){if(B!=null)return B}Y.to=M})(o||(o={}));var s;(function(Y){function x(B){if(B!=null)return B}Y.from=x;function M(B){if(B!=null)return B}Y.to=M})(s||(s={}));var a;(function(Y){function x(U){if(U){const j=U;return j&&!!j.process}else return!1}Y.is=x;function M(U){if(U==null)return;const j={process:U.process,args:U.args};return U.options&&(j.options=s.from(U.options)),j}Y.from=M;function B(U){if(U!=null)return new P.ProcessExecution(U.process,U.args,U.options)}Y.to=B})(a||(a={}));var l;(function(Y){function x(B){if(B!=null)return B}Y.from=x;function M(B){if(B!=null)return B}Y.to=M})(l||(l={}));var v;(function(Y){function x(U){if(U){const j=U;return j&&(!!j.commandLine||!!j.command)}else return!1}Y.is=x;function M(U){if(U==null)return;const j={};return U.commandLine!==void 0?j.commandLine=U.commandLine:(j.command=U.command,j.args=U.args),U.options&&(j.options=l.from(U.options)),j}Y.from=M;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new P.ShellExecution(U.commandLine,U.options):new P.ShellExecution(U.command,U.args?U.args:[],U.options)}Y.to=B})(v||(v={}));var i;(function(Y){function x(U){if(U){const j=U;return j&&j.customExecution==="customExecution"}else return!1}Y.is=x;function M(U){return{customExecution:"customExecution"}}Y.from=M;function B(U,j){return j.get(U)}Y.to=B})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var n;(function(Y){function x(M,B){let U;return M.scope!==void 0&&typeof M.scope!="number"?U=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===P.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=w.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:U}}Y.from=x})(n=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(Y){function x(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}Y.from=x})(h||(h={}));var b;(function(Y){function x(U,j){if(U==null)return[];const he=[];for(const ie of U){const V=M(ie,j);V&&he.push(V)}return he}Y.fromMany=x;function M(U,j){if(U==null)return;let he;U.execution instanceof P.ProcessExecution?he=a.from(U.execution):U.execution instanceof P.ShellExecution?he=v.from(U.execution):U.execution&&U.execution instanceof P.CustomExecution&&(he=i.from(U.execution));const ie=t.from(U.definition);let V;return U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=P.TaskScope.Workspace,!ie||!V?void 0:{_id:U._id,definition:ie,name:U.name,source:{extensionId:j.identifier.value,label:U.source,scope:V},execution:he,isBackground:U.isBackground,group:h.from(U.group),presentationOptions:o.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}Y.from=M;async function B(U,j,he){if(U==null)return;let ie;a.is(U.execution)?ie=a.to(U.execution):v.is(U.execution)?ie=v.to(U.execution):i.is(U.execution)&&(ie=i.to(U._id,he));const V=t.to(U.definition);let J;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?J=U.source.scope:J=await j.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):J=P.TaskScope.Workspace),!V||!J)return;const ne=new P.Task(V,J,U.name,U.source.label,ie,U.problemMatchers);return U.isBackground!==void 0&&(ne.isBackground=U.isBackground),U.group!==void 0&&(ne.group=P.TaskGroup.from(U.group._id),ne.group&&U.group.isDefault&&(ne.group=new P.TaskGroup(ne.group.id,ne.group.label),U.group.isDefault===!0&&(ne.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ne.presentationOptions=o.to(U.presentationOptions)),U._id&&(ne._id=U._id),U.detail&&(ne.detail=U.detail),ne}Y.to=B})(b=e.TaskDTO||(e.TaskDTO={}));var p;(function(Y){function x(B){return B}Y.from=x;function M(B){if(!!B)return Object.assign(Object.create(null),B)}Y.to=M})(p||(p={}));class O{constructor(x,M,B){this._id=M,this.a=B,m.set(this,void 0),_e(this,m,x,"f")}get task(){return this.a}terminate(){Me(this,m,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}m=new WeakMap;let W=class{constructor(x,M,B,U,j,he,ie,V){this.q=new u.Emitter,this.r=new u.Emitter,this.s=new u.Emitter,this.t=new u.Emitter,this.a=x.getProxy(R.MainContext.MainThreadTask),this.b=B,this.c=U,this.d=j,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(x,M,B){if(!B)return new P.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:M,provider:B,extension:x}),this.a.$registerTaskProvider(U,M),new P.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(x,M){this.a.$registerTaskSystem(x,M)}fetchTasks(x){return this.a.$fetchTasks(p.from(x)).then(async M=>{const B=[];for(const U of M){const j=await b.to(U,this.b,this.m);j&&B.push(j)}return B})}get taskExecutions(){const x=[];return this.k.forEach(M=>x.push(M)),x}terminateTask(x){if(!(x instanceof O))throw new Error("No valid task execution provided");return this.a.$terminateTask(x._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(x,M,B){const U=this.m.get(x.id);U&&(this.o.set(x.id,U),this.e.attachPtyToTerminal(M,await U.callback(B))),this.p=x.id,this.q.fire({execution:await this.y(x)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(x){const M=await this.y(x);this.l.delete(x.id),this.k.delete(x.id),this.A(x),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(x){const M=await this.y(x.id);this.s.fire({execution:M,processId:x.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(x){const M=await this.y(x.id);this.t.fire({execution:M,exitCode:x.exitCode})}$provideTasks(x,M){const B=this.j.get(x);if(!B)return Promise.reject(new Error("no handler found"));const U=[],j=(0,A.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(he=>this.u(M,U,B,he));return new Promise(he=>{j.then(ie=>{Promise.all(U).then(()=>{he(ie)})})})}async $resolveTask(x,M){const B=this.j.get(x);if(!B)return Promise.reject(new Error("no handler found"));if(M.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await b.to(M,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const j=await B.provider.resolveTask(U,L.CancellationToken.None);if(!j)return;this.z(j,B);const he=b.from(j,B.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(he.execution)&&await this.x(he,j,!0),await this.v(he)}w(){return this.h++}async x(x,M,B){const U=await this.a.$createTaskId(x);!B&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,M.execution)),this.m.set(U,M.execution)}async y(x,M){if(typeof x=="string"){const j=this.l.get(x);if(!j)throw new y.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const B=this.l.get(x.id);if(B)return B;const U=new Promise((j,he)=>{function ie(V,J,ne){ne?j(new O(V,J.id,ne)):he("Unexpected: Task does not exist.")}M?ie(this,x,M):b.to(x.task,this.b,this.m).then(V=>ie(this,x,V))});return this.l.set(x.id,U),U.then(j=>(this.k.set(x.id,j),j),j=>Promise.reject(j))}z(x,M){x._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}A(x){this.o.get(x.id)&&this.o.delete(x.id),this.n.has(x.id)&&this.p!==x.id&&(this.m.delete(x.id),this.n.delete(x.id));const B=this.n.values();let U=B.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=B.next()}};W=Ve([We(0,S.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,g.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,d.ILogService),We(7,f.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let q=class extends W{constructor(x,M,B,U,j,he,ie,V){super(x,M,B,U,j,he,ie,V),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:r.PlatformToString(0)})}async executeTask(x,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const B=b.from(M,x);if(B===void 0)throw new Error("Task is not valid");if(i.is(B.execution))await this.x(B,M,!1);else throw new y.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(B),M);return this.a.$executeTask(B).catch(j=>{throw new Error(j)}),U}u(x,M,B,U){const j=[];if(U)for(const he of U){this.z(he,B),(!he.definition||!x[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=b.from(he,B.extension);ie&&i.is(ie.execution)?(j.push(ie),M.push(this.x(ie,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:B.extension}}async v(x){if(i.is(x.execution))return x;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(x,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,M,B){}};q=Ve([We(0,S.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,g.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,d.ILogService),We(7,f.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(De[300],Ce([1,0,12,21,46,38,24,43,31]),function(re,e,c,A,u,R,P,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class g{constructor(S,I,C){this.k=S,this.l=I,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=S.filePattern,this.b=S.includePattern&&R.parse(S.includePattern),this.c=S.maxResults||void 0,this.d=S.exists,this.h=new Set,this.j=S.excludePattern&&R.parse(S.excludePattern)}cancel(){this.g=!0,this.h.forEach(S=>S.cancel()),this.h=new Set}search(S){const I=this.k.folderQueries||[];return new Promise((C,E)=>{const r=d=>{this.f++,S(d)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const f=d.toString(),w=c.basename(f);this.j&&this.j(f,w)||this.v(r,{base:d,basename:w})}),Promise.all(I.map(d=>this.p(d,r))).then(d=>{C({limitHit:this.e,stats:d[0]||void 0})},d=>{E(new Error((0,u.toErrorMessage)(d)))})})}async p(S,I){const C=new A.CancellationTokenSource,E=this.q(S),r=this.r(),d=new D.QueryGlobTester(this.k,S),f=!d.hasSiblingExcludeClauses();let w;try{this.h.add(C),w=T.StopWatch.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},E,C.token),m=w.elapsed(),t=T.StopWatch.create();return this.g&&!this.e||(y&&y.forEach(o=>{const s=c.posix.relative(S.folder.path,o.path);if(f){const a=c.basename(o.path);this.v(I,{base:S.folder,relativePath:s,basename:a});return}this.s(r,S.folder,s,I)}),this.g&&!this.e)?null:(this.u(r,d,I),{providerTime:m,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(S){const I=(0,D.resolvePatternsForProvider)(this.k.includePattern,S.includePattern),C=(0,D.resolvePatternsForProvider)(this.k.excludePattern,S.excludePattern);return{folder:S.folder,excludes:C,includes:I,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}s({pathToEntries:S},I,C,E){if(C===this.a){const d=c.basename(this.a);this.v(E,{base:I,relativePath:this.a,basename:d})}function r(d){const f=c.basename(d),w=c.dirname(d);let y=S[w];y||(y=S[w]=[],r(w)),y.push({base:I,relativePath:d,basename:f})}r(C)}u({rootEntries:S,pathToEntries:I},C,E){const r=this,d=this.a;function f(w){const y=(0,D.hasSiblingFn)(()=>w.map(m=>m.basename));for(let m=0,t=w.length;m<t;m++){const o=w[m],{relativePath:s,basename:a}=o;if(C.matchesExcludesSync(s,a,d!==a?y:void 0))continue;const l=I[s];if(l)f(l);else{if(s===d)continue;r.v(E,o)}if(r.e)break}}f(S)}v(S,I){(!this.b||I.relativePath&&this.b(I.relativePath,I.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||S(I))}}class L{constructor(){this.b=new Map}fileSearch(S,I,C,E){const r=this.c(S.cacheKey),d=new g(S,I,r&&r.token);let f=0;const w=y=>{f+=y.length,C(y.map(m=>this.d(m)))};return this.e(d,L.a,w,E).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:y.stats}}))}clearCache(S){this.c(S)?.cancel()}c(S){if(!!S)return this.b.has(S)||this.b.set(S,new A.CancellationTokenSource),this.b.get(S)}d(S){return S.relativePath?{resource:P.joinPath(S.base,S.relativePath)}:{resource:S.base}}e(S,I,C,E){E.onCancellationRequested(()=>{S.cancel()});const r=f=>{f&&(d.push(f),I>0&&d.length>=I&&(C(d),d=[]))};let d=[];return S.search(r).then(f=>(d.length&&C(d),f),f=>(d.length&&C(d),Promise.reject(f)))}}L.a=512,e.FileSearchManager=L}),define(De[301],Ce([1,0,17,61,38,114,28,18,12,24,8,10,2,167,200,54,16,48,134,299,31]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(b,p,O,W,q){this.a=b,this.b=p,this.c=O,this.d=W,this.e=q}text(b,p,O={}){b=this.f(b,O);const W=this.a.getValue(),q=p&&p.some(x=>!this.a.getValue({resource:x}).search.useRipgrep);return{...this.h(p?.map(d.toWorkspaceFolder),O),type:2,contentPattern:b,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:W.search.usePCRE2||q||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(b,p){const O=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const W={...b,wordSeparators:O.editor.wordSeparators};return this.j(b,p)&&(W.isCaseSensitive=!0),this.k(b)&&(W.isMultiline=!0),W}file(b,p={}){return{...this.h(b,p),type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey}}g(b,p){return b?(b=Array.isArray(b)?b.map(l):l(b),p?this.parseSearchPaths(b):{pattern:o(...Array.isArray(b)?b:[b])}):{}}h(b=[],p={}){const O=this.g(p.includePattern,p.expandPatterns),W=this.g(p.excludePattern,p.expandPatterns),q=b.length>1,Y=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(B=>this.q(B,p,W)):b.map(B=>this.r(B,p,W,q))).filter(B=>!!B),x={_reason:p._reason,folderQueries:Y,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:W.pattern,includePattern:O.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const B=c.coalesce(c.flatten(this.c.groups.map(he=>he.editors.map(ie=>ie.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const U=B.filter(he=>(0,y.pathIncludedInQuery)(x,he.fsPath)),j=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...x,...j}}const M=p.extraFileResources&&p.extraFileResources.filter(B=>(0,y.pathIncludedInQuery)(x,B.fsPath));return x.extraFileResources=M&&M.length?M:void 0,x}i(b){const p=[],O=new P.ResourceMap,W={};let q=!1;return b.forEach(Y=>{if(Y.scheme===T.Schemas.walkThrough)return;if((0,g.isAbsolutePath)(Y)){const M=this.b.getWorkspaceFolder(Y)?.uri??Y.with({path:D.dirname(Y.fsPath)});let B=O.get(M);B||(q=!0,B={folder:M,includePattern:{}},p.push(B),O.set(M,B));const U=D.relative(M.fsPath,Y.fsPath);(0,k.assertIsDefined)(B.includePattern)[U.replace(/\\/g,"/")]=!0}else Y.fsPath&&(q=!0,W[Y.fsPath]=!0)}),{folderQueries:p,includePattern:W,usingSearchPaths:!0,excludePattern:q?void 0:{"**/*":!0}}}j(b,p){if(p.isSmartCase){if(b.isRegExp){if(L.containsUppercaseCharacter(b.pattern,!0))return!0}else if(L.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,I.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const p=j=>D.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),W=(Array.isArray(b)?b:s(b)).map(j=>{const he=this.e.resolvedUserHome;return he?(0,R.untildify)(j,he.scheme===T.Schemas.file?he.fsPath:he.path):j}),q=A.groupBy(W,j=>p(j)?"searchPaths":"exprSegments"),Y=(q.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),a(j))),x={},M=this.m(q.searchPaths||[]);M&&M.length&&(x.searchPaths=M);const B=c.flatten(Y),U=o(...B);return U&&(x.pattern=U),x}l(b,p){return p.disregardExcludeSettings?void 0:(0,y.getExcludes)(b,!p.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const p=b.flatMap(W=>{let{pathPortion:q,globPortion:Y}=t(W);return Y&&(Y=v(Y)),this.n(q).flatMap(M=>this.o(M,Y))}),O=new Map;return p.forEach(W=>{const q=W.searchPath.toString(),Y=O.get(q);Y?W.pattern&&(Y.pattern=Y.pattern||{},Y.pattern[W.pattern]=!0):O.set(q,{searchPath:W.searchPath,pattern:W.pattern?o(W.pattern):void 0})}),Array.from(O.values())}n(b){if(D.isAbsolute(b)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==T.Schemas.file?[{searchPath:p[0].uri.with({path:b})}]:[{searchPath:S.URI.file(D.normalize(b))}]}if(this.b.getWorkbenchState()===2){const p=this.b.getWorkspace().folders[0].uri;if(b=l(b),b.startsWith("../")||b===".."){const W=D.posix.resolve(p.path,b);return[{searchPath:p.with({path:W})}]}const O=v(b);return[{searchPath:p,pattern:O}]}else{if(b==="./"||b===".\\")return[];{const p=b.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(q=>{const Y=p.match(new RegExp(`^${L.escapeRegExpCharacters(q.name)}(?:/(.*)|$)`));return Y?{match:Y,folder:q}:null}).filter(k.isDefined);if(W.length)return W.map(q=>{const Y=q.match[1];return{searchPath:q.folder.uri,pattern:Y&&v(Y)}});{const q=b.match(/\.[\/\\](.+)[\/\\]?/),Y=q?q[1]:b,x=C.localize(0,null,Y);throw new Error(x)}}}}o(b,p){const O=b.pattern&&p?`${b.pattern}/${p}`:b.pattern||p,W=[{searchPath:b.searchPath,pattern:O}];return O&&!O.endsWith("**")&&W.push({searchPath:b.searchPath,pattern:O+"/**"}),W}q(b,p,O){const W=this.r((0,d.toWorkspaceFolder)(b.searchPath),p,O,!1);return W?{...W,includePattern:b.pattern}:null}r(b,p,O,W){let q;const Y=S.URI.isUri(b)?b:b.uri;if(O.searchPaths){const j=O.searchPaths.filter(he=>(0,g.isEqual)(he.searchPath,Y))[0];if(j&&!j.pattern)return null;j&&(q=j.pattern)}const x=this.a.getValue({resource:Y}),B={...this.l(x,p)||{},...q||{}},U=S.URI.isUri(b)?(0,g.basename)(b):b.name;return{folder:Y,folderName:W?U:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!x.search.followSymlinks}}};m=Ve([We(0,E.IConfigurationService),We(1,d.IWorkspaceContextService),We(2,f.IEditorGroupsService),We(3,r.ILogService),We(4,w.IPathService)],m),e.QueryBuilder=m;function t(h){const b=h.match(/[\*\{\}\(\)\[\]\?]/);if(b){const p=b.index,O=h.substr(0,p).match(/[/|\\][^/\\]*$/);if(O){let W=h.substr(0,O.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:h.substr((O.index||0)+1)}}}return{pathPortion:h}}function o(...h){return h.length?h.reduce((b,p)=>(b[p]=!0,b),Object.create(null)):void 0}function s(h){return u.splitGlobAware(h,",").map(b=>b.trim()).filter(b=>!!b.length)}function a(h){return[`**/${h}/**`,`**/${h}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function l(h){return h.replace(/\\/g,"/")}function v(h){return l(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(h){return h.replace(/([?*[\]])/g,"[$1]")}function n(h,b){h=c.distinct(h,W=>W.toString());const p=[],O=b.getWorkspace();return h&&h.forEach(W=>{let q;if(b.getWorkbenchState()===2)q=(0,g.relativePath)(O.folders[0].uri,W),q&&q!=="."&&(q="./"+q);else{const Y=b.getWorkspaceFolder(W);if(Y){const x=Y.name;if(O.folders.filter(B=>B.name===x).length===1){const B=(0,g.relativePath)(Y.uri,W);B===""?q=`./${Y.name}`:q=`./${Y.name}/${B}`}else q=W.fsPath}}q&&p.push(i(q))}),p}e.resolveResourcesForSearchIncludes=n}),define(De[302],Ce([1,0,24,2,21,9,4,301,31,48]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(E,r){const d=r.activationEvents;if(!d)return Promise.resolve(void 0);const f=[],w=[];for(const a of d)if(/^workspaceContains:/.test(a)){const l=a.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||E.forceUsingSearch?w.push(l):f.push(l)}if(f.length===0&&w.length===0)return Promise.resolve(void 0);let y;const m=new Promise((a,l)=>{y=a}),t=a=>y({activationEvent:a}),o=Promise.all(f.map(a=>S(E,a,t))).then(()=>{}),s=I(E,r.identifier,w,t);return Promise.all([o,s]).then(()=>{y(void 0)}),m}e.checkActivateWorkspaceContainsExtension=k;async function S(E,r,d){for(const f of E.folders)if(await E.exists(c.joinPath(A.URI.revive(f),r))){d(`workspaceContains:${r}`);return}}async function I(E,r,d,f){if(d.length===0)return Promise.resolve(void 0);const w=new u.CancellationTokenSource,y=E.checkExists(E.folders,d,w.token),m=setTimeout(async()=>{w.cancel(),E.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},L);let t=!1;try{t=await y}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}w.dispose(),clearTimeout(m),t&&f(`workspaceContains:${d.join(",")}`)}function C(E,r,d,f){const w=E.get(P.IInstantiationService),y=E.get(D.ISearchService),t=w.createInstance(T.QueryBuilder).file(r.map(o=>(0,g.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:d,exists:!0});return y.fileSearch(t,f).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=C});var _e=this&&this.__classPrivateFieldSet||function(re,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Me=this&&this.__classPrivateFieldGet||function(re,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!A:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(re):A?A.value:e.get(re)};define(De[42],Ce([1,0,181,12,84,24,19,6,69,2,16,5,35,242,100,34,27,135,9,25,22,224,7,128,4,26,80,20,92,55,41,3,302,99,226,18,98,43,11]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t,o,s,a,l,v,i,n,h,b,p,O,W,q,Y,x,M){"use strict";var B,U,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let he=class fn extends T.Disposable{constructor(N,K,le,me,ke,Z,ce,de,te,ae,oe){super(),this.a=this.D(new b.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=K,this.g=le,this.f=ce,this.j=me,this.k=ke,this.l=Z,this.m=te,this.p=ae,this.q=oe,this.s=this.g.getProxy(k.MainContext.MainThreadWorkspace),this.t=this.g.getProxy(k.MainContext.MainThreadTelemetry),this.u=this.g.getProxy(k.MainContext.MainThreadExtensionService),this.v=new P.Barrier,this.w=new P.Barrier,this.y=new P.Barrier,this.z=new P.Barrier,this.C=new ue(this.f.activationEvents),this.G=new d.ExtensionDescriptionRegistry(this.C,this.f.allExtensions);const F=new w.ExtensionIdentifierSet(this.f.myExtensions);this.F=new d.ExtensionDescriptionRegistry(this.C,ne(this.G,F)),this.H=new C.ExtHostStorage(this.g,this.l),this.I=new O.ExtHostSecretState(this.g),this.J=de,this.h=N.createChild(new i.ServiceCollection([C.IExtHostStorage,this.H],[O.IExtHostSecretState,this.I])),this.L=this.D(new I.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(z,G,_)=>{this.u.$onExtensionActivationError(z,f.transformErrorForSerialization(G),_)},actualActivateExtension:async(z,G)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(z,this.F,this.G))return await this.u.$activateExtension(z,G),new I.HostExtension;const _=this.F.getExtensionDescription(z);return this.Z(_,G)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.v.open(),await this.j.waitForInitializeCall(),u.mark("code/extHost/ready"),this.w.open(),this.f.autoStart&&this.nb()}catch(N){f.onUnexpectedError(N)}}async R(){this.J.onWillDeactivateAll();let N=[];try{N=this.F.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.Y(ke))}catch{}await Promise.all(N)}terminate(N,K=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${N}`),this.l.flush(),this.p.dispose(),this.L.dispose(),f.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const le=this.R();Promise.race([(0,P.timeout)(5e3),le]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${K}`):this.l.info(`Extension host exiting with code ${K}`),this.l.flush(),this.l.dispose(),this.c.exit(K)})}isActivated(N){return this.y.isOpen()?this.L.isActivated(N):!1}async getExtension(N){const K=await this.u.$getExtension(N);let le;if(K?.browserNlsBundleUris){le={};for(const me of Object.keys(K.browserNlsBundleUris))le[me]=g.URI.revive(K.browserNlsBundleUris[me])}return K&&{...K,identifier:new w.ExtensionIdentifier(K.identifier.value),extensionLocation:g.URI.revive(K.extensionLocation),browserNlsBundleUris:le}}S(N,K){return this.L.activateByEvent(N,K)}U(N,K){return this.L.activateById(N,K)}activateByIdWithErrors(N,K){return this.U(N,K).then(()=>{const le=this.L.getActivatedExtension(N);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this.y.wait().then(N=>this.F)}getExtensionExports(N){return this.y.isOpen()?this.L.getActivatedExtension(N).exports:null}async W(N){if(N.scheme!==q.Schemas.file)return N;const K=await this.c.realpath(N.fsPath);return g.URI.file(K)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(N=>new ve(N))),this.M}async X(N){const K=D.TernarySearchTree.forUris(le=>R.extUriBiasedIgnorePathCase.ignorePathCasing(le));return await Promise.all(N.map(async le=>{if(this.qb(le)){const me=await this.W(le.extensionLocation);K.set(me,le)}})),K}Y(N){let K=Promise.resolve(void 0);if(!this.y.isOpen()||!this.L.isActivated(N))return K;const le=this.L.getActivatedExtension(N);if(!le)return K;try{typeof le.module.deactivate=="function"&&(K=Promise.resolve(le.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${N.value}':`),this.l.error(me)}try{(0,T.dispose)(le.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${N.value}':`),this.l.error(me)}return K}async Z(N,K){return this.f.remote.isRemote?this.u.$onWillActivateExtension(N.identifier):await this.u.$onWillActivateExtension(N.identifier),this.bb(N,K).then(le=>{const me=le.activationTimes;return this.u.$onDidActivateExtension(N.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,K),this.ab(N,K,"success",me),le},le=>{throw this.ab(N,K,"failure"),le})}ab(N,K,le,me){const ke=V(N,K);this.t.$publicLog2("extensionActivationTimes",{...ke,...me||{},outcome:le})}bb(N,K){const le=V(N,K);this.t.$publicLog2("activatePlugin",le);const me=this.qb(N);if(!me)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${N.identifier.value}, startup: ${K.startup}, activationEvent: '${K.activationEvent}'${N.identifier.value!==K.extensionId.value?`, root cause: ${K.extensionId.value}`:""}`),this.l.flush();const ke=new I.ExtensionActivationTimesBuilder(K.startup);return Promise.all([this.rb(N,(0,R.joinPath)(N.extensionLocation,me),ke),this.cb(N)]).then(Z=>(u.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),fn.db(this.l,N.identifier,Z[0],Z[1],ke))).then(Z=>(u.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),Z))}cb(N){const K=new m.ExtensionGlobalMemento(N,this.H),le=new m.ExtensionMemento(N.identifier.value,!1,this.H),me=new W.ExtensionSecrets(N,this.I),ke=N.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Z=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([K.whenReady,le.whenReady,this.J.whenReady]).then(()=>{const ce=this;let de,te;const ae=(0,r.isProposedApiEnabled)(N,"ipc")?this.f.messagePorts?.get(w.ExtensionIdentifier.toKey(N.identifier)):void 0;return Object.freeze({globalState:K,workspaceState:le,secrets:me,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(oe){return A.join(N.extensionLocation.fsPath,oe)},get storagePath(){return ce.J.workspaceValue(N)?.fsPath},get globalStoragePath(){return ce.J.globalValue(N).fsPath},get logPath(){return A.join(ce.f.logsLocation.fsPath,N.identifier.value)},get logUri(){return g.URI.joinPath(ce.f.logsLocation,N.identifier.value)},get storageUri(){return ce.J.workspaceValue(N)},get globalStorageUri(){return ce.J.globalValue(N)},get extensionMode(){return ke},get extension(){return de===void 0&&(de=new J(ce,N.identifier,N,Z,!1)),de},get extensionRuntime(){return(0,r.checkProposedApiEnabled)(N,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.p.getEnvironmentVariableCollection(N)},get messagePassingProtocol(){if(!te){if(!ae)return;const oe=b.Event.buffer(b.Event.fromDOMEventEmitter(ae,"message",F=>F.data));ae.start(),te={onDidReceiveMessage:oe,postMessage:ae.postMessage.bind(ae)}}return te}})})}static db(N,K,le,me,ke){return le=le||{activate:void 0,deactivate:void 0},this.eb(N,K,le,me,ke).then(Z=>new I.ActivatedExtension(!1,null,ke.build(),le,Z,me.subscriptions))}static eb(N,K,le,me,ke){if(typeof le.activate=="function")try{ke.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${K.value}`);const Z=typeof global=="object"?global:self,ce=le.activate.apply(Z,[me]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(ce).then(de=>(ke.activateResolveStop(),de))}catch(Z){return Promise.reject(Z)}else return Promise.resolve(le)}fb(N,K){this.U(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:K}).then(void 0,le=>{this.l.error(le)})}gb(N,K=0){const me=Date.now();(0,M.setTimeout0)(()=>{for(let ke=K;ke<N.length;ke+=1){const Z=N[ke];for(const ce of Z.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-me>50){this.gb(N,ke);break}else this.fb(Z,ce)}})}hb(){this.u.$setPerformanceMarks(u.getMarks()),this.k.getConfigProvider().then(N=>{const K=N.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),le=this.F.getAllExtensionDescriptions();if(K)this.gb(le);else for(const me of le)if(me.activationEvents)for(const ke of me.activationEvents)ke==="onStartupFinished"&&this.fb(me,ke)})}ib(){const N=this.S("*",!0).then(void 0,Z=>{this.l.error(Z)});this.D(this.j.onDidChangeWorkspace(Z=>this.jb(Z.added)));const K=this.j.workspace?this.j.workspace.folders:[],le=this.jb(K),me=this.lb(),ke=Promise.all([me,N,le]).then(()=>{});return Promise.race([ke,(0,P.timeout)(1e4)]).then(()=>{this.hb()}),ke}jb(N){return N.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(K=>this.kb(N,K))).then(()=>{})}async kb(N,K){if(this.isActivated(K.identifier))return;const le=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:N.map(Z=>Z.uri),forceUsingSearch:le,exists:Z=>this.c.exists(Z.fsPath),checkExists:(Z,ce,de)=>this.s.$checkExists(Z,ce,de)},ke=await(0,p.checkActivateWorkspaceContainsExtension)(me,K);if(!!ke)return this.U(K.identifier,{startup:!0,extensionId:K.identifier,activationEvent:ke.activationEvent}).then(void 0,Z=>this.l.error(Z))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.z.wait();try{return await this.mb()}catch(N){throw console.error(N),N}}async mb(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:K}=this.f.environment;if(!N||!K)throw new Error(c.localize(0,null));const le=await this.rb(null,K,new I.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(c.localize(1,null,K.toString()));return new Promise((me,ke)=>{const Z=(te,ae)=>{te?ke(te):me(typeof ae=="number"&&ae>0?1:0)},ce=(0,R.originalFSPath)(K),de=le.run(ce,Z);de&&de.then&&de.then(()=>{me(0)}).catch(te=>{ke(te instanceof Error&&te.stack?te.stack:String(te))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.w.wait().then(()=>this.y.open()).then(()=>this.ib()).then(()=>{this.z.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(N,K){return this.N[N]=K,(0,T.toDisposable)(()=>{delete this.N[N]})}async ob(N){const K=N.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const le=N.substr(0,K);return await this.v.wait(),await this.S(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this.N[le]}}async $resolveAuthority(N,K){const le=x.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(N)},${K})][${le.elapsed()}ms] `,ke=ae=>this.l.info(`${me()}${ae}`),Z=(ae,oe=void 0)=>this.l.error(`${me()}${ae}`,oe);ke("activating resolver...");const{authorityPrefix:ce,resolver:de}=await this.ob(N);if(!de)return Z("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};const te=new P.IntervalTimer;try{ke("setting tunnel factory..."),this.D(await this.m.setTunnelFactory(de)),te.cancelAndSet(()=>ke("waiting..."),1e3),ke("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${ce}`);const ae=await de.resolve(N,{resolveAttempt:K});u.mark(`code/extHost/didResolveAuthorityOK/${ce}`),te.dispose(),ke(`returned ${ae.host}:${ae.port}`);const oe={authority:N,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},F={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:oe,options:F,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(u.mark(`code/extHost/didResolveAuthorityError/${ce}`),te.dispose(),Z("returned an error",ae),ae instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(N,K){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(N)})`);const{resolver:le}=await this.ob(N);if(!le)return null;const me=g.URI.revive(K);if(typeof le.getCanonicalURI>"u")return me;const ke=await(0,P.asPromise)(()=>le.getCanonicalURI(me));return ke||me}$startExtensionHost(N){N.toAdd.forEach(me=>me.extensionLocation=g.URI.revive(me.extensionLocation));const{globalRegistry:K,myExtensions:le}=ie(this.C,this.G,this.F,N);return this.G.set(K.getAllExtensionDescriptions()),this.F.set(le),this.nb()}$activateByEvent(N,K){return K===1?this.S(N,!1):this.y.wait().then(le=>this.S(N,!1))}async $activate(N,K){return await this.y.wait(),this.F.getExtensionDescription(N)?(await this.U(N,K),!0):!1}async $deltaExtensions(N){N.toAdd.forEach(Z=>Z.extensionLocation=g.URI.revive(Z.extensionLocation));const{globalRegistry:K,myExtensions:le}=ie(this.C,this.G,this.F,N),me=await this.X(le);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(K.getAllExtensionDescriptions()),this.F.set(le),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){const K=y.VSBuffer.alloc(N),le=Math.random()%256;for(let me=0;me<N;me++)K.writeUInt8(le,me);return K}async $updateRemoteConnectionData(N){this.Q=N,this.a.fire()}};he=Ve([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,v.IExtHostRpcService),We(3,E.IExtHostWorkspace),We(4,S.IExtHostConfiguration),We(5,L.ILogService),We(6,a.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,n.IExtHostTunnelService),We(9,h.IExtHostTerminalService),We(10,Y.IExtHostLocalizationService)],he),e.AbstractExtHostExtensionService=he;function ie(ee,N,K,le){ee.addActivationEvents(le.addActivationEvents);const me=new d.ExtensionDescriptionRegistry(ee,N.getAllExtensionDescriptions());me.deltaExtensions(le.toAdd,le.toRemove);const ke=new w.ExtensionIdentifierSet(K.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of le.myToRemove)ke.delete(ce);for(const ce of le.myToAdd)ke.add(ce);const Z=ne(me,ke);return{globalRegistry:me,myExtensions:Z}}function V(ee,N){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class J{constructor(N,K,le,me,ke){B.set(this,void 0),U.set(this,void 0),j.set(this,void 0),_e(this,B,N,"f"),_e(this,U,K,"f"),_e(this,j,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=me,this.isFromDifferentExtensionHost=ke}get isActive(){return Me(this,B,"f").isActivated(Me(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,j,"f"),{startup:!1,extensionId:Me(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=J,B=new WeakMap,U=new WeakMap,j=new WeakMap;function ne(ee,N){return ee.getAllExtensionDescriptions().filter(K=>N.has(K.identifier))}class ve{constructor(N){this.a=N}setSearchTree(N){this.a=N}findSubstr(N){return this.a.findSubstr(N)}forEach(N){return this.a.forEach(N)}}e.ExtensionPaths=ve;class ue{constructor(N){this.a=new w.ExtensionIdentifierMap,this.addActivationEvents(N)}readActivationEvents(N){return this.a.get(N.identifier)}addActivationEvents(N){for(const K of Object.keys(N))this.a.set(K,N[K])}}}),define(De[303],Ce([1,0,84,2,5,35,27,25,20,26,4,42,36,16,8]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let E=class{constructor(m,t,o,s,a,l,v){this.c=m,this.d=t,this.e=o,this.f=s,this.g=a,this.h=l,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,m,this.i)),this.register(this.e.createInstance(f,t)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(w,t,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const t of m.nodeModuleName)this.a.set(t,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(t=>m.alternativeModuleName(t))}};E=Ve([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,k.IExtHostExtensionService),We(5,g.IExtHostInitDataService),We(6,I.ILogService)],E),e.RequireInterceptor=E;let r=class cn{constructor(m){if(m.environment.appRoot&&cn.a.size){const t=(0,C.escapeRegExpCharacters)(this.c(m.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const t=this.b.exec(this.c(m));if(!t)return;const[,o,s,a]=t,l=cn.a.get(s);if(l!==void 0)return console.warn(`${s} as been renamed to ${l}, please update your imports`),o+l+a}c(m){return m.replace(/\\/g,"/")}};r.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),r=Ve([We(0,g.IExtHostInitDataService)],r);class d{constructor(m,t,o,s,a){this.c=m,this.d=t,this.e=o,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new T.ExtensionIdentifierMap}load(m,t){const o=this.d.findSubstr(t);if(o){let s=this.a.get(o.identifier);return s||(s=this.c(o,this.e,this.f),this.a.set(o.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,l)=>s+=`	${l} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${s}`),this.b=this.c(P.nullExtensionDescription,this.e,this.f)}return this.b}}let f=class{constructor(m,t,o){this.d=m,this.nodeModuleName="keytar",this.a=t.getProxy(u.MainContext.MainThreadTelemetry);const{environment:s}=o,a=t.getProxy(u.MainContext.MainThreadKeytar);if(s.appRoot){let l=s.appRoot.fsPath;S.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,v)=>a.$getPassword(l,v),setPassword:(l,v,i)=>a.$setPassword(l,v,i),deletePassword:(l,v)=>a.$deletePassword(l,v),findPassword:l=>a.$findPassword(l),findCredentials(l){return a.$findCredentials(l)}}}load(m,t){const o=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(m){const t=m.length;if(t<=7||!this.b)return;const o=t-7;if((m.charAt(o)==="/"||m.charAt(o)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.b.has(m)))return"keytar"}};f=Ve([We(1,D.IExtHostRpcService),We(2,g.IExtHostInitDataService)],f);let w=class{constructor(m,t,o){this.e=m,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(u.MainContext.MainThreadTelemetry);const s=o.getProxy(u.MainContext.MainThreadWindow);this.c=(a,l)=>{const v=A.URI.parse(a);return l?this.g(a,l):v.scheme==="http"||v.scheme==="https"?s.$openUri(v,a,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?s.$openUri(v,a,{}):this.g(a,l)}}load(m,t,o){const s=this.e.findSubstr(t);return s&&(this.a=s.identifier.value,this.h()),this.b=o(m),this.c}g(m,t){return this.i(),this.b(m,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};w=Ve([We(2,D.IExtHostRpcService)],w)}),define(De[50],Ce([1,0,65,6,12,36,4,59,60,42,7,34,238,35]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,P.createDecorator)("IExtHostVariableResolverProvider");class C extends S.AbstractVariableResolverService{constructor(d,f,w,y,m,t,o){function s(){if(w){const a=w.activeEditor();if(a)return a.document.uri;const l=y.tabGroups.all.find(v=>v.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof L.TextDiffTabInput||l.input instanceof L.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof L.TextTabInput||l.input instanceof L.NotebookEditorTabInput||l.input instanceof L.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:a=>{const l=t.folders.filter(v=>v.name===a);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,l)=>m.getConfiguration(void 0,a).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=s();if(a)return u.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const a=s();if(a){const l=f.getWorkspaceFolder(a);if(l)return u.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(w){const a=w.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(w){const a=w.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>d.getExtension(a)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let E=class extends A.Disposable{constructor(d,f,w,y,m){super(),this.b=d,this.c=f,this.g=w,this.h=y,this.i=m,this.a=new c.Lazy(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.D(this.c.onDidChangeWorkspace(async a=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,s,this.j())})}getResolver(){return this.a.value}j(){}};E=Ve([We(0,g.IExtHostExtensionService),We(1,k.IExtHostWorkspace),We(2,T.IExtHostDocumentsAndEditors),We(3,I.IExtHostConfiguration),We(4,D.IExtHostEditorTabs)],E),e.ExtHostVariableResolverProviderService=E}),define(De[85],Ce([1,0,19,3,10,2,4,5,60,42,20,7,34,132,231,35,50]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,P.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,l,v,i,n){this.D=a,this.E=l,this.F=v,this.G=i,this.H=n,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(T.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new w(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(b=>{this.I(h)}),this.I(h)})}asDebugSourceUri(s,a){const l=s;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let v=`debug:${encodeURIComponent(l.path||"")}`,i="?";return a&&(v+=`${i}session=${encodeURIComponent(a.id)}`,i="&"),v+=`${i}ref=${l.sourceReference}`,R.URI.parse(v)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const a=[];for(const l of s.getAllExtensionDescriptions())if(l.contributes){const v=l.contributes.debuggers;if(v&&v.length>0)for(const i of v)(0,C.isDebuggerMainContribution)(i)&&a.push(i.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){this.T();const a=s.filter(i=>{const n=i.id;return this.w.has(n)?!1:(this.w.set(n,i),!0)});this.U(a,[],[]);const l=[],v=new Map;for(const i of a)if(i instanceof k.SourceBreakpoint){let n=v.get(i.location.uri.toString());n||(n={type:"sourceMulti",uri:i.location.uri,lines:[]},v.set(i.location.uri.toString(),n),l.push(n)),n.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof k.FunctionBreakpoint&&l.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(s){this.T();const a=s.filter(n=>this.w.delete(n.id));this.U([],a,[]);const l=a.filter(n=>n instanceof k.SourceBreakpoint).map(n=>n.id),v=a.filter(n=>n instanceof k.FunctionBreakpoint).map(n=>n.id),i=a.filter(n=>n instanceof k.DataBreakpoint).map(n=>n.id);return this.k.$unregisterBreakpoints(l,v,i)}startDebugging(s,a,l){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,l){if(!a)return new k.Disposable(()=>{});const v=this.d++;return this.f.push({type:s,handle:v,provider:a}),this.k.$registerDebugConfigurationProvider(s,l,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,v),new k.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==a),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(s,a,l){if(!l)return new k.Disposable(()=>{});if(!this.P(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:a,handle:v,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(a,v),new k.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new k.Disposable(()=>{});const l=this.i++;return this.j.push({type:s,handle:l,factory:a}),new k.Disposable(()=>{this.j=this.j.filter(v=>v.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let l;const v=await this.W(s);return v&&(l={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(l,a)}J(s,a){if(s.type==="implementation")return new m(s.implementation)}K(){}async $startDASession(s,a){const l=this,v=await this.V(a);return this.R(this.M(v.type),v).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const n=this.L(i),h=this.J(n,v);if(!h)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const b=h;return this.A.set(s,b),this.Q(v).then(p=>(p&&this.B.set(s,p),b.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const W=O,q={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const Y=await this.C.sign(W.arguments.value);q.body={signature:Y},b.sendResponse(q)}else throw new Error("no signer")}catch(Y){q.success=!1,q.message=Y.message,b.sendResponse(q)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(O),O=(0,C.convertToVSCPaths)(O,!0),l.k.$acceptDAMessage(s,O)}),b.onError(O=>{p&&p.onError&&p.onError(O),this.k.$acceptDAError(s,O.name,O.message,O.stack)}),b.onExit(O=>{p&&p.onExit&&p.onExit((0,u.withNullAsUndefined)(O),void 0),this.k.$acceptDAExit(s,(0,u.withNullAsUndefined)(O),void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),b.startSession()))})}$sendDAMessage(s,a){a=(0,C.convertToDAPaths)(a,!1);const l=this.B.get(s);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(a),this.A.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.B.get(s);this.B.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const l=this.A.get(s);return this.A.delete(s),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],l=[],v=[];if(s.added)for(const i of s.added){const n=i.id;if(n&&!this.w.has(n)){let h;if(i.type==="function")h=new k.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")h=new k.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const b=R.URI.revive(i.uri);h=new k.SourceBreakpoint(new k.Location(b,new k.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,k.setBreakpointId)(h,n),this.w.set(n,h),a.push(h)}}if(s.removed)for(const i of s.removed){const n=this.w.get(i);n&&(this.w.delete(i),l.push(n))}if(s.changed){for(const i of s.changed)if(i.id){const n=this.w.get(i.id);if(n){if(n instanceof k.FunctionBreakpoint&&i.type==="function"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.functionName=i.functionName}else if(n instanceof k.SourceBreakpoint&&i.type==="source"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.location=new k.Location(R.URI.revive(i.uri),new k.Position(i.line,i.character))}v.push(n)}}}this.U(a,l,v)}$provideDebugConfigurations(s,a,l){return(0,c.asPromise)(async()=>{const v=this.O(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(a);return v.provideDebugConfigurations(i,l)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(s,a,l,v){return(0,c.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const n=await this.W(a);return i.resolveDebugConfiguration(n,l,v)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,l,v){return(0,c.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const n=await this.W(a);return i.resolveDebugConfigurationWithSubstitutedVariables(n,l,v)})}async $provideDebugAdapter(s,a){const l=this.N(s);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(a);return this.R(l,v).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const v={session:await this.V(s),event:a.event,body:a.body};this.u.fire(v)}L(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const a=this.h.filter(l=>l.type===s);if(a.length>0)return a[0].factory}N(s){const a=this.h.filter(l=>l.handle===s);if(a.length>0)return a[0].factory}O(s){const a=this.f.filter(l=>l.handle===s);if(a.length>0)return a[0].provider}P(s,a){if(s.contributes){const l=s.contributes.debuggers;if(l&&l.length>0){for(const v of l)if(v.label&&v.type&&v.type===a)return!0}}return!1}Q(s){const l=s.configuration.type,v=this.j.filter(i=>i.type===l||i.type==="*").map(i=>(0,c.asPromise)(()=>i.factory.createDebugAdapterTracker(s)).then(n=>n,n=>null));return Promise.race([Promise.all(v).then(i=>{const n=i.filter(h=>!!h);if(n.length>0)return new y(n)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(s,a){const l=a.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new k.DebugAdapterServer(l));if(s){const i=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>s.createDebugAdapterDescriptor(a,this.S(a,i))).then(n=>{if(n)return n})}const v=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,v))}S(s,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,a,l){(s.length>0||a.length>0||l.length>0)&&this.z.fire(Object.freeze({added:s,removed:a,changed:l}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const l=await this.W(s.folderUri),v=s.parent?this.l.get(s.parent):void 0;a=new f(this.k,s.id,s.type,s.name,l,s.configuration,v),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=R.URI.revive(s);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};d=Ve([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,g.IExtHostExtensionService),We(3,E.IExtHostConfiguration),We(4,D.IExtHostEditorTabs),We(5,r.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class f{constructor(s,a,l,v,i,n,h){this.d=s,this.f=a,this.g=l,this.h=v,this.i=i,this.j=n,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=f;class w{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=w;class y{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(l=>l.onExit?l.onExit(s,a):void 0)}}class m extends I.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(s,a,l,v,i,n){super(s,a,l,v,i,n)}};t=Ve([We(0,L.IExtHostRpcService),We(1,S.IExtHostWorkspace),We(2,g.IExtHostExtensionService),We(3,E.IExtHostConfiguration),We(4,D.IExtHostEditorTabs),We(5,r.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(De[304],Ce([1,0,9,84,2,5,296,16,91,92,26,207,20,56,42,77]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class r{static async installEarlyHandler(w){const y=w.get(T.ILogService),t=w.get(S.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(o=>{y.error(o);const s=c.transformErrorForSerialization(o);t.$onUnexpectedError(s)})}static async installFullHandler(w){const y=w.get(T.ILogService),m=w.get(S.IExtHostRpcService),t=w.get(C.IExtHostExtensionService),o=w.get(E.IExtHostTelemetry),s=m.getProxy(R.MainContext.MainThreadExtensionService),a=m.getProxy(R.MainContext.MainThreadErrors),l=await t.getExtensionPathIndex(),v=new WeakMap;function i(h,b){let p="",O,W;for(const q of b)p+=`
	at ${q.toString()}`,W=q.getFileName(),!O&&W&&(O=l.findSubstr(u.URI.file(W)));return v.set(h,O?.identifier),`${h.name||"Error"}: ${h.message||""}${p}`}let n=i;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return n},set(h){n=function(b,p){return i(b,p),h.call(Error,b,p)}}}),c.setUnexpectedErrorHandler(h=>{y.error(h);const b=c.transformErrorForSerialization(h),p=v.get(h);if(!p){a.$onUnexpectedError(b);return}s.$onExtensionRuntimeError(p,b);const O=o.onExtensionError(p,h);y.trace("forwarded error to extension?",O,p)})}}Error.stackTraceLimit=100;class d{constructor(w,y,m,t,o){this.a=m,this.b=new P.RPCProtocol(w,null,t),y=d.e(y,this.b);const s=new g.ServiceCollection(...(0,D.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:o}),s.set(S.IExtHostRpcService,new S.ExtHostRpcService(this.b)),s.set(I.IURITransformerService,new I.URITransformerService(t)),s.set(C.IHostUtils,m);const a=new k.InstantiationService(s,!0);a.invokeFunction(r.installEarlyHandler),this.d=a.invokeFunction(l=>l.get(T.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=a.invokeFunction(l=>l.get(C.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(r.installFullHandler)}async asBrowserUri(w){const y=this.b.getProxy(R.MainContext.MainThreadExtensionService);return u.URI.revive(await y.$asBrowserUri(w))}terminate(w){this.c.terminate(w)}static e(w,y){w.allExtensions.forEach(t=>{t.extensionLocation=u.URI.revive(y.transformIncomingURIs(t.extensionLocation));const o={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(s=>o[s]=u.URI.revive(y.transformIncomingURIs(t.browserNlsBundleUris[s]))),t.browserNlsBundleUris=o)}),w.environment.appRoot=u.URI.revive(y.transformIncomingURIs(w.environment.appRoot));const m=w.environment.extensionDevelopmentLocationURI;return m&&(w.environment.extensionDevelopmentLocationURI=m.map(t=>u.URI.revive(y.transformIncomingURIs(t)))),w.environment.extensionTestsLocationURI=u.URI.revive(y.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=u.URI.revive(y.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=u.URI.revive(y.transformIncomingURIs(w.environment.workspaceStorageHome)),w.environment.extensionTelemetryLogResource=u.URI.revive(y.transformIncomingURIs(w.environment.extensionTelemetryLogResource)),w.nlsBaseUrl=u.URI.revive(y.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=u.URI.revive(y.transformIncomingURIs(w.logsLocation)),w.workspace=y.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=d}),define(De[305],Ce([1,0,19,11,189,206,214,85,60,42,20,41,7,50,34,232,234,35]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let f=class extends T.ExtHostDebugServiceBase{constructor(o,s,a,l,v,i,n){super(o,s,a,l,i,n),this.Z=v,this.X=new m}J(o,s){switch(o.type){case"server":return new E.SocketDebugAdapter(o);case"pipeServer":return new E.NamedPipeDebugAdapter(o);case"executable":return new E.ExecutableDebugAdapter(o,s.type)}return super.J(o,s)}S(o,s){const a=E.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(a)return new S.DebugAdapterExecutable(a.command,a.args,a.options)}K(){return new P.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(Y=>{this.X.onTerminalClosed(Y)}));const a=await this.F.getConfigProvider(),l=this.Z.getDefaultShell(!0),v=this.Z.getDefaultShellArgs(!0),i=o.title||u.localize(0,null),n=JSON.stringify({shell:l,shellArgs:v});let h=await this.X.checkout(n,i),b,p=!1;if(h)b=o.cwd;else{const Y={shellPath:l,shellArgs:v,cwd:o.cwd,name:i,iconPath:new S.ThemeIcon("debug")};p=!0,h=this.Z.createTerminalFromOptions(Y,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(h,n)}h.show(!0);const O=await h.processId;p?await new Promise(Y=>setTimeout(Y,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?h.sendText("cls"):l.indexOf("bash")>=0?h.sendText("clear"):A.isWindows?h.sendText("cls"):h.sendText("clear"));const W=(0,r.prepareCommand)(l,o.args,!!o.argsCanBeInterpretedByShell,b,o.env);h.sendText(W);const q=this.onDidTerminateDebugSession(Y=>{Y.id===s&&(this.X.free(h),q.dispose())});return O}else if(o.kind==="external")return y(o,await this.F.getConfigProvider());return super.$runInTerminal(o,s)}};f=Ve([We(0,L.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,g.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,k.IExtHostTerminalService),We(5,D.IExtHostEditorTabs),We(6,I.IExtHostVariableResolverProvider)],f),e.ExtHostDebugService=f;let w;function y(t,o){if(!w)if(A.isWindows)w=new R.WindowsExternalTerminalService;else if(A.isMacintosh)w=new R.MacExternalTerminalService;else if(A.isLinux)w=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return w.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class m{constructor(){this.b=new Map}async checkout(o,s){const l=[...this.b.entries()].map(([v,i])=>(0,c.createCancelablePromise)(async n=>{if(v.name!==s||i.lastUsedAt!==-1&&await(0,r.hasChildProcesses)(await v.processId))return null;const h=Date.now();return i.lastUsedAt+m.a>h||n.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=h,v)}));return await(0,c.firstParallel)(l,v=>!!v)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}m.a=1e3}),define(De[306],Ce([1,0,12,2,117,34,59,35,48,41,20,26,83,18,16,78,24,89,50]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends S.ExtHostTaskBase{constructor(m,t,o,s,a,l,v,i,n){super(m,t,o,s,a,l,v,i),this.B=o,this.C=n,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=S.TaskHandleDTO.from(o,this.B),a=await this.a.$getTaskExecution(s);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(a,t);return this.a.$executeTask(s).catch(()=>{}),l}else{const s=S.TaskDTO.from(t,m);if(s===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(s.execution)&&await this.x(s,t,!1);const a=await this.y(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),a}}u(m,t,o,s){const a=[];if(s)for(const l of s){this.z(l,o),(!l.definition||!m[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const v=S.TaskDTO.from(l,o.extension);v&&(a.push(v),S.CustomExecutionDTO.is(v.execution)&&t.push(this.x(v,l,!0)))}return{tasks:a,extension:o.extension}}async v(m){return m}async F(m){let t=m&&m.length>0?m[0]:void 0;if(!t){const o=A.URI.file((0,d.homedir)());t=new D.WorkspaceFolder({uri:o,name:r.basename(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,t){const o=A.URI.revive(m),s={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(o),l=await this.b.getWorkspaceFolders2()??[],v=await this.C.getResolver(),i=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const n of t.variables)s.variables[n]=await v.resolveAsync(i,n);if(t.process!==void 0){let n;if(t.process.path!==void 0){n=t.process.path.split(c.delimiter);for(let h=0;h<n.length;h++)n[h]=await v.resolveAsync(i,n[h])}s.process=await u.win32.findExecutable(await v.resolveAsync(i,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(i,t.process.cwd):void 0,n)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(m,t,o){return u.win32.findExecutable(m,t,o)}};w=Ve([We(0,L.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,P.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,g.IExtHostTerminalService),We(6,C.ILogService),We(7,E.IExtHostApiDeprecationService),We(8,f.IExtHostVariableResolverProvider)],w),e.ExtHostTask=w}),define(De[307],Ce([1,0,89,50]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends A.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(De[144],Ce([1,0,17,19,21,46,18,12,24,2,31]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(f,w,y,m){this.d=f,this.e=w,this.f=y,this.g=m,this.a=null,this.b=!1,this.c=0}search(f,w){const y=this.d.folderQueries||[],m=new u.CancellationTokenSource;return w.onCancellationRequested(()=>m.cancel()),new Promise((t,o)=>{this.a=new I(f);let s=!1;const a=(l,v)=>{if(!s&&!this.b){const i=this.h(l);E(l)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,s=!0,m.cancel(),l=this.j(l,this.d.maxResults-this.c));const n=this.h(l);this.c+=n,(n>0||!E(l))&&this.a.add(l,v)}};Promise.all(y.map((l,v)=>this.k(l,i=>a(i,v),m.token))).then(l=>{m.dispose(),this.a.flush();const v=l.some(i=>!!i&&!!i.limitHit);t({limitHit:this.b||v,messages:(0,c.flatten)(l.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},l=>{m.dispose();const v=(0,R.toErrorMessage)(l);o(new Error(v))})})}h(f){return E(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,w){const y=Array.isArray(f.ranges)?f.ranges:[f.ranges],m=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:y.slice(0,w),preview:{matches:m.slice(0,w),text:f.preview.text},uri:f.uri}}async k(f,w,y){const m=new L.QueryGlobTester(this.d,f),t=[],o={report:l=>{if(!this.l(l))return;const v=f.folder.scheme===P.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(D.dirname(l.uri))):void 0,i=D.relativePath(f.folder,l.uri);if(i){const n=m.includedInQuery(i,T.basename(i),v);(0,A.isThenable)(n)?t.push(n.then(h=>{h&&w(l)})):n&&w(l)}}},s=this.n(f),a=await this.e.provideTextSearchResults(S(this.d.contentPattern),s,o,y);return t.length&&await Promise.all(t),a}l(f){if(E(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const w=(0,L.resolvePatternsForProvider)(this.d.includePattern,f.includePattern),y=(0,L.resolvePatternsForProvider)(this.d.excludePattern,f.excludePattern),m={folder:g.URI.from(f.folder),excludes:y,includes:w,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.f.toCanonicalName(f.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return m.usePCRE2=this.d.usePCRE2,m}}e.TextSearchManager=k;function S(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class I{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new r(512,w=>this.g(w))}add(f,w){this.d&&(this.b!==w||!D.isEqual(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=w,this.d={resource:f.uri,results:[]}),this.d.results.push(C(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.TextSearchResultsCollector=I;function C(d){return E(d)?{preview:{matches:(0,c.mapArrayOrNot)(d.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:d.preview.text},ranges:(0,c.mapArrayOrNot)(d.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function E(d){return!!d.preview}e.extensionResultIsMatch=E;class r{constructor(f,w){this.g=f,this.h=w,this.c=0,this.d=[],this.e=0}addItem(f,w){!f||this.j(f,w)}addItems(f,w){!f||this.k(f,w)}j(f,w){this.d.push(f),this.e+=w,this.l()}k(f,w){this.d=this.d.concat(f),this.e+=w,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}r.a=4e3,r.b=50,e.BatchedCollector=r}),define(De[86],Ce([1,0,6,5,4,300,20,56,16,2,144]),function(re,e,c,A,u,R,P,T,D,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let k=class{constructor(E,r,d){this.k=E,this.l=r,this.n=d,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(E){return this.l.transformOutgoingScheme(E)}registerTextSearchProvider(E,r){if(this.g.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this.g.add(E);const d=this.d++;return this.e.set(d,r),this.c.$registerTextSearchProvider(d,this.o(E)),(0,c.toDisposable)(()=>{this.g.delete(E),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(E,r){if(this.i.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this.i.add(E);const d=this.d++;return this.h.set(d,r),this.c.$registerFileSearchProvider(d,this.o(E)),(0,c.toDisposable)(()=>{this.i.delete(E),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(E,r,d,f){const w=S(d),y=this.h.get(E);if(y)return this.j.fileSearch(w,y,m=>{this.c.$handleFileMatch(E,r,m.map(t=>t.resource))},f);throw new Error("unknown provider: "+E)}$clearCache(E){return this.j.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,r,d,f){const w=this.e.get(E);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const y=S(d);return this.q(y,w).search(t=>this.c.$handleTextMatch(E,r,t),f)}$enableExtensionHostSearch(){}q(E,r){return new L.TextSearchManager(E,r,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};k=Ve([We(0,P.IExtHostRpcService),We(1,T.IURITransformerService),We(2,D.ILogService)],k),e.ExtHostSearch=k;function S(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(I),extraFileResources:C.extraFileResources&&C.extraFileResources.map(E=>g.URI.revive(E))}}e.reviveQuery=S;function I(C){return{...C,folder:g.URI.revive(C.folder)}}}),define(De[308],Ce([1,0,91,143,34,140,35,40,59,41,83,85,86,100,55,78,142,79,49,99,77,60,141,16,50,98]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t,o,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,c.registerSingleton)(o.ILoggerService,t.ExtHostLoggerService,1),(0,c.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,c.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration,0),(0,c.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,c.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,c.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,0),(0,c.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(g.IExtHostTerminalService,g.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,c.registerSingleton)(r.IExtHostWindow,r.ExtHostWindow,0),(0,c.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,c.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,0),(0,c.registerSingleton)(y.IExtHostTelemetry,y.ExtHostTelemetry,0),(0,c.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs,0),(0,c.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService,0)}),define(De[101],Ce([1,0,17,16,31,82]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=P;function T(k,S,I,C){const E=(0,c.mapArrayOrNot)(I,D),r=new u.TextSearchMatch(S,E,C),d=r.preview.matches;return{ranges:(0,c.mapArrayOrNot)(E,g),uri:k,preview:{text:r.preview.text,matches:(0,c.mapArrayOrNot)(d,g)}}}e.createTextSearchResult=T;function D(k){return new u.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function g(k){return new R.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(S,I){this.a=S,this.b=I}appendLine(S){this.b.debug(`${this.a}#search`,S)}};L=Ve([We(1,A.ILogService)],L),e.OutputChannel=L}),define(De[309],Ce([1,0,47,12,87,33,11,8,101,310]),function(re,e,c,A,u,R,P,T,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(w,y,m,t){const o=S(w,y,m,t),s=y.folder.fsPath;return{cmd:c.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=k;function S(w,y,m,t){const o=["--files","--hidden","--case-sensitive"];C([y],m,!1).forEach(a=>{const l=(0,D.anchorGlob)(a);if(o.push("-g",l),P.isMacintosh){const v=(0,u.normalizeNFD)(l);v!==l&&o.push("-g",v)}});const s=I([y],t,void 0,!1);return s.globArgs.forEach(a=>{const l=`!${(0,D.anchorGlob)(a)}`;if(o.push("-g",l),P.isMacintosh){const v=(0,u.normalizeNFD)(l);v!==l&&o.push("-g",v)}}),y.disregardIgnoreFiles!==!1?o.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),y.ignoreSymlinks||o.push("--follow"),w.exists&&o.push("--quiet"),o.push("--no-config"),y.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function I(w,y,m,t=!0){const o=[];let s={};return w.forEach(a=>{const l=Object.assign({},a.excludePattern||{},y||{}),v=E(l,t?a.folder.fsPath:void 0,m);o.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:o,siblingClauses:s}}function C(w,y,m=!0){const t=[];return w.forEach(o=>{const s=Object.assign({},y||{},o.includePattern||{}),a=E(s,m?o.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function E(w,y,m){const t=[],o={};return Object.keys(w).forEach(s=>{if(m&&m.has(s)||!s)return;const a=w[s];s=d(y?r(y,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof a=="boolean"&&a?(s.startsWith("\\\\")&&(s+="**"),t.push(f(s))):a&&a.when&&(o[s]=a)}),{globArgs:t,siblingClauses:o}}function r(w,y){return A.isAbsolute(y)?y:A.join(w,y)}e.getAbsoluteGlob=r;function d(w){return w=T.rtrim(w,"\\"),T.rtrim(w,"/")}function f(w){return R.getRoot(w).toLowerCase()==="c:/"?w.replace(/^c:[/\\]/i,"/"):w}e.fixDriveC=f}),define(De[311],Ce([1,0,47,71,12,312,17,46,38,87,33,11,43,8,10,29,31,309,112]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const w=new Set;process.on("exit",()=>{w.forEach(s=>s())});class y{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&D.parse(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,f.prepareQuery)(this.b).normalizedLowercase),this.u=a.excludePattern&&D.parse(a.excludePattern),this.t=new Map,a.folderQueries.forEach(l=>{const v=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),i=l.folder.fsPath;a.folderQueries.map(n=>n.folder.fsPath).filter(n=>n!==i).forEach(n=>{(0,L.isEqualOrParent)(n,i)&&(v[u.relative(i,n)]=!0)}),this.t.set(i,new t(v,i))})}cancel(){this.l=!0,w.forEach(a=>a())}walk(a,l,v,i,n){if(this.m=S.StopWatch.create(!1),this.l)return n(null,this.j);l.forEach(h=>{const b=u.basename(h.fsPath);this.u&&this.u(h.fsPath,b)||this.J(v,{relativePath:h.fsPath,searchPath:void 0})}),this.r=S.StopWatch.create(!1),this.w(a,(h,b)=>{this.x(this.y,this,h,v,i,p=>{if(p){const O=(0,T.toErrorMessage)(p);console.error(O),this.q.push(O),b(p,void 0)}else b(null,void 0)})},(h,b)=>{this.m.stop();const p=h?P.coalesce(h)[0]:null;n(p,this.j)})}w(a,l,v){const i=new Array(a.length),n=new Array(a.length);let h=!1,b=0;if(a.length===0)return v(null,[]);a.forEach((p,O)=>{l(p,(W,q)=>{if(W?(h=!0,i[O]=null,n[O]=W):(i[O]=q,n[O]=null),++b===a.length)return v(h?n:null,i)})})}x(a,l,...v){try{a.apply(l,v)}catch(i){v[v.length-1](i)}}y(a,l,v,i){const n=a.folder.fsPath,h=k.isMacintosh,b=()=>Y&&Y.kill();w.add(b);let p=U=>{w.delete(b),p=()=>{},i(U)},O="";const W=this.D(),q=(0,d.spawnRipgrepCmd)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),Y=q.cmd,x=!Object.keys(q.siblingClauses).length,M=q.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${q.rgDiskPath} ${M}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),v({message:B}),this.s=0,this.z(Y,"utf8",v,(U,j,he)=>{if(U){p(U);return}if(this.j){p();return}const V=(O+(h?g.normalizeNFC(j||""):j)).split(`
`);if(he){const J=V.length;V[J-1]=V[J-1].trim(),V[J-1]||V.pop()}else O=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){p(new Error("Splitting up files failed"));return}if(this.s+=V.length,x){for(const J of V)if(this.J(l,{base:n,relativePath:J,searchPath:this.N(a,J)}),this.j){b();break}(he||this.j)&&p();return}this.G(a,W,n,V,l),he&&(this.H(W,n,l),p())})}spawnFindCmd(a){const l=this.t.get(a.folder.fsPath),v=l.getBasenameTerms(),i=l.getPathTerms(),n=["-L","."];if(v.length||i.length){n.push("-not","(","(");for(const h of v)n.push("-name",h),n.push("-o");for(const h of i)n.push("-path",h),n.push("-o");n.pop(),n.push(")","-prune",")")}return n.push("-type","f"),c.spawn("find",n,{cwd:a.folder.fsPath})}readStdout(a,l,v){let i="";this.z(a,l,()=>{},(n,h,b)=>{if(n){v(n);return}i+=h,b&&v(null,i)})}z(a,l,v,i){let n=(p,O,W)=>{(p||W)&&(n=()=>{},this.r?.stop()),i(p,O,W)},h=!1;a.stdout?(this.A(a.stdout,l,n),a.stdout.once("data",()=>h=!0)):v({message:"stdout is null"});let b;a.stderr?b=this.B(a.stderr):v({message:"stderr is null"}),a.on("error",p=>{n(p)}),a.on("close",p=>{let O;!h&&(O=this.C(b,l))&&o(O)?n(new Error(`command failed with error code ${p}: ${this.C(b,l)}`)):(this.g&&p===0&&(this.j=!0),n(null,"",!0))})}A(a,l,v){const i=new R.StringDecoder(l);return a.on("data",n=>{v(null,i.write(n))}),i}B(a){const l=[];return a.on("data",v=>{l.push(v)}),l}C(a,l){const v=new R.StringDecoder(l);return a.map(i=>v.write(i)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:l},v,i,n){i.indexOf(this.b)!==-1&&this.J(n,{base:v,relativePath:this.b,searchPath:this.N(a,this.b)});const h=b=>{const p=u.basename(b),O=u.dirname(b);let W=l[O];W||(W=l[O]=[],h(O)),W.push({base:v,relativePath:b,basename:p,searchPath:this.N(a,b)})};i.forEach(h)}H({rootEntries:a,pathToEntries:l},v,i){const n=this,h=this.t.get(v),b=this.b;function p(O){n.o++;const W=(0,r.hasSiblingFn)(()=>O.map(q=>q.basename));for(let q=0,Y=O.length;q<Y;q++){const x=O[q],{relativePath:M,basename:B}=x;if(h.test(M,B,b!==B?W:void 0))continue;const U=l[M];if(U)p(U);else{if(n.p++,M===b)continue;n.J(i,x)}if(n.j)break}}p(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,l,v,i,n){const h=a.folder,b=(0,r.hasSiblingFn)(()=>v);this.w(v,(p,O)=>{if(this.l||this.j)return O(null);const W=l?[l,p].join(u.sep):p;if(this.t.get(a.folder.fsPath).test(W,p,this.a.filePattern!==p?b:void 0))return O(null);const q=[h.fsPath,W].join(u.sep);A.lstat(q,(Y,x)=>{if(Y||this.l||this.j)return O(null);this.L(q,x,(M,B)=>M||this.l||this.j?O(null):B.isDirectory()?(this.o++,this.M(q,x,(U,j)=>U||this.l||this.j||(j=j||"",this.v[j])?O(null):(this.v[j]=!0,E.Promises.readdir(q).then(he=>{if(this.l||this.j)return O(null);this.I(a,W,he,i,ie=>O(ie||null))},he=>{O(null)})))):(this.p++,W===this.b||this.h&&C.isNumber(B.size)&&B.size>this.h||this.J(i,{base:h.fsPath,relativePath:W,searchPath:this.N(a,W)}),O(null,void 0)))})},p=>{const O=p&&P.coalesce(p);return n(O&&O.length>0?O[0]:void 0)})}J(a,l){this.K(l)&&(!this.d||this.d(l.relativePath,u.basename(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(l))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.isFilePatternMatch)(a,this.c)}return!0}L(a,l,v){return l.isSymbolicLink()?A.stat(a,v):v(null,l)}M(a,l,v){return l.isSymbolicLink()?A.realpath(a,(i,n)=>i?v(i):v(null,n)):v(null,a)}N(a,l){return a.folderName?u.join(a.folderName,l):l}}e.FileWalker=y;class m{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new y(a)}search(a,l,v){this.c.walk(this.a,this.b,a,l,(i,n)=>{v(i,{limitHit:n,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=m;class t{constructor(a,l){this.expression=a,this.c=l,this.d(a)}d(a){let l,v;Object.keys(a).filter(i=>a[i]).forEach(i=>{u.isAbsolute(i)?(l=l||D.getEmptyExpression(),l[i]=a[i]):(v=v||D.getEmptyExpression(),v[i]=a[i])}),this.a=l&&D.parse(l,{trimForExclusions:!0}),this.b=v&&D.parse(v,{trimForExclusions:!0})}test(a,l,v){return this.b&&this.b(a,l,v)||this.a&&this.a(u.join(this.c,a),l,v)}getBasenameTerms(){const a=[];return this.a&&a.push(...D.getBasenameTerms(this.a)),this.b&&a.push(...D.getBasenameTerms(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...D.getPathTerms(this.a)),this.b&&a.push(...D.getPathTerms(this.b)),a}}function o(s){const a=s.trim().split(`
`),l=a[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return I.uppercaseFirstLetter(a[a.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(De[313],Ce([1,0,104,22]),function(re,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===s)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,P=512,T=512*8,D=512*128;var g;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(g=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(a,l){super(a),this.decodeStreamErrorKind=l}}e.DecodeStreamError=L;class k{static async create(a){let l;if(a!==e.UTF8)l=(await new Promise((i,n)=>{re(["@vscode/iconv-lite-umd"],i,n)})).getDecoder(E(a));else{const v=new TextDecoder;l={write(i){return v.decode(i,{stream:!0})},end(){return v.decode()}}}return new k(l)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function S(s,a){const l=a.minBytesRequiredForDetection??a.guessEncoding?T:P;return new Promise((v,i)=>{const n=(0,c.newWriteableStream)(q=>q.join("")),h=[];let b=0,p;const O=async()=>{try{const q=await o({buffer:A.VSBuffer.concat(h),bytesRead:b},a.guessEncoding);if(q.seemsBinary&&a.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await a.overwriteEncoding(q.encoding),p=await k.create(q.encoding);const Y=p.write(A.VSBuffer.concat(h).buffer);n.write(Y),h.length=0,b=0,v({stream:n,detected:q})}catch(q){W?.dispose(),n.destroy(),i(q)}},W=(0,c.listenStream)(s,{onData:async q=>{p?n.write(p.write(q.buffer)):(h.push(q),b+=q.byteLength,b>=l&&(s.pause(),await O(),setTimeout(()=>s.resume())))},onError:q=>n.error(q),onEnd:async()=>{p||await O(),n.end(p?.end())}})})}e.toDecodeStream=S;async function I(s,a,l){const i=(await new Promise((b,p)=>{re(["@vscode/iconv-lite-umd"],b,p)})).getEncoder(E(a),l);let n=!1,h=!1;return{read(){if(h)return null;const b=s.read();if(typeof b!="string"){if(h=!0,!n&&l?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const p=i.end();return p&&p.length>0?(n=!0,A.VSBuffer.wrap(p)):null}return n=!0,A.VSBuffer.wrap(i.write(b))}}}e.toEncodeReadable=I;async function C(s){return(await new Promise((l,v)=>{re(["@vscode/iconv-lite-umd"],l,v)})).encodingExists(E(s))}e.encodingExists=C;function E(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=E;function r(s,a){if(!s||a<e.UTF16be_BOM.length)return null;const l=s.readUInt8(0),v=s.readUInt8(1);if(l===e.UTF16be_BOM[0]&&v===e.UTF16be_BOM[1])return e.UTF16be;if(l===e.UTF16le_BOM[0]&&v===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const i=s.readUInt8(2);return l===e.UTF8_BOM[0]&&v===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=r;const d=["ascii","utf-16","utf-32"];async function f(s){const a=await new Promise((h,b)=>{re(["jschardet"],h,b)}),l=s.slice(0,D),v=m(l.buffer),i=a.detect(v);if(!i||!i.encoding)return null;const n=i.encoding.toLowerCase();return 0<=d.indexOf(n)?null:y(i.encoding)}const w={ibm866:"cp866",big5:"cp950"};function y(s){const a=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[a]||a}function m(s){let a="";for(let l=0;l<s.length;l++)a+=String.fromCharCode(s[l]);return a}function t(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=s.match(/windows(\d+)/);return a?"windows-"+a[1]:s}}}e.toCanonicalName=t;function o({buffer:s,bytesRead:a},l){let v=r(s,a),i=!1;if(v!==e.UTF16be&&v!==e.UTF16le&&s){let n=!0,h=!0,b=!1;for(let p=0;p<a&&p<R;p++){const O=p%2===1,W=s.readUInt8(p)===0;if(W&&(b=!0),n&&(O&&!W||!O&&W)&&(n=!1),h&&(O&&W||!O&&!W)&&(h=!1),W&&!n&&!h)break}b&&(n?v=e.UTF16le:h?v=e.UTF16be:i=!0)}return l&&!i&&!v&&s?f(s.slice(0,a)).then(n=>({seemsBinary:!1,encoding:n})):{seemsBinary:i,encoding:v}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[145],Ce([1,0,313,29,144]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends u.TextSearchManager{constructor(T,D,g=A,L="searchProcess"){super(T,D,{readdir:k=>g.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,c.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=R}),define(De[314],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(u){if(u&&this.a.has(u)){const R=this.a.get(u);return this.a.delete(u),R}}addDragOperationTransfer(u,R){this.a.set(u,R)}getRenderedTreeElement(u){if(this.b.has(u))return this.b.get(u)}addRenderedTreeItemElement(u,R){this.b.set(u,R)}removeRenderedTreeItemElement(u){this.b.has(u)&&this.b.delete(u)}}e.TreeviewsService=c}),define(De[315],Ce([1,0,187,7,24,2,3,6,229,19,7,10,17,13,21,314,27]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(y,m){if((0,k.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let t;return Array.isArray(y.highlights)&&(t=y.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:y.label,highlights:t}}}class f{constructor(m,t,o){this.d=m,this.e=t,this.f=o,this.a=new Map,this.b=new E.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(l=>s(l)?this.i(l):l):a})}registerTreeDataProvider(m,t,o){const s=this.createTreeView(m,{treeDataProvider:t},o);return{dispose:()=>s.dispose()}}createTreeView(m,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,i=this.h(m,t,o),n=this.d.$registerTreeViewDataProvider(m,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:l,hasHandleDrop:v});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,r.checkProposedApiEnabled)(o,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(h){i.message=h},get title(){return i.title},set title(h){i.title=h},get description(){return i.description},set description(h){i.description=h},get badge(){return i.badge},set badge(h){h!==void 0&&L.ViewBadge.isViewBadge(h)?i.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(i.badge=void 0)},reveal:(h,b)=>i.reveal(h,b),dispose:async()=>{await n,this.a.delete(m),i.dispose()}}}$getChildren(m,t){const o=this.a.get(m);return o?o.getChildren(t):Promise.reject(new D.NoTreeViewError(m))}async $handleDrop(m,t,o,s,a,l,v,i){const n=this.a.get(m);if(!n)return Promise.reject(new D.NoTreeViewError(m));const h=I.DataTransfer.toDataTransfer(o,async b=>(await this.d.$resolveDropFileData(m,t,b)).buffer);return v===m&&i&&await this.g(h,n,i,a,l),n.onDrop(h,s,a)}async g(m,t,o,s,a){const l=this.b.removeDragOperationTransfer(a);if(l)(await l)?.forEach((v,i)=>{v&&m.set(i,v)});else if(a&&t.handleDrag){const v=t.handleDrag(o,m,s);this.b.addDragOperationTransfer(a,v),await v}return m}async $handleDrag(m,t,o,s){const a=this.a.get(m);if(!a)return Promise.reject(new D.NoTreeViewError(m));const l=await this.g(new A.DataTransfer,a,t,s,o);if(!!l)return I.DataTransfer.toDataTransferDTO(l)}async $hasResolve(m){const t=this.a.get(m);if(!t)throw new D.NoTreeViewError(m);return t.hasResolve}$resolve(m,t,o){const s=this.a.get(m);if(!s)throw new D.NoTreeViewError(m);return s.resolveTreeItem(t,o)}$setExpanded(m,t,o){const s=this.a.get(m);if(!s)throw new D.NoTreeViewError(m);s.setExpanded(t,o)}$setSelection(m,t){const o=this.a.get(m);if(!o)throw new D.NoTreeViewError(m);o.setSelection(t)}$setFocus(m,t){const o=this.a.get(m);if(!o)throw new D.NoTreeViewError(m);o.setFocus(t)}$setVisible(m,t){const o=this.a.get(m);if(!o)throw new D.NoTreeViewError(m);o.setVisible(t)}$changeCheckboxState(m,t){const o=this.a.get(m);if(!o)throw new D.NoTreeViewError(m);o.setCheckboxState(t)}h(m,t,o){const s=new w(m,t,this.d,this.e.converter,this.f,o);return this.a.set(m,s),s}i(m){const t=this.a.get(m.$treeViewId);return t&&"$treeItemHandle"in m?t.getExtensionElement(m.$treeItemHandle):t&&"$focusedTreeItem"in m&&m.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=f;class w extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(m,t,o,s,a,l){if(super(),this.z=m,this.C=o,this.F=s,this.G=a,this.H=l,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.q=this.D(new P.Emitter),this.onDidExpandElement=this.q.event,this.r=this.D(new P.Emitter),this.onDidCollapseElement=this.r.event,this.s=this.D(new P.Emitter),this.onDidChangeSelection=this.s.event,this.t=this.D(new P.Emitter),this.onDidChangeVisibility=this.t.event,this.u=this.D(new P.Emitter),this.onDidChangeCheckboxState=this.u.event,this.v=this.D(new P.Emitter),this.w=Promise.resolve(),this.y=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,l.contributes&&l.contributes.views)for(const n in l.contributes.views)for(const h of l.contributes.views[n])h.id===m&&(this.J=h.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.D(this.f.onDidChangeTreeData(n=>this.v.fire({message:!1,element:n})));let v,i;this.D(P.Event.debounce(this.v.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(v||(v=new Promise(b=>i=b),this.w=this.w.then(()=>v)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.y=this.y.then(()=>{const b=i;return v=null,this.U(h).then(()=>b())})),n&&this.C.$setMessage(this.z,this.I)}))}async getChildren(m){const t=m?this.getExtensionElement(m):void 0;if(m&&!t)return this.G.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let o=this.Q(m);return o||(o=await this.R(t)),o?o.map(s=>s.item):void 0}getExtensionElement(m){return this.i.get(m)}reveal(m,t){t=t||{select:!0,focus:!1};const o=(0,k.isUndefinedOrNull)(t.select)?!0:t.select,s=(0,k.isUndefinedOrNull)(t.focus)?!1:t.focus,a=(0,k.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.w.then(()=>this.N(m)).then(l=>this.P(m,l[l.length-1]).then(v=>this.C.$reveal(this.z,{item:v.item,parentChain:l.map(i=>i.item)},{select:o,focus:s,expand:a})),l=>this.G.error(l)):this.C.$reveal(this.z,void 0,{select:o,focus:s,expand:a})}get message(){return this.I}set message(m){this.I=m,this.v.fire({message:!0,element:!1})}get title(){return this.J}set title(m){this.J=m,this.C.$setTitle(this.z,m,this.L)}get description(){return this.L}set description(m){this.L=m,this.C.$setTitle(this.z,this.J,m)}get badge(){return this.M}set badge(m){this.M?.value===m?.value&&this.M?.tooltip===m?.tooltip||(this.M=I.ViewBadge.from(m),this.C.$setBadge(this.z,m))}setExpanded(m,t){const o=this.getExtensionElement(m);o&&(t?this.q.fire(Object.freeze({element:o})):this.r.fire(Object.freeze({element:o})))}setSelection(m){(0,S.equals)(this.l,m)||(this.l=m,this.s.fire(Object.freeze({selection:this.selectedElements})))}setFocus(m){this.m=m}setVisible(m){m!==this.k&&(this.k=m,this.t.fire(Object.freeze({visible:this.k})))}async setCheckboxState(m){const t=(await Promise.all(m.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.u.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(m,t,o){const s=[];for(const a of m){const l=this.getExtensionElement(a);l&&s.push(l)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,o),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(m,t,o){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,g.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,m,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(m,t){if(!this.f.resolveTreeItem)return;const o=this.i.get(m);if(o){const s=this.j.get(o);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,o,t)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(m){return this.O(m).then(t=>t?this.N(t).then(o=>this.P(t,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}O(m){const t=this.j.get(m);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,g.asPromise)(()=>this.f.getParent(m))}P(m,t){const o=this.j.get(m);return o?Promise.resolve(o):(0,g.asPromise)(()=>this.f.getTreeItem(m)).then(s=>this.gb(m,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const l=this.j.get(a);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(m){if(m){let t;if(typeof m=="string"){const o=this.getExtensionElement(m);t=o?this.j.get(o):void 0}else t=m;return t&&t.children||void 0}return this.h}async R(m){this.nb(m);const t=new C.CancellationTokenSource(this.S.token);try{const o=m?this.j.get(m):void 0,s=await this.f.getChildren(m);if(t.token.isCancellationRequested)return;const a=await Promise.all((0,S.coalesce)(s||[]).map(async l=>{const v=await this.f.getTreeItem(l);return v&&!t.token.isCancellationRequested?this.Z(l,v,o):null}));return t.token.isCancellationRequested?void 0:(0,S.coalesce)(a)}finally{t.dispose()}}U(m){if(m.some(o=>!o))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.C.$refresh(this.z);{const o=this.W(m);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(m){const t=new Set,o=m.map(a=>this.j.get(a));for(const a of o)if(a&&!t.has(a.item.handle)){let l=a;for(;l&&l.parent&&o.findIndex(v=>l&&l.parent&&v&&v.item.handle===l.parent.item.handle)===-1;){const v=this.i.get(l.parent.item.handle);l=v?this.j.get(v):void 0}l&&!l.parent&&t.add(a.item.handle)}const s=[];return t.forEach(a=>{const l=this.i.get(a);if(l){const v=this.j.get(l);v&&(!v.parent||!t.has(v.parent.item.handle))&&s.push(a)}}),s}X(m){const t={};return Promise.all(m.map(o=>this.Y(o).then(s=>{s&&(t[o]=s.item)}))).then(()=>Object.keys(t).length?this.C.$refresh(this.z,t):void 0)}Y(m){const t=this.getExtensionElement(m);if(t){const o=this.j.get(t);if(o)return this.nb(t),(0,g.asPromise)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const a=this.eb(t,s,o.parent);return this.lb(t,a,o,o.parent),o.dispose(),a}return null})}return Promise.resolve(null)}Z(m,t,o){const s=this.eb(m,t,o);if(t.id&&this.i.has(s.item.handle))throw new Error((0,c.localize)(0,null,t.id));return this.kb(m,s),this.mb(s,o),s}ab(m){return L.MarkdownString.isMarkdownString(m)?I.MarkdownString.from(m):m}bb(m,t){return t?{...this.F.toInternal(t,m),originalId:t.command}:void 0}cb(m){if(!m.checkboxState)return;let t,o;return typeof m.checkboxState=="number"?t=m.checkboxState:(t=m.checkboxState.state,o=m.checkboxState.tooltip),{isChecked:t===L.TreeItemCheckboxState.Checked,tooltip:o}}db(m){if(!L.TreeItem.isTreeItem(m,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(m,t,o){this.db(t);const s=new T.DisposableStore,a=this.gb(m,t,o),l=this.hb(t);return{item:{handle:a,parentHandle:o?o.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.ib(t)||l,themeIcon:this.fb(t),collapsibleState:(0,k.isUndefinedOrNull)(t.collapsibleState)?L.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(m){return m.iconPath instanceof L.ThemeIcon?m.iconPath:void 0}gb(m,{id:t,label:o,resourceUri:s},a,l){if(t)return`${w.b}/${t}`;const v=d(o,this.H),i=a?a.item.handle:w.a;let n=v?v.label:s?(0,u.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(m)?this.j.get(m).item.handle:void 0,b=this.Q(a)||[];let p,O=0;do{if(p=`${i}/${O}:${n}`,l||!this.i.has(p)||h===p)break;O++}while(O<=b.length);return p}hb(m){if(m.iconPath&&!(m.iconPath instanceof L.ThemeIcon))return typeof m.iconPath=="string"||R.URI.isUri(m.iconPath)?this.jb(m.iconPath):this.jb(m.iconPath.light)}ib(m){if(m.iconPath&&!(m.iconPath instanceof L.ThemeIcon)&&m.iconPath.dark)return this.jb(m.iconPath.dark)}jb(m){return R.URI.isUri(m)?m:R.URI.file(m)}kb(m,t){this.i.set(t.item.handle,m),this.j.set(m,t)}lb(m,t,o,s){this.i.delete(t.item.handle),this.j.delete(m),t.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(m,t);const a=this.Q(s)||[],l=a.filter(v=>v.item.handle===o.item.handle)[0];l&&a.splice(a.indexOf(l),1,t)}mb(m,t){t?(t.children||(t.children=[]),t.children.push(m)):(this.h||(this.h=[]),this.h.push(m))}nb(m){if(m){const t=this.j.get(m);if(t){if(t.children)for(const o of t.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}t.children=void 0}}else this.pb()}ob(m){const t=this.j.get(m);if(t){if(t.children)for(const o of t.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}this.j.delete(m),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(m=>m.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.C.$disposeTree(this.z)}}w.a="0",w.b="1"}),define(De[316],Ce([1,0,21,9,3,37,2,122,108,154,165,45,5,97,256,255,40,257,35,259,260,261,244,262,59,42,263,264,269,270,271,143,247,277,278,279,100,41,281,315,13,7,74,284,81,142,34,25,236,268,73,140,83,85,86,16,56,20,26,272,243,55,78,253,282,80,79,287,285,286,254,49,280,283,99,60,77,273,82,274,18,125,246,225,265,6,27,230,98,221,275,276,267,266]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t,o,s,a,l,v,i,n,h,b,p,O,W,q,Y,x,M,B,U,j,he,ie,V,J,ne,ve,ue,ee,N,K,le,me,ke,Z,ce,de,te,ae,oe,F,z,G,_,fe,Ee,Ae,we,Pe,Ie,ze,qe,tt,Qe,it,rt,Be,et,$,Q,ge,Le,Ne,je,Ye,Xe,nt,ot,pt,bt,St,Pt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xt(ft){const vt=ft.get(te.IExtHostInitDataService),Ot=ft.get(ze.IExtHostFileSystemInfo),Ut=ft.get(Ee.IExtHostConsumerFileSystem),Nt=ft.get(a.IExtHostExtensionService),wt=ft.get(ne.IExtHostWorkspace),kt=ft.get(rt.IExtHostTelemetry),At=ft.get(f.IExtHostConfiguration),Bt=ft.get(ce.IURITransformerService),Ke=ft.get(de.IExtHostRpcService),Wt=ft.get(Y.IExtHostStorage),Re=ft.get(fe.IExtensionStoragePaths),Fe=ft.get(Z.ILoggerService),Se=ft.get(Z.ILogService),se=ft.get(F.IExtHostTunnelService),Oe=ft.get(z.IExtHostApiDeprecationService),He=ft.get(J.IExtHostWindow),Ze=ft.get(Qe.IExtHostSecretState),Ge=ft.get(it.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Fe),Ke.set(S.ExtHostContext.ExtHostWorkspace,wt),Ke.set(S.ExtHostContext.ExtHostConfiguration,At),Ke.set(S.ExtHostContext.ExtHostExtensionService,Nt),Ke.set(S.ExtHostContext.ExtHostStorage,Wt),Ke.set(S.ExtHostContext.ExtHostTunnelService,se),Ke.set(S.ExtHostContext.ExtHostWindow,He),Ke.set(S.ExtHostContext.ExtHostSecretState,Ze),Ke.set(S.ExtHostContext.ExtHostTelemetry,kt),Ke.set(S.ExtHostContext.ExtHostEditorTabs,Ge);const ct=Ke.set(S.ExtHostContext.ExtHostDecorations,ft.get(K.IExtHostDecorations)),mt=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(s.IExtHostDocumentsAndEditors)),gt=Ke.set(S.ExtHostContext.ExtHostCommands,ft.get(r.IExtHostCommands)),dt=Ke.set(S.ExtHostContext.ExtHostTerminalService,ft.get(x.IExtHostTerminalService)),lt=Ke.set(S.ExtHostContext.ExtHostDebugService,ft.get(me.IExtHostDebugService)),yt=Ke.set(S.ExtHostContext.ExtHostSearch,ft.get(ke.IExtHostSearch)),Tt=Ke.set(S.ExtHostContext.ExtHostTask,ft.get(le.IExtHostTask)),Ht=Ke.set(S.ExtHostContext.ExtHostOutputService,ft.get(b.IExtHostOutputService)),Ft=Ke.set(S.ExtHostContext.ExtHostLocalization,ft.get(ot.IExtHostLocalizationService)),ai=Ke.set(S.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ke)),Rt=Ke.set(S.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ke,mt)),yi=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Ke,mt,Se)),ci=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Se,Rt,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),It=Ke.set(S.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,gt,mt,Rt)),li=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(It)),ui=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new Le.ExtHostNotebookEditors(Se,It)),Zt=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new Be.ExtHostNotebookKernels(Ke,vt,It,gt,Se)),Di=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new $.ExtHostNotebookRenderers(Ke,It)),Dt=Ke.set(S.ExtHostContext.ExtHostEditors,new M.ExtHostEditors(Ke,mt)),di=Ke.set(S.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),gt,Se)),zi=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),Dt,vt.remote)),ei=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Ke,Se,Ot,mt)),ii=Ke.set(S.ExtHostContext.ExtHostLanguages,new n.ExtHostLanguages(Ke,Rt,gt.converter,Bt)),ht=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ke,Bt,Rt,gt,ei,Se,Oe,kt)),ti=Ke.set(S.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ke,ht)),Vt=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Ke,Se,mt)),Qt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,wt,gt)),hi=Ke.set(S.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(Ke,gt,Se)),Ci=Ke.set(S.ExtHostContext.ExtHostQuickDiff,new St.ExtHostQuickDiff(Ke,Bt)),Ii=Ke.set(S.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ke,gt,Rt)),fi=Ke.set(S.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),ki=Ke.set(S.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(Ke)),mi=Ke.set(S.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Ke)),gi=Ke.set(S.ExtHostContext.ExtHostAuthentication,new G.ExtHostAuthentication(Ke)),Ti=Ke.set(S.ExtHostContext.ExtHostTimeline,new _.ExtHostTimeline(Ke,gt)),ni=Ke.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,vt.remote,wt,Se,Oe)),ri=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new Pe.ExtHostWebviewPanels(Ke,ni,wt)),Pi=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ke,Rt,Re,ni,ri)),$i=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Ke,ni)),Yt=Ke.set(S.ExtHostContext.ExtHostTesting,new qe.ExtHostTesting(Ke,gt,mt)),Ai=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ke)),Wi=Ke.set(S.ExtHostContext.ExtHostProfileContentHandlers,new bt.ExtHostProfileContentHandlers(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ke,It,mt,gt,Se));const Hi=Ke.set(S.ExtHostContext.ExtHostInteractiveEditor,new $t.ExtHostInteractiveEditor(Ke,Rt,Se)),Ni=Ke.set(S.ExtHostContext.ExtHostInteractiveSession,new Pt.ExtHostInteractiveSession(Ke,Se)),ji=Object.values(S.ExtHostContext);Ke.assertRegistered(ji);const Vi=new Ie.ExtHostBulkEdits(Ke,mt),qi=new E.ExtHostClipboard(Ke),si=new h.ExtHostMessageService(Ke,Se),pi=new y.ExtHostDialogs(Ke),Fi=new q.ExtHostStatusBar(Ke,gt.converter);return C.ExtHostApiCommands.register(gt),function($e,xt,oi){const Et=function(){let be=!$e.isUnderDevelopment;function ye(){be||(Se.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(st){if(Array.isArray(st))st.forEach(Ue);else if(typeof st=="string")ye();else{const Ct=st;typeof Ct.scheme>"u"&&ye(),typeof Ct.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return st}}(),xi={getSession(be,ye,Ue){return gi.getSession($e,be,ye,Ue)},async hasSession(be,ye){return(0,Xe.checkProposedApiEnabled)($e,"authSession"),!!await gi.getSession($e,be,ye,{silent:!0})},get onDidChangeSessions(){return gi.onDidChangeSessions},registerAuthenticationProvider(be,ye,Ue,st){return gi.registerAuthenticationProvider(be,ye,Ue,st)}},Gi={registerCommand(be,ye,Ue){return gt.registerCommand(!0,be,ye,Ue,void 0,$e)},registerTextEditorCommand(be,ye,Ue){return gt.registerCommand(!0,be,(...st)=>{const Ct=Dt.getActiveTextEditor();if(!Ct){Se.warn("Cannot execute "+be+" because there is no active text editor.");return}return Ct.edit(Lt=>{ye.apply(Ue,[Ct,Lt,...st])}).then(Lt=>{Lt||Se.warn("Edits from command "+be+" were not applied.")},Lt=>{Se.warn("An error occurred while running command "+be,Lt)})},void 0,void 0,$e)},registerDiffInformationCommand:(be,ye,Ue)=>((0,Xe.checkProposedApiEnabled)($e,"diffCommand"),gt.registerCommand(!0,be,async(...st)=>{const Ct=mt.activeEditor(!0);if(!Ct){Se.warn("Cannot execute "+be+" because there is no active text editor.");return}const Lt=await Dt.getDiffInformation(Ct.id);ye.apply(Ue,[Lt,...st])},void 0,void 0,$e)),executeCommand(be,...ye){return gt.executeCommand(be,...ye)},getCommands(be=!1){return gt.getCommands(be)}},Mi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return qi.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Xe.checkProposedApiEnabled)($e,"envShellEvent"),dt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be){return rt.ExtHostTelemetryLogger.validateSender(be),kt.instantiateLogger($e,be)},openExternal(be,ye){return He.openUri(be,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===vt.environment.appUriScheme)return ai.createAppUri(be);try{return await He.asExternalUri(be,{allowTunneling:!!vt.remote.authority})}catch(ye){if((0,ge.matchesScheme)(be,Q.Schemas.http)||(0,ge.matchesScheme)(be,Q.Schemas.https))return be;throw ye}},get remoteName(){return(0,N.getRemoteName)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)($e,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel}};vt.environment.extensionTestsLocationURI||Object.freeze(Mi);const Ri={createTestController(be,ye,Ue){return Yt.createTestController($e,be,ye,Ue)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.createTestObserver()},runTests(be){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.runTests(be)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Yt.results}},bi=vt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Gt={getExtension(be,ye){(0,Xe.isProposedApiEnabled)($e,"extensionsAny")||(ye=!1);const Ue=xt.mine.getExtensionDescription(be);if(Ue)return new a.Extension(Nt,$e.identifier,Ue,bi,!1);if(ye){const st=xt.all.getExtensionDescription(be);if(st)return new a.Extension(Nt,$e.identifier,st,bi,!0)}},get all(){const be=[];for(const ye of xt.mine.getAllExtensionDescriptions())be.push(new a.Extension(Nt,$e.identifier,ye,bi,!1));return be},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)($e,"extensionsAny");const be=new ve.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const st=!be.has(Ue.identifier);ye.push(new a.Extension(Nt,$e.identifier,Ue,bi,st))}return ye},get onDidChange(){return(0,Xe.isProposedApiEnabled)($e,"extensionsAny")?u.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},vi={createDiagnosticCollection(be){return ei.createDiagnosticCollection($e.identifier,be)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:be=>ei.getDiagnostics(be),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(be,ye){return ii.changeLanguage(be.uri,ye)},match(be,ye){const Ue=Rt.getDocumentData(ye.uri)?.notebook;return(0,L.score)(U.LanguageSelector.from(be),ye.uri,ye.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,ye,Ue){return ht.registerCodeActionProvider($e,Et(be),ye,Ue)},registerDocumentPasteEditProvider(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)($e,"documentPaste"),ht.registerDocumentPasteEditProvider($e,Et(be),ye,Ue)},registerCodeLensProvider(be,ye){return ht.registerCodeLensProvider($e,Et(be),ye)},registerDefinitionProvider(be,ye){return ht.registerDefinitionProvider($e,Et(be),ye)},registerDeclarationProvider(be,ye){return ht.registerDeclarationProvider($e,Et(be),ye)},registerImplementationProvider(be,ye){return ht.registerImplementationProvider($e,Et(be),ye)},registerTypeDefinitionProvider(be,ye){return ht.registerTypeDefinitionProvider($e,Et(be),ye)},registerHoverProvider(be,ye){return ht.registerHoverProvider($e,Et(be),ye,$e.identifier)},registerEvaluatableExpressionProvider(be,ye){return ht.registerEvaluatableExpressionProvider($e,Et(be),ye,$e.identifier)},registerInlineValuesProvider(be,ye){return ht.registerInlineValuesProvider($e,Et(be),ye,$e.identifier)},registerDocumentHighlightProvider(be,ye){return ht.registerDocumentHighlightProvider($e,Et(be),ye)},registerLinkedEditingRangeProvider(be,ye){return ht.registerLinkedEditingRangeProvider($e,Et(be),ye)},registerReferenceProvider(be,ye){return ht.registerReferenceProvider($e,Et(be),ye)},registerRenameProvider(be,ye){return ht.registerRenameProvider($e,Et(be),ye)},registerDocumentSymbolProvider(be,ye,Ue){return ht.registerDocumentSymbolProvider($e,Et(be),ye,Ue)},registerWorkspaceSymbolProvider(be){return ht.registerWorkspaceSymbolProvider($e,be)},registerDocumentFormattingEditProvider(be,ye){return ht.registerDocumentFormattingEditProvider($e,Et(be),ye)},registerDocumentRangeFormattingEditProvider(be,ye){return ht.registerDocumentRangeFormattingEditProvider($e,Et(be),ye)},registerOnTypeFormattingEditProvider(be,ye,Ue,...st){return ht.registerOnTypeFormattingEditProvider($e,Et(be),ye,[Ue].concat(st))},registerDocumentSemanticTokensProvider(be,ye,Ue){return ht.registerDocumentSemanticTokensProvider($e,Et(be),ye,Ue)},registerDocumentRangeSemanticTokensProvider(be,ye,Ue){return ht.registerDocumentRangeSemanticTokensProvider($e,Et(be),ye,Ue)},registerSignatureHelpProvider(be,ye,Ue,...st){return typeof Ue=="object"?ht.registerSignatureHelpProvider($e,Et(be),ye,Ue):ht.registerSignatureHelpProvider($e,Et(be),ye,typeof Ue>"u"?[]:[Ue,...st])},registerCompletionItemProvider(be,ye,...Ue){return ht.registerCompletionItemProvider($e,Et(be),ye,Ue)},registerInlineCompletionItemProvider(be,ye){return ye.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider($e,Et(be),ye)},registerDocumentLinkProvider(be,ye){return ht.registerDocumentLinkProvider($e,Et(be),ye)},registerColorProvider(be,ye){return ht.registerColorProvider($e,Et(be),ye)},registerFoldingRangeProvider(be,ye){return ht.registerFoldingRangeProvider($e,Et(be),ye)},registerSelectionRangeProvider(be,ye){return ht.registerSelectionRangeProvider($e,be,ye)},registerCallHierarchyProvider(be,ye){return ht.registerCallHierarchyProvider($e,be,ye)},registerTypeHierarchyProvider(be,ye){return ht.registerTypeHierarchyProvider($e,be,ye)},setLanguageConfiguration:(be,ye)=>ht.setLanguageConfiguration($e,be,ye),getTokenInformationAtPosition(be,ye){return(0,Xe.checkProposedApiEnabled)($e,"tokenInformation"),ii.tokenAtPosition(be,ye)},registerInlayHintsProvider(be,ye){return ht.registerInlayHintsProvider($e,be,ye)},createLanguageStatusItem(be,ye){return ii.createLanguageStatusItem($e,be,ye)},registerDocumentDropEditProvider(be,ye){return ht.registerDocumentOnDropEditProvider($e,be,ye)}},Ki={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(be,ye,Ue){const st=await(P.URI.isUri(be)?Promise.resolve(zt.openTextDocument(be)):Promise.resolve(be));return Dt.showTextDocument(st,ye,Ue)},createTextEditorDecorationType(be){return Dt.createTextEditorDecorationType($e,be)},onDidChangeActiveTextEditor(be,ye,Ue){return Dt.onDidChangeActiveTextEditor(be,ye,Ue)},onDidChangeVisibleTextEditors(be,ye,Ue){return Dt.onDidChangeVisibleTextEditors(be,ye,Ue)},onDidChangeTextEditorSelection(be,ye,Ue){return Dt.onDidChangeTextEditorSelection(be,ye,Ue)},onDidChangeTextEditorOptions(be,ye,Ue){return Dt.onDidChangeTextEditorOptions(be,ye,Ue)},onDidChangeTextEditorVisibleRanges(be,ye,Ue){return Dt.onDidChangeTextEditorVisibleRanges(be,ye,Ue)},onDidChangeTextEditorViewColumn(be,ye,Ue){return Dt.onDidChangeTextEditorViewColumn(be,ye,Ue)},onDidCloseTerminal(be,ye,Ue){return dt.onDidCloseTerminal(be,ye,Ue)},onDidOpenTerminal(be,ye,Ue){return dt.onDidOpenTerminal(be,ye,Ue)},onDidChangeActiveTerminal(be,ye,Ue){return dt.onDidChangeActiveTerminal(be,ye,Ue)},onDidChangeTerminalDimensions(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)($e,"terminalDimensions"),dt.onDidChangeTerminalDimensions(be,ye,Ue)},onDidChangeTerminalState(be,ye,Ue){return dt.onDidChangeTerminalState(be,ye,Ue)},onDidWriteTerminalData(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(be,ye,Ue)},get state(){return He.state},onDidChangeWindowState(be,ye,Ue){return He.onDidChangeWindowState(be,ye,Ue)},showInformationMessage(be,...ye){return si.showMessage($e,R.default.Info,be,ye[0],ye.slice(1))},showWarningMessage(be,...ye){return si.showMessage($e,R.default.Warning,be,ye[0],ye.slice(1))},showErrorMessage(be,...ye){return si.showMessage($e,R.default.Error,be,ye[0],ye.slice(1))},showQuickPick(be,ye,Ue){return Qt.showQuickPick($e,be,ye,Ue)},showWorkspaceFolderPick(be){return Qt.showWorkspaceFolderPick(be)},showInputBox(be,ye){return Qt.showInput(be,ye)},showOpenDialog(be){return pi.showOpenDialog($e,be)},showSaveDialog(be){return pi.showSaveDialog(be)},createStatusBarItem(be,ye,Ue){let st,Ct,Lt;return typeof be=="string"?(st=be,Ct=ye,Lt=Ue):(Ct=be,Lt=ye),Fi.createStatusBarEntry($e,st,Ct,Lt)},setStatusBarMessage(be,ye){return Fi.setStatusBarMessage(be,ye)},withScmProgress(be){return Oe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),fi.withProgress($e,{location:j.ProgressLocation.SourceControl},(ye,Ue)=>be({report(st){}}))},withProgress(be,ye){return fi.withProgress($e,be,ye)},createOutputChannel(be,ye){return Ht.createOutputChannel(be,ye,$e)},createWebviewPanel(be,ye,Ue,st){return ri.createWebviewPanel($e,be,ye,Ue,st)},createWebviewTextEditorInset(be,ye,Ue,st){return(0,Xe.checkProposedApiEnabled)($e,"editorInsets"),zi.createWebviewEditorInset(be,ye,Ue,st,$e)},createTerminal(be,ye,Ue){return typeof be=="object"?"pty"in be?dt.createExtensionTerminal(be):dt.createTerminalFromOptions(be):dt.createTerminal(be,ye,Ue)},registerTerminalLinkProvider(be){return dt.registerLinkProvider(be)},registerTerminalProfileProvider(be,ye){return dt.registerProfileProvider($e,be,ye)},registerTerminalQuickFixProvider(be,ye){return(0,Xe.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(be,$e.identifier.value,ye)},registerTreeDataProvider(be,ye){return di.registerTreeDataProvider(be,ye,$e)},createTreeView(be,ye){return di.createTreeView(be,ye,$e)},registerWebviewPanelSerializer:(be,ye)=>ri.registerWebviewPanelSerializer($e,be,ye),registerCustomEditorProvider:(be,ye,Ue={})=>Pi.registerCustomEditorProvider($e,be,ye,Ue),registerFileDecorationProvider(be){return ct.registerFileDecorationProvider(be,$e)},registerUriHandler(be){return ai.registerUriHandler($e.identifier,be)},createQuickPick(){return Qt.createQuickPick($e)},createInputBox(){return Qt.createInputBox($e)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(be,ye,Ue){return mi.onDidChangeActiveColorTheme(be,ye,Ue)},registerWebviewViewProvider(be,ye,Ue){return $i.registerWebviewViewProvider($e,be,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ye,Ue){return It.onDidChangeActiveNotebookEditor(be,ye,Ue)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,ye,Ue){return ui.onDidChangeNotebookEditorSelection(be,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(be,ye,Ue){return ui.onDidChangeNotebookEditorVisibleRanges(be,ye,Ue)},showNotebookDocument(be,ye){return It.showNotebookDocument(be,ye)},registerExternalUriOpener(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)($e,"externalUriOpener"),Ai.registerExternalUriOpener($e.identifier,be,ye,Ue)},registerProfileContentHandler(be,ye){return(0,Xe.checkProposedApiEnabled)($e,"profileContentHandlers"),Wi.registrProfileContentHandler($e,be,ye)},registerQuickDiffProvider(be,ye,Ue,st){return(0,Xe.checkProposedApiEnabled)($e,"quickDiffProvider"),Ci.registerQuickDiffProvider(Et(be),ye,Ue,st)},get tabGroups(){return Ge.tabGroups}},zt={get rootPath(){return Oe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(be){throw A.readonly()},getWorkspaceFolder(be){return wt.getWorkspaceFolder(be)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(be){throw A.readonly()},get workspaceFile(){return wt.workspaceFile},set workspaceFile(be){throw A.readonly()},updateWorkspaceFolders:(be,ye,...Ue)=>wt.updateWorkspaceFolders($e,be,ye||0,...Ue),onDidChangeWorkspaceFolders:function(be,ye,Ue){return wt.onDidChangeWorkspace(be,ye,Ue)},asRelativePath:(be,ye)=>wt.getRelativePath(be,ye),findFiles:(be,ye,Ue,st)=>wt.findFiles(be,ye,Ue,$e.identifier,st),findTextInFiles:(be,ye,Ue,st)=>{(0,Xe.checkProposedApiEnabled)($e,"findTextInFiles");let Ct,Lt;return typeof ye=="object"?(Ct=ye,Lt=Ue):(Ct={},Lt=ye,st=Ue),wt.findTextInFiles(be,Ct||{},Lt,$e.identifier,st)},saveAll:be=>wt.saveAll(be),applyEdit(be,ye){return Vi.applyWorkspaceEdit(be,$e,ye)},createFileSystemWatcher:(be,ye,Ue,st)=>Vt.createFileSystemWatcher(wt,$e,be,ye,Ue,st),get textDocuments(){return Rt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw A.readonly()},openTextDocument(be){let ye;const Ue=be;if(typeof be=="string")ye=Promise.resolve(P.URI.file(be));else if(P.URI.isUri(be))ye=Promise.resolve(be);else if(!Ue||typeof Ue=="object")ye=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(st=>Rt.ensureDocumentData(st).then(Ct=>Ct.document))},onDidOpenTextDocument:(be,ye,Ue)=>Rt.onDidAddDocument(be,ye,Ue),onDidCloseTextDocument:(be,ye,Ue)=>Rt.onDidRemoveDocument(be,ye,Ue),onDidChangeTextDocument:(be,ye,Ue)=>Rt.onDidChangeDocument(be,ye,Ue),onDidSaveTextDocument:(be,ye,Ue)=>Rt.onDidSaveDocument(be,ye,Ue),onWillSaveTextDocument:(be,ye,Ue)=>ci.getOnWillSaveTextDocumentEvent($e)(be,ye,Ue),get notebookDocuments(){return It.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ye){let Ue;if(P.URI.isUri(be))Ue=be,await It.openNotebookDocument(be);else if(typeof be=="string")Ue=P.URI.revive(await It.createNotebookDocument({viewType:be,content:ye}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,ye,Ue){return li.onDidSaveNotebookDocument(be,ye,Ue)},onDidChangeNotebookDocument(be,ye,Ue){return li.onDidChangeNotebookDocument(be,ye,Ue)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(be,ye,Ue,st){return It.registerNotebookSerializer($e,be,ye,Ue,(0,Xe.isProposedApiEnabled)($e,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(be,ye,Ue)=>oi.onDidChangeConfiguration(be,ye,Ue),getConfiguration(be,ye){return ye=arguments.length===1?void 0:ye,oi.getConfiguration(be,ye,$e)},registerTextDocumentContentProvider(be,ye){return yi.registerTextDocumentContentProvider(be,ye)},registerTaskProvider:(be,ye)=>(Oe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider($e,be,ye)),registerFileSystemProvider(be,ye,Ue){return(0,Ye.combinedDisposable)(ti.registerFileSystemProvider($e,be,ye,Ue),Ut.addFileSystemProvider(be,ye))},get fs(){return Ut.value},registerFileSearchProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)($e,"fileSearchProvider"),yt.registerFileSearchProvider(be,ye)),registerTextSearchProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)($e,"textSearchProvider"),yt.registerTextSearchProvider(be,ye)),registerRemoteAuthorityResolver:(be,ye)=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),Nt.registerRemoteAuthorityResolver(be,ye)),registerResourceLabelFormatter:be=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),ki.$registerResourceLabelFormatter(be)),onDidCreateFiles:(be,ye,Ue)=>Vt.onDidCreateFile(be,ye,Ue),onDidDeleteFiles:(be,ye,Ue)=>Vt.onDidDeleteFile(be,ye,Ue),onDidRenameFiles:(be,ye,Ue)=>Vt.onDidRenameFile(be,ye,Ue),onWillCreateFiles:(be,ye,Ue)=>Vt.getOnWillCreateFileEvent($e)(be,ye,Ue),onWillDeleteFiles:(be,ye,Ue)=>Vt.getOnWillDeleteFileEvent($e)(be,ye,Ue),onWillRenameFiles:(be,ye,Ue)=>Vt.getOnWillRenameFileEvent($e)(be,ye,Ue),openTunnel:be=>((0,Xe.checkProposedApiEnabled)($e,"tunnels"),se.openTunnel($e,be).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,Xe.checkProposedApiEnabled)($e,"tunnels"),se.getTunnels()},onDidChangeTunnels:(be,ye,Ue)=>((0,Xe.checkProposedApiEnabled)($e,"tunnels"),se.onDidChangeTunnels(be,ye,Ue)),registerPortAttributesProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)($e,"portsAttributes"),se.registerPortsAttributesProvider(be,ye)),registerTimelineProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)($e,"timeline"),Ti.registerTimelineProvider(be,ye,$e.identifier,gt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:be=>((0,Xe.checkProposedApiEnabled)($e,"workspaceTrust"),wt.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ye,Ue)=>wt.onDidGrantWorkspaceTrust(be,ye,Ue),registerEditSessionIdentityProvider:(be,ye)=>((0,Xe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(be,ye)),onWillCreateEditSessionIdentity:(be,ye,Ue)=>((0,Xe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),wt.getOnWillCreateEditSessionIdentityEvent($e)(be,ye,Ue))},wi={get inputBox(){return Oe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox($e)},createSourceControl(be,ye,Ue){return hi.createSourceControl($e,be,ye,Ue)}},Xi={createCommentController(be,ye){return Ii.createCommentController($e,be,ye)}},Qi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(be,ye,Ue){return lt.onDidStartDebugSession(be,ye,Ue)},onDidTerminateDebugSession(be,ye,Ue){return lt.onDidTerminateDebugSession(be,ye,Ue)},onDidChangeActiveDebugSession(be,ye,Ue){return lt.onDidChangeActiveDebugSession(be,ye,Ue)},onDidReceiveDebugSessionCustomEvent(be,ye,Ue){return lt.onDidReceiveDebugSessionCustomEvent(be,ye,Ue)},onDidChangeBreakpoints(be,ye,Ue){return lt.onDidChangeBreakpoints(be,ye,Ue)},registerDebugConfigurationProvider(be,ye,Ue){return lt.registerDebugConfigurationProvider(be,ye,Ue||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ye){return lt.registerDebugAdapterDescriptorFactory($e,be,ye)},registerDebugAdapterTrackerFactory(be,ye){return lt.registerDebugAdapterTrackerFactory(be,ye)},startDebugging(be,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?lt.startDebugging(be,ye,{parentSession:Ue}):lt.startDebugging(be,ye,Ue||{})},stopDebugging(be){return lt.stopDebugging(be)},addBreakpoints(be){return lt.addBreakpoints(be)},removeBreakpoints(be){return lt.removeBreakpoints(be)},asDebugSourceUri(be,ye){return lt.asDebugSourceUri(be,ye)}},Yi={registerTaskProvider:(be,ye)=>Tt.registerTaskProvider($e,be,ye),fetchTasks:be=>Tt.fetchTasks(be),executeTask:be=>Tt.executeTask($e,be),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(be,ye,Ue)=>Tt.onDidStartTask(be,ye,Ue),onDidEndTask:(be,ye,Ue)=>Tt.onDidEndTask(be,ye,Ue),onDidStartTaskProcess:(be,ye,Ue)=>Tt.onDidStartTaskProcess(be,ye,Ue),onDidEndTaskProcess:(be,ye,Ue)=>Tt.onDidEndTaskProcess(be,ye,Ue)},Ji={createNotebookController(be,ye,Ue,st,Ct){return Zt.createNotebookController($e,be,ye,Ue,st,(0,Xe.isProposedApiEnabled)($e,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(be,ye)=>It.registerNotebookCellStatusBarItemProvider($e,be,ye),createRendererMessaging(be){return Di.createRendererMessaging($e,be)},createNotebookControllerDetectionTask(be){return(0,Xe.checkProposedApiEnabled)($e,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask($e,be)},registerKernelSourceActionProvider(be,ye){return(0,Xe.checkProposedApiEnabled)($e,"notebookKernelSource"),Zt.registerKernelSourceActionProvider($e,be,ye)},onDidChangeNotebookCellExecutionState(be,ye,Ue){return(0,Xe.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(be,ye,Ue)}},_i={t(...be){if(typeof be[0]=="string"){const ye=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return Ft.getMessage($e.identifier.value,{message:ye,args:Ue})}return Ft.getMessage($e.identifier.value,be[0])},get bundle(){return Ft.getBundle($e.identifier.value)},get uri(){return Ft.getBundleUri($e.identifier.value)}},Zi={_version:1,registerInteractiveEditorSessionProvider(be){return(0,Xe.checkProposedApiEnabled)($e,"interactive"),Hi.registerProvider($e,be)},registerInteractiveSessionProvider(be,ye){return(0,Xe.checkProposedApiEnabled)($e,"interactive"),Ni.registerInteractiveSessionProvider($e,be,ye)},addInteractiveRequest(be){return(0,Xe.checkProposedApiEnabled)($e,"interactive"),Ni.addInteractiveSessionRequest(be)}};return{version:vt.version,authentication:xi,commands:Gi,comments:Xi,debug:Qi,env:Mi,extensions:Gt,interactive:Zi,l10n:_i,languages:vi,notebooks:Ji,scm:wi,tasks:Yi,tests:Ri,window:Ki,workspace:zt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:g.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:I.UIKind,Uri:P.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:he.TelemetryTrustedValue,LogLevel:Z.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Xt}),define(De[317],Ce([1,0,289,326,327,2,328]),function(re,e,c,A,u,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(k,S,I,C,E,r){const d=r.environment.useHostProxy,f=typeof d=="boolean"?d:!r.remote.isRemote,w=(0,P.createProxyResolver)({resolveProxy:m=>k.resolveProxy(m),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(m,t,...o)=>{switch(m){case P.LogLevel.Trace:C.trace(t,...o);break;case P.LogLevel.Debug:C.debug(t,...o);break;case P.LogLevel.Info:C.info(t,...o);break;case P.LogLevel.Warning:C.warn(t,...o);break;case P.LogLevel.Error:C.error(t,...o);break;case P.LogLevel.Critical:C.error(t,...o);break;case P.LogLevel.Off:break;default:s(m,t,o);break}function s(a,l,...v){C.error("Unknown log level",a),C.error(l,...v)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:f,env:process.env}),y=D(S,w);return L(I,y)}e.connectProxyResolver=T;function D(k,S){const I={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(E=>{I.config=k.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(E=>{C.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,P.createHttpPatch)(c,S,{config:"off"},C,!0)),on:Object.assign({},c,(0,P.createHttpPatch)(c,S,{config:"on"},C,!0)),override:Object.assign({},c,(0,P.createHttpPatch)(c,S,{config:"override"},C,!0)),onRequest:Object.assign({},c,(0,P.createHttpPatch)(c,S,I,C,!0)),default:Object.assign(c,(0,P.createHttpPatch)(c,S,I,C,!1))},https:{off:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"off"},C,!0)),on:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"on"},C,!0)),override:Object.assign({},A,(0,P.createHttpPatch)(A,S,{config:"override"},C,!0)),onRequest:Object.assign({},A,(0,P.createHttpPatch)(A,S,I,C,!0)),default:Object.assign(A,(0,P.createHttpPatch)(A,S,I,C,!1))},tls:Object.assign(u,(0,P.createTlsPatch)(u))}}const g=new Map;function L(k,S){return k.getExtensionPathIndex().then(I=>{const C=globalThis._VSCODE_NODE_MODULES.module,E=C._load;C._load=function(d,f,w){if(d==="tls")return S.tls;if(d!=="http"&&d!=="https")return E.apply(this,arguments);const y=S[d],m=I.findSubstr(R.URI.file(f.filename));let t=g.get(m);if(t||g.set(m,t={}),!t[d]){const o=y.default;t[d]={...o}}return t[d]}})}}),define(De[318],Ce([1,0,84,316,303,317,42,291,2,18,7,288,116,290]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends u.RequireInterceptor{j(){const d=this,f=globalThis._VSCODE_NODE_MODULES.module,w=f._load;f._load=function(o,s,a){return o=m(o),d.a.has(o)?d.a.get(o).load(o,D.URI.file((0,S.realpathSync)(s.filename)),l=>w.apply(this,[l,s,a])):w.apply(this,arguments)};const y=f._resolveLookupPaths;f._resolveLookupPaths=(t,o)=>y.call(this,m(t),o);const m=t=>{for(const o of d.b){const s=o(t);if(s){t=s;break}}return t}}}class E extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async pb(){this.h.createInstance(I.ExtHostConsoleForwarder);const d=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const y=this.h.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=y.ipcHandlePath}await this.h.createInstance(C,d,{mine:this.F,all:this.G}).install(),c.mark("code/extHost/didInitAPI");const w=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,w,this,this.l,this.t,this.f),c.mark("code/extHost/didInitProxyResolver")}qb(d){return d.main}async rb(d,f,w){if(f.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let y=null;w.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this.l.flush();const m=d?.identifier.value;d&&await this.q.initializeLocalizedMessages(d);try{m&&c.mark(`code/extHost/willLoadExtensionCode/${m}`),y=re.__$__nodeRequire(f.fsPath)}finally{m&&c.mark(`code/extHost/didLoadExtensionCode/${m}`),w.codeLoadingStop()}return y}async $setRemoteEnvironment(d){if(!!this.f.remote.isRemote)for(const f in d){const w=d[f];w===null?delete process.env[f]:process.env[f]=w}}}e.ExtHostExtensionService=E}),define(De[146],Ce([1,0,47,329,312,17,61,38,12,8,2,31,82,330,310,101]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const r=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(p){this.a=p}provideTextSearchResults(p,O,W,q){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...O,folder:O.folder.toString()})}`),new Promise((Y,x)=>{q.onCancellationRequested(()=>J());const M=o(p,O),B=O.folder.fsPath,U=M.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");this.a.appendLine(`${r} ${U}
 - cwd: ${B}`);let j=c.spawn(r,M,{cwd:B});j.on("error",N=>{console.error(N),this.a.appendLine("Error: "+(N&&N.message)),x((0,k.serializeSearchError)(new k.SearchError(N&&N.message,k.SearchErrorCode.rgProcessError)))});let he=!1;const ie=new y(O.maxResults,B,O.previewOptions);ie.on("result",N=>{he=!0,ve="",W.report(N)});let V=!1;const J=()=>{V=!0,j?.kill(),ie?.cancel()};let ne=!1;ie.on("hitLimit",()=>{ne=!0,J()});let ve="";j.stdout.on("data",N=>{ie.handleData(N),he||(ve+=N)});let ue=!1;j.stdout.once("data",()=>ue=!0);let ee="";j.stderr.on("data",N=>{const K=N.toString();this.a.appendLine(K),ee.length+K.length<1e6&&(ee+=K)}),j.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(he?"Got result from parser":"No result from parser"),ve&&this.a.appendLine(`Got data without result: ${ve}`),this.a.appendLine(""),V)Y({limitHit:ne});else{ie.flush(),j=null;let N;ee&&!ue&&(N=f(ee))?x((0,k.serializeSearchError)(new k.SearchError(N.message,N.code))):Y({limitHit:ne})}})})}}e.RipgrepTextSearchEngine=d;function f(b){const p=b.split(`
`),O=p[0].trim();if(p.some(q=>q.startsWith("regex parse error")))return new k.SearchError(w(p),k.SearchErrorCode.regexParseError);const W=O.match(/grep config error: unknown encoding: (.*)/);if(W)return new k.SearchError(`Unknown encoding: ${W[1]}`,k.SearchErrorCode.unknownEncoding);if(O.startsWith("error parsing glob"))return new k.SearchError(O.charAt(0).toUpperCase()+O.substr(1),k.SearchErrorCode.globParseError);if(O.startsWith("the literal"))return new k.SearchError(O.charAt(0).toUpperCase()+O.substr(1),k.SearchErrorCode.invalidLiteral);if(O.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(O,k.SearchErrorCode.regexParseError)}function w(b){const p=["Regex parse error"],O=b.filter(W=>W.startsWith("PCRE2:"));if(O.length>=1){const W=O[0].replace("PCRE2:","");if(W.indexOf(":")!==-1&&W.split(":").length>=2){const q=W.split(":")[1];p.push(":"+q)}}return p.join("")}class y extends A.EventEmitter{constructor(p,O,W){super(),this.g=p,this.h=O,this.j=W,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new u.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,O){return super.on(p,O),this}handleData(p){if(this.b)return;const O=typeof p=="string"?p:this.d.write(p);this.k(O)}k(p){let O=p.indexOf(`
`);const W=this.a+p;if(O>=0)O+=this.a.length;else{this.a=W;return}let q=0;for(;O>=0;)this.m(W.substring(q,O).trim()),q=O+1,O=W.indexOf(`
`,q);this.a=W.substring(q)}m(p){if(this.b||!p)return;let O;try{O=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(O.type==="match"){const W=m(O.data.path),q=L.URI.file(D.join(this.h,W)),Y=this.n(O.data,q);this.p(Y),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(O.type==="context"){const W=m(O.data.path),q=L.URI.file(D.join(this.h,W));this.o(O.data,q).forEach(x=>this.p(x))}}n(p,O){const W=p.line_number-1,q=m(p.lines),Y=Buffer.from(q);let x=0,M=0,B=W;p.submatches.length===0&&p.submatches.push(q.length?{start:0,end:1,match:{text:q[0]}}:{start:0,end:0,match:{text:""}});const U=(0,R.coalesce)(p.submatches.map((j,he)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=m(j.match),V=Y.slice(x,j.start).toString(),J=t(V),ne=J.numLines>0?J.lastLineLength:J.lastLineLength+M,ve=t(ie),ue=J.numLines+B,ee=ve.numLines+ue,N=ve.numLines>0?ve.lastLineLength:ve.lastLineLength+ne;return x=j.end,M=N,B=ee,new S.Range(ue,ne,ee,N)}));return(0,E.createTextSearchResult)(O,q,U,this.j)}o(p,O){const W=m(p.lines),q=p.line_number;return W.replace(/\r?\n$/,"").split(`
`).map((Y,x)=>({text:Y,uri:O,lineNumber:q+x}))}p(p){this.emit("result",p)}}e.RipgrepParser=y;function m(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const p=/\n/g;let O=0,W=-1,q;for(;q=p.exec(b);)O++,W=q.index;const Y=W>=0?b.length-W-1:b.length;return{numLines:O,lastLineLength:Y}}function o(b,p){const O=["--hidden"];O.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:W,otherIncludes:q}=(0,P.groupBy)(p.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(q&&q.length){const x=new Set;q.forEach(M=>{x.add(M)}),O.push("-g","!*"),x.forEach(M=>{s(M).map(E.anchorGlob).forEach(B=>{O.push("-g",B)})})}W&&W.length&&W.forEach(x=>{O.push("-g",x)}),p.excludes.map(E.anchorGlob).forEach(x=>O.push("-g",`!${x}`)),p.maxFileSize&&O.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||O.push("--no-ignore-parent"):O.push("--no-ignore"),p.followSymlinks&&O.push("--follow"),p.encoding&&p.encoding!=="utf8"&&O.push("--encoding",p.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,g.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),p.usePCRE2&&O.push("--pcre2"),O.push("--crlf"),b.isRegExp&&(b.pattern=a(b.pattern),O.push("--engine","auto"));let Y;if(b.isWordMatch){const M=(0,g.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");O.push("--regexp",M)}else if(b.isRegExp){let x=v(b.pattern);x=i(x),O.push("--regexp",x)}else Y=b.pattern,O.push("--fixed-strings");return O.push("--no-config"),p.useGlobalIgnoreFiles||O.push("--no-ignore-global"),O.push("--json"),b.isMultiline&&O.push("--multiline"),p.beforeContext&&O.push("--before-context",p.beforeContext+""),p.afterContext&&O.push("--after-context",p.afterContext+""),O.push("--"),Y&&O.push(Y),O.push("."),O}e.getRgArgs=o;function s(b){return h(b).flatMap(O=>{const W=(0,T.splitGlobAware)(O,"/");return W.map((q,Y)=>W.slice(0,Y+1).join("/"))})}function a(b){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(p);)b=b.replace(p,"$1\\x{$2}");const O=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(O);)b=b.replace(O,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=a;const l=b=>b.type==="Assertion"&&b.kind==="lookbehind";function v(b){let p;try{p=new I.RegExpParser().parsePattern(b)}catch{return b}let O="",W=0;const q=(M,B,U)=>{O+=b.slice(W,M)+U,W=B},Y=[];return new I.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=Y[0];if(!B)q(M.start,M.end,"\\r?\\n");else if(!Y.some(l))if(B.type==="CharacterClass")if(B.negate){const U=b.slice(B.start+2,M.start)+b.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?q(B.start,B.end,U?`[^${U}]`:"."):q(B.start,B.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=b.slice(B.start+1,M.start)+b.slice(M.end,B.end-1);q(B.start,B.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else B.type==="Quantifier"&&q(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){Y.unshift(M)},onQuantifierLeave(){Y.shift()},onCharacterClassRangeEnter(M){Y.unshift(M)},onCharacterClassRangeLeave(){Y.shift()},onCharacterClassEnter(M){Y.unshift(M)},onCharacterClassLeave(){Y.shift()},onAssertionEnter(M){l(M)&&Y.push(M)},onAssertionLeave(M){Y[0]===M&&Y.shift()}}).visit(p),O+=b.slice(W),O}e.fixRegexNewline=v;function i(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function n(b){let p=!1,O=!1,W="",q="";for(let Y=0;Y<b.length;Y++){const x=b[Y];switch(x){case"\\":O?(p?q+="\\"+x:W+="\\"+x,O=!1):O=!0;break;case"{":if(O)p?q+=x:W+=x,O=!1;else{if(p)return{strInBraces:W+"{"+q+"{"+b.substring(Y+1)};p=!0}break;case"}":if(O)p?q+=x:W+=x,O=!1;else{if(p)return{fixedStart:W,strInBraces:q,fixedEnd:b.substring(Y+1)};W+=x}break;default:p?q+=(O?"\\":"")+x:W+=(O?"\\":"")+x,O=!1;break}}return{strInBraces:W+(p?"{"+q:"")}}function h(b){const{fixedStart:p,strInBraces:O,fixedEnd:W}=n(b);if(p===void 0||W===void 0)return[O];let q=(0,T.splitGlobAware)(O,",");q.length||(q=[""]);const Y=h(W);return q.flatMap(x=>{const M=p+x;return Y.map(B=>M+B)})}e.performBraceExpansionForRipgrep=h}),define(De[319],Ce([1,0,21,146,126,18]),function(re,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,L,k,S){const I=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:R.Schemas.file})},E=new u.Progress(r=>k.report({...r,uri:r.uri.with({scheme:L.folder.scheme})}));return this.c(S,r=>I.provideTextSearchResults(g,C,E,r))}else return this.c(S,C=>I.provideTextSearchResults(g,L,k,C))}async c(g,L){const k=T(g);this.a.add(k);const S=await L(k.token);return this.a.delete(k),S}d(){this.a.forEach(g=>g.cancel())}}e.RipgrepSearchProvider=P;function T(D){const g=new c.CancellationTokenSource;return D.onCancellationRequested(()=>g.cancel()),g}}),define(De[320],Ce([1,0,29,146,145]),function(re,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(D){this.a=D}search(D,g,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(I){L({message:I})}},S=new u.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(k),c);return new Promise((I,C)=>S.search(E=>{g(E.map(P))},D).then(E=>I({limitHit:E.limitHit,type:"success",stats:E.stats}),C))}}e.TextSearchEngineAdapter=R;function P(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((D,g)=>{if(g.ranges){const L=g;return D+(Array.isArray(L.ranges)?L.ranges.length:1)}else return D+1},0)}}}),define(De[321],Ce([1,0,17,19,9,3,112,12,43,2,45,31,311,320]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let m;const t=d(y),o=new R.Emitter({onDidAddFirstListener:()=>{m=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(S.Engine,t,a=>o.fire(a),s)),m.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{m.cancel()}});return o.event}textSearch(y){let m;const t=d(y),o=new R.Emitter({onDidAddFirstListener:()=>{m=(0,A.createCancelablePromise)(s=>this.f(t,a=>o.fire(a),s)),m.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{m.cancel()}});return o.event}f(y,m,t){return y.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(y).search(t,m,m)}doFileSearch(y,m,t){return this.doFileSearchWithEngine(S.Engine,y,m,t)}doFileSearchWithEngine(y,m,t,o,s=C.a){let a=0;const l=i=>{Array.isArray(i)?(a+=i.length,t(i.map(n=>this.g(n)))):i.relativePath?(a++,t(this.g(i))):t(i)};if(m.sortByScore){let i=this.k(m,l,o);if(!i){const n=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new y(n);i=this.h(h,m,t,l,o)}return new Promise((n,h)=>{i.then(([b,p])=>{const O=p.map(W=>this.g(W));this.n(O,t,s),n(b)},h)})}const v=new y(m);return this.q(v,l,s,o).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}g(y){return{path:y.base?(0,T.join)(y.base,y.relativePath):y.relativePath}}h(y,m,t,o,s){const a=new R.Emitter;let l=(0,A.createCancelablePromise)(i=>{let n=[];const h=b=>{Array.isArray(b)?n=b:(o(b),a.fire(b))};return this.q(y,h,-1,i).then(b=>[b,n])}),v;if(m.cacheKey){v=this.j(m.cacheKey);const i={promise:l,event:a.event,resolved:!1};v.resultsToSearchCache[m.filePattern||""]=i,l.then(()=>{i.resolved=!0},n=>{delete v.resultsToSearchCache[m.filePattern||""]}),l=this.r(l)}return l.then(([i,n])=>{const h=v?v.scorerCache:Object.create(null),b=(typeof m.maxResults!="number"||m.maxResults>0)&&D.StopWatch.create(!1);return this.l(m,n,h,s).then(p=>{const O=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:O,fromCache:!1,type:this.d,workspaceFolderCount:m.folderQueries.length,resultCount:p.length},messages:i.messages,limitHit:i.limitHit||typeof m.maxResults=="number"&&n.length>m.maxResults},p]})})}j(y){const m=this.b[y];return m||(this.b[y]=new E)}k(y,m,t){const o=y.cacheKey&&this.b[y.cacheKey];if(!o)return;const s=this.o(o,y.filePattern||"",m,t);if(s)return s.then(([a,l,v])=>{const i=D.StopWatch.create(!1);return this.l(y,l,o.scorerCache,t).then(n=>{const h=i.elapsed(),b={fromCache:!0,detailStats:v,type:this.d,resultCount:l.length,sortingTime:h};return[{type:"success",limitHit:a.limitHit||typeof y.maxResults=="number"&&l.length>y.maxResults,stats:b},n]})})}l(y,m,t,o){const s=(0,P.prepareQuery)(y.filePattern||""),a=(v,i)=>(0,P.compareItemsByFuzzyScore)(v,i,s,!0,r,t),l=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return c.topAsync(m,a,l,1e4,o)}n(y,m,t){if(t&&t>0)for(let o=0;o<y.length;o+=t)m(y.slice(o,o+t));else m(y)}o(y,m,t,o){const s=D.StopWatch.create(!1),a=m.indexOf(T.sep)>=0;let l;for(const h in y.resultsToSearchCache)if(m.startsWith(h)){if(a&&h.indexOf(T.sep)<0&&h!=="")continue;const b=y.resultsToSearchCache[h];l={promise:this.r(b.promise),event:b.event,resolved:b.resolved};break}if(!l)return null;const v=s.elapsed(),i=D.StopWatch.create(!1),n=l.event(t);return o&&o.onCancellationRequested(()=>{n.dispose()}),l.promise.then(([h,b])=>{if(o&&o.isCancellationRequested)throw(0,u.canceled)();const p=[],O=(0,P.prepareQuery)(m).normalizedLowercase;for(const W of b)!(0,k.isFilePatternMatch)(W,O)||p.push(W);return[h,p,{cacheWasResolved:l.resolved,cacheLookupTime:v,cacheFilterTime:i.elapsed(),cacheEntryCount:b.length}]})}q(y,m,t,o){return new Promise((s,a)=>{let l=[];o?.onCancellationRequested(()=>y.cancel()),y.search(v=>{v&&(t?(l.push(v),t>0&&l.length>=t&&(m(l),l=[])):m(v))},v=>{m(v)},(v,i)=>{l.length&&m(l),v?a(v):s(i)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}r(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,t){return y.then(m,t)}catch(m){return this.then(void 0,m)}finally(m){return y.finally(m)}}}}C.a=512,e.SearchService=C;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(w){return(0,T.basename)(w.relativePath)}getItemDescription(w){return(0,T.dirname)(w.relativePath)}getItemPath(w){return w.relativePath}};function d(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(f),extraFileResources:w.extraFileResources&&w.extraFileResources.map(y=>g.URI.revive(y))}}function f(w){return{...w,folder:g.URI.revive(w.folder)}}}),define(De[322],Ce([1,0,6,18,2,29,16,26,20,86,56,31,321,319,101,145]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let r=class extends g.ExtHostSearch{constructor(f,w,y,m){super(f,y,m),this.s=R,this.t=-1,this.v=null,this.w=!1;const t=new C.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new I.RipgrepSearchProvider(t)),w.remote.isRemote&&w.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const f=new C.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new I.RipgrepSearchProvider(f)),this.y(A.Schemas.file,new S.SearchService("fileSearchProvider"))}y(f,w){const y=this.d++;return this.v=w,this.t=y,this.c.$registerFileSearchProvider(y,this.o(f)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(f,w,y,m){const t=(0,g.reviveQuery)(y);return f===this.t?this.z(f,w,t,m):super.$provideFileSearchResults(f,w,y,m)}z(f,w,y,m){const t=o=>{if((0,k.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(f,w,o.map(s=>u.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,t,m)}$clearCache(f){return this.v?.clearCache(f),super.$clearCache(f)}q(f,w){return new E.NativeTextSearchManager(f,w,void 0,"textSearchProvider")}};r=Ve([We(0,D.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,P.ILogService)],r),e.NativeExtHostSearch=r}),define(De[323],Ce([1,0,91,294,306,305,322,318,295,85,42,86,83,41,55,80,293,292,16,307,50,223,90]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d,f,w,y,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,c.registerSingleton)(f.ILoggerService,d.ExtHostLoggerService,1),(0,c.registerSingleton)(f.ILogService,new t.SyncDescriptor(m.ExtHostLogService,[!1],!0)),(0,c.registerSingleton)(E.IExtensionStoragePaths,r.ExtensionStoragePaths,0),(0,c.registerSingleton)(g.IExtHostDebugService,R.ExtHostDebugService,0),(0,c.registerSingleton)(k.IExtHostSearch,P.NativeExtHostSearch,0),(0,c.registerSingleton)(S.IExtHostTask,u.ExtHostTask,0),(0,c.registerSingleton)(I.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,c.registerSingleton)(C.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,c.registerSingleton)(y.IExtHostVariableResolverProvider,w.NodeExtHostVariableResolverProviderService,0)}),define(De[331],Ce([1,0,233,332,84,9,119,120,211,97,304,22,29,116,19,122,228,241,308,323]),function(re,e,c,A,u,R,P,T,D,g,L,k,S,I,C,E,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let v=0;v<process.execArgv.length;v++)process.execArgv[v]==="--inspect-port=0"&&(process.execArgv.splice(v,1),v--)}();const f=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,v=l._load;l._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return v.apply(this,arguments)}})();const w=process.exit.bind(process);function y(l){process.exit=function(v){if(l)w(v);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const v=new Error("An extension called process.crash() and this was prevented.");console.warn(v.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(l){w()};function t(){const l=(0,d.readExtHostConnection)(process.env);if(l.type===3)return new Promise((v,i)=>{const n=h=>{const b=h[0],p=new P.BufferedEmitter;b.on("message",O=>p.fire(k.VSBuffer.wrap(O.data))),b.on("close",()=>{m("renderer closed the MessagePort")}),b.start(),v({onMessage:p.event,send:O=>b.postMessage(O.buffer)})};process.parentPort.on("message",h=>n(h.ports))});if(l.type===2)return new Promise((v,i)=>{let n=null;const h=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,p=3e5,O=new C.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),b),W=new C.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),p);process.on("message",(Y,x)=>{if(Y&&Y.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const M=k.VSBuffer.wrap(Buffer.from(Y.initialDataChunk,"base64"));let B;if(Y.skipWebSocketFrames)B=new T.NodeSocket(x,"extHost-socket");else{const U=k.VSBuffer.wrap(Buffer.from(Y.inflateBytes,"base64"));B=new T.WebSocketNodeSocket(new T.NodeSocket(x,"extHost-socket"),Y.permessageDeflate,U,!1)}n?(O.cancel(),W.cancel(),n.beginAcceptReconnection(B,M),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(h),n=new P.PersistentProtocol({socket:B,initialChunk:M}),n.sendResume(),n.onDidDispose(()=>m("renderer disconnected")),v(n),n.onSocketClose(()=>{O.schedule()}))}if(Y&&Y.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(W.isScheduled())return;O.isScheduled()&&W.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const v=l.pipeName;return new Promise((i,n)=>{const h=c.createConnection(v,()=>{h.removeListener("error",n);const b=new P.PersistentProtocol({socket:new T.NodeSocket(h,"extHost-renderer")});b.sendResume(),i(b)});h.once("error",n),h.on("close",()=>{m("renderer closed the socket")})})}}async function o(){const l=await t();return new class{constructor(){this.a=new P.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,l.onMessage(v=>{(0,g.isMessageOfType)(v,2)?(this.b=!0,m("received terminate message from renderer")):this.a.fire(v)})}send(v){this.b||l.send(v)}async drain(){if(l.drain)return l.drain()}}}function s(l){return new Promise(v=>{const i=l.onMessage(n=>{i.dispose();const h=JSON.parse(n.toString()),b=h.commit,p=D.default.commit;if(b&&p&&b!==p&&w(55),h.parentPid){let O=0;setInterval(function(){try{process.kill(h.parentPid,0),O=0}catch(q){q&&q.code==="EPERM"?(O++,O>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let W;try{W=globalThis._VSCODE_NODE_MODULES["native-watchdog"],W.start(h.parentPid)}catch(q){(0,R.onUnexpectedError)(q)}}l.send((0,g.createMessageOfType)(0)),v({protocol:l,initData:h})});l.send((0,g.createMessageOfType)(1))})}async function a(){const l=[];process.on("unhandledRejection",(O,W)=>{l.push(W),setTimeout(()=>{const q=l.indexOf(W);q>=0&&W.catch(Y=>{l.splice(q,1),(0,R.isCancellationError)(Y)||(console.warn(`rejected promise not handled within 1 second: ${Y}`),Y&&Y.stack&&console.warn(`stack trace: ${Y.stack}`),O&&(0,R.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const W=l.indexOf(O);W>=0&&l.splice(W,1)}),process.on("uncaughtException",function(O){(0,R.isSigPipeError)(O)||(0,R.onUnexpectedError)(O)}),u.mark("code/extHost/willConnectToRenderer");const v=await o();u.mark("code/extHost/didConnectToRenderer");const i=await s(v);u.mark("code/extHost/didWaitForInitData");const{initData:n}=i;y(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,n.environment.skipWorkspaceStorageLock=(0,E.boolean)(f.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(W){w(W)}exists(W){return S.Promises.exists(W)}realpath(W){return(0,I.realpath)(W)}};let b=null;n.remote.authority&&f.transformURIs&&(b=(0,r.createURITransformer)(n.remote.authority));const p=new L.ExtensionHostMain(i.protocol,n,h,b);m=O=>p.terminate(O)}a().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/workbench/api/node/extensionHostProcess.js.map
