/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ee){for(var e=[],n=0,A=ee.length;n<A;n++)e[n]=Pe[ee[n]];return e};define(Pe[63],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(O,R){const w=Object.create(null);for(const h of O){const L=R(h);let D=w[L];D||(D=w[L]=[]),D.push(h)}return w}e.groupBy=n;function A(O,R){const w=[],h=[];for(const L of O)R.has(L)||w.push(L);for(const L of R)O.has(L)||h.push(L);return{removed:w,added:h}}e.diffSets=A;function C(O,R){const w=[],h=[];for(const[L,D]of O)R.has(L)||w.push(D);for(const[L,D]of R)O.has(L)||h.push(D);return{removed:w,added:h}}e.diffMaps=C;class F{constructor(){this.a=new Map}add(R,w){let h=this.a.get(R);h||(h=new Set,this.a.set(R,h)),h.add(w)}delete(R,w){const h=this.a.get(R);!h||(h.delete(w),h.size===0&&this.a.delete(R))}forEach(R,w){const h=this.a.get(R);!h||h.forEach(w)}}e.SetMap=F}),define(Pe[64],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(O){return(R,w,h)=>{let L=null,D=null;if(typeof h.value=="function"?(L="value",D=h.value):typeof h.get=="function"&&(L="get",D=h.get),!D)throw new Error("not supported");h[L]=O(D,w)}}function A(O,R,w){let h=null,L=null;if(typeof w.value=="function"?(h="value",L=w.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(h="get",L=w.get),!L)throw new Error("not supported");const D=`$memoize$${R}`;w[h]=function(...f){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,f)}),this[D]}}e.memoize=A;function C(O,R,w){return n((h,L)=>{const D=`$debounce$${L}`,f=`$debounce$result$${L}`;return function(...b){this[f]||(this[f]=w?w():void 0),clearTimeout(this[D]),R&&(this[f]=R(this[f],...b),b=[this[f]]),this[D]=setTimeout(()=>{h.apply(this,b),this[f]=w?w():void 0},O)}})}e.debounce=C;function F(O,R,w){return n((h,L)=>{const D=`$throttle$timer$${L}`,f=`$throttle$result$${L}`,b=`$throttle$lastRun$${L}`,p=`$throttle$pending$${L}`;return function(...d){if(this[f]||(this[f]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...d)),this[p])return;const t=this[b]+O;t<=Date.now()?(this[b]=Date.now(),h.apply(this,[this[f]]),this[f]=w?w():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),h.apply(this,[this[f]]),this[f]=w?w():void 0},t-Date.now()))}})}e.throttle=F}),define(Pe[84],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Pe[113],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F=e.ParseOptions||(e.ParseOptions={}));function O(i,u=!1){let r=0;const c=i.length;let o="",k=0,s=16,l=0;function v(q){let U=0,$=0;for(;U<q;){const z=i.charCodeAt(r);if(z>=48&&z<=57)$=$*16+z-48;else if(z>=65&&z<=70)$=$*16+z-65+10;else if(z>=97&&z<=102)$=$*16+z-97+10;else break;r++,U++}return U<q&&($=-1),$}function S(q){r=q,o="",k=0,s=16,l=0}function E(){const q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&h(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&h(i.charCodeAt(r)))for(r++;r<i.length&&h(i.charCodeAt(r));)r++;else return l=3,i.substring(q,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&h(i.charCodeAt(r))){for(r++;r<i.length&&h(i.charCodeAt(r));)r++;U=r}else l=3;return i.substring(q,U)}function W(){let q="",U=r;for(;;){if(r>=c){q+=i.substring(U,r),l=2;break}const $=i.charCodeAt(r);if($===34){q+=i.substring(U,r),r++;break}if($===92){if(q+=i.substring(U,r),r++,r>=c){l=2;break}switch(i.charCodeAt(r++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const j=v(4);j>=0?q+=String.fromCharCode(j):l=4;break}default:l=5}U=r;continue}if($>=0&&$<=31)if(w($)){q+=i.substring(U,r),l=2;break}else l=6;r++}return q}function G(){if(o="",l=0,k=r,r>=c)return k=c,s=17;let q=i.charCodeAt(r);if(R(q)){do r++,o+=String.fromCharCode(q),q=i.charCodeAt(r);while(R(q));return s=15}if(w(q))return r++,o+=String.fromCharCode(q),q===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),s=14;switch(q){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,o=W(),s=10;case 47:{const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<c&&!w(i.charCodeAt(r));)r++;return o=i.substring(U,r),s=12}if(i.charCodeAt(r+1)===42){r+=2;const $=c-1;let z=!1;for(;r<$;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,l=1),o=i.substring(U,r),s=13}return o+=String.fromCharCode(q),r++,s=16}case 45:if(o+=String.fromCharCode(q),r++,r===c||!h(i.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=E(),s=11;default:for(;r<c&&Y(q);)r++,q=i.charCodeAt(r);if(k!==r){switch(o=i.substring(k,r),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(q),r++,s=16}}function Y(q){if(R(q)||w(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let q;do q=G();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>r,scan:u?J:G,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>k,getTokenLength:()=>r-k,getTokenError:()=>l}}e.createScanner=O;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function D(i,u){const r=[],c=new Object;let o;const k={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(v,S,E,W){k.value=v,k.offset=S,k.length=E,k.type=W,k.colonOffset=void 0,o=k}try{y(i,{onObjectBegin:(v,S)=>{if(u<=v)throw c;o=void 0,s=u>v,r.push("")},onObjectProperty:(v,S,E)=>{if(u<S||(l(v,S,E,"property"),r[r.length-1]=v,u<=S+E))throw c},onObjectEnd:(v,S)=>{if(u<=v)throw c;o=void 0,r.pop()},onArrayBegin:(v,S)=>{if(u<=v)throw c;o=void 0,r.push(0)},onArrayEnd:(v,S)=>{if(u<=v)throw c;o=void 0,r.pop()},onLiteralValue:(v,S,E)=>{if(u<S||(l(v,S,E,g(v)),u<=S+E))throw c},onSeparator:(v,S,E)=>{if(u<=S)throw c;if(v===":"&&o&&o.type==="property")o.colonOffset=S,s=!1,o=void 0;else if(v===","){const W=r[r.length-1];typeof W=="number"?r[r.length-1]=W+1:(s=!0,r[r.length-1]=""),o=void 0}}})}catch(v){if(v!==c)throw v}return{path:r,previousNode:o,isAtPropertyKey:s,matches:v=>{let S=0;for(let E=0;S<v.length&&E<r.length;E++)if(v[S]===r[E]||v[S]==="*")S++;else if(v[S]!=="**")return!1;return S===v.length}}}e.getLocation=D;function f(i,u=[],r=F.DEFAULT){let c=null,o=[];const k=[];function s(v){Array.isArray(o)?o.push(v):c!==null&&(o[c]=v)}return y(i,{onObjectBegin:()=>{const v={};s(v),k.push(o),o=v,c=null},onObjectProperty:v=>{c=v},onObjectEnd:()=>{o=k.pop()},onArrayBegin:()=>{const v=[];s(v),k.push(o),o=v,c=null},onArrayEnd:()=>{o=k.pop()},onLiteralValue:s,onError:(v,S,E)=>{u.push({error:v,offset:S,length:E})}},r),o[0]}e.parse=f;function b(i,u=[],r=F.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){c.type==="property"&&(c.length=v-c.offset,c=c.parent)}function k(v){return c.children.push(v),v}y(i,{onObjectBegin:v=>{c=k({type:"object",offset:v,length:-1,parent:c,children:[]})},onObjectProperty:(v,S,E)=>{c=k({type:"property",offset:S,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:v,offset:S,length:E,parent:c})},onObjectEnd:(v,S)=>{c.length=v+S-c.offset,c=c.parent,o(v+S)},onArrayBegin:(v,S)=>{c=k({type:"array",offset:v,length:-1,parent:c,children:[]})},onArrayEnd:(v,S)=>{c.length=v+S-c.offset,c=c.parent,o(v+S)},onLiteralValue:(v,S,E)=>{k({type:g(v),offset:S,length:E,parent:c,value:v}),o(S+E)},onSeparator:(v,S,E)=>{c.type==="property"&&(v===":"?c.colonOffset=S:v===","&&o(S))},onError:(v,S,E)=>{u.push({error:v,offset:S,length:E})}},r);const l=c.children[0];return l&&delete l.parent,l}e.parseTree=b;function p(i,u){if(!i)return;let r=i;for(const c of u)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const k of r.children)if(Array.isArray(k.children)&&k.children[0].value===c){r=k.children[1],o=!0;break}if(!o)return}else{const o=c;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=p;function d(i){if(!i.parent||!i.parent.children)return[];const u=d(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;u.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&u.push(r)}return u}e.getNodePath=d;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const u=Object.create(null);for(const r of i.children){const c=r.children[1];c&&(u[r.children[0].value]=t(c))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function a(i,u,r=!1){return u>=i.offset&&u<i.offset+i.length||r&&u===i.offset+i.length}e.contains=a;function m(i,u,r=!1){if(a(i,u,r)){const c=i.children;if(Array.isArray(c))for(let o=0;o<c.length&&c[o].offset<=u;o++){const k=m(c[o],u,r);if(k)return k}return i}}e.findNodeAtOffset=m;function y(i,u,r=F.DEFAULT){const c=O(i,!1);function o(ke){return ke?()=>ke(c.getTokenOffset(),c.getTokenLength()):()=>!0}function k(ke){return ke?le=>ke(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const s=o(u.onObjectBegin),l=k(u.onObjectProperty),v=o(u.onObjectEnd),S=o(u.onArrayBegin),E=o(u.onArrayEnd),W=k(u.onLiteralValue),G=k(u.onSeparator),Y=o(u.onComment),J=k(u.onError),q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function $(){for(;;){const ke=c.scan();switch(c.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:q||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ke){case 12:case 13:q?z(10):Y();break;case 16:z(1);break;case 15:case 14:break;default:return ke}}}function z(ke,le=[],X=[]){if(J(ke),le.length+X.length>0){let T=c.getToken();for(;T!==17;){if(le.indexOf(T)!==-1){$();break}else if(X.indexOf(T)!==-1)break;T=$()}}}function j(ke){const le=c.getTokenValue();return ke?W(le):l(le),$(),!0}function he(){switch(c.getToken()){case 11:{let ke=0;try{ke=JSON.parse(c.getTokenValue()),typeof ke!="number"&&(z(2),ke=0)}catch{z(2)}W(ke);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return $(),!0}function we(){return c.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),c.getToken()===6?(G(":"),$(),de()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ie(){s(),$();let ke=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(ke||z(4,[],[]),G(","),$(),c.getToken()===2&&U)break}else ke&&z(6,[],[]);we()||z(4,[],[2,5]),ke=!0}return v(),c.getToken()!==2?z(7,[2],[]):$(),!0}function oe(){S(),$();let ke=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(ke||z(4,[],[]),G(","),$(),c.getToken()===4&&U)break}else ke&&z(6,[],[]);de()||z(4,[],[4,5]),ke=!0}return E(),c.getToken()!==4?z(8,[4],[]):$(),!0}function de(){switch(c.getToken()){case 3:return oe();case 1:return ie();case 10:return j(!0);default:return he()}}return $(),c.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):de()?(c.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=y;function P(i,u){const r=O(i),c=[];let o,k=0,s;do switch(s=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:k!==s&&c.push(i.substring(k,s)),u!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,u)),k=r.getPosition();break}while(o!==17);return c.join("")}e.stripComments=P;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(Pe[28],Ae([1,0]),function(ee,e){"use strict";var n,A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function F(d,t,a){let m=d.get(t);return m===void 0&&(m=a,d.set(t,m)),m}e.getOrSet=F;function O(d){const t=[];return d.forEach((a,m)=>{t.push(`${m} => ${a}`)}),`Map(${d.size}) {${t.join(", ")}}`}e.mapToString=O;function R(d){const t=[];return d.forEach(a=>{t.push(a)}),`Set(${d.size}) {${t.join(", ")}}`}e.setToString=R;class w{constructor(t,a){this.uri=t,this.value=a}}class h{constructor(t,a){this[n]="ResourceMap",t instanceof h?(this.b=new Map(t.b),this.c=a??h.a):(this.b=new Map,this.c=t??h.a)}set(t,a){return this.b.set(this.c(t),new w(t,a)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[m,y]of this.b)t(y.value,y.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}h.a=d=>d.toString(),e.ResourceMap=h;class L{constructor(t,a){this[A]="ResourceSet",!t||typeof t=="function"?this.a=new h(t):(this.a=new h(a),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,a){this.a.forEach((m,y)=>t.call(a,y,y,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var D;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class f{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,a=0){const m=this.a.get(t);if(!!m)return a!==0&&this.j(m,a),m.value}set(t,a,m=0){let y=this.a.get(t);if(y)y.value=a,m!==0&&this.j(y,m);else{switch(y={key:t,value:a,next:void 0,previous:void 0},m){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(t,y),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this.a.get(t);if(!!a)return this.a.delete(t),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,a){const m=this.e;let y=this.b;for(;y;){if(a?t.bind(a)(y.value,y.key,this):t(y.value,y.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const t=this,a=this.e;let m=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:m.key,done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return y}values(){const t=this,a=this.e;let m=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:m.value,done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return y}entries(){const t=this,a=this.e;let m=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const P={value:[m.key,m.value],done:!1};return m=m.next,P}else return{value:void 0,done:!0}}};return y}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this.b,m=this.size;for(;a&&m>t;)this.a.delete(a.key),a=a.next,m--;this.b=a,this.d=m,a&&(a.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const a=t.next,m=t.previous;if(!a||!m)throw new Error("Invalid list");a.previous=m,m.next=a}t.next=void 0,t.previous=void 0,this.e++}j(t,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this.b)return;const m=t.next,y=t.previous;t===this.c?(y.next=void 0,this.c=y):(m.previous=y,y.next=m),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(a===2){if(t===this.c)return;const m=t.next,y=t.previous;t===this.b?(m.previous=void 0,this.b=m):(m.previous=y,y.next=m),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((a,m)=>{t.push([m,a])}),t}fromJSON(t){this.clear();for(const[a,m]of t)this.set(a,m)}}e.LinkedMap=f;class b extends f{constructor(t,a=1){super(),this.k=t,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b;class p{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let a=this.a.get(t)||0;return a===0?!1:(a--,a===0?this.a.delete(t):this.a.set(t,a),!0)}has(t){return this.a.has(t)}}e.CounterSet=p}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Pe[114],Ae([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(be,Ee){for(var Ie=0;Ie<Ee.length;Ie++){var se=Ee[Ie];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(be,se.key,se)}}function n(be,Ee,Ie){return Ee&&e(be.prototype,Ee),Ie&&e(be,Ie),Object.defineProperty(be,"prototype",{writable:!1}),be}function A(be,Ee){if(!!be){if(typeof be=="string")return C(be,Ee);var Ie=Object.prototype.toString.call(be).slice(8,-1);if(Ie==="Object"&&be.constructor&&(Ie=be.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(be);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return C(be,Ee)}}function C(be,Ee){(Ee==null||Ee>be.length)&&(Ee=be.length);for(var Ie=0,se=new Array(Ee);Ie<Ee;Ie++)se[Ie]=be[Ie];return se}function F(be,Ee){var Ie=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(Ie)return(Ie=Ie.call(be)).next.bind(Ie);if(Array.isArray(be)||(Ie=A(be))||Ee&&be&&typeof be.length=="number"){Ie&&(be=Ie);var se=0;return function(){return se>=be.length?{done:!0}:{done:!1,value:be[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function O(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=O();function R(be){ee.defaults=be}var w=/[&<>"']/,h=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ee){return f[Ee]};function p(be,Ee){if(Ee){if(w.test(be))return be.replace(h,b)}else if(L.test(be))return be.replace(D,b);return be}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(be){return be.replace(d,function(Ee,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var a=/(^|[^\[])\^/g;function m(be,Ee){be=typeof be=="string"?be:be.source,Ee=Ee||"";var Ie={replace:function(ae,Z){return Z=Z.source||Z,Z=Z.replace(a,"$1"),be=be.replace(ae,Z),Ie},getRegex:function(){return new RegExp(be,Ee)}};return Ie}var y=/[^\w:]/g,P=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(be,Ee,Ie){if(be){var se;try{se=decodeURIComponent(t(Ie)).replace(y,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ee&&!P.test(Ie)&&(Ie=o(Ee,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var i={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(be,Ee){i[" "+be]||(u.test(be)?i[" "+be]=be+"/":i[" "+be]=v(be,"/",!0)),be=i[" "+be];var Ie=be.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ie?Ee:be.replace(r,"$1")+Ee:Ee.charAt(0)==="/"?Ie?Ee:be.replace(c,"$1")+Ee:be+Ee}var k={exec:function(){}};function s(be){for(var Ee=1,Ie,se;Ee<arguments.length;Ee++){Ie=arguments[Ee];for(se in Ie)Object.prototype.hasOwnProperty.call(Ie,se)&&(be[se]=Ie[se])}return be}function l(be,Ee){var Ie=be.replace(/\|/g,function(Z,I,M){for(var H=!1,x=I;--x>=0&&M[x]==="\\";)H=!H;return H?"|":" |"}),se=Ie.split(/ \|/),ae=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Ee)se.splice(Ee);else for(;se.length<Ee;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function v(be,Ee,Ie){var se=be.length;if(se===0)return"";for(var ae=0;ae<se;){var Z=be.charAt(se-ae-1);if(Z===Ee&&!Ie)ae++;else if(Z!==Ee&&Ie)ae++;else break}return be.slice(0,se-ae)}function S(be,Ee){if(be.indexOf(Ee[1])===-1)return-1;for(var Ie=be.length,se=0,ae=0;ae<Ie;ae++)if(be[ae]==="\\")ae++;else if(be[ae]===Ee[0])se++;else if(be[ae]===Ee[1]&&(se--,se<0))return ae;return-1}function E(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(be,Ee){if(Ee<1)return"";for(var Ie="";Ee>1;)Ee&1&&(Ie+=be),Ee>>=1,be+=be;return Ie+be}function G(be,Ee,Ie,se){var ae=Ee.href,Z=Ee.title?p(Ee.title):null,I=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){se.state.inLink=!0;var M={type:"link",raw:Ie,href:ae,title:Z,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,M}return{type:"image",raw:Ie,href:ae,title:Z,text:p(I)}}function Y(be,Ee){var Ie=be.match(/^(\s+)(?:```)/);if(Ie===null)return Ee;var se=Ie[1];return Ee.split(`
`).map(function(ae){var Z=ae.match(/^\s+/);if(Z===null)return ae;var I=Z[0];return I.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var J=function(){function be(Ie){this.options=Ie||ee.defaults}var Ee=be.prototype;return Ee.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},Ee.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var Z=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:v(Z,`
`)}}},Ee.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var Z=ae[0],I=Y(Z,ae[3]||"");return{type:"code",raw:Z,lang:ae[2]?ae[2].trim():ae[2],text:I}}},Ee.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var Z=ae[2].trim();if(/#$/.test(Z)){var I=v(Z,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Z=I.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:Z,tokens:this.lexer.inline(Z)}}},Ee.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},Ee.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var Z=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},Ee.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var Z,I,M,H,x,te,pe,Ce,ue,De,Se,$e,He=ae[1].trim(),et=He.length>1,Xe={type:"list",raw:"",ordered:et,start:et?+He.slice(0,-1):"",loose:!1,items:[]};He=et?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=et?He:"[*+-]");for(var tt=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&($e=!1,!(!(ae=tt.exec(se))||this.rules.block.hr.test(se)));){if(Z=ae[0],se=se.substring(Z.length),Ce=ae[2].split(`
`,1)[0],ue=se.split(`
`,1)[0],this.options.pedantic?(H=2,Se=Ce.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,Se=Ce.slice(H),H+=ae[1].length),te=!1,!Ce&&/^ *$/.test(ue)&&(Z+=ue+`
`,se=se.substring(ue.length+1),$e=!0),!$e)for(var rt=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Me=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");se&&(De=se.split(`
`,1)[0],Ce=De,this.options.pedantic&&(Ce=Ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Ce)||Q.test(Ce)||rt.test(Ce)||Me.test(se)));){if(Ce.search(/[^ ]/)>=H||!Ce.trim())Se+=`
`+Ce.slice(H);else if(!te)Se+=`
`+Ce;else break;!te&&!Ce.trim()&&(te=!0),Z+=De+`
`,se=se.substring(De.length+1)}Xe.loose||(pe?Xe.loose=!0:/\n *\n *$/.test(Z)&&(pe=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(Se),I&&(M=I[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!I,checked:M,loose:!1,text:Se}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=Se.trimRight(),Xe.raw=Xe.raw.trimRight();var _=Xe.items.length;for(x=0;x<_;x++){this.lexer.state.top=!1,Xe.items[x].tokens=this.lexer.blockTokens(Xe.items[x].text,[]);var ve=Xe.items[x].tokens.filter(function(Be){return Be.type==="space"}),We=ve.every(function(Be){for(var Qe=Be.raw.split(""),Ye=0,Ge=F(Qe),at;!(at=Ge()).done;){var Dt=at.value;if(Dt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Xe.loose&&ve.length&&We&&(Xe.loose=!0,Xe.items[x].loose=!0)}return Xe}},Ee.html=function(se){var ae=this.rules.block.html.exec(se);if(ae){var Z={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ae[0]):p(ae[0]);Z.type="paragraph",Z.text=I,Z.tokens=this.lexer.inline(I)}return Z}},Ee.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var Z=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ae[0],href:ae[2],title:ae[3]}}},Ee.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var Z={type:"table",header:l(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ae[0];var I=Z.align.length,M,H,x,te;for(M=0;M<I;M++)/^ *-+: *$/.test(Z.align[M])?Z.align[M]="right":/^ *:-+: *$/.test(Z.align[M])?Z.align[M]="center":/^ *:-+ *$/.test(Z.align[M])?Z.align[M]="left":Z.align[M]=null;for(I=Z.rows.length,M=0;M<I;M++)Z.rows[M]=l(Z.rows[M],Z.header.length).map(function(pe){return{text:pe}});for(I=Z.header.length,H=0;H<I;H++)Z.header[H].tokens=this.lexer.inline(Z.header[H].text);for(I=Z.rows.length,H=0;H<I;H++)for(te=Z.rows[H],x=0;x<te.length;x++)te[x].tokens=this.lexer.inline(te[x].text);return Z}}},Ee.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},Ee.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae){var Z=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:Z,tokens:this.lexer.inline(Z)}}},Ee.text=function(se){var ae=this.rules.block.text.exec(se);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},Ee.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:p(ae[1])}},Ee.tag=function(se){var ae=this.rules.inline.tag.exec(se);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):p(ae[0]):ae[0]}},Ee.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var Z=ae[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var I=v(Z.slice(0,-1),"\\");if((Z.length-I.length)%2===0)return}else{var M=S(ae[2],"()");if(M>-1){var H=ae[0].indexOf("!")===0?5:4,x=H+ae[1].length+M;ae[2]=ae[2].substring(0,M),ae[0]=ae[0].substring(0,x).trim(),ae[3]=""}}var te=ae[2],pe="";if(this.options.pedantic){var Ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);Ce&&(te=Ce[1],pe=Ce[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(Z)?te=te.slice(1):te=te.slice(1,-1)),G(ae,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Ee.reflink=function(se,ae){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var I=(Z[2]||Z[1]).replace(/\s+/g," ");if(I=ae[I.toLowerCase()],!I||!I.href){var M=Z[0].charAt(0);return{type:"text",raw:M,text:M}}return G(Z,I,Z[0],this.lexer)}},Ee.emStrong=function(se,ae,Z){Z===void 0&&(Z="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var M=I[1]||I[2]||"";if(!M||M&&(Z===""||this.rules.inline.punctuation.exec(Z))){var H=I[0].length-1,x,te,pe=H,Ce=0,ue=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,ae=ae.slice(-1*se.length+H);(I=ue.exec(ae))!=null;)if(x=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!x){if(te=x.length,I[3]||I[4]){pe+=te;continue}else if((I[5]||I[6])&&H%3&&!((H+te)%3)){Ce+=te;continue}if(pe-=te,!(pe>0)){if(te=Math.min(te,te+pe+Ce),Math.min(H,te)%2){var De=se.slice(1,H+I.index+te);return{type:"em",raw:se.slice(0,H+I.index+te+1),text:De,tokens:this.lexer.inlineTokens(De)}}var Se=se.slice(2,H+I.index+te-1);return{type:"strong",raw:se.slice(0,H+I.index+te+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},Ee.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var Z=ae[2].replace(/\n/g," "),I=/[^ ]/.test(Z),M=/^ /.test(Z)&&/ $/.test(Z);return I&&M&&(Z=Z.substring(1,Z.length-1)),Z=p(Z,!0),{type:"codespan",raw:ae[0],text:Z}}},Ee.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},Ee.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},Ee.autolink=function(se,ae){var Z=this.rules.inline.autolink.exec(se);if(Z){var I,M;return Z[2]==="@"?(I=p(this.options.mangle?ae(Z[1]):Z[1]),M="mailto:"+I):(I=p(Z[1]),M=I),{type:"link",raw:Z[0],text:I,href:M,tokens:[{type:"text",raw:I,text:I}]}}},Ee.url=function(se,ae){var Z;if(Z=this.rules.inline.url.exec(se)){var I,M;if(Z[2]==="@")I=p(this.options.mangle?ae(Z[0]):Z[0]),M="mailto:"+I;else{var H;do H=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(H!==Z[0]);I=p(Z[0]),Z[1]==="www."?M="http://"+I:M=I}return{type:"link",raw:Z[0],text:I,href:M,tokens:[{type:"text",raw:I,text:I}]}}},Ee.inlineText=function(se,ae){var Z=this.rules.inline.text.exec(se);if(Z){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):p(Z[0]):Z[0]:I=p(this.options.smartypants?ae(Z[0]):Z[0]),{type:"text",raw:Z[0],text:I}}},be}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:k,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=m(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=m(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=m(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=m(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=m(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=m(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=s({},q),q.gfm=s({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=m(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=m(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=s({},q.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:k,paragraph:m(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:k,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:k,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=m(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=m(q._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=m(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=m(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=m(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=m(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=m(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=m(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=m(U.reflink).replace("label",U._label).replace("ref",q._label).getRegex(),U.nolink=m(U.nolink).replace("ref",q._label).getRegex(),U.reflinkSearch=m(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=s({},U),U.pedantic=s({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=s({},U.normal,{escape:m(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=m(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=s({},U.gfm,{br:m(U.br).replace("{2,}","*").getRegex(),text:m(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(be){var Ee="",Ie,se,ae=be.length;for(Ie=0;Ie<ae;Ie++)se=be.charCodeAt(Ie),Math.random()>.5&&(se="x"+se.toString(16)),Ee+="&#"+se+";";return Ee}var j=function(){function be(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ee.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:q.normal,inline:U.normal};this.options.pedantic?(se.block=q.pedantic,se.inline=U.pedantic):this.options.gfm&&(se.block=q.gfm,this.options.breaks?se.inline=U.breaks:se.inline=U.gfm),this.tokenizer.rules=se}be.lex=function(se,ae){var Z=new be(ae);return Z.lex(se)},be.lexInline=function(se,ae){var Z=new be(ae);return Z.inlineTokens(se)};var Ee=be.prototype;return Ee.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Ee.blockTokens=function(se,ae){var Z=this;ae===void 0&&(ae=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(pe,Ce,ue){return Ce+"    ".repeat(ue.length)});for(var I,M,H,x;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(I=pe.call({lexer:Z},se,ae))?(se=se.substring(I.raw.length),ae.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),M=ae[ae.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+I.raw,M.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=M.text):ae.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),M=ae[ae.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+I.raw,M.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=M.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,Ce=se.slice(1),ue=void 0;Z.options.extensions.startBlock.forEach(function(De){ue=De.call({lexer:this},Ce),typeof ue=="number"&&ue>=0&&(pe=Math.min(pe,ue))}),pe<1/0&&pe>=0&&(H=se.substring(0,pe+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){M=ae[ae.length-1],x&&M.type==="paragraph"?(M.raw+=`
`+I.raw,M.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):ae.push(I),x=H.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),M=ae[ae.length-1],M&&M.type==="text"?(M.raw+=`
`+I.raw,M.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):ae.push(I);continue}if(se){var te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,ae},Ee.inline=function(se,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:se,tokens:ae}),ae},Ee.inlineTokens=function(se,ae){var Z=this;ae===void 0&&(ae=[]);var I,M,H,x=se,te,pe,Ce;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(x))!=null;)ue.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(x=x.slice(0,te.index)+"["+W("a",te[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(x))!=null;)x=x.slice(0,te.index)+"["+W("a",te[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(x))!=null;)x=x.slice(0,te.index)+"++"+x.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(pe||(Ce=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(I=Se.call({lexer:Z},se,ae))?(se=se.substring(I.raw.length),ae.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),M=ae[ae.length-1],M&&I.type==="text"&&M.type==="text"?(M.raw+=I.raw,M.text+=I.text):ae.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),M=ae[ae.length-1],M&&I.type==="text"&&M.type==="text"?(M.raw+=I.raw,M.text+=I.text):ae.push(I);continue}if(I=this.tokenizer.emStrong(se,x,Ce)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ae.push(I);continue}if(I=this.tokenizer.autolink(se,z)){se=se.substring(I.raw.length),ae.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,z))){se=se.substring(I.raw.length),ae.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,$e=se.slice(1),He=void 0;Z.options.extensions.startInline.forEach(function(et){He=et.call({lexer:this},$e),typeof He=="number"&&He>=0&&(Se=Math.min(Se,He))}),Se<1/0&&Se>=0&&(H=se.substring(0,Se+1))}(),I=this.tokenizer.inlineText(H,$)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Ce=I.raw.slice(-1)),pe=!0,M=ae[ae.length-1],M&&M.type==="text"?(M.raw+=I.raw,M.text+=I.text):ae.push(I);continue}if(se){var De="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ae},n(be,null,[{key:"rules",get:function(){return{block:q,inline:U}}}]),be}(),he=function(){function be(Ie){this.options=Ie||ee.defaults}var Ee=be.prototype;return Ee.code=function(se,ae,Z){var I=(ae||"").match(/\S*/)[0];if(this.options.highlight){var M=this.options.highlight(se,I);M!=null&&M!==se&&(Z=!0,se=M)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+p(I,!0)+'">'+(Z?se:p(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:p(se,!0))+`</code></pre>
`},Ee.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ee.html=function(se){return se},Ee.heading=function(se,ae,Z,I){if(this.options.headerIds){var M=this.options.headerPrefix+I.slug(Z);return"<h"+ae+' id="'+M+'">'+se+"</h"+ae+`>
`}return"<h"+ae+">"+se+"</h"+ae+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(se,ae,Z){var I=ae?"ol":"ul",M=ae&&Z!==1?' start="'+Z+'"':"";return"<"+I+M+`>
`+se+"</"+I+`>
`},Ee.listitem=function(se){return"<li>"+se+`</li>
`},Ee.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(se){return"<p>"+se+`</p>
`},Ee.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},Ee.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ee.tablecell=function(se,ae){var Z=ae.header?"th":"td",I=ae.align?"<"+Z+' align="'+ae.align+'">':"<"+Z+">";return I+se+("</"+Z+`>
`)},Ee.strong=function(se){return"<strong>"+se+"</strong>"},Ee.em=function(se){return"<em>"+se+"</em>"},Ee.codespan=function(se){return"<code>"+se+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(se){return"<del>"+se+"</del>"},Ee.link=function(se,ae,Z){if(se=g(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<a href="'+p(se)+'"';return ae&&(I+=' title="'+ae+'"'),I+=">"+Z+"</a>",I},Ee.image=function(se,ae,Z){if(se=g(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<img src="'+se+'" alt="'+Z+'"';return ae&&(I+=' title="'+ae+'"'),I+=this.options.xhtml?"/>":">",I},Ee.text=function(se){return se},be}(),we=function(){function be(){}var Ee=be.prototype;return Ee.strong=function(se){return se},Ee.em=function(se){return se},Ee.codespan=function(se){return se},Ee.del=function(se){return se},Ee.html=function(se){return se},Ee.text=function(se){return se},Ee.link=function(se,ae,Z){return""+Z},Ee.image=function(se,ae,Z){return""+Z},Ee.br=function(){return""},be}(),ie=function(){function be(){this.seen={}}var Ee=be.prototype;return Ee.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(se,ae){var Z=se,I=0;if(this.seen.hasOwnProperty(Z)){I=this.seen[se];do I++,Z=se+"-"+I;while(this.seen.hasOwnProperty(Z))}return ae||(this.seen[se]=I,this.seen[Z]=0),Z},Ee.slug=function(se,ae){ae===void 0&&(ae={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,ae.dryrun)},be}(),oe=function(){function be(Ie){this.options=Ie||ee.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ie}be.parse=function(se,ae){var Z=new be(ae);return Z.parse(se)},be.parseInline=function(se,ae){var Z=new be(ae);return Z.parseInline(se)};var Ee=be.prototype;return Ee.parse=function(se,ae){ae===void 0&&(ae=!0);var Z="",I,M,H,x,te,pe,Ce,ue,De,Se,$e,He,et,Xe,tt,rt,Me,it,Q,_=se.length;for(I=0;I<_;I++){if(Se=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(Q=this.options.extensions.renderers[Se.type].call({parser:this},Se),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){Z+=Q||"";continue}switch(Se.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,t(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(ue="",Ce="",x=Se.header.length,M=0;M<x;M++)Ce+=this.renderer.tablecell(this.parseInline(Se.header[M].tokens),{header:!0,align:Se.align[M]});for(ue+=this.renderer.tablerow(Ce),De="",x=Se.rows.length,M=0;M<x;M++){for(pe=Se.rows[M],Ce="",te=pe.length,H=0;H<te;H++)Ce+=this.renderer.tablecell(this.parseInline(pe[H].tokens),{header:!1,align:Se.align[H]});De+=this.renderer.tablerow(Ce)}Z+=this.renderer.table(ue,De);continue}case"blockquote":{De=this.parse(Se.tokens),Z+=this.renderer.blockquote(De);continue}case"list":{for($e=Se.ordered,He=Se.start,et=Se.loose,x=Se.items.length,De="",M=0;M<x;M++)tt=Se.items[M],rt=tt.checked,Me=tt.task,Xe="",tt.task&&(it=this.renderer.checkbox(rt),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Xe+=it),Xe+=this.parse(tt.tokens,et),De+=this.renderer.listitem(Xe,Me,rt);Z+=this.renderer.list(De,$e,He);continue}case"html":{Z+=this.renderer.html(Se.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(De=Se.tokens?this.parseInline(Se.tokens):Se.text;I+1<_&&se[I+1].type==="text";)Se=se[++I],De+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);Z+=ae?this.renderer.paragraph(De):De;continue}default:{var ve='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(ve);return}else throw new Error(ve)}}}return Z},Ee.parseInline=function(se,ae){ae=ae||this.renderer;var Z="",I,M,H,x=se.length;for(I=0;I<x;I++){if(M=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[M.type]&&(H=this.options.extensions.renderers[M.type].call({parser:this},M),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(M.type))){Z+=H||"";continue}switch(M.type){case"escape":{Z+=ae.text(M.text);break}case"html":{Z+=ae.html(M.text);break}case"link":{Z+=ae.link(M.href,M.title,this.parseInline(M.tokens,ae));break}case"image":{Z+=ae.image(M.href,M.title,M.text);break}case"strong":{Z+=ae.strong(this.parseInline(M.tokens,ae));break}case"em":{Z+=ae.em(this.parseInline(M.tokens,ae));break}case"codespan":{Z+=ae.codespan(M.text);break}case"br":{Z+=ae.br();break}case"del":{Z+=ae.del(this.parseInline(M.tokens,ae));break}case"text":{Z+=ae.text(M.text);break}default:{var te='Token with "'+M.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return Z},be}();function de(be,Ee,Ie){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof Ee=="function"&&(Ie=Ee,Ee=null),Ee=s({},de.defaults,Ee||{}),E(Ee),Ie){var se=Ee.highlight,ae;try{ae=j.lex(be,Ee)}catch(x){return Ie(x)}var Z=function(te){var pe;if(!te)try{Ee.walkTokens&&de.walkTokens(ae,Ee.walkTokens),pe=oe.parse(ae,Ee)}catch(Ce){te=Ce}return Ee.highlight=se,te?Ie(te):Ie(null,pe)};if(!se||se.length<3||(delete Ee.highlight,!ae.length))return Z();var I=0;de.walkTokens(ae,function(x){x.type==="code"&&(I++,setTimeout(function(){se(x.text,x.lang,function(te,pe){if(te)return Z(te);pe!=null&&pe!==x.text&&(x.text=pe,x.escaped=!0),I--,I===0&&Z()})},0))}),I===0&&Z();return}function M(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+p(x.message+"",!0)+"</pre>";throw x}try{var H=j.lex(be,Ee);if(Ee.walkTokens){if(Ee.async)return Promise.all(de.walkTokens(H,Ee.walkTokens)).then(function(){return oe.parse(H,Ee)}).catch(M);de.walkTokens(H,Ee.walkTokens)}return oe.parse(H,Ee)}catch(x){M(x)}}de.options=de.setOptions=function(be){return s(de.defaults,be),R(de.defaults),de},de.getDefaults=O,de.defaults=ee.defaults,de.use=function(){for(var be=arguments.length,Ee=new Array(be),Ie=0;Ie<be;Ie++)Ee[Ie]=arguments[Ie];var se=s.apply(void 0,[{}].concat(Ee)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},Z;Ee.forEach(function(I){if(I.extensions&&(Z=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var x=ae.renderers?ae.renderers[H.name]:null;x?ae.renderers[H.name]=function(){for(var te=arguments.length,pe=new Array(te),Ce=0;Ce<te;Ce++)pe[Ce]=arguments[Ce];var ue=H.renderer.apply(this,pe);return ue===!1&&(ue=x.apply(this,pe)),ue}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=de.defaults.renderer||new he,x=function(Ce){var ue=H[Ce];H[Ce]=function(){for(var De=arguments.length,Se=new Array(De),$e=0;$e<De;$e++)Se[$e]=arguments[$e];var He=I.renderer[Ce].apply(H,Se);return He===!1&&(He=ue.apply(H,Se)),He}};for(var te in I.renderer)x(te);se.renderer=H}(),I.tokenizer&&function(){var H=de.defaults.tokenizer||new J,x=function(Ce){var ue=H[Ce];H[Ce]=function(){for(var De=arguments.length,Se=new Array(De),$e=0;$e<De;$e++)Se[$e]=arguments[$e];var He=I.tokenizer[Ce].apply(H,Se);return He===!1&&(He=ue.apply(H,Se)),He}};for(var te in I.tokenizer)x(te);se.tokenizer=H}(),I.walkTokens){var M=de.defaults.walkTokens;se.walkTokens=function(H){var x=[];return x.push(I.walkTokens.call(this,H)),M&&(x=x.concat(M.call(this,H))),x}}Z&&(se.extensions=ae),de.setOptions(se)})},de.walkTokens=function(be,Ee){for(var Ie=[],se=function(){var M=Z.value;switch(Ie=Ie.concat(Ee.call(de,M)),M.type){case"table":{for(var H=F(M.header),x;!(x=H()).done;){var te=x.value;Ie=Ie.concat(de.walkTokens(te.tokens,Ee))}for(var pe=F(M.rows),Ce;!(Ce=pe()).done;)for(var ue=Ce.value,De=F(ue),Se;!(Se=De()).done;){var $e=Se.value;Ie=Ie.concat(de.walkTokens($e.tokens,Ee))}break}case"list":{Ie=Ie.concat(de.walkTokens(M.items,Ee));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[M.type]?de.defaults.extensions.childTokens[M.type].forEach(function(He){Ie=Ie.concat(de.walkTokens(M[He],Ee))}):M.tokens&&(Ie=Ie.concat(de.walkTokens(M.tokens,Ee)))}},ae=F(be),Z;!(Z=ae()).done;)se();return Ie},de.parseInline=function(be,Ee){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");Ee=s({},de.defaults,Ee||{}),E(Ee);try{var Ie=j.lexInline(be,Ee);return Ee.walkTokens&&de.walkTokens(Ie,Ee.walkTokens),oe.parseInline(Ie,Ee)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+p(se.message+"",!0)+"</pre>";throw se}},de.Parser=oe,de.parser=oe.parse,de.Renderer=he,de.TextRenderer=we,de.Lexer=j,de.lexer=j.lex,de.Tokenizer=J,de.Slugger=ie,de.parse=de;var ke=de.options,le=de.setOptions,X=de.use,T=de.walkTokens,V=de.parseInline,ce=de,me=oe.parse,Fe=j.lex;ee.Lexer=j,ee.Parser=oe,ee.Renderer=he,ee.Slugger=ie,ee.TextRenderer=we,ee.Tokenizer=J,ee.getDefaults=O,ee.lexer=Fe,ee.marked=de,ee.options=ke,ee.parse=ce,ee.parseInline=V,ee.parser=me,ee.setOptions=le,ee.use=X,ee.walkTokens=T,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Pe[115],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(R,w,h){return Math.min(Math.max(R,w),h)}e.clamp=n;function A(R,w){return(w+R%w)%w}e.rot=A;class C{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=C;class F{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=F;class O{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const h=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=O}),function(){function ee(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function O(w){F.push(w,Date.now())}function R(){const w=[];for(let h=0;h<F.length;h+=2)w.push({name:F[h],startTime:F[h+1]});return w}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const O of performance.getEntriesByType("mark"))F.push({name:O.name,startTime:Math.round(C+O.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function n(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=n(A))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var A in n)(typeof exports=="object"?exports:ee)[A]=n[A]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function n(A){if(e[A])return e[A].exports;var C=e[A]={i:A,l:!1,exports:{}};return ee[A].call(C.exports,C,C.exports,n),C.l=!0,C.exports}return n.m=ee,n.c=e,n.d=function(A,C,F){n.o(A,C)||Object.defineProperty(A,C,{enumerable:!0,get:F})},n.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},n.t=function(A,C){if(1&C&&(A=n(A)),8&C||4&C&&typeof A=="object"&&A&&A.__esModule)return A;var F=Object.create(null);if(n.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:A}),2&C&&typeof A!="string")for(var O in A)n.d(F,O,function(R){return A[R]}.bind(null,O));return F},n.n=function(A){var C=A&&A.__esModule?function(){return A.default}:function(){return A};return n.d(C,"a",C),C},n.o=function(A,C){return Object.prototype.hasOwnProperty.call(A,C)},n.p="",n(n.s=0)}([function(ee,e,n){(function(A){var C;e=ee.exports=X,C=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],w=e.src=[],h=0,L=h++;w[L]="0|[1-9]\\d*";var D=h++;w[D]="[0-9]+";var f=h++;w[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=h++;w[b]="("+w[L]+")\\.("+w[L]+")\\.("+w[L]+")";var p=h++;w[p]="("+w[D]+")\\.("+w[D]+")\\.("+w[D]+")";var d=h++;w[d]="(?:"+w[L]+"|"+w[f]+")";var t=h++;w[t]="(?:"+w[D]+"|"+w[f]+")";var a=h++;w[a]="(?:-("+w[d]+"(?:\\."+w[d]+")*))";var m=h++;w[m]="(?:-?("+w[t]+"(?:\\."+w[t]+")*))";var y=h++;w[y]="[0-9A-Za-z-]+";var P=h++;w[P]="(?:\\+("+w[y]+"(?:\\."+w[y]+")*))";var g=h++,i="v?"+w[b]+w[a]+"?"+w[P]+"?";w[g]="^"+i+"$";var u="[v=\\s]*"+w[p]+w[m]+"?"+w[P]+"?",r=h++;w[r]="^"+u+"$";var c=h++;w[c]="((?:<|>)?=?)";var o=h++;w[o]=w[D]+"|x|X|\\*";var k=h++;w[k]=w[L]+"|x|X|\\*";var s=h++;w[s]="[v=\\s]*("+w[k]+")(?:\\.("+w[k]+")(?:\\.("+w[k]+")(?:"+w[a]+")?"+w[P]+"?)?)?";var l=h++;w[l]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[P]+"?)?)?";var v=h++;w[v]="^"+w[c]+"\\s*"+w[s]+"$";var S=h++;w[S]="^"+w[c]+"\\s*"+w[l]+"$";var E=h++;w[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=h++;w[W]="(?:~>?)";var G=h++;w[G]="(\\s*)"+w[W]+"\\s+",R[G]=new RegExp(w[G],"g");var Y=h++;w[Y]="^"+w[W]+w[s]+"$";var J=h++;w[J]="^"+w[W]+w[l]+"$";var q=h++;w[q]="(?:\\^)";var U=h++;w[U]="(\\s*)"+w[q]+"\\s+",R[U]=new RegExp(w[U],"g");var $=h++;w[$]="^"+w[q]+w[s]+"$";var z=h++;w[z]="^"+w[q]+w[l]+"$";var j=h++;w[j]="^"+w[c]+"\\s*("+u+")$|^$";var he=h++;w[he]="^"+w[c]+"\\s*("+i+")$|^$";var we=h++;w[we]="(\\s*)"+w[c]+"\\s*("+u+"|"+w[s]+")",R[we]=new RegExp(w[we],"g");var ie=h++;w[ie]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var oe=h++;w[oe]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var de=h++;w[de]="(<|>)?=?\\s*\\*";for(var ke=0;ke<35;ke++)C(ke,w[ke]),R[ke]||(R[ke]=new RegExp(w[ke]));function le(ue,De){if(ue instanceof X)return ue;if(typeof ue!="string"||ue.length>F||!(De?R[r]:R[g]).test(ue))return null;try{return new X(ue,De)}catch{return null}}function X(ue,De){if(ue instanceof X){if(ue.loose===De)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof X))return new X(ue,De);C("SemVer",ue,De),this.loose=De;var Se=ue.trim().match(De?R[r]:R[g]);if(!Se)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<O)return He}return $e}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=le,e.valid=function(ue,De){var Se=le(ue,De);return Se?Se.version:null},e.clean=function(ue,De){var Se=le(ue.trim().replace(/^[=v]+/,""),De);return Se?Se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(ue){return C("SemVer.compare",this.version,this.loose,ue),ue instanceof X||(ue=new X(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},X.prototype.compareMain=function(ue){return ue instanceof X||(ue=new X(ue,this.loose)),V(this.major,ue.major)||V(this.minor,ue.minor)||V(this.patch,ue.patch)},X.prototype.comparePre=function(ue){if(ue instanceof X||(ue=new X(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var De=0;do{var Se=this.prerelease[De],$e=ue.prerelease[De];if(C("prerelease compare",De,Se,$e),Se===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Se===void 0)return-1;if(Se!==$e)return V(Se,$e)}while(++De)},X.prototype.inc=function(ue,De){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,De,Se,$e){typeof Se=="string"&&($e=Se,Se=void 0);try{return new X(ue,Se).inc(De,$e).version}catch{return null}},e.diff=function(ue,De){if(be(ue,De))return null;var Se=le(ue),$e=le(De);if(Se.prerelease.length||$e.prerelease.length){for(var He in Se)if((He==="major"||He==="minor"||He==="patch")&&Se[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in Se)if((He==="major"||He==="minor"||He==="patch")&&Se[He]!==$e[He])return He},e.compareIdentifiers=V;var T=/^[0-9]+$/;function V(ue,De){var Se=T.test(ue),$e=T.test(De);return Se&&$e&&(ue=+ue,De=+De),Se&&!$e?-1:$e&&!Se?1:ue<De?-1:ue>De?1:0}function ce(ue,De,Se){return new X(ue,Se).compare(new X(De,Se))}function me(ue,De,Se){return ce(ue,De,Se)>0}function Fe(ue,De,Se){return ce(ue,De,Se)<0}function be(ue,De,Se){return ce(ue,De,Se)===0}function Ee(ue,De,Se){return ce(ue,De,Se)!==0}function Ie(ue,De,Se){return ce(ue,De,Se)>=0}function se(ue,De,Se){return ce(ue,De,Se)<=0}function ae(ue,De,Se,$e){var He;switch(De){case"===":typeof ue=="object"&&(ue=ue.version),typeof Se=="object"&&(Se=Se.version),He=ue===Se;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof Se=="object"&&(Se=Se.version),He=ue!==Se;break;case"":case"=":case"==":He=be(ue,Se,$e);break;case"!=":He=Ee(ue,Se,$e);break;case">":He=me(ue,Se,$e);break;case">=":He=Ie(ue,Se,$e);break;case"<":He=Fe(ue,Se,$e);break;case"<=":He=se(ue,Se,$e);break;default:throw new TypeError("Invalid operator: "+De)}return He}function Z(ue,De){if(ue instanceof Z){if(ue.loose===De)return ue;ue=ue.value}if(!(this instanceof Z))return new Z(ue,De);C("comparator",ue,De),this.loose=De,this.parse(ue),this.semver===I?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ue,De){return V(De,ue)},e.major=function(ue,De){return new X(ue,De).major},e.minor=function(ue,De){return new X(ue,De).minor},e.patch=function(ue,De){return new X(ue,De).patch},e.compare=ce,e.compareLoose=function(ue,De){return ce(ue,De,!0)},e.rcompare=function(ue,De,Se){return ce(De,ue,Se)},e.sort=function(ue,De){return ue.sort(function(Se,$e){return e.compare(Se,$e,De)})},e.rsort=function(ue,De){return ue.sort(function(Se,$e){return e.rcompare(Se,$e,De)})},e.gt=me,e.lt=Fe,e.eq=be,e.neq=Ee,e.gte=Ie,e.lte=se,e.cmp=ae,e.Comparator=Z;var I={};function M(ue,De){if(ue instanceof M)return ue.loose===De?ue:new M(ue.raw,De);if(ue instanceof Z)return new M(ue.value,De);if(!(this instanceof M))return new M(ue,De);if(this.loose=De,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function H(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function x(ue,De,Se,$e,He,et,Xe,tt,rt,Me,it,Q,_){return((De=H(Se)?"":H($e)?">="+Se+".0.0":H(He)?">="+Se+"."+$e+".0":">="+De)+" "+(tt=H(rt)?"":H(Me)?"<"+(+rt+1)+".0.0":H(it)?"<"+rt+"."+(+Me+1)+".0":Q?"<="+rt+"."+Me+"."+it+"-"+Q:"<="+tt)).trim()}function te(ue,De){for(var Se=0;Se<ue.length;Se++)if(!ue[Se].test(De))return!1;if(De.prerelease.length){for(Se=0;Se<ue.length;Se++)if(C(ue[Se].semver),ue[Se].semver!==I&&ue[Se].semver.prerelease.length>0){var $e=ue[Se].semver;if($e.major===De.major&&$e.minor===De.minor&&$e.patch===De.patch)return!0}return!1}return!0}function pe(ue,De,Se){try{De=new M(De,Se)}catch{return!1}return De.test(ue)}function Ce(ue,De,Se,$e){var He,et,Xe,tt,rt;switch(ue=new X(ue,$e),De=new M(De,$e),Se){case">":He=me,et=se,Xe=Fe,tt=">",rt=">=";break;case"<":He=Fe,et=Ie,Xe=me,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ue,De,$e))return!1;for(var Me=0;Me<De.set.length;++Me){var it=De.set[Me],Q=null,_=null;if(it.forEach(function(ve){ve.semver===I&&(ve=new Z(">=0.0.0")),Q=Q||ve,_=_||ve,He(ve.semver,Q.semver,$e)?Q=ve:Xe(ve.semver,_.semver,$e)&&(_=ve)}),Q.operator===tt||Q.operator===rt||(!_.operator||_.operator===tt)&&et(ue,_.semver)||_.operator===rt&&Xe(ue,_.semver))return!1}return!0}Z.prototype.parse=function(ue){var De=this.loose?R[j]:R[he],Se=ue.match(De);if(!Se)throw new TypeError("Invalid comparator: "+ue);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new X(Se[2],this.loose):this.semver=I},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ue){return C("Comparator.test",ue,this.loose),this.semver===I||(typeof ue=="string"&&(ue=new X(ue,this.loose)),ae(ue,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ue,De){if(!(ue instanceof Z))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new M(ue.value,De),pe(this.value,Se,De);if(ue.operator==="")return Se=new M(this.value,De),pe(ue.semver,Se,De);var $e=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),et=this.semver.version===ue.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),tt=ae(this.semver,"<",ue.semver,De)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),rt=ae(this.semver,">",ue.semver,De)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return $e||He||et&&Xe||tt||rt},e.Range=M,M.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},M.prototype.toString=function(){return this.range},M.prototype.parseRange=function(ue){var De=this.loose;ue=ue.trim(),C("range",ue,De);var Se=De?R[oe]:R[ie];ue=ue.replace(Se,x),C("hyphen replace",ue),ue=ue.replace(R[we],"$1$2$3"),C("comparator trim",ue,R[we]),ue=(ue=(ue=ue.replace(R[G],"$1~")).replace(R[U],"$1^")).split(/\s+/).join(" ");var $e=De?R[j]:R[he],He=ue.split(" ").map(function(et){return function(Xe,tt){return C("comp",Xe),Xe=function(rt,Me){return rt.trim().split(/\s+/).map(function(it){return function(Q,_){C("caret",Q,_);var ve=_?R[z]:R[$];return Q.replace(ve,function(We,Be,Qe,Ye,Ge){var at;return C("caret",Q,We,Be,Qe,Ye,Ge),H(Be)?at="":H(Qe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Ye)?at=Be==="0"?">="+Be+"."+Qe+".0 <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+".0 <"+(+Be+1)+".0.0":Ge?(C("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=Be==="0"?Qe==="0"?">="+Be+"."+Qe+"."+Ye+Ge+" <"+Be+"."+Qe+"."+(+Ye+1):">="+Be+"."+Qe+"."+Ye+Ge+" <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+"."+Ye+Ge+" <"+(+Be+1)+".0.0"):(C("no pr"),at=Be==="0"?Qe==="0"?">="+Be+"."+Qe+"."+Ye+" <"+Be+"."+Qe+"."+(+Ye+1):">="+Be+"."+Qe+"."+Ye+" <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+"."+Ye+" <"+(+Be+1)+".0.0"),C("caret return",at),at})}(it,Me)}).join(" ")}(Xe,tt),C("caret",Xe),Xe=function(rt,Me){return rt.trim().split(/\s+/).map(function(it){return function(Q,_){var ve=_?R[J]:R[Y];return Q.replace(ve,function(We,Be,Qe,Ye,Ge){var at;return C("tilde",Q,We,Be,Qe,Ye,Ge),H(Be)?at="":H(Qe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Ye)?at=">="+Be+"."+Qe+".0 <"+Be+"."+(+Qe+1)+".0":Ge?(C("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=">="+Be+"."+Qe+"."+Ye+Ge+" <"+Be+"."+(+Qe+1)+".0"):at=">="+Be+"."+Qe+"."+Ye+" <"+Be+"."+(+Qe+1)+".0",C("tilde return",at),at})}(it,Me)}).join(" ")}(Xe,tt),C("tildes",Xe),Xe=function(rt,Me){return C("replaceXRanges",rt,Me),rt.split(/\s+/).map(function(it){return function(Q,_){Q=Q.trim();var ve=_?R[S]:R[v];return Q.replace(ve,function(We,Be,Qe,Ye,Ge,at){C("xRange",Q,We,Be,Qe,Ye,Ge,at);var Dt=H(Qe),Tt=Dt||H(Ye),It=Tt||H(Ge);return Be==="="&&It&&(Be=""),Dt?We=Be===">"||Be==="<"?"<0.0.0":"*":Be&&It?(Tt&&(Ye=0),It&&(Ge=0),Be===">"?(Be=">=",Tt?(Qe=+Qe+1,Ye=0,Ge=0):It&&(Ye=+Ye+1,Ge=0)):Be==="<="&&(Be="<",Tt?Qe=+Qe+1:Ye=+Ye+1),We=Be+Qe+"."+Ye+"."+Ge):Tt?We=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":It&&(We=">="+Qe+"."+Ye+".0 <"+Qe+"."+(+Ye+1)+".0"),C("xRange return",We),We})}(it,Me)}).join(" ")}(Xe,tt),C("xrange",Xe),Xe=function(rt,Me){return C("replaceStars",rt,Me),rt.trim().replace(R[de],"")}(Xe,tt),C("stars",Xe),Xe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(et){return!!et.match($e)})),He=He.map(function(et){return new Z(et,De)})},M.prototype.intersects=function(ue,De){if(!(ue instanceof M))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function($e){return ue.set.some(function(He){return He.every(function(et){return $e.intersects(et,De)})})})})},e.toComparators=function(ue,De){return new M(ue,De).set.map(function(Se){return Se.map(function($e){return $e.value}).join(" ").trim().split(" ")})},M.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new X(ue,this.loose));for(var De=0;De<this.set.length;De++)if(te(this.set[De],ue))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ue,De,Se){var $e=null,He=null;try{var et=new M(De,Se)}catch{return null}return ue.forEach(function(Xe){et.test(Xe)&&($e&&He.compare(Xe)!==-1||(He=new X($e=Xe,Se)))}),$e},e.minSatisfying=function(ue,De,Se){var $e=null,He=null;try{var et=new M(De,Se)}catch{return null}return ue.forEach(function(Xe){et.test(Xe)&&($e&&He.compare(Xe)!==1||(He=new X($e=Xe,Se)))}),$e},e.validRange=function(ue,De){try{return new M(ue,De).range||"*"}catch{return null}},e.ltr=function(ue,De,Se){return Ce(ue,De,"<",Se)},e.gtr=function(ue,De,Se){return Ce(ue,De,">",Se)},e.outside=Ce,e.prerelease=function(ue,De){var Se=le(ue,De);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(ue,De,Se){return ue=new M(ue,Se),De=new M(De,Se),ue.intersects(De)},e.coerce=function(ue){if(ue instanceof X)return ue;if(typeof ue!="string")return null;var De=ue.match(R[E]);return De==null?null:le((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,n(1))},function(ee,e){var n,A,C=ee.exports={};function F(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(t){if(n===setTimeout)return setTimeout(t,0);if((n===F||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:F}catch{n=F}try{A=typeof clearTimeout=="function"?clearTimeout:O}catch{A=O}})();var w,h=[],L=!1,D=-1;function f(){L&&w&&(L=!1,w.length?h=w.concat(h):D=-1,h.length&&b())}function b(){if(!L){var t=R(f);L=!0;for(var a=h.length;a;){for(w=h,h=[];++D<a;)w&&w[D].run();D=-1,a=h.length}w=null,L=!1,function(m){if(A===clearTimeout)return clearTimeout(m);if((A===O||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(m);try{A(m)}catch{try{return A.call(null,m)}catch{return A.call(this,m)}}}(t)}}function p(t,a){this.fun=t,this.array=a}function d(){}C.nextTick=function(t){var a=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)a[m-1]=arguments[m];h.push(new p(t,a)),h.length!==1||L||R(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[116],Ae([1,0,10,6]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(P){const g=P;return g?typeof g.read=="function":!1}e.isReadable=C;function F(P){const g=P;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=F;function O(P){const g=P;return g?F(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=O;function R(P,g){return new w(P,g)}e.newWriteableStream=R;class w{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,n.onUnexpectedError)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let u;switch(g){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const r=u.indexOf(i);r>=0&&u.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(P,g){const i=[];let u;for(;(u=P.read())!==null;)i.push(u);return g(i)}e.consumeReadable=h;function L(P,g,i){const u=[];let r;for(;(r=P.read())!==null&&u.length<i;)u.push(r);return r===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return P.read()}}}e.peekReadable=L;function D(P,g){return new Promise((i,u)=>{const r=[];f(P,{onData:c=>{g&&r.push(c)},onError:c=>{g?u(c):i(void 0)},onEnd:()=>{i(g?g(r):void 0)}})})}e.consumeStream=D;function f(P,g){let i=!1;return P.on("error",u=>{i||g.onError(u)}),P.on("end",()=>{i||g.onEnd()}),P.on("data",u=>{i||g.onData(u)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=f;function b(P,g){return new Promise((i,u)=>{const r=new A.DisposableStore,c=[],o=l=>{if(c.push(l),c.length>g)return r.dispose(),P.pause(),i({stream:P,buffer:c,ended:!1})},k=l=>u(l),s=()=>i({stream:P,buffer:c,ended:!0});r.add((0,A.toDisposable)(()=>P.removeListener("error",k))),P.on("error",k),r.add((0,A.toDisposable)(()=>P.removeListener("end",s))),P.on("end",s),r.add((0,A.toDisposable)(()=>P.removeListener("data",o))),P.on("data",o)})}e.peekStream=b;function p(P,g){const i=R(g);return i.end(P),i}e.toStream=p;function d(){const P=R(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=d;function t(P){let g=!1;return{read:()=>g?null:(g=!0,P)}}e.toReadable=t;function a(P,g,i){const u=R(i);return f(P,{onData:r=>u.write(g.data(r)),onError:r=>u.error(g.error?g.error(r):r),onEnd:()=>u.end()}),u}e.transform=a;function m(P,g,i){let u=!1;return{read:()=>{const r=g.read();return u?r:(u=!0,r!==null?i([P,r]):P)}}}e.prefixedReadable=m;function y(P,g,i){let u=!1;const r=R(i);return f(g,{onData:c=>u?r.write(c):(u=!0,r.write(i([P,c]))),onError:c=>r.error(c),onEnd:()=>{u||(u=!0,r.write(P)),r.end()}}),r}e.prefixedStream=y}),define(Pe[25],Ae([1,0,116]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let C,F;class O{static alloc(l){return A?new O(Buffer.allocUnsafe(l)):new O(new Uint8Array(l))}static wrap(l){return A&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new O(l)}static fromString(l,v){return!(v?.dontUseNodeBuffer||!1)&&A?new O(Buffer.from(l)):(C||(C=new TextEncoder),new O(C.encode(l)))}static fromByteArray(l){const v=O.alloc(l.length);for(let S=0,E=l.length;S<E;S++)v.buffer[S]=l[S];return v}static concat(l,v){if(typeof v>"u"){v=0;for(let W=0,G=l.length;W<G;W++)v+=l[W].byteLength}const S=O.alloc(v);let E=0;for(let W=0,G=l.length;W<G;W++){const Y=l[W];S.set(Y,E),E+=Y.byteLength}return S}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=O.alloc(this.byteLength);return l.set(this),l}toString(){return A?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(l,v){return new O(this.buffer.subarray(l,v))}set(l,v){if(l instanceof O)this.buffer.set(l.buffer,v);else if(l instanceof Uint8Array)this.buffer.set(l,v);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),v);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,v){L(this.buffer,l,v)}readUInt32LE(l){return D(this.buffer,l)}writeUInt32LE(l,v){f(this.buffer,l,v)}readUInt8(l){return b(this.buffer,l)}writeUInt8(l,v){p(this.buffer,l,v)}}e.VSBuffer=O;function R(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=R;function w(s,l,v){s[v+0]=l&255,l=l>>>8,s[v+1]=l&255}e.writeUInt16LE=w;function h(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=h;function L(s,l,v){s[v+3]=l,l=l>>>8,s[v+2]=l,l=l>>>8,s[v+1]=l,l=l>>>8,s[v]=l}e.writeUInt32BE=L;function D(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=D;function f(s,l,v){s[v+0]=l&255,l=l>>>8,s[v+1]=l&255,l=l>>>8,s[v+2]=l&255,l=l>>>8,s[v+3]=l&255}e.writeUInt32LE=f;function b(s,l){return s[l]}e.readUInt8=b;function p(s,l,v){s[v]=l}e.writeUInt8=p;function d(s){return n.consumeReadable(s,l=>O.concat(l))}e.readableToBuffer=d;function t(s){return n.toReadable(s)}e.bufferToReadable=t;function a(s){return n.consumeStream(s,l=>O.concat(l))}e.streamToBuffer=a;async function m(s){return s.ended?O.concat(s.buffer):O.concat([...s.buffer,await a(s.stream)])}e.bufferedStreamToBuffer=m;function y(s){return n.toStream(s,l=>O.concat(l))}e.bufferToStream=y;function P(s){return n.transform(s,{data:l=>typeof l=="string"?O.fromString(l):O.wrap(l)},l=>O.concat(l))}e.streamToBufferReadableStream=P;function g(s){return n.newWriteableStream(l=>O.concat(l),s)}e.newWriteableBufferStream=g;function i(s,l){return n.prefixedReadable(s,l,v=>O.concat(v))}e.prefixedBufferReadable=i;function u(s,l){return n.prefixedStream(s,l,v=>O.concat(v))}e.prefixedBufferStream=u;function r(s){let l=0,v=0,S=0;const E=new Uint8Array(Math.floor(s.length/4*3)),W=Y=>{switch(v){case 3:E[S++]=l|Y,v=0;break;case 2:E[S++]=l|Y>>>2,l=Y<<6,v=3;break;case 1:E[S++]=l|Y>>>4,l=Y<<4,v=2;break;default:l=Y<<2,v=1}};for(let Y=0;Y<s.length;Y++){const J=s.charCodeAt(Y);if(J>=65&&J<=90)W(J-65);else if(J>=97&&J<=122)W(J-97+26);else if(J>=48&&J<=57)W(J-48+52);else if(J===43||J===45)W(62);else if(J===47||J===95)W(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${s[Y]}`)}}const G=S;for(;v>0;)W(0);return O.wrap(E).slice(0,G)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:s},l=!0,v=!1){const S=v?o:c;let E="";const W=s.byteLength%3;let G=0;for(;G<s.byteLength-W;G+=3){const Y=s[G+0],J=s[G+1],q=s[G+2];E+=S[Y>>>2],E+=S[(Y<<4|J>>>4)&63],E+=S[(J<<2|q>>>6)&63],E+=S[q&63]}if(W===1){const Y=s[G+0];E+=S[Y>>>2],E+=S[Y<<4&63],l&&(E+="==")}else if(W===2){const Y=s[G+0],J=s[G+1];E+=S[Y>>>2],E+=S[(Y<<4|J>>>4)&63],E+=S[J<<2&63],l&&(E+="=")}return E}e.encodeBase64=k}),define(Pe[117],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[39],Ae([1,0,85]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(O){function R(w){return w&&typeof w=="object"&&typeof w.id=="string"}O.isThemeColor=R})(A=e.ThemeColor||(e.ThemeColor={}));function C(O){return{id:O}}e.themeColorFromId=C;var F;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function w(m){const y=R.exec(m.id);if(!y)return w(n.Codicon.error);const[,P,g]=y,i=["codicon","codicon-"+P];return g&&i.push("codicon-modifier-"+g.substring(1)),i}O.asClassNameArray=w;function h(m){return w(m).join(" ")}O.asClassName=h;function L(m){return"."+w(m).join(".")}O.asCSSSelector=L;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||A.isThemeColor(m.color))}O.isThemeIcon=D;const f=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function b(m){const y=f.exec(m);if(!y)return;const[,P]=y;return{id:P}}O.fromString=b;function p(m){return{id:m}}O.fromId=p;function d(m,y){let P=m.id;const g=P.lastIndexOf("~");return g!==-1&&(P=P.substring(0,g)),y&&(P=`${P}~${y}`),{id:P}}O.modify=d;function t(m){const y=m.id.lastIndexOf("~");if(y!==-1)return m.id.substring(y+1)}O.getModifier=t;function a(m,y){return m.id===y.id&&m.color?.id===y.color?.id}O.isEqual=a})(F=e.ThemeIcon||(e.ThemeIcon={}))}),define(Pe[35],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(C){return n.test(C)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(R){for(let w=0;w<R.length;w++)R[w]=Math.floor(Math.random()*256);return R};const F=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let w=0,h="";return h+=O[F[w++]],h+=O[F[w++]],h+=O[F[w++]],h+=O[F[w++]],h+="-",h+=O[F[w++]],h+=O[F[w++]],h+="-",h+=O[F[w++]],h+=O[F[w++]],h+="-",h+=O[F[w++]],h+=O[F[w++]],h+="-",h+=O[F[w++]],h+=O[F[w++]],h+=O[F[w++]],h+=O[F[w++]],h+=O[F[w++]],h+=O[F[w++]],h}}()}),define(Pe[118],Ae([1,0,16,35]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function C(R){return{id:(0,A.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=C;function F(R,w,h){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:w,data:h}),value:void 0}}e.createFileDataTransferItem=F;class O{constructor(){this.a=new Map}get size(){return this.a.size}has(w){return this.a.has(this.b(w))}get(w){return this.a.get(this.b(w))?.[0]}append(w,h){const L=this.a.get(w);L?L.push(h):this.a.set(this.b(w),[h])}replace(w,h){this.a.set(this.b(w),[h])}delete(w){this.a.delete(this.b(w))}*entries(){for(const[w,h]of this.a.entries())for(const L of h)yield[w,L]}values(){return Array.from(this.a.values()).flat()}forEach(w){for(const[h,L]of this.entries())w(L,h)}b(w){return w.toLowerCase()}}e.VSDataTransfer=O,e.UriList=Object.freeze({create:R=>(0,n.distinct)(R.map(w=>w.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(w=>!w.startsWith("#"))})}),define(Pe[119],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[120],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(O){O[O.None=0]="None",O[O.Indent=1]="Indent",O[O.IndentOutdent=2]="IndentOutdent",O[O.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class A{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let w=0,h=R.notIn.length;w<h;w++)switch(R.notIn[w]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,w){if(R.getTokenCount()===0)return!0;const h=R.findTokenIndexAtOffset(w-2),L=R.getStandardTokenType(h);return this.isOK(L)}g(R,w){for(let h=R;h<=w;h++){const L=String.fromCharCode(h);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class C{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of R)F(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),F(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),F(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),F(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&F(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=C;function F(O,R,w){O.has(R)?O.get(R).push(w):O.set(R,[w])}}),define(Pe[121],Ae([11,12]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Pe[122],Ae([11,12]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Pe[123],Ae([1,0,122]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,C=A*60,F=C*24,O=F*7,R=F*30,w=F*365;function h(D,f,b,p){typeof D!="number"&&(D=D.getTime());const d=Math.round((new Date().getTime()-D)/1e3);if(d<-30)return(0,n.localize)(0,null,h(new Date().getTime()+d*1e3,!1));if(!p&&d<30)return(0,n.localize)(1,null);let t;return d<A?(t=d,f?t===1?b?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):b?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?b?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):b?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):d<C?(t=Math.floor(d/A),f?t===1?b?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):b?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?b?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):b?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):d<F?(t=Math.floor(d/C),f?t===1?b?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):b?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?b?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):b?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):d<O?(t=Math.floor(d/F),f?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):d<R?(t=Math.floor(d/O),f?t===1?b?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):b?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?b?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):b?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):d<w?(t=Math.floor(d/R),f?t===1?b?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):b?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?b?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):b?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(d/w),f?t===1?b?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):b?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?b?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):b?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=h;function L(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Pe[124],Ae([11,12]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Pe[40],Ae([1,0,16,9,124]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function F(D,f){return f&&(D.stack||D.stacktrace)?C.localize(0,null,R(D),O(D.stack)||O(D.stacktrace)):R(D)}function O(D){return Array.isArray(D)?D.join(`
`):D}function R(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function w(D=null,f=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const b=n.coalesce(D),p=w(b[0],f);return b.length>1?C.localize(4,null,p,b.length):p}if(A.isString(D))return D;if(D.detail){const b=D.detail;if(b.error)return F(b.error,f);if(b.exception)return F(b.exception,f)}return D.stack?F(D,f):D.message?D.message:C.localize(5,null)}e.toErrorMessage=w;function h(D){const f=D;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=h;function L(D,f){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=f,b}e.createErrorWithActions=L}),define(Pe[125],Ae([1,0,86,19]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new n.Lazy(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),F=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),O=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(l,v,S=!1){const E=l||"",W=v||"",G=C.value.collator.compare(E,W);return C.value.collatorIsNumeric&&G===0&&E!==W?E<W?-1:1:G}e.compareFileNames=R;function w(l,v){const S=F.value.collator;return l=l||"",v=v||"",P(S,l,v)}e.compareFileNamesDefault=w;function h(l,v){const S=F.value.collator;return l=l||"",v=v||"",r(l,v)||P(S,l,v)}e.compareFileNamesUpper=h;function L(l,v){const S=F.value.collator;return l=l||"",v=v||"",u(l,v)||P(S,l,v)}e.compareFileNamesLower=L;function D(l,v){return l=l||"",v=v||"",l===v?0:l<v?-1:1}e.compareFileNamesUnicode=D;function f(l,v){const[S,E]=m(l),[W,G]=m(v);let Y=C.value.collator.compare(E,G);if(Y===0){if(C.value.collatorIsNumeric&&E!==G)return E<G?-1:1;if(Y=C.value.collator.compare(S,W),C.value.collatorIsNumeric&&Y===0&&S!==W)return S<W?-1:1}return Y}e.compareFileExtensions=f;function b(l,v){l=l||"",v=v||"";const S=y(l),E=y(v),W=F.value.collator,G=O.value.collator;return P(G,S,E)||P(W,l,v)}e.compareFileExtensionsDefault=b;function p(l,v){l=l||"",v=v||"";const S=y(l),E=y(v),W=F.value.collator,G=O.value.collator;return P(G,S,E)||r(l,v)||P(W,l,v)}e.compareFileExtensionsUpper=p;function d(l,v){l=l||"",v=v||"";const S=y(l),E=y(v),W=F.value.collator,G=O.value.collator;return P(G,S,E)||u(l,v)||P(W,l,v)}e.compareFileExtensionsLower=d;function t(l,v){l=l||"",v=v||"";const S=y(l).toLowerCase(),E=y(v).toLowerCase();return S!==E?S<E?-1:1:l!==v?l<v?-1:1:0}e.compareFileExtensionsUnicode=t;const a=/^(.*?)(\.([^.]*))?$/;function m(l,v=!1){const S=l?a.exec(l):[];let E=[S&&S[1]||"",S&&S[3]||""];return v&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function y(l){const v=l?a.exec(l):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function P(l,v,S){const E=l.compare(v,S);return E!==0?E:v.length!==S.length?v.length<S.length?-1:1:0}function g(l){const v=l.charAt(0);return v.toLocaleUpperCase()!==v}function i(l){const v=l.charAt(0);return v.toLocaleLowerCase()!==v}function u(l,v){return g(l)&&i(v)?-1:i(l)&&g(v)?1:0}function r(l,v){return i(l)&&g(v)?-1:g(l)&&i(v)?1:0}function c(l,v,S=!1){return S||(l=l&&l.toLowerCase(),v=v&&v.toLowerCase()),l===v?0:l<v?-1:1}function o(l,v,S=!1){const E=l.split(A.sep),W=v.split(A.sep),G=E.length-1,Y=W.length-1;let J,q;for(let U=0;;U++){if(J=G===U,q=Y===U,J&&q)return R(E[U],W[U],S);if(J)return-1;if(q)return 1;const $=c(E[U],W[U],S);if($!==0)return $}}e.comparePaths=o;function k(l,v,S){const E=l.toLowerCase(),W=v.toLowerCase(),G=s(l,v,S);if(G)return G;const Y=E.endsWith(S),J=W.endsWith(S);if(Y!==J)return Y?-1:1;const q=R(E,W);return q!==0?q:E.localeCompare(W)}e.compareAnything=k;function s(l,v,S){const E=l.toLowerCase(),W=v.toLowerCase(),G=E.startsWith(S),Y=W.startsWith(S);if(G!==Y)return G?-1:1;if(G&&Y){if(E.length<W.length)return-1;if(E.length>W.length)return 1}return 0}e.compareByPrefix=s}),define(Pe[65],Ae([1,0,19]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(L){const D=(0,n.extname)(L),f=A[D.toLowerCase()];return f!==void 0?f:O(L)}e.getMediaOrTextMime=F;function O(L){const D=(0,n.extname)(L);return C[D.toLowerCase()]}e.getMediaMime=O;function R(L){for(const D in C)if(C[D]===L)return D}e.getExtensionForMimeType=R;const w=/^(.+)\/(.+?)(;.+)?$/;function h(L,D){const f=w.exec(L);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:D?void 0:L}e.normalizeMimeType=h}),define(Pe[126],Ae([1,0,5,6,121]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class F extends A.Disposable{constructor(f,b="",p="",d=!0,t){super(),this.j=this.D(new n.Emitter),this.onDidChange=this.j.event,this.w=!0,this.m=f,this.n=b,this.u=p,this.w=d,this.C=t}get id(){return this.m}get label(){return this.n}set label(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.j.fire({label:f}))}get tooltip(){return this.q||""}set tooltip(f){this.G(f)}G(f){this.q!==f&&(this.q=f,this.j.fire({tooltip:f}))}get class(){return this.u}set class(f){this.H(f)}H(f){this.u!==f&&(this.u=f,this.j.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.I(f)}I(f){this.w!==f&&(this.w=f,this.j.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.J(f)}J(f){this.z!==f&&(this.z=f,this.j.fire({checked:f}))}async run(f,b){this.C&&await this.C(f)}}e.Action=F;class O extends A.Disposable{constructor(){super(...arguments),this.f=this.D(new n.Emitter),this.onWillRun=this.f.event,this.h=this.D(new n.Emitter),this.onDidRun=this.h.event}async run(f,b){if(!f.enabled)return;this.f.fire({action:f});let p;try{await this.k(f,b)}catch(d){p=d}this.h.fire({action:f,error:p})}async k(f,b){await f.run(b)}}e.ActionRunner=O;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let b=[];for(const p of f)p.length&&(b.length?b=[...b,new R,...p]:b=p);return b}async run(){}}R.ID="vs.actions.separator",e.Separator=R;class w{get actions(){return this.a}constructor(f,b,p,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=b,this.class=d,this.a=p}async run(){}}e.SubmenuAction=w;class h extends F{constructor(){super(h.ID,C.localize(0,null),void 0,!1)}}h.ID="vs.actions.empty",e.EmptySubmenuAction=h;function L(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.toAction=L}),define(Pe[41],Ae([1,0,19,20,13,9]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(o){return o===47||o===92}e.isPathSeparator=O;function R(o){return o.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=R;function w(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function h(o,k=n.posix.sep){if(!o)return"";const s=o.length,l=o.charCodeAt(0);if(O(l)){if(O(o.charCodeAt(1))&&!O(o.charCodeAt(2))){let S=3;const E=S;for(;S<s&&!O(o.charCodeAt(S));S++);if(E!==S&&!O(o.charCodeAt(S+1))){for(S+=1;S<s;S++)if(O(o.charCodeAt(S)))return o.slice(0,S+1).replace(/[\\/]/g,k)}}return k}else if(a(l)&&o.charCodeAt(1)===58)return O(o.charCodeAt(2))?o.slice(0,2)+k:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<s;v++)if(O(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=h;function L(o){if(!A.isWindows||!o||o.length<5)return!1;let k=o.charCodeAt(0);if(k!==92||(k=o.charCodeAt(1),k!==92))return!1;let s=2;const l=s;for(;s<o.length&&(k=o.charCodeAt(s),k!==92);s++);return!(l===s||(k=o.charCodeAt(s+1),isNaN(k)||k===92))}e.isUNC=L;const D=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,k=A.isWindows){const s=k?D:f;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||k&&b.test(o)||o==="."||o===".."||k&&o[o.length-1]==="."||k&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function d(o,k,s){const l=o===k;return!s||l?l:!o||!k?!1:(0,C.equalsIgnoreCase)(o,k)}e.isEqual=d;function t(o,k,s,l=n.sep){if(o===k)return!0;if(!o||!k||k.length>o.length)return!1;if(s){if(!(0,C.startsWithIgnoreCase)(o,k))return!1;if(k.length===o.length)return!0;let S=k.length;return k.charAt(k.length-1)===l&&S--,o.charAt(S)===l}return k.charAt(k.length-1)!==l&&(k+=l),o.indexOf(k)===0}e.isEqualOrParent=t;function a(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=a;function m(o,k){return A.isWindows&&o.endsWith(":")&&(o+=n.sep),(0,n.isAbsolute)(o)||(o=(0,n.join)(k,o)),o=(0,n.normalize)(o),A.isWindows?(o=(0,C.rtrim)(o,n.sep),o.endsWith(":")&&(o+=n.sep)):(o=(0,C.rtrim)(o,n.sep),o||(o=n.sep)),o}e.sanitizeFilePath=m;function y(o){const k=(0,n.normalize)(o);return A.isWindows?o.length>3?!1:P(k)&&(o.length===2||k.charCodeAt(2)===92):k===n.posix.sep}e.isRootOrDriveLetter=y;function P(o,k=A.isWindows){return k?a(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function g(o){return P(o)?o[0]:void 0}e.getDriveLetter=g;function i(o,k,s){return k.length>o.length?-1:o===k?0:(s&&(o=o.toLowerCase(),k=k.toLowerCase()),o.indexOf(k))}e.indexOfPath=i;function u(o){const k=o.split(":");let s,l,v;for(const S of k){const E=Number(S);(0,F.isNumber)(E)?l===void 0?l=E:v===void 0&&(v=E):s=s?[s,S].join(":"):S}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:v!==void 0?v:l!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(o,k,s=8){let l="";for(let S=0;S<s;S++)l+=r.charAt(Math.floor(Math.random()*r.length));let v;return k?v=`${k}-${l}`:v=l,o?(0,n.join)(o,v):v}e.randomPath=c}),define(Pe[127],Ae([1,0,28,13]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(I,M){for(let H=0,x=Z.length;H<x;H++){const te=Z[H](I,M);if(te)return te}return null}}e.or=C,e.matchesStrictPrefix=F.bind(void 0,!1),e.matchesPrefix=F.bind(void 0,!0);function F(Z,I,M){if(!M||M.length<I.length)return null;let H;return Z?H=A.startsWithIgnoreCase(M,I):H=M.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function O(Z,I){const M=I.toLowerCase().indexOf(Z.toLowerCase());return M===-1?null:[{start:M,end:M+Z.length}]}e.matchesContiguousSubString=O;function R(Z,I){return w(Z.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function w(Z,I,M,H){if(M===Z.length)return[];if(H===I.length)return null;if(Z[M]===I[H]){let x=null;return(x=w(Z,I,M+1,H+1))?a({start:H,end:H+1},x):null}return w(Z,I,M,H+1)}function h(Z){return 97<=Z&&Z<=122}function L(Z){return 65<=Z&&Z<=90}e.isUpper=L;function D(Z){return 48<=Z&&Z<=57}function f(Z){return Z===32||Z===9||Z===10||Z===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>b.add(Z.charCodeAt(0)));function p(Z){return f(Z)||b.has(Z)}function d(Z,I){return Z===I||p(Z)&&p(I)}function t(Z){return h(Z)||L(Z)||D(Z)}function a(Z,I){return I.length===0?I=[Z]:Z.end===I[0].start?I[0].start=Z.start:I.unshift(Z),I}function m(Z,I){for(let M=I;M<Z.length;M++){const H=Z.charCodeAt(M);if(L(H)||D(H)||M>0&&!t(Z.charCodeAt(M-1)))return M}return Z.length}function y(Z,I,M,H){if(M===Z.length)return[];if(H===I.length)return null;if(Z[M]!==I[H].toLowerCase())return null;{let x=null,te=H+1;for(x=y(Z,I,M+1,H+1);!x&&(te=m(I,te))<I.length;)x=y(Z,I,M+1,te),te++;return x===null?null:a({start:H,end:H+1},x)}}function P(Z){let I=0,M=0,H=0,x=0,te=0;for(let Se=0;Se<Z.length;Se++)te=Z.charCodeAt(Se),L(te)&&I++,h(te)&&M++,t(te)&&H++,D(te)&&x++;const pe=I/Z.length,Ce=M/Z.length,ue=H/Z.length,De=x/Z.length;return{upperPercent:pe,lowerPercent:Ce,alphaPercent:ue,numericPercent:De}}function g(Z){const{upperPercent:I,lowerPercent:M}=Z;return M===0&&I>.6}function i(Z){const{upperPercent:I,lowerPercent:M,alphaPercent:H,numericPercent:x}=Z;return M>.2&&I<.8&&H>.6&&x<.2}function u(Z){let I=0,M=0,H=0,x=0;for(let te=0;te<Z.length;te++)H=Z.charCodeAt(te),L(H)&&I++,h(H)&&M++,f(H)&&x++;return(I===0||M===0)&&x===0?Z.length<=30:I<=5}function r(Z,I){if(!I||(I=I.trim(),I.length===0)||!u(Z)||I.length>60)return null;const M=P(I);if(!i(M)){if(!g(M))return null;I=I.toLowerCase()}let H=null,x=0;for(Z=Z.toLowerCase();x<I.length&&(H=y(Z,I,0,x))===null;)x=m(I,x+1);return H}e.matchesCamelCase=r;function c(Z,I,M=!1){if(!I||I.length===0)return null;let H=null,x=0;for(Z=Z.toLowerCase(),I=I.toLowerCase();x<I.length&&(H=o(Z,I,0,x,M))===null;)x=k(I,x+1);return H}e.matchesWords=c;function o(Z,I,M,H,x){if(M===Z.length)return[];if(H===I.length)return null;if(d(Z.charCodeAt(M),I.charCodeAt(H))){let te=null,pe=H+1;if(te=o(Z,I,M+1,H+1,x),!x)for(;!te&&(pe=k(I,pe))<I.length;)te=o(Z,I,M+1,pe,x),pe++;return te?Z.charCodeAt(M)!==I.charCodeAt(H)?te:a({start:H,end:H+1},te):null}else return null}function k(Z,I){for(let M=I;M<Z.length;M++)if(p(Z.charCodeAt(M))||M>0&&p(Z.charCodeAt(M-1)))return M;return Z.length}const s=C(e.matchesPrefix,r,O),l=C(e.matchesPrefix,r,R),v=new n.LRUCache(1e4);function S(Z,I,M=!1){if(typeof Z!="string"||typeof I!="string")return null;let H=v.get(Z);H||(H=new RegExp(A.convertSimple2RegExpPattern(Z),"i"),v.set(Z,H));const x=H.exec(I);return x?[{start:x.index,end:x.index+x[0].length}]:M?l(Z,I):s(Z,I)}e.matchesFuzzy=S;function E(Z,I){const M=me(Z,Z.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return M?G(M):null}e.matchesFuzzy2=E;function W(Z,I,M,H,x,te){const pe=Math.min(13,Z.length);for(;M<pe;M++){const Ce=me(Z,I,M,H,x,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ce)return Ce}return[0,te]}e.anyScore=W;function G(Z){if(typeof Z>"u")return[];const I=[],M=Z[1];for(let H=Z.length-1;H>1;H--){const x=Z[H]+M,te=I[I.length-1];te&&te.end===x?te.end=x+1:I.push({start:x,end:x+1})}return I}e.createMatches=G;const Y=128;function J(){const Z=[],I=[];for(let M=0;M<=Y;M++)I[M]=0;for(let M=0;M<=Y;M++)Z.push(I.slice(0));return Z}function q(Z){const I=[];for(let M=0;M<=Z;M++)I[M]=0;return I}const U=q(2*Y),$=q(2*Y),z=J(),j=J(),he=J(),we=!1;function ie(Z,I,M,H,x){function te(Ce,ue,De=" "){for(;Ce.length<ue;)Ce=De+Ce;return Ce}let pe=` |   |${H.split("").map(Ce=>te(Ce,3)).join("|")}
`;for(let Ce=0;Ce<=M;Ce++)Ce===0?pe+=" |":pe+=`${I[Ce-1]}|`,pe+=Z[Ce].slice(0,x+1).map(ue=>te(ue.toString(),3)).join("|")+`
`;return pe}function oe(Z,I,M,H){Z=Z.substr(I),M=M.substr(H),console.log(ie(j,Z,Z.length,M,M.length)),console.log(ie(he,Z,Z.length,M,M.length)),console.log(ie(z,Z,Z.length,M,M.length))}function de(Z,I){if(I<0||I>=Z.length)return!1;const M=Z.codePointAt(I);switch(M){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(M)}}function ke(Z,I){if(I<0||I>=Z.length)return!1;switch(Z.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function le(Z,I,M){return I[Z]!==M[Z]}function X(Z,I,M,H,x,te,pe=!1){for(;I<M&&x<te;)Z[I]===H[x]&&(pe&&(U[I]=x),I+=1),x+=1;return I===M}e.isPatternInWord=X;var T;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(T||(T={}));var V;(function(Z){Z.Default=[-100,0];function I(M){return!M||M.length===2&&M[0]===-100&&M[1]===0}Z.isDefault=I})(V=e.FuzzyScore||(e.FuzzyScore={}));class ce{constructor(I,M){this.firstMatchCanBeWeak=I,this.boostFullMatch=M}}ce.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ce;function me(Z,I,M,H,x,te,pe=ce.default){const Ce=Z.length>Y?Y:Z.length,ue=H.length>Y?Y:H.length;if(M>=Ce||te>=ue||Ce-M>ue-te||!X(I,M,Ce,x,te,ue,!0))return;Fe(Ce,ue,M,te,I,x);let De=1,Se=1,$e=M,He=te;const et=[!1];for(De=1,$e=M;$e<Ce;De++,$e++){const it=U[$e],Q=$[$e],_=$e+1<Ce?$[$e+1]:ue;for(Se=it-te+1,He=it;He<_;Se++,He++){let ve=Number.MIN_SAFE_INTEGER,We=!1;He<=Q&&(ve=be(Z,I,$e,M,H,x,He,ue,te,z[De-1][Se-1]===0,et));let Be=0;ve!==Number.MAX_SAFE_INTEGER&&(We=!0,Be=ve+j[De-1][Se-1]);const Qe=He>it,Ye=Qe?j[De][Se-1]+(z[De][Se-1]>0?-5:0):0,Ge=He>it+1&&z[De][Se-1]>0,at=Ge?j[De][Se-2]+(z[De][Se-2]>0?-5:0):0;if(Ge&&(!Qe||at>=Ye)&&(!We||at>=Be))j[De][Se]=at,he[De][Se]=3,z[De][Se]=0;else if(Qe&&(!We||Ye>=Be))j[De][Se]=Ye,he[De][Se]=2,z[De][Se]=0;else if(We)j[De][Se]=Be,he[De][Se]=1,z[De][Se]=z[De-1][Se-1]+1;else throw new Error("not possible")}}if(we&&oe(Z,M,H,te),!et[0]&&!pe.firstMatchCanBeWeak)return;De--,Se--;const Xe=[j[De][Se],te];let tt=0,rt=0;for(;De>=1;){let it=Se;do{const Q=he[De][it];if(Q===3)it=it-2;else if(Q===2)it=it-1;else break}while(it>=1);tt>1&&I[M+De-1]===x[te+Se-1]&&!le(it+te-1,H,x)&&tt+1>z[De][it]&&(it=Se),it===Se?tt++:tt=1,rt||(rt=it),De--,Se=it-1,Xe.push(Se)}ue===Ce&&pe.boostFullMatch&&(Xe[0]+=2);const Me=rt-Ce;return Xe[0]-=Me,Xe}e.fuzzyScore=me;function Fe(Z,I,M,H,x,te){let pe=Z-1,Ce=I-1;for(;pe>=M&&Ce>=H;)x[pe]===te[Ce]&&($[pe]=Ce,pe--),Ce--}function be(Z,I,M,H,x,te,pe,Ce,ue,De,Se){if(I[M]!==te[pe])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return pe===M-H?$e=Z[M]===x[pe]?7:5:le(pe,x,te)&&(pe===0||!le(pe-1,x,te))?($e=Z[M]===x[pe]?7:5,He=!0):de(te,pe)&&(pe===0||!de(te,pe-1))?$e=5:(de(te,pe-1)||ke(te,pe-1))&&($e=5,He=!0),$e>1&&M===H&&(Se[0]=!0),He||(He=le(pe,x,te)||de(te,pe-1)||ke(te,pe-1)),M===H?pe>ue&&($e-=He?3:5):De?$e+=He?2:0:$e+=He?0:1,pe+1===Ce&&($e-=He?3:5),$e}function Ee(Z,I,M,H,x,te,pe){return se(Z,I,M,H,x,te,!0,pe)}e.fuzzyScoreGracefulAggressive=Ee;function Ie(Z,I,M,H,x,te,pe){return se(Z,I,M,H,x,te,!1,pe)}e.fuzzyScoreGraceful=Ie;function se(Z,I,M,H,x,te,pe,Ce){let ue=me(Z,I,M,H,x,te,Ce);if(ue&&!pe)return ue;if(Z.length>=3){const De=Math.min(7,Z.length-1);for(let Se=M+1;Se<De;Se++){const $e=ae(Z,Se);if($e){const He=me($e,$e.toLowerCase(),M,H,x,te,Ce);He&&(He[0]-=3,(!ue||He[0]>ue[0])&&(ue=He))}}}return ue}function ae(Z,I){if(I+1>=Z.length)return;const M=Z[I],H=Z[I+1];if(M!==H)return Z.slice(0,I)+H+M+Z.slice(I+2)}}),define(Pe[128],Ae([1,0,127,13,39]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const F="$(",O=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${O.source}`,"g");function w(a){return a.replace(R,(m,y)=>y?m:`\\${m}`)}e.escapeIcons=w;const h=new RegExp(`\\\\${O.source}`,"g");function L(a){return a.replace(h,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=L;const D=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function f(a){return a.indexOf(F)===-1?a:a.replace(D,(m,y,P,g)=>P?m:y||g||"")}e.stripIcons=f;function b(a){return a?a.replace(/\$\((.*?)\)/g,(m,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=b;const p=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(a){p.lastIndex=0;let m="";const y=[];let P=0;for(;;){const g=p.lastIndex,i=p.exec(a),u=a.substring(g,i?.index);if(u.length>0){m+=u;for(let r=0;r<u.length;r++)y.push(P)}if(!i)break;P+=i[0].length}return{text:m,iconOffsets:y}}e.parseLabelWithIcons=d;function t(a,m,y=!1){const{text:P,iconOffsets:g}=m;if(!g||g.length===0)return(0,n.matchesFuzzy)(a,P,y);const i=(0,A.ltrim)(P," "),u=P.length-i.length,r=(0,n.matchesFuzzy)(a,i,y);if(r)for(const c of r){const o=g[c.start+u]+u;c.start+=o,c.end+=o}return r}e.matchesFuzzyIconAware=t}),define(Pe[29],Ae([1,0,13]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(A||(A={})),function(C){const F="error",O="warning",R="warn",w="info",h="ignore";function L(f){return f?n.equalsIgnoreCase(F,f)?C.Error:n.equalsIgnoreCase(O,f)||n.equalsIgnoreCase(R,f)?C.Warning:n.equalsIgnoreCase(w,f)?C.Info:C.Ignore:C.Ignore}C.fromValue=L;function D(f){switch(f){case C.Error:return F;case C.Warning:return O;case C.Info:return w;default:return h}}C.toString=D}(A||(A={})),e.default=A}),define(Pe[48],Ae([1,0,16,13]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),d=this.b.charCodeAt(this.c);return p-d}value(){return this.b[this.c]}}e.StringIterator=C;class F{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,A.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=F;class O{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const d=this.b.charCodeAt(p);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,A.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class w{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,A.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(L||(L={}));class D{static forUris(b=()=>!1,p=()=>!1){return new D(new w(b,p))}static forPaths(b=!1){return new D(new O(void 0,!b))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new F)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const d=p.slice(0);(0,n.shuffle)(d);for(const t of d)this.set(t,b)}else{const d=b.slice(0);(0,n.shuffle)(d);for(const t of d)this.set(t[0],t[1])}}set(b,p){const d=this.b.reset(b);let t;this.c||(this.c=new h,this.c.segment=d.value());const a=[];for(t=this.c;;){const y=d.cmp(t.segment);if(y>0)t.left||(t.left=new h,t.left.segment=d.value()),a.push([-1,t]),t=t.left;else if(y<0)t.right||(t.right=new h,t.right.segment=d.value()),a.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new h,t.mid.segment=d.value()),a.push([0,t]),t=t.mid;else break}const m=t.value;t.value=p,t.key=b;for(let y=a.length-1;y>=0;y--){const P=a[y][1];P.updateHeight();const g=P.balanceFactor();if(g<-1||g>1){const i=a[y][0],u=a[y+1][0];if(i===1&&u===1)a[y][1]=P.rotateLeft();else if(i===-1&&u===-1)a[y][1]=P.rotateRight();else if(i===1&&u===-1)P.right=a[y+1][1]=a[y+1][1].rotateRight(),a[y][1]=P.rotateLeft();else if(i===-1&&u===1)P.left=a[y+1][1]=a[y+1][1].rotateLeft(),a[y][1]=P.rotateRight();else throw new Error;if(y>0)switch(a[y-1][0]){case-1:a[y-1][1].left=a[y][1];break;case 1:a[y-1][1].right=a[y][1];break;case 0:a[y-1][1].mid=a[y][1];break}else this.c=a[0][1]}}return m}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let d=this.c;for(;d;){const t=p.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(p.hasNext())p.next(),d=d.mid;else break}return d}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const d=this.b.reset(b),t=[];let a=this.c;for(;a;){const m=d.cmp(a.segment);if(m>0)t.push([-1,a]),a=a.left;else if(m<0)t.push([1,a]),a=a.right;else if(d.hasNext())d.next(),t.push([0,a]),a=a.mid;else break}if(!!a){if(p?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const m=this.f(a.right);if(m.key){const{key:y,value:P,segment:g}=m;this.e(m.key,!1),a.key=y,a.value=P,a.segment=g}}else{const m=a.left??a.right;if(t.length>0){const[y,P]=t[t.length-1];switch(y){case-1:P.left=m;break;case 0:P.mid=m;break;case 1:P.right=m;break}}else this.c=m}for(let m=t.length-1;m>=0;m--){const y=t[m][1];y.updateHeight();const P=y.balanceFactor();if(P>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),t[m][1]=y.rotateLeft()):P<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),t[m][1]=y.rotateRight()),m>0)switch(t[m-1][0]){case-1:t[m-1][1].left=t[m][1];break;case 1:t[m-1][1].right=t[m][1];break;case 0:t[m-1][1].mid=t[m][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let d=this.c,t;for(;d;){const a=p.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(p.hasNext())p.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(b){return this.g(b,!1)}g(b,p){const d=this.b.reset(b);let t=this.c;for(;t;){const a=d.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,d]of this)b(d,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){!b||(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const d=p.balanceFactor();return d<-1||d>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.TernarySearchTree=D}),define(Pe[66],Ae([1,0,25,13,2]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function F(h){return JSON.stringify(h,R)}e.stringify=F;function O(h){let L=JSON.parse(h);return L=w(L),L}e.parse=O;function R(h,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function w(h,L=0){if(!h||L>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return C.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let D=0;D<h.length;++D)h[D]=w(h[D],L+1);else for(const D in h)Object.hasOwnProperty.call(h,D)&&(h[D]=w(h[D],L+1))}return h}e.revive=w}),define(Pe[15],Ae([1,0,10,20,2]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var F;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(F=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${F.vscodeRemoteResource}`}set(L,D,f){this.a[L]=D,this.b[L]=f}setConnectionToken(L,D){this.c[L]=D}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(t){return n.onUnexpectedError(t),L}const D=L.authority;let f=this.a[D];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const b=this.b[D],p=this.c[D];let d=`path=${encodeURIComponent(L.path)}`;return typeof p=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),C.URI.from({scheme:A.isWeb?this.d:F.vscodeRemoteResource,authority:`${f}:${b}`,path:this.f,query:d})}}e.RemoteAuthorities=new O,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(L){const D=this.b(L,ee);return this.uriToBrowserUri(D)}uriToBrowserUri(L){return L.scheme===F.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===F.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${F.vscodeFileResource}://${R.a}`)?L.with({scheme:F.vscodeFileResource,authority:L.authority||R.a,query:null,fragment:null}):L}asFileUri(L){const D=this.b(L,ee);return this.uriToFileUri(D)}uriToFileUri(L){return L.scheme===F.vscodeFileResource?L.with({scheme:F.file,authority:L.authority!==R.a?L.authority:null,query:null,fragment:null}):L}b(L,D){return C.URI.isUri(L)?L:C.URI.parse(D.toUrl(L))}}R.a="vscode-app",e.FileAccess=new R;var w;(function(h){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(L.get("3"));const D="vscode-coi";function f(p){let d;typeof p=="string"?d=new URL(p).searchParams:p instanceof URL?d=p.searchParams:C.URI.isUri(p)&&(d=new URL(p.toString(!0)).searchParams);const t=d?.get(D);if(!!t)return L.get(t)}h.getHeadersFromQuery=f;function b(p,d,t){if(!globalThis.crossOriginIsolated)return;const a=d&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(D,a):p[D]=a}h.addSearchParam=b})(w=e.COI||(e.COI={}))}),define(Pe[22],Ae([1,0,41,15,19,20,13,2]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=w;class h{constructor(p){this.a=p}compare(p,d,t=!1){return p===d?0:(0,O.compare)(this.getComparisonKey(p,t),this.getComparisonKey(d,t))}isEqual(p,d,t=!1){return p===d?!0:!p||!d?!1:this.getComparisonKey(p,t)===this.getComparisonKey(d,t)}getComparisonKey(p,d=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,d,t=!1){if(p.scheme===d.scheme){if(p.scheme===A.Schemas.file)return n.isEqualOrParent(w(p),w(d),this.a(p))&&p.query===d.query&&(t||p.fragment===d.fragment);if((0,e.isEqualAuthority)(p.authority,d.authority))return n.isEqualOrParent(p.path,d.path,this.a(p),"/")&&p.query===d.query&&(t||p.fragment===d.fragment)}return!1}joinPath(p,...d){return R.URI.joinPath(p,...d)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return C.posix.basename(p.path)}extname(p){return C.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let d;return p.scheme===A.Schemas.file?d=R.URI.file(C.dirname(w(p))).path:(d=C.posix.dirname(p.path),p.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),d="/")),p.with({path:d})}normalizePath(p){if(!p.path.length)return p;let d;return p.scheme===A.Schemas.file?d=R.URI.file(C.normalize(w(p))).path:d=C.posix.normalize(p.path),p.with({path:d})}relativePath(p,d){if(p.scheme!==d.scheme||!(0,e.isEqualAuthority)(p.authority,d.authority))return;if(p.scheme===A.Schemas.file){const m=C.relative(w(p),w(d));return F.isWindows?n.toSlashes(m):m}let t=p.path||"/";const a=d.path||"/";if(this.a(p)){let m=0;for(const y=Math.min(t.length,a.length);m<y&&!(t.charCodeAt(m)!==a.charCodeAt(m)&&t.charAt(m).toLowerCase()!==a.charAt(m).toLowerCase());m++);t=a.substr(0,m)+t.substr(m)}return C.posix.relative(t,a)}resolvePath(p,d){if(p.scheme===A.Schemas.file){const t=R.URI.file(C.resolve(w(p),d));return p.with({authority:t.authority,path:t.path})}return d=n.toPosixPath(d),p.with({path:C.posix.resolve(p.path,d)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,d){return p===d||p!==void 0&&d!==void 0&&(0,O.equalsIgnoreCase)(p,d)}hasTrailingPathSeparator(p,d=C.sep){if(p.scheme===A.Schemas.file){const t=w(p);return t.length>n.getRoot(t).length&&t[t.length-1]===d}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,d=C.sep){return(0,e.hasTrailingPathSeparator)(p,d)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,d=C.sep){let t=!1;if(p.scheme===A.Schemas.file){const a=w(p);t=a!==void 0&&a.length===n.getRoot(a).length&&a[a.length-1]===d}else{d="/";const a=p.path;t=a.length===1&&a.charCodeAt(a.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(p,d)?p.with({path:p.path+"/"}):p}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(b=>b.scheme===A.Schemas.file?!F.isLinux:!0),e.extUriIgnorePathCase=new h(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(b,p){const d=[];for(let t=0;t<b.length;t++){const a=p(b[t]);b.some((m,y)=>y===t?!1:(0,e.isEqualOrParent)(a,p(m)))||d.push(b[t])}return d}e.distinctParents=L;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(y=>{const[P,g]=y.split(":");P&&g&&t.set(P,g)});const m=d.path.substring(0,d.path.indexOf(";"));return m&&t.set(b.META_DATA_MIME,m),t}b.parseMetaData=p})(D=e.DataUri||(e.DataUri={}));function f(b,p,d){if(p){let t=b.path;return t&&t[0]!==C.posix.sep&&(t=C.posix.sep+t),b.with({scheme:d,authority:p,path:t})}return b.with({scheme:d})}e.toLocalResource=f}),define(Pe[17],Ae([1,0,21,10,5,6,22,20,117]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(X){return!!X&&typeof X.then=="function"}e.isThenable=h;function L(X){const T=new n.CancellationTokenSource,V=X(T.token),ce=new Promise((me,Fe)=>{const be=T.token.onCancellationRequested(()=>{be.dispose(),T.dispose(),Fe(new A.CancellationError)});Promise.resolve(V).then(Ee=>{be.dispose(),T.dispose(),me(Ee)},Ee=>{be.dispose(),T.dispose(),Fe(Ee)})});return new class{cancel(){T.cancel()}then(me,Fe){return ce.then(me,Fe)}catch(me){return this.then(void 0,me)}finally(me){return ce.finally(me)}}}e.createCancelablePromise=L;function D(X,T,V){return new Promise((ce,me)=>{const Fe=T.onCancellationRequested(()=>{Fe.dispose(),ce(V)});X.then(ce,me).finally(()=>Fe.dispose())})}e.raceCancellation=D;function f(X,T){return new Promise((V,ce)=>{const me=T.onCancellationRequested(()=>{me.dispose(),ce(new A.CancellationError)});X.then(V,ce).finally(()=>me.dispose())})}e.raceCancellationError=f;async function b(X){let T=-1;const V=X.map((me,Fe)=>me.then(be=>(T=Fe,be))),ce=await Promise.race(V);return X.forEach((me,Fe)=>{Fe!==T&&me.cancel()}),ce}e.raceCancellablePromises=b;function p(X,T,V){let ce;const me=setTimeout(()=>{ce?.(void 0),V?.()},T);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(Fe=>ce=Fe)])}e.raceTimeout=p;function d(X){return new Promise((T,V)=>{const ce=X();h(ce)?ce.then(T,V):T(ce)})}e.asPromise=d;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(T){if(this.a){if(this.d=T,!this.b){const V=()=>{this.b=null;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(V,V).then(ce)})}return new Promise((V,ce)=>{this.b.then(V,ce)})}return this.a=T(),new Promise((V,ce)=>{this.a.then(me=>{this.a=null,V(me)},me=>{this.a=null,ce(me)})})}}e.Throttler=t;class a{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.Sequencer=a;class m{constructor(){this.a=new Map}queue(T,V){const me=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(T)===me&&this.a.delete(T)});return this.a.set(T,me),me}}e.SequencerByKey=m;const y=(X,T)=>{let V=!0;const ce=setTimeout(()=>{V=!1,T()},X);return{isTriggered:()=>V,dispose:()=>{clearTimeout(ce),V=!1}}},P=X=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,X())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class g{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,V=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((me,Fe)=>{this.d=me,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=V===w.MicrotaskDelay?P(ce):y(V,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class i{constructor(T){this.a=new g(T),this.b=new t}trigger(T,V){return this.a.trigger(()=>this.b.queue(T),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class u{constructor(){this.a=!1,this.b=new Promise((T,V)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=u;class r extends u{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function c(X,T){return T?new Promise((V,ce)=>{const me=setTimeout(()=>{Fe.dispose(),V()},X),Fe=T.onCancellationRequested(()=>{clearTimeout(me),Fe.dispose(),ce(new A.CancellationError)})}):L(V=>c(X,V))}e.timeout=c;function o(X,T=0){const V=setTimeout(X,T);return(0,F.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=o;function k(X){const T=[];let V=0;const ce=X.length;function me(){return V<ce?X[V++]():null}function Fe(be){be!=null&&T.push(be);const Ee=me();return Ee?Ee.then(Fe):Promise.resolve(T)}return Promise.resolve(null).then(Fe)}e.sequence=k;function s(X,T=ce=>!!ce,V=null){let ce=0;const me=X.length,Fe=()=>{if(ce>=me)return Promise.resolve(V);const be=X[ce++];return Promise.resolve(be()).then(Ie=>T(Ie)?Promise.resolve(Ie):Fe())};return Fe()}e.first=s;function l(X,T=ce=>!!ce,V=null){if(X.length===0)return Promise.resolve(V);let ce=X.length;const me=()=>{ce=-1;for(const Fe of X)Fe.cancel?.()};return new Promise((Fe,be)=>{for(const Ee of X)Ee.then(Ie=>{--ce>=0&&T(Ie)?(me(),Fe(Ie)):ce===0&&Fe(V)}).catch(Ie=>{--ce>=0&&(me(),be(Ie))})})}e.firstParallel=l;class v{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((V,ce)=>{this.f.push({factory:T,c:V,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const V=T.factory();V.then(T.c,T.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=v;class S extends v{constructor(){super(1)}}e.Queue=S;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const T=new we;return this.b.add(T),T.p}d(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,V=O.extUri){const ce=V.getComparisonKey(T);let me=this.a.get(ce);return me||(me=new S,C.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(ce),this.f()}),this.a.set(ce,me)),me}f(){!this.d()||this.g()}g(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class W{constructor(T,V){this.a=-1,typeof T=="function"&&typeof V=="number"&&this.setIfNotSet(T,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},V)}setIfNotSet(T,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},V))}}e.TimeoutTimer=W;class G{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,V){this.cancel(),this.a=setInterval(()=>{T()},V)}}e.IntervalTimer=G;class Y{constructor(T,V){this.b=-1,this.a=T,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Y;class J{constructor(T,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=T,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=J;class q extends Y{constructor(T,V){super(T,V),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=q;class U extends F.Disposable{constructor(T,V){super(),this.g=T,this.h=V,this.a=[],this.b=this.D(new F.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of T)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,R.setTimeout0)(()=>{if(T)return;const V=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(X,T)=>{const V=requestIdleCallback(X,typeof T=="number"?{timeout:T}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,cancelIdleCallback(V))}}}}();class ${constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(V){this.g=V}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function z(X,T,V){let ce;for(let me=0;me<V;me++)try{return await X()}catch(Fe){ce=Fe,await c(T)}throw ce}e.retry=z;class j{hasPending(T){return this.a?typeof T=="number"?this.a.taskId===T:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(T,V,ce){return this.a={taskId:T,cancel:()=>ce?.(),promise:V},V.then(()=>this.d(T),()=>this.d(T)),V}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this.b)this.b.run=T;else{let V,ce;const me=new Promise((Fe,be)=>{V=Fe,ce=be});this.b={run:T,promise:me,promiseResolve:V,promiseReject:ce}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class he{constructor(T,V=()=>Date.now()){this.d=T,this.f=V,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.IntervalCounter=he;class we{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((T,V)=>{this.a=T,this.b=V})}complete(T){return new Promise(V=>{this.a(T),this.f=!0,V()})}error(T){return new Promise(V=>{this.b(T),this.d=!0,V()})}cancel(){new Promise(T=>{this.b(new A.CancellationError),this.d=!0,T()})}}e.DeferredPromise=we;var ie;(function(X){async function T(ce){let me;const Fe=await Promise.all(ce.map(be=>be.then(Ee=>Ee,Ee=>{me||(me=Ee)})));if(typeof me<"u")throw me;return Fe}X.settled=T;function V(ce){return new Promise(async(me,Fe)=>{try{await ce(me,Fe)}catch(be){Fe(be)}})}X.withAsyncBody=V})(ie=e.Promises||(e.Promises={}));var oe;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(oe||(oe={}));class de{static fromArray(T){return new de(V=>{V.emitMany(T)})}static fromPromise(T){return new de(async V=>{V.emitMany(await T)})}static fromPromises(T){return new de(async V=>{await Promise.all(T.map(async ce=>V.emitOne(await ce)))})}static merge(T){return new de(async V=>{await Promise.all(T.map(async ce=>{for await(const me of ce)V.emitOne(me)}))})}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const V={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(T(V)),this.j()}catch(ce){this.k(ce)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(T,V){return new de(async ce=>{for await(const me of T)ce.emitOne(V(me))})}map(T){return de.map(this,T)}static filter(T,V){return new de(async ce=>{for await(const me of T)V(me)&&ce.emitOne(me)})}filter(T){return de.filter(this,T)}static coalesce(T){return de.filter(T,V=>!!V)}coalesce(){return de.coalesce(this)}static async toPromise(T){const V=[];for await(const ce of T)V.push(ce);return V}toPromise(){return de.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}de.EMPTY=de.fromArray([]),e.AsyncIterableObject=de;class ke extends de{constructor(T,V){super(V),this.l=T}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ke;function le(X){const T=new n.CancellationTokenSource,V=X(T.token);return new ke(T,async ce=>{const me=T.token.onCancellationRequested(()=>{me.dispose(),T.dispose(),ce.reject(new A.CancellationError)});try{for await(const Fe of V){if(T.token.isCancellationRequested)return;ce.emitOne(Fe)}me.dispose(),T.dispose()}catch(Fe){me.dispose(),T.dispose(),ce.reject(Fe)}})}e.createCancelableAsyncIterable=le}),define(Pe[36],Ae([1,0,16,17,41,28,19,20,13]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",D="[^/\\\\]",f=/\//g;function b(he,we){switch(he){case 0:return"";case 1:return`${D}*?`;default:return`(?:${L}|${D}+${L}${we?`|${L}${D}+`:""})*?`}}function p(he,we){if(!he)return[];const ie=[];let oe=!1,de=!1,ke="";for(const le of he){switch(le){case we:if(!oe&&!de){ie.push(ke),ke="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":de=!0;break;case"]":de=!1;break}ke+=le}return ke&&ie.push(ke),ie}e.splitGlobAware=p;function d(he){if(!he)return"";let we="";const ie=p(he,e.GLOB_SPLIT);if(ie.every(oe=>oe===e.GLOBSTAR))we=".*";else{let oe=!1;ie.forEach((de,ke)=>{if(de===e.GLOBSTAR){if(oe)return;we+=b(2,ke===ie.length-1)}else{let le=!1,X="",T=!1,V="";for(const ce of de){if(ce!=="}"&&le){X+=ce;continue}if(T&&(ce!=="]"||!V)){let me;ce==="-"?me=ce:(ce==="^"||ce==="!")&&!V?me="^":ce===e.GLOB_SPLIT?me="":me=(0,w.escapeRegExpCharacters)(ce),V+=me;continue}switch(ce){case"{":le=!0;continue;case"[":T=!0;continue;case"}":{we+=`(?:${p(X,",").map(be=>d(be)).join("|")})`,le=!1,X="";break}case"]":{we+="["+V+"]",T=!1,V="";break}case"?":we+=D;continue;case"*":we+=b(1);continue;default:we+=(0,w.escapeRegExpCharacters)(ce)}}ke<ie.length-1&&(ie[ke+1]!==e.GLOBSTAR||ke+2<ie.length)&&(we+=L)}oe=de===e.GLOBSTAR})}return we}const t=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.LRUCache(1e4),u=function(){return!1},r=function(){return null};function c(he,we){if(!he)return r;let ie;typeof he!="string"?ie=he.pattern:ie=he,ie=ie.trim();const oe=`${ie}_${!!we.trimForExclusions}`;let de=i.get(oe);if(de)return o(de,he);let ke;return t.test(ie)?de=s(ie.substr(4),ie):(ke=a.exec(k(ie,we)))?de=l(ke[1],ie):(we.trimForExclusions?y:m).test(ie)?de=v(ie,we):(ke=P.exec(k(ie,we)))?de=S(ke[1].substr(1),ie,!0):(ke=g.exec(k(ie,we)))?de=S(ke[1],ie,!1):de=E(ie),i.set(oe,de),o(de,he)}function o(he,we){if(typeof we=="string")return he;const ie=function(oe,de){return(0,C.isEqualOrParent)(oe,we.base,!R.isLinux)?he((0,w.ltrim)(oe.substr(we.base.length),O.sep),de):null};return ie.allBasenames=he.allBasenames,ie.allPaths=he.allPaths,ie.basenames=he.basenames,ie.patterns=he.patterns,ie}function k(he,we){return we.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function s(he,we){return function(ie,oe){return typeof ie=="string"&&ie.endsWith(he)?we:null}}function l(he,we){const ie=`/${he}`,oe=`\\${he}`,de=function(le,X){return typeof le!="string"?null:X?X===he?we:null:le===he||le.endsWith(ie)||le.endsWith(oe)?we:null},ke=[he];return de.basenames=ke,de.patterns=[we],de.allBasenames=ke,de}function v(he,we){const ie=z(he.slice(1,-1).split(",").map(X=>c(X,we)).filter(X=>X!==r),he),oe=ie.length;if(!oe)return r;if(oe===1)return ie[0];const de=function(X,T){for(let V=0,ce=ie.length;V<ce;V++)if(ie[V](X,T))return he;return null},ke=ie.find(X=>!!X.allBasenames);ke&&(de.allBasenames=ke.allBasenames);const le=ie.reduce((X,T)=>T.allPaths?X.concat(T.allPaths):X,[]);return le.length&&(de.allPaths=le),de}function S(he,we,ie){const oe=O.sep===O.posix.sep,de=oe?he:he.replace(f,O.sep),ke=O.sep+de,le=O.posix.sep+he;let X;return ie?X=function(T,V){return typeof T=="string"&&(T===de||T.endsWith(ke)||!oe&&(T===he||T.endsWith(le)))?we:null}:X=function(T,V){return typeof T=="string"&&(T===de||!oe&&T===he)?we:null},X.allPaths=[(ie?"*/":"./")+he],X}function E(he){try{const we=new RegExp(`^${d(he)}$`);return function(ie){return we.lastIndex=0,typeof ie=="string"&&we.test(ie)?he:null}}catch{return r}}function W(he,we,ie){return!he||typeof we!="string"?!1:G(he)(we,void 0,ie)}e.match=W;function G(he,we={}){if(!he)return u;if(typeof he=="string"||Y(he)){const ie=c(he,we);if(ie===r)return u;const oe=function(de,ke){return!!ie(de,ke)};return ie.allBasenames&&(oe.allBasenames=ie.allBasenames),ie.allPaths&&(oe.allPaths=ie.allPaths),oe}return U(he,we)}e.parse=G;function Y(he){const we=he;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.isRelativePattern=Y;function J(he){return he.allBasenames||[]}e.getBasenameTerms=J;function q(he){return he.allPaths||[]}e.getPathTerms=q;function U(he,we){const ie=z(Object.getOwnPropertyNames(he).map(X=>$(X,he[X],we)).filter(X=>X!==r)),oe=ie.length;if(!oe)return r;if(!ie.some(X=>!!X.requiresSiblings)){if(oe===1)return ie[0];const X=function(ce,me){let Fe;for(let be=0,Ee=ie.length;be<Ee;be++){const Ie=ie[be](ce,me);if(typeof Ie=="string")return Ie;(0,A.isThenable)(Ie)&&(Fe||(Fe=[]),Fe.push(Ie))}return Fe?(async()=>{for(const be of Fe){const Ee=await be;if(typeof Ee=="string")return Ee}return null})():null},T=ie.find(ce=>!!ce.allBasenames);T&&(X.allBasenames=T.allBasenames);const V=ie.reduce((ce,me)=>me.allPaths?ce.concat(me.allPaths):ce,[]);return V.length&&(X.allPaths=V),X}const de=function(X,T,V){let ce,me;for(let Fe=0,be=ie.length;Fe<be;Fe++){const Ee=ie[Fe];Ee.requiresSiblings&&V&&(T||(T=(0,O.basename)(X)),ce||(ce=T.substr(0,T.length-(0,O.extname)(X).length)));const Ie=Ee(X,T,ce,V);if(typeof Ie=="string")return Ie;(0,A.isThenable)(Ie)&&(me||(me=[]),me.push(Ie))}return me?(async()=>{for(const Fe of me){const be=await Fe;if(typeof be=="string")return be}return null})():null},ke=ie.find(X=>!!X.allBasenames);ke&&(de.allBasenames=ke.allBasenames);const le=ie.reduce((X,T)=>T.allPaths?X.concat(T.allPaths):X,[]);return le.length&&(de.allPaths=le),de}function $(he,we,ie){if(we===!1)return r;const oe=c(he,ie);if(oe===r)return r;if(typeof we=="boolean")return oe;if(we){const de=we.when;if(typeof de=="string"){const ke=(le,X,T,V)=>{if(!V||!oe(le,X))return null;const ce=de.replace("$(basename)",()=>T),me=V(ce);return(0,A.isThenable)(me)?me.then(Fe=>Fe?he:null):me?he:null};return ke.requiresSiblings=!0,ke}}return oe}function z(he,we){const ie=he.filter(X=>!!X.basenames);if(ie.length<2)return he;const oe=ie.reduce((X,T)=>{const V=T.basenames;return V?X.concat(V):X},[]);let de;if(we){de=[];for(let X=0,T=oe.length;X<T;X++)de.push(we)}else de=ie.reduce((X,T)=>{const V=T.patterns;return V?X.concat(V):X},[]);const ke=function(X,T){if(typeof X!="string")return null;if(!T){let ce;for(ce=X.length;ce>0;ce--){const me=X.charCodeAt(ce-1);if(me===47||me===92)break}T=X.substr(ce)}const V=oe.indexOf(T);return V!==-1?de[V]:null};ke.basenames=oe,ke.patterns=de,ke.allBasenames=oe;const le=he.filter(X=>!X.basenames);return le.push(ke),le}function j(he,we){return(0,n.equals)(he,we,(ie,oe)=>typeof ie=="string"&&typeof oe=="string"?ie===oe:typeof ie!="string"&&typeof oe!="string"?ie.base===oe.base&&ie.pattern===oe.pattern:!1)}e.patternsEquals=j}),define(Pe[87],Ae([1,0,10,128,22,13,2]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(a="",m=!1){if(this.value=a,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(a,m=0){return this.value+=f(this.supportThemeIcons?(0,A.escapeIcons)(a):a).replace(/([ \t]+)/g,(y,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,m){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(a,m,y){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(a),")"),y&&(this.value+=` "${this.c(this.c(y,'"'),")")}"`),this.value+=")",this}c(a,m){const y=new RegExp((0,F.escapeRegExpCharacters)(m),"g");return a.replace(y,(P,g)=>a.charAt(g-1)!=="\\"?`\\${P}`:P)}}e.MarkdownString=w;function h(t){return L(t)?!t.value:Array.isArray(t)?t.every(h):!0}e.isEmptyMarkdownString=h;function L(t){return t instanceof w?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function D(t,a){return t===a?!0:!t||!a?!1:t.value===a.value&&t.isTrusted===a.isTrusted&&t.supportThemeIcons===a.supportThemeIcons&&t.supportHtml===a.supportHtml&&(t.baseUri===a.baseUri||!!t.baseUri&&!!a.baseUri&&(0,C.isEqual)(O.URI.from(t.baseUri),O.URI.from(a.baseUri)))}e.markdownStringEqual=D;function f(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function b(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function d(t){const a=[],m=t.split("|").map(P=>P.trim());t=m[0];const y=m[1];if(y){const P=/height=(\d+)/.exec(y),g=/width=(\d+)/.exec(y),i=P?P[1]:"",u=g?g[1]:"",r=isFinite(parseInt(u)),c=isFinite(parseInt(i));r&&a.push(`width="${u}"`),c&&a.push(`height="${i}"`)}return{href:t,dimensions:a}}e.parseHrefAndDimensions=d}),define(Pe[88],Ae([1,0,16,41,19,20,22,13]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(r,c){const{os:o,tildify:k,relative:s}=c;if(s){const S=h(r,s,o);if(typeof S=="string")return S}let l=r.fsPath;if(o===1&&!F.isWindows?l=l.replace(/\//g,"\\"):o!==1&&F.isWindows&&(l=l.replace(/\\/g,"/")),o!==1&&k?.userHome){const S=k.userHome.fsPath;let E;r.scheme!==k.userHome.scheme&&r.path.startsWith(C.posix.sep)?E=k.userHome.with({path:r.path}).fsPath:E=r.fsPath,l=f(E,S,o)}return(o===1?C.win32:C.posix).normalize(L(l,o===1))}e.getPathLabel=w;function h(r,c,o){const k=o===1?C.win32:C.posix,s=o===3?O.extUri:O.extUriIgnorePathCase,l=c.getWorkspace(),v=(0,n.firstOrDefault)(l.folders);if(!v)return;r.scheme!==v.uri.scheme&&r.path.startsWith(C.posix.sep)&&(r=v.uri.with({path:r.path}));const S=c.getWorkspaceFolder(r);if(!S)return;let E;if(s.isEqual(S.uri,r)?E="":E=s.relativePath(S.uri,r)??"",E&&(E=k.normalize(E)),l.folders.length>1&&!c.noPrefix){const W=S.name?S.name:s.basenameOrAuthority(S.uri);E=E?`${W} \u2022 ${E}`:W}return E}function L(r,c=F.isWindows){return(0,A.hasDriveLetter)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let D=Object.create(null);function f(r,c,o=F.OS){if(o===1||!r||!c)return r;let k=D.original===c?D.normalized:void 0;k||(k=c,F.isWindows&&(k=(0,A.toSlashes)(k)),k=`${(0,R.rtrim)(k,C.posix.sep)}${C.posix.sep}`,D={original:c,normalized:k});let s=r;return F.isWindows&&(s=(0,A.toSlashes)(s)),(o===3?s.startsWith(k):(0,R.startsWithIgnoreCase)(s,k))?`~/${s.substr(k.length)}`:r}e.tildify=f;function b(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=b;const p="\u2026",d="\\\\",t="~";function a(r,c=C.sep){const o=new Array(r.length);let k=!1;for(let s=0;s<r.length;s++){const l=r[s];if(l===""){o[s]=`.${c}`;continue}if(!l){o[s]=l;continue}k=!0;let v="",S=l;S.indexOf(d)===0?(v=S.substr(0,S.indexOf(d)+d.length),S=S.substr(S.indexOf(d)+d.length)):S.indexOf(c)===0?(v=S.substr(0,S.indexOf(c)+c.length),S=S.substr(S.indexOf(c)+c.length)):S.indexOf(t)===0&&(v=S.substr(0,S.indexOf(t)+t.length),S=S.substr(S.indexOf(t)+t.length));const E=S.split(c);for(let W=1;k&&W<=E.length;W++)for(let G=E.length-W;k&&G>=0;G--){k=!1;let Y=E.slice(G,G+W).join(c);for(let J=0;!k&&J<r.length;J++)if(J!==s&&r[J]&&r[J].indexOf(Y)>-1){const q=G+W===E.length,U=G>0&&r[J].indexOf(c)>-1?c+Y:Y,$=r[J].endsWith(U);k=!q||$}if(!k){let J="";(E[0].endsWith(":")||v!=="")&&(G===1&&(G=0,W++,Y=E[0]+c+Y),G>0&&(J=E[0]+c),J=v+J),G>0&&(J=J+p+c),J=J+Y,G+W<E.length&&(J=J+c+p),o[s]=J}}k&&(o[s]=l)}return o}e.shorten=a;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function y(r,c=Object.create(null)){const o=[];let k=!1,s="";for(const l of r)if(l==="$"||k&&l==="{")s&&o.push({value:s,type:m.TEXT}),s="",k=!0;else if(l==="}"&&k){const v=c[s];if(typeof v=="string")v.length&&o.push({value:v,type:m.VARIABLE});else if(v){const S=o[o.length-1];(!S||S.type!==m.SEPARATOR)&&o.push({value:v.label,type:m.SEPARATOR})}s="",k=!1}else s+=l;return s&&!k&&o.push({value:s,type:m.TEXT}),o.filter((l,v)=>{if(l.type===m.SEPARATOR){const S=o[v-1],E=o[v+1];return[S,E].every(W=>W&&(W.type===m.VARIABLE||W.type===m.TEXT)&&W.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=y;function P(r,c){return F.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):r.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function g(r,c){return F.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):F.isWindows?r.replace(/&&|&/g,o=>o==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(r){const c=r.indexOf("/")!==-1?C.posix:C.win32,o=c.basename(r),k=c.dirname(r);return o.length?{name:o,parentPath:k}:{name:k,parentPath:""}}e.splitName=u}),define(Pe[129],Ae([1,0,25,2]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(D){return D.toJSON()}class F{constructor(f){this.a=f}transformIncoming(f){const b=this.a.transformIncoming(f);return b===f?f:C(A.URI.from(b))}transformOutgoing(f){const b=this.a.transformOutgoing(f);return b===f?f:C(A.URI.from(b))}transformOutgoingURI(f){const b=this.a.transformOutgoing(f);return b===f?f:A.URI.from(b)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.URITransformer=F,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function O(D,f,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof A.URI)return f.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const d=O(D[p],f,b+1);d!==null&&(D[p]=d)}}return null}function R(D,f){const b=O(D,f,0);return b===null?D:b}e.transformOutgoingURIs=R;function w(D,f,b,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?A.URI.revive(f.transformIncoming(D)):f.transformIncoming(D);if(D instanceof n.VSBuffer)return null;for(const d in D)if(Object.hasOwnProperty.call(D,d)){const t=w(D[d],f,b,p+1);t!==null&&(D[d]=t)}}return null}function h(D,f){const b=w(D,f,!1,0);return b===null?D:b}e.transformIncomingURIs=h;function L(D,f){const b=w(D,f,!0,0);return b===null?D:b}e.transformAndReviveIncomingURIs=L}),define(Pe[130],Ae([1,0,36,19]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(F,O,R,w,h,L){if(Array.isArray(F)){let D=0;for(const f of F){const b=C(f,O,R,w,h,L);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof F=="string")return w?F==="*"?5:F===R?10:0:0;if(F){const{language:D,pattern:f,scheme:b,hasAccessToAllModels:p,notebookType:d}=F;if(!w&&!p)return 0;d&&h&&(O=h);let t=0;if(b)if(b===O.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===R)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(d)if(d===L)t=10;else if(d==="*"&&L!==void 0)t=Math.max(t,5);else return 0;if(f){let a;if(typeof f=="string"?a=f:a={...f,base:(0,A.normalize)(f.base)},a===O.fsPath||(0,n.match)(a,O.fsPath))t=10;else return 0}return t}else return 0}}e.score=C}),define(Pe[89],Ae([1,0,25,20]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function F(D){for(let f=0,b=D.length;f<b;f+=4){const p=D[f+0],d=D[f+1],t=D[f+2],a=D[f+3];D[f+0]=a,D[f+1]=t,D[f+2]=d,D[f+3]=p}}function O(D){const f=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return A.isLittleEndian()||F(f),n.VSBuffer.wrap(f)}function R(D){const f=D.buffer;if(A.isLittleEndian()||F(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const b=new Uint8Array(f.byteLength);return b.set(f),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function w(D){const f=new Uint32Array(h(D));let b=0;if(f[b++]=D.id,D.type==="full")f[b++]=1,f[b++]=D.data.length,f.set(D.data,b),b+=D.data.length;else{f[b++]=2,f[b++]=D.deltas.length;for(const p of D.deltas)f[b++]=p.start,f[b++]=p.deleteCount,p.data?(f[b++]=p.data.length,f.set(p.data,b),b+=p.data.length):f[b++]=0}return O(f)}e.encodeSemanticTokensDto=w;function h(D){let f=0;if(f+=1+1,D.type==="full")f+=1+D.data.length;else{f+=1,f+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(f+=b.data.length)}return f}function L(D){const f=R(D);let b=0;const p=f[b++];if(f[b++]===1){const m=f[b++],y=f.subarray(b,b+m);return b+=m,{id:p,type:"full",data:y}}const t=f[b++],a=[];for(let m=0;m<t;m++){const y=f[b++],P=f[b++],g=f[b++];let i;g>0&&(i=f.subarray(b,b+g),b+=g),a[m]={start:y,deleteCount:P,data:i}}return{id:p,type:"delta",deltas:a}}e.decodeSemanticTokensDto=L}),define(Pe[131],Ae([11,12]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Pe[132],Ae([1,0,131,20,133,16,23,119]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=h;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class D{constructor(_,ve,We,Be){this.id=_,this.name=ve,this.defaultValue=We,this.schema=Be}applyUpdate(_,ve){return b(_,ve)}compute(_,ve,We){return We}}class f{constructor(_,ve){this.newValue=_,this.didChange=ve}}e.ApplyUpdateResult=f;function b(Q,_){if(typeof Q!="object"||typeof _!="object"||!Q||!_)return new f(_,Q!==_);if(Array.isArray(Q)||Array.isArray(_)){const We=Array.isArray(Q)&&Array.isArray(_)&&F.equals(Q,_);return new f(_,!We)}let ve=!1;for(const We in _)if(_.hasOwnProperty(We)){const Be=b(Q[We],_[We]);Be.didChange&&(Q[We]=Be.newValue,ve=!0)}return new f(Q,ve)}class p{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,ve){return b(_,ve)}validate(_){return this.defaultValue}}class d{constructor(_,ve,We,Be){this.id=_,this.name=ve,this.defaultValue=We,this.schema=Be}applyUpdate(_,ve){return b(_,ve)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,ve,We){return We}}function t(Q,_){return typeof Q>"u"?_:Q==="false"?!1:Boolean(Q)}e.boolean=t;class a extends d{constructor(_,ve,We,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=We),super(_,ve,We,Be)}validate(_){return t(_,this.defaultValue)}}function m(Q,_,ve,We){if(typeof Q>"u")return _;let Be=parseInt(Q,10);return isNaN(Be)?_:(Be=Math.max(ve,Be),Be=Math.min(We,Be),Be|0)}e.clampedInt=m;class y extends d{static clampedInt(_,ve,We,Be){return m(_,ve,We,Be)}constructor(_,ve,We,Be,Qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=We,Ye.minimum=Be,Ye.maximum=Qe),super(_,ve,We,Ye),this.minimum=Be,this.maximum=Qe}validate(_){return y.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}class P extends d{static clamp(_,ve,We){return _<ve?ve:_>We?We:_}static float(_,ve){if(typeof _=="number")return _;if(typeof _>"u")return ve;const We=parseFloat(_);return isNaN(We)?ve:We}constructor(_,ve,We,Be,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=We),super(_,ve,We,Qe),this.validationFn=Be}validate(_){return this.validationFn(P.float(_,this.defaultValue))}}class g extends d{static string(_,ve){return typeof _!="string"?ve:_}constructor(_,ve,We,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=We),super(_,ve,We,Be)}validate(_){return g.string(_,this.defaultValue)}}function i(Q,_,ve){return typeof Q!="string"||ve.indexOf(Q)===-1?_:Q}e.stringSet=i;class u extends d{constructor(_,ve,We,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Be,Qe.default=We),super(_,ve,We,Qe),this.c=Be}validate(_){return i(_,this.defaultValue,this.c)}}class r extends D{constructor(_,ve,We,Be,Qe,Ye,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Qe,Ge.default=Be),super(_,ve,We,Ge),this.c=Qe,this.d=Ye}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function c(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,ve,We){return We===0?_.accessibilitySupport:We}}class k extends D{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:n.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{insertSpace:t(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(Q){switch(Q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function E(Q){switch(Q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class W extends p{constructor(){super(135)}compute(_,ve,We){const Be=["monaco-editor"];return ve.get(36)&&Be.push(ve.get(36)),_.extraEditorClassName&&Be.push(_.extraEditorClassName),ve.get(70)==="default"?Be.push("mouse-default"):ve.get(70)==="copy"&&Be.push("mouse-copy"),ve.get(105)&&Be.push("showUnused"),ve.get(133)&&Be.push("showDeprecated"),Be.join(" ")}}class G extends a{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(_,ve,We){return We&&_.emptySelectionClipboard}}class Y extends D{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:n.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:n.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{cursorMoveOnType:t(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":i(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":i(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ve.loop,this.defaultValue.loop)}}}class J extends D{constructor(){super(48,"fontLigatures",J.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?J.OFF:_==="true"?J.ON:_:Boolean(_)?J.ON:J.OFF}}J.OFF='"liga" off, "calt" off',J.ON='"liga" on, "calt" on',e.EditorFontLigatures=J;class q extends D{constructor(){super(51,"fontVariations",q.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?q.OFF:_==="true"?q.TRANSLATE:_:Boolean(_)?q.TRANSLATE:q.OFF}compute(_,ve,We){return _.fontInfo.fontVariationSettings}}q.OFF="normal",q.TRANSLATE="translate",e.EditorFontVariations=q;class U extends p{constructor(){super(47)}compute(_,ve,We){return _.fontInfo}}class $ extends d{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(_){const ve=P.float(_,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:P.clamp(ve,6,100)}compute(_,ve,We){return _.fontInfo.fontSize}}class z extends D{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(y.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class j extends D{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:We,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:We,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:We,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:We,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:We,description:n.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{multiple:i(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??i(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??i(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??i(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??i(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??i(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends D{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:_.above,description:n.localize(45,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{enabled:t(ve.enabled,this.defaultValue.enabled),delay:y.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:t(ve.sticky,this.defaultValue.sticky),above:t(ve.above,this.defaultValue.above)}}}var we;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(we=e.RenderMinimap||(e.RenderMinimap={}));class ie extends p{constructor(){super(138)}compute(_,ve,We){return ie.computeLayout(ve,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio})}static computeContainedMinimapLineCount(_){const ve=_.height/_.lineHeight,We=Math.floor(_.paddingTop/_.lineHeight);let Be=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Be=Math.max(Be,ve-1));const Qe=(We+_.viewLineCount+Be)/(_.pixelRatio*_.height),Ye=Math.floor(_.viewLineCount/Qe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Be,desiredRatio:Qe,minimapLineCount:Ye}}static c(_,ve){const We=_.outerWidth,Be=_.outerHeight,Qe=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ye=ve.stableMinimapLayoutInput,Ge=Ye&&_.outerHeight===Ye.outerHeight&&_.lineHeight===Ye.lineHeight&&_.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&_.pixelRatio===Ye.pixelRatio&&_.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&_.paddingTop===Ye.paddingTop&&_.paddingBottom===Ye.paddingBottom&&_.minimap.enabled===Ye.minimap.enabled&&_.minimap.side===Ye.minimap.side&&_.minimap.size===Ye.minimap.size&&_.minimap.showSlider===Ye.minimap.showSlider&&_.minimap.renderCharacters===Ye.minimap.renderCharacters&&_.minimap.maxColumn===Ye.minimap.maxColumn&&_.minimap.scale===Ye.minimap.scale&&_.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&_.isViewportWrapping===Ye.isViewportWrapping,at=_.lineHeight,Dt=_.typicalHalfwidthCharacterWidth,Tt=_.scrollBeyondLastLine,It=_.minimap.renderCharacters;let Et=Qe>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Mt=_.minimap.maxColumn,Bt=_.minimap.size,Xt=_.minimap.side,ht=_.verticalScrollbarWidth,gt=_.viewLineCount,Ot=_.remainingWidth,Ut=_.isViewportWrapping,Lt=It?2:3;let pt=Math.floor(Qe*Be);const Ct=pt/Qe;let Pt=!1,$t=!1,Ke=Lt*Et,Wt=Et/Qe,Te=1;if(Bt==="fill"||Bt==="fit"){const{typicalViewportLineCount:xe,extraLinesBeforeFirstLine:ot,extraLinesBeyondLastLine:ft,desiredRatio:mt,minimapLineCount:lt}=ie.computeContainedMinimapLineCount({viewLineCount:gt,scrollBeyondLastLine:Tt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Be,lineHeight:at,pixelRatio:Qe});if(gt/lt>1)Pt=!0,$t=!0,Et=1,Ke=1,Wt=Et/Qe;else{let bt=!1,kt=Et+1;if(Bt==="fit"){const Ht=Math.ceil((ot+gt+ft)*Ke);Ut&&Ge&&Ot<=ve.stableFitRemainingWidth?(bt=!0,kt=ve.stableFitMaxMinimapScale):bt=Ht>pt}if(Bt==="fill"||bt){Pt=!0;const Ht=Et;Ke=Math.min(at*Qe,Math.max(1,Math.floor(1/mt))),Ut&&Ge&&Ot<=ve.stableFitRemainingWidth&&(kt=ve.stableFitMaxMinimapScale),Et=Math.min(kt,Math.max(1,Math.floor(Ke/Lt))),Et>Ht&&(Te=Math.min(2,Et/Ht)),Wt=Et/Qe/Te,pt=Math.ceil(Math.max(xe,ot+gt+ft)*Ke),Ut?(ve.stableMinimapLayoutInput=_,ve.stableFitRemainingWidth=Ot,ve.stableFitMaxMinimapScale=Et):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Oe=Math.floor(Mt*Wt),fe=Math.min(Oe,Math.max(0,Math.floor((Ot-ht-2)*Wt/(Dt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let K=Math.floor(Qe*fe);const Re=K/Qe;K=Math.floor(K*Te);const ze=It?1:2,Ze=Xt==="left"?0:We-fe-ht;return{renderMinimap:ze,minimapLeft:Ze,minimapWidth:fe,minimapHeightIsEditorHeight:Pt,minimapIsSampling:$t,minimapScale:Et,minimapLineHeight:Ke,minimapCanvasInnerWidth:K,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Re,minimapCanvasOuterHeight:Ct}}static computeLayout(_,ve){const We=ve.outerWidth|0,Be=ve.outerHeight|0,Qe=ve.lineHeight|0,Ye=ve.lineNumbersDigitCount|0,Ge=ve.typicalHalfwidthCharacterWidth,at=ve.maxDigitWidth,Dt=ve.pixelRatio,Tt=ve.viewLineCount,It=_.get(130),Et=It==="inherit"?_.get(129):It,Mt=Et==="inherit"?_.get(125):Et,Bt=_.get(128),Xt=ve.isDominatedByLongLines,ht=_.get(54),gt=_.get(64).renderType!==0,Ot=_.get(65),Ut=_.get(99),Lt=_.get(80),pt=_.get(69),Ct=_.get(97),Pt=Ct.verticalScrollbarSize,$t=Ct.verticalHasArrows,Ke=Ct.arrowSize,Wt=Ct.horizontalScrollbarSize,Te=_.get(40),Oe=_.get(104)!=="never";let fe=_.get(62);Te&&Oe&&(fe+=16);let K=0;if(gt){const ai=Math.max(Ye,Ot);K=Math.round(ai*at)}let Re=0;ht&&(Re=Qe);let ze=0,Ze=ze+Re,xe=Ze+K,ot=xe+fe;const ft=We-Re-K-fe;let mt=!1,lt=!1,ct=-1;Et==="inherit"&&Xt?(mt=!0,lt=!0):Mt==="on"||Mt==="bounded"?lt=!0:Mt==="wordWrapColumn"&&(ct=Bt);const bt=ie.c({outerWidth:We,outerHeight:Be,lineHeight:Qe,typicalHalfwidthCharacterWidth:Ge,pixelRatio:Dt,scrollBeyondLastLine:Ut,paddingTop:Lt.top,paddingBottom:Lt.bottom,minimap:pt,verticalScrollbarWidth:Pt,viewLineCount:Tt,remainingWidth:ft,isViewportWrapping:lt},ve.memory||new L);bt.renderMinimap!==0&&bt.minimapLeft===0&&(ze+=bt.minimapWidth,Ze+=bt.minimapWidth,xe+=bt.minimapWidth,ot+=bt.minimapWidth);const kt=ft-bt.minimapWidth,Ht=Math.max(1,Math.floor((kt-Pt-2)/Ge)),Nt=$t?Ke:0;return lt&&(ct=Math.max(1,Ht),Mt==="bounded"&&(ct=Math.min(ct,Bt))),{width:We,height:Be,glyphMarginLeft:ze,glyphMarginWidth:Re,lineNumbersLeft:Ze,lineNumbersWidth:K,decorationsLeft:xe,decorationsWidth:fe,contentLeft:ot,contentWidth:kt,minimap:bt,viewportColumn:Ht,isWordWrapMinified:mt,isViewportWrapping:lt,wrappingColumn:ct,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Wt,overviewRuler:{top:Nt,width:Pt,height:Be-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=ie;class oe extends D{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(_){return i(_,"simple",["simple","advanced"])}compute(_,ve,We){return ve.get(2)===2?"advanced":We}}class de extends D{constructor(){const _={enabled:!0};super(61,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:n.localize(49,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}class ke extends D{constructor(){const _={enabled:!1,maxLineCount:5};super(109,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{enabled:t(ve.enabled,this.defaultValue.enabled),maxLineCount:y.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends D{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:n.localize(59,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:i(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily),padding:t(ve.padding,this.defaultValue.padding)}}}class X extends D{constructor(){super(62,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):y.clampedInt(_,this.defaultValue,0,1e3)}compute(_,ve,We){return We<0?y.clampedInt(-We*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class T extends P{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>P.clamp(_,0,150),{markdownDescription:n.localize(60,null)})}compute(_,ve,We){return _.fontInfo.lineHeight}}class V extends D{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:_.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:n.localize(71,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{enabled:t(ve.enabled,this.defaultValue.enabled),autohide:t(ve.autohide,this.defaultValue.autohide),size:i(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ve.side,this.defaultValue.side,["right","left"]),showSlider:i(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ve.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(ve.scale,1,1,3),maxColumn:y.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(Q){return Q==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends D{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{top:y.clampedInt(ve.top,0,0,1e3),bottom:y.clampedInt(ve.bottom,0,0,1e3)}}}class Fe extends D{constructor(){const _={enabled:!0,cycle:!0};super(81,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:n.localize(75,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{enabled:t(ve.enabled,this.defaultValue.enabled),cycle:t(ve.cycle,this.defaultValue.cycle)}}}class be extends p{constructor(){super(136)}compute(_,ve,We){return _.pixelRatio}}class Ee extends D{constructor(){const _={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:_.strings,description:n.localize(79,null)},comments:{anyOf:ve,default:_.comments,description:n.localize(80,null)},other:{anyOf:ve,default:_.other,description:n.localize(81,null)}},default:_,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Dt=_?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!_||typeof _!="object")return this.defaultValue;const{other:ve,comments:We,strings:Be}=_,Qe=["on","inline","off"];let Ye,Ge,at;return typeof ve=="boolean"?Ye=ve?"on":"off":Ye=i(ve,this.defaultValue.other,Qe),typeof We=="boolean"?Ge=We?"on":"off":Ge=i(We,this.defaultValue.comments,Qe),typeof Be=="boolean"?at=Be?"on":"off":at=i(Be,this.defaultValue.strings,Qe),{other:Ye,comments:Ge,strings:at}}}var Ie;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends D{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(_){let ve=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(ve=4,We=_):_==="interval"?ve=3:_==="relative"?ve=2:_==="on"?ve=1:ve=0),{renderType:ve,renderFn:We}}}function ae(Q){const _=Q.get(92);return _==="editable"?Q.get(86):_!=="on"}e.filterValidationDecorations=ae;class Z extends D{constructor(){const _=[],ve={type:"number",description:n.localize(88,null)};super(96,"rulers",_,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:_,description:n.localize(90,null)})}validate(_){if(Array.isArray(_)){const ve=[];for(const We of _)if(typeof We=="number")ve.push({column:y.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Be=We;ve.push({column:y.clampedInt(Be.column,0,0,1e4),color:Be.color})}return ve.sort((We,Be)=>We.column-Be.column),ve}return this.defaultValue}}function I(Q,_){if(typeof Q!="string")return _;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends D{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:n.localize(101,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_,We=y.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=y.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ve.vertical,this.defaultValue.vertical),horizontal:I(ve.horizontal,this.defaultValue.horizontal),useShadows:t(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:y.clampedInt(ve.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:y.clampedInt(ve.verticalSliderSize,Be,0,1e3),scrollByPage:t(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:n.localize(108,null)}})}applyUpdate(_,ve){let We=!1;ve.allowedCharacters&&_&&(O.equals(_.allowedCharacters,ve.allowedCharacters)||(_={..._,allowedCharacters:ve.allowedCharacters},We=!0)),ve.allowedLocales&&_&&(O.equals(_.allowedLocales,ve.allowedLocales)||(_={..._,allowedLocales:ve.allowedLocales},We=!0));const Be=super.applyUpdate(_,ve);return We?new f(Be.newValue,!0):Be}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{nonBasicASCII:Ce(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ce(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ce(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,ve){if(typeof _!="object"||!_)return ve;const We={};for(const[Be,Qe]of Object.entries(_))Qe===!0&&(We[Be]=!0);return We}}class x extends D{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{enabled:t(ve.enabled,this.defaultValue.enabled),mode:i(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class te extends D{constructor(){const _={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{enabled:t(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class pe extends D{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:_.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:_.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:_.highlightActiveIndentation,description:n.localize(128,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{bracketPairs:Ce(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ce(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ce(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ce(Q,_,ve){const We=ve.indexOf(Q);return We===-1?_:ve[We]}class ue extends D{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:_.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:_.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ve=_;return{insertMode:i(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ve.showIcons,this.defaultValue.showIcons),showStatusBar:t(ve.showStatusBar,this.defaultValue.showStatusBar),preview:t(ve.preview,this.defaultValue.preview),previewMode:i(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ve.showMethods,this.defaultValue.showMethods),showFunctions:t(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ve.showFields,this.defaultValue.showFields),showVariables:t(ve.showVariables,this.defaultValue.showVariables),showClasses:t(ve.showClasses,this.defaultValue.showClasses),showStructs:t(ve.showStructs,this.defaultValue.showStructs),showInterfaces:t(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ve.showModules,this.defaultValue.showModules),showProperties:t(ve.showProperties,this.defaultValue.showProperties),showEvents:t(ve.showEvents,this.defaultValue.showEvents),showOperators:t(ve.showOperators,this.defaultValue.showOperators),showUnits:t(ve.showUnits,this.defaultValue.showUnits),showValues:t(ve.showValues,this.defaultValue.showValues),showConstants:t(ve.showConstants,this.defaultValue.showConstants),showEnums:t(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ve.showKeywords,this.defaultValue.showKeywords),showWords:t(ve.showWords,this.defaultValue.showWords),showColors:t(ve.showColors,this.defaultValue.showColors),showFiles:t(ve.showFiles,this.defaultValue.showFiles),showReferences:t(ve.showReferences,this.defaultValue.showReferences),showFolders:t(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ve.showSnippets,this.defaultValue.showSnippets),showUsers:t(ve.showUsers,this.defaultValue.showUsers),showIssues:t(ve.showIssues,this.defaultValue.showIssues)}}}class De extends D{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Se;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));class $e extends D{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,ve,We){return ve.get(2)===2?0:We}}class He extends p{constructor(){super(139)}compute(_,ve,We){const Be=ve.get(138);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class et extends D{constructor(){const _={enabled:!0};super(33,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:n.localize(183,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?tt:A.isLinux?rt:Xe,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var it;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Me(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Me(new o),accessibilityPageSize:Me(new y(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Me(new g(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Me(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Me(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Me(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Me(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Me(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Me(new a(10,"automaticLayout",!1)),autoSurround:Me(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Me(new te),bracketPairGuides:Me(new pe),stickyTabStops:Me(new a(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Me(new a(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Me(new g(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Me(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Me(new a(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Me(new y(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Me(new a(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Me(new k),contextmenu:Me(new a(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Me(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Me(new u(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Me(new r(25,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:n.localize(222,null)})),cursorSurroundingLines:Me(new y(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Me(new u(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Me(new y(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Me(new a(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(31,"domReadOnly",!1)),dragAndDrop:Me(new a(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Me(new G),dropIntoEditor:Me(new et),stickyScroll:Me(new ke),experimentalWhitespaceRendering:Me(new u(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Me(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new P(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(233,null)})),find:Me(new Y),fixedOverflowWidgets:Me(new a(39,"fixedOverflowWidgets",!1)),folding:Me(new a(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Me(new u(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Me(new a(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Me(new a(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Me(new y(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Me(new a(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Me(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Me(new U),fontLigatures2:Me(new J),fontSize:Me(new $),fontWeight:Me(new z),fontVariations:Me(new q),formatOnPaste:Me(new a(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Me(new a(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Me(new a(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Me(new j),hideCursorInOverviewRuler:Me(new a(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Me(new he),inDiffEditor:Me(new a(58,"inDiffEditor",!1)),letterSpacing:Me(new P(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>P.clamp(Q,-5,20),{description:n.localize(247,null)})),lightbulb:Me(new de),lineDecorationsWidth:Me(new X),lineHeight:Me(new T),lineNumbers:Me(new se),lineNumbersMinChars:Me(new y(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Me(new a(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Me(new u(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Me(new V),mouseStyle:Me(new u(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new P(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Me(new a(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Me(new a(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Me(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Me(new u(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Me(new y(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Me(new a(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Me(new a(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Me(new y(79,"overviewRulerLanes",3,0,3)),padding:Me(new me),parameterHints:Me(new Fe),peekWidgetDefaultFocus:Me(new u(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Me(new a(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Me(new Ee),quickSuggestionsDelay:Me(new y(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Me(new a(86,"readOnly",!1)),renameOnType:Me(new a(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Me(new a(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Me(new u(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Me(new u(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Me(new u(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new u(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Me(new y(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Me(new Z),scrollbar:Me(new M),scrollBeyondLastColumn:Me(new y(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Me(new a(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Me(new a(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Me(new a(101,"selectionClipboard",!0,{description:n.localize(283,null),included:A.isLinux})),selectionHighlight:Me(new a(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Me(new a(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new u(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Me(new a(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Me(new a(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Me(new le),snippetSuggestions:Me(new u(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Me(new De),smoothScrolling:Me(new a(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Me(new y(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ue),inlineSuggest:Me(new x),suggestFontSize:Me(new y(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new y(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Me(new u(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Me(new u(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Me(new y(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new H),unusualLineTerminators:Me(new u(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Me(new a(121,"useShadowDOM",!0)),useTabStops:Me(new a(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Me(new u(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Me(new g(124,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Me(new u(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Me(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new y(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Me(new u(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new u(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new W),pixelRatio:Me(new be),tabFocusMode:Me(new a(137,"tabFocusMode",!1,{markdownDescription:n.localize(323,null)})),layoutInfo:Me(new ie),wrappingInfo:Me(new He),wrappingIndent:Me(new $e),wrappingStrategy:Me(new oe)}}),define(Pe[134],Ae([11,12]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[135],Ae([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[136],Ae([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[137],Ae([11,12]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[138],Ae([11,12]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[139],Ae([11,12]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Pe[140],Ae([11,12]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Pe[141],Ae([11,12]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[142],Ae([11,12]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Pe[143],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[144],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[145],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[146],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[147],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[148],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[149],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[150],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[151],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[152],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Pe[153],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Pe[154],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[155],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[156],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[157],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[158],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[159],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[160],Ae([11,12]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[161],Ae([1,0,10,136]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(C=e.TokenType||(e.TokenType={}));function F(...h){switch(h.length){case 1:return(0,A.localize)(0,null,h[0]);case 2:return(0,A.localize)(1,null,h[0],h[1]);case 3:return(0,A.localize)(2,null,h[0],h[1],h[2]);default:return}}const O=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const D=this.d,f=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:f};this.g.push({offset:D,lexeme:f,additionalInfo:L}),this.f.push(b)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const D=this.c.substring(this.d,this.e),f=w.b.get(D);f?this.k(f):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,D=!1,f=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(R);return}const p=this.c.charCodeAt(L);if(D)D=!1;else if(p===47&&!f){L++;break}else p===91?f=!0:p===92?D=!0:p===93&&(f=!1);L++}for(;L<this.c.length&&w.a.has(this.c.charCodeAt(L));)L++;this.e=L;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}w.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0))),w.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=w}),define(Pe[162],Ae([1,0,22,29,138,263]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function w(a){return a=a.trim(),a==="*"||O.test(a)}e.isValidVersionStr=w;function h(a){if(!w(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=a.match(O);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=h;function L(a){if(!a)return null;const m=a.majorBase,y=a.majorMustEqual,P=a.minorBase;let g=a.minorMustEqual;const i=a.patchBase;let u=a.patchMustEqual;a.hasCaret&&(m===0||(g=!1),u=!1);let r=0;if(a.preRelease){const c=R.exec(a.preRelease);if(c){const[,o,k,s]=c;r=Date.UTC(Number(o),Number(k)-1,Number(s))}}return{majorBase:m,majorMustEqual:y,minorBase:P,minorMustEqual:g,patchBase:i,patchMustEqual:u,isMinimum:a.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function D(a,m,y){let P;typeof a=="string"?P=L(h(a)):P=a;let g;m instanceof Date?g=m.getTime():typeof m=="string"&&(g=new Date(m).getTime());let i;if(typeof y=="string"?i=L(h(y)):i=y,!P||!i)return!1;const u=P.majorBase,r=P.minorBase,c=P.patchBase;let o=i.majorBase,k=i.minorBase,s=i.patchBase;const l=i.notBefore;let v=i.majorMustEqual,S=i.minorMustEqual,E=i.patchMustEqual;return i.isMinimum?u>o?!0:u<o?!1:r>k?!0:r<k||g&&g<l?!1:c>=s:(u===1&&o===0&&(!v||!S||!E)&&(o=1,k=0,s=0,v=!0,S=!1,E=!1),u<o?!1:u>o?!v:r<k?!1:r>k?!S:c<s?!1:c>s?!E:!(g&&g<l))}e.isValidVersion=D;function f(a,m,y,P,g){const i=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return i.push([A.default.Error,C.localize(0,null)]),i;if(typeof P.name!="string")return i.push([A.default.Error,C.localize(1,null,"name")]),i;if(typeof P.version!="string")return i.push([A.default.Error,C.localize(2,null,"version")]),i;if(!P.engines)return i.push([A.default.Error,C.localize(3,null,"engines")]),i;if(typeof P.engines.vscode!="string")return i.push([A.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof P.extensionDependencies<"u"&&!t(P.extensionDependencies))return i.push([A.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof P.activationEvents<"u"){if(!t(P.activationEvents))return i.push([A.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof P.main>"u"&&typeof P.browser>"u")return i.push([A.default.Error,C.localize(7,null,"activationEvents","main")]),i}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&i.push([A.default.Warning,C.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return i.push([A.default.Error,C.localize(9,null,"main")]),i;{const c=(0,n.joinPath)(y,P.main);(0,n.isEqualOrParent)(c,y)||i.push([A.default.Warning,C.localize(10,null,c.path,y.path)])}if(typeof P.activationEvents>"u")return i.push([A.default.Error,C.localize(11,null,"activationEvents","main")]),i}if(typeof P.browser<"u"){if(typeof P.browser!="string")return i.push([A.default.Error,C.localize(12,null,"browser")]),i;{const c=(0,n.joinPath)(y,P.browser);(0,n.isEqualOrParent)(c,y)||i.push([A.default.Warning,C.localize(13,null,c.path,y.path)])}if(typeof P.activationEvents>"u")return i.push([A.default.Error,C.localize(14,null,"activationEvents","browser")]),i}if(!F.valid(P.version))return i.push([A.default.Error,C.localize(15,null)]),i;const u=[];if(!b(a,m,P,g,u))for(const c of u)i.push([A.default.Error,c]);return i}e.validateExtensionManifest=f;function b(a,m,y,P,g){return P||typeof y.main>"u"&&typeof y.browser>"u"?!0:d(a,m,y.engines.vscode,g)}e.isValidExtensionVersion=b;function p(a,m,y){return a==="*"||d(m,y,a)}e.isEngineValid=p;function d(a,m,y,P=[]){const g=L(h(y));if(!g)return P.push(C.localize(16,null,y)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return P.push(C.localize(17,null,y)),!1}else if(!g.majorMustEqual)return P.push(C.localize(18,null,y)),!1;return D(a,m,g)?!0:(P.push(C.localize(19,null,a,y)),!1)}function t(a){if(!Array.isArray(a))return!1;for(let m=0,y=a.length;m<y;m++)if(typeof a[m]!="string")return!1;return!0}}),define(Pe[67],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(C,F=[],O=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=n}),define(Pe[68],Ae([1,0,67]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var C;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function F(R,w,h){w instanceof n.SyncDescriptor||(w=new n.SyncDescriptor(w,[],Boolean(h))),A.push([R,w])}e.registerSingleton=F;function O(){return A}e.getSingletonServiceDescriptors=O}),define(Pe[163],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(F,O){this.key=F,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class A{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const O of this.a.values())O.outgoing.size===0&&F.push(O);return F}insertEdge(F,O){const R=this.lookupOrInsertNode(F),w=this.lookupOrInsertNode(O);R.outgoing.set(w.key,w),w.incoming.set(R.key,R)}removeNode(F){const O=this.b(F);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(F){const O=this.b(F);let R=this.a.get(O);return R||(R=new n(O,F),this.a.set(O,R)),R}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[O,R]of this.a)F.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,O]of this.a){const R=new Set([F]),w=this.c(O,R);if(w)return w}}c(F,O){for(const[R,w]of F.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const h=this.c(w,O);if(h)return h;O.delete(R)}}}e.Graph=A}),define(Pe[3],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(w){return w[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(n=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function A(O,R,w){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:O,index:w}):(R[n.DI_DEPENDENCIES]=[{id:O,index:w}],R[n.DI_TARGET]=R)}function C(O){if(n.serviceIds.has(O))return n.serviceIds.get(O);const R=function(w,h,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,w,L)};return R.toString=()=>O,n.serviceIds.set(O,R),R}e.createDecorator=C;function F(O){return O}e.refineServiceDecorator=F}),define(Pe[42],Ae([1,0,9,2,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function F(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof A.URI)}e.isConfigurationOverrides=F;function O(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=O;var R;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function h(t,a){const m=Object.create(null);for(const y in t)L(m,y,t[y],a);return m}e.toValuesTree=h;function L(t,a,m,y){const P=a.split("."),g=P.pop();let i=t;for(let u=0;u<P.length;u++){const r=P[u];let c=i[r];switch(typeof c){case"undefined":c=i[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${a} as ${P.slice(0,u+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[g]=m}catch{y(`Ignoring ${a} as ${P.join(".")} is ${JSON.stringify(i)}`)}else y(`Ignoring ${a} as ${P.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=L;function D(t,a){const m=a.split(".");f(t,m)}e.removeFromValueTree=D;function f(t,a){const m=a.shift();if(a.length===0){delete t[m];return}if(Object.keys(t).indexOf(m)!==-1){const y=t[m];typeof y=="object"&&!Array.isArray(y)&&(f(y,a),Object.keys(y).length===0&&delete t[m])}}function b(t,a,m){function y(i,u){let r=i;for(const c of u){if(typeof r!="object"||r===null)return;r=r[c]}return r}const P=a.split("."),g=y(t,P);return typeof g>"u"?m:g}e.getConfigurationValue=b;function p(t,a,m){Object.keys(a).forEach(y=>{y!=="__proto__"&&(y in t?n.isObject(t[y])&&n.isObject(a[y])?p(t[y],a[y],m):m&&(t[y]=a[y]):t[y]=a[y])})}e.merge=p;function d(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Pe[31],Ae([1,0,20,13,161,3,135]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",n.isMacintosh),R.set("isLinux",n.isLinux),R.set("isWindows",n.isWindows),R.set("isWeb",n.isWeb),R.set("isMacNative",n.isMacintosh&&!n.isWeb),R.set("isEdge",n.isEdge),R.set("isFirefox",n.isFirefox),R.set("isChrome",n.isChrome),R.set("isSafari",n.isSafari);const w=Object.prototype.hasOwnProperty;var h;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(h=e.ContextKeyExprType||(e.ContextKeyExprType={}));const L={regexParsingWithErrorRecovery:!0};class D extends Error{}const f=(0,O.localize)(0,null),b=(0,O.localize)(1,null),p=(0,O.localize)(2,null),d=(0,O.localize)(3,null),t=(0,O.localize)(4,null),a=(0,O.localize)(5,null),m=(0,O.localize)(6,null),y=(0,O.localize)(7,null);class P{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(T=L){this.h=T,this.c=new C.Scanner,this.d=[],this.f=0,this.g=[]}parse(T){if(T===""){this.g.push({message:f,offset:0,lexeme:"",additionalInfo:b});return}this.d=this.c.reset(T).scan(),this.f=0,this.g=[];try{const V=this.k();if(!this.B()){const ce=this.A(),me=ce.type===17?a:void 0;throw this.g.push({message:t,offset:ce.offset,lexeme:C.Scanner.getLexeme(ce),additionalInfo:me}),new D}return V}catch(V){if(!(V instanceof D))throw V;return}}k(){return this.l()}l(){const T=[this.m()];for(;this.v(16);){const V=this.m();T.push(V)}return T.length===1?T[0]:g.or(...T)}m(){const T=[this.o()];for(;this.v(15);){const V=this.o();T.push(V)}return T.length===1?T[0]:g.and(...T)}o(){if(this.v(2)){const T=this.A();switch(T.type){case 11:return this.w(),c.INSTANCE;case 12:return this.w(),o.INSTANCE;case 0:{this.w();const V=this.k();return this.x(1,d),V?.negate()}case 17:return this.w(),E.create(T.lexeme);default:throw this.y("KEY | true | false | '(' expression ')'",T)}}return this.s()}s(){const T=this.A();switch(T.type){case 11:return this.w(),g.true();case 12:return this.w(),g.false();case 0:{this.w();const V=this.k();return this.x(1,d),V}case 17:{const V=T.lexeme;if(this.w(),this.v(9)){const me=this.A();if(!this.h.regexParsingWithErrorRecovery){if(this.w(),me.type!==10)throw this.y("REGEX",me);const Fe=me.lexeme,be=Fe.lastIndexOf("/"),Ee=be===Fe.length-1?void 0:Fe.substring(be+1);let Ie;try{Ie=new RegExp(Fe.substring(1,be),Ee)}catch{throw this.y("REGEX",me)}return U.create(V,Ie)}switch(me.type){case 10:case 19:{const Fe=[me.lexeme];this.w();let be=this.A(),Ee=0;for(let I=0;I<me.lexeme.length;I++)me.lexeme.charCodeAt(I)===40?Ee++:me.lexeme.charCodeAt(I)===41&&Ee--;for(;!this.B()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let I=0;I<be.lexeme.length;I++)be.lexeme.charCodeAt(I)===40?Ee++:me.lexeme.charCodeAt(I)===41&&Ee--}if(Ee<0)break;Fe.push(C.Scanner.getLexeme(be)),this.w(),be=this.A()}const Ie=Fe.join(""),se=Ie.lastIndexOf("/"),ae=se===Ie.length-1?void 0:Ie.substring(se+1);let Z;try{Z=new RegExp(Ie.substring(1,se),ae)}catch{throw this.y("REGEX",me)}return g.regex(V,Z)}case 18:{const Fe=me.lexeme;this.w();let be=null;if(!(0,A.isFalsyOrWhitespace)(Fe)){const Ee=Fe.indexOf("/"),Ie=Fe.lastIndexOf("/");if(Ee!==Ie&&Ee>=0){const se=Fe.slice(Ee+1,Ie),ae=Fe[Ie+1]==="i"?"i":"";try{be=new RegExp(se,ae)}catch{throw this.y("REGEX",me)}}}if(be===null)throw this.y("REGEX",me);return U.create(V,be)}default:throw this.y("REGEX",this.A())}}if(this.v(14)){this.x(13,p);const me=this.t();return g.notIn(V,me)}switch(this.A().type){case 3:{this.w();const me=this.t();if(this.u().type===18)return g.equals(V,me);switch(me){case"true":return g.has(V);case"false":return g.not(V);default:return g.equals(V,me)}}case 4:{this.w();const me=this.t();if(this.u().type===18)return g.notEquals(V,me);switch(me){case"true":return g.not(V);case"false":return g.has(V);default:return g.notEquals(V,me)}}case 5:return this.w(),J.create(V,this.t());case 6:return this.w(),q.create(V,this.t());case 7:return this.w(),G.create(V,this.t());case 8:return this.w(),Y.create(V,this.t());case 13:return this.w(),g.in(V,this.t());default:return g.has(V)}}case 20:throw this.g.push({message:m,offset:T.offset,lexeme:"",additionalInfo:y}),new D;default:throw this.y(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.A())}}t(){const T=this.A();switch(T.type){case 17:case 18:return this.w(),T.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(T){return this.z(T)?(this.w(),!0):!1}w(){return this.B()||this.f++,this.u()}x(T,V){if(this.z(T))return this.w();throw this.y(V,this.A())}y(T,V,ce){const me=(0,O.localize)(8,null,T,C.Scanner.getLexeme(V)),Fe=V.offset,be=C.Scanner.getLexeme(V);return this.g.push({message:me,offset:Fe,lexeme:be,additionalInfo:ce}),new D}z(T){return this.A().type===T}A(){return this.d[this.f]}B(){return this.A().type===20}}e.Parser=P;class g{static false(){return c.INSTANCE}static true(){return o.INSTANCE}static has(T){return k.create(T)}static equals(T,V){return s.create(T,V)}static notEquals(T,V){return S.create(T,V)}static regex(T,V){return U.create(T,V)}static in(T,V){return l.create(T,V)}static notIn(T,V){return v.create(T,V)}static not(T){return E.create(T)}static and(...T){return j.create(T,null,!0)}static or(...T){return he.create(T,null,!0)}static greater(T,V){return G.create(T,V)}static greaterEquals(T,V){return Y.create(T,V)}static smaller(T,V){return J.create(T,V)}static smallerEquals(T,V){return q.create(T,V)}static deserialize(T){return T==null?void 0:this.c.parse(T)}}g.c=new P({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=g;function i(X){const T=new P({regexParsingWithErrorRecovery:!1});return X.map(V=>(T.parse(V),T.lexingErrors.length>0?T.lexingErrors.map(ce=>({errorMessage:ce.additionalInfo?(0,O.localize)(9,null,ce.additionalInfo):(0,O.localize)(10,null),offset:ce.offset,length:ce.lexeme.length})):T.parsingErrors.length>0?T.parsingErrors.map(ce=>({errorMessage:ce.additionalInfo?`${ce.message}. ${ce.additionalInfo}`:ce.message,offset:ce.offset,length:ce.lexeme.length})):[]))}e.validateWhenClauses=i;function u(X,T){const V=X?X.substituteConstants():void 0,ce=T?T.substituteConstants():void 0;return!V&&!ce?!0:!V||!ce?!1:V.equals(ce)}e.expressionsAreEqualWithConstantSubstitution=u;function r(X,T){return X.cmp(T)}class c{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return o.INSTANCE}}c.INSTANCE=new c,e.ContextKeyFalseExpr=c;class o{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return c.INSTANCE}}o.INSTANCE=new o,e.ContextKeyTrueExpr=o;class k{static create(T,V=null){const ce=R.get(T);return typeof ce=="boolean"?ce?o.INSTANCE:c.INSTANCE:new k(T,V)}constructor(T,V){this.key=T,this.c=V,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:ie(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=R.get(this.key);return typeof T=="boolean"?T?o.INSTANCE:c.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=E.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=k;class s{static create(T,V,ce=null){if(typeof V=="boolean")return V?k.create(T,ce):E.create(T,ce);const me=R.get(T);return typeof me=="boolean"?V===(me?"true":"false")?o.INSTANCE:c.INSTANCE:new s(T,V,ce)}constructor(T,V,ce){this.c=T,this.d=V,this.f=ce,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=R.get(this.c);if(typeof T=="boolean"){const V=T?"true":"false";return this.d===V?o.INSTANCE:c.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=s;class l{static create(T,V){return new l(T,V)}constructor(T,V){this.d=T,this.f=V,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const V=T.getValue(this.f),ce=T.getValue(this.d);return Array.isArray(V)?V.includes(ce):typeof ce=="string"&&typeof V=="object"&&V!==null?w.call(V,ce):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=l;class v{static create(T,V){return new v(T,V)}constructor(T,V){this.d=T,this.f=V,this.type=11,this.c=l.create(T,V)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=v;class S{static create(T,V,ce=null){if(typeof V=="boolean")return V?E.create(T,ce):k.create(T,ce);const me=R.get(T);return typeof me=="boolean"?V===(me?"true":"false")?c.INSTANCE:o.INSTANCE:new S(T,V,ce)}constructor(T,V,ce){this.c=T,this.d=V,this.f=ce,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=R.get(this.c);if(typeof T=="boolean"){const V=T?"true":"false";return this.d===V?c.INSTANCE:o.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=S;class E{static create(T,V=null){const ce=R.get(T);return typeof ce=="boolean"?ce?c.INSTANCE:o.INSTANCE:new E(T,V)}constructor(T,V){this.c=T,this.d=V,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:ie(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=R.get(this.c);return typeof T=="boolean"?T?c.INSTANCE:o.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.ContextKeyNotExpr=E;function W(X,T){if(typeof X=="string"){const V=parseFloat(X);isNaN(V)||(X=V)}return typeof X=="string"||typeof X=="number"?T(X):c.INSTANCE}class G{static create(T,V,ce=null){return W(V,me=>new G(T,me,ce))}constructor(T,V,ce){this.c=T,this.d=V,this.f=ce,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=G;class Y{static create(T,V,ce=null){return W(V,me=>new Y(T,me,ce))}constructor(T,V,ce){this.c=T,this.d=V,this.f=ce,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=Y;class J{static create(T,V,ce=null){return W(V,me=>new J(T,me,ce))}constructor(T,V,ce){this.c=T,this.d=V,this.f=ce,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=J;class q{static create(T,V,ce=null){return W(V,me=>new q(T,me,ce))}constructor(T,V,ce){this.c=T,this.d=V,this.f=ce,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:oe(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=q;class U{static create(T,V){return new U(T,V)}constructor(T,V){this.d=T,this.f=V,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const V=this.f?this.f.source:"",ce=T.f?T.f.source:"";return V<ce?-1:V>ce?1:0}equals(T){if(T.type===this.type){const V=this.f?this.f.source:"",ce=T.f?T.f.source:"";return this.d===T.d&&V===ce}return!1}substituteConstants(){return this}evaluate(T){const V=T.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=$.create(this)),this.c}}e.ContextKeyRegexExpr=U;class ${static create(T){return new $(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(T){return new $(this.c.map(T))}negate(){return this.c}}e.ContextKeyNotRegexExpr=$;function z(X){let T=null;for(let V=0,ce=X.length;V<ce;V++){const me=X[V].substituteConstants();if(X[V]!==me&&T===null){T=[];for(let Fe=0;Fe<V;Fe++)T[Fe]=X[Fe]}T!==null&&(T[V]=me)}return T===null?X:T}class j{static create(T,V,ce){return j.d(T,V,ce)}constructor(T,V){this.expr=T,this.c=V,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let V=0,ce=this.expr.length;V<ce;V++){const me=r(this.expr[V],T.expr[V]);if(me!==0)return me}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let V=0,ce=this.expr.length;V<ce;V++)if(!this.expr[V].equals(T.expr[V]))return!1;return!0}return!1}substituteConstants(){const T=z(this.expr);return T===this.expr?this:j.create(T,this.c,!1)}evaluate(T){for(let V=0,ce=this.expr.length;V<ce;V++)if(!this.expr[V].evaluate(T))return!1;return!0}static d(T,V,ce){const me=[];let Fe=!1;for(const be of T)if(!!be){if(be.type===1){Fe=!0;continue}if(be.type===0)return c.INSTANCE;if(be.type===6){me.push(...be.expr);continue}me.push(be)}if(me.length===0&&Fe)return o.INSTANCE;if(me.length!==0){if(me.length===1)return me[0];me.sort(r);for(let be=1;be<me.length;be++)me[be-1].equals(me[be])&&(me.splice(be,1),be--);if(me.length===1)return me[0];for(;me.length>1;){const be=me[me.length-1];if(be.type!==9)break;me.pop();const Ee=me.pop(),Ie=me.length===0,se=he.create(be.expr.map(ae=>j.create([ae,Ee],null,ce)),null,Ie);se&&(me.push(se),me.sort(r))}if(me.length===1)return me[0];if(ce){for(let be=0;be<me.length;be++)for(let Ee=be+1;Ee<me.length;Ee++)if(me[be].negate().equals(me[Ee]))return c.INSTANCE;if(me.length===1)return me[0]}return new j(me,V)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const V of this.expr)T.push(...V.keys());return T}map(T){return new j(this.expr.map(V=>V.map(T)),null)}negate(){if(!this.c){const T=[];for(const V of this.expr)T.push(V.negate());this.c=he.create(T,this,!0)}return this.c}}class he{static create(T,V,ce){return he.d(T,V,ce)}constructor(T,V){this.expr=T,this.c=V,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let V=0,ce=this.expr.length;V<ce;V++){const me=r(this.expr[V],T.expr[V]);if(me!==0)return me}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let V=0,ce=this.expr.length;V<ce;V++)if(!this.expr[V].equals(T.expr[V]))return!1;return!0}return!1}substituteConstants(){const T=z(this.expr);return T===this.expr?this:he.create(T,this.c,!1)}evaluate(T){for(let V=0,ce=this.expr.length;V<ce;V++)if(this.expr[V].evaluate(T))return!0;return!1}static d(T,V,ce){let me=[],Fe=!1;if(T){for(let be=0,Ee=T.length;be<Ee;be++){const Ie=T[be];if(!!Ie){if(Ie.type===0){Fe=!0;continue}if(Ie.type===1)return o.INSTANCE;if(Ie.type===9){me=me.concat(Ie.expr);continue}me.push(Ie)}}if(me.length===0&&Fe)return c.INSTANCE;me.sort(r)}if(me.length!==0){if(me.length===1)return me[0];for(let be=1;be<me.length;be++)me[be-1].equals(me[be])&&(me.splice(be,1),be--);if(me.length===1)return me[0];if(ce){for(let be=0;be<me.length;be++)for(let Ee=be+1;Ee<me.length;Ee++)if(me[be].negate().equals(me[Ee]))return o.INSTANCE;if(me.length===1)return me[0]}return new he(me,V)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const V of this.expr)T.push(...V.keys());return T}map(T){return new he(this.expr.map(V=>V.map(T)),null)}negate(){if(!this.c){const T=[];for(const V of this.expr)T.push(V.negate());for(;T.length>1;){const V=T.shift(),ce=T.shift(),me=[];for(const Fe of le(V))for(const be of le(ce))me.push(j.create([Fe,be],null,!1));T.unshift(he.create(me,null,!1))}this.c=he.create(T,this,!0)}return this.c}}class we extends k{static all(){return we.d.values()}constructor(T,V,ce){super(T,null),this.f=V,typeof ce=="object"?we.d.push({...ce,key:T}):ce!==!0&&we.d.push({key:T,description:ce,type:V!=null?typeof V:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return s.create(this.key,T)}notEqualsTo(T){return S.create(this.key,T)}}we.d=[],e.RawContextKey=we,e.IContextKeyService=(0,F.createDecorator)("contextKeyService");function ie(X,T){return X<T?-1:X>T?1:0}function oe(X,T,V,ce){return X<V?-1:X>V?1:T<ce?-1:T>ce?1:0}function de(X,T){if(X.type===0||T.type===1)return!0;if(X.type===9)return T.type===9?ke(X.expr,T.expr):!1;if(T.type===9){for(const V of T.expr)if(de(X,V))return!0;return!1}if(X.type===6){if(T.type===6)return ke(T.expr,X.expr);for(const V of X.expr)if(de(V,T))return!0;return!1}return X.equals(T)}e.implies=de;function ke(X,T){let V=0,ce=0;for(;V<X.length&&ce<T.length;){const me=X[V].cmp(T[ce]);if(me<0)return!1;me===0&&V++,ce++}return V===X.length}function le(X){return X.type===9?X.expr:[X]}}),define(Pe[164],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[90],Ae([1,0,137,3]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function C(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function F(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function O(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function R(a,m){return m==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function w(a,m,y){return R(m,y)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===y?!0:h(y).includes(a)}e.isTargetPlatformCompatible=w;function h(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function L(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=L;var D;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var f;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var b;(function(a){a.Install="install",a.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var p;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var d;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class t extends Error{constructor(m,y){super(m),this.code=y,this.name=y}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Pe[43],Ae([1,0,48,19,13,9,2,139,3,20,15]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function D(ie){return ie.create===!0}e.isFileOpenForWriteOptions=D;var f;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(f=e.FileType||(e.FileType={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var p;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(ie){return!!(ie.capabilities&2)}e.hasReadWriteCapability=d;function t(ie){return!!(ie.capabilities&8)}e.hasFileFolderCopyCapability=t;function a(ie){return!!(ie.capabilities&32768)}e.hasFileCloneCapability=a;function m(ie){return!!(ie.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function y(ie){return!!(ie.capabilities&16)}e.hasFileReadStreamCapability=y;function P(ie){return d(ie)?!!(ie.capabilities&16384):!1}e.hasFileAtomicReadCapability=P;var g;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(oe,de){const ke=new i(oe.toString(),de);return c(ke,de),ke}constructor(oe,de){super(oe),this.code=de}}e.FileSystemProviderError=i;function u(ie,oe){return i.create(ie,oe)}e.createFileSystemProviderError=u;function r(ie){return ie||u((0,R.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=r;function c(ie,oe){return ie.name=oe?`${oe} (FileSystemError)`:"FileSystemError",ie}e.markAsFileSystemProviderError=c;function o(ie){if(!ie)return g.Unknown;if(ie instanceof i)return ie.code;const oe=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!oe)return g.Unknown;switch(oe[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=o;function k(ie){if(ie instanceof W)return ie.fileOperationResult;switch(o(ie)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=k;var s;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(oe,de,ke){this.resource=oe,this.operation=de,this.target=ke}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=l;var v;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class S{constructor(oe,de){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ke=new Map;for(const le of oe){const X=ke.get(le.type);switch(X?X.push([le.resource,le]):ke.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,X]of ke)switch(le){case 1:this.a=n.TernarySearchTree.forUris(()=>de),this.a.fill(X);break;case 0:this.b=n.TernarySearchTree.forUris(()=>de),this.b.fill(X);break;case 2:this.c=n.TernarySearchTree.forUris(()=>de),this.c.fill(X);break}}contains(oe,...de){return this.d(oe,{includeChildren:!1},...de)}affects(oe,...de){return this.d(oe,{includeChildren:!0},...de)}d(oe,de,...ke){if(!oe)return!1;const le=ke.length>0;return!!((!le||ke.includes(1))&&(this.a?.get(oe)||de.includeChildren&&this.a?.findSuperstr(oe))||(!le||ke.includes(0))&&(this.b?.get(oe)||de.includeChildren&&this.b?.findSuperstr(oe))||(!le||ke.includes(2))&&(this.c?.findSubstr(oe)||de.includeChildren&&this.c?.findSuperstr(oe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=S;function E(ie,oe,de){return!ie||!oe||ie===oe||oe.length>ie.length?!1:(oe.charAt(oe.length-1)!==A.sep&&(oe+=A.sep),de?(0,C.startsWithIgnoreCase)(ie,oe):ie.indexOf(oe)===0)}e.isParent=E;class W extends Error{constructor(oe,de,ke){super(oe),this.fileOperationResult=de,this.options=ke}}e.FileOperationError=W;class G extends W{constructor(oe,de,ke,le){super(oe,de,le),this.fileOperationResult=de,this.size=ke}}e.TooLargeFileOperationError=G;class Y extends W{constructor(oe,de,ke){super(oe,2,ke),this.stat=de}}e.NotModifiedSinceFileOperationError=Y;var J;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ie[ie.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.etag=U;async function $(ie,oe){if(!oe.hasProvider(O.URI.from({scheme:ie.scheme})))return new Promise(de=>{const ke=oe.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===ie.scheme&&le.added&&(ke.dispose(),de())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(oe){return(0,F.isNumber)(oe)||(oe=0),oe<z.KB?(0,R.localize)(1,null,oe.toFixed(0)):oe<z.MB?(0,R.localize)(2,null,(oe/z.KB).toFixed(2)):oe<z.GB?(0,R.localize)(3,null,(oe/z.MB).toFixed(2)):oe<z.TB?(0,R.localize)(4,null,(oe/z.GB).toFixed(2)):(0,R.localize)(5,null,(oe/z.TB).toFixed(2))}}z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB,e.ByteSize=z;var j;(function(ie){ie[ie.IA32=0]="IA32",ie[ie.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function he(ie){return{maxFileSize:ie===0?300*z.MB:16*z.GB,maxHeapSize:ie===0?700*z.MB:2*700*z.MB}}e.getPlatformFileLimits=he;function we(ie){const oe=typeof ie=="string"||ie?.scheme===L.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===L.Schemas.file?1024*z.MB:oe?10*z.MB:h.isWeb?50*z.MB:1024*z.MB}e.getLargeFileConfirmationLimit=we}),define(Pe[69],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...C){this.a=new Map;for(const[F,O]of C)this.set(F,O)}set(C,F){const O=this.a.get(C);return this.a.set(C,F),O}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=n}),define(Pe[165],Ae([1,0,17,10,6,67,163,3,69,166]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class f{constructor(t=new w.ServiceCollection,a=!1,m,y=L){this.f=t,this.g=a,this.h=m,this.i=y,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=y?m?._globalGraph??new O.Graph(P=>P):void 0}createChild(t){return new f(t,this.g,this,this.i)}invokeFunction(t,...a){const m=p.traceInvocation(this.i,t);let y=!1;try{return t({get:g=>{if(y)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(g,m);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...a)}finally{y=!0,m.stop()}}createInstance(t,...a){let m,y;return t instanceof F.SyncDescriptor?(m=p.traceCreation(this.i,t.ctor),y=this.j(t.ctor,t.staticArguments.concat(a),m)):(m=p.traceCreation(this.i,t),y=this.j(t,a,m)),m.stop(),y}j(t,a=[],m){const y=R._util.getServiceDependencies(t).sort((i,u)=>i.index-u.index),P=[];for(const i of y){const u=this.m(i.id,m);u||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),P.push(u)}const g=y.length>0?y[0].index:a.length;if(a.length!==g){console.trace(`[createInstance] First service dependency of ${t.name} at position ${g+1} conflicts with ${a.length} static arguments`);const i=g-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,g)}return Reflect.construct(t,a.concat(P))}k(t,a){if(this.f.get(t)instanceof F.SyncDescriptor)this.f.set(t,a);else if(this.h)this.h.k(t,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const a=this.f.get(t);return!a&&this.h?this.h.l(t):a}m(t,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const m=this.l(t);return m instanceof F.SyncDescriptor?this.q(t,m,a.branch(t,!0)):(a.branch(t,!1),m)}q(t,a,m){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,a,m)}finally{this.o.delete(t)}}r(t,a,m){const y=new O.Graph(i=>i.id.toString());let P=0;const g=[{id:t,desc:a,_trace:m}];for(;g.length;){const i=g.pop();if(y.lookupOrInsertNode(i),P++>1e3)throw new D(y);for(const u of R._util.getServiceDependencies(i.desc.ctor)){const r=this.l(u.id);if(r||this.u(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(u.id)),r instanceof F.SyncDescriptor){const c={id:u.id,desc:r,_trace:i._trace.branch(u.id,!0)};y.insertEdge(i,c),g.push(c)}}}for(;;){const i=y.roots();if(i.length===0){if(!y.isEmpty())throw new D(y);break}for(const{data:u}of i){if(this.l(u.id)instanceof F.SyncDescriptor){const c=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,c)}y.removeNode(u)}}return this.l(t)}s(t,a,m=[],y,P){if(this.f.get(t)instanceof F.SyncDescriptor)return this.t(t,a,m,y,P);if(this.h)return this.h.s(t,a,m,y,P);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(t,a,m=[],y,P){if(y){const g=new f(void 0,this.g,this,this.i);g.c=String(t);const i=new Map,u=new n.IdleValue(()=>{const r=g.j(a,m,P);for(const[c,o]of i){const k=r[c];if(typeof k=="function")for(const s of o)k.apply(r,s)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,c){if(!u.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let s=i.get(c);return s||(s=new h.LinkedList,i.set(c,s)),(v,S,E)=>{const W=s.push([v,S,E]);return(0,C.toDisposable)(W)}}if(c in r)return r[c];const o=u.value;let k=o[c];return typeof k!="function"||(k=k.bind(o),r[c]=k),k},set(r,c,o){return u.value[c]=o,!0},getPrototypeOf(r){return a.prototype}})}else return this.j(a,m,P)}u(t,a){if(a&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=f;var b;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(b||(b={}));class p{static traceInvocation(t,a){return t?new p(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,a){return t?new p(1,a.name):p.c}constructor(t,a){this.type=t,this.name=a,this.g=Date.now(),this.h=[]}branch(t,a){const m=new p(3,t.toString());return this.h.push([t,a,m]),m}stop(){const t=Date.now()-this.g;p.f+=t;let a=!1;function m(P,g){const i=[],u=new Array(P+1).join("	");for(const[r,c,o]of g.h)if(c&&o){a=!0,i.push(`${u}CREATES -> ${r}`);const k=m(P+1,o);k&&i.push(k)}else i.push(`${u}uses -> ${r}`);return i.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||a)&&p.all.add(y.join(`
`))}}p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0,e.Trace=p}),define(Pe[14],Ae([1,0,40,5,91,6,28,20,22,9,2,31,3]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function b(){return new Date().toISOString()}function p(v){return(0,h.isNumber)(v)}e.isLogLevel=p;var d;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function t(v,S,E){switch(S){case d.Trace:v.trace(E);break;case d.Debug:v.debug(E);break;case d.Info:v.info(E);break;case d.Warning:v.warn(E);break;case d.Error:v.error(E);break;case d.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=t;function a(v,S=!1){let E="";for(let W=0;W<v.length;W++){let G=v[W];if(G instanceof Error&&(G=(0,n.toErrorMessage)(G,S)),typeof G=="object")try{G=JSON.stringify(G)}catch{}E+=(W>0?" ":"")+G}return E}class m extends F.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==d.Off&&this.b<=S}}e.AbstractLogger=m;class y extends m{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...E){this.f(d.Trace)&&this.g(d.Trace,a([S,...E],!0))}debug(S,...E){this.f(d.Debug)&&this.g(d.Debug,a([S,...E]))}info(S,...E){this.f(d.Info)&&this.g(d.Info,a([S,...E]))}warn(S,...E){this.f(d.Warning)&&this.g(d.Warning,a([S,...E]))}error(S,...E){if(this.f(d.Error))if(S instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=S.stack,this.g(d.Error,a(W))}else this.g(d.Error,a([S,...E]))}flush(){}}e.AbstractMessageLogger=y;class P extends m{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.g=!R.isWindows}trace(S,...E){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...E):console.log(`[main ${b()}]`,S,...E))}debug(S,...E){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...E):console.log(`[main ${b()}]`,S,...E))}info(S,...E){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...E):console.log(`[main ${b()}]`,S,...E))}warn(S,...E){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,S,...E):console.warn(`[main ${b()}]`,S,...E))}error(S,...E){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,S,...E):console.error(`[main ${b()}]`,S,...E))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class g extends m{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S)}trace(S,...E){this.f(d.Trace)&&console.log("%cTRACE","color: #888",S,...E)}debug(S,...E){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",S,...E)}info(S,...E){this.f(d.Info)&&console.log("%c INFO","color: #33f",S,...E)}warn(S,...E){this.f(d.Warning)&&console.log("%c WARN","color: #993",S,...E)}error(S,...E){this.f(d.Error)&&console.log("%c  ERR","color: #f33",S,...E)}dispose(){}flush(){}}e.ConsoleLogger=g;class i extends m{constructor(S,E=e.DEFAULT_LOG_LEVEL){super(),this.g=S,this.setLevel(E)}trace(S,...E){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(S),...E])}debug(S,...E){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(S),...E])}info(S,...E){this.f(d.Info)&&this.g.log(d.Info,[this.h(S),...E])}warn(S,...E){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(S),...E])}error(S,...E){this.f(d.Error)&&this.g.log(d.Error,[this.h(S),...E])}h(S){return typeof S=="string"?S:(0,n.toErrorMessage)(S,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class u extends m{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const E of this.g)E.setLevel(S);super.setLevel(S)}trace(S,...E){for(const W of this.g)W.trace(S,...E)}debug(S,...E){for(const W of this.g)W.debug(S,...E)}info(S,...E){for(const W of this.g)W.info(S,...E)}warn(S,...E){for(const W of this.g)W.warn(S,...E)}error(S,...E){for(const W of this.g)W.error(S,...E)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.MultiplexLogger=u;class r extends F.Disposable{constructor(S,E,W){if(super(),this.h=S,this.j=E,this.b=new O.ResourceMap,this.c=this.D(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new A.Emitter),this.onDidChangeVisibility=this.g.event,W)for(const G of W)this.b.set(G.resource,{logger:void 0,info:G})}k(S){return(0,h.isString)(S)?[...this.b.values()].find(E=>E.info.id===S):this.b.get(S)}getLogger(S){return this.k(S)?.logger}createLogger(S,E){const W=this.l(S),G=(0,h.isString)(S)?S:E?.id??(0,C.hash)(W.toString()).toString(16);let Y=this.b.get(W)?.logger;const J=E?.logLevel==="always"?d.Trace:E?.logLevel;Y||(Y=this.m(W,J??this.getLogLevel(W)??this.h,{...E,id:G}));const q={logger:Y,info:{resource:W,id:G,logLevel:J,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(q.info),this.b.set(W,q),Y}l(S){return(0,h.isString)(S)?(0,w.joinPath)(this.j,`${S}.log`):S}setLogLevel(S,E){if(L.URI.isUri(S)){const W=S,G=E,Y=this.b.get(W);Y&&G!==Y.info.logLevel&&(Y.info.logLevel=G===this.h?void 0:G,Y.logger?.setLevel(G),this.b.set(Y.info.resource,Y),this.f.fire([W,G]))}else{this.h=S;for(const[W,G]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&G.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,E){const W=this.k(S);W&&E!==!W.info.hidden&&(W.info.hidden=!E,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,E]))}getLogLevel(S){let E;return S&&(E=this.b.get(S)?.info.logLevel),E??this.h}registerLogger(S){const E=this.b.get(S.resource);E?E.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const E=this.b.get(S);E&&(E.logger&&E.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class c{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(S){}getLevel(){return d.Info}trace(S,...E){}debug(S,...E){}info(S,...E){}warn(S,...E){}error(S,...E){}critical(S,...E){}dispose(){}flush(){}}e.NullLogger=c;class o extends c{}e.NullLogService=o;function k(v){if(v.verbose)return d.Trace;if(typeof v.logLevel=="string"){const S=l(v.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=k;function s(v){switch(v){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=s;function l(v){switch(v){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=l,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",s(d.Info))}),define(Pe[167],Ae([1,0,6,14]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends n.Disposable{constructor(O,R=[]){super(),this.a=new A.MultiplexLogger([O,...R]),this.D(O.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.LogService=C}),define(Pe[92],Ae([1,0,29,140,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(F=e.MarkerTag||(e.MarkerTag={}));var O;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(O=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function h(p,d){return d-p}w.compare=h;const L=Object.create(null);L[w.Error]=(0,A.localize)(0,null),L[w.Warning]=(0,A.localize)(1,null),L[w.Info]=(0,A.localize)(2,null);function D(p){return L[p]||""}w.toString=D;function f(p){switch(p){case n.default.Error:return w.Error;case n.default.Warning:return w.Warning;case n.default.Info:return w.Info;case n.default.Ignore:return w.Hint}}w.fromSeverity=f;function b(p){switch(p){case w.Error:return n.default.Error;case w.Warning:return n.default.Warning;case w.Info:return n.default.Info;case w.Hint:return n.default.Ignore}}w.toSeverity=b}(O=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(w){const h="";function L(f){return D(f,!0)}w.makeKey=L;function D(f,b){const p=[h];return f.source?p.push(f.source.replace("\xA6","\\\xA6")):p.push(h),f.code?typeof f.code=="string"?p.push(f.code.replace("\xA6","\\\xA6")):p.push(f.code.value.replace("\xA6","\\\xA6")):p.push(h),f.severity!==void 0&&f.severity!==null?p.push(O.toString(f.severity)):p.push(h),f.message&&b?p.push(f.message.replace("\xA6","\\\xA6")):p.push(h),f.startLineNumber!==void 0&&f.startLineNumber!==null?p.push(f.startLineNumber.toString()):p.push(h),f.startColumn!==void 0&&f.startColumn!==null?p.push(f.startColumn.toString()):p.push(h),f.endLineNumber!==void 0&&f.endLineNumber!==null?p.push(f.endLineNumber.toString()):p.push(h),f.endColumn!==void 0&&f.endColumn!==null?p.push(f.endColumn.toString()):p.push(h),p.push(h),p.join("\xA6")}w.makeKeyOptionalMessage=D})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(Pe[168],Ae([1,0,5,29,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,C.createDecorator)("notificationService");var F;(function(h){h[h.WORKSPACE=0]="WORKSPACE",h[h.PROFILE=1]="PROFILE",h[h.APPLICATION=2]="APPLICATION"})(F=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var O;(function(h){h[h.OFF=0]="OFF",h[h.SILENT=1]="SILENT",h[h.ERROR=2]="ERROR"})(O=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new w,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=R;class w{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=w}),define(Pe[93],Ae([1,0,13,2,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService");function F(h,L){return A.URI.isUri(h)?(0,n.equalsIgnoreCase)(h.scheme,L):(0,n.startsWithIgnoreCase)(h,L+":")}e.matchesScheme=F;function O(h,...L){return L.some(D=>F(h,D))}e.matchesSomeScheme=O;function R(h,L){return h.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=R;function w(h){let L;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(h.fragment);return D&&(L={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},h=h.with({fragment:""})),{selection:L,uri:h}}e.extractSelection=w}),define(Pe[169],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(ee,e,n,A){var C=arguments.length,F=C<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,n):A,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ee,e,n,A);else for(var R=ee.length-1;R>=0;R--)(O=ee[R])&&(F=(C<3?O(F):C>3?O(e,n,F):O(e,n))||F);return C>3&&F&&Object.defineProperty(e,n,F),F},Ve=this&&this.__param||function(ee,e){return function(n,A){e(n,A,ee)}};define(Pe[170],Ae([1,0,17,21,6,3]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,F.createDecorator)("progressService");var O;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(O=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}R.None=Object.freeze({report(){}}),e.Progress=R;let w=class extends C.Disposable{constructor(D,f){super(),this.a=new n.DeferredPromise,f.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.D((0,C.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};w=je([Ve(1,e.IProgressService)],w),e.UnmanagedProgress=w;class h extends C.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.D(new C.DisposableStore)}start(D){this.stop();const f=++this.a,b=new A.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,C.toDisposable)(()=>b.cancel())),this.b.add((0,C.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:b.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=h,e.IEditorProgressService=(0,F.createDecorator)("editorProgressService")}),define(Pe[30],Ae([1,0,49,9]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(O,R){n.ok(A.isString(O)),n.ok(A.isObject(R)),n.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new C}),define(Pe[70],Ae([1,0,5,30]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class F{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,h){this.a[C(w)]=h,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const O=new F;A.Registry.add(e.Extensions.JSONContribution,O)}),define(Pe[94],Ae([1,0,16,5,9,134,42,70,30]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=w.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const r=new Set;this.n(i,u,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const u=new Set;this.o(i,u),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:i,remove:u}){const r=new Set;this.o(u,r),this.n(i,!1,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const u=new Set;this.k(i,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(i,u){const r=[];for(const{overrides:c,source:o}of i)for(const k in c)if(u.add(k),e.OVERRIDE_PROPERTY_REGEX.test(k)){const s=this.a.get(k),l=s?.valuesSources??new Map;if(o)for(const W of Object.keys(c[k]))l.set(W,o);const v={...s?.value||{},...c[k]};this.a.set(k,{source:o,value:v,valuesSources:l});const S=(0,O.getLanguageTagSettingPlainKey)(k),E={type:"object",default:v,description:F.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:C.isString(o)?void 0:o,defaultValueSource:o};r.push(...d(k)),this.d[k]=E,this.b.properties[k]=E}else{this.a.set(k,{value:c[k],source:o});const s=this.d[k];s&&(this.w(k,s),this.r(k,s))}this.m(r)}deregisterDefaultConfigurations(i){const u=new Set;this.l(i,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(i,u){for(const{overrides:r,source:c}of i)for(const o in r){const k=this.a.get(o),s=C.isString(c)?c:c?.id,l=C.isString(k?.source)?k?.source:k?.source?.id;if(s===l)if(u.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}}this.u()}deltaConfiguration(i){let u=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),u=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),u=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const u of i)this.h.add(u);this.u()}n(i,u,r){i.forEach(c=>{this.p(c,u,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(i,u){const r=c=>{if(c.properties)for(const o in c.properties){u.add(o);const k=this.d[o];k?.policy?.name&&this.e.delete(k.policy.name),delete this.d[o],this.s(o,c.properties[o])}c.allOf?.forEach(o=>r(o))};for(const c of i){r(c);const o=this.c.indexOf(c);o!==-1&&this.c.splice(o,1)}}p(i,u=!0,r,c,o=3,k){o=C.isUndefinedOrNull(i.scope)?o:i.scope;const s=i.properties;if(s)for(const v in s){const S=s[v];if(u&&y(v,S)){delete s[v];continue}if(S.source=r,S.defaultDefaultValue=s[v].default,this.w(v,S),e.OVERRIDE_PROPERTY_REGEX.test(v)?S.scope=void 0:(S.scope=C.isUndefinedOrNull(S.scope)?o:S.scope,S.restricted=C.isUndefinedOrNull(S.restricted)?!!c?.includes(v):S.restricted),s[v].hasOwnProperty("included")&&!s[v].included){this.f[v]=s[v],delete s[v];continue}else this.d[v]=s[v],s[v].policy?.name&&this.e.set(s[v].policy.name,v);!s[v].deprecationMessage&&s[v].markdownDeprecationMessage&&(s[v].deprecationMessage=s[v].markdownDeprecationMessage),k.add(v)}const l=i.allOf;if(l)for(const v of l)this.p(v,u,r,c,o,k)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const u=r=>{const c=r.properties;if(c)for(const k in c)this.r(k,c[k]);r.allOf?.forEach(u)};u(i)}r(i,u){switch(e.allSettings.properties[i]=u,u.scope){case 1:e.applicationSettings.properties[i]=u;break;case 2:e.machineSettings.properties[i]=u;break;case 6:e.machineOverridableSettings.properties[i]=u;break;case 3:e.windowSettings.properties[i]=u;break;case 4:e.resourceSettings.properties[i]=u;break;case 5:e.resourceSettings.properties[i]=u,this.g.properties[i]=u;break}}s(i,u){switch(delete e.allSettings.properties[i],u.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const u=`[${i}]`,r={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(u,r),e.allSettings.properties[u]=r,e.applicationSettings.properties[u]=r,e.machineSettings.properties[u]=r,e.machineOverridableSettings.properties[u]=r,e.windowSettings.properties[u]=r,e.resourceSettings.properties[u]=r}}v(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,u){const r=this.a.get(i);let c=r?.value,o=r?.source;C.isUndefined(c)&&(c=u.defaultDefaultValue,o=void 0),C.isUndefined(c)&&(c=a(u.type)),u.default=c,u.defaultValueSource=o}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let u=p.exec(g);for(;u?.length;){const r=u[1].trim();r&&i.push(r),u=p.exec(g)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=d;function t(g){return g.reduce((i,u)=>`${i}[${u}]`,"")}e.keyFromOverrideIdentifiers=t;function a(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const m=new f;w.Registry.add(e.Extensions.Configuration,m);function y(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?F.localize(7,null,g):m.getConfigurationProperties()[g]!==void 0?F.localize(8,null,g):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,g,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}e.validateProperty=y;function P(){const g=[],i=m.getConfigurationProperties();for(const u of Object.keys(i))g.push([u,i[u].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=P}),define(Pe[171],Ae([1,0,16,5,113,6,28,23,9,2,42,94,30]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(u){return Object.isFrozen(u)?u:R.deepFreeze(u)}class p{constructor(r={},c=[],o=[],k){this.b=r,this.c=c,this.d=o,this.raw=k,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof p)return c;const o=new d("");return o.parseRaw(c),o.configurationModel});this.f=r.reduce((c,o)=>o===c?o:c.merge(o),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const o=this.rawConfiguration.getValue(r),k=c?this.rawConfiguration.getOverrideValue(r,c):void 0,s=c?this.rawConfiguration.override(c).getValue(r):o;return{value:o,override:k,merged:s}}getOverrideValue(r,c){const o=this.i(c);return o?r?(0,L.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const o of this.overrides)o.identifiers.includes(r)&&c.push(...o.keys);return n.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return n.distinct(r)}override(r){let c=this.a.get(r);return c||(c=this.g(r),this.a.set(r,c)),c}merge(...r){const c=R.deepClone(this.contents),o=R.deepClone(this.overrides),k=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const l of r)if(s.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(c,l.contents);for(const v of l.overrides){const[S]=o.filter(E=>n.equals(E.identifiers,v.identifiers));S?(this.h(S.contents,v.contents),S.keys.push(...v.keys),S.keys=n.distinct(S.keys)):o.push(R.deepClone(v))}for(const v of l.keys)k.indexOf(v)===-1&&k.push(v)}return new p(c,k,o,s.every(l=>l instanceof p)?void 0:s)}g(r){const c=this.i(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const o={};for(const k of n.distinct([...Object.keys(this.contents),...Object.keys(c)])){let s=this.contents[k];const l=c[k];l&&(typeof s=="object"&&typeof l=="object"?(s=R.deepClone(s),this.h(s,l)):s=l),o[k]=s}return new p(o,this.keys,this.overrides)}h(r,c){for(const o of Object.keys(c)){if(o in r&&w.isObject(r[o])&&w.isObject(c[o])){this.h(r[o],c[o]);continue}r[o]=R.deepClone(c[o])}}i(r){let c=null,o=null;const k=s=>{s&&(o?this.h(o,s):o=R.deepClone(s))};for(const s of this.overrides)n.equals(s.identifiers,[r])?c=s.contents:s.identifiers.includes(r)&&k(s.contents);return k(c),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.j(r,c,!0)}setValue(r,c){this.j(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,L.removeFromValueTree)(this.contents,r),D.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(o=>n.equals(o.identifiers,(0,D.overrideIdentifiersFromKey)(r))),1))}j(r,c,o){(0,L.addToValueTree)(this.contents,r,c,k=>console.error(k)),o=o||this.keys.indexOf(r)===-1,o&&this.keys.push(r),D.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,L.toValuesTree)(this.contents[r],k=>console.error(k))})}}e.ConfigurationModel=p;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!w.isUndefinedOrNull(r)){const o=this.g(r);this.parseRaw(o,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:o,keys:k,overrides:s,restricted:l,hasExcludedProperties:v}=this.h(r,c);this.b=new p(o,k,s,v?[r]:void 0),this.c=l||[]}g(r){let c={},o=null,k=[];const s=[],l=[];function v(E){Array.isArray(k)?k.push(E):o!==null&&(k[o]=E)}const S={onObjectBegin:()=>{const E={};v(E),s.push(k),k=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{k=s.pop()},onArrayBegin:()=>{const E=[];v(E),s.push(k),k=E,o=null},onArrayEnd:()=>{k=s.pop()},onLiteralValue:v,onError:(E,W,G)=>{l.push({error:E,offset:W,length:G})}};if(r)try{C.visit(r,S),c=k[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return c}h(r,c){const o=f.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),k=this.i(r,o,!0,c);r=k.raw;const s=(0,L.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),l=Object.keys(r),v=this.j(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:s,keys:l,overrides:v,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}i(r,c,o,k){let s=!1;if(!k?.scopes&&!k?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const l={},v=[];for(const S in r)if(D.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const E=this.i(r[S],c,!1,k);l[S]=E.raw,s=s||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=c[S],W=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(S),(W===void 0||k.scopes===void 0||k.scopes.includes(W))&&!(k.skipRestricted&&E?.restricted)?l[S]=r[S]:s=!0}return{raw:l,restricted:v,hasExcludedProperties:s}}j(r,c){const o=[];for(const k of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(k)){const s={};for(const l in r[k])s[l]=r[k][l];o.push({identifiers:(0,D.overrideIdentifiersFromKey)(k),keys:Object.keys(s),contents:(0,L.toValuesTree)(s,c)})}return o}}e.ConfigurationModelParser=d;class t extends F.Disposable{constructor(r,c,o,k){super(),this.f=r,this.g=c,this.h=k,this.c=this.D(new A.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(o.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(A.Event.any(A.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class a{constructor(r,c,o,k,s,l,v,S,E,W,G,Y,J){this.a=r,this.b=c,this.c=o,this.overrideIdentifiers=k,this.d=s,this.f=l,this.g=v,this.h=S,this.i=E,this.j=W,this.k=G,this.l=Y,this.m=J}get value(){return b(this.c)}n(r,c,o){const k=r.inspect(c,o);return{get value(){return b(k.value)},get override(){return b(k.override)},get merged(){return b(k.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(r,c,o,k,s=new p,l=new p,v=new O.ResourceMap,S=new p,E=new O.ResourceMap){this.c=r,this.d=c,this.f=o,this.g=k,this.h=s,this.i=l,this.j=v,this.l=S,this.m=E,this.a=null,this.b=new O.ResourceMap,this.n=null}getValue(r,c,o){return this.q(r,c,o).getValue(r)}updateValue(r,c,o={}){let k;o.resource?(k=this.m.get(o.resource),k||(k=new p,this.m.set(o.resource,k))):k=this.l,c===void 0?k.removeValue(r):k.setValue(r,c),o.resource||(this.a=null)}inspect(r,c,o){const k=this.q(r,c,o),s=this.u(c.resource,o),l=c.resource?this.m.get(c.resource)||this.l:this.l,v=new Set;for(const S of k.overrides)for(const E of S.identifiers)k.getOverrideValue(r,E)!==void 0&&v.add(E);return new a(r,c,k.getValue(r),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,s||void 0,l)}keys(r){const c=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,c){this.j.set(r,c),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const o=[];if(!c){const{added:k,updated:s,removed:l}=g(this.c,r);c=[...k,...s,...l]}for(const k of c)for(const s of(0,D.overrideIdentifiersFromKey)(k)){const l=this.c.getKeysForOverrideIdentifier(s),v=r.getKeysForOverrideIdentifier(s),S=[...v.filter(E=>l.indexOf(E)===-1),...l.filter(E=>v.indexOf(E)===-1),...l.filter(E=>!R.equals(this.c.override(s).getValue(E),r.override(s).getValue(E)))];o.push([s,S])}return this.updateDefaultConfiguration(r),{keys:c,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:o,removed:k}=g(this.d,r),s=[...c,...o,...k];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:o,removed:k,overrides:s}=g(this.applicationConfiguration,r),l=[...c,...o,...k];return l.length&&this.updateApplicationConfiguration(r),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:o,removed:k,overrides:s}=g(this.localUserConfiguration,r),l=[...c,...o,...k];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:o,removed:k,overrides:s}=g(this.remoteUserConfiguration,r),l=[...c,...o,...k];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:o,removed:k,overrides:s}=g(this.workspaceConfiguration,r),l=[...c,...o,...k];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(r,c){const o=this.p.get(r),{added:k,updated:s,removed:l,overrides:v}=g(o,c),S=[...k,...s,...l];return(S.length||!o)&&this.updateFolderConfiguration(r,c),{keys:S,overrides:v}}compareAndDeleteFolderConfiguration(r){const c=this.p.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:k,removed:s,overrides:l}=g(c,void 0);return{keys:[...o,...k,...s],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,c,o){let k=this.r(c,o);return c.overrideIdentifier&&(k=k.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(k=k.merge(this.d)),k}r({resource:r},c){let o=this.s();if(c&&r){const k=c.getFolder(r);k&&(o=this.t(k.uri)||o);const s=this.m.get(r);s&&(o=o.merge(s))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let c=this.b.get(r);if(!c){const o=this.s(),k=this.j.get(r);k?(c=o.merge(k),this.b.set(r,c)):c=o}return c}u(r,c){if(c&&r){const o=c.getFolder(r);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,c)=>{const{contents:o,overrides:k,keys:s}=this.j.get(c);return r.push([c,{contents:o,overrides:k,keys:s}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.i.keys.forEach(c=>r.add(c)),this.j.forEach(c=>c.keys.forEach(o=>r.add(o))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}w(r){const c=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(o=>c.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>c.add(o)),this.i.getKeysForOverrideIdentifier(r).forEach(o=>c.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(k=>c.add(k))),[...c.values()]}static parse(r){const c=this.x(r.defaults),o=this.x(r.policy),k=this.x(r.application),s=this.x(r.user),l=this.x(r.workspace),v=r.folders.reduce((S,E)=>(S.set(h.URI.revive(E[0]),this.x(E[1])),S),new O.ResourceMap);return new m(c,o,k,s,new p,l,v,new p,new O.ResourceMap)}static x(r){return new p(r.contents,r.keys,r.overrides)}}e.Configuration=m;function y(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,c=new Map;for(const k of u)k.keys.forEach(s=>r.add(s)),k.overrides.forEach(([s,l])=>{const v=(0,O.getOrSet)(c,s,new Set);l.forEach(S=>v.add(S))});const o=[];return c.forEach((k,s)=>o.push([s,[...k.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=y;class P{constructor(r,c,o,k){this.change=r,this.f=c,this.g=o,this.h=k,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of r.keys)this.affectedKeys.add(s);for(const[,s]of r.overrides)for(const l of s)this.affectedKeys.add(l);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(r,c){const o=this.a+r,k=this.d.indexOf(o);if(k<0)return!1;const s=k+o.length;if(s>=this.d.length)return!1;const l=this.d.charCodeAt(s);if(l!==this.b&&l!==this.c)return!1;if(c){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,S=this.g.getValue(r,c,this.h);return!R.equals(v,S)}return!0}}e.ConfigurationChangeEvent=P;function g(u,r){const{added:c,removed:o,updated:k}=i(r?.rawConfiguration,u?.rawConfiguration),s=[],l=u?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const S=v.filter(E=>!l.includes(E));for(const E of S)s.push([E,r.getKeysForOverrideIdentifier(E)])}if(u){const S=l.filter(E=>!v.includes(E));for(const E of S)s.push([E,u.getKeysForOverrideIdentifier(E)])}if(r&&u){for(const S of l)if(v.includes(S)){const E=i({contents:u.getOverrideValue(void 0,S)||{},keys:u.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});s.push([S,[...E.added,...E.removed,...E.updated]])}}return{added:c,removed:o,updated:k,overrides:s}}function i(u,r){const c=u?r?u.keys.filter(s=>r.keys.indexOf(s)===-1):[...u.keys]:[],o=r?u?r.keys.filter(s=>u.keys.indexOf(s)===-1):[...r.keys]:[],k=[];if(u&&r){for(const s of r.keys)if(u.keys.indexOf(s)!==-1){const l=(0,L.getConfigurationValue)(r.contents,s),v=(0,L.getConfigurationValue)(u.contents,s);R.equals(l,v)||k.push(s)}}return{added:c,removed:o,updated:k}}}),define(Pe[95],Ae([1,0,10,3]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var C;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class F extends n.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof F&&w._code===C.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof F&&w._code===C.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof F&&w._code===C.NoResolverFound}static isHandled(w){return w instanceof F&&w.isHandled}constructor(w,h=C.Unknown,L){super(w),this._message=w,this._code=h,this._detail=L,this.isHandled=h===C.NotAvailable&&L===!0,Object.setPrototypeOf(this,F.prototype)}}e.RemoteAuthorityResolverError=F;function O(R){const w=R.indexOf("+");return w===-1?R:R.substring(0,w)}e.getRemoteAuthorityPrefix=O}),define(Pe[50],Ae([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=A;function C(h){if(!h)return;const L=h.indexOf("+");return L<0?h:h.substr(0,L)}e.getRemoteName=C;function F(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=F;function O(h){const{host:L,port:D}=w(h);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:D}}e.parseAuthorityWithPort=O;function R(h,L){let{host:D,port:f}=w(h);return typeof f>"u"&&(f=L),{host:D,port:f}}e.parseAuthorityWithOptionalPort=R;function w(h){const L=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const D=h.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const f=h.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:h,port:void 0}}}),define(Pe[24],Ae([1,0,13,3,50]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function F(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const m=typeof t=="string"?t:t.value,y=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(m,y)}return t.c===a.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=w;class h{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const a of t)this.add(a)}add(t){this.c.add(w.toKey(t))}delete(t){return this.c.delete(w.toKey(t))}has(t){return this.c.has(w.toKey(t))}}e.ExtensionIdentifierSet=h;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(w.toKey(t))}get(t){return this.c.get(w.toKey(t))}has(t){return this.c.has(w.toKey(t))}set(t,a){this.c.set(w.toKey(t),a)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function D(d){return f(d)}e.isApplicationScopedExtension=D;function f(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function b(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function p(d,t){if(t){const a=`onResolveRemoteAuthority:${(0,C.getRemoteName)(t)}`;return!!d.activationEvents?.includes(a)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[96],Ae([1,0,10,24]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(O,R){this.a.set(O,R)}readActivationEvents(O){return this.b.has(O)||this.b.set(O,this.c(O)),this.b.get(O)}createActivationEventsMap(O){const R=Object.create(null);for(const w of O){const h=this.readActivationEvents(w);h.length>0&&(R[A.ExtensionIdentifier.toKey(w.identifier)]=h)}return R}c(O){if(typeof O.main>"u"&&typeof O.browser>"u")return[];const R=Array.isArray(O.activationEvents)?O.activationEvents.slice(0):[];if(!O.contributes)return R;for(const w in O.contributes){const h=this.a.get(w);if(!h)continue;const L=O.contributes[w],D=Array.isArray(L)?L:[L];try{h(D,R)}catch(f){(0,n.onUnexpectedError)(f)}}return R}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Pe[172],Ae([1,0,20,51,2,35]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(h){if(n.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function R(h,L,D,f,b,p,d,t,a,m){const y=Object.create(null);y["common.machineId"]=d,y.sessionID=(0,F.generateUuid)()+Date.now(),y.commitHash=b,y.version=p,y["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,n.PlatformToString)(n.platform),y["common.nodePlatform"]=A.platform,y["common.nodeArch"]=f,y["common.product"]=m||"desktop",t&&(y["common.msftInternal"]=t);let P=0;const g=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.isLinuxSnap&&(y["common.snap"]="true");const i=O(D);i&&(y["common.platformDetail"]=i);try{const u=await h.readFile(C.URI.file(a));y["common.source"]=u.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function w(h){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const D=L.toLowerCase();return h.some(f=>D===f)}e.verifyMicrosoftInternalDomain=w}),define(Pe[173],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Pe[52],Ae([1,0,23,9,5,42,50,172,173]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(o){this.value=o}}e.TelemetryTrustedValue=h;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,k){return Promise.resolve(void 0)}publicLog2(o,k){return this.publicLog(o,k)}publicLogError(o,k){return Promise.resolve(void 0)}publicLogError2(o,k){return this.publicLogError(o,k)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class D{async publicLog(o,k,s){}async publicLogError(o,k,s){}}e.NullEndpointTelemetryService=D,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(c,o){return C.Event.debounce(o.onDidChangeConfiguration,(s,l)=>{const v=s?new Set([...s.affectedKeys,...l.affectedKeys]):l.affectedKeys;return{...l,affectedKeys:v}},1e3,!0)(s=>{s.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(s.source),configurationKeys:Array.from(s.affectedKeys)})})}e.configurationTelemetry=f;function b(c,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!c.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=b;function p(c,o){return!(o.isBuilt||o.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=p;function d(c){const o=c.getValue(w.TELEMETRY_SETTING_ID),k=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||k===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function t(c){const o={},k={},s={};y(c,s);for(let l in s){l=l.length>150?l.substr(l.length-149):l;const v=s[l];typeof v=="number"?k[l]=v:typeof v=="boolean"?k[l]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${v.length}`),o[l]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(o[l]=v)}return{properties:o,measurements:k}}e.validateTelemetryData=t;const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(c){if(!c)return"none";const o=(0,O.getRemoteName)(c);return a.has(o)?o:"other"}e.cleanRemoteAuthority=m;function y(c,o,k=0,s){if(!!c)for(const l of Object.getOwnPropertyNames(c)){const v=c[l],S=s?s+l:l;Array.isArray(v)?o[S]=(0,n.safeStringify)(v):v instanceof Date?o[S]=v.toISOString():(0,A.isObject)(v)?k<2?y(v,o,k+1,S+"."):o[S]=(0,n.safeStringify)(v):o[S]=v}}function P(c,o){const k=c.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(k)||s}e.isInternalTelemetry=P;function g(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=g;function i(c,o){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let k=c;const s=[];for(const E of o)for(;;){const W=E.exec(c);if(!W)break;s.push([W.index,E.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(k="";;){const E=v.exec(c);if(!E)break;const W=s.some(([G,Y])=>E.index<Y&&G<v.lastIndex);!l.test(E[0])&&!W&&(k+=c.substring(S,E.index)+"<REDACTED: user-file-path>",S=v.lastIndex)}return S<c.length&&(k+=c.substr(S)),k}function u(c){if(!c)return c;const o=c.toLowerCase(),k=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of k)if(s.regex.test(o))return`<REDACTED: ${s.label}>`;return c}function r(c,o){return(0,n.cloneAndChange)(c,k=>{if(k instanceof h)return k.value;if(typeof k=="string"){let s=k.replaceAll("%20"," ");s=i(s,o);for(const l of o)s=s.replace(l,"");return s=u(s),s}})}e.cleanData=r}),define(Pe[174],Ae([1,0,13,90,24,20,2,10,51,52]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,n.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=L;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(c){const o=c.manifest?c.manifest.version:c.version,k=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new f(c.identifier,o,k)}static parse(c){const o=D.exec(c);return o&&o[1]&&o[2]?new f({id:o[1]},o[2],o[4]||void 0):null}constructor(c,o,k="undefined"){this.version=o,this.targetPlatform=k,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof f?L(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=f;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const c=b.exec(r);return c&&c[1]?[t(c[1]),c[2]]:[t(r),void 0]}e.getIdAndVersion=p;function d(r,c){return`${r}.${c}`}e.getExtensionId=d;function t(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function a(r,c){return t(d(r??C.UNDEFINED_PUBLISHER,c))}e.getGalleryExtensionId=a;function m(r,c){const o=[],k=s=>{for(const l of o)if(l.some(v=>L(c(v),c(s))))return l;return null};for(const s of r){const l=k(s);l?l.push(s):o.push([s])}return o}e.groupByExtension=m;function y(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function P(r){return{id:new h.TelemetryTrustedValue(r.identifier.id),name:new h.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function g(r,c){const o=[],k=c.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const s=k.shift();if(s&&o.every(l=>!L(l.identifier,{id:s}))){const l=r.filter(v=>L(v.identifier,{id:s}));l.length===1&&(o.push(l[0]),k.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=g;async function i(r,c){if(!F.isLinux)return!1;let o;try{o=(await r.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){c.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(s))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,c){const o=await i(r,c),k=(0,A.getTargetPlatform)(o?"alpine":F.platform,w.arch);return c.debug("ComputeTargetPlatform:",k),k}e.computeTargetPlatform=u}),define(Pe[175],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(O){return[...O.entries()]}e.serializeEnvironmentVariableCollection=n;function A(O){return new Map(O)}e.deserializeEnvironmentVariableCollection=A;function C(O){return Array.from(O.entries()).map(R=>[R[0],n(R[1].map)])}e.serializeEnvironmentVariableCollections=C;function F(O){return new Map(O.map(R=>[R[0],{map:A(R[1])}]))}e.deserializeEnvironmentVariableCollections=F}),define(Pe[176],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,O=5){const R=F(w=>{const h=typeof w=="string"?w:w.data;let L=this.a.get(C);if(L){L.data.push(h);return}const D=setTimeout(()=>this.flushBuffer(C),O);L={data:[h],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),R.dispose()}},this.a.set(C,L)});return R}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.TerminalDataBufferer=n}),define(Pe[177],Ae([1,0,17,85,39,5,9,2,141,70,30]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(P){function g(i,u){let r=i.defaults;for(;C.ThemeIcon.isThemeIcon(r);){const c=p.getIcon(r.id);if(!c)return;r=c.defaults}return r}P.getDefinition=g})(D=e.IconContribution||(e.IconContribution={}));var f;(function(P){function g(u){return{weight:u.weight,style:u.style,src:u.src.map(r=>({format:r.format,location:r.location.toString()}))}}P.toJSONObject=g;function i(u){const r=c=>(0,O.isString)(c)?c:void 0;if(u&&Array.isArray(u.src)&&u.src.every(c=>(0,O.isString)(c.format)&&(0,O.isString)(c.location)))return{weight:r(u.weight),style:r(u.style),src:u.src.map(c=>({format:c.format,location:R.URI.parse(c.location)}))}}P.fromJSONObject=i})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new F.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,i,u,r){const c=this.b[g];if(c){if(u&&!c.description){c.description=u,this.d.properties[g].markdownDescription=`${u} $(${g})`;const s=this.e.enum.indexOf(g);s!==-1&&(this.e.enumDescriptions[s]=u),this.a.fire()}return c}const o={id:g,description:u,defaults:i,deprecationMessage:r};this.b[g]=o;const k={$ref:"#/definitions/icons"};return r&&(k.deprecationMessage=r),u&&(k.markdownDescription=`${u}: $(${g})`),this.d.properties[g]=k,this.e.enum.push(g),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,i){const u=this.f[g];return u||(this.f[g]=i,this.a.fire(),i)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(c,o)=>c.id.localeCompare(o.id),i=c=>{for(;C.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(c=>this.b[c]);for(const c of r.filter(o=>!!o.description).sort(g))u.push(`|<i class="${i(c)}"></i>|${c.id}|${C.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const c of r.filter(o=>!C.ThemeIcon.isThemeIcon(o.defaults)).sort(g))u.push(`|<i class="${i(c)}"></i>|${c.id}|`);return u.join(`
`)}}const p=new b;L.Registry.add(e.Extensions.IconContribution,p);function d(P,g,i,u){return p.registerIcon(P,g,i,u)}e.registerIcon=d;function t(){return p}e.getIconRegistry=t;function a(){const P=(0,A.getCodiconFontCharacters)();for(const g in P){const i="\\"+P[g].toString(16);p.registerIcon(g,{fontCharacter:i})}}a(),e.iconsSchemaId="vscode://schemas/icons";const m=L.Registry.as(h.Extensions.JSONContribution);m.registerSchema(e.iconsSchemaId,p.getIconSchema());const y=new n.RunOnceScheduler(()=>m.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{y.isScheduled()||y.schedule()}),e.widgetClose=d("widget-close",A.Codicon.close,(0,w.localize)(2,null)),e.gotoPreviousLocation=d("goto-previous-location",A.Codicon.arrowUp,(0,w.localize)(3,null)),e.gotoNextLocation=d("goto-next-location",A.Codicon.arrowDown,(0,w.localize)(4,null)),e.syncing=C.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=C.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(Pe[178],Ae([1,0,5,42,3,14]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var O;(function(d){d.Http="http",d.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=D;function f(d,t,a,m){if(a===1)return!1;if(a===2&&D(t)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(y?.length===4&&parseInt(y[1])>=18)return!1}return d<1024}e.isPortPrivileged=f;class b{constructor(t,a,m){this.remoteAddress=t,this.localAddress=a,this.b=m,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let p=class{constructor(t,a){this.i=t,this.j=a,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],a=Array.from(this.d.values());for(const m of a){const y=Array.from(m.values());for(const P of y){const g=await P.value;g&&t.push(g)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:a}of t.values())await a.then(m=>m?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,a,m,y,P){this.o(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:m,privacy:y,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(D(t)||L(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const m=this.q(t,a);if(m)return++m.refcount,m.value}openTunnel(t,a,m,y,P,g=!1,i,u){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${P}.`),!t)return;if(a||(a="localhost"),y||(y=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(t,a,m,y,P,g,i,u);return r?r.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(c);return(c.tunnelRemoteHost!==a||c.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.d.get(t.tunnelRemoteHost);if(a){const m=a.get(t.tunnelRemotePort);m&&(m.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,m))}}}}async n(t,a,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const y=m.value.then(async P=>{P&&(await P.dispose(!0),this.b.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(a),y}}async closeTunnel(t,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const m=this.d.get(t);if(m&&m.has(a)){const y=m.get(a);y.refcount=0,await this.n(t,a,y)}}o(t,a,m){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(a,{refcount:1,value:m})}async p(t,a){const m=this.d.get(t);m&&(await m.get(a)||m.delete(a),m.size===0&&this.d.delete(t))}q(t,a){const m=[t];L(t)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):D(t)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const y=m.map(P=>this.d.get(P));for(const P of y){const g=P?.get(a);if(g)return g}}canTunnel(t){return!!h(t)}s(t,a,m,y,P,g,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${y}.`);const u=m;this.h.add(u);const r=y===void 0?m:y,c={elevationRequired:P?this.isPortPrivileged(r):!1},o={remoteAddress:{host:a,port:m},localAddressPort:y,privacy:g,public:g?g!==R.Private:void 0,protocol:i},k=t.forwardPort(o,c);return k?(this.o(a,m,k),k.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(u)})):this.h.delete(u),k}};p=je([Ve(0,F.ILogService),Ve(1,A.IConfigurationService)],p),e.AbstractTunnelService=p}),define(Pe[179],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var A;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Pe[180],Ae([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(w){return w.scheme!==n.Schemas.file&&w.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=A;function C(w){if(w.folders.length)return w.folders.every(h=>A(h.uri))?w.folders[0].uri:void 0;if(w.configuration&&A(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=C;function F(w){return C(w)?.scheme}e.getVirtualWorkspaceScheme=F;function O(w){return C(w)?.authority}e.getVirtualWorkspaceAuthority=O;function R(w){return C(w)!==void 0}e.isVirtualWorkspace=R}),define(Pe[53],Ae([1,0,142,19,48,22,2,3,15]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function h(c){const o=c;return typeof o?.id=="string"&&O.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=h;function L(c){return typeof c?.id=="string"&&!h(c)&&!f(c)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(c,o){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,A.basename)(c)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const k=c;return k.configuration?{id:k.id,configPath:k.configuration}:k.folders.length===1?{id:k.id,uri:k.folders[0].uri}:{id:k.id}}e.toWorkspaceIdentifier=D;function f(c){const o=c;return typeof o?.id=="string"&&O.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=f;function b(c){const o=c;if(o?.uri)return{id:o.id,uri:O.URI.revive(o.uri)};const k=c;if(k?.configPath)return{id:k.id,configPath:O.URI.revive(k.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=b;var p;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function d(c){const o=c;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=d;function t(c){const o=c;return!!(o&&typeof o=="object"&&O.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=t;class a{constructor(o,k,s,l,v){this.h=o,this.j=s,this.k=l,this.l=v,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=k}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class m{constructor(o,k){this.raw=k,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,F.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function y(c){return new m({uri:c,index:0,name:(0,F.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(c,o){return F.extUriBiasedIgnorePathCase.isEqualOrParent(c,o.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function g(c){let o;return O.URI.isUri(c)?o=c:o=c.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=g,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function u(c,o){return!P(c,o)&&!g(c)}e.isSavedWorkspace=u;function r(c){return(typeof c=="string"?(0,A.extname)(c):(0,F.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Pe[54],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Pe[37],Ae([1,0,15,22,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class F{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(R=>{const w=this.b.get(R.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(R,w){w===null?this.b.delete(R.scheme):this.b.set(R.scheme,w)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=F,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Pe[181],Ae([1,0,145,14,167,27]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let O=class extends C.LogService{constructor(w,h,L){const D=L.remote.isRemote?"remoteexthost":w?"workerexthost":"exthost",f=L.remote.isRemote?(0,n.localize)(0,null):w?(0,n.localize)(1,null):(0,n.localize)(2,null);super(h.createLogger(D,{name:f}))}};O=je([Ve(1,A.ILoggerService),Ve(2,F.IExtHostInitDataService)],O),e.ExtHostLogService=O}),define(Pe[182],Ae([1,0,17]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(O,R,w){this.h=new Map,this.a=O,this.b=R,this.c=w,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(h=>(this.f=h,this)),this.g=this.c.onDidChangeStorage(h=>{h.shared===this.b&&h.key===this.a&&(this.f=h.value)}),this.i=new n.RunOnceScheduler(()=>{const h=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of h.values())L.complete()}catch(L){for(const D of h.values())D.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,O])=>O!==void 0).map(([O])=>O)}get whenReady(){return this.d}get(O,R){let w=this.f[O];return typeof w>"u"&&(w=R),w}update(O,R){this.f[O]=R;const w=this.h.get(O);if(w!==void 0)return w.p;const h=new n.DeferredPromise;return this.h.set(O,h),this.i.isScheduled()||this.i.schedule(),h.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class C extends A{setKeysForSync(O){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},O)}constructor(O,R){super(O.identifier.value,!0,R),this.j=O}}e.ExtensionGlobalMemento=C}),define(Pe[183],Ae([1,0,5,2]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(O){this.c=O,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(O,R,w,h){const D=this.c.getNotebookDocument(A.URI.revive(O)).acceptModelChanged(R.value,w,h);this.b.fire(D)}$acceptDirtyStateChanged(O,R){this.c.getNotebookDocument(A.URI.revive(O)).acceptDirty(R)}$acceptModelSaved(O){const R=this.c.getNotebookDocument(A.URI.revive(O));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(Pe[18],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class A{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[184],Ae([1,0,24,5]),function(ee,e,n,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class F{constructor(R,w){C.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(R.identifier),Je(this,C,w,"f"),Le(this,C,"f").onDidChangePassword(h=>{h.extensionId===this.a&&this.b.fire({key:h.key})})}get(R){return Le(this,C,"f").get(this.a,R)}store(R,w){return Le(this,C,"f").store(this.a,R,w)}delete(R){return Le(this,C,"f").delete(this.a,R)}}e.ExtensionSecrets=F,C=new WeakMap}),define(Pe[71],Ae([1,0,3,178,5,18]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var O;(function(w){function h(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:D.protocol}}w.fromApiTunnel=h;function L(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==A.TunnelPrivacyId.ConstantPrivate&&D.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}w.fromServiceTunnel=L})(O=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let R=class{constructor(h){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(h){return h}async openTunnel(h,L){}async getTunnels(){return[]}async setTunnelFactory(h){return{dispose:()=>{}}}registerPortsAttributesProvider(h,L){return{dispose:()=>{}}}async $providePortAttributes(h,L,D,f,b){return[]}async $forwardPort(h,L){}async $closeTunnel(h){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=je([Ve(0,F.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Pe[55],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class A{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=O=>O,this.transformOutgoing=O=>O,this.transformOutgoingURI=O=>O,this.transformOutgoingScheme=O=>O)}}e.URITransformerService=A}),define(Pe[185],Ae([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(w){let h=this.buffers.indexOf(w);return h<0&&(h=this.buffers.length,this.buffers.push(w)),h}}function C(R,w){if(w.serializeBuffersForPostMessage){const h=new A,L=(b,p)=>{if(p instanceof ArrayBuffer){const d=h.add(p);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(p)){const d=F(p);if(d){const t=h.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:t,view:{type:d,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},D=JSON.stringify(R,L),f=h.buffers.map(b=>{const p=new Uint8Array(b);return n.VSBuffer.wrap(p)});return{message:D,buffers:f}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=C;function F(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function O(R,w){const h=w.map(f=>{const b=new ArrayBuffer(f.byteLength);return new Uint8Array(b).set(f.buffer),b}),L=w.length?(f,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:d}=p,t=h[d];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(R,L),arrayBuffers:h}}e.deserializeWebviewMessage=O}),define(Pe[97],Ae([1,0,152,9,2,6,3,30,43,15,40,126,29]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function d(le){const X=le;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.isEditorPaneWithSelection=d;function t(le,X,T){for(const V of T.visibleEditorPanes)if(V.group.id===X&&le.matches(V.input))return V.getViewState()}e.findViewStateForEditor=t;function a(le){if(l(le))return!1;const X=le;return C.URI.isUri(X?.resource)}e.isResourceEditorInput=a;function m(le){if(l(le))return!1;const X=le;return X?.original!==void 0&&X.modified!==void 0}e.isResourceDiffEditorInput=m;function y(le){if(l(le)||m(le))return!1;const X=le;return X?.primary!==void 0&&X.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function P(le){if(l(le))return!1;const X=le;return X?X.resource===void 0||X.resource.scheme===h.Schemas.untitled||X.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;const g=/Untitled-\d+/;function i(le){return le.scheme===h.Schemas.untitled&&le.path.length>1&&!g.test(le.path)}e.isUntitledWithAssociatedResource=i;function u(le){if(l(le))return!1;const X=le;return C.URI.isUri(X?.base?.resource)&&C.URI.isUri(X?.input1?.resource)&&C.URI.isUri(X?.input2?.resource)&&C.URI.isUri(X?.result?.resource)}e.isResourceMergeEditorInput=u;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var c;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(X,T){let V=this.a.get(X);return V||(V={source:X,label:T},this.a.set(X,V)),V.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.SaveSourceRegistry=new o;var k;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors"})(k=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends F.Disposable{}e.AbstractEditorInput=s;function l(le){return le instanceof s}e.isEditorInput=l;function v(le){const X=le;return C.URI.isUri(X?.preferredResource)}function S(le){const X=le;return l(X?.primary)&&l(X?.secondary)}e.isSideBySideEditorInput=S;function E(le){const X=le;return l(X?.modified)&&l(X?.original)}e.isDiffEditorInput=E;function W(le,X,T,V,ce){return ke(V,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const me={...T,limits:{size:Number.MAX_VALUE}};le.openEditor(X,me)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=W;function G(le){return l(le?.editor)}e.isEditorInputWithOptions=G;function Y(le){const X=le;return G(le)&&X?.group!==void 0}e.isEditorInputWithOptionsAndGroup=Y;function J(le){const X=le;return typeof X?.groupId=="number"&&l(X.editor)}e.isEditorIdentifier=J;var q;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(X,T){if(!X)return;if(u(X))return e.EditorResourceAccessor.getOriginalUri(X.result,T);if(T?.supportSideBySide){const{primary:ce,secondary:me}=this.a(X);if(ce&&me){if(T?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:T.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:T.filterByScheme})};if(T?.supportSideBySide===$.ANY)return this.getOriginalUri(ce,{filterByScheme:T.filterByScheme})??this.getOriginalUri(me,{filterByScheme:T.filterByScheme});X=T.supportSideBySide===$.PRIMARY?ce:me}}if(m(X)||y(X)||u(X))return;const V=v(X)?X.preferredResource:X.resource;return!V||!T||!T.filterByScheme?V:this.b(V,T.filterByScheme)}a(X){return S(X)||y(X)?{primary:X.primary,secondary:X.secondary}:E(X)||m(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,T){if(!X)return;if(u(X))return e.EditorResourceAccessor.getCanonicalUri(X.result,T);if(T?.supportSideBySide){const{primary:ce,secondary:me}=this.a(X);if(ce&&me){if(T?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:T.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:T.filterByScheme})};if(T?.supportSideBySide===$.ANY)return this.getCanonicalUri(ce,{filterByScheme:T.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:T.filterByScheme});X=T.supportSideBySide===$.PRIMARY?ce:me}}if(m(X)||y(X)||u(X))return;const V=X.resource;return!V||!T||!T.filterByScheme?V:this.b(V,T.filterByScheme)}b(X,T){if(Array.isArray(T)){if(T.some(V=>X.scheme===V))return X}else if(T===X.scheme)return X}}e.EditorResourceAccessor=new z;var j;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class he{constructor(){this.c=new Map,this.d=new Map}start(X){const T=this.a=X.get(O.IInstantiationService);for(const[V,ce]of this.c)this.e(V,ce,T);this.c.clear()}e(X,T,V){const ce=V.createInstance(T);this.d.set(X,ce)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(X,T){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,T,this.a):this.c.set(X,T),(0,F.toDisposable)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new he);async function we(le,X,T){return!le||!le.length?[]:await Promise.all(le.map(async V=>{const ce=C.URI.revive(V.fileUri);if(!ce){T.info("Cannot resolve the path because it is not valid.",V);return}if(!await X.canHandleResource(ce)){T.info("Cannot resolve the path because it cannot be handled",V);return}let Fe=V.exists,be=V.type;if(typeof Fe!="boolean"||typeof be!="number")try{be=(await X.stat(ce)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Fe=!0}catch(Ie){T.error(Ie),Fe=!1}if(!Fe&&V.openOnlyIfExists){T.info("Cannot resolve the path because it does not exist",V);return}if(be===w.FileType.Directory){T.info("Cannot resolve the path because it is a directory",V);return}const Ee={...V.options,pinned:!0};return Fe?{resource:ce,options:Ee}:{resource:ce,options:Ee,forceUntitled:!0}}))}e.pathsToEditors=we;var ie;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(ie=e.EditorsOrder||(e.EditorsOrder={}));function oe(le){const X=le;if(!X)return!1;const T=X;if(T.modified)return oe(T.modified);const V=X;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.isTextEditorViewState=oe;function de(le){return(0,L.isErrorWithActions)(le)}e.isEditorOpenError=de;function ke(le,X,T){const V=(0,L.createErrorWithActions)(le,X);return V.forceMessage=T?.forceMessage,V.forceSeverity=T?.forceSeverity,V.allowDialog=T?.allowDialog,V}e.createEditorOpenError=ke}),define(Pe[186],Ae([1,0,5,153,3,6,28,30,16,63,23,85,177]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",D.Codicon.window,(0,A.localize)(0,null));var b;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function d(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=d;class t extends F.Disposable{constructor(){super(...arguments),this.c=this.D(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.D(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,w.flatten)([...this.g.values()])}registerViewContainer(c,o,k){const s=this.get(c.id);if(s)return s;const l=c;return l.openCommandActionDescriptor=k?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,O.getOrSet)(this.g,o,[]).push(l),k?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:o}),l}deregisterViewContainer(c){for(const o of this.g.keys()){const k=this.g.get(o),s=k?.indexOf(c);if(s!==-1){k?.splice(s,1),k.length===0&&this.g.delete(o),this.f.fire({viewContainer:c,viewContainerLocation:o});return}}}get(c){return this.all.filter(o=>o.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(k=>k?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(o=>this.getViewContainerLocation(o)===c)}}R.Registry.add(b.ViewContainersRegistry,new t);var a;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function m(r,c){const o=r.group??a.More,k=c.group??a.More;return o!==k?o.localeCompare(k):(r.order??5)-(c.order??5)}class y extends F.Disposable{constructor(){super(...arguments),this.c=this.D(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.D(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.D(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.D(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new h.SetMap}registerViews(c,o){this.registerViews2([{views:c,viewContainer:o}])}registerViews2(c){c.forEach(({views:o,viewContainer:k})=>this.l(o,k)),this.c.fire(c)}deregisterViews(c,o){const k=this.m(c,o);k.length&&this.f.fire({views:k,viewContainer:o})}moveViews(c,o){for(const k of this.j.keys())if(k!==o){const s=this.m(c,k);s.length&&(this.l(s,o),this.g.fire({views:s,from:k,to:o}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const o of this.i){const k=(this.j.get(o)||[]).filter(s=>s.id===c)[0];if(k)return k}return null}getViewContainer(c){for(const o of this.i)if((this.j.get(o)||[]).filter(s=>s.id===c)[0])return o;return null}registerViewWelcomeContent(c,o){return this.k.add(c,o),this.h.fire(c),(0,F.toDisposable)(()=>{this.k.delete(c,o),this.h.fire(c)})}registerViewWelcomeContent2(c,o){const k=new Map;for(const[s,l]of o)this.k.add(c,l),k.set(s,(0,F.toDisposable)(()=>{this.k.delete(c,l),this.h.fire(c)}));return this.h.fire(c),k}getViewWelcomeContent(c){const o=[];return this.k.forEach(c,k=>o.push(k)),o.sort(m)}l(c,o){let k=this.j.get(o);k||(k=[],this.j.set(o,k),this.i.push(o));for(const s of c){if(this.getView(s.id)!==null)throw new Error((0,A.localize)(1,null,s.id));k.push(s)}}m(c,o){const k=this.j.get(o);if(!k)return[];const s=[],l=[];for(const v of k)c.includes(v)?s.push(v):l.push(v);return s.length&&(l.length?this.j.set(o,l):(this.j.delete(o),this.i.splice(this.i.indexOf(o),1))),s}}R.Registry.add(b.ViewsRegistry,new y),e.IViewsService=(0,C.createDecorator)("viewsService"),e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var P;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(P=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,o){this.c=!1,this.d=!1,(0,L.mixin)(this,c),this.d=!!o,this.resolve=async k=>{if(o&&!this.c){const s=await o(k);s&&(this.tooltip=this.tooltip??s.tooltip,this.command=this.command??s.command)}k.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class u extends Error{constructor(c){super((0,A.localize)(2,null,c))}}e.NoTreeViewError=u}),define(Pe[187],Ae([1,0,5,17,154]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,w,h,L){const D={command:R};if(w&&Object.keys(w).length>0&&(D.arguments=w),this.s("request",D),typeof L=="number"){const f=setTimeout(()=>{clearTimeout(f);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:R,message:(0,C.localize)(0,null,L,R)};b(p)}},L)}return h&&this.f.set(D.seq,h),D.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,w){return R.type!=="event"||w.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,A.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const w=R,h=this.f.get(w.request_seq);h&&(this.f.delete(w.request_seq),h(w));break}}}}s(R,w){w.type=R,w.seq=this.d++,this.sendMessage(w)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((w,h)=>R.set(h,w)),await(0,A.timeout)(500),R.forEach((w,h)=>{w({type:"response",seq:0,request_seq:h,success:!1,command:"canceled",message:"canceled"}),this.f.delete(h)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=F}),define(Pe[188],Ae([1,0,155,31,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const F=f=>n.localize(51,null,f);e.debuggerDisabledMessage=F,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var O;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(O=e.State||(e.State={}));function R(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var w;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var h;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(h=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,C.createDecorator)("debugService");var D;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Pe[189],Ae([1,0,13,2,19,23,15,44,21,16]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function D(s,l,v){return s.replace(L,function(S,E){return l&&E.length>0&&E[0]!=="_"?S:v&&v.hasOwnProperty(E)?v[E]:S})}e.formatPII=D;function f(s){const l={};for(const v of Object.keys(s))v.startsWith("!")||(l[v]=s[v]);return l}e.filterExceptionsFromTelemetry=f;function b(s){return s.configuration.request==="attach"&&!p(s)&&(!s.parentSession||b(s.parentSession))}e.isSessionAttach=b;function p(s){let l=s.configuration.type;if(!!l)return l==="vslsShare"&&(l=s.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(l,"extensionhost")||(0,n.equalsIgnoreCase)(l,"pwa-extensionhost")?s:s.parentSession?p(s.parentSession):void 0}e.getExtensionHostDebugSession=p;function d(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=d;function t(s,l,v){let S,E=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=W.exec(s);){const Y=G.index+1,J=Y+G[0].length;if(Y<=l&&J>=v){S=G[0],E=Y;break}}if(S){const Y=/\w+/g;let J=null;for(;(J=Y.exec(S))&&!(J.index+1+E+J[0].length>=v););J&&(S=S.substring(0,Y.lastIndex))}return S?{start:E,end:E+S.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function a(s,l,v,S){if(s.evaluatableExpressionProvider.has(l)){const E=s.evaluatableExpressionProvider.ordered(l),W=(0,h.coalesce)(await Promise.all(E.map(async G=>{try{return await G.provideEvaluatableExpression(l,v,S??w.CancellationToken.None)}catch{return}})));if(W.length>0){let G=W[0].expression;const Y=W[0].range;return G||(G=l.getLineContent(v.lineNumber).substring(Y.startColumn-1,Y.endColumn-1)),{range:Y,matchingExpression:G}}}else{const E=l.getLineContent(v.lineNumber),{start:W,end:G}=t(E,v.column,v.column),Y=E.substring(W-1,G);return{matchingExpression:Y,range:new R.Range(v.lineNumber,W,v.lineNumber,W+Y.length)}}return null}e.getEvaluatableExpressionAtPosition=a;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function y(s){return!!(s&&s.match(m))}e.isUri=y;function P(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(y(s.path))return A.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return A.URI.file(s.path)}return s.path}function g(s){if(typeof s.path=="object"){const l=A.URI.revive(s.path);if(l)return l.scheme===O.Schemas.file?l.fsPath:l.toString()}return s.path}function i(s,l){const v=l?P:g,S=(0,F.deepClone)(s);return r(S,(E,W)=>{E&&W&&(W.path=v(W))}),S}e.convertToDAPaths=i;function u(s,l){const v=l?P:g,S=(0,F.deepClone)(s);return r(S,(E,W)=>{!E&&W&&(W.path=v(W))}),S}e.convertToVSCPaths=u;function r(s,l){switch(s.type){case"event":{const v=s;switch(v.event){case"output":l(!1,v.body.source);break;case"loadedSource":l(!1,v.body.source);break;case"breakpoint":l(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=s;switch(v.command){case"setBreakpoints":l(!0,v.arguments.source);break;case"breakpointLocations":l(!0,v.arguments.source);break;case"source":l(!0,v.arguments.source);break;case"gotoTargets":l(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(S=>l(!1,S));break;default:break}break}case"response":{const v=s;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(S=>l(!1,S.source));break;case"loadedSources":v.body.sources.forEach(S=>l(!1,S));break;case"scopes":v.body.scopes.forEach(S=>l(!1,S.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(S=>l(!1,S.source));break;case"setBreakpoints":v.body.breakpoints.forEach(S=>l(!1,S.source));break;case"disassemble":v.body?.instructions.forEach(E=>l(!1,E.location));break;default:break}break}}}function c(s){return s.filter(l=>!l.presentation?.hidden).sort((l,v)=>l.presentation?v.presentation?l.presentation.group?v.presentation.group?l.presentation.group!==v.presentation.group?l.presentation.group.localeCompare(v.presentation.group):o(l.presentation.order,v.presentation.order):-1:v.presentation.group?1:o(l.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=c;function o(s,l){return typeof s!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:s-l}async function k(s,l){const v=s.getValue("debug.saveBeforeStart",{overrideIdentifier:l.activeTextEditorLanguageId});if(v!=="none"&&(await l.saveAll(),v==="allEditorsInActiveGroup")){const S=l.activeEditorPane;S&&S.input.resource?.scheme===O.Schemas.untitled&&await l.save({editor:S.input,groupId:S.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=k}),define(Pe[72],Ae([1,0,25,36,190,65,15,19,20,31]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var f;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var t;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(t=e.SelectionStateType||(e.SelectionStateType={}));var a;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var m;(function($){$.scheme=O.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),he=7;function we(X,T){const V=T.toString(he),me=`${V.length<z.length?z[V.length-1]:"z"}${V}s${(0,n.encodeBase64)(n.VSBuffer.fromString(X.scheme),!0,!0)}`;return X.with({scheme:$.scheme,fragment:me})}$.generate=we;function ie(X){if(X.scheme!==$.scheme)return;const T=X.fragment.indexOf("s");if(T<0)return;const V=parseInt(X.fragment.substring(0,T).replace(j,""),he),ce=(0,n.decodeBase64)(X.fragment.substring(T+1)).toString();if(!isNaN(V))return{handle:V,notebook:X.with({scheme:ce,fragment:null})}}$.parse=ie;function oe(X,T){return X.with({scheme:O.Schemas.vscodeNotebookCellOutput,fragment:`op${T??""},${X.scheme!==O.Schemas.file?X.scheme:""}`})}$.generateCellOutputUri=oe;function de(X){if(X.scheme!==O.Schemas.vscodeNotebookCellOutput)return;const T=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!T)return;const V=T[1]&&T[1]!==""?T[1]:void 0,ce=T[2];return{outputId:V,notebook:X.with({scheme:ce||O.Schemas.file,fragment:null})}}$.parseCellOutputUri=de;function ke(X,T,V){return $.generate(X,T).with({scheme:V})}$.generateCellPropertyUri=ke;function le(X,T){if(X.scheme===T)return $.parse(X.with({scheme:$.scheme}))}$.parseCellPropertyUri=le})(m=e.CellUri||(e.CellUri={}));const y=$=>w.isWindows?$.replace(/\//g,"\\"):$;class P{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(z)].map(he=>({pattern:he,matches:A.parse(y(he))}))}sort(z){const j=new Map(C.Iterable.map(z,we=>[we,y(we)]));let he=[];for(const{matches:we}of this.d)for(const[ie,oe]of j)if(we(oe)){he.push(ie),j.delete(ie);break}return j.size&&(he=he.concat([...j.keys()].sort((we,ie)=>this.e.indexOf(we)-this.e.indexOf(ie)))),he}prioritize(z,j){const he=this.f(z);if(he===-1){this.d.unshift({pattern:z,matches:A.parse(y(z))});return}const we=new Set(j.map(oe=>this.f(oe,he)));we.delete(-1);const ie=Array.from(we).sort();this.d.splice(he+1,0,...ie.map(oe=>this.d[oe]));for(let oe=ie.length-1;oe>=0;oe--)this.d.splice(ie[oe],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,j=this.d.length){const he=y(z);for(let we=0;we<j;we++)if(this.d[we].matches(he))return we;return-1}}e.MimeTypeDisplayOrder=P;function g($,z,j,he=(we,ie)=>we===ie){const we=[];function ie(ke,le,X){if(le===0&&X.length===0)return;const T=we[we.length-1];T&&T.start+T.deleteCount===ke?(T.deleteCount+=le,T.toInsert.push(...X)):we.push({start:ke,deleteCount:le,toInsert:X})}let oe=0,de=0;for(;;){if(oe===$.length){ie(oe,0,z.slice(de));break}if(de===z.length){ie(oe,$.length-oe,[]);break}const ke=$[oe],le=z[de];if(he(ke,le)){oe+=1,de+=1;continue}j(le)?(ie(oe,1,[]),oe+=1):(ie(oe,0,[le]),de+=1)}return we}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new h.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function($){$.default="default",$.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u($){const z=$;return!!((typeof z.include=="string"||A.isRelativePattern(z.include))&&(typeof z.exclude=="string"||A.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=u;function r($,z,j){if(Array.isArray($.viewType)&&$.viewType.indexOf(z)>=0||$.viewType===z)return!0;if($.filenamePattern){const he=u($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,we=u($.filenamePattern)?$.filenamePattern.exclude:void 0;if(A.match(he,(0,R.basename)(j.fsPath).toLowerCase()))return!(we&&A.match(we,(0,R.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",textOutputLineLimit:"notebook.output.textLineLimit",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var c;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(z){return`${o.d}${z}`}static parse(z){if(z.startsWith(o.d))return z.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function k($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=k;const s=new TextDecoder;function l($){const z=[];let j=!1;for(const he of $)(z.length===0||j)&&(z.push(he),j=!0);return W(z),U(n.VSBuffer.concat(z.map(he=>n.VSBuffer.wrap(he))))}e.compressOutputItemStreams=l;const v=`${String.fromCharCode(27)}[A`,S=v.split("").map($=>$.charCodeAt(0)),E=10;function W($){$.forEach((z,j)=>{if(j===0||z.length<v.length)return;const he=$[j-1],we=z.subarray(0,v.length);if(we[0]===S[0]&&we[1]===S[1]&&we[2]===S[2]){const ie=he.lastIndexOf(E);if(ie===-1)return;$[j-1]=he.subarray(0,ie),$[j]=z.subarray(v.length)}})}function G($){let z=$;do $=z,z=$.replace(/[^\n]\x08/gm,"");while(z.length<$.length);return $}function Y($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const z=$.match(/^(.*)\r+/m)[1];let j=$.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return $}const J="\b".charCodeAt(0),q="\r".charCodeAt(0);function U($){return!$.buffer.includes(J)&&!$.buffer.includes(q)?$:n.VSBuffer.fromString(Y(G(s.decode($.buffer))))}}),define(Pe[191],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(F){F.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class C{static fromExtHostTestItem(O,R,w=O.parent){if(O._isRoot)return new C([R]);const h=[O.id];for(let L=w;L&&L.id!==R;L=L.parent)h.push(L.id);return h.push(R),new C(h.reverse())}static isRoot(O){return!O.includes("\0")}static root(O){const R=O.indexOf("\0");return R===-1?O:O.slice(0,R)}static fromString(O){return new C(O.split("\0"))}static join(O,R){return new C([...O.path,R])}static joinToString(O,R){return O.toString()+"\0"+R}static parentId(O){const R=O.lastIndexOf("\0");return R===-1?void 0:O.slice(0,R)}static localId(O){const R=O.lastIndexOf("\0");return R===-1?O:O.slice(R+1)}static compare(O,R){return O===R?0:R.startsWith(O+"\0")?2:O.startsWith(R+"\0")?3:1}constructor(O,R=O.length){if(this.path=O,this.d=R,O.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let O=1;O<=this.d;O++)yield new C(this.path,O)}*idsToRoot(){for(let O=this.d;O>0;O--)yield new C(this.path,O)}compare(O){if(typeof O=="string")return C.compare(this.toString(),O);for(let R=0;R<O.d&&R<this.d;R++)if(O.path[R]!==this.path[R])return 1;return O.d>this.d?2:O.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let O=1;O<this.d;O++)this.c+="\0",this.c+=this.path[O]}return this.c}}e.TestId=C}),define(Pe[56],Ae([1,0,2,44,45]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var F;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(F=e.TestResultState||(e.TestResultState={}));var O;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable",s[s.SupportsContinuousRun=64]="SupportsContinuousRun"})(O=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=s=>"runId"in s;e.isStartControllerTests=R;var w;(function(s){s.serialize=l=>({range:l.range.toJSON(),uri:l.uri.toJSON()}),s.deserialize=l=>({range:A.Range.lift(l.range),uri:n.URI.revive(l.uri)})})(w=e.IRichLocation||(e.IRichLocation={}));var h;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(h=e.TestMessageType||(e.TestMessageType={}));var L;(function(s){s.serialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,location:l.location&&w.serialize(l.location)}),s.deserialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,location:l.location&&w.deserialize(l.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const D=(s,l)=>`${l?"s":"e"}${s}`;e.getMarkId=D;var f;(function(s){s.serialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&w.serialize(l.location)}),s.deserialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&w.deserialize(l.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(s){s.serialize=l=>l.type===0?L.serialize(l):f.serialize(l),s.deserialize=l=>l.type===0?L.deserialize(l):f.deserialize(l)})(b=e.ITestMessage||(e.ITestMessage={}));var p;(function(s){s.serializeWithoutMessages=l=>({state:l.state,duration:l.duration,messages:[]}),s.serialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(b.serialize)}),s.deserialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(b.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const d="\0",t=(s,l)=>s+d+l;e.namespaceTestTag=t;const a=s=>{const l=s.indexOf(d);return{ctrlId:s.slice(0,l),tagId:s.slice(l+1)}};e.denamespaceTestTag=a;var m;(function(s){s.serialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?.toJSON(),range:l.range?.toJSON()||null,description:l.description,error:l.error,sortText:l.sortText}),s.deserialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?n.URI.revive(l.uri):void 0,range:l.range?A.Range.lift(l.range):null,description:l.description,error:l.error,sortText:l.sortText})})(m=e.ITestItem||(e.ITestItem={}));var y;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(s){s.serialize=l=>({expand:l.expand,item:m.serialize(l.item)}),s.deserialize=l=>({controllerId:C.TestId.root(l.item.extId),expand:l.expand,item:m.deserialize(l.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=l=>{let v;return l.item&&(v={},l.item.label!==void 0&&(v.label=l.item.label),l.item.tags!==void 0&&(v.tags=l.item.tags),l.item.busy!==void 0&&(v.busy=l.item.busy),l.item.uri!==void 0&&(v.uri=l.item.uri?.toJSON()),l.item.range!==void 0&&(v.range=l.item.range?.toJSON()),l.item.description!==void 0&&(v.description=l.item.description),l.item.error!==void 0&&(v.error=l.item.error),l.item.sortText!==void 0&&(v.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:v}},s.deserialize=l=>{let v;return l.item&&(v={},l.item.label!==void 0&&(v.label=l.item.label),l.item.tags!==void 0&&(v.tags=l.item.tags),l.item.busy!==void 0&&(v.busy=l.item.busy),l.item.range!==void 0&&(v.range=l.item.range?A.Range.lift(l.item.range):null),l.item.description!==void 0&&(v.description=l.item.description),l.item.error!==void 0&&(v.error=l.item.error),l.item.sortText!==void 0&&(v.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:v}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(s,l)=>{l.expand!==void 0&&(s.expand=l.expand),l.item!==void 0&&(s.item=s.item?Object.assign(s.item,l.item):l.item)};e.applyTestItemUpdate=i;var u;(function(s){s.serializeWithoutMessages=l=>({...P.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(p.serializeWithoutMessages),retired:l.retired}),s.serialize=l=>({...P.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(p.serialize),retired:l.retired}),s.deserialize=l=>({...P.deserialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(p.deserialize),retired:!0})})(u=e.TestResultItem||(e.TestResultItem={}));var r;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(s){s.deserialize=l=>l.op===0?{op:l.op,item:P.deserialize(l.item)}:l.op===1?{op:l.op,item:g.deserialize(l.item)}:l.op===2?{op:l.op,uri:n.URI.revive(l.uri),docv:l.docv}:l,s.serialize=l=>l.op===0?{op:l.op,item:P.serialize(l.item)}:l.op===1?{op:l.op,item:g.serialize(l.item)}:l})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(l){const v=this.o();for(const S of l)switch(S.op){case 0:this.j(P.deserialize(S.item),v);break;case 1:this.k(g.deserialize(S.item),v);break;case 3:this.l(S.itemId,v);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}v.complete?.()}j(l,v){const S=C.TestId.parentId(l.item.extId)?.toString();let E;if(!S)E=this.p(l),this.f.add(E),this.d.set(l.item.extId,E);else if(this.d.has(S)){const W=this.d.get(S);W.children.add(l.item.extId),E=this.p(l,W),this.d.set(l.item.extId,E)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(l)}`);return}return v.add?.(E),l.expand===2&&this.g++,E}k(l,v){const S=this.d.get(l.extId);if(!!S)return l.expand!==void 0&&(S.expand===2&&this.g--,l.expand===2&&this.g++),(0,e.applyTestItemUpdate)(S,l),v.update?.(S),S}l(l,v){const S=this.d.get(l);if(!S)return;const E=C.TestId.parentId(S.item.extId)?.toString();E?this.d.get(E).children.delete(S.item.extId):this.f.delete(S);const W=[[l]];for(;W.length;)for(const G of W.pop()){const Y=this.d.get(G);Y&&(W.push(Y.children),this.d.delete(G),v.remove?.(Y,Y!==S),Y.expand===2&&this.g--)}}m(l){}updatePendingRoots(l){this.h+=l}o(){return{}}}e.AbstractIncrementalTestCollection=k}),define(Pe[73],Ae([1,0,17,5,6,49,56,45]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const h=(m,y)=>m===y,D=Object.entries({range:(m,y)=>m===y?!0:!m||!y?!1:m.equalsRange(y),busy:h,label:h,description:h,error:h,sortText:h,tags:(m,y)=>!(m.length!==y.length||m.some(P=>!y.includes(P)))}),f=(m,y)=>{let P;for(const[g,i]of D)i(m[g],y[g])||(P?P[g]=y[g]:P={[g]:y[g]});return P};class b extends C.Disposable{get root(){return this.m.root}constructor(y){super(),this.m=y,this.f=this.D(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.D(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.s(this.root,void 0)}set resolveHandler(y){this.h=y;for(const P of this.tree.values())this.G(P)}get resolveHandler(){return this.h}collectDiff(){const y=this.k;return this.k=[],y}pushDiff(y){switch(y.op){case 2:{for(const P of this.k)if(P.op===2&&P.uri===y.uri){P.docv=y.docv;return}break}case 1:{const P=this.k[this.k.length-1];if(P){if(P.op===1&&P.item.extId===y.item.extId){(0,O.applyTestItemUpdate)(P.item,y.item);return}if(P.op===0&&P.item.item.extId===y.item.extId){(0,O.applyTestItemUpdate)(P.item,y.item);return}}break}}this.k.push(y),this.f.isScheduled()||this.f.schedule()}expand(y,P){const g=this.tree.get(y);if(!!g){if((g.expandLevels===void 0||P>g.expandLevels)&&(g.expandLevels=P),g.expand===1){const i=this.I(g);return i.isOpen()?this.H(g,P-1):i.wait().then(()=>this.H(g,P-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,P-1)):this.H(g,P-1)}}dispose(){for(const y of this.tree.values())this.m.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(y,P){switch(P.op){case 3:this.L(R.TestId.joinToString(y.fullId,P.id));break;case 0:this.s(P.item,y);break;case 5:for(const g of P.ops)this.p(y,g);break;case 1:this.u(P.new,P.old,y.fullId.toString());break;case 2:this.G(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:P.update}});break;case 6:this.q(y.actual.uri);break;default:(0,F.assertNever)(P)}}q(y){y&&this.pushDiff({op:2,uri:y,docv:this.m.getDocumentVersion(y)})}s(y,P){const g=R.TestId.fromExtHostTestItem(y,this.root.id,P?.actual),i=this.m.getApiFor(y);i.parent&&i.parent!==P?.actual&&this.m.getChildren(i.parent).delete(y.id);let u=this.tree.get(g.toString());if(!u){u={fullId:g,actual:y,expandLevels:P?.expandLevels?P.expandLevels-1:void 0,expand:0},y.tags.forEach(this.w,this),this.tree.set(u.fullId.toString(),u),this.z(y,P),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:u.expand,item:this.m.toITestItem(y)}}),this.F(y,u,P);return}if(u.actual===y){this.C(y,u,P);return}if(u.actual.uri?.toString()!==y.uri?.toString())return this.L(g.toString()),this.s(y,P);const r=this.m.getChildren(u.actual),c=u.actual,o=f(this.m.toITestItem(c),this.m.toITestItem(y));this.m.getApiFor(c).listener=void 0,u.actual=y,u.expand=0,o&&(o.hasOwnProperty("tags")&&(this.u(y.tags,c.tags,g.toString()),delete o.tags),this.p(u,{op:4,update:o})),this.F(y,u,P);for(const[k,s]of r)this.m.getChildren(y).get(s.id)||this.L(R.TestId.joinToString(g,s.id));this.q(u.actual.uri)}u(y,P,g){const i=new Set(P.map(u=>u.id));for(const u of y)i.delete(u.id)||this.w(u);this.pushDiff({op:1,item:{extId:g,item:{tags:y.map(u=>(0,O.namespaceTestTag)(this.m.controllerId,u.id))}}}),i.forEach(this.y,this)}w(y){const P=this.j.get(y.id);P?P.refCount++:(this.j.set(y.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,O.namespaceTestTag)(this.m.controllerId,y.id)}}))}y(y){const P=this.j.get(y);P&&!--P.refCount&&(this.j.delete(y),this.pushDiff({op:7,id:(0,O.namespaceTestTag)(this.m.controllerId,y)}))}z(y,P){this.m.getApiFor(y).parent=P&&P.actual!==this.root?P.actual:void 0}C(y,P,g){this.z(y,g);const i=this.m.getApiFor(y);i.parent=g?.actual,i.listener=u=>this.p(P,u),this.G(P)}F(y,P,g){this.C(y,P,g);for(const[i,u]of this.m.getChildren(y))this.s(u,P)}G(y){let P;this.h?y.resolveBarrier?P=y.resolveBarrier.isOpen()?3:2:P=y.actual.canResolveChildren?1:0:P=0,P!==y.expand&&(y.expand=P,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:P}}),P===1&&y.expandLevels!==void 0&&this.I(y))}H(y,P){if(P<0)return;const g=[];for(const[i,u]of this.m.getChildren(y.actual)){const r=this.expand(R.TestId.joinToString(y.fullId,u.id),P);(0,n.isThenable)(r)&&g.push(r)}if(g.length)return Promise.all(g).then(()=>{})}I(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this.h){const u=new n.Barrier;return u.open(),u}y.expand=2,this.J(y);const P=y.resolveBarrier=new n.Barrier,g=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,u)};let i;try{i=this.h(y.actual===this.root?void 0:y.actual)}catch(u){g(u)}return(0,n.isThenable)(i)?i.catch(g).then(()=>{P.open(),this.G(y)}):(P.open(),this.G(y)),y.resolveBarrier}J(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}L(y){const P=this.tree.get(y);if(!P)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:y});const g=[P];for(;g.length;){const i=g.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const u of i.actual.tags)this.y(u.id);this.tree.delete(i.fullId.toString());for(const[u,r]of this.m.getChildren(i.actual))g.push(this.tree.get(R.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.g.fire(y)}}e.TestItemCollection=b;class p extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=p;class d extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class t extends Error{constructor(y,P,g){super(`TestItem with ID "${y}" is from controller "${P}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=t;const a=(m,y,P)=>{let g=new Map;return{get size(){return g.size},forEach(i,u){for(const r of g.values())i.call(u,r,this)},[Symbol.iterator](){return g.entries()},replace(i){const u=new Map,r=new Set(g.keys()),c={op:5,ops:[]};for(const o of i){if(!(o instanceof P))throw new d(o.id);const k=y(o).controllerId;if(k!==m.controllerId)throw new t(o.id,k,m.controllerId);if(u.has(o.id))throw new p(o.id);u.set(o.id,o),r.delete(o.id),c.ops.push({op:0,item:o})}for(const o of r.keys())c.ops.push({op:3,id:o});m.listener?.(c),g=u},add(i){if(!(i instanceof P))throw new d(i.id);g.set(i.id,i),m.listener?.({op:0,item:i})},delete(i){g.delete(i)&&m.listener?.({op:3,id:i})},get(i){return g.get(i)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=a}),define(Pe[98],Ae([1,0,73]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,C=(O,R)=>{const w={controllerId:R};return A.set(O,w),w};e.createPrivateApiFor=C;const F=O=>{const R=A.get(O);if(!R)throw new n.InvalidTestItemError(O?.id||"<unknown>");return R};e.getPrivateApiFor=F}),define(Pe[74],Ae([1,0,15,2]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(R,w){return R.scheme===n.Schemas.http||R.scheme===n.Schemas.https?R:(w&&w.authority&&w.isRemote&&R.scheme===n.Schemas.file&&(R=A.URI.from({scheme:n.Schemas.vscodeRemote,authority:w.authority,path:R.path})),A.URI.from({scheme:n.Schemas.https,authority:`${R.scheme}+${F(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=C;function F(R){return R.replace(/./g,w=>{const h=w.charCodeAt(0);return h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57?w:"-"+h.toString(16).padStart(4,"0")})}function O(R){return R.replace(/-([0-9a-f]{4})/g,(w,h)=>String.fromCharCode(parseInt(h,16)))}e.decodeAuthority=O}),define(Pe[192],Ae([1,0,5,6,74]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class F{constructor(R,w,h){this.d=R,this.e=w,this.f=h,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(w.onDidChangeVisibleTextEditors(()=>{const L=w.getVisibleTextEditors();for(const D of this.c.values())L.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,w,h,L,D){let f;for(const y of this.e.getVisibleTextEditors(!0))if(y.value===R){f=y;break}if(!f)throw new Error("not a visible editor");const b=this,p=this.a++,d=new n.Emitter,t=new n.Emitter,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(y){return(0,C.asWebviewUri)(y,b.f)}get cspSource(){return C.webviewGenericCspSource}set options(y){this.b=y,b.d.$setOptions(p,y)}get options(){return this.b}set html(y){this.a=y,b.d.$setHtml(p,y)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(y){return b.d.$postMessage(p,y)}},m=new class{constructor(){this.editor=R,this.line=w,this.height=h,this.webview=a,this.onDidDispose=t.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset(p,f.id,f.value.document.uri,w+1,h,L||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:R,inset:m,onDidReceiveMessage:d}),m}$onDidDispose(R){const w=this.c.get(R);w&&w.inset.dispose()}$onDidReceiveMessage(R,w){this.c.get(R)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=F}),define(Pe[193],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var A;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(O,R){super(R),this.variable=O}}e.VariableError=C}),define(Pe[194],Ae([1,0,19,51,9,23,20,88,158,193,13]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(b,p,d,t){this.g=new Map,this.a=b,this.b=p,this.d=d,t&&(this.c=t.then(a=>this.h(a)))}h(b){if(O.isWindows){const p=Object.create(null);return Object.keys(b).forEach(d=>{p[d.toLowerCase()]=b[d]}),p}return b}resolveWithEnvironment(b,p,d){return this.j({env:this.h(b),userHome:void 0},p?p.uri:void 0,d)}async resolveAsync(b,p){const d={env:await this.c,userHome:await this.d};return this.j(d,b?b.uri:void 0,p)}async i(b,p,d,t){const a=F.deepClone(p);O.isWindows&&a.windows?Object.keys(a.windows).forEach(y=>a[y]=a.windows[y]):O.isMacintosh&&a.osx?Object.keys(a.osx).forEach(y=>a[y]=a.osx[y]):O.isLinux&&a.linux&&Object.keys(a.linux).forEach(y=>a[y]=a.linux[y]),delete a.windows,delete a.osx,delete a.linux;const m={env:await this.c,userHome:await this.d};return this.j(m,b?b.uri:void 0,a,d,t)}async resolveAnyAsync(b,p,d){return this.i(b,p,d)}async resolveAnyMap(b,p,d){const t=new Map;return{newConfig:await this.i(b,p,d,t),resolvedVariables:t}}resolveWithInteractionReplace(b,p,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,p)}async j(b,p,d,t,a){if(C.isString(d))return this.l(b,p,d,t,a);if(Array.isArray(d))return Promise.all(d.map(m=>this.j(b,p,m,t,a)));if(C.isObject(d)){const m=Object.create(null),y=await Promise.all(Object.keys(d).map(async P=>[await this.l(b,p,P,t,a),await this.j(b,p,d[P],t,a)]));for(const[P,g]of y)m[P]=g;return m}return d}l(b,p,d,t,a){return(0,L.replaceAsync)(d,D.VARIABLE_REGEXP,async(m,y)=>{if(y.includes(D.VARIABLE_LHS))return m;let P=await this.n(b,m,y,p,t);return a?.set(y,P),P!==m&&C.isString(P)&&P.match(D.VARIABLE_REGEXP)&&(P=await this.l(b,p,P,t,a)),P})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,p,d,t,a){let m;const y=d.split(":");y.length>1&&(d=y[0],m=y[1]);const P=u=>{const r=this.a.getFilePath();if(r)return(0,R.normalizeDriveLetter)(r);throw new h.VariableError(u,(0,w.localize)(0,null,p))},g=u=>{const r=P(u);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,R.normalizeDriveLetter)(c)}throw new h.VariableError(u,(0,w.localize)(1,null,p,n.basename(r)))},i=u=>{if(m){const r=this.a.getFolderUri(m);if(r)return r;throw new h.VariableError(u,(0,w.localize)(2,null,p,m))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new h.VariableError(u,(0,w.localize)(3,null,p)):new h.VariableError(u,(0,w.localize)(4,null,p))};switch(d){case"env":if(m){if(b.env){const u=b.env[O.isWindows?m.toLowerCase():m];if(C.isString(u))return u}return""}throw new h.VariableError(h.VariableKind.Env,(0,w.localize)(5,null,p));case"config":if(m){const u=this.a.getConfigurationValue(t,m);if(C.isUndefinedOrNull(u))throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(6,null,p,m));if(C.isObject(u))throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(7,null,p,m));return u}throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(8,null,p));case"command":return this.o(h.VariableKind.Command,p,m,a,"command");case"input":return this.o(h.VariableKind.Input,p,m,a,"input");case"extensionInstallFolder":if(m){const u=await this.a.getExtension(m);if(!u)throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,p,m));return this.m(u.extensionLocation)}throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,p));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(i(h.VariableKind.WorkspaceFolder)));case"cwd":return t||m?(0,R.normalizeDriveLetter)(this.m(i(h.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(n.basename(this.m(i(h.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new h.VariableError(h.VariableKind.UserHome,(0,w.localize)(11,null,p))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new h.VariableError(h.VariableKind.LineNumber,(0,w.localize)(12,null,p))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new h.VariableError(h.VariableKind.SelectedText,(0,w.localize)(13,null,p))}case"file":return P(h.VariableKind.File);case"fileWorkspaceFolder":return g(h.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||m?n.relative(this.m(i(h.VariableKind.RelativeFile)),P(h.VariableKind.RelativeFile)):P(h.VariableKind.RelativeFile);case"relativeFileDirname":{const u=n.dirname(P(h.VariableKind.RelativeFileDirname));if(t||m){const r=n.relative(this.m(i(h.VariableKind.RelativeFileDirname)),u);return r.length===0?".":r}return u}case"fileDirname":return n.dirname(P(h.VariableKind.FileDirname));case"fileExtname":return n.extname(P(h.VariableKind.FileExtname));case"fileBasename":return n.basename(P(h.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=n.basename(P(h.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-n.extname(u).length)}case"fileDirnameBasename":return n.basename(n.dirname(P(h.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||p}case"execInstallFolder":{const u=this.a.getAppRoot();return u||p}case"pathSeparator":return n.sep;default:try{const u=m?`${d}:${m}`:d;return this.o(h.VariableKind.Unknown,p,u,a,void 0)}catch{return p}}}}o(b,p,d,t,a){if(d&&t){const m=a===void 0?t[d]:t[a+":"+d];if(typeof m=="string")return m;throw new h.VariableError(b,(0,w.localize)(14,null,p))}return p}}D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=D}),define(Pe[99],Ae([1,0,3,97]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var C;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var F;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(F=e.GroupOrientation||(e.GroupOrientation={}));var O;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(O=e.GroupLocation||(e.GroupLocation={}));var R;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function h(p){const d=p;return(0,A.isEditorInput)(d?.editor)&&(0,A.isEditorInput)(d?.replacement)}e.isEditorReplacement=h;var L;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function f(p){const d=p;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=f;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Pe[195],Ae([1,0,3,99]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(F){const O=F;return typeof F=="number"||(0,A.isEditorGroup)(O)}e.isPreferredGroup=C}),define(Pe[196],Ae([1,0,3,164]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(A.IEnvironmentService)}),define(Pe[100],Ae([1,0,24,5,19,6]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class O{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=O;class R{static isHostExtension(t,a,m){if(a.getExtensionDescription(t))return!1;const y=m.getExtensionDescription(t);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(t,a){this.h=t,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=a,this.j()}j(){this.d.sort(b),this.e=new n.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const a=this.h.readActivationEvents(t);if(Array.isArray(a))for(let m of a)m==="onUri"&&(m=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,a){this.d=p(this.d,a),this.d=this.d.concat(t);const m=R.k(this.d);return this.d=p(this.d,m.map(y=>y.identifier)),this.j(),this.c.fire(void 0),new O(m)}static k(t){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,u){this.addNode(i),this.addNode(u),this.c.has(i)?this.c.get(i).push(u):this.c.set(i,[u])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,u){const r=a.getArcs(i);for(let c=0;c<r.length;c++)if(!u.has(r[c]))return!1;return!0}getNodes(){return this.e}},m=new n.ExtensionIdentifierMap;for(const i of t)if(m.set(i.identifier,i),i.extensionDependencies)for(const u of i.extensionDependencies)a.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(u));const y=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>y.add(i));const P=a.getNodes().filter(i=>!y.has(i));let g;do{g=!1;for(let i=0;i<P.length;i++){const u=P[i];a.hasOnlyGoodArcs(u,y)&&(P.splice(i,1),i--,y.add(u),g=!0)}}while(g);return P.map(i=>m.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const a=this.g.get(t);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const a=this.e.get(t);return a||void 0}getExtensionDescriptionByUUID(t){for(const a of this.f)if(a.uuid===t)return a}getExtensionDescriptionByIdOrUUID(t,a){return this.getExtensionDescription(t)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=R,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class w{constructor(t){this.d=new D,this.c=new R(t,[])}async acquireLock(t){const a=await this.d.acquire(t);return new h(this,a)}deltaExtensions(t,a,m){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,m)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,a){return this.c.getExtensionDescriptionByIdOrUUID(t,a)}}e.LockableExtensionDescriptionRegistry=w;class h extends F.Disposable{constructor(t,a){super(),this.f=t,this.c=!1,this.D(a)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=h;class L{constructor(t){this.name=t,this.promise=new Promise((a,m)=>{this.c=a})}resolve(t){this.c(t)}}class D{constructor(){this.c=[],this.d=!1}async acquire(t){const a=new L(t);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let a=!0;const m=setTimeout(()=>{a&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{!a||(clearTimeout(m),a=!1,this.d=!1,this.e())};t.resolve((0,F.toDisposable)(y))}}var f;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(f||(f={}));function b(d,t){const a=d.isBuiltin?0:d.isUnderDevelopment?2:1,m=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(a!==m)return a-m;const y=C.posix.basename(d.extensionLocation.path),P=C.posix.basename(t.extensionLocation.path);return y<P?-1:y>P?1:0}function p(d,t){const a=new n.ExtensionIdentifierSet(t);return d.filter(m=>!a.has(m.identifier))}}),define(Pe[75],Ae([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var C;(function(h){h[h.VersionMismatch=55]="VersionMismatch",h[h.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var F;(function(h){h[h.Initialized=0]="Initialized",h[h.Ready=1]="Ready",h[h.Terminate=2]="Terminate"})(F=e.MessageType||(e.MessageType={}));function O(h){const L=n.VSBuffer.alloc(1);switch(h){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=O;function R(h,L){if(h.byteLength!==1)return!1;switch(h.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=R;var w;(function(h){h.Start="START_NATIVE_LOG",h.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Pe[57],Ae([1,0,3,5,14,27,75,50,52,23,2,6,148]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class extends D.Disposable{constructor(a,m){super(),this.m=a,this.n=m,this.a=this.D(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.D(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=m.createLogger(this.j,{id:w.extensionTelemetryLogChannelId,name:(0,f.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.D(m.onDidChangeLogLevel(y=>{(0,C.isLogLevel)(y)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,m,y){const P=this.getTelemetryDetails(),g=new p(m,y,a,this.k,this.i,this.getBuiltInCommonProperties(a),{isUsageEnabled:P.isUsageEnabled,isErrorsEnabled:P.isErrorsEnabled});return this.l.set(a.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(a,m,y){this.f=a,this.g=m,this.c=y??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(a){const m={};switch(m["common.extname"]=`${a.publisher}.${a.name}`,m["common.extversion"]=a.version,m["common.vscodemachineid"]=this.m.telemetryInfo.machineId,m["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,m["common.vscodeversion"]=this.m.version,m["common.isnewappinstall"]=d(this.m.telemetryInfo.firstSessionDate),m["common.product"]=this.m.environment.appHost,this.m.uiKind){case O.UIKind.Web:m["common.uikind"]="web";break;case O.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,R.getRemoteName)((0,w.cleanRemoteAuthority)(this.m.remote.authority)),m}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const m=this.getTelemetryDetails();this.l.forEach((y,P)=>{y.isDisposed&&this.l.delete(P)}),this.l.forEach(y=>{y.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(a,m){const y=this.l.get(a.value);return y&&y.isDisposed?(this.l.delete(a.value),!1):!y||y.ignoreUnhandledExtHostErrors?!1:(y.logError(m),!0)}};b=je([Ve(0,F.IExtHostInitDataService),Ve(1,C.ILoggerService)],b),e.ExtHostTelemetry=b;class p{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,m,y,P,g,i,u){this.g=y,this.h=P,this.i=g,this.j=i,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(a,m){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let m=a.properties??a;return m=(0,w.cleanData)(m,[]),this.c&&(m=(0,h.mixin)(m,this.c)),this.b||(m=(0,h.mixin)(m,this.j)),a.properties?a.properties=m:a=m,a}k(a,m){!this.f||(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(a,m),this.h.trace(a,m))}logUsage(a,m){!this.d.isUsageEnabled||this.k(a,m)}logError(a,m){!this.d.isErrorsEnabled||!this.f||(typeof a=="string"?this.k(a,m):this.f.sendErrorData(a,m))}get apiTelemetryLogger(){if(!this.e){const a=this,m={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=p;function d(t){const a=Date.now()-new Date(t).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=d,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,174,96,24,3]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new O.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class w{constructor(g){this.dependency=g}}e.MissingExtensionDependency=w;var h;(function(P){P[P.EagerAutoStart=1]="EagerAutoStart",P[P.EagerManualStart=2]="EagerManualStart",P[P.Lazy=3]="Lazy"})(h=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class L{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:F.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(g,i){const u=[],r=[],c=[],o=[],k=D(this.c),s=D(g),l=(G,Y)=>G.extensionLocation.toString()===Y.extensionLocation.toString()||G.isBuiltin===Y.isBuiltin||G.isUserBuiltin===Y.isUserBuiltin||G.isUnderDevelopment===Y.isUnderDevelopment;for(const G of this.c){const Y=s.get(G.identifier);if(!Y){u.push(G.identifier),k.delete(G.identifier);continue}if(!l(G,Y)){u.push(G.identifier),k.delete(G.identifier);continue}}for(const G of g){const Y=k.get(G.identifier);if(!Y){r.push(G);continue}if(!l(Y,G)){u.push(Y.identifier),k.delete(Y.identifier);continue}}const v=new O.ExtensionIdentifierSet(this.d),S=new O.ExtensionIdentifierSet(i);for(const G of this.d)S.has(G)||c.push(G);for(const G of i)v.has(G)||o.push(G);const E=F.ImplicitActivationEvents.createActivationEventsMap(r),W={toRemove:u,toAdd:r,addActivationEvents:E,myToRemove:c,myToAdd:o};return this.delta(W),W}delta(g){const{toRemove:i,toAdd:u,myToRemove:r,myToAdd:c}=g,o=new O.ExtensionIdentifierSet(i),k=new O.ExtensionIdentifierSet(r);for(let s=0;s<this.c.length;s++)o.has(this.c[s].identifier)&&(this.c.splice(s,1),s--);for(let s=0;s<this.d.length;s++)k.has(this.d[s])&&(this.d.splice(s,1),s--);for(const s of u)this.c.push(s);for(const s of c)this.d.push(s)}containsExtension(g){for(const i of this.d)if(O.ExtensionIdentifier.equals(i,g))return!0;return!1}}e.ExtensionHostExtensions=L;function D(P){const g=new O.ExtensionIdentifierMap;for(const i of P)g.set(i.identifier,i);return g}function f(P,g){return P.enabledApiProposals?P.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=f;function b(P,g){if(!f(P,g))throw new Error(`Extension '${P.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${P.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${P.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(g,i,u,r){this.codeLoadingTime=g,this.activateCallTime=i,this.activateResolvedTime=u,this.activationReason=r}}e.ActivationTimes=p;class d{constructor(g,i){this.description=g,this.value=i}}e.ExtensionPointContribution=d;var t;(function(P){P[P.Normal=0]="Normal",P[P.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function a(P){return{type:P.isBuiltin?0:1,isBuiltin:P.isBuiltin||P.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(P.publisher,P.name),uuid:P.uuid},manifest:P,location:P.extensionLocation,targetPlatform:P.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function m(P,g){return{identifier:new O.ExtensionIdentifier((0,C.getExtensionId)(P.manifest.publisher,P.manifest.name)),isBuiltin:P.type===0,isUserBuiltin:P.type===1&&P.isBuiltin,isUnderDevelopment:!!g,extensionLocation:P.location,...P.manifest,uuid:P.identifier.uuid,targetPlatform:P.targetPlatform,browserNlsBundleUris:P.browserNlsBundleUris}}e.toExtensionDescription=m;class y{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(g,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=y}),define(Pe[197],Ae([1,0,10,100,24,26,14,17]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class w{constructor(a,m,y,P){this.startup=a,this.codeLoadingTime=m,this.activateCallTime=y,this.activateResolvedTime=P}}w.NONE=new w(!1,-1,-1,-1),e.ExtensionActivationTimes=w;class h{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,m){return a===-1||m===-1?-1:m-a}build(){return new w(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=h;class L{constructor(a,m,y,P,g,i){this.activationFailed=a,this.activationFailedError=m,this.activationTimes=y,this.module=P,this.exports=g,this.subscriptions=i}}e.ActivatedExtension=L;class D extends L{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class f extends L{constructor(){super(!1,null,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class b extends L{constructor(a){super(!0,a,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(a,m,y,P){this.g=P,this.a=a,this.b=m,this.c=y,this.d=new C.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[a,m]of this.d)m.dispose()}isActivated(a){const m=this.d.get(a);return Boolean(m&&m.value)}getActivatedExtension(a){const m=this.d.get(a);if(!m||!m.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return m.value}async activateByEvent(a,m){if(this.f[a])return;const y=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(y.map(P=>({id:P.identifier,reason:{startup:m,extensionId:P.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,m){const y=this.a.getExtensionDescription(a);if(!y)throw new Error(`Extension '${a}' is not known`);return this.h([{id:y.identifier,reason:m}])}async h(a){const m=a.filter(y=>!this.isActivated(y.id)).map(y=>this.j(y));await Promise.all(m.map(y=>y.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const m=this.a.getExtensionDescription(a.id);if(!m){const g=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new b(g));return this.c.onExtensionActivationError(a.id,g,new F.MissingExtensionDependency(a.id.value)),i}const y=[],P=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const g of P){if(this.m(g))continue;const i=this.d.get(g);if(i){y.push(i);continue}if(this.l(g)){y.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:a.reason}));continue}const u=this.a.getExtensionDescription(g);if(u){if(!u.main&&!u.browser)continue;y.push(this.j({id:u.identifier,reason:a.reason}));continue}const r=m.displayName||m.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${g}'`),o=this.k(a,m.displayName,[],new b(c));return this.c.onExtensionActivationError(m.identifier,c,new F.MissingExtensionDependency(g)),o}return this.k(a,m.displayName,y,null)}k(a,m,y,P){const g=new d(a.id,m,a.reason,y,P,this.c,this.g);return this.d.set(a.id,g),g}l(a){return A.ExtensionDescriptionRegistry.isHostExtension(a,this.a,this.b)}m(a){const m=this.b.getExtensionDescription(a);return m?!m.main&&!m.browser:!1}};p=je([Ve(3,O.ILogService)],p),e.ExtensionsActivator=p;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,m,y,P,g,i,u){this.c=a,this.d=m,this.f=y,this.g=P,this.h=g,this.j=i,this.k=u,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const m=this.g[a];if(m.value&&!m.value.activationFailed){this.g.splice(a,1),a--;continue}if(m.value&&m.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);y.detail=m.value.activationFailedError,this.h=new b(y),this.j.onExtensionActivationError(this.c,y,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const m=new Error;if(a&&a.name&&(m.name=a.name),a&&a.message?m.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(m.stack=a.stack),this.h=new b(m),this.b&&n.isCancellationError(a))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};d=je([Ve(6,O.ILogService)],d)});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[7],Ae([1,0,16,10,87,28,65,13,9,2,35,43,95,72,26]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p){"use strict";var d,t,a,m,y,P,g,i,u,r,c,o,k,s,l,v,S,E,W,G,Y,J,q,U,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function z(B){return Object.assign(B,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(B,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[ne,...ye]=arguments;return Reflect.construct(B,ye,ne.constructor)}}})}var j;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(j=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var he;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(he=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let we=i=class{static from(...N){let ne=N;return new i(function(){if(ne){for(const ye of ne)ye&&typeof ye.dispose=="function"&&ye.dispose();ne=void 0}})}constructor(N){d.set(this,void 0),Je(this,d,N,"f")}dispose(){typeof Le(this,d,"f")=="function"&&(Le(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,we=i=je([z],we),e.Disposable=we;let ie=u=class{static Min(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let ye=1;ye<N.length;ye++){const qe=N[ye];qe.isBefore(ne)&&(ne=qe)}return ne}static Max(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let ye=1;ye<N.length;ye++){const qe=N[ye];qe.isAfter(ne)&&(ne=qe)}return ne}static isPosition(N){if(!N)return!1;if(N instanceof u)return!0;const{line:ne,character:ye}=N;return typeof ne=="number"&&typeof ye=="number"}static of(N){if(N instanceof u)return N;if(this.isPosition(N))return new u(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ne){if(N<0)throw(0,A.illegalArgument)("line must be non-negative");if(ne<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=N,this.e=ne}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ne=0){if(N===null||ne===null)throw(0,A.illegalArgument)();let ye;return typeof N>"u"?ye=0:typeof N=="number"?ye=N:(ye=typeof N.lineDelta=="number"?N.lineDelta:0,ne=typeof N.characterDelta=="number"?N.characterDelta:0),ye===0&&ne===0?this:new u(this.line+ye,this.character+ne)}with(N,ne=this.character){if(N===null||ne===null)throw(0,A.illegalArgument)();let ye;return typeof N>"u"?ye=this.line:typeof N=="number"?ye=N:(ye=typeof N.line=="number"?N.line:this.line,ne=typeof N.character=="number"?N.character:this.character),ye===this.line&&ne===this.character?this:new u(ye,ne)}toJSON(){return{line:this.line,character:this.character}}};ie=u=je([z],ie),e.Position=ie;let oe=r=class{static isRange(N){return N instanceof r?!0:N?ie.isPosition(N.start)&&ie.isPosition(N.end):!1}static of(N){if(N instanceof r)return N;if(this.isRange(N))return new r(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ne,ye,qe){let _e,st;if(typeof N=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"?(_e=new ie(N,ne),st=new ie(ye,qe)):ie.isPosition(N)&&ie.isPosition(ne)&&(_e=ie.of(N),st=ie.of(ne)),!_e||!st)throw new Error("Invalid arguments");_e.isBefore(st)?(this.c=_e,this.e=st):(this.c=st,this.e=_e)}contains(N){return r.isRange(N)?this.contains(N.start)&&this.contains(N.end):ie.isPosition(N)?!(ie.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ne=ie.Max(N.start,this.c),ye=ie.Min(N.end,this.e);if(!ne.isAfter(ye))return new r(ne,ye)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ne=ie.Min(N.start,this.c),ye=ie.Max(N.end,this.end);return new r(ne,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ne=this.end){if(N===null||ne===null)throw(0,A.illegalArgument)();let ye;return N?ie.isPosition(N)?ye=N:(ye=N.start||this.start,ne=N.end||this.end):ye=this.start,ye.isEqual(this.c)&&ne.isEqual(this.end)?this:new r(ye,ne)}toJSON(){return[this.start,this.end]}};oe=r=je([z],oe),e.Range=oe;let de=c=class extends oe{static isSelection(N){return N instanceof c?!0:N?oe.isRange(N)&&ie.isPosition(N.anchor)&&ie.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ne,ye,qe){let _e,st;if(typeof N=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"?(_e=new ie(N,ne),st=new ie(ye,qe)):ie.isPosition(N)&&ie.isPosition(ne)&&(_e=ie.of(N),st=ie.of(ne)),!_e||!st)throw new Error("Invalid arguments");super(_e,st),this.f=_e,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};de=c=je([z],de),e.Selection=de;class ke{constructor(N,ne,ye){if(typeof N!="string"||N.length===0)throw(0,A.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,A.illegalArgument)("port");if(typeof ye<"u"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z_\-]+$/.test(ye)))throw(0,A.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(ne),this.connectionToken=ye}}e.ResolvedAuthority=ke;class le extends Error{static NotAvailable(N,ne){return new le(N,f.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(N){return new le(N,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ne=f.RemoteAuthorityResolverErrorCode.Unknown,ye){super(N),this._message=N,this._code=ne,this._detail=ye,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var X;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(X=e.EndOfLine||(e.EndOfLine={}));var T;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(T=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=o=class{static isTextEdit(N){return N instanceof o?!0:N?oe.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ne){return new o(N,ne)}static insert(N,ne){return o.replace(new oe(N,N),ne)}static delete(N){return o.replace(N,"")}static setEndOfLine(N){const ne=new o(new oe(new ie(0,0),new ie(0,0)),"");return ne.newEol=N,ne}get range(){return this.c}set range(N){if(N&&!oe.isRange(N))throw(0,A.illegalArgument)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,A.illegalArgument)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,A.illegalArgument)("newEol");this.f=N}constructor(N,ne){this.c=N,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};V=o=je([z],V),e.TextEdit=V;let ce=k=class{static isNotebookCellEdit(N){return N instanceof k?!0:N?Kt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ne){return new k(N,ne)}static insertCells(N,ne){return new k(new Kt(N,N),ne)}static deleteCells(N){return new k(N,[])}static updateCellMetadata(N,ne){const ye=new k(new Kt(N,N),[]);return ye.newCellMetadata=ne,ye}static updateNotebookMetadata(N){const ne=new k(new Kt(0,0),[]);return ne.newNotebookMetadata=N,ne}constructor(N,ne){this.range=N,this.newCells=ne}};ce=k=je([z],ce),e.NotebookEdit=ce;class me{static isSnippetTextEdit(N){return N instanceof me?!0:N?oe.isRange(N.range)&&Ee.isSnippetString(N.snippet):!1}static replace(N,ne){return new me(N,ne)}static insert(N,ne){return me.replace(new oe(N,N),ne)}constructor(N,ne){this.range=N,this.snippet=ne}}e.SnippetTextEdit=me;var Fe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Fe=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ne,ye,qe){this.c.push({_type:1,from:N,to:ne,options:ye,metadata:qe})}createFile(N,ne,ye){this.c.push({_type:1,from:void 0,to:N,options:ne,metadata:ye})}deleteFile(N,ne,ye){this.c.push({_type:1,from:N,to:void 0,options:ne,metadata:ye})}e(N,ne,ye){this.c.push({_type:3,metadata:ye,uri:N,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(N,ne,ye,qe){const _e=ne.start,st=ne.end;(_e!==st||ye.length>0)&&this.c.push({_type:5,uri:N,index:_e,count:st-_e,cells:ye,metadata:qe})}g(N,ne,ye,qe){this.c.push({_type:3,metadata:qe,uri:N,edit:{editType:8,index:ne,metadata:ye}})}replace(N,ne,ye,qe){this.c.push({_type:2,uri:N,edit:new V(ne,ye),metadata:qe})}insert(N,ne,ye,qe){this.replace(N,new oe(ne,ne),ye,qe)}delete(N,ne,ye){this.replace(N,ne,"",ye)}has(N){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===N.toString())}set(N,ne){if(ne)for(const ye of ne){if(!ye)continue;let qe,_e;Array.isArray(ye)?(qe=ye[0],_e=ye[1]):qe=ye,ce.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(N,qe.range.start,qe.newCellMetadata,_e):qe.newNotebookMetadata?this.e(N,qe.newNotebookMetadata,_e):this.f(N,qe.range,qe.newCells,_e):me.isSnippetTextEdit(qe)?this.c.push({_type:6,uri:N,range:qe.range,edit:qe.snippet,metadata:_e}):this.c.push({_type:2,uri:N,edit:qe,metadata:_e})}else{for(let ye=0;ye<this.c.length;ye++){const qe=this.c[ye];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===N.toString()&&(this.c[ye]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(N){const ne=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===N.toString()&&ne.push(ye.edit);return ne}entries(){const N=new F.ResourceMap;for(const ne of this.c)if(ne._type===2){let ye=N.get(ne.uri);ye||(ye=[ne.uri,[]],N.set(ne.uri,ye)),ye[1].push(ne.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([z],be),e.WorkspaceEdit=be;let Ee=s=class{static isSnippetString(N){return N instanceof s?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=s.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ne=this.e++){if(typeof N=="function"){const ye=new s;ye.e=this.e,N(ye),this.e=ye.e,N=ye.value}else N=s.c(N);return this.value+="${",this.value+=ne,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ne=this.e++){const ye=N.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(N,ne){if(typeof ne=="function"){const ye=new s;ye.e=this.e,ne(ye),this.e=ye.e,ne=ye.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};Ee=s=je([z],Ee),e.SnippetString=Ee;var Ie;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Ie=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=l=class{static isLocation(N){return N instanceof l?!0:N?oe.isRange(N.range)&&h.URI.isUri(N.uri):!1}constructor(N,ne){if(this.uri=N,ne)if(oe.isRange(ne))this.range=oe.of(ne);else if(ie.isPosition(ne))this.range=new oe(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ae=l=je([z],ae),e.Location=ae;let Z=class{static is(N){return N?typeof N.message=="string"&&N.location&&oe.isRange(N.location.range)&&h.URI.isUri(N.location.uri):!1}constructor(N,ne){this.location=N,this.message=ne}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.location.range.isEqual(ne.location.range)&&N.location.uri.toString()===ne.location.uri.toString()}};Z=je([z],Z),e.DiagnosticRelatedInformation=Z;let I=class{constructor(N,ne,ye=se.Error){if(!oe.isRange(N))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=N,this.message=ne,this.severity=ye}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.severity===ne.severity&&N.code===ne.code&&N.severity===ne.severity&&N.source===ne.source&&N.range.isEqual(ne.range)&&(0,n.equals)(N.tags,ne.tags)&&(0,n.equals)(N.relatedInformation,ne.relatedInformation,Z.isEqual)}};I=je([z],I),e.Diagnostic=I;let M=class{constructor(N,ne){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ne}};M=je([z],M),e.Hover=M;var H;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(H=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let x=class{constructor(N,ne=H.Text){this.range=N,this.kind=ne}toJSON(){return{range:this.range,kind:H[this.kind]}}};x=je([z],x),e.DocumentHighlight=x;var te;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(te=e.SymbolKind||(e.SymbolKind={}));var pe;(function(B){B[B.Deprecated=1]="Deprecated"})(pe=e.SymbolTag||(e.SymbolTag={}));let Ce=v=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ne,ye,qe,_e){this.name=N,this.kind=ne,this.containerName=_e,typeof ye=="string"&&(this.containerName=ye),qe instanceof ae?this.location=qe:ye instanceof oe&&(this.location=new ae(qe,ye)),v.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};Ce=v=je([z],Ce),e.SymbolInformation=Ce;let ue=S=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(S.validate)}constructor(N,ne,ye,qe,_e){this.name=N,this.detail=ne,this.kind=ye,this.range=qe,this.selectionRange=_e,this.children=[],S.validate(this)}};ue=S=je([z],ue),e.DocumentSymbol=ue;var De;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(De=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Se=class{constructor(N,ne){this.title=N,this.kind=ne}};Se=je([z],Se),e.CodeAction=Se;let $e=E=class{constructor(N){this.value=N}append(N){return new E(this.value?this.value+E.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+E.c)}};$e.c=".",$e=E=je([z],$e),e.CodeActionKind=$e,$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorMove=$e.Refactor.append("move"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let He=class{constructor(N,ne){if(this.range=N,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};He=je([z],He),e.SelectionRange=He;class et{constructor(N,ne,ye,qe,_e,st){this.kind=N,this.name=ne,this.detail=ye,this.uri=qe,this.range=_e,this.selectionRange=st}}e.CallHierarchyItem=et;class Xe{constructor(N,ne){this.fromRanges=ne,this.from=N}}e.CallHierarchyIncomingCall=Xe;class tt{constructor(N,ne){this.fromRanges=ne,this.to=N}}e.CallHierarchyOutgoingCall=tt;var rt;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(rt=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(N,ne){this.range=N,this.command=ne}get isResolved(){return!!this.command}};Me=je([z],Me),e.CodeLens=Me;let it=W=class{static isMarkdownString(N){return N instanceof W?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ne=!1){t.set(this,void 0),Je(this,t,new C.MarkdownString(N,{supportThemeIcons:ne}),"f")}get value(){return Le(this,t,"f").value}set value(N){Le(this,t,"f").value=N}get isTrusted(){return Le(this,t,"f").isTrusted}set isTrusted(N){Le(this,t,"f").isTrusted=N}get supportThemeIcons(){return Le(this,t,"f").supportThemeIcons}set supportThemeIcons(N){Le(this,t,"f").supportThemeIcons=N}get supportHtml(){return Le(this,t,"f").supportHtml}set supportHtml(N){Le(this,t,"f").supportHtml=N}get baseUri(){return Le(this,t,"f").baseUri}set baseUri(N){Le(this,t,"f").baseUri=N}appendText(N){return Le(this,t,"f").appendText(N),this}appendMarkdown(N){return Le(this,t,"f").appendMarkdown(N),this}appendCodeblock(N,ne){return Le(this,t,"f").appendCodeblock(ne??"",N),this}};t=new WeakMap,it=W=je([z],it),e.MarkdownString=it;let Q=class{constructor(N,ne){this.label=N,this.documentation=ne}};Q=je([z],Q),e.ParameterInformation=Q;let _=class{constructor(N,ne){this.label=N,this.documentation=ne,this.parameters=[]}};_=je([z],_),e.SignatureInformation=_;let ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ve=je([z],ve),e.SignatureHelp=ve;var We;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(We=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Be;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Be=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(N){this.value=N}};Qe=je([z],Qe),e.InlayHintLabelPart=Qe;let Ye=class{constructor(N,ne,ye){this.position=N,this.label=ne,this.kind=ye}};Ye=je([z],Ye),e.InlayHint=Ye;var Ge;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var Dt;(function(B){B[B.Deprecated=1]="Deprecated"})(Dt=e.CompletionItemTag||(e.CompletionItemTag={}));let Tt=class{constructor(N,ne){this.label=N,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Tt=je([z],Tt),e.CompletionItem=Tt;let It=class{constructor(N=[],ne=!1){this.items=N,this.isIncomplete=ne}};It=je([z],It),e.CompletionList=It;let Et=class{constructor(N,ne,ye){this.insertText=N,this.range=ne,this.command=ye}};Et=je([z],Et),e.InlineSuggestion=Et;let Mt=class{constructor(N){this.commands=void 0,this.items=N}};Mt=je([z],Mt),e.InlineSuggestionList=Mt;var Bt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Bt=e.ViewColumn||(e.ViewColumn={}));var Xt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ht;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(ht=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(gt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Lt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Lt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function N(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=N}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ct=class{constructor(N,ne){if(ne&&!h.URI.isUri(ne))throw(0,A.illegalArgument)("target");if(!oe.isRange(N)||N.isEmpty)throw(0,A.illegalArgument)("range");this.range=N,this.target=ne}};Ct=je([z],Ct),e.DocumentLink=Ct;let Pt=class{constructor(N,ne,ye,qe){this.red=N,this.green=ne,this.blue=ye,this.alpha=qe}};Pt=je([z],Pt),e.Color=Pt;let $t=class{constructor(N,ne){if(ne&&!(ne instanceof Pt))throw(0,A.illegalArgument)("color");if(!oe.isRange(N)||N.isEmpty)throw(0,A.illegalArgument)("range");this.range=N,this.color=ne}};$t=je([z],$t),e.ColorInformation=$t;let Ke=class{constructor(N){if(!N||typeof N!="string")throw(0,A.illegalArgument)("label");this.label=N}};Ke=je([z],Ke),e.ColorPresentation=Ke;var Wt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var Te;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Te=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Oe;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Oe=e.TerminalExitReason||(e.TerminalExitReason={}));class fe{constructor(N,ne,ye){if(this.startIndex=N,this.length=ne,this.tooltip=ye,typeof N!="number"||N<0)throw(0,A.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,A.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=fe;class K{constructor(N){this.uri=N}}e.TerminalQuickFixOpener=K;class Re{constructor(N){this.terminalCommand=N}}e.TerminalQuickFixCommand=Re;var ze;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ze=e.TerminalLocation||(e.TerminalLocation={}));class Ze{constructor(N){if(this.options=N,typeof N!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Ze;var xe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var ot;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ot=e.TaskPanelKind||(e.TaskPanelKind={}));let ft=G=class{static from(N){switch(N){case"clean":return G.Clean;case"build":return G.Build;case"rebuild":return G.Rebuild;case"test":return G.Test;default:return}}constructor(N,ne){if(this.label=ne,typeof N!="string"||typeof ne!="string")throw(0,A.illegalArgument)("name");this.c=N}get id(){return this.c}};ft.Clean=new G("clean","Clean"),ft.Build=new G("build","Build"),ft.Rebuild=new G("rebuild","Rebuild"),ft.Test=new G("test","Test"),ft=G=je([z],ft),e.TaskGroup=ft;function mt(B){let N="";for(let ne=0;ne<B.length;ne++)N+=B[ne].replace(/,/g,",,")+",";return N}let lt=class{constructor(N,ne,ye){if(typeof N!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=N,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ye):this.f=ne)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,A.illegalArgument)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)N.push(ne);return mt(N)}};lt=je([z],lt),e.ProcessExecution=lt;let ct=class{constructor(N,ne,ye){if(this.f=[],Array.isArray(ne)){if(!N)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,A.illegalArgument)("command");this.e=N,this.f=ne,this.g=ye}else{if(typeof N!="string")throw(0,A.illegalArgument)("commandLine");this.c=N,this.g=ne}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,A.illegalArgument)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,A.illegalArgument)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)N.push(typeof ne=="string"?ne:ne.value);return mt(N)}};ct=je([z],ct),e.ShellExecution=ct;var bt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Ht{constructor(N){this.c=N}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(N){this.c=N}get callback(){return this.c}}e.CustomExecution=Ht;let Nt=Y=class{constructor(N,ne,ye,qe,_e,st){this.j=!1,this.k=this.definition=N;let ut;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=ye,this.execution=qe,ut=_e,this.j=!0):ne===kt.Global||ne===kt.Workspace?(this.target=ne,this.m=this.name=ye,this.t=this.source=qe,this.execution=_e,ut=st):(this.target=ne,this.m=this.name=ye,this.t=this.source=qe,this.execution=_e,ut=st),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:Y.e,id:this.n.computeId()}:this.n instanceof ct?this.k={type:Y.f,id:this.n.computeId()}:this.n instanceof Ht?this.k={type:Y.c,id:this.n.computeId()}:this.k={type:Y.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=N}get scope(){return this.l}set target(N){this.y(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.y(),this.n=N;const ne=this.k.type;(Y.g===ne||Y.e===ne||Y.f===ne||Y.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.y(),this.o=N,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.y(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.y(),this.u=N}get detail(){return this.x}set detail(N){N===null&&(N=void 0),this.x=N}get presentationOptions(){return this.v}set presentationOptions(N){N==null&&(N=Object.create(null)),this.y(),this.v=N}get runOptions(){return this.w}set runOptions(N){N==null&&(N=Object.create(null)),this.y(),this.w=N}};Nt.c="customExecution",Nt.e="process",Nt.f="shell",Nt.g="$empty",Nt=Y=je([z],Nt),e.Task=Nt;var ai;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ai=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(B){function N(ne){const ye=ne;return(0,w.isNumber)(ye.value)?ye.tooltip&&!(0,w.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}B.isViewBadge=N})(At=e.ViewBadge||(e.ViewBadge={}));let yi=J=class{static isTreeItem(N,ne){const ye=N;if(ye.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(ne,"treeItemCheckbox");const qe=(0,w.isNumber)(ye.checkboxState)?ye.checkboxState:(0,w.isObject)(ye.checkboxState)&&(0,w.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,_e=!(0,w.isNumber)(ye.checkboxState)&&(0,w.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(qe===void 0||qe!==yt.Checked&&qe!==yt.Unchecked||_e!==void 0&&!(0,w.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(N instanceof J)return!0;if(ye.label!==void 0&&!(0,w.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,w.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,w.isString)(ye.iconPath)&&!h.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,w.isString)(ye.iconPath.id))){const qe=ye.iconPath;if(!qe||!(0,w.isString)(qe.light)&&!h.URI.isUri(qe.light)&&!(0,w.isString)(qe.dark)&&!h.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,w.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!h.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,w.isString)(ye.tooltip)&&!(ye.tooltip instanceof it)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<ci.None&&ye.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,w.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(N,ne=ci.None){this.collapsibleState=ne,h.URI.isUri(N)?this.resourceUri=N:this.label=N}};yi=J=je([z],yi),e.TreeItem=yi;var ci;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var yt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(yt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ui=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N,ne){this.value=N,this.id=ne??(0,L.generateUuid)()}};ui=je([z],ui),e.DataTransferItem=ui;let li=class{constructor(N){a.add(this),m.set(this,new Map);for(const[ne,ye]of N??[]){const qe=Le(this,m,"f").get(Le(this,a,"m",y).call(this,ne));qe?qe.push(ye):Le(this,m,"f").set(Le(this,a,"m",y).call(this,ne),[ye])}}get(N){return Le(this,m,"f").get(Le(this,a,"m",y).call(this,N))?.[0]}set(N,ne){Le(this,m,"f").set(Le(this,a,"m",y).call(this,N),[ne])}forEach(N,ne){for(const[ye,qe]of Le(this,m,"f"))for(const _e of qe)N.call(ne,_e,ye,this)}*[(m=new WeakMap,a=new WeakSet,Symbol.iterator)](){for(const[N,ne]of Le(this,m,"f"))for(const ye of ne)yield[N,ye]}};y=function(N){return N.toLowerCase()},li=je([z],li),e.DataTransfer=li;let Zt=class{constructor(N){this.insertText=N}};Zt=je([z],Zt),e.DocumentDropEdit=Zt;let Di=class{constructor(N){this.insertText=N}};Di=je([z],Di),e.DocumentPasteEdit=Di;let wt=class{constructor(N,ne){this.id=N,this.color=ne}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};wt=je([z],wt),e.ThemeIcon=wt,wt.File=new wt("file"),wt.Folder=new wt("folder");let di=class{constructor(N){this.id=N}};di=je([z],di),e.ThemeColor=di;var zi;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(zi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(N){this.c=N,this.e=h.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ne){if(typeof N!="string"&&(!N||!h.URI.isUri(N)&&!h.URI.isUri(N.uri)))throw(0,A.illegalArgument)("base");if(typeof ne!="string")throw(0,A.illegalArgument)("pattern");typeof N=="string"?this.baseUri=h.URI.file(N):h.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=je([z],ei),e.RelativePattern=ei;const ii=new WeakMap;function dt(B,N){ii.set(B,N)}e.setBreakpointId=dt;let ti=class{constructor(N,ne,ye,qe){this.enabled=typeof N=="boolean"?N:!0,typeof ne=="string"&&(this.condition=ne),typeof ye=="string"&&(this.hitCondition=ye),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this.c||(this.c=ii.get(this)??(0,L.generateUuid)()),this.c}};ti=je([z],ti),e.Breakpoint=ti;let jt=class extends ti{constructor(N,ne,ye,qe,_e){if(super(ne,ye,qe,_e),N===null)throw(0,A.illegalArgument)("location");this.location=N}};jt=je([z],jt),e.SourceBreakpoint=jt;let Qt=class extends ti{constructor(N,ne,ye,qe,_e){super(ne,ye,qe,_e),this.functionName=N}};Qt=je([z],Qt),e.FunctionBreakpoint=Qt;let hi=class extends ti{constructor(N,ne,ye,qe,_e,st,ut){if(super(qe,_e,st,ut),!ne)throw(0,A.illegalArgument)("dataId");this.label=N,this.dataId=ne,this.canPersist=ye}};hi=je([z],hi),e.DataBreakpoint=hi;let Ii=class{constructor(N,ne,ye){this.command=N,this.args=ne||[],this.options=ye}};Ii=je([z],Ii),e.DebugAdapterExecutable=Ii;let Ci=class{constructor(N,ne){this.port=N,this.host=ne}};Ci=je([z],Ci),e.DebugAdapterServer=Ci;let fi=class{constructor(N){this.path=N}};fi=je([z],fi),e.DebugAdapterNamedPipeServer=fi;let ki=class{constructor(N){this.implementation=N}};ki=je([z],ki),e.DebugAdapterInlineImplementation=ki;let mi=class{constructor(N,ne){this.range=N,this.expression=ne}};mi=je([z],mi),e.EvaluatableExpression=mi;var gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ti=class{constructor(N,ne){this.range=N,this.text=ne}};Ti=je([z],Ti),e.InlineValueText=Ti;let ni=class{constructor(N,ne,ye=!0){this.range=N,this.variableName=ne,this.caseSensitiveLookup=ye}};ni=je([z],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(N,ne){this.range=N,this.expression=ne}};ri=je([z],ri),e.InlineValueEvaluatableExpression=ri;let Pi=class{constructor(N,ne){this.frameId=N,this.stoppedLocation=ne}};Pi=je([z],Pi),e.InlineValueContext=Pi;var Bi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let Yt=q=class extends Error{static FileExists(N){return new q(N,D.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(N){return new q(N,D.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(N){return new q(N,D.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(N){return new q(N,D.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(N){return new q(N,D.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(N){return new q(N,D.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(N,ne=D.FileSystemProviderErrorCode.Unknown,ye){super(h.URI.isUri(N)?N.toString(!0):N),this.code=ye?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};Yt=q=je([z],Yt),e.FileSystemError=Yt;let Ai=class{constructor(N,ne,ye){this.start=N,this.end=ne,this.kind=ye}};Ai=je([z],Ai),e.FoldingRange=Ai;var Wi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ni;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ni=e.CommentMode||(e.CommentMode={}));var Vi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Vi=e.CommentThreadState||(e.CommentThreadState={}));class ji{constructor(N,ne=[]){this.tokenTypes=N,this.tokenModifiers=ne}}e.SemanticTokensLegend=ji;function qi(B){return typeof B>"u"||(0,w.isStringArray)(B)}class si{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let ne=0,ye=N.tokenTypes.length;ne<ye;ne++)this.j.set(N.tokenTypes[ne],ne);for(let ne=0,ye=N.tokenModifiers.length;ne<ye;ne++)this.k.set(N.tokenModifiers[ne],ne)}}push(N,ne,ye,qe,_e){if(typeof N=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(N,ne,ye,qe,_e);if(oe.isRange(N)&&typeof ne=="string"&&qi(ye))return this.m(N,ne,ye);throw(0,A.illegalArgument)()}m(N,ne,ye){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const qe=N.start.line,_e=N.start.character,st=N.end.character-N.start.character,ut=this.j.get(ne);let Ft=0;if(ye)for(const Vt of ye){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Vt);Ft|=1<<qt>>>0}this.n(qe,_e,st,ut,Ft)}n(N,ne,ye,qe,_e){if(this.f&&(N<this.c||N===this.c&&ne<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,qt=0;for(let Gt=0;Gt<Ft;Gt++){let _t=this.g[5*Gt],Oi=this.g[5*Gt+1];_t===0?(_t=Vt,Oi+=qt):_t+=Vt,this.g[5*Gt]=_t,this.g[5*Gt+1]=Oi,Vt=_t,qt=Oi}}let st=N,ut=ne;this.f&&this.h>0&&(st-=this.c,st===0&&(ut-=this.e)),this.g[this.h++]=st,this.g[this.h++]=ut,this.g[this.h++]=ye,this.g[this.h++]=qe,this.g[this.h++]=_e,this.c=N,this.e=ne}static o(N){const ne=[],ye=N.length/5|0;for(let ut=0;ut<ye;ut++)ne[ut]=ut;ne.sort((ut,Ft)=>{const Vt=N[5*ut],qt=N[5*Ft];if(Vt===qt){const Gt=N[5*ut+1],_t=N[5*Ft+1];return Gt-_t}return Vt-qt});const qe=new Uint32Array(N.length);let _e=0,st=0;for(let ut=0;ut<ye;ut++){const Ft=5*ne[ut],Vt=N[Ft+0],qt=N[Ft+1],Gt=N[Ft+2],_t=N[Ft+3],Oi=N[Ft+4],un=Vt-_e,Ln=un===0?qt-st:qt,Li=5*ut;qe[Li+0]=un,qe[Li+1]=Ln,qe[Li+2]=Gt,qe[Li+3]=_t,qe[Li+4]=Oi,_e=Vt,st=qt}return qe}build(N){return this.f?new pi(new Uint32Array(this.g),N):new pi(si.o(this.g),N)}}e.SemanticTokensBuilder=si;class pi{constructor(N,ne){this.resultId=ne,this.data=N}}e.SemanticTokens=pi;class Fi{constructor(N,ne,ye){this.start=N,this.deleteCount=ne,this.data=ye}}e.SemanticTokensEdit=Fi;class Ue{constructor(N,ne){this.resultId=ne,this.edits=N}}e.SemanticTokensEdits=Ue;var xt;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let oi=class{constructor(){}};oi.Back={iconPath:new wt("arrow-left")},oi=je([z],oi),e.QuickInputButtons=oi;var vt;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(vt=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ki;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ki=e.ExtensionKind||(e.ExtensionKind={}));class Mi{static validate(N){if(typeof N.badge=="string"){let ne=(0,R.nextCharLength)(N.badge,0);if(ne<N.badge.length&&(ne+=(0,R.nextCharLength)(N.badge,ne)),N.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!wt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ne,ye){this.badge=N,this.tooltip=ne,this.color=ye}}e.FileDecoration=Mi;let Ri=class{constructor(N){this.kind=N}};Ri=je([z],Ri),e.ColorTheme=Ri;var vi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(vi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(N){return N instanceof Kt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ne){if(N<0)throw(0,A.illegalArgument)("start must be positive");if(ne<0)throw(0,A.illegalArgument)("end must be positive");N<=ne?(this.c=N,this.e=ne):(this.c=ne,this.e=N)}with(N){let ne=this.c,ye=this.e;return N.start!==void 0&&(ne=N.start),N.end!==void 0&&(ye=N.end),ne===this.c&&ye===this.e?this:new Kt(ne,ye)}}e.NotebookRange=Kt;class bi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ne=>bi.isNotebookCellData(ne))}static isNotebookCellData(N){return!0}constructor(N,ne,ye,qe,_e,st,ut){this.kind=N,this.value=ne,this.languageId=ye,this.mime=qe,this.outputs=_e??[],this.metadata=st,this.executionSummary=ut,bi.validate(this)}}e.NotebookCellData=bi;class Gi{constructor(N){this.cells=N}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(N){return N instanceof zt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ne={name:N.name,message:N.message,stack:N.stack};return zt.json(ne,"application/vnd.code.notebook.error")}static stdout(N){return zt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return zt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ne="application/octet-stream"){return new zt(N,ne)}static text(N,ne=O.Mimes.text){const ye=Le(zt,P,"f",g).encode(String(N));return new zt(ye,ne)}static json(N,ne="text/x-json"){const ye=JSON.stringify(N,void 0,"	");return zt.text(ye,ne)}constructor(N,ne){this.data=N,this.mime=ne;const ye=(0,O.normalizeMimeType)(ne,!0);if(!ye)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}P=zt,g={value:new TextEncoder},e.NotebookCellOutputItem=zt;class Ei{static isNotebookCellOutput(N){return N instanceof Ei?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ne=!1){const ye=new Set,qe=new Set;for(let _e=0;_e<N.length;_e++){const st=N[_e],ut=(0,O.normalizeMimeType)(st.mime);if(!ye.has(ut)||(0,b.isTextStreamMime)(ut)){ye.add(ut);continue}qe.add(_e),ne&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?N:N.filter((_e,st)=>!qe.has(st))}constructor(N,ne,ye){this.items=Ei.ensureUniqueMimeTypes(N,!0),typeof ne=="string"?(this.id=ne,this.metadata=ye):(this.id=(0,L.generateUuid)(),this.metadata=ne??ye)}}e.NotebookCellOutput=Ei;var Xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ji{constructor(N,ne){this.text=N,this.alignment=ne}}e.NotebookCellStatusBarItem=Ji;var Zi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Zi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var re;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(re=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ge{constructor(N,ne=[]){this.uri=N,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=ge;class Ne{constructor(N){this.label=N}}e.NotebookKernelSourceAction=Ne;let nt=class{constructor(N,ne){this.label=N,this.timestamp=ne}};nt=je([z],nt),e.TimelineItem=nt;var St;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(St=e.ExtensionMode||(e.ExtensionMode={}));var Rt;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Rt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(N,ne){this.ranges=N,this.wordPattern=ne}}e.LinkedEditingRanges=gn;class pn{constructor(N,ne){this.c=N,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=pn;var vn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(vn=e.TestResultState||(e.TestResultState={}));var bn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(bn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(N=void 0,ne=void 0,ye=void 0){this.include=N,this.exclude=ne,this.profile=ye}};Ui=je([z],Ui),e.TestRunRequest=Ui;let en=class extends Ui{constructor(N=void 0,ne=void 0,ye=void 0,qe=!1){super(N,ne,ye),this.continuous=qe}};en=je([z],en),e.TestRunRequest2=en;let tn=U=class{static diff(N,ne,ye){const qe=new U(N);return qe.expectedOutput=ne,qe.actualOutput=ye,qe}constructor(N){this.message=N}};tn=U=je([z],tn),e.TestMessage=tn;let nn=class{constructor(N){this.id=N}};nn=je([z],nn),e.TestTag=nn;let wi=class{constructor(N,ne){this.covered=N,this.total=ne}};wi=je([z],wi),e.CoveredCount=wi;let rn=$=class{static fromDetails(N,ne){const ye=new wi(0,0),qe=new wi(0,0),_e=new wi(0,0);for(const ut of ne)if("branches"in ut){ye.total+=1,ye.covered+=ut.executionCount>0?1:0;for(const Ft of ut.branches)qe.total+=1,qe.covered+=Ft.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const st=new $(N,ye,qe.total>0?qe:void 0,_e.total>0?_e:void 0);return st.detailedCoverage=ne,st}constructor(N,ne,ye,qe){this.uri=N,this.statementCoverage=ne,this.branchCoverage=ye,this.functionCoverage=qe}};rn=$=je([z],rn),e.FileCoverage=rn;let sn=class{constructor(N,ne,ye=[]){this.executionCount=N,this.location=ne,this.branches=ye}};sn=je([z],sn),e.StatementCoverage=sn;let on=class{constructor(N,ne){this.executionCount=N,this.location=ne}};on=je([z],on),e.BranchCoverage=on;let an=class{constructor(N,ne){this.executionCount=N,this.location=ne}};an=je([z],an),e.FunctionCoverage=an;var En;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(En=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(N,ne,ye,qe,_e,st){this.kind=N,this.name=ne,this.detail=ye,this.uri=qe,this.range=_e,this.selectionRange=st}}e.TypeHierarchyItem=yn;class Dn{constructor(N){this.uri=N}}e.TextTabInput=Dn;class In{constructor(N,ne){this.original=N,this.modified=ne}}e.TextDiffTabInput=In;class Cn{constructor(N,ne,ye,qe){this.base=N,this.input1=ne,this.input2=ye,this.result=qe}}e.TextMergeTabInput=Cn;class kn{constructor(N,ne){this.uri=N,this.viewType=ne}}e.CustomEditorTabInput=kn;class Tn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=Tn;class Pn{constructor(N,ne){this.uri=N,this.notebookType=ne}}e.NotebookEditorTabInput=Pn;class An{constructor(N,ne,ye){this.original=N,this.modified=ne,this.notebookType=ye}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class On{constructor(N,ne){this.uri=N,this.inputBoxUri=ne}}e.InteractiveWindowInput=On}),define(Pe[101],Ae([1,0,49,15,13,264,133,7,16]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const h=new Map;function L(p,d){d?h.set(p,d):h.delete(p)}e.setWordDefinitionFor=L;function D(p){return h.get(p)}class f extends F.MirrorTextModel{constructor(d,t,a,m,y,P,g,i){super(t,a,m,y),this.m=d,this.p=P,this.q=g,this.notebook=i,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,w.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===A.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,a){return d.y(t,a)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,n.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,n.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.d[t.start.line].substring(t.start.character,t.end.character);const a=this.f,m=t.start.line,y=t.end.line,P=[];P.push(this.d[m].substring(t.start.character));for(let g=m+1;g<y;g++)P.push(this.d[g]);return P.push(this.d[y].substring(0,t.end.character)),P.join(a)}t(d){let t;if(d instanceof R.Position?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.d.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.d[t],t===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const t=this.h.getIndexOf(d),a=this.d[t.index].length;return new R.Position(t.index,Math.min(t.remainder,a))}w(d){if(!(d instanceof R.Range))throw new Error("Invalid argument");const t=this.x(d.start),a=this.x(d.end);return t===d.start&&a===d.end?d:new R.Range(t.line,t.character,a.line,a.character)}x(d){if(!(d instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:t,character:a}=d,m=!1;if(t<0)t=0,a=0,m=!0;else if(t>=this.d.length)t=this.d.length-1,a=this.d[t].length,m=!0;else{const y=this.d[t].length;a<0?(a=0,m=!0):a>y&&(a=y,m=!0)}return m?new R.Position(t,a):d}y(d,t){const a=this.x(d);if(!t)t=D(this.p);else if((0,C.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const m=(0,O.getWordAtText)(a.character+1,(0,O.ensureValidWordDefinition)(t),this.d[a.line],0);if(m)return new R.Range(a.line,m.startColumn-1,a.line,m.endColumn-1)}}e.ExtHostDocumentData=f;class b{constructor(d,t,a){this.a=d,this.b=t,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Pe[198],Ae([1,0,7,18,5]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let F=class{constructor(R){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new C.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let w;switch(R){case"light":w=n.ColorThemeKind.Light;break;case"hcDark":w=n.ColorThemeKind.HighContrast;break;case"hcLight":w=n.ColorThemeKind.HighContrastLight;break;default:w=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(w),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};F=je([Ve(0,A.IExtHostRpcService)],F),e.ExtHostTheming=F}),define(Pe[8],Ae([1,0,16,25,118,199,87,28,114,66,65,23,9,2,44,76,92,98,97,72,45,56,195,7]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Te){function Oe(K){const{selectionStartLineNumber:Re,selectionStartColumn:ze,positionLineNumber:Ze,positionColumn:xe}=K,ot=new u.Position(Re-1,ze-1),ft=new u.Position(Ze-1,xe-1);return new u.Selection(ot,ft)}Te.to=Oe;function fe(K){const{anchor:Re,active:ze}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Te.from=fe})(r=e.Selection||(e.Selection={}));var c;(function(Te){function Oe(K){if(!K)return;const{start:Re,end:ze}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Te.from=Oe;function fe(K){if(!K)return;const{startLineNumber:Re,startColumn:ze,endLineNumber:Ze,endColumn:xe}=K;return new u.Range(Re-1,ze-1,Ze-1,xe-1)}Te.to=fe})(c=e.Range||(e.Range={}));var o;(function(Te){function Oe(fe){switch(fe){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Te.to=Oe})(o=e.TokenType||(e.TokenType={}));var k;(function(Te){function Oe(K){return new u.Position(K.lineNumber-1,K.column-1)}Te.to=Oe;function fe(K){return{lineNumber:K.line+1,column:K.character+1}}Te.from=fe})(k=e.Position||(e.Position={}));var s;(function(Te){function Oe(Re,ze){return(0,n.coalesce)((0,n.asArray)(Re).map(Ze=>fe(Ze,ze)))}Te.from=Oe;function fe(Re,ze){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:K(Re.scheme,ze),pattern:ve.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function K(Re,ze){return ze&&typeof Re=="string"?ze.transformOutgoingScheme(Re):Re}})(s=e.DocumentSelector||(e.DocumentSelector={}));var l;(function(Te){function Oe(K){switch(K){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Te.from=Oe;function fe(K){switch(K){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Te.to=fe})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(Te){function Oe(K){let Re;return K.code&&((0,f.isString)(K.code)||(0,f.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),{...c.from(K.range),message:K.message,source:K.source,code:Re,severity:E.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(S.from),tags:Array.isArray(K.tags)?(0,n.coalesce)(K.tags.map(l.from)):void 0}}Te.from=Oe;function fe(K){const Re=new u.Diagnostic(c.to(K),K.message,E.to(K.severity));return Re.source=K.source,Re.code=(0,f.isString)(K.code)?K.code:K.code?.value,Re.relatedInformation=K.relatedInformation&&K.relatedInformation.map(S.to),Re.tags=K.tags&&(0,n.coalesce)(K.tags.map(l.to)),Re}Te.to=fe})(v=e.Diagnostic||(e.Diagnostic={}));var S;(function(Te){function Oe(K){return{...c.from(K.location.range),message:K.message,resource:K.location.uri}}Te.from=Oe;function fe(K){return new u.DiagnosticRelatedInformation(new u.Location(K.resource,c.to(K)),K.message)}Te.to=fe})(S=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var E;(function(Te){function Oe(K){switch(K){case u.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Te.from=Oe;function fe(K){switch(K){case t.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Te.to=fe})(E=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var W;(function(Te){function Oe(K){return typeof K=="number"&&K>=u.ViewColumn.One?K-1:K===u.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Te.from=Oe;function fe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=fe})(W=e.ViewColumn||(e.ViewColumn={}));function G(Te){return typeof Te.range<"u"}function Y(Te){return Te.length===0?!0:!!G(Te[0])}e.isDecorationOptionsArr=Y;var J;(function(Te){function Oe(xe){return xe.map(Te.from)}Te.fromMany=Oe;function fe(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function K(xe){let ot;if(fe(xe)){const{language:ct,value:bt}=xe;ot={value:"```"+ct+`
`+bt+"\n```\n"}}else u.MarkdownString.isMarkdownString(xe)?ot={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?ot={value:xe}:ot={value:""};const ft=Object.create(null);ot.uris=ft;const mt=ct=>{try{let bt=b.URI.parse(ct,!0);bt=bt.with({query:Re(bt.query,ft)}),ft[ct]=bt}catch{}return""},lt=new w.marked.Renderer;return lt.link=mt,lt.image=ct=>typeof ct=="string"?mt(O.parseHrefAndDimensions(ct).href):"",(0,w.marked)(ot.value,{renderer:lt}),ot}Te.from=K;function Re(xe,ot){if(!xe)return xe;let ft;try{ft=(0,h.parse)(xe)}catch{}if(!ft)return xe;let mt=!1;return ft=(0,D.cloneAndChange)(ft,lt=>{if(b.URI.isUri(lt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ct]=lt,mt=!0,ct}else return}),mt?JSON.stringify(ft):xe}function ze(xe){const ot=new u.MarkdownString(xe.value,xe.supportThemeIcons);return ot.isTrusted=xe.isTrusted,ot.supportHtml=xe.supportHtml,ot.baseUri=xe.baseUri?b.URI.from(xe.baseUri):void 0,ot}Te.to=ze;function Ze(xe){if(!!xe)return typeof xe=="string"?xe:Te.from(xe)}Te.fromStrict=Ze})(J=e.MarkdownString||(e.MarkdownString={}));function q(Te){return Y(Te)?Te.map(Oe=>({range:c.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?J.fromMany(Oe.hoverMessage):Oe.hoverMessage?J.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Te.map(Oe=>({range:c.from(Oe)}))}e.fromRangeOrRangeWithMessage=q;function U(Te){return typeof Te>"u"?Te:typeof Te=="string"?b.URI.file(Te):Te}e.pathOrURIToURI=U;var $;(function(Te){function Oe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?U(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Te.from=Oe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Te){function Oe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?U(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}Te.from=Oe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Te){function Oe(fe){if(typeof fe>"u")return fe;switch(fe){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Oe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var he;(function(Te){function Oe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?j.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?U(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}Te.from=Oe})(he=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var we;(function(Te){function Oe(K){return{text:K.newText,eol:K.newEol&&rt.from(K.newEol),range:c.from(K.range)}}Te.from=Oe;function fe(K){const Re=new u.TextEdit(c.to(K.range),K.text);return Re.newEol=typeof K.eol>"u"?void 0:rt.to(K.eol),Re}Te.to=fe})(we=e.TextEdit||(e.TextEdit={}));var ie;(function(Te){function Oe(K,Re){const ze={edits:[]};if(K instanceof u.WorkspaceEdit){const Ze=new R.ResourceSet;for(const xe of K._allEntries())xe._type===1&&b.URI.isUri(xe.to)&&xe.from===void 0&&Ze.add(xe.to);for(const xe of K._allEntries())xe._type===1?ze.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contentsBase64:xe.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(xe.options.contents))},metadata:xe.metadata}):xe._type===2?ze.edits.push({resource:xe.uri,textEdit:we.from(xe.edit),versionId:Ze.has(xe.uri)?void 0:Re?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===6?ze.edits.push({resource:xe.uri,textEdit:{range:c.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Ze.has(xe.uri)?void 0:Re?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?ze.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&ze.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Dt.from)}})}return ze}Te.from=Oe;function fe(K){const Re=new u.WorkspaceEdit;for(const ze of K.edits)ze.textEdit?Re.replace(b.URI.revive(ze.resource),c.to(ze.textEdit.range),ze.textEdit.text):Re.renameFile(b.URI.revive(ze.oldResource),b.URI.revive(ze.newResource),ze.options);return Re}Te.to=fe})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(Te){const Oe=Object.create(null);Oe[u.SymbolKind.File]=0,Oe[u.SymbolKind.Module]=1,Oe[u.SymbolKind.Namespace]=2,Oe[u.SymbolKind.Package]=3,Oe[u.SymbolKind.Class]=4,Oe[u.SymbolKind.Method]=5,Oe[u.SymbolKind.Property]=6,Oe[u.SymbolKind.Field]=7,Oe[u.SymbolKind.Constructor]=8,Oe[u.SymbolKind.Enum]=9,Oe[u.SymbolKind.Interface]=10,Oe[u.SymbolKind.Function]=11,Oe[u.SymbolKind.Variable]=12,Oe[u.SymbolKind.Constant]=13,Oe[u.SymbolKind.String]=14,Oe[u.SymbolKind.Number]=15,Oe[u.SymbolKind.Boolean]=16,Oe[u.SymbolKind.Array]=17,Oe[u.SymbolKind.Object]=18,Oe[u.SymbolKind.Key]=19,Oe[u.SymbolKind.Null]=20,Oe[u.SymbolKind.EnumMember]=21,Oe[u.SymbolKind.Struct]=22,Oe[u.SymbolKind.Event]=23,Oe[u.SymbolKind.Operator]=24,Oe[u.SymbolKind.TypeParameter]=25;function fe(Re){return typeof Oe[Re]=="number"?Oe[Re]:6}Te.from=fe;function K(Re){for(const ze in Oe)if(Oe[ze]===Re)return Number(ze);return u.SymbolKind.Property}Te.to=K})(oe=e.SymbolKind||(e.SymbolKind={}));var de;(function(Te){function Oe(K){switch(K){case u.SymbolTag.Deprecated:return 1}}Te.from=Oe;function fe(K){switch(K){case 1:return u.SymbolTag.Deprecated}}Te.to=fe})(de=e.SymbolTag||(e.SymbolTag={}));var ke;(function(Te){function Oe(K){return{name:K.name,kind:oe.from(K.kind),tags:K.tags&&K.tags.map(de.from),containerName:K.containerName,location:ce.from(K.location)}}Te.from=Oe;function fe(K){const Re=new u.SymbolInformation(K.name,oe.to(K.kind),K.containerName,ce.to(K.location));return Re.tags=K.tags&&K.tags.map(de.to),Re}Te.to=fe})(ke=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Te){function Oe(K){const Re={name:K.name||"!!MISSING: name!!",detail:K.detail,range:c.from(K.range),selectionRange:c.from(K.selectionRange),kind:oe.from(K.kind),tags:K.tags?.map(de.from)??[]};return K.children&&(Re.children=K.children.map(Oe)),Re}Te.from=Oe;function fe(K){const Re=new u.DocumentSymbol(K.name,K.detail,oe.to(K.kind),c.to(K.range),c.to(K.selectionRange));return(0,n.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map(de.to)),K.children&&(Re.children=K.children.map(fe)),Re}Te.to=fe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(Te){function Oe(K){const Re=new u.CallHierarchyItem(oe.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),c.to(K.range),c.to(K.selectionRange));return Re._sessionId=K._sessionId,Re._itemId=K._itemId,Re}Te.to=Oe;function fe(K,Re,ze){if(Re=Re??K._sessionId,ze=ze??K._itemId,Re===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:ze,name:K.name,detail:K.detail,kind:oe.from(K.kind),uri:K.uri,range:c.from(K.range),selectionRange:c.from(K.selectionRange),tags:K.tags?.map(de.from)}}Te.from=fe})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var T;(function(Te){function Oe(fe){return new u.CallHierarchyIncomingCall(X.to(fe.from),fe.fromRanges.map(K=>c.to(K)))}Te.to=Oe})(T=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var V;(function(Te){function Oe(fe){return new u.CallHierarchyOutgoingCall(X.to(fe.to),fe.fromRanges.map(K=>c.to(K)))}Te.to=Oe})(V=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ce;(function(Te){function Oe(K){return{range:K.range&&c.from(K.range),uri:K.uri}}Te.from=Oe;function fe(K){return new u.Location(b.URI.revive(K.uri),c.to(K.range))}Te.to=fe})(ce=e.location||(e.location={}));var me;(function(Te){function Oe(K){const Re=K,ze=K;return{originSelectionRange:Re.originSelectionRange?c.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:ze.uri,range:c.from(Re.targetRange?Re.targetRange:ze.range),targetSelectionRange:Re.targetSelectionRange?c.from(Re.targetSelectionRange):void 0}}Te.from=Oe;function fe(K){return{targetUri:b.URI.revive(K.uri),targetRange:c.to(K.range),targetSelectionRange:K.targetSelectionRange?c.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?c.to(K.originSelectionRange):void 0}}Te.to=fe})(me=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Te){function Oe(K){return{range:c.from(K.range),contents:J.fromMany(K.contents)}}Te.from=Oe;function fe(K){return new u.Hover(K.contents.map(J.to),c.to(K.range))}Te.to=fe})(Fe=e.Hover||(e.Hover={}));var be;(function(Te){function Oe(K){return{range:c.from(K.range),expression:K.expression}}Te.from=Oe;function fe(K){return new u.EvaluatableExpression(c.to(K.range),K.expression)}Te.to=fe})(be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ee;(function(Te){function Oe(K){if(K instanceof u.InlineValueText)return{type:"text",range:c.from(K.range),text:K.text};if(K instanceof u.InlineValueVariableLookup)return{type:"variable",range:c.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Oe;function fe(K){switch(K.type){case"text":return{range:c.to(K.range),text:K.text};case"variable":return{range:c.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:c.to(K.range),expression:K.expression}}}Te.to=fe})(Ee=e.InlineValue||(e.InlineValue={}));var Ie;(function(Te){function Oe(K){return{frameId:K.frameId,stoppedLocation:c.from(K.stoppedLocation)}}Te.from=Oe;function fe(K){return new u.InlineValueContext(K.frameId,c.to(K.stoppedLocation))}Te.to=fe})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(Te){function Oe(K){return{range:c.from(K.range),kind:K.kind}}Te.from=Oe;function fe(K){return new u.DocumentHighlight(c.to(K.range),K.kind)}Te.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Te){function Oe(fe){switch(fe){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Te.to=Oe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Te){function Oe(fe){return{triggerKind:ae.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Te.to=Oe})(Z=e.CompletionContext||(e.CompletionContext={}));var I;(function(Te){function Oe(K){switch(K){case u.CompletionItemTag.Deprecated:return 1}}Te.from=Oe;function fe(K){switch(K){case 1:return u.CompletionItemTag.Deprecated}}Te.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var M;(function(Te){const Oe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function fe(ze){return Oe.get(ze)??9}Te.from=fe;const K=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Re(ze){return K.get(ze)??u.CompletionItemKind.Property}Te.to=Re})(M=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(Te){function Oe(fe,K){const Re=new u.CompletionItem(fe.label);return Re.insertText=fe.insertText,Re.kind=M.to(fe.kind),Re.tags=fe.tags?.map(I.to),Re.detail=fe.detail,Re.documentation=O.isMarkdownString(fe.documentation)?J.to(fe.documentation):fe.documentation,Re.sortText=fe.sortText,Re.filterText=fe.filterText,Re.preselect=fe.preselect,Re.commitCharacters=fe.commitCharacters,p.Range.isIRange(fe.range)?Re.range=c.to(fe.range):typeof fe.range=="object"&&(Re.range={inserting:c.to(fe.range.insert),replacing:c.to(fe.range.replace)}),Re.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Re.insertText=new u.SnippetString(fe.insertText):(Re.insertText=fe.insertText,Re.textEdit=Re.range instanceof u.Range?new u.TextEdit(Re.range,Re.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Re.additionalTextEdits=fe.additionalTextEdits.map(ze=>we.to(ze))),Re.command=K&&fe.command?K.fromInternal(fe.command):void 0,Re}Te.to=Oe})(H=e.CompletionItem||(e.CompletionItem={}));var x;(function(Te){function Oe(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:J.fromStrict(K.documentation)}}Te.from=Oe;function fe(K){return{label:K.label,documentation:O.isMarkdownString(K.documentation)?J.to(K.documentation):K.documentation}}Te.to=fe})(x=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(Te){function Oe(K){return{label:K.label,documentation:J.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(x.from):[],activeParameter:K.activeParameter}}Te.from=Oe;function fe(K){return{label:K.label,documentation:O.isMarkdownString(K.documentation)?J.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(x.to):[],activeParameter:K.activeParameter}}Te.to=fe})(te=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(Te){function Oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(te.from):[]}}Te.from=Oe;function fe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(te.to):[]}}Te.to=fe})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Ce;(function(Te){function Oe(fe,K){const Re=new u.InlayHint(k.to(K.position),typeof K.label=="string"?K.label:K.label.map(ue.to.bind(void 0,fe)),K.kind&&De.to(K.kind));return Re.textEdits=K.textEdits&&K.textEdits.map(we.to),Re.tooltip=O.isMarkdownString(K.tooltip)?J.to(K.tooltip):K.tooltip,Re.paddingLeft=K.paddingLeft,Re.paddingRight=K.paddingRight,Re}Te.to=Oe})(Ce=e.InlayHint||(e.InlayHint={}));var ue;(function(Te){function Oe(fe,K){const Re=new u.InlayHintLabelPart(K.label);return Re.tooltip=O.isMarkdownString(K.tooltip)?J.to(K.tooltip):K.tooltip,d.Command.is(K.command)&&(Re.command=fe.fromInternal(K.command)),K.location&&(Re.location=ce.to(K.location)),Re}Te.to=Oe})(ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Te){function Oe(K){return K}Te.from=Oe;function fe(K){return K}Te.to=fe})(De=e.InlayHintKind||(e.InlayHintKind={}));var Se;(function(Te){function Oe(K){return{range:c.from(K.range),url:K.target,tooltip:K.tooltip}}Te.from=Oe;function fe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?b.URI.parse(K.url,!0):b.URI.revive(K.url)}catch{}return new u.DocumentLink(c.to(K.range),Re)}Te.to=fe})(Se=e.DocumentLink||(e.DocumentLink={}));var $e;(function(Te){function Oe(K){const Re=new u.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=we.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(ze=>we.to(ze))),Re}Te.to=Oe;function fe(K){return{label:K.label,textEdit:K.textEdit?we.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>we.from(Re)):void 0}}Te.from=fe})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(Te){function Oe(K){return new u.Color(K[0],K[1],K[2],K[3])}Te.to=Oe;function fe(K){return[K.red,K.green,K.blue,K.alpha]}Te.from=fe})(He=e.Color||(e.Color={}));var et;(function(Te){function Oe(K){return{range:c.from(K.range)}}Te.from=Oe;function fe(K){return new u.SelectionRange(c.to(K.range))}Te.to=fe})(et=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Te){function Oe(fe){switch(fe){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Te.to=Oe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Te){function Oe(K){switch(K){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Oe;function fe(K){switch(K){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Te.to=fe})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Te){function Oe(K){if(K===u.EndOfLine.CRLF)return 1;if(K===u.EndOfLine.LF)return 0}Te.from=Oe;function fe(K){if(K===1)return u.EndOfLine.CRLF;if(K===0)return u.EndOfLine.LF}Te.to=fe})(rt=e.EndOfLine||(e.EndOfLine={}));var Me;(function(Te){function Oe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Oe})(Me=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Te){function Oe(K){const Re={start:K.start+1,end:K.end+1};return K.kind&&(Re.kind=Q.from(K.kind)),Re}Te.from=Oe;function fe(K){const Re={start:K.start-1,end:K.end-1};return K.kind&&(Re.kind=Q.to(K.kind)),Re}Te.to=fe})(it=e.FoldingRange||(e.FoldingRange={}));var Q;(function(Te){function Oe(K){if(K)switch(K){case u.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Te.from=Oe;function fe(K){if(K)switch(K.value){case d.FoldingRangeKind.Comment.value:return u.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports.value:return u.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region.value:return u.FoldingRangeKind.Region}}Te.to=fe})(Q=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(Te){function Oe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?c.from(fe.selection):void 0,override:typeof fe.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Te.from=Oe})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ve;(function(Te){function Oe(ze){return ze instanceof u.RelativePattern?ze.toJSON():typeof ze=="string"?ze:fe(ze)||K(ze)?new u.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Te.from=Oe;function fe(ze){const Ze=ze;return Ze?b.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(ze){const Ze=ze;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Re(ze){return typeof ze=="string"?ze:new u.RelativePattern(b.URI.revive(ze.baseUri),ze.pattern)}Te.to=Re})(ve=e.GlobPattern||(e.GlobPattern={}));var We;(function(Te){function Oe(fe){if(fe){if(Array.isArray(fe))return fe.map(Oe);if(typeof fe=="string")return fe;{const K=fe;return{language:K.language,scheme:K.scheme,pattern:ve.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Te.from=Oe})(We=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Te){function Oe(K){return{start:K.start,end:K.end}}Te.from=Oe;function fe(K){return new u.NotebookRange(K.start,K.end)}Te.to=fe})(Be=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(Te){function Oe(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Te.to=Oe;function fe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Te.from=fe})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(Te){function Oe(fe){if(fe===y.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(fe===y.NotebookCellExecutionState.Pending)return;if(fe===y.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Te.to=Oe})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(Te){function Oe(K){switch(K){case u.NotebookCellKind.Markup:return y.CellKind.Markup;case u.NotebookCellKind.Code:default:return y.CellKind.Code}}Te.from=Oe;function fe(K){switch(K){case y.CellKind.Markup:return u.NotebookCellKind.Markup;case y.CellKind.Code:default:return u.NotebookCellKind.Code}}Te.to=fe})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(Te){function Oe(K){const Re={metadata:K.metadata??Object.create(null),cells:[]};for(const ze of K.cells)u.NotebookCellData.validate(ze),Re.cells.push(Dt.from(ze));return Re}Te.from=Oe;function fe(K){const Re=new u.NotebookData(K.cells.map(Dt.to));return(0,f.isEmptyObject)(K.metadata)||(Re.metadata=K.metadata),Re}Te.to=fe})(at=e.NotebookData||(e.NotebookData={}));var Dt;(function(Te){function Oe(K){return{cellKind:Ge.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Qe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(It.from):[]}}Te.from=Oe;function fe(K){return new u.NotebookCellData(Ge.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(It.to):void 0,K.metadata,K.internalMetadata?Qe.to(K.internalMetadata):void 0)}Te.to=fe})(Dt=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(Te){function Oe(K){return{mime:K.mime,valueBytes:A.VSBuffer.wrap(K.data)}}Te.from=Oe;function fe(K){return new u.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Te.to=fe})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(Te){function Oe(K){return{outputId:K.id,items:K.items.map(Tt.from),metadata:K.metadata}}Te.from=Oe;function fe(K){const Re=K.items.map(Tt.to);return new u.NotebookCellOutput(Re,K.outputId,K.metadata)}Te.to=fe})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Te){function Oe(Re){return K(Re)?{include:(0,f.withNullAsUndefined)(ve.from(Re.include)),exclude:(0,f.withNullAsUndefined)(ve.from(Re.exclude))}:(0,f.withNullAsUndefined)(ve.from(Re))}Te.from=Oe;function fe(Re){return K(Re)?{include:ve.to(Re.include),exclude:ve.to(Re.exclude)}:ve.to(Re)}Te.to=fe;function K(Re){const ze=Re;return ze?!(0,f.isUndefinedOrNull)(ze.include)&&!(0,f.isUndefinedOrNull)(ze.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Mt;(function(Te){function Oe(fe,K,Re){const ze=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(ze,Re),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Te.from=Oe})(Mt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(Te){function Oe(fe,K,Re){const ze=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:K.toInternal(ze,Re),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Te.from=Oe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Xt;(function(Te){function Oe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Te.from=Oe})(Xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ht;(function(Te){function Oe(K){return{uri:K.uri,provides:K.provides}}Te.from=Oe;function fe(K){return new u.NotebookRendererScript(b.URI.revive(K.uri),K.provides)}Te.to=fe})(ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Te){function Oe(K){return{message:J.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:c.from(K.location.range),uri:K.location.uri}}}Te.from=Oe;function fe(K){const Re=new u.TestMessage(typeof K.message=="string"?K.message:J.to(K.message));return Re.actualOutput=K.actual,Re.expectedOutput=K.expected,Re.location=K.location?ce.to(K.location):void 0,Re}Te.to=fe})(gt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Te){Te.namespace=g.namespaceTestTag,Te.denamespace=g.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Ut;(function(Te){function Oe(K){const Re=(0,a.getPrivateApiFor)(K).controllerId;return{extId:P.TestId.fromExtHostTestItem(K,Re).toString(),label:K.label,uri:b.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(ze=>Ot.namespace(Re,ze.id)),range:p.Range.lift(c.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&J.fromStrict(K.error)||null}}Te.from=Oe;function fe(K){return{parent:void 0,error:void 0,id:P.TestId.fromString(K.extId).localId,label:K.label,uri:b.URI.revive(K.uri),tags:(K.tags||[]).map(Re=>{const{tagId:ze}=Ot.denamespace(Re);return new u.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Te.toPlain=fe})(Ut=e.TestItem||(e.TestItem={})),function(Te){function Oe(K){return{id:K.id}}Te.from=Oe;function fe(K){return new u.TestTag(K.id)}Te.to=fe}(Ot=e.TestTag||(e.TestTag={}));var Lt;(function(Te){const Oe=(K,Re)=>{const ze=[];for(const[xe,ot]of Re)P.TestId.compare(ot.item.extId,xe)===2&&(Re.delete(xe),ze.push(ot));const Ze={...Ut.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(ot=>ot.type===0).map(gt.to)})),children:ze.map(xe=>Oe(xe,Re))};for(const xe of Ze.children)xe.parent=Ze;return Ze};function fe(K){const Re=[],ze=new Map;for(const Ze of K.items){ze.set(Ze.item.extId,Ze);const xe=P.TestId.root(Ze.item.extId);K.request.targets.some(ot=>ot.controllerId===xe&&ot.testIds.includes(Ze.item.extId))&&Re.push(Ze)}return{completedAt:K.completedAt,results:Re.map(Ze=>Oe(Ze,ze))}}Te.to=fe})(Lt=e.TestResults||(e.TestResults={}));var pt;(function(Te){function Oe(ze){return{covered:ze.covered,total:ze.covered}}function fe(ze){return"line"in ze?k.from(ze):c.from(ze)}function K(ze){return"branches"in ze?{count:ze.executionCount,location:fe(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&fe(Ze.location)})):void 0}:{type:0,count:ze.executionCount,location:fe(ze.location)}}Te.fromDetailed=K;function Re(ze){return{uri:ze.uri,statement:Oe(ze.statementCoverage),branch:ze.branchCoverage&&Oe(ze.branchCoverage),function:ze.functionCoverage&&Oe(ze.functionCoverage),details:ze.detailedCoverage?.map(K)}}Te.fromFile=Re})(pt=e.TestCoverage||(e.TestCoverage={}));var Ct;(function(Te){function Oe(fe){switch(fe){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Te.to=Oe})(Ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Te){function Oe(K){const Re=new u.TypeHierarchyItem(oe.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),c.to(K.range),c.to(K.selectionRange));return Re._sessionId=K._sessionId,Re._itemId=K._itemId,Re}Te.to=Oe;function fe(K,Re,ze){if(Re=Re??K._sessionId,ze=ze??K._itemId,Re===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:ze,kind:oe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:c.from(K.range),selectionRange:c.from(K.selectionRange),tags:K.tags?.map(de.from)}}Te.from=fe})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var $t;(function(Te){function Oe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Te.from=Oe})($t=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Te){function Oe(ze,Ze,xe){const ot=Ze.fileData;return ot?new class extends u.DataTransferItem{asFile(){return{name:ot.name,uri:b.URI.revive(ot.uri),data:(0,F.once)(()=>xe())}}}("",Ze.id):ze===L.Mimes.uriList&&Ze.uriListData?new u.DataTransferItem(Re(Ze.uriListData)):new u.DataTransferItem(Ze.asString)}Te.to=Oe;async function fe(ze,Ze){const xe=await Ze.asString();if(ze===L.Mimes.uriList)return{id:Ze.id,asString:xe,fileData:void 0,uriListData:K(xe)};const ot=Ze.asFile();return{id:Ze.id,asString:xe,fileData:ot?{name:ot.name,uri:ot.uri}:void 0}}Te.from=fe;function K(ze){return C.UriList.split(ze).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return b.URI.parse(Ze)}catch{}return Ze})}function Re(ze){return C.UriList.create(ze.map(Ze=>typeof Ze=="string"?Ze:b.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Wt;(function(Te){function Oe(K,Re){const ze=K.items.map(([Ze,xe])=>[Ze,Ke.to(Ze,xe,()=>Re(xe.id))]);return new u.DataTransfer(ze)}Te.toDataTransfer=Oe;async function fe(K){const Re={items:[]},ze=[];return K.forEach((Ze,xe)=>{ze.push((async()=>{Re.items.push([xe,await Ke.from(xe,Ze)])})())}),await Promise.all(ze),Re}Te.toDataTransferDTO=fe})(Wt=e.DataTransfer||(e.DataTransfer={}))}),define(Pe[200],Ae([1,0,2,10,7,8,166]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(h,L,D,f={timeout:1500,errors:3}){this.c=h,this.d=L,this.f=D,this.g=f,this.a=new O.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(h){return(L,D,f)=>{const p={dispose:this.a.push([L,D,h])};return Array.isArray(f)&&f.push(p),p}}async $participateInSave(h,L){const D=n.URI.revive(h);let f=!1;const b=setTimeout(()=>f=!0,this.g.timeout),p=[];try{for(const d of[...this.a]){if(f)break;const t=this.d.getDocument(D),a=await this.h(d,{document:t,reason:F.TextDocumentSaveReason.to(L)});p.push(a)}}finally{clearTimeout(b)}return p}h([h,L,D],f){const b=this.b.get(h);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,h,L,f).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const d=this.b.get(h);this.b.set(h,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(h,L,D,f){const b=[],p=Date.now(),{document:d,reason:t}=f,{version:a}=d,m=Object.freeze({document:d,reason:t,waitUntil(y){if(Object.isFrozen(b))throw(0,A.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(y))}});try{L.apply(D,[m])}catch(y){return Promise.reject(y)}return Object.freeze(b),new Promise((y,P)=>{const g=setTimeout(()=>P(new Error("timeout")),this.g.timeout);return Promise.all(b).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(g),y(i)}).catch(i=>{clearTimeout(g),P(i)})}).then(y=>{const P={edits:[]};for(const g of y)if(Array.isArray(g)&&g.every(i=>i instanceof C.TextEdit))for(const{newText:i,newEol:u,range:r}of g)P.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&F.Range.from(r),text:i,eol:u&&F.EndOfLine.from(u)}});if(P.edits.length!==0)return a===d.version?this.f.$tryApplyWorkspaceEdit(P):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Pe[201],Ae([1,0,15,2,8,7,72]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(D,f,b,p){this.start=D,this.deletedCount=f,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new F.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(D,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,f,b){this.notebook=D,this.h=f,this.j=b,this.handle=b.handle,this.uri=A.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,f,b){const p=b.map(C.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===D);if(d&&(f||(d.items.length=0),d.items.push(...p),d.items.length>1&&d.items.every(t=>O.isTextStreamMime(t.mime)))){const t=new Map,a=[];d.items.forEach(m=>{let y;t.has(m.mime)?y=t.get(m.mime):(y=[],t.set(m.mime,y),a.push(m.mime)),y.push(m.data)}),d.items.length=0,a.forEach(m=>{const y=O.compressOutputItemStreams(t.get(m));d.items.push({mime:m,data:y.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=w;class h{constructor(D,f,b,p,d){this.k=D,this.l=f,this.m=b,this.uri=p,this.handle=h.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,f={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===n.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(d=>d.apiCell)},save(){return D.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,f,b){this.g=D.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},d=[];for(const a of D.rawEvents)a.kind===O.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,p.contentChanges):a.kind===O.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,p.contentChanges):a.kind===O.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===O.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===O.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===O.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===O.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===O.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),d.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===O.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),d.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const t=new Map;for(let a=0;a<d.length;a++){const m=d[a],y=t.get(m.cell);if(y===void 0){const P=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});t.set(m.cell,P-1)}else p.cellChanges[y]={...p.cellChanges[y],...m}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let f=D.start|0,b=D.end|0;return f<0&&(f=0),b>this.b.length&&(b=this.b.length),D.with({start:f,end:b})}p(D){D=this.o(D);const f=[];for(let b=D.start;b<D.end;b++)f.push(this.b[b]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,f,b){if(this.j)return;const p=[],d=[],t=[];if(D.reverse().forEach(a=>{const y=a[2].map(i=>{const u=new w(this,this.l,i);return f||d.push(w.asModelAddData(this.apiNotebook,i)),u}),P=new R(a[0],a[1],[],y),g=this.b.splice(a[0],a[1],...y);for(const i of g)t.push(i.uri),P.deletedItems.push(i.apiCell);p.push(P)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),b)for(const a of p)b.push(a.asApiEvent())}s(D,f,b,p){const d=this.b.splice(D,f);this.b.splice(b,0,...d);const t=[new R(D,f,d.map(a=>a.apiCell),[]),new R(b,0,[],d)];for(const a of t)p.push(a.asApiEvent())}t(D,f){this.b[D].setOutputs(f)}u(D,f,b,p){this.b[D].setOutputItems(f,b,p)}v(D,f){const b=this.b[D];b.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(b.uri,f)}w(D,f){const b=this.b[D];b.apiCell.mime=f}x(D,f){this.b[D].setMetadata(f)}y(D,f){this.b[D].setInternalMetadata(f)}getCellFromApiCell(D){return this.b.find(f=>f.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(f=>f.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}h.a=0,e.ExtHostNotebookDocument=h}),define(Pe[102],Ae([1,0,10,8,7]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class F{constructor(R,w,h,L,D,f){this.id=R,this.f=w,this.notebookData=h,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=L,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(w){this.selections=[w]},get selections(){return R.a},set selections(w){if(!Array.isArray(w)||!w.every(C.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");R.a=w,R.g(w)},get visibleRanges(){return R.b},revealRange(w,h){R.f.$tryRevealRange(R.id,A.NotebookRange.from(w),h??C.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(A.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}F.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=F}),define(Pe[202],Ae([1,0,10,5,14,8]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let O=class{constructor(w,h){this.c=w,this.d=h,this.a=new A.Emitter({onListenerError:n.onUnexpectedExternalError}),this.b=new A.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,h){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,h);const L=this.d.getEditorById(w);h.visibleRanges&&L._acceptVisibleRanges(h.visibleRanges.ranges.map(F.NotebookRange.to)),h.selections&&L._acceptSelections(h.selections.selections.map(F.NotebookRange.to)),h.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),h.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const h in w)this.d.getEditorById(h)._acceptViewColumn(F.ViewColumn.to(w[h]))}};O=je([Ve(0,C.ILogService)],O),e.ExtHostNotebookEditors=O}),define(Pe[203],Ae([1,0,8,170,146,21,64,10]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,b,p){const d=this.b++,{title:t,location:a,cancellable:m}=b,y={label:(0,C.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(d,{location:n.ProgressLocation.from(a),title:t,source:y,cancellable:m},f.isUnderDevelopment?void 0:f.identifier.value).catch(R.onUnexpectedExternalError),this.d(d,p,!!m)}d(f,b,p){let d;p&&(d=new F.CancellationTokenSource,this.c.set(f,d));const t=m=>{this.a.$progressEnd(m),this.c.delete(m),d?.dispose()};let a;try{a=b(new L(this.a,f),p&&d?d.token:F.CancellationToken.None)}catch(m){throw t(f),m}return a.then(m=>t(f),m=>t(f)),a}$acceptProgressCanceled(f){const b=this.c.get(f);b&&(b.cancel(),this.c.delete(f))}}e.ExtHostProgress=w;function h(D,f){return D.message=f.message,typeof f.increment=="number"&&(typeof D.increment=="number"?D.increment+=f.increment:D.increment=f.increment),D}class L extends A.Progress{constructor(f,b){super(p=>this.throttledReport(p)),this.c=f,this.d=b}throttledReport(f){this.c.$progressReport(this.d,f)}}je([(0,O.throttle)(100,(D,f)=>h(D,f),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Pe[103],Ae([1,0,44,98,45,73,56,8,2]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const h=(y,P,g,i)=>{let u=P;return{enumerable:!0,configurable:!1,get(){return u},set(r){if(!g(u,r)){const c=u;u=r,y.listener?.(i(r,c))}}}},L=(y,P)=>y===P,D={range:(y,P)=>y===P?!0:!y||!P?!1:y.isEqual(P),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(y,P)=>!(y.length!==P.length||y.some(g=>!P.find(i=>g.id===i.id)))},f=y=>P=>({op:4,update:y(P)}),b=(y,P)=>({range:(()=>{let g;const i=f(u=>({range:n.Range.lift(R.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return g},set(u){y.listener?.({op:6}),D.range(g,u)||(g=u,y.listener?.(i(u)))}}})(),label:h(y,P,D.label,f(g=>({label:g}))),description:h(y,void 0,D.description,f(g=>({description:g}))),sortText:h(y,void 0,D.sortText,f(g=>({sortText:g}))),canResolveChildren:h(y,!1,D.canResolveChildren,g=>({op:2,state:g})),busy:h(y,!1,D.busy,f(g=>({busy:g}))),error:h(y,void 0,D.error,f(g=>({error:R.MarkdownString.fromStrict(g)||null}))),tags:h(y,[],D.tags,(g,i)=>({op:1,new:g.map(R.TestTag.from),old:i.map(R.TestTag.from)}))}),p=y=>{const P=C.TestId.fromString(y.extId),g=new t(P.controllerId,P.localId,y.label,w.URI.revive(y.uri)||void 0);return g.range=R.Range.to(y.range||void 0),g.description=y.description||void 0,g.sortText=y.sortText||void 0,g.tags=y.tags.map(i=>R.TestTag.to({id:(0,O.denamespaceTestTag)(i).tagId})),g},d=y=>{let P;for(const g of y.tests){const i=p(g.item);(0,A.getPrivateApiFor)(i).parent=P,P=i}return P};e.toItemFromContext=d;class t{constructor(P,g,i,u){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const r=(0,A.createPrivateApiFor)(this,P);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof a?void 0:r.parent}},children:{value:(0,F.createTestItemChildren)(r,A.getPrivateApiFor,t),enumerable:!0,writable:!1},...b(r,i)})}}e.TestItemImpl=t;class a extends t{constructor(P,g){super(P,P,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class m extends F.TestItemCollection{constructor(P,g,i){super({controllerId:P,getDocumentVersion:u=>u&&i.getDocument(u)?.version,getApiFor:A.getPrivateApiFor,getChildren:u=>u.children,root:new a(P,g),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(Pe[104],Ae([1,0,49,10,84,8,7]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(f,b,p){const d=R.c.nextId();f.$registerTextEditorDecorationType(b.identifier,d,F.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:d,dispose(){f.$removeTextEditorDecorationType(d)}})}}R.c=new C.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=R;class w{constructor(f,b){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,b){this.k();let p=null;if(f instanceof O.Position)p=new O.Range(f,f);else if(f instanceof O.Range)p=f;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(f,b){this.k(),this.l(new O.Range(f,f),b,!0)}delete(f){this.k();let b=null;if(f instanceof O.Range)b=f;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(f,b,p){const d=this.c.validateRange(f);this.g.push({range:d,text:b,forceMoveMarkers:p})}setEndOfLine(f){if(this.k(),f!==O.EndOfLine.LF&&f!==O.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=f}}class h{constructor(f,b,p,d){this.c=f,this.d=b,this._accept(p),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(a){t.m(a)},get indentSize(){return t.g},set indentSize(a){t.o(a)},get insertSpaces(){return t.h},set insertSpaces(a){t.q(a)},get cursorStyle(){return t.j},set cursorStyle(a){t.s(a)},get lineNumbers(){return t.k},set lineNumbers(a){t.t(a)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}m(f){const b=this.l(f);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}o(f){const b=this.n(f);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const b=this.p(f);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(f)})))}assign(f){const b={};let p=!1;if(typeof f.tabSize<"u"){const d=this.l(f.tabSize);d==="auto"?(p=!0,b.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,p=!0,b.tabSize=d)}if(typeof f.indentSize<"u"){const d=this.n(f.indentSize);d==="tabSize"?(p=!0,b.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,p=!0,b.indentSize=d)}if(typeof f.insertSpaces<"u"){const d=this.p(f.insertSpaces);d==="auto"?(p=!0,b.insertSpaces=d):this.h!==d&&(this.h=d,p=!0,b.insertSpaces=d)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,p=!0,b.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,p=!0,b.lineNumbers=F.TextEditorLineNumbersStyle.from(f.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(f,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(p)})}}e.ExtHostTextEditorOptions=h;class L{constructor(f,b,p,d,t,a,m,y){this.id=f,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new h(this.j,this.id,a,p),this.e=m,this.f=y;const P=this;this.value=Object.freeze({get document(){return d.value},set document(g){throw(0,A.readonly)("document")},get selection(){return P.c&&P.c[0]},set selection(g){if(!(g instanceof O.Selection))throw(0,A.illegalArgument)("selection");P.c=[g],P.l()},get selections(){return P.c},set selections(g){if(!Array.isArray(g)||g.some(i=>!(i instanceof O.Selection)))throw(0,A.illegalArgument)("selections");P.c=g,P.l()},get visibleRanges(){return P.e},set visibleRanges(g){throw(0,A.readonly)("visibleRanges")},get options(){return P.d.value},set options(g){P.g||P.d.assign(g)},get viewColumn(){return P.f},set viewColumn(g){throw(0,A.readonly)("viewColumn")},edit(g,i={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new w(d.value,i);return g(u),P.m(u)},insertSnippet(g,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=P.c.map(c=>F.Range.from(c));else if(i instanceof O.Position){const{lineNumber:c,column:o}=F.Position.from(i);r=[{startLineNumber:c,startColumn:o,endLineNumber:c,endColumn:o}]}else if(i instanceof O.Range)r=[F.Range.from(i)];else{r=[];for(const c of i)if(c instanceof O.Range)r.push(F.Range.from(c));else{const{lineNumber:o,column:k}=F.Position.from(c);r.push({startLineNumber:o,startColumn:k,endLineNumber:o,endColumn:k})}}return b.$tryInsertSnippet(f,d.value.version,g.value,r,u)},setDecorations(g,i){const u=i.length===0;u&&!P.h.has(g.key)||(u?P.h.delete(g.key):P.h.add(g.key),P.n(()=>{if(F.isDecorationOptionsArr(i))return b.$trySetDecorations(f,g.key,F.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let c=0,o=i.length;c<o;c++){const k=i[c];r[4*c]=k.start.line+1,r[4*c+1]=k.start.character+1,r[4*c+2]=k.end.line+1,r[4*c+3]=k.end.character+1}return b.$trySetDecorationsFast(f,g.key,r)}}))},revealRange(g,i){P.n(()=>b.$tryRevealRange(f,F.Range.from(g),i||O.TextEditorRevealType.Default))},show(g){b.$tryShowEditor(f,F.ViewColumn.from(g))},hide(){b.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,n.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,n.ok)(!this.g),this.f=f}_acceptSelections(f){(0,n.ok)(!this.g),this.c=f}async l(){const f=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const b=f.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(t=>t.range);p.sort((t,a)=>t.end.line===a.end.line?t.end.character===a.end.character?t.start.line===a.start.line?t.start.character-a.start.character:t.start.line-a.start.line:t.end.character-a.end.character:t.end.line-a.end.line);for(let t=0,a=p.length-1;t<a;t++){const m=p[t].end;if(p[t+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=b.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,d,{setEndOfLine:typeof b.setEndOfLine=="number"?F.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=L}),define(Pe[204],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[205],Ae([1,0,159,10,29,90,70,30,24,204,169,96]),function(ee,e,n,A,C,F,O,R,w,h,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=R.Registry.as(O.Extensions.JSONContribution);class b{constructor(g,i,u){this.a=g,this.b=i,this.c=u}d(g,i){this.a({type:g,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(C.default.Error,g)}warn(g){this.d(C.default.Warning,g)}info(g){this.d(C.default.Info,g)}}e.ExtensionMessageCollector=b;class p{static a(g){const i=new w.ExtensionIdentifierSet;for(let u=0,r=g.length;u<r;u++)i.add(g[u].description.identifier);return i}static compute(g,i){if(!g||!g.length)return new p(i,[]);if(!i||!i.length)return new p([],g);const u=this.a(g),r=this.a(i),c=i.filter(k=>!u.has(k.description.identifier)),o=g.filter(k=>!r.has(k.description.identifier));return new p(c,o)}constructor(g,i){this.added=g,this.removed=i}}e.ExtensionPointUserDelta=p;class d{constructor(g,i){this.name=g,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=p.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,A.onUnexpectedError)(g)}}}e.ExtensionPoint=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class m{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const i=new d(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,i),g.activationEventsGenerator&&D.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,f.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=m;const y={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(y.ExtensionsRegistry,new m),e.ExtensionsRegistry=R.Registry.as(y.ExtensionsRegistry),f.registerSchema(a,e.schema),f.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}}]}}}})}),define(Pe[206],Ae([1,0,156,9,23,205,31,5]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var h;(function(f){function b(p,d,t){if(!p)return;const a=A.isString(p.type)?p.type:void 0;if(!a||a.length===0){t.error(n.localize(3,null));return}const m=[];if(Array.isArray(p.required))for(const y of p.required)A.isString(y)&&m.push(y);return{extensionId:d.value,taskType:a,required:m,properties:p.properties?C.deepClone(p.properties):{},when:p.when?O.ContextKeyExpr.deserialize(p.when):void 0}}f.from=b})(h||(h={}));const L=F.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:w}});class D{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{L.setHandler((d,t)=>{this.c=void 0;try{for(const a of t.removed){const m=a.value;for(const y of m)this.a&&y.type&&this.a[y.type]&&delete this.a[y.type]}for(const a of t.added){const m=a.value;for(const y of m){const P=h.from(y,a.description.identifier,a.collector);P&&(this.a[P.taskType]=P)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const d={type:"object",additionalProperties:!1};p.required.length>0&&(d.required=p.required.slice(0)),p.properties!==void 0?d.properties=C.deepClone(p.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[p.taskType]},b.push(d)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Pe[207],Ae([1,0,157,9,22,23,31,206]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new O.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var w;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function $(z){if(!z)return U.Strong;switch(z.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=$}(w=e.ShellQuoting||(e.ShellQuoting={}));var h;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(h=e.CommandOptions||(e.CommandOptions={}));var L;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(U){function $(z){switch(z.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=$}(L=e.RevealKind||(e.RevealKind={}));var D;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function $(z){switch(z.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=$}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(U){function $(z){switch(z.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=$}(f=e.PanelKind||(e.PanelKind={}));var b;(function(U){U.defaults={echo:!0,reveal:L.Always,revealProblems:D.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var p;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(p=e.RuntimeType||(e.RuntimeType={})),function(U){function $(j){switch(j.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=$;function z(j){switch(j){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=z}(p=e.RuntimeType||(e.RuntimeType={}));var d;(function(U){function $(z){return A.isString(z)?z:z.value}U.value=$})(d=e.CommandString||(e.CommandString={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function $(j){return j===U.Clean._id||j===U.Build._id||j===U.Rebuild._id||j===U.Test._id}U.is=$;function z(j){if(j!==void 0)return A.isString(j)?$(j)?{_id:j,isDefault:!1}:void 0:j}U.from=z})(t=e.TaskGroup||(e.TaskGroup={}));var a;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var m;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function $(z){switch(z){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=$})(m=e.TaskSourceKind||(e.TaskSourceKind={}));var y;(function(U){U.parallel="parallel",U.sequence="sequence"})(y=e.DependsOrder||(e.DependsOrder={}));var P;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(P=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:P.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class i{constructor($,z,j,he,we,ie){this._label="",this._id=$,z&&(this._label=z),j&&(this.type=j),this.runOptions=he,this.configurationProperties=we,this._source=ie}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,z=!1){if($===void 0)return!1;if(A.isString($))return $===this._label||$===this.configurationProperties.identifier||z&&$===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class u extends i{constructor($,z,j,he,we,ie,oe,de){super($,j,void 0,oe,de,z),this.command={},this._source=z,this.hasDefinedMatchers=ie,we&&(this.command=we)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case p.Shell:z="shell";break;case p.Process:z="process";break;case p.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is($){return $ instanceof u}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new u($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=u;class r extends i{constructor($,z,j,he,we,ie,oe){super($,j,he,ie,oe,z),this._source=z,this.configures=we}static is($){return $ instanceof r}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(j)}}e.ConfiguringTask=r;class c extends i{constructor($,z,j,he,we,ie,oe,de,ke){super($,j,he,de,ke,z),this.defines=we,this.hasDefinedMatchers=oe,this.command=ie,this.icon=ke.icon,this.hide=ke.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof c}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new c($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=c;class o extends i{constructor($,z,j,he,we,ie){super($,j,he,we,ie,z),this._source=z}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new o($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=o;var k;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(k=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(k=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor($){this.c=new Map;for(let z=0;z<$.length;z++)this.c.set($[z].uri.toString(),z)}compare($,z){const j=$.getWorkspaceFolder(),he=z.getWorkspaceFolder();if(j&&he){let we=this.c.get(j.uri.toString());we=we===void 0?0:we+1;let ie=this.c.get(he.uri.toString());return ie=ie===void 0?0:ie+1,we===ie?$._label.localeCompare(z._label):we-ie}else return!j&&he?-1:j&&!he?1:0}}e.TaskSorter=l;var v;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(U){U.SingleRun="singleRun",U.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var E;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(E=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(U){function $(z,j,he,we){if(j){const ie={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:j};return z==="start"?ie.resolvedVariables=we:z==="processStarted"?ie.processId=we:z==="processEnded"&&(ie.exitCode=we),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}U.create=$})(W=e.TaskEvent||(e.TaskEvent={}));var G;(function(U){function $(j){const he=Object.keys(j).sort();let we="";for(const ie of he){let oe=j[ie];oe instanceof Object?oe=$(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),we+=ie+","+oe+","}return we}function z(j){const we={_key:$(j),type:j.taskType};return Object.assign(we,j),we}U.create=z})(G=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var Y;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(Y=e.TaskSettingId||(e.TaskSettingId={}));var J;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(J=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var q;(function(U){function $(z,j){const he=R.TaskDefinitionRegistry.get(z.type);if(he===void 0){const de=F.deepClone(z);return delete de._key,G.create(de)}const we=Object.create(null);we.type=he.taskType;const ie=new Set;he.required.forEach(de=>ie.add(de));const oe=he.properties;for(const de of Object.keys(oe)){const ke=z[de];if(ke!=null)we[de]=ke;else if(ie.has(de)){const le=oe[de];if(le.default!==void 0)we[de]=F.deepClone(le.default);else switch(le.type){case"boolean":we[de]=!1;break;case"number":case"integer":we[de]=0;break;case"string":we[de]="";break;default:j.error(n.localize(2,null,JSON.stringify(z,void 0,0),de));return}}}return G.create(we)}U.createTaskIdentifier=$})(q=e.TaskDefinition||(e.TaskDefinition={}))}),define(Pe[208],Ae([1,0,10]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((O,R)=>{this.b=O,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(O){this.f||this.h||(this.f=!0,this.g=O,this.a&&this.b(O))}resolveErr(O){this.f||this.h||(this.h=!0,this.i=O,this.a?this.d(O):(0,n.onUnexpectedError)(O))}then(O,R){return this.j().then(O,R)}catch(O){return this.j().then(void 0,O)}finally(O){return this.j().finally(O)}}e.LazyPromise=A;class C extends A{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=C}),define(Pe[46],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const A=[];function C(R){const w=new n(R);return A[w.nid]=w,w}e.createProxyIdentifier=C;function F(R){return A[R].sid}e.getStringIdentifierForProxy=F;class O{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=O}),define(Pe[4],Ae([1,0,46]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var F;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(F=e.TabModelOperationKind||(e.TabModelOperationKind={}));var O;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(O=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var h;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(h=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(t){return t._id=D.a++,t}}D.a=0,e.IdObject=D;var f;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Pe[77],Ae([1,0,3,14,4,18]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let O=class{constructor(w,h){this.c=h,this.a=new Set,this.b=w.getProxy(C.MainContext.MainThreadTelemetry)}report(w,h,L){const D=this.d(w,h);this.a.has(D)||(this.a.add(D),h.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${w}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:h.identifier.value,apiId:w}))}d(w,h){return`${w}-${h.identifier.value}`}};O=je([Ve(0,F.IExtHostRpcService),Ve(1,A.ILogService)],O),e.ExtHostApiDeprecationService=O,e.NullApiDeprecationService=Object.freeze(new class{report(R,w,h){}})}),define(Pe[209],Ae([1,0,5,4,7,24]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class O{constructor(w){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=w.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,h,L,D={}){const f=F.ExtensionIdentifier.toKey(w.identifier),b=this.f.get(f)||[],p=[...L].sort().join(" ");let d=b.find(t=>t.providerId===h&&t.scopes===p);if(d)return d.result;{const t=this.g(w,f,h,L,D);d={providerId:h,scopes:p,result:t},b.push(d),this.f.set(f,b);try{await t}finally{const a=b.findIndex(m=>m.providerId===h&&m.scopes===p);a>-1&&(b.splice(a),this.f.set(f,b))}return t}}async g(w,h,L,D,f={}){await this.a.$ensureProvider(L);const b=w.displayName||w.name;return this.a.$getSession(L,D,h,b,f)}async removeSession(w,h){const L=this.b.get(w);return L?L.provider.removeSession(h):this.a.$removeSession(w,h)}registerAuthenticationProvider(w,h,L,D){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:h,provider:L,options:D??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===w)||this.c.push({id:w,label:h});const f=L.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(w,h,D?.supportsMultipleAccounts??!1),new C.Disposable(()=>{f.dispose(),this.b.delete(w);const b=this.c.findIndex(p=>p.id===w);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,h){const L=this.b.get(w);if(L)return Promise.resolve(L.provider.createSession(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,h){const L=this.b.get(w);if(L)return Promise.resolve(L.provider.removeSession(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,h){const L=this.b.get(w);if(L)return Promise.resolve(L.provider.getSessions(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,h){return this.d.fire({provider:{id:w,label:h}}),Promise.resolve()}}e.ExtHostAuthentication=O}),define(Pe[210],Ae([1,0,4,18,8]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let F=class{constructor(R,w){this.a=R.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:h=>w.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,w,h){const L=C.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,h?.isRefactoring??!1)}};F=je([Ve(0,A.IExtHostRpcService)],F),e.ExtHostBulkEdits=F}),define(Pe[211],Ae([1,0,4]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(F){const O=F.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return O.$readText()},writeText(R){return O.$writeText(R)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[38],Ae([1,0,9,7,8,23,4,16,14,66,44,265,2,6,3,18,103,25,46,40,78,52,57]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g,i){"use strict";var u,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(E,W,G){u.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),c.set(this,void 0),Je(this,u,E.getProxy(O.MainContext.MainThreadCommands),"f"),this.d=W,Je(this,c,G,"f"),Je(this,r,E.getProxy(O.MainContext.MainThreadTelemetry),"f"),this.converter=new k(this,Y=>{const J=this.c.get(Y);return J?.result===l.Void?J:void 0},W),this.f=[{processArgument(Y){return(0,h.revive)(Y)}},{processArgument(Y){return(0,F.cloneAndChange)(Y,function(J){if(L.Range.isIRange(J))return C.Range.to(J);if(D.Position.isIPosition(J))return C.Position.to(J);if(L.Range.isIRange(J.range)&&f.URI.isUri(J.uri))return C.location.to(J);if(J instanceof a.VSBuffer)return J.buffer.buffer;if(!Array.isArray(J))return J})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const W=this.registerCommand(!1,E.id,async(...G)=>{const Y=E.args.map((q,U)=>{if(!q.validate(G[U]))throw new Error(`Invalid argument '${q.name}' when running '${E.id}', received: ${G[U]}`);return q.convert(G[U])}),J=await this.executeCommand(E.internalId,...Y);return E.result.convert(J,G,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new A.Disposable(()=>{W.dispose(),this.c.delete(E.id)})}registerCommand(E,W,G,Y,J,q){if(this.d.trace("ExtHostCommands#registerCommand",W),!W.trim().length)throw new Error("invalid id");if(this.b.has(W))throw new Error(`command '${W}' already exists`);return this.b.set(W,{callback:G,thisArg:Y,description:J,extension:q}),E&&Le(this,u,"f").$registerCommand(W),new A.Disposable(()=>{this.b.delete(W)&&E&&Le(this,u,"f").$unregisterCommand(W)})}executeCommand(E,...W){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,W,!0)}async g(E,W,G){if(this.b.has(E))return Le(this,u,"f").$fireCommandActivationEvent(E),this.h(E,W,!1);{let Y=!1;const J=(0,F.cloneAndChange)(W,function(q){if(q instanceof A.Position)return C.Position.from(q);if(q instanceof A.Range)return C.Range.from(q);if(q instanceof A.Location)return C.location.from(q);if(A.NotebookRange.isNotebookRange(q))return C.NotebookRange.from(q);if(q instanceof ArrayBuffer)return Y=!0,a.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return Y=!0,a.VSBuffer.wrap(q);if(q instanceof a.VSBuffer)return Y=!0,q;if(!Array.isArray(q))return q});try{const q=await Le(this,u,"f").$executeCommand(E,Y?new m.SerializableObjectWithBuffers(J):J,G);return(0,h.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(E,W,!1);throw q}}}async h(E,W,G){const Y=this.b.get(E);if(!Y)throw new Error("Unknown command");const{callback:J,thisArg:q,description:U}=Y;if(U)for(let z=0;z<U.args.length;z++)try{(0,n.validateConstraint)(W[z],U.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${U.args[z].name}' - ${U.args[z].description}`)}const $=P.StopWatch.create();try{return await J.apply(q,W)}catch(z){if(E===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...W);j&&(E=j.command)}if(this.d.error(z,E,Y.extension?.identifier),!G)throw z;if(Y.extension?.identifier){const j=Le(this,c,"f").onExtensionError(Y.extension.identifier,z);this.d.trace("forwarded error to extension?",j,Y.extension?.identifier)}throw new class extends Error{constructor(){super((0,y.toErrorMessage)(z)),this.id=E,this.source=Y.extension?.displayName??Y.extension?.name}}}finally{this.j(Y,E,$.elapsed())}}j(E,W,G){!E.extension||Le(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new g.TelemetryTrustedValue(W),duration:G})}$executeContributedCommand(E,...W){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const G=this.b.get(E);return G?(W=W.map(Y=>this.f.reduce((J,q)=>q.processArgument(J,G.extension?.identifier),Y)),this.h(E,W,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),Le(this,u,"f").$getCommands().then(W=>(E&&(W=W.filter(G=>G[0]!=="_")),W))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[W,G]of this.b){const{description:Y}=G;Y&&(E[W]=Y)}return Promise.resolve(E)}};u=new WeakMap,r=new WeakMap,c=new WeakMap,o=je([Ve(0,d.IExtHostRpcService),Ve(1,w.ILogService),Ve(2,i.IExtHostTelemetry)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class k{constructor(E,W,G){this.d=E,this.f=W,this.g=G,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,W){if(!E)return;const G={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return G;const Y=this.f(E.command);if(Y)G.id=Y.internalId,G.arguments=Y.args.map((J,q)=>J.convert(E.arguments&&E.arguments[q]));else if((0,R.isNonEmptyArray)(E.arguments)){const J=`${E.command}/${++this.c}`;this.b.set(J,E),W.add((0,b.toDisposable)(()=>{this.b.delete(J),this.g.trace("CommandsConverter#DISPOSE",J)})),G.$ident=J,G.id=this.delegatingCommandId,G.arguments=[J],this.g.trace("CommandsConverter#CREATE",E.command,J)}return G}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const W=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],W?W.command:"MISSING"),W?this.d.executeCommand(W.command,...W.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.CommandsConverter=k;class s{constructor(E,W,G,Y){this.name=E,this.description=W,this.validate=G,this.convert=Y}optional(){return new s(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,W){return new s(E??this.name,W??this.description,this.validate,this.convert)}}s.Uri=new s("uri","Uri of a text document",S=>f.URI.isUri(S),S=>S),s.Position=new s("position","A position in a text document",S=>A.Position.isPosition(S),C.Position.from),s.Range=new s("range","A range in a text document",S=>A.Range.isRange(S),C.Range.from),s.Selection=new s("selection","A selection in a text document",S=>A.Selection.isSelection(S),C.Selection.from),s.Number=new s("number","",S=>typeof S=="number",S=>S),s.String=new s("string","",S=>typeof S=="string",S=>S),s.CallHierarchyItem=new s("item","A call hierarchy item",S=>S instanceof A.CallHierarchyItem,C.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",S=>S instanceof A.TypeHierarchyItem,C.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",S=>S instanceof t.TestItemImpl,C.TestItem.from),e.ApiCommandArgument=s;class l{constructor(E,W){this.description=E,this.convert=W}}l.Void=new l("no result",S=>S),e.ApiCommandResult=l;class v{constructor(E,W,G,Y,J){this.id=E,this.internalId=W,this.description=G,this.args=Y,this.result=J}}e.ApiCommand=v}),define(Pe[212],Ae([1,0,16,15,2,76,89,31,93,38,8,7]),function(ee,e,n,A,C,F,O,R,w,h,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const f=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(L.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,a)=>{if((0,n.isFalsyOrEmpty)(t))return;class m extends D.SymbolInformation{static to(P){const g=new m(P.name,L.SymbolKind.to(P.kind),P.containerName||"",new D.Location(a[0],L.Range.to(P.range)));return g.detail=P.detail,g.range=g.location.range,g.selectionRange=L.Range.to(P.selectionRange),g.children=P.children?P.children.map(m.to):[],g}}return t.map(m.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(L.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(L.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(L.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(L.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(L.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(a=>D.Position.isPosition(a)),t=>t.map(L.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(a=>{let m;for(const y of a.reverse())m=new D.SelectionRange(L.Range.to(y),m);return m}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(L.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(L.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(L.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(L.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:L.Range.to(t.range),placeholder:t.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return L.WorkspaceEdit.to(t)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(L.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,O.decodeSemanticTokensDto)(t);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,O.decodeSemanticTokensDto)(t);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,a,m)=>{if(!t)return new D.CompletionList([]);const y=t.suggestions.map(P=>L.CompletionItem.to(P,m));return new D.CompletionList(y,t.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return L.SignatureHelp.to(t)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,a,m)=>p(y=>new D.CodeLens(L.Range.to(y.range),y.command&&m.fromInternal(y.command)))(t))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.Range.isRange(t),t=>D.Selection.isSelection(t)?L.Selection.from(t):L.Range.from(t)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,a,m)=>p(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(y.command)}else{const P=new D.CodeAction(y.title,y.kind?new D.CodeActionKind(y.kind):void 0);return y.edit&&(P.edit=L.WorkspaceEdit.to(y.edit)),y.command&&(P.command=m.fromInternal(y.command)),P.isPreferred=y.isPreferred,P}})(t))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(a=>new D.ColorInformation(L.Range.to(a.range),L.Color.to(a.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",t=>t instanceof D.Color,L.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:L.Range.from(t.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(L.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,a,m)=>t.map(L.InlayHint.to.bind(void 0,m)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,a)=>{if(t)return t.map(L.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(a=>L.NotebookExclusiveDocumentPattern.to(a))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(L.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,w.matchesSomeScheme)(t,A.Schemas.http,A.Schemas.https),t=>t),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[L.ViewColumn.from(t),void 0]:[L.ViewColumn.from(t.viewColumn),L.TextEditorOpenOptions.from(t)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[L.ViewColumn.from(t),void 0]:[L.ViewColumn.from(t.viewColumn),L.TextEditorOpenOptions.from(t)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[L.ViewColumn.from(t.viewColumn),L.TextEditorOpenOptions.from(t)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(L.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(L.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(L.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],h.ApiCommandResult.Void)];class b{static register(a){f.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",R.validateWhenClauses)}}e.ExtHostApiCommands=b;function p(t){return a=>{if(Array.isArray(a))return a.map(t)}}function d(t){if(!Array.isArray(t))return;const a=[];for(const m of t)F.isLocationLink(m)?a.push(L.DefinitionLink.to(m)):a.push(L.location.to(m));return a}}),define(Pe[213],Ae([1,0,17,64,5,6,2,76,24,8,7,4]),function(ee,e,n,A,C,F,O,R,w,h,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(b,p,d){const t=b.getProxy(D.MainContext.MainThreadComments);class a{constructor(){this.b=new Map,this.c=new w.ExtensionIdentifierMap,p.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const k=this.b.get(o.handle);return k?k.value:o}else if(o&&o.$mid===7){const k=this.b.get(o.commentControlHandle);if(!k)return o;const s=k.getCommentThread(o.commentThreadHandle);return s?s.value:o}else if(o&&(o.$mid===9||o.$mid===8)){const k=this.b.get(o.thread.commentControlHandle);if(!k)return o;const s=k.getCommentThread(o.thread.commentThreadHandle);return s?o.$mid===8?s.value:{thread:s.value,text:o.text}:o}else if(o&&o.$mid===10){const k=this.b.get(o.thread.commentControlHandle);if(!k)return o;const s=k.getCommentThread(o.thread.commentThreadHandle);if(!s)return o;const l=o.commentUniqueId,v=s.getCommentByUniqueId(l);return v||o}else if(o&&o.$mid===11){const k=this.b.get(o.thread.commentControlHandle);if(!k)return o;const s=k.getCommentThread(o.thread.commentThreadHandle);if(!s)return o;const l=o.text,v=o.commentUniqueId,S=s.getCommentByUniqueId(v);return S?(typeof S.body=="string"?S.body=l:S.body=new L.MarkdownString(l),S):o}return o}})}createCommentController(o,k,s){const l=a.a++,v=new y(o,l,k,s);this.b.set(v.handle,v);const S=this.c.get(o.identifier)||[];return S.push(v),this.c.set(o.identifier,S),v.value}$createCommentThreadTemplate(o,k,s){const l=this.b.get(o);!l||l.$createCommentThreadTemplate(k,s)}async $updateCommentThreadTemplate(o,k,s){const l=this.b.get(o);!l||l.$updateCommentThreadTemplate(k,s)}$deleteCommentThread(o,k){this.b.get(o)?.$deleteCommentThread(k)}$provideCommentingRanges(o,k,s){const l=this.b.get(o);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const v=d.getDocument(O.URI.revive(k));return(0,n.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(v,s)).then(S=>S?S.map(E=>h.Range.from(E)):void 0)}$toggleReaction(o,k,s,l,v){const S=this.b.get(o);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const E=S.getCommentThread(k);if(E){const W=E.getCommentByUniqueId(l.uniqueIdInThread);if(S!==void 0&&W&&S.reactionHandler)return S.reactionHandler(W,i(v))}return Promise.resolve(void 0)})}dispose(){}}a.a=0;class m{set threadId(o){this.n=o}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(o){o.isEqual(this.p)||(this.p=o,this.b.range=o,this.c.fire())}get range(){return this.p}set canReply(o){this.d!==o&&(this.d=o,this.b.canReply=o,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(o){this.e=o,this.b.label=o,this.c.fire()}get contextValue(){return this.f}set contextValue(o){this.f=o,this.b.contextValue=o,this.c.fire()}get comments(){return this.q}set comments(o){this.q=o,this.b.comments=o,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(o){this.g=o,this.b.collapsibleState=o,this.c.fire()}get state(){return this.h}set state(o){this.h=o,this.b.state=o,this.c.fire()}get isDisposed(){return this.j}constructor(o,k,s,l,v,S,E,W){this.m=k,this.n=s,this.o=l,this.p=v,this.q=S,this.extensionDescription=E,this.r=W,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.MutableDisposable,this.l.value=new F.DisposableStore,this.n===void 0&&(this.n=`${o}.${this.handle}`),t.$createCommentThread(k,this.handle,this.n,this.o,h.Range.from(this.p),E.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{t.$deleteCommentThread(k,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(Y){G.range=Y},get comments(){return G.comments},set comments(Y){G.comments=Y},get collapsibleState(){return G.collapsibleState},set collapsibleState(Y){G.collapsibleState=Y},get canReply(){return G.canReply},set canReply(Y){G.canReply=Y},get contextValue(){return G.contextValue},set contextValue(Y){G.contextValue=Y},get label(){return G.label},set label(Y){G.label=Y},get state(){return G.state},set state(Y){G.state=Y},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.DisposableStore);const o=s=>Object.prototype.hasOwnProperty.call(this.b,s),k={};o("range")&&(k.range=h.Range.from(this.p)),o("label")&&(k.label=this.label),o("contextValue")&&(k.contextValue=this.contextValue??null),o("comments")&&(k.comments=this.q.map(s=>P(this,s,this.k))),o("collapsibleState")&&(k.collapseState=u(this.g)),o("canReply")&&(k.canReply=this.canReply),o("state")&&(k.state=r(this.h)),o("isTemplate")&&(k.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(o){for(const k of this.k){const s=k[0],l=k[1];if(o===l)return s}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(o=>o.dispose())}}m.a=0,je([(0,A.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class y{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(o){this.b=o,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(o){this.c=o,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this.d}set options(o){this.d=o,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(o,k,s,l){this.f=o,this.g=k,this.h=s,this.i=l,this.a=new Map,t.$registerCommentController(this.handle,s,l);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(S){v.options=S},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(S){v.commentingRangeProvider=S},get reactionHandler(){return v.reactionHandler},set reactionHandler(S){v.reactionHandler=S},createCommentThread(S,E,W){return v.createCommentThread(S,E,W).value},dispose:()=>{v.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(o,k,s,l){if(typeof o=="string"){const v=new m(this.id,this.handle,o,k,s,l,this.f,!1);return this.a.set(v.handle,v),v}else{const v=new m(this.id,this.handle,void 0,o,k,s,this.f,!1);return this.a.set(v.handle,v),v}}$createCommentThreadTemplate(o,k){const s=new m(this.id,this.handle,void 0,O.URI.revive(o),h.Range.to(k),[],this.f,!0);return s.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(s.handle,s),s}$updateCommentThreadTemplate(o,k){const s=this.a.get(o);s&&(s.range=h.Range.to(k))}$deleteCommentThread(o){this.a.get(o)?.dispose(),this.a.delete(o)}getCommentThread(o){return this.a.get(o)}dispose(){this.a.forEach(o=>{o.dispose()}),this.e.forEach(o=>o.dispose())}}function P(c,o,k){let s=k.get(o);s||(s=++c.commentHandle,k.set(o,s));const l=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:s,body:typeof o.body=="string"?o.body:h.MarkdownString.from(o.body),userName:o.author.name,userIconPath:l,label:o.label,commentReactions:o.reactions?o.reactions.map(v=>g(v)):void 0,timestamp:o.timestamp?.toJSON()}}function g(c){return{label:c.label,iconPath:c.iconPath?h.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function i(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?O.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function u(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function r(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new a}e.createExtHostComments=f}),define(Pe[214],Ae([1,0,23,4,27,18]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let O=class{constructor(L,D){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,D){const f=this,b=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){f.e(L,D,b,arguments)}})}e(L,D,f,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:w(b,this.b)}),this.c&&this.f(L,f,b)}};O=je([Ve(0,F.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],O),e.AbstractExtHostConsoleForwarder=O;const R=1e5;function w(h,L){const D=[];if(h.length)for(let f=0;f<h.length;f++){let b=h[f];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}D.push(b)}if(L){const f=new Error().stack;f&&D.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(D);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Pe[105],Ae([1,0,2,4,7,3,18,14,16,13,19,26]),function(ee,e,n,A,C,F,O,R,w,h,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class $i{constructor(p,d){this.h=d,this.f=new Map,this.g=p.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,d){const t=$i.c++;this.f.set(t,{provider:p,extensionDescription:d}),this.g.$registerDecorationProvider(t,d.identifier.value);const a=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(t,null);return}const y=(0,w.asArray)(m);if(y.length<=$i.d){this.g.$onDidChange(t,y);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,y.length);const P=y.map(u=>({uri:u,rank:(0,h.count)(u.path,"/")})),g=(0,w.groupBy)(P,(u,r)=>u.rank-r.rank||(0,h.compare)(u.uri.path,r.uri.path)),i=[];e:for(const u of g){let r;for(const c of u){const o=(0,L.dirname)(c.uri.path);if(r!==o&&(r=o,i.push(c.uri)>=$i.d))break e}}this.g.$onDidChange(t,i)});return new C.Disposable(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(p,d,t){if(!this.f.has(p))return Object.create(null);const a=Object.create(null),{provider:m,extensionDescription:y}=this.f.get(p);return await Promise.all(d.map(async P=>{try{const{uri:g,id:i}=P,u=await Promise.resolve(m.provideFileDecoration(n.URI.revive(g),t));if(!u)return;try{C.FileDecoration.validate(u),u.badge&&typeof u.badge!="string"&&(0,D.checkProposedApiEnabled)(y,"codiconDecoration"),a[i]=[u.propagate,u.tooltip,u.badge,u.color]}catch(r){this.h.warn(`INVALID decoration from extension '${y}': ${r}`)}}catch(g){this.h.error(g)}})),a}};f.c=0,f.d=250,f=je([Ve(0,O.IExtHostRpcService),Ve(1,R.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,F.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[215],Ae([1,0,143,92,2,4,7,8,5,14,28,37]),function(ee,e,n,A,C,F,O,R,w,h,L,D){"use strict";var f,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(m,y,P,g,i,u,r){this.d=m,this.e=y,this.f=P,this.g=g,f.set(this,void 0),b.set(this,void 0),p.set(this,void 0),this.c=!1,Je(this,p,new L.ResourceMap(c=>i.getComparisonKey(c)),"f"),Je(this,f,u,"f"),Je(this,b,r,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,f,"f")?.$clear(this.e),Le(this,p,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(m,y){if(!m){this.clear();return}this.h();let P=[];if(C.URI.isUri(m)){if(!y){this.delete(m);return}Le(this,p,"f").set(m,y.slice()),P=[m]}else if(Array.isArray(m)){P=[];let i;m=[...m].sort(d.j);for(const u of m){const[r,c]=u;if((!i||r.toString()!==i.toString())&&(i&&Le(this,p,"f").get(i).length===0&&Le(this,p,"f").delete(i),i=r,P.push(r),Le(this,p,"f").set(r,[])),c)Le(this,p,"f").get(r)?.push(...c);else{const o=Le(this,p,"f").get(r);o&&(o.length=0)}}}if(Le(this,b,"f").fire(P),!Le(this,f,"f"))return;const g=[];for(const i of P){let u=[];const r=Le(this,p,"f").get(i);if(r)if(r.length>this.f){u=[];const c=[O.DiagnosticSeverity.Error,O.DiagnosticSeverity.Warning,O.DiagnosticSeverity.Information,O.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const k of r)if(k.severity===c[o]&&u.push({...R.Diagnostic.from(k),modelVersionId:this.g(i)})===this.f)break e;u.push({severity:A.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this.f),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=r.map(c=>({...R.Diagnostic.from(c),modelVersionId:this.g(i)}));g.push([i,u])}Le(this,f,"f").$changeMany(this.e,g)}delete(m){this.h(),Le(this,b,"f").fire([m]),Le(this,p,"f").delete(m),Le(this,f,"f")?.$changeMany(this.e,[[m,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,f,"f")?.$clear(this.e)}forEach(m,y){this.h();for(const[P,g]of this)m.call(y,P,g,this)}*[(f=new WeakMap,b=new WeakMap,p=new WeakMap,Symbol.iterator)](){this.h();for(const m of Le(this,p,"f").keys())yield[m,this.get(m)]}get(m){this.h();const y=Le(this,p,"f").get(m);return Array.isArray(y)?Object.freeze(y.slice(0)):[]}has(m){return this.h(),Array.isArray(Le(this,p,"f").get(m))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(m,y){return m[0].toString()<y[0].toString()?-1:m[0].toString()>y[0].toString()?1:0}}e.DiagnosticCollection=d;let t=class Si{static _mapper(m){const y=new L.ResourceMap;for(const P of m)y.set(P,P);return{uris:Object.freeze(Array.from(y.values()))}}constructor(m,y,P,g){this.h=y,this.j=P,this.k=g,this.f=new Map,this.g=new w.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this.g.event,Si._mapper),this.e=m.getProxy(F.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,y){const{f:P,e:g,g:i,h:u,j:r,k:c}=this,o=new class{$changeMany(l,v){g.$changeMany(l,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,l,v.length===0?"CLEARING":v)}$clear(l){g.$clear(l),u.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,l)}dispose(){g.dispose()}};let k;if(!y)y="_generated_diagnostic_collection_name_#"+Si.c++,k=y;else if(!P.has(y))k=y;else{this.h.warn(`DiagnosticCollection with name '${y}' does already exist.`);do k=y+Si.c++;while(P.has(k))}return new class extends d{constructor(){super(y,k,Si.d,l=>c.getDocument(l)?.version,r.extUri,o,i),P.set(k,this)}dispose(){super.dispose(),P.delete(k)}}}getDiagnostics(m){if(m)return this.l(m);{const y=new Map,P=[];for(const g of this.f.values())g.forEach((i,u)=>{let r=y.get(i.toString());typeof r>"u"&&(r=P.length,y.set(i.toString(),r),P.push([i,[]])),P[r][1]=P[r][1].concat(...u)});return P}}l(m){let y=[];for(const P of this.f.values())P.has(m)&&(y=y.concat(P.get(m)));return y}$acceptMarkersChange(m){if(!this.m){const y="_generated_mirror",P=new d(y,y,Si.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(y,P),this.m=P}for(const[y,P]of m)this.m.set(C.URI.revive(y),P.map(R.Diagnostic.to))}};t.c=0,t.d=1e3,t=je([Ve(1,h.ILogService),Ve(2,D.IExtHostFileSystemInfo)],t),e.ExtHostDiagnostics=t}),define(Pe[216],Ae([1,0,2,4,26]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class F{constructor(R){this.a=R.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(R,w){return w?.allowUIResources&&(0,C.checkProposedApiEnabled)(R,"showLocal"),this.a.$showOpenDialog(w).then(h=>h?h.map(L=>n.URI.revive(L)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(w=>w?n.URI.revive(w):void 0)}}e.ExtHostDialogs=F}),define(Pe[217],Ae([1,0,10,2,7,4,15,21,13]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class h{constructor(D,f,b){this.d=f,this.e=b,this.b=new Map,this.c=D.getProxy(F.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,f){if(Object.keys(O.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=h.a++;this.b.set(b,f),this.c.$registerTextContentProvider(b,D);let p;return typeof f.onDidChange=="function"&&(p=f.onDidChange(d=>{if(d.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(b,d).then(t=>{if(!t&&typeof t!="string")return;const a=this.d.getDocument(d);if(!a)return;const m=(0,w.splitLines)(t);if(!a.equalLines(m))return this.c.$onVirtualDocumentChange(d,t)},n.onUnexpectedError)})),new C.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,f){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(A.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}h.a=0,e.ExtHostDocumentContentProvider=h}),define(Pe[218],Ae([1,0,5,6,2,4,101,8,9,23,7]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,p){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=b.getProxy(F.MainContext.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(d=>{for(const t of d)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const t of d)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const p=this.g.getDocument(b);if(p)return p}getDocument(b){const p=this.getDocumentData(b);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return p.document}ensureDocumentData(b){const p=this.g.getDocument(b);if(p)return Promise.resolve(p);let d=this.h.get(b.toString());return d||(d=this.f.$tryOpenDocument(b).then(t=>{this.h.delete(b.toString());const a=C.URI.revive(t);return(0,w.assertIsDefined)(this.g.getDocument(a))},t=>(this.h.delete(b.toString()),Promise.reject(t))),this.h.set(b.toString(),d)),d}createDocumentData(b){return this.f.$tryCreateDocument(b).then(p=>C.URI.revive(p))}$acceptModelLanguageChanged(b,p){const d=C.URI.revive(b),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(p),this.a.fire(t.document)}$acceptModelSaved(b){const p=C.URI.revive(b),d=this.g.getDocument(p);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(b,p){const d=C.URI.revive(b),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");t._acceptIsDirty(p),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,p,d){const t=C.URI.revive(b),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),a.onEvents(p);let m;p.isUndoing?m=L.TextDocumentChangeReason.Undo:p.isRedoing&&(m=L.TextDocumentChangeReason.Redo),this.c.fire((0,h.deepFreeze)({document:a.document,contentChanges:p.changes.map(y=>({range:R.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:m}))}setWordDefinitionFor(b,p){(0,O.setWordDefinitionFor)(b,p)}}e.ExtHostDocuments=D}),define(Pe[58],Ae([1,0,49,5,6,2,3,4,101,18,104,8,14,28,15,190,86]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(P){this.value=P,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(P,g){this.h=P,this.i=g,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(P){this.acceptDocumentsAndEditorsDelta(P)}acceptDocumentsAndEditorsDelta(P){const g=[],i=[],u=[];if(P.removedDocuments)for(const r of P.removedDocuments){const c=F.URI.revive(r),o=this.c.get(c);o?.unref()&&(this.c.delete(c),g.push(o.value))}if(P.addedDocuments)for(const r of P.addedDocuments){const c=F.URI.revive(r.uri);let o=this.c.get(c);if(o&&c.scheme!==p.Schemas.vscodeNotebookCell&&c.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);o||(o=new a(new w.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(c,o),i.push(o.value)),o.ref()}if(P.removedEditors)for(const r of P.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&u.push(c)}if(P.addedEditors)for(const r of P.addedEditors){const c=F.URI.revive(r.documentUri);n.ok(this.c.has(c),`document '${c}' does not exist`),n.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const o=this.c.get(c).value,k=new L.ExtHostTextEditor(r.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>o.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(s=>D.Range.to(s)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,k)}P.newActiveEditor!==void 0&&(n.ok(P.newActiveEditor===null||this.b.has(P.newActiveEditor),`active editor '${P.newActiveEditor}' does not exist`),this.a=P.newActiveEditor),(0,C.dispose)(g),(0,C.dispose)(u),P.removedDocuments&&this.e.fire(g),P.addedDocuments&&this.d.fire(i),(P.removedEditors||P.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),P.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(P){return this.c.get(P)?.value}allDocuments(){return d.Iterable.map(this.c.values(),P=>P.value)}getEditor(P){return this.b.get(P)}activeEditor(P){if(!this.a)return;const g=this.b.get(this.a);return P?g:g?.value}allEditors(){return[...this.b.values()]}};m=je([Ve(0,h.IExtHostRpcService),Ve(1,f.ILogService)],m),e.ExtHostDocumentsAndEditors=m,e.IExtHostDocumentsAndEditors=(0,O.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[59],Ae([1,0,8,4,2,5,3,7,18,9,63]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,O.createDecorator)("IExtHostEditorTabs");class D{constructor(t,a,m){this.e=m,this.d=a,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(C.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(t,a){this.c=[],this.d="",this.b=t,this.e=a;for(const m of t.tabs)m.isActive&&(this.d=m.id),this.c.push(new D(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return n.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(m=>m.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(m=>m.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const m=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,m),t.tabDto.isActive&&(this.d=m.tabId),m}else if(t.kind===1){const m=this.c.splice(t.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(t.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,m),m}const a=this.c.find(m=>m.tabId===t.tabDto.id);if(!a)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(t.tabDto),a}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new F.Emitter,this.c=new F.Emitter,this.e=[],this.a=t.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,a={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(m=>m.apiObject))},get activeTabGroup(){const m=t.d;return(0,h.assertIsDefined)(t.e.find(P=>P.groupId===m)?.apiObject)},close:async(m,y)=>{const P=Array.isArray(m)?m:[m];return P.length?p(P[0])?this.j(P,y):this.i(P,y):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(t){const a=new Set(this.e.map(r=>r.groupId)),m=new Set(t.map(r=>r.groupId)),y=(0,L.diffSets)(a,m),P=this.e.filter(r=>y.removed.includes(r.groupId)).map(r=>r.apiObject),g=[],i=[];this.e=t.map(r=>{const c=new f(r,()=>this.d);return y.added.includes(c.groupId)?g.push(c.apiObject):i.push(c.apiObject),c});const u=(0,h.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:g,closed:P,changed:i}))}$acceptTabGroupUpdate(t){const a=this.e.find(m=>m.groupId===t.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const a=this.e.find(y=>y.groupId===t.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const m=a.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(t){for(const a of this.e)for(const m of a.tabs)if(m.apiObject===t)return m}h(t){return this.e.find(a=>a.apiObject===t)}async i(t,a){const m=[];for(const y of t){const P=this.g(y);if(!P)throw new Error("Tab close: Invalid tab not found!");m.push(P.tabId)}return this.a.$closeTab(m,a)}async j(t,a){const m=[];for(const y of t){const P=this.h(y);if(!P)throw new Error("Group close: Invalid group not found!");m.push(P.groupId)}return this.a.$closeGroup(m,a)}};b=je([Ve(0,w.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function p(d){return d.tabs!==void 0}}),define(Pe[219],Ae([1,0,2,4,6,7,8,266,13,25,26]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const d=this.a.indexOf(p);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),d=[];let t,a,m=14,y=14;for(const P of p){let g=t?(0,w.commonPrefixLength)(t,P):0;for(g===0?a=1:a=y;g<P.length;g++)g+1===P.length?(m=y,y=9):y+=1,d.push([a,P.toUpperCase().charCodeAt(g),y]),d.push([a,P.toLowerCase().charCodeAt(g),y]),a=y;t=P,y=m}d.push([9,58,10]),d.push([10,47,12]),this.b=new R.StateMachine(d)}}provideDocumentLinks(p){this.c();const d=[],t=R.LinkComputer.computeLinks({getLineContent(a){return p.lineAt(a-1).text},getLineCount(){return p.lineCount}},this.b);for(const a of t){const m=O.DocumentLink.to(a);m.target&&d.push(m)}return d}}class f{constructor(p,d){this.i=d,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,d,t,a={}){if(f.j(t),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const m=this.h++;this.b.add(d),this.d.add(d),this.c.set(m,t);let y=2;a.isCaseSensitive&&(y+=1024),a.isReadonly&&(y+=2048),typeof t.copy=="function"&&(y+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,L.checkProposedApiEnabled)(p,"fsChunks"),y+=4),this.a.$registerFileSystemProvider(m,d,y).catch(g=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${d}`),console.error(g)});const P=t.onDidChangeFile(g=>{const i=[];for(const u of g){const{uri:r,type:c}=u;if(r.scheme!==d)continue;let o;switch(c){case F.FileChangeType.Changed:o=0;break;case F.FileChangeType.Created:o=1;break;case F.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:o})}this.a.$onFileSystemChange(m,i)});return(0,C.toDisposable)(()=>{P.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:d,ctime:t,mtime:a,size:m,permissions:y}=p;return{type:d,ctime:t,mtime:a,size:m,permissions:y}}$stat(p,d){return Promise.resolve(this.l(p).stat(n.URI.revive(d))).then(t=>f.k(t))}$readdir(p,d){return Promise.resolve(this.l(p).readDirectory(n.URI.revive(d)))}$readFile(p,d){return Promise.resolve(this.l(p).readFile(n.URI.revive(d))).then(t=>h.VSBuffer.wrap(t))}$writeFile(p,d,t,a){return Promise.resolve(this.l(p).writeFile(n.URI.revive(d),t.buffer,a))}$delete(p,d,t){return Promise.resolve(this.l(p).delete(n.URI.revive(d),t))}$rename(p,d,t,a){return Promise.resolve(this.l(p).rename(n.URI.revive(d),n.URI.revive(t),a))}$copy(p,d,t,a){const m=this.l(p);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(n.URI.revive(d),n.URI.revive(t),a))}$mkdir(p,d){return Promise.resolve(this.l(p).createDirectory(n.URI.revive(d)))}$watch(p,d,t,a){const m=this.l(p).watch(n.URI.revive(t),a);this.f.set(d,m)}$unwatch(p,d){const t=this.f.get(d);t&&(t.dispose(),this.f.delete(d))}$open(p,d,t){const a=this.l(p);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(n.URI.revive(d),t))}$close(p,d){const t=this.l(p);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(d))}$read(p,d,t,a){const m=this.l(p);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const y=h.VSBuffer.alloc(a);return Promise.resolve(m.read(d,t,y.buffer,0,a)).then(P=>y.slice(0,P))}$write(p,d,t,a){const m=this.l(p);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(d,t,a.buffer,0,a.byteLength))}l(p){const d=this.c.get(p);if(!d){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return d}}e.ExtHostFileSystem=f}),define(Pe[60],Ae([1,0,4,43,7,25,3,18,37,6]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Jt{constructor(f,b){this.b=new Map,this.a=f.getProxy(n.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(d){try{const t=p.b.get(d.scheme);if(!t)return await p.a.$stat(d);await p.a.$ensureActivation(d.scheme);const a=await t.stat(d);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(t){Jt.c(t)}},async readDirectory(d){try{const t=p.b.get(d.scheme);return t?(await p.a.$ensureActivation(d.scheme),(await t.readDirectory(d)).slice()):await p.a.$readdir(d)}catch(t){return Jt.c(t)}},async createDirectory(d){try{return await p.a.$mkdir(d)}catch(t){return Jt.c(t)}},async readFile(d){try{const t=p.b.get(d.scheme);return t?(await p.a.$ensureActivation(d.scheme),(await t.readFile(d)).slice()):(await p.a.$readFile(d)).buffer}catch(t){return Jt.c(t)}},async writeFile(d,t){try{return await p.a.$writeFile(d,F.VSBuffer.wrap(t))}catch(a){return Jt.c(a)}},async delete(d,t){try{const a=p.b.get(d.scheme);return a?(await p.a.$ensureActivation(d.scheme),await a.delete(d,{recursive:!1,...t})):await p.a.$delete(d,{recursive:!1,useTrash:!1,...t})}catch(a){return Jt.c(a)}},async rename(d,t,a){try{return await p.a.$rename(d,t,{overwrite:!1,...a})}catch(m){return Jt.c(m)}},async copy(d,t,a){try{return await p.a.$copy(d,t,{overwrite:!1,...a})}catch(m){return Jt.c(m)}},isWritableFileSystem(d){const t=b.getCapabilities(d);if(typeof t=="number")return!(t&2048)}})}static c(f){if(f instanceof C.FileSystemError)throw f;if(!(f instanceof Error))throw new C.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw C.FileSystemError.Unavailable(f.message);switch(f.name){case A.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(f.message);case A.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(f.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(f.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(f.message);case A.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(f.message);case A.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(f.message);default:throw new C.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,b){return this.b.set(f,b),(0,h.toDisposable)(()=>this.b.delete(f))}};L=je([Ve(0,R.IExtHostRpcService),Ve(1,w.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,O.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[220],Ae([1,0,5,36,2,4,8,7]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,f,b,p,d,t,a,m){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const y=this.h(D,b,d);this.g=0,t&&(this.g+=1),a&&(this.g+=2),m&&(this.g+=4);const P=(0,A.parse)(d),g=typeof d=="string",i=p(u=>{if(!t)for(const r of u.created){const c=C.URI.revive(r);P(c.fsPath)&&(!g||f.getWorkspaceFolder(c))&&this.a.fire(c)}if(!a)for(const r of u.changed){const c=C.URI.revive(r);P(c.fsPath)&&(!g||f.getWorkspaceFolder(c))&&this.b.fire(c)}if(!m)for(const r of u.deleted){const c=C.URI.revive(r);P(c.fsPath)&&(!g||f.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=R.Disposable.from(y,this.a,this.b,this.c,i)}h(D,f,b){const p=R.Disposable.from();if(typeof b=="string")return p;const d=D.getProxy(F.MainContext.MainThreadFileSystem);let t=!1;(b.pattern.includes(A.GLOBSTAR)||b.pattern.includes(A.GLOB_SPLIT))&&(t=!0);const a=Math.random();return d.$watch(f.identifier.value,a,b.baseUri,{recursive:t,excludes:[]}),R.Disposable.from({dispose:()=>d.$unwatch(a)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class h{constructor(D,f,b){this.j=D,this.k=f,this.l=b,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,f,b,p,d,t){return new w(this.j,D,f,this.a.event,O.GlobPattern.from(b),p,d,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,f){switch(D){case 2:this.b.fire(Object.freeze({files:f.map(b=>({oldUri:C.URI.revive(b.source),newUri:C.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(b=>C.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(b=>C.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,f){return(b,p,d)=>{const t=function(m){b.call(p,m)};return t.extension=D,f.event(t,void 0,d)}}async $onWillRunFileOperation(D,f,b,p){switch(D){case 2:return await this.n(this.g,{files:f.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},b,p);case 1:return await this.n(this.i,{files:f.map(d=>C.URI.revive(d.target))},b,p);case 0:case 3:return await this.n(this.h,{files:f.map(d=>C.URI.revive(d.target))},b,p)}}async n(D,f,b,p){const d=new Set,t=[];if(await D.fireAsync(f,p,async(m,y)=>{const P=Date.now(),g=await Promise.resolve(m);g instanceof R.WorkspaceEdit&&(t.push([y.extension,g]),d.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-P>b&&this.k.warn("SLOW file-participant",y.extension.identifier)}),p.isCancellationRequested||t.length===0)return;const a={edits:[]};for(const[,m]of t){const{edits:y}=O.WorkspaceEdit.from(m,{getTextDocumentVersion:P=>this.l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(y)}return{edit:a,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=h}),define(Pe[221],Ae([1,0,2,38]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(O,R,w,h,L){this.a=R,this.b=w,this.c=h;const D=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new A.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new A.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new A.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new A.ApiCommandResult("Notebook and input URI",f=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const b=this.a.getEditorById(f.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:b.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(O,R,w,h){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:w,uri:O,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(h))?.apiNotebook}]})}$willRemoveInteractiveDocument(O,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[O]})}}e.ExtHostInteractive=C}),define(Pe[222],Ae([1,0,6,2,4,8]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class O{constructor(h,L){this.extension=h,this.provider=L,this.handle=O.a++}}O.a=0;class R{constructor(h,L,D){this.e=L,this.f=D,this.b=new Map,this.c=new Map,this.d=h.getProxy(C.MainContext.MainThreadInteractiveEditor)}registerProvider(h,L){const D=new O(h,L);return this.b.set(D.handle,D),this.d.$registerInteractiveEditorProvider(D.handle,h.identifier.value),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(D.handle),this.b.delete(D.handle)})}async $prepareInteractiveSession(h,L,D,f){const b=this.b.get(h);if(!b){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const p=this.e.getDocument(A.URI.revive(L)),d=await b.provider.prepareInteractiveEditorSession({document:p,selection:F.Selection.to(D)},f);if(!d)return;const t=R.a++;return this.c.set(t,d),{id:t,placeholder:d.placeholder}}async $provideResponse(h,L,D,f){const b=this.b.get(h);if(!b)return;const p=this.c.get(L.id);if(!p)return;const d=await b.provider.provideInteractiveEditorResponse({session:p,prompt:D.prompt,selection:F.Selection.to(D.selection),wholeRange:F.Range.to(D.wholeRange)},f);if(!!d)return{edits:d.edits.map(F.TextEdit.from),placeholder:d.placeholder}}$releaseSession(h,L){const D=this.c.get(L),f=this.b.get(h);D&&f&&f.provider.releaseInteractiveEditorSession?.(D),this.c.delete(L)}}R.a=0,e.ExtHostInteractiveEditor=R}),define(Pe[223],Ae([1,0,6,9,4]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class F{constructor(w,h){this.extension=w,this.provider=h,this.handle=F.a++}}F.a=0;class O{constructor(w,h){this.b=new Map,this.c=new Map,this.d=w.getProxy(C.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(w,h,L){const D=new F(w,L);return this.b.set(D.handle,D),this.d.$registerInteractiveSessionProvider(D.handle,h),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveSessionProvider(D.handle),this.b.delete(D.handle)})}addInteractiveSessionRequest(w){this.d.$addInteractiveSessionRequest(w)}async $prepareInteractiveSession(w,h,L){const D=this.b.get(w);if(!D)return;const f=await D.provider.prepareSession(h,L);if(!f)return;const b=O.a++;return this.c.set(b,f),{id:b}}async $resolveInteractiveRequest(w,h,L,D){const f=this.b.get(w);if(!f)return;const b=this.c.get(h);if(!b||!f.provider.resolveRequest)return;const p=await f.provider.resolveRequest(b,L,D);if(p)return{message:p.message}}async $provideInitialSuggestions(w,h){const L=this.b.get(w);if(!!L&&!!L.provider.provideInitialSuggestions)return(0,A.withNullAsUndefined)(await L.provider.provideInitialSuggestions(h))}async $provideInteractiveReply(w,h,L,D){const f=this.b.get(w);if(!f)return;const b=this.c.get(h);if(!b)return;const p={session:b,message:L.message};if(f.provider.provideResponse){const d=await f.provider.provideResponse(p,D);if(b.saveState){const t=b.saveState();this.d.$acceptInteractiveSessionState(h,t)}return d?(this.d.$acceptInteractiveResponseProgress(w,h,{responsePart:d.content}),{followups:d.followups}):void 0}else if(f.provider.provideResponseWithProgress){const d={report:a=>this.d.$acceptInteractiveResponseProgress(w,h,{responsePart:a.content})},t=await f.provider.provideResponseWithProgress(p,d,D);if(b.saveState){const a=b.saveState();this.d.$acceptInteractiveSessionState(h,a)}return t?{followups:t.followups}:void 0}throw new Error("provider must implement either provideResponse or provideResponseWithProgress")}$releaseSession(w){this.c.delete(w)}}O.a=0,e.ExtHostInteractiveSession=O}),define(Pe[224],Ae([1,0,6,4]),function(ee,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(O){this.b=0,this.a=O.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(O){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,O),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=C}),define(Pe[225],Ae([1,0,2,23,8,7,76,4,13,44,16,9,267,21,6,89,84,54,78,10,17,26]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(I,M){this.d=I,this.e=M}async provideDocumentSymbols(I,M){const H=this.d.getDocument(I),x=await this.e.provideDocumentSymbols(H,M);if(!(0,L.isFalsyOrEmpty)(x))return x[0]instanceof F.DocumentSymbol?x.map(C.DocumentSymbol.from):i.f(x)}static f(I){I=I.slice(0).sort((x,te)=>{let pe=x.location.range.start.compareTo(te.location.range.start);return pe===0&&(pe=te.location.range.end.compareTo(x.location.range.end)),pe});const M=[],H=[];for(const x of I){const te={name:x.name||"!!MISSING: name!!",kind:C.SymbolKind.from(x.kind),tags:x.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:C.Range.from(x.location.range),selectionRange:C.Range.from(x.location.range),children:[]};for(;;){if(H.length===0){H.push(te),M.push(te);break}const pe=H[H.length-1];if(h.Range.containsRange(pe.range,te.range)&&!h.Range.equalsRange(pe.range,te.range)){pe.children?.push(te),H.push(te);break}H.pop()}}return M}}class u{constructor(I,M,H){this.g=I,this.h=M,this.j=H,this.e=new a.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,M){const H=this.g.getDocument(I),x=await this.j.provideCodeLenses(H,M);if(!x||M.isCancellationRequested)return;const te=this.e.add(x),pe=new p.DisposableStore;this.f.set(te,pe);const Ce={cacheId:te,lenses:[]};for(let ue=0;ue<x.length;ue++)Ce.lenses.push({cacheId:[te,ue],range:C.Range.from(x[ue].range),command:this.h.toInternal(x[ue].command,pe)});return Ce}async resolveCodeLens(I,M){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let x;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?x=H:x=await this.j.resolveCodeLens(H,M),x||(x=H),M.isCancellationRequested)return;const te=I.cacheId&&this.f.get(I.cacheId[0]);if(!!te)return I.command=this.h.toInternal(x.command??u.d,te),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}u.d={command:"missing",title:"!!MISSING: command!!"};function r(Z){return Array.isArray(Z)?Z.map(C.DefinitionLink.from):Z?[C.DefinitionLink.from(Z)]:[]}class c{constructor(I,M){this.d=I,this.e=M}async provideDefinition(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideDefinition(x,te,H);return r(pe)}}class o{constructor(I,M){this.d=I,this.e=M}async provideDeclaration(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideDeclaration(x,te,H);return r(pe)}}class k{constructor(I,M){this.d=I,this.e=M}async provideImplementation(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideImplementation(x,te,H);return r(pe)}}class s{constructor(I,M){this.d=I,this.e=M}async provideTypeDefinition(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideTypeDefinition(x,te,H);return r(pe)}}class l{constructor(I,M){this.d=I,this.e=M}async provideHover(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideHover(x,te,H);if(!(!pe||(0,L.isFalsyOrEmpty)(pe.contents)))return pe.range||(pe.range=x.getWordRangeAtPosition(te)),pe.range||(pe.range=new F.Range(te,te)),C.Hover.from(pe)}}class v{constructor(I,M){this.d=I,this.e=M}async provideEvaluatableExpression(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideEvaluatableExpression(x,te,H);if(pe)return C.EvaluatableExpression.from(pe)}}class S{constructor(I,M){this.d=I,this.e=M}async provideInlineValues(I,M,H,x){const te=this.d.getDocument(I),pe=await this.e.provideInlineValues(te,C.Range.to(M),C.InlineValueContext.to(H),x);if(Array.isArray(pe))return pe.map(Ce=>C.InlineValue.from(Ce))}}class E{constructor(I,M){this.d=I,this.e=M}async provideDocumentHighlights(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideDocumentHighlights(x,te,H);if(Array.isArray(pe))return pe.map(C.DocumentHighlight.from)}}class W{constructor(I,M){this.d=I,this.e=M}async provideLinkedEditingRanges(I,M,H){const x=this.d.getDocument(I),te=C.Position.to(M),pe=await this.e.provideLinkedEditingRanges(x,te,H);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,L.coalesce)(pe.ranges.map(C.Range.from)),wordPattern:pe.wordPattern}}}class G{constructor(I,M){this.d=I,this.e=M}async provideReferences(I,M,H,x){const te=this.d.getDocument(I),pe=C.Position.to(M),Ce=await this.e.provideReferences(te,pe,H,x);if(Array.isArray(Ce))return Ce.map(C.location.from)}}class Y{constructor(I,M,H,x,te,pe,Ce){this.g=I,this.h=M,this.j=H,this.k=x,this.l=te,this.m=pe,this.n=Ce,this.e=new a.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,M,H,x){const te=this.g.getDocument(I),pe=f.Selection.isISelection(M)?C.Selection.to(M):C.Range.to(M),Ce=[];for(const et of this.j.getDiagnostics(I))if(pe.intersection(et.range)&&Ce.push(et)>Y.d)break;const ue={diagnostics:Ce,only:H.only?new F.CodeActionKind(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},De=await this.k.provideCodeActions(te,pe,ue,x);if(!(0,L.isNonEmptyArray)(De)||x.isCancellationRequested)return;const Se=this.e.add(De),$e=new p.DisposableStore;this.f.set(Se,$e);const He=[];for(let et=0;et<De.length;et++){const Xe=De[et];!Xe||(Y.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,$e)})):(ue.only&&(Xe.kind?ue.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Se,et],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,$e),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(C.Diagnostic.from),edit:Xe.edit&&C.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Se,actions:He}}async resolveCodeAction(I,M){const[H,x]=I,te=this.e.get(H,x);if(!te||Y.o(te)||!this.k.resolveCodeAction)return;const pe=await this.k.resolveCodeAction(te,M)??te;return pe?.edit?C.WorkspaceEdit.from(pe.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}Y.d=1e3;class J{constructor(I,M,H,x){this.d=I,this.e=M,this.f=H,this.g=x}async prepareDocumentPaste(I,M,H,x){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(I),pe=M.map(ue=>C.Range.to(ue)),Ce=C.DataTransfer.toDataTransfer(H,()=>{throw new y.NotImplementedError});return await this.f.prepareDocumentPaste(te,pe,Ce,x),C.DataTransfer.toDataTransferDTO(Ce)}async providePasteEdits(I,M,H,x,te){const pe=this.e.getDocument(M),Ce=H.map(Se=>C.Range.to(Se)),ue=C.DataTransfer.toDataTransfer(x,async Se=>(await this.d.$resolvePasteFileData(this.g,I,Se)).buffer),De=await this.f.provideDocumentPasteEdits(pe,Ce,ue,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?C.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class q{constructor(I,M){this.d=I,this.e=M}async provideDocumentFormattingEdits(I,M,H){const x=this.d.getDocument(I),te=await this.e.provideDocumentFormattingEdits(x,M,H);if(Array.isArray(te))return te.map(C.TextEdit.from)}}class U{constructor(I,M){this.d=I,this.e=M}async provideDocumentRangeFormattingEdits(I,M,H,x){const te=this.d.getDocument(I),pe=C.Range.to(M),Ce=await this.e.provideDocumentRangeFormattingEdits(te,pe,H,x);if(Array.isArray(Ce))return Ce.map(C.TextEdit.from)}}class ${constructor(I,M){this.d=I,this.e=M,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,M,H,x,te){const pe=this.d.getDocument(I),Ce=C.Position.to(M),ue=await this.e.provideOnTypeFormattingEdits(pe,Ce,H,x,te);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}}class z{constructor(I,M){this.e=I,this.f=M,this.d=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,M){const H=await this.e.provideWorkspaceSymbols(I,M);if(!(0,L.isNonEmptyArray)(H))return{symbols:[]};const x=this.d.add(H),te={cacheId:x,symbols:[]};for(let pe=0;pe<H.length;pe++){const Ce=H[pe];if(!Ce||!Ce.name){this.f.warn("INVALID SymbolInformation",Ce);continue}te.symbols.push({...C.WorkspaceSymbol.from(Ce),cacheId:[x,pe]})}return te}async resolveWorkspaceSymbol(I,M){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const x=await this.e.resolveWorkspaceSymbol(H,M);return x&&(0,A.mixin)(I,C.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,M,H){this.d=I,this.e=M,this.f=H}async provideRenameEdits(I,M,H,x){const te=this.d.getDocument(I),pe=C.Position.to(M);try{const Ce=await this.e.provideRenameEdits(te,pe,H,x);return Ce?C.WorkspaceEdit.from(Ce):void 0}catch(Ce){const ue=j.g(Ce);return ue?{rejectReason:ue,edits:void 0}:Promise.reject(Ce)}}async resolveRenameLocation(I,M,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(I),te=C.Position.to(M);try{const pe=await this.e.prepareRename(x,te,H);let Ce,ue;if(F.Range.isRange(pe)?(Ce=pe,ue=x.getText(pe)):(0,D.isObject)(pe)&&(Ce=pe.range,ue=pe.placeholder),!Ce||!ue)return;if(Ce.start.line>te.line||Ce.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Ce),text:ue}}catch(pe){const Ce=j.g(pe);return Ce?{rejectReason:Ce,range:void 0,text:void 0}:Promise.reject(pe)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class he{constructor(I,M){this.resultId=I,this.tokens=M}}class we{constructor(I,M){this.f=I,this.g=M,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,M,H){const x=this.f.getDocument(I),te=M!==0?this.d.get(M):null;let pe=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,te.resultId,H):await this.g.provideDocumentSemanticTokens(x,H);return te&&this.d.delete(M),pe?(pe=we.h(pe),this.o(we.n(te,pe),pe)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return we.j(I)?we.k(I)?I:new F.SemanticTokens(new Uint32Array(I.data),I.resultId):we.l(I)?we.m(I)?I:new F.SemanticTokensEdits(I.edits.map(M=>new F.SemanticTokensEdit(M.start,M.deleteCount,M.data?new Uint32Array(M.data):M.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const M of I.edits)if(!(M.data instanceof Uint32Array))return!1;return!0}static n(I,M){if(!we.j(M)||!I||!I.tokens)return M;const H=I.tokens,x=H.length,te=M.data,pe=te.length;let Ce=0;const ue=Math.min(x,pe);for(;Ce<ue&&H[Ce]===te[Ce];)Ce++;if(Ce===x&&Ce===pe)return new F.SemanticTokensEdits([],M.resultId);let De=0;const Se=ue-Ce;for(;De<Se&&H[x-De-1]===te[pe-De-1];)De++;return new F.SemanticTokensEdits([{start:Ce,deleteCount:x-Ce-De,data:te.subarray(Ce,pe-De)}],M.resultId)}o(I,M){if(we.j(I)){const H=this.e++;return this.d.set(H,new he(I.resultId,I.data)),(0,d.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(we.l(I)){const H=this.e++;return we.j(M)?this.d.set(H,new he(M.resultId,M.data)):this.d.set(H,new he(I.resultId)),(0,d.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ie{constructor(I,M){this.d=I,this.e=M}async provideDocumentRangeSemanticTokens(I,M,H){const x=this.d.getDocument(I),te=await this.e.provideDocumentRangeSemanticTokens(x,C.Range.to(M),H);return te?this.f(te):null}f(I){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class oe{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,M,H,x,te){this.f=I,this.g=M,this.h=H,this.j=x,this.k=te,this.d=new a.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,M,H,x){const te=this.f.getDocument(I),pe=C.Position.to(M),Ce=te.getWordRangeAtPosition(pe)||new F.Range(pe,pe),ue=Ce.with({end:pe}),De=new m.StopWatch(!0),Se=await this.h.provideCompletionItems(te,pe,x,C.CompletionContext.to(H));if(!Se||x.isCancellationRequested)return;const $e=Array.isArray(Se)?new F.CompletionList(Se):Se,He=oe.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),et=new p.DisposableStore;this.e.set(He,et);const Xe=[],tt={x:He,b:Xe,a:{replace:C.Range.from(Ce),insert:C.Range.from(ue)},c:$e.isIncomplete||void 0,d:De.elapsed()};for(let rt=0;rt<$e.items.length;rt++){const Me=$e.items[rt],it=this.l(Me,[He,rt],ue,Ce);Xe.push(it)}return tt}async resolveCompletionItem(I,M){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const x=await this.h.resolveCompletionItem(H,M);if(!!x)return this.l(x,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,M,H,x){const te=this.e.get(M[0]);if(!te)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(I.command,te),Ce={x:M,a:I.label,b:I.kind!==void 0?C.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(C.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:C.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(C.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ce.h=I.textEdit.newText):typeof I.insertText=="string"?Ce.h=I.insertText:I.insertText instanceof F.SnippetString&&(Ce.h=I.insertText.value,Ce.i|=4);let ue;return I.textEdit?ue=I.textEdit.range:I.range&&(ue=I.range),F.Range.isRange(ue)?Ce.j=C.Range.from(ue):ue&&(!H?.isEqual(ue.inserting)||!x?.isEqual(ue.replacing))&&(Ce.j={insert:C.Range.from(ue.inserting),replace:C.Range.from(ue.replacing)}),Ce}}class de{async provideInlineCompletions(I,M,H,x){}disposeCompletions(I){}handleDidShowCompletionItem(I,M){}handlePartialAccept(I,M,H){}}class ke extends de{constructor(I,M,H,x){super(),this.f=I,this.g=M,this.h=H,this.j=x,this.d=new le,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[O.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[O.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(I,M,H,x){const te=this.g.getDocument(I),pe=C.Position.to(M),Ce=await this.h.provideInlineCompletionItems(te,pe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},x);if(!Ce||x.isCancellationRequested)return;const ue=Array.isArray(Ce)?Ce:Ce.items,De=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[];let Se;return{pid:this.d.createReferenceId({dispose(){Se?.dispose()},items:ue}),items:ue.map((He,et)=>{let Xe;He.command&&(Se||(Se=new p.DisposableStore),Xe=this.j.toInternal(He.command,Se));const tt=He.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:He.filterText,range:He.range?C.Range.from(He.range):void 0,command:Xe,idx:et,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:De.map(He=>(Se||(Se=new p.DisposableStore),this.j.toInternal(He,Se)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,M){const H=this.d.get(I)?.items[M];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}handlePartialAccept(I,M,H){const x=this.d.get(I)?.items[M];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,H)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const M=this.e++;return this.d.set(M,I),M}disposeReferenceId(I){const M=this.d.get(I);return this.d.delete(I),M}get(I){return this.d.get(I)}}class X{constructor(I,M){this.e=I,this.f=M,this.d=new a.Cache("SignatureHelp")}async provideSignatureHelp(I,M,H,x){const te=this.e.getDocument(I),pe=C.Position.to(M),Ce=this.g(H),ue=await this.f.provideSignatureHelp(te,pe,x,Ce);if(ue){const De=this.d.add([ue]);return{...C.SignatureHelp.from(ue),id:De}}}g(I){let M;if(I.activeSignatureHelp){const H=C.SignatureHelp.to(I.activeSignatureHelp),x=this.d.get(I.activeSignatureHelp.id,0);x?(M=x,M.activeSignature=H.activeSignature,M.activeParameter=H.activeParameter):M=H}return{...I,activeSignatureHelp:M}}releaseSignatureHelp(I){this.d.delete(I)}}class T{constructor(I,M,H,x,te){this.f=I,this.g=M,this.h=H,this.j=x,this.k=te,this.d=new a.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,M,H){const x=this.f.getDocument(I),te=C.Range.to(M),pe=await this.h.provideInlayHints(x,te,H);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${M}`);return}if(H.isCancellationRequested)return;const Ce=this.d.add(pe);this.e.set(Ce,new p.DisposableStore);const ue={hints:[],cacheId:Ce};for(let De=0;De<pe.length;De++)this.l(pe[De],te)&&ue.hints.push(this.m(pe[De],[Ce,De]));return this.j.trace(`[InlayHints] ${ue.hints.length} inlay hints from '${this.k.identifier.value}' for ${M}`),ue}async resolveInlayHint(I,M){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const x=await this.h.resolveInlayHint(H,M);if(!!x&&!!this.l(x))return this.m(x,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,M){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(M&&!M.contains(I.position))}m(I,M){const H=this.e.get(M[0]);if(!H)throw Error("DisposableStore is missing...");const x={label:"",cacheId:M,tooltip:C.MarkdownString.fromStrict(I.tooltip),position:C.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(C.TextEdit.from),kind:I.kind&&C.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?x.label=I.label:x.label=I.label.map(te=>{const pe={label:te.value};return pe.tooltip=C.MarkdownString.fromStrict(te.tooltip),F.Location.isLocation(te.location)&&(pe.location=C.location.from(te.location)),te.command&&(pe.command=this.g.toInternal(te.command,H)),pe}),x}}class V{constructor(I,M){this.e=I,this.f=M,this.d=new a.Cache("DocumentLink")}async provideLinks(I,M){const H=this.e.getDocument(I),x=await this.f.provideDocumentLinks(H,M);if(!(!Array.isArray(x)||x.length===0)&&!M.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(V.g).map(C.DocumentLink.from)};{const te=this.d.add(x),pe={links:[],cacheId:te};for(let Ce=0;Ce<x.length;Ce++){if(!V.g(x[Ce]))continue;const ue=C.DocumentLink.from(x[Ce]);ue.cacheId=[te,Ce],pe.links.push(ue)}return pe}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,M){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const x=await this.f.resolveDocumentLink(H,M);if(!(!x||!V.g(x)))return C.DocumentLink.from(x)}releaseLinks(I){this.d.delete(I)}}class ce{constructor(I,M){this.d=I,this.e=M}async provideColors(I,M){const H=this.d.getDocument(I),x=await this.e.provideDocumentColors(H,M);return Array.isArray(x)?x.map(pe=>({color:C.Color.from(pe.color),range:C.Range.from(pe.range)})):[]}async provideColorPresentations(I,M,H){const x=this.d.getDocument(I),te=C.Range.to(M.range),pe=C.Color.to(M.color),Ce=await this.e.provideColorPresentations(pe,{document:x,range:te},H);if(!!Array.isArray(Ce))return Ce.map(C.ColorPresentation.from)}}class me{constructor(I,M){this.d=I,this.e=M}async provideFoldingRanges(I,M,H){const x=this.d.getDocument(I),te=await this.e.provideFoldingRanges(x,M,H);if(!!Array.isArray(te))return te.map(C.FoldingRange.from)}}class Fe{constructor(I,M,H){this.d=I,this.e=M,this.f=H}async provideSelectionRanges(I,M,H){const x=this.d.getDocument(I),te=M.map(C.Position.to),pe=await this.e.provideSelectionRanges(x,te,H);if(!(0,L.isNonEmptyArray)(pe))return[];if(pe.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ce=[];for(let ue=0;ue<te.length;ue++){const De=[];Ce.push(De);let Se=te[ue],$e=pe[ue];for(;;){if(!$e.range.contains(Se))throw new Error("INVALID selection range, must contain the previous range");if(De.push(C.SelectionRange.from($e)),!$e.parent)break;Se=$e.range,$e=$e.parent}}return Ce}}class be{constructor(I,M){this.f=I,this.g=M,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(I,M,H){const x=this.f.getDocument(I),te=C.Position.to(M),pe=await this.g.prepareCallHierarchy(x,te,H);if(!pe)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(pe)?pe.map(ue=>this.h(Ce,ue)):[this.h(Ce,pe)]}async provideCallsTo(I,M,H){const x=this.j(I,M);if(!x)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(x,H);if(!!te)return te.map(pe=>({from:this.h(I,pe.from),fromRanges:pe.fromRanges.map(Ce=>C.Range.from(Ce))}))}async provideCallsFrom(I,M,H){const x=this.j(I,M);if(!x)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(x,H);if(!!te)return te.map(pe=>({to:this.h(I,pe.to),fromRanges:pe.fromRanges.map(Ce=>C.Range.from(Ce))}))}releaseSession(I){this.e.delete(I)}h(I,M){const H=this.e.get(I),x=C.CallHierarchyItem.from(M,I,H.size.toString(36));return H.set(x._itemId,M),x}j(I,M){return this.e.get(I)?.get(M)}}class Ee{constructor(I,M){this.f=I,this.g=M,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(I,M,H){const x=this.f.getDocument(I),te=C.Position.to(M),pe=await this.g.prepareTypeHierarchy(x,te,H);if(!pe)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(pe)?pe.map(ue=>this.h(Ce,ue)):[this.h(Ce,pe)]}async provideSupertypes(I,M,H){const x=this.j(I,M);if(!x)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(x,H);if(!!te)return te.map(pe=>this.h(I,pe))}async provideSubtypes(I,M,H){const x=this.j(I,M);if(!x)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(x,H);if(!!te)return te.map(pe=>this.h(I,pe))}releaseSession(I){this.e.delete(I)}h(I,M){const H=this.e.get(I),x=C.TypeHierarchyItem.from(M,I,H.size.toString(36));return H.set(x._itemId,M),x}j(I,M){return this.e.get(I)?.get(M)}}class Ie{constructor(I,M,H,x){this.d=I,this.e=M,this.f=H,this.g=x}async provideDocumentOnDropEdits(I,M,H,x,te){const pe=this.e.getDocument(M),Ce=C.Position.to(H),ue=C.DataTransfer.toDataTransfer(x,async Se=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,Se)).buffer),De=await this.f.provideDocumentDropEdits(pe,Ce,ue,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?C.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class se{constructor(I,M){this.adapter=I,this.extension=M}}class ae{constructor(I,M,H,x,te,pe,Ce,ue){this.g=M,this.h=H,this.j=x,this.k=te,this.l=pe,this.m=Ce,this.n=ue,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return C.DocumentSelector.from(I,this.g)}p(I){return new F.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ae.d++}async s(I,M,H,x,te,pe=!1){const Ce=this.f.get(I);if(!Ce||!(Ce.adapter instanceof M))return x;const ue=Date.now();pe||this.l.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const De=H(Ce.adapter,Ce.extension);return Promise.resolve(De).catch(Se=>{(0,y.isCancellationError)(Se)||(this.l.error(`[${Ce.extension.identifier.value}] provider FAILED`),this.l.error(Se),this.n.onExtensionError(Ce.extension.identifier,Se))}).finally(()=>{pe||this.l.trace(`[${Ce.extension.identifier.value}] provider DONE after ${Date.now()-ue}ms`)}),b.CancellationToken.isCancellationToken(te)?(0,P.raceCancellationError)(De,te):De}t(I,M){const H=this.q();return this.f.set(H,new se(I,M)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,M,H,x){const te=this.t(new i(this.h,H),I),pe=x&&x.label||ae.u(I);return this.e.$registerDocumentSymbolProvider(te,this.o(M),pe),this.p(te)}$provideDocumentSymbols(I,M,H){return this.s(I,i,x=>x.provideDocumentSymbols(n.URI.revive(M),H),void 0,H)}registerCodeLensProvider(I,M,H){const x=this.q(),te=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new se(new u(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(x,this.o(M),te);let pe=this.p(x);if(te!==void 0){const Ce=H.onDidChangeCodeLenses(ue=>this.e.$emitCodeLensEvent(te));pe=F.Disposable.from(pe,Ce)}return pe}$provideCodeLenses(I,M,H){return this.s(I,u,x=>x.provideCodeLenses(n.URI.revive(M),H),void 0,H)}$resolveCodeLens(I,M,H){return this.s(I,u,x=>x.resolveCodeLens(M,H),void 0,void 0)}$releaseCodeLenses(I,M){this.s(I,u,H=>Promise.resolve(H.releaseCodeLenses(M)),void 0,void 0)}registerDefinitionProvider(I,M,H){const x=this.t(new c(this.h,H),I);return this.e.$registerDefinitionSupport(x,this.o(M)),this.p(x)}$provideDefinition(I,M,H,x){return this.s(I,c,te=>te.provideDefinition(n.URI.revive(M),H,x),[],x)}registerDeclarationProvider(I,M,H){const x=this.t(new o(this.h,H),I);return this.e.$registerDeclarationSupport(x,this.o(M)),this.p(x)}$provideDeclaration(I,M,H,x){return this.s(I,o,te=>te.provideDeclaration(n.URI.revive(M),H,x),[],x)}registerImplementationProvider(I,M,H){const x=this.t(new k(this.h,H),I);return this.e.$registerImplementationSupport(x,this.o(M)),this.p(x)}$provideImplementation(I,M,H,x){return this.s(I,k,te=>te.provideImplementation(n.URI.revive(M),H,x),[],x)}registerTypeDefinitionProvider(I,M,H){const x=this.t(new s(this.h,H),I);return this.e.$registerTypeDefinitionSupport(x,this.o(M)),this.p(x)}$provideTypeDefinition(I,M,H,x){return this.s(I,s,te=>te.provideTypeDefinition(n.URI.revive(M),H,x),[],x)}registerHoverProvider(I,M,H,x){const te=this.t(new l(this.h,H),I);return this.e.$registerHoverProvider(te,this.o(M)),this.p(te)}$provideHover(I,M,H,x){return this.s(I,l,te=>te.provideHover(n.URI.revive(M),H,x),void 0,x)}registerEvaluatableExpressionProvider(I,M,H,x){const te=this.t(new v(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(te,this.o(M)),this.p(te)}$provideEvaluatableExpression(I,M,H,x){return this.s(I,v,te=>te.provideEvaluatableExpression(n.URI.revive(M),H,x),void 0,x)}registerInlineValuesProvider(I,M,H,x){const te=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new S(this.h,H),I);this.e.$registerInlineValuesProvider(pe,this.o(M),te);let Ce=this.p(pe);if(te!==void 0){const ue=H.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(te));Ce=F.Disposable.from(Ce,ue)}return Ce}$provideInlineValues(I,M,H,x,te){return this.s(I,S,pe=>pe.provideInlineValues(n.URI.revive(M),H,x,te),void 0,te)}registerDocumentHighlightProvider(I,M,H){const x=this.t(new E(this.h,H),I);return this.e.$registerDocumentHighlightProvider(x,this.o(M)),this.p(x)}$provideDocumentHighlights(I,M,H,x){return this.s(I,E,te=>te.provideDocumentHighlights(n.URI.revive(M),H,x),void 0,x)}registerLinkedEditingRangeProvider(I,M,H){const x=this.t(new W(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(x,this.o(M)),this.p(x)}$provideLinkedEditingRanges(I,M,H,x){return this.s(I,W,async te=>{const pe=await te.provideLinkedEditingRanges(n.URI.revive(M),H,x);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?ae.w(pe.wordPattern):void 0}},void 0,x)}registerReferenceProvider(I,M,H){const x=this.t(new G(this.h,H),I);return this.e.$registerReferenceSupport(x,this.o(M)),this.p(x)}$provideReferences(I,M,H,x,te){return this.s(I,G,pe=>pe.provideReferences(n.URI.revive(M),H,x,te),void 0,te)}registerCodeActionProvider(I,M,H,x){const te=new p.DisposableStore,pe=this.t(new Y(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(pe,this.o(M),{providedKinds:x?.providedCodeActionKinds?.map(Ce=>Ce.value),documentation:x?.documentation?.map(Ce=>({kind:Ce.kind.value,command:this.j.converter.toInternal(Ce.command,te)}))},ae.u(I),Boolean(H.resolveCodeAction)),te.add(this.p(pe)),te}$provideCodeActions(I,M,H,x,te){return this.s(I,Y,pe=>pe.provideCodeActions(n.URI.revive(M),H,x,te),void 0,te)}$resolveCodeAction(I,M,H){return this.s(I,Y,x=>x.resolveCodeAction(M,H),void 0,void 0)}$releaseCodeActions(I,M){this.s(I,Y,H=>Promise.resolve(H.releaseCodeActions(M)),void 0,void 0)}registerDocumentFormattingEditProvider(I,M,H){const x=this.t(new q(this.h,H),I);return this.e.$registerDocumentFormattingSupport(x,this.o(M),I.identifier,I.displayName||I.name),this.p(x)}$provideDocumentFormattingEdits(I,M,H,x){return this.s(I,q,te=>te.provideDocumentFormattingEdits(n.URI.revive(M),H,x),void 0,x)}registerDocumentRangeFormattingEditProvider(I,M,H){const x=this.t(new U(this.h,H),I);return this.e.$registerRangeFormattingSupport(x,this.o(M),I.identifier,I.displayName||I.name),this.p(x)}$provideDocumentRangeFormattingEdits(I,M,H,x,te){return this.s(I,U,pe=>pe.provideDocumentRangeFormattingEdits(n.URI.revive(M),H,x,te),void 0,te)}registerOnTypeFormattingEditProvider(I,M,H,x){const te=this.t(new $(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(te,this.o(M),x,I.identifier),this.p(te)}$provideOnTypeFormattingEdits(I,M,H,x,te,pe){return this.s(I,$,Ce=>Ce.provideOnTypeFormattingEdits(n.URI.revive(M),H,x,te,pe),void 0,pe)}registerWorkspaceSymbolProvider(I,M){const H=this.t(new z(M,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof M.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,M,H){return this.s(I,z,x=>x.provideWorkspaceSymbols(M,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,M,H){return this.s(I,z,x=>x.resolveWorkspaceSymbol(M,H),void 0,void 0)}$releaseWorkspaceSymbols(I,M){this.s(I,z,H=>H.releaseWorkspaceSymbols(M),void 0,void 0)}registerRenameProvider(I,M,H){const x=this.t(new j(this.h,H,this.l),I);return this.e.$registerRenameSupport(x,this.o(M),j.supportsResolving(H)),this.p(x)}$provideRenameEdits(I,M,H,x,te){return this.s(I,j,pe=>pe.provideRenameEdits(n.URI.revive(M),H,x,te),void 0,te)}$resolveRenameLocation(I,M,H,x){return this.s(I,j,te=>te.resolveRenameLocation(n.URI.revive(M),H,x),void 0,x)}registerDocumentSemanticTokensProvider(I,M,H,x){const te=this.t(new we(this.h,H),I),pe=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(M),x,pe);let Ce=this.p(te);if(pe){const ue=H.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(pe));Ce=F.Disposable.from(Ce,ue)}return Ce}$provideDocumentSemanticTokens(I,M,H,x){return this.s(I,we,te=>te.provideDocumentSemanticTokens(n.URI.revive(M),H,x),null,x)}$releaseDocumentSemanticTokens(I,M){this.s(I,we,H=>H.releaseDocumentSemanticColoring(M),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,M,H,x){const te=this.t(new ie(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(M),x),this.p(te)}$provideDocumentRangeSemanticTokens(I,M,H,x){return this.s(I,ie,te=>te.provideDocumentRangeSemanticTokens(n.URI.revive(M),H,x),null,x)}registerCompletionItemProvider(I,M,H,x){const te=this.t(new oe(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(te,this.o(M),x,oe.supportsResolving(H),`${I.identifier.value}(${x.join("")})`),this.p(te)}$provideCompletionItems(I,M,H,x,te){return this.s(I,oe,pe=>pe.provideCompletionItems(n.URI.revive(M),H,x,te),void 0,te)}$resolveCompletionItem(I,M,H){return this.s(I,oe,x=>x.resolveCompletionItem(M,H),void 0,H)}$releaseCompletionItems(I,M){this.s(I,oe,H=>H.releaseCompletionItems(M),void 0,void 0)}registerInlineCompletionsProvider(I,M,H){const x=new ke(I,this.h,H,this.j.converter),te=this.t(x,I);return this.e.$registerInlineCompletionsSupport(te,this.o(M),x.supportsHandleEvents),this.p(te)}$provideInlineCompletions(I,M,H,x,te){return this.s(I,de,pe=>pe.provideInlineCompletions(n.URI.revive(M),H,x,te),void 0,te)}$handleInlineCompletionDidShow(I,M,H){this.s(I,de,async x=>{x.handleDidShowCompletionItem(M,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(I,M,H,x){this.s(I,de,async te=>{te.handlePartialAccept(M,H,x)},void 0,void 0)}$freeInlineCompletionsList(I,M){this.s(I,de,async H=>{H.disposeCompletions(M)},void 0,void 0)}registerSignatureHelpProvider(I,M,H,x){const te=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,pe=this.t(new X(this.h,H),I);return this.e.$registerSignatureHelpProvider(pe,this.o(M),te),this.p(pe)}$provideSignatureHelp(I,M,H,x,te){return this.s(I,X,pe=>pe.provideSignatureHelp(n.URI.revive(M),H,x,te),void 0,te)}$releaseSignatureHelp(I,M){this.s(I,X,H=>H.releaseSignatureHelp(M),void 0,void 0)}registerInlayHintsProvider(I,M,H){const x=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new T(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(te,this.o(M),typeof H.resolveInlayHint=="function",x,ae.u(I));let pe=this.p(te);if(x!==void 0){const Ce=H.onDidChangeInlayHints(ue=>this.e.$emitInlayHintsEvent(x));pe=F.Disposable.from(pe,Ce)}return pe}$provideInlayHints(I,M,H,x){return this.s(I,T,te=>te.provideInlayHints(n.URI.revive(M),H,x),void 0,x)}$resolveInlayHint(I,M,H){return this.s(I,T,x=>x.resolveInlayHint(M,H),void 0,H)}$releaseInlayHints(I,M){this.s(I,T,H=>H.releaseHints(M),void 0,void 0)}registerDocumentLinkProvider(I,M,H){const x=this.t(new V(this.h,H),I);return this.e.$registerDocumentLinkProvider(x,this.o(M),typeof H.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(I,M,H){return this.s(I,V,x=>x.provideLinks(n.URI.revive(M),H),void 0,H,M.scheme==="output")}$resolveDocumentLink(I,M,H){return this.s(I,V,x=>x.resolveLink(M,H),void 0,void 0,!0)}$releaseDocumentLinks(I,M){this.s(I,V,H=>H.releaseLinks(M),void 0,void 0,!0)}registerColorProvider(I,M,H){const x=this.t(new ce(this.h,H),I);return this.e.$registerDocumentColorProvider(x,this.o(M)),this.p(x)}$provideDocumentColors(I,M,H){return this.s(I,ce,x=>x.provideColors(n.URI.revive(M),H),[],H)}$provideColorPresentations(I,M,H,x){return this.s(I,ce,te=>te.provideColorPresentations(n.URI.revive(M),H,x),void 0,x)}registerFoldingRangeProvider(I,M,H){const x=this.q(),te=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new se(new me(this.h,H),I)),this.e.$registerFoldingRangeProvider(x,this.o(M),I.identifier,te);let pe=this.p(x);if(te!==void 0){const Ce=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));pe=F.Disposable.from(pe,Ce)}return pe}$provideFoldingRanges(I,M,H,x){return this.s(I,me,te=>te.provideFoldingRanges(n.URI.revive(M),H,x),void 0,x)}registerSelectionRangeProvider(I,M,H){const x=this.t(new Fe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(x,this.o(M)),this.p(x)}$provideSelectionRanges(I,M,H,x){return this.s(I,Fe,te=>te.provideSelectionRanges(n.URI.revive(M),H,x),[],x)}registerCallHierarchyProvider(I,M,H){const x=this.t(new be(this.h,H),I);return this.e.$registerCallHierarchyProvider(x,this.o(M)),this.p(x)}$prepareCallHierarchy(I,M,H,x){return this.s(I,be,te=>Promise.resolve(te.prepareSession(n.URI.revive(M),H,x)),void 0,x)}$provideCallHierarchyIncomingCalls(I,M,H,x){return this.s(I,be,te=>te.provideCallsTo(M,H,x),void 0,x)}$provideCallHierarchyOutgoingCalls(I,M,H,x){return this.s(I,be,te=>te.provideCallsFrom(M,H,x),void 0,x)}$releaseCallHierarchy(I,M){this.s(I,be,H=>Promise.resolve(H.releaseSession(M)),void 0,void 0)}registerTypeHierarchyProvider(I,M,H){const x=this.t(new Ee(this.h,H),I);return this.e.$registerTypeHierarchyProvider(x,this.o(M)),this.p(x)}$prepareTypeHierarchy(I,M,H,x){return this.s(I,Ee,te=>Promise.resolve(te.prepareSession(n.URI.revive(M),H,x)),void 0,x)}$provideTypeHierarchySupertypes(I,M,H,x){return this.s(I,Ee,te=>te.provideSupertypes(M,H,x),void 0,x)}$provideTypeHierarchySubtypes(I,M,H,x){return this.s(I,Ee,te=>te.provideSubtypes(M,H,x),void 0,x)}$releaseTypeHierarchy(I,M){this.s(I,Ee,H=>Promise.resolve(H.releaseSession(M)),void 0,void 0)}registerDocumentOnDropEditProvider(I,M,H){const x=this.q();return this.f.set(x,new se(new Ie(this.e,this.h,H,x),I)),this.e.$registerDocumentOnDropEditProvider(x,this.o(M)),this.p(x)}$provideDocumentOnDropEdits(I,M,H,x,te,pe){return this.s(I,Ie,Ce=>Promise.resolve(Ce.provideDocumentOnDropEdits(M,n.URI.revive(H),x,te,pe)),void 0,void 0)}registerDocumentPasteEditProvider(I,M,H,x){const te=this.q();return this.f.set(te,new se(new J(this.e,this.h,H,te),I)),this.e.$registerPasteEditProvider(te,this.o(M),!!H.prepareDocumentPaste,x.pasteMimeTypes),this.p(te)}$prepareDocumentPaste(I,M,H,x,te){return this.s(I,J,pe=>pe.prepareDocumentPaste(n.URI.revive(M),H,x,te),void 0,te)}$providePasteEdits(I,M,H,x,te,pe){return this.s(I,J,Ce=>Ce.providePasteEdits(M,n.URI.revive(H),x,te,pe),void 0,pe)}static w(I){return{pattern:I.source,flags:(0,w.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ae.w(I.decreaseIndentPattern),increaseIndentPattern:ae.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ae.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ae.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ae.w(I.beforeText),afterText:I.afterText?ae.w(I.afterText):void 0,previousLineText:I.previousLineText?ae.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ae.z)}setLanguageConfiguration(I,M,H){const{wordPattern:x}=H;if(x&&(0,w.regExpLeadsToEndlessLoop)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(M,x):this.h.setWordDefinitionFor(M,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const te=this.q(),pe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ae.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(te,M,pe),this.p(te)}$setWordDefinitions(I){for(const M of I)this.h.setWordDefinitionFor(M.languageId,new RegExp(M.regexSource,M.regexFlags))}}ae.d=0,e.ExtHostLanguageFeatures=ae}),define(Pe[226],Ae([1,0,4,8,7,29,17,6]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(L,D,f,b){this.c=D,this.d=f,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,D){await this.a.$changeLanguage(L,D);const f=this.c.getDocumentData(L);if(!f)throw new Error(`document '${L.toString()}' NOT found`);return f.document}async tokenAtPosition(L,D){const f=L.version,b=A.Position.from(D),p=await this.a.$tokensAtPosition(L.uri,b),d={type:C.StandardTokenType.Other,range:L.getWordRangeAtPosition(D)??new C.Range(D.line,D.character,D.line,D.character)};if(!p)return d;const t={range:A.Range.to(p.range),type:A.TokenType.to(p.type)};return!t.range.contains(D)||f!==L.version?d:t}createLanguageStatusItem(L,D,f){const b=this.f++,p=this.a,d=this.g,t=`${L.identifier.value}/${D}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(t);const a={selector:f,id:D,name:L.displayName??L.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let m;const y=new R.DisposableStore,P=()=>{m?.dispose(),m=(0,O.disposableTimeout)(()=>{y.clear(),this.a.$setLanguageStatus(b,{id:t,name:a.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===C.LanguageStatusSeverity.Error?F.default.Error:a.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:a.command&&this.d.toInternal(a.command,y),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},g={dispose(){y.dispose(),m?.dispose(),p.$removeLanguageStatus(b),d.delete(t)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,P()},get selector(){return a.selector},set selector(i){a.selector=i,P()},get text(){return a.text},set text(i){a.text=i,P()},get detail(){return a.detail},set detail(i){a.detail=i,P()},get severity(){return a.severity},set severity(i){a.severity=i,P()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,P()},get command(){return a.command},set command(i){a.command=i,P()},get busy(){return a.busy},set busy(i){a.busy=i,P()}};return P(),g}}e.ExtHostLanguages=w}),define(Pe[79],Ae([1,0,20,13,2,3,14,4,27,18]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(f,b,p){this.f=p,this.d=new Map,this.a=b.getProxy(R.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(f,b){const{message:p,args:d,comment:t}=b;if(this.c)return(0,A.format2)(p,d??{});let a=p;t&&t.length>0&&(a+=`/${Array.isArray(t)?t.join(""):t}`);const m=this.d.get(f)?.contents[a];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,A.format2)(m??p,d??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let b;const p=await this.g(f);if(!p){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(p),t=JSON.parse(d);b=f.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${f.identifier.value} from ${p}: ${d.message}`);return}b&&this.d.set(f.identifier.value,{contents:b,uri:p})}async g(f){if(f.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return C.URI.revive(b)}return f.l10n?C.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=je([Ve(0,w.IExtHostInitDataService),Ve(1,h.IExtHostRpcService),Ve(2,O.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,F.createDecorator)("IExtHostLocalizationService")}),define(Pe[227],Ae([1,0,14,4,27,18,2,66]),function(ee,e,n,A,C,F,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(D,f){super(f.logLevel,f.logsLocation,f.loggers.map(b=>(0,R.revive)(b))),this.n=D.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(D,f){f?this.setLogLevel(O.URI.revive(f),D):this.setLogLevel(D)}setVisibility(D,f){super.setVisibility(D,f),this.n.$setVisibility(D,f)}m(D,f,b){return new h(this.n,D,f,b)}};w=je([Ve(0,F.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],w),e.ExtHostLoggerService=w;class h extends n.AbstractMessageLogger{constructor(D,f,b,p){super(p?.logLevel==="always"),this.m=D,this.n=f,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(f,p).then(()=>{this.q(this.l),this.k=!0})}g(D,f){const b=[[D,f]];this.k?this.q(b):this.l.push(...b)}q(D){this.m.$log(this.n,D)}}}),define(Pe[228],Ae([1,0,4,14,26]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function F(R){return R&&R.title}let O=class{constructor(w,h){this.b=h,this.a=w.getProxy(n.MainContext.MainThreadMessageService)}showMessage(w,h,L,D,f){const b={source:{identifier:w.identifier,label:w.displayName||w.name}};let p;typeof D=="string"||F(D)?p=[D,...f]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,p=f),b.useCustom&&(0,C.checkProposedApiEnabled)(w,"resolvers");const d=[];for(let t=0;t<p.length;t++){const a=p[t];if(typeof a=="string")d.push({title:a,handle:t,isCloseAffordance:!1});else if(typeof a=="object"){const{title:m,isCloseAffordance:y}=a;d.push({title:m,isCloseAffordance:!!y,handle:t})}else this.b.warn("Invalid message item:",a)}return this.a.$showMessage(h,L,b,d).then(t=>{if(typeof t=="number")return p[t]})}};O=je([Ve(1,A.ILogService)],O),e.ExtHostMessageService=O}),define(Pe[229],Ae([1,0,25,5,6,28,13,9,2,54,4,38,8,7,46,201,102,10]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(P=>P.apiEditor)}constructor(P,g,i,u){this.q=i,this.r=u,this.f=new Map,this.g=new F.ResourceMap,this.h=new Map,this.j=new A.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=P.getProxy(L.MainContext.MainThreadNotebook),this.c=P.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=P.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const c=r.notebookEditor?.notebookUri,o=r.cell.handle,s=this.g.get(c)?.getCell(o);if(s)return s.apiCell}if(r&&r.$mid===14){const c=r.uri,o=this.g.get(c);if(o)return o.apiNotebook}return r}}),m.x(g)}getEditorById(P){const g=this.h.get(P);if(!g)throw new Error(`unknown text editor: ${P}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(P){for(const[g,i]of this.h)if(i.apiEditor===P)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(P,g){const i=this.g.get(P);if(!i&&!g)throw new Error(`NO notebook document for '${P}'`);return i}static s(P,g){if(!g)return;const i=g.filenamePattern.map(u=>f.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(g.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:g.displayName,filenamePattern:i,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,g,i){const u=m.a++,r=typeof i.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(u,i),this.b.$registerNotebookCellStatusBarItemProvider(u,r,g);let c;return r!==void 0&&(c=i.onDidChangeCellStatusBarItems(o=>this.b.$emitCellStatusBarEvent(r))),new b.Disposable(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,r),c?.dispose()})}async createNotebookDocument(P){const g=await this.c.$tryCreateNotebook({viewType:P.viewType,content:P.content&&f.NotebookData.from(P.content)});return w.URI.revive(g)}async openNotebookDocument(P){const g=this.g.get(P);if(g)return g.apiNotebook;const i=await this.c.$tryOpenNotebook(P),u=this.g.get(w.URI.revive(i));return(0,R.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(P,g){w.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let i;typeof g=="object"?i={position:f.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(f.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:i={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(P.uri,P.notebookType,i),r=u&&this.h.get(u)?.apiEditor;if(r)return r;throw u?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,g,i,u){const r=this.f.get(P),c=w.URI.revive(g),o=this.g.get(c);if(!o||!r)return;const k=o.getCellFromIndex(i);if(!k)return;const s=await r.provideCellStatusBarItems(k.apiCell,u);if(!s)return;const l=new C.DisposableStore,v=this.p.add([l]),E=(Array.isArray(s)?s:[s]).map(W=>f.NotebookStatusBarItem.from(W,this.i,l));return{cacheId:v,items:E}}$releaseNotebookCellStatusBarItems(P){this.p.delete(P)}registerNotebookSerializer(P,g,i,u,r){if((0,O.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const c=this.t++;return this.u.set(c,i),this.b.$registerNotebookSerializer(c,{id:P.identifier,location:P.extensionLocation},g,f.NotebookDocumentContentOptions.from(u),m.s(P,r)),(0,C.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(c)})}async $dataToNotebook(P,g,i){const u=this.u.get(P);if(!u)throw new Error("NO serializer found");const r=await u.deserializeNotebook(g.buffer,i);return new p.SerializableObjectWithBuffers(f.NotebookData.from(r))}async $notebookToData(P,g,i){const u=this.u.get(P);if(!u)throw new Error("NO serializer found");const r=await u.serializeNotebook(f.NotebookData.to(g.value),i);return n.VSBuffer.wrap(r)}w(P,g,i){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const u=new t.ExtHostNotebookEditor(g,this.d,P,i.visibleRanges.map(f.NotebookRange.to),i.selections.map(f.NotebookRange.to),typeof i.viewColumn=="number"?f.ViewColumn.to(i.viewColumn):void 0);this.h.set(g,u)}$acceptDocumentAndEditorsDelta(P){if(P.value.removedDocuments)for(const i of P.value.removedDocuments){const u=w.URI.revive(i),r=this.g.get(u);r&&(r.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(c=>c.document.uri)}),this.n.fire(r.apiNotebook));for(const c of this.h.values())c.notebookData.uri.toString()===u.toString()&&this.h.delete(c.id)}if(P.value.addedDocuments){const i=[];for(const u of P.value.addedDocuments){const r=w.URI.revive(u.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const c=new d.ExtHostNotebookDocument(this.c,this.q,this.r,r,u);i.push(...u.cells.map(o=>d.ExtHostCell.asModelAddData(c.apiNotebook,o))),this.g.get(r)?.dispose(),this.g.set(r,c),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this.m.fire(c.apiNotebook)}}if(P.value.addedEditors)for(const i of P.value.addedEditors){if(this.h.has(i.id))return;const u=w.URI.revive(i.documentUri),r=this.g.get(u);r&&this.w(r,i.id,i)}const g=[];if(P.value.removedEditors)for(const i of P.value.removedEditors){const u=this.h.get(i);u&&(this.h.delete(i),this.k?.id===u.id&&(this.k=void 0),g.push(u))}if(P.value.visibleEditors){this.l=P.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const i=new Set;this.l.forEach(u=>i.add(u.id));for(const u of this.h.values()){const r=i.has(u.id);u._acceptVisibility(r)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}P.value.newActiveEditor===null?this.k=void 0:P.value.newActiveEditor&&(this.h.get(P.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${P.value.newActiveEditor}`),this.k=this.h.get(P.value.newActiveEditor)),P.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(P){const g=D.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new D.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>n.VSBuffer.wrap(r))],new D.ApiCommandResult("Notebook Data",r=>f.NotebookData.to(r.value))),u=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new p.SerializableObjectWithBuffers(f.NotebookData.from(r)))],new D.ApiCommandResult("Bytes",r=>r.buffer));P.registerApiCommand(i),P.registerApiCommand(u)}}m.a=0,e.ExtHostNotebookController=m}),define(Pe[230],Ae([1,0,16,17,21,5,6,28,2,24,14,54,4,38,8,7,74,191,26,46]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let P=class{constructor(o,k,s,l,v){this.k=k,this.l=s,this.m=l,this.n=v,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(f.MainContext.MainThreadNotebookKernels);const S=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const W=this.l.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:W}}else if(E&&"notebookEditor"in E){const W=this.l.getIdByEditor(E.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return E})],b.ApiCommandResult.Void);this.m.registerApiCommand(S)}createNotebookController(o,k,s,l,v,S){for(const de of this.h.values())if(de.controller.id===k&&h.ExtensionIdentifier.equals(o.identifier,de.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const E=this.i++,W=this;this.n.trace(`NotebookController[${E}], CREATED by ${o.identifier.value}, ${k}`);const G=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${o.identifier}'`);let Y=!1;const J=new O.DisposableStore,q=new F.Emitter,U=new F.Emitter,$={id:r(o.identifier,k),notebookType:s,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:l||o.identifier.value,preloads:S?S.map(p.NotebookRendererScript.from):[]};let z=v??G,j;this.a.$addKernel(E,$).catch(de=>{console.log(de),Y=!0});let he=0;const we=()=>{if(Y)return;const de=++he;Promise.resolve().then(()=>{de===he&&this.a.$updateKernel(E,$)})},ie=new R.ResourceMap,oe={get id(){return k},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return $.label},set label(de){$.label=de??o.displayName??o.name,we()},get detail(){return $.detail??""},set detail(de){$.detail=de,we()},get description(){return $.description??""},set description(de){$.description=de,we()},get kind(){return(0,m.checkProposedApiEnabled)(o,"notebookControllerKind"),$.kind??""},set kind(de){(0,m.checkProposedApiEnabled)(o,"notebookControllerKind"),$.kind=de,we()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(de){$.supportedLanguages=de,we()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(de){$.supportsExecutionOrder=de,we()},get rendererScripts(){return $.preloads?$.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(de){z=de??G},get interruptHandler(){return j},set interruptHandler(de){j=de,$.supportsInterrupt=Boolean(de),we()},createNotebookCellExecution(de){if(Y)throw new Error("notebook controller is DISPOSED");if(!ie.has(de.notebook.uri))throw W.n.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return W._createNotebookCellExecution(de,r(o.identifier,this.id))},dispose:()=>{Y||(this.n.trace(`NotebookController[${E}], DISPOSED`),Y=!0,this.h.delete(E),J.dispose(),q.dispose(),U.dispose(),this.a.$removeKernel(E))},updateNotebookAffinity(de,ke){ke===d.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(E,de.uri,ke)},onDidReceiveMessage:U.event,postMessage(de,ke){return(0,m.checkProposedApiEnabled)(o,"notebookMessaging"),W.a.$postMessage(E,ke&&W.l.getIdByEditor(ke),de)},asWebviewUri(de){return(0,m.checkProposedApiEnabled)(o,"notebookMessaging"),(0,t.asWebviewUri)(de,W.k.remote)}};return this.h.set(E,{extensionId:o.identifier,controller:oe,onDidReceiveMessage:U,onDidChangeSelection:q,associatedNotebooks:ie}),oe}getIdByController(o){for(const[k,s]of this.h)if(s.controller===o)return r(s.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,k){const s=this.d++,l=this;this.n.trace(`NotebookControllerDetectionTask[${s}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(s,k);const v={dispose:()=>{this.c.delete(s),l.a.$removeKernelDetectionTask(s)}};return this.c.set(s,v),v}registerKernelSourceActionProvider(o,k,s){const l=this.f++,v=typeof s.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,S=this;this.e.set(l,s),this.n.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,k);let E;return v!==void 0&&(E=s.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.e.delete(l),S.a.$removeKernelSourceActionProvider(l,l),E?.dispose()}}}async $provideKernelSourceActions(o,k){const s=this.e.get(o);if(s){const l=new O.DisposableStore;return this.g.add([l]),(await s.provideNotebookKernelSourceActions(k)??[]).map(S=>p.NotebookKernelSourceAction.from(S,this.m.converter,l))}return[]}$acceptNotebookAssociation(o,k,s){const l=this.h.get(o);if(l){const v=this.l.getNotebookDocument(w.URI.revive(k));s?l.associatedNotebooks.set(v.uri,!0):l.associatedNotebooks.delete(v.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,v.uri.toString(),s),l.onDidChangeSelection.fire({selected:s,notebook:v.apiNotebook})}}async $executeCells(o,k,s){const l=this.h.get(o);if(!l)return;const v=this.l.getNotebookDocument(w.URI.revive(k)),S=[];for(const E of s){const W=v.getCell(E);W&&S.push(W.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,v.uri.toString(),S.length),await l.controller.executeHandler.call(l.controller,S,v.apiNotebook,l.controller)}catch(E){this.n.error(`NotebookController[${o}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(o,k,s){const l=this.h.get(o);if(!l)return;const v=this.l.getNotebookDocument(w.URI.revive(k));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,v.apiNotebook);else for(const S of s){const E=v.getCell(S);E&&this.b.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,k,s){const l=this.h.get(o);if(!l)return;const v=this.l.getEditorById(k);l.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:s}))}$cellExecutionChanged(o,k,s){const v=this.l.getNotebookDocument(w.URI.revive(o)).getCell(k);if(v){const S=s?p.NotebookCellExecutionState.to(s):d.NotebookCellExecutionState.Idle;S!==void 0&&this.j.fire({cell:v.apiCell,state:S})}}_createNotebookCellExecution(o,k){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const v=new i(k,l,this.a);this.b.set(l.uri,v);const S=v.onDidChangeState(()=>{v.state===g.Resolved&&(v.dispose(),S.dispose(),this.b.delete(l.uri))});return v.asApiObject()}};P=je([Ve(4,L.ILogService)],P),e.ExtHostNotebookKernels=P;var g;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(g||(g={}));class i extends O.Disposable{get state(){return this.f}constructor(o,k,s){super(),this.j=k,this.k=s,this.b=i.a++,this.c=new F.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.D(new C.CancellationTokenSource),this.h=new u(10,l=>this.m(l)),this.i=k.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const k=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new y.SerializableObjectWithBuffers(k))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}q(o){let k=this.j;if(o&&(k=this.j.notebook.getCellFromApiCell(o)),!k)throw new Error("INVALID cell");return k.handle}r(o){return o.map(k=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(k.items,!0);return s===k.items?p.NotebookCellOutput.from(k):p.NotebookCellOutput.from({items:s,id:k.id,metadata:k.metadata})})}async s(o,k,s){const l=this.q(k),v=this.r((0,n.asArray)(o));return this.l({editType:a.CellExecutionUpdateType.Output,cellHandle:l,append:s,outputs:v})}async t(o,k,s){return o=d.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(o),!0),this.l({editType:a.CellExecutionUpdateType.OutputItems,items:o.map(p.NotebookCellOutputItem.from),outputId:k.id,append:s})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(s){o.i=s,o.m([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(s){if(o.f===g.Resolved||o.f===g.Started)throw new Error("Cannot call start again");o.f=g.Started,o.c.fire(),o.m({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:s})},end(s,l){if(o.f===g.Resolved)throw new Error("Cannot call resolve twice");o.f=g.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new y.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:s}))},clearOutput(s){return o.n(),o.s([],s,!1)},appendOutput(s,l){return o.n(),o.s(s,l,!0)},replaceOutput(s,l){return o.n(),o.s(s,l,!1)},appendOutputItems(s,l){return o.n(),o.t(s,l,!0)},replaceOutputItems(s,l){return o.n(),o.t(s,l,!1)}})}}i.a=0;class u{constructor(o,k){this.d=o,this.e=k,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const k=this.a;return this.a=[],this.e(k).finally(()=>o.complete())}}function r(c,o){return`${c.value}/${o}`}e.createKernelId=r}),define(Pe[231],Ae([1,0,5,4,102]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(R,w){this.c=w,this.a=new Map,this.b=R.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,w,h){const L=this.c.getEditorById(R);this.a.get(w)?.fire({editor:L.apiEditor,message:h})}createRendererMessaging(R,w){if(!R.contributes?.notebookRenderer?.some(L=>L.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(L,D,f)=>this.d(w).event(L,D,f),postMessage:(L,D)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,D]=[D,L]);const f=D&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(f?.id,w,L)}}}d(R){let w=this.a.get(R);return w||(w=new n.Emitter({onDidRemoveLastListener:()=>{w?.dispose(),this.a.delete(R)}}),this.a.set(R,w),w)}}e.ExtHostNotebookRenderers=F}),define(Pe[232],Ae([1,0,6,9,2,26,4]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(h){this.b=new Map,this.a=h.getProxy(O.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(h,L,D){if((0,F.checkProposedApiEnabled)(h,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,D),this.a.$registerProfileContentHandler(L,D.name,D.description,h.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(h,L,D,f){const b=this.b.get(h);if(!b)throw new Error(`Unknown handler with id: ${h}`);return b.saveProfile(L,D,f)}async $readProfile(h,L,D){const f=this.b.get(h);if(!f)throw new Error(`Unknown handler with id: ${h}`);return f.readProfile((0,A.isString)(L)?L:C.URI.revive(L),D)}}e.ExtHostProfileContentHandlers=R}),define(Pe[233],Ae([1,0,2,4,17,8]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class O{constructor(w,h){this.d=h,this.c=new Map,this.b=w.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(w,h,L){const D=n.URI.revive(h),f=this.c.get(w);return f?(0,C.asPromise)(()=>f.provideOriginalResource(D,L)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(w,h,L,D){const f=O.a++;return this.c.set(f,h),this.b.$registerQuickDiffProvider(f,F.DocumentSelector.from(w,this.d),L,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}O.a=0,e.ExtHostQuickDiff=O}),define(Pe[234],Ae([1,0,21,5,6,4,2,7,10,16,29,39,26,8]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(d,t,a){const m=d.getProxy(F.MainContext.MainThreadQuickOpen);class y{constructor(s,l){this.e=new Map,this.f=0,this.a=s,this.b=l}showQuickPick(s,l,v,S=n.CancellationToken.None){this.c=void 0;const E=Promise.resolve(l),W=++this.f,G=m.$show(W,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},S),Y={},J=G.then(()=>Y);return Promise.race([J,E]).then(q=>{if(q===Y)return;const U=(0,f.isProposedApiEnabled)(s,"quickPickItemTooltip");return E.then($=>{const z=[];for(let j=0;j<$.length;j++){const he=$[j];typeof he=="string"?z.push({label:he,handle:j}):he.kind===R.QuickPickItemKind.Separator?z.push({type:"separator",label:he.label}):(he.tooltip&&!U&&console.warn(`Extension '${s.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`),z.push({label:he.label,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:U?b.MarkdownString.fromStrict(he.tooltip):void 0,handle:j}))}return v&&typeof v.onDidSelectItem=="function"&&(this.c=j=>{v.onDidSelectItem($[j])}),m.$setItems(W,z),G.then(j=>{if(typeof j=="number")return $[j];if(Array.isArray(j))return j.map(he=>$[he])})})}).then(void 0,q=>{if(!(0,w.isCancellationError)(q))return m.$setError(W,q),Promise.reject(q)})}$onItemSelected(s){this.c?.(s)}showInput(s,l=n.CancellationToken.None){return this.d=s?.validateInput,m.$input(s,typeof this.d=="function",l).then(void 0,v=>{if(!(0,w.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(s){if(!this.d)return;const l=await this.d(s);if(!l||typeof l=="string")return l;let v;switch(l.severity){case R.InputBoxValidationSeverity.Info:v=L.default.Info;break;case R.InputBoxValidationSeverity.Warning:v=L.default.Warning;break;case R.InputBoxValidationSeverity.Error:v=L.default.Error;break;default:v=l.message?L.default.Error:L.default.Ignore;break}return{content:l.message,severity:v}}async showWorkspaceFolderPick(s,l=n.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!v)return;const S=await this.a.getWorkspaceFolders2();if(!!S)return S.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(s){const l=new c(s,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}createInputBox(s){const l=new o(s,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}$onDidChangeValue(s,l){this.e.get(s)?._fireDidChangeValue(l)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,l){const v=this.e.get(s);v instanceof c&&v._fireDidChangeActive(l)}$onDidChangeSelection(s,l){const v=this.e.get(s);v instanceof c&&v._fireDidChangeSelection(l)}$onDidTriggerButton(s,l){this.e.get(s)?._fireDidTriggerButton(l)}$onDidTriggerItemButton(s,l,v){const S=this.e.get(s);S instanceof c&&S._fireDidTriggerItemButton(l,v)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class P{constructor(s,l){this.x=s,this.y=l,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((l,v)=>{const S=l===R.QuickInputButtons.Back?-1:v;this.o.set(S,l)}),this.z({buttons:s.map((l,v)=>({...r(l),tooltip:l.tooltip,handle:l===R.QuickInputButtons.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const l=this.o.get(s);l&&this.r.fire(l)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(s){if(!this.v){for(const l of Object.keys(s)){const v=s[l];this.u[l]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}P.a=1;function g(k){if(k instanceof R.ThemeIcon)return{id:k.id};const s=u(k),l=i(k);return{dark:typeof s=="string"?O.URI.file(s):s,light:typeof l=="string"?O.URI.file(l):l}}function i(k){return typeof k=="object"&&"light"in k?k.light:k}function u(k){return typeof k=="object"&&"dark"in k?k.dark:k}function r(k){const s=g(k.iconPath);let l,v;return"id"in s?v=D.ThemeIcon.asClassName(s):l=s,{iconPath:l,iconClass:v}}class c extends P{constructor(s,l){super(s.identifier,l),this.O=s,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((S,E)=>{this.C.set(E,S),this.D.set(S,E)});const l=(0,f.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),v=[];for(let S=0;S<s.length;S++){const E=s[S];E.kind===R.QuickPickItemKind.Separator?v.push({type:"separator",label:E.label}):(E.tooltip&&!l&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),v.push({handle:S,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:l?b.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((W,G)=>({...r(W),tooltip:W.tooltip,handle:G}))}))}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(l=>this.D.has(l)),this.z({activeItems:this.J.map(l=>this.D.get(l))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(l=>this.D.has(l)),this.z({selectedItems:this.L.map(l=>this.D.get(l))})}_fireDidChangeActive(s){const l=(0,h.coalesce)(s.map(v=>this.C.get(v)));this.J=l,this.K.fire(l)}_fireDidChangeSelection(s){const l=(0,h.coalesce)(s.map(v=>this.C.get(v)));this.L=l,this.M.fire(l)}_fireDidTriggerItemButton(s,l){const v=this.C.get(s);if(!v||!v.buttons||!v.buttons.length)return;const S=v.buttons[l];S&&this.N.fire({button:S,item:v})}}class o extends P{constructor(s,l){super(s.identifier,l),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:L.default.Error}):this.z({validationMessage:s.message,severity:s.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new y(t,a)}e.createExtHostQuickOpen=p});var Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n};define(Pe[235],Ae([1,0,2,5,64,6,17,4,16,125,14,24,39,8,26]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p){"use strict";var d,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(l){if(l)return typeof l.iconPath=="string"?n.URI.file(l.iconPath):n.URI.isUri(l.iconPath)||f.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function m(l,v){if(!l.iconPath&&!v.iconPath)return 0;if(l.iconPath){if(!v.iconPath)return 1}else return-1;const S=typeof l.iconPath=="string"?l.iconPath:n.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,E=typeof v.iconPath=="string"?v.iconPath:n.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,h.comparePaths)(S,E)}function y(l,v){let S=0;if(l.strikeThrough!==v.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==v.faded)return l.faded?1:-1;if(l.tooltip!==v.tooltip)return(l.tooltip||"").localeCompare(v.tooltip||"");if(S=m(l,v),S!==0)return S;if(l.light&&v.light)S=m(l.light,v.light);else{if(l.light)return 1;if(v.light)return-1}if(S!==0)return S;if(l.dark&&v.dark)S=m(l.dark,v.dark);else{if(l.dark)return 1;if(v.dark)return-1}return S}function P(l,v){if(l.command!==v.command)return l.command<v.command?-1:1;if(l.title!==v.title)return l.title<v.title?-1:1;if(l.tooltip!==v.tooltip){if(l.tooltip!==void 0&&v.tooltip!==void 0)return l.tooltip<v.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(l.arguments===v.arguments)return 0;if(l.arguments)if(v.arguments){if(l.arguments.length!==v.arguments.length)return l.arguments.length-v.arguments.length}else return 1;else return-1;for(let S=0;S<l.arguments.length;S++){const E=l.arguments[S],W=v.arguments[S];if(E!==W)return E<W?-1:1}return 0}function g(l,v){let S=(0,h.comparePaths)(l.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(S!==0)return S;if(l.command&&v.command)S=P(l.command,v.command);else{if(l.command)return 1;if(v.command)return-1}if(S!==0)return S;if(l.decorations&&v.decorations)S=y(l.decorations,v.decorations);else{if(l.decorations)return 1;if(v.decorations)return-1}return S}function i(l,v){for(let S=0;S<l.length;S++)if(l[S]!==v[S])return!1;return!0}function u(l,v){return l.command===v.command&&l.title===v.title&&l.tooltip===v.tooltip&&(l.arguments&&v.arguments?i(l.arguments,v.arguments):l.arguments===v.arguments)}function r(l,v){return(0,w.equals)(l,v,u)}class c{get value(){return this.d}set value(v){v=v??"",Le(this,d,"f").$setInputBoxValue(this.l,v),this.m(v)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(v){Le(this,d,"f").$setInputBoxPlaceholder(this.l,v),this.f=v}get validateInput(){return(0,p.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(v){if((0,p.checkProposedApiEnabled)(this.k,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=v,Le(this,d,"f").$setValidationProviderIsEnabled(this.l,!!v)}get enabled(){return this.h}set enabled(v){v=!!v,this.h!==v&&(this.h=v,Le(this,d,"f").$setInputBoxEnablement(this.l,v))}get visible(){return this.j}set visible(v){v=!!v,this.j!==v&&(this.j=v,Le(this,d,"f").$setInputBoxVisibility(this.l,v))}constructor(v,S,E){this.k=v,this.l=E,d.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,S,"f")}showValidationMessage(v,S){(0,p.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,d,"f").$showValidationMessage(this.l,v,S)}$onInputBoxValueChange(v){this.m(v)}m(v){this.d=v,this.e.fire(v)}}e.ExtHostSCMInputBox=c,d=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(v){this.v=v,this.q.$updateGroupLabel(this.t,this.handle,v)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(v){this.p=v,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(v){this.f=[...v],this.k.fire()}constructor(v,S,E,W,G){this.q=v,this.s=S,this.t=E,this.u=W,this.v=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(v){return this.g.get(v)}$executeResourceCommand(v,S){const E=this.h.get(v);return E?(0,O.asPromise)(()=>this.s.executeCommand(E.command,...E.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this.f].sort(g),E=(0,w.sortedDiff)(this.o,v,g).map(Y=>{const J=Y.toInsert.map(q=>{const U=this.e++;this.g.set(U,q);const $=q.resourceUri;let z;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const T=new F.DisposableStore;z=this.s.converter.toInternal(q.command,T),this.j.set(U,T)}else this.h.set(U,q.command);const j=a(q.decorations),he=q.decorations&&a(q.decorations.light)||j,we=q.decorations&&a(q.decorations.dark)||j,ie=[he,we],oe=q.decorations&&q.decorations.tooltip||"",de=q.decorations&&!!q.decorations.strikeThrough,ke=q.decorations&&!!q.decorations.faded,le=q.contextValue||"";return{rawResource:[U,$,ie,oe,de,ke,le,z],handle:U}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:J}}),W=E.map(({start:Y,deleteCount:J,toInsert:q})=>[Y,J,q.map(U=>U.rawResource)]),G=E.reverse();for(const{start:Y,deleteCount:J,toInsert:q}of G){const U=q.map(z=>z.handle),$=this.n.splice(Y,J,...U);for(const z of $)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=v,W}dispose(){this.l=!0,this.m.fire()}}o.d=0;class k{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(v){this.g!==v&&(this.g=v,Le(this,t,"f").$updateSourceControl(this.t,{count:v}))}get quickDiffProvider(){return this.h}set quickDiffProvider(v){this.h=v,v?.label&&(0,p.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Le(this,t,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!v,quickDiffLabel:v?.label})}get commitTemplate(){return this.j}set commitTemplate(v){v!==this.j&&(this.j=v,Le(this,t,"f").$updateSourceControl(this.t,{commitTemplate:v}))}get acceptInputCommand(){return this.l}set acceptInputCommand(v){this.k.value=new F.DisposableStore,this.l=v;const S=this.v.converter.toInternal(v,this.k.value);Le(this,t,"f").$updateSourceControl(this.t,{acceptInputCommand:S})}get actionButton(){return(0,p.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(v){(0,p.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new F.DisposableStore,this.n=v;const S=v!==void 0?{command:this.v.converter.toInternal(v.command,this.m.value),secondaryCommands:v.secondaryCommands?.map(E=>E.map(W=>this.v.converter.toInternal(W,this.m.value))),description:v.description,enabled:v.enabled}:void 0;Le(this,t,"f").$updateSourceControl(this.t,{actionButton:S??null})}get statusBarCommands(){return this.p}set statusBarCommands(v){if(this.p&&v&&r(this.p,v))return;this.o.value=new F.DisposableStore,this.p=v;const S=(v||[]).map(E=>this.v.converter.toInternal(E,this.o.value));Le(this,t,"f").$updateSourceControl(this.t,{statusBarCommands:S})}get selected(){return this.q}constructor(v,S,E,W,G,Y){this.u=v,this.v=E,this.w=W,this.x=G,this.y=Y,t.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new F.MutableDisposable,this.l=void 0,this.m=new F.MutableDisposable,this.o=new F.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=k.d++,this.z=new Map,this.A=new Set,Je(this,t,S,"f"),this.f=new c(v,Le(this,t,"f"),this.t),Le(this,t,"f").$registerSourceControl(this.t,W,G,Y)}createResourceGroup(v,S){const E=new o(Le(this,t,"f"),this.v,this.t,v,S),W=A.Event.once(E.onDidDispose)(()=>this.z.delete(E));return this.z.set(E,W),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const v=[],S=[];for(const[E,W]of this.z){W.dispose();const G=E.onDidUpdateResourceStates(()=>{this.A.add(E),this.eventuallyUpdateResourceStates()});A.Event.once(E.onDidDispose)(()=>{this.A.delete(E),G.dispose(),this.e.delete(E.handle),Le(this,t,"f").$unregisterGroup(this.t,E.handle)}),v.push([E.handle,E.id,E.label,E.features]);const Y=E._takeResourceStateSnapshot();Y.length>0&&S.push([E.handle,Y]),this.e.set(E.handle,E)}Le(this,t,"f").$registerGroups(this.t,v,S),this.z.clear()}eventuallyUpdateResourceStates(){const v=[];this.A.forEach(S=>{const E=S._takeResourceStateSnapshot();E.length!==0&&v.push([S.handle,E])}),v.length>0&&Le(this,t,"f").$spliceResourceStates(this.t,v),this.A.clear()}getResourceGroup(v){return this.e.get(v)}setSelectionState(v){this.q=v,this.s.fire(v)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(v=>v.dispose()),Le(this,t,"f").$unregisterSourceControl(this.t)}}t=new WeakMap,k.d=0,je([(0,C.debounce)(100)],k.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let s=class ln{get onDidChangeActiveProvider(){return this.j.event}constructor(v,S,E){this.l=S,this.m=E,this.g=new Map,this.h=new D.ExtensionIdentifierMap,this.j=new A.Emitter,this.e=v.getProxy(R.MainContext.MainThreadSCM),this.f=v.getProxy(R.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const G=this.g.get(W.sourceControlHandle);if(!G)return W;const Y=G.getResourceGroup(W.groupHandle);return Y?Y.getResourceState(W.handle):W}else if(W&&W.$mid===4){const G=this.g.get(W.sourceControlHandle);return G?G.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const G=this.g.get(W.handle);return G||W}return W}})}createSourceControl(v,S,E,W){this.m.trace("ExtHostSCM#createSourceControl",v.identifier.value,S,E,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const G=ln.d++,Y=new k(v,this.e,this.l,S,E,W);this.g.set(G,Y);const J=this.h.get(v.identifier)||[];return J.push(Y),this.h.set(v.identifier,J),Y}getLastInputBox(v){this.m.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const S=this.h.get(v.identifier),E=S&&S[S.length-1];return E&&E.inputBox}$provideOriginalResource(v,S,E){const W=n.URI.revive(S);this.m.trace("ExtHostSCM#$provideOriginalResource",v,W.toString());const G=this.g.get(v);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,O.asPromise)(()=>G.quickDiffProvider.provideOriginalResource(W,E)).then(Y=>Y||null)}$onInputBoxValueChange(v,S){this.m.trace("ExtHostSCM#$onInputBoxValueChange",v);const E=this.g.get(v);return E&&E.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(v,S,E,W){this.m.trace("ExtHostSCM#$executeResourceCommand",v,S,E);const G=this.g.get(v);if(!G)return Promise.resolve(void 0);const Y=G.getResourceGroup(S);return Y?Y.$executeResourceCommand(E,W):Promise.resolve(void 0)}$validateInput(v,S,E){this.m.trace("ExtHostSCM#$validateInput",v);const W=this.g.get(v);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,O.asPromise)(()=>W.inputBox.validateInput(S,E)).then(G=>{if(!G)return Promise.resolve(void 0);const Y=b.MarkdownString.fromStrict(G.message);return Y?Promise.resolve([Y,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this.g.get(v)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=v,Promise.resolve(void 0)}};s.d=0,s=je([Ve(2,L.ILogService)],s),e.ExtHostSCM=s}),define(Pe[80],Ae([1,0,4,5,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class F{constructor(R){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,w){return this.a.$getPassword(R,w)}store(R,w,h){return this.a.$setPassword(R,w,h)}delete(R,w){return this.a.$deletePassword(R,w)}}e.ExtHostSecretState=F,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[236],Ae([1,0,7,4,147,6,8,9]),function(ee,e,n,A,C,F,O,R){"use strict";var w,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(p,d,t,a,m=n.StatusBarAlignment.Left,y){w.set(this,void 0),h.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new F.DisposableStore,Je(this,w,p,"f"),Je(this,h,d,"f"),this.c=L.a++,this.e=t,this.f=a,this.g=m,this.h=this.u(y)}u(p){if(!!(0,R.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!L.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new F.DisposableStore,typeof p=="string"?this.r={fromApi:p,internal:Le(this,h,"f").toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:Le(this,h,"f").toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,w,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let d;this.m?d=this.m:d=(0,C.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=L.b.get(this.o.id));const a=O.MarkdownString.fromStrict(this.l);Le(this,w,"f").$setEntry(this.c,p,d,this.k,a,this.r?.internal,t,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}w=new WeakMap,h=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class D{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const d={message:p};return this.b.unshift(d),this.c(),new n.Disposable(()=>{const t=this.b.indexOf(d);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(p,d){this.a=p.getProxy(A.MainContext.MainThreadStatusBar),this.b=d,this.c=new D(this)}createStatusBarEntry(p,d,t,a){return new L(this.a,this.b,p,d,t,a)}setStatusBarMessage(p,d){const t=this.c.setMessage(p);let a;return typeof d=="number"?a=setTimeout(()=>t.dispose(),d):typeof d<"u"&&d.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=f}),define(Pe[81],Ae([1,0,4,5,3]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class F{constructor(R,w){this.c=w,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,w){this.a.$registerExtensionStorageKeysToSync(R,w)}async initializeExtensionStorage(R,w,h){const L=await this.a.$initializeExtensionStorage(R,w);let D;return L&&(D=this.d(R,w,L)),D||h}setValue(R,w,h){return this.a.$setValue(R,w,h)}$acceptValue(R,w,h){const L=this.d(R,w,h);L&&this.b.fire({shared:R,key:w,value:L})}d(R,w,h){try{return JSON.parse(h)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${R}): ${L}`)}}}e.ExtHostStorage=F,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(Pe[82],Ae([1,0,3,27,14,60,2]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let R=class{constructor(h,L,D){this.d=L,this.f=D,this.a=h.workspace??void 0,this.b=h.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(h){return O.URI.joinPath(this.b.workspaceStorageHome,h)}async h(){if(!this.a)return Promise.resolve(void 0);const h=this.a.id,L=await this.g(h);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(O.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:O.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(h){if(this.c)return O.URI.joinPath(this.c,h.identifier.value)}globalValue(h){return O.URI.joinPath(this.b.globalStorageHome,h.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=je([Ve(0,A.IExtHostInitDataService),Ve(1,C.ILogService),Ve(2,F.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Pe[61],Ae([1,0,5,4,3,2,18,6,7,149,10,175,21,35,176,39,9,17,8]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class y{constructor(s,l,v,S){this.k=s,this._id=l,this.l=v,this.m=S,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(W=>this.f=W);const E=this;this.value={get name(){return E.m||""},get processId(){return E.b},get creationOptions(){return E.l},get exitStatus(){return E.h},get state(){return E.j},sendText(W,G=!0){E.o(),E.k.$sendText(E._id,W,G)},show(W){E.o(),E.k.$show(E._id,W)},hide(){E.o(),E.k.$hide(E._id)},dispose(){E.a||(E.a=!0,E.k.$dispose(E._id))},get dimensions(){if(!(E.d===void 0||E.g===void 0))return{columns:E.d,rows:E.g}}}}async create(s,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:s.name,shellPath:(0,t.withNullAsUndefined)(s.shellPath),shellArgs:(0,t.withNullAsUndefined)(s.shellArgs),cwd:(0,t.withNullAsUndefined)(s.cwd),env:(0,t.withNullAsUndefined)(s.env),icon:(0,t.withNullAsUndefined)(c(s.iconPath)),color:d.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,t.withNullAsUndefined)(s.message),strictEnv:(0,t.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this.n(s.location,l?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,l,v,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:d.ThemeColor.isThemeColor(S)?S.id:void 0,location:this.n(s,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(s,l){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in s?{viewColumn:m.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(s){this.m=s}setExitStatus(s,l){this.h=Object.freeze({code:s,reason:l})}setDimensions(s,l){return s===this.d&&l===this.g||s===0||l===0?!1:(this.d=s,this.g=l,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(s){this.f?(this.f(s),this.f=void 0):this.b.then(l=>{l!==s&&(this.b=Promise.resolve(s))})}}e.ExtHostTerminal=y;class P{get onProcessReady(){return this.b.event}constructor(s){this.g=s,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(s){this.g.handleInput?.(s)}resize(s,l){this.g.setDimensions?.({columns:s,rows:l})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(s||void 0),s&&this.g.setDimensions?.(s),this.b.fire({pid:-1,cwd:""})}}let g=1,i=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(s=>s.value)}get onDidWriteTerminalData(){return this.I.event}constructor(s,l){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new n.Emitter,this.onDidCloseTerminal=this.z.event,this.C=new n.Emitter,this.onDidOpenTerminal=this.C.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=l.getProxy(A.MainContext.MainThreadTerminalService),this.q=new p.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(s),this.D({dispose:()=>{for(const[v,S]of this.g)S.shutdown(!0)}})}getDefaultShell(s){return(s?this.n:this.m)?.path||""}getDefaultShellArgs(s){return(s?this.n:this.m)?.args||[]}createExtensionTerminal(s,l){const v=new y(this.a,(0,b.generateUuid)(),s,s.name),S=new P(s.pty);return v.createExtensionTerminal(s.location,this.L(s,l).resolvedExtHostIdentifier,c(s.iconPath),o(s.color)).then(E=>{const W=this.M(E,S);this.h[E]=W}),this.f.push(v),v.value}L(s,l){if(l=l||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const v=s.location.parentTerminal;if(v){const S=this.f.find(E=>E.value===v);S&&(l.resolvedExtHostIdentifier=S._id)}}else s.location&&typeof s.location!="object"?l.location=s.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(s,l){if(!this.O(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const S=new P(l),E=this.M(s,S);this.h[s]=E}async $acceptActiveTerminalChanged(s){const l=this.b;if(s===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const v=this.O(s);v&&(this.b=v,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(s,l){const v=this.O(s);v&&this.I.fire({terminal:v.value,data:l})}async $acceptTerminalDimensions(s,l,v){const S=this.O(s);S&&S.setDimensions(l,v)&&this.G.fire({terminal:S.value,dimensions:S.value.dimensions})}async $acceptTerminalMaximumDimensions(s,l,v){this.g.get(s)?.resize(l,v)}async $acceptTerminalTitleChange(s,l){const v=this.O(s);v&&(v.name=l)}async $acceptTerminalClosed(s,l,v){const S=this.Q(this.f,s);if(S!==null){const E=this.f.splice(S,1)[0];E.setExitStatus(l,v),this.z.fire(E.value)}}$acceptTerminalOpened(s,l,v,S){if(l){const G=this.Q(this.f,l);if(G!==null){this.f[G]._id=s,this.C.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const E={name:S.name,shellPath:S.executable,shellArgs:S.args,cwd:typeof S.cwd=="string"?S.cwd:F.URI.revive(S.cwd),env:S.env,hideFromUser:S.hideFromUser},W=new y(this.a,s,E,v);this.f.push(W),this.C.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(s,l){this.O(s)?._setProcessId(l)}async $startExtensionTerminal(s,l){const v=this.O(s);if(!v)return{message:(0,h.localize)(0,null,s)};v.isOpen||await new Promise(E=>{const W=this.onDidOpenTerminal(async G=>{G===v.value&&(W.dispose(),E())})});const S=this.g.get(s);S?S.startSendingEvents(l):this.j[s]={initialDimensions:l}}M(s,l){const v=new R.DisposableStore;v.add(l.onProcessReady(E=>this.a.$sendProcessReady(s,E.pid,E.cwd))),v.add(l.onDidChangeProperty(E=>this.a.$sendProcessProperty(s,E))),this.q.startBuffering(s,l.onProcessData),v.add(l.onProcessExit(E=>this.N(s,E))),this.g.set(s,l);const S=this.j[s];return S&&l instanceof P&&(l.startSendingEvents(S.initialDimensions),delete this.j[s]),v}$acceptProcessAckDataEvent(s,l){this.g.get(s)?.acknowledgeDataEvent(l)}$acceptProcessInput(s,l){this.g.get(s)?.input(l)}$acceptTerminalInteraction(s){const l=this.O(s);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptProcessResize(s,l,v){try{this.g.get(s)?.resize(l,v)}catch(S){if(S.code!=="EPIPE"&&S.code!=="ERR_IPC_CHANNEL_CLOSED")throw S}}$acceptProcessShutdown(s,l){this.g.get(s)?.shutdown(l)}$acceptProcessRequestInitialCwd(s){this.g.get(s)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(s,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(s){this.g.get(s)?.getCwd().then(l=>this.a.$sendProcessProperty(s,{type:"cwd",value:l}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this.s.add(s),this.s.size===1&&this.a.$startLinkProvider(),new w.Disposable(()=>{this.s.delete(s),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(s,l,v){if(this.u.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.u.set(l,v),this.a.$registerProfileProvider(l,s.identifier.value),new w.Disposable(()=>{this.u.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(s,l,v){if(this.v.has(s))throw new Error(`Terminal quick fix provider "${s}" is already registered`);return this.v.set(s,v),this.a.$registerQuickFixProvider(s,l),new w.Disposable(()=>{this.v.delete(s),this.a.$unregisterQuickFixProvider(s)})}async $provideTerminalQuickFixes(s,l){const v=new f.CancellationTokenSource().token;if(v.isCancellationRequested)return;const S=this.v.get(s);if(!S)return;const E=await S.provideTerminalQuickFixes(l,v);if(E!==null)return E}async $createContributedProfileTerminal(s,l){const v=new f.CancellationTokenSource().token;let S=await this.u.get(s)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(S&&!("options"in S)&&(S={options:S}),!S||!("options"in S))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in S.options){this.createExtensionTerminal(S.options,l);return}this.createTerminalFromOptions(S.options,l)}}async $provideLinks(s,l){const v=this.O(s);if(!v)return[];this.w.delete(s),this.y.get(s)?.dispose(!0);const E=new f.CancellationTokenSource;this.y.set(s,E);const W=[],G={terminal:v.value,line:l},Y=[];for(const U of this.s)Y.push(a.Promises.withAsyncBody(async $=>{E.token.onCancellationRequested(()=>$({provider:U,links:[]}));const z=await U.provideTerminalLinks(G,E.token)||[];E.token.isCancellationRequested||$({provider:U,links:z})}));const J=await Promise.all(Y);if(E.token.isCancellationRequested)return[];const q=new Map;for(const U of J)U&&U.links.length>0&&W.push(...U.links.map($=>{const z={id:g++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return q.set(z.id,{provider:U.provider,link:$}),z}));return this.w.set(s,q),W}$activateLink(s,l){const v=this.w.get(s)?.get(l);!v||v.provider.handleTerminalLink(v.link)}N(s,l){this.q.stopBuffering(s),this.g.delete(s),delete this.j[s];const v=this.h[s];v&&(v.dispose(),delete this.h[s]),this.a.$sendProcessExit(s,l)}O(s){return this.P(this.f,s)}P(s,l){const v=this.Q(s,l);return v!==null?s[v]:null}Q(s,l){let v=null;return s.some((S,E)=>S._id===l?(v=E,!0):!1),v}getEnvironmentVariableCollection(s){let l=this.l.get(s.identifier.value);return l||(l=new u,this.S(s.identifier.value,l)),l}R(s,l){const v=(0,D.serializeEnvironmentVariableCollection)(l.map);this.a.$setEnvironmentVariableCollection(s,l.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(s){s.forEach(l=>{const v=l[0],S=new u(l[1]);this.S(v,S)})}$acceptDefaultProfile(s,l){const v=this.m;this.m=s,this.n=l,v?.path!==s.path&&this.J.fire(s.path)}S(s,l){this.l.set(s,l),l.onDidChangeCollection(()=>{this.R(s,l)})}};i=je([Ve(1,O.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class u{get persistent(){return this.a}set persistent(s){this.a=s,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(s){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,l){this.d(s,{value:l,type:w.EnvironmentVariableMutatorType.Replace})}append(s,l){this.d(s,{value:l,type:w.EnvironmentVariableMutatorType.Append})}prepend(s,l){this.d(s,{value:l,type:w.EnvironmentVariableMutatorType.Prepend})}d(s,l){const v=this.map.get(s);(!v||v.value!==l.value||v.type!==l.type)&&(this.map.set(s,l),this.b.fire())}get(s){return this.map.get(s)}forEach(s,l){this.map.forEach((v,S)=>s.call(l,S,v,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends i{constructor(s){super(!1,s)}createTerminal(s,l,v){throw new L.NotSupportedError}createTerminalFromOptions(s,l){throw new L.NotSupportedError}};r=je([Ve(0,O.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function c(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function o(k){return d.ThemeColor.isThemeColor(k)?k:void 0}});var Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n};define(Pe[237],Ae([1,0,16,17,25,21,5,199,91,6,23,9,35,4,18,103,8,7,45,73,56,26]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g){"use strict";var i,u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(U,$,z){this.j=z,this.c=new O.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(b.MainContext.MainThreadTesting),this.h=new G(this.f),this.g=new s(this.f),$.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const he=j,we=he.tests[he.tests.length-1].item.extId;return this.d.get(m.TestId.root(we))?.collection.tree.get(we)?.actual??(0,d.toItemFromContext)(j)}})}createTestController(U,$,z,j){if(this.d.has($))throw new Error(`Attempt to insert a duplicate controller with ID "${$}"`);const he=new h.DisposableStore,we=he.add(new d.ExtHostTestItemCollection($,z,this.j));we.root.label=z;const ie=new Map,oe=this.f,de={items:we.root.children,get label(){return z},set label(le){z=le,we.root.label=le,oe.$updateController($,{label:z})},get refreshHandler(){return j},set refreshHandler(le){j=le,oe.$updateController($,{canRefresh:!!le})},get id(){return $},createRunProfile:(le,X,T,V,ce,me)=>{let Fe=(0,w.hash)(le);for(;ie.has(Fe);)Fe++;return me!==void 0&&(0,g.checkProposedApiEnabled)(U,"testContinuousRun"),new Y(this.f,ie,$,Fe,le,X,T,V,ce,me)},createTestItem(le,X,T){return new d.TestItemImpl($,le,X,T)},createTestRun:(le,X,T=!0)=>this.g.createTestRun($,we,le,X,T),set resolveHandler(le){we.resolveHandler=le},get resolveHandler(){return we.resolveHandler},dispose:()=>{he.dispose()}};oe.$registerTestController($,z,!!j),he.add((0,h.toDisposable)(()=>oe.$unregisterTestController($)));const ke={controller:de,collection:we,profiles:ie};return this.d.set($,ke),he.add((0,h.toDisposable)(()=>this.d.delete($))),he.add(we.onDidGenerateDiff(le=>oe.$publishDiff($,le.map(P.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(U,$=F.CancellationToken.None){const z=l(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(he=>m.TestId.fromExtHostTestItem(he,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:J[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(he=>he.id)},$)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,$,z){return(0,n.mapFind)(this.g.trackers,he=>he.id===U?he.getCoverage($):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(U,$,z,j){return(0,n.mapFind)(this.g.trackers,we=>we.id===U?we.getCoverage($):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(U,$){this.d.get(U)?.profiles.get($)?.configureHandler?.()}async $refreshTests(U,$){await this.d.get(U)?.controller.refreshHandler?.($)}$publishTestResults(U){this.results=Object.freeze(U.map($=>(0,L.deepFreeze)(t.TestResults.to($))).concat(this.results).sort(($,z)=>z.completedAt-$.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,$){const z=this.d.get(m.TestId.fromString(U).controllerId)?.collection;z&&(await z.expand(U,$<0?1/0:$),z.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(P.TestsDiffOp.deserialize))}async $runControllerTests(U,$){return Promise.all(U.map(z=>this.k(z,!1,$)))}async $startContinuousRun(U,$){const z=new F.CancellationTokenSource($),j=await Promise.all(U.map(he=>this.k(he,!0,z.token)));return!$.isCancellationRequested&&!j.some(he=>he.error)&&await new Promise(he=>$.onCancellationRequested(he)),z.dispose(!0),j}async k(U,$,z){const j=this.d.get(U.controllerId);if(!j)return{};const{collection:he,profiles:we}=j,ie=we.get(U.profileId);if(!ie)return{};const oe=U.testIds.map(X=>he.tree.get(X)).filter(D.isDefined),de=U.excludeExtIds.map(X=>j.collection.tree.get(X)).filter(D.isDefined).filter(X=>oe.some(T=>T.fullId.compare(X.fullId)===2));if(!oe.length)return{};const ke=new a.TestRunRequest2(oe.some(X=>X.actual instanceof d.TestItemRootImpl)?void 0:oe.map(X=>X.actual),de.map(X=>X.actual),ie,$),le=(0,P.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(ke,v.fromInternal(U,j.collection),z);try{return await ie.runHandler(ke,z),{}}catch(X){return{error:String(X)}}finally{le&&(le.hasRunningTasks&&!z.isCancellationRequested&&await O.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};r=je([Ve(0,p.IExtHostRpcService)],r),e.ExtHostTesting=r;const c=1e4;var o;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(o||(o={}));class k extends h.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,$,z){super(),this.k=U,this.l=$,this.c=0,this.f=new Map,this.g=new Set,this.j=this.D(new O.Emitter),this.onEnd=this.j.event,this.h=this.D(new F.CancellationTokenSource(z));const j=this.D(new A.RunOnceScheduler(()=>this.m(),c));this.D(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const $=this.k.id,z=this.k.controllerId,j=(0,f.generateUuid)(),he=new S(this.l,$,j),we=ke=>(le,...X)=>{if(oe){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(le)||(this.q(le),ke(le,...X))},ie=(ke,le)=>{const X=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(ke.uri&&ke.range){const T={range:t.Range.from(ke.range),uri:ke.uri};for(const V of X)V.location=V.location||T}this.l.$appendTestMessagesInRun($,j,m.TestId.fromExtHostTestItem(ke,z).toString(),X)};let oe=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return he.coverageProvider},set coverageProvider(ke){he.coverageProvider=ke},enqueued:we(ke=>{this.l.$updateTestStateInRun($,j,m.TestId.fromExtHostTestItem(ke,z).toString(),1)}),skipped:we(ke=>{this.l.$updateTestStateInRun($,j,m.TestId.fromExtHostTestItem(ke,z).toString(),5)}),started:we(ke=>{this.l.$updateTestStateInRun($,j,m.TestId.fromExtHostTestItem(ke,z).toString(),2)}),errored:we((ke,le,X)=>{ie(ke,le),this.l.$updateTestStateInRun($,j,m.TestId.fromExtHostTestItem(ke,z).toString(),6,X)}),failed:we((ke,le,X)=>{ie(ke,le),this.l.$updateTestStateInRun($,j,m.TestId.fromExtHostTestItem(ke,z).toString(),4,X)}),passed:we((ke,le)=>{this.l.$updateTestStateInRun($,j,m.TestId.fromExtHostTestItem(ke,this.k.controllerId).toString(),3,le)}),appendOutput:(ke,le,X)=>{oe||(X&&(this.k.isIncluded(X)?this.q(X):X=void 0),this.l.$appendOutputToRun($,j,C.VSBuffer.fromString(ke),le&&t.location.from(le),X&&m.TestId.fromExtHostTestItem(X,z).toString()))},end:()=>{oe||(oe=!0,this.l.$finishedTestRunTask($,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:de,coverage:he}),this.l.$startedTestRunTask($,{id:j,name:U,running:!0}),de}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}q(U){if(!(U instanceof d.TestItemImpl))throw new y.InvalidTestItemError(U.id);if(this.g.has(m.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const $=[],z=this.k.colllection.root;for(;;){const j=t.TestItem.from(U);if($.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),U===z))break;U=U.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,$)}}class s{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,$,z){return this.f(U,$,z)}cancelRunById(U){for(const $ of this.c.values())if($.id===U){$.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,$,z,j,he){const we=this.c.get(z);if(we)return we.createRun(j);const ie=v.fromPublic(U,$,z,he),oe=l(z);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!z.continuous,profile:oe&&{group:J[oe.kind],id:oe.profileId},exclude:z.exclude?.map(ke=>m.TestId.fromExtHostTestItem(ke,$.root.id).toString())??[],id:ie.id,include:z.include?.map(ke=>m.TestId.fromExtHostTestItem(ke,$.root.id).toString())??[$.root.id],persist:he});const de=this.f(z,ie);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),de.dispose()}),de.createRun(j)}f(U,$,z){const j=new k($,this.d,z);return this.c.set(U,j),j.onEnd(()=>this.c.delete(U)),j}}e.TestRunCoordinator=s;const l=q=>{if(!!q.profile){if(!(q.profile instanceof Y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class v{static fromPublic(U,$,z,j){return new v(U,(0,f.generateUuid)(),z.include?.map(he=>m.TestId.fromExtHostTestItem(he,U).toString())??[U],z.exclude?.map(he=>m.TestId.fromExtHostTestItem(he,U).toString())??[],j,$)}static fromInternal(U,$){return new v(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,$)}constructor(U,$,z,j,he,we){this.controllerId=U,this.id=$,this.isPersisted=he,this.colllection=we,this.c=z.map(ie=>ie+"\0"),this.d=j.map(ie=>ie+"\0")}isIncluded(U){const $=m.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.d)if($===z||$.startsWith(z))return!1;for(const z of this.c)if($===z||$.startsWith(z))return!0;return!1}}e.TestRunDto=v;class S{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,$,z){this.f=U,this.g=$,this.h=z}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch($){throw this.d=void 0,$}}async resolveFileCoverage(U,$){const z=await this.d;let j=z?.[U];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[U]=await this.c.resolveFileCoverage?.(j,$)??j),j.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const $=m.TestId.parentId(U.item.extId);if($&&this.g.has($.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:$,f:z}=this;return{get added(){return[...U].map(j=>j.revived)},get updated(){return[...$].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class W extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new O.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,$){return{...U,revived:t.TestItem.toPlain(U.item),depth:$?$.depth+1:0,children:new Set}}o(){return new E(this.q)}}class G{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map($=>$.revived)},dispose:(0,R.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new W;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class Y{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Le(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,$,z,j,he,we,ie,oe=!1,de=void 0,ke=!1){this.controllerId=z,this.profileId=j,this.d=he,this.kind=we,this.runHandler=ie,this.f=oe,this._tag=de,this.g=ke,i.set(this,void 0),u.set(this,void 0),Je(this,i,U,"f"),Je(this,u,$,"f"),$.set(j,this);const le=J[we];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${we}`);Le(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:z,tag:de?t.TestTag.namespace(this.controllerId,de.id):null,label:he,group:le,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:ke})}dispose(){Le(this,u,"f")?.delete(this.profileId)&&(Je(this,u,void 0,"f"),Le(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Y,i=new WeakMap,u=new WeakMap;const J={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Pe[238],Ae([1,0,16,10,5,4,104,8,7]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class h{constructor(D,f){this.i=f,this.a=new C.Emitter({onListenerError:A.onUnexpectedExternalError}),this.b=new C.Emitter({onListenerError:A.onUnexpectedExternalError}),this.c=new C.Emitter({onListenerError:A.onUnexpectedExternalError}),this.d=new C.Emitter({onListenerError:A.onUnexpectedExternalError}),this.f=new C.Emitter({onListenerError:A.onUnexpectedExternalError}),this.g=new C.Emitter({onListenerError:A.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(F.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const f=this.i.allEditors();return D?f:f.map(b=>b.value)}async showTextDocument(D,f,b){let p;typeof f=="number"?p={position:R.ViewColumn.from(f),preserveFocus:b}:typeof f=="object"?p={position:R.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selection:typeof f.selection=="object"?R.Range.from(f.selection):void 0,pinned:typeof f.preview=="boolean"?!f.preview:void 0}:p={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(D.uri,p),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,f){return new O.TextEditorDecorationType(this.h,D,f).value}$acceptEditorPropertiesChanged(D,f){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(f.options&&b._acceptOptions(f.options),f.selections){const p=f.selections.selections.map(R.Selection.to);b._acceptSelections(p)}if(f.visibleRanges){const p=n.coalesce(f.visibleRanges.map(R.Range.to));b._acceptVisibleRanges(p)}if(f.options&&this.b.fire({textEditor:b.value,options:{...f.options,lineNumbers:R.TextEditorLineNumbersStyle.to(f.options.lineNumbers)}}),f.selections){const p=w.TextEditorSelectionChangeKind.fromValue(f.selections.source),d=f.selections.selections.map(R.Selection.to);this.a.fire({textEditor:b.value,selections:d,kind:p})}if(f.visibleRanges){const p=n.coalesce(f.visibleRanges.map(R.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const f in D){const b=this.i.getEditor(f);if(!b)throw new Error("Unknown text editor");const p=R.ViewColumn.to(D[f]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.ExtHostEditors=h}),define(Pe[239],Ae([1,0,2,3,4,6,7,8,24,9]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&w.ExtensionIdentifier.equals(t,this.b.get(d.source)?.extension)){const a=d.uri===void 0?void 0:n.URI.revive(d.uri);return this.c.get(d.source)?.get(D(a))?.get(d.handle)}else return;return d}})}async $getTimeline(b,p,d,t){return this.b.get(b)?.provider.provideTimeline(n.URI.revive(p),d,t)}registerTimelineProvider(b,p,d,t){const a=new F.DisposableStore,m=this.d(p.id,t,a).bind(this);let y;p.onDidChange&&(y=p.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:p.id}),this));const P=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline(g,i,u){i?.resetCache&&(a.clear(),P.get(p.id)?.clear());const r=await p.provideTimeline(g,i,u);if(r==null)return;const c=m(g,i);return{...r,source:p.id,items:r.items.map(c)}},dispose(){for(const g of P.values())g.get(p.id)?.clear();y?.dispose(),a.dispose()}},d)}d(b,p,d){return(t,a)=>{let m;if(a?.cacheResults){let y=this.c.get(b);y===void 0&&(y=new Map,this.c.set(b,y));const P=D(t);m=y.get(P),m===void 0&&(m=new Map,y.set(P,m))}return y=>{const{iconPath:P,...g}=y,i=`${b}|${y.id??y.timestamp}`;m?.set(i,y);let u,r,c;y.iconPath&&(P instanceof O.ThemeIcon?c={id:P.id,color:P.color}:n.URI.isUri(P)?(u=P,r=P):{light:u,dark:r}=P);let o;return O.MarkdownString.isMarkdownString(g.tooltip)?o=R.MarkdownString.from(g.tooltip):(0,h.isString)(g.tooltip)?o=g.tooltip:O.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=R.MarkdownString.from(g.detail)):(0,h.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=g.detail),{...g,id:g.id??void 0,handle:i,source:b,command:y.command?p.toInternal(y.command,d):void 0,icon:u,iconDark:r,themeIcon:c,tooltip:o,accessibilityInformation:y.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,F.toDisposable)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=L;function D(f){return f?.toString()}}),define(Pe[240],Ae([1,0,6,15,2,4]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class O{constructor(w){this.c=new Map,this.b=w.getProxy(F.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,h,L,D){if(this.c.has(h))throw new Error(`Opener with id '${h}' already registered`);const f=D.schemes.find(b=>!O.a.has(b));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(h,L),this.b.$registerUriOpener(h,D.schemes,w,D.label),(0,n.toDisposable)(()=>{this.c.delete(h),this.b.$unregisterUriOpener(h)})}async $canOpenUri(w,h,L){const D=this.c.get(w);if(!D)throw new Error(`Unknown opener with id: ${w}`);const f=C.URI.revive(h);return D.canOpenExternalUri(f,L)}async $openUri(w,h,L){const D=this.c.get(w);if(!D)throw new Error(`Unknown opener id: '${w}'`);return D.openExternalUri(C.URI.revive(h.resolvedUri),{sourceUri:C.URI.revive(h.sourceUri)},L)}}O.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=O}),define(Pe[241],Ae([1,0,4,2,6,10,24]),function(ee,e,n,A,C,F,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(h){this.c=new O.ExtensionIdentifierSet,this.d=new Map,this.b=h.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(h,L){if(this.c.has(h))throw new Error(`Protocol handler already registered for extension ${h}`);const D=R.a++;return this.c.add(h),this.d.set(D,L),this.b.$registerUriHandler(D,h),(0,C.toDisposable)(()=>{this.c.delete(h),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(h,L){const D=this.d.get(h);if(!D)return Promise.resolve(void 0);try{D.handleUri(A.URI.revive(L))}catch(f){(0,F.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(h){return A.URI.revive(await this.b.$createAppUri(h))}}R.a=0,e.ExtHostUrls=R});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[62],Ae([1,0,5,15,23,2,162,185,74,4]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";var L,D,f,b,p,d,t,a,m,y,P,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(E,W,G,Y,J,q,U){L.set(this,void 0),D.set(this,void 0),f.set(this,void 0),b.set(this,void 0),p.set(this,void 0),d.set(this,void 0),t.set(this,""),a.set(this,void 0),m.set(this,!1),y.set(this,!1),P.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Le(this,i,"f").event,Je(this,L,E,"f"),Je(this,D,W,"f"),Je(this,a,G,"f"),Je(this,b,Y,"f"),Je(this,p,J,"f"),Je(this,d,q,"f"),Je(this,P,r(q),"f"),Je(this,g,c(q),"f"),Je(this,f,U,"f")}dispose(){Je(this,m,!0,"f"),Le(this,i,"f").fire(),Le(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return Je(this,y,!0,"f"),(0,w.asWebviewUri)(E,Le(this,b,"f"))}get cspSource(){const E=Le(this,d,"f").extensionLocation;if(E.scheme===A.Schemas.https||E.scheme===A.Schemas.http){let W=E.toString();return W.endsWith("/")||(W+="/"),W+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.a(),Le(this,t,"f")}set html(E){this.a(),Le(this,t,"f")!==E&&(Je(this,t,E,"f"),Le(this,g,"f")&&!Le(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(Je(this,y,!0,"f"),Le(this,f,"f").report("Webview vscode-resource: uris",Le(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,D,"f").$setHtml(Le(this,L,"f"),this.b(E)))}get options(){return this.a(),Le(this,a,"f")}set options(E){this.a(),C.equals(Le(this,a,"f"),E)||Le(this,D,"f").$setOptions(Le(this,L,"f"),s(Le(this,d,"f"),Le(this,p,"f"),E)),Je(this,a,E,"f")}async postMessage(E){if(Le(this,m,"f"))return!1;const W=(0,R.serializeWebviewMessage)(E,{serializeBuffersForPostMessage:Le(this,P,"f")});return Le(this,D,"f").$postMessage(Le(this,L,"f"),W.message,...W.buffers)}a(){if(Le(this,m,"f"))throw new Error("Webview is disposed")}b(E){if(!Le(this,g,"f"))return E;const W=Le(this,d,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,G=Le(this,d,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Le(this,d,"f").extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Y,J,q,U,$,z)=>{const j=F.URI.from({scheme:U||"file",path:decodeURIComponent($)}),he=(0,w.asWebviewUri)(j,{isRemote:W,authority:G}).toString();return`${J}${he}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Y,J,q,U,$,z)=>{const j=F.URI.from({scheme:U||"file",path:decodeURIComponent($)}),he=(0,w.asWebviewUri)(j,{isRemote:W,authority:G}).toString();return`${J}${he}${z}`})}}e.ExtHostWebview=u,L=new WeakMap,D=new WeakMap,f=new WeakMap,b=new WeakMap,p=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap,y=new WeakMap,P=new WeakMap,g=new WeakMap,i=new WeakMap;function r(S){try{const E=(0,O.normalizeVersion)((0,O.parseVersion)(S.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function c(S){try{const E=(0,O.normalizeVersion)((0,O.parseVersion)(S.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class o{constructor(E,W,G,Y,J){this.c=W,this.d=G,this.e=Y,this.f=J,this.b=new Map,this.a=E.getProxy(h.MainContext.MainThreadWebviews)}$onMessage(E,W,G){const Y=this.g(E);if(Y){const{message:J}=(0,R.deserializeWebviewMessage)(W,G.value);Y._onMessageEmitter.fire(J)}}$onMissingCsp(E,W){this.e.warn(`${W} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,W,G){const Y=new u(E,this.a,l(W),this.c,this.d,G,this.f);return this.b.set(E,Y),Y._onDidDispose(()=>{this.b.delete(E)}),Y}deleteWebview(E){this.b.delete(E)}g(E){return this.b.get(E)}}e.ExtHostWebviews=o;function k(S){return{id:S.identifier,location:S.extensionLocation}}e.toExtensionData=k;function s(S,E,W){return{enableCommandUris:W.enableCommandUris,enableScripts:W.enableScripts,enableForms:W.enableForms,portMapping:W.portMapping,localResourceRoots:W.localResourceRoots||v(S,E)}}e.serializeWebviewOptions=s;function l(S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots?.map(E=>F.URI.from(E))}}function v(S,E){return[...(E?.getWorkspaceFolders()||[]).map(W=>W.uri),S.extensionLocation]}}),define(Pe[242],Ae([1,0,21,91,6,15,22,2,8,62,54,4,7]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(u,r){this.document=u,this.b=r,this.a=1,this.c=new L.Cache("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,r){await this.f(u).undo(),r||this.disposeBackup()}async redo(u,r){await this.f(u).redo(),r||this.disposeBackup()}disposeEdits(u){for(const r of u)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=g(this.document.uri)+this.a++;return(0,O.joinPath)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const r=this.c.get(u,0);if(!r)throw new Error("No edit found");return r}}class p{constructor(){this.a=new Map}get(u,r){return this.a.get(this.b(u,r))}add(u,r,c){const o=this.b(u,r.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${u} resource:${r.uri}`);const k=new b(r,c);return this.a.set(o,k),k}delete(u,r){const c=this.b(u,r.uri);this.a.delete(c)}b(u,r){return`${u}@@@${r}`}}var d;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(u,r,c){return this.b(0,u,r,c)}addCustomProvider(u,r,c){return this.b(1,u,r,c)}get(u){return this.a.get(u)}b(u,r,c,o){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:u,extension:c,provider:o}),new f.Disposable(()=>this.a.delete(r))}}class a{constructor(u,r,c,o,k){this.d=r,this.f=c,this.g=o,this.h=k,this.b=new t,this.c=new p,this.a=u.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,r,c,o){const k=new C.DisposableStore;return y(c)?(k.add(this.b.addTextProvider(r,u,c)),this.a.$registerTextEditorProvider((0,h.toExtensionData)(u),r,o.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,h.shouldSerializeBuffersForPostMessage)(u))):(k.add(this.b.addCustomProvider(r,u,c)),m(c)&&k.add(c.onDidChangeCustomDocument(s=>{const l=this.i(r,s.document.uri);if(P(s)){const v=l.addEdit(s);this.a.$onDidEdit(s.document.uri,r,v,s.label)}else this.a.$onContentChange(s.document.uri,r)})),this.a.$registerCustomEditorProvider((0,h.toExtensionData)(u),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,h.shouldSerializeBuffersForPostMessage)(u))),f.Disposable.from(k,new f.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(u,r,c,o,k){const s=this.b.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${r}'`);const l=R.URI.revive(u),v=await s.provider.openCustomDocument(l,{backupId:c,untitledDocumentData:o?.buffer},k);let S;return m(s.provider)&&this.f&&(S=this.f.workspaceValue(s.extension)??this.f.globalValue(s.extension)),this.c.add(r,v,S),{editable:m(s.provider)}}async $disposeCustomDocument(u,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=R.URI.revive(u),{document:k}=this.i(r,o);this.c.delete(r,k),k.dispose()}async $resolveCustomEditor(u,r,c,o,k,s){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);const v=w.ViewColumn.to(k),S=this.g.createNewWebview(r,o.contentOptions,l.extension),E=this.h.createNewWebviewPanel(r,c,o.title,v,o.options,S,!0),W=R.URI.revive(u);switch(l.type){case 1:{const{document:G}=this.i(c,W);return l.provider.resolveCustomEditor(G,E,s)}case 0:{const G=this.d.getDocument(W);return l.provider.resolveCustomTextEditor(G,E,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,r,c){this.i(r,u).disposeEdits(c)}async $onMoveCustomEditor(u,r,c){const o=this.b.get(c);if(!o)throw new Error(`No provider found for '${c}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const k=this.h.getWebviewPanel(u);if(!k)throw new Error("No webview found");const s=R.URI.revive(r),l=this.d.getDocument(s);await o.provider.moveCustomTextEditor(l,k,n.CancellationToken.None)}async $undo(u,r,c,o){return this.i(r,u).undo(c,o)}async $redo(u,r,c,o){return this.i(r,u).redo(c,o)}async $revert(u,r,c){const o=this.i(r,u);await this.j(r).revertCustomDocument(o.document,c),o.disposeBackup()}async $onSave(u,r,c){const o=this.i(r,u);await this.j(r).saveCustomDocument(o.document,c),o.disposeBackup()}async $onSaveAs(u,r,c,o){const k=this.i(r,u);return this.j(r).saveCustomDocumentAs(k.document,R.URI.revive(c),o)}async $backup(u,r,c){const o=this.i(r,u),s=await this.j(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},c);return o.updateBackup(s),s.id}i(u,r){const c=this.c.get(u,R.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(u){const c=this.b.get(u)?.provider;if(!c||!m(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=a;function m(i){return!!i.onDidChangeCustomDocument}function y(i){return typeof i.resolveCustomTextEditor=="function"}function P(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function g(i){const u=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,A.hash)(u)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[243],Ae([1,0,5,6,2,35,8,62,4,7]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";var L,D,f,b,p,d,t,a,m,y,P,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends A.Disposable{constructor(k,s,l,v){super(),L.set(this,void 0),D.set(this,void 0),f.set(this,void 0),b.set(this,void 0),p.set(this,void 0),d.set(this,void 0),t.set(this,void 0),a.set(this,void 0),m.set(this,!0),y.set(this,void 0),P.set(this,!1),g.set(this,this.D(new n.Emitter)),this.onDidDispose=Le(this,g,"f").event,i.set(this,this.D(new n.Emitter)),this.onDidChangeViewState=Le(this,i,"f").event,Je(this,L,k,"f"),Je(this,D,s,"f"),Je(this,b,l,"f"),Je(this,f,v.viewType,"f"),Je(this,p,v.panelOptions,"f"),Je(this,a,v.viewColumn,"f"),Je(this,d,v.title,"f"),Je(this,y,v.active,"f")}dispose(){Le(this,P,"f")||(Je(this,P,!0,"f"),Le(this,g,"f").fire(),Le(this,D,"f").$disposeWebview(Le(this,L,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,f,"f")}get title(){return this.c(),Le(this,d,"f")}set title(k){this.c(),Le(this,d,"f")!==k&&(Je(this,d,k,"f"),Le(this,D,"f").$setTitle(Le(this,L,"f"),k))}get iconPath(){return this.c(),Le(this,t,"f")}set iconPath(k){this.c(),Le(this,t,"f")!==k&&(Je(this,t,k,"f"),Le(this,D,"f").$setIconPath(Le(this,L,"f"),C.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,a,"f")=="number"&&Le(this,a,"f")<0))return Le(this,a,"f")}get active(){return this.c(),Le(this,y,"f")}get visible(){return this.c(),Le(this,m,"f")}_updateViewState(k){Le(this,P,"f")||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(Je(this,y,k.active,"f"),Je(this,m,k.visible,"f"),Je(this,a,k.viewColumn,"f"),Le(this,i,"f").fire({webviewPanel:this}))}reveal(k,s){this.c(),Le(this,D,"f").$reveal(Le(this,L,"f"),{viewColumn:typeof k>"u"?void 0:O.ViewColumn.from(k),preserveFocus:!!s})}c(){if(Le(this,P,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,D=new WeakMap,f=new WeakMap,b=new WeakMap,p=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap,y=new WeakMap,P=new WeakMap,g=new WeakMap,i=new WeakMap;class r{static c(){return(0,F.generateUuid)()}constructor(k,s,l){this.g=s,this.h=l,this.e=new Map,this.f=new Map,this.d=k.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(k,s,l,v,S={}){const E=typeof v=="object"?v.viewColumn:v,W={viewColumn:O.ViewColumn.from(E),preserveFocus:typeof v=="object"&&!!v.preserveFocus},G=(0,R.shouldSerializeBuffersForPostMessage)(k),Y=r.c();this.d.$createWebviewPanel((0,R.toExtensionData)(k),Y,s,{title:l,panelOptions:c(S),webviewOptions:(0,R.serializeWebviewOptions)(k,this.h,S),serializeBuffersForPostMessage:G},W);const J=this.g.createNewWebview(Y,S,k);return this.createNewWebviewPanel(Y,s,l,E,S,J,!0)}$onDidChangeWebviewPanelViewStates(k){const s=Object.keys(k);s.sort((l,v)=>{const S=k[l],E=k[v];return S.active?1:E.active?-1:+S.visible-+E.visible});for(const l of s){const v=this.getWebviewPanel(l);if(!v)continue;const S=k[l];v._updateViewState({active:S.active,visible:S.visible,viewColumn:O.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.e.delete(k),this.g.deleteWebview(k)}registerWebviewPanelSerializer(k,s,l){if(this.f.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.f.set(s,{serializer:l,extension:k}),this.d.$registerSerializer(s,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(k)}),new h.Disposable(()=>{this.f.delete(s),this.d.$unregisterSerializer(s)})}async $deserializeWebviewPanel(k,s,l,v){const S=this.f.get(s);if(!S)throw new Error(`No serializer found for '${s}'`);const{serializer:E,extension:W}=S,G=this.g.createNewWebview(k,l.webviewOptions,W),Y=this.createNewWebviewPanel(k,s,l.title,v,l.panelOptions,G,l.active);await E.deserializeWebviewPanel(Y,l.state)}createNewWebviewPanel(k,s,l,v,S,E,W){const G=new u(k,this.d,E,{viewType:s,title:l,viewColumn:v,panelOptions:S,active:W});return this.e.set(k,G),G}getWebviewPanel(k){return this.e.get(k)}}e.ExtHostWebviewPanels=r;function c(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[244],Ae([1,0,5,6,62,8,4,7]),function(ee,e,n,A,C,F,O,R){"use strict";var w,h,L,D,f,b,p,d,t,a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends A.Disposable{constructor(i,u,r,c,o,k){super(),w.set(this,void 0),h.set(this,void 0),L.set(this,void 0),D.set(this,void 0),f.set(this,!1),b.set(this,void 0),p.set(this,void 0),d.set(this,void 0),t.set(this,void 0),a.set(this,this.D(new n.Emitter)),this.onDidChangeVisibility=Le(this,a,"f").event,m.set(this,this.D(new n.Emitter)),this.onDidDispose=Le(this,m,"f").event,Je(this,L,r,"f"),Je(this,p,c,"f"),Je(this,w,i,"f"),Je(this,h,u,"f"),Je(this,D,o,"f"),Je(this,b,k,"f")}dispose(){Le(this,f,"f")||(Je(this,f,!0,"f"),Le(this,m,"f").fire(),Le(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,p,"f")}set title(i){this.a(),Le(this,p,"f")!==i&&(Je(this,p,i,"f"),Le(this,h,"f").$setWebviewViewTitle(Le(this,w,"f"),i))}get description(){return this.a(),Le(this,d,"f")}set description(i){this.a(),Le(this,d,"f")!==i&&(Je(this,d,i,"f"),Le(this,h,"f").$setWebviewViewDescription(Le(this,w,"f"),i))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,D,"f")}get viewType(){return Le(this,L,"f")}_setVisible(i){i===Le(this,b,"f")||Le(this,f,"f")||(Je(this,b,i,"f"),Le(this,a,"f").fire())}get badge(){return this.a(),Le(this,t,"f")}set badge(i){this.a(),!(i?.value===Le(this,t,"f")?.value&&i?.tooltip===Le(this,t,"f")?.tooltip)&&(Je(this,t,F.ViewBadge.from(i),"f"),Le(this,h,"f").$setWebviewViewBadge(Le(this,w,"f"),i))}show(i){this.a(),Le(this,h,"f").$show(Le(this,w,"f"),!!i)}a(){if(Le(this,f,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,h=new WeakMap,L=new WeakMap,D=new WeakMap,f=new WeakMap,b=new WeakMap,p=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap;class P{constructor(i,u){this.d=u,this.b=new Map,this.c=new Map,this.a=i.getProxy(O.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,u,r,c){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:r,extension:i}),this.a.$registerWebviewViewProvider((0,C.toExtensionData)(i),u,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(i)}),new R.Disposable(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(i,u,r,c,o){const k=this.b.get(u);if(!k)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:l}=k,v=this.d.createNewWebview(i,{},l),S=new y(i,this.a,u,r,v,!0);this.c.set(i,S),await s.resolveWebviewView(S,{state:c},o)}async $onDidChangeWebviewViewVisibility(i,u){this.e(i)._setVisible(u)}async $disposeWebviewView(i){const u=this.e(i);this.c.delete(i),u.dispose(),this.d.deleteWebview(i)}e(i){const u=this.c.get(i);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=P}),define(Pe[106],Ae([1,0,5,4,2,15,13,3,18]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let h=class dn{get state(){return this.d}constructor(D){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=dn.a,this.b=D.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,f){let b;if(typeof D=="string"){b=D;try{D=C.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,O.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,b,f)}async asExternalUri(D,f){if((0,O.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(D,f);return C.URI.from(b)}};h.a={focused:!0},h=je([Ve(0,w.IExtHostRpcService)],h),e.ExtHostWindow=h,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Pe[245],Ae([1,0,214,27,18]),function(ee,e,n,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let F=class extends n.AbstractExtHostConsoleForwarder{constructor(R,w){super(R,w)}f(R,w,h){w.apply(console,h)}};F=je([Ve(0,C.IExtHostRpcService),Ve(1,A.IExtHostInitDataService)],F),e.ExtHostConsoleForwarder=F}),define(Pe[246],Ae([1,0,17,25,21,10,5,6,129,208,46]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(S,E){try{return JSON.stringify(S,E)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class d{constructor(E,W){this.jsonString=E,this.referencedBuffers=W}}function t(S,E=null,W=!1){const G=[];return{jsonString:(W?f:JSON.stringify)(S,(J,q)=>{if(typeof q>"u")return p;if(typeof q=="object"){if(q instanceof A.VSBuffer){const U=G.push(q)-1;return{[b]:U}}if(E)return E(J,q)}return q}),referencedBuffers:G}}e.stringifyJsonWithBufferRefs=t;function a(S,E,W){return JSON.parse(S,(G,Y)=>{if(Y){const J=Y[b];if(typeof J=="number")return E[J];if(W&&Y.$mid===1)return W.transformIncoming(Y)}return Y})}e.parseJsonAndRestoreBufferRefs=a;function m(S,E){return JSON.stringify(S,E)}function y(S){return S?(E,W)=>W&&W.$mid===1?S.transformOutgoing(W):W:null}var P;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends R.Disposable{constructor(E,W=null,G=null){super(),this[D]=!0,this.b=this.D(new O.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=E,this.f=W,this.g=G,this.h=y(this.g),this.j=!1,this.k=[],this.l=[];for(let Y=0,J=L.ProxyIdentifier.count;Y<J;Y++)this.k[Y]=null,this.l[Y]=null;this.m=0,this.p=Object.create(null),this.q={},this.s=0,this.t=0,this.u=0,this.v=this.D(new n.RunOnceScheduler(()=>this.z(),1e3)),this.c.onMessage(Y=>this.G(Y))}dispose(){this.j=!0,Object.keys(this.q).forEach(E=>{this.q[E].resolveErr(F.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}w(E){this.t===0&&(this.u=Date.now()+c.a),this.t++,this.v.isScheduled()||this.v.schedule()}y(E){this.u=Date.now()+c.a,this.t--,this.t===0&&this.v.cancel(),this.C(0)}z(){this.t!==0&&(Date.now()>this.u?this.C(1):this.v.schedule())}C(E){this.s!==E&&(this.s=E,this.b.fire(this.s))}get responsiveState(){return this.s}transformIncomingURIs(E){return this.g?(0,w.transformIncomingURIs)(E,this.g):E}getProxy(E){const{nid:W,sid:G}=E;return this.l[W]||(this.l[W]=this.F(W,G)),this.l[W]}F(E,W){const G={get:(Y,J)=>(typeof J=="string"&&!Y[J]&&J.charCodeAt(0)===36&&(Y[J]=(...q)=>this.O(E,J,q)),J===r?W:Y[J])};return new Proxy(Object.create(null),G)}set(E,W){return this.k[E.nid]=W,W}assertRegistered(E){for(let W=0,G=E.length;W<G;W++){const Y=E[W];if(!this.k[Y.nid])throw new Error(`Missing proxy instance ${Y.sid}`)}}G(E){if(this.j)return;const W=E.byteLength,G=o.read(E,0),Y=G.readUInt8(),J=G.readUInt32();switch(Y){case 1:case 2:{let{rpcId:q,method:U,args:$}=s.deserializeRequestJSONArgs(G);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.H(W,J,q,U,$,Y===2);break}case 3:case 4:{let{rpcId:q,method:U,args:$}=s.deserializeRequestMixedArgs(G);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.H(W,J,q,U,$,Y===4);break}case 5:{this.f?.logIncoming(W,J,0,"ack"),this.y(J);break}case 6:{this.I(W,J);break}case 7:{this.J(W,J,void 0);break}case 9:{let q=s.deserializeReplyOKJSON(G);this.g&&(q=(0,w.transformIncomingURIs)(q,this.g)),this.J(W,J,q);break}case 10:{const q=s.deserializeReplyOKJSONWithBuffers(G,this.g);this.J(W,J,q);break}case 8:{const q=s.deserializeReplyOKVSBuffer(G);this.J(W,J,q);break}case 11:{let q=s.deserializeReplyErrError(G);this.g&&(q=(0,w.transformIncomingURIs)(q,this.g)),this.L(W,J,q);break}case 12:{this.L(W,J,void 0);break}default:console.error("received unexpected message"),console.error(E)}}H(E,W,G,Y,J,q){this.f?.logIncoming(E,W,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(G)}.${Y}(`,J);const U=String(W);let $,z;if(q){const he=new C.CancellationTokenSource;J.push(he.token),$=this.M(G,Y,J),z=()=>he.cancel()}else $=this.M(G,Y,J),z=i;this.p[U]=z;const j=s.serializeAcknowledged(W);this.f?.logOutgoing(j.byteLength,W,1,"ack"),this.c.send(j),$.then(he=>{delete this.p[U];const we=s.serializeReplyOK(W,he,this.h);this.f?.logOutgoing(we.byteLength,W,1,"reply:",he),this.c.send(we)},he=>{delete this.p[U];const we=s.serializeReplyErr(W,he);this.f?.logOutgoing(we.byteLength,W,1,"replyErr:",he),this.c.send(we)})}I(E,W){this.f?.logIncoming(E,W,1,"receiveCancel");const G=String(W);this.p[G]?.()}J(E,W,G){this.f?.logIncoming(E,W,0,"receiveReply:",G);const Y=String(W);if(!this.q.hasOwnProperty(Y))return;const J=this.q[Y];delete this.q[Y],J.resolveOk(G)}L(E,W,G){this.f?.logIncoming(E,W,0,"receiveReplyErr:",G);const Y=String(W);if(!this.q.hasOwnProperty(Y))return;const J=this.q[Y];delete this.q[Y];let q;G&&(G.$isError?(q=new Error,q.name=G.name,q.message=G.message,q.stack=G.stack):q=G),J.resolveErr(q)}M(E,W,G){try{return Promise.resolve(this.N(E,W,G))}catch(Y){return Promise.reject(Y)}}N(E,W,G){const Y=this.k[E];if(!Y)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(E));const J=Y[W];if(typeof J!="function")throw new Error("Unknown method "+W+" on actor "+(0,L.getStringIdentifierForProxy)(E));return J.apply(Y,G)}O(E,W,G){if(this.j)return new h.CanceledLazyPromise;let Y=null;if(G.length>0&&C.CancellationToken.isCancellationToken(G[G.length-1])&&(Y=G.pop()),Y&&Y.isCancellationRequested)return Promise.reject(F.canceled());const J=s.serializeRequestArguments(G,this.h),q=++this.m,U=String(q),$=new h.LazyPromise;Y&&Y.onCancellationRequested(()=>{const j=s.serializeCancel(q);this.f?.logOutgoing(j.byteLength,q,0,"cancel"),this.c.send(s.serializeCancel(q))}),this.q[U]=$,this.w(q);const z=s.serializeRequest(q,E,W,J,!!Y);return this.f?.logOutgoing(z.byteLength,q,0,`request: ${(0,L.getStringIdentifierForProxy)(E)}.${W}(`,G),this.c.send(z),$}}D=u,c.a=3*1e3,e.RPCProtocol=c;class o{static alloc(E,W,G){const Y=new o(A.VSBuffer.alloc(G+1+4),0);return Y.writeUInt8(E),Y.writeUInt32(W),Y}static read(E,W){return new o(E,W)}get buffer(){return this.a}constructor(E,W){this.a=E,this.b=W}static sizeUInt8(){return 1}writeUInt8(E){this.a.writeUInt8(E,this.b),this.b+=1}readUInt8(){const E=this.a.readUInt8(this.b);return this.b+=1,E}writeUInt32(E){this.a.writeUInt32BE(E,this.b),this.b+=4}readUInt32(){const E=this.a.readUInt32BE(this.b);return this.b+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this.a.writeUInt8(E.byteLength,this.b),this.b+=1,this.a.set(E,this.b),this.b+=E.byteLength}readShortString(){const E=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+E).toString();return this.b+=E,G}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}readLongString(){const E=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+E).toString();return this.b+=E,G}writeBuffer(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}readVSBuffer(){const E=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+E);return this.b+=E,W}static sizeMixedArray(E){let W=0;W+=1;for(let G=0,Y=E.length;G<Y;G++){const J=E[G];switch(W+=1,J.type){case 1:W+=this.sizeLongString(J.value);break;case 2:W+=this.sizeVSBuffer(J.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(J.value);for(let q=0;q<J.buffers.length;++q)W+=this.sizeVSBuffer(J.buffers[q]);break;case 4:break}}return W}writeMixedArray(E){this.a.writeUInt8(E.length,this.b),this.b+=1;for(let W=0,G=E.length;W<G;W++){const Y=E[W];switch(Y.type){case 1:this.writeUInt8(1),this.writeLongString(Y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(Y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(Y.buffers.length),this.writeLongString(Y.value);for(let J=0;J<Y.buffers.length;++J)this.writeBuffer(Y.buffers[J]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this.a.readUInt8(this.b);this.b+=1;const W=new Array(E);for(let G=0;G<E;G++)switch(this.readUInt8()){case 1:W[G]=this.readLongString();break;case 2:W[G]=this.readVSBuffer();break;case 3:{const J=this.readUInt32(),q=this.readLongString(),U=[];for(let $=0;$<J;++$)U.push(this.readVSBuffer());W[G]=new L.SerializableObjectWithBuffers(a(q,U,null));break}case 4:W[G]=void 0;break}return W}}o.sizeUInt32=4;var k;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(k||(k={}));class s{static a(E){for(let W=0,G=E.length;W<G;W++)if(E[W]instanceof A.VSBuffer||E[W]instanceof L.SerializableObjectWithBuffers||typeof E[W]>"u")return!0;return!1}static serializeRequestArguments(E,W){if(this.a(E)){const G=[];for(let Y=0,J=E.length;Y<J;Y++){const q=E[Y];if(q instanceof A.VSBuffer)G[Y]={type:2,value:q};else if(typeof q>"u")G[Y]={type:4};else if(q instanceof L.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:$}=t(q.value,W);G[Y]={type:3,value:A.VSBuffer.fromString(U),buffers:$}}else G[Y]={type:1,value:A.VSBuffer.fromString(m(q,W))}}return{type:1,args:G}}return{type:0,args:m(E,W)}}static serializeRequest(E,W,G,Y,J){switch(Y.type){case 0:return this.b(E,W,G,Y.args,J);case 1:return this.c(E,W,G,Y.args,J)}}static b(E,W,G,Y,J){const q=A.VSBuffer.fromString(G),U=A.VSBuffer.fromString(Y);let $=0;$+=o.sizeUInt8(),$+=o.sizeShortString(q),$+=o.sizeLongString(U);const z=o.alloc(J?2:1,E,$);return z.writeUInt8(W),z.writeShortString(q),z.writeLongString(U),z.buffer}static deserializeRequestJSONArgs(E){const W=E.readUInt8(),G=E.readShortString(),Y=E.readLongString();return{rpcId:W,method:G,args:JSON.parse(Y)}}static c(E,W,G,Y,J){const q=A.VSBuffer.fromString(G);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(q),U+=o.sizeMixedArray(Y);const $=o.alloc(J?4:3,E,U);return $.writeUInt8(W),$.writeShortString(q),$.writeMixedArray(Y),$.buffer}static deserializeRequestMixedArgs(E){const W=E.readUInt8(),G=E.readShortString(),Y=E.readMixedArray(),J=new Array(Y.length);for(let q=0,U=Y.length;q<U;q++){const $=Y[q];typeof $=="string"?J[q]=JSON.parse($):J[q]=$}return{rpcId:W,method:G,args:J}}static serializeAcknowledged(E){return o.alloc(5,E,0).buffer}static serializeCancel(E){return o.alloc(6,E,0).buffer}static serializeReplyOK(E,W,G){if(typeof W>"u")return this.d(E);if(W instanceof A.VSBuffer)return this.e(E,W);if(W instanceof L.SerializableObjectWithBuffers){const{jsonString:Y,referencedBuffers:J}=t(W.value,G,!0);return this.g(E,Y,J)}else return this.f(E,f(W,G))}static d(E){return o.alloc(7,E,0).buffer}static e(E,W){let G=0;G+=o.sizeVSBuffer(W);const Y=o.alloc(8,E,G);return Y.writeVSBuffer(W),Y.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static f(E,W){const G=A.VSBuffer.fromString(W);let Y=0;Y+=o.sizeLongString(G);const J=o.alloc(9,E,Y);return J.writeLongString(G),J.buffer}static g(E,W,G){const Y=A.VSBuffer.fromString(W);let J=0;J+=o.sizeUInt32,J+=o.sizeLongString(Y);for(const U of G)J+=o.sizeVSBuffer(U);const q=o.alloc(10,E,J);q.writeUInt32(G.length),q.writeLongString(Y);for(const U of G)q.writeBuffer(U);return q.buffer}static deserializeReplyOKJSON(E){const W=E.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(E,W){const G=E.readUInt32(),Y=E.readLongString(),J=[];for(let q=0;q<G;++q)J.push(E.readVSBuffer());return new L.SerializableObjectWithBuffers(a(Y,J,W))}static serializeReplyErr(E,W){const G=W?f(F.transformErrorForSerialization(W),null):void 0;if(typeof G!="string")return this.h(E);const Y=A.VSBuffer.fromString(G);let J=0;J+=o.sizeLongString(Y);const q=o.alloc(11,E,J);return q.writeLongString(Y),q.buffer}static deserializeReplyErrError(E){const W=E.readLongString();return JSON.parse(W)}static h(E){return o.alloc(12,E,0).buffer}}var l;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var v;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(v||(v={}))}),define(Pe[247],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(F){const O=R=>{globalThis.removeEventListener("message",O);const w=R.data;Object.defineProperties(globalThis,{postMessage:{value(h,L){w.postMessage(h,L)}},onmessage:{get(){return w.onmessage},set(h){w.onmessage=h}}}),w.addEventListener("message",h=>{globalThis.dispatchEvent(new MessageEvent("message",{data:h.data}))}),w.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",O)}.toString();class A extends EventTarget{constructor(F,O,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${n})('${O}'))`,h=new Blob([w],{type:"application/javascript"}),L=URL.createObjectURL(h),D=new MessageChannel,f=L,b={type:"_newWorker",id:f,port:D.port2,url:L,options:R};F(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:f}),URL.revokeObjectURL(L),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const d=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(d)}),D.port1.addEventListener("message",p=>{const d=new MessageEvent("message",{data:p.data});this.dispatchEvent(d)}),D.port1.start()}}e.NestedWorker=A}),define(Pe[248],Ae([1,0,5,30,31,3]),function(ee,e,n,A,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,F.createDecorator)("outputService");var O;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(O=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(L=>h.push(L)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}A.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(Pe[107],Ae([1,0,4,3,18,24,14,248,60,27,37,123,25,9,43,5,6]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends O.AbstractMessageLogger{get disposed(){return this.l}constructor(g,i,u,r,c){super(),this.id=g,this.name=i,this.m=u,this.n=r,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(u.getLevel()),this.D(u.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,g)}replace(g){const i=this.k;this.info(g),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(g,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:i))}hide(){this.n.$close(this.id)}g(g,i){this.k+=f.VSBuffer.fromString(i).byteLength,(0,O.log)(this.m,g,i),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class m extends a{appendLine(g){this.append(g)}}let y=class{constructor(g,i,u,r,c,o){this.i=i,this.j=u,this.k=r,this.l=c,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[i,u]of this.g)u.visible=i===this.h}createOutputChannel(g,i,u){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,c=(0,b.isString)(i)?i:void 0;if((0,b.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const k=this.i.environment.extensionLogLevel?.find(([l])=>F.ExtensionIdentifier.equals(u.identifier,l))?.[1];k&&(o=(0,O.parseLogLevel)(k));const s=r?this.o(g,o,u):this.n(g,c,u);return s.then(l=>{this.g.set(l.id,l),l.visible=l.id===this.h}),r?this.r(g,o??this.m.getLevel(),s):this.q(g,s)}async n(g,i,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),k=await this.a.$register(g,c,i,u.identifier.value);return new a(k,g,o,this.a,u)}async o(g,i,u){const r=await this.p(u),c=g.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(r,`${c}.log`),k=`${u.identifier.value}.${c}`,s=this.l.createLogger(o,{id:k,name:g,logLevel:i,extensionId:u.identifier.value});return new m(k,g,s,this.a,u)}p(g){let i=this.d.get(g.identifier.value);if(!i){const u=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(u)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}return u})())}return i}q(g,i){let u=!1;const r=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return g},append(c){r(),i.then(o=>o.append(c))},appendLine(c){r(),i.then(o=>o.appendLine(c))},clear(){r(),i.then(c=>c.clear())},replace(c){r(),i.then(o=>o.replace(c))},show(c,o){r(),i.then(k=>k.show(c,o))},hide(){r(),i.then(c=>c.hide())},dispose(){u=!0,i.then(c=>c.dispose())}}}r(g,i,u){const r=new t.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},o=r.add(new d.Emitter);function k(s){i=s,o.fire(s)}return u.then(s=>{r.add(s),s.logLevel!==i&&k(s.logLevel),r.add(s.onDidChangeLogLevel(l=>k(l)))}),{...this.q(g,u),get logLevel(){return i},onDidChangeLogLevel:o.event,trace(s,...l){c(),u.then(v=>v.trace(s,...l))},debug(s,...l){c(),u.then(v=>v.debug(s,...l))},info(s,...l){c(),u.then(v=>v.info(s,...l))},warn(s,...l){c(),u.then(v=>v.warn(s,...l))},error(s,...l){c(),u.then(v=>v.error(s,...l))},dispose(){r.dispose()}}}};y=je([Ve(0,C.IExtHostRpcService),Ve(1,h.IExtHostInitDataService),Ve(2,w.IExtHostConsumerFileSystem),Ve(3,L.IExtHostFileSystemInfo),Ve(4,O.ILoggerService),Ve(5,O.ILogService)],y),e.ExtHostOutputService=y,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(Pe[249],Ae([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Pe[250],Ae([1,0,41,15,19,20,22,2,3,180,53,196,249]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let b=class hn{constructor(d,t,a,m){this.d=d,this.e=t,this.f=a,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const y=await this.e.getEnvironment();return this.c=y?.userHome??d})()}hasValidBasename(d,t,a){return typeof t=="string"||typeof t>"u"?this.a.then(m=>this.h(d,m,t)):this.h(d,t,a)}h(d,t,a){return d.scheme===A.Schemas.file||d.scheme===A.Schemas.vscodeRemote?(0,n.isValidBasename)(a??(0,O.basename)(d),t===1):!0}get defaultUriScheme(){return hn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,t){if(d.remoteAuthority)return A.Schemas.vscodeRemote;const a=(0,h.getVirtualWorkspaceScheme)(t.getWorkspace());if(a)return a;const m=t.getWorkspace().folders[0];if(m)return m.uri.scheme;const y=t.getWorkspace().configuration;return y?y.scheme:A.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?C.win32:C.posix)}async fileURI(d){let t="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const m=d.indexOf("/",2);m===-1?(t=d.substring(2),d="/"):(t=d.substring(2,m),d=d.substring(m)||"/")}return R.URI.from({scheme:A.Schemas.file,authority:t,path:d,query:"",fragment:""})}};b=je([Ve(1,f.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,L.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Pe[108],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(O,R){this.line=O,this.character=R}isBefore(O){return!1}isBeforeOrEqual(O){return!1}isAfter(O){return!1}isAfterOrEqual(O){return!1}isEqual(O){return!1}compareTo(O){return 0}translate(O,R){return new n(0,0)}with(O){return new n(0,0)}}e.Position=n;class A{constructor(O,R,w,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(O,R),this.end=new n(w,h)}contains(O){return!1}isEqual(O){return!1}intersection(O){}union(O){return new A(0,0,0,0)}with(O){return new A(0,0,0,0)}}e.Range=A;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Pe[47],Ae([1,0,16,36,23,41,13,3,19,10,108,17]),function(ee,e,n,A,C,F,O,R,w,h,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",b=" characters skipped \u27EB",p=(f.length+b.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var d;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var t;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(t=e.QueryType||(e.QueryType={}));function a(oe){return!!oe.preview}e.resultIsMatch=a;function m(oe){return!!oe.resource}e.isFileMatch=m;function y(oe){return!!oe.message}e.isProgressMessage=y;var P;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(P=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=g;class i{constructor(de,ke,le){this.ranges=ke;const X=Array.isArray(ke)?ke:[ke];if(le&&le.matchLines===1&&u(X)){de=(0,O.getNLines)(de,le.matchLines);let T="",V=0,ce=0;const me=Math.floor(le.charsPerLine/5),Fe=[];for(const be of X){const Ee=Math.max(be.startColumn-me,0),Ie=be.startColumn+le.charsPerLine;if(Ee>ce+me+p){const se=f+(Ee-ce)+b;T+=se+de.slice(Ee,Ie),V+=Ee-(ce+se.length)}else T+=de.slice(ce,Ie);Fe.push(new c(0,be.startColumn-V,be.endColumn-V)),ce=Ie}this.preview={text:T,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const T=Array.isArray(ke)?ke[0].startLineNumber:ke.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(ke,V=>new r(V.startLineNumber-T,V.startColumn,V.endLineNumber-T,V.endColumn))}}}}e.TextSearchMatch=i;function u(oe){const de=oe[0].startLineNumber;for(const ke of oe)if(ke.startLineNumber!==de||ke.endLineNumber!==de)return!1;return!0}class r{constructor(de,ke,le,X){this.startLineNumber=de,this.startColumn=ke,this.endLineNumber=le,this.endColumn=X}}e.SearchRange=r;class c extends r{constructor(de,ke,le){super(de,ke,de,le)}}e.OneLineRange=c;var o;(function(oe){oe.List="list",oe.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var k;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(k=e.SearchSortOrder||(e.SearchSortOrder={}));function s(oe,de=!0){const ke=oe&&oe.files&&oe.files.exclude,le=de&&oe&&oe.search&&oe.search.exclude;if(!ke&&!le)return;if(!ke||!le)return ke||le;let X=Object.create(null);return X=C.mixin(X,C.deepClone(ke)),X=C.mixin(X,C.deepClone(le),!0),X}e.getExcludes=s;function l(oe,de){return oe.excludePattern&&A.match(oe.excludePattern,de)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&A.match(oe.includePattern,de)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ke=>{const le=ke.folder.fsPath;if(F.isEqualOrParent(de,le)){const X=w.relative(le,de);return!ke.includePattern||!!A.match(ke.includePattern,X)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var v;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(de,ke){super(de),this.code=ke}}e.SearchError=S;function E(oe){const de=oe.message;if((0,h.isCancellationError)(oe))return new S(de,v.canceled);try{const ke=JSON.parse(de);return new S(ke.message,ke.code)}catch{return new S(de,v.other)}}e.deserializeSearchError=E;function W(oe){const de={message:oe.message,code:oe.code};return new Error(JSON.stringify(de))}e.serializeSearchError=W;function G(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=G;function Y(oe){return oe.type==="success"}e.isSerializedSearchSuccess=Y;function J(oe){return!!oe.path}e.isSerializedFileMatch=J;function q(oe,de){const ke=oe.searchPath?oe.searchPath:oe.relativePath;return(0,O.fuzzyContains)(ke,de)}e.isFilePatternMatch=q;class U{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function $(oe,de){const ke={...oe||{},...de||{}};return Object.keys(ke).filter(le=>{const X=ke[le];return typeof X=="boolean"&&X})}e.resolvePatternsForProvider=$;class z{constructor(de,ke){this.c=null,this.a={...de.excludePattern||{},...ke.excludePattern||{}},this.b=A.parse(this.a);let le=de.includePattern;ke.includePattern&&(le?le={...le,...ke.includePattern}:le=ke.includePattern),le&&(this.c=A.parse(le))}matchesExcludesSync(de,ke,le){return!!(this.b&&this.b(de,ke,le))}includedInQuerySync(de,ke,le){return!(this.b&&this.b(de,ke,le)||this.c&&!this.c(de,ke,le))}includedInQuery(de,ke,le){const X=this.b(de,ke,le),T=()=>this.c?!!this.c(de,ke,le):!0;return(0,D.isThenable)(X)?X.then(V=>V?!1:T()):T()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=z;function j(oe){for(const de in oe)if(typeof oe[de]!="boolean")return!0;return!1}function he(oe){if(!oe)return;let de;return ke=>(de||(de=(oe()||Promise.resolve([])).then(le=>le?ie(le):{})),de.then(le=>!!le[ke]))}e.hasSiblingPromiseFn=he;function we(oe){if(!oe)return;let de;return ke=>{if(!de){const le=oe();de=le?ie(le):{}}return!!de[ke]}}e.hasSiblingFn=we;function ie(oe){const de={};for(const ke of oe)de[ke]=!0;return de}}),define(Pe[32],Ae([1,0,16,17,21,5,6,48,15,115,22,13,9,2,151,3,14,168,53,37,27,18,8,7,55,47,4]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g,i,u,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function k(Y,J,q){return new L.ExtUri(U=>S(U,q)).isEqual(Y,J)}function s(Y,J,q){return k(Y.uri,J.uri,q)?0:(0,D.compare)(Y.uri.toString(),J.uri.toString())}function l(Y,J,q){return Y.index!==J.index?Y.index<J.index?-1:1:k(Y.uri,J.uri,q)?(0,D.compare)(Y.name,J.name):(0,D.compare)(Y.uri.toString(),J.uri.toString())}function v(Y,J,q,U){const $=Y.slice(0).sort((j,he)=>q(j,he,U)),z=J.slice(0).sort((j,he)=>q(j,he,U));return(0,n.delta)($,z,(j,he)=>q(j,he,U))}function S(Y,J){const q=J.getCapabilities(Y.scheme);return!(q&&q&1024)}class E extends m.Workspace{static toExtHostWorkspace(J,q,U,$){if(!J)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:he,configuration:we,transient:ie,isUntitled:oe}=J,de=[],ke=q;q?he.forEach((V,ce)=>{const me=b.URI.revive(V.uri),Fe=E.o(U||q,me,$);Fe?(Fe.name=V.name,Fe.index=V.index,de.push(Fe)):de.push({uri:me,name:V.name,index:ce})}):de.push(...he.map(({uri:V,name:ce,index:me})=>({uri:b.URI.revive(V),name:ce,index:me}))),de.sort((V,ce)=>V.index<ce.index?-1:1);const le=new E(z,j,de,!!ie,we?b.URI.revive(we):null,!!oe,V=>S(V,$)),{added:X,removed:T}=v(ke?ke.workspaceFolders:[],le.workspaceFolders,s,$);return{workspace:le,added:X,removed:T}}static o(J,q,U){for(let $=0;$<J.folders.length;$++){const z=J.workspaceFolders[$];if(k(z.uri,q,U))return z}}constructor(J,q,U,$,z,j,he){super(J,U.map(we=>new m.WorkspaceFolder(we)),$,z,he),this.t=q,this.u=j,this.q=[],this.s=R.TernarySearchTree.forUris(he),U.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(J,q){return q&&this.s.get(J)&&(J=(0,L.dirname)(J)),this.s.findSubstr(J)}resolveWorkspaceFolder(J){return this.s.get(J)}}let W=class{constructor(J,q,U,$,z){this.c=new F.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new F.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.AsyncEmitter,this.h=$,this.s=U,this.t=z,this.j=new h.Counter,this.k=new A.Barrier,this.o=J.getProxy(o.MainContext.MainThreadWorkspace),this.q=J.getProxy(o.MainContext.MainThreadMessageService);const j=q.workspace;this.l=j?new E(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,he=>S(he,U)):void 0}$initializeWorkspace(J,q){this.v=q,this.$acceptWorkspaceData(J),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:w.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(J,q,U,...$){const z=[];if(Array.isArray($)&&$.forEach(oe=>{b.URI.isUri(oe.uri)&&!z.some(de=>k(de.uri,oe.uri,this.s))&&z.push({uri:oe.uri,name:oe.name||(0,L.basenameOrAuthority)(oe.uri)})}),this.n||[q,U].some(oe=>typeof oe!="number"||oe<0)||U===0&&z.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(q+U>j.length)return!1;const he=j.slice(0);he.splice(q,U,...z.map(oe=>({uri:oe.uri,name:oe.name||(0,L.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<he.length;oe++){const de=he[oe];if(he.some((ke,le)=>le!==oe&&k(de.uri,ke.uri,this.s)))return!1}he.forEach((oe,de)=>oe.index=de);const{added:we,removed:ie}=v(j,he,l,this.s);if(we.length===0&&ie.length===0)return!1;if(this.o){const oe=J.displayName||J.name;this.o.$updateWorkspaceFolders(oe,q,U,z).then(void 0,de=>{this.n=void 0;const ke={source:{identifier:J.identifier,label:J.displayName||J.name}};this.q.$showMessage(a.Severity.Error,(0,p.localize)(0,null,oe,de.toString()),ke,[])})}return this.y(he),!0}getWorkspaceFolder(J,q){if(!!this.x)return this.x.getWorkspaceFolder(J,q)}async getWorkspaceFolder2(J,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(J,q)}async resolveWorkspaceFolder(J){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(J)}getPath(){if(!this.x)return;const{folders:J}=this.x;if(J.length!==0)return J[0].uri.fsPath}getRelativePath(J,q){let U,$="";if(typeof J=="string"?(U=b.URI.file(J),$=J):typeof J<"u"&&(U=J,$=J.fsPath),!U)return $;const z=this.getWorkspaceFolder(U,!0);if(!z)return $;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let j=(0,L.relativePath)(z.uri,U);return q&&z.name&&(j=`${z.name}/${j}`),j}y(J){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:J,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(J){const{workspace:q,added:U,removed:$}=E.toExtHostWorkspace(J,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:$}))}findFiles(J,q,U,$,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let j;if(q===null?j=!1:q&&(typeof q=="string"?j=q:j=q.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:we}=G(i.GlobPattern.from(J));return this.o.$startFileSearch((0,f.withUndefinedAsNull)(he),(0,f.withUndefinedAsNull)(we),(0,f.withUndefinedAsNull)(j),(0,f.withUndefinedAsNull)(U),z).then(ie=>Array.isArray(ie)?ie.map(oe=>b.URI.revive(oe)):[])}async findTextInFiles(J,q,U,$,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),he=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:we,folder:ie}=G(i.GlobPattern.from(q.include)),oe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,de={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:he,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:we,excludePattern:oe},ke=!1;if(this.u[j]=le=>{if(ke)return;const X=b.URI.revive(le.resource);le.results.forEach(T=>{(0,c.resultIsMatch)(T)?U({uri:X,preview:{text:T.preview.text,matches:(0,n.mapArrayOrNot)(T.preview.matches,V=>new u.Range(V.startLineNumber,V.startColumn,V.endLineNumber,V.endColumn))},ranges:(0,n.mapArrayOrNot)(T.ranges,V=>new u.Range(V.startLineNumber,V.startColumn,V.endLineNumber,V.endColumn))}):U({uri:X,text:T.text,lineNumber:T.lineNumber})})},z.isCancellationRequested)return{};try{const le=await this.o.$startTextSearch(J,(0,f.withUndefinedAsNull)(ie),de,j,z);return delete this.u[j],le||{}}catch(le){throw delete this.u[j],le}}$handleTextSearchResult(J,q){this.u[q]?.(J)}saveAll(J){return this.o.$saveAll(J)}resolveProxy(J){return this.o.$resolveProxy(J)}get trusted(){return this.v}requestWorkspaceTrust(J){return this.o.$requestWorkspaceTrust(J)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(J,q){if(this.w.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.w.set(J,q);const U=this.t.transformOutgoingScheme(J),$=this.z++;return this.o.$registerEditSessionIdentityProvider($,U),(0,O.toDisposable)(()=>{this.w.delete(J),this.o.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(J,q){this.h.info("Getting edit session identifier for workspaceFolder",J);const U=await this.resolveWorkspaceFolder(b.URI.revive(J));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const $=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!$),!$)return;const z=await $.provideEditSessionIdentity(U,q);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(J,q,U,$){this.h.info("Getting edit session identifier for workspaceFolder",J);const z=await this.resolveWorkspaceFolder(b.URI.revive(J));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const he=await j.provideEditSessionIdentityMatch?.(q,U,$);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(J){return(q,U,$)=>{const z=function(he){q.call(U,he)};return z.extension=J,this.A.event(z,void 0,$)}}async $onWillCreateEditSessionIdentity(J,q,U){const $=await this.resolveWorkspaceFolder(b.URI.revive(J));if($===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:$},q,async(z,j)=>{const he=Date.now();await Promise.resolve(z),Date.now()-he>U&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),q.isCancellationRequested}};W=je([Ve(0,g.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,y.IExtHostFileSystemInfo),Ve(3,t.ILogService),Ve(4,r.IURITransformerService)],W),e.ExtHostWorkspace=W,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function G(Y){let J,q;return Y&&(typeof Y=="string"?J=Y:(J=Y.pattern,q=b.URI.revive(Y.baseUri))),{includePattern:J,folder:q}}}),define(Pe[33],Ae([1,0,23,5,32,4,7,171,94,9,17,3,18,14,2]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(u,r){if(r){const c=r.split(".");let o=u;for(let k=0;o&&k<c.length;k++)o=o[c[k]];return o}}function t(u){return u instanceof p.URI}function a(u){return u&&u.uri instanceof p.URI&&u.languageId&&typeof u.languageId=="string"}function m(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function y(u){return u&&u.uri instanceof p.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function P(u){if(t(u))return{resource:u};if(a(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(m(u))return{overrideIdentifier:u.languageId};if(y(u))return{resource:u.uri};if(u===null)return{resource:null}}let g=class{constructor(r,c,o){this.a=r.getProxy(F.MainContext.MainThreadConfiguration),this.c=c,this.b=o,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new i(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,c))}};g=je([Ve(0,f.IExtHostRpcService),Ve(1,C.IExtHostWorkspace),Ve(2,b.ILogService)],g),e.ExtHostConfiguration=g;class i{constructor(r,c,o,k){this.a=new A.Emitter,this.b=r,this.f=k,this.c=c,this.e=R.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,o))}getConfiguration(r,c,o){const k=P(c)||{},s=this.g(r?d(this.e.getValue(void 0,k,this.c.workspace),r):this.e.getValue(void 0,k,this.c.workspace));r&&this.h(r,k,o?.identifier);function l(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case O.ConfigurationTarget.Global:return 2;case O.ConfigurationTarget.Workspace:return 5;case O.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(S){return typeof d(s,S)<"u"},get:(S,E)=>{this.h(r?`${r}.${S}`:S,k,o?.identifier);let W=d(s,S);if(typeof W>"u")W=E;else{let G;const Y=(J,q)=>{let U;const $=()=>{G=G||(0,n.deepClone)(s),U=U||d(G,q)};return(0,h.isObject)(J)?new Proxy(J,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return $(),()=>U;if(G)return U=U||d(G,q),U[j];const he=z[j];return typeof j=="string"?Y(he,`${q}.${j}`):he},set:(z,j,he)=>($(),U&&(U[j]=he),!0),deleteProperty:(z,j)=>($(),U&&delete U[j],!0),defineProperty:(z,j,he)=>($(),U&&Object.defineProperty(U,j,he),!0)}):J};W=Y(W,S)}return W},update:(S,E,W,G)=>{S=r?`${r}.${S}`:S;const Y=l(W);return E!==void 0?this.b.$updateConfigurationOption(Y,S,E,k,G):this.b.$removeConfigurationOption(Y,S,k,G)},inspect:S=>{S=r?`${r}.${S}`:S;const E=this.e.inspect(S,k,this.c.workspace);if(E)return{key:S,defaultValue:(0,n.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,n.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,n.deepClone)(E.workspace?.value),workspaceFolderValue:(0,n.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(E.default?.override),globalLanguageValue:(0,n.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,n.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(E.workspaceFolder?.override),languageIds:(0,n.deepClone)(E.overrideIdentifiers)}}};return typeof s=="object"&&(0,n.mixin)(v,s,!1),Object.freeze(v)}g(r){const c=o=>(0,h.isObject)(o)?new Proxy(o,{get:(k,s)=>c(k[s]),set:(k,s,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(k,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(k,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return c(r)}h(r,c,o){const k=w.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),s=o?`[${o.value}] `:"";if(k===4){typeof c?.resource>"u"&&this.f.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(k===3){c?.resource&&this.f.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const o=new R.ConfigurationChangeEvent(r,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(k,s)=>o.affectsConfiguration(k,P(s))})}k(r){return r.reduce((c,o)=>(c.set(o[0],o[1]),c),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[109],Ae([1,0,2,17,5,4,7,32,58,33,21,61,18,27,3,15,20,14,77,207,10]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(J){function q($){if($!=null)return $}J.from=q;function U($){if($!=null)return $}J.to=U})(i||(i={}));var u;(function(J){function q($){if($!=null)return $}J.from=q;function U($){if($!=null)return $}J.to=U})(u||(u={}));var r;(function(J){function q($){if($!=null)return $}J.from=q;function U($){if($!=null)return $}J.to=U})(r||(r={}));var c;(function(J){function q(z){if(z){const j=z;return j&&!!j.process}else return!1}J.is=q;function U(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=r.from(z.options)),j}J.from=U;function $(z){if(z!=null)return new O.ProcessExecution(z.process,z.args,z.options)}J.to=$})(c||(c={}));var o;(function(J){function q($){if($!=null)return $}J.from=q;function U($){if($!=null)return $}J.to=U})(o||(o={}));var k;(function(J){function q(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}J.is=q;function U(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=o.from(z.options)),j}J.from=U;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new O.ShellExecution(z.commandLine,z.options):new O.ShellExecution(z.command,z.args?z.args:[],z.options)}J.to=$})(k||(k={}));var s;(function(J){function q(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}J.is=q;function U(z){return{customExecution:"customExecution"}}J.from=U;function $(z,j){return j.get(z)}J.to=$})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(J){function q(U,$){let z;return U.scope!==void 0&&typeof U.scope!="number"?z=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===O.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=y.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:z}}J.from=q})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(J){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}J.from=q})(v||(v={}));var S;(function(J){function q(z,j){if(z==null)return[];const he=[];for(const we of z){const ie=U(we,j);ie&&he.push(ie)}return he}J.fromMany=q;function U(z,j){if(z==null)return;let he;z.execution instanceof O.ProcessExecution?he=c.from(z.execution):z.execution instanceof O.ShellExecution?he=k.from(z.execution):z.execution&&z.execution instanceof O.CustomExecution&&(he=s.from(z.execution));const we=i.from(z.definition);let ie;return z.scope?typeof z.scope=="number"?ie=z.scope:ie=z.scope.uri:ie=O.TaskScope.Workspace,!we||!ie?void 0:{_id:z._id,definition:we,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:ie},execution:he,isBackground:z.isBackground,group:v.from(z.group),presentationOptions:u.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}J.from=U;async function $(z,j,he){if(z==null)return;let we;c.is(z.execution)?we=c.to(z.execution):k.is(z.execution)?we=k.to(z.execution):s.is(z.execution)&&(we=s.to(z._id,he));const ie=i.to(z.definition);let oe;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?oe=z.source.scope:oe=await j.resolveWorkspaceFolder(n.URI.revive(z.source.scope)):oe=O.TaskScope.Workspace),!ie||!oe)return;const de=new O.Task(ie,oe,z.name,z.source.label,we,z.problemMatchers);return z.isBackground!==void 0&&(de.isBackground=z.isBackground),z.group!==void 0&&(de.group=O.TaskGroup.from(z.group._id),de.group&&z.group.isDefault&&(de.group=new O.TaskGroup(de.group.id,de.group.label),z.group.isDefault===!0&&(de.group.isDefault=z.group.isDefault))),z.presentationOptions&&(de.presentationOptions=u.to(z.presentationOptions)),z._id&&(de._id=z._id),z.detail&&(de.detail=z.detail),de}J.to=$})(S=e.TaskDTO||(e.TaskDTO={}));var E;(function(J){function q($){return $}J.from=q;function U($){if(!!$)return Object.assign(Object.create(null),$)}J.to=U})(E||(E={}));class W{constructor(q,U,$){this._id=U,this.a=$,g.set(this,void 0),Je(this,g,q,"f")}get task(){return this.a}terminate(){Le(this,g,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}g=new WeakMap;let G=class{constructor(q,U,$,z,j,he,we,ie){this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.t=new C.Emitter,this.a=q.getProxy(F.MainContext.MainThreadTask),this.b=$,this.c=z,this.d=j,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=we,this.g=ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,$){if(!$)return new O.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:U,provider:$,extension:q}),this.a.$registerTaskProvider(z,U),new O.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(E.from(q)).then(async U=>{const $=[];for(const z of U){const j=await S.to(z,this.b,this.m);j&&$.push(j)}return $})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof W))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,$){const z=this.m.get(q.id);z&&(this.o.set(q.id,z),this.e.attachPtyToTerminal(U,await z.callback($))),this.p=q.id,this.q.fire({execution:await this.y(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){const U=await this.y(q);this.l.delete(q.id),this.k.delete(q.id),this.A(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.y(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(q){const U=await this.y(q.id);this.t.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const $=this.j.get(q);if(!$)return Promise.reject(new Error("no handler found"));const z=[],j=(0,A.asPromise)(()=>$.provider.provideTasks(L.CancellationToken.None)).then(he=>this.u(U,z,$,he));return new Promise(he=>{j.then(we=>{Promise.all(z).then(()=>{he(we)})})})}async $resolveTask(q,U){const $=this.j.get(q);if(!$)return Promise.reject(new Error("no handler found"));if(U.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await S.to(U,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await $.provider.resolveTask(z,L.CancellationToken.None);if(!j)return;this.z(j,$);const he=S.from(j,$.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(he.execution)&&await this.x(he,j,!0),await this.v(he)}w(){return this.h++}async x(q,U,$){const z=await this.a.$createTaskId(q);!$&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,U.execution)),this.m.set(z,U.execution)}async y(q,U){if(typeof q=="string"){const j=this.l.get(q);if(!j)throw new P.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const $=this.l.get(q.id);if($)return $;const z=new Promise((j,he)=>{function we(ie,oe,de){de?j(new W(ie,oe.id,de)):he("Unexpected: Task does not exist.")}U?we(this,q,U):S.to(q.task,this.b,this.m).then(ie=>we(this,q,ie))});return this.l.set(q.id,z),z.then(j=>(this.k.set(q.id,j),j),j=>Promise.reject(j))}z(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const $=this.n.values();let z=$.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=$.next()}};G=je([Ve(0,f.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,m.IExtHostApiDeprecationService)],G),e.ExtHostTaskBase=G;let Y=class extends G{constructor(q,U,$,z,j,he,we,ie){super(q,U,$,z,j,he,we,ie),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const $=S.from(U,q);if($===void 0)throw new Error("Task is not valid");if(s.is($.execution))await this.x($,U,!1);else throw new P.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution($),U);return this.a.$executeTask($).catch(j=>{throw new Error(j)}),z}u(q,U,$,z){const j=[];if(z)for(const he of z){this.z(he,$),(!he.definition||!q[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const we=S.from(he,$.extension);we&&s.is(we.execution)?(j.push(we),U.push(this.x(we,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:$.extension}}async v(q){if(s.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,$){}};Y=je([Ve(0,f.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,m.IExtHostApiDeprecationService)],Y),e.WorkerExtHostTask=Y,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Pe[251],Ae([1,0,19,21,40,36,22,78,47]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class h{constructor(f,b,p){this.k=f,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&F.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&F.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const b=this.k.folderQueries||[];return new Promise((p,d)=>{const t=a=>{this.f++,f(a)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const m=a.toString(),y=n.basename(m);this.j&&this.j(m,y)||this.v(t,{base:a,basename:y})}),Promise.all(b.map(a=>this.p(a,t))).then(a=>{p({limitHit:this.e,stats:a[0]||void 0})},a=>{d(new Error((0,C.toErrorMessage)(a)))})})}async p(f,b){const p=new A.CancellationTokenSource,d=this.q(f),t=this.r(),a=new w.QueryGlobTester(this.k,f),m=!a.hasSiblingExcludeClauses();let y;try{this.h.add(p),y=R.StopWatch.create();const P=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,p.token),g=y.elapsed(),i=R.StopWatch.create();return this.g&&!this.e||(P&&P.forEach(u=>{const r=n.posix.relative(f.folder.path,u.path);if(m){const c=n.basename(u.path);this.v(b,{base:f.folder,relativePath:r,basename:c});return}this.s(t,f.folder,r,b)}),this.g&&!this.e)?null:(this.u(t,a,b),{providerTime:g,postProcessTime:i.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(f){const b=(0,w.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),p=(0,w.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:p,includes:b,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},b,p,d){if(p===this.a){const a=n.basename(this.a);this.v(d,{base:b,relativePath:this.a,basename:a})}function t(a){const m=n.basename(a),y=n.dirname(a);let P=f[y];P||(P=f[y]=[],t(y)),P.push({base:b,relativePath:a,basename:m})}t(p)}u({rootEntries:f,pathToEntries:b},p,d){const t=this,a=this.a;function m(y){const P=(0,w.hasSiblingFn)(()=>y.map(g=>g.basename));for(let g=0,i=y.length;g<i;g++){const u=y[g],{relativePath:r,basename:c}=u;if(p.matchesExcludesSync(r,c,a!==c?P:void 0))continue;const o=b[r];if(o)m(o);else{if(r===a)continue;t.v(d,u)}if(t.e)break}}m(f)}v(f,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(b))}}class L{constructor(){this.b=new Map}fileSearch(f,b,p,d){const t=this.c(f.cacheKey),a=new h(f,b,t&&t.token);let m=0;const y=P=>{m+=P.length,p(P.map(g=>this.d(g)))};return this.e(a,L.a,y,d).then(P=>({limitHit:P.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:P.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new A.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:O.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,b,p,d){d.onCancellationRequested(()=>{f.cancel()});const t=m=>{m&&(a.push(m),b>0&&a.length>=b&&(p(a),a=[]))};let a=[];return f.search(t).then(m=>(a.length&&p(a),m),m=>(a.length&&p(a),Promise.reject(m)))}}L.a=512,e.FileSearchManager=L}),define(Pe[252],Ae([1,0,16,63,36,88,28,15,19,22,13,9,2,268,160,42,14,53,99,250,47]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(S,E,W,G,Y){this.a=S,this.b=E,this.c=W,this.d=G,this.e=Y}text(S,E,W={}){S=this.f(S,W);const G=this.a.getValue(),Y=E&&E.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(E?.map(a.toWorkspaceFolder),W),type:2,contentPattern:S,previewOptions:W.previewOptions,maxFileSize:W.maxFileSize,usePCRE2:G.search.usePCRE2||Y||!1,beforeContext:W.beforeContext,afterContext:W.afterContext,userDisabledExcludesAndIgnoreFiles:W.disregardExcludeSettings&&W.disregardIgnoreFiles}}f(S,E){const W=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const G={...S,wordSeparators:W.editor.wordSeparators};return this.j(S,E)&&(G.isCaseSensitive=!0),this.k(S)&&(G.isMultiline=!0),G}file(S,E={}){return{...this.h(S,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(S,E){return S?(S=Array.isArray(S)?S.map(o):o(S),E?this.parseSearchPaths(S):{pattern:u(...Array.isArray(S)?S:[S])}):{}}h(S=[],E={}){const W=this.g(E.includePattern,E.expandPatterns),G=this.g(E.excludePattern,E.expandPatterns),Y=S.length>1,J=(W.searchPaths&&W.searchPaths.length?W.searchPaths.map($=>this.q($,E,G)):S.map($=>this.r($,E,G,Y))).filter($=>!!$),q={_reason:E._reason,folderQueries:J,usingSearchPaths:!!(W.searchPaths&&W.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:G.pattern,includePattern:W.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const $=n.coalesce(n.flatten(this.c.groups.map(he=>he.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const z=$.filter(he=>(0,P.pathIncludedInQuery)(q,he.fsPath)),j=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...q,...j}}const U=E.extraFileResources&&E.extraFileResources.filter($=>(0,P.pathIncludedInQuery)(q,$.fsPath));return q.extraFileResources=U&&U.length?U:void 0,q}i(S){const E=[],W=new O.ResourceMap,G={};let Y=!1;return S.forEach(J=>{if(J.scheme===R.Schemas.walkThrough)return;if((0,h.isAbsolutePath)(J)){const U=this.b.getWorkspaceFolder(J)?.uri??J.with({path:w.dirname(J.fsPath)});let $=W.get(U);$||(Y=!0,$={folder:U,includePattern:{}},E.push($),W.set(U,$));const z=w.relative(U.fsPath,J.fsPath);(0,D.assertIsDefined)($.includePattern)[z.replace(/\\/g,"/")]=!0}else J.fsPath&&(Y=!0,G[J.fsPath]=!0)}),{folderQueries:E,includePattern:G,usingSearchPaths:!0,excludePattern:Y?void 0:{"**/*":!0}}}j(S,E){if(E.isSmartCase){if(S.isRegExp){if(L.containsUppercaseCharacter(S.pattern,!0))return!0}else if(L.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,b.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const E=j=>w.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),G=(Array.isArray(S)?S:r(S)).map(j=>{const he=this.e.resolvedUserHome;return he?(0,F.untildify)(j,he.scheme===R.Schemas.file?he.fsPath:he.path):j}),Y=A.groupBy(G,j=>E(j)?"searchPaths":"exprSegments"),J=(Y.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),c(j))),q={},U=this.m(Y.searchPaths||[]);U&&U.length&&(q.searchPaths=U);const $=n.flatten(J),z=u(...$);return z&&(q.pattern=z),q}l(S,E){return E.disregardExcludeSettings?void 0:(0,P.getExcludes)(S,!E.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const E=S.flatMap(G=>{let{pathPortion:Y,globPortion:J}=i(G);return J&&(J=k(J)),this.n(Y).flatMap(U=>this.o(U,J))}),W=new Map;return E.forEach(G=>{const Y=G.searchPath.toString(),J=W.get(Y);J?G.pattern&&(J.pattern=J.pattern||{},J.pattern[G.pattern]=!0):W.set(Y,{searchPath:G.searchPath,pattern:G.pattern?u(G.pattern):void 0})}),Array.from(W.values())}n(S){if(w.isAbsolute(S)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==R.Schemas.file?[{searchPath:E[0].uri.with({path:S})}]:[{searchPath:f.URI.file(w.normalize(S))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(S=o(S),S.startsWith("../")||S===".."){const G=w.posix.resolve(E.path,S);return[{searchPath:E.with({path:G})}]}const W=k(S);return[{searchPath:E,pattern:W}]}else{if(S==="./"||S===".\\")return[];{const E=S.replace(/^\.[\/\\]/,""),G=this.b.getWorkspace().folders.map(Y=>{const J=E.match(new RegExp(`^${L.escapeRegExpCharacters(Y.name)}(?:/(.*)|$)`));return J?{match:J,folder:Y}:null}).filter(D.isDefined);if(G.length)return G.map(Y=>{const J=Y.match[1];return{searchPath:Y.folder.uri,pattern:J&&k(J)}});{const Y=S.match(/\.[\/\\](.+)[\/\\]?/),J=Y?Y[1]:S,q=p.localize(0,null,J);throw new Error(q)}}}}o(S,E){const W=S.pattern&&E?`${S.pattern}/${E}`:S.pattern||E,G=[{searchPath:S.searchPath,pattern:W}];return W&&!W.endsWith("**")&&G.push({searchPath:S.searchPath,pattern:W+"/**"}),G}q(S,E,W){const G=this.r((0,a.toWorkspaceFolder)(S.searchPath),E,W,!1);return G?{...G,includePattern:S.pattern}:null}r(S,E,W,G){let Y;const J=f.URI.isUri(S)?S:S.uri;if(W.searchPaths){const j=W.searchPaths.filter(he=>(0,h.isEqual)(he.searchPath,J))[0];if(j&&!j.pattern)return null;j&&(Y=j.pattern)}const q=this.a.getValue({resource:J}),$={...this.l(q,E)||{},...Y||{}},z=f.URI.isUri(S)?(0,h.basename)(S):S.name;return{folder:J,folderName:G?z:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!q.search.followSymlinks}}};g=je([Ve(0,d.IConfigurationService),Ve(1,a.IWorkspaceContextService),Ve(2,m.IEditorGroupsService),Ve(3,t.ILogService),Ve(4,y.IPathService)],g),e.QueryBuilder=g;function i(v){const S=v.match(/[\*\{\}\(\)\[\]\?]/);if(S){const E=S.index,W=v.substr(0,E).match(/[/|\\][^/\\]*$/);if(W){let G=v.substr(0,W.index);return G.match(/[/\\]/)||(G+="/"),{pathPortion:G,globPortion:v.substr((W.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((S,E)=>(S[E]=!0,S),Object.create(null)):void 0}function r(v){return C.splitGlobAware(v,",").map(S=>S.trim()).filter(S=>!!S.length)}function c(v){return[`**/${v}/**`,`**/${v}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function k(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(v){return v.replace(/([?*[\]])/g,"[$1]")}function l(v,S){v=n.distinct(v,G=>G.toString());const E=[],W=S.getWorkspace();return v&&v.forEach(G=>{let Y;if(S.getWorkbenchState()===2)Y=(0,h.relativePath)(W.folders[0].uri,G),Y&&Y!=="."&&(Y="./"+Y);else{const J=S.getWorkspaceFolder(G);if(J){const q=J.name;if(W.folders.filter($=>$.name===q).length===1){const $=(0,h.relativePath)(J.uri,G);$===""?Y=`./${J.name}`:Y=`./${J.name}/${$}`}else Y=G.fsPath}}Y&&E.push(s(Y))}),E}e.resolveResourcesForSearchIncludes=l}),define(Pe[253],Ae([1,0,22,2,21,10,3,252,47,53]),function(ee,e,n,A,C,F,O,R,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function D(d,t){const a=t.activationEvents;if(!a)return Promise.resolve(void 0);const m=[],y=[];for(const c of a)if(/^workspaceContains:/.test(c)){const o=c.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||d.forceUsingSearch?y.push(o):m.push(o)}if(m.length===0&&y.length===0)return Promise.resolve(void 0);let P;const g=new Promise((c,o)=>{P=c}),i=c=>P({activationEvent:c}),u=Promise.all(m.map(c=>f(d,c,i))).then(()=>{}),r=b(d,t.identifier,y,i);return Promise.all([u,r]).then(()=>{P(void 0)}),g}e.checkActivateWorkspaceContainsExtension=D;async function f(d,t,a){for(const m of d.folders)if(await d.exists(n.joinPath(A.URI.revive(m),t))){a(`workspaceContains:${t}`);return}}async function b(d,t,a,m){if(a.length===0)return Promise.resolve(void 0);const y=new C.CancellationTokenSource,P=d.checkExists(d.folders,a,y.token),g=setTimeout(async()=>{y.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},L);let i=!1;try{i=await P}catch(u){F.isCancellationError(u)||F.onUnexpectedError(u)}y.dispose(),clearTimeout(g),i&&m(`workspaceContains:${a.join(",")}`)}function p(d,t,a,m){const y=d.get(O.IInstantiationService),P=d.get(w.ISearchService),i=y.createInstance(R.QueryBuilder).file(t.map(u=>(0,h.toWorkspaceFolder)(A.URI.revive(u))),{_reason:"checkExists",includePattern:a,exists:!0});return P.fileSearch(i,m).then(u=>!!u.limitHit,u=>F.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=p});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,A,C){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Le=this&&this.__classPrivateFieldGet||function(ee,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!A:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(ee):A?A.value:e.get(ee)};define(Pe[34],Ae([1,0,144,19,83,22,17,6,48,2,14,4,33,197,81,32,26,100,10,24,25,182,7,95,3,27,82,18,69,71,61,5,253,80,184,15,79,78,20]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g,i,u,r,c,o,k,s,l,v,S,E,W,G,Y,J,q,U){"use strict";var $,z,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let he=class fn extends R.Disposable{constructor(T,V,ce,me,Fe,be,Ee,Ie,se,ae,Z){super(),this.a=this.D(new S.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=V,this.g=ce,this.f=Ee,this.j=me,this.k=Fe,this.l=be,this.m=se,this.p=ae,this.q=Z,this.s=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.t=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.u=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.v=new O.Barrier,this.w=new O.Barrier,this.y=new O.Barrier,this.z=new O.Barrier,this.C=new le(this.f.activationEvents),this.G=new a.ExtensionDescriptionRegistry(this.C,this.f.allExtensions);const I=new y.ExtensionIdentifierSet(this.f.myExtensions);this.F=new a.ExtensionDescriptionRegistry(this.C,de(this.G,I)),this.H=new p.ExtHostStorage(this.g,this.l),this.I=new W.ExtHostSecretState(this.g),this.J=Ie,this.h=T.createChild(new s.ServiceCollection([p.IExtHostStorage,this.H],[W.IExtHostSecretState,this.I])),this.L=this.D(new b.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(M,H,x)=>{this.u.$onExtensionActivationError(M,m.transformErrorForSerialization(H),x)},actualActivateExtension:async(M,H)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(M,this.F,this.G))return await this.u.$activateExtension(M,H),new b.HostExtension;const x=this.F.getExtensionDescription(M);return this.Z(x,H)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.v.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.w.open(),this.f.autoStart&&this.nb()}catch(T){m.onUnexpectedError(T)}}async R(){this.J.onWillDeactivateAll();let T=[];try{T=this.F.getAllExtensionDescriptions().map(Fe=>Fe.identifier).filter(Fe=>this.isActivated(Fe)).map(Fe=>this.Y(Fe))}catch{}await Promise.all(T)}terminate(T,V=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${T}`),this.l.flush(),this.p.dispose(),this.L.dispose(),m.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const ce=this.R();Promise.race([(0,O.timeout)(5e3),ce]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.l.info(`Extension host exiting with code ${V}`),this.l.flush(),this.l.dispose(),this.c.exit(V)})}isActivated(T){return this.y.isOpen()?this.L.isActivated(T):!1}async getExtension(T){const V=await this.u.$getExtension(T);let ce;if(V?.browserNlsBundleUris){ce={};for(const me of Object.keys(V.browserNlsBundleUris))ce[me]=h.URI.revive(V.browserNlsBundleUris[me])}return V&&{...V,identifier:new y.ExtensionIdentifier(V.identifier.value),extensionLocation:h.URI.revive(V.extensionLocation),browserNlsBundleUris:ce}}S(T,V){return this.L.activateByEvent(T,V)}U(T,V){return this.L.activateById(T,V)}activateByIdWithErrors(T,V){return this.U(T,V).then(()=>{const ce=this.L.getActivatedExtension(T);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.y.wait().then(T=>this.F)}getExtensionExports(T){return this.y.isOpen()?this.L.getActivatedExtension(T).exports:null}async W(T){if(T.scheme!==Y.Schemas.file)return T;const V=await this.c.realpath(T.fsPath);return h.URI.file(V)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(T=>new ke(T))),this.M}async X(T){const V=w.TernarySearchTree.forUris(ce=>F.extUriBiasedIgnorePathCase.ignorePathCasing(ce));return await Promise.all(T.map(async ce=>{if(this.qb(ce)){const me=await this.W(ce.extensionLocation);V.set(me,ce)}})),V}Y(T){let V=Promise.resolve(void 0);if(!this.y.isOpen()||!this.L.isActivated(T))return V;const ce=this.L.getActivatedExtension(T);if(!ce)return V;try{typeof ce.module.deactivate=="function"&&(V=Promise.resolve(ce.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${T.value}':`),this.l.error(me)}try{(0,R.dispose)(ce.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${T.value}':`),this.l.error(me)}return V}async Z(T,V){return this.f.remote.isRemote?this.u.$onWillActivateExtension(T.identifier):await this.u.$onWillActivateExtension(T.identifier),this.bb(T,V).then(ce=>{const me=ce.activationTimes;return this.u.$onDidActivateExtension(T.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,V),this.ab(T,V,"success",me),ce},ce=>{throw this.ab(T,V,"failure"),ce})}ab(T,V,ce,me){const Fe=ie(T,V);this.t.$publicLog2("extensionActivationTimes",{...Fe,...me||{},outcome:ce})}bb(T,V){const ce=ie(T,V);this.t.$publicLog2("activatePlugin",ce);const me=this.qb(T);if(!me)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${T.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${T.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.l.flush();const Fe=new b.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this.rb(T,(0,F.joinPath)(T.extensionLocation,me),Fe),this.cb(T)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${T.identifier.value}`),fn.db(this.l,T.identifier,be[0],be[1],Fe))).then(be=>(C.mark(`code/extHost/didActivateExtension/${T.identifier.value}`),be))}cb(T){const V=new g.ExtensionGlobalMemento(T,this.H),ce=new g.ExtensionMemento(T.identifier.value,!1,this.H),me=new G.ExtensionSecrets(T,this.I),Fe=T.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,be=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${T.identifier.value}`),Promise.all([V.whenReady,ce.whenReady,this.J.whenReady]).then(()=>{const Ee=this;let Ie,se;const ae=(0,t.isProposedApiEnabled)(T,"ipc")?this.f.messagePorts?.get(y.ExtensionIdentifier.toKey(T.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ce,secrets:me,subscriptions:[],get extensionUri(){return T.extensionLocation},get extensionPath(){return T.extensionLocation.fsPath},asAbsolutePath(Z){return A.join(T.extensionLocation.fsPath,Z)},get storagePath(){return Ee.J.workspaceValue(T)?.fsPath},get globalStoragePath(){return Ee.J.globalValue(T).fsPath},get logPath(){return A.join(Ee.f.logsLocation.fsPath,T.identifier.value)},get logUri(){return h.URI.joinPath(Ee.f.logsLocation,T.identifier.value)},get storageUri(){return Ee.J.workspaceValue(T)},get globalStorageUri(){return Ee.J.globalValue(T)},get extensionMode(){return Fe},get extension(){return Ie===void 0&&(Ie=new oe(Ee,T.identifier,T,be,!1)),Ie},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(T,"extensionRuntime"),Ee.extensionRuntime},get environmentVariableCollection(){return Ee.p.getEnvironmentVariableCollection(T)},get messagePassingProtocol(){if(!se){if(!ae)return;const Z=S.Event.buffer(S.Event.fromDOMEventEmitter(ae,"message",I=>I.data));ae.start(),se={onDidReceiveMessage:Z,postMessage:ae.postMessage.bind(ae)}}return se}})})}static db(T,V,ce,me,Fe){return ce=ce||{activate:void 0,deactivate:void 0},this.eb(T,V,ce,me,Fe).then(be=>new b.ActivatedExtension(!1,null,Fe.build(),ce,be,me.subscriptions))}static eb(T,V,ce,me,Fe){if(typeof ce.activate=="function")try{Fe.activateCallStart(),T.trace(`ExtensionService#_callActivateOptional ${V.value}`);const be=typeof global=="object"?global:self,Ee=ce.activate.apply(be,[me]);return Fe.activateCallStop(),Fe.activateResolveStart(),Promise.resolve(Ee).then(Ie=>(Fe.activateResolveStop(),Ie))}catch(be){return Promise.reject(be)}else return Promise.resolve(ce)}fb(T,V){this.U(T.identifier,{startup:!1,extensionId:T.identifier,activationEvent:V}).then(void 0,ce=>{this.l.error(ce)})}gb(T,V=0){const me=Date.now();(0,U.setTimeout0)(()=>{for(let Fe=V;Fe<T.length;Fe+=1){const be=T[Fe];for(const Ee of be.activationEvents??[])if(Ee==="onStartupFinished")if(Date.now()-me>50){this.gb(T,Fe);break}else this.fb(be,Ee)}})}hb(){this.u.$setPerformanceMarks(C.getMarks()),this.k.getConfigProvider().then(T=>{const V=T.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.F.getAllExtensionDescriptions();if(V)this.gb(ce);else for(const me of ce)if(me.activationEvents)for(const Fe of me.activationEvents)Fe==="onStartupFinished"&&this.fb(me,Fe)})}ib(){const T=this.S("*",!0).then(void 0,be=>{this.l.error(be)});this.D(this.j.onDidChangeWorkspace(be=>this.jb(be.added)));const V=this.j.workspace?this.j.workspace.folders:[],ce=this.jb(V),me=this.lb(),Fe=Promise.all([me,T,ce]).then(()=>{});return Promise.race([Fe,(0,O.timeout)(1e4)]).then(()=>{this.hb()}),Fe}jb(T){return T.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(V=>this.kb(T,V))).then(()=>{})}async kb(T,V){if(this.isActivated(V.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:T.map(be=>be.uri),forceUsingSearch:ce,exists:be=>this.c.exists(be.fsPath),checkExists:(be,Ee,Ie)=>this.s.$checkExists(be,Ee,Ie)},Fe=await(0,E.checkActivateWorkspaceContainsExtension)(me,V);if(!!Fe)return this.U(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Fe.activationEvent}).then(void 0,be=>this.l.error(be))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.z.wait();try{return await this.mb()}catch(T){throw console.error(T),T}}async mb(){const{extensionDevelopmentLocationURI:T,extensionTestsLocationURI:V}=this.f.environment;if(!T||!V)throw new Error(n.localize(0,null));const ce=await this.rb(null,V,new b.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(n.localize(1,null,V.toString()));return new Promise((me,Fe)=>{const be=(se,ae)=>{se?Fe(se):me(typeof ae=="number"&&ae>0?1:0)},Ee=(0,F.originalFSPath)(V),Ie=ce.run(Ee,be);Ie&&Ie.then&&Ie.then(()=>{me(0)}).catch(se=>{Fe(se instanceof Error&&se.stack?se.stack:String(se))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.w.wait().then(()=>this.y.open()).then(()=>this.ib()).then(()=>{this.z.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(T,V){return this.N[T]=V,(0,R.toDisposable)(()=>{delete this.N[T]})}async ob(T){const V=T.indexOf("+");if(V===-1)throw new Error("Not an authority that can be resolved!");const ce=T.substr(0,V);return await this.v.wait(),await this.S(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.N[ce]}}async $resolveAuthority(T,V){const ce=q.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,u.getRemoteAuthorityPrefix)(T)},${V})][${ce.elapsed()}ms] `,Fe=ae=>this.l.info(`${me()}${ae}`),be=(ae,Z=void 0)=>this.l.error(`${me()}${ae}`,Z);Fe("activating resolver...");const{authorityPrefix:Ee,resolver:Ie}=await this.ob(T);if(!Ie)return be("no resolver"),{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ee}.`,detail:void 0}};const se=new O.IntervalTimer;try{Fe("setting tunnel factory..."),this.D(await this.m.setTunnelFactory(Ie)),se.cancelAndSet(()=>Fe("waiting..."),1e3),Fe("invoking resolve()..."),C.mark(`code/extHost/willResolveAuthority/${Ee}`);const ae=await Ie.resolve(T,{resolveAttempt:V});C.mark(`code/extHost/didResolveAuthorityOK/${Ee}`),se.dispose(),Fe(`returned ${ae.host}:${ae.port}`);const Z={authority:T,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},I={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Z,options:I,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(C.mark(`code/extHost/didResolveAuthorityError/${Ee}`),se.dispose(),be("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(T,V){this.l.info(`$getCanonicalURI invoked for authority (${(0,u.getRemoteAuthorityPrefix)(T)})`);const{resolver:ce}=await this.ob(T);if(!ce)return null;const me=h.URI.revive(V);if(typeof ce.getCanonicalURI>"u")return me;const Fe=await(0,O.asPromise)(()=>ce.getCanonicalURI(me));return Fe||me}$startExtensionHost(T){T.toAdd.forEach(me=>me.extensionLocation=h.URI.revive(me.extensionLocation));const{globalRegistry:V,myExtensions:ce}=we(this.C,this.G,this.F,T);return this.G.set(V.getAllExtensionDescriptions()),this.F.set(ce),this.nb()}$activateByEvent(T,V){return V===1?this.S(T,!1):this.y.wait().then(ce=>this.S(T,!1))}async $activate(T,V){return await this.y.wait(),this.F.getExtensionDescription(T)?(await this.U(T,V),!0):!1}async $deltaExtensions(T){T.toAdd.forEach(be=>be.extensionLocation=h.URI.revive(be.extensionLocation));const{globalRegistry:V,myExtensions:ce}=we(this.C,this.G,this.F,T),me=await this.X(ce);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(V.getAllExtensionDescriptions()),this.F.set(ce),Promise.resolve(void 0)}async $test_latency(T){return T}async $test_up(T){return T.byteLength}async $test_down(T){const V=P.VSBuffer.alloc(T),ce=Math.random()%256;for(let me=0;me<T;me++)V.writeUInt8(ce,me);return V}async $updateRemoteConnectionData(T){this.Q=T,this.a.fire()}};he=je([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,k.IExtHostRpcService),Ve(3,d.IExtHostWorkspace),Ve(4,f.IExtHostConfiguration),Ve(5,L.ILogService),Ve(6,c.IExtHostInitDataService),Ve(7,o.IExtensionStoragePaths),Ve(8,l.IExtHostTunnelService),Ve(9,v.IExtHostTerminalService),Ve(10,J.IExtHostLocalizationService)],he),e.AbstractExtHostExtensionService=he;function we(X,T,V,ce){X.addActivationEvents(ce.addActivationEvents);const me=new a.ExtensionDescriptionRegistry(X,T.getAllExtensionDescriptions());me.deltaExtensions(ce.toAdd,ce.toRemove);const Fe=new y.ExtensionIdentifierSet(V.getAllExtensionDescriptions().map(Ee=>Ee.identifier));for(const Ee of ce.myToRemove)Fe.delete(Ee);for(const Ee of ce.myToAdd)Fe.add(Ee);const be=de(me,Fe);return{globalRegistry:me,myExtensions:be}}function ie(X,T){return{id:X.identifier.value,name:X.name,extensionVersion:X.version,publisherDisplayName:X.publisher,activationEvents:X.activationEvents?X.activationEvents.join(","):null,isBuiltin:X.isBuiltin,reason:T.activationEvent,reasonId:T.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class oe{constructor(T,V,ce,me,Fe){$.set(this,void 0),z.set(this,void 0),j.set(this,void 0),Je(this,$,T,"f"),Je(this,z,V,"f"),Je(this,j,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=A.normalize((0,F.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=me,this.isFromDifferentExtensionHost=Fe}get isActive(){return Le(this,$,"f").isActivated(Le(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,$,"f").getExtensionExports(Le(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,$,"f").activateByIdWithErrors(Le(this,j,"f"),{startup:!1,extensionId:Le(this,z,"f"),activationEvent:"api"}),this.exports}}e.Extension=oe,$=new WeakMap,z=new WeakMap,j=new WeakMap;function de(X,T){return X.getAllExtensionDescriptions().filter(V=>T.has(V.identifier))}class ke{constructor(T){this.a=T}setSearchTree(T){this.a=T}findSubstr(T){return this.a.findSubstr(T)}forEach(T){return this.a.forEach(T)}}e.ExtensionPaths=ke;class le{constructor(T){this.a=new y.ExtensionIdentifierMap,this.addActivationEvents(T)}readActivationEvents(T){return this.a.get(T.identifier)}addActivationEvents(T){for(const V of Object.keys(T))this.a.set(V,T[V])}}}),define(Pe[254],Ae([1,0,83,2,4,33,26,24,18,27,3,34,51,14,13]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(g,i,u,r,c,o,k){this.c=g,this.d=i,this.e=u,this.f=r,this.g=c,this.h=o,this.i=k,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,g,this.i)),this.register(this.e.createInstance(m,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(y,i,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const i of g.nodeModuleName)this.a.set(i,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(i=>g.alternativeModuleName(i))}};d=je([Ve(2,L.IInstantiationService),Ve(3,F.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,h.IExtHostInitDataService),Ve(6,b.ILogService)],d),e.RequireInterceptor=d;let t=class cn{constructor(g){if(g.environment.appRoot&&cn.a.size){const i=(0,p.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),u="[a-z0-9_.-]",r=`@${u}+\\/${u}+|${u}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const i=this.b.exec(this.c(g));if(!i)return;const[,u,r,c]=i,o=cn.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),u+o+c}c(g){return g.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=je([Ve(0,h.IExtHostInitDataService)],t);class a{constructor(g,i,u,r,c){this.c=g,this.d=i,this.e=u,this.f=r,this.g=c,this.nodeModuleName="vscode",this.a=new R.ExtensionIdentifierMap}load(g,i){const u=this.d.findSubstr(i);if(u){let r=this.a.get(u.identifier);return r||(r=this.c(u,this.e,this.f),this.a.set(u.identifier,r)),r}if(!this.b){let r="";this.d.forEach((c,o)=>r+=`	${o} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this.b=this.c(O.nullExtensionDescription,this.e,this.f)}return this.b}}let m=class{constructor(g,i,u){this.d=g,this.nodeModuleName="keytar",this.a=i.getProxy(C.MainContext.MainThreadTelemetry);const{environment:r}=u,c=i.getProxy(C.MainContext.MainThreadKeytar);if(r.appRoot){let o=r.appRoot.fsPath;f.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,k)=>c.$getPassword(o,k),setPassword:(o,k,s)=>c.$setPassword(o,k,s),deletePassword:(o,k)=>c.$deletePassword(o,k),findPassword:o=>c.$findPassword(o),findCredentials(o){return c.$findCredentials(o)}}}load(g,i){const u=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const i=g.length;if(i<=7||!this.b)return;const u=i-7;if((g.charAt(u)==="/"||g.charAt(u)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};m=je([Ve(1,w.IExtHostRpcService),Ve(2,h.IExtHostInitDataService)],m);let y=class{constructor(g,i,u){this.e=g,this.f=i,this.nodeModuleName=["open","opn"],this.d=u.getProxy(C.MainContext.MainThreadTelemetry);const r=u.getProxy(C.MainContext.MainThreadWindow);this.c=(c,o)=>{const k=A.URI.parse(c);return o?this.g(c,o):k.scheme==="http"||k.scheme==="https"?r.$openUri(k,c,{allowTunneling:!0}):k.scheme==="mailto"||k.scheme===this.f?r.$openUri(k,c,{}):this.g(c,o)}}load(g,i,u){const r=this.e.findSubstr(i);return r&&(this.a=r.identifier.value,this.h()),this.b=u(g),this.c}g(g,i){return this.i(),this.b(g,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};y=je([Ve(2,w.IExtHostRpcService)],y)}),define(Pe[110],Ae([1,0,86,6,19,51,3,58,59,34,7,32,194,33]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,O.createDecorator)("IExtHostVariableResolverProvider");class p extends f.AbstractVariableResolverService{constructor(a,m,y,P,g,i,u){function r(){if(y){const c=y.activeEditor();if(c)return c.document.uri;const o=P.tabGroups.all.find(k=>k.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof L.TextDiffTabInput||o.input instanceof L.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof L.TextTabInput||o.input instanceof L.NotebookEditorTabInput||o.input instanceof L.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:c=>{const o=i.folders.filter(k=>k.name===c);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(c,o)=>g.getConfiguration(void 0,c).get(o),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return C.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const c=r();if(c){const o=m.getWorkspaceFolder(c);if(o)return C.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(y){const c=y.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(y){const c=y.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(F.env))}}let d=class extends A.Disposable{constructor(a,m,y,P,g){super(),this.b=a,this.c=m,this.g=y,this.h=P,this.i=g,this.a=new n.Lazy(async()=>{const i=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.D(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.i,i,r,this.j())})}getResolver(){return this.a.value}j(){}};d=je([Ve(0,h.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,b.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Pe[111],Ae([1,0,17,5,9,2,3,4,59,34,18,7,32,187,189,33,110]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,O.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,c,o,k,s,l){this.D=c,this.E=o,this.F=k,this.G=s,this.H=l,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=r.getProxy(R.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new y(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(v=>{v.onDidChange(S=>{this.I(v)}),this.I(v)})}asDebugSourceUri(r,c){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let k=`debug:${encodeURIComponent(o.path||"")}`,s="?";return c&&(k+=`${s}session=${encodeURIComponent(c.id)}`,s="&"),k+=`${s}ref=${o.sourceReference}`,F.URI.parse(k)}else{if(o.path)return F.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const c=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const k=o.contributes.debuggers;if(k&&k.length>0)for(const s of k)(0,p.isDebuggerMainContribution)(s)&&c.push(s.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(c=>r.push(c)),r}addBreakpoints(r){this.T();const c=r.filter(s=>{const l=s.id;return this.w.has(l)?!1:(this.w.set(l,s),!0)});this.U(c,[],[]);const o=[],k=new Map;for(const s of c)if(s instanceof D.SourceBreakpoint){let l=k.get(s.location.uri.toString());l||(l={type:"sourceMulti",uri:s.location.uri,lines:[]},k.set(s.location.uri.toString(),l),o.push(l)),l.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof D.FunctionBreakpoint&&o.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){this.T();const c=r.filter(l=>this.w.delete(l.id));this.U([],c,[]);const o=c.filter(l=>l instanceof D.SourceBreakpoint).map(l=>l.id),k=c.filter(l=>l instanceof D.FunctionBreakpoint).map(l=>l.id),s=c.filter(l=>l instanceof D.DataBreakpoint).map(l=>l.id);return this.k.$unregisterBreakpoints(o,k,s)}startDebugging(r,c,o){return this.k.$startDebugging(r?r.uri:void 0,c,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,o){if(!c)return new D.Disposable(()=>{});const k=this.d++;return this.f.push({type:r,handle:k,provider:c}),this.k.$registerDebugConfigurationProvider(r,o,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,k),new D.Disposable(()=>{this.f=this.f.filter(s=>s.provider!==c),this.k.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(r,c,o){if(!o)return new D.Disposable(()=>{});if(!this.P(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:c,handle:k,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(c,k),new D.Disposable(()=>{this.h=this.h.filter(s=>s.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new D.Disposable(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:c}),new D.Disposable(()=>{this.j=this.j.filter(k=>k.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let o;const k=await this.W(r);return k&&(o={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,c)}J(r,c){if(r.type==="implementation")return new g(r.implementation)}K(){}async $startDASession(r,c){const o=this,k=await this.V(c);return this.R(this.M(k.type),k).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const l=this.L(s),v=this.J(l,k);if(!v)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const S=v;return this.A.set(r,S),this.Q(k).then(E=>(E&&this.B.set(r,E),S.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const G=W,Y={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const J=await this.C.sign(G.arguments.value);Y.body={signature:J},S.sendResponse(Y)}else throw new Error("no signer")}catch(J){Y.success=!1,Y.message=J.message,S.sendResponse(Y)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(W),W=(0,p.convertToVSCPaths)(W,!0),o.k.$acceptDAMessage(r,W)}),S.onError(W=>{E&&E.onError&&E.onError(W),this.k.$acceptDAError(r,W.name,W.message,W.stack)}),S.onExit(W=>{E&&E.onExit&&E.onExit((0,C.withNullAsUndefined)(W),void 0),this.k.$acceptDAExit(r,(0,C.withNullAsUndefined)(W),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),S.startSession()))})}$sendDAMessage(r,c){c=(0,p.convertToDAPaths)(c,!1);const o=this.B.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(c),this.A.get(r)?.sendMessage(c)}$stopDASession(r){const c=this.B.get(r);this.B.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const o=this.A.get(r);return this.A.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],o=[],k=[];if(r.added)for(const s of r.added){const l=s.id;if(l&&!this.w.has(l)){let v;if(s.type==="function")v=new D.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")v=new D.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const S=F.URI.revive(s.uri);v=new D.SourceBreakpoint(new D.Location(S,new D.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}(0,D.setBreakpointId)(v,l),this.w.set(l,v),c.push(v)}}if(r.removed)for(const s of r.removed){const l=this.w.get(s);l&&(this.w.delete(s),o.push(l))}if(r.changed){for(const s of r.changed)if(s.id){const l=this.w.get(s.id);if(l){if(l instanceof D.FunctionBreakpoint&&s.type==="function"){const v=l;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.functionName=s.functionName}else if(l instanceof D.SourceBreakpoint&&s.type==="source"){const v=l;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.location=new D.Location(F.URI.revive(s.uri),new D.Position(s.line,s.character))}k.push(l)}}}this.U(c,o,k)}$provideDebugConfigurations(r,c,o){return(0,n.asPromise)(async()=>{const k=this.O(r);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.W(c);return k.provideDebugConfigurations(s,o)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(r,c,o,k){return(0,n.asPromise)(async()=>{const s=this.O(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.W(c);return s.resolveDebugConfiguration(l,o,k)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,o,k){return(0,n.asPromise)(async()=>{const s=this.O(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.W(c);return s.resolveDebugConfigurationWithSubstitutedVariables(l,o,k)})}async $provideDebugAdapter(r,c){const o=this.N(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.V(c);return this.R(o,k).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.L(s)})}async $acceptDebugSessionStarted(r){const c=await this.V(r);this.m.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.V(r);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,c){(await this.V(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const k={session:await this.V(r),event:c.event,body:c.body};this.u.fire(k)}L(r){if(r instanceof D.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof D.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const c=this.h.filter(o=>o.type===r);if(c.length>0)return c[0].factory}N(r){const c=this.h.filter(o=>o.handle===r);if(c.length>0)return c[0].factory}O(r){const c=this.f.filter(o=>o.handle===r);if(c.length>0)return c[0].provider}P(r,c){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const k of o)if(k.label&&k.type&&k.type===c)return!0}}return!1}Q(r){const o=r.configuration.type,k=this.j.filter(s=>s.type===o||s.type==="*").map(s=>(0,n.asPromise)(()=>s.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(k).then(s=>{const l=s.filter(v=>!!v);if(l.length>0)return new P(l)}),new Promise(s=>setTimeout(()=>s(void 0),1e3))]).catch(s=>{})}async R(r,c){const o=c.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new D.DebugAdapterServer(o));if(r){const s=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(c,this.S(c,s))).then(l=>{if(l)return l})}const k=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,k))}S(r,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,c,o){(r.length>0||c.length>0||o.length>0)&&this.z.fire(Object.freeze({added:r,removed:c,changed:o}))}async V(r){if(r)if(typeof r=="string"){const c=this.l.get(r);if(c)return c}else{let c=this.l.get(r.id);if(!c){const o=await this.W(r.folderUri),k=r.parent?this.l.get(r.parent):void 0;c=new m(this.k,r.id,r.type,r.name,o,r.configuration,k),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(r){if(r){const c=F.URI.revive(r);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};a=je([Ve(0,L.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class m{constructor(r,c,o,k,s,l,v){this.d=r,this.f=c,this.g=o,this.h=k,this.i=s,this.j=l,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,c){return this.d.$customDebugAdapterRequest(this.f,r,c)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=m;class y{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=y;class P{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.d.forEach(o=>o.onExit?o.onExit(r,c):void 0)}}class g extends b.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends a{constructor(r,c,o,k,s,l){super(r,c,o,k,s,l)}};i=je([Ve(0,L.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Pe[255],Ae([1,0,10,83,2,4,246,14,68,69,27,165,18,55,34,57]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(y){const P=y.get(R.ILogService),i=y.get(f.IExtHostRpcService).getProxy(F.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(u=>{P.error(u);const r=n.transformErrorForSerialization(u);i.$onUnexpectedError(r)})}static async installFullHandler(y){const P=y.get(R.ILogService),g=y.get(f.IExtHostRpcService),i=y.get(p.IExtHostExtensionService),u=y.get(d.IExtHostTelemetry),r=g.getProxy(F.MainContext.MainThreadExtensionService),c=g.getProxy(F.MainContext.MainThreadErrors),o=await i.getExtensionPathIndex(),k=new WeakMap;function s(v,S){let E="",W,G;for(const Y of S)E+=`
	at ${Y.toString()}`,G=Y.getFileName(),!W&&G&&(W=o.findSubstr(C.URI.file(G)));return k.set(v,W?.identifier),`${v.name||"Error"}: ${v.message||""}${E}`}let l=s;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return l},set(v){l=function(S,E){return s(S,E),v.call(Error,S,E)}}}),n.setUnexpectedErrorHandler(v=>{P.error(v);const S=n.transformErrorForSerialization(v),E=k.get(v);if(!E){c.$onUnexpectedError(S);return}r.$onExtensionRuntimeError(E,S);const W=u.onExtensionError(E,v);P.trace("forwarded error to extension?",W,E)})}}Error.stackTraceLimit=100;class a{constructor(y,P,g,i,u){this.a=g,this.b=new O.RPCProtocol(y,null,i),P=a.e(P,this.b);const r=new h.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());r.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...P,messagePorts:u}),r.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),r.set(b.IURITransformerService,new b.URITransformerService(i)),r.set(p.IHostUtils,g);const c=new D.InstantiationService(r,!0);c.invokeFunction(t.installEarlyHandler),this.d=c.invokeFunction(o=>o.get(R.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",P),this.c=c.invokeFunction(o=>o.get(p.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(t.installFullHandler)}async asBrowserUri(y){const P=this.b.getProxy(F.MainContext.MainThreadExtensionService);return C.URI.revive(await P.$asBrowserUri(y))}terminate(y){this.c.terminate(y)}static e(y,P){y.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(P.transformIncomingURIs(i.extensionLocation));const u={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(r=>u[r]=C.URI.revive(P.transformIncomingURIs(i.browserNlsBundleUris[r]))),i.browserNlsBundleUris=u)}),y.environment.appRoot=C.URI.revive(P.transformIncomingURIs(y.environment.appRoot));const g=y.environment.extensionDevelopmentLocationURI;return g&&(y.environment.extensionDevelopmentLocationURI=g.map(i=>C.URI.revive(P.transformIncomingURIs(i)))),y.environment.extensionTestsLocationURI=C.URI.revive(P.transformIncomingURIs(y.environment.extensionTestsLocationURI)),y.environment.globalStorageHome=C.URI.revive(P.transformIncomingURIs(y.environment.globalStorageHome)),y.environment.workspaceStorageHome=C.URI.revive(P.transformIncomingURIs(y.environment.workspaceStorageHome)),y.environment.extensionTelemetryLogResource=C.URI.revive(P.transformIncomingURIs(y.environment.extensionTelemetryLogResource)),y.nlsBaseUrl=C.URI.revive(P.transformIncomingURIs(y.nlsBaseUrl)),y.logsLocation=C.URI.revive(P.transformIncomingURIs(y.logsLocation)),y.workspace=P.transformIncomingURIs(y.workspace),y}}e.ExtensionHostMain=a}),define(Pe[256],Ae([1,0,16,17,21,40,15,19,22,2,47]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(m,y,P,g){this.d=m,this.e=y,this.f=P,this.g=g,this.a=null,this.b=!1,this.c=0}search(m,y){const P=this.d.folderQueries||[],g=new C.CancellationTokenSource;return y.onCancellationRequested(()=>g.cancel()),new Promise((i,u)=>{this.a=new b(m);let r=!1;const c=(o,k)=>{if(!r&&!this.b){const s=this.h(o);d(o)&&typeof this.d.maxResults=="number"&&this.c+s>this.d.maxResults&&(this.b=!0,r=!0,g.cancel(),o=this.j(o,this.d.maxResults-this.c));const l=this.h(o);this.c+=l,(l>0||!d(o))&&this.a.add(o,k)}};Promise.all(P.map((o,k)=>this.k(o,s=>c(s,k),g.token))).then(o=>{g.dispose(),this.a.flush();const k=o.some(s=>!!s&&!!s.limitHit);i({limitHit:this.b||k,messages:(0,n.flatten)(o.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.g}})},o=>{g.dispose();const k=(0,F.toErrorMessage)(o);u(new Error(k))})})}h(m){return d(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,y){const P=Array.isArray(m.ranges)?m.ranges:[m.ranges],g=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:P.slice(0,y),preview:{matches:g.slice(0,y),text:m.preview.text},uri:m.uri}}async k(m,y,P){const g=new L.QueryGlobTester(this.d,m),i=[],u={report:o=>{if(!this.l(o))return;const k=m.folder.scheme===O.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(w.dirname(o.uri))):void 0,s=w.relativePath(m.folder,o.uri);if(s){const l=g.includedInQuery(s,R.basename(s),k);(0,A.isThenable)(l)?i.push(l.then(v=>{v&&y(o)})):l&&y(o)}}},r=this.n(m),c=await this.e.provideTextSearchResults(f(this.d.contentPattern),r,u,P);return i.length&&await Promise.all(i),c}l(m){if(d(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const y=(0,L.resolvePatternsForProvider)(this.d.includePattern,m.includePattern),P=(0,L.resolvePatternsForProvider)(this.d.excludePattern,m.excludePattern),g={folder:h.URI.from(m.folder),excludes:P,includes:y,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.f.toCanonicalName(m.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=D;function f(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class b{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new t(512,y=>this.g(y))}add(m,y){this.d&&(this.b!==y||!w.isEqual(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=y,this.d={resource:m.uri,results:[]}),this.d.results.push(p(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.TextSearchResultsCollector=b;function p(a){return d(a)?{preview:{matches:(0,n.mapArrayOrNot)(a.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:a.preview.text},ranges:(0,n.mapArrayOrNot)(a.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function d(a){return!!a.preview}e.extensionResultIsMatch=d;class t{constructor(m,y){this.g=m,this.h=y,this.c=0,this.d=[],this.e=0}addItem(m,y){!m||this.j(m,y)}addItems(m,y){!m||this.k(m,y)}j(m,y){this.d.push(m),this.e+=y,this.l()}k(m,y){this.d=this.d.concat(m),this.e+=y,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}t.a=4e3,t.b=50,e.BatchedCollector=t}),define(Pe[112],Ae([1,0,6,4,3,251,18,55,14,2,256]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let D=class{constructor(d,t,a){this.k=d,this.l=t,this.n=a,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const a=this.d++;return this.e.set(a,t),this.c.$registerTextSearchProvider(a,this.o(d)),(0,n.toDisposable)(()=>{this.g.delete(d),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const a=this.d++;return this.h.set(a,t),this.c.$registerFileSearchProvider(a,this.o(d)),(0,n.toDisposable)(()=>{this.i.delete(d),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(d,t,a,m){const y=f(a),P=this.h.get(d);if(P)return this.j.fileSearch(y,P,g=>{this.c.$handleFileMatch(d,t,g.map(i=>i.resource))},m);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,a,m){const y=this.e.get(d);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const P=f(a);return this.q(P,y).search(i=>this.c.$handleTextMatch(d,t,i),m)}$enableExtensionHostSearch(){}q(d,t){return new L.TextSearchManager(d,t,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};D=je([Ve(0,O.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,w.ILogService)],D),e.ExtHostSearch=D;function f(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(d=>h.URI.revive(d))}}e.reviveQuery=f;function b(p){return{...p,folder:h.URI.revive(p.folder)}}}),define(Pe[257],Ae([1,0,68,107,32,105,33,38,58,61,109,111,112,81,71,77,106,60,37,80,57,59,227,14,110,79]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g,i,u,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,n.registerSingleton)(u.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,n.registerSingleton)(O.IExtHostConfiguration,O.ExtHostConfiguration,0),(0,n.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,n.registerSingleton)(F.IExtHostDecorations,F.ExtHostDecorations,0),(0,n.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,n.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,n.registerSingleton)(h.IExtHostTerminalService,h.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,0),(0,n.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState,0),(0,n.registerSingleton)(P.IExtHostTelemetry,P.ExtHostTelemetry,0),(0,n.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,n.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Pe[258],Ae([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(C){if(C&&this.a.has(C)){const F=this.a.get(C);return this.a.delete(C),F}}addDragOperationTransfer(C,F){this.a.set(C,F)}getRenderedTreeElement(C){if(this.b.has(C))return this.b.get(C)}addRenderedTreeItemElement(C,F){this.b.set(C,F)}removeRenderedTreeItemElement(C){this.b.has(C)&&this.b.delete(C)}}e.TreeviewsService=n}),define(Pe[259],Ae([1,0,150,7,22,2,5,6,186,17,7,9,16,8,21,258,26]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(P,g){if((0,D.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let i;return Array.isArray(P.highlights)&&(i=P.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),i=i.length?i:void 0),{label:P.label,highlights:i}}}class m{constructor(g,i,u){this.d=g,this.e=i,this.f=u,this.a=new Map,this.b=new d.TreeviewsService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:c=>r(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(o=>r(o)?this.i(o):o):c})}registerTreeDataProvider(g,i,u){const r=this.createTreeView(g,{treeDataProvider:i},u);return{dispose:()=>r.dispose()}}createTreeView(g,i,u){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],c=i.dragAndDropController?.dragMimeTypes??[],o=!!i.dragAndDropController?.handleDrag,k=!!i.dragAndDropController?.handleDrop,s=this.h(g,i,u),l=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:o,hasHandleDrop:k});return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(u,"treeItemCheckbox"),s.onDidChangeCheckboxState},get message(){return s.message},set message(v){s.message=v},get title(){return s.title},set title(v){s.title=v},get description(){return s.description},set description(v){s.description=v},get badge(){return s.badge},set badge(v){v!==void 0&&L.ViewBadge.isViewBadge(v)?s.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(s.badge=void 0)},reveal:(v,S)=>s.reveal(v,S),dispose:async()=>{await l,this.a.delete(g),s.dispose()}}}$getChildren(g,i){const u=this.a.get(g);return u?u.getChildren(i):Promise.reject(new w.NoTreeViewError(g))}async $handleDrop(g,i,u,r,c,o,k,s){const l=this.a.get(g);if(!l)return Promise.reject(new w.NoTreeViewError(g));const v=b.DataTransfer.toDataTransfer(u,async S=>(await this.d.$resolveDropFileData(g,i,S)).buffer);return k===g&&s&&await this.g(v,l,s,c,o),l.onDrop(v,r,c)}async g(g,i,u,r,c){const o=this.b.removeDragOperationTransfer(c);if(o)(await o)?.forEach((k,s)=>{k&&g.set(s,k)});else if(c&&i.handleDrag){const k=i.handleDrag(u,g,r);this.b.addDragOperationTransfer(c,k),await k}return g}async $handleDrag(g,i,u,r){const c=this.a.get(g);if(!c)return Promise.reject(new w.NoTreeViewError(g));const o=await this.g(new A.DataTransfer,c,i,r,u);if(!!o)return b.DataTransfer.toDataTransferDTO(o)}async $hasResolve(g){const i=this.a.get(g);if(!i)throw new w.NoTreeViewError(g);return i.hasResolve}$resolve(g,i,u){const r=this.a.get(g);if(!r)throw new w.NoTreeViewError(g);return r.resolveTreeItem(i,u)}$setExpanded(g,i,u){const r=this.a.get(g);if(!r)throw new w.NoTreeViewError(g);r.setExpanded(i,u)}$setSelection(g,i){const u=this.a.get(g);if(!u)throw new w.NoTreeViewError(g);u.setSelection(i)}$setFocus(g,i){const u=this.a.get(g);if(!u)throw new w.NoTreeViewError(g);u.setFocus(i)}$setVisible(g,i){const u=this.a.get(g);if(!u)throw new w.NoTreeViewError(g);u.setVisible(i)}$changeCheckboxState(g,i){const u=this.a.get(g);if(!u)throw new w.NoTreeViewError(g);u.setCheckboxState(i)}h(g,i,u){const r=new y(g,i,this.d,this.e.converter,this.f,u);return this.a.set(g,r),r}i(g){const i=this.a.get(g.$treeViewId);return i&&"$treeItemHandle"in g?i.getExtensionElement(g.$treeItemHandle):i&&"$focusedTreeItem"in g&&g.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=m;class y extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,D.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,i,u,r,c,o){if(super(),this.z=g,this.C=u,this.F=r,this.G=c,this.H=o,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.q=this.D(new O.Emitter),this.onDidExpandElement=this.q.event,this.r=this.D(new O.Emitter),this.onDidCollapseElement=this.r.event,this.s=this.D(new O.Emitter),this.onDidChangeSelection=this.s.event,this.t=this.D(new O.Emitter),this.onDidChangeVisibility=this.t.event,this.u=this.D(new O.Emitter),this.onDidChangeCheckboxState=this.u.event,this.v=this.D(new O.Emitter),this.w=Promise.resolve(),this.y=Promise.resolve(),this.I="",this.J="",this.S=new p.CancellationTokenSource,o.contributes&&o.contributes.views)for(const l in o.contributes.views)for(const v of o.contributes.views[l])v.id===g&&(this.J=v.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.D(this.f.onDidChangeTreeData(l=>this.v.fire({message:!1,element:l})));let k,s;this.D(O.Event.debounce(this.v.event,(l,v)=>(l||(l={message:!1,elements:[]}),v.element!==!1&&(k||(k=new Promise(S=>s=S),this.w=this.w.then(()=>k)),Array.isArray(v.element)?l.elements.push(...v.element):l.elements.push(v.element)),v.message&&(l.message=!0),l),200,!0)(({message:l,elements:v})=>{v.length&&(this.y=this.y.then(()=>{const S=s;return k=null,this.U(v).then(()=>S())})),l&&this.C.$setMessage(this.z,this.I)}))}async getChildren(g){const i=g?this.getExtensionElement(g):void 0;if(g&&!i)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let u=this.Q(g);return u||(u=await this.R(i)),u?u.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,i){i=i||{select:!0,focus:!1};const u=(0,D.isUndefinedOrNull)(i.select)?!0:i.select,r=(0,D.isUndefinedOrNull)(i.focus)?!1:i.focus,c=(0,D.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.w.then(()=>this.N(g)).then(o=>this.P(g,o[o.length-1]).then(k=>this.C.$reveal(this.z,{item:k.item,parentChain:o.map(s=>s.item)},{select:u,focus:r,expand:c})),o=>this.G.error(o)):this.C.$reveal(this.z,void 0,{select:u,focus:r,expand:c})}get message(){return this.I}set message(g){this.I=g,this.v.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.C.$setTitle(this.z,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.C.$setTitle(this.z,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=b.ViewBadge.from(g),this.C.$setBadge(this.z,g))}setExpanded(g,i){const u=this.getExtensionElement(g);u&&(i?this.q.fire(Object.freeze({element:u})):this.r.fire(Object.freeze({element:u})))}setSelection(g){(0,f.equals)(this.l,g)||(this.l=g,this.s.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.t.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const i=(await Promise.all(g.map(async u=>{const r=this.getExtensionElement(u.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:u.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);i.forEach(u=>{u.treeItem.checkboxState=u.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.u.fire({items:i.map(u=>[u.extensionItem,u.newState])})}async handleDrag(g,i,u){const r=[];for(const c of g){const o=this.getExtensionElement(c);o&&r.push(o)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,i,u),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,i,u){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.g?.handleDrop))return(0,h.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,i){if(!this.f.resolveTreeItem)return;const u=this.i.get(g);if(u){const r=this.j.get(u);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,u,i)??r.extensionItem;return this.db(c),r.item.tooltip=this.ab(c.tooltip),r.item.command=this.bb(r.disposableStore,c.command),r.item}}}N(g){return this.O(g).then(i=>i?this.N(i).then(u=>this.P(i,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}O(g){const i=this.j.get(g);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,h.asPromise)(()=>this.f.getParent(g))}P(g,i){const u=this.j.get(g);return u?Promise.resolve(u):(0,h.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const o=this.j.get(c);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let i;if(typeof g=="string"){const u=this.getExtensionElement(g);i=u?this.j.get(u):void 0}else i=g;return i&&i.children||void 0}return this.h}async R(g){this.nb(g);const i=new p.CancellationTokenSource(this.S.token);try{const u=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(i.token.isCancellationRequested)return;const c=await Promise.all((0,f.coalesce)(r||[]).map(async o=>{const k=await this.f.getTreeItem(o);return k&&!i.token.isCancellationRequested?this.Z(o,k,u):null}));return i.token.isCancellationRequested?void 0:(0,f.coalesce)(c)}finally{i.dispose()}}U(g){if(g.some(u=>!u))return this.S.dispose(!0),this.S=new p.CancellationTokenSource,this.pb(),this.C.$refresh(this.z);{const u=this.W(g);if(u.length)return this.X(u)}return Promise.resolve(void 0)}W(g){const i=new Set,u=g.map(c=>this.j.get(c));for(const c of u)if(c&&!i.has(c.item.handle)){let o=c;for(;o&&o.parent&&u.findIndex(k=>o&&o.parent&&k&&k.item.handle===o.parent.item.handle)===-1;){const k=this.i.get(o.parent.item.handle);o=k?this.j.get(k):void 0}o&&!o.parent&&i.add(c.item.handle)}const r=[];return i.forEach(c=>{const o=this.i.get(c);if(o){const k=this.j.get(o);k&&(!k.parent||!i.has(k.parent.item.handle))&&r.push(c)}}),r}X(g){const i={};return Promise.all(g.map(u=>this.Y(u).then(r=>{r&&(i[u]=r.item)}))).then(()=>Object.keys(i).length?this.C.$refresh(this.z,i):void 0)}Y(g){const i=this.getExtensionElement(g);if(i){const u=this.j.get(i);if(u)return this.nb(i),(0,h.asPromise)(()=>this.f.getTreeItem(i)).then(r=>{if(r){const c=this.eb(i,r,u.parent);return this.lb(i,c,u,u.parent),u.dispose(),c}return null})}return Promise.resolve(null)}Z(g,i,u){const r=this.eb(g,i,u);if(i.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.kb(g,r),this.mb(r,u),r}ab(g){return L.MarkdownString.isMarkdownString(g)?b.MarkdownString.from(g):g}bb(g,i){return i?{...this.F.toInternal(i,g),originalId:i.command}:void 0}cb(g){if(!g.checkboxState)return;let i,u;return typeof g.checkboxState=="number"?i=g.checkboxState:(i=g.checkboxState.state,u=g.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:u}}db(g){if(!L.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,i,u){this.db(i);const r=new R.DisposableStore,c=this.gb(g,i,u),o=this.hb(i);return{item:{handle:c,parentHandle:u?u.item.handle:void 0,label:a(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(r,i.command),contextValue:i.contextValue,icon:o,iconDark:this.ib(i)||o,themeIcon:this.fb(i),collapsibleState:(0,D.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof L.ThemeIcon?g.iconPath:void 0}gb(g,{id:i,label:u,resourceUri:r},c,o){if(i)return`${y.b}/${i}`;const k=a(u,this.H),s=c?c.item.handle:y.a;let l=k?k.label:r?(0,C.basename)(r):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const v=this.j.has(g)?this.j.get(g).item.handle:void 0,S=this.Q(c)||[];let E,W=0;do{if(E=`${s}/${W}:${l}`,o||!this.i.has(E)||v===E)break;W++}while(W<=S.length);return E}hb(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon))return typeof g.iconPath=="string"||F.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return F.URI.isUri(g)?g:F.URI.file(g)}kb(g,i){this.i.set(i.item.handle,g),this.j.set(g,i)}lb(g,i,u,r){this.i.delete(i.item.handle),this.j.delete(g),i.item.handle!==u.item.handle&&this.i.delete(u.item.handle),this.kb(g,i);const c=this.Q(r)||[],o=c.filter(k=>k.item.handle===u.item.handle)[0];o&&c.splice(c.indexOf(o),1,i)}mb(g,i){i?(i.children||(i.children=[]),i.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const i=this.j.get(g);if(i){if(i.children)for(const u of i.children){const r=this.i.get(u.item.handle);r&&this.ob(r)}i.children=void 0}}else this.pb()}ob(g){const i=this.j.get(g);if(i){if(i.children)for(const u of i.children){const r=this.i.get(u.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.C.$disposeTree(this.z)}}y.a="0",y.b="1"}),define(Pe[260],Ae([1,0,21,10,5,29,2,132,269,120,130,43,4,75,212,211,38,213,33,215,216,217,200,218,58,34,219,220,225,226,228,107,203,234,235,236,81,61,238,259,8,7,52,241,62,106,32,24,192,224,50,105,109,111,112,14,55,18,27,229,198,71,77,209,239,82,60,244,242,243,210,37,237,240,80,59,57,230,108,231,15,93,202,183,221,6,26,188,79,179,232,233,223,222]),function(ee,e,n,A,C,F,O,R,w,h,L,D,f,b,p,d,t,a,m,y,P,g,i,u,r,c,o,k,s,l,v,S,E,W,G,Y,J,q,U,$,z,j,he,we,ie,oe,de,ke,le,X,T,V,ce,me,Fe,be,Ee,Ie,se,ae,Z,I,M,H,x,te,pe,Ce,ue,De,Se,$e,He,et,Xe,tt,rt,Me,it,Q,_,ve,We,Be,Qe,Ye,Ge,at,Dt,Tt,It,Et,Mt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xt(ht){const gt=ht.get(se.IExtHostInitDataService),Ot=ht.get($e.IExtHostFileSystemInfo),Ut=ht.get(pe.IExtHostConsumerFileSystem),Lt=ht.get(c.IExtHostExtensionService),pt=ht.get(de.IExtHostWorkspace),Ct=ht.get(rt.IExtHostTelemetry),Pt=ht.get(m.IExtHostConfiguration),$t=ht.get(Ee.IURITransformerService),Ke=ht.get(Ie.IExtHostRpcService),Wt=ht.get(J.IExtHostStorage),Te=ht.get(te.IExtensionStoragePaths),Oe=ht.get(be.ILoggerService),fe=ht.get(be.ILogService),K=ht.get(I.IExtHostTunnelService),Re=ht.get(M.IExtHostApiDeprecationService),ze=ht.get(oe.IExtHostWindow),Ze=ht.get(Xe.IExtHostSecretState),xe=ht.get(tt.IExtHostEditorTabs);Ke.set(f.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Oe),Ke.set(f.ExtHostContext.ExtHostWorkspace,pt),Ke.set(f.ExtHostContext.ExtHostConfiguration,Pt),Ke.set(f.ExtHostContext.ExtHostExtensionService,Lt),Ke.set(f.ExtHostContext.ExtHostStorage,Wt),Ke.set(f.ExtHostContext.ExtHostTunnelService,K),Ke.set(f.ExtHostContext.ExtHostWindow,ze),Ke.set(f.ExtHostContext.ExtHostSecretState,Ze),Ke.set(f.ExtHostContext.ExtHostTelemetry,Ct),Ke.set(f.ExtHostContext.ExtHostEditorTabs,xe);const ot=Ke.set(f.ExtHostContext.ExtHostDecorations,ht.get(V.IExtHostDecorations)),ft=Ke.set(f.ExtHostContext.ExtHostDocumentsAndEditors,ht.get(r.IExtHostDocumentsAndEditors)),mt=Ke.set(f.ExtHostContext.ExtHostCommands,ht.get(t.IExtHostCommands)),lt=Ke.set(f.ExtHostContext.ExtHostTerminalService,ht.get(q.IExtHostTerminalService)),ct=Ke.set(f.ExtHostContext.ExtHostDebugService,ht.get(me.IExtHostDebugService)),bt=Ke.set(f.ExtHostContext.ExtHostSearch,ht.get(Fe.IExtHostSearch)),kt=Ke.set(f.ExtHostContext.ExtHostTask,ht.get(ce.IExtHostTask)),Ht=Ke.set(f.ExtHostContext.ExtHostOutputService,ht.get(S.IExtHostOutputService)),Nt=Ke.set(f.ExtHostContext.ExtHostLocalization,ht.get(Dt.IExtHostLocalizationService)),ai=Ke.set(f.ExtHostContext.ExtHostUrls,new we.ExtHostUrls(Ke)),At=Ke.set(f.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ke,ft)),yi=Ke.set(f.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Ke,ft,fe)),ci=Ke.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(fe,At,Ke.getProxy(f.MainContext.MainThreadBulkEdits))),yt=Ke.set(f.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,mt,ft,At)),ui=Ke.set(f.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(yt)),li=Ke.set(f.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(fe,yt)),Zt=Ke.set(f.ExtHostContext.ExtHostNotebookKernels,new Me.ExtHostNotebookKernels(Ke,gt,yt,mt,fe)),Di=Ke.set(f.ExtHostContext.ExtHostNotebookRenderers,new Q.ExtHostNotebookRenderers(Ke,yt)),wt=Ke.set(f.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ke,ft)),di=Ke.set(f.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ke.getProxy(f.MainContext.MainThreadTreeViews),mt,fe)),zi=Ke.set(f.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ke.getProxy(f.MainContext.MainThreadEditorInsets),wt,gt.remote)),ei=Ke.set(f.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Ke,fe,Ot,ft)),ii=Ke.set(f.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ke,At,mt.converter,$t)),dt=Ke.set(f.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Ke,$t,At,mt,ei,fe,Re,Ct)),ti=Ke.set(f.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Ke,dt)),jt=Ke.set(f.ExtHostContext.ExtHostFileSystemEventService,new k.ExtHostFileSystemEventService(Ke,fe,ft)),Qt=Ke.set(f.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ke,pt,mt)),hi=Ke.set(f.ExtHostContext.ExtHostSCM,new G.ExtHostSCM(Ke,mt,fe)),Ii=Ke.set(f.ExtHostContext.ExtHostQuickDiff,new Et.ExtHostQuickDiff(Ke,$t)),Ci=Ke.set(f.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ke,mt,At)),fi=Ke.set(f.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ke.getProxy(f.MainContext.MainThreadProgress))),ki=Ke.set(f.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Ke)),mi=Ke.set(f.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ke)),gi=Ke.set(f.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Ke)),Ti=Ke.set(f.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Ke,mt)),ni=Ke.set(f.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ke,gt.remote,pt,fe,Re)),ri=Ke.set(f.ExtHostContext.ExtHostWebviewPanels,new De.ExtHostWebviewPanels(Ke,ni,pt)),Pi=Ke.set(f.ExtHostContext.ExtHostCustomEditors,new ue.ExtHostCustomEditors(Ke,At,Te,ni,ri)),Bi=Ke.set(f.ExtHostContext.ExtHostWebviewViews,new Ce.ExtHostWebviewViews(Ke,ni)),Yt=Ke.set(f.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ke,mt,ft)),Ai=Ke.set(f.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Ke)),Wi=Ke.set(f.ExtHostContext.ExtHostProfileContentHandlers,new It.ExtHostProfileContentHandlers(Ke));Ke.set(f.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(Ke,yt,ft,mt,fe));const Hi=Ke.set(f.ExtHostContext.ExtHostInteractiveEditor,new Bt.ExtHostInteractiveEditor(Ke,At,fe)),Ni=Ke.set(f.ExtHostContext.ExtHostInteractiveSession,new Mt.ExtHostInteractiveSession(Ke,fe)),Vi=Object.values(f.ExtHostContext);Ke.assertRegistered(Vi);const ji=new Se.ExtHostBulkEdits(Ke,ft),qi=new d.ExtHostClipboard(Ke),si=new v.ExtHostMessageService(Ke,fe),pi=new P.ExtHostDialogs(Ke),Fi=new Y.ExtHostStatusBar(Ke,mt.converter);return p.ExtHostApiCommands.register(mt),function(Ue,xt,oi){const vt=function(){let re=!Ue.isUnderDevelopment;function ge(){re||(fe.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Ne(nt){if(Array.isArray(nt))nt.forEach(Ne);else if(typeof nt=="string")ge();else{const St=nt;typeof St.scheme>"u"&&ge(),typeof St.exclusive=="boolean"&&(0,Ge.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return nt}}(),xi={getSession(re,ge,Ne){return gi.getSession(Ue,re,ge,Ne)},async hasSession(re,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"authSession"),!!await gi.getSession(Ue,re,ge,{silent:!0})},get onDidChangeSessions(){return gi.onDidChangeSessions},registerAuthenticationProvider(re,ge,Ne,nt){return gi.registerAuthenticationProvider(re,ge,Ne,nt)}},Ki={registerCommand(re,ge,Ne){return mt.registerCommand(!0,re,ge,Ne,void 0,Ue)},registerTextEditorCommand(re,ge,Ne){return mt.registerCommand(!0,re,(...nt)=>{const St=wt.getActiveTextEditor();if(!St){fe.warn("Cannot execute "+re+" because there is no active text editor.");return}return St.edit(Rt=>{ge.apply(Ne,[St,Rt,...nt])}).then(Rt=>{Rt||fe.warn("Edits from command "+re+" were not applied.")},Rt=>{fe.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,ge,Ne)=>((0,Ge.checkProposedApiEnabled)(Ue,"diffCommand"),mt.registerCommand(!0,re,async(...nt)=>{const St=ft.activeEditor(!0);if(!St){fe.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await wt.getDiffInformation(St.id);ge.apply(Ne,[Rt,...nt])},void 0,void 0,Ue)),executeCommand(re,...ge){return mt.executeCommand(re,...ge)},getCommands(re=!1){return mt.getCommands(re)}},Mi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return qi.value},get shell(){return lt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ge.checkProposedApiEnabled)(Ue,"envShellEvent"),lt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re){return rt.ExtHostTelemetryLogger.validateSender(re),Ct.instantiateLogger(Ue,re)},openExternal(re,ge){return ze.openUri(re,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===gt.environment.appUriScheme)return ai.createAppUri(re);try{return await ze.asExternalUri(re,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,ve.matchesScheme)(re,_.Schemas.http)||(0,ve.matchesScheme)(re,_.Schemas.https))return re;throw ge}},get remoteName(){return(0,T.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return fe.getLevel()},get onDidChangeLogLevel(){return fe.onDidChangeLogLevel}};gt.environment.extensionTestsLocationURI||Object.freeze(Mi);const Ri={createTestController(re,ge,Ne){return Yt.createTestController(Ue,re,ge,Ne)},createTestObserver(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.createTestObserver()},runTests(re){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.runTests(re)},get onDidChangeTestResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.results}},vi=gt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Kt={getExtension(re,ge){(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")||(ge=!1);const Ne=xt.mine.getExtensionDescription(re);if(Ne)return new c.Extension(Lt,Ue.identifier,Ne,vi,!1);if(ge){const nt=xt.all.getExtensionDescription(re);if(nt)return new c.Extension(Lt,Ue.identifier,nt,vi,!0)}},get all(){const re=[];for(const ge of xt.mine.getAllExtensionDescriptions())re.push(new c.Extension(Lt,Ue.identifier,ge,vi,!1));return re},get allAcrossExtensionHosts(){(0,Ge.checkProposedApiEnabled)(Ue,"extensionsAny");const re=new ke.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ge=[];for(const Ne of xt.all.getAllExtensionDescriptions()){const nt=!re.has(Ne.identifier);ge.push(new c.Extension(Lt,Ue.identifier,Ne,vi,nt))}return ge},get onDidChange(){return(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},bi={createDiagnosticCollection(re){return ei.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:re=>ei.getDiagnostics(re),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(re,ge){return ii.changeLanguage(re.uri,ge)},match(re,ge){const Ne=At.getDocumentData(ge.uri)?.notebook;return(0,L.score)(z.LanguageSelector.from(re),ge.uri,ge.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(re,ge,Ne){return dt.registerCodeActionProvider(Ue,vt(re),ge,Ne)},registerDocumentPasteEditProvider(re,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,vt(re),ge,Ne)},registerCodeLensProvider(re,ge){return dt.registerCodeLensProvider(Ue,vt(re),ge)},registerDefinitionProvider(re,ge){return dt.registerDefinitionProvider(Ue,vt(re),ge)},registerDeclarationProvider(re,ge){return dt.registerDeclarationProvider(Ue,vt(re),ge)},registerImplementationProvider(re,ge){return dt.registerImplementationProvider(Ue,vt(re),ge)},registerTypeDefinitionProvider(re,ge){return dt.registerTypeDefinitionProvider(Ue,vt(re),ge)},registerHoverProvider(re,ge){return dt.registerHoverProvider(Ue,vt(re),ge,Ue.identifier)},registerEvaluatableExpressionProvider(re,ge){return dt.registerEvaluatableExpressionProvider(Ue,vt(re),ge,Ue.identifier)},registerInlineValuesProvider(re,ge){return dt.registerInlineValuesProvider(Ue,vt(re),ge,Ue.identifier)},registerDocumentHighlightProvider(re,ge){return dt.registerDocumentHighlightProvider(Ue,vt(re),ge)},registerLinkedEditingRangeProvider(re,ge){return dt.registerLinkedEditingRangeProvider(Ue,vt(re),ge)},registerReferenceProvider(re,ge){return dt.registerReferenceProvider(Ue,vt(re),ge)},registerRenameProvider(re,ge){return dt.registerRenameProvider(Ue,vt(re),ge)},registerDocumentSymbolProvider(re,ge,Ne){return dt.registerDocumentSymbolProvider(Ue,vt(re),ge,Ne)},registerWorkspaceSymbolProvider(re){return dt.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,ge){return dt.registerDocumentFormattingEditProvider(Ue,vt(re),ge)},registerDocumentRangeFormattingEditProvider(re,ge){return dt.registerDocumentRangeFormattingEditProvider(Ue,vt(re),ge)},registerOnTypeFormattingEditProvider(re,ge,Ne,...nt){return dt.registerOnTypeFormattingEditProvider(Ue,vt(re),ge,[Ne].concat(nt))},registerDocumentSemanticTokensProvider(re,ge,Ne){return dt.registerDocumentSemanticTokensProvider(Ue,vt(re),ge,Ne)},registerDocumentRangeSemanticTokensProvider(re,ge,Ne){return dt.registerDocumentRangeSemanticTokensProvider(Ue,vt(re),ge,Ne)},registerSignatureHelpProvider(re,ge,Ne,...nt){return typeof Ne=="object"?dt.registerSignatureHelpProvider(Ue,vt(re),ge,Ne):dt.registerSignatureHelpProvider(Ue,vt(re),ge,typeof Ne>"u"?[]:[Ne,...nt])},registerCompletionItemProvider(re,ge,...Ne){return dt.registerCompletionItemProvider(Ue,vt(re),ge,Ne)},registerInlineCompletionItemProvider(re,ge){return ge.handleDidShowCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,vt(re),ge)},registerDocumentLinkProvider(re,ge){return dt.registerDocumentLinkProvider(Ue,vt(re),ge)},registerColorProvider(re,ge){return dt.registerColorProvider(Ue,vt(re),ge)},registerFoldingRangeProvider(re,ge){return dt.registerFoldingRangeProvider(Ue,vt(re),ge)},registerSelectionRangeProvider(re,ge){return dt.registerSelectionRangeProvider(Ue,re,ge)},registerCallHierarchyProvider(re,ge){return dt.registerCallHierarchyProvider(Ue,re,ge)},registerTypeHierarchyProvider(re,ge){return dt.registerTypeHierarchyProvider(Ue,re,ge)},setLanguageConfiguration:(re,ge)=>dt.setLanguageConfiguration(Ue,re,ge),getTokenInformationAtPosition(re,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"tokenInformation"),ii.tokenAtPosition(re,ge)},registerInlayHintsProvider(re,ge){return dt.registerInlayHintsProvider(Ue,re,ge)},createLanguageStatusItem(re,ge){return ii.createLanguageStatusItem(Ue,re,ge)},registerDocumentDropEditProvider(re,ge){return dt.registerDocumentOnDropEditProvider(Ue,re,ge)}},Gi={get activeTextEditor(){return wt.getActiveTextEditor()},get visibleTextEditors(){return wt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(re,ge,Ne){const nt=await(O.URI.isUri(re)?Promise.resolve(zt.openTextDocument(re)):Promise.resolve(re));return wt.showTextDocument(nt,ge,Ne)},createTextEditorDecorationType(re){return wt.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,ge,Ne){return wt.onDidChangeActiveTextEditor(re,ge,Ne)},onDidChangeVisibleTextEditors(re,ge,Ne){return wt.onDidChangeVisibleTextEditors(re,ge,Ne)},onDidChangeTextEditorSelection(re,ge,Ne){return wt.onDidChangeTextEditorSelection(re,ge,Ne)},onDidChangeTextEditorOptions(re,ge,Ne){return wt.onDidChangeTextEditorOptions(re,ge,Ne)},onDidChangeTextEditorVisibleRanges(re,ge,Ne){return wt.onDidChangeTextEditorVisibleRanges(re,ge,Ne)},onDidChangeTextEditorViewColumn(re,ge,Ne){return wt.onDidChangeTextEditorViewColumn(re,ge,Ne)},onDidCloseTerminal(re,ge,Ne){return lt.onDidCloseTerminal(re,ge,Ne)},onDidOpenTerminal(re,ge,Ne){return lt.onDidOpenTerminal(re,ge,Ne)},onDidChangeActiveTerminal(re,ge,Ne){return lt.onDidChangeActiveTerminal(re,ge,Ne)},onDidChangeTerminalDimensions(re,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDimensions"),lt.onDidChangeTerminalDimensions(re,ge,Ne)},onDidChangeTerminalState(re,ge,Ne){return lt.onDidChangeTerminalState(re,ge,Ne)},onDidWriteTerminalData(re,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(re,ge,Ne)},get state(){return ze.state},onDidChangeWindowState(re,ge,Ne){return ze.onDidChangeWindowState(re,ge,Ne)},showInformationMessage(re,...ge){return si.showMessage(Ue,F.default.Info,re,ge[0],ge.slice(1))},showWarningMessage(re,...ge){return si.showMessage(Ue,F.default.Warning,re,ge[0],ge.slice(1))},showErrorMessage(re,...ge){return si.showMessage(Ue,F.default.Error,re,ge[0],ge.slice(1))},showQuickPick(re,ge,Ne){return Qt.showQuickPick(Ue,re,ge,Ne)},showWorkspaceFolderPick(re){return Qt.showWorkspaceFolderPick(re)},showInputBox(re,ge){return Qt.showInput(re,ge)},showOpenDialog(re){return pi.showOpenDialog(Ue,re)},showSaveDialog(re){return pi.showSaveDialog(re)},createStatusBarItem(re,ge,Ne){let nt,St,Rt;return typeof re=="string"?(nt=re,St=ge,Rt=Ne):(St=re,Rt=ge),Fi.createStatusBarEntry(Ue,nt,St,Rt)},setStatusBarMessage(re,ge){return Fi.setStatusBarMessage(re,ge)},withScmProgress(re){return Re.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(ge,Ne)=>re({report(nt){}}))},withProgress(re,ge){return fi.withProgress(Ue,re,ge)},createOutputChannel(re,ge){return Ht.createOutputChannel(re,ge,Ue)},createWebviewPanel(re,ge,Ne,nt){return ri.createWebviewPanel(Ue,re,ge,Ne,nt)},createWebviewTextEditorInset(re,ge,Ne,nt){return(0,Ge.checkProposedApiEnabled)(Ue,"editorInsets"),zi.createWebviewEditorInset(re,ge,Ne,nt,Ue)},createTerminal(re,ge,Ne){return typeof re=="object"?"pty"in re?lt.createExtensionTerminal(re):lt.createTerminalFromOptions(re):lt.createTerminal(re,ge,Ne)},registerTerminalLinkProvider(re){return lt.registerLinkProvider(re)},registerTerminalProfileProvider(re,ge){return lt.registerProfileProvider(Ue,re,ge)},registerTerminalQuickFixProvider(re,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),lt.registerTerminalQuickFixProvider(re,Ue.identifier.value,ge)},registerTreeDataProvider(re,ge){return di.registerTreeDataProvider(re,ge,Ue)},createTreeView(re,ge){return di.createTreeView(re,ge,Ue)},registerWebviewPanelSerializer:(re,ge)=>ri.registerWebviewPanelSerializer(Ue,re,ge),registerCustomEditorProvider:(re,ge,Ne={})=>Pi.registerCustomEditorProvider(Ue,re,ge,Ne),registerFileDecorationProvider(re){return ot.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return ai.registerUriHandler(Ue.identifier,re)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(re,ge,Ne){return mi.onDidChangeActiveColorTheme(re,ge,Ne)},registerWebviewViewProvider(re,ge,Ne){return Bi.registerWebviewViewProvider(Ue,re,ge,Ne?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ge,Ne){return yt.onDidChangeActiveNotebookEditor(re,ge,Ne)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,ge,Ne){return li.onDidChangeNotebookEditorSelection(re,ge,Ne)},onDidChangeNotebookEditorVisibleRanges(re,ge,Ne){return li.onDidChangeNotebookEditorVisibleRanges(re,ge,Ne)},showNotebookDocument(re,ge){return yt.showNotebookDocument(re,ge)},registerExternalUriOpener(re,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ai.registerExternalUriOpener(Ue.identifier,re,ge,Ne)},registerProfileContentHandler(re,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Wi.registrProfileContentHandler(Ue,re,ge)},registerQuickDiffProvider(re,ge,Ne,nt){return(0,Ge.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider(vt(re),ge,Ne,nt)},get tabGroups(){return xe.tabGroups}},zt={get rootPath(){return Re.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(re){throw A.readonly()},getWorkspaceFolder(re){return pt.getWorkspaceFolder(re)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(re){throw A.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(re){throw A.readonly()},updateWorkspaceFolders:(re,ge,...Ne)=>pt.updateWorkspaceFolders(Ue,re,ge||0,...Ne),onDidChangeWorkspaceFolders:function(re,ge,Ne){return pt.onDidChangeWorkspace(re,ge,Ne)},asRelativePath:(re,ge)=>pt.getRelativePath(re,ge),findFiles:(re,ge,Ne,nt)=>pt.findFiles(re,ge,Ne,Ue.identifier,nt),findTextInFiles:(re,ge,Ne,nt)=>{(0,Ge.checkProposedApiEnabled)(Ue,"findTextInFiles");let St,Rt;return typeof ge=="object"?(St=ge,Rt=Ne):(St={},Rt=ge,nt=Ne),pt.findTextInFiles(re,St||{},Rt,Ue.identifier,nt)},saveAll:re=>pt.saveAll(re),applyEdit(re,ge){return ji.applyWorkspaceEdit(re,Ue,ge)},createFileSystemWatcher:(re,ge,Ne,nt)=>jt.createFileSystemWatcher(pt,Ue,re,ge,Ne,nt),get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw A.readonly()},openTextDocument(re){let ge;const Ne=re;if(typeof re=="string")ge=Promise.resolve(O.URI.file(re));else if(O.URI.isUri(re))ge=Promise.resolve(re);else if(!Ne||typeof Ne=="object")ge=At.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(nt=>At.ensureDocumentData(nt).then(St=>St.document))},onDidOpenTextDocument:(re,ge,Ne)=>At.onDidAddDocument(re,ge,Ne),onDidCloseTextDocument:(re,ge,Ne)=>At.onDidRemoveDocument(re,ge,Ne),onDidChangeTextDocument:(re,ge,Ne)=>At.onDidChangeDocument(re,ge,Ne),onDidSaveTextDocument:(re,ge,Ne)=>At.onDidSaveDocument(re,ge,Ne),onWillSaveTextDocument:(re,ge,Ne)=>ci.getOnWillSaveTextDocumentEvent(Ue)(re,ge,Ne),get notebookDocuments(){return yt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ge){let Ne;if(O.URI.isUri(re))Ne=re,await yt.openNotebookDocument(re);else if(typeof re=="string")Ne=O.URI.revive(await yt.createNotebookDocument({viewType:re,content:ge}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(re,ge,Ne){return ui.onDidSaveNotebookDocument(re,ge,Ne)},onDidChangeNotebookDocument(re,ge,Ne){return ui.onDidChangeNotebookDocument(re,ge,Ne)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(re,ge,Ne,nt){return yt.registerNotebookSerializer(Ue,re,ge,Ne,(0,Ge.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(re,ge,Ne)=>oi.onDidChangeConfiguration(re,ge,Ne),getConfiguration(re,ge){return ge=arguments.length===1?void 0:ge,oi.getConfiguration(re,ge,Ue)},registerTextDocumentContentProvider(re,ge){return yi.registerTextDocumentContentProvider(re,ge)},registerTaskProvider:(re,ge)=>(Re.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Ue,re,ge)),registerFileSystemProvider(re,ge,Ne){return(0,Ye.combinedDisposable)(ti.registerFileSystemProvider(Ue,re,ge,Ne),Ut.addFileSystemProvider(re,ge))},get fs(){return Ut.value},registerFileSearchProvider:(re,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(re,ge)),registerTextSearchProvider:(re,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(re,ge)),registerRemoteAuthorityResolver:(re,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(re,ge)),registerResourceLabelFormatter:re=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),ki.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,ge,Ne)=>jt.onDidCreateFile(re,ge,Ne),onDidDeleteFiles:(re,ge,Ne)=>jt.onDidDeleteFile(re,ge,Ne),onDidRenameFiles:(re,ge,Ne)=>jt.onDidRenameFile(re,ge,Ne),onWillCreateFiles:(re,ge,Ne)=>jt.getOnWillCreateFileEvent(Ue)(re,ge,Ne),onWillDeleteFiles:(re,ge,Ne)=>jt.getOnWillDeleteFileEvent(Ue)(re,ge,Ne),onWillRenameFiles:(re,ge,Ne)=>jt.getOnWillRenameFileEvent(Ue)(re,ge,Ne),openTunnel:re=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),K.openTunnel(Ue,re).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),K.getTunnels()},onDidChangeTunnels:(re,ge,Ne)=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),K.onDidChangeTunnels(re,ge,Ne)),registerPortAttributesProvider:(re,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"portsAttributes"),K.registerPortsAttributesProvider(re,ge)),registerTimelineProvider:(re,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"timeline"),Ti.registerTimelineProvider(re,ge,Ue.identifier,mt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:re=>((0,Ge.checkProposedApiEnabled)(Ue,"workspaceTrust"),pt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ge,Ne)=>pt.onDidGrantWorkspaceTrust(re,ge,Ne),registerEditSessionIdentityProvider:(re,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(re,ge)),onWillCreateEditSessionIdentity:(re,ge,Ne)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),pt.getOnWillCreateEditSessionIdentityEvent(Ue)(re,ge,Ne))},Ei={get inputBox(){return Re.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Ue)},createSourceControl(re,ge,Ne){return hi.createSourceControl(Ue,re,ge,Ne)}},Xi={createCommentController(re,ge){return Ci.createCommentController(Ue,re,ge)}},Qi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(re,ge,Ne){return ct.onDidStartDebugSession(re,ge,Ne)},onDidTerminateDebugSession(re,ge,Ne){return ct.onDidTerminateDebugSession(re,ge,Ne)},onDidChangeActiveDebugSession(re,ge,Ne){return ct.onDidChangeActiveDebugSession(re,ge,Ne)},onDidReceiveDebugSessionCustomEvent(re,ge,Ne){return ct.onDidReceiveDebugSessionCustomEvent(re,ge,Ne)},onDidChangeBreakpoints(re,ge,Ne){return ct.onDidChangeBreakpoints(re,ge,Ne)},registerDebugConfigurationProvider(re,ge,Ne){return ct.registerDebugConfigurationProvider(re,ge,Ne||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ge){return ct.registerDebugAdapterDescriptorFactory(Ue,re,ge)},registerDebugAdapterTrackerFactory(re,ge){return ct.registerDebugAdapterTrackerFactory(re,ge)},startDebugging(re,ge,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?ct.startDebugging(re,ge,{parentSession:Ne}):ct.startDebugging(re,ge,Ne||{})},stopDebugging(re){return ct.stopDebugging(re)},addBreakpoints(re){return ct.addBreakpoints(re)},removeBreakpoints(re){return ct.removeBreakpoints(re)},asDebugSourceUri(re,ge){return ct.asDebugSourceUri(re,ge)}},Yi={registerTaskProvider:(re,ge)=>kt.registerTaskProvider(Ue,re,ge),fetchTasks:re=>kt.fetchTasks(re),executeTask:re=>kt.executeTask(Ue,re),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(re,ge,Ne)=>kt.onDidStartTask(re,ge,Ne),onDidEndTask:(re,ge,Ne)=>kt.onDidEndTask(re,ge,Ne),onDidStartTaskProcess:(re,ge,Ne)=>kt.onDidStartTaskProcess(re,ge,Ne),onDidEndTaskProcess:(re,ge,Ne)=>kt.onDidEndTaskProcess(re,ge,Ne)},_i={createNotebookController(re,ge,Ne,nt,St){return Zt.createNotebookController(Ue,re,ge,Ne,nt,(0,Ge.isProposedApiEnabled)(Ue,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(re,ge)=>yt.registerNotebookCellStatusBarItemProvider(Ue,re,ge),createRendererMessaging(re){return Di.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,re,ge)},onDidChangeNotebookCellExecutionState(re,ge,Ne){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(re,ge,Ne)}},Ji={t(...re){if(typeof re[0]=="string"){const ge=re.shift(),Ne=!re||typeof re[0]!="object"?re:re[0];return Nt.getMessage(Ue.identifier.value,{message:ge,args:Ne})}return Nt.getMessage(Ue.identifier.value,re[0])},get bundle(){return Nt.getBundle(Ue.identifier.value)},get uri(){return Nt.getBundleUri(Ue.identifier.value)}},Zi={_version:1,registerInteractiveEditorSessionProvider(re){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Hi.registerProvider(Ue,re)},registerInteractiveSessionProvider(re,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Ni.registerInteractiveSessionProvider(Ue,re,ge)},addInteractiveRequest(re){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Ni.addInteractiveSessionRequest(re)}};return{version:gt.version,authentication:xi,commands:Ki,comments:Xi,debug:Qi,env:Mi,extensions:Kt,interactive:Zi,l10n:Ji,languages:bi,notebooks:_i,scm:Ei,tasks:Yi,tests:Ri,window:Gi,workspace:zt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:h.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:b.UIKind,Uri:O.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:he.TelemetryTrustedValue,LogLevel:be.LogLevel,EditSessionIdentityMatch:Tt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Xt}),define(Pe[261],Ae([1,0,260,34,2,254,7,17,245]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends F.RequireInterceptor{j(){}getModule(b,p){for(const d of this.b){const t=d(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class L extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=O.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(w.ExtHostConsoleForwarder);const b=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(h,b,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(b){return b.browser}async rb(b,p,d){p=p.with({path:D(p.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const a=C.URI.revive(await this.u.$asBrowserUri(p)),m=await fetch(a.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),m.status!==200)throw new Error(m.statusText);const y=await m.text(),P=`${p.toString(!0)}#vscode-extension`,g=`${y}
//# sourceURL=${P}`;let i;try{i=new Function("module","exports","require",g)}catch(o){throw console.error(t?`Loading code for extension ${t} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${p.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}b&&await this.q.initializeLocalizedMessages(b);const u={},r={exports:u},c=o=>{const k=this.r.getModule(o,p);if(k===void 0)throw new Error(`Cannot load module '${o}'`);return k};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(r,u,c),r.exports!==u?r.exports:u}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(b){}async vb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=L;function D(f,b){return f.endsWith(b)?f:f+b}}),define(Pe[262],Ae([1,0,67,68,14,34,181,82,261]),function(ee,e,n,A,C,F,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,A.registerSingleton)(C.ILogService,new n.SyncDescriptor(O.ExtHostLogService,[!0],!0)),(0,A.registerSingleton)(F.IExtHostExtensionService,w.ExtHostExtensionService,0),(0,A.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths,0)}),define(Pe[270],Ae([1,0,25,5,75,255,247,19,83,15,2,257,262]),function(ee,e,n,A,C,F,O,R,w,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(i){return/^(file|vscode-remote):/i.test(i)}const p=fetch.bind(self);function d(i){self.fetch=async function(u,r){return u instanceof Request||b(String(u))&&(u=(await i(L.URI.parse(String(u)))).toString(!0)),p(u,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,r,c,o,k){(async()=>(b(r.toString())&&(r=(await i(L.URI.parse(r.toString()))).toString(!0)),super.open(u,r,c??!0,o,k)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(u,r){if(/^file:/i.test(u.toString()))u=h.FileAccess.uriToBrowserUri(L.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(v){function S(G){return typeof G=="string"||G instanceof URL?String(G).replace(/^file:\/\//i,"vscode-file://vscode-app"):G}const E=fetch.bind(self);self.fetch=function(G,Y){return G instanceof Request?E(G,Y):E(S(G),Y)},self.XMLHttpRequest=class extends XMLHttpRequest{open(G,Y,J,q,U){return super.open(G,S(Y),J??!0,q,U)}};const W=importScripts.bind(self);self.importScripts=(...G)=>{W(...G.map(S))},W(v)}.toString()}('${u}'))`;r=r||{},r.name=r.name||R.basename(u.toString());const k=new Blob([o],{type:"application/javascript"}),s=URL.createObjectURL(k);return new i(s,r)}}else self.Worker=class extends O.NestedWorker{constructor(i,u){super(f,i,{name:R.basename(i.toString()),...u})}};const t=new class{constructor(){this.pid=void 0}exit(i){D()}async exists(i){return!0}async realpath(i){return i}};class a{constructor(){const u=new MessageChannel,r=new A.Emitter;let c=!1;f(u.port2,[u.port2]),u.port1.onmessage=o=>{const{data:k}=o;if(!(k instanceof ArrayBuffer)){console.warn("UNKNOWN data received",k);return}const s=n.VSBuffer.wrap(new Uint8Array(k,0,k.byteLength));if((0,C.isMessageOfType)(s,2)){c=!0,y("received terminate message from renderer");return}r.fire(s)},this.protocol={onMessage:r.event,send:o=>{if(!c){const k=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);u.port1.postMessage(k,[k])}}}}}function m(i){return new Promise(u=>{const r=i.onMessage(c=>{r.dispose();const o=JSON.parse(c.toString());i.send((0,C.createMessageOfType)(0)),u({protocol:i,initData:o})});i.send((0,C.createMessageOfType)(1))})}let y=i=>D();function P(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function g(){w.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(u){!P(u)||m(i.protocol).then(r=>{w.mark("code/extHost/didWaitForInitData");const c=new F.ExtensionHostMain(r.protocol,r.initData,t,null,u.data);d(o=>c.asBrowserUri(o)),y=o=>c.terminate(o)})}}}e.create=g})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/workbench/api/worker/extensionHostWorker.js.map
