/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/errors","vs/editor/common/core/eolCounter","vs/editor/common/tokens/lineTokens","vs/base/common/buffer","vs/editor/common/encodedTokenAttributes","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/arrays","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages/nullTokenize","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],G=function(F){for(var e=[],P=0,v=F.length;P<v;P++)e[P]=K[F[P]];return e};define(K[14],G([0,1,4,2]),function(F,e,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(O){const o=O;return o?typeof o.read=="function":!1}e.isReadable=S;function U(O){const o=O;return o?[o.on,o.pause,o.resume,o.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=U;function n(O){const o=O;return o?U(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=n;function c(O,o){return new i(O,o)}e.newWriteableStream=c;class i{constructor(o,d){this.e=o,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(d=>d(o))}h(o){this.c.error.length===0?(0,P.onUnexpectedError)(o):this.c.error.slice(0).forEach(d=>d(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,d){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(o,d){if(this.a.destroyed)return;let T;switch(o){case"data":T=this.c.data;break;case"end":T=this.c.end;break;case"error":T=this.c.error;break}if(T){const y=T.indexOf(d);y>=0&&T.splice(y,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(T=>T())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function t(O,o){const d=[];let T;for(;(T=O.read())!==null;)d.push(T);return o(d)}e.consumeReadable=t;function r(O,o,d){const T=[];let y;for(;(y=O.read())!==null&&T.length<d;)T.push(y);return y===null&&T.length>0?o(T):{read:()=>{if(T.length>0)return T.shift();if(typeof y<"u"){const R=y;return y=void 0,R}return O.read()}}}e.peekReadable=r;function l(O,o){return new Promise((d,T)=>{const y=[];b(O,{onData:R=>{o&&y.push(R)},onError:R=>{o?T(R):d(void 0)},onEnd:()=>{d(o?o(y):void 0)}})})}e.consumeStream=l;function b(O,o){let d=!1;return O.on("error",T=>{d||o.onError(T)}),O.on("end",()=>{d||o.onEnd()}),O.on("data",T=>{d||o.onData(T)}),(0,v.toDisposable)(()=>d=!0)}e.listenStream=b;function k(O,o){return new Promise((d,T)=>{const y=new v.DisposableStore,R=[],h=u=>{if(R.push(u),R.length>o)return y.dispose(),O.pause(),d({stream:O,buffer:R,ended:!1})},I=u=>T(u),m=()=>d({stream:O,buffer:R,ended:!0});y.add((0,v.toDisposable)(()=>O.removeListener("error",I))),O.on("error",I),y.add((0,v.toDisposable)(()=>O.removeListener("end",m))),O.on("end",m),y.add((0,v.toDisposable)(()=>O.removeListener("data",h))),O.on("data",h)})}e.peekStream=k;function a(O,o){const d=c(o);return d.end(O),d}e.toStream=a;function f(){const O=c(()=>{throw new Error("not supported")});return O.end(),O}e.emptyStream=f;function w(O){let o=!1;return{read:()=>o?null:(o=!0,O)}}e.toReadable=w;function N(O,o,d){const T=c(d);return b(O,{onData:y=>T.write(o.data(y)),onError:y=>T.error(o.error?o.error(y):y),onEnd:()=>T.end()}),T}e.transform=N;function B(O,o,d){let T=!1;return{read:()=>{const y=o.read();return T?y:(T=!0,y!==null?d([O,y]):O)}}}e.prefixedReadable=B;function j(O,o,d){let T=!1;const y=c(d);return b(o,{onData:R=>T?y.write(R):(T=!0,y.write(d([O,R]))),onError:R=>y.error(R),onEnd:()=>{T||(T=!0,y.write(O)),y.end()}}),y}e.prefixedStream=j}),define(K[7],G([0,1,14]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const v=typeof Buffer<"u";let S,U;class n{static alloc(u){return v?new n(Buffer.allocUnsafe(u)):new n(new Uint8Array(u))}static wrap(u){return v&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new n(u)}static fromString(u,L){return!(L?.dontUseNodeBuffer||!1)&&v?new n(Buffer.from(u)):(S||(S=new TextEncoder),new n(S.encode(u)))}static fromByteArray(u){const L=n.alloc(u.length);for(let C=0,z=u.length;C<z;C++)L.buffer[C]=u[C];return L}static concat(u,L){if(typeof L>"u"){L=0;for(let p=0,$=u.length;p<$;p++)L+=u[p].byteLength}const C=n.alloc(L);let z=0;for(let p=0,$=u.length;p<$;p++){const q=u[p];C.set(q,z),z+=q.byteLength}return C}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=n.alloc(this.byteLength);return u.set(this),u}toString(){return v?this.buffer.toString():(U||(U=new TextDecoder),U.decode(this.buffer))}slice(u,L){return new n(this.buffer.subarray(u,L))}set(u,L){if(u instanceof n)this.buffer.set(u.buffer,L);else if(u instanceof Uint8Array)this.buffer.set(u,L);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),L);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return t(this.buffer,u)}writeUInt32BE(u,L){r(this.buffer,u,L)}readUInt32LE(u){return l(this.buffer,u)}writeUInt32LE(u,L){b(this.buffer,u,L)}readUInt8(u){return k(this.buffer,u)}writeUInt8(u,L){a(this.buffer,u,L)}}e.VSBuffer=n;function c(m,u){return m[u+0]<<0>>>0|m[u+1]<<8>>>0}e.readUInt16LE=c;function i(m,u,L){m[L+0]=u&255,u=u>>>8,m[L+1]=u&255}e.writeUInt16LE=i;function t(m,u){return m[u]*2**24+m[u+1]*2**16+m[u+2]*2**8+m[u+3]}e.readUInt32BE=t;function r(m,u,L){m[L+3]=u,u=u>>>8,m[L+2]=u,u=u>>>8,m[L+1]=u,u=u>>>8,m[L]=u}e.writeUInt32BE=r;function l(m,u){return m[u+0]<<0>>>0|m[u+1]<<8>>>0|m[u+2]<<16>>>0|m[u+3]<<24>>>0}e.readUInt32LE=l;function b(m,u,L){m[L+0]=u&255,u=u>>>8,m[L+1]=u&255,u=u>>>8,m[L+2]=u&255,u=u>>>8,m[L+3]=u&255}e.writeUInt32LE=b;function k(m,u){return m[u]}e.readUInt8=k;function a(m,u,L){m[L]=u}e.writeUInt8=a;function f(m){return P.consumeReadable(m,u=>n.concat(u))}e.readableToBuffer=f;function w(m){return P.toReadable(m)}e.bufferToReadable=w;function N(m){return P.consumeStream(m,u=>n.concat(u))}e.streamToBuffer=N;async function B(m){return m.ended?n.concat(m.buffer):n.concat([...m.buffer,await N(m.stream)])}e.bufferedStreamToBuffer=B;function j(m){return P.toStream(m,u=>n.concat(u))}e.bufferToStream=j;function O(m){return P.transform(m,{data:u=>typeof u=="string"?n.fromString(u):n.wrap(u)},u=>n.concat(u))}e.streamToBufferReadableStream=O;function o(m){return P.newWriteableStream(u=>n.concat(u),m)}e.newWriteableBufferStream=o;function d(m,u){return P.prefixedReadable(m,u,L=>n.concat(L))}e.prefixedBufferReadable=d;function T(m,u){return P.prefixedStream(m,u,L=>n.concat(L))}e.prefixedBufferStream=T;function y(m){let u=0,L=0,C=0;const z=new Uint8Array(Math.floor(m.length/4*3)),p=q=>{switch(L){case 3:z[C++]=u|q,L=0;break;case 2:z[C++]=u|q>>>2,u=q<<6,L=3;break;case 1:z[C++]=u|q>>>4,u=q<<4,L=2;break;default:u=q<<2,L=1}};for(let q=0;q<m.length;q++){const W=m.charCodeAt(q);if(W>=65&&W<=90)p(W-65);else if(W>=97&&W<=122)p(W-97+26);else if(W>=48&&W<=57)p(W-48+52);else if(W===43||W===45)p(62);else if(W===47||W===95)p(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${m[q]}`)}}const $=C;for(;L>0;)p(0);return n.wrap(z).slice(0,$)}e.decodeBase64=y;const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:m},u=!0,L=!1){const C=L?h:R;let z="";const p=m.byteLength%3;let $=0;for(;$<m.byteLength-p;$+=3){const q=m[$+0],W=m[$+1],Z=m[$+2];z+=C[q>>>2],z+=C[(q<<4|W>>>4)&63],z+=C[(W<<2|Z>>>6)&63],z+=C[Z&63]}if(p===1){const q=m[$+0];z+=C[q>>>2],z+=C[q<<4&63],u&&(z+="==")}else if(p===2){const q=m[$+0],W=m[$+1];z+=C[q>>>2],z+=C[(q<<4|W>>>4)&63],z+=C[W<<2&63],u&&(z+="=")}return z}e.encodeBase64=I}),define(K[15],G([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(K[5],G([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var P;(function(S){S[S.Unknown=0]="Unknown",S[S.Invalid=3]="Invalid",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(P=e.StringEOL||(e.StringEOL={}));function v(S){let U=0,n=0,c=0,i=0;for(let t=0,r=S.length;t<r;t++){const l=S.charCodeAt(t);l===13?(U===0&&(n=t),U++,t+1<r&&S.charCodeAt(t+1)===10?(i|=2,t++):i|=3,c=t+1):l===10&&(i|=1,U===0&&(n=t),U++,c=t+1)}return U===0&&(n=S.length),[U,n,S.length-c,i]}e.countEOL=v}),define(K[8],G([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var v;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(v=e.FontStyle||(e.FontStyle={}));var S;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(S=e.ColorId||(e.ColorId={}));var U;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(U=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(t){return(t&255)>>>0}static getTokenType(t){return(t&768)>>>8}static containsBalancedBrackets(t){return(t&1024)!==0}static getFontStyle(t){return(t&30720)>>>11}static getForeground(t){return(t&16744448)>>>15}static getBackground(t){return(t&4278190080)>>>24}static getClassNameFromMetadata(t){const r=this.getForeground(t);let l="mtk"+r;const b=this.getFontStyle(t);return b&1&&(l+=" mtki"),b&2&&(l+=" mtkb"),b&4&&(l+=" mtku"),b&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(t,r){const l=this.getForeground(t),b=this.getFontStyle(t);let k=`color: ${r[l]};`;b&1&&(k+="font-style: italic;"),b&2&&(k+="font-weight: bold;");let a="";return b&4&&(a+=" underline"),b&8&&(a+=" line-through"),a&&(k+=`text-decoration:${a};`),k}static getPresentationFromMetadata(t){const r=this.getForeground(t),l=this.getFontStyle(t);return{foreground:r,italic:Boolean(l&1),bold:Boolean(l&2),underline:Boolean(l&4),strikethrough:Boolean(l&8)}}}e.TokenMetadata=c}),define(K[6],G([0,1,8]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class v{static createEmpty(n,c){const i=v.defaultTokenMetadata,t=new Uint32Array(2);return t[0]=n.length,t[1]=i,new v(t,n,c)}constructor(n,c,i){this._lineTokensBrand=void 0,this.a=n,this.b=this.a.length>>>1,this.c=c,this.d=i}equals(n){return n instanceof v?this.slicedEquals(n,0,this.b):!1}slicedEquals(n,c,i){if(this.c!==n.c||this.b!==n.b)return!1;const t=c<<1,r=t+(i<<1);for(let l=t;l<r;l++)if(this.a[l]!==n.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(n){return n>0?this.a[n-1<<1]:0}getMetadata(n){return this.a[(n<<1)+1]}getLanguageId(n){const c=this.a[(n<<1)+1],i=P.TokenMetadata.getLanguageId(c);return this.d.decodeLanguageId(i)}getStandardTokenType(n){const c=this.a[(n<<1)+1];return P.TokenMetadata.getTokenType(c)}getForeground(n){const c=this.a[(n<<1)+1];return P.TokenMetadata.getForeground(c)}getClassName(n){const c=this.a[(n<<1)+1];return P.TokenMetadata.getClassNameFromMetadata(c)}getInlineStyle(n,c){const i=this.a[(n<<1)+1];return P.TokenMetadata.getInlineStyleFromMetadata(i,c)}getPresentation(n){const c=this.a[(n<<1)+1];return P.TokenMetadata.getPresentationFromMetadata(c)}getEndOffset(n){return this.a[n<<1]}findTokenIndexAtOffset(n){return v.findIndexInTokensArray(this.a,n)}inflate(){return this}sliceAndInflate(n,c,i){return new S(this,n,c,i)}static convertToEndOffset(n,c){const t=(n.length>>>1)-1;for(let r=0;r<t;r++)n[r<<1]=n[r+1<<1];n[t<<1]=c}static findIndexInTokensArray(n,c){if(n.length<=2)return 0;let i=0,t=(n.length>>>1)-1;for(;i<t;){const r=i+Math.floor((t-i)/2),l=n[r<<1];if(l===c)return r+1;l<c?i=r+1:l>c&&(t=r)}return i}withInserted(n){if(n.length===0)return this;let c=0,i=0,t="";const r=new Array;let l=0;for(;;){const b=c<this.b?this.a[c<<1]:-1,k=i<n.length?n[i]:null;if(b!==-1&&(k===null||b<=k.offset)){t+=this.c.substring(l,b);const a=this.a[(c<<1)+1];r.push(t.length,a),c++,l=b}else if(k){if(k.offset>l){t+=this.c.substring(l,k.offset);const a=this.a[(c<<1)+1];r.push(t.length,a),l=k.offset}t+=k.text,r.push(t.length,k.tokenMetadata),i++}else break}return new v(new Uint32Array(r),t,this.d)}}v.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0,e.LineTokens=v;class S{constructor(n,c,i,t){this.a=n,this.b=c,this.c=i,this.d=t,this.e=n.findTokenIndexAtOffset(c),this.f=0;for(let r=this.e,l=n.getCount();r<l&&!(n.getStartOffset(r)>=i);r++)this.f++}getMetadata(n){return this.a.getMetadata(this.e+n)}getLanguageId(n){return this.a.getLanguageId(this.e+n)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(n){return n instanceof S?this.b===n.b&&this.c===n.c&&this.d===n.d&&this.a.slicedEquals(n.a,this.e,this.f):!1}getCount(){return this.f}getForeground(n){return this.a.getForeground(this.e+n)}getEndOffset(n){const c=this.a.getEndOffset(this.e+n);return Math.min(this.c,c)-this.b+this.d}getClassName(n){return this.a.getClassName(this.e+n)}getInlineStyle(n,c){return this.a.getInlineStyle(this.e+n,c)}getPresentation(n){return this.a.getPresentation(this.e+n)}findTokenIndexAtOffset(n){return this.a.findTokenIndexAtOffset(n+this.b-this.d)-this.e}}}),define(K[16],G([0,1,6]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class v{static deleteBeginning(n,c){return n===null||n===e.EMPTY_LINE_TOKENS?n:v.delete(n,0,c)}static deleteEnding(n,c){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const i=S(n),t=i[i.length-2];return v.delete(n,c,t)}static delete(n,c,i){if(n===null||n===e.EMPTY_LINE_TOKENS||c===i)return n;const t=S(n),r=t.length>>>1;if(c===0&&t[t.length-2]===i)return e.EMPTY_LINE_TOKENS;const l=P.LineTokens.findIndexInTokensArray(t,c),b=l>0?t[l-1<<1]:0,k=t[l<<1];if(i<k){const B=i-c;for(let j=l;j<r;j++)t[j<<1]-=B;return n}let a,f;b!==c?(t[l<<1]=c,a=l+1<<1,f=c):(a=l<<1,f=b);const w=i-c;for(let B=l+1;B<r;B++){const j=t[B<<1]-w;j>f&&(t[a++]=j,t[a++]=t[(B<<1)+1],f=j)}if(a===t.length)return n;const N=new Uint32Array(a);return N.set(t.subarray(0,a),0),N.buffer}static append(n,c){if(c===e.EMPTY_LINE_TOKENS)return n;if(n===e.EMPTY_LINE_TOKENS)return c;if(n===null)return n;if(c===null)return null;const i=S(n),t=S(c),r=t.length>>>1,l=new Uint32Array(i.length+t.length);l.set(i,0);let b=i.length;const k=i[i.length-2];for(let a=0;a<r;a++)l[b++]=t[a<<1]+k,l[b++]=t[(a<<1)+1];return l.buffer}static insert(n,c,i){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const t=S(n),r=t.length>>>1;let l=P.LineTokens.findIndexInTokensArray(t,c);l>0&&t[l-1<<1]===c&&l--;for(let b=l;b<r;b++)t[b<<1]+=i;return n}}e.ContiguousTokensEditing=v;function S(U){return U instanceof Uint32Array?U:new Uint32Array(U)}e.toUint32Array=S}),define(K[17],G([0,1,18,7,30,5,16]),function(F,e,P,v,S,U,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class c{static deserialize(t,r,l){const b=new Uint32Array(t.buffer),k=(0,v.readUInt32BE)(t,r);r+=4;const a=(0,v.readUInt32BE)(t,r);r+=4;const f=[];for(let w=0;w<a;w++){const N=(0,v.readUInt32BE)(t,r);r+=4,f.push(b.subarray(r/4,r/4+N/4)),r+=N}return l.push(new c(k,f)),r}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(t,r){this.a=t,this.b=r}getLineTokens(t){return this.b[t-this.a]}appendLineTokens(t){this.b.push(t)}serializeSize(){let t=0;t+=4,t+=4;for(let r=0;r<this.b.length;r++){const l=this.b[r];if(!(l instanceof Uint32Array))throw new Error("Not supported!");t+=4,t+=l.byteLength}return t}serialize(t,r){(0,v.writeUInt32BE)(t,this.a,r),r+=4,(0,v.writeUInt32BE)(t,this.b.length,r),r+=4;for(let l=0;l<this.b.length;l++){const b=this.b[l];if(!(b instanceof Uint32Array))throw new Error("Not supported!");(0,v.writeUInt32BE)(t,b.byteLength,r),r+=4,t.set(new Uint8Array(b.buffer),r),r+=b.byteLength}return r}applyEdit(t,r){const[l,b]=(0,U.countEOL)(r);this.c(t),this.d(new S.Position(t.startLineNumber,t.startColumn),l,b)}c(t){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return;const r=t.startLineNumber-this.a,l=t.endLineNumber-this.a;if(l<0){const b=l-r;this.a-=b;return}if(!(r>=this.b.length)){if(r<0&&l>=this.b.length){this.a=0,this.b=[];return}if(r===l){this.b[r]=n.ContiguousTokensEditing.delete(this.b[r],t.startColumn-1,t.endColumn-1);return}if(r>=0)if(this.b[r]=n.ContiguousTokensEditing.deleteEnding(this.b[r],t.startColumn-1),l<this.b.length){const b=n.ContiguousTokensEditing.deleteBeginning(this.b[l],t.endColumn-1);this.b[r]=n.ContiguousTokensEditing.append(this.b[r],b),this.b.splice(r+1,l-r)}else this.b[r]=n.ContiguousTokensEditing.append(this.b[r],null),this.b=this.b.slice(0,r+1);else{const b=-r;this.a-=b,this.b[l]=n.ContiguousTokensEditing.deleteBeginning(this.b[l],t.endColumn-1),this.b=this.b.slice(l)}}}d(t,r,l){if(r===0&&l===0)return;const b=t.lineNumber-this.a;if(b<0){this.a+=r;return}if(!(b>=this.b.length)){if(r===0){this.b[b]=n.ContiguousTokensEditing.insert(this.b[b],t.column-1,l);return}this.b[b]=n.ContiguousTokensEditing.deleteEnding(this.b[b],t.column-1),this.b[b]=n.ContiguousTokensEditing.insert(this.b[b],t.column-1,l),this.e(t.lineNumber,r)}}e(t,r){if(r===0)return;const l=[];for(let b=0;b<r;b++)l[b]=null;this.b=P.arrayInsert(this.b,t,l)}}e.ContiguousMultilineTokens=c}),define(K[9],G([0,1,7,17]),function(F,e,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class S{static deserialize(n){let c=0;const i=(0,P.readUInt32BE)(n,c);c+=4;const t=[];for(let r=0;r<i;r++)c=v.ContiguousMultilineTokens.deserialize(n,c,t);return t}constructor(){this.a=[]}add(n,c){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===n){i.appendLineTokens(c);return}}this.a.push(new v.ContiguousMultilineTokens(n,[c]))}finalize(){return this.a}serialize(){const n=this.b(),c=new Uint8Array(n);return this.c(c),c}b(){let n=0;n+=4;for(let c=0;c<this.a.length;c++)n+=this.a[c].serializeSize();return n}c(n){let c=0;(0,P.writeUInt32BE)(n,this.a.length,c),c+=4;for(let i=0;i<this.a.length;i++)c=this.a[i].serialize(n,c)}}e.ContiguousMultilineTokensBuilder=S}),define(K[19],G([0,1,20,3,21,31]),function(F,e,P,v,S,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(h){return h===47||h===92}e.isPathSeparator=n;function c(h){return h.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=c;function i(h){return h.indexOf("/")===-1&&(h=c(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=i;function t(h,I=P.posix.sep){if(!h)return"";const m=h.length,u=h.charCodeAt(0);if(n(u)){if(n(h.charCodeAt(1))&&!n(h.charCodeAt(2))){let C=3;const z=C;for(;C<m&&!n(h.charCodeAt(C));C++);if(z!==C&&!n(h.charCodeAt(C+1))){for(C+=1;C<m;C++)if(n(h.charCodeAt(C)))return h.slice(0,C+1).replace(/[\\/]/g,I)}}return I}else if(N(u)&&h.charCodeAt(1)===58)return n(h.charCodeAt(2))?h.slice(0,2)+I:h.slice(0,2);let L=h.indexOf("://");if(L!==-1){for(L+=3;L<m;L++)if(n(h.charCodeAt(L)))return h.slice(0,L+1)}return""}e.getRoot=t;function r(h){if(!v.isWindows||!h||h.length<5)return!1;let I=h.charCodeAt(0);if(I!==92||(I=h.charCodeAt(1),I!==92))return!1;let m=2;const u=m;for(;m<h.length&&(I=h.charCodeAt(m),I!==92);m++);return!(u===m||(I=h.charCodeAt(m+1),isNaN(I)||I===92))}e.isUNC=r;const l=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(h,I=v.isWindows){const m=I?l:b;return!(!h||h.length===0||/^\s+$/.test(h)||(m.lastIndex=0,m.test(h))||I&&k.test(h)||h==="."||h===".."||I&&h[h.length-1]==="."||I&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=a;function f(h,I,m){const u=h===I;return!m||u?u:!h||!I?!1:(0,S.equalsIgnoreCase)(h,I)}e.isEqual=f;function w(h,I,m,u=P.sep){if(h===I)return!0;if(!h||!I||I.length>h.length)return!1;if(m){if(!(0,S.startsWithIgnoreCase)(h,I))return!1;if(I.length===h.length)return!0;let C=I.length;return I.charAt(I.length-1)===u&&C--,h.charAt(C)===u}return I.charAt(I.length-1)!==u&&(I+=u),h.indexOf(I)===0}e.isEqualOrParent=w;function N(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=N;function B(h,I){return v.isWindows&&h.endsWith(":")&&(h+=P.sep),(0,P.isAbsolute)(h)||(h=(0,P.join)(I,h)),h=(0,P.normalize)(h),v.isWindows?(h=(0,S.rtrim)(h,P.sep),h.endsWith(":")&&(h+=P.sep)):(h=(0,S.rtrim)(h,P.sep),h||(h=P.sep)),h}e.sanitizeFilePath=B;function j(h){const I=(0,P.normalize)(h);return v.isWindows?h.length>3?!1:O(I)&&(h.length===2||I.charCodeAt(2)===92):I===P.posix.sep}e.isRootOrDriveLetter=j;function O(h,I=v.isWindows){return I?N(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=O;function o(h){return O(h)?h[0]:void 0}e.getDriveLetter=o;function d(h,I,m){return I.length>h.length?-1:h===I?0:(m&&(h=h.toLowerCase(),I=I.toLowerCase()),h.indexOf(I))}e.indexOfPath=d;function T(h){const I=h.split(":");let m,u,L;for(const C of I){const z=Number(C);(0,U.isNumber)(z)?u===void 0?u=z:L===void 0&&(L=z):m=m?[m,C].join(":"):C}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:u!==void 0?u:void 0,column:L!==void 0?L:u!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function R(h,I,m=8){let u="";for(let C=0;C<m;C++)u+=y.charAt(Math.floor(Math.random()*y.length));let L;return I?L=`${I}-${u}`:L=u,h?(0,P.join)(h,L):L}e.randomPath=R}),define(K[22],G([0,1,4,3,10]),function(F,e,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var U;(function(t){t.inMemory="inmemory",t.vscode="vscode",t.internal="private",t.walkThrough="walkThrough",t.walkThroughSnippet="walkThroughSnippet",t.http="http",t.https="https",t.file="file",t.mailto="mailto",t.untitled="untitled",t.data="data",t.command="command",t.vscodeRemote="vscode-remote",t.vscodeRemoteResource="vscode-remote-resource",t.vscodeUserData="vscode-userdata",t.vscodeCustomEditor="vscode-custom-editor",t.vscodeNotebookCell="vscode-notebook-cell",t.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",t.vscodeNotebookCellOutput="vscode-notebook-cell-output",t.vscodeInteractive="vscode-interactive",t.vscodeInteractiveInput="vscode-interactive-input",t.vscodeSettings="vscode-settings",t.vscodeWorkspaceTrust="vscode-workspace-trust",t.vscodeTerminal="vscode-terminal",t.webviewPanel="webview-panel",t.vscodeWebview="vscode-webview",t.extension="extension",t.vscodeFileResource="vscode-file",t.tmp="tmp",t.vsls="vsls",t.vscodeSourceControl="vscode-scm"})(U=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class n{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r){this.f=`${r}/${U.vscodeRemoteResource}`}set(r,l,b){this.a[r]=l,this.b[r]=b}setConnectionToken(r,l){this.c[r]=l}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(w){return P.onUnexpectedError(w),r}const l=r.authority;let b=this.a[l];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const k=this.b[l],a=this.c[l];let f=`path=${encodeURIComponent(r.path)}`;return typeof a=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(a)}`),S.URI.from({scheme:v.isWeb?this.d:U.vscodeRemoteResource,authority:`${b}:${k}`,path:this.f,query:f})}}e.RemoteAuthorities=new n,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class c{asBrowserUri(r){const l=this.b(r,F);return this.uriToBrowserUri(l)}uriToBrowserUri(r){return r.scheme===U.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===U.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${U.vscodeFileResource}://${c.a}`)?r.with({scheme:U.vscodeFileResource,authority:r.authority||c.a,query:null,fragment:null}):r}asFileUri(r){const l=this.b(r,F);return this.uriToFileUri(l)}uriToFileUri(r){return r.scheme===U.vscodeFileResource?r.with({scheme:U.file,authority:r.authority!==c.a?r.authority:null,query:null,fragment:null}):r}b(r,l){return S.URI.isUri(r)?r:S.URI.parse(l.toUrl(r))}}c.a="vscode-app",e.FileAccess=new c;var i;(function(t){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);t.CoopAndCoep=Object.freeze(r.get("3"));const l="vscode-coi";function b(a){let f;typeof a=="string"?f=new URL(a).searchParams:a instanceof URL?f=a.searchParams:S.URI.isUri(a)&&(f=new URL(a.toString(!0)).searchParams);const w=f?.get(l);if(!!w)return r.get(w)}t.getHeadersFromQuery=b;function k(a,f,w){if(!globalThis.crossOriginIsolated)return;const N=f&&w?"3":w?"2":"1";a instanceof URLSearchParams?a.set(l,N):a[l]=N}t.addSearchParam=k})(i=e.COI||(e.COI={}))}),define(K[11],G([0,1,19,22,20,3,21,10]),function(F,e,P,v,S,U,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function i(k){return(0,c.uriToFsPath)(k,!0)}e.originalFSPath=i;class t{constructor(a){this.a=a}compare(a,f,w=!1){return a===f?0:(0,n.compare)(this.getComparisonKey(a,w),this.getComparisonKey(f,w))}isEqual(a,f,w=!1){return a===f?!0:!a||!f?!1:this.getComparisonKey(a,w)===this.getComparisonKey(f,w)}getComparisonKey(a,f=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,f,w=!1){if(a.scheme===f.scheme){if(a.scheme===v.Schemas.file)return P.isEqualOrParent(i(a),i(f),this.a(a))&&a.query===f.query&&(w||a.fragment===f.fragment);if((0,e.isEqualAuthority)(a.authority,f.authority))return P.isEqualOrParent(a.path,f.path,this.a(a),"/")&&a.query===f.query&&(w||a.fragment===f.fragment)}return!1}joinPath(a,...f){return c.URI.joinPath(a,...f)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return S.posix.basename(a.path)}extname(a){return S.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let f;return a.scheme===v.Schemas.file?f=c.URI.file(S.dirname(i(a))).path:(f=S.posix.dirname(a.path),a.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),f="/")),a.with({path:f})}normalizePath(a){if(!a.path.length)return a;let f;return a.scheme===v.Schemas.file?f=c.URI.file(S.normalize(i(a))).path:f=S.posix.normalize(a.path),a.with({path:f})}relativePath(a,f){if(a.scheme!==f.scheme||!(0,e.isEqualAuthority)(a.authority,f.authority))return;if(a.scheme===v.Schemas.file){const B=S.relative(i(a),i(f));return U.isWindows?P.toSlashes(B):B}let w=a.path||"/";const N=f.path||"/";if(this.a(a)){let B=0;for(const j=Math.min(w.length,N.length);B<j&&!(w.charCodeAt(B)!==N.charCodeAt(B)&&w.charAt(B).toLowerCase()!==N.charAt(B).toLowerCase());B++);w=N.substr(0,B)+w.substr(B)}return S.posix.relative(w,N)}resolvePath(a,f){if(a.scheme===v.Schemas.file){const w=c.URI.file(S.resolve(i(a),f));return a.with({authority:w.authority,path:w.path})}return f=P.toPosixPath(f),a.with({path:S.posix.resolve(a.path,f)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,f){return a===f||a!==void 0&&f!==void 0&&(0,n.equalsIgnoreCase)(a,f)}hasTrailingPathSeparator(a,f=S.sep){if(a.scheme===v.Schemas.file){const w=i(a);return w.length>P.getRoot(w).length&&w[w.length-1]===f}else{const w=a.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,f=S.sep){return(0,e.hasTrailingPathSeparator)(a,f)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,f=S.sep){let w=!1;if(a.scheme===v.Schemas.file){const N=i(a);w=N!==void 0&&N.length===P.getRoot(N).length&&N[N.length-1]===f}else{f="/";const N=a.path;w=N.length===1&&N.charCodeAt(N.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(a,f)?a.with({path:a.path+"/"}):a}}e.ExtUri=t,e.extUri=new t(()=>!1),e.extUriBiasedIgnorePathCase=new t(k=>k.scheme===v.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new t(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(k,a){const f=[];for(let w=0;w<k.length;w++){const N=a(k[w]);k.some((B,j)=>j===w?!1:(0,e.isEqualOrParent)(N,a(B)))||f.push(k[w])}return f}e.distinctParents=r;var l;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function a(f){const w=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(j=>{const[O,o]=j.split(":");O&&o&&w.set(O,o)});const B=f.path.substring(0,f.path.indexOf(";"));return B&&w.set(k.META_DATA_MIME,B),w}k.parseMetaData=a})(l=e.DataUri||(e.DataUri={}));function b(k,a,f){if(a){let w=k.path;return w&&w[0]!==S.posix.sep&&(w=S.posix.sep+w),k.with({scheme:f,authority:a,path:w})}return k.with({scheme:f})}e.toLocalResource=b}),define(K[12],G([0,1,32,4,23,2,11,3,15]),function(F,e,P,v,S,U,n,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function t(A){return!!A&&typeof A.then=="function"}e.isThenable=t;function r(A){const s=new P.CancellationTokenSource,g=A(s.token),E=new Promise((M,D)=>{const _=s.token.onCancellationRequested(()=>{_.dispose(),s.dispose(),D(new v.CancellationError)});Promise.resolve(g).then(Y=>{_.dispose(),s.dispose(),M(Y)},Y=>{_.dispose(),s.dispose(),D(Y)})});return new class{cancel(){s.cancel()}then(M,D){return E.then(M,D)}catch(M){return this.then(void 0,M)}finally(M){return E.finally(M)}}}e.createCancelablePromise=r;function l(A,s,g){return new Promise((E,M)=>{const D=s.onCancellationRequested(()=>{D.dispose(),E(g)});A.then(E,M).finally(()=>D.dispose())})}e.raceCancellation=l;function b(A,s){return new Promise((g,E)=>{const M=s.onCancellationRequested(()=>{M.dispose(),E(new v.CancellationError)});A.then(g,E).finally(()=>M.dispose())})}e.raceCancellationError=b;async function k(A){let s=-1;const g=A.map((M,D)=>M.then(_=>(s=D,_))),E=await Promise.race(g);return A.forEach((M,D)=>{D!==s&&M.cancel()}),E}e.raceCancellablePromises=k;function a(A,s,g){let E;const M=setTimeout(()=>{E?.(void 0),g?.()},s);return Promise.race([A.finally(()=>clearTimeout(M)),new Promise(D=>E=D)])}e.raceTimeout=a;function f(A){return new Promise((s,g)=>{const E=A();t(E)?E.then(s,g):s(E)})}e.asPromise=f;class w{constructor(){this.a=null,this.b=null,this.d=null}queue(s){if(this.a){if(this.d=s,!this.b){const g=()=>{this.b=null;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(g,g).then(E)})}return new Promise((g,E)=>{this.b.then(g,E)})}return this.a=s(),new Promise((g,E)=>{this.a.then(M=>{this.a=null,g(M)},M=>{this.a=null,E(M)})})}}e.Throttler=w;class N{constructor(){this.a=Promise.resolve(null)}queue(s){return this.a=this.a.then(()=>s(),()=>s())}}e.Sequencer=N;class B{constructor(){this.a=new Map}queue(s,g){const M=(this.a.get(s)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(s)===M&&this.a.delete(s)});return this.a.set(s,M),M}}e.SequencerByKey=B;const j=(A,s)=>{let g=!0;const E=setTimeout(()=>{g=!1,s()},A);return{isTriggered:()=>g,dispose:()=>{clearTimeout(E),g=!1}}},O=A=>{let s=!0;return queueMicrotask(()=>{s&&(s=!1,A())}),{isTriggered:()=>s,dispose:()=>{s=!1}}};class o{constructor(s){this.defaultDelay=s,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(s,g=this.defaultDelay){this.g=s,this.h(),this.b||(this.b=new Promise((M,D)=>{this.d=M,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=g===i.MicrotaskDelay?O(E):j(g,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new v.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=o;class d{constructor(s){this.a=new o(s),this.b=new w}trigger(s,g){return this.a.trigger(()=>this.b.queue(s),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=d;class T{constructor(){this.a=!1,this.b=new Promise((s,g)=>{this.d=s})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=T;class y extends T{constructor(s){super(),this.f=setTimeout(()=>this.open(),s)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=y;function R(A,s){return s?new Promise((g,E)=>{const M=setTimeout(()=>{D.dispose(),g()},A),D=s.onCancellationRequested(()=>{clearTimeout(M),D.dispose(),E(new v.CancellationError)})}):r(g=>R(A,g))}e.timeout=R;function h(A,s=0){const g=setTimeout(A,s);return(0,U.toDisposable)(()=>clearTimeout(g))}e.disposableTimeout=h;function I(A){const s=[];let g=0;const E=A.length;function M(){return g<E?A[g++]():null}function D(_){_!=null&&s.push(_);const Y=M();return Y?Y.then(D):Promise.resolve(s)}return Promise.resolve(null).then(D)}e.sequence=I;function m(A,s=E=>!!E,g=null){let E=0;const M=A.length,D=()=>{if(E>=M)return Promise.resolve(g);const _=A[E++];return Promise.resolve(_()).then(Q=>s(Q)?Promise.resolve(Q):D())};return D()}e.first=m;function u(A,s=E=>!!E,g=null){if(A.length===0)return Promise.resolve(g);let E=A.length;const M=()=>{E=-1;for(const D of A)D.cancel?.()};return new Promise((D,_)=>{for(const Y of A)Y.then(Q=>{--E>=0&&s(Q)?(M(),D(Q)):E===0&&D(g)}).catch(Q=>{--E>=0&&(M(),_(Q))})})}e.firstParallel=u;class L{constructor(s){this.a=0,this.d=s,this.f=[],this.b=0,this.g=new S.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(s){return this.a++,new Promise((g,E)=>{this.f.push({factory:s,c:g,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const s=this.f.shift();this.b++;const g=s.factory();g.then(s.c,s.e),g.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=L;class C extends L{constructor(){super(1)}}e.Queue=C;class z{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const s=new V;return this.b.add(s),s.p}d(){for(const[,s]of this.a)if(s.size>0)return!1;return!0}queueFor(s,g=n.extUri){const E=g.getComparisonKey(s);let M=this.a.get(E);return M||(M=new C,S.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(E),this.f()}),this.a.set(E,M)),M}f(){!this.d()||this.g()}g(){for(const s of this.b)s.complete();this.b.clear()}dispose(){for(const[,s]of this.a)s.dispose();this.a.clear(),this.g()}}e.ResourceQueue=z;class p{constructor(s,g){this.a=-1,typeof s=="function"&&typeof g=="number"&&this.setIfNotSet(s,g)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(s,g){this.cancel(),this.a=setTimeout(()=>{this.a=-1,s()},g)}setIfNotSet(s,g){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,s()},g))}}e.TimeoutTimer=p;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(s,g){this.cancel(),this.a=setInterval(()=>{s()},g)}}e.IntervalTimer=$;class q{constructor(s,g){this.b=-1,this.a=s,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(s=this.d){this.cancel(),this.b=setTimeout(this.f,s)}get delay(){return this.d}set delay(s){this.d=s}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class W{constructor(s,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=s,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(s=this.b){s%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${s}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(s/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=W;class Z extends q{constructor(s,g){super(s,g),this.j=[]}work(s){this.j.push(s),this.isScheduled()||this.schedule()}h(){const s=this.j;this.j=[],this.a?.(s)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Z;class x extends U.Disposable{constructor(s,g){super(),this.g=s,this.h=g,this.a=[],this.b=this.D(new U.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(s){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+s.length>this.g.maxBufferedWork)return!1}else if(this.pending+s.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of s)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=A=>{(0,c.setTimeout0)(()=>{if(s)return;const g=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let s=!1;return{dispose(){s||(s=!0)}}}:e.runWhenIdle=(A,s)=>{const g=requestIdleCallback(A,typeof s=="number"?{timeout:s}:void 0);let E=!1;return{dispose(){E||(E=!0,cancelIdleCallback(g))}}}}();class ee{constructor(s){this.d=!1,this.a=()=>{try{this.f=s()}catch(g){this.g=g}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ee;async function te(A,s,g){let E;for(let M=0;M<g;M++)try{return await A()}catch(D){E=D,await R(s)}throw E}e.retry=te;class ie{hasPending(s){return this.a?typeof s=="number"?this.a.taskId===s:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(s,g,E){return this.a={taskId:s,cancel:()=>E?.(),promise:g},g.then(()=>this.d(s),()=>this.d(s)),g}d(s){this.a&&s===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const s=this.b;this.b=void 0,s.run().then(s.promiseResolve,s.promiseReject)}}setNext(s){if(this.b)this.b.run=s;else{let g,E;const M=new Promise((D,_)=>{g=D,E=_});this.b={run:s,promise:M,promiseResolve:g,promiseReject:E}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ie;class ne{constructor(s,g=()=>Date.now()){this.d=s,this.f=g,this.a=0,this.b=0}increment(){const s=this.f();return s-this.a>this.d&&(this.a=s,this.b=0),this.b++,this.b}}e.IntervalCounter=ne;class V{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((s,g)=>{this.a=s,this.b=g})}complete(s){return new Promise(g=>{this.a(s),this.f=!0,g()})}error(s){return new Promise(g=>{this.b(s),this.d=!0,g()})}cancel(){new Promise(s=>{this.b(new v.CancellationError),this.d=!0,s()})}}e.DeferredPromise=V;var re;(function(A){async function s(E){let M;const D=await Promise.all(E.map(_=>_.then(Y=>Y,Y=>{M||(M=Y)})));if(typeof M<"u")throw M;return D}A.settled=s;function g(E){return new Promise(async(M,D)=>{try{await E(M,D)}catch(_){D(_)}})}A.withAsyncBody=g})(re=e.Promises||(e.Promises={}));var X;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(X||(X={}));class H{static fromArray(s){return new H(g=>{g.emitMany(s)})}static fromPromise(s){return new H(async g=>{g.emitMany(await s)})}static fromPromises(s){return new H(async g=>{await Promise.all(s.map(async E=>g.emitOne(await E)))})}static merge(s){return new H(async g=>{await Promise.all(s.map(async E=>{for await(const M of E)g.emitOne(M)}))})}constructor(s){this.a=0,this.b=[],this.d=null,this.f=new S.Emitter,queueMicrotask(async()=>{const g={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(s(g)),this.j()}catch(E){this.k(E)}finally{g.emitOne=void 0,g.emitMany=void 0,g.reject=void 0}})}[Symbol.asyncIterator](){let s=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(s<this.b.length)return{done:!1,value:this.b[s++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(s,g){return new H(async E=>{for await(const M of s)E.emitOne(g(M))})}map(s){return H.map(this,s)}static filter(s,g){return new H(async E=>{for await(const M of s)g(M)&&E.emitOne(M)})}filter(s){return H.filter(this,s)}static coalesce(s){return H.filter(s,g=>!!g)}coalesce(){return H.coalesce(this)}static async toPromise(s){const g=[];for await(const E of s)g.push(E);return g}toPromise(){return H.toPromise(this)}g(s){this.a===0&&(this.b.push(s),this.f.fire())}h(s){this.a===0&&(this.b=this.b.concat(s),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(s){this.a===0&&(this.a=2,this.d=s,this.f.fire())}}H.EMPTY=H.fromArray([]),e.AsyncIterableObject=H;class J extends H{constructor(s,g){super(g),this.l=s}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=J;function se(A){const s=new P.CancellationTokenSource,g=A(s.token);return new J(s,async E=>{const M=s.token.onCancellationRequested(()=>{M.dispose(),s.dispose(),E.reject(new v.CancellationError)});try{for await(const D of g){if(s.token.isCancellationRequested)return;E.emitOne(D)}M.dispose(),s.dispose()}catch(D){M.dispose(),s.dispose(),E.reject(D)}})}e.createCancelableAsyncIterable=se}),define(K[24],G([0,1,13]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(U){return this===U}};function v(U,n){return new P.TokenizationResult([new P.Token(0,"",U)],n)}e.nullTokenize=v;function S(U,n){const c=new Uint32Array(2);return c[0]=0,c[1]=(U<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.EncodedTokenizationResult(c,n===null?e.NullState:n)}e.nullTokenizeEncoded=S}),define(K[25],G([0,1,18,12,4,2,3,33,5,13,24,9,6]),function(F,e,P,v,S,U,n,c,i,t,r,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextModelTokenization=e.TokenizationStateStore=e.ContiguousGrowingArray=void 0;var k;(function(O){O[O.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(k||(k={}));class a{constructor(o){this.c=o,this.a=[]}get(o){return o<this.a.length?this.a[o]:this.c}set(o,d){for(;o>=this.a.length;)this.a[this.a.length]=this.c;this.a[o]=d}delete(o,d){d===0||o>=this.a.length||this.a.splice(o,d)}insert(o,d){if(d===0||o>=this.a.length)return;const T=[];for(let y=0;y<d;y++)T[y]=this.c;this.a=P.arrayInsert(this.a,o,T)}}e.ContiguousGrowingArray=a;class f{get invalidLineStartIndex(){return this.d}constructor(o,d){this.tokenizationSupport=o,this.initialState=d,this.a=new a(null),this.c=new a(!0),this.d=0,this.a.set(0,this.initialState)}markMustBeTokenized(o){this.c.set(o,!0),this.d=Math.min(this.d,o)}getBeginState(o){return this.a.get(o)}setEndState(o,d,T){if(this.c.set(d,!1),this.d=d+1,d===o-1)return!1;const y=this.a.get(d+1);if(y===null||!T.equals(y))return this.a.set(d+1,T),this.markMustBeTokenized(d+1),!0;let R=d+1;for(;R<o&&!this.c.get(R);)R++;return this.d=R,!1}applyEdits(o,d){this.markMustBeTokenized(o.startLineNumber-1),this.a.delete(o.startLineNumber,o.endLineNumber-o.startLineNumber),this.c.delete(o.startLineNumber,o.endLineNumber-o.startLineNumber),this.a.insert(o.startLineNumber,d),this.c.insert(o.startLineNumber,d)}updateTokensUntilLine(o,d,T,y){const R=o.getLanguageId(),h=o.getLineCount(),I=y-1;for(let m=this.invalidLineStartIndex;m<=I;m++){const u=o.getLineContent(m+1),L=this.getBeginState(m),C=B(d,R,this.tokenizationSupport,u,!0,L);T.add(m+1,C.tokens),this.setEndState(h,m,C.endState),m=this.invalidLineStartIndex-1}}isTokenizationComplete(o){return this.invalidLineStartIndex>=o.getLineCount()}}e.TokenizationStateStore=f;class w extends U.Disposable{constructor(o,d,T){super(),this.g=o,this.h=d,this.j=T,this.a=null,this.c=null,this.f=this.D(new U.MutableDisposable),this.D(t.TokenizationRegistry.onDidChange(y=>{const R=this.g.getLanguageId();y.changedLanguages.indexOf(R)!==-1&&(this.k(),this.h.clearTokens())})),this.k()}handleDidChangeContent(o){if(o.isFlush){this.k();return}if(this.a)for(let d=0,T=o.changes.length;d<T;d++){const y=o.changes[d],[R]=(0,i.countEOL)(y.text);this.a.applyEdits(y.range,R)}this.c?.handleChanges()}handleDidChangeAttached(){this.c?.handleChanges()}handleDidChangeLanguage(o){this.k(),this.h.clearTokens()}k(){const[o,d]=N(this.g,this.h);if(o&&d?this.a=new f(o,d):this.a=null,this.f.clear(),this.c=null,this.a){const T={setTokens:y=>{this.h.setTokens(y)},backgroundTokenizationFinished:()=>{this.h.handleBackgroundTokenizationFinished()},setEndState:(y,R)=>{if(!R)throw new S.BugIndicatingError;const h=this.a?.invalidLineStartIndex;h!==void 0&&y-1>=h&&this.a?.setEndState(this.g.getLineCount(),y-1,R)}};o&&o.createBackgroundTokenizer&&(this.f.value=o.createBackgroundTokenizer(this.g,T)),this.f.value||(this.f.value=this.c=new j(this.g,this.a,T,this.j),this.c.handleChanges())}}tokenizeViewport(o,d){const T=new l.ContiguousMultilineTokensBuilder;this.l(T,o,d),this.h.setTokens(T.finalize()),this.c?.checkFinished()}reset(){this.k(),this.h.clearTokens()}forceTokenization(o){const d=new l.ContiguousMultilineTokensBuilder;this.a?.updateTokensUntilLine(this.g,this.j,d,o),this.h.setTokens(d.finalize()),this.c?.checkFinished()}getTokenTypeIfInsertingCharacter(o,d){if(!this.a)return 0;this.forceTokenization(o.lineNumber);const T=this.a.getBeginState(o.lineNumber-1);if(!T)return 0;const y=this.g.getLanguageId(),R=this.g.getLineContent(o.lineNumber),h=R.substring(0,o.column-1)+d+R.substring(o.column-1),I=B(this.j,y,this.a.tokenizationSupport,h,!0,T),m=new b.LineTokens(I.tokens,h,this.j);if(m.getCount()===0)return 0;const u=m.findTokenIndexAtOffset(o.column-1);return m.getStandardTokenType(u)}tokenizeLineWithEdit(o,d,T){const y=o.lineNumber,R=o.column;if(!this.a)return null;this.forceTokenization(y);const h=this.a.getBeginState(y-1);if(!h)return null;const I=this.g.getLineContent(y),m=I.substring(0,R-1)+T+I.substring(R-1+d),u=this.g.getLanguageIdAtPosition(y,0),L=B(this.j,u,this.a.tokenizationSupport,m,!0,h);return new b.LineTokens(L.tokens,m,this.j)}isCheapToTokenize(o){if(!this.a)return!0;const d=this.a.invalidLineStartIndex+1;return o>d?!1:o<d||this.g.getLineLength(o)<2048}l(o,d,T){if(!this.a||T<=this.a.invalidLineStartIndex)return;if(d<=this.a.invalidLineStartIndex){this.a.updateTokensUntilLine(this.g,this.j,o,T);return}let y=this.m(d);const R=this.g.getLanguageId();for(let h=d;h<=T;h++){const I=this.g.getLineContent(h),m=B(this.j,R,this.a.tokenizationSupport,I,!0,y);o.add(h,m.tokens),y=m.endState}this.f.value?.requestTokens(d,T+1)}m(o){let d=this.g.getLineFirstNonWhitespaceColumn(o);const T=[];let y=null;for(let I=o-1;d>1&&I>=1;I--){const m=this.g.getLineFirstNonWhitespaceColumn(I);if(m!==0&&m<d&&(T.push(this.g.getLineContent(I)),d=m,y=this.a.getBeginState(I-1),y))break}y||(y=this.a.initialState),T.reverse();const R=this.g.getLanguageId();let h=y;for(const I of T)h=B(this.j,R,this.a.tokenizationSupport,I,!1,h).endState;return h}}e.TextModelTokenization=w;function N(O,o){if(O.isTooLargeForTokenization())return[null,null];const d=t.TokenizationRegistry.get(o.getLanguageId());if(!d)return[null,null];let T;try{T=d.getInitialState()}catch(y){return(0,S.onUnexpectedError)(y),[null,null]}return[d,T]}function B(O,o,d,T,y,R){let h=null;if(d)try{h=d.tokenizeEncoded(T,y,R.clone())}catch(I){(0,S.onUnexpectedError)(I)}return h||(h=(0,r.nullTokenizeEncoded)(O.encodeLanguageId(o),R)),b.LineTokens.convertToEndOffset(h.tokens,T.length),h}class j{constructor(o,d,T,y){this.c=o,this.d=d,this.f=T,this.g=y,this.a=!1,this.h=!1}dispose(){this.a=!0}handleChanges(){this.j()}j(){this.h||!this.c.isAttachedToEditor()||!this.m()||(this.h=!0,(0,v.runWhenIdle)(o=>{this.h=!1,this.k(o)}))}k(o){const d=Date.now()+o.timeRemaining(),T=()=>{this.a||!this.c.isAttachedToEditor()||!this.m()||(this.l(),Date.now()<d?(0,n.setTimeout0)(T):this.j())};T()}l(){const o=this.c.getLineCount(),d=new l.ContiguousMultilineTokensBuilder,T=c.StopWatch.create(!1);do if(T.elapsed()>1||this.n(d)>=o)break;while(this.m());this.f.setTokens(d.finalize()),this.checkFinished()}m(){return this.d?this.d.invalidLineStartIndex<this.c.getLineCount():!1}n(o){if(!this.d||!this.m())return this.c.getLineCount()+1;const d=this.d.invalidLineStartIndex+1;return this.d.updateTokensUntilLine(this.c,this.g,o,d),d}checkFinished(){this.a||this.d.isTokenizationComplete(this.c)&&this.f.backgroundTokenizationFinished()}requestTokens(o,d){for(let T=o;T<d;T++)this.d.markMustBeTokenized(T-1)}}}),define(K[26],G([0,1,23,2,8,13]),function(F,e,P,v,S,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class n extends v.Disposable{constructor(i,t,r,l){super(),this.c=i,this.f=t,this.g=r,this.h=l,this.a=[],this.b=this.D(new P.Emitter),this.onDidEncounterLanguage=this.b.event}getInitialState(){return this.f}tokenize(i,t,r){throw new Error("Not supported!")}createBackgroundTokenizer(i,t){if(this.h)return this.h(i,t)}tokenizeEncoded(i,t,r){const l=this.c.tokenizeLine2(i,r,500);if(l.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${i.substring(0,100)}`),new U.EncodedTokenizationResult(l.tokens,r);if(this.g){const k=this.a,a=l.tokens;for(let f=0,w=a.length>>>1;f<w;f++){const N=a[(f<<1)+1],B=S.TokenMetadata.getLanguageId(N);k[B]||(k[B]=!0,this.b.fire(B))}}let b;return r.equals(l.ruleStack)?b=r:b=l.ruleStack,new U.EncodedTokenizationResult(l.tokens,b)}}e.TextMateTokenizationSupport=n}),define(K[27],G([0,1,11]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class v{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(U){if(this.a[U.scopeName]){const n=this.a[U.scopeName];P.isEqual(n.location,U.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${U.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${U.location.toString()}`)}this.a[U.scopeName]=U}getGrammarDefinition(U){return this.a[U]||null}}e.TMScopeRegistry=v}),define(K[28],G([0,1,2,27]),function(F,e,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class S extends P.Disposable{constructor(n,c,i,t){super(),this.a=n,this.b=i.INITIAL,this.c=new v.TMScopeRegistry,this.f={},this.g={},this.h=new Map,this.j=this.D(new i.Registry({onigLib:t,loadGrammar:async r=>{const l=this.c.getGrammarDefinition(r);if(!l)return this.a.logTrace(`No grammar found for scope ${r}`),null;const b=l.location;try{const k=await this.a.readFile(b);return i.parseRawGrammar(k,b.path)}catch(k){return this.a.logError(`Unable to load and parse grammar for scope ${r} from ${b}`,k),null}},getInjections:r=>{const l=r.split(".");let b=[];for(let k=1;k<=l.length;k++){const a=l.slice(0,k).join(".");b=[...b,...this.f[a]||[]]}return b}}));for(const r of c){if(this.c.register(r),r.injectTo){for(const l of r.injectTo){let b=this.f[l];b||(this.f[l]=b=[]),b.push(r.scopeName)}if(r.embeddedLanguages)for(const l of r.injectTo){let b=this.g[l];b||(this.g[l]=b=[]),b.push(r.embeddedLanguages)}}r.language&&this.h.set(r.language,r.scopeName)}}has(n){return this.h.has(n)}setTheme(n,c){this.j.setTheme(n,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(n,c){const i=this.h.get(n);if(typeof i!="string")throw new Error(e.missingTMGrammarErrorMessage);const t=this.c.getGrammarDefinition(i);if(!t)throw new Error(e.missingTMGrammarErrorMessage);const r=t.embeddedLanguages;if(this.g[i]){const k=this.g[i];for(const a of k)for(const f of Object.keys(a))r[f]=a[f]}const l=Object.keys(r).length>0;let b;try{b=await this.j.loadGrammarWithConfiguration(i,c,{embeddedLanguages:r,tokenTypes:t.tokenTypes,balancedBracketSelectors:t.balancedBracketSelectors,unbalancedBracketSelectors:t.unbalancedBracketSelectors})}catch(k){throw k.message&&k.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):k}return{languageId:n,grammar:b,initialState:this.b,containsEmbeddedLanguages:l}}}e.TMGrammarFactory=S}),define(K[29],G([0,1,34,25,35,9,5,6,26,12]),function(F,e,P,v,S,U,n,c,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class r extends P.MirrorTextModel{constructor(k,a,f,w,N,B,j){super(k,a,f,w),this.s=new t.RunOnceScheduler(()=>this.u(),10),this.a=null,this.b=N,this.m=B,this.p=j,this.q=!1,this.t()}dispose(){this.q=!0,super.dispose()}onLanguageId(k,a){this.m=k,this.p=a,this.t()}onEvents(k){if(super.onEvents(k),this.a)for(let a=0;a<k.changes.length;a++){const f=k.changes[a],[w]=(0,n.countEOL)(f.text);this.a.applyEdits(f.range,w)}this.s.schedule()}retokenize(k,a){if(this.a){for(let f=k;f<a;f++)this.a.markMustBeTokenized(f-1);this.s.schedule()}}t(){this.a=null;const k=this.m,a=this.p;this.b.getOrCreateGrammar(k,a).then(f=>{if(!(this.q||k!==this.m||a!==this.p||!f)){if(f.grammar){const w=new i.TextMateTokenizationSupport(f.grammar,f.initialState,!1);this.a=new v.TokenizationStateStore(w,w.getInitialState())}else this.a=null;this.u()}})}u(){if(this.q||!this.a)return;const k=new Date().getTime();for(;;){const a=new U.ContiguousMultilineTokensBuilder,f=this.d.length;let w=0;const N=new l;for(;this.a.invalidLineStartIndex<f;){const O=this.a.invalidLineStartIndex;if(w++,w>200)break;const o=this.d[O],d=this.a.getBeginState(O),T=this.a.tokenizationSupport.tokenizeEncoded(o,!0,d);if(this.a.setEndState(f,O,T.endState)){const R=(0,S.diffStateStacksRefEq)(d,T.endState);N.setState(O+1,R)}if(c.LineTokens.convertToEndOffset(T.tokens,o.length),a.add(O+1,T.tokens),new Date().getTime()-k>20)break}if(w===0)break;const B=N.getStateDeltas();if(this.b.setTokensAndStates(this.c,this.g,a.serialize(),B),new Date().getTime()-k>20){setTimeout(()=>this.u(),3);return}}}}e.TextMateWorkerModel=r;class l{constructor(){this.a=-1,this.b=[]}setState(k,a){k===this.a+1?this.b[this.b.length-1].stateDeltas.push(a):this.b.push({startLineNumber:k,stateDeltas:[a]}),this.a=k}getStateDeltas(){return this.b}}}),define(K[36],G([0,1,10,28,29]),function(F,e,P,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class U{constructor(i,t){this.f=t,this.b=Object.create(null),this.c=[],this.a=i.host;const r=t.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors}));this.d=this.g(r)}async g(i){const t=this.f.textmateMainUri,r=await new Promise((f,w)=>{F([t],f,w)}),l=await new Promise((f,w)=>{F([this.f.onigurumaMainUri],f,w)}),k=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(k);const a=Promise.resolve({createOnigScanner:f=>l.createOnigScanner(f),createOnigString:f=>l.createOnigString(f)});return new v.TMGrammarFactory({logTrace:f=>{},logError:(f,w)=>console.error(f,w),readFile:f=>this.a.readFile(f)},i,r,a)}acceptNewModel(i){const t=P.URI.revive(i.uri),r=t.toString();this.b[r]=new S.TextMateWorkerModel(t,i.lines,i.EOL,i.versionId,this,i.languageId,i.encodedLanguageId)}acceptModelChanged(i,t){this.b[i].onEvents(t)}retokenize(i,t,r){this.b[i].retokenize(t,r)}acceptModelLanguageChanged(i,t,r){this.b[i].onLanguageId(t,r)}acceptRemovedModel(i){this.b[i]&&(this.b[i].dispose(),delete this.b[i])}async acceptTheme(i,t){(await this.d)?.setTheme(i,t)}async getOrCreateGrammar(i,t){const r=await this.d;return r?(this.c[t]||(this.c[t]=r.createGrammar(i,t)),this.c[t]):Promise.resolve(null)}setTokensAndStates(i,t,r,l){this.a.setTokensAndStates(i,t,r,l)}}e.TextMateTokenizationWorker=U;function n(c,i){return new U(c,i)}e.create=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0cab3cc3cbe4d4ac2cbf30e8c30351d9db6dcfb4/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
